/*!
*  filename: ej.web.all.js
*  version : 15.4.0.20
*  Copyright Syncfusion Inc. 2001 - 2017. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/
(function (fn) {
    typeof define === 'function' && define.amd ? define(["jquery","jsrender","jquery-validation"], fn) : fn();
})
(function () {
	

window.ej = window.Syncfusion = window.Syncfusion || {};


(function ($, ej, undefined) {
    'use strict';

    ej.version = "15.4.0.20";

    ej.consts = {
        NamespaceJoin: '-'
    };
    ej.TextAlign = {
        Center: 'center',
        Justify: 'justify',
        Left: 'left',
        Right: 'right'
    };
    ej.Orientation = { Horizontal: "horizontal", Vertical: "vertical" };

    ej.serverTimezoneOffset = 0;

    ej.persistStateVersion = null;

    ej.locales = ej.locales || [];

    if (!Object.prototype.hasOwnProperty) {
        Object.prototype.hasOwnProperty = function (obj, prop) {
            return obj[prop] !== undefined;
        };
    }

    //to support toISOString() in IE8
    if (!Date.prototype.toISOString) {
        (function () {
            function pad(number) {
                var r = String(number);
                if (r.length === 1) {
                    r = '0' + r;
                }
                return r;
            }
            Date.prototype.toISOString = function () {
                return this.getUTCFullYear()
                    + '-' + pad(this.getUTCMonth() + 1)
                    + '-' + pad(this.getUTCDate())
                    + 'T' + pad(this.getUTCHours())
                    + ':' + pad(this.getUTCMinutes())
                    + ':' + pad(this.getUTCSeconds())
                    + '.' + String((this.getUTCMilliseconds() / 1000).toFixed(3)).slice(2, 5)
                    + 'Z';
            };
        }());
    }

    String.format = function () {
        var source = arguments[0];
        for (var i = 0; i < arguments.length - 1; i++)
            source = source.replace(new RegExp("\\{" + i + "\\}", "gm"), arguments[i + 1]);

        source = source.replace(/\{[0-9]\}/g, "");
        return source;
    };

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };
    // Function to create new class
    ej.defineClass = function (className, constructor, proto, replace) {
        /// <summary>Creates the javascript class with given namespace & class name & constructor etc</summary>
        /// <param name="className" type="String">class name prefixed with namespace</param>
        /// <param name="constructor" type="Function">constructor function</param>
        /// <param name="proto" type="Object">prototype for the class</param>
        /// <param name="replace" type="Boolean">[Optional]Replace existing class if exists</param>
        /// <returns type="Function">returns the class function</returns>
        if (!className || !proto) return undefined;

        var parts = className.split(".");

        // Object creation
        var obj = window, i = 0;
        for (; i < parts.length - 1; i++) {

            if (ej.isNullOrUndefined(obj[parts[i]]))
                obj[parts[i]] = {};

            obj = obj[parts[i]];
        }

        if (replace || ej.isNullOrUndefined(obj[parts[i]])) {

            //constructor
            constructor = typeof constructor === "function" ? constructor : function () {
            };

            obj[parts[i]] = constructor;

            // prototype
            obj[parts[i]].prototype = proto;
        }

        return obj[parts[i]];
    };

    ej.util = {
        getNameSpace: function (className) {
            /// <summary>Internal function, this will create namespace for plugins using class name</summary>
            /// <param name="className" type="String"></param>
            /// <returns type="String"></returns>
            var splits = className.toLowerCase().split(".");
            splits[0] === "ej" && (splits[0] = "e");

            return splits.join(ej.consts.NamespaceJoin);
        },

        getObject: function (nameSpace, from) {
            if (!from || !nameSpace) return undefined;
			(typeof(nameSpace) != "string") && (nameSpace = JSON.stringify(nameSpace));
            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (ej.util.isNullOrUndefined(value)) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i, t, length = splits.length;

            for (i = 0; i < length; i++) {
                t = splits[i];
                if (i + 1 == length)
                    from[t] = value;
                else if (ej.isNullOrUndefined(from[t]))
                    from[t] = {};

                from = from[t];
            }

            return start;
        },

        isNullOrUndefined: function (value) {
            /// <summary>Util to check null or undefined</summary>
            /// <param name="value" type="Object"></param>
            /// <returns type="Boolean"></returns>
            return value === undefined || value === null;
        },
        print: function (element, printWin) {
            var $div = ej.buildTag('div')
            var elementClone = element.clone();
            $div.append(elementClone);
            if (!printWin)
                var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no");
            printWin.document.write('<!DOCTYPE html>');
            var links = $('head').find('link').add("style");
            if (ej.browserInfo().name === "msie") {
                var a = ""
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                var a = ""
                printWin.document.write('<html><head>')
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.writeln(a + '</head><body>')
                printWin.document.writeln($div[0].innerHTML + '</body></html>')
            }
            printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if (!ej.isNullOrUndefined(printWin.window)) {
                    printWin.print();
                    setTimeout(function () { printWin.close() }, 1000);
                }
            }, 1000);
        },
        ieClearRemover: function (element) {
            var searchBoxHeight = $(element).height();
            element.style.paddingTop = parseFloat(searchBoxHeight / 2) + "px";
            element.style.paddingBottom = parseFloat(searchBoxHeight / 2) + "px";
            element.style.height = "1px";
            element.style.lineHeight = "1px";
        },
        //To send ajax request
        sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.successHandler,
                error: ajaxOptions.errorHandler,
                beforeSend: ajaxOptions.beforeSendHandler,
                complete: ajaxOptions.completeHandler
            });
        },

        buildTag: function (tag, innerHtml, styles, attrs) {
            /// <summary>Helper to build jQuery element</summary>
            /// <param name="tag" type="String">tagName#id.cssClass</param>
            /// <param name="innerHtml" type="String"></param>
            /// <param name="styles" type="Object">A set of key/value pairs that configure styles</param>
            /// <param name="attrs" type="Object">A set of key/value pairs that configure attributes</param>
            /// <returns type="jQuery"></returns>
            var tagName = /^[a-z]*[0-9a-z]+/ig.exec(tag)[0];

            var id = /#([_a-z]+[-_0-9a-z]+)/ig.exec(tag);
            id = id ? id[id.length - 1] : undefined;

            var className = /\.([a-z]+[-_0-9a-z ]+)/ig.exec(tag);
            className = className ? className[className.length - 1] : undefined;

            return $(document.createElement(tagName))
                .attr(id ? { "id": id } : {})
                .addClass(className || "")
                .css(styles || {})
                .attr(attrs || {})
                .html(innerHtml || "");
        },
        _preventDefaultException: function (el, exceptions) {
            if (el) {
                for (var i in exceptions) {
                    if (exceptions[i].test(el[i])) {
                        return true;
                    }
                }
            }

            return false;
        },

        //Gets the maximum z-index in the document
        getMaxZindex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute' || $(e).css('position') == 'fixed')
                    return parseInt($(e).css('z-index')) || 1;
            })
            );
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },

        //To prevent default actions for the element
        blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },

        //To get dimensions of the element when its hidden
        getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().andSelf().filter(':hidden');
            if ($hidden) {
                var prop = { visibility: 'hidden', display: 'block' };
                var tmp = [];
                $hidden.each(function () {
                    var temp = {}, name;
                    for (name in prop) {
                        temp[name] = this.style[name];
                        this.style[name] = prop[name];
                    }
                    tmp.push(temp);
                });
                value = /(outer)/g.test(method) ?
                $(element)[method](true) :
               $(element)[method]();

                $hidden.each(function (i) {
                    var temp = tmp[i], name;
                    for (name in prop) {
                        this.style[name] = temp[name];
                    }
                });
            }
            return value;
        },
        //Get triggers when transition End
        transitionEndEvent: function () {
            var transitionEnd = {
                '': 'transitionend',
                'webkit': 'webkitTransitionEnd',
                'Moz': 'transitionend',
                'O': 'otransitionend',
                'ms': 'MSTransitionEnd'
            };

            return transitionEnd[ej.userAgent()];
        },
        //Get triggers when transition End
        animationEndEvent: function () {
            var animationEnd = {
                '': 'animationend',
                'webkit': 'webkitAnimationEnd',
                'Moz': 'animationend',
                'O': 'webkitAnimationEnd',
                'ms': 'animationend'
            };

            return animationEnd[ej.userAgent()];
        },
        //To return the start event to bind for element
        startEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchstart" : "mousedown";
        },
        //To return end event to bind for element
        endEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchend" : "mouseup"
        },
        //To return move event to bind for element
        moveEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? ($.support.hasPointer && !ej.isMobile()) ? "ejtouchmove" : "touchmove" : "mousemove";
        },
        //To return cancel event to bind for element
        cancelEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchcancel" : "mousecancel";
        },
        //To return tap event to bind for element
        tapEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "tap" : "click";
        },
        //To return tap hold event to bind for element
        tapHoldEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "taphold" : "click";
        },
        //To check whether its Device
        isDevice: function () {
            if (ej.getBooleanVal($('head'), 'data-ej-forceset', false))
                return ej.getBooleanVal($('head'), 'data-ej-device', this._device());
            else
                return this._device();
        },
        //To check whether its portrait or landscape mode
        isPortrait: function () {
            var elem = document.documentElement;
            return (elem) && ((elem.clientWidth / elem.clientHeight) < 1.1);
        },
        //To check whether its in lower resolution
        isLowerResolution: function () {
            return ((window.innerWidth <= 640 && ej.isPortrait() && ej.isDevice()) || (window.innerWidth <= 800 && !ej.isDevice()) || (window.innerWidth <= 800 && !ej.isPortrait() && ej.isWindows() && ej.isDevice()) || ej.isMobile());
        },
        //To check whether its iOS web view
        isIOSWebView: function () {
            return (/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(navigator.userAgent));
        },
        //To check whether its Android web view
        isAndroidWebView: function () {
            return (!(typeof (Android) === "undefined"));
        },
        //To check whether its windows web view
        isWindowsWebView: function () {
            return location.href.indexOf("x-wmapp") != -1;
        },
        _device: function () {
            return (/Android|BlackBerry|iPhone|iPad|iPod|IEMobile|kindle|windows\sce|palm|smartphone|iemobile|mobile|pad|xoom|sch-i800|playbook/i.test(navigator.userAgent.toLowerCase()));
        },
        //To check whether its Mobile
        isMobile: function () {
            return ((/iphone|ipod|android|blackberry|opera|mini|windows\sce|palm|smartphone|iemobile/i.test(navigator.userAgent.toLowerCase()) && /mobile/i.test(navigator.userAgent.toLowerCase()))) || (ej.getBooleanVal($('head'), 'data-ej-mobile', false) === true);
        },
        //To check whether its Tablet
        isTablet: function () {
            return (/ipad|xoom|sch-i800|playbook|tablet|kindle/i.test(navigator.userAgent.toLowerCase())) || (ej.getBooleanVal($('head'), 'data-ej-tablet', false) === true) || (!ej.isMobile() && ej.isDevice());
        },
        //To check whether its Touch Device
        isTouchDevice: function () {
            return (('ontouchstart' in window || (window.navigator.msPointerEnabled && ej.isMobile())) && this.isDevice());
        },
        //To get the outerHTML string for object
        getClearString: function (string) {
            return $.trim(string.replace(/\s+/g, " ").replace(/(\r\n|\n|\r)/gm, "").replace(new RegExp("\>[\n\t ]+\<", "g"), "><"));
        },
        //Get the attribute value with boolean type of element
        getBooleanVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value.toLowerCase() == "true";
            else
                return option;
        },
        //Gets the Skew class based on the element current position
        _getSkewClass: function (item, pageX, pageY) {
            var itemwidth = item.width();
            var itemheight = item.height();
            var leftOffset = item.offset().left;
            var rightOffset = item.offset().left + itemwidth;
            var topOffset = item.offset().top;
            var bottomOffset = item.offset().top + itemheight;
            var widthoffset = itemwidth * 0.3;
            var heightoffset = itemheight * 0.3;
            if (pageX < leftOffset + widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topleft";
            if (pageX > rightOffset - widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topright";
            if (pageX > rightOffset - widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomright";
            if (pageX < leftOffset + widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomleft";
            if (pageX > leftOffset + widthoffset && pageY < topOffset + heightoffset && pageX < rightOffset - widthoffset)
                return "e-m-skew-top";
            if (pageX < leftOffset + widthoffset)
                return "e-m-skew-left";
            if (pageX > rightOffset - widthoffset)
                return "e-m-skew-right";
            if (pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottom";
            return "e-m-skew-center";
        },
        //Removes the added Skew class on the element
        _removeSkewClass: function (element) {
            $(element).removeClass("e-m-skew-top e-m-skew-bottom e-m-skew-left e-m-skew-right e-m-skew-topleft e-m-skew-topright e-m-skew-bottomleft e-m-skew-bottomright e-m-skew-center e-skew-top e-skew-bottom e-skew-left e-skew-right e-skew-topleft e-skew-topright e-skew-bottomleft e-skew-bottomright e-skew-center");
        },
        //Object.keys  method to support all the browser including IE8.
        _getObjectKeys: function (obj) {
            var i, keys = [];
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            if (!Object.keys) {
                for (i in obj) {
                    if (obj.hasOwnProperty(i))
                        keys.push(i);
                }
                return keys;
            }
            if (Object.keys)
                return Object.keys(obj);
        },
        _touchStartPoints: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt;
                object._distX = 0;
                object._distY = 0;
                object._moved = false;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
            }
        },
        _isTouchMoved: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt,
                deltaX = point.pageX - object._pointX,
                deltaY = point.pageY - object._pointY,
                timestamp = Date.now(),
                newX, newY,
                absDistX, absDistY;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
                object._distX += deltaX;
                object._distY += deltaY;
                absDistX = Math.abs(object._distX);
                absDistY = Math.abs(object._distY);
                return !(absDistX < 5 && absDistY < 5);
            }
        },
        //To bind events for element
        listenEvents: function (selectors, eventTypes, handlers, remove, pluginObj, disableMouse) {
            for (var i = 0; i < selectors.length; i++) {
                ej.listenTouchEvent(selectors[i], eventTypes[i], handlers[i], remove, pluginObj, disableMouse);
            }
        },
        //To bind touch events for element
        listenTouchEvent: function (selector, eventType, handler, remove, pluginObj, disableMouse) {
            var event = remove ? "removeEventListener" : "addEventListener";
            var jqueryEvent = remove ? "off" : "on";
            var elements = $(selector);
            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                switch (eventType) {
                    case "touchstart":
                        ej._bindEvent(element, event, eventType, handler, "mousedown", "MSPointerDown", "pointerdown", disableMouse);
                        break;
                    case "touchmove":
                        ej._bindEvent(element, event, eventType, handler, "mousemove", "MSPointerMove", "pointermove", disableMouse);
                        break;
                    case "touchend":
                        ej._bindEvent(element, event, eventType, handler, "mouseup", "MSPointerUp", "pointerup", disableMouse);
                        break;
                    case "touchcancel":
                        ej._bindEvent(element, event, eventType, handler, "mousecancel", "MSPointerCancel", "pointercancel", disableMouse);
                        break;
                    case "tap": case "taphold": case "ejtouchmove": case "click":
                        $(element)[jqueryEvent](eventType, handler);
                        break;
                    default:
                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                            pluginObj["_on"]($(element), eventType, handler);
                        else
                            element[event](eventType, handler, true);
                        break;
                }
            }
        },
        //To bind events for element
        _bindEvent: function (element, event, eventType, handler, mouseEvent, pointerEvent, ie11pointerEvent, disableMouse) {
            if ($.support.hasPointer)
                element[event](window.navigator.pointerEnabled ? ie11pointerEvent : pointerEvent, handler, true);
            else
                element[event](eventType, handler, true);
        },
        _browser: function () {
            return (/webkit/i).test(navigator.appVersion) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : (/trident/i).test(navigator.userAgent) ? 'ms' : 'opera' in window ? 'O' : '';
        },
        styles: document.createElement('div').style,
        /**
       * To get the userAgent Name     
       * @example             
       * &lt;script&gt;
       *       ej.userAgent();//return user agent name
       * &lt;/script&gt         
       * @memberof AppView
       * @instance
       */
        userAgent: function () {
            var agents = 'webkitT,t,MozT,msT,OT'.split(','),
            t,
            i = 0,
            l = agents.length;

            for (; i < l; i++) {
                t = agents[i] + 'ransform';
                if (t in ej.styles) {
                    return agents[i].substr(0, agents[i].length - 1);
                }
            }

            return false;
        },
        addPrefix: function (style) {
            if (ej.userAgent() === '') return style;

            style = style.charAt(0).toUpperCase() + style.substr(1);
            return ej.userAgent() + style;
        },
        //To Prevent Default Exception

        //To destroy the mobile widgets
        destroyWidgets: function (element) {
            var dataEl = $(element).find("[data-role *= ejm]");
            dataEl.each(function (index, element) {
                var $element = $(element);
                var plugin = $element.data("ejWidgets");
                if (plugin)
                    $element[plugin]("destroy");
            });
        },
        //Get the attribute value of element
        getAttrVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value;
            else
                return option;
        },

        // Get the offset value of element
        getOffset: function (ele) {
            var pos = {};
            var offsetObj = ele.offset() || { left: 0, top: 0 };
            $.extend(true, pos, offsetObj);
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },

        // Z-index calculation for the element
        getZindexPartial: function (element, popupEle) {
            if (!ej.isNullOrUndefined(element) && element.length > 0) {
                var parents = element.parents(), bodyEle;
                bodyEle = $('body').children();
                if (!ej.isNullOrUndefined(element) && element.length > 0)
                    bodyEle.splice(bodyEle.index(popupEle), 1);
                $(bodyEle).each(function (i, ele) { parents.push(ele); });

                var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                    if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
                }));
                if (!maxZ || maxZ < 10000) maxZ = 10000;
                else maxZ += 1;
                return maxZ;
            }
        },

        isValidAttr: function (element, attribute) {
            var element = $(element)[0];
            if (typeof element[attribute] != "undefined")
                return true;
            else {
                var _isValid = false;
                $.each(element, function (key) {
                    if (key.toLowerCase() == attribute.toLowerCase()) {
                        _isValid = true;
                        return false;
                    }
                });
            }
            return _isValid;
        }

    };

    $.extend(ej, ej.util);

    // base class for all ej widgets. It will automatically inhertied
    ej.widgetBase = {
        droppables: { 'default': [] },
        resizables: { 'default': [] },

        _renderEjTemplate: function (selector, data, index, prop, ngTemplateType) {
            var type = null;
            if (typeof selector === "object" || selector.startsWith("#") || selector.startsWith("."))
                type = $(selector).attr("type");
            if (type) {
                type = type.toLowerCase();
                if (ej.template[type])
                    return ej.template[type](this, selector, data, index, prop);
            }
            // For ejGrid Angular2 Template Support
            else if (!ej.isNullOrUndefined(ngTemplateType))
                 return ej.template['text/x-'+ ngTemplateType](this, selector, data, index, prop);
            return ej.template.render(this, selector, data, index, prop);
        },

        destroy: function () {

            if (this._trigger("destroy"))
                return;

            if (this.model.enablePersistence) {
                this.persistState();
                $(window).off("unload", this._persistHandler);
            }

            try {
                this._destroy();
            } catch (e) { }

            var arr = this.element.data("ejWidgets") || [];
            for (var i = 0; i < arr.length; i++) {
                if (arr[i] == this.pluginName) {
                    arr.splice(i, 1);
                }
            }
            if (!arr.length)
                this.element.removeData("ejWidgets");

            while (this._events) {
                var item = this._events.pop(), args = [];

                if (!item)
                    break;

                for (var i = 0; i < item[1].length; i++)
                    if (!$.isPlainObject(item[1][i]))
                        args.push(item[1][i]);

                $.fn.off.apply(item[0], args);
            }

            this._events = null;

            this.element
                .removeClass(ej.util.getNameSpace(this.sfType))
                .removeClass("e-js")
                .removeData(this.pluginName);

            this.element = null;
            this.model = null;
        },

        _on: function (element) {
            if (!this._events)
                this._events = [];
            var args = [].splice.call(arguments, 1, arguments.length - 1);

            var handler = {}, i = args.length;
            while (handler && typeof handler !== "function") {
                handler = args[--i];
            }

            args[i] = ej.proxy(args[i], this);

            this._events.push([element, args, handler, args[i]]);

            $.fn.on.apply(element, args);

            return this;
        },

        _off: function (element, eventName, selector, handlerObject) {
            var e = this._events, temp;
            if (!e || !e.length)
                return this;
            if (typeof selector == "function") {
                temp = handlerObject;
                handlerObject = selector;
                selector = temp;
            }
            var t = (eventName.match(/\S+/g) || [""]);
            for (var i = 0; i < e.length; i++) {
                var arg = e[i],
                r = arg[0].length && (!handlerObject || arg[2] === handlerObject) && (arg[1][0] === eventName || t[0]) && (!selector || arg[1][1] === selector) && $.inArray(element[0], arg[0]) > -1;
                if (r) {
                    $.fn.off.apply(element, handlerObject ? [eventName, selector, arg[3]] : [eventName, selector]);
                    e.splice(i, 1);
                    break;
                }
            }

            return this;
        },

        // Client side events wire-up / trigger helper.
        _trigger: function (eventName, eventProp) {
            var fn = null, returnValue, args, clientProp = {};
            $.extend(clientProp, eventProp)

            if (eventName in this.model)
                fn = this.model[eventName];

            if (fn) {
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }

                if ($.isFunction(fn)) {

                    args = ej.event(eventName, this.model, eventProp);

                    var scopeFn = this.model["_applyScope"];

                    returnValue = fn.call(this, args);

                    scopeFn && scopeFn.call();

                    // sending changes back - deep copy option should not be enabled for this $.extend 
                    if (eventProp) $.extend(eventProp, args);

                    if (args.cancel || !ej.isNullOrUndefined(returnValue))
                        return returnValue === false || args.cancel;
                }
            }

            var isPropDefined = Boolean(eventProp);
            eventProp = eventProp || {};
            eventProp.originalEventType = eventName;
            eventProp.type = this.pluginName + eventName;

            args = $.Event(eventProp.type, ej.event(eventProp.type, this.model, eventProp));

            this.element && this.element.trigger(args);

            // sending changes back - deep copy option should not be enabled for this $.extend 
            if (isPropDefined) $.extend(eventProp, args);

            if (ej.isOnWebForms && args.cancel == false && this.model.serverEvents && this.model.serverEvents.length)
                ej.raiseWebFormsServerEvents(eventName, eventProp, clientProp);

            return args.cancel;
        },

        setModel: function (options, forceSet) {
            // check for whether to apply values are not. if _setModel function is defined in child,
            //  this will call that function and validate it using return value

            if (this._trigger("modelChange", { "changes": options }))
                return;

            for (var prop in options) {
                if (!forceSet) {
                    if (this.model[prop] === options[prop]) {
                        delete options[prop];
                        continue;
                    }
                    if ($.isPlainObject(options[prop])) {
                        iterateAndRemoveProps(this.model[prop], options[prop]);
                        if ($.isEmptyObject(options[prop])) {
                            delete options[prop];
                            continue;
                        }
                    }
                }

                if (this.dataTypes) {
                    var returnValue = this._isValidModelValue(prop, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + prop + " - " + returnValue;
                }
                if (this.model.notifyOnEachPropertyChanges && this.model[prop] !== options[prop]) {
                    var arg = {
                        oldValue: this.model[prop],
                        newValue: options[prop]
                    };

                    options[prop] = this._trigger(prop + "Change", arg) ? this.model[prop] : arg.newValue;
                }
            }
            if ($.isEmptyObject(options))
                return;

            if (this._setFirst) {
                var ds = options.dataSource;
                if (ds) delete options.dataSource;

                $.extend(true, this.model, options);
                if (ds) {
                    this.model.dataSource = (ds instanceof Array) ? ds.slice() : ds;
                    options["dataSource"] = this.model.dataSource;
                }
                !this._setModel || this._setModel(options);

            } else if (!this._setModel || this._setModel(options) !== false) {
                $.extend(true, this.model, options);
            }
            if ("enablePersistence" in options) {
                this._setState(options.enablePersistence);
            }
        },
        option: function (prop, value, forceSet) {
            if (!prop)
                return this.model;

            if ($.isPlainObject(prop))
                return this.setModel(prop, forceSet);

            if (typeof prop === "string") {
                prop = prop.replace(/^model\./, "");
                var oldValue = ej.getObject(prop, this.model);

                if (value === undefined && !forceSet)
                    return oldValue;

                if (prop === "enablePersistence")
                    return this._setState(value);

                if (forceSet && value === ej.extensions.modelGUID) {
                    return this._setModel(ej.createObject(prop, ej.getObject(prop, this.model), {}));
                }

                if (forceSet || ej.getObject(prop, this.model) !== value)
                    return this.setModel(ej.createObject(prop, value, {}), forceSet);
            }
            return undefined;
        },

        _isValidModelValue: function (prop, types, options) {
            var value = types[prop], option = options[prop], returnValue;

            if (!value)
                return true;

            if (typeof value === "string") {
                if (value == "enum") {
                    options[prop] = option ? option.toString().toLowerCase() : option;
                    value = "string";
                }

                if (value === "array") {
                    if (Object.prototype.toString.call(option) === '[object Array]')
                        return true;
                }
                else if (value === "data") {
                    return true;
                }
                else if (value === "parent") {
                    return true;
                }
                else if (typeof option === value)
                    return true;

                return "Expected type - " + value;
            }

            if (option instanceof Array) {
                for (var i = 0; i < option.length; i++) {
                    returnValue = this._isValidModelValue(prop, types, option[i]);
                    if (returnValue !== true) {
                        return " [" + i + "] - " + returnValue;
                    }
                }
                return true;
            }

            for (var innerProp in option) {
                returnValue = this._isValidModelValue(innerProp, value, option);
                if (returnValue !== true)
                    return innerProp + " : " + returnValue;
            }

            return true;
        },

        _returnFn: function (obj, propName) {
            if (propName.indexOf('.') != -1) {
                this._returnFn(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
            }
            else
                obj[propName] = obj[propName].call(obj.propName);
        },

        _removeCircularRef: function (obj) {
            var seen = [];
            function detect(obj, key, parent) {
                if (typeof obj != 'object') { return; }
                if (!Array.prototype.indexOf) {
                    Array.prototype.indexOf = function (val) {
                        return jQuery.inArray(val, this);
                    };
                }
                if (seen.indexOf(obj) >= 0) {
                    delete parent[key];
                    return;
                }
                seen.push(obj);
                for (var k in obj) { //dive on the object's children
                    if (obj.hasOwnProperty(k)) { detect(obj[k], k, obj); }
                }
                seen.pop();
                return;
            }
            detect(obj, 'obj', null);
            return obj;
        },

        stringify: function (model, removeCircular) {
            var observables = this.observables;
            for (var k = 0; k < observables.length; k++) {
                var val = ej.getObject(observables[k], model);
                if (!ej.isNullOrUndefined(val) && typeof (val) === "function")
                    this._returnFn(model, observables[k]);
            }
            if (removeCircular) model = this._removeCircularRef(model);
            return JSON.stringify(model);
        },

        _setState: function (val) {
            if (val === true) {
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
            } else {
                this.deleteState();
                $(window).off("unload", this._persistHandler);
            }
        },

        _removeProp: function (obj, propName) {
            if (!ej.isNullOrUndefined(obj)) {
                if (propName.indexOf('.') != -1) {
                    this._removeProp(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
                }
                else
                    delete obj[propName];
            }
        },

        persistState: function () {
            var model;

            if (this._ignoreOnPersist) {
                model = copyObject({}, this.model);
                for (var i = 0; i < this._ignoreOnPersist.length; i++) {
                    this._removeProp(model, this._ignoreOnPersist[i]);
                }
                model.ignoreOnPersist = this._ignoreOnPersist;
            } else if (this._addToPersist) {
                model = {};
                for (var i = 0; i < this._addToPersist.length; i++) {
                    ej.createObject(this._addToPersist[i], ej.getObject(this._addToPersist[i], this.model), model);
                }
                model.addToPersist = this._addToPersist;
            } else {
                model = copyObject({}, this.model);
            }

            if (this._persistState) {
                model.customPersists = {};
                this._persistState(model.customPersists);
            }

            if (window.localStorage) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") == null)
                    window.localStorage.setItem("persistKey", ej.persistStateVersion);
                window.localStorage.setItem("$ej$" + this.pluginName + this._id, JSON.stringify(model));
            }
            else if (document.cookie) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") == null)
                    ej.cookie.set("persistKey", ej.persistStateVersion);
                ej.cookie.set("$ej$" + this.pluginName + this._id, model);
            }
        },

        deleteState: function () {
            if (window.localStorage)
                window.localStorage.removeItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                ej.cookie.set("$ej$" + this.pluginName + this._id, model, new Date());
        },

        restoreState: function (silent) {
            var value = null;
            if (window.localStorage)
                value = window.localStorage.getItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                value = ej.cookie.get("$ej$" + this.pluginName + this._id);

            if (value) {
                var model = JSON.parse(value);

                if (this._restoreState) {
                    this._restoreState(model.customPersists);
                    delete model.customPersists;
                }

                if (ej.isNullOrUndefined(model) === false)
                    if (!ej.isNullOrUndefined(model.ignoreOnPersist)) {
                        this._ignoreOnPersist = model.ignoreOnPersist;
                        delete model.ignoreOnPersist;
                    } else if (!ej.isNullOrUndefined(model.addToPersist)) {
                        this._addToPersist = model.addToPersist;
                        delete model.addToPersist;
                    }
            }
            if (!ej.isNullOrUndefined(model) && !ej.isNullOrUndefined(this._ignoreOnPersist)) {
                for (var i in this._ignoreOnPersist) {
                    if (this._ignoreOnPersist[i].indexOf('.') !== -1)
                        ej.createObject(this._ignoreOnPersist[i], ej.getObject(this._ignoreOnPersist[i], this.model), model);
                    else
                        model[this._ignoreOnPersist[i]] = this.model[this._ignoreOnPersist[i]];
                }
                this.model = model;
            }
            else
                this.model = $.extend(true, this.model, model);

            if (!silent && value && this._setModel)
                this._setModel(this.model);
        },

        //to prevent persistence
        ignoreOnPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    this._ignoreOnPersist.push(collection[i]);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    var index = this._addToPersist.indexOf(collection[i]);
                    this._addToPersist.splice(index, 1);
                }
            }
        },

        //to maintain persistence
        addToPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    var index = this._ignoreOnPersist.indexOf(collection[i]);
                    this._ignoreOnPersist.splice(index, 1);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    if ($.inArray(collection[i], this._addToPersist) === -1)
                        this._addToPersist.push(collection[i]);
                }
            }
        },

        // Get formatted text 
        formatting: function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture(locale) ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (s.startsWith("{") && !s.startsWith("{0:")) {
                var fVal = s.split(""), str = (str || "") + "", strSplt = str.split(""), formats = /[0aA\*CN<>\?]/gm;
                for (var f = 0, f, val = 0; f < fVal.length; f++)
                    fVal[f] = formats.test(fVal[f]) ? "{" + val++ + "}" : fVal[f];
                return String.format.apply(String, [fVal.join("")].concat(strSplt)).replace('{', '').replace('}', '');
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        },
    };

    ej.WidgetBase = function () {
    }

    var iterateAndRemoveProps = function (source, target) {
        for (var prop in source) {
            if (source[prop] === target[prop])
                delete target[prop];
            if ($.isPlainObject(target[prop]) && $.isPlainObject(source[prop]))
                iterateAndRemoveProps(source[prop], target[prop]);
        }
    }

    ej.widget = function (pluginName, className, proto) {
        /// <summary>Widget helper for developers, this set have predefined function to jQuery plug-ins</summary>
        /// <param name="pluginName" type="String">the plugin name that will be added in jquery.fn</param>
        /// <param name="className" type="String">the class name for your plugin, this will help create default cssClas</param>
        /// <param name="proto" type="Object">prototype for of the plug-in</param>

        if (typeof pluginName === "object") {
            proto = className;
            for (var prop in pluginName) {
                var name = pluginName[prop];

                if (name instanceof Array) {
                    proto._rootCSS = name[1];
                    name = name[0];
                }

                ej.widget(prop, name, proto);

                if (pluginName[prop] instanceof Array)
                    proto._rootCSS = "";
            }

            return;
        }

        var nameSpace = proto._rootCSS || ej.getNameSpace(className);

        proto = ej.defineClass(className, function (element, options) {

            this.sfType = className;
            this.pluginName = pluginName;
            this.instance = pInstance;

            if (ej.isNullOrUndefined(this._setFirst))
                this._setFirst = true;

            this["ob.values"] = {};

            $.extend(this, ej.widgetBase);

            if (this.dataTypes) {
                for (var property in options) {
                    var returnValue = this._isValidModelValue(property, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + property + " - " + returnValue;
                }
            }

            var arr = (element.data("ejWidgets") || []);
            arr.push(pluginName);
            element.data("ejWidgets", arr);

            for (var i = 0; ej.widget.observables && this.observables && i < this.observables.length; i++) {
                var t = ej.getObject(this.observables[i], options);
                if (t) ej.createObject(this.observables[i], ej.widget.observables.register(t, this.observables[i], this, element), options);
            }

            this.element = element.jquery ? element : $(element);
            this.model = copyObject(true, {}, proto.prototype.defaults, options);
            this.model.keyConfigs = copyObject(this.keyConfigs);

            this.element.addClass(nameSpace + " e-js").data(pluginName, this);

            this._id = element[0].id;

            if (this.model.enablePersistence) {
                if (window.localStorage && !ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") != ej.persistStateVersion) {
                    for (var i in window.localStorage) {
                        if (i.indexOf("$ej$") != -1) {
                            window.localStorage.removeItem(i); //removing the previously stored plugin item from local storage
							window.localStorage.setItem("persistKey", ej.persistStateVersion);
						}				
                    }
                }
                else if (document.cookie && !ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") != ej.persistStateVersion) {
                    var splits = document.cookie.split(/; */);
                    for (var k in splits) {
                        if (k.indexOf("$ej$") != -1) {
                            ej.cookie.set(k.split("=")[0], model, new Date()); //removing the previously stored plugin item from local storage
							ej.cookie.set("persistKey", ej.persistStateVersion);
						}		
                    }
                }
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
                this.restoreState(true);
            }

            this._init(options);

            if (typeof this.model.keyConfigs === "object" && !(this.model.keyConfigs instanceof Array)) {
                var requiresEvt = false;
                if (this.model.keyConfigs.focus)
                    this.element.attr("accesskey", this.model.keyConfigs.focus);

                for (var keyProps in this.model.keyConfigs) {
                    if (keyProps !== "focus") {
                        requiresEvt = true;
                        break;
                    }
                }

                if (requiresEvt && this._keyPressed) {
                    var el = element, evt = "keydown";

                    if (this.keySettings) {
                        el = this.keySettings.getElement ? this.keySettings.getElement() || el : el;
                        evt = this.keySettings.event || evt;
                    }

                    this._on(el, evt, function (e) {
                        if (!this.model.keyConfigs) return;

                        var action = keyFn.getActionFromCode(this.model.keyConfigs, e.which, e.ctrlKey, e.shiftKey, e.altKey);
                        var arg = {
                            code: e.which,
                            ctrl: e.ctrlKey,
                            alt: e.altKey,
                            shift: e.shiftKey
                        };
                        if (!action) return;

                        if (this._keyPressed(action, e.target, arg, e) === false)
                            e.preventDefault();
                    });
                }
            }
            this._trigger("create");
        }, proto);

        $.fn[pluginName] = function (options) {
            var opt = options, args;
            for (var i = 0; i < this.length; i++) {

                var $this = $(this[i]),
                    pluginObj = $this.data(pluginName),
                    isAlreadyExists = pluginObj && $this.hasClass(nameSpace),
                    obj = null;

                if (this.length > 0 && $.isPlainObject(opt))
                    options = ej.copyObject({}, opt);

                // ----- plug-in creation/init
                if (!isAlreadyExists) {
                    if (proto.prototype._requiresID === true && !$(this[i]).attr("id")) {
                        $this.attr("id", getUid("ejControl_"));
                    }
                    if (!options || typeof options === "object") {
                        if (proto.prototype.defaults && !ej.isNullOrUndefined(ej.setCulture) && "locale" in proto.prototype.defaults && pluginName != "ejChart") {
                            if (options && !("locale" in options)) options.locale = ej.setCulture().name;
                            else if (ej.isNullOrUndefined(options)) {
                                options = {}; options.locale = ej.setCulture().name;
                            }
                        }
                        new proto($this, options);
                    }
                    else {
                        throwError(pluginName + ": methods/properties can be accessed only after plugin creation");
                    }
                    continue;
                }

                if (!options) continue;

                args = [].slice.call(arguments, 1);

                if (this.length > 0 && args[0] && opt === "option" && $.isPlainObject(args[0])) {
                    args[0] = ej.copyObject({}, args[0]);
                }

                // --- Function/property set/access
                if ($.isPlainObject(options)) {
                    // setModel using JSON object
                    pluginObj.setModel(options);
                }

                    // function/property name starts with "_" is private so ignore it.
                else if (options.indexOf('_') !== 0
                    && !ej.isNullOrUndefined(obj = ej.getObject(options, pluginObj))
                    || options.indexOf("model.") === 0) {

                    if (!obj || !$.isFunction(obj)) {

                        // if property is accessed, then break the jquery chain
                        if (arguments.length == 1)
                            return obj;

                        //setModel using string input
                        pluginObj.option(options, arguments[1]);

                        continue;
                    }

                    var value = obj.apply(pluginObj, args);

                    // If function call returns any value, then break the jquery chain
                    if (value !== undefined)
                        return value;

                } else {
                    throwError(className + ": function/property - " + options + " does not exist");
                }
            }
            if (pluginName.indexOf("ejm") != -1)
                ej.widget.registerInstance($this, pluginName, className, proto.prototype);
            // maintaining jquery chain
            return this;
        };

        ej.widget.register(pluginName, className, proto.prototype);
        ej.loadLocale(pluginName);
    };

    ej.loadLocale = function (pluginName) {
        var i, len, locales = ej.locales;
        for (i = 0, len = locales.length; i < len; i++)
            $.fn["Locale_" + locales[i]](pluginName);
    };


    $.extend(ej.widget, (function () {
        var _widgets = {}, _registeredInstances = [],

        register = function (pluginName, className, prototype) {
            if (!ej.isNullOrUndefined(_widgets[pluginName]))
                throwError("ej.widget : The widget named " + pluginName + " is trying to register twice.");

            _widgets[pluginName] = { name: pluginName, className: className, proto: prototype };

            ej.widget.extensions && ej.widget.extensions.registerWidget(pluginName);
        },
        registerInstance = function (element, pluginName, className, prototype) {
            _registeredInstances.push({ element: element, pluginName: pluginName, className: className, proto: prototype });
        }

        return {
            register: register,
            registerInstance: registerInstance,
            registeredWidgets: _widgets,
            registeredInstances: _registeredInstances
        };

    })());

    ej.widget.destroyAll = function (elements) {
        if (!elements || !elements.length) return;

        for (var i = 0; i < elements.length; i++) {
            var data = elements.eq(i).data(), wds = data["ejWidgets"];
            if (wds && wds.length) {
                for (var j = 0; j < wds.length; j++) {
                    if (data[wds[j]] && data[wds[j]].destroy)
                        data[wds[j]].destroy();
                }
            }
        }
    };

    ej.cookie = {
        get: function (name) {
            var value = RegExp(name + "=([^;]+)").exec(document.cookie);

            if (value && value.length > 1)
                return value[1];

            return undefined;
        },
        set: function (name, value, expiryDate) {
            if (typeof value === "object")
                value = JSON.stringify(value);

            value = escape(value) + ((expiryDate == null) ? "" : "; expires=" + expiryDate.toUTCString());
            document.cookie = name + "=" + value;
        }
    };

    var keyFn = {
        getActionFromCode: function (keyConfigs, keyCode, isCtrl, isShift, isAlt) {
            isCtrl = isCtrl || false;
            isShift = isShift || false;
            isAlt = isAlt || false;

            for (var keys in keyConfigs) {
                if (keys === "focus") continue;

                var key = keyFn.getKeyObject(keyConfigs[keys]);
                for (var i = 0; i < key.length; i++) {
                    if (keyCode === key[i].code && isCtrl == key[i].isCtrl && isShift == key[i].isShift && isAlt == key[i].isAlt)
                        return keys;
                }
            }
            return null;
        },
        getKeyObject: function (key) {
            var res = {
                isCtrl: false,
                isShift: false,
                isAlt: false
            };
            var tempRes = $.extend(true, {}, res);
            var $key = key.split(","), $res = [];
            for (var i = 0; i < $key.length; i++) {
                var rslt = null;
                if ($key[i].indexOf("+") != -1) {
                    var k = $key[i].split("+");
                    for (var j = 0; j < k.length; j++) {
                        rslt = keyFn.getResult($.trim(k[j]), res);
                    }
                }
                else {
                    rslt = keyFn.getResult($.trim($key[i]), $.extend(true, {}, tempRes));
                }
                $res.push(rslt);
            }
            return $res;
        },
        getResult: function (key, res) {
            if (key === "ctrl")
                res.isCtrl = true;
            else if (key === "shift")
                res.isShift = true;
            else if (key === "alt")
                res.isAlt = true;
            else res.code = parseInt(key, 10);
            return res;
        }
    };

    ej.getScrollableParents = function (element) {
        return $(element).parentsUntil("html").filter(function () {
            return $(this).css("overflow") != "visible";
        }).add($(window));
    }
    ej.browserInfo = function () {
        var browser = {}, clientInfo = [],
        browserClients = {
            opera: /(opera|opr)(?:.*version|)[ \/]([\w.]+)/i, edge: /(edge)(?:.*version|)[ \/]([\w.]+)/i, webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie|trident) ([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase() == "opr" ? "opera" : clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    browser.culture = {};
                    browser.culture.name = browser.culture.language = navigator.language || navigator.userLanguage;
                    if (typeof (ej.globalize) != 'undefined') {
                        var oldCulture = ej.preferredCulture().name;
                        var culture = (navigator.language || navigator.userLanguage) ? ej.preferredCulture(navigator.language || navigator.userLanguage) : ej.preferredCulture("en-US");
                        for (var i = 0; (navigator.languages) && i < navigator.languages.length; i++) {
                            culture = ej.preferredCulture(navigator.languages[i]);
                            if (culture.language == navigator.languages[i])
                                break;
                        }
                        ej.preferredCulture(oldCulture);
                        $.extend(true, browser.culture, culture);
                    }
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    };
    ej.eventType = {
        mouseDown: "mousedown touchstart",
        mouseMove: "mousemove touchmove",
        mouseUp: "mouseup touchend",
        mouseLeave: "mouseleave touchcancel",
        click: "click touchend"
    };

    ej.event = function (type, data, eventProp) {

        var e = $.extend(eventProp || {},
            {
                "type": type,
                "model": data,
                "cancel": false
            });

        return e;
    };

    ej.proxy = function (fn, context, arg) {
        if (!fn || typeof fn !== "function")
            return null;

        if ('on' in fn && context)
            return arg ? fn.on(context, arg) : fn.on(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.hasStyle = function (prop) {
        var style = document.documentElement.style;

        if (prop in style) return true;

        var prefixs = ['ms', 'Moz', 'Webkit', 'O', 'Khtml'];

        prop = prop[0].toUpperCase() + prop.slice(1);

        for (var i = 0; i < prefixs.length; i++) {
            if (prefixs[i] + prop in style)
                return true;
        }

        return false;
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };
    var copyObject = ej.copyObject = function (isDeepCopy, target) {
        var start = 2, current, source;
        if (typeof isDeepCopy !== "boolean") {
            start = 1;
        }
        var objects = [].slice.call(arguments, start);
        if (start === 1) {
            target = isDeepCopy;
            isDeepCopy = undefined;
        }

        for (var i = 0; i < objects.length; i++) {
            for (var prop in objects[i]) {
                current = target[prop], source = objects[i][prop];

                if (source === undefined || current === source || objects[i] === source || target === source)
                    continue;
                if (source instanceof Array) {
                    if (i === 0 && isDeepCopy) {
                        target[prop] = new Array();
                        for (var j = 0; j < source.length; j++) {
                            copyObject(true, target[prop], source);
                        }
                    }
                    else
                        target[prop] = source.slice();
                }
                else if (ej.isPlainObject(source)) {
                    target[prop] = current || {};
                    if (isDeepCopy)
                        copyObject(isDeepCopy, target[prop], source);
                    else
                        copyObject(target[prop], source);
                } else
                    target[prop] = source;
            }
        }
        return target;
    };
    var pInstance = function () {
        return this;
    }

    var _uid = 0;
    var getUid = function (prefix) {
        return prefix + _uid++;
    }

    ej.template = {};

    ej.template.render = ej.template["text/x-jsrender"] = function (self, selector, data, index, prop) {
        if (selector.slice(0, 1) !== "#")
            selector = ["<div>", selector, "</div>"].join("");
        var property = { prop: prop, index: index };
        return $(selector).render(data, property);
    }

    ej.isPlainObject = function (obj) {
        if (!obj) return false;
        if (ej.DataManager !== undefined && obj instanceof ej.DataManager) return false;
        if (typeof obj !== "object" || obj.nodeType || jQuery.isWindow(obj)) return false;
        try {
            if (obj.constructor &&
                !obj.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                return false;
            }
        } catch (e) {
            return false;
        }

        var key, ownLast = ej.support.isOwnLast;
        for (key in obj) {
            if (ownLast) break;
        }

        return key === undefined || obj.hasOwnProperty(key);
    };
    var getValueFn = false;
    ej.util.valueFunction = function (prop) {
        return function (value, getObservable) {
            var val = ej.getObject(prop, this.model);

            if (getValueFn === false)
                getValueFn = ej.getObject("observables.getValue", ej.widget);

            if (value === undefined) {
                if (!ej.isNullOrUndefined(getValueFn)) {
                    return getValueFn(val, getObservable);
                }
                return typeof val === "function" ? val.call(this) : val;
            }

            if (typeof val === "function") {
                this["ob.values"][prop] = value;
                val.call(this, value);
            }
            else
                ej.createObject(prop, value, this.model);
        }
    };
    ej.util.getVal = function (val) {
        if (typeof val === "function")
            return val();
        return val;
    };
    ej.support = {
        isOwnLast: function () {
            var fn = function () { this.a = 1; };
            fn.prototype.b = 1;

            for (var p in new fn()) {
                return p === "b";
            }
        }(),
        outerHTML: function () {
            return document.createElement("div").outerHTML !== undefined;
        }()
    };

    var throwError = ej.throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

    ej.getRandomValue = function (min, max) {
        if (min === undefined || max === undefined)
            return ej.throwError("Min and Max values are required for generating a random number");

        var rand;
        if ("crypto" in window && "getRandomValues" in crypto) {
            var arr = new Uint16Array(1);
            window.crypto.getRandomValues(arr);
            rand = arr[0] % (max - min) + min;
        }
        else rand = Math.random() * (max - min) + min;
        return rand | 0;
    }

    ej.extensions = {};
    ej.extensions.modelGUID = "{0B1051BA-1CCB-42C2-A3B5-635389B92A50}";
})(window.jQuery, window.Syncfusion);
(function () {
    $.fn.addEleAttrs = function (json) {
        var $this = $(this);
        $.each(json, function (i, attr) {
            if (attr && attr.specified) {
                $this.attr(attr.name, attr.value);
            }
        });

    };
    $.fn.removeEleAttrs = function (regex) {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && regex.test(attr.name)) {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.fn.attrNotStartsWith = function (regex) {
        var proxy = this;
        var attributes = [], attrs;
        this.each(function () {
            attrs = $(this.attributes).clone();
        });
        for (i = 0; i < attrs.length; i++) {
            if (attrs[i] && attrs[i].specified && regex.test(attrs[i].name)) {
                continue
            }
            else
                attributes.push(attrs[i])
        }
        return attributes;

    }
    $.fn.removeEleEmptyAttrs = function () {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && attr.value === "") {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.extend($.support, {
        has3d: ej.addPrefix('perspective') in ej.styles,
        hasTouch: 'ontouchstart' in window,
        hasPointer: navigator.msPointerEnabled,
        hasTransform: ej.userAgent() !== false,
        pushstate: "pushState" in history &&
        "replaceState" in history,
        hasTransition: ej.addPrefix('transition') in ej.styles
    });
    //Ensuring elements having attribute starts with 'ejm-' 
    $.extend($.expr[':'], {
        attrNotStartsWith: function (element, index, match) {
            var i, attrs = element.attributes;
            for (i = 0; i < attrs.length; i++) {
                if (attrs[i].nodeName.indexOf(match[3]) === 0) {
                    return false;
                }
            }
            return true;
        }
    });
    //addBack() is supported from Jquery >1.8 and andSelf() supports later version< 1.8. support for both the method is provided by extending the JQuery function.
    var oldSelf = $.fn.andSelf || $.fn.addBack;
    $.fn.andSelf = $.fn.addBack = function () {
        return oldSelf.apply(this, arguments);
    };
})();;
;
window.ej = window.Syncfusion = window.Syncfusion || {};

(function ($, ej, doc, undefined) {
    'use strict';
	
    ej.DataManager = function (dataSource, query, adaptor) {
          if (!(this instanceof ej.DataManager))
            return new ej.DataManager(dataSource, query, adaptor);

        if (!dataSource)
            dataSource = [];
        adaptor = adaptor || dataSource.adaptor;

        if (typeof (adaptor) === "string") 
            adaptor = new ej[adaptor]();
        var data = [], self = this;

        if (dataSource instanceof Array) {
            // JSON array
            data = {
                json: dataSource,
                offline: true
            };

        } else if (typeof dataSource === "object") {
            if ($.isPlainObject(dataSource)) {
                if (!dataSource.json)
                    dataSource.json = [];
                if (dataSource.table)
                    dataSource.json = this._getJsonFromElement(dataSource.table, dataSource.headerOption);
                data = {
                    url: dataSource.url,
                    insertUrl: dataSource.insertUrl,
                    removeUrl: dataSource.removeUrl,
                    updateUrl: dataSource.updateUrl,
                    crudUrl: dataSource.crudUrl,
                    batchUrl: dataSource.batchUrl,
                    json: dataSource.json,
                    headers: dataSource.headers,
                    accept: dataSource.accept,
                    data: dataSource.data,
					async : dataSource.async,
                    timeTillExpiration: dataSource.timeTillExpiration,
                    cachingPageSize: dataSource.cachingPageSize,
                    enableCaching: dataSource.enableCaching,
                    requestType: dataSource.requestType,
                    key: dataSource.key,
                    crossDomain: dataSource.crossDomain,
                    antiForgery: dataSource.antiForgery,
                    jsonp: dataSource.jsonp,
                    dataType: dataSource.dataType,
                    offline: dataSource.offline !== undefined ? dataSource.offline : dataSource.adaptor == "remoteSaveAdaptor" || dataSource.adaptor instanceof ej.remoteSaveAdaptor ? false : dataSource.url ? false : true,
                    requiresFormat: dataSource.requiresFormat
                };
            } else if (dataSource.jquery || isHtmlElement(dataSource)) {
                data = {
                    json: this._getJsonFromElement(dataSource),
                    offline: true,
                    table: dataSource
                };
            }
        } else if (typeof dataSource === "string") {
            data = {
                url: dataSource,
                offline: false,
                dataType: "json",
                json: []
            };
        }

        if (data.requiresFormat === undefined && !ej.support.cors)
            data.requiresFormat = isNull(data.crossDomain) ? true : data.crossDomain;
         if(data.antiForgery){
        this.antiForgeryToken();
        }
        if (data.dataType === undefined)
            data.dataType = "json";
        this.dataSource = data;
        this.defaultQuery = query;

        if (data.url && data.offline && !data.json.length) {
            this.isDataAvailable = false;
            this.adaptor = adaptor || new ej.ODataAdaptor();
            this.dataSource.offline = false;
            this.ready = this.executeQuery(query || ej.Query()).done(function (e) {
                self.dataSource.offline = true;
                self.isDataAvailable = true;
                data.json = e.result;
                self.adaptor = new ej.JsonAdaptor();
            });
        }
        else
            this.adaptor = data.offline ? new ej.JsonAdaptor() : new ej.ODataAdaptor();
        if (!data.jsonp && this.adaptor instanceof ej.ODataAdaptor)
            data.jsonp = "callback";
        this.adaptor = adaptor || this.adaptor;
        if (data.enableCaching)
            this.adaptor = new ej.CacheAdaptor(this.adaptor, data.timeTillExpiration, data.cachingPageSize);
        return this;
    };

    ej.DataManager.prototype = {
        setDefaultQuery: function (query) {
            this.defaultQuery = query;
        },
	
        executeQuery: function (query, done, fail, always) {
            if (typeof query === "function") {
                always = fail;
                fail = done;
                done = query;
                query = null;
            }

            if (!query)
                query = this.defaultQuery;

            if (!(query instanceof ej.Query))
                throwError("DataManager - executeQuery() : A query is required to execute");

            var deffered = $.Deferred();

            deffered.then(done, fail, always);
            var args = { query: query };

            if (!this.dataSource.offline && this.dataSource.url != undefined) {
				 var result = this.adaptor.processQuery(this, query);
                if (!ej.isNullOrUndefined(result.url))
                    this._makeRequest(result, deffered, args, query);
                else {
                    nextTick(function () {
                        args = this._getDeferedArgs(query, result, args);
                        deffered.resolveWith(this, [args]);;
                    }, this);
                }
            } else {
				if(!ej.isNullOrUndefined(this.dataSource.async) && this.dataSource.async == false)
					this._localQueryProcess(query, args, deffered);
				else{
					nextTick(function () {
						this._localQueryProcess(query, args, deffered);
					}, this);
				}
            }
            return deffered.promise();
        },
		_localQueryProcess: function(query, args, deffered){
			var res = this.executeLocal(query);
			args = this._getDeferedArgs(query, res, args);
			deffered.resolveWith(this, [args]);
		},
        _getDeferedArgs: function (query, result, args) {
            if (query._requiresCount) {
                args.result = result.result;
                args.count = result.count;
            } else
                args.result = result;
            args.getTableModel = getTableModel(query._fromTable, args.result, this);
            args.getKnockoutModel = getKnockoutModel(args.result);
            return args;
        },
	
        executeLocal: function (query) {
            if (!this.defaultQuery && !(query instanceof ej.Query))
                throwError("DataManager - executeLocal() : A query is required to execute");

            if (!this.dataSource.json)
                throwError("DataManager - executeLocal() : Json data is required to execute");

            query = query || this.defaultQuery;

            var result = this.adaptor.processQuery(this, query);

            if (query._subQuery) {
                var from = query._subQuery._fromTable, lookup = query._subQuery._lookup,
                    res = query._requiresCount ? result.result : result;

                if (lookup && lookup instanceof Array) {
                    buildHierarchy(query._subQuery._fKey, from, res, lookup, query._subQuery._key);
                }

                for (var j = 0; j < res.length; j++) {
                    if (res[j][from] instanceof Array) {
                        res[j] = $.extend({}, res[j]);
                        res[j][from] = this.adaptor.processResponse(query._subQuery.using(ej.DataManager(res[j][from].slice(0))).executeLocal(), this, query);
                    }
                }
            }

            return this.adaptor.processResponse(result, this, query);
        },

        _makeRequest: function (url, deffered, args, query) {
            var isSelector = !!query._subQuerySelector;

            var fnFail = $proxy(function (e) {
                args.error = e;
                deffered.rejectWith(this, [args]);
            }, this);

            var process = $proxy(function (data, count, xhr, request, actual, aggregates, virtualSelectRecords) {
                if (isSelector) return;

                args.xhr = xhr;
                args.count = parseInt(count, 10);
                args.result = data;
                args.request = request;
                args.aggregates = aggregates;
                args.getTableModel = getTableModel(query._fromTable, data, this);
                args.getKnockoutModel = getKnockoutModel(data);
                args.actual = actual;
                args.virtualSelectRecords = virtualSelectRecords;
                deffered.resolveWith(this, [args]);

            }, this);

            var fnQueryChild = $proxy(function (data, selector) {
                var subDeffer = $.Deferred(),
                    childArgs = { parent: args };

                query._subQuery._isChild = true;

                var subUrl = this.adaptor.processQuery(this, query._subQuery, data ? this.adaptor.processResponse(data) : selector);

                var childReq = this._makeRequest(subUrl, subDeffer, childArgs, query._subQuery);

                if(!isSelector)
                    subDeffer.then(function (subData) {
                        if (data) {
                            buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, data, subData, query._subQuery._key);
                            process(data);
                        }
                    }, fnFail);

                return childReq;
            }, this);

            var fnSuccess = proxy(function (data, status, xhr, request) {
                if (xhr.getResponseHeader("Content-Type").indexOf("xml") == -1 && ej.dateParse)
                    data = ej.parseJSON(data);
                var result = this.adaptor.processResponse(data, this, query, xhr, request), count = 0, aggregates = null;
                var virtualSelectRecords = data.virtualSelectRecords;
                if (query._requiresCount) {
                    count = result.count;
                    aggregates = result.aggregates;
                    result = result.result;
                }

                if (!query._subQuery) {
                    process(result, count, xhr, request, data, aggregates, virtualSelectRecords);
                    return;
                }

                if (!isSelector)
                    fnQueryChild(result);

            }, this);

            var req = $.extend({
                type: "GET",
                dataType: this.dataSource.dataType,
                crossDomain: this.dataSource.crossDomain,
                jsonp: this.dataSource.jsonp,
                cache: true,
                beforeSend: $proxy(this._beforeSend, this),
                processData: false,
                success: fnSuccess,
                error: fnFail
            }, url);

            if ("async" in this.dataSource)
                req.async = this.dataSource.async;

            req = $.ajax(req);

            if (isSelector) {
                var res = query._subQuerySelector.call(this, { query: query._subQuery, parent: query });

                if (res && res.length) {
                    req = $.when(req, fnQueryChild(null, res));

                    req.then(proxy(function (pData, cData, requests) {
                        var pResult = this.adaptor.processResponse(pData[0], this, query, pData[2], requests[0]), count = 0;
                        if (query._requiresCount) {
                            count = pResult.count;
                            pResult = pResult.result;
                        }
                        var cResult = this.adaptor.processResponse(cData[0], this, query._subQuery, cData[2], requests[1]), count = 0;
                        if (query._subQuery._requiresCount) {
                            count = cResult.count;
                            cResult = cResult.result;
                        }

                        buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, pResult, cResult, query._subQuery._key);
                        isSelector = false;
                        process(pResult, count, pData[2]);

                    }, this), fnFail);
                } else {
                    isSelector = false;
                }
            }

            return req;
        },

        _beforeSend: function (request, settings) {
            this.adaptor.beforeSend(this, request, settings);

            var headers = this.dataSource.headers, props;
            for (var i = 0; headers && i < headers.length; i++) {
                props = [];
                for (var prop in headers[i]) {
                    props.push(prop);
                    request.setRequestHeader(prop, headers[i][prop]);
                }
            }
        },
	
        saveChanges: function (changes, key, tableName, query) {

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var args = {
                url: tableName,
                key: key || this.dataSource.key
            };

            var req = this.adaptor.batchRequest(this, changes, args, query);

            if (this.dataSource.offline) {
                return req;
            }

            var deff = $.Deferred();
            $.ajax($.extend({
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (data, status, xhr, request) {
                    deff.resolveWith(this, [this.adaptor.processResponse(data, this, null, xhr, request, changes, key)]);
                }, this),
                error: function (e) {
                    deff.rejectWith(this, [{ error: e }]);
                }
            }, req));

            return deff.promise();
        },
	
        insert: function (data, tableName, query) {           
            data = p.replacer(data);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.insert(this, data, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }            

            var deffer = $.Deferred();

            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                processData: false,
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));

            return deffer.promise();
        },
        antiForgeryToken: function () {
           var tokens = {};
           if(ej.isNullOrUndefined($("input[name='_ejRequestVerifyToken']").val()))
                var input = ej.buildTag("input", "", "", { type: "hidden", name: "_ejRequestVerifyToken" , value: ej.getGuid()}).appendTo("body"); 
           else
               $("input[name='_ejRequestVerifyToken']").val(ej.getGuid());
            ej.cookie.set("_ejRequestVerifyToken", $("input[name='_ejRequestVerifyToken']").val());
            tokens ={name: "_ejRequestVerifyToken", value: $("input[name='_ejRequestVerifyToken']").val()}
            return tokens;
        },
        remove: function (keyField, value, tableName, query) {
            if (typeof value === "object")
                value = value[keyField];

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.remove(this, keyField, value, tableName, query);

            if (this.dataSource.offline)
                return res;          

            var deffer = $.Deferred();
            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));
            return deffer.promise();
        },
	
        update: function (keyField, value, tableName, query) {
            value = p.replacer(value);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.update(this, keyField, value, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }           

            var deffer = $.Deferred();

           $.ajax($.extend({
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
           }, res));

           return deffer.promise();
        },

        _getJsonFromElement: function (ds) {
            if (typeof (ds) == "string")
                ds = $($(ds).html());

            ds = ds.jquery ? ds[0] : ds;

            var tagName = ds.tagName.toLowerCase();

            if (tagName !== "table")
                throwError("ej.DataManager : Unsupported htmlElement : " + tagName);

            return ej.parseTable(ds);
        }
    };

    var buildHierarchy = function (fKey, from, source, lookup, pKey) {
        var i, grp = {}, t;
        if (lookup.result) lookup = lookup.result;

        if (lookup.GROUPGUID)
            throwError("ej.DataManager: Do not have support Grouping in hierarchy");

        for (i = 0; i < lookup.length; i++) {
            var fKeyData = ej.getObject(fKey, lookup[i]);
            t = grp[fKeyData] || (grp[fKeyData] = []);

            t.push(lookup[i]);
        }

        for (i = 0; i < source.length; i++) {
            source[i][from] = grp[ej.getObject(pKey || fKey, source[i])];
        }
    };

    var oData = {
        accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
        multipartAccept: "multipart/mixed",
        batch: "$batch",
        changeSet: "--changeset_",
        batchPre: "batch_",
        contentId: "Content-Id: ",
        batchContent: "Content-Type: multipart/mixed; boundary=",
        changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
        batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
    };
    var p = {
        parseJson: function (jsonText) {
            var type = typeof jsonText;
            if (type === "string") {
                jsonText = JSON.parse(jsonText, p.jsonReviver);
            } else if (jsonText instanceof Array) {
                p.iterateAndReviveArray(jsonText);
            } else if (type === "object")
                p.iterateAndReviveJson(jsonText);
            return jsonText;
        },
        iterateAndReviveArray: function (array) {
            for (var i = 0; i < array.length; i++) {
                if (typeof array[i] === "object")
                    p.iterateAndReviveJson(array[i]);
                else if (typeof array[i] === "string" && !/^[\s]*\[|^[\s]*\{|\"/g.test(array[i]))
                    array[i] = p.jsonReviver("",array[i]);
                else
                    array[i] = p.parseJson(array[i]);
            }
        },
        iterateAndReviveJson: function (json) {
            var value;

            for (var prop in json) {
                if (prop.startsWith("__"))
                    continue;

                value = json[prop];
                if (typeof value === "object") {
                    if (value instanceof Array)
                        p.iterateAndReviveArray(value);
                    else
                        p.iterateAndReviveJson(value);
                } else
                    json[prop] = p.jsonReviver(prop, value);
            }
        },
        jsonReviver: function (field, value) {
            var s = value;
            if (typeof value === "string") {
                var ms = /^\/Date\(([+-]?[0-9]+)([+-][0-9]{4})?\)\/$/.exec(value);
                if (ms)
                    return p.replacer(new Date(parseInt(ms[1])));
                else if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*){1})([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(value)) {
                    value = p.replacer(new Date(value));
                    if (isNaN(value)) {
                        var a = s.split(/[^0-9]/);
                        value = p.replacer(new Date(a[0], a[1] - 1, a[2], a[3], a[4], a[5]));
                    }
                }
            }

            return value;
        },
        isJson: function (jsonData) {
            if(typeof jsonData[0]== "string")
                return jsonData;
            return ej.parseJSON(jsonData);
        },
        isGuid: function (value) {
            var regex = /[A-Fa-f0-9]{8}(?:-[A-Fa-f0-9]{4}){3}-[A-Fa-f0-9]{12}/i;
            var match = regex.exec(value);
            return match != null;
        },
        replacer: function (value) {

            if (ej.isPlainObject(value))
                return p.jsonReplacer(value);

            if (value instanceof Array)
                return p.arrayReplacer(value);

            if (value instanceof Date)
                return p.jsonReplacer({ val: value }).val;

            return value;
        },
        jsonReplacer: function (val) {
            var value;
            for (var prop in val) {
                value = val[prop];

                if (!(value instanceof Date))
                    continue;
                val[prop] = new Date(+value + (ej.serverTimezoneOffset * 60 * 60 * 1000));
            }

            return val;
        },
        arrayReplacer: function (val) {

            for (var i = 0; i < val.length; i++) {            
                if (ej.isPlainObject(val[i]))
                    val[i] = p.jsonReplacer(val[i]);
                else if (val[i] instanceof Date)
                    val[i] = p.jsonReplacer({ date: val[i] }).date;
            }

            return val;
        }
    };

    ej.isJSON = p.isJson;
    ej.parseJSON = p.parseJson;
    ej.dateParse = true;
    ej.isGUID = p.isGuid;
    ej.Query = function (from) {
        if (!(this instanceof ej.Query))
            return new ej.Query(from);

        this.queries = [];
        this._key = "";
        this._fKey = "";

        if (typeof from === "string")
            this._fromTable = from || "";
        else if (from && from instanceof Array)
            this._lookup = from;

        this._expands = [];
        this._sortedColumns = [];
        this._groupedColumns = [];
        this._subQuery = null;
        this._isChild = false;
        this._params = [];
        return this;
    };

    ej.Query.prototype = {
        key: function (field) {
            if (typeof field === "string")
                this._key = field;

            return this;
        },
	
        using: function (dataManager) {
            if (dataManager instanceof ej.DataManager) {
                this.dataManagar = dataManager;
                return this;
            }

            return throwError("Query - using() : 'using' function should be called with parameter of instance ej.DataManager");
        },
	
        execute: function (dataManager, done, fail, always) {
            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeQuery(this, done, fail, always);

            return throwError("Query - execute() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        executeLocal: function (dataManager) {
            // this does not support for URL binding
            

            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeLocal(this);

            return throwError("Query - executeLocal() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        clone: function () {
            var cl = new ej.Query();
            cl.queries = this.queries.slice(0);
            cl._key = this._key;
            cl._isChild = this._isChild;
            cl.dataManagar = this.dataManager;
            cl._fromTable = this._fromTable;
            cl._params = this._params.slice(0);
            cl._expands = this._expands.slice(0);
            cl._sortedColumns = this._sortedColumns.slice(0);
            cl._groupedColumns = this._groupedColumns.slice(0);
            cl._subQuerySelector = this._subQuerySelector;
            cl._subQuery = this._subQuery;
            cl._fKey = this._fKey;
            cl._requiresCount = this._requiresCount;
            return cl;
        },
	
        from: function (tableName) {
            if (typeof tableName === "string")
                this._fromTable = tableName;

            return this;
        },
	
        addParams: function (key, value) {
            if (typeof value !== "function" && !ej.isPlainObject(value))
                this._params.push({ key: key, value: value });
            else if (typeof value === "function")
                this._params.push({ key: key, fn: value });

            return this;
        },
	
        expand: function (tables) {
            if (typeof tables === "string")
                this._expands = [].slice.call(arguments, 0);
            else
                this._expands = tables.slice(0);

            return this;
        },
	
        where: function (fieldName, operator, value, ignoreCase) {
            operator = (operator || ej.FilterOperators.equal).toLowerCase();
            var predicate = null;

            if (typeof fieldName === "string")
                predicate = new ej.Predicate(fieldName, operator, value, ignoreCase);
            else if (fieldName instanceof ej.Predicate)
                predicate = fieldName;
            else
                throwError("Query - where : Invalid arguments");

            this.queries.push({
                fn: "onWhere",
                e: predicate
            });
            return this;
        },
	
        search: function (searchKey, fieldNames, operator, ignoreCase) {
            if (!fieldNames || typeof fieldNames === "boolean") {
                fieldNames = [];
                ignoreCase = fieldNames;
            } else if (typeof fieldNames === "string")
                fieldNames = [fieldNames];

            if (typeof operator === "boolean") {
                ignoreCase = operator;
                operator = null;
            }
            operator = operator || ej.FilterOperators.contains;
            if (operator.length < 3)
                operator = ej.data.operatorSymbols[operator];

            var comparer = ej.data.fnOperators[operator] || ej.data.fnOperators.processSymbols(operator);

            this.queries.push({
                fn: "onSearch",
                e: {
                    fieldNames: fieldNames,
                    operator: operator,
                    searchKey: searchKey,
                    ignoreCase: ignoreCase,
                    comparer: comparer
                }
            });
            return this;
        },
		
        sortBy: function (fieldName, comparer, isFromGroup) {
            var order = ej.sortOrder.Ascending, sorts, t;

            if (typeof fieldName === "string" && fieldName.toLowerCase().endsWith(" desc")) {
                fieldName = fieldName.replace(/ desc$/i, '');
                comparer = ej.sortOrder.Descending;
            }
            if (fieldName instanceof Array) {
                for(var i=0;i<fieldName.length;i++)
                   this.sortBy(fieldName[i],comparer,isFromGroup);
                return this;
            }
            if (typeof comparer === "boolean")
                comparer = !comparer ? ej.sortOrder.Ascending : ej.sortOrder.Descending;
            else if (typeof comparer === "function")
                order = "custom";

            if (!comparer || typeof comparer === "string") {
                order = comparer ? comparer.toLowerCase() : ej.sortOrder.Ascending;
                comparer = ej.pvt.fnSort(comparer);
            }
            if (isFromGroup) {
                sorts = filterQueries(this.queries, "onSortBy");

                for (var i = 0; i < sorts.length; i++) {
                    t = sorts[i].e.fieldName;
                    if (typeof t === "string") {
                        if (t === fieldName) return this;
                    } else if (t instanceof Array) {
                        for (var j = 0; j < t.length; j++)
                            if (t[j] === fieldName || fieldName.toLowerCase() === t[j] + " desc")
                                return this;
                    }
                }
            }

            this.queries.push({
                fn: "onSortBy",
                e: {
                    fieldName: fieldName,
                    comparer: comparer,
                    direction: order
                }
            });

            return this;
        },
		
        sortByDesc: function (fieldName) {
            return this.sortBy(fieldName, ej.sortOrder.Descending);
        },
		
        group: function (fieldName,fn) {
            this.sortBy(fieldName, null, true);

            this.queries.push({
                fn: "onGroup",
                e: {
                    fieldName: fieldName,
                    fn: fn
                }
            });
            return this;
        },
	
        page: function (pageIndex, pageSize) {
            this.queries.push({
                fn: "onPage",
                e: {
                    pageIndex: pageIndex,
                    pageSize: pageSize
                }
            });
            return this;
        },
	
        range: function (start, end) {
            if (typeof start !== "number" || typeof end !== "number")
                throwError("Query() - range : Arguments type should be a number");

            this.queries.push({
                fn: "onRange",
                e: {
                    start: start,
                    end: end
                }
            });
            return this;
        },
	

        take: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Take : Argument type should be a number");

            this.queries.push({
                fn: "onTake",
                e: {
                    nos: nos
                }
            });
            return this;
        },
	
        skip: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Skip : Argument type should be a number");

            this.queries.push({
                fn: "onSkip",
                e: { nos: nos }
            });
            return this;
        },
	
        select: function (fieldNames) {
            if (typeof fieldNames === "string")
                fieldNames = [].slice.call(arguments, 0);

            if (!(fieldNames instanceof Array)) {
                throwError("Query() - Select : Argument type should be String or Array");
            }

            this.queries.push({
                fn: "onSelect",
                e: { fieldNames: fieldNames }
            });
            return this;
        },
	
        hierarchy: function (query, selectorFn) {
            if (!query || !(query instanceof ej.Query))
                throwError("Query() - hierarchy : query must be instance of ej.Query");

            if (typeof selectorFn === "function")
                this._subQuerySelector = selectorFn;

            this._subQuery = query;
            return this;
        },
	
        foreignKey: function (key) {
            if (typeof key === "string")
                this._fKey = key;

            return this;
        },
	
        requiresCount: function () {
            this._requiresCount = true;

            return this;
        },
        //type - sum, avg, min, max
        aggregate: function (type, field) {
            this.queries.push({
                fn: "onAggregates",
                e: { field: field, type: type }
            });
        }
    };

    ej.Adaptor = function (ds) {
        this.dataSource = ds;
        this.pvt = {};
		this.init.apply(this, [].slice.call(arguments, 1));
    };

    ej.Adaptor.prototype = {
        options: {
            from: "table",
            requestType: "json",
            sortBy: "sorted",
            select: "select",
            skip: "skip",
            group: "group",
            take: "take",
            search: "search",
            count: "requiresCounts",
            where: "where",
            aggregates: "aggregates",
            antiForgery: "antiForgery"
        },
        init: function () {
        },
        extend: function (overrides) {
            var fn = function (ds) {
                this.dataSource = ds;

                if (this.options)
                    this.options = $.extend({}, this.options);
				this.init.apply(this, [].slice.call(arguments, 0));

                this.pvt = {};
            };
            fn.prototype = new this.type();
            fn.prototype.type = fn;

            var base = fn.prototype.base = {};
            for (var p in overrides) {
                if (fn.prototype[p])
                    base[p] = fn.prototype[p];
            }
            $.extend(true, fn.prototype, overrides);
            return fn;
        },
        processQuery: function (dm, query) {
            // this needs to be overridden
        },
        processResponse: function (data, ds, query, xhr) {
            if (data.d)
               return data.d;
            return data;
        },
        convertToQueryString: function (req, query, dm) {
            return $.param(req);
        },
        type: ej.Adaptor
    };

    ej.UrlAdaptor = new ej.Adaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
                aggregates = filterQueries(query.queries, "onAggregates"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params,
                url = dm.dataSource.url, tmp, skip, take = null,
                op = this.options;

            var r = {
                sorted: [],
                grouped: [],
                filters: [],
                searches: [],
                aggregates: []
            };

            // calc Paging & Range
            if (singles["onPage"]) {
                tmp = singles["onPage"];
                skip = getValue(tmp.pageIndex, query);
                take = getValue(tmp.pageSize, query);
				skip = (skip - 1) * take;
            } else if (singles["onRange"]) {
                tmp = singles["onRange"];
                skip = tmp.start;
                take = tmp.end - tmp.start;
            }

            // Sorting
            for (var i = 0; i < sorted.length; i++) {
                tmp = getValue(sorted[i].e.fieldName, query);

                r.sorted.push(callAdaptorFunc(this, "onEachSort", { name: tmp, direction: sorted[i].e.direction }, query));
            }

            // hierarchy
            if (hierarchyFilters) {
                tmp = this.getFiltersFrom(hierarchyFilters, query);
                if (tmp)
                    r.filters.push(callAdaptorFunc(this, "onEachWhere", tmp.toJSON(), query));
            }

            // Filters
            for (var i = 0; i < filters.length; i++) {
                r.filters.push(callAdaptorFunc(this, "onEachWhere", filters[i].e.toJSON(), query));

                for (var prop in r.filters[i]) {
                    if (isNull(r[prop]))
                        delete r[prop];
                }
            }

            // Searches
            for (var i = 0; i < searchs.length; i++) {
                tmp = searchs[i].e;
                r.searches.push(callAdaptorFunc(this, "onEachSearch", {
                    fields: tmp.fieldNames,
                    operator: tmp.operator,
                    key: tmp.searchKey,
                    ignoreCase: tmp.ignoreCase
                }, query));
            }

            // Grouping
            for (var i = 0; i < grouped.length; i++) {
                r.grouped.push(getValue(grouped[i].e.fieldName, query));
            }

            // aggregates
            for (var i = 0; i < aggregates.length; i++) {
                tmp = aggregates[i].e; 
                r.aggregates.push({ type: tmp.type, field: getValue(tmp.field, query) });
            }

            var req = {};
            req[op.from] = query._fromTable;
            if (op.expand) req[op.expand] = query._expands;
            req[op.select] = singles["onSelect"] ? callAdaptorFunc(this, "onSelect", getValue(singles["onSelect"].fieldNames, query), query) : "";
            req[op.count] = query._requiresCount ? callAdaptorFunc(this, "onCount", query._requiresCount, query) : "";
            req[op.search] = r.searches.length ? callAdaptorFunc(this, "onSearch", r.searches, query) : "";
            req[op.skip] = singles["onSkip"] ? callAdaptorFunc(this, "onSkip", getValue(singles["onSkip"].nos, query), query) : "";
            req[op.take] = singles["onTake"] ? callAdaptorFunc(this, "onTake", getValue(singles["onTake"].nos, query), query) : "";
            req[op.antiForgery] = (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : "";
            req[op.where] = r.filters.length || r.searches.length ? callAdaptorFunc(this, "onWhere", r.filters, query) : "";
            req[op.sortBy] = r.sorted.length ? callAdaptorFunc(this, "onSortBy", r.sorted, query) : "";
            req[op.group] = r.grouped.length ? callAdaptorFunc(this, "onGroup", r.grouped, query) : "";
            req[op.aggregates] = r.aggregates.length ? callAdaptorFunc(this, "onAggregates", r.aggregates, query) : "";
			req["param"] = [];
			
            // Params
			callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: params, reqParams: req });

            // cleanup
            for (var prop in req) {
                if (isNull(req[prop]) || req[prop] === "" || req[prop].length === 0 || prop === "params")
                    delete req[prop];
            }

            if (!(op.skip in req && op.take in req) && take !== null) {
                req[op.skip] = callAdaptorFunc(this, "onSkip", skip, query);
                req[op.take] = callAdaptorFunc(this, "onTake", take, query);
            }
            var p = this.pvt;
            this.pvt = {};

            if (this.options.requestType === "json") {
                return {
                    data: JSON.stringify(req),
                    url: url,
                    ejPvtData: p,
                    type: "POST",
                    contentType: "application/json; charset=utf-8"
                }
            }
            tmp = this.convertToQueryString(req, query, dm);
            tmp =  (dm.dataSource.url.indexOf("?")!== -1 ? "&" : "/") + tmp;
            return {
                type: "GET",
                url: tmp.length ? url.replace(/\/*$/, tmp) : url,
                ejPvtData: p
            };
        },
        convertToQueryString: function (req, query, dm) {
            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1)
                return $.param(req);
            return "?" + $.param(req);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request.ejPvtData || {};
			var groupDs= data.groupDs;
			if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            var d = JSON.parse(request.data);
            if (d && d.action === "batch" && data.added) {
                changes.added = data.added;
                return changes;
            }
            if (data.d)
                data = data.d;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                if ('count' in data) args.count = data.count;
                if (data["result"]) args.result = data.result;
                if (data["aggregate"]) data = data.aggregate;
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                args["aggregates"] = res;
                data = args;
            }

            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups, args = {};
                if ('count' in data) args.count = data.count;
                if (data["aggregates"]) args.aggregates = data.aggregates;
                if (data["result"]) data = data.result;
                for (var i = 0; i < groups.length; i++){
                    var level = null;
                    var format = getColFormat(groups[i], query.queries);
                    if (!ej.isNullOrUndefined(groupDs))
                        groupDs = ej.group(groupDs, groups[i], null, format);
                    data = ej.group(data, groups[i], pvt.aggregates, format, level, groupDs);
                }
                if (args.count != undefined)
                    args.result = data;
                else
                    args = data;
                return args;
            }
            return data;
        },
        onGroup: function (e) {
            this.pvt.groups = e;
        },
        onAggregates: function (e) {
            this.pvt.aggregates = e;
        },
        batchRequest: function (dm, changes, e, query) {
            var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key,
				antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.removeUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        },
        beforeSend: function (dm, request) {
        },
        insert: function (dm, data, tableName, query) {
            var res = {
                value: data,
                table: tableName,
                action: "insert",
                antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        remove: function (dm, keyField, value, tableName, query) {
            var res = {
                key: value,
                keyColumn: keyField,
                table: tableName,
                action: "remove",
                antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.removeUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        update: function (dm, keyField, value, tableName, query) {
            var res = {
                value: value,
                action: "update",
                keyColumn: keyField,
                key: value[keyField],
                table: tableName,
                antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        getFiltersFrom: function (data, query) {
            if (!(data instanceof Array) || !data.length)
                throwError("ej.SubQuery: Array of key values required");
            var key = query._fKey, value, prop = key, pKey = query._key, predicats = [],
                isValues = typeof data[0] !== "object";

            if (typeof data[0] !== "object") prop = null;

            for (var i = 0; i < data.length; i++) {
                value = !isValues ? ej.pvt.getObject(pKey || prop, data[i]) : data[i];
                predicats.push(new ej.Predicate(key, "==", value));
            }

            return ej.Predicate.or(predicats);
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                req[tmp.key] = tmp.value;
                if (tmp.fn)
                    req[tmp.key] = tmp.fn.call(query, tmp.key, query, dm);                
                req["params"][tmp.key] = req[tmp.key];
            }
        }
    });
    ej.WebMethodAdaptor = new ej.UrlAdaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var obj = ej.UrlAdaptor.prototype.processQuery(dm, query, hierarchyFilters);
            var data = ej.parseJSON(obj.data), result = {};

            result["value"] = data;

            //Params             
            callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: query._params, reqParams: result });

            return {
                data: JSON.stringify(result),
                url: obj.url,
                ejPvtData: obj.ejPvtData,
                type: "POST",
                contentType: "application/json; charset=utf-8"
            }
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                var webkey = tmp.key, webvalue = tmp.value;
                if (tmp.fn)
                    webvalue = tmp.fn.call(query, tmp.key, query, dm);
                req[webkey] = webvalue;
                req["params"][webkey] = req[webkey];
            }
        }
    });
    ej.CacheAdaptor = new ej.UrlAdaptor().extend({
        init: function (adaptor, timeStamp, pageSize) {
            if (!ej.isNullOrUndefined(adaptor)) {
                this.cacheAdaptor = adaptor;
            }
            this.pageSize = pageSize;
            this.guidId = ej.getGuid("cacheAdaptor");
            var obj = { keys: [], results: [] };
            if (window.localStorage)
                window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            var guid = this.guidId;
            if (!ej.isNullOrUndefined(timeStamp)) {
                setInterval(function () {
                    var data = ej.parseJSON(window.localStorage.getItem(guid));
                    var forDel = [];
                    for (var i = 0; i < data.results.length; i++) {
                        data.results[i].timeStamp = new Date() - new Date(data.results[i].timeStamp)
                        if (new Date() - new Date(data.results[i].timeStamp) > timeStamp)
                            forDel.push(i);
                    }
                    var d = forDel;
                    for (var i = 0; i < forDel.length; i++) {
                        data.results.splice(forDel[i], 1);
                        data.keys.splice(forDel[i], 1);
                    }
                    window.localStorage.removeItem(guid);
                    window.localStorage.setItem(guid, JSON.stringify(data));
                }, timeStamp);
            }
        },
        generateKey: function (url, query) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
				pageQuery = filterQueries(query.queries, "onPage"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params;
            var key = url;
            if (singles["onPage"])
              key += singles["onPage"].pageIndex;
              sorted.forEach(function (obj) {
                   key += obj.e.direction + obj.e.fieldName;
              });
                grouped.forEach(function (obj) {
                    key += obj.e.fieldName;
                });
                searchs.forEach(function (obj) {
                    key += obj.e.searchKey;
                });
            
            for (var filter = 0; filter < filters.length; filter++) {
                var currentFilter = filters[filter];
                if (currentFilter.e.isComplex) {
                    var newQuery = query.clone();
                    newQuery.queries = [];
                    for (var i = 0; i < currentFilter.e.predicates.length; i++) {
                        newQuery.queries.push({ fn: "onWhere", e: currentFilter.e.predicates[i], filter: query.queries.filter });
                    }
                    key += currentFilter.e.condition + this.generateKey(url, newQuery);
                }
                else
                    key += currentFilter.e.field + currentFilter.e.operator + currentFilter.e.value
            }
            return key;
        },
        processQuery: function (dm, query, hierarchyFilters) {
            var key = this.generateKey(dm.dataSource.url, query);
            var cachedItems;
            if (window.localStorage)
                cachedItems = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var data = cachedItems ? cachedItems.results[cachedItems.keys.indexOf(key)] : null;
            if (data != null && !this._crudAction && !this._insertAction) {
                return data;
            }
            this._crudAction = null; this._insertAction = null;
            return this.cacheAdaptor.processQuery.apply(this.cacheAdaptor, [].slice.call(arguments, 0))
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (this._insertAction || (request && this.cacheAdaptor.options.batch && request.url.endsWith(this.cacheAdaptor.options.batch) && request.type.toLowerCase() === "post")) {
                return this.cacheAdaptor.processResponse(data, ds, query, xhr, request, changes);
            }
            var data = this.cacheAdaptor.processResponse.apply(this, [].slice.call(arguments, 0));
            var key = this.generateKey(ds.dataSource.url, query)
            var obj = {};
            if (window.localStorage)
                obj = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var index = $.inArray(key, obj.keys);
            if (index != -1) {
                obj.results.splice(index, 1);
                obj.keys.splice(index, 1);
            }
            obj.results[obj.keys.push(key) - 1] = { keys: key, result: data.result, timeStamp: new Date(), count: data.count }
            while (obj.results.length > this.pageSize) {
                obj.results.splice(0, 1);
                obj.keys.splice(0, 1);
            }
            window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            return data;
        },
        update: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.update(dm, keyField, value, tableName);
        },
        insert: function (dm, data, tableName) {
            this._insertAction = true;
            return this.cacheAdaptor.insert(dm, data, tableName);
        },
        remove: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.remove(dm, keyField, value, tableName);
        },
        batchRequest: function (dm, changes, e) {
            return this.cacheAdaptor.batchRequest(dm, changes, e);
        }
    });
    var filterQueries = function (queries, name) {
        return queries.filter(function (q) {
            return q.fn === name;
        }) || [];
    };
    var filterQueryLists = function (queries, singles) {
        var filtered = queries.filter(function (q) {
            return singles.indexOf(q.fn) !== -1;
        }), res = {};
        for (var i = 0; i < filtered.length; i++) {
            if (!res[filtered[i].fn])
                res[filtered[i].fn] = filtered[i].e;
        }
        return res;
    };
    var callAdaptorFunc = function (obj, fnName, param, param1) {
        if (obj[fnName]) {
            var res = obj[fnName](param, param1);
            if (!isNull(res)) param = res;
        }
        return param;
    };

    ej.ODataAdaptor = new ej.UrlAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$inlinecount",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onEachWhere: function (filter, requiresCast) {
            return filter.isComplex ? this.onComplexPredicate(filter, requiresCast) : this.onPredicate(filter, requiresCast);
        },
		_typeStringQuery: function (pred, requiresCast,val,field,guid) {
			if(val.indexOf("'") != -1)
                    val = val.replace(new RegExp(/'/g),"''");
                val = "'" + val + "'";

                if (requiresCast) {
                    field = "cast(" + field + ", 'Edm.String')";
                }
                if (ej.isGUID(val))
                    guid = 'guid';
                if (pred.ignoreCase) {
                    !guid ? field = "tolower(" + field + ")" : field;
                    val = val.toLowerCase();
                }
				return {"val":val,"guid":guid ,"field":field};
		},
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                operator,guid,
                val = pred.value,
                type = typeof val,
                field = this._p(pred.field);

            if (val instanceof Date)
                val = "datetime'" + p.replacer(val).toJSON() + "'";

            if (type === "string") {
				var args = this._typeStringQuery(pred,requiresCast,val,field , guid);
				val = args["val"]; field = args["field"]; guid = args["guid"];
            }

            operator = ej.data.odBiOperator[pred.operator];
			if(pred.anyCondition != "" && operator) {
				returnValue += val["table"];
				returnValue += ("/"+pred.anyCondition);
				returnValue += "(d:d/";
				returnValue += field;
				returnValue += operator;
				returnValue += val["value"];
				returnValue += ")";
				return returnValue;
			}
			if( pred.operator == "in" || pred.operator == "notin" ) {
				for(var index = 0; index < val.length; index++ ) {
					var args = this._typeStringQuery(pred,requiresCast,val[index],field,guid);
					val[index] = args["val"]; field = args["field"];
					returnValue += field;
					returnValue += operator;
					returnValue += val[index];
					if( index != val.length -1 ) returnValue += ( pred.operator == "in") ? " or " : " and ";
				}
				return returnValue;
			}
            if (operator) {
                returnValue += field;
                returnValue += operator;
                if (guid)
                    returnValue += guid;
                return returnValue + val;
            }

            operator = ej.data.odUniOperator[pred.operator];
            if (!operator || type !== "string") return "";

            if (operator === "substringof") {
                var t = val;
                val = field;
                field = t;
            }

            returnValue += operator + "(";
            returnValue += field + ",";
            if (guid) returnValue += guid;
            returnValue += val + ")";
			
			if( pred.operator == "notcontains" ) {
				returnValue += " eq false"
			}
			if(pred.anyCondition != "" && operator) {
				var returnValue1;
				returnValue1 += val["table"];
				returnValue1 += ("/"+pred.anyCondition);
				returnValue1 += "(d:d/";
				returnValue += returnValue;
				returnValue1 += ")";
				return returnValue1;
			}
            return returnValue;
        },
        onComplexPredicate: function (pred, requiresCast) {
            var res = [];
            for (var i = 0; i < pred.predicates.length; i++) {
                res.push("(" + this.onEachWhere(pred.predicates[i], requiresCast) + ")");
            }
            return res.join(" " + pred.condition + " ");
        },
        onWhere: function (filters) {
            if (this.pvt.searches)
                filters.push(this.onEachWhere(this.pvt.searches, null, true));

            return filters.join(" and ");
        },
        onEachSearch: function (e) {
            if (e.fields.length === 0)
                throwError("Query() - Search : oData search requires list of field names to search");

            var filter = this.pvt.searches || [];
            for (var i = 0; i < e.fields.length; i++) {
                filter.push(new ej.Predicate(e.fields[i], e.operator, e.key, e.ignoreCase));
            }
            this.pvt.searches = filter;
        },
        onSearch: function (e) {
            this.pvt.searches = ej.Predicate.or(this.pvt.searches);
            return "";
        },
        onEachSort: function (e) {
            var res = [];
            if (e.name instanceof Array) {
                for (var i = 0; i < e.name.length; i++)
                    res.push(this._p(e.name[i]));
            } else {
                res.push(this._p(e.name) + (e.direction === "descending" ? " desc" : ""));
            }
            return res.join(",");
        },
        onSortBy: function (e) {
            return e.reverse().join(",");
        },
        onGroup: function (e) {
            this.pvt.groups = e;
            return "";
        },
        onSelect: function (e) {
            for (var i = 0; i < e.length; i++)
                e[i] = this._p(e[i]);

            return e.join(',');
        },
        onAggregates: function(e){
            this.pvt.aggregates = e;
            return "";
        },
        onCount: function (e) {
            return e === true ? "allpages" : "";
        },
        beforeSend: function (dm, request, settings) {
            if (settings.url.endsWith(this.options.batch) && settings.type.toLowerCase() === "post") {
                request.setRequestHeader("Accept", oData.multipartAccept);
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.overrideMimeType("text/plain; charset=x-user-defined");
            }

            if (!dm.dataSource.crossDomain) {
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.setRequestHeader("MaxDataServiceVersion", "2.0");
            }
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (!ej.isNullOrUndefined(data.d)) {
                var dataCopy = (query && query._requiresCount) ? data.d.results : data.d;
                if (!ej.isNullOrUndefined(dataCopy))
                    for (var i = 0; i < dataCopy.length; i++) {
                        !ej.isNullOrUndefined(dataCopy[i].__metadata) && delete dataCopy[i].__metadata;
                    }
            }
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                    if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
            }
            var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
            version = (version && parseInt(version, 10)) || 2;

            if (query && query._requiresCount) {
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
                if (data.d) data = data.d;
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
            }

            if (version === 3 && data.value) data = data.value;
            if (data.d) data = data.d;
            if (version < 3 && data.results) data = data.results;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                aggregateResult = res;
            }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries)
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
        convertToQueryString: function (req, query, dm) {
            var res = [], tableName = req.table || "";
            delete req.table;

            if (dm.dataSource.requiresFormat)
                req["$format"] = "json";

            for (var prop in req)
                res.push(prop + "=" + req[prop]);

            res = res.join("&");

            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1 && !tableName)
                return res;

            return res.length ? tableName + "?" + res : tableName || "";
        },
        insert: function (dm, data, tableName) {
            return {
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : ''),
                data: JSON.stringify(data)
            }
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value + ')'
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value[keyField] + ')',
                data: JSON.stringify(value),
                accept: this.options.accept
            };
        },
        batchRequest: function (dm, changes, e) {
            var initialGuid = e.guid = ej.getGuid(oData.batchPre);
            var url = dm.dataSource.url.replace(/\/*$/, '/' + this.options.batch);
            var args = {
                url: e.url,
                key: e.key,
                cid: 1,
                cSet: ej.getGuid(oData.changeSet)
            };
            var req = "--" + initialGuid + "\n";

            req += "Content-Type: multipart/mixed; boundary=" + args.cSet.replace("--", "") + "\n";

            this.pvt.changeSet = 0;

            req += this.generateInsertRequest(changes.added, args);
            req += this.generateUpdateRequest(changes.changed, args);
            req += this.generateDeleteRequest(changes.deleted, args);

            req += args.cSet + "--\n";
            req += "--" + initialGuid + "--";

            return {
                type: "POST",
                url: url,
                contentType: "multipart/mixed; charset=UTF-8;boundary=" + initialGuid,
                data: req
            };
        },
        generateDeleteRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "DELETE ";
                req += e.url + "(" + arr[i][e.key] + ") HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n";
            }

            return req + "\n";
        },
        generateInsertRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "POST ";
                req += e.url + " HTTP/1.1\n";
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n";
            }

            return req;
        },
        generateUpdateRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "PUT ";
                req += e.url + "(" + arr[i][e.key] + ")" + " HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n\n";
            }

            return req;
        },
        _p: function (prop) {
            return prop.replace(/\./g, "/");
        }
    });
    ej.ODataV4Adaptor = new ej.ODataAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$count",
            search: "$search",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onCount: function (e) {
            return e === true ? "true" : "";
        },
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                val = pred.value,
                isDate = val instanceof Date;               
            ej.data.odUniOperator["contains"] = "contains";
            returnValue = ej.ODataAdaptor.prototype.onPredicate.call(this, pred, query, requiresCast);
            ej.data.odUniOperator["contains"] = "substringof";
                if (isDate)
                    returnValue = returnValue.replace(/datetime'(.*)'$/, "$1");

            return returnValue;
        },
        onEachSearch: function (e) {
			 var search = this.pvt.search || [];
			 search.push(e.key);
			 this.pvt.search = search;
		},
		onSearch: function (e) {
			 return this.pvt.search.join(" OR ");
		},
        beforeSend: function (dm, request, settings) {
 
        },
        processQuery: function (ds, query) {
            var digitsWithSlashesExp = /\/[\d*\/]*/g;
            var poppedExpand = "";
            for (var i = query._expands.length - 1; i > 0; i--) {
                if (poppedExpand.indexOf(query._expands[i]) >= 0) { // If current expand is child of previous
                    query._expands.pop(); // Just remove it because its in the expand already
                }
                else {
                    if (digitsWithSlashesExp.test(query._expands[i])) { //If expanded to subentities
                        poppedExpand = query._expands.pop();
                        var r = poppedExpand.replace(digitsWithSlashesExp, "($expand="); //Rewrite into odata v4 expand
                        for (var j = 0; j < poppedExpand.split(digitsWithSlashesExp).length - 1; j++) {
                            r = r + ")"; // Add closing brackets
                        }
                        query._expands.unshift(r); // Add to the front of the array
                        i++;
                    }
                }
            }
            return ej.ODataAdaptor.prototype.processQuery.apply(this, [ds, query]);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                   if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
           }
            var count = null, aggregateResult = {};
            if (query && query._requiresCount)
                if ('@odata.count' in data) count = data['@odata.count'];

            data = ej.isNullOrUndefined(data.value) ? data : data.value;
           if (pvt && pvt.aggregates && pvt.aggregates.length) {
               var agg = pvt.aggregates, args = {}, fn, res = {};
               for (var i = 0; i < agg.length; i++) {
                   fn = ej.aggregates[agg[i].type];
                   if (fn)
                       res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
               }
               aggregateResult = res;
           }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries);
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
    });
    ej.JsonAdaptor = new ej.Adaptor().extend({
        processQuery: function (ds, query) {
            var result = ds.dataSource.json.slice(0), count = result.length, cntFlg = true, ret, key, agg = {};

            for (var i = 0; i < query.queries.length; i++) {
                key = query.queries[i];
                ret = this[key.fn].call(this, result, key.e, query);
                if (key.fn == "onAggregates")
                    agg[key.e.field + " - " + key.e.type] = ret;
                else
                result = ret !== undefined ? ret : result;

                if (key.fn === "onPage" || key.fn === "onSkip" || key.fn === "onTake" || key.fn === "onRange") cntFlg = false;

                if (cntFlg) count = result.length;
            }

            if (query._requiresCount) {
                result = {
                    result: result,
                    count: count,
                    aggregates: agg
                };
            }

            return result;
        },
        batchRequest: function (dm, changes, e) {
            var i;
            for (i = 0; i < changes.added.length; i++)
                this.insert(dm, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                this.update(dm, e.key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                this.remove(dm, e.key, changes.deleted[i]);
            return changes;
        },
        onWhere: function (ds, e) {
            if (!ds) return ds;

            return ds.filter(function (obj) {
                return e.validate(obj);
            });
        },
        onAggregates: function(ds, e){
            var fn = ej.aggregates[e.type];
            if (!ds || !fn || ds.length == 0) return null;
            return fn(ds, e.field);
        },
        onSearch: function (ds, e) {
            if (!ds || !ds.length) return ds;

            if (e.fieldNames.length === 0) {
                ej.pvt.getFieldList(ds[0], e.fieldNames);
            }

            return ds.filter(function (obj) {
                for (var j = 0; j < e.fieldNames.length; j++) {
                    if (e.comparer.call(obj, ej.pvt.getObject(e.fieldNames[j], obj), e.searchKey, e.ignoreCase))
                        return true;
                }
                return false;
            });
        },
        onSortBy: function (ds, e, query) {
            if (!ds) return ds;
            var fnCompare, field = getValue(e.fieldName, query);
            if (!field)
                return ds.sort(e.comparer);

            if (field instanceof Array) {
                field = field.slice(0);

                for (var i = field.length - 1; i >= 0; i--) {
                    if (!field[i]) continue;

                    fnCompare = e.comparer;

                    if (field[i].endsWith(" desc")) {
                        fnCompare = ej.pvt.fnSort(ej.sortOrder.Descending);
                        field[i] = field[i].replace(" desc", "");
                    }

                    ds = stableSort(ds, field[i], fnCompare, []);
                }
                return ds;
            }
            return stableSort(ds, field, e.comparer, query ? query.queries : []);
        },
        onGroup: function (ds, e, query) {
            if (!ds) return ds;
            var aggQuery = filterQueries(query.queries, "onAggregates"), agg = [];
            if (aggQuery.length) {
                var tmp;
                for (var i = 0; i < aggQuery.length; i++) {
                    tmp = aggQuery[i].e;
                    agg.push({ type: tmp.type, field: getValue(tmp.field, query) });
                }
            }
            var format = getColFormat(e.fieldName, query.queries);
            return ej.group(ds, getValue(e.fieldName, query), agg, format);
        },
        onPage: function (ds, e, query) {
            var size = getValue(e.pageSize, query),
                start = (getValue(e.pageIndex, query) - 1) * size, end = start + size;

            if (!ds) return ds;

            return ds.slice(start, end);
        },
        onRange: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.start), getValue(e.end));
        },
        onTake: function (ds, e) {
            if (!ds) return ds;

            return ds.slice(0, getValue(e.nos));
        },
        onSkip: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.nos));
        },
        onSelect: function (ds, e) {
            if (!ds) return ds;
            return ej.select(ds, getValue(e.fieldNames));
        },
        insert: function (dm, data) {
            return dm.dataSource.json.push(data);
        },
        remove: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i;
            if (typeof value === "object")
                value = ej.getObject(keyField, value);
            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === value) break;
            }

            return i !== ds.length ? ds.splice(i, 1) : null;
        },
        update: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i, key = ej.getObject(keyField, value);

            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === key) break;
            }

            return i < ds.length ? $.extend(ds[i], value) : null;
        }
    });
    ej.ForeignKeyAdaptor = function (data, type) {
        var foreignObj = new ej[type || "JsonAdaptor"]().extend({
            init: function () {
                this.foreignData = [];
                this.key = [];
                this.adaptorType = type;
                this.value = [];
                this.fValue = [];
                this.keyField = [];
                var dataObj = data;
                for (var i = 0; i < dataObj.length; i++) {
                    this.foreignData[i] = dataObj[i].dataSource;
                    this.key[i] = dataObj[i].foreignKeyField;
                    this.fValue[i] = ej.isNullOrUndefined(dataObj[i].field)? dataObj[i].foreignKeyValue : dataObj[i].field + "_" + dataObj[i].foreignKeyValue;
                    this.value[i] = dataObj[i].foreignKeyValue;
                    this.keyField[i] = dataObj[i].field || dataObj[i].foreignKeyField;
                    this.initial = true;
                }
            },
            processQuery: function (ds, query) {
                var data = ds.dataSource.json;
                if (this.initial) {
                    for (var i = 0; i < data.length; i++) {
                        var proxy = this;
                        for (var j = 0; j < this.foreignData.length; j++) {
                            this.foreignData[j].filter(function (col) { //filtering the foreignKey dataSource
                                if (ej.getObject(proxy.key[j], col) == ej.getObject(proxy.keyField[j], data[i]))
                                    data[i][proxy.fValue[j]] = ej.getObject(proxy.value[j], col);
                            });
                        }
                    }
                    this.initial = false;
                }
                return this.base.processQuery.apply(this, [ds, query]);
            },
            setValue: function (value) {
                for (var i = 0; i < this.foreignData.length; i++) {
                    var proxy = this;
                    var keyValue = value[this.fValue[i]];
                    if (typeof keyValue == "string" && !isNaN(keyValue))
                        keyValue = ej.parseFloat(keyValue);
                    var data = $.grep(proxy.foreignData[i], function (e) {
                        return e[proxy.value[i]] == keyValue;
                    })[0];
                    if (ej.isNullOrUndefined(data)) {
                        data = $.grep(proxy.foreignData[i], function (e) {
                            return e[proxy.key[i]] == keyValue;
                        })[0];
                        if (ej.getObject(this.value[i], data) != undefined)
                            ej.createObject(proxy.value[i], ej.getObject(this.value[i], data), value);
                    }
                    if (ej.getObject(this.value[i], data) != undefined)
                        ej.createObject(this.keyField[i], ej.getObject(this.key[i], data), value);
                }
            },
            insert: function (dm, data, tableName) {
                this.setValue(data);
                return {
                    url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: data,
                        table: tableName,
                        action: "insert",
                        antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
                    })
                };
            },
            update: function (dm, keyField, value, tableName) {
                this.setValue(value);
                ej.JsonAdaptor.prototype.update(dm, keyField, value, tableName);
                return {
                    type: "POST",
                    url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: value,
                        action: "update",
                        keyColumn: keyField,
                        key: value[keyField],
                        table: tableName,
                        antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
                    })
                };
            }
        });
        $.extend(this, new foreignObj());
        return this;
    }
    ej.remoteSaveAdaptor = new ej.JsonAdaptor().extend({
        beforeSend: ej.UrlAdaptor.prototype.beforeSend,
        insert: ej.UrlAdaptor.prototype.insert,
        update: ej.UrlAdaptor.prototype.update,
        remove: ej.UrlAdaptor.prototype.remove,
        addParams: ej.UrlAdaptor.prototype.addParams,
        batchRequest: function (dm, changes, e, query) { 
			var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key,
                antiForgery: (dm.dataSource.antiForgery) ? dm.antiForgeryToken().value : ""
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });
            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        },
         processResponse: function (data, ds, query, xhr, request, changes, key) {
			if(!ej.isNullOrUndefined(changes)){
            var i;
            for (i = 0; i < changes.added.length; i++)
                ej.JsonAdaptor.prototype.insert(ds, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                ej.JsonAdaptor.prototype.update(ds, key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                ej.JsonAdaptor.prototype.remove(ds, key, changes.deleted[i]);
            return this.base.processResponse.apply(this, [data, ds, query, xhr, request, changes]);
             }
            else{
                if (data.d)
               return data.d;
            return data;
            }
        }
    });
    ej.WebApiAdaptor = new ej.ODataAdaptor().extend({
        insert: function (dm, data, tableName) {
            return {
                type: "POST",
                url: dm.dataSource.url,
                data: JSON.stringify(data)
            };
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url + "/" + value,
                data: JSON.stringify(value)
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url,
                data: JSON.stringify(value)
            };
        },
		batchRequest: function (dm, changes, e) {
            var initialGuid = e.guid = ej.getGuid(oData.batchPre);
            var req = [];

		    //insertion 
		
			$.each(changes.added, function (i, d) {
			    req.push('--' + initialGuid);
			    req.push('Content-Type: application/http; msgtype=request', '');
			    req.push('POST' + ' ' + dm.dataSource.insertUrl + ' HTTP/1.1');
			    req.push('Content-Type: ' + 'application/json; charset=utf-8');
			    req.push('Host: ' + location.host);
			    req.push('', d ? JSON.stringify(d) : '');
			});
			
			//updation
			$.each(changes.changed, function (i, d) {
			    req.push('--' + initialGuid);
			    req.push('Content-Type: application/http; msgtype=request', '');
			    req.push('PUT' + ' ' + dm.dataSource.updateUrl + ' HTTP/1.1');
			    req.push('Content-Type: ' + 'application/json; charset=utf-8');
			    req.push('Host: ' + location.host);
			    req.push('', d ? JSON.stringify(d) : '');
			});
			
			//deletion
			$.each(changes.deleted, function (i, d) {
			    req.push('--' + initialGuid);
                req.push('Content-Type: application/http; msgtype=request', '');
                req.push('DELETE' + ' ' + dm.dataSource.removeUrl +"/"+ d[e.key] + ' HTTP/1.1');
                req.push('Content-Type: ' + 'application/json; charset=utf-8');
                req.push('Host: ' + location.host);
                req.push('', d ? JSON.stringify(d) : '');		
			});
			req.push('--' + initialGuid + '--', '');
            return {
				type: 'POST',
				url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: req.join('\r\n'),
                contentType: 'multipart/mixed; boundary="' + initialGuid + '"',
            };
        },
        processResponse: function (data, ds, query, xhr, request, changes) {

            var pvt = request && request.ejPvtData;
            if (request && request.type.toLowerCase() != "post") {
                var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
                version = (version && parseInt(version, 10)) || 2;

                if (query && query._requiresCount) {
                     if (!isNull(data.Count)) count = data.Count;
                }

                if (version < 3 && data.Items) data = data.Items;

                if (pvt && pvt.aggregates && pvt.aggregates.length) {
                    var agg = pvt.aggregates, args = {}, fn, res = {};
                    for (var i = 0; i < agg.length; i++) {
                        fn = ej.aggregates[agg[i].type];
                        if (fn)
                            res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                    }
                    aggregateResult = res;
                }
                if (pvt && pvt.groups && pvt.groups.length) {
                    var groups = pvt.groups;
                    for (var i = 0; i < groups.length; i++) {
                        var format = getColFormat(groups[i], query.queries);
                        data = ej.group(data, groups[i], pvt.aggregates, format);
                    }
                }
                return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
            }
        }
    });
    var getValue = function (value, inst) {
        if (typeof value === "function")
            return value.call(inst || {});
        return value;
    }

    ej.TableModel = function (name, jsonArray, dataManager, modelComputed) {
        if (!instance(this, ej.TableModel))
            return new ej.TableModel(jsonArray);

        if (!instance(jsonArray, Array))
            throwError("ej.TableModel - Json Array is required");

        var rows = [], model, dirtyFn = $proxy(setDirty, this);

        for (var i = 0; i < jsonArray.length; i++) {
            model = new ej.Model(jsonArray[i], this);
            model.state = "unchanged";
            model.on("stateChange", dirtyFn);
            if (modelComputed)
                model.computes(modelComputed);
            rows.push(model);
        }

        this.name = name || "table1";

        this.rows = ej.NotifierArray(rows);
        this._deleted = [];

        this._events = $({});

        this.dataManager = dataManager;

        this._isDirty = false;

        return this;
    };

    ej.TableModel.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },

        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },

        setDataManager: function (dataManager) {
            this.dataManagar = dataManager;
        },

        saveChanges: function () {
            if (!this.dataManager || !instance(this.dataManager, ej.DataManager))
                throwError("ej.TableModel - saveChanges : Set the dataManager using setDataManager function");

            if (!this.isDirty())
                return;

            var promise = this.dataManager.saveChanges(this.getChanges(), this.key, this.name);

            promise.done($proxy(function (changes) {
                var rows = this.toArray();
                for (var i = 0; i < rows.length; i++) {
                    if (rows.state === "added") {
                        rows.set(this.key, changes.added.filter(function (e) {
                            return e[this.key] === rows.get(this.key);
                        })[0][this.key]);
                    }
                    rows[i].markCommit();
                }

                this._events.triggerHandler({ type: "save", table: this });

            }, this));

            promise.fail($proxy(function (e) {
                this.rejectChanges();
                this._events.triggerHandler({ type: "reject", table: this, error: e });
            }, this));

            this._isDirty = false;
        },

        rejectChanges: function () {
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++)
                rows[i].revert(true);

            this._isDirty = false;
            this._events.triggerHandler({ type: "reject", table: this });
        },

        insert: function (json) {
            var model = new ej.Model(json);
            model._isDirty = this._isDirty = true;

            this.rows.push(model);

            this._events.triggerHandler({ type: "insert", model: model, table: this });
        },

        update: function (value) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var row = value, model, key = this.key, keyValue = row[key];

            model = this.rows.array.filter(function (obj) {
                return obj.get(key) === keyValue;
            });

            model = model[0];

            for (var col in row) {
                model.set(col, row[col]);
            }

            this._isDirty = true;

            this._events.triggerHandler({ type: "update", model: model, table: this });
        },

        remove: function (key) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var field = this.key;

            var index = -1, model;

            if (key && typeof key === "object") {
                key = key[field] !== undefined ? key[field] : key.get(field);
            }

            for (var i = 0; i < this.rows.length() ; i++) {
                if (this.rows.array[i].get(field) === key) {
                    index = i;
                    break;
                }
            }

            if (index > -1) {
                model = this.rows.removeAt(index);
                model.markDelete();

                this._deleted.push({ model: model, position: index });

                this._isDirty = true;
                this._events.triggerHandler({ type: "remove", model: model, table: this });
            }
        },

        isDirty: function () {
            return this._isDirty;
        },

        getChanges: function () {

            var changes = {
                added: [],
                changed: []
            };
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++) {
                if (changes[rows[i].state])
                    changes[rows[i].state].push(rows[i].json);
            }

            changes.deleted = ej.select(this._deleted, ["model"]);

            return changes;
        },

        toArray: function () {
            return this.rows.toArray();
        },

        setDirty: function (dirty, model) {
            if (this._isDirty === !!dirty) return;

            this._isDirty = !!dirty;

            this._events.triggerHandler({ type: "dirty", table: this, model: model });
        },
        get: function (index) {
            return this.rows.array[index];
        },
        length: function () {
            return this.rows.array.length;
        },

        bindTo: function (element) {
            var marker = tDiv, template = $(element.html()), rows = this.toArray(), cur;
            if ($.inArray(element.prop("tagName").toLowerCase(), ["table", "tbody"]))
                marker = tTR;

            marker.insertBefore(element);
            element.detach().empty();

            for (var i = 0; i < rows.length; i++) {
                cur = template.clone();
                rows[i].bindTo(cur);
                element.append(cur);
            }

            element.insertAfter(marker);
            marker.remove();
        }
    };

    var tDiv = doc ? $(document.createElement("div")) : {},
        tTR = doc ? $(document.createElement("tr")) : {};

    ej.Model = function (json, table, name) {
        if (typeof table === "string") {
            name = table;
            table = null;
        }
        this.$id = getUid("m");

        this.json = json;
        this.table = table instanceof ej.TableModel ? table : null;
        this.name = name || (this.table && this.table.name);
        this.dataManager = (table instanceof ej.DataManager) ? table : table.dataManagar;
        this.actual = {};
        this._events = $({});
        this.isDirty = false;
        this.state = "added";
        this._props = [];
        this._computeEls = {};
        this._fields = {};
        this._attrEls = {};
        this._updates = {};
        this.computed = {};
    };

    ej.Model.prototype = {
        computes: function (value) {
            $.extend(this.computed, value);
        },
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        set: function (field, value) {
            var obj = this.json, actual = field, prev;
            field = field.split('.');

            for (var i = 0; i < field.length - 1; i++) {
                field = field[0];
                obj = obj[field[0]];
            }

            this.isDirty = true;
            this.changeState("changed", { from: "set" });

            prev = obj[field];

            if (this.actual[field] === undefined && !(field in this.actual))
                this.actual[field] = value; // Complex property ?

            obj[field] = value;

            this._updateValues(field, value);
            this._events.triggerHandler({ type: actual, current: value, previous: prev, model: this });
        },
        get: function (field) {
            return ej.pvt.getObject(field, this.json);
        },
        revert: function (suspendEvent) {
            for (var prop in this.actual) {
                this.json[prop] = this.actual[prop];
            }

            this.isDirty = false;

            if (suspendEvent)
                this.state = "unchanged";
            else
                this.changeState("unchanged", { from: "revert" });
        },
        save: function (dm, key) {
            dm = dm || this.dataManagar;
            key = key || dm.dataSource.key;
            if (!dm) throwError("ej.Model - DataManager is required to commit the changes");
            if (this.state === "added") {
                return dm.insert(this.json, this.name).done(ej.proxy(function (e) {
                    $.extend(this.json, e.record);
                }, this));
            }
            else if (this.state === "changed") {
                return dm.update(key, this.json, this.name);
            }
            else if (this.state === "deleted") {
                return dm.remove(key, this.json, this.name);
            }
        },
        markCommit: function () {
            this.isDirty = false;
            this.changeState("unchanged", { from: "commit" });
        },
        markDelete: function () {
            this.changeState("deleted", { from: "delete" });
        },
        changeState: function (state, args) {
            if (this.state === state) return;

            if (this.state === "added") {
                if (state === "deleted")
                    state = "unchanged";
                else return;
            }

            var prev = state;
            args = args || {};

            this.state = state;
            this._events.triggerHandler($.extend({ type: "stateChange", current: state, previous: prev, model: this }, args));
        },
        properties: function () {
            if (this._props.length)
                return this._props;

            for (var pr in this.json) {
                this._props.push(pr);
                this._updates[pr] = { read: [], input: [] };
            }

            return this._props;
        },
        bindTo: function (element) {
            var el = $(element), ctl, field,
                elements = el.find("[ej-observe], [ej-computed], [ej-prop]"), len = elements.length;

            el.data("ejModel", this);
            var unbindData = { fields: [], props: [], computes: [] };
            for (var i = 0; i < len; i++) {
                ctl = elements.eq(i);

                field = ctl.attr("ej-prop");
                if (field) {
                    this._processAttrib(field, ctl, unbindData);
                }
                field = ctl.attr("ej-observe");
                if (field && this._props.indexOf(field) !== -1) {
                    this._processField(ctl, field, unbindData);
                    continue;
                }

                field = ctl.attr("ej-computed");
                if (field) {
                    this._processComputed(field, ctl, unbindData);
                    continue;
                }
            }
            el.data("ejModelBinding" + this.$id, unbindData);
        },
        unbind: function (element) {
            var tmp, data = {
                props: this._attrEls,
                computes: this._computeEls
            }, isCustom = false;

            if (element) {
                data = $(element).removeData("ejModel").data("ejModelBinding" + this.$id) || data;
                isCustom = true;
            }

            for (var p in this.computed) {
                tmp = data.computes[p], p = this.computed[p];
                if (tmp && p.deps) {
                    this.off(p.deps.join(' '), tmp.handle);
                    if (isCustom)
                        delete this._computeEls[p];
                }
            }
            if (!isCustom)
                this._computeEls = {};

            for (var p in data.props) {
                tmp = data.props[p];
                if (tmp) {
                    this.off(tmp.deps.join(' '), tmp.handle);
                    delete data.props[p];
                    if (isCustom)
                        delete this._attrEls[p];
                }
            }
            if (!isCustom)
                this._attrEls = {};

            if (data.fields && data.fields.length) {
                var len = data.fields.length, ctl, idx, ty;
                for (var i = 0; i < len; i++) {
                    ctl = data.fields[i];
                    $(ctl).off("change", null, this._changeHandler);

                    ty = this.formElements.indexOf(ctl.tagName.toLowerCase()) !== -1 ? "input" : "read";
                    idx = this._updates[ty].indexOf(ctl);
                    if (idx !== -1)
                        this._updates[ty].splice(idx, 1);
                }
            }
        },
        _processComputed: function (value, element, data) {
            if (!value) return;

            var val, deps, safeVal = safeStr(value),
            type = this.formElements.indexOf(element[0].tagName.toLowerCase()) !== -1 ? "val" : "html";

            if (!this.computed[value] || !this.computed[safeVal]) {
                this.computed[safeVal] = {
                    value: new Function("var e = this; return " + value),
                    deps: this._generateDeps(value)
                }
                value = safeVal;
            }

            val = this.computed[value];
            if (!val.get) {
                val.get = function () {
                    val.value.call(this.json);
                }
            }

            deps = val.deps;
            val = val.value;

            this._updateDeps(deps);
            this._updateElement(element, type, val);

            val = { el: element, handle: $proxy(this._computeHandle, this, { value: value, type: type }) };
            this._computeEls[value] = val;
            data.computes[value] = val;

            this.on(deps.join(' '), val.handle);
        },
        _computeHandle: function (e) {
            var el = this._computeEls[e.value];
            if (el && this.computed[e.value])
                this._updateElement(el.el, e.type, this.computed[e.value].value);
        },
        _updateElement: function (el, type, val) {
            el[type](val.call($.extend({}, this.json, this.computed)));
        },
        _updateDeps: function (deps) {
            for (var i = 0; i < deps.length; i++) {
                if (!(deps[i] in this.json) && deps[i] in this.computed)
                    ej.merge(deps, this.computed[deps[i]].deps);
            }
        },
        _generateDeps: function (value) {
            var splits = value.replace(/(^e\.)|( e\.)/g, '#%^*##ej.#').split("#%^*#"),
                field, deps = [];

            for (var i = 0; i < splits.length; i++) {
                if (splits[i].startsWith("#ej.#")) {
                    field = splits[i].replace("#ej.#", "").split(' ')[0];
                    if (field && this._props.indexOf(field) !== -1)
                        deps.push(field);
                }
            }

            return deps;
        },
        _processAttrib: function (value, el, data) {
            var prop, val, res = {};
            value = value.replace(/^ +| +$/g, "").split(";");
            for (var i = 0; i < value.length; i++) {
                value[i] = value[i].split(":");
                if (value[i].length < 2) continue;

                prop = value[i][0].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
                res[prop] = value[i][1].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
            }
            value = res;
            var deps = [];
            for (prop in value)
                deps.push(value[prop]);

            this._updateDeps(deps);
            this._updateProps(el, value);

            res = getUid("emak");
            val = { el: el, handle: $proxy(this._attrHandle, this, res), value: value, deps: deps };
            el.prop("ejmodelattrkey", res);

            data.props[res] = val;
            this._attrEls[res] = val;

            this.on(deps.join(' '), val.handle);
        },
        _attrHandle: function (res) {
            var el = this._attrEls[res];
            if (el)
                this._updateProps(el.el, el.value);
        },
        _updateProps: function (element, value) {
            var json = this.json, t, c = this.computed;
            for (var prop in value) {
                t = value[prop];
                if (t in json)
                    t = json[t];
                else if (t in c) {
                    t = c[t];
                    if (t) {
                        t = t.value.call($.extend({}, this.json, c));
                    }
                }

                if (!isNull(t)) {
                    element.prop(prop, t);
                }
            }
        },
        _updateValues: function (prop, value) {
            var arr = this._updates[prop];

            if (!arr || (!arr.read && !arr.input)) return;

            this._ensureItems(arr.read, "html", value);
            this._ensureItems(arr.input, "val", value);
        },
        _ensureItems: function (a, type, value) {
            if (!a) return;

            for (var i = a.length - 1; i > -1; i--) {
                if (!a[i].offsetParent) {
                    a.splice(i, 1);
                    continue;
                }
                $(a[i])[type](value);
            }
        },
        _changeHandler: function (e) {
            e.data.self.set(e.data.prop, $(this).val());
        },
        _processField: function (ctl, field, data) {
            var e = { self: this, prop: field }, val = this.get(field);

            data.fields.push(ctl[0]);

            if (this.formElements.indexOf(ctl[0].tagName.toLowerCase()) === -1) {
                ctl.html(val);
                return this._updates[field].read.push(ctl[0]);
            }

            ctl.val(val)
                    .off("change", null, this._changeHandler)
                    .on("change", null, e, this._changeHandler);

            return this._updates[field].input.push(ctl[0]);
        },
        formElements: ["input", "select", "textarea"]
    };

    var safeReg = /[^\w]+/g;
    var safeStr = function (value) {
        return value.replace(safeReg, "_");
    };
    var setDirty = function (e) {
        this.setDirty(true, e.model);
    };

    ej.Predicate = function (field, operator, value, ignoreCase) {
        if (!(this instanceof ej.Predicate))
            return new ej.Predicate(field, operator, value, ignoreCase);

        if (typeof field === "string") {
			var checkAny = "";
			if(operator.toLowerCase().indexOf(" any") != -1) {
				operator = operator.replace(" any","");
				checkAny = "any";
			} 
			else if(operator.toLowerCase().indexOf(" all") != -1) {
				operator = operator.replace(" all","");
				checkAny = "all";
			} 
            this.field = field;
            this.operator = operator;
            this.value = value;
            this.ignoreCase = ignoreCase;
            this.isComplex = false;
			this.anyCondition = checkAny;

            this._comparer = ej.data.fnOperators.processOperator(checkAny != "" ? checkAny:this.operator);

        } else if (field instanceof ej.Predicate && value instanceof ej.Predicate || value instanceof Array) {
            this.isComplex = true;
            this.condition = operator.toLowerCase();
            this.predicates = [field];
            if (value instanceof Array)
                [].push.apply(this.predicates, value);
            else
                this.predicates.push(value);
        }
        return this;
    };

    ej.Predicate.and = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "and");
    };

    ej.Predicate.or = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "or");
    };

    ej.Predicate.fromJSON = function (json) {
        if (instance(json, Array)) {
            var res = [];
            for (var i = 0, len = json.length; i < len; i++)
                res.push(pvtPredicate._fromJSON(json[i]));
            return res;
        }

        return pvtPredicate._fromJSON(json);
    };

    // Private fn
    var pvtPredicate = {
        _combinePredicates: function (predicates, operator) {
            if (!predicates.length) return undefined;
            if (predicates.length === 1) {
                if (!instance(predicates[0], Array))
                    return predicates[0];
                predicates = predicates[0];
            }
            return new ej.Predicate(predicates[0], operator, predicates.slice(1));
        },

        _combine: function (pred, field, operator, value, condition, ignoreCase) {
            if (field instanceof ej.Predicate)
                return ej.Predicate[condition](pred, field);

            if (typeof field === "string")
                return ej.Predicate[condition](pred, new ej.Predicate(field, operator, value, ignoreCase));

            return throwError("Predicate - " + condition + " : invalid arguments");
        },

        _fromJSON: function (json) {

            if (!json || instance(json, ej.Predicate))
                return json;

            var preds = json.predicates || [], len = preds.length, predicates = [], result;

            for (var i = 0; i < len; i++)
                predicates.push(pvtPredicate._fromJSON(preds[i]));                     

            if(!json.isComplex)
                result = new ej.Predicate(json.field, json.operator, ej.parseJSON({ val: json.value }).val, json.ignoreCase);
            else
                result = new ej.Predicate(predicates[0], json.condition, predicates.slice(1));

            return result;
        }
    };

    ej.Predicate.prototype = {
        and: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "and", ignoreCase);
        },
        or: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "or", ignoreCase);
        },
        validate: function (record) {
            var p = this.predicates, isAnd, ret;

            if (!this.isComplex) {
                return this._comparer.call(this, ej.pvt.getObject(this.field, record), this.value, this.ignoreCase);
            }

            isAnd = this.condition === "and";

            for (var i = 0; i < p.length; i++) {
                ret = p[i].validate(record);
                if (isAnd) {
                    if (!ret) return false;
                } else {
                    if (ret) return true;
                }
            }

            return isAnd;
        },
        toJSON: function () {
            var predicates, p;
            if (this.isComplex) {
                predicates = [], p = this.predicates;
                for (var i = 0; i < p.length; i++)
                    predicates.push(p[i].toJSON());
            }
            return {
                isComplex: this.isComplex,
                field: this.field,
                operator: this.operator,
                value: this.value,
                ignoreCase: this.ignoreCase,
                condition: this.condition,
                predicates: predicates,
				anyCondition: this.anyCondition
            }
        }
    };

    ej.dataUtil = {
        swap: function (array, x, y) {
            if (x == y) return;

            var tmp = array[x];
            array[x] = array[y];
            array[y] = tmp;
        },

        mergeSort: function (jsonArray, fieldName, comparer) {
            if (!comparer || typeof comparer === "string")
                comparer = ej.pvt.fnSort(comparer, true);

            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.mergeSort(jsonArray, fieldName, comparer);
        },

        max: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnDescending);
        },

        min: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnAscending);
        },

        distinct: function (json, fieldName, requiresCompleteRecord) {
            var result = [], val, tmp = {};
            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!(val in tmp)) {
                    result.push(!requiresCompleteRecord ? val : json[i]);
                    tmp[val] = 1;
                }
            }
            return result;
        },

        sum: function (json, fieldName) {
            var result = 0, val, castRequired = typeof getVal(json, fieldName, 0) !== "number";

            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!isNaN(val) && val !== null) {
                    if (castRequired)
                       val = +val;
                   result += val;
                }
            }
            return result;
        },

        avg: function (json, fieldName) {
            return ej.sum(json, fieldName) / json.length;
        },

        select: function (jsonArray, fields) {
            var newData = [];

            for (var i = 0; i < jsonArray.length; i++) {
                newData.push(ej.pvt.extractFields(jsonArray[i], fields));
            }

            return newData;
        },

        group: function (jsonArray, field, agg, format,/* internal */ level,groupDs) {
            level = level || 1;

            if (jsonArray.GROUPGUID == ej.pvt.consts.GROUPGUID) {
                for (var j = 0; j < jsonArray.length; j++) {
                    if(!ej.isNullOrUndefined(groupDs)){
                        var indx = -1;
                        var temp = $.grep(groupDs,function(e){return e.key==jsonArray[j].key});
                        indx = groupDs.indexOf(temp[0]);
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1, groupDs[indx].items);
                        jsonArray[j].count = groupDs[indx].count;
                    }
                    else{
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1);
                        jsonArray[j].count = jsonArray[j].items.length;
                    }  
                }

                jsonArray.childLevels += 1;
                return jsonArray;
            }

            var grouped = {}, groupedArray = [];

            groupedArray.GROUPGUID = ej.pvt.consts.GROUPGUID;
            groupedArray.level = level;
            groupedArray.childLevels = 0;
            groupedArray.records = jsonArray;

            for (var i = 0; i < jsonArray.length; i++) {
                var val = getVal(jsonArray, field, i);
                if (!ej.isNullOrUndefined(format)) val = format(val, field);

                if (!grouped[val]) {
                    grouped[val] = {
                        key: val,
                        count: 0,
                        items: [],
                        aggregates: {},
                        field: field
                    };
                    groupedArray.push(grouped[val]);
					if(!ej.isNullOrUndefined(groupDs)) {
                        var tempObj = $.grep(groupDs,function(e){return e.key==grouped[val].key});
                       grouped[val].count = tempObj[0].count
                    }
                }

                grouped[val].count = !ej.isNullOrUndefined(groupDs) ? grouped[val].count :  grouped[val].count += 1;
                grouped[val].items.push(jsonArray[i]);
            }
            if (agg && agg.length) {

                for (var i = 0; i < groupedArray.length; i++) {
                    var res = {}, fn;
                    for (var j = 0; j < agg.length; j++) {

                        fn = ej.aggregates[agg[j].type];
                        if(!ej.isNullOrUndefined(groupDs)) {
                            var temp = $.grep(groupDs,function(e){return e.key==groupedArray[i].key});
                            if(fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(temp[0].items, agg[j].field);
                        }
                        else{
                            if (fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(groupedArray[i].items, agg[j].field);
                        }

                    }
                    groupedArray[i]["aggregates"] = res;
                }
            }
            return groupedArray;
        },

        parseTable: function (table, headerOption, headerRowIndex) {
            var tr = table.rows, headerRow, headerTds = [], data = [], i;

            if (!tr.length) return [];

            headerRowIndex = headerRowIndex || 0;

            switch ((headerOption || "").toLowerCase()) {
                case ej.headerOption.tHead:
                    headerRow = table.tHead.rows[headerRowIndex];
                    break;
                case ej.headerOption.row:
                default:
                    headerRow = table.rows[headerRowIndex];
                    break;
            }

            var hTd = headerRow.cells;

            for (i = 0; i < hTd.length; i++)
                headerTds.push($.trim(hTd[i].innerHTML));

            for (i = headerRowIndex + 1; i < tr.length; i++) {
                var json = {}, td = tr[i].cells;
                for (var j = 0; j < td.length; j++) {
                    var temp = td[j].innerHTML;
                    if (typeof temp == "string" && $.isNumeric(temp))
                       json[headerTds[j]] = Number(temp);
				    else
                       json[headerTds[j]] = temp;
                }
                data.push(json);
            }
            return data;
        }
    };

    ej.headerOption = {
        tHead: "thead",
        row: "row"
    };

    ej.aggregates = {
        sum: function (ds, field) {
            return ej.sum(ds, field);
        },
        average: function (ds, field) {
            return ej.avg(ds, field);
        },
        minimum: function (ds, field) {
            return ej.getObject(field, ej.min(ds, field));
        },
        maximum: function (ds, field) {
            return  ej.getObject(field, ej.max(ds, field));
        },
        truecount: function (ds, field){
            var predicate = ej.Predicate(field, "equal", true);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        falsecount: function (ds, field) {
            var predicate = ej.Predicate(field, "equal", false);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        count: function (ds, field) {
            return ds.length;
        }

    };
    ej.pvt = {
        filterQueries: filterQueries,
        mergeSort: function (jsonArray, fieldName, comparer) {
            if (jsonArray.length <= 1)
                return jsonArray;

            // else list size is > 1, so split the list into two sublists
            var middle = parseInt(jsonArray.length / 2, 10);

            var left = jsonArray.slice(0, middle),
                right = jsonArray.slice(middle);

            left = ej.pvt.mergeSort(left, fieldName, comparer);
            right = ej.pvt.mergeSort(right, fieldName, comparer);

            return ej.pvt.merge(left, right, fieldName, comparer);
        },

        getItemFromComparer: function (array, field, comparer) {
            var keyVal, current, key, i = 0,castRequired = typeof getVal(array, field, 0) == "string";
            if (array.length)
            while (ej.isNullOrUndefined(keyVal) && i < array.length) {
                keyVal = getVal(array, field, i);
                key = array[i++];
            }
            for (; i < array.length; i++) {
                current = getVal(array, field, i);
                if (ej.isNullOrUndefined(current))
                    continue;
                if (castRequired) {
                    keyVal = +keyVal;
                    current = +current;
                }
                if (comparer(keyVal, current) > 0) {
                    keyVal = current;
                    key = array[i];
                }
            }
            return key;
        },

        quickSelect: function (array, fieldName, left, right, k, comparer) {
            if (left == right)
                return array[left];

            var pivotNewIndex = ej.pvt.partition(array, fieldName, left, right, comparer);

            var pivotDist = pivotNewIndex - left + 1;

            if (pivotDist == k)
                return array[pivotNewIndex];

            else if (k < pivotDist)
                return ej.pvt.quickSelect(array, fieldName, left, pivotNewIndex - 1, k, comparer);
            else
                return ej.pvt.quickSelect(array, fieldName, pivotNewIndex + 1, right, k - pivotDist, comparer);
        },

        extractFields: function (obj, fields) {
            var newObj = {};

            if (fields.length == 1)
                return ej.pvt.getObject(fields[0], obj);

            for (var i = 0; i < fields.length; i++) {
                newObj[fields[i].replace('.', ej.pvt.consts.complexPropertyMerge)] = ej.pvt.getObject(fields[i], obj);
            }

            return newObj;
        },

        partition: function (array, field, left, right, comparer) {

            var pivotIndex = parseInt((left + right) / 2, 10),
                pivot = getVal(array, field, pivotIndex);

            ej.swap(array, pivotIndex, right);

            pivotIndex = left;

            for (var i = left; i < right; i++) {
                if (comparer(getVal(array, field, i), pivot)) {
                    ej.swap(array, i, pivotIndex);
                    pivotIndex++;
                }
            }

            ej.swap(array, pivotIndex, right);

            return pivotIndex;
        },

        fnSort: function (order) {
            order = order ? order.toLowerCase() : ej.sortOrder.Ascending;

            if (order == ej.sortOrder.Ascending)
                return ej.pvt.fnAscending;

            return ej.pvt.fnDescending;
        },

        fnGetComparer: function (field, fn) {
            return function (x, y) {
                return fn(ej.pvt.getObject(field, x), ej.pvt.getObject(field, y));
            }
        },

        fnAscending: function (x, y) {
            if (y === null || y === undefined)
                return -1;

            if (typeof x === "string")
                return x.localeCompare(y);

            if (x === null || x === undefined)
                return 1;

            return x - y;
        },

        fnDescending: function (x, y) {
            if (y === null || y === undefined)
                return 1;

            if (typeof x === "string")
                return x.localeCompare(y) * -1;

            if (x === null || x === undefined)
                return -1;

            return y - x;
        },

        merge: function (left, right, fieldName, comparer) {
            var result = [], current;

            while (left.length > 0 || right.length > 0) {
                if (left.length > 0 && right.length > 0) {
                    if (comparer)
                        current = comparer(getVal(left, fieldName, 0), getVal(right, fieldName, 0)) <= 0 ? left : right;
                    else
                        current = left[0][fieldName] < left[0][fieldName] ? left : right;
                } else {
                    current = left.length > 0 ? left : right;
                }

                result.push(current.shift());
            }

            return result;
        },

        getObject: function (nameSpace, from) {
            if (!from) return undefined;
            if (!nameSpace) return from;

            if (nameSpace.indexOf('.') === -1) return from[nameSpace];

            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (value == null) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i;

            for (i = 0; i < splits.length; i++) {

                if (i + 1 == splits.length)
                    from[splits[i]] = value === undefined ? {} : value;
                else if (from[splits[i]] == null)
                    from[splits[i]] = {};

                from = from[splits[i]];
            }

            return start;
        },

        getFieldList: function (obj, fields, prefix) {
            if (prefix === undefined)
                prefix = "";

            if (fields === undefined || fields === null)
                return ej.pvt.getFieldList(obj, [], prefix);

            for (var prop in obj) {
                if (typeof obj[prop] === "object" && !(obj[prop] instanceof Array))
                    ej.pvt.getFieldList(obj[prop], fields, prefix + prop + ".");
                else
                    fields.push(prefix + prop);
            }

            return fields;
        }
    };

    ej.FilterOperators = {
        lessThan: "lessthan",
        greaterThan: "greaterthan",
        lessThanOrEqual: "lessthanorequal",
        greaterThanOrEqual: "greaterthanorequal",
        equal: "equal",
        contains: "contains",
        startsWith: "startswith",
        endsWith: "endswith",
        notEqual: "notequal"
    };

    ej.data = {};

    ej.data.operatorSymbols = {
        "<": "lessthan",
        ">": "greaterthan",
        "<=": "lessthanorequal",
        ">=": "greaterthanorequal",
        "==": "equal",
        "!=": "notequal",
        "*=": "contains",
        "$=": "endswith",
        "^=": "startswith"
    };

    ej.data.odBiOperator = {
        "<": " lt ",
        ">": " gt ",
        "<=": " le ",
        ">=": " ge ",
        "==": " eq ",
        "!=": " ne ",
        "lessthan": " lt ",
        "lessthanorequal": " le ",
        "greaterthan": " gt ",
        "greaterthanorequal": " ge ",
        "equal": " eq ",
        "notequal": " ne ",
		"in":" eq ",
		"notin": " ne "
    };

    ej.data.odUniOperator = {
        "$=": "endswith",
        "^=": "startswith",
        "*=": "substringof",
        "endswith": "endswith",
        "startswith": "startswith",
        "contains": "substringof",
		"notcontains":"substringof"
    };

    ej.data.fnOperators = {
        equal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) == toLowerCase(expected);

            return actual == expected;
        },
        notequal: function (actual, expected, ignoreCase) {
            return !ej.data.fnOperators.equal(actual, expected, ignoreCase);
        },
		notin: function (actual, expected, ignoreCase) {
			for(var i = 0; i < expected.length; i++) 
				if(ej.data.fnOperators.notequal(actual, expected[i], ignoreCase) == false) return false;
            return true;
        },
        lessthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) < toLowerCase(expected);

            return actual < expected;
        },
        greaterthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) > toLowerCase(expected);

            return actual > expected;
        },
        lessthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) <= toLowerCase(expected);

            return actual <= expected;
        },
        greaterthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) >= toLowerCase(expected);

            return actual >= expected;
        },
        contains: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return !isNull(actual) && !isNull(expected) && toLowerCase(actual).indexOf(toLowerCase(expected)) != -1;

            return !isNull(actual) && !isNull(expected) && actual.toString().indexOf(expected) != -1;
        },
		notcontains: function (actual, expected, ignoreCase) {
			 return !ej.data.fnOperators.contains(actual, expected, ignoreCase);
		},
        notnull: function (actual) {
            return actual !== null;
        },
        isnull: function (actual) {
            return actual === null;
        },
        startswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).startsWith(toLowerCase(expected));

            return actual && expected && actual.startsWith(expected);
        },
        endswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).endsWith(toLowerCase(expected));

            return actual && expected && actual.endsWith(expected);
        },
		all: function (actual, expected, ignoreCase ) {
			for(var i = 0; i < expected.length; i++)
				if (ej.data.fnOperators[this.operator](actual, expected[i], ignoreCase) == false) return false;
            return true;
		},
		any: function (actual, expected, ignoreCase ) {
			for(var i = 0; i < expected.length; i++)
				if (ej.data.fnOperators[this.operator](actual, expected[i], ignoreCase) == true) return true;
            return false;
		},
        processSymbols: function (operator) {
            var fnName = ej.data.operatorSymbols[operator];
            if (fnName) {
                var fn = ej.data.fnOperators[fnName];
                if (fn) return fn;
            }

            return throwError("Query - Process Operator : Invalid operator");
        },

        processOperator: function (operator) {
            var fn = ej.data.fnOperators[operator];
            if (fn) return fn;
            return ej.data.fnOperators.processSymbols(operator);
        }
    };

    ej.data.fnOperators["in"] = function (actual, expected, ignoreCase) {
        for(var i = 0; i < expected.length; i++)
            if (ej.data.fnOperators.equal(actual, expected[i], ignoreCase) == true) return true;
        return false;
    };

    ej.NotifierArray = function (array) {
        if (!instance(this, ej.NotifierArray))
            return new ej.NotifierArray(array);

        this.array = array;

        this._events = $({});
        this._isDirty = false;

        return this;
    };

    ej.NotifierArray.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        push: function (item) {
            var ret;

            if (instance(item, Array))
                ret = [].push.apply(this.array, item);
            else
                ret = this.array.push(item);

            this._raise("add", { item: item, index: this.length() - 1 });

            return ret;
        },
        pop: function () {
            var ret = this.array.pop();

            this._raise("remove", { item: ret, index: this.length() - 1 });

            return ret;
        },
        addAt: function (index, item) {
            this.array.splice(index, 0, item);

            this._raise("add", { item: item, index: index });

            return item;
        },
        removeAt: function (index) {
            var ret = this.array.splice(index, 1)[0];

            this._raise("remove", { item: ret, index: index });

            return ret;
        },
        remove: function (item) {
            var index = this.array.indexOf(item);

            if (index > -1) {
                this.array.splice(index, 1);
                this._raise("remove", { item: item, index: index });
            }

            return index;
        },
        length: function () {
            return this.array.length;
        },
        _raise: function (e, args) {
            this._events.triggerHandler($.extend({ type: e }, args));
            this._events.triggerHandler({ type: "all", name: e, args: args });
        },
        toArray: function () {
            return this.array;
        }
    };

    $.extend(ej, ej.dataUtil);

    // For IE8
    Array.prototype.forEach = Array.prototype.forEach || function (fn, scope) {
        for (var i = 0, len = this.length; i < len; ++i) {
            fn.call(scope, this[i], i, this);
        }
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    Array.prototype.filter = Array.prototype.filter || function (fn) {
        if (typeof fn != "function")
            throw new TypeError();

        var res = [];
        var thisp = arguments[1] || this;
        for (var i = 0; i < this.length; i++) {
            var val = this[i]; // in case fun mutates this
            if (fn.call(thisp, val, i, this))
                res.push(val);
        }

        return res;
    };

    String.prototype.endsWith = String.prototype.endsWith || function (key) {
        return this.slice(-key.length) === key;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };

    if (!ej.support) ej.support = {};
    ej.support.stableSort = function () {
        var res = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16].sort(function () { return 0; });
		for(var i = 0; i < 17; i++){
		    if(i !== res[i]) return false;
		}
        return true;
    }();
    ej.support.cors = $.support.cors;

    if (!$.support.cors && window.XDomainRequest) {
        var httpRegEx = /^https?:\/\//i;
        var getOrPostRegEx = /^get|post$/i;
        var sameSchemeRegEx = new RegExp('^' + location.protocol, 'i');
        var xmlRegEx = /\/xml/i;

        // ajaxTransport exists in jQuery 1.5+
        $.ajaxTransport('text html xml json', function (options, userOptions, jqXHR) {
            // XDomainRequests must be: asynchronous, GET or POST methods, HTTP or HTTPS protocol, and same scheme as calling page
            if (options.crossDomain && options.async && getOrPostRegEx.test(options.type) && httpRegEx.test(userOptions.url) && sameSchemeRegEx.test(userOptions.url)) {
                var xdr = null;
                var userType = (userOptions.dataType || '').toLowerCase();
                return {
                    send: function (headers, complete) {
                        xdr = new XDomainRequest();
                        if (/^\d+$/.test(userOptions.timeout)) {
                            xdr.timeout = userOptions.timeout;
                        }
                        xdr.ontimeout = function () {
                            complete(500, 'timeout');
                        };
                        xdr.onload = function () {
                            var allResponseHeaders = 'Content-Length: ' + xdr.responseText.length + '\r\nContent-Type: ' + xdr.contentType;
                            var status = {
                                code: 200,
                                message: 'success'
                            };
                            var responses = {
                                text: xdr.responseText
                            };

                            try {
                                if (userType === 'json') {
                                    try {
                                        responses.json = JSON.parse(xdr.responseText);
                                    } catch (e) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        //throw 'Invalid JSON: ' + xdr.responseText;
                                    }
                                } else if ((userType === 'xml') || ((userType !== 'text') && xmlRegEx.test(xdr.contentType))) {
                                    var doc = new ActiveXObject('Microsoft.XMLDOM');
                                    doc.async = false;
                                    try {
                                        doc.loadXML(xdr.responseText);
                                    } catch (e) {
                                        doc = undefined;
                                    }
                                    if (!doc || !doc.documentElement || doc.getElementsByTagName('parsererror').length) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        throw 'Invalid XML: ' + xdr.responseText;
                                    }
                                    responses.xml = doc;
                                }
                            } catch (parseMessage) {
                                throw parseMessage;
                            } finally {
                                complete(status.code, status.message, responses, allResponseHeaders);
                            }
                        };
                        xdr.onerror = function () {
                            complete(500, 'error', {
                                text: xdr.responseText
                            });
                        };
						if(navigator.userAgent.indexOf("MSIE 9.0") != -1)
							xdr.onprogress = function() {};
                        xdr.open(options.type, options.url);
                        xdr.send(userOptions.data);
                        //xdr.send();
                    },
                    abort: function () {
                        if (xdr) {
                            xdr.abort();
                        }
                    }
                };
            }
        });
    }

    $.support.cors = true;

    ej.sortOrder = {
        Ascending: "ascending",
        Descending: "descending"
    };

    // privates
    ej.pvt.consts = {
        GROUPGUID: "{271bbba0-1ee7}",
        complexPropertyMerge: "_"
    };

    // private utils
    var nextTick = function (fn, context) {
        if (context) fn = $proxy(fn, context);
        (window.setImmediate || window.setTimeout)(fn, 0);
    };

    ej.support.enableLocalizedSort = false;

    var stableSort = function (ds, field, comparer, queries) {
        if (ej.support.stableSort) {
            if(!ej.support.enableLocalizedSort && typeof ej.pvt.getObject(field, ds[0] || {}) == "string" 
                && (comparer === ej.pvt.fnAscending || comparer === ej.pvt.fnDescending)
                && queries.filter(function(e){return e.fn === "onSortBy";}).length === 1)
                return fastSort(ds, field, comparer === ej.pvt.fnDescending);
            return ds.sort(ej.pvt.fnGetComparer(field, comparer));
        }
        return ej.mergeSort(ds, field, comparer);
    };
    var getColFormat = function (field, query) {
        var grpQuery = $.grep(query, function (args) { return args.fn == "onGroup" });
        for (var grp = 0; grp < grpQuery.length; grp++) {
            if (ej.getObject("fieldName", grpQuery[grp].e) == field) {
                return ej.getObject("fn", grpQuery[grp].e);
            }
        }
    };
    var fastSort = function(ds, field, isDesc){
        var old = Object.prototype.toString;
        Object.prototype.toString = (field.indexOf('.') === -1) ? function(){
            return this[field];
        }:function(){
            return ej.pvt.getObject(field, this);
        };
        ds = ds.sort();
        Object.prototype.toString = old;
        if(isDesc)
            ds.reverse();
    }

    var toLowerCase = function (val) {
        return val ? val.toLowerCase ? val.toLowerCase() : val.toString().toLowerCase() : (val === 0 || val === false) ? val.toString() : "";
    };

    var getVal = function (array, field, index) {
        return field ? ej.pvt.getObject(field, array[index]) : array[index];
    };

    var isHtmlElement = function (e) {
        return typeof HTMLElement === "object" ? e instanceof HTMLElement :
            e && e.nodeType === 1 && typeof e === "object" && typeof e.nodeName === "string";
    };

    var instance = function (obj, element) {
        return obj instanceof element;
    };

    var getTableModel = function (name, result, dm, computed) {
        return function (tName) {
            if (typeof tName === "object") {
                computed = tName;
                tName = null;
            }
            return new ej.TableModel(tName || name, result, dm, computed);
        };
    };

    var getKnockoutModel = function (result) {
        return function (computedObservables, ko) {
            ko = ko || window.ko;

            if (!ko) throwError("Knockout is undefined");

            var model, koModels = [], prop, ob;
            for (var i = 0; i < result.length; i++) {
                model = {};
                for (prop in result[i]) {
                    if (!prop.startsWith("_"))
                        model[prop] = ko.observable(result[i][prop]);
                }
                for (prop in computedObservables) {
                    ob = computedObservables[prop];

                    if ($.isPlainObject(ob)) {
                        if (!ob.owner) ob.owner = model;
                        ob = ko.computed(ob);
                    } else
                        ob = ko.computed(ob, model);

                    model[prop] = ob;
                }
                koModels.push(model);
            }

            return ko.observableArray(koModels);
        };
    };

    var uidIndex = 0;
    var getUid = function (prefix) {
        uidIndex += 1;
        return prefix + uidIndex;
    };

    ej.getGuid = function (prefix) {
        var hexs = '0123456789abcdef', rand;
        return (prefix || "") + '00000000-0000-4000-0000-000000000000'.replace(/0/g, function (val, i) {
            if ("crypto" in window && "getRandomValues" in crypto) {
                var arr = new Uint8Array(1)
                window.crypto.getRandomValues(arr);
                rand = arr[0] % 16|0
            }
            else rand = Math.random() * 16 | 0;
            return hexs[i === 19 ? rand & 0x3 | 0x8 : rand];
        });
    };

    var proxy = function (fn, context) {
        return function () {
            var args = [].slice.call(arguments, 0);
            args.push(this);

            return fn.apply(context || this, args);
        };
    };

    var $proxy = function (fn, context, arg) {
        if ('bind' in fn)
            return arg ? fn.bind(context, arg) : fn.bind(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.merge = function (first, second) {
        if (!first || !second) return;

        Array.prototype.push.apply(first, second);
    };

    var isNull = function (val) {
        return val === undefined || val === null;
    };

    var throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

})(window.jQuery, window.Syncfusion, window.document);;

(function ($, undefined) {

    var $document = $(document);
    // add new event shortcuts
    $.each(("touchstart touchmove touchend " +
		"tap doubletap taphold " +
		"swipe swipeleft swiperight " + "pinch pinchin pinchout pinchstop " +
		"scrollstart scrollstop").split(" "), function (i, name) {

		    $.fn[name] = function (fn) {
		        return fn ? this.on(name, fn) : this.trigger(name);
		    };

		    // jQuery < 1.8
		    if ($.attrFn) {
		        $.attrFn[name] = true;
		    }
		});

    var isPointer = browserInfo().isMSPointerEnabled,
    isIE11Pointer = browserInfo().pointerEnabled,
    supportTouch = 'ontouchstart' in window,
	scrollEvent = "scroll",
    isDesktop = (typeof window.orientation === "undefined"),
    isIosDevice = navigator.userAgent.match(/iPhone|iPad|iPod/i),
	touchStartEvent = isPointer ? (isIE11Pointer ? "pointerdown" : "MSPointerDown") : (supportTouch ? "touchstart" : "mousedown"),
	touchStopEvent = isPointer ? (isIE11Pointer ? "pointerup" : "MSPointerUp") : isIosDevice ? ("touchend") : (supportTouch ? "touchend" : "mouseup"),
	touchMoveEvent = isPointer ? (isIE11Pointer ? "pointermove" : "MSPointerMove") : (supportTouch ? "touchmove" : "mousemove"),
    touchCancelEvent = isPointer ? (isIE11Pointer ? "pointercancel" : "MSPointerCancel") : (supportTouch ? "touchcancel" : "mouseleave"),
    mouseStartEvent = isPointer || !isDesktop ? touchStartEvent : isIosDevice ? "touchstart" : "touchstart mousedown",
    mouseStopEvent = isPointer || !isDesktop ? touchStopEvent : "touchend mouseup",
    mouseMoveEvent = isPointer || !isDesktop ? touchMoveEvent : "touchmove mousemove",
    browser = browserInfo(),
    isIE9 = ((browser.name == 'msie') && (browser.version == '9.0')) ? true : false;

    function browserInfo() {
        var browser = {}, clientInfo = [],
        browserClients = {
            webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie) ([\w.]+)/i,
            opera: /(opera)(?:.*version|)[ \/]([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    }
    function initiateCustomEvent(obj, eventType, e) {
        var originalType = e.type;
        e.type = eventType;
        $.event.dispatch.call(obj, e);
        e.type = originalType;
    }
    function copyObject(e, origEvent) {
        if (origEvent) {
            for (prop in origEvent) {
                if (!(prop in e)) {
                    e[prop] = origEvent[prop];
                }
            }
        }
    }
    $.event.special.ejtouchmove = {
        setup: function () {
            var thisObj = this,
				$this = $(thisObj);
            $this.on(touchStartEvent, startMoveHandler);
            $document.on(touchStopEvent, clearTouchMoveHandlers);
            function clearTouchMoveHandlers() {
               // $this.off(touchMoveEvent, moveHandler)
            }
            var coords = {};
            function startMoveHandler(e) {
                if (!e.originalEvent) return;
                if (!(e.which && e.which !== 1)) {
                    var origTarget = e.target,
					origEvent = e.originalEvent;
                    if (isPointer)
                        coords = { x: origEvent.x, y: origEvent.y };
                    $this.on(touchMoveEvent, moveHandler);
                }
            }
            function moveHandler(e) {
                if (!(e.which && e.which !== 1)) {
                    var origTarget = e.target,
					origEvent = e.originalEvent;
                    copyObject(e, e.originalEvent);
                    if (!isPointer || !coords || (Math.abs(coords.x - origEvent.x) > 10 || Math.abs(coords.y - origEvent.y) > 10 && isPointer))
                        initiateCustomEvent(thisObj, "ejtouchmove", e);
                }
            }
        }
    };
    function touchObj(e) {
        return e.originalEvent.touches ?
					e.originalEvent.touches[0] : isPointer ? e.originalEvent : e;
    }
    // handles swipeup and swipedown
    $.event.special.swipeupdown = {
        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);
            $this.on(touchStartEvent, function (e) {
                if (!e.originalEvent) return;
                var _startevent = e;
                var data = touchObj(e),
                            startPoint = {
                                time: (new Date).getTime(),
                                coords: [data.pageX, data.pageY],
                                origin: $(e.target)
                            },
                            stopPoint;
                function moveHandler(e) {
                    e.preventDefault();
                    if (!startPoint) return;
                    var data = touchObj(e);
                    stopPoint = {
                        time: (new Date).getTime(),
                        coords: [data.pageX, data.pageY]
                    };
                    if (Math.abs(startPoint.coords[1] - stopPoint.coords[1]) > 10) e.preventDefault();
                }

                $this
                            .on(touchMoveEvent, moveHandler)
                            .one(touchStopEvent, function (e) {
                                $this.off(touchMoveEvent, moveHandler);
                                if (startPoint && stopPoint) {
                                    if (stopPoint.time - startPoint.time < 1000 &&
                                    Math.abs(startPoint.coords[1] - stopPoint.coords[1]) > 30 &&
                                    Math.abs(startPoint.coords[0] - stopPoint.coords[0]) < 75) {
                                        var _addDetails = { time: stopPoint.time - startPoint.time, _isSwipe: true, _isDelta: true, stopPoint: stopPoint };
                                        var _options = _getOptions(e, _addDetails, _startevent);

                                        startPoint.origin
                                        .trigger($.extend(true, { type: "swipeupdown" }, _options))
                                        .trigger($.extend(true, { type: startPoint.coords[1] > stopPoint.coords[1] ? "swipeup" : "swipedown" }, _options));
                                    }
                                }
                                startPoint = stopPoint = undefined;
                            });
            });
        }
    };
    $.event.special.scrollstart = {
        isEnabled: true,
        setup: function () {
            var thisObj = this, $this = $(thisObj), scrolling, timer;
            function trigger(e, scrollState) {
                scrolling = scrollState;
                initiateCustomEvent(thisObj, scrolling ? "scrollstart" : "scrollstop", e);
            }
            $this.on(scrollEvent, function (e) {
                if (!$.event.special.scrollstart.isEnabled) return;
                if (!scrolling) trigger(e, true);
                clearTimeout(timer);
                timer = setTimeout(function () {
                    trigger(e, false);
                }, 250);
            });
        }
    };

    // also handles doubletap, taphold
    $.event.special.tap = {
        doubleTapThreshold: 500,
        tapholdThreshold: 650,
        canDoubleTap: function (d) {
            return ((getTimeSpan() - d.doubleTapStartTime) <= $.event.special.tap.doubleTapThreshold);
        },
        setup: function () {
            var thisObj = this, $this = $(thisObj), d = $this.data();
            var mouseDownTarget;            
            checkMsieTouch($this);
            d.isDoubleTapWait = false;
            d.stopProcess = false;
            d.preTouchend = null;
            d.preTouchstart = null;

            $this.on(mouseStartEvent, function (event) {
                if (!event.originalEvent) return;
                if (event.type == "mousedown" || event.type == "pointerdown" || "MSPointerDown")                   
                    mouseDownTarget = event.target;
                               
                d = $this.data();
                d.startTime = getTimeSpan();
                if (!d.isDoubleTapWait) d.doubleTapStartTime = d.startTime;
                if (event.type == "touchstart") d.preTouchstart = d.startTime;
                // checked mousedown event arrives within 300'ms after the touchend completes
                if (event.type == "mousedown" && (d.startTime - d.preTouchend < 300 || d.startTime - d.preTouchstart < 30))
                    d.stopProcess = true;
                else d.stopProcess = false;

                var origTarget = event.currentTarget,
					origEvent = event.originalEvent,
					timer;

                function clearTapHandlers() {
                    clearTimeout(timer);

                    $this.off(mouseStopEvent, clickHandler);
                    if (isIE9) $document.off(mouseStopEvent, clickHandler);
                    $document.off(mouseStopEvent, clearTapHandlers);
                    $this.off(touchCancelEvent, clearTapHandlers);
                    $this.off(mouseMoveEvent, touchMoveAction);
                    $this.off('dragstart', dragAction);
                }
                function touchMoveAction(e) {
                    var touchmoveThreshold = 10;
                    var coor1 = (e.originalEvent.changedTouches ? e.originalEvent.changedTouches[0] : e.originalEvent),
                        coor2 = (event.originalEvent.changedTouches ? event.originalEvent.changedTouches[0] : event.originalEvent);
                    if (!((coor1.pageX - coor2.pageX < touchmoveThreshold && coor1.pageX - coor2.pageX > -(touchmoveThreshold)) &&
                        (coor1.pageY - coor2.pageY < touchmoveThreshold && coor1.pageY - coor2.pageY > -(touchmoveThreshold)))) {
                        if (e.type == "mousemove" || (e.type == "pointermove" && e.originalEvent.pointerType == "mouse") ||
                            e.type == "MSPointerMove" && e.originalEvent.pointerType == 4) {
                            clearTimeout(timer);
                            $this.off(touchCancelEvent, clearTapHandlers);
                            $this.off(mouseMoveEvent, touchMoveAction);
                        }
                        else
                          clearTapHandlers();                                            
                    }                    
                }
                function clickHandler(e) {
                    if (e.type == "touchend") d.preTouchend = getTimeSpan();
                    clearTapHandlers();

                    // Modify the tap event target
                    if (mouseDownTarget != e.target && (e.type == "mouseup" || event.type == "pointerup" || "MSPointerUp")) {
                        var mouseupTarget = e.target;                        
                        // Mousedown element is the parent of the mouseup element.                       
                        if (jQuery.contains(mouseDownTarget, mouseupTarget))
                            // Mousedown element is target.
                            updateTargetEle(e, mouseDownTarget);
                       
                        // Mousedown element is the sibiling of the mouseup element.                            
                        else if (!(jQuery.contains(mouseupTarget, mouseDownTarget))) {
                            var ele = $(mouseDownTarget).parents().has($(mouseupTarget)).first()[0];
							if(!ej.isNullOrUndefined(ele))
                                updateTargetEle(e, ele);                         
                        }
                    }

                    // ONLY trigger a 'tap' event if the startPoint target is
                    // the same as the stopPoint target.
                    if (origTarget === e.currentTarget) {
                        initiateCustomEvent(thisObj, "tap", $.extend(_getBaseOptions(e), {
                            time: getTimeSpan() - d.startTime
                        }));

                        if (d.isDoubleTapWait && $.event.special.tap.canDoubleTap(d)) {
                            d.isDoubleTapWait = false;

                            initiateCustomEvent(thisObj, "doubletap", $.extend(_getBaseOptions(e), {
                                time: getTimeSpan() - d.doubleTapStartTime
                            }));
                        }
                        else {
                            if (d.isDoubleTapWait) {
                                d.isDoubleTapWait = false;
                                d.doubleTapStartTime = d.startTime;
                            }
                            if ($.event.special.tap.canDoubleTap(d)) {
                                d.isDoubleTapWait = true;
                            }
                        }
                    }
                }
                function updateTargetEle(e,target) {
                    e.target = target;
                    e.toElement = target;                  
                }
                function dragAction(e) {
                    // Remove the tap handler while moving the element inside the tap.
                    clearTapHandlers();
                }
                if (!(event.which && event.which !== 1) && !d.stopProcess) {                   
                    $this.on(mouseStopEvent, clickHandler);
                    $document.on(mouseStopEvent, clearTapHandlers);
                    if (isIE9) $document.on(mouseStopEvent, clickHandler);
                    $this.on(touchCancelEvent, clearTapHandlers);
                    $this.on(mouseMoveEvent, touchMoveAction);
                    $this.on('dragstart', dragAction);
                    var eventCopy = {};  
                    for (var i in origEvent) {
                        eventCopy[i] = origEvent[i];    // For IE8 taphold issue, copy the original event in local variable 
                    }
                    timer = setTimeout(function () {
                        if (d.isDoubleTapWait) d.isDoubleTapWait = false;
                        initiateCustomEvent(thisObj, "taphold", $.extend(_getBaseOptions(event), {
                            options: eventCopy,
                            time: getTimeSpan() - d.startTime
                        }));

                    }, $.event.special.tap.tapholdThreshold);
                }
                else if (d.stopProcess) d.stopProcess = false;
            });
        }
    };    
    $.event.special.swipe = {
        scrollSupression: 10,
        duration: 1000,
        horizontalDistance: 30,
        verticalDistance: 75,
        pointers: window.navigator.msPointerEnabled,
        startPoint: function (e) {
            var data = touchObj(e);
            return {
                time: (new Date()).getTime(),
                Items: data,
                coords: [data.pageX, data.pageY],
                origin: $(e.target)
            };
        },
        stopPoint: function (e) {
            var data = touchObj(e);
            return {
                time: (new Date()).getTime(),
                Items: data,
                coords: [data.pageX, data.pageY]
            };
        },
        handleSwipe: function (startPoint, stopPoint, e, _startevent) {
            if(startPoint.Items.pageY != startPoint.Items.clientY || stopPoint.Items.pageY != stopPoint.Items.clientY) $.event.special.swipe.horizontalDistance = 130;
            if (stopPoint.time - startPoint.time < $.event.special.swipe.duration &&  
				Math.abs(startPoint.coords[0] - stopPoint.coords[0]) > $.event.special.swipe.horizontalDistance &&
				Math.abs(startPoint.coords[1] - stopPoint.coords[1]) < $.event.special.swipe.verticalDistance) {

                var _addDetails = { time: stopPoint.time - startPoint.time, _isSwipe: true, _isDelta: true, stopPoint: stopPoint };
                var _options = _getOptions(e, _addDetails, _startevent);

                startPoint.origin.trigger($.extend(true, { type: "swipe" }, _options))
					.trigger($.extend(true,
                    { type: startPoint.coords[0] > stopPoint.coords[0] ? "swipeleft" : "swiperight" }, _options));
            }
        },

        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);

            $this.on(touchStartEvent, function (e) {
                if (!e.originalEvent) return;
                var startPoint = $.event.special.swipe.startPoint(e),
					stopPoint;
                var _startevent = e;
                $(e.target).data('_dataTouchStart', { event: e, _now: new Date().getTime() });

                function moveHandler(e) {
                    if (!startPoint) return;
                    stopPoint = $.event.special.swipe.stopPoint(e);
                    if (Math.abs(startPoint.coords[0] - stopPoint.coords[0]) > $.event.special.swipe.scrollSupression) e.preventDefault();
                }

                $this.on(touchMoveEvent, moveHandler)
					.one(touchStopEvent, function (e) {
					    $this.off(touchMoveEvent, moveHandler);
					    if (startPoint && stopPoint) {
					        $.event.special.swipe.handleSwipe(startPoint, stopPoint, e, _startevent);
					    }
					    startPoint = stopPoint = undefined;
					});
            });
        }
    };
    // also handles pinchin, pinchout
    $.event.special.pinch = {
        distance: function (e) {
            if (e.originalEvent.touches.length < 2) return null;
            return $.event.special.pinch._getdistance(e.originalEvent.touches[0], e.originalEvent.touches[1]);
        },
        _getdistance: function (coor1, coor2) {
            return Math.sqrt((coor1.pageX - coor2.pageX) * (coor1.pageX - coor2.pageX) +
                (coor1.pageY - coor2.pageY) * (coor1.pageY - coor2.pageY));
        },
        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);
            $this.on(touchStartEvent, function (e) {
                if (!e.originalEvent) return;
                var _startevent = e;
                if (e.originalEvent.touches && e.originalEvent.touches.length >= 2) {
                    var startPoint = $.event.special.pinch.distance(e), stopPoint, minDistance = 5;

                    var _pinchDistance = startPoint, moveEvent;
                    var _options = _getOptions(e, { _isPinch: true, _pinchDistance: _pinchDistance }, _startevent);

                    $(e.target).trigger($.extend(true, { type: "pinch" }, _options));

                    function moveHandler(e) {
                        moveEvent = e;
                        stopPoint = $.event.special.pinch.distance(e) || null;
                        if (startPoint && stopPoint && Math.abs(startPoint - stopPoint) > minDistance) {

                            $(e.target).trigger($.extend(true,
                                { type: startPoint > stopPoint ? "pinchin" : "pinchout" }, _getOptions(e,
                                { _isPinch: true, _pinchDistance: _pinchDistance }, _startevent)));

                            startPoint = stopPoint;
                        }
                    }

                    $this.on(touchMoveEvent, moveHandler)
                        .one(touchStopEvent, function () {
                            $this.off(touchMoveEvent, moveHandler);
                            $(e.target).trigger($.extend(true, { type: "pinchstop" }, _getOptions(moveEvent,
                                { _isPinch: true, _pinchDistance: stopPoint }, _startevent)));
                            startPoint = stopPoint = undefined;
                        });
                }
            });
        }
    };
    //  handles touchdrag, touchdrag
    $.event.special.touchdrag = {

        setup: function () {
            var thisObj = this, $this = $(thisObj);
            checkMsieTouch($this);

            $this.on(touchStartEvent, function (e) {
                if (!e.originalEvent) return;
                var startPoint = touchObj(e),
					stopPoint;
                var _startevent = e;
                $(e.target).data('_dataTouchStart', { event: e, _now: new Date().getTime() });

                function moveHandler(e) {
                    if (!startPoint) {
                        return;
                    }
                    stopPoint = touchObj(e);

                    if ($.event.special.pinch._getdistance(startPoint, stopPoint) > 5)
                        $(e.target).trigger($.extend(true, { type: "touchdrag" },
                            _getOptions(e, { _isdrag: true, stopPoint: stopPoint, _isDelta: true }, _startevent)));
                }

                $this.on(touchMoveEvent, moveHandler)
					.one(touchStopEvent, function (e) {
					    $this.off(touchMoveEvent, moveHandler);
					    startPoint = stopPoint = undefined;
					});
            });
        }
    };
    function _getBaseOptions(e) {
        var _pointer = isPointer ? e.originalEvent.pointerType : (!e.originalEvent.touches ? "mouse" : "touch")
        var pointerType = (isPointer && isIE11Pointer == undefined) ? (_pointer == 4 ? "mouse" : "touch") : _pointer;
        e["pointerType"] = pointerType;
        if (e.type != "mousedown" && e.type != "mouseup") {
            copyObject(e, e.originalEvent);
        }
        if (pointerType == "touch")
            e.button = undefined;
        return e;
    }
    function _getOptions(e, _details, _startevent) {
        var _distance, _time, _scale, _iDelta = {}, _startXY, _endXY;
        if (_startevent) {
            var coor;
            if (!_startevent.originalEvent.touches) coor = [_startevent.originalEvent, e.originalEvent];
            else coor = [_startevent.originalEvent.touches[0], e.originalEvent.changedTouches[0]];

            if (_details._isSwipe || _details._isdrag) {
                _distance = $.event.special.pinch._getdistance(coor[0], coor[1]);
                _time = _details.time;
                _endXY = { pageX: _details.stopPoint.pageX, pageY: _details.stopPoint.pageY };
            }
            else if (_details._isPinch) {
                _distance = $.event.special.pinch.distance(e);
                _time = e.timeStamp - _startevent.timeStamp;
                _scale = _details._pinchDistance;
            }
            if (_details._isDelta) {
                _iDelta._dTime = e.timeStamp - _startevent.timeStamp;
                _iDelta._x = coor[1].pageX - coor[0].pageX;
                _iDelta._y = coor[1].pageY - coor[0].pageY;
            }
        }

        return {
            options: e,
            delta: {
                time: _iDelta._dTime || null,
                X: _iDelta._x || null,
                Y: _iDelta._y || null
            },
            distance: _distance,
            scale: _details._isPinch ? _scale : null,
            time: _time,
            velocity: {
                XY: _distance / _iDelta._dTime || null,
                X: _iDelta._x / _iDelta._dTime || null,
                Y: _iDelta._y / _iDelta._dTime || null
            },
            currentPosition: { pageX: _endXY ? _endXY.pageX : null, pageY: _endXY ? _endXY.pageY : null }
        };
    }

    function getTimeSpan() {
        var now = new Date();
        return now.getTime();
    }
    function checkMsieTouch($this) {
        if (isPointer)
            $this.css("-ms-touch-action", "pinch-zoom").css("touch-action", "pinch-zoom");
    }

    $.each({
        scrollstop: "scrollstart",
        doubletap: "tap",
        taphold: "tap",
        swipeleft: "swipe",
        swiperight: "swipe",
        swipedown: "swipeupdown",
        swipeup: "swipeupdown",
        pinchin: "pinch",
        pinchout: "pinch",
        pinchstop: "pinch"
    }, function (event, sourceEvent) {

        $.event.special[event] = {
            setup: function () {
                $(this).on(sourceEvent, $.noop);
            }
        };
    });

})(jQuery);;
/**
* @fileOverview Plugin to drag the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejDraggable", "ej.Draggable", {
        
        element: null,

        
        model: null,
        validTags: ["div", "span", "a"],

        
        defaults: {
            
            scope: 'default', 
            
            handle: null,  
            
            dragArea: null,
            
            clone: false,
            
            distance: 1, 
			
			dragOnTaphold: false,
            
            cursorAt: { top: -1, left: -2 }, 
            
            dragStart: null, 
            
            drag: null, 
            
            dragStop: null, 
			
			create: null,
            
            destroy: null, 
            
            helper: function () {
                return $('<div class="e-drag-helper" />').html("draggable").appendTo(document.body);
            }
        },

        
        _init: function () {
            this.handler = function () { },
			this.resizables = {};
            this._wireEvents();
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            //e-pinch class enables the touch mode operations in IE browsers
            this._browser.name == "msie" && this.element.addClass("e-pinch");
            this._browser.name == "edge" && this.element.css("touch-action", "none");
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "dragArea":
                        this.model.dragArea = options[key];
                        break;
						case "dragOnTaphold":
                        this.model.dragOnTaphold = options[key];
                        break; 
                }
            }
        },
        
        
        _destroy: function () {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._dragStopHandler)
                .off(ej.eventType.mouseMove, this._dragStartHandler)
                .off(ej.eventType.mouseMove, this._dragHandler)
                .off("mouseleave", this._dragMouseOutHandler)
                .off('selectstart', false);

            

            ej.widgetBase.droppables[this.scope] = null;
            
        },

        _initialize: function (e) {
            if( e.target && e.target.nodeName && $( e.target ).closest( "input[type='text'], input[type='checkbox'], textarea, select, option" ).length) return true;
            var ori = e;
			e.preventDefault();
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            
            $(document).on(ej.eventType.mouseMove, this._dragStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);
            if (!this.model.clone) {
                var _offset = this.element.offset();
                this._relXposition = e.pageX - _offset.left;
                this._relYposition = e.pageY - _offset.top;
            }
            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
           //return false;
        },
        _setDragArea: function () {
            var _dragElement = $(this.model.dragArea)[0]; if (!_dragElement) return;
            var elementArea, elementWidthBound, elementHeightBound, elementArea, direction = ["left", "right", "bottom", "top"], top, left;
            if (!ej.isNullOrUndefined(_dragElement.getBoundingClientRect)) {
                elementArea = _dragElement.getBoundingClientRect();
                elementArea.width ? elementWidthBound = elementArea.width : elementWidthBound = elementArea.right - elementArea.left;
                elementArea.height ? elementHeightBound = elementArea.height : elementHeightBound = elementArea.bottom - elementArea.top;
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"));
                    this["padding-" + direction[j]] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]));
                }
                top = $(this.model.dragArea).offset().top; left = $(this.model.dragArea).offset().left;
            } else {
                elementWidthBound = $(this.model.dragArea).outerWidth();
                elementHeightBound = $(this.model.dragArea).outerHeight();
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = 0;
                    this["padding-" + direction[j]] = 0;
                }
                top = left = 0;
            }
            this._left = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-left-width"] + this["padding-left"] : left + this["border-left-width"] + this["padding-left"];
            this._top = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-top-width"] + this["padding-top"] : top + this["border-top-width"] + this["padding-top"];
            this._right = left + elementWidthBound - [this["border-right-width"] + this["padding-right"]];
            this._bottom = top + elementHeightBound - [this["border-bottom-width"] + this["padding-bottom"]];
        },
        _dragStart: function (e) {
            if(e.type =="touchmove" || ( e.type =="mousemove" && ((e.buttons !== undefined ? e.buttons : e.which) == 1) || (this._isIE8 || this._isIE9))){
            var ori = e;
            e = this._getCoordinate(e);
            this.margins = {
                left: (parseInt(this.element.css("marginLeft"), 10) || 0),
                top: (parseInt(this.element.css("marginTop"), 10) || 0),
                right: (parseInt(this.element.css("marginRight"), 10) || 0),
                bottom: (parseInt(this.element.css("marginBottom"), 10) || 0)
            };
            this.offset = this.element.offset();
            this.offset = {
                top: this.offset.top - this.margins.top,
                left: this.offset.left - this.margins.left
            };
            this.position = this._getMousePosition(ori);
            var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY;
            var distance = Math.sqrt((x * x) + (y * y));

            if (distance >= this.model.distance) {
			    var ele = this.model.helper({ sender: ori, element: this.target });
				if(!ele || ej.isNullOrUndefined(ele)) return;
                var dragTargetElmnt = this.model.handle = this.helper = ele;
                if (this.model.dragStart) {
                    var currTarget = null;
                    if (ori.type == 'touchmove') {
                        var coor = ori.originalEvent.changedTouches[0];
                        currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                    }
                    else currTarget = ori.originalEvent.target || ori.target;
					if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
						currTarget = this._checkTargetElement(e) || currTarget;   
                    if (this._trigger("dragStart", { event: ori, element: this.element, target: currTarget, currentTarget: this._getCurrTarget(e)})) {
                        this._destroy();
                        return false;
                    }
                }
                if (this.model.dragArea) this._setDragArea();
                else {
                    this._left = this._top = this._right = this._bottom = 0;
                    this["border-top-width"] = this["border-left-width"] = 0;
                }
                
                var pos= dragTargetElmnt.offsetParent().offset();
                $(document).off(ej.eventType.mouseMove, this._dragStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                    .on(ej.eventType.mouseMove, this._dragHandler).on(ej.eventType.mouseUp, this._dragStopHandler).on("mouseleave", this._dragMouseOutHandler).on("selectstart", false);
                ej.widgetBase.droppables[this.model.scope] = {
                    draggable: this.element,
                    helper: dragTargetElmnt.css({ position: 'absolute',  left: (this.position.left-pos.left), top: (this.position.top-pos.top) }),
                    destroy: this._destroyHandler
                }
            }
            }
        },

        _drag: function (e) {
            var left, top, pageX, pageY;
			e.preventDefault();
            this.position = this._getMousePosition(e);
            if (this.position.top < 0)
                this.position.top = 0;
            if ($(document).height() < this.position.top)
                this.position.top = $(document).height();
            if ($(document).width() < this.position.left)
                this.position.left = $(document).width();
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
            if (this.model.drag) {
                var currTarget = null;
                if (e.type == 'touchmove') {
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }
                else currTarget = e.originalEvent.target || e.target;
				if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0 )
                    currTarget = this._checkTargetElement(e)|| currTarget; 
                this._trigger("drag", { event: e, element: this.target, target: currTarget, currentTarget: this._getCurrTarget(e) });// Raise the dragging event
            }
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._over(e); 
                this._hoverTarget = element; 
            }
            else if (this._hoverTarget) {
                e.target = e.toElement = this._hoverTarget;
                this._hoverTarget.object._out(e);
                this._hoverTarget = null;
            }
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
			var pos= helperElement.offsetParent().offset();			 
            pageX = ej.isNullOrUndefined(e.pageX) ? e.originalEvent.changedTouches[0].pageX : e.pageX;
            pageY = ej.isNullOrUndefined(e.pageY) ? e.originalEvent.changedTouches[0].pageY : e.pageY;
            if (this.model.dragArea) {
                if (this._pageX != pageX) {
                    if (this._left > this.position.left) left = this._left;
                    else if (this._right < this.position.left + helperElement.outerWidth(true)) left = this._right - helperElement.outerWidth(true);
                    else left = this.position.left;
                }
                if (this._pageY != pageY) {
                    if (this._top > this.position.top) top = this._top;
                    else if (this._bottom < this.position.top + helperElement.outerHeight(true)) top = this._bottom - helperElement.outerHeight(true);
                    else top = this.position.top;
                }
            }
            else {
                left = this.position.left;
                top = this.position.top;
            }
            if (top < 0 || top - [pos.top + this["border-top-width"]] < 0) top = [pos.top + this["border-top-width"]];
            if (left < 0 || left - [pos.left + this["border-left-width"]] < 0) left = [pos.left + this["border-left-width"]];
            helperElement.css({ left: left - [pos.left + this["border-left-width"]], top: top - [pos.top + this["border-top-width"]] });
            this.position.left = left;
            this.position.top = top;
            this._pageX = pageX;
            this._pageY = pageY;
        },

        _dragStop: function (e) {
            if (e.type == 'mouseup' || e.type == 'touchend') 
                this._destroy(e);
            if (this.model.dragStop) {
                var currTarget = null;
                if (e.type == 'touchend') {
                if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
				currTarget = e.originalEvent.target || e.target;  
                else{
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }  
                }
                else currTarget = e.originalEvent.target || e.target;                
                if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
                    currTarget = this._checkTargetElement(e) || currTarget;              
                this._trigger("dragStop", { event: e, element: this.target, target: currTarget, currentTarget: this._getCurrTarget(e) });// Raise the dragstop event
            }
            this._dragEnd(e);
        },
        _dragEnd: function (e) {
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._drop(e, this.element);
            }
        },

        _dragMouseEnter: function (e) {
            $(document).off("mouseenter", this._dragMouseEnterHandler);
            if (this._isIE9)
                this._dragManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._dragManualStop(e);
            }
            else if (e.buttons == 0)
                this._dragManualStop(e);
        },

        _dragManualStop: function (e) {
            if (this.model.dragStop != null)
                this._trigger("dragStop", { event: e, element: this.target, target: e.originalEvent.target || e.target, currentTarget: this._getCurrTarget(e) });  // Raise the dragstop event
            this._destroy(e);
        },

        _dragMouseOut: function (e) {
            $(document).on("mouseenter", this._dragMouseEnterHandler);
        },

        _checkTargetElement:function(e)
        {
            var target ;
			if (e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold") {
				var coor = e.originalEvent.changedTouches[0];
				target = document.elementFromPoint(coor.clientX, coor.clientY);
			}
			else
				target = e.target;
            if (this.helper && this._contains(this.helper[0], target)) {
                this.helper.hide();
                target = this._elementUnderCursor(e);
                this.helper.show();
                return this._withDropElement(target);
            }
            return this._withDropElement(target);
        },
        _getCurrTarget: function(e) {
            var target = (e.originalEvent && e.originalEvent.target) || e.target;
            if(!ej.isNullOrUndefined(target.style)){
            var styleVal = target.style.display;
            target.style.display = "none";
            var currTarget = document.elementFromPoint(e.pageX, e.pageY);
            target.style.display = styleVal;
            return currTarget;
            }
        },
        _withDropElement:function(target)
        {
            if (target) {
                var dropObj = $(target).data('ejDroppable');
                if (ej.isNullOrUndefined(dropObj)) dropObj = this._checkParentElement($(target));
                if (!ej.isNullOrUndefined(dropObj)) {
                    return $.extend(target, { object: dropObj });
                }
            }
        },
        _checkParentElement: function (element) {
            var target = $(element).closest('.e-droppable');
            if (target.length > 0) {
                var dropObj = $(target).data('ejDroppable');
                if (!ej.isNullOrUndefined(dropObj)) return dropObj;
            }
        },
        _elementUnderCursor:function(e){
            if(e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold")
                return document.elementFromPoint(e.originalEvent.changedTouches[0].clientX, e.originalEvent.changedTouches[0].clientY);
            else return document.elementFromPoint(e.clientX, e.clientY);
        },
        _contains:function(parent, child) {
            try {
                return $.contains(parent, child) || parent == child;
            } catch (e) {
                    return false;
                }
        },
        _wireEvents: function () {
			if(ej.isDevice()==true && this.model.dragOnTaphold==true)
            this._on(this.element, "taphold", this._initialize);
		else
            this._on(this.element, ej.eventType.mouseDown, this._initialize);
            this._dragStartHandler = $.proxy(this._dragStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._dragStopHandler = $.proxy(this._dragStop, this);
            this._dragHandler = $.proxy(this._drag, this);
            this._dragMouseEnterHandler = $.proxy(this._dragMouseEnter, this);
            this._dragMouseOutHandler = $.proxy(this._dragMouseOut, this);
        },
        _getMousePosition: function (event) {
            event = this._getCoordinate(event);
            var pageX = this.model.clone ? event.pageX : event.pageX - this._relXposition;
            var pageY = this.model.clone ? event.pageY : event.pageY - this._relYposition;
            return { left: pageX - [this.margins.left + this.model.cursorAt.left ], top: pageY - [this.margins.top + this.model.cursorAt.top ] };
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend" || evt.type== "taphold" && ej.browserInfo().name !="msie")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to drop the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejDroppable", "ej.Droppable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        dropElements : [],
        defaults: {
            
            accept: null,
            
            scope: 'default',
            
            drop: null,
            
            over: null,
            
            out: null,
			
			create: null,
            
            destroy: null
        },

        
        _init: function () {
            this._mouseOver = false;
			this.dropElements.push(this);
        },

        _setModel: function (options) {

        },
        
        
        _destroy: function () {
			 $(this.element).off('mouseup', $.proxy(this._drop, this));
        },

        _over: function (e) {
            if (!this._mouseOver) {
                this._trigger("over", e);
                this._mouseOver = true;
            }
        },
        _out: function (e) {
            if (this._mouseOver) {
                this._trigger("out", e);
                this._mouseOver = false;
            }
        },
        _drop: function (e, dragElement) {
			var _target = e.target; 
			var _parents = $(_target).parents(".e-droppable");
			if($(_target).hasClass("e-droppable")) _parents.push(_target);
			for (var i =0; i< this.dropElements.length; i++ ){
				if ($(_parents).is($(this.dropElements[i].element)))
					this.dropElements[i]._dropEvent.call( this.dropElements[i], e, dragElement );
			}
        },
		_dropEvent : function (e, dragElement){
			var drag = ej.widgetBase.droppables[this.model.scope];
            var isDragged = !ej.isNullOrUndefined(drag.helper) && drag.helper.is(":visible");
			if(isDragged && e.type == "touchend") $(drag.helper).hide();
            var area = this._isDropArea(e);
			if(isDragged && e.type == "touchend") $(drag.helper).show();
            if (drag && !ej.isNullOrUndefined(this.model.drop) && isDragged && area.canDrop) {
                this.model.drop($.extend(e, { dropTarget: area.target , dragElement : dragElement }, true), drag);
            }
		},
        _isDropArea: function (e) {
            // check for touch devices only
            var area = { canDrop: true, target: $(e.target) };
            if (e.type == "touchend") {
                var coor = e.originalEvent.changedTouches[0], _target;
                _target = document.elementFromPoint(coor.clientX, coor.clientY);
                area.canDrop = false;
                var _parents = $(_target).parents();

                for (var i = 0; i < this.element.length; i++) {
                    if ($(_target).is($(this.element[i]))) area = { canDrop: true, target: $(_target) };
                    else for (var j = 0; j < _parents.length; j++) {
                        if ($(this.element[i]).is($(_parents[j]))) {
                            area = { canDrop: true, target: $(_target) };
                            break;
                        }
                    }
                    if (area.canDrop) break;
                }
            }
            return area;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to resize the Html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejResizable", "ej.resizable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        
        defaults: {
            
            scope: 'default',
            
            handle: null,
            
            distance: 1,
            
            maxHeight: null,
            
            maxWidth: null,
            
            minHeight: 10,
            
            minWidth: 10,
            
            cursorAt: { top: 1, left: 1 },
            
            resizeStart: null,
            
            resize: null,
            
            resizeStop: null,
			
			create: null,
            
            destroy: null,
            
            helper: function () {
                return $('<div class="e-resize-helper" />').html("resizable").appendTo(document.body);
            }
        },
        
        _init: function () {
            this.target = this.element;
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            if (this.handle != null) {
                $(this.target).delegate(this.handle, ej.eventType.mouseDown, $.proxy(this._mousedown, this))
                .delegate(this.handle, 'resizestart', this._blockDefaultActions);
            }
            else {
                $(this.target).on(ej.eventType.mouseDown, $.proxy(this._mousedown, this));                                
            }
            this._resizeStartHandler = $.proxy(this._resizeStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._resizeStopHandler = $.proxy(this._resizeStop, this);
            this._resizeHandler = $.proxy(this._resize, this);
            this._resizeMouseEnterHandler = $.proxy(this._resizeMouseEnter, this);
        },
        _mouseover: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                $(e.target).css({ cursor: "se-resize" });
                $(this.target).on(ej.eventType.mouseDown, $.proxy(this._mousedown, this));
            }
            else {
                $(this.target).off(ej.eventType.mouseDown);
                $(this.target).css({ cursor: "" });
            }
        },
        _blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },
        _setModel: function (options) {

        },
        _mousedown: function (e) {
            var ori = e;
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            this._pageX = e.pageX;
            this._pageY = e.pageY;

            $(document).on(ej.eventType.mouseMove, this._resizeStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);

            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
            return false;
        },

        _resizeStart: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                e = this._getCoordinate(e);
                var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY, _width, _height;
                var distance = Math.sqrt((x * x) + (y * y));
                if (distance >= this.model.distance) {
                    if (this.model.resizeStart != null) 
                        if (this._trigger("resizeStart", { event: e, element: this.target }))  // Raise the resize start event
                            return;
                    var resizeTargetElmnt = this.model.helper({ element: this.target });
                    _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
                    _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
                    this._pageX = e.pageX;
                    this._pageY = e.pageY;
                    var pos = this.getElementPosition(resizeTargetElmnt);
                    $(document).off(ej.eventType.mouseMove, this._resizeStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                        .on(ej.eventType.mouseMove, this._resizeHandler).on(ej.eventType.mouseUp, this._resizeStopHandler).on("mouseenter", this._resizeMouseEnterHandler).on("selectstart", false);
                    ej.widgetBase.resizables[this.scope] = {
                        resizable: this.target,
                        helper: resizeTargetElmnt.css({ width: _width, height: _height }),
                        destroy: this._destroyHandler
                    }
                }
            }
        },

        _resize: function (e) {
            var _width, _height, _diff;
            e = this._getCoordinate(e);
            var pos = this.getElementPosition(ej.widgetBase.resizables[this.scope].helper);
            var resizeTargetElmnt = this.model.helper({ element: this.target });
            _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
            _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
            this._pageX = e.pageX;
            this._pageY = e.pageY;
            if (_width < this.model.minWidth) {
                _diff = this.model.minWidth - _width;
                _width = this.model.minWidth;
                this._pageX = e.pageX + _diff;
            }
            if (_height < this.model.minHeight) {
                _diff = this.model.minHeight - _height;
                _height = this.model.minHeight;
                this._pageY = e.pageY + _diff;
            }
            if (this.model.maxHeight != null && _height > this.model.maxHeight) {
                _diff = _height - this.model.maxHeight;
                _height = this.model.maxHeight;
                this._pageY = e.pageY - _diff;
            }
            if (this.model.maxWidth != null && _width > this.model.maxWidth) {
                _diff = _width - this.model.maxWidth;
                _width = this.model.maxWidth;
                this._pageX = e.pageX - _diff;
            }
            ej.widgetBase.resizables[this.scope].helper.css({ width: _width, height: _height });
            this._trigger("resize", { element: this.target }) // Raise the resize event
        },

        _resizeStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            if (e.type == 'mouseup' || e.type == 'touchend')
                this._destroy(e);
        },

        _resizeMouseEnter: function (e) {
            if (this._isIE9)
                this._resizeManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._resizeManualStop(e);
            }
            else if (e.buttons == 0)
                this._resizeManualStop(e);
        },

        _resizeManualStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            this._destroy(e);
        },

        
        _destroy: function (e) {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._resizeStopHandler)
                .off(ej.eventType.mouseMove, this._resizeStartHandler)
                .off(ej.eventType.mouseMove, this._resizeHandler)
                .off("mouseenter", this._resizeMouseEnterHandler)
                .off('selectstart', false);            
            ej.widgetBase.resizables[this.scope] = null;
            
        },

        getElementPosition: function (elemnt) {
            if (elemnt != null && elemnt.length > 0)
                return {
                    left: elemnt[0].offsetLeft,
                    top: elemnt[0].offsetTop
                };
            else
                return null;
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);;

/**
* @fileOverview Plugin to style the Html ScrollBar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScrollBar", "ej.ScrollBar", {
        defaults: {

            orientation: "horizontal",

            viewportSize: 0,

            height: 18,

            width: 18,

            smallChange: 57,

            largeChange: 57,

            value: 0,

            maximum: 0,

            minimum: 0,

            buttonSize: 18,

            infiniteScrolling: false
        },
        validTags: ["div"],
        type: "transclude",
        dataTypes: {
            buttonSize: "number",
            smallChange: "number",
            largeChange: "number",
        },
        observables: ["value"],
        value: ej.util.valueFunction("value"),
        _enabled: true,
        content: function () {
            if (!this._content || !this._content.length) {
                if (this.model.orientation === "horizontal") {
                    this._content = this.element.find(".e-hhandle");
                }
                else {
                    this._content = this.element.find(".e-vhandle");
                }
            }
            return this._content;
        },
        _init: function () {
            this.element.addClass("e-widget");
            this._ensureScrollers();
            this.content();
            this._setInitialValues();

        },

        _setInitialValues: function () {
            var xy = "X";
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                this.element.addClass("e-hscrollbar");
            }
            else {
                this.element.addClass("e-vscrollbar");
                xy = "Y";
            }
            if (this.value() !== 0 || this.model.minimum !== 0) {
                if (this.value() < this.model.minimum)
                    this.value(this.model.minimum);
                this["scroll"](this.value(), "none");
            }
        },

        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }
            var d2;
            if (!this._scrollData) {
                if (this.model.orientation === "vertical") {
                    this._scrollData = this._createScroller("Height", "Y", "Top", "e-v");
                }
                else {
                    this._scrollData = this._createScroller("Width", "X", "Left", "e-h");
                }
            }
        },

        _setModel: function (option) {
            for (var prop in option) {
                if (prop === "value") {
                    if (this.value()) {
                        this.scroll(this.value(), "none");
                    }
                } else {
                    this.refresh();
                    break;
                }
            }
        },

        _createScroller: function (dimension, xy, position, css) {
            var height;
            var d = {};
            var jqVersion = $.fn.jquery;
            d.dimension = dimension;
            d.xy = xy;
            d.position = position;
            d.css = css;
            d.uDimension = dimension;

            this._calculateLayout(d);
            this._createLayout(d);
            var buttons = this[d.main].find(".e-button");

            this._off(buttons, "mousedown")
                ._on(buttons, "mousedown", { d: d, step: 1 }, this._spaceMouseDown);
            this._off(this[d.scroll], "mousedown")
                ._on(this[d.scroll], "mousedown", { d: d }, this._spaceMouseDown);
            this._off(this[d.handler], "mousedown touchstart")
                ._on(this[d.handler], "mousedown touchstart", { d: d }, this._mouseDown);

            return d;
        },
        _createLayout: function (d) {
            var divString = "<div class='" + d.css + "{0}' style='" + d.dimension + ":{1}px'>{2}</div>";
            var jqVersion = $.fn.jquery;
            var lit = {}, height;
            lit[d.dimension] = d.modelDim;

            var el = ej.buildTag(
                "div." + d.css + "scroll e-box",
                    String.format(divString, "up e-chevron-up_01 e-icon e-box e-button", d.buttonSize) +
                    String.format(divString, "handlespace", d.handleSpace,
                        String.format(divString, "handle e-box e-pinch", d.handle)) +
                    String.format(divString, "down e-chevron-down_01 e-icon e-box e-button", d.buttonSize),
                lit
            );

            this.element.append(el);
            this.element.find('.e-vhandle').addClass("e-v-line e-icon");
            this.element.find('.e-hhandle').addClass("e-h-line e-icon");
            jqVersion === "1.7.1" || jqVersion === "1.7.2" ? height = d.uDimension.toLowerCase() : height = "outer" + d.uDimension;
            this[d.handler] = this.element.find("." + d.handler);
            this[d.handler].css("transition", "none");
            this[d.scroll] = this[d.handler].parent();
            this[d.main] = this[d.scroll].parent();
            this[d.main].find(".e-button")["outer" + d.uDimension](d.buttonSize);
        },
        _calculateLayout: function (d) {
            d.scrollDim = "scroll" + d.dimension;
            d.lPosition = d.position.toLowerCase();
            d.clientXy = "page" + d.xy;
            d.scrollVal = "scroll" + d.position;
            d.scrollOneStepBy = this.model.smallChange;
            d.modelDim = this.model[(d.dimension = d.dimension.toLowerCase())];
            d.handler = d.css + "handle";
            d.buttonSize = this.model.buttonSize;
            d.main = d.css + "scroll";
            d.scroll = d.css + "ScrollSpace";
            d.handleSpace = d.modelDim - 2 * d.buttonSize;
            d.scrollable = (this.model.maximum - this.model.minimum);
            var trackLength = this.model.height;
            if (this.model.orientation === "horizontal")
                trackLength = this.model.width;
            d.handle = (this.model.viewportSize / ((this.model.maximum - this.model.minimum) + this.model.viewportSize)) * (trackLength - 2 * this.model.buttonSize);
            var check;
            !ej.isNullOrUndefined(this.model.elementHeight) && typeof this.model.elementHeight === "string" && this.model.elementHeight.indexOf("%") != -1 ? check = true : check = false;
            if (d.handle < 20 && !check) d.handle = 20;
            d.onePx = d.scrollable / (d.handleSpace - d.handle);
            d.fromScroller = false;
            d.up = true;
            d.vInterval = undefined;
        },
        _updateLayout: function (d) {
            this.element.height(this.model.height);
            this.element.width(this.model.width);
            var handle = this.element.find("." + d.css + "handle");
            var handleSpace = this.element.find("." + d.css + "handlespace");
            var size = d.dimension == "width" ? handle.css('left') : handle.css('top');
            var dimension = d.dimension == "width" ? handleSpace.outerWidth() : handleSpace.outerHeight();
            if (size !== undefined && size !== "auto") {
                if (!(dimension >= d.handle + parseFloat(size)))
                    if (this.model.enableRTL) handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle));
                    else handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle) > 0 ? (parseFloat(dimension) - d.handle) : 0);
            }
            this.element.find("." + d.css + "scroll").css(d.dimension, d.modelDim + "px")
                .find(".e-button").css(d.dimension, this.model.buttonSize).end()
                .find("." + d.css + "handlespace").css(d.dimension, d.handleSpace + "px")
                .find("." + d.css + "handle").css(d.dimension, d.handle + "px");
        },
        refresh: function () {
            this._ensureScrollers();
            if (this.value()) {
                this.scroll(this.value(), "none");
            }
            if (this._scrollData) {
                this._calculateLayout(this._scrollData);
                this._updateLayout(this._scrollData);
            }
        },

        scroll: function (pixel, source, triggerEvent, e) {
            var dS = this._scrollData;
            if (!triggerEvent) {
                if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollLeft: pixel, originalEvent: e }))
                        return;
                }
                else {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollTop: pixel, originalEvent: e }))
                        return;
                }
            }
            if (this._scrollData) {
                if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie")
                    this.value(-dS.scrollable + pixel);
                else {
                    if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie") this.value(-1 * pixel);
                    else this.value(pixel);
                }
                if (this.content().length > 0) {
                    if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                        var left = (this.element.find('.e-hhandlespace').width() - this.element.find('.e-hhandle').outerWidth());
                        pixel = left < ((pixel - this.model.minimum) / this._scrollData.onePx) ? left : ((pixel - this.model.minimum) / this._scrollData.onePx);
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie") {
                            pixel = left - pixel;
                            pixel > 0 ? pixel = pixel * -1 : pixel;
                        }
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie") pixel = -pixel;
                        this._scrollData.enableRTL && pixel > 0 && !this._scrollData._scrollleftflag ? pixel = 0 : pixel
                        if (this._scrollData._scrollleftflag) {

                            pixel > 0 ? pixel = pixel * -1 : pixel;
                            this.value(pixel);
                        }
                        this.content()[0].style.left = pixel + "px";
                        this._scrollData._scrollleftflag = false;
                    }
                    else {
                        var top = (this.element.find('.e-vhandlespace').height() - this.element.find('.e-vhandle').outerHeight());
                        pixel = top < ((pixel - this.model.minimum) / this._scrollData.onePx) ? top : ((pixel - this.model.minimum) / this._scrollData.onePx);
                        if (ej.browserInfo().name == "msie" && isNaN(pixel)) pixel = "";
                        this.content()[0].style.top = pixel + "px";
                    }
                }
            }
        },

        _changeTop: function (d, step, source) {
            var start, t;
            if (d.dimension === "height")
                start = this.value();
            else
                start = this.value();
            t = start + step;
            d.step = step;
            if ((d.enableRTL && step < 0) || (step > 0 && !d.enableRTL)) {
                if (d.enableRTL) {
                    if (t < this.model.maximum * -1)
                        t = this.model.maximum * -1;
                }
                else {
                    if (t > this.model.maximum)
                        t = this.model.maximum;
                }
            }
            else {
                if (d.enableRTL) {
                    if (t > this.model.minimum)
                        t = this.model.minimum;
                }
                else {
                    if (t < this.model.minimum)
                        t = this.model.minimum;
                }
            }
            if (t !== start || this.model.infiniteScrolling) {
                this["scroll"](t, source);
            }
            return t !== start;
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            clearInterval(d.vInterval);
            if (e.type == "touchend") $(e.target).removeClass("e-touch");
            if (e.type === "mouseup" || e.type === "touchend" || (!e.toElement && !e.relatedTarget && !e.target)) {
                this._prevY = this._d = this._data = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._mouseUp, this));
                d.fromScroller = false;
                this[d.scroll].off("mousemove");
                this[d.handler].off("mousemove").css("transition", "");
                if (e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                }
            }
            d.up = true;
        },


        _mouseDown: function (down) {
            if (!this._enabled) return;
            this._d = down;
            this._data = this._d.data.d,
            this._data.target = this._d.target;
            this._data.fromScroller = true;
            this[this._data.handler].css("transition", "none");
            this._on($(document), "mousemove touchmove", { d: this._data, source: "thumb" }, this._mouseMove);
            this._trigger("thumbStart", { originalEvent: this._d, scrollData: this._data });
            $(document).one("mouseup touchend", { d: this._data, source: "thumb" }, ej.proxy(this._mouseUp, this));
            if (down.type == "touchstart") $(down.target).addClass("e-touch");
        },
        _mouseCall: function (move) {
            move.type = "mouseup";
            this._mouseUp(move);
        },
        _mouseMove: function (move) {
            var value, step = 0, top = parseInt(this[this._data.handler].css(this._data.lPosition)) || 0;
            move.preventDefault();
            var skip = 1;
            if (ej.isNullOrUndefined(move.target.tagName)) {
                if ($(move.target).is(document)) {
                    this._mouseCall(move);
                    return;
                }
            }
            else if (move.target.tagName.toLowerCase() === "iframe") { this._mouseCall(move); return; }
            var pageXY = move.type == "mousemove" ? move[this._data.clientXy] : move.originalEvent.changedTouches[0][this._data.clientXy];
            if (this._prevY && pageXY !== this._prevY) {
                step = (pageXY - this._prevY);
                if (this.model.infiniteScrolling) {
                    top = top + step;
                    this._data.step = step;
                    if (this._data.enableRTL ? top > 0 : top < 0) top = 0;
                    if ((top * (this._data.enableRTL ? -1 : 1)) + this._data.handle >= this._data.handleSpace)
                        top = (this._data.handleSpace - this._data.handle) * (this._data.enableRTL ? -1 : 1);
                    value = Math.ceil(top * this._data.onePx);
                    this["scroll"](value, "thumb");
                }
                else {
                    value = step * this._data.onePx;
                    this._changeTop(this._data, value, "thumb", this._d);
                }
                this._trigger("thumbMove", { originalEvent: move, scrollData: this._data });
            }
            if (skip === 1)
                this._prevY = pageXY;
        },

        _spaceMouseDown: function (e) {
            if (!e.data || !this._enabled) return;
            var d = e.data.d;
            if (e.which !== 1 || e.target === this[d.handler][0]) return;
            var step = e.data.step ? this.model.smallChange : this.model.largeChange, hTop = e.data.top || this[d.handler].offset()[d.lPosition];
            e[d.clientXy] = e[d.clientXy] || 0;
            if (e[d.clientXy] < hTop) step *= -1;
            d.target = e.target;
            this._changeTop(d, step, step === 3 ? "track" : "button", e);
            if (e.data.step !== 1) {
                this[d.scroll].mousemove(function () {
                    d.up = true;
                });
            }
            d.up = false;
            d.vInterval = setInterval(ej.proxy(function () {
                if (step < 0 ? hTop + (step / d.onePx) < e[d.clientXy] : hTop + d.handle + (step / d.onePx) > e[d.clientXy])
                    d.up = true;
                if (d.up) {
                    clearInterval(d.vInterval);
                    return;
                }
                this._changeTop(d, step, step === 3 ? "track" : "button", e);
                e.data ? hTop = e.data.top || this[d.handler].offset()[d.lPosition] : hTop = this[d.handler].offset()[d.lPosition];
            }, this), 150);

            $(document).one("mouseup", { d: d }, ej.proxy(this._mouseUp, this));
            $(document).mouseout({ d: d }, ej.proxy(this._mouseUp, this));
        },

        _remove: function () {
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal)
                this.element.find(".e-hscroll").remove();
            if (this.model.orientation === ej.ScrollBar.Orientation.Vertical)
                this.element.find(".e-vscroll").remove();
            this._scrollData = null;
            this._content = null;
        },

        _destroy: function () {
            this.element.remove();
        },
    });

    ej.ScrollBar.Orientation = {
        Horizontal: "horizontal",
        Vertical: "vertical"
    };
})(jQuery, Syncfusion, window);;

/**
* @fileOverview Plugin to style the Html Scroller elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/


(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScroller", "ej.Scroller", {
        _addToPersist: ["scrollLeft", "scrollTop"],
        defaults: {

            height: 250,

            autoHide: false,

            animationSpeed: 600,

            width: 0,

            scrollOneStepBy: 57,

            buttonSize: 18,

            scrollLeft: 0,

            scrollTop: 0,

            targetPane: null,

            scrollerSize: 18,

            enablePersistence: false,

            enableRTL: undefined,

            enableTouchScroll: true,

            enabled: true,

            create: null,

            destroy: null,

            wheelStart: null,

            wheelMove: null,

            wheelStop: null
        },
        validTags: ["div"],
        type: "transclude",

        dataTypes: {
            buttonSize: "number",
            scrollOneStepBy: "number"
        },
        observables: ["scrollTop", "scrollLeft"],
        scrollTop: ej.util.valueFunction("scrollTop"),
        scrollLeft: ej.util.valueFunction("scrollLeft"),

        keyConfigs: {
            up: "38",
            down: "40",
            left: "37",
            right: "39",
            pageUp: "33",
            pageDown: "34",
            pageLeft: "ctrl+37",
            pageRight: "ctrl+39"
        },

        content: function () {
            if (!this._content || !this._content.length || !this._content[0].offsetParent)
                this._content = this.element.children().first().addClass("e-content");

            return this._content;
        },
        _setFirst: true,
        _updateScroll: false,

        _init: function () {
            if (!ej.isNullOrUndefined(this.content()[0])) {
                this._prevScrollWidth = this.content()[0].scrollWidth, this._prevScrollHeight = this.content()[0].scrollHeight;
                this.element.addClass("e-widget");
                this.content();
                this._browser = ej.browserInfo().name;
                this._wheelStart = true;
                this._eleHeight = this.model.height;
                this._eleWidth = this.model.width;
                if (this.model.enableRTL === undefined) {
                    this.model.enableRTL = this.element.css("direction") === "rtl";
                }
                this._ensureScrollers();
                if (this.model.enableRTL) {
                    this.element.addClass("e-rtl");
                    this._rtlScrollLeftValue = this.content().scrollLeft();
                }
                this._on(this.content(), "scroll", this._scroll);
                this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
                if (this.scrollLeft())
                    this._setScrollLeftValue(this.scrollLeft());
                if (this.scrollTop())
                    this.content().scrollTop(this.scrollTop());

                if (this.model.autoHide) {
                    this._autohide();
                }
                if (this.model.enabled) {
                    this.enable();
                }
                else {
                    this.disable();
                }
                this._setDimension();
                if (this._prevScrollWidth !== this.content()[0].scrollWidth || this._prevScrollHeight !== this.content()[0].scrollHeight) this.refresh();
            }
            this._addActionClass();
        },
        _addActionClass: function () {
            //e-pinch class enables the touch mode operations in IE browsers
            if (this._browser == "msie") {
                this.content().removeClass('e-pinch e-pan-x e-pan-y');
                if (this._vScrollbar && this._hScrollbar) this.content().addClass('e-pinch');
                else if (this._vScrollbar && !this._hScrollbar) this.content().addClass('e-pan-x');
                else if (this._hScrollbar && !this._vScrollbar) this.content().addClass('e-pan-y');
            }
        },
        _setDimension: function () {
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1) {
                if (!this._vScroll) $(this.content()[0]).height("");
                else this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());
            }
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                if (!this._hScroll) $(this.content()[0]).width("");
                else this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), this.element.parent().width());
            }
        },
        _setScrollLeftValue: function (leftValue) {
            if (this.model.enableRTL) {
                if (ej.browserInfo().name == "mozilla")
                    leftValue = leftValue < 0 ? leftValue : (leftValue * -1);
                else if (!ej.isNullOrUndefined(this._rtlScrollLeftValue) && (ej.browserInfo().name == "chrome" || this._rtlScrollLeftValue > 0))
                    leftValue = leftValue < 0 ? (this._rtlScrollLeftValue + leftValue) : (this._rtlScrollLeftValue - leftValue);
                else
                    leftValue = Math.abs(leftValue);
            }
            this.content().scrollLeft(leftValue);
        },


        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
            this.model.height = typeof this.model.height == "string" && this.model.height.indexOf("px") != -1 ? parseInt(this.model.height) : this.model.height;
            this.model.width = typeof this.model.width == "string" && this.model.width.indexOf("px") != -1 ? parseInt(this.model.width) : this.model.width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }

            this._off(this.content(), "mousedown touchstart");
            if (this.content().length > 0) {
                if (this.isVScroll()) {
                    if (!this._vScrollbar) {
                        this._vScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Vertical, this.isHScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._vScrollbar = null;
                    this.element.children(".e-vscrollbar").remove();
                }
                if (this.isHScroll()) {
                    if (!this._hScrollbar) {
                        this._hScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Horizontal, this.isVScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._hScrollbar = null;
                    this.element.children(".e-hscrollbar").remove();
                }

                if (!this._vScrollbar && !this._hScrollbar)
                    this.content().css({ width: "auto", height: "auto" });

                if (!(this.element.find(".e-hscroll").length > 0)) {
                    if (this._vScrollbar) {
                        this.content().outerHeight(this.content().outerHeight() - 1);
                    }
                }
                jqVersion === "1.7.1" || jqVersion === "1.7.2" ? (this._contentHeight = "height", this._contentWidth = "width") : (this._contentHeight = "outerHeight", this._contentWidth = "outerWidth");
                this._hScroll = this.isHScroll(), this._vScroll = this.isVScroll();
                if (this._hScroll || this._vScroll) {
                    this.content().addClass("e-content");
                    var rect = this._exactElementDimension(this.element);
                    this._elementDimension(rect);
                    if(this.model.targetPane !== null && this.content().find(this.model.targetPane)[0] !== undefined) this.content().find(this.model.targetPane)[0].scrollLeft = this.scrollLeft();
                    if ((isNaN(this._eleWidth) && (this._eleWidth.indexOf("%") > 0)) && (isNaN(this._eleHeight) && (this._eleHeight.indexOf("%") > 0))) $(window).on('resize', $.proxy(this._resetScroller, this));
                } else
                    this.content().removeClass("e-content");
                this._setDimension();
                this._parentHeight = $(this.element).parent().height(); this._parentWidth = $(this.element).parent().width();
            }
        },
        _elementDimension:function(rect){
            this._ElementHeight = rect.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
            this.content()[this._contentHeight](this._ElementHeight - ((this._hScroll && !this.model.autoHide) ? this.model.scrollerSize :
             this.element.find(".e-hscrollbar").is(':visible') ? this.model.scrollerSize : 0));
            this._ElementWidth = rect.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
            this.content()[this._contentWidth](this._ElementWidth - ((this._vScroll && !this.model.autoHide) ? this.model.scrollerSize :
            this.element.find(".e-vscrollbar").is(':visible') ? this.model.scrollerSize : 0));
        },        
        _convertPercentageToPixel: function (ele, outer) {
            return Math.floor((ele * outer) / 100);
        },

        isHScroll: function () {
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1)
                return this.content()[0].scrollWidth > this.element.width();
            else {
                if (this.model.width > 0) {
                    var $paneObject = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $paneObject.length)
                        return ($paneObject[0].scrollWidth + $paneObject.siblings().width()) > this.model.width;
                    else {
                        if (this.content()[0].scrollWidth > this.model.width) return true;
                        else if (this.content()[0].scrollWidth == this.model.width)
                            if (this.model.autoHide && $(this.content()[0]).find('> *').length > 0) return $(this.content()[0]).find('> *')[0].scrollWidth > $(this.content()[0]).width();
                            else if ($(this.content()[0]).find('> *').length > 0) return $(this.content()[0]).find('> *')[0].scrollWidth > this.model.width;
                        return false;
                    }
                    return false;
                }
                return false;
            }
        },

        isVScroll: function () {
            //To avoid unnecessarilly render the vertical scrollbar for 1 or 2 px difference range.
            var border = 2;
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                return this.content()[0].scrollHeight > this.element.outerHeight(); //this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());        
            else if (this.model.height > 0) {
                if ((this.content()[0].scrollHeight > Math.ceil(this.model.height))) return true;
                else if (this.isHScroll()) if ((this.content()[0].scrollHeight == this.model.height || (this.content()[0].scrollHeight > this.model.height - (this.model.scrollerSize - border)))) return true;
            }
            return false;
        },
        _setModel: function (option) {
            for (var prop in option) {
                switch (prop) {
                    case "enableRTL":
                        if (option[prop]) {
                            this.element.addClass("e-rtl");
                            this._rtlScrollLeftValue = this.content().scrollLeft();
                            if (!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = true;

                        } else {
                            this.element.removeClass("e-rtl");
                            if (!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = false;
                        }
                        if (this._hScrollbar) {
                            this.element.find(".e-hhandle").css("left", 0);
                            this._hScrollbar.value(0);
                        }
                        break;
                    case "scrollLeft":
                        if (parseFloat(ej.util.getVal(option[prop])) < 0 || !this._hScroll) option[prop] = 0;
                        if (this._hScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        this._setScrollLeftValue(parseFloat(option[prop]));
                        this["scrollLeft"](option[prop]);
                        if (this._hScrollbar && !(this._hScrollbar._scrollData._scrollleftflag && this.model.enableRTL))
                            this.scrollX(option[prop], true);
                        break;
                    case "scrollTop":
                        if (this._vScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        if (parseFloat(option[prop]) < 0 || !this._vScroll) option[prop] = 0;
                        this.content().scrollTop(parseFloat(option[prop]));
                        this["scrollTop"](option[prop]);
                        this.scrollY(option[prop], true);
                        break;
                    case "touchScroll":
                        if (!this.model.enableTouchScroll)
                            this._off(this.content(), "mousedown touchstart");
                        else {
                            if (this._vScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                            if (this._hScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                        }
                        break;
                    case "scrollOneStepBy":
                        if (this._vScrollbar) {
                            this._vScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._vScrollbar.model.smallChange = option[prop];
                        }
                        if (this._hScrollbar) {
                            this._hScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._hScrollbar.model.smallChange = option[prop];
                        }
                        break;
                    case "buttonSize":
                        if (this._vScrollbar) this._vScrollbar.model.buttonSize = this.model.buttonSize;
                        if (this._hScrollbar) this._hScrollbar.model.buttonSize = this.model.buttonSize;
                        this.refresh();
                        break;
                    case "height": this._eleHeight = option[prop];
                        this.refresh();
                        break;
                    case "width": this._eleWidth = option[prop];
                        this.refresh();
                        break;
                    case "enabled":
                        if (!option[prop]) this.disable();
                        else this.enable();
                        break;
                    default:
                        this.refresh();
                }
            }
        },

        _createScrollbar: function (orientation, isOtherScroll) {
            var proxy = this;
            var id, viewportSize, width, height, maximum, value;
            var div = document.createElement("div");
            if (orientation === ej.ScrollBar.Orientation.Vertical) {
                width = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                    height = viewportSize = this.element.height() - (isOtherScroll ? this.model.scrollerSize : 0);
                else
                    height = viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                maximum = this.content()[0]["scrollHeight"];
                value = this.scrollTop();
            }
            else {
                width = viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                height = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                    width = viewportSize = this.element.width() - (isOtherScroll ? this.model.scrollerSize : 0);
                    maximum = this.content()[0]["scrollWidth"];
                }
                else {
                    var $pane = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $pane.length)
                        maximum = $pane[0]["scrollWidth"] + $pane.parent().width() - $pane.width();
                    else
                        maximum = this.content()[0]["scrollWidth"];
                }
                value = this.scrollLeft();
            }
            if (this.element.children(".e-hscrollbar").length > 0)
                $(this.element.children(".e-hscrollbar")).before(div);
            else
                this.element.append(div);
            $(div).ejScrollBar({
                elementHeight: proxy._eleHeight,
                elementWidth: proxy._eleWidth,
                buttonSize: proxy.model.buttonSize,
                orientation: orientation,
                viewportSize: viewportSize,
                height: height,
                width: width,
                maximum: maximum - viewportSize,
                value: value,
                smallChange: this.model.scrollOneStepBy,
                largeChange: 3 * this.model.scrollOneStepBy,
                scroll: ej.proxy(this._scrollChanged, this),
                thumbEnd: ej.proxy(this._thumbEnd, this),
                thumbStart: ej.proxy(this._thumbStart, this),
                thumbMove: ej.proxy(this._thumbMove, this),
            });
            var scrollbar = $(div).ejScrollBar("instance");
            (orientation === ej.ScrollBar.Orientation.Vertical || !isOtherScroll) && this._off(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", this._mouseWheel)
                ._on(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", { d: scrollbar._scrollData }, this._mouseWheel);
            if (orientation === ej.ScrollBar.Orientation.Horizontal) {
                this._scrollXdata = scrollbar._scrollData;
            }
            else
                this._scrollYdata = scrollbar._scrollData;
            if (orientation === ej.ScrollBar.Orientation.Horizontal && this.model.enableRTL) {
                scrollbar._scrollData.enableRTL = true;
            }
            scrollbar._enabled = this.model.enabled;
            return scrollbar;
        },

        _updateScrollbar: function (orientation, isOtherScroll) {
            var scrollbar = orientation === ej.ScrollBar.Orientation.Vertical ? this._vScrollbar : this._hScrollbar;
            if (scrollbar) {
                if (orientation === ej.ScrollBar.Orientation.Vertical) {
                    scrollbar.model.width = this.model.scrollerSize;
                    scrollbar.model.height = scrollbar.model.viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.maximum = this.content()[0]["scrollHeight"] - scrollbar.model.viewportSize;
                    scrollbar.model.value = this.scrollTop();
                }
                else {
                    scrollbar.model.width = scrollbar.model.viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.height = this.model.scrollerSize;
                    scrollbar.model.maximum = ((this.model.targetPane != null && this.content().find(this.model.targetPane).length > 0) ? this.content().find(this.model.targetPane)[0]["scrollWidth"] + (this.content().width() - $(this.model.targetPane).outerWidth()) : this.content()[0]["scrollWidth"]) - scrollbar.model.viewportSize;
                    if (!this.model.enableRTL)
                        scrollbar.model.value = this.scrollLeft();
                }
            }
        },

        _autohide: function () {
            if (this.model.autoHide) {
                this.element.addClass("e-autohide");
                this._on(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").hide();
				this._elementDimension(this._exactElementDimension(this.element));
            }
            else {
                this.element.removeClass("e-autohide");
                this._off(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").show();
            }
        },

        _scrollChanged: function (e) {
            this._updateScroll = true;
            if (e.scrollTop !== undefined)
                this.scrollY(e.scrollTop, true, "", e.source);
            else if (e.scrollLeft !== undefined)
                this.scrollX(e.scrollLeft, true, "", e.source);
            this._updateScroll = false;
            var proxy = this;
            $.when(this.content()).done(ej.proxy(function () {
                proxy._trigger("scrollEnd", { scrollData: e });
            }));
        },
        _bindBlurEvent: function (scrollObj, e) {
            this._scrollEle = $(scrollObj).data('ejScrollBar');
            this._event = e; var proxy = this;
            this._listener = function (e) {
                this._scrollEle._off($(document), "mousemove touchmove", this._scrollEle._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._scrollEle._mouseUp, this._scrollEle));
                this._scrollEle._prevY = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                this._off($(document), "mouseup touchend", this._mouseUp);
                this._off($(window), "blur");
                if (this._evtData.handler === "e-vhandle") this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
                else this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
            };
            this._on($(window), "blur", this._listener);
        },
        _thumbStart: function (e) {
            this._evtData = e.scrollData;
            var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar'); var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar');
            this._bindBlurEvent(scrollObj, e);
            this._trigger("thumbStart", e);
        },
        _thumbMove: function (e) {
            this._trigger("thumbMove", e);
        },
        _thumbEnd: function (e) {
            this._trigger("thumbEnd", e);
            this._off($(window), "blur");
        },

        refresh: function (needRefresh) {
            if (!needRefresh)
                this.element.find(">.e-content").removeAttr("style");

            if (!ej.isNullOrUndefined(this._eleHeight) && typeof this._eleHeight === "string" && this._eleHeight.indexOf("%") != -1 && this._parentHeight != $(this.element).parent().height()) {
                var element = this._exactElementDimension(this.element.parent());
                element = element.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
                this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), element);
            }
            if (!ej.isNullOrUndefined(this._eleWidth) && typeof this._eleWidth === "string" && this._eleWidth.indexOf("%") != -1 && this._parentWidth != $(this.element).parent().width()) {
                var element = this._exactElementDimension(this.element.parent());
                element = element.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
                this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), element);
            }

            this._ensureScrollers();
            var scrollLeftValue = this.scrollLeft();
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
                this._rtlScrollLeftValue = this.content().scrollLeft();
                scrollLeftValue > 0 ? this.content().scrollLeft(scrollLeftValue) : this._setScrollLeftValue(scrollLeftValue);
            }
            else
                this.content().scrollLeft(scrollLeftValue);
            if ((this.scrollTop() && ej.isNullOrUndefined(this._vScrollbar)) || (!ej.isNullOrUndefined(this._vScrollbar) && (this._vScrollbar && this._vScrollbar._scrollData != null) && !this._vScrollbar._scrollData.skipChange))
                this.content().scrollTop(this.scrollTop());

            if (this._vScrollbar) {
                this._vScrollbar._scrollData.dimension = "Height";
                this._updateScrollbar(ej.ScrollBar.Orientation.Vertical, this._hScroll);
                this._vScroll && !this._vScrollbar._calculateLayout(this._vScrollbar._scrollData) && this._vScrollbar._updateLayout(this._vScrollbar._scrollData);
            }
            if (this._hScrollbar) {
                this._hScrollbar._scrollData.dimension = "Width";
                this._updateScrollbar(ej.ScrollBar.Orientation.Horizontal, this._vScroll);
                this._hScroll && !this._hScrollbar._calculateLayout(this._hScrollbar._scrollData) && this._hScrollbar._updateLayout(this._hScrollbar._scrollData);
            }
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this.element.find(".e-hhandle").css("left", "0px");
            else
                this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
            this._addActionClass();
            this._autohide();
        },
        _exactElementDimension: function (element) {
            var rect = element.get(0).getBoundingClientRect(), direction = ["left", "right", "top", "bottom"], width, height;
            rect.width ? width = rect.width : width = rect.right - rect.left;
            rect.height ? height = rect.height : height = rect.bottom - rect.top;
            for (var i = 0; i < direction.length; i++) {
                this["border_" + direction[i]] = isNaN(parseFloat(element.css("border-" + direction[i] + "-width"))) ? 0 : parseFloat(element.css("border-" + direction[i] + "-width"));
                this["padding_" + direction[i]] = isNaN(parseFloat(element.css("padding-" + direction[i]))) ? 0 : parseFloat(element.css("padding-" + direction[i]));
            }
            return rect = { width: width, height: height };
        },
        _keyPressed: function (action, target) {
            if (!this.model.enabled) return;
            if (["input", "select", "textarea"].indexOf(target.tagName.toLowerCase()) !== -1)
                return true;

            var d, iChar;

            if (["up", "down", "pageUp", "pageDown"].indexOf(action) !== -1) {
                if (this._vScrollbar) {
                    if (ej.browserInfo().name == "msie" && this.model.allowVirtualScrolling)
                        this._content.focus();
                    d = this._vScrollbar._scrollData;
                }
                iChar = "o";
            } else if (["left", "right", "pageLeft", "pageRight"].indexOf(action) !== -1) {
                if (this._hScrollbar)
                    d = this._hScrollbar._scrollData;
                iChar = "i";
            } else return true;
            if (!d) return true;

            return !this._changeTop(d, (action.indexOf(iChar) < 0 ? -1 : 1) * (action[0] !== "p" ? 1 : 3) * d.scrollOneStepBy, "key");
        },

        scrollY: function (pixel, disableAnimation, animationSpeed, source, e) {
            var proxy = this;
            if (pixel === "") return;
            if (disableAnimation) {
                var e = { source: source || "custom", scrollData: this._vScrollbar ? this._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e };
                pixel = e.scrollTop;
                this.scrollTop(pixel);
                if (this._trigger("scroll", e)) return;
                this.content().scrollTop(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this._vScrollbar) pixel = parseFloat(pixel) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(pixel)
            this.scrollTop(pixel);
            this.content().stop().animate({
                scrollTop: pixel
            }, animationSpeed, 'linear', function () {
                if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._vScrollbar ? proxy._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e })) return;
            })
        },

        scrollX: function (pixel, disableAnimation, animationSpeed, source, e) {
            var proxy = this;
            if (pixel === "") return;
            if (this._hScrollbar) pixel = parseFloat(pixel) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(pixel)
            var browserName = ej.browserInfo().name;
            if (this.model.enableRTL && browserName != "mozilla") {
                if (pixel < 0) pixel = Math.abs(pixel);
                var content = this.model.targetPane != null ? this.content().find(this.model.targetPane)[0] : this.content()[0];
                if (e != "mousemove" && e != "touchmove" && (browserName != "msie")) if (browserName != "msie") pixel = this._hScrollbar._scrollData.scrollable - pixel;
            }
            this.scrollLeft(pixel);
            if (disableAnimation) {
                if (this._trigger("scroll", { source: source || "custom", scrollData: this._hScrollbar ? this._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e }))
                    return;
                if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                    this.content().find(this.model.targetPane).scrollLeft(pixel);
                else
                    this.content().scrollLeft(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                this.content().find(this.model.targetPane).stop().animate({
                    scrollLeft: pixel
                }, animationSpeed, 'linear');
            else this.content().stop().animate({
                scrollLeft: pixel
            }, animationSpeed, 'linear', function () {
                if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._hScrollbar ? proxy._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e })) return;
            });
        },

        enable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            if (scroller.hasClass("e-disable")) {
                scroller.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        disable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            scroller.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        _changeTop: function (d, step, source, e) {
            var start = Math.ceil(this.model.targetPane != null && d.dimension != "height" ? this.content().find(this.model.targetPane)[d.scrollVal]() : this.content()[d.scrollVal]()), t;

            if (d.dimension == "height" && start == 0)
                start = this.scrollTop() != 0 ? this.scrollTop() : 0;
            t = start + step;
            if (!d.enableRTL ? t > d.scrollable : t < d.scrollable) t = Math.round(d.scrollable);
            if (!d.enableRTL ? t < 0 : t > 0) t = 0;

            if (t !== start) {
                this["scroll" + d.xy](t, true, "", source, e);
                if (d.xy === "X" && !ej.isNullOrUndefined(this._hScrollbar))
                    this._hScrollbar["scroll"](t, source, true, e);
                else if (!ej.isNullOrUndefined(this._vScrollbar))
                    this._vScrollbar["scroll"](t, source, true, e);
            }

            return t !== start;
        },

        _mouseWheel: function (e) {
            if (this._vScrollbar && e.ctrlKey)
                return;
            if (!this._vScrollbar && !e.shiftKey)
                return;
            if (!e.data || !this.model.enabled) return;
            var delta = 0, data = e.data.d, ori = e, direction;
            e = e.originalEvent;
            this._wheelStart && this._trigger("wheelStart", { originalEvent: e, scrollData: ori.data.d });
            this._wheelStart = false;
            clearTimeout($.data(this, 'timer'));
            if (this._wheelx != 1 && (e.wheelDeltaX == 0 || e.wheelDeltaY == 0))
                this._wheelx = 1;
            if (navigator.platform.indexOf("Mac") == 0 && (this._wheelx == 0)) {
                if (this._browser == "webkit" || this._browser == "chrome")
                    return true;
            }
            if (this._browser == "mozilla")
                e.axis == e.HORIZONTAL_AXIS ? data = this._scrollXdata : this._scrollYdata;
            else if (this._browser == "msie") {
                if ((e.type == "wheel")) delta = e.deltaX / 120;
                if ((e.type == "mousewheel" && e.shiftKey)) {
                    data = this._scrollXdata;
                    e.preventDefault ? e.preventDefault() : (e.returnValue = false);
                }
            }
            else if (this._wheelx && e.wheelDeltaX != 0 && e.wheelDeltaY == 0 && this._scrollXdata)
                data = this._scrollXdata;
            if (e.wheelDeltaX == 0) this._wheelx = e.wheelDeltaX;
            if (e.wheelDelta) {
				delta = this._normalizingDelta(e);                
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) delta = e.detail / 3;
            if (!delta) return;
            if ((ori.originalEvent))
                if (ori.originalEvent.wheelDelta && ori.originalEvent.wheelDelta > 0 || ori.originalEvent.detail && ori.originalEvent.detail < 0) direction = -1;
                else direction = 1;
            if (this._changeTop(data, delta * data.scrollOneStepBy, "wheel", e)) {
                e.preventDefault ? e.preventDefault() : ori.preventDefault();
                ori.stopImmediatePropagation();
                ori.stopPropagation();
                this._trigger("wheelMove", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }
            else {
                this._trigger("scrollEnd", { originalEvent: e, scrollData: ori });
                this._wheelx = 0;
            }
            var proxy = this;
            $.data(this, 'timer', setTimeout(function () {
                proxy._wheelStart = true;
                proxy._trigger("wheelStop", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }, 250));
        },		
		
        _normalizingDelta: function (e) {
            var delta = navigator.platform.indexOf("Mac") == 0 ? -e.wheelDelta / 3 : -e.wheelDelta / 120;
            return delta;
		},
		
        _contentHeightWidth: function () {
            if (this.content().siblings().css("display") == "block" && this.model.autoHide) {
                this._hScroll && this.content()[this._contentHeight](this._ElementHeight - (this.model.scrollerSize));
                this._vScroll && this.content()[this._contentWidth](this._ElementWidth - (this.model.scrollerSize));
            }
            else if (this.content().siblings().css("display") == "none" && this.model.autoHide && (this._vScroll || this._hScroll)) {
                this.content()[this._contentHeight](this._ElementHeight);
                this.content()[this._contentWidth](this._ElementWidth);
            }
        },
        _scrollerHover: function (e) {
            if (this.model.enabled) {
                if ((e.type == "mouseenter" || e.type == "touchstart") && !this.content().siblings().is(":visible")) {
                    this.content().siblings().css("display", "block");
                    this._contentHeightWidth();
                    this._ensureScrollers();
                    this._setScrollLeftValue(this.model.scrollLeft);
                    this._trigger("scrollVisible", { originalEvent: e });
                }
                else if (e.type == "mouseleave" || e.type == "touchend") {
                    this.content().siblings().hide();
                    this._contentHeightWidth();
                    this._trigger("scrollHide", { originalEvent: e });
                }
            }
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            if (e.type === "mouseup" || e.type === "touchend" || (!e.toElement && !e.relatedTarget)) {
                this.content().css("cursor", "default");
                this._off($(document), "mousemove touchmove");
                this._off($(document), "mouseup touchend", this._mouseUp);
                d.fromScroller = false;
                if (this._mouseMoved === true && e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                    this._off($(window), "blur");
                }
            }
            d.up = true;
            window.ontouchmove = null;
        },

        _mouseDownOnContent: function (down) {
            this._startX = (down.clientX != undefined) ? down.clientX : down.originalEvent.changedTouches[0].clientX;
            this._startY = (down.clientY != undefined) ? down.clientY : down.originalEvent.changedTouches[0].clientY;
            this._timeStart = down.timeStamp || Date.now();
            if (!this.model.enabled) return;
            var d = down.data.d;
            this._evtData = down.data;
            var scrollObj = d.handler === "e-vhandle" ? this.element.find('.' + d.handler).closest('.e-scrollbar') : this.element.find('.' + d.handler).closest('.e-scrollbar');
            this._bindBlurEvent(scrollObj, down);
            if (this._trigger("thumbStart", { originalEvent: down, scrollData: d }))
                return;
            if (down.which == 3 && down.button == 2) return;
            d.fromScroller = true;
            var prevY = null, skip = 1, min = 5, direction;
            this._document = $(document); this._window = $(window);
            this._mouseMove = function (move) {
                if (this._startX + this._startY != move.clientX + move.clientY) {
                    this._relDisX = ((move.clientX != undefined) ? this._startx = move.clientX : this._startx = move.originalEvent.changedTouches[0].clientX) - this._startX;
                    this._relDisY = ((move.clientY != undefined) ? this._starty = move.clientY : this._starty = move.originalEvent.changedTouches[0].clientY) - this._startY;
                    this._duration = (move.timeStamp || Date.now()) - this._timeStart;
                    this._velocityY = Math.abs(this._relDisY) / this._duration;
                    this._velocityX = Math.abs(this._relDisX) / this._duration;
                    if (!ej.isNullOrUndefined(move.target.tagName) && move.target.tagName.toLowerCase() === "iframe") {
                        move.type = "mouseup";
                        this._mouseUp(move);
                        return;
                    }
                    var pageXY = move.type == "mousemove" ? move[d.clientXy] : move.originalEvent.changedTouches[0][d.clientXy];
                    if (prevY && pageXY !== prevY) {
                        this._mouseMoved = true;
                        var diff = pageXY - prevY, sTop = this.model[d.scrollVal] - (diff);

                        if (skip == 1 && Math.abs(diff) > min) {
                            direction = d.position;
                            skip = 0;
                        }
                        if (skip == 0) prevY = pageXY;

                        if (sTop >= 0 && sTop <= d.scrollable && direction === d.position) {
                            var top = this._velocityY > 0.5 && this._duration < 50 && d.position == "Top";
                            var left = this._velocityX > 0.5 && this._duration < 50 && d.position == "Left";
                            var swipeXY = ((this._velocityY > 0.5) || (this._velocityX > 0.5)) && this._duration < 50;
                            if (swipeXY) {
                                if (top) {
                                    sTop = Math.abs(this._relDisY) + (this._duration * this._velocityY);
                                    if (this._startY > this._starty) {
                                        sTop += this.scrollTop();
                                        if (sTop > d.scrollable) sTop = d.scrollable;
                                    }
                                    else {
                                        if (sTop < this.scrollTop()) sTop = Math.abs(sTop - this.scrollTop());
                                        if (sTop > this.scrollTop())
                                            sTop = 0;
                                    }
                                    if (this.scrollTop() <= d.scrollable) this["scrollY"](sTop, false, this.model.animationSpeed, "thumb");
                                }
                                else if (left) {
                                    sTop = Math.abs(this._relDisX);
                                    if (this._startX > this._startx) {
                                        sTop += this.scrollLeft();
                                        if (sTop > d.scrollable) sTop = d.scrollable;
                                    }
                                    else {
                                        sTop -= this.scrollLeft();
                                        sTop = Math.abs(sTop);
                                        if (sTop > d.scrollable || sTop >= this.scrollLeft()) sTop = 0;
                                    }
                                    if (this.scrollLeft() <= d.scrollable) this["scrollX"](sTop, false, this.model.animationSpeed, "thumb");
                                }
                            }
                            else {
                                this["scroll" + d.xy](sTop, true, "", "thumb", move.type);
                                if (d.xy === "X")
                                    this._hScrollbar["scroll"](sTop, "thumb", true, move.type);
                                else if (!ej.isNullOrUndefined(this._vScrollbar))
                                    this._vScrollbar["scroll"](sTop, "thumb", true, move.type);
                                this.content().css("cursor", "pointer");
                                this._trigger("thumbMove", { originalEvent: move, scrollData: d });
                            }
                        }
                    }
                    window.ontouchmove = function (e) {
                        e = e || window.event;
                        if (e.preventDefault) e.preventDefault();

                        e.returnValue = false;
                    }
                    if (prevY == null) prevY = pageXY;
                    if (Math.abs(this._relDisX) > Math.abs(this._relDisY))
                        this._swipe = (this._relDisX < 0) ? "left" : "right";
                    else
                        this._swipe = (this._relDisY < 0) ? "up" : "down";
                    if (((Math.round(this._content["scrollTop"]()) == 0) && this._swipe == "down" || ((Math.ceil(this._content["scrollTop"]()) == d.scrollable || Math.ceil(this._content["scrollTop"]()) + 1 == d.scrollable) && this._swipe == "up"))) {
                        this._trigger("scrollEnd", { originalEvent: move.originalEvent, scrollData: move });
                        window.ontouchmove = null;
                    }
                }
            }
            this._on($(document), "mousemove touchmove", { d: d, source: "thumb" }, this._mouseMove);
            this._mouseMoved = false;
            this._on($(document), "mouseup touchend", { d: d, source: "thumb" }, this._mouseUp);
        },

        _scroll: function (e) {
            var dS = [this._vScrollbar ? this._vScrollbar._scrollData : null, this._hScrollbar ? this._hScrollbar._scrollData : null];

            for (var i = 0; i < 2; i++) {
                var d = dS[i];
                if (!d || d.skipChange) continue;
                if (!this._externalCall) d.dimension === "height" ? this.scrollTop(e.target[d.scrollVal]) : this.scrollLeft(e.target[d.scrollVal])
                if (this.model && this.model.targetPane != null && i == 1 && this.content().find(this.model.targetPane).length)
                    d.sTop = this.content().find(this.model.targetPane)[0][d.scrollVal];
                else d.scrollVal == "scrollTop" ? d.sTop = this.scrollTop() : d.sTop = this.scrollLeft();
                this[d.scrollVal](d.sTop);
                if (d.fromScroller) return;
                if (i === 1) {
                    var content = this.content()[0];
                    if (this._rtlScrollLeftValue && content.scrollWidth - content.clientWidth != this._rtlScrollLeftValue)
                        this._rtlScrollLeftValue = content.scrollWidth - content.clientWidth;
                    d.sTop = (this.model && ej.browserInfo().name != "mozilla" && this.model.enableRTL && !this._hScrollbar._scrollData._scrollleftflag) ? (this._rtlScrollLeftValue == 0 ? (d.sTop * -1) : (d.sTop - this._rtlScrollLeftValue)) : d.sTop;
                    this._hScrollbar["scroll"](d.sTop, "", true);
                } else
                    this._vScrollbar["scroll"](d.sTop, "", true);
                if (dS.length == 2 && i == 1 || dS.length == 1 && i == 0){
                    this._externalScroller = false;
                    this.model && this._trigger('scroll', { source: "custom", scrollData: this._hScrollbar ? this._hScrollbar._scrollData : null, scrollLeft: this.scrollLeft(), originalEvent: e });
                }
            }
        },

        _changevHandlerPosition: function (top) {
            var scrollbar = this._vScrollbar;
            if (scrollbar) {
                top = scrollbar._scrollData != null && top >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : top;
                if (scrollbar != null && top >= 0 && top <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (top / scrollbar._scrollData.onePx) + "px");
            }
        },

        _changehHandlerPosition: function (left) {
            var scrollbar = this._hScrollbar;
            if (scrollbar) {
                left = scrollbar._scrollData != null && left >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : left;
                if (scrollbar != null && top >= 0 && left <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (left / scrollbar._scrollData.onePx) + "px");
            }
        },

        _destroy: function () {
            this.element.css({ "width": "", "height": "" }).find(".e-vscrollbar,.e-hscrollbar").remove();
            this.content().removeClass("e-content").css({ "width": "", "height": "" });
            this.element.removeClass("e-widget");
        },
        _preventDefault: function (e) {
            e = e || window.event;
            if (e.preventDefault) e.preventDefault();

            e.returnValue = false;
        }
    });
})(jQuery, Syncfusion, window);;
/**
* @fileOverview Plugin to style the Html NavigationDrawer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejNavigationDrawerBase", "ej.NavigationDrawerBase", {

        defaults: {

            contentId: null,

            cssClass: "",

            direction: "left",

            targetId: null,

            position: "normal",

            enableListView: false,

            listViewSettings: {},

            type: "overlay",

            width: "auto",

            swipe: null,

            open: null,

            beforeClose: null,

            items: [],

            ajaxSettings: {

				type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true

            },

            ajaxSuccess: null,

            ajaxError: null,

			ajaxComplete: null
        },

        dataTypes: {
            direction: "enum",
            type: "enum",
            ajaxSettings: "data"
        },

        loadContent: function (content ,link) {
            var proxy = this;
			if(link.indexOf("#") == 0) {
				var _link = $(link)[0] && $(link)[0].nodeName && $(link)[0].nodeName.toLowerCase() == "script" ? ej.getClearString($(link)[0].innerHTML) : link;
				if(_link != $(link)) {
					if($(_link).length != 0)
						this._scriptTemplate.push({id:link,data:$(_link)});
					else {
						var result = $.grep(this._scriptTemplate, function(e){ if(e.id == _link) return e.data; });
						_link = (result.length >0 )?result[0].data[0]:_link;
					}
				}
				$(content).html($(_link));
				this._hide();
			}
			else {
				var ajaxOptions = {

					url:link,

					"success": function (data) {
						try { 
							$(content).html(data);
                            proxy._trigger("ajaxSuccess", { data: data, url: link ,content: content});
							proxy._hide();
							
						}
						catch (e) { }
					},
					"error": function (e) {
						try { 
                            proxy._trigger("ajaxError", {data:{ "status": e.status, "responseText": e.responseText, "statusText": e.statusText },content: content,url: link});
							proxy._hide();
							}
						catch (e) { }
					},
					"complete": function (e) {
						 try {
							 proxy._trigger("ajaxComplete", {data:e, content: content, url: link });
                    } catch (e) {}
					}
				};
				this._sendAjaxRequest(ajaxOptions);
			}
        },
        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },
		_shadowWrapper: function () {
			if (!this.model.isPaneOpen) {
                this._elementOverlay = ej.buildTag("div#" + this._id + "_Overlay", {}, {}, { "class": this._rootCSS + " " + this._prefixClass + "nb-layout " + this._prefixClass + "nb-overlay" });
                this._elementShadow = ej.buildTag("div#" + this._id + "_shadow", {}, {}, { "class": this._rootCSS + " " + this._prefixClass + "nb-shadow " + "" + this._prefixClass + "nb-type-" + (this.model.type == "slide" ? "slide" : "overlay") });
                this._nbHome.append(this._elementOverlay);
                this._elementOverlay.hide();
                this.element.hide();
				this.element.prepend(this._elementShadow);
            }
		},
        _renderControl: function () {
            if (this.model.position.toLowerCase() == "fixed")
                this.element.appendTo(this._nbHome);
			this._shadowWrapper();
            this.element.addClass(this._prefixClass + "user-select" + " " + this.model.cssClass);
            this.element.addClass(this._prefixClass + 'nb-layout ' + (this.model.direction.toLowerCase() == "left" ? this._prefixClass + 'nb-left' : this._prefixClass + 'nb-right'));
            this.element.addClass(this._prefixClass + 'nb-type-' + (this.model.type == "slide" ? "slide" : "overlay"));
            this._maxIndex = this._getMaxZindex();
            this._parentWidth = this._nbHome.width();
            this._setWidth();
            this._setLayout();
        },
        _getMaxZindex: function () {
            return Math.max.apply(null, $.map($('body *'), function (e, n) {
                return parseInt($(e).css('z-index')) + 1 || 1;
            }));
        },
        _transform: function (dist, time, element) {
            var translate = "-" + this._browser + "-transform",
                translateVal = "translateX(" + dist + "px) translateZ(0px)";
            var trans = "-" + this._browser + "-transition-property",
            transVal = "transform",
            transDur = "-" + this._browser + "-transition-duration",
            transDurVal = time + "ms";
            if (element) {
                var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                if (this.model.position == "normal" && this.model.type=="slide")
                    $("#" + this._id + "_WrapContainer").addClass("e-nb-normal");
                this.element.addClass("" + this._prefixClass + "nb-animate" + " " + positionClass);
                this.element.css(trans, transVal).css(transDur, transDurVal).css(translate, translateVal);
				this.element.css("transition-property", transVal).css("transition-duration", transDurVal).css("transform", translateVal);
            }
            else {
                var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                if (this.model.position == "normal" && this.model.type == "slide")
                    $("#" + this._id + "_WrapContainer").addClass("e-nb-normal");
                this._nbHome.addClass(this._rootCSS + " " + this._prefixClass + "nb-animate" + " " + positionClass);
                this._nbHome.css(trans, transVal).css(transDur, transDurVal).css(translate, translateVal);
				this._nbHome.css("transition-property", transVal).css("transition-duration", transDurVal).css("transform", translateVal);
            }
        },

        _show: function () {
            if (!ej.isNullOrUndefined(this.element.css("left").match((/\d/g))) && (!Number(this.element.css("left").match((/\d/g))[0] < this.element.width()))) this._setLayout();
            if ($("." + this._prefixClass + "nb-opened").length && $("." + this._prefixClass + "nb-opened")[0] != this.element[0])
                $("." + this._prefixClass + "nb-opened").ejNavigationDrawer("close");
            this.element.show();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionOpenHandler, false, this);
            this.element.addClass("" + this._prefixClass + "nb-opened");
            this._elementOverlay.css("z-index", this._maxIndex * 2);
            this.element.css("z-index", this._maxIndex * 3);
            if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9))
                this.model.direction == "left" ? this._transform($(this.element).width(), 400, this._isTransitionElement()) : this._transform(-($(this.element).width()), 400, this._isTransitionElement());
            else
                $(this.element).show().animate({ "left": (this.model.direction == "left" ? "0px" : (this._parentWidth - $(this.element).width())) }, 400, $.proxy(this._transitionOpenEnd, this));
            this._data = { element: this.element };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : null;
            this._elementOverlay.show();
            this._trigger("open", this._data);
        },

        _hide: function () {
            this._elementOverlay.hide();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionCloseHandler, false, this);
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 9))
                this._transform(0, 400, this._isTransitionElement());
            else
                $(this.element).animate({ "left": (this.model.direction == "left" ? -($(this.element).width()) : this._nbHome.width()) }, 400, $.proxy(this._transitionCloseEnd, this));
        },
        _clearHomeElement: function () {
            var browSpec = "";
            if (this._browser != "")
                browSpec = '-' + this._browser + '-';
            var translate = browSpec + "transform";
            var trans = browSpec + "transition-property";
            var transDur = browSpec + "transition-duration";
            this._nbHome.css(translate, "").css(transDur, "").css(trans, "");
            var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
            this._nbHome.removeClass(this._rootCSS + " " + this._prefixClass + "nb-animate" + " " + positionClass);
        },

        _isOpened: function () {
            return this.element.hasClass("" + this._prefixClass + "nb-opened");
        },

        _isOtherOpened: function () {
            return $("." + this._prefixClass + "nb-opened").length;
        },

        _isTransitionElement: function () {
            return this.model.type == "overlay" ? true : false;
        },

        _isOrientationSupported: function () {
            return ("orientation" in window && "onorientationchange" in window);
        },

        _setWidth: function () {
            $(this._nbHome).width() < 500 ? this.element.css("maxwidth", "80%") : this.element.css("maxwidth", "40%");
            if (this.model.width != "auto" && Number(this.model.width) != 0)
                this.element.width(Number(this.model.width));
            this.element.height("100%");
        },

          _setLayout: function () {
            this.element.show();
            this.element.find('.' + this._prefixClass + 'list-container').removeClass("e-scroller");
            if (this.model.position == "fixed")
                this.element.css("min-height", window.innerHeight);
            if (this.model.direction.toLowerCase() == "left") {
                $("#" + this._id + "_WrapContainer").css({ right: "" }).removeClass("e-nb-right").addClass("e-nb-left");
                this.element.removeClass("e-nb-right").addClass("e-nb-left");
                if (!this.model.isPaneOpen) {
                    if (this.model.position == "normal")
                        this.element.css({ right: "", left: this.model.type == "overlay" ? (-(ej.getDimension(this.element, "width"))) : "0px" });
                    else
                        this.element.css({ right: "", left: (-(ej.getDimension(this.element, "width"))) });
                    if (this.model.type == "slide")
                        $("#" + this._id + "_WrapContainer").removeAttr("style").css({ left: (-(ej.getDimension(this.element, "width"))) })
                }
                else {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this.element.css({ "right": "", "left": this.model.position == "fixed" ? -ej.getDimension(this.element, "width") : 0 });
                    this._nbHome.css({ "width": this._nbHome.parent().width() - ej.getDimension(this.element, "width"), "left": ej.getDimension(this.element, "width"), "position": "absolute" }).addClass(positionClass);
                }
            }
            else {
                $("#" + this._id + "_WrapContainer").css({ left: "" }).removeClass("e-nb-left").addClass("e-nb-right");
                this.element.css({ left: "" }).removeClass("e-nb-left").addClass("e-nb-right");
                if (!this.model.isPaneOpen) {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this._nbHome.removeClass("e-nb-fixed-slide" + " " + positionClass);
                    $("#" + this._id + "_WrapContainer").removeClass("e-nb-left").addClass("e-nb-right");
                    if (this.model.type == "slide")
                        $("#" + this._id + "_WrapContainer").removeAttr("style").css({ right: "0px" });
                    if (this.model.position.toLowerCase() == "fixed" && this.model.type == "slide")
                        this._nbHome.addClass("e-nb-fixed-slide");
                    if (this.model.position.toLowerCase() == "fixed" && this.model.type == "overlay")
                        this.element.addClass(positionClass);
                    if (this.model.position.toLowerCase() == "normal")
                        this.element.css({ left: ej.getDimension(this.element, "width") });
                    else
                        this.element.css({ right: -ej.getDimension(this.element, "width") });
                }
                else {
                    var positionClass = this.model.position == "fixed" ? "e-nb-fixed" : "";
                    this._nbHome.css({"left": "","position":"", "width": ej.getDimension(this._nbHome.parent(), "width") - ej.getDimension(this.element, "width") }).addClass(positionClass);
                    this.element.css({ "left": "", "right": "0px" });
                }
            }
            if (!this._isOpened() && !this.model.isPaneOpen)
                this.element.hide();
        },

        _destroy: function (isSetModel) {
            this._wireEvents(true);
            if (this._elementOverlay)
                this._elementOverlay.remove();
            if (this._elementShadow)
                this._elementShadow.remove();
            if (this._elementWrapper) this.element.unwrap();
            this.element.removeAttr("style");
            this.element.css("left", "");
            this._destroyEJMPlugin();
            if(!isSetModel) this.element.removeClass("e-nb e-user-select e-nb-layout e-nb-left e-nb-type-overlay e-nb-animate e-nb-opened");
        },

        _refresh: function () {
            this._destroy(true);
            this._load();
            this._renderControl();
            this._renderEJMControls();
            this._createDelegate();
            this._wireEvents();
        },


        _createDelegate: function () {
            //Swipe Events Handler
            this._swipeStartHandler = $.proxy(this._swipeStart, this);
            this._swipeEndHandler = $.proxy(this._swipeEnd, this);
            this._swipeMoveHandler = $.proxy(this._swipeMove, this);
            //Touch Event Handler
            this._touchMoveHandler = $.proxy(this._touchMove, this);
            this._touchEndHandler = $.proxy(this._touchEnd, this);
            //Transition Event
            this._transitionOpenHandler = $.proxy(this._transitionOpenEnd, this);
            this._transitionCloseHandler = $.proxy(this._transitionCloseEnd, this);
            //Target Touch Event Handler
            this._overlayTapHandler = $.proxy(this._elementOverlayTap, this);
            //TargetButton Tap
            this._targetButtonTapHandler = $.proxy(this._targetButtonTap, this);
            // Size Event Handler
            this._onOrientationChangeHandler = $.proxy(this._onOrientationChangeEvent, this);
            this._onResizeEventHandler = $.proxy(this._onResizeEvent, this);
        },

        _wireEvents: function (remove) {
            if (!this.model.isPaneOpen || remove) {
                //Event Binding
                if (this.model.targetId) {
                    if (ej.getCurrentPage)
                        var ele = ej.getCurrentPage();
                    else
                        var ele = $("body");
                    ej.listenTouchEvent(ele.find("#" + this.model.targetId), (this._prefixClass == "e-" ? "click" : ej.endEvent()), this._targetButtonTapHandler, remove, this);
                }
                else {
                    if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8))
                        ej.listenTouchEvent(this._nbHome, ej.startEvent(), this._swipeStartHandler, remove, this);
                }
                //Ovelay Binding
                ej.listenTouchEvent(this._elementOverlay, ej.endEvent(), this._overlayTapHandler, remove, this);
            }
            if (this.model.isPaneOpen) {
                if (ej.isTouchDevice() && this._isOrientationSupported())
                    ej.listenTouchEvent(window, "orientationchange", this._onOrientationChangeHandler, remove, this);
                else
                    ej.listenTouchEvent(window, "resize", this._onResizeEventHandler, remove, this);
            }
        },
        _onResizeEvent: function (e) {
            var state;
            this.element.show();
            if (this._isOpened() && this.element.is(":visible") && !this.model.isPaneOpen) { state = "opened "; } else { state = "closed" }
            this._transform(0, 0, this._isTransitionElement());
            this.element.hide();
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            this._clearHomeElement();
            this._parentWidth = this._nbHome.width();
            this._setWidth();
            this._setLayout();
            if (state == "opened ") { this._show(); }
        },
        _onOrientationChangeEvent: function (e) {
            var state;
            this.element.show();
            if (this._isOpened() && this.element.is(":visible")) { state = "opened "; } else { state = "closed" }
            if (window.orientation == 0 || window.orientation == 180 || window.orientation == 90) { window.scrollTo(0, 0); }
            this._transform(0, 0, this._isTransitionElement());
            this.element.hide();
            this.element.removeClass("" + this._prefixClass + "nb-opened");
            this._parentWidth = this._nbHome.width();
            this._clearHomeElement();
            var proxy = this
            setTimeout(function () {
                proxy._setWidth();
                proxy._setLayout();
                if (state == "opened ") { proxy._show(); }
            }, 300);
        },
        _transitionCloseEnd: function () {
            if(!ej.isNullOrUndefined(this.element)) this.element.hide();
            this._clearHomeElement();
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionCloseHandler, true, this);
            if(this._lbObj)
                this.model.listViewSettings.selectedItemIndex = this._lbObj.model.selectedItemIndex;
        },
        _transitionOpenEnd: function () {
            if (!ej.isNullOrUndefined(this.element)) this.element.show();
            if (this._scrollbar)
                this._scrollbar.ejmScrollPanel("refresh");
            if (this._lbscrollbar)
                this._lbscrollbar.ejmScrollPanel("refresh");
            ej.listenTouchEvent((this._isTransitionElement() ? this.element : this._nbHome), ej.transitionEndEvent(), this._transitionOpenHandler, true, this);
        },

        _targetButtonTap: function (e) {
            e.preventDefault();
            if (!this._isOtherOpened()) this._show();
        },
        _elementOverlayTap: function (e) {
            ej.blockDefaultActions(e);
            this._data = { element: this.element };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
            this._trigger("beforeclose", this._data);
            this._hide();
        },

        _swipeStart: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            this._startSwipeOffsetX = point.clientX - this._nbHome.offset().left;
            this._startSwipeOffsetActualX = point.clientX;
            this._startSwipeOffsetY = point.clientY;
            this._containerX = this._isTransitionElement() ? this.element.offset().left : this._nbHome.offset().left;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, false, this);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._swipeEndHandler, false, this);
        },

        _swipeMove: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            if (!ej.isNullOrUndefined(this.element.css("left").match((/\d/g))) && Number(this.element.css("left").match((/\d/g))[0]) < this.element.width()) this._setLayout();
            if (this._startSwipeOffsetActualX && this._startSwipeOffsetActualX > (point.clientX)) { this._swipeDirection = "right"; }
            else { this._swipeDirection = "left"; }
            var allowOpDirection = this._isOpened() ? (this._swipeDirection != this.model.direction.toLowerCase() ? true : false) : false;
            if (!allowOpDirection) {
                if (this._swipeDirection == this.model.direction.toLowerCase() && !this._isOtherOpened()) {
                    ej.listenEvents([this._nbHome, this._nbHome, this._nbHome], [ej.moveEvent(), ej.endEvent()], [this._touchMoveHandler, this._touchEndHandler], false, this);
                }
                else {
                    ej.listenEvents([this._nbHome, this._nbHome, this._nbHome], [ej.moveEvent(), ej.endEvent()], [this._touchMoveHandler, this._touchEndHandler], true, this);
                }
            }
            else {
                if (this._startSwipeOffsetX && this._isOpened()) {
                    this._relativeX = point.clientX - this._startSwipeOffsetActualX;
                    this._relativeY = point.clientY - this._startSwipeOffsetY;
                    var leftPoint = (this.element.width() + this._relativeX) - (this.model.type.toLowerCase() == "overlay" ? this._nbHome.offset().left : 0);
                    if ($(point.target).hasClass("" + this._prefixClass + "nb-overlay")) {
                        if (this.model.direction == "left" ? -(this._relativeX) < this.element.width() : this._relativeX < this.element.width())
                            this._transform((this.model.direction == "left" ? leftPoint : -((this.element.width() - this._relativeX))), 0, this._isTransitionElement());
                    }
                }
            }
        },

        _swipeEnd: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, true, this);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._swipeEndHandler, true, this);
        },

        _touchMove: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._swipeMoveHandler, true, this);
            if (this._isTransitionElement()) { this._containerX = 0; }
            if (this._startSwipeOffsetX && !this._isOpened()) {
                this._relativeX = point.clientX - this._startSwipeOffsetX;
                this._relativeY = point.clientY - this._startSwipeOffsetY;
                if ((this.model.direction == "left" ? this._startSwipeOffsetX < 50 : this._startSwipeOffsetX > this._nbHome.width() - 50)) {
                    this.element.show();
                    var leftPoint = this.model.type.toLowerCase() == "slide" ? 0 : this._nbHome.offset().left;
                    if (this.model.direction == "left" ? this._relativeX - leftPoint < this.element.width() : this._relativeX - leftPoint > -(this.element.width())) {
                        !this._containerX || this.model.targetHome ? this._transform((this._containerX + this._relativeX) - leftPoint, 0, this._isTransitionElement()) : undefined;
                    }
                }
            }
        },

        _touchEnd: function (e) {
            var point = e.changedTouches ? e.changedTouches[0] : e;
            ej.listenTouchEvent(this._nbHome, ej.moveEvent(), this._touchMoveHandler, true, this);
            if (!this._isOpened() && !($.isFunction(ej.isIOS7) ? ej.isIOS7() : false)) {
                if (!this._containerX) {
                    this._relativeX = point.clientX - this._startSwipeOffsetX;
                    this._relativeY = point.clientY - this._startSwipeOffsetY;
                    if (this.model.direction == "left" ? this._startSwipeOffsetX < 50 : this._startSwipeOffsetX > this._nbHome.width() - 50) {
                        if (this._relativeX > 30 || this._relativeX < -30)
                            this._show();
                        else
                            this._hide();
                    }
                }
                else {
                    this._hide();
                }
            }
            this._data = { targetElement: this._nbHome, element: this.element, direction: this._swipeDirection };
            this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
            this._trigger("swipe", this._data);
            ej.listenTouchEvent(this._nbHome, ej.endEvent(), this._touchEndHandler, true, this);
            ej.listenTouchEvent(this._nbHome, "mouseleave", this._touchEndHandler, true, this);
        },

        open: function (e) {
            if (!this.model.isPaneOpen) {
                this._show();
            }
        },

        close: function (e) {
            if (!this.model.isPaneOpen) {
                this._data = { element: this.element };
                this.model.enableListView ? $.extend(this._data, { listview: this._lb }) : undefined;
                this._trigger("beforeClose", this._data);
                this._hide();
            }
        },

        toggle: function (e) {
            if (!this.model.isPaneOpen) {
                this._isOpened() ? this.close() : this.open();
            }
        }
    });

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html ListView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListViewBase", "ej.ListViewBase", {
        _addToPersist: ["selectedItemIndex", "checkedIndices"],
        defaults: {
            
            height: null,

            width: null,

            selectedItemIndex: -1,

            enableGroupList: false,
            
            enableAjax: false,
            
            enableCache: false,
            
            enablePersistence: false,
			
			ready: null,
            
            load: null,

            itemRequestCount: 5,

            totalItemsCount: 5,
			
            loadComplete: null,
            
            ajaxBeforeLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            ajaxComplete: null,

            ajaxSettings: {
                type: 'GET',
                cache: false,
                async: true,
                dataType: "html",
                contentType: "html",
                url: "",
                data: {}
            },
                                    
            renderTemplate: false,

            templateId: null,

            persistSelection: false,

            preventSelection: false,

            dataSource: [],

            query: null,

            allowVirtualScrolling: false,

            virtualScrollMode: "normal",

            showHeader: false,
			
			showHeaderBackButton: false,

            cssClass: "",

            headerTitle: "Title",

            headerBackButtonText: null,

            enableFiltering: false,

            enableCheckMark: false,

            checkedIndices :[],
			
			locale:"en-US"

        },

        observables: ["selectedItemIndex", "dataSource"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        dataSource: ej.util.valueFunction("dataSource"),
        checkedIndices: ej.util.valueFunction("checkedIndices"),

        _updateModelItems: function () {
            this.model.items = eval(this.model.items);
            var ang_attr = this.model.items;
            if (ang_attr.length) {
                var ul = ej.buildTag("ul.e-m-clearall");
                for (i = 0; i < ang_attr.length; i++) {
                    ang_attr[i].items = [];
                    var ang_li = ej.buildTag("li");
                    if (this.model.items[i].template)
                        ang_li.html(this.model.items[i].template);
                    if (!this.model.items[i].childId && this.model.items[i].href)
                        this.model.items[i].childId = ("page_" + parseInt(Math.random().toFixed(3) * 1000));
                    if (this.model.items[i].renderTemplate) {
                        if (!this._storedTemplate[i]) {
                            if (this.model.items[i].templateId) {
                                var ele = this._tempContent.find('#' + this.model.items[i].templateId).remove();
                                this._storedTemplate[i] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                            }
                            else
                                this._storedTemplate[i] = this.model.items[i].template;
                            this.model.items[i].templateId = this._storedTemplate[i];
                        }
                    }
                    if (this.model.fieldSettings)
                        this.model.fieldSettings = $.extend(this.defaults.fieldSettings, this.model.fieldSettings);
                    ul.append(ang_li);
                }
                this.element.append(ul)
            }
            else {
                var ul = this.element.find(">ul");
                var groupid = 1;
                for (var ulindex = 0; ulindex < ul.length; ulindex++) {
                    this._listitems = $(ul[ulindex]).find(">li");
                    for (var index = 0; index < this._listitems.length; index++) {
                        var element = this._listitems[index];
                        if ((ej.getAttrVal(element, "data-ej-primarykey") == null) && ($(element).find("ul").length)) {
                            var primaryKey = Math.round(Math.random() * 100);
                            $(element).attr("data-ej-primarykey", primaryKey);
                        }
                        else
                            primaryKey = "";
                        var groupTitle = ej.getAttrVal($(ul[ulindex]), "data-ej-grouplistitle") ? ej.getAttrVal($(ul[ulindex]), "data-ej-grouplistitle") : "GroupList" + groupid;
                        this.model.items.push(this._itemsObjectCollection($(this._listitems[index]), primaryKey, null, groupTitle));
                        this._nestedListitems = $(this._listitems[index]).find("ul >li");
                        for (var index1 = 0; index1 < this._nestedListitems.length; index1++) {
                            var element1 = this._nestedListitems[index1];
                            if ((ej.getAttrVal(element1, "data-ej-primarykey") == null) && ($(element1).find("ul").length)) {
                                var primaryKey = Math.round(Math.random() * 100);
                                $(element1).attr("data-ej-primarykey", primaryKey);
                            }
                            else
                                primaryKey = "";
                            var parentPrimaryKey = ej.getAttrVal($($(element1).parent()).closest("li"), "data-ej-primarykey");
                            this.model.items.push(this._itemsObjectCollection($(this._nestedListitems[index1]), primaryKey, parentPrimaryKey, groupTitle));
                        }
                    }
                    groupid++;
                }
            }
        },

        _load: function () {
            this._orgEle = this.element.clone();
            this._index = 0;
            this._items = [];
            this._dummyUl = [];
            this._virtualCount = 0;
            this._liItemHeight = 0;
            this._requestType = null;
            this._checkedValues = [];
            this._checkedValues = this.model.checkedIndices;
            this.model.id = this.element[0].id;
            if (this.model.allowVirtualScrolling && this.model.query != null) {
                this._savedQueries = this.model.query.clone();
            }
            if (this.model.load)
                this._trigger("load");
            this.model.fieldSettings = eval(this.model.fieldSettings);
            if (this.model.fieldSettings) {
                if (ej.DataManager && this._dataUrl instanceof ej.DataManager) {
                    if (!this._dataUrl.dataSource.offline && !(this._dataUrl.dataSource.json && this._dataUrl.dataSource.json.length > 0)) {
                        this._queryPromise(0, this, this.model.totalItemsCount, null);
                    }
                    else
                        this._queryPromise(0, this, this.model.totalItemsCount, null);
                }
            }
            if(!this.model.allowVirtualScrolling)
                    this._renderControl();
        },
        _loadVirtualData: function (args) {
            this._dummyUl=[];
            var list = this._renderLists();
            $.views.helpers({ _checkAjaxUrls: this._checkAjaxUrl, _checkImgUrls: this._checkImgUrl, _checkIsChecked: this._checkIsCheck, Object: this, ej: ej });           
            this.jsRender = ej.buildTag("script#" + this.model.id + "_Template", "", {}, { "type": "text/x-jsrender" }); //Template for parent item
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');          
            this.jsChildRender = ej.buildTag("script#" + this.model.id + "_ChildTemplate", "", {}, { "type": "text/x-jsrender" });  //Template for child item
            if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") var ulContainer = ej.buildTag("div");
            var ul = ej.buildTag("ul." + this._prefixClass + "childcontainer " + this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            list.addClass(this._prefixClass + "childli");
            ul[0].innerHTML = "{{for items}}" + list[0].outerHTML + "{{/for}}";             
            var result = args;
            if (result) {
                ul.empty().html($(this.jsRender).render(result));
                var _ulItems = ul.clone().find('li'), temp = "";
                if (this._initEJCheckBox) this._initEJCheckBox(ul);                     				               
                var proxy = this;
                for (var j =0; j < result.length; j++) {              
                    if (result[j] && result[j].attributes) {
                        $.each(result[j].attributes, function (i, attr) {
                            if (attr && attr.name.toLowerCase() == "class") temp = $(_ulItems[j]).attr('class');
                        });
                    }
                    if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                        var k = this.realUllength;	
                        if(this.model.enableCheckMark){
                            if($(this.element.find('li').eq(k).find('.e-chkbox-wrap')).length!=0){
                                var x=$(this.element.find('li').eq(k).find('.e-chkbox-wrap'))[0];
                                var checked = x.getAttribute("aria-checked")=="true" ? true : false;
                                $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox({ checked: checked });		
                            }
                            else{
                                var checked = false;
                                if(this._removeIndex!=j)
                                    $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox({ checked: checked });	
                                else 
                                    $(_ulItems[j]).find('.e-lv-check').remove();									
                            }																							 													 									
                        }
                        if($(_ulItems[j]).find('.e-lv-check').length !=0) $(_ulItems[j]).find('.e-lv-check').parent().addClass("e-lv-checkdiv");
                        this._dummyUl.push(_ulItems[j]);
                        this._removeEmptyElements();
                        this.scrollerObj.refresh();
                    }
                    else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                        if(this.model.enableCheckMark){																										 				
                            $($(_ulItems[j]).find(".e-lv-check")).ejCheckBox();												
                        }
                        $(_ulItems[j]).find('.e-lv-check').parent().addClass("e-lv-checkdiv");
                        this._lContainer.find('ul').append(_ulItems[j]);
                        this._removeEmptyElements();
                        this._lContainer.find('ul li.e-lastitem').removeClass(this._prefixClass + "lastitem");
                        this._lContainer.find('ul li:last').addClass(this._prefixClass + "lastitem");
                        this.scrollerObj.refresh();
                    }
                    this.realUllength+=1;
                }
            }
        },
        _removeEmptyElements:function()
        {
            this.eLi = this.element.find('li.' + this._prefixClass + 'list');
            this.eLi.removeEleEmptyAttrs();
            this.eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
        },

        _renderControl: function () {
            var proxy = this;
            this.element.addClass(this._prefixClass + "parentlv " + this.model.cssClass);
            this._lbEle = ej.buildTag("div." + this._rootCSS);
            this._lbEle.addClass("subpage");
            if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") var ulContainer = ej.buildTag("div." + this._prefixClass + "sub-list-container");
            this._lContainer = ej.buildTag("div." + this._prefixClass + "list-container#" + this.model.id + "_container");
            if (this._hasDataSource())
                var ul = this.element.find(">ul");
            else
                var ul = this.element.find("ul:first");
            if (this.model.showHeader) {
                var hdr = this._renderHeader(this.model.id, false , this.model.headerTitle, this.model.headerBackButtonText);
                this._lbEle.prepend(hdr);
            }
            if (this._hasDataSource() && !this.model.renderTemplate)
                this.element.empty();
            if (this.model.renderTemplate) {
                if (this.model.templateId) {
                    if (this._tempContent.find('#' + this.model.templateId).length) {
                        this._template = this._tempContent.find('#' + this.model.templateId);
                        ej.destroyWidgets(this._template);
                        if (this._template[0].nodeName.toLowerCase() != "script")
                            this._template.remove();
                        this._template = this._template[0].nodeName && this._template[0].nodeName.toLowerCase() == "script" ? ej.getClearString(this._template[0].innerHTML) : this._template[0].outerHTML;
                    }
                }
                else {
                    ej.destroyWidgets(this.element);
                    this._template = this.element.html();
                    this.element.empty();
                }
				this._lContainer.addClass(this._prefixClass+"template-list");
            }
            if (this.model.renderTemplate && !this._hasDataSource() && !this.model.enableGroupList) {
                this.element.append(this._lbEle.append(this._lContainer));
				$(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
                if (this._template) {
                    this._lContainer.append(this._template);
                    if (ej.widget.init)
                        ej.widget.init(this._lContainer);
                }
            }
            else if (!this.model.renderTemplate || this.model.renderTemplate && this._hasDataSource() || this.model.renderTemplate && this.model.enableGroupList) {
                this._model_index = 0;
                if (this.model.enableGroupList) {
                    this._lContainer.addClass(this._prefixClass + "grouped");
                    var innerDiv = ej.buildTag("div." + this._prefixClass + "grouplist");
                    ul = this.element.children();
                    if (ul.length || this.dataSource().length) {
                        if (this.dataSource().length)
                            var group = ej.DataManager(this.dataSource()).executeLocal(ej.Query().from(this.dataSource()).group(this.model.fieldSettings['groupID']));
                        else
                            var group = ej.DataManager(this.model.items).executeLocal(ej.Query().from(this.model.items).group(this.model.fieldSettings['groupID']));
                        var length = group.length;
                        var title;
                        for (var i = 0; i < length; i++) {
                            this._items = group[i].items;
                            if (this._hasDataSource()) {
                                ulItem = ej.buildTag('ul', "", {}, { "data-ej-grouplisttitle": group[i].key });
                                this._lbEle.append(ulItem);
                            }
                            else
                                ulItem = ul[i];
                            title = this._hasDataSource() ? group[i].key : ej.getAttrVal($(ulItem), 'data-ej-grouplisttitle', "GroupList" + (i + 1));
                            $(ulItem).attr("data-ej-grouplisttitle", title);
                            var groupdiv = ej.buildTag("div." + this._prefixClass + "groupdiv", ej.buildTag("div." + this._prefixClass + "grouptitle", title));
                            innerDiv.append(groupdiv.append(this._renderListItems($(ulItem).addClass(this._prefixClass + "grouped"))));
                        }
                    }
                    else if (this._template) {
                        ej.destroyWidgets(this._template);
                        innerDiv[0].innerHTML = this._template;
                    }
					this._lContainer.append(innerDiv);
                    if (ej.widget.init)
                        ej.widget.init(innerDiv);
                }
                else {
                    if (this._hasDataSource()) {
                        var ul = ej.buildTag('ul');
                        this._items = this.dataSource();
                        this._items = eval(this._items);
                        for (j = 0; j < this._items.length; j++) {
                            if (this._items[j].href && !this._items[j].childId) {
                                this._items[j].childId = ("page_" + parseInt(Math.random().toFixed(3) * 1000));
                            }
                        }
                    }
                    if (ul.length) {
                        ej.destroyWidgets(ul);
                        if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") {
                            ulContainer.append(this._renderListItems(ul));
                            $(ul).find('li').attr("data-ej-page",0);
                            this._lContainer.append(ulContainer);
                        }
                        else 
                            this._lContainer.append(this._renderListItems(ul));
                    }
                    else if (this._template) {
                        ej.destroyWidgets(this._template);
                        this._lContainer[0].innerHTML = this._template;
                    }
                }
                this.element.prepend(this._lbEle);
                if (this.model.enableFiltering)
                    this._createFilterWrapper(this._lbEle);
                this._setHeightWidth();
                this._lContainer.ejScroller({
                    height: this._lContainer.outerHeight(),
                    width: 0,
                    scrollerSize: 20,
                    scroll: function (e) {
                        proxy._onScroll(e);
                    },
                });
                this.scrollerObj = this._lContainer.ejScroller("instance");
                this._lbEle.append(this._lContainer);
                if (ej.widget.init)
                    ej.widget.init(this._lContainer);
                var eLi = this.element.find('li.' + this._prefixClass + 'list');
                eLi.removeEleEmptyAttrs();
                eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
                if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") {
                    this._liItemHeight = $(this.element.find('li')[0]).outerHeight();
                    totalHeight = this._totalCount * this._liItemHeight;
                    $('.e-sub-list-container ul').height(totalHeight);
                }
                if (ej.widget.init)
                    ej.widget.init(this._lbEle);
                var ulItems = this.element.find('ul');
                ulItems.find('li:first').addClass(this._prefixClass + "firstitem");
                ulItems.find('li:last').addClass(this._prefixClass + "lastitem");
                this._liEl = this.element.find("li");
                if (this.selectedItemIndex() >= 0 && !this.model.preventSelection && this.model.persistSelection) {
                    if (!ej.getBooleanVal(ulItems[this.selectedItemIndex()], 'data-preventselection', this.model.preventSelection) && ej.getBooleanVal(ulItems[this.selectedItemIndex()], 'data-persistselection', this.model.persistSelection)) {
                        this._currentItem = $(this._liEl[this.selectedItemIndex()]);
                        this._prevItem = this._currentItem;
                        this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
                    }
                }
                $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass + 'lv-checkdiv');
				if(this.model.renderTemplate) $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
                $(this.element.find('.' + this._prefixClass + 'lv-check').closest('li.' + this._prefixClass + 'list')).addClass(this._prefixClass + 'list-check');
                $(this.element.find('.' + this._prefixClass + 'lv-input').closest('.' + this._prefixClass + 'lv-filter')).addClass(this._prefixClass + 'lv-inputdiv');
                this._wireEvents();
            }
            this._setHeightWidth();
			if (this.model.height !== null) 
				if (this._lContainer.height() > this.model.height)
					this._refreshScroller(this._lContainer,false);
			if (this.scrollerObj) {
				this.scrollerObj.refresh();
				$(this.scrollerObj.element).find(".e-vhandlespace").css("height",($(this.scrollerObj.element).find(".e-vhandlespace").height() -1));
            }
            if (this.model.loadComplete)
                this._trigger("loadComplete");
        },

        _createFilterWrapper: function (element) {
            var fDiv = this._createFilterDiv();
            var fAnchor = ej.buildTag("a." + this._prefixClass + "lv-anchor", ej.buildTag('span.' + this._prefixClass + 'input-btn'), {}, { "Title": "Clear text", "data-role": "none" });
            $(fDiv).append(fAnchor);
            element.append(fDiv);
        },
        
		_refreshScroller: function (container,isChild) {
            //added start
               if (this.model.virtualScrollMode == "continuous") {
                this._lContainer.find(".e-content, .e-vhandle,.e-vhandle div").removeAttr("style");
                this._lContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this._lContainer.height();
                    this.scrollerObj.refresh();
                    this.scrollerObj.option("scrollTop", 0);
                }
            }
            //added end
            container.find(".e-vhandle div").removeAttr("style");
            if(isChild)
                hgt = this.model.showHeader && this.model.enableFiltering ? this.model.height - ((ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight')) + (ej.getDimension($(id).find('.' + this._prefixClass + 'lv-filter'), 'outerHeight'))) - 2 : this.model.showHeader ? this.model.height - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight') - 2 : this.model.enableFiltering ? this.model.height - (ej.getDimension($(id).find('.' + this._prefixClass + 'lv-filter'), 'outerHeight')) - 2 : this.model.height - 2;
            else
                hgt = this.model.showHeader && this.model.enableFiltering ? this.model.height - ((ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight')) + ($('.' + this._prefixClass + 'lv-filter').height())) - 2 : this.model.showHeader ? this.model.height - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight') - 2 : this.model.enableFiltering ? this.model.height - $('.' + this._prefixClass + 'lv-filter').height() - 2 : this.model.height - 2;
            if (this.scrollerObj) {
                this.scrollerObj.model.height = hgt;
            }
        },
        
        _renderListItems: function (ul) {
            ul.addClass(this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            this._liItems = ul.find("li");
            if (this._liItems.length && !this._hasDataSource() || this._hasDataSource()) {
                this._renderParentChildTemplate();
                if (!this._hasDataSource() && !this.model.enableGroupList) {
                    this._items = this.model.items;
                }
                var items = this._items;
                var proxy = this;
                if (this.model.allowVirtualScrolling) {
                    var childItem = [];
                    var result =  { parent: items, child: childItem };
                }
                else {
                    var result = this._filterParentChild(items);
                }
                if (result.child.length)
                    this._childRendering(result.child);
                if (result.parent) {
                    ul.empty().html($(this.jsRender).render(result.parent));
                    var ulItems = ul.find('>li'), temp = "";
                    for (var j = 0; j < ulItems.length; j++) {
                        if (result.parent[j] && result.parent[j].attributes) {
                            $.each(result.parent[j].attributes, function (i, attr) {
                                if (attr && attr.name.toLowerCase() == "class") temp = $(ulItems[j]).attr('class');
                            });
							$(ulItems[j]).addEleAttrs(result.parent[j].attributes);
							$(ulItems[j]).addClass(temp);
                        }
                    }
                }
            }
            if (this._initEJCheckBox)
                this._initEJCheckBox(ul);
            return ul;
        },

        _onScroll: function (e) {
            if (!e.scrollTop) return;
            var scrollerPosition = e.scrollTop, proxy = this;
            if (this.model.actionBegin)
                this._trigger("actionBegin", {});
            this.realUllength = this.element.find('li.e-list').length;
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                window.setTimeout(function () {
                    if (proxy._virtualCount == 0) {
                        proxy._loadList();
                    }
                }, 300);
            }
            else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                liHeight = $(this.element.find('li')[0]).outerHeight();
                if(scrollerPosition + this.model.height >= this.element.find("li").length * liHeight) { 
                    this._updateLoadingClass(true);
                    if (ej.DataManager && this._dataUrl instanceof ej.DataManager) {
                        this._queryPromise(this.realUllength, proxy, this.realUllength + this.model.itemRequestCount, e);
                    }
                }
            }
        },

        _loadList: function () {
            this._virtualCount++;
            var top = this.scrollerObj.scrollTop(), proxy = this, prevIndex = 0, prevPageLoad, nextIndex = null;
            this._currentPageindex = Math.round(top / (this._liItemHeight * this._items.length));
            if (($.inArray(this._currentPageindex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) {
                if (this._currentPageindex == 0) {
                    if (($.inArray(this._currentPageindex + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPageindex = this._currentPageindex + 1;
                    }
                }
                else if (($.inArray(this._currentPageindex - 1, this._virtualPages)) != -1) {
                    if (($.inArray(this._currentPageindex + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPageindex = this._currentPageindex + 1;
                    }
                }
                else {
                    this._currentPageindex = this._currentPageindex - 1;
                }
            }
            prevPageLoad = !($.inArray(this._currentPageindex - 1, this._virtualPages) != -1);
            this._updateLoadingClass(true);
            for (var i = this._virtualPages.length - 1; i >= 0; i--) {
                if (this._virtualPages[i] < this._currentPageindex) {
                    prevIndex = this._virtualPages[i];
                    if (!(i + 1 == this._virtualPages.length))
                        nextIndex = this._virtualPages[i + 1];
                    break;
                }
            }
            var firstArg = prevPageLoad ? (this._currentPageindex - 1) * this._items.length : this._currentPageindex * this._items.length;
            var skipQuery = ej.Query().range(firstArg, this._currentPageindex * this._items.length + this._items.length), queryPromise, list;
            if (ej.DataManager) {
                var skipParam = prevPageLoad ? (this._currentPageindex - 1) * this._items.length : this._currentPageindex * this._items.length;
                if(this._dataUrl.dataSource.offline == true)
                    skipQuery = ej.Query().skip(skipParam).take(this.model.itemRequestCount);
                else 
                    skipQuery = this._getQuery().skip(skipParam);
                if (prevPageLoad) {
                    for (i = 0; i < skipQuery.queries.length; i++) {
                        if (skipQuery.queries[i].fn == "onTake") {
                            skipQuery.queries.splice(i, 1);
                            break;
                        }
                    }
                    skipQuery.take(2 * this._items.length);
                }
                if (!proxy._trigger("actionBegin")) {
                    queryPromise = proxy._dataUrl.executeQuery(skipQuery);
                    queryPromise.done(function (e) {
                        proxy._appendVirtualList(e.result, prevIndex, proxy._currentPageindex, nextIndex, prevPageLoad);
                        proxy._trigger("actionSuccess", { e: e });
                    }).fail(function (e) {
                        proxy._virtualCount--;
                        proxy._trigger("actionFailure", { e: e });
                    }).always(function (e) {
                        proxy._updateLoadingClass(false);
                        proxy._trigger("actionComplete", { e: e });
                    });
                }
            } 
            else {
                list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                this._appendVirtualList(list, prevIndex, this._currentPageindex, nextIndex, prevPageLoad);
                this._updateLoadingClass(false);
            }
        },

        _appendVirtualList: function (list, prevIndex, currentIndex, nextIndex, prevPageLoad) {
            this._virtualCount--;
            if (($.inArray(currentIndex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) return false;
            if (prevPageLoad && ($.inArray(currentIndex - 1, this._virtualPages.sort()) != -1)) {
                list.splice(0, this._items.length);
                prevPageLoad = false;
            }
            var items = this._items.length, tempUl = $("<ul>"), firstVirtualHeight, secondVirtualHeight;
            firstVirtualHeight = prevPageLoad ? ((currentIndex - 1) * items * this._liItemHeight) - (prevIndex * items + items) * this._liItemHeight : (currentIndex * items * this._liItemHeight) - (prevIndex * items + items) * this._liItemHeight;
            if (firstVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: firstVirtualHeight }));
            this._loadVirtualData(list);
            $(this._dummyUl).attr("data-ej-page", currentIndex);
            if (prevPageLoad) {
                $(this._dummyUl).slice(0, items).attr("data-ej-page", currentIndex - 1);
            }
            tempUl.append(this._dummyUl);
            var ulItems = this.element.find('ul');
            secondVirtualHeight = (currentIndex * items + items) * this._liItemHeight;
            if (nextIndex != null) secondVirtualHeight = (nextIndex * items * this._liItemHeight) - secondVirtualHeight;
            else secondVirtualHeight = ulItems.height() - secondVirtualHeight;
            if (secondVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: secondVirtualHeight }));
            var selector = ulItems.find("li[data-ej-page=" + prevIndex + "]").last();
            selector.next().remove();
            tempUl.children().insertAfter(selector);
            this._removeEmptyElements();
            this._virtualPages.push(currentIndex);
            if (prevPageLoad) this._virtualPages.push(currentIndex - 1);
            this._virtualUl = ulItems.clone(true);
            ulItems.find('li.e-lastitem').removeClass(this._prefixClass + "lastitem");
            ulItems.find('li:last').addClass(this._prefixClass + "lastitem");
        },

        _updateLoadingClass: function (value) {
            var _id = this.element.attr("id")
            if(value){
                $("#" + _id+" .e-list-container.e-scroller .e-sub-list-container").addClass("e-load");
                $(".e-lv .e-list.e-state-default").css("opacity","0.5");
            }
            else {
                $("#" + _id+" .e-list-container.e-scroller .e-sub-list-container").removeClass("e-load");
                $(".e-lv .e-list.e-state-default").css("opacity","");
            }
            return this;
        },

        _queryPromise: function (start, proxy, end, event) {
            if (ej.DataManager && this._dataUrl instanceof ej.DataManager) {
                if (event==null) {
                    proxy._requestType = "init";
                    var queryPromise = this._dataUrl.executeQuery(this._getQuery());
                }
                else if(event != null) {
                    proxy._requestType = "request";
                    this._trigger('itemRequest', { event: event, isInteraction: true });
                    if(this._dataUrl.dataSource.offline == true) var mQuery = ej.Query();
                    else var mQuery = this._savedQueries.clone();
                    var queryPromise = this._dataUrl.executeQuery(mQuery.range(start, end));
                    this._updateLoadingClass(true);
                }
                queryPromise.done(function (e) {
                    if(proxy._requestType == "init"){
                        proxy._totalCount = e.count;
                        proxy.model.dataSource = e.result;
                        proxy._renderControl();
                        proxy._virtualPages = [0];
                    }
                    if(proxy._requestType == "request"){
                        proxy._trigger("actionBeforeSuccess", e);
                        proxy.realUllength =start;
                        proxy._loadVirtualData(e.result);
                    }
                    proxy._trigger("actionSuccess", { e: e });
                }).fail(function (e) {
                    proxy._trigger("actionFailure", { e: e });
                }).always(function (e) {
                    proxy._updateLoadingClass(false);
                    proxy._requestType = null;
                    proxy._trigger("actionComplete", { e: e });
                });
            }
        },

        _getQuery: function() {
            var remoteUrl, mapper = this.model.fieldSettings, queryManager = ej.Query();
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [];
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
            }
            else if (this.model.query) 
                queryManager = this.model.query.clone();
            if (this.model.allowVirtualScrolling) { 
                queryManager.requiresCount();
                queryManager.take(this.model.totalItemsCount);
            }
            remoteUrl = this.model.dataSource.dataSource;
            if (mapper)
                if ((remoteUrl && remoteUrl.url && !remoteUrl.url.match(mapper.tableName + "$")) || (remoteUrl && !remoteUrl.url) || (!remoteUrl))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            return queryManager;
        },
        
        _filterParentChild: function (items) {
            var dataMgr = ej.DataManager(items);
            var childItem = dataMgr.executeLocal(ej.Query().from(items).where(ej.Predicate(this.model.fieldSettings['parentPrimaryKey'], ej.FilterOperators.notEqual, null)).group(this.model.fieldSettings['parentPrimaryKey']));
            var parentItem = dataMgr.executeLocal(ej.Query().from(items).where(ej.Predicate(this.model.fieldSettings['parentPrimaryKey'], ej.FilterOperators.equal, null)));
            return { parent: parentItem, child: childItem };
        },

        _childRendering: function (grouped) {
            var proxy = this;
            if (grouped.length) {
                proxy.element.append($(proxy.jsChildRender).render(grouped));
                $.each(grouped, function (index, element) {
                    if (ej.widget.init)
                        ej.widget.init(proxy.element.find('#child' + element.key));
                    var ul = proxy.element.find('#child' + element.key).find('ul');
                    var li = ul.find('li');
                   var k = 0;
                    for (var j = 0; j < li.length; j++) {
                        if (grouped[k].items[j] && grouped[k].items[j].attributes)
                            $(li[j]).addEleAttrs(grouped[k].items[j].attributes);
                    }
                    k++;
                });
            }
        },
        _renderParentChildTemplate: function () {
            var list = this._renderLists();
            $.views.helpers({ _checkAjaxUrls: this._checkAjaxUrl, _checkImgUrls: this._checkImgUrl, _checkIsChecked: this._checkIsCheck, Object: this, ej: ej });
            //Template for parent item
            this.jsRender = ej.buildTag("script#" + this.model.id + "_Template", "", {}, { "type": "text/x-jsrender" });
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsRender[0].text = list[0].outerHTML.replace(/&gt;/g, '>');
            //Template for child item
            this.jsChildRender = ej.buildTag("script#" + this.model.id + "_ChildTemplate", "", {}, { "type": "text/x-jsrender" });
            if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") var ulContainer = ej.buildTag("div");
            var ul = ej.buildTag("ul." + this._prefixClass + "childcontainer " + this._prefixClass + "list-hdr " + this._prefixClass + "clearall");
            list.addClass(this._prefixClass + "childli");
            ul[0].innerHTML = "{{for items}}" + list[0].outerHTML + "{{/for}}";
            var div = ej.buildTag("div." + this._rootCSS + " subpage " + this._prefixClass + "childitem", "", {}, { "id": "{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}", "style": "display:none" });
            var innerdiv = ej.buildTag("div." + this._prefixClass + "list-container", "", {}, { "id": "{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}_container" });
            if (this.model.showHeader)
                div.append(this._renderHeader("{{if key}}child{{>key}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}", true, "Title"));
            if (this.model.enableFiltering)
                this._createFilterWrapper(div);
            if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") div.append(innerdiv.append(ulContainer.append(ul)));
            else  div.append(innerdiv.append(ul));
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                this.jsChildRender[0].text = div[0].outerHTML.replace(/&gt;/g, '>');
            else
                this.jsChildRender[0].innerHTML = div[0].outerHTML.replace(/&gt;/g, '>');
        },
    
        _renderChild: function (childId, ignoreWidth) {
            this._currentItem.attr('data-childid', childId);
            if (!this._currentItem.attr('data-childtitle'))
                this._currentItem.attr('data-childtitle', this._currentItem.text());
            this._createListDiv(childId);
            this._div.hide();
            this._container = ej.buildTag("div." + this._prefixClass + "list-container#" + childId + "_container");
            this.element.append(this._div);
        },

        _getText: function (element) {
            return $(element).clone()
           .children()
           .remove()
           .end()
           .text();
        },

        
        _checkImgUrl: function (item) {
            var obj = this.getRsc("helpers", "Object");
            var img = this.data[obj.model.fieldSettings.imageUrl];
            if (!$.support.pushstate)
                img = typeof App == "object" ? App.route.makeUrlAbsolute(img, true) : img;
            return "<img src = " + img + " class='" + obj._prefixClass + "list-img " + obj._prefixClass + "rel " + obj._prefixClass + "user-select'/>";
        },

        
        
        _checkAjaxUrl: function () {
            var href = this.data.href;
            var childid = this.data.childId;
            var rendertemp = this.data.renderTemplate;
            var tempid = this.data.templateId;
            var listObj = this.getRsc("helpers", "Object");
            var ej = this.getRsc("helpers", "ej");
            var content = listObj._currentPage(listObj);
            if (href && href.indexOf("#") != -1 && href != "#") {
                if (!listObj._storedContent[childid]) {
                    content.find(href).show();
                    var ele = content.find(href).clone();
                    content.find(href).hide();
                    listObj._storedContent[childid] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                }
            }
            else {
                if (listObj._storedContent[this.index])
                    listObj._storedContent = ej._pushValue(listObj._storedContent, "", this.index);
            }

        },

        _currentPage: function (obj) {
            return obj._prefixClass == "e-m-" ? ej.getCurrentPage() : $("body");
        },
        
        _checkIsCheck: function (item) {
            return this.data[this.getRsc("helpers", "Object").model.fieldSettings.checked] ? true : false;
        },

        _onTouchStartHandler: function (evt) {
             this._mouseDown = { x: (!ej.isNullOrUndefined(evt.clientX)) ? evt.clientX : evt.touches[0].clientX, y: (!ej.isNullOrUndefined(evt.clientY)) ? evt.clientY : evt.touches[0].clientY };
			if(($(evt.target.parentElement).hasClass(this._prefixClass + 'disable')) || ($(evt.currentTarget).hasClass(this._prefixClass + 'disable'))) 
				return false;
            if (!ej.isDevice() && !ej._preventDefaultException(evt.target, this._preventDefaultException))
                evt.preventDefault && evt.preventDefault();
            if (ej.isWindows && ej.isWindows())
                ej._touchStartPoints(evt, this);
            this._currentItem = $(evt.currentTarget);
            this._scroll = false;
            if (!ej.getBooleanVal(this._currentItem, 'data-preventSelection', this.model.preventSelection))
                this._addSelection();
			 if (this.model.renderMode == "windows" &&!this.model.windows.preventSkew)
                 this._currentItem.addClass(this._prefixClass + "m-skew-center");
            this._triggerStartEvent(this._returnData());
			ej.listenEvents([this._liEl, this._liEl],
                           [ej.endEvent(), ej.moveEvent(), ej.cancelEvent()],
                           [this._touchEndDelegate, this._touchMoveDelegate, this._touchMoveDelegate], false, this);
            $(window).on(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
        },
        
        
        _onTouchMoveHandler: function (evt) {
		if ((ej.browserInfo().name == "msie" && ej.browserInfo().version > 8)|| ej.browserInfo().name != "msie"){
           if (((!ej.isNullOrUndefined(evt.clientX)) ? evt.clientX : evt.changedTouches[0].clientX !== this._mouseDown.x) || ((!ej.isNullOrUndefined(evt.clientY)) ? evt.clientY : evt.changedTouches[0].clientY !== this._mouseDown.y)) {
            this._isMoved = true;
             if (ej.isDevice() && (!ej.isWindows || (ej.isWindows && !ej.isWindows()) || (ej.isWindows && ej.isWindows() && ej._isTouchMoved(evt, this)))) {
                this._scroll = true;
                if (!ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                    this._removeSelection();
                else if (this._prevItem && this._prevItem[0] != this._currentItem[0])
                    this._removeSelection();
                 if (this.model.renderMode == "windows" && !this.model.windows.preventSkew)					
                     ej._removeSkewClass(this._currentItem);
                else if (!ej.getBooleanVal(this._currentItem, 'data-preventselection', this.model.preventSelection) && this._prevItem && ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                    this._prevItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
                    }
                }
            }
        },
        
        

        _onTouchEndHandler: function (evt) {
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == 8)
                evt.stopImmediatePropagation();
            this._isFromAjax = false;
            if (!ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection))
                this._removeSelection();
            if (this.model.renderMode == "windows" && !this.model.windows.preventSkew)			
                ej._removeSkewClass(this._currentItem);
            if (this._scroll) {
                this._setCurrent();
                this._unbindEvents(evt);
                return false;
            }
            else if (!this._scroll) {
                if (this._currentItem.find('.' + this._prefixClass + 'lv-check').length) {
                    var lbCheck = this._currentItem.find('.' + this._prefixClass + 'lv-check');
					  if ((this._prefixClass == "e-" && !ej.isNullOrUndefined(evt) && !$(evt.target).closest('.e-lv-checkdiv').length))
                        this._toggleCheckboxValue(lbCheck);
                }
                var backButton = this._currentItem.attr('data-childheaderbackbuttontext') == undefined ? this._currentItem.closest('.' + this._rootCSS + '').find('.' + this._prefixClass + 'header').length && ! this.model.showHeaderBackButton ? this._currentItem.closest('.' + this._rootCSS + '').find('.' + this._prefixClass + 'header .' + this._prefixClass + 'htitle').text() : "Back" : ej.getAttrVal(this._currentItem, 'data-childheaderbackbuttontext');
                var urlVal = this._currentItem.attr('data-href');
                if (!this._currentItem.attr('data-navigateUrl')) {
                    var page = this._isInsideNavigation ? this._tempContent.find("[data-ajaxurl='" + this._convertToRelativeUrl(urlVal) + "']") : this.element.find("[data-ajaxurl='" + this._convertToRelativeUrl(urlVal) + "']");
                    if (ej.getBooleanVal(this._currentItem, 'data-loadajax', (this.model.enableAjax && typeof (urlVal) != "undefined" || !typeof (urlVal))) && (!this.model.enableCache || page.length == 0)) {
                        if (page.length)
                            page.remove();
                        if ((this._prefixClass == "e-" && this._currentItem.hasClass("e-arrow")) || this._prefixClass != "e-")
                            this.loadAjaxContent(urlVal, backButton);
                        this._unbindEvents(evt);
                        if (this._isInsideNavigation && this._nearestND.model.contentId)
                            this._closeNavigation();
                        return;
                    }
                    else if (urlVal && urlVal.indexOf("#") != -1) {
                        if (this._currentPage(this).find('#' + urlVal.replace('#', '')).length) {
                            this._renderChild(ej.getAttrVal(this._currentItem, 'data-childid', "page_" + parseInt(Math.random().toFixed(3) * 1000)));
                            var content = ej.buildTag("div." + this._prefixClass + "content", this._storedContent[this._currentItem.attr('data-childid')]);
                            this._div.append(this._container.append(content));
                            if (ej.widget.init)
                                ej.widget.init(this._div);
                        }
                    }
                    this._updateContent(this._currentItem, backButton);
					if (this.model.ready) this._trigger("ready");
                    if (this._isInsideNavigation)
                        var close = this._nearestND.model.contentId ? (!this._currentItem.attr("data-childid") || this._currentItem.attr("data-href")) : !(this._currentItem.attr("data-childid") || this._currentItem.attr("data-href"));
                    if (this._isInsideNavigation && close)
                        this._closeNavigation();
                    this._touchEndEventHandler(evt);
                }
                else
                    this._touchEndEventHandler();
                this._prevItem = this._currentItem;
            }
            this._unbindEvents(evt);
        },

        _hasValue: function (data, index) {
            for (var i = 0; i < data.length; i++) {
                if (data[i] == index) return true;
            }
        },

        _generateData: function (items, elementId) {
            var collection = ej.DataManager(items).executeLocal(ej.Query().from(this.model.dataSource).where(ej.Predicate(typeof ej.getAttrVal(this._currentItem, "data-id") == "undefined" ? this.model.fieldSettings['text'] : this.model.fieldSettings['id'], ej.FilterOperators.equal, elementId)).group(elementId))[0];
            return collection ? collection.items[0] : [];
        },


        
        _closeNavigation: function () {
                this.element.closest('.' + this._prefixClass + 'nb').ejNavigationDrawer('close');
        },

        
        _setCurrent: function (e) {
            if (this._prevItem && ej.getBooleanVal(this._currentItem, 'data-persistSelection', this.model.persistSelection)) {
                this._currentItem = this._prevItem;
                this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
            }
        },
        
        _unbindEvents: function (e) {
            if (e && e.target.nodeName && e.target.nodeName.toLowerCase() != "a") {
                
                this._scroll = false;
            }
            ej.listenEvents([this._liEl, this._liEl],
                           [ej.endEvent(), ej.moveEvent(), ej.cancelEvent()],
                           [this._touchEndDelegate, this._touchMoveDelegate, this._touchMoveDelegate], true, this);
        },
        
        
        _addSelection: function () {
            if (!this._scroll) {
                this._currentItem.closest('.' + this._prefixClass + 'list-container').find('.' + this._prefixClass + 'state-active').removeClass(this._prefixClass + "state-active").addClass(this._prefixClass + "state-default");
                this._currentItem.removeClass(this._prefixClass + "state-default").addClass(this._prefixClass + "state-active");
            }
        },
        
        
        _removeSelection: function () {
            var proxy = this;
            proxy._currentItem.removeClass(this._prefixClass + "state-active").addClass(this._prefixClass + "state-default");
        },

        
        _setHeightWidth: function () {
            if (this.model.autoAdjustHeight)
                this.element.height(window.innerHeight);
            else if (this.model.height)
                this.element.height(this.model.height);
            else {
                var hgt = this.element[0].scrollHeight ? this.element[0].scrollHeight : ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'list-container'), 'outerHeight');
                this.element.height(hgt);
            }
            if (this.model.width)
                this.element.width(this.model.width);
        },
        
        
        _touchEndEventHandler: function (evt) {
            this._triggerEndEvent(this._returnData(),evt);
        },
                
        _docClick: function (evt) {
            if (this._scroll) {
                this._setCurrent();
                $(document).off(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
                ej.listenEvents([this._liEl, this._liEl],
                               [ej.endEvent(), ej.moveEvent()],
                               [this._touchEndDelegate, this._touchMoveDelegate], true, this);
                $(window).off(ej.endEvent() + " MSPointerUp pointerup", this._docClickDelegate);
            }
        },
        
        
        _popStateNavigation: function (evt, data) {
            if (data.pageUrl && this.model.enableFiltering)
                this._initializeFiltering($("div[data-url='" + data.pageUrl.replace('#', '') + "']"));
        },
        
        
        _anchorClickHandler: function (e) {
            if (this._scroll) {
                ej.blockDefaultActions(e);
                return false;
            }
        },
        
        _onResize: function () {
            var proxy = this;
            setTimeout(function () {
                proxy._setHeightWidth();
            }, ej.isAndroid() ? 200 : 0);
        },
        _onScrollStop: function (e) {
            ej.blockDefaultActions(e);
        },
        
        
        _createDelegates: function () {
            this._anchorClickDelegate = $.proxy(this._anchorClickHandler, this);
            this._keyup = $.proxy(this._onKeyUp, this);
            this._touchStartDelegate = $.proxy(this._onTouchStartHandler, this);
            this._touchEndDelegate = $.proxy(this._onTouchEndHandler, this);
            this._touchMoveDelegate = $.proxy(this._onTouchMoveHandler, this);
            this._resizeDelegate = $.proxy(this._onResize, this);
            this._popStateDelegate = $.proxy(this._popStateNavigation, this);
            this._docClickDelegate = $.proxy(this._docClick, this);
        },
        
        
        _wireEvents: function (remove, items) {
            var listItems = this._liEl || items;
            if (listItems) {
                this._createDelegates();
                var eventType = remove ? "unbind" : "bind";
                if (this.model.autoAdjustHeight) {
                    var evt = !ej.isDevice() && "onorientationchange" in window ? "orientationchange" : "resize";
                    ej.listenEvents([window], [evt], [this._resizeDelegate], remove, this);
                }
                ej.listenEvents([listItems.find('a'), this.element.find('.' + this._prefixClass + 'lv-input'), listItems, listItems],
                ["click", "keyup", ej.startEvent(), ej.cancelEvent()],
                [this._anchorClickDelegate, this._keyup, this._touchStartDelegate, this._touchMoveDelegate], remove, this);
                this._lContainer.on("scrollstop", $.proxy(this._onScrollStop, this));
                $('body')[eventType]('viewpopstate', this._popStateDelegate);
                if (this.model.enableFiltering)
                    this._initializeFiltering(this._lbEle);
            }
        },
        
        
        _initializeFiltering: function (element) {
            this._searchItems = $(element).find("." + this._prefixClass + "list");
            this._emptyFilterTextValue(element);
            element.find('.' + this._prefixClass + 'list[style*="display: none"]').show();
            this._elementText = [];
            for (var i = 0; i < this._searchItems.length; i++) {
                if ($(this._searchItems[i]))
                    this._elementText.push($.trim($(this._searchItems[i]).html().replace(new RegExp('<[^<]+\>', 'g'), "").toLowerCase()));
                else
                    this._elementText.push("");
            }
        },
        
        
        _onKeyUp: function (evt) {
            for (var i = 0; i < this._searchItems.length; i++) {
                if (this._elementText[i].indexOf(evt.target.value.toLowerCase()) == -1)
                    $(this._searchItems[i]).css("display", "none");
                else
                    $(this._searchItems[i]).css("display", "");
            }
        },
        
        
        _setModel: function (options) {
            var refresh = false;
            for (var prop in options) {
                var setModel = "_set" + prop.charAt(0).toUpperCase() + prop.slice(1);
				 if (this[setModel] || prop == "locale") {
                    switch (prop) {                       
						case "locale":
							if (ej.ListView.Locale[options[prop]]) {
								this.model.locale = options[prop];
								this._setCulture();	
                                this._setHeaderVal(this.model.id,this.model.headerTitle, this.model.headerBackButtonText);						
							}
                            break;
                        default:
                            this[setModel](options[prop]);
                    }
                }               
                else
                    refresh = true;
            }
            if (refresh)
                this._refresh();
        },
        
        
        _setTheme: function (value) {
            if (value) {
                this.model.theme = value;
                this._lbEle.removeClass("e-m-dark e-m-light e-default").addClass("e-m-" + this.model.theme);
                if (this.model.enableFiltering)
                    this.element.find('.' + this._prefixClass + 'text-input').ejmTextBox('model.theme', this.model.theme);
                if (this.model.showHeader)
                    this._lbEle.find('#' + this.model.id + "_header").ejmHeader('model.theme', this.model.theme);
                if (this.element.find('.' + this._prefixClass + 'childitem').length) {
                    $(this.element.find('.' + this._prefixClass + 'childitem')).removeClass("e-m-dark e-m-light e-default").addClass("e-m-" + this.model.theme);
                    var header = this.element.find('.' + this._prefixClass + 'childitem .' + this._prefixClass + 'header');
                    var proxy = this;
                    header.each(function (index, element) {
                        $(element).ejmHeader('model.theme', proxy.model.theme);
                    });
                }
            }
        },
        
        
        _setDataSource: function (dataSource, fieldSettings) {
            if (this._hasDataSource() && dataSource) {
                if (fieldSettings)
                    this.model.fieldSettings = fieldSettings;
                this._refresh();
            }
        },
        
        
        _hasDataSource: function () {
            return this.dataSource() && this.dataSource().length;
        },
        
        
        _getElement: function (childId) {
            return childId ? this.element.find('#' + childId) : this._lbEle;
        },
        
        
        _isEnable: function (item) {
            return item.hasClass(this._prefixClass + 'state-disabled') ? false : true;
        },
        //To refresh the control
        _refresh: function () {
            this._destroy();
            this.element.addClass(this._rootCSS);
            this._load();
        },
        //To clear the element
        _clearElement: function () {
            this.element.removeAttr("class style");
            this.element.empty().html(this._orgEle.html());
        },
        // all events bound using this._on will be unbind automatically
        _destroy: function () {
			if (this._prefixClass == "e-")
			   ej.listenEvents([window], ["resize"], [this._resizeDelegate], true, this);
            this._wireEvents(true);
            this._clearElement();
        },

        loadAjaxContent: function (urlVal, backButton) {
            var proxy = this;
            this._isFromAjax = true;
            this._renderChild(ej.getAttrVal(this._currentItem, 'data-childid', "page_" + parseInt(Math.random().toFixed(3) * 1000)));
            if (!$.support.pushstate || ej.isWindowsWebView())
            var loadData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
            if (this.model.ajaxBeforeLoad)
                this._trigger("ajaxBeforeLoad", loadData);
            var ajaxSettings = {
                cache: proxy.model.ajaxSettings.cache,
                async: proxy.model.ajaxSettings.async,
                type: proxy.model.ajaxSettings.type,
                contentType: proxy.model.ajaxSettings.contentType,
                url: ej.isWindowsWebView() ? urlVal : proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal,
                dataType: proxy.model.ajaxSettings.dataType,
                data: proxy.model.ajaxSettings.data,
                "successHandler": function (data) { //Ajax post success event handler
                    var content = ej.buildTag("div." + this._prefixClass + "content", (/<\/?body[^>]*>/gmi).test(data) ? data.split(/<\/?body[^>]*>/gmi)[1] : data || "");
                    proxy._div.append(proxy._container.append(content));
                    proxy._updateContent(proxy._currentItem, backButton);                    
					mobileApp =  proxy._prefixClass == "e-m-" ? App.angularAppName : false;
                    if ((mobileApp || ej.angular.defaultAppName))
                        ej.angular.compile(content);
                    var successData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxSuccess)
                        proxy._trigger("ajaxSuccess", successData);
                },
                "errorHandler": function (xhr, textStatus, errorThrown) {
                    var errorData = { "xhr": xhr, "textStatus": textStatus, "errorThrown": errorThrown, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxError)
                        proxy._trigger("ajaxError", errorData);
                },
                "completeHandler": function (data) {
                    var completeData = { content: proxy._div, item: proxy._currentItem, index: $(proxy._currentItem).index(), text: $(proxy._currentItem).text(), url: proxy.model.ajaxSettings.url ? proxy.model.ajaxSettings.url : urlVal };
                    if (proxy.model.ajaxComplete)
                        proxy._trigger("ajaxComplete", completeData);
                }
            };
            ej.sendAjaxRequest(ajaxSettings);
        },

        selectItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]))) {
                this.setActive(index, childId);
                this._currentItem = $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]);
                this._prevItem = this._currentItem;
                this._onTouchEndHandler();
            }
        },

        setActive: function (index, childId) {
            if (index >= 0) {
               var element = this._getElement(childId);
                if (this._isEnable($(element.find('li.' + this._prefixClass + 'list')[index])) && ej.getBooleanVal($(element.find('li.' + this._prefixClass + 'list')[index]), 'data-persistSelection', this.model.persistSelection)) {
                    element.find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active').removeClass(this._prefixClass + 'state-active').addClass(this._prefixClass + 'state-default');
                    this._currentItem = $(element.find('li.' + this._prefixClass + 'list')[index]);
                    this._prevItem = this._currentItem;
                    this._currentItem.removeClass(this._prefixClass + 'state-default').addClass(this._prefixClass + 'state-active');
                }
            }
        },

        deActive: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).removeClass(this._prefixClass + 'state-active').addClass(this._prefixClass + 'state-default');
        },

        enableItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).removeClass(this._prefixClass + 'disable').addClass(this._prefixClass + 'state-default').find('a').removeClass(this._prefixClass + 'disable').find('.' + this._prefixClass + 'lv-check').ejCheckBox("enable");
        },

        disableItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).addClass(this._prefixClass + 'disable').removeClass(this._prefixClass + 'state-default').find('a').addClass(this._prefixClass + 'disable').find('.' + this._prefixClass + 'lv-check').ejCheckBox("disable");
        },

        removeCheckMark: function (index, childId) {
            this._removeIndex=index;
           var element = this._getElement(childId);
            if (index >= 0 && this._isEnable($(element.find('li.' + this._prefixClass + 'list')[index])))
                $(element.find('li.' + this._prefixClass + 'list')[index]).find('.' + this._prefixClass + 'lv-checkdiv').remove();
            else
                element.find('.' + this._prefixClass + 'lv-checkdiv').remove();
        },

        checkItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                this._setCheckboxValue($(this._getElement(childId).find('.' + this._prefixClass + 'lv-check')[index]), true);
			this._checkedValues.push(index);
			this.checkedIndices(this._checkedValues);
        },

        unCheckItem: function (index, childId) {
            if (index >= 0 && this._isEnable($(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index])))
                this._setCheckboxValue($(this._getElement(childId).find('.' + this._prefixClass + 'lv-check')[index]), false);
			 this._checkedValues.splice(this._checkedValues.indexOf(index), 1);
        },

        checkAllItem: function (childId) {
            var proxy = this;
            this._getElement(childId).find('.' + this._prefixClass + 'lv-check').each(function (index, check) {
                if (proxy._isEnable($(proxy._getElement(childId).find('li.' + proxy._prefixClass + 'list')[index])))
                    proxy._setCheckboxValue($(check), true);
            });
			this._checkStatevalue();
        },

        unCheckAllItem: function (childId) {
            this.model.checkedIndices=[];
            var proxy = this;
            this._getElement(childId).find('.' + this._prefixClass + 'lv-check').each(function (index, check) {
                if (proxy._isEnable($(proxy._getElement(childId).find('li.' + proxy._prefixClass + 'list')[index])))
                    proxy._setCheckboxValue($(check), false);
            });
        },
		
        _checkStatevalue:function (){			
			this._currentItem = $(this._liEl);
			for(i=0; i<this._currentItem.length; i++){
			  index = this.element.find("li").index(this._currentItem[i]);
			  if (!this._hasValue(this._checkedValues, index))
                        this._checkedValues.push(index);
                    else
                        this._checkedValues.splice(this._checkedValues.indexOf(index), 1);}

				this.checkedIndices(this._checkedValues);
			    this.model.checkedIndices = this.checkedIndices();		
			
		},
		
        getActiveItem: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active');
        },

        getActiveItemText: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list.' + this._prefixClass + 'state-active').text();
        },

        getItemText: function (index, childId) {
            if (index >= 0)
                return $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).text();
        },

        getCheckedItems: function (childId) {
            if (childId != undefined)
                return this._getElement(childId).find('input.' + this._prefixClass + 'lv-check:checked').closest('li.' + this._prefixClass + 'list');
            else
                var checkedlist=[];
		        for(i=0; i<this.checkedIndices().length; i++){
			    var clist = this.element.find("li")[this.checkedIndices()[i]];
			    checkedlist.push(clist);
		   }
			   return checkedlist;
        },

        getCheckedItemsText: function (childId) {
            return $(this.getCheckedItems(childId)).map(function () { return $(this).text(); }).get();
        },

        hasChild: function (index, childId) {
            if (index >= 0)
                return this.element.find('#' + $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).attr('data-childid')).length ? true : false;
        },
        
        isChecked: function (index, childId) {
            if (index >= 0)
                return $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).find('input.' + this._prefixClass + 'lv-check').prop('checked');
        },

        showItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).css('visibility', '');
        },

        hideItem: function (index, childId) {
            if (index >= 0)
                $(this._getElement(childId).find('li.' + this._prefixClass + 'list')[index]).css('visibility', 'hidden');
        },

        show: function (childId) {
            this._getElement(childId).css('visibility', '');
        },

        hide: function (childId) {
            this._getElement(childId).css('visibility', 'hidden');
        },

		_objectSplice:function(list,index){
		    for (var i = 0; i < list.length; i++) {
		        this.model.items.splice(index, 0, list[i]);
		    }
		},
		
        addItem: function (list, index, groupid) {
			if (typeof (list) == 'object') list = $(list);
            if (index >= 0) {
                if (!this._hasDataSource()) {
					if($('.e-list-container').find('ul').length == 0){
                    var ul = ej.buildTag('ul'), li = ej.buildTag('li');
                    $('.e-list-container').find('div:first').append(ul);
                    $('.e-list-container > div > ul').append(li);
                }
                    if (typeof (list) == 'object')
                        this._objectSplice(list, index);
                    else
                        this.model.items.splice(index, 0, this._getLiAttributes(list, null, null, groupid));
                    var items = this.model.items;
                }
                else {
                    if (typeof (list) == 'object') {
                        for (var i = 0; i < list.length; i++) 
                            this.dataSource().splice(index, 0, list[i]);
                    }
                    else 
                    this.dataSource().splice(index, 0, this._itemsObjectCollection($(list), null, null, groupid));
                    var items = this.dataSource();
                }
            }
            else
                this._orgEle.children().append(list);
            if (!this.model.enableGroupList)
                var $ul = $(this.element.find("ul:visible"));
            else
                var $ul = $(this.element.find('ul[data-ej-grouplisttitle= ' + groupid + ']'));
            if (!ej.isNullOrUndefined(this.jsRender)) {
				 var ele;
				if (typeof (list) == 'object') {
                    for (var i = 0; i < list.length; i++) 
	                    ele = $($(this.jsRender).render(items[index+i])).insertBefore($ul.children()[index]);
                }
                else 
                      ele = $($(this.jsRender).render(items[index])).insertBefore($ul.children()[index]);    
                ej.widget.init && ej.widget.init(ele);
				if($(list).attrNotStartsWith(/^data-ej-/).length>0) $(ele).addEleAttrs($($(list).attrNotStartsWith(/^data-ej-/)));
            }
            else {
                this._renderControl();
                if ($(this.element).find('.subpage').length > 1) {
                    $(this.element).find('.subpage:nth-child(2)').remove();
                }
            }
            this._processing($ul);
            this._liEl = this.element.find('li.' + this._prefixClass + 'list');
            if (this._initEJCheckBox){
			this._initEJCheckBox($ul);
		    if(this.model.renderTemplate) $(this.element.find('.' + this._prefixClass + 'lv-check').parent()).addClass(this._prefixClass+'template-checkmark');
			}
            this._setHeightWidth();
            this._wireEvents();
        },

            _processing: function ($ul) {
            $ul.find("li." + this._prefixClass + "firstitem").removeClass(this._prefixClass + "firstitem");
            $ul.find('li:first').addClass(this._prefixClass + "firstitem");
            $ul.find("li." + this._prefixClass + "lastitem").removeClass(this._prefixClass + "lastitem");
            $ul.find('li:last').addClass(this._prefixClass + "lastitem");
            eLi = $ul.find('li.' + this._prefixClass + 'list');
            eLi.removeEleEmptyAttrs();
            eLi.find('.' + this._prefixClass + 'chevron-right_01').removeEleEmptyAttrs();
            $ul.find('.' + this._prefixClass + 'lv-check').parent().addClass(this._prefixClass + 'lv-checkdiv');
            $ul.find('.' + this._prefixClass + 'lv-check').closest('li.' + this._prefixClass + 'list').addClass(this._prefixClass + 'list-check');
            $ul.find('.' + this._prefixClass + 'lv-input').closest('.' + this._prefixClass + 'lv-filter').addClass(this._prefixClass + 'lv-inputdiv');
        },

        removeItem: function (index, childId) {
            var removedItems = [];
            if (index >= 0) {
                element = this._getElement(childId);
                var child = $(element.find('li.' + this._prefixClass + 'list')[index]).attr('data-childid');
                if (this.element.find($('#' + child).length))
                    this.element.find($('#' + child)).remove();
                $(element.find('li.' + this._prefixClass + 'list')[index]).remove();
                var index = [parseInt(index)];
                this.dataSource(this.dataSource().filter(function (e, i) {
                    if (index.indexOf(i) != -1)
                        removedItems.push(e);
                    else
                        return true;
                }));
            }
        },

        clear: function () {
            this.element.empty().html();
            this._liEl = this.element.find('li.' + this._prefixClass + 'list');
        },

        getItemsCount: function (childId) {
            return this._getElement(childId).find('li.' + this._prefixClass + 'list').length;
        },
		
        getActiveItemData: function () {
            if (this.getActiveItem().attr("data-id"))
                return (this._generateData(this.dataSource().length ? typeof this.dataSource() == "string" ? eval(this.dataSource()) : this.dataSource() : this.model.items, this.getActiveItem().attr("data-id")));
        }
    });
	ej.VirtualScrollMode = {
        /** Supports to Virtual Scrolling mode with normal only */
        Normal: "normal",
        /** Supports to Virtual Scrolling mode with continuous only */
        Continuous: "continuous"
    };
})(jQuery, Syncfusion);;;
(function($, undefined){
    
ej.globalize = {};
ej.cultures = {};

ej.cultures['default'] = ej.cultures['en-US'] = $.extend(true, {
    name: 'en-US',
    englishName: "English",
    nativeName: "English",
    language: 'en',
    isRTL: false,
    numberFormat: {
        pattern: ["-n"],
        decimals: 2,
        ',': ",",
        '.': ".",
        groupSizes: [3],
        '+': "+",
        '-': "-",
        percent: {
            pattern: ["-n %", "n %"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '%'
        },
        currency: {
            pattern: ["($n)", "$n"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '$'
        }
    },
    calendars: {
    	standard: {
	        '/': '/',
	        ':': ':',
	        firstDay: 0,
			week:{
			name:"Week",
			nameAbbr:"Wek",
			nameShort:"Wk"
			},
	        days: {
	            names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
	            namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
	            namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
	        },
	        months: {
	            names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""],
	            namesAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""]
	        },
	        AM: ['AM', 'am', 'AM'],
	        PM: ['PM', 'pm', 'PM'],
            twoDigitYearMax: 2029,
	        patterns: {
                d: "M/d/yyyy",
                D: "dddd, MMMM dd, yyyy",
                t: "h:mm tt",
                T: "h:mm:ss tt",
                f: "dddd, MMMM dd, yyyy h:mm tt",
                F: "dddd, MMMM dd, yyyy h:mm:ss tt",
                M: "MMMM dd",
                Y: "yyyy MMMM",
                S: "yyyy\u0027-\u0027MM\u0027-\u0027dd\u0027T\u0027HH\u0027:\u0027mm\u0027:\u0027ss"

	        }
    	}
    }
}, ej.cultures['en-US']);

ej.cultures['en-US'].calendar = ej.cultures['en-US'].calendar || ej.cultures['en-US'].calendars.standard; 



// *************************************** Numbers ***************************************
var regexTrim = /^\s+|\s+$/g,
    regexInfinity = /^[+-]?infinity$/i,
    regexHex = /^0x[a-f0-9]+$/i,
    regexParseFloat = /^[+-]?\d*\.?\d*(e[+-]?\d+)?$/;

function patternStartsWith(value, pattern) {
    return value.indexOf( pattern ) === 0;
}

function patternEndsWith(value, pattern) {
    return value.substr( value.length - pattern.length ) === pattern;
}

function trim(value) {
    return (value+"").replace( regexTrim, "" );
}

function truncate(value){
    if(isNaN(value))
        return NaN;
    
    return Math[value < 0 ? "ceil" : "floor"](value);
}

function padWithZero(str, count, left) {
    for (var l = str.length; l < count; l++) {
        str = (left ? ('0' + str) : (str + '0'));
    }
    return str;
}

function parseNumberWithNegativePattern(value, nf, negativePattern) {
    var neg = nf["-"],
        pos = nf["+"],
        ret;
    switch (negativePattern) {
        case "n -":
            neg = ' ' + neg;
            pos = ' ' + pos;
            // fall through
        case "n-":
            if ( patternEndsWith( value, neg ) ) {
                ret = [ '-', value.substr( 0, value.length - neg.length ) ];
            }
            else if ( patternEndsWith( value, pos ) ) {
                ret = [ '+', value.substr( 0, value.length - pos.length ) ];
            }
            break;
        case "- n":
            neg += ' ';
            pos += ' ';
            // fall through
        case "-n":
            if ( patternStartsWith( value, neg ) ) {
                ret = [ '-', value.substr( neg.length ) ];
            }
            else if ( patternStartsWith(value, pos) ) {
                ret = [ '+', value.substr( pos.length ) ];
            }
            break;
        case "(n)":
            if ( patternStartsWith( value, '(' ) && patternEndsWith( value, ')' ) ) {
                ret = [ '-', value.substr( 1, value.length - 2 ) ];
            }
            break;
    }
    return ret || [ '', value ];
}

function getFullNumber(number, precision, formatInfo) {
    var groupSizes = formatInfo.groupSizes || [3],
        curSize = groupSizes[0],
        curGroupIndex = 1,
        factor = Math.pow(10, precision),
        rounded = Math.round(number * factor) / factor;
    if (!isFinite(rounded)) {
        rounded = number;
    }
    number = rounded;

    var numberString = number + "",
        right = "",
        split = numberString.split(/e/i),
        exponent = split.length > 1 ? parseInt(split[1], 10) : 0;
    numberString = split[0];
    split = numberString.split(".");
    numberString = split[0];
    right = split.length > 1 ? split[1] : "";

    var l;
    if (exponent > 0) {
        right = padWithZero(right, exponent, false);
        numberString += right.slice(0, exponent);
        right = right.substr(exponent);
    } else if (exponent < 0) {
        exponent = -exponent;
        numberString = padWithZero(numberString, exponent + 1, true);
        right = numberString.slice(-exponent, numberString.length) + right;
        numberString = numberString.slice(0, -exponent);
    }

    var dot = formatInfo['.'] || '.';
    if (precision > 0) {
        right = dot +
            ((right.length > precision) ? right.slice(0, precision) : padWithZero(right, precision));
    } else {
        right = "";
    }

    var stringIndex = numberString.length - 1,
        sep = formatInfo[","] || ',',
        ret = "";

    while (stringIndex >= 0) {
        if (curSize === 0 || curSize > stringIndex) {
            return numberString.slice(0, stringIndex + 1) + (ret.length ? (sep + ret + right) : right);
        }
        ret = numberString.slice(stringIndex - curSize + 1, stringIndex + 1) + (ret.length ? (sep + ret) : "");

        stringIndex -= curSize;

        if (curGroupIndex < groupSizes.length) {
            curSize = groupSizes[curGroupIndex];
            curGroupIndex++;
        }
    }
    return numberString.slice(0, stringIndex + 1) + sep + ret + right;
}

function formatNumberToCulture(value, format, culture) {
    if (!format || format === 'i') {
        return culture.name.length ? value.toLocaleString() : value.toString();
    }
    format = format || "D";

    var nf = culture.numberFormat,
        number = Math.abs(value),
        precision = -1,
        pattern;

    if (format.length > 1) precision = parseInt(format.slice(1), 10);

    var current = format.charAt(0).toUpperCase(),
        formatInfo;

    switch (current) {
        case 'D':
            pattern = 'n';
            number = truncate(number);
            if (precision !== -1) {
                number = padWithZero("" + number, precision, true);
            }
            if (value < 0) number = -number;
            break;
        case 'N':
            formatInfo = nf;
            formatInfo.pattern = formatInfo.pattern || ['-n'];
            // fall through
        case 'C':
            formatInfo = formatInfo || nf.currency;
            formatInfo.pattern = formatInfo.pattern || ['-$n', '$n'];
            // fall through
        case 'P':
            formatInfo = formatInfo || nf.percent;
            formatInfo.pattern = formatInfo.pattern || ['-n %', 'n %'];
            pattern = value < 0 ? (formatInfo.pattern[0] || "-n") : (formatInfo.pattern[1] || "n");
            if (precision === -1) precision = formatInfo.decimals;
            number = getFullNumber(number * (current === "P" ? 100 : 1), precision, formatInfo);
            break;
        default:
            throw "Bad number format specifier: " + current;
    }

    return matchNumberToPattern(number, pattern, nf);
}



function matchNumberToPattern(number, pattern, nf){
    var patternParts = /n|\$|-|%/g,
        ret = "";
    for (;;) {
        var index = patternParts.lastIndex,
            ar = patternParts.exec(pattern);

        ret += pattern.slice(index, ar ? ar.index : pattern.length);

        if (!ar) {
            break;
        }

        switch (ar[0]) {
            case "n":
                ret += number;
                break;
            case "$":
                ret += nf.currency.symbol || "$";
                break;
            case "-":
                // don't make 0 negative
                if (/[1-9]/.test(number)) {
                    ret += nf["-"] || "-";
                }
                break;
            case "%":
                ret += nf.percent.symbol || "%";
                break;
        }
    }

    return ret;
}

function parseValue(value, culture, radix ) {
		// make radix optional
    if (typeof radix === "string") {
        culture = radix;
        radix = 10;
    }
    culture = ej.globalize.findCulture(culture);
    var ret = NaN, nf = culture.numberFormat, npattern = culture.numberFormat.pattern[0];
    value = value.replace(/ /g, '');
    if (value.indexOf(culture.numberFormat.currency.symbol) > -1) {
        // remove currency symbol
        value = value.replace(culture.numberFormat.currency.symbol || "$", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.currency["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the currency
        npattern = trim(culture.numberFormat.currency.pattern[0].replace("$", ""));
    } else if (value.indexOf(culture.numberFormat.percent.symbol) > -1) {
        // remove percentage symbol
        value = value.replace(culture.numberFormat.percent.symbol || "%", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.percent["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the percent
        npattern = trim(culture.numberFormat.percent.pattern[0].replace("%", ""));
    }

    // trim leading and trailing whitespace
    value = trim( value );

    // allow infinity or hexidecimal
    if (regexInfinity.test(value)) {
        ret = parseFloat(value, "" ,radix);
    }
    else if (regexHex.test(value)) {
        ret = parseInt(value, 16);
    }
    else {
        var signInfo = parseNumberWithNegativePattern( value, nf, npattern ),
            sign = signInfo[0],
            num = signInfo[1];
        // determine sign and number
        if ( sign === "" && nf.pattern[0] !== "-n" ) {
            signInfo = parseNumberWithNegativePattern( value, nf, "-n" );
            sign = signInfo[0];
            num = signInfo[1];
        }
        sign = sign || "+";
        // determine exponent and number
        var exponent,
            intAndFraction,
            exponentPos = num.indexOf( 'e' );
        if ( exponentPos < 0 ) exponentPos = num.indexOf( 'E' );
        if ( exponentPos < 0 ) {
            intAndFraction = num;
            exponent = null;
        }
        else {
            intAndFraction = num.substr( 0, exponentPos );
            exponent = num.substr( exponentPos + 1 );
        }
        // determine decimal position
        var integer,
            fraction,
            decSep = nf['.'] || '.',
            decimalPos = intAndFraction.indexOf( decSep );
        if ( decimalPos < 0 ) {
            integer = intAndFraction;
            fraction = null;
        }
        else {
            integer = intAndFraction.substr( 0, decimalPos );
            fraction = intAndFraction.substr( decimalPos + decSep.length );
        }
        // handle groups (e.g. 1,000,000)
        var groupSep = nf[","] || ",";
        integer = integer.split(groupSep).join('');
        var altGroupSep = groupSep.replace(/\u00A0/g, " ");
        if ( groupSep !== altGroupSep ) {
            integer = integer.split(altGroupSep).join('');
        }
        // build a natively parsable number string
        var p = sign + integer;
        if ( fraction !== null ) {
            p += '.' + fraction;
        }
        if ( exponent !== null ) {
            // exponent itself may have a number patternd
            var expSignInfo = parseNumberWithNegativePattern( exponent, nf, npattern );
            p += 'e' + (expSignInfo[0] || "+") + expSignInfo[1];
        }
        if ( !radix && regexParseFloat.test( p ) ) {
            ret = parseFloat( p );
        }
		else if(radix)
			ret = parseInt(p, radix);
    }
    return ret;
}

// *************************************** Dates ***************************************

var dateFormat = {
    DAY_OF_WEEK_THREE_LETTER : "ddd",
    DAY_OF_WEEK_FULL_NAME : "dddd",
    DAY_OF_MONTH_SINGLE_DIGIT : "d",
    DAY_OF_MONTH_DOUBLE_DIGIT : "dd",
    MONTH_THREE_LETTER : "MMM",
    MONTH_FULL_NAME : "MMMM",
    MONTH_SINGLE_DIGIT : "M",
    MONTH_DOUBLE_DIGIT : "MM",
    YEAR_SINGLE_DIGIT : "y",
    YEAR_DOUBLE_DIGIT : "yy",
    YEAR_FULL : "yyyy",
    HOURS_SINGLE_DIGIT_12_HOUR_CLOCK : "h",
    HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK : "hh",
    HOURS_SINGLE_DIGIT_24_HOUR_CLOCK : "H",
    HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK : "HH",
    MINUTES_SINGLE_DIGIT : "m",
    MINUTES_DOUBLE_DIGIT : "mm",
    SECONDS_SINGLE_DIGIT : "s",
    SECONDS_DOUBLE_DIGIT : "ss",
    MERIDIAN_INDICATOR_SINGLE : "t",
    MERIDIAN_INDICATOR_FULL : "tt",
    DECISECONDS : "f",
    CENTISECONDS: "ff",
    MILLISECONDS : "fff",
    TIME_ZONE_OFFSET_SINGLE_DIGIT : "z",
    TIME_ZONE_OFFSET_DOUBLE_DIGIT : "zz",
    TIME_ZONE_OFFSET_FULL : "zzz",
    DATE_SEPARATOR : "/"
};

function valueOutOfRange(value, low, high) {
    return value < low || value > high;
}

function expandYear(cal, year) {
    // expands 2-digit year into 4 digits.
    var now = new Date();
    if ( year < 100 ) {
        var twoDigitYearMax = cal.twoDigitYearMax;
        twoDigitYearMax = typeof twoDigitYearMax === 'string' ? new Date().getFullYear() % 100 + parseInt( twoDigitYearMax, 10 ) : twoDigitYearMax;
        var curr = now.getFullYear();
        year += curr - ( curr % 100 );
        if ( year > twoDigitYearMax ) {
            year -= 100;
        }
    }
    return year;
}

function arrayIndexOf( array, item ) {
    if ( array.indexOf ) {
        return array.indexOf( item );
    }
    for ( var i = 0, length = array.length; i < length; i++ ) {
        if ( array[ i ] === item ) return i;
    }
    return -1;
}

function toUpper(value) {
    // 'he-IL' has non-breaking space in weekday names.
    return value.split( "\u00A0" ).join(' ').toUpperCase();
}

function toUpperArray(arr) {
    var results = [];
    for ( var i = 0, l = arr.length; i < l; i++ ) {
        results[i] = toUpper(arr[i]);
    }
    return results;
}

function getIndexOfDay(cal, value, abbr) {
    var ret,
        days = cal.days,
        upperDays = cal._upperDays;
    if ( !upperDays ) {
        cal._upperDays = upperDays = [
            toUpperArray( days.names ),
            toUpperArray( days.namesAbbr ),
            toUpperArray( days.namesShort )
        ];
    }
    value = toUpper( value );
    if ( abbr ) {
        ret = arrayIndexOf( upperDays[ 1 ], value );
        if ( ret === -1 ) {
            ret = arrayIndexOf( upperDays[ 2 ], value );
        }
    }
    else {
        ret = arrayIndexOf( upperDays[ 0 ], value );
    }
    return ret;
}

function getIndexOfMonth(cal, value, abbr) {
    var months = cal.months,
        monthsGen = cal.monthsGenitive || cal.months,
        upperMonths = cal._upperMonths,
        upperMonthsGen = cal._upperMonthsGen;
    if ( !upperMonths ) {
        cal._upperMonths = upperMonths = [
            toUpperArray( months.names ),
            toUpperArray( months.namesAbbr )
        ];
        cal._upperMonthsGen = upperMonthsGen = [
            toUpperArray( monthsGen.names ),
            toUpperArray( monthsGen.namesAbbr )
        ];
    }
    value = toUpper( value );
    var i = arrayIndexOf( abbr ? upperMonths[ 1 ] : upperMonths[ 0 ], value );
    if ( i < 0 ) {
        i = arrayIndexOf( abbr ? upperMonthsGen[ 1 ] : upperMonthsGen[ 0 ], value );
    }
    return i;
}

function appendMatchStringCount(preMatch, strings) {
    var quoteCount = 0,
        escaped = false;
    for ( var i = 0, il = preMatch.length; i < il; i++ ) {
        var c = preMatch.charAt( i );
        if(c == '\''){
            escaped ? strings.push( "'" ) : quoteCount++;
            escaped = false;
        } else if( c == '\\'){
            if (escaped) strings.push( "\\" );
            escaped = !escaped;
        } else {
            strings.push( c );
            escaped = false;
        }
    }
    return quoteCount;
}


function parseDayByInt(value, format, culture, cal) {
    if (!value) {
        return null;
    }
    var index = 0, valueX = 0, day = null;
    format = format.split("");
    length = format.length;
    var countDays = function (match) {
        var i = 0;
        while (format[index] === match) {
            i++;
            index++;
        }
        if (i > 0) {
            index -= 1;
        }
        return i;
    },
    getNumber = function (size) {
        var rg = new RegExp('^\\d{1,' + size + '}'),
            match = value.substr(valueX, size).match(rg);

        if (match) {
            match = match[0];
            valueX += match.length;
            return parseInt(match, 10);
        }
        return null;
    },
    getName = function (names, lower) {
        var i = 0,
            length = names.length,
            name, nameLength,
            subValue;

        for (; i < length; i++) {
            name = names[i];
            nameLength = name.length;
            subValue = value.substr(valueX, nameLength);

            if (lower) {
                subValue = subValue.toLowerCase();
            }

            if (subValue == name) {
                valueX += nameLength;
                return i + 1;
            }
        }
        return null;
    },
     lowerArray = function (data) {
         var index = 0,
             length = data.length,
             array = [];

         for (; index < length; index++) {
             array[index] = (data[index] + "").toLowerCase();
         }

         return array;
     },
     lowerInfo = function (localInfo) {
         var newLocalInfo = {}, property;

         for (property in localInfo) {
             newLocalInfo[property] = lowerArray(localInfo[property]);
         }

         return newLocalInfo;
     };
    for (; index < length; index++) {
        ch = format[index];
        if (ch === "d") {
            count = countDays("d");
            if (!cal._lowerDays) {
                cal._lowerDays = lowerInfo(cal.days);
            }
            day = count < 3 ? getNumber(2) : getName(cal._lowerDays[count == 3 ? "namesAbbr" : "names"], true)
        }
    }
    return day;
}


function getFullDateFormat(cal, format) {
    // expands unspecified or single character date formats into the full pattern.
    format = format || "F";
    var pattern,
        patterns = cal.patterns,
        len = format.length;
    if ( len === 1 ) {
        pattern = patterns[ format ];
        if ( !pattern ) {
            throw "Invalid date format string '" + format + "'.";
        }
        format = pattern;
    }
    else if ( len === 2  && format.charAt(0) === "%" ) {
        // %X escape format -- intended as a custom format string that is only one character, not a built-in format.
        format = format.charAt( 1 );
    }
    return format;
}

ej.globalize._getDateParseRegExp = function (cal, format) {
    // converts a format string into a regular expression with groups that
    // can be used to extract date fields from a date string.
    // check for a cached parse regex.
    var re = cal._parseRegExp;
    if ( !re ) {
        cal._parseRegExp = re = {};
    }
    else {
        var reFormat = re[ format ];
        if ( reFormat ) {
            return reFormat;
        }
    }

    // expand single digit formats, then escape regular expression characters.
    var expFormat = getFullDateFormat( cal, format ).replace( /([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1" ),
        regexp = ["^"],
        groups = [],
        index = 0,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        match;

    // iterate through each date token found.
    while ( (match = tokenRegExp.exec( expFormat )) !== null ) {
        var preMatch = expFormat.slice( index, match.index );
        index = tokenRegExp.lastIndex;

        // don't replace any matches that occur inside a string literal.
        quoteCount += appendMatchStringCount( preMatch, regexp );
        if ( quoteCount % 2 ) {
            regexp.push( match[ 0 ] );
            continue;
        }

        // add a regex group for the token.
        var m = match[ 0 ],
            len = m.length,
            add;
            
        switch ( m ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER: case dateFormat.DAY_OF_WEEK_FULL_NAME:
            case dateFormat.MONTH_FULL_NAME: case dateFormat.MONTH_THREE_LETTER:
                add = "(\\D+)";
                break;
            case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                add = "(\\D*)";
                break;
            case dateFormat.YEAR_FULL:
            case dateFormat.MILLISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.DECISECONDS:
                add = "(\\d{" + len + "})";
                break;
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT: case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT: case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.MINUTES_DOUBLE_DIGIT: case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT: case dateFormat.SECONDS_SINGLE_DIGIT:
                add = "(\\d\\d?)";
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                add = "([+-]?\\d\\d?:\\d{2})";
                break;
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
                add = "([+-]?\\d\\d?)";
                break;
            case dateFormat.DATE_SEPARATOR:
                add = "(\\" + cal["/"] + ")";
                break;
            default:
                throw "Invalid date format pattern '" + m + "'.";
                break;
        }
        if ( add ) {
            regexp.push( add );
        }
        groups.push( match[ 0 ] );
    }
    appendMatchStringCount( expFormat.slice( index ), regexp );
    regexp.push( "$" );

    // allow whitespace to differ when matching formats.
    var regexpStr = regexp.join( '' ).replace( /\s+/g, "\\s+" ),
        parseRegExp = {'regExp': regexpStr, 'groups': groups};

    // cache the regex for this format.
    return re[ format ] = parseRegExp;
}

function getParsedDate(value, format, culture) {
    // try to parse the date string by matching against the format string
    // while using the specified culture for date field names.
    value = trim( value );
    format = trim(format);
    var cal = culture.calendar,
        // convert date formats into regular expressions with groupings.
        parseInfo = ej.globalize._getDateParseRegExp(cal, format),
        match = new RegExp(parseInfo.regExp).exec(value);
    if (match === null) {
        return null;
    }
    // found a date format that matches the input.
    var groups = parseInfo.groups,
        year = null, month = null, date = null, weekDay = null,
        hour = 0, hourOffset, min = 0, sec = 0, msec = 0, tzMinOffset = null,
        pmHour = false;
    // iterate the format groups to extract and set the date fields.
    for ( var j = 0, jl = groups.length; j < jl; j++ ) {
        var matchGroup = match[ j + 1 ];
        if ( matchGroup ) {
            var current = groups[ j ],
                clength = current.length,
                matchInt = parseInt( matchGroup, 10 );
            
            switch ( current ) {
                case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
                    date = matchInt;
                    if ( valueOutOfRange( date, 1, 31 ) ) return null;
                    break;
                case dateFormat.MONTH_THREE_LETTER:
                case dateFormat.MONTH_FULL_NAME:
                    month = getIndexOfMonth( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.MONTH_SINGLE_DIGIT: case dateFormat.MONTH_DOUBLE_DIGIT:
                    month = matchInt - 1;
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.YEAR_SINGLE_DIGIT: case dateFormat.YEAR_DOUBLE_DIGIT:
                case dateFormat.YEAR_FULL:
                    year = clength < 4 ? expandYear( cal, matchInt ) : matchInt;
                    if ( valueOutOfRange( year, 0, 9999 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                    hour = matchInt;
                    if ( hour === 12 ) hour = 0;
                    if ( valueOutOfRange( hour, 0, 11 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                    hour = matchInt;
                    if ( valueOutOfRange( hour, 0, 23 ) ) return null;
                    break;
                case dateFormat.MINUTES_SINGLE_DIGIT: case dateFormat.MINUTES_DOUBLE_DIGIT:
                    min = matchInt;
                    if ( valueOutOfRange( min, 0, 59 ) ) return null;
                    break;
                case dateFormat.SECONDS_SINGLE_DIGIT: case dateFormat.SECONDS_DOUBLE_DIGIT:
                    sec = matchInt;
                    if ( valueOutOfRange( sec, 0, 59 ) ) return null;
                    break;
                case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                    pmHour = cal.PM && ( matchGroup === cal.PM[0] || matchGroup === cal.PM[1] || matchGroup === cal.PM[2] );
                    if ( !pmHour && ( !cal.AM || (matchGroup !== cal.AM[0] && matchGroup !== cal.AM[1] && matchGroup !== cal.AM[2]) ) ) return null;
                    break;
                case dateFormat.DECISECONDS:
                case dateFormat.CENTISECONDS:
                case dateFormat.MILLISECONDS:
                    msec = matchInt * Math.pow( 10, 3-clength );
                    if ( valueOutOfRange( msec, 0, 999 ) ) return null;
                    break;
                case dateFormat.DAY_OF_WEEK_THREE_LETTER:
                    date = parseDayByInt(value, format, culture, cal);
                    break;
                case dateFormat.DAY_OF_WEEK_FULL_NAME:
                     getIndexOfDay( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( weekDay, 0, 6 ) ) return null;
                    break;
                case dateFormat.TIME_ZONE_OFFSET_FULL:
                    var offsets = matchGroup.split( /:/ );
                    if ( offsets.length !== 2 ) return null;

                    hourOffset = parseInt( offsets[ 0 ], 10 );
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    
                    var minOffset = parseInt( offsets[ 1 ], 10 );
                    if ( valueOutOfRange( minOffset, 0, 59 ) ) return null;
                    
                    tzMinOffset = (hourOffset * 60) + (patternStartsWith( matchGroup, '-' ) ? -minOffset : minOffset);
                    break;
                case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                    // Time zone offset in +/- hours.
                    hourOffset = matchInt;
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    tzMinOffset = hourOffset * 60;
                    break;
            }
        }
    }
    var result = new Date(), defaultYear, convert = cal.convert;
    defaultYear = convert ? convert.fromGregorian( result )[ 0 ] : result.getFullYear();
    if ( year === null ) {
        year = defaultYear;
    }
    
    // set default day and month to 1 and January, so if unspecified, these are the defaults
    // instead of the current day/month.
    if ( month === null ) {
        month = 0;
    }
    if ( date === null ) {
        date = 1;
    }
    // now have year, month, and date, but in the culture's calendar.
    if ( convert ) {
        result = convert.toGregorian( year, month, date );
        if ( result === null ) return null;
    }
    else {
        // have to set year, month and date together to avoid overflow based on current date.
        result.setFullYear( year, month, date );
        // check to see if date overflowed for specified month (only checked 1-31 above).
        if ( result.getDate() !== date ) return null;
        // invalid day of week.
        if ( weekDay !== null && result.getDay() !== weekDay ) {
            return null;
        }
    }
    // if pm designator token was found make sure the hours fit the 24-hour clock.
    if ( pmHour && hour < 12 ) {
        hour += 12;
    }
    result.setHours( hour, min, sec, msec );
    if ( tzMinOffset !== null ) {
        var adjustedMin = result.getMinutes() - ( tzMinOffset + result.getTimezoneOffset() );
        result.setHours( result.getHours() + parseInt( adjustedMin / 60, 10 ), adjustedMin % 60 );
    }
    return result;
}


function formatDateToCulture(value, format, culture) {
    var cal = culture.calendar,
        convert = cal.convert;
    if ( !format || !format.length || format === 'i' ) {
        var ret;
        if ( culture && culture.name.length ) {
            if ( convert ) {
                // non-gregorian calendar, so we cannot use built-in toLocaleString()
                ret = formatDateToCulture( value, cal.patterns.F, culture );
            }
            else {
                ret = value.toLocaleString();
            }
        }
        else {
            ret = value.toString();
        }
        return ret;
    }

    var sortable = format === "s";
        format = getFullDateFormat(cal, format);


    // Start with an empty string
    ret = [];
    var hour,
        zeros = ['0','00','000'],
        foundDay,
        checkedDay,
        dayPartRegExp = /([^d]|^)(d|dd)([^d]|$)/g,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        converted;

    function padWithZeros(num, c) {
        var r, s = num+'';
        if ( c > 1 && s.length < c ) {
            r = ( zeros[ c - 2 ] + s);
            return r.substr( r.length - c, c );
        }
        else {
            r = s;
        }
        return r;
    }

    function hasDay() {
        if ( foundDay || checkedDay ) {
            return foundDay;
        }
        foundDay = dayPartRegExp.test( format );
        checkedDay = true;
        return foundDay;
    }

    if ( !sortable && convert ) {
        converted = convert.fromGregorian( value );
    }

    for (;;) {
        // Save the current index
        var index = tokenRegExp.lastIndex,
            // Look for the next pattern
            ar = tokenRegExp.exec( format );

        // Append the text before the pattern (or the end of the string if not found)
        var preMatch = format.slice( index, ar ? ar.index : format.length );
        quoteCount += appendMatchStringCount( preMatch, ret );

        if ( !ar ) {
            break;
        }

        // do not replace any matches that occur inside a string literal.
        if ( quoteCount % 2 ) {
            ret.push( ar[ 0 ] );
            continue;
        }

        var current = ar[ 0 ],
            clength = current.length;


        switch ( current ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER:
            case dateFormat.DAY_OF_WEEK_FULL_NAME:
                var names = (clength === 3) ? cal.days.namesAbbr : cal.days.names;
                ret.push( names[ value.getDay() ] );
                break;
            case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT:
                foundDay = true;
                ret.push( padWithZeros( (converted ? converted[2] : value.getDate()), clength ) );
                break;
            case dateFormat.MONTH_THREE_LETTER:
            case dateFormat.MONTH_FULL_NAME:
                var part = converted ? converted[1] : value.getMonth();
                ret.push( (cal.monthsGenitive && hasDay())
                    ? cal.monthsGenitive[ clength === 3 ? "namesAbbr" : "names" ][ part ]
                    : cal.months[ clength === 3 ? "namesAbbr" : "names" ][ part ] );
                break;
            case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT:
                ret.push( padWithZeros((converted ? converted[1] : value.getMonth()) + 1, clength ) );
                break;
            case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT:
            case dateFormat.YEAR_FULL:
                part = converted ? converted[ 0 ] : value.getFullYear();
                if ( clength < 4 ) {
                    part = part % 100;
                }
                ret.push( padWithZeros( part, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                hour = value.getHours() % 12;
                if ( hour === 0 ) hour = 12;
                ret.push( padWithZeros( hour, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                ret.push( padWithZeros( value.getHours(), clength ) );
                break;
            case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.MINUTES_DOUBLE_DIGIT:
                ret.push( padWithZeros( value.getMinutes(), clength ) );
                break;
            case dateFormat.SECONDS_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT:
                ret.push( padWithZeros(value .getSeconds(), clength ) );
                break;
            case dateFormat.MERIDIAN_INDICATOR_SINGLE:
            case dateFormat.MERIDIAN_INDICATOR_FULL:
                part = value.getHours() < 12 ? (cal.AM ? cal.AM[0] : " ") : (cal.PM ? cal.PM[0] : " ");
                ret.push( clength === 1 ? part.charAt( 0 ) : part );
                break;
            case dateFormat.DECISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.MILLISECONDS:
                ret.push( padWithZeros( value.getMilliseconds(), 3 ).substr( 0, clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), 2 ) +
                    ":" + padWithZeros( Math.abs( value.getTimezoneOffset() % 60 ), 2 ) );
                break;
            case dateFormat.DATE_SEPARATOR:
                ret.push( cal["/"] || "/" );
                break;
            default:
                throw "Invalid date format pattern '" + current + "'.";
                break;
        }
    }
    return ret.join( '' );
}

//add new culture into ej 
ej.globalize.addCulture = function (name, culture) {
    ej.cultures[name] = $.extend(true, $.extend(true, {}, ej.cultures['default'], culture), ej.cultures[name]);
	ej.cultures[name].calendar = ej.cultures[name].calendars.standard;
}

//return the specified culture or default if not found
ej.globalize.preferredCulture = function (culture) {
    culture = (typeof culture != "undefined" && typeof culture === typeof this.cultureObject) ? culture.name : culture;
    this.cultureObject = ej.globalize.findCulture(culture);
    return this.cultureObject;
}
ej.globalize.setCulture = function (culture) {
	if (ej.isNullOrUndefined(this.globalCultureObject)) this.globalCultureObject = ej.globalize.findCulture(culture);
	culture = (typeof culture != "undefined" && typeof culture === typeof this.globalCultureObject) ? culture.name : culture;
    if (culture) this.globalCultureObject = ej.globalize.findCulture(culture);
    ej.cultures.current = this.globalCultureObject;
    return this.globalCultureObject;
}
ej.globalize.culture=function(name){
    ej.cultures.current = ej.globalize.findCulture(name);
}

//return the specified culture or current else default if not found
ej.globalize.findCulture = function (culture) {
    var cultureObject;
    if (culture) {

        if ($.isPlainObject(culture) && culture.numberFormat) {
            cultureObject = culture;
        }
        if (typeof culture === "string") {
            var cultures = ej.cultures;
            if (cultures[culture]) {
                return cultures[culture];
            }
            else {
                if (culture.indexOf("-") > -1) {
                    var cultureShortName = culture.split("-")[0];
                    if (cultures[cultureShortName]) {
                        return cultures[cultureShortName];
                    }
                }
                else {
                    var cultureArray = $.map(cultures, function (el) { return el });
                    for (var i = 0; i < cultureArray.length; i++) {
                        var shortName = cultureArray[i].name.split("-")[0];
                        if (shortName === culture) {
                            return cultureArray[i];
                        }
                    };
                }
            }
            return ej.cultures["default"];
        }
    }
    else {
        cultureObject = ej.cultures.current || ej.cultures["default"];
    }

    return cultureObject;
}
//formatting date and number based on given format
ej.globalize.format = function (value, format, culture) {
    var cultureObject =  ej.globalize.findCulture(culture);
    if (typeof(value) === 'number') {
        value = formatNumberToCulture(value, format, cultureObject);
    } else if(value instanceof Date){
    	value = formatDateToCulture(value, format, cultureObject);
    }

    return value;
}

//parsing integer takes string as input and return as number
ej.globalize.parseInt = function(value, radix, culture) {
	if(!radix)
		radix = 10;
    return Math.floor( parseValue( value, culture, radix ) );
}

//returns the ISO date string from date object
ej.globalize.getISODate = function(value) {
    if(value instanceof Date) return value.toISOString();
}

//parsing floationg poing number takes string as input and return as number
ej.globalize.parseFloat = function(value, radix, culture) {
	if (typeof radix === "string") {
        culture = radix;
        radix = 10;
    }
    return parseValue( value, culture);
}

//parsing date takes string as input and return as date object
ej.globalize.parseDate = function(value, formats, culture) {
    culture = ej.globalize.findCulture(culture);

    var date, prop, patterns;
    if ( formats ) {
        if ( typeof formats === "string" ) {
            formats = [ formats ];
        }
        if ( formats.length ) {
            for ( var i = 0, l = formats.length; i < l; i++ ) {
                var format = formats[ i ];
                if ( format ) {
                    date = getParsedDate( value, format, culture );
                    if ( date ) break;
                }
            }
        }
    }
    else {
        patterns = culture.calendar.patterns;
        for ( prop in patterns ) {
            date = getParsedDate( value, patterns[prop], culture );
            if ( date ) break;
        }
    }
    return date || null;
}

function getControlObject(obj, stringArray){
    return stringArray.length ? getControlObject(obj[stringArray[0]], stringArray.slice(1)) : obj;
}

//return localized constants as object for the given widget control and culture
ej.globalize.getLocalizedConstants = function(controlName, culture){
    var returnObject,
        controlNameArray = controlName.replace("ej.", "").split(".");
    
    returnObject = getControlObject(ej, controlNameArray);

    return ( $.extend(true, {}, returnObject.Locale['default'], returnObject.Locale[culture ? culture : this.cultureObject.name]) ) ;
}

$.extend(ej, ej.globalize);

}(jQuery));;
/**
* @fileOverview Plugin to style the Waiting pop elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejWaitingPopup", "ej.WaitingPopup", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,
        _rootCSS: "e-waitingpopup",


        defaults: {

            showOnInit: false,

            target: null,

            appendTo: null,

            showImage: true,

            htmlAttributes: {},

            cssClass: "",

            text: null,

            template: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            showOnInit: "boolean",
            showImage: "boolean",
            cssClass: "string"
        },
		_isTargetVisible: function(){
			return this.element.css('display') != 'none';
		},
        show: function () {
			if(this._isTargetVisible()){
				this._refreshPanel();
				this.maindiv.css("display", "block");
				this.model.showOnInit = true;
			}
        },

        hide: function () {
			this.maindiv.css("display", "none");
			this.model.showOnInit = false;
        },

        refresh: function () {
            if(this._isTargetVisible())
				this._refreshPanel();
        },

        _setText: function (text) {
            if (text) {
                if (this.popupText) this.popupText.html(text);
                else {
                    this._generateTextTag(text);
                    this._setContentPosition();
                }
            }
            else if (this.popupText) {
                this.popupText.remove();
                this.popupText = null;
            }
        },

        _showImage: function (boolean) {
            if (boolean) {
                this.popupImage = ej.buildTag("span.e-image");
                if (this.popupText) this.popupImage.insertBefore(this.popupText);
                else this.maindiv.append(this.popupImage);
            }
            else if (this.popupImage) {
                this.popupImage.remove();
                this.popupImage = null;
            }
        },

        _setTemplate: function () {
            var template = this.model.template;
            if (typeof template === "string") template = $(template);
            if (typeof template === "object" && typeof template.css === "function")
                this.templateObj = template;
            else
                this.templateObj = ej.buildTag("div", "", { "text-align": "center" }).append(template);

            this.templateObj.css({ "visibility": "visible", "display": "block" });
            this.maindiv.append(this.templateObj);
        },

        _setTheme: function (skin) {
            this.maindiv.removeClass(this.model.cssClass).addClass(skin);
        },



        _init: function () {
			this._initialize();
			this._render();
			this._wireEvents();
        },

        _wireEvents: function () {
            $(window).on('resize', $.proxy(this._resizeHandler, this));
        },
        _unwireEvents: function () {
            $(window).off("resize", $.proxy(this._resizeHandler, this));
        },

        _resizeHandler: function () {
            this.refresh();
         },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "text": this._setText(options[option]); break;
                    case "cssClass": this._setTheme(options[option]); break;
                    case "htmlAttributes ": this._addAttr(options[option]); break;
                    case "showOnInit": this._setVisibility(options[option]); break;
                    case "showImage": this._showImage(options[option]); this._setContentPosition(); break;
                    case "target": this.model.target = options[option]; this._setTarget(); this.refresh(); break;
                    case "appendTo": this.model.appendTo = options[option]; this._setTarget();
                        if (!ej.isNullOrUndefined(this.model.appendTo) && this.model.appendTo != "document" && this.model.appendTo != "window")
                            this.maindiv.appendTo($(this.model.appendTo));
                        else
                            $('body').append(this.maindiv);
                        this.refresh(); break;
                    case "template":
                        this.maindiv.empty();
                        if (options[option]) {
                            this.model.template = options[option];
                            this._setTemplate();
                        }
                        else {
                            this.model.template = options[option] = null;
                            this._showImage(this.model.showImage);
                            if (this.model.text) this._generateTextTag(this.model.text);
                        }
                        this._setContentPosition();
                        break;
                }
            }
        },
        _setTarget: function () {
            if (this.model.target == "document") 
                this.targetElement = $(document);
            else if (this.model.target == "window")
                this.targetElement = $(window);
            else
                this.targetElement = this.model.target ? $(this.model.target) : this.element;
        },
        _destroy: function () {
            this.maindiv.remove();
			this._unwireEvents();
        },

        _initialize: function () {
            this.maindiv = null;
            this.popupText = null;
            this.popupImage = null;
            this.templateObj = null;
            this.targetElement = null;
        },


        _render: function () {
            this._setTarget();
            var oldWrapper = $("#" + this.element[0].id + "_WaitingPopup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.maindiv = ej.buildTag("div.e-waitpopup-pane e-widget " + this.model.cssClass + "#" + this.element[0].id + "_WaitingPopup");
            if (this.model.template) {
                this._setTemplate();
            }
            else {
                this._showImage(this.model.showImage);
                if (this.model.text) {
                    this._generateTextTag(this.model.text);
                }
            }
            if (!ej.isNullOrUndefined(this.model.appendTo) && this.model.appendTo != "document" && this.model.appendTo != "window")
                this.maindiv.appendTo($(this.model.appendTo));
            else
                $('body').append(this.maindiv);
            this._setVisibility(this.model.showOnInit);
            this._addAttr(this.model.htmlAttributes);
        },

        _refreshPanel: function () {
            this.maindiv.width(this.targetElement.outerWidth());
            this.maindiv.height(this.targetElement.outerHeight());
            this._setPanelPosition();
            this._setContentPosition();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.maindiv.addClass(value);
                else proxy.maindiv.attr(key, value)
            });
        },

        _setPanelPosition: function () {			 
            var location = ej.util.getOffset(this.targetElement);
			if(this.model.appendTo != null && $(this.model.appendTo).length >0) {				
				if ((this.targetElement.css("position") == "relative" || this.targetElement.css("position") == "absolute") && this.targetElement[0] === $(this.model.appendTo)[0] ) {					
					location = {left:0, top:0};														
				}
				else{
					location.left -= this.targetElement.offsetParent().offset().left;
					location.top -= this.targetElement.offsetParent().offset().top;
				}
			}
            this.maindiv.css({
                "position": "absolute",
                "left": Math.ceil(location.left) + "px",
                "top": Math.ceil(location.top) + "px",
                "z-index": this._maxZindex() + 1
            });
        },

        _setContentPosition: function () {
            if (this.model.template == null) {
                var textHeight = 0, imgHeight = 0, targetHeight, top = null;
                targetHeight = this.targetElement.outerHeight();
                if (this.popupText) textHeight = this.popupText.outerHeight();
                if (this.popupImage) imgHeight = this.popupImage.outerHeight();

                if (this.popupImage) {
                    top = Math.ceil((targetHeight - (imgHeight + textHeight)) / 2);
                    this.popupImage.css("top", top + "px");
                }
                if (this.popupText) {
                    if (!top) top = Math.ceil((targetHeight - textHeight) / 2);
                    this.popupText.css("top", top + "px");
                }
            }
            else {
                this.templateObj.css({
                    "position": "relative",
                    "left": Math.ceil((this.targetElement.outerWidth() - this.templateObj.outerWidth()) / 2),
                    "top": Math.ceil((this.targetElement.outerHeight() - this.templateObj.outerHeight()) / 2)
                });
            }
        },

        _generateTextTag: function (text) {
            this.popupText = ej.buildTag("div.e-text", text);
            this.maindiv.append(this.popupText);
        },

        _setVisibility: function (showOnInit) {
            if (showOnInit && this._isTargetVisible()) this.show();
            else this.hide();
        },

        _maxZindex: function () {
            return ej.util.getZindexPartial(this.element);
        }
    });
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejButton", "ej.Button", {

        element: null,

        model: null,
        validTags: ["button", "input"],
        _setFirst: false,

        _rootCSS: "e-button",
        _requiresID: true,

        defaults: {

            size: "normal",

            type: "submit",

            height: "",

            width: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            showRoundedCorner: false,

            cssClass: "",

            prefixIcon: null,

            suffixIcon: null,

            enableRTL: false,

            repeatButton: false,

            timeInterval: "150",

            create: null,

            click: null,

            destroy: null
        },


        dataTypes: {
            size: "enum",
            enabled: "boolean",
            type: "enum",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            repeatButton: "boolean",
            enableRTL: "boolean",
            timeInterval: "string",
            htmlAttributes: "data"
        },

        disable: function () {
            this.element.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            this.element.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._render();
            this._controlStatus(this.model.enabled);
            this._wireEvents(this.model.repeatButton);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value);
                if (key == "disabled" && value == "disabled") proxy.disable();
            });
        },

        _destroy: function () {
            this._off(this.element, "blur", this._btnBlur);
            this.element.removeClass(this.model.cssClass + "e-ntouch e-btn e-txt e-select e-disable e-corner e-widget").removeAttr("role aria-describedby aria-disabled");
            !this._cloneElement.attr("type") && this.element.attr("type") && this.element.removeAttr("type");			
            this.element.removeClass("e-btn-" + this.model.size);
            this.model.contentType && this.model.contentType != "textonly" ? this.element.append(this._cloneElement.text()) && this.imgtxtwrap[0].remove() : "";
            
        },


        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        if (!this.element.is("input"))
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        if (!this.element.is("input"))
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "timeInterval":
                        this.model.timeInterval = options[option];
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },


        _setSize: function (val) {
            this.element.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.element.addClass("e-btn-" + val);
        },
        _setType: function (val) {
            this.element.prop({ "type": val });
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function (val) {
            this.element.css('width', val);
        },

        _setText: function (val) {
            if (this.buttonType == "inputButton") {
                this.element.val(val);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.element.html(val);
                } else {
                    this.textspan.html(val);
                }
            }
            this.model.text = val;
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
            this.model.prefixIcon = val;
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
            this.model.suffixIcon = val;
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                if (!this.element.is("input"))
                this._renderButtonNormal();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.element.empty();
                this.model.imagePosition = val;
                if (!this.element.is("input"))
                this._renderButtonNormal();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.element.addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
        },

        _initialize: function () {
            if(!ej.isTouchDevice()) this.element.addClass("e-ntouch");
            if (this.element.is("input")) {
                this.buttonType = "inputButton";
            }
            else if ((this.element.is("a")) || (this.element.is("button"))) {
                this.buttonType = "tagButton";
            }
            else {
                this.element.removeClass("e-button");
            }
            if (this.element.attr("type")) {
                this.model.type = this.element.attr("type");
            }
            else
                this._setType(this.model.type);
            this._timeout = null;
        },


        _render: function () {
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this.element.addClass(this.model.cssClass + " e-btn e-select e-widget").attr("role", "button");
            if (this.buttonType == "inputButton") {
                this.element.addClass("e-txt");
                if ((this.model.text != null) && (this.model.text != "")) {
                    this.element.val(this.model.text);
                } else {
                    this.model.text = this.element.val();
                }
            } else { this._renderButtonNormal(); }
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.element[0].id)
                this.element.attr("aria-describedby", this.element[0].id);
        },

        _renderButtonNormal: function () {
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.html();
            }
            this.element.empty();
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            if (this.model.contentType.indexOf("image") > -1) {
                this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
                this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
                this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');
            }

            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
                this.element.append(this.imgtxtwrap);
            } else {
                this.element.addClass("e-txt");
                this.element.html(this.model.text);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.element.addClass('e-corner') : this.element.removeClass('e-corner');
        },

        _wireEvents: function (val) {
            if (val) {
                this._on(this.element, "mousedown", this._btnRepatMouseClickEvent);
                this._on($(document), 'mouseup', this._mouseUpClick);
                this._on(this.element, "keyup", this._btnRepatKeyUpEvent);
                this._on($(document), "keypress", this._btnRepatKeyDownEvent);

            }
            this._on(this.element, "click", this._btnMouseClickEvent);
            this._on(this.element, "blur", this._btnBlur);
        },

        _btnBlur:function(e){
            this.element.removeClass("e-animate");
        },

        _btnMouseClickEvent: function (e) {
            var self = this;
            this.element.addClass("e-animate");
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                // here aregument 'e' used in serverside events 
                var args = { target: e.currentTarget, e : e , status:self.model.enabled};
                self._trigger("click", args);
            } 
        },

        _btnRepatMouseClickEvent: function (e) {
            var self = this;
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.button == 0) || (e.which == 1)) {

                    self._timeout = setInterval(function () { self._trigger("click", { target: e.currentTarget, status: self.model.enabled }); }, this.model.timeInterval);
                }
            }
        },

        _mouseUpClick: function (event) {
            clearTimeout(this._timeout);
        },

        _btnRepatKeyDownEvent: function (e) {
            var self = this;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.keyCode == 32) || (e.keyCode == 13)) {
                    self._trigger("click", args);
                }
            }
        },

        _btnRepatKeyUpEvent: function (e) {
            if ((e.keyCode == 32) || (e.keyCode == 13)) {
                clearTimeout(this._timeout);
            }
        },
    });


    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft",
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
		ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
        Large: "large"
    };

    ej.ButtonType = {
		/**  Creates button with inbuilt button type specified */
		Button : "button",
		/**  Creates button with inbuilt reset type specified */
		Reset: "reset", 
		/**  Creates button with inbuilt submit type specified */
		Submit: "submit"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html CheckBox elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejCheckBox", "ej.CheckBox", {
        _rootCSS: "e-checkbox",

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["checked", "checkState"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            id: null,

            name: null,

            value: null,

            htmlAttributes: {},

            checked: false,

            enabled: true,

            enableTriState: false,

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            idPrefix: "ej",

            size: "small",

            checkState: "uncheck",

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            enableTriState: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },
        observables: ["checked", "checkState"],
        checked: ej.util.valueFunction("checked"),
        checkState: ej.util.valueFunction("checkState"),

        _init: function (options) {
            this._cloneElement = this.element.clone();
            var browserInfo = ej.browserInfo();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._isIE9 = (browserInfo.name == 'msie' && browserInfo.version == '9.0') ? true : false;
            this._isDevice = this._checkDevice();
            this._setValue();
            this._renderControl();
            this.model.enableRTL && this._setRTL();
            if (this.model.enabled)
                this._wireEvents();
            this._setEnabled(this.model.enabled);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._addAttr(this.model.htmlAttributes);
            if (this._isIE9 || this._isIE8) {
                // In IE8 and IE9, the text of the checkox will float to next line while the length of the text is high fixed this by adding the following class and procssed with CSS
                this.wrapper.addClass("e-tb-cell");
            }
        },
        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },
        _setRTL: function () {
            $(this.maindiv).addClass("e-rtl");
        },
        _initValidator: function () {
            (!this.wrapper.closest("form").data("validator")) && this.wrapper.closest("form").validate();
        },
        _setValidation: function () {
            this.wrapper.find('input').rules("add", this.model.validationRules);
            var validator = this.wrapper.closest("form").data("validator");
            validator = validator ? validator : this.wrapper.closest("form").validate();
            name = this.wrapper.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "name") proxy.element.attr(key, value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._setEnabled(false);
                else if (key == "checked" && value == "checked") {
                    if (proxy.checked() instanceof Array)
                        proxy._updateCheckedItem();
                    else
                        proxy._checked(true);
                }
                else proxy.wrapper.attr(key, value);
            });
        },

        _triggerBeforeChange: function () {
            var data = { isChecked: this._isChecked, isInteraction: false };
            if (true == this._trigger("beforeChange", data)) return false;
        },

        _triggerChange: function () {
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: false };
            this._trigger("change", data);
        },

        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "checked":
                        $(this.maindiv).removeClass("e-material-animate");
                        if (this.model.beforeChange) this._triggerBeforeChange();
                        if (this.checked() instanceof Array) {
                            var checkedItemArray = ej.util.getVal(options[prop]);
                            var lastVal = checkedItemArray[checkedItemArray.length - 1];
                            if (this.model.value == lastVal) this._isChecked = true;
                        }
                        else {
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checked(this._isChecked);
                        }
                        this._isChecked ? this._checked() : this._unChecked();
                        if (this.model.change) this._triggerChange();
                        break;
                    case "enableTriState":
                        if (options[prop]) {
                            this.model.enableTriState = options[prop];
                            this._indeterminateState = options[prop];
                        }
                        break;
                    case "checkState":
                        if (this.model.enableTriState) {
                            if (this.model.beforeChange) this._triggerBeforeChange();
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checkState(this._isChecked);
                            this._changeState(this._isChecked);
                            this._setCheckBoxState();
                            this.checked(this._isChecked);
                            if (this.model.checkState == "indeterminate")
                                this._setIndeterminate(this._indeterminateState);
                            if (this.checked() instanceof Array)
                                this._updateCheckedItem();
                            else if (options[prop] == "check") this._hiddenInput.removeAttribute("name");
                            else this._hiddenInput.setAttribute("name", this.model.name);
                            if (this.model.change) {
                                if (!(this.checked() instanceof Array)) this._isChecked = this.checkState() == "uncheck" ? false : true;
                                this._triggerChange();
                            }
                        }
                        break;
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        (options[prop]) ? this._setRTL() : $(this.maindiv).removeClass("e-rtl");
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.wrapper.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
					this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                         break;
					case "validationMessages":
					  this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.element.attr('name', options[prop]);
                        if (!this._isChecked || this.spanImg.hasClass("e-chk-indeter")) this._hiddenInput.setAttribute('name', options[prop]);
                        this.model.name = options[prop];
                        break;
                    case "value": this.element.attr('value', options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[prop]); break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.element.removeClass("e-checkbox e-input");
            !this._cloneElement.attr("name") && this.element.attr("name") && this.element.removeAttr("name");
            !this._cloneElement.attr("value") && this.element.attr("value") && this.element.removeAttr("value");
            this.element.insertBefore(this.wrapper);
            this.wrapper.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.wrapper.removeClass(this.model.cssClass).addClass(skin);
                $("#" + this.model.idPrefix + this.model.id + "_wrapper").removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            this._indeterminateState = false;
            this._isChecked = false;
            var _id = this.element[0].getAttribute("id"), _name = this.element[0].getAttribute('name'), _value = this.element[0].getAttribute('value');
            !ej.isNullOrUndefined(_id) && (this.model.id = _id);
            !ej.isNullOrUndefined(_name) && (this.model.name = _name);
            if (!ej.isNullOrUndefined(_value) && _value != "") this.model.value = _value;
            if (!this.checked() && !ej.isNullOrUndefined(this.element.attr('checked'))) this._isChecked = true;
            ej.isNullOrUndefined(this.model.name) && (this.model.name = this.model.id);
            this.model.enabled = this.model.enabled && !this.element.attr("disabled");
        },

        _setSize: function (val) {
            if (val == ej.CheckboxSize.Medium) {
                $(this.innerdiv).removeClass('e-chkbox-small').addClass('e-chkbox-medium');
                $(this.maindiv).removeClass('e-check-small').addClass('e-check-medium');
				
			}
            else {
                $(this.innerdiv).removeClass('e-chkbox-medium').addClass('e-chkbox-small');
				$(this.maindiv).removeClass('e-check-medium').addClass('e-check-small');
			}
        },

        _setRoundedCorner: function (val) {
            if (val)
                this.span.addClass("e-corner");
            else
                this.span.removeClass("e-corner");
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },
        _setCheckBoxState: function () {
            if (this.model.enableTriState) {
                if (this.checkState() == "indeterminate")
                    this._indeterminateState = true;
                else if (this.checkState() == "check")
                    this._isChecked = true;
                else if (this.checkState() == "uncheck")
                    this._isChecked = false;
            }
            else if (this.checkState() == "indeterminate")
                this.checkState("uncheck");
        },
        _createElement: function (tagName, attrs) {
            var ele = document.createElement(tagName);
            this._setAttributes(ele, attrs);
            return ele;
        },
        _setAttributes: function (ele, attrs) {
            for (var key in attrs) {
                ele.setAttribute(key, attrs[key]);
            }
        },
        _renderControl: function () {
            this._setCheckBoxState();
            this.maindiv = this._createElement("span", { "class": "e-chkbox-wrap e-widget " + this.model.cssClass, "role": "checkbox", tabindex: 0 });
            if (this._isValid(this.model.id)) {
                this.maindiv.setAttribute("id", this.model.idPrefix + this.model.id);
                this.element[0].setAttribute("id", this.model.id);
            }
            this.innerdiv = document.createElement("div");
            this._setSize(this.model.size);
            this.span = document.createElement("span");
            this.span = $(this.span);
            this.spanImg = this._createElement("span", { "class": "e-chk-image e-icon", "role": "presentation" });
            this.spanImg = $(this.spanImg);
            this.element.addClass("e-input");
            this.model.name = ej.isNullOrUndefined(this.model.name) ? this.model.id : this.model.name;
		    this.model.value = ej.isNullOrUndefined(this.model.value) ? true : this.model.value;
            this._setAttributes(this.element[0], { "name": this.model.name, "value": this.model.value });
            var hiddenEl = $("#" + this._id + "_hidden")
            // hidden input element will be generated in MVC wrapper
            this._hiddenInput = hiddenEl.length ? hiddenEl[0] : this._createElement("input", { type: "checkbox", value: false, style: "display:none" });
            this._isValid(this.model.name) && this._hiddenInput.setAttribute("id", this.model.name + "_hidden");

            this._setRoundedCorner(this.model.showRoundedCorner);
            if (this.checked())
                this._setCheckedItem(this.checked());
            if (this._isChecked) {
                this.spanImg.addClass("e-checkmark");
                this.span.addClass("e-chk-act");
                this.maindiv.setAttribute("aria-checked", true);
                this.element.attr("checked", "checked")
            }
            else {
                this.span.addClass("e-chk-inact");
                this.maindiv.setAttribute("aria-checked", false);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            if (!(this.checked() instanceof Array))
                this.checked(this._isChecked);
            this.span[0].appendChild(this.spanImg[0]);
            this.innerdiv.appendChild(this.span[0]);
            this.element[0].parentNode && this.element[0].parentNode.insertBefore(this.maindiv, this.element[0]);
            this.maindiv.appendChild(this.element[0]);
            this.maindiv.appendChild(this._hiddenInput);
            this.maindiv.appendChild(this.innerdiv);
            this.wrapper = $(this.maindiv);
            this._setTextWrapper(this.model.text);
            this.chkbx = this.element;
            if (this.model.enableTriState == true && this._indeterminateState == true)
                this._setIndeterminate(this._indeterminateState);
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
        },
        _changeState: function (state) {
            if (state == "indeterminate") {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                if (!(this.checked() instanceof Array))
                    this.checked(null);
            }
            else if (state == "check") {
                this.spanImg.removeClass("e-stop").addClass("e-checkmark");
                this.span.removeClass("e-chk-act e-chk-inact e-chk-indeter").addClass("e-chk-act");
                this.wrapper[0].setAttribute("aria-checked", true);
            }
            else if (state == "uncheck") {
                this.spanImg.removeClass("e-checkmark e-stop");
                this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
                this.wrapper[0].setAttribute("aria-checked", false);
            }
        },

        _setIndeterminate: function (indeter) {
            if (indeter) {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                this.checkState("indeterminate");
                if (!(this.checked() instanceof Array))
                    this.checked(null);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            else {
                this.span.removeClass("e-chk-indeter");
                this.spanImg.removeClass("e-stop");
                this.wrapper.find('input').removeAttr('enableTriState');
                this.wrapper.find('input').prop('enableTriState', false);
                if (this.checked())
                    this._checked();
                else
                    this._unChecked();
            }
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.wrapper.append(this.txtSpan);
                this.model.enableRTL && this._setRTL();
            }
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            this.element[0].setAttribute('id', val);
        },

        _isValid: function (value) {
            return (!ej.isNullOrUndefined(value) && value != "") ? true : false;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "click", this._checkedHandler);
            if (this._isIE8) {
                this._isValid(this.model.id) && this._on($("label[for=" + this.model.id + "]"), "click", function () { this.wrapper.click(); });
            }
            this._on(this.wrapper, "focus", this._focusIn);
            this._on(this.wrapper, "focusout", this._focusOut);
        },


        _unWireEvents: function () {
            this._off(this.wrapper, (this._isDevice && $.isFunction($.fn.tap)) ? "tap" : "click");
            if (this._isIE8) {
                this._isValid(this.model.id) && this._off($("label[for=" + this.model.id + "]"), "click");
            }
            this._off(this.wrapper, "focus");
            this._off(this.wrapper, "focusout");
        },
        _focusIn: function (evt) {
            $(this.wrapper).addClass("e-focus");
            $(this.wrapper).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.wrapper).removeClass("e-focus");
            $(this.wrapper).off("keydown", $.proxy(this._checkUnCheck, this));
        },
        _checkUnCheck: function (evt) {
            //Space bar to check and uncheck
            if (evt.keyCode == 32) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },
        _checkedHandler: function (evt) {
            var data = { isChecked: this._isChecked, isInteraction: true, event: evt };
            if (true == this._trigger("beforeChange", data)) {
                return false;
            }
            if (this.span.hasClass("e-chk-inact")) {
                this._checked();
                if (!(this.checked() instanceof Array))
                    this.checked(true);
                if (this.model.enableTriState) {
                    this._indeterminateState = true;
                    this.checkState("check");
                }
            }
            else if (this.span.hasClass("e-chk-act")) {
                if ((this.model.enableTriState == true) && (this.model.checkState == "check") && (this.model.checked == true)){
                    this._setIndeterminate(true);
                    if (!(this.checked() instanceof Array)) {
                        this.checked(true);
                        this.checkState("indeterminate");
                    }
                } else {
                    this._unChecked();
                    if (!(this.checked() instanceof Array)) {
                        this.checked(false);
                        this.checkState("uncheck");
                    }
                }
            }
            else if (this.span.hasClass("e-chk-indeter")) {
                if (!(this.checked() instanceof Array))
                    this.checked(false);
                else
                    this._isChecked = false;
                this._setIndeterminate(false);
                this._indeterminateState = false;
            }
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
            else
                this._isChecked = this.checked();
            $(this.maindiv).addClass("e-material-animate");
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: true, event: evt };
            this._trigger("change", data);
            return true;
        },


        _checked: function () {
            this.span.removeClass("e-chk-inact").addClass("e-chk-act");
            this.spanImg.removeClass("e-stop").addClass("e-checkmark");
            this.wrapper[0].setAttribute("aria-checked", true);
            this.wrapper.find('input[type=checkbox]').prop('checked', true);
            this.checkState("check");
            this._hiddenInput.removeAttribute("name");
        },


        _unChecked: function () {
            this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
            this.wrapper[0].setAttribute("aria-checked", false);
            this.spanImg.removeClass("e-checkmark e-stop");
            this.wrapper.find('input[type=checkbox]').prop('checked', false);
            this.checkState("uncheck");
            this._hiddenInput.setAttribute("name", this.model.name);
        },

        _setCheckedItem: function (value) {
            if (typeof(value) == "boolean" && !(value instanceof Array))
                this._isChecked = true;
            else if (value instanceof Array && !ej.isNullOrUndefined(this.model.value) && this.model.value != "") {
                for (var item = 0; item < value.length; item++) {
                    if (value[item] == this.model.value)
                        this._isChecked = true;
                }
            }
        },

        _updateCheckedItem: function () {
            if (!ej.isNullOrUndefined(this.model.value) && this.model.value != "" && !this.wrapper.find("span:first").hasClass("e-chk-indeter")) {
                if (($.inArray(this.model.value, this.checked()) < 0) && this.wrapper.find("span:first").hasClass("e-chk-act")) {
                    this.checked().push(this.model.value);
                    this._isChecked = true;
                    this._hiddenInput.removeAttribute("name");
                }
                else if (($.inArray(this.model.value, this.checked()) > -1) && this.wrapper.find("span:first").hasClass("e-chk-inact")) {
                    this.checked().splice($.inArray(this.model.value, this.checked()), 1);
                    this._isChecked = false;
                    this._hiddenInput.setAttribute("name", this.model.name);
                }
            }
        },


        disable: function () {
            if (!this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", true);
                this.element[0].setAttribute("disabled", "disabled");
                if (this._isIE8) this.span.addClass("e-disable");
                this._unWireEvents();
                this.model.enabled = false;
            }
        },

        enable: function () {
            if (this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", false);
                this.element.prop("disabled", false);
                if (this._isIE8) this.span.removeClass("e-disable");
                this._wireEvents();
                this.model.enabled = true;
            }
        },

        isChecked: function () {
            if ((this._isChecked != null) && (this._isChecked != undefined))
                return this._isChecked;
        }
    });

    ej.CheckboxSize = {
        /**  Creates checkbox with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates checkbox with inbuilt medium size height, width specified */
        Medium: "medium"
    };

    ej.CheckState = {
        /**  Specifies the Check attribute of the Checkbox */
        Check: "check",
        /**  Specifies the Uncheck attribute of the Checkbox */
        Uncheck: "uncheck",
        /**  Specifies the Indeterminate state of the Checkbox */
        Indeterminate: "indeterminate"
    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the Html Radiobutton elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRadioButton", "ej.RadioButton", {
        _rootCSS: "e-radiobtn",

        element: null,
        _requiresID: true,
        model: null,
        validTags: ["input"],
        _addToPersist: ["checked"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            id: null,

            name: null,

            value: null,

            checked: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            htmlAttributes: {},

            enablePersistence: false,

            idPrefix: "ej",

            size: "small",

            enabled: true,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null
        },


        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },

        observables: ["checked"],
        checked: ej.util.valueFunction("checked"),

        _init: function (options) {
            var browserInfo = ej.browserInfo();
            this._cloneElement = this.element.clone();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._setValue();
            this._renderControl();
            if (this.isChecked)
                this._checkedHandler();
            if (!ej.isNullOrUndefined(this.radbtn.attr("disabled"))) this.model.enabled = false;
            this._setEnabled(this.model.enabled);
            this._addAttr(this.model.htmlAttributes);
            if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
                this.model.validationMessages = this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._wireEvents();
            this.initialRender = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.div.addClass(value);
                else if (key == "name") proxy.radbtn.attr(key, value);
                else if (key == "required") proxy.radbtn.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._checkedChange(true, true);
                else proxy.div.attr(key, value);
            });
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.find("input").rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        if (this.model.text)
                            (options[prop]) ? this.div.addClass("e-rtl") : this.div.removeClass("e-rtl") && this.element.closest('.e-radiobtn-wrap').hasClass('e-rtl') ? this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl') : "";
                        else 
                            (options[prop]) ? this.element.closest('.e-radiobtn-wrap').addClass('e-rtl') : this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl');
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "checked":
                        $(this.div).removeClass("e-material-animate");
                        if (typeof this.checked() == "boolean") {
                            this.model.checked = options[prop];
                            this._checkedChange(this.model.checked);
                        }
                        else if (options[prop]() != null) {
                            if (options[prop]() == this.element.find(".e-input").attr("value"))
                                this._checkedChange(options[prop]());
                        }
                        break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.radbtn.attr('name', options[prop]); break;
                    case "value":
                        this.radbtn.attr("value", options[prop]);
                        break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.radbtn.remove();
            this._cloneElement.removeClass("e-js e-input e-radiobtn");
            this._cloneElement.insertBefore(this.element)
            this.element.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
                this.div.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            if (ej.isNullOrUndefined(this.element.attr("type")))
                this.element.attr("type", "radio");
            if (!ej.isNullOrUndefined(this.element.attr("id")))
                this.model.id = this.element.attr("id");
            if (!ej.isNullOrUndefined(this.element.attr("name")))
                this.model.name = this.element.attr("name");
            if (!ej.isNullOrUndefined(this.element.attr("value")))
                this.model.value = (this.element.attr("value"));
            this.element.attr({ "id": this.model.id, "name": this.model.name, "value": this.model.value });
            if (typeof this.checked() == "boolean")
                this.model.checked = this.isChecked = this.model.checked || this.element.attr('checked') == "checked"
            else
                this.isChecked = this.element.attr("value") == this.checked();
            if (this.isChecked) this.element.attr('checked', 'checked');
            this._hiddenValue = this.element.attr("value");
            this._isUI = false;
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            $("#" + this.model.idPrefix + this.model.id).attr('id', this.model.idPrefix + val);
            this.radbtn.attr('id', val);
        },

        _setSize: function (val) {
            if (val == ej.RadioButtonSize.Medium) {
                this.span.removeClass('e-radsmaller').addClass('e-radmedium');
                this.div.removeClass('e-radsmall').addClass('e-radmed');
            }
            else {
                this.span.removeClass('e-radmedium').addClass('e-radsmaller');
                this.div.removeClass('e-radmed').addClass('e-radsmall');
            }
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },

        _renderControl: function () {
            this.initialRender = true;
            var browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == '8.0')
                this.div = $('<div class="e-radiobtn-wrap e-widget e-rad-outer" ></div>');
            else
                this.div = $('<div class="e-radiobtn-wrap e-widget" ></div>');
            this.div.attr({ 'id': this.model.idPrefix + this.model.id, "role": "radio", "tabindex": 0, "aria-checked": false });
            this.span = $('<span></span>');
            this.span.addClass("e-spanicon");
            this._setSize(this.model.size);
            this.spanImg = $('<span class="e-rad-icon e-icon e-rad-select"></span>', "", {}, { "role": "presentation" });
            this.element.addClass("e-input");
            this.div.addClass(this.model.cssClass);
            this.span.append(this.spanImg);
            this.div.insertBefore(this.element);
            this.div.append(this.element);
            this.div.append(this.span);
            this._setTextWrapper(this.model.text);
            this.radbtn = this.element;
            this.element = this.div;
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.div.append(this.txtSpan);
                if (this.model.enableRTL)
                    this.div.addClass("e-rtl");
            } else if (this.model.enableRTL)
                this.element.closest('.e-radiobtn-wrap').addClass('e-rtl');
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _wireEvents: function () {
            this._on(this.element, "click", function (e) {
                this._isUI = true;
                this._checkedHandler(e);
            });
            this._on(this.element, "focus", this._focusIn);
            this._on(this.element, "focusout", this._focusOut);
        },
        _focusIn: function (evt) {
            $(this.element).addClass("e-focus");
            $(this.element).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.element).removeClass("e-focus");
            $(this.element).off("keydown", $.proxy(this._checkUnCheck, this));
        },

        _checkUnCheck: function (evt) {
            //Space bar,and arrow keys to check and uncheck
            if (evt.keyCode == 32 || evt.keyCode == 37 || evt.keyCode == 38 || evt.keyCode == 39 || evt.keyCode == 40) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },

        _checkedHandler: function (evt) {
            if (evt) this._interacted = true;
            if (!this.element.hasClass('e-disable')) {
                if (typeof this.checked() == "boolean")
                    this.isChecked = this.radbtn.attr('checked') == 'checked' ? true : false;
                else
                    this.isChecked = this.checked() == this.radbtn.attr('value');
                if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) this._changeEvent(true);
                if (evt) $(this.div).addClass("e-material-animate");
            }
        },

        _checkedChange: function (val, interaction) {
            this.isChecked = val;
            this._changeEvent(interaction);
        },

        _changeEvent: function (interaction) {
            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender) {
                if (true == this._trigger("beforeChange", data))
                    return false;
            }

            if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) {
                var curname = this.element.find(".e-input").attr('name'),
                input = $('input.e-radiobtn[name="' + curname + '"]:radio'),
                proxy = this,
                currElement = this.element.find('.e-input'),
                currObj = $(currElement).data("ejRadioButton");
                if (data.isChecked) {
                    this.spanImg.addClass("e-circle_01").removeClass('e-rad-select');
                    this.span.addClass("e-rad-active");
                    this.div.attr({ "tabindex": 0, "aria-checked": true });
                    this.radbtn.attr("checked", "checked");
                }
                $.each(input, function (i, obj) {
                    if (proxy._interacted && $($(obj).closest(".e-widget")).find("span.e-spanicon").hasClass("e-rad-active")) $(obj).closest(".e-radiobtn-wrap").addClass("e-material-animate");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-rad-icon").removeClass("e-circle_01").addClass("e-rad-select");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-spanicon").removeClass("e-rad-active");
                    $(obj).closest(".e-radiobtn-wrap").attr({ "tabindex": 0, "aria-checked": false });
                    var prevObj = $(obj).data("ejRadioButton");
                    if (prevObj != null && prevObj.checked() != null && typeof prevObj.checked() == "boolean")
                        prevObj.model.checked = false;
                });
                if (currObj != null && currObj.checked() != null && typeof currObj.checked() == "boolean")
                    currObj.model.checked = true;
                else
                    currObj.checked(currObj.radbtn.attr("value"));
                this.element.find(".e-rad-icon").addClass("e-circle_01").removeClass("e-rad-select");
                this.span.addClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": true });
                if (this._isUI) this.element.find(".e-input").click();
                this.isChecked = true;
                (this.isChecked == true) ? this.radbtn.attr("checked", "checked") : this.radbtn.removeAttr("checked");
            }
            else {
                this.spanImg.removeClass("e-circle_01").addClass('e-rad-select');
                this.span.removeClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": false });
                this.radbtn.removeAttr("checked");
            }

            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender)
                this._trigger("change", data);
            if (interaction) this._trigger("_change", { value: this._hiddenValue });
        },

        disable: function () {
            if (!this.element.hasClass("e-disable")) {
                this.element.addClass("e-disable");
                this.radbtn.attr("disabled", "disabled");
            }
            if (this._isIE8) this.span.addClass("e-disable");
            this.div.attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            if (this.element.hasClass("e-disable")) {
                this.element.removeClass("e-disable");
                this.radbtn.prop("disabled", false);
            }
            if (this._isIE8) this.span.removeClass("e-disable");
            this.div.attr("aria-disabled", false);
            this.model.enabled = true;
        }
    });

    ej.RadioButtonSize = {
        /**  Creates radio button with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates radio button with inbuilt medium size height, width specified */
        Medium: "medium"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejAutocomplete", "ej.Autocomplete", {

        element: null,

        model: null,
        validTags: ["input"],
        _ignoreOnPersist: ["fields", "dataSource", "query", "focusIn", "focusOut", "change", "select",
                            "create", "destroy", "open", "close", "actionComplete", "actionSuccess", "actionFailure"],
        _setFirst: false,

        _rootCSS: "e-autocomplete",
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        _requiresID: true,

        defaults: {

            dataSource: null,

            query: null,

            fields: {

                text: null,

                key: null,
                //Deprecated
                category: null,

                groupBy: null,

                htmlAttributes: null
            },
            locale: "en-US",
			
			name:null,

            template: null,
            //Deprecated
            allowGrouping: false,

            enableDistinct: false,

            allowSorting: true,

            sortOrder: "ascending",

            htmlAttributes: {},

            multiSelectMode: "none",

            delimiterChar: ',',

            allowAddNew: false,

            addNewText: "Add New",

            showRoundedCorner: false,

            readOnly: false,

            cssClass: "",

            watermarkText: null,

            value: "",

            selectValueByKey: null,

            filterType: "startswith",

            caseSensitiveSearch: false,

            showLoadingIcon: true,
			
			showResetIcon : false,

            itemsCount: 0,

            minCharacter: 1,

            delaySuggestionTimeout: 200,

            showPopupButton: false,

            highlightSearch: false,

            enableAutoFill: false,

            enableRTL: false,

            enabled: true,

            visible: true,

            height: "",

            width: "",

            emptyResultText: "No suggestions",

            animateType: "slide",

            showEmptyResultText: true,

            enablePersistence: false,

            popupHeight: "152px",

            popupWidth: "auto",

            autoFocus: false,
			
            multiColumnSettings: {
    
                enable:false,
    
                showHeader:true, 
                
                stringFormat:"{0}",

                searchColumnIndices:[],
                         columns:[{
                           field:null,
           
                            headerText:null,
							
							textAlign:"left",
							
							headerTextAlign:"left",
							
							cssClass: "",
							
							type:"string",

							filterType: "startswith"
       
                        }]
            },

            validationRules: null,

            validationMessage: null,

            focusIn: null,

            focusOut: null,

            change: null,

            select: null,

            create: null,

            open: null,

            close: null,

            destroy: null,

            actionBegin: null,

            actionComplete: null,

            actionSuccess: null,

            actionFailure: null
        },

        dataTypes: {
            autoFocus: "boolean",
            watermarkText: "string",
            locale: "string",
            cssClass: "string",
            filterType: "enum",
            caseSensitiveSearch: "boolean",
            showLoadingIcon: "boolean",
            template: "string",
            //Deprecated
            allowGrouping: "boolean",
            enableDistinct: "boolean",
            allowSorting: "boolean",
            sortOrder: "enum",
            allowAddNew: "boolean",
            addNewText: "string",
            showRoundedCorner: "boolean",
			showResetIcon:"boolean",
            readOnly: "boolean",
            itemsCount: "number",
            animateType: "enum",
            minCharacter: "number",
            showPopupButton: "boolean",
            highlightSearch: "boolean",
            enableAutoFill: "boolean",
            enableRTL: "boolean",
            multiSelectMode: "enum",
            delimiterChar: "string",
            emptyResultText: "string",
            showEmptyResultText: "boolean",
            enabled: "boolean",
            visible: "boolean",
            enablePersistence: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
            multiColumnSettings: "data",
            columns:"data",
            searchColumnIndices:"data"
        },
        observables: ["value", "selectValueByKey"],
        value: ej.util.valueFunction("value"),
        _selectValueByKey:ej.util.valueFunction("selectValueByKey"),
        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                this.target.disabled = false;
                this.element.removeClass("e-disable").attr({ "aria-disabled": false });
                this.element.removeAttr("disabled");
                if (this.model.showPopupButton) this.dropdownbutton.removeClass("e-disable").attr({ "aria-disabled": false });
                if (this.model.multiSelectMode == "visualmode") this._ulBox.removeClass("e-disable").attr({ "aria-disabled": false });
                this.wrapper.removeClass('e-disable-wrap');
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this._hideResult();
                this.model.enabled = false;
                this.target.disabled = true;
                this.element.attr("disabled", "disabled");
                this.element.addClass("e-disable").attr({ "aria-disabled": true });
                if (this.model.showPopupButton) this.dropdownbutton.addClass("e-disable").attr({ "aria-disabled": true });
                if (this.model.multiSelectMode == "visualmode" && this._ulBox) this._ulBox.addClass("e-disable").attr({ "aria-disabled": true });
                this.wrapper.addClass('e-disable-wrap');
            }
        },

        clearText: function () {
            if (this.model.multiSelectMode == "visualmode")
                this._deleteBox(this._ulBox.children("li"));
            this.element.val("");
            this._valueChange();
            if (this._isFocused) this.element.blur();
            else this._focusOutAction();
            this._hideResult()
        },

        getValue: function () {
            var value = this.value();
            return (value == null) ? "" : value; 
        },

        getSelectedItems: function () {
            if (this._isFocused && this.model.multiSelectMode != "visualmode")
                this._updateSelectedItemArray(this.getValue());
            return this._selectedItems;
        },
        _setValue: function (value) {
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            if (typeof value === "object" || (typeof value === "number" && isNaN(value)) || $.trim(value) == "") value = "";
            if (this.model.multiSelectMode == "visualmode")
                this._hiddenInput.val("");
            this.element.val("");
            if (!this._hiddenInput) this._hiddenInput = ej.buildTag("input#" + this.target.id + "_hidden", "", {}, { type: "hidden", "name": this.element.attr("name") }).insertBefore(this.element);
            if (value) {
                if (this.model.multiSelectMode == "visualmode") {
                    this._selectedItems = [];
                    this._modelValue = value;
                    this._deleteBox(this._ulBox.children("li"));
                    var values = value.split(this.model.delimiterChar);
					this.element.width(1).val("").removeAttr('placeholder');
					if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
                        this._createBoxForObjectType(values);
                    }
                    else {
                        this.suggestionListItems = this.model.dataSource;
                        if (this.suggestionListItems && typeof this.suggestionListItems[0] != "object") {
							this._hiddenInput.val(value);
                            for (var i = 0, length = values.length; i < length; i++) {
                                if (values[i]) {
                                    this._ulBox.append(this._createBox(values[i]));
                                    this._selectedItems.push(values[i]);
                                }
                            }
                            }
                        else this._createBoxForObjectType(values);
                    }
                }
                else {
                    this.element.val(value);
                    this._updateSelectedItemArray(value);
                }
            }
            if (this.model.multiSelectMode != "visualmode") this.value(this.element.val());
            this._preVal = this.element.val();
            !this._isWatermark && this._setWatermarkTxt();
            return value;

        },
        _createBoxForObjectType: function (values) {
			var proxy=this, map=this._declareVariable();
            for (var data = 0, length = values.length; data < length; data++) {
                var _val = $.trim(values[data]);
				if(_val != ""){
                if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
                    this._dataQuery = this._getQuery().where(map[0], "equal", _val, false);
                    this._promise = (this.model.dataSource).executeQuery(this._dataQuery);
                    this._promise.done(function (e) {
                        var res = e.result;
                        proxy._strData = res instanceof Array && res.length ? res[0] : _val;
                        if (!ej.isNullOrUndefined(proxy._strData[map[1]]))
                            proxy._selectKeyInit();
                        proxy._selectedItems.push(proxy._strData);
                    }).fail(function (e) {
                        proxy._selectedItems.push(_val);
                    });
                }
                else {
                    this._dataQuery = ej.Query().where(map[0], "equal", _val, false);
                    this._promise = ej.DataManager(this.suggestionListItems).executeLocal(this._dataQuery);
                    this._strData = this._promise instanceof Array && this._promise.length ? this._promise[0] : _val;
                    if (!ej.isNullOrUndefined(this._strData[map[1]])) 
					  this._selectKeyInit();
					this._selectedItems.push(this._strData);
                }
                if (this.model.multiSelectMode == "visualmode")
                    this._ulBox.append(this._createBox(_val));
            }
			}
			
        },

        _selectKeyInit: function () {
            var mapper = this._declareVariable();
            delimiterChar = this._delimiterChar();
            if (this.model.multiSelectMode == "visualmode")
                this._hiddenInput.val(this._hiddenInput.val() + (!ej.isNullOrUndefined(this._strData[mapper[1]] || this._strData[mapper[0]]) ? (this._strData[mapper[1]] || this._strData[mapper[0]]) + this.model.delimiterChar : ""));
            if (!ej.isNullOrUndefined(this._strData[mapper[1]])) {
                if (this.model.multiSelectMode != "none") {
                    var keyValue = this._selectValueByKey() != null ? (this._selectValueByKey() + this._strData[mapper[1]] + delimiterChar) : this._strData[mapper[1]] + delimiterChar
                    keyValue = keyValue.split(delimiterChar).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                    this._selectValueByKey(keyValue.join(delimiterChar));
                }
                else this._selectValueByKey(this._strData[mapper[1]]);
            }
        },
		    _declareVariable: function () {
		        var mapper = this.model.fields, mapFld = { _key: null, _text: null, _attr: null }, keyText = [];
			 if(!ej.isNullOrUndefined(mapper)){
				mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text" ;
				mapFld._key = (mapper && mapper.key) ? mapper["key"] : "key" ;
				keyText.push(mapFld._text,mapFld._key);
				return keyText;
			 }
		},

       selectValueByKey: function (key) {
            if (!ej.isNullOrUndefined(key)) {
                var proxy = this;
                key = key.toString();
                var result = this.model.multiSelectMode != "none" ? key.split(this.model.delimiterChar) : key.split(",");
                if (Object.prototype.toString.call(result) === '[object Array]') {
                    $.each(result, function (index, value) {
                        proxy._setOperation($.trim(value), "key");
                    });
                }
                this._eventTrigger();
            }
        },

        selectValueByText: function (text) {
            this._setOperation(text, "text");
            var list = this.model.dataSource;
            if (!(ej.DataManager && list instanceof ej.DataManager)) this._eventTrigger();
        },

        _eventTrigger: function () {
            var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val() == "" ? null : this.element.val();
            this._trigger("select", { isInteraction: true, value: this.value(), text: currValue, key: this._selectValueByKey(), item: this._selectedItems });
        },

        setValue: function (text) {
            this._setText(text);
        },

        _setOperation: function (source, value) {
            var bindTo = "", promise, dataQuery, proxy = this, list = this.model.dataSource;
            if (ej.isNullOrUndefined(list)) return false;
            if (typeof list[0] == "object" || list instanceof ej.DataManager) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper[value]) ? mapper[value] : value;
            } else if (value == "key")
                return false;
            if (ej.DataManager && list instanceof ej.DataManager) {
                dataQuery = this._getQuery().where(bindTo, "equal", source, !this.model.caseSensitiveSearch);
                promise = (list).executeQuery(dataQuery);
                promise.done(function (e) {
                    proxy._setText(e.result[0]);
                    proxy._eventTrigger();
                });
            }
            else {
                if ((!list || !list.length || list.length < 1)) return false;
                dataQuery = ej.Query().where(bindTo, "equal", source, !this.model.caseSensitiveSearch);
                promise = ej.DataManager(list).executeLocal(dataQuery);
                this._setText(promise[0]);
            }
        },

        _setText: function (data) {
            if (!data) return false;
            var currentValue, keyvalue, mapper = this.model.fields;
            if ((typeof this.model.dataSource[0] == "object") || (typeof data == "object")) {
                currentValue = typeof data == "string" ? data : (mapper && mapper["text"]) ? data[mapper["text"]] : data["text"];
                keyvalue = typeof data == "string" ? data : (mapper && mapper["key"]) ? data[mapper["key"]] : data["key"];
            }
            else currentValue = data;
            if (currentValue) {
                if (this.model.multiSelectMode == "visualmode" && this._removeDuplicates(data)) return false;
                this._valueToTextBox(currentValue, data, true);
                var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();
                this.value(currValue);
				if (this.model.showResetIcon) this._showReset();
            }
           this._selectkey.push(keyvalue);
           if (!ej.isNullOrUndefined(keyvalue)) this._selectValueByKey(this._selectkey + this.model.delimiterChar);                
        },

        _textFormateString: function (data, index) {
            var _textFormatString = this.model.multiColumnSettings.stringFormat
			this._columnsIndex();
            if (!ej.isNullOrUndefined(data) && typeof data == "object") {
                for (var i = 0, length = this._columnIndex.length; i < length; i++)
                    _textFormatString = _textFormatString.replace("{" + this._columnIndex[i] + "}", data[this.model.multiColumnSettings.columns[parseInt(this._columnIndex[i])].field]);
            }
            else if (!ej.isNullOrUndefined(data) && typeof data != "object") {
                _textFormatString = _textFormatString.replace("{" + this._columnIndex[0] + "}", data);
            }
            else
                _textFormatString = this._currList[this._activeItem - 1];
            return _textFormatString;
        },

		_columnsIndex: function(){
			var _proxy = this; this._columnIndex = [];
			$.each(this.model.multiColumnSettings.stringFormat.match(/\{.+?\}/g),function (x,n){ 
				  _proxy._columnIndex[x] = n.slice(1,-1)
            });
            this._searchColumnIndex = [];
            $.each(this.model.multiColumnSettings.searchColumnIndices,function (x,m){ 
                _proxy._searchColumnIndex.push(m);
          });
        },
        _valueToTextBox: function (currentValue, data, flag) {
            var delimiterIndex;
         if(!this._addNewTemplate && this.model.multiColumnSettings.enable && typeof data != "string") 
             currentValue = this._textFormateString(data);
         delimiterIndex = this.model.delimiterChar;
         var key = this._getUniqueKey();
         key = key ? key : (this.model.fields && this.model.fields["key"]) ? data[this.model.fields["key"]] : !ej.isNullOrUndefined(data["key"]) ? data["key"] : key;
         if (!this._hiddenInput) this._hiddenInput = ej.buildTag("input#" + this.target.id + "_hidden", "", {}, { type: "hidden", "name": this.element.attr("name") }).insertBefore(this.element);
         if (!(this._hiddenInput.val() == key || key == null) || temp > -1) {
                 if (this.model.multiSelectMode == "none") this._hiddenInput.val(this._hiddenInput.val() + (key || currentValue));
                 else this._hiddenInput.val(this._hiddenInput.val() + (key || currentValue) + delimiterIndex);
         }
         if (this.model.multiSelectMode == "visualmode") {
             data = (typeof data == "string" && this._addNewTemplate && data.substr(data.length - this._addNewTemplate.length) == this._addNewTemplate) ? data.replace(this._addNewTemplate, "") : data;
             if (typeof currentValue == "number") currentValue = this._textFormateString(currentValue);
				var temp = currentValue.indexOf(this._addNewTemplate);
                if (this._addNewTemplate) currentValue = currentValue.substr(0, currentValue.length - this._addNewTemplate.length);
                if(!(this._selectValueByKey() == key || key == null) || temp > -1 )					
			        this._selectValueByKey(this._selectValueByKey() != null ? (this._selectValueByKey() + (temp > -1 ? currentValue : key) + delimiterIndex) : (temp > -1 ? currentValue : key) + delimiterIndex);
			    this._modelValue = ej.isNullOrUndefined(this.value()) ? currentValue + delimiterIndex : this.value() + currentValue + delimiterIndex;
                this.element.val("").removeAttr('placeholder').width(1);
                this._ulBox.append(this._createBox(currentValue));
				if(this.model.height!=""){
                $(this._ulBox).parent().css("overflow","auto");	
                if((this.model.showPopupButton)&&(this._ulBox.parent()[0].scrollHeight!=0)) this.dropdownbutton.css("height",this._ulBox.parent()[0].scrollHeight);				
				}
                this._addNewTemplate = null;
            }
            else if (this.model.multiSelectMode == "delimiter") {
                var delimiterIndex = (this.target.value).lastIndexOf(this.model.delimiterChar);
                if (this._typed || this.element.val() == "" || flag || !this.model.showPopupButton) {
                    if (flag)
                        this.element.val(this.element.val() == "" ? (currentValue + this.model.delimiterChar) : (this.element.val() + currentValue + this.model.delimiterChar));
                    else					 
                        delimiterIndex == -1 ? this.element.val(this._queryString.substr(0, delimiterIndex + 1) + currentValue + this.model.delimiterChar):this.element.val(this._queryString.substr(0, delimiterIndex + ((this.model.delimiterChar).length)) + currentValue + this.model.delimiterChar)
                 }
                else {
                    if(!this.model.enableAutoFill || this.showSuggestionBox) {
					if (this._checkDeli())
                        this.element.val(this._queryString.substr(0, delimiterIndex) + this.model.delimiterChar + currentValue + this.model.delimiterChar);
                    else
                        this.element.val(this.element.val() + this.model.delimiterChar);
                    }
					else if(!this._checkDeli()) this.element.val(this.element.val() + this.model.delimiterChar);
				}
                this._typed = false;
            }
            else {
                this.element.val(currentValue);
                this._selectedItems = [];
            }
            this._selectedItems.push(data);
			this._originalval.push(currentValue);
            this._moveCaretToEnd(this.element[0]);
        },

        _removeDuplicates: function (currentValue) {
            if (this._selectedItems.length == 0) return false;
            if (this._selectedItems.indexOf(currentValue) != -1) return true;
        },

        search: function () {
            if (this.model.enabled && this._checkDelimiter()) {
                this._hideResult();
                this._autoFill = false;
                this._queryString = $.trim(this._queryString);
                if (this._queryString.length > 0) this._OnTextEnter();
            }
        },
        setVisible: function (value) {
            if (value)
                this.wrapper.show();
            else
                this.wrapper.hide();
        },

        hide: function () {
            this._hideResult();
        },

        open: function () {
            this._showFullList();
        },

        _changeWatermark: function (text) {
            if (this._isWatermark) this.element.attr("placeholder", text);
            else this._hiddenSpan.text(text);
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.suggestionList.removeClass(this.model.cssClass).addClass(skin);
        },
        _setDropdown: function (boolean) {
            this.model.showPopupButton = boolean;
            if (boolean) this._renderDropdown();
            else this._destroyDropdown();
        },
        _changeHeight: function (height) {
            this.wrapper.height(height);
        },
        _changeWidth: function (width) {
            this.wrapper.width(width);
            this._setListWidth();
        },
        _setCulture: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.addNewText)) this._localizedLabels.addNewText = this._options.addNewText;
                if (!ej.isNullOrUndefined(this._options.emptyResultText)) this._localizedLabels.emptyResultText = this._options.emptyResultText;
                if (!ej.isNullOrUndefined(this._options.watermarkText)) this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this.model.addNewText = this._localizedLabels.addNewText;
            this.model.emptyResultText = this._localizedLabels.emptyResultText;
            this.model.watermarkText = this._localizedLabels.watermarkText;
        },
        
        _init: function (options) {
            this._options = options;
            this._selectkey=[];
            this._setCulture();
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            //deprecated Property Added
            this.model.fields.groupBy = !this.model.fields.groupBy ? this.model.fields.category : this.model.fields.groupBy;
            this._initialize();
            this._render();
            this._wireEvents();
            this.initialRender = false;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            if (!this.model.validationRules) return;
            var element = this.model.multiSelectMode == "visualmode" ? this._hiddenInput : this.element;
            element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
		_removeDuplicateValue: function(values) {
			return values.split(this.model.delimiterChar).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []).join(this.model.delimiterChar);
		},
        _delimiterChar:function(){
            return (this.model.multiSelectMode != "none" ? this.model.delimiterChar : "");
        },
        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "dataSource": this.model.dataSource = null; break;
                    case "watermarkText": this._changeWatermark(options[option]); break;
                    case "delaySuggestionTimeout": this.model.delaySuggestionTimeout = parseInt(options[option]); break;
                    case "value":
                        deli = this._delimiterChar();
                        if (this.model.multiSelectMode != "none") {
                            value = options[option].substr(options[option].length - deli.length) == deli ? options[option] : options[option] + deli;
                            options[option] = options[option] == "" ? this.value() : (this.value() ? this.value() : "") + value;
                            if (this.model.multiSelectMode == "visualmode") {
                                options[option] = options[option].split(deli).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                                options[option] = options[option].join(deli);
                            }
                        }
                        this.value(this._setValue(options[option]));
                        this._modelValue = this.value()
                        var currValue = this.model.multiSelectMode == "visualmode" ? this._hiddenInput.val() : this.element.val();
                        this._changeEvtTrigger(currValue);
                        if (this.model.showResetIcon) this._showReset();
                        break;
                    case "showPopupButton": this._setDropdown(options[option]); break;
                    case "enableRTL": this._RightToLeft(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "readOnly": this._checkReadOnly(options[option]); break;
                    case "delimiterChar": var delchar = this.model.delimiterChar;
                        options[option] = this._validateDelimiter(options[option]);
                        this.model.delimiterChar = options[option];
                        this.element.val(this.value().replace(new RegExp(delchar, 'g'), this.model.delimiterChar));
                        this.value(this.element.val());
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = options[option];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "locale":
                        if (ej.Autocomplete.Locale[options[option]]) {
                            this.model.locale = options[option];
                            this._setCulture();
                            this._setWatermark();
                        } else  this.model.locale = options[option];
                        break;
                    case "filterType":
                        var arr = [];
                        for (var key in ej.filterType)
                            if (ej.filterType.hasOwnProperty(key))
                                arr.push(ej.filterType[key]);
                        if (arr.indexOf(options[option]) > -1)
                            this.model.filterType = options[option];
                        else
                            options[option] = this.model.filterType;
                        break;
                    case "multiSelectMode":
                        this.model.multiSelectMode = options[option];
                         var delimiter =this._delimiterChar();
                         if (this.model.multiSelectMode != "none") {
                             var key = this._selectValueByKey(), value = this.value();
                             if (value) {
                                 value = value.substr(value.length - delimiter.length) == delimiter ? value : value + delimiter
                                 this.value(value);
								 if(this.model.multiSelectMode == "visualmode") this.value(this._removeDuplicateValue(this.value()))
                             }
                             if (key) {
                             this._selectValueByKey(key.substr(key.length - delimiter.length) == delimiter ? key : key + delimiter);
							 if(this.model.multiSelectMode == "visualmode") this._selectValueByKey(this._removeDuplicateValue(this._selectValueByKey()));
							 }
						 }
                         else {

                         }
                        if (options[option] == "visualmode") {
                            if (this.model.validationRules != null)
                                this.element.rules('remove');
							if (this.element.val() != "" && this._isWatermark ) this.element.removeAttr("placeholder");
                            this._renderBoxModel();
                        }
                        else if (this.element.hasClass("e-visual-mode")) 
                            this._destroyBoxModel();
                        this._setValue(this.value());
                        this._setValidation();
                        if (ej.isNullOrUndefined(this.element.attr("placeholder")) && this._isWatermark)
                            this._setWatermark();
                        break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "visible":
                        this.setVisible(options[option]);
                        break;
                    case "height": this._changeHeight(options[option]); break;
                    case "width": this._changeWidth(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "itemsCount ": if (options[option] <= 0 || isNaN(options[option])) options[option] = 0; break;
                    case "popupHeight": this.suggestionList.css({ "max-height": isNaN(options[option]) ? options[option]: options[option] + "px" }); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "selectValueByKey":
                        deli = this._delimiterChar();
                        key = ej.util.getVal(options[option]);
                        this.selectValueByKey(key);
                        keyValue =   (this.model.multiSelectMode != "none") ? this._selectValueByKey() + options[option]:options[option];
                        keyValue = keyValue.split(deli).reduce(function (a, b) { if (a.indexOf(b) < 0) a.push(b); return a; }, []);
                        keyValue=keyValue.join(deli);
                        options[option] = keyValue.substr(keyValue.length - deli.length) == deli ? keyValue  : keyValue+ deli;
                        break
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "emptyResultText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["emptyResultText"] = this.model.emptyResultText = options[option];
                        this._setCulture(); break;
                    case "addNewText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["addNewText"] = this.model.emptyResultText = options[option];
                        this._setCulture(); break;
					case "multiColumnSettings":
						if(!ej.isNullOrUndefined(options[option].enable)) this.model.multiColumnSettings.enable = options[option].enable;
						if(!ej.isNullOrUndefined(options[option].showHeader)) this.model.multiColumnSettings.showHeader = options[option].showHeader;
                        if(!ej.isNullOrUndefined(options[option].stringFormat)) this.model.multiColumnSettings.stringFormat = options[option].stringFormat;
                        if(!ej.isNullOrUndefined(options[option].searchColumnIndices)) this.model.multiColumnSettings.searchColumnIndices = options[option].searchColumnIndices;
						if(!ej.isNullOrUndefined(options[option].columns)) this.model.multiColumnSettings.columns = options[option].columns;
						this.suggestionList.remove();
						this._renderSuggestionList();
						break; 
                    case "showResetIcon": this.model.showResetIcon = options[option];
                        if (options[option] && !ej.isNullOrUndefined(this.value()) && this.value()!="") this._showReset();
						else this._removeReset();
						break;
                }
				this._hideResult();
            }
        },

        _destroy: function () {
            this.element.width("").removeAttr("role aria-label aria-expanded aria-haspopup aria-autocomplete autocomplete placeholder aria-owns aria-disabled disabled");
            this.element.insertAfter(this.wrapper);
            if (this.model.multiSelectMode == "visualmode")
                this.element.removeClass("e-visual-mode").attr("name", this._hiddenInput.attr("name"));
            if (!this.model.enabled) this.element.removeClass('e-disable');
            this.wrapper.remove();
            this.element.removeClass("e-input").val("");
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this._hideResult();
            this.suggestionList.remove();
        },

        _initialize: function () {
            this.value(this.value() === "" ? this.element[0].value : this.value());
            this.element.attr("role", "combobox").attr("aria-label", "Autocomplete textbox").attr("aria-expanded", false).attr("tabindex", 0).attr("aria-autocomplete", "list");
            if (/Edge\/12./i.test(navigator.userAgent)) this.element.addClass('edge-browser');
            this.target = this.element[0];
            this.dropdownbutton = null;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this.showSuggestionBox = false;
            this.noresult = true;
            this._queryString = null;
            this.suggLen = 0;
            this._selectedItems = [];
            this._modelValue = "";
            this._activeItem = 0;
			this._originalval = [];
            this.ctrlKeyPressed = false;
            this._isFocused = false;
            this._isOpened = false;
            this._typed = false;
            this._cancelEvent = false;
            this._isWatermark = this._checkWatermarkSupport();
			this._selectedObj = [];
        },

        _render: function () {
            this._renderWrapper();
            this._addAttr(this.model.htmlAttributes);
            this._setDimentions();
            this._renderDropdown();
            this._checkProperties();
            this._isWatermark ? this._setWatermark() : this._setWatermarkTxt();
            this._renderSuggestionList();
            this._RightToLeft(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this.setVisible(this.model.visible);
            this._setListPosition();
        },
        _renderWrapper: function () {
            this.element.addClass("e-input").attr("autocomplete", "off");
            this.wrapper = ej.buildTag("span.e-atc e-widget " + this.model.cssClass + "#" + this.target.id + "_wrapper").insertAfter(this.element);
            if (document.activeElement == this.element[0]) var focus = true;
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isWatermark) {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this.model.watermarkText);
                this._hiddenSpan.css("display", "none");
                var proxy = this;
                this._hiddenSpan.click(function (event) {
                    if (!this._isFocused) proxy.element.focus();
                });
            }
            if (focus) this.element.focus();
        },

        _renderDropdown: function () {
            if (this.model.showPopupButton) {
                var span = ej.buildTag("span.e-icon e-search").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                this.dropdownbutton = ej.buildTag("span.e-select#" + this.target.id + "_dropdown").attr((this._isIE8) ? { 'unselectable': 'on' } : {}).append(span);
                this.container.append(this.dropdownbutton).addClass("e-padding");
                if (!this.model.enabled)this.dropdownbutton.addClass("e-disable").attr({ "aria-disabled": true });
                this.dropdownbutton.on("mousedown", $.proxy(this._OnDropdownClick, this));
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "required") proxy.element.attr(key, value);
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "name") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(true);
                else if (key == "readOnly" && value === true) proxy._checkReadOnly(true);
                else proxy.wrapper.attr(key, value);
            });
        },
        _setDimentions: function () {
            if (this.model.height)
                this.wrapper.height(this.model.height);
            if (this.model.width)
                this.wrapper.width(this.model.width);
        },

        _renderBoxModel: function () {
            this._ulBox = ej.buildTag("ul.e-ul e-boxes");
            var disableClass = this.model.enabled ? "" : "e-disable";
            this._ulBox.addClass(disableClass);
            this._hiddenInput = ej.buildTag("input#" + this.target.id + "_hidden", "", {}, { type: "hidden" }).insertBefore(this.element);
            this._hiddenInput.attr("name", this.element.attr("name"));
            this.element.val("").removeAttr("name").addClass("e-visual-mode");
            if (!this._isWatermark) this.element.width(1);
            this.container.prepend(this._hiddenInput, this._ulBox);
            if(this.model.height!="")
			  this.wrapper.height(this.model.height);
			else 
				this.wrapper.height("auto");
            this._on(this.container, "mousedown", function (e) {
                if (!this.model.enabled) return false;
                var $target = $(e.target);
                if (!$target.is(this.element)) {
                    e.preventDefault();
                    if (!this._isFocused) this.element.focus();
                    if ($target.hasClass("e-options")) {
                        if (!e.ctrlKey && $target.siblings().hasClass("e-active")) this._removeActive();
                        if ($target.hasClass("e-active")) $target.removeClass("e-active");
                        else $target.addClass("e-active");
                    }
                    else this._moveCaretToEnd(this.element[0]);
                }
                if (!e.ctrlKey && ($target.hasClass("e-boxes") || $target.hasClass("e-input"))) this._removeActive();
            });
        },
        _destroyBoxModel: function () {
            this.container.prepend(this.element);
            this.element.attr({ name: this._hiddenInput.attr("name") }).removeAttr("style").removeClass("e-visual-mode");
            this.wrapper.height(this.model.height);
            this._hiddenInput.remove();
			this._hiddenInput = null;
            this._ulBox.remove();
            this._off(this.container, "mousedown");
        },
        _deleteLastBox: function () {
            var items = this._ulBox.children();
            var item = items.last(), flag = item.hasClass("e-active");
            this._removeActive();
            flag ? this._deleteBox(item) : item.addClass("e-active");
        },
        _deleteBox: function (items) {
            for (var i = 0, length = items.length; i < length; i++) {
                var boxes = this._ulBox.children();
                var index = boxes.index(items[i]);
                this._selectedItems.splice(index, 1);

                var deli = this.model.delimiterChar;
                var values = this._hiddenInput.val().split(deli);
                values.splice(index, 1);
                this._hiddenInput.val(values.join(deli));
                this._selectValueByKey(values.join(deli));

                var val = this._modelValue.split(deli);
                val.splice(index, 1);
                this._modelValue = val.join(deli);
                $(items[i]).remove();
            }
            if (this.showSuggestionBox) this._refreshPopup();
            this._valueChange();
            if (this.value() == "" && this.model.height != "") {
                $(this._ulBox).parent().css("overflow", "hidden");
                this.dropdownbutton.css("height", this.model.height);
            }
            if (this._hiddenInput.val() == "")
                this._setWatermark();
        },
        _removeActive: function () {
            this._ulBox.children("li.e-active").removeClass("e-active");
        },
        _adjustWidth: function () {
            var tempSpan = ej.buildTag("span", this.element.val()), wid, minWidth;
            this.container.append(tempSpan);
            minWidth = 30;  //  some additional width for textbox in visualmode
            wid = tempSpan.width() + minWidth;
            if (this.element.width() != wid)
                this.element.width(wid);
            if (this._hiddenInput.val() == "")
                this._setWatermark();
            tempSpan.remove();
        },

        _checkProperties: function () {
            this._checkReadOnly(this.model.readOnly);
            this.model.delimiterChar = this._validateDelimiter(this.model.delimiterChar);
            if (!this.model.enabled) {
                this.model.enabled = true;
                this._disabled(true);
            }
            else if (this.model.enabled && $(this.element).hasClass("e-disable")) {
                this.model.enabled = false;
                this._disabled(false);
            }
            this._checkNameAttr();
            if (this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            if (this._selectValueByKey() != null && this.value() == "") {
                var key = this._selectValueByKey().toString();
                if (this.model.multiSelectMode != "none") {
                    key = key.substr(key.length - this.model.delimiterChar.length) == this.model.delimiterChar ? key : key + this.model.delimiterChar;
                    ((this.model.multiSelectMode == "visualmode") ? this._selectValueByKey(null) : this._selectValueByKey(key));
                }
                this.selectValueByKey(key);
				if (this.model.showResetIcon) this._showReset();
            }
            else {
                var value = this.value();
                if (this.model.multiSelectMode != "none" && (!ej.isNullOrUndefined(value) && value !="")) {
                    value = value.substr(value.length - this.model.delimiterChar.length) == this.model.delimiterChar ? value : value + this.model.delimiterChar;
                }
                this.value(this._setValue(value));
                this._hiddenInput.val(value);
				if (this.model.showResetIcon && this.value() != "") this._showReset();
            }
        },

        _checkNameAttr: function () {			
           this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
           this.element.attr("name", this.model.name);
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _destroyDropdown: function () {
            this.dropdownbutton.off("mousedown", $.proxy(this._OnDropdownClick, this));
            this.dropdownbutton.remove();
            this.dropdownbutton = null;
            this.container.removeClass("e-padding");
        },

        _validateDelimiter: function (deli) {
           if ($.trim(deli).length == deli.length || deli.length != null) {
                var RegEx = /^[a-zA-Z0-9]+$/;
                if (!RegEx.test(deli)) return deli;
            }
            return ",";
        },

        _checkWatermarkSupport: function () {
            return 'placeholder' in document.createElement('input');
        },
        _setWatermark: function () {
            if ((this.model.watermarkText && (this.value() == ""|| ej.isNullOrUndefined(this.value()))) || (this.model.multiSelectMode != "visualmode"))
                this.element.attr("placeholder", this.model.watermarkText).width("");
        },
        _setWatermarkTxt: function () {
            if (this.model.watermarkText != null && $.trim(this.element.val()) == "" && (this.model.multiSelectMode != "visualmode" || $.trim(this._hiddenInput.val()) == "")) {
                var watermark = (this.model.watermarkText != null) ? this.model.watermarkText : this._localizedLabels.watermarkText;
                this._hiddenSpan.css("display", "block").text(watermark);
            }
        },

        _renderSuggestionList: function () {
            var oldWrapper = $("#" + this.element[0].id + "_suggestion").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.suggestionList = ej.buildTag("div.e-atc-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.target.id + "_suggestion", "", { "display": "none" }).attr("role", "listbox");
            this.element.attr("aria-owns", this.target.id + "_suggestion");
            this.popup = this.suggestionList;
            var scrollerDiv = ej.buildTag("div");
			if(this.model.multiColumnSettings.enable) {
				this._tableColumn = ej.buildTag("table","", {"border": 0, "padding": 0, "border-spacing": 0}, { "role": "listbox", "class" : "e-atc-tableContent" });
				this._listEventBind(this._tableColumn,"tr");
                this._headerColGroup = document.createElement("colgroup");				
				if(this.model.multiColumnSettings.showHeader) {
				this._tableHeaderDiv = ej.buildTag("div",{},{},{"class":"e-atc-tableHeader "+((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll")});
				var headerDiv = ej.buildTag("div",{},{},{"class":"e-atc-tableHeaderContent e-atc-tableHeaderBorder"}); 
				var tr = document.createElement("tr");
				this._tableHeader = ej.buildTag("table" , "" ,{"border-spacing": "0.25px"},{});
									
                for (var z = 0, length = this.model.multiColumnSettings.columns.length; z < length; z++) {
					$(tr).append( ej.buildTag("th" , (this.model.multiColumnSettings.columns[z].headerText ? this.model.multiColumnSettings.columns[z].headerText : "column"+z) , {"text-align":(this.model.multiColumnSettings.columns[z].headerTextAlign ? this.model.multiColumnSettings.columns[z].headerTextAlign:"left")}, {"class":((z == this.model.multiColumnSettings.columns.length - 1) ? "" :(this.model.enableRTL ? "e-atc-thleft" : "e-atc-thright"))}) );
				    $(this._headerColGroup).append(document.createElement("col"));
				}
				$(this._tableHeaderDiv).append($(headerDiv).append($(this._tableHeader).append(tr).append(this._headerColGroup)));
				this.suggestionList.append(this._tableHeaderDiv);
				}
				else {
                    for (var z = 0, length = this.model.multiColumnSettings.columns.length; z < length; z++)
                        $(this._headerColGroup).append(document.createElement("col"));
					this._tableColumn.append(this._headerColGroup);
				}
				var scrollerParent = ej.buildTag("div");
				scrollerParent.append(this._tableColumn);
				scrollerDiv.append(scrollerParent);
			}
			else {
                this.ul = ej.buildTag("ul.e-ul").attr("role", "listbox");
				this._listEventBind(this.ul,"li:not('.e-category')");
				scrollerDiv.append(this.ul);
			}
            this.suggestionList.append(scrollerDiv);
            $('body').append(this.suggestionList);
            this._setListWidth();
            this._setListHeight();
			if(this.model.multiColumnSettings.enable) {
				scrollerDiv.ejScroller({ height: 0, width: 0, scrollerSize: 20 });
            this.scrollerObj = scrollerDiv.ejScroller("instance");
			}
			else {
            this.suggestionList.ejScroller({ height: 0, width: 0, scrollerSize: 20 });
            this.scrollerObj = this.suggestionList.ejScroller("instance");
				}
        },

		_listEventBind: function (element,target) {
			element.on({
					mouseenter: $.proxy(this._OnMouseEnter, this),
					mouseleave: $.proxy(this._OnMouseLeave, this),
					click: $.proxy(this._OnMouseClick, this)
				}, target);
		},
		
        _checkEmptyList: function () {
            if (this.model.multiSelectMode == "visualmode") this._removeRepeated();
            if (this.suggestionListItems.length == 0) {
                this.suggestionListItems.push(this.model.emptyResultText);
                this.noresult = true;
            }
            else this.noresult = false;
        },
        _showSuggestionList: function (e) {
            this.suggestionListItems = this.model.enableDistinct ? ej.dataUtil.distinct(this.suggestionListItems, (typeof this.suggestionListItems[0] != "object" ? "" : (this.model.fields && this.model.fields.text) ? this.model.fields["text"] : "text"), true) : this.suggestionListItems;
            if(this.model.itemsCount > 0) this.suggestionListItems = ej.DataManager(this.suggestionListItems).executeLocal(ej.Query().take(this.model.itemsCount));
            this._checkEmptyList();
            this._addNewTemplate = null;
            if (this.noresult && this.model.multiSelectMode == "visualmode" && this.model.allowAddNew && this.element.val() != "" && !this._repeatRemove ) {
                this.noresult = false;
                this.suggestionListItems.pop();
                this._addNewTemplate = "   (" + this.model.addNewText + ")";
                this.suggestionListItems.push(this.element.val() + this._addNewTemplate);
                this._checkEmptyList();
            }

            if (!this.noresult || this.model.showEmptyResultText)
                this._generateSuggestionList(e);
        },

        _generateSuggestionList: function (e) {
            var list = this.suggestionListItems, i, suggList = [];
            (!this.model.multiColumnSettings.enable) ? this.ul.empty() : this._tableColumn.empty() && this.model.multiColumnSettings.showHeader && this._tableHeaderDiv.css("display", "");
            var _proxy = this;
            var fragmentParent = document.createDocumentFragment();
            if (typeof list[0] != "object") {
                if (_proxy.model.multiColumnSettings.enable) {
					var tbodyEle = ej.buildTag("tbody"); 
                    var trColumnEle = ej.buildTag("tr").attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {});
                    var tdEle = ej.buildTag("td", {}, {}, { "role": "option" });
                    for (var i = 0, listLength = list.length; listLength > i; i++) {
                        var _txt = (_proxy.model.highlightSearch && !_proxy.noresult) ? _proxy._highlightSuggestion(list[i]) : list[i];
                        var trColumn = trColumnEle.clone();
                        var td = tdEle.clone()
                         $(td).attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}).attr((list[i] != (list.length - 1)) ? { "class": "e-atc-tdbottom" } : {}).html(_txt);
                        trColumn[0].appendChild(td[0]);
						tbodyEle[0].appendChild(trColumn[0]);
                        fragmentParent.appendChild(tbodyEle[0]);
                        _proxy.model.showEmptyResultText && _proxy.model.emptyResultText == _txt && _proxy.model.multiColumnSettings.showHeader && _proxy._tableHeaderDiv.css("display", "none") && $(td).removeClass("e-atc-tdbottom");
                        
                        if ((_proxy._addNewTemplate) && !ej.isNullOrUndefined(_proxy._tableHeaderDiv))
                            _proxy._tableHeaderDiv.css("display", "none");
                    }
                    _proxy._tableColumn[0].appendChild(fragmentParent);
                }
                else {
                    var liEle = ej.buildTag("li", {}, {}, { "role": "option" }).attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {})
                    for (var i = 0, listLength = list.length; listLength > i; i++) {
                        var _txt = (_proxy.model.highlightSearch && !_proxy.noresult) ? _proxy._highlightSuggestion(list[i]) : list[i];
                        var li = liEle.clone();
                        li[0].innerHTML=_txt;
                        fragmentParent.appendChild(li[0])
                    }
                    _proxy.ul[0].appendChild(fragmentParent);
                }
                this._currList = list;
                this._mapper = { txt: null, key: null };
            }
            else {
                var mapper = this.model.fields, mapFld = { _key: null, _text: null, _attr: null };
                mapFld._key = (mapper && mapper.key) ? mapper["key"] : "key";
                mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
                mapFld._attr = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
                this._mapper = { txt: mapFld._text, key: mapFld._key }, this._currList = [];
                if (this.model.fields.groupBy) {
                    var mapCateg = (mapper && mapper.groupBy) ? mapper["groupBy"] : "groupBy", groupedList, _query;
                    _query = ej.Query().group(mapCateg);
                    this._addSortingQuery(_query, "key");
                    groupedList = ej.DataManager(list).executeLocal(_query);
                    this._swapUnCategorized(groupedList);
                    groupedList.forEach(function (each, i) {
                        if (each.key)
                            if (_proxy.model.multiColumnSettings.enable) {
                                var trColumn = ej.buildTag("tr.e-category").attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {});
                                trColumn.append(ej.buildTag("td", each.key).attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}).attr((i != (list.length - 1)) ? { "class": "e-atc-tdbottom" } : {}));
                                _proxy._tableColumn.append(trColumn);
                            }
                            else _proxy.ul.append(ej.buildTag("li.e-category", each.key).attr("role", "option").attr((_proxy._isIE8) ? { 'unselectable': 'on' } : {}));
                        _proxy._generateLi(each.items, mapFld);
                    });
                }
                else this._generateLi(list, mapFld);
            }
            for (var i = 0, listLength = list.length; listLength > i; i++) {
                if (this.model.multiColumnSettings.enable) {
                    var data = this._textFormateString(this._currList[i]);
                    if (data == this.value()) {
                        var activeText = this._getLiTags()[i];
                        $(activeText).addClass('e-activeli');
                    }
                }
                else {
                    var value = this.value().split(this.model.delimiterChar);
                    for (var k = 0; k <= value.length; k++) {
                        if (this._currList[i] == value[k]) {
                            var activeText = this._getLiTags()[i];
                            $(activeText).addClass('e-activeli');
                        }
                    }
                }
            }
            if (this._getLiTags().length > 0) {
				this._showResult(e);
			}

        },

        _swapUnCategorized: function (list) {
            var length = list.length;
            for (var i = 0; i < length; i++) {
                if (!list[i].key) {
                    for (var j = i; j > 0; j--) {
                        list[j] = list[j - 1];
                    }
                    list[j] = list[i];
                    return false;
                }
            }
        },

        _generateLi: function (list, mapFld) {
            var _proxy = this;
            var fragmentParent = document.createDocumentFragment();
            var fragment = document.createDocumentFragment();
            if (_proxy.model.multiColumnSettings.enable) {
                var multiColumnLength = _proxy.model.multiColumnSettings.columns.length;
                this._tableColumn.append(ej.buildTag("tbody"));
                var trEle = ej.buildTag("tr");
                var tdEle = ej.buildTag("td");
                for (var j = 0, listLength = list.length; listLength > j; j++) {
                    var _text = this._getField(list[j],mapFld._text);
                    var _key = this._getField(list[j],mapFld._key);
                    if (!ej.isNullOrUndefined(_text) || _proxy.model.multiColumnSettings.enable) {
                        var fieldAttr = _proxy._getField(list[j]);
                        var tr = trEle.clone();
                        tr[0].className = (j % 2) ? "e-atc-trbgcolor" : "";
                        for (var z = 0; z < multiColumnLength; z++) {
                            var td = tdEle.clone();
                            if(this.model.multiColumnSettings.searchColumnIndices.length !=0)
                            td[0].innerHTML = (_proxy.model.highlightSearch && $.inArray(z, _proxy._searchColumnIndex) > -1) ? _proxy._highlightSuggestion(_proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field).toString()) : _proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field);
                            else
                                td[0].innerHTML = (_proxy.model.highlightSearch && $.inArray(z.toString(), _proxy._columnIndex) > -1) ? ((!ej.isNullOrUndefined(_proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field))) ? _proxy._highlightSuggestion(_proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field).toString()) : _proxy._highlightSuggestion("")) : _proxy._getField(list[j], _proxy.model.multiColumnSettings.columns[z].field);
                            td[0].className = (((j != (list.length - 1)) ? "e-atc-tdbottom " : "") + ((z != (_proxy.model.multiColumnSettings.columns.length - 1)) ? ((_proxy.model.enableRTL) ? "e-atc-tdleft " : "e-atc-tdright ") : ""))+(_proxy.model.multiColumnSettings.columns[z].cssClass ?_proxy.model.multiColumnSettings.columns[z].cssClass:"" );
                            td[0].style.textAlign = (_proxy.model.multiColumnSettings.columns[z].textAlign ? _proxy.model.multiColumnSettings.columns[z].textAlign:"left");
							fragment.appendChild(td[0])
                        }
                        tr[0].appendChild(fragment);
                        if (_key)
                            tr.attr("id", _key);
                        _proxy._setAttributes(_proxy._getField(list[j], mapFld._attr), tr[0]);
                        fragmentParent.appendChild(tr[0]);
                        _proxy._currList = _proxy._currList.concat([list[j]]);
                    }
                }
                $(_proxy._tableColumn).find("tbody")[0].appendChild(fragmentParent);
            }
            else {
				var liEle= $("<li></li>");
                for (var j = 0, listLength = list.length; listLength > j; j++) {
                    var _text = this._getField(list[j],mapFld._text);
                    var _key = this._getField(list[j],mapFld._key);
                    if (!ej.isNullOrUndefined(_text)) {
                        if (_proxy.model.highlightSearch) _text = _proxy._highlightSuggestion(_text);
                        if (_proxy.model.template) _text = _proxy._getTemplatedString(list[j], mapFld._text, _text);
                        var li = liEle.clone();
                        li[0].innerHTML += _text;
                        if (_key)
                             li[0].setAttribute("id", _key);
                        _proxy._setAttributes(_proxy._getField(list[j], mapFld._attr), li[0]);
                        fragmentParent.appendChild(li[0]);
                        _proxy._currList = _proxy._currList.concat([list[j]]);
                    }
                }
                _proxy.ul[0].appendChild(fragmentParent);
            }

        },

        _getLiTags: function () {
            return (!this.model.multiColumnSettings.enable) ? this.ul.children("li:not('.e-category')") :this._tableColumn.find("tbody tr:not('.e-category')") ;
        },

        _getTemplatedString: function (list, searchLabl, searchTxt) {
            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                var replace = this._getField(list, field);
                // if highlightSearch is enabled, it replaces the highlighted search text
                if (searchLabl == field) replace = searchTxt;
                if (!replace) replace = "";
                str = str.split(content).join(replace);
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _setAttributes: function (data, element) {
            if (data) {
                if (typeof data == "string")
                    data = $.parseJSON(data);
                for (var key in data)
                    element.setAttribute(key, data[key]);
            }
        },

        _setListWidth: function () {
            var width = this.model.popupWidth;
            if (width && width != "auto") this.suggestionList.css({ "width": width });
            else this.suggestionList.css({ "width": this.wrapper.width() });
        },

        _setListHeight: function () {
            this.suggestionList.css({ "max-height": this.model.popupHeight });
        },

        _refreshPopup: function () {
            if (this.model.popupWidth == "auto" && Math.floor(this.wrapper.outerWidth()) != Math.floor(this.suggestionList.outerWidth())) {
                this.suggestionList.css({ "width": this.wrapper.width() });
                this._refreshScroller();
            }
            this._setListPosition();
        },

        _showResult: function (e) {
            this._refreshScroller();
            this._refreshPopup();
            if (this._isOpened)
                $(document).on("mousedown", $.proxy(this._OnDocumentClick, this));
            else {
                this.suggestionList.css("display", "none");
                var tis = this;
                clearTimeout(this._typing);
                this._typing = setTimeout(function () {
                    tis.suggestionList[(tis.model.animateType == "slide" ? "slideDown" : "fadeIn")]((tis.model.animateType == "none" ? 0 : 300), function () {
                        $(document).on("mousedown", $.proxy(tis._OnDocumentClick, tis));
                    });
                }, this.model.delaySuggestionTimeout);
                var args = (e != undefined) ? { event: e, isInteraction: true } : { isInteraction: false };
                this._trigger("open", args);
                this.wrapper.addClass("e-active");
            }

            this._isOpened = true;
            this.showSuggestionBox = true;
            var _suggestionListItems = this._getLiTags();
            this._listSize = _suggestionListItems.length;


            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            var scrObj = ej.getScrollableParents(this.wrapper);
            if (scrObj[0] != window)
                this._on(scrObj, "scroll", this._hideResult);
        },

        _hideResult: function (e) {
            if (this.showSuggestionBox) {
                this.showSuggestionBox = false;
                this._activeItem = 0;
                clearTimeout(this._hiding);
                this.element.attr("aria-expanded", false);
                var proxy = this;
                if (this._isOpened) {
                    this.suggestionList.css("display", "none");
                    var args = (e != undefined) ? { event: e, isInteraction: true } : { isInteraction: false };
                    this._trigger("close", args);
                }
                else {
                    this._hiding = setTimeout(function () {
                        if( proxy.model ) proxy.suggestionList[(proxy.model.animateType == "slide" ? "slideUp" : "fadeOut")]((proxy.model.animateType == "none" ? 0 : 100));
                         proxy._activeItem = 0;
                    }, this.model.delaySuggestionTimeout);
                }
                $(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                this.wrapper.removeClass("e-active");
            }
        },

        _refreshScroller: function () {
            this.suggestionList.css("height", "auto");
            this.suggestionList.find(".e-content , .e-scroller").removeAttr("style");
            
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
			$(this._tableColumn).css("width" ,"auto");
			$(this._tableHeader).css("width" ,"auto");
			}
            this.suggestionList.css("display", "block");
			if(this.model.multiColumnSettings.enable) {
				this.scrollerObj.option("height","auto");
				this._columnBorderAlign();
			}
            var _suggestHeight = this.suggestionList.height() > (parseInt($.isNumeric(this.model.popupHeight) ? this.model.popupHeight : this.model.popupHeight.replace("px", "")) - 4);
            if ( _suggestHeight || (this.model.multiColumnSettings.enable && (( this.suggestionList.height() <= this._tableColumn.height() )|| ( this.suggestionList.width() <= this._tableColumn.width() || (this.model.multiColumnSettings.showHeader && this.suggestionList.width() <= this._tableHeader.width()) )))){
                if( _suggestHeight ) this.scrollerObj.model.height = (this.model.multiColumnSettings.showHeader && this._tableHeader) ? parseInt(this.suggestionList.height()) - parseInt(this._tableHeader.height()) : this.suggestionList.height();
                if(!this.model.multiColumnSettings.enable && this.suggestionList.width() < this.suggestionList.find(".e-ul").width())  this.suggestionList.find(".e-ul").width(this.suggestionList.find(".e-ul").width());
				this.scrollerObj.model.width = this.suggestionList.width();
                this.scrollerObj.refresh();
                this.scrollerObj.option({"enableRTL" : this.model.enableRTL , "scrollTop": 0 , "scrollLeft" : 0 });
				if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._addThBorder();
                this.suggestionList.addClass("e-scroller")
				if(!this.scrollerObj._vScroll && this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._removeThBorder();
            }
            else {
				this.scrollerObj.setModel({height:"auto", width:this.suggestionList.width()});
				this.scrollerObj.refresh();
				if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) this._removeThBorder();
			}
            this.suggestionList.css("height", "auto");
            if (this._isIE8)
                this.suggestionList.find('.e-vscroll div, .e-hscroll div').attr("unselectable", "on");
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
		    this.suggestionList.find(".e-content").scroll(ej.proxy(function (e) {
                    this._tableHeader.parent(".e-atc-tableHeaderContent").scrollLeft($(e.currentTarget).scrollLeft());
            }, this));
			if(this.suggestionList.find(".e-content").length > 0) this._tableHeader.parent(".e-atc-tableHeaderContent").scrollLeft(this.model.enableRTL ?  this.suggestionList.find(".e-content")[0].scrollWidth - this.suggestionList.find(".e-content")[0].clientWidth : 0);
			}
        },
		
		_columnBorderAlign : function (){
			if (this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader && this._tableHeaderDiv.css("display") != "none") {
				this._tableWid = (this._tableHeader.outerWidth() > this._tableColumn.outerWidth() ) ? this._tableHeader.outerWidth() : this._tableColumn.outerWidth(); 
				this._tableColumn.find("colgroup").remove();
				$(this._headerColGroup.children).removeAttr("style");
                for (var z = 0, length = this._headerColGroup.children.length; z < length; z++) {
					$(this._headerColGroup.children[z]).css({"width": ( parseInt($(this._tableColumn).find("tr:first td").eq(z).outerWidth()) > parseInt(this._tableHeader.find("tr:first th").eq(z).outerWidth() ) ? $(this._tableColumn).find("tr:first td").eq(z).outerWidth() : this._tableHeader.find("tr:first th").eq(z).outerWidth()) });
				}
				this._tableColumn.append($(this._headerColGroup).clone());
				var wid = (this._tableWid > this.suggestionList.width()) ? this._tableWid : "100%" ;
				$(this._tableColumn).css("width" , wid );
				$( this._tableHeader ).css("width" , wid);
			}
			else if (this.model.multiColumnSettings.enable && !this.model.multiColumnSettings.showHeader ) {
				$(this._tableColumn).css("width" , "auto" );
				this._tableWid = this._tableColumn.outerWidth(); 
				$(this._headerColGroup.children).removeAttr("style");
				var wid = (this._tableWid > this.suggestionList.width()) ? this._tableWid : "100%" ;
				if(wid != "100%") {
                    for (var z = 0, length = this._headerColGroup.children.length; z < length; z++) {
						$(this._headerColGroup.children[z]).css({"width": $(this._tableColumn).find("tr:first td").eq(z).outerWidth() });
					}
					this._tableColumn.append(this._headerColGroup);
				}
				$(this._tableColumn).css("width" , wid );
			}	
			else $(this._tableColumn).css("width","100%");
		},

		_removeThBorder: function(){
			this._tableHeader.parents(".e-atc-tableHeader").removeClass((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll");
			this._tableHeader.parent(".e-atc-tableHeaderContent").removeClass("e-atc-tableHeaderBorder");
		},
		
		_addThBorder: function(){
			this._tableHeader.parents(".e-atc-tableHeader").addClass((this.model.enableRTL)? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll").removeClass((this.model.enableRTL)? "e-atc-tableHeaderScroll" : "e-atc-tableHeaderRTL");
			this._tableHeader.parent(".e-atc-tableHeaderContent").addClass("e-atc-tableHeaderBorder");
		},
        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.suggestionList.outerHeight(),
            popupWidth = this.suggestionList.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.suggestionList.outerWidth() - elementObj.outerWidth();
            this.suggestionList.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.suggestionList);
        },

        _targetFocus: function (e) {
            var minWidth = 30;  //  minimum width for textbox in visualmode
            if (this.model.multiSelectMode == "visualmode")
                this._setWatermarkWidth(minWidth);
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.wrapper.addClass("e-focus");
			this._focusValue = this.model.value;
            this._isFocused = true;
            this._trigger("focusIn", { event: e, isInteraction: true, value: this.value() });
        },
        _focusOutAction: function (e) {
			var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();	
            this._isFocused = false;
            this.wrapper.removeClass("e-focus");
            if (ej.isNullOrUndefined(this.model.fields["key"])) this._hiddenInput.val(currValue);
			if (this._focusValue != this.model.value)                                     		
                 this._changeEvtTrigger(currValue, e);
			else
			     return false;
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
            !this._isWatermark && this._setWatermarkTxt();
            this._removeSelection();
			if(this.model.multiSelectMode == "visualmode" && this.model.showResetIcon && this.element.val() != "")
				this._removeReset();
            if (this.model.multiSelectMode == "visualmode") {
                this._removeActive();
                this.element.val("");
                this._setWatermarkWidth(1);
                this._preVal = "";
                this._addNewTemplate = null;
            }
            else {
                if (this.model.multiSelectMode == "delimiter") 
                        this._valueChange(e);
                this._updateSelectedItemArray(this.getValue());
            }
		    if(!ej.isNullOrUndefined(this.value()) && this.value()!="")
			{
				var values = this.value().split(this.model.delimiterChar);
				if(this.model.multiSelectMode == "delimiter" || this.model.multiSelectMode == "none" )
				{
					var result = this._removeDuplicateVal(values); 
					this._keyProcess(result);
				}
			}
			if(this.element.val() == "" && (this.value() == "" || this.value() == null))
				this._selectValueByKey(null);
        },
        _targetBlur: function (e) {
            this._focusOutAction(e);
            this._trigger("focusOut", { event: e, isInteraction: true, value: this.value() });
        },
        _setWatermarkWidth: function (width) {
            this.model.watermarkText && this.element.attr('placeholder') ? this.element.width("") : this.element.val("").width(width);
        },
        _checkDeli: function () {
            var val = this.element.val(), deli = this.model.delimiterChar, last = val.substr(val.length - deli.length, val.length);
            if (last == deli) {
                this.element.val(val.substr(0, val.length - deli.length));
                return true;
            }
            else return false;
        },
        _removeSelection: function () {
            if (this.model.enableAutoFill) {
                this.element.attr("aria-autocomplete", "both");
                var selection = this._getCaretSelection();
                if (selection.end - selection.start != 0 && selection.end - selection.start != this.element.val().length)
                    this.target.value = this.target.value.substr(0, selection.start);
            }
        },

        _removeListHover: function () {
            this._getLiTags().removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = $(this._getLiTags()[this._activeItem - 1]);
            activeItem.addClass("e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
            activeItem.focus();
        },

        _calcScrollTop: function () {
            var ulH = (this.model.multiColumnSettings.enable) ? ((this.model.multiColumnSettings.showHeader) ? this._tableColumn.outerHeight() + this._tableHeader.outerHeight()  : this._tableColumn.outerHeight() ): this.ul.outerHeight() , li = (!this.model.multiColumnSettings.enable) ? this.ul.find("li") : this._tableColumn.find("tr"), liH = 0, index, top, i;
            index = (!this.model.multiColumnSettings.enable) ? this.ul.find("li.e-hover").index() : this._tableColumn.find("tr.e-hover").index();
            liH = li.eq(1).outerHeight() * index;
            top = liH - ((((this.model.multiColumnSettings.enable) ? this._tableColumn.parent().outerHeight() : this.suggestionList.outerHeight()) - li.eq(index).outerHeight()) / 2);
            return top;
        },

        getActiveText: function () {
			if (this._activeItem > 0) {
				if(this.model.multiColumnSettings.enable) return this._textFormateString(this._currList[this._activeItem -1 ])
				else if (!ej.isNullOrUndefined(this._mapper) && this._mapper.txt) return this._getField(this._currList[this._activeItem - 1], this._mapper.txt);			
				else  return  this._currList[this._activeItem  - 1];
			}
        },

        _getUniqueKey: function () {
            var key = null;
			if(!ej.isNullOrUndefined(this._mapper))
			{
			    if (this._mapper.key) key = this._getField(this._currList[this._activeItem - 1], this._mapper.key);
			    ej.isNullOrUndefined(key) && (key = null);
			}
            return key;
        },

        _setTextBoxValue: function () {
            if (this._activeItem && !this.noresult) {
                var currentValue, selection, val, text;
                currentValue = this.model.multiColumnSettings.enable ? this._textFormateString(this._currList[this._activeItem -1 ]) : this.getActiveText();
                selection = this._getCaretSelection();
                this.suggLen = selection.start;
                val = this.target.value.substr(0, this.suggLen);
                var _deliIndex = (this.target.value).lastIndexOf(this.model.delimiterChar);
				if(_deliIndex == -1) { var query = $.trim(val.substr(_deliIndex + 1, this.suggLen));}
               else				
				var query = $.trim(val.substr(_deliIndex + ((this.model.delimiterChar).length) ,this.suggLen));			
                if (val && (val.toLowerCase() == currentValue.substr(0, this.suggLen).toLowerCase() || query.toLowerCase() == currentValue.substr(0, this.suggLen -( _deliIndex + ((this.model.delimiterChar).length))).toLowerCase())) {
                    if (this.model.multiSelectMode == "delimiter") 
                        text = val + currentValue.substr(query.length, currentValue.length);            
                    else 
                        text = val + currentValue.substr(val.length, currentValue.length);
                    this.element.val(text);
                    this._autofilSelection();
                    if (this.model.multiSelectMode == "visualmode") {
						this._adjustWidth();
						if(this.model.enableAutoFill) this._refreshPopup();
					}
                    if (this.model.autoFocus && !this.noresult) this._addListHover();
                }
                else {
					if (this.model.multiSelectMode == "delimiter" && currentValue && query) this.element.val(this.element.val().replace(query,currentValue))
					else if (currentValue) this.element.val(currentValue)
					this._removeSelection();
				} 
            }
        },

        _enterTextBoxValue: function (e) {
            if (this._activeItem && !this.noresult && !this.model.readOnly) {
                var currentValue = this.getActiveText(), currItem = this._currList[this._activeItem - 1];
                this._preVal = currentValue + ((this.model.multiSelectMode == "delimiter") ? this.model.delimiterChar : "");
                this._valueToTextBox(currentValue, currItem, false);
                var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val() == "" ? null : this.element.val();
                this._trigger("select", { event: e, isInteraction: true, value: currValue, text: currentValue, key: this._getUniqueKey(), item: currItem });
                this._valueChange(e);
                if (this.model.showResetIcon) this._showReset();
            }
            this._isOpened && this._trigger("close", { event: e, isInteraction: true });
        },

        _createBox: function (value) {
            var span = ej.buildTag("span.e-icon e-close");
            var li = ej.buildTag("li.e-options", value).append(span);

            this._on(span, "click", function (e) {
                if (!this.model.enabled) return false;
                this._deleteBox($(e.target).parent());
            });
            return li;
        },

        _addLoadingClass: function () {
            if (this.model.showLoadingIcon)
                this.element.addClass("e-load");
        },

        _removeLoadingClass: function () {
            this.element.removeClass("e-load");
        },


        _highlightSuggestion: function (suggestion) {
            if ($.trim(this._queryString) != "") {
                var caseSensitive, tempQueryString, RegEx, mch, split, query, str;
                caseSensitive = this.model.caseSensitiveSearch ? "g" : "gi";
                query = $.trim(this._queryString);
                query = /^[a-zA-Z0-9- ]*$/.test(query) ? query : query.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
                tempQueryString = this.model.filterType == "startswith" ? "^" + query : this.model.filterType == "endswith" ? query + "$" : query;
                RegEx = new RegExp(tempQueryString, caseSensitive);
                if (RegEx.test(suggestion)) {
                    mch = suggestion.match(RegEx);
                    //for IE-8 the regEx doesnt returns the empty string.So manually we replace string to return empty string.
                    str = suggestion.replace(RegEx, "~^");
                    split = str.split("~^");
                    suggestion = "";
                    for (var i = 0, splitlength = split.length; splitlength > i; i++)
                        suggestion += mch[i] ? split[i] + "<span class='e-hilight-txt'>" + mch[i] + "</span>" : split[i];
                }
            }
            return suggestion;
        },

        _RightToLeft: function (value) {
            if (value) {
                this.wrapper.addClass("e-rtl");
                this.suggestionList.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                this.suggestionList.removeClass("e-rtl");
            }
			if(this.model.multiColumnSettings.enable && this.model.multiColumnSettings.showHeader) {
					this._tableHeaderDiv.removeClass( value ? "e-atc-tableHeaderRTL" : "e-atc-tableHeaderScroll" );
					this._tableHeader.find("tr :not(th:last)").addClass(value ? "e-atc-thleft" : "e-atc-thright").removeClass(value ? "e-atc-thright" : "e-atc-thleft" );
			}
        },

        _setRoundedCorner: function (value) {
            if (value) {
                this.container.addClass("e-corner");
                this.suggestionList.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                this.suggestionList.removeClass("e-corner");
            }
        },

        _checkReadOnly: function (value) {
            this.model.readOnly = value;
            if (this.model.readOnly) {
                this.element.attr({ "readonly": "readonly", "aria-readonly": true });
                this._off(this.element, "keydown", this._OnKeyDown);
                this._off(this.element, "keyup", this._OnKeyUp);
				this._off(this.element, "paste", this._OnPaste);
				this._off(this.element, "keypress", this._onkeyPress);
            }
            else {
                this.element.removeAttr("readonly aria-readonly");
                this._on(this.element, "keydown", this._OnKeyDown);
                this._on(this.element, "keyup", this._OnKeyUp);
			    this._on(this.element, "paste", this._OnPaste);
				this._on(this.element, "keypress", this._onkeyPress);
            }
        },
		_onkeyPress: function (e) {
			if(e.keyCode == 13) this._PreventDefaultAction(e);
		},
		_OnPaste: function (e) {
			var _proxy = this;
			setTimeout(function () {
				 _proxy._OnKeyUp(e);
				}, 0);
		},
        _OnKeyDown: function (e) {
            if (this.model.filterType != "startswith")
                this.model.enableAutoFill = false;

            switch (e.keyCode) {
                case 37:
                case 35:
                case 36:
                    this._removeSelection();
				case 13:
                case 39:
                    break;
                case 38:
                    if (this.showSuggestionBox && this.suggestionList) {
                        this._removeListHover();
                        if (this._activeItem > 1)
                            this._activeItem -= 1;
                        else
                            this._activeItem = this._listSize;
                        this._navigationHover();
                    }
                    this._PreventDefaultAction(e);
                    break;
                case 40:
                    if (this.showSuggestionBox && this.suggestionList) {
                        this._removeListHover();
                        if (this._activeItem < this._listSize)
                            this._activeItem += 1;
                        else
                            this._activeItem = 1;
                        this._navigationHover();
                    } else {
                        if (e.ctrlKey && this.element.val() == "") {
                            this._showFullList(e);
                        }
                        else if (e.ctrlKey) {
                            this._showSuggestionList(e);
                        }
                    }
                    this._PreventDefaultAction(e);
                    break;
				case 33: /* page up */
				case 34:
				    if (this.showSuggestionBox && this.suggestionList) {
						this._removeListHover();             
                        var suggestionH = (this.model.multiColumnSettings.enable) ? this._tableColumn.parent().height() : this.suggestionList.height();
                        var liH = (this.model.multiColumnSettings.enable) ? this._tableColumn.find("tr").outerHeight() : this.ul.children("li").outerHeight();
                        var activeItem = Math.round(suggestionH / liH) != 0 ? Math.round(suggestionH / liH) : this._listSize;
                        this._activeItem = (e.keyCode == 33) ? this._activeItem - activeItem :  this._activeItem + activeItem
						if( this._activeItem < 1) this._activeItem = 1;
						if(this._activeItem > this._listSize ) this._activeItem = this._listSize;
						this._navigationHover();
					}
                        this._PreventDefaultAction(e);
                        break;
                case 8:
                    if ($.trim(this.element.val()) == "") this._isOpened = false;
                    if (this.model.multiSelectMode == "visualmode" && this.element.val() == "") {
                        this._deleteLastBox();
                    }
                    break;
                case 17:
                    this.ctrlKeyPressed = true;
                    break;
                case 9:
                    if (this.showSuggestionBox) {
                        this._queryString = this.element.val();
                        this._enterTextBoxValue(e);
                        this._hideResult(e);
                        this._isOpened = false;
                        this._PreventDefaultAction(e);
                    }
                    break;
                case 27:
                    this._isOpened = false;
                    var _showSuggestionBox = this.showSuggestionBox;
                    this._hideResult(e);
                    this._PreventDefaultAction(e);
                    if (_showSuggestionBox) this._trigger("close", { event: e, isInteraction: true });
                    break;
            }
            if (this.model.multiSelectMode == "visualmode") {
                if (e.keyCode != 17 && e.keyCode != 8 && e.keyCode != 46) this._removeActive();
                this._adjustWidth();
            }
        },


        _PreventDefaultAction: function (e) {

            e.preventDefault();
            if (!this._cancelEvent) {
                e.stopPropagation();
                e.cancelBubble = true;
                e.returnValue = true;
            }

        },
        _bubbleEvent: function (cancelevent) {

            if (typeof cancelevent == "boolean")
                this._cancelEvent = cancelevent;
            return this._cancelEvent;
        },
        _navigationHover: function () {
			this._addListHover();
            if (this.model.enableAutoFill) {
                this.element.attr("aria-autocomplete", "both");
                this._queryString = this.target.value;
                this._setTextBoxValue();
            }
		},


        _OnKeyUp: function (e) {
            this._keyDownComplete(e);
            if (this.ctrlKeyPressed && e.type != "paste") {
                if (e.keyCode == 17)
                    this.ctrlKeyPressed = false;
                return false;
            }

            if ($.trim(this.element.val()) == "" && e.keyCode == 38 && e.keyCode == 40) {
                this._hideResult(e);
                return false;
            }
            if (!this._checkDelimiter()) return false;
            this._queryString = $.trim(this._queryString);

            switch (e.keyCode) {
				case 34:
				case 33:
                case 38:
                case 40:
                case 37:
                case 39:
                case 20:
                case 16:
                case 17:
                case 18:
                case 35:
                case 36:
                case 144:
                case 9:
                case 27: break;

                case 13:
                    e.preventDefault();
                    this._queryString = this.element.val();
                    this._enterTextBoxValue(e);
                    if (this.model.enableAutoFill) {
                        this.element.attr("aria-autocomplete", "both");
                        this.suggLen = this.element.val().length;
                        this._autofilSelection();
                    }
                    this._isOpened = false;
                    this._hideResult(e);
                    break;

                case 46:
                    if (this.model.multiSelectMode == "visualmode" && this.element.val() == "") {
                        this._deleteBox(this._ulBox.children("li.e-active"));
                        break;
                    }
                case 8:
                    if (this._queryString.length >= this.model.minCharacter) {
                        this._autoFill = false;
                        this._OnTextEnter(e);
                    }
                    else {
                        this.noresult = true;
                        this._hideResult(e);
                        if ($.trim(this.element.val()) == "") 
                            this._isOpened = false;
                    }
                    this._typed = true;
                    break;

                default:
                    if (this._queryString.length >= this.model.minCharacter) {
                        this._autoFill = true;
                        this._OnTextEnter(e);
                    }
                    else {
						this.noresult = true;
						this._isOpened = false;
					}
                    this._typed = true;
                    break;
            }
        },

        _getFilteredList: function (list, e) {
            clearTimeout(this.timeDelay);
            if (!ej.isNullOrUndefined(list) && typeof list[0] == "object") {
                var bindTo = (this.model.fields.text) ? this.model.fields["text"] : "text";
                if ( this.model.actionFailure && ej.isNullOrUndefined((ej.DataManager(list).executeLocal(ej.Query().select(bindTo))[0])) )
                    this._trigger("actionFailure", { error: this._localizedLabels["actionFailure"] });
            }
            if (!list || !list.length || list.length < 1) {
                this.suggestionListItems = [];
                if (this.model.actionFailure) this._trigger("actionFailure", { error: this._localizedLabels["actionFailure"] });
            }
            else {
                var tempQuery = ej.Query();
                this._addQuery(tempQuery, typeof list[0] == "object");
                this.suggestionListItems = ej.DataManager(list).executeLocal(tempQuery);
                if (this.model.actionSuccess) this._trigger("actionSuccess");
            }
            this._doneRemaining(e);
            if (this.model.actionComplete)
                this._trigger("actionComplete");
        },

        _performSearch: function (e) {
            if (this.model.actionBegin)
                this._trigger("actionBegin");
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (!source.dataSource.offline && !(source.dataSource.json && source.dataSource.json.length > 0)) {
                    window.clearTimeout(this.timer);
                    var proxy = this;
                    this.timer = window.setTimeout(function () {
                        proxy._fetchRemoteDat(source);
                    }, 700);
                }
                else {
					this._getFilteredList(source.dataSource.json, e);
					this._selectedObj.push(source.dataSource.json);
				}
            }
            else this._getFilteredList(source, e);
        },

        _fetchRemoteDat: function (source) {
            var proxy = this, queryPromise, tempQuery = this._getQuery();
            this._addQuery(tempQuery, true);
            queryPromise = source.executeQuery(tempQuery);
            queryPromise.fail(function (e) {
                proxy.suggestionListItems = null;
                proxy._removeLoadingClass();
                proxy._trigger("actionFailure", e);
            }).done(function (e) {
                proxy.suggestionListItems = e.result;
				if(proxy.model.multiSelectMode == "none")
					proxy._selectedObj = e.result;
				else if(proxy.model.multiSelectMode == "delimiter")
					proxy._selectedObj = proxy._selectedObj.concat(e.result);
                proxy._doneRemaining(e);
                proxy._trigger("actionSuccess", e);
            }).always(function (e) {
                proxy._trigger("actionComplete", e);
            });
        },

        _addSortingQuery: function (query, key) {
            if (this.model.allowSorting) {
                var order = (this.model.sortOrder == "descending") ? true : false;
                query.sortBy(key, order);
            }
        },

        _addQuery: function (_query, checkMapper) {
            var bindTo = "";
            var predicate, index;
            if (checkMapper) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper.text) ? mapper["text"] : "text";
            }
			if (this._queryString) {
            if (this.model.multiColumnSettings.enable) {
				this._columnsIndex();
				if (checkMapper) {
                    var bindTo = [];
                    if(this.model.multiColumnSettings.searchColumnIndices.length !=0){
				    for (var i = 0, length = this._searchColumnIndex.length; i < length; i++) {
				        bindTo.push(this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].field);
				        predicate = this._predicateConvertion(predicate, this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].field, (this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].filterType ? this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].filterType : this.model.filterType), this._queryString, !this.model.caseSensitiveSearch, (this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].type ? this.model.multiColumnSettings.columns[this._searchColumnIndex[i]].type : "string"));
                    }
                }
                else{
                    for (var i = 0, length = this._columnIndex.length; i < length; i++) {
				        bindTo.push(this.model.multiColumnSettings.columns[this._columnIndex[i]].field);
				        predicate = this._predicateConvertion(predicate, this.model.multiColumnSettings.columns[this._columnIndex[i]].field, (this.model.multiColumnSettings.columns[this._columnIndex[i]].filterType ? this.model.multiColumnSettings.columns[this._columnIndex[i]].filterType : this.model.filterType), this._queryString, !this.model.caseSensitiveSearch, (this.model.multiColumnSettings.columns[this._columnIndex[i]].type ? this.model.multiColumnSettings.columns[this._columnIndex[i]].type : "string"));
                    }
                }
				    for (var i = 0; i < _query.queries.length; i++) {
				        if (_query.queries[i].fn == "onWhere") {
				            index = _query.queries.slice(i)[0].e;
				        }
				    }
				    if (ej.isNullOrUndefined(index))
				        _query.where(predicate);
				    else
				        _query.where((index).and(predicate));
				}
				else _query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);

            }
            
			else _query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);
			}
            this._addSortingQuery(_query, bindTo);
        },

		_predicateConvertion: function( predicate, field, filterType, value, casing ,type){
			var _query;
			if(type == "number")
				_query = Number(value);
			else if(type == "boolean") {
				if(value == "true" || value == "yes" || value =="1") _query = true;
				else if(value == "false" || value == "no" || value =="0") _query = false;
			}	
			else if(type =="date")
				_query = new Date(value);
			else _query = value;
			if( (type == "number" && isNaN(_query)) ||(type == "boolean" && _query == undefined ) )
				predicate = predicate;
			else 
				predicate = predicate != undefined ? predicate["or"]( field, filterType, _query,casing):ej.Predicate( field, filterType, _query,casing);
			return predicate;
		}, 
		
        _getQuery: function () {
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [], queryManager = ej.Query(), mapper = this.model.fields;
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!ej.isNullOrUndefined(this.model.dataSource.dataSource.url) && !this.model.dataSource.dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = this.model.query.clone();
            return queryManager;
        },

        _OnTextEnter: function (e) {
            var proxy = this;
			if( ej.isDevice() ) {
            clearTimeout(this.timeDelay);
            this.timeDelay = setTimeout(function () {
                proxy._onTextProcess(e);
            }, proxy.model.delaySuggestionTimeout);
			}
			else proxy._onTextProcess(e);
        },
		_onTextProcess: function (e) {
			this._addLoadingClass();
			this.element.attr("aria-expanded", false);
			this._performSearch(e);
			if (this.model.showResetIcon) this._showReset();
		},
        _showReset: function () {
            if (ej.isNullOrUndefined(this.resetSpan)) {
                this.resetSpan = ej.buildTag("span.e-icon e-iclose");
                if (!this.model.showPopupButton) {
                    this.container.append(this.resetSpan).addClass("e-reset");
                }
                else {
                    this.dropdownbutton.before(this.resetSpan);
                    this.container.addClass("e-popup e-reset");
                }
            }
            this._on(this.resetSpan, "mousedown", this._refreshSearch);
        },
		 
		_refreshSearch:function(){
			this.resetSpan = null;
			this.clearText();
			this._refreshPopup();			
		},
		
		_removeReset:function (){
	        this.resetSpan = this.resetSpan && this.resetSpan[0].remove();		
            this._refreshPopup();			  
		  },

        _doneRemaining: function (e) {
            this._showSuggestionList(e);
            this.element.attr({"aria-expanded": true , "aria-haspopup": true});
            if (this.model.enableAutoFill && this._autoFill && !this.noresult || this.model.autoFocus) {
                this.element.attr("aria-autocomplete", "both");
                this._activeItem = 1;
                this._queryString = this.target.value;
            }
            if (this.model.enableAutoFill && this._autoFill && !this.noresult) this._setTextBoxValue();
            if (this.model.autoFocus && !this.noresult) this._addListHover();
            this._removeLoadingClass();
            if (this.noresult && !this.model.showEmptyResultText)
                this._hideResult(e);
        },

        _removeRepeated: function () {
            var results = this.suggestionListItems;
            if (!results || results.length == 0 || this._selectedItems.length == 0 || ( this.suggestionListItems.length == 1 && this.suggestionListItems[0] == (this.element.val() + this._addNewTemplate)))
                return false;
			this._repeatRemove = false;
			for (var i = 0, length = this._selectedItems.length; i < length; i++) {
			    var index;
			    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
			        var proxy = this, tempindex = 0;
			        results.forEach(function (data) {
			            if (!ej.isNullOrUndefined(data[proxy.model.fields["text"]]) ? (data[proxy.model.fields["text"]] == proxy._selectedItems[i][proxy.model.fields["text"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["key"]]) ? (data[proxy.model.fields["key"]] == proxy._selectedItems[i][proxy.model.fields["key"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["htmlAttributes"]]) ? (data[proxy.model.fields["htmlAttributes"]] == proxy._selectedItems[i][proxy.model.fields["htmlAttributes"]]) : true &&
                            !ej.isNullOrUndefined(data[proxy.model.fields["groupBy"]]) ? (data[proxy.model.fields["groupBy"]] == proxy._selectedItems[i][proxy.model.fields["groupBy"]]) : true)
			                index = tempindex;
			            tempindex++;
			        });
			    }
			    else{
                 index = results.indexOf(this._selectedItems[i]);
				 if (!isNaN(parseFloat(this._selectedItems[i]))) index = results.indexOf(parseFloat(this._selectedItems[i]));
				}
			    if (index != -1 && !ej.isNullOrUndefined(index)) this.suggestionListItems.splice(index, 1);
				if( this.element.val() == this._selectedItems[i] )this._repeatRemove = true;
            }
        },

        _checkDelimiter: function () {
            this._queryString = this.element.val();
            var _deliIndex = (this.model.multiSelectMode != "delimiter") ? -1 : this._queryString.lastIndexOf(this.model.delimiterChar);


            if (_deliIndex == -1) {
                return true;
            }
            else {
                this._queryString = this._queryString.substr(_deliIndex + ((this.model.delimiterChar).length), this._queryString.length);
                return true;
            }
        },

        _autofilSelection: function () {
            var element = this.element[0], totLen = this.element.val().length;

            if (element.setSelectionRange)
                element.setSelectionRange(this.suggLen, totLen);
            else if (element.createTextRange) {

                element = element.createTextRange();
                element.collapse(true);
                element.moveEnd('character', totLen);
                element.moveStart('character', this.suggLen);
                element.select();
            }
        },

        _OnDropdownClick: function (e) {
            if (this.model.enabled && !this.model.readOnly) {
                e.preventDefault();
                this.dropdownbutton.addClass("e-active");
                this._iconEventBind(this.dropdownbutton, "span");
				if ((e.which && e.which == 1) ||(e.button && e.button == 0)) {
                this._addLoadingClass();
                if (this.showSuggestionBox) {
                    this._hideResult(e);
                    this._isOpened = false;
                    this._removeLoadingClass();
                }
                else this._showFullList(e);
            }
		  }
        },

        _iconEventBind: function (element, target) {
            element.on({
                mouseleave: $.proxy(this._OnMouseIconClick, this)
            }, target);
        },

        _OnMouseIconClick: function (e) {
            this.dropdownbutton.removeClass("e-active");
        },

        _showFullList: function (e) {
            if (!this._isFocused)
                this.element.focus();
            this._queryString = null;
            this._autoFill = false;
            this._performSearch(e);
        },

        _OnMouseEnter: function (e) {
            this._getActiveItemIndex(e);
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
        },
        _getActiveItemIndex: function (e) {
            var targetEle = e.target;
            if (this.model.multiColumnSettings.enable && e.target.tagName.toLowerCase() != "tr") targetEle = $(e.target).parents("tr");
            else if (e.target.tagName.toLowerCase() != "li") targetEle = $(e.target).parents("li");
            this._getLiTags().removeClass("e-hover");
            $(targetEle).addClass("e-hover");
            this._queryString = this.element.val();
            this._activeItem = this._getLiTags().index($(targetEle)) + 1;
        },

        _OnMouseLeave: function (e) {
            this._getLiTags().removeClass("e-hover");
            if (this.model.showPopupButton) this.dropdownbutton.removeClass('e-active');
            if (this.model.highlightSearch)
                this._getLiTags().find(".e-hilight-txt").removeClass("e-hover");
        },

         _OnMouseClick: function (e) {
             this._getActiveItemIndex(e);
            if (!this.noresult) {
                this._enterTextBoxValue(e);
                this._isOpened = false;
                this._hideResult(e);
            }
        },
        
        _OnDocumentClick: function (e) {
            if (!$(e.target).is(this.suggestionList) && !$(e.target).parents(".e-atc-popup").is(this.suggestionList) &&
                !$(e.target).is(this.element) && !$(e.target).parents(".e-atc").is(this.wrapper)) {
                this._isOpened = true;
                this._hideResult(e);
            }
            else if ($(e.target).is(this.suggestionList) || $(e.target).parents(".e-atc-popup").is(this.suggestionList))
                e.preventDefault();
        },

        _OnWindowResize: function (e) {
            this._refreshPopup();
        },

		_keyProcess: function (values) {
		    var map = this._declareVariable(), proxy = this;
		    var delimiterIndex;
		    delimiterIndex = this._delimiterChar();
		    if (!ej.isNullOrUndefined(values)){
                for (var data = 0, length = values.length; data < length; data++) {
                    var _val =values[data];
                    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager)
                        proxy._selectValueByKey(null);
                 else {
                        this._dataQuery =this.model.multiColumnSettings.enable ? ej.Query(): ej.Query().where(map[0], this.model.filterType, _val, false);
                        this._promise = ej.DataManager(this.model.dataSource).executeLocal(this._dataQuery);
                        if (!this.model.multiColumnSettings.enable) {
                            if (this._promise instanceof Array && (this._promise.length == 0))
                                this._selectValueByKey() != null ? this._selectValueByKey() : null;
                            else
                                this._getFieldKey(this._promise[0], map[1], delimiterIndex);
                        }
                        else this._formatStringKey(values, map, delimiterIndex)
                    }
                }
			}
		},

		_formatStringKey: function (values, map, delimiterIndex) {
		    this._selectValueByKey(null);
            for (var data = 0, valueLength = values.length; data < valueLength; data++) {
		        if (values[data] != "") {
		            var _val = values[data];
		            var _isExistIndex
                    for (var i = 0, length = this._promise.length; i < length; i++) {
		                if (_val == this._textFormateString(this._promise[i]))
		                    _isExistIndex = i;
		            }
		            if (_isExistIndex) this._getFieldKey(this._promise[_isExistIndex], map[1], delimiterIndex);
		            else
		                this._selectValueByKey() != null ? this._selectValueByKey() : null;
		        }
		    }
		},
		_getFieldKey: function (data, _key, deliIndex) {
		    if (!ej.isNullOrUndefined(this.model.template) && ej.isNullOrUndefined(this._getField(data, _key))) return;
		    if (ej.isNullOrUndefined(this._getField(data, _key))) return;
		    key = this._getField(data, _key).toString();
		    if (this.model.multiSelectMode != "none") {
		        var keyval, splitval, eleVal, key = this._selectValueByKey();
		        delimiterChar = this.model.delimiterChar;
		        keyval = this._getField(data, _key).toString();
		        if (key != null) {
		            splitval = key.toString().split(deliIndex).filter(function (v) { return v !== "" });
		            if ($.inArray(keyval, splitval) == -1) {
		                splitval.push(keyval);
		                key = splitval.join(delimiterChar) + delimiterChar;
		            }
		            else
		                key = keyval + delimiterChar;
		        }
		        else
		            key = keyval + delimiterChar;
		    }
		    this._selectValueByKey(key);
		},

		_removeDuplicateVal: function (values) {
		    var result = [];
		    $.each(values, function (i, e) {
		        if ($.inArray(e, result) == -1)
		            result.push(e);
		    });
		    if (values.length == 1 && !ej.isNullOrUndefined(this._originalval)) {
		        if ($.inArray(values[0], this._originalval) == -1)
		            this._selectValueByKey(null);
		    }
		    return result;
		},

        _valueChange: function (e) {
            var currValue = this.model.multiSelectMode == "visualmode" ? this._modelValue : this.element.val();
            if (this.value() != currValue || (currValue == "" && this.element.val() != "")) {
                this.value(currValue);
                if (ej.isNullOrUndefined(this.model.fields["key"])) this._hiddenInput.val(currValue);
                this._changeEvtTrigger(currValue, e);
            }
			if(this.model.showResetIcon && !currValue){
			this.wrapper.find("span.e-iclose").remove();
			this.resetSpan = null;}
        },
        _changeEvtTrigger: function (currValue, e) {
            var args = (e != undefined) ? { event: e, isInteraction: true, value: currValue } : { isInteraction: false, value: currValue };
            if (!this.initialRender) {
				this._trigger("_change", { value: currValue });
                this._trigger("change", args);
            }
        },

        _updateSelectedItemArray: function (value) {
            var  values = [];
            this._selectedItems = [];
            this.suggestionListItems = this.model.dataSource;
            if (this.model.multiSelectMode == "delimiter" && value) {
                values = value.split(this.model.delimiterChar);
                if ((ej.DataManager && this.model.dataSource instanceof ej.DataManager) || ((!ej.isNullOrUndefined(this.suggestionListItems)) && (typeof this.suggestionListItems[0] != "object"))) {
                    for (var i = 0, length = values.length; i < length; i++) {
                        if (values[i]) {
                            var _proxy = this;
							var _objLen = this._selectedObj.length;
							var result = {};
							for (var j = 0; j< _objLen; j++ ){
								if(this._selectedObj[j][_proxy.model.fields.text] == values[i]) {
									result = this._selectedObj[j];
									j = _objLen;
								}
							}
							this._selectedItems.push(!$.isEmptyObject(result) ? result : values[i]);
						}
                    }
                }
                else
                    this._createBoxForObjectType(values);
            }
            else if (this.model.multiSelectMode == "none" && value) {
                values.push(value);
                if ((ej.DataManager && this.model.dataSource instanceof ej.DataManager) || ((!ej.isNullOrUndefined(this.suggestionListItems)) && (typeof this.suggestionListItems[0] != "object"))) {
                    var _proxy = this;
					var result = $.grep(this._selectedObj, function(e){ if(e[_proxy.model.fields.text] == value) return e; });
					this._selectedItems.push(result.length > 0 ? result : value);
				}
                else
                    this._createBoxForObjectType(values);
            }
        },

        _keyDownComplete: function (e) {
            var currValue = this.element.val();
            var prevValue = this.value();
            if (!ej.isNullOrUndefined(this.model.fields["key"])) {
                if ((e.keyCode == 46 || e.keyCode == 8 || e.keyCode == 65) && (this.model.multiSelectMode != "visualmode")) {
                    var data = this.value();
                    var array = data.split(",");
                    var deli = this.model.delimiterChar;
                    var index = array.indexOf(prevValue.replace(/,/g, ''));
                    var values = this._hiddenInput.val().split(deli);
                    values.splice(index, 1);
                    this._hiddenInput.val(values.join(deli));
                }
            }
            if (this._preVal != currValue) {
                this._preVal = currValue;
                if (this.model.multiSelectMode == "visualmode") this._adjustWidth();
                this._valueChange(e);
            }
        },

        _moveCaretToEnd: function (el) {
            //Chrome Scroll content
            el.scrollLeft = el.scrollWidth;
            //IE Scroll the content
            if (el.createTextRange) {
                var rng = el.createTextRange();
                rng.moveEnd('textedit');
                rng.moveStart('textedit');
                rng.select();
            }
            if (typeof el.selectionStart == "number") {
                el.selectionStart = el.selectionEnd = el.value.length;
            } else if (typeof el.createTextRange != "undefined") {
                var range = el.createTextRange();
                range.collapse(false);
                range.select();
            }
        },

        _getCaretSelection: function () {
            var input = this.element[0], start = 0, end = 0;

            if (!isNaN(input.selectionStart)) {
                start = input.selectionStart;
                end = input.selectionEnd;
                return { start: Math.abs(start), end: Math.abs(end) };
            }

            var bookmark = document.selection.createRange().getBookmark();
            var selection = input.createTextRange();
            selection.moveToBookmark(bookmark);

            var before = input.createTextRange();
            before.collapse(true);
            before.setEndPoint("EndToStart", selection);
            var beforeLength = before.text.length, selLength = selection.text.length;
            return { start: beforeLength, end: beforeLength + selLength };
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _wireEvents: function () {
            this._on(this.element, "focus", this._targetFocus);
            this._on(this.element, "blur", this._targetBlur);
        }
    });
    ej.Autocomplete.Locale = ej.Autocomplete.Locale || {};
    ej.Autocomplete.Locale["default"] = ej.Autocomplete.Locale["en-US"] = {
        addNewText: "Add New",
        emptyResultText: "No suggestions",
        actionFailure: "The specified field doesn't exist in given data source",
        watermarkText: ""
    };

    ej.filterType = {
        /**  Supports to search text with startswith  */
        StartsWith: "startswith",
        /**  Supports to search text with contains */
        Contains: "contains",
        /**  Supports to search text with endswith */
        EndsWith: "endswith",
        /**  Supports only for number lessthan only */
        LessThan: "lessthan",
        /**  Supports only for number greaterthan only */
        GreaterThan: "greaterthan",
        /**  Supports only for number lessthanorequal only */
        LessThanOrEqual: "lessthanorequal",
        /**  Supports only for number greaterthanorequal only */
        GreaterThanOrEqual: "greaterthanorequal",
        /**  Supports only for number equal only */
        Equal: "equal",
        /** Supports only for number notequal only */
        NotEqual: "notequal"
    };

    ej.SortOrder = {
        /** Supports to sorts with ascending only */
        Ascending: "ascending",
        /** Supports to sorts with descending only */
        Descending: "descending"
    };

    ej.MultiSelectMode = {
        /** Supports to selection mode with none only */
        None: "none",
        /** Supports to selection mode with delimitter only */
        Delimiter: "delimiter",
        /** Supports to selection mode with visualmode only */
        VisualMode: "visualmode"
    };
    ej.Animation = {
        /** Supports to animation type with none only */
        None: "none",
        /** Supports to animation type with slide only */
        Slide: "slide",
        /** Supports to animation type with fade only */
        Fade: "fade"
    };
	ej.Type = {
		Number: "number",
		String: "string",
		Boolean: "boolean",
		Date: "date"
	}
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin provides support to display calendar within your web page and allows to pick the date.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDatePicker", "ej.DatePicker", {

        element: null,
        _rootCss: "e-datepicker",

        model: null,
        validTags: ["input", "div", "span"],
        _setFirst: false,
        _addToPersist: ["value"],
        _cancelValue: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },


        defaults: {

            dayHeaderFormat: "min",

            showPopupButton: true,

            enableAnimation: true,

            showFooter: true,

            displayInline: false,

            htmlAttributes: {},

            dateFormat: '',

            watermarkText: "Select date",

            value: null,
            minDate: new Date("01/01/1900"),

            maxDate: new Date("12/31/2099"),

            startLevel: "month",

            depthLevel: "",

            cssClass: "",

            startDay: -1,

            stepMonths: 1,

            locale: "en-US",

            showOtherMonths: true,

            enableStrictMode: false,

            enablePersistence: false,

            enabled: true,

            width: "",

            height: "",

            enableRTL: false,

            showRoundedCorner: false,

            headerFormat: 'MMMM yyyy',

            buttonText: 'Today',

            readOnly: false,

            specialDates: null,

            fields: {

                date: "date",

                tooltip: "tooltip",

                iconClass: "iconClass",

                cssClass: "cssClass"
            },

            showTooltip: true,

            showDisabledRange: true,

            highlightSection: "none",

            highlightWeekend: false,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            allowEdit: true,

            tooltipFormat: "ddd MMM dd yyyy",

            allowDrillDown: true,

            blackoutDates: [],

            beforeDateCreate: null,

            open: null,

            close: null,

            select: null,

            change: null,

            focusIn: null,

            focusOut: null,

            beforeOpen: null,

            beforeClose: null,

            navigate: null,

            create: null,

            destroy: null,

            weekNumber: false

        },


        dataTypes: {
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            displayInline: "boolean",
            showPopupButton: "boolean",
            locale: "string",
            readOnly: "boolean",
            cssClass: "string",
            dateFormat: "string",
            watermarkText: "string",
            headerFormat: "string",
            buttonText: "string",
            specialDates: "data",
            showTooltip: "boolean",
            highlightSection: "enum",
            highlightWeekend: "boolean",
            enableAnimation: "boolean",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data",
            tooltipFormat: "string",
            allowEdit: "boolean",
            allowDrillDown: "boolean",
            weekNumber: "boolean"

        },

        _renderPopup: function () {
            this.sfCalendar = ej.buildTag('div.e-datepicker e-popup e-widget ' + this.model.cssClass + ' e-calendar ' + (this.model.specialDates ? (this.model.specialDates[0][this._mapField._icon] ? 'e-icons ' : '') : ''), "", {}, { id: (this._id ? 'e-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                     .insertBefore(this.element);
            if (this.model.displayInline && !this.element.is("input"))
                this.sfCalendar.addClass('e-inline');
            this.popup = this.sfCalendar;
            if (!ej.isTouchDevice()) this.sfCalendar.addClass('e-ntouch');
            this._setRestrictDateState(this.model.showDisabledRange);
            this._createCalender();
            this._setDisplayInline(this.model.displayInline);
            this._resizeCalender();
            this._setRTL(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this._wireCalendarEvents();
        },

        _setModel: function (jsondata) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            var callRefresh = false, start = false, validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "dayHeaderFormat":
                        this.model.dayHeaderFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "weekNumber":
                        this.model.weekNumber = jsondata[key];
                        this._refreshDatepicker();
                        break;
                    case "showPopupButton":
                        this._renderDateIcon(jsondata[key], true);
                        break;
                    case "displayInline":
                        if (!jsondata[key]) this._bindDateButton();
                        this._setDisplayInline(jsondata[key]);
                        if (!this.model.allowEdit && !jsondata[key] && this._isInputBox)
                            this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                        break;
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        if (ej.isNullOrUndefined(jsondata["minDate"]) && ej.isNullOrUndefined(jsondata["maxDate"])) {
                            this._setDateValue(jsondata[key]);
                            if (this._specificFormat())
                                this._stopRefresh = true;
                            jsondata[key] = this.model.value;
                        }
                        else
                            this._updateDateValue(jsondata[key]);
                        validate = callRefresh = start = true;
                        break;
                    case "specialDates":
                        this.model.specialDates = jsondata[key];
                        this._createSpecialDateObject();
                        callRefresh = start = true;
                        break;
                    case "fields":
                        this.model.fields = jsondata[key];
                        this._mapField = this._getMapper();
                        callRefresh = start = true;
                        break;
                    case "showTooltip":
                        this.model.showTooltip = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightWeekend":
                        this.model.highlightWeekend = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightSection":
                        this.model.highlightSection = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "dateFormat":
                        this.model.dateFormat = jsondata[key];
                        this._ensureValue();
                        break;
                    case "minDate":
                        this._setMinDate(jsondata[key]);
                        jsondata[key] = this.model.minDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "maxDate":
                        this._setMaxDate(jsondata[key]);
                        jsondata[key] = this.model.maxDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this.model.startDay = ((ej.isNullOrUndefined(this._options.startDay)) && (this.model.startDay === this.culture.calendar.firstDay))
                            ? -1 : (this._options.startDay === this.defaults.startDay) ? -1 : this.model.startDay;
                        this.model.dateFormat = ((ej.isNullOrUndefined(this._options.dateFormat)) && (this.model.dateFormat === this.culture.calendar.patterns.d))
                            ? '' : this.model.dateFormat;
                        this._setCulture(jsondata[key]);
                        if (this.model.value) this._setDateValue(this.model.value);
                        jsondata[key] = this.model.locale;
                        callRefresh = start = true;
                        break;
                    case "showOtherMonths":
                        this.model.showOtherMonths = jsondata[key];
                        this._otherMonthsVisibility();
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = jsondata[key];
                        validate = callRefresh = start = true;
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "readOnly":
                        this.model.readOnly = jsondata[key];
                        this._disbleMaualInput();
                        break;
                    case "width":
                        this._setWidth(jsondata[key]);
                        break;
                    case "height":
                        this._setHeight(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        break;
                    case "enableRTL":
                        this._setRTL(jsondata[key]);
                        break;
                    case "showRoundedCorner":
                        this._setRoundedCorner(jsondata[key]);
                        break;
                    case "enabled":
                        if (!jsondata[key]) this.disable();
                        else this.enable();
                        break;
                    case "buttonText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["buttonText"] = this.model.buttonText = jsondata[key];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._setFooterText(jsondata[key]);
                        break;
                    case "showFooter":
                        this._enableFooter(jsondata[key]);
                        break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "startDay":
                        var initial = jsondata[key];
                        if (parseInt(jsondata[key]) < 0 || parseInt(jsondata[key]) > 6) {
                            jsondata[key] = this.culture.calendar.firstDay;
                            initial = -1;
                        }
                        this.model.startDay = jsondata[key];
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["startDay"] = initial;
                        callRefresh = start = true;
                        break;
                    case "startLevel":
                        this.model.startLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "headerFormat":
                        this.model.headerFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "depthLevel":
                        this.model.depthLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "allowEdit": this._changeEditable(jsondata[key]); break;
                    case "tooltipFormat":
                        this.model.tooltipFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "allowDrillDown":
                        this._allowQuickPick(jsondata[key]);
                        callRefresh = start = true;
                        break;
                    case "showDisabledRange":
                        this._setRestrictDateState(jsondata[key]);
                        break;
                    case "blackoutDates":
                        this.model.blackoutDates = jsondata[key];
                        this._initDisableObj(this.model.blackoutDates);
                        callRefresh = start = true;
                        break;
                }
            }
            if (validate) {
                this._validateMinMaxDate();
                jsondata["value"] = this.model.value;
                jsondata["maxDate"] = this.model.maxDate;
                jsondata["minDate"] = this.model.minDate;
            }
            this._setWaterMark();

            if (callRefresh && (this.isValidState || this.model.displayInline))
                this._refreshDatepicker();
            if (start) this._startLevel(this.model.startLevel);
            this._triggerChangeEvent();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.model.displayInline)
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
            if (this._isOpen)
                this.hide();
            this.sfCalendar && this.sfCalendar.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
            this.element.removeClass('e-datepicker e-input');
            this.element.removeAttr('aria-atomic aria-live aria-activedescendant aria-expanded role placeholder tabindex' );
            !this._cloneElement.hasAttribute("name") && this.element.removeAttr("name");
        },

        _init: function (options) {
            this._options = options;
            this._cloneElement = this.element.clone();
            this._dt_drilldown = false;
            this._ISORegex();
            this._initDisableObj(this.model.blackoutDates);
            this.animation = {
                open: { duration: 200 },
                close: { duration: 100 }
            };
            this._animating = false;
            this._isInputBox = this._isInputBox();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._checkAttribute();
            this._setValues();
            this._createDatePicker();
            if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
                this.model.validationMessages = this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },

        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _checkAttribute: function () {
            var attr = ["min", "max", "readonly", "disabled"], propName = ["minDate", "maxDate", "readOnly", "enabled"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if (!ej.isNullOrUndefined(value)) {
                    if (ej.isNullOrUndefined(this._options))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                    else if (ej.isNullOrUndefined(this._options[propValue]))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _updateDateValue: function (value) {
            var date = this._checkDateObject(value);
            if (date != null) {
                this.isValidState = true;
                if (date == "") {
                    this.element.val("");
                    this.model.value = null;
                } else {
                    this.model.value = date;
                    this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
                }
            }
            else {
                (typeof date === "string" && this.model.enableStrictMode) ? this.element.val(value) : this.element.val("");
                this.model.value = null;
                this.isValidState = (this.element.val() == "") ? true : false;
            }
            this._removeWatermark();
        },
        _ensureValue: function () {
            var dateValue = this._parseDate(this.element.val(), this.model.dateFormat);
            if (this.model.value)
                this._setDateValue(this.model.value);
            else if (dateValue)
                this._setDateValue(dateValue);
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    if (!this.model.displayInline) this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                }
                this[action](this.element, "blur", this._onFocusOut);
                this[action](this.element, "focus", this._onFocusIn);
                this[action](this.element, "keydown", this._onKeyDown);
            }
        },
        _allowQuickPick: function (value) {
            $('.e-datepicker-headertext', this.sfCalendar)[value ? "on" : "off"]("click", $.proxy(this._forwardNavHandler, this));
        },
        _setRestrictDateState: function (value) {
            var action = value ? "addClass" : "removeClass";
            this.sfCalendar[action]("e-dp-restrict-show");
        },
        _setValues: function () {
            this.Date = new Date();
            this._id = this.element[0].id;
            this.isValidState = true;
            this._setCulture(this.model.locale);
            this._setMinDate(this.model.minDate);
            this._setMaxDate(this.model.maxDate);
            this._calendarDate = this._zeroTime(new Date());
            if (this.model.startDay < 0 || this.model.startDay > 6) this.model.startDay = 0;
            this.Date.firstDayOfWeek = this.model.startDay;
            this.Date.fullYearStart = '20';
            this._showHeader = true;
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "")
                this.model.value = this.element[0].value;
            this._validateMinMaxDate();
            this._dateValue = new Date(this._calendarDate.toString());
            this._isIE7 = this._checkIE7();
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            // this variable is set to true in DateTimePicker control
            this._getInternalEvents = false;
            this._flag = true;
            this._ejHLWeekEnd = false;
            this._isOpen = false;
            this._prevDate = null;
            this._preValue = null;
            this._isFocused = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled") proxy.disable();
                else if (keyName == "readOnly") proxy.model.readOnly = true;
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);

            });
        },
        _createDatePicker: function () {
            this._createWrapper();
            this._wireEvents();
            if (this.model.displayInline) {
                this.show();
            }
            if (this.model.enableRTL) this._setRTL(true);
            if (this.model.showRoundedCorner) this._setRoundedCorner(true);
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name") && this._isInputBox)
                this.element.attr("name", this.element[0].id);
            if (this.model.displayInline && !this._isInputBox)
                this._hiddenInput.attr("name", this.element[0].id);
        },
        _createWrapper: function () {
            this._getMapper();
            if (this.model.specialDates)
                this._createSpecialDateObject();
			this.element.attr("tabindex","0");
            if (this._isInputBox) {
			    this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive','aria-activedescendant': 'null', 'aria-expanded':'false','role':'combobox' });
                this.wrapper = ej.buildTag("span.e-datewidget e-widget " + this.model.cssClass);
                this.wrapper.attr("style", this.element.attr("style"));
                this.element.removeAttr('style');
                if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
                this.innerWrapper = ej.buildTag("span.e-in-wrap e-box e-padding");
                this.wrapper.append(this.innerWrapper).insertBefore(this.element);
                this.innerWrapper.append(this.element);
                this.dateIcon = ej.buildTag("span.e-select#" + this._id + "-img", "", {}, (this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-icon e-calendar", "", {}, { 'aria-label': 'Select' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})).insertAfter(this.element);
            }
            if (!this._isSupport || (this.model.displayInline && !this._isInputBox)) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                if (this._isInputBox) this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
            this._checkNameAttr();
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            if (this._id)
                $("#e-" + this._id).remove();
            this._setDateValue(this.model.value);
            this._preValue = this._parseDate(this.element.val(), this.model.dateFormat);
            this._setWaterMark();
            this._dateValue = new Date(this._calendarDate.toString());
            if (this.model.displayInline) this._renderPopup();
            else if (this._isInputBox) this._renderDateIcon(this.model.showPopupButton, false);
            if (this.model.readOnly) this._disbleMaualInput();
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && $(this.element).hasClass("e-disable")) this.enable();
            this._layoutChanged();
            this._checkErrorClass();
            this._addAttr(this.model.htmlAttributes);
        },
        _isInputBox: function () {
			if(this.element.is("input[type=date]")) this.element.attr('type',"text");
            return (this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type')));
        },

        _renderDateIcon: function (bool, reRender) {
            if (reRender && this.model.showPopupButton == bool) return;
            if (!bool && this.dateIcon) {
                this._bindInputEvent();
                this.dateIcon.css('display', 'none');
                this.innerWrapper.removeClass('e-padding');
            }
            else {
                if (this.innerWrapper) {
                    this.innerWrapper.addClass('e-padding');
                    this.dateIcon.css('display', 'block');
                }
                if (!this.model.displayInline)
                    this._bindDateButton();
            }
            this.model.showPopupButton = bool;
        },

        _resizeCalender: function () {
            if ((this.model.dayHeaderFormat == "short") || (this.model.dayHeaderFormat == "min") || (this.model.dayHeaderFormat == "none"))
                this.sfCalendar.removeClass("e-headerlong");
            else if (this.model.dayHeaderFormat == "long") {
                this.sfCalendar.addClass("e-headerlong");
            }
        },

        _setWidth: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.width(value);
                else this.element.width(value);
            }
            else
                this.model.width = this.wrapper ? this.wrapper.outerWidth() : this.element.width();
        },
        _setHeight: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.height(value);
                else this.element.height(value);
            }
            else
                this.model.height = this.wrapper ? this.wrapper.outerHeight() : this.element.height();
            if (this._isIE7) this.element.height(this.innerWrapper.height());
        },
        _setRTL: function (isRTL) {
            if (isRTL) {
                if (this.wrapper) {
                    this.wrapper.addClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.addClass("e-rtl");
            }
            else {
                if (this.wrapper) {
                    this.wrapper.removeClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.removeClass("e-rtl");
            }
        },
        _setRoundedCorner: function (bool) {
            if (bool) {
                if (this.innerWrapper)
                    this.innerWrapper.addClass("e-corner");
                this.sfCalendar && this.sfCalendar.addClass("e-corner");
            }
            else {
                if (this.innerWrapper)
                    this.innerWrapper.removeClass("e-corner");
                this.sfCalendar && this.sfCalendar.removeClass("e-corner");
            }
        },

        _refreshDatepicker: function () {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var _currentVal = this.element.val();
            //  For checking the year maximum range....
            if (this._specificFormat() && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != _currentVal)
                var currentValue = this._parseDate(_currentVal, true);
            else var currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            this._setDateValue(currentValue);
            if (this._specificFormat() && this._compareDate(this.model.value, this._calendarDate))
                this.element.val(_currentVal)
            $(".e-datepicker-headertext", this.sfCalendar).text(this._formatter(this._calendarDate, this.model.headerFormat));
            this._resizeCalender();
            this._dateValue = new Date(this._calendarDate.toString());
            this._hoverDate = this._calendarDate.getDate() - 1;
            this._renderCalendar(this, this._dateValue);
            this._setFooterText(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
            this._layoutChanged();
        },
        _validateYearValue: function (value) {
            if (value != null) {
                var twoDigitYearMax = ej.preferredCulture(this.model.locale).calendars.standard.twoDigitYearMax;
                twoDigitYearMax = typeof twoDigitYearMax === "string" ? new Date().getFullYear() % 100 + parseInt(twoDigitYearMax, 10) : twoDigitYearMax;
                if (this._calendarDate.getFullYear() - value.getFullYear() == 100) {
                    if (this._calendarDate.getFullYear() > twoDigitYearMax)
                        value.setFullYear(this._calendarDate.getFullYear())
                }
            }
            return value;
        },
        _setFooterText: function (footerText) {
            $('.e-footer-text', this.sfCalendar).html(footerText);
        },
        _setSkin: function (skin) {
            if (this.wrapper) {
                this.wrapper.removeClass(this.model.cssClass);
                this.wrapper.addClass(skin);
            }
            else {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
            this.sfCalendar.removeClass(this.model.cssClass);
            this.sfCalendar.addClass(skin);
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this._isInputBox) {
                this.sfCalendar.insertAfter(this.wrapper);
                this._setDatePickerPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.sfCalendar);
                if (!this._isSupport || !this._isInputBox) this._hiddenInput.css("display", "none");
            }
            else {
                this.sfCalendar.css('display', 'none');
                $('body').append(this.sfCalendar);
                this._isOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                this._off(this.dateIcon, "mousedown", this._showDatePopUp);
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
            }

        },

        _disbleMaualInput: function () {
            if (this.model.readOnly) {
                $(this.element).attr("readonly", "readonly");
                if (!this.model.displayInline) this.hide();
            }
            else if (this.model.allowEdit)
                $(this.element).prop("readonly", false);

        },
        _checkDateObject: function (date, val) {
            if (!date || (typeof JSON === "object" && JSON.stringify(date) === "{}")) return date = null;
            else if (!(date instanceof Date)) {
                if (this._specificFormat())
                    var val = this._parseDate(date, true);
                else
                    var val = this._parseDate(date, val);
                date = val ? val : (val = this._checkJSONString(date)) ? val : null;
            }
            if (!isNaN(Date.parse(date))) {
                this._dateValue = this._calendarDate = this._zeroTime(date)
                if (this._validateDate(date))
                    return this._dateValue;
            }
            return null;
        },
        _checkJSONString: function (date) {
            // Validate the string value
            if (!isNaN(Date.parse(date))) {
                if ((new Date(date).toJSON() === date) || (new Date(date).toDateString() === date) || (new Date(date).toGMTString() === date) ||
                    (new Date(date).toISOString() === date) || (new Date(date).toLocaleString() === date) ||
                    (new Date(date).toString() === date) || (new Date(date).toUTCString() === date)) {
                    return new Date(new Date(date).getTime() + (ej.serverTimezoneOffset * 60 * 60 * 1000));
                }
                else if (typeof date == "string") return this._dateFromISO(date);
            } else if (this._extISORegex.exec(date) || this._basicISORegex.exec(date)) return this._dateFromISO(date);
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _checkInstanceType: function (date) {
            date = this._stringToObject(date);
            if (!date) return null;
            else if (!(date instanceof Date)) {
                date = this._parseDate(date);
            }
            if (!isNaN(Date.parse(date))) return this._zeroTime(date);
            return null;
        },
        _stringToObject: function (value) {
            if (typeof value === "string") {
                var val = ej.parseDate(value, this.model.dateFormat, this.model.locale);
                value = (val != null) ? val : new Date(value);
            }
            return value;
        },
        _validateMinMaxDate: function () {
            var dateChange = false, valueExceed = false;
            if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
            if (!this.model.enableStrictMode) {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.value = this.model.minDate;
                        dateChange = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.value = this.model.maxDate;
                        dateChange = true;
                    }
                }
                else {
                    this.element.val("");
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
                this.isValidState = true;
            }
            else {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.minDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.maxDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else this.isValidState = true;
                }
                else {
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
            if (dateChange) this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
        },
        _setCulture: function (culture) {
            this.culture = ej.preferredCulture(culture);
            if (this.culture) {
                this.model.locale = this.culture.name == "en" ? "en-US" : this.culture.name;
                this.Date.dayNames = this.culture.calendar.days.names;
                this.Date.dayNamesMin = this.culture.calendar.days.namesShort;
                this.Date.abbrDayNames = this.culture.calendar.days.namesAbbr;
                this.Date.monthNames = this.culture.calendar.months.names;
                this.Date.abbrMonthNames = this.culture.calendar.months.namesAbbr;
                this.Date.format = this.culture.calendar.patterns.d;
                if (this.model.dateFormat == '') this.model.dateFormat = this.culture.calendar.patterns.d;
                if (this.model.startDay == -1) this.model.startDay = this.culture.calendar.firstDay;
            }
            this._separator = this._getSeparator();
            this._localizedLabels = this._getLocalizedLabels();

            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    this._localizedLabels.buttonText = this._options.buttonText;
            }
            this._localizedLabelToModel();
        },

        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },

        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "") {
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                }
                else {
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                }
                return true;
            }
        },

        _setDatePickerPosition: function () {
            if (!this.model.displayInline || this._isInputBox) {
                var elementObj = this.element.is('input') ? this.wrapper : this.element;
                var pos = this._getOffset(elementObj), winLeftWidth, winRightWidth,
                winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
                winTopHeight = pos.top - $(document).scrollTop(),
                popupHeight = this.sfCalendar.outerHeight(),
                popupWidth = this.sfCalendar.outerWidth(),
                left = pos.left,
                totalHeight = elementObj.outerHeight(),
                border = (totalHeight - elementObj.height()) / 2,
                maxZ = this._getZindexPartial(), popupmargin = 3,
                topPos = (popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin; // popupmargin denotes space b/w the element and the popup.
                winLeftWidth = $(document).scrollLeft() + $(window).width() - left;
                winRightWidth = $(document).scrollLeft() + left + elementObj.width();
                if (this.model.enableRTL || popupWidth > winLeftWidth && (popupWidth < left + elementObj.outerWidth()) && !ej.isNullOrUndefined(this.wrapper))
                    left += this.wrapper.width() - this.sfCalendar.width();
                if (popupWidth > winRightWidth) left = pos.left;
                this.sfCalendar.css({
                    "left": left + "px",
                    "top": topPos + "px",
                    "z-index": maxZ
                });
            }
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.sfCalendar);
        },

        _setMinDate: function (d) {
            this.model.minDate = this._checkInstanceType(d);
            if (!this.model.minDate) {
                this.model.minDate = (new Date('11/31/1899'));
            }
        },

        _setMaxDate: function (d) {
            this.model.maxDate = this._checkInstanceType(d);
            if (!this.model.maxDate) {
                this.model.maxDate = (new Date('12/31/2099')); // using the JS Date.parse function which expects mm/dd/yyyy
            }
        },
        _setDateValue: function (date, val) {
            var newDate = this._checkDateObject(date, val);
            if (newDate != null) {
                this.isValidState = true;
                this.model.value = new Date(newDate.toString());
                if (!this.model.displayInline)
                    this.wrapper.addClass('e-valid');
                this._validateMinMaxDate();
                this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            }
            else {
                if (date instanceof Date) {
                    this._validateMinMaxDate();
                    date = this._formatter(date, this.model.dateFormat);
                }
                (this.model.enableStrictMode) ? this.element.val(date) : this.element.val(null);
                this.model.value = null; //updating model value as null to avoid the recursive call to this method
                if (!this.model.displayInline)
                    this.wrapper.removeClass('e-valid');
                this._triggerChangeEvent();
                this.isValidState = (this.element.val() == "" || ej.isNullOrUndefined(this.element.val())) ? true : false;
            }
            this._removeWatermark();
        },
        _updateInputVal: function () {
            var val = this._validateValue();
            if ((val != null || !this.model.enableStrictMode) && this.sfCalendar && this.sfCalendar.find('.e-datepicker-days').is(':visible'))
                this._refreshDatepicker();
        },
        _validateInputVal: function () {
            var val = this._validateValue();
            if (val != null) {
                if (!this.model.enableStrictMode) {
                    if (val <= this.model.maxDate && val >= this.model.minDate)
                        this.isValidState = true;
                    else {
                        this.model.value = null;
                        this.isValidState = true;
                    }
                }
            }
        },

        _validateValue: function () {
            if (this._specificFormat() && this.element.val() != this._formatter(this._preValue, this.model.dateFormat, this.model.locale))
                var value = this._parseDate(this.element.val(), true);
            else var value = this._parseDate(this.element.val());
            return this._validateYearValue(value);
        },
        _getSeparator: function () {
            var formats;
            if (this.culture) {
                formats = this.culture.calendar.patterns.d;
            }
            else formats = this.model.dateFormat;
            var regex = new RegExp("^[a-zA-Z0-9]+$");
            for (var i = 0; i < formats.length; i++) {
                if (!regex.test(formats[i])) return formats[i];
            }
        },
        _checkIE7: function () {
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})"), version = -1;
                if (re.exec(navigator.userAgent) != null)
                    version = parseFloat(RegExp.$1);
                if (version >= 7 && version < 8) return true;
            }
            return false;
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },

        //Date formatter - Convert date object to specific date format
        _formatter: function (date, format) {
            var newFormat = this._checkFormat(format);
            return ej.format(date, newFormat, this.model.locale);
        },
        _parseDate: function (date, type) {
            var newFormat = this._checkFormat(this.model.dateFormat);
            var DateValue = date;
            if ((this._specificFormat()) && DateValue != undefined && date != "" && type != true && !(ej.format(ej.parseDate(DateValue, newFormat, this.model.locale), this.model.dateFormat, this.model.locale) == DateValue)) {
                return this._dateValue;
            }
            else return ej.parseDate(date, newFormat, this.model.locale);
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },

        isLeapYear: function (year) {
            return (year % 4 == 0 && year % 100 != 0) || year % 400 == 0;
        },
        //Sets the time component of this Date to zero for cleaner, easier comparison of dates where time is not relevant.
        _zeroTime: function (date) {
            var newDate = typeof date === "string" ? this._parseDate(date) : new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },

        _getDaysInMonth: function (date) {
            return [31, (this.isLeapYear(date) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][date.getMonth()];
        },

        _addDays: function (d, number) {
            d.setDate(d.getDate() + number);
            return d;
        },

        _addYears: function (d, number) {
            d.setFullYear(d.getFullYear() + number);
            return d;
        },

        _addMonths: function (d, number) {
            var tempDatedateMonth = d.getDate();
            d.setMonth(d.getMonth() + number);
            if (tempDatedateMonth > d.getDate())
                this._addDays(d, -d.getDate());
            return d;
        },
        //Checks if the day is a weekend day (Sat or Sun).
        _isWeekend: function (date) {
            return date.getDay() == 0 || date.getDay() == 6;
        },

        _isSpecialDates: function (dates) {
            if (this.model.specialDates) {
                for (var i = 0; i < this.model.specialDates.length; i++) {
                    if (this.model.specialDates[i] && this.model.specialDates[i][this._mapField._date]) {
                        if (dates.getDate() == this.model.specialDates[i][this._mapField._date].getDate() && dates.getMonth() == this.model.specialDates[i][this._mapField._date].getMonth() && dates.getFullYear() == this.model.specialDates[i][this._mapField._date].getFullYear()) {
                            this._getIndex = i;
                            return true;
                        }
                    }
                }
            }
            return false;
        },
        _getMapper: function () {
            var mapper = this.model.fields;
            this._mapField = {};
            this._mapField["_date"] = (mapper && mapper.date) ? mapper["date"] : "date";
            this._mapField["_tooltip"] = (mapper && mapper.tooltip) ? mapper["tooltip"] : "tooltip";
            this._mapField["_icon"] = (mapper && mapper.iconClass) ? mapper["iconClass"] : "iconClass";
            this._mapField["_custom"] = (mapper && mapper.cssClass) ? mapper["cssClass"] : "cssClass";
        },
        _createSpecialDateObject: function () {
            for (var i = 0; i < this.model.specialDates.length; i++) {
                this.model.specialDates[i][this._mapField._date] = this._checkInstanceType(this.model.specialDates[i][this._mapField._date]);
            }
        },

        _getMonthName: function (abbreviated, date) {
            return abbreviated ? this.Date.abbrMonthNames[date.getMonth()] : this.Date.monthNames[date.getMonth()];
        },



        _displayNewMonth: function (m, y) {
            this._setDisplayedMonth(this.displayedMonth + m, this.displayedYear + y, true);
            return false;
        },

        _setDisplayedMonth: function (m, y, rerender) {
            if (this.model.minDate == undefined || this.model.maxDate == undefined) {
                return;
            }
            var s = new Date(this.model.minDate.getTime());
            s.setDate(1);
            var e = new Date(this.model.maxDate.getTime());
            e.setDate(1);

            var t;
            if ((!m && !y) || (isNaN(m) && isNaN(y))) {

                t = this._zeroTime(new Date());
                t.setDate(1);
            } else if (isNaN(m)) {

                t = new Date(y, this.displayedMonth, 1);
            } else if (isNaN(y)) {

                t = new Date(this.displayedYear, m, 1);
            } else {

                t = new Date(y, m, 1);
            }

            if (t.getTime() < s.getTime()) {
                t = s;
            } else if (t.getTime() > e.getTime()) {
                t = e;
            }
            var oldMonth = this.displayedMonth;
            var oldYear = this.displayedYear;
            this.displayedMonth = t.getMonth();
            this.displayedYear = t.getFullYear();
            var tempDate = t;
            if (rerender && (this.displayedMonth != oldMonth || this.displayedYear != oldYear)) {
                this._renderCalendar(this, tempDate);
                this._dateValue = tempDate;
                this._trigger("monthChanged", [this.displayedMonth, this.displayedYear]);
            }
        },
        _clearSelected: function () {
            this.numSelected = 0;
            if (!ej.isNullOrUndefined(this.sfCalendar)) {
            if (this.model.highlightSection == "week") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-selected-week');
            }
            else if (this.model.highlightSection == "month") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().parent().removeClass('e-selected-month');
            }
            else if (this.model.highlightSection == "workdays") {
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-work-week');
            }
            else
                $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false);
            }

        },
        _addSelected: function () {
            if (this.model.highlightSection == "week") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-selected-week');
            }
            else if (this.model.highlightSection == "month") {
                $('td.e-active, this.sfCalendar').parent().parent().addClass('e-selected-month');
            }
            else if (this.model.highlightSection == "workdays") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-work-week');
            }
        },

        _hideOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css("visibility", "hidden");
        },
        _showOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css({ 'visibility': 'visible' });
        },
        _otherMonthsVisibility: function () {
            if (this.model.showOtherMonths)
                this._showOtherMonths(this.sfCalendar);
            else
                this._hideOtherMonths(this.sfCalendar);
        },

        _createCalender: function () {
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-datepicker-headertext").text(this._formatter(this._calendarDate, this.model.headerFormat)).attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .appendTo(this.sfCalendar);
            this._enableHeader(this._showHeader);
            var table = ej.buildTag("table.e-dp-viewdays", "", {}).data("e-table", "data").attr({ 'role': 'grid'}).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.sfCalendar.append(table);
            this._renderCalendar(this);
            this._startLevel(this.model.startLevel);
            ej.buildTag("div.e-footer")
                .append(ej.buildTag("span.e-footer-icon"))
                .append(ej.buildTag("span.e-footer-text"))
                .appendTo(this.sfCalendar);
            $('.e-footer-text', this.sfCalendar).html(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
        },
        _enableHeader: function (show) {
            if (show) $(".e-header", this.sfCalendar).show();
            else $(".e-header", this.sfCalendar).hide();
        },
        _enableFooter: function (show) {
            if (show) $('.e-footer', this.sfCalendar).show();
            else $('.e-footer', this.sfCalendar).hide();
            this._todayBtnDisable();
        },
        _todayBtnDisable: function () {
            var today = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 0, 0, 0);
            if (!(+this.model.minDate <= +today && +this.model.maxDate >= +today)) {
                $('.e-footer', this.sfCalendar).addClass('e-footer-disable')
            } else {
                $('.e-footer', this.sfCalendar).removeClass('e-footer-disable')
            }
        },
        _checkArrows: function (min, max) {
            this._preArrowCondition(min, this.model.minDate.getFullYear());
            this._nextArrowCondition(max, this.model.maxDate.getFullYear());
        },
        _checkDateArrows: function () {
            this._preArrowCondition(this._tempMinDate, this.model.minDate);
            this._nextArrowCondition(this._tempMaxDate, this.model.maxDate);
        },
        _preArrowCondition: function (val1, val2) {
            if (val1 <= val2) this.sfCalendar.find(".e-prev").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-prev").removeClass("e-disable").attr({ "aria-disabled": false });
        },
        _nextArrowCondition: function (val1, val2) {
            if (val1 >= val2) this.sfCalendar.find(".e-next").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-next").removeClass("e-disable").attr({ "aria-disabled": false });
        },

        _previousNextHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled || $(event.target).hasClass("e-disable")) return false;
            event.preventDefault();
            var prevTable = $("table", this.sfCalendar), navFrom;
            navFrom = this._navigateFrom(prevTable);
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrevDate(progress);
            var currentTable = $("table", this.sfCalendar), tClassName, navTo;
            tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewdays": navTo = "month"; break;
                case "e-dp-viewmonths": navTo = "year"; break;
                case "e-dp-viewyears": navTo = "decade"; break;
                case "e-dp-viewallyears": navTo = "century"; break;
            }
            this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
        },
        _processNextPrevDate: function (progress) {
            if (this._DRPdisableFade) {
                var s = new Date(this.sfCalendar.find("td.current-month").attr("data-date"));
                this._dateValue = s;
            }
            if (progress && this.sfCalendar.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && this.sfCalendar.find(".e-arrow-sans-right").hasClass("e-disable")) return false;

            var currentTable = $("table", this.sfCalendar), temp;
            var tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case 'e-dp-viewdays':
                    var step = this.model.stepMonths;
                    if (progress) {
                        if (this._dateValue <= this.model.minDate) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (this._dateValue >= this.model.maxDate) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addMonths(this._dateValue, (progress ? -step : step));
                    if (this._clickedDate)
                        this._calendarDate = this._clickedDate;
                    this._dateValue = this._dateValue < this.model.minDate ? new Date(this.model.minDate.toString()) : this._dateValue;
                    this._dateValue = this._dateValue > this.model.maxDate ? new Date(this.model.maxDate.toString()) : this._dateValue;
                    this._renderCalendar(this, this._dateValue);
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    this._addFocus('day', this._hoverDate);
                    var dateRange = this._findFirstLastDay(new Date(this._dateValue.toString()));
                    this._preArrowCondition(dateRange.firstDay, this.model.minDate);
                    this._nextArrowCondition(dateRange.lastDay, this.model.maxDate);
                    break;
                case 'e-dp-viewmonths':
                    var dateValue = this._dateValue;
                    dateValue.setFullYear($('.e-datepicker-headertext', this.sfCalendar).text())
                    if (progress) {
                        if (dateValue.getFullYear() <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (dateValue.getFullYear() >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addYears(dateValue, (progress ? -1 : 1));
                    this._renderCalendar(this, dateValue);
                    temp = dateValue.getFullYear();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-months').hide();
                    $($(currentTable).find('.e-datepicker-months')).show();
                    this._addFocus('month', this._hoverMonth);
                    this._checkArrows(temp, temp);
                    break;
                case 'e-dp-viewyears':
                    var yearValue;
                    yearValue = this._dateValue
                    yearValue.setFullYear($(currentTable).find(".e-state-hover").text());
                    if (progress) {
                        if (parseInt($('td.e-year-first:first').text()) <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (parseInt($('td.e-year-last:first').prev().text()) >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && progress) || ($(currentTable).find(".e-state-hover").hasClass('e-year-last') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear());
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() + 11);
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-last') && progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() - 11);
                    else
                        this._dateValue.setFullYear(yearValue.getFullYear() + (progress ? -10 : 10));
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    $(".e-datepicker-headertext", this.sfCalendar).text((setYear + 1) + ' - ' + (setYear + 10));
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-years').hide();
                    $($(currentTable).find('.e-datepicker-years')).show();
                    this._addFocus('year', this._hoverYear + (!($('.e-year-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, setYear + 10);
                    break;
                case 'e-dp-viewallyears':
                    var headYears;
                    if (progress) {
                        headYears = parseFloat($('td.e-allyear-first', currentTable.get(0)).text().split('-')[1]);
                        if (headYears <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else {
                            this._flag = true;
                        }

                    } else {
                        headYears = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                        if (headYears >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else
                            this._flag = true;
                    }
                    this._dateValue.setFullYear((!(this._lastHoveredYear) ? this._dateValue.getFullYear() : this._lastHoveredYear) + (progress ? -100 : 100));
                    this._lastHoveredYear = this._dateValue.getFullYear();
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 100) + 1);
                    temp = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                    $('.e-datepicker-headertext', this.sfCalendar).text((setYear + 1) + ' - ' + temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-allyears').hide();
                    $($(currentTable).find('.e-datepicker-allyears')).show();
                    this._addFocus('allyear', this._hoverAllYear + (!($('.e-allyear-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, temp);
                    break;
            }
            this._layoutChanged();
        },
        _addFocus: function (selection, index) {
            var cls = 'e-current-' + selection;
            if (selection == 'day') cls = 'current-month';
            var items = this.sfCalendar.find('tbody tr td.' + cls);
            if (selection == "month") {
                $(items).each(function (i, ele) {
                    if (parseInt($(ele).attr("data-index")) == parseInt(index)) {
                        index = i;
                        return;
                    }
                });
            }
            var cell = items[index];
            if (!cell) cell = items.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(selection);
            return index;
        },
        _setActiveState: function (selection) {
            if (!(this.model.value instanceof Date)) return;
            var items = this.sfCalendar.find('tbody tr td.e-current-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "month":
                    if (this.model.value.getFullYear() === parseInt($('.e-text', this.sfCalendar).text())) {
                        $(items).each(function (i, ele) {
                            if (parseInt($(ele).attr("data-index")) == parseInt(proxy.model.value.getMonth())) {
                                indx = i;
                                return;
                            }
                        });
                    }
                    break;
                case "year":
                    var value = this.model.value.getFullYear();
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(value)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
                case "allyear":
                    var start = parseInt(this.model.value.getFullYear()) - ((parseInt(this.model.value.getFullYear()) % 10) + 1);
                    var active = (start + 1) + ' - ' + (start + 10);
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(active)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
            }
            cell = items[indx];
            if (cell) {
                this.sfCalendar.find('table td').removeClass("e-active");
                if (!$(cell).hasClass('e-hidedate'))
                    $(cell).addClass("e-active");
            }
        },
        _setFocusByName: function (name, value) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(name);
            return index;
        },
        _getHeaderTxt: function () {
            return this.sfCalendar.find(".e-datepicker-headertext").text();
        },
        _findFirstLastDay: function (value) {
            var y = value.getFullYear(), m = value.getMonth();
            var firstDay = new Date(y, m, 1);
            var lastDay = new Date(y, m + 1, 0);
            return { firstDay: firstDay, lastDay: lastDay }
        },
        _forwardNavHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (event) event.preventDefault();

            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, headerTxt, navTo;
            var navFrom = this._navigateFrom(currentTable);
            switch (tclassName) {
                case 'e-dp-viewdays':
                    this._hoverMonth = this._getDateObj(currentTable.find(".e-state-hover")).getMonth() ||
                                this._getDateObj(currentTable.find(".e-active")).getMonth() || 0;
                    if (this._DRPdisableFade) {
                        this._renderCalendar(this, this._calendarDate);
                        $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    }
                    this._startLevel("year"); navTo = "year";
                    this._addFocus('month', this._hoverMonth);
                    break;
                case 'e-dp-viewmonths':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("decade"); navTo = "decade";
                    this._hoverYear = this._setFocusByName('year', headerTxt);
                    break;
                case 'e-dp-viewyears':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("century"); navTo = "century";
                    this._hoverAllYear = this._setFocusByName('allyear', headerTxt);
                    break;
            }
            if (navFrom != "century") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },
        _cellSelection: function () {
            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className;
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    this._hoverMonth = this._addFocus('month', this._dateValue.getMonth());
                    break;
                case 'e-dp-viewyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('year');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    this._hoverYear = this._setFocusByName('year', this._dateValue.getFullYear());
                    break;
                case 'e-dp-viewallyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('allyear');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', setYear + 1 + ' - ' + setYear + 10);
                    break;
            }
            this._layoutChanged();
        },
        _navigationToPrevNext: function (name) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            var value = this._dateValue.getFullYear();
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (cell) {
                if ($(cell).hasClass('e-' + name + '-last'))
                    this._processNextPrevDate(false)
                else if ($(cell).hasClass('e-' + name + '-first'))
                    this._processNextPrevDate(true);
            }
        },
        _navigateFrom: function (prevTable) {
            var tPrevClassName = prevTable.get(0).className, navFrom;
            switch (tPrevClassName) {
                case "e-dp-viewdays": navFrom = "month"; break;
                case "e-dp-viewmonths": navFrom = "year"; break;
                case "e-dp-viewyears": navFrom = "decade"; break;
                case "e-dp-viewallyears": navFrom = "century"; break;
            }
            return navFrom;
        },
        _backwardNavHandler: function (event) {
            this._animating = true;
            if (this.model.readOnly || !this.model.enabled) return false;
            var element;
            if (event.type) {
                event.preventDefault();
                element = $(event.currentTarget);
            }
            else element = event;
            var cTable = $("table", this.sfCalendar), temp;
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, navTo;
            var navFrom = this._navigateFrom(cTable);
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    cTable.removeClass("e-dp-viewmonths").addClass("e-dp-viewdays");
                    this._lastHoveredMonth = parseInt($(element).attr('data-index'));
                    this._dateValue = new Date(this._dateValue.getFullYear(), this._lastHoveredMonth, 1);
                    if (this._DRPdisableFade) this._trigger("_month_Loaded", { currentTarget: event.currentTarget });
                    this._renderCalendar(this, this._dateValue);
                    $('tbody', cTable).not('.e-datepicker-days,.e-week-header').hide();
                    $($(cTable).find('.e-datepicker-days,.e-week-header')).fadeIn("fast", function () {
                        proxy._addFocus('day', proxy._hoverDate || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat)); navTo = "month";
                    break;
                case 'e-dp-viewyears':
                    cTable.removeClass("e-dp-viewyears").addClass("e-dp-viewmonths");
                    this._lastHoveredYear = parseInt(element.text());
                    this._dateValue.setFullYear(this._lastHoveredYear);
                    this._renderCalendar(this, this._dateValue);
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-months').hide();
                    if (ej.isNullOrUndefined(this._hoverMonth) && !ej.isNullOrUndefined(this._dateValue)) this._hoverMonth = this._dateValue.getMonth();
                    $($(cTable).find('.e-datepicker-months')).fadeIn("fast", function () {
                        proxy._addFocus('month', proxy._hoverMonth || 0);
                        proxy._animating = false;
                    });
                    temp = element.text();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    this._checkArrows(temp, temp); navTo = "year";
                    break;
                case 'e-dp-viewallyears':
                    var headYears = element.text().split('-');
                    cTable.removeClass("e-dp-viewallyears").addClass("e-dp-viewyears");
                    if (headYears[0] < this.model.minDate.getFullYear()) headYears[0] = this.model.minDate.getFullYear().toString();
                    else if (headYears[0] > this.model.maxDate.getFullYear()) headYears[0] = this.model.maxDate.getFullYear().toString();
                    this._renderCalendar(this, (new Date(headYears[0], 0, 1)));
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).fadeIn("fast", function () {
                        proxy._addFocus('year', proxy._hoverYear || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(headYears[0] + ' - ' + headYears[1]);
                    this._checkArrows(headYears[0], headYears[1]); navTo = "decade";
                    this._dateValue = new Date(this._dateValue.setFullYear(parseInt($.trim(headYears[0])) + ((!this._lastHoveredYear) ? this._dateValue.getFullYear() % 10 : this._lastHoveredYear % 10)));
                    break;
                default:
                    this._clearSelected();
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    element.not('td.other-month.e-hidedate').addClass('e-active').attr('aria-selected', true);
                    this._addSelected();

                    this._hoverDate = this._getDateObj(element).getDate() - 1;
                    this._dateValue = new Date(element.attr('data-date'));
                    this._clickedDate = new Date(element.attr('data-date'));
                    this._animating = false;
                    break;
            }
            if (navFrom != "month") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },

        _startLevel: function (start) {
            var cTable = $("table", this.sfCalendar);
            var headerText = $(".e-datepicker-headertext", this.sfCalendar), s, e;
            var dateValue = this._dateValue;
            switch (start) {
                case "decade":
                    cTable.removeClass("e-dp-viewallyears e-dp-viewmonths e-dp-viewdays").addClass("e-dp-viewyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) dateValue = this._calendarDate;
                    else dateValue = dateValue;
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    s = setYear + 1;
                    e = setYear + 10;
                    headerText.text(s + ' - ' + e);
                    this._checkArrows(s, e);
                    this._hoverYear = this._setFocusByName('year', dateValue.getFullYear());
                    break;
                case "century":
                    if (!(this._calendarDate < this._dateValue)) this._renderCalendar(this, dateValue);
                    cTable.removeClass("e-dp-viewyears e-dp-viewdays e-dp-viewmonths").addClass("e-dp-viewallyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-allyears').hide();
                    $($(cTable).find('.e-datepicker-allyears')).show();
                    s = parseFloat($('td.e-allyear-first', cTable.get(0)).text().split('-')[1]) + 1;
                    e = parseFloat($('td.e-allyear-last', cTable.get(0)).prev().text().split('-')[1]);
                    var headYears = s + ' - ' + e;
                    headerText.text(headYears);
                    this._checkArrows(s, e);
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', (setYear + 1) + ' - ' + (setYear + 10));
                    break;
                case "year":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewdays").addClass("e-dp-viewmonths");
                    $('tbody,tr.e-week-header', cTable).hide();
                    $($(cTable).find('.e-datepicker-months')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) s = this._calendarDate.getFullYear();
                    else s = dateValue.getFullYear();
                    headerText.text(s);
                    this._checkArrows(s, s);
                    this._hoverMonth = dateValue.getMonth();
                    this._addFocus('month', this._hoverMonth);
                    break;
                case "month":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewmonths").addClass("e-dp-viewdays ");
                    break;
            }
        },
        _depthLevel: function (depth) {
            var calendarTable = this.sfCalendar;
            switch (depth) {
                case "year":
                    $(calendarTable.find('.e-current-year,.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    this._on($('.e-current-month', this.sfCalendar), "click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "decade":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    $('.e-current-year', this.sfCalendar).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "century":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "month":
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }
        },
        _onDepthSelectHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if ($(e.target).hasClass("e-current-month"))
                this._dateValue = new Date(this._dateValue.setMonth(parseInt(e.target.attributes["data-index"].value)));
            else if ($(e.target).hasClass("e-current-year"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            else if ($(e.target).hasClass("e-current-allyear"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            this._onSetCancelDateHandler(e);
        },

        _datepickerMonths: function (tbody, calendarTable, currentDate) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var month = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'))
                        .addClass('e-current-month e-state-default')
                        .attr({ 'data-index': month }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .html(this.Date.abbrMonthNames[month++]);
                    if (currentDate.getFullYear() < this.model.minDate.getFullYear() || currentDate.getFullYear() > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    else if ((currentDate.getFullYear() <= this.model.minDate.getFullYear() && month < this.model.minDate.getMonth() + 1) ||
                        (currentDate.getFullYear() >= this.model.maxDate.getFullYear() && month > this.model.maxDate.getMonth() + 1)) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            var s = currentDate.getFullYear();
            this._checkArrows(s, s);
        },

        _datepickerYears: function (tbody, calendarTable, currentYear) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 10) + 1);
            var years = [];
            for (var j = 0; j < 12; j++) {
                years.push(Year + j);
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-year-first e-current-year ');
                    else if (year == 11)
                        td.addClass('e-year-last e-current-year ');
                    else
                        td.addClass('e-current-year e-state-default');
                    if (years[year] < this.model.minDate.getFullYear() || years[year] > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-year');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            this._checkArrows(years[0], years[years.length]);
        },

        _datepickerAllYears: function (tbody, calendarTable, currentYear) {
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 100) + 10);
            var headYear = Year;
            var years = [], newline = this._isIE8 || this._isIE9 ? "" : "\n";

            for (var j = 0; j < 12; j++) {
                years.push(parseInt(Year) + " -" + newline + parseInt(Year + 9));
                Year = Year + 10;
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(document.createElement('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(document.createElement('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-allyear-first e-current-allyear ');
                    else if (year == 11)
                        td.addClass('e-allyear-last e-current-allyear ');
                    else
                        td.addClass('e-current-allyear e-state-default');
                    if (parseInt(years[year].split('-\n')[1]) < this.model.minDate.getFullYear() || parseInt(years[year].split('-\n')[0]) > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-allyear');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
        },
        _renderHeader: function (dpObject) {
            var thead = $(document.createElement('thead'));
            var cultureObj = ej.preferredCulture(this.model.locale).calendars.standard.days;
            if (dpObject.model.dayHeaderFormat != "none") {
                var headRow = ej.buildTag("tr.e-week-header").attr({ 'role': 'row' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                if (this.model.weekNumber == true) {
                    var WeekCulture = ej.preferredCulture(this.model.locale).calendars.standard.week;
                    var day = WeekCulture.name;
                    var headerday;
                    if (dpObject.model.dayHeaderFormat == "short")
                        headerday = WeekCulture.nameAbbr;
                    else if (dpObject.model.dayHeaderFormat == "long") headerday = week;
                    else headerday = WeekCulture.nameShort;
                    var tr = ej.buildTag("th", "", {}, { 'scope': 'col', 'abbr': day, 'data-date': day, 'title': this._formatter(day, "dddd") }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .html(headerday);
                    headRow.append(tr);
                }
                for (var i = this.Date.firstDayOfWeek; i < this.Date.firstDayOfWeek + 7; i++) {
                    var weekday = i % 7;
                    var day = cultureObj.names[weekday];
                    var headerday;
                    if (dpObject.model.dayHeaderFormat == "short")
                        headerday = cultureObj.namesAbbr[weekday];
                    else if (dpObject.model.dayHeaderFormat == "long") headerday = day;
                    else headerday = cultureObj.namesShort[weekday];
                    var th = ej.buildTag("th", "", {}, { 'scope': 'col', 'abbr': day, 'data-date': day, 'title': this._formatter(day, "dddd"), 'class': (weekday == 0 || weekday == 6 ? 'e-week-end' : 'e-week-day') }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                            .html(headerday);
                    headRow.append(th);
                }
            };
            return thead.append(headRow);
        },

        _renderCalendar: function (dpObject, date) {
            var proxy = this, today;
            dpObject = $.extend({}, ej.DatePicker.prototype.defaults, dpObject);
            this.Date.firstDayOfWeek = this.model.startDay;
            if (date) today = date;
            else if (this._calendarDate) today = this._calendarDate;
            else today = proxy._zeroTime(new Date());
            var calendarTable = $('table', this.sfCalendar);
            calendarTable.empty();

            calendarTable.append(this._renderHeader(dpObject));

            var tbody = ej.buildTag('tbody.e-datepicker-allyears', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerAllYears(tbody, calendarTable, today.getFullYear());

            tbody = ej.buildTag("tbody.e-datepicker-years", "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerYears(tbody, calendarTable, today.getFullYear());
            var month = dpObject.model.month == undefined ? today.getMonth() : dpObject.model.month;
            var year = dpObject.model.year || today.getFullYear();
            var currentDate = (new Date(year, month, 1, 0, 0, 0));
            var firstDayOffset = this.Date.firstDayOfWeek - currentDate.getDay() + 1;
            if (firstDayOffset > 1) firstDayOffset -= 7;
            var weeksToDraw = Math.ceil(((-1 * firstDayOffset + 1) + this._getDaysInMonth(currentDate)) / 7);
            this._addDays(currentDate, (firstDayOffset - 1));
            var newdate = proxy._zeroTime(new Date());
            var selected = this._calendarDate;
            tbody = ej.buildTag('tbody.e-datepicker-months', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            this._datepickerMonths(tbody, calendarTable, today);

            tbody = ej.buildTag('tbody.e-datepicker-days', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var w = 0, _first = true, _last = true;
            while (w++ < weeksToDraw) {
                var r = jQuery(document.createElement('tr')).attr({'role':'row'});
                if (this.model.weekNumber == true)
                {
                    var week = this._weekDate(currentDate);
                    week = $(document.createElement('td')).attr({}).addClass('e-weeknumber').html(week)
                    r.append(week);
                }
                for (var i = 0; i < 7; i++) {
                    var thisMonth = currentDate.getMonth() == month;
                    var checkSpecialDate = this._isSpecialDates(currentDate);
                    var disable = this._checkDisableRange(currentDate);
                    var index = this._getIndex;
                    var d = $(document.createElement('td')).
                        html(checkSpecialDate ? '<span></span>' + currentDate.getDate() : currentDate.getDate() + '')
                        .attr({

                            'data-date': currentDate.toDateString(),
                            'title': (this.model.showTooltip ? (checkSpecialDate && this.model.specialDates[index][this._mapField._tooltip] ? this.model.specialDates[index][this._mapField._tooltip] : this._formatter(currentDate, this.model.tooltipFormat)) : ''),
                            'aria-selected': false,
                            'role': 'gridcell',
                            'id': this._formatter(currentDate, "yyyyddMM")
                        }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .addClass((thisMonth ? 'current-month e-state-default ' : 'other-month e-state-default ') +
                            (this._isWeekend(currentDate) ? (this._ejHLWeekEnd ? 'e-dp-weekend e-week-end ' : (this.model.highlightWeekend ? 'e-week-end ' : '')) : 'e-week-day ') +
                            (thisMonth && currentDate.getTime() == newdate.getTime() ? 'today ' : ''));

                    d.find('span:first-of-type').addClass((checkSpecialDate ? (this.model.specialDates[index][this._mapField._icon] ? 'e-special-date-icon ' + this.model.specialDates[index][this._mapField._icon] + ' ' : 'e-special-day') : ''));
                    d.addClass(checkSpecialDate ? (this.model.specialDates[index][this._mapField._custom] ? this.model.specialDates[index][this._mapField._custom] : '') : '');
                    if (disable) this._disableDates({ date: currentDate, element: d });
                    if (selected.getTime() == currentDate.getTime() && thisMonth) {
                        if (!d.hasClass('e-hidedate'))
                            if (this.model.value) {
                                d.addClass('e-active').attr({ 'aria-selected': true });
                                if (this.model.highlightSection == "week") {
                                    r.addClass('e-selected-week');
                                }
                                if (this.model.highlightSection == "month") {
                                    tbody.addClass('e-selected-month');
                                }
                                if (this.model.highlightSection == "workdays") {
                                    r.addClass('e-work-week');
                                }
                            }
                            else { if(this.model.value!=null)d.addClass('e-state-hover').attr({ 'aria-selected': false }); }
                        if (!this._hoverDate) {
                            if (!d.hasClass('e-hidedate')) d.addClass('e-state-hover');
                            this._hoverDate = currentDate.getDate() - 1;
                        }
                    }
                    var cond = true;
                    if (currentDate < this.model.minDate || currentDate > this.model.maxDate) {
                        d.addClass('e-hidedate');
                        d.removeClass('current-month');
                        if (this.model.showOtherMonths) d.removeClass('other-month');
                        cond = _last = false;
                    }
                    if (thisMonth) {
                        if (cond && _first) {
                            this._tempMinDate = currentDate;
                            _first = false; _last = true;
                        }
                        if (_last) this._tempMaxDate = currentDate;
                    }
                    this._trigger("beforeDateCreate", { date: currentDate, value: this._formatter(currentDate, this.model.dateFormat), element: d });
                    r.append(d);
                    currentDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + 1, 0, 0, 0);
                }
                tbody.append(r);
            }
            calendarTable.append(tbody);
            if (this._DRPdisableFade) {
                $(tbody).css("display", "block");
                $(tbody).css({ display: "table-row-group", "vertical-align": "middle", "border-color": "inherit" });
            }
            else {
                (this._isIE8 || this._isIE7) ? $(tbody).css("display", "table-row-group") : $(tbody).fadeIn("fast");
            }
            if (this.model.startLevel === this.model.depthLevel)
                this._depthLevel(this.model.depthLevel);
            else if (this.model.depthLevel != "month" && this.model.depthLevel != "") {
                if (this.model.startLevel == "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "year" && this.model.depthLevel != "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else {
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
                }
            }
            else {
                this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }

            this._otherMonthsVisibility();
            this._checkDateArrows();
        },

        _checkDisableRange: function (value) {
            if (!ej.isNullOrUndefined(this._disableCollection[value.getFullYear()]))
                if (jQuery.inArray(value.getMonth(), this._disableCollection[value.getFullYear()]) !== -1)
                    return true;
            return false;
        },
        _initDisableObj: function (disableDates) {
            this._disableCollection = {};
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj) {
                    var year = dateObj.getFullYear();
                    var month = dateObj.getMonth();
                    if (ej.isNullOrUndefined(this._disableCollection[year])) this._disableCollection[year] = [];
                    if (jQuery.inArray(month, this._disableCollection[year]) == -1) this._disableCollection[year].push(month);
                }
            }
        },

        _disableDates: function (args) {
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj && +args.date === +dateObj)
                    args.element.removeClass('current-month').addClass('e-hidedate');
            }
        },

        _keyboardNavigation: function (e) {
            if (this._animating) return false;
            if ((this._isOpen) && (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                if (e.altKey) { if (e.keyCode == 13) { this._setCurrDate(e); return false; } else return; }
                var t = { row: null, col: null };

                t.col = this.sfCalendar.find('tbody tr td.e-state-hover').index();
                t.row = this.sfCalendar.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this.sfCalendar.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this.sfCalendar.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this.sfCalendar.find('table')[0].className, next, rowLength = 3, colLength = 4;
                switch (tableClass) {
                    case "e-dp-viewallyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "yearall", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverAllYear = this.sfCalendar.find('tbody.e-datepicker-allyears tr td').index(next);
                        break;
                    case "e-dp-viewyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "year", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverYear = this.sfCalendar.find('tbody.e-datepicker-years tr td').index(next);
                        break;
                    case "e-dp-viewmonths":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "month", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverMonth = this.sfCalendar.find('tbody.e-datepicker-months tr td').index(next);
                        break;
                    case "e-dp-viewdays":
                        rowLength = this.sfCalendar.find('tbody.e-datepicker-days tr').length, colLength = 7;
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "day", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverDate = this._getDateObj(next).getDate() - 1;
                        break;
                }
                if (!e.ctrlKey) {
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                    this._setAriaAttributes(next);
                }
            }
            else if (!this.model.displayInline && (e.keyCode == 27 || e.keyCode == 9)) { this.hide(); }
            else if (e.altKey && e.keyCode == 40) { this.show(); return false; }
        },
        _setAriaAttributes: function (next) {
            if (this._popupOpen) {
                this.sfCalendar.find("[aria-selected=true]").attr("aria-selected", false)
                this.sfCalendar.find("[aria-label]").removeAttr("aria-label");
                $(this.element).attr("aria-activedescendant", next.attr('id'));
                $(next).attr("aria-selected", true);
                $(next).attr("aria-label", "The current focused date is " + this._formatter(this._getDateObj(next), "dddd, dd MMMM, yyyy"));
            }
        },
        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, cls = { parent: null, child: null };
            switch (target) {
                case "day": eleClass = "tbody.e-datepicker-days tr td.current-month";
                    cls.parent = ".e-datepicker-days", cls.child = ".current-month";
                    break;
                case "month": eleClass = "tbody.e-datepicker-months tr td.e-current-month";
                    cls.parent = ".e-datepicker-months", cls.child = ".e-current-month";
                    break;
                case "year": eleClass = "tbody.e-datepicker-years tr td.e-current-year";
                    cls.parent = ".e-datepicker-years", cls.child = ".e-current-year";
                    break;
                case "yearall": eleClass = "tbody.e-datepicker-allyears tr td.e-current-allyear";
                    cls.parent = ".e-datepicker-allyears", cls.child = ".e-current-allyear";
                    break;
            }
            if (t.row <= 0 && t.col <= 0)
                return this.sfCalendar.find(eleClass + ':first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return this.sfCalendar.find(eleClass + ':first');
                case 35:
                    return this.sfCalendar.find(eleClass + ':last');
                case 38:
                    if (ctrlKey && this.model.allowDrillDown) {
                        this._forwardNavHandler();
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrevDate(true);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrevDate(false);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down");
                            if (cell !== null) return cell;
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var tclassName = $("table", this.sfCalendar).get(0).className, ele, element;
                    ele = this._getCell(t, cls); element = $(ele)[0];
                    if (tclassName == "e-dp-viewmonths" && this.model.startLevel == "year" && this.model.depthLevel == "year") {
                        this._dateValue = new Date(this._dateValue.setMonth(parseInt(element.attributes["data-index"].value)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if ((tclassName == "e-dp-viewyears" && this.model.startLevel == "decade" && this.model.depthLevel == "decade") ||
                        (tclassName == "e-dp-viewallyears" && this.model.startLevel == "century" && this.model.depthLevel == "century")) {
                        this._dateValue = new Date(this._dateValue.setFullYear(parseInt(element.innerHTML)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if (tclassName == "e-dp-viewdays") {
                        this._backwardNavHandler(ele);
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else
                        this._backwardNavHandler(ele);
                    break;
            }
            return this._getCell(t, cls);
        },
        _findVisible: function (t, cls, key) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                nextElement = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-hidedate') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass('other-month')) {
                    return null;
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    return nextElement;
                }
            }
        },
        _getCell: function (t, cls) {
            return this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child + ':nth-child(' + t.col + ')');
        },
        _getDateObj: function (element) {
            return new Date(element.attr("data-date"));
        },
        _touchCalendar: function (e) {
            var tableClass = this.sfCalendar.find('table')[0].className;
            switch (e.type) {
                case "pinchin":
                    if (tableClass != "e-dp-viewdays")
                        this._keyboardNavigation({ keyCode: 13 });
                    break;
                case "pinchout":
                    if (tableClass != "e-dp-viewallyears" && this.model.allowDrillDown)
                        this._forwardNavHandler();
                    break;
                case "swipeleft":
                    this._processNextPrevDate(false);
                    break;
                case "swiperight":
                    this._processNextPrevDate(true);
                    break;
            }
        },

        show: function (e) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            if (this._isOpen) return false;
            var proxy = this;
            this._popupOpen = true;
            $(this.element).attr("aria-expanded", true);
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            if (!this.model.enabled) return;
            if (!this.model.displayInline) this._setDatePickerPosition();
            if (this._trigger("beforeOpen", { element: this.sfCalendar, events: e })) return false;
            this.sfCalendar.attr({ 'aria-hidden': 'false' });
            proxy._isOpen = true;
            this.sfCalendar.slideDown(this.model.enableAnimation ? this.animation.open.duration : 0, function () {
                if (proxy.model && !proxy.model.displayInline)
                    $(document).on("mousedown", $.proxy(proxy._onDocumentClick, proxy));
            });
            if (this._isIE8) {
                if (this.element.val() && this._compareDate(new Date(this.element.val()), previous)) this._updateInputVal();
            }
            else this._updateInputVal();
            this._refreshLevel(previous);
            this._trigger("open", { prevDate: previous, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline) {
              this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
              this._on(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
			}
            this._isInputBox && this.wrapper.addClass("e-active");
        },


        hide: function (e) {
            if (!this._isOpen || this._getInternalEvents) return false;
            if (this._trigger("beforeClose", { element: this.sfCalendar, events: e })) return false;
            var proxy = this;
            this._popupOpen = false;
            $(this.element).attr("aria-expanded", false);
            this.sfCalendar.attr({ 'aria-hidden': 'true' });
            if (this._popClose && e != undefined && e.type != "click") {
                return;
            }
            this.sfCalendar.slideUp(this.model.enableAnimation ? this.animation.close.duration : 0, function () {
                proxy._isOpen = false;
                $(document).off("mousedown", $.proxy(proxy._onDocumentClick, proxy));
                proxy._setWaterMark();
            });
            if (this.element.val() != "") this._validateInputVal();
            this._trigger("close", { prevDate: this._prevDate, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            this._off(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
            this._isInputBox && this.wrapper.removeClass("e-active");
            $(this.element).attr("aria-activedescendant", 'null');
        },


        enable: function () {
            this.model.enabled = true;
            this.wrapper && this.wrapper.removeClass('e-disable');
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
            if (this.dateIcon) this.dateIcon.removeClass('e-disable').attr({ "aria-disabled": false });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().removeClass("e-disable");
            this.element.prop("disabled", false);
            if (!this._isSupport)
                this._hiddenInput.prop("disabled", false);
            this.sfCalendar && this.sfCalendar.removeClass('e-disable').attr({ "aria-disabled": false });
        },


        disable: function () {
            this.model.enabled = false;
            this.wrapper && this.wrapper.addClass('e-disable');
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.attr("disabled", "disabled");
            if (this.dateIcon) this.dateIcon.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().addClass("e-disable");
            this.element.attr("disabled", "disabled");
            if (!this._isSupport)
                this._hiddenInput.attr("disabled", "disabled");
            this.sfCalendar && this.sfCalendar.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isOpen) {
                if (this.element.is(':input')) this.element.blur();
                if (!this.model.displayInline) this.hide();
            }
        },

        getValue: function () { return this._formatter(this.model.value, this.model.dateFormat); },

        _wireCalendarEvents: function () {
            this._allowQuickPick(this.model.allowDrillDown);
            this._on($('.e-next', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            this._on($('.e-prev', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            if (!this.model.displayInline) {
                this.sfCalendar.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
                this.sfCalendar.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));
            }
            if (this.model.showFooter)
                this._on($('.e-footer', this.sfCalendar), "click", this._setCurrDate);
            this.sfCalendar && this._on(this.sfCalendar, "pinchin pinchout swipeleft swiperight", $.proxy(this._touchCalendar, this));
        },

        _wireEvents: function () {
            if (this.element.is(":input") && (this.model.allowEdit)) {
                this._on(this.element, "blur", this._onFocusOut);
                this._on(this.element, "focus", this._onFocusIn);
                this._on(this.element, "keydown", this._onKeyDown);
            }

            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
            }
        },
        _bindDateButton: function () {
            this._on(this.dateIcon, "mousedown", this._showDatePopUp);
            if (this.model.allowEdit)
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
        },
        _bindInputEvent: function () {
            this._off(this.dateIcon, "mousedown", this._showDatePopUp);
        },

        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },

        _onFocusOut: function (e) {
            this._isFocused = false;
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            this._validateOnFocusOut(this._validateValue(), e);
            this.wrapper.removeClass("e-focus");
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
            if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
            if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
            this.element.off("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            var _currentVal = this.element.val();
            var data = { prevDate: this._prevDate, value: _currentVal };
            if (this._specificFormat()) {
                if (this._prevDate != _currentVal)
                    this._setDateValue(_currentVal, true);
            }
            else
                this._setDateValue(_currentVal);
            if (!this.model.value) this._clearSelected();
            this._trigger("focusOut", data);
            this._checkErrorClass();
        },
        _onFocusIn: function (e) {
            if (this._isSupport) {
                e.preventDefault();
                this._isFocused = true;
            }
            this.wrapper.removeClass('e-error');
            this.isValidState = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.addClass('e-valid');
            if (this.model.readOnly)
                return;
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this.element.on("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton && !this.model.readOnly) this.show(e);
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            this._trigger("focusIn", { date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
        },
        _elementClick: function (e) {
            if (!this._popupOpen) this.show(e);
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport)
                this._hiddenInput.css("display", "none");
        },
        _refreshPopup: function () {
            this._refreshDatepicker();
            this._startLevel(this.model.startLevel);
        },
        _weekDate: function (currentDate) {
            var time, checkDate = new Date(currentDate.getTime());
            checkDate.setDate(checkDate.getDate() + 4 - (checkDate.getDay() || 7));
            time = checkDate.getTime();
            checkDate.setMonth(0);
            checkDate.setDate(1);
            return Math.floor(Math.round((time - checkDate) / 86400000) / 7) + 1;

        },
        _refreshLevel: function (previous) {
            if ((this.model.startLevel == this.model.depthLevel) && this.model.startLevel != "month") {
                var val = this._stringToObject(this.element.val());
                val = this._validateYearValue(val);
                if (val)
                    if (!this._compareDate(previous, val))
                        this._refreshPopup();
            }
        },
        _validateOnFocusOut: function (val, e) {
            var dateVal = this._preValue != null ? this._calendarDate : this._preValue;
            var calenderDate = this._formatter(dateVal, this.model.dateFormat);
            if (this._specificFormat() && (val > this.model.minDate) && (val < this.model.maxDate)) {
                if (val == null) this.model.value = dateVal
                else {
                    this.model.value = val;
                    var currDate = this._formatter(val, this.model.dateFormat, this.model.locale);
                }
            }
            else var currDate = this._formatter(this._parseDate((this._formatter(new Date(), "MM/dd/yyyy"))), this.model.dateFormat);
            var dateChange = false, valueExceed = false;
            if (val != null && !this.model.enableStrictMode) {
                if (ej.isNullOrUndefined(this.model.value))
                    this.model.value = this._parseDate(this.element.val());
                if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
                if (!this.model.enableStrictMode) {
                    if (val) {
                        if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                            dateChange = true,
                            this._calendarDate = val = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                        }
                    }
                    else {
                        this.element.val("");
                        if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                        else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                    }
                    this.isValidState = true;
                }
                if (dateChange) this.element.val(this._formatter(val, this.model.dateFormat));
                if (!this._compareDate(this._preValue, this._parseDate(this.element.val(), true))) this._triggerChangeEvent(e);
            }
            else if (val == null && !this.model.enableStrictMode) {
                if (this._preTxtValue == null || this.element.val() == "") {
                    this.element.val("");
                    if (!this._isSupport) this._hiddenInput.css("display", "block");
                } else
                    this.element.val(calenderDate);
                this._triggerChangeEvent(e);
            }
            else {
                if (val) {
                    if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                        this.isValidState = false, valueExceed = true,
                        this._calendarDate = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                    }
                    else
                        this.isValidState = true;
                    this._triggerChangeEvent(e);
                    if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
                }
                else {
                    this.isValidState = false;
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
        },
        _onKeyDown: function (e) {
            if (e.keyCode === 13) {
                var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
                this._validateOnFocusOut(this._validateValue(), e);
                if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
                if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
                if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
                this._checkErrorClass();
            }
        },
        _showhidePopup: function (e) {
            if (!this.model.enabled) return false;
            if (this._isOpen) {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                if (!this._cancelValue) this.hide(e);
            }
            else {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                this.show(e);
            }
        },
        _compareDate: function (first, second) {
            var result = (+first === +second) ? true : false;
            return result;
        },
        _validateDate: function (val) {
            var result = true;
            if (val != null) {
                for (var i = 0; i < this.model.blackoutDates.length; i++) {
                    var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                    if (dateObj && +val === +dateObj)
                        result = false;
                }
                if ((val < this.model.minDate || val > this.model.maxDate) && this.model.enableStrictMode) {
                    result = false;
                    this.isValidState = false;
                }
            }

            return result;
        },

        _triggerChangeEvent: function (e) {
            var currentValue;
            var _currentVal = this.element.val() == "" ? null : this.element.val();
            this._prevDate = this._formatter(this._preValue, this.model.dateFormat);
            var data = { prevDate: this._prevDate, value: _currentVal, isInteraction: !!e };
            if (this._specificFormat() && e != undefined && e.type == "keydown" && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != this.element.val())
                currentValue = this._parseDate(this.element.val(), true);
            else if ((this._specificFormat() && e != undefined && e.type == "blur"))
                currentValue = this.model.value;
            else currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            if (!this._validateDate(currentValue)) currentValue = null;
            if (!this._compareDate(this._preValue, currentValue)) {
                this._preValue = this.model.value = currentValue;
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                if (this.model.value) this._clickedDate = this._calendarDate = this.model.value;
                if (this.model.displayInline && !this._isInputBox) this._hiddenInput.attr('value', _currentVal);
                if (!this.model.value && !this.model.enableStrictMode) this._setDateValue(this.model.value);
                data.value = _currentVal;
                this._trigger("_change", data);
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                this._trigger("change", data);
                this._checkErrorClass();
            }
            else if (!(this.element.val() == "" && this._prevDate == null) && this.element.val() != this._prevDate) {
                data.value = this.element.val();
                this._trigger("_change", data);
            }
        },

        _triggerSelectEvent: function (e) {
            var val = this.element.val();
            if (this._parseDate(val)) {
                var data = { prevDate: this._prevDate, date: this.model.value, value: val, isSpecialDay: this._isSpecialDates(this.model.value) };
                if (this._prevDate != val) {
                    if (this._parseDate(data.value) && (this.model.value >= this.model.minDate && this.model.value <= this.model.maxDate)) {
                        this._cancelValue = this._trigger("select", data);
                    }
                }
                if (this._dt_drilldown) this._trigger("dt_drilldown", data);
            }
        },

        _onDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datewidget").is(this.wrapper)) {
                    this.hide(e);
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-popup").is(this.popup)) {
                    e.preventDefault();
                }
            }
        },

        _OnWindowResize: function (e) {
            if (this.sfCalendar) this._setDatePickerPosition();
        },

        _showDatePopUp: function (e) {
            var isRightClick = false;
            if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            if (isRightClick) return;
            if (!this._isSupport && !this.model.showPopupButton) {
                e.preventDefault();
                this._onFocusIn();
            }
            if (this.model.readOnly) return;
            e.preventDefault();
            if (!this.model.enabled && this.model.displayInline) return false;
            this._showhidePopup(e);
        },
        _layoutChanged: function (e) {
            // this event internally used to observe the layout change in "DateTimePicker" control
            if (this._getInternalEvents) this._trigger("layoutChange");
        },
        _setCurrDate: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e) e.preventDefault();
            var proxy = this;
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._dateValue = this._zeroTime(new Date());
            this.model.value = this._calendarDate = new Date(this._dateValue.toString());
            this._setDateValue(this.model.value);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._refreshDatepicker();
            this._changeDayClass();
            this._startLevel(this.model.startLevel);
            this._onSetCancelDateHandler(e);
            this._layoutChanged();
        },
        _changeDayClass: function () {
            var className = this.popup.children("table")[0].className;
            if (className != "e-dp-viewdays") {
                this.popup.children("table").removeClass(className).addClass("e-dp-viewdays");
            }
        },

        _onSetCancelDateHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && ($(e.target).hasClass("e-disable") || $(e.target).hasClass("e-hidedate"))) return false;
            if (e && e.type) e.preventDefault();
            if (this._specificFormat()) this._prevDate = this.element.val();
            else this.model.value = this._parseDate(this.element.val());
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._setDateValue(this._dateValue);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._dateValue = (this.model.value == null)? null:new Date(this.model.value.toString());
            if (this.element.is(':input') && !this.model.displayInline) {
                this._showhidePopup(e);
            }
            if (e && $(e.currentTarget).hasClass("other-month"))
                this._refreshDatepicker();
            this._cellSelection();
        },
        _closeCalendar: function (ele) {
            if (!ele || ele == this.element) {
                this.sfCalendar.empty().remove();
            }
        },
        //Error class for input value validation
        _checkErrorClass: function () {
            if (this.wrapper) {
                if (this.isValidState) this.wrapper.removeClass("e-error");
                else this.wrapper.addClass("e-error");
            }
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DatePicker.Locale = ej.DatePicker.Locale || {};

    ej.DatePicker.Locale['default'] = ej.DatePicker.Locale['en-US'] = {
        watermarkText: "Select date",
        buttonText: 'Today'
    };


    ej.DatePicker.Header = {
        /**  Removes the day header */
        None: "none",
        /**  Shows the day header format in short like Sun, Mon, Tue … */
        Short: "short",
        /**  Shows the day header format in min like Su, Mo, Tu … */
        Min: "min",
        /**  Shows the day header format in long like Sunday, Monday, Tuesday … */
        Long: "long"
    };

    ej.DatePicker.HighlightSection = {
        /**  Highlight the Current Month. */
        Month: "month",
        /**  Highlight the Current Week. */
        Week: "week",
        /**  Highlight the Current WorkDays. */
        WorkDays: "workdays",
        /** Don't Highlight Anything. */
        None: "none"
    };


    ej.DatePicker.Level = {
        /**  Starts from month level view. */
        Month: "month",
        /**  Starts from year level view. */
        Year: "year",
        /**  Starts from year decade level view. */
        Decade: "decade",
        /**  Starts from century level view.  */
        Century: "century"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to craete a Timepicker with the Html input element
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejTimePicker", "ej.TimePicker", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _rootCSS: "e-timepicker",
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },
        _requiresID: true,

        defaults: {

            cssClass: "",

            timeFormat: "",

            value: null,

            enableAnimation: true,

            locale: "en-US",

            htmlAttributes: {},

            readOnly: false,

            showPopupButton: true,

            enableStrictMode: false,

            interval: 30,

            hourInterval: 1,

            minutesInterval: 1,

            secondsInterval: 1,

            height: "",

            width: "",

            minTime: "12:00 AM",

            maxTime: "11:59 PM",

            showRoundedCorner: false,

            enableRTL: false,

            popupHeight: "191px",

            popupWidth: "auto",

            enabled: true,

            enablePersistence: false,

            disableTimeRanges: null,

            validationRules: null,

            validationMessages: null,

            focusIn: null,

            focusOut: null,

            beforeChange: null,

            change: null,

            select: null,

            create: null,

            destroy: null,

            beforeOpen: null,

            open: null,

            close: null,

            watermarkText:"select a time"
        },


        dataTypes: {
            timeFormat: "string",
            minTime: "string",
            maxTime: "string",
            readOnly: "boolean",
            interval: "number",
            showPopupButton: "boolean",
            locale: "string",
            hourInterval: "number",
            minutesInterval: "number",
            secondsInterval: "number",
            enabled: "boolean",
            enablePersistence: "boolean",
            enableAnimation: "boolean",
            enableStrictMode: "boolean",
            disableTimeRanges: "data",
            htmlAttributes: "data",
            validationRules: "data",
            validationMessages: "data",
            watermarkText:"string"
        },

        observables: ["value"],

        enable: function () {
            if (!this.model.enabled) {
                this.element[0].disabled = false;
                this.element.prop("disabled", false);
                this.model.enabled = true;
                this.wrapper.removeClass('e-disable');
                this.element.removeClass("e-disable").attr("aria-disabled", false);
                if (this.model.showPopupButton) {
                    this.timeIcon.removeClass("e-disable").attr("aria-disabled", false);
                    if (this.popupList) this.popupList.removeClass("e-disable").attr("aria-disabled", false);
                }
                if (this._isIE8) this.timeIcon.children().removeClass("e-disable");
            }
        },


        disable: function () {
            if (this.model.enabled) {
                this.element[0].disabled = true;
                this.model.enabled = false;
                this.element.attr("disabled", "disabled");
                this.wrapper.addClass('e-disable');
                this.element.addClass("e-disable").attr("aria-disabled", true);
                if (this.model.showPopupButton) {
                    this.timeIcon.addClass("e-disable").attr("aria-disabled", true);
                    if (this.popupList) this.popupList.addClass("e-disable").attr("aria-disabled", true);
                }
                if (this._isIE8) this.timeIcon.children().addClass("e-disable");
                this._hideResult();
            }
        },


        getValue: function () {
            return this.element.val();
        },


        setCurrentTime: function () {
            if (!this.model.readOnly) this._setMask();
        },

        show: function () {
            (!this.showDropdown && !this._getInternalEvents) && this._showResult();
        },

        hide: function () {
            (this.showDropdown) && this._hideResult();
        },


        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },

        _timeFormat: function (format) {
            if (!format)
                format = ej.preferredCulture(this.model.locale).calendars.standard.patterns.t;
            var validatedformat = this._validateTimeFormat(format);
            if (validatedformat) {
                this.model.timeFormat = validatedformat;
                // Only change the format when model is not null.   
                this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
                this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);

                if (this.model.value) {
                    this._setModelOption = true;
                    this.model.value = this._localizeTime(this.model.value);
                    this.element.val(this.model.value);
                }
                else {
                    this._setModelOption = false;
                    var timeValue = this._localizeTime(this.element.val());
                    if (timeValue && this._checkMinMax(timeValue)) {
                        this.model.value = timeValue;
                        this.element.val(timeValue);
                    }
                }
            }
            return validatedformat;
        },

        _getTimeFormat: function () {
            if (this._prevTimeFormat)
                this.model.timeFormat = ej.preferredCulture(this.model.locale).calendar.patterns.t || "h:mm tt";
            this.seperator = this._getSeperator();
        },

        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            if (this.popupList) this.popupList.removeClass(this.model.cssClass).addClass(skin);
        },

        _localize: function (culture) {
            var currentTime = this._createObject(this.model.value, true);
            this.model.locale = culture;
            this._getTimeFormat();

            this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
            this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            if (currentTime) {
                this.model.value = this._localizeTime(currentTime);
                this.element.val(this.model.value);
            }
            else {
                currentTime = this._localizeTime(this.element.val());
                if (currentTime && this._checkMinMax(currentTime)) {
                    this.model.value = currentTime;
                    this.element.val(currentTime);
                }
            }
            this._getAmPm();
        },
        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val()=="") {
                    this._hiddenInput.css("display", "block").text(this._localizedLabels.watermarkText);
                }
                else {
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                }
                
            }
        },
        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },
        _setLocalize: function (culture) {
            var culture = ej.preferredCulture(culture);
            if (culture) {
                this.model.locale = culture.name == "en" ? "en-US" : culture.name;
                if (!ej.isNullOrUndefined(this._options) && (ej.isNullOrUndefined(this._options.timeFormat) || (!this._options.timeFormat)))
                    this.model.timeFormat = ej.preferredCulture(this.model.locale).calendars.standard.patterns.t;
                    this._prevTimeFormat = (ej.isNullOrUndefined(this._options.timeFormat)||this._options.timeFormat=="") ? true : false;
            }
        },
        _updateInput: function () {
            if (ej.isNullOrUndefined(this._options)) return;
            var value = this._localizeTime(this._options.value);
            if (!ej.isNullOrUndefined(value))
                if (typeof value === "string" && this.model.enableStrictMode && !this.model.value) {
                    this.element.val(this._options.value);
                    this.isValidState = (this.element.val() == "") ? true : false;
                    this._checkErrorClass();
                }
        },
        _createMinMaxObj: function () {
            // create minTime object
            this._minTimeObj = this._createObject(this.model.minTime);
            if (!this._minTimeObj)
                this.model.minTime = ej.format(this._createObject(new Date().setHours(0, 0, 0, 0)), this.model.timeFormat, this.model.locale);

            // create maxTime object
            this._maxTimeObj = this._createObject(this.model.maxTime);
            if (!this._maxTimeObj)
                this.model.maxTime = ej.format(this._createObject(new Date().setHours(23, 59, 59, 59)), this.model.timeFormat, this.model.locale);
        },
        _setMinMax: function () {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var maxval = new Date().setHours(23, 59, 59, 59);
            if (!ej.isNullOrUndefined(this._options) && ej.isNullOrUndefined(this._options.minTime))
                this.model.minTime = ej.format(this._createObject(minVal), this.model.timeFormat, this.model.locale);
            if (!ej.isNullOrUndefined(this._options) && ej.isNullOrUndefined(this._options.maxTime))
                this.model.maxTime = ej.format(this._createObject(maxval), this.model.timeFormat, this.model.locale);
            this._createMinMaxObj();
        },
        _init: function (options) {
            this._options = options;
            this._cloneElement = this.element.clone();
            this._ISORegex();
            this._isSupport = 'placeholder' in document.createElement('input');
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            this._initialize();
            this._render();
            this._wireEvents();
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
            this._updateInput();
            this._updateTextbox();
            this._setWaterMark();
            if (this.model.validationRules != null) {
                this._initTimeValidator();
                this._setTimeValidation();
            }

        },
        _updateTextbox: function () {
            if (this._options.disableTimeRanges) {
                var isValid = true;
                for (var i = 0; i < this._options.disableTimeRanges.length; i++) {
                    if (this.model.minTime >= this._options.disableTimeRanges[i].startTime || this.model.minTime <= this._options.disableTimeRanges[i].endTime) {
                        if ((this._options.disableTimeRanges[i].startTime == this.model.minTime)) {
                            isValid = false;
                            break;
                        }
                    }
                }

                if (this._options === undefined || (this._options.value === undefined && !this.model.value && isValid))
                    this._setTime(this._localizeTime(this.model.minTime));
            }

            else if (this._options === undefined || (this._options.value === undefined && !this.model.value))
                this._setTime(this._localizeTime(this.model.minTime));
        },

        _setMinMaxTime: function (prev, options) {
            if (!ej.isNullOrUndefined(options["minTime"]) && $.trim(options["minTime"]) && this._isValid(options["minTime"])) {
                this.model.minTime = options["minTime"];
                this._minTimeObj = this._createObject(this.model.minTime);
                this._validateTimes();
            }
            if (!ej.isNullOrUndefined(options["maxTime"]) && $.trim(options["maxTime"]) && this._isValid(options["maxTime"])) {
                this.model.maxTime = options["maxTime"];
                this._maxTimeObj = this._createObject(this.model.maxTime);
                this._validateTimes();
            }

            this._validateMinMax();
            this._createMinMaxObj();
            if (!ej.isNullOrUndefined(options["minTime"])) options["minTime"] = this.model.minTime;
            if (!ej.isNullOrUndefined(options["maxTime"])) options["maxTime"] = this.model.maxTime;
            if (!this._checkMinMax(this.model.value)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                        this.model.value = this.model.minTime;
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                        this.model.value = this.model.maxTime;
                }
                else {
                    this.isValidState = false;
                    this.model.value = null;
                }
            }
            if (prev !== this.model.value && this._isValid(this.model.value, true))
                this.element.val(this.model.value);
        },
        _setModel: function (options) {
            var change = false, prev = this.model.value;
            if (ej.isNullOrUndefined(this.popupList)) this._renderDropdown();
            for (var option in options) {
                switch (option) {
                    case "timeFormat":
                        var prevTime = this._createObject(this.model.value);
                        this._preTimeformat = this.model.timeFormat;
                        var newFormat = this._timeFormat(options[option]);
                        options[option] = this.model.timeFormat;
                        if (newFormat)
                            this.seperator = this._getSeperator();
                        var currentTime = this._createObject(this.model.value);
                        change = (+prevTime === +currentTime) ? false : true;
                        break;
                    case "locale":
                        var prevTime = this._createObject(this.model.value);
                        this._localize(options[option]);
                        this.model.minTime = ej.format(this._createObject(this._minTimeObj), this.model.timeFormat, this.model.locale);
                        this.model.maxTime = ej.format(this._createObject(this._maxTimeObj), this.model.timeFormat, this.model.locale);
                        var currentTime = this._createObject(this.model.value);
                        change = (+prevTime === +currentTime) ? false : true;
                        break;
                    case "interval":
                        this.model.interval = options[option];
                        break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "enableRTL": this._setRtl(options[option]); break;
                    case "height":
                        this._setHeight(options[option]); break;
                    case "width":
                        this.wrapper.width(options[option]);
                        this._setListWidth();
                        break;
                    case "value":
                        if (ej.isPlainObject(options[option])) options[option] = null;
                        this.model.value = ej.format(this._createObject(options[option], true), this.model.timeFormat, this.model.locale);
                        this._ensureValue();
                        this._enableMask();
                        if (this.model.enableStrictMode && !this._isValid(options[option], true)) {
                            var tval = this._isValid(options[option]) ? this._localizeTime(options[option]) : options[option];
                            this.element.val(tval);
                        }
                        options[option] = this.model.value;
                        change = true;
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = options[option];
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initTimeValidator();
                            this._setTimeValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initTimeValidator();
                            this._setTimeValidation();
                        }
                        break;
                    case "popupHeight": this.model.popupHeight = options[option]; this._setListHeight(); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "enabled": if (options[option]) this.enable(); else this.disable(); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "disableTimeRanges":
                        this.model.disableTimeRanges = options[option];
                        this._initStartEnd();
                        this.model.value = ej.format(this._createObject(this.element.val(), true), this.model.timeFormat, this.model.locale);
                        this._ensureValue();
                        this._enableMask();
                        if (this.model.enableStrictMode && !this._isValid(this.element.val(), true))
                            this.element.val(this.element.val());
                        change = true;
                        break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options[option] = this.model.watermarkText = options[option];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                }
            }
            if (!ej.isNullOrUndefined(options["minTime"]) || !ej.isNullOrUndefined(options["maxTime"])) {
                this._setMinMaxTime(prev, options);
                change = true;
            }
            if (!ej.isNullOrUndefined(options["showPopupButton"]))
                this._showButton(options[option]);
            else if (this.model.showPopupButton && (newFormat || !ej.isNullOrUndefined(options["minTime"]) || !ej.isNullOrUndefined(options["maxTime"]) ||
                   !ej.isNullOrUndefined(options["locale"]) || !ej.isNullOrUndefined(options["interval"]) || !ej.isNullOrUndefined(options["disableTimeRanges"]))) {
                this._reRenderDropdown();
            }
            if (change) {
                this._raiseChangeEvent(prev, true);
                options["value"] = this.model.value;
            }
            this._checkErrorClass();
        },


        _destroy: function () {
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            this.element.removeClass("e-input").removeAttr("ondragstart draggable aria-atomic aria-live aria-readonly").val(this.element.attr("value"));
            if (!this._cloneElement.attr('name')) this.element.removeAttr('name');
            if (this.popupList) this.popupList.remove();
        },

        _initialize: function () {
            this.target = this.element[0];
            this.timeIcon = null;
            this._disabledItems = [];
            this.popupList = null;
            this.focused = false;
            this.start = 0;
            this.end = 0;
            this.min = null;
            this.max = null;
            this.incomplete = false;
            this.downPosition = 0;
            this._setLocalize(this.model.locale);
            this._setMinMax();
            this._getAmPm();
            this.showDropdown = false;
            this._activeItem = 0;
            this.isValidState = true;
            this._manualFocus = false;
            this._isIE7 = this._checkIE7();
            this._initStartEnd();
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "")
                this.model.value = this.element[0].value;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            // _getInternalEvents is used when TimePicker used as a subcontrol of DateTimePicker 
            this._getInternalEvents = false;
            this._dateTimeInternal = false;
            if (!this.model.timeFormat) this._getTimeFormat();
            else this.seperator = this._getSeperator();
        },

        _render: function () {
            this._renderWrapper();
            this._setDimentions();
            this._renderTimeIcon();
            this._validateTimes();
            this._createMinMaxObj();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this._enableMask();
            this._checkErrorClass();
            this.element.attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', "aria-readonly": this.model.readOnly, "value": this.model.value });
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.addClass('e-valid') : this.wrapper.removeClass('e-valid');
        },

        _renderWrapper: function () {
            this.element.addClass("e-input").attr({'tabindex':'0','role':'combobox','aria-expanded':'false'});
            this.wrapper = ej.buildTag("span.e-timewidget e-widget " + this.model.cssClass + "#" + this.target.id + "_timewidget").insertAfter(this.element);
            this.wrapper.attr("style", this.element.attr("style"));
            this.element.removeAttr('style');
            if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isSupport) {
                this._hiddenInput = ej.buildTag("span.e-input e-placeholder").insertAfter(this.element);
                this._hiddenInput.text(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "none");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true;
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);

            });
        },
        _initTimeValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setTimeValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _renderTimeIcon: function () {
            if (this.model.showPopupButton) {
                this.timeIcon = ej.buildTag("span.e-select").attr({ 'role': 'button', 'aria-label': 'select' });
                var icon = ej.buildTag("span.e-icon e-clock").attr('role', 'presentation');
                if (this._isIE8) {
                    this.timeIcon.attr("unselectable", "on");
                    icon.attr("unselectable", "on");
                }
                this.timeIcon.append(icon);
                this.container.append(this.timeIcon).addClass("e-padding");
                this._on(this.timeIcon, "mousedown", this._timeIconClick);
            }

        },
        _elementClick: function (e) {
            if (!this.showDropdown) this._showResult();
        },
        _renderDropdown: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            if (!this.model.showPopupButton || this.popupList) return false;
            this.popupList = ej.buildTag("div.e-time-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.target.id + "_popup", "", {}, { 'tabindex': 0, 'role':'listbox'});
            if (!ej.isTouchDevice()) this.popupList.addClass('e-ntouch');
            this.popup = this.popupList;
            this.ul = ej.buildTag("ul.e-ul");
            if (this._isIE8)
                this.ul.attr("unselectable", "on");
            var scrollDiv = ej.buildTag("div").append(this.ul);
            $('body').append(this.popupList.append(scrollDiv));
            this._renderLiTags();
            this._setListHeight();
            this._setListWidth();
            this.popupList.ejScroller({ height: this.popupList.height(), width: 0, scrollerSize: 20 });
            this.scrollerObj = this.popupList.ejScroller("instance");
            this.popupList.css("display", "none");
            this._listSize = this.ul.find("li").length;
        },
        _renderLiTags: function () {
            this._disabledItems = [];
            var start, end, timeVal, interval = this.model.interval * 60000;
            // Maintain the min and max time as object;
            var disableTime = (!ej.isNullOrUndefined(this.model.disableTimeRanges) && this.model.disableTimeRanges.length > 0) ? true : false;
            start = this._minTimeObj;
            end = this._maxTimeObj;
            var i = 0;
            while (this._compareTime(end, start, true)) {
                timeVal = this._localizeTime(start);
                var litag = $(document.createElement('li'));
                litag[0].appendChild(document.createTextNode(timeVal));
                if (this._isIE8) litag.attr("unselectable", "on");
                if (disableTime) {
                    if (this._ensureTimeRange(timeVal)) {
                        litag.addClass('e-disable');
                        this._disabledItems.push(i);
                    }
                    else {
                        litag.removeClass('e-disable');
                    }
                }
                this.ul[0].appendChild(litag[0]);
                start = new Date(start).getTime() + interval;
                i++;
            }

            var liTags = this.ul.find("li");
            if (!ej.isTouchDevice()) {
                this._on(liTags, "mouseenter", $.proxy(this._OnMouseEnter, this));
                this._on(liTags, "mouseleave", $.proxy(this._OnMouseLeave, this));
            }
            this._on(liTags, "click", $.proxy(this._OnMouseClick, this));
            if (this.model.showPopupButton || !ej.isNullOrUndefined(this.popupList))
                this.ul.find("li").attr({ 'tabindex': -1, 'aria-selected': false,'role':'option' });
        },
        _ensureTimeRange: function (value) {
            if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                var timeVal = this._makeDateTimeObj(value);
                for (var i = 0; i < this.model.disableTimeRanges.length; i++) {
                    if (+timeVal >= +this._makeDateTimeObj(this.model.disableTimeRanges[i].startTime) && +timeVal <= +this._makeDateTimeObj(this.model.disableTimeRanges[i].endTime))
                        return true;
                }
            }
            return false;
        },
        _initStartEnd: function () {
            this._startTime = [];
            this._endTime = [];
            if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                for (var i = 0; i < this.model.disableTimeRanges.length; i++) {
                    this._startTime[i] = this._makeDateTimeObj(this.model.disableTimeRanges[i].startTime);
                    this._endTime[i] = this._makeDateTimeObj(this.model.disableTimeRanges[i].endTime);
                }
            }
        },
        _makeDateTimeObj: function (value) {
            if (typeof value === "string") {
                var dateFormat = ej.preferredCulture(this.model.locale).calendar.patterns.d;
                var dateValue = ej.format(new Date("1/1/2000"), dateFormat, this.model.locale);
                var obj = ej.parseDate(dateValue + " " + value, dateFormat + " " + this.model.timeFormat, this.model.locale);
                if (!obj) {
                    var isJSONString = new Date(value);
                    if (!isNaN(Date.parse(isJSONString)) && !ej.isNullOrUndefined(value))
                        return this._setEmptyDate(value);
                    else
                        obj = new Date("1/1/2000 " + value);
                }
                return obj;
            }
            else if (value instanceof Date)
                return this._setEmptyDate(value);
            else return null;
        },
        _reRenderDropdown: function () {
            this.ul.empty();
            this._renderLiTags();
            this._refreshScroller();
            this._changeActiveEle();
        },
        _refreshScroller: function () {
            var flag = this.popupList.css("display") == "none" ? true : false;
            this.popupList.css("height", "auto");
            this.popupList.find(".e-content, .e-vscroll").removeAttr("style");
            this.popupList.find(".e-vscroll div").removeAttr("style");

            if (flag) this.popupList.css("display", "block");
            this.scrollerObj.model.height = this.popupList.height();
            this.scrollerObj.model.scrollTop = 0;
            this.scrollerObj.refresh();
            if (this._isIE8) {
                $("#" + this.scrollerObj._id).children('.e-vscroll').children().attr("unselectable", "on");
                $("#" + this.scrollerObj._id).find('.e-vhandle').attr("unselectable", "on");
            }
            if (flag) this.popupList.css("display", "none");
        },

        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport)
                this._hiddenInput.css("display", "none");
        },

        _setListWidth: function () {
            if (this.popupList) {
                var timePopupWidth = this.model.popupWidth,width;
                if ((typeof (timePopupWidth) == "string" && timePopupWidth.indexOf("%") != -1) || typeof (timePopupWidth) == "string") width = parseInt(timePopupWidth) > 0 ? timePopupWidth : "auto" && (this.model.popupWidth = "auto");
                else {
                    width = timePopupWidth > 0 ? timePopupWidth : "auto" && (this.model.popupWidth = "auto");
                }
                if (width && width != "auto") this.popupList.css({ "width": width });
                else this.popupList.css({ "width": this.wrapper.width() });
            }
            if (this.scrollerObj) {
                this._refreshScroller();
                this._updateScrollTop();
            }
        },
        _setListHeight: function () {
            if (this.popupList) this.popupList.css({ "max-height": this.model.popupHeight || "191px" });
            if (this.scrollerObj) {
                this._refreshScroller();
                this._updateScrollTop();
            }
        },
        _updateScrollTop: function () {
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
        },
        _refreshPopup: function () {
            if (this.model.popupWidth == "auto") this.popupList.css({ "width": this.wrapper.width() });
            this._setListPosition();
            this._refreshScroller();
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupList.outerHeight(),
            popupWidth = this.popupList.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupList.outerWidth() - elementObj.outerWidth();
            this.popupList.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupList);
        },

        _enableMask: function () {
            var flag = false;
            if ((this.model.minTime && this._compareTime(this.model.minTime, this.model.value)) ||
                this.model.maxTime && this._compareTime(this.model.value, this.model.maxTime))
                this.isValidState = false;
            else this.isValidState = true;
            this._setTime(this.model.value);
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            if (this._getInternalEvents && !this.isValidState) this._trigger("outOfRange");
            this._changeActiveEle();
            this._preVal = this.element.val();
        },
        _setTime: function (time) {
            if (!this._isSupport)
                this._hiddenInput.css("display", "none");
            var modifiedTime = this._localizeTime(time);
            this.element.val(modifiedTime);
            if (this.model.enableStrictMode) {
                this.model.value = (this._compareTime(this.model.value, this.model.minTime) && this._compareTime(this.model.maxTime, this.model.value)) ? modifiedTime : null;
            } else {
                this.model.value = modifiedTime;
            }
            this._setWaterMark();
        },
        _timeFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _setMask: function () {
            this.model.value = new Date();
            this._enableMask();
        },

        _validateTimes: function () {
            var validatedformat = this._validateTimeFormat(this.model.timeFormat);
            if (validatedformat) this.model.timeFormat = validatedformat;
            else this.model.timeFormat = "h:mm tt";
            if (!this._isValid(this.model.minTime)) this.model.minTime = "12:00 AM";
            if (!this._isValid(this.model.maxTime)) this.model.maxTime = "11:59 PM";
            if (!this._isValid(this.model.value, true)) this.model.value = null;
            if (!this._checkMinMax(this.model.value) && !this.model.enableStrictMode) {
                if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                    this.model.value = this.model.minTime;
                if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                    this.model.value = this.model.maxTime;
            }
            this._validateMinMax();
        },
        _ensureValue: function () {
            if (!this._checkMinMax(this.model.value) && this._isValid(this.model.value, true)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this.model.value, this.model.minTime, true))
                        this.model.value = this.model.minTime;
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this.model.value, true))
                        this.model.value = this.model.maxTime;
                }
                else
                    this.isValidState = false;
            }
        },
        _validateMinMax: function () {
            if (this.model.minTime && this.model.maxTime && this._compareTime(this.model.minTime, this.model.maxTime)) {
                this.model.minTime = this.model.maxTime;
            }
        },
        _checkProperties: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                this.disable();
            }
            else if (this.model.enabled && this.element.hasClass("e-disable")) {
                this.model.enabled = false;
                this.enable();
            }
            this._addProperty();
            this._checkAttributes();
        },
        _addProperty: function () {
            this._setRtl(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
        },
        _setRtl: function (boolean) {
            if (boolean) {
                this.wrapper.addClass("e-rtl");
                if (this.popupList) this.popupList.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                if (this.popupList) this.popupList.removeClass("e-rtl");
            }
        },
        _setRoundedCorner: function (boolean) {
            if (boolean) {
                this.container.addClass("e-corner");
                if (this.popupList) this.popupList.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                if (this.popupList) this.popupList.removeClass("e-corner");
            }
        },
        _showButton: function (show) {
            this.model.showPopupButton = show;
            if (show) {
                this.container.addClass("e-padding");
                this._renderTimeIcon();
                this._renderDropdown();
                this._addProperty();
            }
            else {
                this.container.removeClass("e-padding");
                this.timeIcon.remove();
                this.popupList.remove();
                this.timeIcon = this.popupList = null;
                $(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
            }
        },
        _checkAttributes: function () {
            if (!this.element.attr("name"))
                this.element.attr({ "name": this.element[0].id });
            if ('ondragstart' in document.createElement('input'))
                this.element.attr({ "ondragstart": "return false" });
            if ('draggable' in document.createElement('input'))
                this.element.attr({ "draggable": "false" });
        },

        _getAmPm: function () {
            var dateObj = new Date();
            dateObj.setHours(0);
            this.ttAM = $.trim(this._localizeMeridian(dateObj));
            dateObj.setHours(23);
            this.ttPM = $.trim(this._localizeMeridian(dateObj));
        },

        _setDimentions: function () {
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this._setHeight(this.model.height);
            if (this.model.width) this.wrapper.width(this.model.width);
        },
        _setHeight: function (height) {
            if (height) this.wrapper.height(height);
            if (this._isIE7) this.element.height(this.container.height());
        },

        _validateTimeFormat: function (timeFormat) {
            var parts = timeFormat.split(" "), format = "";
            if (parts.length == 1 || parts.length == 2) {
                $(parts).each(function (i, part) {
                    format += $.trim(part) + " ";
                });
                return $.trim(format);
            }
            else return null;
        },

        _getSeperator: function () {
            var p = this._getElePlace(), formats = this.model.timeFormat.split(" ")[p.time];
            var regex = new RegExp("^[a-zA-Z0-9]+$");

            for (var i = 0; i < formats.length; i++) {
                if (!regex.test(formats.charAt(i))) return formats.charAt(i);
            }
        },

        _checkInComplete: function () {
            var pos = this._getCaretSelection(), cursor = this._getStartEnd(pos);
            var replace = "00", selected = this._getSelectedValue(cursor), category = this._getCategory(cursor);
            if (pos.end - pos.start == this.element.val().length) this._checkAll();

            if (category && category != "tt") {
                this._findCategoryPosition(category);
                if (selected == "__") {
                    if (category == "h" || category == "hh") replace = "12";
                    this._changeToDefault(replace);
                }
                else if (category.length != 1 && selected.length == 1) {
                    selected = this._changeWhole(selected);
                    this.element.val(this._replaceAt(this.target.value, this.start, this.end, selected));
                }
            }
        },
        _checkAll: function () {
            var i, p = this._getElePlace(), categories = this.model.timeFormat.split(" ")[p.time].split(this.seperator);
            for (i = 0; i < categories.length; i++) {
                this._findCategoryPosition(categories[i]);
                var selected = this._getSelectedValue({ start: this.start, end: this.end });

                if (categories[i].length != 1 && selected.length == 1) {
                    selected = this._changeWhole(selected);
                    this.element.val(this._replaceAt(this.element.val(), this.start, this.end, selected));
                }
            }
        },

        _changeToDefault: function (replace) {
            this.incomplete = true;
            var preVal = this.element[0].value
            this.element[0].value = this._replaceAt(this.target.value, this.start, this.end, replace);
            var timeValue = this._checkExceedRange(this.target.value);
            if (!!timeValue) {
                this._setTime(this.model[timeValue]);
            }
            this._setSelection(this.start, this.end);
            this._raiseChangeEvent(preVal);
        },

        _setSelection: function (start, end) {
            var element = this.element[0];

            if (element.setSelectionRange)
                element.setSelectionRange(start, end);
            else if (element.createTextRange) {
                // For lower version browsers (IE8, IE7 ...)
                element = element.createTextRange();
                element.collapse(true);
                element.moveEnd('character', end);
                element.moveStart('character', start);
                element.select();
            }
        },

        _getSelectedValue: function (cursor) {
            return this.target.value.substring(cursor.start, cursor.end);
        },

        _getMinMax: function (currPart, keydown) {
            if (currPart == "hh" || currPart == "h") {
                this.min = 1; this.max = 11;
                if (keydown) this.max = 12;
            }
            else if (currPart == "HH" || currPart == "H") {
                this.min = 0; this.max = 23;
            }
            else if (currPart == "mm" || currPart == "m" || currPart == "ss" || currPart == "s") {
                this.min = 0; this.max = 59;
            }
        },

        _focusElement: function () {
            this._manualFocus = true;
            this.element.focus();
        },
        _targetFocus: function (e) {
            this._clearRange();
            e.preventDefault();
            this.focused = true;
            this.element.on('mousewheel DOMMouseScroll', $.proxy(this._mouseWheel, this));
            this.wrapper.addClass("e-focus").removeClass("e-error").attr('aria-invalid', "false");
            if (!this._manualFocus) {
                this._findCategoryPosition(this._getLeast(false));
                this._setSelection(this.start, this.end);
            }
            this._manualFocus = false;
            this._prevTimeVal = this.element.val();
            this._raiseEvent("focusIn");
            this.wrapper.addClass('e-valid');
            if (!this._isSupport)
                this._hiddenInput.css("display", "none");
        },
        _targetBlur: function () {
            this.focused = false;
            this.element.off('mousewheel DOMMouseScroll', $.proxy(this._mouseWheel, this));
            this.wrapper.removeClass("e-focus");
            if (!this.model.enableStrictMode) {
                // To remove the min value mask while focusout the timepicker.
                if (this.target.value.indexOf('_') > -1) this.element.val('');
            }
            if (!this._checkMinMax(this.target.value) && this._isValid(this.target.value, true)) {
                if (!this.model.enableStrictMode) {
                    if (this.model.minTime && !this._compareTime(this._createObject(this.target.value), this.model.minTime, true))
                        this.element.val(this.model.minTime);
                    if (this.model.maxTime && !this._compareTime(this.model.maxTime, this._createObject(this.target.value), true))
                        this.element.val(this.model.maxTime);
                    if (!this._isValid(this.model.value, true))
                        this.element.val(null);
                    this.isValidState = true;
                    (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
                }
                else
                    this.isValidState = false;
            }
            else this.isValidState = true;
            this._ensureValue();
            this._raiseChangeEvent();
            this._checkErrorClass();
            this._raiseEvent("focusOut");
            this._setWaterMark();
            if (!this.model.enableStrictMode) this._checkInComplete();
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
        },
        _clearRange: function () {
            var input = this.element[0];
            if (!isNaN(input.selectionStart)) {
                input.selectionStart = 0;
                input.selectionEnd = 0;
            }
        },
        _checkErrorClass: function () {
            if (this.isValidState) this.wrapper.removeClass("e-error").attr('aria-invalid', "false");
            else this.wrapper.addClass("e-error").attr('aria-invalid', "true");
        },

        _getCaretSelection: function () {
            var input = this.element[0], start = 0, end = 0;
            if (!isNaN(input.selectionStart)) {
                start = input.selectionStart;
                end = input.selectionEnd;
                return { start: Math.abs(start), end: Math.abs(end) };
            }
            // For lower version browsers (IE8, IE7 ...)
            var bookmark = document.selection.createRange().getBookmark();
            var selection = input.createTextRange();
            selection.moveToBookmark(bookmark);

            var before = input.createTextRange();
            before.collapse(true);
            before.setEndPoint("EndToStart", selection);
            var beforeLength = before.text.length, selLength = selection.text.length;
            return { start: beforeLength, end: beforeLength + selLength };
        },

        _mouseDownOnInput: function (e) {
            if (!this.focused && (!ej.isTouchDevice())) this._focusElement();
            this.downPosition = this._getCaretSelection();
            $(document).on("mouseup", $.proxy(this._mouseUpOnInput, this));
        },

        _mouseUpOnInput: function (e) {
            e.preventDefault();
            $(document).off("mouseup", $.proxy(this._mouseUpOnInput, this));
            var pos = this._getCaretSelection();

            if (this.incomplete) {
                this.incomplete = false;
                pos = this.downPosition;
            }
            // Select the Complete Time value using mouse.            
            if (this.target.value != this._getSelectedText()) {
                pos = this._getStartEnd(pos);
                this._setSelection(pos.start, pos.end);
            }
        },

        _getCategoryPosition: function (category) {
            var s = 0, e = 0, parts = this.target.value.split(" "), p = this._getElePlace(), sep = this.seperator, valid = false;
            var fParts = this.model.timeFormat.split(" ")[p.time].split(sep);
            var tParts = parts[p.time].split(sep);
            if (fParts.length > tParts.length) return { start: s, end: e, isValid: valid };

            if (category == "tt") {
                if (parts[p.tt] == this.ttAM || parts[p.tt] == this.ttPM) {
                    if (p.tt == 0) s = 0;
                    else s = parts[p.time].length + 1;
                    e = s + parts[p.tt].length;
                    valid = true;
                }
            }
            else {
                if (p.time == 0) s = 0;
                else s = parts[p.tt].length + 1;

                var index = fParts.indexOf(category);
                if (index != -1) {
                    for (var i = 0; i < fParts.length; i++) {
                        e = tParts[i].length + 1;
                        if (i == index) break;
                        else s += e;
                    }
                    e += s - 1;
                    valid = true;
                }
            }
            return { start: s, end: e, isValid: valid };
        },
        _getCategory: function (cursor) {
            var parts = this.model.timeFormat.split(" "), sep = this.seperator;
            var p = this._getElePlace();
            if (cursor.isTT) return parts[p.tt];
            else return parts[p.time].split(sep)[cursor.index];
        },

        _getStartEnd: function (pos) {
            var tt, sep = this.seperator;
            var value = this.element.val(), parts = value.split(" "), s = 0, e = 0, place = tt = null, i, j;

            for (j = 0; j < parts.length; j++) {
                if (parts[j] != this.ttAM && parts[j] != this.ttPM) {
                    var time = parts[j].split(sep), tempS = s, tempE = s + time[0].length;
                    for (i = 0; i < time.length; i++) {
                        e = time[i].length + s;
                        if (pos.start <= e) {
                            place = i;
                            tt = false;
                            j = parts.length;
                            break;
                        }
                        else s += time[i].length + 1;
                    }
                }
                else {
                    if (pos.start <= s + parts[j].length) {
                        e = parts[j].length + s;
                        place = 0;
                        tt = true;
                        j = parts.length;
                        break;
                    }
                    else s += parts[j].length + 1;
                }
            }
            if (place == null) s = tempS, e = tempE, place = 0, tt = false;

            return { start: s, end: e, index: place, isTT: tt };
        },

        _modifyValue: function (isIncrement) {
            if (!this._isValid(this.target.value)) return;
            if (!this.model.enableStrictMode) this._checkInComplete();
            var pos = this._getCaretSelection(), cursor;
            if (pos.start == pos.end) {
                var cate = this._getLeast(true);
                var position = this._getCategoryPosition(cate);
                cursor = this._getStartEnd(position);
            }
            else cursor = this._getStartEnd(pos);
            this.start = cursor.start; this.end = cursor.end;
            this._changeValue(cursor, isIncrement);
        },

        _keyUpOnInput: function (e) {
            e.preventDefault();
            if (this._preVal != this.element.val()) {
                this._preVal = this.element.val();
            }
            var proxy = this;
            pos = this._getCaretSelection();
            cursor = this._getStartEnd(pos);
            category = this._getCategory(cursor);
            proxy = this;
            var currSelection = this._getSelectedValue(cursor);
            spl = this.element.val();
            spl.split(":");
            if (spl[0] < 3)
                if (isNaN(spl[0] + spl[1]) == true && (spl[0]) < 10)
                    this._poschange = true;
                else
                    this._poschange = false;

            if (((category == 'h') && (pos.start == 2 && pos.end == 2) && (currSelection > 9 && currSelection < 13)) || ((category == 'H') && (currSelection > 9 && currSelection < 24)) || ((category == 'H') && (currSelection < 9) && (pos.start == 2 && pos.end == 2)) || (category == "mm" && this._poschange == true && (pos.start == 4 && pos.end == 4)) || (category == "ss" && (pos.start == 8 && pos.end == 8)) || (category == "ss" && this._poschange == true && (pos.start == 7 && pos.end == 7)) || (category == 'mm' && (pos.start == 5 && pos.end == 5))) {
                if (!((category == 'mm' && (this.model.timeFormat == "HH:mm" || this.model.timeFormat == "hh:mm" || this.model.timeFormat == "H:mm" || this.model.timeFormat == "h:mm")) || (category == "ss" && (this.model.timeFormat == "HH:mm:ss" || this.model.timeFormat == "hh:mm:ss" || this.model.timeFormat == "H:mm:ss" || this.model.timeFormat == "h:mm:ss"))))
                    this._movePosition(pos, null);
            }
            else if (((category == 'hh' || category == 'HH') && (pos.start && pos.end == 2)) && (currSelection < 24)) {
                this._movePosition(pos, null);
            }
        },

        _getNextCategory: function (cate, direction) {
            var categories = [], sep = this.seperator;
            var fParts = this.model.timeFormat.split(" ");
            $(fParts).each(function (i, part) {
                if (part == "tt") categories.push(part);
                else {
                    var inner = part.split(sep);
                    categories = inner.concat(categories);
                }
            });
            var index = categories.indexOf(cate), ix;
            if (index != -1) {
                if (direction) {
                    if (index == 0) ix = categories.length - 1;
                    else ix = index - 1;
                }
                else {
                    if (index == categories.length - 1) ix = 0;
                    else ix = index + 1;
                }
                return categories[ix];
            }
            return cate;
        },
        _getElePlace: function () {
            var fParts = this.model.timeFormat.split(" "), time, tt;
            if (fParts[0] == "tt") time = 1, tt = 0;
            else time = 0, tt = 1;
            return { time: time, tt: tt };
        },
        _movePosition: function (pos, direction) {
            var cursor = this._getStartEnd(pos);
            var currCate = this._getCategory(cursor);
            if (!currCate) currCate = this._getLeast(direction);
            var next = this._getNextCategory(currCate, direction);
            var cursor = this._getCategoryPosition(next);

            if (cursor.isValid) {
                this._setSelection(cursor.start, cursor.end);
            }
        },
        _findActiveIndex: function () {
            var elements = this.ul.find("li");
            var currTime = this.element.val(), firstTime = elements.first().html(), index;
            index = (this._parse(currTime) - this._parse(firstTime)) / (this.model.interval * 60000);
            index = Math.round(index);
            this._activeItem = (index == elements.length) ? index : index + 1;
            if (this._activeItem < 0 || this._activeItem > elements.length || isNaN(this._activeItem)) this._activeItem = 0;
        },
        _keyDownOnInput: function (e) {
            if (this.model.readOnly && !this._readOnlyKeys(e)) return false;
            var pos, cursor, category, key = e.keyCode;

            // _getInternalEvents is set to true when TimePicker used inside DateTimePicker control
            // in DateTimePicker control it allows Up, Down, Home, End, Tab keys only
            if (this._getInternalEvents && key != 38 && key != 40 && key != 36 && key != 35 && key != 9) return false;
            // Up, Down, Esc
            if (!this.model.enableStrictMode) {
                // Prevent type operation on popup open in state.
                if (this.showDropdown && key != 38 && key != 40 && key != 27 && !this._readOnlyKeys(e)) return false;
                else if (this.showDropdown && (key == 37 || key == 39)) e.keyCode = (key == 37) ? 38 : 40;
            }
            pos = this._getCaretSelection();
            cursor = this._getStartEnd(pos);
            category = this._getCategory(cursor);
            switch (e.keyCode) {
                case 38:
                    e.preventDefault();
                    if (!this.showDropdown) {
                        if (this._isValid(this.target.value)) this._modifyValue(true);
                    }
                    else if (this.showDropdown) {
                        e.preventDefault();
                        this._findActiveIndex();
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectUp(this._activeItem - 1);
                        if (this._activeItem == 0) this._activeItem = prevActiveItem;
                        this._addListHover();
                        activeItem = this._getActiveItem();
                        if (activeItem.length) this._selectTimeItem(activeItem);
                    }
                    break;
                case 40:
                    e.preventDefault();
                    if (e.altKey && this.model.showPopupButton)
                        this._showhidePopup();
                    else if (!this.showDropdown) {
                        if (this._isValid(this.target.value)) this._modifyValue(false);
                    }
                    else if (this.showDropdown) {
                        e.preventDefault();
                        this._findActiveIndex();
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectDown(this._activeItem);
                        if (this._activeItem < this._listSize) this._activeItem += 1;
                        else
                            this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 37:
                    e.preventDefault();
                    if (pos.start == pos.end) this._setSelection(pos.start - 1, pos.start - 1);
                    else this._movePosition(pos, true);
                    break;
                case 39:
                    e.preventDefault();
                    if (pos.start == pos.end) this._setSelection(pos.start + 1, pos.start + 1);
                    else this._movePosition(pos, false);
                    break;

                case 36:
                    // Home key 
                    e.preventDefault();
                    if (!this.showDropdown) {
                        var homecate = this._firstlastVal(true);
                        var hPos = this._getCategoryPosition(homecate);
                        if (hPos.isValid) this._setSelection(hPos.start, hPos.end);
                    }
                    else {
                        this._activeItem = 0;
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectDown(this._activeItem);
                        if (this._activeItem < this._listSize) this._activeItem += 1;
                        else
                            this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 35:
                    // End key
                    e.preventDefault();
                    if (!this.showDropdown) {
                        var endcate = this._firstlastVal(false);
                        var ePos = this._getCategoryPosition(endcate);
                        if (ePos.isValid) this._setSelection(ePos.start, ePos.end);
                    }
                    else {
                        this._activeItem = this._listSize + 1;
                        prevActiveItem = this._activeItem;
                        this._activeItem = this._disableItemSelectUp(this._activeItem - 1);
                        if (this._activeItem == 0) this._activeItem = prevActiveItem;
                        this._addListHover();
                        this._selectTimeItem(this._getActiveItem());
                    }
                    break;
                case 9:
                    if (this._getInternalEvents) break;
                    this._hideResult();
                    var flag = null;
                    if (e.shiftKey && pos.start > 0) flag = true;
                    else if (!e.shiftKey && pos.end < this.element.val().length) flag = false;
                    if (flag != null) {
                        e.preventDefault();
                        this._checkInComplete();
                        this._movePosition(pos, flag);
                    }
                    break;
                case 13:
                    if (!this.showDropdown) {
                        this._raiseChangeEvent();
                        break;
                    }
                case 27:
                    e.preventDefault();
                    this._hideResult();
                    break;
                case 8:
                case 46:
                    if (this.model.enableStrictMode) return;
                    if (this.target.value != this._getSelectedText()) {
                        e.preventDefault();
                        if (category && category != "tt") {
                            this._findCategoryPosition(category);
                            var _doBackspace = (key == 8 && pos.start != this.start), _doDelete = (key == 46 && pos.end != this.end), len;
                            len = this.end - this.start;

                            if ((pos.start != pos.end || len == 1) && (_doBackspace || _doDelete || pos.start != pos.end)) {
                                var s1 = this.start, s2 = this.end, te;
                                this.element[0].value = this._replaceAt(this.target.value, s1, s2, "__");
                                te = (s2 - s1 != 2) ? s2 + 1 : s2;
                                this._setSelection(s1, te);
                            }
                            else {
                                if (_doBackspace) {
                                    this.element[0].value = this._replaceAt(this.target.value, pos.start - 1, pos.start, "");
                                    this._setSelection(pos.start - 1, pos.start - 1);
                                }
                                else if (_doDelete) {
                                    this.element[0].value = this._replaceAt(this.target.value, pos.end, pos.end + 1, "");
                                    this._setSelection(pos.end, pos.end);
                                }
                            }
                        }

                    }
                    break;

            }

            var currSelection = this._getSelectedValue(cursor);
            var unicode = e.keyCode ? e.keyCode : e.charCode, actualkey;

            if (e.keyCode > 47 && e.keyCode < 58)
                actualkey = String.fromCharCode(unicode);
            else if (e.keyCode > 95 && e.keyCode < 106)
                actualkey = String.fromCharCode(unicode - 48);
            if (category == "tt" && ((!e.shiftKey && !e.ctrlKey && !e.altKey) && (e.keyCode > 64 && e.keyCode < 91) || (e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106))) {
                e.preventDefault();
                var ttPos = this._getCategoryPosition(category);
                this.start = ttPos.start;
                this.end = ttPos.end;
                this._changeAmPm(currSelection);
                this._raiseChangeEvent();
            }

            // Select complete text and then press time value in the textbox               
            if (this.target.value == this._getSelectedText() && (!e.shiftKey && !e.ctrlKey && !e.altKey)) {
                if (e.keyCode > 64 && e.keyCode < 91 && !this.model.enableStrictMode) e.preventDefault();
                if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106)) {
                    var cursor = this._getStartEnd(pos);
                    this._setSelection(cursor.start, cursor.end);
                }
            }

            if ((!e.shiftKey && !e.ctrlKey && !e.altKey) && (e.keyCode > 47 && e.keyCode < 58) || (e.keyCode > 95 && e.keyCode < 106)) {
                if (category != "tt") {
                    this._getMinMax(category, true);
                    if (pos.start == pos.end) {
                        this._findCategoryPosition(category);
                        var newVal;
                        if (pos.start == this.start) {
                            newVal = actualkey + currSelection;
                            if (this.model.enableStrictMode == false) {
                                this._validateTimes();
                                this._targetBlur();
                            }
                            if (this.model.value == null) this.element.val(this.model.minTime);
                            var cursor = this._getStartEnd(pos);
                            this._setSelection(cursor.start, cursor.end);
                        }
                        else {
                            newVal = currSelection + actualkey;
                        }
                        if (newVal.length > 2 || !(Number(newVal) >= this.min && this.max >= Number(newVal))) {
                            !this.model.enableStrictMode && e.preventDefault();
                        }
                    }
                    else if (!(Number(actualkey) >= this.min && this.max >= Number(actualkey))) {
                        !this.model.enableStrictMode && e.preventDefault();
                    }
                }
            }
            else if (!this._allowKeyCodes(e)) {
                !this.model.enableStrictMode ? (e.keyCode == 8 || e.keyCode == 46) ? e.stopPropagation() : e.preventDefault() : e.stopPropagation();
            }
        },

        _getSelectedText: function (e) {
            if (window.getSelection) {
                var element = $('#' + this.element[0].id).get(0);
                return element.value.substring(element.selectionStart, element.selectionEnd);
            }
                // For IE
            else return document.selection.createRange().text;
        },
        _allowKeyCodes: function (e) {
            if ((e.ctrlKey && (e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 90 || e.keyCode == 89))
                || e.keyCode == 9 || e.keyCode == 116 || e.keyCode == 13)
                return true;
            return false;
        },
        _readOnlyKeys: function (e) {
            if (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || this._allowKeyCodes(e))
                return true;
            return false;
        },

        _firstlastVal: function (initial) {
            var parts = this.model.timeFormat.split(" "), sep = this.seperator;
            if (initial) {
                if (parts[0] != "tt") return parts[0].split(sep)[0];
                return "tt";
            }
            else {
                if (parts[0] != "tt") return "tt";
                else if (parts[1]) {
                    var lastItem = parts[1].split(sep);
                    return lastItem.length ? lastItem[lastItem.length - 1] : "tt";
                }
                return "tt";
            }
        },

        _mouseWheel: function (event) {
            event.preventDefault();
            if (this.model.readOnly) return false;
            var delta, rawEvent = event.originalEvent;
            if (rawEvent.wheelDelta) {
                // IE and Opera use wheelDelta, which is a multiple of 120 (possible values -120, 0, 120).
                delta = rawEvent.wheelDelta / 120;
                // In Opera, value is negated.
                //if (Sys.Browser.agent === Sys.Browser.Opera) delta = -delta;
            }
            else if (rawEvent.detail) {
                // Firefox uses detail property, which is a multiple of 3.
                delta = -rawEvent.detail / 3;
            }
            if (delta > 0)
                this._modifyValue(true);
            else if (delta < 0)
                this._modifyValue(false);
        },

        _addListHover: function () {
            this._addSelected();
            this._updateScrollTop();
        },
        _addSelected: function () {
            this.ul.find("li").removeClass("e-active e-hover");
            var activeItem = this._getActiveItem();
            if (activeItem.length && !activeItem.hasClass('e-disable'))
                activeItem.addClass('e-active');
        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0)
                    return current;
                else
                    return this._disableItemSelectDown(current + 1);
            }
            else return this._listSize;
        },

        _disableItemSelectUp: function (current) {
            current = current - 1;
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0)
                    return current + 1;
                else if (current > 0)
                    return this._disableItemSelectUp(current);
            }
            return 0;
        },
        _getActiveItem: function () {
            return $(this.ul.find("li")[this._activeItem - 1]);
        },

        _timeIconClick: function (event) {
            if (ej.isNullOrUndefined(this.popupList)) {
                this._renderDropdown();
                this._addProperty();
            };
            var isRightClick = false;
            if (event.button)
                isRightClick = (event.button == 2);
            else if (event.which)
                isRightClick = (event.which == 3); //for Opera
            if (isRightClick) return;
            event.preventDefault();
            if (!this.model.enabled || this.model.readOnly || this.ul.find("li").length < 1) return false;
            this._showhidePopup();
            var len = this.element.val().length;
            if (!ej.isTouchDevice()) this._setSelection(len, len);
        },
        _showhidePopup: function () {
            if (this._getInternalEvents) return false;
            if (!this.showDropdown)
                this._showResult();
            else
                this._hideResult();
        },
        _showResult: function () {
            if (this.popupList == null) this._renderDropdown();
            this._raiseEvent("beforeOpen");
            this._refreshPopup();
            if (!this.focused && (!ej.isTouchDevice())) this._focusElement();
            if (this.model.value) this._changeActiveEle();
            else
                this.ul.find("li").removeClass("e-active");

            var proxy = this, sTop = this._vissibleAndCalculateTop();
            this.popupList.slideDown(this.model.enableAnimation ? 200 : 0, function () {
                $(document).on("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
            });
            this.scrollerObj.setModel({ "scrollTop": sTop });
			this.scrollerObj.refresh();
            this.showDropdown = true;
            this._listSize = this.ul.find("li").length;
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._on(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this._raiseEvent("open");
            this.wrapper.addClass("e-active");
        },
        _hideResult: function (e) {
			if ( e && (e.type == "touchmove" || e.type== "scroll")) {
				if ($(e.target).parents("#"+this.popupList[0].id).length > 0)
			   return;
			}           
			if (this.showDropdown && !this._getInternalEvents) {
			this.showDropdown = false;
			this.popupList.slideUp(this.model.enableAnimation ? 100 : 0);
			$(document).off("mousedown", $.proxy(this._OnDocumentClick, this));
			$(window).off("resize", $.proxy(this._OnWindowResize, this));
			this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
			this._off(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
			this._raiseEvent("close");
			this.wrapper.removeClass("e-active");
            }
        },

        _vissibleAndCalculateTop: function () {
            this.popupList.css({ "display": "block" });
            var scrollTop = this._calcScrollTop();
            this.popupList.css({ "display": "none" });
            return scrollTop;
        },
        _calcScrollTop: function () {
            var ulH = this.ul.outerHeight(), liH = this.ul.find("li").outerHeight(), index, top;
            index = this.ul.find("li.e-active").index();
            top = (liH * index) - ((this.popupList.outerHeight() - liH) / 2);
            return top;
        },
        _changeActiveEle: function () {
            if (!this.model.showPopupButton || !this.popupList) return false;
            var elements = this.ul.find("li");
            var currTime = this.element.val(), firstTime = elements.first().html(), index;
            index = (this._parse(currTime) - this._parse(firstTime)) / (this.model.interval * 60000);
            index = Math.round(index);
            this._activeItem = (index == elements.length) ? index : index + 1;
            if (this._activeItem < 0 || this._activeItem > elements.length || isNaN(this._activeItem) || this._ensureTimeRange(currTime)) this._activeItem = 0;
            this._addListHover();
        },

        _OnDocumentClick: function (e) {
            if (!$(e.target).is(this.popupList) && !$(e.target).parents(".e-time-popup").is(this.popupList) &&
                !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-timewidget").is(this.wrapper)) {
                this._hideResult();
            }
            else if ($(e.target).is(this.popupList) || $(e.target).parents(".e-time-popup").is(this.popupList))
                e.preventDefault();
        },
        _OnWindowResize: function (e) {
            this._refreshPopup();
        },

        _OnMouseEnter: function (e) {
            var targetEle = e.target;
            this.ul.find("li").removeClass("e-hover");
            if (!$(targetEle).hasClass('e-disable'))
                $(targetEle).addClass("e-hover");
        },
        _OnMouseLeave: function (e) {
            if (!this._dateTimeInternal || this.model.value)
                this.ul.find("li").removeClass("e-hover");
        },
        _OnMouseClick: function (e) {
            e.preventDefault();
            if ($(e.target).hasClass('e-disable')) return;
            if (this.model.enabled && !this.model.readOnly) {
                this._activeItem = $(e.target).index() + 1;
                this.ul.find("li").attr({ 'tabindex': -1, 'aria-selected': false });
                $(e.target).attr({ 'aria-selected': true, 'tabindex': 0 });
                this._addSelected();
                this._selectTimeItem($(e.target));
            }
            this._showhidePopup();
        },
        _selectTimeItem: function (ele) {
            this._beforeChange(ele);
            var flag = this._raiseChangeEvent();
            if (flag)
                this._trigger("select", { value: this.model.value, prevTime: this._previousValue });
        },

        _findCategoryPosition: function (category) {
            if (category == "least") category = this._getLeast(true);
            var pos = this._getCategoryPosition(category);
            this.start = pos.start;
            this.end = pos.end;
        },

        _getLeast: function (lower) {
            var formats = this.model.timeFormat.split(" "), sep = this.seperator, res = null;
            $(formats).each(function (i, e) {
                if (e != "tt") {
                    var times = e.split(sep);
                    if (lower) res = times[times.length - 1];
                    else res = times[0];
                }
            });
            return res;
        },

        _changeValue: function (cursor, isIncrement) {
            var preVal = this.target.value, currValue, category = this._getCategory(cursor);
            if (!category) return false;
            this._setSelection(this.start, this.end);
            currValue = this.target.value.substring(this.start, this.end);
            if (this._checkMinMax(this.target.value)) {
                if (currValue != this.ttAM && currValue != this.ttPM) {
                    currValue = this._changeCurrentValue(currValue, category, isIncrement);
                    if (category.length != 1) currValue = this._changeWhole(currValue);
                    this._findCategoryPosition(category);
                    this.element.val(this._replaceAt(this.target.value, this.start, this.end, currValue));
                    this.end = this.start + currValue.toString().length;
                    this._setSelection(this.start, this.end);
                    if (this._ensureTimeRange(this.target.value) && this._checkMinMax(this.target.value)) {
                        var timeObject = this._createObject(this.target.value);
                        var hour = timeObject.getHours();
                        var fromTime = isIncrement ? this._startTime : this._endTime;
                        var toTime = isIncrement ? this._endTime : this._startTime;
                        if (!ej.isNullOrUndefined(this.model.disableTimeRanges)) {
                            for (i = 0; i < this.model.disableTimeRanges.length; i++) {
                                if ((fromTime[i].getHours() === hour) || ((+timeObject >= +this._startTime[i]) && +timeObject <= +this._endTime[i])) {
                                    this.target.value = this._localizeTime(toTime[i]);
                                    this._findCategoryPosition(category);
                                    this._setSelection(this.start, this.end);
                                    this._changeValue(cursor, isIncrement);
                                }
                            }
                        }
                    }
                }
                else this._changeAmPm(currValue);
            }
            else {
                var timeValue = this._checkExceedRange(this.target.value);
                this._setTime(this.model[timeValue]);
                this._findCategoryPosition(category);
                this._setSelection(this.start, this.end);
            }
            if (!this._checkMinMax(this.target.value)) {
                this.element.val(this.model.value);
                this._findCategoryPosition(category);
                this._setSelection(this.start, this.end);
            }
            else this._raiseChangeEvent();
        },

        _checkMinMax: function (value) {
            var res = this._checkExceedRange(value);
            if (res == null) res = false;
            return !res;
        },
        _checkExceedRange: function (value) {
            if (value) {
                if (this.model.minTime && !this._compareTime(value, this.model.minTime, true)) return "minTime";
                if (this.model.maxTime && !this._compareTime(this.model.maxTime, value, true)) return "maxTime";
            }
            return null;
        },

        _changeWhole: function (currValue) {
            return currValue > 9 ? "" + currValue : "0" + currValue;
        },
        _changeAmPm: function (ampm) {
            ampm = ampm == this.ttAM ? this.ttPM : this.ttAM;
            this.element.val(this._replaceAt(this.target.value, this.start, this.end, ampm));
            this._setSelection(this.start, this.end);
        },
        _changeMinute: function (isIncrement) {
            var formats = ["mm", "m"];
            var currFormat = this._getExactFormat(formats);
            if (currFormat) {
                this._findCategoryPosition(currFormat);
                var minute = Number(this.target.value.substring(this.start, this.end));
                this._getMinMax(currFormat);
                if (isIncrement) {
                    if (minute == this.max) {
                        minute = this.min;
                        this._changeHour(isIncrement);
                    }
                    else minute += 1;
                }
                else {
                    if (minute == this.min) {
                        minute = this.max;
                        this._changeHour(isIncrement);
                    }
                    else minute -= 1;
                }
                this._findCategoryPosition(currFormat);
                if (currFormat.length != 1) minute = this._changeWhole(minute);
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, minute));
            }
        },
        _changeHour: function (isIncrement) {
            var formats = ["hh", "h", "HH", "H"];
            var currFormat = this._getExactFormat(formats);
            if (currFormat) {
                this._findCategoryPosition(currFormat);
                var hour = Number(this.target.value.substring(this.start, this.end));
                this._getMinMax(currFormat);
                if (isIncrement) {
                    if (hour == this.max) {
                        hour += 1;
                        this._changeMeridian();
                    }
                    else if (hour > this.max) hour = this.min;
                    else hour += 1;
                }
                else {
                    if (hour == this.min) hour = this.max + 1;
                    else if (hour > this.max) {
                        hour = this.max;
                        this._changeMeridian();
                    }
                    else hour -= 1;
                }
                this._findCategoryPosition(currFormat);
                if (currFormat.length != 1) hour = this._changeWhole(hour);
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, hour));
            }
        },
        _getExactFormat: function (cate) {
            var tFormat = this.model.timeFormat;
            for (var i = 0; i < cate.length; i++) {
                if (tFormat.indexOf(cate[i]) != -1) return cate[i];
            }
            return null;
        },
        _changeMeridian: function () {
            var start = this.model.timeFormat.indexOf("tt");
            if (start != -1) {
                this._findCategoryPosition("tt");
                var meridian = this.target.value.substring(this.start, this.end);
                meridian = (meridian == this.ttAM) ? this.ttPM : this.ttAM;
                this.element.val(this._replaceAt(this.target.value, this.start, this.end, meridian));
            }
        },
        _changeCurrentValue: function (current, category, isIncrement) {
            current = Number(current);
            var c = category, step = 1, change = true;
            this._getMinMax(c);

            if (c == "hh" || c == "h" || c == "HH" || c == "H") step = this.model.hourInterval;
            else if (c == "mm" || c == "m") step = this.model.minutesInterval;
            else if (c == "ss" || c == "s") step = this.model.secondsInterval;
            if (step <= 0) return current;

            if (isIncrement) {
                if ((c == "hh" || c == "h") && current > this.max) current = this.min - 1 + step;
                else if (current < this.max) current += step;
                else {
                    change = false;
                    if (c != "hh" && c != "h") current = this.min - 1 + step;
                    else current += step;
                    this._changeAdjacent(c, isIncrement);
                }
                if ((c == "hh" || c == "h") && current == this.max + 1)
                    change && this._changeAdjacent(c, isIncrement);
                else if (current > this.max + 1) {
                    current = current - (this.max + 1);
                    change && this._changeAdjacent(c, isIncrement);
                }
                if ((c != "hh" && c != "h") && current == this.max + 1) {
                    current = this.min;
                    change && this._changeAdjacent(c, isIncrement);
                }
            }
            else {
                if ((c != "hh" && c != "h") && current > this.min) current -= step;
                else if ((c == "hh" || c == "h") && current > this.min && current <= this.max) current -= step;
                else if ((c == "hh" || c == "h") && current == this.min) current = this.max + 2 - step;
                else {
                    change = false;
                    current = this.max + 1 - step;
                    this._changeAdjacent(c, isIncrement);
                }
                if (current < this.min) {
                    current = current + (this.max + 1);
                    change && this._changeAdjacent(c, isIncrement);
                }
            }
            return current;
        },
        _changeAdjacent: function (c, isIncrement) {
            if (c == "ss" || c == "s") this._changeMinute(isIncrement);
            else if (c == "mm" || c == "m") this._changeHour(isIncrement);
            else if (c == "hh" || c == "h" || c == "HH" || c == "H") this._changeMeridian();
        },

        _valueChange: function (e) {
            this._raiseChangeEvent();
        },

        _beforeChange: function (ele) {
            if (!this._raiseEvent("beforeChange")) {
                this.element.val(ele.text());
            }
            return true;
        },

        _raiseChangeEvent: function (prev, isCode) {
            prev = (prev === undefined) ? this.model.value : prev;
            this._previousValue = prev;
            var current = !this.target.value ? null : this.target.value;
            if (prev == current) return false;
            if (this._checkMinMax(this.target.value) && this._isValid(this.target.value, this.model.enableStrictMode) || !this.target.value) this.isValidState = true;
            else this.isValidState = false;
            this.model.value = this._isValid(this.target.value, true) && this._checkMinMax(this.target.value) ? this.target.value : null;
            if (!this.model.value && !this.model.enableStrictMode) this._setTime(this.model.value);
            if (this.model.value == this._previousValue) return false;
            this._raiseEvent("change", isCode);
            this._raiseEvent("_change", isCode);
            return true;
        },
        _raiseEvent: function (name, isCode) {
            var data = { value: this.model.value, prevTime: this._previousValue };
            if (name == "change") data.isInteraction = !isCode;
            return (this._trigger(name, data));
        },
        _checkIE7: function () {
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})"), version = -1;
                if (re.exec(navigator.userAgent) != null)
                    version = parseFloat(RegExp.$1);
                if (version >= 7 && version < 8) return true;
            }
            return false;
        },
        _replaceAt: function (mainString, from, to, replace) {
            return mainString.substring(0, from) + replace + mainString.substring(to);
        },
        _localizeTime: function (value) {
            if (value)
                return $.trim(ej.format(this._createObject(value), this.model.timeFormat, this.model.locale));
            return null;
        },
        _localizeMeridian: function (value) {
            return $.trim(ej.format(value, "tt", this.model.locale));
        },
        _compareTime: function (time1, time2, orEqual) {
            orEqual = (!orEqual) ? false : true;
            if (orEqual) return this._parse(time1) >= this._parse(time2);
            else return this._parse(time1) > this._parse(time2);
        },
        _isValid: function (time, validate) {
            time = this._createObject(time, validate);
            return time && typeof time.getTime === "function" && isFinite(time.getTime());
        },
        _parse: function (time) {
            return Date.parse(this._createObject(time));
        },
        _setEmptyDate: function (date) {
            var newDate = new Date(date);
            newDate.setDate(1);
            newDate.setMonth(0);
            newDate.setFullYear(2000);
            return newDate;
        },
        _createObject: function (value, validate) {
            var obj = null;
            if (typeof value === "string") {
                var format = this._setModelOption ? this._preTimeformat : this.model.timeFormat;
                var dateFormat = ej.preferredCulture(this.model.locale).calendar.patterns.d;
                var dateValue = ej.format(new Date("1/1/2000"), dateFormat, this.model.locale);
                obj = ej.parseDate(dateValue + " " + value, dateFormat + " " + format, this.model.locale);
                if (this._extISORegex.exec(value) || this._basicISORegex.exec(value)) this.model.value = obj = this._timeFromISO(value);
                this._setModelOption = false;
                if (!obj) {
                    var isJSONString = new Date(value);
                    if (!isNaN(Date.parse(isJSONString)) && !ej.isNullOrUndefined(value))
                        obj = this._setEmptyDate(value);
                    else
                        obj = !this._dateTimeInternal || value == "" ? null : new Date("1/1/2000 " + value);
                }
            }
            else if (typeof value === "number")
                obj = new Date(value);
            else if (value instanceof Date)
                obj = this._setEmptyDate(value);

            if (obj && !this._dateTimeInternal && validate) {
                var timeVal = this._localizeTime(obj);
                if (this._ensureTimeRange(timeVal))
                    obj = null;
            }
            return obj;
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },

        _wireEvents: function () {
            this._on(this.element, "focus", this._targetFocus);
            this._on(this.element, "blur", this._targetBlur);
            this._on(this.element, "mousedown", this._mouseDownOnInput);
            this._on(this.element, "keydown", this._keyDownOnInput);
            this._on(this.element, "keyup", this._keyUpOnInput);
        }
    });
    ej.TimePicker.Locale = ej.TimePicker.Locale || {};

    ej.TimePicker.Locale['default'] = ej.TimePicker.Locale['en-US'] = {
        watermarkText: "select a time",
    };
    
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to select the date and time values.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDateTimePicker", "ej.DateTimePicker", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        _rootCSS: "e-datetimepicker",
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },
        _requiresID: true,


        defaults: {

            cssClass: "",

            locale: "en-US",

            readOnly: false,

            showRoundedCorner: false,

            enableRTL: false,

            htmlAttributes: {},
            allowEdit: true,

            enabled: true,

            value: "",

            name: null,

            minDateTime: new Date("1/1/1900 12:00:00 AM"),

            maxDateTime: new Date("12/31/2099 11:59:59 PM"),

            height: "",

            width: "",

            dateTimeFormat: "",

            showPopupButton: true,

            enableStrictMode: false,

            buttonText: {

                today: "Today",

                timeNow: "Time Now",

                done: "Done",

                timeTitle: "Time"
            },

            watermarkText: "Select datetime",

            enablePersistence: false,

            interval: 30,

            timeDisplayFormat: "",

            timePopupWidth: 105,
            popupPosition: "bottom",

            dayHeaderFormat: "short",

            startLevel: "month",

            depthLevel: "",

            startDay: -1,

            stepMonths: 1,

            showOtherMonths: true,

            enableAnimation: true,

            headerFormat: 'MMMM yyyy',

            validationRules: null,

            validationMessage: null,

            validationMessages: null,
            timeDrillDown: {
                enabled: false,
                interval: 5,
                showMeridian: false,
                autoClose: true,
                showFooter: true
            },

            beforeOpen: null,

            beforeClose: null,

            open: null,

            close: null,

            change: null,

            create: null,

            destroy: null,

            focusIn: null,

            focusOut: null,

            disableDateTimeRanges: null,

           
        },


        dataTypes: {
            allowEdit: "boolean",
            cssClass: "string",
            locale: "string",
            readOnly: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            enabled: "boolean",
            enableAnimation: "boolean",
            dateTimeFormat: "string",
            showPopupButton: "boolean",
            buttonText: "data",
            watermarkText: "string",
            enablePersistence: "boolean",
            enableStrictMode: "boolean",
            interval: "number",
            timeDrillDown: "data",
            timeDisplayFormat: "string",
            dayHeaderFormat: "string",
            startLevel: "string",
            depthLevel: "string",
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            headerFormat: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data",
            disableDateTimeRanges: "data"
        },

        _setModel: function (options) {
            if (!this.popup) this._renderDropdown();
            var option, validate = false;
            for (option in options) {
                switch (option) {
                    case "allowEdit": this._changeEditable(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "locale": this._localize(options[option]); break;
                    case "readOnly": this._readOnly(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "enableRTL": this._setRtl(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "value":
                        options[option] = this._setValue(options[option]);
                        if (this._specificFormat())
                            this._stopRefresh = true
                        validate = true;
                        this._prevDateTime = this._prevDateTimeVal || this._preVal;
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = options[option];
                        validate = true;
                        break;
                    case "minDateTime":
                        var temp = this._stringToObject(options[option]);
                        var mintime = this._getFormat(temp, this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("minDate", temp);
                            if(this.datePicker.model.value && this.datePicker.model.value.toDateString() == this.datePicker.model.minDate.toDateString() )this.timePicker.option("minTime", mintime);
                            options[option] = temp;
                            this.model.minDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true;
                        break;
                    case "maxDateTime":
                        var temp = this._stringToObject(options[option]);
                        var maxtime = this._getFormat(options[option], this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("maxDate", temp);
                            if(this.datePicker.model.value && this.datePicker.model.value.toDateString() == this.datePicker.model.maxDate.toDateString() )this.timePicker.option("maxTime", maxtime);
                            options[option] = temp;
                            this.model.maxDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true; break;
                    case "height": this.wrapper.height(options[option]); break;
                    case "width": this.wrapper.width(options[option]); break;
                    case "dateTimeFormat":
                        this.model.dateTimeFormat = options[option];
                        if (this.isValidState) this._setValue(this.model.value);
                        break;
                    case "showPopupButton": this._showButton(options[option]); break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options[option] = this.model.watermarkText = options[option];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "buttonText":
                        if (!ej.isNullOrUndefined(this._options))
                            this._options["buttonText"] = this.model.buttonText = options[option];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._buttonText(options[option]); break;
                    case "interval":
                        this._updateTimeHeight();
                        this.timePicker.option("interval", options[option]); break;
                    case "timeDisplayFormat":
                        this._updateTimeHeight();
                        this.timePicker.option("timeFormat", options[option]); break;
					case "disableDateTimeRanges": 
					if(this._disabledDate) this._disabledDates = false;
					this.model.disableDateTimeRanges = (options[option]);
					this._setValue(this.model.value);
					break;
                    case "timePopupWidth":
                        this._updateTimeHeight();
                        var width = options[option];
                        if ((typeof (width) == "string" && width.indexOf("%") != -1) || typeof (width) == "string" )  options[option] = parseInt(width) > 0 ? width : 105;
                        else {
                            options[option] = width > 0 ? width : 105;
                        }
                        this.timePicker.option("popupWidth", options[option]);
                        break;
                    case "dayHeaderFormat": this.datePicker.option("dayHeaderFormat", options[option]); break;
                    case "startLevel": this.datePicker.option("startLevel", options[option]); break;
                    case "depthLevel": this.datePicker.option("depthLevel", options[option]); break;
                    case "startDay": this.datePicker.option("startDay", options[option]);
                        this.model.startDay = this.datePicker.model.startDay;
                        options[option] = this.model.startDay; break;
                    case "stepMonths": this.datePicker.option("stepMonths", options[option]); break;
                    case "showOtherMonths": this.datePicker.option("showOtherMonths", options[option]); break;
                    case "headerFormat": this.datePicker.option("headerFormat", options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "popupPosition": this.model.popupPosition = options[option]; this._setListPosition(); break;
                    case "timeDrillDown":

                        // For timeDrillDown.enabled
                        if (!ej.isNullOrUndefined(options[option].enabled)) {
                            this.model.timeDrillDown.enabled = options[option].enabled; this._changeDesign();
                        }

                        // For timeDrillDown.interval
                        if (!ej.isNullOrUndefined(options[option].interval)) {
                            this.model.timeDrillDown.interval = options[option].interval;
                            this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));
                        }

                        // For timeDrillDown.showMeridian
                        if (!ej.isNullOrUndefined(options[option].showMeridian)) {
                            this.model.timeDrillDown.showMeridian = options[option].showMeridian;
                            this._sfTimeHour.empty(); this._renderHourTable();
                        }

                        // For timeDrillDown.showFooter
                        if (!ej.isNullOrUndefined(options[option].showFooter)) {
                            this.model.timeDrillDown.showFooter = options[option].showFooter;
                            this._changeDesign();
                        }
                        break;

                }
            }
            if (validate) this._validateMinMax();
            this._valueChange(true);
            if (option == "value") options[option] = this.model.value;
            this._updateTimeHeight();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.isPopupOpen)
                this._hideResult();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
            this._cloneElement.removeClass("e-js e-input").removeClass(ej.util.getNameSpace(this.sfType));
            this._cloneElement.insertAfter(this.element);
            this.element.remove();
            if (!ej.isNullOrUndefined(this.datePicker))
                this.datePicker.destroy();
            if (!ej.isNullOrUndefined(this.timePicker))
                this.timePicker.destroy();
            if(this.popup)this.popup.remove();
        },
        _initDisableTimeRanges: function (currvalue) {
            var value = this._getDateObj(currvalue, this.datePicker.model.dateFormat);
                for (var i = 0; i < this.model.disableDateTimeRanges.length; i++) {
					if(ej.isNullOrUndefined(this.model.disableDateTimeRanges[i].endDateTime)) this.model.disableDateTimeRanges[i].endDateTime = this.model.disableDateTimeRanges[i].startDateTime;
					if(this.model.disableDateTimeRanges[i].startDateTime instanceof Date || this.model.disableDateTimeRanges[i].endDateTime instanceof Date){
						var sdate = this._getFormat(this.model.disableDateTimeRanges[i].startDateTime, this.datePicker.model.dateFormat);
						var edate = this._getFormat(this.model.disableDateTimeRanges[i].endDateTime, this.datePicker.model.dateFormat);
					}
                    else{
						var sdate = this.model.disableDateTimeRanges[i].startDateTime.split(' ')[0];
						var edate = this.model.disableDateTimeRanges[i].endDateTime.split(' ')[0];
					}
                    var startval = new Date(this.model.disableDateTimeRanges[i].startDateTime);
                    var endval = new Date(this.model.disableDateTimeRanges[i].endDateTime);
                    if (sdate == edate) {
                        if (this._compare(value, this._setEmptyTime(this.model.disableDateTimeRanges[i].startDateTime))) {
                            var stime = this._getFormat(startval, this.timePicker.model.timeFormat);
                            var etime = this._getFormat(endval, this.timePicker.model.timeFormat);
                            var values = [];
                            values.push({ startTime: stime, endTime: etime });
                            this.timePicker.option("disableTimeRanges", values);
							return;
                        }
                        else
                            this.timePicker.option("disableTimeRanges", this._defaultMinVal());
					if(!this._disabledDates && this.model.disableDateTimeRanges[i].endDateTime == this.model.disableDateTimeRanges[i].startDateTime){
						if(this.model.disableDateTimeRanges[i].endDateTime instanceof Date == false){
							if((this._getFormat(this.model.disableDateTimeRanges[i].endDateTime,this.model.dateTimeFormat) == this._getFormat(this.model.disableDateTimeRanges[i].endDateTime,this.model.dateFormat) && ej.isNullOrUndefined(this.model.disableDateTimeRanges[i].endDateTime.split(' ')[1]))){
									this._between.push(new Date(this.model.disableDateTimeRanges[i].endDateTime));
								}
						}
					}
                   }
                    else if (sdate != edate) {                            
						if (this._compare(value, this._setEmptyTime(this.model.disableDateTimeRanges[i].startDateTime))||this._compare(value, this._setEmptyTime(this.model.disableDateTimeRanges[i].endDateTime))) {
							var stime = this.timePicker.model.minTime,etime = this.timePicker.model.maxTime;
                            if(this.datePicker.model.value.toDateString() == new Date(this.model.disableDateTimeRanges[i].startDateTime).toDateString()) stime = this._getFormat(new Date(this.model.disableDateTimeRanges[i].startDateTime), this.timePicker.model.timeFormat);
                            if(this.datePicker.model.value.toDateString() == new Date(this.model.disableDateTimeRanges[i].endDateTime).toDateString()) etime = this._getFormat(new Date(this.model.disableDateTimeRanges[i].endDateTime), this.timePicker.model.timeFormat);
                            var values = [];
                            values.push({ startTime: stime, endTime: etime });
                            this.timePicker.option("disableTimeRanges", values);
							return;
                        }
						if(!this._disabledDates){
							var stime = this._getFormat(new Date(this.model.disableDateTimeRanges[i].startDateTime), this.timePicker.model.timeFormat);
							var etime = this._getFormat(new Date(this.model.disableDateTimeRanges[i].endDateTime), this.timePicker.model.timeFormat);
							if(stime == this.timePicker.model.minTime){
								this._between.push(new Date(this.model.disableDateTimeRanges[i].startDateTime));
							}
							if(this.model.disableDateTimeRanges[i].endDateTime instanceof Date == false){
								if(this._getFormat(this.model.disableDateTimeRanges[i].endDateTime,this.model.dateTimeFormat) == this._getFormat(new Date(this.model.disableDateTimeRanges[i].endDateTime), this.datePicker.model.dateFormat)){
									etime = this.timePicker.model.maxTime;
								}
							}
							if(etime == this.timePicker.model.maxTime){
								this._between.push(new Date(this.model.disableDateTimeRanges[i].endDateTime));
							}
						}
                    }

            }
        },
		_disableBetweenDates: function(){
			for (var i = 0; i < this.model.disableDateTimeRanges.length; i++) {
					var datePickedStr1 = this.model.disableDateTimeRanges[i].startDateTime;
                    var datePickedDate1 = this._setEmptyTime(datePickedStr1);
					var startDateTimeVal = this._getFormat(new Date(this.model.disableDateTimeRanges[i].startDateTime), this.timePicker.model.timeFormat);
                    var endDateTimeVal = this._getFormat(new Date(this.model.disableDateTimeRanges[i].endDateTime), this.timePicker.model.timeFormat);
                    var datePickedStr2 = this.model.disableDateTimeRanges[i].endDateTime;
                    var datePickedDate2 = this._setEmptyTime(datePickedStr2);
                        while (datePickedDate1 < datePickedDate2) {
                           datePickedDate1.setDate(datePickedDate1.getDate() + 1);
							if(new Date(datePickedDate1) < datePickedDate2){
								this._between.push(new Date(datePickedDate1));
								}
                        }
					
			}
			this._datesDisabled = true;
		},
        _init: function (options) {
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            this._options = options;
            this._cloneElement = this.element.clone();
            this._ISORegex();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._validateMeridian();
            this._checkAttribute();
            this._initialize();
            this._initial = true;
            this._interval = 60;
            this._render();
            this._wireEvents();
            this._addAttr(this.model.htmlAttributes);
            if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
                this.model.validationMessages = this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
			this._removeWatermark();
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },
        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },
        _changeDesign: function () {
            if (this.model.timeDrillDown.enabled) {
                var state = this.model.timeDrillDown.showFooter ? "block" : "none";
                this.popup.addClass("e-drill-down");
                this._timeContainer.css("display", "none");
                this._buttonContainer.css("display", "none");
                this.datePicker.option("showFooter", this.model.timeDrillDown.showFooter);
                $('.e-footer', this._sfTimeHour).css("display", state);
                $('.e-footer', this._sfTimeMins).css("display", state);
            }
            else {
                this.popup.removeClass("e-drill-down");
                this._sfTimeHour.hide();
                this._sfTimeMins.hide();
                this._updateTimeHeight();
                this._dateContainer.show();
                this._timeContainer.show();
                this._buttonContainer.show();
                this.datePicker.option("showFooter", false);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },
        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _checkAttribute: function () {
            this.model.value = this.model.value === "" ? this.element[0].value : this.model.value;
            if (!this._options.minDateTime) this.model.minDateTime = this.element[0].min;
            if (!this._options.maxDateTime) this.model.maxDateTime = this.element[0].max;
            if (ej.isNullOrUndefined(this._options.readOnly)) this.model.readOnly = this.element.is("[readonly]");
            if (ej.isNullOrUndefined(this._options.enabled)) this.model.enabled = !this.element.is("[disabled]");
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
		_validateDisableRanges: function(){
			for (var i = 0; i < this.model.disableDateTimeRanges.length; i++) {
				var tempValue = this.model.value;
				if(new Date(this.model.value).getTime() >= new Date(this.model.disableDateTimeRanges[i].startDateTime).getTime() && new Date(this.model.value).getTime() <= new Date(this.model.disableDateTimeRanges[i].endDateTime).getTime()) this.model.value = null;
				if(this.model.value == null && tempValue !=null && this.model.enableStrictMode) this.isValidState = false;	
				if(this.isValidState) this.element.val(this._getFormat(this.model.value,this.model.dateTimeFormat));
			}
		},
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled") proxy._enabled(false);
                else if (keyName == "readOnly") proxy._readOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], keyName)) proxy.element.attr(keyName, value);
                else proxy.wrapper.attr(keyName, value);
            });
        },
        _validateMeridian: function () {
            var culture = ej.preferredCulture(this.model.locale);
            if (culture) this.model.locale = culture.name == "en" ? "en-US" : culture.name;
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.timeDrillDown)) {
                    if (ej.isNullOrUndefined(this._options.timeDrillDown.showMeridian))
                        this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
                }
                else this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
            }
            else
                this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
        },
        _initialize: function () {
            var val;
            this.popup = null;
            this.isPopupOpen = false;
            this.isValidState = true;
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            if (this.model.startDay == -1) this.model.startDay = ej.preferredCulture(this.model.locale).calendar.firstDay;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            if (!this.model.dateTimeFormat || !this.model.timeDisplayFormat) this._getDateTimeFormat();
            if (!this.model.value || (typeof JSON === "object" && JSON.stringify(this.model.value) === "{}")) val = null;
            else if (!(this.model.value instanceof Date)) {
                var dateTimeObj = ej.parseDate(this.model.value, this.model.dateTimeFormat, this.model.locale);
                val = dateTimeObj ? dateTimeObj : (dateTimeObj = this._checkJSONString(this.model.value)) ? dateTimeObj : null;
            }
            else val = this.model.value;
            if (val) this.model.value = val;
            var min = this.model.minDateTime = this._stringToObject(this.model.minDateTime);
            if (!min || !this._isValidDate(min)) this.model.minDateTime = this.defaults.minDateTime;
            var max = this.model.maxDateTime = this._stringToObject(this.model.maxDateTime);
            if (!max || !this._isValidDate(max)) this.model.maxDateTime = this.defaults.maxDateTime;
        },
        _checkJSONString: function (dateTimeString) {
            // Validate the string value
            var dateTimeObj = new Date(dateTimeString);
            if (!isNaN(Date.parse(dateTimeObj))) {
                if ((dateTimeObj.toJSON() === this.model.value) || (dateTimeObj.toGMTString() === this.model.value) ||
                    (dateTimeObj.toISOString() === this.model.value) || (dateTimeObj.toLocaleString() === this.model.value) ||
                    (dateTimeObj.toString() === this.model.value) || (dateTimeObj.toUTCString() === this.model.value))
                    return dateTimeObj;
                else if (typeof dateTimeString == "string") return this._dateFromISO(dateTimeString);
            } else if (this._extISORegex.exec(dateTimeString) || this._basicISORegex.exec(dateTimeString)) return this._dateFromISO(dateTimeString);
        },
        _render: function () {
            this._renderWrapper();
            this._renderIcon();
            this._setDimentions();
            this._checkProperties();
        },

        _renderWrapper: function () {
            this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', "tabindex": "0", 'role':'combobox','aria-expanded':'false' });
            this.wrapper = ej.buildTag("span.e-datetime-wrap e-widget " + this.model.cssClass + "#" + this.element[0].id + "_wrapper").insertAfter(this.element);
            this._setValue(this.model.value);
            this.wrapper.attr("style", this.element.attr("style"));
            this.element.removeAttr("style");
            if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isSupport) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport && this._hiddenInput)
                this._hiddenInput.css("display", "none");
        },
        _renderIcon: function () {
            if (!this.model.showPopupButton) return false;
            this.datetimeIcon = ej.buildTag("span.e-select", "", {}).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var icon = ej.buildTag("span.e-icon e-datetime", "", {}, { "aria-label": "select" }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.datetimeIcon.append(icon);
            this.container.append(this.datetimeIcon).addClass("e-padding");
            this._on(this.datetimeIcon, "click", this._iconClick);
            this._on(this.datetimeIcon, "mousedown", function (e) { e.preventDefault(); });
        },
        _setDimentions: function () {
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this.wrapper.height(this.model.height);
            this.wrapper.width(this.model.width);
        },

        _renderDropdown: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popup = ej.buildTag("div.e-datetime-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.element[0].id + "_popup").css("visibility", "hidden");
            if (!ej.isTouchDevice()) this.popup.addClass('e-ntouch');
            $('body').append(this.popup);
            this._renderControls();

            var _timeTitle, _dateContainer, popupContainer, _today, _now, _done;

            _timeTitle = ej.buildTag("div.e-header", this._localizedLabels.buttonText.timeTitle).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._dateContainer = ej.buildTag("div.e-datecontainer").append(this.datePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._timeContainer = ej.buildTag("div.e-timecontainer").append(_timeTitle, this.timePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._drillDownContainer = ej.buildTag("div.e-drillDowncontainer").append().attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            popupContainer = ej.buildTag("div.e-popup-container").append(this._dateContainer, this._timeContainer, this._drillDownContainer).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            _today = ej.buildTag("div.e-dt-button e-dt-today e-btn e-select e-flat", this._localizedLabels.buttonText.today).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _now = ej.buildTag("div.e-dt-button e-dt-now e-btn e-select e-flat", this._localizedLabels.buttonText.timeNow).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _done = ej.buildTag("div.e-dt-button e-dt-done e-btn e-select e-flat", this._localizedLabels.buttonText.done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._buttonContainer = ej.buildTag("div.e-button-container").append(_today, _now, _done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._renderDrillDown();
            this.popup.append(popupContainer, this._buttonContainer);
            this._checkForResponsive();
            this._updateTimeHeight();

            this._bindOperations();
            this._updateValues();
            this.popup.css({ "visibility": "visible", "display": "none" });

            this._on(_today, "click", this._todayClick);
            this._on(_now, "click", this._nowClick);
            this._on(_done, "click", this._doneClick);
            this.popup.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
            this.popup.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));
            this._changeDesign();
        },
        _renderControls: function () {
            this._renderDateControl();
            this._renderTimeControl();
            var tempContainer = ej.buildTag("span").append(this.datePicker.wrapper, this.timePicker.wrapper);
            tempContainer.find("span").css("display", "none");
            this.popup.append(tempContainer);
        },
        _renderDrillDown: function () {
            this._renderHourPopup();
            this._renderMinsPopup();
        },
        _renderHourPopup: function () {
            var table;
            this._sfTimeHour = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-hours ', "", {}, { id: (this._id ? 'e-hours-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeHour.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeHour);
            this._renderHourTable();
        },
        _renderHourTable: function () {
            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-headertext").text("October 2015").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeHour);

            // Render meridian calendar popup.
            if (this._interval < 1) return false;
            var start, end, timeVal, rowCount, table, tr, interval = this._interval * 60000;
            var tableCount = this.model.timeDrillDown.showMeridian ? 2 : 1; rowCount = this.model.timeDrillDown.showMeridian ? 6 : 4;
            var timeDisplayFormat = this.model.timeDrillDown.showMeridian ? "hh" : "HH:00";
            var meridianText = ["AM", "PM"], count = 0, meridianClass = "";

            start = this.timePicker._createObject("12:00:00 AM");
            end = this.model.timeDrillDown.showMeridian ? this.timePicker._createObject("11:59:59 AM") : this.timePicker._createObject("11:59:59 PM");

            for (var i = 0; i < tableCount; i++) {
                if (this.model.timeDrillDown.showMeridian) {
                    meridianClass = meridianText[i].toLowerCase();
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    ej.buildTag("div.e-header-" + meridianClass).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                      .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-meridiantxt-" + meridianClass).text(txt)
                      .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                      .appendTo(this._sfTimeHour);
                }

                // Table for Time Value
                table = ej.buildTag("table.e-dp-viewhours", "", {}).data("e-table", "data").attr({ 'role': 'grid' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                this._sfTimeHour.append(table);

                var tbody = ej.buildTag('tbody.e-timepicker-hours').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                while (this.timePicker._compareTime(end, start, true)) {
                    timeVal = this._localizeTime(start, timeDisplayFormat);
                    var tdtag = ej.buildTag("td.e-hour e-state-default", timeVal);
                    this.model.timeDrillDown.showMeridian && tdtag.addClass("e-hour-" + meridianClass);
                    if (this._isIE8) tdtag.attr("unselectable", "on");
                    tr.append(tdtag);
                    count++;
                    if (count >= rowCount) {
                        count = 0;
                        tbody.append(tr);
                        tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    }
                    start = this.timePicker._createObject(start).getTime() + interval;
                }

                //tbody.append(tr);
                table.append(tbody);

                if (this.model.timeDrillDown.showMeridian) {
                    start = this.timePicker._createObject("12:00:00 PM");
                    end = this.timePicker._createObject("11:59:59 PM");
                }
            }

            // Rendering the footer template
            ej.buildTag("div.e-footer")
              .append(ej.buildTag("span.e-footer-icon"))
              .append(ej.buildTag("span.e-footer-text"))
              .appendTo(this._sfTimeHour);
            $('.e-footer-text', this._sfTimeHour).html(this._localizedLabels.buttonText.timeNow);
            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));

            // Bind action to the item.
            this._on(this._sfTimeHour.find('.e-hour'), "click", $.proxy(this._hourNavHandler, this));
            this._on($('.e-next', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-prev', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-footer', this._sfTimeHour), "click", this._todayBtn);
            $('.e-hours-headertext', this._sfTimeHour).on("click", $.proxy(this._forwardNavHandler, this));

            this._sfTimeHour.hide();
        },
        _localizeTime: function (value, format) {
            return $.trim(ej.format(this.timePicker._createObject(value), format, this.model.locale));
        },
        _renderMinsPopup: function () {
            this._sfTimeMins = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-minitues ', "", {}, { id: (this._id ? 'e-time-minitues-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeMins.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeMins);

            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-headertext").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeMins);

            // Meridian Header template
            ej.buildTag("div.e-mins-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                          .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-meridiantxt").text("AM")
                          .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                          .appendTo(this._sfTimeMins);

            // Table for Time Value
            var table = ej.buildTag("table.e-dp-viewmins", "", {}).data("e-table", "data").attr({ 'role': 'grid' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._sfTimeMins.append(table);

            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            // Render Time value
            if (this._intervall < 1) return false;
            var start, end, timeVal, interval = this._interval * 60000;
            start = this.timePicker._createObject("12:00:00 AM");
            end = this.timePicker._createObject("11:59:59 PM");
            var tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var count = 0;
            while (this.timePicker._compareTime(end, start, true)) {
                timeVal = this._localizeTime(start, "HH:00");
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                if (count >= 4) {
                    count = 0;
                    tbody.append(tr);
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                }
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            //tbody.append(tr);
            table.append(tbody);
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());

            // Rendering the footer template
            ej.buildTag("div.e-footer")
               .append(ej.buildTag("span.e-footer-icon"))
               .append(ej.buildTag("span.e-footer-text"))
               .appendTo(this._sfTimeMins);
            $('.e-footer-text', this._sfTimeMins).html(this._localizedLabels.buttonText.timeNow);
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));
            !this.model.timeDrillDown.showMeridian && $(".e-mins-header", this._sfTimeMins).css("display", "none");

            // Bind action to the item.
            this._on(table.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
            this._on($('.e-next', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-prev', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-footer', this._sfTimeMins), "click", this._todayBtn);
            $('.e-minitues-headertext', this._sfTimeMins).on("click", $.proxy(this._forwardNavHandler, this));
            this._sfTimeMins.hide();
        },
        _todayBtn: function () {
            this._nowClick();
            this._hideResult();
        },
        _hourNavHandler: function (e) {
            var value;
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();

            $("table", this._sfTimeHour).find("td").removeClass("e-active");
            $(e.target).addClass("e-active");

            this._sfTimeHour.hide();
            this._sfTimeMins.show();
            this._addFocus(this._sfTimeMins);
            if (this.model.timeDrillDown.showMeridian) {
                var txt = $(e.target).hasClass("e-hour-am") ? "AM" : "PM";
                value = $(e.target).text() + ":00 " + txt;
            }
            else
                value = $(e.target).text();
            this._generateMins(value);
            var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
            var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
            var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));
            var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
            index = Math.ceil(index);
            this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);
        },
        _minsNavHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();
            $("table", this._sfTimeMins).find("td").removeClass("e-active").removeClass("e-state-hover");
            $(e.target).addClass("e-active");
            if (this.model.timeDrillDown.showMeridian) {
                var value = $(e.target).text() + " " + ej.format(this._datetimeValue, "tt", "en-US");
                value = this.timePicker._localizeTime(value)
            }
            else
                value = $(e.target).text();
            this.timePicker.option("value", value);
            this.datePicker.option("value", this._datetimeValue);
            this._datetimeValue = new Date(this.model.value.toString());
            this._updateInput();
            this.model.timeDrillDown.autoClose && this._hideResult(e);
        },
        _generateMins: function (value) {
            var minsTable = $('table', this._sfTimeMins);
            minsTable.empty();
            this.model.timeDrillDown.showMeridian ? $(".e-mins-header", this._sfTimeMins).show() : $(".e-mins-header", this._sfTimeMins).hide()
            var displayFormat = this.model.timeDrillDown.showMeridian ? "hh:mm" : "HH:mm";
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());
            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var start, tr, end, timeVal, count = 0, interval = this.model.timeDrillDown.interval * 60000;
            start = this.timePicker._createObject(value);
            this._datetimeValue.setHours(start.getHours());
            end = this.timePicker._createObject(start).getTime() + 59 * 60000;
            tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            tbody.append(tr);
            while (this.timePicker._compareTime(end, start, true)) {
                if (count >= 4) {
                    count = 0;
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    tbody.append(tr);
                }
                timeVal = this._localizeTime(start, displayFormat);
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            minsTable.append(tbody);
            $(".e-mins-header", this._sfTimeMins).find('.e-minitues-meridiantxt').text(ej.format(this._datetimeValue, "tt", this.model.locale))
            this._disableRange("mins");
            this._on(minsTable.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
        },
        _prevNextHourHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeHour);
        },
        _prevNextMinsHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeMins);
        },
        _processNextPrev: function (progress, wrapper) {
            if (progress && wrapper.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && wrapper.find(".e-arrow-sans-right").hasClass("e-disable")) return false;
            var currentTable = $("table", wrapper), temp;
            var incVal, tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewhours":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setDate(this._datetimeValue.getDate() + incVal);
                    this._disableRange("hour");

                    this._hoverHour = this._setFocusByIndex("hour", this._hoverHour, this._sfTimeHour);
                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
                case "e-dp-viewmins":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setHours(this._datetimeValue.getHours() + incVal);
                    this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));

                    var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                    var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                    var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                    var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                    index = Math.ceil(index);

                    this._disableRange("mins");

                    this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
            }
        },
        _forwardNavHandler: function (event, table) {
            if (this.model.readOnly || !this.model.enabled) return false;
            var hclassName, proxy = this;
            if (event) event.preventDefault();
            if (event)
                hclassName = $(event.currentTarget).get(0).className;
            else
                hclassName = table.find(".e-text>span").get(0).className;

            switch (hclassName) {
                case "e-hours-headertext":
                    this._sfTimeHour.css("display", "none");
                    this._dateContainer.css("display", "block");
                    this._addFocus(this._dateContainer.find('.e-datepicker'));
                    break;
                case "e-minitues-headertext":
                    this._sfTimeMins.css("display", "none");
                    this._disableRange("hour");

                    var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                    var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
                    indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                    indx = Math.floor(indx);

                    this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    this._sfTimeHour.css("display", "block");
                    this._addFocus(this._sfTimeHour);
                    break;
            }
        },
        _renderDateControl: function () {
            var dateInput = ej.buildTag("input#" + this.element[0].id + "_date", "", {}, { "type": "text" });
            this.popup.append(dateInput);
            dateInput.ejDatePicker({

                height: "0px", width: "0px",
                displayInline: true,
                showDateIcon: false,
                showFooter: this.model.timeDrillDown.enabled ? this.model.timeDrillDown.showFooter : false,
                enableStrictMode: true,
                buttonText: this._localizedLabels.buttonText.today,

                minDate: this._stringToObject(this.model.minDateTime),
                maxDate: this._stringToObject(this.model.maxDateTime),

                dayHeaderFormat: this.model.dayHeaderFormat,
                startLevel: this.model.startLevel,
                depthLevel: this.model.depthLevel,
                startDay: this.model.startDay,
                stepMonths: this.model.stepMonths,
                showOtherMonths: this.model.showOtherMonths,
                headerFormat: this.model.headerFormat,

                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale,
                
            });
            if (!ej.isNullOrUndefined(this.model.value))
                this._datetimeValue = new Date(this.model.value.toString());
            this.datePicker = dateInput.data("ejDatePicker");
            this._datetimeValue = new Date(this.datePicker._dateValue.toString());
            this.model.startDay = this.datePicker.model.startDay;
            this.datePicker._getInternalEvents = true;
            this.datePicker._dt_drilldown = true;
            this.datePicker.popup.css({ "position": "static", "display": "block" });
        },
        _renderTimeControl: function () {
            var timeInput = ej.buildTag("input#" + this.element[0].id + "_time", "", {}, { "type": "text" });
            this.popup.append(timeInput);
            var popupWidth = this.model.timePopupWidth,width;
            if ((typeof (popupWidth) == "string" && popupWidth.indexOf("%") != -1) || typeof (popupWidth) == "string") width = parseInt(popupWidth) > 0 ? popupWidth : 105 && (this.model.timePopupWidth = 105);
            else {
                width = popupWidth > 0 ? popupWidth : 105 && (this.model.timePopupWidth = 105);
            }
            timeInput.ejTimePicker({
                height: "0px", width: "0px",
                interval: this.model.interval,
                timeFormat: this.model.timeDisplayFormat,
                popupWidth: width,
                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale,
            });
            this.timePicker = timeInput.data("ejTimePicker");
            this.timePicker._renderDropdown();
            this.timePicker.popup.css({ "position": "static", "display": "block" });
            this.timePicker._getInternalEvents = true;
            this.timePicker.showDropdown = true;
            this.timePicker._dateTimeInternal = true;
            var min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            var max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;

        },
        _updateTimeHeight: function () {
            var height = this.popup.find(".e-timecontainer .e-header").is(":visible") ? this.datePicker.popup.height() - this.popup.find(".e-header").height() : this.datePicker.popup.height();
            height = this.popup.hasClass("e-dt-responsive") ? "98px" : height;
            this.timePicker.option("popupHeight", height);
        },

        _bindOperations: function () {
            var proxy = this;
            this.datePicker.option("layoutChange", function () { proxy._updateTimeHeight(); });
            this.datePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.timePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.datePicker.option("change", function (a) {
                proxy._refreshTimes(a);
            });
            this.datePicker.option("select", function (e) {
                proxy._updateInput(e);
            });
            this.datePicker.option("dt_drilldown", function (e) {
                if (proxy.model.timeDrillDown.enabled) {
                    proxy._updateInput(e);
                    proxy._switchToDrilDown(e);
                }
            });
            this.timePicker.option("select", function () { proxy._updateInput(); });
        },
        _switchToDrilDown: function (e) {
            this._dateContainer.hide();
            this._sfTimeHour.show();
            this._addFocus(this._sfTimeHour);
            var selected = new Date(this.model.value.toString());
            this._datetimeValue = new Date(selected.setHours(this._datetimeValue.getHours(), this._datetimeValue.getMinutes(), this._datetimeValue.getSeconds(), this._datetimeValue.getMilliseconds()));

            // To hide the hours that exceeds the min and max.
            this._disableRange("hour");

            var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
            var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
            var indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
            indx = Math.floor(indx);

            this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
        },
        _disableRange: function (view) {
            var interval = view == "hour" ? this._interval : this.model.timeDrillDown.interval, table = view == "hour" ? this._sfTimeHour : this._sfTimeMins
            var addClassName = view == "hour" ? "e-hide-hour e-disable" : "e-hide-mins e-disable";
            table.find('tbody tr td.e-' + view).removeClass(addClassName);
            table.find('.e-arrow-sans-left').removeClass("e-disable");
            table.find('.e-arrow-sans-right').removeClass("e-disable");
            var start = view == "hour" ? this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00") :
                this._localizeTime($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)), "HH:00");

            if (this._compareDate(this.model.minDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.minDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.minDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = view == "hour" ? Math.floor(indx) : Math.ceil(indx);
                for (i = 0; i < indx; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-left').addClass("e-disable");
            }
            if (this._compareDate(this.model.maxDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.maxDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.maxDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = Math.floor(indx) + 1;
                var length = table.find('tbody tr td.e-' + view).length
                for (i = indx; i < length; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-right').addClass("e-disable");
            }
        },
        _setFocusByName: function (name, value, table) {
            var allValues = table.find('tbody tr td.e-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (ele.innerHTML == value) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setFocusByIndex: function (name, index, table) {
            var allValues = table.find('tbody tr td.e-' + name), cell;
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setActiveState: function (selection, table) {
            var items = table.find('tbody tr td.e-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "hour":
                    if (this._compareDate(this.model.value, this._datetimeValue)) {

                        var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                        var val = $.trim(ej.format(this.timePicker._createObject(this.model.value), "HH:00", this.model.locale));
                        indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                        indx = Math.floor(indx);

                    }
                    break;
                case "mins":
                    if (this._compareDate(this.model.value, this._datetimeValue) && (this.model.value.getHours() === this._datetimeValue.getHours())) {

                        var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                        var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                        var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                        indx = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                        indx = Math.ceil(indx);
                    }
                    break;
            }
            cell = items[indx];
            if (cell) {
                table.find('table td').removeClass("e-active");
                $(cell).removeClass("e-state-hover").addClass("e-active");
            }
        },

        _compareDate: function (first, second) {
            var val1 = new Date(first.toString()).setHours(0, 0, 0, 0);
            var val2 = new Date(second.toString()).setHours(0, 0, 0, 0);
            var result = (+val1 === +val2) ? true : false;
            return result;
        },

        _updateInput: function (e) {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var date = this._getDate() || new Date(), time = this._getTime() || this.timePicker._createObject(minVal);
            this.model.value = new Date(date.getFullYear(), date.getMonth(), date.getDate(),
                time.getHours(), time.getMinutes(), time.getSeconds());
            this._updateDateTime();
            this._raiseChangeEvent();
            this._updateModel(e, true);
            if (e)
                e.cancel = true;
        },
        _updateDateTime: function () {
            this.isValidState = true;
            var datetime = this._objectToString(this.model.value);
            this.element.val(datetime);
            this._removeWatermark();
        },
        _refreshTimes: function (args) {
            var value = this._getDateObj(args.value, this.datePicker.model.dateFormat);
            if (!value) return false;
            this.isValidState = true;

            if (this._compare(value, this._setEmptyTime(this.model.minDateTime))) {
                var mintime = this._getFormat(this.model.minDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("minTime", mintime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("minTime", this._defaultMinVal());

            if (this._compare(value, this._setEmptyTime(this.model.maxDateTime))) {
                var maxtime = this._getFormat(this.model.maxDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("maxTime", maxtime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("maxTime", this._defaultMaxVal());

            this.timePicker._changeActiveEle();
            if (!ej.isNullOrUndefined(this.model.disableDateTimeRanges)) {
                this._setDisabledTimeRanges(args);				
            }

        },
		_setDisabledTimeRanges: function(args){
				var currvalue = args? args.value : this._setEmptyTime(this.model.value);
				this._between=[];
                this._initDisableTimeRanges(currvalue);
				if(!this._datesDisabled){
					this._disableBetweenDates();
					this.datePicker.option("blackoutDates", this._between);
				}
		},

        _defaultMinVal: function () {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var minTimeVal = ej.format(this.timePicker._createObject(minVal), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return minTimeVal;
        },
        _defaultMaxVal: function () {
            var maxval = new Date().setHours(23, 59, 59, 59);
            var maxTimeVal = ej.format(this.timePicker._createObject(maxval), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return maxTimeVal;
        },
        _updateValues: function () {
            var dateValue = this.model.enableStrictMode && this.model.value == null ? this.element.val() : this.model.value;
            if (this.model.value != null) {
                this.datePicker.option("value", this.model.value);
                this.timePicker.option("value", this.model.value);
            }
            this._setValue(dateValue);
            this._validateMinMax();
            this._preVal = this.element.val();
            this._checkErrorClass();
        },
        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showhidePopup, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    this.element.on("mousedown", $.proxy(this._showhidePopup, this));
                }
                this[action](this.element, "blur", this._targetBlur);
                this[action](this.element, "focus", this._targetFocus);
                this[action](this.element, "keydown", this._keyDownOnInput);
            }
            this._change("allowEdit", bool);
        },
        _setValue: function (value) {
            if (!value || (typeof JSON === "object" && JSON.stringify(value) === "{}")) {
                this.element.val("");
                this.model.value = null;
                this.isValidState = true;
                this.wrapper.removeClass('e-valid');
            }
            else if (typeof value === "string") {
                if (this._extISORegex.exec(value) || this._basicISORegex.exec(value)) this._checkObject(this._dateFromISO(value));
                else {
                    this.element.val(value);
                    this._updateModel();
                    this._validateMinMax();
                    this._checkStrictMode();
                    this.wrapper.addClass('e-valid');
                }
            }
            else if (value instanceof Date && this._isValidDate(value)) {
                this._checkObject(value);
            }
			if(!ej.isNullOrUndefined(this.model.disableDateTimeRanges))this._validateDisableRanges();
            this._checkErrorClass();
            return this.model.value;
        },
        _checkObject: function (value) {
            if (value instanceof Date && this._isValidDate(value)) {
                this.model.value = value;
                this._updateDateTime();
                this._validateMinMax();
                this._checkStrictMode();
            }
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _validateValue: function (value) {
            var dateObj = ej.parseDate(value, this.model.dateTimeFormat);
            if (!dateObj || dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = false;
            }
            else {
                this._change("value", this.model.value);
                this.isValidState = true;
            }
        },
        _validateMinMax: function () {
            var value, min, max;
            value = (this.model.value) ? this._stringToObject(this.model.value) : null;
            min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;
            if (!value || !min || !max) return false;
            if (min > max) this.model.minDateTime = this.model.maxDateTime;
            if (value < min) {
                if (!this.model.enableStrictMode) {
                    this._setValue(min);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
					if (this.popup){
                    this.datePicker.option('minDate', this._getFormat(min, this.datePicker.model.dateFormat));
                    this.timePicker.option('minTime', this._getFormat(min, this.timePicker.model.timeFormat));
					}
                    this.isValidState = false;
                }
            }
            if (value > max) {
                if (!this.model.enableStrictMode) {
                    this._setValue(max);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
					if (this.popup){
                    this.datePicker.option('maxDate', this._getFormat(max, this.datePicker.model.dateFormat));
                    this.timePicker.option('maxTime', this._getFormat(max, this.timePicker.model.timeFormat));
					}
                    this.isValidState = false;

                }
            }

            if (!(value < min) && !(value > max)) this.isValidState = true;
        },

        _checkProperties: function () {
            this.model.readOnly && this._readOnly(true);
            this.model.showRoundedCorner && this._setRoundedCorner(true);
            this.model.enableRTL && this._setRtl(true);
            this.model.enabled && this._enabled(true);
            if (!this.model.enabled) this._enabled(false);
            else if (this.model.enabled && this.element.hasClass("e-disable")) this._enabled(true);
            this.model.name = !this._options.name ? !this.element.attr("name") ? this.element[0].id : this.element.attr("name") : this.model.name;
            this.element.attr("name", this.model.name);
            this._checkStrictMode();
            this._checkErrorClass();
            this._setWaterMark();
        },

        _checkStrictMode: function () {
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    if (this.model.value < this.model.minDateTime) {
                        this.element.val(this._objectToString(this.model.minDateTime));
                        this.model.value = this.model.minDateTime;
                        this.isValidState = true;
                    }
                    else if (this.model.value > this.model.maxDateTime) {
                        this.element.val(this._objectToString(this.model.maxDateTime));
                        this.model.value = this.model.maxDateTime;
                        this.isValidState = true;
                    }
                    else {
                        this.model.value = "";
                        this.element.val("");
                        this.isValidState = true;
                    }
                }
            }
            else if (this.model.enableStrictMode) {
                if (!this.isValidState) {

                    this.model.value = null;
                    this.isValidState = false;
                }
            }
        },

        _targetFocus: function (e) {
            e.preventDefault();
            this.isFocused = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass("e-error");
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this._prevDateTimeVal = this.element.val();
            if (!this.model.showPopupButton && !this.model.readOnly) this._showResult();
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            if (!this.model.showPopupButton && this.model.readOnly) this._off(this.element, "click", this._elementClick);
            this._trigger("focusIn", { value: this.model.value });
            this.wrapper.addClass('e-valid');
        },
        _targetBlur: function () {
            this.isFocused = false;
            this.wrapper.removeClass("e-focus");
            if (!this.model.showPopupButton) this._hideResult();
            var dateObj = ej.parseDate(this.element.val(), this.model.dateTimeFormat, this.model.locale);
            if (dateObj && !this.model.enableStrictMode) {
                if (dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                    dateObj = dateObj < this.model.minDateTime ? this.model.minDateTime : this.model.maxDateTime;
                    this.element.val(this._objectToString(dateObj));
                }
            }
            var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat, this.model.locale);
            if (val == null && !this.model.enableStrictMode) {
                if (this._prevDateTimeVal == null || this.element.val() == "") {
                    this.element.val("");
                } else
                    this.element.val(this._preVal);
            }
            this._valueChange();
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    this.element.val(this._prevDateTimeVal);
                    this._preVal = this._prevDateTimeVal;
                    this.model.value = this._stringToObject(this._prevDateTimeVal);
                    this.isValidState = true;
                }
                else
                    this._prevDateTimeVal = this.element.val();
            } else if (this.element.val() != "")
                this._validateValue(this.element.val());
            if (!this._isSupport && this.element.val() == "")
                this._hiddenInput.css("display", "block");
            this._checkErrorClass();
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            this._trigger("focusOut", { value: this.model.value });
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            this._previousDateUpdate();
        },
        _previousDateUpdate: function () {
            var previous = ej.parseDate(this._prevDateTime, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preValString = this._prevDateTime;
                this._prevDateTime = this.element.val();
            }
            return this._preValString;
        },
        _elementClick: function () {
            if (!this.isPopupOpen) this._showResult();
        },
        _keyDownOnInput: function (e) {
            switch (e.keyCode) {
                case 40:
                    if (e.altKey) this._showhidePopup();
                    break;
                case 37:
                case 39:
                    if (!this.model.timeDrillDown.enabled)
                        if (e.altKey && this.isPopupOpen) {
                            e.preventDefault();
                            this._addPrevNextFocus(e.keyCode == 37);
                        }
                    break;
                case 27:
                    e.preventDefault();
                case 9:
                    this._hideResult();
                    break;
                case 13:    // Enter Key
                    var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
                    if (val == null && !this.model.enableStrictMode) {
                        if (this._prevDateTimeVal == null || this.element.val() == "") {
                            this.element.val("");
                        } else
                            this.element.val(this._preVal);
                    }
                    this._valueChange();
                    if (!this.model.timeDrillDown.enabled) {
                        this._valueChange();
                        if (this.model.enableStrictMode)
                            this._checkErrorClass();
                        break;
                    }
            }
        },
        _addFocus: function (target) {
            if (!target.hasClass("e-focus")) {
                this._removeFocus();
                target.addClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).on("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).on("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).on("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).on("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).on("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _removeFocus: function () {
            var target = this._getFocusedElement();
            if (target.length > 0) {
                target.removeClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).off("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).off("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).off("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).off("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).off("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _addPrevNextFocus: function (flag) {
            // flag true means previous focus, false means next focus
            var target = this._getFocusedElement(), next;
            if (target.length > 0) {
                if (target.hasClass("e-datepicker e-popup"))
                    next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-timecontainer");
                else if (target.hasClass("e-timecontainer"))
                    next = flag ? this.popup.find(".e-datecontainer >.e-datepicker.e-popup") : this.popup.find(".e-dt-today");
                else if (target.hasClass("e-dt-today"))
                    next = flag ? this.popup.find(".e-timecontainer") : this.popup.find(".e-dt-now");
                else if (target.hasClass("e-dt-now"))
                    next = flag ? this.popup.find(".e-dt-today") : this.popup.find(".e-dt-done");
                else if (target.hasClass("e-dt-done"))
                    next = flag ? this.popup.find(".e-dt-now") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            }
            else next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            this._addFocus(next);
        },
        _getFocusedElement: function () {
            return this.popup.children("div").find("div.e-focus")
        },
        _keyDownOnHours: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeHour.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeHour.find('tbody tr td.e-state-hover').parent().index();

                if (t.col != -1)
                    t.col = t.col + 1;
                else
                    t.col = this._sfTimeHour.find('tbody tr td.e-active').index() + 1;


                if (t.row != -1) {
                    t.row = t.row + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-state-hover').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }
                else {
                    t.row = this._sfTimeHour.find('tbody tr td.e-active').parent().index() + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-active').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }

                var tableClass = this._sfTimeHour.find('table')[0].className, next;
                rowLength = this._sfTimeHour.find('tbody.e-timepicker-hours tr').length, colLength = this.model.timeDrillDown.showMeridian ? 6 : 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "hours", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeHour.find('tbody.e-timepicker-hours tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeHour.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },

        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, table, cls = { parent: null, child: null };
            switch (target) {
                case "hours": eleClass = "tbody.e-timepicker-hours tr td.e-hour";
                    cls.parent = ".e-timepicker-hours", cls.child = ".e-hour";
                    hiddenClass = ".e-hide-hour";
                    table = this._sfTimeHour;
                    break;
                case "mins": eleClass = "tbody.e-timepicker-mins tr td.e-mins";
                    cls.parent = ".e-timepicker-mins", cls.child = ".e-mins";
                    hiddenClass = ".e-hide-mins";
                    table = this._sfTimeMins;
                    cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    break;

            }
            if (t.row <= 0 && t.col <= 0)
                return table.find(eleClass + ':not(.e-disable):first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return table.find(eleClass + ':not(.e-disable):first');
                case 35:
                    return table.find(eleClass + ':not(.e-disable):last');
                case 38:
                    if (ctrlKey) {
                        this._forwardNavHandler(null, table);
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrev(true, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                        // different columns for the mins popup.
                        if (target == "mins") t.col = cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrev(false, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls, table).not(hiddenClass);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down", table);
                            if (cell !== null) return cell;
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var ele, element;
                    ele = this._getCell(t, cls, table); element = $(ele)[0];
                    args = { type: null, target: ele };
                    if (target == "hours") this._hourNavHandler(args);
                    if (target == "mins") this._minsNavHandler(args);
                    break;
            }
            return this._getCell(t, cls, table).not(hiddenClass);
        },
        _getCell: function (t, cls, table) {
            var row = t.row;
            if (this.model.timeDrillDown.showMeridian && t.row > 2 && table.hasClass('e-time-hours'))
                row = row - 2;
            var cell = table.find('tbody' + cls.parent + ' tr:nth-child(' + row + ') td' + cls.child + ':nth-child(' + t.col + ')');
            if (this.model.timeDrillDown.showMeridian && cell.length > 0 && table.hasClass('e-time-hours'))
                cell = t.row <= 2 ? $(cell[0]) : $(cell[1]);
            return cell;
        },
        _findVisible: function (t, cls, key, table) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                //nextElement = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                nextElement = this._getCell({ row: rows, col: cols }, cls, table)
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-disable') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    nextElement = this._getCell(t, cls, table)
                    return nextElement;
                }
            }
        },
        _keyDownOnMinutes: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeMins.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeMins.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this._sfTimeMins.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this._sfTimeMins.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this._sfTimeMins.find('table')[0].className, next;
                rowLength = this._sfTimeMins.find('tbody.e-timepicker-mins tr').length, colLength = 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "mins", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeMins.find('tbody.e-timepicker-mins tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeMins.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },
        _valueChange: function (isCode) {
            if (!this.model.enableStrictMode) {
                if (this._preVal != this.element.val()) {
                    this._preVal = this.element.val();
                    this._updateModel();
                    this._validateMinMax();
                    this._raiseChangeEvent(isCode);
                }
                this._setWaterMark();
            }
            else if (this.model.enableStrictMode) {
                if (this._preVal != this.element.val() || this.model.value < this.model.minDateTime || this.model.value > this.model.maxDateTime) {
                    this._updateModel();
                    this._raiseChangeEvent(isCode);
                }
            }
        },
        _updateModel: function (e, stopUpdateModel) {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var value = this.element.val();
            if (value == "") {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = true;
            }
            else {
                var dateObj;
                if (e != undefined && e.type == "select" || this._prevDateTimeVal == this.element.val()) dateObj = this.model.value;
                else dateObj = ej.parseDate(value, this.model.dateTimeFormat, this.model.locale);
                if (dateObj) {
                    this.model.value = dateObj;
                    this.isValidState = true;
                    if (!stopUpdateModel)
                        this._refreshPopup();
                    if (this._specificFormat() && this._prevDateTimeVal != this.element.val())
                        this.element.val(this._objectToString(this.model.value));
                }
                else {
                    this.model.value = null;
                    this._change("value", this.model.value);
                    this.isValidState = false;
                    if (!this.model.enableStrictMode)
                        this.element.val(this._objectToString(this.model.value));
                }
            }
        },
        _refreshPopup: function () {
            if (this.isValidState && this.isPopupOpen) {
                var date = this._setEmptyTime(this.model.value), time = this._setEmptyDate(this.model.value);
                var getDate = this._getDate(), getTime = this._getTime();
                if (!getDate || !this._compare(getDate, date)) this.datePicker.option("value", date);
                if (!getTime || !this._compare(getTime, time)) this.timePicker.option("value", time);
            }
        },

        _buttonClick: function (e) {
            if (e.keyCode == 13) {
                e.preventDefault();
                var target = this._getFocusedElement();
                if (target.hasClass("e-dt-today"))
                    this._todayClick();
                else if (target.hasClass("e-dt-now"))
                    this._nowClick();
                else if (target.hasClass("e-dt-done"))
                    this._doneClick();
            }
        },
        _todayClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            if (!this.datePicker.popup.find(".today").hasClass("e-active") ||
                !this.datePicker.popup.children("table").hasClass("e-dp-viewdays") ||
                this.element.val() == "" || !this.isValidState) {
                this.datePicker._setCurrDate();
                this._updateInput();
            }
        },
        _nowClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            this.timePicker.setCurrentTime();
            var mintime = this.model.minDateTime, maxtime = this.model.maxDateTime, date = this.datePicker.model.value, time = new Date();
            date = ej.isNullOrUndefined(date) ? new Date() : date;
            var currTime = new Date(date.getFullYear(), date.getMonth(), date.getDate(), time.getHours(), time.getMinutes(), time.getSeconds());
            if (currTime < mintime)
                this.timePicker.option("value", this.timePicker._localizeTime(mintime));
            else if (currTime > maxtime)
                this.timePicker.option("value", this.timePicker._localizeTime(maxtime));
            this._updateInput();
        },
        _doneClick: function () {
            this._hideResult();
        },

        _iconClick: function (e) {
            e.preventDefault();
            if (!this.isFocused && (!ej.isTouchDevice())) this.element.focus();
            this._showhidePopup();
			if(this.model.disableDateTimeRanges && ej.isNullOrUndefined(this.model.value)) this._setDisabledTimeRanges(this.datePicker.model.value);
            if (this._isIE9)
                this.popup.find(".e-popup-container").css("display", "inline-block");
        },
        _setInitialSelection: function () {
            var elements = this.timePicker.ul.find("li");
            if (elements.hasClass('e-hover')) return;
            var currentTime = this.timePicker._setEmptyDate(new Date()), selected;
            selected = currentTime;
            if (this.timePicker.minTime && !this._compareTime(this._createObject(currentTime), this.timePicker.minTime, true))
                selected = this.timePicker.minTime;
            if (this.timePicker.maxTime && !this._compareTime(this.timePicker.maxTime, this._createObject(currentTime), true))
                selected = this.timePicker.maxTime;
            var firstTime = elements.first().html(), index;
            index = (this.timePicker._parse(selected) - this.timePicker._parse(firstTime)) / (this.timePicker.model.interval * 60000);
            index = Math.round(index);
            var activeItem = (index == elements.length) ? index : index + 1;
            if (activeItem < 0 || activeItem > elements.length || isNaN(activeItem)) activeItem = 1;
            var activeEle = $(this.timePicker.ul.find("li")[activeItem - 1]);
            activeEle.addClass('e-hover');
            this._calcScrollTop();
        },
        _calcScrollTop: function () {
            var ulH = this.timePicker.ul.outerHeight(), liH = this.timePicker.ul.find("li").outerHeight(), index, top;
            index = this.timePicker.ul.find("li.e-hover").index();
            top = (liH * index) - ((this.timePicker.popupList.outerHeight() - liH) / 2);
            this.timePicker.scrollerObj.setModel({ "scrollTop": top });
        },
        _showhidePopup: function () {
            if (this.model.readOnly) return false;
            if (!this.isPopupOpen)
                this._showResult();
            else
                this._hideResult();
        },
        _showResult: function () {
            if (!this.popup) this._renderDropdown();
            if (this.isPopupOpen || !this.model.enabled) return false;
			this._setRtl(this.model.enableRTL);
			this._setRoundedCorner(this.model.showRoundedCorner);
            if (this._trigger("beforeOpen", { element: this.popup })) return false;
            this.isPopupOpen = true;
			this.element.attr({'aria-expanded':'true'})
            this._setListPosition();
            this._checkForResponsive();
            var proxy = this;
            this.popup.slideDown(this.model.enableAnimation ? 200 : 0, function () {
                proxy._on($(document), "mousedown", proxy._OnDocumentClick);
                proxy.model.timeDrillDown.enabled && proxy._addFocus(proxy._dateContainer.find('.e-datepicker'));
                if (!proxy.timePicker.model.value) proxy._setInitialSelection();
            });
            this._updateModel();
            this._updateTimeHeight();
            this._validateMinMax();
            this._on($(window), "resize", this._OnWindowResize);
            this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._on(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this._raiseEvent("open");
            if (this._initial) {
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
                this._initial = false;
            }
            this.wrapper.addClass("e-active");
        },
        _hideResult: function (e) {
			if ( e && (e.type == "touchmove" || e.type== "scroll")) {
				if ($(e.target).parents("#"+this.popup[0].id).length > 0)
				return;
	        }
            var proxy = this;
            if (!this.isPopupOpen) return false;
            if (this._trigger("beforeClose", { element: this.popup })) return false;
            this.isPopupOpen = false;
			this.element.attr({'aria-expanded':'false'})
            this._removeFocus();
            if (this._popClose && e && e.type != "click") {
                this.isPopupOpen = true;
                return;
            }
            this.popup.slideUp(this.model.enableAnimation ? 100 : 0, function () {
                if (proxy.model) {
                    if (proxy.model.timeDrillDown.enabled) {
                        proxy._sfTimeHour.hide();
                        proxy._sfTimeMins.hide();
                        proxy._dateContainer.show();
                    }
                    if (!ej.isNullOrUndefined(proxy.model.value))
                        proxy._datetimeValue = new Date(proxy.model.value.toString());
                }
            });
            this._raiseEvent("close");
            this._off($(document), "mousedown", this._OnDocumentClick);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._off(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this.wrapper.removeClass("e-active");
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popup.outerHeight(),
            popupWidth = this.popup.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
			popupPosition = this.model.popupPosition;
            if (this.model.popupPosition == ej.PopupPosition.Bottom)
                var topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            else
                var topPos = ((popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popup.outerWidth() - elementObj.outerWidth();
            this.popup.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _OnDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-datetime-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datetime-wrap").is(this.wrapper)) {
                    this._hideResult();
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-datetime-popup").is(this.popup)) {
                    e.preventDefault();
                    if ($(e.target).parents(".e-datepicker").length > 0) this._addFocus($(e.target).parents(".e-datepicker"));
                    else if ($(e.target).parents(".e-timecontainer").length > 0) this._addFocus($(e.target).parents(".e-timecontainer"));
                    else if ($(e.target).hasClass("e-dt-button")) this._addFocus($(e.target));
                    else if ($(e.target).parents(".e-time-hours").length > 0) this._addFocus($(e.target).parents(".e-time-hours"));
                    else if ($(e.target).parents(".e-time-minitues").length > 0) this._addFocus($(e.target).parents(".e-time-minitues"));
                    else this._removeFocus();
                }
            }
        },
        _OnWindowResize: function (e) {
            this._setListPosition();
            this._checkForResponsive();
            this._updateTimeHeight();
        },

        _raiseChangeEvent: function (isCode) {
            var previous = ej.parseDate(this._prevDateTimeVal, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preVal = this.element.val();
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isInteraction: !isCode, isValidState: this.isValidState };
                this._trigger("_change", data);
                data.value = $.trim(this.element.val()) == "" ? null : this.element.val();
                this._trigger("change", data);
                this._prevDateTimeVal = this.element.val();
            }
            else if ((this._prevDateTimeVal != this.element.val())) {
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isValidState: this.isValidState };
                this._prevDateTimeVal = this.element.val()
                this._trigger("_change", data);
            }
        },
        _raiseEvent: function (name) {
            var dateStringVal = this._previousDateUpdate();
            if (this.element != null && this.model[name])
                return this._trigger(name, { prevDateTime: ej.isNullOrUndefined(dateStringVal || this._preValString) ? '' : dateStringVal || this._preValString, value: this.element.val() });
            return false;
        },
        _getDateTimeFormat: function () {
            var pattern = ej.preferredCulture(this.model.locale).calendar.patterns;

            if (!this.model.dateTimeFormat) this.model.dateTimeFormat = pattern.d + " " + pattern.t;
            if (!this.model.timeDisplayFormat) this.model.timeDisplayFormat = pattern.t;
        },
        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _checkErrorClass: function () {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
        _getDate: function () {
            return this.datePicker.model.value;
        },
        _getTime: function () {
            return this._getDateObj(this.timePicker.model.value, this.timePicker.model.timeFormat);
        },
        _setEmptyTime: function (date) {
            var newDate = new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },
        _setEmptyDate: function (date) {
            var newDate = new Date(date);
            newDate.setDate(1);
            newDate.setMonth(0);
            newDate.setFullYear(2000);
            return newDate;
        },
        _objectToString: function (obj) {
            return this._getFormat(obj, this.model.dateTimeFormat);
        },
        _stringToObject: function (value) {
            return this._getDateObj(value, this.model.dateTimeFormat);
        },
        _getFormat: function (value, format) {
            if (value instanceof Date) {
                var newFormat = this._checkFormat(format);
                return ej.format(value, newFormat, this.model.locale);
            }
            else return value;
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },
        _getDateObj: function (value, format) {
            if (typeof value === "string") {
                var newFormat = this._checkFormat(format);
                var temp = ej.parseDate(value, newFormat, this.model.locale);
                if (temp != null)
                    return temp;
                else {
                    if (value != "" && value != null) {
                        var dateregexp = /^\s*(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d).*Z\s*$/, month, datetimesplit = dateregexp.exec(value);
                        var datevariable = new Date();
                        if (datetimesplit) {
                            datevariable = new Date();
                            month = +datetimesplit[2];
                            datevariable.setUTCFullYear(datetimesplit[1], month - 1, datetimesplit[3]);
                            datevariable.setUTCHours(datetimesplit[4], datetimesplit[5], datetimesplit[6]);
                            if (month != datevariable.getUTCMonth() + 1)
                                datevariable.setTime();
                        }
                        if (this._isValidDate(datevariable))
                            return datevariable;
                    }
                    else return null;
                }
            }
            else return value;
        },
        _compare: function (obj1, obj2) {
            return obj1 && obj2 && obj1.getTime() == obj2.getTime();
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },


        _change: function (property, value) {
            if (this.popup) {
                this.datePicker.option(property, value);
                this.timePicker.option(property, value);
            }
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.popup.removeClass(this.model.cssClass).addClass(skin);

            this._change("cssClass", skin);
        },
        _localize: function (culture) {
            this.model.locale = culture;
            if (ej.isNullOrUndefined(this._options.timeDisplayFormat))
                this.model.timeDisplayFormat = "";
            if (ej.isNullOrUndefined(this._options.dateTimeFormat))
                this.model.dateTimeFormat = "";
            var meridianText = ["AM", "PM"];
            this._getDateTimeFormat();
            this.timePicker.option("timeFormat", this.model.timeDisplayFormat);
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this._buttonText(this._localizedLabels.buttonText);
            if (this.isValidState || (this.model.value instanceof Date && this._isValidDate(this.model.value)))
                this.element.val(this._objectToString(this.model.value));
            this._preVal = this.element.val();
            this._change("locale", culture);
            this.model.startDay = this.datePicker.model.startDay;
            this._validateMeridian();
            this._sfTimeHour.empty();
            this._renderHourTable();

            // Update the meridian support
            if (this.model.timeDrillDown.showMeridian)
                for (i = 0; i < 2; i++) {
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    $("span.e-hours-meridiantxt-" + meridianText[i].toLowerCase(), this._sfTimeHour).text(txt);

                }
        },
        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "") {
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                }
                else {
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                }
                return true;
            }
        },
        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },
        _readOnly: function (boolean) {
            this.model.readOnly = boolean;
            if (boolean) this.element.attr("readonly", "readonly");
            else this.element.prop("readonly", false);

            this._change("readOnly", boolean);
        },
        _setRoundedCorner: function (boolean) {
            if (boolean) {
                this.container.addClass("e-corner");
                if(this.popup)this.popup.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                if(this.popup) this.popup.removeClass("e-corner");
            }
            !ej.isNullOrUndefined(this.datePicker) && this.datePicker.option("showRoundedCorner", boolean);
			!ej.isNullOrUndefined(this.timePicker) && this.timePicker.option("showRoundedCorner", boolean);
        },
        _setRtl: function (boolean) {
            if (boolean) {
                this.wrapper.addClass("e-rtl");
                if(this.popup) this.popup.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                if(this.popup) this.popup.removeClass("e-rtl");
            }

            this._change("enableRTL", boolean);
        },
        _enabled: function (boolean) {
            if (boolean) {
                this.model.enabled = false;
                this.enable();
            }
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _showButton: function (show) {
            this.model.showPopupButton = show;
            if (show) {
                this.container.addClass("e-padding");
                this._renderIcon();
            }
            else {
                this.container.removeClass("e-padding");
                this.datetimeIcon.remove();
                this.datetimeIcon = null;
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            this.popup.find(".e-dt-today").html(this.model.buttonText.today);
            this.popup.find(".e-dt-now").html(this.model.buttonText.timeNow);
            this.popup.find(".e-dt-done").html(this.model.buttonText.done);
            this.popup.find(".e-timecontainer").find(".e-header").html(this.model.buttonText.timeTitle);
        },
        _checkForResponsive: function () {
            if (($(window).outerWidth() > 200) && ($(window).outerWidth() <= 500)) {
                if (!this.popup.hasClass("e-dt-responsive")) {
                    this.popup.addClass("e-dt-responsive");
                    this.timePicker.option("popupWidth", this.datePicker.popup.outerWidth());
                    this.timePicker.option("popupHeight", 98);
                    this.timePicker._refreshScroller();
                    this.timePicker._changeActiveEle();
                }
            }
            else if (this.popup.hasClass("e-dt-responsive")) {
                this.popup.removeClass("e-dt-responsive");
                this.timePicker.option("popupWidth", this.model.timePopupWidth);
                var height = this.datePicker.popup.height() - this.popup.find(".e-header").height();
                this.timePicker.option("popupHeight", height);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },

        enable: function () {
            if (!this.model.enabled) {
                this.element[0].disabled = false;
                this.model.enabled = true;
                this.element.prop("disabled", false);
                this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable").attr("aria-disabled", false);
                if (!this._isSupport)
                    this._hiddenInput.prop("disabled", false);
                if (this.datetimeIcon) this.datetimeIcon.removeClass("e-disable").attr("aria-disabled", false);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().removeClass("e-disable");
                if (this.popup) {
                    this.popup.children("div").removeClass("e-disable").attr("aria-disabled", false);
                    this._change("enabled", true);
                }
            }
        },


        disable: function () {
            if (this.model.enabled) {
                this.element[0].disabled = true;
                this.model.enabled = false;
                this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable").attr("aria-disabled", true);
                this.element.attr("disabled", "disabled");
                if (!this._isSupport)
                    this._hiddenInput.attr("disabled", "disabled");
                if (this.datetimeIcon) this.datetimeIcon.addClass("e-disable").attr("aria-disabled", true);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().addClass("e-disable");
                this._hideResult();
                this._change("enabled", false);
                if (this.popup) {
                    this.popup.children("div").addClass("e-disable").attr("aria-disabled", true);
                    this.datePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
                    this.timePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
                }
            }
        },


        getValue: function () {
            return this._objectToString(this.model.value);
        },


        setCurrentDateTime: function () {
            if (!this.model.readOnly)
                this._setValue(new Date());
        },


        show: function () {
            this._showResult();
        },


        hide: function () {
            this._hideResult();
        },


        _wireEvents: function () {
            if (this.model.allowEdit) {
                this._on(this.element, "focus", this._targetFocus);
                this._on(this.element, "blur", this._targetBlur);
                this._on(this.element, "keydown", this._keyDownOnInput);
            }
            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showhidePopup, this));
            }
        },

        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DateTimePicker.Locale = ej.DateTimePicker.Locale || {};

    ej.DateTimePicker.Locale['default'] = ej.DateTimePicker.Locale['en-US'] = {
        watermarkText: "Select datetime",
        buttonText: {
            today: "Today",
            timeNow: "Time Now",
            done: "Done",
            timeTitle: "Time"
        }
    };

    ej.PopupPosition = {
        Bottom: "bottom",
        Top: "top"
    };
})(jQuery, Syncfusion);;

/**
* @fileOverview Plugin to style the Dialog control
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDialog", "ej.Dialog", {
        _rootCSS: "e-dialog",

        element: null,
        _ignoreOnPersist: ["drag", "dragStart", "dragStop", "resizeStop", "resizeStart", "resize", "beforeClose", "beforeOpen", "collapse", "expand", "close", "open", "destroy", "create", "ajaxSuccess", "ajaxError", "contentLoad", "actionButtonClick", "enableResize"],

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            showOnInit: true,

            closeOnEscape: true,

            //currently we have deprecated this API
            closeIconTooltip: "close",

            enableAnimation: true,

            allowDraggable: true,

            backgroundScroll: true,

            height: "auto",

            minHeight: 120,

            minWidth: 200,

            maxHeight: null,

            maxWidth: null,

            enableModal: false,

            position: { X: "", Y: "" },

            containment: null,

            enableResize: true,

            htmlAttributes: {},

            showHeader: true,

            showFooter: false,

            contentType: null,

            contentUrl: null,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            title: "",

            width: 400,

            zIndex: 1000,

            cssClass: "",

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            actionButtons: ["close"],

            animation:{
                show:{
                    effect:"fade",
                    duration:400
                },
                hide:{
                    effect:"fade",
                    duration:400
                }
            },            

            tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },

            footerTemplateId: null,
            
            locale:"en-US",
            
            faviconCSS: null,

            content: null,

            target: null,

            enablePersistence: false,

            enabled: true,

            isResponsive: false,

            actionButtonClick: null,

            beforeClose: null,

            close: null,            

            expand: null,

            collapse: null,

            beforeOpen: null,

            open: null,

            drag: null,

            dragStart: null,

            dragStop: null,

            resize: null,

            resizeStart: null,

            resizeStop: null,

            contentLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            create: null,

            destroy: null,

            /*Deprecated*/            
            Close:null
        },

        dataTypes: {
            showOnInit: "boolean",
            closeOnEscape: "boolean",
            enableAnimation: "boolean",
            backgroundScroll: "boolean",
            position: "data",
            animation:"data",
            closeIconTooltip: "string",
            tooltip: "data",
            allowDraggable: "boolean",
            enableModal: "boolean",
            enableResize: "boolean",
            isResponsive: "boolean",
            showHeader: "boolean",
            showFooter: "boolean",
            title: "string",
            faviconCSS:"string",
            zIndex: "number",
            cssClass: "string",
            enablePersistence: "boolean",
            contentUrl: "string",
            contentType: "string",
            enableRTL: "boolean",
            enabled: "boolean",
            allowKeyboardNavigation: "boolean",
            showRoundedCorner: "boolean",
            locale: "string",
            htmlAttributes: "data",
            ajaxSettings: "data",
            actionButtons: "array",
			footerTemplateId: "string"
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "closeIconTooltip": this._dialogClose.attr("title", options[key]); break;
                    case "tooltip": this._tooltipText(options[key]); break;
                    case "title":
                        this.model.title = options[key];
                        if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(options[key]);
                        this._updateCaptionWidth();
                        break;
                    case "width": this.model.width = options[key]; this._changeSize(); this._updateCaptionWidth(); options[key] = this.model.width; break;
                    case "height": this.model.height = options[key]; this._changeSize(); options[key] = this.model.height; break;
                    case "position": this.model.position = options[key]; this._dialogPosition(); break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this.model.showRoundedCorner=options[key]; this._roundedCorner(options[key]); break;
                    case "contentType": { this.model.contentType = options[key]; this._appendContent(options[key]); break; }
                    case "enabled": { this.model.enabled = options[key]; this._enabledAction(options[key]); break; }
                    case "contentUrl": { this.model.contentUrl = options[key]; this._appendContent(this.model.contentType); break; }
					case "backgroundScroll":
						this.model.backgroundScroll = options[key]; 
						if (!this.model.backgroundScroll && this.model.enableModal) $("body").addClass("e-dialog-modal");
						else $("body").removeClass("e-dialog-modal");
						break;
                    case "content":
                    case "target": 
                        this._ejDialog.appendTo($(options[key]));
                        this.model.target = this.model.content = options[key];
                        this._dialogPosition();
                        break;
                    case "containment":
                        this._setDragArea(options[key]);
                        !ej.isNullOrUndefined(this._target) ? this._ejDialog.appendTo(this._target) : this._ejDialog.appendTo(document.body);
                        this.model.position.X = this.model.position.Y = "";
                        this._dialogPosition();
                        this.model.containment = options[key] = this._target;
                        this.model.enableModal && this._createOverlay();
                        this._dialogTitlebar.ejDraggable({ dragArea: this._target });
                        break;
                    case "locale":
					    this.model.locale = options[key];
                        this.localizedLabels = this._getLocalizedLabels(); 
                        this._setLocaleCulture(this.localizedLabels, true);
                        this._tooltipText(this.model.tooltip);
						if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(this.model.title);
                        this._updateCaptionWidth();                       				
                        break;
                    case "minHeight": { this.model.minHeight = options[key]; this._ejDialog.css("minHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "minWidth": { this.model.minWidth = options[key]; this._ejDialog.css("minWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxHeight": { this.model.maxHeight = options[key]; this._ejDialog.css("maxHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxWidth": { this.model.maxWidth = options[key]; this._ejDialog.css("maxWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "zIndex": { this._ejDialog.css('z-index', options[key]); break; }
                    case "faviconCSS":
                        this.model.faviconCSS = options[key]; this._favIcon();this._updateCaptionWidth(); break;
                    case "isResponsive": {
                        this.model.isResponsive = options[key];
                        this.model.isResponsive ? this._ejDialog.addClass("e-dialog-resize") : this._ejDialog.removeClass("e-dialog-resize");
                        this._wireResizing();
                        break;
                    }
                    case "allowDraggable": {
                        this.model.allowDraggable = options[key];
                        if (options[key])
                            this._enableDrag();
                        else {
                            this._dialogTitlebar.removeClass("e-draggable");
                        }
                        break;
                    }
                    case "enableResize": {
                        this.model.enableResize = options[key];
                        if (options[key])
                            this._enableResize();
                        else {
                            this._ejDialog.removeClass("e-resizable");
                            this._ejDialog.find(".e-resize-handle").remove();
                        }
                        this._reRenderScroller();
                        break;
                    }
                    case "showHeader": {
                        this.model.showHeader = options[key];
                        if (options[key]) {
                            this._renderTitleBar();
                            this._iconsRender(this.model.actionButtons);
                            if (this.model.faviconCSS) { this._dialogFavIcon = false; this._favIcon(); }
                            this._enableDrag();
                            if (!this._maximize) this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? (this._ejDialog.outerHeight(true) - (this._dialogTitlebar.outerHeight(true))) : this._ejDialog.outerHeight(true) - 1 - (this._dialogTitlebar.outerHeight(true)), (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        else {
                            this._ejDialog.find(".e-titlebar").remove();
                            this._maximize ? this.refresh() : this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.outerHeight(true) : this._ejDialog.outerHeight(true) - 1, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        this._roundedCorner(this.model.showRoundedCorner);
                        if (this.model.showFooter) this._setContainerSize()._resetScroller();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[key];
                        if (options[key]) {
                            this._appendContent();
                            this._ejDialog.find(".e-resizable").remove();
                        }
                        else 
                            this._ejDialog.find(".e-footerbar").remove();
                        this._enableResize()._enableDrag()._sizeInPercent();
                        this._reRenderScroller();
                        this._setContainerSize()._resetScroller();
                        this._roundedCorner(this.model.showRoundedCorner);
                        break;
                    }
                    case "footerTemplateId": {
                        this.model.footerTemplateId = options[key];
                        if (this.model.showFooter) {
                            this._ejDialog.find(".e-footerbar").empty();
                            var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                            this._dialogFooterbar.append(templateContent);
                            this._enableResize();
                        }
                        break;
                    }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            if (this.model.faviconCSS) this._favIcon();
                            if (options[key]) {
                                this._ejDialog.addClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "rtl");
                                if (this.scroller) 
                                    this._resetScroller();
                            } else {
                                this._ejDialog.removeClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "ltr");
                                if (this.scroller) 
                                    this._resetScroller();
                            }
                            break;
                        }
                    case "actionButtons":
                        {
                            if (!ej.isNullOrUndefined(this._dialogTitlebar) ){
                                this._removeAllIcons();
                                this._iconsRender(options[key]);
                            }
                            this.model.actionButtons = options[key];
                            this._updateCaptionWidth();
                            break;
                        }
                    case "enableModal": {
                        this._enableModal(options[key]);
                        break;
                    }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                }
            }
        },


        _destroy: function () {
            if (this._overLay) this._overLay.remove();
            this._cloneElement.appendTo(this._ejDialog.parent());
            this._ejDialog.remove();
            this._cloneElement.removeClass("e-dialog");
            this.element = this._cloneElement;
            this._isOpen = false;
            $(window).off("resize", $.proxy(this._reSizeHandler, this));
        },

        keyConfigs: [37, 38, 39, 40],

        _init: function () {
			this._init=true;
            this._widthPercent = null;
            this._heightPercent = null;
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType = { width: isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g)[0] : null, height: isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g)[0] : null };
            this._isOpen = this._maximize = this._minimize = false;
            this.localizedLabels = this._getLocalizedLabels(); 
            this._setLocaleCulture(this.localizedLabels);
            this._setDimension();
            if (!this.model.close) this.model.close = this.model.Close;
            if (!this.model.target) this.model.target = this.model.content;
			this._responsive();
            this._renderControl();
            this._wireEvents();    
            this.scrObj= this._ejDialog.closest(".e-dialog.e-js").data("ejDialog")
            if(this.scrObj) this.scrObj._resetScroller(); 
			this.hidden=false;			
            this._init=false;
            this._keyNavigation=false;	
        },
		
		_responsive: function () {
            this.width = this.model.width;
            $(this.element).width(this.width);

            this.height = this.model.height;
            $(this.element).height(this.height);
            $(window).on("resize", $.proxy(this._resizeHandler, this));
        },
        
        _resizeHandler: function () {
            if (this._maximize) {
                this.width = $(this._dialogTitlebar).outerWidth();
                $(this.contentDiv).width(this.width);
                $(this.contentDiv).children().width(this.width);

                this.model.height = this.height = $(window).height();
                this._ejDialog.css({ height: this.height });
                this.contentDiv.height(this._ejDialog.height() - $(this._dialogTitlebar).outerHeight() - $(this._dialogFooterbar).outerHeight());
                this.element.height(this.contentDiv.height());
            }
			if(!ej.isNullOrUndefined(this.element)) this._resetScroller();
        },
       
        _setLocaleCulture:function(localizedLabels, isSetModel){
            //Deprecated closeIconTooltip locale
            if(this.defaults.closeIconTooltip===this.model.closeIconTooltip)
                this.model.closeIconTooltip=localizedLabels.closeIconTooltip;
			
                if (isSetModel) {	
                 	 this.model.tooltip= this.localizedLabels.tooltip ;
                     this.model.title= this.localizedLabels.title;			 
				} 
				if(JSON.stringify(this.model.tooltip) === JSON.stringify(this.defaults.tooltip))
                this.model.tooltip=localizedLabels.tooltip;  				
				if(this.model.title === this.defaults.title)
				this.model.title=localizedLabels.title;  
        },

        _setDragArea: function (value) {
            if (!ej.isNullOrUndefined(value))
            {
                if (typeof value == "string") {
                    if (value == "parent") this._target = $(this.element).parent();
                    if (value.toLowerCase() == "document") this._target = $(document);
                    if (value.toLowerCase() == "window") this._target = $(window);
                    else if ($(value).length > 0) this._target = $(value);
                } else if (typeof value == "object") {
                    if (value.length > 0) this._target = value;
                }
                else this._target = null;
            } else this._target = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy._ejDialog.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else{
					if(proxy._ejDialog[0].hasAttribute("style")){
					 var newValue = proxy._ejDialog[0].getAttribute("style") + value;
					 proxy._ejDialog.attr(key, newValue);
					}					
				} 
            });
        },
        _tooltipText: function(data){
            $.extend(this.model.tooltip, data);
            if(!ej.isNullOrUndefined(this._dialogClose) && this._dialogClose.hasClass('e-close'))
                this._dialogClose.attr("title", this.model.tooltip.close);
            if (!ej.isNullOrUndefined(this._dialogCollapsible) && (data.collapse || data.expand)) {
                if (this._dialogCollapsible.hasClass('e-arrowhead-up'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                if (this._dialogCollapsible.hasClass('e-arrowhead-down'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.expand);
            }
            if (!ej.isNullOrUndefined(this._dialogMaximize) && (data.maximize || data.restore)) {
                if (this._dialogMaximize.hasClass('e-maximize'))
                    this._dialogMaximize.attr("title", this.model.tooltip.maximize);
                if (this._dialogMaximize.hasClass('e-restore'))
                    this._dialogMaximize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogMinimize) && (data.minimize || data.restore)) {
                if (this._dialogMinimize.hasClass('e-minus'))
                    this._dialogMinimize.attr("title", this.model.tooltip.minimize);
                if (this._dialogMinimize.hasClass('e-restore'))
                    this._dialogMinimize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogPin) && (data.pin || data.unPin)) {
                if (this._dialogPin.hasClass('e-unpin'))
                    this._dialogPin.attr("title", this.model.tooltip.pin);
                if (this._dialogPin.hasClass('e-pin'))
                    this._dialogPin.attr("title", this.model.tooltip.unPin);
            }
        },
        _renderControl: function () {
            this._cloneElement = this.element.clone();
            this.element.attr("tabindex", 0).attr({ "role": "dialog", "aria-labelledby": this.element.prop("id") + "_title" });
            this._ejDialog = ej.buildTag("div.e-dialog e-widget e-box " + this.model.cssClass + " e-dialog-wrap e-shadow#" + (this.element.prop("id") == "" ? "" : this.element.prop("id") + "_wrapper"), "", { display: "none", zIndex: this.model.zIndex }, { tabindex: 0 });
            if(this.model.isResponsive) this._ejDialog.addClass("e-dialog-resize");
            this.wrapper = this._ejDialog;
            this._addAttr(this.model.htmlAttributes);
            this._setDragArea(this.model.containment);
            if(!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) var target = this._target;                
            else if(!ej.isNullOrUndefined(this.model.target)) var target = this.model.target;
            var wrapperTarget = !ej.isNullOrUndefined(target) ? target : document.body;
            var oldWrapper = $(wrapperTarget).find("#" + this._id + "_wrapper").get(0);
            if (oldWrapper) $(oldWrapper).remove();
            this._ejDialog.appendTo(wrapperTarget);
            if (this.model.enableRTL) this._ejDialog.addClass("e-rtl");
            if (this.model.showHeader) {
                this._renderTitleBar();
                this._iconsRender(this.model.actionButtons);
                if (this.model.faviconCSS) this._favIcon();
            }
            this._appendContent(this.model.contentType);
            this._enableResize()._enableDrag()._setSize();
			if(this.model.height != "auto") this._sizeInPercent();
            if (this.model.contentType != "ajax"){                                                                  
                if (this.model.showOnInit && this.open()) {
                    this._setContainerSize()._resetScroller();
                }
                else this._setHiddenDialogSize();
            }
            this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            if (this._sizeType.width == "auto") this._maxWidth = this.model.width;
            if (this._sizeType.height == "auto") this._maxHeight = this.model.height;
        },

        _setContainerSize: function () {
            if (this.model.height != "auto") {
                var cntHeight = this._ejDialog.outerHeight() - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)  + ((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0) - 1;
                this.contentDiv.height(cntHeight);
                this.element.outerHeight(cntHeight);
            }
            return this;
        },

        _changeSize: function () {
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType.width = isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g) : null;
            this._sizeType.height = isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g) : null;
            this._setSize()._sizeInPercent()._setContainerSize()._resetScroller();
        },

        _enableDrag: function () {
            if (this.model.allowDraggable && this.model.showHeader) {
                this._dialogTitlebar.addClass("e-draggable");
                this._dragDialog();
            }
            return this;
        },

        _enableResize: function () {
            if (this.model.enableResize) {
                this._ejDialog.addClass("e-resizable");
                var resizeDiv = ej.buildTag("div.e-icon e-resize-handle");
                if (this.model.showFooter) 
                    resizeDiv.appendTo(this._dialogFooterbar);
                else
                    resizeDiv.appendTo(this._ejDialog);
                this._resizeDialog();
            }
            return this;
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this._ejDialog.removeClass(this.model.cssClass).addClass(skin);
            }
        },
        _enableModal: function (value) {
            if (value) this._isOpen && this._createOverlay();
            else if (this._overLay) this._overLay.remove();
        },

        _enabledAction: function (flag) {
            if (flag) {
                this._ejDialog.removeClass("e-disable");
                this.wrapper.children(".e-disable-overlay").remove();
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.enable();
            }
            else {
                this._ejDialog.addClass("e-disable");
                ej.buildTag("div.e-disable-overlay").appendTo(this.wrapper);
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.disable();
            }
        },

        _renderTitleBar: function () {
            this._elementTitle = this.element.attr("title");
            if (typeof this._elementTitle !== "string")
                this._elementTitle = "";
            this.model.title = this.model.title || this._elementTitle;
            this._dialogTitlebar = ej.buildTag("div#" + this.element.prop("id") + "_title.e-titlebar e-header e-dialog").prependTo(this._ejDialog);
            this._addTitleText();
        },

        _renderFooterBar: function () {
            this._dialogFooterbar = ej.buildTag("div#" + this.element.prop("id") + "_foot.e-footerbar e-dialog e-js").appendTo(this._ejDialog);
        },

        _addTitleText: function () {
            if (this.model.title) 
                this._titleText = ej.buildTag("span.e-title", this.model.title).prependTo(this._dialogTitlebar);
            return this;
        },
        _updateCaptionWidth: function () {
            var addWidth=this.model.faviconCSS && !ej.isNullOrUndefined(this._dialogFavIcon)?this._dialogFavIcon.outerWidth():0;
			if(this._titleText && !ej.isNullOrUndefined(this._dialogTitlebar))
			    this._titleText.css("max-width", (this._dialogTitlebar.width() - 20 - (this._dialogTitlebar.find(".e-dialog-icon").width() * this._dialogTitlebar.find(".e-dialog-icon").length) - addWidth));
			return this;
        },
        _iconsRender: function (iconArray) {
            for (var icon = 0; icon < iconArray.length; icon++) {
                switch ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) ? $.trim(iconArray[icon]) : iconArray[icon].trim()) {
                    case "close": {
                        this._closeIcon();
                        break;
                    }
                    case "collapse":
                    case "collapsible": {
                        this._collapsibleIcon();
                        break;
                    }
                    case "maximize": {
                        this._maximizeIcon();
                        break;
                    }
                    case "minimize": {
                        this._minimizeIcon();
                        break;
                    }
                    case "pin": {
                        this._pinIcon();
                        break;
                    }
                    default: {
                        this._customIconsRender(iconArray[icon]);
                        break;
                    }
                }
            }
        },

        _customIconsRender: function (icon) {
            this._customIcon = ej.util.buildTag("div#" + this.element[0].id + "_" + icon + "button.e-dialog-icon e-icon e-" + icon, null, null).attr('tabIndex', '0').attr('title', icon);
            this._customIcon.appendTo(this._dialogTitlebar);
            this._on(this._customIcon, "touchstart click", this._iconClick);
        },

        _iconClick: function () {
            
            if (!this.element.hasClass("e-disable")) {
                var args = {
                    cancel: false,
                    buttonID: $(event.target).attr("id"),
                    event: event.type,
                    model: this.model,
                    currentTarget: event.currentTarget.title
                }
                this._trigger("actionButtonClick", args);
            }
        },

        _removeAllIcons: function () {
            this._dialogTitlebar.find("div.e-dialog-icon").remove();
        },

        _appendContent: function (contentType) {
            this.contentDiv = ej.isNullOrUndefined(this.contentDiv) ? ej.buildTag("div.e-dialog-scroller") : this.contentDiv;
            this.element.removeAttr("title").addClass("e-widget-content e-box");
            var proxy = this;
            if (!ej.isNullOrUndefined(this.model.contentUrl) && !ej.isNullOrUndefined(contentType)) {
                if (contentType == "ajax") {
                    this.model.ajaxSettings.url = this.model.contentUrl;
                    this._sendAjaxOptions(this.element, this.model.ajaxSettings.url);
                }
                else if (contentType == "iframe") {
                    if (this.element.children('.e-iframe').length > 0) {
                        this.iframe = this.element.find('iframe.e-iframe');
                        this.iframe.attr('src', this.model.contentUrl);
                    }
                    else {
                        this.iframe = ej.buildTag("iframe.e-iframe", "", { width: "100%", height:"100%" }, { scrolling: "auto", frameborder: 0, src: this.model.contentUrl });
                        this.element.appendTo(this.contentDiv).append(this.iframe).show();
                    }
                    if (this.model.enableRTL) {
                        $(this.iframe).load(function () {
                            proxy.iframe.contents().find("body").css("direction", "rtl");
                        });
                    }
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else if (contentType == "image") {
                    var img = ej.buildTag("img.e-images", "", "", { src: this.model.contentUrl });
                    this.element.append(img).show().appendTo(this.contentDiv);
                    $(img).on("load", function () {
                        proxy._dialogPosition();
                    });
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else
                    this.element.show().appendTo(this.contentDiv);
            }
            else {
				this.dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(this.dialogIframeContent)) {
				   this.element.show().appendTo(this.contentDiv).find('iframe').append(this.dialogIframeContent.lastChild);
				}
				else
					this.element.show().appendTo(this.contentDiv);
			}
            if (this._ejDialog.find("div.e-resize-handle").length > 0) {
                if (this._ejDialog.find(".e-footerbar").length == 0)
				this.contentDiv.insertBefore(this._ejDialog.find("div.e-resize-handle"));
			}
			else {
				var dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(dialogIframeContent)) {
                    this.contentDiv.appendTo(this._ejDialog);
					var getid = $("#"+this.contentDiv.find('iframe').attr('id'));
					$(getid[0].contentDocument.lastChild).remove();
				    getid[0].contentDocument.appendChild(dialogIframeContent);
					if(ej.browserInfo().name == "mozilla")
					setTimeout(function () {
						$(getid[0].contentDocument.lastChild).remove();
				        getid[0].contentDocument.appendChild(dialogIframeContent);
                    },500);
				}
				else {
					if(this._ejDialog.find(".e-footerbar").length == 0)
					this.contentDiv.appendTo(this._ejDialog);
				    else
                    this.contentDiv.insertBefore(this._dialogFooterbar);
				     }
				}
            if (this.model.showFooter && this._ejDialog.find(".e-footerbar").length == 0) {
                this._renderFooterBar();
                if (this.model.footerTemplateId != null) {
                    var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                    this._dialogFooterbar.append(templateContent);
                }
            }
        },

        _roundedCorner: function (value) {
            this._ejDialog[(value ? "addClass" : "removeClass")]('e-corner');
            this.contentDiv.removeClass('e-dialog-top e-dialog-bottom e-dialog-content');
            if (this.model.showRoundedCorner) {
                this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-bottom') : !this.model.showHeader && this.model.showFooter ? this.contentDiv.addClass('e-dialog-top') : !this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-content') : true;
            }
        },

        _reRenderScroller: function () {
            if (this.scroller != undefined) {
                    this.scroller.refresh(true);
                if (!this.model.enableRTL) {
                    if ((this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerHeight();
	                    if (Math.floor(this.contentDiv.outerHeight()) === Math.floor(this.scroller._vScrollbar.model.height + 1)) {
                            this.scroller._vScrollbar.model.height -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._scrollData.handle -= resizeHandleSize;
                            this.scroller._vScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._updateLayout(this.scroller._vScrollbar._scrollData);
                            this.scroller._vScrollbar.element.find('> div.e-vscroll').height(height - resizeHandleSize - padngSpace);
                        }
                    }
                    if (!(this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && (this.scroller._hScrollbar && this.scroller._hScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerWidth();
                        this.scroller._hScrollbar.model.width -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handle -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._updateLayout(this.scroller._hScrollbar._scrollData);
                        this.scroller._hScrollbar.element.find('> div.e-hscroll').width(width - resizeHandleSize - padngSpace);
                    }
                }
            }
        },       

        _dialogMaxZindex: function () {
            var parents = this.element.parents(), bodyEle, contEle,index,cindex;
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            contEle = $(this.model.target).children(), cindex = contEle.index(this.popup);
            contEle.splice(cindex, 1);
            $(contEle).each(function (i, ele) { parents.push(ele); });
            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;
        },

        _setZindex: function () {
            var zindex = this._dialogMaxZindex();
            if (this.model.zIndex <= zindex)
                this._ejDialog.css({ zIndex: zindex + 1 });
        },

        _createOverlay: function () {
            var zindex = this._ejDialog.css('zIndex'), target, element, position;
            !ej.isNullOrUndefined(this._overLay) && this._overLay.remove();
            if (!this.model.backgroundScroll) $("body").addClass("e-dialog-modal");
            this._overLay = ej.buildTag("div#" + this.element.attr("id") + "_overLay.e-overlay", "", { zIndex: zindex - 1 });
            if (!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) target = this._target;
            else if (!ej.isNullOrUndefined(this.model.target)) target = this.model.target;
            this._overLay.appendTo(!ej.isNullOrUndefined(target) ? target : document.body);
            var position = !ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target) ? "absolute" : "fixed";
            var left =(ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().left;
            var top = (ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().top;
            this._overLay.css({ top: top, left: left, position: position });
        },

        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            content.addClass("e-load");
            var proxy = this;
            var curTitle = this.model.title;
            var hrefLink = link;
            var ajaxOptions = {
                "success": function (data) {
                    try { proxy._ajaxSuccessHandler(data, content, link, curTitle); }
                    catch (e) { }
                },
                "error": function (e) {
                    try { proxy._ajaxErrorHandler({ "status": e.status, "responseText": e.responseText, "statusText": e.statusText }, content, link, curTitle); }
                    catch (e) { }
                },
                "complete": function () {
                    try {
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        if (!proxy.model.showOnInit) proxy._setHiddenDialogSize();
                    } catch (e) {}
                }
            };
            $.extend(true, ajaxOptions, this.model.ajaxSettings);
            this._sendAjaxRequest(ajaxOptions);
        },

        _setHiddenDialogSize: function () {
            if (!this._isOpen) {
                this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                this._setContainerSize()._resetScroller();
                this._ejDialog.css({ "display": "none", "visibility": "" });
            }
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },

        _ajaxSuccessHandler: function (data, content, link, curTitle) {
            content.removeClass("e-load");
            content.html(data).addClass("e-dialog-loaded").appendTo(this._ejDialog);
            content.appendTo(this.contentDiv);
            this._dialogPosition();
            if (this.model.showOnInit)
                this.open();
            this._trigger("ajaxSuccess", { data: data, url: link });
        },

        _ajaxErrorHandler: function (data, content, link, curTitle) {
            content.addClass("e-dialog-loaded").appendTo(this.contentDiv);
            this._dialogPosition().open();
            this._trigger("ajaxError", { data: data, url: link });
        },
        _closeIcon: function () {
            this._dialogClose = ej.util.buildTag("div#" + this.element[0].id + "_closebutton.e-dialog-icon e-icon e-close",null,null).attr('tabIndex','0');            
            if(this.model.closeIconTooltip == "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else if(this.model.closeIconTooltip != "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.closeIconTooltip);
            else if(this.model.closeIconTooltip == "close" && this.model.tooltip.close != "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else   this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            this._on(this._dialogClose, "touchstart click", this._closeClick);
        },
		
        _collapsibleIcon: function () {            
            this._dialogCollapsible = ej.util.buildTag("div#" + this.element[0].id + "_collapsbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');             
            if (this._collapsible) {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.expand).addClass("e-arrowhead-down").removeClass("e-arrowhead-up");
            }
            else {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.collapse).addClass("e-arrowhead-up").removeClass("e-arrowhead-down");
            }
            this._on(this._dialogCollapsible, "touchstart click", this._collapsibleClick);
        },

        _maximizeIcon: function () {
            this._dialogMaximize = ej.util.buildTag("div#" + this.element[0].id + "_maximizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            if (this._maximize) {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-maximize");
            }
            else {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.maximize).addClass("e-maximize").removeClass("e-restore");
            }
            this._on(this._dialogMaximize, "touchstart click", this._maximizeClick);
        },

        _minimizeIcon: function () {
            this._dialogMinimize = ej.util.buildTag("div#" + this.element[0].id + "_minimizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');           
            if (this._minimize) {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-minus");
            }
            else {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.minimize).addClass("e-minus").removeClass("e-restore");
            }
            this._on(this._dialogMinimize, "touchstart click", this._minimizeClick);
        },

        _pinIcon: function () {
            this._dialogPin = ej.util.buildTag("div#" + this.element[0].id + "_pinbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            this._dialogPin.appendTo(this._dialogTitlebar).attr("title", this.dialogPin ? this.model.tooltip.unPin : this.model.tooltip.pin).addClass(this.dialogPin ? "e-pin" : "e-unpin").removeClass(this.dialogPin ? "e-unpin" : "e-pin");
            this._on(this._dialogPin, "touchstart click", this._pinClick);
        },

        _favIcon: function () {
            if (!this._dialogFavIcon) {
                this._dialogFavIcon = ej.util.buildTag("div.e-dialog-favicon", "", {}, { style: "float:"+ (this.model.enableRTL?"right":"left") });
                var span = ej.util.buildTag("span.e-dialog-custom", "", {}, { role: "presentation" });
                span.appendTo(this._dialogFavIcon);
                this._dialogFavIcon.appendTo(this._dialogTitlebar);
            }
            else 
                span = this._dialogFavIcon.find("span").removeClass().addClass("e-dialog-custom");
            if (!this.model.faviconCSS) this._dialogFavIcon.remove();
            else span.addClass(this.model.faviconCSS); this._dialogFavIcon.css("float", (this.model.enableRTL ? "right" : "left"));
        },

        _minMaxValidation: function () {
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight), _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight),_width = parseInt(this.model.width), _height = parseInt(this.model.height), parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = this._convertPercentageToPixel(parentObj.innerWidth(), _width);
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = this._convertPercentageToPixel(parentObj.innerHeight(), _height);
            if (_maxWidth && _width > _maxWidth || _minWidth && _width < _minWidth) {
                if (_width > _maxWidth) this.model.width = _maxWidth;
                else this.model.width = _minWidth;
            }
            if (_maxHeight && _height >_maxHeight || _minHeight && _height< _minHeight) {
                if (_height > _maxHeight) this.model.height = _maxHeight;
                else this.model.height = _minHeight;
            }
        },

        _setSize: function () {
            var mdl = this.model;
            this._minMaxValidation();
            this._ejDialog.css({ width: mdl.width, minWidth: mdl.minWidth, maxWidth: mdl.maxWidth });
            this._ejDialog.css({ height: mdl.height, minHeight: mdl.minHeight, maxHeight: mdl.maxHeight });
            this._dialogPosition();
            return this;
        },

        _resetScroller: function () {		
			this.element.css({ "height": "auto", "max-width": "", "max-height": "", "width": "" });
            var scrHeight = this._ejDialog.outerHeight(true) - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)-((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0), eleHeight;
            var scrModel = { width: (this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? Math.round(this._ejDialog.width()) : Math.round(this._ejDialog.width() - 2), enableRTL: this.model.enableRTL, height: (this.contentDiv.css('border-width') == "0px") ? scrHeight : scrHeight - 1, enableTouchScroll: false }; // 2px border width
            if ((this.model.height == "auto") && (this.element.height() < this.model.maxHeight || !this.model.maxHeight) && !this._maximize)
                scrModel.height = "auto";
            if (this.model.width == "auto" && !this._maximize)
                scrModel.width = this.model.width;
            this.contentDiv.ejScroller(scrModel);
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            this._padding = parseInt($(this.element).css("padding-top")) + parseInt($(this.element).css("padding-bottom"));
            if(($(this._ejDialog).css("display"))=="none"){
				  this.hidden=true;         
                  this._ejDialog.css({"display":"block"}); 
			}		
			if (!ej.isNullOrUndefined(this.contentDiv.height()) && this.contentDiv.height() > 0) {
                if (!ej.isNullOrUndefined(this.scroller))
                    if (!this.scroller._hScrollbar && this.scroller._vScrollbar)
                        eleHeight = this.contentDiv.outerHeight();
                    else if (this.scroller._hScrollbar)
                         eleHeight = this.contentDiv.outerHeight() - this.scroller.model.buttonSize;
                     else  eleHeight = this.contentDiv.outerHeight();
                 else
                    eleHeight = this.contentDiv.outerHeight() - this._padding;
                if ((this.model.height != "auto" && this.model.height != "100%"))
                    this.element.css({ "height": eleHeight-1 });
                else
                    this.element.css("height", this.model.height);
                if ((this.model.height == "auto" || this.model.height == "100%") && !this.scroller._vScrollbar)
                    this.element.css({ "min-height": this.model.minHeight -((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)});
                if (!this.scroller._vScrollbar && (this.model.width != "auto" && this.model.width != "100%"))
                    this.element.outerWidth((this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? this._ejDialog.width() : this._ejDialog.width() - 2);
                else if (!this.scroller._vScrollbar)
                    this.element.css("width", this.model.width);
                this.element.css({"max-width": this.model.maxWidth, "max-height": this.model.maxHeight });
            }
			if(this.hidden) this._ejDialog.css({"display":"none"});					
			this.hidden=false;
        },

        _updateScroller: function (height, width) {
            this.contentDiv.ejScroller({ width: width, height: height, enableRTL: this.model.enableRTL, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
			this._changeSize();
        },

        _dragDialog: function () {
            var proxy = this;
            var pos = this._ejDialog.parents(".e-dialog-scroller");
            this._dialogTitlebar.ejDraggable({
                handle: ".e-titlebar",
                cursorAt: { top: 0, left: 0 },
                dragArea: proxy._target,
                dragStart: function (event) {
					event.element.attr('aria-grabbed', true);
                    proxy._clickHandler();
                    if (proxy.dialogPin || !proxy.model.allowDraggable || !proxy.model.enabled) {
                        event.cancel = true;
                        return false;
                    }
                    if (proxy._trigger("dragStart", { event: event })) {
                        event.cancel = true;
                        return false;
                    }
                },
                drag: function (event) {
                    proxy._trigger("drag", { event: event });
                },
                dragStop: function (event) {
                    proxy._ejDialog.focus();
					event.element.attr('aria-grabbed', false);
                    if (proxy.element.find("> .e-draggable.e-titlebar")) {
                       var dragobject = $("#" + proxy.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                        if (dragobject)
                            dragobject.option("cursorAt", proxy.element.offset());
                    }
                    var pos = this.helper.offsetParent().offset();
                    proxy._trigger("dragStop", { event: event });
                    proxy.model.position.X = ej.isNullOrUndefined(this.position.left) ? parseInt(this.helper.css('left')) : this.position.left - [pos.left + parseFloat(this.helper.offsetParent().css('border-left-width'))];
                    proxy.model.position.Y = ej.isNullOrUndefined(this.position.top) ? parseInt(this.helper.css('top')) : this.position.top - [pos.top + parseFloat(this.helper.offsetParent().css('border-top-width'))];
                    proxy._positionChanged = true;
                    proxy.dlgresized = true;
                },
                helper: function (event) {
                    return $(proxy._ejDialog).addClass("dragClone");
                }
            });
            return this;
        },

        _resizeDialog: function () {
            if (!this.model.enableResize)  return;
            var proxy = this, started = false, parentObj;
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight);
            var _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight);
            parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
            this._ejDialog.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: _minHeight,
                    minWidth: _minWidth,
                    maxHeight: _maxHeight,
                    maxWidth: _maxWidth,
                    handle: "e-widget-content",
                    resizeStart: function (event) {
                        proxy.dlgresized=true;
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("resizeStart", { event: event });
                        started = true;
                        proxy.model.position = { X: proxy._ejDialog.css("left"), Y: proxy._ejDialog.css("top") };
                        proxy._dialogPosition();
                    },
                    resize: function (event) {
                        proxy.dlgresized=true;
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        proxy._updateCaptionWidth();
                        proxy._trigger("resize", { event: event });
                        proxy._sizeType = { width: "px", height: "px" };
                        if(this.scrObj) this.scrObj._resetScroller();                      
                    },
                    resizeStop: function (event) {
                        proxy.dlgresized=true;
                        proxy._ejDialog.focus();
                        proxy._sizeInPercent();
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        started && proxy._trigger("resizeStop", { event: event });
                        started = false;
                        proxy._setDimension();
                    },
                    helper: function (event) {
                        return $(proxy._ejDialog);
                    }
                });
            return this;
        },

        _dialogPosition: function () {
            if (this._ejDialog.parents("form").length > 0 && ej.isNullOrUndefined(this.model.containment) && ej.isNullOrUndefined(this.model.target)) {
                this._ejDialog.appendTo(this._ejDialog.parents("form"));
            }
            if (this.model.position.X != "" || this.model.position.Y != "") {
                this._ejDialog.css("position", "absolute");
                if(ej.isNullOrUndefined(this.model.target) && ej.isNullOrUndefined(this.model.containment)) {
                this._ejDialog.css("left", this.model.position.X);
                this._ejDialog.css("top", this.model.position.Y);
				}
				else {
					  var containerEle=ej.isNullOrUndefined(this.model.containment)?this.model.target:this.model.containment;
					  if (this.dlgresized || this._keyNavigation){
                         this._ejDialog.css("left", this.model.position.X);
                         this._ejDialog.css("top", this.model.position.Y);                   
                                    }
                      else{
                      this._ejDialog.css("left", $(containerEle).offset()["left"]+ parseInt(this.model.position.X));
					  this._ejDialog.css("top", $(containerEle).offset()["top"]+ parseInt(this.model.position.Y));
				}
            }
            }
            else {
                this._centerPosition();
            }
            return this;
        },
        _centerPosition:function(){
            var x = 0, y = 0;
            if (!ej.isNullOrUndefined(this.model.target) ||!ej.isNullOrUndefined(this._target) && !$(this._target).is($(document)) && !($(this._target).is($(window)))) {
                var $content = !ej.isNullOrUndefined(this._target) ? $(this._target) : $(this.model.target);
                if ($content.css("position") == 'static') {
                    var parentOffset = $content.offsetParent().offset();
                    var contentOffset = $content.offset();
                    x = contentOffset.left - parentOffset.left;
                    y = contentOffset.top - parentOffset.top;
                }
                if ($content.outerWidth() > this._ejDialog.width()) x += ($content.outerWidth() - this._ejDialog.width()) / 2;
                if ($content.outerHeight() > this._ejDialog.height()) y += ($content.outerHeight() - this._ejDialog.height()) / 2;
            }
            else {
                var doc = document.documentElement;
                x = (($(window).outerWidth() > this._ejDialog.width()) ? ($(window).outerWidth() - this._ejDialog.outerWidth()) / 2 : 0) + (window.pageXOffset || doc.scrollLeft);
                y = (($(window).outerHeight() > this._ejDialog.height()) ? ($(window).outerHeight() - this._ejDialog.outerHeight()) / 2 : 0) + (window.pageYOffset || doc.scrollTop);
            }
            this._ejDialog.css({ top: y, left: x });
            this._ejDialog.css("position", "absolute");
        },
        _closeClick: function (event) {
			if(event.type == "touchstart")
		    	event.preventDefault();
            if (this.model.enabled) {
                event.stopPropagation();
                this.close(event);
            }
        },

        _collapsibleClick: function (e) {
            if (this.model.enabled) {
                if ($(e.target).hasClass("e-arrowhead-up")) {
                    this._actionCollapse(e);
                }
                else if ($(e.target).hasClass("e-arrowhead-down")) {
                    this._actionExpand(e);
                }
            }
        },
        _actionCollapse: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-up").addClass("e-arrowhead-down");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.expand);
                this._ejDialog.find("div.e-resize-handle").hide();
                this._ejDialog.find(".e-widget-content").parent().slideUp("fast");
                if(this.model.showFooter)  this._dialogFooterbar.slideUp("fast");
                this._ejDialog.removeClass("e-shadow");
                this._ejDialog.css("minHeight", "0");
                this._ejDialog.height("auto");
                this._trigger("collapse",{isInteraction :(e ? true : false )});
                this._collapsible = true;
            }
        },
        _actionExpand: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                this._ejDialog.addClass("e-shadow");
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast");
                if (this.model.showFooter) this._dialogFooterbar.slideDown("fast");
                if (this._maximize) {
                    this._ejDialog.css({ width: "100%", height: "100%" });
                    this.element.css({ width: "100%", height: "100%" });
                    this.contentDiv.css({ width: "100%", height: "100%" });
                }
                else this._ejDialog.height(this.model.height);
                this._ejDialog.find("div.e-resize-handle").show();
                this._trigger("expand",{isInteraction :(e ? true : false )});
                this._collapsible = false;
            }
        },

        _maximizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMaximize;
                if (_target.hasClass("e-maximize")) {
                    this._actionMaximize();
                    if (this._dialogTitlebar){
                        this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-minus');
                        this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    }
                    _target.removeClass("e-maximize").addClass("e-restore");
                    this._dialogMaximize.attr('title', this.model.tooltip.restore);
                    this._hideIcon(true);
                }
                else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-maximize");
                    this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMaximize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
			this._resetScroller();
        },
        _actionMaximize: function () {
            this._ejDialog.css("top", "0px").css("left", "0px").css("overflow", "hidden").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css({ width: "100%", height: "100%" });
            this.element.css({ width: "100%", height: "100%" });
            this.contentDiv.css({ width: "100%", height: "100%" });
            this._maximize = true;
            this._minimize = false;
            var proxy=this;
            if (this._dialogCollapsible && !ej.isNullOrUndefined(this._dialogCollapsible.hasClass("e-arrowhead-down"))) {
                this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible.attr('title', this.model.tooltip.collapse);
                this._collapseValue = true
            }
            if(this._collapseValue == true) {
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast",function(){
					proxy.refresh();
                    proxy._reRenderScroller();
                });
            }
            this._resetScroller();
        },
        _actionRestore: function () {
            this.element.height("").width("");
            this.contentDiv.height("").width("");
            this._restoreDialog();
            this._maximize = this._minimize = false;
        },

        _minimizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMinimize.hasClass("e-icon")&& this._dialogMinimize;
                if (_target.hasClass("e-minus")) {
                    if (this._maximize)
                        this._setSize();
                    this._actionMinimize();
                } else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-minus");
                    this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMinimize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
        },

        _actionMinimize: function () {
            var top = ($(window).height() - this._ejDialog.height()) + this.element.height() + 14, _height;
            this._ejDialog.css("top", "").css("bottom", "0").css("left", "0").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css("minHeight", "0");
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-maximize');
                this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                this._dialogTitlebar.find(".e-minus").removeClass("e-minus").addClass("e-restore");
                this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.restore);
                if (this._isOpen)
                    _height = this._dialogTitlebar.outerHeight();
                else {
                    this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                    _height = this._dialogTitlebar.outerHeight();
                    this._ejDialog.css({ "display": "none", "visibility": "" });
                }
                this._ejDialog.css("height", _height + 2); // 1px bordertop + 1px borderbottom of the dialog wrapper is added
                this._hideIcon(false);
            } else this._ejDialog.css("height", "");
            this.contentDiv.hide();
			if(this.model.showFooter) this._dialogFooterbar.hide();
            this._maximize = false;
            this._minimize = true;
        },

        _hideIcon: function (value) {
            var hideIcon = this._dialogCollapsible ? this._dialogCollapsible : null;
            if (value) {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').show();
                this._ejDialog.find("div.e-resize-handle").show();
            } else {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').hide();
                this._ejDialog.find("div.e-resize-handle").hide();
            }
        },

        _pinClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                if (_target.hasClass("e-unpin")) {
                    this.dialogPin = true;
                    _target.removeClass("e-unpin").addClass("e-pin");
                    this._dialogPin.attr('title', this.model.tooltip.unPin);
                }
                else if (_target.hasClass("e-pin")) {
                    this.dialogPin = false;
                    _target.removeClass("e-pin").addClass("e-unpin");
                    this._dialogPin.attr('title', this.model.tooltip.pin);
                }
            }
        },

        _restoreDialog: function () {
            this.contentDiv.show();
			if(this.model.showFooter) this._dialogFooterbar.show();
            this._ejDialog.css({"position": "absolute", "bottom": ""}).addClass("e-shadow");
            this._setSize()._resetScroller();
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find(".e-minus").parent().show();
                if (this._dialogCollapsible) {
                    this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                }
            }
        },

        _clickHandler: function (e) {
            var zindex = this._dialogMaxZindex();
            if (parseInt(this._ejDialog.css("zIndex")) < zindex) 
                this._ejDialog.css({ zIndex: zindex + 1 });            
        },

        _mouseClick: function (e) {
			if(e.currentTarget==this._id)
				if ($(e.target).hasClass("e-dialog") || $(e.target).hasClass("e-icon e-resize-handle")) {
					this._setZindex();
					$(e.target).closest(".e-dialog.e-widget").focus();
				}
        },

        _keyDown: function (e) {
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            if (this.model.allowKeyboardNavigation && this.model.enabled && $(e.target).hasClass("e-dialog"))
                if ($.inArray(code, this.keyConfigs) > -1 && this.model.allowDraggable && !this.dialogPin) {
                    this._keyPressed(code, e.ctrlKey);
                    e.preventDefault();
                }            
            if (this.model.closeOnEscape && code === 27 && this.model.enabled) 
                if (!this.element.find(".e-js.e-dialog").first().is(":visible")) {
                    this.close(e);
                    e.preventDefault();
                }
            if (code===13 && this.model.enabled){
                if($(e.target).hasClass("e-close")) this.close(e);
                else if ($(e.target).hasClass("e-arrowhead-up") || $(e.target).hasClass("e-arrowhead-down")) this._collapsibleClick(e);                
                if ($(e.target).hasClass("e-maximize") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMaximize)))
				    this._maximizeClick(e);
                else if ($(e.target).hasClass("e-minus") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMinimize)))
				    this._minimizeClick(e);
				if ($(e.target).hasClass("e-pin") || $(e.target).hasClass("e-unpin")){
				    this._pinClick(e);
					}
            }
            if (code == 9 && this.model.enableModal)
                this._focusOnTab(e);
        },

        _focusOnTab: function (e) {
            var focusEle = this._ejDialog.find("a, button, :input, select, [tabindex]:not('-1')");
            focusEle = $(focusEle).find("a, button, :input, select, [tabindex]:not('')");
            if (e.shiftKey) {
                if (!focusEle[focusEle.index(e.target) - 1]) {
                    e.preventDefault();
                    focusEle.last().focus();
                }
            }
            else if (!focusEle[focusEle.index(e.target) + 1]) {
                e.preventDefault();
                focusEle[0].focus();
            }
        },

        _keyPressed: function (code, ctrlKey) {
            this._keyNavigation=true;
            switch (code) {
                case 40:
                    ctrlKey ?  this._resizing("height", (this._ejDialog.outerHeight() + 3)) : this.option("position", { X: this._ejDialog.position().left, Y: (this._ejDialog.position().top + 3) });
                    break;
                case 39:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() + 3)) : this.option("position", { X: (this._ejDialog.position().left + 3), Y: this._ejDialog.position().top });
                    break;
                case 38:
                    ctrlKey ? this._resizing("height", (this._ejDialog.outerHeight() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left == 0 ? 0 : this._ejDialog.position().left),
						Y: (this._ejDialog.position().top > 3 ? this._ejDialog.position().top - 3 : 0) 
					});
                    break;
                case 37:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left > 3 ? this._ejDialog.position().left - 3 : 0), 
						Y: (this._ejDialog.position().top == 0 ? 0 : this._ejDialog.position().top)
					});
                    break;
            }
        },

        _resizing:function(key, value){
            if (this.model.enableResize) this.option(key, value);
        },

        _sizeInPercent: function () {
            if (!this._enableWindowResize()) return this;
            var parentObj = this._getParentObj();
            if (this._sizeType.width == "%") this._widthPercent = parseFloat(this.model.width);
            else this._widthPercent = this._convertPixelToPercentage(parentObj.outerWidth(), this._ejDialog.outerWidth());
            if (this._sizeType.height == "%") this._heightPercent = parseFloat(this.model.height);
            else this._heightPercent = this._convertPixelToPercentage(parentObj.outerHeight(), this._ejDialog.outerHeight());
            if (this._widthPercent >= 100) {
                this._widthPercent = 100;
                this._ejDialog.outerWidth(parentObj.outerWidth());
                this.model.width = this._ejDialog.width();
            }
            if (this._heightPercent >= 100) {
                this._heightPercent = 100;
                this._ejDialog.outerHeight(parentObj.outerHeight());
                this.model.height = this._ejDialog.height();
            }
            return this;
        },

        _getParentObj: function () {
            return (!ej.isNullOrUndefined(this.model.containment) ? $(this.model.containment) : !ej.isNullOrUndefined(this.model.target) ? $(this.model.target) : $(document));
        },

        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },

        _convertPixelToPercentage: function (parent, child) {
            return Math.round((child / parent) * 100);
        },

        _reSizeHandler: function () {
            var parentObj;
            if (this._maximize) { this._resetScroller(); return; }
            if (this.model.position.X == "" || this.model.position.Y == "" && !this._minimize) this._centerPosition();
            parentObj = this._getParentObj();
            this._change = false;
            if (this._windowSize.outerWidth != $(window).outerWidth()) {
                if (this._sizeType.width == "%") this._percentageWidthDimension(parentObj);
                else this._pixelsWidthDimension(parentObj);
            }
            else if (this._windowSize.outerHeight != $(window).outerHeight()) {
                if (this._sizeType.height == "%") this._percentageHeightDimension(parentObj);
                else this._pixelsHeightDimension(parentObj);
            }
            this._change && this._resizeContainer(parentObj);
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
			this._centerPosition();
        },
        _setDimension:function(){
            if (ej.isNullOrUndefined(this.model.maxWidth)) {
                if (ej.isNullOrUndefined(this._sizeType.width)) this._maxWidth = +this.model.width;
                else if (this._sizeType.width == "px" || this._sizeType.width == "auto") this._maxWidth = this.model.width;
            } else this._maxWidth = this.model.maxWidth;
            if (ej.isNullOrUndefined(this.model.maxHeight)) {
                if (ej.isNullOrUndefined(this._sizeType.height)) this._maxHeight = +this.model.height;
                else if (this._sizeType.height == "px" || this._sizeType.height == "auto") this._maxHeight = this.model.height;
            } else this._maxHeight = this.model.maxHeight;
        },
        _percentageWidthDimension: function (parentObj) {
            this._ejDialog.outerWidth(this._convertPercentageToPixel(parentObj.outerWidth(), this._widthPercent));
            this._change = true;
        },
        _percentageHeightDimension: function (parentObj) {
            this._ejDialog.outerHeight(this._convertPercentageToPixel(parentObj.outerHeight(), this._heightPercent));
            this._change = true;
        },
        _pixelsWidthDimension: function (parentObj) {
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if (parseInt(this._ejDialog.css("width")) < parseInt(this._maxWidth)) {
                if (parseInt(this._maxWidth) < $(parentObj).outerWidth()) this._ejDialog.outerWidth((parseInt(this._maxWidth)));
                else this._ejDialog.outerWidth((parentObj.outerWidth()));
                this._change = true;
            }
        },
        _pixelsHeightDimension: function (parentObj) {
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (parseInt(this._ejDialog.css("height")) < parseInt(this._maxHeight)) {
                if (parseInt(this._maxHeight) < $(parentObj).outerHeight()) this._ejDialog.outerWidth((parseInt(this._maxHeight)));
                else this._ejDialog.outerHeight((parentObj.outerHeight()));
                this._change = true;
            }
        },
        _setWidth: function (parentObj) {
            this._ejDialog.outerWidth((parentObj.outerWidth()));
            this._change = true;
        },
        _setHeight: function (parentObj) {
            this._ejDialog.outerHeight((parentObj.outerHeight()));
            this._change = true;
        },
        _resizeContainer: function (parentObj) {
            this.contentDiv.width(this._ejDialog.width());
            this.element.outerWidth(this.contentDiv.width());
            var contentDivheight = this._ejDialog.height() - ((this.model.showHeader) ? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0);
            this.contentDiv.height((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.element.outerHeight((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.scroller = this.contentDiv.ejScroller({ width: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2, height: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this.element.outerHeight() : this.element.outerHeight() - 2, rtl: this.model.rtl, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            if ((this.model.position.X == "" || this.model.position.Y == "" && !this._minimize)||(this._positionChanged)) this._centerPosition();
            else this._ejDialog.css("height", this._dialogTitlebar.outerHeight());
            this._updateCaptionWidth();
            this._change = false;
        },
        _getLocalizedLabels:function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }, 

        _enableWindowResize: function () {
            return (this.model.isResponsive || ((isNaN(this.model.width) && (this.model.width.indexOf("%") > 0)) && (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0) && (this.model.height != "auto")))) ? true : false;
        },

        _wireResizing: function () {             
            $(window)[(this._enableWindowResize() ? "on" : "off")]('resize', $.proxy(this._reSizeHandler, this));                        
        },

        _wireEvents: function () {
            this._on(this._ejDialog, "keydown", this._keyDown);
            this._on(this._ejDialog, "click", this._mouseClick);
            this._wireResizing();
        },

        refresh: function () {
            this._resetScroller();
        },

        open: function () {
            if (this._isOpen) return true;
            if (true == this._trigger("beforeOpen")) return false;
            this.element.css("display", "block");
            this._setZindex();
            if (!this._minimize && !this._maximize && !this._init) this._dialogPosition();
            var proxy = this, effect = {}, height;
            this._ejDialog.show();
            if (this.model.enableAnimation) {
                this._ejDialog.css({ "opacity": 0});
                if (this.model.animation.show.effect == "slide") {
                    var eLeft = this._ejDialog.css("left");
                    this._ejDialog.css({ "left": -this._ejDialog.width() });
                    effect = { left: eLeft, opacity: 1 };
                }
                else {
                    effect = { opacity: 1 };
                }
            }
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.show.duration) : 0), function () {
                if (proxy.model) {
					  if (proxy._ejDialog.css("display") == "none") proxy._ejDialog.show();
                    proxy._ejDialog.eq(0).focus();
                    proxy._ejDialog.css({ "opacity": "" });
                    proxy.contentDiv.find("a:visible:enabled, button:visible:enabled, :input:visible:enabled, select:visible:enabled, .e-input").first().focus();
                    proxy._trigger("open");
                    proxy._updateCaptionWidth();
					if(proxy.model.enableModal && !proxy.model.backgroundScroll)
					{
						if( proxy._ejDialog.height() > $(window).height()) proxy._ejDialog.css("height",$(window).height());
						proxy.model.height=$(window).height(); proxy._overLay.css("position","fixed");
						proxy.scroller.refresh(true); proxy.refresh();
					}
                    if (proxy.model.maxHeight || proxy.model.maxWidth)
                    {
                        height = proxy._ejDialog.outerHeight(true) - ((proxy._dialogTitlebar ? proxy._dialogTitlebar.outerHeight(true) : 0));
                        if ((proxy.model.height == "auto" || proxy.model.height == "100%"))
                            height = proxy.model.height;
                        proxy._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? height : height - 2, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? proxy._ejDialog.width() : proxy._ejDialog.width() - 2);
                    }
                }
            });
            if (this.model.enableModal == true) this._createOverlay();
            this._isOpen = true;
            if (this.element.find("> .e-draggable.e-titlebar")) {
               var dragobject = $("#" + this.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                if (dragobject)
                    dragobject.option("cursorAt", this.element.offset());
            }
            return this;
        },

        close: function (event) {
            if (!this._isOpen || !this.model.enabled) return true;
            var isInteraction= event ? true : false;            
            if (true == this._trigger("beforeClose", { event: event,isInteraction:isInteraction })) return false;
            this._isOpen = false;
            var proxy = this, effect = {};
            if (this.model.enableAnimation) 
            effect = this.model.animation.hide.effect == "slide" ? { left: -this._ejDialog.width(), opacity: 0 } : { opacity: 0 };
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.hide.duration) : 0), function () {
                proxy._trigger("close", { event: event, isInteraction:isInteraction });
                proxy._ejDialog.hide();
            });
            if (this.model.enableModal){
                if (this._overLay) this._overLay.remove();
                if (!this.model.backgroundScroll) $("body").removeClass("e-dialog-modal");
            }
            return this;
        },

        isOpened: function () { return this.isOpen() },
        isOpen: function () { return this._isOpen; },

        setTitle: function (titleText) {
            this.model.title = titleText;
            this._titleText.text(titleText);
            this._updateCaptionWidth();
            return this;
        },

        setContent: function (htmlContent) {
            if (!this.model.enabled) return false;
            this.element.html(htmlContent);
            this._resetScroller();
            return this;
        },      

        focus: function () {
            this._setZindex();
            this.element.focus();
            return this;
        },

        minimize: function () {
			if(this.model.showHeader){
            this._actionMinimize();
            $(this.wrapper.find(".e-minus")[0]).parent().hide();
            return this;
			}
        },

        maximize: function () {
			if(this.model.showHeader){
            this._actionMaximize();
            $(this.wrapper.find(".e-maximize")[0]).removeClass("e-maximize").addClass("e-restore");
            $(this.wrapper.find(".e-restore")[1]).removeClass("e-restore").addClass("e-minus");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.restore);
            this.contentDiv.show();
            this._dialogTitlebar && this._dialogTitlebar.find(".e-minus").parent().show();
            this._hideIcon(true);
            return this;
			}
        },

        restore: function () {
			if(this.model.showHeader){
            var action = this._minimize;
            this._actionRestore();
            $(this.wrapper.find(".e-restore")[0]).removeClass("e-restore").addClass(action ? "e-minus" : "e-maximize");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
            this._hideIcon(true);
            return this;
			}
        },

        pin: function () {
			if(this.model.showHeader){
            this.dialogPin = true;
            $(this.wrapper.find(".e-unpin")[0]).removeClass("e-unpin").addClass("e-pin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.unPin);
            return this;
			}
        },

        unpin: function () {
            if(this.model.showHeader){
			this.dialogPin = false;
            $(this.wrapper.find(".e-pin")[0]).removeClass("e-pin").addClass("e-unpin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.pin);
            return this;
			}
        },

        collapse: function () {
			if(this.model.showHeader){
            this._actionCollapse();
            this._collapseValue=true;
            return this;
			}
        },

        expand: function () {
			if(this.model.showHeader){
            this._actionExpand();
            return this;
			}
        }
    });
    
ej.Dialog.Locale = ej.Dialog.Locale || {} ;
    
ej.Dialog.Locale["default"] = ej.Dialog.Locale["en-US"] = {
    tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },
    title:"",
     //currently we have deprecated this API
    closeIconTooltip: "close"
};

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 

    ej.widget("ejDropDownList", "ej.DropDownList", {
        element: null,

        model: null,
        validTags: ["select", "input"],
        _addToPersist: ["value", "text", "selectedIndex", "selectedItemIndex", "selectedItems", "selectedIndices", "popupWidth", "popupHeight", "itemValue"],
        _setFirst: false,

        _rootCSS: "e-dropdownlist",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },
        _requiresID: true,
      


        defaults: {
            cssClass: "",

            value: null,

            htmlAttributes: {},

            text: null,

            itemValue: "",

            itemsCount: 0,

            dataSource: null,

            delimiterChar: ',',

            query: null,

            fields: {
                id: null,

                text: null,

                value: null,

                category: null,
                
                groupBy:null,

                imageUrl: null,

                imageAttributes: null,

                spriteCssClass: null,

                htmlAttributes: null,

                selected: null,

                tableName: null
            },
			
			locale: "en-US",

            watermarkText: null,

            height: "",

            loadOnDemand: false,

            width: "",

            popupHeight: "152px",

            popupWidth: "auto",

            maxPopupHeight: null,

            minPopupHeight: '20',

            maxPopupWidth: null,

            minPopupWidth: '0',

            targetID: null,

            template: null,

            headerTemplate: null,

            selectedItemIndex: -1,

            selectedIndex: -1,

            disableItemsByIndex: null,

            enableItemsByIndex: null,

            selectedItems: [],

            selectedIndices: [],

            cascadeTo: null,

            enablePopupResize: false,

            allowVirtualScrolling: false,

            virtualScrollMode: "normal",

            showRoundedCorner: false,

            showPopupOnLoad: false,

            enableRTL: false,

            enabled: true,

            filterType: "contains",

            sortOrder: "ascending",

            caseSensitiveSearch: false,

            showCheckbox: false,

            checkAll: false,

            uncheckAll: false,

            enablePersistence: false,

            enableFilterSearch: false,

            enableServerFiltering: false,

            enableIncrementalSearch: true,

            readOnly: false,

            enableAnimation: false,

            multiSelectMode: "none",

            allowGrouping: false,

            enableSorting: false,

            validationRules: null,

            validationMessage: null,

            actionBegin: null,

            actionComplete: null,

            actionFailure: null,

            actionSuccess: null,

            create: null,

            popupHide: null,

            popupShown: null,

            beforePopupShown: null,

            beforePopupHide: null,

            popupResizeStart: null,

            popupResize: null,

            popupResizeStop: null,

            change: null,

            select: null,

            dataBound: null,

            search: null,

            checkChange: null,

            cascade: null,

            destroy: null

        },

        dataTypes: {
            cssClass: "string",
            itemsCount: "number",
            watermarkText: "string",
            template: "string",
            disableItemsByIndex: "string",
            enableItemsByIndex: "string",
            enableIncrementalSearch: "boolean",
            cascadeTo: "string",
            delimiterChar: "string",
            showRoundedCorner: "boolean",
            showPopupOnLoad: "boolean",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            allowVirtualScrolling: "boolean",
            virtualScrollMode: "enum",
            enabled: "boolean",
            readOnly: "boolean",
            multiSelectMode: "enum",
            dataSource: "data",
            query: "data",
            fields: "data",
            selectedItems: "array",
            enableAnimation: "boolean",
            allowGrouping: "boolean",
            enableSorting: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
			locale:"string"
        },

        observables: ["value", "selectedItemIndex", "selectedIndex"],
        value: ej.util.valueFunction("value"),
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        selectedIndex: ej.util.valueFunction("selectedIndex"),
        

        enable: function () {
            if (this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = false;
                this.model.enabled = true;
				this.container.removeClass('e-disable');
                this._visibleInput.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
                if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.removeClass('e-disable');
                if (this._isIE8) this.drpbtnspan.removeClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
                if (this.model.multiSelectMode == "visualmode") this._ulBox.removeClass("e-disable");
                this.wrapper.attr('tabindex', '0');
            }
            this._wireEvents();
        },

        disable: function () {
            if (!this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = true;
                this.model.enabled = false;
				this.container.addClass('e-disable');
                this._visibleInput.addClass('e-disable');
                if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
                if (this._isIE8) this.drpbtnspan.addClass("e-disable");
                if (this.model.multiSelectMode == "visualmode") this._ulBox.addClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
                this._unwireEvents();
                this.wrapper.removeAttr('tabindex');
                if (this._isPopupShown()) this._hideResult();
            }
        },

        /* will deprecate with text property */
        getValue: function () {
			return this._visibleInput.val();
        },
        _setValue: function (value) {
            if (!ej.isNullOrUndefined(value)) {
                if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0))this._showFullList();
                this._raiseEvents = false;
                if (!ej.isNullOrUndefined(this.model.text)) this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this._addValue(value);
                this.selectItemByValue(value);
            }
        },
        _addValue: function (args) {
            if (this.model.itemsCount > 0 && args != "") {
                this._checkValue = true;
                var listitems = args.split(this.model.delimiterChar);
                var field = this.mapFld._value; 
                this._addListItems(listitems, this._rawList, "local");
                if (this._checkValue) {
                    var source = this.model.dataSource;
                    if (ej.DataManager && source instanceof ej.DataManager) {
                        if (source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0))
                            this._addListItems(listitems, source.dataSource.json,"remote");
                        else {
                            var proxy = this;
                            var value= args;
                                source.executeQuery(ej.Query()).done(function (e) {
                                proxy._addListItems(listitems, e.result, "remote");
                                proxy.selectItemByValue(value);
                            });
                        }
                    }
                    else
                        this._addListItems(listitems, source, "remote");
                }

            }
        },
        _addListItems: function (listitems, source, checkValue) {
            for (k = 0; k < listitems.length; k++) {
                for (var i = 0; i < source.length; i++) {
                    if (checkValue == "local" && source[i][this.mapFld._value] == listitems[k])
                        this._checkValue = false;
                    if (checkValue == "remote" && source[i][this.mapFld._value] == listitems[k])
                        this.addItem(source[i]);
                }
            }
        },
        _setText: function (text) {
            if (text) {
                if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0))this._showFullList();
                this._raiseEvents = false;
                this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this.selectItemByText(text);
            }
        },
        _setItemValue: function (itemValue) {
            this.model.itemValue = itemValue;
        },
        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) this._visibleInput.attr("placeholder", text);
            else this._hiddenSpan.text(text);
        },

        hidePopup: function () {
            if (!this.model.enabled) return false;
            if (this.ultag.find('li').length > 0)
                this._hideResult();
        },

        showPopup: function () {
            if (!this.model.enabled) return false;
            var ultag = !ej.isNullOrUndefined(this.ultag) ? this.ultag.find('li').length > 0 : (this.model.loadOnDemand) ? true: false;
            if (ultag)
                this._showResult();
        },

        clearText: function () {
            this._clearTextboxValue(); 
            if (!this._isWatermark)
                this._setWatermark();
        },

        addItem: function (itemTag) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            if (!this.model.enabled || !itemTag) return false;
            this._mapFields();
            var list = $.isArray(itemTag) ? itemTag : [itemTag];
            if (list.length < 1) return false;
            var mapper = this.mapFld,
                mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null, _category: null };
            mapFld._id = list[0][mapper._id] ? mapper._id : "id";
            mapFld._imageUrl = list[0][mapper._imageUrl] ? mapper._imageUrl : "imageUrl";
            mapFld._imageAttributes = list[0][mapper._imageAttributes] ? mapper._imageAttributes : "imageAttributes";
            mapFld._spriteCSS = list[0][mapper._spriteCSS] ? mapper._spriteCSS : "spriteCssClass";
            mapFld._text = list[0][mapper._text] ? mapper._text : "text";
            mapFld._value = list[0][mapper._value] ? mapper._value : "value";
            mapFld._htmlAttributes = list[0][mapper._htmlAttributes] ? mapper._htmlAttributes : "htmlAttributes";
            mapFld._selected = list[0][mapper._selected] ? mapper._selected : "selected";
            mapFld._category = list[0][mapper._category] ? mapper._category : "groupBy";
            this._generateLi(list, mapFld);
            
            var i, listItems = this.dummyUl;
            for (var i = 0; i < list.length; i++)
                this._listItem(list[i], "add");
            if (this.model.showCheckbox) {
                this._appendCheckbox(listItems, true);               
            }
            else if (!this._isSingleSelect()) this._multiItemSelection(listItems, true);
			this._virtualUl.append($(this.dummyUl).clone(true));
            this.ultag.append(this.dummyUl);

            if (this._isPopupShown()) {
                var scrollerPosition = this.scrollerObj ? this.scrollerObj.scrollTop() : 0;
                this._refreshScroller();
                if (this.scrollerObj) this.scrollerObj.option("scrollTop", scrollerPosition);
            }
        },

        _toArray: function (index, mode) {
            var items;
            if (typeof index == "function") index = ej.util.getVal(index);
            if ($.isArray(index)) items = index;
            else if (typeof index == "string") {
                if ((mode && (this.model.multiSelectMode == "visualmode" || this.model.multiSelectMode == "delimiter" || this.model.showCheckbox))) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else if (!mode) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else items = [index];
            } else items = [index];
            return items;
        },
        _trim: function (val) {
            return typeof val == "string" ? $.trim(val) : val;
        },
        /*will deprecate with selectItemsByIndices */
        selectItemByIndex: function (index) {
            this._selectItemByIndex(index);
        },

        selectItemsByIndices: function (index) {
            this._selectItemByIndex(index);
        },

        _selectItemByIndex: function (val) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            this.listitems = this._getLi();
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
			if( parseInt(val) == -1 && this.model.selectedItems.length > 0) {
				this._clearTextboxValue();
				this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
			}
			else {
            var items = this._toArray(val, true), index;
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                if (index != null && index >= 0) {
                    if ($.inArray(index, this._selectedIndices) == -1)
                        for (var i = 0; i < this.listitems.length; i++) {
                            if (!$(this.listitems[i]).hasClass('e-disable')) {
                                if (i == index) {
                                    this.selectedIndexValue = i;
                                    this._activeItem = index;
                                    this._enterTextBoxValue();
                                }
                            }
                        }
                } else if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && this.model.selectedItems.length > 0) {
					this._clearTextboxValue();
				   this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
				} 
            }
			}
        },

        unselectItemsByIndices: function (val) { this._unselectItemByIndex(val); },

        /*will deprecate with unselectItemsByIndices method */
        unselectItemByIndex: function (val) { this._unselectItemByIndex(val); },

        _unselectItemByIndex: function (val) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            var i, items = this._toArray(val, true), index;
            this.listitems = this._getLi();
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                for (i = 0; i < this.listitems.length; i++) {
                    if (i == index) {
                        this.selectedIndexValue = i;
                        this._activeItem = index;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                    }
                }
            }
        },

        /*Deprecated with selectedItemByValue */
        setSelectedValue: function (idvalue) { this.selectItemByValue(idvalue); },

        selectItemByValue: function (val) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            var i, hidelement; 
            this.listitems = this._getLi();
            if(this.inputSearch && this.inputSearch.val() != "" && this.model.enableServerFiltering && !ej.isNullOrUndefined(this._searchresult)){
                var field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
                for(i=0; i< this._searchresult.length; i++){
                for (var j = 0; j < this.listitems.length; j++) {
					if ($(this.listitems[j]).attr("data-value") == this._searchresult[i][field]) {
						this._searchresult=null;
					}
                }
            }
                this.addItem(this._searchresult);
            }
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else { 
                this._selectUnSelectValue(val, "selectValue");
            }
        },

        _selectUnSelectValue: function(val, selectValue, ignoreCasing){
             var items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable') && (selectValue=="selectValue" || selectValue=="selectText")) {
                            if(selectValue=="selectValue"){
                                var fieldValue = this._getAttributeValue(this.listitems[i]) || $(this.listitems[i]).text();
                                this._selectedValue = fieldValue == items[k]; 
                            }
                            if(selectValue=="selectText"){
                                this.selectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                                this._selectedValue = (this.selectedTextValue == items[k]) || (ignoreCasing && this.selectedTextValue.toString().toLowerCase() == items[k].toString().toLowerCase())
                            }  
                                if (this._selectedValue) {
                                    this._activeItem = i;
                                    this._aselectedItem = this._activeItem;
                                    this._enterTextBoxValue();
                                    break;
                                } 
                        }
                        else{ 
                             if (this._getAttributeValue(this.listitems[i])) {
                                 if(selectValue=="unselectValue"){
                                this._selectedValue = this._getAttributeValue(this.listitems[i]);
                                this._selectedValue = this._selectedValue == items[k]; 
                            }
                            if(selectValue=="unselectText"){
                                this.unselectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                                this._selectedValue = (this.unselectedTextValue == items[k]) || (ignoreCasing && this.unselectedTextValue.toString().toLowerCase() == items[k].toString().toLowerCase())
                            }   
                                if (this._selectedValue) {
                                    this._activeItem = i;
                                    if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                                        this._removeTextBoxValue();
                                     break;
                                }
                            }
                        }
                    }
                }
        },

        unselectItemByValue: function (val) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0))this._showFullList();
            var i, hidelement;
            this.listitems = this._getLi(); 
            this._selectUnSelectValue(val, "unselectValue");
        },

        /* Deprecated with selectItemByText*/
        setSelectedText: function (value) { this.selectItemByText(value); },

        selectItemByText: function (val) {
            var i, hidelement, items;
            this.listitems = this._getLi();
            this._mapFields();
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else {
                items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable')) {
                            this.selectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                            if (this.selectedTextValue == items[k]) {
                                this._activeItem = i;
                                this._aselectedItem = this._activeItem;
                                this._enterTextBoxValue();
                                break;
                            }
                        }
                    }
                }
            }
        },


        unselectItemByText: function (val) {
            var i, hidelement, items = this._toArray(val, true);
            this.listitems = this._getLi();
            this._mapFields();
            for (var k = 0; k < items.length; k++) {
                for (i = 0; i < this.listitems.length; i++) {
                    this.unselectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    if (this.unselectedTextValue == items[k]) {
                        this._activeItem = i;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                        break;
                    }
                }
            }
        },

        getSelectedValue: function () {
			return this.element.val();
        },

        getSelectedItem: function () {
            var k, selected = [];
            this.listitems = this._getLi();
            for (k = 0; k < this._selectedIndices.length; k++) {
                selected.push(this.listitems[this._selectedIndices[k]]);
            }
            return selected;
        },
        getItemDataByValue: function (value) {
            var listitems = this._toArray(value, false);
			var rawList  = (!ej.isNullOrUndefined(this.resultList)) ? this._rawList.concat(this.resultList): this._rawList;
            var k, m, selected = [], field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
            for (k = 0; k < listitems.length; k++) {
                for (m = 0; m < rawList.length; m++) {
                    if (rawList[m][field] == listitems[k])
                        selected.push(rawList[m]);
                }
            }
            return selected;
        },

        getListData: function () { return this._rawList; },

        /* will be deprecate in upcoming releases*/
        getSelectedItemsID: function () {
            return this._selectedItemsID;
        },

        disableItemsByIndices: function (value) { this._disableItemByIndex(value) },

        /*Deprecated with disableItemsByIndices method */
        disableItemByIndex: function (value) { this._disableItemByIndex(value) },

        _disableItemByIndex: function (value) {
            if (!this.model.enabled) return false;
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            var listitems = this._toArray(value, false),index;
            for (var i = 0; i < listitems.length; i++) {
                if (listitems[i] != null && !isNaN(parseInt(listitems[i]))) {
                    if (listitems.length > 0 && !($.inArray(parseInt(listitems[i]), this._disabledItems) > -1)) {
                        index = $.inArray(listitems[i], this._disabledItems);
                        this._setClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                        this._disabledItems.push(parseInt(listitems[i]));
                        this.model.disableItemsByIndex = String(this._disabledItems.join(","));
                    }
                }
            }
        },

        enableItemsByIndices: function (value) { this._enableItemByIndex(value) },

        /*Deprecated with enableItemsByIndices method */
        enableItemByIndex: function (value) { this._enableItemByIndex(value) },

        _enableItemByIndex: function (value) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0)) this._showFullList();
            var listitems = this._toArray(value, false), index;
            this.model.enableItemsByIndex = value;
            for (var i = 0; i < listitems.length; i++) {
                if (listitems.length > 0 && ($.inArray(parseInt(listitems[i]), this._disabledItems) > -1) &&  !isNaN(parseInt(listitems[i]))) {
                    index = $.inArray(parseInt(listitems[i]), this._disabledItems);
                    this._removeClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                    this._disabledItems.splice(index, 1);
                }
            }
            this.model.enableItemsByIndex = null;
            this.model.disableItemsByIndex = this._disabledItems.join(this.model.delimiterChar);
        },
        _validateDelimiter: function (deli) {
            if (this._trim(deli).length == 1) {
                var RegEx = /^[a-zA-Z0-9]+$/;
                if (!RegEx.test(deli)) return deli;
            }
            return ",";
        },

        _removeText: function (currentValue) {
            var eleVal = this.element[0].value.split(this.model.delimiterChar), hidVal = this._visibleInput[0].value.split(this.model.delimiterChar),
            index = $.inArray(currentValue, eleVal);
            if (index >= 0) {
                eleVal.splice(index, 1);
                hidVal.splice(index, 1);
            }
            this.element[0].value = eleVal.join(this.model.delimiterChar);
            this._visibleInput[0].value = hidVal.join(this.model.delimiterChar);
        },
        _addText: function (currentValue) {
            if (this._checkContains(this._hiddenValue)) return false;
            var ele = ["element", "_visibleInput"], val;
            for (var i = 0; i < ele.length; i++) {
                val = ele[i] == "element" ? this._hiddenValue : currentValue;
                if (this[ele[i]][0].value && this[ele[i]][0].value != "") {
                    var splitedText = this[ele[i]][0].value.split(this.model.delimiterChar);
                    splitedText.push(val);
                    this[ele[i]][0].value = splitedText.join(this.model.delimiterChar);
                } else this[ele[i]][0].value = val;
            }
        },
        _checkContains: function (chkValue) {
            var values = this.element[0].value.split(this.model.delimiterChar);
            this.contains = false;
            for (var i = 0; i < values.length; i++) {
                if (this._parseValue(values[i]) === this._parseValue(chkValue)) {
                    this.contains = true;
                    break;
                }
            }
            return this.contains;
        },
		_parseValue: function (value){
			return isNaN(parseInt(value)) || (typeof(this._rawList[0][this.mapFld._value]) == 'string') ? value : parseInt(value);
		},
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.DropDownList", this.model.locale);
        },
        _init: function () {
            var browserInfo = ej.browserInfo();
            this._updateLocalConstant();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0');
            this._textContent = this._isIE8 ? "innerText" : "textContent";
            if ((this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type'))) || this.element.is("select")) {
                this._isWatermark = 'placeholder' in $(document.createElement('input')).attr("placeholder", '')[0];
                this._id = this.element[0].id;
                this._initialize();
                this._render();
                this._addAttr(this.model.htmlAttributes);
                this._enabled(this.model.enabled);
                this._initValue = false;
                this._checkboxValue = false;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            }
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                this.element.rules("add", this.model.validationRules);
                var validator = this.element.closest("form").data("validator");
                if (!validator) validator = this.element.closest("form").validate();
                var name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                            message = this.model.validationRules["messages"][ruleName];
                        else {
                            validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                    }
                }
            }
        },

        _setInitialPopup: function (value) {
            if (this.model.enabled && !this.model.readOnly)
                value == false ? this._hideResult() : this._showResult();
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            if(!ej.isNullOrUndefined(this.popupListWrapper))this.popupListWrapper.removeClass(this.model.cssClass).addClass(skin);
        },

        _setRTL: function (val) {
            if (this.model.enableRTL != val) {
                this.model.enableRTL = val;
                this._RightToLeft();
                if(!ej.isNullOrUndefined(this.popupListWrapper)) this._dropbtnRTL();
            }
        },

        _changeHeight: function (height) {
            this.wrapper.height(height);
            this._setListHeight();
        },
        _changeWidth: function (width) {
            this.wrapper.width(width);
            this._setListWidth();
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "dataSource": if (!this._isEqualDataSource(options[option])) this._checkModelDataBinding(options[option], this.model.query); break;
                    case "query": this._checkModelDataBinding(this.model.dataSource, options[option]); break;
                    case "fields": this.model.fields = $.extend(this.model.fields, options[option]); this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "itemsCount": this.model.itemsCount = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query);; break;
                    case "template": this.model.template = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "value": 
					var optionValue = ej.util.getVal(options[option]);
					if (ej.isNullOrUndefined(optionValue) || optionValue === "") this._clearTextboxValue();
					if (ej.isNullOrUndefined(optionValue) || optionValue === "") this._clearTextboxValue();
                    else { this._setValue(ej.util.getVal(options[option])); options[option] = this.model.value; } break;
                    case "delimiterChar": 
						var delchar = this.model.delimiterChar; 
						options[option] = this._validateDelimiter(options[option]);
                        this.model.delimiterChar = options[option];
                        if (!this._isSingleSelect()) {
						if (this.model.text) {
							this.model.text = this.model.text.split(delchar).join(this.model.delimiterChar);
							this._visibleInput.val(this.model.text);							
						}
						if(!ej.isNullOrUndefined(this.value())) {
							this.value(this.value().split(delchar).join(this.model.delimiterChar));
							this.element.val(this.value());	
						}
                    }
                        break;
                    case "text": if (ej.isNullOrUndefined(options[option]) || options[option] === "") this._clearTextboxValue();
                    else { this._setText(options[option]); options[option] = this.model.text; } break;
                    case "itemValue": this._setItemValue(options[option]); break;
                    case "enableRTL": this._setRTL(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "height": this._changeHeight(options[option]); break;
                    case "width": this._changeWidth(options[option]); break;
                    case "popupHeight": this.model.popupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "minPopupHeight": this.model.minPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "minPopupWidth": this.model.minPopupWidth = options[option]; this._setListWidth(); break;
                    case "maxPopupHeight": this.model.maxPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "maxPopupWidth": this.model.maxPopupWidth = options[option]; this._setListWidth(); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showCheckbox": this.model.showCheckbox = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        this._checkboxHideShow(options[option]);
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else if (_textes && _textes.length)
                            this._setText(_textes[0]);
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will depreciate with checkAll  Method*/
                    case "checkAll": this._setCheckAll(options[option]); return false; break;
                        /* will depreciate with uncheckAll  Method*/
                    case "uncheckAll": this._setUncheckAll(options[option]); return false; break;
                    case "watermarkText": this._changeWatermark(options[option]); break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "showRoundedCorner": this._roundedCorner(options[option]); this.model.showRoundedCorner = options[option]; break;
                    case "showPopupOnLoad": this._setInitialPopup(options[option]); break;
                    case "targetID": this.model.targetID = options[option]; this._showFullList(); break;
                        /* will depreciate with selectedIndex  Method*/
                    case "selectedItemIndex":
                    case "selectedIndex":
                        this._selectItemByIndex(options[option]);
                        this.model.selectedItemIndex = this.model.selectedIndex = options[option];
                        break;
                        /* will depreciate with unselectItemByIndex API Method*/
                    case "unselectItemByIndex": this._unselectItemByIndex(options[option]); break;
                        /* will depreciate with disableItemsByIndex API Method*/
                    case "disableItemsByIndex": this._disableItemByIndex(options[option]); break;
                        /* will depreciate with enableItemsByIndex API Method*/
                    case "enableItemsByIndex": this._enableItemByIndex(options[option]); break;
                        /* will depreciate with selectedIndices  Method*/
                    case "selectedItems":
                    case "selectedIndices":
                        this._selectCheckedItem(options[option]);
                        options[option] = this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        break;
                    case "multiSelectMode":
                        if (this.model.multiSelectMode == "visualmode") {
                            this._swapUlandInput(false);
                            this._ulBox.remove();                         
                            this._ulBox = null;                     
                        }
                        this.model.multiSelectMode = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else {
                            this._setText(_textes[0]);
                            this.wrapper.find("input[name=" + this._name + "]").remove();
                        }
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will deprecate with fields.groupBy and e-category element in target element binding */
                    case "allowGrouping":
                        this._setGroupingAndSorting("allowGrouping", options[option]);
                        break;
                    case "enableSorting":
                        this._setGroupingAndSorting("enableSorting", options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "enablePopupResize": this.model.enablePopupResize = options[option];
                        (options[option]) ? this._enablePopupResize() : this.popupListWrapper.removeClass("e-resizable").find(".e-resizebar").remove() && this._hideResult();
                        break;
                    case "enableFilterSearch":
                        if (!options[option]) this._removeSearch();
                        else {
                            this.model.enableFilterSearch = true;
                            this._enableSearch();
                            break;
                        } 
                        case "enableServerFiltering": 
                            this._enableSearch();
                            break; 
                }
            }
        },

        _clearTextboxValue: function () {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = this.model.itemValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = []; this._selectedIndices = [];
            this.model.selectedItems = [];
            this.model.selectedIndices = [];
            this.selectedIndex(null);
            if(!ej.isNullOrUndefined(this.ultag)){
            this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
            if (this.model.showCheckbox) this._resetCheck();
            }
            if (this.wrapper.find('ul.e-ul.e-boxes').length != 0) {
                this._ulBox.children("li").remove();
                if (this._name === "")
                    this.wrapper.find("input:hidden[id^='#']").remove();
                else
                    this.wrapper.find("input:hidden[id^='#'][name=" + this._name + "]").remove();
                $(this.element).attr("name", this._name);
            }
        },

        _destroy: function () {
            if( this.selectOptions) {
                if (!this.model.dataSource && this.docbdy ) 
                    this.docbdy.append(this.selectOptions.removeClass("e-dropdownlist e-js").show()).show();
                else this.selectOptions.insertAfter(this.wrapper).removeClass("e-dropdownlist e-js").show();
                this.element.remove();
            }
            else {
                this.element.insertAfter(this.wrapper);
                this.element.width(this.element.width() + this.dropdownbutton.outerWidth());
                this._visibleInput.removeClass("e-input ");
                this._setAttr( this.element[0], { 'accesskey': this.wrapper.attr('accesskey'), type:"text" });
                if (this._isWatermark) this._visibleInput.removeAttr("placeholder");
                this.element[0].value = "";
                this.element.removeAttr("aria-expanded aria-autocomplete aria-haspopup aria-owns accesskey role").css({"width": "", "display": "block"});
                (!this.model.dataSource) && this.docbdy && this.ultag.find("li").removeClass("e-active") && this.docbdy.append(this.ultag.html()).show();
            }
            this.wrapper.remove();
            this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
            this._hideResult();
            this.popupPanelWrapper.remove();
			this._unwireEvents();
        },


        _finalize: function () {
            if (this.value() == "" && this._visibleInput[0].value !== "")
                this._updateValue(this.element[0].value);
            if (this.value() !== this.element.val())
                this._setValue(this.value());
            if (this.model.text != this._visibleInput.val())
                this._setText(this.model.text);
            this.selectedIndex((this.selectedIndex() != -1) ? this.selectedIndex() : this.selectedItemIndex());
            if (this.selectedIndex() != -1) {
                this._selectItemByIndex(this.selectedIndex());
            } else if (this._selectedIndices.length > 0) {
                this._selectCheckedItem(this._selectedIndices);
            } if (this.model.disableItemsByIndex != null)
                this._disableItemByIndex(this.model.disableItemsByIndex);
            if (this.model.enableItemsByIndex != null)
                this._enableItemByIndex(this.model.enableItemsByIndex);
        },


        _initialize: function () {
            this._selectedIndices = this.model.selectedIndices.length > 0 ? this.model.selectedIndices : this.model.selectedItems;
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            this.model.selectedIndex = this.model.selectedIndex != -1 ? this.model.selectedIndex : this.model.selectedItemIndex;
            if (this.element.is("select")) {
                this.selectelement = true;
                this._renderSelectToDropdown();
            }
            this._selectedItemsID = [];
            this.target = this.element[0];
            this._disabledItems = new Array();
            this._queryString = null;
            this.suggLen = 0;
            this._itemId = null;
            this.checkedStatus = false;
            this._incqueryString = "";
            this._activeItem = null;
            this.ddWidth = 0;
            this._initValue = true;
            this._virtualCount = 0;
            this._raiseEvents = true;
            this.popUpShow= false; 
        },
        _renderSelectToDropdown: function () {
            var i, optionLength, optionText, item;
            this.inputElement = ej.buildTag("input.e-dropdownlist#" + this._id + "_input", "", {}, { "type": "text", "data-role": "none" });
            this.inputElement.insertAfter(this.element);
			if (this.element.attr("name")) {
                this.inputElement.attr("name", this.element.attr("name"));
                this.element.removeAttr("name");
            }
			this.selectOptions = this.element;
            this.selectOptions.attr('id', this._id);
			if( this.model.dataSource == null ) {
            this.optionDiv = ej.buildTag("div#" + this._id + "_list");
            this.optionDiv.insertAfter(this.inputElement);
            this.optionUl = ej.buildTag("ul");
            this.optionDiv.append(this.optionUl);

            this.selectOptionItems = this.element.children("option");
            optionLength = this.selectOptionItems.length;
            this.optionDummyUl = $();

            for (i = 0; i < optionLength; i++) {
                item = this.selectOptionItems[i], optionText = $(item).attr('label') ? $(item).attr('label') : item.innerHTML;
                if (optionText != null) {
                    this.optionLi = ej.buildTag("li", optionText, {}, { 'data-value': item.value, "unselectable": "on" });
                    this.optionDummyUl.push(this.optionLi[0]);
                    if ($(item).attr("selected")) {
                        if (this.model.showCheckbox)
                            if ($.inArray(i, this._selectedIndices) == -1) {
                                this._selectedIndices.push(i);
                                this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                            }
                            else if (ej.isNullOrUndefined(this.selectedIndex())) this.selectedIndex(i);
                    }
                }
            }
            this.optionUl.append(this.optionDummyUl);

			}
            this.element.css('display', 'none');
            this.element = this.inputElement;
        },


        _render: function () {
            this._renderDropdown();
            this._setWatermark();
            if (this.model.loadOnDemand && (!this.model.dataSource || this.model.dataSource.length < 1)) {
            var predecessor = this.element.parents().last();
            this.docbdy = this.model.targetID ? predecessor.find("#" + this.model.targetID) : this.optionDiv ? this.optionDiv : null;
            this.itemsContainer = this.docbdy[0].nodeName == "UL" ? this.docbdy : this.docbdy.children("ol,ul");
            this.itemsContainer.css("display", "none");
            }
            if(!this.model.loadOnDemand){
            this._renderPopupPanelWrapper();
            this._showFullList();
            }
            this._roundedCorner(this.model.showRoundedCorner);
            //To call finalize() only local data source
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._finalize();
                }               
            }
            else this._finalize();
            if (!(ej.DataManager && this.model.dataSource instanceof ej.DataManager)){
                
                 this._finalize();
            }        
            if(this.model.loadOnDemand && (ej.DataManager && this.model.dataSource instanceof ej.DataManager && !this.model.dataSource.dataSource.offline)) this._finalize();       
            this._setCheckAll(this.model.checkAll);
            if(this.element.attr("disabled") || $(this.selectOptions).attr("disabled"))this.disable();
            if(this.model.loadOnDemand)this.model.showPopupOnLoad && this._showResult();
        },

        _isEqualDataSource: function (source) {
            if (!this.model.dataSource || !source || !(this.model.dataSource.length === source.length) || (ej.DataManager && source instanceof ej.DataManager)) return false;
            var equal = true;
            for (var i = 0, len = this.model.dataSource.length; i < len; i++) {
                if (this.model.dataSource[i] !== source[i]) {
                    equal = false;
                    break;
                }
            }
            return equal;
        },

        _checkModelDataBinding: function (source, query) {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = [];
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices = [];
            this.model.selectedIndex = this.model.selectedItemIndex = -1;
            if (this.model.multiSelectMode == "visualmode") this._destroyBoxModel();
            this.model.dataSource = source;
            this.model.query = query;
            !ej.isNullOrUndefined(this.ultag) && this.ultag.empty();
            this._showFullList();
        },
        _initDataSource: function (source) {
            var proxy = this;
            if (ej.DataManager && source instanceof ej.DataManager) {
                proxy._addLoadingClass();
                if (!proxy._trigger("actionBegin", { requestFrom: "default" })) {
                    var queryPromise = source.executeQuery(this._getQuery());
                    queryPromise.done(function (e) {
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "default" });
                        proxy._totalCount = e.count;
                        proxy._listItem(e.result);
                        proxy._removeLoadingClass();
                        proxy._renderPopupList();
                        proxy._finalize();

                    }).fail(function (e) {
                        proxy.model.dataSource = null;
                        proxy._addLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "default" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "default" });
                    });
                }
            }
        },
        _listItem: function (list, type) {
            if (type == "add") {
                this.popupListItems.push(list);
                this._rawList.push(list);
            } else if ($.isArray(list)) {
                this.popupListItems = list.slice(0);
                this._rawList = list.slice(0);
            }
        },
        _getQuery: function (isLocal) {
            var remoteUrl, mapper = this.model.fields, queryManager = ej.Query();
            if (ej.isNullOrUndefined(this.model.query) && !this.model.template && !isLocal) {
                var column = [];
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
            }
            else if (this.model.query) queryManager = this.model.query.clone();

            if (this.model.allowVirtualScrolling) queryManager.requiresCount();
            if (this.model.itemsCount > 0) queryManager.take(this.model.itemsCount);

            remoteUrl = this.model.dataSource.dataSource;
            if (mapper)
                if ((remoteUrl && remoteUrl.url && !remoteUrl.url.match(mapper.tableName + "$")) || (remoteUrl && !remoteUrl.url) || (!remoteUrl))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);

            return queryManager;
        },

        _addLoadingClass: function () {
            if (this._isPopupShown()) {
                this.popupListWrapper.addClass("e-load");
            } else {
                this.dropdownbutton.addClass("e-load");
                this.drpbtnspan.removeClass("e-icon e-arrow-sans-down");
            }
            this._readOnly = true;
        },
        _removeLoadingClass: function () {
            this.dropdownbutton.removeClass("e-load");
            this.drpbtnspan.addClass("e-icon e-arrow-sans-down");
            this._readOnly = false;
            if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.removeClass("e-load");
        },

        _renderDropdown: function () {
            this.wrapper = ej.buildTag("span.e-ddl e-widget " + this.model.cssClass + "#" + this._id + "_wrapper", "", {}, { "tabindex": "0", "accesskey": this.element.attr("accesskey") });
            this.container = ej.buildTag("span.e-in-wrap e-box " + "#" + this._id + "_container");
            this.element.removeAttr('accesskey');            
			if(this.model.value == null && this.element.attr("value") != null)
				this.model.value = this.element.attr("value");				
			this.element.attr("value","").val("");
            if(!this._isIE8)
            this._setAttr(this.element[0], { "type":"hidden","role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();
			else
			this._setAttr(this.element[0], {"role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();			
            this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select", "unselectable": "on" });
            this.dropdownbutton = ej.buildTag("span.e-select#" + this._id + "_dropdown", "", {}, { "role": "button", "unselectable": "on" }).append(this.drpbtnspan);
            this.container.insertAfter(this.element);
            this.container.append(this.element);
            this.container.append(this.dropdownbutton);
            this.wrapper.insertBefore(this.container);
            this.wrapper.append(this.container);
            if (this.selectelement) {
                this.selectOptions.insertBefore(this.element);
            }
            this._visibleInput = ej.buildTag("input#" + this._id + "_hidden", "", {}).insertAfter(this.element);
            this._visibleInput.addClass("e-input ");
			this._setAttr(this._visibleInput[0],{ "readonly": "readonly", "tabindex": -1,"data-role": "none" });        
            if (!this._isWatermark) {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(watermark);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.on("mousedown", $.proxy(this._OnDropdownClick, this));
            }
            this._checkNameAttr();
            this._setDimentions();
            this._RightToLeft();
            this.ddWidth = (this.dropdownbutton.outerWidth() > 0) ? this.dropdownbutton.outerWidth() : 24;
            //Element not Maintain in Multiselection
            this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
        },

        _checkNameAttr: function () {
            this._name = ej.isNullOrUndefined(this.element.attr("name")) ? this._id : this.element.attr("name");
            this.element.attr("name", this._name);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
				var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value); 
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true; 
                else if (keyName == "style") proxy.wrapper.attr(key, value);
				else if (ej.isValidAttr(proxy._visibleInput[0], key)) $(proxy._visibleInput).attr(key, value);
                else proxy.wrapper.attr(key, value)
            });
        },
        _renderBoxModel: function () {
            if (!ej.isNullOrUndefined(this._ulBox) || this.model.multiSelectMode != "visualmode") return false;
            this._ulBox = ej.buildTag("ul.e-ul e-boxes");
            this.container.prepend(this._ulBox);
            this._ulBox.css('min-height', '30px');
            this._ulBox.css('display', 'none');
            this._on(this.container, "click", function (e) {
                if (!this.model.enabled) return false;
                var $target = $(e.target);
                if ($target.hasClass("e-options")) {
                    if (!e.ctrlKey && $target.siblings().hasClass("e-active")) this._removeActive();
                    if ($target.hasClass("e-active")) $target.removeClass("e-active");
                    else $target.addClass("e-active");
                }
                if (!e.ctrlKey && ($target.hasClass("e-boxes"))) this._removeActive();
            });
        },

        _renderPopupPanelWrapper: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup_wrapper").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popupPanelWrapper = ej.buildTag("div#" + this._id + "_popup_wrapper");
            $('body').append(this.popupPanelWrapper);
            this.popupListWrapper = ej.buildTag("div.e-ddl-popup e-box e-widget  e-popup#" + this._id + "_popup_list_wrapper", "", { display: "none", overflow: "hidden" });
            this.popupList = ej.buildTag("div#" + this._id + "_popup", { "tabIndex": 0 });
            this.popupListWrapper.addClass(this.model.cssClass);
            this.popup = this.popupList;
            this.popupScroller = ej.buildTag("div"); if((ej.isNullOrUndefined(this.ultag))) this.ultag = ej.buildTag("ul.e-ul", "", {}, { "role": "listbox" });
            this.popupScroller.append(this.ultag);
            this.popupList.append(this.popupScroller);
            if (this.model.headerTemplate) {
                this.headerTemplate = $("<div>").append(this.model.headerTemplate);
                this.popupListWrapper.append(this.headerTemplate);
            }
            this.popupListWrapper.append(this.popupList);
            this.popupPanelWrapper.append(this.popupListWrapper);
            this.ultag.on({ mouseenter: $.proxy(this._OnMouseEnter, this), mouseleave: $.proxy(this._OnMouseLeave, this), click: $.proxy(this._OnMouseClick, this)}, "li:not('.e-category')");
            if (ej.isTouchDevice())
             {
             this.ultag.on({tap:$.proxy(this._OnMouseEnter, this) }, "li:not('.e-category')");
               }
            $(window).on("resize", $.proxy(this._OnWindowResize, this));

        },

        _updateText: function () {
            this.model.text = this._visibleInput.val() == "" ? null : this._visibleInput.val();
        },
        _updateValue: function (val) {
            this.value(val == "" ? null : val);
        },
        _setGroupingAndSorting: function (prop, value) {
            this.model[prop] = value;
            var oldValue = this.model.text;
            this._updateValue("");
            this._selectedIndices = [];
            this.ultag.empty();
            this._showFullList();
            if (this.model.showCheckbox && oldValue) {
                var values = oldValue.split(this.model.delimiterChar);
                for (var i = 0; i < values.length; i++)
                    this.selectItemByText(values[i]);
            }
            else
                this.selectItemByText(oldValue);
        },
        _setSortingList: function () {
            var sortedlist = document.createElement("ul"), i, sortitems;
            $(sortedlist).append(this.itemsContainer.children());
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (i = 0; i < $(sortedlist).find(">.e-category").length; i++) {
                    sortitems = $(sortedlist).find(">.e-category").eq(0).first().nextUntil(".e-category").get();
                    this._setSortList(sortedlist, sortitems);
                }
            }
            else {
                $(sortedlist).children('>.e-category').remove();
                sortitems = $(sortedlist).children('li').get();
                this._setSortList(sortedlist, sortitems);
            }
            this.itemsContainer = $(sortedlist);
        },
        _setSortList: function (sortedlist, sortitems) {
            sortitems.sort(function (objA, objB) {
                var sortA = $(objA).text().toUpperCase();
                var sortB = $(objB).text().toUpperCase();
                return (sortA < sortB) ? -1 : (sortA > sortB) ? 1 : 0;
            });
            if (this.model.sortOrder == "descending") sortitems.reverse();
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                $(sortedlist).append($("<li>").text($(sortedlist).find(">.e-category").eq(0).text()).addClass("e-category"));
                $(sortedlist).find(">.e-category").eq(0).remove();
            }
            $.each(sortitems, function (index, item) {
                $(sortedlist).append(item);
            });
        },

        _renderPopupList: function () {
            this._doDataBind();
            if(this.model.loadOnDemand && (ej.DataManager && this.model.dataSource instanceof ej.DataManager && !this.model.dataSource.dataSource.offline)){
            this.model.showCheckbox && this._checkboxHideShow(this.model.showCheckbox);
            }
            if(ej.isNullOrUndefined(this.scrollerObj) || this._ulBox==null)this._renderRemaining(); 
            if (this.model.loadOnDemand && (this.popUpShow && ej.DataManager && this.model.dataSource instanceof ej.DataManager && !this.model.dataSource.dataSource.offline)){
                this._refreshPopup();
                this._refreshScroller();
            }
        },
        _renderRemaining: function () {
            var proxy = this;
           if(!ej.isNullOrUndefined(this.popupListWrapper)) this._dropbtnRTL();
            if (this.model.enableFilterSearch) this._enableSearch();
            if (this.model.enablePopupResize) this._enablePopupResize();
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                if (this._totalCount && this._totalCount > 0) {
                    this._totalHeight = this._totalCount * 29;
                    this._totalPages = this._totalCount / (this.model.itemsCount * 29);
                    this._loadedItemHeight =  this._getLi().length * 29;
                    this._getLi().attr("page", 0);
                    this._virtualPages = [0];
                    this.ultag.append($("<span>").addClass("e-virtual").css({ "height": this._totalHeight - this._loadedItemHeight, "display": "block" }));
                }
            }
            this._virtualUl = this.ultag.clone(true);
           if(!ej.isNullOrUndefined(this.popupListWrapper)){ 
				this._setListWidth();
            	this._setListHeight();
			}
			if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) this._checkboxHideShow(this.model.showCheckbox);
                else this._multiItemSelection(this._getLi());
            }
            this._setUncheckAll(this.model.uncheckAll);
            if(!ej.isNullOrUndefined(this.popupListWrapper)){
            this.popupScroller.css({ "height": "", "width": "" });
            this.popupList.ejScroller({
                height: this._getPopupHeight(), width: 0, scrollerSize: 20, scroll: function (e) {
                    if (proxy.model.allowVirtualScrolling) proxy._onScroll(e);
                }
            });
            this.scrollerObj = this.popupList.ejScroller("instance");
            this.popupList.find("div.e-scrollbar div").attr("unselectable", "on");
			this._setListPosition();
            !this.popUpShow && this.popupListWrapper.css({ 'display': 'none', 'visibility': 'visible' });
            this._changeSkin(this.model.cssClass);
            }
            if(!this.model.loadOnDemand)this.model.showPopupOnLoad && this._showResult();
        },

        _enableSearch: function () {
            if (this.model.enableFilterSearch)
                if (!ej.isNullOrUndefined(this.popupListWrapper) && !this.inputSearch) {
                    this.inputSearch = ej.buildTag("input#" + this._id + "_inputSearch.e-input", "", {}, { "type": "text", "data-role": "none" });
                    this.popupListWrapper.prepend($("<span>").addClass("e-atc e-search").append($("<span>").addClass("e-in-wrap ").append(this.inputSearch).append($("<span>").addClass(" e-icon e-search"))));
                    var debounceListener = (this.model.enableServerFiltering) ? this._debounce(this._OnSearchEnter, 200): this._OnSearchEnter;
                    this._on(this.inputSearch, "keyup", debounceListener)._on(this.inputSearch, "keydown", function(args){
						var keyCode = args.keyCode || args.which; 
						  if (keyCode == 9) { 
						    args.preventDefault(); 
						    this.wrapper.focus();
							this._hideResult();
						  } 
					});
                }
        },
        _removeSearch: function () {
            this.model.enableFilterSearch = false;
            this.popupListWrapper.find(".e-atc.e-search").remove();
            if (this._isPopupShown()) this.hidePopup();
            this.inputSearch = null;
        },

        _OnSearchEnter: function (e) {
            var proxy = this;
            if ($.inArray(e.keyCode, [38, 40, 13]) != -1 && this.ultag.find("li.e-nosuggestion").length <= 0) {
                if (e.keyCode == 13) this._OnKeyUp(e);
                else this._OnKeyDown(e);
            }
            else {
                this._activeItem = -1;
                this._queryString = this.inputSearch.val();
                if (this._queryString == "" && this._virtualUl) {
                    var args = { searchString: this._queryString, searchQuery: null, items: this._rawList };
                    this._trigger("search", args);
                    this._resetList();
                    this._updateSelectedIndexByValue(this.value());
                    this._refreshScroller();
                    this._setListPosition();
                } else {
                    this._mapFields(); 
                    var searchQuery = this._addSearchQuery(ej.Query(), !this._isPlainType(this._rawList));
                    var args = { searchString: this._queryString, items: this._rawList, searchQuery: searchQuery };
                    this.popupListWrapper.find(".e-atc.e-search .e-search").addClass("e-cross-circle").removeClass("e-search");
                    this._on(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
                    if (!this._trigger("search", args)){ 
                        proxy._onActionComplete(args); 
                }
                  
                }
            } 
        },
        _debounce: function(eventFunction, delay) { 
            var out;
            var proxy = this;
            return function (){
                var args= arguments;
                var later = function(){
                    out = null;
                return eventFunction.apply(proxy, args);
                };
                clearTimeout(out);
                out = setTimeout(later, delay);
            };
        },
        _onActionComplete: function(args){
            var proxy = this; 
            this._queryString = this.inputSearch.val();
                        var searchQuery = this._addSearchQuery(ej.Query(), !this._isPlainType(this._rawList));
                    var args = { searchString: this._queryString, items: this._rawList, searchQuery: searchQuery }; 
                if(ej.DataManager && this.model.dataSource instanceof ej.DataManager && this.model.enableServerFiltering && (window.getSelection().type == "Caret" || ej.browserInfo().name == "msie" )){
                        var searchQuery = args.searchQuery.clone();
                        var queryPromise = proxy.model.dataSource.executeQuery(searchQuery);
                        queryPromise.done(function (e) { 
                        proxy._filterSearch(args.searchQuery, e); 
                    });
                        }
                        else{
                            proxy._filterSearch(searchQuery, args);
                        }
        },
        _refreshSearch: function () {
            this._resetSearch();
            this._refreshPopup();
        },
        _filterSearch: function (searchQuery, args) {
            var flag = false; 
            this.resultList = args.result ? args.result : ej.DataManager(this._rawList).executeLocal(searchQuery);
            if (this.resultList.length == 0) {
                flag = true;
                this.resultList.push(this._getLocalizedLabels("emptyResultText"));
            }
            this.popupListItems = this.resultList;
            this.ultag.empty();
            this._isPlainType(this.popupListItems) ? this._plainArrayTypeBinding(this.resultList) :
            this._objectArrayTypeBinding(this.resultList, "search");
            if (flag && this.ultag.find("li").length == 1) {
                this.ultag.find("li").eq(0).addClass("e-nosuggestion");
            }
            if (this.model.showCheckbox && !flag) {
                this._appendCheckbox( this._getLi());
            }
            this._onSearch = true;
            var value = this.value(), visibleText = this._visibleInput[0].value;
            this._setValue(this.value());
			var checkVal = typeof this.model.value === "function" ? this.model.value() : this.model.value;
			if(checkVal != value){
				this.element[0].value = value;
				this._visibleInput[0].value = visibleText;
				this.model.text = visibleText == "" ? null : visibleText;
				if (this.value() != value && !(this.value() == null && value =="" )) {
					this._updateValue(value);
				}
			}
            this._onSearch = false;
            this._updateSelectedIndexByValue(this.value());
            this._refreshScroller();
            this._setListPosition();
        },
        _updateSelectedIndexByValue: function (value) {
            if (!value || !this.model.enableFilterSearch) return;
            this._selectedIndices = this.model.selectedItems = this.model.selectedIndices = [];
            this._virtualList = this._virtualUl.children("li:not('.e-category')");
            var item = this._toArray(value);
            for (var k = 0; k < item.length; k++) {
                for (var m = 0; m < this._virtualList.length; m++) {
                    if (item[k] == this._getIndexedValue(this._virtualList[m])) {
                        this._selectedIndices.push(m);
                        break;
                    }
                }
            }
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
        },
        _getIndexedValue: function (item) {
            return this._getAttributeValue(item) ? this._getAttributeValue(item) : item.innerText;
        },

        _resetSearch: function () {
            if (!this.inputSearch || !(this.model && this.model.enableFilterSearch)) return;
            if (this.inputSearch.val() != "" && this._virtualUl) {
                this.inputSearch.val("");
                this._resetList();
            }
        },
        _resetList: function () {
            if (this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").length == 1) {
                this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").addClass("e-search").removeClass("e-cross-circle");
                this._off(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
            }
            if(this.model.enableServerFiltering){
			var field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
			for (var i=0; i< this._rawList.length; i++){
				if(this._rawList[i][field] == this._selectedValue)
					this._searchresult= null;
			} 
			if(!ej.isNullOrUndefined(this._searchresult) && !(this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal"))
                this.addItem(this._searchresult);
            }
            this._listItem(this._rawList);
            this.ultag.empty().append(this._virtualUl.children().clone(true));           
            // this._onSearch variable will restrict the change and select event on searching
            this._onSearch = true;
            this._setValue(this.value());
            this._onSearch = false;
			this._searchresult = [];
        },

       
        _addSearchQuery: function (query, checkMapper) {
            var bindTo = "";
            if (checkMapper) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper.text) ? mapper["text"] : "text";
            }
            if (this._queryString) query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);
            if (this.model.itemsCount > 0) query.take(this.model.itemsCount);
            return query;
        },

        _targetElementBinding: function () {
            var predecessor = this.element.parents().last();
            this.docbdy = this.model.targetID ? predecessor.find("#" + this.model.targetID) : this.optionDiv ? this.optionDiv : null;
            if (!this.docbdy) return false;
            this.itemsContainer = this.docbdy[0].nodeName == "UL" ? this.docbdy : this.docbdy.children("ol,ul");
            if ((this.model.allowGrouping || this.itemsContainer.find(">.e-category").length > 0) && !this.model.enableSorting) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (var k = 0; k < this.itemsContainer.find(">.e-category").length; k++) {
                    var ele = this.itemsContainer.find(">.e-category").eq(k);
                    ele.replaceWith($("<li>").text(ele.text()).addClass("e-category"));
                }
            }
            else if (this.model.enableSorting) this._setSortingList();
            this.itemsContainer.children("ol,ul").remove();
            if(this.model.loadOnDemand)
            this.items = (this.itemsContainer.children().length>0)?this.itemsContainer.children('li'): this.items;
            else
            this.items = this.itemsContainer.children('li');
            this.items.children("img,div").addClass("e-align");
            this._listItem([]);
            for (var i = 0; i < this.items.length; i++) {
                var fieldText = $(this.items[i]).text(), fieldValue = this._getAttributeValue(this.items[i]);
                if(!$(this.items[i]).attr("data-value")) $(this.items[i]).attr("data-value", fieldValue ? fieldValue : fieldText);
                this._listItem({ text: fieldText, value: fieldValue ? fieldValue : fieldText }, "add");
            }
            //This will append the list with the popup wrapper
            if(this.model.loadOnDemand)
            this.ultag.empty().append(this.items);
            else 
            this.ultag.empty().append(this.itemsContainer.children());
			this.ultag.children('li').attr("role", "option").attr("unselectable", "on");		
            this.docbdy.css({ 'display': 'none' }).children("ol,ul").remove();
        },
        _plainArrayTypeBinding: function (list) {
            this.dummyUl = $();
            if (this.model.enableSorting) {
                list.sort();
                if (this.model.sortOrder == "descending") list.reverse();
            }
            if (list.length > 0) {
                for (var i = 0; i < list.length; i++) {
                    if (!ej.isNullOrUndefined(list[i])) {
                        var litag = ej.buildTag("li", list[i], {}, { 'data-value': list[i], "unselectable": "on" });
                        this.dummyUl.push(litag[0]);
                    }
                }
                this.ultag.append(this.dummyUl);
                this._trigger('dataBound', { data: list });
            }

        },
        _mapFields: function () {
            this.model.fields.groupBy = this.model.fields.groupBy ? this.model.fields.groupBy : this.model.fields.category;
            var mapper = this.model.fields;
            this.mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null };
            this.mapFld._id = (mapper && mapper.id) ? mapper["id"] : "id";
            this.mapFld._imageUrl = (mapper && mapper.imageUrl) ? mapper["imageUrl"] : "imageUrl";
            this.mapFld._imageAttributes = (mapper && mapper.imageAttributes) ? mapper["imageAttributes"] : "imageAttributes";
            this.mapFld._spriteCSS = (mapper && mapper.spriteCssClass) ? mapper["spriteCssClass"] : "spriteCssClass";
            this.mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            this.mapFld._value = (mapper && mapper.value) ? mapper["value"] : "value";
            this.mapFld._htmlAttributes = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            this.mapFld._selected = (mapper && mapper.selected) ? mapper["selected"] : "selected";
            this.mapFld._category = (mapper && mapper.groupBy) ? mapper["groupBy"] : "groupBy";
        },
        _doDataBind: function () {
            var source = this.model.dataSource, list = this.popupListItems;
            !source || !list || !list.length || list.length < 1 ? this._targetElementBinding()
            : this._isPlainType(list) ? this._plainArrayTypeBinding(list)
            : this._objectArrayTypeBinding(list);
        },
        _isPlainType: function (list) {
            return typeof list[0] != "object";
        },
        _objectArrayTypeBinding: function (list, from) {
            this.dummyUl = $();
            this._mapFields();
            if (this.model.enableSorting) {
                var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                list = ej.DataManager(list).executeLocal(sortQuery);
				this.popupListItems = list;
            }
            if (this.model.allowGrouping || this.model.fields.groupBy) {
              if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.addClass("e-atc-popup");
                var mapCateg = this.mapFld._category, groupedList, groupQuery;
                groupQuery = ej.Query().group(mapCateg);
                if (!this.model.enableSorting) groupQuery.queries.splice(0, 1);
                groupedList = ej.DataManager(list).executeLocal(groupQuery);
                this._swapUnCategorized(groupedList);
                (from == "search") ? this.popupListItems = [] : this._listItem([]);
                for (var i = 0; i < groupedList.length; i++) {
                    if (groupedList[i].key)
                        this.ultag.append(ej.buildTag("li.e-category", groupedList[i].key).attr("role", "option")[0]);
                    this._generateLi(groupedList[i].items, this.mapFld);
                    this.ultag.append(this.dummyUl);
                    for (var j = 0; j < groupedList[i].items.length; j++) {
                        (from == "search") ? this.popupListItems.push(groupedList[i].items[j]) : this._listItem(groupedList[i].items[j], "add");
                    }
                }
            }
            else {
                this._generateLi(list, this.mapFld);
                this.ultag.append(this.dummyUl);//ko binding
            }
            this._trigger('dataBound', { data: list });
        },
        _onScroll: function (e) {
            if (!e.scrollTop) return;
            var scrollerPositon = e.scrollTop, proxy = this;
            var source = this.model.dataSource;
            if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "continuous") {
                var list, queryPromise, skipQuery = ej.Query().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                if (scrollerPositon >= Math.round($(proxy.popupList).find("ul,ol").height() - $(proxy.popupList).height()) && proxy._rawList.length < proxy._totalCount) {
                    proxy._addLoadingClass();
                    if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager && !ej.isNullOrUndefined(proxy.model.dataSource.dataSource.url)) {
                        if (proxy.inputSearch && proxy.inputSearch.val() != "" && this.model.enableServerFiltering) 
                         skipQuery = proxy._addSearchQuery(ej.Query(), !proxy._isPlainType(proxy._rawList)).skip(proxy._getLi().length).clone();
                        else
                        skipQuery = proxy._getQuery().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                        if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                            queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                            queryPromise.done(function (e) {
                                if (!ej.isNullOrUndefined(proxy.model.value) && proxy.model.enableServerFiltering)
                                    e.result = proxy._removeSelectedValue(e.result);
                                proxy.addItem(e.result);
                                proxy._removeLoadingClass();
                                proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                            }).fail(function () {
                                proxy.model.dataSource = null;
                                proxy._removeLoadingClass();
                                proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                            }).always(function (e) {
                                proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                            });
                        }
                    }
                    else if (ej.DataManager && source instanceof ej.DataManager && source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                                proxy.addItem(this._localDataVirtualScroll());
                                window.setTimeout(function () {
                                proxy._removeLoadingClass();
                            }, 100);
                    }
                    else {
                        list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                        proxy.addItem(proxy._removeSelectedValue(list));
                        proxy._removeLoadingClass();
                    }
                }
            } else if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "normal") {

                window.setTimeout(function () {
                    if (proxy._virtualCount == 0) {
                        proxy._loadList();
                    }
                }, 300);

            }

        },
        _localDataVirtualScroll: function () {
            var proxy = this;
            var selectValue = (!ej.isNullOrUndefined(proxy.value())) ? proxy.value().split(proxy.model.delimiterChar).length : 0;
            var _rawlist = (proxy._checkValue) ? proxy._rawList.length - selectValue : proxy._rawList.length;
            var queryPromise = ej.DataManager(proxy.model.dataSource.dataSource.json).executeLocal(ej.Query().skip(_rawlist).take(proxy.model.itemsCount).clone());
            return proxy._removeSelectedValue(queryPromise); 
        },
        _removeSelectedValue: function (data) { 
            if (!ej.isNullOrUndefined(this.value())) {
                var listitems = this.value().split(this.model.delimiterChar);
                for (var k = 0; k < listitems.length; k++) {
                    for (var m = 0; m < data.length; m++) {
                        if (data[m][this.mapFld._value] == listitems[k]) 
                            data.splice(data.indexOf(data[m]), 1);
                    }
                }
                return data;
            }
            else
                return data;
        },
        _loadList: function () {
            this._virtualCount++;
            var source = this.model.dataSource;
            var top = this.scrollerObj.scrollTop(), proxy = this, prevIndex = 0, prevPageLoad, nextIndex = null;
            this._currentPage = Math.round(top / (29 * this.model.itemsCount));
            if (($.inArray(this._currentPage, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) {
                if (this._currentPage == 0) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else if (($.inArray(this._currentPage - 1, this._virtualPages)) != -1) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else {
                    this._currentPage = this._currentPage - 1;
                }
            }
            prevPageLoad = !($.inArray(this._currentPage - 1, this._virtualPages) != -1);
            this._addLoadingClass();
            for (var i = this._virtualPages.length - 1; i >= 0; i--) {
                if (this._virtualPages[i] < this._currentPage) {
                    prevIndex = this._virtualPages[i];
                    if (!(i + 1 == this._virtualPages.length))
                        nextIndex = this._virtualPages[i + 1];
                    break;
                }
            }

            var firstArg = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
            var skipQuery = ej.Query().range(firstArg, this._currentPage * this.model.itemsCount + this.model.itemsCount), queryPromise, list;
            if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager && !ej.isNullOrUndefined(proxy.model.dataSource.dataSource.url)) {
                var skipParam = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
                skipQuery = this._getQuery().skip(skipParam);
                if (prevPageLoad) {
                    for (i = 0; i < skipQuery.queries.length; i++) {
                        if (skipQuery.queries[i].fn == "onTake") {
                            skipQuery.queries.splice(i, 1);
                            break;
                        }
                    }
                    skipQuery.take(2 * this.model.itemsCount);
                }
                if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                   if (proxy.inputSearch && proxy.inputSearch.val() != "" && this.model.enableServerFiltering) var skipQuery = proxy._addSearchQuery(ej.Query(), !proxy._isPlainType(proxy._rawList)).skip(proxy._getLi().length).clone();
                    queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                    queryPromise.done(function (e) {
                        e.result = proxy._removeSelectedValue(e.result);
                        proxy._appendVirtualList(e.result, prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                        proxy._removeLoadingClass();
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                    }).fail(function (e) {
                        proxy._virtualCount--;
                        proxy._removeLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                    });
                }
            }
            else if (ej.DataManager && source instanceof ej.DataManager && source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                proxy._appendVirtualList(this._localDataVirtualScroll(), prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                window.setTimeout(function () {
                    proxy._removeLoadingClass();
                }, 100);
            }
            else {
                list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                proxy._appendVirtualList(proxy._removeSelectedValue(list), prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                proxy._removeLoadingClass();
            }
        },
        _appendVirtualList: function (list, prevIndex, currentIndex, nextIndex, prevPageLoad) {
            this._virtualCount--;
            this.ultag.find("span.e-virtual").remove();
            if (!ej.isNullOrUndefined(this.activeItem)) this.activeItem.attr("page", "0");
            if (($.inArray(currentIndex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) return false;
            if (prevPageLoad && ($.inArray(currentIndex - 1, this._virtualPages.sort()) != -1)) {
                list.splice(0, this.model.itemsCount);
                prevPageLoad = false;
            }
            var items = this.model.itemsCount, tempUl = $("<ul>"), firstVirtualHeight, secondVirtualHeight;
            firstVirtualHeight = prevPageLoad ? ((currentIndex - 1) * items * 29) - (prevIndex * items + items) * 29 : (currentIndex * items * 29) - (prevIndex * items + items) * 29;
            if (firstVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: firstVirtualHeight }));
            this._mapFields();
            this._generateLi(list, this.mapFld);
            $(this.dummyUl).attr("page", currentIndex);
            if (prevPageLoad) {
                $(this.dummyUl).slice(0, items).attr("page", currentIndex - 1);
            }
            if (this.model.showCheckbox) {
                this._appendCheckbox(this.dummyUl);
            }
            tempUl.append(this.dummyUl);
            secondVirtualHeight = (currentIndex * items + items) * 29;
            if (nextIndex != null) secondVirtualHeight = (nextIndex * items * 29) - secondVirtualHeight;
            else secondVirtualHeight = this.ultag.height() - secondVirtualHeight;
            if (secondVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: secondVirtualHeight }));
            if (this.model.itemsCount > 0 && this.value() != "" && (this.model.dataSource instanceof ej.DataManager && this.model.dataSource.dataSource.offline))
                var selector = this.ultag.find("li").last();
            else
                var selector = this.ultag.find("li[page=" + prevIndex + "]").last();
            selector.next().remove();
            tempUl.children().insertAfter(selector);
            this._virtualPages.push(currentIndex);
            if (prevPageLoad) this._virtualPages.push(currentIndex - 1);
            for (var i = 0; i < list.length; i++) {
                this._listItem(list[i], "add");
            }
            this._virtualUl = this.ultag.clone(true);
            this._renderBoxModel();
        },

        _generateLi: function (list, mapFld) {
            this.mapFld = mapFld;
            this.dummyUl = [];
            if (!list || !list.length || list.length < 1) return false;
            for (var i = 0; i < list.length; i++) {
                var _did = this._getField(list[i], this.mapFld._id),
                    _dimageUrl = this._getField(list[i], this.mapFld._imageUrl),
                    _dimageAttributes = this._getField(list[i], this.mapFld._imageAttributes),
                    _dspriteCss = this._getField(list[i], this.mapFld._spriteCSS),
                    _dtext = this._getField(list[i], this.mapFld._text),
                    _dvalue = this._getField(list[i], this.mapFld._value),
                    _dhtmlAttributes = this._getField(list[i], this.mapFld._htmlAttributes),
                    _dselected = this._getField(list[i], this.mapFld._selected),
                    litag = document.createElement("li");

                if (!ej.isNullOrUndefined(_dvalue) && _dvalue.toString().length > 0) {
                    litag.setAttribute('data-value', typeof _dvalue == "object" ? JSON.stringify(_dvalue) : _dvalue);
                }
                else {
                     litag.setAttribute('data-value', _dtext);
                }
                if (!ej.isNullOrUndefined(_did) && (_did !== ""))
                    litag.setAttribute('id', _did);
                if (!ej.isNullOrUndefined(_dhtmlAttributes) && (_dhtmlAttributes != "")) {
                    this._setAttr(litag, _dhtmlAttributes);
                }

                if (this.model.template) {
                    $(litag).append(this._getTemplatedString(list[i]));
                } else {
                    if (!ej.isNullOrUndefined(_dimageUrl) && (_dimageUrl != "")) {
                        var imgtag = document.createElement("img");
                        this._setClass(imgtag, "e-align")._setAttr(imgtag, { 'src': _dimageUrl, 'alt': _dtext });
                        if ((_dimageAttributes) && (_dimageAttributes != "")) {
                            this._setAttr(imgtag, _dimageAttributes);
                        }
                        litag.appendChild(imgtag);
                    }
                    if (!ej.isNullOrUndefined(_dspriteCss) && (_dspriteCss != "")) {
                        var divtag = document.createElement("div");
                        this._setClass(divtag, 'div.e-align ' + _dspriteCss + ' sprite-image');
                        litag.appendChild(divtag);
                    }
                    if (_dselected) {
                        this._setClass(litag, "chkselect");
                    }
                    {
                        if (ej.isNullOrUndefined(_dtext)) _dtext = String(_dtext);
                        var textEle = document.createElement("span");
                        textEle.innerHTML = _dtext;                      
                        this._setClass(textEle, "e-ddltxt");
                        litag.innerHTML += textEle.outerHTML;
                    }
                }
                this._setAttr(litag, { "role": "option", "unselectable": "on" });
                this.dummyUl.push(litag);
             
            }
        },

        _setAttr: function (element, attrs) {
            if (typeof attrs == "string") {
                var sAttr = attrs.replace(/['"]/g, "").split("=");
                if (sAttr.length == 2) element.setAttribute(sAttr[0], sAttr[1]);
            }
            else {
                for (var idx in attrs) {
                    if ((idx == 'styles' || idx == 'style') && typeof attrs[idx] == 'object') {
                        for (var prop in attrs[idx]) {
                            element.style[prop] = attrs[idx][prop];
                        }
                    }
                    else
                        element.setAttribute(idx, attrs[idx]);
                }
            }
            return this;
        },
        _setClass: function (element, classNme) {
            element.className += " " + classNme;
            return this;
        },
        _removeClass: function (element, classNme) {
            var index = element.className.indexOf(classNme);
            if (index >= 0) {
                if (index != 0 && element.className[index - 1] === " ")
                    element.className = element.className.replace(" " + classNme, "");
                else element.className = element.className.replace(classNme, "");
            }
            return this;
        },
        _hasClass: function (element, classNme) {
            return element.className.indexOf(classNme) >= 0;
        },
        _swapUnCategorized: function (list) {
            $(list).each(function (i, obj) {
                if (!obj.key) {
                    for (var j = i; j > 0; j--) {
                        list[j] = list[j - 1];
                    }
                    list[j] = obj;
                    return false;
                }
            });
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _getTemplatedString: function (list) {

            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _setWatermark: function () {
            if ((this.element.val() == "") && this._trim(this._visibleInput.val()) == "") {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                if (this._isWatermark)
                    this._visibleInput.attr("placeholder", watermark);
                else
                    this._hiddenSpan.css("display", "block").text(watermark);
                //In visual mode, to show watermark text when no items selected.
                if (this.model.multiSelectMode == "visualmode" && this._ulBox && this._ulBox.find('li').length == 0) this._swapUlandInput(false);
            }
        },

        _checkboxHideShow: function (value) {
            if(!ej.isNullOrUndefined(this.ultag)){
            if (value) {
                this.listitems = this._getLi();
                var chklist = this.listitems.find('input[type=checkbox]');
                if (chklist.length == 0) {
                    this._appendCheckbox(this.listitems);
                }
            }

            else
                this._removeCheck(this.popupList);
            this.model.showCheckbox = value;
            this._virtualUl = this.ultag.clone(true);
            }
        },
        
        _setCheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.checkAll();
            else this.model.checkAll = false;
        },
        _setUncheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.uncheckAll();
            else this.model.uncheckAll = false;
        },

        checkAll: function () {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0))this._showFullList();
            var _nodes = this._selectedIndices, isAlreadySelected = false;
            this._mapFields();
            this.listitems = this._getLi();
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(!this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && !this._isChecked(checkboxWrap)) {
                            this._setClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":true});
                            checkboxWrap.firstChild.checked = true;
                            isAlreadySelected = false;
                        }
                        else isAlreadySelected = true;
                    }
                    else {
                        isAlreadySelected = false;
                        $(this.listitems[i]).addClass("e-active");
                    }
                    else isAlreadySelected = true;
                    
                    if (!isAlreadySelected) {
						this.checkedStatus = true;
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._selectedItemsID.push(this._itemID);
                        this._createListHidden(this._hiddenValue);
                        if (this.model.multiSelectMode == "visualmode") {
                            this._ulBox.append(this._createBox(this._currentText,this._hiddenValue));
                            if (this._isPopupShown()) this._setListPosition();
                        }
                        this._addText(this._currentText);
                        if ($.inArray(i, _nodes) == -1) {
                            this._selectedIndices.push(i);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._cascadeAction();
                    }
                }
                this.model.itemValue = this._selectedValue;
                this.model.uncheckAll = false;
                this.model.checkAll = true;
                this._activeItem = -1;
                this._setWatermark();
            }
        },
        _createListHidden: function (value) {
            var arrayHidden = document.createElement("input");
			var quote = /'/;
			if(quote.test(value))
			   value =value.replace(quote,"&apos;")
            this._setAttr(arrayHidden, { type: "hidden", name: this._name, value: value, id: "#" + value });
            this.container.append(arrayHidden);
            $(this.element).attr("name", "hiddenEle");
        },
        _removeListHidden: function (value) {
			var quote = /'/;
			if(quote.test(value))
			     value =value.replace(quote,"&apos;")
            var arrayEle = this.container.find("[id='#" + value + "']");
            $(arrayEle).remove();
			if (!this._isSingleSelect())this.element.attr("name", this._name);
        },
        _getAttributeValue: function (val) {
            return val ? val.getAttribute("data-value") || val.getAttribute("value") : null;
        },
       
        _selectCheckedItem: function (chkitems) {
            if(this.model.loadOnDemand && (ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0))this._showFullList();
            for (var i = 0; i < chkitems.length; i++) {
                this._activeItem = chkitems[i];
                this._enterTextBoxValue();
            }
        },

        /* will deprecate with uncheckAll method */
        unCheckAll: function () { this.uncheckAll(); },

        uncheckAll: function () {
            var isAlreadySelected = false;
            this.listitems = this._getLi();
            this._mapFields();
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && this._isChecked(checkboxWrap)) {
                            this._removeClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":false});
                            checkboxWrap.firstChild.checked = false;
                            isAlreadySelected = true;
                        }
                        else isAlreadySelected = false;
                    }
                    else {
                        $(this.listitems[i]).removeClass("e-active");
                        isAlreadySelected = true;
                    }
                    else isAlreadySelected = false;
                    
                    if (isAlreadySelected) {
                        this.checkedStatus = false;
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._removeText(this._hiddenValue);
                        this._removeListHidden(this._hiddenValue);
                        var _nodes = this._selectedIndices;
                        if ($.inArray(i, _nodes) > -1) {
                            this._selectedIndices.splice($.inArray(i, _nodes), 1);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._removeSelectedItemsID();
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._cascadeAction();
                        if (this.model.multiSelectMode == "visualmode") {
                            this._deleteBoxCheck(this._hiddenValue);
                            if (this._isPopupShown())
                                this._setListPosition();
                        }
                    }
                    
                }
                this.model.itemValue = this._selectedValue;
                this.model.checkAll = false;
                this.model.uncheckAll = true;
                this._setWatermark();
                this._activeItem = -1;
            }

        },
        _removeSelectedItemsID: function () {
            var itemToRemove;
            itemToRemove = this._selectedItemsID.indexOf(this._itemID);
            this._selectedItemsID.splice(itemToRemove, 1);
            this._itemID = "";
        },


        _refreshScroller: function () {
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.popupList.find(".e-content, .e-vhandle").removeAttr("style");
            this.popupList.find(".e-vhandle div").removeAttr("style");
            this.popupList.children(".e-content").removeClass("e-content");
            var flag = this._isPopupShown();
            this.popupListWrapper.css("display", "block");
            this.popupList.css({ "display": "block" });  // For get the height of the popup
            this.scrollerObj.model.height = Math.ceil(this._getPopupHeight());
            this.scrollerObj.refresh();
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.scrollerObj.option("scrollTop", 0);
            if (!flag) this.popupListWrapper.css("display", "none");
        },
        _enablePopupResize: function () {
            if (this.model.enablePopupResize && !ej.isNullOrUndefined(this.popupListWrapper)) {
                this.popupListWrapper.addClass("e-resizable").append(ej.buildTag("div.e-resizebar").append(ej.buildTag("div.e-icon e-resize-handle")))
                .find(".e-resize-handle").addClass((this.model.enableRTL) ? "e-rtl-resize" : "");
                this._resizePopup();
            }
        },


        _resizePopup: function () {
            var proxy = this, started = false;
            this.popupListWrapper.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: proxy._validatePixelData(proxy.model.minPopupHeight),
                    minWidth:  proxy._validatePixelData(proxy.model.minPopupWidth),
                    maxHeight: proxy._validatePixelData(proxy.model.maxPopupHeight),
                    maxWidth:  proxy._validatePixelData(proxy.model.maxPopupWidth),
                    handle: "e-ddl-popup",
                    resizeStart: function (event) {
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("popupResizeStart", { event: event });
                        started = true;
                    },
                    resize: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        proxy._trigger("popupResize", { event: event });
                    },
                    resizeStop: function (event) {
                        if (started) {
                            proxy._refreshPopupOnResize(proxy.model.popupHeight, proxy.model.popupWidth);
                            started && proxy._trigger("popupResizeStop", { event: event });
                            started = false;
                        }
                    },
                    helper: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        return $(proxy.popupListWrapper);
                    }
                });
        },

        _refreshPopupOnResize: function (currHeight, currWidth) {
            if (currHeight) this.model.popupHeight = currHeight;
            if (currWidth) this.model.popupWidth = currWidth;
            this.popupListWrapper.css({ "height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight) });
            this._setListWidth();
            this._refreshScroller();
        },

        _setListWidth: function () {
            if(!ej.isNullOrUndefined(this.popupListWrapper)){
            var width = this.model.popupWidth;
            if (width != "auto") this.popupListWrapper.css({ "width": width });
            else this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            this.popupListWrapper.css({ "max-width": this._validatePixelData(this.model.maxPopupWidth) });
            }
        },

        _setListHeight: function () {
            if(!ej.isNullOrUndefined(this.popupListWrapper)){
            if (this.model.enablePopupResize && this.model.enableFilterSearch && this.model.minPopupHeight && this.model.minPopupHeight.toString().indexOf("%") <0 && this._validatePixelData(this.model.minPopupHeight) == 20)
                this.model.minPopupHeight = '65'; /* adding default height of search box*/
            this.model.enablePopupResize ? this.popupListWrapper.css({ "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight), "height": this._validatePixelData(this.model.popupHeight) }) :
            this.popupListWrapper.css({ "max-height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight) });
            }
        },
		_validatePixelData: function (data) {			
			return (data && !isNaN(data))? Number(data):data;
		},
        _getPopupHeight: function () {
            var wrap = this.popupListWrapper.height();
            if (this.model.enablePopupResize) wrap -= this.popupListWrapper.find(">div.e-resizebar").height();
            if (this.model.headerTemplate && this.headerTemplate) wrap -= this.headerTemplate.height();
            if (this.model.enableFilterSearch && this.inputSearch) {
                var ele = this.inputSearch.parent(".e-in-wrap");
                wrap -= (parseInt(ele.css("height")) + parseInt(ele.css('margin-top')) + parseInt(ele.css('margin-bottom')));
            }
            return wrap;
        },

        _refreshPopup: function () {
            if (this.model.popupWidth == "auto" && !this._validatePixelData(this.model.minPopupWidth)) this.popupListWrapper.css({ "min-width": this.wrapper.width() });
			else if(this._validatePixelData(this.model.minPopupWidth))this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            if(this.scrollerObj != undefined) this._refreshScroller();
            this._setListPosition();
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupListWrapper.outerHeight(),
            popupWidth = this.popupListWrapper.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupListWrapper.outerWidth() - elementObj.outerWidth();
            this.popupListWrapper.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });

        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupListWrapper);
        },


        _showResult: function () {
            var proxy = this;
            this.popUpShow = true
            if(this.model.loadOnDemand){ 
            if(ej.isNullOrUndefined(this.popupListWrapper))this._renderPopupPanelWrapper();
            if(ej.isNullOrUndefined(this.ultag) || this.ultag.children().length==0){
            this._showFullList();
            }
            this._renderRemaining();
            }
            var args = { text: this._visibleInput[0].value, value: this._selectedValue, refreshPopup: true };
            if (this._trigger("beforePopupShown", args)) return;
            if (args.refreshPopup) this._refreshPopup();
            $(this.popupListWrapper).slideDown(this.model.enableAnimation ? 200 : 1, function () {
                $(document).on("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                if(!(ej.isDevice()))
                proxy._on(ej.getScrollableParents(proxy.wrapper), "scroll", proxy._hideResult);
            });
            this.element[0].setAttribute("aria-expanded", true);
            this._listSize =  this._getLi().length;
            this.wrapper.addClass("e-popactive");
            this._trigger("popupShown", { text: this._visibleInput[0].value, value: this._selectedValue });
            this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
        },

        _OnWindowResize: function (e) {
            if (!ej.isNullOrUndefined(this.model) && this._isPopupShown()) {
                this._refreshPopup();
            }
        },
        _hideResult: function (e) {
            if (this.model && this._isPopupShown()) {
				if (!ej.isNullOrUndefined(e) && !ej.isNullOrUndefined(this.inputSearch) && $(this.inputSearch).is(":focus")){
					if(e.type == "scroll" && ej.isTouchDevice())
						return false;
				}
                var proxy = this;
                if (this._trigger("beforePopupHide", { text: this._visibleInput[0].value, value: this._selectedValue })) return;
                $(this.popupListWrapper).slideUp(this.model.enableAnimation ? 100 : 0, function () {
                    $(document).off("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                });
                if (this.element != null)
                    this.element.attr( "aria-expanded", false );
				if(!(ej.isDevice()))
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                if (this._visibleInput != null)
                this.wrapper.removeClass("e-popactive");
               this.popUpShow= false;
                    this._trigger("popupHide", { text: this._visibleInput[0].value, value: this._selectedValue });

                setTimeout(function () {
                    proxy._resetSearch();                 
                }, 100);
				this._getLi().find(".e-ddl-anim").removeClass("e-ddl-anim");
            }
        },

        _isPopupShown: function () { 
            if(!ej.isNullOrUndefined(this.popupListWrapper)) return (this.popupListWrapper.css("display") == "block");
        },

        _enterTextBoxValue: function () {
            var args, valueModified = true;
            this.removeID = false;
			this.checkedStatus = false;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-check-inact');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}
            args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };
            if (!this._initValue && !this._onSearch && this._raiseEvents){ 
                if(this._trigger("select", args)) {
                    this._setWatermark();
                    return;
                }
            }
            if (this._activeItem >=0 || this._activeItem != null) {
                if (!this._isSingleSelect() && !this._checkContains(this._selectedValue)) {                   
                    if (this.model.showCheckbox) {
                        var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                        if (!this._isChecked(checkboxEle)) {
							this._removeClass(checkboxEle, "e-ddl-anim");	
                            this._setClass(checkboxEle, "e-check-act e-ddl-anim");
                            this._setAttr(checkboxEle,{"aria-checked":true});
                            $(checkboxEle).find(".e-check-input")[0].checked = true;
                        }
                    }
                    else {
                        this.activeItem.addClass('e-active');
                    }
                    if (this.model.multiSelectMode == "visualmode") {
                        this._ulBox.append(this._createBox(this._currentText, this._selectedValue));
                        if (this._isPopupShown())
                            this._setListPosition();
                    }

                    this._maintainHiddenValue();
                    this._addText(this._currentText);
                    this._createListHidden(this._hiddenValue);
                    if ($.inArray(this.selectedIndexValue, this._selectedIndices) == -1) {
                        this._selectedIndices.push(this.selectedIndexValue);
                        this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                    }                
                } else if( this._isSingleSelect()){
                    this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
                    this.activeItem.addClass('e-active');                    
                    this._maintainHiddenValue();
                    this._visibleInput.val(this._currentText);
                    this.element.val(this._hiddenValue);
                    this.selectedItemIndex(this.selectedIndexValue);
                    this.selectedIndex(this.selectedIndexValue);
                    this._selectedIndices[0] = this.selectedIndexValue;
                }
                else valueModified = false;
                if(valueModified) {
					this.checkedStatus = true;
                    this._onValueChange();
                    this._cascadeAction();
                    if (this.selectelement) {
                    if ($("#" + this._id).children().length > this.selectedIndexValue)
                        $("#" + this._id).children()[this.selectedIndexValue].selected = true;
                    }
                }
            }
            this.model.uncheckAll = false;
            this._setWatermark();
			this._uiInteract = false;
        },
        _onValueChange: function () {
            this.model.itemValue = this._selectedValue;
            this._updateText();
            if (this.value() != this.element.val() && !(this.value() == null && this.element.val() =="" )) {
                this._updateSelectedIndexByValue(this.element.val());
                this._updateValue(this.element.val());
				if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && (this.model.value == null || this.model.value == "")){
					this.model.itemValue = "";
				}
               var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: this.selectedIndexValue, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };

                if (!this._initValue && !this._onSearch && this._raiseEvents) {
					if(typeof this.model._change == "function") this._trigger("_change", { isChecked: this.checkedStatus, text: this._visibleInput.val(), itemId: this.selectedIndexValue, selectedText: this._currentText, selectedValue: this._selectedValue, value: this.value(), data: this.model, isInteraction: !!this._uiInteract  });
                    this._trigger("change", args);
                    if (this.model.showCheckbox)
                        this._trigger('checkChange', { isChecked: this.checkedStatus, text: this._visibleInput.val(), itemId: this.selectedIndexValue, selectedText: this._currentText, selectedValue: this._selectedValue, value: this._selectedValue, data: this.model });
                }
                this._uiInteract = false;
                if(this.model.enableFilterSearch && this.model.enableServerFiltering){
				this._searchresult = [];
                this._searchresult = this.getItemDataByValue(this.value());
                }
                
            }
        },
        _decode: function (val) {
            return $("<span>").html(val).text();
        },
        _chooseSelectionType: function () {
            this.activeItem = this._getActiveItem();
            this.selectedIndexValue = this._activeItem;
            this._mapFields();
            if (this.model.dataSource != null && (!this._isPlainType(this.model.dataSource) || !this._isPlainType(this.popupListItems))) {
                this._currentText = this._decode(this._getField(this.popupListItems[this._activeItem], this.mapFld._text));
                this._currentText = (this._currentText === "" || this._currentText == null) ? this.activeItem.text() : this._currentText;
                this._selectedValue = this._getField(this.popupListItems[this._activeItem], this.mapFld._value);
                this._selectedValue = (this._selectedValue != null) ? this._selectedValue : this._currentText;
                this._itemID = this._getField(this.popupListItems[this._activeItem], this.mapFld._id);
            } else {
                this._currentText = this.activeItem.text();
                if (this._getAttributeValue(this.activeItem[0]))
                    this._selectedValue = this._getAttributeValue(this.activeItem[0]);
                else {
                    if (this._currentText != null) {
                        if(!ej.isNullOrUndefined(this.activeItem[0]))this.activeItem[0].setAttribute("value", this._currentText);
                        this._selectedValue = this._currentText;
                    }
                    else
                        this._selectedValue = "";
                }
                this._itemID = $(this.activeItem).attr("id");
            }
            if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "") {
                if (!this.model.showCheckbox) {
                    this._selectedItemsID = [];
                    !this.removeID && this._selectedItemsID.push(this._itemID);
                }
                else
                    !this.removeID ? this._selectedItemsID.push(this._itemID) : this._removeSelectedItemsID();
            }
            this.selectedTextValue = this._currentText;
        },
        _maintainHiddenValue: function () {
            this._hiddenValue = this._getAttributeValue(this.activeItem[0]) || this._currentText;
        },
        _removeTextBoxValue: function (delvalue) {
            this._uiInteract = true;
            this.removeID = true;
			this.checkedStatus = true;
			if(this._isFilterInput()){
				for (var j = 0; j < this._getLi().length; j++) {
					if ($(this._getLi()[j]).attr("data-value") == delvalue) {
						this._activeItem = j;
					}
				}
			}
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-ddl-anim').addClass('e-check-inact e-ddl-anim');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}			
            var args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus };
            if (!this._initValue && !this._onSearch && this._raiseEvents){
                if(this._trigger("select", args)){
                    this._setWatermark();
                    return;
                }
            }                
            this._maintainHiddenValue();
			this._hiddenValue = this._isFilterInput() && !ej.isNullOrUndefined(delvalue) ? delvalue : this._hiddenValue;
            this._removeText(this._hiddenValue);
            this._removeListHidden(this._hiddenValue);
			if(this._isFilterInput() && !this.activeItem.attr("data-value") == delvalue)
				this.activeItem.removeClass('e-active');
            if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) {
                    var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                    if (this._isChecked(checkboxEle)) {
                        this._removeClass(checkboxEle, "e-check-act");
						this._setAttr(checkboxEle,{"aria-checked":false});
                        $(checkboxEle).find(".e-check-input")[0].checked = true;
                    }
                }
                else this.activeItem.removeClass('e-active');

                if ($.inArray(this.selectedIndexValue, this._selectedIndices) > -1) {
                    this._selectedIndices.splice($.inArray(this.selectedIndexValue, this._selectedIndices), 1);
                    this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                }
                if (this.model.multiSelectMode == "visualmode") {
                    this._deleteBoxCheck(this._hiddenValue);
                    if (this._isPopupShown())
                        this._setListPosition();
                }
            }
			this.checkedStatus = false;            
            this._onValueChange();
            if ((this.model.cascadeTo != null) && !this._isSingleSelect() && !this._initValue ) this._cascadeAction();
            this.model.checkAll = false;
            this._setWatermark();
        },


        _createBox: function (text, value) {
            if (!this._checkContains(value)) {

                if (this._ulBox.css('display') == "none" && this._visibleInput.css('display') != "none") this._swapUlandInput(true);
                var span = ej.buildTag("span.e-icon e-close", "", {}, { "unselectable": "on" });
                var li = ej.buildTag("li.e-options").text(text).attr("data-value",value).append(span);
                this._on(span, "click", function (e) {
                    if (!this.model.enabled) return false;
                    this._deleteBox($(e.target).parent());                   
                });
                return li;
            }
        },
        _deleteBoxCheck: function (val) {
            var items = this._ulBox.children('li');
            for (var i = 0; i < items.length; i++) {
                if ($(items[i]).attr("data-value") == val) {
                    $(items[i]).remove();
                }
            }
        },
        _deleteLastBox: function () {
            var items = this._ulBox.children("li:not(.e-search-box)");
            var item = items.last();
            if (item.hasClass("e-active")) this._deleteBox(item);
            else {
                this._removeActive();
                item.addClass("e-active");
            }
        },
        _deleteBox: function (items) {
            for (var i = 0; i < items.length; i++) {              
                var deltext = $(items[i]).attr("data-value");
                if(this._isFilterInput()){ 
                    var datalist = this.getListData();
                    for (var j = 0; j < datalist.length; j++) {
                        var val = this._getField(datalist[j], this.mapFld._value) ? this._getField(datalist[j], this.mapFld._value): this._getField(datalist[j], this.mapFld._text);
                        if (val == deltext) {
                            this._removeTextBoxValue(deltext);
                            break;
                        }
                    }
				}else{
					var listItems = this._getLi();
					for (var j = 0; j < listItems.length; j++) {
						if ($(listItems[j]).attr("data-value") == deltext) {
							this._activeItem = j;
							this._removeTextBoxValue();
							break;
						}
					}
				}
            }
            if (!this._isFocused && !this._isPopupShown())
                this._setWatermark();
        },
        _isFilterInput: function(){
            if(this.model.enableFilterSearch){
                if(!this.inputSearch.val() == ""){
                       return true; 
                }
            }else{
                return false;
            }
        },
        _swapUlandInput: function (inputHide) {
            if (inputHide) {
                this._visibleInput.css('display', 'none');
                this._ulBox.css('display', 'block');
                this.wrapper.css({ 'height': 'auto' });
            }
            else {
                this._visibleInput.css('display', 'block');
                this._ulBox.css('display', 'none');
                this.wrapper.css({ 'height': this.model.height });
            }
        },
        _removeActive: function () {
            this._ulBox.children("li").removeClass("e-active");
        },
        _adjustWidth: function () {
            var tempSpan = ej.buildTag("span", this._visibleInput.val());
            this.container.append(tempSpan);
            this._visibleInput.width(tempSpan.width() + 30);
            tempSpan.remove();
        },
        _destroyBoxModel: function () {
            this._visibleInput.css('display', 'block');
            this.wrapper.height(this.model.height);
            this._ulBox.remove();
			this._ulBox = null;
            this._off(this.container, "click");
        },

        _removeListHover: function () {
            this.ultag.children("li").removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            activeItem.addClass("e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop('hover') });
            activeItem.focus();
        },
        _getLi: function () {
            return this.ultag.children("li:not('.e-category'):not('.e-nosuggestion')");
        },
        _calcScrollTop: function (val) {
            var ulH = this.ultag.outerHeight(), li = this.ultag.find("li"), liH = 0, index, top, i;
            if (this._selectedIndices && this._selectedIndices.length > 0 && val == "active") {
                var getLi = this._getLi();
                index = this._selectedIndices.length == getLi.length ? 0
                : this._selectedIndices[this._selectedIndices.length - 1];
                if (this.model.fields.groupBy != null || this.ultag.find("li.e-category").length > 0) {
                    index = $.inArray(getLi.eq(index)[0], li);
                }
            }
            else index = this.ultag.find("li.e-" + val).index();

            for (i = 0; i < index; i++) { liH += li.eq(i).outerHeight(true); }
            top = liH - ((this.popupList.outerHeight() - li.eq(index).outerHeight(true)) / 2);
            return top < 0 ? 0 : top;
        },
        _getActiveItem: function () {
            return this._getLi().eq(this._activeItem);
        },
        _setDimentions: function () {
            if (this.model.height)
                this.wrapper.height(this.model.height);
            if (this.model.width)
                this.wrapper.width(this.model.width);
        },


        _roundedCorner: function (val) {
            if (val) {
                this.container.addClass("e-corner");
                if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.addClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                if(!ej.isNullOrUndefined(this.popupListWrapper)) this.popupListWrapper.removeClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').removeClass("e-corner");
            }

        },

        _enabled: function (boolean) {
            if (boolean) this.enable();
            else this.disable();
        },

        _RightToLeft: function () {
            if (this.model.enableRTL) {
                this.wrapper.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
            }

        },
        _dropbtnRTL: function () {
            if (this.model.enableRTL) {
                this.popupListWrapper.addClass("e-rtl").find(".e-resize-handle").addClass("e-rtl-resize");
                this.popupList.addClass("e-rtl");
            }
            else {
                this.popupListWrapper.removeClass("e-rtl").find(".e-resize-handle").removeClass("e-rtl-resize");
                this.popupList.removeClass("e-rtl");
            }
        },
        _OnDropdownClick: function (e) {
            this._preventDefaultAction(e);
            if (($(e.target).is("li") && $(e.target).parent().hasClass("e-boxes")) || ($(e.target).parents("ul").hasClass("e-boxes") && $(e.target).hasClass("e-icon e-close")))
                return false;
            if (this.model.readOnly || this._readOnly) return false;
            var popuphideshow = !ej.isNullOrUndefined(this.ultag) ? this.ultag.find('li').length > 0 : (this.model.loadOnDemand) ? true: false;
            if (popuphideshow && ((e.which && e.which == 1 ) ||(e.button && e.button == 0) )) {
                this._OnPopupHideShow();
            }
        },
        _OnPopupHideShow: function () {
            if (this._isPopupShown()) {
                this._hideResult();
            }
            else {
				this._showResult();
				if (this.model.enableFilterSearch){
					if(this.getSelectedItem().length == 0)
						this.ultag.find("li:first").addClass("e-hover");
					else{
						var length = this.getSelectedItem().length;
						$(this.getSelectedItem()[length -1]).addClass("e-hover");
					}
                    $(this.inputSearch).focus();
				}
				else
					this.wrapper.focus();
            }
        },

        _showFullList: function () {
            var source = this.model.dataSource;
            if(ej.isNullOrUndefined(this.ultag)) this.ultag = ej.buildTag("ul.e-ul", "", {}, { "role": "listbox" });
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (!source.dataSource.offline && !(source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._initDataSource(source);
                }
                else this._getFilteredList(source.dataSource.json);
            }
            else this._getFilteredList(source);
        },
        _getFilteredList: function (list) {
            if (!list || !list.length || list.length < 1) {
                this._targetElementBinding();
                this._renderRemaining();
            }
            else {
                var listItem = ej.DataManager(list).executeLocal(this._isPlainType(list) ? ej.Query() : this._getQuery(true));
                this._totalCount = listItem.count;
                this._listItem(listItem.result ? listItem.result : listItem);
                this._renderPopupList();
                this._rawList =  this.popupListItems.slice();
            }
        },

        _cascadeAction: function () {
            if (this.model.cascadeTo) {
                var citem = this.model.cascadeTo.split(","), i;
                for (i = 0; i < citem.length; i++) {
                    if ($('#' + citem[i]).hasClass("e-dropdownlist")) {
                        this._doCascadeAction(citem[i], this, this.checkedStatus);
                    }
                    else {
                        $('#' + citem[i]).on("ejDropDownListcreate", { Obj: this, status: this.checkedStatus }, function (e) {
                            if (!ej.isNullOrUndefined(e.data.Obj.getValue()) && e.data.Obj.getValue() != "") {
                                e.data.Obj._doCascadeAction(this.id, e.data.Obj, e.data.status);
                            }
                        });
                    }
                }
            }
        },
        _doCascadeAction: function (id, parentObj, status) {
            parentObj._currentValue = parentObj._getField(parentObj.popupListItems[parentObj._activeItem], parentObj.mapFld._value);
            parentObj.selectDropObj = $('#' + id).ejDropDownList('instance');
            var args = { cascadeModel: parentObj.selectDropObj.model, cascadeValue: parentObj._currentValue, setCascadeModel:{}, requiresDefaultFilter: true };
            this._trigger("cascade", args);
            parentObj.selectDropObj._setCascadeModel = args.setCascadeModel;
            if (ej.isNullOrUndefined(parentObj[id])) {
                parentObj[id] = parentObj.selectDropObj.model.dataSource;
            }
            (ej.DataManager && parentObj[id] instanceof ej.DataManager) ?
                parentObj._cascadeOdataInit(parentObj[id], args.requiresDefaultFilter, status, args.cascadeQuery) :
            parentObj._cascadeJsonInit(parentObj.selectDropObj, parentObj[id], parentObj.mapFld._value, args.requiresDefaultFilter, status, args.cascadeQuery);
        },
        _cascadeOdataInit: function (_dSource, requiresFilter, status, cascadeQuery) {
            var proxy = this, queryPromise, tempQuery;
            proxy._dQuery = this.selectDropObj._getQuery().clone();
            tempQuery = proxy._dQuery.clone();
            requiresFilter ? tempQuery.where(proxy.mapFld._value, "equal", proxy._currentValue) : tempQuery = cascadeQuery;
            proxy.selectDropObj._addLoadingClass();
            if (!proxy._trigger("actionBegin", { requestFrom: "cascade" })) {
                queryPromise = _dSource.executeQuery(tempQuery);
                queryPromise.fail(function (e) {
                    proxy._changedSource = null;
                    proxy.selectDropObj.setModel({ dataSource: proxy._changedSource, enabled: false });
                    proxy._trigger("actionFailure", { e: e, requestFrom: "cascade" });
                }).done(function (e) {
                    proxy._trigger("actionSuccess", { e: e, requestFrom: "cascade" });
                    proxy._cascadeDataBind(proxy.selectDropObj, e.result, status);
                    proxy.selectDropObj._removeLoadingClass();
                }).always(function (e) {
                    proxy._trigger("actionComplete", { e: e, requestFrom: "cascade" });
                });
            }
        },

        _cascadeJsonInit: function (cascadeDropDownObj, _dSource, mapFld, requiresFilter, status, cascadeQuery) {           
            var tempQuery = requiresFilter ? ej.Query().where(mapFld, "==", this._currentValue) : cascadeQuery
            var changedSource = ej.DataManager(_dSource).executeLocal(tempQuery);
            this._cascadeDataBind(cascadeDropDownObj, changedSource, status);
        },

        _cascadeDataBind: function (cascadeDropDownObj, changedSource, status) {
			var cascadeVal  = cascadeDropDownObj.value();
            if ((this.model.showCheckbox && status) || (this.model.multiSelectMode != "none" && this.activeItem.hasClass("e-active"))) {
                this._changedSource = (!ej.isNullOrUndefined(this._changedSource)) ? this._changedSource.concat(changedSource) : changedSource;
            }
            else if (!this.model.showCheckbox && this.model.multiSelectMode == "none") this._changedSource = changedSource;
            else {
                for (var i = 0; i < changedSource.length; i++) {
                    if (this._isPlainType(changedSource) && this._isPlainType(this._changedSource)) this._changedSource.splice(this._changedSource.indexOf(changedSource[i]), 1);
                    else {
                        for (var j = 0; j < this._changedSource.length; j++) {
                            if (JSON.stringify(this._changedSource[j]) == JSON.stringify(changedSource[i]))
                                this._changedSource.splice(j, 1);
                        }

                    }
                }
                cascadeDropDownObj.setModel({ dataSource: null });
            }
			var cascadeValFn = cascadeDropDownObj.model.value;
            var cascadeModel = JSON.parse(JSON.stringify(cascadeDropDownObj.model)),enable;
            cascadeDropDownObj.setModel({ dataSource: this._changedSource, enabled: this._changedSource.length > 0 });
			if( !this._isSingleSelect() ) cascadeDropDownObj.selectItemByValue(cascadeVal);
            if (cascadeDropDownObj.model.showCheckbox || cascadeDropDownObj.model.multiSelectMode != "none") {
                $("input:hidden[id^='#'][name=" + cascadeDropDownObj._id + "]").remove();
            }
            
            if (!cascadeDropDownObj._setSelectedItem) {
                var selectProp = ["value", "text", "selectedIndex", "selectedIndices"];
                for (var m = 0; m < selectProp.length ; m++)
                    cascadeDropDownObj.model[selectProp[m]] = cascadeModel[selectProp[m]];
				cascadeDropDownObj.model["value"] = cascadeValFn;
                cascadeDropDownObj._finalize();                
            }            
            else {                                               
               cascadeDropDownObj.setModel(cascadeDropDownObj._setCascadeModel);
            }
            cascadeDropDownObj._setSelectedItem = true;
        },        

        _OnMouseEnter: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            var targetEle;
            this.ultag.children("li").removeClass("e-hover");
            if ($(e.target).is("li:not('.e-category')")) { $(e.target).addClass("e-hover"); }
            if ($(e.target).hasClass("e-disable"))
                $(e.target).removeClass('e-hover');
            else if (e.target.tagName != "li") {
                targetEle = $(e.target).parents("li:not('.e-category')");
                $(targetEle).addClass("e-hover");
            }
            var activeItem;
            this.ultag.children("li:not('.e-category')").each(function (index) {
                if ($(this).hasClass("e-hover")) {
                    activeItem = index;
                    return false;
                }
            });
            this._activeItem = activeItem;
        },
        _OnMouseLeave: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            this.ultag.children("li").removeClass("e-hover");
        },
        _OnMouseClick: function (e) {
            this._uiInteract = true;
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            if (this.model.enableFilterSearch && $(e.target).is("li") && $(e.target).hasClass('e-nosuggestion')) return false;
            else if (($(e.target).is("li") && !$(e.target).hasClass('e-disable')) || (!$(e.target).is("li") && !$(e.target).closest("li").hasClass('e-disable'))) {
                if (this._isSingleSelect()) {
                    this._enterTextBoxValue();
                    this._hideResult();
                } else {
                    if (this.model.showCheckbox) {
                        var liEle = e.target.nodeName === "LI" ? e.target : $(e.target).parents("li.e-hover"),
                        checkboxEle = $(liEle).find('.e-checkwrap')[0];
                        this._onCheckChange({ target: checkboxEle });
                    }
                    else {
                        var ele = $(e.target).is("li") ? e.target : $(e.target).closest("li")[0];
                        this._activeItem = $.inArray(ele, this._getLi());
                        if ($(ele).hasClass("e-active")) this._removeTextBoxValue();
                        else this._enterTextBoxValue();
                    }
                   
                }
            }
        },        

        _OnDocumentClick: function (e) {
            if (this.model && (!this.model.enabled || this.model.readOnly || this._readOnly)) return false;
            if (!$(e.target).is(this.popupList) && !$(e.target).parents(".e-ddl-popup").is(this.popupListWrapper) &&
                !$(e.target).is(this._visibleInput) && !$(e.target).parents(".e-ddl").is(this.wrapper)) {
                this._hideResult();
            }
            else if ($(e.target).is(this.inputSearch)) {
                this.inputSearch.focus();
            }
            else if ($(e.target).is(this.popupList) || $(e.target).parents(".e-ddl-popup").is(this.popupListWrapper))
                this._preventDefaultAction(e);
        },

        _OnKeyPress: function (e) {
            if (this.model.enableIncrementalSearch && e.keyCode != 13) {
                this._OnTextEnter((ej.browserInfo().name == "mozilla") ? e.charCode : e.keyCode);
            }
            if (e.keyCode == 32) this._preventDefaultAction(e);
        },
        _OnTextEnter: function (from) {
            var proxy = this;
            this._incqueryString += String.fromCharCode(from);
            if (this._incqueryString.length > 0) {
                setTimeout(function () { proxy._incqueryString = ""; }, 1000);
            }
            var list = this._getLi(), i,
            caseSence = this.model.caseSensitiveSearch,            
            str, queryStr = this._incqueryString,
            querylength = this._incqueryString.length, searchflag = false;

            if (!caseSence) queryStr = queryStr.toLowerCase();

            for (i = 0; i < list.length; i++) {
                str = $(list[i]).text();
                str = caseSence ? str : str.toLowerCase();
                if (str.substr(0, querylength) == queryStr) {
                    this._activeItem = i;
                    if (this._isSingleSelect()){
						this._enterTextBoxValue();
						this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
					}
                    else if (this._isPopupShown()) {
                        this._removeListHover();                      
                        this._addListHover();
                    } 
                    searchflag = true;
                }                 
                if (searchflag) break;
            }

        },

        _selectItem: function (current) {
            if (!this._isSingle) this._clearTextboxValue();
            this._activeItem = current;
            this._addListHover();
            this._enterTextBoxValue();
        },
        _focusItem: function (current) {
            this._removeListHover();
            this._activeItem = current;
            this._addListHover();
        },
        _selectFocusedItem: function (current) {
            this._focusItem(current);
            this._enterTextBoxValue();
        },
        
        _selectShiftDown: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = start; n <= stop; n++) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftUp: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = stop; n >= start ; n--) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftHome: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current >= 0 && current <= this._listSize - 1) {
                if (current == 0) this._clearTextboxValue();
                else {
                    for (var n = current; n >= stop ; n--) {
                        if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                            this._activeItem = n;
                            this._enterTextBoxValue();
                        }
                    }
                }
                this._activeItem = current;
                if (current == 0) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": 0 });
            }
        },
        _selectShiftEnd: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current <= this._listSize - 1) {
                if (current == stop) this._clearTextboxValue();
                else 
                for (var n = current; n <= stop; n++) {
                    if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                        this._activeItem = n;
                        this._enterTextBoxValue();
                    }
                }
                this._activeItem = current;
                if (current == stop) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": this.ultag.outerHeight() });
            }
        },


        _getLastFocusedLi: function () {
            return this._selectedIndices && this._selectedIndices.length > 0 ? this._selectedIndices[this._selectedIndices.length - 1] : null;
        },

        _getLastShiftFocusedLi: function (index, isDown) {
            var step = isDown ? index - 1 : index + 1;
            if ($.inArray(step, this._selectedIndices) < 0) {
                return index;
            }
            else {
                return this._getLastShiftFocusedLi(step, isDown);
            }
        },

        _shiftUp: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(0, step, false, false, true);
            }
            else if (current > 0 && current <= this._listSize - 1) {

                var select = this._disableItemSelectUp(current - step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current - 1 == this._selectedIndices[this._selectedIndices.length - 2])
                            for (var s = 1; s <= step; s++) {
                                if (current - s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current + 1 -s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current - s);
                                }
                                else break;
                            }
                        else {
                            var next = this._getLastShiftFocusedLi(this._getLastFocusedLi(), false);
                            this._selectShiftUp(select, next, isCtrl);
                        }
                    }
                    else {
                        this._moveUp(current, step, false);
                    }

                }

            }
        },

        _shiftDown: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, false, true);
            }
            else if (current < this._listSize - 1) {
                var select = this._disableItemSelectDown(current + step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current + 1 == this._selectedIndices[this._selectedIndices.length - 2]) {
                           for (var s = 1; s <= step; s++) {
                                if (current + s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current - 1 +s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current + s);
                                }
                                else break;
                            }
                        }
                        else {
                            var start = this._getLastShiftFocusedLi(this._getLastFocusedLi(), true);
                            this._selectShiftDown(start, select, isCtrl);
                        }
                    }
                    else {
                        this._moveDown(current, step, false);
                    }
                }

            }
        },
        _moveUp: function (current, step, isMulti) {
            if (current == null || current <= 0) {
                this._checkDisableStep(0, step, false, isMulti);
            }
            else if (current > this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, false, isMulti);
            }
            else if (current > 0 && current <= this._listSize - 1) {
                this._checkDisableStep(current, step, false, isMulti);
            }
        },
        _moveDown: function (current, step, isMulti) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, isMulti);
            }
            else if (current == 0) {
                this._checkDisableStep(0, step, true, isMulti);
            }
            else if (current >= this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, true, isMulti);
            }
            else if (current < this._listSize - 1) {
                this._checkDisableStep(current, step, true, isMulti);
            }
        },
        _checkDisableStep: function (current, step, isdown, isMulti, shift) {
            var command = isdown ? "_disableItemSelectDown" : "_disableItemSelectUp";
            var index = isdown ? current + step : current - step;
            var select = this[command](index);
            if (select == null) {
                for (var i = step; i >= 0; i--) {
                    index = isdown ? current + i : current - i;
                    select = this[command](index);
                    if (select != null) break;
                }
            }
            if (select != null) {
                isMulti ? this._focusItem(select) : this._selectItem(select);
                if (shift && isMulti) this._enterTextBoxValue();
            }

        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    return this._disableItemSelectDown(current + 1);
                }
            }
            else return this._listSize - 1;
        },

        _disableItemSelectUp: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    if (current > 0) {
                        return this._disableItemSelectUp(current - 1);
                    }
                }
            }
        },

        _preventDefaultAction: function (e, stopBubble) {
            e.preventDefault ? e.preventDefault() : (e.returnValue = false);
            if (stopBubble) {
                e.stopPropagation ? e.stopPropagation() : (e.cancelBubble = true);
            }
        },

        _OnKeyDown: function (e) {
            this._uiInteract = true;
            if (this.model.enabled) {
                this._itemId = null;
                var _popupListItems = this._getLi(), liH, popupH, activeitem, flag;
                this._listSize = _popupListItems.length;                
                popupH = this.popupList.height();
                liH = this.ultag.children("li").outerHeight();
                activeitem = Math.round(popupH / liH) != 0 ? Math.round(popupH / liH) : 5;
                this._isSingle = this._isSingleSelect();
                if (this._isSingle) {
                    switch (e.keyCode) {
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                                break;
                            }
                        case 33: /* page up */
                            var step = e.keyCode == 33 ? activeitem : 1;
                            this._moveUp(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
					    case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                                break;
                            }
                        case 34: /* page down */
                            var step = e.keyCode == 34 ? activeitem : 1;
                            this._moveDown(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1);
                            else this._moveUp(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1);
                            else this._moveDown(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            this._moveDown(this._listSize - 1, 0);
                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            this._moveUp(step, step);
                            this._preventDefaultAction(e);
                            break;
                    }
                }
                else {
                    switch (e.keyCode) {
                        
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftUp(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 33: /* page up */
                            if (e.shiftKey) {
                                this._shiftUp(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, activeitem, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
						case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftDown(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;

                        case 34: /* page down */

                            if (e.shiftKey) {
                                this._shiftDown(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, activeitem, e.ctrlKey);
                            this._preventDefaultAction(e);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1, false);
                            else this._moveUp(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1, false);
                            else this._moveDown(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            if (e.shiftKey) {
                                this._selectShiftEnd(this._activeItem, this._listSize - 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, this._listSize, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            if (e.shiftKey) {
                                this._selectShiftHome(this._activeItem, 0, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, step, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                    }
                }
            }
        },

        _OnKeyUp: function (e) {
            if (this.model.enabled) {
                this._preventDefaultAction(e);
                var target = e.target;
                if (this._activeItem == null) {
                    this._activeItem = this._getLi().index(this.popupList.find("ol,ul").children("li.e-hover"));
                }
                if (this._trim(this._visibleInput.val()) == "" && e.keyCode == 38 && e.keyCode == 40) {
                    this._hideResult();
                    return false;
                }

                switch (e.keyCode) {
                    case 38: break;
                    case 40: break;
                    case 37: break;
                    case 39: break;

                    case 20: break;
                    case 16: break;
                    case 17: break;
                    case 18: break;
                    case 35: break;
                    case 36: break;
                    case 144: break;
                    case 27: break;
                    case 9: break;

                    case 13 /*Enter*/:
                        if (!this._isSingle && this._isPopupShown() && (e.ctrlKey || e.shiftKey) && this._activeItem >= 0) 
                            this._selectAndUnselect();
                        else if (this._isPopupShown() && !e.ctrlKey && !e.shiftKey){
							if(!ej.isNullOrUndefined(this.inputSearch)){
								if(this.getSelectedItem().length == 0) {
									this.selectItemByIndex(0);
									$(this.listitems[0]).removeClass("e-hover");
								}
								else {		
									var focusedItems = this._getLastFocusedLi();
                                    if(this.model.multiSelectMode  != "none" || this.model.showCheckbox) {
										this.unselectItemByIndex(focusedItems);
										$(this.listitems[focusedItems]).removeClass("e-hover");
									}
								}
							}
							this._hideResult();
						}
						else if (this._isPopupShown()) this._hideResult();
                        this._preventDefaultAction(e);
                        break;

                    case 32 /*spacebar*/:
                        if (this._isPopupShown() && this._isSingle) this._hideResult();
                        if (!this._isSingle && this._isPopupShown() && this._activeItem >= 0) {
                            this._selectAndUnselect();
                        }
                        this._preventDefaultAction(e);
                        break;
                    case 8 /*backspace*/:
                        if(this.model.multiSelectMode =="visualmode") this._deleteLastBox();                        
                        this._preventDefaultAction(e);
                        break;
                    case 46 /*Del*/:
                        if (this.model.multiSelectMode == "visualmode" || this.model.showCheckbox) {
                            this._deleteBox(this._ulBox.children("li.e-active"));
                            break;
                        }
                }
            }
        },

        _isSingleSelect: function () {
            return !this.model.showCheckbox && this.model.multiSelectMode == "none";
        },

        _selectAndUnselect: function () {
            if (this.model.showCheckbox) {
                this._isChecked(this._getActiveItem().find(".e-checkwrap")[0]) ?
                        this._removeTextBoxValue() : this._enterTextBoxValue();
            }
            else if (this.model.MultiSelectMode != "none") {
                this._getActiveItem().hasClass("e-active") ? this._removeTextBoxValue() : this._enterTextBoxValue();
            }
        },

        _targetFocus: function () {
            if (this.model.enabled && !this._isFocused) {
                if (!this._isWatermark)
                    this._hiddenSpan.css("display", "none");
                this.wrapper.addClass("e-focus e-popactive");
                this._isFocused = true;
                this._trigger("focusIn");
            }
        },

        _targetBlur: function () {
            if (this.model.enabled) {
                this._isFocused = false;
                this.wrapper.removeClass("e-focus e-popactive");
                this._setWatermark();
                this._trigger("focusOut");
            }
        },

		_getLocalizedLabels: function (property) {
            return this._localizedLabels[property] === undefined ? ej.DropDownList.Locale["en-US"][property] : this._localizedLabels[property]
        },
        _wireEvents: function () {
            this._on(this.wrapper, "focus", this._targetFocus);
            this._on(this.wrapper, "blur", this._targetBlur);
            this._on(this.wrapper, "keydown", this._OnKeyDown);
            !ej.isNullOrUndefined(this.popupList) && this._on(this.popupList, "keydown", this._OnKeyDown);
            !ej.isNullOrUndefined(this.popupList) && this._on(this.popupList, "keyup", this._OnKeyUp);
            this._on(this.wrapper, "keyup", this._OnKeyUp);
            !ej.isNullOrUndefined(this.popupList) && this._on(this.popupList, "keypress", this._OnKeyPress);
            this._on(this.wrapper, "keypress", this._OnKeyPress);
        },

        _unwireEvents: function () {
            this._off(this.wrapper, "focus", this._targetFocus);
            this._off(this.wrapper, "blur", this._targetBlur);
            this._off(this.wrapper, "keydown", this._OnKeyDown);
            !ej.isNullOrUndefined(this.popupList) && this._off(this.popupList, "keydown", this._OnKeyDown);
            !ej.isNullOrUndefined(this.popupList) && this._off(this.popupList, "keyup", this._OnKeyUp);
            this._off(this.wrapper, "keyup", this._OnKeyUp);
            !ej.isNullOrUndefined(this.popupList) && this._off(this.popupList, "keypress", this._OnKeyPress);
            this._off(this.wrapper, "keypress", this._OnKeyPress);
			$(window).off("resize", $.proxy(this._OnWindowResize, this));
        },

        _multiItemSelection: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i;
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },
        _appendCheckbox: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i,
                $checkbox = document.createElement("input"),
                $spanCheck = document.createElement("span");
                this._setAttr($checkbox, { type: "checkbox", name: "list" + index, "data-role": "none", id: this._id + "_" + "check" + index })
                    ._setClass($checkbox, "e-check-input")
                    ._setAttr($spanCheck, { name: "list" + index + "_wrap", "data-role": "none", id: this._id + "_" + "check" + index + "wrap", unselectable: "on", "aria-checked": false})
                    ._setClass($spanCheck, "e-checkwrap e-icon ");
                $spanCheck.appendChild($checkbox);
                listItems[i].insertBefore($spanCheck, listItems[i].childNodes[0]);
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },

        _onCheckChange: function (e) {
            var curEle = e.target.nodeName === "INPUT" ? e.target.parentElement : e.target;
            this._activeItem = $.inArray($(curEle).parents("li")[0], this._getLi());
            if (!this._hasClass(curEle, "e-check-act")) {
                this._enterTextBoxValue();
            }
            else {
                this._removeTextBoxValue();
            }
        },
        _isChecked: function (checkEle) {
            return (this._hasClass(checkEle, "e-check-act") && $(checkEle).children(".e-check-input")[0].checked == true);
        },
        _removeCheck: function () {
            this._getLi().find(".e-checkwrap").remove();
        },
        _resetCheck: function () {
            var getLi = this._getLi(), checkEle;
            getLi.find(".e-check-act").removeClass("e-check-act").attr("aria-checked",false);
            checkEle = getLi.find(".e-check-input:checked");
            for (var e = 0; e < checkEle.length; e++) {
                checkEle[e].checked = false;
            }
        }

    });
	ej.DropDownList.Locale = ej.DropDownList.Locale || {};
    ej.DropDownList.Locale["default"] = ej.DropDownList.Locale["en-US"] = {        
        emptyResultText: "No suggestions",  
		watermarkText:""
    };
    ej.MultiSelectMode = {
        /** Supports to selection mode with none only */
        None: "none",
        /** Supports to selection mode with delimitter only */
        Delimiter: "delimiter",
        /** Supports to selection mode with visualmode only */
        VisualMode: "visualmode"
    };
    ej.VirtualScrollMode = {      
        /** Make virtual scrollbar in normal mode */
        Normal: "normal",
        /** Make virtual scrollbar in continuous mode*/
        Continuous: "continuous"
    };
    
})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejTooltip = (function (_super) {
    __extends(ejTooltip, _super);
    function ejTooltip(element, options) {
        _super.call(this);
        this._rootCSS = "e-tooltip";
        this._setFirst = false;
        this.PluginName = "ejTooltip";
        this.id = "null";
        this.model = null;
        this.defaults = {
            height: "auto",
            width: "auto",
            enabled: true,
            content: null,
            containment: "body",
            target: null,
            title: null,
            closeMode: "none",
            autoCloseTimeout: 4000,
            position: {
                stem: { horizontal: "center", vertical: "bottom" },
                target: { horizontal: "center", vertical: "top" }
            },
            associate: "target",
            collision: "flipfit",
            showShadow: false,
            cssClass: null,
            animation: {
                effect: "none",
                speed: 0
            },
            isBalloon: true,
            showRoundedCorner: false,
            enableRTL: false,
            allowKeyboardNavigation: true,
            tip: {
                size: {
                    width: 20,
                    height: 10
                },
                adjust: {
                    xValue: 0,
                    yValue: 0
                }
            },
            trigger: "hover",
            create: null,
            click: null,
            destroy: null,
            hover: null,
            tracking: null,
            beforeOpen: null,
            beforeClose: null,
            open: null,
            close: null,
        };
        this.dataTypes = {
            enabled: "boolean",
            closeMode: "enum",
            autoCloseTimeout: "number",
            trigger: "enum",
            position: {
                stem: "data",
                target: "data"
            },
            associate: "enum",
            collision: "enum",
            showShadow: "boolean",
            animation: {
                effect: "enum",
                speed: "number"
            },
            isBalloon: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            allowKeyboardNavigation: "boolean",
            tip: {
                size: {
                    width: "number",
                    height: "number"
                },
                adjust: {
                    xValue: "number",
                    yValue: "number"
                }
            }
        };
        this.isTrack = true;
        this._isCancel = false;
        this._isHidden = true;
        this.arrowValue = { left: 0, top: 0, width: 0, height: 0, display: null };
        this.tooltipPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.targetPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.mouseTimer = null;
        this.positionTarget = null;
        this.positionTooltip = null;
        this.containerSize = null;
        this._createTitle = function () {
            this.tooltipTitle = ej.buildTag('div.e-def e-header', " ", {}, {});
            this.tooltipHeader = ej.buildTag('div', " ", {}, {});
            $(this.tooltipTitle).html(this.model.title).appendTo(this.tooltipHeader);
        };
        if (element) {
            if (!element["jquery"]) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejTooltip(options).data(this.PluginName);
            }
        }
    }
    ejTooltip.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    ejTooltip.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    ejTooltip.prototype.triggerEvents = function (eventName, eventProp) {
        var temp;
        switch (eventName) {
            case "click":
                var clickArg = eventProp;
                temp = this._trigger(eventName, clickArg);
                break;
            case "hover":
                var hoverArg = eventProp;
                temp = this._trigger(eventName, hoverArg);
                break;
            case "tracking":
                var trackArg = eventProp;
                temp = this._trigger(eventName, trackArg);
                break;
            case "beforeOpen":
                var beforeOpenArg = eventProp;
                temp = this._trigger(eventName, beforeOpenArg);
                break;
            case "open":
                var openArg = eventProp;
                temp = this._trigger(eventName, openArg);
                break;
            case "beforeClose":
            case "close":
                var closeArg = eventProp;
                temp = this._trigger(eventName, closeArg);
                break;
        }
        return temp;
    };
    ejTooltip.prototype.enable = function (val) {
        if (this.tooltip.hasClass("e-disable")) {
            this.model.enabled = true;
            this.tooltip.removeClass("e-disable");
        }
    };
    ejTooltip.prototype.disable = function (val) {
        if (!this.tooltip.hasClass("e-disable")) {
            this.model.enabled = false;
            this.tooltip.addClass("e-disable");
        }
    };
    ejTooltip.prototype.show = function (targetElement, func) {
        if (this.model.enabled) {
            if (ej.isNullOrUndefined(targetElement)) {
                var target = (this.model.target == null) ? this.element : $(this.element).find(this.model.target + ":first");
                this._positionElement(target);
            }
            else {
                this._positionElement(targetElement);
            }
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).show(func);
                }
                else {
                    if (typeof func === "function") {
                        func.call.apply(this.tooltip);
                    }
                }
            }
            else {
                this._showTooltip();
            }
        }
    };
    ejTooltip.prototype.hide = function (func) {
        if (this.model.enabled) {
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).hide(func);
                }
                else if (typeof func === "function") {
                    func.call.apply(this.tooltip);
                }
            }
            else {
                this._hideTooltip();
            }
        }
    };
    ejTooltip.prototype._destroy = function () {
        this.mouseTimer && clearTimeout(this.mouseTimer);
        this.timer && clearTimeout(this.timer);
        $(this.tooltip).remove();
        this.tooltip = null;
    };
    ejTooltip.prototype._setModel = function (options) {
        var option;
        for (option in options) {
            switch (option) {
                case "height":
                    this._setHeight(options[option]);
                    break;
                case "width":
                    this._setWidth(options[option]);
                    break;
                case "enabled":
                    this._enabled(options[option]);
                    break;
                case "content":
                    this._setContent(options[option]);
                    break;
                case "title":
                    this.model.title = options[option];
                    if (this.model.title == null) {
                        $(this.tooltipHeader).remove();
                        this.tooltipHeader = null;
                        this.tooltipTitle = null;
                        if (this.model.closeMode === ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                    }
                    else
                        (ej.isNullOrUndefined(this.tooltipHeader)) ? this._createHeader() : $(this.tooltipTitle).html(this.model.title);
                    this.tooltipPos.height = $(this.tooltip).outerHeight();
                    break;
                case "associate":
                    this.model.associate = options[option];
                    this._wireMouseEvents(false);
                    this._wireMouseEvents(true);
                    break;
                case "position":
                    this._setPosition(options[option]);
                    break;
                case "collision":
                    this.model.collision = options[option];
                    break;
                case "closeMode":
                    if (typeof options[option] !== "undefined") {
                        this.model.closeMode = options[option];
                        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                        else {
                            $(this.tooltipClose).remove();
                            this.tooltipClose = null;
                        }
                        this.tooltipPos.height = $(this.tooltip).outerHeight();
                    }
                    break;
                case "cssClass":
                    this._setSkin(options[option]);
                    break;
                case "showShadow":
                    this._shadowEffect(options[option], this.model.position);
                    break;
                case "isBalloon":
                    if (!ej.isNullOrUndefined(options[option])) {
                        this.model.isBalloon = options[option];
                        if (!this.model.isBalloon) {
                            $(this.tip).remove();
                            this.tip = null;
                        }
                        else
                            this._renderArrow();
                    }
                    break;
                case "animation":
                    var val = options[option];
                    this.model.animation = $.extend(true, this.model.animation, val);
                    if (this.model.animation.effect != ej.Tooltip.Effect.None) {
                        this._off($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._off($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    else if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                        this._on($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._on($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    break;
                case "enableRTL":
                    this._setRTL(options[option]);
                    break;
                case "target":
                    this._wireTriggerEvents(false);
                    this.model.target = options[option];
                    this._wireTriggerEvents(true);
                    this._renderTarget();
                    break;
                case "trigger":
                    this._setTrigger(options[option]);
                    break;
                case "showRoundedCorner":
                    this.model.showRoundedCorner = options[option];
                    this._roundedCorner(options[option]);
                    break;
                case "allowKeyboardNavigation":
                    this.model.allowKeyboardNavigation = options[option];
                    if (!this.model.allowKeyboardNavigation) {
                        this._off($(window), "keydown", this._keyDown);
                    }
                    else {
                        this._on($(window), "keydown", this._keyDown);
                    }
                    break;
            }
        }
    };
    ejTooltip.prototype._enabled = function (val) {
        (val) ? this.enable(val) : this.disable(val);
        this.model.enabled = val;
    };
    ejTooltip.prototype._shadowEffect = function (val, position) {
        this.model.showShadow = val;
        var shadowEffect = null;
        $(this.tooltip).removeClass("e-tooltipShadowLeft e-tooltipShadowRight");
        if (this.model.showShadow) {
            if (this.model.isBalloon) {
                switch (position.stem.horizontal) {
                    case "center":
                        shadowEffect = (position.stem.vertical == "top") ? "e-tooltipShadowLeft" : (position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                    case "right":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "top") ? "e-tooltipShadowLeft" : "e-tooltipShadowRight";
                        break;
                    case "left":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                }
            }
            else
                shadowEffect = "e-tooltipShadowLeft";
            $(this.tooltip).addClass(shadowEffect);
        }
    };
    ejTooltip.prototype._setContent = function (val) {
        this.model.content = val;
        $(this.tooltipContent).html(this.model.content);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.tooltipPos.width = $(this.tooltip).outerWidth();
    };
    ejTooltip.prototype._setPosition = function (val) {
        this.model.position.stem = $.extend(true, this.model.position.stem, val.stem);
        this.model.position.target = $.extend(true, this.model.position.target, val.target);
    };
    ejTooltip.prototype._setTrigger = function (val) {
        this._wireTriggerEvents(false);
        this.model.trigger = val;
        this._wireTriggerEvents(true);
    };
    ejTooltip.prototype._init = function () {
        this.id = this.element[0].id;
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.tipSize = $.extend(true, {}, this.model.tip.size);
        this._initialize();
        this._render();
        this.enable(this.model.enabled);
        this._wireEvents(true);
    };
    ejTooltip.prototype._initialize = function () {
        if (ej.isNullOrUndefined(this.model.target)) {
            if (ej.isNullOrUndefined(this.model.content) && (!ej.isNullOrUndefined(this.element.attr("title")))) {
                this.model.content = this.element.attr("title");
                this.element.attr("data-content", this.model.content);
                this.element.removeAttr("title");
            }
        }
        else
            this._renderTarget();
    };
    ejTooltip.prototype._wireEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        this._wireTriggerEvents(val);
        if (this.model.allowKeyboardNavigation)
            this[wire]($(window), "keydown", this._keyDown);
        (this.model.target != null) ? this[wire](this.element, "scroll", this.model.target, this._hideTooltip) : this[wire](this.element, "scroll", this._hideTooltip);
        this[wire]($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
        this[wire]($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
        this[wire]($(window), "resize", this._hideTooltip);
        this[wire]($(window), "touchend", this._docTouchEndHandler);
    };
    ejTooltip.prototype._wireTriggerEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        if (this.model.trigger == ej.Tooltip.Trigger.Focus)
            (this.model.target != null) ? this[wire](this.element, "blur", this.model.target, this._hideTooltip) : this[wire](this.element, "blur", this._hideTooltip);
        else
            (this.model.target != null) ? this[wire](this.element, ej.isDevice() ? "touchstart" : "mouseleave", this.model.target, this._onMouseOut) : this[wire](this.element, ej.isDevice() ? "touchstart" : "mouseleave", this._onMouseOut);
        this._wireMouseEvents(val);
        var triggerEvent = (this.model.trigger == ej.Tooltip.Trigger.Click) ? (ej.isDevice() ? "touchstart" : "click") : (this.model.trigger == ej.Tooltip.Trigger.Focus) ? (ej.isDevice() ? "touchstart" : "focus") : (ej.isDevice() ? "touchstart" : "mouseenter");
        (this.model.target != null) ? this[wire](this.element, triggerEvent, this.model.target, this._targetHover) : this[wire](this.element, triggerEvent, this._targetHover);
    };
    ejTooltip.prototype._wireMouseEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        if (this.model.associate == ej.Tooltip.Associate.MouseEnter || this.model.associate == ej.Tooltip.Associate.MouseFollow)
            (this.model.target != null) ? this[wire](this.element, ej.isDevice() ? "touchstart" : "mousemove", this.model.target, this._tooltipMove) : this[wire](this.element, ej.isDevice() ? "touchstart" : "mousemove", this._tooltipMove);
    };
    ejTooltip.prototype._render = function () {
        this.tooltip = ej.buildTag("div.e-tooltip-wrap e-widget", "", {}, { role: "tooltip", 'aria-readonly': 'true', 'aria-hidden': 'true', 'aria-describedby': this.id + '_content', 'id': this.id + '_Main' });
        this.tooltipInter = ej.buildTag("div.e-tipContainer", "", {}, {});
        this.tooltip.append(this.tooltipInter);
        if (this.model.isBalloon)
            this._renderArrow();
        $(this.model.containment).append(this.tooltip);
        this._setHeight(this.model.height);
        this._setWidth(this.model.width);
        this._createHeader();
        this._tooltipContent();
        if (this.model.cssClass)
            this.tooltip.addClass(this.model.cssClass);
        if (this.model.showRoundedCorner)
            this._roundedCorner(this.model.showRoundedCorner);
        if (this.model.enableRTL)
            this._setRTL(this.model.enableRTL);
        $(this.tooltip).css({ "top": "auto", "left": "auto" });
        this.tooltipPos = { width: $(this.tooltip).outerWidth(), height: $(this.tooltip).outerHeight(), left: $(this.tooltip).offset().left, top: $(this.tooltip).offset().top, position: "absolute" };
        if (ej.isNullOrUndefined(this.model.target)) {
            this._containerCalc(this.element);
            this._positionElement(this.element);
        }
    };
    ejTooltip.prototype._containerCalc = function (target) {
        if (ej.isNullOrUndefined(target))
            target = this.element;
        var containerElement = { left: 0, top: 0 };
        var childElement = $(target).offset();
        this.containerSize = {
            height: (this.model.containment == "body") ? $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight : $(this.model.containment).innerHeight(),
            width: (this.model.containment == "body") ? $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth : $(this.model.containment).innerWidth()
        };
        this.containerSize.left = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().left - $(this.model.containment).offsetParent().offset().left) : 0 : 0;
        this.containerSize.top = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().top - $(this.model.containment).offsetParent().offset().top) : 0 : 0;
        childElement.left -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().left : $(this.model.containment).offset().left) : 0;
        childElement.top -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().top : $(this.model.containment).offset().top) : 0;
        this.targetPos.left = childElement.left;
        this.targetPos.top = childElement.top;
    };
    ejTooltip.prototype._setHeight = function (val) {
        this.model.height = val;
        (!isNaN(+val) && isFinite(val)) ? $(this.tooltip).css("height", val + "px") : $(this.tooltip).css("height", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setWidth = function (val) {
        this.model.width = val;
        if (this.model.width != "auto") {
            val = (!isNaN(+val) && isFinite(val)) ? val + "px" : val;
            $(this.tooltip).css("max-width", val);
            $(this.tooltip).css("min-width", "0px");
        }
        $(this.tooltip).css("width", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setRTL = function (val) {
        this.model.enableRTL = val;
        val ? this.tooltip.addClass("e-rtl") : this.tooltip.removeClass("e-rtl");
    };
    ejTooltip.prototype._setSkin = function (skin) {
        if (this.model.cssClass != skin) {
            this.tooltip.removeClass(this.model.cssClass).addClass(skin);
            this.model.cssClass = skin;
        }
    };
    ejTooltip.prototype._roundedCorner = function (val) {
        (this.model.showRoundedCorner) ? this.tooltip.addClass("e-corner") : this.tooltip.removeClass("e-corner");
    };
    ejTooltip.prototype._renderArrow = function () {
        if (ej.isNullOrUndefined(this.tip)) {
            this.tip = ej.buildTag('div.e-arrowTip', " ", { 'id': this.id + "_eTip" }, {});
            $(this.tip).append("<div class='e-arrowTipOuter'></div>").append("<div class='e-arrowTipInner'></div>");
            $(this.tip).insertBefore(this.tooltipInter);
        }
    };
    ejTooltip.prototype._adjustArrow = function (position) {
        var leftValue, topValue, tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        var positionTooltip = position.stem, positionTarget = position.target;
        var arrow = { "tipHeight": 0, "tipWidth": 0 };
        if (positionTarget.horizontal == "right" || positionTarget.horizontal == "left") {
            leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : (positionTooltip.horizontal == "right") ? tooltipWidth : ((tooltipWidth) / 2 - (this.tipSize.width / 2));
            if (positionTooltip.horizontal != "center")
                topValue = (positionTooltip.vertical == "top") ? 5 : (positionTooltip.vertical == "center") ? ((tooltipHeight / 2) - (this.tipSize.width / 2)) : ((tooltipHeight - 5) - this.tipSize.width);
            else
                topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((this.tooltipPos.height / 2) - (this.tipSize.width / 2));
            arrow = this._arrowBinding(position, "horizontal");
        }
        else {
            topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((tooltipHeight / 2) - (this.tipSize.width / 2));
            if (positionTooltip.vertical == "center")
                leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : tooltipWidth;
            else
                leftValue = (positionTooltip.horizontal == "left") ? 10 : (positionTooltip.horizontal == "center") ? ((this.tooltipPos.width) / 2 - (this.tipSize.width / 2)) : ((tooltipWidth - 10) - this.tipSize.width);
            arrow = this._arrowBinding(position, "vertical");
        }
        this.arrowValue.left = leftValue;
        this.arrowValue.top = topValue;
        $(this.tip).css({ height: arrow.tipHeight + "px", width: arrow.tipWidth + "px", left: leftValue + "px", top: topValue + "px", display: (positionTooltip.horizontal == "center" && positionTooltip.vertical == "center") ? "none" : "block" });
    };
    ejTooltip.prototype._arrowBinding = function (position, arrowType) {
        var positionTooltip = position.stem, condition = (arrowType == "horizontal") ? (positionTooltip.horizontal != "center") : (positionTooltip.vertical == "center");
        var tipWidth, tipHeight, borderColor = $(this.tooltip).css("border-top-color"), backgroudColor = $(this.tooltip).css("background-color"), arrowOuterSize = this.model.tip.size.height, arrowInterSize = this.model.tip.size.height - 1, arrowCalculation = { "border-top": "none", "border-bottom": "none", "border-right": "none", "border-left": "none" };
        if (condition) {
            tipWidth = this.model.tip.size.height;
            tipHeight = this.model.tip.size.width;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "horizontal"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "horizontal"));
        }
        else {
            tipWidth = this.model.tip.size.width;
            tipHeight = this.model.tip.size.height;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "vertical"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "vertical"));
        }
        return { tipHeight: tipHeight, tipWidth: tipWidth };
    };
    ejTooltip.prototype._arrow = function (position, size, color, arrowCalculation, arrowType) {
        var positionTooltip = position.stem, innerLeft = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? "0px" : "1px" : "1px", innerTop = (arrowType == "horizontal") ? "1px" : (positionTooltip.vertical == "bottom") ? "0px" : "1px";
        arrowCalculation["border-top"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "bottom") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-bottom"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "top") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-right"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "left") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        arrowCalculation["border-left"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        if (size == this.model.tip.size.height - 1) {
            arrowCalculation["left"] = innerLeft;
            arrowCalculation["top"] = innerTop;
        }
        return arrowCalculation;
    };
    ejTooltip.prototype._iconRender = function () {
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky) {
            if (!ej.isNullOrUndefined(this.tooltipClose))
                $(this.tooltipClose).remove();
            this.tooltipClose = ej.buildTag("div .e-icon", " ", {}, { 'id': "_closeIcon" });
            (this.model.title != null) ? $(this.tooltipClose).insertAfter(this.tooltipTitle).addClass("e-close") : $(this.tooltipClose).insertBefore(this.tooltipInter).addClass("e-cross-circle");
            this._on($(this.tooltipClose), "click", this._hideTooltip);
        }
    };
    ejTooltip.prototype._renderTarget = function () {
        this.targetElement = $(this.element).find(this.model.target);
        for (var i = 0; i < this.targetElement.length; i++) {
            if (!ej.isNullOrUndefined($(this.targetElement[i]).attr("title"))) {
                this.targetElement[i].setAttribute("data-content", this.targetElement[i].title);
                this.targetElement[i].removeAttribute("title");
            }
        }
    };
    ejTooltip.prototype._tooltipContent = function () {
        this.tooltipContent = ej.buildTag('div.e-tipcontent e-def', "", {}, { 'id': this.id + '_content' });
        $(this.tooltipContent).html(this.model.content).addClass("e-def");
        (this.model.title != null) ? $(this.tooltipContent).insertAfter(this.tooltipHeader) : $(this.tooltipContent).appendTo(this.tooltipInter);
    };
    ejTooltip.prototype._positionElement = function (target) {
        this.tooltipPos.width = $(this.tooltip).outerWidth();
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.targetPos.width = $(target).outerWidth();
        this.targetPos.height = $(target).outerHeight();
        this._containerCalc(target);
        if (this.model.associate == ej.Tooltip.Associate.Window)
            this._browserPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Axis)
            this._axisPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Target)
            this._tooltipPosition(this.model.position);
        if (this.model.collision != ej.Tooltip.Collision.None && this.model.associate == ej.Tooltip.Associate.Target)
            this._calcCollision(this.model.position, target);
    };
    ejTooltip.prototype._browserPosition = function () {
        if (this.model.containment == "body") {
            this.containerSize = {
                height: $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight,
                width: $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth
            };
            var position = $.extend(true, {}, this.model.position);
            var calPosition = { position: "absolute", left: "auto", top: "auto", bottom: "auto", right: "auto" }, offsetTop, offsetLeft;
            if (!ej.isNullOrUndefined(this.tip))
                $(this.tip).css({ "display": "none" });
            (this.model.position.target.horizontal == "right") ? calPosition.right = 0 : (this.model.position.target.horizontal == "left") ? calPosition.left = 0 : (calPosition.left = (this.containerSize.width / 2) - (this.tooltipPos.width / 2));
            (this.model.position.target.vertical == "top") ? (calPosition.top = 0) : (this.model.position.target.vertical == "center") ? (calPosition.top = ((this.containerSize.height / 2) - (this.tooltipPos.height / 2))) : calPosition.bottom = 0;
            if (this.model.showShadow)
                this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css(calPosition);
        }
    };
    ejTooltip.prototype._tooltipMove = function (event) {
        if (this.model.closeMode == ej.Tooltip.CloseMode.None && this.model.enabled) {
            var proxy = this;
            if (this._isCancel)
                return;
            if (this.model.associate == ej.Tooltip.Associate.MouseFollow)
                this._mousePosition(event);
            else if (this.model.associate == ej.Tooltip.Associate.MouseEnter) {
                clearTimeout(this.mouseTimer);
                this.mouseTimer = setTimeout(function () {
                    if (proxy.isTrack)
                        proxy._mousePosition(event);
                }, 300);
            }
        }
    };
    ejTooltip.prototype._mousePosition = function (event) {
        var eventPageX, eventPageY;
        if (event.type == "touchstart") {
            event.preventDefault();
            eventPageX = event.touches[0].pageX;
            eventPageY = event.touches[0].pageY;
        }
        else if (event.type == "mousemove") {
            eventPageX = event.pageX;
            eventPageY = event.pageY;
        }
        this.isCollision = true;
        this._containerCalc(event.currentTarget);
        var tipGapX = 0, tipGapY = 0, tipSize = 0, positionTooltip = $.extend(true, {}, this.model.position.stem), position = $.extend(true, {}, this.model.position), containerElement = { left: 0, top: 0 }, calcPosition = { left: eventPageX, top: eventPageY }, childElement = { left: eventPageX, top: eventPageY }, containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        var targetLeft = (this.model.containment != "body") ? (eventPageX - $(this.model.containment).offset().left) : eventPageX, targetTop = (this.model.containment != "body") ? (eventPageY - $(this.model.containment).offset().top) : eventPageY;
        position.target.horizontal = position.target.vertical = "center";
        if (this.model.containment != "body")
            containerElement = ($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset() : $(this.model.containment).offset();
        childElement.left -= containerElement.left;
        childElement.top -= containerElement.top;
        while (this.isCollision) {
            calcPosition = $.extend(true, {}, childElement);
            var tipY = (this.model.isBalloon) ? (positionTooltip.vertical == "top" || positionTooltip.vertical == "bottom") ? (5 + (this.tipSize.height / 2)) : 0 : 0, tipX = (this.model.isBalloon) ? (positionTooltip.horizontal == "right" || positionTooltip.horizontal == "left") ? (10 + (this.tipSize.width / 2)) : 0 : 0;
            tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : 7;
            tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : 10;
            tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal != "center") ? this.model.tip.size.height : (positionTooltip.vertical != "center") ? this.model.tip.size.height : 0 : 2;
            calcPosition.left += (positionTooltip.horizontal == "right") ? -this.tooltipPos.width : (positionTooltip.horizontal == "left") ? 0 : -(this.tooltipPos.width / 2);
            calcPosition.top += (positionTooltip.vertical == "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical == "top") ? 0 : -(this.tooltipPos.height / 2);
            calcPosition.left += (positionTooltip.vertical != "center") ? ((positionTooltip.horizontal == "right") ? tipX : (positionTooltip.horizontal == "left") ? -tipX : 0) : 0;
            calcPosition.left += (positionTooltip.vertical == "center") ? (positionTooltip.horizontal == "right") ? -(tipSize) : (positionTooltip.horizontal == "left") ? +(tipSize + tipGapX) : 0 : 0;
            calcPosition.top += (positionTooltip.vertical == "top") ? +(tipSize + tipGapY) : (positionTooltip.vertical == "bottom") ? -(tipSize) : 0;
            if (this.targetElement != event.currentTarget) {
                this.targetElement = event.currentTarget;
                if (calcPosition.left < containerLeft || (calcPosition.left + this.tooltipPos.width > (containerLeft + this.containerSize.width)))
                    this.positionTooltip.horizontal = (targetLeft >= this.tooltipPos.width) ? "right" : ((this.containerSize.width - targetLeft) >= this.tooltipPos.width) ? "left" : "center";
                if (calcPosition.top < containerTop || ((calcPosition.top + this.tooltipPos.height) > (this.containerSize.height + containerTop)))
                    this.positionTooltip.vertical = (targetTop >= this.tooltipPos.height) ? "bottom" : ((this.containerSize.height - targetTop) >= this.tooltipPos.height) ? "top" : "center";
            }
            if (this.positionTooltip.horizontal != positionTooltip.horizontal || this.positionTooltip.vertical != positionTooltip.vertical) {
                this.isCollision = true;
                positionTooltip = $.extend(true, {}, this.positionTooltip);
            }
            else {
                this.isCollision = false;
                $(this.tooltip).css({ top: calcPosition.top + "px", left: calcPosition.left + "px", position: "absolute", right: "auto", bottom: "auto" });
                position.stem = $.extend(true, {}, this.positionTooltip);
                if (this.model.showShadow)
                    this._shadowEffect(this.model.showShadow, position);
                if (this.model.isBalloon)
                    this._adjustArrow(position);
                this._showTooltip();
                if (this.model.associate == ej.Tooltip.Associate.MouseEnter)
                    this.isTrack = false;
                if (this.model.associate == ej.Tooltip.Associate.MouseFollow) {
                    if (this.triggerEvents("tracking", { position: this.model.position, event: event }))
                        return;
                }
            }
        }
    };
    ejTooltip.prototype._axisPosition = function () {
        var position = $.extend(true, {}, this.model.position);
        if (typeof this.model.position.target.horizontal == 'number')
            var leftValue = (this.model.position.target.horizontal).toString();
        if (typeof this.model.position.target.vertical == 'number')
            var topValue = (this.model.position.target.vertical).toString();
        var offsetLeft = parseInt(leftValue), offsetTop = parseInt(topValue);
        if (!ej.isNullOrUndefined(this.tip))
            $(this.tip).css({ "display": "none" });
        if (this.model.showShadow)
            this._shadowEffect(this.model.showShadow, position);
        if (this.model.isBalloon)
            this._adjustArrow(position);
        if (isFinite(offsetLeft) && isFinite(offsetTop))
            $(this.tooltip).css({ top: offsetTop, left: offsetLeft, position: "absolute" });
    };
    ejTooltip.prototype._tooltipPosition = function (position) {
        var tipSize = 0, tipGap = 0, tipAdjustment = 0, positionTooltip = $.extend(true, {}, position.stem), positionTarget = $.extend(true, {}, position.target);
        var calcPosition = $.extend(true, {}, this.targetPos);
        var tipY = (positionTooltip.vertical === "top" || positionTooltip.vertical === "bottom") ? (5 + (this.tipSize.width / 2)) : 0, tipX = (positionTooltip.horizontal === "right" || positionTooltip.horizontal === "left") ? (10 + (this.tipSize.width / 2)) : 0, tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal !== "center") ? this.model.tip.size.height : (positionTooltip.vertical !== "center") ? this.model.tip.size.height : 0 : 0;
        var tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : (this.model.isBalloon) ? 0 : 2, tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : (this.model.isBalloon) ? 0 : 2;
        calcPosition.left += (positionTarget.horizontal === "right") ? this.targetPos.width : (positionTarget.horizontal === "left") ? 0 : (this.targetPos.width / 2);
        calcPosition.top += (positionTarget.vertical === "bottom") ? this.targetPos.height : (positionTarget.vertical === "top") ? 0 : (this.targetPos.height / 2);
        calcPosition.left += (positionTooltip.horizontal === "right") ? -this.tooltipPos.width : (positionTooltip.horizontal === "left") ? 0 : -(this.tooltipPos.width / 2);
        calcPosition.top += (positionTooltip.vertical === "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical === "top") ? 0 : -(this.tooltipPos.height / 2);
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0 : 0;
        calcPosition.left += (positionTarget.horizontal === "center" && positionTooltip.vertical !== "center") ? ((positionTooltip.horizontal === "right") ? tipX : (positionTooltip.horizontal === "left") ? -tipX : 0) : 0;
        calcPosition.top += (positionTarget.horizontal !== "center" && positionTooltip.horizontal !== "center") ? ((positionTooltip.vertical === "top") ? -tipY : (positionTooltip.vertical === "bottom") ? tipY : 0) : 0;
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0 : 0;
        this.tooltipPos.left = calcPosition.left;
        this.tooltipPos.top = calcPosition.top;
        if (this.model.collision === ej.Tooltip.Collision.None) {
            if (this.model.isBalloon)
                this._adjustArrow(position);
            this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css({ "top": calcPosition.top + "px", "left": calcPosition.left + "px", position: "absolute" });
        }
    };
    ejTooltip.prototype._calcCollision = function (position, target) {
        var position = $.extend(true, {}, position), newPosition = $.extend(true, {}, position), arrowSize = this.model.tip.size.height, isCollision = true;
        var targetLeft = (this.model.containment != "body") ? ($(target).offset().left - $(this.model.containment).offset().left) : $(target).offset().left, targetTop = (this.model.containment != "body") ? ($(target).offset().top - $(this.model.containment).offset().top) : $(target).offset().top;
        var availSpace = {
            topSpace: targetTop,
            rightSpace: this.containerSize.width - (targetLeft + this.targetPos.width),
            bottomSpace: this.containerSize.height - (targetTop + this.targetPos.height),
            leftSpace: targetLeft,
            centerRight: this.containerSize.width - (targetLeft + (this.targetPos.width / 2)),
            centerLeft: (targetLeft + (this.targetPos.width / 2)),
            centerTop: targetTop + (this.targetPos.height / 2),
            centerBottom: this.containerSize.height - (targetTop + (this.targetPos.height / 2)),
            tooltipWidth: this.tooltipPos.width + arrowSize,
            tooltipHeight: this.tooltipPos.height + arrowSize
        };
        if (this.model.collision === ej.Tooltip.Collision.Fit)
            this._collisionFit(position, availSpace);
        else {
            while (isCollision) {
                newPosition = this._collisionFlip(newPosition, availSpace);
                if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical || newPosition.stem.horizontal != position.stem.horizontal || newPosition.stem.vertical != position.stem.vertical) {
                    this._tooltipPosition(newPosition);
                    position = $.extend(true, {}, newPosition);
                }
                else
                    isCollision = false;
            }
            if (!isCollision) {
                if (this.model.collision == ej.Tooltip.Collision.FlipFit)
                    this._collisionFit(newPosition, availSpace);
                else {
                    this._adjustArrow(newPosition);
                    this._shadowEffect(this.model.showShadow, newPosition);
                    $(this.tooltip).css({ "top": this.tooltipPos.top + "px", "left": this.tooltipPos.left + "px", position: "absolute" });
                }
            }
        }
    };
    ejTooltip.prototype._collisionFlip = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), newPosition = $.extend(true, {}, position);
        var scrollLeft = $(this.model.containment).scrollLeft(), scrollTop = $(this.model.containment).scrollTop();
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if ((tooltipPos.left + tooltipPos.width) > (containerLeft + this.containerSize.width + scrollLeft) || (tooltipPos.left < containerLeft)) {
            if (position.target.horizontal != "center")
                newPosition.target.horizontal = (availSpace.leftSpace >= availSpace.tooltipWidth) ? "left" : (availSpace.rightSpace >= availSpace.tooltipWidth) ? "right" : "center";
            else
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
        }
        if (tooltipPos.top < containerTop)
            newPosition.target.vertical = (availSpace.bottomSpace >= availSpace.tooltipHeight) ? "bottom" : "center";
        if ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))
            newPosition.target.vertical = (availSpace.topSpace >= availSpace.tooltipHeight) ? "top" : "center";
        if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical) {
            if (newPosition.target.horizontal == "center")
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
            else
                newPosition.stem.horizontal = (newPosition.target.horizontal == "right") ? "left" : "right";
        }
        if (newPosition.target.vertical != position.target.vertical || newPosition.target.horizontal != position.target.horizontal) {
            if (newPosition.target.vertical == "center")
                newPosition.stem.vertical = (availSpace.centerTop >= availSpace.tooltipHeight) ? "bottom" : (availSpace.centerBottom >= availSpace.tooltipHeight) ? "top" : (availSpace.centerTop > availSpace.centerBottom) ? "bottom" : "top";
            else
                newPosition.stem.vertical = (newPosition.target.vertical == "top") ? "bottom" : "top";
        }
        return newPosition;
    };
    ejTooltip.prototype._collisionFit = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), isHorizontalCollision = false, isVerticalCollision = false;
        var leftValue = 1, topValue = 1, arrowValue = null;
        var scrollLeft = $(this.model.containment).scrollLeft();
        var scrollTop;
        if (this.model.containment == "body") {
            scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        }
        else {
            scrollTop = $(this.model.containment).scrollTop();
        }
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if (tooltipPos.left < containerLeft || ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft))) {
            leftValue = (tooltipPos.left < containerLeft) ? containerLeft : ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft)) ? (tooltipPos.left - ((tooltipPos.left + tooltipPos.width) - (this.containerSize.width + containerLeft))) : 1;
            isHorizontalCollision = true;
        }
        if (tooltipPos.top < containerTop || ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))) {
            topValue = (tooltipPos.top < containerTop) ? containerTop : ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop)) ? (tooltipPos.top - ((tooltipPos.top + tooltipPos.height) - (this.containerSize.height + containerTop))) : 1;
            isVerticalCollision = true;
        }
        $(this.tooltip).css({
            top: (topValue != 1) ? topValue + "px" : tooltipPos.top + "px",
            left: (leftValue != 1) ? leftValue + "px" : tooltipPos.left + "px",
            position: "absolute"
        });
        this._adjustArrow(position);
        arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: $(this.tip).css("display") };
        this.tooltipPos.top = topValue = (topValue != 1) ? topValue : tooltipPos.top;
        this.tooltipPos.left = leftValue = (leftValue != 1) ? leftValue : tooltipPos.left;
        var tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        if (isHorizontalCollision || isVerticalCollision && (arrowValue.display != "none")) {
            if (this.model.isBalloon) {
                if (isHorizontalCollision)
                    this.arrowValue.left = this._horizontalAdjustment(position, availSpace);
                if (isVerticalCollision)
                    this.arrowValue.top = this._verticalAdjustment(position, availSpace);
            }
            if (this.arrowValue.left == -this.model.tip.size.height || this.arrowValue.left == tooltipWidth) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else if (this.arrowValue.top == -this.model.tip.size.height || this.arrowValue.top == tooltipHeight) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "none" });
            }
        }
        this._shadowEffect(this.model.showShadow, position);
    };
    ejTooltip.prototype._horizontalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowLeft = (position.target.horizontal != "center" && position.stem.horizontal == "left") ? $(this.tip).offset().left : (position.target.horizontal != "center" && position.stem.horizontal == "right") ? $(this.tip).offset().left + arrowSize : $(this.tip).offset().left;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowLeft > availSpace.leftSpace) && ((arrowLeft + arrowSize) < (availSpace.leftSpace + this.targetPos.width)))
            return arrowValue.left;
        else {
            if ((arrowLeft > (availSpace.leftSpace + this.targetPos.width)) || (arrowLeft < availSpace.leftSpace))
                arrowValue.left = (availSpace.leftSpace + this.targetPos.width / 2) - parseInt(this.tooltipPos.left.toString());
            return arrowValue.left;
        }
    };
    ejTooltip.prototype._verticalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: this.arrowValue.display };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowTop = (position.target.horizontal == "center" && position.stem.vertical == "top") ? $(this.tip).offset().top : $(this.tip).offset().top + arrowSize;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowTop > availSpace.topSpace) && (arrowTop < (availSpace.topSpace + this.targetPos.height)))
            return arrowValue.top;
        else {
            if ((arrowTop < availSpace.topSpace) || ((arrowTop + arrowSize) > (availSpace.topSpace + this.targetPos.height)))
                arrowValue.top = (availSpace.topSpace + this.targetPos.height / 2) - parseInt(this.tooltipPos.top.toString());
            return arrowValue.top;
        }
    };
    ejTooltip.prototype._createHeader = function () {
        if (this.model.title != null) {
            if (ej.isNullOrUndefined(this.tooltipTitle))
                this._createTitle();
            if (ej.isNullOrUndefined(this.tooltipContent))
                $(this.tooltipHeader).appendTo(this.tooltipInter).addClass("e-tooltipHeader");
            else
                $(this.tooltipHeader).insertBefore(this.tooltipContent).addClass("e-tooltipHeader");
        }
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
            this._iconRender();
    };
    ejTooltip.prototype._hideTooltip = function () {
        var speed;
        this._isHidden = true;
        speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
        if (this.model.enabled == true && $(this.tooltip).css("display") == 'block') {
            if (this.triggerEvents("beforeClose", {}))
                return;
            (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeOut(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideUp(speed) : $(this.tooltip).css({ display: "none" });
            if ($(this.tooltip).css("display") == 'none')
                $(this.tooltip).attr('aria-hidden', 'true').removeClass("e-customAnimation");
            if (this.triggerEvents("close", {}))
                return;
        }
    };
    ejTooltip.prototype._showTooltip = function () {
        if (this._isHidden) {
            var speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
            this._isHidden = false;
            if ($(this.tooltip).css("display") == 'none' && this.model.enabled == true) {
                (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeIn(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideDown(speed) : $(this.tooltip).css({ display: "block" });
                if ($(this.tooltip).css("display") == 'block') {
                    $(this.tooltip).attr('aria-hidden', 'false').css({ zIndex: ej.getMaxZindex() + 1 });
                    if (this.model.animation.effect == ej.Tooltip.Effect.None)
                        $(this.tooltip).addClass("e-customAnimation");
                    var elements = this._getScrollableParents();
                    this._on(elements, "scroll", this._hideTooltip);
                }
                if (this.triggerEvents("open", {}))
                    return;
            }
        }
    };
    ejTooltip.prototype._getScrollableParents = function () {
        return $(this.element).parentsUntil("html").filter(function () {
            return $(this).css("overflow") != "visible";
        }).add($(window));
    };
    ejTooltip.prototype._tooltipAuto = function () {
        var proxy = this;
        this.timer = setTimeout(function () {
            proxy._hideTooltip();
        }, proxy.model.autoCloseTimeout);
    };
    ejTooltip.prototype._beforeOpenTooltip = function (event) {
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.targetElement = this.element;
        if (!ej.isNullOrUndefined(this.model.target)) {
            if (!ej.isNullOrUndefined($(event.currentTarget).attr('data-content'))) {
                this.model.content = $(event.currentTarget).attr('data-content');
                this._setContent(this.model.content);
            }
        }
    };
    ejTooltip.prototype._targetHover = function (event) {
        this.isTrack = true;
        if (this.model.enabled) {
            if (this._isHidden || ((ej.browserInfo().name == 'msie' || ej.browserInfo().name == 'edge') && this.model.associate == ej.Tooltip.Associate.MouseFollow)) {
                this.tooltip.stop(true, true);
                if (this.triggerEvents("beforeOpen", { event: event })) {
                    this._isCancel = true;
                    return;
                }
                this._isCancel = false;
                this._beforeOpenTooltip(event);
                if (this.model.associate != ej.Tooltip.Associate.MouseEnter && this.model.associate != ej.Tooltip.Associate.MouseFollow) {
                    (!ej.isNullOrUndefined(this.model.target)) ? this._positionElement(event.currentTarget) : this._positionElement(this.element);
                    clearTimeout(this.timer);
                    this._showTooltip();
                    if (this.model.closeMode == ej.Tooltip.CloseMode.Auto)
                        this._tooltipAuto();
                    (event.type == "click") ? this.triggerEvents("click", { event: event }) : this.triggerEvents("hover", { event: event });
                }
                else
                    this.isTrack = true;
            }
            else if (!ej.isNullOrUndefined(this.model.target))
                this._positionElement(event.currentTarget);
        }
    };
    ejTooltip.prototype._onMouseOut = function (event) {
        if (this.model.enabled && !this._isHidden) {
            if (this.model.closeMode == ej.Tooltip.CloseMode.None)
                this._hideTooltip();
            clearTimeout(this.mouseTimer);
        }
        this.isTrack = false;
    };
    ejTooltip.prototype._onTooltipMouseEnter = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None)
                $(proxy.tooltip).css({ display: "block" });
        }
    };
    ejTooltip.prototype._onTooltipMouseLeave = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                if (proxy.model.closeMode == ej.Tooltip.CloseMode.None)
                    $(proxy.tooltip).css({ display: "none" });
            }
        }
    };
    ejTooltip.prototype._docTouchEndHandler = function (e) {
        if (!$(e.target).closest('.e-tooltip').length && this.model.closeMode == ej.Tooltip.CloseMode.None)
            this._hideTooltip();
    };
    ejTooltip.prototype._keyDown = function (event) {
        var code = (event.keyCode) ? event.keyCode : (event.which) ? event.which : event.charCode;
        if (this.model.enabled) {
            switch (code) {
                case 27:
                    event.preventDefault();
                    this._hideTooltip();
                    break;
            }
        }
    };
    return ejTooltip;
}(ej.WidgetBase));
window.ej.widget("ejTooltip", "ej.Tooltip", new ejTooltip());
window["ejTooltip"] = null;
ej.Tooltip.CloseMode = {
    Auto: "auto",
    None: "none",
    Sticky: "sticky"
};
ej.Tooltip.Effect = {
    Slide: "slide",
    Fade: "fade",
    None: "none"
};
ej.Tooltip.Trigger = {
    Hover: "hover",
    Click: "click",
    Focus: "focus"
};
ej.Tooltip.Collision = {
    Flip: "flip",
    FlipFit: "flipfit",
    None: "none",
    Fit: "fit"
};
ej.Tooltip.Associate = {
    Window: "window",
    MouseFollow: "mousefollow",
    MouseEnter: "mouseenter",
    Target: "target",
    Axis: "axis"
};
;
/**
* @fileOverview Plugin to style the Html ListView elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListView", "ej.ListView", {
        _rootCSS: "e-lv",
        validTags:['div'],
        _prefixClass: "e-",
        defaults: {

            fieldSettings: {
                "navigateUrl": "navigateUrl",
                "href": "href",
                "enableAjax": "enableAjax",
                "preventSelection": "preventSelection",
                "persistSelection": "persistSelection",
                "text": "text",
                "enableCheckMark": "enableCheckMark",
                "checked": "checked",
                "primaryKey": "primaryKey",
                "parentPrimaryKey": "parentPrimaryKey",
                "imageClass": "imageClass",
                "imageUrl": "imageUrl",
                "childHeaderTitle": "childHeaderTitle",
                "childId": "childId",
                "childHeaderBackButtonText": "childHeaderBackButtonText",
                "renderTemplate": "renderTemplate",
                "templateId": "templateId",
                "attributes": "attributes",
                "mouseUp": "mouseUp",
                "mouseDown": "mouseDown",
                "groupID": "groupID",
                "id": "id"
            },

            mouseDown: null,

            mouseUp: null,

            items: []

        },



        dataTypes: {
            dataSource: "data",
            query: "data",
            itemRequestCount: "number",
            totalItemsCount: "number",
            fieldSettings: "data",
            renderMode: "enum",
            theme: "enum",
            enablePersistence: "boolean"
        },
        observables: ["selectedItemIndex", "dataSource"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        dataSource: ej.util.valueFunction("dataSource"),
		checkedIndices: ej.util.valueFunction("checkedIndices"),

        _tags: [{
            tag: "items",
            attr:
                ["navigateUrl",
                "href",
                "text",
                "checked",
                "primaryKey",
                "parentPrimaryKey",
                "imageClass",
                "imageUrl",
                "childHeaderTitle",
                "childId",
                "childHeaderBackButtonText",
                "mouseUP",
                "mouseDown",
                "attributes",
                "renderTemplate",
                "templateId",
                "enableAjax",
                "preventSelection",
                "persistSelection",
                "enableCheckMark",
                "attributes"
                ],
            content: "template"
        }
        ],


        _init: function (options) {
            this._options = options;
            this._preventDefaultException = { tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT)$/ };
            this._storedContent = [];
            this._storedTemplate = [];
            this._tempContent = $("body");
            this._touchStart = this.model.mouseDown;
            this._touchEnd = this.model.mouseUp;
            this._oldEle = this.element.clone();
            if (this._oldEle.find("ul").length)
                this.model.items = [];
            this._indexVal = 0;
			this._setCulture();
			this._updateModelItems();
            this._dataUrl = this.model.dataSource;
            this._load();
            var navObj = this.element.closest(".e-nb.e-js");
            this._isInsideNavigation = navObj.length;
            if (this._isInsideNavigation)
                this._nearestND = navObj.ejNavigationDrawer("instance");
            this._responsive();
        },

        _responsive: function () {
			$(window).on("resize", $.proxy(this._resizeHandler, this));
        },

        _resizeHandler: function () {
			if ($(this.element).parent().width() == null && this.model == null) {
				$(this.element).width(this.width);
			}
			else if($(this.element).parent().width()<=this.model.width) {
				this.width = $(this.element).parent().width();
				$(this.element).width(this.width);
			}
			else
				$(this.element).width(this.model.width);
        },

        _itemsObjectCollection: function (element, primaryKey, parentPrimaryKey, groupid) {
            if (ej.getAttrVal(element, "data-ej-rendertemplate")) {
                var tempid = this._tempContent.find('#' + ej.getAttrVal(element, "data-ej-templateid"));
                if (tempid.length) {
                    var ele = tempid.remove();
                    this._storedTemplate[this._indexVal] = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                }
                else if (!this._storedTemplate[this._indexVal])
                    if ($(element)[0].innerHTML)
                        this._storedTemplate[this._indexVal] = $(element)[0].innerHTML;
                    else if (this._storedTemplate[this._indexVal] && this._tempContent.find('#' + template).length) {
                        var ele = this._tempContent.find('#' + template).remove();
                        ele = ele[0].nodeName && ele[0].nodeName.toLowerCase() == "script" ? ej.getClearString(ele[0].innerHTML) : ele[0].outerHTML;
                        this._storedTemplate = ej._pushValue(this._storedTemplate, ele, this._indexVal);
                    }
                this._indexVal++;
            }
          return  this._getLiAttributes(element, primaryKey, parentPrimaryKey, groupid);
        },

        _getLiAttributes: function (element, primaryKey, parentPrimaryKey, groupid) {
            var item = {};
            item.groupID = groupid ? groupid : "",
            item.text = ej.getAttrVal(element, "data-ej-text") ? ej.getAttrVal(element, "data-ej-text") : this._getText(element);
            item.preventSelection = ej.getAttrVal(element, "data-ej-preventselection");
            item.persistSelection = ej.getAttrVal(element, "data-ej-persistselection");
            item.navigateUrl = ej.getAttrVal(element, "data-ej-navigateurl");
            item.href = ej.getAttrVal(element, "data-ej-href");
            item.checked = ej.getAttrVal(element, "data-ej-checked");
            item.primaryKey = ej.getAttrVal(element, "data-ej-primarykey", primaryKey);
            item.parentPrimaryKey = ej.getAttrVal(element, "data-ej-parentprimarykey", parentPrimaryKey);
            item.imageClass = ej.getAttrVal(element, "data-ej-imageclass");
            item.imageUrl = ej.getAttrVal(element, "data-ej-imageurl");
            item.childHeaderTitle = ej.getAttrVal(element, "data-ej-childheadertitle");
            item.childId = item.href ? ej.getAttrVal(element, "data-ej-childid") ? ej.getAttrVal(element, "data-ej-childid") : ("page_" + parseInt(Math.random().toFixed(3) * 1000)) : "";
            item.childHeaderBackButtonText = ej.getAttrVal(element, "data-ej-childheaderbackbuttontext");
            item.mouseUp = ej.getAttrVal(element, "data-ej-mouseUp");
            item.mouseDown = ej.getAttrVal(element, "data-ej-mouseDown");
            if (this.element.find('li').length > 0) item.attributes = (typeof(element)=="object")? element.attrNotStartsWith(/^data-ej-/):$(element).attrNotStartsWith(/^data-ej-/);
            item.renderTemplate = ej.getAttrVal(element, "data-ej-rendertemplate");
            item.templateId = this._storedTemplate[this._indexVal - 1],
            item.enableAjax = ej.getAttrVal(element, "data-ej-enableajax");
            item.enableCheckMark = ej.getAttrVal(element, "data-ej-enablecheckmark");
            return item;
        },



        _renderLists: function () {
            var list = ej.buildTag("li", "", {}, {
                "class": this._prefixClass + "user-select " + this._prefixClass + "list " + this._prefixClass + "state-default{{if " + this.model.fieldSettings['primaryKey'] + " || " + this.model.fieldSettings['enableAjax'] + " || " + this.model.enableAjax + "}} " + this._prefixClass + "arrow{{/if}}{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "margin{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "margin{{/if}}{{/if}}",
                "data-childid": "{{if " + this.model.fieldSettings['primaryKey'] + "}}child{{>" + this.model.fieldSettings['primaryKey'] + "}}{{else " + this.model.fieldSettings['childId'] + "}}{{>" + this.model.fieldSettings['childId'] + "}}{{else}}{{/if}}",
                "data-childheadertitle": "{{>" + this.model.fieldSettings['childHeaderTitle'] + "}}",
                "data-childheaderbackbuttontext": "{{>" + this.model.fieldSettings['childHeaderBackButtonText'] + "}}",
                "data-preventSelection": "{{>" + this.model.fieldSettings['preventSelection'] + "}}",
                "data-persistSelection": "{{>" + this.model.fieldSettings['persistSelection'] + "}}",
                "data-navigateUrl": "{{>" + this.model.fieldSettings['navigateUrl'] + "}}",
                "data-loadajax": "{{>" + this.model.fieldSettings['enableAjax'] + "}}",
                "data-href": '{{>' + this.model.fieldSettings['href'] + '}}{{:~_checkAjaxUrls()}}',
                "data-checked": '{{>' + this.model.fieldSettings['checked'] + '}}',
                "data-templateid": "{{>" + this.model.fieldSettings['renderTemplate'] + "}}",
                "data-mouseup": "{{>" + this.model.fieldSettings['mouseUp'] + "}}",
                "data-mousedown": "{{>" + this.model.fieldSettings['mouseDown'] + "}}",
                "data-id": "{{>" + this.model.fieldSettings['id'] + "}}"
            });
            if (this.model.renderTemplate) {
               if (this._hasDataSource() && this._template){
                    var check = this._createCheckBox();
                    list[0].innerHTML = this._template+"{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}";
            }
            }
            else {
                var linkTag = ej.buildTag("a", "", {}, { "class": this._prefixClass + "chevron-right_01 " + this._prefixClass + "remove-shadow{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "margin{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "margin{{/if}}{{/if}}{{if " + this.model.fieldSettings['primaryKey'] + " || " + this.model.fieldSettings['enableAjax'] + " || " + this.model.enableAjax + "}} " + this._prefixClass + "fontimage e-icon{{/if}}", "href": (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 ? "" : "{{if " + this.model.fieldSettings['navigateUrl'] + " == '' || " + this.model.fieldSettings['navigateUrl'] + " == undefined }}{{else}}{{:" + this.model.fieldSettings['navigateUrl'] + "}}{{/if}}") }); 
                (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) && linkTag.removeAttr('href');
				var span = ej.buildTag("span", "{{>" + this.model.fieldSettings['text'] + "}}", {}, { "class": this._prefixClass + "list-text " + this._prefixClass + "rel " + this._prefixClass + "user-select{{if " + this.model.fieldSettings['imageClass'] + "}} " + this._prefixClass + "text{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}} " + this._prefixClass + "text{{/if}}{{/if}}" });
                var imgClass = ej.buildTag("div", "", {}, { 'class': this._prefixClass + "list-img " + this._prefixClass + "rel " + this._prefixClass + "user-select {{>" + this.model.fieldSettings['imageClass'] + "}}" });
                var check = this._createCheckBox();
                if (this.model.renderMode == "windows" && ej.isMobile())
                    linkTag[0].innerHTML = "{{if !" + this.model.fieldSettings['primaryKey'] + "}}{{if " + this.model.fieldSettings['enableAjax'] + " == undefined || " + this.model.fieldSettings['enableAjax'] + ".toString() == 'false'}}{{if !" + this.model.fieldSettings['navigateUrl'] + "}}{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}{{/if}}{{/if}}{{/if}}" + "{{if " + this.model.fieldSettings['imageClass'] + "}}" + imgClass[0].outerHTML + "{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}}{{:~_checkImgUrls()}}{{/if}}{{/if}}" + span[0].outerHTML;
                else
                    linkTag[0].innerHTML = "{{if " + this.model.fieldSettings['imageClass'] + "}}" + imgClass[0].outerHTML + "{{else}}{{if " + this.model.fieldSettings['imageUrl'] + "}}{{:~_checkImgUrls()}}{{/if}}{{/if}}" + span[0].outerHTML + "{{if !" + this.model.fieldSettings['primaryKey'] + "}}{{if " + this.model.fieldSettings['enableAjax'] + " == undefined || " + this.model.fieldSettings['enableAjax'] + ".toString() == 'false'}}{{if !" + this.model.fieldSettings['navigateUrl'] + "}}{{if " + this.model.fieldSettings['enableCheckMark'] + " !== undefined}}{{if " + this.model.fieldSettings['enableCheckMark'] + ".toString() == 'false' ? " + this.model.fieldSettings['enableCheckMark'] + " : " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{else}}{{if " + this.model.enableCheckMark + "}}" + check[0].outerHTML + "{{/if}}{{/if}}{{/if}}{{/if}}{{/if}}";

                list[0].innerHTML = "{{if " + this.model.fieldSettings['renderTemplate'] + " == undefined || " + this.model.fieldSettings['renderTemplate'] + ".toString() == 'false'}}" + linkTag[0].outerHTML + "{{else}}{{:templateId}}{{/if}}";
            }
            if (this.model.renderMode == "ios7") {
                var innerDiv = ej.buildTag("div." + this._prefixClass + "list-div");
                innerDiv[0].innerHTML = list[0].innerHTML;
                list.empty().append(innerDiv);
            }
            return list;
        },


        _updateContent: function (currentItem, backButton) {
            var proxy = this;
            var $curIte = $(currentItem), childid = $curIte.attr('data-childid');
            var id = this._isInsideNavigation && currentItem.attr('data-href') ? $('body').find($("#" + childid)) : this.element.find($("#" + childid));
            if (id.length) {
                var hdr = this.element.find('#' + childid + '_header');
                if (this.model.enableFiltering)
                    this._initializeFiltering($(id));
                var title = $curIte.attr('data-childheadertitle') == undefined ? currentItem.text() : $curIte.attr('data-childheadertitle');
                if (hdr.hasClass('e-header')) {
                    this._setHeaderVal(childid, title, backButton);
                }
                id.attr("data-hdr-title", title).attr("data-hdr-bckbtn", backButton);
                this._initEJCheckBox(id);
                if (this._isInsideNavigation && currentItem.attr('data-href') && this._nearestND.model.contentId) {
                    if ($('body').find('.e-lv.subpage.e-childitem')) {
                        $("#" + this._nearestND.model.contentId).empty().append(id.show());
                    }
                }
                else {
                    $curIte.closest('.subpage').hide();
                    id.show();
					this._childContainer = id.find('.' + this._prefixClass + 'list-container');
					this._childContainer.ejScroller({
                        height: this._childContainer.height(),
                        width: 0,
                        scrollerSize: 20
                    });
			        this.scrollerObj = this._childContainer.ejScroller("instance");
					this._containerHeight = this.element.height() - ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'lv-inputdiv'), 'outerHeight')-ej.getDimension(this._lbEle.find('.' + this._prefixClass + 'header'), 'outerHeight');
					if (this.model.height !== null) {
				        if (this._childContainer.height() > this._containerHeight) {
			                this._refreshScroller(this._childContainer,true);
					    }
				    }
				    if (this.scrollerObj) {
						this.scrollerObj.refresh();
						$(this.scrollerObj.element).find(".e-vhandlespace").css("height",($(this.scrollerObj.element).find(".e-vhandlespace").height() - 1));
					}
                    $(this.element.children()[0]).removeClass("e-slideright");
                    id.addClass("e-slideleft");
                }
            }
        },



        _renderHeader: function (id, showbutton, title, backtext) {
            var header = ej.buildTag("div", "", {}, { "id": id + "_header", "class": "e-header e-box" });
            if (showbutton) {
                header.append("<span class='e-hicon e-icon e-chevron-left_01'></span>");
                header.append("<div class='e-btn-text'>" + (backtext ? backtext : "Back") + "</div>");
            }
            else
                header.append("<div class='e-htitle'>" + title + "</div>");
            return header;
        },
        _setHeaderVal: function (id, title, backtext) {
            this._onBackButtonDelegate = $.proxy(this._onBackButtonClick, this);
            ej.listenTouchEvent($("#" + id + "_header"), ej.endEvent(), this._onBackButtonDelegate, false, this);
            var backButtonText = this.model.showHeaderBackButton ? this.model.headerBackButtonText ? this.model.headerBackButtonText : backtext : backtext;
            $("#" + id + "_header").find(".e-btn-text").text(backtext ? backButtonText : "Back");
            $("#" + id + "_header").find(".e-htitle").text(title);
        },
        _onBackButtonClick: function (e) {
            this.element.find(".e-slideleft").removeClass("e-slideleft");
            this.element.children(":visible").hide();
            $(this.element.children()[0]).show();
            $(this.element.children()[0]).addClass("e-slideright");
            if (this.model.enableFiltering)
            this._initializeFiltering($(this.element.children()[0]));
     },


        _returnData: function () {
            var checkedItem = this._currentItem.closest('ul.e-list-hdr').find('.e-chkbox-wrap[aria-checked="true"]').closest("li");
            var elementId = ej.getAttrVal(this._currentItem, "data-id", this._currentItem.text());
            var items = this.dataSource().length ? typeof this.dataSource() == "string" ? eval(this.dataSource()) : this.dataSource() : this.model.items;
            return {
                hasChild: this._currentItem.attr("data-childid") && this._currentItem.attr('data-childid').length > 0 ? (this.element.find('#' + this._currentItem.attr('data-childid')).length ? true : false) : false,
                item: this._currentItem,
                text: this._currentItem.text(),
                index: this._currentItem.index(),
                isChecked: this._currentItem.find("input.e-lv-check").closest('.e-chkbox-wrap').attr('aria-checked') == "true" ? true : false,
                checkedItems: checkedItem.length ? checkedItem : null,
                checkedItemsText: $(checkedItem).map(function () { return $(this).text(); }).get(),
                itemData: this._generateData(items, elementId),
                checkedValues: this.checkedIndices()  
            };
        },
        _initEJCheckBox: function (ul) {
            var liItems = ul.find("li");
            var count = liItems.length;
            for (i = 0; i < count; i++) {
                if (this.model.enablePersistence || this.model.checkedIndices.length > 0 ) {   
                    var localItems = this.model.checkedIndices;
                    var checked = this._hasValue(localItems, i);
                }
                else {
                    var checked = ej.getAttrVal($(liItems[i]), "data-checked");
                    var checked = checked == "true" ? true : false;
                }
                $($(liItems[i]).find(".e-lv-check")).ejCheckBox({ checked: checked });
            }
            ul.find('.e-lv-checkdiv').removeClass("e-lv-checkdiv")
            ul.find('.e-lv-check').parent().addClass("e-lv-checkdiv")
        },
        _triggerStartEvent: function (data) {
			if (ej.browserInfo().name == "msie" && ej.browserInfo().version == 8)
				this.model.mouseDown = this._touchStart;
            else this.model.mouseDown = ej.getAttrVal(this._currentItem, 'data-mousedown', this._touchStart);
                this._trigger("mouseDown", data);
        },

        _triggerEndEvent: function (data, evt) {
			if (ej.browserInfo().name == "msie" && ej.browserInfo().version == 8)
				this.model.mouseUp = this._touchEnd;
            else this.model.mouseUp = ej.getAttrVal(this._currentItem, 'data-mouseup', this._touchEnd);
            this.selectedItemIndex(this._currentItem.index());
            if (this.model.enablePersistence || this.model.enableCheckMark) {
                var state = this._currentItem.find('.e-chkbox-wrap'), index = this._currentItem.index();
                if (state.attr('aria-checked') == 'true' || (index||$(evt.target).parent().hasClass('e-chk-inact'))) {
                    if (!this._hasValue(this._checkedValues, index))
                        this._checkedValues.push(index);
                    else
                        this._checkedValues.splice(this._checkedValues.indexOf(index), 1);
                }
                else
                    this._checkedValues.splice(this._checkedValues.indexOf(index), 1);
            }
            this.checkedIndices(this._checkedValues);
            if (this.model.mouseUp)
                this._trigger("mouseUp", data);
        },
        _createFilterDiv: function () {
            return ej.buildTag('div.e-lv-filter', ej.buildTag('input.e-lv-input', "", {}, { 'type': 'text', 'placeholder': 'search' }));
        },
        _emptyFilterTextValue: function (element) {
            element.find('.e-lv-input').val("");
        },
        _createListDiv: function (childId) {
            this._div = ej.buildTag("div#" + childId + "." + this._rootCSS + " subpage e-childitem e-ajaxchild", (this.model.showHeader && this._isInsideNavigation && !this._nearestND.model.contentId) ? this._renderHeader(childId, true, this._currentItem.text()) : "");
        },
        _createCheckBox: function () {
            return ej.buildTag("input.e-lv-check", "", {}, { "type": "checkbox", });
        },
        _toggleCheckboxValue: function (lbCheck) {
            lbCheck.ejCheckBox({ checked: $(lbCheck.closest('.e-chkbox-wrap')).attr('aria-checked') == "true" ? false : true });
        },
        _setCheckboxValue: function (element, val) {
            element.ejCheckBox({ checked: val });
        },
        _convertToRelativeUrl: function (url) {
            return url;
        },
		_setCulture: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.headerTitle)) this._localizedLabels.headerTitle = this._options.headerTitle;
                if (!ej.isNullOrUndefined(this._options.headerBackButtonText)) this._localizedLabels.headerBackButtonText = this._options.headerBackButtonText;
            }
            this.model.headerTitle = this._localizedLabels.headerTitle;
            this.model.headerBackButtonText = this._localizedLabels.headerBackButtonText;
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
		
    });
	 ej.ListView.Locale = ej.ListView.Locale || {};
        ej.ListView.Locale["default"] = ej.ListView.Locale["en-US"] = {
            headerTitle: "Title",
            headerBackButtonText: "",
        };
    $.extend(true, ej.ListView.prototype, ej.ListViewBase.prototype);
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Navigation Drawer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejNavigationDrawer", "ej.NavigationDrawer", {

        _setFirst: true,
        validTags: ["div"],
        _rootCSS: "e-nb",
        _prefixClass: "e-",

        defaults: {
            isPaneOpen: false
        },

        dataTypes: {
            isPaneOpen: "boolean"
        },

        _init: function () {
            this._load();
            this._renderControl();
            this._renderEJMControls();
            this._createDelegate();
            this._wireEvents();
        },

        _load: function () {
            this._browser = this._getBrowserAgent();
            if (this.model.position == "normal") {
                if (!this.model.isPaneOpen) {
                    this._elementWrapper = ej.buildTag("div#" + this._id + "_WrapContainer", {}, {}, { "class": this._rootCSS + " e-nb-container e-nb-" + this.model.direction.toLowerCase() });
                    this.element.wrapAll(this._elementWrapper);
                    this._nbHome = $("#" + this._id + "_WrapContainer").parent();
                }
                else {
                    this.element.siblings().wrapAll("<div id='" + this._id + "_PageContainer' class='e-nb-container e-nb-pageContainer'></div>")
                    this._pageContainer = this._nbHome = this.element.siblings();
                }
            }
            else {
                this._nbHome = $("body");
                this.element.appendTo(this._nbHome);
            }
            this._nbHomeCss = this._nbHome.clone(true)[0].style;
        },

        _renderEJMControls: function () {
            if (this.model.enableListView) {
                this._lb = ej.buildTag("div#" + this._id + "_listview", {}, {}, { "class": "e-nb-listview" });
                if (this.model.items.length || this.model.listViewSettings.dataSource.length)
                    this._lb.appendTo(this.element);
                else
                    this.element.find(">ul").wrapAll(this._lb);
                this._lb = $("#" + this._id + "_listview");
                if (!this.model.listViewSettings["width"])
                    this.model.listViewSettings["width"] = 240;
                this.model.listViewSettings.items = this.model.items;
                this._lb.ejListView($.extend({}, this.model.listViewSettings, { loadComplete: $.proxy(this._setLayout, this) }));
                this._lbObj = this._lb.data("ejListView"); 
                this._lb.ejListView("selectItem", this.model.listViewSettings.selectedItemIndex);
            }
			else
				this.element.find(".e-nb-listview").empty();
        },

        _setModel: function (options) {
            var refresh = false;
            for (var prop in options) {
                switch (prop) {
                    case "width":
                        this._setWidth();
                        this._setLayout();
                        break;
                    case "direction":
                        this._setLayout();
                        break;
                    case "type":
                        this._transform(0, 0, true);
                        this._transform(0, 0, false);
                        break;
                    case "isPaneOpen":
                        this.model[prop] = options[prop];
						this.element.hide();
						if(options[prop]) {
							$(this._elementWrapper,this._elementShadow,this._elementOverlay).remove();
							this.element.removeAttr("style").height("100%");
							this.element.unwrap();
						}
						else{
							this._pageContainer.children().unwrap();
							this._pageContainer.remove();
						}
						this._load();
						this._shadowWrapper();
						if (this.model.enableListView) this._renderEJMControls();
						this._wireEvents();
						break;
					case "enableListView":
					    this._renderEJMControls();
						break;
                    default:
                        refresh = true;
                }
                if (refresh) { this._refresh(); }
            }
        },

        _destroyEJMPlugin: function () {
            if (this._lb) {
                this._lb.ejListView("destroy");
                this._lb.children().unwrap();
            }
            if (this.model.contentId) $("#" + this.model.contentId).empty();
			if (this._id) $("#"+this._id).hide();
        },

        _getBrowserAgent: function () {
            return (/webkit/i).test(navigator.appVersion) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : (/trident/i).test(navigator.userAgent) ? 'ms' : 'opera' in window ? 'O' : '';
        }

    });
    $.extend(true, ej.NavigationDrawer.prototype, ej.NavigationDrawerBase.prototype);
    $.extend(true, ej.NavigationDrawer.prototype.defaults.listViewSettings, ej.ListView.prototype.defaults);
    ej.NavigationDrawer.prototype._tags = ej.ListView.prototype._tags;

})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html UL elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejListBox", "ej.ListBox", {

        element: null,
        _ignoreOnPersist: ["dataSource", "query", "itemRequestCount", "fields", "create", "change", "select", "unselect", "itemDragStart", "itemDrag", "itemDragStop", "itemDrop", "checkChange", "destroy", "actionComplete", "actionFailure", "actionSuccess", "actionBegin", "itemDropped", "selected"],
        model: null,
        validTags: ["ul"],
        _setFirst: false,
        _rootCSS: "e-listbox",
        defaults: {
            itemsCount: null,
            totalItemsCount: null,
            dataSource: null,
            query: ej.Query(),
            itemRequestCount: 5,
            itemHeight:null,
            fields: {
                id: null,
                text: null,
                imageUrl: null,
                imageAttributes: null,
                spriteCssClass: null,
                htmlAttributes: null,
                tooltipText: null,
                selectBy: null,
                checkBy: null,
                groupBy: null,
                tableName: null,

                //deprecated field properties
                selected: null,
                category: null,
                toolTipText: null
            },
            height: "auto",
            width: "200",
            template: null,
            text: "",
            selectedIndex: null,
            checkedIndices: [],
            selectedIndices: [],
            cascadeTo: null,
            value: "",
            cssClass: "",
            targetID: null,
            htmlAttributes: {},
            showRoundedCorner: false,
            enableRTL: false,
            enabled: true,
            showCheckbox: false,
            allowVirtualScrolling: false,
            virtualScrollMode: "normal",
            enablePersistence: false,
            allowMultiSelection: false,
            allowDrag: false,
            allowDrop: false,
            enableIncrementalSearch: false,
            enableWordWrap:true,
            caseSensitiveSearch: false,
            loadDataOnInit: true,
            create: null,
            change: null,
            select: null,
            unselect: null,
            itemDragStart: null,
            itemDrag: null,
            itemDragStop: null,
            itemDrop: null,
            checkChange: null,
            destroy: null,
            actionComplete: null,
            actionSuccess: null,
            actionBeforeSuccess:null,
            focusIn:null,
            focusOut:null,
            actionFailure: null,
            actionBegin: null,
			cascade: null,
            sortOrder: "none",

            //Deprecated Members
            enableVirtualScrolling: false,
            checkAll: false,
            uncheckAll: false,
            enableLoadOnDemand: false,
            itemRequest: null,
            allowDragAndDrop: undefined,
            selectedItemIndex: null,
            enableItemsByIndex: null,
            checkItemsByIndex: null,
            disableItemsByIndex: null,
            uncheckItemsByIndex: null,
            itemDropped: null,
            selected: null,
            selectIndexChanged: null,
            selectedItems: [],
            checkedItems: [],
            checkedItemlist: [],
            selectedItemlist: [],
        },
        dataTypes: {
            cssClass: "string",
            itemsCount: "number",
            itemRequestCount: "number",
            allowDrag: "boolean",
            allowDrop: "boolean",
            enableWordWrap:"boolean",
            enableIncrementalSearch: "boolean",
            caseSensitiveSearch: "boolean",
            template: "string",
            targetID: "string",
            cascadeTo: "string",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            enabled: "boolean",
            allowMultiSelection: "boolean",
            dataSource: "data",
            query: "data",
            checkedIndices: "data",
            selectedIndices: "data",
            htmlAttributes: "data",
            loadDataOnInit: "boolean",
            showCheckbox: "boolean",
            sortOrder: "enum"
        },
        observables: ["value", "dataSource"],
        value: ej.util.valueFunction("value"),
        dataSource: ej.util.valueFunction("dataSource"),
        enable: function () {
            if (this.listContainer.hasClass("e-disable")) {
                this.target.disabled = false;
                this.model.enabled = this.model.enabled = true;
                this.element.removeAttr("disabled");
                this.listContainer.removeClass('e-disable');
                if (this.model.allowMultiSelection) this.listContainer.removeClass("e-disable");
                var scroller = this.listContainer.find(".e-vscrollbar,.e-hscrollbar");
                if (this.model.showCheckbox) { 
                    var items = this.listContainer.find('li:not(.e-disable)');
                    items.find(".listcheckbox").ejCheckBox("enable");
                }
                if (scroller.length > 0)
                    this.scrollerObj.enable();
            }
        },
        disable: function () {
            if (!this.listContainer.hasClass("e-disable")) {
                this.target.disabled = true;
                this.model.enabled = this.model.enabled = false;
                this.element.attr("disabled", "disabled");
                this.listContainer.addClass('e-disable');
                if (this.model.allowMultiSelection) this.listContainer.addClass("e-disable");
                var scroller = this.listContainer.find(".e-vscrollbar,.e-hscrollbar");
                if (this.model.showCheckbox) this.element.find(".listcheckbox").ejCheckBox("disable");
                if (scroller.length > 0)
                    this.scrollerObj.disable();
            }
        },
        selectItemByIndex: function (index) {            
            var prevSelectedItem = this.model.selectedIndex, listitems= (this.listitems)?this.listitems:this.listitem;
			if(index!=0) index=parseInt(index);       
            if (index != null) {				
                if ((index > this.element.find("li:not('.e-ghead')").length) || (index < 0) || ((1 / index) == -Infinity))
					 index=this.model.selectedIndex;                    				
                var activeitem = $(this.element.find("li:not('.e-ghead')")[index]);
                if (!activeitem.hasClass("e-select")) {
                    this._activeItem = index;
                    this.element.children("li").removeClass("e-select");
                    this._selectedItems = [];
                    this.model.selectedIndices = [];
                    activeitem.addClass("e-select");
                    if (this.model.showCheckbox) {
                        if (!($(activeitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                            $(activeitem).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                            activeitem.removeClass("e-select");
                            if (!($.inArray(this._activeItem, this._checkedItems) > -1)) this._checkedItems.push(this._activeItem);
                            if (!($.inArray(activeitem[0], this.model.checkedIndices) > -1)) this.model.checkedIndices.push(this._activeItem);
                        }
                    }
                    this._selectedItems.push(activeitem);
                    this.model.selectedIndices.push(index);
                    var selectData = this._getItemObject(activeitem, null);
                    selectData["isInteraction"] = false;
                    if (this.model.select)
                        this._trigger('select', selectData);
                }
            }
            if (this.model.cascadeTo) {
                this._activeItem = index;
                this._cascadeAction();
            }
            this._setSelectionValues()._onlistselection(prevSelectedItem, this._activeItem);;
        },
        checkItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.checkItemsByIndices(index.toString());
        },
        uncheckItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.uncheckItemsByIndices(index.toString());
        },
        checkItemsByIndices: function (index) {
            if ((ej.isNullOrUndefined(index))) return false;
            var checkitems = index.toString().split(',');
            if (checkitems.length > 0) {
                for (var i = 0; i < checkitems.length; i++) {
                    if (checkitems[i] != null) {
                        this._activeItem = parseInt(checkitems[i]);
                        if (this._activeItem < 0) this._activeItem = 0;
                        var activeitem = $(this.element.children("li:not('.e-ghead')")[this._activeItem]);
                        if (this.model.showCheckbox) {
                            if (!($(activeitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                                $(activeitem).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                                this.checkedStatus = true;
                                if (!($.inArray(this._activeItem, this._checkedItems) > -1)) this._checkedItems.push(this._activeItem);
                                if (!($.inArray(activeitem[0], this.model.checkedIndices) > -1)) this.model.checkedIndices.push(this._activeItem);
                                var checkData = this._getItemObject(activeitem, null);
                                checkData["isInteraction"] = false;
                                if (this.model.checkChange)
                                    this._trigger('checkChange', checkData);
                            }
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        uncheckItemsByIndices: function (value) {
            if ((ej.isNullOrUndefined(value))) return false;
            var checkitems = value.toString().split(',');
            if (checkitems.length > 0) {
                for (var i = 0; i < checkitems.length; i++) {
                    if (checkitems[i] != null) {
                        var index = parseInt(checkitems[i]);
                        var unselectitem = $(this.element.children("li:not('.e-ghead')")[parseInt(index)]);
                        if (this.model.showCheckbox) {
                            if (($(unselectitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                                $(unselectitem).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                                this.checkedStatus = false;
                                var itemIndex = $.inArray(index, this.model.checkedIndices);
                                if ($.inArray(index, this._checkedItems) > -1) this._checkedItems.splice(itemIndex, 1);
                                if (itemIndex > -1) this.model.checkedIndices.splice(itemIndex, 1);
                                var unselectData = this._getItemObject(unselectitem, null);
                                unselectData["isInteraction"] = false;
                                if (this.model.checkChange)
                                    this._trigger('checkChange', unselectData);
                            }
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        selectAll: function () {
            if (!this.model.showCheckbox && this.model.allowMultiSelection) {
                var activeItem = this.element.children("li:not('.e-ghead')");
                for (var i = 0; i < activeItem.length; i++) {
                    if (!$(activeItem[i]).hasClass("e-select") && !$(activeItem[i]).hasClass("e-disable")) {
                        $(activeItem[i]).addClass("e-select");
                        this._selectedItems.push($(activeItem[i]));
                        this.model.selectedIndices.push(i);
                        var selectData = this._getItemObject(activeItem, null);
                        selectData["isInteraction"] = false;
                        if (this.model.select)
                            this._trigger('select', selectData);
                    }
                }
            }
            this._setSelectionValues();
        },
        //Deprecated Method
        unSelectAll: function () { this.unselectAll(); },
        unselectAll: function () {
            if (!this.model.showCheckbox)
                this._removeListHover();
            this._setSelectionValues();
            return this;
        },
        //deprecated function
        selectItemsByIndex: function (value) {
            this.selectItemsByIndices(value);
        },
        selectItemsByIndices: function (value) {
            if (ej.isNullOrUndefined(value)) return false;
            var selectitems = value.toString().split(',');
            if (this.model.allowMultiSelection) {
                for (var i = 0; i < selectitems.length; i++) {
                    if (selectitems[i] != null && !isNaN(parseInt(selectitems[i])) && selectitems[i] < this.element.children('li').length) {
                        var index = parseInt(selectitems[i]);
                        this._activeItem = index;
                        var activeitem = $(this.element.children("li:not('.e-ghead')")[this._activeItem]);
                        if (!activeitem.hasClass("e-select")) {
                            activeitem.addClass("e-select");
                            this._selectedItems.push(activeitem);
                            this.model.selectedIndices.push(index);
                            if (this.model.showCheckbox) {
                                if (!($(activeitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                                    $(activeitem).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                                    activeitem.removeClass("e-select");
                                    if (!($.inArray(this._activeItem, this._checkedItems) > -1)) this._checkedItems.push(this._activeItem);
                                    if (!($.inArray(activeitem[0], this.model.checkedIndices) > -1)) this.model.checkedIndices.push(this._activeItem);
                                }
                            }
                            var selectData = this._getItemObject(activeitem, null);
                            selectData["isInteraction"] = false;
                            if (this.model.select)
                                this._trigger('select', selectData);
                        }
                    }
                }
            }
            this._setSelectionValues();
        },
        //deprecated property
        unselectItemsByIndex: function (value) {
            this.unselectItemsByIndices(value);
        },
        unselectItemsByIndices: function (value) {
            var selectitems = value.toString().split(',');
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems[i] != null) {
                    var index = parseInt(selectitems[i]);
                    var activeitem = $(this.listItemsElement[index]);
                    this._activeItem = index;
                    activeitem.removeClass('e-active e-select');
                    if (this.model.showCheckbox) {
                        if (($(activeitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                            $(activeitem).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                            var itemIndex = $.inArray(index, this.model.checkedIndices);
                            if ($.inArray(index, this._checkedItems) > -1) this._checkedItems.splice(itemIndex, 1);
                            if (itemIndex > -1) this.model.checkedIndices.splice(itemIndex, 1);
                        }
                    }
                    if (this.model.selectedIndex == index) this.model.selectedIndex = this._activeItem = null;
                    var itemIndex = this._selectedItems.indexOf(activeitem[0]);
                    this._selectedItems.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                    this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(itemIndex), 1);

                    var unselectData = this._getItemObject(activeitem, null);
                    unselectData["isInteraction"] = false;
                    if (this.model.unselect)
                        this._trigger('unselect', unselectData);
                }
            }
            this._setSelectionValues();
        },
        unselectItemByIndex: function (index) {
            index = parseInt(index);
            var unselectitem = $(this.element.children("li:not('.e-ghead')")[index]);
            if (this.model.showCheckbox) {
                if (($(unselectitem).find('.listcheckbox').ejCheckBox('isChecked'))) {
                    $(unselectitem).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                    var itemIndex = $.inArray(index, this.model.checkedIndices);
                    if ($.inArray(index, this._checkedItems) > -1) this._checkedItems.splice(itemIndex, 1);
                    if (itemIndex > -1) this.model.checkedIndices.splice(itemIndex, 1);
                }
            }
            if (unselectitem.hasClass('e-select')) {
                unselectitem.removeClass('e-active e-select');
                if (this.model.selectedIndex == index) this.model.selectedIndex = this._activeItem = null;
                var itemIndex = this._selectedItems.indexOf(unselectitem[0]);
                this._selectedItems.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(itemIndex), 1);
                var unselectData = this._getItemObject(unselectitem, null);
                unselectData["isInteraction"] = false;
                if (this.model.unselect)
                    this._trigger('unselect', unselectData);
            }
            this._setSelectionValues();
        },
        selectItemByText: function (text) {
            if (!ej.isNullOrUndefined(text))
            this[(this.model.allowMultiSelection ? "selectItemsByIndices" : "selectItemByIndex")](this.getIndexByText(text));
        },
        selectItemByValue: function (value) {
            this[(this.model.allowMultiSelection ? "selectItemsByIndices" : "selectItemByIndex")](this.getIndexByValue(value));
        },
        unselectItemByText: function (text) {
            this[(this.model.allowMultiSelection ? "unselectItemsByIndices" : "unselectItemByIndex")](this.getIndexByText(text));
        },
        unselectItemByValue: function (value) {
            this[(this.model.allowMultiSelection ? "unselectItemsByIndices" : "unselectItemByIndex")](this.getIndexByValue(value));
        },
        getSelectedItems: function () {
            var items = [], proxy = this;
            $(proxy.model.selectedIndices).each(function (index, elementIndex) {
                items.push(proxy.getItemByIndex(elementIndex));
            });
            return items;
        },
        getCheckedItems: function () {
            var items = [], proxy = this;
            $(proxy.model.checkedIndices).each(function (index, elementIndex) {
                items.push(proxy.getItemByIndex(elementIndex));
            });
            return items;
        },
        removeItem: function () {
            return this.removeSelectedItems();
        },
        removeItemByText: function (text) {
            if (ej.isNullOrUndefined(this.getItemByText(text))) return false;
            return this.removeItemByIndex(this.getItemByText(text).index);
        },
        hideSelectedItems: function () {
            var items = this.getSelectedItems();
            this._hideOrShowItemsByIndex(items, "hide");
        },
        hideCheckedItems: function () {
            var items = this.getCheckedItems();
            this._hideOrShowItemsByIndex(items, "hide");
        },
        _hideOrShowItemsByIndex: function (items, hideOrShow) {
            if ($.type(items) == "number") {
                if (hideOrShow == "hide") {
                    $(this.listItemsElement[items]).hide();
                    if ($(this.listItemsElement[items]).next().hasClass('e-ghead'))
                        $(this.listItemsElement[items]).prev().hide();
                }
                else {
                    $(this.listItemsElement[items]).show();
                    if ($(this.listItemsElement[items]).prev().hasClass('e-ghead'))
                        $(this.listItemsElement[items]).prev().show();
                }
            }
            else {
                for (var litem = 0; litem < items.length; litem++) {
                    if (hideOrShow == "hide")
                        items[litem].item ? items[litem].item.hide() : $(this.listItemsElement[items[litem]]).hide();
                    else
                        items[litem].item ? items[litem].item.show() : $(this.listItemsElement[items[litem]]).show();
                }
            }
            this._refreshScroller();
        },
        showItemsByIndices: function (items) {
            this._hideOrShowItemsByIndex(items, "show");
        },
        hideItemsByIndices: function (items) {
            this._hideOrShowItemsByIndex(items, "hide");
        },
        _hideOrShowItemsByValue: function (values, hideOrShow) {
            if ($.type(values) == "array") {
				for(var i=0;i < this.listItemsElement.length;i++){
					 for (var length = 0; length <= values.length; length++) {
                        if ($(this.listItemsElement[i]).attr("value") == values[length])
                            (hideOrShow == "hide") ? $(this.listItemsElement[i]).hide() : $(this.listItemsElement[i]).show();
                    }			
			 }                
            }
            else {
                for(var i=0;i < this.listItemsElement.length;i++){
                    if ($(this.listItemsElement[i]).attr("value") == values)
                        (hideOrShow == "hide") ? $(this.listItemsElement[i]).hide() :$(this.listItemsElement[i]).show();
                }
            }
            this._refreshScroller();
        },
        showItemsByValues: function (value) {
            this._hideOrShowItemsByValue(value, "show");
        },
        hideItemsByValues: function (value) {
            this._hideOrShowItemsByValue(value, "hide");
        },
        showItemByValue: function (value) {
            this._hideOrShowItemsByValue(value, "show");
        },
        hideItemByValue: function (value) {
            this._hideOrShowItemsByValue(value, "hide");
        },
        showItemByIndex: function (item) {
            this._hideOrShowItemsByIndex(item, "show");
        },
        hideItemByIndex: function (item) {
            this._hideOrShowItemsByIndex(item, "hide");
        },
        hide: function () {
            this.listContainer.hide();
        },
        show: function () {
            this.listContainer.show()
        },
        hideAllItems: function () {
            this.element.find("li:visible").hide()
            this._refreshScroller();
        },
        showAllItems: function () {
            this.element.find("li:hidden").show()
            this._refreshScroller();
        },
        _stateMaintained: function (index) {
            var lenth, len, value, j;
            this.model.disableItemsByIndex = [];
            this.model.selectedIndices = [];
            this.model.checkedIndices = [];
            if (this.model.selectedIndex >= index && this.model.selectedIndex != null) {
                if (this.model.selectedIndex == index || $(this.element.children()[index - 1]).hasClass('e-disable'))
                    this.model.selectedIndex = null;
                else if (this.model.selectedIndex != index)
                    this.model.selectedIndex -= 1;
            }
            len = $(index).length;
            if (len > 1) {
                for (i = len; i >= 0; i--)
                    $(this.element.children()[index[i]]).remove();
                lenth = this.element.children().length;
                for (j = 0; j < lenth; j++)
                    if ($(this.element.children()[j]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(j);
            }
            else {
                value = index - 1;
                for (value; value >= 0; value--) {
                    if ($(this.element.children()[value]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(value);
                    if ($(this.element.children()[value]).hasClass('e-select'))
                        this.model.selectedIndices.push(value);
                    if ($(this.element.children()[value]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(value);
                }
                index = parseInt(index) + 1;
                for (index; index < this._listSize; index++) {
                    if ($(this.element.children()[index]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(index - 1);
                    if ($(this.element.children()[index]).hasClass('e-select'))
                        this.model.selectedIndices.push(index - 1);
                    if ($(this.element.children()[index]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(index - 1);
                }
            }
        },
        removeAll: function () {
            if (ej.isNullOrUndefined(this.dataSource())) {
                var text = [], lbItems = this.element.find("li");
                $(lbItems).each(function (i, e) {
                    text.push($(this).text());
                    e.remove();
                });
                this._refreshItems();
                return text;
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                var elements = [], count = $(this.listItemsElement).length;
                for (var i = 0; i < count; i++) {
                    elements.push(this._getRemovedItems([parseInt(0)]));
                }
                return elements;
            }
        },
        removeItemByIndex: function (index) {
            var text, selectItem = this.model.selectedIndex,removedElem=this.element.find("li:not('.e-ghead')");
            if (ej.isNullOrUndefined(this.dataSource())) {
                text = $(removedElem[index]).remove().text();
                this._stateMaintained(index);
                this._refreshItems();
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) text = this._getRemovedItems([parseInt(index)]);
            this.model.selectedIndex = (index == selectItem) ? null : index < selectItem ? selectItem - 1 : selectItem;
            return text;
        },
        removeSelectedItems: function () {
            if (this.model.showCheckbox) return false;
            if (ej.isNullOrUndefined(this.dataSource())) {
                var text = this.value();
                $(this.getSelectedItems()).each(function (i, e) {
                    e.item.remove()
                });
                this._refreshItems();
                return text;
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                this.model.selectedIndex = null;
                return this._getRemovedItems(this.model.selectedIndices);
            }
        },
        _getRemovedItems: function (index) {
            var removedItems = [];
            this._stateMaintained(index);
            this.value(null);
            this._activeItem = null;
            this.dataSource(this.dataSource().filter(function (e, i) {
                if (index.indexOf(i) != -1)
                    removedItems.push(e);
                else
                    return true;
            }));
            this.refresh(true);
            return removedItems;
        },
        getIndexByValue: function (value) {
            var index;
			for(var i=0;i < this.listItemsElement.length;i++){
				if($(this.listItemsElement[i]).attr("value") == value){
					index=i;
                    break;					
				}             
			}                     
			return index;
        },
        getIndexByText: function (text) {
            var index;
            if (this.model.allowMultiSelection) {
                var text = text.split(",");
                index = [];
            }
			for(var i=0;i < this.listItemsElement.length;i++){
				if (typeof text == "object") {
                    for (var j = 0; j < text.length; j++) {
                        if ($(this.listItemsElement[i]).text() == text[j]) {                           
                            index.push(i);                          
                            break;							
                        }
                    }
                }
                else if ($(this.listItemsElement[i]).text() == text) {
                    index = i;  
                    break;					
                }				
				}			                    
            return index;
        },
        getTextByIndex: function (index) {
            return $(this.element.find("li:not('.e-ghead')")[index]).text();
        },
        getItemByText: function (text) {
            var proxy = this, obj;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    obj = proxy._getItemObject($(this));
                    return false;
                }
            });
            return obj;
        },
        getItemByIndex: function (index) {
            return this._getItemObject($(this.element.children("li:not('.e-ghead')")[index]));
        },
        getListData: function () {
            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                if(this.model.allowVirtualScrolling) {
                    this.listitems = this.element.find('li');
                    return this.listitems;
                }
                else
                    return this.listitems;
            }
            else if (this.dataSource()){
				if(this.model.sortOrder != "none" && !(this.mapCateg && this.mapCateg != ""))
					 return this._newList;
			
			     return this.dataSource();
		}
            else
                return;
        },
        enableItem: function (text) {
            var proxy = this;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    $(this).removeClass("e-disable");
                    if (proxy.model.showCheckbox) $(this).find(".listcheckbox").ejCheckBox("enable");
                    proxy._disabledItems.splice($(this).index().toString());
                    return false;
                }
            });
        },
        disableItem: function (text) {
            var proxy = this;
            this.listItemsElement.each(function () {
                if ($(this).text() == text) {
                    $(this).addClass("e-disable");
                    if (proxy.model.showCheckbox) $(this).find(".listcheckbox").ejCheckBox("disable");
                    proxy._disabledItems.push($(this).index().toString());
                    return false;
                }
            });
        },
        moveUp: function () {
            var process = (this.model.fields.groupBy != null) ? (this.model.allowMultiSelection || this.model.showCheckbox) ? false : true : true;
            if (process) {
                this.checkedorselected = this.model.checkedIndices.length == 0 ? this.model.selectedIndices.reverse() : this.model.checkedIndices.reverse();
				this._checkstate(true);
               
            }
        },
				
        moveDown: function () {
            var process = (this.model.fields.groupBy != null) ? (this.model.allowMultiSelection || this.model.showCheckbox) ? false : true : true;
            if (process) {
                this.checkedorselected = this.model.checkedIndices.length == 0 ? this.model.selectedIndices : this.model.checkedIndices;   this._checkstate();
                }
        },
		
		_checkstate:function(ismoveup){			
			 var curItem = $(this.element.children("li:not('.e-ghead')")[this.checkedorselected[0]]);
                if ((ismoveup && !curItem.prev().hasClass("e-ghead")) || !curItem.next().hasClass("e-ghead") ) {
                    if (!ej.isNullOrUndefined(this.checkedorselected)) {
                        var selectIndex = 0;
                        var listval = this._getItem(this.checkedorselected[selectIndex]);
                        this._moveupdown(listval, selectIndex, ismoveup ? "up":"down");
                    }
                }			
		},
		
        _moveItem: function (item, list, direction) {
            var selectedItem = item, index = item.index(), moveup = (direction == "up"), movedown = (direction == "down");
			this._addListHover();
			this._getItem(this._selectedItem).removeClass("e-hover");
            if (moveup) {
                list.insertAfter(selectedItem);
                if (list.hasClass('e-disable') && $.inArray(index.toString(), this._disabledItems) > -1) {
                    this._disabledItems.splice($.inArray(index.toString(), this._disabledItems), 1);
                    this._disabledItems.push((index + 1).toString());
                }
				  this._selectedItem -= 1;
                  this._refreshItems();
            } else if (movedown) {
                list.insertBefore(selectedItem);
                if (list.hasClass('e-disable') && $.inArray(index.toString(), this._disabledItems) > -1) {
                    this._disabledItems.splice($.inArray(index.toString(), this._disabledItems), 1);
                    this._disabledItems.push((index - 1).toString());
                }
				 this._selectedItem += 1;
                 this._refreshItems();
            }
        },
        _moveupdown: function (list, index, direction) {

            var j = this.checkedorselected[index], next, k;
            var i = 0, i = j;
            while (i < $(this.element.children("li:not('.e-ghead')")).length) {
                next = $(this.element.children("li:not('.e-ghead')")[i]);
                if (ej.isNullOrUndefined(next)) break;
                if (next.hasClass("e-select") || next.find("span").hasClass("e-checkmark")) {
                    k = i;
                    direction == "down" ? eval(i++) : eval(i--);
                    continue;
                }
                else break;
            }
            if (!ej.isNullOrUndefined(next) && i < $(this.element.children("li")).length) this._moveItem(list, next, direction);

            if (index < this.checkedorselected.length) {
                ele = $(this.element.children("li")[this.checkedorselected[index]]);
                if (ele.next().hasClass("e-select") || ele.next().find("span").hasClass("e-checkmark")) var oneafter = direction == "down" ? true : false;
                else if (ej.isNullOrUndefined(ele[0])) var oneafter = direction == "up" ? true : false;
                else if (ele.hasClass("e-select") || ele.find("span").hasClass("e-checkmark")) {
                    this._moveupdown(ele, index + 1, direction);
                }

            }

            length = this.element.children("li:not('.e-ghead')").length;
            if (this.model.checkedIndices.length == 0) {
                this.model.selectedIndices = [];
                for (var i = 0; i < length; i++) {
                    if ($(this.element.children("li:not('.e-ghead')")[i]).hasClass('e-select'))
                        this.model.selectedIndices.push(i);
                }
            } else {
                this.model.checkedIndices = [];
                for (var j = 0; j < length; j++)
                    if ($.parseJSON($(this.element.children("li:not('.e-ghead')")[j]).find("span").attr("aria-checked")))
                        this.model.checkedIndices.push(j);
            }

        },


        checkAll: function () {
            if (!this.model.showCheckbox) return false;
            var items = this.element.find("li:not('.e-ghead')");
            for (i = 0; i < items.length; i++) {
                if (!($(items[i].firstChild).find('.listcheckbox').ejCheckBox('isChecked'))) {
                    $(items[i].firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(items[i]);
                    this.model.checkedIndices.push(i);
                }
            }
			this._setSelectionValues();
            this.model.uncheckAll = false;
        },
        //Deprecated Method
        unCheckAll: function () { this.uncheckAll(); },
        uncheckAll: function () {
            if (!this.model.showCheckbox) return false;
            var items = this.element.find("li:not('.e-ghead')");
            for (i = 0; i < items.length; i++)
                if ($(items[i].firstChild).find('.listcheckbox').ejCheckBox('isChecked'))
                    $(items[i].firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', false);
            this._checkedItems = [];
            this.model.checkedIndices = [];
			this._setSelectionValues();
            this.model.checkAll = false;
        },
        addItem: function (val, index) {
            var index = (!ej.isNullOrUndefined(index) && index <= this.element.find("li:not('.e-ghead')").length) ? index : this.element.find("li:not('.e-ghead')").length;
            var proxy = this, num = index;
            if (ej.isNullOrUndefined(this.dataSource())) {
                if (!(val instanceof Array)) {
					 if(this.model.fields.groupBy && typeof val == "object" ){ 
                          _query = ej.Query().group(this.model.fields.groupBy);
                           groupedList = ej.DataManager([val]).executeLocal(_query);
                            this.dataSource([]);  
                            for (i = 0; i < groupedList.length; i++) {
							this._setMapFields();
                            this.dummyUl.push(ej.buildTag('li.e-ghead', groupedList[i].key)[0]);
                            this._loadlist(groupedList[i].items);
                            this.dataSource(this.dataSource().concat(groupedList[i].items));										
					               } 
					    }
					 else{						 
						val = (typeof val == "object" ) ? val[this.model.fields.text] : val;
                    this.listitem = (this.element.find("li:not('.e-ghead')").length ?
                                        ((index - 1 < 0) ? $(this.element.find("li:not('.e-ghead')")[0]).before('<li role="option">' + val + '</li>') : $(this.element.find("li:not('.e-ghead')")[index - 1]).after('<li role="option">' + val + '</li>'))
                                         : $(this.element).html('<li role="option">' + val + '</li>'));
					 }
                    this.listitems = this.element.find("li:not('.e-ghead')");
                    this._addItemIndex = index;
                    if (this.model.showCheckbox) {
                        $checkbox = ej.buildTag("input.listcheckbox e-align#popuplist" + (this.listitems.length - 1) + "_" + this._id, "", {}, {
                            type: "checkbox",
                            name: "list" + (this.listitems.length - 1)
                        });
                        $(this.listitems[index]).prepend($checkbox);
                        $($(this.listitems[index]).find(".listcheckbox")).ejCheckBox({
                            change: $.proxy(this._onClickCheckList, this)
                        });
                    }
                    if (this.model.allowDrag || this.model.allowDrop) this._enableDragDrop();
                    this._addItemIndex = null;
                    this._refreshItems();
                }
                else {
                    $(val).each(function (i, e) {
                        proxy.addItem(e, index);
                        index = index + 1;
                    })
                }
            }
            else if (!(this.dataSource() instanceof ej.DataManager)) {
                if (proxy.dataSource() instanceof Object) {
					dup = new Object();
                    if (!(val instanceof Object)) {
                        dup[proxy.model.fields.text] = val;
                        val = dup;
                    }
                }
                else if (!(val instanceof Array)) val = [val];
                $(val).each(function (i, e) {
                    if(proxy.model.fields.groupBy==null||!ej.isNullOrUndefined(e[proxy.model.fields.groupBy])){
                    proxy.dataSource().splice(index, 0, e);
                    index = index + 1;
                 }
                })
                this.model.disableItemsByIndex = [];
                this.model.selectedIndices = [];
                this.model.checkedIndices = [];
                if (this.model.selectedIndex >= num)
                    this.model.selectedIndex += 1;
                var value = num - 1;
                for (value; value >= 0; value--) {
                    if ($(this.element.find("li:not('.e-ghead')")[value]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(value);
                    if ($(this.element.find("li:not('.e-ghead')")[value]).hasClass('e-select'))
                        this.model.selectedIndices.push(value);
                    if ($(this.element.children()[value]).hasClass("e-checkmark"))
                        this.model.checkedIndices.push(value);
                }
                for (num; num < this._listSize; num++) {
                    if ($(this.element.find("li:not('.e-ghead')")[num]).hasClass('e-disable'))
                        this.model.disableItemsByIndex.push(num + 1);
                    if ($(this.element.find("li:not('.e-ghead')")[num]).hasClass('e-select'))
                        this.model.selectedIndices.push(num + 1);
                    if ($(this.element.find("li:not('.e-ghead')")[num]).find('.listcheckbox').ejCheckBox('isChecked'))
                        this.model.checkedIndices.push(num + 1);
                }
                this.refresh(true);
            }
        },
        enableItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.enableItemsByIndices(index.toString());
        },
        disableItemByIndex: function (index) {
            if (typeof (index) == "number")
                this.disableItemsByIndices(index.toString());
        },
        disableItemsByIndices: function (value) {
            if (ej.isNullOrUndefined(value)) return false;
            var selectitems = value.toString().split(',');
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems.length > 0 && !($.inArray(selectitems[i], this._disabledItems) > -1)) {
                    var disable = $(this.element.children("li:not('.e-ghead')")[parseInt(selectitems[i])]).addClass('e-disable');
                    disable.find(".listcheckbox").ejCheckBox("disable");
                    this._disabledItems.push(selectitems[i]);
                }
            }
        },
        enableItemsByIndices: function (value) {
            var selectitems = value.toString().split(','), index;
            for (var i = 0; i < selectitems.length; i++) {
                if (selectitems.length > 0 && ($.inArray(selectitems[i], this._disabledItems) > -1)) {
                    index = $.inArray(selectitems[i], this._disabledItems);
                    var enable = $(this.element.children("li:not('.e-ghead')")[parseInt(selectitems[i])]).removeClass('e-disable');
                    enable.find(".listcheckbox").ejCheckBox("enable");
                    this._disabledItems.splice(index, 1);
                }
            }
        },
        _init: function () {
            this._id = this.element[0].id;
            this._isMozilla = ej.browserInfo().name == "mozilla" ? true : false;
            this._cloneElement = this.element.clone();
            this._deprecatedValue()._initialize()._render()._wireEvents();
            this._initValue = this.focused = this.datamerged = this.groupData = false;
            this._typeInterval = null;
            this._dummyVirtualUl = [];
            this._virtualCount = 0;
            this._liItemHeight = 0;
            this._typingThreshold = 2000;
            this._dataUrl = this.dataSource();
            //deprecatedFunction
            if (this.model.checkAll)
                this.checkAll();
            if (this.model.uncheckAll)
                this.uncheckAll();
            if (this.model.disableItemsByIndex)
                this.disableItemsByIndices(this.model.disableItemsByIndex.toString());
            if (this.model.enableItemsByIndex)
                this.enableItemsByIndices(this.model.enableItemsByIndex.toString());
            if (this.model.uncheckItemsByIndex)
                this.uncheckItemsByIndices(this.model.uncheckItemsByIndex.toString());
            this._deprecatedValue()._enabled(this.model.enabled);

        },
        _deprecatedValue: function () {
            this.model.itemDrop = (this.model.itemDrop || this.model.itemDropped);
            this.model.change = (this.model.change || this.model.selectIndexChanged);
            this.model.fields.checkBy = this.model.fields.selected || this.model.fields.checkBy;
            this.model.fields.tooltipText = this.model.fields.toolTipText || this.model.fields.tooltipText;
            this.model.fields.groupBy = this.model.fields.category || this.model.fields.groupBy;
            this.model.select = (this.model.select || this.model.selected);
            if (this.model.allowDragAndDrop != undefined)
                this.model.allowDrag = this.model.allowDrop = true;
            this.model.selectedIndex = this.model.selectedIndex != null ? this.model.selectedIndex : this.model.selectedItemIndex;
            this.model.checkedIndices = ((this.model.checkedIndices.length ? this.model.checkedIndices : null) || (this.model.checkItemsByIndex ? this.model.checkItemsByIndex : null) || (this.model.checkedItems.length ? this.model.checkedItems : null) || (this.model.checkedItemlist.length ? this.model.checkedItemlist : []));
            this.model.selectedIndices = ((this.model.selectedIndices.length ? this.model.selectedIndices : null) || (this.model.selectedItems.length ? this.model.selectedItems : null) || (this.model.selectedItemlist.length ? this.model.selectedItemlist : []));
            return this;
        },
        _setModel: function (options) {
            var option, refresh = false;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._setText(ej.util.getVal(options[option]));
                        break;
                    case "dataSource":
                        if (!ej.isNullOrUndefined(this._isCasCadeTarget))
                            this.model.selectedIndex = null;
                        options[option] = ej.util.getVal(options[option])
                        this._checkModelDataBinding(options[option]);
                        break;
                    case "query":
                        this._queryCheck(options[option]);
                        break;
                    case "fields":
                        this.model.fields = $.extend(this.model.fields, options[option]);
                        this._checkModelDataBinding(this.dataSource());
                        break;
                    case "template":
                        this.model.template = options[option];
                        this.refresh(true);
                        break;
                    case "loadDataOnInit":
                        this._loadContent = options[option];
                        this._checkModelDataBinding(this.dataSource());
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[option];
                        (this.model.enableRTL) ? this.listContainer.addClass("e-rtl") : this.listContainer.removeClass("e-rtl");
                        break;
                    case "enabled":
                        this.model.enabled = options[option];
                        this._enabled(options[option]);
                        break;
				    case "enableWordWrap":
					      this.model.enableWordWrap=options[option];
					      this._wordWrapItems(options[option]);
						  break;
                    case "height":
                    case "width":
                        this.model[option] = options[option];
                        this._setDimensions();
                        break;
                    case "cssClass":
                        this.model.cssClass = options[option];
                        this.listContainer.addClass(this.model.cssClass);
                        break;
                    case "showCheckbox":
                        this._checkboxHideShow(options[option]); if (options[option]) this._removeListHover();
                        break;
                    case "showRoundedCorner":
                        this.model.showRoundedCorner=options[option];
                        this._roundedCorner();
                        break;
                    case "selectedItemIndex":
                    case "selectedIndex":
                         if (this.listitem[options[option]] || options[option] == null || this.listitems[options[option]]) {
                            this.selectItemByIndex(options[option]);
                            this.model.selectedIndex = this.model.selectedItemIndex = options[option];
                        } else options[option] = this.model.selectedIndex;
                        break;
                    case "sortOrder":
                        this.model.sortOrder = options[option];
                        if (this.dataSource() != null)
                            this._showFullList();
                        else
                            this._renderlistContainer();
                        break;
                    case "checkItemsByIndex":
                    case "checkedItemlist":
                    case "checkedItems":
                    case "checkedIndices":
                        this.uncheckAll();
                        this.checkItemsByIndices(options[option].toString());
                        options[option] = this.model[option] = this.model.checkedIndices;
                        break;
                    case "uncheckItemsByIndex":
                        this.uncheckItemsByIndices(options[option].toString());
                        this.model[option] = options[option];
                        break;
                    case "selectedItemlist":
                    case "selectedItems":
                    case "selectedIndices":
                        this.unselectAll();
                        this.selectItemsByIndices(options[option].toString());
                        options[option] = this.model.selectedIndices;
                        break;
                    case "enableItemsByIndex":
                        this.model[option] = options[option];
                        this.enableItemsByIndices(options[option].toString());
                        break;
                    case "disableItemsByIndex":
                        this.model[option] = options[option];
                        this.disableItemsByIndices(options[option].toString());
                        break;
                    case "enableVirtualScrolling":
                        this.model.allowVirtualScrolling = options[option]; refresh = true;
                        break;
                    case "allowDrag":
                    case "allowDrop":
                    case "allowDragAndDrop":
                    case "allowVirtualScrolling":
                    case "virtualScrollMode":
                        this.model[option] = options[option]; refresh = true;
                        break;
                    case "checkAll":
                        this.model[option] = options[option]; if (options[option]) this.checkAll(); else this.uncheckAll();
                        break;
                    case "uncheckAll":
                        this.model[option] = options[option]; if (options[option]) this.uncheckAll(); else this.checkAll();
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "itemsCount":
                        var items = this.model.itemsCount;
                        if (this.model.height) {
                            this.model.itemsCount = options[option];
                            this._setItemsCount()._setDimensions();
                        } else options[option] = items;
                        break;
                    case "itemHeight":
                        var $liElements = this.listItemsElement;
                        var optionHeight = ej.isNullOrUndefined(options[option]) ? options[option] : options[option].toString().replace("px", "");
                        var modelHeight= ej.isNullOrUndefined(this.model.itemHeight) ? this.model.itemHeight :this.model.itemHeight.toString().replace("px", "");
                        for (var z = 0; z < $liElements.length; z++) {
                            var style = ej.isNullOrUndefined(options[option]) ? { "min-height": ej.isNullOrUndefined(this.model.itemHeight)? "20px":modelHeight } : { "min-height": optionHeight + "px", "height": optionHeight + "px" };
                            $liElements.eq(z).css(style);
                        } this.refresh();
                        break;
                    case "allowMultiSelection":
                        this.model.allowMultiSelection = options[option];
                        if (!options[option]) {
                            var index = this.model.selectedIndex;
                            this._removeListHover();
                            ej.isNullOrUndefined(index) ? "" : this.selectItemByIndex(index);
                        };
                        break;
                    case "totalItemsCount":
                        if (!ej.isNullOrUndefined(this.dataSource())) {
                            this.model.totalItemsCount = options[option];
                            if (this.model.query)
                                this._queryCheck(this.model.query);
                        }
                        break;
                }
            }
            if (refresh) this._refresh();
        },
        _destroy: function () {
            if (!ej.isNullOrUndefined(this._lilist)) $(this._lilist).ejDraggable("destroy");
            this.element.insertAfter(this.listContainer);
            this.element.find(".e-chkbox-wrap").remove();
            this.listContainer.remove();
			this.element.removeClass("e-ul");
            if (!this._isList) this.element.empty();
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
			this._ListEventUnbind(this.element.children("li"));
            return this;
        },
		_ListEventUnbind: function (_ListItemsContainer) {
			_ListItemsContainer.off("contextmenu", $.proxy(this._OnMouseContext, this));
            _ListItemsContainer.off("click", $.proxy(this._OnMouseClick, this));
            _ListItemsContainer.off("touchstart mouseenter", $.proxy(this._OnMouseEnter, this));
            _ListItemsContainer.off("touchend mouseleave", $.proxy(this._OnMouseLeave, this));
		},
        _refresh: function () {
            this._destroy()._init();
        },
        _finalize: function () {
            if (this.model.selectedIndex != null)
                this.selectItemByIndex(this.model.selectedIndex);
            else if ((this.model.showCheckbox == true) && (this._selectedItems.length > 0))
                this._selectCheckedItem(this._selectedItems);
            if (this.model.checkedIndices != null) this.checkItemsByIndices(this.model.checkedIndices.toString());
            return this;
        },
        _initialize: function () {
            this._isList = this.element.children().length ? true : false;
            this.target = this.element[0];
            this._queryString = null;
            this._disabledItems = [];
            this._itemId = null;
            this._up = this._down = this._ctrlClick = false;
            this.checkedStatus = this._isScrollComplete = false;
            this._incqueryString = "";
            this._totalCount = 0;
            this._activeItem = null;
            this._initValue = true;
            this.model.allowVirtualScrolling = (this.model.allowVirtualScrolling) ? this.model.allowVirtualScrolling : this.model.enableLoadOnDemand;
            this.model.virtualScrollMode = (this.model.enableVirtualScrolling) ? "continuous" : this.model.virtualScrollMode;
            this._selectedItems = [];
            this._checkedItems = [];
            this._loadContent = this.model.loadDataOnInit;
            this._loadInitialRemoteData = true;
            this._skipInitialRemoteData = false;
            if (this.model.enableVirtualScrolling) this.model.allowVirtualScrolling = true;
            this._setItemsCount();
            return this;
        },
        _render: function () {
            this._savedQueries = this.model.query.clone();
            if (this.model.totalItemsCount)
                this._savedQueries.take(this.model.totalItemsCount);
            this._renderContainer()._addAttr(this.model.htmlAttributes);
            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                if (this.model.actionBegin)
                    this._trigger("actionBegin", {});
                if (this._loadInitialRemoteData)
                    this._initDataSource(this.dataSource());
            }
            else
                this._showFullList();
            if (!this.dataSource()) this._finalize();
			this.listItemsElement=this.element.find("li:not('.e-ghead')");
            if (this.model.showRoundedCorner)
                this._roundedCorner();
            return this;
        },
        _queryCheck: function (value) {
            this._savedQueries = value.clone();
            this.element.empty();
            if (this.dataSource())
                this._checkModelDataBinding(this.dataSource());
        },
        _checkModelDataBinding: function (source) {
            this.mergeValue = null;
            this.dataSource(source);
            if (source != null && source.length != 0) {
                if (ej.DataManager && source instanceof ej.DataManager) this._initDataSource(source);
                else this._showFullList();
            } else { this.element.empty(); this._refreshScroller(); }
        },
        _initDataSource: function (source) {
            var proxy = this;
            proxy.listitems = proxy.dataSource();
            proxy._updateLoadingClass(true);
            var queryPromise = source.executeQuery(this._getQuery());
            queryPromise.done(function (e) {
                proxy._totalCount = e.count;
                proxy.listitems = e.result;
                proxy._updateLoadingClass()._showFullList()._trigger("actionSuccess", e);
                proxy._finalize();
                proxy._virtualPages = [0];
            }).fail(function (e) {
                proxy.dataSource(null);
                proxy._updateLoadingClass(true)._trigger("actionFailure", e);
            }).always(function (e) {
                if (proxy.model.checkAll)
                    proxy.checkAll();
                if (proxy.model.uncheckAll)
                    proxy.uncheckAll();
                proxy._trigger("actionComplete", e);
            });
        },
        _getQuery: function () {
            var queryManager;
            if (ej.isNullOrUndefined(this.model.query)) {
                var column = [],
                    mapper = this.model.fields;
                queryManager = ej.Query();
                for (var col in mapper)
                    if (col !== "tableName") column.push(mapper[col]);
                if (column.length > 0) queryManager.select(column);
                if (!this.dataSource().dataSource.url.match(mapper.tableName + "$")) !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            } else queryManager = this.model.query.clone();
            if(this.model.allowVirtualScrolling) {
                queryManager.requiresCount();
                queryManager.take(this.model.itemRequestCount);
            }
            return queryManager;
        },
        _getLiHeight: function () {
            this._liItemHeight = $(this.element.find('li')[0]).outerHeight();
        },
        _addDragableClass: function () {
            if (this.model.allowDrag || this.model.allowDrop) {
                this.element.css("cursor", "pointer");
                if (this.model.allowDrop) {
                    this.listContainer.addClass("e-droppable");
                    this.listBoxScroller.addClass("e-droppable");
                }
                var proxy = this;
                this.element.children("li").each(function (index) {
                    if (proxy.model.allowDrag) ($(this).addClass("e-draggable"));
                    if (proxy.model.allowDrop) ($(this).addClass("e-droppable"));
                });
            }
            return this;
        },
        _enableDragDrop: function () {
            if (this.model.allowDrag || this.model.allowDrop) this._drag();
        },
        _updateLoadingClass: function (value) {
            this.listContainer[(value ? "addClass" : "removeClass")]("e-load"); return this;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.listContainer.addClass(value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._enabled(false);
                else proxy.listContainer.attr(key, value);
            });
        },
        _renderContainer: function () {
            this.listContainer = ej.buildTag("div.e-ddl-popup e-box e-popup e-widget " + this.model.cssClass, "", {
                "visibility": "hidden"
            }, {
                "tabIndex": 0,
                "id": this._id + "_container"
            });
            this.listBoxScroller = ej.buildTag("div.e-listbox-container");
            this.ultag = ej.buildTag("ul.e-ul", "", {}, {
                "role": "listbox"
            });
            this.element = this.element.addClass("e-ul");
            this.listContainer.append(this.listBoxScroller).insertAfter(this.element);
            this.listBoxScroller.append(this.element);
            this.element.attr('data-ej-unselectable', 'on').css('user-select', 'none');
            this._hiddenInput = ej.buildTag("input#" + this._id + "_hidden", "", {}, {
                type: "hidden"
            }).insertBefore(this.element);
            this._hiddenInput.attr('name', this._id);
            return this;
        },
        _setMapFields: function () {
           var mapper = this.model.fields;
            this.mapFld = {
                _id: null,
                _imageUrl: null,
                _imageAttributes: null,
                _tooltipText: null,
                _spriteCSS: null,
                _text: null,
                _value: null,
                _htmlAttributes: null,
                _selectBy: null,
                _checkBy: null
            };
            this.mapFld._id = (mapper && mapper.id) ? mapper["id"] : "id";
            this.mapFld._imageUrl = (mapper && mapper.imageUrl) ? mapper["imageUrl"] : "imageUrl";
            this.mapFld._tooltipText = (mapper && mapper.tooltipText) ? mapper["tooltipText"] : "tooltipText";
            this.mapFld._imageAttributes = (mapper && mapper.imageAttributes) ? mapper["imageAttributes"] : "imageAttributes";
            this.mapFld._spriteCSS = (mapper && mapper.spriteCssClass) ? mapper["spriteCssClass"] : "spriteCssClass";
            this.mapFld._text = (mapper && mapper.text) ? mapper["text"] : this.listitems[0].text ? "text" : this._getObjectKey(this.listitems[0])[0];
            this.mapFld._value = (mapper && mapper.value) ? mapper["value"] : "value";
            this.mapFld._htmlAttributes = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            this.mapFld._checkBy = (mapper && mapper.checkBy) ? mapper["checkBy"] : "checkBy";
            this.mapFld._selectBy = (mapper && mapper.selectBy) ? mapper["selectBy"] : "selectBy";
            this.mapCateg = (mapper && mapper.groupBy) ? mapper["groupBy"] : ""
        },
        _getObjectKey: function (obj) {
            if (!Object.keys) {
                var keys = [];
                for (var i in obj) {
                    if (obj.hasOwnProperty(i)) {
                        keys.push(i);
                    }
                }
                return keys;
            }
            else return Object.keys(obj)
        },
        _itemStyle:function(){
            var height = ej.isNullOrUndefined(this.model.itemHeight) ? this.model.itemHeight : this.model.itemHeight.toString().replace("px", "");
            var itemHeight = ej.isNullOrUndefined(this.model.itemHeight) ? "" : "min-height:" + height + "px;height:" + height + "px";
            return { style: itemHeight }
        },
        sort: function () {
            var sortedlist = document.createElement("ul"), i, sortitems;
            $(sortedlist).append(this.itemsContainer.children());
            if (this.model.fields.groupBy != null || $(sortedlist).find(">.e-ghead").length > 0) {
                for (i = 0; i < $(sortedlist).find(">.e-ghead").length; i++) {
                    sortitems = $(sortedlist).find(">.e-ghead").eq(0).first().nextUntil(".e-ghead").get();
                    this._setSortList(sortedlist, sortitems);
                }
                var headerlist = document.createElement("ul"), headeritems, j;
                headeritems = $(sortedlist).clone().find('>.e-ghead').get();
                for (var k = 0; k < headeritems.length; k++)
                    headerlist.append(headeritems[k]);
                var headerdata = this._customSort(headerlist, headeritems);
                var groupSort = document.createElement("ul"), groupitems;
                var temp = $(sortedlist).find('li.e-ghead').get();
                if (this.model.sortOrder.toLowerCase() == "descending")
                    headerdata.reverse();
                for (j = 0; j < headerdata.length; j++) {
                    groupSort.append(headerdata[j]);
                    for (l = 0; l < temp.length; l++) {
                        if (headerdata[j].textContent == temp[l].textContent) {
                            groupitems = $(sortedlist).find(">.e-ghead").eq(l).first().nextUntil(".e-ghead").get();
                            for (m = 0; m < groupitems.length; m++) {
                                groupSort.append(groupitems[m]);
                            }
                        }
                    }
                }
                this.itemsContainer = $(groupSort);
            }
            else {
                sortitems = $(sortedlist).children('li').get();
                this._setSortList(sortedlist, sortitems);
                this.itemsContainer = $(sortedlist)
            }
        },
        _customSort: function (headerlist, headeritems) {
            headeritems.sort(function (objA, objB) {
                var sortA = $(objA).text().toUpperCase();
                var sortB = $(objB).text().toUpperCase();
                return (sortA < sortB) ? -1 : (sortA > sortB) ? 1 : 0;
            });
            return headeritems;
        },
        _setSortList: function (sortedlist, sortitems) {
            this._customSort(sortedlist, sortitems);
            if (this.model.sortOrder.toLowerCase() == "descending") sortitems.reverse();
            if (this.model.fields.groupBy != null || $(sortedlist).find(">.e-ghead").length > 0) {
                $(sortedlist).append($("<li>").text($(sortedlist).find(">.e-ghead").eq(0).text()).addClass("e-ghead"));
                $(sortedlist).find(">.e-ghead").eq(0).remove();
            }
            $.each(sortitems, function (index, item) {
                $(sortedlist).append(item);
            });
        },
        _renderlistContainer: function () {
            this.hold = this.touchhold = false;
            this.item = "";
            this.startime = 0;
            this.listitemheight = 24;
            var list = this.listitems,
                i, ulempty, ulno, litag, _id, _txt, mapper = this.model.fields,
                predecessor;
            this.lastScrollTop = -1;
            this.dummyUl = $();
            if (this.model.enableRTL) this.listContainer.addClass("e-rtl");
            this._wordWrapItems();
            if (this.dataSource() == null || this.dataSource().length < 1) {
                predecessor = this.element.parents().last();
                if (this.model.targetID) this.docbdy = predecessor.find("#" + this.model.targetID);
                else this.docbdy = predecessor.find("#" + this._id);
                this.itemsContainer = this.docbdy;
                if(this.model.sortOrder != "none") this.sort();
                this.itemsContainer.children("ol,ul").remove();
                this.items = this.itemsContainer.children('li');
                this.items.children("img").addClass("e-align");
                this.items.children("div").addClass("e-align");
                var iHeight = parseInt(this.model.itemHeight) + "px";
                if (this.model.itemHeight) $('li').css({ "min-height": iHeight, "height": iHeight });
                this.element.append(this.itemsContainer.children());
            }
            else if (this.dataSource() != null && typeof list[0] != "object") {
                if (this._loadInitialRemoteData && this.mergeValue && this.model.virtualScrollMode == "continuous" && this.model.totalItemsCount)
                    this._loadlist(this.mergeValue);
                else if (this._loadInitialRemoteData && this.mergeValue && this.model.virtualScrollMode == "normal" && this.model.totalItemsCount) {
                    this.realUllength = 0;
                    this.mergeUl = [];
                    for (i = 0; i < this.mergeValue.length; i++)
                         this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null, this._itemStyle())[0]);
                    this.element.append(this.mergeUl);
                    for (i = 0; i < this.model.totalItemsCount - this.mergeValue.length; i++)
                        this.dummyUl.push(ej.buildTag('li', null, null, this._itemStyle())[0]);
                    this.element.append(this.dummyUl);
                    this._refreshScroller();
                }
                else if (this._loadInitialRemoteData && this.mergeValue && !this.model.totalItemsCount)
                    this._initDataSource(this.dataSource());
            }
            else {
                this._setMapFields();
                var groupedList, _query;
                _query = this._savedQueries;
                this.listContainer.height(this.model.height);
                this.listitemheight = 24;
                if (this.model.allowVirtualScrolling) {
                    if (this.model.virtualScrollMode == "normal") {
                        this.realUllength = 0;
                        if (this.dataSource().length < 0) {
                            query = this._savedQueries.take(parseInt(this.listContainer.height() / this.listitemheight));
                            var proxy = this;
                            if (ej.DataManager && this.dataSource() instanceof ej.DataManager) {
                                proxy.listitems = proxy.dataSource();
                                var queryPromise = this.dataSource().executeQuery(query);
                                queryPromise.done(function (e) {
								    proxy._trigger("actionBeforeSuccess", e);
                                    proxy.listitems = e.result;
                                    proxy._trigger("actionSuccess", e);
                                }).fail(function (e) { proxy._trigger("actionFailure", e); })
                                  .always(function (e) { proxy._trigger("actionComplete", e); });
                            }
                        }
                        if (this.mergeValue != groupedList && !ej.isNullOrUndefined(this.mergeValue)) {
                            this.mergeUl = [];
                            for (i = 0; i < this.mergeValue.length; i++) {
                                var $liEle = ej.buildTag('li', this.model.template ? "" : this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]
                                if (this.model.template) $liEle.append(this._getTemplatedString(list[i]));
                                this.mergeUl.push($liEle[0]);
                            }
                            this.element.append(this.mergeUl);
                        }
                        if (!this.model.totalItemsCount)
                            var originalliLength = this.listitems.length;
                        else
                            var originalliLength = (this.mergeValue) ? this.model.totalItemsCount - this.mergeValue.length : this.model.totalItemsCount;
                        for (var i = 0; i < originalliLength; i++) {
                            var $listEle = ej.buildTag('li', null, null,  this._itemStyle());
                            this.dummyUl.push($listEle[0]);
                        }
                        this.dummyUl.attr("data-ej-page", 0);
                        this.element.append(this.dummyUl);
                    }
                    this._loadInitialData(_query, list);
                } else {
                    if (this.mapCateg && this.mapCateg != "") {
                        _query = ej.Query().group(this.mapCateg);
                        if(this.model.sortOrder.toLowerCase() == "none")
                       _query.queries.splice(0, 1);
                        groupedList = ej.DataManager(list).executeLocal(_query);
                        if (this.model.sortOrder.toLowerCase() != "none") {
                            var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                            groupedList = ej.DataManager(groupedList).executeLocal(sortQuery);
                        }
                        this.dataSource([]);
                        if(this.datamerged && this.model.fields.groupBy){
                                this.mergeUl = [];
                                for (i = 0; i <this.mergeValue.length; i++) {
                                    this.mergeUl.push(this.mergeValue[i]);
                                   for(j=0;j<groupedList[0].items.length;j++){
                                       if(this.mergeValue[i].category==groupedList[0].items[j].key)
                                           groupedList[0].items[j].items.push(this.mergeUl[i]);
                                        }     
                                    }
                           for(i = 0; i < groupedList[0].items.length; i++) {
                            this.dummyUl.push(ej.buildTag('li.e-ghead', groupedList[0].items[i].key)[0]);
                            this._loadlist(groupedList[0].items[i].items);
                            this.dataSource(this.dataSource().concat(groupedList[0].items[i].items));
                        }
                    }
                    else{
                            for (i = 0; i < groupedList.length; i++) {
                            this.dummyUl.push(ej.buildTag('li.e-ghead', groupedList[i].key)[0]);
                            this._loadlist(groupedList[i].items);
                            this.dataSource(this.dataSource().concat(this._newList));
                        }
                    } }
                    else {
                        groupedList = ej.DataManager(list).executeLocal(_query);
                        if (groupedList.length > 0) {
                            if (this.mergeValue != groupedList && !ej.isNullOrUndefined(this.mergeValue)) {
                                this.mergeUl = [];
                                for (i = 0; i < this.mergeValue.length; i++) {
                                    this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]);
                                    groupedList.push(this.mergeValue[i]);
                                }
                            }
                            if (this.model.template != null && this._loadContent) {
                                if (this.model.sortOrder.toLowerCase() != "none") {
                                    var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                                    list = ej.DataManager(list).executeLocal(sortQuery);
                                }
                                for (i = 0; i < list.length; i++) {
                                    var _dhtmlAttributes = this._getField(list[i], this.mapFld._htmlAttributes);
                                    var _did = this._getField(list[i], this.mapFld._id);
                                    litag = ej.buildTag('li');
                                    if ((_dhtmlAttributes) && (_dhtmlAttributes != "")) litag.attr(_dhtmlAttributes);
                                    if (_did) litag.attr('id', _did);
                                    if (this.model.template) litag.append(this._getTemplatedString(list[i]));
                                    this.dummyUl.push(litag[0]);
                                }
                                if (!this.model.allowVirtualScrolling) this.element.children().remove();
								var k = (this.model.virtualScrollMode == "continuous" && this.mergeValue) ? this.realUllength + this.mergeValue.length : this.realUllength;
                                if (this.element.children()[k] == null && (!this.model.allowVirtualScrolling || this.model.virtualScrollMode == ej.VirtualScrollMode.Continuous) && this._loadContent)								
                                this.element.append(this.dummyUl);
                            }
                            else {
                                this.realUllength = 0;
                                this._loadlist(groupedList);
                            }
                        }
                    }
                }
            }
            var proxy = this;
            if (groupedList) this.listitems = groupedList;
            this._setDimensions();
            this.listContainer.css({ "position": "relative", "height": "" });
            this.listBoxScroller.css({ "height": "", "width": "" });
            if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "normal") {
                this._getLiHeight();
                totalHeight = this._totalCount * this._liItemHeight;
                this.element.height(totalHeight);
            }
            else if(this.model.allowVirtualScrolling == true && this.model.virtualScrollMode == "continuous") {
                this.element.css("height", "auto");
            }
            this.listContainer.ejScroller({
                height: this.listContainer.height(),
                width: 0,
                scrollerSize: 20,
                scroll: function (e) {
                    proxy._onScroll(e);
                },
            });
            this.scrollerObj = this.listContainer.ejScroller("instance");
            this._setDimensions();
            this.listContainer.css({ 'display': 'none', 'visibility': 'visible' });
            this._checkboxHideShow(this.model.showCheckbox)._checkitems()._showResult();
            //if (this.model.totalItemsCount)
            //    this._setTotalItemsCount();
        },
		  _wordWrapItems:function(){
			   this.model.enableWordWrap?this.listContainer.addClass("e-wrap").removeClass("e-nowrap"):this.listContainer.addClass("e-nowrap").removeClass("e-wrap");
			},
	
        _loadInitialData: function (query, list) {
            var _query = query.clone();
            this.realUllength = 0;
            if ((ej.DataManager && this.dataSource() instanceof ej.DataManager))
                _query = _query.range(0, parseInt(this.listContainer.height() / this.listitemheight));
            else
                _query = _query.range(0, this.listitems.length);
            groupedList = list;
            if (this.mergeValue != groupedList && this.mergeValue != undefined && this.model.virtualScrollMode == "continuous") {
                this.mergeUl = [];
                for (i = 0; i < this.mergeValue.length; i++)
                    this.mergeUl.push(ej.buildTag('li', this.mergeValue[i][this.model.fields.text], null,  this._itemStyle())[0]);
                this.element.append(this.mergeUl);
            }
            if (!this.mergeValue || (this.mergeValue && this._loadInitialRemoteData))
                this._loadlist(groupedList);
        },
        _loadlist: function (sublist) {
            this._dummyVirtualUl = []; this._newList = [];
            if (this.element != null) {
                var selectionArray = [];
                if (this.model.sortOrder.toLowerCase() != "none") {
                    var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                    sublist = ej.DataManager(sublist).executeLocal(sortQuery);
                }
                for (var j = 0; j < sublist.length; j++) {
                    var _did = this._getField(sublist[j], this.mapFld._id);
                    var _dimageUrl = this._getField(sublist[j], this.mapFld._imageUrl);
                    var _dimageAttributes = this._getField(sublist[j], this.mapFld._imageAttributes);
                    var _dspriteCss = this._getField(sublist[j], this.mapFld._spriteCSS);
                    var _dtext = this._getField(sublist[j], this.mapFld._text);
                    var _dvalue = this._getField(sublist[j], this.mapFld._value);
                    var _dhtmlAttributes = this._getField(sublist[j], this.mapFld._htmlAttributes);
                    var _dselectBy = this._getField(sublist[j], this.mapFld._selectBy);
                    var _dcheckBy = this._getField(sublist[j], this.mapFld._checkBy);
                    var _dtooltipText = this._getField(sublist[j], this.mapFld._tooltipText);
                    var k = (this.model.virtualScrollMode == "continuous" && this.mergeValue) ? this.realUllength + this.mergeValue.length : this.realUllength;
                    if ((_dvalue) && (_dvalue != "")) litag = ej.buildTag('li', "", "", $.extend( this._itemStyle(), {value: _dvalue}));
                    else var litag = ej.buildTag('li', null, null,  this._itemStyle()); if (_did) litag.attr('id', _did);

                    if ((_dimageUrl) && (_dimageUrl != "")) {
                        imgtag = ej.buildTag('img.e-align', '', {}, {
                            'src': _dimageUrl,
                            'alt': _dtext
                        });
                        if ((_dimageAttributes) && (_dimageAttributes != "")) imgtag.attr(_dimageAttributes);
                        litag.append(imgtag);
                    }
                    if ((_dspriteCss) && (_dspriteCss != "")) {
                        divtag = ej.buildTag('div.e-align ' + _dspriteCss + ' sprite-image');
                        litag.append(divtag);
                    }
                    if ((_dtext) && (_dtext != "")){
                    if(this.model.template) litag.append(this._getTemplatedString(sublist[j]))
                    else litag.append(_dtext);
                    }
                    if ((_dhtmlAttributes) && (_dhtmlAttributes != "")) litag.attr(_dhtmlAttributes);
                    if ((_dtooltipText) && (_dtooltipText != "")) litag.attr('data-content', _dtooltipText).addClass("e-tooltip");
                    if (_dcheckBy || this.model.checkAll) litag.addClass("checkItem");
                    if (_dselectBy || this.model.selectAll) litag.addClass("selectItem");
                    if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                        $(litag[0]).attr("data-ej-page", 0);
                        ($(this.dummyUl[k])).replaceWith(litag[0]);
                        this._dummyVirtualUl.push(litag[0]);
                    }
                    else
                        this.dummyUl.push(litag[0]);
                    this.realUllength += 1;
                }
                if (!this.model.allowVirtualScrolling) this.element.children().remove();
                if (this.element.children()[k] == null && (!this.model.allowVirtualScrolling || this.model.virtualScrollMode == ej.VirtualScrollMode.Continuous) && this._loadContent)
                    this.element.append(this.dummyUl);
                var listItems = this.element.find("li:not('.e-ghead')"); this.listItemsElement = this.element.find("li:not('.e-ghead')");
                if (this.model.showCheckbox && this.model.checkedIndices) {
                    for (var i = 0; i < listItems.length; i++)
                        if (this.model.checkedIndices.indexOf(i) != -1)
                            $(listItems[i]).addClass("checkItem");
                }
                else if (!this.model.showCheckbox) {
					if(this.value()!="" && !this.mapCateg && !this.mapCateg != "") this.selectItemByText(this.value());
                    for (var i = 0; i < listItems.length; i++)
                        if (this.model.selectedIndices.indexOf(i) != -1 || this.model.selectedIndex == i)
                            $(listItems[i]).addClass("selectItem");
                }
                this.element.find('.selectItem').each(function (i, e) {
                    selectionArray.push($(e).parent().find("li").index($(e)));
                });
                var proxy = this;
                if (!proxy.model.showCheckbox && !this.mapCateg && !this.mapCateg != "")
                    proxy._selectListItems();
                this.element.find('.checkItem').each(function (i, e) {
                    proxy.model.checkedIndices.push(proxy._elementIndex(e));
                });
				if(!this.mapCateg && !this.mapCateg != ""){
                if (selectionArray.length)
                    this.model.allowMultiSelection ? this.model.selectedIndices = selectionArray : this.model.selectedIndex = selectionArray[0];
                if (this.model.checkedIndices)
                    this.model.checkedIndices = $.grep(proxy.model.checkedIndices, function (el, index) { return index == $.inArray(el, proxy.model.checkedIndices); });
                else if (this.model.selectedIndices)
                    this.model.selectedIndices = $.grep(proxy.model.selectedIndices, function (el, index) { return index == $.inArray(el, proxy.model.selectedIndices); });
				}
                this._loadContent = true;
            }
			this._newList = sublist;
            return this;
            
        },
        _applySelection: function () {
            if (!(this.model.fields.checkBy || this.model.fields.selectBy)) return false;
            if (this.model.showCheckbox) {
                this.uncheckAll();
                this.checkItemsByIndices(this.model.checkedIndices);
            }
            else {
                if (this.model.allowMultiSelection)
                    this.selectItemsByIndices(this.model.selectedIndices);
                else {
                    this.unselectAll();
                    this.selectItemByIndex(this.model.selectedIndex);
                }
            }
        },
        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },
        _getTemplatedString: function (list) {
            var str = this.model.template,
                start = str.indexOf("${"),
                end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },
        _checkboxHideShow: function (value) {
            this.model.showCheckbox = value;
            (value) ? this._createCheckbox() : this._removeCheckbox();
            return this;
        },
        _createCheckbox: function () {
            var i, _extchk, chklist, me = this;
            this._listitems = this.listContainer.find("ol,ul").length > 0 ? this.listContainer.find("ol,ul").children("li:not('.e-ghead')") : this.element.children("li:not('.e-ghead')");
            chklist = this._listitems.find('input[type=checkbox]');
            for (i = 0; i < this._listitems.length; i++) {
                if ($(this._listitems[i]).text() != "") {
                    $checkbox = ej.buildTag("input.listcheckbox e-align#popuplist" + i + "_" + this._id, "", {}, {
                        type: "checkbox",
                        name: "list" + i
                    });
                    if (!$(this._listitems[i]).find('input[type=checkbox]').length)
                        $(this._listitems[i]).prepend($checkbox);
                }
            }
            this.listContainer.find(".listcheckbox").ejCheckBox({
                cssClass: this.model.cssClass,
                change: $.proxy(this._onClickCheckList, this)
            });
            for (i = 0; i < this._listitems.length; i++) {
                var checkbox = $(this._listitems[i]).find(".listcheckbox");
                if ($(this._listitems[i]).hasClass('e-disable')) checkbox.ejCheckBox('disable');
                else if ( $(this._listitems[i]).hasClass('checkItem') && !checkbox.ejCheckBox('isChecked')) {                    
                    checkbox.ejCheckBox({
                        "checked": true
                    });
                    this._activeItem = i;
                    this.checkedStatus = true;
                    var checkData = this._getItemObject($(this._listitems[i]), null);
                    checkData["isInteraction"] = true;
                    if (!this._initValue) this._trigger('checkChange', checkData);
                    $(this._listitems[i]).removeClass('checkItem');
                }
            }
            for (i = 0; i < this.model.selectedIndices.length; i++) {
                this.checkItemsByIndices(this.model.selectedIndices);
            }
        },
        _removeCheckbox: function () {
            var i, checkbox;
            this.listitem = this.listContainer.find("ol,ul").children("li");
            checkbox = this.listitem.find('.listcheckbox');
            if (checkbox.length > 0) {
                this.listitem.find('.listcheckbox').ejCheckBox('destroy');
                this.listitem.find('input[type=checkbox]').remove();
                if (this.model.allowMultiSelection) {
                    for (i = 0; i < this.model.checkedIndices.length; i++) {
                        this.selectItemsByIndices(this.model.checkedIndices);
                    }
                } else this.selectItemByIndex(this.model.checkedIndices[0]);
                this._checkedItems = this.model.checkedIndices = [];
            }
        },
        _selectCheckedItem: function (chkitems) {
            if (chkitems.length > 0)
                for (i = 0; i < chkitems.length; i++)
                    this._selectedItems.push(chkitems[i]);
        },
        _refreshScroller: function () {
            if (this.model.virtualScrollMode == "continuous") {
                this.listContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this.listContainer.height();
                    this.scrollerObj.refresh();
                }
            } else {
                this.listContainer.find(".e-vhandle div").removeAttr("style");
                var listboxcontent = this.listBoxScroller.height();
                this.listContainer.css({ "display": "block" });
                if (this.scrollerObj) {
                    this.scrollerObj.model.height = this.listContainer.css("height");
                    this.scrollerObj.refresh();
                }
                this.listBoxScroller.css("height", "100%");
            }
            if (!this.model.enabled) {
                if (this.scrollerObj) this.scrollerObj.disable();
            }
            this.listContainer.css("height", this.model.height);
        },
        _setDimensions: function () {
            this.listContainer.css({ "width": this.model.width, "height": this.model.height });
            this._refreshScroller();
            return this;
        },
        _setItemsCount: function () {
            if(this.model.height=="auto"){
            if (this.model.itemsCount && this.model.itemsCount != 0 && this.model.height == "auto")
                this.model.height = this.model.itemsCount * 30;
            else
                this.model.height = (this.model.height == "auto") ? "220" : this.model.height;
              }
               else if (this.model.height != "auto" && this.model.itemsCount) {
                if (this.model.itemHeight)
                this.model.height = (this.model.height == "auto") ? "220" : this.model.itemsCount * this.model.itemHeight.replace(/[^-\d\.]/g, '');
                else
                    this.model.height = (this.model.height == "auto") ? "220" : this.model.itemsCount * 30;
            }
            else if (this.model.height != "auto" && this.model.itemsCount !=0) {
                this.model.height;
            }
            return this;
        },
        _setTotalItemsCount: function () {
            if (this.model.virtualScrollMode != "continuous") {
                this.element.height(this.element.find("li").outerHeight() * this.model.totalItemsCount);
                this.scrollerObj.refresh();
            }
        },

        _refreshContainer: function () {
            this.listContainer.css({ "position": "relative" });
            this._setDimensions()._roundedCorner()._refreshScroller();
        },
        _drag: function () {
            var proxy = this,
                pre = false,
                _clonedElement = null,
                dragContainment = null;
            this._listitem = this.element.parent();
            this._lilist = this._addItemIndex ? $($(this._listitem).find("li")[this._addItemIndex]) : $(this._listitem).find("li");
            this._lilist.not(".e-js").ejDraggable({
                dragArea: dragContainment,
                clone: true,
                dragStart: function (args) {
                  if( proxy.model.allowDrag || proxy.model.allowDragAndDrop ) {
                    if (!$(args.element.closest('.e-ddl-popup.e-js')).hasClass('e-disable') && !args.element.hasClass('e-disable')) {
                        var draggedobj = $("#" + this.element.parent()[0].id).data("ejListBox");
                        draggedobj._refreshItems();
                        var dragEle = proxy.getSelectedItems();
                        if (dragEle.length > 1 ? proxy._onDragStarts(dragEle, args.target) : proxy._onDragStarts([proxy._getItemObject(args.element, args)], args.target)) {
                            args.cancel = true;
                            _clonedElement && _clonedElement.remove();
                            return false;
                        }
                    } else {
                        _clonedElement && _clonedElement.remove();
                        return false;
                    }
                  }
                  else return false;
                },
                drag: function (args) {
                    var target = args.target;
                    var dragEle = proxy.getSelectedItems();
                    if (dragEle.length > 1 ? proxy._onDrag(dragEle, target) : proxy._onDrag([proxy._getItemObject(args.element, args)], target)) return false;
                    if ($(target).hasClass('e-droppable') || $(target).parent().hasClass('e-droppable'))
                        $(target).addClass("allowDrop");
                },
                dragStop: function (args) {
                    if (!args.element.dropped)
                        _clonedElement && _clonedElement.remove();
					if(!$(args.target).closest(".e-js.e-widget").hasClass("e-disable")){					
                    var target = args.target, targetObj = proxy;
                    var position = pre ? "Before" : "After";
                    var dragEle = proxy.getSelectedItems();
                    if (dragEle.length > 1 ? proxy._onDragStop(dragEle, target) : proxy._onDragStop([proxy._getItemObject(args.element, args)], target)) return false;
                    $(args.element).removeClass("e-active");
                    if (target.nodeName == 'UL') target = $(target)[0];
                    if ($(target).closest('li').length) target = $(args.target).closest('li')[0];
                    else if (target.nodeName != 'LI') target = $(target).closest('.e-ddl-popup.e-droppable')[0];
                    if (target && target.nodeName == 'LI' && $(target).hasClass('e-droppable') && $(target).closest('.e-ddl-popup.e-droppable').length) proxy._dropItem(target, args.element, pre, args.event);
                    else if ($(target).hasClass('e-droppable') && $(target).closest('.e-ddl-popup.e-droppable').length) proxy._dropItemContainer(target, args.element, args.event);
                    $(".allowDrop").removeClass("allowDrop");
                    if (args.target != proxy.element[0] && (args.element.parent().length && $(args.element.parent()[0]).data().ejWidgets[0] == "ejListBox")) {
                        proxy = $("#" + args.element.parent()[0].id).data($(args.element.parent()[0]).data().ejWidgets[0]);
                        if (dragEle.length > 1 ? proxy._onDropped(dragEle, target) : proxy._onDropped([proxy._getItemObject(args.element), args], args.target)) return false;
					}}
                    if( !proxy.model.allowDrag && !proxy.model.allowDragAndDrop ) proxy.element.children().removeClass("e-draggable");
                },
                helper: function (event, ui) {
                    if (!ej.isNullOrUndefined(event.element) && !$(event.element.closest('.e-ddl-popup.e-js')).hasClass('e-disable') && $(event.element).hasClass('e-draggable')) {
                        proxy = $(event.element).closest('.e-listbox.e-js').data('ejListBox');
                        proxy._tempTarget = $(event.element).text();
                        if ((proxy.model.allowDrag || proxy.model.allowDragAndDrop) && proxy) {
                            _clonedElement = $(event.sender.target).clone().addClass("dragClone e-dragClonelist");
                            _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                            _clonedElement.css({ "width": proxy.element.width(), "padding": "5px 5px 5px 0.857em", "list-style": "none", "text-align": (proxy.model.enableRTL ? "right" : "left"), "opacity": "1" });
                            return _clonedElement.appendTo($("body"));
                        }
                    }
                }
            });
        },
        _dropItem: function (target, element, pre, event) {
            element.addClass("e-droppable");
            var targetid = $(target).closest('.e-ddl-popup.e-droppable')[0].id.replace('_container', '');
            var dataIndex = [], dataObj = [];
            var droppedobj = $("#" + targetid).data("ejListBox");
            var preventDrop = (droppedobj.model.showCheckbox ? !this.model.showCheckbox : this.model.showCheckbox);
            if (preventDrop) return;
            var data = this._getDropObject(target, element, event);
            dataIndex = data.dataIndex;
            dataObj = data.dataObj;
            pre ? $(this.li).insertBefore(target) : $(this.li).insertAfter(target);
            this._refreshItems();
            var ulElements =$(this.li.parent()[0]).find("li:not('.e-ghead')");
            if (dataObj && this.dataSource())
                this._dropDataSource(droppedobj, dataIndex, dataObj, ulElements.index(this.li));
            droppedobj._refreshItems();
        },
        _dropItemContainer: function (target, element, event) {
            element.addClass("e-droppable");
            var targetid = $(target)[0].id.replace('_container', '');
            var droppedobj = $("#" + targetid).data("ejListBox");
            var preventDrop = (droppedobj.model.showCheckbox ? !this.model.showCheckbox : this.model.showCheckbox);
            if (preventDrop) return;
            var dataIndex = [], dataObj = [];
            var data = this._getDropObject(target, element, event);
            dataIndex = data.dataIndex;
            dataObj = data.dataObj;
            this.li.insertAfter($($(target).find('li')).last());
			if($(target).find('ul').length > 0) $(target).find('ul').append(this.li);
			else $(target).find('ej-listbox').append(this.li);
            this._refreshItems();
            if (dataObj && this.dataSource())
                this._dropDataSource(droppedobj, dataIndex, dataObj, droppedobj.dataSource() ? droppedobj.dataSource().length : 0);
            if (!droppedobj.model.allowDrag)
                $(this.li).ejDraggable("instance")._destroy();
            droppedobj._refreshItems();
        },
        _dropDataSource: function (droppedobj, dataIndex, dataObj, droppedIndex) {
            var preventDropData = ej.DataManager && this.dataSource() instanceof ej.DataManager;
            if (preventDropData) return;
            if (dataIndex instanceof Array) {
                var proxy = this;
                $.each(dataObj, function (index) {
                   var indx = proxy.dataSource().indexOf(dataObj[index]);
                    proxy.dataSource().splice(indx, 1);
                });
            }
            else
                this.dataSource().splice(dataIndex, 1);
            if (droppedobj.dataSource() instanceof Array) {
                droppedobj.dataSource().splice.apply(droppedobj.dataSource(), [droppedIndex, 0].concat(dataObj));
            }
            else {
                droppedobj.dataSource(dataObj);
            }
        },
        _getDropObject: function (target, element, event) {
            var dataIndex = [], dataObj = [];
            if (this.model.allowMultiSelection) {
                this.li = $(element).parent().find(".e-select").removeClass("e-select e-hover");
                if (!this.li.length)
                 this.li = element.removeClass("e-select e-hover");
            }
            else
                this.li = element.removeClass("e-select e-hover");

            if (this.li.length) {
               var proxy = this;
               var sortFlg=this.model.sortOrder.toLowerCase();
                $.each(this.li, function (ele) {
                    var ulElements=$(this.parentElement).find("li:not('.e-ghead')");
                    dataIndex.push(ulElements.index(this));
                            if( sortFlg!="none"){
            var sortQuery = ej.Query().sortBy(sortFlg, true);
                    dataAfterSort = ej.DataManager(proxy.dataSource()).executeLocal(sortQuery);
                dataObj.push((proxy.dataSource()) ? dataAfterSort[ulElements.index(this)] : null);
            }
            else
                    dataObj.push((proxy.dataSource()) ? proxy.dataSource()[ulElements.index(this)] : null);
                });
            }
            else {
                dataIndex = this.li.index();
                dataObj = (this.dataSource()) ? this.dataSource()[dataIndex] : null;
            }
            return { "dataIndex": dataIndex, "dataObj": dataObj };
        },
        _showResult: function () {
            var proxy = this;
            this._refreshContainer();
            this.element.attr({
                "aria-expanded": true
            });
            var _ListItemsContainer = this.element.children("li:not('.e-ghead')");
            this._listSize = _ListItemsContainer.length;
			this._ListEventUnbind(_ListItemsContainer);
            _ListItemsContainer.on("touchstart mouseenter", $.proxy(this._OnMouseEnter, this));
            _ListItemsContainer.on("touchend mouseleave", $.proxy(this._OnMouseLeave, this));
            _ListItemsContainer.on("click", $.proxy(this._OnMouseClick, this));
            _ListItemsContainer.on("contextmenu", $.proxy(this._OnMouseContext, this));            
            if (proxy.model.showCheckbox) proxy.element.find(".listcheckbox").ejCheckBox({ enabled: proxy.model.enabled });
            return this;
        },
        _OnWindowResize: function (e) {
            this._refreshContainer();
            this.listContainer.css("display", "block");
        },
        refresh: function (value) {
		    if (!ej.isNullOrUndefined(this.model.query)) this._savedQueries = this.model.query; 
            if (this.model.dataSource) {
                if (this.model.template)
                    this.element.empty();
                this._checkModelDataBinding(this.dataSource());
            }
            else {
                this.listContainer.css({ "height": this.model.height, "width": this.model.width });
                this._refreshScroller();
            }
        },
        _removeListHover: function () {
            this._selectedItems = [];
            this.model.selectedIndices = [];
            this.model.selectedIndex = null;
            this.element.children("li").removeClass("e-hover e-select selectItem");
            return this;
        },
        _addListHover: function () {
            this._activeItem = this._selectedItem;
            var activeItem = this._getItem(this._selectedItem);
            activeItem.addClass("e-select e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
            activeItem.focus();
            this._OnListSelect(this.prevselectedItem, this._selectedItem);
        },
        _calcScrollTop: function (value) {
            var ulH = this.element.outerHeight(),
                li = this.element.find("li"),
                liH = 0,
                index, top, i;
            index = value ? value : this.element.find("li.e-select").index();
            for (i = 0; i < index; i++)
                liH += li.eq(i).outerHeight();
            top = liH - ((this.listContainer.outerHeight() - li.eq(index).outerHeight()) / 2);
            return top;
        },
        _refreshItems: function () {
            this.listBoxScroller.append(this.element);
            this.listContainer.append(this.listBoxScroller);
            this._refreshContainer();
            this._showResult();
            this._setSelectionValues();
            this._setDisableValues();
        },
        _selectedIndices: function () {
            var selectItem;
            this.element.children("li:not('.e-ghead')").each(function (index) {
                if ($(this).hasClass("e-select")) {
                    selectItem = index;
                    return false
                }
            });
            this._selectedItem = selectItem;
            return selectItem;
        },
        _addSelectedItem: function (e) {
            if ((!Array.isArray(this.model.disableItemsByIndex) && this.model.disableItemsByIndex != null) || (Array.isArray(this.model.disableItemsByIndex) && this.model.disableItemsByIndex.length > 0)) {
                if (e.keyCode == 40 || e.keyCode == 39) this._disableItemSelectDown();
                else this._disableItemSelectUp();
                this._selectedItem = this._activeItem
            }
            var activeItem = this._getItem(this._selectedItem);
            this._selectedItems.push(activeItem)
        },
        _getItem: function (val) {
            return $(this.element.children("li:not('.e-ghead')")[val])
        },
        _getItemObject: function (item, evt) {
            var index = this._elementIndex(item);
            return {
                item: item,
                index: index,
                text: item.text(),
                value: item.attr("value") ? item.attr("value") : item.text(),
                isEnabled: !item.hasClass("e-disable"),
                isSelected: item.hasClass("e-select"),
                isChecked: item.find('.e-chk-image').hasClass('e-checkmark'),
                data: this.dataSource() ? this.getListData()[index] : null,
                event: evt ? evt : null
            };
        },
        _roundedCorner: function () {
            this.listContainer[(this.model.showRoundedCorner ? "addClass" : "removeClass")]("e-corner-all");
            return this;
        },
        _enabled: function (boolean) {
            boolean ? this.enable() : this.disable();
            return this;
        },
        _showFullList: function () {
            if (this.dataSource() != null) {
                if (!(ej.DataManager && this.dataSource() instanceof ej.DataManager))
                    this.listitems = this.dataSource();
                if (this._savedQueries.queries.length && !(ej.DataManager && this.dataSource() instanceof ej.DataManager))
                    this.listitems = ej.DataManager(this.dataSource()).executeLocal(this._savedQueries);
            }
            this._renderlistContainer();
            if (!(this.dataSource() instanceof ej.DataManager)) this._trigger("actionComplete");
            this._addDragableClass()._enableDragDrop();
            this._disabledItems = [];
            this.disableItemsByIndices(this.model.disableItemsByIndex);
            if (this.model.selectedIndex == 0) this.selectItemByIndex(this.model.selectedIndex);
            else this.model.selectedIndex && this.selectItemByIndex(this.model.selectedIndex);
            this.selectItemsByIndices(this.model.selectedIndices);
            this.checkItemsByIndices(this.model.checkedIndices);
            this._tooltipList();
            return this;
        },
        _tooltipList: function(){
             if (this.listContainer.find('li').hasClass('e-tooltip')){
                $(this.listContainer).ejTooltip({
                    target: ".e-tooltip",
                    isBalloon: false,
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    }
                });
            }
       },
        _cascadeAction: function () {
            if (this.model.cascadeTo) {
                this._currentValue = this._getField(this.listitems[this._activeItem], this.mapFld._value);
                this.selectDropObj = $('#' + this.model.cascadeTo).ejListBox('instance');
                 $.extend(true, this.selectDropObj, { _isCasCadeTarget: true });
                if (ej.isNullOrUndefined(this._dSource))
                    this._dSource = this.selectDropObj.dataSource();
                this._performJsonDataInit();
			     var args = { cascadeModel: this.selectDropObj.model, cascadeValue: this._currentValue, setCascadeModel:{}, requiresDefaultFilter: true };
                this._trigger("cascade", args);	
                this.selectDropObj._setCascadeModel = args.setCascadeModel;				
            }
        },
        _performJsonDataInit: function () {
            this._changedSource = ej.DataManager(this._dSource).executeLocal(ej.Query().where(this.mapFld._value, "==", this._currentValue));
            this.selectDropObj.setModel({
                dataSource: this._changedSource,
                enable: true,
                value: "",
                selectedIndex: -1                
            })
        },
        _OnMouseContext: function (e) {
            e.preventDefault();
            return false
        },
        _OnMouseEnter: function (e) {
            this.startime = 0;
            this.item = "";
            if (e.type == "touchstart") {
                this.item = $(e.target).text();
                this.startime = new Date().getTime()
            }
            if (this.model.enabled) {
                var targetEle;
                this.element.children("li").removeClass("e-hover");
                if ($(e.target).is("li")) $(e.target).addClass("e-hover");
                if ($(e.target).hasClass("e-disable")) $(e.target).removeClass('e-hover');
                else if (e.target.tagName != "li") {
                    targetEle = $(e.target).parents("li");
                    $(targetEle).addClass("e-hover")
                }
                var activeItem, selectItem = 0;
                this.element.children("li:not('.e-ghead')").each(function (index) {
                    if ($(this).hasClass("e-hover")) {
                        activeItem = index;
                        return false
                    }
                });
                this._hoverItem = activeItem
            }
        },
        _OnMouseLeave: function (e) {
            this.element.children("li").removeClass("e-hover");
            this.endtime = new Date().getTime();
            if ((((this.endtime - this.startime) / 200) > 2))
                if ((this.item == $(e.target).text())) this.hold = (((this.endtime - this.startime) / 200) > 2) ? !this.hold : false;
        },
        _OnMouseClick: function (e) {
            if($(e.currentTarget).hasClass("e-disable")) return false;
            if (e.which == 3)
                this.hold = true;
            this.endtime = new Date().getTime();
            if ((((this.endtime - this.startime) / 200) > 2))
                if ((!this.model.template && this.item == $(e.target).text()) && (!this.hold))
                    this.hold = (((this.endtime - this.startime) / 200) > 2);
            if (e.shiftKey && this._shiftkey) {
                this._shiftkey = false;
                this.prevselectedItem = this._activeItem;
            }
            if (!ej.isNullOrUndefined(this._hoverItem)) this._activeItem = this._hoverItem;
            if (this.model.enabled && this._activeItem != undefined) {
                if (!e.shiftKey || isNaN(this.prevselectedItem)) {
                    this._shiftkey = true;
                    this.prevselectedItem = this._lastEleSelect ? this._lastEleSelect : this._activeItem;                    
                }
                if (isNaN(this._lastEleSelect) || (this._lastEleSelect != this._activeItem)) {
                    var selectData = this._getItemObject($(this.element.find("li:not('.e-ghead')")[this.prevselectedItem]), e);
                    selectData["isInteraction"] = true;
                    this._trigger('change', selectData);
                }
                if (!this.model.showCheckbox) {
                    var activeitem = $(this.element.children("li:not('.e-ghead')")[this._hoverItem]);
                    if (!this.model.allowMultiSelection || (!(e.ctrlKey || this.touchhold || this.hold) && !e.shiftKey))
                        this._removeListHover();
                    this.element.children("li").removeClass('e-hover');
                    if (!activeitem.hasClass('e-select') ||(e.shiftKey && this.model.allowMultiSelection)) {
                        activeitem.addClass('e-select');
                        this._selectedItems.push(activeitem);
                        this.model.selectedIndices.push(this._activeItem);
                        if (e.shiftKey && (this.model.allowMultiSelection)) {
                            if (!e.ctrlKey) this._removeListHover();
                            var initial, last;
                            if (this.prevselectedItem < this._activeItem)
                                initial = this.prevselectedItem, last = this._activeItem;
                            else
                                initial = this._activeItem, last = this.prevselectedItem;
                            this._activeItemLoop(initial,last);
                        }
                    } else {
                        activeitem.removeClass('e-select');
                        this._selectedItems.splice(this.model.selectedIndices.indexOf(this._activeItem), 1);
                        this.model.selectedIndices.splice(this.model.selectedIndices.indexOf(this._activeItem), 1);
                    }
                    this._selectedItem = this._selectedIndices();
                    this.model.selectedIndex = this._activeItem;
                    this._cascadeAction();
                    var selecteditem = $(this.element.children("li:not('.e-ghead')")[this._selectedItem]);
                    if ($(selecteditem).text() != "") {
                        this.element.val($(selecteditem).text());
                        this.element.attr({
                            "value": this.element.val()
                        });
                    }
                    this.model.selectedText = activeitem.text();
                    this._selectedData = this._getItemObject($(selecteditem), e);
                    this._selectedData["isInteraction"] = true;
                    if (this._prevSelectedData && (this._selectedData.text != this._prevSelectedData.text))
                        this._trigger("unselect", this._prevSelectedData)
                    this._trigger("select", this._selectedData);
                    this._prevSelectedData = this._selectedData;
                    this._lastEleSelect = this._activeItem;
                    if (this._selectedItems && this._selectedItems.length != 1)
                        this._ctrlClick = true;
                } else {
                    if (($(e.currentTarget).is("li")) && ($(e.target).is("li"))) {
                        if ($(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('isChecked')) {
                            $(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', false);
                            var index = this.model.checkedIndices.indexOf($(e.currentTarget).index());
                            this._checkedItems.splice(index, 1);
                            this.model.checkedIndices.splice(index, 1);
                            this.checkedStatus = false;
                        } else {
                            $(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                            this._checkedItems.push(this._activeItem);
                            this.model.checkedIndices.push(this._elementIndex(e.currentTarget));
                            this.checkedStatus = true;
                        }
                    }
                    else if (($(e.currentTarget).is("li")) && ($(e.target).is("span"))) {
                        if ($(e.currentTarget.firstChild).find('.listcheckbox').ejCheckBox('isChecked')) {
                            this._checkedItems.push(this._activeItem);
                            this.model.checkedIndices.push($(e.currentTarget).index());
                            this.checkedStatus = true;
                        }
                        else {
                            var index = this.model.checkedIndices.indexOf($(e.currentTarget).index());
                            this._checkedItems.splice(index, 1);
                            this.model.checkedIndices.splice(index, 1);
                            this.checkedStatus = false;
                        }
                    }
                    else
                        return false;
                    this.selectedTextValue = $(e.currentTarget).text();
                    if (!this.element.hasClass("e-disable") && $(e.target).is("li")) {
                        var args = {
                            status: this.model.enabled,
                            isChecked: this.checkedStatus,
                            selectedTextValue: this.selectedTextValue
                        };
                        var checkData = this._getItemObject($(e.target), e);
                        checkData["isInteraction"] = true;
                        this._trigger("checkChange", checkData);
                    }
                    this._lastEleSelect = $(e.currentTarget).index();
                }
                if (e.ctrlKey || e.shiftKey) e.shiftKey ? (this._shiftSelectItem = this._activeItem, this._ctrlSelectItem = null)  : (this._ctrlSelectItem = this._activeItem, this._shiftSelectItem = null);
                else {
                    this._shiftSelectItem = null;
                    this._ctrlSelectItem = null;
                }
                this._setSelectionValues()._OnListSelect(this.prevselectedItem, this._activeItem);
            }
            if (e.target.nodeName != "INPUT")
                this.listContainer.focus();
			this._pageUpStep = this._pageDownStep = null;
        },
		_activeItemLoop: function (initial , last) {
		    if (this.model.showCheckbox) {
		        var items = this.listContainer.find('li:not(.e-disable)');
		        items.find(".listcheckbox").ejCheckBox('option', 'checked', false);
				this._checkedItems = [];
                this.model.checkedIndices = [];
			}
			for (var i = initial; i <= last; i++) {
			    if (this.model.showCheckbox && !this.listContainer.find('li').eq(i).hasClass('e-disable')) {
					this.element.find('.listcheckbox').eq(i).ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(i);
                    this.model.checkedIndices.push(i);
                    this.checkedStatus = true;
                }
				else {
			        activeitem = $(this.element.children("li:not('.e-ghead')")[i]);
                    if (!activeitem.hasClass('e-disable')) {
                        if (!activeitem.hasClass('e-select')) activeitem.addClass('e-select');
                        this._selectedItems.push(activeitem);
                        this.model.selectedIndices.push(i);
                    }
                }
            }
		},
        _setSelectionValues: function () {
            var selectionArray = [];
            var oldSelectedIndices = this.model.selectedIndices;
            var oldCheckedIndices = this.model.checkedIndices;
            this.model.selectedIndices = [];
            this.model.checkedIndices = [];
            var proxy = this;
            if (!this.model.showCheckbox) {
                if (!ej.isNullOrUndefined(this._activeItem) && this._activeItem >= 0) this.model.selectedIndex = this._activeItem;
                var liItem = this.element.children("li:not('.e-ghead')");
                this.element.children("li:not('.e-ghead').e-select").each(function (index, ele) {
                    selectionArray.push($(ele).attr("value") ? $(ele).attr("value") : !ej.isNullOrUndefined(proxy.model.fields.text) && proxy.dataSource() ? proxy.getListData()[proxy._elementIndex(ele)][proxy.model.fields.text] : $(ele).text());
                    proxy.model.selectedIndices.push(liItem.index(ele));
                });
            }
            else {
                this.element.find("li:not('.e-ghead') .listcheckbox:checked").closest('li').each(function (index, ele) {
                    selectionArray.push($(ele).attr("value") ? $(ele).attr("value") : !ej.isNullOrUndefined(proxy.model.fields.text) && proxy.dataSource() ? proxy.getListData()[proxy._elementIndex(ele)][proxy.model.fields.text] : $(ele).text());
                    proxy.model.checkedIndices.push(proxy._elementIndex(ele));
                });
            }
            if (ej.DataManager && ej.DataManager && this.dataSource() instanceof ej.DataManager && this.model.allowVirtualScrolling) {
                if (this.model.showCheckbox) {
                    for (var i = 0; i < oldCheckedIndices.length; i++) {
                        if (this.model.checkedIndices.indexOf(oldCheckedIndices[i]) == -1)
                            this.model.checkedIndices.push(oldCheckedIndices[i]);
                    }
                }
                else {
                    for (var i = 0; i < oldSelectedIndices.length; i++) {
                        if (this.model.selectedIndices.indexOf(oldSelectedIndices[i]) == -1)
                            this.model.selectedIndices.push(oldSelectedIndices[i]);
                    }
                }
            }
            this.model.selectedItemIndex = this.model.selectedIndex;
            this.model.selectedItems = this.model.selectedItemlist = this.model.selectedIndices;
            this.model.checkedItems = this.model.checkedItemlist = this.model.checkItemsByIndex = this.model.checkedIndices;
			this.model.text = "";
			if(this.model.showCheckbox){
               var checked = this.getCheckedItems();
				for(i = 0;i < checked.length;i++){			
				         this.model.text +=  checked[i].text + ","
			        }
			}else{
                var selected = this.getSelectedItems();
				for(i = 0;i < selected.length;i++){			
				         this.model.text +=  selected[i].text + ","
			        }	
			}
            this.value(selectionArray.toString());
            this._hiddenInput.val(this.value());
            return this;
        },
        _setDisableValues: function () {
            this._disabledItems = [];
            this.model.disableItemsByIndex = [];
            var lenth = this.element.children().length, indx;
            for (var indx = 0; indx < lenth; indx++)
                if ($(this.element.children()[indx]).hasClass('e-disable'))
                    this.model.disableItemsByIndex.push(indx);
            this.disableItemsByIndices(this.model.disableItemsByIndex);
        },
        _onClickCheckList: function (e) {
			if(!e.isChecked) $("#"+ e.model.id).closest('li').removeClass("checkItem");
            if (e.isInteraction) {
                this.checkedStatus = e.isChecked ? true : false;
                if (!this._initValue) {
                    this.checkedStatus ? this.model.checkedIndices.push($(e.event.target).closest('li:not(".e-ghead")').index()) : this.model.checkedIndices.splice($.inArray($(e.event.target).closest('li:not(".e-ghead")').index(), this.model.checkedIndices), 1);
                    var checkData = this._getItemObject($(e.event.target).closest('li'), e);
                    checkData["isInteraction"] = true;
                    this._trigger('checkChange', checkData);
                }
            }
        },
		_elementIndex: function (args) {
		    return $(args).parent().children("li:not('.e-ghead')").index(args);
		},
        _disableItemSelectCommon: function () {
            this.listitems = this.element.find('li');
            this._activeItem = this.listitems.index(this.element.find(".e-select"));
        },

        _disableItemSelectUp: function () {
            this._disableItemSelectCommon();
            var disableList = (typeof (this.model.disableItemsByIndex) != "object") ? this.model.disableItemsByIndex.split(",").sort().reverse() : this.model.disableItemsByIndex;
            if (this._activeItem == 0) this._activeItem = this.listitems.length - 1;
            else this._activeItem--;
            for (var lists = 0;
                ($.inArray(this._activeItem.toString(), disableList.toString())) > -1; lists++) {
                this._activeItem--;
                if (this._activeItem < 0) this._activeItem = this.listitems.length - 1
            }
            $(this.element.children("li")[this._activeItem]).addClass('e-select')
        },
        _disableItemSelectDown: function () {
            this._disableItemSelectCommon();
            var disableList = (typeof (this.model.disableItemsByIndex) != "object") ? this.model.disableItemsByIndex.split(",").sort() : this.model.disableItemsByIndex;
            ((this.listitems.length - 1) == this._activeItem) ? this._activeItem = 0 : this._activeItem++;
            for (var lists = 0;
                ($.inArray(this._activeItem.toString(), disableList.toString())) > -1; lists++) {
                this._activeItem++;
                if ((this.listitems.length) == this._activeItem) this._activeItem = 0
            }
            $(this.element.children("li")[this._activeItem]).addClass('e-select')
        },
        _checkitems: function () {
            if (this.model.showCheckbox) {
                var listitems = this.element.find("li:not('.e-ghead')");
                for (i = 0; i < this.model.checkedIndices.length; i++) {
                    var item = this.model.checkedIndices[i];
                    $(listitems[item]).find('.listcheckbox').ejCheckBox('option', 'checked', true);
                    this._checkedItems.push(listitems[item])
                }
            } else {
                if (this.model.allowMultiSelection) {
                    for (i = 0; i < this.model.selectedIndices.length; i++) {
                        var item = this.model.selectedIndices[i];
                        if (!($(this.listitem[item]).hasClass("e-select"))) {
                            $(this.listitem[item]).addClass("e-select");
                            this._selectedItems.push($(this.listitem[item]));
                        }
                    }
                } else {
                    if (!($(this.listitem[this.model.selectedIndex]).hasClass("e-select")))
                        $(this.listitem[this.model.selectedIndex]).addClass("e-select");
                    this._selectedItems.push($(this.listitem[this.model.selectedIndex]))
                }
            }
            this._setSelectionValues();
            return this;
        },

        _onlistselection: function (previtem, selecteditem, e) {
            if (previtem != selecteditem) {
                var selectData = this._getItemObject($(this.element.find("li:not('.e-ghead')")[selecteditem]), e);
                selectData["isInteraction"] = true;
                this._trigger('change', selectData);
            }
        },

        _OnListSelect: function (previtem, selecteditem, e) {
            if (!ej.isNullOrUndefined(previtem) && previtem != selecteditem && !this.model.showCheckbox) {
                var selectData = this._getItemObject($(this.element.find("li:not('.e-ghead')")[selecteditem]), e);
                selectData["isInteraction"] = true;
                this._trigger('change', selectData);
            }
        },
        _OnKeyDown: function (e) {
            if (this.model.enabled) {
                if (this._selectedItems && this._selectedItems.length == 1 && !this.model.showCheckbox)
                    this._lastEleSelect = $(this.element.children("li.e-select")).index();
                this._itemId = null;
                var _ListItemsContainer = this.element.children("li:not('.e-ghead')"), proxy = this, liH, popupH, activeitem;
                popupH = this.listContainer.height();
                liH = _ListItemsContainer.outerHeight();
                activeitem = Math.round(popupH / liH) != 0 ? Math.floor(popupH / liH) : 7;
                this._listSize = this.element.children("li").length;
                if (!e.shiftKey) this._up = this._down;
				if(e.keyCode != 33 && e.keyCode != 34) this._pageUpStep = this._pageDownStep = null;
                switch (e.keyCode) {
                    case 37:
                    case 38:
                        var liItems = this.listItemsElement;
                        var selectedIndex = this._shiftSelectItem ? this._shiftSelectItem : this._ctrlSelectItem ? this._ctrlSelectItem : (this.model.showCheckbox) ? (this._lastEleSelect || 0) : liItems.index(this.element.find("li.e-select"));
                        if (e.shiftKey && this.model.allowMultiSelection && !this.model.showCheckbox) {
                            if (this._lastEleSelect == 0) return false;
                            this._lastEleSelect = (this._ctrlClick) ? this._lastEleSelect - 1 : this._lastEleSelect;
                            selectedIndex = this._lastEleSelect;
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == 0 ? this._listSize - 1 : (this._down ? selectedIndex : selectedIndex - 1)) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i--)
                                this._selectedItem -= 1;
                            if($(_ListItemsContainer[this._selectedItem]).hasClass("e-select") && this.element.find("li.e-select").length == 1) this._selectedItem -= 1;
                            var activeItem = $(_ListItemsContainer[this._selectedItem]);
                            if (activeItem.hasClass("e-select")) {
                                if (this._selectedItem == 0) return;
                                activeItem.removeClass("e-select");
                                this._selectedItems.pop();
                            }
                            else {
                                activeItem.addClass("e-select");
                                this._selectedItems.push(activeItem);
                            }
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                            this._up = true;
                            this._down = false;
                            this._ctrlClick = false;
                        }
                        else {
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == 0 ? this._listSize - 1 : selectedIndex - 1) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i--)
                                this._selectedItem -= 1;
                            if (this._selectedItem == -1) this._selectedItem = this._listSize - 1;
                            this._addSelectedItem(e);
                            $(_ListItemsContainer).removeClass("e-hover e-select");
                            var addClass = (this.model.showCheckbox) ? "e-hover" : "e-select";
                            $(_ListItemsContainer[this._selectedItem]).addClass(addClass);
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                        }
						this._activeItem = this.prevselectedItem = this._selectedItem;
                        this._OnListSelect(this._selectedItem + 1, this._selectedItem, e);
                        this._lastEleSelect = this._selectedItem;
                        this._keyCascade(_ListItemsContainer[this._selectedItem]);
                        this._setSelectionValues();
                        this._shiftSelectItem = this._ctrlSelectItem = null;
                        e.preventDefault();
                        return false;
                        break;
                    case 39:
                    case 40:
                        var liItems = this.listItemsElement;
                        var selectedIndex = this._shiftSelectItem ? this._shiftSelectItem : this._ctrlSelectItem ? this._ctrlSelectItem : (this.model.showCheckbox) ? (this._lastEleSelect || 0) : liItems.index(this.element.find("li.e-select"));
                        if (e.shiftKey && this.model.allowMultiSelection && !this.model.showCheckbox) {
                            if (this._lastEleSelect == this._listSize - 1) return false;
                            this._lastEleSelect = (this._ctrlClick) ? this._lastEleSelect + 1 : this._lastEleSelect;
                            selectedIndex = this._lastEleSelect;
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == this._listSize - 1 ? 0 : ((this._up || this._ctrlClick) ? selectedIndex : selectedIndex + 1)) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i++)
                                this._selectedItem += 1;
							if($(_ListItemsContainer[this._selectedItem]).hasClass("e-select") && this.element.find("li.e-select").length == 1) this._selectedItem += 1;		
                            var activeItem = $(_ListItemsContainer[this._selectedItem]);
                            if (activeItem.hasClass("e-select")) {
                                activeItem.removeClass("e-select");
                                this._selectedItems.pop();
                            }
                            else {
                                activeItem.addClass("e-select");
                                this._selectedItems.push(activeItem);
                            }
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
                            this._up = false;
                            this._down = true;
                            this._ctrlClick = false;
                        }
                        else {
                            this._selectedItem = (selectedIndex || selectedIndex == 0) ? (selectedIndex == this._listSize - 1 ? 0 : selectedIndex + 1) : 0;
                            for (var i = this._selectedItem; $(_ListItemsContainer[i]).hasClass("e-disable") ; i++)
                                this._selectedItem += 1;
                            if (this._selectedItem == this._listSize) this._selectedItem = 0;
                            this._addSelectedItem(e);
                            $(_ListItemsContainer).removeClass("e-hover e-select");
                            var addClass = (this.model.showCheckbox) ? "e-hover" : "e-select";
                            $(_ListItemsContainer[this._selectedItem]).addClass(addClass);
                            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(this._selectedItem) });
							this.element.find("li").removeClass("selectItem");
							this.model.selectedIndices.length = 0;
							this.model.selectedIndices.push(this._selectedItem);
                        }
						this._activeItem = this.prevselectedItem = this._selectedItem;
                        this._OnListSelect(this._selectedItem - 1, this._selectedItem);
                        this._lastEleSelect = this._selectedItem;
                        this._keyCascade(_ListItemsContainer[this._selectedItem]);
                        this._setSelectionValues();
                        this._shiftSelectItem = this._ctrlSelectItem = null;
                        return false;
                        break;
                    case 8:
                    case 9:
                    case 13:
                        if (this.model.showCheckbox) {
                            if (this.model.checkedIndices.indexOf(this._selectedItem) < 0)
                                this.checkItemByIndex(this._selectedItem);
                            else
                                this.uncheckItemByIndex(this._selectedItem);
                        }
                        break;
                    case 18:
                    case 33: /* page up */
                        var step = e.keyCode == 33 ? activeitem : 1;
						if (e.shiftKey && this.model.allowMultiSelection) { 
							if(this._pageUpStep == null) this._pageUpStep = this.prevselectedItem;
							if(this._pageDownStep == null) this._pageDownStep = this.prevselectedItem;
							if(this._pageDownStep <= this.prevselectedItem) {
								start = this._pageUpStep - step > 0  ? this._pageUpStep - step : 0;
								end = this._pageDownStep;
							}
							else {
								start = this.prevselectedItem;
								end = this._pageDownStep - step > this.prevselectedItem  ? this._pageDownStep - step : this.prevselectedItem;
							}
							this._shiftHomeAndEndKeyProcess( start,end, end > this.prevselectedItem ? end:start);
							this._pageUpStep = start;
							this._pageDownStep =end;
						}
                        else this._moveUp(this._activeItem, step);
					    this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
                        this._preventDefaultAction(e);
                        break;
                    case 34: /* page down */
                        var step = e.keyCode == 34 ? activeitem : 1;
                        if (e.shiftKey && this.model.allowMultiSelection){
                            if(this._pageUpStep == null) this._pageUpStep = this.prevselectedItem;
                            if(this._pageDownStep == null) this._pageDownStep = this.prevselectedItem;
                            if( this._pageUpStep == 0 && this.prevselectedItem != 0) { 
								if( this._pageUpStep + step >= this.prevselectedItem) start = end = this.prevselectedItem;
								else {
									start = this._pageUpStep + step ;
									end = this._pageDownStep + step < this.element.children("li").length ?  this._pageDownStep + step : this.element.children("li").length-1;
                               }
                            }
                            else if(this._pageUpStep != this.prevselectedItem && this._pageUpStep + step >= this.prevselectedItem) start = end = this.prevselectedItem;
                            else {
                                start = this._pageUpStep;
                                end = this._pageDownStep + step < this.element.children("li").length ?  this._pageDownStep + step : this.element.children("li").length-1;
                            }
                            if(start < this.prevselectedItem && end > this.prevselectedItem ) end = this.prevselectedItem;
                            this._shiftHomeAndEndKeyProcess(start,end, start < this.prevselectedItem ? start:end);
                            this._pageUpStep = start;
                            this._pageDownStep =end;
                        } 
                        else this._moveDown(this._activeItem, step);
						this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop() });
                        this._preventDefaultAction(e);
                        break;
                    case 35:
                        if (e.shiftKey && this.model.allowMultiSelection) this._shiftHomeAndEndKeyProcess(this._activeItem,(this._listSize - 1) , (this._listSize - 1));
                        else this._homeAndEndKeyProcess(e, _ListItemsContainer, (this._listSize - 1));
                        for (var i = this._listSize - 1; i > 0; i--) {
                            if (!$(this.element.find('li')[i]).hasClass('e-disable')) {
                                this.model.selectedIndex = i;
                                this._shiftSelectItem = i;
                               if (this.model.allowVirtualScrolling == true) proxy._onScroll(e);
                                return false;
                            }
                        }
                    break;
                case 36:
                    if (e.shiftKey && this.model.allowMultiSelection) this._shiftHomeAndEndKeyProcess(0, this._activeItem, 0);
                    else this._homeAndEndKeyProcess(e, _ListItemsContainer, 0);
                    for (var i = 0; i < this._listSize; i++) {
                        if (!$(this.element.find('li')[i]).hasClass('e-disable')) {
                            this.model.selectedIndex = i;
                            return false;
                        }
                    }
                    break;
                }
            }
        },
        _moveUp: function (current, step) {
            if (current == null || current <= 0)  this._checkDisableStep(0, step, false);
            else if (current > this._listSize - 1) this._checkDisableStep(this._listSize - 1, step, false);
            else if (current > 0 && current <= this._listSize - 1) this._checkDisableStep(current, step, false);
        },
        _moveDown: function (current, step) {
            if (current == null || current < 0) this._checkDisableStep(-1, step, true);
            else if (current == 0)  this._checkDisableStep(0, step, true);
            else if (current >= this._listSize - 1) this._checkDisableStep(this._listSize - 1, step, true);
            else if (current < this._listSize - 1)  this._checkDisableStep(current, step, true);
        },
        _checkDisableStep: function (current, step, isdown, shift) {
            var command = isdown ? "_disableItemSelectDown" : "_disableItemSelectUp";
            var index = isdown ? current + step : current - step;
            var select = this[command](index);
            if (select == null) {
                for (var i = step; i >= 0; i--) {
                    index = isdown ? current + i : current - i;
                    select = this[command](index);
                    if (select != null) break;
                }
            }
            if (select != null)
                this.selectItemByIndex(select);
        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) 
                    return current;
                else
                    return this._disableItemSelectDown(current + 1);
            }
            else return this._listSize - 1;
        },

        _disableItemSelectUp: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) 
                    return current;
                else {
                    if (current > 0) 
                        return this._disableItemSelectUp(current - 1);
                }
            }
        },

        _preventDefaultAction: function (e, stopBubble) {
            e.preventDefault ? e.preventDefault() : (e.returnValue = false);
            if (stopBubble) 
                e.stopPropagation ? e.stopPropagation() : (e.cancelBubble = true);
        },
        _homeAndEndKeyProcess: function (e, _ListItemsContainer, index) {
            if ($(':focus').length && $(':focus')[0].nodeName != "INPUT") {
                this._OnListSelect(this._selectedItem, index);
                this.selectItemByIndex(index);
                this._selectedItem = index;
                this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(index) });
                if (this.model.showCheckbox) {
                    this._removeListHover();
                    $(_ListItemsContainer[index]).addClass("e-hover");
                    this._lastEleSelect = this._selectedItem = index;
                }
                this._keyCascade(_ListItemsContainer[index],e);
                e.preventDefault();
                return false;
            }
        },
        _shiftHomeAndEndKeyProcess: function(initial , last , index) {
			this._removeListHover();
			this._activeItemLoop(initial ,last);
			this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop(index) });
            return false;
		},
        _keyCascade: function (obj, evt) {
            var selectData = this._getItemObject($(obj), evt);
            this.model.selectedText = selectData.text;
            selectData["isInteraction"] = true;
            this._trigger("select", selectData);
            if (this.model.cascadeTo) {
                this._activeItem = this._selectedItem;
                this._cascadeAction();
            }
        },

        mergeData: function (data,skipInitial) {
            this.datamerged=true;
            this.mergeUl = $();
            this._setMapFields();
            var proxy = this;
            this._skipInitialRemoteData = skipInitial ? skipInitial : false;
            if (ej.DataManager && data instanceof ej.DataManager) {
                var queryPromise = data.executeQuery(this._getQuery());
                queryPromise.done(function (e) {
                    proxy.mergeValue = e.result;
                    proxy._renderlistContainer();
                });
            }
            else {
                this.mergeValue = data;
                if(!ej.isNullOrUndefined(this.model.fields.groupBy) && this.datamerged && this.groupData)
                 this.listitems= this.listitems[0].items ? this.listitems[0].items:this.dataSource();
                else{
                this.groupData = true;
                this.listitems = this.listitems ? this.listitems : this.dataSource();
                }
                this._renderlistContainer();
            }
            this._loadInitialRemoteData = false;
        },

        _onScroll: function (e) {
            if (!e.scrollTop) return;
            var scrollerPosition = e.scrollTop, proxy = this;
            if (this.model.actionBegin)
                this._trigger("actionBegin", {});
            this.realUllength = this.element.find('li').length;
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                if(e.scrollTop!= e.scrollData.scrollOneStepBy + e.scrollData.scrollable){
                window.setTimeout(function () {
                    if (proxy._virtualCount == 0) {
                        proxy._loadVirtualList();
                    }
                }, 300);
            }
            }
            else if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "continuous") {
                if (scrollerPosition >= Math.round($(this.listContainer).find("ul").height() - $(this.listContainer).height()) && this.listitems.length < this._totalCount) {
                    this._updateLoadingClass(true);
                    if (ej.DataManager && this.model.dataSource instanceof ej.DataManager) {
                        this._queryPromise(this.realUllength, proxy, this.realUllength + this.model.itemRequestCount, e);
                    }
                }
            }
        },
        _queryPromise: function (start, proxy, end, e) {
            this._trigger('itemRequest', { event: e, isInteraction: true });
            this._setMapFields();
            var mQuery = this._savedQueries.clone();
            var queryPromise = this.dataSource().executeQuery(mQuery.range(start, end));
            this._updateLoadingClass(true);
            queryPromise.done(function (d) {
			    proxy._trigger("actionBeforeSuccess", d);
                proxy.realUllength = (e.source != "wheel") ? proxy.mergeValue ? proxy.mergeValue.length + start : start : start;
                proxy._loadlist(d.result)._checkboxHideShow(proxy.model.showCheckbox)._showResult()._updateLoadingClass();
                proxy._applySelection();
                if (proxy.model.virtualScrollMode == "continuous") {
                    proxy.scrollerObj.refresh();
                }
                proxy._trigger("actionSuccess", d);
            }).fail(function (e) {
                proxy._trigger("actionFailure", e);
            }).always(function (e) {
                proxy._trigger("actionComplete", e);
            });
        },
        _loadVirtualList: function () {
            this._virtualCount++;
            this._getLiHeight();
            var top = this.scrollerObj.scrollTop(), proxy = this, prevIndex = 0, prevPageLoad, nextIndex = null;
            this._currentPageindex = Math.round(top / (this._liItemHeight * this.model.itemRequestCount));
            if (($.inArray(this._currentPageindex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) {
                if (this._currentPageindex == 0) {
                    if (($.inArray(this._currentPageindex + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPageindex = this._currentPageindex + 1;
                    }
                }
                else if (($.inArray(this._currentPageindex - 1, this._virtualPages)) != -1) {
                    if (($.inArray(this._currentPageindex + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPageindex = this._currentPageindex + 1;
                    }
                }
                else {
                    this._currentPageindex = this._currentPageindex - 1;
                }
            }
            prevPageLoad = !($.inArray(this._currentPageindex - 1, this._virtualPages) != -1);
            this._updateLoadingClass(true);
            for (var i = this._virtualPages.length - 1; i >= 0; i--) {
                if (this._virtualPages[i] < this._currentPageindex) {
                    prevIndex = this._virtualPages[i];
                    if (!(i + 1 == this._virtualPages.length))
                        nextIndex = this._virtualPages[i + 1];
                    break;
                }
            }
            var firstArg = prevPageLoad ? (this._currentPageindex - 1) * this.model.itemRequestCount : this._currentPageindex * this.model.itemRequestCount;
            var skipQuery = ej.Query().range(firstArg, this._currentPageindex * this.model.itemRequestCount + this.model.itemRequestCount), queryPromise, list;
            if (ej.DataManager) {
                var skipParam = prevPageLoad ? (this._currentPageindex - 1) * this.model.itemRequestCount : this._currentPageindex * this.model.itemRequestCount;
                if(this.dataSource().dataSource.offline == true)
                    skipQuery = ej.Query().skip(skipParam).take(this.model.itemRequestCount);
                else 
                    skipQuery = this._getQuery().skip(skipParam);
                if (prevPageLoad) {
                    for (i = 0; i < skipQuery.queries.length; i++) {
                        if (skipQuery.queries[i].fn == "onTake") {
                            skipQuery.queries.splice(i, 1);
                            break;
                        }
                    }
                    skipQuery.take(2 * this.model.itemRequestCount);
                }
                if (!proxy._trigger("actionBegin")) {
                    queryPromise = proxy._dataUrl.executeQuery(skipQuery);
                    queryPromise.done(function (e) {
                        proxy._appendVirtualList(e.result, prevIndex, proxy._currentPageindex, nextIndex, prevPageLoad);
                        proxy._trigger("actionSuccess", { e: e });
                    }).fail(function (e) {
                        proxy._virtualCount--;
                        proxy._trigger("actionFailure", { e: e });
                    }).always(function (e) {
                        proxy._updateLoadingClass(false);
                        proxy._trigger("actionComplete", { e: e });
                    });
                }
            } 
            else {
                list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                this._appendVirtualList(list, prevIndex, this._currentPageindex, nextIndex, prevPageLoad);
                this._updateLoadingClass(false);
            }
        },

        _appendVirtualList: function (list, prevIndex, currentIndex, nextIndex, prevPageLoad) {
            this._virtualCount--;
            this._getLiHeight();
            if (($.inArray(currentIndex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) return false;
            if (prevPageLoad && ($.inArray(currentIndex - 1, this._virtualPages.sort()) != -1)) {
                list.splice(0, this.model.itemRequestCount);
                prevPageLoad = false;
            }
            var items = this.model.itemRequestCount, tempUl = $("<ul>"), firstVirtualHeight, secondVirtualHeight;
            firstVirtualHeight = prevPageLoad ? ((currentIndex - 1) * items * this._liItemHeight) - (prevIndex * items + items) * this._liItemHeight : (currentIndex * items * this._liItemHeight) - (prevIndex * items + items) * this._liItemHeight;
            if (firstVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: firstVirtualHeight }));
            this._loadlist(list);
            $(this._dummyVirtualUl).attr("data-ej-page", currentIndex);
            if (prevPageLoad) {
                $(this._dummyVirtualUl).slice(0, items).attr("data-ej-page", currentIndex - 1);
            }
            tempUl.append(this._dummyVirtualUl);
            var ulItems = this.element;
            secondVirtualHeight = (currentIndex * items + items) * this._liItemHeight;
            if (nextIndex != null) secondVirtualHeight = (nextIndex * items * this._liItemHeight) - secondVirtualHeight;
            else secondVirtualHeight = ulItems.height() - secondVirtualHeight;
            if (secondVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: secondVirtualHeight }));
            var selector = ulItems.find("li[data-ej-page=" + prevIndex + "]").last();
            selector.next().remove();
            tempUl.children().insertAfter(selector);
            if(this.model.showCheckbox) this._checkboxHideShow(true);
            this._virtualPages.push(currentIndex);
            if (prevPageLoad) this._virtualPages.push(currentIndex - 1);
            this._virtualUl = ulItems.clone(true);
            this._showResult();
            this._addDragableClass()._enableDragDrop();
        },

        _selectListItems: function () {
            var listItems = this.element.find("li:not('.e-ghead')");;
            for (var i = 0; i < listItems.length; i++) {
                if ($(listItems[i]).hasClass('selectItem') && !$(listItems[i]).hasClass('e-select'))
                    $(listItems[i]).addClass("e-select").removeClass('selectItem');
            }
        },
        _setText: function (text) {
            for (i = 0; i < this.listitems.length; i++)
                if ($(this.element.children("li")[i]).text() == text) this.unselectAll().selectItemByIndex(i);
        },
        _getLiCount: function () {
            return parseInt(this.listContainer.height() / this.listItemsElement.height());
        },
        _onDragStarts: function (data, target) {
            return this._trigger("itemDragStart", { items: data, target: target });
        },
        _onDrag: function (data, target) {
            return this._trigger("itemDrag", { items: data, target: target });
        },
        _onDragStop: function (data, target) {
            return this._trigger("itemDragStop", { items: data, target: target });
        },
        _onDropped: function (data, target) {
            data = { droppedItemText: data[0].text, droppedItemValue: data[0].value, droppedItemIsChecked: data[0].isChecked, droppedElementData: data[0], dropTarget:[data[1].target],event:data[1].event};
            return this._trigger("itemDrop",data);
        },
        _OnKeyPress: function (e) {
            if (this.model.enableIncrementalSearch && this.model.enabled) {
                this._incrementalSearch(this._isMozilla ? e.charCode : e.keyCode)
            }
        },
        _incrementalSearch: function (from) {
            _proxy = this;
            var typedCharacter = String.fromCharCode(from);
            if (this._incqueryString != typedCharacter) this._incqueryString += typedCharacter;
            else this._incqueryString = typedCharacter;
            if ((this._incqueryString.length > 0) && (this._typeInterval == null)) {
                this._typeInterval = setTimeout(function () {
                    _proxy._incqueryString = "";
                    _proxy._typeInterval = null
                }, _proxy._typingThreshold)
            }
            var list = this.listContainer.find("ol,ul").children("li:not('.e-ghead')"),
                i, strlen;
            var caseSence = this.model.caseSensitiveSearch,
                str, queryStr = this._incqueryString;
            var querylength = this._incqueryString.length,
                searchflag = false;
            if (!caseSence) queryStr = queryStr.toLowerCase();
            var initialSelection = this._activeItem;
            --initialSelection;
            var startIndex = this._activeItem != list.length - 1 ? (this._activeItem + 1) : 0;
            if (this._incqueryString.length > 1) startIndex = this._activeItem;
            for (var i = startIndex;
                (i < list.length && initialSelection != i) ; i++) {
                str = $.trim($(list[i]).text());
                str = caseSence ? str : str.toLowerCase();
                if (str.substr(0, querylength) === queryStr) {
                    this._removeListHover();
                    this.element.children("li").removeClass('e-active');
                    this._selectedItem = i;
                    this._addListHover();
                    searchflag = true;
                } else if ((i == list.length - 1) && (searchflag == false)) {
                    if (startIndex != 0) {
                        i = -1;
                        ++initialSelection;
                    } else searchflag = true;
                }
                if (searchflag) break;
            }
        },
        _wireEvents: function () {
            this._on(this.listContainer, "focus", this._OnFocusIn);
            this._on(this.listContainer, "blur", this._OnFocusOut);
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
        },
        _OnFocusIn: function () {
            if (!this._focused) {
                this._trigger("focusIn");
                this._on(this.listContainer, "keydown", this._OnKeyDown);
                this._on(this.listContainer, "keypress", this._OnKeyPress);
                this._focused = true;
            }
        },
        _OnFocusOut: function () {
            if (this._focused) {
                this._trigger("focusOut");
                this._off(this.listContainer, "keydown", this._OnKeyDown);
                this._off(this.listContainer, "keypress", this._OnKeyPress);
                this._focused = false;
            }
        }
    });
    ej.VirtualScrollMode = {
        /** Supports to Virtual Scrolling mode with normal only */
        Normal: "normal",
        /** Supports to Virtual Scrolling mode with continuous only */
        Continuous: "continuous"
    };
    ej.SortOrder = {

        Ascending: "ascending",

        Descending: "descending",

	    None:"none"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget(
    {
        "ejNumericTextbox": ["ej.NumericTextbox", "e-numerictextbox"],
        "ejPercentageTextbox": ["ej.PercentageTextbox", "e-percentagetextbox"],
        "ejCurrencyTextbox": ["ej.CurrencyTextbox", "e-currencytextbox"]
    },
    {
        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true,
            requireParser:true
        },

        defaults: {

            width: "",

            height: "",

            value: null,

            name: null,

            htmlAttributes: {},

            minValue: -(Number.MAX_VALUE),

            maxValue: Number.MAX_VALUE,

            incrementStep: 1,

            decimalPlaces: 0,

            validateOnType: false,

            cssClass: "",

            enablePersistence: false,

            showSpinButton: true,

            locale: "en-US",

            enableStrictMode: false,

            showRoundedCorner: false,

            readOnly: false,

            enabled: true,

            enableRTL: false,

            watermarkText: "Enter value",

            validationRules: null,

            validationMessage: null,

            groupSeparator: null,

            groupSize: null,

            positivePattern: null,

            currencySymbol:null,

            negativePattern: null,

            change: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            minValue: "number",
            maxValue: "number",
            incrementStep: "number",
            decimalPlaces: "number",
            showSpinButton: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            locale: "string",
            watermarkText: "string",
            cssClass: "string",
            readOnly: "boolean",
            enabled: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
            validateOnType: "boolean",
            groupSeparator: "string"
        },
        observables: ["value"],

        _setModel: function (jsondata) {
            var validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isNullOrUndefined(jsondata["minValue"]) && ej.isNullOrUndefined(jsondata["maxValue"])) {
                            this._setValue(jsondata[key], true);
                            jsondata[key] = this.model.value;
                        }
                        else {
                            this.model.value = this._checkNumValue(jsondata[key]);
                            this._localizedFormat();
                            this._raiseChangeEvent(true);
                            validate = true;
                        }
                        break;
                    case "enableRTL": this._enableRTL(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "minValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.minValue = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "maxValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.maxValue = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "incrementStep":
                        if (isNaN(jsondata[key])) return;
                        this.model.incrementStep = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        break;
                    case "enableStrictMode": this.model.enableStrictMode = jsondata[key]; validate = true; break;
                    case "showSpinButton": this._showSpin(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "locale":                        
                        this.model.decimalPlaces = ((ej.isNullOrUndefined(this._options.decimalPlaces)) && (this.model.decimalPlaces === this.culture.numberFormat.decimals))
                           ? -1 : (this._options.decimalPlaces === -1) ? -1 : this.model.decimalPlaces;
                        this._setLocalize(jsondata[key]);
                        this._options.decimalPlaces = this.model.decimalPlaces;
						jsondata[key] = this.model.locale;
						break;
                    case "decimalPlaces":
                        this._setDecimal(jsondata[key]);
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["decimalPlaces"] = jsondata[key];
                        break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": if (jsondata[key]) this.enable(); else this.disable(); break;
                    case "watermarkText":
                        if(!ej.isNullOrUndefined(this._options)) this._options = [];
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;						
						this._changeWatermark(jsondata[key]);
						break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "groupSeparator":
                        this._checkSeparator(jsondata[key]);
                        jsondata[key] = this.model.groupSeparator;
                        break;
                    case "positivePattern":
                    case "negativePattern":
                    case "groupSize":
                    case "currencySymbol":
                        this.model[key] = jsondata[key];
                        this._options[key] = jsondata[key];
                        this._initCustomValue();
                        jsondata[key] = this.model[key];
                        this._setValue(this.model.value, true);
                        break;                    
                }
            }
            if (validate) {
                this._validateMinMaxValue(true, true);
                jsondata["value"] = this.model.value;
                jsondata["maxValue"] = this.model.maxValue;
                jsondata["minValue"] = this.model.minValue;
                if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
				this.wrapper.attr({ 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value });
            }
            this._checkSeparator(this.model.groupSeparator);
            this.element.val(this._removeSeparator(this.model.value));
            this._updateSeparator();
            this._checkErrorClass();
        },


        _destroy: function () {
            if (this.wrapper) {
                this.element.insertBefore(this.wrapper);
                this.wrapper.remove();
            }
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.val("").removeClass('e-input e-disable').empty();
            this.element.removeAttr('disabled aria-disabled');
			this.wrapper.removeAttr('aria-valuemin aria-valuemax aria-valuenow aria-live');
            if (!(this._cloneElement).attr('role')) this.element.removeAttr('role');
            this.element.css("display", "block");
        },



        _init: function (options) {
            this._cloneElement = this.element.clone();
            this._options = ej.isNullOrUndefined(options) ? {} :options;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=number]") || !this.element.attr('type'))) {
                if(this.model.decimalPlaces > 0){
                    this.element[0].type = "text";
                }
                this._isWatermark = 'placeholder' in document.createElement('input');
                this.model.locale = ej.preferredCulture(this.model.locale).name == "en" ? "en-US" : ej.preferredCulture(this.model.locale).name;
                this._localizedLabels = this._getLocalizedLabels();
                this.culture = ej.preferredCulture(this.model.locale);
                this._browsername = ej.browserInfo().name;
                this._initCustomValue();
                this._prevSeparator = null;
                this._checkSeparator(this.model.groupSeparator);
                this._checkAttribute();
                this._renderControl();
                this._setValues();
                this._wireEvents();
                this._initObjects();
                this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                this._updateSeparator();
                if (options && options.value != undefined) {
                    this._trigger("_change", { value: this.model.value });
                }
            }
            else {
                this._destroy();
                return false;
            }
        },
		
        _checkAttribute: function () {
            var attr = ["min", "max", "step", "readonly", "disabled", "placeholder"], propName = ["minValue", "maxValue", "incrementStep", "readOnly", "enabled", "watermarkText"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if ((!ej.isNullOrUndefined(value)) && !ej.isNullOrUndefined(this._options) && (ej.isNullOrUndefined(this._options[propValue]))) {
                    if (propValue == "watermarkText") this._options[propValue] = value;
                    else this.model[propValue] = ((propValue != "disabled") && (propValue != "readOnly")) ? ej.parseFloat(value, this.model.locale) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "accesskey") proxy._hiddenInput.attr(key, value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "tabindex") {
                    proxy._hiddenInput.attr(key, value);
                    proxy.element.attr(key, value);
                }
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },

        _setValues: function () {
            this._id = this.element[0].id;
            this._textBox = this._hiddenInput[0];
            this._error = false;
            this._timeout = null;
            this.isValidState = true;
            this._allowkeyboard = true;
            this._validateOnType = false;
            this._focused = false;
            this._startValue = 0;
            if (this.sfType === "ej.CurrencyTextbox" && this.model.minValue == -(Number.MAX_VALUE))
                this.model.minValue = 0;
            if (ej.isNullOrUndefined(this.model.decimalPlaces)) {
                if (this.sfType === "ej.CurrencyTextbox")
                    this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.currency.decimals;
                else this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.decimals;

            }
            if (this.model.decimalPlaces >= 0) {
                this.model.minValue = parseFloat(this.model.minValue.toFixed(this.model.decimalPlaces));
                this.model.maxValue = parseFloat(this.model.maxValue.toFixed(this.model.decimalPlaces));
            }
            if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
			if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                
            }
            this._localizedLabelToModel();
            this._localizedFormat();
            this._validateMinMaxValue(true);
            this._updateSymbol(this.model.locale);
            var value;
            if (ej.isNullOrUndefined(this.model.value)) {
                value = this.model.value;
                this.wrapper.removeClass('e-valid');
            }
            else {
                value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.wrapper.addClass('e-valid');
            }
           this.element.val(value);
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            var rules = this.model.validationRules;
            this.element.rules("add", rules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in rules) {
                var message = null;
                if (!ej.isNullOrUndefined(rules[ruleName])) {
                    if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"][ruleName]))
                        message = rules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _renderControl: function () {
            this.wrapper = ej.buildTag("span.e-widget e-pinch");
            this.innerWrap = ej.buildTag("span.e-in-wrap e-box ");
            this.wrapper.attr("style", this.element.attr("style"));
            if (this.sfType === "ej.NumericTextbox")
                this.wrapper.addClass('e-numeric');
            else if (this.sfType === "ej.PercentageTextbox")
                this.wrapper.addClass('e-percent');
            else if (this.sfType === "ej.CurrencyTextbox")
                this.wrapper.addClass('e-currency');
            this.wrapper.append(this.innerWrap).insertAfter(this.element);
            this.innerWrap.append(this.element);
            this._hiddenInput = ej.buildTag("input", "", {}, { type: "text" }).insertBefore(this.element);
            this._hiddenInput.attr('data-role', 'none');

            this._hiddenInput[0].tabIndex = this.element[0].tabIndex;
            this._hiddenInput.attr("accesskey", this.element[0].accessKey);
            this.element[0].accessKey = "";

            this._hiddenInput.css("display", "block");
            this.element.css("display", "none");
            if (!this._isWatermark) {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this._localizedLabels.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._on(this._hiddenSpan,"mousedown", this._focusIn);
                this._on(this._hiddenSpan,'mousewheel', this._mouseWheel);
                this._on(this._hiddenSpan,'DOMMouseScroll',this._mouseWheel);
            }
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            this.element.attr("name") == null ? this.element.attr("name", this.model.name) : "";
            this.element.addClass('e-input');
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") {
                if (ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.element[0].value = this.element[0].value.replace(".", ",");
                this.model.value = this._checkNumValue(this.element[0].value);
            }   
            else {
                if (typeof this.model.value== "string" && ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.model.value = this.model.value.replace(".", ",");
                this.model.value = this._checkNumValue(this.model.value);
            }
            this._hiddenInput.attr({ 'value': this.model.value }).addClass('e-input');
			this.wrapper.attr({'role': 'spinbutton', 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value,});
            this.element.attr({'aria-live': 'assertive', "value": this.model.value });
            var spinbutton = $('<span class="e-select"><span class="e-spin e-spin-up " role="button" aria-label="Increase Value" unselectable="on" /><span class="e-spin e-spin-down" role="button" aria-label="Decrease Value" unselectable="on" /></span>');
            spinbutton.find('.e-spin-up').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-up').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            spinbutton.find('.e-spin-down').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-down').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            this.innerWrap.append(spinbutton);
            this.spin = this.wrapper.find('.e-select');
            this.spinUp = this.wrapper.find('.e-spin-up');
            this.spinDown = this.wrapper.find('.e-spin-down');
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            if (this.model.cssClass != "") this._setSkin(this.model.cssClass);
            this._showSpin(this.model.showSpinButton);
            if (this.model.showRoundedCorner) this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableRTL) this._enableRTL(this.model.enableRTL);
            if (this.model.readOnly) this._setReadOnly(this.model.readOnly);
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && this.element.hasClass("e-disable")) this.enable();
        },


        _initObjects: function () {
            this._preVal = this.model.value;
            if (this.model.value === null) {
                this.isValidState = true;
                this._hiddenInput.val(null);
            }
            else if ((this.model.value < this.model.minValue) || (this.model.value > this.model.maxValue))
                this.isValidState = false;
            this._checkErrorClass();
            this._setWaterMark();
        },


        _showSpin: function (value) {
            if (!value) {
                if (this.spin) {
                    this.spin.hide();
                    this.innerWrap.removeClass('e-padding');
                }
                this._spinEvents("_off");
            }
            else {
                if (this.spin) {
                    this.spin.show();
                    this.innerWrap.addClass('e-padding');
                }
                this._spinEvents("_on");
            }
        },


        _roundedCorner: function (value) {
            if (value && !this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.addClass('e-corner');
            } else if (this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.removeClass('e-corner');
            }
        },


        _enableRTL: function (enableRTL) {
            if (enableRTL) {
                if (this.spin) {
                    this.wrapper.addClass("e-rtl");
                }
                else this.element.addClass("e-rtl");
            }
            else {
                if (this.spin) {
                    this.wrapper.removeClass("e-rtl");
                }
                else this.element.removeClass("e-rtl");
            }
        },


        _setWidth: function (value) {
            value != "" ? this.wrapper.width(value) : this.model.width = this.wrapper.outerWidth();
        },


        _setHeight: function (value) {
            value != "" ? this.wrapper.height(value) : this.model.height = this.wrapper.outerHeight();
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },


        _setValue: function (value, isCode) {
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.model.value = this._checkNumValue(value);
            this._validateMinMaxValue(false);
            this._checkErrorClass();
            this._localizedFormat();
            this._raiseChangeEvent(isCode);
            this._setWaterMark();
        },

        _setLocalize: function (val) {
            var prevSeparator = ej.preferredCulture(this.model.locale).numberFormat[',']
            this.model.locale = ej.preferredCulture(val).name == "en" ? "en-US" : ej.preferredCulture(val).name;
            this.model.groupSeparator = ((ej.isNullOrUndefined(this._options.groupSeparator) && (prevSeparator === this.model.groupSeparator))) ?
                ej.preferredCulture(this.model.locale).numberFormat[','] : this.model.groupSeparator;
			this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this.culture = ej.preferredCulture(this.model.locale);
            this._initCustomValue();
            this._updateSymbol(this.model.locale);
            this._localizedFormat();
            this._changeWatermark(this.model.watermarkText);
            if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
            else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n",true) : this._convertToExponetial(this.model.value).unformattedValue;
            this.element.val(value);
			
        },
		 _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            
        },
        _updateSymbol: function (locale) {
            this._percentSymbol = ej.preferredCulture(locale).numberFormat.percent.symbol;
            this._currencySymbol = ej.preferredCulture(locale).numberFormat.currency.symbol;
        },

        _setDecimal: function (val) {
            this.model.decimalPlaces = val;
            this._localizedFormat();
        },


        _validateMinMaxValue: function (fromMinMax, isCode) {
            var valChange = false, value;
            if (this.model.minValue > this.model.maxValue) this.model.minValue = this.model.maxValue;
            if (!ej.isNullOrUndefined(this.model.value) && this.model.minValue > this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this._startValue = this.model.value = this.model.minValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else if (!ej.isNullOrUndefined(this.model.value) && this.model.maxValue < this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this.model.value = this.model.maxValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else this.isValidState = true;
            if (this.model.minValue == this.model.maxValue) this._startValue = this.model.minValue;
            if ((valChange && fromMinMax)) {
                value = this._formatValue(this.model.value, "n", true);
                this._hiddenInput.val(value);
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n", true) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._localizedFormat();
                this._raiseChangeEvent(isCode);
            }
        },

        _convertToExponetial: function (value) {
            var number = "", pattern, format;
            var negative = value < 0 ? true : false;
            value = value.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            unformattedValue = value;
            var length = null;
            if (this.sfType === "ej.NumericTextbox") {
                pattern = negative ? format.pattern[0] : ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = "";
            }
            else if (this.sfType === "ej.PercentageTextbox") {
                pattern = negative ? format.percent.pattern[0] : format.percent.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.percent.symbol;
            }
            else if (this.sfType === "ej.CurrencyTextbox") {
                pattern = negative ? format.currency.pattern[0] : format.currency.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.currency.symbol;
            }
            for (idx = 0, length = pattern.length; idx < length; idx++) {
                ch = pattern.charAt(idx);
                (ch === "n") ? number += value : (ch === "$" || ch === "%") ? number += symbol : number += ch;
            }
            return { formattedValue: number, unformattedValue: unformattedValue }
        },

        _localizedFormat: function () {
            this.culture = ej.preferredCulture(this.model.locale);
            this._decimalSep = ej.preferredCulture(this.model.locale).numberFormat['.'];
            if (ej.isNullOrUndefined(this.model.value)) {
                this._textBox.value = "";
                return;
            }
            if (this.model.value.toString().indexOf('e') == -1) {
                this._textBox.value = this._removeSeparator(this.model.value)
                if (!this._focused && this._textBox.value != "") {
                    this._textBox.value = this._formatValue(this.model.value, "n", true);
					
                    if (this.sfType === "ej.PercentageTextbox") this._appendPercentSymbol(this._textBox.value);
                    else if (this.sfType === "ej.CurrencyTextbox") this._appendCurrencySymbol(this._textBox.value);


                    var symbolIndex = (this.sfType === "ej.CurrencyTextbox") ? this._textBox.value.indexOf(this._currencySymbol) : (this.sfType === "ej.PercentageTextbox") ? this._textBox.value.indexOf(this._percentSymbol) : -1;

                    if (this.model.decimalPlaces == -1) {
                        this._textBox.value = this._textBox.value.substr(0, this._textBox.value.lastIndexOf(this._decimalSep));
                        if (symbolIndex > 1 && (ej.isNullOrUndefined(this._afterDec) || this._afterDec == "")) {
                            if (this.sfType === "ej.CurrencyTextbox")
                                this._textBox.value = this._textBox.value + " " + this._currencySymbol;
                            if (this.sfType === "ej.PercentageTextbox")
                                this._textBox.value = this._textBox.value + " " + this._percentSymbol;
                        }
                        if (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this._afterDec) && this._afterDec != "") {
                            var index = this._textBox.value.lastIndexOf(this._decimalSep);
                            if (index >= 0) {
                                this._textBox.value = this._textBox.value.substr(0, index);
                            }
                            var symbolPos = this._afterDec;
                            if (symbolIndex > 1) {
                                if (this.sfType === "ej.CurrencyTextbox")
                                    symbolPos = symbolPos + " " + this._currencySymbol;
                                if (this.sfType === "ej.PercentageTextbox")
                                    symbolPos = symbolPos + " " + this._percentSymbol;

                            }
                            this._textBox.value = this._textBox.value + this._decimalSep + symbolPos;
                        }
                    }
                }
                else {
                    var value = this._convertToExponetial(this.model.value);
                    this._textBox.value = value.unformattedValue;
                    if (!this._focused && this._textBox.value != "")
                        this._textBox.value = value.formattedValue;
                }
            }
            else {
                this._textBox.value = this.model.value.toString();
            }
        },

        _checkNumValue: function (value) {
            if (typeof value == "string")
                value = !this._changeSeparator ? value : this._replaceSeparator(value, this.model.groupSeparator, ej.preferredCulture(this.model.locale).numberFormat[',']);
            if (typeof value == "string" && !isNaN(this._parseValue(value))) {
                value = this._parseValue(value);
                return parseFloat(value);
            }
            else if ((typeof value == "number") && !isNaN(value))
                return value;
            else return null;
        },


        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) {
                this.element.attr("readonly", true);
                this._hiddenInput.attr("readonly", true);
            }
            else {
                this.element.prop("readonly",false);
                this._hiddenInput.prop("readonly",false);
            }
        },


        _setWaterMark: function () {
            if ((this._localizedLabels.watermarkText != null) && (this._textBox.value === "") && $.trim(this._hiddenInput.val()) === "") {
                if (this._isWatermark) {
                    this._hiddenInput.attr("placeholder", this._localizedLabels.watermarkText);
                    this.element.attr("placeholder", this._localizedLabels.watermarkText);
                }
                else
                    this._hiddenSpan.css("display", "block").text(this._localizedLabels.watermarkText);
            }
        },


        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) {
                this._hiddenInput.attr("placeholder", text);
                this.element.attr("placeholder", text);
            }
            else this._hiddenSpan.text(text);
        },


        _setSelectionRange: function (selectionStart, selectionEnd) {
            var input = this._textBox;
            try {
                if (input.setSelectionRange) {
                    if (this._browsername == "edge")  setTimeout(function () { input.setSelectionRange(selectionStart, selectionEnd) })
                    else input.setSelectionRange(selectionStart, selectionEnd);
                }
                else if (input.createTextRange) {
                    var range = input.createTextRange();
                    _setselction(range);
                }
            }
            catch (e) {
                var control = this;
                window.setTimeout(function () {
                    document.body.focus();
                    control._textBox.select();
                    if (document.selection) {
                        var range = document.selection.createRange();
                        _setselction(range);
                    }
                }, 1);
            }
            function _setselction(range) {
                range.collapse(true);
                range.moveEnd('character', selectionEnd);
                range.moveStart('character', selectionStart);
                range.select();
            }
        },


        _getSelection: function (value) {
            if (this._textBox.type != "number") {
                var oSel = null;
                if (document.selection) {
                    oSel = document.selection.createRange();
                    return (oSel.text === "" ? oSel.text : this._removeFormats(oSel.text));
                }
                else {
                    if (value == null)
                        return this.model.value;
                    else {
                        oSel = this._removeFormats(value.substring(this._textBox.selectionStart, this._textBox.selectionEnd));
                        return oSel;
                    }
                }
            }
        },


        _caretPosition: function () {
            var oField = this._textBox;
            var iCaretPos = 0;
            // IE Support
            if (oField.type != "number") {
                if (document.selection) {
                    oField.focus();
                    // To get cursor position, get empty selection range
                    var oSel = document.selection.createRange();
                    // Move selection start to 0 position
                    oSel.moveStart('character', -oField.value.length);
                    // The caret position is selection length
                    iCaretPos = oSel.text.length;
                }
                    // Firefox support
                else if (oField.selectionStart || oField.selectionStart == '0')
                    iCaretPos = oField.selectionEnd;
                return (iCaretPos);
            }  
        },


        _appendPercentSymbol: function (value) {
            if (this._percentSymbol) value = value.replace(this._percentSymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value) / 100, "p", true);
            this._percentSymbol = ej.preferredCulture(this.model.locale).numberFormat.percent.symbol;
        },

        _appendCurrencySymbol: function (value) {
            if (this._currencySymbol) value = value.replace(this._currencySymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.currency.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value), "c", true);
            this._currencySymbol = ej.preferredCulture(this.model.locale).numberFormat.currency.symbol;

        },

        _removeFormats: function (val) {
            var grpSep = ej.preferredCulture(this.model.locale).numberFormat[","];
            if (val != null) {
                if (grpSep == ".")
                    return (val.toString().replace(/["."]/g, ""));
                else if (val.toString().match(new RegExp(grpSep, "g")))
                    return (val.toString().replace(new RegExp(grpSep, "g"), ""));
                else
                    return val;
            }
            else
                return null;
        },


        _checkErrorClass: function (obj) {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
		


        enable: function () {
            this.model.enabled = true;
            this.element[0].disabled = false;
            this.element.prop("disabled",false);
            this._hiddenInput.prop("disabled", false);
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this._hiddenInput.removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select").removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select span.e-icon.e-arrow").removeClass('e-disable');
            this.wrapper.removeClass('e-disable-wrap');
        },


        disable: function () {
            this.model.enabled = false;
            this.element[0].disabled = true;
            this.element.attr("disabled", "disabled");
            this._hiddenInput.attr("disabled", "disabled");
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this._hiddenInput.addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select").addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select span.e-icon.e-arrow").addClass('e-disable');
            this.wrapper.addClass('e-disable-wrap');
        },


        getValue: function () {
            return this.model.value;
        },

        _wireEvents: function () {
            this._on(this._hiddenInput, 'focus', this._focusIn);
            this._on(this.element, 'paste', this._paste);
            this._on(this.element, 'blur', this._focusOut);
            this._on(this.element, 'keydown', this._keyDown);
            this._on(this.element, 'keypress', this._keyPress);
            this._on(this.element, 'mousewheel', this._mouseWheel);
            this._on(this.element, 'DOMMouseScroll', this._mouseWheel);
        },

        _spinEvents: function (action) {
            this[action](this.spinUp, "mousedown mouseup touchstart touchend", this._spinUpClick);
            this[action](this.spinDown, "mousedown mouseup touchstart touchend", this._spinDownClick);
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },

        _spinUpClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinUp.addClass("e-animate");
            this._on(this.spinUp, 'mouseleave', this._mouseUpClick);
            this.spinUp.addClass("e-active");
            var self = this;
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("increment");
                this.spinUp.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus();
                this._timeout = setInterval(function () {
                    self._updateInputField("increment");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _spinDownClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinDown.addClass("e-animate");
            this._on(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.addClass("e-active");
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("decrement");
                this.spinDown.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus()
                this._timeout = setInterval(function () {
                    self._updateInputField("decrement");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _mouseUpClick: function (event) {
            event.stopPropagation();
            clearTimeout(this._timeout);
            this._off(this.spinUp, 'mouseleave', this._mouseUpClick);
            this._off(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.removeClass("e-active");
            this.spinUp.removeClass("e-active");
        },

        _mouseWheel: function (event) {
            event.preventDefault();
            if (!this._focused) this.element[0].focus();
            if (!this.model.enabled || this.model.readOnly) return;
            var delta;
            var rawEvent = event.originalEvent;
            if (rawEvent.wheelDelta) {
                // IE and Opera use wheelDelta, which is a multiple of 120 (possible values -120, 0, 120).
                delta = rawEvent.wheelDelta / 120;
                // In Opera, value is negated.
                //if (Sys.Browser.agent === Sys.Browser.Opera) delta = -delta;
            }
            else if (rawEvent.detail) {
                // Firefox uses detail property, which is a multiple of 3.
                delta = -rawEvent.detail / 3;
            }
            if (delta > 0)
                this._updateInputField("increment");
            else if (delta < 0)
                this._updateInputField("decrement");
            this._cancelEvent(event);
        },


        _numberValue: function () {
            var value = this._textBox.value;
            if (this.sfType === "ej.NumericTextbox")
                value = this._formatValue(this.model.value, "n", true);
            if (this.sfType === "ej.PercentageTextbox")
                value = this._formatValue(this.model.value, "n", true);
            else if (this.sfType === "ej.CurrencyTextbox")
                value = this._formatValue(this.model.value, "n", true);
            value = (typeof value == "string" && !isNaN(this._parseValue(value))) ? value : "";
            return value;
        },
        _formatValue: function (value, format,flag) {
            if(flag) this._updateCultureInfo();
            var value = ej.format(value, format + this.model.decimalPlaces, this.model.locale);
            if (flag) this._restCultureInfo();
            return value;
        },
        _parseValue: function (value) {
            this._updateCultureInfo();
            var value = ej.parseFloat(value, this.model.locale);
            this._restCultureInfo();
            return value;            
        },

        _initCustomValue: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            switch (ctr) {
                case "percent":
                case "currency":
                    format = this.culture.numberFormat[ctr];
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.currencySymbol) && ctr == "currency") this.model.currencySymbol = format.symbol;
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];                    
                    break;
                case "numeric":
                    format = this.culture.numberFormat;
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];
                    break;
            }
        },

        _updateCultureInfo: function (flag) {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            this._oldNegativePattern = format.pattern[0];
            this._oldGroupSize = format.groupSizes[0];
            format.pattern[0] = this.model.negativePattern;
            format.groupSizes[0] = this.model.groupSize;
            this._oldPositivePattern = format.pattern[1];
            format.pattern[1] = this.model.positivePattern;
            if (ctr == "currency") {
                this._oldcurrencySymbol = format.symbol;
                format.symbol = this.model.currencySymbol;
            }
        },
        _restCultureInfo: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            format.pattern[0] = this._oldNegativePattern;
            format.groupSizes[0] = this._oldGroupSize;
            format.pattern[1] = this._oldPositivePattern;
            if (ctr == "currency")
                format.symbol = this._oldcurrencySymbol;;
        },
        _toggleTextbox: function (toggle) {
            var proxy = this;
            proxy._hiddenInput.toggle(toggle);
            proxy.element.toggle(!toggle);
        },

        _paste: function (event) {
            var text;
            if (window.clipboardData && window.clipboardData.getData) { // IE
                text = window.clipboardData.getData('Text');
            }
            else if (event.originalEvent.clipboardData && event.originalEvent.clipboardData.getData) { // other browsers
                text = event.originalEvent.clipboardData.getData('text/plain');
            }
            var data = ej.parseFloat(text, this.model.locale);
            if (isNaN(data) && text) this._cancelEvent(event)
        },
        _focusIn: function (event) {
            if (this.model.readOnly)
                return;
            this._focused = true;
            if(!ej.isNullOrUndefined(this.model.value)) this.element.val(this._removeSeparator(this.model.value));
            this._toggleTextbox(false);
            this._textBox = this.element[0];
            this.element[0].focus();
            this._preVal = this.model.value;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass('e-error');
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = this._formatValue(this._textBox.value, "n", true);
                    if (this.model.decimalPlaces == -1) {
                        this._separateValue(this._textBox.value.toString(), true, true);
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            value = this._beforeDec + this._decimalSep + this._afterDec
                    }
                    this._textBox.value = value;
                    this._hiddenInput.val(value);
                }
                this._setSelectionRange(0, this._textBox.value.length);
            }
            this._trigger("focusIn", { value: this.model.value });
        },

        _separateValue: function (value, isDecimal, isgroupSep) {
            var index = (!isDecimal) ? value.lastIndexOf(".") : value.lastIndexOf(this._decimalSep);
            this._beforeDec = (index >= 0) ? value.substr(0, index) : value;
            if (!isDecimal && isgroupSep)
                this._afterDec = (index >= 0) ? value.substr(index + 1) : "";
        },

        _focusOut: function (event) {
            this._focused = false;
            this.wrapper.removeClass("e-focus");
            this._separateValue(this._textBox.value,false,true);
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = ej.parseFloat(this._textBox.value, this.model.locale);
                    if (value < this.model.minValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.minValue, "n", false)
                        else
                            this.isValidState = false
                    }
                    else if (value > this.model.maxValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.maxValue, "n", false);
                        else
                            this.isValidState = false;
                    }
                    this.model.value = (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this._afterDec) && (this._textBox.value.lastIndexOf(this._decimalSep) == -1) && (value.toString().indexOf('e') == -1)) ? ej.parseFloat(this._textBox.value + this._decimalSep + this._afterDec, this.model.locale) : ej.parseFloat(this._textBox.value, this.model.locale);
                    if (isNaN(this.model.value) && !this.model.value) {
                        this.model.value = null;
                        this.isValidState = false;
                    }
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                    this._localizedFormat();
                    this._checkErrorClass();
                }
                else {
                    var value = this._textBox.value == "" ? null : this._textBox.value;
                    this.model.value = value;
                    this._hiddenInput.val(value);
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                }
                if (this.model.value === null || this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) this.isValidState = true;
                else if (this.model.enableStrictMode) this.isValidState = false;
                this._raiseChangeEvent();
                this._setWaterMark();
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._updateSeparator();
                this._trigger("focusOut", { value: this.model.value });
            }
            this._checkErrorClass();
            this._afterDec = "";
        },

        _cancelEvent: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _updateInputField: function (operation) {
            this.isValidState = true;
            if (!this._focused) $(this._hiddenInput[0]).focus();
            var step = this.model.incrementStep;
            var itemValue = this.model.value;
            if (this._textBox.value === "") {
                this._textBox.value = this._formatValue(this._startValue, "n", true);
                step = 0;
            }
            else if (this._textBox.value.indexOf(" ") >= 0)
                this._textBox.value = this._textBox.value.replace(" ", "");
            if (this.sfType === "ej.PercentageTextbox" || this.sfType === "ej.CurrencyTextbox") {
                var editorvalue = this._textBox.value, value = editorvalue;
                if (editorvalue.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) > -1)
                    value = editorvalue.substring(0, editorvalue.length - 1);
                this.model.value = this._parseValue(value);
            }
            else if (this.sfType == "ej.NumericTextbox")
                this.model.value = ej.parseFloat(this._textBox.value, this.model.locale);

            if (isNaN(this.model.value) && !this.model.value)
                this.model.value = this._startValue;

            if (this.model.value >= this.model.minValue && this.model.value > this.model.maxValue) {
                this.model.value = this.model.maxValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value < this.model.minValue && this.model.value <= this.model.maxValue) {
                this.model.value = this.model.minValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) {
                value = operation == "increment" ? this.model.value + step : this.model.value - step;
                if(this.model.decimalPlaces == -1) {
                    value = (this.model.value.toString().indexOf('e') == -1) ? parseFloat(value.toFixed(this._afterDec.length)) : parseFloat(value);
                    };
                if (value >= this.model.minValue && value <= this.model.maxValue)
                    this._setValue(value);
            }
            this._checkErrorClass();
        },

        _validateDecimal: function (e) {
            var char = String.fromCharCode(e.keyCode);
            char = e.keyCode == 188 ? "," : (e.keyCode == 190) ? "." : (e.keyCode == 110) ? ej.preferredCulture(this.model.locale).numberFormat["."] : char;
            if (ej.preferredCulture(this.model.locale).numberFormat["."].charCodeAt(0) == char.charCodeAt(0))
                return true;
            return false;
        },

        _allowKeyCodes: function (e) {
            var keys = new Array(38, 40, 35, 36, 109, 189, 46, 8, 127, 37, 39, 190, 9, 13, 16, 17, 18, 20, 110, 173, 86, 88, 67);
            for (var i = 0; i < keys.length; i++) {
                if (e.keyCode == keys[i] || (this._validateDecimal(e) && this.model.decimalPlaces != 0))
                    return true;
            }
            return false;
        },

        _raiseChangeEvent: function (isCode) {
            var currVal = this.model.value, value;
            if ((this._checkNumValue(this._preVal) !== this._checkNumValue(currVal))) {
                this._preVal = currVal;
                this.model.value = (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this.model.value)) ? parseFloat(this.model.value) : this._checkNumValue(this._formatValue(this._preVal, "n", false));
                this._updateHiddenField();
                if (ej.isNullOrUndefined(this.model.value)) {
                    value = this.model.value;
                    this.wrapper.removeClass('e-valid');
                }
                else {
                    value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                    if (this.model.decimalPlaces == -1) {
                        this._separateValue(this.model.value.toString(), false,true);
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            value = this._beforeDec + this._decimalSep + this._afterDec;
                    }
                    this.wrapper.addClass('e-valid');
                }
                this.element.val(value);
			    this.wrapper.attr('aria-valuenow', value);
                this._updateSeparator();
                // Trigger the Jquery change event for the input element.
                this.element.trigger("change");
                this._trigger("_change", { value: this.model.value, isInteraction: !isCode });
                this._trigger("change", { value: this.model.value, isInteraction: !isCode });
            }
        },
        _updateHiddenField: function () {
            var prevActive = this._textBox;
            this._textBox = this._hiddenInput[0];
            this._localizedFormat();
            this._textBox = prevActive;
        },
        _removeSeparator: function (number) {
            if (ej.isNullOrUndefined(number)) return;
            var value, format, tag;
            if (this.model.decimalPlaces == -1) {
                this._separateValue(number.toString(), false,true);
            }
            if (number.toString().indexOf('e') == -1) {
                number = this._checkNumValue(this._formatValue(number, "n", false));
            }
            value = number.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            return value;
        },
        _updateSeparator: function () {
            if (this._changeSeparator && this.model.value) {
                var formatValue;
                    if (this.sfType === "ej.NumericTextbox")
                        formatValue = this._formatValue(this.model.value, "n", true);
                    else if (this.sfType === "ej.PercentageTextbox")
                        formatValue = this._formatValue((this.model.value) / 100, "p", true);
                    else if (this.sfType === "ej.CurrencyTextbox")
                        formatValue = this._formatValue(this.model.value, "c", true);
                    if (this.model.decimalPlaces == -1) {
                        var index = formatValue.lastIndexOf(this._decimalSep);
                        var val = formatValue.substr(index + 1);
                        this._separateValue(formatValue, true, false);
                        var symbolIndex = (this.sfType === "ej.CurrencyTextbox") ? formatValue.indexOf(this._currencySymbol) : (this.sfType === "ej.PercentageTextbox") ? this._textBox.value.indexOf(this._percentSymbol) : -1;
                        var symbolPos = this._afterDec;
                         if (symbolIndex > 1) {
                           if (this.sfType === "ej.CurrencyTextbox")
                                symbolPos = symbolPos + " " + this._currencySymbol;
                            if (this.sfType === "ej.PercentageTextbox")
                                symbolPos = symbolPos + " " + this._percentSymbol;
                         }
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            formatValue = this._beforeDec + this._decimalSep + symbolPos;
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec == "")
                            formatValue = this._beforeDec + this._decimalSep + val;
                    }
                
                this._hiddenInput.val(this._replaceSeparator(formatValue, ej.preferredCulture(this.model.locale).numberFormat[","], this.model.groupSeparator));
            }
        },

        _replaceSeparator: function (value, find, replaceWith) {
            this._decimalSep = ej.preferredCulture(this.model.locale).numberFormat['.'];
            var reg = find === "" ? new RegExp("\\s", "g") : new RegExp("\\" + find, "g");
            if (this.model.groupSeparator == ej.preferredCulture(this.model.locale).numberFormat['.']) {
                var decimalpoints = this.model.decimalPlaces;
                if (this.model.decimalPlaces == -1) {
                    var index = value.lastIndexOf(this._decimalSep);
                    decimalpoints = value.substr(index + 1).length;
                 }
                var valuelength = value.length - decimalpoints - 1;
                return value.substring(0, valuelength).replace(reg, replaceWith) + value.substring(valuelength, value.length);
            }
            return value.replace(reg, replaceWith);
        },

        _checkSeparator: function (value) {
            this.model.groupSeparator = value != null ? this._validateSeparator(value) : ej.preferredCulture(this.model.locale).numberFormat[','];
            this._changeSeparator = ej.preferredCulture(this.model.locale).numberFormat[","] != this.model.groupSeparator ? true : false;
            this._prevSeparator = this.model.groupSeparator;
        },
        _validateSeparator: function (value) {
            var separator = value.toString();
            var reg = new RegExp("[a-zA-Z0-9]");
            separator = (separator.length > 1) ? separator[0] : separator;
            separator = (!reg.test(separator)) ? separator : this._prevSeparator != null ? this._prevSeparator : ej.preferredCulture(this.model.locale).numberFormat[','];
            return separator;
        },
        _keyPress: function (e) {
            if (e.which === 0 || e.metaKey || e.ctrlKey || e.keyCode === 8 || e.keyCode === 13)
                return;
            var proxy = this, regExp = null, point = ".", cursor, beforeCursor, afterCursor, numberFormat, value;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            numberFormat = ej.preferredCulture(this.model.locale).numberFormat;

            var character = String.fromCharCode(e.which);
            value = beforeCursor + character + afterCursor;
            var separator = numberFormat[point];
            separator = (separator === point) ? "\\" + separator : separator;
            regExp = proxy.model.decimalPlaces === 0 ? new RegExp("^((-)?(\\d*)(-)?)?$") : new RegExp("^(-)?(((\\d+(" + separator + "\\d*)?)|(" + separator + "\\d*)))?((-)?)$");
            // Validate the textbox value 
            if (!regExp.test(value))
                return false;
        },
        _validateDecimalOnType: function (e) {
            var cursor, cancelEvent, beforeCursor, afterCursor, sel, temp;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            sel = this._getSelection(this._textBox.value);
            var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
            temp = (ej.isNullOrUndefined(this.model.value)) ? "" : this.model.value.toString();
            if (this.model.decimalPlaces != 0) {
                var afterdeci = (this._textBox.value).split(decSep)[1];
                if (temp.indexOf(decSep) > 0) {
                    if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                        cancelEvent = true;
                    else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                    else cancelEvent = false;
                }
                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                else
                    cancelEvent = false;
            }
            else
                cancelEvent = false;
            if (cancelEvent) {
                this._keypressFlag = false;
                this._cancelEvent(e);
                return false;
            }
        },

        _keyDown: function (e) {
            if (this.model.readOnly) return;
            this._CurrentCultureInfo = JSON.parse(JSON.stringify(ej.preferredCulture()));
            var cursor, cancelEvent, beforeCursor, afterCursor, sel;
            if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || this._allowKeyCodes(e)) {
                if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 118 || e.keyCode == 67 || e.keyCode == 88)))
                    return true;
                if ((((e.ctrlKey == true) && (e.keyCode != 9 && e.keyCode != 17 && e.keyCode != 86 && e.keyCode != 67))) || (e.keyCode == 67 || e.keyCode == 86 || e.keyCode == 88)) {//Prevent Shift + Tab event
                    this._keypressFlag = false;
                    this._cancelEvent(e);
                    return false;
                }

                if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || e.keyCode == 110) {//Numbers from 0 to 9 in keyboard and numpad (110 for decimal)
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.toString().substring(0, cursor);
                    afterCursor = this._textBox.value.toString().substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                    // For Numpad issue
                    if (e.keyCode >= 96 && e.keyCode <= 105)
                        e.keyCode -= 48;
                    if (this.model.validateOnType && this.model.decimalPlaces != -1) this._validateDecimalOnType(e);
                    if (this._validateOnType) {
                        var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
                        var temp = this.model.value.toString();
                        var tempIndex = temp.indexOf(decSep);
                        var value = this.model.value;

                        var replaceminVal = (this.model.decimalPlaces == -1) ? this.model.minValue : this.model.minValue.toFixed(this.model.decimalPlaces);
                        var replacemaxVal = (this.model.decimalPlaces == -1) ? this.model.maxValue : this.model.maxValue.toFixed(this.model.decimalPlaces);
                        var exp = false;
                        if (replaceminVal.toString().indexOf("e") > 0 || replacemaxVal.toString().indexOf("e") > 0)
                            exp = true;
                        if (!exp) {
                            if (decSep != ".") {
                                temp = this._textBox.value.toString();
                                if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                    replaceminVal = this.model.minValue.toString().replace(/["."]/g, decSep);
                                if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                    replacemaxVal = this.model.maxValue.toString().replace(/["."]/g, decSep);
                            }
                            if (replaceminVal.toString().indexOf(decSep) > 0)
                                minVal = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                            else
                                minVal = this.model.minValue;
                            if (replacemaxVal.toString().indexOf(decSep) > 0)
                                maxVal = Number(replacemaxVal.toString().toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                            else
                                maxVal = this.model.maxValue;
                            if (tempIndex > 0) {
                                value = Number(temp.substring(temp.indexOf(decSep) + 1, temp.toString().length));
                                if (replaceminVal.toString().indexOf(decSep) > 0)
                                    minVal = Number(replaceminVal.toString().substring(replaceminVal.toString().indexOf(decSep) + 1, replaceminVal.toString().length));
                                else
                                    minVal = 0;
                                if (replacemaxVal.toString().indexOf(decSep) > 0)
                                    maxVal = Number(replacemaxVal.toString().substring(replacemaxVal.toString().indexOf(decSep) + 1, replacemaxVal.toString().length));
                                else
                                    maxVal = 0;
                                var valb4Dec = Number(temp.substring(0, temp.indexOf(decSep)));
                                var minValb4Dec = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                                var maxValb4Dec = Number(replacemaxVal.toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                                if (!this._validateValue(value, minVal, maxVal, true, valb4Dec, minValb4Dec, maxValb4Dec))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                            else {
                                if (!this._validateValue(value, minVal, maxVal, false))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                        }
                        else if (this.model.decimalPlaces != 0) {
                            var afterdeci = (this._textBox.value).split(".")[1];
                            if (temp.indexOf(decSep) > 0 || (Number(temp) < Number(replaceminVal) || Number(temp) > Number(replacemaxVal))) {
                                if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                                    cancelEvent = true;
                                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                                else cancelEvent = false;
                            }
                            else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                            else
                                cancelEvent = false;
                        }
                        else
                            cancelEvent = false;
                        if (cancelEvent) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                    }

                }
                if (e.keyCode == 38 && this._allowkeyboard) {
                    this._updateInputField("increment");
                    this._cancelEvent(e);
                }

                if (e.keyCode == 40 && this._allowkeyboard) {
                    this._updateInputField("decrement");
                    this._cancelEvent(e);

                }
                if (e.keyCode == 8) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }

                if (e.keyCode == 46 || e.keyCode == 127) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }
                if (this._validateDecimal(e) && this.model.decimalPlaces != 0 && e.keyCode != 46) {
                    var decChar = ej.preferredCulture(this.model.locale).numberFormat["."];
                    var minVal, maxVal;
                    var dotSplit = this._textBox.value.split(decChar);
                    if (dotSplit[1] == undefined) {
                        var curPosition = this._caretPosition();
                        var strBeforeCursor = dotSplit[0].substring(0, curPosition);
                        var strAfterCursor = dotSplit[0].substring(curPosition);
                        if (this.model.minValue.toString().indexOf("e") > 0 || this.model.maxValue.toString().indexOf("e") > 0)
                            exp = true;
                        if (this.model.decimalPlaces != -1 && strAfterCursor.length > this.model.decimalPlaces && this.model.validateOnType == true) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                        if (this._validateOnType && !exp) {
                            if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                minVal = this.model.minValue.toString().replace(/["."]/g, decChar);
                            if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                maxVal = this.model.maxValue.toString().replace(/["."]/g, decChar);
                            if (minVal.indexOf(decChar) > 0)
                                minVal = Number(minVal.substring(0, minVal.indexOf(decChar)));
                            else
                                minVal = Number(minVal);
                            if (maxVal.indexOf(decChar) > 0)
                                maxVal = Number(maxVal.substring(0, maxVal.indexOf(decChar)));
                            else
                                maxVal = Number(maxVal);
                            if (this._validateValue(this.model.value, minVal, maxVal, "DecimalKeyPressed"))
                                this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                            else {
                                this._keypressFlag = false;
                                this._cancelEvent(e);
                                return false;
                            }
                        }
                        else
                            this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                        this._setSelectionRange(curPosition + 1, curPosition + 1);
                    }
                    this._cancelEvent(e);
                } else if (e.keyCode == 190 || e.keyCode == 110) {
                    this._cancelEvent(e);
                }
                if (e.keyCode == 109 || e.keyCode == 189 || e.keyCode == 173) { //'-' char key press.
                    if ((this._caretPosition() != 0 && this._getSelection(this._removeFormats(this._textBox.value)) != this.model.value) || (this.model.minValue >= 0 && !this.model.enableStrictMode) || (this._textBox.value.toString().match(new RegExp("-", "g")) && this._getSelection(this._textBox.value) === ""))
                        this._cancelEvent(e);

                    else if (this._getSelection() == this.model.value)
                        this.model.value = null;
                }

                if (e.keyCode == 13)
                    if ((this._checkNumValue(this._preVal) !== this._checkNumValue(this._textBox.value)))
                        this._setValue(this._textBox.value);
            }

            else if (e.keyCode != 27 && !e.ctrlKey || (e.ctrlKey && e.keyCode == 90 && $.trim(this._textBox.value) === "")) {
                this._keypressFlag = false;
                this._cancelEvent(e);
            }
        },
		_getLocalizedLabels: function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
		
    });
	
    ej.NumericTextbox.Locale = ej.NumericTextbox.Locale || {} ;
    
    ej.NumericTextbox.Locale['default'] = ej.NumericTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.PercentageTextbox.Locale = ej.PercentageTextbox.Locale || {} ;
    
    ej.PercentageTextbox.Locale['default'] = ej.PercentageTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.CurrencyTextbox.Locale = ej.CurrencyTextbox.Locale || {} ;
    
    ej.CurrencyTextbox.Locale['default'] = ej.CurrencyTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	
		
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejMaskEdit", "ej.MaskEdit", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },

        defaults: {

            maskFormat: "",

            value: null,

            watermarkText: "",

            name : null,

            height: "",

            width: "",

            showError: false,

            htmlAttributes: {},

            cssClass: "",

            customCharacter: null,

            inputMode: "text",

            readOnly: false,

            textAlign: ej.TextAlign.Left,

            hidePromptOnLeave: false,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            locale:"en-US",

            showPromptChar: true,

            validationRules: null,

            validationMessage: null,

            keydown: null,

            keyup: null,

            keyPress: null,

            change: null,

            mouseover: null,

            mouseout: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            maskFormat: "string",
            showError: "boolean",
            enabled: "boolean",
            customCharacter: "string",
            cssClass: "string",
            watermarkText: "string",
            showRoundedCorner: "boolean",
            showPromptChar: "boolean",
            inputMode: "enum",
            textAlign: "enum",
            hidePromptOnLeave: "boolean",
            readOnly: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data"
        },

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        this._setValue(jsondata[key]);
                        this._initObjects();
                        jsondata[key] = this.get_UnstrippedValue(); this._raiseEvents("change", true); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "watermarkText": this.model.watermarkText = jsondata[key]; this._changeWatermark(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "showPromptChar": this._setShowPrompt(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this._hiddenInput.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "textAlign": this._setTextAlign(jsondata[key]); break;
                    case "inputMode": this._setInputMode(jsondata[key]); break;
                    case "maskFormat":
                        this.model.maskFormat = jsondata[key];
                        this._valueMapper();
                        this._maskModel = this.model.maskFormat;
                        this._setMask(jsondata[key]);
                        this._initObjects();
                        jsondata[key] = this.model.maskFormat;
                        break;
                    case "locale":
                         this.model.value = this.get_StrippedValue();
                         this.model.locale = jsondata[key];
                         this._setValue(this.model.value);
                         this._initObjects();                        
                         break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "hidePromptOnLeave": this.model.hidePromptOnLeave = jsondata[key];
                        if (this._textbox.value != "") {
                            if(this.model.hidePromptOnLeave) {
                                this._unStrippedMask = this._textbox.value;
                                this._textbox.value = this.get_UnstrippedValue();
                            }
                            else this._textbox.value = this._textbox.value.replace(/[ ]/g, '_');
                            this.model.value = this._textbox.value;
                        }
                }
            }
        },
        observables: ["value"],


        _destroy: function () {
            if (!ej.isNullOrUndefined(this._hiddenInput)) this.element.attr("name", this._hiddenInput.attr("name"));
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.insertAfter(this.wrapper);
            if (!ej.isNullOrUndefined(this.wrapper)) this.wrapper.remove();
            if (this.model.textAlign) this.element.css("text-align", "");
            this.element.val("").removeClass(' e-mask e-input e-disable').empty();
            this.element.removeAttr('aria-invalid aria-disabled');
        },


        _init: function (options) {
            this._options = options;
            this._tempMask = this.model.maskFormat;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=password]") || !this.element.attr('type'))) {
                this._isWatermark = 'placeholder' in document.createElement('input');
                this._setValues();
                this._valueMapper();
                this._renderControl();
                this._initObjects();
                this._wireEvents();
				this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            } else {
                this._destroy();
                return false;
            }
            if (options && options.value != undefined && this.model.value !== options.value)
                this._trigger("_change", { value: this.get_UnstrippedValue(), unmaskedValue: this.get_StrippedValue()});            
        },

        _initValidator: function () {
			(!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
				else if(keyName == "name") proxy._hiddenInput.attr(key,value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },
        _setValidation: function () {
            this._hiddenInput.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this._hiddenInput.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },

        _setShowPrompt:function(value){
            this.model.showPromptChar = value;
            this._textbox.value = this.model.showPromptChar ? this._unStrippedMask : this.get_UnstrippedValue();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _setValues: function () {
            this._unStrippedMask = null;
            //Predefined character definitions
            this._charMap = {
                '9': "[0-9 ]",
                'a': "[A-Za-z0-9 ]",
                'A': "[A-Za-z0-9]",
                'N': "[0-9]",
                '#': "[0-9]",
                '&': '[^\x7f]+',
                '<': "",
                '>': "",
                'C': this.model.customCharacter != null ? "[" + this.model.customCharacter + "]" : "[A-Za-z ]",
                '?': "[A-Za-z]",
            };
        },

        _renderControl: function () {
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            if (this.element.attr("name") != null)
                this.element.removeAttr('name');
            this.wrapper = ej.buildTag("span.e-mask e-widget " + this.model.cssClass);
            this.innerWrapper = ej.buildTag("span.e-in-wrap e-box");
            this.wrapper.append(this.innerWrapper).insertBefore(this.element);
            this.innerWrapper.append(this.element);
            this._hiddenInput = ej.buildTag("input#" + this._id + "_hidden", "", {}, { type: "hidden" }).insertBefore(this.element);
            if (!this._isWatermark && this.model.inputMode != "password") {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this.model.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.bind("mousedown", $.proxy(this._OnFocusHandler, this));
            }
            if(ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") this.model.value =  this.element[0].value;
            if (!ej.isNullOrUndefined(this.model.value)) {
                this.wrapper.addClass('e-valid');
                if (typeof this.model.value == "number")
                    this.model.value = this.model.value.toString();
            }
            this._hiddenInput.attr({ "name": this.model.name, "value": this.model.value });
            this.element.attr({ 'aria-invalid': false }).addClass('e-input')
            if (this.model.maskFormat == "" && this.model.value == null) {
                var proxy = this;
                setTimeout(function () {
                    if (proxy.element.val() != "") {
                        proxy.option('value', proxy.element.val());
                        proxy.previousValue = proxy.model.value;
                        proxy._initObjects();
                    }
                }, 500)
            }
            else this.element.attr({ 'value': this.model.value });
            if (ej.isNullOrUndefined(this._options.inputMode) && !ej.isNullOrUndefined(this.element.attr("type")))
                this.model.inputMode = this.element.attr("type");
            else
                this._setInputMode(this.model.inputMode);
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            this._roundedCorner(this.model.showRoundedCorner);
            this._setTextAlign(this.model.textAlign);
            this._setReadOnly(this.model.readOnly);
            this._controlStatus(this.model.enabled);
            this.previousValue = this.model.value;
        },

        _initObjects: function () {
            this._textbox = this.element[0];
            this._keypressFlag = 0;
            this._selectedTextKeyDown = 0;
            // KeyDown trace [ 0 - None, 1 - BackSpace, 2 - Delete]
            this._keydownFlag = 0;
            // Length of the Mask
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskLength = this.model.maskFormat.length;
            else {
                var _position = 0;
                for (var temp = 0; temp < this.model.maskFormat.length; temp++) {
                    if ((this.model.maskFormat[temp] == "\\"))
                        _position += 1;
                }
                this._maskLength = this.model.maskFormat.length - _position;
            }
            //Replacing all [9?$CANa*] to '_'           
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat;

            this._changeMask(this.model.locale);
            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
                this._valueMapper();
            }

            this._validatedValue = this._maskModel;
            if (this.model.inputMode != "password") {
                this._setValue(this.model.value);
                this._setWaterMark();
            }
            if (this.model.showError) {
                this.element.addClass("e-error").attr('aria-invalid', "true");
            }
        },


        _setWidth: function (value) {
            this.wrapper.width(value);
        },

        _setHeight: function (value) {
            this.wrapper.height(value);
        },

        _roundedCorner: function (value) {
            if (value && !this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.addClass('e-corner');
            }
            else if (this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.removeClass('e-corner');
            }
        },

        _setTextAlign: function (align) {
            if (align == "right") {
                this.element.css("text-align","");
                this.wrapper.addClass('e-rtl');
            }
            else {
                this.wrapper.removeClass('e-rtl');
                this.element.css("text-align",align);
            }
        },

        _setInputMode: function (type) {
            this.element.attr('type', type);
        },

        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) this.element.attr("readonly", true);
            else this.element.removeAttr("readonly");
        },

        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },

        _setWaterMark: function () {
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = $.trim(this.model.maskFormat.replace(/[9?CANa#&]/g, '_')) === "" ? null : this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat === "" ? null : this.model.maskFormat;
            if ((this._maskModel != ''&&this._maskModel !=null&& this._textbox.value == formatValue) || (formatValue == '' && this._textbox.value == "") && this.model.inputMode != "password") this._textbox.value = "";
            if(this.model.watermarkText.length==0 && !ej.isNullOrUndefined(this.element.attr("placeholder"))) this.model.watermarkText = this.element.attr("placeholder");
            if (this.model.watermarkText) {
                if (this._isWatermark)
                    this.element.attr("placeholder", this.model.watermarkText);
                else {
                    if (this._textbox.value) this._hiddenSpan.css("display", "none").text(this.model.watermarkText);
                    else this._hiddenSpan.css("display", "block").text(this.model.watermarkText);
                }
            }
            if (!this.model.watermarkText && !this._textbox.value && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
            else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if ((this._textbox.value == formatValue || this._textbox.value == '' || $.trim(this.get_StrippedValue()) == "") && this.model.inputMode != "password") this._textbox.value = "";
            (this._isWatermark ? this.element.attr("placeholder", text) : this._hiddenSpan.text(text))
            if (!this.model.watermarkText && $.trim(this.get_StrippedValue()) == "" && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
                else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _showAlert: function () {
            var ptr = this;
            this.element.addClass("e-error").attr('aria-invalid', "true").animate({ Opacity: 1 }, 700, null, function () {
                $(ptr._textbox).removeClass("e-error").attr('aria-invalid', "false");
            });
        },

        _unMask: function () {
            var tempModel = "";
            var valueIndex = -1, maskIndex = 0, i = 0, chr, prompt = "_", rule;
            var replacestring = this.model.value.toString();
            var tempValue = replacestring.replace(/[\(\)-]/g, "");
            while (maskIndex < this._rules.length) {
                chr = tempValue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    tempModel += chr === prompt ? prompt : "";
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined && chr.match(this._rules[maskIndex].rule)) {
                    var charCode = tempValue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        tempModel += tempValue.charAt(i);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = tempValue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            tempModel += tempValue.charAt(i);
                            maskIndex++;
                            i++;
                        }
                    } else { i++; maskIndex++;}
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            return tempModel;
        },

        _validateValue: function () {
            if (ej.isNullOrUndefined(this.model.value)) return;
            var tempValue = this.model.value;
            var tempModel = this._maskModel;
            var valueIndex = -1, maskIndex = i = 0, chr, prompt = "_", rule;
            var oldvalue = this._unMask();
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            // Check if Mask is Empty display the text
            if (this._maskLength == 0) {
                this._textbox.value = tempValue;
                this._setWaterMark();
                return true;
            }
            else {
                var replacestring = this.model.value.toString();
                if (!((this.model.maskFormat.indexOf("\\") >= 0)) && this.model.customCharacter == null)
                    tempValue = this.model.value = replacestring.replace(/[\(\)-]/g, "");
                else
                    tempValue = this.model.value;
            }

            while (maskIndex < this._rules.length) {
                chr = oldvalue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    chr === prompt ? prompt : "";
                    var strBefore = tempModel.substring(0, maskIndex);
                    var strAfter = tempModel.substring(maskIndex);
                    tempModel = strBefore + chr + strAfter.substr(1, strAfter.length);
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined ) {
                    var charCode = oldvalue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = oldvalue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            var strBefore = tempModel.substring(0, maskIndex);
                            var strAfter = tempModel.substring(maskIndex);
                            tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                            maskIndex++;
                            i++;
                        } else maskIndex++;
                    } else {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + prompt + strAfter.substr(1, strAfter.length);
                        i++;
                        maskIndex++;
                    }
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            if (this.model.value) {
                this._textbox.value = tempModel;
                this.model.value = this.get_UnstrippedValue();
                if (!((this.model.maskFormat.indexOf("\\") >= 0) || (this.model.maskFormat.indexOf("&") >= 0))) {
                    if (!this.model.hidePromptOnLeave) this._textbox.value = tempModel;
                    else { this._unStrippedMask = tempModel.replace(/[ ]/g, '_'); this._textbox.value = tempModel; }
                }         
                else {
                    this._textbox.value = "";
                    var _tPos = 0;
                    for (_pos = 0; _pos < this.model.maskFormat.length; _pos++) {
                        if (this.model.maskFormat[_pos] == "\\")
                            _tPos += 1;
                    }
                    var _position = 0;
                    if (this.model.value.length == tempModel.length - _tPos) {
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos] == "\\")
                                _position = _position + 1;
                            else if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempValue[pos - _position];
                            else if (!(this.model.maskFormat[pos] == "\\")) {
                                if (tempValue.length <= pos - _position)
                                    this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                                else
                                    this._textbox.value += tempValue[pos - _position].replace(/[9?CANa#&]/g, '_');
                            }

                        }
                    }
                    else {
                        this._textbox.value = "";
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempModel[pos];
                            else if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                        }
                    }

                }
            }
            else {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];

                        else if (!(this.model.maskFormat[pos] == "\\"))
                            this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');

                    }
                }
            }
            if (this._textbox.value != undefined && this.model.hidePromptOnLeave) {
                this._unStrippedMask = this._textbox.value.replace(/[ ]/g, '_');
                this._textbox.value = this.get_UnstrippedValue();
            }
            if (this._maskModel!=null &&(this._textbox.value.indexOf(">") >= 0 || this._textbox.value.indexOf("<") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');                
            }
            if (!this.model.showPromptChar)
                this._textbox.value = this.get_UnstrippedValue();
            // Update the character to upper and lower case.
            if (this._tempMask != null) {
                for (var i = 0; i < this._textbox.value.length; i++) {
                    var tempkey = this._updateCasing(this._textbox.value[i], i);
                    if (!ej.isNullOrUndefined(tempkey))
                        this._textbox.value = this._textbox.value.substring(0, i) + tempkey + this._textbox.value.substring(i + tempkey.length);
                }
            }
            
            this._setWaterMark();
        },


        _selectionText: function (begin, end) {
            var replaceValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(begin, end):"";
            this._textbox.value = this._textbox.value.substring(0, begin) + replaceValue + this._textbox.value.substring(end);
            if (this._keydownFlag == 1) {
                this._setCaretPosition(begin);
                return begin;
            }
            else if (this._keydownFlag == 2) {
                this._setCaretPosition(end);
                return end;
            }
            return begin;
        },


        _caretPosition: function (textbox) {
            var caretPos = 0;
            // Microsoft supports only IE for using document.selection
            if (document.selection) {
                // Create a Range of selected position
                var selectedRange = document.selection.createRange();
                var selectionLength = selectedRange.text.length;
                // Move selection start to 0 position
                selectedRange.moveStart('character', -textbox.value.length);
                // Get caret position by selection length, becoz now range is from Zero to current focus
                caretPos = selectedRange.text.length - selectionLength;
                if (selectionLength != 0) {
                    caretPos = this._selectionText(caretPos, selectedRange.text.length);
                    this._selectedTextKeyDown = 1;
                }
            }
            // For Firefox
            else if (textbox.selectionStart || textbox.selectionStart == '0') {
                caretPos = textbox.selectionStart;
                if (textbox.selectionStart != textbox.selectionEnd) {
                    if (this._keydownFlag)
                        caretPos = this._selectionText(textbox.selectionStart, textbox.selectionEnd);
                    this._selectedTextKeyDown = 1;
                }
            }
            return (caretPos);
        },


        _setCaretPosition: function (caretPos) {
            var element = this._textbox;
            //For IE
            if (window.navigator.appName == "Microsoft Internet Explorer") {
                if (element.createTextRange) {
                    var range = element.createTextRange();
                    range.move('character', caretPos);
                    range.select();
                }
            }
            else
            /* For FireFox and Chrome */
                if (element.selectionStart || element.selectionStart == '0') {
                    element.focus();
                    element.setSelectionRange(caretPos, caretPos);
                }
                else
                    element.focus();
        },


        _validateChars: function (keyChar, caretPos) {
            var charmap = this._charMap, match = false;
            if (this.model.maskFormat.indexOf("\\") >= 0) {
                _position = this._getCunrrentPos(caretPos);
                var maskChar = this.model.maskFormat.substr(caretPos + _position, 1);
            }
            else
                var maskChar = this.model.maskFormat.substr(caretPos, 1);
            var customChar = this.model.customCharacter;
            var actualkey = String.fromCharCode(keyChar);
            $.each(charmap, function (key, value) {
                if (maskChar == key) {
                    if (customChar != null) {
                        if (key == "C")
                            value = "[" + customChar + "]";
                        else if (key == "A" || key == "N" || key == "#")
                            value = value.replace(("]"), "") + customChar + "]";
                    }
                    if (actualkey.match(new RegExp(value))) match = true;
                    else match = false;
                }
            });
            return match;
        },


        _seekNext: function () {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = currentPos;
            var seekFlag = true;
            //seeking the focus to next valid position on right of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    var _position = 0;
                    for (var temp = 0; temp <= currentPos; temp++) {
                        if ((this.model.maskFormat[temp] == "\\"))
                            _position += 1;
                    }
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (this.model.maskFormat.charAt(currentPos + _position) != "\\" && this.model.maskFormat.charAt(currentPos + _position - 1) != "\\") {
                                if (!this._charMap[this.model.maskFormat.charAt(currentPos + _position)]) {
                                    this._setCaretPosition(currentPos);
                                    currentPos++;
                                }
                            }
                        }
                        else {
                            if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                                this._setCaretPosition(currentPos);
                                currentPos++;
                            }
                        }
                        if (currentPos != tempPos) {
                            tempPos = currentPos;
                            continue;
                        }
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _seekBefore: function (caretPos) {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = --currentPos;
            var seekFlag = true;
            // Stop Seek when backspace of select more than a char
            if (this._selectedTextKeyDown == 1)
                seekFlag = false;
            //seeking the focus to next valid position on left of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                            this._setCaretPosition(--currentPos);
                        }
                    }
                    if (currentPos != tempPos) {
                        tempPos = currentPos;
                        continue;
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _writeBuffer: function (key, cursorPos) {
            if (cursorPos <= this._maskLength) {
                var input = this._textbox.value;
                if (this._tempMask != null)
                    var tempkey = this._updateCasing(key, cursorPos);
                key = (tempkey == undefined) ? key : tempkey;
                var strBeforeCursor = input.substring(0, cursorPos);
                var strAfterCursor = input.substring(cursorPos);
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    var _position = 0;
                    for (var temp = 0; temp <= cursorPos; temp++) {
                        if ((this.model.maskFormat[temp].indexOf("\\") >= 0) && (cursorPos != 0))
                            _position += 1;
                    }
                    if (this.model.maskFormat[cursorPos + _position].indexOf("\\") >= 0)
                        this._textbox.value = strBeforeCursor + input[cursorPos] + strAfterCursor.substr(1, strAfterCursor.length);
                    else
                        this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                }
                else
                    this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                this._setCaretPosition(cursorPos + 1);
            }
        },

        _updateCasing: function (key, pos) {
            for (var i = 0; i < pos + 1; i++) {
                if (this._tempMask.substr(i, 1) == '<' || this._tempMask.substr(i, 1) == '>')
                    pos++;
            }

            for (var j = pos; j > -1; j--) {
                if (this._tempMask.substr(j, 1) == '<') {
                    return key.toLowerCase();
                }
                else if (this._tempMask.substr(j, 1) == '>') {
                    return key.toUpperCase();
                }
            }
        },


        get_StrippedValue: function () {
            var i, value, mask = this.model.maskFormat, stripVal = null;
            value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value;
            if (mask.length == 0) return value;
            var _position = 0;
            for (var i = 0; i < mask.length; i++) {
                stripVal = $.trim(stripVal);
                if ((this.model.maskFormat.indexOf("\\") >= 0)) {
                    if ((this.model.maskFormat[i] == "\\"))
                        _position += 1;
                    else if (this.model.maskFormat[i - 1] == "\\")
                        stripVal += this._textbox.value[i - _position];
                    else {
                        var char = mask[i], exp = null;

                        if ("9?$a*".indexOf(char) != -1)
                            exp = this._charMap[char];
                        else if (char == "A" || char == "N" || char == "#")
                            exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                        else if (char == "C")
                            exp = "[" + this.model.customCharacter + "]";
                        else if (char == "&")
                            stripVal += value[i - _position];
                        if (exp && value[i - _position] && value[i - _position].match(new RegExp(exp)))
                            stripVal += value[i - _position];
                    }

                }
                else {
                    var char = mask[i], exp = null;

                    if ("9?$a*".indexOf(char) != -1)
                        exp = this._charMap[char];
                    else if (char == "A" || char == "N" || char == "#")
                        exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                    else if (char == "C")
                        exp = "[" + this.model.customCharacter + "]";
                    else if (char == "&")
                        stripVal += value[i - _position];
                    if (exp && value[i] && value[i].match(new RegExp(exp)))
                        stripVal += value[i];
                }
            }
            return stripVal;
        },


        get_UnstrippedValue: function () {
            var value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value, unstripVal = null;
            if (this.model.maskFormat.length == 0) return value;

            if (value != undefined)
                unstripVal = $.trim(value.replace(/[_]/g, " ")) == "" ? null : value.replace(/[_]/g, " ");
            return unstripVal;
        },

        _setValue: function (value) {
            if (ej.isNullOrUndefined(value) || $.trim(value) == "") value = null;
            this.model.value = value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") {
                this._validateValue();
                if (ej.isNullOrUndefined(this.model.value)) { 
                    this._textbox.value = ej.isNullOrUndefined(value) ? "" : value; 
                    this._unStrippedMask = this._maskModel; 
                }
            }
            else { this._textbox.value = ej.isNullOrUndefined(value) ? "" : value;  this._unStrippedMask = this._textbox.value; }
            this._setWaterMark();
        },


        _valueMapper: function () {
            var mapper = [], mapperIdx = 0, mask = this.model.maskFormat || "", maskChars = mask.split(""), i = 0, chr;
            var emptyMask = "", rule, rules = this._charMap, promptChar = "_";

            for (; i < mask.length; i++) {
                chr = maskChars[i];
                rule = rules[chr];
                if (rule) {
                    mapper[mapperIdx] = { rule: rule };
                    emptyMask += promptChar;
                    mapperIdx += 1;
                } else {
                    if (chr === "\\") {
                        idx += 1;
                        chr = maskChars[idx];
                    }
                    chr = chr.split("");
                    for (var j = 0; j < chr.length; j++) {
                        mapper[mapperIdx] = chr[j];
                        emptyMask += chr[j];
                        mapperIdx += 1;
                    }
                }
            }
            this._rules = mapper;
            this._emptyMask = emptyMask;
            this._maskLength = emptyMask.length;
        },
        _changeMask:function(locale){
            if (this._maskModel.length != 0) {
                var preferredlocale = ej.preferredCulture(locale), groupSep, currecySymbol, decimalSep,unmask = "";
                groupSep = preferredlocale.numberFormat[','];
                currecySymbol = preferredlocale.numberFormat.currency.symbol;
                decimalSep = preferredlocale.numberFormat['.'];
                for (var i = 0; i < this._maskModel.length; i++) {
                    if (this._maskModel[i] == ",")
                        unmask += groupSep;
                    else if (this._maskModel[i] == ".")
                        unmask += decimalSep;
                    else if (this._maskModel[i] == "$")
                        unmask += currecySymbol;
                    else
                        unmask += this._maskModel[i];
                }
                this._maskModel = unmask;
            }
        },
        _setMask: function (maskValue) {
            this._maskLength = maskValue.length;
            this.model.maskFormat = maskValue;
            this._tempMask = this.model.maskFormat;
            this._maskModel = maskValue.replace(/[9?CANa]/g, '_');
            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }            
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") 
                this._validateValue();
            else if (!this.model.watermarkText && this._textbox.value != this._maskModel) {
                if (!this.model.maskFormat) {
                    unstripVal = this._unStrippedMask.replace(/[_]/g, " ");
                    this._textbox.value = (this.model.customCharacter == null) ? $.trim(unstripVal.replace(/[\(\)-]/g, "")) : $.trim(unstripVal);
                    this._unStrippedMask = this._textbox.value;
                }
                else if (this.model.hidePromptOnLeave) {
                    this._textbox.value = this._maskModel;
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._textbox.value = this._maskModel;
            }
        },

        enable: function () {
            this.element.disabled = false;			
            this.element.removeAttr("disabled").removeClass('e-disable').attr({ "aria-disabled": false });
            if (this.wrapper.find('.e-placeholder').length > 0) this.wrapper.find('.e-placeholder').removeAttr("disabled", "disabled");
			this.wrapper.removeClass('e-disable-wrap');
            this.model.enabled = true;
        },

        disable: function () {
            this.element.disabled = true;
            this.element.attr("disabled", "disabled").addClass('e-disable').attr({ "aria-disabled": true });
            if (this.wrapper.find('.e-placeholder').length > 0) this.wrapper.find('.e-placeholder').attr("disabled", "disabled");
			this.wrapper.addClass('e-disable-wrap');
            this.model.enabled = false;
        },

        clear: function () {
            this._textbox.value = this.model.maskFormat.replace(/[9?aCAN]/g, '_');
            this.model.value = this.get_StrippedValue();
        },

        _wireEvents: function () {
            this._on(this.element, 'focus', this._OnFocusHandler);
            this._on(this.element, 'blur', this._OnBlurHandler);
            this._on(this.element, 'keydown', this._OnKeyDownHandler);
            this._on(this.element, 'keypress', this._OnKeyPressHandler);
            this._on(this.element, 'keyup', this._OnKeyUpHandler);
            this._on(this.element, 'mouseover', this._OnMouseOverHandler);
            this._on(this.element, 'mouseout', this._OnMouseOutHandler);
            this._on(this.element, 'paste', this._OnPasteHandler);
            this._on(this.element, 'cut', this._OnCutHandler);
        },

        _OnCutHandler: function (e) {
            var selectedValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(this._textbox.selectionStart, this._textbox.selectionEnd):"";
            var beforeSelection = this._textbox.value.substring(0, this._textbox.selectionStart);
            var afterSelection = this._textbox.value.substring(this._textbox.selectionEnd);
            var cursorPosition = this._textbox.selectionStart;
            var context = this;
            setTimeout(function () {
                context._textbox.value = beforeSelection + selectedValue + afterSelection;
                context._setCaretPosition(cursorPosition);
                context._raiseEvents("change");
            }, 0);
        },


        _OnPasteHandler: function (e) {
            var context = this;
            setTimeout(function () {
                var text = $(context._textbox).val();
                context._setValue(text);
                context._raiseEvents("change");
            }, 0);
            return true;
        },


        _OnFocusHandler: function (e) {
            this.wrapper.addClass("e-focus");
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (this.model.readOnly)
                return;
            this._focusValue = this.model.value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (this._textbox.value == "" && this._maskModel != "" && this.model.inputMode != "password")
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    this._textbox.value = this.model.watermarkText;
                }
                else
                    this._textbox.value = ej.isNullOrUndefined(this._maskModel) ? "" : formatValue;
            if (this._maskModel != null && (this._textbox.value.indexOf("<") >= 0 || this._textbox.value.indexOf(">") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._maskModel = this._textbox.value;
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }

            if (this._textbox.value != formatValue && this._unStrippedMask != null && this.model.hidePromptOnLeave)
                this._textbox.value = this._unStrippedMask;

            if (!this.model.showPromptChar) this._textbox.value = this.get_UnstrippedValue();

            $.fn.selectRange = function (start, end) {
                return this.each(function () {
                    if (this.setSelectionRange) {
                        this.focus();
                        this.setSelectionRange(start, end);
                    } else if (this.createTextRange) {
                        var range = this.createTextRange();
                        range.collapse(true);
                        range.moveEnd('character', end);
                        range.moveStart('character', start);
                        range.select();
                    }
                });
            };
            if (this.model.maskFormat) {
                $(this.element).selectRange(0, 0);
            }

            this._raiseEvents("focusIn");
        },

        _OnBlurHandler: function (e) {
            this.wrapper.removeClass("e-focus");            
            this.model.value = this.get_StrippedValue();
            var dup = new Array();
            var option = new Array();
            if ((this._textbox.value.indexOf('_') != -1 || this._textbox.value.indexOf(' ') != -1)&& !ej.isNullOrUndefined(this.model.value)) {
                for (var i = 0; i < this.model.maskFormat.length; i++) {
                    if ((this.model.maskFormat[i] == "A") || (this.model.maskFormat[i] == "?")) dup.push(i);
                    else if ((this.model.maskFormat[i] == "9") || (this.model.maskFormat[i] == "a") || (this.model.maskFormat[i] == "C")) {
                        option.push(i);
                    }
                }
                for (var i = 0; i < dup.length; i++) {
                    if (this._textbox.value[dup[i]] === "_") {
                        this._showAlert();
                        this.model.value = this._textbox.value;
                    }
                }
                for (var i = 0; i < option.length; i++) {
                    if ((this.model.value[option[i]] == "_") || (this.model.value[option[i]] == " ")) {
                        this.model.value = this.model.value.substr(0, option[i]) + this.model.value.substr(option[i] + 1, this.model.value.length)
                        for (var j = i; j < option.length; j++) {
                            option[j] = option[j] - 1;
                        }
                    }
                }
            }
            this.model.value = (this.model.value != null) ? this.model.value.replace(/\s+/g, "") : this.model.value;
            if (this._textbox.value != undefined && (this.model.watermarkText == "" || (this.model.watermarkText != "" && this.model.value != ""))) {
                if (this.model.hidePromptOnLeave) {
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._unStrippedMask = this._textbox.value;
            }
            if (this.model.inputMode != "password")
                this._setWaterMark();
            this._raiseEvents("change");
            this._raiseEvents("focusOut");
        },


        _OnKeyDownHandler: function (e) {
            if (this.model.readOnly) return;
            this._keypressFlag = 0;
            this._raiseEvents("onKeyDown", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });

            this.element.removeClass("error");

            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var currentPos = this._seekNext();
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var val = ej.browserInfo().name;
            if ((val == "msie") && (this._textbox.value == "")) {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];
                        else

                            if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');
                    }
                }
                this._setCaretPosition(currentPos);
            }

            if (unicode >= 35 && unicode <= 41) {
                if (window.navigator.appCodeName == "Mozilla" || window.navigator.appCodeName == "opera") {
                    this._keypressFlag = 1;
                }
            }
            if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 88))) {
                this._keypressFlag = 1;
                return;
            }
            else if (unicode == 8) {

                if (this.model.inputMode != "password") {
                    this._keydownFlag = 1;
                    // Seek to next valid position
                    var currentPos = this._seekBefore();
                    if (!this._selectedTextKeyDown) {
                        if (currentPos >= 0 && currentPos < this._maskLength)
                            this._writeBuffer(promptChar, currentPos);                       
                        this._setCaretPosition(currentPos);
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown)
                    {                        
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos+1);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
            else if (e.keyCode == 46 || e.keyCode == 127) {
                if (this.model.inputMode != "password") {
                    this._keydownFlag = 2;
                    // Seek to next valid position
                    currentPos = this._seekNext();
                    if (!this._selectedTextKeyDown) {
                    if (currentPos >= 0 && currentPos < this._maskLength) {                        
                        _position=this. _getCunrrentPos(currentPos);
                            if (!((this.model.maskFormat[currentPos + _position] == "&")))
                                this._writeBuffer(promptChar, currentPos);
                        }
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown) {
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
        },


        _ErrorHandler: function (currentPos) {
            var promptChar = this.model.showPromptChar ? "_" : " ";
            if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
            this._setCaretPosition(currentPos);
            this._showAlert();
        },
        _getCunrrentPos: function (currentPos) {
            var _position = 0;
            for (var temp = 0; temp <= currentPos + _position; temp++) {
                if ((this.model.maskFormat[temp] == "\\"))
                    _position += 1;
            }
            return _position;
        },


        _OnKeyPressHandler: function (e) {
            if (this.model.readOnly) return;
            this._raiseEvents("keyPress", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var currentPos = this._seekNext();
            var val = ej.browserInfo().name;
            if (this._validateChars(unicode, currentPos)) {
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else {
                    if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
                    if (this.model.maskFormat.indexOf("\\") >= 0) {
                        if (currentPos < this._maskLength)
                            this._writeBuffer(actualkey, currentPos);
                    }
                    else
                        this._writeBuffer(actualkey, currentPos);
                }
            }
            else
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else if (this.model.maskFormat.indexOf("&") >= 0 || this.model.maskFormat.indexOf("\\") >= 0) {
                    _position = this._getCunrrentPos(currentPos);
                    if (!((this.model.maskFormat[currentPos + _position] == "&") && (unicode == 127))) {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (currentPos < this._maskLength) {
                                if (this._validateChars(unicode, currentPos + _position) || (this.model.maskFormat[currentPos + _position - 1] == "\\"))
                                    this._writeBuffer(actualkey, currentPos);
                                else
                                    this._ErrorHandler(currentPos);
                            }
                        }
                        else {
                            if (this._validateChars(unicode, currentPos + _position))
                                this._writeBuffer(actualkey, currentPos);
                            else
                                this._ErrorHandler(currentPos);
                        }
                    }
                }
                else
                    this._ErrorHandler(currentPos);

            if (!this._keypressFlag && unicode != 9) {
                this._keypressFlag = 0;
                e.preventDefault();
                return false;
            }
            this._keypressFlag = 0;
        },

        _OnKeyUpHandler: function (e) {
            if (this._maskLength == 0) this._raiseEvents("change");
            this._raiseEvents("keyUp", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (!ej.isNullOrUndefined(this.model.validationRules)) this._hiddenInput.valid();
        },


        _OnMouseOverHandler: function (e) {
            this._raiseEvents("mouseOver");
        },


        _OnMouseOutHandler: function (e) {
            this._raiseEvents("mouseOut");
        },


        _raiseEvents: function (eventName, isCode, additionalArgs) {
            var eventArgs, strippedVal = this.get_StrippedValue(), unstrippedVal = this.get_UnstrippedValue();
            this.model.value = unstrippedVal !== null ? (this.model.customCharacter == null && $.trim(unstrippedVal.replace(/[\(\)-]/g, "")) == "") ? null : unstrippedVal : null;
            if (eventName == "change") {
                if (this.previousValue != this.model.value) {
                    this.previousValue = this.model.value;
                }
                else {
                    if (this._focusValue == this.model.value)
                        return false;
                }
            }
            eventArgs = { value: unstrippedVal, unmaskedValue: strippedVal };
            if (eventName == "change") eventArgs["isInteraction"] = !isCode ;
            if (eventName == "change") {
                this._trigger("_change", eventArgs);
                ej.isNullOrUndefined(this.model.value) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            }
            if (additionalArgs) $.extend(true, eventArgs, additionalArgs);
			this._hiddenInput.val(strippedVal);
			this._trigger(eventName, eventArgs);
			},

        _OnValueChange: function () {
            if (this._textbox.value == "" && this._maskModel != "")
                this._textbox.value = this._maskModel;
            this._setValue(this._textbox.value);
        }

    });

    ej.InputMode = {
		/**  support for user enter character in password format. */
		Password: "password", 
		/**  support for user enter character in normal format. */
        Text: "text"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Menu control.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejMenu", "ej.Menu", {

        element: null,

        model: null,
        validTags: ["ul"],
        _setFirst: false,
        _rootCss: "e-menu",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            animationType: "default",

            orientation: ej.Orientation.Horizontal,

            menuType: "normalmenu",
			
			isResponsive: true,

            contextMenuTarget: null,

            htmlAttributes: {},

            cssClass: "",

            openOnClick: false,

            subMenuDirection: "none",

            enableCenterAlign: false,

            showRootLevelArrows: true,

            showSubLevelArrows: true,

            enableAnimation: true,
            
            container: null,

            enableSeparator: true,

            enabled: true,

            overflowHeight: "auto",

            overflowWidth: "auto",

            fields: {

                child: null,

                dataSource: null,

                query: null,

                tableName: null,

                id: "id",

                parentId: "parentId",

                text: "text",

                spriteCssClass: "spriteCssClass",

                url: "url",

                imageAttribute: "imageAttribute",

                htmlAttribute: "htmlAttribute",

                linkAttribute: "linkAttribute",

                imageUrl: "imageUrl",
            },

            enableRTL: false,

            titleText: "Menu",

            locale: "en-US",

            excludeTarget: null,

            beforeOpen: null,

            open: null,

            close: null,

            mouseover: null,

            mouseout: null,

            click: null,

            keydown: null,

            overflowOpen: null,

            overflowClose:null,

            create: null,

            destroy: null
        },

        dataTypes: {
            animationType: "enum",
            cssClass: "string",
            titleText: "string",
            locale: "string",
            openOnClick: "boolean",
            enabled: "boolean",
            enableCenterAlign: "boolean",
            showArrow: "boolean",
            showRootLevelArrows: "boolean",
            showSubLevelArrows: "boolean",
            enableSeparator: "boolean",
			isResponsive: "boolean",
            enableRTL: "boolean",
            enableAnimation: "boolean",
            fields: {
                dataSource: "data",
                query: "data",
                child: "data"
            },
            excludeTarget: "string",
            htmlAttributes: "data"
        },


        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "menuType":
                        jsondata[key] = this.model.menuType;
                        break;
                    case "fields":
                        this._wireEvents("_off");
                        this.element.empty().insertBefore(this.wrapper);
                        this.wrapper.remove();
                        $.extend(this.model.fields, jsondata[key]);
                        this._intializeData();
                        if (!this.model.enabled)
                            this._wireEvents("_off");
                        break;
                    case "orientation": this._setOrientation(jsondata[key]); break;
                    case "showRootLevelArrows": this._addArrow(jsondata[key], this.model.showSubLevelArrows); break;
                    case "showSubLevelArrows": this._addArrow(this.model.showRootLevelArrows, jsondata[key]); break;
                    case "enableSeparator": this._setSeparator(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "isResponsive":
                        if (this.model.isResponsive)
                            this._responsiveLayout();
                        else {
                            $(this.resWrap).remove();
                            $(this.wrapper).removeClass("e-menu-responsive");
                            $(this.element).removeClass("e-menu-responsive");
                            this.resWrap = null;
                        }
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "enableRTL": this._setRTL(jsondata[key]); break;
                    case "enableCenterAlign": this._centerAlign(jsondata[key]); break;
                    case "excludeTarget": this.model.excludeTarget = jsondata[key];
                        break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "animationType":
                        this._setAnimation(jsondata[key]);
                        break;
                    case "enableAnimation": this.model.enableAnimation = jsondata[key]; break;
                    case "openOnClick":
                            this._hoverOpen = !jsondata[key];
                            this._hoverClose = !jsondata[key]; 
                        break;
                    case "subMenuDirection": this._setSubMenuDirection(this.model.subMenuDirection); break;
                    case "titleText":
						this._titleText(jsondata[key]);
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "overflowHeight":                       
                            this._setOverflowDimensions("height",jsondata[key]); break;
                    case "overflowWidth":                      
                        this._setOverflowDimensions("width",jsondata[key]); break;

                }
            }
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Menu", this.model.locale);
        },
        		
        _setLocale: function () {
            this._titleText(this._localizedLabels.titleText);
        },
        _titleText: function(val){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                $(this.label).text(val);
        },

        _destroy: function () {
            this.model.menuType == ej.MenuType.ContextMenu ? this._referenceElement.append(this._cloneElement) : this._cloneElement.insertBefore(this.wrapper);
            this._cloneElement.removeClass('e-menu e-js');
            this.wrapper.remove();
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this.element.css("visibility", "hidden");
            this._setValues();
            this._intializeData();
            this.element.css("visibility", "visible");
        },

        _setValues: function () {
            this._mouseOver = true;
            this._hoverOpen = true;
            this._hoverClose = true;
            this._isMenuOpen = false;
            this._hideSpeed = 100;
            this._showSpeed = 100;
            this._isSubMenuOpen = false;
            this._isContextMenuOpen = false;
            this._disabledMenuItems = new Array();
            this._hiddenMenuItems = new Array();
            this._delayMenuHover = 0;
            this._delaySubMenuHover = 0;
            this._delaySubMenuShow = 0;
            this._preventContextOpen = true;
            this._setAnimation(this.model.animationType);
            this._isFocused = true;
            this._menuOverflowItems = new Array();
            this._menuHeaderItems = new Array();
            this._menuCloneItems = new Array();
            this._itemWidth = 0; 
        },
        _intializeData: function () {
            if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) {
                this._generateTemplate(this.model.fields["dataSource"]);
                this._renderMenu();
            }
            else {
                this._renderMenu();
                this._wireEvents("_on");
                this._calculateOverflowItems();
            }
        },
        _renderMenu: function () {
            this._renderControl();
            this._addArrow(this.model.showRootLevelArrows, this.model.showSubLevelArrows);
			this._renderArrow();
			this._intializeMenu();
            //item Width for width property		
			    this._itemWidth = this.element.width();
			    if (this.model.isResponsive) {
			        this._ensureResponsiveClasses($(window).width() < 767);
			    }
			    if (this.model.orientation == "horizontal") {
			        this._on(this.element.parent().find("span.e-check-wrap.e-icon"), "click", this._mobileResponsiveMenu);
			        if(this.model.fields["dataSource"] != null) this._calculateOverflowItems();
			    }
        },      

        _renderControl: function () {
            var label, checkBox, checkObj, list, spanlist, i;
            if (this.model.menuType == "normalmenu") {
                this.wrapper = ej.buildTag("div");
                this.wrapper.addClass(this.model.cssClass + " e-menu-wrap");
            } else
                this.wrapper = ej.buildTag("div.e-menu-wrap");
            if (this.model.isResponsive) this._responsiveLayout();
            if (this.model.menuType != ej.MenuType.ContextMenu) {
                this.wrapper.insertBefore(this.element);
                this.wrapper.append(this.element);
                }            
            this.element.addClass("e-menu e-widget e-box").attr({ "role": "menu", "tabindex": 0 });
            this._addAttr(this.model.htmlAttributes);
            if (this.model.enableRTL) this._setRTL(this.model.enableRTL);
            this._setSubMenuDirection(this.model.subMenuDirection);
            if (this.model.menuType == "normalmenu") {
                this.model.orientation == "horizontal" ? this.element.addClass("e-horizontal") : this.element.addClass("e-vertical");
            }
            //For ContextMenu Mode
            else this._contextMenu_Template();
            this._addClass();
            if (this.model.enableCenterAlign) this._centerAlign(this.model.enableCenterAlign);
            if (this.model.enableSeparator) this._setSeparator(true);
            (!this.model.enabled) && this.disable();
        },
        _renderPopupWrapper: function (e) {
            if(this._ensureOverflowPopup()){                          
                this.popupWrapper = ej.buildTag("div.e-menu-popwrap");                         
                this.popupWrapper.insertAfter(this.element);              
                var height = typeof value === "number" ? this.model.overflowHeight + "px" :this.model.overflowHeight;
                var width = typeof value === "number" ? this.model.overflowWidth + "px" : this.model.overflowWidth;
                this.popupWrapper.css({ "height": height,"width":width});
                this.popupWrapper.hide();
                this._addOverflowItems();                
            }
        
        },
        _calculateOverflowItems: function (e) {        
            if (this._ensureOverflowPopup()) {
                this.element.find("li.e-list").removeClass("e-menu-show");
                $(this.lastelement).removeClass("e-last");
                this._menuHeaderItems = [];  
                var menuHeaderWidth = this.element.outerWidth();               
                if (this.element.find("li.e-ham-wrap").length > 0) //for window resizing event neglect the hamburger icon list from the listCollection
                {                   
                    if ((this._itemWidth<=this.element.width())||(this._itemWidth>=this.element.width()) && (!(this._isOverflowPopupOpen()))) {
						if(!ej.isNullOrUndefined(this.popupWrapper))
							this.popupWrapper.hide();                        
                    }
                }
				this._renderHamburgerIcon();	
				this.element.find("li.e-ham-wrap").css({display: 'list-item'});
                var hamburgerWidth = this.element.find("li.e-ham-wrap").outerWidth(), itemsOuterWidth = 0, hideState=true;
				this.element.find("li.e-ham-wrap").hide();
                this._menuHeaderItems = this.element.find(">li.e-list");
                this._menuOverflowItems = [];
                for ( var i = 0; i < this._menuHeaderItems.length; i++) {
                   var menuItem = $(this._menuHeaderItems[i]);                                        
                        itemsOuterWidth = itemsOuterWidth + menuItem.outerWidth();
                        if (itemsOuterWidth < menuHeaderWidth) {                      
                            menuItem.removeClass('e-menu-hide');
							this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");
                            if (this.model.enableSeparator) this._setSeparator(true);                  
                        }
                        else {
							if(hideState)
							{
								hideState=false;
								this.element.find("li.e-ham-wrap").css({display: 'list-item'}); 
								itemsOuterWidth = itemsOuterWidth - menuItem.outerWidth() + hamburgerWidth;
								if(i>1){
									(itemsOuterWidth = itemsOuterWidth - $(this._menuHeaderItems[i-1]).outerWidth());
									i=i-2;
								}								
								continue;
							}
                            this._menuOverflowItems.push($(menuItem).clone(true));                            
                            menuItem.addClass('e-menu-hide');                            
                        }
                }            
                if (this._menuOverflowItems.length>0) {
                    this._renderHamburgerIcon();
                    $('.e-menu-popwrap').length ?  this._addOverflowItems():  this._renderPopupWrapper();                     
                    this.lastelement = this.element.find('>li.e-list:visible').last().addClass('e-last');
                    this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");            
                }
                else if (this._menuOverflowItems.length == 0 && $("li.e-ham-wrap").length > 0) {
                    this.element.find("li.e-ham-wrap").remove();
                }

            }           
            if (this.model.orientation == "vertical" || this.model.menuType == ej.MenuType.ContextMenu && ($(window).width() >= 768) && (this.model.isResponsive)) {
                this.element.find("span.e-icon.e-arrowhead-down").removeClass('e-arrowhead-down').addClass('e-arrowhead-right');
            }
            

        },
        _renderHamburgerIcon: function () {
            if((this._ensureOverflowPopup())&& (this.element.find("li.e-ham-wrap").length==0)){            
                var liTag = ej.buildTag("li.e-ham-wrap");
                var divTag = ej.buildTag("div");
                this.hamburgerspan = ej.buildTag('span.e-hamburger');                                                     
                divTag.append(this.hamburgerspan);
                liTag.append(divTag);    
                this.element.append(liTag);
                //to set border
                if (this.model.height != 0) this._setHeight(this.model.height);
                else {                       
                    $("li.e-ham-wrap").css({"height":this.element.find("li.e-list").first().height()});
                }
                //button click event
                this._on(this.element.find("li.e-ham-wrap"), "click", this._overflowOpen);                
            }
        },
        _addOverflowItems: function () {
            if ((this._ensureOverflowPopup()) && ($('.e-menu-popwrap').length>0)) {
				if(!ej.isNullOrUndefined(this.popupWrapper)){
					this.popupWrapper.empty();
					this._menuCloneItems.length = 0;                
					for (var i = 0; i < this._menuOverflowItems.length; i++) {
						this._menuCloneItems.push($(this._menuOverflowItems[i]).clone(true));                    
					}
					this.ulTag = ej.buildTag("ul");
					this.ulTag.addClass("e-menu e-js e-responsive e-widget e-box e-vertical");
					this.popupWrapper.append(this.ulTag);
					for (var i = 0; i < this._menuCloneItems.length; i++) {
						if ($(this._menuCloneItems[i]).hasClass('e-haschild')) {
							$(this._menuCloneItems[i]).find('span.e-icon').removeClass('e-arrowhead-down e-arrowhead-right').addClass('e-arrowhead-down');
							$(this._menuCloneItems[i]).children('span.e-menu-arrow.e-menu-left').remove();                       
						}
						this.ulTag.append(this._menuCloneItems[i]);
					}
					$(this.ulTag).children("li").removeClass("e-menu-hide");
					//to set width of ULTag          
					var popupWidth = Math.round(this.popupWrapper.width());
					if (popupWidth>0) {
						var popupWrapperWidth = this.popupWrapper.innerWidth();
						this.popupWrapper.find("ul.e-menu").css({ "width":popupWrapperWidth+ "px" });                
					}
					//to set the separator                  
					if (this.model.enableSeparator) this._setSeparator(true);                    
				}
            }         
        },
        _overflowOpen: function (e) {           
            if(this._isOverflowPopupOpen ()){   
                //set popup wrapper left position 
                 var location = ej.util.getOffset(this.element);
					var left = location.left + (this.model.enableRTL? 0 :(this.element.outerWidth() - this.popupWrapper.outerWidth()));
					var top = location.top + this.element.outerHeight();
					
					if(this.wrapper.parent().length && (this.wrapper.parent().css("position") == "absolute" || this.wrapper.parent().css("position") == "relative"))
					{
						location = ej.util.getOffset(this.wrapper.parent());
						left = left-location.left;
						top = top-location.top;
					}						
					this.popupWrapper.css({ "left": left,"top":top});                          
                this.popupWrapper.show();                                
                this._trigger("overflowOpen",  {e:e});
            }
            else {
                this._overflowClose(e);
            }
        },           
        _overflowClose: function (e) {
            if(this._ensureOverflowPopup() && !ej.isNullOrUndefined(this.popupWrapper)){            
                this.popupWrapper.find("li.e-list").removeClass(".e-mhover.e-active.e-mfocused");
                this._hideAnimation(this.popupWrapper.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
                this.popupWrapper.hide();                               
                this._trigger("overflowClose", { e: e });
            }
        },
        _isOverflowPopupOpen: function () {
		       if($(this.popupWrapper).length>0)
            return this.popupWrapper.css("display")=="none";           
        },
        _removePopup:function(e){
            if(($(window).width()<767)&& (this.model.isResponsive)){
			        this._ensureResponsiveClasses($(window).width());
                if ((this.element.find("li.e-ham-wrap").length > 0) && (this.popupWrapper.length>0)){
                    this.element.find("li.e-ham-wrap").remove();
                    $('.e-menu-popwrap').remove();                   
                    this.element.find("li.e-list").addClass("e-menu-show");             
                }
            }          
        },      
        _mobileResponsiveMenu:function(e){            
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ((this.element.css("display")=="none"))) {
                    this.element.removeClass("e-res-hide").addClass("e-res-show");                 
                }
            else if((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && (!(this.element.css("display")=="none")))
                {
                    this.element.removeClass("e-res-show").addClass("e-res-hide");                    
                }          
        },
        _ensureOverflowPopup:function(e){
            return (this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ($(window).width() >= 768) && (this.model.isResponsive);                
        },
        _onResize:function(e){
			this.element.find("li.e-ham-wrap").hide(); 
            $(window).width()>=768 ? this._calculateOverflowItems() : this._removePopup();
        },
        _ensureResponsiveClasses:function(viewport){
            if (viewport && this.element.find("span.e-icon").hasClass("e-arrowhead-right") ) this.element.find("span.e-icon.e-arrowhead-right").removeClass('e-arrowhead-right').addClass('e-arrowhead-down');            
        },

        _responsiveLayout: function () {
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
                this.wrapper.addClass("e-menu-responsive");
                this.element.addClass("e-menu-responsive")
                this.resWrap = ej.buildTag('span.e-menu-res-wrap e-menu-responsive');
                this.inResWrap = ej.buildTag('span.e-in-wrap e-box e-menu-res-in-wrap');
                this.label = ej.buildTag('span.e-res-title').html(this.model.locale == "en-US" ? this.model.titleText : (ej.Menu.Locale[this.model.locale] && ej.Menu.Locale[this.model.locale].titleText)?ej.Menu.Locale[this.model.locale].titleText:this.model.titleText);
                this.check = ej.buildTag('span.e-check-wrap e-icon');
                this.wrapper.append(this.resWrap)
                this.resWrap.append(this.inResWrap);
                this.inResWrap.append(this.label).append(this.check);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },

        _oncheck: function (e) {
            var obj = this.element.parents('.e-menu-wrap').children('.e-menu');
            e.isChecked ? obj.removeClass('e-res-hide').addClass('e-res-show') : obj.removeClass('e-res-show').addClass('e-res-hide');
        },
        _addClass : function (){
            //Adding arrows to items with sub items
            this.element.find('li:has("> ul")').find('> a,> span').addClass('aschild');
            this.element.find('>li').addClass('e-list').attr({ "role": "menuitem" });
			this.element.find('li').find(">a, >span").addClass('e-menulink');
            var list = this.element.find('.e-list a.aschild');
            var spanlist = this.element.find('.e-list span.aschild');
            var listElement, spanElement;
            for ( var i = 0; i < list.length; i++) {
                listElement = $(list[i]);
                listElement.siblings().attr({ "aria-hidden": true });
                listElement.parent().attr({ "aria-haspopup": true, "role": "menuitem" }).addClass("e-haschild");
                listElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
            for ( var i = 0; i < spanlist.length; i++) {
                spanElement = $(spanlist[i]);
                spanElement.siblings().attr({ "aria-hidden": true });
                spanElement.parent().attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                spanElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
        },
		_renderArrow : function(){
			 if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
				if( $($(this.element).find("span.e-menu-arrow")).length == 0){
					var arrow = ej.buildTag("span.e-menu-arrow e-menu-left");
					$(arrow).append("<span class='e-arrowMenuOuter'></span>").append("<span class='e-arrowMenuInner'></span>");
					this.element.find('>li.e-list.e-haschild').append(arrow);
				}
			 }
		},
        _generateTemplate: function (data) {
            var proxy = this, queryPromise;
            if (data instanceof ej.DataManager) {
                queryPromise = data.executeQuery(this._columnToSelect(this.model.fields));
                queryPromise.done(function (e) {
                    proxy._odataFlag = true;
                    proxy._generateItemTemplate(e.result);
                    proxy._wireEvents("_on");
                });
            } else {
                proxy._odataFlag = false;
                this._generateItemTemplate(proxy.model.fields['dataSource']);
                this._wireEvents("_on");
            }
        },

        _generateItemTemplate: function (items) {
            for (var i = 0; i < items.length; i++) {
                if ((items[i][this.model.fields.parentId] == null) || (items[i][this.model.fields.parentId] == 0)) {
                    var subItem = this._menuTemplate(items[i], items, this.model.fields);
                    this.element.append(subItem);
                }
            }
        },

        _menuTemplate: function (item, tableData, mapper) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr("class", 'e-list');
            if (item[mapper.htmlAttribute]) this._setAttributes(item[mapper.htmlAttribute], liTag);
			aTag = $(document.createElement('a'));
			aTag.attr("class", 'e-menulink');
			if (item[mapper.imageUrl] && item[mapper.imageUrl] != "") {
				imgTag = $(document.createElement('img'));
				imgTag.attr('src', item[mapper.imageUrl]);
				if (item[mapper.imageAttribute]) this._setAttributes(item[mapper.imageAttribute], imgTag);
				aTag.append(imgTag);
			}
			else if (item[mapper.spriteCssClass] && item[mapper.spriteCssClass] != "") {
				spanTag = $(document.createElement('span'));
				spanTag.addClass(item[mapper.spriteCssClass]);
				aTag.append(spanTag);
			}
			aTag.append(item[mapper.text]);
			if (item[mapper.linkAttribute]) this._setAttributes(item[mapper.linkAttribute], aTag);
			if (item[mapper.url])
				aTag.attr('href', item[mapper.url]);
			liTag.append(aTag);
            if (item[mapper.id]) {
                liTag.prop("id", item[mapper.id]);
            }
            if (!ej.isNullOrUndefined(mapper["child"])) {
                this._odataFlag = true;
                if (mapper["child"]["dataSource"] instanceof ej.DataManager) {
                    var proxy = this, queryManager = ej.Query();
					$(liTag).attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                    queryManager = this._columnToSelect(mapper["child"]);
                    queryManager.where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]);
                    var queryPromise = mapper["child"]["dataSource"].executeQuery(queryManager);
                    queryPromise.done(function (e) {
                        var childItems = e.result;
                        if (childItems && childItems.length > 0) {
                            var ul = $(document.createElement('ul'));
                            for (var i = 0; i < childItems.length; i++) {
                                var liItem = proxy._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                                ul.append(liItem);
                            }
                            liTag.append(ul);
                            $(liTag).children('a').addClass('aschild');
                            if ($(liTag).parent().hasClass('e-menu') && (proxy.model.showRootLevelArrows))
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
                            else if (proxy.model.showSubLevelArrows)
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
                        }
                    });
                    queryPromise.then(function (e) {
                        proxy._renderArrow();
                    });
                }
                else {
					var childItems;
					if(!ej.isNullOrUndefined(item.child)){
						if(ej.isPlainObject(item.child))
							childItems = ej.DataManager(mapper["child"]["dataSource"]).executeLocal(ej.Query().where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]));
						else if(item.child instanceof Array)
							childItems =  item.child;
					}	
                    if (childItems && childItems.length > 0) {
                        var ul = $(document.createElement('ul'));
                        for (var i = 0; i < childItems.length; i++) {
                            var liItem = this._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                            ul.append(liItem);
                        }
                        liTag.append(ul);
                    }
                }
            }
            else if (!this._odataFlag) {
                var childItems = ej.DataManager(mapper["dataSource"]).executeLocal(ej.Query().where(mapper["parentId"], ej.FilterOperators.equal, item[mapper.id]));
                if (childItems && childItems.length > 0) {
                    var ul = ej.buildTag('ul');
                    for (var i = 0; i < childItems.length; i++) {
                        var liItem = this._menuTemplate(childItems[i], mapper["dataSource"], mapper);
                        ul.append(liItem);
                    }
                    liTag.append(ul);
                }
            }
            return liTag;
        },

        _setAttributes: function (data, element) {
            for (var key in data) {
                if (key == "class")
                    element.addClass(data[key]);
                else
                    element.attr(key, data[key]);
            }
        },

        _addArrow: function (topArrows, bottomArrows) {
            if (topArrows) {
				var arrowIcon = (this.model.orientation == "horizontal") ? "e-arrowhead-down" : "e-arrowhead-right";
				this.element.find('>li.e-list:has("> ul")').children('a').append($('<span>').addClass("e-icon "+arrowIcon)).addClass("e-arrow-space");
			}
            else {
                this.element.find('>li.e-list:has("> ul")').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

            if (bottomArrows)
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else {
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

        },

        _intializeMenu: function () {
            if (this.model.height != 0) this._setHeight(this.model.height);
            if (this.model.width != 0) this._setWidth(this.model.width);
            if (this.model.menuType == "contextmenu")
                this.model.openOnClick = false;
            if (this.model.openOnClick) {
                this._hoverOpen = false;
                this._hoverClose = false;
            }
        },

        _setOrientation: function (val) {
            if (val == "horizontal") {
                this.element.removeClass("e-vertical e-horizontal").addClass("e-horizontal");
            } else {
                this.element.removeClass("e-horizontal e-vertical").addClass("e-vertical");
            }
            if (val == "vertical") {
                this._removePopup();
            }
        },

        _setHeight: function (value) {
            if (this.model.orientation == "horizontal" && value !=="auto") {
                value = typeof value === "number" ? value + "px" : value;
                this.element.find('> li').find('>a:first').css("line-height", value);
                if (this.model.showRootLevelArrows)
                    this.element.find('> li').find('>a:first').find('> span:first').css({ "line-height": value, "top": "0px" })
                if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")){
                    if ($("li.e-ham-wrap").length > 0) {                        
                        this.element.find("li.e-ham-wrap").children("div").css({ "line-height": value });
                        this.element.find("li.e-ham-wrap").css({ "height": value });
                        if($(".e-menu-popwrap").length>0)
                        this.popupWrapper.find("a.e-menulink").css({ "line-height":value });                        
                    }
                }
            }
            else
                this.element.height(value);
        },

        _setWidth: function (value) {
            this.element.css("width", value);
            if (this.model.orientation === "horizontal" && value !== "auto") {
                if (this.model.isResponsive)
                    this.resWrap.css("width", value);
            }
            if (this.model.orientation == "horizontal" &&  ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) ) {
                this._calculateOverflowItems();
            }
            
        },        
        _setOverflowDimensions:function(property,value){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                value = typeof value == "number" ? value + "px" : value;
                if (property == "height") this.popupWrapper.css({ height: value });
                else if (property == "width") this.popupWrapper.css({ width: value });                           
                this._addOverflowItems();
        },

        _setRTL: function (isRTL) {
            if (isRTL) {
                this.element.removeClass("e-rtl").addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
            if (isRTL && this.model.orientation === "horizontal")
                this.wrapper.removeClass("e-menu-rtl").addClass("e-menu-rtl");
            else
                this.wrapper.removeClass("e-menu-rtl");
			this.model.subMenuDirection = isRTL ? "left" : "right";
        },

        _setSubMenuDirection: function (direction) {
            if (direction != "left" && direction != "right")
                this.model.subMenuDirection = this.model.enableRTL ? "left" : "right";
        },

        _setAnimation: function (value) {
            value === "none" ? (this._showAnim = "none", this._hideAnim = "none") : (this._showAnim = "slideDown", this._hideAnim = "slideUp");
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _centerAlign: function (enableCenterAlign) {
            if (this.model.orientation == "horizontal" && enableCenterAlign)
                this.element.css('text-align', 'center');
            else
                this.element.css('text-align', 'inherit');
        },
        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (ej.isNullOrUndefined(mapper.query)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "child" && col !== "dataSource" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.fields["dataSource"].dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },


        _max_zindex: function () {
            var parents, bodyEle, maxZ, index;
            if (this.model.menuType == "contextmenu") {
                parents = $(this._targetElement).parents();
                parents.push(this._targetElement);
            }
            else
                parents = $(this.element).parents();
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;

        },

        _recursiveFunction: function (items, menuText) {
            var context = this;
            var isFound = false;
            $.each(items, function (key, value) {
                if (value.Text == menuText) {
                    context.selectedItem = value;
                    isFound = true;
                    return false;
                }
                else if (value.ChildItems != null) {
                    context._recursiveFunction(value.ChildItems, menuText);
                }
                if (isFound)
                    return false;
            });
        },

        _contextMenu_Template: function () {
            if(this.element[0].id !="")
            var oldWrapper = $(".e-menu-wrap #" + this.element[0].id).get(0);
            if (oldWrapper)
                $(oldWrapper.parentElement).remove();
            this.model.orientation = "vertical";
            this.element.addClass(this.model.cssClass + " e-context");
			 this.element.css("display", "none");
            this._referenceElement = this.element.parent();
            $("body").append(this.element);
            this.wrapper.insertBefore(this.element);
            this.wrapper.append(this.element);
        },

        _closeMenu: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
        },

        _onMenuIntent: function (element, obj, canOpen) {
            obj._delayMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == true && canOpen) {
                    var showanim = obj._showAnim;
                    var hideanim = obj._hideAnim;
                    var showSpeed = obj._showSpeed;
                    var hideSpeed = obj._hideSpeed;
                    obj._show(element, showanim, hideanim);
                }
            }, this._showSpeed);
        },

        _onHide: function (element, obj, canHide) {
            obj._delaySubMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == false && canHide) {
                    var id = obj._id;
                    var hideanim = obj._hideAnim;
                    var hideSpeed = obj._hideSpeed;
                    obj._closeAll();
                }

            }, obj._hideSpeed);
        },

        _subMenuPos: function (element, direction) {
            var pos = $(element).offset();
            var subMenuLeft, subMenuRight ;
            var posLeft = pos.left;
            var subMenu = $('ul:first', element);
            var menuWidth = $(element).outerWidth();
            if (pos == null || pos == undefined)
                return false;
            var submenuWidth = subMenu.outerWidth() + 1; // +1 for the space between menu and submenu
            var left = this.model.container ? $(this.model.container).width() + $(document).scrollLeft() : document.documentElement.clientWidth + $(document).scrollLeft();
            if (this.model.menuType == "normalmenu") {
                if ($(element.parentNode).is(this.element)) {
                    if (this.model.orientation == "horizontal"){
                        subMenu.css("top", $(element).outerHeight() + "px");
                        if (!this.model.enableRTL) {
                            subMenuLeft = (left < (posLeft + submenuWidth)) ? ((posLeft + submenuWidth) - left) : 1;
                            subMenu.css("left", (subMenuLeft *(-1)) + "px");
                        }
                        else {
                            subMenuRight = (((posLeft + menuWidth) - submenuWidth) < 0) ? ((posLeft + menuWidth) - submenuWidth) : 1;
                            subMenu.css({ "left": "auto", "right": subMenuRight + "px" });
                        }
                    }
                    else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth))
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                    else {
                        subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    }
                } else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth)) {
                    subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                else {
                    subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    var submenuHeight = subMenu.outerHeight();
                    var winHeight = $(window).height();
                    var submenuTop = (winHeight - (pos.top - $(window).scrollTop()));
                    if (winHeight < submenuHeight) {
					     var menuPos = pos.top - $(window).scrollTop();
						subMenu.css("top", -(menuPos) + 4 + "px");
					}
                    else if (submenuTop < submenuHeight) {
                        var menuPos = submenuTop - submenuHeight;
						subMenu.css("top", menuPos - 2 + "px");
					}
					else subMenu.css("top", "");
				}
            }
            else {
                left -= (pos.left + (2 * submenuWidth) + 4);
                if (left < 0) {
                    var menuLeftPos = (submenuWidth == null) ? "-206.5px" : "-" + (submenuWidth + 5) + "px";
                    subMenu.css("left", menuLeftPos);
                }
                else {
                    if (subMenu.parent('li.e-list').parent('ul').width() && direction == "right") {
                        subMenu.css("left", (subMenu.parent('li.e-list').parent('ul').width() + 4) + "px");
                    }
                    else if (pos.left > submenuWidth)
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                var submenuHeight = subMenu.outerHeight();
                if ((pos.top + submenuHeight > $(window).height())) {
                    var top = -(submenuHeight) + $(element).outerHeight();
                    if (submenuHeight > (pos.top + ($(element).outerHeight() / 2))) {
                        subMenu.css("top", -(submenuHeight / 2) + "px");
                    }
                    else
                        subMenu.css("top", top + "px");
                }
                else
                    subMenu.css("top","0px");
            }
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin + " e-menu-wrap");
        },

        _setSeparator: function (separator) {
            if (separator){
                this.element.addClass("e-separator");
                if ($('.e-menu-popwrap').length>0 && !ej.isNullOrUndefined(this.ulTag))
                    this.ulTag.addClass("e-separator");     
            }
            else this.element.removeClass("e-separator");
        },

        _contextMenuEvents: function (action) {
            this[action]($(this.model.contextMenuTarget), "mouseup taphold", this._ContextMenuHandler);
            this[action](this.element, "contextmenu", this._onDefaultPreventer);
            this[action]($(this.model.contextMenuTarget), "contextmenu", this._onDefaultPreventer);
            this[action]($(document), "mousedown", this._onContextClose);
        },

        _show: function (element, showanim, hideanim) {
            var siblingElement;
            var sibling = $('> ul', element);
			var zIndex = this._max_zindex();
            sibling.attr({ "aria-hidden": false });
            this._hideAnimation($(element).siblings().find(' > ul:visible'), hideanim);
            if (!($.inArray(this._disabledMenuItems, element) > -1)) {
                if (sibling.css('display') != "none") {
                    siblingElement = this.model.openOnClick ? $(sibling) : sibling.children().find('> ul');
                    this._hideAnimation(siblingElement, hideanim);
                }
                else $('> ul', element).children().find('> ul').hide();
                this._subMenuPos(element, this.model.subMenuDirection);
                sibling.css({ "z-index": zIndex + 1 });
				$(element).children('span.e-menu-arrow').css({"z-index": zIndex + 2 });
                if ($('> ul', element).css('display') != 'block' && !$(element).hasClass("e-disable-item")) {
                    this._showAnimation(sibling, showanim);
                    sibling.closest('li').addClass('e-active e-mfocused');
                }
                if ($(element).siblings("li.e-active").length > 0)
                    $(element).siblings("li.e-active").removeClass("e-active e-mfocused");
            }
        },

        _closeAll: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
            this._hideAnimation(this.element.find('> ul:visible'), this._hideAnim);
        },

        _showAnimation: function (element, anim) {
            switch (anim) {
                case "slideDown":
                    element.slideDown(this.model.enableAnimation ? 200 : 0); break;
                case "none":
                    element.css("display", "block"); break;
            }
        },

        _hideAnimation: function (element, anim) {
            switch (anim) {
                case "slideUp":
                    $(element).attr({ "aria-hidden": true });
                    element.slideUp(this.model.enableAnimation ? 100 : 0); break;
                case "none":
                    element.css("display", "none"); break;
            }
            element.closest('li').removeClass('e-active e-mfocused');
        },

        _removeValue: function (text, disableList) {
            var $browInfo = ej.browserInfo(), elementText;
            $browInfo.version === "8.0" && $browInfo.name === "msie" ? elementText = text[0].outerText : elementText = text[0].textContent;
            var count = $(disableList).length, i = 0;
            var childEle = $(disableList).children('a').length == 0 ? $(disableList).children('span') : $(disableList).children('a');
            while (i <= count) {
                if ($(childEle[i]).text() === elementText)
                    return i;
                i++;
            }
        },

        _createSubLevelItem: function (target, element) {
            var ulTag;
            ulTag = $(document.createElement('ul'));
            ulTag.append(element);
            target.append(ulTag);
            target.attr({ 'role': 'menu', 'aria-haspopup': 'true' });
            target.addClass("e-haschild");
            this.element.find('li:has("> ul")').find('> a,>span').addClass('aschild e-arrow-space');
            this._insertArrows(ulTag);
        },

        _insertArrows: function (ulTag) {
            if (this.model.showRootLevelArrows)
                ulTag.find('>a,>span').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
            else
                ulTag.find('>a,>span').removeClass("e-arrow-space").find('>span.e-icon').remove();

            if (this.model.showSubLevelArrows)
                ulTag.parent('li.e-list:has(>ul)').children('a,span').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else
                ulTag.parent('li.e-list:has(>ul)').children('a,span').removeClass("e-arrow-space").find('>span.e-icon').remove();
        },

        _createMenuItem: function (item) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr({ "class": 'e-list', "role": "menuitem" });
            if (item["htmlAttribute"]) this._setAttributes(item["htmlAttribute"], liTag);
            if (item["text"] && item["text"] != "") {
                aTag = $(document.createElement('a'));
				aTag.attr({ "class": 'e-menulink'});
                if (item["imageUrl"] && item["imageUrl"] != "") {
                    imgTag = $(document.createElement('img'));
                    imgTag.attr('src', item["imageUrl"]);
                    if (item["imageAttribute"]) this._setAttributes(item["imageAttribute"], imgTag);
                    aTag.append(imgTag);
                }
                else if (item["spriteCssClass"] && item["spriteCssClass"] != "") {
                    spanTag = $(document.createElement('span'));
                    spanTag.addClass(item["spriteCssClass"]);
                    aTag.append(spanTag);
                }
                aTag.append(item["text"]);
                if (item["linkAttribute"]) this._setAttributes(item["linkAttribute"], aTag);
                if (item["url"])
                    aTag.attr('href', item["url"]);
                liTag.append(aTag);
            }
            if (item["id"]) {
                liTag.prop("id", item["id"]);
            }
            if (!this.model.enabled)
                liTag.addClass("e-disable-item");
            return liTag;
        },

        _insertNode: function (itemCollection, targetNode, operation) {
            var item = 0, targetList = 0, target = 0, targetCollection = [];
            if ($(targetNode).is(this.element))
                targetCollection.push(this.element);
            else
                typeof (targetNode) === "string" ? targetCollection.push(this.element.find(targetNode)) : typeof (targetNode) === "undefined" ? targetCollection.push(this.element) : targetCollection.push(targetNode);
            for (targetList = 0; targetList < targetCollection.length; targetList++) {
                for (target = 0; target < targetCollection[targetList].length; target++)
                    for (item = 0; item < itemCollection.length && !ej.isNullOrUndefined(itemCollection[item]) ; item++)
                        this._addItem(itemCollection[item], targetCollection[targetList][target], operation);
            }
        },

        _addItem: function (item, target, operation) {
            var element, targetElement;
            this._wireEvents("_off");
            element = this._createMenuItem(item);
            target = target === "default" ? $("#" + item["parentId"]) : $(target);
            switch (operation) {
                case "insert":
                    $(target).is(this.element) ? targetElement = target : targetElement = target.children('ul');
                    targetElement.length != 0 ? targetElement.append(element) : this._createSubLevelItem(target, element);
                    break;
                case "insertBefore":
                    if (!$(target).is(this.element))
                        element.insertBefore(target);
                    else
                        target.prepend(element);
                    break;
                case "insertAfter":
                    if (!$(target).is(this.element))
                        element.insertAfter(target);
                    else
                        target.append(element);
                    break;
            }
            this._wireEvents("_on");
        },

        _removeItem: function (item) {
            if (item.siblings('li').length == 0) {
                item.closest("ul").siblings('a.aschild').removeClass("aschild e-arrow-space").children('span.e-icon').remove();
                !item.closest("ul").hasClass("e-menu") ? item.closest("ul").remove() : item.remove();
            }
            else
                item.remove();
        },

        _hiddenElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) == -1)) {
                ele.addClass("e-hidden-item");
                this._hiddenMenuItems.push(ele[0]);
            }
        },

        _showElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) > -1)) {
                ele.removeClass("e-hidden-item");
                this._hiddenMenuItems.splice(this._hiddenMenuItems.indexOf(ele[0]), 1);
            }
        },

        _getNodeByID: function (node) {
            (typeof node != "object" && node != "") && (node = this.element.find(".e-list" + node));
            return $(node);
        },

        _processItems: function (node, bool) {
            var ele = this._getNodeByID(node);
            for (var i = 0; i < ele.length; i++) bool ? this._showElement($(ele[i])) : this._hiddenElement($(ele[i]));
        },

        insert: function (item, target) {
            this._insertNode(item, target, "insert");
        },

        insertBefore: function (item, target) {
            this._insertNode(item, target, "insertBefore");
        },

        insertAfter: function (item, target) {
            this._insertNode(item, target, "insertAfter");
        },

        remove: function (targetCollection) {
            var target = 0, innerTarget = 0;
            for (target = 0; target < targetCollection.length; target++) {
                targetCollection[target] = typeof (targetCollection[target]) === "string" ? (this.element.find(targetCollection[target])) : targetCollection[target];
                for (innerTarget = 0; innerTarget < targetCollection[target].length; innerTarget++)
                    (targetCollection[target][innerTarget].tagName === "LI" || targetCollection[target][innerTarget].tagName === "UL") ? this._removeItem($(targetCollection[target][innerTarget])) : targetCollection[target][innerTarget].remove();
            }
        },

        showContextMenu: function (locationX, locationY, targetElement, e, update) {
            this._closeMenu();
            this._eventArgs = e;
            if (!ej.isNullOrUndefined(e) && this._checkForExclusion(e.target)) return;
            if (this._trigger("beforeOpen", { target: targetElement, events: e })) return false;
            if (this._preventContextOpen) {
                if (!ej.isNullOrUndefined(targetElement))
                    this._targetElement = targetElement;
                else if (!ej.isNullOrUndefined(target))
                    this._targetElement = target;
                else
                    this._targetElement = this.element;
                if (update) {
                    var position = this._calculateContextMenuPosition(e);
                    locationX = position.X;
                    locationY = position.Y;
                }
                this.element.css({ "left": locationX, "top": locationY });
                this.element.css({ "z-index": this._max_zindex() + 1 });
                this._showAnimation(this.element, this._showAnim);
                this._isContextMenuOpen = true;
                this.element.focus();

                this._trigger("open", { target: targetElement });
                this._on(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
            }
            return false;
        },

        _checkForExclusion: function (e) {
            if (!ej.isNullOrUndefined(this.model.excludeTarget)) {
                var excludeTargets = this.model.excludeTarget.split(",");
                for (var target = 0; target < excludeTargets.length; target++) {
                    if ($(e).closest(this.model.excludeTarget).is($.trim(excludeTargets[target])))
                        return true;
                }
            }
        },


        hideContextMenu: function (e) {
            this._closeMenu();
            this.element.find(".e-mhover").removeClass("e-mhover");
            this.element.find(".e-mfocused").removeClass("e-mfocused");
            this._hideAnimation(this.element, this._hideAnim);
            this._isContextMenuOpen = false;

            this._trigger("close", $.extend({ events: e }, e));
            this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
        },


        disableItem: function (itemToDisable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToDisable; });
            if (isMenuItem.length > 0 && !($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().addClass("e-disable-item").attr({ "aria-disabled": true });
                isMenuItem.parent().find('>a.aschild span.e-icon').addClass("e-disable");
                this._disabledMenuItems.push(isMenuItem.parent()[0]);
            }
        },


        disableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToDisable = this.element.find("#" + itemId) ? this.element.find("#" + itemId)[0] : undefined;
                if (itemToDisable && !($.inArray(itemToDisable, this._disabledMenuItems) > -1)) {
                    $(itemToDisable).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(itemToDisable).find('>a.aschild span.e-icon').addClass("e-disable");
                    this._disabledMenuItems.push(itemToDisable);
                }
            }
        },

        getHiddenItems:function(){
            return this._hiddenMenuItems;
        },

        hideItems: function (node) {
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], false);                
            }
            else this._processItems(node, false);
        },

        showItems:function(node){
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], true);
            }
            else this._processItems(node, true);
        },

        enableItem: function (itemToEnable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToEnable; });
            if (isMenuItem.length > 0 && ($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().removeClass("e-disable-item").attr({ "aria-disabled": false });
                isMenuItem.parent().find('>a.aschild span.e-icon').removeClass("e-disable");
                var index = this._removeValue(isMenuItem, this._disabledMenuItems);
                this._disabledMenuItems.splice(index, 1);
            }
        },


        enableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToEnable = this.element.find("#" + itemId)[0];
                if (itemToEnable && ($.inArray(itemToEnable, this._disabledMenuItems) > -1)) {
                    $(itemToEnable).removeClass("e-disable-item").attr({ "aria-disabled": false });
                    $(itemToEnable).find('>a.aschild span.e-icon').removeClass("e-disable");
                    for (var i = this._disabledMenuItems.length - 1; i >= 0; i--) {
                        if (this._disabledMenuItems[i].id == itemId) {
                            this._disabledMenuItems.splice(i, 1);
                        }
                    }
                }
            }
        },


        disable: function () {
            this.model.enabled = false;
            var menuItemCollection = this.element.find('>li[class~=e-list]');
            var proxy = this;
            $.each(menuItemCollection, function (key, value) {
                if (!($.inArray(value, proxy._disabledMenuItems) > -1))
                {
                    $(value).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(value).find('>a.aschild span.e-icon').addClass("e-disable");
                    proxy._disabledMenuItems.push(value);
                }
                
            });
        },


        enable: function () {
            var proxy = this;
            this.model.enabled = true;
            var menuItemCollection = this.element.find('li.e-disable-item');
            $.each(menuItemCollection, function (key, value) {
                $(value).removeClass("e-disable-item").attr({ "aria-disabled": false });
                $(value).find('>a.aschild span.e-icon').removeClass("e-disable");
                proxy._disabledMenuItems.pop(value);
            });
        },

        show: function (locationX, locationY, targetElement, e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.showContextMenu(locationX, locationY, targetElement, e, false);
            else
                this.element.css("display", "block");
        },

        hide: function (e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.hideContextMenu(e);
            else {
                this._closeMenu();
                this.element.css("display", "none");
            }
        },

        _wireEvents: function (action) {
            this[action](this.element.find("li.e-list"), "mouseout", this._mouseOutHandler);
            this[action](this.element.find("li.e-list"), "mouseover", this._mouseOverHandler);
            this[action](this.element.children(), "click", this._onClickHandler); 
            this[action](this.element, "keydown", this._onKeyDownHandler);
            this[action](this.element, "focus", this._OnFocusHandler);
            this[action](this.element, "blur", this._OnFocusOutHandler);
            if (this.model.menuType == "contextmenu" && $(this.model.contextMenuTarget)[0] != null) {
                this._contextMenuEvents(action);
            }
            if (this.model.menuType != "contextmenu") {
                this[action]($(document), "click", this._onDocumentClick);
                this[action](this.element, "mousedown", this._onMouseDownHandler);
            }
            this[action]($(window),"resize", $.proxy(this._onResize, this));            
        },

        _mouseOverHandler: function (event) {
            var element, itemId = "";
            this.element.find(".e-mhover").removeClass("e-mhover");
            event.currentTarget = $(event.target).closest("li")[0];
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                $(event.currentTarget).addClass("e-mhover");
            else this._isFocused = false;
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = true;
            this._isMenuOpen = true;
            if ($(event.currentTarget.parentNode.parentNode).is(this.element)) {
                this._isSubMenuOpen = false;
            }
            else {
                this._isSubMenuOpen = true;
            }
            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                this._onMenuIntent(element, this, this._hoverOpen);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseover", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onMouseDownHandler: function (e) {
            if ($(e.target).hasClass('e-menu')) this._isFocused = false;
        },


        _mouseOutHandler: function (event) {
            var element, itemId = "";
            $(event.currentTarget).removeClass("e-mhover");
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = false;
            this._isMenuOpen = false;

            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            this._onHide(element, this, this._hoverClose);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseout", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onClickHandler: function (event) {
            var element, itemId = "" , parentId, parentText;
            this._isFocused = true;
            var openOnClickStart = false;
            if (!$(event.target).closest("li.e-list").hasClass('e-disable-item') && $(event.target).closest("li.e-list").length > 0) {
                element = $(event.target).closest("li.e-list")[0];
                if ($(element).is(this.element.find(">li.e-list")))
                    this._activeElement = element;
            }
            else {
                if ($(event.target).is(this.element))
                    this._activeElement = this.element.find(">li:first");
                return;
            }
            if ($(event.target).is("a") && $(element).find(">a,>span").hasClass('aschild') && this.model.openOnClick) {
                this._isFocused = false;
            }
            if (!this._hoverOpen && $(element).find(">a,>span").hasClass('aschild')) {
                this._show(element, this._showAnim, this._hideAnim);
                this._hoverOpen = false;
                openOnClickStart = true;
            }
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                //Check if Context Menu, then hide the context menu firing the events
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && !$(element).hasClass("e-haschild")) {
                        this._hideAnimation(this.element, this._hideAnim);
                        this._isContextMenuOpen = false;

                        this._trigger("close", $.extend({ events: event }, event));
						this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
                    }
                }
                if (!openOnClickStart) {



                    if (!$(element).find(">a,>span").hasClass("aschild")) {
                        this._closeMenu();
                        if (this.model.openOnClick)
                            this._hoverOpen = false;
                    }
                }
                var menuText = $(element).children('a,span').text();
                var parent = $(element).closest("ul").parent("li");
                if (parent.length != 0) {
                    parentId = ej.isNullOrUndefined(parent.attr("id")) ? null : parent.attr("id");
                    parentText = parent.children('a,span').text();
                }
                else {
                    parentId = null;
                    parentText = null;
                }
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "selectedItem": this.selectedItem, "ID": itemId, "parentId": parentId, "parentText": parentText };
                this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                this.selectedItem = null;
                if (this.model.openOnClick && this.model.menuType != "contextmenu")
                    this.element.focus();
            }
        },


        _onKeyDownHandler: function (e) {
            if (this.model.menuType == "contextmenu" && !this._isContextMenuOpen) return;
            var element, focusEle, itemId = "", hoverElement = this.element.find(".e-mhover"), focusedElement = this.element.find(".e-mfocused"), currentElement, liVisible;
            if (!$(hoverElement).length > 0 && $(this._activeElement).length > 0)
                hoverElement = focusedElement = $(this._activeElement);

            if (e.keyCode == 9) {
                this._isFocused = false;
                this._OnFocusOutHandler();
            }
            else if (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
                e.preventDefault();

            if (e.keyCode == 40) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-mhover").children("ul").length > 0 || $(this._activeElement).length > 0) {
                        if ($(hoverElement).children("ul").css('display') === "none")
                            this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                        hoverElement.removeClass("e-mhover e-mfocused").children("ul:first").find("li:first").addClass("e-mhover");
                        this._activeElement == null ? hoverElement.addClass("e-mfocused") : $(this._activeElement).addClass("e-mfocused");
                    } else {
                        liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        $(hoverElement[hoverElement.length-1]).removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mfocused");
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    } else focusEle = liVisible.first();
                    focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 39) {
                if (this.model.orientation == "horizontal" && (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0)) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if ($(hoverElement).children("ul").length > 0) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    var firstChild = hoverElement.children("ul:first").find("li:first");
                    this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                    liVisible = hoverElement.addClass('e-mfocused').children("ul:first").children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(firstChild)]).length > 0 ? $(liVisible[liVisible.index(firstChild)]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if (hoverElement.children("ul").length <= 0) {
                    if (this.model.orientation == "horizontal" && hoverElement.parent().closest('.e-list').parent().hasClass('e-menu')) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]) : $(liVisible[liVisible.index(focusedElement.first())]);
                        focusEle.addClass("e-mhover");
                    }
                }
            }

            if (e.keyCode == 38) {
                if (this.model.orientation == "horizontal") {
                    liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mhover");
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                    } else focusEle = liVisible.last();
                }
                focusEle.addClass("e-mhover");
            }

            if (e.keyCode == 37) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        liVisible = this.element.find('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                    else {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused e-active");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        if (hoverElement.parent().closest('.e-list').parent('.e-menu').length > 0)
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]) : liVisible.last();
                        else
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (hoverElement.parent(".e-menu").length == 0 || (this.model.menuType == "contextmenu" && hoverElement.parent("ul.e-context").length == 0)) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : $(liVisible[liVisible.index(focusedElement.last())]);
                        focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 13) {
                var menuText = $(hoverElement).children('a,span').text();
                itemId = !ej.isNullOrUndefined($(hoverElement)[0]) ? $(hoverElement)[0].id : "";
                var eventArgs = { "menuId": this.element[0].id, "text": menuText, "selectedItem": focusedElement, "ID": itemId };
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && hoverElement.length > 0 && !focusedElement.hasClass("e-disable-item")) {
                        if (this.model.click)
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                        this.selectedItem = null;
                        this.hideContextMenu(e);
                    }
                } else {
                    if (hoverElement.length > 0 && !hoverElement.hasClass("e-disable-item")) {
                        if ($(hoverElement).find(">a,>span").hasClass('aschild') && $(hoverElement).children("ul").css('display') === "none") {
                            this._show(hoverElement[0], this._showAnim, this._hideAnim);
                            hoverElement.removeClass("e-mhover").children("ul:first").find("li:first").addClass("e-mhover");
                        }
                        else {
                            this.element.find(".e-mhover >a,.e-mhover >span ").focus();
                            this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                            this._closeAll();
                        }
                        if (ej.isNullOrUndefined($(hoverElement).find(">a").attr("href")))
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                    }
                }
            }
            if (e.keyCode == 27) {
                if (this.model.menuType == "contextmenu")
                    this.hideContextMenu(e);
                else
					this.element.find("li.e-list").removeClass("e-mhover");
                    this.element.find('li.e-list:has("> ul")').find('> ul:visible').parents("li.e-list").addClass("e-mhover");
                    this._closeAll();
            }
            if ($(e.target).is(this.element) && e.target.parentNode) {
                if (hoverElement.length)
                    element = hoverElement;
            }
            else
                return false;
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();

                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                if (this.element.find('li.e-mfocused.e-mhover').length || e.keyCode == 13)
                    currentElement = (e.keyCode == 13) ? hoverElement : this.element.find('li.e-mfocused.e-mhover');
                var eventArgs = { "text": menuText, "element": element, "targetElement": currentElement , "event": e, "ID": itemId };

                this._trigger("keydown", $.extend({ events: eventArgs }, eventArgs));
            }
            this._activeElement = null; focusedElement = this.element.find(".e-mfocused");
        },

        _OnFocusHandler: function (event) {
            if (this.model.menuType != "contextmenu" && !this.element.find(">li:first").hasClass("e-disable-item") && this._isFocused && this.element.find(".e-mhover").length == 0 && $('li.e-ham-wrap').length ==0) {
                this.element.find(">li:first").addClass("e-mhover");
            }
            else this._isFocused = true;
            if (this.model.menuType != "contextmenu")
                this._activeElement = this.element.find(">li:first");
        },

        _OnFocusOutHandler: function () {
            if (!this._isFocused) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
            }
            this._isFocused = false;
        },

        _onDocumentClick: function (event) {
            if (this.model.openOnClick)
                this._hoverOpen = false;
            if (!$(event.target).parents(".e-menu").is(this.element)) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
                this._isFocused = true;
            }
            if ((!$(event.target).parents("ul.e-menu").is(this.popupWrapper)) && (!$(event.target).hasClass('e-ham-wrap')) && (!($(event.target).parent().hasClass('e-ham-wrap'))) && (!$(event.target).hasClass('e-hamburger')) && (!$(event.target).parent("li").hasClass("e-haschild")) && (!$(event.target).is('span.e-icon.e-arrowhead-down')) && !(this._isOverflowPopupOpen()) && this.model.menuType != "contextmenu" && $("li.e-ham-wrap").length > 0) {
                this._overflowClose();
            }           
        },


        _ContextMenuHandler: function (e) {
            var isRightClick = false;
            if (e.type == "taphold" && e.button != 0)
                isRightClick = true;
            else if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            var targetElement = e.target;
            if (isRightClick) {
                var evt = e;
                if (e.type == "taphold") {
                    if (e.options.type == "touchstart") evt = e.options.touches[0];
                    else evt = e.options;
                }
                var showSpeed = this._showSpeed;
                this.showContextMenu(null, null, targetElement, evt, true);
            }
            else {
                if (this._isContextMenuOpen) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                }
            }
        },

        _calculateContextMenuPosition: function (e) {
            var locationX, locationY;
            this.element.css({"top": "", "left": ""}); 
            locationX = (e.clientX + this.element.width() < $(window).width()) ? e.pageX : e.pageX - this.element.width();
            locationY = (e.clientY + this.element.height() < $(window).height()) ? e.pageY : (e.clientY > this.element.height()) ? e.pageY - this.element.height() : $(window).height() - this.element.outerHeight();
            var bodyPos = $("body").css("position") != "static" ? $("body").offset() : { left: 0, top: 0 };
            locationX -= bodyPos.left, locationY -= bodyPos.top;
            return {
                X: locationX,
                Y: locationY
            };
        },


        _onDefaultPreventer: function (e) {
            e.preventDefault();
            e.stopPropagation();
            return false;
        },


        _onContextClose: function (e) {
            var proxy = this;
            if (this._isContextMenuOpen) {
                var isRightClick = false;
                if ($(e.target).is(this.element) || $(e.target).parents(".e-context").is(this.element))
                    isRightClick = true;
                if (!isRightClick) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                    var parentElements = $(e.target).parents();
                    $.each(parentElements, function (index, value) {
                        if (value.id == proxy._ContextTargetId) {
                            return;
                        }
                    });

                }
            }
        }

    });

    ej.Menu.Locale = ej.Menu.Locale || {} ;
       
    ej.Menu.Locale['default'] = ej.Menu.Locale["en-US"] = {  	
        titleText: "Menu"
    };
    ej.MenuType = {
        /**  support for list of items appears as normal menu in horizontal or vertical direction. */
        NormalMenu: "normalmenu",
        /**  support for list of items appears as menu when right clicked on target area, thereby preventing browser’s default right click.. */
        ContextMenu: "contextmenu"
    };

    ej.Direction = {
        /**  support for Render sub menu popup in left direction. */
        Left: "left",
        /**  support for Render sub menu popup in Right direction. */
        Right: "right",
        /** Default opening direction of menu sub items */
        None: "none",
    };

    ej.AnimationType = {
        /**  support for disable the AnimationType while hover or click an menu items. */
        None: "none",
        /**  support for enable the AnimationType while hover or click an menu items. */
        Default: "default"
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {

    ej.widget("ejPager", "ej.Pager", {
        _rootCSS: "e-pager",
        validTags: ["div"],
        // default model
        defaults: {
            pageSize: 12,
            pageSizeList: null,
            pageCount: 10,
            currentPage: 1,
            enableExternalMessage: false,
            externalMessage: "",
            pageSizeMessage: "",
            enableQueryString: false,
            locale: "en-US",
            masterObject: null,
            pageSizeSelected: null,
            enableRTL: false,
            totalRecordsCount: null,
            totalPages: null,
            customText: "",
            showPageInfo: true,
            cssClass: "",
            enabled: true,
            showGoToPage: false,
            isResponsive: false,
            change: null,
            click: null,
			template: "",
        },

        // constructor function
        _init: function () {
            this._initPrivateProperties();
            this.model.enableQueryString && this._queryStringValue();
            this.renderPager();
            if (this.model.isResponsive) this._reSizeHandler();
            this._wireResizing();
            this._wireEvents();
            this.refreshPager();
        },
        _initPrivateProperties: function () {
            if (typeof (this.model.pageSizeList) == "string")
                this.model.pageSizeList = JSON.parse(this.model.pageSizeList);
            this._pageSize = this.model.pageSize;
            this._links = [];
            this._$prev = null;
            this._$first = null;
            this._$PP = null;
            this._$NP = null;
            this._lastNP = false;
            this._lastpageCount = null;
            this._$last = null;
            this._$next = null;
            this._prevPageNo = 1;
            this.localizedLabels = this._getLocalizedLabels();
            this._intervalWid = 0;
            this._msgWidth = 0;
            this._gotoWid = 0;
        },
        _wireEvents: function () {
            var proxy = this;
            this._on(this.element, "click", this._pagerClickHandler);
            $(document).on("click", $.proxy(proxy._hidedrop, proxy));
			if(this._pagerContainer){
			this._touchPrev = false;
			this._pagerContainer.on("touchstart",this._touchHandler);
			this._pagerContainer.on("mouseover",this._mouseOverHandler);
			this._pagerContainer.on("mouseout",this._mouseOutHandler);
			}
			
        },
		_touchHandler: function(e){
			this._touchPrev = true;
		},
		 _mouseOverHandler: function (e) {
				if(this._touchPrev == false){
					var $target = $(e.target);
					if (($target.hasClass("e-icon") || $target.hasClass("e-link")) && !$target.hasClass("e-hover")) {
						$target.addClass("e-hover")
					}
				}
				this._touchPrev = false;
		},
		_mouseOutHandler: function (e) {
            var $target = $(e.target);
			if (($target.hasClass("e-icon") || $target.hasClass("e-link")) && $target.hasClass("e-hover")) {
				$target.removeClass("e-hover")
			}
		},
        _hidedrop: function () {
            if (this.$dropItem && this.$dropItem.css("display") != "none") this.$dropItem.hide();
        },
        _wireResizing: function () {
            this._refreshDropandTextItems();
            $(window).bind('resize', (this.model.isResponsive) ? $.proxy(this._reSizeHandler, this) : $.proxy(this._unWireResizing, this));
        },
        _unWireResizing: function () {
            this._refreshDropandTextItems();
            if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },
        _reSizeHandler: function () {
            if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
            controlwidth = this._intervalWid + this._gotoWid + this.element.find('.e-pagercontainer').outerWidth() + this._msgWidth;
            if (controlwidth > (this.element.outerWidth() - 20)) { if (this._msgWidth > 0) this.element.find(".e-parentmsgbar").addClass("e-msg-res"); }
            else if (this._msgWidth > 0) this.element.find(".e-parentmsgbar").removeClass("e-msg-res");
            if (this.element.outerWidth() - $(this.element.find(".e-pagercontainer")).outerWidth() < 40) {
                this._flag = true;
                this._fillScreen();
            }
            if (this.element.outerWidth() - $(this.element.find(".e-pagercontainer")).outerWidth() > 40) {
				if(!$(this._templateElement).find(".e-textbox-paging").length > 0)
				if(!this._maxPageCount) this._maxPageCount = this.model.pageCount;
                this.option("pageCount", this._maxPageCount);
                if (this.element.outerWidth() - $(this.element.find(".e-pagercontainer")).outerWidth() < 40) {
                    this._flag = true;
                    this._fillScreen();
                }
            }
            this._refreshDropandTextItems();
        },
        _refreshDropandTextItems: function () {
            if (this.numTextbox && !this.model.template) {
                if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-parentmsgbar").position().top) {
                    this.numTextbox.addClass("e-pager-goto-res");
                }
                else this.numTextbox.removeClass("e-pager-goto-res");
            }
            if (this.pageInterval_wrap && !this.model.template) {
                if (this.element.find('.e-pagercontainer').position().top != this.element.find(".e-pager-itemsinterval").position().top) {
                    this.element.find(".e-pager-itemsinterval").addClass("e-pager-goto-res");
                }
                else this.element.find(".e-pager-itemsinterval").removeClass("e-pager-goto-res");
            }


        },
        renderPager: function () {
			var  tempElement;
			if(!this.model.template){
            var $pagerContainer = ej.buildTag('div.e-pagercontainer', "", {});
			this._pagerContainer = $pagerContainer;
            this._renderPagerContainer($pagerContainer);
            this.element[0].appendChild($pagerContainer[0]);
			}
			else{
			this._templateElement = ej.buildTag('div.e-template',"",{});
			if (this.model.template.startsWith(".") || this.model.template.startsWith("#"))
			tempElement = $($(this.model.template).html());
			else tempElement = $(this.model.template);
			tempElement.appendTo(this._templateElement);
			if($(this._templateElement).find(".e-default-paging").length > 0){
				var $pagerContainer = ej.buildTag('div.e-pagercontainer', "", {});
				this._renderPagerContainer($pagerContainer);
				$pagerContainer.appendTo($(this._templateElement).find(".e-default-paging"));
			}
			if($(this._templateElement).find(".e-textbox-paging").length > 0){
		 	    proxy = this;
				var accessTemplatePagerContainer = $(this._templateElement).find(".e-textbox-paging");
				accessTemplatePagerContainer.addClass("e-pagercontainer");
				var accesFirstPage = ej.buildTag('div.e-firstpage e-icon e-mediaback  e-firstpagedisabled e-disable', "", {}, { title: proxy.localizedLabels.firstPageTooltip });
				var accesPrevPage = ej.buildTag('div.e-prevpage e-icon e-arrowheadleft-2x  e-prevpagedisabled e-disable', "", {}, {  title: proxy.localizedLabels.previousPageTooltip });
				var numInput = ej.buildTag("input.e-gototextbox", {}, { "type": "textbox" });
				var accesNextPage = ej.buildTag('div.e-nextpage e-icon e-arrowheadright-2x  e-default', "", {}, { title: proxy.localizedLabels.nextPageTooltip });
				var accesLastPage = ej.buildTag('div.e-lastpage e-icon e-mediaforward  e-default', "", {}, { title: proxy.localizedLabels.lastPageTooltip });
				var accesNewRecord = ej.buildTag('div.e-newrecord e-icon e-plus e-default', "", {}, { title: "Add New Record" });
				accessTemplatePagerContainer.append(accesFirstPage);
				accessTemplatePagerContainer.append(accesPrevPage);
				accessTemplatePagerContainer.append(numInput);
				accessTemplatePagerContainer.append(accesNextPage);
				accessTemplatePagerContainer.append(accesLastPage);
				accessTemplatePagerContainer.append(accesNewRecord);
				numInput.focus(function(){
					numInput.val(proxy.model.currentPage);
				});
			}
			var element = this.element;
			$(this._templateElement).addClass("e-template");
			this._pagerContainer = $pagerContainer = $(this._templateElement).find(".e-pagercontainer") ? $(this._templateElement).find(".e-pagercontainer") : $(this._templateElement);
				element.append($(this._templateElement));
				if($(this._templateElement).find(".e-prevpage").length > 0) this._$prev = $(this._templateElement).find(".e-prevpage");
				if($(this._templateElement).find(".e-nextpage").length > 0) this._$next = $(this._templateElement).find(".e-nextpage");
				if($(this._templateElement).find(".e-firstpage").length > 0) this._$first = $(this._templateElement).find(".e-firstpage");
				if($(this._templateElement).find(".e-lastpage").length > 0) this._$last = $(this._templateElement).find(".e-lastpage");
				if($(this._templateElement).find(".e-gototextbox").length > 0) {
				this.numTextbox = $(this._templateElement).find(".e-gototextbox").addClass("e-pager-goto-res e-textbox").attr("type","textbox");
				if(!$(this._templateElement).find(".e-textbox-paging").length > 0)this.numTextbox.width(35);
				this._on($(this.numTextbox), 'keydown', this._mouseScroll);
				this._on(this.numTextbox, 'focusout', this._onTextboxBlur);
				}
				if(this._$prev &&(this._$prev).hasClass("e-prevpagedisabled")) this._$prev.removeClass("e-prevpage");
				if(this._$last &&(this._$last).hasClass("e-lastpagedisabled")) this._$prev.removeClass("e-lastpage");
				if(this._$first && (this._$first).hasClass("e-firstpagedisabled")) this._$prev.removeClass("e-firstpage");
				if(this._$next &&(this._$next).hasClass("e-nextpagedisabled")) this._$prev.removeClass("e-nextpage");
				if($(this._templateElement).find(".e-drpdwndiv").length > 0 && this.model.pageSizeList) this._renderDropdownlist();
				this._templatePageCount = $(this._templateElement).find(".e-pagenumbers").length;
				if( this._templatePageCount > 1){
					proxy =this;
					if($(this._templateElement).find(".e-previouspager").length > 0){
						this._$PP = $(this._templateElement).find(".e-previouspager").addClass("e-nextprevitemdisabled e-disable e-spacing e-PP");
					} 
					if($(this._templateElement).find(".e-nextpager").length > 0){
						this._$NP = $(this._templateElement).find(".e-nextpager").addClass("e-NP e-spacing e-nextprevitemdisabled e-disable");
					} 
					$(this._templateElement).find(".e-pagenumbers").each(function(index){
						$(this).attr("role","link").addClass("e-numericitem e-spacing e-default").data("index",index);
					});
					proxy._links = $(this._templateElement).find(".e-numericitem[role=link]");
			    }
			}
			if (!this.model.enabled) this._disable();
			if (this.model.pageSizeList && this.model.pageSizeList.length > 0) this._renderDropdownlist();
			this._pageInfo();
			this.model.enableExternalMessage && this._renderPagerMessage();
			if (this.model.showGoToPage) this._renderTextboxItem();
			if (this.model.enableRTL) this.element.addClass("e-rtl");
            this._cssClass = this.model.cssClass; this.element.addClass(this.model.cssClass);
        },
		_onTextboxBlur: function (e) {
				proxy = this;
                e.currentTarget.value = parseInt(e.currentTarget.value);
                var regEx = /^[0-9]*$/;
                var flag = regEx.test(parseInt(e.currentTarget.value));
                if (!flag) {
                    proxy.numTextbox.val(proxy.model.currentPage)
                    return false;
                }
                if (proxy.model.currentPage != parseInt(e.currentTarget.value)) {
                    if (parseInt(e.currentTarget.value) >= 1 && parseInt(e.currentTarget.value) <= proxy.model.totalPages) {
                        proxy.model.currentPage = parseInt(e.currentTarget.value);
                        proxy.refreshPager();
                        if (proxy._prevPageNo != proxy.model.currentPage)
                            proxy._trigger("change", { "currentPage": proxy.model.currentPage, "isInteraction": true, "event": e });
                    }
                    else proxy.numTextbox.val(this.model.currentPage);
                }
				if($(this._templateElement).find(".e-textbox-paging").length > 0){
				this.numTextbox.val(this.model.currentPage+ " of " +this.model.totalPages);
				}
            },
        _removeDropdownlist: function () {
            this.pageInterval_wrap.remove();
            this.pageInterval_wrap = null;
            this.$textspan = null;
            this.$dropItem = null;
        },
        _renderDropdownlist: function () {
            var proxy = this;
            this.pageInterval_wrap = ej.buildTag('div.e-pager-itemsinterval', "", {});
			if(this.model.template && $(this._templateElement).find(".e-drpdwndiv").length > 0){
				var pageDrop_wrap = $(this._templateElement).find(".e-drpdwndiv").addClass("e-icon e-arrow-sans-down");
			}
			else var pageDrop_wrap = ej.buildTag('div.e-drpdwndiv e-icon e-arrow-sans-down', "", {});
            if (proxy.model.totalRecordsCount == null || proxy.model.totalRecordsCount == 0) {
                pageDrop_wrap.addClass("e-disable");
            }
            this.$textspan = ej.buildTag('span.e-text');
            this.sizeIntervals = this.model.pageSizeList;
			if(proxy.model.template) var prevElement = ($(proxy._templateElement).find(".e-drpdwndiv").prev().length > 0) ? $(proxy._templateElement).find(".e-drpdwndiv").prev(): $(proxy._templateElement);
            pageDrop_wrap.appendTo(this.pageInterval_wrap);
			if(proxy.model.template) prevElement.after(this.pageInterval_wrap);
            else this.pageInterval_wrap.appendTo(this.element);
            this.pageInterval_wrap.insertBefore(this._parentMsgBar);
            this.$textspan.appendTo(pageDrop_wrap);
            proxy.$textspan.text(this.model.pageSize || this.model.pageSizeList[0]);
            this.$dropItem = ej.buildTag('ul.e-drpdwn e-ul');
            this._renderItems();
            this.$dropItem.appendTo(pageDrop_wrap);
            this._renderPageSizeMessage();
            pageDrop_wrap.on("click", function () {
                if (proxy.$dropItem.css("display") != "none") proxy.$dropItem.hide();
                else if (proxy.model.enabled && !pageDrop_wrap.hasClass("e-disable")) {
					proxy.$dropItem.show();
					proxy._setListPosition();
				}
            });
            this.$dropItem.hide();
            this._intervalWid = this.element.find('.e-pager-itemsinterval').outerWidth();
        },
		_getOffset: function (ele) {
			return ej.util.getOffset(ele);
		},

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.pageInterval_wrap, this.$dropItem);
        },

		_setListPosition: function () {
            var elementObj = this.pageInterval_wrap, pos = this._getOffset(elementObj),
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.$dropItem.outerHeight(),
            popupWidth = this.$dropItem.outerWidth(),
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()),
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? this.$dropItem.position().top : -(popupHeight+border+popupmargin));
            this.$dropItem.css({
                "top": (topPos) + "px",
                "z-index": maxZ
            });
        },
        _renderPageSizeMessage: function () {
            if (!this.pageInterval_wrap.children().hasClass("e-interval-msg")) {
                this._msgwrapper = ej.buildTag('div.e-interval-msg');
            }

            this._msgwrapper.appendTo(this.pageInterval_wrap);
            if (this.model.pageSizeMessage.toString().length) {
                this._msgwrapper.html(this.model.pageSizeMessage);
                if (this._msgwrapper.css('display') == 'none') this._msgwrapper.show();
            }
            else {
                this._msgwrapper.remove();
            }
        },
        _renderItems: function () {
            var proxy = this;
            $(this.model.pageSizeList).each(function () {
                li = ej.buildTag('li');
                li.text(this);
                proxy.$dropItem.append(li);
                if (proxy.model.pageSize == this) {
                    li.addClass("e-active");
                }
            });
            this.$dropItem.find("li").on("click", function (e) {
                proxy.$dropItem.find("li.e-active").removeClass("e-active");
                $(this).addClass("e-active")
                proxy._pageSize = parseInt($(this).text());
                proxy.$textspan.text($(this).text());
                proxy.refreshPager();
                proxy._trigger("pageSizeSelected", { pageSize: proxy._pageSize });
                if (proxy._prevPageNo != proxy.model.currentPage)
                    proxy._trigger("change", { "currentPage": proxy.model.currentPage, "isInteraction": true, "event": e });
            });
        },
        _queryStringValue: function () {
            var results = new RegExp('[\\?&]page=([^&#]*)').exec(window.location.href);
            !results ? this.model.currentPage = 1 : this.model.currentPage = parseInt(results[1] || 1);
        },
        _renderPagerMessage: function () {
            if (this.element.find('e-pagermessage').length<=1) {
                this._messageDiv = ej.buildTag('div.e-pagermessage');
            }
            if (this.model.externalMessage.toString().length) {
                this._messageDiv.html(this.model.externalMessage);
                if (this._messageDiv.css('display') == 'none') this._messageDiv.show();
            }
            else
                this._messageDiv.hide();
            this.element.append(this._messageDiv);
        },
        _removePagerMessage: function () {
            this.element.find("div.e-pagermessage").remove();
        },
        _mouseScroll: function (event) {
		if(this.model.enabled){
            var delta;
            if (event.keyCode == "38")
                this._updateField("increment");
            else if (event.keyCode == "40")
                this._updateField("decrement");
				}
        },
        _updateField: function (operation) {
            var preval = this.model.currentPage;
            var step = 1;
            if (this.numTextbox.val() == "") this.numTextbox.val(1);
            else if (this.numTextbox.val().indexOf(" ") >= 1)
                this.numTextbox.val(this.numTextbox.val().replace(" ", ""));
            this.model.currentPage = ej.parseInt(this.numTextbox.val(), this.model.locale);
            if (isNaN(this.model.currentPage) && !this.model.currentPage) this.model.currentPage = 1;
            if (this.model.currentPage >= 1 && this.model.currentPage > this.model.totalPages) {
                this.model.currentPage = this.model.totalPages;
                this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage < 1 && this.model.currentPage <= this.model.totalPages) {
                this.model.currentPage = 1;
                this.numTextbox.val(this.model.currentPage);
            }
            else if (this.model.currentPage >= 1 && this.model.currentPage <= this.model.totalPages) {
                value = operation == "increment" ? this.model.currentPage + step : this.model.currentPage - step;
                if (value >= 1 && value <= this.model.totalPages) {
                    this.numTextbox.val(value);
                    this.model.currentPage = value;
                }
            }
            this.refreshPager();
            if (preval != this.model.currentPage) {
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
            }
        },
        _renderTextboxItem: function () {
            proxy = this;
            var numInput = ej.buildTag("input#" + this.element[0].id + "_numtext", "", {}, { "type": "textbox" });
            $(numInput).appendTo(this._parentMsgBar).insertBefore($(this._parentMsgBar).find("span"));
            this.numTextbox = numInput;
            this.numTextbox.height(this.element.find('.e-pagercontainer .e-numericcontainer a').outerHeight());
            this.numTextbox.width(35);
            this.numTextbox.addClass('e-gototextbox e-textbox');
            if (!this.model.showGoToPage) this.numTextbox.hide();
            this._gotoWid = $(this.numTextbox).outerWidth();
            this._on($(this.numTextbox), 'keydown', this._mouseScroll);
            this._on(this.numTextbox, 'focusout', this._onTextboxBlur);
        },
        _renderPagerContainer: function ($pagerContainer) {
            //Update pager styles here for next versions
            this._renderBackwardButton($pagerContainer);
            this._renderpreviousPager($pagerContainer);
            this._renderNumericItem($pagerContainer);
            this._renderForwardPager($pagerContainer);
            this._renderForwardButton($pagerContainer);
        },
        _renderMsgBar: function () {
            var $msgBar = ej.buildTag('span.e-pagermsg', String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
            this._parentMsgBar.appendChild($msgBar[0]);
            this._parentMsgBar.style.textAlign = ej.TextAlign.Right;
        },
        _renderpreviousPager: function ($pagerContainer) {
            this._$PP = ej.buildTag('a.e-link e-nextprevitemdisabled e-disable e-spacing e-PP', "...", {}, { title: this.localizedLabels.previousPagerTooltip});
            $pagerContainer.append(this._$PP);
        },
        _renderForwardPager: function ($pagerContainer) {
            this._$NP = ej.buildTag('a.e-link e-NP e-numericitem e-spacing e-default', "...", {}, { title: this.localizedLabels.nextPagerTooltip });
            $pagerContainer.append(this._$NP);
        },
        _renderBackwardButton: function ($pagerContainer) {
            this._$first = ej.buildTag('div.e-firstpage e-icon e-mediaback  e-firstpagedisabled e-disable', "", {}, { title: this.localizedLabels.firstPageTooltip });
            this._$prev = ej.buildTag('div.e-prevpage e-icon e-arrowheadleft-2x  e-prevpagedisabled e-disable', "", {}, {  title: this.localizedLabels.previousPageTooltip });
            $pagerContainer.append(this._$first);
            $pagerContainer.append(this._$prev);
        },
        _renderNumericItem: function ($pagerContainer) {
            var $numericContainer = ej.buildTag('div.e-numericcontainer e-default', "", {});
            this._renderNumericLinks($numericContainer, this.model.pageCount);
            $pagerContainer.append($numericContainer);
            this._maxPageCount = this.model.pageCount;
        },
        _renderNumericLinks: function ($numericContainer) {
            $numericContainer.empty();
            this.model.pageCount = Math.round(this.model.pageCount);
            this.model.customText != "" ? $numericContainer.addClass("e-customtext") : $numericContainer.removeClass("e-customtext");
            for (var page = 1; page <= this.model.pageCount; page++) {
                var $link = ej.buildTag('a.e-link', this.model.customText + page, {}, { role: "link" }).addClass("e-numericitem e-spacing e-default").data("index", page);
                if (page == this.model.currentPage)
                    $link.removeClass("e-default").addClass("e-currentitem e-active");
                $numericContainer.append($link);
            }
            this._links = $numericContainer.children();
        },
        _renderForwardButton: function ($pagerContainer) {
            this._$next = ej.buildTag('div.e-nextpage e-icon e-arrowheadright-2x  e-default', "", {}, { title: this.localizedLabels.nextPageTooltip });
            this._$last = ej.buildTag('div.e-lastpage e-icon e-mediaforward  e-default', "", {}, { title: this.localizedLabels.lastPageTooltip });
            $pagerContainer.append(this._$next);
            $pagerContainer.append(this._$last);

        },
        _setLocale: function () {
            this.localizedLabels = this._getLocalizedLabels();
            this._$first.attr("title", this.localizedLabels.firstPageTooltip);
            this._$prev.attr("title", this.localizedLabels.previousPageTooltip);
            this._$next.attr("title", this.localizedLabels.nextPageTooltip);
            this._$last.attr("title", this.localizedLabels.lastPageTooltip);
            this._$NP.attr("title", this.localizedLabels.nextPagerTooltip);
            this._$NP.attr("title", this.localizedLabels.previousPagerTooltip);
        },
        _applyCss: function () {
            if (this.model.totalRecordsCount == null) {
                if(this._$prev)this._$prev.addClass("e-prevpagedisabled e-disable").removeClass("e-prevpage").removeClass("e-default");
                if(this._$first)this._$first.addClass("e-firstpagedisabled e-disable").removeClass("e-firstpage").removeClass("e-default");
                if(this._$last)this._$last.addClass("e-lastpagedisabled e-disable").removeClass("e-lastpage").removeClass("e-default");
                if(this._$next)this._$next.addClass("e-nextpagedisabled e-disable").removeClass("e-nextpage").removeClass("e-default");
                if(this._$NP)this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                if (this.model.pageSizeList) {
                    $(".e-drpdwndiv").addClass("e-disable");
                }
                return;
            }
            else {
                if (this.model.totalRecordsCount == 0 && this.model.pageSizeList) {
                    $(".e-drpdwndiv").addClass("e-disable");
                }
                else if (this.model.totalRecordsCount != 0 && this.model.pageSizeList && $(".e-drpdwndiv").hasClass("e-disable")) {
                    $(".e-drpdwndiv").removeClass("e-disable");
                }
                if (this.model.currentPage > 1 && this._$prev && this._$first) {
                    this._$prev.removeClass("e-prevpagedisabled").removeClass("e-disable").addClass("e-prevpage e-default");
                    this._$first.removeClass("e-firstpagedisabled").removeClass("e-disable").addClass("e-firstpage e-default");
                } else {
                    if(this._$prev)this._$prev.addClass("e-prevpagedisabled e-disable").removeClass("e-prevpage").removeClass("e-default");
                    if(this._$first)this._$first.addClass("e-firstpagedisabled e-disable").removeClass("e-firstpage").removeClass("e-default");
                }
				if(this._$PP){
                (this.model.currentPage > this.model.pageCount) ?(this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default")) : (this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default"));}

                if (this._links.length && parseInt(this._links[0].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount > this.model.totalPages)
                    this._lastNP = true;
                else
                    this._lastNP = false;

                if (this._lastNP == false)
                    if(this._$NP)this._$NP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
                else
                    if(this._$NP)this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");

                this._lastpageCount = this.model.totalPages % this.model.pageCount;
                if (this._lastpageCount == 0)
                    this._lastpageCount = this.model.pageCount;
                if (this.model.currentPage > (this.model.totalPages - this._LastpageCount)) {
                    if(this._$PP)this._$PP.removeClass("e-nextprevitemdisabled").removeClass("e-disable").addClass("e-numericitem e-default");
                    if(this._$NP)this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                }
                if (this.model.currentPage == this.model.totalPages || this.model.totalRecordsCount == 0) {
                    if(this._$last)this._$last.addClass("e-lastpagedisabled e-disable").removeClass("e-lastpage").removeClass("e-default");
                    if(this._$next)this._$next.addClass("e-nextpagedisabled e-disable").removeClass("e-nextpage").removeClass("e-default");
                    if(this._$NP)this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                } else {
                    if(this._$last)this._$last.addClass("e-lastpage e-default").removeClass("e-lastpagedisabled").removeClass("e-disable");
                    if(this._$next)this._$next.addClass("e-nextpage e-default").removeClass("e-nextpagedisabled").removeClass("e-disable");
                }
                if (this._links.length) {
                    this._links.removeClass("e-currentitem").removeClass("e-active").addClass("e-default");
                    $(this._links[(this.model.currentPage - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-currentitem e-active");
                    $(this._links[(this._prevPageNo - 1) % this.model.pageCount]).removeClass("e-default").addClass("e-numericitem");
                }
                if (this._pageSize >= (this.model.totalRecordsCount / this.model.pageCount) && this._$PP != null && this._$PP.length != 0) {
                    this._$PP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                    this._$NP.addClass("e-nextprevitemdisabled e-disable").removeClass("e-numericitem").removeClass("e-default");
                }
            }
        },
        _SetTotalPages: function () {
            this.model.totalPages = (this.model.totalRecordsCount % this._pageSize == 0) ? (this.model.totalRecordsCount / this._pageSize) : (parseInt(this.model.totalRecordsCount / this._pageSize, 10) + 1);
        },
        _refreshNumericItem: function () {
            if (this._links.length != 0 && this._links != null) {
                this.model.currentPage = this.model.totalPages == 1 ? 1 : this.model.currentPage;
                if (this.model.currentPage > this.model.totalPages && this.model.totalPages != 0)
                    this.model.currentPage = this.model.totalPages;
                var _pagerTarget = parseInt(this.model.currentPage / this.model.pageCount, 10);
                if (this.model.currentPage % this.model.pageCount == 0)
                    if (_pagerTarget > 0)
                        _pagerTarget = _pagerTarget - 1;
                this._links.css("display", "none");
                for (var i = 0; i < this.model.pageCount; i++) {
                    var start = (_pagerTarget * this.model.pageCount) + 1 + i;
                    if (start <= this.model.totalPages) {
                        this._links[i].style.display = '';
                        $(this._links[i]).data('index', start);
                        $(this._links[i]).html(this.model.customText + start);
                    }
                }
            }
        },
        _refreshPagerInfo: function () {
            if (this.model.totalRecordsCount == 0)
                this.model.currentPage = 0;
            this.element.find(".e-pagermsg").text(String.format(this.localizedLabels.pagerInfo, this.model.currentPage, this.model.totalPages || 0, this.model.totalRecordsCount || 0));
        },
        _refreshExternalMessage: function () {
            if (this.model.externalMessage.toString().length)
                this.element.find(".e-pagermessage").empty().html(this.model.externalMessage).show();
            else
                this.element.find(".e-pagermessage").hide();
        },
        refreshPager: function () {
			if(this._templateElement) this._links = $(this._templateElement).find(".e-numericitem[role=link]");
            this._SetTotalPages();
            this._refreshNumericItem();
            this._refreshPagerInfo();
            this._applyCss();
            this.model.enableExternalMessage && this._refreshExternalMessage();
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            else
                this.element.removeClass("e-rtl");
            if (this.numTextbox) {
			if($(this._templateElement).find(".e-textbox-paging").length > 0){
				if(this.model.currentPage > this.model.totalPages && this.model.totalPages != 0){
					this.model.currentPage = this.model.totalPages;
				}
				 if (!this.numTextbox.is(':focus')) this.numTextbox.val(String.format("{0} of {1}", this.model.currentPage, this.model.totalPages));
			}
			else this.numTextbox.val(this.model.currentPage);
			}
        },

        _kDownHandler: function (e) {
            var code;
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            e.target = null;
            if (this.model.masterObject.checkKey("firstPage", code, e))
                e.target = this._$first;
            else if (this.model.masterObject.checkKey("previousPager", code, e))
                e.target = this._$PP;
            else if (this.model.masterObject.checkKey("previousPage", code, e))
                e.target = this._$prev;
            else if (this.model.masterObject.checkKey("lastPage", code, e))
                e.target = this._$last;
            else if (this.model.masterObject.checkKey("nextPager", code, e))
                e.target = this._$NP;
            else if (this.model.masterObject.checkKey("nextPage", code, e))
                e.target = this._$next;
            else
                return false;
            this._pagerClickHandler(e);
        },
        _pageInfo: function ($pagerContainer) {
            if ((this.model.showPageInfo || this.model.showGoToPage) && !this._parentMsgBar) {
                this._parentMsgBar = document.createElement("div");
                this._parentMsgBar.className += "e-parentmsgbar";
                if (this.model.showPageInfo)
                    this._renderMsgBar();
                this.element[0].appendChild(this._parentMsgBar);
                this.element[0].className += this.model.enableRTL ? " e-pager e-rtl" : " e-pager";
            } else if (!this.model.showPageInfo && !this.model.showGoToPage) {
                this._parentMsgBar && this._parentMsgBar.remove();
                this._parentMsgBar = null;
            }
            else $(this._parentMsgBar).find(".e-pagermsg").remove();
            this._msgWidth = $(this._parentMsgBar).outerWidth()
        },
        _doClickAnimation: function (event) {
            var element = $(event.target);
            if (element == undefined || event.type == undefined) return;
            element.addClass("e-animate");
        },
        _pagerClickHandler: function (e) {
            if (!this.model.enabled) return false;
            this._prevPageNo = this.model.currentPage;
            var $target = $(e.target);
            this.element.find(".e-animate").removeClass("e-animate");
            this._doClickAnimation(e);
            if ($.inArray(e.target, this._links) != -1) {
                this.model.currentPage = parseInt($(e.target).data("index"), 10);
            }
            else if ($target.hasClass("e-nextpage") && $target.hasClass("e-nextpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 0) {
                    this.model.currentPage++;
                    if (this._links != undefined && this._links.length != 0)
                        this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                    if (this.model.currentPage + this.model.pageCount >= this.model.totalPages)
                        this._lastNP = true;
                }
                else
                    this.model.currentPage++;
            }
            else if ($target.hasClass("e-prevpage") && $target.hasClass("e-prevpagedisabled") != true) {
                if (this.model.currentPage % this.model.pageCount == 1)
                    this._lastNP = false;
                this.model.currentPage--;
                if (this.model.currentPage < 0) { this.model.currentPage = 0; }
            }
            else if ($target.hasClass("e-lastpage") && $target.hasClass("e-lastpagedisabled") != true) {
                this._LastpageCount = this.model.totalPages % this.model.pageCount;
                (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                this.model.currentPage = this.model.totalPages;
                this._lastNP = true;
            }
            else if ($target.hasClass("e-firstpage") && $target.hasClass("e-firstpagedisabled") != true) {
                this.model.currentPage = 1;
                this._lastNP = false;
            }
            else if ($target.hasClass("e-NP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) + this.model.pageCount;
                if (parseInt(this._links[this.model.pageCount - 1].innerHTML.replace(this.model.customText, ""), 10) + this.model.pageCount >= this.model.totalPages) {
                    this._lastNP = true;
                    if ((this.model.totalRecordsCount - this._pageSize) < this._pageSize)
                        this._LastpageCount = this.model.totalRecordsCount - this._pageSize;
                    else
                        this._LastpageCount = ((this.model.totalRecordsCount / this._pageSize) % this.model.pageCount);
                    (this._LastpageCount == 0) ? (this._LastpageCount = this.model.pageCount) : null;
                    if (this._links != undefined)
                        this.model.currentPage = parseInt($(this._links[this.model.pageCount - 1]).data("index"), 10) + 1;
                }
            }
            else if ($target.hasClass("e-PP") && $target.hasClass("e-nextprevitemdisabled") != true) {
                if (this._links != undefined)
                    this.model.currentPage = parseInt($(this._links[0]).data("index"), 10) - this.model.pageCount;
                this._lastNP = false;
            }
            this._trigger("click", { "currentPage": this.model.currentPage, "event": e });
			if($target.hasClass("e-newrecord")){
				 this._trigger("addRecord", { "currentPage": this.model.currentPage, "event": e });
			}
            this.goToPage(this.model.currentPage, e);
            return false;
        },
        goToPage: function (pageIndex, event) {
            if (pageIndex != this.model.currentPage)
                this._prevPageNo = this.model.currentPage;
            if (this._prevPageNo !== pageIndex && (pageIndex >= 1 && pageIndex <= this.model.totalPages)) {
                this.model.currentPage = pageIndex;
                this.model.enableQueryString && this._updateQueryString(this.model.currentPage);
            }
            if (this._prevPageNo != this.model.currentPage) {
                this.refreshPager();
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
            }
        },
		goToNextPage: function () {
			if(this.model.totalRecordsCount != 0 && this.model.currentPage >= 1 && this.model.currentPage < this.model.totalPages){
				this.model.currentPage = this.model.currentPage + 1;
				this.refreshPager();
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
			}
		},
		goToLastPage: function () {
			if(this.model.totalRecordsCount != 0 && this.model.currentPage >= 1 && this.model.currentPage < this.model.totalPages){
				this.model.currentPage = this.model.totalPages;
				this.refreshPager();
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
			}
		},
		goToFirstPage: function () {
			if(this.model.totalRecordsCount != 0 && this.model.currentPage > 1){
				this.model.currentPage = 1;
				this.refreshPager();
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
			}
		},
		goToPrevPage: function () {
			if(this.model.totalRecordsCount != 0 && this.model.currentPage > 1 ){
				this.model.currentPage = this.model.currentPage - 1;
				this.refreshPager();
                this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": true, "event": event });
			}
		},
		
        _updateQueryString: function (value) {
            var _newUrl = this._getUpdatedURL(window.location.href, "page", value);
            if (history.pushState) {
                window.history.pushState({ path: _newUrl }, '', _newUrl);
            }
            else
                window.location.href = _newUrl;
        },

        _getUpdatedURL: function (uri, key, value) {
            var re = new RegExp("([?|&])" + key + "=.*?(&|#|$)", "i");
            if (uri.match(re)) {
                return uri.replace(re, '$1' + key + "=" + value + '$2');
            } else {
                var hash = '';
                var separator = uri.indexOf('?') !== -1 ? "&" : "?";
                if (uri.indexOf('#') !== -1) {
                    hash = uri.replace(/.*#/, '#');
                    uri = uri.replace(/#.*/, '');
                }
                return uri + separator + key + "=" + value + hash;
            }
        },
        _getLocalizedLabels: function (property) {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _fillScreen: function () {
			if(!$(this._templateElement).find(".e-textbox-paging").length > 0){
				var numLen = this.element.find('.e-pagercontainer').outerWidth() - (this._$first.outerWidth(true) + this._$last.outerWidth(true) + this._$next.outerWidth(true) + this._$prev.outerWidth(true))
				numLen -= !this._$NP||this._$NP.hasClass('e-disable') ? 0 : this._$NP.outerWidth(true);
				numLen -= !this._$PP||this._$PP.hasClass('e-disable') ? 0 : this._$PP.outerWidth(true);
				if(this.model.template){
					if (this.element.outerWidth() - $(this.element.find(".e-pagercontainer")).outerWidth() < 40) {
					if (Math.floor(numLen / this.element.find('.e-numericitem.e-spacing.e-default').outerWidth(true)) - 1 < 1) this._flag ? this.option("pageCount", 1) : this.model.pageCount = 1;
					else this._flag ? this.option("pageCount", Math.floor(numLen / this.element.find('.e-numericitem.e-spacing.e-default').outerWidth(true)) - 1) : this.model.pageCount = Math.floor(numLen / this.element.find('.e-numericitem.e-spacing.e-default').outerWidth(true)) - 1;
				}
				}
				else{
					if (this.element.outerWidth() - $(this.element.contents()[0]).outerWidth() < 40) {
						if (Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth(true)) - 1 < 1) this._flag ? this.option("pageCount", 1) : this.model.pageCount = 1;
						else this._flag ? this.option("pageCount", Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth(true)) - 1) : this.model.pageCount = Math.floor(numLen / this.element.find('.e-numericcontainer .e-numericitem.e-spacing.e-default').outerWidth(true)) - 1;
					}
				}
			}
        },
        _enable: function () {
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
            if (this.numTextbox) this.numTextbox.removeAttr("disabled");
        },
        _disable: function () {
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.prop("disabled", "disabled");
            if (this.numTextbox) this.numTextbox.attr("disabled","disabled");
            if (this.$dropItem) if (this.$dropItem.css("display") != "none") this.$dropItem.hide();
			if(this.model.template){
				$(this._templateElement).addClass(".e-disable");
			}
        },
        _setFirst: true,
        _setModel: function (options) {
            for (var prop in options) {
                this._preval = this.model.currentPage;
                switch (prop) {
                    case "pageCount":
                        this._renderNumericLinks(this.element.find(".e-numericcontainer"));
                        if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount;
                            this._fillScreen();
                        }
                        this._flag = false;
                        break;
					case "template":
                        this.element.children().remove();
                        this.renderPager();
                        break;
                    case "enableExternalMessage":
                        if (options[prop])
                            this._renderPagerMessage();
                        else
                            this._removePagerMessage();
                        break;
                    case "showPageInfo":
                        this._pageInfo();
                        break;
                    case "pageSizeMessage":
                        if (options[prop] != null) {
                            this._renderPageSizeMessage();
                        }
                        break;
					case "pageSize":
					    this._pageSize = this.model.pageSize;
					    if (this.model.pageSizeList && this.model.pageSizeList.length > 0) {
							proxy=this;
					        this.$textspan.text(this.model.pageSize);
					        this.$dropItem.find(".e-active").removeClass("e-active");
							 $(".e-drpdwn.e-ul").find("li").each(function()  {
								var $li=$(this);  
								if($li.text() == proxy.model.pageSize)
								{
									$(this).addClass("e-active")
								}
							});
					    }
						break;
					case "pageSizeList":
						this.model.pageSizeList = options[prop];
                        if (options[prop].length > 0) {
                            this._pageSize = this.model.pageSize;
                            if (this.$dropItem) {
                                this.$dropItem.empty();
                                this._renderItems();
                            }
                            else this._renderDropdownlist();
                        }
                        else if (this.$dropItem) this._removeDropdownlist();
                        break;
                    case "enabled":
                        if (!options[prop]) this._disable(); else this._enable(); break;
                    case "cssClass":
                        this.element.removeClass(this._cssClass).addClass(options[prop]); this._cssClass = this.model.cssClass;
                    case "isResponsive":
                        this._wireResizing();
                        if (!options[prop]) this.option("pageCount", this._maxPageCount);
                        else if (this.model.isResponsive && !this._flag) {
                            this._maxPageCount = this.model.pageCount; this._fillScreen();
                        }
                        this._flag = false;
                        break;
                    case "showGoToPage": if (options[prop]) this._renderTextboxItem(); else if (this.numTextbox) { this.numTextbox.remove(); this.numTextbox = null; } break;
                    case "locale": this._setLocale(); break;
                    case "currentPage": {
                        this.refreshPager();
                        this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": false });
                    }


                }
            }
            if (prop != "currentPage") {
                this.refreshPager();
                if (this._preval != this.model.currentPage)
                    this._trigger("change", { "currentPage": this.model.currentPage, "isInteraction": false });
            }
        },

        // all events bound using this._on will be unbind automatically
        _destroy: function () {
            this.element.empty().removeClass("e-pager");
            this._unWireResizing();
        }
    });
    ej.Pager.Locale = ej.Pager.Locale || {};

    ej.Pager.Locale["default"] = ej.Pager.Locale["en-US"] = {
        pagerInfo: "{0} of {1} pages ({2} items)",
        firstPageTooltip: "Go to first page",
        lastPageTooltip: "Go to last page",
        nextPageTooltip: "Go to next page",
        previousPageTooltip: "Go to previous page",
        nextPagerTooltip: "Go to next pager",
        previousPagerTooltip: "Go to previous pager"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSlider", "ej.Slider", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["value", "values"],
        _rootCSS: "e-slider",
        _setFirst: false,
        _requiresID: true,

        defaults: {

            orientation: "horizontal",

            enableAnimation: true,

            animationSpeed: 500,

            showTooltip: true,

            cssClass: "",

            showRoundedCorner: false,

            readOnly: false,

            enableRTL: false,

            htmlAttributes: {},

            minValue: 0,

            maxValue: 100,

            sliderType: "default",

            value: null,

            values: null,

            incrementStep: 1,

            height: null,

            width: null,

            enabled: true,

            showScale: false,

            largeStep: 10,

            smallStep: 1,

            showSmallTicks: true,

            showButtons: false,

            enablePersistence: false,
            
            allowMouseWheel:false,

            start: null,

            stop: null,

            slide: null,

            change: null,

            create: null,

            destroy: null,

            tooltipChange: null,

            renderingTicks: null
        },

        dataTypes: {
            orientation: "enum",
            enableAnimation: "boolean",
            animationSpeed: "number",
            cssClass: "string",
            showRoundedCorner: "boolean",
            readOnly: "boolean",
            enableRTL: "boolean",
            minValue: "number",
            maxValue: "number",
            sliderType: "enum",
            incrementStep: "number",
            enabled: "boolean",
            showButtons: "boolean",
            showScale: "boolean",
            largeStep: "number",
            smallStep: "number",
            showSmallTicks: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data",
            allowMouseWheel:"boolean"
        },

        observables: ["value", "values"],
        value: ej.util.valueFunction("value"),
        values: ej.util.valueFunction("values"),

        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                if (this.wrapper) this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable");
                if (this.model.showButtons) this.element.siblings('.e-sliderbtn').ejButton("model.enabled", this.model.enabled);
                this._wireEvents();
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this.model.enabled = false;
                if (this.wrapper) this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable");
                if (this.model.showButtons) this.element.siblings('.e-sliderbtn').ejButton("model.enabled", this.model.enabled);
                this._unWireEvents();
            }
        },

        _validateValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null || value === "") value = this.model.minValue;
            else if (typeof value === "string") value = parseFloat(value);

            if (this._isNumber(value)) {
                this._hidden.val(value);
                this.value(value);
            }
            else if (!this._isNumber(this.value())) {
                this._hidden.val(this.model.minValue);
                this.value(this.model.minValue);
            }
            if (this.model.sliderType != "range") this._setValue(animation);
        },

        _validateRangeValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null) value = new Array(this.model.minValue, this.model.maxValue);
            else if (typeof value === "string") {
                var vals = value.split(",");
                if (vals.length > 1) value = new Array(parseFloat(vals[0]), parseFloat(vals[1]));
            }

            if (typeof value === "object" && this._isNumber(value[0]) && this._isNumber(value[1])) {
                this._hidden.val(new Array(value[0], value[1]));
                this.values(new Array(value[0], value[1]));
            }
            else if (!(typeof this.values() === "object" && this._isNumber(this.values()[0]) && this._isNumber(this.values()[1]))) {
                this._hidden.val(new Array(this.model.minValue, this.model.maxValue));
                this.values(new Array(this.model.minValue, this.model.maxValue));
            }
            if (this.model.sliderType == "range") this._setRangeValue(animation);
        },

        _validateStartEnd: function () {
            if (isNaN(this.model.minValue)) this.model.minValue = 0;
            if (isNaN(this.model.maxValue)) this.model.maxValue = 100;
        },

        _isNumber: function (number) {
            return typeof number === "number" && !isNaN(number);
        },

        _outerCorner: function (boolean) {
            if (boolean) this._roundedCorner();
            else this._sharpedCorner();
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
            if (this.model.showScale)
                this.ul.removeClass(this.model.cssClass).addClass(skin);
        },

        getValue: function () {

            return this._getHandleValue();
        },

        setValue: function (value, animation) {
            if (this.model.sliderType == "range")
                this._validateRangeValue(value, animation);
            else
                this._validateValue(value, animation);
        },

        _init: function () {
            this._isInteraction = true;
            this._initialize();
            this._render();
        },

        _setModel: function (options) {
            this._isInteraction = false;
            if (!ej.isNullOrUndefined(options["minValue"]) || !ej.isNullOrUndefined(options["maxValue"])) {
                if (this._isNumber(options["minValue"])) this.model.minValue = options["minValue"];
                else options["minValue"] = this.model.minValue;

                if (this._isNumber(options["maxValue"])) this.model.maxValue = options["maxValue"];
                else options["maxValue"] = this.model.maxValue;

                if (this.model.sliderType == "range" && options["values"] == undefined) this._setRangeValue();
                else if (this.model.sliderType != "range" && options["value"] == undefined) this._setValue();
            }

            var option;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._validateValue(ej.util.getVal(options[option]));
                        options[option] = this.model.value;
                        break;
                    case "values":
                        var val= typeof options.values == "function" ? options.values() : options.values;
                        if (!ej.isNullOrUndefined(val) && !ej.isNullOrUndefined(val.length) && typeof val != "string")
                        {
                            if (!isNaN(val[0]) && !isNaN(val[1])) {
                                var actualValue = typeof this.values().join == "function" ? val.join() : val;
                                if (actualValue == this._hidden.val()) break;
                            }
                        }
                        this._validateRangeValue(ej.util.getVal(options[option]));
                        options[option] = this.model.values;
                        break;
                    case "height": this.model.height = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "width": this.model.width = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "showRoundedCorner": this._outerCorner(options[option]); break;
                    case "enableRTL": this.model.enableRTL = options[option];
                        if (this.model.showButtons) this._valueChanged = true;
                        this._checkRTL();
                        options[option] = this.model.enableRTL;
                        break;
                    case "cssClass": this._changeSkin(options[option]);
                        if (this.model.showButtons) this.element.siblings('.e-sliderbtn').ejButton("model.cssClass", options[option]);
                        break;
                    case "showScale": this._renderScale(options[option]);
                        if (this.model.enableRTL) this._changeVerticalScaleDir(options[option]); break;
                    case "orientation":
                        var t = this.model.height;
                        this.model.height = this.model.width;
                        this.model.width = t;
                    case "sliderType":
                        this._sliderOptions(option, options[option]); break;
                    case "smallStep":
                    case "largeStep":
                    case "showSmallTicks":
                    case "minValue":
                    case "maxValue":
                        this._scaleOptions(option, options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "tooltipChange":
                        this.model.tooltipChange = options[option]; break;
                    case "allowMouseWheel": this.model.allowMouseWheel = options[option]; break;
                    case "renderingTicks": this.model.renderingTicks = options[option]; break;
                    case "showButtons": this.model.showButtons = options[option]; this._renderButtons(); break;
                }
            }
        },

        _destroy: function () {
            if (this.model.showScale) this._destroyScale();
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            this.element.removeClass("e-widget e-box " + this.model.cssClass).empty();
            if (this.model.showButtons) this.element.removeAttr("style");
        },

        _initialize: function () {
            this.target = this.element[0];
            this.horDir = "left";
            this.verDir = "bottom";
            this._isFocused = false;
        },

        _render: function () {
            this.initialRender = true;
            this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false
            this.wrapper = ej.buildTag("div.e-slider-wrap e-widget" + this.model.cssClass + "#" + this.target.id + "_wrapper", { tabindex: "0", role: "slider" })
                .insertAfter(this.element);
            (this.model.showButtons) ? this._showButtons() : this.wrapper.append(this.element);

            this.element.addClass("e-widget e-box " + this.model.cssClass);
            if (this.model.sliderType != "default") {
                this.header = ej.buildTag("div.e-range");
                this.element.append(this.header);
                if (this.model.sliderType == "range") {
                    this.secondHandle = this._createHandle();
                }
            }
            this.firstHandle = this._createHandle();
            this._setOrientation();
            this._setDimension();
            this._insertHiddenField();
            this._checkProperties();
            if(!this.model.showScale) this._alignButtons();
            this._addAttr(this.model.htmlAttributes);
            this._setSliderValue();
        },

        _showButtons: function () {
            var proxy = this;
            var decreaseButton = ej.buildTag('button.e-decreasebtn e-sliderbtn e-animate');
            var increaseButton = ej.buildTag('button.e-increasebtn e-sliderbtn e-animate');
            decreaseButton.ejButton({
                contentType: "imageonly",
                prefixIcon: "e-icon e-minus",
                type: "button",
                repeatButton: true,
                enabled: proxy.model.enabled,
                cssClass: proxy.model.cssClass,
                click: function (e) { proxy._clickButtons(e) }
            });
            increaseButton.ejButton({
                contentType: "imageonly",
                prefixIcon: "e-icon e-plus",
                type: "button",
                repeatButton: true,
                enabled: proxy.model.enabled,
                cssClass: proxy.model.cssClass,
                click: function (e) { proxy._clickButtons(e) }
            });
            if ((this.model.enableRTL && this.model.orientation == "horizontal") || (this.model.orientation == "vertical" && !this.model.enableRTL))
                this.wrapper.append($(increaseButton)).append(this.element).append($(decreaseButton)).addClass("e-slider-buttons");
            else this.wrapper.append($(decreaseButton)).append(this.element).append($(increaseButton)).addClass("e-slider-buttons");
            this.wrapper.find('.e-sliderbtn').attr("tabindex", -1);
        },

        _renderButtons: function () {
            if (this.model.showButtons) {
                this._showButtons();
                if(!this.model.showScale) this._alignButtons();
            }
            else {
                this.element.siblings('.e-sliderbtn').remove();
                this.element.removeAttr('style');
                this.wrapper.removeClass("e-slider-buttons");
            }
            if (this.wrapper.find('ul').hasClass('e-scale')) {
                this._destroyScale();
                this._renderScale(true);
            }
        },

        _alignButtons: function () {
            if (this.model.showButtons) {
                var sliderButtons = this.wrapper.find('.e-sliderbtn');
                if (this.model.orientation == "horizontal") 
                    sliderButtons.css("top", ((this.element.outerHeight() / 2) - parseFloat(sliderButtons.outerHeight() / 2) + parseFloat(this.wrapper.css("padding-top"))) + "px");
                else 
                    sliderButtons.css("left", ((this.element.outerWidth() / 2) - parseFloat(sliderButtons.outerWidth() / 2) + parseFloat(this.wrapper.css("padding-left"))) + "px");
            }
        },

        _clickButtons: function (evt) {
            if ($(evt.target).hasClass("e-animate"))
                $(evt.target).removeClass('e-animate');
            if (this.model.readOnly || ej.isNullOrUndefined(evt.target)) return;
            var value, hval;
            if (this.model.sliderType == "range") {
                if ($(this.element).find('.e-handle.e-focus').is(this.firstHandle) && !this.model.enableRTL) { this.firstHandle.focus().addClass("e-no-tab"); hVal = this.handleVal; }
                else if (!this.model.enableRTL) { this.secondHandle.focus().addClass("e-no-tab"); hVal = this.handleVal2; }
                if ($(this.element).find('.e-handle.e-focus').is(this.secondHandle) && this.model.enableRTL) { this.secondHandle.focus().addClass("e-no-tab"); hVal = this.handleVal2; }
                else if (this.model.enableRTL) { this.firstHandle.focus().addClass("e-no-tab"); hVal = this.handleVal; }
            }
            else { this.firstHandle.focus().addClass("e-no-tab"); hVal = this.handleVal; }
            if ($(evt.target).hasClass("e-decreasebtn")) value = this._add(hVal, this.model.incrementStep, false);
            else value = this._add(hVal, this.model.incrementStep, true);
            this._changeHandleValue(value, false);
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(true);
                else proxy.element.attr(key, value)
            });
        },

        _renderScale: function (showScale) {
            if (showScale) {
                this.wrapper.addClass("e-scale-wrap");
                var width = "width", orien = "h", spanText;
                if (this.model.orientation == "vertical") {
                    width = "height";
                    orien = "v";
                }

                var _smallStep = this.model.smallStep;
                if (!this.model.showSmallTicks) {
                    if (this.model.largeStep > 0)
                        _smallStep = this.model.largeStep;
                    else
                        _smallStep = this.model.maxValue - this.model.minValue;
                }
                else if (_smallStep <= 0)
                    _smallStep = this.model.incrementStep;
                var count = Math.abs(this.model.maxValue - this.model.minValue) / _smallStep;

                this.ul = ej.buildTag("ul.e-scale e-" + orien + "-scale " + this.model.cssClass);
                if (this._isIE8) this.ul.addClass('e-ie8')
                this.wrapper.append(this.ul);

                var li, args, start = this.model.minValue, left = 0, tickWidth = 100 / count;
                if (orien == "v") start = this.model.maxValue;
                for (var i = 0; i <= count; i++) {
                    li = ej.buildTag("li.e-tick", "", {}, { "title": start });
                    var islargeTick = (start % this.model.largeStep == 0) ? true : false;
                    if (islargeTick) li.addClass("e-large");
                    li.css(width, tickWidth + "%");
                    if (this.model.renderingTicks) {
                        args = { value: start, valueType: "tooltip", tick: li[0]};
                        this._trigger("renderingTicks", args);
                        li.attr("title", args.value);
                    }
                    if (islargeTick) {
                        if (this.model.renderingTicks) {
                            args.valueType = "label";
                            args.value = start;
                            this._trigger("renderingTicks", args);
                            spanText = args.value;
                        }
                        else spanText = start;
                        var span = ej.buildTag("span.e-tick-value", "" + spanText);
                        li.append(span);
                    }
                    this.ul.append(li);

                    if (orien == "h") start += _smallStep;
                    else start -= _smallStep;
                    left += _smallStep;
                }

                this.ul.children().first().addClass("e-first-tick").css(width, (tickWidth / 2) + "%");
                this.ul.children().last().addClass("e-last-tick").css(width, (tickWidth / 2) + "%");

                this._scaleAlignment();
            }
            else this._destroyScale();
            this._setWrapperHeight();
            this._alignButtons();
        },
        _destroyScale: function () {
            this.wrapper.removeClass("e-scale-wrap");
            this.ul.remove();
            this.ul = null;
        },

        _tickValuePosition: function () {
            var width = (this.model.orientation == "vertical") ? "height" : "width";
            var left = (this.model.orientation == "vertical") ? "top" : "left";
            var firstTick = this.ul.find(".e-tick.e-first-tick");
            var first = firstTick.find(".e-tick-value");
            var other = this.ul.find(".e-tick.e-large:not(.e-first-tick)").find(".e-tick-value");
            var tickWidth = firstTick[width]() * 2;
            first.css(left, -first[width]() / 2);
            other.css(left, (tickWidth - other[width]()) / 2);
        },

        _scaleAlignment: function () {
            this._tickValuePosition();
            var smallTick = 12, largeTick = 20, half = largeTick / 2;
            var height = "height", top = "top", orien = "h";
            if (this.model.orientation == "vertical") {
                height = "width";
                top = "right";
                orien = "v";
                (this.element.width() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            }
            else
                (this.element.height() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            // scale
             this.ul.css(top, -(this.wrapper[height]() + half));
            if(orien == "v") this.ul.css("top", -this.wrapper.height()).css(top, half);
            this.ul[height](this.wrapper[height]() + largeTick);
            // small-ticks
            var topSize = -(largeTick - smallTick) / 2;
            if (this.model.largeStep == null && orien != "v") topSize = -topSize;
            this.ul.find(".e-tick:not(.e-large)").css(height, this.wrapper[height]() + smallTick).css(top, topSize);
            // tick-values   // 4 - distance between tick value and tick
            if (orien == "v") this.ul.children(".e-large").find(".e-tick-value").css("right", this.wrapper.width() + largeTick + 4);
        },

        _setWrapperHeight : function(){
            var wrapHeight, wrapWidth;
            if (this.model.orientation == "horizontal") {
                if (this.ul)
                    wrapHeight = (this.firstHandle.outerHeight() > this.ul.height()) ? this.firstHandle.outerHeight() : this.ul.height();
                else wrapHeight = this.firstHandle.outerHeight();
                var top = (wrapHeight - this.element.outerHeight()) / 2;
                if (top < 0) top = 0;
                this.wrapper.css({ "padding": top + "px 0px" });
            }
            else {
                if (this.ul)
                    wrapWidth = (this.firstHandle.outerWidth() > this.ul.width()) ? this.firstHandle.outerWidth() : this.ul.width();
                else wrapWidth = this.firstHandle.outerWidth();
                var right = ( wrapWidth - this.element.outerWidth()) / 2;
                if (right < 0) right = 0;
                this.wrapper.css({ "padding": "0px " + right + "px" });
            }
        },


        _createHandle: function () {
			var handle = ej.buildTag("a.e-handle e-select", "", {}, { "aria-label": "drag", "tabindex": 0});
            this.element.attr({ role: "slider", "aria-valuemin": this.model.minValue, "aria-valuemax": this.model.maxValue });
            ej.browserInfo().name == "msie" && handle.addClass("e-pinch");
            this.element.append(handle);
            return handle;
        },

        _setDimension: function () {
            if (this.model.height) this.wrapper.height(this.model.height);
            if (this.model.width) this.wrapper.width(this.model.width);
            this._setHandleSize();
            this._handleAlignment(this.model.enableRTL);
            this._alignButtons();
        },

        _insertHiddenField: function () {
            this._hidden = ej.buildTag("input", "", {},
                { "type": "hidden", "name": this.element[0].id });
            this._hidden.val(this._getHandleValue());
            this.element.append(this._hidden);
        },

        _checkProperties: function () {
            if (!this.model.enabled) {
                if (this.wrapper) this.wrapper.addClass("e-disable");
                else this.element.addClass("e-disable");
            }
            else this._wireEvents();
            if (this.model.showScale) this._renderScale(true);
            else this._setWrapperHeight();
            if (this.model.enableRTL) this._checkRTL();
            if (this.model.showRoundedCorner) this._roundedCorner();
        },

        _roundedCorner: function () {
            this.element.addClass("e-corner");
        },

        _sharpedCorner: function () {
            this.element.removeClass("e-corner");
        },

        _handleAlignment: function (rtl) {
            var mar = -(this.firstHandle.outerWidth() / 2) + "px", margin;
            if (this.model.orientation != "vertical") {
                if (!rtl) margin = "0 0 0 " + mar;
                else margin = "0 " + mar + " 0 0";
            }
            else {
                if (!rtl) margin = "0 0 " + mar + " 0";
                else margin = mar + " 0 0 0";
            }
            this.element.children('.e-handle').css("margin", margin);
        },

        _checkRTL: function () {
            if (this.model.showButtons && this._valueChanged) {
                this.element.siblings('.e-sliderbtn').remove();
                this._renderButtons();
            }
            var rtl = this.model.enableRTL, preDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;
            if (rtl) {
                (this.model.orientation != "vertical") ? this.wrapper.addClass("e-rtl") : this.wrapper.addClass("e-top-to-bottom");
                this.horDir = "right";
                this.verDir = "top";
            }
            else {
                this.wrapper.removeClass("e-rtl e-top-to-bottom");
                this.horDir = "left";
                this.verDir = "bottom";
            }
            if (!this.model.showButtons || (this.model.showButtons && this.model.enableRTL)) this._changeVerticalScaleDir(this.model.showScale);
            var currDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;

            if (preDir != currDir) {
                this.firstHandle.css(currDir, this.firstHandle[0].style[preDir]).css(preDir, "auto");
                if (this.model.sliderType != "default") {
                    this.header.css(currDir, this.header[0].style[preDir]).css(preDir, "auto");
                    if (this.model.sliderType == "range")
                        this.secondHandle.css(currDir, this.secondHandle[0].style[preDir]).css(preDir, "auto");
                }
            }
            this._handleAlignment(rtl);
        },

        _setOrientation: function () {
            if (this.model.orientation != "vertical") {
                this.wrapper.addClass("e-horizontal");
            }
            else {
                this.wrapper.addClass("e-vertical");
                this.firstHandle.css(this.verDir, "0");
            }
        },

        _changeVerticalScaleDir: function (showScale) {
            if (showScale) {
                var verscaleli = this.wrapper.find('.e-v-scale li');
                if (verscaleli.length > 0)
                {
                    var revdir = verscaleli.toArray().reverse(); verscaleli.remove();
                    this.wrapper.find('.e-v-scale').append(revdir);
                }
            }
        },

        _setHandleSize: function () {
            if ((this.model.height != null && this.model.orientation == "horizontal") || (this.model.width != null && this.model.orientation == "vertical") ) {
                var size;
                if (this.model.orientation != "vertical")
                    size = this.wrapper.height() + 2;
                else
                    size = this.wrapper.width() + 2;
                this.element.find(".e-handle").height(size).width(size);
            }
            else{
                this.wrapper.addClass("e-default-wrap");
                this.element.find(".e-handle").addClass("e-default");
            }
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _sliderOptions: function (prop, value) {
            this._unWireEvents();
            this._destroy();
            this.model[prop] = value;
            this._init();
        },

        _scaleOptions: function (prop, value) {
            if (this.model.showScale) {
                this._destroyScale();
                this.model[prop] = value;
                this._renderScale(true);
                if (this.model.enableRTL)
                    this._changeVerticalScaleDir(true);
            }
        },

        _showTooltip: function () {
            if (this.model.showTooltip) {
                this._timeOut && clearTimeout(this._timeOut);
                var _tooltip = this.tooltip ? $('body .e-tooltipbox').text().replace(/\s+/g, '').replace("-", ",") : "";
                if (this.tooltip && this.tooltip.length && this.tooltip.css("display") != "none" && this._getHandle()[0] == this._oldHandle && _tooltip == this.preValue) {
                    if (this._getHandleValue().toString() != this.preValue)
                        this._setTooltipPosition();
                    return;
                }
                this._oldHandle = this._getHandle()[0];
                $('body .e-tooltipbox').remove();
                this.tooltip = ej.buildTag("div.e-tooltipbox " + this.model.cssClass + " e-corner", { role: "tooltip" }).css(this._getOffset(this._getHandle()));
                $("body").append(this.tooltip);
                if (this.model.orientation == "vertical") {
                    this.tooltip.addClass("e-vertical");
                }
                this._setTooltipPosition();
            }
        },

        _hideTooltip: function () {
            if (this.model.showTooltip) {
                var proxy = this;
                this._timeOut = setTimeout(function () {
                    proxy.tooltip.fadeOut(800);
                }, 1500);
            }
                
        },

        _showhideTooltip: function (showTooltip) {
            if (this.model.showTooltip && showTooltip) {
                this._showTooltip();
                this._timeOut && clearTimeout(this._timeOut);
                this._hideTooltip();
            }
        },

        _setTooltipPosition: function () {
            if (this.model.showTooltip) {
                this._updateTooltipValue();
                var top, left, remainLeft, remainTop, handle, pos, gap = 5, broder, tooltipPos, border; // gap -> distance between tooltip and slider
                handle = this._getHandle(), pos = this._getOffset(handle), tooltipPos = this._getOffset(this.tooltip);
                border = $(handle).outerHeight() - $(handle).height();
                if (this.model.orientation == "vertical") {
                    remainTop = (this.tooltip.outerHeight() - handle.outerHeight()) / 2;
                    remainLeft = handle.outerWidth() + gap;
                    top = pos.top - remainTop;
                    left = pos.left + remainLeft;
					var height=$(window).height();
                    if (window.pageYOffset > 0) height+=window.pageYOffset; 
                    if (top < 0) top = 0;
                    else if (height < top + this.tooltip.outerHeight()) top = height - this.tooltip.outerHeight() - border;
                    if ($(window).width() < left + this.tooltip.outerWidth()) left = pos.left - this.tooltip.outerWidth() - border;
                }
                else {
                    if (tooltipPos.left + this.tooltip.outerWidth() > $(window).width()) this.tooltip.css({ "left": '0px' });
                    remainLeft = (this.tooltip.outerWidth() - handle.outerWidth()) / 2;
                    remainTop = this.tooltip.outerHeight() + gap;
                    top = pos.top - remainTop;
                    left = pos.left - remainLeft;
					var width=$(window).width();
                    if (window.pageXOffset > 0) width+=window.pageXOffset;    
                    if (left < 0) left = 0;
                    else if (width < left + this.tooltip.outerWidth()) left = width - this.tooltip.outerWidth() - border;
                    if (top < 0 || pos.top < remainTop) {
                        if (pos.top + handle.outerHeight() + border + this.tooltip.outerHeight() > $(window).height()) {
                            top = pos.top;
                            if (pos.left > this.tooltip.outerWidth() + gap + border) left = pos.left - (this.tooltip.outerWidth() + border);
                            else left = pos.left + (handle.outerWidth() + gap + border);
                        } else top = pos.top + handle.outerHeight() + border;
                    }
                }
                var zindex = this._maxZindex();
                this.tooltip.css({ "top": top, "left": left, "zIndex": zindex + 1 });
            }
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },


        _maxZindex: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },

        _updateTooltipValue: function () {
            var one = 0, two = 1, val;
            if (this.model.enableRTL) { one = 1, two = 0; }
            if (this.model.tooltipChange)
                val = this._raiseEvent("tooltipChange");
            else
                val = this._getHandleValue();
            if (this.model.sliderType != "range")
                this.tooltip[0].innerHTML = val;
            else
                this.tooltip[0].innerHTML = val[one] + " - " + val[two];
        },

        _increaseHeaderWidth: function (animation) {
            if (this.model.sliderType != "default") {
                var size = "width", direction = this.horDir, properties = {};
                if (this.model.orientation == "vertical") { size = "height", direction = this.verDir; }

                if (this.model.sliderType == "range") {
                    properties[size] = this.handlePos - this.handlePos2 + "%";
                    properties[direction] = this.handlePos2 + "%";
                }
                else {
                    properties[size] = this.handlePos + "%";
                    properties[direction] = 0;
                }
                if (!animation) this.header.css(properties);
                else this.header.animate(properties, this.model.animationSpeed);
            }
        },

        _setSliderValue: function () {
            this._validateStartEnd();

            if (this.model.sliderType == "range")
                this._validateRangeValue(this.values());
            else
                this._validateValue(this.value());
            this.preValue = this.getValue().toString();
        },


        _hoverOnHandle: function (evt) {
            $(evt.currentTarget).addClass("e-hover");
        },

        _leaveFromHandle: function (evt) {
            $(evt.currentTarget).removeClass("e-hover");
        },

        _firstHandleClick: function (evt) {
            evt.preventDefault();
            this.firstHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos = this.handlePos;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._on($(document),"mouseleave",this._firstHandleUp);
            this._showTooltip();
        },

        _firstHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position = { x: evt.pageX, y: evt.pageY };
            this.handlePos = this._xyToPosition(position);

            if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
            }
            if (this.handlePos != this.preHandlePos) {
                this.preHandlePos = this.handlePos;
                this.handleVal = this._positionToValue(this.handlePos);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _firstHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._off($(document), "mouseleave", this._firstHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos != this.handlePos) this._raiseChangeEvent();
        },

        _secondHandleClick: function (evt) {
            evt.preventDefault();
            this.secondHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos2 = this.handlePos2;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._secondHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._on($(document),"mouseleave",this._secondHandleUp);
            this._showTooltip();
        },

        _secondHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position2 = { x: evt.pageX, y: evt.pageY };
            this.handlePos2 = this._xyToPosition(position2);

            if (this.handlePos2 > this.handlePos) {
                this.handlePos2 = this.handlePos;
            }
            if (this.handlePos2 != this.preHandlePos2) {
                this.preHandlePos2 = this.handlePos2;
                this.handleVal2 = this._positionToValue(this.handlePos2);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _secondHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove,this._secondHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._off($(document), "mouseleave", this._secondHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos2 != this.handlePos2) this._raiseChangeEvent();
        },

        _focusInHandle: function (evt) {
            if (!this._isFocused) {
                this._isFocused = true;
                $(evt.currentTarget).addClass("e-focus");
                if (!this.model.readOnly)
                   this._on($(document),"keydown",this._moveHandle);
                if (this.model.allowMouseWheel && !this.model.readOnly) {
                    this._on(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
                }
                this.activeHandle = $(evt.currentTarget).is(this.firstHandle) ? 1 : 2;
                this._setZindex();
            }
        },

        _focusOutHandle: function (evt) {
            if ($(evt.relatedTarget).is('button') && $(evt.target).parent().siblings().is(evt.relatedTarget)) return;
            if (ej.isNullOrUndefined(evt.relatedTarget) && !ej.isNullOrUndefined(evt.originalEvent.toElement)) {
                if ($(evt.originalEvent.toElement).is('button') && $(evt.target).parent().siblings().is(evt.originalEvent.toElement)) return;
            }
            this._isFocused = false;
            if (this.model.showTooltip && this.tooltip)
                this.tooltip.fadeOut(800);
            this.element.find(".e-no-tab").removeClass("e-no-tab");
            $(evt.currentTarget).removeClass("e-focus");
         this._off($(document),"keydown",this._moveHandle);
            this._off(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
        },

        _moveHandle: function (e) {
            if ((e.type == 'mousewheel') || (e.type=='DOMMouseScroll')) e.preventDefault()
            var oper, val, handleNo;
            handleNo = this._getHandleIndex(this.activeHandle) - 1;
            if ((e.type == 'mousewheel') || (e.type == 'DOMMouseScroll')) {
                var rawEvent = e.originalEvent;
                if (rawEvent.wheelDelta) {
                    delta = rawEvent.wheelDelta / 120;
                }
                else if (rawEvent.detail) {
                    // Firefox uses detail property, which is a multiple of 3.
                    delta = -rawEvent.detail / 3;
                }
                oper = delta > 0 ? 'add' : 'sub';
            }

            switch (e.keyCode || e.originalEvent.wheelDelta) {
                case -120:
                case 37:
                case 40:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "sub";
                    break;
                case 120:
                case 38:
                case 39:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "add";
                    break;
                case 36:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.minValue) {
                        this._changeHandleValue(this.model.minValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 2) ? this.model.minValue : this.handleVal2;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 35:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.maxValue) {
                        this._changeHandleValue(this.model.maxValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 1) ? this.model.maxValue : this.handleVal;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 27:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    this._getHandle().focusout();
                    break;
            }

            if (oper == "add" || oper == "sub") {
                if (this._raiseEvent("start")) return false;
                var hVal = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
                var value = (oper == "add") ? this._add(hVal, this.model.incrementStep, true) : this._add(hVal, this.model.incrementStep, false);
                this._changeHandleValue(value, false);
            }
        },

        _changeHandleValue: function (value, animate) {
            var position = null;
            if (this.activeHandle == 1) {
                this.handleVal = this._checkHandleValue(value);
                this.handlePos = this._checkHandlePosition(this.handleVal);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos = this.handlePos2;
                    this.handleVal = this.handleVal2;
                }
                if (this.handlePos != this.preHandlePos)
                    position = this.preHandlePos = this.handlePos;
            }
            else {
                this.handleVal2 = this._checkHandleValue(value);
                this.handlePos2 = this._checkHandlePosition(this.handleVal2);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos2 = this.handlePos;
                    this.handleVal2 = this.handleVal;
                }
                if (this.handlePos2 != this.preHandlePos2)
                    position = this.preHandlePos2 = this.handlePos2;
            }

            if (position != null) {
                this._increaseHeaderWidth(animate);
                this._setHandlePosition(animate, true, true);
            }
        },

        _sliderBarClick: function (evt) {
            if (this.model.readOnly) return false;
            if (evt.target == this.target || (this.model.sliderType != "default" && evt.target == this.header[0]) || $(evt.target).hasClass('e-tick') || $(evt.target).hasClass('e-scale') || evt.target == this.wrapper[0]) {
                evt.preventDefault();
                if (this._raiseEvent("start")) return false;
                var pos = { x: evt.pageX, y: evt.pageY },
                handlepos = this._xyToPosition(pos),
                handleVal = this._positionToValue(handlepos);

                if (this.model.sliderType == "range" && (this.handlePos - handlepos) > (handlepos - this.handlePos2)) {
                    this.handlePos2 = this.preHandlePos2 = handlepos;
                    this.handleVal2 = handleVal;
                    this.activeHandle = 2;
                }
                else {
                    this.handlePos = this.preHandlePos = handlepos;
                    this.handleVal = handleVal;
                    this.activeHandle = 1;
                }

                this._getHandle().focus().addClass("e-no-tab");;
                if (this.model.sliderType != "default") this._increaseHeaderWidth(this.model.enableAnimation);
                this._setHandlePosition(this.model.enableAnimation, true, true);
            }
        },

        _setHandlePosition: function (animation, showTooltip, changeEvt) {
            var Handle = this._getHandle(), proxy = this, properties = {}, pos, val, direction;
            pos = (this.activeHandle == 1) ? this.handlePos : this.handlePos2;
            val = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
            Handle.attr("aria-label", val);
            direction = (this.model.orientation == "vertical") ? this.verDir : this.horDir;
            properties[direction] = pos + "%";
            if (pos == 0) {
                this.model.sliderType != "range" && this._getHandle().addClass("e-handle-start");
            }
            else {
                this._getHandle().removeClass("e-handle-start");
            }
            if (!animation) {
                Handle.css(properties);
                this._showhideTooltip(showTooltip);
                if (changeEvt) this._raiseChangeEvent();
            }
            else Handle.animate(properties, this.model.animationSpeed, function () {
                proxy._showhideTooltip(showTooltip);
                if (changeEvt) proxy._raiseChangeEvent();
            });
        },

        _xyToPosition: function (position) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            if (this.model.orientation != "vertical") {
                var left = position.x - this.element.offset().left,
                num = this.element.width() / 100,
                val = (left / num);
            }
            else {
                var top = position.y - this.element.offset().top,
                num = this.element.height() / 100,
                val = 100 - (top / num);
            }
            val = this._stepValueCalculation(val);
            if (val < 0) val = 0;
            else if (val > 100) val = 100;
            if (this.model.enableRTL) return 100 - val;
            return val;
        },

        _updateValue: function () {
            this.handleVal = this._checkHandleValue(this.value());
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.preHandlePos = this.handlePos;
            this.activeHandle = 1;
        },

        _setValue: function (animation) {
            this._updateValue();
            this._increaseHeaderWidth(animation);
            this._setHandlePosition(animation, false, true);
        },

        _updateRangeValue: function () {
            var values = this.values();
            this.handleVal = this._checkHandleValue(values[1]);
            this.handleVal2 = this._checkHandleValue(values[0]);
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.handlePos2 = this._checkHandlePosition(this.handleVal2);

            if (this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
                this.handleVal = this.handleVal2;
            }
            this.preHandlePos = this.handlePos;
            this.preHandlePos2 = this.handlePos2;
        },

        _setRangeValue: function (animation) {
            this._updateRangeValue();
            this._increaseHeaderWidth(animation);
            this.activeHandle = 1;
            this._setHandlePosition(animation, false, false);
            this.activeHandle = 2;
            this._setHandlePosition(animation, false, true);
        },

        _checkHandlePosition: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            var handle = this._tempStartEnd();
            if (value >= handle.start && value <= handle.end)
                value = (100 * (value - this.model.minValue)) / (this.model.maxValue - this.model.minValue);
            else if (value < handle.start) value = 0;
            else value = 100;
            return value;
        },

        _checkHandleValue: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return this.model.minValue;
            var handle = this._tempStartEnd();
            if (value < handle.start) value = handle.start;
            else if (value > handle.end) value = handle.end;
            return value;
        },

        _tempStartEnd: function () {
            if (this.model.minValue > this.model.maxValue)
                return {
                    start: this.model.maxValue,
                    end: this.model.minValue
                };
            else
                return {
                    start: this.model.minValue,
                    end: this.model.maxValue
                };
        },

        _positionToValue: function (pos) {
            var diff = this.model.maxValue - this.model.minValue,
            val = this._round(diff * pos / 100),
            total = this._add(val, this.model.minValue, true);
            return total;
        },

        _getHandle: function () {
            return (this.activeHandle == 1) ? this.firstHandle : this.secondHandle;
        },

        _getHandleIndex: function (no) {
            if (this.model.sliderType == "range" && no == 1)
                return 2;
            return 1;
        },

        _getHandleValue: function () {
            if (this.model.sliderType == "range") return [this.handleVal2, this.handleVal];
            else return this.handleVal;
        },

        _updateModelValue: function () {
            var value = this._getHandleValue();
            this._hidden.val(value);
            if (this.model.sliderType == "range") this.values(value);
            else this.value(value);
        },

        _add: function (a, b, addition, precision) {
            var x = Math.pow(10, precision || 3), val;
            if (addition) val = (Math.round(a * x) + Math.round(b * x)) / x;
            else val = (Math.round(a * x) - Math.round(b * x)) / x;
            return val;
        },

        _round: function (a) {
            var _f = this.model.incrementStep.toString().split(".");
            return _f[1] ? parseFloat(a.toFixed(_f[1].length)) : Math.round(a);
        },

        _raiseChangeEvent: function () {
            this._updateModelValue();
            if (this.initialRender)
                this.initialRender = false;
            else {
                if(this.getValue().toString() != this.preValue.toString()){
                        this._raiseEvent("change");
                        this._raiseEvent("stop");
                        this.preValue = this.getValue().toString();
                        this._isInteraction = true;
                }
            }
        },

        _raiseEvent: function (name) {
            var data = { id: this.target.id, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "change")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "tooltipChange")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            var status = this._trigger(name, data);
            if (name == "tooltipChange")
                return data.value;
            return status;
        },

        _setZindex: function () {
            if (this.model.sliderType == "range") {
                if (this.activeHandle == 1) {
                    this.firstHandle.css("z-index", 2);
                    this.secondHandle.css("z-index", 1);
                }
                else {
                    this.firstHandle.css("z-index", 1);
                    this.secondHandle.css("z-index", 2);
                }
            }
        },

        _stepValueCalculation: function (value) {
            if (this.model.incrementStep == 0) this.model.incrementStep = 1;
            var percentStep = this.model.incrementStep / ((this.model.maxValue - this.model.minValue) / 100);
            var remain = value % Math.abs(percentStep);
            if (remain != 0) {
                if ((percentStep / 2) > remain) value -= remain;
                else value += Math.abs(percentStep) - remain;
            }
            return value;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "mousedown", this._sliderBarClick);
            this._on(this.firstHandle, ej.eventType.mouseDown, this._firstHandleClick);
            this._on(this.firstHandle, "mouseenter", this._hoverOnHandle);
            this._on(this.firstHandle, "mouseleave", this._leaveFromHandle);
            this._on(this.firstHandle, "focusin", this._focusInHandle);
            this._on(this.firstHandle, "focusout", this._focusOutHandle);

            if (this.model.sliderType == "range") {
                this._on(this.secondHandle, ej.eventType.mouseDown, this._secondHandleClick);
                this._on(this.secondHandle, "mouseenter", this._hoverOnHandle);
                this._on(this.secondHandle, "mouseleave", this._leaveFromHandle);
                this._on(this.secondHandle, "focusin", this._focusInHandle);
                this._on(this.secondHandle, "focusout", this._focusOutHandle);
            }
        },


        _unWireEvents: function () {
            this._off(this.wrapper, "mousedown");
            this._off(this.firstHandle, ej.eventType.mouseDown);
            this._off(this.firstHandle, "mouseenter");
            this._off(this.firstHandle, "mouseleave");
            this._off(this.firstHandle, "focusin");
            this._off(this.firstHandle, "focusout");

            if (this.model.sliderType == "range") {
                this._off(this.secondHandle, ej.eventType.mouseDown);
                this._off(this.secondHandle, "mouseenter");
                this._off(this.secondHandle, "mouseleave");
                this._off(this.secondHandle, "focusin");
                this._off(this.secondHandle, "focusout");
            }
        }
    });

    ej.SliderType = {
        /**  support for slider control to select a single value. */
        Default: "default",
        /**  support for slider control to select a single value considered from start value to current handle. */
        MinRange: "minrange",
        /**  support for slider control to select a range of value between the two handles. */
        Range: "range"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitButton", "ej.SplitButton", {

        element: null,

        model: null,
        validTags: ["button"],
        _setFirst: false,

        _rootCSS: "e-splitbutton",

        defaults: {

            size: "normal",

            width: "",

            height: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            buttonMode: "split",

            arrowPosition: "right",

            targetID: null,

            target: null, 

            showRoundedCorner: false,

            prefixIcon: null,

            suffixIcon: null,

            cssClass: "",

            enableRTL: false,

            create: null,

            beforeOpen: null,

            click: null,

            itemMouseOver: null,

            itemMouseOut: null,

            itemSelected: null,

            open: null,

            close: null,

            destroy: null,

            popupPosition: "down",
    
        },

        dataTypes: {
            size: "string",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            buttonMode: "enum",
            arrowPosition: "enum",
            target: "string",       
            targetID: "string",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            htmlAttributes: "data"
        },


        disable: function () {
            this.element.addClass("e-disable");
            this.wrapper.addClass("e-disable");
            if (this.contstatus) {
                this._hidePopup();
            }
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.addClass("e-disable").attr("aria-disabled", true);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        visible: function (display) {
            if (!display) {
               this.wrapper.addClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "hidden");
            }
            else {
               this.wrapper.removeClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "");
            }
        },

        enable: function () {
            this.element.removeClass("e-disable");
            this.wrapper.removeClass("e-disable");
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.removeClass("e-disable").attr("aria-disabled", false);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        hide: function () {
            if (this.contstatus) {
                this._hidePopup();
            }
        },

        show: function () {
            if (!this.contstatus) {
                if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                    this.element.click();
                else if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.dropbutton.click();
            }
        },

        setPopupPosition: function (val) {
            this._setPosition = true;
            this._val = val;
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            this._setPosition = false;
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._documentClickHandler = $.proxy(this._documentClick, this);
            this._wireEvents();
        },

        _createElement: function (tagName, attrs) {
            var ele = document.createElement(tagName);
            this._setAttributes(ele, attrs);
            return $(ele);
        },
        _setAttributes: function (ele, attrs) {
            for (var key in attrs) {
                ele.setAttribute(key, attrs[key]);
            }
        },

        _destroy: function () {
            if (this.contstatus) {
                this._hide();
            }
            this.splitwrap.removeClass("e-drop");
            this.splitwrap.removeClass("e-btn-" + this.model.size);
            this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
            this.element.removeClass(this.model.cssClass + "e-ntouch e-select e-corner e-btn e-disable e-split-btn e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop e-left-btn e-txt").empty();
            this.element.append(this._cloneElement.text());
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            if(this._contextObj) this._contextObj.model && this._contextObj.destroy();            
			if(this._contextObj) this._contextObj = null;			
            //this has to be worked out in Menu
            $(this.model.target).show();
            $(this.model.target).insertAfter(this.element); 
            this._off(this.element, "click", this._btnMouseClick);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "width":
                        this._splitbtnWidth(options[option]);
                        break;
                    case "height":
                        this._splitbtnHeight(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "buttonMode":
                        this._setButtonMode(options[option]);
                        break;
                    case "arrowPosition":
                        this._setArrowPosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "targetID":
                    case "target":
                        this._setTarget(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "popupPosition":
                        this._setPopupPosition(options[option]);
                        break;
                }
            }
        },

        _setText: function (val) {
            if (this.model.contentType == ej.ContentType.TextOnly) {
                if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.element.html(val);
                else {
                    this.element.empty();
                    this.imgtxtwrap = val;
                    if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Top)
                        this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    else
                        this.element.append(this.imgtxtwrap, this.btnimgwrap);
                }
            } else {
                this.textspan.html(val);
            }
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
        },
        _setTarget: function (val) {
            if ((val.substring(0, 1) == ".") || (val.substring(0, 1) == "#")) {
                this.model.target = val; 
            }
            else {
                this.model.targetID = val;
                this.model.target = "#" + val;
            }
            this._renderContxtMenu();
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if (val == ej.ImagePosition.ImageRight || val == ej.ImagePosition.ImageLeft || val == ej.ImagePosition.ImageBottom || val == ej.ImagePosition.ImageTop) {
                if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                    this.element.empty();
                    this.model.imagePosition = val;
                    this._renderButtonContent();
                }
            }
        },

        _setButtonMode: function (val) {
            if (val == ej.ButtonMode.Split || val == ej.ButtonMode.Dropdown) {
                if (val != this.model.buttonMode) {
                    this._destroy();
                    this.model.buttonMode = val;
                    this._init();
                }
            }
        },

        _setArrowPosition: function (val) {
            if (val == ej.ArrowPosition.Right || val == ej.ArrowPosition.Left || val == ej.ArrowPosition.Bottom || val == ej.ArrowPosition.Top) {
                if ((this.model.buttonMode == ej.ButtonMode.Dropdown) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this.element.empty();
                    this._setSize(this.model.size);
                    this.element.removeClass("e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop");
                    this._renderButtonContent();
                }
                else if ((this.model.buttonMode == ej.ButtonMode.Split) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this._setSize(this.model.size);
                    this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
                    this._setRTL(this.model.enableRTL);
                }
            }
        },

        _setPopupPosition: function (val) {
            this.model.popupPosition = val;
            if (this.model.popupPosition == "down")
                this.dropdownimg.addClass("e-arrow-sans-down").removeClass("e-arrow-sans-up");
            if (this.model.popupPosition == "up")
                this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
        },

        _setRTL: function (val) {
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
                switch (this.model.arrowPosition) {
                    case ej.ArrowPosition.Right:
                        this.innerWrap.addClass("e-splitarrowright");
                        break;
                    case ej.ArrowPosition.Left:
                        this.innerWrap.addClass("e-splitarrowleft");
                        break;
                    case ej.ArrowPosition.Bottom:
                        this.innerWrap.addClass("e-splitarrowbottom");
                        break;
                    case ej.ArrowPosition.Top:
                        this.innerWrap.addClass("e-splitarrowtop");
                        this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                        break;
                }
                val == true ? (this.innerWrap.hasClass("e-splitarrowleft") ? "" : this.splitwrap.addClass("e-rtl e-btnrtl")) && (this._contextObj && this._contextObj.model && this._contextObj.element.addClass('e-rtl')) : this.splitwrap.removeClass("e-rtl e-btnrtl") && (this._contextObj && this._contextObj.model && this._contextObj.element.removeClass('e-rtl'));
            }
            else
                val == true ? this.splitwrap.addClass('e-rtl') && (this._contextObj && this._contextObj.model && this._contextObj.element.addClass('e-rtl')) : this.splitwrap.removeClass('e-rtl') && (this._contextObj && this._contextObj.model && this._contextObj.element.removeClass('e-rtl'));
            this.model.enableRTL = val;
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).addClass('e-corner');  
            } else {
                this.element.removeClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).removeClass('e-corner');
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass);
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton.removeClass(this.model.cssClass);
                this.dropbutton.addClass(skin);
            }
            this.element.addClass(skin);
            if(this._contextObj) this._contextObj.model && this._contextObj.option('cssClass', skin);  
        },

        _initialize: function () {
            if (this.element.is("button") || this.element.is("ej-splitbutton")) {
                this._render();
            } else {
                this.element.removeClass("e-splitbutton");//need to change in src level
            }
            this._timeout = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._controlStatus(false);
                else proxy.wrapper.attr(key, value)
            });
        },


        _render: function () {
            this.element.addClass(this.model.cssClass + " e-btn e-select e-split-btn " + (!ej.isTouchDevice() ? "e-ntouch" : ""));
            this._setAttributes(this.element[0]);
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.text();
            }
            else
                this._setAttributes(this.element[0],{"aria-describedby": this.model.text});
            if (this.model.buttonMode != ej.ButtonMode.Split && this.model.buttonMode != ej.ButtonMode.Dropdown)
                this.model.buttonMode = ej.ButtonMode.Split;
            if (this.model.arrowPosition != ej.ArrowPosition.Right && this.model.arrowPosition != ej.ArrowPosition.Left && this.model.arrowPosition != ej.ArrowPosition.Bottom && this.model.arrowPosition != ej.ArrowPosition.Top)
                this.model.arrowPosition = ej.ArrowPosition.Right;
            this.element.empty();
            this.splitwrap = (this.model.buttonMode == ej.ButtonMode.Split ? this._createElement('span', { 'class': 'e-split e-widget' }) : this._createElement('span', { 'class': 'e-split e-drop e-widget' }));
            this.splitwrap.insertBefore(this.element);
            this.innerWrap = this._createElement('span', { 'class': 'e-in-wrap e-box e-padding' });
            this.splitwrap[0].appendChild(this.innerWrap[0]);
            this.wrapper = this.splitwrap;
            /*DropDown Image*/
            this.dropdownimg = this._createElement('span', { "class": "e-icon e-arrow-sans-down" });
            this.dropdownimage = this._createElement('span', { "class": "e-icon e-arrow-sans-up" });
            this.btnimgwrap = this._createElement('span', { 'class': 'e-split-btn-div e-btn-span' });
            if (this.model.popupPosition == "up")
                this.btnimgwrap[0].appendChild(this.dropdownimage[0])
            else
            this.btnimgwrap[0].appendChild(this.dropdownimg[0]);
            /*Split Button*/
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton = ej.buildTag('button.e-split-btn e-btn e-select ' + this.model.cssClass + ' e-drp-btn' + (!ej.isTouchDevice() ? " e-ntouch" : ""), "", {}, { type: "button", "data-role": "none", "id": this.element[0].id + 'drpbtn' });
                this.dropbutton[0].appendChild(this.btnimgwrap[0]);
                this.dropbutton.insertAfter(this.element);
                if (this.model.contentType == ej.ContentType.TextOnly)
                    this.dropbutton.addClass("e-btn-txt");
                else
                    this.dropbutton.addClass("e-rht-btn");
            }
            this._setSize(this.model.size);
            this.element.addClass("e-left-btn");
            this._renderButtonContent();
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.innerWrap[0].appendChild(this.element[0]);
            else {
                this.innerWrap[0].appendChild(this.element[0]);
                this.innerWrap[0].appendChild(this.dropbutton[0]);
            }
            /* If target ID is set, the value of target will be set to target prefixed with # tag */
            if ((this.model.target == null) && (this.model.targetID != null)) {
                this.model.target = "#"+this.model.targetID;
            }
            /*Rendering Context menu*/
            $(this.model.target).hide();
            this._roundedCorner(this.model.showRoundedCorner);
            this._setRTL(this.model.enableRTL);
            this._addAttr(this.model.htmlAttributes);
        },

        _renderButtonContent: function () {
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
            this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
            this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');;
            /*Rendering Option*/
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
            } else {
                this.element.addClass("e-txt");
                this.imgtxtwrap = this.model.text;
            }
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this._renderDropdownArrow();
            else
                this.element.append(this.imgtxtwrap);
        },

        _renderDropdownArrow: function () {
            this.btnimgwrap.css("position", "absolute");
            this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
            switch (this.model.arrowPosition) {
                case ej.ArrowPosition.Right:
                    this.element.addClass("e-droparrowright");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Left:
                    this.element.addClass("e-droparrowleft");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
                case ej.ArrowPosition.Bottom:
                    this.element.addClass("e-droparrowbottom");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Top:
                    this.element.addClass("e-droparrowtop");
                    this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
            }
        },


        _setSize: function (val) {
            this.wrapper.css({ "height": "", "width": "" });
            switch (val) {
                case "mini":
                    this._splitbtnSize(val);
                    break;
                case "small":
                    this._splitbtnSize(val);
                    break;
                case "medium":
                    this._splitbtnSize(val);
                    break;
                case "large":
                    this._splitbtnSize(val); 
                    break;
                default:
                    this._splitbtnSize(val);
                    break;
            }
            if ((this.model.arrowPosition == ej.ArrowPosition.Bottom || this.model.arrowPosition == ej.ArrowPosition.Top) && this.model.height == "")
                this.splitwrap.addClass("e-btn-arrowsplit-" + val);		   // 15px added the height of the wrapper due to Arrow positioned in bottom
            var wd, ht = this.model.height === "" ? this.wrapper.outerHeight() + "px" : this.model.height;
            this._splitbtnHeight(ht);
            if (this.model.size !== "normal") {
                wd = this.model.width === "" ? this.wrapper.outerWidth() + "px" : this.model.width;
                this._splitbtnWidth(wd);
            }
            else if (this.model.width !== "") {
                wd = this.model.width;
                this._splitbtnWidth(wd);
            }
        },

        _splitbtnSize: function (val) {
        
            this.splitwrap.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal e-btn-arrowsplit-large e-btn-arrowsplit-small e-btn-arrowsplit-mini e-btn-arrowsplit-medium e-btn-arrowsplit-normal');
            if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Right)
            {
            this.splitwrap.addClass("e-btn-" + val);
            }
        },
        _splitbtnHeight: function (val) {
           if ((val == "") || (val == null)) val = '30px';
          this.splitwrap.css("height", val);
        },


        _splitbtnWidth: function (val) {
            this.splitwrap.css("width", val);
        },


        _renderContxtMenu: function () {
            /* Check whether target is a class and add a id to that target element if id of that element is not given */
            if ((this.model.target != null) && ($(this.model.target).attr("id") == null)) {
                if (this.model.target.substring(0, 1) == ".") {
                    $(this.model.target).attr("id", this.element.attr('id') + "_" + this.model.target.replace(".", ""));
                }
            }
            
            $(this.model.target).ejMenu({
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: "",
                fields: this.model.fields,
                showArrow: true,
                cssClass: "e-split " + this.model.cssClass,
                enableRTL: this.model.enableRTL
            }).on("ejMenuclose", $.proxy(this._onKeyDown, this));
            this._contextObj = $(this.model.target).ejMenu("instance");
        },
        _onKeyDown: function (e) {
            e.keyCode == 27 && this._hide();
        },
        _itemClick: function (args) {
            args = { status: this.model.enabled, ID: args.ID, text: args.text };
            this._trigger("itemSelected", args);
            (!$(args.element).hasClass("e-haschild")) && this._hide();
        },

        _itemMouseOver: function (args) {
            this._trigger("itemMouseOver", args);
        },

        _itemMouseOut: function (args) {
            this._trigger("itemMouseOut", args);
        },


        _wireEvents: function () {
            this._on(this.element, "click", this._btnMouseClick);
            this._on(this.element, "mousedown", this._btnMouseDown);
            /*DrpBTN*/
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this._on(this.dropbutton, "click", this._btnMouseClick);
            /*DocClk*/
            this._on($(document), "mousedown", this._docrhtclk);
        },


        _btnMouseClick: function (e) {
            !this._contextObj ? this._renderContxtMenu() : !this._contextObj.model && this._renderContxtMenu();
            var args;
            if(!this.model.enabled) return false;
            if (!$(e.currentTarget).hasClass("e-disable")) {
                if (e.currentTarget.id != this.element[0].id + "drpbtn" && this.model.buttonMode == ej.ButtonMode.Split) {
                    args = { status: this.model.enabled };
                    this._trigger("click", args);
                } else {
                    !this.contstatus && this._trigger("beforeOpen");
                    this.wrapper.addClass('e-active');
                    if (this.contstatus) {
                        this._hidecontext(e);
                    } else {
                        this._contextPosition(e);
                        this._trigger("open");
                        this._on($(window), "resize", this._OnWindowResize);
                        this.contstatus = true;
                        this.element.on("click", $.proxy(this._hidecontext, this));
                        ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, false, this);
                        this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
                    }
                }
            }
        },

        _OnWindowResize: function (e) {
            this._contextPosition(e);
        },

        _contextPosition: function (e,value,m,n) {
            if (this._contextObj.model) {
                if (this._setPosition) 
                    var position = this._val;
                else
                var position = this._getXYpos(e);
                var posleft, targetElement, posadjustleft;
                targetElement = (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
                var contextObj = this._contextObj;
                posleft = position.x - ($(this.model.target).outerWidth() - (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerWidth() : this.element.outerWidth()));
                if (this.model.enableRTL)
                    position.x = (this.model.popupPosition=="left" || (posleft < $(this.model.target).outerWidth())) ? position.x : posleft;
                else
                    position.x = ((this.model.popupPosition == "left") || (position.x + $(this.model.target).outerWidth() < $(window).width())) ? position.x : posleft;
                if (this._posright < 0 && this.model.popupPosition == "left") position.x = $(window).outerWidth();
                 contextObj.option({
                    click: $.proxy(this._itemClick, this),
                    mouseover: $.proxy(this._itemMouseOver, this),
                    mouseout: $.proxy(this._itemMouseOut, this)
                 });
                 if (value)
                     contextObj.show(m, n, targetElement, e);
                else
                 contextObj.show(position.x, position.y, targetElement, e);
            }
        },

        _getXYpos: function (e) {
            var btnpos, btnposx, btnposy, posleft, posright, poscur = 1, postop;
            btnpos = this._getOffset(this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
            posleft = (this.model.popupPosition == "right" && ((!this.model.enableRTL) && (this.model.arrowPosition != ej.ArrowPosition.Left) && (this.model.arrowPosition != ej.ArrowPosition.Bottom) && (this.model.arrowPosition != ej.ArrowPosition.Top))) ? (this.model.buttonMode == ej.ButtonMode.Split?(btnpos.left + this.dropbutton.outerWidth()):(btnpos.left + this.element.outerWidth())) : ((this.model.popupPosition == "left" && (((this.model.enableRTL)||(this.model.arrowPosition != ej.ArrowPosition.Right)) && (this.model.arrowPosition != ej.ArrowPosition.Bottom) && (this.model.arrowPosition != ej.ArrowPosition.Top)))) ? (btnpos.left - ($(this.model.target).outerWidth())) : btnpos.left;
            this._posright = ($(window).width() - posleft) - ($(this.model.target).outerWidth());
            this._posleft = posleft - $(this.model.target).outerHeight();
            this._posrightht = ($(window).height() - btnpos.top - $(this.model.target).outerHeight());
            btnposx = ((this.model.popupPosition=="right" && (this._posright<0))||(posleft < 0))  ? (btnpos.left) : posleft;
            postop = ((this.model.arrowPosition == ej.ArrowPosition.Top) || (this.model.popupPosition == "up")) ? (btnpos.top - $(this.model.target).outerHeight() + 1) : (((this.model.arrowPosition != ej.ArrowPosition.Top) && (this.model.arrowPosition != ej.ArrowPosition.Bottom) && ((((this.model.arrowPosition == ej.ArrowPosition.Right) != (this.model.popupPosition == "left")) || ((this.model.arrowPosition == ej.ArrowPosition.Right) && this.model.enableRTL && (this.model.popupPosition == "left"))) && (((this.model.arrowPosition == ej.ArrowPosition.Left)) != (this.model.popupPosition == "right")) || ((this.model.arrowPosition == ej.ArrowPosition.Right) && this.model.enableRTL && (this.model.popupPosition == "left"))) && (((!this.model.enableRTL) && (this.model.popupPosition == "right")) || (this.model.popupPosition == "left")))  ? (btnpos.top) : ((this.model.buttonMode == ej.ButtonMode.Split ? (btnpos.top + this.dropbutton.outerHeight()) : (btnpos.top + this.element.outerHeight())) - poscur));//1px added to top due to element border-top as none
            btnposy =((this.model.popupPosition == "left") && this._posrightht < 0 && this._posright > 0 && this._posleft <0) ? (btnpos.top - ($(this.model.target).outerHeight())) : ((this.model.popupPosition == "left") && this._posrightht < 0 && this._posright > 0) ? (btnpos.top+this.element.outerHeight() - ($(this.model.target).outerHeight())) : ((this.model.popupPosition == "right"||this.model.popupPosition=="up"||this.model.popupPosition) && this._posrightht < 0 && this._posright < 0) ? (btnpos.top - ($(this.model.target).outerHeight())) : ((this.model.popupPosition == "right" || this.model.popupPosition == "left") && this._posrightht < 0) ? (btnpos.top + this.element.outerHeight() - ($(this.model.target).outerHeight())) : (this.model.popupPosition == "right" && this._posright < 0 && this._posrightht > 0) ? btnpos.top + this.element.outerHeight() :(this.model.popupPosition=="down"&&this._posrightht<0&&this._posright>0)?(btnpos.top-$(this.model.target).outerHeight()):((posleft < 0) || (this._posright < 0)) ? (btnpos.top + this.element.outerHeight()) : (postop < 0) ? (this.model.buttonMode == ej.ButtonMode.Split && this.model.popupPosition == "up" && this.model.arrowPosition != ej.ArrowPosition.Top) ? (btnpos.top + this.element.outerHeight() - poscur) : ((btnpos.top + (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerHeight() + this.element.outerHeight() : this.element.outerHeight()) - poscur)) : postop;
            return { x: btnposx, y: btnposy };
        },
        _getOffset: function (ele) {
            var pos = ele.offset();
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },


        _btnMouseDown: function (e) {
            if (!$(e.currentTarget).hasClass("e-disable")) {
                this._docrhtclk(e);
            }
        },
        _hidePopup: function (e) {
           this._contextObj && this._contextObj.hide(e);   
            this._hide();
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
        },
        _hide: function () {
            this.contstatus = false;
            this.wrapper.removeClass('e-active');
            this.element.off("click", $.proxy(this._hidecontext, this));
            ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, true, this);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hide);
            this._closeEvent();
        },
        _closeEvent: function () {
            this._trigger("close");
        },

        _hidecontext: function (e) {
            if (($(e.target).is(this.element) || $(e.target).is(this.dropbutton) || $(e.target).is(this.textspan) || $(e.target).is(this.dropdownimg) || $(e.target).is(this.btnimgwrap) || !$(e.target).is(this.majorimgtag) || !$(e.target).is(this.minorimgtag)) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) || (this.element.hasClass("e-txt") || $(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is(this.element) && !$(e.target).is(this.dropbutton) && !$(e.target).is(this.textspan) && !$(e.target).is(this.dropdownimg) && !$(e.target).is(this.btnimgwrap) && !$(e.target).is(this.majorimgtag) && !$(e.target).is(this.minorimgtag) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) && (this.element.hasClass("e-txt") || !$(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _docrhtclk: function (e) {
            var isRightClick, targetElement;
            isRightClick = false;
            if (e.button) {
                isRightClick = (e.button == 2);
            } else if (e.which) {
                isRightClick = (e.which == 3); //for Opera
            }
            targetElement = e.target;
            if (isRightClick) {
                e.preventDefault();
            }
        },

    });

    ej.ContentType = { TextOnly: "textonly", ImageOnly: "imageonly", ImageBoth: "imageboth", TextAndImage: "textandimage", ImageTextImage: "imagetextimage" };

    ej.ImagePosition = { ImageRight: "imageright", ImageLeft: "imageleft", ImageTop: "imagetop", ImageBottom: "imagebottom" };

    ej.ButtonSize = { Mini: "mini", Small: "small", Medium: "medium", Large: "large" };

    ej.ButtonMode = { Split: "split", Dropdown: "dropdown" };

    ej.ArrowPosition = { Right: "right", Left: "left", Top: "top", Bottom: "bottom" };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejToggleButton", "ej.ToggleButton", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["toggleState"],
        _setFirst: false,

        _rootCSS: "e-togglebutton",

        defaults: {

            size: "normal",

            type: "button",

            width: "",

            height: "",

            enabled: true,

            toggleState: false,

            defaultText: null,

            preventToggle: false,

            activeText: null,

            contentType: "textonly",

            htmlAttributes: {},

            imagePosition: "imageleft",

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            defaultPrefixIcon: null,

            defaultSuffixIcon: null,

            activePrefixIcon: null,

            activeSuffixIcon: null,

            enableRTL: false,

            create: null,

            click: null,

            change: null,

            destroy: null
        },


        dataTypes: {
            size: "string",
            type: "enum",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            preventToggle: "boolean",
            defaultText: "string",
            activeText: "string",
            contentType: "enum",
            imagePosition: "enum",
            defaultPrefixIcon: "string",
            defaultSuffixIcon: "string",
            activePrefixIcon: "string",
            activeSuffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data"
        },
        observables: ["toggleState"],
        toggleState: ej.util.valueFunction("toggleState"),


        disable: function () {
            this.buttontag.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
        },

        enable: function () {
            if (this.buttontag.hasClass("e-disable")) {
                this.buttontag.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._wireEvents();
            this.initialRender = false;
        },

        _destroy: function () {
            this._off(this.buttontag, "blur", this._tglebtnblur);
            this.element.unwrap();
            this.element.removeClass('e-chkbx-hidden e-tbtn');
            !this._cloneElement.attr("name") && this.element.attr("name") && this.element.removeAttr("name");
            this.labelFinder.empty();
            this.labelFinder.text(this.model.defaultText);
            this.buttontag.remove();
            this.element.unwrap();
            this.defaultLabel.insertAfter(this.element);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "type":
                        this._settype(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "defaultText":
                        this._setDefaultText(options[option]);
                        break;
                    case "activeText":
                        this._setActiveText(options[option]);
                        break;
                    case "defaultPrefixIcon":
                        this._setDefaultMajorIcon(options[option]);
                        break;
                    case "defaultSuffixIcon":
                        this._setDefaultMinorIcon(options[option]);
                        break;
                    case "activePrefixIcon":
                        this._setActiveMajorIcon(options[option]);
                        break;
                    case "activeSuffixIcon":
                        this._setActiveMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "toggleState":
                        this._tglevaluestatus(ej.util.getVal(options[option]));
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },

        _setSize: function (val) {
            this.buttontag.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.buttontag.addClass("e-btn-" + val);
        },

        _settype: function (val) {
            this.model.type = val;
        },


        _setHeight: function (val) {
            this.buttontag.css('height', val);
        },

        _setWidth: function (val) {
            this.buttontag.css('width', val);
        },

        _setDefaultText: function (val) {
            if (!this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }	
        },

        _setActiveText: function (val) {
            if (this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }
        },

        _setDefaultMajorIcon: function (val) {
            this.defMainIcon.removeClass(this.model.defaultPrefixIcon);
            this.defMainIcon.addClass(val);
        },

        _setDefaultMinorIcon: function (val) {
            this.defMiniIcon.removeClass(this.model.defaultSuffixIcon);
            this.defMiniIcon.addClass(val);
        },

        _setActiveMajorIcon: function (val) {
            if (this.toggleState()) {
                this.defMainIcon.removeClass(this.model.activePrefixIcon);
                this.defMainIcon.addClass(val);
            }
        },

        _setActiveMinorIcon: function (val) {
            if (this.toggleState()) {
                this.defMiniIcon.removeClass(this.model.activeSuffixIcon);
                this.defMiniIcon.addClass(val);
            }
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.buttontag.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.buttontag.empty();
                this.model.imagePosition = val;
                this._renderButtonContent();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.buttontag.addClass("e-rtl");
            } else {
                this.buttontag.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.buttontag.removeClass(this.model.cssClass);
                this.buttontag.addClass(skin);
            }
        },

        _initialize: function () {
            if (this.element.is('[type = "checkbox"]')) {
                this._render();
            } else {
                this.element.removeClass("e-togglebutton");
            }
        },


        _render: function () {
			this.initialRender = true;
            var predecessor, labelSelector;
            /*Determine Button Type*/
            this.element.addClass('e-chkbx-hidden e-tbtn');
            if (!this.element.attr("name"))
                this.element.attr("name", this.element[0].id);
            /*Finding the label element in the dom*/
            predecessor = this.element.parents().last();
            labelSelector = "label[for='" + this.element[0].id + "']";
            this.labelFinder = predecessor.find(labelSelector);
            this.defaultLabel = predecessor.find(labelSelector).clone();
            if (!this.labelFinder.length) {
                this.labelFinder = ej.buildTag('label', "Button", {}, { "for": this.element[0].id });
                this.labelFinder.insertAfter(this.element);
            }
            if ((this.model.defaultText == null) || (this.model.defaultText == "")) {
                this.model.defaultText = this.labelFinder.text();
            }
            this.labelFinder.empty();
            this.wrapper = $('<span id="' + this.element[0].id + '-wrapper" class="e-tbtn-wrap e-widget"></span>');
            this.labelFinder.append(this.element);
            this.buttontag = ej.buildTag('button.e-togglebutton e-btn e-tbtn ' + this.model.cssClass + ' e-select', "", {}, { "role": "button", "tabindex": 0, "type": this.model.type, "data-role": "none" });
            if (!ej.isTouchDevice()) this.buttontag.addClass("e-ntouch");
            $(this.labelFinder).wrap(this.wrapper);
            this.buttontag.insertAfter(this.labelFinder);
            if (ej.util.isNullOrUndefined(this.model.activeText)) {
                this.model.activeText = this.model.defaultText;
            }
            if (ej.util.isNullOrUndefined(this.model.activePrefixIcon)) {
                this.model.activePrefixIcon = this.model.defaultPrefixIcon;
            }
            if (ej.util.isNullOrUndefined(this.model.activeSuffixIcon)) {
                this.model.activeSuffixIcon = this.model.defaultSuffixIcon;
            }
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this._renderButtonContent();
            if (!this.toggleState() && !ej.isNullOrUndefined(this.element.attr('checked')))
                this.toggleState(true);
            this._tglevaluestatus(this.toggleState());
            this._roundedCorner(this.model.showRoundedCorner);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._tglevaluestatus(this.toggleState());
                else proxy.wrapper.attr(key, value);
            });
        },

        _renderButtonContent: function () {
            this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');
            this.defaulttxtspan = ej.buildTag('span.e-btntxt' + '#' + this.element[0].id + 'textstatic',(this.toggleState() ? this.model.activeText : this.model.defaultText));
            if (this.model.contentType.indexOf("image") > -1) {
                this.defMainIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'mainiconstatic');
                this.defMiniIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'miniconstatic');
                (this.toggleState() ? this.defMainIcon.addClass(this.model.activePrefixIcon) : this.defMainIcon.addClass(this.model.defaultPrefixIcon));
                (this.toggleState() ? this.defMiniIcon.addClass(this.model.activeSuffixIcon) : this.defMiniIcon.addClass(this.model.defaultSuffixIcon))
            }
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                }
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.defMainIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.defMainIcon, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else {
                this.buttontag.addClass("e-txt");
                this.buttontag.text(this.model.defaultText);
            }
        },

        _tglevaluestatus: function (value) {
            if (value) {
                this._toggleButtonStatus(value);
                this.element.attr("checked", "checked");
            } else {
                this._toggleButtonStatus(value);
                this.element.prop("checked",false);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.buttontag.addClass('e-corner') : this.buttontag.removeClass('e-corner');
        },


        _wireEvents: function () {
            this._on(this.buttontag, "click", this._tglebtnclicked);
            this._on(this.buttontag, "blur", this._tglebtnblur);
        },

        _tglebtnblur:function(e){
            this.buttontag.removeClass("e-animate");
        },

        _tglebtnclicked: function (e) {
            if (this.model.preventToggle && !this.model.enabled) return false;
            if (!this.model.preventToggle) {
                if (!this.buttontag.hasClass("e-disable")) {
                    this.toggleState(this.toggleState() ? false : true);
                    if (ej.browserInfo().name == "msie" && (ej.browserInfo().version == "8.0"))
                        this._tglevaluestatus(this.toggleState());
                    else
                        this._toggleButtonStatus(this.toggleState());
                    $(this.element).prop("checked", this.toggleState());
                    e.preventDefault();
                    this.buttontag.addClass("e-animate");
                    this._trigger("click", { "isChecked": this.toggleState(), status: this.model.enabled });
                }
            }
        },

        _toggleButtonStatus: function (buttonstatus) {
            if (buttonstatus) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.activeText);
                } else {
                    this.defaulttxtspan.html(this.model.activeText);
                    this.defMainIcon.removeClass(this.model.defaultPrefixIcon).addClass(this.model.activePrefixIcon);
                    this.defMiniIcon.removeClass(this.model.defaultSuffixIcon).addClass(this.model.activeSuffixIcon);
                }
                this.buttontag.addClass("e-active").attr("aria-pressed", true);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.defaultText);
                } else {
                    this.defaulttxtspan.html(this.model.defaultText);
                    this.defMainIcon.removeClass(this.model.activePrefixIcon).addClass(this.model.defaultPrefixIcon);
                    this.defMiniIcon.removeClass(this.model.activeSuffixIcon).addClass(this.model.defaultSuffixIcon);
                }
                this.buttontag.removeClass("e-active").attr("aria-pressed", false);
            }
            this.toggleState(buttonstatus);
            if(!this.initialRender)
            this._trigger('change', { "isChecked": this.toggleState() });
        },

    });

    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft", 
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
        ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
		Large: "large" 
    };
        
    ej.ButtonType = {
        /**  Creates button with button type as button */
        Button: "button",
        /**  Creates button with button type as reset */
        Reset: "reset",
        /**  Creates button with button type as submit */
        Submit: "submit"

    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the Toolbar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejToolbar", "ej.Toolbar", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,

        _rootCSS: "e-toolbar",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            enabled: true,

            hide: false,

            disabledItemIndices: [],

            enabledItemIndices: [],

            enableSeparator: false,

            orientation: "horizontal",

            enableRTL: false,

            isResponsive: false,

            showRoundedCorner: false,

            htmlAttributes: {},

            dataSource: null,
			
			Items:{

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },

            query: null,
		
			responsiveType:"popup",


            fields: {

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },
            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 },
					adjust: { xValue: 17, yValue: 17 }
                },
                isBalloon: false
            },

            cssClass: "",
			
			targetID : null,

            create: null,

            click: null,

            itemHover: null,

            itemLeave: null,
			
			overflowOpen:null,
			
			overflowClose:null,

            destroy: null

        },


        dataTypes: {
            enabled: "boolean",
            hide: "boolean",
            enableSeparator: "boolean",
            disabledItemIndices: "data",
            enabledItemIndices: "data",
            orientation: "enum",
            enableRTL: "boolean",
            showRoundedCorner: "boolean",
            isResponsive: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            cssClass: "string",
            htmlAttributes: "data",
			targetID: "string",
			responsiveType:"enum"
        },



        hide: function () {
            if (!this.model.enabled && (this.element.css("display") == "none")) return false;
            this.element.css("display", "none");
			this.model.hide = true;
        },

        show: function () {
            if (!this.model.enabled && (this.element.css("display") != "none")) return false;
            this.element.css("display", "block");
			this.model.hide = false;
        },


        _init: function () {
            if(this.model.targetID != null)
				this.element.html($("#" + this.model.targetID).find('ul,ol'));
			this._cloneElement = $(this.element).clone();
			//Stored the local & remote data source processed value. 
			 
			this._localDataSource=null;
            if (this.model.dataSource != null) {
                this._generateTemplate();
            }
			else if(this.model.Items != null)
			{
			  this._generateTemplate();
			}
            (!(this.model.dataSource instanceof ej.DataManager)) && this._initialize();
            this._renderTooltip(this.model.tooltipSettings);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this.model.width = options[option];
                        this._setWidth();
                        this._bindUnbindWidth();
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "disabledItemIndices": {
                        this._disableItemByIndex(options[option]);
						options[option] = this.model.disabledItemIndices;
                        break;
                    }
                    case "enabledItemIndices": {
						this._enableItemByIndex(options[option]); 
						break;
					}
                    case "isResponsive":
                        this.model.isResponsive = options[option];
                        if(this.model.isResponsive) {
							this._responsiveLayout();
							this._renderTooltip(this.model.tooltipSettings);
						}
						else
							this._removeResponsive();
                        break;
                    case "hide":
                        this._controlVisibleOptions(options[option]);
                        break;
                    case "orientation":
                        this._setOrientation(options[option]);
                        this.model.orientation = options[option];
                        this._wireResizing();
                        break;
					case "tooltipSettings":
					    this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
						this._renderTooltip(this.model.tooltipSettings);
						break;
                    case "enableRTL":
                        this._enableRTL(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "enableSeparator":
                        this.model.enableSeparator = options[option];
                        this._renderToolbarSeparator();
                        break;
                    case "fields":
                        $.extend(this.model.fields, options[option]);
                        break;
                    case "query":
                        this.model.query = options[option];
                        break;
                    case "dataSource":
                        for (var optio in options) {
                            if (optio == "fields") $.extend(this.model.fields, options[optio]);
                            if (optio == "query") this.model.query = options[optio];
                        }
                        this._refreshTagItems(option, options[option]);
                        break;
					case "Items":
					 
					   $.extend(this.model.Items, options[option]);
					   this._refreshTagItems(option, options[option]);
					   break;
					case "targetID":
						this.model.targetID = options[option];
						this._setTargetID();					
						break;
					
                }
            }
        },
		
		_setTargetID: function() {
			this.element.removeAttr('role tabindex aria-disabled style');			
			$(this._spantag).remove();
			$(this._liTemplte).remove();			
			this._liTemplte = this._tipRes = null;		
			this.element.removeClass('e-widget e-box e-toolbarspan e-rtl');
			this.element.find('ul,ol').removeClass('e-ul e-horizontal e-vertical e-separator e-comnrtl');
			this.element.find('li').removeClass('e-tooltxt e-comnrtl');
			this.element.find('li').removeAttr('aria-label');
			this._init();
		},
		
        _refreshTagItems: function (key, value) {
            this.model[key] = value;
            this.element.empty();
            this._generateTemplate();
            this._initialize();
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function () {
            if (this.model.width == "auto") {
                var itemswidth = parseFloat(this.element.css('border-left-width')) + parseFloat(this.element.css('border-right-width')),
                listElement = this.element.find('ul').children('li'), listUl = this.element.find('ul'),resEle;
				if(this.model.responsiveType=="inline")
				 resEle = this.element.find('.e-arrow-sans-down');
				 else
				resEle = this.element.find('.e-toolbar-res-arrow');
				
				for(var i=0, len = listUl.length; i < len; i++) {           // calculate separator width also
                    if (listUl[i] != null && $(listUl[i]).hasClass('e-separator'))
                        itemswidth += parseFloat(listUl.eq(i).css('border-right-width')) + parseFloat(listUl.eq(i).css('border-left-width'));
                }
                if (resEle[0] != null)
				 if(this.model.responsiveType=="inline")
                   itemswidth += Math.round(this.element.find('.e-arrow-sans-down').outerWidth()) + 8; // 8px for position
				 else
				   itemswidth += Math.round(this.element.find('.e-toolbar-res-arrow').outerWidth()) + 8;// 8px for position
                
                for (var i = 0, len = listElement.length; i < len; i++) {
                    if (listElement[i] != null)
                        itemswidth += Math.round(listElement.eq(i).outerWidth());
                }
                this.element.css("width", Math.ceil(itemswidth));
            } else
                this.element.css('width', this.model.width);
        },
        _bindUnbindWidth: function () {
            (this.model.width != "auto") ? this._off($(window), "resize", this._widthHandler) : this._on($(window), "resize", this._widthHandler);
        },
        _widthHandler: function (e) {
            this._setWidth(this.model.width);
        },

        _setOrientation: function (value) {
            if (value != ej.Orientation.Vertical) {
                this.element.removeClass(this.model.cssClass).addClass("e-toolbarspan " + this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-vertical").addClass("e-ul e-horizontal");
            }
            else {
                this.element.removeClass("e-toolbarspan " + this.model.cssClass).addClass(this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-horizontal").addClass("e-ul e-vertical");
            }
            this.items.addClass("e-tooltxt");
			
        },

        _reSizeHandler: function () {
			if (this._isResized && this._liTemplte.children().length > 0) {
                $(this._liTemplte.children()).insertBefore($(this.element).find("span.e-res-pos"));
                this._renderToolbarSeparator();
			  if(this.model.responsiveType!="inline")
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
            }
			this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
            this._liWidth = this._spanWidth;
            this._spantag.removeClass("e-display-block").addClass("e-display-none");
            for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true)+8;
                if (this._liWidth > this._elementWidth) {
                    if (!this._spantag.hasClass("e-display-block"))
                    this._spantag.removeClass("e-display-none").addClass("e-display-block");
                    this._spantag.addClass('e-res-pos');
					this._liTemplte.addClass('e-normal');
                    this._liTemplte.append(this.itemsContainer[i]);
                }
            }
			if(this.model.responsiveType=="inline")
			{
			this._liTemplte.removeClass('e-normal');
            this._liTemplte.css("width",this.element.width());
			}
		    this._isResized = true;
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _btnMouseClick: function (e) {
            var args, btnpos, btnposx, btnposy, poscur = 1, eleWidth = this.element.outerWidth(), eleHeight = this.element.outerHeight(), resWidth = $(this._liTemplte).outerWidth(), winWidth = $(window).width(), winLeft = $(window).scrollLeft();
            if (!$(e.currentTarget).hasClass("e-disable")) {
                /*Context Menu Functionality*///need to write enableRTL
              var maxZ = this._getZindexPartial();
                btnpos = this._getOffset(this.element);
                btnposx = this.model.enableRTL ? btnpos.left : (btnpos.left + eleWidth - resWidth);
                btnposy = btnpos.top + eleHeight - poscur + 2;
                btnposx = btnposx < winLeft ? winLeft + poscur : ((btnposx + resWidth) > (winWidth + winLeft) ? winWidth - resWidth + winLeft - poscur : btnposx);
                if (this._contstatus) {
                    this._liTemplte.addClass("e-display-none");
					if(this.model.responsiveType=="inline")
					   this._spantag.removeClass("e-active");
                    this._contstatus = false;	
                   args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};					
					this._trigger("overflowClose",args);
                  					
                } else {
				   this._liTemplte.removeClass("e-display-none");
                   if(this.model.responsiveType!="inline")
				     this._liTemplte.css({ "top": btnposy + "px", "left": btnposx + "px", "z-index": maxZ });
				   if(this.model.responsiveType=="inline")	
                      this._spantag.addClass("e-active");
                    this._contstatus = true;
					args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};
					this._trigger("overflowOpen",args);
				 if(this.model.responsiveType!="inline")
                    this._on(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                    this.element.bind("click", $.proxy(this._hidecontext, this));
                }
                if ((this._contstatus)&&(this.model.responsiveType!="inline"))
                    this._on($(document), "mouseup", this._documentClick);
					 if(!this._contstatus)
				 this._off($(document), "mouseup", this._documentClick);
                this._removeListHover();
            }
        },

        _hidecontext: function (e) {
            if ((!$(e.target).is($("#" + this.element[0].id + "_target")))&&(this.model.responsiveType!="inline")) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
                this.element.unbind("click", $.proxy(this._hidecontext, this));
                this._off(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is($("#" + this.element[0].id + "_target")) && !($(e.target).closest("div#" + this.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
				var args = { currentTarget: e.currentTarget, clientX: e.clientX, clientY: e.clientY, cancel: e.cancellable };
                this._trigger("overflowClose", args);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
			var tooltipCssClass = "e-toolbarTooltip " + skin; 
			this._subControlsSetModel("cssClass", tooltipCssClass);
        },
		_subControlsSetModel : function (prop, value){
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("option", prop, value);
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("option", prop, value);
		},

        _destroy: function () {
            this.element.html("");
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("destroy");
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            this._cloneElement.removeClass('e-toolbar e-js');
            this.element.replaceWith(this._cloneElement);
            this._liTemplte && this._liTemplte.remove();
            this._unWireResizing();
        },

        _initialize: function () {
            this.element.attr({ "role": "toolbar", "tabindex": "0" });
            var liList = this.element.children().find('li');
            this._focusEnable = true;
            this._renderControl();
            this._responsiveLayout();
            this._wireEvents();
        },
        _responsiveLayout: function () {
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.isResponsive && (this.model.orientation == "horizontal")) {
                if (!ej.isNullOrUndefined(this._liTemplte)) {
                    !ej.isNullOrUndefined(this._tipRes) && this._tipRes.destroy();
                    $(this._liTemplte).remove();
                }
				this._spantag = $("<span id='" + this.element[0].id + "_target' class='e-icon e-toolbar-res-arrow e-rel-position e-display-block' unselectable='on'></span>");
				if(this.model.responsiveType=="inline")
				{
				this._spantag.removeClass("e-toolbar-res-arrow").addClass("e-inlinearrow e-arrow-sans-down");
				}
                this._spantag.appendTo(this.element);
				this._liTemplte = $("<div id='" + this.element[0].id + "_hiddenlist' class='e-responsive-toolbar e-display-none e-abs-position " + $(this.element)[0].className + "'></div>");
                if(this.model.responsiveType=="inline")
                   this._liTemplte.removeClass("e-abs-position").addClass("e-inline");				 
                this._spantag.appendTo(this.element);
                this._spanWidth = this._spantag.outerWidth(true) + 8; // 8px from right of span 
                if (this.model.enableRTL) this._liTemplte.addClass('e-rtl');
                this._isResized = false;
				this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
				this._liWidth = this._spanWidth;
				for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true);
				}
                if (this._liWidth > this._elementWidth)
                this._reSizeHandler();
                else 
				this._spantag.removeClass("e-display-block").addClass("e-display-none");
				if(this.model.responsiveType=="inline")
				  $(this.element[0]).append(this._liTemplte);
				else
                  $('body').append(this._liTemplte);
                this._renderTooltip(this.model.tooltipSettings);
            }
            this._on($("#" + this.element[0].id + "_target"), "mousedown", this._btnMouseClick);
            this._wireResizing();
            this._controlVisibleOptions(this.model.hide);
            this._enableRTL(this.model.enableRTL);
			this._disabledItems = this.model.disabledItemIndices; 
            this._controlStatus(this.model.enabled);
			this.model.disabledItemIndices = this._disabledItems;
            if (this.model.disabledItemIndices.length != 0)
                this._disableItemByIndex(this.model.disabledItemIndices);
            if (this.model.enabledItemIndices.length != 0)
                this._enableItemByIndex(this.model.enabledItemIndices);
            this._setWidth();
        },
        _removeResponsive: function () {
            $(this._spantag).remove();
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            var list = $(this._liTemplte).children('ul');
            $(this._liTemplte).detach();
            $(this.element).append(list);
            this.itemsContainer = this.element.children("ol,ul");
            this.items = this.itemsContainer.children('li');
            this._off(this.items, "mouseup");
            this._off(this.items, "mousedown");
            this._off(this.element, "mousedown");
            this._wireEvents();
            this._wireResizing();
            this._setWidth();
        },

        _controlVisibleOptions: function (value) {
            value != false ? this.hide() : this.show();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                this._liTemplte && this._liTemplte.addClass('e-corner');
            } else {
                this.element.removeClass('e-corner');
                this._liTemplte && this._liTemplte.removeClass('e-corner');
            }
			this._subControlsSetModel("showRoundedCorner", value);
        },

        _generateTemplate: function () {
            var proxy = this, queryPromise;
            this.element.css("visibility", "hidden");
            if (this.model.dataSource instanceof ej.DataManager) {
                queryPromise = this.model.dataSource.executeQuery(this.model.query);
                queryPromise.done(function (e) {
                    proxy._generateGroup(e.result);
                    proxy._initialize();
                    proxy.element.css("visibility", "");
                });
            } else if(this.model.dataSource!=null)
			{ 
			    proxy._generateGroup(proxy.model.dataSource);
                proxy.element.css("visibility", "");
               
            }
			else {
                proxy._generateGroup(proxy.model.Items);
                proxy.element.css("visibility", "");
            }
        },
        _generateGroup: function (value) {
            var proxy = this;
			this._localDataSource=value;
            var y = -1;
            var groupArray = [];
            for (var i = 0; i < value.length; i++) {
                if (this._isNewGroup(value[i][this.model.fields.group], groupArray)) {
                    groupArray[++y] = value[i][this.model.fields.group];
                    var index = -1;
                    proxy.itemsSource = [];
                    for (var x = i; x < value.length; x++) {
                        if (value[i][this.model.fields.group] == value[x][this.model.fields.group]) {
                            proxy.itemsSource[++index] = value[x];
                        }
                    }
                    proxy.element.append(proxy._generateTagitems());
                }
            }

        },
        _isNewGroup: function (value, group) {
            if (!group)
                return true;
            for (var i = 0; i < group.length; i++) {
                if (value == group[i])
                    return false;
            }
            return true;
        },


        _renderControl: function () {
            this.element.addClass("e-widget e-box");
            this._renderToolbarItems();
            this._addAttr(this.model.htmlAttributes);
            this._setOrientation(this.model.orientation);
            this._renderToolbarSeparator();
            this._setHeight(this.model.height);
            this._bindUnbindWidth();
        },

        _renderToolbarItems: function () {
            this.target = this.element[0];
            this.itemsContainer = this.element.children("ol,ul");
            this.itemsContainer.children("ol,ul").remove();
            this.items = this.itemsContainer.children('li');
            for (var i = 0; i < this.items.length; i++) {
                if (ej.isNullOrUndefined($(this.items[i]).attr("title")))
                    $(this.items[i]).attr("aria-label", this.items[i].id);
            }
            this._liCount = this.items.length;
        },

        _generateTagitems: function () {
            var list, i;
            list = this.itemsSource;
            this.ultag = ej.buildTag('ul');
            for (i = 0; i < list.length; i++) {
                this.ultag.append(this._generateLi(list[i]));
            }
            return this.ultag;
        },

        _generateLi: function (toolbarItem) {
            var litag, imgtag, divtag, i;
            litag = ej.buildTag('li');
            if (toolbarItem[this.model.fields.id])
                litag.attr('id', toolbarItem[this.model.fields.id]);
            else 
                (toolbarItem[this.model.fields.text]) && litag.attr('id', toolbarItem[this.model.fields.text]);
            if (toolbarItem[this.model.fields.tooltipText])
                litag.attr('title', toolbarItem[this.model.fields.tooltipText]);
            if ((toolbarItem[this.model.fields.imageUrl]) && (toolbarItem[this.model.fields.imageUrl] != "")) {
                //Creating the image tag
                imgtag = ej.buildTag('img.e-align', '', {}, { 'src': toolbarItem[this.model.fields.imageUrl], 'alt': toolbarItem[this.model.fields.text] });
                if (toolbarItem[this.model.fields.imageAttributes]) this._setAttributes(toolbarItem[this.model.fields.imageAttributes], imgtag);
                litag.append(imgtag);
            }
            if ((toolbarItem[this.model.fields.spriteCssClass]) && (toolbarItem[this.model.fields.spriteCssClass] != "")) {
                //Creating the Sprite image tag
                divtag = ej.buildTag('div.e-align ' + toolbarItem[this.model.fields.spriteCssClass] + ' e-spriteimg');
                litag.append(divtag);
            }
            if ((toolbarItem[this.model.fields.text]) && (toolbarItem[this.model.fields.text] != "")) {
                //Creating text Content inside the  tag
                litag.append(toolbarItem[this.model.fields.text]);
            }
            if (toolbarItem[this.model.fields.htmlAttributes]) this._setAttributes(toolbarItem[this.model.fields.htmlAttributes], litag);
              if(toolbarItem[this.model.fields.template])
			{
			
			divtag=ej.buildTag('div .e-align' ,toolbarItem[this.model.fields.template]);
			litag.append(divtag);
			}
            return litag;
        },


        _setAttributes: function (data, element) {
            for (var key in data) {
                $(element).attr(key, data[key]);
            }
        },

        _renderToolbarSeparator: function () {
            var i, len;
            if (this.model.enableSeparator) {
                for (i = 0, len = this.itemsContainer.length - 1; i < len; i++) {
                    $(this.itemsContainer[i]).addClass("e-separator");
                }
				if (this.itemsContainer.length == 1) {
                        for (i = 0, len = this.itemsContainer[0].children.length; i < len; i++) {
                            if (i == len - 1) $(this.itemsContainer[0].children[i]).removeClass("e-separator");
                            else
                                $(this.itemsContainer[0].children[i]).addClass("e-separator");
                        }
                    }    
            } else {
                this.itemsContainer.removeClass('e-separator').find('.e-separator').removeClass('e-separator');
            }
            this._setWidth();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },


        _enableRTL: function (value) {
            if (value) {
                this.element.addClass('e-rtl');
                this.items.addClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.addClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.addClass('e-rtl');
            } else {
                this.element.removeClass('e-rtl');
                this.items.removeClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.removeClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.removeClass('e-rtl');
            }
            this.model.enableRTL = value;
			this._subControlsSetModel("enableRTL", value);
            this._renderToolbarSeparator();
        },

        _renderTooltip: function (options) {
            var model =$.extend(true, {}, options); 
			if(!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
				model.cssClass = model.cssClass + " e-toolbarTooltip " + this.model.cssClass;
			else 
				model.cssClass = "e-toolbarTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
			model.showRoundedCorner = this.model.showRoundedCorner;
			model.target ="li[data-content], li[title]" ;
			model.beforeOpen = this._showTooltip;
            this._tipToolbar = $(this.target).ejTooltip(model).data("ejTooltip");
			if(this.model.isResponsive && !ej.isNullOrUndefined(this._liTemplte))
				this._tipRes = $(this._liTemplte).ejTooltip(model).data("ejTooltip");
        },
		_showTooltip : function (e){
			var currentItem = $(e.event.currentTarget), targetItem = e.event.target;
			if (currentItem.hasClass("e-disable"))
				e.cancel = true;
		
		},
		_hideTooltip : function (){
			//tap to select the items, mousemove triggered after the tap, so private variable isHided of Tooltip is set as false
			if(!ej.isNullOrUndefined(this._tipToolbar)){ this._tipToolbar.hide(); this._tipToolbar._isHidden= false;}
			if(!ej.isNullOrUndefined(this._tipRes)){ this._tipRes.hide(); this._tipRes._isHidden = false;}
		},
        _addOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                if (!$(element[i]).hasClass('e-disable')) {
                    $(element[i]).addClass('e-disable');
                    var ele = ej.buildTag("div.e-item-overlay");
                    $(element[i]).append(ele);
                }
            }
        },
        _removeOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                $(element[i]).children(".e-item-overlay").remove();
            }
        },



        disableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            if (!current.hasClass("e-disable")) {
                current.attr("aria-disabled", true).removeAttr("aria-label");
                this._addOverlay(current);
            }
            current.removeClass("e-hover e-active").attr("data-aria-selected", false);
        },


        enableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-disable").attr("aria-disabled", false).removeClass('e-disable');
            this._removeOverlay(current);
        },


        disableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.disableItem(lielement);
        },

        enableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.enableItem(lielement);
        },

        _enableItemByIndex: function (indices) {
            var index;
            if (!this.model.enabled) return false;
            if (indices.length != 0) {
                for (var i = 0; i < indices.length; i++) {
                    if ($.inArray(indices[i], this.model.disabledItemIndices) > -1) {
                        index = $.inArray(indices[i], this.model.disabledItemIndices);
                        this.enableItem(this.items[this.model.disabledItemIndices[index]]);
						this.model.disabledItemIndices.splice(index, 1);
                    }

                }
            }
        },

        _disableItemByIndex: function (indices) {
			if (!this.model.enabled) return false;
			this._disabledItems = this.model.disabledItemIndices; 
			for(var i=0; i< indices.length; i++){
				if ($.inArray(indices[i], this.model.disabledItemIndices) < 0)
					this._disabledItems.push(parseInt(indices[i]));
			}
			for (var i = 0; i < this.items.length; i++) {
				if ($.inArray(i, this.model.disabledItemIndices) > -1)
					this.disableItem(this.items[i]);
			}
			this.model.disabledItemIndices = this._disabledItems ;
        },

        disable: function () {
            if (this.element.attr("aria-disabled") == "true") return false;
            this.element.attr("aria-disabled", true).removeAttr("aria-label");
            this._addOverlay(this.items);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.addClass("e-disable");
            this.model.enabled = false;
			this._subControlsSetModel("enabled", false);
        },


        enable: function () {
			this.model.disabledItemIndices = [];
            if (this.element.attr("aria-disabled") == "false") return false;
            this.items.removeClass("e-disable");
            this._removeOverlay(this.items);
            this.element.attr("aria-disabled", false);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.removeClass("e-disable");
            this.model.enabled = true;
			this._subControlsSetModel("enabled", true);
        },


        selectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.addClass("e-active").attr("data-aria-selected", true);
            this._activeItem = $(this.items).index(current);
        },


        deselectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-active").attr("data-aria-selected", false);
        },

        selectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.selectItem(lielement);
        },


        deselectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.deselectItem(lielement);
        },


        removeItem: function (lielement) {
            this.model.disabledItemIndices = [];
            var current = $(lielement);
			var j=0;
            if ((current == null) || (current.length <= 0)) return;
            current.remove();
            this.items = this.itemsContainer.children('li');
			for(var i=0; i< this.items.length ; i++){
				if($(this.items[i]).hasClass("e-disable"))
					this.model.disabledItemIndices [j++] = i;
			}
        },


        removeItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.removeItem(lielement);
        },
        _wireResizing: function () {
            (this.model.isResponsive && (this.model.orientation == "horizontal")) ? $(window).bind('resize', $.proxy(this._reSizeHandler, this)) : this._unWireResizing();
        },

        _unWireResizing: function () {
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },

        _wireEvents: function () {
            this._on(this.element, "mousedown", this._clickEventHandler);
            this._on(this.element, "focus", this._focusElement);
            this._on(this.element, "blur", this._targetBlur);
            this._on(this.items, "mouseenter", this._onItemHover);
            this._on(this.items, "mouseleave", this._onItemLeave);
            this._on(this.items, "mousedown", this._onItemClick);
            this._on(this.items, "mouseup", this._onItemClick);
        },

        _onItemHover: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this.items.removeClass("e-hover");
                currentItem.addClass("e-hover");
               var args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemHover", args);
            }
        },

        _onItemClick: function (e) {
            if ($(e.currentTarget).hasClass('e-disable') || e.which!=1) return false; //e.which for Opera
            var currentItem = e.currentTarget, targetItem = e.target;
			if(!ej.isDevice()) this._hideTooltip();
            if (e.type == "mousedown") {
                this._focusEnable = false;
                $(currentItem).addClass('e-active');
                this._focusedItem = this._currentItem = $(currentItem);
				
            }
            else if (e.type == "mouseup") {
                this._removeSelection();
				 if (!$(currentItem).hasClass("e-disable")) {
                    var args = { currentTarget: currentItem, text: $(currentItem).attr("data-content"), target: targetItem, status: this.model.enabled, event: e };
                    if (this.model.isResponsive && this._contstatus && $(currentItem).closest('.e-responsive-toolbar').length > 0)
                        this._activeItem = this._liTemplte.find('.e-tooltxt').index(currentItem);
                    else
                        this._activeItem = $(this.items).index(currentItem);
                    this._trigger("click", args);
                }
               
            }
        },

        _onItemLeave: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this._removeSelection();
                currentItem.removeClass("e-hover");
               var args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemLeave", args);
            }
        },

        _onKeyPress: function(e) {
            var code, items, active, toFocus;
            code = (e.keyCode) ? e.keyCode : (e.which) ? e.which : e.charCode;
            if (this.model.isResponsive && this._liTemplte.find('.e-tooltxt').length > 0) {
                this._keyPressed = true;
                this._items = (this._contstatus) ? this._liTemplte.find('.e-tooltxt') : this.element.find('.e-tooltxt');
                items = this._items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            } else {
                this._keyPressed = false;
                items = this.items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            }
            if (this._focusedItem) {
                active = this._focusedItem;
                this._focusedItem = null;
            } else
                active = items.filter('.e-hover');
            if(e.type == 'keydown') {
                if(code == 9 && e.shiftKey && $(items[items.index(active) - 1]).length > 0 ){                    
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]);               
                } else if (code == 9 && $(items[items.index(active) + 1]).length > 0) {                    
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]);
                } else if(((code == 38 || code == 39) && this.model.orientation != ej.Orientation.Vertical) || ((code == 39 || code == 40) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]).length > 0 ? $(items[items.index(active) + 1]) : items.first();
                } else if(((code == 37 || code == 40) && this.model.orientation != ej.Orientation.Vertical) || ((code == 37 || code == 38) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]).length > 0 ? $(items[items.index(active) - 1]) : items.last();
                } else if(code == 33 || code == 36) {
                    e.preventDefault();
                    toFocus = items.first();
                } else if(code == 34 || code == 35) {
                    e.preventDefault();
                    toFocus = items.last();
                }
                if(toFocus) {
                    this._removeListHover();
                    toFocus.addClass('e-hover');
                }
            } else {
                switch(code) {
                    case 33: case 34: case 35: case 36: case 37: case 38: case 39: case 40: break;
                    case 13: case 32:
                        e.preventDefault();
                        if (!active[0])
                            break;
                        var args = { currentTarget: active[0], target: $(active)[0], status: this.model.enabled, event: e };
                        this._trigger("click", args);
                        this._removeListHover();
                        break;
                    case 27:
                        e.preventDefault();
                        this.element.blur();
                        break;                    
                }
            }
        },

        _removeListHover: function () {
            $(this.items).removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            if (!activeItem.hasClass('e-disable'))
                activeItem.addClass("e-hover").focus();
        },

        _getActiveItem: function () {
            if (this.model.isResponsive && this._keyPressed)
                return $(this._items[this._activeItem]);
            else
                return $(this.items[this._activeItem]);
        },

        _targetBlur: function (e) {
            e.preventDefault();
            this.element.focusout().removeClass("e-focus");
            this._removeListHover();
            this._off(this.element, "keyup", this._onKeyPress)
                ._off(this.element, "keydown", this._onKeyPress);
            this._trigger("focusOut");
        },

        _clickEventHandler: function (e) {
            this._clicked = true;
        },

        _removeSelection: function() {
            (this._currentItem && this._currentItem.attr("data-aria-selected") != "true") && this._currentItem.removeClass('e-active');
        },

        _focusElement: function (e) {
		    if(!this.element.hasClass("e-focus")){
				this.element.addClass("e-focus");
				this._on(this.element, "keyup", this._onKeyPress)
					._on(this.element, "keydown", this._onKeyPress);
				if (!this._focusEnable) {
					this._focusEnable = true;
					return;
				}
			}
            this._removeListHover();
            this._activeItem = (this._clicked) ? -1 : 0;
            if (this._getActiveItem().hasClass('e-disable') || this._getActiveItem().is(':hidden'))
                this._activeItem = $(this.items).filter('li:not([class*="e-disable"])').first().index();
            this._addListHover();
        },
    });
ej.Toolbar.ResponsiveType = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar itself on clicking the arrow. */
        Inline: "inline"
    };
	
})(jQuery, Syncfusion);


;
/**
* @fileOverview Plugin to style the Html Div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitter", "ej.Splitter", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-splitter",
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            cssClass: "",

            orientation: "horizontal",

            enableAnimation: true,

            properties: [],

            height: null,

            width: null,

            // EnableAutoResize is a deprecated API, we can achieve this requirement by isResponsive property
            enableAutoResize: false,

            isResponsive: false,

            enableRTL: false,
			
			allowKeyboardNavigation: true,

            htmlAttributes: {},

            animationSpeed: 300,

            beforeExpandCollapse: null,

            expandCollapse: null,

            resize: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            cssClass: "string",
            orientation: "enum",
            properties: "data",
            enableAutoResize: "boolean",
            isResponsive: "boolean",
            enableRTL: "boolean",
			allowKeyboardNavigation: "boolean",
            animationSpeed: "number",
            enableAnimation: "boolean",
            htmlAttributes: "data",
        },


        _init: function () {
            this._initialize();
            this._render();
            if (this.model.isResponsive || this.model.enableAutoResize)
                this._wireEvents(true);
            else
                this._wireEvents(false);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "enableAutoResize": this._windowResizing(options[option]); break;
                    case "isResponsive": this._windowResizing(options[option]); break;
                    case "enableRTL": this._rtl(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "orientation": this._refreshSplitter("orientation", options[option]); break;
                    case "properties": this._refreshSplitter("properties", options[option]); break;
                    case "width": this.model.width = options[option]; this._setHeightWidth(); break;
                    case "height": this.model.height = options[option]; this._setHeightWidth(); break;
                }
            }
        },

        refresh: function () {
            this._setPanesSize();
            this._getPanesPercent();
        },

        collapse: function (paneIndex) {
            this._clickArrow(paneIndex, true, true);
        },

        expand: function (paneIndex) {
            this._clickArrow(paneIndex, false, true);
        },

        _clickArrow: function (index, bool, canClick) {
            if (this._inMovement || index < 0 || index > this.panes.length || this.panes.length <= 1) return false;
            var arrow, cls = bool ? "e-collapse" : "e-expand", splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == splitbars.length) arrow = this._clickArrow(index - 1, !bool, false);
            else arrow = $(splitbars[index]).children("." + cls);
            if (canClick) arrow.css("display") != "none" && arrow.mouseup();
            else return arrow;
        },


        addItem: function (content, property, index) {
            var paneCount = this.panes.length;
            index = this._getNumber(index);
			 var totalSize = this.element[this.containerCss]();
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount) return "";
            var property = this._getPaneProperty(property), paneDiv, paneDivSize, requiredSize;
            property = this._checkMinMaxSize(property);
            paneDiv = ej.buildTag("div.e-pane e-" + this.model.orientation.substr(0, 1) + "-pane");
            this.element.append(paneDiv[this.containerCss](property.paneSize));
            paneDivSize = property.paneSize = paneDiv[this.containerCss]();
			 if(paneCount==0) this.panes.push(paneDiv);	
            paneDiv.remove();
            var start = index, end = (paneCount>0)?paneCount:this.panes.length, i, j, insert, before, direction = 2, getters = {}, taken = 0, canInsert = false;
            requiredSize = paneDivSize + this._bar;

            for (j = 0; j < direction; j++) {
                for (i = start; i < end; i++) {
                    var _paneSize = $(this.panes[i])[this.containerCss]();
					 var minSize=(!ej.isNullOrUndefined(this.model.properties[i]))?(this.model.properties[i].minSize): property.minSize;
                    var availableSpace = _paneSize - minSize;
                    if (availableSpace >= requiredSize - taken) {
                        getters[i] = _paneSize - (requiredSize - taken);
                        canInsert = true;
                        break;
                    }
					else if((paneCount==0)&&(availableSpace>=0)){
						  getters[i] = minSize;
                        taken += availableSpace;
						canInsert=true;
					}
                    else if (availableSpace > 0) {
                        getters[i] = minSize;
                        taken += availableSpace;
                    }
                }
                if (canInsert) break;
                else end = start, start = 0;
            }
            if (!canInsert) return "";
            for (var pos in getters)
                $(this.panes[pos])[this.containerCss](getters[pos]);
			if(paneCount<=0) paneDiv.append($(this.panes[index]));
			else{
            if (index == paneCount) {
                insert = "insertBefore", before = 1;
                paneDiv.insertAfter($(this.panes[index - 1]));
            }
            else {
                insert = "insertAfter", before = 0;
                paneDiv.insertBefore($(this.panes[index]));
            }
			 }
            this.model.properties.splice(index, 0, property);
			 if(paneCount==0)this.element.append(paneDiv[this.containerCss](totalSize));			
			 if(paneCount>0){
            this.panes.splice(index, 0, paneDiv);
            var splitBar = this._createSplitBar(index - before);
            splitBar[insert](paneDiv);
			 }
            paneDiv.append(content);
            this._updateModel();
            return paneDiv;
        },


        removeItem: function (index) {
            var paneCount = this.panes.length - 1;
            index = this._getNumber(index);
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount || paneCount < 0) return null;
            var targetPane, nextPane, splitbars, removedSize;
            targetPane = $(this.panes[index]);
            removedSize = targetPane[this.containerCss]() + this._bar;
            targetPane.remove();
            splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == paneCount) {
                nextPane = $(this.panes[index - 1]);
                $(splitbars[index - 1]).remove();
            }
            else {
                nextPane = $(this.panes[index + 1]);
                $(splitbars[index]).remove();
            }
            nextPane[this.containerCss](nextPane[this.containerCss]() + removedSize);
            this._removeArrays(index);
            this._updateModel();
        },
        _checkMinMaxSize: function (property) {
            if ((!ej.isNullOrUndefined(property.minSize))&&(property.paneSize < property.minSize))
                property.paneSize = property.minSize;
            if ((!ej.isNullOrUndefined(property.maxSize))&&(property.paneSize > property.maxSize))
                property.paneSize = property.maxSize;
            return property;
        },

        _removeArrays: function (index) {
            this.model.properties.splice(index, 1);
            this.panes.splice(index, 1);
            this.oldPaneSize.splice(index, 1);
            this.oldPanePercent.splice(index, 1);
            this._sizePercent.splice(index, 1);
        },

        _getNumber: function (value) {
            value = parseFloat(value);
            return isNaN(value) ? null : value;
        },

        _updateModel: function () {
            for (var i = 0; i < this.panes.length; i++)
                this.model.properties[i].paneSize = $(this.panes[i])[this.containerCss]();
            this._getPanesPercent();
        },

        _getPaneProperty: function (property) {
            var _default = { paneSize: 10, minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true };
            return $.extend(_default, property);
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
        },

        _windowResizing: function (boolean) {
            if (boolean) this._wireEvents(boolean);
            else this._unWireEvents();
        },

        _refreshSplitter:function(key,value){
            this._unWireEvents();
            this._refreshDestroy();
            this.model[key] = value;
            this._init();
        },

		_destroy: function() {
			this.element.removeClass("e-splitter");
			this._refreshDestroy();
			this._unWireEvents();
		},

        _refreshDestroy: function () {
            this.element.removeClass("e-widget e-box e-rtl" + this.model.cssClass + " e-" + this.model.orientation);
            this.element.children(".e-splitbar").remove();
            this.element.children(".e-pane").removeClass("e-pane e-" + this.model.orientation.substr(0, 1) + "-pane").height("").width("");
        },

        _initialize: function () {
            this.panes = [];
            this.oldPaneSize = [];
            this.oldPanePercent = [];
            this._initialPropertiesValue = [];
            this._updateHeightWidth = false;
            this.shadowBar = null;
            this._inMovement = false;
            this.containerCss = this.model.orientation == "horizontal" ? "width" : "height";
            this.displayCss = this.model.orientation == "horizontal" ? "left" : "top";
            this.borderCss = this.model.orientation == "horizontal" ? "right" : "bottom";
            this._bar = 9;      // For the center splitbar size
        },

        _render: function () {
            this.element.addClass("e-widget e-box " + this.model.cssClass + " e-" + this.model.orientation).attr("data-role", "splitter");
            var i, j, target = this.element[0];
            for (i = 0, j = 0; i < target.children.length; i++) {
                $(target.children[i]).addClass("e-pane");
                this.panes.push(target.children[i]);
            }
            this._setPanesProperty();
            this._insertSplitBar();
            this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this.element.find(".e-pane").addClass("e-" + this.model.orientation.substr(0, 1) + "-pane");
			if(this.model.isResponsive){
				if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
					this.element.css("height",this.model.height);
				if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
					this.element.css("width",this.model.width );
			}
        },

        _setPanesProperty: function () {
            for (var p = 0; p < this.panes.length; p++) {
                if (this.model.properties[p] != undefined) {
                    this.model.properties[p].paneSize = this.model.properties[p].paneSize == undefined ? "0px" : this.model.properties[p].paneSize;
                    this.model.properties[p].minSize = isNaN(parseFloat(this.model.properties[p].minSize)) ? 10 : parseFloat(this.model.properties[p].minSize);
                    this.model.properties[p].maxSize = isNaN(parseFloat(this.model.properties[p].maxSize)) ? null : parseFloat(this.model.properties[p].maxSize);
                    this.model.properties[p].collapsible = this.model.properties[p].collapsible != false ? true : false;
                    this.model.properties[p].resizable = this.model.properties[p].resizable != false ? true : false;
                    this.model.properties[p].expandable = this.model.properties[p].expandable != false ? true : false;
                }
                else this.model.properties.push({ paneSize: "0px", minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true });
                this._initialPropertiesValue[p] = this.model.properties[p].paneSize;
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value)
            });
        },


        _insertSplitBar: function () {
            if (this.panes.length > 1) {
                var i, splitBar;
                for (i = 0; i < this.panes.length - 1; i++) {
                    splitBar = this._createSplitBar(i);
                    splitBar.insertAfter(this.panes[i]);
                }
            }
        },

        _createSplitBar: function (i) {
            var orient = this.model.orientation.substr(0, 1), arrow1, arrow2, arrow3, splitBar, accessible = false;
            splitBar = ej.buildTag("span.e-box e-splitbar e-split-divider e-" + orient + "-bar").attr("aria-expanded", true);
            ej.browserInfo().name == "msie" && splitBar.addClass("e-pinch");
            arrow1 = ej.buildTag("span.e-icon e-collapse e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-left" :"e-arrow-sans-up"));
            splitBar.append(arrow1);
            arrow3 = ej.buildTag("span.e-activebar e-" + orient + "-arrow ");
            splitBar.append(arrow3);
            arrow2 = ej.buildTag("span.e-icon e-expand e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-right" :"e-arrow-sans-down"));
            splitBar.append(arrow2);
            accessible = true;
            this._on(arrow1, "mouseup", this._collapseArrowClick);
            this._on(arrow2, "mouseup", this._expandArrowClick);
            if (!this.model.properties[i].collapsible)
                arrow1.css("display", "none");
		   if(!this.model.properties[i].expandable)
			   arrow2.css("display", "none");
            if (this.model.properties[i + 1].collapsible)
                arrow2.css("display", "block");
            if (this.model.properties[i].resizable && this.model.properties[i + 1].resizable) {
                splitBar.addClass("e-resize").removeClass("e-icon-hide");
                accessible = true;
                this._on(splitBar, ej.eventType.mouseDown, this._mouseDownOnDivider);
                this._on(arrow3, ej.eventType.mouseDown, this._mouseDownOnDivider);
            }
            if (accessible) {
                splitBar.attr({ "role": "separator", "tabindex": "0" });
                this._on(splitBar, "focus focusout", this._focusOnDivider);
            }
            else splitBar.attr({ "role": "presentation" });
            return splitBar;
        },
        _getPanesPercent: function () {
            this._sizePercent = [];
            var size = this.element[this.containerCss](), outerSize = size - ((this.panes.length - 1) * this._bar), i;
            for (i = 0; i < this.panes.length; i++) {
                if (!$(this.panes[i]).hasClass("collapsed"))
                    this.oldPaneSize[i] = $(this.panes[i])[this.containerCss]();
                this.oldPanePercent[i] = this._convertToPercent(outerSize, this.oldPaneSize[i]);
                this._sizePercent.push(this._convertToPercent(outerSize, $(this.panes[i])[this.containerCss]()));
            }
        },

        _setDimentions: function () {
			var parentObj = this._getParentObj(),_width = parseInt(this.model.width), _height = parseInt(this.model.height);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerWidth(), _width):this.model.width;
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerHeight(), _height):this.model.height;
            if (this.model.height)
                this.element.css("height",_height);
            if (this.model.width)
                this.element.css("width",_width );
        },

        _setHeightWidth: function () {
            this._updateHeightWidth = true;
   		    this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
        },

         _getParentObj: function () {
            return this.element.parent();
        },
        _checkProperties: function () {
            if (this.model.enableRTL) this._rtl(this.model.enableRTL);
            this._prevSize = this.element[this.containerCss]();
        },
        _getExactInnerWidth: function () {
            var browser = ej.browserInfo(), exactInnerWidth;
            if (browser.name == "msie") {
                if (browser.version == 8 || browser.version == 9)
                    exactInnerWidth = $(this.element)[this.containerCss]();
                else
                    exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss]);
            }
            else
                exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss])
                                 - (parseFloat(this.element.css("border-" + this.displayCss + "-width")) +
                                     parseFloat(this.element.css("border-" + this.borderCss + "-width")) +
                                     parseFloat(this.element.css("padding-" + this.displayCss)) +
                                     parseFloat(this.element.css("padding-" + this.borderCss)));
            return exactInnerWidth;
        },

        _rtl: function (boolean) {
            if (boolean) this.element.addClass("e-rtl");
            else this.element.removeClass("e-rtl");
        },

        _setPanesSize: function () {
            var attr = this.containerCss,
            zeroPanes = 0,
            totalPaneSize = 0,
            totalSize = this.element[attr](),
            remainZero = false,
            bar = this._bar=($(this.element).find(">.e-splitbar").length>0)?parseFloat($(this.element).find(">.e-splitbar").css(attr)):this._bar,
            zerothPanes = [],
            panLength, j, paneCount = this.panes.length;

            if (paneCount > 1) {
                for (j = 0; j < paneCount ; j++) {
                    $(this.panes[j]).css(attr, (this._updateHeightWidth == true) ? this._initialPropertiesValue[j] : this.model.properties[j].paneSize);
                    this._updateHeightWidth = false;
                    bar = (j == paneCount - 1) ? 0 : bar;
                    panLength = parseFloat($(this.panes[j])[attr]());
                    if(!ej.isNullOrUndefined(this.model.properties[j].maxSize)) panLength = panLength > this.model.properties[j].maxSize ? this.model.properties[j].maxSize : panLength;
                    $(this.panes[j]).css(attr, panLength);
                    if (panLength <= 0) {
                        zeroPanes++;
                        zerothPanes.push(j);
                        totalPaneSize += bar;
                    }
                    else {
                        if (remainZero) {
                            $(this.panes[j]).css(attr, 0);
                            totalPaneSize += panLength + bar;
                            this.model.properties[j].paneSize = 0;
                        }
                        else {
                            totalPaneSize += panLength + bar;
                            if (totalPaneSize > totalSize) {
                                var currPane = totalPaneSize - totalSize + bar,
                                remainDivider = paneCount - j - 1;
                                currPane += remainDivider * bar;
                                $(this.panes[j]).css(attr, currPane);
                                remainZero = true;
                                totalPaneSize += currPane + bar;
                            }
                            this.model.properties[j].paneSize = panLength;
                        }
                    }
                }
            }
            else if (paneCount == 1) {
                $(this.panes[0]).css(attr, "100%");
                totalPaneSize = totalSize;
            }

            if (paneCount > 1 && totalPaneSize != totalSize) {
			     var remainingSize, lastPane = $(this.panes[paneCount - 1]);
                if (totalPaneSize > totalSize) {
                    remainingSize = totalPaneSize - totalSize;
                    lastPane.css(attr, remainingSize);
                }
                else if (totalPaneSize < totalSize) {
                    remainingSize = totalSize - totalPaneSize;
                    if (zeroPanes > 0) {
                        var z, avgWid = parseFloat(remainingSize / zeroPanes);
                        for (z = 0; z < zeroPanes ; z++) {
                            $(this.panes[zerothPanes[z]]).css(attr, avgWid);
                            this.model.properties[zerothPanes[z]].paneSize = avgWid;
                        }
                    }
                    else {
                        for(var i = paneCount; i > 0; i--){
                            if(ej.isNullOrUndefined(this.model.properties[i - 1].maxSize)){ lastPane = $(this.panes[i - 1]); break;	}
                        }
                        lastPane.css(attr, parseFloat(lastPane[attr]() + remainingSize));
                        this.model.properties[paneCount - 1].paneSize = lastPane[attr]();
                    }
                }
            }
            if (paneCount > 1) this._checkPaneSize();
        },

        _getUnit: function (str) {
            if (str == "px") return "px";
            else if (str == "pt") return "pt";
            else if (str.substr(1) == "%") return "%";
            else return "px";
        },

        _getNormalValue: function (position) {
            var currentLOB, currentLOBPercent, totalValue, currentValue;
            if (this.model.orientation == "vertical") {
                currentLOB = position.y - this.element.offset().top;
                currentLOBPercent = currentLOB / this.element.outerHeight();
                totalValue = this.element.height();
            }
            else {
                currentLOB = position.x - this.element.offset().left;
                currentLOBPercent = currentLOB / this.element.outerWidth();
                totalValue = this.element.width();
            }
            if (currentLOBPercent > 1) {
                currentLOBPercent = 1;
            }
            if (currentLOBPercent < 0) {
                currentLOBPercent = 0;
            }
            currentValue = currentLOBPercent * totalValue;
            return this._trimValue(currentValue);
        },

        _trimValue: function (value) {
            var step, stepModValue, correctedValue;
            step = 1;
            stepModValue = (value) % step;
            correctedValue = value - stepModValue;
            if (Math.abs(stepModValue) * 2 >= step)
                correctedValue += (stepModValue > 0) ? step : (-step);
            return parseFloat(correctedValue.toFixed(5));
        },

        _getSplitbarIndex: function () {
            return this.element.children(".e-splitbar:not(.e-shadowbar)").index(this.currentSplitBar);
        },

        _paneResize: function () {
            if (this.shadowBar == null) return false;
            this.currentSplitBar = this.shadowBar.next();
            var newPosition, prevPane, nextPane, prevPaneIndex, nextPaneIndex, index = this._getSplitbarIndex();
            prevPane = this.shadowBar.prev(), nextPane = this.currentSplitBar.next();
            prevPaneIndex = index, nextPaneIndex = index + 1;
            newPosition = this.shadowBar.offset()[this.displayCss];
            newPosition = newPosition - this.currentSplitBar.offset()[this.displayCss];
            $(prevPane).css(this.containerCss, newPosition + $(prevPane)[this.containerCss]() + "px");
            $(nextPane).css(this.containerCss, $(nextPane)[this.containerCss]() - newPosition + "px");
            this.oldPaneSize[prevPaneIndex] = $(prevPane)[this.containerCss]();
            this.oldPaneSize[nextPaneIndex] = $(nextPane)[this.containerCss]();
            this.shadowBar.remove();
            this._checkPaneSize();
            var prevObj = { item: prevPane, index: prevPaneIndex, size: this.oldPaneSize[prevPaneIndex] };
            var nextObj = { item: nextPane, index: nextPaneIndex, size: this.oldPaneSize[nextPaneIndex] };
            this._updateModelValue(prevObj, nextObj);
            this._trigger("resize", {
                prevPane: prevObj,
                nextPane: nextObj,
                splitbarIndex: index
            });
        },

        _checkPaneSize: function () {
            var total = 0, len, i, splitterLen, paneCount = this.panes.length;
            for (i = 0; i < paneCount; i++) {
                len = this.containerCss=='width' ? $(this.panes[i])['outerWidth']() :$(this.panes[i])['outerHeight']();
                total += len + this._bar;
            }
            total -= this._bar;
            splitterLen = this._getExactInnerWidth();
            if (total != splitterLen) {
                var remain = splitterLen - total;
                var last = $(this.panes[paneCount - 1])[this.containerCss]();
                if (last == 0) {
                    for (i = paneCount - 1; i >= 0; i--) {
                        if ($(this.panes[i]).hasClass("expanded") && !$(this.panes[i]).hasClass("collapsed")) {
                            last = $(this.panes[i])[this.containerCss]();
                            $(this.panes[i]).css(this.containerCss, parseFloat(last + remain));
                            break;
                        }
                    }
                }
                else
                    $(this.panes[paneCount - 1]).css(this.containerCss, parseFloat(last + remain));
            }
        },

        _maxminDraggableRange: function (shadowbarPos) {
            var prevPane, nextPane, prevPaneSize, nextPaneSize, splitbarPosition, prevPaneRange, nextPaneRange,
                prevPaneIndex, nextPaneIndex, PaneMax1, PaneMax2, PaneMin1, PaneMin2, index;
            prevPane = this.shadowBar.prev();
            this.currentSplitBar = this.shadowBar.next();
            nextPane = this.currentSplitBar.next();
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            splitbarPosition = this.displayCss == "left" ? this.currentSplitBar[0].offsetLeft : this.currentSplitBar[0].offsetTop;
            prevPaneRange = splitbarPosition - prevPaneSize;
            nextPaneRange = nextPaneSize + splitbarPosition;
            index = this._getSplitbarIndex();
            prevPaneIndex = index;
            nextPaneIndex = index + 1;
            PaneMax1 = this.model.properties[prevPaneIndex].maxSize;
            PaneMax2 = this.model.properties[nextPaneIndex].maxSize;
            PaneMax1 = PaneMax1 != null ? parseInt(PaneMax1, 10) : null;
            PaneMax2 = PaneMax2 != null ? parseInt(PaneMax2, 10) : null;
            this.model.properties[prevPaneIndex].minSize = parseInt(this.model.properties[prevPaneIndex].minSize, 10);
            this.model.properties[nextPaneIndex].minSize = parseInt(this.model.properties[nextPaneIndex].minSize, 10);
            PaneMin1 = this.model.properties[prevPaneIndex].minSize;
            PaneMin2 = this.model.properties[nextPaneIndex].minSize;
            this.shadowBar.removeClass("e-end-indicaton");
            if (shadowbarPos > nextPaneRange - PaneMin2) {
                this.resizedPosition = nextPaneRange - PaneMin2;
                this.shadowBar.addClass("e-end-indicaton");
            }
            else if (shadowbarPos < prevPaneRange + PaneMin1) {
                this.resizedPosition = prevPaneRange + PaneMin1;
                this.shadowBar.addClass("e-end-indicaton");
            }
            if (PaneMax1 != null) {
                if (shadowbarPos > prevPaneRange + PaneMax1) {
                    this.resizedPosition = prevPaneRange + PaneMax1;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
            else if (PaneMax2 != null) {
                if (shadowbarPos < nextPaneRange - PaneMax2) {
                    this.resizedPosition = nextPaneRange - PaneMax2;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
        },

        _collapseArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };
            expanded = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!nextPane.hasClass("collapsed")) {
                this.oldPaneSize[prevPaneIndex] = prevPaneSize;
                prevPane.addClass("collapsed");
                nextPane.addClass("expanded");
                this.currentSplitBar.attr("aria-expanded", false);
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[nextPaneIndex].collapsible)
                     $($target.siblings()).not('.e-activebar').css("display", "block");
                if (prevPaneIndex != 0) {
                    var preBar = prevPane.prev();
                    preBar.find(".e-expand").css("display", "none");
                    if (!this.model.properties[prevPaneIndex - 1].collapsible && $(prevPane.prev().prev()[0]).hasClass("expanded"))
                        preBar.find(".e-collapse").css("display", "block");
                    preBar.removeClass("e-resize").addClass("e-icon-hide");
                }
                properties[this.containerCss] = 0;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (prevPaneSize < this.oldPaneSize[nextPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("expanded");
                    nextPane.removeClass("collapsed");
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                    $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[prevPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (nextPaneIndex != paneCount - 1) {
                        var nextBar = nextPane.next();
                        if (!this.model.properties[nextPaneIndex + 1].collapsible)
                            nextBar.find(".e-expand").css("display", "none");
                        nextBar.find(".e-collapse").css("display", "block");
                        if (!nextBar.next().hasClass("collapsed")) {
                            nextBar.addClass("e-resize").removeClass("e-icon-hide");
                            nextBar.attr("aria-expanded", true);
                        }
                    }

                    properties[this.containerCss] = this.oldPaneSize[nextPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = prevPaneSize - this.oldPaneSize[nextPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _expandArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            expanded = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };

            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!prevPane.hasClass("collapsed")) {
                this.oldPaneSize[nextPaneIndex] = nextPaneSize;
                prevPane.addClass("expanded");
                nextPane.addClass("collapsed");
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[prevPaneIndex].collapsible)
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                if (nextPaneIndex != paneCount - 1) {
                    var nextBar = nextPane.next();
                    nextBar.find(".e-collapse").css("display", "none");
                    if (!this.model.properties[nextPaneIndex + 1].collapsible && $(nextPane.next().next()[0]).hasClass("collapsed"))
                        nextBar.find(".e-expand").css("display", "block");
                    nextBar.removeClass("e-resize").addClass("e-icon-hide");
                    nextBar.attr("aria-expanded", false);
                }
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = 0;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (nextPaneSize < this.oldPaneSize[prevPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("collapsed");
                    nextPane.removeClass("expanded");
                    this.currentSplitBar.attr("aria-expanded", true);
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[nextPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (prevPaneIndex != 0) {
                        var preBar = prevPane.prev();
                        if (!this.model.properties[currBarNo - 1].collapsible)
                            preBar.find(".e-collapse").css("display", "none");
                        preBar.find(".e-expand").css("display", "block");
                        if (!preBar.prev().hasClass("collapsed")) preBar.addClass("e-resize").removeClass("e-icon-hide");
                    }

                    properties[this.containerCss] = this.oldPaneSize[prevPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = nextPaneSize - this.oldPaneSize[prevPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _raiseEvent: function (evtName, collapsed, expanded, index) {
            if (evtName == "expandCollapse") {
                this._inMovement = false;
                this._updateModelValue(collapsed, expanded);
            }
            return this._trigger(evtName, {
                collapsed: collapsed,
                expanded: expanded,
                splitbarIndex: index
            });

        },

        _updateModelValue: function (collapsed, expanded) {
            this.model.properties[collapsed.index].paneSize = collapsed.item[this.containerCss]();
            this.model.properties[expanded.index].paneSize = expanded.item[this.containerCss]();
            this._getPanesPercent();
        },

        _mouseUpOnArrow: function (event) {
            this.element.find(".e-end-indicaton").removeClass("e-end-indicaton");
            $(document).off("mouseup", $.proxy(this._mouseUpOnArrow, this));
        },

        _keydownOnDivider: function (e) {
            var key = e.keyCode;
            if (key == 37 || key == 38 || key == 39 || key == 40) {
                e.preventDefault();
                var oriTarget = $(e.data.target);
                if (e.ctrlKey) {
                    if (this.shadowBar == null) {
                        this.currentSplitBar = oriTarget;
                        var index = this._getSplitbarIndex();
                        if (this.model.orientation == "vertical") {
                            if (e.keyCode == 38) this.collapse(index);
                            else if (e.keyCode == 40) this.expand(index);
                        }
                        else {
                            if (e.keyCode == 37) this.collapse(index);
                            else if (e.keyCode == 39) this.expand(index);
                        }
                    }
                }
                else if (oriTarget.hasClass("e-resize")) {
                    var target = (this.shadowBar != null) ? this.shadowBar : oriTarget;
                    var offset = target.offset(), location = { pageX: offset.left, pageY: offset.top };
                    $.extend(true, e, location);
                    if ((this.model.orientation == "vertical" && (e.keyCode == 38 || e.keyCode == 40)) ||
                        (this.model.orientation == "horizontal" && (e.keyCode == 37 || e.keyCode == 39))) {
                        if (e.keyCode == 38) e.pageY -= 5;
                        else if (e.keyCode == 40) e.pageY += 5;
                        else if (e.keyCode == 37) e.pageX -= 5;
                        else if (e.keyCode == 39) e.pageX += 5;
                        this._mouseMoveOnDivider(e);
                    }
                }
            }
            else if (key == 13) {
                e.preventDefault();
                this._mouseUpOnDivider();
            }
            else if (key == 27) {
                e.preventDefault();
                if (this.shadowBar != null) this.shadowBar.remove();
                this.shadowBar = null;
                this._mouseUpOnDivider();
                this.element.children(".e-splitbar.e-hover").focusout();
            }
        },

        _focusOnDivider: function (e) {
            if (e.type == "focus") {
                if (!$(e.target).hasClass("e-hover")) {
                    $(e.target).addClass("e-hover");
                    if (this.model.allowKeyboardNavigation)
                        $(document).on("keydown", { target: e.target }, $.proxy(this._keydownOnDivider, this));
                }
            }
            else {
                this.element.children(".e-splitbar.e-hover").removeClass("e-hover");
                this._mouseUpOnDivider();
                $(document).off("keydown", $.proxy(this._keydownOnDivider, this));
            }
        },

        _mouseDownOnDivider: function (event) {
            event.preventDefault();
            var $target;
            ($(event.target).hasClass("e-activebar")) ? $target=$(event.target.parentElement) : $target=$(event.target);
            if ($target.hasClass("e-splitbar") && $target.hasClass("e-resize")) {
                this._overlayElement = ej.buildTag('div.e-pane-overlay');
                if (!$target.hasClass("e-hover")) $target.focus();
                this.element.find(".e-pane").not(".e-splitter").append(this._overlayElement);
                $(document).on(ej.eventType.mouseMove, { target: ($(event.target).hasClass("e-activebar")) ? event.target.parentElement : event.target }, $.proxy(this._mouseMoveOnDivider, this));
                $(document).on(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
                $(document).on("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            }
            else if ($target.hasClass("e-expand") || $target.hasClass("e-collapse")) {
                $target.parent().focus();
            }
        },

        _mouseMoveOnDivider: function (event) {
            var _data = event.data;
            event = event.type == "touchmove" ? event.originalEvent.changedTouches[0] : event;
            var position = { x: event.pageX, y: event.pageY };
            this.resizedPosition = this._getNormalValue(position);
            if (this.shadowBar == null) {
                var target;
                ($(_data.target).hasClass('e-activebar')) ? target=$(_data.target.parentElement) : target=$(_data.target);
                this.shadowBar = target.clone().addClass("e-shadowbar").removeClass("e-hover").removeClass("e-split-divider").insertBefore(target);
                this.shadowBar.children().remove();
            }
            this._maxminDraggableRange(this.resizedPosition);
            this.shadowBar.css(this.displayCss, this.resizedPosition);
        },

        _mouseUpOnDivider: function (event) {
            this._paneResize();
            this.element.find(".e-pane").not(".e-splitter").find(".e-pane-overlay").remove();
            $(document).off(ej.eventType.mouseMove, $.proxy(this._mouseMoveOnDivider, this));
            $(document).off(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
            $(document).off("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            // sets shadowBar null after removing shadowBar element
            this.shadowBar = null;
        },

        _windowResized: function (event) {
            var size = this._getExactInnerWidth();
            if (this._prevSize == size) return false;
            var paneCount = this.panes.length, outerSize = size - ((paneCount - 1) * this._bar), i, val;
            this._prevSize = size;
            for (i = 0; i < paneCount; i++) {
                val = this._convertToPixel(outerSize, this._sizePercent[i]);
                $(this.panes[i]).css(this.containerCss, val + "px");
            }
            for (i = 0; i < this.oldPaneSize.length; i++)
                this.oldPaneSize[i] = this._convertToPixel(outerSize, this.oldPanePercent[i]);
            this._checkPaneSize();
        },

        _convertToPercent: function (outer, pane) {
            return (pane * 100) / outer;
        },
        _convertToPixel: function (tot, percent) {
            return parseFloat((tot * percent) / 100);
        },

        _wireEvents: function (boolean) {
            if (boolean) $(window).on('resize', $.proxy(this._windowResized, this));
        },

        _unWireEvents: function () {
            $(window).off('resize', $.proxy(this._windowResized, this));
        }
    });

})(jQuery, Syncfusion);;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Print = (function (_super) {
    __extends(Print, _super);
    function Print(element, options) {
        _super.call(this);
        this._rootCSS = "e-print";
        this.PluginName = "ejPrint";
        this.id = "null";
        this.defaults = {
            globalStyles: true,
            externalStyles: null,
            excludeSelector: null,
            append: null,
            printInNewWindow: false,
            prepend: null,
            timeOutPeriod: 1000,
            title: null,
            height: 454,
            width: 1024,
            docType: "<!doctype html>",
            beforeStart: null
        };
        if (element) {
            if (!element.jquery) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejPrint(options).data(this.PluginName);
            }
        }
    }
    Print.prototype._init = function () {
        this.id = this.element[0].id;
        this._initialize(this.element, undefined);
    };
    Print.prototype._initialize = function (element, bool) {
        this.styles = $("");
        this.title = $("title");
        if (this.model.globalStyles) {
            this._addglobalStyles(this.model.globalStyles);
        }
        if (this.model.externalStyles) {
            this._addStylesToElement(this.model.externalStyles);
        }
        if (this.model.title) {
            this._addTitleToElement(this.model.title);
        }
        var htmlTag = $("<html/>");
        var headTag = $("<head/>").append(this.title);
        headTag.append(this.styles.clone());
        var bodyTag = $("<body/>");
        var innercontent = $("<div/>");
        if (bool) {
            if (typeof element === "string") {
                element = $(element);
                innercontent.append(element.clone());
            }
            else if (typeof element === "object") {
                for (var i = 0; i < element.length; i++) {
                    innercontent.append($(element[i]).clone());
                }
            }
        }
        else {
            innercontent.append(element.clone());
        }
        this.copy = innercontent;
        bodyTag.append(this.copy);
        if (this.model.append) {
            bodyTag.append(this._getjQueryObject(this.model.append));
        }
        if (this.model.prepend) {
            bodyTag.prepend(this._getjQueryObject(this.model.prepend));
        }
        this.copy = htmlTag.append(headTag).append(bodyTag);
        if (this.model.excludeSelector != null) {
            this._removeContentFromPrint(this.model.excludeSelector);
        }
        var content = this.copy;
        this.copy.remove();
        if (bool === undefined) {
            this._printContent(content, null, false);
            return true;
        }
        return content;
    };
    Print.prototype._getjQueryObject = function (element) {
        var value = $(element).clone().length === 0 ? $("<div />").html(element) : $(element).clone();
        return value;
    };
    Print.prototype._addglobalStyles = function (element) {
        if (this.model.globalStyles) {
            this.styles = $("style, link, meta, title");
        }
    };
    Print.prototype._addStylesToElement = function (element) {
        if (this.model.externalStyles) {
            var substr = $.isArray(element) ? element : element.split(",");
            for (var i = 0; i < substr.length; i++) {
                var link = $("<link rel='stylesheet' href='" + substr[i] + "'>");
                this.styles = $.merge(this.styles, link);
            }
        }
    };
    Print.prototype._addTitleToElement = function (element) {
        if (this.model.title) {
            if (this.title.length === 0) {
                this.title = $("<title />");
            }
            this.title.text(this.model.title);
        }
    };
    Print.prototype._removeContentFromPrint = function (element) {
        if (this.model.excludeSelector) {
            var substr = $.isArray(element) ? element : element.split(",");
            for (var i = 0; i < substr.length; i++) {
                this.copy.find(substr[i]).remove();
            }
        }
    };
    Print.prototype._printContent = function (element, printWin, bool) {
        var _this = this;
        var printWindow;
        if (bool) {
            var content = [];
            if (this.element.attr("id") !== undefined) {
                content.push("#" + this.element.attr("id"));
            }
            else {
                content.push("." + this.element.attr("class").replace(/ /g, "."));
            }
            if (element !== undefined) {
                if ($.isArray(element)) {
                    for (var i = 0; i < element.length; i++) {
                        content.push(element[i]);
                    }
                }
                else {
                    content.push(element);
                }
            }
            element = this._initialize(content, true);
        }
        this._trigger("beforeStart", { content: element });
        if (!printWin) {
            if (this.model.printInNewWindow) {
                printWindow = window.open();
            }
            else {
                printWindow = window.open(" ", "print", "height=" + this.model.height + ",width=" + this.model.width + ",tabbar=no");
            }
        }
        printWindow.document.write(this.model.docType);
        printWindow.document.write((element[0].outerHTML));
        printWindow.document.close();
        printWindow.focus();
        setTimeout(function () {
            if (!ej.isNullOrUndefined(printWindow.window)) {
                printWindow.print();
                setTimeout(function () { printWindow.close(); }, _this.model.timeOutPeriod);
            }
        }, this.model.timeOutPeriod);
    };
    Print.prototype.print = function (element, printWin) {
        this._printContent(element, printWin, true);
    };
    return Print;
}(ej.WidgetBase));
window.ej.widget("ejPrint", "ej.Print", new Print());
;
/**
* @fileOverview Plugin to style the tab control.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejTab", "ej.Tab", {
        _rootCSS: "e-tab",

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["selectedItemIndex"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            collapsible: false,

            enableAnimation: true,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            disabledItemIndex: [],

            enabledItemIndex: [],

            hiddenItemIndex: [],

            events: "click",

            idPrefix: "ej-tab-",

            heightAdjustMode: "content",

            selectedItemIndex: 0,

            cssClass: "",

            showCloseButton: false,

            htmlAttributes: {},

            enableTabScroll: false,

            showReloadIcon: false,

            headerPosition: "top",

            width: null,

            height: null,

            headerSize: null,

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            ajaxLoad: null,

            ajaxBeforeLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            itemActive: null,

            beforeActive: null,

            itemAdd: null,

            itemRemove: null,

            beforeItemRemove: null,

            create: null,

            destroy: null

        },
        dataTypes: {
            cssClass: "string",
            collapsible: "boolean",
            events: "string",
            heightAdjustMode: "enum",
            enabled: "boolean",
            ajaxSettings: "data",
            disabledItemIndex: "data",
            enabledItemIndex: "data",
            enableAnimation: "boolean",
            htmlAttributes: "data"
        },
        observables: ["selectedItemIndex"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),


        _destroy: function () {
            this._unWireEvents();
            this._removeBaseClass();
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "events": {
                        this._off(this.items, this.model.events);
                        this._on(this.items, options[key], this._tabItemClick);
                        break;
                    }
                    case "disabledItemIndex": {
                        this._disableItems(options[key]);
                        options[key] = this.model.disabledItemIndex;
                        break;
                    }
                    case "enabledItemIndex": this._enableItems(options[key]); break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "selectedItemIndex": {
                        this._isInteraction = false;
                        this.showItem(ej.util.getVal(options[key]));
                        options[key] = this.model.selectedItemIndex;
                        break;
                    }
                    case "heightAdjustMode": {
                        this.model.heightAdjustMode = options[key];
                        this._setTabsHeightStyle(options[key]);
                        this._resizeEvents(options[key]);
                        break;
                    }
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this._roundedCorner(options[key]); break;
                    case "height": {
                        this.model.height = options[key];
                        this._setTabsHeightStyle(this.model.heightAdjustMode);
                        break;
                    }
                    case "width": this.element.width(options[key]);
                        $(this.contentPanels).width(Number(options[key]));
                        this.refreshTabScroll();
                        break;
                    case "headerSize": this._setHeaderSize(options[key]); break;
                    case "allowKeyboardNavigation": {
                        if (options[key])
                            this._on(this.element, 'keydown', this._keyPress);
                        else
                            this._off(this.element, "keydown");
                        break;
                    }
                    case "headerPosition":
                        {
                            this.model.headerPosition = options[key];
                            if (this.model.headerPosition == ej.Tab.Position.Top) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.itemsContainer.remove();
                                this.itemsContainer.insertBefore(this.element.find(">div").first());
                                this.element.find("div.e-active-content").removeClass("e-activebottom");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Bottom) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.element.find("div.e-active-content").removeClass("e-activetop");
                                this.model.enableTabScroll ? $(this.contentPanels).css("margin-top", "0") : $(this.contentPanels).css("position", "relative")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._removeHeaderClass();
                                $(this.items).css('display', '');
                                this._removeScroll();

                            }
                            this._refresh();
                            if (this.model.headerPosition == ej.Tab.Position.Right)
                                this.element.css("position", "")
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                
                            }

                            this.scrollstep = 30
                            break;
                        }
                    case "showCloseButton":
                        {
                            if (options[key]) {
                                this._addDeleteIcon();
                                this._on(this.element.find("div.e-close"), "click", this._tabDeleteClick);
                            } else
                                this.element.find("div.e-close").remove();
                            break;
                        }
                    case "enableTabScroll":
                        {
                            this.model.enableTabScroll = options[key];
                            if (options[key]) {
                                this._removeScroll();
                                this._addScroll();
                                if (this.model.headerPosition == "left") {
                                    this._refresh();
                                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                }
                            } else {
                                this._removeScroll();
                                this.itemsContainer.removeAttr("style");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._refresh();
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                if (this.model.headerPosition == ej.Tab.Position.Right && !this.model.enableTabScroll)
                                    this.element.css("margin-left", "")
                            }
                            break;
                        }
                    case "showReloadIcon":
                        {
                            if (options[key]) {
                                this._addReloadIcon();
                            } else
                                this.element.find("div.e-reload").remove();
                            break;
                        }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            this._removeScroll();
                            this.itemsContainer.removeAttr("style");
                            $(this.contentPanels).css("margin-top", "0")
                            this.element.find("ul").removeAttr("style")
                            options[key] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                            if (this.model.enableTabScroll)
                                this._addScroll();
                            this._refresh();
                            this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                            if (this.model.headerPosition == ej.Tab.Position.Right && this.model.enableRTL)
                                this.element.css("margin-left", '')

                            break;
                        }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                    case "hiddenItemIndex": {
                        if (this.model.headerPosition == ej.Tab.Position.Top || this.model.headerPosition == ej.Tab.Position.Bottom)
                            $(this.items).css('display', 'inline-block');
                        else $(this.items).css('display', '');
                        this.model.hiddenItemIndex = options[key];
                        this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
                        break;
                    }
                }
            }
        },

        _removeScroll: function () {
            this.itemsContainer.removeAttr("style");
            this.element.find("div.e-chevron-circle-right").remove();
            this.element.find("div.e-chevron-circle-left").remove();
        },

        _addScroll: function () {
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                this._checkScroll();
            this._addScrollIcon();
            this.refreshTabScroll();
        },

        _init: function () {
            this._addItemIndex = null;
            this.tabId = 0;
            this._hiddenIndex = this.model.hiddenItemIndex;
            this._initialize();
            this._prevSize = this._getDimension($(this.element).parent(), "height");
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _tabContentsWidth: function () {
            var length = this.element.find("li").length;
            var tabLength = 0;
            for (var i = 0; i < length; i++) {
                tabLength = tabLength + $(this.element.find("li")[i]).width();
            }
            return tabLength
        },

        _tabContentsHeight: function () {
            var length = this.element.find("li").length;
            var tabHeight = 0;
            for (var i = 0; i < length; i++) {
                tabHeight = tabHeight + $(this.element.find("li")[i]).height();
            }
            return tabHeight
        },

        _initialize: function () {
            this.initialRender = true;
            this.element.attr("tabindex", 0).attr("role", "tablist");
            this._itemsRefreshing();
            $(this.anchors).addClass("e-link");
            this._preTabSelectedIndex = this._preTabIndex = -1;
            if (!ej.isNullOrUndefined(this.model.width))
                this.element.width(this.model.width);
            if (!ej.isNullOrUndefined(this.model.height))
                this.element.height(this.model.height);
            this._setTabPosition(this.model.headerPosition);
            if (this.model.showCloseButton)
                this._addDeleteIcon();
            if (this.model.showReloadIcon)
                this._addReloadIcon();
            if (this.model.showRoundedCorner)
                this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            this.contentPanels = [];
            this._addAttr(this.model.htmlAttributes);
            this._reinitialize();
            this._addBaseClass();
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            this._disableTabs();
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableTabScroll) {
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (this.itemsContainer.width() > (this.element.width()))
                        this._addScrollIcon();
                }
                else {
                    if (this.element.height() < (this.items.height() * this.items.length))
                        this._addScrollIcon();
                }
            }
            this._wireEvents(this.model.events);
            // Added for rendering the Windows tab...
            this.showItem(this.selectedItemIndex());
            this._setTabsHeightStyle(this.model.heightAdjustMode);
            this._enabledAction(this.model.enabled);
            this._resizeEvents(this.model.heightAdjustMode);
			if(this.selectedItemIndex() > -1 && this.contentPanels != 0 && this.model.enableRTL)		
				$(this.element).height(this.itemsContainer.height()+parseInt($(this.contentPanels).css("height")));        
            this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
        },

        _reinitialize: function ( addContentBaseClass ) {
            var hid, href, hrefBase;
            for (var i = (this._addItemIndex != null) ? this._addItemIndex : 0; i < this.anchors.length; i++) {
                hid = this.anchors[i];
                if (this.divId == undefined)
                    href = $(hid).attr("href");
                else
                    href = this.divId;
                this.divId = undefined;
                hrefBase = href.split("#")[0];
                if (hrefBase && (hrefBase === location.toString().split("#")[0])) {
                    href = a.hash;
                    hid.href = href;
                }
                if (href && href !== "#") {
                    this._addContentTag(href, i);
                    if(addContentBaseClass) this._addContentBaseClass($(this.contentPanels[i]));
                }
                else if (!this.model.enablePersistence) {
                    this.model.disabledItemIndex.push(i);
                }
                if (this._addItemIndex != null) {
                    this._unWireEvents();
                    this._wireEvents(this.model.events);
				if (this.items.length == 1) {
					this.showItem(this.selectedItemIndex());
				}
                    break;
                }
            }

        },
        _itemsRefreshing: function () {
            this.itemsContainer = this.element.find("ol,ul").eq(0);
            this.items = this.itemsContainer.find(" > li:has(a[href])");
            this.anchors = this.items.find('a[href]');
        },
        _setHeaderSize: function (size) {
            this.element.find(">ul li.e-item").css("height", "auto");
            this.element.find(">ul li.e-item").children("a.e-link").css("margin-top", "0px");
            if (this.model.headerPosition == "left") {
                this.element.find(">ul.e-left").css({ "width": size, "text-align": "center" });
            }
            else if (this.model.headerPosition == "right") {
                this.element.find(">ul.e-right").css({ "width": size, "text-align": "center" });
            }
            else {
                this.element.find(">ul.e-header li.e-item").css("height", size);
                this.element.find(">ul.e-header li.e-item a.e-link").css("margin-top", ((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item a.e-link").outerHeight()).toString() + "px");
				this.element.find(">ul.e-header li.e-item .e-icon.e-tabdelete").css("margin-top", (((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item .e-icon.e-tabdelete").outerHeight())-5).toString() + "px");
				this.element.find(">ul.e-header li.e-item .e-icon.e-reload").css("margin-top", (((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item .e-icon.e-reload").outerHeight())-5).toString() + "px");
            }
        },
        _enabledAction: function (flag) {
            if (flag) {
                this.element.removeClass("e-disable");
            }
            else {
                this.element.addClass("e-disable");
            }
        },
        _hiddenIndexItem: function (value) {
            var elementId;
            for (var i = 0; i < value.length; i++) {
                if (!$.inArray(parseInt(value[i]), this._hiddenIndex) > -1) {
                    elementId = $(this.items[parseInt(value[i])]).children('a').attr('href');
                    this._hidePanel(elementId);
                }
            }
            this._hideContentPanel(this.selectedItemIndex(), this.model.hiddenItemIndex);
            this._hiddenIndex = this.model.hiddenItemIndex;
        },
        _hidePanel: function (value) {
            for (var j = 0; j < this.contentPanels.length; j++) {
                if ("#" + $(this.contentPanels[j]).attr('id') == value) {
                    $(this.contentPanels[j]).css('display', 'none');
                    break;
                }
            }
            for (var i = 0; i < this.items.length; i++) {
                if ($(this.items.children('a')[i]).attr('href') == value) {
                    $(this.items[i]).css('display', 'none');
                    break;
                }
            }
        },
        _hideContentPanel: function (index, value) {
            if ($.inArray(index, value) > -1) {
                index += 1;
                if (index <= this.items.length - 1) {
                    this._hideContentPanel(index, value);
                }
                else if (index > this.items.length - 1 && value.length != this.items.length) {
                    this._hideContentPanel(0, value);
                }
            }
            else this.showItem(index);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else proxy.element.attr(key, value)
            });
        },


        _setTabPosition: function (position) {
            if (position == ej.Tab.Position.Bottom) {
                this.itemsContainer.appendTo(this.element);
                this.items.removeClass("e-bottom-line");
                this.items.addClass("e-top-line");
            }
            else if (position == ej.Tab.Position.Top) {
                this.items.removeClass("e-top-line");
				this.itemsContainer.prependTo(this.element);
                if (this.model.enableRTL)
                    this.items.addClass("e-rtl-top-line e-top-hover");
                else
                    this.items.addClass("e-bottom-line");
            }
            else if (position == ej.Tab.Position.Left || position == ej.Tab.Position.Right) {
                if (this.items.length >= 0) {
                    if (this.model.height)
                        this.itemsContainer.css("height", this.model.height);
                    else {
                        if (!this.model.heightAdjustMode === "fill") $(this.itemsContainer).css("height", "");
                    }
                    this.element.addClass("e-vertical");
                }
            }
        },


        _addDeleteIcon: function () {
            if (this.element.find("div.e-close.e-tabdelete").length <= 0 && this.items.length > 0) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var delIconPosition = this.items.find("a");
                    deleteIcon.insertBefore(delIconPosition);
                }
                else
                    this.items.append(deleteIcon);
            }
        },
        _tabScrollIconCalc: function(){
            this.padding = {
                left : Number(this.element.css("padding-left").split("px")[0]),
                right : Number(this.element.css("padding-right").split("px")[0]),
                top : Number(this.element.css("padding-top").split("px")[0]),
                bottom : Number(this.element.css("padding-bottom").split("px")[0]),
            }; 
            this.scrollPosition = (this.itemsContainer.width() / 2) - this._rightScrollIcon.width();
            this.rightScroll = ej.getDimension(this.element, "width")- (this.itemsContainer.outerWidth()/2);
        },
        _addScrollIcon: function () { 
            this.element.addClass("e-tabscroll").css({"position":"relative", "overflow":"hidden"});
            if (this.element.find("div.e-chevron-circle-right").length <= 0 && this.items.length > 0) {
                this._rightScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-right', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.after(this._rightScrollIcon);
                this.scrollstep = 30;
                this._tabScrollIconCalc();
                this._rightScrollIcon.css("position", "absolute");
                if (!this.model.enableRTL) {
                    if (this.model.headerPosition == "left"){
                        this._rightScrollIcon.css("top", this.padding.top + 20 + "px");
                        this._rightScrollIcon.css("left", (this.scrollPosition + this.padding.left) + "px");
                    }
                    else if (this.model.headerPosition == "right"){
                        this._rightScrollIcon.css({"margin-left": this.itemsContainer.width() / 2 - this.scrollstep + "px", "z-index": "15", "top": this.padding.top + 20 + "px", "left": this.rightScroll + "px" });
                        this.element.css({"position": "relative"});
                    }
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelWidth))
                            this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - this.scrollPanelWidth + 20 - ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px");
                        else
                            this._rightScrollIcon.css("left", (this.scrollPanelWidth-(this.scrollstep + 20) + this.padding.left) + "px");
                    }
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    this._rightScrollIcon.css("transform", "rotate(270deg)");
                    if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                            if (!this.model.enableRTL)
                                this._rightScrollIcon.css("top", this.padding.top + 20 + "px");
                            else
                                this._rightScrollIcon.css("top", this.padding.top + 20 + "px");
                    }
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelHeight))
                            this._rightScrollIcon.css("margin-top", "-" + ((this.items[this.selectedItemIndex()].offsetTop * 3 - this.scrollPanelHeight * 2)) + "px");
                        else
                            if (this.model.enableRTL)
                                if(this.model.headerPosition == "left")
                                this._rightScrollIcon.css({"left": "0px", "margin-left": (this.scrollPosition + this.padding.left) + "px", "z-index":"15"});
                                else
                                this._rightScrollIcon.css({"right": (this.itemsContainer.outerWidth()/2) + this.padding.right + "px","z-index":"15"});
                                    

                    }
                }

                else {
                    if (this.model.enableRTL) { 
                        this._rightScrollIcon.css("margin-left", (this.itemsContainer.width() - 14) + "px");
                    } 
                }
                if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                     if (this.model.headerPosition == "bottom") {
                        if (!this.model.enableRTL)
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");
                        else
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 20) + "px");
                    }
                }
                
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                this._on(this.element.find("div.e-chevron-circle-right"), "mouseover", this._hoverHandler);
                this._on(this.element.find("div.e-chevron-circle-right"), "mouseout", this._hoverHandler);
            }
        },
        _addScrollBackIcon: function () {
            if (this.element.find("div.e-chevron-circle-left").length <= 0) {
                this._leftScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-left', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.before(this._leftScrollIcon);
                this.rightscrollstep = 30;
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._leftScrollIcon.css("position", "absolute").css("z-index", "10");
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (this.model.enableRTL){ 
                        this._leftScrollIcon.css("left", (this.padding.left + this.rightscrollstep) + "px");
                    }
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    if (!this.model.enableRTL) {
                        if (this.model.headerPosition == "right"){
                            this._leftScrollIcon.css({"margin-left": ((this.itemsContainer.width() / 2) - 30) + "px", "z-index": "15", "left": this.rightScroll + "px"});
                            this._leftScrollIcon.css("top", this.scrollPanelHeight + 30 + "px");
                        }
                        else if (this.model.headerPosition == "left"){
                            this._leftScrollIcon.css("left", (this.scrollPosition + this.padding.left) + "px");
                            this._leftScrollIcon.css("top", (this.scrollPanelHeight- 20) + this.padding.top + "px");
                        }
                    }
                    else {
                        this._leftScrollIcon.css("top", this.scrollPanelHeight + "px");
                        if (this.model.headerPosition == "right")
                            
                            this._leftScrollIcon.css({"right": (this.itemsContainer.outerWidth()/2) + this.padding.right + "px", "margin-left": (this.scrollPosition + this.padding.left) + "px", "z-index": "15"});
                        else
                            this._leftScrollIcon.css({"left":"0px", "margin-left": (this.scrollPosition + this.padding.left) + "px"});
                    }
                    this._leftScrollIcon.css("transform", "rotate(270deg)");
                }
                if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11)
                    if (this.model.headerPosition == "bottom") {
                    this._leftScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");     
                    }
                this._on(this._leftScrollIcon, "click", this._tabScrollBackClick);
                this._on(this.element.find("div.e-chevron-circle-left"), "mouseout", this._hoverHandler);
                this._on(this.element.find("div.e-chevron-circle-left"), "mouseover", this._hoverHandler);
            }
        },


        _addReloadIcon: function () {
            if (this.element.find("div.e-reload").length <= 0 && this.items.length > 0) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var iconPosition = this.items.find("a");
                    reloadIcon.insertBefore(iconPosition);
                }
                else
                    this.items.append(reloadIcon);
            }
        },


        _addBaseClass: function () {
            this.element.addClass("e-widget " + this.model.cssClass);
            this.itemsContainer.addClass("e-box")
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            // To avoid border blinking 
            if (this.model.headerPosition == "top") {
                $(this.contentPanels).addClass("e-hidebottom e-addborderbottom");
                $(this.itemsContainer).addClass("e-addborderbottom");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderright e-addborderleft");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-top-line");
                    this.items.removeClass("e-rtl-bottom-line");
                }
            }
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels).removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addborderbottom e-addborderright e-addborderleft");
                $(this.contentPanels).addClass("e-hidetop e-addbordertop");
                $(this.itemsContainer).addClass("e-addbordertop");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-bottom-line")
                    this.items.removeClass("e-rtl-top-line e-top-line");
                }
            }
            if (this.model.headerPosition == "left") {
                this.items.length > 0 && this.itemsContainer.addClass("e-left");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderright");
                $(this.contentPanels).addClass("e-hideleft e-addborderleft");
                $(this.itemsContainer).addClass("e-addborderleft");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            if (this.model.headerPosition == "right") {
                this.items.length > 0 && this.itemsContainer.addClass("e-right");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderleft");
                $(this.contentPanels).addClass("e-hideright e-addborderright");
                $(this.itemsContainer).addClass("e-addborderright");
                if (this.model.enableTabScroll && this._tabContentsHeight() > (this.element.height || Number(this.model.height)))
                    $(this.itemsContainer).css("z-index", "12").css("margin-left", "-" + this.itemsContainer.find("li").width() + "px");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            this.items.addClass("e-select e-item").attr("role", "tab").attr("tabindex", -1).attr("aria-expanded", true).attr("aria-selected", false);
            $(this.contentPanels).addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
            if (((this.model.headerPosition == "left" || this.model.headerPosition == "right") && (this._tabContentsHeight() > (this.element.height() || Number(this.model.height)))) || ((this.model.headerPosition == "top" || this.model.headerPosition == "bottom") && this._tabContentsWidth() > ((ej.getDimension(this.element, "width")) || this.model.width)))
                this._checkScroll();
        },
        _addContentBaseClass: function (panelElement) {
            if (this.model.headerPosition == "top") {
                panelElement.addClass("e-hidebottom e-addborderbottom");
                panelElement.removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "bottom") {
                panelElement.removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                panelElement.addClass("e-hidetop e-addbordertop");
            }
            if (this.model.headerPosition == "left") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                panelElement.addClass("e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "right") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                panelElement.addClass("e-hideright e-addborderright");
            }
            panelElement.addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
        },

        _checkScroll: function () {
            this.scrollPanelWidth = ej.getDimension(this.element, "width");
            this.scrollPanelHeight = ej.getDimension(this.element, "height");
            if (this.model.enableTabScroll == true && this._tabContentsHeight() > this.items.height()) {
                this.scrollstep = 0;
                this.model.enableTabScroll = true;
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    this.itemsContainer.css({ "width": ((ej.getDimension(this.element, "width") + (parseInt(this.items.css("width")) * this.items.length))) + "px", "position": "absolute" });
                }
                this._beforeWidth = 0;
                if (this.model.enablePersistence == true) {
                    if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetWidth;
                        }
                    }
                    else {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetHeight;
                        }
                    }
                }
                var widthValue = parseInt(this.itemsContainer.css("width"));
                if (this.model.headerPosition == "top") {
                    var item = $(this.contentPanels);
                    item.css("padding-top", this.itemsContainer.outerHeight() + (item.hasClass("e-activetop") ? 0 : (this.model.enableRTL ? 4 : 3)) + "px");
                    $(this.contentPanels).css({"border-top": "none", "width": ej.getDimension(this.element, "width") - 1 + "px" });
                    this.itemsContainer.css("border-bottom", "1px solid #bbbcbb");
                }
                if (this.model.headerPosition == "bottom") {
                    $(this.contentPanels).css({ "position": "relative", "width": ej.getDimension(this.element, "width") - 1 + "px", "border-bottom": "none" });
                    this.itemsContainer.css("border-top", "1px solid #bbbcbb");
                    $(this.contentPanels).css({ "border-top": "" });
                }

                var rigtVaule = parseInt(widthValue - (this.scrollPanelWidth + this.scrollstep - 1));
                if (this.model.enableRTL && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                    this.itemsContainer.css("clip", "rect(0px," + widthValue + "px,100px," + rigtVaule + "px)");
                }
                else if (this.model.headerPosition == "left") {
                    if (this._tabContentsHeight() > Number(this.model.height.split("px")[0])) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "border-right": "1px solid #bbbcbb", "background": "white" });
                        $(this.contentPanels).css("padding-left", this.itemsContainer.width() + 5 + "px");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", (ej.getDimension(this.element, "width") - this.itemsContainer.width()));
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + (this.itemsContainer.width() + 4) + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }

                        this.element.removeClass("e-scrolltab");
                    }
                }
                else if (this.model.headerPosition == "right") {
                    if (this._tabContentsHeight() > Number(this.model.height.split("px")[0])) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "margin-left": "-1px", "right": 0 + Number(this.element.css("padding-left").split("px")[0]) + "px" }).css("z-index", "12")
                        $(this.contentPanels).css({ "position": "absolute", "width": ej.getDimension(this.element, "width")-this.itemsContainer.outerWidth() + "px", "height": ej.getDimension(this.element, "height") + "px", "border-right": "none" });
                        this.itemsContainer.css("border-left", "1px solid #bbbcbb");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", "-" + (this.itemsContainer.width() + 1) + "px");
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + this.itemsContainer.width() + 2 + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }
                        this.element.removeClass("e-scrolltab");
                    }
                    if(this.model.enableRTL){
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "margin-left": "-1px", "right": this.itemsContainer.width() + Number(this.element.css("padding-right").split("px")[0]) + "px" }).css("z-index", "12")
                        $(this.contentPanels).css({ "position": "absolute", "width": ej.getDimension(this.element, "width")-this.itemsContainer.outerWidth() + "px", "left": this.element.css("padding-left"), "height": ej.getDimension(this.element, "height") + "px", "border-right": "none", "left": 0 + Number(this.element.css("padding-right").split("px")[0]) + "px"});
                    }
                }
                else {
                    if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelWidth) {
                        this.itemsContainer.css({ "clip": "rect(0px," + (this.scrollPanelWidth + this.scrollstep) + "px,100px," + (this.scrollstep) + "px)", "margin-left": "-" + this.scrollstep + "px" });
                    }
                    else {
                        if (this._beforeWidth > this.scrollPanelWidth) {
                            this.itemsContainer.css({ "clip": "rect(0px," + (this.items[this.selectedItemIndex()].offsetLeft * 2 - this.scrollPanelWidth) + "px,100px," + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px)", "margin-left": "-" + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px" });
                        }
                    }
                }
                this.element.find(".e-icon.e-chevron-circle-left").length && this.element.find(".e-icon.e-chevron-circle-left").css("display", "none");
                this._initialClip = this.itemsContainer.css("clip");
            }
        },
        _executeForwardScrolling: function (args , scrollStep) {
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 + tabScrollStep) + "px" });
					if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
					if ((this._leftScrollIcon && this._leftScrollIcon.css("margin-left")) && (Number(this.itemsContainer.css("margin-left").split("px")[0].replace("-", "")) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))) {
                        this._rightScrollIcon.css("display", "none"); 
						this._off(this.items, "swipeleft", this._tabSwipe);
                    }

                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = this.itemsContainer.css("margin-right") ? Number(this.itemsContainer.css("margin-right").split("px")[0].replace(",", "")) : 0;
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin + tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue - tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll + tabScrollStep) + "px") : "";
					 if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
                    if (this._leftScrollIcon && this._leftScrollIcon.css("margin-right") && (Number(this.itemsContainer.css("margin-right").split("px")[0].replace("-", ""))) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
                        this._rightScrollIcon.css("display", "none")

                }

            }
            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0].replace(",", ""));
                var RightTop = this._leftScrollIcon && this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 + tabScrollStep) + "px, " + (this.itemsContainer.width() + 4) + "px," + (ClipValue2 + tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop + tabScrollStep) + "px" });
                if (ClipValue2 > (this._tabContentsHeight() - 20)) {
                    this.itemsContainer.css({ "clip": "rect(" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px, " + (this.itemsContainer.width() + 4) + "px, " + (this._tabContentsHeight() + 2) + "px, 0px", "margin-top": "-" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px" })
                    this._rightScrollIcon.css("display", "none");
                }
            }
        },
        _executeBackwardScrolling: function ( args , scrollStep ) {
            if (this._rightScrollIcon != "") this._rightScrollIcon.css("display", "block");
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 - tabScrollStep) + "px" });
                    if (ClipValue2 - tabScrollStep < 0) {
                        this.itemsContainer.css({ "clip": "rect(0px," + ej.getDimension(this.element, "width") + "px,100px, 0px", "margin-left": "0px" });
                        this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - ej.getDimension(this.element, "width") + 20 + "px");
                    }
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (ClipValue2 <= tabScrollStep && this._leftScrollIcon)
                        this._leftScrollIcon.css("display", "none");
                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin - tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue + tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll - tabScrollStep) + "px") : "";
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (itemsMargin >= -tabScrollStep && this._leftScrollIcon) {
                        this._leftScrollIcon.css("display", "none");
                    }
                }
            }

            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0]);
                var RightTop = this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 - tabScrollStep) + "px, " + this.itemsContainer.width() + "px," + (ClipValue2 - tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop - tabScrollStep) + "px" });
                if (Number(this.itemsContainer.css("clip").split("px")[0].split("(")[1]) <= 0) {
                    this.itemsContainer.css({ "clip": "rect( 0px, " + this.itemsContainer.width() + "px," + (Number(this.model.height)) + "px, 0px)", "margin-top": "0px" });
                    this._leftScrollIcon.css("display", "none");
                }
            }
        },

        _removeHeaderClass: function () {
            this.itemsContainer.remove();
            this.itemsContainer.insertBefore(this.element.find(">div").first());
            this.items.removeClass("e-bottom-line e-top-line");
            $(this.contentPanels).removeClass("e-content-bottom e-activetop e-activebottom");
            this.itemsContainer.removeClass("e-header e-left e-right");
        },

        _removeVerticalClass: function () {
            this.element.removeClass("e-vertical");
            this.itemsContainer.removeClass("e-left e-right").removeAttr("style");
        },


        _removeBaseClass: function () {
            this.element.removeClass("e-tab e-widget e-corner e-rtl e-js e-tabscroll").removeAttr("role tabindex unselectable");
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                this._removeVerticalClass();
            this.itemsContainer.removeClass("e-header e-box e-clearall e-select e-addborderbottom e-addbordertop e-addborderleft e-addborderright");
            this.anchors.removeClass("e-link");
            this.items.removeClass("e-select e-item e-active e-bottom-line e-top-line e-margine-top e-margine-bottom e-rtl-top-line e-top-hover e-rtl-bottom-line e-disable").removeAttr("role tabindex aria-selected aria-expanded");
            $(this.contentPanels).removeClass("e-content  e-content-item e-box e-content-bottom e-activetop e-activebottom e-active-content e-hidebottom e-addborderbottom e-hidetop e-addbordertop e-hideleft e-addborderleft e-hideright e-addborderright e-disable").removeAttr("role aria-hidden").css("display", "");
            this.element.find("div.e-close.e-tabdelete,div.e-icon.e-chevron-circle-right,div.e-icon.e-chevron-circle-left,div.e-icon.e-reload").remove();
        },


        _addContentTag: function (href, index) {
            var id = this._getTabId(href);
            var panel = this.element.find("#" + id);
            if (!panel.length) {
                panel = ej.buildTag("div.e-content  e-content-item e-box e-content-bottom #" + id)
                    .insertAfter(this.contentPanels[index - 1] || this.itemsContainer);
            }
            this.contentPanels.splice(index, 0, panel[0]);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
            }
            else if (this.element.hasClass('e-corner')) {
                this.element.removeClass('e-corner');
            }
        },


        _setTabsHeightStyle: function (heightFormat) {
            if (ej.Tab.HeightAdjustMode.Content != heightFormat) $(this.contentPanels).height("");
            if (ej.Tab.HeightAdjustMode.Fill == heightFormat) {
                if (ej.Tab.Position.Left === this.model.headerPosition || ej.Tab.Position.Right === this.model.headerPosition) {
                    $(this.contentPanels).css("height", "100vh");
                }
                this._contentPaneSize();
            }
            else if (ej.Tab.HeightAdjustMode.Auto == heightFormat) {
                var maxHeight = 0;
                $(this.contentPanels).css({ "display": "none" }).addClass('e-active-content');
                for (var i = 0; i < this.contentPanels.length; i++) {
                    maxHeight = Math.max(maxHeight, this._getDimension($(this.contentPanels[i]), "outerHeight"));
                }
                $(this.contentPanels).removeClass('e-active-content');
                $(this.contentPanels).height(maxHeight);
                this.maxAutoHeight = maxHeight;
                this.showItem(this.selectedItemIndex());
            }
            else if (ej.Tab.HeightAdjustMode.None == heightFormat) {
                if (this.model.height != null) {
                    this._contentPaneSize();
                }
            }
            if (ej.Tab.HeightAdjustMode.Fill !== heightFormat) $(this.itemsContainer).height("");
            if (ej.Tab.HeightAdjustMode.Content == heightFormat)
                $(this.contentPanels).height("auto");

            if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },
        _getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().addBack().filter(':hidden');
            var prop = { visibility: 'hidden', display: 'block' };
            var hiddenCollection = [];
            $hidden.each(function () {
                var hidden = {}, name;
                for (name in prop) {
                    hidden[name] = this.style[name];
                    this.style[name] = prop[name];
                }
                hiddenCollection.push(hidden);
            });
            value = /(outer)/g.test(method) ?
            $(element)[method](true) :
           $(element)[method]();

            $hidden.each(function (i) {
                var hidden = hiddenCollection[i], name;
                for (name in prop) {
                    this.style[name] = hidden[name];
                }
            });
            return value;
        },
        // Tab to active given index value
        showItem: function (index) {
            if ($.inArray(index, this.model.disabledItemIndex) < 0) {
                var proxy = this;
                if (this._isInteraction != false) this._isInteraction = true;
                this._preTabSelectedIndex = this.selectedItemIndex();
                this.selectedItemIndex(index);
                if (this.selectedItemIndex() >= this.contentPanels.length) {
                    this.selectedItemIndex(0);
                    index = this.selectedItemIndex();
                }
                if (index >= 0 && !this.initialRender && true === this._onBeforeActive(index)){
                    this.selectedItemIndex(this._preTabSelectedIndex);
                    return false;
                } 
                else this._preTabIndex = this._preTabSelectedIndex;
                $(this.items[this.selectedItemIndex()]).attr("aria-expanded", true).attr("aria-selected", true).attr("tabindex", 0);
                if (this.selectedItemIndex() != null && this.selectedItemIndex() < this.contentPanels.length) {
                    this._ajaxLoad();
                    this.hideItem(this._preTabIndex);
                    $(this.contentPanels[this.selectedItemIndex()]).fadeIn(this.model.enableAnimation ? 20 : 0, function () {
                        if (!proxy.initialRender && proxy._onActive())
                            return true;
                        proxy.initialRender = false;
                    });
                    if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                        var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
                        $(this.contentPanels[this.selectedItemIndex()]).addClass(activeClass)
                    }
                    else
                        $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content ");
                    $(this.items[this.selectedItemIndex()]).addClass("e-active").removeClass("e-select");
                    $(this.items[this.selectedItemIndex()]).removeClass("e-margine-top e-margine-bottom");

                    for (var i = 0; i <= $(this.items).length; i++) {
                        if ($(this.items[i]).hasClass("e-select")) {
                            if (this.model.headerPosition == "right") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "left") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "top") {
                                if (!this.element.hasClass("e-tab-collapsed"))
                                    $(this.items[i]).addClass("e-margine-top");
                                else
                                    $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).removeClass("e-margine-bottom");
                            }
                            if (this.model.headerPosition == "bottom") {
                                $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).addClass("e-margine-bottom");
                            }
                        }
                    }
                    $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content").removeAttr("aria-hidden", false);
                }
            }
            if (this.model.enableTabScroll && this._tabContentsWidth() > (this.model.width || this.element.width()) && this.itemsContainer.find("li").length && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                if (!this.model.enableRTL) {
                    var itemPosition = Number(this.itemsContainer.find("li.e-active").position().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() - ej.getDimension(this.element, "width");
                    if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() > ej.getDimension(this.element, "width") || (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) - this.itemsContainer.find("li.e-active").width() < 0))) {
                        this.itemsContainer.css("clip", "rect(0 ," + (ej.getDimension(this.element, "width") + (itemPosition + 10)) + "px, 100px," + (itemPosition + 10) + "px)").css("margin-left", "-" + (itemPosition + 10) + "px")
                        this._rightScrollIcon ? this._rightScrollIcon.css("margin-right", (this.itemsContainer.width() - ej.getDimension(this.element, "width") + 10 - itemPosition) + "px").css("display", "block") : "";
                        this._addScrollBackIcon();
                        if ((this._leftScrollIcon && this._leftScrollIcon.css("margin-left")) && (Number(this.itemsContainer.css("margin-left").split("px")[0].replace("-", "")) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))) {
                        this._rightScrollIcon.css("display", "none"); 
						this._off(this.items, "swipeleft", this._tabSwipe);
                    }else
                        this._leftScrollIcon ? this._leftScrollIcon.css("display", "block") : "";
                    }
                }
            }
            else if (this.model.enableTabScroll && this.model.height && (this.model.headerPosition == "left" || this.model.headerPosition == "right") && !this.model.enableRTL) {
                var itemPosition = Number(this.itemsContainer.find("li.e-active").position().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() - Number(this.model.height);
                if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() > Number(this.model.height) || (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) - this.itemsContainer.find("li.e-active").height() < 0))) {
                    this.itemsContainer.css("clip", "rect(" + itemPosition + "px," + (this.itemsContainer.outerWidth() + 2) + "px, " + (Number(this.model.height) + itemPosition) + "px, 0px").css("margin-top", "-" + itemPosition + "px");
                    this._addScrollBackIcon();
                }
            }

        },

        hideItem: function (index) {
            $(this.contentPanels[index]).fadeOut(0);
            if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
            $(this.items[index]).removeClass("e-active").addClass("e-select");
            $(this.contentPanels[index]).removeClass("e-active-content " + activeClass).attr("aria-hidden", true);
        },


        _ajaxLoad: function () {
            var content = $(this.contentPanels[this.selectedItemIndex()]);
            var link = this.anchors[this.selectedItemIndex()];
            var href = $(link).attr("href");
            if (content.is(':empty') && href.indexOf("#") !== 0)
                this._sendAjaxOptions(content, link);
        },


        _getTabId: function (href) {
            return !href.indexOf("#") ? href.replace("#", "") : this.model.idPrefix + this._getNextTabId();
        },

        _getNextTabId: function () {
            return ++this.tabId;
        },


        _disableTabs: function () {
            for (var i = 0, li; (li = this.items[i]) ; i++) {
                if ($.inArray(i, this.model.disabledItemIndex) > -1) {
                    $(li).find("a").off(this.model.events);
                    $(li).find("div.e-close").off("click");
                }
                $(li)[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(li).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
                $(this.contentPanels[i])[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(this.contentPanels[i]).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
            }
        },


        _tabItemClick: function (args) {

            if (this.model.enabled) {
                args.preventDefault(); // Prevent the ancher tag url action
                var index;
                if (this.selectedItemIndex() == $(this.items).index($(args.currentTarget)) && this.model.collapsible) {
                    index = -1; $(this.element).addClass("e-tab-collapsed");
                }
                else {
                    index = $(this.items).index($(args.currentTarget));
                }
                if (index != this.selectedItemIndex())
                    this.showItem(index);
                $(this.element).removeClass("e-tab-collapsed");               
				if(this.selectedItemIndex() > -1 && this.contentPanels != 0 && this.model.enableRTL)
				    $(this.element).height(this.itemsContainer.height()+parseInt($(this.contentPanels[this.selectedItemIndex()]).css("height")));
            }
        },

        _tabDeleteClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                var tabWidth = $(args.target).parent().width();
                if (currentTab.hasClass("e-close"))
                    var index = $(this.items).index($(args.target).parent());
                if (index == this.selectedItemIndex() && this.items.length > index)
                    this.selectedItemIndex(this.selectedItemIndex() + 1)
                var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                if(this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                     if(!this.model.enableRTL || (this.model.enableRTL && itemsMargin < -tabWidth )) this._executeBackwardScrolling(args,tabWidth);
                     else {
                         this.itemsContainer.css({"margin-right":"0px","clip":this._initialClip});
                         this._leftScrollIcon && this._leftScrollIcon.css("display", "none");
                         this._rightScrollIcon && this._rightScrollIcon.css("display", "none");
                     }	 
                }
                this.removeItem(index);
            }
        },
        _tabScrollClick: function (args) {
            if (this.model.enabled) {
                if ((this._rightScrollIcon[0] == args.target)) {
                    this._executeForwardScrolling(args);

                    this._addScrollBackIcon();
                    this._leftScrollIcon.css("display", "block");
                }
            }
        },
		
		_tabSwipe: function(e){ 
			 if(e.type=='swipeleft')  
			this._executeForwardScrolling(e);
			else 
			this._executeBackwardScrolling(e);
		},
        _tabScrollBackClick: function (args) { 
            if (this.model.enabled) {
                if ((this._leftScrollIcon[0] == args.target)) {
                    this._executeBackwardScrolling(args);
                }
            }
        },

        _tabReloadClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                if (currentTab.hasClass("e-reload")) {
                    var link = this.anchors[this.selectedItemIndex()];
                    var href = $(link).attr("href");
                    var content = $(this.contentPanels[this.selectedItemIndex()]);
                    if (href.indexOf("#") !== 0)
                        this._sendAjaxOptions(content, link);
                    else
                        this.showItem(this.selectedItemIndex());
                }
            }
        },


        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            if (this._onBeforeLoad(link))
                return true;
            content.addClass("e-load");
            var proxy = this;
            var curTabTitle = $(link).html();
            var hrefLink = link.href.replace("#", "");
            var ajaxOptions = {
                type: this.model.ajaxSettings.type, cache: this.model.ajaxSettings.cache, url: hrefLink, data: this.model.ajaxSettings.data,
                dataType: this.model.ajaxSettings.dataType, contentType: this.model.ajaxSettings.contentType, async: this.model.ajaxSettings.async,
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, content, link, curTabTitle);
                    } catch (e) {

                    }
                }, "error": function () {
                    try {
                        proxy._ajaxErrorHandler(link, proxy.selectedItemIndex(), curTabTitle);
                    } catch (e) {

                    }
                }
            };
            this._sendAjaxRequest(ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },


        _ajaxSuccessHandler: function (data, content, link, curTabTitle) {
            if (curTabTitle != null)
                $(link).html(curTabTitle);
            content.removeClass("e-load");
            content.html(data).addClass("e-tab-loaded"); //to indicate the content is already loaded
            var eventData = { data: data, url: link, content: content };
            this._trigger("ajaxSuccess", eventData);
            if (this._onLoad(link))
                return true;
        },


        _ajaxErrorHandler: function (data, link, index, title) {
            this._trigger("ajaxError", { data: data, url: link });
            this._onLoad(link);
        },

        _createContentPanel: function (id) {
            return $('<div></div>')
				.attr("id", id)
				.addClass("e-content  e-content-item e-content-bottom e-box");
        },


        _refresh: function () {
            this._unWireEvents();
            this.itemsContainer.removeAttr("style class");
            $(this.contentPanels).removeAttr("style class");
            this.element.css("margin-left", "");
            this._removeVerticalClass();
            this._removeHeaderClass();
            this._initialize();
        },

        _keyPress: function (e) {
            if (this.model.enabled) {
                var index, currentEle, targetEle = $(e.target),code;
                if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
                else if (e.which) code = e.which; // ns4 and opera
                else code = e.charCode;
                if (targetEle.hasClass("e-link") || targetEle.hasClass("e-item")) {
                    switch (code) {
                        case 39:
                        case 40:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex() + 1);
                                break;
                            }
                        case 37:
                        case 38:
                            {
                                e.preventDefault();
                                if (this.selectedItemIndex() != 0)
                                    this.showItem(this.selectedItemIndex() - 1);
                                else if (this.selectedItemIndex() == 0)
                                    this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 35:
                            {
                                e.preventDefault();
                                this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 36:
                            {
                                e.preventDefault();
                                this.showItem(0);
                                break;
                            }
                        case 13:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex());
                                break;
                            }
                    }
                }
                else if (e.ctrlKey && !targetEle.hasClass("e-tab")) {
                    switch (code) {
                        case 38:
                            e.preventDefault();
                            index = $(this.contentPanels).index(targetEle.parent(".e-content"));
                            currentEle = $(this.items[index]);
                            break;
                        case 33:
                            e.preventDefault();
                            currentEle = $(this.items[0]);
                            this.showItem(0);
                            break;
                        case 34:
                            e.preventDefault();
                            currentEle = $(this._headers[this.getItemsCount() - 1]);
                            this.showItem(this.getItemsCount() - 1);
                            break;
                    }
                }
                if (!ej.isNullOrUndefined(currentEle)) {
                    currentEle.addClass("e-focus");
                    currentEle.focus();
                }
            }
        },

        _hoverHandler: function (args) {
            args.preventDefault();
            if (this.model.enabled) {
                var index = $(this.items).index($(args.target).parent());
                if (index == -1)
                    index = $(this.items).index($(args.target));
				if((this.model.showCloseButton || this.model.showReloadIcon) && !$(this.items[index]).hasClass("e-disable")){
                args.type === "mouseout" ? $(this.element.find("div.e-tabdelete")[index]).css("visibility", "hidden") : $(this.element.find("div.e-tabdelete")[index]).css("visibility", "visible");
				args.type === "mouseout" ? $(this.element.find("div.e-reload")[index]).css("visibility", "hidden") : $(this.element.find("div.e-reload")[index]).css("visibility", "visible");
				}
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-right")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-right")).css("visibility", "visible");
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-left")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-left")).css("visibility", "visible");
            }
        },


        _wireEvents: function (event) {
            this._on(this.items, event, this._tabItemClick);
            this._on(this.itemsContainer, "mouseover", this._hoverHandler);
            this._on(this.itemsContainer, "mouseout", this._hoverHandler);
            this._on(this.element.find(">ul").eq(0).find(">li div.e-close"), "click", this._tabDeleteClick);
            this._on(this.element.find("div.e-chevron-circle-left"), "click", this._tabScrollBackClick);
			if (this.model.enableTabScroll)this._on(this.items, "swipeleft swiperight", this._tabSwipe);
            this._on(this.itemsContainer, "focusin", this._focusIn);
            this._on(this.itemsContainer, "focusout", this._focusOut);
            $(window).on('resize', $.proxy(this._resize, this));
            this._on(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click", this._tabReloadClick);
        },
        _resize: function () {
            if (this.model && this.model.width == null && this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                this._removeScroll()
                this._addScroll()
            }
        },


        _unWireEvents: function () {
            this._off(this.items, this.model.events);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-close"), "click");
            this._off(this.element.find("div.e-chevron-circle-right"), "click");
            this._off(this.element.find("div.e-chevron-circle-left"), "click");
			if (this.model.enableTabScroll)this._off(this.items, "swipeleft swiperight", this._tabSwipe);
            this._off(this.itemsContainer, "mouseover", this._hoverHandler);
            this._off(this.itemsContainer, "mouseout", this._hoverHandler);
            this._off(this.element.find("div.e-chevron-circle-left"), "mouseover", this._hoverHandler);
            this._off(this.element.find("div.e-chevron-circle-right"), "mouseover", this._hoverHandler);
            this._off(this.element.find("div.e-chevron-circle-left"), "mouseout", this._hoverHandler);
            this._off(this.element.find("div.e-chevron-circle-right"), "mouseout", this._hoverHandler);
            this._off(this.itemsContainer, "focusin", this._focusIn);
            this._off(this.itemsContainer, "focusout", this._focusOut);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click");
            this._resizeEvents();
        },
        _resizeEvents: function (value) {
            if (value === "fill") $(window).on('resize', $.proxy(this._windowResized, this));
            else $(window).off('resize', $.proxy(this._windowResized, this));
        },


        _windowResized: function (e) {
            var maxHeight = this._getDimension($(this.element).parent(), "height");
            if (this._prevSize == maxHeight) return;
            else this._contentPaneSize();
            this._prevSize = maxHeight;
            if (!this.model.width && this.model.enableTabScroll)
                this._addScroll();
        },
        _contentPaneSize: function () {
            if (this.model.height != null && this.model.heightAdjustMode == "none") {
                $(this.element).height(this.model.height);
                var maxHeight = this._getDimension($(this.element), "height");
            }
            else var maxHeight = this._getDimension($(this.element).parent(), "height");
            $(this.contentPanels).height("");
            $(this.element).parent().css({ "overflow": "auto" });
            if (this.model.headerPosition === "top" || this.model.headerPosition === "bottom")
                maxHeight -= this._getDimension($(this.itemsContainer), "outerHeight");
            var maxPadding = 0, padding;
            for (var i = 0; i < this.contentPanels.length; i++) {
                if ($(this.contentPanels[i]).hasClass("e-active-content")) {
                    padding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - padding).css({ "overflow": "auto" });
                } else {
                    maxPadding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - maxPadding).css({ "overflow": "auto" });
                }
            }
        },
        _disableItems: function (indexes) {
            if (!this.model.enabled) return false;
            if (indexes != null) {
                for (var i = 0; i < indexes.length; i++) {
                    if ($.inArray(indexes[i], this.model.disabledItemIndex) == -1)
                        this.model.disabledItemIndex.push(indexes[i]);
                }
                this.model.disabledItemIndex.sort();
                this._disableTabs();
            }
        },

        _enableItems: function (indexes) {
            if (!this.model.enabled) return false;
            for (var i = 0; i < indexes.length; i++) {
                var index = indexes[i];
                this.model.disabledItemIndex = $.grep(this.model.disabledItemIndex, function (n, i) {
                    return n != index;
                });
            }
            this._disableTabs();
        },


        disable: function () {
            var indexes = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                indexes.push(index);
            }
            this._disableItems(indexes);
            this.model.enabledItemIndex = [];
            this._unWireEvents();
        },

        enable: function () {
            var indexes = [];
            this.model.disabledItemIndex = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                if ($.inArray(index, this.model.enabledItemIndex) < 0) {
                    this.model.enabledItemIndex.push(index);
                    indexes.push(index);
                }
                this._enableItems(index);
            }
        },

        getItemsCount: function () {
            if (this.items) {
                return this.items.length;
            }
        },

        addItem: function (url, displayLabel, index, cssClass, id) {
            (index >= 0 && index < this.items.length) ? this._addItemIndex = index : this._addItemIndex = this.items.length;
            for (var disable_index = 0; disable_index < this.model.disabledItemIndex.length; disable_index++) {
                if (this.model.disabledItemIndex[disable_index] >= index)
                    this.model.disabledItemIndex[disable_index]++;
            }
            if (this.model.headerPosition == "left") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-left");
            }
            else if (this.model.headerPosition == "right") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-right");
            }
            else
                this.items.length == 0 && this.itemsContainer.addClass("e-header");
            var liTag = ej.buildTag("li.e-select e-item");
            if ((this.model.headerPosition == "top"))
                if (this.model.enableRTL)
                    $(liTag).addClass("e-rtl-top-line e-top-hover");
                else
                    $(liTag).addClass("e-bottom-line");
            if (!ej.isNullOrUndefined(cssClass)) {
                var span = ej.buildTag('span').addClass(cssClass);
                liTag.append(span);
            }
            if (index === undefined && displayLabel === undefined && url != null)
                displayLabel = "Item";
            if (index === undefined && displayLabel === undefined && id === undefined) {
                url = "#Item" + this.items.length;
                displayLabel = "Item"
            }
            if (id != undefined) {
                if (id.indexOf("#") != 0)
                    id = "#" + id;
                this.divId = id;
            }
            else if (url != undefined)
                id = url;
            var aTag = ej.buildTag("a", displayLabel, {}, { href: url });
            aTag.addClass("e-link");
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")
                aTag.appendTo(liTag);
            if (this.model.showCloseButton) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, {}).css("visibility", "hidden");
                liTag.append(deleteIcon);
                this._on(deleteIcon, "click", this._tabDeleteClick);
            }
            if (this.model.headerPosition == "left" || this.model.headerPosition == "right")
                aTag.appendTo(liTag);
            if (index === undefined) {
                index = this.anchors.length;
            }
            var insertIndex = index >= this.items.length;
            if (insertIndex) {
                liTag.appendTo(this.itemsContainer);
            } else {
                liTag.insertBefore(this.items[index]);
            }
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            if (this.selectedItemIndex() == index) {
                this.hideItem[index];
                this.selectedItemIndex(this.selectedItemIndex() + 1);
            } else {
                this.hideItem[index];
                if (index < this.selectedItemIndex())
                    this.selectedItemIndex(this.selectedItemIndex() + 1);
            }
            this._itemsRefreshing();
            this._reinitialize(true);
            if (this.model.headerPosition == "top")
                $(this.contentPanels[index]).addClass("e-hidebottom");
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels[index]).addClass("e-hidetop");
                liTag.addClass("e-top-line e-item e-select e-margine-bottom")
            }
            if (this.model.headerPosition == "left")
                $(this.contentPanels[index]).addClass("e-hideleft");
            if (this.model.headerPosition == "right")
                $(this.contentPanels[index]).addClass("e-hideright");
            var data = {
                tabHeader: this.anchors[index],
                tabContent: this.contentPanels[index]
            };
            this.refreshTabScroll();
            this._addItemIndex = null;
            this._onAdd(data);
            if (this.model.showReloadIcon) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                $(this.element.find("li")[index]).append(reloadIcon)
            }
            if (this.model.enableTabScroll && this.model.headerPosition == "right") {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },

        _isSizeExceeded: function () {
            var eleWidth = this.element.width(), itemsWidth = 0;
            var tabcount = this.items.length;
            for (var tabVal = 0; tabVal < tabcount; tabVal++) {
                var tabWidth = $(this.items[tabVal]).width();
                itemsWidth += tabWidth;
            }
            return (itemsWidth > eleWidth ? true : false);
        },

        refreshTabScroll: function () {
            if (this._isSizeExceeded()) {
                this.element.find("div.e-chevron-circle-right").length >= 1 && this.element.find("div.e-chevron-circle-right").remove();
                if (this.model.enableTabScroll) {
                    this._checkScroll();
                    this._addScrollIcon();
                }
            }
            else {
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                    this._checkScroll();
            }
        },

        removeItem: function (index) {
            if (!this.model.enabled) return false;
            if (index != null && index > -1 && index < this.items.length) {
                if (this._onBrforeRemove({ index: index }) === true)
                    return false;
                var removedTab = $(this.items[index]).remove();
                this.model.disabledItemIndex = [];
                if (removedTab.hasClass("e-active")) {
                    index == 0 ? this.selectedItemIndex(index + 1) : this.selectedItemIndex(index - 1);
                    this.showItem(this.selectedItemIndex());
                }
                $(this.element.find(">div.e-content")[index]).remove();
                this.contentPanels.splice(index, 1);
                index < this.selectedItemIndex() ? this.selectedItemIndex(this.selectedItemIndex() - 1) : this.selectedItemIndex();

                if (index < 0 || index >= this.anchors.length) {
                    this.selectedItemIndex(0);
                }
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right") && this.items.length == 1)
                    this._removeVerticalClass();
                else
                    this.items.length == 1 && this.itemsContainer.removeClass("e-header");
                this._unWireEvents();
                this._itemsRefreshing();
                this._wireEvents(this.model.events);
                if (this.model.enableTabScroll)
                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                for (var indx = 0; indx < this.items.length; indx++)
                    if ($(this.items[indx]).hasClass('e-disable'))
                        this.model.disabledItemIndex.push(indx);
                this._disableTabs();
                var data = {
                    removedTab: removedTab
                };
                this._onRemove(data);
            }
            if (this.getItemsCount() == 0) {
                this.itemsContainer.removeAttr("style")
                this.itemsContainer.find("div").remove()
            }
            if (this._tabContentsHeight() < Number(this.model.height) && this.itemsContainer.css("clip").split("px").length && this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                this._refresh();
                this.itemsContainer.removeAttr("style");
                this._leftScrollIcon ? this._leftScrollIcon.remove() : "";
                this._rightScrollIcon ? this._rightScrollIcon.remove() : "";
            }
            else if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                if (this._leftScrollIcon && Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]) != -(Number(this._leftScrollIcon.css("margin-top").split("px")[0]))) {
                    this._removeScroll();
                    this._addScroll();
                } else
                    this.refreshTabScroll();
                this.showItem(this.selectedItemIndex())
            }

        },

        show: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "visible");
        },

        hide: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "hidden");
        },

        _onBeforeLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxBeforeLoad", data);
        },

        _focusIn: function () {
            if (!this.model.readOnly && this.model.allowKeyboardNavigation)
                $(this.element).on("keydown", $.proxy(this._keyPress, this));
        },

        _focusOut: function (e) {
            $(this.element).off("keydown", $.proxy(this._keyPress, this));
        },

        _onLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxLoad", data);
        },

        _onActive: function () {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), isInteraction: this._isInteraction };
            this._isInteraction = true;
            return this._trigger("itemActive", data);

        },

        _onBeforeActive: function (index) {
            if (this.model.beforeActive != null) {
                var data;
                if (this.selectedItemIndex() == -1 && this.model.collapsible)
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
                else
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: this.items[index], activeIndex: index, isInteraction: this._isInteraction };
                return this._trigger("beforeActive", data);
            }
        },

        _onAdd: function (data) {
            return this._trigger("itemAdd", data);
        },

        _onRemove: function (data) {
            return this._trigger("itemRemove", data);
        },

        _onBrforeRemove: function (data) {
            return this._trigger("beforeItemRemove", data);
        }
    });

    ej.Tab.HeightAdjustMode = {
        /**  Panel height adjusts based on the content */
        Content: "content",
        /**  All panel height will be set the tallest panel height. */
        Auto: "auto",
        /**  Content panel take based on the parent height. */
        Fill: "fill",
        /**  Content panel take based on the height property. */
        None: "none"
    };

    ej.Tab.Position = {
        /**  Tab headers display to top position. */
        Top: "top",
        /**  Tab headers display to bottom position. */
        Bottom: "bottom",
        /**  Tab headers display to left position. */
        Left: "left",
        /** Tab headers display to right position. */
        Right: "right"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {
    ej.widget("ejTreeView", "ej.TreeView", {
        _rootCSS: "e-treeview",

        element: null,

        model: null,

        validTags: ["ul", "div"],
        _addToPersist: ["expandedNodes", "checkedNodes", "selectedNodes"],
       
        _setFirst: false,

        _requiresID: true,

        defaults: {

            allowMultiSelection: false,

            showCheckbox: false,

            enableAnimation: true,

            allowDragAndDrop: false,

            htmlAttributes: {},

            allowDropChild: true,

            allowDropSibling: true,

            allowDragAndDropAcrossControl: true,

            allowEditing: false,

            allowKeyboardNavigation: true,

            items: null,

            fields: {

                dataSource: null,

                query: null,

                tableName: null,

                child: null,

                id: "id",

                parentId: "parentId",

                text: "text",

                spriteCssClass: "spriteCssClass",

                expanded: "expanded",

                hasChild: "hasChild",

                selected: "selected",

                linkAttribute: "linkAttribute",

                imageAttribute: "imageAttribute",

                htmlAttribute: "htmlAttribute",

                imageUrl: "imageUrl",

                isChecked: "isChecked"

            },

            autoCheckParentNode: false,

            loadOnDemand: false,

            cssClass: "",

            template: null,

            enableRTL: false,

            expandOn: "dblclick",

            enablePersistence: false,

            enabled: true,

            expandedNodes: [],

            checkedNodes: [],

            selectedNode: -1,

            selectedNodes: [],

            width: null,

            height: null,

            autoCheck: true,

            enableMultipleExpand: true,

            fullRowSelect: false,

            sortSettings: {

                allowSorting: false,

                sortOrder: "ascending",

            },

            nodeClick: null,

            beforeExpand: null,

            nodeExpand: null,

            beforeCollapse: null,

            nodeCollapse: null,

            beforeSelect: null,

            nodeSelect: null,

            nodeUnselect: null,

            nodeCheck: null,

            nodeUncheck: null,

            inlineEditValidation: null,

            beforeEdit: null,

            nodeEdit: null,

            keyPress: null,

            nodeDragStart: null,

            nodeDrag: null,

            nodeDragStop: null,

            nodeDropped: null,

            beforeAdd: null,

            nodeAdd: null,

            beforeDelete: null,

            nodeDelete: null,

            beforeCut: null,

            nodeCut: null,

            beforePaste: null,

            nodePaste: null,

            beforeLoad: null,

            loadSuccess: null,

            loadError: null,

            ready: null,

            create: null,

            destroy: null

        },

        dataTypes: {

            allowMultiSelection: "boolean",

            cssClass: "string",

            showCheckbox: "boolean",

            enableAnimation: "boolean",

            allowDragAndDrop: "boolean",

            allowDropChild: "boolean",

            allowDragAndDropAcrossControl: "boolean",

            allowEditing: "boolean",

            allowKeyboardNavigation: "boolean",

            autoCheckParentNode: "boolean",

            loadOnDemand: "boolean",

            enableRTL: "boolean",

            expandOn: "string",

            enablePersistence: "boolean",

            enableMultipleExpand: "boolean",

            fullRowSelect: "boolean",

            items: "data",

            fields: {

                dataSource: "data",

                query: "data",

                child: "data"

            },

            expandedNodes: "array",

            checkedNodes: "array",

            selectedNode: "number",

            selectedNodes: "array",

            htmlAttributes: "data",

            sortSettings: {

                allowSorting: "boolean",

                sortOrder: "enum",

            }
        },

        observables: ["fields.dataSource"],

        dataSource: ej.util.valueFunction("fields.dataSource"),

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "allowMultiSelection":
                        this.model.allowMultiSelection = options[key];
                        if (!this.model.allowMultiSelection) {
                            var sleNode = $(this._liList[this.model.selectedNodes[0]]);
                            this._unselectAll();
                            this._isRender = false;
                            this._nodeSelectionAction(sleNode);
                            this._isRender = true;
                        }
                        break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "fields":
                        if (this._deepWatch && !ej.isNullOrUndefined(options[key]["dataSource"]) && (JSON.stringify(this._oldDataSource) == JSON.stringify(typeof options[key]["dataSource"] == "function" ? options[key]["dataSource"]() : options[key]["dataSource"])))
                            return;
                        this._unWireEvents();
                        var tempUl, f = this.element.hasClass("e-js") ? false : true, element = f ? this.element.children("ul") : this.element;
                        element.empty();
                        if (this.model.fields == null || options[key] == null)
                            this.model.fields = options[key];
                        else
                            this._extendFields(this.model.fields, options[key]);
                        this.model.expandedNodes = [];
                        this.model.checkedNodes = [];
                        this.model.selectedNodes = [];
                        this.model.selectedNode = -1;
                        this._persistValues(this.model.expandedNodes, "expandedNodes");
                        this._persistValues(this.model.checkedNodes, "checkedNodes");
                        this._persistValues(this.model.selectedNodes, "selectedNodes");
                        this._newDataSource = this.dataSource();
                        (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) ? this._checkDataBinding() : this._initialize();
                        if (f) {
                            tempUl = this.element.children(".e-treeview-ul");
                            element.append(tempUl.children());
                            tempUl.remove();
                        }
                        break;
                    case "allowDragAndDropAcrossControl":
                        this.model.allowDragAndDropAcrossControl = options[key];
                        this._enableDragDrop();
                        break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "showCheckbox":
                        if (options[key]) {
                            this.model.showCheckbox = options[key];
                            this._showCheckBox();
                            (!this.model.enabled) && this.element.find('.nodecheckbox').ejCheckBox("disable");
                        } else {
                            this.element.find('.e-item > div > .e-chkbox-wrap').remove();
                            this._updateCheckedNodes();
                        }
                        break;
                    case "autoCheck": this.model.autoCheck = options[key]; break;
                    case "autoCheckParentNode": this.model.autoCheckParentNode = options[key]; break;
                    case "expandedNodes":
                        var len = options[key].length, temp = JSON.parse(JSON.stringify(this.model.expandedNodes));
                        if (len > 0) {
                            this._expandNodes(options[key]);
                            for (var i = 0, len = temp.length; i < len; i++) {
                                if (options[key].indexOf(temp[i]) == -1) {
                                    this._collapseNode($(this._liList[temp[i]]));
                                }
                            }
                        } else
                             (len == 0) && this._collapseAll();
                        options[key] = this.model.expandedNodes;
                        break;
                    case "checkedNodes":
                        if (this.model.showCheckbox) {
                            var len = options[key].length, temp = JSON.parse(JSON.stringify(this.model.checkedNodes));
                            if (len > 0) {
                                this._checkedNodes(options[key]);
                                for (var i = 0, len = temp.length; i < len; i++)
                                    (options[key].indexOf(temp[i]) == -1) && this._nodeUncheck($(this._liList[temp[i]]).find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                            } else
                                 (len == 0) && this._uncheckAll();
                        }
                        options[key] = this.model.checkedNodes;
                        break;
                    case "expandOn":
                        this._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn, this._expandEventHandler);
                        this._assignTouchExpandOn(options[key]);
                        this._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : options[key], this._expandEventHandler);
                        break;
                    case "allowEditing":
                        this._preventEditable();
                        (options[key]) && this._allowEditable();
                        break;
                    case "allowKeyboardNavigation":
                        var action = (options[key]) ? "_on" : "_off";
                        this[action](this.element, 'keydown', this._KeyPress);
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDraggable();
                        break;
                    case "allowDropChild":
                        this.model.allowDropChild = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDropChild();
                        break;
                    case "allowDropSibling":
                        this.model.allowDropSibling = options[key];
                        (options[key]) ? this._addDragableClass() : this._preventDropSibling();
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[key];
                        var action, ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
                        action = (this.model.enableRTL) ? "addClass" : "removeClass";
                        ele[action]("e-rtl");
                        break;
                    case "height": this.element.is("ul") ? this.element.parent().height(options[key]) : this.element.height(options[key]); break;
                    case "width": this.element.is("ul") ? this.element.parent().width(options[key]) : this.element.width(options[key]); break;
                    case "selectedNode":
                    case "selectedNodes":
                        this.model.selectedNodes = (key == "selectedNode") ? [options[key]] : options[key];
                        this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active').closest('li').attr("aria-selected", false);
                        this._doSelectNodes(this.model.selectedNodes, false);
                        if (key != "selectedNode") options[key] = this.model.selectedNodes;
                        break;
                    case "htmlAttributes": this._addAttr(options[key]); break;
                    case "enableMultipleExpand":
                        (!options[key]) && this.collapseAll();
                        this.model.enableMultipleExpand = options[key];
                        break;
                    case "sortSettings":
                        $.extend(this.model.sortSettings, options[key]);
                        if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                            this.model.expandedNodes = [];
                            this.model.checkedNodes = [];
                            this.model.selectedNodes = [];
                            this._checkDataBinding();
                        }
                        break;
                    case "fullRowSelect":
                        this._wholeRowEvents("_off");
                        this.model.fullRowSelect = options[key];
                        this.model.fullRowSelect ? this._addWholeRowWrap() : this._removeWholeRowWrap();
                        this._doWholeRowAction();
                        this._wholeRowEvents("_on");
                        break;
                }
            }
        },

        _destroy: function () {
            this.element.html("");
            this._cloneElement.removeClass('e-treeview e-js e-treeview-wrap');
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
            ele.replaceWith(this._cloneElement);
            $("#" + this._id + "_WaitingPopup").remove();
            if (window.localStorage) {
                window.localStorage.removeItem(this._id + "_childNodes");
                window.localStorage.removeItem(this._id + "_persistedValues");
            }
            else if (window.cookie) {
                document.cookie = this._id + "_childNodes=; expires=Thu, 01 Jan 1970 00:00:00 UTC";
                document.cookie = this._id + "_persistedValues=; expires=Thu, 01 Jan 1970 00:00:00 UTC";
            }
        },

        _init: function () {
            this._cloneElement = this.element.clone(), this._dataSource = [], this._fragment = [], this._templateType = "", this._indexID = 0, this._newDataSource = this.dataSource(), this._id = this.element.prop("id"), this._treeList = [], this._isTextbox = false;
            this._isDevice = this._checkDevice();
            this._deepWatch = (this.element.attr("e-deepwatch") === "true" && !(this.dataSource() instanceof ej.DataManager)) ? true : false;
            var browserInfo = ej.browserInfo();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._oldDataSource = JSON.parse(JSON.stringify(this.dataSource()));
            this._assignTouchExpandOn(this.model.expandOn);
            if (this.model.enablePersistence) {
                var cookieData = this._getCookies("_persistedValues");
                if (!cookieData) {
                    var obj = { selectedNodes: [], expandedNodes: [], checkedNodes: [] };
                    obj = this._updatePersistAttr(obj);
                    this._setCookies("_persistedValues", JSON.stringify(obj));
                }
            }
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                this._checkDataBinding();
            } else {
                this._initialize();
                this._completeRendering();
            }
        },

        _initialize: function () {
            this._cutNode = null, this._beforeEditText = null, this._CurrenctSelectedNodes = [], this._isLoaded = false;
            this._renderMultiTouchDialog();
            if (this.element.is("ul")) {
                this._createWrapper();
            }
            else {
                this.element.addClass("e-treeview-wrap e-widget").attr("tabindex", 0)
                            .children('ul:first').addClass("e-ul e-box");
                (this.model.width != null) && this.element.width(this.model.width);
                (this.model.height != null) && this.element.height(this.model.height);
                (this.model.enableRTL) && this.element.addClass("e-rtl");
                (this.model.cssClass != null) && this.element.addClass(this.model.cssClass);
                this._addAttr(this.model.htmlAttributes);
            }
            this._elementSettings();
            this._beforeBaseClass();
            if (this.dataSource() == null) {
                this._addBaseClass();
                this._controlRender();
            }
            this._addWholeRowWrap();
            if (this._isIE8)
                (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').addClass("e-ie8") : this.element.addClass("e-ie8");
            this._finalize();
        },

        _completeRendering: function () {
            if (this._treeList.length == 0 && !this._isLoaded) {
                this._finalizeNode();
                this._enabledAction(this.model.enabled);
                this._triggerEvent('ready', { element: this.element[0] });
                this._isLoaded = true;
            }
        },

        _addWholeRowWrap: function () {
            if (this.model.fullRowSelect)
                (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').addClass("e-fullrow-wrap") : this.element.addClass("e-fullrow-wrap");
        },

        _removeWholeRowWrap: function () {
            (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap').removeClass("e-fullrow-wrap") : this.element.removeClass("e-fullrow-wrap");
        },

        _doWholeRowAction: function () {
            if (this.model.fullRowSelect) {
                for (var i = 0, len = this._liList.length; i < len; i++) {
                    var element = $(this._liList[i]);
                    if (element[0] != null) {
                        var txtEle = element.find("> .e-text-wrap");
                        this._renderWholeRow(element, txtEle);
                    }
                }
            }
            else
                this.element.find(".e-fullrow").remove();
        },

        _renderWholeRow: function (element, nestedEle) {
            if (!element) return;
            if (this.model.fullRowSelect) {
                var absolutediv = document.createElement('div');
                absolutediv.setAttribute('class', 'e-fullrow');
                nestedEle ? $(absolutediv).insertAfter(nestedEle) : element[0].appendChild(absolutediv);
            }
        },

        _extendFields: function (mapper, value) {
            if (mapper == null || value == null)
                mapper = value;
            else if (mapper.child == null || value['child'] == null)
                $.extend(mapper, value);
            else {
                this._extendFields(mapper.child, value['child']);
                var tempField = mapper.child;
                $.extend(mapper, value);
                $.extend(mapper.child, tempField);
            }
        },

        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },

        _assignTouchExpandOn: function (expandon) {
            if (expandon == "dblclick")
                this._touchExpandOn = "doubletap";
            else if (expandon == "click")
                this._touchExpandOn = "tap";
            else
                this._touchExpandOn = expandon;
        },

        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-fe-popup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSelection) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            if(!this.element.is("ul")){
			this.element.append(this._customPop);     
			} 
            this._on($content, (this._isDevice && $.isFunction($.fn.tap)) ? "touchstart" : "mousedown", this._popupClick);
        },

        _popupClick: function () {
            var $selElement = this._customPop.find(".e-rowselect");
            if ($selElement.hasClass("e-spanclicked")) {
                this._hidePopup();
            }
            else {
                this._isPopup = true;
                $selElement.addClass("e-spanclicked");
            }
        },

        _hidePopup: function () {
            if (this._customPop != null && this._customPop.is(":visible")) {
                this._customPop.find(".e-rowselect").removeClass("e-spanclicked");
                this._customPop.hide();
                this._isPopup = false;
            }
        },

        _elementSettings: function () {
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
            (this.element.is("ul")) ? ele.attr("role", "tree") : ele.attr("aria-activedescendant", this._id + "_active").attr("role", "tree");
        },

        _beforeBaseClass: function () {
            var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap')[0] : this.element[0];
            this._ulList = $(ele.querySelectorAll('ul'));
            this._liList = $(ele.querySelectorAll('li'));
        },

        _createWrapper: function () {
            var mainWidget = ej.buildTag("div.e-treeview-wrap e-widget " + this.model.cssClass, "", "", { tabindex: 0, "aria-activedescendant": this._id + "_active" });
            (this.model.width != null) && mainWidget.width(this.model.width);
            (this.model.height != null) && mainWidget.height(this.model.height);
            (this.model.enableRTL) && mainWidget.addClass("e-rtl");
            mainWidget.insertAfter(this.element);
            mainWidget.append(this.element.addClass("e-ul e-box").attr("tabindex", 0));
			if(this.element.is("ul")){
				mainWidget.append(this._customPop);
			}
            this._addAttr(this.model.htmlAttributes);
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._enabledAction(false);
                else proxy.element.attr(key, value)
            });
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                var ele = (this.element.is('UL')) ? this.element.parent('.e-treeview-wrap') : this.element;
                ele.removeClass(this.model.cssClass).addClass(skin);
                ele.find('.e-item > div > .e-chkbox-wrap').removeClass(this.model.cssClass).addClass(skin);
                this._waitingPopup && this._waitingPopup.option("cssClass", skin);
            }
        },

        _enabledAction: function (flag) {
            this.model.enabled = flag;
            if (flag) {
                this.element.removeClass("e-disable");
                this._wireEvents();
            }
            else {
                this.element.addClass("e-disable");
                this._unWireEvents();
            }
        },

        _checkDataBinding: function () {
            if (this.dataSource() instanceof ej.DataManager) {
                this._initDataSource();
            } else {
                this._ensureDataSource(this.dataSource());
                this._initialize();
                this._completeRendering();
            }
        },

        _initDataSource: function () {
            this.element.ejWaitingPopup({ cssClass: this.model.cssClass });
            this._waitingPopup = this.element.ejWaitingPopup("instance");
            this._waitingPopup.maindiv.addClass("e-tree-popup");
            var proxy = this, queryPromise, queryManager;
            this.element.ejWaitingPopup("refresh");
            this.element.ejWaitingPopup("show");
            if (this.dataSource().ready != undefined) {
                this.dataSource().ready.done(function (e) {
                    proxy._initAfterDataSource(e);
                });
            } else {
                queryManager = this._columnToSelect(this.model.fields);
                queryPromise = this.dataSource().executeQuery(queryManager);
                queryPromise.done(function (e) {
                    proxy._initAfterDataSource(e);
                });
            }
        },

        _initAfterDataSource: function (e) {
            var proxy = this;
            proxy.element.ejWaitingPopup("hide");
            proxy.retriveData = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
            proxy._typeOfFieldId = proxy.retriveData[0] ? (typeof (ej.getObject(proxy.model.fields.id, proxy.retriveData[0]))).toLowerCase() : "";
            proxy._ensureDataSource(proxy.retriveData);
            proxy._newDataSource = JSON.parse(JSON.stringify(proxy.retriveData));
            proxy._initialize();
            if (!proxy.dataSource().dataSource.offline && (proxy.model.loadOnDemand || !ej.isNullOrUndefined(proxy.model.fields["child"]))) proxy._templateType = 2;
            if (proxy.model.loadOnDemand || ej.isNullOrUndefined(proxy.model.fields["child"])) {
                proxy._completeRendering();
            }
        },

        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (!mapper.query && !ej.isNullOrUndefined(mapper.tableName)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "child" && col !== "dataSource" && mapper[col])
                        column.push(mapper[col]);
                }
                (column.length > 0) && queryManager.select(column);
                if (!this.dataSource().dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else queryManager = (mapper.query) ? mapper.query.clone() : queryManager;
            return queryManager;
        },

        _ensureDataSource: function (dataSource) {
            dataSource = this._getSortAndFilterList(this.model.fields, dataSource);
            this.currentSelectedData = dataSource;
            this._renderTemplate(dataSource);
            (this.element.is("ul")) ? this.element.html(this._fragment.firstChild.children) : this.element.html(this._fragment);
        },

        _getTemplateType: function (ds, mapper) {
            for (var i = 0, len = ds.length; i < len; i++) {
                if (ej.getObject(mapper.parentId, ds[i]) !== undefined || ej.getObject(mapper.hasChild, ds[i]) !== undefined) return 1;
                if (ds[i].hasOwnProperty('child')) return 2;
            }
            return 1;
        },

        _groupingObjects: function (array, f) {
            var childs = {}, keys = [];
            for (var i = 0, len = array.length; i < len; i++) {
                var child = JSON.stringify(f(array[i]));
                childs[child] = childs[child] || [];
                childs[child].push(array[i]);
            }
            for (var i in childs)
                keys.push(childs[i]);
            return keys;
        },

        _renderTemplate: function (item) {
            this._onlineData = false, this._loadOnDemandNodes = false;
            var proxy = this;
            this._templateType = this._getTemplateType(item, this.model.fields);
            this._dataSource = (this._templateType == 1) ? this._groupingObjects(item, function (item) { return [!ej.isNullOrUndefined(item) && [ej.getObject(proxy.model.fields.parentId, item)].toString()]; }) : item;
            this._templateNodeCreation(item, this.model.fields);
        },

        _templateNodeCreation: function (data, mapper) {
            this._fragment = document.createDocumentFragment();
            var ulTag = document.createElement('ul'), fragment;
            this._fragment.appendChild(ulTag);
            fragment = this._fragment.firstChild;
            if (this._onlineData || this._loadOnDemandNodes) {
                fragment.className = "e-treeview-ul";
                fragment.setAttribute('role', "group");
                $(fragment).attr('style', 'display:none');
            }
            if (this.dataSource() != null) {
                for (var i = 0, objlen = data.length; i < objlen; i++) {
                    if (data[i]) {
                        var parentId = ej.getObject(this.model.fields.parentId, data[i]);
                        if (ej.isNullOrUndefined(parentId) || parentId == 0 || this._loadOnDemandNodes)
                            fragment.appendChild(this._genTemplate(data[i], mapper));
                    }
                }
                $(fragment).find('.e-item:first-child:not(:last-child)').addClass('first');
                $(fragment).find('.e-item:last-child').addClass('last');
            }
        },

        _onlineDataSource: function (childItems, id, mapper) {
            this._loadOnDemandNodes = true;
            this._templateNodeCreation(childItems, mapper);
            var element = this.element.find('.e-item#' + id);
            if (element[0] != null) {
                $(element[0]).append(this._fragment);
                element.children().find('> div:first').addClass("e-icon e-plus");
                this._finalizeLoadOnDemand(element);
            }
            this._onlineData = false;
        },

        _genTemplate: function (item, mapper) {
            var liFrag = document.createDocumentFragment(), liEle, liTag, imgTag, aTag, childItems;
            liTag = document.createElement('li');
            liFrag.appendChild(liTag);
            liEle = liFrag.firstChild;
            liEle.id = ej.getObject(mapper.id, item);
            if (!liEle.id)
                liEle.id = "";
            liEle.setAttribute('role', "treeitem");
            var htmlAttribute = ej.getObject(mapper.htmlAttribute, item);
            (htmlAttribute) && this._setAttributes(htmlAttribute, liEle);
            liEle.className += ' e-item';
            aTag = document.createElement('a');
            var imageURL = ej.getObject(mapper.imageUrl, item);
            var spriteCssClass = ej.getObject(mapper.spriteCssClass, item);
            if (imageURL) {
                imgTag = document.createElement('img');
                imgTag.className = "e-align";
                imgTag.src = imageURL;
                var imageAttribute = ej.getObject(mapper.imageAttribute, item);
                (imageAttribute) && this._setAttributes(imageAttribute, imgTag);
            }
            else if (spriteCssClass) {
                imgTag = document.createElement('span');
                imgTag.className = spriteCssClass;
            }
            if (this.model.template) {
                (imgTag) && aTag.appendChild(imgTag);
                if (typeof $.fn.render != "function") throw "Error : JsRender dependecy script missing";
                aTag.innerHTML += this._renderEjTemplate(this.model.template, item);
            }
            else {
                var mapperText = ej.getObject(mapper.text, item);
                (mapperText) ? $(aTag).text(mapperText) : $(aTag).text("undefined");
                (imgTag) && aTag.insertBefore(imgTag, aTag.lastChild);
            }
            var linkAttribute = ej.getObject(mapper.linkAttribute, item);
            (linkAttribute) && (typeof linkAttribute == "object" ? this._setAttributes(linkAttribute, aTag) : aTag.href = linkAttribute);
            liEle.appendChild(aTag);
            (ej.getObject(mapper.expanded, item)) && (liEle.className += ' expanded');
            (ej.getObject(mapper.selected, item)) && (liEle.className += ' selected');
            var isChecked = ej.getObject(mapper.isChecked, item);
            if (!ej.isNullOrUndefined(isChecked))
                liEle.className += (isChecked) ? ' checked' : ' unchecked';
            liEle.setAttribute('aria-selected', false);
            liEle.setAttribute('aria-expanded', false);
            if (this.dataSource() instanceof ej.DataManager) {
                this._updateElement(liEle, true);
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                if (!this.model.loadOnDemand) {
                    if (!ej.isNullOrUndefined(mapper["child"]) && mapper["child"]["dataSource"] instanceof ej.DataManager) {
                        var proxy = this, queryPromise, pid, id;
                        pid = (mapper["child"]["parentId"]) ? mapper["child"]["parentId"] : proxy.model.fields.parentId, id;
                        id = (mapper.id) ? mapper.id : this.model.fields.id;
                        this._treeList.push("false");
                        var itemID = ej.getObject(id, item);
                        queryPromise = this._executeDataQuery(mapper["child"], pid, (this._typeOfFieldId == "number" ? parseInt(itemID) : itemID));
                        queryPromise.done(function (e) {
                            proxy._treeList.pop();
                            childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                            childItems = proxy._getSortAndFilterList(mapper.child, childItems);
                            if (childItems && childItems.length > 0) {
                                proxy._onlineData = true;
                                var parentID = childItems[0][mapper["child"]["parentId"]];
                                proxy._updateRemoteData(proxy._newDataSource, parentID, childItems, proxy.model.fields);
                                proxy._onlineDataSource(childItems, parentID, mapper.child);
                            }
                            if (proxy._treeList.length == 0) {
                                proxy._completeRendering();
                            }
                        });
                    } else if (ej.isNullOrUndefined(this.model.fields["child"])) {
                        this._childNodeCreation(item, liEle, mapper);
                    }
                }
                else {
                    if (ej.getObject(mapper.hasChild, item) || item.hasOwnProperty('child'))
                        liEle.children[0].firstChild.className = "e-icon e-plus";
                }
            }
            else if (this.model.loadOnDemand) {
                this._updateElement(liEle, true);
                if (ej.getObject(mapper.hasChild, item) || item.hasOwnProperty('child'))
                    liEle.children[0].firstChild.className = "e-icon e-plus";
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                (ej.getObject(mapper.expanded, item)) && this._childNodeCreation(item, liEle, mapper);
                if (this.model.enablePersistence) {
                    var value, childObj;
                    value = this._getCookies("_childNodes");
                    if (value) {
                        childObj = JSON.parse(value);
                        for (var i = 0, objlen = childObj.length; i < objlen; i++) {
                            if (childObj[i].toString() == ej.getObject(mapper.id, item).toString()) {
                                this._childNodeCreation(item, liEle, mapper);
                                break;
                            }
                        }
                    }
                }
            }
            else if (!this._onlineData) {
                this._updateElement(liEle, true);
                this.model.showCheckbox && this._checkboxOnTemplate(liEle.children[0]);
                this._childNodeCreation(item, liEle, mapper);
            }
            return liEle;
        },

        _childNodeCreation: function (item, liEle, mapper) {
            var childItems, tempFrag, ul, tFrag;
            childItems = (this._templateType == 2) ? (!ej.isNullOrUndefined(item.child) && item.child.length > 0) && item.child : this._getChildNodes(this._dataSource, { id: ej.getObject(mapper.id, item) });
            if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                liEle.children[0].firstChild.className = "e-icon e-plus";
                tempFrag = document.createDocumentFragment();
                ul = document.createElement('ul');
                tempFrag.appendChild(ul);
                tFrag = tempFrag.firstChild;
                tFrag.className = "e-treeview-ul";
                tFrag.setAttribute('role', "group");
                $(tFrag).attr('style', 'display:none');
                for (var i = 0, objlen = childItems.length; i < objlen; i++)
                    (childItems[i]) && (ej.getObject(this.model.fields.parentId, [childItems[i]]) != 0) && tFrag.appendChild(this._genTemplate(childItems[i], mapper));
                liEle.appendChild(ul);
            }
        },

        _checkboxOnTemplate: function (element) {
            if (element.parentElement.id == "") {
                element.parentElement.id = this._id + "_" + this._indexID;
                this._indexID++;
            }
            var checkbox = document.createElement('input');
            checkbox.setAttribute('type', 'checkbox');
            checkbox.setAttribute('class', 'nodecheckbox');
            checkbox.setAttribute('name', this._id + "_Checkbox_" + element.parentElement.id);
            checkbox.setAttribute('value', element.parentElement.id);
            element.insertBefore(checkbox, element.children[1]);   // Checkbox to be inserted after the expand/collapse div            
        },

        _updateElement: function (liElement, subItem) {
            var outerdiv, exCollpasediv, linkElement, spanTag, node = liElement.firstChild, firstchild, nodeText, nText,textElement;
            if (node) {
                firstchild = node.nodeName;
                if (firstchild == 'SPAN' || firstchild == 'IMG') {
                    spanTag = node;
                    linkElement = liElement.lastChild;
                }
                else
                    linkElement = liElement.lastChild;
                if (linkElement) {
                    nText = (linkElement.lastChild != null) ? linkElement.lastChild.nodeValue : "";
                    nodeText = $.trim(linkElement.innerHTML);
                    textElement = $(linkElement).clone()[0];
                    $(linkElement).remove();
                    textElement.className += " e-text CanSelect";
                    textElement.innerHTML = nodeText;
                    liElement.innerHTML = '';
                }

                outerdiv = document.createElement('div');
                outerdiv.setAttribute('class', 'e-text-wrap');
                outerdiv.setAttribute('role', "presentation");
                if (subItem) {
                    exCollpasediv = document.createElement('div');
                    exCollpasediv.setAttribute('role', "presentation");
                    outerdiv.appendChild(exCollpasediv);
                }
                (spanTag) && outerdiv.appendChild(spanTag);
                outerdiv.appendChild(textElement);
                ($(liElement).prop('name') == undefined) && $(liElement).prop('name', $.trim(nText));
                liElement.appendChild(outerdiv);
                this._renderWholeRow($(liElement));
            }
        },

        _setAttributes: function (data, element) {
            for (var key in data) {
                $(element).attr(key, data[key]);
            }
        },

        _addDragableClass: function () {
            if (this.model.allowDragAndDrop) {
                this._anchors = this._liList.map(function () {
                    return $("a.e-text", this)[0];
                });
                this._anchors.addClass("e-draggable e-droppable");
                this._enableDragDrop();
                this._on(this.element, "mouseup touchstart pointerdown MSPointerDown", this._anchors, this._focusElement);
            }
        },

        _addBaseClass: function () {
            this._ulList.addClass("e-treeview-ul").attr("role", "group");
            this._liList.addClass("e-item").attr("role", "treeitem");
            if (!this.element.is("ul"))
                this.element.find("ul:first").removeClass("e-treeview-ul").addClass('e-ul');
        },

        _controlRender: function () {
            var element = this.element, licoll;
            if (element != null) {
                licoll = element.find('.e-item');
                for (var i = 0; i < licoll.length; i++) {
                    var listEl = $(licoll[i]), textElement, customElement, nodeText, subItems, linkElement, span, exCollpasediv, outerdiv;
                    subItems = listEl.children('ul')[0];
                    if (subItems)
                        $(listEl.children('ul')[0]).remove();
                    linkElement = listEl.children('a')[0];
                    if (linkElement) {
                        nodeText = $.trim($(linkElement).text());
                        textElement = $(linkElement).clone();
                        $(linkElement).remove();
                        customElement = listEl.clone();
                        $(textElement).prepend(customElement.children());
                        $(textElement).addClass('e-text CanSelect');
                        listEl.html('');
                    }
                    else {
                        nodeText = $.trim(this._getText(listEl));
                        customElement = listEl.clone();
                        listEl.html('');
                        textElement = ej.buildTag("a.e-text CanSelect", "", "", "");
                        textElement.append(customElement.children());
                        textElement[0].innerHTML += nodeText;
                    }
                    exCollpasediv = ej.buildTag('div', "", {}, { role: "presentation" });
                    outerdiv = ej.buildTag('div.e-text-wrap', "", {}, { role: "presentation" });
                    $(outerdiv).append(exCollpasediv).append(textElement);
                    listEl.prepend(outerdiv);
                    this._renderWholeRow(listEl);
                    if (subItems)
                        listEl.append(subItems);
                    (listEl.prop('name') == undefined) && listEl.prop('name', nodeText);
                    (this.model.showCheckbox) && this._checkboxOnTemplate(licoll[i].children[0]);
                }
                if (this.model.showCheckbox)
                    element.find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            }
            var liCollection = element.find('.e-item'), acollection;
            liCollection.find('>ul').hide();
            acollection = liCollection.find('.e-text');
            acollection.focus(function () {
                $(this).blur();
            });
            liCollection.filter('.e-item:last-child').addClass('last');
            $(liCollection[0]).addClass('first');
            if ($(liCollection[0]).hasClass('first') && $(liCollection[0]).hasClass('last'))
                $(liCollection[0]).removeClass('first');
            $(liCollection.filter(':has(ul)')).each(function () {
                $(this).attr("aria-expanded", false).attr("aria-selected", false)
                var liHasul = $(this).children('ul:first');
                if ($(liHasul).is(':hidden')) {
                    $(this).find('> div > div:first').removeClass('e-icon e-minus').addClass('e-icon e-plus');
                }
                else {
                    $(this.childNodes[1]).removeClass('e-icon e-plus').addClass('e-icon e-minus');
                }
            });
        },

        _getText: function (element) {
            return $(element)
                      .clone()
                      .children()
                      .remove()
                      .end()
                      .text();
        },

        _expandNodes: function (indexColl, _isIdBase) {
            var len = indexColl.length, element = [], temp;
            for (var i = 0; i < len; i++) {
                element = _isIdBase ? this._getNodeByID(indexColl[i]) : $(this._liList[indexColl[i]]);
                if (ej.isNullOrUndefined(element)) continue;
                if (!this.model.enableMultipleExpand) {
                    var distinctEle = element.siblings().find(">div>.e-minus").closest(".e-item");
                    if (distinctEle.length > 0) continue;
                }
                if (this.isExpanded(element)) continue;
                if (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager))
                    this._createChildNodesWhenExpand(element);
                else
                    this._expandNode(element);
            }
        },

        _checkedNodes: function (indexColl) {
            var node;
            if (indexColl.length > 0) this._removeField(this._newDataSource, this.model.fields, "isChecked");
            for (var j = 0, len = indexColl.length; j < len; j++) {
                node = $(this._liList[indexColl[j]]);
                (node[0] != null) && this._nodeCheck(node.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        _finalize: function () {
            if (this.model.showCheckbox)
                this.element.find('.e-item > div .nodecheckbox').ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            this.model.allowEditing && this._allowEditable();
        },

        _finalizeNode: function () {
            this._isRender = false;
            this._allowOnDemand = true;
            var thisElement = this.element, cookieData = this._getCookies("_persistedValues"), idColl = [], id = 0, element = [], expandList, parsedData, temp;
            if (!(this.model.expandedNodes instanceof Array && this.model.expandedNodes.length > 0)) {
                expandList = thisElement.find("li.expanded"), len = expandList.length;
                for (var i = 0; i < len; i++) {
                    var expandEle = $(expandList[i]);
                    if (!this.model.enableMultipleExpand) {
                        var distinctEle = expandEle.siblings().find(">div>.e-minus").closest(".e-item");
                        if (distinctEle.length > 0) continue;
                    }
                    this._expandNode(expandEle);
                }
            }
            if (cookieData)
                parsedData = JSON.parse(cookieData), idColl = parsedData.expandedNodes, element = [];
            if (idColl && idColl.length > 0 && !ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                for (var i = 0, len = idColl.length; i < len; i++) {
                    element = this.element.find('.e-item#' + idColl[i]);
                    if (element[0] != null) {
                        if (!this.model.enableMultipleExpand) {
                            var distinctEle = element.siblings().find(">div>.e-minus").closest(".e-item");
                            if (distinctEle.length > 0) continue;
                        }
                        if (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager))
                            this._createChildNodesWhenExpand(element);
                        else
                            this._expandNode(element);
                    }
                }
            } else {
                temp = JSON.parse(JSON.stringify(this.model.expandedNodes));
                this._expandNodes(temp);
            }
            if (this.model.showCheckbox) {
                if (cookieData)
                    parsedData = JSON.parse(cookieData), idColl = parsedData.checkedNodes, element = [];
                if (idColl && idColl.length > 0 && !ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                    this._removeField(this._newDataSource, this.model.fields, "isChecked");
                    for (var i = 0, len = idColl.length; i < len; i++) {
                        element = this.element.find('.e-item#' + idColl[i]);
                        if (element[0] != null)
                            this._nodeCheck(element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                    }
                } else {
                    temp = JSON.parse(JSON.stringify(this.model.checkedNodes));
                    this._checkedNodes(temp);
                }
            }
            if (!(this.model.checkedNodes instanceof Array && this.model.checkedNodes.length > 0))
                this.model.showCheckbox && this._isCheckedAction();
            var _isIdBase = false;
            if (cookieData) {
                parsedData = JSON.parse(cookieData), idColl = parsedData.selectedNodes;
                _isIdBase = true;
            }
            if (!cookieData || (idColl && idColl.length == 0)) {
                idColl = this.model.selectedNodes.length > 0 ? this.model.selectedNodes : (this.model.selectedNode == -1 ? [] : [this.model.selectedNode]);
                _isIdBase = false;
            }
            var data = { ctrlKey: true };
            if (idColl && idColl.length > 0)
                this._doSelectNodes(idColl, _isIdBase);
            else
                this._isSelectedAction(data);
            this._isRender = true;
            this._allowOnDemand = false;
            thisElement.find('.e-item.checked, .e-item.expanded, .e-item.selected').removeClass("checked expanded selected");
        },

        _doSelectNodes: function (idColl, _isIdBase) {
            var data = { ctrlKey: true };
            for (var i = 0, len = idColl.length; i < len; i++) {
                var element = _isIdBase ? this._getNodeByID(idColl[i]) : $(this._liList[idColl[i]]);
                if (element[0] != null)
                    this._nodeSelectionAction(element, data);
                if (!this.model.allowMultiSelection) break;
            }
        },

        _doUnselectNodes: function (idColl) {
            for (var i = 0, len = idColl.length; i < len; i++) {
                var element = this._getNodeByID(idColl[i]);
                if (element[0] != null)
                    this._nodeUnSelectionAction(element);
                if (!this.model.allowMultiSelection) break;
            }
        },

        _updateSelectedNode: function () {
            var node = $(this._liList).find('.e-text.e-active').closest('.e-item'), element = [];
            this.model.selectedNodes = [];
            if (!this.model.allowMultiSelection) this.model.selectedNode = null;
            if (node[0] == undefined || node.length <= 0) {
                this._persistValues(this.model.selectedNodes, "selectedNodes");
                return;
            }
            if (!this.model.allowMultiSelection) {
                this._isRender = false;
                this._nodeSelectionAction($(node[0]));
                this._isRender = true;
            }
            else {
                for (var i = 0, len = node.length; i < len; i++) {
                    var index = $(this._liList).index(node[i]);
                    this.model.selectedNodes.push(index);
                }
                this._persistValues(this.model.selectedNodes, "selectedNodes");
            }
        },

        _setCookies: function (name, value) {
            if (window.localStorage)
                window.localStorage.setItem(this._id + name, value);
            else if (document.cookie)
                ej.cookie.set(this._id + name, value);
        },

        _getCookies: function (name) {
            if (window.localStorage)
                return window.localStorage.getItem(this._id + name);
            else if (window.cookie)
                return ej.cookie.get(this._id + name);
        },

        _updateCheckedNodes: function () {
            var checkedList, chkdNodes = [];
            checkedList = this.element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox.checked').closest('.e-item');
            for (var chk = 0; chk < checkedList.length; chk++)
                chkdNodes.push($(this._liList).index(checkedList[chk]));
            (chkdNodes.length > 0 || checkedList.length == 0) && (this.model.checkedNodes = chkdNodes);
            (checkedList.length == 0) && this.model.checkedNodes.push(-1);
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _updateExpandedNodes: function () {
            var expandedEle, expndedNodes = [];
            expandedEle = this.element.find('.e-item > div > .e-minus').closest('.e-item').addClass('e-collapse');
            for (var i = 0, objlen = expandedEle.length; i < objlen; i++)
                expndedNodes.push($(this._liList).index(expandedEle[i]));
            (expndedNodes.length > 0 || expandedEle.length == 0) && (this.model.expandedNodes = expndedNodes);
            (expandedEle.length == 0) && this.model.expandedNodes.push(-1);
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _isCheckedAction: function () {
            var chk, checkedList = this.element.find('.e-item.checked');
            for (var chk = 0; chk < checkedList.length; chk++) {
                var _childItems = $(checkedList[chk]).find('.e-item');
                var _uncheckedItems = $(checkedList[chk]).find('.e-item.unchecked');
                if (_childItems.length == 0 || !(_childItems.length > 0 && _uncheckedItems.length == _childItems.length) || !this.model.autoCheck) {
                    this._nodeCheck($(checkedList[chk]).find("> div > .e-chkbox-wrap > input.nodecheckbox:first")[0]);
                    for (var i = 0; i < _uncheckedItems.length; i++)
                        this._nodeUncheck($(_uncheckedItems[i]).find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                }
            }
            this.element.find('.e-item.checked, .e-item.unchecked').removeClass("checked unchecked");
        },

        _isExpandedAction: function (event) {
            var expandList = this.element.find("li.expanded"), len = expandList.length;
            for (var i = 0; i < len; i++) {
                var expandEle = $(expandList[i]);
                if (!this.model.enableMultipleExpand) {
                    var distinctEle = expandEle.siblings().find(" > div > .e-minus").closest(".e-item");
                    if (distinctEle.length > 0) continue;
                }
                this._expandNode(expandEle);
            }
            this.element.find('.e-item.expanded').removeClass("expanded");
        },

        _isSelectedAction: function (event) {
            var snode = this.element.find('.e-item.selected');
            for (var i = 0, len = snode.length; i < len; i++) {
                if (snode[i] != null)
                    this._nodeSelectionAction($(snode[i]), event);
                if (!this.model.allowMultiSelection) break;
            }
            this.element.find('.e-item.selected').removeClass("selected");
        },

        _checkedChange: function (args) {
            if (!args.isInteraction) return;
            var treeview = this.element.closest(".e-treeview.e-js").data("ejTreeView");
            var action = (args.isChecked) ? "_nodeCheck" : "_nodeUncheck";
            treeview[action]($(this.element)[0], args);
        },

        _doClickAnimation: function (event) {
            var element = $(event.target);
            if (element == undefined || event.type == undefined) return;
            element.addClass("e-animate");
            if (element.is('A') && element.hasClass('e-text')) element.closest(".e-text-wrap").addClass("e-animate");
        },

        _ClickEventHandler: function (event) {
            var proxy = this, parentLi, element = $(event.target), divTag = element.closest('.e-item').find("> div > div:first");
            this._isPopup = false;
            if (divTag && !divTag.hasClass("e-process")) {
                parentLi = element.closest('.e-item');
                if (!parentLi.hasClass('e-node-disable')) {
                    this.element.find(".e-animate").removeClass("e-animate");
                    this._doClickAnimation(event);
                    var _id = (parentLi[0] != null) ? parentLi[0].getAttribute('id') : "";
                    this._triggerEvent('nodeClick', { event: event, currentElement: element[0], id: _id, parentId: parentLi.closest('ul').closest('.e-item').attr('id') });
                    if (!ej.isNullOrUndefined(element) && element.is('DIV')) {
                        if (element.hasClass('e-plus') || element.hasClass('e-minus')) {
                            var expandUl = null, args, nodeDetails, isChildLoaded;
                            if (element.is('SPAN'))
                                element = element.parent('div').find('div:first');
                            expandUl = parentLi.children('ul:first');
                            isChildLoaded = this.isChildLoaded(parentLi);
                            if (!isChildLoaded && this.model.loadOnDemand) {
                                element.removeClass('e-plus').addClass("e-load");
                                this._checkboxChecked = element.parent().find('.nodecheckbox').hasClass('checked');
                                nodeDetails = this._getNodeDetails(parentLi);
                                args = { currentElement: parentLi, targetElement: element[0], id: nodeDetails.id, value: nodeDetails.text, parentId: nodeDetails.parentId, isChildLoaded: isChildLoaded, hasParent: true, async: true };
                                this._isEventTriggered = true;
                                if(this._triggerEvent('beforeExpand', args)) {
                                    return false;
                                }
                                this._loadOnDemand(args, element[0]);
                            }
                            else
                                (element.hasClass('e-plus')) ? this._expandNode(parentLi) : this._collapseNode(parentLi);
                        }
                        else if (this.model.fullRowSelect && (element.hasClass("e-fullrow") || element.hasClass("e-text-wrap"))) {
                            element = element.closest('.e-item').find("> .e-text-wrap .e-text");
                        }
                    }
                    (!element.is('A') && !element.hasClass('input-text')) && (element = element.closest('.e-text'));
                    if (!ej.isNullOrUndefined(element) && element.is('A') && element.hasClass('CanSelect')) {
                        if (event && event["pointerType"] == "touch" && this._customPop != null && this.model.allowMultiSelection) {
                            var $target = $(event.target);
                            if (!this._customPop.is(":visible"))
                                this._customPop.show();
                            if (this._customPop.is(":visible") && !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) {
                                var offset = $target.offset();
                                this._customPop.offset({ left: offset.left, top: offset.top - 40 });
                            }
                            else
                                event.ctrlKey = true;
                        }
                        else
                            this._hidePopup();
                        element.hasClass('e-active') ? (this.model.allowMultiSelection && this._nodeUnSelectionAction(element.closest('.e-item'), event)) : this._nodeSelectionAction(element.closest('.e-item'), event);
                    }
                }
            }
        },

        _getChildTables: function (mapper, parentLen, currentLen) {
            if (!ej.isNullOrUndefined(mapper.child))
                return (parentLen == currentLen) ? mapper.child : this._getChildTables(mapper.child, parentLen, currentLen + 1);
        },

        _loadOnDemand: function (args) {
            var childItems, parent, mapper, proxy = this, queryPromise;
            if (this.dataSource() instanceof ej.DataManager) {
                parent = args.currentElement.parents('ul').length;
                mapper = this._getChildTables(proxy.model.fields, parent, 1);
                if (ej.isNullOrUndefined(mapper) && ej.isNullOrUndefined(this.model.fields["child"]))
                    mapper = this.model.fields;
                if (!mapper) {
                    $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                    return;
                }
                queryPromise = this._executeDataQuery(mapper, mapper["parentId"], (this._typeOfFieldId == "number" ? parseInt(args.currentElement[0].id) : args.currentElement[0].id));
                queryPromise.done(function (e) {
                    childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                    childItems = proxy._getSortAndFilterList(mapper, childItems);
                    if (childItems.length > 0) {
                        proxy._onlineData = true;
                        var parentID = ej.getObject(mapper["parentId"], childItems[0]);
                        proxy._updateRemoteData(proxy._newDataSource, parentID, childItems, proxy.model.fields);
                        proxy._loadChildNodeWhenOnDemand(childItems, args, mapper);
                    } else
                        $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                });
            }
            else {
                childItems = this._getChildNodes(this._dataSource, args);
                if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                    setTimeout(function () {
                        proxy._createSubNodesWhenLoadOnDemand(childItems, args.targetElement, proxy.model.fields);
                    }, 400);
                }
                else
                    $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
            }
        },

        _loadChildNodeWhenOnDemand: function (childItems, args, mapper) {
            var proxy = this;
            !ej.isNullOrUndefined(childItems) && childItems.length > 0 && setTimeout(function () {
                proxy._createSubNodesWhenLoadOnDemand(childItems, args.targetElement, mapper);
            }, 100);
        },

        _createSubNodesWhenLoadOnDemand: function (childItems, element, mapper) {
            this._loadOnDemandNodes = true;
            this._templateNodeCreation(childItems, mapper);
            $(this._fragment.firstChild).attr('style', 'display:none');
            this._fragment.firstChild.className = "e-treeview-ul";
            this._fragment.firstChild.setAttribute('role', "group");
            element.parentNode.parentNode.appendChild(this._fragment);
            var liElement = $(element).closest('.e-item');
            liElement.attr({ 'aria-expanded': false, 'aria-expanded': true });
            $(element).removeClass("e-load").addClass('e-plus');
            this._expandNode(liElement);
            this._finalizeLoadOnDemand(liElement);
        },

        _finalizeLoadOnDemand: function (element) {
            this._beforeBaseClass();
            this._isRender = false;
            if (this.model.showCheckbox) {
                element.children('ul').find('li > div > input.nodecheckbox').ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
                var _childItems = element.children('ul').find('.e-item');
                var _uncheckedItems = element.children('ul').find('.e-item.unchecked');
                if (_uncheckedItems.length >= 0 && _uncheckedItems.length != _childItems.length && this._checkboxChecked)
                    _childItems.not(".unchecked").addClass('checked');
                else if (_uncheckedItems.length == _childItems.length && this.isNodeChecked(element))
                    this._nodeUncheck(element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                if (this._isLoaded) {
                    this._isCheckedAction();
                    this._updateCheckedNodes();
                }
            }
            this._isRender = true;
            this._addDragableClass();
            this._preventEditable();
            this.model.allowEditing && this._allowEditable();
            if (this._isLoaded) {
                this._isSelectedAction();
                this._updateSelectedNode();
                this._allowOnDemand = true;
                this._isExpandedAction();
                this._updateExpandedNodes();
                this._allowOnDemand = false;
            }
            if (this.model.loadOnDemand && this.model.enablePersistence && !(this.dataSource() instanceof ej.DataManager)) {
                var obj, value = this._getCookies("_childNodes");
                if (value) obj = JSON.parse(value);
                (!ej.isNullOrUndefined(obj) && obj.indexOf(element[0].id) == -1) ? obj.push(element[0].id) : obj = [element[0].id];
                this._setCookies("_childNodes", JSON.stringify(obj));
            }
        },

        _getChildNodes: function (obj, rootNodes) {
            var childNodes = [];
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    var parentId = ej.getObject(this.model.fields.parentId, obj[i][0]);
                    if (!ej.isNullOrUndefined(obj[i][0]) && !ej.isNullOrUndefined(parentId) && parentId != 0 && parentId == rootNodes.id)
                        return obj[i];
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (ej.getObject(this.model.fields.id, obj[i]) == rootNodes.id && ej.getObject(this.model.fields.parentId, obj[i]) != 0)
                        return obj[i].child;
                    if (obj[i].hasOwnProperty('child')) {
                        childNodes = this._getChildNodes(obj[i].child, rootNodes);
                        if (!ej.isNullOrUndefined(childNodes) && childNodes.length > 0)
                            break;
                    }
                }
                return childNodes;
            }
        },

        _getPath: function (element) {
            var path = element.prop('name'), liEle;
            var liEle = element.parents('.e-item:first');
            while (liEle[0] != null && liEle[0].parentNode.id != this._id) {
                path = liEle.prop('name') + '/' + path;
                liEle = liEle.parents('.e-item:first');
            }
            path = this._id + "/" + path;
            return path;
        },

        _nodeSelectionAction: function (liElement, event) {
            if (liElement[0] == null && liElement.length == 0) return;
            var nodeDetails, data, angElement = $(liElement.find('> div > .e-text')[0]), _isSelected = false, _oldSelectedNodes = this.model.selectedNodes.slice();
            var index = this._liList.index(liElement[0]);
            this._currNode = liElement;
            if (this._triggerEvent('beforeSelect', { target: liElement, nodeDetails: this._getNodeDetails(liElement) })) return;
            if (!this.model.allowMultiSelection || !event || (event && !event.ctrlKey)) {
                this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active');
                this.element.find('[aria-selected=true]').attr("aria-selected", false);
                this.element.find('.e-li-active').removeClass('e-li-active');
                if (this.model.fullRowSelect) {
                    this.element.find('.e-li-focus').removeClass('e-li-focus');
                    this.element.find('.e-node-focus').removeClass('e-node-focus');
                }
                this.element.find("#" + this._id + "_active").removeAttr("id");
                this.model.selectedNodes = [];
                this._deepWatch && this._removeField(this._newDataSource, this.model.fields, "selected");
            }
            if (this.model.allowMultiSelection && event && event.shiftKey) {
                if (!this._startNode)
                    this._startNode = this._currNode;
                var nodes = this.getVisibleNodes();
                var startIndex = nodes.index(this._startNode);
                var endIndex = nodes.index(liElement[0]);
                if (startIndex > endIndex) {
                    var temp = startIndex;
                    startIndex = endIndex;
                    endIndex = temp;
                }
                for (var i = startIndex ; i <= endIndex; i++) {
                    var _currLi = $(nodes.get(i));
                    var _currIndex = this._liList.index(_currLi[0]);
                    if ($.inArray(_currIndex, this.model.selectedNodes) == -1) {
                        this.model.selectedNodes.push(_currIndex);
                        var _currAng = _currLi.find('> div > a.e-text');
                        _currAng.removeClass('e-node-focus');
                        _currLi.attr("aria-selected", true);
                        _currLi.addClass('e-li-active');
                        _currAng.addClass('e-active');
                        _isSelected = true;
                        this._deepWatch && this._updateField(this._newDataSource, _currLi.attr('id'), this.model.fields, "selected", true);
                    }
                }
            }
            else
                this._startNode = liElement;
            if (!this.model.allowMultiSelection) this.model.selectedNode = index;
            if (!_isSelected) {
                this.element.find('a.e-text.e-node-focus').removeClass('e-node-focus');
                liElement.attr("aria-selected", true);
                liElement.addClass('e-li-active');
                angElement.addClass('e-active');
                if (!this.model.allowMultiSelection) angElement.attr("id", this._id + "_active");
                if ($.inArray(index, this.model.selectedNodes) == -1)
                    this.model.selectedNodes.push(index);
                this._deepWatch && this._updateField(this._newDataSource, liElement.attr('id'), this.model.fields, "selected", true);
            }
            if (this.model.enablePersistence)
                this._persistValues(this.model.selectedNodes, "selectedNodes");
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
                this.dataSource(this._newDataSource);
            }
            this._triggerGivenEvent('nodeSelect', liElement);
        },

        _nodeUnSelectionAction: function (liElement, event) {
            if (this.model.allowMultiSelection && event && !event.ctrlKey) {
                this._nodeSelectionAction(liElement, event);
                return;
            }
            liElement.removeClass('e-li-active');
            liElement.attr("aria-selected", false).find('> div > .e-text').removeClass('e-active').attr("id", "");
            this._updateUnselectModel(liElement[0]);
            if (this._deepWatch) {
                this._updateField(this._newDataSource, liElement.attr('id'), this.model.fields, "selected", false);
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
                this.dataSource(this._newDataSource);
            }
            this._triggerGivenEvent('nodeUnselect', liElement);
        },

        _updateUnselectModel: function (liElement) {
            var index = this._liList.index(liElement), _nodes = this.model.selectedNodes;
            if (!this.model.allowMultiSelection) this.model.selectedNode = null;
            var arrIndex = $.inArray(index, _nodes);
            if (arrIndex > -1) {
                this.model.selectedNodes.splice(arrIndex, 1);
            }
            this._persistValues(this.model.selectedNodes, "selectedNodes");
        },

        _triggerGivenEvent: function (event, element) {
            if (this._isRender) {
                var data = { currentElement: element, value: element.find('> div > a.e-text').eq(0).text(), id: element[0].getAttribute('id'), parentId: element.closest('ul').closest('.e-item').attr('id'), selectedNodes: this.model.selectedNodes };
                this._triggerEvent(event, data);
            }
        },

        _getNodesIndex: function (cnodes) {
            var cindex = [];
            for (var i = 0, len = cnodes.length; i < len; i++)
                cindex.push(this._liList.index(cnodes[i]));
            return cindex;
        },

        _nodeEnableAction: function (liElement) {
            var parent = this.getParent(liElement);
            if (parent[0] != null && parent.hasClass('e-node-disable')) return;
            if (this.model.showCheckbox)
                liElement.find('div > .e-chkbox-wrap > .nodecheckbox').ejCheckBox('enable').prop('disabled', false);
            liElement.find('.e-text').removeClass('e-node-disable')
                     .closest('.e-item')
                     .removeClass('e-node-disable')
                     .removeProp("disabled");
        },

        _nodeDisableAction: function (liElement) {
            this._collapseNode(liElement);
            if (this.model.showCheckbox)
                liElement.find('div > .e-chkbox-wrap > .nodecheckbox').ejCheckBox('disable').prop('disabled', true);
            var snodes = liElement.find(".e-text.e-active").closest(".e-item");
            liElement.find('.e-text').addClass('e-node-disable')
                     .removeClass('e-active')
                     .attr("id", "")
                     .closest('.e-item')
                     .addClass('e-node-disable')
                     .prop('disabled', true);
            for (var i = 0, len = snodes.length; i < len; i++)
                this._updateUnselectModel(snodes[i]);
        },

        _getNodeDetails: function (liElement) {
            if (liElement[0] != null && liElement.is('LI') && liElement.hasClass('e-item')) {
                var id, text, pid, level, childs, expanded, checked, selected, index;
                id = liElement[0].getAttribute('id');
                text = liElement.children('div').find('.e-text:first').text();
                pid = liElement.closest('ul').closest('.e-item').attr('id');
                level = liElement.parents('ul').length;
                childs = liElement.find('.e-item').length;
                expanded = this._isNodeExpanded(liElement);
                checked = this._isChecked(liElement);
                selected = liElement.find('> div > .e-text').hasClass('e-active');
                index = this._liList.index(liElement);
                return { id: id, text: text, parentId: (pid) ? pid : "", level: level, count: childs, expanded: expanded, checked: checked, selected: selected, index: index };
            } else {
                return { id: "", text: "", parentId: "", level: "", count: "", expanded: "", checked: "", selected: "", index: "" };
            }
        },

        _denyMultipleExpand: function (liElement) {
            var distinctEle = liElement.siblings().find(">div>.e-minus").closest(".e-item");
            for (var i = 0, len = distinctEle.length; i < len; i++) {
                this._collapseNode($(distinctEle[i]));
            }
        },

        _expandCollapseAction: function (element) {
            if (element && !element.hasClass("e-process")) {
                var expandUl, proxy = this, parentLi, nodeDetails, data, isChildLoaded;
                parentLi = element.closest('.e-item');
                if (element.is('SPAN'))
                    element = $(element).parent('div').find('div:first');
                expandUl = parentLi.children('ul:first');
                if (expandUl.find('> .e-item').length > 0) {
                    this.model.enableAnimation && element.addClass("e-process");
                    nodeDetails = this._getNodeDetails(parentLi);
                    isChildLoaded = this.isChildLoaded(parentLi);
                    data = { currentElement: parentLi, value: nodeDetails.text, isChildLoaded: isChildLoaded, id: nodeDetails.id, parentId: nodeDetails.parentId, async: false };
                    if (!this._isNodeExpanded(parentLi) && isChildLoaded) {
                        if (!this._isEventTriggered)
                            if (this._triggerEvent('beforeExpand', data)) return false;
                        this._isEventTriggered = false;
                        parentLi.attr("aria-expanded", true);
                        this._addExpandedNodes(this._liList.index(parentLi));
                        $(element).removeClass('e-icon e-plus').addClass('e-icon e-minus');
                        parentLi.addClass('e-collapse');
                        this._deepWatch && this._updateField(this._newDataSource, nodeDetails.id, this.model.fields, "expanded", true);
                        this._doAnimation(expandUl, element, "nodeExpand", data, 350);
                    }
                    else {
                        this.element.find(".e-material-animate").removeClass("e-material-animate");
                        parentLi.attr("aria-expanded", false);
                        if (this._triggerEvent('beforeCollapse', data) === true)
                            return false;
                        this._removeExpandedNodes(this._liList.index(data.currentElement));
                        $(element).removeClass('e-icon e-minus').addClass('e-icon e-plus');
                        parentLi.removeClass('e-collapse');
                        this._deepWatch && this._updateField(this._newDataSource, nodeDetails.id, this.model.fields, "expanded", false);
                        this._doAnimation(expandUl, element, "nodeCollapse", data, 200);
                    }
                    if (this._deepWatch) {
                        this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
						this.dataSource(this._newDataSource);
                    }
                }
            }
        },

        _doAnimation: function (expandUl, element, event, data, animationSpeed) {
            var proxy = this;
            if (this.model.enableAnimation) {
                expandUl.animate({ height: 'toggle' }, animationSpeed, 'linear', function () {
                    if (ej.isNullOrUndefined(proxy.model)) return;
                    proxy._doAnimateAction(element, event, data);
                });
            }
            else {
                expandUl.css("display", animationSpeed == 200 ? "none" : "block");
                this._doAnimateAction(element, event, data);
            }
        },

        _doAnimateAction: function (element, event, data) {
            element.removeClass("e-process");
            this._triggerEvent(event, data);
        },

        _isChecked: function (liElement) {
            return (liElement.find("> div > .e-chkbox-wrap:first").attr("aria-checked") === 'true') ? true : false;
        },

        _doRecursiveCheck: function (parentLi, checkedArray) {
            var chkWrapper, chkEle, liElement, textvalue, parentLi, childUl;
            childUl = this._getChildUl(parentLi);
            chkWrapper = (childUl) ? childUl.querySelectorAll('.e-chkbox-wrap[aria-checked="true"]').length : 0;
            var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
            chkEle = parentLi.firstChild.querySelector('.nodecheckbox');
            if (chkEle && chkEle.nodeName.toUpperCase() == 'INPUT') {
                var chkboxObj = $(chkEle).data('ejCheckBox');
                if (chkWrapper == allChkEle.length || this.model.autoCheckParentNode) {
                    chkboxObj.setModel({ enableTriState: false, checked: true });
                    chkEle.className += " checked";
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    checkedArray.push({ id: parentLi.id, text: textvalue });
                    if (this._deepWatch && !this.model.autoCheckParentNode) this._updateField(this._newDataSource, parentLi.id, this.model.fields, "isChecked", true);
                    this._addHiddenInputElement(chkEle, textvalue);
                    this._addCheckNodes(this._liList.index(parentLi));
                } else
                    chkboxObj.setModel({ enableTriState: true, checkState: "indeterminate" });
                parentLi = parentLi.parentNode.parentNode;
                if (parentLi.nodeName.toUpperCase() == 'LI')
                    this._doRecursiveCheck(parentLi, checkedArray);
            }
        },

        _nodeCheck: function (chkEle, args) {
            if ($(chkEle)[0] == null) return;
            this._CurrenctSelectedNodes = [];
            this._checkedArray = [];
            var chkObj, currentLi, textvalue, chkCollection, chklen, parentLi;
            chkEle.className += " checked";
            chkObj = $(chkEle).data('ejCheckBox');
            if (chkObj) {
                chkObj.setModel({ enableTriState: false, checked: true });
                currentLi = chkEle.parentNode.parentNode.parentNode;
                textvalue = currentLi.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                this._checkedArray.push({ id: currentLi.id, text: textvalue });
                this._deepWatch && this._updateField(this._newDataSource, currentLi.id, this.model.fields, "isChecked", true);
                this._addHiddenInputElement(chkEle, textvalue);
                this._addCheckNodes(this._liList.index(currentLi));
                if (this.model.autoCheck) {
                    var allChkEle, liElement, childUl;
                    childUl = this._getChildUl(currentLi);
                    allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
                    for (var i = 0, chklen = allChkEle.length; i < chklen; i++) {
                        $(allChkEle[i]).ejCheckBox({ checked: true, enableTriState: false })[0].className += " checked";
                        liElement = allChkEle[i].parentNode.parentNode.parentNode;
                        textvalue = liElement.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                        this._checkedArray.push({ id: liElement.id, text: textvalue });
                        this._deepWatch && this._updateField(this._newDataSource, liElement.id, this.model.fields, "isChecked", true);
                        this._addHiddenInputElement(allChkEle[i], textvalue);
                        this._addCheckNodes(this._liList.index(liElement));
                    }
                    parentLi = currentLi.parentNode.parentNode;
                    if (parentLi.nodeName.toUpperCase() == 'LI')
                        this._doRecursiveCheck(parentLi, this._checkedArray);
                }
                (args) && (args.checknode = this._checkedArray);
                this._onChecked($(chkEle), args);
            }
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
				this.dataSource(this._newDataSource);
            }
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _addHiddenInputElement: function (checkedElement, textVal) {
            if (checkedElement.firstChild == null) {
                var hiddenElement = document.createElement('input');
                hiddenElement.setAttribute("type", "hidden");
                hiddenElement.setAttribute("name", this._id + "_Checkbox_" + checkedElement.value + ".Text");
                hiddenElement.setAttribute("value", textVal);
                try {
                    checkedElement.appendChild(hiddenElement);
                }
                catch (err) { }
            }
        },

        _doRecursiveUncheck: function (parentLi, uncheckedArray) {
            var chkWrapper, chkEle, liElement, textvalue, parentLi, childUl;
            childUl = this._getChildUl(parentLi);
            chkWrapper = (childUl) ? childUl.querySelectorAll('.e-chkbox-wrap[aria-checked="true"]').length : 0;
            var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
            chkEle = parentLi.firstChild.querySelector('.nodecheckbox');
            if (chkEle && chkEle.nodeName.toUpperCase() == 'INPUT') {
                var chkboxObj = $(chkEle).data('ejCheckBox');
                if (chkWrapper <= 0) {
                    chkboxObj.setModel({ enableTriState: false, checked: false });
                    $(chkEle).removeClass("checked").removeClass('checked').children().remove();
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    this._removeCheckNodes(this._liList.index(parentLi));
                    uncheckedArray.push({ id: parentLi.id, text: textvalue });
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields, "isChecked", false);
                }
                if (chkWrapper > 0 && this.model.autoCheckParentNode) {
                    chkboxObj.setModel({ checked: true });
                    chkEle.className += " checked";
                    textvalue = parentLi.firstChild.getElementsByTagName('a')[0].innerHTML;
                    this._addHiddenInputElement(parentLi, textvalue);
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields, "isChecked", false);
                }
                else if (chkWrapper > 0 && !this.model.autoCheckParentNode) {
                    if (allChkEle.length > 1)
                        chkboxObj.setModel({ enableTriState: true, checkState: "indeterminate" });
                    else
                        chkboxObj.setModel({ checked: false });
                    $(chkEle).removeClass("checked").removeClass('checked').children().remove();
                    this._removeCheckNodes(this._liList.index(parentLi));
                    this._deepWatch && this._updateField(this._newDataSource, parentLi.id, this.model.fields, "isChecked", false);
                }
                parentLi = parentLi.parentNode.parentNode;
                if (parentLi.nodeName.toUpperCase() == 'LI')
                    this._doRecursiveUncheck(parentLi, uncheckedArray);
            }
        },

        _nodeUncheck: function (chkEle, args) {
            if ($(chkEle)[0] == null) return;
            var proxy = this; this._uncheckedArray = [];
            var currentLi = chkEle.parentNode.parentNode.parentNode;
            $(currentLi).find('div > .e-chkbox-wrap > .nodecheckbox').removeClass('checked').children().remove();
            var chkObj = $(chkEle).data('ejCheckBox');
            this._removeCheckNodes(this._liList.index(currentLi));
            if (chkObj) {
                chkObj.setModel({ enableTriState: false, checked: false });
                var textvalue = currentLi.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                this._uncheckedArray.push({ id: currentLi.id, text: textvalue });
                this._deepWatch && this._updateField(this._newDataSource, currentLi.id, this.model.fields, "isChecked", false);
                if (this.model.autoCheck) {
                    var childUl = this._getChildUl(currentLi);
                    var allChkEle = (childUl) ? childUl.querySelectorAll('.e-item > div > .e-chkbox-wrap > .nodecheckbox') : [];
                    for (var i = 0, chklen = allChkEle.length; i < chklen; i++) {
                        $(allChkEle[i]).ejCheckBox({ enableTriState: false, checked: false });
                        var liElement = allChkEle[i].parentNode.parentNode.parentNode;
                        textvalue = liElement.firstChild.getElementsByTagName('a')[0].lastChild.nodeValue;
                        this._uncheckedArray.push({ id: liElement.id, text: textvalue });
                        this._deepWatch && this._updateField(this._newDataSource, liElement.id, this.model.fields, "isChecked", false);
                        this._removeCheckNodes(this._liList.index(liElement));
                    }
                    var parentLi = currentLi.parentNode.parentNode;
                    if (parentLi.nodeName.toUpperCase() == 'LI')
                        this._doRecursiveUncheck(parentLi, this._uncheckedArray);
                }
                (args) && (args.unchecknode = this._uncheckedArray);
                this._onUnChecked($(chkEle), args);
            }
            if (this._deepWatch) {
                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
				this.dataSource(this._newDataSource);
            }
            this._persistValues(this.model.checkedNodes, "checkedNodes");
        },

        _executeDataQuery: function(mapper, key, val) {
            var queryManager, queryPromise;
            queryManager = ej.Query();
            queryManager = this._columnToSelect(mapper);
            if (!ej.isNullOrUndefined(key) && key != "") {
                var tempQuery=$.extend(true,[],queryManager._params);
                queryManager._params = [];
                queryManager.addParams(key, val);
                for (var i = 0; i < tempQuery.length; i++)
                    (tempQuery[i].key != key) && queryManager.addParams(tempQuery[i].key, tempQuery[i].value);
                queryManager.where(key, ej.FilterOperators.equal, val);
            }
            queryPromise = mapper["dataSource"].executeQuery(queryManager);
            return queryPromise;
        },

        _createChildNodesWhenExpand: function (parentLi, expandChild, level, excludeHiddenNodes, outerLi, thisObj) {
            var nodeid, nodeText, args, element;
            if (parentLi.length > 0 && parentLi.find('ul .e-item').length == 0) {
                nodeid = parentLi.attr('id');
                nodeText = parentLi.children('div').find('.e-text:first').text();
                element = parentLi.children('div').find('div.e-plus:first');
                args = { currentElement: parentLi, targetElement: element[0], id: nodeid, value: nodeText, isChildLoaded: false, hasParent: true, async: false };
                var childItems, parent, mapper, proxy = this, queryPromise;
                this._isEventTriggered = true;
                if (this._triggerEvent('beforeExpand', args)) {
                    return false;
                }
                if (this.dataSource() instanceof ej.DataManager) {
                    parent = args.currentElement.parents('ul').length;
                    mapper = this._getChildTables(this.model.fields, parent, 1);
                    if (ej.isNullOrUndefined(mapper) && ej.isNullOrUndefined(this.model.fields["child"]))
                        mapper = this.model.fields;
                    if (!mapper) {
                        $(args.targetElement).hasClass('e-load') && $(args.targetElement).removeClass(($(args.targetElement).hasClass('e-plus') || $(args.targetElement).hasClass('e-minus')) ? 'e-load' : 'e-icon e-load');
                        return;
                    }
                    (mapper.query && mapper.query.queries.length > 0) && (mapper.query.queries = []);
                    this._treeList.push("false");
                    queryPromise = this._executeDataQuery(mapper, mapper["parentId"], (this._typeOfFieldId == "number" ? parseInt(args.currentElement[0].id) : args.currentElement[0].id));
                    queryPromise.done(function (e) {
                        proxy._treeList.pop();
                        childItems = (e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.d) ? e.xhr.responseJSON.d : (e.result ? e.result : []);
                        childItems = proxy._getSortAndFilterList(mapper, childItems);
                        if (childItems.length > 0) {
                            var parentID = ej.getObject(mapper["parentId"], childItems[0]);
                            proxy._updateRemoteData(proxy._newDataSource, parentID, childItems, proxy.model.fields);
                        }
                        proxy._appendChild(childItems, parentLi, mapper, expandChild, level, excludeHiddenNodes);
                        level && proxy._expandByLevel(parentLi.find('> ul'), level - 1, excludeHiddenNodes);
                        if (proxy._treeList.length == 0) {
                            outerLi && proxy._doAfterExpand(parentLi, outerLi, thisObj);
                            proxy._completeRendering();
                        }
                    });
                }
                else {
                    var childItems = this._getChildNodes(this._dataSource, { id: parentLi[0].id });
                    this._appendChild(childItems, parentLi, this.model.fields, expandChild, level, excludeHiddenNodes);
                }
            }
            else
                this._expandNode(parentLi);
        },

        _appendChild: function (childItems, parentLi, mapper, expandChild, level, excludeHiddenNodes) {
            if (!ej.isNullOrUndefined(childItems) && childItems.length > 0) {
                this._checkboxChecked = parentLi.find('> div > .e-chkbox-wrap > .nodecheckbox').hasClass('checked');
                this._loadOnDemandNodes = true;
                if (parentLi.find('ul .e-item').length == 0) {
                    this._templateNodeCreation(childItems, mapper);
                    parentLi.append(this._fragment);
                }
                this._finalizeLoadOnDemand(parentLi);
                this._expandNode(parentLi);
                if (expandChild && !level && !excludeHiddenNodes) {
                    var _items = parentLi.find(".e-item > div > .e-plus").closest(".e-item");
                    for (var i = 0, len = _items.length; i < len; i++)
                        this._createChildNodesWhenExpand($(_items[i]), true, null, excludeHiddenNodes);
                }
            }
            else if (expandChild)
                parentLi.find("> div > .e-plus").removeClass('e-plus e-icon');
        },

        _getSortAndFilterList: function (mapper, list) {
            var dataSource;
            if (!list || !list.length || list.length < 1) dataSource = [];
            else {
                var tempQuery = ej.Query();
                this._addSortingQuery(tempQuery, mapper);
                dataSource = ej.DataManager(list).executeLocal(tempQuery);
            }
            return dataSource;
        },

        _addSortingQuery: function (query, mapper) {
            if (this.model.sortSettings.allowSorting) {
                var key = (mapper && mapper.text) ? mapper["text"] : "text";
                var order = (this.model.sortSettings.sortOrder == ej.sortOrder.Descending) ? true : false;
                query.sortBy(key, order);
            }
        },

        _expandNode: function (liElement) {
            if (liElement[0] != null && liElement.length > 0) {
                var expandIcon = liElement.find('> div > div:first');
                if (this.model.loadOnDemand && !this.model.enablePersistence) {
                    if (liElement.find('> ul > .e-item').length > 0 && expandIcon.hasClass('e-plus')) {
                        if (!this.model.enableMultipleExpand) this._denyMultipleExpand(liElement);
                        this._expandCollapseAction(liElement.find('> div > div.e-plus:first'));
                    } else if (expandIcon.hasClass('e-icon') && !expandIcon.hasClass('e-minus')) {
                        (this._allowOnDemand) && this._createChildNodesWhenExpand(liElement);
                    }
                }
                else {
                    if (expandIcon.hasClass('e-plus')) {
                        var isExpanded = liElement.find('> ul > .e-item').length > 0 ? true : false;
                        if (isExpanded) {
                            if (!this.model.enableMultipleExpand) this._denyMultipleExpand(liElement);
                            this._expandCollapseAction(expandIcon);
                        }
                    }
                }
            }
            return true;
        },

        _collapseNode: function (liElement) {
            if (liElement[0] != null && liElement.length > 0) {
                if (liElement.find('> ul > .e-item').length > 0) {
                    var collapseIcon = liElement.find('> div > div:first');
                    if (collapseIcon.hasClass('e-minus'))
                        this._expandCollapseAction(collapseIcon);
                }
            }
        },

        _getElement: function (level) {
            return (!this.element.is('UL')) ? this.element.find('> ul') : this.element;
        },

        _getImmediateChild: function (ele, excludeHiddenNodes) {
            return excludeHiddenNodes ? ele.find('> .e-item:not(:hidden)') : ele.find('> .e-item');
        },

        _expandByLevel: function (ele, level, excludeHiddenNodes) {
            (level > 0) && this._expandByNode(this._getImmediateChild(ele, excludeHiddenNodes), level, excludeHiddenNodes);
        },

        _expandByNode: function (cnodes, level, excludeHiddenNodes) {
            for (var i = 0, len = cnodes.length; i < len; i++) {
                if ($(cnodes[i]).find("> div > div").hasClass("e-plus"))
                    this.model.loadOnDemand ? this._createChildNodesWhenExpand($(cnodes[i]), true, level, excludeHiddenNodes) : this._expandNode($(cnodes[i]));
                this._expandByLevel($(cnodes[i]).find('> ul'), level - 1, excludeHiddenNodes);
            }
        },

        _expandAll: function (excludeHiddenNodes) {
            var element = this.element, i, cnodes;
            cnodes = element.find(excludeHiddenNodes ? '.e-item > div > .e-plus:not(:hidden)' : '.e-item > div > .e-plus').closest('.e-item');
            if (this.model.loadOnDemand) {
                for (i = 0, len = cnodes.length; i < len; i++)
                    this._createChildNodesWhenExpand($(cnodes[i]), true, null, excludeHiddenNodes);
            }
            else {
                for (i = 0, len = cnodes.length; i < len; i++)
                    this._expandNode($(cnodes[i]));
            }
        },

        _collapseByLevel: function (ele, level, excludeHiddenNodes) {
            (level > 0) && this._collapseByNode(this._getImmediateChild(ele, excludeHiddenNodes), level, excludeHiddenNodes);
        },

        _collapseByNode: function (cnodes, level, excludeHiddenNodes) {
            for (var i = 0, len = cnodes.length; i < len; i++) {
                if ($(cnodes[i]).find("> div > div").hasClass("e-minus"))
                    this._collapseNode($(cnodes[i]));
                this._collapseByLevel($(cnodes[i]).find('> ul'), level - 1, excludeHiddenNodes);
            }
        },

        _collapseAll: function (excludeHiddenNodes) {
            var element = this.element, i, enodes;
            enodes = element.find(excludeHiddenNodes ? '.e-item > div > .e-minus:not(:hidden)' : '.e-item > div > .e-minus').closest('.e-item');
            if (enodes.length > 0) {
                for (i = 0, len = enodes.length; i < len; i++) {
                    this._collapseNode($(enodes[i]));
                }
            }
        },

        _checkAll: function () {
            this._CurrenctSelectedNodes = [];
            var element = this.element, chkColl;
            chkColl = element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox');
            chkColl.addClass('checked');
            for (i = 0, len = chkColl.length; i < len; i++) {
                $(chkColl[i]).ejCheckBox("setModel", { checked: true });
                this._addHiddenInputElement(chkColl[i], $(chkColl[i]).parent().siblings('.e-text')[0].lastChild.nodeValue);
            }
            this.model.checkedNodes = this.getCheckedNodesIndex();
        },

        _uncheckAll: function () {
            var element = this.element, chkColl;
            chkColl = element.find('.e-item > div > .e-chkbox-wrap > .nodecheckbox');
            chkColl.removeClass("checked").children().remove();
            for (i = 0, len = chkColl.length; i < len; i++)
                $(chkColl[i]).ejCheckBox("setModel", { checked: false });
            this.model.checkedNodes = [];
            this.model.checkedNodes.push(-1);
        },

        _selectAll: function () {
            this._isRender = false;
            var data = { ctrlKey: true };
            for (var i = 0, len = this._liList.length; i < len; i++) {
                var element = $(this._liList[i]);
                if (element[0] != null)
                    this._nodeSelectionAction(element, data);
                if (!this.model.allowMultiSelection) break;
            }
            this._isRender = true;
        },

        _unselectAll: function () {
            this.element.find('a.e-text.e-active').removeClass('e-node-focus e-active');
            this.element.find('[aria-selected=true]').attr("aria-selected", false);
            this.element.find('.e-li-active').removeClass('e-li-active');
            this.element.find('.e-li-focus').removeClass('e-li-focus');
            this.element.find('.e-node-focus').removeClass('e-node-focus');
            this.model.selectedNodes = [];
            if (this.model.enablePersistence)
                this._persistValues(this.model.selectedNodes, "selectedNodes");
        },

        _isNodeExpanded: function (liElement) {
            if (liElement[0] != null)
                return liElement.children('ul:first').length > 0 && liElement.find('> div > div.e-minus').length > 0;
        },

        _showCheckBox: function () {
            var element = this.element, licoll, i, subItems;
            licoll = element.find('li');
            for (var i = 0; i < licoll.length; i++)
                this._checkboxOnTemplate(licoll[i].children[0]);
            element.find(".e-item > div > .nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            element.find(".e-item.e-node-disable > div > .e-chkbox-wrap > .nodecheckbox").ejCheckBox("disable");
        },
        _drag: function () {
            var proxy, pre = false, browserInfo = ej.browserInfo(), _clonedElement = null, _draggedElement = null, dragContainment = null, _isIE8;
            _isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            if (this.element.is("ul")) {
                this._treeView = this.element.parent();
                if (!this.model.allowDragAndDropAcrossControl)
                    dragContainment = this.element.parent();
            }
            else {
                this._treeView = this.element;
                if (!this.model.allowDragAndDropAcrossControl)
                    dragContainment = this.element;
            }
            $(this._treeView).find("ul li div a").not(".e-js").ejDraggable({
                dragArea: dragContainment,
                clone: true,
                dragStart: function (args) {
                    if (proxy && !ej.isNullOrUndefined(args.target) && !$(args.target).hasClass('e-node-disable') && proxy.element.find('.e-item > div > .e-text.e-editable').length == 0) {
                        args.element.attr('aria-grabbed', true);
                        proxy.element.closest('.e-treeview-wrap').addClass('e-dragging');
                        if ($(args.target).is('A') && !$(args.target).hasClass('e-draggable')) return false;
                        if (_isIE8) document.ondragstart = function () { return false; }
                        var data = { target: $(args.target).closest(".e-item"), targetElementData: proxy._getNodeDetails($(args.target).closest(".e-item")), dragTarget: args.target, parentElement: $(args.target).closest("ul").closest('.e-item'), parentElementData: proxy._getNodeDetails($(args.target).closest("ul").closest('.e-item')), event: args.event };
                        if (proxy._triggerEvent('nodeDragStart', data)) {
                            args.cancel = true;
                            _clonedElement && _clonedElement.remove();
                            return false;
                        }
                    } else return false;
                },
                drag: function (args) {
                    pre = false;
                    if ($(args.target).hasClass('e-sibling')) args.target = args.target.parentElement;
                    $('.e-sibling').remove();
                    var target = args.target, trgtEle = proxy._findTarget($(target)), data;
                    $(target).closest('.e-treeview-wrap').addClass('e-dragging');
                    var desProxy = $(target).closest('.e-treeview.e-js').data('ejTreeView');
                    desProxy = !desProxy ? proxy : desProxy;
                    $(_clonedElement).css({ "margin-top": args.event.clientY - 20 < 0 ? "0px" : "10px" });
                    
                    data = { draggedElement: $(args.element).closest(".e-item"), draggedElementData: proxy._getNodeDetails($(args.element).closest(".e-item")), dragTarget: target, target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), event: args.event };
                    if (($(args.element).parent().parent().has($(target)).length == 0 || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length > 1)) && ($(target).hasClass('e-droppable') || $(target).parent().hasClass('e-droppable')) && $(target).hasClass('e-dropchild') && !$(target).hasClass('e-node-disable') &&
                       (proxy.model.allowDragAndDropAcrossControl || (!proxy.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(proxy.element)))) {
                        document.body.style.cursor = '';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                        $(target).addClass("allowDrop");
                    } else if (desProxy.model.allowDropChild && desProxy.model.allowDropSibling && (($(target).hasClass('e-droppable') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) || ($(target).is("UL") && $(target).hasClass('e-ul') && $(target).find('.e-item').length == 0 && $(target).parent('.e-treeview-wrap').length > 0))) {
                        document.body.style.cursor = '';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                    }
                    else if ((!$(target).hasClass('e-sibling') && !$(target).find('a').hasClass('e-text')) || (!$(target).hasClass('e-sibling') && !$(target).parent().parent().hasClass('e-item') && !$(target).parent().hasClass('e-item') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) || ((target.nodeName.toUpperCase() == "LI" || target.parentElement !== null && target.parentElement.nodeName.toUpperCase() == "LI") && !desProxy.model.allowDropSibling) || (!proxy.model.allowDragAndDropAcrossControl && !$(target).parents('.e-treeview').is(proxy.element))) {
                        document.body.style.cursor = 'not-allowed';
                        $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-minus");
                        $(target).removeClass('showline-hover');
                        $(target).removeClass('noline-hover');
                    }
                    if (target.nodeName != 'A' && ($(args.element).parent().parent().has($(target)).length == 0 || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length > 1)) && $(args.element).parent().parent()[0] != $(target)[0]) {
                        if (target.nodeName == 'UL' && $(target).children()[0] != null)
                        { target = $(target).children()[0]; pre = true; }
                        if (target.nodeName != 'LI')
                            target = $(target).closest('.e-droppable')[0] || $(target).parent();
                        if (target.nodeName == 'LI' && $(target).hasClass("e-droppable") && $(target).hasClass("e-dropsibling") && (proxy.model.allowDragAndDropAcrossControl || (!proxy.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(proxy.element)))) {
                            var div = ej.buildTag('div.e-sibling'), targetY;
                            targetY = $(target).offset().top + $(target).find('a').height() || -1;
                            pre = (args.event.pageY > targetY) ? false : true;
                            pre ? div.insertBefore($(target).find('> div > a').parent()) : div.insertAfter($(target).find('> div > a').parent());
                            if ($(target).parents().hasClass("e-rtl")) {
                                document.body.style.cursor = '';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-insertInbetween-rtl");
                            }
                            else {
                                document.body.style.cursor = '';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-insertInbetween");
                            }
                        }
                        else if (target.nodeName == 'A' && $(target) && $(target).hasClass('e-droppable') && $(target).hasClass('e-dropchild')) {
                            document.body.style.cursor = '';
                            $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                            $(target).addClass("allowDrop");
                        } else if ($(target).hasClass('e-droppable') && !$(target).hasClass('e-item') && !$(target).hasClass('e-text')) {
                            document.body.style.cursor = '';
                            $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-plus");
                        }
                    }
                    else {
                        if ($(args.element).parent().parent().has($(target)).length == 1 || $(args.element).parent().parent().is($(target))) {
                            if (!proxy.model.allowMultiSelection || (proxy.model.allowMultiSelection && proxy.model.selectedNodes.length <= 1)) {
                                document.body.style.cursor = 'not-allowed';
                                $(_clonedElement).find('span.e-dropedStatus').removeClass().addClass("e-dropedStatus e-icon e-minus");
                            }
                        }
                        $('.e-sibling').remove();
                    }
                    if (proxy._triggerEvent('nodeDrag', data))
                        return false;
                },
                dragStop: function (args) {
                    if (_isIE8) document.ondragstart = function () { return true; }
                    if (!args.element.dropped) {
                        _clonedElement && _clonedElement.remove();
                        document.body.style.cursor = '';
                    }
                    var target = args.target, position, data;
                    $(target).closest('.e-treeview-wrap').removeClass('e-dragging');
                    proxy.element.closest('.e-treeview-wrap').removeClass('e-dragging');
                    if (target.className == "e-sibling")
                        target = $(target).closest(".e-item")[0];
                    $('.e-sibling').remove();
                    if ($(target).hasClass('e-node-disable')) return false;
                    position = pre ? "Before" : "After", trgtEle = proxy._findTarget($(target));
                    position = target.nodeName == 'A' ? "Over" : position;
                    data = { draggedElementData: proxy._getNodeDetails($(args.element).closest('.e-item')), draggedElement: $(args.element).closest('.e-item'), dropTarget: $(target), target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), position: position, event: args.event };
                    if (proxy._triggerEvent('nodeDragStop', data))
                        return false;
                    if (proxy.model.allowMultiSelection && $(args.element).hasClass("e-active")) {
                        var sleNodes = proxy.element.find('.e-item > div > .e-active');
                        for (var l = 0, slelen = sleNodes.length; l < slelen; l++) {
                            args.element = sleNodes[l];
                            position = proxy._dropNode(target, args, position, pre);
                            if (position == "After" && $(target).closest('.e-treeview.e-js').length)
                                target.nodeName.toUpperCase() == "LI" ? target = target.nextElementSibling : target = target.closest("li").nextElementSibling;
                        }
                    }
                    else
                        position = proxy._dropNode(target, args, position, pre);
                    $(".allowDrop").removeClass("allowDrop");
                    $(args.element).attr('aria-grabbed', false);
                    if (!$(target).hasClass('e-dropchild')) {
                        _clonedElement && _clonedElement.remove();
                    }
                    trgtEle = proxy._findTarget($(target));
                    data = { droppedElementData: proxy._getNodeDetails($(args.element).closest('.e-item')), droppedElement: $(args.element).closest('.e-item'), dropTarget: $(target), target: trgtEle, targetElementData: proxy._getNodeDetails(trgtEle), position: position, event: args.event };
                    if (proxy._triggerEvent('nodeDropped', data))
                        return false;
                    document.body.style.cursor = '';
                },
                helper: function (event, ui) {
                    if (!ej.isNullOrUndefined(event.element) && !$(event.element).hasClass('e-node-disable') && $(event.element).hasClass('e-draggable')) {
                        proxy = $(event.element).closest('.e-treeview.e-js').data('ejTreeView');
                        if (proxy) {
                            _clonedElement = ej.buildTag('div.e-dragedNode e-widget');
                            var maxZ = ej.util.getZindexPartial(proxy.element);
                            _clonedElement.css({ "z-index": maxZ });
                            _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                            var sleNodes = proxy.element.find('.e-item > div > .e-active');
                            var sleNodesLen = sleNodes.length;
                            _draggedElement = $(event.element).clone().addClass("dragClone");
                            this.spanEle = ej.buildTag('span.e-icon e-plus e-dropedStatus');
                            _clonedElement.append(this.spanEle);
                            _clonedElement.append(_draggedElement);
                            var _spanEle = ej.buildTag('span.e-drop-count', sleNodesLen);
                            if (sleNodesLen > 1 && proxy.model.allowMultiSelection && $(event.element).hasClass("e-active"))
                                _clonedElement.append(_spanEle);
                            return _clonedElement.appendTo($("body"));
                        }
                    }
                }
            });
        },

        _dropNode: function (target, args, position, pre) {
            proxy = $(target).closest('.e-treeview.e-js').data('ejTreeView');
            if (target.nodeName == 'A' && $(target).hasClass('e-dropchild') && $(target).hasClass('e-droppable') || (target.nodeName == 'UL' && $(target).children().length == 0)) {
                position = "Over";
                if ($(target).is("UL") && $(target).hasClass('e-ul') && $(target).find('.e-item').length == 0 && $(target).parent('.e-treeview-wrap').length > 0 && proxy.model.allowDropChild)
                    this._dropAsChildNode($(target), $(args.element), args.event);
                else if (proxy.model.allowDropChild && ($(args.element).parent().parent().has($(target)).length == 0) && ($(target).parent().parent().has($(args.element)).length == 0 || this._isDescendant($(target).parents("li:last").find('>ul>li'), $(args.element).parents("li:first")[0])) && (this.model.allowDragAndDropAcrossControl || (!this.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(this.element))))
                    this._dropAsChildNode($(target).closest('.e-item'), $(args.element), args.event);
            }
            else {
                if (target.nodeName == 'UL')
                    target = $(target).children()[0];
                if (target.nodeName != 'LI')
                    target = $(target).closest('.e-droppable')[0] || $(target).parent();
                if (target.nodeName == 'LI' && $(target).hasClass('e-dropsibling') && $(target).hasClass('e-droppable')) {
                    if (proxy.model.allowDropSibling && $(args.element).parent().parent().has($(target)).length < 1 && $(args.element).parent().parent()[0] != $(target)[0] && (this.model.allowDragAndDropAcrossControl || (!this.model.allowDragAndDropAcrossControl && $(target).parents('.e-treeview').is(this.element))))
                        this._dropAsSiblingNode($(target), $(args.element), pre, args.event);
                }
                else if (target.nodeName == 'A' && $(target).hasClass('e-dropchild') && $(target).hasClass('e-droppable')) {
                    position = "Over";
                    if (proxy.model.allowDropChild && ($(args.element).parent().parent().has($(target)).length == 0) && ($(target).parent().parent().has($(args.element)).length == 0 || this._isDescendant($(target).parents("li:last").find('>ul>li'), $(args.element).parents("li:first")[0])))
                        this._dropAsChildNode($(target).closest('.e-item'), $(args.element), args.event);
                }
            }
            return position;
        },

        _findTarget: function (trgt) {

            if (trgt.hasClass('e-text') || trgt.parents('a').hasClass('e-text')) return trgt.closest('.e-item')
               
            else if (trgt.closest("ul").closest('.e-item').length > 0) return trgt.closest("ul").closest('.e-item')

            else if (this.element.find(trgt).length > 0 && !this.model.template) return trgt.parents("ul").first()

            else if (this.element.find(trgt).length > 0 && this.model.template){ 

                return (trgt.closest('.e-text').length > 0) ? trgt.closest('.e-item') : trgt.parents("ul").first();
             
            }
            else return trgt;

        },

        _isDescendant: function (src, target) {
            var match = true;
            $(src).each(function (i, item) {
                if (item == target) {
                    match = false;
                    return false;
                }
                else
                    match = true;
            });
            return match;
        },

        _childDrop: function () {
            $(this._treeView).find("ul .e-item div .e-text").ejDroppable({
                accept: $(this._treeView).find("ul .e-item div .e-text").addClass('e-dropchild'),
                drop: function (event, ui) {
                    $(ui.helper).hide();
                }
            });
        },

        _siblingDrop: function () {
            $(this._treeView).find("ul .e-item").addClass('e-dropsibling').ejDroppable({
                drop: function (event, ui) {
                    $(ui.helper).hide();
                }
            });
        },

        _dropAsSiblingNode: function (target, element, pre, event) {
            var li = element.parent().parent(), li = $(li), parentNode;
            parentNode = $(element.parents('.e-item')[1]);
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager))
                this._updateDataSource(element.parents('.e-item:first'), $(target), pre, this);
            pre ? li.insertBefore(target) : li.insertAfter(target);
            (!this.model.template) && this._autoGenerateNodes(element.parents('.e-item:first'));
            this._modifyCss(parentNode);
            this._isRender = false;
            this._updateCheckState(li);
            this._updateCheckState(parentNode);
            this._isRender = true;
            (li.find('> div > .e-minus').length > 0 && !this.model.enableMultipleExpand) && this._denyMultipleExpand(li);
            this._updateChanges($(target));
        },

        _dropAsChildNode: function (target, element, event) {
            var li = element.parent().parent(), li = $(li), parentNode;
            parentNode = $(element.parents('.e-item')[1]);
            ($(target).is('UL')) ? $(target).append(li) : this._appendNode(target, li);
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager))
                this._updateDataSource(element.parents('.e-item:first'), $(target).find("> div > .e-text").first(), "", this);
            (!this.model.template) && this._autoGenerateNodes(element.parents('.e-item:first'));
            this._modifyCss(parentNode);
            this._isRender = false;
            this._updateCheckState(li);
            this._updateCheckState(parentNode);
            this._isRender = true;
            if (target.find('> div > .e-icon.e-plus:first').length > 0) this._expandNode(target);
            this._updateChanges($(target));
        },

        _updateChanges: function (dropEle) {
            if ($(dropEle)[0] != null) {
                var desTree = this, tree = 0;
                do {
                    desTree._updateNodes();
                    if (tree == 1) desTree._updateTarget(this);
                    tree++;
                    desTree = dropEle.closest('.e-treeview.e-js').data('ejTreeView')
                } while (desTree && this._id != desTree._id && tree == 1);
            }
        },

        _updateTarget: function (obj) {
            if (this.model.allowDropChild != obj.model.allowDropChild)
                this.model.allowDropChild ? this._childDrop() : this._preventDropChild();
            if (this.model.allowDropSibling != obj.model.allowDropSibling)
                this.model.allowDropSibling ? this._siblingDrop() : this._preventDropSibling();
        },

        _updatePersistProb: function () {
            this._removeField(this._newDataSource, this.model.fields, "selected");
            this._removeField(this._newDataSource, this.model.fields, "expanded");
            this._removeField(this._newDataSource, this.model.fields, "isChecked");
            var sleNodes = this.getSelectedNodes();
            for (var l = 0, slelen = sleNodes.length; l < slelen; l++)
                this._updateField(this._newDataSource, $(sleNodes[l]).attr('id'), this.model.fields, "selected", true);
            var enodes = this.getExpandedNodes();
            for (var k = 0, nodelen = enodes.length; k < nodelen; k++)
                this._updateField(this._newDataSource, $(enodes[k]).attr('id'), this.model.fields, "expanded", true);
            if (this.model.showCheckbox) {
                var cnodes = this.getCheckedNodes();
                for (var m = 0, nodelen = cnodes.length; m < nodelen; m++)
                    this._updateField(this._newDataSource, $(cnodes[m]).attr('id'), this.model.fields, "isChecked", true);
            }
        },

        _orderDataSource: function () {
            this._beforeBaseClass();
            this._updatePersistProb();
            var orderedData = [], datasource = JSON.parse(JSON.stringify(this._newDataSource));
            if (this.dataSource() instanceof ej.DataManager && this._templateType == 2) {
                return this._newDataSource;
            }
            else {
                for (var i = 0, objlen = this._liList.length; i < objlen; i++) {
                    for (var j = 0, dlen = datasource.length; j < dlen; j++) {
                        if ($(document.getElementById(ej.getObject(this.model.fields.id, datasource[j]))).length > 0 && !ej.isNullOrUndefined(datasource[j]) && !ej.isNullOrUndefined(datasource[j][this.model.fields.id]) && datasource[j][this.model.fields.id].toString() == $(this._liList[i]).attr('id')) {
                            if ($(document.getElementById(ej.getObject(this.model.fields.id, datasource[j]))).find('> ul .e-item').length == 0) {
                                this._deepPropertyDelete(this.model.fields.hasChild, datasource[j]);
                                if (this._templateType == 2)
                                    delete datasource[j]["child"];
                            } else if (this._templateType == 1)
                                ej.createObject(this.model.fields.hasChild, true, datasource[j]);
                            else
                                this._updateChildData(datasource[j]["child"], this.model.fields);
                            orderedData.push(datasource[j]);
                        }
                    }
                }
            }
            return orderedData;
        },

        _updateDataSource: function (dragEle, dropEle, before ,obj) {
            if ($(dragEle)[0] != null && $(dropEle)[0] != null) {
                var sourceTree = obj, desTree, pid, indexPos;
                desTree = dropEle.closest('.e-treeview.e-js').data('ejTreeView');

                if (sourceTree && desTree && !ej.isNullOrUndefined(desTree.model.fields) && desTree.dataSource() != null && !(desTree.dataSource() instanceof ej.DataManager)) {
                    if (dropEle.is("A")) {
                        pid = dropEle.closest('.e-item').attr('id');
                        var child = dropEle.closest('.e-item').find('> ul > .e-item');
                        indexPos = (child.length > 0) ? child.length : dropEle.closest('.e-item').index();
                    }
                    else {
                        pid = dropEle.parents('.e-item:first').attr('id');
                        var nextLi = dropEle.next('.e-item'), prevLi = dropEle.prev('.e-item');
                        if (nextLi.length > 0)
                            indexPos = (prevLi.length > 0) ? indexPos = nextLi.index() - 1 : (before) ? indexPos = dropEle.index() : indexPos = nextLi.index();
                        else
                            indexPos = (before) ? dropEle.index() : dropEle.index() + 1;
                    }
                    (desTree) && sourceTree._findAndUpdate(dragEle.attr('id'), pid, sourceTree._newDataSource, indexPos, desTree, dropEle, before);
                }
            }
        },

        _removeObject: function (data, searchId, key) {
            for (var i = 0, len = data.length; i < len; i++) {
                if (!ej.isNullOrUndefined(data[i]) && !ej.isNullOrUndefined(data[i][key]) && data[i][key].toString() == searchId) {
                    data.splice(i, 1);
                    break;
                }
            }
        },

        _getObjectPosition: function (data, searchId, key) {
            for (var i = 0, len = data.length; i < len; i++) {
                if (!ej.isNullOrUndefined(data[i]) && !ej.isNullOrUndefined(data[i][key]) && data[i][key].toString() == searchId) {
                    return i;
                }
                if (data[i].hasOwnProperty('child')) {
                    var pos = this._getObjectPosition(data[i].child, searchId, key);
                    if (pos >= 0) return pos;
                }
            }
            return -1;
        },

        _convertDataSourceTypes: function (data, resultobj) {
            for (var j = 0; j < data.child.length; j++) {
                ej.createObject(this.model.fields.parentId, ej.getObject(this.model.fields.id, data), data.child[j]);
                resultobj.push(data.child[j]);
                if (data.child[j].hasOwnProperty('child') && data.child[j].child.length > 0) {
                    this._convertDataSourceTypes(data.child[j], resultobj);
                }
            }
            if (data['child']) {
                delete data['child'];
                ej.createObject(this.model.fields.hasChild, true, data);
            }
            return resultobj;
        },

        _childObjectCollection: function (childNodes, groupedObj, resultobj, tempType) {
            for (var j = 0, len = childNodes.length; j < len; j++) {
                var temp = this._getChildNodes(groupedObj, { id: ej.getObject(this.model.fields.id, childNodes[j]) });
                if (temp) {
                    if (tempType == 2) {
                        if (!resultobj[j].hasOwnProperty('child'))
                            resultobj[j].child = [];
                        resultobj[j].child = this._childObjectCollection(temp, groupedObj, temp, tempType);
                    }
                    else {
                        resultobj = resultobj.concat(temp);
                        resultobj = this._childObjectCollection(temp, groupedObj, resultobj, tempType);
                    }
                }
            }
            return resultobj;
        },

        _updateCopyData: function (i, obj , childNodes) {
            var newTree = obj.model.fields; temp = childNodes, arr = JSON.parse(JSON.stringify(childNodes[i])), proxy = this;
            $.each(this.model.fields, function (key, value) {
                if (key !== "dataSource" || key !== "query")
                    if (temp[i][proxy.model.fields[key]] !== undefined) {
                        delete arr[proxy.model.fields[key]];
                        arr[newTree[key]] = temp[i][proxy.model.fields[key]];
                    }
            })
            var tempArr = $.extend(tempArr, arr, false);
            return tempArr;
        },

        _updateDataFields: function (obj, childNodes, searchId, tree2, templateType) {
            var childData = [];
            for (var j = 0, len = childNodes.length; j < len; j++) {
                if (templateType == 1) {
                    this._removeObject(obj, searchId, this.model.fields.parentId);
                    this._deepPropertyDelete(this.model.fields.parentId, childNodes[j]);
                    this._deepPropertyDelete(this.model.fields.hasChild, childNodes[j]);
                }
                if (childNodes[j].hasOwnProperty('child'))
                    childNodes[j].child = this._updateDataFields(obj, childNodes[j].child, ej.getObject(this.model.fields.id, childNodes[j]), tree2, templateType);
                childData.push(this._updateCopyData(j, tree2, childNodes));
            }
            return childData;
        },
        _deepPropertyDelete: function (nameSpace, from) {
            if (!from || ej.isNullOrUndefined(nameSpace)) return undefined;
            var splits = nameSpace.split('.');
            if (splits.length > 1)
                deepDelete(splits.slice(1).join('.'), from[splits[0]]);
            else
                delete from[nameSpace];
        },

        _findAndUpdate: function (searchId, parentId, obj, index, tree2, dropEle, before) {
            if (ej.isNullOrUndefined(obj)) return;
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    var fieldId = ej.getObject(this.model.fields.id, obj[i]);
                    if (!ej.isNullOrUndefined(obj[i]) && !ej.isNullOrUndefined(fieldId) && fieldId.toString() == searchId) {
                        if (this._id == tree2._id) {
                            (!ej.isNullOrUndefined(parentId)) ? (ej.createObject(this.model.fields.parentId, parentId, obj[i])) : (this._deepPropertyDelete(this.model.fields.parentId, obj[i]));
                            var list = this.dataSource(), proxy = this;
                            if (this._deepWatch) {
                                var remvObj = obj.splice(i, 1);
                                var pos = this._getObjectPosition(list, dropEle.attr("id"), this.model.fields.id);
                                (pos >= 0 && !dropEle.is("A")) ? obj.splice(before ? pos : pos + 1, 0, remvObj[0]) : obj.push(remvObj[0]);
                                this._oldDataSource = JSON.parse(JSON.stringify(obj));
								this.dataSource(obj);
                            }
                            this._templateType = this._getTemplateType(list, this.model.fields);
                            this._dataSource = (this._templateType == 1) ? this._groupingObjects(list, function (list) { return [!ej.isNullOrUndefined(list) && [ej.getObject(proxy.model.fields.parentId, list)].toString()]; }) : list;
                        } else {
                            var remObj = [], childNodes, proxy = this, groupedObj, result = [], nodeArr = [];
                            groupedObj = this._groupingObjects(obj, function (obj) { return [!ej.isNullOrUndefined(obj) && [ej.getObject(proxy.model.fields.parentId, obj)].toString()]; });
                            nodeArr = obj.splice(i, 1);
                            remObj.push(this._updateCopyData(0, tree2, nodeArr));
                            childNodes = this._getChildNodes(groupedObj, { id: searchId });
                            if (childNodes && childNodes.length > 0)
                                childNodes = this._childObjectCollection(childNodes, groupedObj, childNodes, tree2._templateType);
                            if (tree2._templateType == 2) {
                                if (childNodes && childNodes.length > 0) {
                                    var childData = this._updateDataFields(obj, childNodes, searchId, tree2, this._templateType);
                                    if (!remObj[0].hasOwnProperty('child'))
                                        remObj[0].child = [];
                                    remObj[0].child = childData;
                                }
                                this._deepPropertyDelete(tree2.model.fields.parentId, remObj[0]);
                                this._deepPropertyDelete(tree2.model.fields.hasChild, remObj[0]);
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, pos) : tree2._newDataSource.splice(pos, 0, remObj[0]);
                                }
                                else {
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, index) : tree2._newDataSource.splice(index, 0, remObj[0]);
                                }
                            } else {
                                if (childNodes && childNodes.length > 0) {
                                    for (var j = 0, len = childNodes.length; j < len; j++) {
                                        this._removeObject(obj, ej.getObject(this.model.fields.id, childNodes[j]), this.model.fields.id);
                                    }
                                    this._dataSource = (this._templateType == 1) ? this._groupingObjects(obj, function (obj) { return [!ej.isNullOrUndefined(obj) && [ej.getObject(proxy.model.fields.parentId, obj)].toString()]; }) : obj;
                                }
                                (parentId) ? (ej.createObject(tree2.model.fields.parentId, parentId, remObj[0])) : this._deepPropertyDelete(tree2.model.fields.parentId, remObj[0]);
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    (pos >= 0 && !dropEle.is("A")) ? tree2._newDataSource.splice(before ? pos : pos + 1, 0, remObj[0]) : tree2._newDataSource.push(remObj[0]);
                                }
                                else
                                    tree2._newDataSource.push(remObj[0]);
                                var childData = [];
                                if (childNodes && childNodes.length > 0) {
                                    if (!(this.dataSource() instanceof ej.DataManager)) {
                                        for (var i = 0; i < childNodes.length; i++) {
                                            childData.push(this._updateCopyData(i, tree2, childNodes));
                                        }
                                        childNodes = childData;
                                    }
                                    var collection = tree2._newDataSource = tree2._newDataSource.concat(childNodes);
                                    tree2._dataSource = (tree2._templateType == 1) ? tree2._groupingObjects(collection, function (collection) { return [!ej.isNullOrUndefined(collection) && [ej.getObject(tree2.model.fields.parentId, collection)].toString()]; }) : collection;
                                }
                            }
                            if (tree2._deepWatch) {
                                tree2.dataSource(tree2._newDataSource);
                                tree2._oldDataSource = JSON.parse(JSON.stringify(tree2._newDataSource));
                            }
                            if (this._deepWatch) {
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                        }
                        break;
                    }
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    if (ej.getObject(this.model.fields.id, obj[i]).toString() == searchId) {
                        var remObj = obj.splice(i, 1);
                        if (this._id == tree2._id) {
                            if (this._deepWatch) {
                                var pos = this._getObjectPosition(this._newDataSource, dropEle.attr("id"), this.model.fields.id);
                                pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                (parentId) ? this._changeObjectPos(parentId, remObj, this._newDataSource, pos) : this._newDataSource.splice(pos, 0, remObj[0]);
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                            else
                                (parentId) ? this._changeObjectPos(parentId, remObj, this._newDataSource, index) : this._newDataSource.splice(index, 0, remObj[0]);
                        } else {
                            remObj = this._updateDataFields(obj, remObj, searchId, tree2, this._templateType);
                            if (tree2._templateType == 1) {
                                // convert nested child datasource into id & parentId case datasource
                                var result = [];
                                if (remObj[0].hasOwnProperty('child')) {
                                    result = tree2._convertDataSourceTypes(remObj[0], result);
                                    remObj[0] = remObj.concat(result);
                                } else
                                    remObj[0] = remObj.concat();
                                (parentId) ? ej.createObject(tree2.model.fields.parentId, parentId, remObj[0][0]) : this._deepPropertyDelete(tree2.model.fields.parentId, remObj[0][0]);
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    (pos >= 0 && !dropEle.is("A")) ? tree2._newDataSource.splice(before ? pos : pos + 1, 0, remObj[0][0]) : tree2._newDataSource.push(remObj[0][0]);
                                    tree2._newDataSource = tree2._newDataSource.concat(result);
                                }
                                else
                                    tree2._newDataSource = tree2._newDataSource.concat(remObj[0]);
                            } else {
                                if (tree2._deepWatch) {
                                    var pos = this._getObjectPosition(tree2._newDataSource, dropEle.attr("id"), tree2.model.fields.id);
                                    pos = (pos >= 0 && !dropEle.is("A")) ? (before ? pos : pos + 1) : index;
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, pos) : tree2._newDataSource.splice(pos, 0, remObj[0]);
                                }
                                else
                                    (parentId) ? tree2._changeObjectPos(parentId, remObj, tree2._newDataSource, index) : tree2._newDataSource.splice(index, 0, remObj[0]);
                            }
                            if (tree2._deepWatch) {
                                tree2.dataSource(tree2._newDataSource);
                                tree2._oldDataSource = JSON.parse(JSON.stringify(tree2._newDataSource));
                            }
                            if (this._deepWatch) {
                                this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
								this.dataSource(this._newDataSource);
                            }
                        }
                        return true;
                    }
                    else if (obj[i].hasOwnProperty('child')) {
                        if (this._findAndUpdate(searchId, parentId, obj[i].child, index, tree2, dropEle, before))
                            break;
                    }
                }
            }
        },

        _changeObjectPos: function (searchId, remObj, data, index) {
            for (var i = 0, objlen = data.length; i < objlen; i++) {
                if (ej.getObject(this.model.fields.id, data[i]).toString() == searchId) {
                    if (data[i].hasOwnProperty('child')) {
                        data[i].child.splice(index, 0, remObj[0]);
                    } else {
                        data[i].child = [];
                        data[i].child.push(remObj[0]);
                    }
                    return true;
                }
                else if (data[i].hasOwnProperty('child')) {
                    if (this._changeObjectPos(searchId, remObj, data[i].child, index))
                        break;
                }
            }
        },

        _finalizeEditing: function (element) {
            if ($(element)[0] != null) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                if (thisObj) {
                    thisObj._preventEditable();
                    thisObj.model.allowEditing && thisObj._allowEditable();
                }
            }
        },

        _updateCheckState: function (element) {
            if (this._isTreeElement(element)) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView'), chdNodes;
                if (thisObj && thisObj.model.showCheckbox) {
                    chdNodes = element.children('ul').find('.e-item > div > .e-chkbox-wrap > .checked').closest('.e-item').addClass('checked');
                    if (chdNodes.length > 0)
                        thisObj._isCheckedAction();
                    else {
                        var action = (thisObj.isNodeChecked(element)) ? "_nodeCheck" : "_nodeUncheck";
                        thisObj[action](element.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
                    }
                }
            }
        },

        _autoGenerateNodes: function (element) {
            if ($(element)[0] != null) {
                var thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                if (thisObj && thisObj.model.showCheckbox) {
                    if (element.find(".e-chkbox-wrap").length == 0) {
                        this._checkboxOnTemplate(element[0].children[0]);
                        var subItems = element.find('.e-item');
                        for (var i = 0, len = subItems.length; i < len ; i++)
                            this._checkboxOnTemplate(subItems[i].children[0]);
                        element.find(".nodecheckbox").ejCheckBox({ cssClass: thisObj.model.cssClass, change: thisObj._checkedChange });
                    }
                } else
                    element.find('.e-chkbox-wrap').remove();
            }
        },

        _appendNode: function (element, outerLi) {
            if (this._isTreeElement(element)) {
                var thisObj, outerUl, divTag, nodeid, nodeText, data, parentId, expandList, isExpanded;
                if (element.find('ul')[0] == null) {
                    thisObj = element.closest('.e-treeview.e-js').data('ejTreeView');
                    if (thisObj) {
                        isExpanded = this._isNodeExpanded(element);
                        if (!isExpanded && thisObj.model.loadOnDemand && element.find('> div > div').first().hasClass('e-plus'))
                            thisObj._createChildNodesWhenExpand(element, null, null, null, outerLi, thisObj);
                    }
                    if (!(this.dataSource() instanceof ej.DataManager && thisObj.model.loadOnDemand && element.find('> div > div').first().hasClass('e-plus')))
                        this._doAfterExpand(element, outerLi, thisObj);
                    if (this._deepWatch && (this._templateType == 1)) {
                        this._updateField(this._newDataSource, element.attr("id"), this.model.fields, "hasChild", true);
                        this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
						this.dataSource(this._newDataSource);
                    }
                }
                else
                    $(element.find('ul')[0]).append(outerLi);
                (!this.isDisabled(element)) && this._expandNode(element);
            }
            else {
                if (this.element.is('UL')) {
                    this.element.append(outerLi);
                } else if (this.element.children('ul:first').length > 0) {
                    this.element.children('ul:first').append(outerLi);
                } else {
                    outerUl = ej.buildTag("ul.e-treeview-ul", "", {}, { role: "group" });
                    outerUl.append(outerLi);
                    this.element.append(outerUl);
                }
            }
            expandList = this.element.find(".e-item.expanded");
            for (var i = 0; i < expandList.length; i++) {
                (this.model.loadOnDemand && !(this.dataSource() instanceof ej.DataManager)) ? this._createChildNodesWhenExpand($(expandList[i])) : this._expandNode($(expandList[i]));
            }
            expandList.removeClass("expanded");
            this.model.showCheckbox && this._isCheckedAction();
        },

        _doAfterExpand: function (element, outerLi, thisObj) {
            var outerUl = ej.buildTag("ul.e-treeview-ul", "", {}, { role: "group", style: "display:none" });
            $(outerUl).append($(outerLi));
            if ($(element.find('div')[1]).length == 0) {
                var divTag = document.createElement('div');
                divTag.setAttribute('role', 'presentation');
                divTag.className = 'e-icon e-minus';
                $(element.find('div')).append($(divTag));
            } else if (!$(element.find('div')[1]).hasClass('e-minus'))
                $(element.find('div')[1]).addClass('e-icon e-plus');
            if (thisObj && thisObj.model.loadOnDemand && element.find('ul').length > 0)
                element.children('ul').append($(outerLi));
            else
                element.append($(outerUl));
        },

        _modifyCss: function (liElement) {
            liElement = $(liElement);
            if (liElement[0] != null && liElement.find('.e-item').length == 0) {
                liElement.removeClass('e-collapse').attr("aria-expanded", false).find('> div > .e-icon').removeClass('e-icon e-minus').closest('.e-item').find('ul').remove();
                if (this._deepWatch) {
                    this._updateField(this._newDataSource, liElement.attr("id"), this.model.fields, "expanded", false);
                    (this._templateType == 1) && this._updateField(this._newDataSource, liElement.attr("id"), this.model.fields, "hasChild", false);
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
            }
        },

        _applyFirstLastChildClass: function () {
            $(this._liList).removeClass('first last').filter(':first-child:not(:last-child)').addClass('first');
            $(this._liList).filter(':last-child').addClass('last');
        },

        _expandEventHandler: function (event) {
            var target = $(event.target), selectedNode, liElement;
            if (target.hasClass("e-icon") || target.closest('.e-item').hasClass("e-node-disable")) return;
            if (!(event.type === "dblclick" && this.model.allowEditing)) {
                event.preventDefault();
                selectedNode = (target.is('A')) ? $(target.siblings('div')) : $(target.parents(".e-text-wrap").find('div'));
                if (this.model.fullRowSelect && (target.is('div.e-text-wrap') || target.is('div.e-fullrow')))
                    selectedNode = target.closest('.e-item').find("> .e-text-wrap > div");
                liElement = target.closest('.e-item');
                if (selectedNode.hasClass('e-minus'))
                    this._collapseNode(liElement);
                else {
                    if (this.model.loadOnDemand && selectedNode.find(".e-item").length == 0) {
                        this._ClickEventHandler({ target: selectedNode[0] });
                    }
                    else this._expandNode(liElement);
                }
            }
        },

        _inlineEdit: function (event) {
            event.preventDefault();
            var target = $(event.target);
            if (!target.hasClass('input-text') && !target.hasClass("e-node-disable") ) {
                if (!target.is('A'))
                    target = target.closest('.e-text');
                if (target.is('A') && !target.hasClass("e-node-disable")) {
                    this._inlineEditAction(target);
                }
            }
            return false;
        },

        _inlineEditAction: function (element) {
            var editTextBox = this.element.find('.e-item > div > .e-text > #Edit_Input');
            (editTextBox[0] == null) && this._createEditTextBox(element);
        },

        _createEditTextBox: function (values) {
            var argsData = { currentElement: values };
            if (this._triggerEvent('beforeEdit', argsData))
                return false;
            var editTextBox = this.element.find('.e-item > div > .e-text > #Edit_Input');
            if (editTextBox[0] == null) {
                var size, textBox = ej.buildTag('Input.input-text#Edit_Input', "", "", { type: 'text', value: $.trim(values.text()).replace(/\n\s+/g, " "), name: 'inplace_value' });
                $(textBox).css("width", (values.outerWidth() + 5) + "px");
                $(textBox).css("height", values.outerHeight() + "px");
                textBox.addClass("e-tree-input e-textbox");
                this._beforeEditText = values.text();
                values[0].lastChild.nodeValue = "";
                values.addClass('e-editable').append(textBox);
                editTextBox = textBox;
                size = (editTextBox.val().length == '') ? 3 : values.outerWidth() + 20;
                this._mousePositionAtEnd(editTextBox);
                this._currentEditableNode = values;
                this._on(editTextBox, 'keypress', this._editTextBoxKeyPress)
                    ._on(editTextBox, 'keydown', this, this._pressEscKey)
                    ._on(editTextBox, 'mousedown pointerdown MSPointerDown', this, this._preventPropagation)
                    ._on(editTextBox, this.model.expandOn, this, this._preventPropagation)
                    ._on(editTextBox, 'blur', this._focusout);
            }
            return editTextBox;
        },

        _preventPropagation: function (e) {
            e.stopImmediatePropagation();
            this._isTextbox = true;
        },

        _editTextBoxKeyPress: function (event) {
            event.target.size = event.target.value.length + 1;
        },

        _mousePositionAtEnd: function (ctl) {
            (ctl.focus) && ctl.focus();
            (ctl.select) && ctl.select();
            return true;
        },

        _focusElement: function (e) {
            if (this._isTextbox) return;
            if(e && (e.type == "touchstart" || e.type == "pointerdown" || e.type == "MSPointerDown")) {
                var ele = $(e.currentTarget);
                (ele.hasClass("e-text")) && this.selectNode(ele.closest('.e-item'));
            }
            this.element.focus();
        },

        _focusout: function (e) {
            var editTextBox = $(e.currentTarget), data, element;
            this._isTextbox = false;
            data = { id: editTextBox.closest('.e-item').attr('id'), oldText: this._beforeEditText, newText: editTextBox.val() };
            (this._triggerEvent('inlineEditValidation', data)) ? this._cancelAction(editTextBox) : this._saveAction(editTextBox, e);
        },

        _pressEscKey: function (event) {
            event.cancelBubble = true;
            event.returnValue = false;
            var editTextBox = $(event.currentTarget);
            if (editTextBox[0] != null) {
                if (event.keyCode == 13) {
                    event.stopPropagation();
                    this._focusout(event);
                }
                if (event.keyCode == 27)
                    this._cancelAction(editTextBox);
                if (event.keyCode == 13 || event.keyCode == 27) {
                    var browserInfo = ej.browserInfo(), _isIE8;
                    _isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
                    (_isIE8) && this.element.focus();
                }
            }
        },

        _onFocusHandler: function (event) {
            event.preventDefault();
        },

        _onKeyDown: function (currentEle, focusEle) {
            currentEle.find('> div > .e-text:first').removeClass('e-node-focus');
            focusEle.find('> div > .e-text:first').addClass('e-node-focus');
            if (this.model.fullRowSelect) {
                currentEle.removeClass("e-li-focus");
                focusEle.addClass("e-li-focus");
            }
        },

        _KeyPress: function (e) {
            var code, node, element;
            var proxy = this;
            element = (this.element.is("ul")) ? this.element : this.element.find("> ul");
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            if (proxy.model.allowKeyboardNavigation && (proxy.element.find('#Edit_Input').length < 1) && proxy.element.find(".e-chkbox-wrap.e-focus").length < 1) {
                this.element.find(".e-animate").removeClass("e-animate");
                var nextElement, selectedItem, liVisible, activeNode;
                selectedItem = $(element.find(".e-item > div > .e-text.e-active").closest('.e-item')[0]);
                liVisible = element.find('.e-item:visible');
                if (proxy._focusedNode) {
                    activeNode = proxy._focusedNode;
                    proxy._focusedNode = null;
                } else
                    activeNode = element.find('.e-text.e-node-focus').closest('.e-item');
                if (code == 113) {
                    e.preventDefault();
                    var element = (activeNode.length > 0) ? activeNode : selectedItem;
                    if (element.length > 0 && proxy.model.allowEditing && !this.model.template) {
                        e.target = element.find('> div > .e-text:first');
                        proxy._inlineEdit(e);
                    }
                }
                if (code == 40 && !e.altKey) {
                    e.preventDefault();
                    var ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    var nextEle = this._getNextEle(liVisible, ele);
                    if (proxy._KeyPressEventHandler((nextEle.length > 0) ? nextEle : null, proxy, code, e)) return;
                    if (nextEle.length > 0)
                        proxy._onKeyDown(activeNode, nextEle);
                }
                else if (code == 38 && !e.altKey) {
                    e.preventDefault();
                    var ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    var prevEle = this._getPrevEle(liVisible, ele);
                    if (proxy._KeyPressEventHandler((prevEle.length > 0) ? prevEle : null, proxy, code, e)) return;
                    if (prevEle.length > 0)
                        proxy._onKeyDown(activeNode, prevEle);
                }
                else if ((code == 39 && !this.model.enableRTL && !e.altKey) || (code == 37 && this.model.enableRTL)) {
                    e.preventDefault();
                    var nextEle, expandIcon;
                    expandIcon = (activeNode.length > 0) ? activeNode.find('> div > div').first() : selectedItem.find('> div > div').first();
                    nextEle = expandIcon.closest('.e-item');
                    if (expandIcon.hasClass('e-plus')) {
                        if (this.model.loadOnDemand && nextEle.find("> ul .e-item").length == 0) {
                            this._ClickEventHandler({ target: expandIcon[0] });
                        }
                        else this._expandNode($(liVisible[liVisible.index(nextEle)]));
                    } else {
                        var nextEle = this._getNextEle(liVisible, nextEle);
                        if (proxy._KeyPressEventHandler((nextEle.length > 0) ? nextEle : "", proxy, code, e)) return;
                        if (nextEle.length > 0 && nextEle[0] == expandIcon.closest('.e-item').find('ul > .e-item:first')[0] || nextEle.find('ul > .e-item').first().hasClass('e-node-disable'))
                            proxy._onKeyDown(activeNode, nextEle);
                    }
                }
                else if ((code == 37 && !this.model.enableRTL && !e.altKey) || (code == 39 && this.model.enableRTL)) {
                    e.preventDefault();
                    var prevEle, collapseIcon;
                    collapseIcon = (activeNode.length > 0) ? activeNode.find('> div > div').first() : selectedItem.find('> div > div').first();
                    prevEle = collapseIcon.closest('.e-item');
                    if (collapseIcon.hasClass('e-minus')) {
                        this._collapseNode($(liVisible[liVisible.index(collapseIcon.closest('.e-item'))]));
                    } else {
                        prevEle = $(liVisible[liVisible.index(prevEle)]).closest('ul').closest('.e-item');
                        if (proxy._KeyPressEventHandler((prevEle.length > 0) ? prevEle : "", proxy, code, e)) return;
                        if (prevEle.length > 0) {
                            proxy._onKeyDown(activeNode, prevEle);
                        }
                    }
                }
                else if (code == 36 && !e.altKey) {
                    e.preventDefault();
                    var firstEle, ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    firstEle = $(liVisible).first();
                    if (firstEle.hasClass('e-node-disable') || firstEle.hasClass('hidden'))
                        firstEle = this._getNextEle(liVisible, firstEle);
                    if ((selectedItem.length > 0 && activeNode.length == 0 && selectedItem[0] != firstEle[0]) || (activeNode.length > 0 && activeNode[0] != firstEle[0])) {
                        if (proxy._KeyPressEventHandler(firstEle, proxy, code, e)) return;
                        proxy._onKeyDown(ele, firstEle);
                    }
                }
                else if (code == 35 && !e.altKey) {
                    e.preventDefault();
                    var lastEle, ele = (activeNode.length > 0) ? activeNode : selectedItem;
                    lastEle = $(liVisible).last();
                    if (lastEle.hasClass('e-node-disable') || lastEle.hasClass('hidden'))
                        lastEle = this._getPrevEle(liVisible, lastEle);
                    if ((selectedItem.length > 0 && activeNode.length == 0 && selectedItem[0] != lastEle[0]) || (activeNode.length > 0 && activeNode[0] != lastEle[0])) {
                        if (proxy._KeyPressEventHandler(lastEle, proxy, code, e)) return;
                        proxy._onKeyDown(ele, lastEle);
                    }
                }
                else if (code == 13) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                    var angEle = currentEle.find('> div > .e-text');
                    angEle.removeClass('e-node-focus');
                    this.model.fullRowSelect && currentEle.removeClass("e-li-focus");
                    angEle.hasClass('e-active') ? (proxy.model.allowMultiSelection && proxy._nodeUnSelectionAction(currentEle, event)) : proxy._nodeSelectionAction(currentEle, e);
                    proxy._focusedNode = currentEle;
                }
                else if (code == 32) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                    if (currentEle.length > 0 && this.model.showCheckbox) {
                        var chkBoxEle = currentEle.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0];
                        if (chkBoxEle.checked)
                            this._nodeUncheck(chkBoxEle);
                        else
                            this._nodeCheck(chkBoxEle);
                        proxy._focusedNode = currentEle;
                    }
                }
                else if (code == 46) {
                    e.preventDefault();
                    var currentEle = (activeNode.length > 0) ? activeNode : (this.model.allowMultiSelection ? element.find(".e-item > div > .e-text.e-active").closest('.e-item') : selectedItem);
                    (currentEle.length > 0) && this._removeNode(currentEle, e);
                }
                else if (e && e.ctrlKey == true) {
                    if (code == 88 && this.model.allowDragAndDrop && this.model.allowDropChild) {
                        e.preventDefault();
                        var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                        if (currentEle.length > 0) {
                            var parent = currentEle.parents('.e-item:first');
							if (this._triggerEvent('beforeCut', { target: currentEle, nodeDetails: this._getNodeDetails(currentEle), keyCode: code, event: e })) return;
                            this._cutNode = $(liVisible[liVisible.index(currentEle)]).detach();
                            if ($(this._cutNode)[0] != null) {                                
                                this._isRender = false;
                                this.unselectNode(currentEle);
                                if (parent.find('> ul > .e-item').length == 0) {
                                    this.collapseNode(parent);
                                    this._modifyCss(parent);
                                }
                                this._isRender = true;
                                this._triggerEvent('nodeCut', { parentElement: parent, parentDetails: this._getNodeDetails(parent), keyCode: code, event: e });
                            }
                        }
                    }
                    else if (code == 86 && this._cutNode != null && this.model.allowDragAndDrop && this.model.allowDropChild) {
                        e.preventDefault();
                        var currentEle = (activeNode.length > 0) ? activeNode : selectedItem;
                        currentEle = $(liVisible[liVisible.index(currentEle)]);
                        currentEle.length === 0 && (currentEle = this.element);
                        var element = this._cutNode.find(" > div > .e-text").first();
                        if ($(liVisible).length > 0) {
                            if (this._triggerEvent('beforePaste', { target: currentEle, nodeDetails: this._getNodeDetails(currentEle), keyCode: code, event: e })) return;
                            this._isRender = false;
                            this._dropAsChildNode(currentEle, element, e);
                            this._isRender = true;
                            this._cutNode = null;
                            var currentNode = element.closest('.e-item');
                            this._triggerEvent('nodePaste', { target: currentNode, nodeDetails: this._getNodeDetails(currentNode), keyCode: code, event: e });
                        }
                    }
                    else if (proxy.model.allowMultiSelection)
                        proxy._focusedNode = activeNode;
                }
            }
        },

        _getNextEle: function (liVisible, ele) {
            var index = liVisible.index(ele), nextEle;
            do {
                index++;
                nextEle = $(liVisible[index]);
            }
            while (nextEle.hasClass('e-node-disable') || nextEle.hasClass('hidden'))
            return nextEle;
        },

        _getPrevEle: function (liVisible, ele) {
            var index = liVisible.index(ele), prevEle;
            do {
                index--;
                prevEle = $(liVisible[index]);
            }
            while (prevEle.hasClass('e-node-disable') || prevEle.hasClass('hidden'))
            return prevEle;
        },

        _removeChildNodes: function (obj, groupedObj, id) {
            var len = 0, currentid;
            for (var i = 0; i < groupedObj.length; i++) {
                var parentId = ej.getObject(this.model.fields.parentId, groupedObj[i][0]);
                if (!ej.isNullOrUndefined(parentId) && (parentId).toString() == id) {
                    len = groupedObj[i].length; break;
                }
            }
            for (var i = 0; i < len; i++) {
                for (var j = 0; j < obj.length; j++) {
                    var parentID = ej.getObject(this.model.fields.parentId, obj[j]);
                    if (!ej.isNullOrUndefined(parentID) && (parentID).toString() == id) {
                        if (!ej.isNullOrUndefined(obj[j])) currentid = ej.getObject(this.model.fields.id, obj[j]).toString();
                        obj.splice(j, 1);
                        this._removeChildNodes(obj, groupedObj, currentid);
                        break;
                    }
                }
            }
        },

        _removeNode: function (node, event) {
            if (node[0] == null) return;
            if (node[0] != null && node.length > 0) {
                var parentNode, currentNode, _dataObj, liVisible, childNodes, proxy = this;
                parentNode = $(node[0]).closest('ul').closest('.e-item');
                currentNode = $(node[0]);
                if (this._triggerEvent('beforeDelete', { target: currentNode, nodeDetails: this._getNodeDetails(currentNode), parentElement: (parentNode[0] != null) ? parentNode : null, parentDetails: this._getNodeDetails(parentNode), event: event, removedNodes: node })) return;
                this._isRender = false;
                if (this.dataSource() instanceof ej.DataManager) {
                    _dataObj = this._newDataSource;
                    this._removeData(node, _dataObj);
                }
                else if (!ej.isNullOrUndefined(this.dataSource()) && this.dataSource().length > 0) {
                    _dataObj = this.dataSource();
                    this._removeData(node, _dataObj);
                    if (this._deepWatch) {
                        this._oldDataSource = JSON.parse(JSON.stringify(_dataObj));
						this.dataSource(_dataObj);
                    }
                }
                node.remove();
                this._modifyCss(parentNode);
                this._updateNodes();
                this._updateCheckState(parentNode);
                this._isRender = true;
                if (this._triggerEvent('nodeDelete', { parentElement: (parentNode[0] != null) ? parentNode : null, parentDetails: this._getNodeDetails(parentNode), event: event, removedNodes: node })) return;
                var proxy = this, _dataObj = this.dataSource();
                setTimeout(function () {
                    if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                        proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [ej.getObject(proxy.model.fields.parentId, _dataObj)].toString()]; });
                }, 300);
            }
        },

        _removeData: function (node, _dataObj) {
            for (var j = 0, len = node.length; j < len; j++) {
                (this._templateType == 2) ? this._removeRemoteData(_dataObj, $(node[j]), this.model.fields) : this._removeLocalData(_dataObj, $(node[j]));;
            }
        },

        _removeLocalData: function (_dataObj, currentNode) {
            var proxy = this;
            for (var i = 0; i < _dataObj.length; i++) {
                var id = currentNode.attr("id");
                var fieldId = ej.getObject(this.model.fields.id, _dataObj[i]);
                if (fieldId && (fieldId).toString() == id) {
                    var groupedObj = this._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [ej.getObject(proxy.model.fields.parentId, _dataObj)].toString()]; });
                    _dataObj.splice(i, 1);
                    this._removeChildNodes(_dataObj, groupedObj, id);
                    break;
                }
            }
        },

        _removeRemoteData: function (obj, currentNode, mapper) {
            for (var i = 0; i < obj.length; i++) {
                var id = currentNode.attr("id");
                var fieldId = ej.getObject(mapper.id, obj[i]);
                if (fieldId && (fieldId).toString() == id) {
                    obj.splice(i, 1);
                    break;
                }
                if (obj[i].hasOwnProperty('child'))
                    this._removeRemoteData(obj[i].child, currentNode, mapper.child ? mapper.child : mapper);
            }
        },

        _updateNodes: function () {
            this._beforeBaseClass();
            this._applyFirstLastChildClass();
            this._updateExpandedNodes();
            this._updateCheckedNodes();
            this._updateSelectedNode();
        },

        _updateField: function (obj, searchId, mapper, fieldName, fieldValue) {
            if (ej.isNullOrUndefined(mapper) || this.dataSource() == null || ej.isNullOrUndefined(obj) || ej.isNullOrUndefined(searchId) || ej.isNullOrUndefined(fieldName)) return;
            if (this._templateType == 1) {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    var fieldId = ej.getObject(mapper.id, obj[i]);
                    if (!ej.isNullOrUndefined(obj[i]) && !ej.isNullOrUndefined(fieldId) && fieldId.toString() == searchId) {
                        var fname = mapper[fieldName] ? mapper[fieldName] : fieldName;
                        obj[i][fname] = fieldValue;
                        if (fieldValue == false) delete obj[i][fname];
                        var newobj = obj[i];
                        obj.splice(i, 1, newobj);
                        break;
                    }
                }
            }
            else {
                for (var i = 0, objlen = obj.length; i < objlen; i++) {
                    var fieldID = ej.getObject(mapper.id, obj[i]);
                    if (!ej.isNullOrUndefined(obj[i]) && !ej.isNullOrUndefined(fieldID) && fieldID.toString() == searchId) {
                        var fname = mapper[fieldName] ? mapper[fieldName] : fieldName;
                        obj[i][fname] = fieldValue;
                        if (fieldValue == false) delete obj[i][fname];
                        var newobj = obj[i];
                        obj.splice(i, 1, newobj);
                        break;
                    }
                    if (obj[i].hasOwnProperty('child'))
                        this._updateField(obj[i].child, searchId, mapper.child ? mapper.child : mapper, fieldName, fieldValue);
                }
            }
        },

        _removeField: function (obj, mapper, fieldName) {
            if (ej.isNullOrUndefined(mapper) || this.dataSource() == null || ej.isNullOrUndefined(obj)) return;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i][mapper[fieldName]] != undefined) delete obj[i][mapper[fieldName]];
                if (obj[i].hasOwnProperty('child'))
                    this._removeField(obj[i].child, mapper.child ? mapper.child : mapper, fieldName);
            }
        },

        _KeyPressEventHandler: function (nextElement, proxy, code, event) {
            var nodeDetails, data, path, isExpanded;
            if ($(nextElement)[0] != null) {
                isExpanded = this._isNodeExpanded(nextElement);
                nodeDetails = this._getNodeDetails(nextElement);
                path = proxy._getPath(nextElement);
                data = { keyCode: code, currentElement: nextElement, value: nodeDetails.text, isExpanded: isExpanded, path: path, event: event, id: nodeDetails.id, parentId: nodeDetails.parentId };
            } else {
                data = { keyCode: code, currentElement: nextElement, value: "", isExpanded: "", path: "", event: event, id: "", parentId: "" };
            }
            return this._triggerEvent('keyPress', data);
        },

        _documentClick: function (event) {
            if (event.target.id != 'Edit_Input')
                var editTextBox = $('#Edit_Input')[0], aTag, newText;
            if (editTextBox != null) {
                var aTag = $(editTextBox).closest('.e-text')[0], newText = editTextBox.value, parent = $(editTextBox).closest('.e-item');
                $(editTextBox).remove();
                aTag.lastChild.nodeValue = newText;
                $(aTag).removeClass('e-editable').removeAttr('style');
                this._updateField(this._newDataSource, parent.attr('id'), this.model.fields, "text", newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: parent.attr('id'), oldText: this._beforeEditText, newText: newText, target: parent, nodeDetails: this._getNodeDetails(parent), event: event });
            }
            if (this.element.find(event.target).length == 0) {
                var ele = this.element.find('.e-item > div > .e-text.e-node-focus');
                this._focusedNode = ele.closest('.e-item');
                ele.removeClass('e-node-focus');
            }
            else if ($(event.target).hasClass("e-active"))
                this._focusedNode = this.element.find(event.target).closest('.e-item');
        },

        _saveAction: function (values, event) {
            var newText = values.val(), parent = values.closest('.e-item'), aTag = values.closest('.e-text')[0];
            values.remove();
            if (aTag != null) {
                aTag.lastChild.nodeValue = newText;
                $(aTag).removeClass('e-editable');
                this._updateField(this._newDataSource, parent.attr('id'), this.model.fields, "text", newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: parent.attr('id'), oldText: this._beforeEditText, newText: newText, target: parent, nodeDetails: this._getNodeDetails(parent), event: event });
                this.element.focus();
                this._focusedNode = parent;
            }
        },

        _cancelAction: function (values) {
            var aTag = values.closest('.e-text')[0];
            values.remove();
            aTag.lastChild.nodeValue = this._beforeEditText;
            $(aTag).removeClass('e-node-hover e-editable');
            this.element.focus();
        },

        _mouseEnterEvent: function (event) {
            this.element.find('.e-node-hover').removeClass("e-node-hover");
            if ($(event.currentTarget).hasClass("e-text") && !$(event.currentTarget).hasClass("e-node-disable"))
                $(event.currentTarget).addClass("e-node-hover");
        },

        _mouseLeaveEvent: function (event) {
            $(event.currentTarget).removeClass("e-node-hover");
        },

        _liMouseEnterEvent: function (event) {
            this.element.find('.e-node-hover').removeClass("e-node-hover");
            this.element.find('.e-li-hover').removeClass("e-li-hover");
            var curLi = $(event.currentTarget).closest('.e-item');
            var curAng = curLi.find("> div .e-text");
            if (curAng.length > 0 && !curAng.hasClass("e-node-disable")) {
                curAng.addClass("e-node-hover");
                curLi.addClass("e-li-hover");
            }
        },

        _liMouseLeaveEvent: function (event) {
            var curLi = $(event.currentTarget).closest('.e-item');
            curLi.find("> div .e-text").removeClass("e-node-hover");
            curLi.removeClass("e-li-hover");
        },

        _onFocusOutHandler: function (event) {
            if (!this._isPopup) this._hidePopup();
            this._isPopup = false;
        },

        _createObjectByText: function (text, targetNode) {
            if (typeof text != "string") return;
            var obj = {};
            ej.createObject(this.model.fields.text, text, obj);
            if ($(targetNode)[0] != null)
                ej.createObject(this.model.fields.parentId, targetNode[0].getAttribute('id'), obj);
            return obj;
        },

        _addNodesWhenObject: function (obj, selectedNode) {
            var tempObj = JSON.stringify(this._dataSource), _dataObj = this.dataSource(), parentId, tempType;
            this._dataSource = [];
            if (this.dataSource() != null && this.dataSource() instanceof ej.DataManager)
                _dataObj = [];
            if (selectedNode[0] != null && selectedNode.length > 0)
                parentId = selectedNode[0].getAttribute('id');
            if (ej.isNullOrUndefined(obj.length)) {
                this._dataSource.push(obj);
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    this._setNodeId(obj, this.model.fields);
                    (!ej.isNullOrUndefined(parentId)) && (ej.createObject(this.model.fields.parentId, parentId, obj));
                    _dataObj.push(obj);
                }
            }
            else {
                this._dataSource = obj;
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    for (var j = 0; j < obj.length; j++) {
                        this._setNodeId(obj[j], this.model.fields);
                        if (parentId)
                            ej.createObject(this.model.fields.parentId, parentId, obj[j]);
                        else
                            this._deepPropertyDelete(this.model.fields.parentId, obj[j]);
                        _dataObj.push(obj[j]);
                    }
                }
            }
            tempType = this._templateType;
            this._templateType = 2;
            if (!this._liList)
                this._liList = $("li", this.element);
            var fragmentObj = document.createDocumentFragment();
            for (var i = 0, len = this._dataSource.length ; i < len; i++) {
                fragmentObj.appendChild(this._genTemplate(this._dataSource[i], this.model.fields));
                this._liList.push($(fragmentObj).children()[0]);
            }
            this._templateType = tempType;
            if (this.dataSource() != null && !(this.dataSource() instanceof ej.DataManager)) {
                this._dataSource = JSON.parse(tempObj);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(_dataObj));
					this.dataSource(_dataObj);
                }
            }
            return fragmentObj;
        },

        _setNodeId: function (dataObj, mapper) {
            var mapId = (mapper && mapper.id) ? mapper.id : this.model.fields.id;
            if (ej.isNullOrUndefined(dataObj[mapId]) || dataObj[mapId] == "") {
                dataObj[mapId] = this._id + "_" + this._indexID;
                this._indexID++;
            }
            if (dataObj.hasOwnProperty('child')) {
                var childObj = dataObj.child;
                for (var i = 0, len = childObj.length; i < len; i++) {
                    this._setNodeId(childObj[i], mapper.child);
                }
            }
        },

        _addExpandedNodes: function (index) {
            var _nodes = this.model.expandedNodes;
            this._removeNullInArray(_nodes);
            if ($.inArray(index, _nodes) == -1)
                this.model.expandedNodes.push(index);
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _removeExpandedNodes: function (index) {
            var _nodes = this.model.expandedNodes;
            if ($.inArray(index, _nodes) > -1) {
                this.model.expandedNodes.splice($.inArray(index, _nodes), 1);
                _nodes.length == 0 && (_nodes.push(-1));
            }
            this._persistValues(this.model.expandedNodes, "expandedNodes");
        },

        _persistValues: function (indexColl, valueType) {
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null) {
                var _nodes = indexColl, idColl = [], ele, id;
                for (var i = 0, len = _nodes.length; i < len; i++) {
                    if (!ej.isNullOrUndefined(_nodes[i]) && _nodes[i] >= 0) {
                        ele = this._liList[_nodes[i]], id = $(ele).attr('id');
                        (id) && idColl.push(id);
                    }
                }
                var cookieData = this._getCookies("_persistedValues");
                if (cookieData) {
                    var parsedData = JSON.parse(cookieData);
                    parsedData[valueType] = idColl;
                    parsedData = this._updatePersistAttr(parsedData);
                    this._setCookies("_persistedValues", JSON.stringify(parsedData));
                }
            }
        },

        _updatePersistAttr: function (parsedData) {
            if (ej.isNullOrUndefined(this._ignoreOnPersist)) {
                if ($.inArray('selectedNodes', this._addToPersist) == -1) delete parsedData.selectedNodes;
                if ($.inArray('expandedNodes', this._addToPersist) == -1) delete parsedData.expandedNodes;
                if ($.inArray('checkedNodes', this._addToPersist) == -1) delete parsedData.checkedNodes;
            }
            else {
                if ($.inArray('selectedNodes', this._ignoreOnPersist) > -1) delete parsedData.selectedNodes;
                if ($.inArray('expandedNodes', this._ignoreOnPersist) > -1) delete parsedData.expandedNodes;
                if ($.inArray('checkedNodes', this._ignoreOnPersist) > -1) delete parsedData.checkedNodes;
            }
            return parsedData;
        },

        _onChecked: function (element, args) {
            var liElement = element.closest('.e-item'), isChecked, evt, checknode, data;
            var nodeDetails = this._getNodeDetails(liElement);
            this._CurrenctSelectedNodes.push(nodeDetails.text);
            isChecked = this._isChecked(liElement);
            evt = !ej.isNullOrUndefined(args) ? !ej.isNullOrUndefined(args.event) ? args.event : "" : "";
            data = { currentElement: liElement, id: nodeDetails.id, parentId: nodeDetails.parentId, value: nodeDetails.text, currentNode: this._CurrenctSelectedNodes, currentCheckedNodes: this._checkedArray, isChecked: isChecked, event: evt };
            if (this._isRender) this._triggerEvent('nodeCheck', data);
        },

        _onUnChecked: function (element, args) {
            var liElement = element.closest('.e-item'), isUnChecked, evt, unchecknode, data;
            var nodeDetails = this._getNodeDetails(liElement);
            this._CurrenctSelectedNodes.push(nodeDetails.text);
            isUnChecked = this._isChecked(liElement);
            evt = !ej.isNullOrUndefined(args) ? !ej.isNullOrUndefined(args.event) ? args.event : "" : "";
            data = { currentElement: liElement, id: nodeDetails.id, parentId: nodeDetails.parentId, value: nodeDetails.text, currentNode: nodeDetails.text, currentUncheckedNodes: this._uncheckedArray, isChecked: isUnChecked, event: evt };
            this._triggerEvent('nodeUncheck', data);
        },

        _addCheckNodes: function (item) {
            var checkedArray = this.model.checkedNodes;
            this._removeNullInArray(checkedArray);
            !checkedArray instanceof Array && (checkedArray = []);
            if (checkedArray.indexOf(item) == -1) checkedArray.push(item);
        },

        _removeCheckNodes: function (item) {
            var checkedArray = this.model.checkedNodes;
            !checkedArray instanceof Array && (checkedArray = []);
            var i = checkedArray.indexOf(item);
            if (i != -1) {
                checkedArray.splice(i, 1);
                checkedArray.length == 0 && (checkedArray.push(-1));
            }
        },

        _removeNullInArray: function (array) {
            var i = array.indexOf(-1);
            if (i != -1) array.splice(i, 1);
        },

        _afterInsertingNode: function (outerLi) {
            this._addDragableClass();
            this._finalizeEditing(outerLi);
            var parentLi = outerLi.closest('ul').closest('.e-item');
            this._modifyCss(parentLi);
            this._updateCheckState(parentLi);
            this._isSelectedAction();
            if (parentLi.length > 0 && parentLi.hasClass('e-node-disable'))
                this._nodeDisableAction(parentLi);
            this._updateSelectedNode();
        },

        _insertBeforeOrAfter: function (txtobj, afterEle, before) {
            afterEle = this._getNodeByID(afterEle);
            if (afterEle[0] != null && afterEle.is('LI') && afterEle.hasClass('e-item')) {
                if (this._triggerEvent('beforeAdd', { data: txtobj, targetParent: (afterEle[0] != null) ? afterEle : null, parentDetails: this._getNodeDetails(afterEle) })) return;
                this._isRender = false;
                if (typeof txtobj != 'object')
                    txtobj = this._createObjectByText(txtobj);
                if (typeof txtobj != "object") return;
                (ej.getObject(this.model.parentId, txtobj)) && this._deepPropertyDelete(this.model.parentId, txtobj);
                outerLi = this._addNodesWhenObject(txtobj, afterEle);
                temp = document.createElement('ul');
                $(temp).append(outerLi); outerLi = $(temp.children);
                this.model.showCheckbox && outerLi.children().find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
                (afterEle.parents('.e-item:first').length > 0) ? afterEle.parents('.e-item:first').append(outerLi) : this.element.append(outerLi);
                this.model.showCheckbox && this._isCheckedAction();
                this._dropAsSiblingNode(afterEle, outerLi.find("> div > .e-text"), before, "");
                this._afterInsertingNode(outerLi);
                this._isRender = true;
                this._triggerEvent('nodeAdd', { data: txtobj, nodes: outerLi, parentElement: (afterEle[0] != null) ? afterEle : null, parentDetails: this._getNodeDetails(afterEle) });
                var proxy = this, _dataObj = this.dataSource();
                setTimeout(function () {
                    if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                        proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [ej.getObject(proxy.model.fields.parentId, _dataObj)].toString()]; });
                }, 300);
            }
        },

        _getNodeByID: function (node) {
            if (typeof node != "object" && node != "" && node != undefined) return this.element.find(this._checkValidId(node.toString()));
            node = $(node);
            (node.is("A") && node.hasClass('e-text')) && (node = node.closest('.e-item'));
            return node;
        },

        _checkValidId: function (myid) {
            return (myid[0] == "#") ? myid.replace(/(:|\.|\[|\]|,)/g, "\\$1") : "#" + myid.replace(/(:|\.|\[|\]|,)/g, "\\$1");;
        },

        _isTreeElement: function (node) {
            return $(node)[0] != null && node.is('LI') && node.hasClass('e-item');
        },

        _isUrl: function (url) {
            var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            return regexp.test(url);
        },

        _getChildUl: function (ele) {
            return this.model.fullRowSelect ? ele.children[2] : ele.children[1];
        },

        _sendAjaxOptions: function (url, trgt) {
            var proxy = this, dataobj, ajaxOptions;
            dataobj = this._getNodeDetails(trgt);
            dataobj['mapper'] = this.model.fields;
            dataobj['model'] = this.model;
            ajaxOptions = {
                url: url, data: dataobj, type: 'POST', async: true, crossDomain: true,
                dataType: 'JSON', contentType: "application/json; charset=utf-8",
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, trgt);
                    } catch (e) { }
                }, "error": function (data) {
                    try {
                        proxy._ajaxErrorHandler(data);
                    } catch (e) { }
                }
            };
            this._sendAjaxRequest(ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions) {
            var temp = JSON.parse(JSON.stringify(ajaxOptions));
            delete temp.success;     // To prevent user to edit ajax success and edit event handler
            delete temp.error;
            if (this._triggerEvent('beforeLoad', { ajaxOptions: temp })) return;
            delete temp.success;
            delete temp.error;
            $.extend(ajaxOptions, temp);  // The modified data will be restored in ajaxOptions
            $.ajax({
                type: ajaxOptions.type,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                async: ajaxOptions.async,
                contentType: ajaxOptions.contentType,
                crossDomain: ajaxOptions.crossDomain,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
            });
        },

        _ajaxSuccessHandler: function (data, targetNode) {
            this._isRender = false;        // To prevent event triggering
            (typeof data == "object") && this.addNode(data, targetNode);
            this._isRender = true;
            this._triggerEvent('loadSuccess', { data: data, targetParent: targetNode, parentDetails: this._getNodeDetails(targetNode) });
        },

        _ajaxErrorHandler: function (args) {
            this._triggerEvent('loadError', { error: args });
        },

        _wireEvents: function () {
            if (this._isDevice && $.isFunction($.fn.tap)) this._on(this.element.find('li'), 'tap', this._ClickEventHandler);
            else this._on(this.element, "click", this._ClickEventHandler)
            this._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn, this._expandEventHandler)
                ._on(this.element, "focus", this._onFocusHandler)
                ._on(this.element, "blur", this._onFocusOutHandler);
            this._wholeRowEvents("_on");
			this.model.allowEditing && this._allowEditable();
			this.model.allowDragAndDrop && this._addDragableClass();
			this.model.showCheckbox && this.element.find('.nodecheckbox').ejCheckBox("enable");
            this.model.allowKeyboardNavigation && this._on(this.element, "keydown", this._KeyPress);
        },

        _unWireEvents: function () {
            if (this._isDevice && $.isFunction($.fn.tap)) this._off(this.element.find('li'), "tap")
            else this._off(this.element, "click")
            this._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? this._touchExpandOn : this.model.expandOn)
                ._off(this.element, "focus")
                ._off(this.element, "blur");
            this._wholeRowEvents("_off");
            this._preventEditable();
            this._preventDraggable();
            this.model.allowKeyboardNavigation && this._off(this.element, 'keydown');
            this.model.showCheckbox && this.element.find('.nodecheckbox').ejCheckBox("disable");
        },

        _wholeRowEvents: function (action) {
            if (this.model.fullRowSelect) {
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-text-wrap", this._liMouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-text-wrap", this._liMouseLeaveEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-fullrow", this._liMouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-fullrow", this._liMouseLeaveEvent);
            }
            else {
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchstart)) ? "touchstart" : "mouseenter", ".e-text", this._mouseEnterEvent);
                this[action](this.element, (this._isDevice && $.isFunction($.fn.touchend)) ? "touchend" : "mouseleave", ".e-text", this._mouseLeaveEvent);
            }
        },

        _enableDragDrop: function () {
            if (this.model.allowDragAndDrop) {
                this._drag();
                this.model.allowDropChild && this._childDrop();
                this.model.allowDropSibling && this._siblingDrop();
            }
        },

        _allowEditable: function () {
            if (!this.model.template) {
                this.element.find('.e-item').addClass('AllowEdit');
                this._on($(document), 'click', this._documentClick)
                    ._on(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? 'doubletap' : 'dblclick', "a.e-text", this._inlineEdit);
            }
        },

        _preventEditable: function () {
            this.element.find('.e-item').removeClass('AllowEdit');
            this._off($(document), 'click')
                ._off(this.element, (this._isDevice && $.isFunction($.fn.tap)) ? 'doubletap' : 'dblclick', "a.e-text");
        },

        _preventDraggable: function () {
            this.element.find('.e-draggable, .e-droppable').removeClass("e-draggable e-droppable");
            this._preventDropSibling();
            this._preventDropChild();
            this._off(this.element, "mouseup touchstart pointerdown MSPointerDown", this._anchors, this._focusElement);
        },

        _preventDropSibling: function () {
            this.element.find('.e-dropsibling').removeClass("e-dropsibling");
        },

        _preventDropChild: function () {
            this.element.find('.e-item > div > .e-dropchild').removeClass("e-dropchild");
        },

        _getNodeData: function (id) {
            if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null && id != undefined) {
                this._updatePersistProb();
                var newList = [], orderedData = [];
                if (this.dataSource() instanceof ej.DataManager && this._templateType == 2) {
                    newList = this._getRemoteNode(this._newDataSource, this.model.fields, id);
                    return newList;
                }
                if (this._templateType == 2) {
                    newList = JSON.parse(JSON.stringify(this._getRemoteNode(this._newDataSource, this.model.fields, id)));
                } else {
                    var predicats = [];
                    var list = this._newDataSource;
                    var query1 = ej.Query().where(this.model.fields.id, "equal", id, false);
                    var filteredList = ej.DataManager(list).executeLocal(query1);
                    var filters = this._getFilterItems(filteredList[0], list);
                    for (var i = 0, flen = filters.length; i < flen; i++) {
                        predicats.push(new ej.Predicate(this.model.fields.id, 'equal', filters[i], false));
                    }
                    var query = ej.Query().where(ej.Predicate.or(predicats));
                    newList = JSON.parse(JSON.stringify(ej.DataManager(list).executeLocal(query)));
                }
                for (var k = 0, dlen = newList.length; k < dlen; k++) {
                    var fieldId = ej.getObject(this.model.fields.id, newList[k]);
                    if ($(document.getElementById(fieldId)).length > 0) {
                        if ($(document.getElementById(fieldId)).find('> ul .e-item').length == 0) {
                            this._deepPropertyDelete(this.model.fields.hasChild, newList[k]);
                            if (this._templateType == 2)
                                delete newList[k]["child"];
                        } else if (this._templateType == 1)
                            ej.createObject(this.model.fields.hasChild, true, newList[k]);
                        else
                            this._updateChildData(newList[k]["child"], this.model.fields);
                        orderedData.push(newList[k]);
                    }
                }
                return orderedData;
            }
        },

        _updateChildData: function (newData, mapper) {
            if (newData == undefined) return;
            for (var i = 0, objlen = newData.length; i < objlen; i++) {
                var id = ej.getObject(mapper.id, newData[i]);
                if ($(document.getElementById(id)).length > 0) {
                    if ($(document.getElementById(id)).find('> ul .e-item').length == 0) {
                        this._deepPropertyDelete(mapper.hasChild, newData[i]);
                        delete newData[i]["child"];
                    } else
                        this._updateChildData(newData[i]["child"], mapper.child ? mapper.child : mapper);
                }
            }
        },

        _getFilterItems: function (fList, list) {
            var nodes = [];
            if (fList == undefined) return nodes;
            var id = ej.getObject(this.model.fields.id, fList);
            nodes.push(id);
            var query2 = ej.Query().where(this.model.fields.parentId, 'equal', id, false);
            var fList1 = ej.DataManager(list).executeLocal(query2);
            for (var l = 0, nlen = fList1.length; l < nlen ; l++) {
                var cNode = this._getFilterItems(fList1[l], list);
                for (var i = 0, clen = cNode.length; i < clen; i++) {
                    nodes.push(cNode[i]);
                }
            }
            return nodes;
        },

        _getRemoteNode: function (obj, mapper, id) {
            var newList = [];
            for (var i = 0, objlen = obj.length; i < objlen; i++) {
                var fieldId = ej.getObject(mapper.id, obj[i]);
                if (fieldId && (fieldId.toString() == id)) {
                    newList.push(obj[i]);
                    return newList;
                }
                if (obj[i].hasOwnProperty('child')) {
                    newList = this._getRemoteNode(obj[i].child, mapper.child ? mapper.child : mapper, id);
                    if (newList.length > 0) return newList;
                }
            }
            return newList;
        },

        _updateRemoteData: function (obj, searchId, childObj, mapper) {
            if (this.dataSource() != null && this.dataSource().dataSource.offline) return;
            for (var i = 0, objlen = obj.length; i < objlen; i++) {
                var fieldId = ej.getObject(mapper.id, obj[i]);
                if (fieldId && (fieldId.toString() == searchId)) {
                    obj[i]["child"] = childObj;
                    var newobj = obj[i];
                    obj.splice(i, 1, newobj);
                    break;
                }
                if (obj[i].hasOwnProperty('child'))
                    this._updateRemoteData(obj[i].child, searchId, childObj, mapper.child ? mapper.child : mapper);
            }
        },

        refresh: function () {
            this._unWireEvents();
            this.element.html("");
            this._init();
        },

        expandAll: function (level, excludeHiddenNodes) {
            if (this.model.enableMultipleExpand)
                (level > 0) ? this._expandByLevel(this._getElement(), level, excludeHiddenNodes) : this._expandAll(excludeHiddenNodes);
        },

        collapseAll: function (level, excludeHiddenNodes) {
            if (this.model.enableMultipleExpand)
                (level > 0) ? this._collapseByLevel(this._getElement(), level, excludeHiddenNodes) : this._collapseAll(excludeHiddenNodes);
        },

        checkAll: function () {
            this.model.showCheckbox && this._checkAll();
        },

        unCheckAll: function () {
            this.model.showCheckbox && this._uncheckAll();
        },

        selectNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                this._unselectAll();
                this._doSelectNodes(node, true);
            }
            else {
                node = this._getNodeByID(node);
                this._isTreeElement(node) && this._nodeSelectionAction(node);
            }
        },

        unselectNode: function (node) {
            if (node && typeof node == "object" && node.length > 0)
                this._doUnselectNodes(node);
            else {
                node = this._getNodeByID(node);
                this._isTreeElement(node) && this._nodeUnSelectionAction(node);
            }
        },

        selectAll: function () {
            this.model.allowMultiSelection && this._selectAll();
        },

        unselectAll: function () {
            this.model.allowMultiSelection && this._unselectAll();
        },

        enableNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.enableNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeEnableAction(item);
            }
        },

        disableNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.disableNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeDisableAction(item);
            }
        },

        addNodes: function (collection, targetNode) {
            if (collection && typeof collection == "object" && targetNode == undefined && collection.length > 0) {
                for (var i = 0; i < collection.length; i++)
                    this.addNode(collection[i], targetNode);
            }
            else this.addNode(collection, targetNode);
        },

        addNode: function (newNodeText, targetNode) {
            if (ej.isNullOrUndefined(newNodeText)) return;
            var outerLi = null, innerUl = null, temp, activeNode, id, selectedNode, template;
            selectedNode = targetNode ? this._getNodeByID(targetNode) : (this.model.allowMultiSelection ? this.getSelectedNodes() : this.getSelectedNode());
            if (typeof newNodeText == 'object' && ej.isNullOrUndefined(targetNode)) {
                var parentId = ej.getObject(this.model.fields.parentId, newNodeText);
                if (ej.isNullOrUndefined(newNodeText.length) && !ej.isNullOrUndefined(parentId))
                    id = parentId;
                else if (!ej.isNullOrUndefined(newNodeText.length) && newNodeText.length == 1)
                    id = ej.getObject(this.model.fields.parentId, newNodeText[0]);
                if (id) selectedNode = this._getNodeByID(id);
            }
            selectedNode = (this._isTreeElement(selectedNode)) ? $(selectedNode[0]) : [];
            if (this._triggerEvent('beforeAdd', { data: newNodeText, targetParent: (selectedNode[0] != null) ? selectedNode : null, parentDetails: this._getNodeDetails(selectedNode) })) return;
            (selectedNode.length != 0 && !selectedNode.hasClass('e-node-disable')) && this._expandNode(selectedNode);
            if (typeof newNodeText != 'object')
                newNodeText = this._createObjectByText(newNodeText, selectedNode);
            if (typeof newNodeText != "object" || (ej.isNullOrUndefined(newNodeText.length) && newNodeText.length == 0)) return;
            outerLi = this._addNodesWhenObject(newNodeText, selectedNode);
            temp = document.createElement('ul');
            $(temp).append(outerLi); outerLi = $(temp.children);
            this.model.showCheckbox && outerLi.children().find(".nodecheckbox").ejCheckBox({ cssClass: this.model.cssClass, change: this._checkedChange });
            this._appendNode(selectedNode, outerLi);
            if (selectedNode[0] != null) {
                var imgTag = $(selectedNode[0].childNodes[0].childNodes[0]);
                (imgTag.hasClass('e-plus') || imgTag.hasClass('e-minus')) ? imgTag.removeClass('e-load') : imgTag.removeClass('e-icon e-load');
            }
            (selectedNode[0] != null && selectedNode.find('> div > .e-minus').length > 0 && !this.model.enableMultipleExpand) && this._denyMultipleExpand(selectedNode);
            this._updateNodes();
            this._afterInsertingNode(outerLi);
            if (this._isDevice && $.isFunction($.fn.tap)&&selectedNode[0] == null) {
                this._on(outerLi, 'tap', this._ClickEventHandler);
            }
            this._triggerEvent('nodeAdd', { data: newNodeText, nodes: outerLi, parentElement: (selectedNode[0] != null) ? selectedNode : null, parentDetails: this._getNodeDetails(selectedNode) });
            var proxy = this, _dataObj = this.dataSource();
            setTimeout(function () {
                if (proxy.dataSource() != null && !(proxy.dataSource() instanceof ej.DataManager))
                    proxy._dataSource = proxy._groupingObjects(_dataObj, function (_dataObj) { return [!ej.isNullOrUndefined(_dataObj) && [ej.getObject(proxy.model.fields.parentId, _dataObj)].toString()]; });
            }, 300);
        },

        removeNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.removeNode(node[i]);
            }
            else {
                var item = node ? this._getNodeByID(node) : (this.model.allowMultiSelection ? this.getSelectedNodes() : this.getSelectedNode());
                this._isTreeElement(item) && this._removeNode(item);
            }
        },

        removeAll: function () {
            this._liList.remove();
            this._updateNodes();
        },

        checkNode: function (node) {
            if (!this.model.showCheckbox) return;
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.checkNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeCheck(item.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        uncheckNode: function (node) {
            if (!this.model.showCheckbox) return;
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.uncheckNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._nodeUncheck(item.find("> div > .e-chkbox-wrap > .nodecheckbox:first")[0]);
            }
        },

        expandNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                this._allowOnDemand = true;
                this._expandNodes(node, true);
                this._allowOnDemand = false;
            }
            else {
                node = this._getNodeByID(node);
                if (this._isTreeElement(node)) {
                    this._allowOnDemand = true;
                    this._expandNode(node);
                    this._allowOnDemand = false;
                }
            }
        },

        collapseNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.collapseNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && this._collapseNode(item);
            }
        },

        showNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.showNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && item.css("visibility", "").removeClass('hidden');
            }
        },

        hideNode: function (node) {
            if (node && typeof node == "object" && node.length > 0) {
                for (var i = 0; i < node.length; i++)
                    this.hideNode(node[i]);
            }
            else {
                var item = this._getNodeByID(node);
                this._isTreeElement(item) && item.css("visibility", "hidden").addClass('hidden');
            }
        },

        show: function () {
            this.element.css("visibility", "").find('.e-item').removeClass('hidden');
        },

        hide: function () {
            this.element.css("visibility", "hidden").find('.e-item').addClass('hidden');
        },

        hasChildNode: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return node.find('> ul > .e-item').length > 0 ? true : false;
        },

        isChildLoaded: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.find('ul > .e-item').length > 0) ? true : false;
        },

        isNodeChecked: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._isChecked(node);
        },

        isExpanded: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._isNodeExpanded(node);
        },

        isVisible: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.css("visibility") != "hidden") ? true : false;
        },

        isExist: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && this._liList.index(node) != -1) ? true : false;
        },

        isSelected: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node)) return node.find('> div > .e-text').hasClass('e-active');
        },

        isDisabled: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node) && node.hasClass('e-node-disable')) ? true : false;
        },

        getTreeData: function (id) {
            if (id != undefined)
                return this._getNodeData(id);
            else if (!ej.isNullOrUndefined(this.model.fields) && this.dataSource() != null)
                return this._orderDataSource();
        },

        getText: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return $.trim(this.element.find(node).find('> div > .e-text').text());
        },

        getSelectedNode: function () {
            return !this.model.allowMultiSelection ? this.element.find('.e-item > div > .e-active').closest('.e-item') : null;
        },

        getSelectedNodes: function () {
            return this.element.find('.e-item > div > .e-active').closest('.e-item');
        },

        getCheckedNodes: function () {
            if (this.model.showCheckbox)
                return this._liList.find('> div > .e-chkbox-wrap[aria-checked="true"]').closest('.e-item');
        },

        getExpandedNodes: function () {
            return this.element.find('.e-item > div > .e-minus').closest('.e-item');
        },

        getExpandedNodesIndex: function () {
            return this._getNodesIndex(this.getExpandedNodes());
        },

        getCheckedNodesIndex: function () {
            return this._getNodesIndex(this.getCheckedNodes());
        },

        getSelectedNodeIndex: function () {
            return !this.model.allowMultiSelection ? this._getNodesIndex(this.getSelectedNode()) : null;
        },

        getSelectedNodesIndex: function () {
            return this._getNodesIndex(this.getSelectedNodes());
        },

        getVisibleNodes: function () {
            return this.element.find('.e-item:visible:not(.hidden, .e-node-disable)');
        },

        getNodeCount: function () {
            return this.element.find('.e-item').length;
        },

        getNode: function (node) {
            node = this._getNodeByID(node);
            return (this._isTreeElement(node)) ? this._getNodeDetails(node) : null;
        },

        getNodeIndex: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return this._liList.index(node);
        },

        getNodeByIndex: function (index) {
            if (typeof index == "number")
                return $(this._liList[index]);
        },

        getParent: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return node.parents('.e-item:first');
        },

        getChildren: function (node, includeNestedChild) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node))
                return includeNestedChild ? node.find('.e-item') : node.find('> ul > .e-item');
        },

        updateText: function (node, newText) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node) && !ej.isNullOrUndefined(newText)) {
                var aTag = this.element.find(node).children('div').find('> .e-text')[0], oldText, argsData;
                if (aTag != null) {
                    argsData = { currentElement: $(aTag) };
                    if (this._triggerEvent('beforeEdit', argsData))
                        return false;
                    oldText = aTag.lastChild.nodeValue;
                }
                aTag.lastChild.nodeValue = newText;
                this._updateField(this._newDataSource, node.attr('id'), this.model.fields, "text", newText);
                if (this._deepWatch) {
                    this._oldDataSource = JSON.parse(JSON.stringify(this._newDataSource));
					 this.dataSource(this._newDataSource);
                }
                this._triggerEvent('nodeEdit', { id: node.attr('id'), oldText: oldText, newText: newText, target: node, nodeDetails: this._getNodeDetails(node), event: null });
            }
        },

        insertAfter: function (nodeObj, afterEle) {
            this._insertBeforeOrAfter(nodeObj, afterEle, false);
        },

        insertBefore: function (nodeObj, afterEle) {
            this._insertBeforeOrAfter(nodeObj, afterEle, true);
        },

        moveNode: function (srcNode, desNode, index) {
            srcNode = this._getNodeByID(srcNode);
            desNode = this._getNodeByID(desNode);
            if (this._isTreeElement(srcNode)) {
                if ((srcNode.parents('.e-item')[0] == desNode[0] && ej.isNullOrUndefined(index)) || desNode.find(srcNode).index() == index || (desNode[0] == null && this._liList.index(srcNode) == index)) return;
                var target = (desNode[0] != null && index >= 0) ? desNode.find("> ul > .e-item").eq(index) : this.getNodeByIndex(index);
                this._isRender = false;
                if (this._isTreeElement(target)) {
                    if (target.parents('.e-item:first')[0] == srcNode.parents('.e-item:first')[0] && target.next('.e-item')[0] == null)
                        this._dropAsSiblingNode(target, srcNode.find(" > div > .e-text"), false, "");
                    else
                        this._dropAsSiblingNode(target, srcNode.find(" > div > .e-text"), true, "");
                } else {
                    this._dropAsChildNode(desNode, srcNode.find(" > div > .e-text"), "");
                }
                if (desNode.length > 0 && desNode.hasClass('e-node-disable'))
                    this._nodeDisableAction(desNode);
                this._isRender = true;
            }
        },

        loadData: function (url, targetNode) {
            targetNode = this._getNodeByID(targetNode);
            if (this._isUrl(url) && (targetNode[0] == null || (this._isTreeElement(targetNode))))
                this._sendAjaxOptions(url, targetNode);
        },

        ensureVisible: function (node) {
            node = this._getNodeByID(node);
            if (this._isTreeElement(node) && !this.isDisabled(node) && this.isVisible(node)) {
                var parents = node.parents('.e-item'), offset;
                for (var j = 0, len = parents.length; j < len; j++)
                    this._expandNode($(parents[j]));
                offset = node.offset();
                node.animate({ scrollTop: offset.top }, this.model.enableAnimation ? 350 : 0, 'linear', function () {
                    node.find("> div > a.e-text")[0].scrollIntoView(false);
                });
                return true;
            } else
                return false;
        },

        _triggerEvent: function (e, data) {
            if (this._isRender) return this._trigger(e, data);
        },

    });
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejUploadbox", "ej.Uploadbox", {

        element: null,
		_addToPersist: [""],
        model: null,
        validTags: ["div", "span"],
        _setFirst: false,

        _rootCSS: "e-uploadbox",

        defaults: {

            buttonText: {

                browse: "Browse",

                upload: "Upload",

                cancel: "Cancel",

                close: "Close",
            },

            width: "100px",

            height: "35px",

            htmlAttributes: {},

            dialogPosition: { X: "", Y: "" },

            dialogText: {

                title: "Upload Box",

                name: "Name",

                size: "Size",

                status: "Status"
            },

            customFileDetails: {

                title: true,

                name: true,

                size: true,

                status: true,

                action: true
            },

            dialogAction: {

                modal: false,

                closeOnComplete: false,

                drag: true,

                content: null

            },

            locale: "en-US",

            asyncUpload: true,

            pushFile: null,

            enabled: true,

            multipleFilesSelection: true,

            autoUpload: false,

            showFileDetails: true,

            fileSize: 31457280,

            extensionsAllow: "",

            extensionsDeny: "",

            saveUrl: "",

            removeUrl: "",

            uploadName: "",

            cssClass: "",

            dropAreaText: "Drop files or click to upload",

            allowDragAndDrop: false,

            showBrowseButton: true,

            showRoundedCorner: true,

            dropAreaHeight: "100%",

            dropAreaWidth: "100%",

            enableRTL: false,

            create: null,

            fileSelect: null,

            begin: null,
			
			beforeSend:null,

            cancel: null,

            inProgress: null,
            
            success: null,

            complete: null,

            remove: null,

            error: null,

            destroy: null
        },


        dataTypes: {
            buttonText: "data",
            dialogText: "data",
            disbled: "boolean",
            customFileDetails: "data",
            pushFile: "data",
            dialogAction: "data",
            multipleFilesSelection: "boolean",
            autoUpload: "boolean",
            showFileDetails: "boolean",
            allowDragAndDrop: "boolean",
            showBrowseButton: "boolean",
            showRoundedCorner: "boolean",
            fileSize: "number",
            extensionsAllow: "string",
            extensionsDeny: "string",
            saveUrl: "string",
            removeUrl: "string",
            cssClass: "string",
            enableRTL: "boolean",
            htmlAttributes: "data"
        },



        disable: function () {
            this._changeState(false);
        },

        enable: function () {
            this._changeState(true);
        },
		
        _changeState: function (state) {
            (state)? $(this.control).removeClass("e-disable") : $(this.control).addClass("e-disable");
            this.model.enabled = state;
            $(this._currentElement).find(".e-uploadinput")[0].disabled = !state;
            if (this.diaObj) {
                this.diaObj.option("beforeClose", this._onBeforeClose);
                this.diaObj.setModel({ enabled: state, allowDraggable: state });
            }
        },

        refresh: function () {
            if (this.diaObj) {
                if (this.diaObj.isOpened())
                    this.diaObj.close();
                else
                    this._uploadFileListDelete();
            }
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Uploadbox", this.model.locale);
        },
        _init: function () {
            this.s = ej.browserInfo();
            this._updateLocalConstant();
            this._initialize();
            this._wireEvents();
            /*Sync Uploads*/
            if (!this.model.asyncUpload) {
                this._initObjectsSyncUpload();
            }
            this._controlStatus(this.model.enabled);
            this.model.locale == "en-US" ? this._buttonText(this.model.buttonText) : this._setLocale();
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "buttonText":
                        this._buttonText(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "dialogText":
                        this._dialogText(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "height":
                        this.model.height = options[option];
                        this._setHeight(this.model.height);
                        break;
                    case "width":
                        this.model.width = options[option];
                        this._setWidth(this.model.width);
                        break;
                    case "dialogPosition":
                        this.model.dialogPosition = options[option];
                        this._dialogPosition();
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[option];
                        this._dragAndDrop();
                        break;
                    case "dropAreaText":
                        this.model.dropAreaText = options[option];
						this._dropAreaText(this.model.dropAreaText);
                        break;
                    case "showBrowseButton":
                        this.model.showBrowseButton = options[option];
                        this._hideBrowseButton();
						this._refreshUploadDialogParent();
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "dropAreaHeight":
                        this.model.dropAreaHeight = options[option];
                        this._setSize();
                        break;
                    case "dropAreaWidth":
                        this.model.dropAreaWidth = options[option];
                        this._setSize();
                        break;
                    case "pushFile":
                        this.model.pushFile = options[option];
                        if (this.model.pushFile != null && this.UploadType == "Xhr" && this.model.asyncUpload) this._files = this.model.pushFile; this._onXhrSelect();
                        break;
                    case "multipleFilesSelection":
                        this.model.multipleFilesSelection = options[option];
						 if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false)
                        if (this.model.multipleFilesSelection)
                            this._currentElement.find(".e-uploadinput").attr('multiple', 'multiple');
                        else
                            this._currentElement.find(".e-uploadinput").removeAttr('multiple');
                        break;
                    case "uploadName":
                        this.model.uploadName = options[option];
                        this.inputupload.attr('name', this.model.uploadName);
                        this.refresh();
                        break;
                    case "autoUpload":
                        this.model.autoUpload = options[option];
                        break;
                    case "showFileDetails":
                        this.model.showFileDetails = options[option];
                        this.refresh();
                        break;
                    case "fileSize":
                        this.model.fileSize = options[option];
                        break;
                    case "extensionsAllow":
                        this.model.extensionsAllow = options[option];
						this._currentElement.find(".e-uploadinput").attr('accept', options[option]);
                        break;
                    case "extensionsDeny":
                        this.model.extensionsDeny = options[option];
                        break;
                    case "saveUrl":
                        this.model.saveUrl = options[option];
                        break;
                    case "removeUrl":
                        this.model.removeUrl = options[option];
                        break;
                }
                this._currentElement = this.model.allowDragAndDrop && !this.model.showBrowseButton ? this.dragWrapper : this.element;
            }
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _setRTL: function (val) {
            val ? this._currentElement.addClass("e-rtl") : this._currentElement.removeClass("e-rtl");
            if (this.updialog) this.updialog.ejDialog({ enableRTL: val });
        },
        _getLocalizedLabels: function (property) {
            var textType,targetText="";
            if (property == "browse" || property == "upload" || property == "cancel" || property == 'close')
                textType = "buttonText";
            else
                textType = "dialogText";
            if(this._localizedLabels[property])
                targetText =this._localizedLabels[property];
            else if(this._localizedLabels[textType][property])
                targetText =this._localizedLabels[textType][property];
            else if(ej.Uploadbox.Locale["en-US"][property])
                targetText =ej.Uploadbox.Locale["en-US"][property];
            else if(ej.Uploadbox.Locale["en-US"][textType][property]) 
                targetText =ej.Uploadbox.Locale["en-US"][textType][property];
            return targetText;
        },

        _setLocale: function () {
            this._buttonText(this._localizedLabels.buttonText);
            this._dialogText(this._localizedLabels.dialogText);
            this._dropAreaText(this._localizedLabels.dropAreaText);
        },

        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            this.buttondiv.val(this.model.buttonText.browse);
            if (this.updialog) {
                this.updialog.find(".e-action-container .e-uploadbtn").html(this.model.buttonText.upload);
                this.updialog.find(".e-action-container .e-uploadclosebtn").html(this.model.buttonText.cancel);
            }
        },

        _dialogText: function (data) {
            $.extend(this.model.dialogText, data);
            if (!(this.diaObj == undefined))
                this.diaObj.option('title', this.model.dialogText.title);
            if (this.updialog) {
                this.updialog.find('.e-head-name').html(this.model.dialogText.name);
                this.updialog.find('.e-head-size').html(this.model.dialogText.size);
                this.updialog.find('.e-head-status').html(this.model.dialogText.status);
            }
        },


        _destroy: function () {
            if (this._currentElement.hasClass("e-uploadbox")) {
                this._currentElement.removeClass("e-uploadbox e-widget");
                this._currentElement.empty();
                $(this.dragWrapper).after(this._currentElement);
				this.element.css({"width": "", "height": ""});
                this._bindResizeHandler(false);
                this.dragWrapper.remove();
            }
        },

        _setSkin: function (skin) {
            this._currentElement.removeClass(this.model.cssClass);
            this._currentElement.addClass(skin);
			if (this.diaObj)
                this.diaObj.setModel({ cssClass:this.model.cssClass });
			if (this.model.allowDragAndDrop) this.dragWrapper.addClass(skin);
        },


        _initialize: function () {
            this.control = this.element[0];
            this.element.addClass("e-widget " + this.model.cssClass);
            this.innerdiv = ej.buildTag('div.e-selectpart e-select e-box');
            this.element.append(this.innerdiv);
            this.buttondiv = ej.buildTag('input.e-inputbtn e-btn#' + this.control.id + '_SelectButton', '', {}, { type: 'button', "data-role": "none", value: this._getLocalizedLabels("browse") });
            this.inputupload = ej.buildTag('input.e-uploadinput', "", {}, { type: 'file', "data-role": "none", name: this.model.uploadName != "" ? this.model.uploadName : this.control.id });
			if(this.model.extensionsAllow){
			   this.inputupload.attr("accept",this.model.extensionsAllow);
			}
            if (this.model.multipleFilesSelection) 
			if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false){
                this.inputupload.attr('multiple', 'multiple');
            }
            this.innerdiv.append(this.buttondiv);
            this.innerdiv.append(this.inputupload);
            if (this.model.allowDragAndDrop) this._dragAndDrop(true);
            this._Selector = this.buttondiv[0];
            this._currentElement = this.model.allowDragAndDrop && !this.model.showBrowseButton ? this.dragWrapper : this.element;
            this._setRTL(this.model.enableRTL);
            this._addAttr(this.model.htmlAttributes);
            this.Uploadframes = []; //For IFrame
            this.UploadForms = [];
            this._successFiles = [];
			this._errorFiles = [];
            this.UploadType = this._isXhrSupported() ? "Xhr" : "IFrame";
            if (this.model.width != "") this._setWidth(this.model.width);
            if (this.model.height != "") this._setHeight(this.model.height);
            this._hideBrowseButton();
        },		
        _refreshUploadDialogParent: function () {
            if (this.diaObj)
                this.diaObj.setModel({ target: (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : (!this.model.showBrowseButton) && (this.model.allowDragAndDrop) ? "#" + this.control.id + '_dragWrapper' : "#" + this.control.id });
        },
        _hideBrowseButton: function () {
            if ((!this.model.showBrowseButton) && (this.model.allowDragAndDrop)) {
                this.element.addClass("e-browse-hide");
                this._dropAreaSize();
            }
            else {
                if (this.element.hasClass("e-browse-hide")) {
                    this.element.removeClass("e-browse-hide");
                    this.element.width(this.model.width);
                    this.element.height(this.model.height);
                }
            }
        },
        _setSize: function () {
            if (this.model.allowDragAndDrop) {
                if (this.model.dropAreaWidth != "") this.dragWrapper.outerWidth(this.model.dropAreaWidth);
                if (this.model.dropAreaHeight != "") this.dragWrapper.outerHeight(this.model.dropAreaHeight);
                if (!this.model.showBrowseButton) this._dropAreaSize();
            }
        },

        _dropAreaSize: function () {
            if (this.model.dropAreaWidth != "") this.element.width(this.model.dropAreaWidth);
            if (this.model.dropAreaHeight != "") this.element.height(this.model.dropAreaHeight);
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },

        _dragAndDrop: function () {
            if (this.model.allowDragAndDrop) {
                this.dragWrapper = ej.buildTag("div.e-drag-wrapper e-widget-wrapper e-upload-box " + this.model.cssClass + "#" + this.control.id + '_dragWrapper')
                this.innerWrapper = ej.buildTag("div.e-drag-container");
                this._spanTag = ej.buildTag("span.e-drag-text").html(this.model.locale == "en-US" ? this.model.dropAreaText : ej.Uploadbox.Locale[this.model.locale].dropAreaText);
                this.innerWrapper.append(this._spanTag);
                this.innerWrapper.insertBefore(this.element);
                this.dragWrapper.insertBefore(this.element);
                this.innerWrapper.append(this.element);
                this.dragWrapper.append(this.innerWrapper);
                this._bindDragEvents();
                this._refreshUploadDialogParent();
                this._setSize();
            }
            else {
                this._refreshUploadDialogParent();
                this.element.insertBefore(this.dragWrapper);
                this.dragWrapper.remove();
                this._unBindDragEvents();
            }
            this._hideBrowseButton();
        },
        _resizeHandler: function () {
            if (this.diaObj) {
                if ($(window).width() > 750) {
                    $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
                    this.diaObj.setModel({ width: this._getDialogContentWidth(), height: "auto" });
                }
                else {
                    $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload");
                    this.diaObj.setModel({ width: 250, height: "auto"});
                }
                if (this.diaObj.scroller) this.diaObj.scroller.setModel({ height: "auto" });
            }
        },
        _getDialogContentWidth: function () {
            var dialogWidth = 0;
            if (this.model.customFileDetails.name)   dialogWidth = dialogWidth + 200;
            if (this.model.customFileDetails.size)  dialogWidth = dialogWidth + 100;
            if (this.model.customFileDetails.status) dialogWidth = dialogWidth + 200; 
            else if (this.model.customFileDetails.action) dialogWidth = dialogWidth + 45;
            return dialogWidth+5;
        },
		_dropAreaText: function (areaText) {
            if (this.model.allowDragAndDrop)
                this._spanTag.html(areaText);
        },
        _bindDragEvents: function () {
            this._on(this.dragWrapper, "dragover", this._onDragOverHandler);
            this._on(this.dragWrapper, "drop", this._onDropHandler);
        },
        _unBindDragEvents: function () {
            this._off(this.dragWrapper, "dragover", this._onDragOverHandler);
            this._off(this.dragWrapper, "drop", this._onDropHandler);
        },
        _setWidth: function (value) {
            this.element.css("width", value);
        },
        _setHeight: function (value) {
            this.element.height(value);
        },
        _dialogPosition: function () {
            if (this.diaObj) {
                if ((this.diaObj.model.content == "#" + this.control.id || this.diaObj.model.content == "#" + this.control.id + "_dragWrapper") && this.model.dialogPosition.X == "" && this.model.dialogPosition.Y == "") {
                    var left = parseInt(this.diaObj.wrapper.css("left")) - ((this.diaObj.wrapper.outerWidth() - $(this.diaObj.model.content).outerWidth()) / 2);
                    this.model.dialogPosition.X = parseInt(left) > 0 ? left : parseInt(this.diaObj.wrapper.css("left"));
                    this.model.dialogPosition.Y = parseInt(this.diaObj.wrapper.css("top")) + $(this.diaObj.model.content).outerHeight();
                }
                if (this.model.dialogPosition.X != "" && this.model.dialogPosition.Y != "") this.diaObj.setModel({ position: this.model.dialogPosition });
            }
        },

        _roundedCorner: function (value) {
            if (value) {
                this.innerdiv.addClass('e-corner');
            }
            else if (this.innerdiv.hasClass('e-corner')) {
                this.innerdiv.removeClass('e-corner');
            }
        },


        _wireEvents: function () {

            this._on(this.element, "click", this._disableclickselect);
            this._on(this.element, "keydown", this._keydownselect);
            this._bindInputChangeEvent();
            this._bindResizeHandler(true);
        },
        _bindResizeHandler: function (responsive) {
            responsive ? $(window).on('resize', $.proxy(this._resizeHandler, this)) : $(window).off('resize', $.proxy(this._resizeHandler, this));
        },

        _keydownselect: function (e) {
             if (!this.element.hasClass("e-disable") && e.keyCode == 13 && (!this.diaObj || !this.diaObj.isOpened()))
               this.element.find('.e-uploadinput').click();
        },

        _onDropHandler: function (e) {
            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0" || ej.browserInfo().version === "9.0") return false;
            if (this._currentElement.hasClass("e-disable")) return false;
            e.stopPropagation();
            e.preventDefault();
            this._files = this._getAllFileInfo(e.originalEvent.dataTransfer.files);
            this._fileSelect(e);
        },


        _onDragOverHandler: function (e) {
            if (this._currentElement.hasClass("e-disable")) return false;
            e.stopPropagation();
            e.preventDefault();
        },


        _disableclickselect: function (e) {
            if (this._currentElement.hasClass("e-disable")) {
                e.preventDefault();
            }
        },


        _bindInputChangeEvent: function () {
            this._on(this.inputupload, "change", this._inputValueChange);
        },


        _inputValueChange: function (e) {
            this._files = this._getInputFileInfo($(e.target));
            return this._fileSelect(e);
        },
		_fileSelect:function(e){
			if (this._trigger("fileSelect", {files:this._files})) { this._resetFileInput(this._currentElement.find(".e-uploadinput")); return false; }
            this._fileUpload(e);
		},
        _fileUpload: function (e) {
            var filteredFiles = this._isAllowed(this._files);
            this._files = filteredFiles.files;
            if (!this.model.asyncUpload) {
                if (filteredFiles.status)
                    this._onSelectSyncUpload(e); //Sync Upload
                } else {
                    if (filteredFiles.files != null && filteredFiles.files.length > 0) {
                        if (this.UploadType == "Xhr") 
                            this._onXhrSelect(e); //removed uploadcore // For XHR Upload
                        else 
                           this._onSelectIFrame(e); //For Iframe
                        this._resetFileInput(this._currentElement.find(".e-uploadinput"));
                    }
            }
            this._renderTooltip();
        },
		
		upload: function() {
             if (this.UploadType == "Xhr") {
                        this._xhrOnUploadButtonClick(); // Xhr Upload
                    } else {
                        this._onUploadButtonClickIFrame(); //Iframe Upload
                    }					
		},

        __uploadButtonClick: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var uploadbtn = this._currentElement.find(".e-uploadbtn");
                if (this._currentElement.find(".e-uploadbtn").hasClass("e-disable")) e.preventDefault();
                else {
                    this.upload();
                }
                $(e.target).attr('disabled', 'disabled').addClass('e-disable');
            }
        },

        _actionClick: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var targetAction, fileItem, file;
                targetAction = $(e.target);
                fileItem = targetAction.closest(".e-upload-file");
                this._file = $(fileItem).data("file");
                if (targetAction.hasClass("e-delete")) {

                    if (this.UploadType == "Xhr") {
                        this._xhrOnRemove(e, fileItem); //XHr Remove
                    } else {
                        this._onRemoveIFrame(e, fileItem); //IFrame File Upload
                    }
                } else if (targetAction.hasClass("e-file-cancel")) {
                    this._trigger("cancel", { fileStatus: this._file });
                    var fileclose = this.updialog.find(".e-file-cancel");
                    if (fileclose.hasClass("e-disable")) e.preventDefault();
                    else {
                        if (!this.model.asyncUpload) {
                            this._onCancelSyncUpload(e, fileItem); //sync
                        } else {
							this._removeFile($(fileItem).data("file"));
                            if (this.UploadType == "Xhr") {
                                this._xhrOnCancel(e, fileItem); //Xhr Cancel Item
                            } else {
                                this._onCancelIFrame(e, fileItem); //IFrame Cancel Item
                            }
                        }
                    }
                } else if (targetAction.hasClass("e-reload")) {//removed uploadcore
                    if (this.UploadType == "Xhr") {
                        this._xhrOnRetry(e, fileItem); //xhr remove
                    } else {
                        this._onRetryIFrame(e, fileItem); //IFrame Remove
                    }
                }
            }
        },

        _removeFileEntry: function (file) {
            file.remove();
        },
		_removeFile:function(file){
			var fileList=[];
			for(var index=0;index<this._files.length;index++)
				if(this._files[index]!=file)
					fileList.push(this._files[index]);
			this._files=fileList;
		},


        _isFileUpload: function (fileEntry) {
            if (this.model.customFileDetails.action) {
                var actiondiv = $(fileEntry).find("div.e-icon");
                return actiondiv.is(".e-file-cancel");
            }
            else return true;
        },


        _isXhrSupported: function () {
            return (((this.s.name == "msie" && parseInt(this.s.version) < 9) || ((this.s.name == "safari" && this.s.name == "chrome") && this.s.version == "536")) ? false : (typeof (FormData) != "undefined") && (typeof (File) != "undefined"));
        },


        _getFileName: function (input) {
            return $.map(this._getAllFileInfo(input), function (file) {
                return file.name;
            }).join(", ");
        },

        _getFileSize: function (input) {
            var tempProxy = this;
            return $.map(this._getAllFileInfo(input), function (file) {
                return tempProxy._formatSize(file.size);
            }).join(", ");
        },

        _pushFile: function (files, datapart) {
            var fileListDetails, addedFile, actionlist, i, action, diaObj, addedheading, addedfilesize, addname, addsize, addstatus, DialogContentContainer, fileListActions, dialogActions, filedialog;
            addedheading = $("<div class='e-head-content'></div>");
            addname = $("<div class='e-file-head e-head-name'>" + this._getLocalizedLabels("name") + "</div>");
            addsize = $("<div class='e-file-head e-head-size'>" + this._getLocalizedLabels("size") + "</div>");
            addstatus = $("<div class='e-file-head e-head-status'>" + this._getLocalizedLabels("status") + "</div>");
            if (this.model.customFileDetails.name) $(addname).appendTo(addedheading);
            if (this.model.customFileDetails.size) $(addsize).appendTo(addedheading);
            if (this.model.customFileDetails.status) $(addstatus).appendTo(addedheading);
            filedialog = this.updialog;
            if (filedialog && filedialog.length != 0) {
                if (this.model.showFileDetails) {
                    if (this.updialog) this.updialog.find(".e-uploadbtn").removeAttr('disabled').removeClass('e-disable');
                    this.diaObj.open();
                }
            }
            else {
                this.updialog = ej.buildTag('div.e-uploaddialog#' + this.element[0].id + '_dialog', "", {}, { 'title': this._getLocalizedLabels("title") });
                if (this.model.allowDragAndDrop && !this.model.showBrowseButton) {
                    this.dragWrapper.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id + '_dragWrapper';
                }
                else {
                    this.element.append(this.updialog);
                    this.control.id!="" ?  DialogContentContainer = "#" + this.control.id : DialogContentContainer = this.element;
                }
            }
            fileListDetails = this.updialog.find(".e-ul");
            if ($(this.updialog.find(".e-head-content")))
                $(this.updialog.find(".e-head-content")).replaceWith(addedheading);
            if (fileListDetails.length == 0) {
                addedheading.appendTo(this.updialog);
                fileListDetails = ej.buildTag('ul.e-ul').appendTo(this.updialog);
			}
			if($(this.updialog).find('.e-file-upload').length>0)
				$(this.updialog).find('.e-file-upload').remove();
			fileListActions = ej.buildTag('div.e-file-upload').appendTo(this.updialog).append((this.model.autoUpload || !this.model.asyncUpload) ? $(ej.buildTag('div.e-action-container')).addClass("sync") : ej.buildTag('div.e-action-container'));
            dialogActions = ej.buildTag('button.e-uploadclosebtn e-btn e-select', this._getLocalizedLabels("cancel"), {}, { type: 'button', "data-role": "none" }).appendTo($(this.updialog).find(".e-action-container"));
            if (this.model.showRoundedCorner)
                dialogActions.addClass('e-corner');
            this._on(dialogActions, "click", this._dialogclose);
            this._on(dialogActions, 'keydown', this._keydownDialogClose);            
            var dialogContainer = (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : DialogContentContainer
            this.updialog.ejDialog({ showOnInit: false, closeIconTooltip: this._getLocalizedLabels("closeToolTip"), minWidth: 240, width: ($(window).width() < 750) ? 250 : this._getDialogContentWidth(), height: "auto", cssClass: "e-uploadbox " + this.model.cssClass, close: $.proxy(this._uploadFileListDelete, this), enableRTL: this.model.enableRTL, target: dialogContainer, enableResize: false, allowDraggable: this.model.dialogAction.drag, enableModal: this.model.asyncUpload ? this.model.dialogAction.modal : false, showHeader: this.model.customFileDetails.title , showRoundedCorner : this.model.showRoundedCorner});
            $(window).width() < 750 ? $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload") : $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
			this.diaObj = this.updialog.data('ejDialog');
			if(this.model.cssClass!="")
				this.diaObj.setModel({ cssClass: "e-uploadbox " + this.model.cssClass });
            this._dialogPosition();
            if (!this.model.multipleFilesSelection) {
                this.updialog.find(".e-ul>.e-upload-file").remove();
            }
            for (i = 0; i < files.length; i++) {//localization can be given for not started
                addedFile = $("<li class='e-upload-file'></li>").appendTo(fileListDetails).data(datapart);
                addedlist = $("<div class='e-file-list'></div>");
                addedfilename = $("<div class='e-file-progress e-file-view'><div class='e-file-name e-file-view'><span class='e-file-name-txt'>" + files[i].name + "</span></div>");
                addedfilesize = "<div class='e-file-size e-file-view'><span class='e-file-name-txt'>" + this._formatSize(files[i].size) + "</span></div>";
                addedfilestatus = $("<div class='e-file-percentage e-file-view'><div class='e-file-progress-bar'><div class='e-file-progress-status'></div></div></div>");
                addedfileaction = $("<div class='e-action-perform'><div class='e-icon e-file-view'></div></div>")
                if (this.model.customFileDetails.name) $(addedfilename).appendTo(addedlist);
                if (this.model.customFileDetails.size) {
                    if (this._getFileSize(files[i]).toString().toLowerCase().match("0.0kb").length == 0 || files[i].size != null) {
                        $(addedfilesize).appendTo(addedlist);
                    }
                    else $(this.updialog).find(".e-head-size").remove();
                }
                if (this.model.customFileDetails.status) $(addedfilestatus).appendTo(addedlist);
                if (this.model.customFileDetails.action) {
                    $(addedfileaction).appendTo(addedlist);
                    action = "cancel";
                    addedlist.find(".e-icon").remove().addClass(action.toString());
                    if (action == "cancel") {
                        actionlist = ej.buildTag('div.e-icon e-file-cancel', '', {}, { "data-content": this._getLocalizedLabels("cancelToolTip") });
                    } else if (action == "remove") {
                        actionlist = ej.buildTag('div.e-icon e-delete', '', {}, { "data-content": this._getLocalizedLabels("removeToolTip") });
                    } else if (action == "retry") {
                        actionlist = ej.buildTag('div.e-icon e-reload', '', {}, { "data-content": this._getLocalizedLabels("retryToolTip") });
                    }

                    addedlist.find(".e-action-perform").append(actionlist);

                    this._on(actionlist, "click", this._actionClick);
                }
                $(addedlist).appendTo(addedFile);
            }
            if (this.model.showFileDetails) {
                this.diaObj.open();
            }
            this._buttonText(this.model.buttonText);
            this._dialogText(this.model.dialogText);
            return addedFile;
        },

        _keydownDialogClose: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                if (e.keyCode == 13) this._dialogclose();
            }
        },

        _pushFileDetails: function (files) {
            var fileListDetails, addedFile, actionlist, i, action, me, diaObj, addedlist, addedheading, addname, addsize, addstatus, addaction, addedfilename, addedfilestatus, addedfilesize, addedfileaction, filedialog, DialogContentContainer, dialogActions, fileListActions;
            addedheading = $("<div class='e-head-content'></div>");
            addname = $("<div class='e-file-head e-head-name'>" + this._getLocalizedLabels("name") + "</div>");
            addsize = $("<div class='e-file-head e-head-size'>" + this._getLocalizedLabels("size") + "</div>");
            addstatus = $("</div><div class='e-file-head e-head-status'>" + this._getLocalizedLabels("status") + "</div>");
            if (this.model.customFileDetails.name) $(addname).appendTo(addedheading);
            if (this.model.customFileDetails.size) $(addsize).appendTo(addedheading);
            if (this.model.customFileDetails.status) $(addstatus).appendTo(addedheading);
            me = this;
            filedialog = this.updialog;
            if (filedialog && filedialog.length != 0) {
                if (this.model.showFileDetails) {
				    this.control.id!="" ?  DialogContentContainer  : DialogContentContainer = this.element;
                    if (this.updialog) this.updialog.find(".e-uploadbtn").removeAttr('disabled').removeClass('e-disable');
                    me.diaObj.open();
                }
            } else {
                this.updialog = ej.buildTag('div.e-uploaddialog#' + this.element[0].id + '_dialog', "", {}, { 'title': this._getLocalizedLabels("title") });
                if (this.model.allowDragAndDrop && !this.model.showBrowseButton) {
                    this.dragWrapper.append(this.updialog);
                    DialogContentContainer = "#" + this.control.id + '_dragWrapper';
                }
                else {
                    this.element.append(this.updialog);
                    this.control.id!="" ?  DialogContentContainer = "#" + this.control.id : DialogContentContainer = this.element;
                }
            }
            var fileListDetails, addedFile;
            fileListDetails = this.updialog.find(".e-ul");
            if ($(this.updialog.find(".e-head-content")))
                $(this.updialog.find(".e-head-content")).replaceWith(addedheading);
            if (fileListDetails.length == 0) {
                addedheading.appendTo(this.updialog);
                fileListDetails = ej.buildTag('ul.e-ul').appendTo(this.updialog);
			}
			if($(this.updialog).find('.e-file-upload').length>0)
				$(this.updialog).find('.e-file-upload').remove();
			fileListActions = ej.buildTag('div.e-file-upload').appendTo(this.updialog).append((this.model.autoUpload || !this.model.asyncUpload) ? $(ej.buildTag('div.e-action-container')).addClass("sync") : ej.buildTag('div.e-action-container'));
            dialogActions = ej.buildTag('button.e-uploadclosebtn e-btn e-select', this._getLocalizedLabels("cancel"), {}, { type: 'button', "data-role": "none" }).appendTo($(this.updialog).find(".e-action-container"));
            if (this.model.showRoundedCorner)
            dialogActions.addClass('e-corner');
            this._on(dialogActions, "click", this._dialogclose);            
            if (!this.model.multipleFilesSelection) {
                this.updialog.find(".e-ul>.e-upload-file").remove();
            }
            addedFile = $("<li class='e-upload-file'></li>").appendTo(fileListDetails).data("file", files);
            addedlist = $("<div class='e-file-list'></div>");
            addedfilename = $("<div class='e-file-progress e-file-view'><div class='e-file-name e-file-view'><span class='e-file-name-txt'>" + files.name + "</span></div>");
            addedfilesize = $("<div class='e-file-size e-file-view'><span class='e-file-name-txt'>" + this._formatSize(0) + "\\" + this._formatSize(files.size) + "</span></div>");
            addedfilestatus = $("<div class='e-file-percentage e-file-view'><div class='e-file-progress-bar'><div class='e-file-progress-status'></div></div></div>");
            addedfileaction = $("<div class='e-action-perform'><div class='e-icon e-file-view'></div></div></div>")
            if (this.model.customFileDetails.name) $(addedfilename).appendTo(addedlist);
            if (this.model.customFileDetails.size) $(addedfilesize).appendTo(addedlist);
            if (this.model.customFileDetails.status) $(addedfilestatus).appendTo(addedlist);
            if (this.model.customFileDetails.action) $(addedfileaction).appendTo(addedlist);
            $(addedlist).appendTo(addedFile);
            var dialogContainer = (this.model.dialogAction.content != null && this.model.dialogAction.content != "") ? this.model.dialogAction.content : DialogContentContainer;
            this.updialog.ejDialog({ showOnInit: false, closeIconTooltip: this._getLocalizedLabels("closeToolTip"), minWidth: 240, width: ($(window).width() < 750) ? 250 : this._getDialogContentWidth(), height: "auto", cssClass: "e-uploadbox " + this.model.cssClass, close: $.proxy(this._uploadFileListDelete, this), enableRTL: this.model.enableRTL, target: dialogContainer, enableResize: false, allowDraggable: this.model.dialogAction.drag, enableModal: this.model.asyncUpload ? this.model.dialogAction.modal : false, showHeader: this.model.customFileDetails.title , showRoundedCorner : this.model.showRoundedCorner })
			$(window).width() < 750 ? $(this.updialog).closest('.e-dialog.e-uploadbox').addClass("e-mobile-upload") : $(this.updialog).closest('.e-dialog.e-uploadbox').removeClass("e-mobile-upload");
			me.diaObj = this.updialog.data("ejDialog");
			if (me.model.cssClass!="")
                me.diaObj.setModel({ cssClass: "e-uploadbox " + this.model.cssClass });
            me._dialogPosition();
            if (this.model.showFileDetails) {
                me.diaObj.open();
            }
            this._buttonText(this.model.buttonText);
            this._dialogText(this.model.dialogText);
            return addedFile;
        },

        _setProgress: function (filelist, percentage, e) {
            var progressbar, progress, filesize, loaded, total;
            if (this.model.customFileDetails.status) {
                progressbar = $(filelist).find(".e-file-progress-status");
                progressbar.width(percentage + "%");
            }
            if (this.model.customFileDetails.size) {
                filesize = $(filelist).find(".e-file-size .e-file-name-txt");
                loaded = this._formatSize(e.loaded);
                total = this._formatSize(e.total);
                filesize.html(loaded + "\\" + total);
            }
        },

        _setAction: function (element, action) {
            if (this.model.customFileDetails.action) {
                var actionlist;
                element.find(".e-action-perform .e-icon,.e-file-percentage .e-icon").remove().addClass(action.toString());
                if (action == "cancel") {
                    actionlist = ej.buildTag('div.e-icon e-file-cancel', '', {}, { "data-content": this._getLocalizedLabels("cancelToolTip") });
                } else if (action == "remove") {
                    actionlist = ej.buildTag('div.e-icon e-delete', '', {}, { "data-content": this._getLocalizedLabels("removeToolTip") });
                } else if (action == "retry") {
                    actionlist = ej.buildTag('div.e-icon e-reload', '', {}, { "data-content": this._getLocalizedLabels("retryToolTip") });
                }
                element.find(".e-action-perform").append(actionlist);
                this._on(actionlist, "click", this._actionClick);
            }
        },

        _setStatus: function (element, status) {
            if (this.model.customFileDetails.status) {
                var progress, upstatus = ej.buildTag('div');
                if (status == "success") {
                    element.find(".file-status").addClass("e-file-status-success").html("Completed");
                    element.find(".e-file-percentage").html("");
                    upstatus.addClass("e-icon e-checkmark").attr("data-content", this._getLocalizedLabels("completedToolTip"));
                    element.find(".e-file-percentage").append(upstatus);
                }
                if (status == "failed") {
                    element.find(".file-status").addClass("e-file-status-failed").html("Failed");
                    element.find(".e-file-percentage").html("");
                    upstatus.addClass("e-icon e-file-percentage-failed").attr("data-content", this._getLocalizedLabels("failedToolTip"));
                    element.find(".e-file-percentage").append(upstatus);
                }
                if (status == "progress") {
                    element.find(".file-status").addClass("file-status-inprogress").html("in progress");
                }
                if (status == "uploading") {
                    element.find(".file-status").addClass("file-status-inprogress").html("uploading");
                    progress = element.find(".e-file-percentage");
                    progress.html("");
                }
            }
        },
        _renderTooltip: function () {
            var proxy = this;
            if (!ej.isNullOrUndefined(this.updialog)) {
                this.upTooltip = $(this.updialog).ejTooltip({
                    target: ".e-file-cancel, .e-delete, .e-reload, .e-checkmark, .e-close, .e-file-percentage-failed",
                    content: " ",
                    isBalloon: false,
					showRoundedCorner : this.model.showRoundedCorner,
                    enableRTL: this.model.enableRTL,
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    }
                }).data("ejTooltip");
                $(this.upTooltip.tooltip).css({ "min-width": "auto" });
            }
        },

        _createInputandBind: function () {
            var tempInput = ej.buildTag('input', '', {}, { type: 'file', "data-role": "none" });
            tempInput.attr("name", this.model.uploadName != "" ? this.model.uploadName : this.control.id).attr("autocomplete", "off").attr("class", "e-uploadinput").attr("accept",this.model.extensionsAllow);
            if (this.model.multipleFilesSelection) 
			 if (((navigator.userAgent.indexOf('Safari') != -1 )&& (navigator.userAgent.indexOf('Chrome') == -1 ))==false){
                tempInput.attr("multiple", "multiple");
            }
            tempInput.appendTo(this.element.find(".e-selectpart"));
            this.inputupload = tempInput;
            this._bindInputChangeEvent();
        },

        _showUploadButton: function () {
            var uploadbutton = this.updialog.find(".e-uploadbtn");
            if (uploadbutton.length == 0) {
                uploadbutton = ej.buildTag('button.e-uploadbtn e-btn e-select', this._getLocalizedLabels("upload"), {}, { type: "button", "data-role": "none" });
                if (this.model.showRoundedCorner)
                    uploadbutton.addClass('e-corner');
                this.updialog.find(".e-action-container").append(uploadbutton);
                this._on(uploadbutton, "click", this.__uploadButtonClick);
                this._on(uploadbutton, 'keydown', this._keydownUpload);
                $(uploadbutton).focus();
            }
            this._buttonText(this.model.buttonText);
        },

        _keydownUpload: function (e) {
            if (e.keyCode == 13) this.__uploadButtonClick(e);
        },

        _resetFileInput: function ($element) {
            var clone = $element.clone(false, false);
            this._on(clone, "change", this._inputValueChange);
            $element.replaceWith(clone);
        },

         _isAllowed: function (files) {
            var inputfield, uploadControl, args, allowExtension,allowSize,denyExtension, proxy = this, allowedFiles = [], filteredFiles = [],status=true;
            inputfield = this.element.find(".e-uploadinput");
            uploadControl = this;
			
            if (this.model.extensionsAllow != "") {
                allowExtension = this.model.extensionsAllow.replace(/\s/g, "").toLowerCase().split(",");
				
             
                $(files).each(function () {
                    if ($.inArray((this.extension).toLowerCase(), allowExtension) == -1) {

                        args = { action: "Files Processing", error:proxy._getLocalizedLabels("allowError").replace("#Extension", allowExtension.join(", ")), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        if (this.extension != "")
                            allowedFiles.push(this);
                    }
                });
            }

            else if (this.model.extensionsDeny != "") {
                denyExtension = this.model.extensionsDeny.replace(/\s/g, "").toLowerCase().split(",");
				
				
                $(files).each(function () {
                    if ($.inArray((this.extension).toLowerCase(), denyExtension) != -1) {

                        args = { action: "Files Processing", error: proxy._getLocalizedLabels("denyError").replace("#Extension", denyExtension.join(", ")), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        if (this.extension != "")
                            allowedFiles.push(this);
                    }
                });
            }
            else {
                $(files).each(function () {
                    if (this.extension != "")
                        allowedFiles.push(this);
                });
            }
            if (this.model.fileSize != "") {
                allowSize = this.model.fileSize;
                $(allowedFiles).each(function () {
                    if ((this.size > allowSize)) {
                  
                        args = { action: "Files Processing", error: proxy._getLocalizedLabels("filedetail").replace("#fileSize", allowSize), files: this };
                        uploadControl._trigger('error', args);
						proxy._resetFileInput(inputfield);
                        status = false;
                    }
                    else {
                        filteredFiles.push(this);
                    }
                });
            }
            else
                filteredFiles = allowedFiles;
            return { files: filteredFiles, status: status };
        },

        _fileListRemove: function () {
            var fileList = this.updialog.find(".e-upload-file .e-delete");
            if (fileList.length == 0) {
                this.updialog.find(".e-uploadbtn").attr('disabled', 'disabled').addClass('e-disable');
                this.updialog.ejDialog('close');
            }
        },

        _uploadHide: function () {
            var fileList = this.updialog.find(".e-upload-file .e-file-cancel");
            if (fileList.length == 0) {
                this.updialog.find(".e-ul").empty();
                this.updialog.find(".e-uploadbtn").attr('disabled', 'disabled').addClass('e-disable');
                this.updialog.ejDialog('close');
                this.upTooltip.hide();
            }
        },

        _onBeforeClose: function (args) {
            if (!ej.isNullOrUndefined(args.event)) if ($(args.event.currentTarget).hasClass("e-disable")) args.cancel = true;
            else args.cancel = false;
        },

        _dialogclose: function (e) {
            if (!this._currentElement.hasClass("e-disable")) {
                var closebtn = this.updialog.find(".e-uploadclosebtn");
                var file, fileItem;
                fileItem = this.updialog.find(".e-ul").children().first();
                file = $(fileItem).data("file");
                if (closebtn.hasClass("e-disable")) e.preventDefault();
                else {
                    this._uploadFileListDelete();
                    this.updialog.ejDialog('close');
                }
                this._trigger("cancel", { fileStatus: file });
            }
        },

        _uploadFileListDelete: function () {
            this.updialog.find(".e-ul").empty();
			this._currentElement.find(".e-uploadinput").val("");
            this._resetFileInput(this._currentElement.find(".e-uploadinput"));
            if (!this.model.asyncUpload)
                this._formResetSyncUpload();
        },

        _onXhrSelect: function (e) {
            var files, xhrUpload, addedFile;
            this._xhrBeforeUpload(this._files);
            xhrUpload = this;
            $.each(xhrUpload._files, function (i, fileItem) {
                addedFile = $(fileItem).data("filelist");
                xhrUpload._setAction(addedFile, "cancel"); // XhrUpload._Uploader._setAction(addedFile, "cancel");
                if (xhrUpload.model.autoUpload) {
                    xhrUpload._xhrPerformUpload(fileItem);
                } else {
                    xhrUpload._showUploadButton();
                }
            });
        },

        _xhrBeforeUpload: function (files) {
            var fileEntry, xhrUpload, formdata, addedFile;
            fileEntry = files;
            xhrUpload = this;
            $.each(fileEntry, function (i, fileItem) {
                formdata = xhrUpload._createFormObjectXhr(fileItem);
                $(fileItem).data("formobject", formdata);
                addedFile = xhrUpload._pushFileDetails(fileItem);
                $(fileItem).data("filelist", addedFile);
            });

            return fileEntry;
        },

        _xhrPerformUpload: function (fileItem) {
            var isPrevented, url, xhrUpload, formdata, xhr, args;
            xhr = new XMLHttpRequest();
            xhrUpload = this;
            args = { files: fileItem };
            if (this._trigger('begin', args)) {
                $(fileItem).data("xhr", xhr);
                xhrUpload._onRequestError(xhrUpload, undefined, fileItem);
                return;
            }
            url = this.model.saveUrl;
            formdata = $(fileItem).data("formobject");

            formdata.append(((this.model.uploadName && this.model.uploadName!="")? this.model.uploadName:this.control.id)+"_data", JSON.stringify(args.data));
            $(fileItem).data("xhr", xhr);
            xhr.addEventListener("load", function (e) {
                xhrUpload._onRequestSuccess(xhrUpload, e, fileItem);
            }, false);
            xhr.addEventListener("error", function (e) {
                xhrUpload._onRequestError(xhrUpload, e, fileItem);
            }, false);
            xhr.upload.addEventListener("progress", function (e) {
                xhrUpload._onRequestProgress(xhrUpload, e, fileItem);
            }, false);
            xhr.open("POST", url);
			args = { files: fileItem, xhr: xhr };
			if (this._trigger('beforeSend', args)) {
               $(fileItem).data("xhr", xhr);
               xhrUpload._onRequestError(xhrUpload, undefined, fileItem);
               return;
            }
            xhr.send(formdata);
        },

        _xhrOnUploadButtonClick: function (e) {
            var xhrUpload, fileEntry, started, fileCount;
            xhrUpload = this.model.showBrowseButton ? this.diaObj.wrapper : this.dragWrapper;
            fileCount = xhrUpload.find(".e-ul li.e-upload-file");
            for (var i = 0; i < fileCount.length; i++) {
                fileEntry = $(this);
                started = this._isFileUpload(fileCount[i]);
                if (started) {
                    this._xhrPerformUpload($(fileCount[i]).data("file"));
                }
            }
        },

        _xhrOnRemove: function (e, fileItem) {
            var filename = $(fileItem).find(".e-file-name").text().toString().split(","), proxy = this;
            $.ajax({
                url: this.model.removeUrl,
                type: "POST",
                data: "fileNames=" + filename,
                success: function () {
                    $(fileItem).remove();
                    proxy._fileListRemove();
                    proxy._trigger("remove", { fileStatus: proxy._file });

                }
            });
			this.upTooltip.hide();
        },

        _xhrOnCancel: function (e, fileItem) {
            var file, xhr;
            file = $(fileItem).data("file");
            xhr = $(file).data("xhr");
            if (xhr) {
                $(file).data("xhr").abort();
            }
            $(file).data("xhr", null);
            $(fileItem).data("file", null);
            $(fileItem).remove();
            this._uploadHide();
        },

        _xhrOnRetry: function (e, fileItem) {
            if (!this._currentElement.hasClass("e-disable")) {
                var file = $(fileItem).data("file");
                this._xhrPerformUpload(file);
            }
        },

        _onRequestSuccess: function (xhrUpload, e, fileEntry) {
            var xhr = $(fileEntry).data("xhr");
            if (xhr.status >= 200 && xhr.status <= 299) {
                xhrUpload._onXhrUploadSuccess(xhrUpload, e, fileEntry);
            }
            else {
                xhrUpload._onRequestError(xhrUpload, e, fileEntry);
            }
			if (xhrUpload._files.length == (this._successFiles.length + this._errorFiles.length)) {
                xhrUpload._trigger('complete', { files: fileEntry, responseText: xhr.responseText,success: this._successFiles,error: this._errorFiles, xhr: xhr, e: e });
                this._onClearCompletedFiles();
            }
        },
		
		_onClearCompletedFiles: function(){
			this._successFiles.length = this._errorFiles.length = 0;
            if (this.model.dialogAction.closeOnComplete) this._dialogclose()
		},

        _onXhrUploadSuccess: function (xhrUpload, e, fileEntry) {
            var addedFile, xhr, progressbar, size, fSize, filesize, args;
            addedFile = $(fileEntry).data("filelist");
            xhr = $(fileEntry).data("xhr");
            if (xhrUpload.model.removeUrl) {
                xhrUpload._setAction(addedFile, "remove");
                xhrUpload._setStatus(addedFile, "success");
            } else {
                addedFile.find(".e-action-perform .e-icon,.e-file-percentage .e-icon").remove();
                xhrUpload._setStatus(addedFile, "success");
            }
            if ($(fileEntry).length > 0) {
                progressbar = $(addedFile).find(".e-file-progress-status");
                progressbar.width("100%");
                size = $(fileEntry)[0].size;
                fSize = this._formatSize(size);
                filesize = $(addedFile).find(".e-file-size .e-file-name-txt");
                filesize.html(fSize + "\\" + fSize);
            }
            args = { files: fileEntry,responseText: xhr.responseText, xhr: xhr, e: e };
            this.updialog.find(".e-file-upload .e-uploadclosebtn").html(this.model.buttonText.close).focus();
            xhrUpload._trigger('success', args);
            this._successFiles.push(fileEntry);
        },

        _onRequestError: function (xhrUpload, e, fileEntry) {
            var addedFile, xhr, args;
            addedFile = $(fileEntry).data("filelist");
            xhr = $(fileEntry).data("xhr");
            xhrUpload._setAction(addedFile, "retry");
            xhrUpload._setStatus(addedFile, "failed");
            args = { action: "File Processing", error: xhr.status? xhr.status+" " + xhr.statusText:"Unable to reach the server.", files: fileEntry, xhr: xhr, e: e };
            xhrUpload._trigger('error', args);
			this._errorFiles.push(fileEntry);
        },

        _onRequestProgress: function (xhrUpload, e, fileEntry) {
            var percentage, addedFile,args;
            percentage = Math.round(e.loaded * 100 / e.total);
            addedFile = $(fileEntry).data("filelist");
            xhrUpload._setProgress(addedFile, percentage, e);
            xhrUpload._setStatus(addedFile, "progress");
            args = { file: fileEntry, percentage: percentage, e: e };
            this._trigger('inProgress', args);
        },

        _createFormObjectXhr: function (file) {
            var formData = new FormData();
            formData.append(this.model.uploadName != "" ? this.model.uploadName : this.control.id, file.rawFile);
            return formData;
        },

        _getInputFileInfo: function ($input) {
            var input = $input[0];
            if (input.files) {
                return this._getAllFileInfo(input.files);
            } else {
                return [{
                    name: this._GetName(input.value),
                    extension: this._getFileExtensionType(input.value),
                    size: this._getFileSizeinIE(input.value)
                }];
            }
        },

        _getFileSizeinIE: function (fileName) {
            var actievXObj, fileSize;
            actievXObj = null;
            fileSize = null;
            try {
                actievXObj = new ActiveXObject("Scripting.FileSystemObject");
            } catch (e) {
                fileSize = null;
            }
            if (actievXObj) {
                fileSize = actievXObj.getFile(fileName).size;
            }
            return fileSize;
        },

        _getFileExtensionType: function (fileName) {
            return fileName.match ? (fileName.match(/\.([^\.]+)$/) ? fileName.match(/\.([^\.]+)$/)[0] : "" || "") : "";
        },

        _getAllFileInfo: function (rawFiles) {
            var tempProxy = this;
            return $.map(rawFiles, function (file) {
                return tempProxy._getFileInfo(file || rawFiles);
            });
        },

        _GetName: function (fullname) {
            var nameIndex = fullname.lastIndexOf("\\");
            return (nameIndex != -1) ? fullname.substr(nameIndex + 1) : fullname;
        },

        _getFileInfo: function (rawFile) {
            // Older Firefox versions (before 3.6) use fileName and fileSize
            var fileName = rawFile.name || rawFile.fileName || rawFile;
            return {
                name: fileName,
                extension: this._getFileExtensionType(fileName),
                size: rawFile.size || rawFile.fileSize,
                rawFile: rawFile
            };
        },

        _formatSize: function (bytes) {
            var i = -1;
            if (!bytes)
                return "0.0KB";
            do {
                bytes = bytes / 1024;
                i++;
            } while (bytes > 99);
            return Math.max(bytes, 0).toFixed(1) + ['KB', 'MB', 'GB', 'TB', 'PB', 'EB'][i];
        },

        _onSelectIFrame: function (e) {
            var input, files, addedFile, uploadframe;
            input = $(e.target);
            files = this._getInputFileInfo(input);
            addedFile = this._beforeUploadIFrame(files);
            uploadframe = addedFile.data("iframe");
            if (this.model.autoUpload) {
                this._performUploadIFrame(addedFile);
            } else {
                this._showUploadButton();
            }
            this._off(this.inputupload, "change");
            this._bindInputChangeEvent();
        },

        _onRemoveIFrame: function (e, fileItem) {
            var iframe, fileNames, proxy, fileDetails;
            iframe = fileItem.data("iframe");
            fileDetails = $(fileItem).data("file");
            fileNames = fileDetails[0].name;
            proxy = this;
            if (iframe) {
                this._removeFileEntry(fileItem);
                if (this.model.removeUrl) {
                    $.ajax({
                        url: this.model.removeUrl,
                        type: "POST",
                        data: "fileNames=" + fileNames,
                        success: function () {
                            proxy._fileListRemove();
                            proxy._trigger("remove", { fileStatus: proxy._file });
                        }
                    });
                }
            } else {
                this._removeFileEntry(fileItem);
                this._trigger("remove", { fileStatus: this._file });
            }
        },

        _onCancelIFrame: function (e, fileItem) {
            var iframe;
            this._trigger('cancel', { Status: fileItem });
            iframe = fileItem.data("iframe");
            if (iframe) {
                this._removeFileEntry(fileItem);
                if (typeof (iframe.stop) != "undefined") {
                    iframe.stop();
                } else if (iframe.document) {
                    iframe.document.execCommand("Stop");
                    iframe.contentWindow.location.href = iframe.contentWindow.location.href;
                }
                this._processServerResponse(iframe, "");
            }
            this._uploadHide();
        },

        _onRetryIFrame: function (e, fileItem) {
            this._performUploadIFrame(fileItem);
        },

        _beforeUploadIFrame: function (files) {
            var uploadframe, uploadform, addedfile;
            //creating iframe and adding it to the upload div block.
            uploadframe = this._createFrame(this.control.id + "_Iframe" + this.Uploadframes.length);
            this.Uploadframes.push(uploadframe);
            uploadform = this._createForm(this.model.saveUrl, uploadframe[0].id);
            this._currentElement.find("input.e-uploadinput").removeClass("e-uploadinput").css("display", "none").appendTo(uploadform);
            this._createInputandBind();
            addedfile = this._pushFile(files, { "iframe": uploadframe, "form": uploadform, "file": files });
            uploadframe.data({ "filelist": addedfile });
            this._setAction(addedfile, "cancel");
            return addedfile;
        },

        _performUploadIFrame: function (addedFile) {
            var isPrevented, files, uploadframe, uploadform, args;
            args = { files: addedFile };
            if (this._trigger('begin', args)) {
                this._failureIframeUpload(addedFile, "File upload has been denied");
                return;
            }
            files = addedFile.data("file");
            this._setStatus(addedFile, "uploading");
            uploadframe = addedFile.data("iframe");
            uploadform = addedFile.data("form");
            var hiddendata = $("<input>").attr("name", ((this.model.uploadName && this.model.uploadName!="")? this.model.uploadName:this.control.id)+"_data").attr('type', 'hidden').val(JSON.stringify(args.data));
            uploadform.append(hiddendata);
            uploadframe.appendTo(document.body);
            uploadform.appendTo(document.body);
            //error here calls the upload even if the url is wrong
            this._on(uploadframe, "load", this._removeFramesIFrame);
            uploadform.submit();
        },

        _onUploadButtonClickIFrame: function (e) {
            var iframeUpload, fileEntry, started;
            iframeUpload = this;
            $(".e-ul li.e-upload-file", iframeUpload.updialog).each(function () {
                fileEntry = $(this);
                started = iframeUpload._isFileUpload(fileEntry);
                if (started) {
                    iframeUpload._performUploadIFrame(fileEntry);
                }
            });
        },

        _removeFramesIFrame: function (e) {
            var uploadframe, response, filelist, fileEntry, args;
            uploadframe = $(e.target);
			fileEntry = this._files;
            filelist = uploadframe.data("filelist");
            try {
                response = $.trim(e.target.contentDocument.body.innerText.replace(/\n|\r/g, ' '));
            } catch (e) {
                response = "Server Error trying to get server response: " + e;
            }
            if (response.substring(0, 12) != "Server Error" && response.indexOf("HTTP Error") != 0) {
                this._processServerResponse(uploadframe, response);
                this._setIframeProgress(filelist, 100, e);
                this._setStatus(filelist, "progress");
                this._successIframeUpload(filelist, response);
            }
            else { this._failureIframeUpload(filelist, response); }
			if (filelist.length == (this._successFiles.length + this._errorFiles.length)) {
                this._trigger('complete', { files: fileEntry, responseText: response, success: this._successFiles, error: this._errorFiles });
                this._onClearCompletedFiles();
            }		
        },


        _setIframeProgress: function (filelist, percentage, e) {
            var progressbar, progress, filesize, loaded, total;
            progressbar = $(filelist).find(".e-file-progress-status");
            progressbar.width(percentage + "%");
        },

        _successIframeUpload: function (filelist, response) {
            fileEntry = filelist.data("file");
            if (this.model.removeUrl) {
                this._setAction(filelist, "remove");
                this._setStatus(filelist, "success");
            } else {
                filelist.find(".file-action").remove();
                this._setStatus(filelist, "success");
            }
            args = { files: fileEntry, responseText: response };
            this.updialog.find(".e-file-upload .e-uploadclosebtn").html(this.model.buttonText.close).focus();
            this._trigger('success', args);
            this._successFiles.push(fileEntry);
        },

        _failureIframeUpload: function (filelist, response) {
            fileEntry = filelist.data("file");
            if (this.model.saveUrl && response != "File upload has been denied") {
                this._setAction(filelist, "retry");
                this._setStatus(filelist, "failed");
            } else {
                filelist.find(".file-action").remove();
                this._setStatus(filelist, "failed");
            }
            if (response.indexOf("HTTP Error") == 0)
                args = { files: fileEntry, responseText: response, status: response.match(/\d+/).toString() };
            else
                args = { files: fileEntry, responseText: response };
            this._trigger('error', args);
			this._errorFiles.push(fileEntry);
        },

        _processServerResponse: function (uploadframe) {
            var uploadform;
            uploadform = $(document.body).find("form[target='" + $(uploadframe).attr("id") + "']");
            setTimeout(function () {
                uploadform.remove();
                uploadframe.remove();
            }, 0);
        },

        _createDivBlock: function (className) {
            return ej.buildTag('div.' + className);
        },

        _createForm: function (action, target) {
            return ej.buildTag('form', '', {}, { enctype: 'multipart/form-data', method: 'POST', action: action, target: target });
        },

        _createFrame: function (id) {
            return ej.buildTag('iframe#' + id, '', { display: 'none' }, { name: id });
        },

        _createInput: function (id) {
            return ej.buildTag('input', '', {}, { type: 'file', name: id, "data-role": "none" });
        },



        _initObjectsSyncUpload: function () {
            this._currentElement.closest("form")
                    .attr("enctype", "multipart/form-data")
                    .attr("encoding", "multipart/form-data");
            this._wireEventsSyncUpload();
        },

        _wireEventsSyncUpload: function () {
            var closestform = this._currentElement.closest("form")[0];
            this._on($(closestform), "submit", this._formSubmitSyncUpload);
            this._on($(closestform), "reset", this._formResetSyncUpload);
        },

        _onSelectSyncUpload: function (e) {
            var input, files, selection, addedfile;
            input = $(e.target);
            selection = $(".e-selectpart", this.control);
            this._currentElement.find("input.e-uploadinput").removeClass("e-uploadinput").css("display", "none").appendTo(selection);
            this._createInputandBind();
            addedfile = this._pushFile(this._files, { "file": this._files, "Input": input });
        },

        _onCancelSyncUpload: function (e, fileItem) {
            var inputfield = fileItem.data("Input");
            fileItem.data("file", null);
            fileItem.data("Input", null);
            fileItem.remove();
            inputfield.remove();
            this._uploadHide();
        },

        _formSubmitSyncUpload: function (e) {
            var input, uploader;
            input = $(".e-uploadinput", this.control);
            input.attr("name", "");
            uploader = this.model.uploadName != "" ? this.model.uploadName : this.control.id;
            setTimeout(function () {
                input.attr("name", uploader);
            }, 0);
        },

        _formResetSyncUpload: function (e) {
            $(".e-selectpart", this.control).children('input[type="file"]').each(function () {
                if (!$(this).hasClass('e-uploadinput')) {
                    $(this).remove();
                }
            });
        }
        /*Sync End*/
    });
	ej.Uploadbox.Locale = ej.Uploadbox.Locale || {} ;
    
    ej.Uploadbox.Locale['default'] = ej.Uploadbox.Locale["en-US"] = {
        buttonText: {
            upload: "Upload",
            browse: "Browse",
            cancel: "Cancel",
            close: "Close"
        },
        dialogText: {
            title: "Upload Box",
            name: "Name",
            size: "Size",
            status: "Status"
        },
		dropAreaText: "Drop files or click to upload",
        filedetail: "The selected file size is too large.  Please select a file within #fileSize",
        denyError: "Files with #Extension extensions are not allowed.",
        allowError: "Only files with #Extension extensions are allowed.",
        cancelToolTip: "Cancel",
        removeToolTip: "Remove",
        retryToolTip: "Retry",
        completedToolTip: "Completed",
        failedToolTip: "Failed",
        closeToolTip: "Close"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Html TextArea
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    var xhr = null;
    ej.widget("ejRTE", "ej.RTE", {

        element: null,

        model: null,
        _rootCSS: "e-rte",
        validTags: ["textarea"],
        _addOnPersist: ["value", "height", "width"],
        _setFirst: false,
        _requiresID: true,
        _operationHandler: null,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            allowEditing: true,

            isResponsive: false,

            allowKeyboardNavigation: true,

            enableTabKeyNavigation: true,

            cssClass: "",

            height: "370",

            width: "786",

            enabled: true,

            htmlAttributes: null,

            externalCSS: null,

            enableXHTML: false,

            importSettings: { url: "" },

            exportToPdfSettings: { url: "", fileName: "PdfExport" },

            exportToWordSettings: { url: "", fileName: "WordExport" },

            validationRules: null,

            validationMessage: null,
            maxLength: 7000,

            minWidth: "400",

            maxWidth: null,

            minHeight: "280",

            maxHeight: null,

            showToolbar: true,

            showFooter: false,

            showHtmlSource: false,

            showWordCount: true,
            showCharCount: true,

            showHtmlTagInfo: true,

            showClearAll: false,

            iframeAttributes: null,

            showClearFormat: true,
            showContextMenu: true,

            showFontOption: true,
            autoFocus: false,
            enableHtmlEncode: false,
            showDimensions: false,

            showRoundedCorner: false,

            locale: "en-US",

            name: "",
            pasteCleanupSettings: {
				listConversion: false, 
				cleanCSS: false,
				removeStyles: false,
				cleanElements: false
			},
			toolbarOverflowMode:"popup",

            tools: {

                formatStyle: ["format"],

                edit: [],

                style: ["bold", "italic", "underline", "strikethrough"],

                alignment: ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],

                lists: ["unorderedList", "orderedList"],

                indenting: ["outdent", "indent"],

                doAction: ["undo", "redo"],

                links: ["createLink", "removeLink"],

                images: ["image"],
                media: ["video"],

                tables: ["createTable", "addRowAbove", "addRowBelow", "addColumnLeft", "addColumnRight", "deleteRow", "deleteColumn", "deleteTable"],
                view: ["fullScreen"],
                customTools: [],
                print: [],
                customOrderList: [],
                customUnOrderList: [],
                font: [],
                clipboard: [],
                clear: [],
                effects: [],
                casing: [],
                importExport: [],
            },

            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 }
                },
                isBalloon: false
            },
            toolsList: ["formatStyle", "font", "style", "effects", "alignment", "lists", "indenting", "clipboard", "doAction", "clear", "links", "images", "media", "tables", "casing", "customTools", "view", "print", "edit", "importExport"],

            colorCode: [
			            "000000", "FFFFFF", "C4C4C4", "ADADAD", "595959", "262626", "4f81bd", "dbe5f1", "b8cce4", "95b3d7", "366092", "244061", "c0504d", "f2dcdb", "e5b9b7", "d99694", "953734",
			            "632423", "9bbb59", "ebf1dd", "d7e3bc", "c3d69b", "76923c", "4f6128", "8064a2", "e5e0ec", "ccc1d9", "b2a2c7", "5f497a", "3f3151", "f79646", "fdeada", "fbd5b5", "fac08f",
			            "e36c09", "974806"
            ],

            format: [
                { text: "Paragraph", value: "<p>", spriteCssClass: "e-paragraph" },
                { text: "Quotation", value: "<blockquote>", spriteCssClass: "e-quotation" },
                { text: "Heading 1", value: "<h1>", spriteCssClass: "e-h1" },
                { text: "Heading 2", value: "<h2>", spriteCssClass: "e-h2" },
                { text: "Heading 3", value: "<h3>", spriteCssClass: "e-h3" },
                { text: "Heading 4", value: "<h4>", spriteCssClass: "e-h4" },
                { text: "Heading 5", value: "<h5>", spriteCssClass: "e-h5" },
                { text: "Heading 6", value: "<h6>", spriteCssClass: "e-h6" }
            ],

            fontName: [
                       {
                           text: "Segoe UI",
                           value: "Segoe UI"
                       },
                       {
                           text: "Arial",
                           value: "Arial,Helvetica,sans-serif"
                       },
                       {
                           text: "Courier New",
                           value: "Courier New,Courier,monospace"
                       },
                       {
                           text: "Georgia",
                           value: "Georgia,serif"
                       },
                       {
                           text: "Impact",
                           value: "Impact,Charcoal,sans-serif"
                       },
                       {
                           text: "Lucida Console",
                           value: "Lucida Console,Monaco,monospace"
                       },
                       {
                           text: "Tahoma",
                           value: "Tahoma,Geneva,sans-serif"
                       },
                       {
                           text: "Times New Roman",
                           value: "Times New Roman,Times,serif"
                       },
                       {
                           text: "Trebuchet MS",
                           value: "Trebuchet MS,Helvetica,sans-serif"
                       },
                       {
                           text: "Verdana",
                           value: "Verdana,Geneva,sans-serif"
                       }
            ],

            fontSize: [
                {
                    text: "1 (8pt)",
                    value: "8pt"
                },
                {
                    text: "2 (10pt)",
                    value: "10pt"
                },
                {
                    text: "3 (12pt)",
                    value: "12pt"
                },
                {
                    text: "4 (14pt)",
                    value: "14pt"
                },
                {
                    text: "5 (18pt)",
                    value: "18pt"
                },
                {
                    text: "6 (24pt)",
                    value: "24pt"
                },
                {
                    text: "7 (36pt)",
                    value: "36pt"
                }
            ],

            tableRows: 8,

            tableColumns: 10,

            colorPaletteRows: 6,

            colorPaletteColumns: 6,

            showCustomTable: true,

            value: null,

            undoStackLimit: 50,

            enableResize: true,

            enablePersistence: false,

            enableRTL: false,

            autoHeight: false,

            zoomStep: '0.05',

            imageBrowser: {

                filePath: "",

                extensionAllow: "*.png,*.gif,*.jpg,*.jpeg",

                ajaxAction: "",

                ajaxSettings: ""
            },

            fileBrowser: {

                filePath: "",

                extensionAllow: "*.doc,*.docx,*.pdf,*.txt",

                ajaxAction: ""
            },


            change: null,

            execute: null,

            keydown: null,

            keyup: null,

            create: null,

            destroy: null,
            contextMenuClick: null,
            preRender: null,
            select: null
        },

        dataTypes: {
            enabled: "boolean",
            autoFocus: "boolean",
            enableHtmlEncode: "boolean",
            autoHeight: "boolean",
            enableXHTML: "boolean",
            isResponsive: "boolean",
            enablePersistence: "boolean",
            showRoundedCorner: "boolean",
            showCustomTable: "boolean",
            enableResize: "boolean",
            importSettings: { url: "string" },
            exportToPdfSettings: { url: "string", fileName: "string" },
            exportToWordSettings: { url: "string", fileName: "string" },
            pasteCleanupSettings: {
				listConversion: "boolean", 
				cleanCSS: "boolean",
				removeStyles: "boolean",
				cleanElements: "boolean"
			},
            showDimensions: "boolean",
            showFontOption: "boolean",
            showClearFormat: "boolean",
            showClearAll: "boolean",
            showHtmlTagInfo: "boolean",
            showWordCount: "boolean",
            showCharCount: "boolean",
            showHtmlSource: "boolean",
            allowKeyboardNavigation: "boolean",
            enableTabKeyNavigation: "boolean",
            allowEditing: "boolean",
            showToolbar: "boolean",
            showFooter: "boolean",
            showContextMenu: "boolean",
            enableRTL: "boolean",
            toolsList: "array",
            colorCode: "array",
			toolbarOverflowMode:"enum",
            format: "data",
            fontName: "data",
            fontSize: "data",
            htmlAttributes: "data",
            iframeAttributes: "data",
            tools: {
                formatStyle: "array",
                font: "array",
                edit: "array",
                style: "array",
                effects: "array",
                alignment: "array",
                lists: "array",
                indenting: "array",
                clipboard: "array",
                doAction: "array",
                clear: "array",
                links: "array",
                media: "array",
                images: "array",
                tables: "array",
                casing: "array",
                customTools: "array",
                view: "array",
                print: "array",
                importExport: "array",
                customOrderList: "array",
                customUnOrderList: "array"
            }
        },

        _rteIconsList: {
            "format": "format",
            "bold": "e-bold_01",
            "italic": "e-italic_01",
            "underline": "e-underline_01",
            "strikethrough": "e-strikethrough_01",
            "justifyLeft": "e-align-left_01",
            "justifyCenter": "e-align-center_01",
            "justifyRight": "e-align-right_01",
            "justifyFull": "e-align-justify_01",
            "unorderedList": "e-bullets_01",
            "orderedList": "orderedList",
            "outdent": "outdent",
            "indent": "indent",
            "undo": "undo",
            "redo": "redo",
            "createLink": "e-link_01",
            "removeLink": "e-unlink_01",
            "image": "e-image",
            "video": "e-video",
            "createTable": "e-table_02",
            "addRowAbove": "e-insert-row-above_02",
            "addRowBelow": "e-insert-row-below_02",
            "addColumnLeft": "e-insert-column-left_02",
            "addColumnRight": "e-insert-column-right_02",
            "deleteRow": "e-delete-row_01",
            "deleteColumn": "e-delete-column_01",
            "deleteTable": "deleteTable",
            "fullScreen": "fullScreen",
            "superscript": "e-superscript_01",
            "subscript": "e-subscript_01",
            "upperCase": "e-uppercase_01",
            "lowerCase": "e-lowercase_01",
            "zoomIn": "e-zoom-in",
            "zoomOut": "e-zoom-out",
            "print": "print",
            "import": "e-upload",
            "wordExport": "e-icon e-word-export",
            "pdfExport": "e-icon e-pdf-export",
            "findAndReplace": "findAndReplace",
            "cut": "e-cut_01",
            "copy": "e-copy_02",
            "paste": "e-paste_01",
            "clearFormat": "clearFormat",
            "clearAll": "e-delete_05",
            "fontName": "fontName",
            "fontSize": "fontSize",
            "fontColor": "e-font",
            "backgroundColor": "e-background-color",
            "rteResize": "e-resize-handle",
            "rteSource": "e-file-code",
            "customTableImage": "e-table",
            "resize": "e-full-screen-collapse_01",
            "maximize": "e-full-screen-expand_01",
            //Added empty strings for context menu
            "openLink": "",
            "deleteTables": "",
            "insertTable": "",
            "tableProperties": "",
            "imageProperties": ""
        },

        observables: ["value"],
        value: ej.util.valueFunction("value"),

        _setModel: function (options) {
            this._isInteraction = false;
            var option;
            for (option in options) {
                switch (option) {
                    case "allowEditing": this._enableEdit(options[option]); break;
                    case "autoFocus ": { this.model.autoFocus = options[option]; if (options[option]) this._focus(); break; }
                    case "showToolbar": {
                        options[option] ? (ej.isNullOrUndefined(this._rteToolbar) ? this._renderToolBar() : (this._rteToolbar.show() , (this.model.isResponsive && this._toolBarObj._reSizeHandler()))): this._rteToolbar.hide();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[option];
                        options[option] ? ej.isNullOrUndefined(this._rteFooter) ? this._renderFooter() : this._rteFooter.show() : this._rteFooter.hide();
                        break;
                    }
                    case "pasteCleanupSettings":
                        this.model.pasteCleanupSettings = options[option];
                        if (ej.clipboardCleaner) {
                            if (!this._pasteCleaner)
                                this._enableContentCleaner();
                            this._pasteCleaner && (this._pasteCleaner.filterOptions = options[option]);
                        }						
                    case "isResponsive": {
                        this.model.isResponsive = options[option];
                        this._renderToolBarList();
                        var iframeHeight = $(this._rteIframe).outerHeight();
                        var toolListHeight = $(this._rteToolbar).outerHeight();
                        $(this._rteWapper).height(iframeHeight + toolListHeight);
                        if (!ej.isNullOrUndefined($(this._rteFooter))) {
                            var footerHeight = $(this._rteFooter).outerHeight();
                            $(this._rteWapper).height(iframeHeight + footerHeight + toolListHeight);
                        }
                        break;
                    }
                    case "enabled": this._disabled(options[option]); break;
                    case "height": { this.model.height = options[option]; this._rteWapper.height(options[option]); } break;
                    case "width": { this.model.height = options[option]; this._rteWapper.css("width", options[option]); } break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showHtmlSource": this._footerElement("div.e-rte-source", options[option]); break;
                    case "showHtmlTagInfo": this._footerElement("div.e-rte-htmltaginfo", options[option]); break;
                    case "showWordCount": {
                        this.model.showWordCount = options[option];
                        this._createCountElement(options[option], this._wordCount);
                        break;
                    }
                    case "showCharCount": {
                        this.model.showCharCount = options[option];
                        this._createCountElement(options[option], this._charCount);
                        break;
                    }
                    case "tooltipSettings": {
                        this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
                        if (this.model.showToolbar)
                            this._toolBarItems.ejToolbar("option", "tooltipSettings", options[option]);
                        this._renderTooltip(this.model.tooltipSettings);
                        break;
                    }
                    case "showClearAll": this._footerElement("div.clearAll", options[option]); break;
                    case "showClearFormat": this._footerElement("div.clearFormat", options[option]); break;
                    case "enableResize": this._footerElement("div.e-rte-resize", options[option]); break;
                    case "fontName": this._fontStyleDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "fontSize": this._fontSizeDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "format": this._formatDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "value":
                        if (ej.isPlainObject(options[option])) options[option] = null;
                        var optionValue = ej.util.getVal(options[option]);
                        if (optionValue != this._getDocument().body.innerHTML){
                            this._getDocument().body.innerHTML=optionValue;
                            var args = { text: this._getText(), htmlText: this.getHtml() };
                            this._onChange();
                        } 
                        break;
                    case "showDimensions":
                        this._renderImageDialog();
                        if (options[option]) {
                            this._imgDialog.find("div.e-rte-imgdimensions").show();
                            this._imgDialog.find("div.e-rte-videoDimensions").show();
                        }
                        else {
                            this._imgDialog.find("div.e-rte-imgdimensions").hide();
                            this._imgDialog.find("div.e-rte-videoDimensions").hide();
                        }
                        break;
                    case "showFontOption":
                        if (options[option])
                            this._rteWapper.find("ul.e-rte-fontgroup").show();
                        else
                            this._rteWapper.find("ul.e-rte-fontgroup").hide();
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "importSettings": {
                        this.model.importSettings = $.extend(true, this.model.importSettings, options[option]);
                        break;
                    }
                    case "exportToPdfSettings": {
                        this.model.exportToPdfSettings = $.extend(true, this.model.exportToPdfSettings, options[option]);
                        break;
                    }
                    case "exportToWordSettings": {
                        this.model.exportToWordSettings = $.extend(true, this.model.exportToWordSettings, options[option]);
                        break;
                    }
                    case "tableRows": {
                        this.model.tableRows = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "iframeAttributes": {
                        this._updateIframeSkin(options[option]);
                        break;
                    }
                    case "tableColumns": {
                        this.model.tableColumns = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "showCustomTable": {
                        this._createCustomTable();
                        var custLink = this._createTable.find("div.customtable-group");
                        options[option] ? ej.isNullOrUndefined(this._customTableDialog) ? this._createCustomTable() : custLink.show() : custLink.hide();
                        break;
                    }
                    case "colorPaletteRows": {
                        this.model.colorPaletteRows = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorPaletteColumns": {
                        this.model.colorPaletteColumns = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorCode": {
                        this.model.colorCode = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "name": {
                        this.model.name = options[option];
                        this._checkNameAttr();
                        break;
                    }
                    case "showContextMenu":
                        this.model.showContextMenu = options[option];
                        this._showHideContextMenu();
                        break;
                    case "enableRTL": this._enableRTL(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "autoHeight": this.model.autoHeight = options[option];
                        this._setAutoHeight();
                }
                if (option != "locale")
                    this._setIframeHeight();
            }
            this._updateCount();
        },
		_updateLocalConstant:function(){
			this._localizedLabels = ej.getLocalizedConstants("ej.RTE", this.model.locale);
		},
		_enableContentCleaner:function(){
			if(ej.clipboardCleaner && !this._isIE8()){
				!this._pasteCleaner && (this._pasteCleaner=new ej.clipboardCleaner(this._getDocument(),this._iframePaste,this));
				this._pasteCleaner.filterOptions = this.model.pasteCleanupSettings;
			}
		},
        _init: function () {
            if (!ej.isNullOrUndefined(this.element) && this.element[0].type == "textarea") {
				this._updateLocalConstant();
                this.element.hide();
                this._initialize()
                    ._render();
                this.model.allowEditing && this._wireEvents();
                this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion) && this._enableContentCleaner();
                if(this.model.iframeAttributes != null) this._updateIframeSkin(this.model.iframeAttributes);
                if (this.model.enabled == false) this._disabled(this.model.enabled);
                if(this.model.htmlAttributes != null) this._addAttr(this.model.htmlAttributes);
                if (this.model.autoFocus) {
                    this._focus();
                    this._updateToolbarStatus();
                    this._updateFontOptionStatus();
                    this._updateFormat();
                }
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._decode(this.value())));
                if (this.model.showToolbar) {
                    this.disableToolbarItem("removeLink");
                    if (!ej.isNullOrUndefined(this._getWindow()))
                        this._updateIndentStatus();
                }
                if (this.model.enableRTL)
                    this._enableRTL(true);
                this.model.externalCSS && this._addCssToIframe(this.model.externalCSS);
                this.wrapper = this._rteWapper;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                if (this.model.showContextMenu) {
                    this._showHideContextMenu();
                }
                this._isInteraction = true;
            }
        },
        _hideContextMenuByItem: function (data) {
            for (var index1 = 0; index1 < $(this._textMenuObj.element).children("li").length; index1++)
                ($.inArray($(this._textMenuObj.element.children("li")[index1]).attr("id"), data) != -1) ? $(this._textMenuObj.element.children("li")[index1]).show() : $(this._textMenuObj.element.children("li")[index1]).hide();
        },
        _filterMenuItems: function (e) {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode(), node = this._saveSelection().commonAncestorContainer;
            if (!ej.isNullOrUndefined(selectNode) && !ej.isNullOrUndefined(selectNode.tagName) && (selectNode.tagName.toLowerCase() === "img" || e.target.tagName.toLowerCase() == "img")) {
                this._hideContextMenuByItem(this._contextType.image);
                this._updateContextMenuItemState(true);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("table").length) {
                this._hideContextMenuByItem($(selectNode).closest("a").length ? this._contextType.table_hyper : this._contextType.table);
                this._contextValidation(node, e);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("a").length) {
                this._hideContextMenuByItem(this._contextType.hyperlink);
                this._contextValidation(node, e);
            }
            else if (this._isIE8()) {
                this._hideContextMenuByItem(this._contextType.text);
                this._updateContextMenuItemState(this._getRange().text !== "");
            }
            else {
                this._hideContextMenuByItem(this._contextType.text);
                this._contextValidation(node, e);
            }
            this._rteIframe.contents().find("body").addClass("e-cursor");
        },
        _contextmenuPosition: function (e) {
            var posX = (( e.clientX == undefined ) ? 0 : e.clientX ) + this._rteWapper.offset().left , posY = (( e.clientY == undefined ) ? 0 : e.clientY ) + this._rteWapper.offset().top + (this._rteToolbar ? this._rteToolbar.outerHeight() : 0) , menuHeight = this._textMenuObj.element.attr("style", "visibility: visible;display:block;").height() ,  menuWidth = this._textMenuObj.element.width();
            posY = ((posY + menuHeight) < ($(document).scrollTop() + $(window).height())) ? posY : ((posY - menuHeight) < 0 ? posY : (posY - menuHeight));
            posX = ((posX + menuWidth) < ($(document).scrollLeft() + $(window).width())) ? posX : (posX - menuWidth);
            this._textMenuObj.element.attr("style", ("width:auto;left:" + posX + "px;top:" + posY + "px;z-index:" + (this._onGetMaxZindex() + 1))).focus();
        },
        _contextValidation: function (node, e) {
            var data;
            this._updateContextMenuItemState(node && (data = node.nodeValue ? node.nodeValue : node.textContent) && ((this._saveSelection().endContainer == this._saveSelection().startContainer) ? (data.substring(this._saveSelection().startOffset, this._saveSelection().endOffset) !== "") : true));
        },
        _updateContextMenuItemState: function (stauts) {
            stauts ? (this._textMenuObj.enableItemByID("cut"), this._textMenuObj.enableItemByID('copy')) : (this._textMenuObj.disableItemByID("cut"), this._textMenuObj.disableItemByID('copy'));
        },
        _contextMenuClick: function (e) {
            var spellObj = this._rteIframe.data("ejSpellCheck");
            var action = e.ID ? e.ID.toLowerCase() : $(e.element).attr("id").toLowerCase(), _node;
            this._isIE() && this._ieSelectionRange && this.selectRange(this._ieSelectionRange);
            switch (action) {
                case "cut":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("cutAlert")) : this._getDocument().execCommand(action, false, undefined);
                    if (this._imgOrg && this._imgDupDiv && this._imgBoxMouseMove) {
                        $(this._imgOrg).css("outline", "");
                        $(this._imgDupDiv).remove();
                        this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
                    }
                    this._updateCursor();
                    break;
                case "copy":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("copyAlert")) : this._getDocument().execCommand(action, false, undefined);
                    this.selectRange(this._getRange());
                    break;
                case "paste":
                    (!this._isIE()) ? this._openAlert(this._getLocalizedLabels("pasteAlert")) : this._getDocument().execCommand(action, false, undefined);
                    break;
                case "openlink":
                    this._onOpen();
                    break;
                case "createlink":
                    this._renderLinkDialog();
                    (!this._linkDialog) && this._renderLinkDialog();
                    this._hyperLinkManager(false);
                    break;
                case "imageproperties":
                    this._renderImageDialog();
                    (!this._imgDialog) && this._renderImageDialog();
                    this._imageManager();
                    break;
                case "addcolumnleft":
                    _node = this.insertColumn(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addcolumnright":
                    _node = this.insertColumn(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowabove":
                    _node = this.insertRow(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowbelow":
                    _node = this.insertRow(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "deleterow":
                    this.removeRow(this._currentSelNode);
                    break;
                case "deletecolumn":
                    this.removeColumn(this._currentSelNode);
                    break;
                case "deletetable":
                    this.removeTable($(this._currentSelNode).closest('table'));
                    break;
                case "tableproperties":
                    this._renderEditTableDialog();
                    (!this._eTblDialog) && this._renderEditTableDialog()
                    this._eTblManager();
                    this._eTblDialog.ejDialog("open");
                    break;
                case "removelink":
                    this._onUnlink();
                    break;
                case "add to dictionary":
                    var addWord = (this._currentSelNode.innerText).trim();
                    spellObj._currentElement = $("#"+ spellObj._id);
                    spellObj.addToDictionary(addWord);
                    this._ieCursorMaintainance();
                    break;
                case "ignoreall":
                    var errorWord = (this._currentSelNode.innerText).trim();
                    var result = spellObj.ignoreAll(errorWord, this.getHtml()); 
                    this.setHtml(result.resultHTML);
                    this._ieCursorMaintainance();
                    break;
                default:
                    if(!ej.isNullOrUndefined(spellObj)){
                    var replaceItem = document.createTextNode(e.text);
                    this._currentSelNode.parentNode.insertBefore(replaceItem, this._currentSelNode);
                    $(this._currentSelNode).remove();
                    }
            }
            this._trigger("contextMenuClick", { event: e });
            this._onChange();
        },
        _updateCursor: function (node, rangeData) {
            if (!this._isIE8()) {
                var _range = this._getDocument().createRange(), _currentRange = this._getRange();
                if (node)
                    this._setRange(node, _currentRange, true);
                else if (rangeData) {
                    _range.setStart(rangeData.startContainer, rangeData.startOffset);
                    _range.setEnd(rangeData.endContainer, rangeData.endOffset);
                    this.selectRange(_range);
                }
                else {
                    _range.setStart(_currentRange.startContainer, _currentRange.startOffset);
                    _range.setEnd(_currentRange.startContainer, _currentRange.startOffset);
                    this.selectRange(_range);
                }
            }
        },
        _loadRules: function () {
            var rteObj= this.element.data('ejRTE');
            jQuery.validator.addMethod("contentRequired", function (value, element) {
                return $.trim(rteObj._getText());
            }, "Please specify the value.");
            jQuery.validator.addMethod("maxWordCount", function (value, element, params) {
                return $.trim(rteObj._getText()).split(/\W+/).length <= params;
            }, "Please enter the content with in max word count.");
            jQuery.validator.addMethod("minWordCount", function (value, element, params) {
                return $.trim(rteObj._getText()).split(/\W+/).length >= params;
            }, "Please enter the content with min word count.");
            jQuery.validator.addMethod("minCharCount", function (value, element, params) {
                return rteObj._getText().length >= params;
            }, "Please enter the content with min length.");
            jQuery.validator.addMethod("maxCharCount", function (value, element, params) {
                return rteObj._getText().length <= params;
            }, "Please enter the content with in  max length.");
            this._customRules = { "required": "contentRequired", "maxWordCount": "maxWordCount", "minWordCount": "minWordCount", "maxlength": "maxCharCount", "minlength": "minCharCount", "equalTo": "equalTo" };
        },
        _initValidator: function () {
            this._loadRules();
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _getRuleData: function (rule, data) {
            var ruleData = null;
            switch (rule) {
                case "contentRequired":
                    ruleData = { 'contentRequired': data };
                    break;
                case "minCharCount":
                    ruleData = { 'minCharCount': data };
                    break;
                case "maxCharCount":
                    ruleData = { 'maxCharCount': data };
                    break;
                case "maxWordCount":
                    ruleData = { 'maxWordCount': data };
                    break;
                case "minWordCount":
                    ruleData = { 'minWordCount': data };
                    break;
                case "equalTo":
                    ruleData = { 'equalTo': data };
                    break;
            }
            return ruleData;
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                var validator = this.element.closest("form").validate(), rule, ruleVal, name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName]) && this._customRules[ruleName]) {
                        rule = this._customRules[ruleName], ruleVal = this.model.validationRules[ruleName];
                        this.element.rules("add", this._getRuleData(rule, ruleVal));
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][rule]))
                            message = this.model.validationRules["messages"][rule];
                        else {
                            validator.settings.messages[name][rule] = $.validator.messages[rule];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][rule] = message != null ? message : $.validator.messages[rule];
                    }
                }
            }
        },
        _addAttr: function (htmlAttr) {
            if (htmlAttr != null) {
                var proxy = this;
                $.map(htmlAttr, function (value, key) {
                    if (key == "class") proxy._rteWapper.addClass(value);
                    else if (key == "name") proxy.element.attr(key, value);
                    else if (key == "required") proxy.element.attr(key, value);
                    else if (key == "disabled" && value == "disabled") proxy.disable();
                    else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                    else proxy._rteWapper.attr(key, value);
                });
            }
        },
        _addCssToIframe: function (value) {
            var substr = $.isArray(value) ? value : value.split(',');
            for (var i = 0; i < substr.length; i++) {
                var linkTag = document.createElement("link");
                linkTag.href = substr[i];
                linkTag.rel = "stylesheet";
                linkTag.type = "text/css";
                this._rteIframe.contents().find("head").append(linkTag);
            }
        },
        _disabled: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _destroy: function () {
            this.element.insertBefore(this._rteWapper);
            !ej.isNullOrUndefined(this._tooltip) && $(this._rteFooter).ejTooltip("destroy");
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._unOrderSplit) && this._unOrderSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._orderSplit) && this._orderSplit.ejSplitButton("destroy");
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-ddlAlignment")) && this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("destroy");
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-txtBorder")) && this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("destroy");
            }
            !ej.isNullOrUndefined(this._linkDialog) && $(this._linkDialog).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("destroy");
                $(this._imgDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._videoDialog) && $(this._videoDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._createTable) && $(this._createTable).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._sourceDialog) && $(this._sourceDialog).closest("div.e-dialog-wrap").remove();
		    !ej.isNullOrUndefined(this._customColor )&& $(this._customColor ).closest("div.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
			!ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._alertWindow) && $(this._alertWindow).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("destroy");
                $(this._eTblDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._explorerObj) && this._explorerObj.destroy();
            !ej.isNullOrUndefined(this._imgPicker) && this._imgPicker.destroy();
			!ej.isNullOrUndefined(this._tblborderPicker) && this._tblborderPicker.destroy();
            !ej.isNullOrUndefined(this._fileDialog) && $(this._fileDialog).closest("div.e-rte.e-dialog-wrap").remove();
			this._textMenuObj && this._textMenuObj.destroy();
            this._toolBarObj && this._toolBarObj.destroy();
            this._rteWapper.remove();
			if($("#"+this._rteId+"customcolor_popup").length>0)
			$("#"+this._rteId+"customcolor_popup").remove();
			if($("#"+this._rteId+"customcolor_Presets").length>0)
			$("#"+this._rteId+"customcolor_Presets").remove();
            this.element.show();
            this.element.focus();
            this._createTable = null;
            this._unwireEvents();
        },

        _initialize: function () {
            this._toolsList = this.model.toolsList;
            this._rteId = this.element[0].id;
            this._rteId = this._rteId ? this._rteId : "";
            this._backupArray = new Array();
            this._undoRedoPosition = 0;
            this._fontColor = "#000000";
            this._bgColor = "#ffffff";
            this._imgWidth = 0;
            this._imgHeight = 0;
            this._videoWidth = 0;
            this._videoHeight = 0;
            this._keypressFlag = true;
            this._styleItems = ej.isNullOrUndefined(this.model.tools["style"]) ? [] : this.model.tools["style"];
            this._alignItems = ej.isNullOrUndefined(this.model.tools["alignment"]) ? [] : this.model.tools["alignment"];
            this._listItems = ej.isNullOrUndefined(this.model.tools["lists"]) ? [] : this.model.tools["lists"];
            this._scriptsItems = ej.isNullOrUndefined(this.model.tools["effects"]) ? [] : this.model.tools["effects"];
            this._contextMenu = ["cut", "copy", "paste", "|", "insertTable", ["addColumnLeft", "addColumnRight", "addRowAbove", "addRowBelow"], "|", "deleteTables", ["deleteRow", "deleteColumn", "deleteTable"], "|", "tableProperties", "|", "createLink", "openLink", "removeLink", "imageProperties"];
            this._contextType = { text: ["cut", "copy", "paste", "createLink"], image: ["cut", "copy", "paste", "imageProperties"], hyperlink: ["cut", "copy", "paste", "createLink", "openLink", "removeLink"], table: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink"], table_hyper: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink", "openLink", "removeLink"] };
            return this;
        },

        _render: function () {
            this._renderWrapper()
            ._checkNameAttr();
            if (this.model.showToolbar) {
                this._renderToolBar();
            }
            this._trigger("preRender", this.element);
            this._renderEditArea();
            this.model.showFooter && this._renderFooter();
            this._setIframeHeight();
            this._rteWidth = this.model.width;
            this._rteHeight = this.model.height;
            this._renderAlertDialog();
            this._roundedCorner(this.model.showRoundedCorner);
            this.undoTimeout = null;
        },

        _initContextMenu: function () {
            var menuOptions = [], subMenuOptions = [];
            for (var i = 0; i < this._contextMenu.length; i++) {
                if (this._contextMenu[i] != "|") {
                    if (typeof this._contextMenu[i] === "object") {
                        var temp = i + 1;
                        for (var j = 0; j < this._contextMenu[i].length; j++) {
                            if (this._contextMenu[i][j] != "|") {
                                menuOptions.push({ id: this._contextMenu[i][j], parentId: this._contextMenu[i - 1], text: this._getLocalizedLabels(this._contextMenu[i][j]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i][j] + " " + this._rteIconsList[this._contextMenu[i][j]], htmlAttr: (this._contextMenu[i + 1][j + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i][j] } : { "id": this._contextMenu[i][j] }) });
                            }
                        }
                    } else {
                        menuOptions.push({ id: this._contextMenu[i], parentId: null, text: this._getLocalizedLabels(this._contextMenu[i]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i] + " " + this._rteIconsList[this._contextMenu[i]], htmlAttr: (this._contextMenu[i + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i] } : { "id": this._contextMenu[i] }) });
                    }
                }
            }
            return menuOptions;
        },
        _createContextMenu: function () {
            var ContextMenutag = ej.buildTag('ul.e-rte-context-menu #' + this._id + "_contextmenu");
            var proxy = this;
            ContextMenutag.ejMenu({
                menuType: ej.MenuType.ContextMenu,
                enableSeparator: true,
                width: "auto",
                enableRTL: this.model.enableRTL,
                cssClass: this.model.cssClass,
                contextMenuTarget: this._getDocument(),
                click: $.proxy(this._contextMenuClick, this),
                fields: { dataSource: this._initContextMenu(), id: "id", parentId: "parentId", text: "text", htmlAttribute: "htmlAttr", spriteCssClass: "sprite" },
                beforeOpen: function (args) { 
                this._spellObj = proxy._rteIframe.data("ejSpellCheck");
                      if($(args.target).hasClass("errorspan") && !ej.isNullOrUndefined(this._spellObj)){  
                    this._spellObj._selectedTarget=args.target;
                    this._spellObj._selectedValue=args.target.innerText;
                    var filterValue = this._spellObj._filterSuggestions(this._spellObj, this._spellObj._selectedValue);
                    if (filterValue.length > 0) { 
                        this._spellObj._suggestedWords = filterValue[0].SuggestedWords;
                        } else {
                        this._spellObj.getSuggestionWords(args.target.innerText); 
                        }   
                        proxy._spellcheckContextMenu(args, this._spellObj);          
                    }
                    else{
                        var customMenus = $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions"); 
                        if (customMenus.length > 0 )
                            $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parent().parent().remove();
                      }
                    (proxy._isIE() && proxy._ieSelectionRange) && proxy.selectRange(proxy._ieSelectionRange);
                    proxy.model.enabled ? this.enable() : this.disable();
                    proxy._filterMenuItems(proxy._contextMenuEventArgs = args.events);
                    $(this.element).parent().hide();
                    $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parents("li").css('display', 'block');
                },
                open: function () {
                    this.element.attr("style", ("visibility:visible;width:auto;display:block;left:0px;top:0px;"));
                    this.element.parent().show();
                    proxy._contextmenuPosition(proxy._contextMenuEventArgs);
                    this._showAnimation(this.element, this._showAnim);
                    $(this.element).focus();
                },
                close: function () {
                    $(proxy._getDocument()).find("body").removeClass("e-cursor");
                }
            });
            var menuObj = ContextMenutag.data("ejMenu");
			 if (menuObj._isContextMenuOpen) {
                if (document.addEventListener)
				 document.addEventListener("scroll",function (event) { menuObj.hideContextMenu(event); }, true);
			 else  
              document.attachEvent("scroll",function (event) { menuObj.hideContextMenu(event); }, true); 
             }
            return ContextMenutag;
        },
         _spellcheckContextMenu: function(args, spellcheck){
            var proxy= this;   
            var target = args.events.target;  
            var customMenus = $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions"); 
            if (customMenus.length > 0 )
                $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parent().parent().remove();
            var suggestionList= [this._getLocalizedLabels("addtodictionary"), this._getLocalizedLabels("ignoreall")].concat(spellcheck._suggestedWords);   
                for (var k = 0; k < suggestionList.length; k++) {
                    proxy.insertMenuOption({
                    newItem: suggestionList[k],
                    targetItem: this._getLocalizedLabels("paste"),
                    insertType: ("insertAfter"),
                    menuType: { text: true, image: false, hyperlink: true, table: false },
                    spriteCssClass: "e-spellsuggestions"  
                });   
            } 
        },
        _showHideContextMenu: function () {
            if (this.model.allowEditing && this.model.enabled && this.model.showContextMenu && this._getDocument()) {
                this._textMenuObj = this._createContextMenu().data("ejMenu");
                //below codes unbinds the contextMenu taphold event.
                this._textMenuObj["_off"]($(this._textMenuObj.model.contextMenuTarget), "mouseup taphold", this._textMenuObj._ContextMenuHandler);
                this._textMenuObj["_on"]($(this._textMenuObj.model.contextMenuTarget), "mouseup", this._textMenuObj._ContextMenuHandler);
            }
            else
                (this._textMenuObj) && this._textMenuObj.destroy();
        },
        _checkNameAttr: function () {
            if (this.model.name)
                this.element.attr({ "name": this.model.name });
            else if (ej.isNullOrUndefined(this.element.attr("name")))
                this.element.attr({ "name": this.element[0].id });
        },
        _enableEdit: function (args) {
            this.model.allowEditing = args;
            if (args) {
                this._wireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", this._toolBarClick);
                this._rteIframe.contents().find("body").attr("contenteditable", true);
            }
            else {
                this._unwireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", null);
                this._rteIframe.contents().find("body").attr("contenteditable", false);
            }
            this._showHideContextMenu();
            this._disableResizeObj(args);
        },
        _disableResizeObj: function (value) {
            if (!value) {
                if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
                this._off($(this._getDocument()), "mouseover", 'table', this._tableMouseOver)
                this._removeResizeObject();
            }
        },
        _changeSkin: function (value) {
            this._rteWapper.removeClass(this.model.cssClass).addClass(value);
            this._subControlsSetModel("cssClass", value);
        },

        _updateIframeSkin: function (htmlAttr) {
            try {
                var target = this._rteIframe.contents().find("body");
                if (htmlAttr) {
                    proxy = this;
                    $.map(htmlAttr, function (value, key) {
                        if (key == "class") target.addClass(value);
                        else if (key == "required") target.attr(key, value);
                        else if (key == "disabled" && value == "disabled") proxy.disable();
                        else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                        else target.attr(key, value);
                    });
                }
            }
            catch (err) {
                return false;
            }
        },


        _renderWrapper: function () {
            if (this.model.minHeight.toString().indexOf("%") > 0)
                this.model.minHeight = (parseInt(this.model.height) * parseInt(this.model.minHeight)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxHeight) && (this.model.maxHeight.toString().indexOf("%") > 0))
                this.model.maxHeight = parseInt(this.model.height) + (parseInt(this.model.height) * parseInt(this.model.maxHeight)) / 100;
            if (this.model.minWidth.toString().indexOf("%") > 0)
                this.model.minWidth = (parseInt(this.model.width) * parseInt(this.model.minWidth)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxWidth) && (this.model.maxWidth.toString().indexOf("%") > 0))
                this.model.maxWidth = parseInt(this.model.width) + (parseInt(this.model.width) * parseInt(this.model.maxWidth)) / 100;
            this._rteWapper = ej.buildTag("div.e-rte e-rte-wrapper e-widget e-box " + this.model.cssClass + "#" + this._rteId + "_wrapper", "", {}, { role: "presentation" }).insertBefore(this.element);
            this._rteWapper.css("height", this.model.height).css("width", this.model.width).css("min-height", this.model.minHeight).css("min-width", this.model.minWidth).css("max-height", this.model.maxHeight).css("max-width", this.model.maxWidth);
            this._rteWapper.append(this.element.hide());
            return this;
        },

        _renderToolBar: function () {
            this._rteToolbar = ej.buildTag("div.e-rte-toolbar #" + this._rteId + "_tools").insertAfter(this.element);
            this._crateToolbarTemplate()
            ._initToolBarItems()
            ._renderToolBarList();
            this._renderToolBarItems();
            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._toolBarObj.disableItemByID(this._rteId + "_" + "video");
        },
        _renderToolBarList: function () {
            var model = {};
            model.click = this.model.allowEditing ? this._toolBarClick : null;
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeparator = true;
			if(this.model.toolbarOverflowMode=="inline")
			model.responsiveType="inline";
            model.isResponsive = this.model.isResponsive;
            model.height = model.isResponsive ? "" : "auto";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.tooltipSettings = this.model.tooltipSettings;
            model.create = function () {
                var ddl = $(this.element).find(".e-ddl.e-widget .e-dropdownlist"), spbtn = $(this.element).find(".e-split.e-widget .e-splitbutton");
                ddl.length && ddl.ejDropDownList({ height: "30px" });
                spbtn.length && spbtn.ejSplitButton({ height: '30px' });
            }
            this._toolBarItems.ejToolbar(model);
            this._disableTabkeyNavigation(this._toolBarItems)._disableTabkeyNavigation(this._toolBarItems.find("[tabindex],.e-split-btn"));
            this._toolBarObj = this._toolBarItems.ejToolbar("instance");
             if(this.model.toolbarOverflowMode=="inline"){
            this._rteinline = this._toolBarObj._spantag;
            this._on(this._rteinline, "click", this._rteinlineClick);
             }
            this._on($(document), "mouseup touchend", this._zoomUp);
            this._on($(this._toolBarObj.itemsContainer).find(".e-rteItem-zoomIn , .e-rteItem-zoomOut"), "mousedown touchstart", this._zoomDown);
        },
        _disableTabkeyNavigation: function (elements) {
            $(elements).attr("tabindex", '-1');
            return this;
        },
        _crateToolbarTemplate: function () {
            this._toolBarItems = ej.buildTag("div#" + this._rteId + "_toolbar").appendTo(this._rteToolbar).height(30);
            for (var items in this._toolsList) {
                items = this._toolsList[items];
                if (!ej.isNullOrUndefined(this.model.tools[items])) {
                    if (items == "customTools")
                        !ej.isNullOrUndefined(this.model.tools[items]) && this._customTools(this.model.tools[items]);
                    else
                        this.model.tools[items].length > 0 && this._createToolsItems(this.model.tools[items], items);
                }
            }
            if (this.model.fileBrowser.filePath != "") {
                var ulTag = ej.buildTag("ul#" + this._rteId + "-file-exporer"), liTag;
                liTag = $("<li id='" + this._rteId + "_fileBrowser" + "' class='e-rte-explorer e-rteItem-fileBrowser' title='" + this._getLocalizedLabels("fileBrowser") + "' ><div class='e-rte-toolbar-icon fileBrowser e-fileBrowser' unselectable = 'on'></div></li>");
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
            return this;
        },

        _createToolsItems: function (items, itemName) {
            var ulTag = ej.buildTag("ul#" + (this._rteId + "_" + itemName)), liTag;
            (itemName == "font") && ulTag.addClass("e-rte-fontgroup");
            (itemName == "formatStyle") && ulTag.addClass("e-rte-format");
            (itemName == "lists") && ulTag.addClass("e-rte-lists");
            for (var i = 0; i < items.length; i++) {
                liTag = $("<li id='" + (this._rteId + "_" + items[i].replace(/ /g, '')) + "' class='e-rteItem-" + items[i] + "' ><div class='e-rte-toolbar-icon " + items[i] + " " + this._rteIconsList[items[i]] + "' unselectable = 'on'></div></li>");
                if (items[i] === "video" && ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") liTag.attr('title', this._getLocalizedLabels("html5Support"));
                else liTag.attr('title', this._getLocalizedLabels(items[i].replace(/ /g, '')));
                if (items[i] === "fullScreen") liTag.attr('data-content', this._getLocalizedLabels("maximize")).children(".e-rte-toolbar-icon").addClass(this._rteIconsList["maximize"]);
                else if (items[i] === "findAndReplace")
                    liTag.attr('title', this._getLocalizedLabels("FindAndReplace"));
                liTag.appendTo(ulTag);
            }
            ulTag.appendTo(this._toolBarItems);
            if (itemName == "font" && !this.model.showFontOption)
                ulTag.hide();
        },

        _customTools: function (toolbarItems) {
            for (var item = 0; item < toolbarItems.length; item++) {
                var ulTag = ej.buildTag("ul"), liTag;
                liTag = $("<li id='" + toolbarItems[item].name + "' title='" + toolbarItems[item].tooltip + "' ><div class='" + (ej.isNullOrUndefined(toolbarItems[item].css) ? "" : toolbarItems[item].css) + "'>" + (ej.isNullOrUndefined(toolbarItems[item].text) ? "" : toolbarItems[item].text) + "</div></li>");
                var fn = toolbarItems[item].action;
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }
                !ej.isNullOrUndefined(toolbarItems[item].action) && this._on(liTag, "click", fn);
                $(toolbarItems[item].template).appendTo(liTag.find("div"));
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
        },

        _initToolBarItems: function () {
            this._rteToolbar.find("li.e-rteItem-format").length > 0 && this._renderFormat(); 
            this._rteToolbar.find("li.e-rteItem-createTable").length > 0 && this._renderTableDialog();
            this._rteToolbar.find("li.e-rteItem-fontName").length > 0 && this._renderFontStyle();
            this._rteToolbar.find("li.e-rteItem-fontSize").length > 0 && this._renderFontSize();
            this._rteToolbar.find("li.e-rteItem-fontColor").length > 0 && this._renderFontColor();
            this._rteToolbar.find("li.e-rteItem-backgroundColor").length > 0 && this._renderBGColor();   
            this._rteToolbar.find("li.e-rteItem-unorderedList").length > 0 && this._renderUnOrderList();
            this._rteToolbar.find("li.e-rteItem-orderedList").length > 0 && this._renderOrderList();
            this._rteToolbar.find("li.e-rteItem-import").length > 0 && this._renderimport();
            !this.model.showClearAll && this._rteToolbar.find("li.e-rteItem-clearAll").hide();
            return this;
        },
        _renderToolBarItems: function () {
            this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
            this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
            // Default action when render the RTE
            if (!this.model.enableRTL)
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
            else
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyRight");
            //Hide the editable table icons
            var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
            if (this.model.isResponsive && items.length == 0) this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            else this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            return this;
        },

        _renderEditArea: function () {
            this._rteEditor = ej.buildTag("div.editarea #" + this._rteId + "_editor").appendTo(this._rteWapper);
            this._rteIframe = ej.buildTag("iframe.content-iframe #" + this._rteId + "_Iframe", "", {}).appendTo(this._rteEditor);
            this._rteIframe.css({ "border": "0" });
			this._setIFrames();
            if (navigator.userAgent.match(/(iPhone|iPod|iPad)/i) != null){
                this._rteEditor.addClass('e-ipadscroll');
				this._rteEditor.css("height", (this._rteWapper.outerHeight()- (this.model.showToolbar?this._rteToolbar.height():0)));
            }
        },

        _xhtmlTagValidation: function () {
            if (this.value() != null) {
                var htmlText = this.value();
                htmlText = htmlText.replace(/\r/gi, " ").replace(/\n/gi, "<br/> ").replace(/\r\n/gi, " ").replace(/( )+/gi, " ").replace(/&nbsp;/gi, " ").replace(/&bull;/gi, "*").replace(/&ltquo;/gi, "<").replace(/&rtquo;/gi, ">").replace(/&trze;/gi, "(tm)").replace(/&copy;/gi, "(c)").replace(/&reg;/gi, "(r)");
                if (htmlText.indexOf("<body>") != -1) {
                    var indexBody = htmlText.indexOf("<body>");
                    var delBody = htmlText.slice(0, indexBody + 6);
                    htmlText = htmlText.replace(delBody, "").replace("</body></html>", "");
                }
                htmlText = htmlText.replace(/<br>/g, "<br/>").replace(/<hr>/g, "<hr/>");
                htmlText = this._imageXhtml(htmlText);
                htmlText = this._styleXhtml(htmlText);
                htmlText = this._startXhtml(htmlText);
                if (htmlText.indexOf("alt=") != -1) {
                    var imageTag = /alt=\"(.*?)\"/ig;
                    var altTemp = new Array();
                    var tempAlt;
                    var j = 0;
                    while ((tempAlt = imageTag.exec(htmlText)) != null) {
                        altTemp[j] = tempAlt[0];
                        j++;
                    }
                    for (var i = 0; i < altTemp.length; i++) {
                        htmlText = htmlText.replace(altTemp[i], "alt=\"\"");
                    }
                }
                if (!ej.isNullOrUndefined(this._fontXhtml(htmlText))) {
                    htmlText = this._fontXhtml(htmlText);
                    if (htmlText.indexOf("ol") != -1) {
                        var olStyle = /<ol(.*)<\/ol>/ig;
                        var tempOl;
                        var k = 0;
                        var olTemp = new Array();
                        while ((tempOl = olStyle.exec(htmlText)) !== null) {
                            olTemp[k] = tempOl[0].toString();
                            k++;
                        }
                        var olEx = new Array();
                        for (var f = 0; f < olTemp.length; f++) {
                            olEx[f] = olTemp[f];
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            olTemp[i] = olTemp[i].replace(/<br\/>/gi, "");
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            htmlText = htmlText.replace(olEx[i], olTemp[i]);
                        }
                    }
                    htmlText = htmlText.replace(/<o:p>/gi, "").replace(/<\/o:p>/gi, "");
                }
                this.value(htmlText);
            }
        },

        _setIFrames: function () {
            var rteContent = null;
            if ((this.value() != null && this.value() != "")) rteContent = this.value().replace(/'/g, "\"");
            if (rteContent == null) this.value($.trim(this.element[0].value));
            var isIE8 = ej.browserInfo().name == 'msie' && parseInt(ej.browserInfo().version) == 8;
            var _htmlText = ("<!DOCTYPE html> <html> <head> <meta charset='utf-8' /> <style>html, body{height: 100%;margin: 0;}body.e-cursor{cursor:default} span.e-selected-node	{background-color: #939393;color: white;}span.e-selected-node.e-highlight{background-color: #1d9dd8;}body{font-family:Times New Roman,Times,serif;color:#5C5C5C;word-wrap:break-word;padding: 8px;box-sizing: border-box;}.e-rte-table caption{border: 1px solid;border-bottom:none}td{word-wrap:break-word;word-break:break-all;}.e-rteColumnResizer{position: absolute;bottom:0;overflow: visible;cursor: col-resize;background-repeat:repeat;background-color:transparent}.e-rteRowResizer{position: absolute;bottom:0;overflow: visible;margin-left: -4px;cursor: row-resize;background-repeat:repeat;background-color:transparent} span.e-rte-imageboxmark{width:5px;height:5px;position:absolute;display:block;background:#fff;border:1px solid #000;}</style></head><body spellcheck='false' autocorrect='off' contenteditable=" + (this.model.allowEditing ? 'true' : 'false') + ">" + ((this.value() != "" && this.value() != "<br>" ) ? $.trim(this.value()) : "<p><br/></p>" ) + "</body></html>");
            this._rteIframe.css({ "width": "100%" });
            if (this.element[0].value == "<div></div>" || this.element[0].value == "")
                this.element[0].innerHTML = this.value();

            this._setContent(_htmlText);
            if (this._isIE8()) this.value(this._getDocument().body.innerHTML);
            if (this.model.enableXHTML) this._updateValue();
            this._setAutoHeight();
        },


        _setIframeHeight: function () {
            var _height = (!ej.isNullOrUndefined(this._rteToolbar) && this._rteToolbar.is(':visible') ? this._rteToolbar.outerHeight() : 6) + (!ej.isNullOrUndefined(this._rteFooter) && this._rteFooter.is(':visible') ? this._rteFooter.outerHeight() : 0);
            this._rteIframe.css("height", (_height == 0 ? this.model.height : ((this._rteWapper.outerHeight() - _height) - (parseInt(this._rteEditor.css("padding-top")) + parseInt($(".e-rte-wrapper").css("border-bottom-width")) + parseInt(this.model.showFooter ? $(".e-rte-footer").css("margin-top") : 0)))));
        },

        // Footer Div render 
        _renderFooter: function () {
            var options = this.model;
            this._rteFooter = ej.buildTag("div.e-rte-footer #" + this._rteId + "_footer").appendTo(this._rteWapper);
            var _leftPan = ej.buildTag("div.e-rte-footer-left");
            this._htmlSource = ej.buildTag("div.e-rte-icons e-rte-footeritems e-rte-footericon e-rte-source " + this._rteIconsList["rteSource"], "", {}, { title: this._getLocalizedLabels("viewHtml") }).appendTo(_leftPan);
            this._htmlInfo = ej.buildTag("div.e-rte-htmltaginfo e-rte-footeritems").appendTo(_leftPan);
            _leftPan.appendTo(this._rteFooter);
            var _rightPan = ej.buildTag("div.e-rte-footer-right");
            this._wordCount = ej.buildTag("div.e-rte-wordcount e-rte-footeritems").appendTo(_rightPan);
            this._charCount = ej.buildTag("div.e-rte-charcount e-rte-footeritems").appendTo(_rightPan);
            this._clearFormat = ej.buildTag("div.e-rte-icons " + this._rteIconsList["clearFormat"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearFormat"), "unselectable": "on" }).appendTo(_rightPan);
            this._clearAll = ej.buildTag("div.e-rte-icons clearAll " + this._rteIconsList["clearAll"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearAll") }).appendTo(_rightPan);
            this._resize = ej.buildTag("div.e-icons e-rte-resize " + this._rteIconsList["rteResize"] + " e-rte-footeritems").appendTo(_rightPan);
            _rightPan.appendTo(this._rteFooter);
            this._footerEvents("_on");
            !this.model.showHtmlSource && this._htmlSource.hide().removeClass("e-rte-footeritems");
            !this.model.showHtmlTagInfo && this._htmlInfo.hide().removeClass("e-rte-footeritems");
            !this.model.showWordCount && this._wordCount.hide().removeClass("e-rte-footeritems");
            !this.model.showCharCount && this._charCount.hide().removeClass("e-rte-footeritems");
            !this.model.showClearAll && this._clearAll.hide().removeClass("e-rte-footeritems");
            !this.model.showClearFormat && this._clearFormat.hide().removeClass("e-rte-footeritems");
            //if (options.showFooter && this.model.enableRTL) this._rteFooter.addClass("e-rtl");
            if (options.enableResize)
                this._enableResize();
            else
                this._resize.hide().removeClass("e-rte-footeritems");
            this._updateCount();
            if (this.model.showWordCount) this._on(this._wordCount, "click", this._wordCharClick);
            if (this.model.showCharCount) this._on(this._charCount, "click", this._wordCharClick);
            this._renderTooltip(this.model.tooltipSettings);

        },
        _renderTooltip: function (options) {
            var model = $.extend(true, {}, options);
            if (!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
                model.cssClass = model.cssClass + " e-rteTooltip " + this.model.cssClass;
            else
                model.cssClass = "e-rteTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.target = ".e-rte-icons";
            if (this.model.showFooter)
                this._tooltip = $(this._rteFooter).ejTooltip(model).data("ejTooltip");
        },
        _hideTooltip: function () {
            if (!ej.isNullOrUndefined(this._tooltip))
                this._tooltip.hide();
        },
        _footerElement: function (selector, visible) {
            if (this.model.showFooter) {
                var ele = this._rteFooter.find(selector);
                visible ? ele.show().addClass("e-rte-footeritems") : ele.hide().addClass("e-rte-footeritems");
            }
        },
        _wordCharClick: function (e) {
            this._alertWindow.ejDialog("option", { "showHeader": true, "title": "<span style='padding-left:0.4em;'>" + this._getLocalizedLabels("wordCount") + "</span>" });
            this.model.enableRTL && this._alertWindow.find(".e-alert-ok").removeClass("e-rte-alertBtnRTL");
            this._alertWindow.find(".e-rte-button").removeClass("e-fieldseparate").css({ "text-align": "center", "padding-bottom": "1em", "padding-top": "0.5em" });
            this._alertWindow.ejDialog("instance").refresh();
            this._openAlert("<div style='padding-left:0.3em;padding-right:0.3em;'><div style='" + ((this.model.enableRTL) ? 'float:right' : 'float:left') + "'>" + this._getLocalizedLabels("words") + "<p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charSpace") + "</p><p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charNoSpace") + "</p></div><div style='" + ((this.model.enableRTL) ? 'float:left;padding-right:2em;' : 'float:right;padding-left:2em;') + "'>"
			+ ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0) + "<p style='margin:0.875em 0em;'>" + this._getText().length + "</p><p style='margin:0.875em 0em;'>" + this._getText().replace(/\s/g, "").length + "</p></div></div><br/>");
        },
        _updateColorPalette: function () {
            var _fontColor = $("ul#" + this._rteId + "_colorTable");
            var _bgColor = $("ul#" + this._rteId + "_colorBGTable");
            _fontColor.find("div.e-rte-table").remove();
            _fontColor.find("li").append(this._colorTable());
            //Bg Color table Update
            _bgColor.find("div.e-rte-table").remove();
            _bgColor.find("li").append(this._colorTable());
        },
        _enableRTL: function (value) {
            try {
                if (value)
                    this._rteIframe.contents().find("body").css("direction", "rtl");
                else
                    this._rteIframe.contents().find("body").css("direction", "ltr");
            }
            catch (error) { }
            this._subControlsSetModel("enableRTL", value);
            //if (this.model.showFooter && this._rteFooter) this._rteFooter.addClass("e-rtl");
        },
        _roundedCorner: function (value) {
            if (value) this._rteWapper.toggleClass('e-corner-all');
            this._subControlsSetModel("showRoundedCorner", value);
        },
        _subControlsSetModel: function (prop, value) {
            if (!ej.isNullOrUndefined(this._tooltip)) {
                if (prop == "cssClass")
                    $(this._rteFooter).ejTooltip("option", prop, "e-rteTooltip " + value);
                else
                    $(this._rteFooter).ejTooltip("option", prop, value);
            }
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("option", prop, value);
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("option", prop, value);
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-top"))
                    this._toolBarItems.removeClass("e-corner-top").addClass("e-corner-all");
                this._toolBarItems.ejToolbar("option", prop, value);
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-all"))
                    this._toolBarItems.removeClass("e-corner-all").addClass("e-corner-top");
            }
            if (!ej.isNullOrUndefined(this._linkDialog)) {
                this._linkDialog.ejDialog("option", prop, value);
                this._linkDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._linkDialog.find(".e-inputtext").addClass('e-corner-all') : this._linkDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.ejDialog("option", prop, value);
                this._imgDialog.find("div.e-rte-imageTab").ejTab("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("option", prop, value);
                this._chkImgDimensions.ejCheckBox("option", prop, value);
                this._dialogchkTarget.ejCheckBox("option", prop, value);
                this._imgDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._imgDialog.find(".e-inputtext").addClass('e-corner-all') : this._imgDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._videoDialog)) {
                this._videoDialog.ejDialog("option", prop, value);
                this._videoDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkvideoDimensions.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._videoDialog.find(".e-inputtext").addClass('e-corner-all') : this._videoDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("option", prop, value);
            if (!ej.isNullOrUndefined(this._sourceDialog)) {
                this._sourceDialog.ejDialog("option", prop, value);
                this._sourceDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._sourceDialog.find(".e-inputtext").addClass('e-corner-all') : this._sourceDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._alertWindow)) {
                this._alertWindow.ejDialog("option", prop, value);
                this._alertWindow.find(".e-rte-btn").ejButton("option", prop, value);
            }
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                this._customTableDialog.ejDialog("option", prop, value);
                this._customTableDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._customTableDialog.find(".numerictextbox").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("option", prop, value);
                this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("option", prop, value);
                this._chkTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._customTableDialog.find(".e-inputtext").addClass('e-corner-all') : this._customTableDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.ejDialog("option", prop, value);
                this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox("option", prop, value);
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("option", prop, value);
                this._getTableObj("_Tab").ejTab("option", prop, value);
                this._eTblDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._eTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._eTblDialog.find(".e-inputtext").addClass('e-corner-all') : this._eTblDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._fileDialog)) {
                this._fileDialog.ejDialog("option", prop, value);
                this._fileDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkFileTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._fileDialog.find(".e-inputtext").addClass('e-corner-all') : this._fileDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._explorerObj))
                this._explorerObj.option(prop, value);
            if (!ej.isNullOrUndefined(this._fileBrowserObj))
                this._fileBrowserObj.option(prop, value);
        },
        _createCountElement: function (option, element) {
            option ? element.show() : element.hide();
            element.toggleClass("e-rte-footeritems");
        },

        _enableResize: function () {
            if (this.model.enableResize && this.model.enabled) {
                this._rteWapper.addClass("e-resizable");
                this._resizeRTE();
            }
        },

        _resizeRTE: function () {
            var proxy = this;
            this._overlayElement = ej.buildTag('div.e-rte-overlay');
            this._rteEditor.css("position", "relative");
            this._rteWapper.find("div.e-rte-resize").ejResizable(
                {
                    minHeight: parseInt(proxy.model.minHeight),
                    minWidth: parseInt(proxy.model.minWidth),
                    maxHeight: parseInt(proxy.model.maxHeight),
                    maxWidth: parseInt(proxy.model.maxWidth),
                    resizeStart: function (event) {
                        proxy._rteEditor.append(proxy._overlayElement);
                        proxy._trigger("resizeStart", { event: event });
                    },
                    resize: function (event) {
					    proxy._updateCount();
                        proxy._resizeHeight(event.element);
                        proxy._trigger("resize", { event: event });
                        if (proxy.model.isResponsive && proxy.model.showToolbar) proxy._toolBarObj._reSizeHandler();
                    },
                    resizeStop: function (event) {
                        proxy._overlayElement.remove();
                        proxy._trigger("resizeStop", { event: event });
                    },
                    helper: function (event) {
                        proxy._resizeHeight(event.element);
                        return $(proxy._rteWapper);
                    }
                });
        },
        _getDocumentHandler: function () {
            (!this._operationHandler) && (this._operationHandler = new ej.editorManager(this.getDocument(), this._getWindow()));
            return this._operationHandler;
        },
        _resizeHeight: function (element) {
            var reElement = element.parents("div.e-rte-wrapper");
            this._rteWidth = reElement.width();
            this._rteHeight = reElement.height();
            this._rteWapper.height(this._rteHeight);
            this._rteWapper.width(this._rteWidth);
            this._setIframeHeight();
        },

        _getDialogModel: function () {
            var dialogModel;
            var rtecontent = this._rteWapper;
            return dialogModel = {
                enableResize: false,
                showOnInit: false,
                enableModal: true,
                cssClass: this.model.cssClass,
                target: rtecontent,
				isResponsive:true,
                enableRTL: this.model.enableRTL
            };
        },
        _labelFor: function (val) {
            return this._rteId ? " for=" + this._rteId + val + " " : "";
        },
        _TagId: function (val) {
            return this._rteId ? " id=" + this._rteId + val + " " : "";
        },
        _renderLinkDialog: function () {
            var proxy = this;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var createLink = this._linkDialog = ej.buildTag("div#" + this._rteId + "_link");
            var content = $("<div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_link_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-linkUrl' " + this._TagId("_link_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkText' " + this._TagId("_link_text") + "></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_title") + ">" + this._getLocalizedLabels("linkTooltipLabel") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkTitle' " + this._TagId("_link_title") + "></div><div class='e-rte-label " + btnDiv + "'></div>" +
                           "<div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-linkTarget'  data-role ='none' " + this._TagId("_link_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='link_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='link_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(createLink);
            createLink.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.minWidth="340px";
			model.width="auto";
            model.title = this._getLocalizedLabels("createLink");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            createLink.ejDialog(model);
            createLink.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && createLink.find(".e-inputtext").addClass('e-corner-all');
            this._chkTarget = createLink.find(".e-rte-linkTarget");
            this._chkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            createLink.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(createLink.find(".e-rte-btn"), "click", this._linkBtnClick)
            ._on(this._linkDialog.find(".e-rte-linkUrl"), "keypress", this._urlValidation);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },


        _renderImageDialog: function () {
            var proxy = this, pathData = "";
            this._imgDialog = ej.buildTag("div#" + this._rteId + "_Image");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = "<div " + this._TagId("_img_Tab") + " class='e-rte-imageTab'><ul><li class='e-first'><a href='#" + this._rteId + "_general'>" + this._getLocalizedLabels("general") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_advanced'>" + this._getLocalizedLabels("advanced") + " </a></li></ul>" +
                "<div id='" + this._rteId + "_general'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_url") + ">" + this._getLocalizedLabels("imageWebUrl") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgUrl' " + this._TagId("_img_url") + "></div></div><div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'>" +
                         "<label " + this._labelFor("_img_text") + ">" + this._getLocalizedLabels("imageAltText") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none'  class='e-inputtext e-rte-imgText' " + this._TagId("_img_text") + "></div></div>" +
                        "<div class='e-rte-imgdimensions' " + this._TagId("_imgdimensions") + "><div class='e-rte-label " + btnDiv + "'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "'  data-role ='none' class='e-inputtext e-dimensions e-rte-imgX' maxlength='3' " + this._TagId("_imgX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-imgY' maxlength='3' " + this._TagId("_imgY") + "></div>" +
                 "<input type='checkbox' class='e-rte-imgConsrn' data-role ='none'" + this._TagId("_img_consrn") + "<label " + this._labelFor("_img_consrn") + "  style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div>" +
                "</div>" +
                "<div id='" + this._rteId + "_advanced'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_link") + ">" + this._getLocalizedLabels("imageLink") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgLink' " + this._TagId("_img_link") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_border_px") + ">" + this._getLocalizedLabels("imageBorder") + "</label></div><div class='e-rte-field " + btnDiv + "'><div class='e-img-border-field'><input type='text' data-role ='none' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-rte-imgBorderPx' maxlength='3' " + this._TagId("_img_border_px") + "></div><div class='e-img-border-field'><select class='e-rte-imgBorderStyle'  data-role ='none' " + this._TagId("_img_border_style") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-inputtext e-rte-imgBorderColor' " + this._TagId("_img_border_color") + "></div></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_style") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  class='e-inputtext e-rte-imgStyle' " + this._TagId("_img_style") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'></div><div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-imgLinkTarget' data-role ='none' " + this._TagId("_img_link_target") + "><label " + this._labelFor("_img_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div></div>" +
                "</div>" +

                "</div>" +
                "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none'  type='button' id='" + this._rteId + "_img_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_img_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            if (this.model.imageBrowser.filePath != "")
                pathData = "<div " + this._TagId("_img_explorer") + " class='e-rte-explorer e-rte-imgBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._imgDialog);
            this._imgDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find("div.e-rte-imgdimensions").hide();
            var model = this._getDialogModel();
			this.model.imageBrowser.filePath=="" ? model.maxWidth="470px" : model.maxWidth="720px";
            model.width ="auto";
		    model.title = this._getLocalizedLabels("image");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._explorerObj && proxy._explorerObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", false);
            };
            this._imgDialog.ejDialog(model);
            this._imgDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            if (this.model.imageBrowser.filePath != "") {
                var ajaxSettings = { upload: { url: this.model.imageBrowser.uploadAction } };
                if (this.model.imageBrowser.ajaxSettings)
                    $.extend(true, ajaxSettings, this.model.imageBrowser.ajaxSettings);

                this._explorerObj = this._imgDialog.find("div.e-rte-imgBrowser").ejFileExplorer({
                    allowMultiSelection: false, showFooter: false, showTreeview: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth: "690px", isResponsive:true,minWidth:"330px",height: "300px", path: this.model.imageBrowser.filePath, fileTypes: this.model.imageBrowser.extensionAllow, layout: ej.FileExplorer.layoutType.LargeIcons, select: function (e) { proxy._UpdateImgDetails(e); },
                    tools: {
                        creation: ["NewFolder", "Open"],
                        navigation: ["Back", "Forward"],
                        addressBar: ["Addressbar"],
                        editing: ["Refresh", "Upload", "Delete"],
                        searchBar: ["Searchbar"]
                    }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                    ajaxAction: this.model.imageBrowser.ajaxAction, locale: this.model.locale,
                    ajaxSettings: ajaxSettings
                }).data('ejFileExplorer');
                this._imgSplitObj = this._imgDialog.find(".e-splitter").data("ejSplitter");
                this._imgSplitObj.option("enableAutoResize", false);
            }
            this.model.showRoundedCorner && this._imgDialog.find(".e-inputtext").addClass('e-corner-all');
            this._imgDialog.find("div.e-rte-imageTab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkImgDimensions = this._imgDialog.find(".e-rte-imgConsrn");
            this._chkImgDimensions.ejCheckBox({ check: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgPicker = this._imgDialog.find(".e-rte-imgBorderColor").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._imgDialog.parents("#" + this._rteId + "_Image_wrapper").css({ "visibility": "visible", "display": "none" });
            this._dialogchkTarget = this._imgDialog.find(".e-rte-imgLinkTarget");
            this._dialogchkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._imgDialog.find(".e-rte-btn"), "click", this._imageBtnClick)
            this._on(this._imgDialog.find(".e-rte-imgUrl , .e-rte-imgLink"), "keypress", this._urlValidation);
            this._on(this._imgDialog.find("input.e-dimensions"), "change", this._recalcImgSize);
            this.model.showRoundedCorner && this._subControlsSetModel();    
        },
        _renderFileBrowserDialog: function () {
            var proxy = this, pathData = "";
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._fileDialog = ej.buildTag("div#" + this._rteId + "_fileDialog");
            var content = "<div class='e-rte-elements'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_file_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-fileUrl' " + this._TagId("_file_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_file_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-fileText' " + this._TagId("_file_text") + "></div> </div>" +
                           "<div class='e-rte-field'><input type='checkbox' class='e-rte-fileTarget'  data-role ='none' " + this._TagId("_file_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_file_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='" + this._rteId + "_file_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            pathData = "<div " + this._TagId("_file_explorer") + " class='e-rte-explorer e-rte-fileBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._fileDialog);
            this._fileDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.width="auto";
            model.title = this._getLocalizedLabels("fileBrowser");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._fileBrowserObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", false);
            };
            this._fileDialog.ejDialog(model);
            this._fileDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            var ajaxSettings = { upload: { url: this.model.fileBrowser.uploadAction } };
            if (this.model.fileBrowser.ajaxSettings)
                $.extend(true, ajaxSettings, this.model.fileBrowser.ajaxSettings);

            this._fileBrowserObj = this._fileDialog.find("div.e-rte-fileBrowser").ejFileExplorer({
                allowMultiSelection: false, showFooter: false, showTreeview: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth:"690px", height: "300px",isResponsive:true,minWidth:"330px", path: this.model.fileBrowser.filePath, fileTypes: this.model.fileBrowser.extensionAllow, layout: "list", select: function (e) { proxy._UpdateFileDetails(e); },
                tools: {
                    creation: ["NewFolder", "Open"],
                    navigation: ["Back", "Forward"],
                    addressBar: ["Addressbar"],
                    editing: ["Refresh", "Upload", "Delete"],
                    searchBar: ["Searchbar"]
                }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                ajaxAction: this.model.fileBrowser.ajaxAction, locale: this.model.locale,
                ajaxSettings: ajaxSettings
            }).data('ejFileExplorer');
            this._fileSplitObj = this._fileDialog.find(".e-splitter").data("ejSplitter");
            this._fileSplitObj.option("enableAutoResize", false);
            this.model.showRoundedCorner && this._fileDialog.find(".e-inputtext").addClass('e-corner-all');
            this._fileDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._fileDialog.parents("#" + this._rteId + "_fileDialog_wrapper").css({ "visibility": "visible", "display": "none" });
            this._chkFileTarget = content.find(".e-rte-fileTarget");
            this._chkFileTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._fileDialog.find(".e-rte-btn"), "click", this._fileBtnClick);
            this.model.showRoundedCorner && this._subControlsSetModel(); 
        },
        _UpdateImgDetails: function (e) {
            if ($(this._imgURL).hasClass('e-error')) this._imgURL.removeClass("e-error");
            if (e.path === "") this._imgURL.val("http://");
            else this._imgDialog.find("div.e-rte-imageTab").find('.e-rte-imgUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _UpdateFileDetails: function (e) {
            if ($(this._fileURL).hasClass('e-error')) this._fileURL.removeClass("e-error");
            if (e.path === "") this._fileURL.val("http://");
            else this._fileDialog.find('.e-rte-fileUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _fileBtnClick: function (sender) {
            this._renderLinkDialog();
            if (sender.target.id === this._rteId + "_file_cancel") {
                this._clearFileFields();
                this._fileDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_file_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._fileDialog.find('e-rte-fileUrl').val() != "")
                    this._onInsertFileLink();
                else this._linkDialog.ejDialog("close");
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },
        _clearFileFields: function () {
            this._fileURL = this._fileDialog.find(".e-rte-fileUrl");
            this._fileURL.val("http://");
            this._fileLinkText = this._fileDialog.find(".e-rte-fileText");
            this._fileLinkText.val("");
            this._chkFileTarget.ejCheckBox({ check: false });
        },
        _onGetInsertFileContent: function (Url) {
            if (this._fileLinkText.val() === "") this._selectedHTML = Url;
            else this._selectedHTML = this._fileLinkText.val();
        },
        _onInsertFileLink: function () {
            var oEl, sHtml;
            var fileVal = this._fileURL.val().match(/(ftp:|http:|https:)\/\//g);
            var fsrcUrl = (this._fileURL.val().startsWith("~")) ? this._fileURL.val().replace(this._fileURL.val().substr('0', '1'), "..") : this._fileURL.val();
            if ((ej.isNullOrUndefined(fileVal) && fsrcUrl !== "") || (!ej.isNullOrUndefined(fileVal) && fileVal[0].length < fsrcUrl.length)) {
                var selectedNode = ((this._isIE()) && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
                if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                    selectedNode.href = fsrcUrl;
                    selectedNode.innerHTML = this._fileLinkText.val();
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "_self";
                }
                else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                    var parentNode = $(selectedNode).parent('a')[0];
                    if (ej.isNullOrUndefined(parentNode)) {
                        oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                        $(selectedNode.outerHTML).appendTo($(oEl));
                        $(selectedNode).replaceWith($(oEl));
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    } else {
                        parentNode.href = fsrcUrl;
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "_self";
                    }
                }
                else {
                    oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    var oSelection;
                    var oSelRange;
                    this._focus();
                    if (this._isIE()) {
                        if (!ej.isNullOrUndefined(this._selectedHTML)) {
                            if (this._selectedHTML.length == 0)
                                this._onGetInsertFileContent(fsrcUrl);
                        }
                        else
                            this._onGetInsertFileContent(fsrcUrl);
                        oEl[0].innerHTML = this._selectedHTML;
                        sHtml = oEl[0].outerHTML;
                    }
                    else {
                        if (this._fileLinkText.val() === "")
                            oEl.html(fsrcUrl);
                        else oEl.html(this._fileLinkText.val());
                        sHtml = $('<div>').append($(oEl).clone()).html();
                    }
                    if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                        this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                        this._focus();
                    }
                }
                this._fileDialog.ejDialog("close");
            } else {
                this._fileURL.addClass("e-error");
                return false;
            }
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },
        //Render the Table selection rows and columans popup
        _renderVideoDialog: function () {
            var proxy = this;
            this._videoDialog = ej.buildTag("div#" + this._rteId + "_video");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div><label>" + this._getLocalizedLabels("embedVideo") + "</label></div><textarea class='e-rte-video e-inputtext'  aria-label=" + this._getLocalizedLabels("embedVideo") + "></textarea>" +
               "<div class='e-rte-videoDimensions'" + this._TagId("_videodimensions") + " style='margin-top:7px'><div class='e-rte-label'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div><input type='text'  data-role ='none' title='" + this._getLocalizedLabels("dimensions") + "' class='e-inputtext e-dimensions e-rte-videoX' maxlength='3' " + this._TagId("_videoX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-videoY' maxlength='3'" + this._TagId("_videoY") + ">" +
               "<input type='checkbox' class='e-rte-videoConsrn' data-role ='none'" + this._TagId("_video_consrn") + "<label " + this._labelFor("_video_consrn") + "style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div></div>" +
                "<div class='e-rte-button e-fieldseparate'><button id='video_insert'type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogInsert") + "</button><button id='video_cancel' type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._videoDialog);
            this._videoDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find(".e-rte-videoDimensions").hide();
            var model = this._getDialogModel();
            model.width="auto";
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.title = this._getLocalizedLabels("video");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._videoDialog.ejDialog(model);
            this._videoDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._videoDialog.find(".e-inputtext").addClass('e-corner-all');
            this._chkvideoDimensions = this._videoDialog.find(".e-rte-videoConsrn");
            this._chkvideoDimensions.ejCheckBox({ checked: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._videoDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._videoDialog.find(".e-rte-btn"), "click", this._insertVideo);
            this._on(this._videoDialog.find("input.e-dimensions"), "change", this._recalcVideoSize);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },


        _renderTableDialog: function () {
            var proxy = this;
            this._createTable = ej.buildTag("div.e-rte-table-picker#" + this._rteId + "_table");
            this._customTable = $("<div class='customtable-group e-rte-createCustomTableLink' " + this._TagId("_createCustomTableLink") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("customTable") + "'>" + this._getLocalizedLabels("customTable") + "</a></div>" +
               "<div class='customtable-group e-rte-eTblProperties e-disable' " + this._TagId("_eTblProperties") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("editTable") + "'>" + this._getLocalizedLabels("editTable") + "</a></div>");  
            var tableCell, rowDiv, colDiv, tableDiv;
            this._tblheaderDiv = ej.buildTag("div.e-rte-tableheader");
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
            this._tblheaderDiv.appendTo(this._createTable);
            var tableDiv = ej.buildTag("div.e-rte-table");
            this._drawTable(tableDiv);
            tableDiv.appendTo(this._createTable); 
            this._createTable.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.enableModal = false;
            model.showHeader = false;
            model.width = "auto";
            model.minWidth = "270px";
            model.maxWidth = "270px";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function (args) {
				args.event&& args.event.clickAction && proxy._ieCursorMaintainance();
            };
            this._createTable.ejDialog(model); 
            this._on(this._customTable, "click", this._openCustomTable);
            this._customTable.appendTo(this._createTable); 
        },

        _createCustomTable: function () { 
            if (!this.model.showCustomTable)
                this._createTable.find("#" + this._rteId + "_createCustomTableLink").hide();
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._customTableDialog = ej.buildTag("div.e-rte-customtable#" + this._rteId + "_customTable");
            var content = $("<div class='e-fieldgroup'><div class='e-rte-tablefields'><label " + this._labelFor("_txtColumns") + ">" + this._getLocalizedLabels("tableColumns") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtColumns' " + this._TagId("_txtColumns") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtRows") + ">" + this._getLocalizedLabels("tableRows") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtRows' " + this._TagId("_txtRows") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtWidth'" + this._TagId("_txtWidth") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtHeight'" + this._TagId("_txtHeight") + "></div></div>" +
                 "<div class='e-fieldseparate'><div class='e-rte-tablefields'><label " + this._labelFor("_txtSpacing") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtSpacing' " + this._TagId("_txtSpacing") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtPadding") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtPadding'" + this._TagId("_txtPadding") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtBorder") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-txtBorder' data-role ='none' " + this._TagId("_txtBorder") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_chkCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' class='e-rte-chkCaption'  data-role ='none'" + this._TagId("_chkCaption") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_ddlAlignment") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-ddlAlignment' data-role ='none' " + this._TagId("_ddlAlignment") + "><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div></div>" +
                 "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._customTableDialog);
			var model = this._getDialogModel();
            model.width = "auto";
			model.maxWidth="480px";
            model.title = this._getLocalizedLabels("customTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customTableDialog.ejDialog(model);
            this._customTableDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._customTableDialog.find(".e-inputtext").addClass('e-corner-all');
            this._createTable.find("div.e-rte-eTblProperties");
            this._customTableDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 1, value: 3, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox({ maxValue: 63, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: false, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkTblCaption = this._customTableDialog.find(".e-rte-chkCaption");
            this._chkTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._customTableDialog.find(".e-rte-btn"), "click", this._insertCustomTable);
            this._on(this._customTableDialog.find(".e-rte-txtWidth"), "focusout", this._widthFocusOut);
        },
        _renderEditTableDialog: function () {
            var proxy = this;
            this._eTblDialog = ej.buildTag("div.e-rte-edittable#" + this._rteId + "_eTbl");
            var rteID = this._rteId;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div id='" + this._rteId + "_eTbl_Tab'><ul><li class='e-first'><a href='#" + this._rteId + "_eTblTable'>" + this._getLocalizedLabels("table") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblRow'>" + this._getLocalizedLabels("row") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblCell'>" + this._getLocalizedLabels("cell") + " </a></li></ul>" +
            "<div id='" + this._rteId + "_eTblTable'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellSpace") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellSpace") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellPad") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellPad") + "></div>" +
                   "<div class='e-rte-tablefields'><label  " + this._labelFor("_eTblAlign") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select id='" + rteID + "_eTblAlign' data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' data-role ='none' " + this._TagId("_eTblCaption") + "></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTbl_border_style") + " class='e-rte-dropdown' data-role ='none' ><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTbl_border_color") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblRow'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblRHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblRAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblRBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTblRBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblRBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblRStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblCell'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblClAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3' " + this._TagId("_eTblClBrdrPx") + " ></div><div class='e-img-border-field'><select " + this._TagId("_eTblClBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblClBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClStyle") + "></div></div>" +
            "</div>" +
            "</div>" +
            "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_apply'>" + this._getLocalizedLabels("dialogApply") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>"
            );
            content.appendTo(this._eTblDialog);
            this._tblborderPicker = this._eTblDialog.find("#"+this._rteId +"_eTbl_border_color").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._eTblDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.width = "auto";
            model.title = this._getLocalizedLabels("editTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._eTblDialog.ejDialog(model);
            this._eTblDialog.closest(".e-dialog-wrap").addClass("e-rte e-edittable");
            this.model.showRoundedCorner && this._eTblDialog.find(".e-inputtext").addClass('e-corner-all');
            this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-dropdown").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", showRoundedCorner: this.model.showRoundedCorner });
            this._eTblAlign = this._getTableObj("Align").data('ejDropDownList');
            this._eTblAlign.option('enabled', false);
            this._getTableObj("_Tab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblCaption = this._getTableObj("Caption");
            this._eTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._eTblDialog.find(".e-rte-btn"), "click", this._eTblBtnClick);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },

        _drawTable: function (tableDiv) {
            var rowDiv, tableCell;
            for (var row = 0; row < this.model.tableRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.tableColumns; col++) {
                    tableCell = ej.buildTag("div.e-rte-tablecell e-default");
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
        },


        _renderSourceDialog: function () {
            var proxy = this;
            this._sourceDialog = ej.buildTag("div.e-rte-source#" + this._rteId + "_Source");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<textarea class='e-rte-srctextarea e-inputtext'></textarea><div class='e-rte-button e-fieldseparate'><button id='src_update' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogUpdate") + "</button><button id='src_cancel' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._sourceDialog);
            var model = this._getDialogModel();
            model.title = this._getLocalizedLabels("viewHtml");
            model.width = "auto";
			model.minWidth="330px";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._sourceDialog.ejDialog(model);
			this._sourceDialog.closest(".e-dialog-wrap").addClass("e-rte e-sourcedialog")
            this.model.showRoundedCorner && this._sourceDialog.find(".e-inputtext").addClass('e-corner-all');
            this._sourceDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._sourceDialog.find(".e-rte-btn"), "click", this._srcBtnClick)
        },


        _renderAlertDialog: function () {
            var proxy = this;
            this._alertWindow = ej.buildTag("div#" + this._rteId + "_Alert");
            var content = $("<p class='e-alerttext' style='margin:0.875em 0em;'></p><div class='e-rte-button e-fieldseparate'><button data-role ='none' class='e-rte-btn e-alert-ok' type='button'>" + this._getLocalizedLabels("dialogOk") + "</button><button class='e-rte-btn e-alert-cancel' data-role='none'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._alertWindow);
            var model = this._getDialogModel();
            model.showHeader = false;
            model.width = "auto";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.minHeight = "50px";
            this._alertWindow.ejDialog(model);
            this._alertWindow.closest(".e-dialog-wrap").addClass("e-rte");
            this._alertWindow.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._alertWindow.find(".e-rte-btn"), "click", this._alertBtnClick)
            this._alertWindow.find(".e-alert-cancel").hide();
        },

        _alertBtnClick: function (e) {
            if ($.trim(this._alertWindow.find(".e-alerttext").html()) == this._getLocalizedLabels("deleteAlert") && $(e.target).hasClass("e-alert-ok")) {
                this._getDocument().body.innerHTML = " ";
				this._emptyContent();
                if (this.model.showToolbar)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
                this._setBackupData();
                this._updateCount();
                var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
                this._updateTagInfo(selectNode);
                this._onChange();
            }
            this._alertWindow.ejDialog("close");
            this._alertWindow.find(".e-alert-cancel").hide();
        },

		_emptyContent: function (){
			var setNode,tempSpanNode = document.createElement("span");
			tempSpanNode.innerHTML = "&#65279;"
			 var range = this._getDocument().createRange(), Selection = this._getDocument().getSelection();
			 this._getDocument().body.firstChild && this._getDocument().body.firstChild.remove();
				this._getDocument().body.appendChild(setNode=this._getDocument().createElement("p"));
				setNode.appendChild(tempSpanNode);
				Selection.removeAllRanges();
                range.setStart(tempSpanNode.firstChild, 0);
                range.setEnd(tempSpanNode.firstChild, 0);
                Selection.addRange(range);
                $(this._getDocument().body).find('p span').remove();
		},
        _openAlert: function (alertText) {
            this._alertWindow.find(".e-alerttext").html(alertText);
            this._alertWindow.ejDialog("instance")._centerPosition();
            $("#" + this._rteId + "_Alert_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._alertWindow.ejDialog("open");
        },


        _renderFormat: function () {
            this._formatDDL = ej.buildTag("input#" + this._rteId + "_formatDDL", "", "", { type: "text", title: this._getLocalizedLabels("format"), "data-role": "none" });
            var defaultText = [
                { text: "paragraph", value: "<p>" },
                { text: "quotation", value: "<blockquote>" },
                { text: "heading1", value: "<h1>" },
                { text: "heading2", value: "<h2>" },
                { text: "heading3", value: "<h3>" },
                { text: "heading4", value: "<h4>" },
                { text: "heading5", value: "<h5>" },
                { text: "heading6", value: "<h6>" }];
            var model = {};
            model.dataSource = this._formatText(this.model.format, defaultText);
            model.width = "105px";
            model.enableRTL = this.model.enableRTL;
            model.popupWidth = "175px";
            model.popupHeight = "auto";
            model.selectedItemIndex = 0;
            model.select = this._formatChange;
            model.cssClass = "e-rte-format-ddl";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value", spriteCssClass: "spriteCssClass" };
            this._formatDDL.appendTo(this._rteToolbar.find("li.e-rteItem-format").html(""));
            this._formatDDL.ejDropDownList(model);
            this._formatPopupStyle();
        },

        _formatText: function (formatSource, formatText) {
            for (var i = 0; i < formatSource.length; i++)
                for (var j = 0; j < formatText.length; j++)
                    if (formatSource[i].value == formatText[j].value) {
                        formatSource[i].text = this._getLocalizedLabels(formatText[j].text) ? this._getLocalizedLabels(formatText[j].text) : formatSource[i].text;
                        break;
                    }
            return formatSource;
        },

        _formatPopupStyle: function () {
            var _liList = this._formatDDL.data("ejDropDownList").popupPanelWrapper.find("li");
            for (var i = 0; i < _liList.length; i++) {
                $(_liList[i]).addClass(this.model.format[i].spriteCssClass);
            }
        },


        _renderFontStyle: function () {
            this._fontStyleDDL = ej.buildTag("input#" + this._rteId + "_fontNameDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontName"), "data-role": "none" });
            var defaultText = [
				{ text: "timesnewroman", value: "Times New Roman,Times,serif" },
			    { text: "segoeui", value: "Segoe UI" },
				{ text: "arial", value: "Arial,Helvetica,sans-serif" },
				{ text: "couriernew", value: "Courier New,Courier,monospace" },
				{ text: "georgia", value: "Georgia,serif" },
				{ text: "impact", value: "Impact,Charcoal,sans-serif" },
                { text: "lucidaconsole", value: "Lucida Console,Monaco,monospace" },
                { text: "tahoma", value: "Tahoma,Geneva,sans-serif" },
                { text: "trebuchetms", value: "Trebuchet MS,Helvetica,sans-serif" },
                { text: "verdana", value: "Verdana,Geneva,sans-serif" }
            ];
            var model = {};
            model.dataSource = this._formatText(this.model.fontName, defaultText);
            model.enableRTL = this.model.enableRTL;
            model.selectedItemIndex = 0;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontStyleChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontStyleDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontName").html(""));
            this._fontStyleDDL.ejDropDownList(model);
        },


        _renderFontSize: function () {
            this._fontSizeDDL = ej.buildTag("input#" + this._rteId + "_fontSizeDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontSize"), "data-role": "none" });
            var model = {};
            model.dataSource = this.model.fontSize;
            model.width = "100px";
            model.enableRTL = this.model.enableRTL
            model.selectedItemIndex = 2;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontSizeChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontSizeDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontSize").html(""));
            this._fontSizeDDL.ejDropDownList(model);
        },


        _renderFontColor: function () {
            var proxy = this;
            this._fontColorSplit = ej.buildTag("button#" + this._rteId + "_fontColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
            var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["fontColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            this._fontColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
			 var FontColors = $("<div class='customcolor e-rte-customcolor' " + this._TagId("_customcolor") + "><a class='customcolor-link' role='button' title='" + this._getLocalizedLabels("customColor") + "'>" + this._getLocalizedLabels("customFontColor") + "</a></div>");
             _liTemplte.append(FontColors);
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor"));
			 this._on(FontColors, "click", this._openColorpalette);
            this._fontColorSplit.ejSplitButton(model);
            this._splitObj = this._fontColorSplit.ejSplitButton("instance");
            this._splitObj.option("beforeOpen", function () { proxy._bindClickOperation("FontColor"); });
            this._on(this._fontColorSplit, "click", this._fontColorClick);
            this._fontColorSplit.find("span." + this._rteIconsList["fontColor"]).removeClass("e-icon");
            this._fontColorSplit.find("span.e-btntxt").css("background-color", this._fontColor);
        },
        _renderUnOrderList: function () {
            var proxy = this;
            this._unOrderSplit = ej.buildTag("button#" + this._rteId + "_unorder", "", {}, { type: "button", "data-role": "none" });
            this._unorderLiTemplate = ej.buildTag("ul#" + this._rteId + "_unorderlist", "", { "height": "auto", "width": "84px" }, { "class": "e-rte-unorderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-nonelist-icon'></span></li><li id='disc' title='" + this._getLocalizedLabels("disc") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-disclist-icon'></span></li><li id='square' title='" + this._getLocalizedLabels("square") + "' class='square' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-squarelist-icon'></span></li><li id='circle' title='" + this._getLocalizedLabels("circle") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-circlelist-icon'></span></li>").appendTo(this._unorderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customUnorderedList"]))
                $.each(proxy.model.tools["customUnorderedList"], function (i, val) {
                    if (i == 0) $(proxy._unorderLiTemplate).find("#circle,#square").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("ulcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._unorderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.targetID = this._rteId + "_unorderlist";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["unorderedList"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.itemSelected = $.proxy(this._onUnorderList, this);
            this._unOrderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-unorderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_unorderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._unorderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-unorderedList") : $('body')));
            this._unOrderSplit.ejSplitButton(model);
            this._unOrderSplitObj = this._unOrderSplit.ejSplitButton("instance");
            this._unOrderSplit.find("span.e-unorderedList-icon").removeClass("e-icon");
            this._on(this._unOrderSplit, "click", this._onUnorderList);
        },
        _renderOrderList: function () {
            var proxy = this;
            this._orderSplit = ej.buildTag("button#" + this._rteId + "_order", "", {}, { type: "button", "data-role": "none" });
            this._orderLiTemplate = ej.buildTag("ul#" + this._rteId + "_orderlist", "", { "height": "auto", "width": "124.05px" }, { "class": "e-rte-orderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-nonelist-icon'></span></li><li id='decimal' title='" + this._getLocalizedLabels("number") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-numbering-icon'></span></li><li id='lower-alpha' title='" + this._getLocalizedLabels("loweralpha") + "'  style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-loweralpha-icon'></span></li><li id='lower-roman' title='" + this._getLocalizedLabels("lowerroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-lowerroman-icon'></span></li><li id='upper-alpha' title='" + this._getLocalizedLabels("upperalpha") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperalpha-icon'></span></li><li id='upper-roman' title='" + this._getLocalizedLabels("upperroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperroman-icon'></span></li>").appendTo(this._orderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customOrderedList"]))
                $.each(proxy.model.tools["customOrderedList"], function (i, val) {
                    if (i == 0) $(proxy._orderLiTemplate).find("#upper-roman,#upper-alpha,#lower-roman").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("olcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._orderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._rteId + "_orderlist";
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["orderedList"];
            model.itemSelected = $.proxy(this._onOrderList, this);
            this._orderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-orderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_orderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._orderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-orderedList") : $('body')));
            this._orderSplit.ejSplitButton(model);
            this._orderSplitObj = this._orderSplit.ejSplitButton("instance");
            this._on(this._orderSplit, "click", this._onOrderList);
        },
        _renderBGColor: function () {
            var proxy = this;
            this._bgColorSplit = ej.buildTag("button#" + this._rteId + "_backgroundColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorBGTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
			this._bgTransparent=$("<button id='"+this._rteId+"_backgroundtransparentbtn'class='e-rte-transbtn' role='button' title='"+this._getLocalizedLabels("TransBGColor")+"'>"+this._getLocalizedLabels("TransBGColor") + "</button>");
			var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorBGTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["backgroundColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
			var BGColors = $("<div class='customBGcolor e-rte-customcolor' " + this._TagId("_customBGcolor") + "><a class='customcolor-link ' role='button' title='" + this._getLocalizedLabels("customBGColor") + "'>" + this._getLocalizedLabels("customBGColor") + "</a></div>");
             _liTemplte.append(BGColors);
			 this._on(BGColors, "click", this._openColorpalette);
			this._bgTransparent.prependTo(_liTemplte);
			this._bgColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorBGTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor"));
            this._bgColorSplit.ejSplitButton(model);
			this._bgTransparent.ejButton({width:"100%",contentType:"text",targetID:this._rteId+"_colorBGTable",showRoundercorner:this.model.showRounderCorner});
			this._bgObj=this._bgTransparent.ejButton("instance");
			 this._on(this._bgTransparent, "click", this._bgTransClick);
            this._bgSplitObj = this._bgColorSplit.ejSplitButton("instance");
            this._bgSplitObj.option("beforeOpen", function () { proxy._bindClickOperation("BGColor"); });
            this._on(this._bgColorSplit, "click", this._bgColorClick);
            this._bgColorSplit.find("span." + this._rteIconsList["backgroundColor"]).removeClass("e-icon");
            this._bgColorSplit.find("span.e-btntxt").css("background-color", this._bgColor);
        },
        _bindClickOperation: function (toolName) {
            var proxy = this, SplitMenu;
            var splitObj = toolName == "BGColor" ? proxy._bgSplitObj : proxy._splitObj;
            var element = toolName == "BGColor" ? "_backgroundColorbtn" : "_fontColorbtn";
			var tblelement=toolName == "BGColor" ? "_colorBGTable" : "_colorTable";
            SplitMenu = $("#" + proxy._rteId + element).ejSplitButton("instance");
            toolName == "BGColor" ? proxy._bgSplitMenu = SplitMenu : proxy._splitMenu = SplitMenu;
            SplitMenu.model.close = function () {
                splitObj.contstatus = false;
                proxy._off($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
            }
            proxy._on($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
        },
        _colorTable: function () {
            var tableDiv = ej.buildTag("div.e-rte-table");
            var color = 0, hexCode, rowDiv, tableCell;
            for (var row = 0; row < this.model.colorPaletteRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.colorPaletteColumns ; col++) {
                    if (color < this.model.colorCode.length) {
                        hexCode = "#" + this.model.colorCode[color];
                        tableCell = ej.buildTag("div.e-rte-palettetable", "", { "background-color": hexCode }, { title: hexCode, "color-code": hexCode });
                        tableCell.appendTo(rowDiv);
                        color++;
                    }
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },

        _recalcVideoSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._videoDialog.find(".e-rte-videoX");
            txtheight = this._videoDialog.find(".e-rte-videoY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();
            if (this._chkvideoDimensions.ejCheckBox("isChecked") && !!this._videoWidth && !!this._videoHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._videoWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._videoHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._videoWidth = newWidth;
            this._videoHeight = newHeight;
        },


        _recalcImgSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._imgDialog.find(".e-rte-imgX");
            txtheight = this._imgDialog.find(".e-rte-imgY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();

            if (this._chkImgDimensions.ejCheckBox("isChecked") && !!this._imgWidth && !!this._imgHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._imgWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._imgHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._imgWidth = newWidth;
            this._imgHeight = newHeight;
        },

        _urlValidation: function (e) {
            var _target = $(e.target);
            _target.hasClass("e-error") && _target.removeClass("e-error");
        },
        _ieLinkRange: function () {
            var rang = this._getRange();
            if (!this._isIE() && !this._isIE8()) {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html"
                this._selectionRange = rang;
            }
            else {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html" && rang.setStart(this._currentSelNode, this._currentSelNode.childNodes.length)
                this._selectionRange = rang;
            }
        },
        _ieCursorMaintainance: function () {
            if (!this._isIE8()) {
                this._ieLinkRange();
                this._focus();
            }
            else
                this._setRange(this._currentSelNode, this._getDocument().body.createTextRange(), true);
        },
        _linkBtnClick: function (sender) {
            if (sender.target.id === "link_cancel") {
                this._clearLinkFields();
                this._linkDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === "link_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._txtURL.val() != "")
                    this._onInsertLink();
                else {
                    this._onUnlink();
                    this._linkDialog.ejDialog("close");
                }
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },

        _imageBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_img_cancel") {
                this._imgDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_img_insert") {
                var imageVal = this._imgURL.val().match(/(ftp:|http:|https:)\/\//g);
                if ((ej.isNullOrUndefined(imageVal) && this._imgURL.val() !== "") || (!ej.isNullOrUndefined(imageVal) && imageVal[0].length < this._imgURL.val().length)) {
                    (this.model.maxLength != null && this.model.maxLength > $.trim(this._getText()).length) ? this._onInsertImage() : this._imgDialog.ejDialog("close");
                    this._onChange();
                    this._setBackupData();
                } else {
                    this._imgURL.addClass("e-error");
                    if (!this._isUrl($.trim(this._imageLink.val()))) this._imageLink.addClass("e-error");
                    return false;
                }
            }
        },


        _srcBtnClick: function (sender) {
            if (sender.target.id === "src_update") {
                var _editHTML = $.trim(this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value);
                if (this.model.enableHtmlEncode)
                    _editHTML = this._decode(_editHTML);
                try {
                    this._getDocument().documentElement.innerHTML = _editHTML.replace("<html>", "").replace("</html>", "");
                    if (this.model.enableXHTML)
                        this._getDocument().documentElement.innerHTML = this._updateXhtml();
                }
                catch (e) {
                    var regEX = /<body[^>]*>((.|[\n\r])*)<\/body>/i;
                    if (!ej.isNullOrUndefined(regEX.exec(_editHTML))) {
                        _editHTML = regEX.exec(_editHTML)[1];
                        this._getDocument().body.innerHTML = _editHTML;
                    }
                }
                this._onChange();
                this._updateCount();
            }
            this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = "";
            this._sourceDialog.ejDialog("close");
            this._showHideContextMenu();
        },

        _eTblBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_eTbl_cancel") {
                this._eTblDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_eTbl_apply") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._oneditTable();
                this._onChange();
                this._setBackupData();
            }
        },

        _insertCustomTable: function (sender) {
            this._customTableValidation = false;
            if (sender.target.id === "insert") {
                var cols = this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("getValue");
                var row = this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("getValue");
                var height = this._customInputValidation(this._customTableDialog.find(".e-rte-txtHeight"));
                var width = this._customInputValidation(this._customTableDialog.find(".e-rte-txtWidth"));
                var align = this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("getSelectedValue");
                var spacing = this._customInputValidation(this._customTableDialog.find(".e-rte-txtSpacing"));
                var padding = this._customInputValidation(this._customTableDialog.find(".e-rte-txtPadding"));
                var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("getSelectedValue");
                var caption = this._chkTblCaption.ejCheckBox("isChecked");
                if (!this._customTableValidation) {
                    if (!ej.isNullOrUndefined(this._tableInsertAt) && !ej.isNullOrUndefined(this._tableInsertAt.startContainer))
                        this._restoreSelection(this._tableInsertAt);
                    var tableEle = this._tableGenerator(row, cols, false, width, height, spacing, padding, align, border, caption);
                    this.executeCommand('inserthtml', tableEle);
                    var _tableEle = $(this._getDocument()).find("table.e-rte-table");
                    var drpDwnObj = this._customTableDialog.find(".e-rte-ddlAlignment").data("ejDropDownList");
                    if (drpDwnObj.option('value') == "Center")
                        _tableEle.attr('style', "margin: 0 auto");
                    this._onChange();
                    drpDwnObj.option({ value: "", enabled: false });
                }
                this._on(this._customTableDialog.find(".e-rte-txtHeight"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtWidth"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtSpacing"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtPadding"), "keypress", this._urlValidation);

            }
            if (!this._customTableValidation) {
                this._customTableDialog.ejDialog("close");
                this._clearTableFields();
                this._ieCursorMaintainance();
            }
        },

        _customInputValidation: function (validation) {
            var value = validation.val().toLowerCase();
            var lastPos = value.substr(value.length - 2, 2);
            var specChar = value.match(/[!@#$%^&*()_+\-=\[\]{};':"\\|,<>\/?]/gi);
            var alphaChar = value.match(/[a-z]/gi);
            if (((!isNaN(value) && (specChar == null || specChar.length == 0)) || (value.length > 1 && value.substr(value.length - 1, 1) == "%" && specChar.length == 1) && (alphaChar == null || alphaChar.length == 0)) || (value.length > 2 && (specChar == null || specChar.length == 0) && (alphaChar != null && alphaChar.length == 2) && (lastPos == "px" || lastPos == "in" || lastPos == "cm" || lastPos == "mm" || lastPos == "em" || lastPos == "ex" || lastPos == "pt" || lastPos == "pc")))
                return value;
            else {
                validation.addClass("e-error");
                this._customTableValidation = true;
                return 0;
            }
        },

        _clearTableFields: function () {
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtHeight").val("");
            this._customTableDialog.find(".e-rte-txtWidth").val("");
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("clearText");
            this._customTableDialog.find(".e-rte-txtSpacing").val("");
            this._customTableDialog.find(".e-rte-txtPadding").val("");
            var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("clearText");
            var caption = this._chkTblCaption.ejCheckBox({ check: false });
        },

        _clearEditTableFields: function () {
            this._eTblHeight = this._eTblDialog.find("input").val("");
            this._eTblDialog.find(".e-numerictextbox").data("ejNumericTextbox").option("value", "");
            this._eTblDialog.find(".e-rte-dropdown").data("ejDropDownList").option("value", "");
            this._eTblAlign.disable();
            this._eTblCaption.ejCheckBox({ check: false });
        },

        _clearLinkFields: function () {
            this._txtURL = this._linkDialog.find(".e-rte-linkUrl");
            this._txtURL.removeClass("e-error");
            this._txtURL.val("http://");
            this._txtLinkText = this._linkDialog.find(".e-rte-linkText");
            this._txtLinkText.val("");
            this._txtLinkTitle = this._linkDialog.find(".e-rte-linkTitle");
            this._txtLinkTitle.val("");
            this._chkTarget.ejCheckBox({ check: false });
            this._txtURL.focus();
        },
        _textFieldFocus: function (ele, start, end) {
            if (!this._isIE8()) ele.setSelectionRange(start, end);
            else {
                var range = ele.createTextRange();
                range.collapse(true);
                range.moveEnd('character', start);
                range.moveStart('character', end);
                range.select();
            }
        },
        _clearImgFields: function () {
            this._imgURL = this._imgDialog.find(".e-rte-imgUrl").val("http://").removeClass("e-error");
            this._imgDialog.find(".e-rte-imgText").val("");
            this._chkImgDimensions.ejCheckBox({ checked: true });
            this._imageLink = this._imgDialog.find(".e-rte-imgLink");
            this._imageLink.removeClass("e-error");
            this._imageLink.val("");
            this._imageBorderPx = this._imgDialog.find(".e-rte-imgBorderPx").data('ejNumericTextbox');
            this._imageBorderPx.option('value', 0);
            this._imageBorderStyle = this._imgDialog.find(".e-rte-imgBorderStyle").data('ejDropDownList');
            this._imageBorderStyle.option('value', "");
            this._imgPicker.option('value', null);
            this._imgDialog.find('.e-selected-color').removeAttr('style');
            this._imageStyle = this._imgDialog.find(".e-rte-imgStyle");
            this._imageStyle.val("");
            this._dialogchkTarget.ejCheckBox({ check: false });
        },

        _videoManager: function () {
            this._renderVideoDialog();
            var selectNode = this._getSelectedNode();
            this._editVideo = null;
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode.tagName)) {
                this._editVideo = selectNode;
                this._videoWidth = parseInt($(selectNode).width());
                this._videoHeight = parseInt($(selectNode).width());
                if (this.model.showDimensions) {
                    this._videoDialog.find(".e-rte-videoX").val(this._videoWidth);
                    this._videoDialog.find(".e-rte-videoY").val(this._videoHeight);
                }
            }
            $("#" + this._rteId + "_video_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._videoDialog.ejDialog("open");
            this._videoDialog.find("textarea.e-rte-video").focus();
        },

        _sourceCodeManager: function () {
            ej.isNullOrUndefined(this._sourceDialog) && this._renderSourceDialog();
            this._updateTagInfo("body");
            this._hideTooltip();
            if (!ej.isNullOrUndefined(this._getDocument().documentElement)) {
                this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = (this.model.enableHtmlEncode) ? this._encode(this._getDocument().documentElement.outerHTML) : this._getDocument().documentElement.outerHTML;
                $("#" + this._rteId + "_Source_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._sourceDialog.ejDialog("open");
                this._sourceDialog.find("textarea.e-rte-srctextarea").focus();
            }
            else
                this._htmlSource.addClass("e-disable");
        },
        _getPasteRangeVal: function () {
            if (this._isIE()) {
                this._pasteRangeVal = this._getRange();
                this._pasteFlag = true;
            }
        },
        _hyperLinkManager: function (filebrowser) {
            this._renderLinkDialog();
            filebrowser && this._renderFileBrowserDialog();
            this._getPasteRangeVal();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();

            this._selectedHTML = (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? this._pasteRangeVal.toString() : this._getSelText();
            if (filebrowser) {
                this._clearFileFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._fileLinkText.val($(selectNode).html()) : this._fileLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_fileDialog_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._fileDialog.ejDialog("open");
            }
            else {
                this._clearLinkFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._txtLinkText.val($(selectNode).html()) : this._txtLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_link_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._linkDialog.ejDialog("open");
                this._textFieldFocus(this._txtURL[0], this._txtURL.val().length, this._txtURL.val().length);
            }

            if (selectNode && !(/^(A)$/).test(selectNode.nodeName)) {
                if (selectNode.tagName.toUpperCase() == "IMG")
                    selectNode = $(selectNode).parent('a')[0];
            }
            if (filebrowser) {
                if (selectNode && (/^(A)$/).test(selectNode.nodeName)) this._fileURL.val(selectNode.href);
            }
            else if (selectNode && (/^(A)$/).test(selectNode.nodeName)) {
                this._txtURL.val(selectNode.href);
                this._txtLinkTitle.val(selectNode.title);
            }
        },
        _tableManager: function () {
            var tableLi = this._rteToolbar.find("li.e-rteItem-createTable"), Xpos, Ypos;
            this._getPasteRangeVal();
            if (this._getSelectedNode().nodeName.toLowerCase() == "td")
                this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
            if (this.model.isResponsive && tableLi.length == 0) {
                var border = $(this._toolBarObj._liTemplte).outerHeight() - $(this._toolBarObj._liTemplte).height();
                tableLi = this._toolBarObj._liTemplte.find("li.e-rteItem-createTable");
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "hidden", "display": "block" });
                Ypos = ($(this._toolBarObj._liTemplte).offset().top + $(this._toolBarObj._liTemplte).outerHeight() + border - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().top);
                if($(tableLi).offset().left>230)
                   Xpos = ($(tableLi).offset().left - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().left);
				else
				   Xpos =$("#" + this._rteId + "_table_wrapper").offsetParent().offset().left;
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "visible" });
            }
            else
                Xpos = $(tableLi).position().left, Ypos = $(tableLi).position().top + tableLi.height() + 7;
            if (((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > document.body.clientWidth) || ((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > parseInt($("#" + this._id + "_wrapper").css("width")) + $("#" + this._id + "_wrapper").position().left)) Xpos = (parseInt(Xpos) - (parseInt($("#" + this._id + "_table_wrapper").css("width")) - $(tableLi).width())) + "px";
            var top = (document.documentElement && document.documentElement.scrollTop) || document.body.scrollTop;
            if (top < Ypos && $(window).height() < (Ypos - top + parseInt($("#" + this._id + "_table_wrapper").css("height"))))
                Ypos = (parseInt($("#" + this._id + "_table_wrapper").css("height")) > $(window).height()) ? top : ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height"))) > 0 ? ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height")) + top) : top;
            var parentOffset=this._rteWapper.offset();
		    Xpos=parseInt(Xpos)-parseInt(parentOffset["left"]);
			Ypos=parseInt(Ypos)-parseInt(parentOffset["top"]);
			this._createTable.ejDialog("option", "position", { X: Xpos, Y: Ypos });
            this._createTable.ejDialog("open");
            this._on(ej.getScrollableParents(this._createTable), "scroll", function () {
                this._createTable.ejDialog("close");
            });
        },
        _eTblManager: function () {
            this._renderEditTableDialog();
            this._clearEditTableFields();
            var rteID = this._rteId;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            if (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toLowerCase() === "td") {
                var parentTable = $(selectNode).closest('tbody').closest('table');
                this._getTableObj("Height").val($(parentTable).height());
                this._getTableObj("Width").val($(parentTable).width());
                if (!ej.isNullOrUndefined(parentTable[0])) {
                    this._getTableObj("CellSpace").data('ejNumericTextbox').option('value', parentTable[0].cellSpacing);
                    this._getTableObj("CellPad").data('ejNumericTextbox').option('value', parentTable[0].cellPadding);
                    var align = parentTable[0].align;
                }
                if (!ej.isNullOrUndefined(align) && align != "") {
                    this._eTblAlign.enable();
                    this._eTblAlign.option('value', align);
                }
                var captionEle = $($(selectNode).closest('tbody')).prev('caption');
                if (captionEle.length > 0)
                    this._eTblCaption.ejCheckBox({ checked: true });
                if (!ej.isNullOrUndefined(parentTable[0]) && parentTable[0].style != "") {
                    this._getTableObj("BrdrPx").data('ejNumericTextbox').option('value', parentTable[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("_border_style").data('ejDropDownList');
                    (parentTable[0].style.borderStyle != "") ? obj.selectItemByValue(parentTable[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("_border_color").val(parentTable[0].style.borderColor);
                }
                this._getTableObj("Style").val(parentTable.attr('style'));


                var parentRow = $(selectNode).closest('tr');
                this._getTableObj("RHeight").val($(parentRow).height());
                this._getTableObj("RAlign").data('ejDropDownList').option('value', parentRow[0].style.textAlign);
                if (parentRow[0].style != "") {
                    this._getTableObj("RBrdrPx").data('ejNumericTextbox').option('value', parentRow[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("RBrdrStyle").data('ejDropDownList');
                    (parentRow[0].style.borderStyle != "") ? obj.selectItemByValue(parentRow[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("RBrdrColor").val(parentRow[0].style.borderColor);
                }
                this._getTableObj("RStyle").val(parentRow.attr('style'));
                this._getTableObj("ClWidth").val($(selectNode).width());
                this._getTableObj("ClAlign").data('ejDropDownList').option('value', selectNode.style.textAlign);
                if (selectNode.style != "") {
                    this._getTableObj("ClBrdrPx").data('ejNumericTextbox').option('value', selectNode.style.borderLeftWidth.split('px')[0]);
                    var obj = this._getTableObj("ClBrdrStyle").data('ejDropDownList');
                    (selectNode.style.borderStyle != "") ? obj.selectItemByValue(selectNode.style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("ClBrdrColor").val(selectNode.style.borderColor);
                }
                this._getTableObj("ClStyle").val($(selectNode).attr('style'));
            }
        },

        _getTableObj: function (value) {
            return this._eTblDialog.find('#' + this._rteId + "_eTbl" + value);
        },

        _imageManager: function () {
            this._renderImageDialog();
            this._clearImgFields();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode)) {
                this._imgWidth = parseInt($(selectNode).width());
                this._imgHeight = parseInt($(selectNode).height());
                if (this.model.showDimensions) {
                    this._imgDialog.find(".e-rte-imgX").val(this._imgWidth);
                    this._imgDialog.find(".e-rte-imgY").val(this._imgHeight);
                }
                var linkNode = $(selectNode).parent('a');
                if (linkNode.length > 0)
                    this._imageLink.val(linkNode.attr('href'));
                if (selectNode.tagName.toLowerCase() === "img") {
                    this._imgDialog.find(".e-rte-imgUrl").val(selectNode.src);
                    this._imgDialog.find(".e-rte-imgText").val(selectNode.alt);
                    if (selectNode.style != "") {
                        this._imageBorderPx.option('value', selectNode.style.borderWidth.split('px')[0]);
                        this._imageBorderStyle.option('value', selectNode.style.borderStyle);
                        if (selectNode.style.borderColor.length > 0) {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._imgPicker.option('value', selectNode.style.borderColor);
                            else {
                                var colorCode = selectNode.style.borderColor.split("(")[1].split(")")[0];
                                colorCode = colorCode.split(",");
                                colorCode = { r: $.trim(colorCode[0]), g: $.trim(colorCode[1]), b: $.trim(colorCode[2]) };
                                this._imgPicker.option('value', this._imgPicker.RGBToHEX(colorCode));
                            }
                        }
                    }
                    this._imageStyle.val($(selectNode).attr('style'));
                }
            }
            $("#" + this._rteId + "_Image_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._imgDialog.ejDialog("open");
            this._textFieldFocus(this._imgURL[0], this._imgURL.val().length, this._imgURL.val().length);
            if (ej.isNullOrUndefined(this._explorerObj)) this._imgDialog.find(".e-rte-imgUrl").focus();
        },
        _getValidbrowser: function (name) {
            switch (name) {
                case "chrome":
                    return ej.browserInfo().version < 42
                    break;
                case "mozilla":
                    return ej.browserInfo().version < 41
                    break;
                case "opera":
                    return ej.browserInfo().version < 29
                    break;
                default:
                    return true;
                    break;
            }
        },
        _alertHeader: function (rteInstcne) {
            rteInstcne._alertWindow.ejDialog("option", "showHeader", false);
            this.model.enableRTL && !this._alertWindow.find(".e-alert-ok").hasClass("e-rte-alertBtnRTL") && this._alertWindow.find(".e-alert-ok").addClass("e-rte-alertBtnRTL");
            rteInstcne._alertWindow.find(".e-rte-button").css({ "text-align": "", "padding-bottom": "", "padding-top": "" }).addClass("e-fieldseparate");
            rteInstcne._alertWindow.ejDialog("instance").refresh();
        },
        _toolBarClick: function (sender) {
            if (sender.event && ((sender.event.which && sender.event.which == 3) || (sender.event.button && sender.event.button == 2)))
                return;
            var $rteEle = $(this.itemsContainer).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
            var _itemId = ej.isNullOrUndefined(rteId) ? sender.currentTarget.id.replace("_", "") : sender.currentTarget.id.replace(rteId + "_", "");
            rteInstcne._alertHeader(rteInstcne);
            if (ej.browserInfo().name === "mozilla") rteInstcne._getDocument().designMode = "off";
            if ($(sender.currentTarget).hasClass("e-rteItem-copy") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("copyAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-cut") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("cutAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-paste") && !rteInstcne._isIE())
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("pasteAlert"));
            else {
                if (ej.browserInfo().name != "chrome") {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0 && $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).hasClass("e-active"))
                        rteInstcne._selectCommand(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
                    var commandName = $.grep(sender.currentTarget.children[0].className.split(/\s+/), function (a) {
                        return !/^e-(rteItem|rte-toolbar-icon)$/i.test(a)
                    });
                if (commandName.indexOf("e-split") >= 0 || commandName.indexOf("e-ddl") >= 0)
                    commandName[0] = _itemId;
                rteInstcne._selectCommand(commandName[0]);
            }

            if (rteInstcne._styleItems.indexOf(_itemId) >= 0 || rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                    this.deselectItemByID(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
            }


            else if (rteInstcne._alignItems.indexOf(_itemId) >= 0) {
                this.selectItemByID(sender.currentTarget.id);
                var index = rteInstcne._alignItems.indexOf(_itemId)
                for (var i = 0; i < rteInstcne._alignItems.length; i++) {
                    if (i != index)
                        this.deselectItemByID(rteId + "_" + rteInstcne._alignItems[i]);
                }
            }

            else if (rteInstcne._listItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                var index = rteInstcne._listItems.indexOf(_itemId);
                $("#" + rteId + "_" + rteInstcne._listItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                if (index == 0)
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[1]);
                else
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[0]);
            }
        },

        _toggleEditTable: function () {
            if (this._isIE8())
                this._getRange().parentElement&& (this._currentSelNode = this._getRange().parentElement());
            var isTable = $(this._getSelectedNode()).closest("table");
            var selTag = (isTable.length > 0) ? isTable[0] : this._getSelectedNode(), _eTblItems;
            if (ej.isNullOrUndefined(selTag)) return false;
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (this.model.isResponsive && items.length == 0)
                    _eTblItems = this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                else _eTblItems = this._toolBarItems.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (!ej.isNullOrUndefined(selTag.tagName)) {
                    if (selTag && selTag.tagName && selTag.tagName.toLowerCase() == "td" || selTag.tagName.toLowerCase() == "table" || selTag.tagName.toLowerCase() == "tr") {
                        _eTblItems.show();
                        this._createTable && this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
                    }
                    else if (!ej.isNullOrUndefined(this._createTable)) {
                        _eTblItems.hide();
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                }
            }
            if (this.model.isResponsive && this.model.showToolbar) this._toolBarObj._reSizeHandler();
            if (!this.model.autoHeight ||(this._toolBarObj && $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length))
                this._setIframeHeight();
        },


        _formatChange: function (args) {
            if (args.isInteraction) {
                var $rteEle = $(this.element).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                args.value !== "" && rteInstcne._onFormatBlock(args.value);
                rteInstcne._isIE() && rteInstcne._focus();
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }

        },


        _fontStyleChange: function (args) {
            if (args.isInteraction) {
			     var $rteEle;
               (this.element.closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = this.element.closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontName(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _fontSizeChange: function (args) {
            if (args.isInteraction) {
                var $rteEle;
               (this.element.closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = this.element.closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontSize(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _colorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onFontColor(value);
                this._splitMenu.hide(e);
                this._fontColor = value;
                this._fontColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },


        _bgColorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onBGColor(value);
                this._bgSplitMenu.hide(e);
                this._bgColor = value;
                this._bgColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },

        _fontColorClick: function (e) {
            this._onFontColor(this._fontColor);
            if (ej.isNullOrUndefined(this._splitMenu)) return false;
            this._splitMenu.hide(e);
        },

		_bgTransClick:function(e)
		{
		    this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, "transparent");
            this._trigger("execute", { commandName: "backColor" });
			this._bgColorSplit.find("span.e-btntxt").css("background-color", "transparent");
		    if (!ej.isNullOrUndefined(this._bgSplitMenu));
            this._bgSplitMenu.hide(e);
			this._bgColor="transparent";
		},
        _bgColorClick: function (e) {
            this._onBGColor(this._bgColor);
            if (ej.isNullOrUndefined(this._bgSplitMenu)) return false;
            this._bgSplitMenu.hide(e);
        },

        _selectCommand: function (selectedId) {
			$(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline","");
                if (ej.browserInfo().name != "edge" && !(selectedId == "format" || selectedId == "fontName" || selectedId == "fontSize" || selectedId == "fontColor" || selectedId == "backgroundColor" || selectedId == "createTable" )) {
                this._focus();
            }
            switch (selectedId) {
                case "fullScreen":
                    this._onFullScreen();
                    break;
                case "print":
                    this._onPrint();
                    break;
                case "import":
                    this._onImport();
                    break;
                case "wordExport":
                    this._onExportToWord();
                    break;
                case "pdfExport":
                    this._onExportToPdf();
                    break;
                case "findAndReplace":
                    if (ej.RTE.FindAndReplace)
                        this._showFindAndReplace();
                    break;
                case "bold":
                    this._onBold();
                    break;
                case "italic":
                    this._onItalics();
                    break;
                case "underline":
                    this._onUnderLine();
                    break;
                case "strikethrough":
                    this._onStrikeThrough();
                    break;
                case "justifyLeft":
                    this._onJustifyLeft();
                    break;
                case "justifyRight":
                    this._onJustifyRight();
                    break;
                case "justifyCenter":
                    this._onJustifyCenter();
                    break;
                case "justifyFull":
                    this._onJustifyFull();
                    break;
                case "cut":
                    this._onCut();
                    break;
                case "copy":
                    this._onCopy();
                    break;
                case "paste":
                    this._onPaste();
                    break;
                case "clearFormat":
                    this._onClearFormat();
                    break;
                case "clearAll":
                    this._clearAllManager();
                    break;
                case "orderedList":
                case "unorderedList":
                    this._getPasteRangeVal();
                    break;
                case "undo":
                    this._undo();
                    break;
                case "redo":
                    this._redo();
                    break;
                case "indent":
                    this._onIndent();
                    this._indentdepth++;
                    break;
                case "outdent":
                    this._onOutdent();
                    if (this._indentdepth > 0)
                        this._indentdepth--;
                    break;
                case "createLink":
                    this._hyperLinkManager(false);
                    break;
                case "removeLink":
                    this._onUnlink();
                    break;
                case "image":
                    this._imageManager();
                    break;
                case "createTable":
                    (!this._createTable.ejDialog("isOpen")) ? this._tableManager() : this._createTable.ejDialog("close");
                    break;
                case "addRowAbove":
                    this.insertRow(true);
                    break;
                case "addRowBelow":
                    this.insertRow(false);
                    break;
                case "addColumnLeft":
                    this.insertColumn(true);
                    break;
                case "addColumnRight":
                    this.insertColumn(false);
                    break;
                case "deleteRow":
                    this.removeRow();
                    break;
                case "deleteColumn":
                    this.removeColumn();
                    break;
                case "deleteTable":
                    this.removeTable();
                    break;
                case "superscript":
                    this._onSuperScript();
                    break;
                case "subscript":
                    this._onSubScript();
                    break;
                case "upperCase":
                    this._onUpperCase();
                    break;
                case "lowerCase":
                    this._onLowerCase();
                    break;
                case "video":
                    this._videoManager();
                    break;
                case "fileBrowser":
                    this._hyperLinkManager(true);
                    break;
                default:
                    this._onChange();
                    break;
            }
            if (selectedId != "createLink" && selectedId != "image" && selectedId != "video" && selectedId != "createTable") {
                this._onChange();
            }
            if ((selectedId != "undo") && (selectedId != "redo"))
                this._setBackupData();
            var selectEle = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._updateTagInfo(selectEle);
        },
        _focus: function () {
          var  browserInfo = ej.browserInfo();
            if (browserInfo.name == "webkit")
                this._getWindow().focus();
            else
                this._getWindow().document.body.focus();
            this._restoreSelection(this._selectionRange);
        },
        _getWindow: function () {
            var iframe = $($(this._rteWapper.find(".content-iframe"))[0].contentWindow)[0];
            return iframe;
        },
        _getDocument: function () {
            var iframe = this._rteWapper.find(".content-iframe");
            try {
                return iframe.contents()[0];
            }
            catch (err) {
                return "";
            }
        },
        _onFullScreen: function () {
            if (!$(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length) {
                this._rteOffset = $(this._rteWapper).position();
                this._rtePosition = $(this._rteWapper).css("position");
                $(this._rteWapper).css({ "top": "0px", "left": "0px", "width": "100%", "height": "100%", "position": "fixed", "z-index": this._onGetMaxZindex() });
                $("body").css("overflow", "hidden");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["maximize"])).removeClass(this._rteIconsList["maximize"]).addClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("resize"));
            }
            else {
                $(this._rteWapper).css({ "top": this._rteOffset.top, "left": this._rteOffset.left, "width": this._rteWidth, "height": this._rteHeight, "position": this._rtePosition, "z-index": "" });
                $("body").css("overflow", "");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).addClass(this._rteIconsList["maximize"]).removeClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("maximize"));
            }
            if ($(this._getDocument()).find("table.e-rte-table").length > 0) this._removeResizeObject();
            this._setAutoHeight();
            if (this.model.showToolbar && this.model.isResponsive) this._toolBarObj._reSizeHandler();
            this._setIframeHeight();
            if (!ej.isNullOrUndefined(this._createTable))
                this._createTableClose();
        },
        _onGetMaxZindex: function () {
            return Math.max.apply(null,
                  $.map($('body *'), function (e, n) {
                      return parseInt($(e).css('z-index')) + 1 || 1;
                  }));
        },
        _onZooming: function (_proxy) {
            _proxy._zoomValue = 0;
            var size = Number(_proxy.getDocument().body.style.zoom == "" || ej.isNullOrUndefined(_proxy.getDocument().body.style.zoom) ? 1 : _proxy.getDocument().body.style.zoom);
            var zoomStep = (isNaN(_proxy.model.zoomStep) && _proxy.model.zoomStep.indexOf("%") != -1) ? parseInt(_proxy.model.zoomStep) / 100 : Number(_proxy.model.zoomStep);
            _proxy._zoomValue = (_proxy._zoomArgs == "IN") ? size + zoomStep : ((size - zoomStep) > 0.1) ? size - zoomStep : 0.1;
            $(_proxy.getDocument().body).css({ "zoom": _proxy._zoomValue, "transform": "scale(" + _proxy._zoomValue + ")", "transform-origin": "0 0", "-o-transform": "scale(" + _proxy._zoomValue + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + _proxy._zoomValue + ")", "-webkit-transform-origin": "0 0" });
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            if (_proxy._isIE()) return _proxy;
        },
        _onKeyZoom: function (args) {
            var _proxy = this;
            this._mouseStillDown = true;
            this._zoomArgs = args;
            this._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onPrint: function () {
            var _proxy = this;
            if (this._isIE() || ej.browserInfo().name === "mozilla") this._getWindow().onafterprint = function () { $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" }); };
            else _proxy._getWindow().matchMedia('print').addListener(function (args) {
                if (!args.matches) $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" });
            });
            $(_proxy.getDocument().body).css({ "zoom": "", "transform": "", "-o-transform": "", "-webkit-transform": "" });
            this._getWindow().print();
        },
        _renderimport: function () {
            var divEle = ej.buildTag("div#" + this._id + "_importUpload", "", "", ""), url = this.model.importSettings.url + "?rteid=" + this._id;
            this._rteToolbar.find("li.e-rteItem-import").append(divEle);
            divEle.ejUploadbox({
                multipleFilesSelection: false, width: "0px", height: "0px", autoUpload: true, extensionsAllow: ".docx,.doc", showBrowseButton: false, buttonText: { browse: this._id }, showFileDetails: false, saveUrl: url,
                success: function (args) {
                    var rteID = args.model.buttonText.browse, rteObj = $("#" + rteID).data("ejRTE"), htmlText = args.responseText, iframe = $(rteObj._getDocument().body);
                    htmlText = htmlText.replace('<string xmlns="http://schemas.microsoft.com/2003/10/Serialization/">', '').replace('</string>', '').replace(/"/gi, '');
                    iframe.children().remove();
                    iframe.append($.parseHTML(htmlText));
                }
            });
            divEle.addClass("e-browse-hide");
        },
        _onImport: function () {
            this._toolBarItems.find("div#" + this._id + "_importUpload").find('input[type=file]').trigger("click");
			if(this.model.isResponsive)$("div#" + this._id + "_toolbar_hiddenlist").find("div#" + this._id + "_importUpload").find('input[type=file]').trigger("click"); 
        },
        _onExportToWord: function () {
            var str = this._getDocument().body, url = this.model.exportToWordSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToWordSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _onExportToPdf: function () {
            var str = this._getDocument().body, url = this.model.exportToPdfSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToPdfSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _zoomUp: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            if (this._setInterval) {
                this._mouseStillDown = false;
                clearInterval(this._setInterval);
                this._setInterval = null;
            }
        },
        _zoomDown: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            var _proxy = this;
            _proxy._mouseStillDown = true;
            _proxy._zoomArgs = $(e.target).hasClass("e-rte-toolbar-icon zoomIn " + this._rteIconsList["zoomIn"]) || $(e.target).hasClass("e-rteItem-zoomIn") ? "IN" : "OUT";
            if (e.type == "mousedown") _proxy._setInterval = setInterval(function () { _proxy._onZooming(_proxy); }, 100);
            else _proxy._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onBold: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('bold', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.bold, null);
                this._trigger("execute", { commandName: "bold" });
            }
        },

        _onItalics: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('italic', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.italic, null);
                this._trigger("execute", { commandName: "italic" });
            }

        },
        _onStrikeThrough: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('strikethrough', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.strikethrough, null);
                this._trigger("execute", { commandName: "strikethrough" });
            }
        },

        _onUnderLine: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('underline', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.underline, null);
                this._trigger("execute", { commandName: "underline" });
            }
        },

        _onJustifyLeft: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyLeft', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyleft, null);
                this._trigger("execute", { commandName: "JustifyLeft" });
            }
        },

        _onJustifyRight: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyRight', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyright, null);
                this._trigger("execute", { commandName: "JustifyRight" });
            }
        },

        _onJustifyCenter: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyCenter', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifycenter, null);
                this._trigger("execute", { commandName: "JustifyCenter" });
            }
        },

        _onJustifyFull: function () {
            this._alignFlag = true;
            if (this._isIE8())
                this.executeCommand('justifyfull');
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyfull, null);
                this._trigger("execute", { commandName: "justifyfull" });
            }
        },

        _onCut: function () {
            var args;
            this.executeCommand('cut', args);
        },
        _onCopy: function () {
            var args;
            this.executeCommand('copy', args);
        },
        _onOpen: function () {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            window.open($(selectNode).attr('href'));
        },
        _onPaste: function () {
            var args;
            this.executeCommand('paste', args);

        },
        _onOrderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "OL" && $(_listSelect).parents("ol").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "OL" || $(_listSelect).parents("ol").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listOrderType == "none"))
                this.executeCommand('insertorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ol").length >= 0) e.ID = this._listOrderType;
            if (!ej.isNullOrUndefined(e.ID)) var orderParent = ($(_listSelect).prop("tagName") == "OL") ? _listSelect : $(_listSelect).parents("ol");
            this._generateListItems(e, orderParent, !ej.isNullOrUndefined(this.model.tools["customOrderedList"]) ? this.model.tools["customOrderedList"] : []);
            this._listOrderType = e.ID;
            this._updateIndent(_listSelect);
        },
        _onUnorderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "UL" && $(_listSelect).parents("ul").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "UL" || $(_listSelect).parents("ul").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listType == "none"))
                this.executeCommand('insertunorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ul").length >= 0) e.ID = this._listType;
            if (!ej.isNullOrUndefined(e.ID)) var unOrderParent = ($(_listSelect).prop("tagName") == "UL") ? _listSelect : $(_listSelect).parents("ul");
            this._generateListItems(e, unOrderParent, !ej.isNullOrUndefined(this.model.tools["customUnorderedList"]) ? this.model.tools["customUnorderedList"] : []);
            this._listType = e.ID;
            this._updateIndent(_listSelect);
        },
        _generateListItems: function (e, list, template) {
            $(list).css({ "list-style-type": e.ID, "list-style-image": "" });
            var proxy = this;
            if (["none", "disc", "circle", "square", "decimal", "upper-roman", "lower-roman", "upper-alpha", "lower-alpha"].indexOf(e.ID) == -1)
                $.each(template, function (i, val) {
                    if (val["name"] == e.ID) $(list).css({ "list-style-type": val["listStyle"], "list-style-image": val["listImage"] });
                });
            this._setBackupData();
            (this._isIE()) ? this.selectRange(this._pasteRangeVal) : this.selectRange(this._getRange());
            this._updateTagInfo((this._isIE()) ? this._currentSelNode : this._getSelectedNode());
        },
        _onUndo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('undo', null);
            else
                this._undo();
        },
        _onDelete: function () {
            var args;
            this.executeCommand('delete', null);
        },

        _onRedo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('redo', null);
            else
                this._redo();
        },

        _onClearFormat: function () {
            var args;
            this.executeCommand('removeformat', args);
            this._hideTooltip();
            this._setBackupData();
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateToolbarStatus();
        },

        _onFormatBlock: function (formatBlock) {
            this._focus();
            if (this._isIE8()) {
                var selection, range, node;
                node = document.getSelection ? this._getSelectedNode() : this._getWindow().document.selection.createRange().parentElement();
                this._onClearFormat();
                this.executeCommand('formatBlock', formatBlock);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.formatblock, formatBlock);
                this._trigger("execute", { commandName: "formatBlock" });
            }

            
            this._updateToolbarStatus();
            this._updateFontOptionStatus();

        },

        _onFontName: function (fontsname) {
            if ((this._isIE8()))
                this.executeCommand("fontName", fontsname);//backColor,fontName,fontSize,foreColor
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontname, fontsname);
                this._trigger("execute", { commandName: "fontName" });
            }
        },

        _onFontSize: function (Size) {
            if ((this._isIE8()))
                this.executeCommand('fontSize', Size);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontsize, Size);
                this._trigger("execute", { commandName: "fontSize" });
            }
        },

       _onFontColor: function (color) {
	         this._fontColorSplit.find("span.e-btntxt").css("background-color", color);
		     if(this._customDialogobj&&this._customDialogobj.isOpen())
			    this._customColor.ejDialog("close");
             if (this._isIE8())
                this.executeCommand('foreColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.forecolor, color);
                this._trigger("execute", { commandName: "foreColor" });
            }
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
        },

       _onBGColor: function (color) {
	        this._bgColorSplit.find("span.e-btntxt").css("background-color", color);
		    if(this._customDialogobj&&this._customDialogobj.isOpen())
               this._customColor.ejDialog("close");	 
            if (this._isIE8())
                this.executeCommand('backColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, color);
                this._trigger("execute", { commandName: "backColor" });
            }
            this._onChange();
        },

        _onIndent: function () {
            if (this._isIE8()) {
                this._getWindow().document.body.style.wordWrap = "break-word";
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listIndent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listIndent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('indent', false);

                node && $(node).focus();
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.indent, null);
                this._trigger("execute", { commandName: "indent" });
            }

            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateIndentStatus();
        },

        _onOutdent: function () {
            if (this._isIE8()) {
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listOutdent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listOutdent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('outdent', false);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.outdent, null);
                this._trigger("execute", { commandName: "outdent" });
            }
            this._updateIndentStatus();
        },

        _onSelectAll: function () {
            this.executeCommand('selectall');
        },
        selectAll: function () {
            this._onSelectAll();
        },
        _onHyperLink: function (val) {
            this.executeCommand('createlink', val);
        },

        _onInsertLink: function () {
            var oEl, sHtml;
            if (!this._isUrl($.trim(this._txtURL.val()))) {
                this._txtURL.addClass("e-error");
                return false;
            }
            var selectedNode = ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
            if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                selectedNode.href = this._txtURL.val();
                selectedNode.title = this._txtLinkTitle.val();
                selectedNode.innerHTML = this._txtLinkText.val();
                (this._chkTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "";
            }
            else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                var parentNode = $(selectedNode).parent('a')[0];
                if (ej.isNullOrUndefined(parentNode)) {
                    oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                    (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";
                    $(selectedNode.outerHTML).appendTo($(oEl));
                    $(selectedNode).replaceWith($(oEl));
                } else {
                    parentNode.href = this._txtURL.val();
                    parentNode.title = this._txtLinkTitle.val();
                    (this._chkTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "";
                }
            }
            else {
                oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";

                var oSelection;
                var oSelRange;
                this._focus();
                if (this._isIE()) {
                    if (this._selectedHTML.length == 0) {
                        if (this._txtLinkText.val() === "") this._selectedHTML = this._txtURL.val();
                        else this._selectedHTML = this._txtLinkText.val();
                    }
                    oEl[0].innerHTML = this._selectedHTML;
                    sHtml = oEl[0].outerHTML;
                }
                else {
                    if (this._txtLinkText.val() === "") oEl.html(this._txtURL.val());
                    else oEl.html(this._txtLinkText.val());
                    sHtml = $('<div>').append($(oEl).clone()).html();
                }
                if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                    this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                    this.selectRange(this._getRange());
                }
            }
            this._linkDialog.ejDialog("close");
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },

        _setImageProperties: function (imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor) {
            if (this.model.showDimensions) {
                (imgX != "") && (imgEle[0].width = imgX);
                (imgY != "") && (imgEle[0].height = imgY);
            }

            imgEle = $(imgEle).attr('style', imageStyle);

            var border = borderPx + "px ";
            (!ej.isNullOrUndefined(borderStyle) && borderStyle != "") ? border += borderStyle + " " : border += "solid ";
            (!ej.isNullOrUndefined(borderColor) && borderColor != "") ? border += borderColor : border += "#000000";
            imgEle = imgEle.css('border', border);
        },
        _onInsertImage: function () {
            var url = this._imgDialog.find(".e-rte-imgUrl");
            var altText = this._imgDialog.find(".e-rte-imgText");
            var imgX = this._imgDialog.find(".e-rte-imgX").val();
            var imgY = this._imgDialog.find(".e-rte-imgY").val();
            var proxy = this;
            this._restoreSelection(this._selectionRange);
            var element, border, nodeName = "", imageLink = proxy._imageLink.val(), borderPx = proxy._imageBorderPx.getValue(), borderStyle = proxy._imageBorderStyle.getSelectedValue(), borderColor = proxy._imgPicker.getValue(), imageStyle = proxy._imageStyle.val();
            var selectedNode = (proxy._isIE()) ? proxy._currentSelNode : proxy._getSelectedNode();
            (!ej.isNullOrUndefined(selectedNode)) && (nodeName = selectedNode.nodeName.toUpperCase());
            borderColor = !ej.isNullOrUndefined(borderColor) && borderColor.length > 0 ? borderColor : "";
            var srcUrl = (url.val().startsWith("~")) ? url.val().replace(url.val().substr('0', '1'), "..") : url.val();
            if (nodeName != 'IMG') {
                //Url Validation
                var _img = $("<img>", {
                    src: srcUrl,
                    error: function () { url.addClass("e-error"); },
                    success: function () {
                        var imgEle = ej.buildTag("img", "", {}, { alt: altText.val(), src: srcUrl });
                        proxy._setImageProperties(imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                        if (imageLink != "") {
                            if (proxy._isUrl($.trim(imageLink))) {
                                var link = ej.buildTag("a", "", {}, { href: imageLink });
                                (proxy._dialogchkTarget.ejCheckBox("isChecked")) ? link[0].target = "_blank" : link[0].target = "_self";
                                $(imgEle[0].outerHTML).appendTo(link);
                                imgEle = link;
                            }
                            else {
                                proxy._imageLink.addClass("e-error");
                                return false;
                            }
                        }
                        var element = imgEle[0].outerHTML;
                        proxy.executeCommand('inserthtml', element);
                    }
                });
            }
            else {
                selectedNode.src = srcUrl;
                selectedNode.alt = altText.val();
                proxy._setImageProperties($(selectedNode), imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                var linkNode = $(selectedNode).parent('a');
                if (imageLink != "") {
                    if (proxy._isUrl($.trim(imageLink))) {
                        if (linkNode.length > 0)
                            linkNode.attr('href', imageLink);
                        else {
                            var linkNode = ej.buildTag("a", "", {}, { href: imageLink });
                            $(selectedNode.outerHTML).appendTo(linkNode);
                            $(selectedNode).replaceWith(linkNode);
                        }
                    }
                    else {
                        proxy._imageLink.addClass("e-error");
                        return false;
                    }
                }
                else 
                    (linkNode.length > 0) && (linkNode.attr('href', ""));
                if (!ej.isNullOrUndefined(linkNode) && linkNode.length > 0)
                    (this._dialogchkTarget.ejCheckBox("isChecked")) ? linkNode[0].target = "_blank" : linkNode[0].target = "_self";
            }
            proxy._setAutoHeight();
            if (!proxy._imageLink.hasClass("e-error")) proxy._imgDialog.ejDialog("close");
            proxy._on(proxy._imageLink, "keypress", proxy._urlValidation)._on(proxy._imageLink, "blur", proxy._urlValidation);
        },

        _insertVideo: function (sender) {
            var videoLink = $.trim(this._videoDialog.find("textarea.e-rte-video")[0].value);
            var videoX = this._videoDialog.find(".e-rte-videoX").val();
            var videoY = this._videoDialog.find(".e-rte-videoY").val();
            this._restoreSelection(this._selectionRange);
            this._alertHeader(this);
            if (sender.target.id === "video_insert" && videoLink !== "") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                var ele = $(videoLink)[0];
                if (this.model.showDimensions && !ej.isNullOrUndefined(ele)) {
                    (videoX != "") && (ele.width = videoX);
                    (videoY != "") && (ele.height = videoY);
                }
                if (!ej.isNullOrUndefined(ele) && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)))
                    this.executeCommand('inserthtml', ele.outerHTML + "<br/>");

                this._onChange();
                this._setBackupData();
                this._videoDialog.ejDialog("close");
            }
            else if (sender.target.id === "video_cancel") {
                this._videoDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else
                this._openAlert(this._getLocalizedLabels("videoError"));
            this._videoDialog.find("textarea.e-rte-video")[0].value = "";
            this._videoDialog.find(".e-rte-videoX").val("");
            this._videoDialog.find(".e-rte-videoY").val("");
            this._chkvideoDimensions.ejCheckBox({ check: true });
            this._setAutoHeight();
        },

        _oneditTable: function () {
            //var selectedNode = this._currentSelNode;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectedNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            var parentTable = $(selectedNode).closest('tbody').closest('table');
            var captionEle = $($(selectedNode).closest('tbody')).prev('caption');
            (this._eTblCaption.ejCheckBox("isChecked")) ? (captionEle.length == 0) && ej.buildTag('caption').append($('<br type="_moz">')).insertBefore($($(selectedNode).closest('tbody'))) : (captionEle.length > 0) && captionEle.remove();
            var tblAlign = this._eTblAlign.getSelectedValue();
            var style = this._getTableObj("Style").val();
            style = style.replace((tblAlign == 'center') ? /float(.*?);/ig : /margin(.*?);/ig ,"");
            if (tblAlign == 'center') style += ";margin: 0 auto;";
            (style) && parentTable.attr('style', style);
            this._customTableValidation = false;
            var tableWid = this._customInputValidation(this._getTableObj("Width"));
            var tableHgt = this._customInputValidation(this._getTableObj("Height"));
            var rowHgt = this._customInputValidation(this._getTableObj("RHeight"));
            var cellWid = this._customInputValidation(this._getTableObj("ClWidth"));
            var borderSpa = this._getTableObj("CellSpace").data('ejNumericTextbox').getValue();
            var cellPad = this._getTableObj("CellPad").data('ejNumericTextbox').getValue();
            if (!this._customTableValidation) {
                parentTable.css({
					'width':isNaN(Number(tableWid))?tableWid:tableWid+"px",
                    'height': isNaN(Number(tableHgt))?tableHgt:tableHgt+"px",
                    'border-spacing': isNaN(Number(borderSpa))?borderSpa:borderSpa+"px",
                    'float': tblAlign,
                    'border-width': this._getTableObj("BrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("_border_style").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("_border_color").val()
                });
                parentTable.find("td,th").css("padding",isNaN(Number(cellPad))?cellPad:cellPad+"px");
                var parentRow = $(selectedNode).closest('tr');
                parentRow.attr({
                    style: this._getTableObj("RStyle").val()
                }).css({
                    'height': isNaN(Number(rowHgt))?rowHgt:rowHgt+"px",
                    'text-align': this._getTableObj("RAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("RBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("RBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("RBrdrColor").val()
                });
                $(selectedNode).attr({
                    style: this._getTableObj("ClStyle").val()
                }).css({
                    'width': isNaN(Number(cellWid))?cellWid:cellWid+"px",
                    'text-align': this._getTableObj("ClAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("ClBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("ClBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("ClBrdrColor").val()
                });
                this._eTblDialog.ejDialog("close");
            }
            this._on(this._getTableObj("Width"), "keypress", this._urlValidation)
				._on(this._getTableObj("Height"), "keypress", this._urlValidation)
				._on(this._getTableObj("RHeight"), "keypress", this._urlValidation)
				._on(this._getTableObj("ClWidth"), "keypress", this._urlValidation);
        },


        _clearAllManager: function () {
            this._hideTooltip();
            this._alertWindow.find(".e-alert-cancel").show();
            this._alertHeader(this);
            this._openAlert(this._getLocalizedLabels("deleteAlert"));
        },

        _onUnlink: function () {
            var args;
            this.executeCommand('unlink', args);
            this.disableToolbarItem("removeLink");
        },
        _onSuperScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SuperScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.superscript, null);
                this._trigger("execute", { commandName: "SuperScript" });
            }
        },
        _onSubScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SubScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.subscript, null);
                this._trigger("execute", { commandName: "SubScript" });
            }
        },
        _onInsertTable: function (rows, cols, designTime) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                $(this._getDocument().body).css("display", "inline-block");
                var tableEle = this._tableGenerator(rows, cols, designTime);
                this.executeCommand('inserthtml', tableEle);
                if ((ej.isNullOrUndefined($(this._getDocument().body).find("table:last")[0].nextSibling)) || ($(this._getDocument().body).find("table:last")[0].nextSibling.nodeName.toLowerCase() == "#text" && $.trim($(this._getDocument().body).find("table:last")[0].nextSibling.nodeValue) == "\n"))
                    $("<p><br/></p>").insertAfter($(this._getDocument().body).find("table"))
                $(this._getDocument().body).css("display", "");
                this._setAutoHeight();
            }
        },

        _onUpperCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toLowerCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toUpperCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents()
                        var result = this._changeCase(contents, "Upper");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toUpperCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.uppercase, null);


            this._trigger("execute", { commandName: "uppercase" });
        },

        _changeCase: function (parentNode, toChangeCase) {
            var s = parentNode.childNodes;
            if (s.length > 0) {
                for (var t = 0; t < s.length; t++) {
                    if (s[t].nodeType == 3) {
                        s[t].nodeValue = toChangeCase == "Upper" ? s[t].nodeValue.toUpperCase() : s[t].nodeValue.toLowerCase();
                    }
                    else {
                        if (s[t].nodeType == 1 && s[t].tagName.toUpperCase() != "FONT") {
                            this._changeCase(s[t], toChangeCase);
                        }
                    }
                }
            }
            return s;
        },


        _onLowerCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toUpperCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toLowerCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents();
                        var result = this._changeCase(contents, "Lower");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toLowerCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.lowercase, null);
            //execCommand=emphasize-contentformat-indent-contentalignment-formatblock-captionconvertion
            this._trigger("execute", { commandName: "lowercase" });
        },

        _listIndent: function (node, selection) {
            var sibling, newList;
            sibling = node.previousSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.appendChild(node);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(sibling.lastChild)) {
                sibling.lastChild.appendChild(node);
                this._combineLists(node.lastChild, sibling.lastChild, node);
                return true;
            }
            sibling = node.nextSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.insertBefore(node, sibling.firstChild);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(node.lastChild)) {
                return false;
            }
            sibling = node.previousSibling;
            if (sibling && sibling.nodeName == 'LI') {
                newList = ej.buildTag(node.parentNode.nodeName)[0];
                sibling.appendChild(newList);
                newList.appendChild(node);
                this._combineLists(node.lastChild, newList, node);
                return true;
            }
            return true;
        },

        _combineLists: function (from, to, li) {
            var node;
            if (this._isListNode(from)) {
                while ((node = li.lastChild.firstChild)) {
                    to.appendChild(node);
                }
                $(from).remove();
            }
        },
        _isListNode: function (node) {
            return node && (/^(OL|UL)$/).test(node.nodeName);
        },
        _isFirstChild: function (node) {
            return node.parentNode.firstChild == node;
        },

        _isLastChild: function (node) {
            return node.parentNode.lastChild == node;
        },
        _removeEmptyList: function (node) {
            if (node && $(node).children().length === 0)
                $(node).remove();
        },
        _listOutdent: function (node) {
            var ul = $(node.parentNode), ulParent = ul[0].parentNode, newBlock;
            node = $(node);
            if (this._isFirstChild(node[0]) && this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    this._removeEmptyList(ulParent);
                    ul.remove();
                } else if (this._isListNode(ulParent)) {
                    ul.remove();
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isFirstChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    node[0].appendChild(ul[0]);
                    this._removeEmptyList(ulParent);
                } else if (this._isListNode(ulParent)) {
                    ulParent.insertBefore(node[0], ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                } else if (this._isListNode(ulParent)) {
                    node.insertAfter(ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }
                return true;
            } else {
                this.executeCommand('outdent', false);
            }
            return false;
        },
        _updateIndent: function (node) {
            if (!ej.isNullOrUndefined(this._toolBarObj)) {
                if ($("#" + this._rteId + "_" + "indent").hasClass('e-disable')) this._toolBarObj.enableItemByID(this._rteId + "_" + "indent");
                if (node && (/^(LI)$/).test(node.nodeName)) {
                    if ($(node).parents(node.parentNode.nodeName).last().find("li").index(node) === 0)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "indent");
                }
            }
        },
         _updateCount: function () {
            if (!ej.isNullOrUndefined(this.model)) {
                if (this.model.showFooter && this.model.showWordCount)
				{
                   this._wordCount.html(this._getLocalizedLabels("words") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
				  if(this._rteFooter.width()<400)
				  this._wordCount.html(this._getLocalizedLabels("w") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
					}
				
                if (this.model.showFooter && this.model.showCharCount)
				{
                    this._charCount.html(this._getLocalizedLabels("characters") + " : " + this._getText().length);
					if(this._rteFooter.width()<400)
					this._charCount.html(this._getLocalizedLabels("c")+ " : " + this._getText().length);
					}
            }
        },
        _updateTagInfo: function (element) {
            var text = "", pTag, count = 1;
            if (!ej.isNullOrUndefined(element))
                if (element.localName == "body" || element.localName == "html")
                    element = this._getSelectedNode();
            if (ej.isNullOrUndefined(element)) this._curNode = "";
            else this._curNode = element.tagName ? element.tagName.toLowerCase() : "html";
            if (this.model.showFooter && this.model.showHtmlTagInfo) {
                if (this._curNode != "html" && this._curNode !== "") {
                    var parentNodes = $(element).parents();
                    for (var i = parentNodes.length - 1; i >= 0; i--) {
                        pTag = parentNodes[i].tagName.toLowerCase();
                        if (pTag != "html")
                            text += " » " + pTag;
                        else count++;
                    }
                    text += " » " + this._curNode;
                    if ($(element).parents().length > 0) {
                        if (!ej.isNullOrUndefined(parentNodes[parentNodes.length - count]))
                            this._pTag = parentNodes[parentNodes.length - count].tagName.toLowerCase();
                    }
                }
                this._tags = text;
                this._responsiveTagList();
            }
        },
        _responsiveTagList: function () {
            $(this._htmlInfo).html(this._tags);
            if ($(this._rteWapper).outerWidth() < $(this._rteWapper).find('.e-rte-footer-left').outerWidth() + $(this._rteWapper).find('.e-rte-footer-right').outerWidth())
                $(this._htmlInfo).html(" » " + this._pTag + " » ... ...  » " + this._curNode);
            else $(this._htmlInfo).html(this._tags);
        },
		_removeNoSpaceChar:function(data){
			data &&(data=data.replace(/[\uFEFF]/g,""));
			return data
		},
        _updateValue: function () {
            var updatedval = this._removeNoSpaceChar(this._updateXhtml());
            if (this.model.enableHtmlEncode)
                updatedval = this._encode(this._decode(updatedval));
            if((!this._getCommandStatus("bold") && !this._getCommandStatus("italic") && !this._getCommandStatus("underline")) || $.trim(this.value()) !== this._removeNoSpaceChar(this.getText()))
                this.value(updatedval);
            this.element.val(updatedval);
        },
        _imageXhtml: function (imgVal) {
            var imgRegexp = /<img(.*?)>/ig;
            var imgTemp;
            var j = 0;
            var imgDup = new Array();
            while ((imgTemp = imgRegexp.exec(imgVal)) !== null) {
                imgDup.push(imgTemp[0].toString());
            }
            var imgEx = new Array();
            imgEx = imgDup.slice(0);
            for (var i = 0; i < imgDup.length; i++) {
                if (imgDup[i].indexOf("/") == -1) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
                else if (imgDup[i].lastIndexOf("/") != imgDup[i].length - 2) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 1) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
            }
            var altReg = /(alt)=("[^"]*")/i;
            var srcReg = /(src)=("[^"]*")/g;
            var altRegS = /(alt)=('[^"]*')/i;
            var srcRegS = /(src)=('[^"]*')/g;
            for (var i = 0; i < imgDup.length; i++) {
                var temp = ej.isNullOrUndefined(altReg.exec(imgDup[i])) ? altRegS.exec(imgDup[i]) : altReg.exec(imgDup[i]);
                var dup = ej.isNullOrUndefined(srcReg.exec(imgDup[i])) ? srcRegS.exec(imgDup[i]) : srcReg.exec(imgDup[i]);
                var srcVar = ej.isNullOrUndefined(imgDup[i].match(srcReg)) ? imgDup[i].match(srcRegS) : imgDup[i].match(srcReg);
                var altVar = ej.isNullOrUndefined(imgDup[i].match(/(alt)=("[^"]*")/g)) ? imgDup[i].match(/(alt)=('[^"]*')/g) : imgDup[i].match(/(alt)=("[^"]*")/g);
                if (temp == null && altVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " alt=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = altVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(altVar[j], "");
                    }
                }
                if (dup == null && srcVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " src=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = srcVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(srcVar[j], "");
                    }
                }
            }
            for (var g = 0; g < imgDup.length; g++) {
                imgVal = imgVal.replace(imgEx[g], imgDup[g]);
            }
            return imgVal;
        },
        _tagCssReplace: function (styleTag, styleDup, styleRegval) {
            var tagStyle = /(style)=("[^"]*")/i;
            var tagCss = tagStyle.exec(styleDup);
            if (tagCss != null) {
                var cssTag = tagCss[0];
                if (styleTag != "")
                    cssTag = cssTag.substr(0, cssTag.length - 1) + styleTag + ";\"";
                if (!ej.isNullOrUndefined(styleTag))
                    styleDup = styleDup.replace(styleRegval[0], "").replace(tagCss[0], cssTag);
                return styleDup;
            }
        },
        _updateIndentStatus: function () {
            if (this._isIE8())
                ($(this._getSelectedNode()).closest("BLOCKQUOTE").length > 0) ? this.enableToolbarItem("outdent") : this.disableToolbarItem("outdent");
            else {
                if (this._getDocumentHandler() && this._operationHandler._validateIndent(this._getRange().startContainer))
                    this.enableToolbarItem("outdent");
                else
                    this.disableToolbarItem("outdent");
            }

        },
        _replaceHeightWidth: function (htmlTagreg, styleDup) {
            var styleRegval = htmlTagreg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":");
            }
            return (this._tagCssReplace(styleTag, styleDup, styleRegval));
        },
        _typeXhtmlValidation: function (styleDup) {
            var styleTag = styleRegval[0];
            if (styleTag == "type=\"a\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("a", "lower-alpha");
            else if (styleTag == "type=\"A\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("A", "upper-alpha");
            else if (styleTag == "type=\"1\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("1", "decimal");
            else if (styleTag == "type=\"i\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("i", "lower-roman");
            else if (styleTag == "type=\"I\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("I", "upper-roman");
            else
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type");
        },
        _getCssXhtml: function (tagReg, styleDup) {
            var styleRegval = tagReg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "text-align").replace("align", "text-align");
                styleDup = styleDup.replace(styleRegval[0], "style=\"" + styleTag + ";\"");
            }
            return styleDup;
        },
        _styleXhtml: function (styleVal) {
            var styleRegex = /<((?:(?!\/)).)*?>/ig;
            var styleTemp;
            var k = 0;
            var styleDup = new Array();
            var arr = new Array();
            while ((styleTemp = styleRegex.exec(styleVal)) !== null) {
                styleDup.push(styleTemp[0].toString());
            }
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                if (styleDup[i].indexOf("style=") != -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /( height)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /( width)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        var styleRegval = typeTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval))
                            var styleTag = this._typeXhtmlValidation(styleDup[i]);
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /( valign)=("[^"]*")/i;
                        var styleRegval = valignTag.exec(styleDup[i]);
                        var styleTag = styleRegval[0];
                        if (styleDup[i].indexOf("vertical-align:") != -1)
                            styleTag = "";
                        else
                            styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "vertical-align");
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /( align)=("[^"]*")/i;
                        var styleRegval = alignTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval)) {
                            var styleTag = styleRegval[0];
                            if (styleDup[i].indexOf("text-align:") != -1)
                                styleTag = "";
                            else
                                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("align", "text-align");
                        }
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                }
                if (styleDup[i].indexOf("style=") == -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /(height)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /(width)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(typeTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /(valign)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(valignTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /(align)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(alignTag, styleDup[i]);
                    }
                }
            }
            for (var i = 0; i < styleDup.length; i++) {
                styleVal = styleVal.replace(styleEx[i], styleDup[i]);
            }
            return styleVal;
        },
        _getFormatXhtml: function (startRegex, startVal) {
            var startDup = new Array();
            var j = 0;
            var startTemp;
            while ((startTemp = startRegex.exec(startVal)) != null) {
                startDup.push(startTemp[0]);
            }
            for (var i = 0; i < startDup.length; i++) {
                startVal = startVal.replace(startDup[i], "");
            }
        },
        _startXhtml: function (startVal) {
            if (startVal.indexOf("start=") != -1) {
                var startRegex = /start=\"(.*?)\"/ig;
                startVal = this._getFormatXhtml(startRegex, startVal);
            }
            return startVal;
        },
        _fontXhtml: function (fontVal) {
            if (fontVal.indexOf("<font") != -1) {
                var fontRegex = /<font(.*?)>/ig;
                fontVal = this._getFormatXhtml(fontRegex, fontVal);
            }
            return fontVal;
        },
        _filerXhtmlNode: function (tableRegex, xhtmlVal) {
            var dupArray = new Array();
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                dupArray.push(tableTemp[0]);
            }
            return dupArray;
        },
        _replaceXhtmlNode: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _tdXhtml: function (xhtmlVal) {
            var tableRegex = /<td((?:(?!<\/td>).))*?<td/ig;
            var tableDup = new Array();
            tableDup = this._filerXhtmlNode(tableRegex, xhtmlVal);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var z = tableDup[i].lastIndexOf("<td");
                tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
            }
            xhtmlVal = this._replaceXhtmlNode(tableDup, xhtmlVal, tableEx);
            return xhtmlVal;
        },
        _ptagXhtml: function (htmlText) {
            var ptagRegex1 = /<\/p>((?:(?!<p).))*<\/p>/ig;
            var pTemp1;
            var pEx = new Array();
            if ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                while ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                    pEx.push(pTemp1[0]);
                }
            }
            var ptagEx = new Array();
            ptagEx = pEx.slice(0);
            for (var i = 0; i < pEx.length; i++) {
                if (pEx[i].indexOf("<p") == -1)
                    pEx[i] = pEx[i].substr(0, pEx[i].length - 4);
            }
            for (var i = 0; i < pEx.length; i++) {
                htmlText = htmlText.replace(ptagEx[i], pEx[i]);
            }
            return htmlText;
        },
        _getUpdaeNodeXhtml: function (tableRegex, xhtmlVal, tableDup) {
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                tableDup.push(tableTemp[0]);
            }
            return tableDup;
        },
        _replaceUpdateXhtml: function (tableRegex, xhtmlVal, value) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableDup[i], value);
            }
            return xhtmlVal;
        },
        _replaceXhtmlVal: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _replaceTagUpdateXhtml: function (tagRegex, xhtmlVal, value1, value2) {
            var tempArray = new Array();
            tempArray = this._getUpdaeNodeXhtml(tagRegex, xhtmlVal, tempArray);
            var tempEx = new Array();
            tempEx = tempArray.slice(0);
            tempArray[0] = value1 + tempArray[0] + value2;
            return xhtmlVal.replace(tempEx[0], tempArray[0]);
        },
        _replaceTagXHTML: function (styleRegex, xhtmlVal) {
            var styleDup = new Array();
            styleDup = this._getUpdaeNodeXhtml(styleRegex, xhtmlVal, styleDup);
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                styleDup[i] = styleDup[i].replace(/<br\/>/gi, "");
            }
            return this._replaceXhtmlVal(styleDup, xhtmlVal, styleEx);
        },
        _replaceInputParams: function (inputRegex, xhtmlVal) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(inputRegex, xhtmlVal, tableDup);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var divInndex = tableDup[i].indexOf(">");
                tableDup[i] = tableDup[i].substr(0, divInndex) + "/" + tableDup[i].substr(divInndex, tableDup[i].length - 1);
            }
            return this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
        },
        _updateXhtml: function () {
            var updateVal = this._getDocument().body.innerHTML;
            if (this.model.enableXHTML) {
                updateVal = updateVal.replace(/hhh/g, "").replace(/<br>/g, "<br/>").replace(/contenteditable="false"/g, "").replace(/contenteditable="true"/g, "").replace(/&nbsp;/g, " ").replace(/<hr>/g, "<hr/>").replace(/cellspacing =[0-9]/g, "").replace(/cellpadding  =[0-9]/g, "");
                this.value(updateVal);
                this._xhtmlTagValidation();
                updateVal = this.value();
                var xhtmlVal = updateVal.replace(/\s+/g, ' ').replace(/> </gi, "><");
                if (xhtmlVal.indexOf("<?xml") != -1) {
                    var xmlRegexp = /<?xml:(.*?)>/ig;
                    var xmlDup = new Array();
                    var k = 0;
                    while ((xmlTemp = xmlRegexp.exec(xhtmlVal)) != null) {
                        var j = xhtmlVal.indexOf("<?xml");
                        xmlDup[k] = xmlTemp[0];
                        xmlDup[k] = xhtmlVal.substr(j, xmlDup[k].length + 2);
                        xhtmlVal = xhtmlVal.replace(xmlDup[k], "");
                        k++;
                    }
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    //tabletag
                    var tableRegex = /<table(.*?)<\/table>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        tableDup[i] = tableDup[i].replace(/<p>/gi, "").replace(/<\/p>/gi, "");
                        if (tableDup[i].indexOf("<p") != -1) {
                            for (var k = 0; k < tableDup[i].length; k++) {
                                var divInndex = tableDup[i].indexOf("<p");
                                var t = 0;
                                if (divInndex != -1) {
                                    for (var j = divInndex + 4; j < tableDup[i].length - 7; j++) {
                                        if (tableDup[i].charAt(j) == '>') {
                                            if (t == 0) {
                                                tableDup[i] = tableDup[i].substr(0, divInndex) + tableDup[i].substr(j + 1, tableDup[i].length - 1);
                                                t++;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //td tag
                if (xhtmlVal.indexOf("<td") != -1) {
                    for (var i = 0; i < 2; i++) {
                        xhtmlVal = this._tdXhtml(xhtmlVal);
                    }
                }
                //tr tag
                if (xhtmlVal.indexOf("<tr") != -1) {
                    var trtdRegex = /<tr(.*?)>(?!<\/td>)/ig;
                    var tabletrDup = new Array();
                    tabletrDup = this._getUpdaeNodeXhtml(trtdRegex, xhtmlVal, tabletrDup);
                    var tabletrEx = new Array();
                    tabletrEx = tabletrDup.slice(0);
                    for (var i = 0; i < tabletrDup.length; i++) {
                        if (tabletrDup[i].indexOf("</td>") != -1)
                            tabletrDup[i] = tabletrDup[i].replace("</td>", "");
                    }
                    xhtmlVal = this._replaceXhtmlVal(tabletrDup, xhtmlVal, tabletrEx);
                    var tableRegex = /<tr(.*?)<\/tr>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        var z = tableDup[i].lastIndexOf("</tr>");
                        var w = tableDup[i].charAt(z - 5) + tableDup[i].charAt(z - 4) + tableDup[i].charAt(z - 3) + tableDup[i].charAt(z - 2) + tableDup[i].charAt(z - 1);
                        if (w != "</td>") {
                            tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //input tag
                if (xhtmlVal.indexOf("<input") != -1) {
                    var inputRegex = /<input((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/input>/gi, "");
                }
                if (xhtmlVal.indexOf("<param") != -1) {
                    var inputRegex = /<param((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/param>/gi, "");
                }
                if (xhtmlVal.indexOf("<p ") != -1 || xhtmlVal.indexOf("<p>") != -1) {
                    var ptagRegex = /<p(.*)<\/p>/ig;
                    var pDup = new Array();
                    pDup = this._getUpdaeNodeXhtml(ptagRegex, xhtmlVal, pDup);
                    var pEx = new Array();
                    pEx.slice(0);
                    var r = pDup[0].length - 1;
                    var htmlText = pDup[0];
                    if (htmlText.indexOf("<p") != -1) {
                        for (var m = htmlText.indexOf("<p") ; m <= r; m++) {
                            var z = "";
                            var i = 0;
                            if (m < r - 3) {
                                z = htmlText.charAt(m) + htmlText.charAt(m + 1);
                            }
                            if (z == "<p") {
                                for (var s = m + 1; s <= r; s++) {
                                    var w;
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1) + htmlText.charAt(s + 2) + htmlText.charAt(s + 3)) == "</p>") {
                                        i++;
                                    }
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1)) == "<p") {
                                        if (i == 0) {
                                            if (htmlText.indexOf("<div") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<div") != -1) {
                                                    var divIn = divSplit.indexOf("<div");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5);
                                                        if (z == "</div>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 6)) + "<p><span>" + htmlText.substr(u + 6, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                        }
                                        if (i == 0) {
                                            if (htmlText.indexOf("<table") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<table") != -1) {
                                                    var divIn = divSplit.indexOf("<table");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5) + htmlText.charAt(l + 6) + htmlText.charAt(l + 7);
                                                        if (z == "</table>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 8)) + "<p><span>" + htmlText.substr(u + 8, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                            if (i == 0) {
                                                htmlText = htmlText.substr(0, s - 1) + "</p>" + htmlText.substr(s, htmlText.length - 1);
                                                r++;
                                                i++;
                                            }
                                        }
                                    }

                                }
                            }
                        }
                    }
                    htmlText = htmlText.replace(/<\/p><\/p>/gi, "</p>");
                    var pDupex = new Array();
                    pDupex = pDup.slice(0);
                    for (var i = 0; i < 2; i++) {
                        htmlText = this._ptagXhtml(htmlText);
                    }
                    var htmlRegex = /<p(.*?)<\/p>/ig;
                    var htmlDup = new Array();
                    htmlDup = this._getUpdaeNodeXhtml(htmlRegex, htmlText, htmlDup);
                    var htmlEx = new Array();
                    htmlEx.slice(0);
                    for (var j = 0; j < htmlDup.length; j++) {
                        if (htmlDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                        if (htmlDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                    }
                    htmlText = this._replaceXhtmlVal(htmlDup, htmlText, htmlEx);
                    xhtmlVal = xhtmlVal.replace(pEx[0], htmlText);
                }
                if (xhtmlVal.indexOf("<span") != -1) {
                    var spanRegex = /<span(.*?)<\/span>/ig;
                    //var spanTemp;                    
                    var spanDup = new Array();
                    spanDup = this._getUpdaeNodeXhtml(spanRegex, xhtmlVal, spanDup);
                    var spanEx = new Array();
                    sapnEX = spanDup.slice(0);
                    for (var j = 0; j < spanDup.length; j++) {
                        if (spanDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<p") != -1) {
                            var tagRegex = /<p(.*)<\/p>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(spanDup, xhtmlVal, spanEx);
                }
                if (xhtmlVal.indexOf("<ol") != -1) {
                    var styleRegex = /<ol(.*?)<\/ol>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    var styleRegex = /<table(.*?)><\/table>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("style") != -1) {
                    var styleRegex = /style="(.*?)"/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                //style tag 
                if (!ej.isNullOrUndefined(this._fontXhtml(xhtmlVal)))
                    xhtmlVal = this._fontXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("<br ") != -1 || xhtmlVal.indexOf("<br>") != -1) {
                    var htmlTagreg = /<br(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<br/>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1 || xhtmlVal.indexOf("<strong>") != -1) {
                    var htmlTagreg = /<strong((?:(?!r).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1) {
                    var htmlTagreg = /<strong (.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<u") != -1) {
                    var htmlTagreg = /<u((?:(?!l).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<span style=\"text-decoration: underline;\">").replace(/<\/u>/gi, "</span>");
                }
                if (xhtmlVal.indexOf("<hr") != -1) {
                    var htmlTagreg = /<hr(.*?)>/ig;
                    var htmlTagtemp = new Array();
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<hr/>");
                }
                if (!ej.isNullOrUndefined(this._startXhtml(xhtmlVal)))
                    xhtmlVal = this._startXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("v:shapes=") != -1) {
                    var htmlTagreg = /v:shapes=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("v:") != -1) {
                    var htmlTagreg = /<v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/v:") != -1) {
                    var htmlTagreg = /<\/v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("o:") != -1) {
                    var htmlTagreg = /<o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/o:") != -1) {
                    var htmlTagreg = /<\/o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("role=") != -1) {
                    var htmlTagreg = /role=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("target=") != -1) {
                    var htmlTagreg = /target=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("language=") != -1) {
                    var htmlTagreg = /language=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("lang=") != -1) {
                    var htmlTagreg = /lang=\"(.*?)\"/ig;
					var htmlTagtemp = new Array();
                    htmlTagtemp = this._getUpdaeNodeXhtml(htmlTagreg, xhtmlVal, htmlTagtemp);
                    var height3 = new Array();
                    height3 = htmlTagtemp.slice(0);
                    for (var i = 0; i < htmlTagtemp.length; i++) {
                        xhtmlVal = xhtmlVal.replace(height3[i], htmlTagtemp[i].toLowerCase());
                    }
                }
                xhtmlVal = xhtmlVal.replace(/<\/td><\/td>/gi, "</td>").replace(/<\/th><\/td>/gi, "</th>");
                xhtmlVal = (xhtmlVal == "" || /<div class="e-xhtml">/ig.test(xhtmlVal) ) ? xhtmlVal : "<div class='e-xhtml'>" + xhtmlVal + "</div>";
                updateVal = xhtmlVal.replace(/&quot;/g, "'").replace(/cellspacing=("[0-9]")/g, '').replace(/cellSpacing=("[0-9]")/g, '').replace(/cellpadding=("[0-9]")/g, '').replace(/cellPadding=("[0-9]")/g, '').replace(/border=("[^"]")/g, '').replace(/<!--(.*?)-->/gm, '').replace(/(vAlign)=("[^"]*")/g, "").replace(/(valign)=("[^"]*")/g, "").replace(/(colspan)=("[^"]*")/g, "").replace(/(colSpan)=("[^"]*")/g, "");
                this.value(updateVal);
            }
            return updateVal;
        },
        _setClearFormat: function () {
            var selItemslength = this._rteToolbar.find(".e-active").length;
        },
        //Updates the status of the toolbar items
        _updateToolbarStatus: function () {
            try {
                var _isAligned = false;
                if (this.model.showToolbar) {
                    //Style Tools
                    for (var i = 0; i < this._styleItems.length; i++) {
                        var rtestyleid= document.getElementById(this._rteId + "_" + this._styleItems[i]);
                        if (this._getCommandStatus($.trim(this._styleItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._styleItems[i]);
                             rtestyleid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._styleItems[i]);
                            rtestyleid.classList.remove("e-isactive");
                        }  
                        } 
                    for (var i = 0; i < this._alignItems.length; i++) {
                        if (this._getCommandStatus($.trim(this._alignItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._alignItems[i]);
                            _isAligned = true;
                        } else
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]); 
                } 
                    if (!_isAligned) this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft"); 
                    for (var i = 0; i < this._scriptsItems.length; i++) {
                         var rtescriptid= document.getElementById(this._rteId + "_" + this._scriptsItems[i]);
                         if (this._getCommandStatus($.trim(this._scriptsItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                             rtescriptid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                           rtescriptid.classList.remove("e-isactive");
                        }
                    } 
                     var rteorderid=document.getElementById(this._rteId + "_" + "orderedList"); 
                    var rteunorderid= document.getElementById(this._rteId + "_" + "unorderedList");
                    if (this._getCommandStatus('InsertOrderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.remove("e-isactive");
                    } if (this._getCommandStatus('InsertUnorderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.remove("e-isactive");
                    }
                
                   this._updateIndentStatus(); 
                }
            }
            catch (error) { }
        },

        _updateFormat: function () {
            try {
                if (this._formatDDL && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["formatStyle"])) {
                    var formatName = $.trim(this._getCommandValue('formatblock').replace(/'/g, ""));
                    if (!this._isIE())
                        formatName = "<" + formatName + ">"; 
                    if (this._formatDDL.hasClass('e-dropdownlist')) {
                        if (ej.isNullOrUndefined(formatName) || formatName == "")
                            this._formatDDL.ejDropDownList({ "value": this._getLocalizedLabels("format") });
                        else if (!$(this._formatDDL).parents("ul.e-rte-format").length == 0)
                            this._formatDDL.ejDropDownList("setSelectedValue", formatName);
                    }
                }
            }
            catch (error) { }
        },

        _updateFontOptionStatus: function () {
            try {
                if (this.model.showFontOption && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["font"])) {
                    var fontName = $.trim(this._getCommandValue('fontname').replace(/"/g, "").replace(/'/g, "").replace(/, /g, ","));
                    (ej.isNullOrUndefined(fontName) || fontName == "") && (fontName = "Segoe UI");
                    if (!ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass('e-dropdownlist') && !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontStyleDDL.ejDropDownList("setSelectedValue", fontName);

                    var fontSize = (this._isIE8()) ? this._getCommandValue('fontsize') : (this._getDocumentHandler() && this._operationHandler._validateFontSize(this._getRange().startContainer));
                    (ej.isNullOrUndefined(fontSize) || fontSize == "") && (fontSize = 2);
                    if (!ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass('e-dropdownlist') && !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontSizeDDL.ejDropDownList("setSelectedValue", fontSize);
                }
            }
            catch (error) { }
        },

        _getSelText: function () {
            var selectedtext = '';
            var selection;
            var textnode;
            if (!this._isIE()) {
                if (window.getSelection) {
                    selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    textnode = document.createTextNode(range.toString());
                    selectedtext = textnode.nodeValue;
                }
                else if (document.getSelection) {
                    selectedtext = this._getWindow().document.getSelection();
                }
            }
            else
                selectedtext = this._seleText;
            return selectedtext;
        },

        _isIE: function () {
            var _ie = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie') {
                _ie = true;
            }
            return _ie;
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },
        //Vaidate the input URL string
        _isUrl: function (url) {
            var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            return regexp.test(url);
        },
        _pasteHtml: function (html, textnodeType) {
            var sel, range;
            if (this._pasteAPIFlag) {
                if (this._isIE())
                    this._focus();
            }
            else
                this._focus();
            if (window.getSelection) {
                // IE9 and non-IE
                sel = this._getWindow().getSelection();
                if (sel.getRangeAt && sel.rangeCount) {
                    range = this._pasteFlag ? this._pasteRangeVal : sel.getRangeAt(0);
                    var cnode = range.commonAncestorContainer, parentElement, i, container;
                    parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                    for (i = parentElement.length - 1; i >= 0; i--) {
                        if (parentElement[i].textContent == range.toString() && parentElement[i].nodeName.toLowerCase() != "li") {
                            range.selectNode(parentElement[i]);
                            break;
                        }
                    }
                    range.deleteContents();
                    // some browsers (IE9, for one)
                    var el = document.createElement("div");
                    el.innerHTML = html;
                    var frag = this._getDocument().createDocumentFragment(), node, lastNode;
                    var parent = el.firstChild;
                    if (!(this._pasteFlag || this._pasteAPIFlag)) {
                        while ((node = el.firstChild)) {
                            lastNode = frag.appendChild(node);
                        }
                    }
                    else {
                        while ((node = el.firstChild)) {
                            if (parent != node)
                                lastNode = parent.appendChild(node);
                            else
                                el.removeChild(el.firstChild);
                        }
                        lastNode = frag.appendChild(parent);
                    }
                    range.insertNode(frag);
                    // Preserve the selection
                    if (lastNode && !textnodeType) {
                        range = range.cloneRange();
                        range.setStartAfter(lastNode);
                        range.collapse(true);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                    else {
                        range = this.createRange();
                        range.setStart(lastNode, lastNode.data.length);
                        range.setEnd(lastNode, lastNode.data.length);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                }
            } else if (this._getDocument().selection && this._getDocument().selection.type != "Control") {
                // IE < 9
                if (this._ieSelectionRange && !(this._ieSelectionRange.offsetLeft == 0 && this._ieSelectionRange.offsetTop == 0 && this._ieSelectionRange.boundingHeight == 0)) {
                    if (this._pasteFlag)
                        this.selectRange(this._pasteRangeVal);
                    var ieParentElement = this._ieParents(this._getRange()), i, isParent = false;
                    if (this._pasteAPIFlag)
                        this._getRange().pasteHTML(html);
                    else {
                        var text = this._getRange().text;
                        for (i = ieParentElement.length - 1; i >= 0; i--) {
                            if (ieParentElement[i].innerText == text && ieParentElement[i].nodeName.toLowerCase() != "li") {
                                ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML = html : ieParentElement[i].outerHTML = html;
                                isParent = true;
                                break;
                            }
                        }
                        if (!isParent)
                            this._getRange().pasteHTML(html);
                    }
                }
                else
                    this._getDocument().body.insertAdjacentHTML("afterBegin", html);
            }
            this._pasteAPIFlag = this._pasteFlag = false;
        },
        _ieParents: function (range) {
            var parentElement = [];
            rangeval = this._isIE8() ? range.duplicate() : range.cloneRange();
            range.parentElement = rangeval.parentElement();
            while (range.parentElement.nodeName != "HTML") {
                if (range.parentElement.nodeName == "TD" || range.parentElement.nodeName == "TH")
                    break;
                parentElement.push(range.parentElement);
                range = range.parentElement;
            }
            return parentElement;
        },

        _getLocalizedLabels: function (property) {
			return this._localizedLabels[property] === undefined ? ej.RTE.Locale["en-US"][property] : this._localizedLabels[property];
        },

        _setLocale: function () {
            for (var items in this._toolsList) {
                items = this._toolsList[items];
                var tipItems = this.model.tools[items]
                for (var i = 0; i < tipItems.length; i++) {
                    var liTag = $("#" + this._rteId + "_" + tipItems[i].replace(/ /g, ''));
                        liTag.attr('data-content', this._getLocalizedLabels(tipItems[i]));
                    if (tipItems[i] === "fullScreen") liTag.attr('data-content', this._getLocalizedLabels("maximize"));
                    else if (tipItems[i] === "findAndReplace")
                        liTag.attr('data-content', this._getLocalizedLabels("FindAndReplace"));
                }
            }
            this._createTable.find(".e-rte-createCustomTableLink .customtable-link").text(this._getLocalizedLabels("customTable"));
            this._createTable.find(".e-rte-createCustomTableLink .customtable-link").attr("title", this._getLocalizedLabels("customTable"));
            this._createTable.find(".e-rte-eTblProperties .customtable-link").text(this._getLocalizedLabels("editTable"));
            this._createTable.find(".e-rte-eTblProperties .customtable-link").attr("title", this._getLocalizedLabels("editTable"));
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
            this._alertWindow.find(".e-rte-btn.e-alert-ok").text(this._getLocalizedLabels("dialogOk")); 
            this._alertWindow.find(".e-rte-btn.e-alert-cancel").text(this._getLocalizedLabels("dialogCancel")); 
            this._toolBarItems.find(".customBGcolor a.customcolor-link").text(this._getLocalizedLabels("customBGColor"));
			this._toolBarItems.find(".customcolor a.customcolor-link").text(this._getLocalizedLabels("customFontColor"));
            if(!ej.isNullOrUndefined(this._bgTransparent))this._bgTransparent.text(this._getLocalizedLabels("TransBGColor"));
            if(!ej.isNullOrUndefined(this._htmlSource))this._htmlSource.attr('data-content', this._getLocalizedLabels("viewHtml"));
            if(!ej.isNullOrUndefined(this._clearFormat))this._clearFormat.attr('data-content', this._getLocalizedLabels("clearFormat")); 
            if(!ej.isNullOrUndefined(this._clearAll))this._clearAll.attr('data-content', this._getLocalizedLabels("clearAll"));
            if(this.model.showContextMenu){
            this._initContextMenu();
            var ContextMenutag = $("#" + this._rteId + "_contextmenu").data("ejMenu");
            ContextMenutag = this._textMenuObj;
            ContextMenutag.setModel({ fields: { dataSource: this._initContextMenu()} });
            }
            this._renderFormat();
            var ddl = $(this.wrapper).find(".e-ddl.e-widget .e-dropdownlist"), spbtn = $(this.wrapper).find(".e-split.e-widget .e-splitbutton");
            ddl.length && ddl.ejDropDownList({ height: "30px" });
            spbtn.length && spbtn.ejSplitButton({ height: '30px' }); 
        },

        _getSelectedNode: function () {
            var temp = this._getRange();
            var element, rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
            var startContainer = rng.startContainer, endContainer = rng.endContainer;
            var startOffset = rng.startOffset, endOffset = rng.endOffset;
            // if (!ej.isNullOrUndefined(rng.commonAncestorContainer))
            // if (rng.commonAncestorContainer.nodeName == "BODY")
            // this._tempEle = $(rng.commonAncestorContainer);
            // else if ($(rng.cloneContents()).text() == $($($(rng.startContainer).parents("li")).contents()[0]).text() && (startOffset == 0 && endOffset == $(rng.startContainer).parents("li").text().length) || startOffset == endOffset || startOffset == 0 && endOffset == 1)
            // this._tempEle = $($(rng.startContainer).parents("li"));
            // else if ((rng.commonAncestorContainer.nodeName == "OL") && startOffset != endOffset && endOffset != 0 && endOffset != 1)
            // this._tempEle = $(rng.commonAncestorContainer);
            // else
            // this._tempEle = $(rng.startContainer);
            if (!rng) {
                return this._getDocument().selection;
            }
            if (rng.setStart) {
                element = rng.commonAncestorContainer;
                //Image tage and link selection
                if (!rng.collapsed) {
                    if (startContainer == endContainer) {
                        if (endOffset - startOffset < 2) {
                            if (startContainer.hasChildNodes()) {
                                element = startContainer.childNodes[startOffset];
                            }
                        }
                    }
                    if (startContainer.nodeType === 3 && endContainer.nodeType === 3) {
                        if (startContainer.length === startOffset) {
                            startContainer = this._skipEmptyNode(startContainer.nextSibling, true);
                        } else {
                            startContainer = startContainer.parentNode;
                        }

                        if (endOffset === 0) {
                            endContainer = this._skipEmptyNode(endContainer.previousSibling, false);
                        } else {
                            endContainer = endContainer.parentNode;
                        }

                        if (startContainer && startContainer === endContainer) {
                            return startContainer;
                        }
                    }
                }

                if (element && element.nodeType == 3) {
                    return element.parentNode;
                }
                return element;
            }
            element = rng.item ? rng.item(0) : rng.parentElement();
            return element;
        },

        _skipEmptyNode: function (node, forwards) {
            var orig = node;
            while (node && node.nodeType === 3 && node.length === 0) {
                node = forwards ? node.nextSibling : node.previousSibling;
            }
            return node || orig;
        },

        _getSelection: function () {
            var selCurrent;
            if (this._isIE()) {
                selCurrent = this._getDocument().selection.createRange();
                selCurrent.type = this._getDocument().selection.type;
            }
            else {
                selCurrent = window.getSelection();
                if (selCurrent.rangeCount) {
                    sText = selCurrent.getRangeAt(0);
                }
                selCurrent.type = this._getWindow().getSelection().type;
            }
            return selCurrent;
        },

        _saveSelection: function () {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            var range;

            if (sel) {
                if (sel.createRange) {
                    range = sel.createRange();
                } else if (sel.rangeCount > 0 && sel.getRangeAt(0)) {
                    range = sel.getRangeAt(0);
                } else if (sel.anchorNode && sel.focusNode && doc.createRange) {
                    // Older WebKit browsers
                    range = doc.createRange();
                    range.setStart(sel.anchorNode, sel.anchorOffset);
                    range.setEnd(sel.focusNode, sel.focusOffset);
                    if (range.collapsed !== sel.isCollapsed) {
                        range.setStart(sel.focusNode, sel.focusOffset);
                        range.setEnd(sel.anchorNode, sel.anchorOffset);
                    }
                }
                else if (doc.createRange()) {
                    range = doc.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                else {
                    var iframe = document.getElementsByTagName("iframe")[0];
                    var win = iframe.contentWindow;
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
            }
            return range;
        },

        _restoreSelection: function (range) {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            if (sel && range) {
                if (range.select) {
                    range.select();
                } else if (sel.removeAllRanges && sel.addRange) {
                    sel.removeAllRanges();
                    sel.addRange(range);
                }
            }
        },

        _getRange: function () {
            if (this._isIE8()) {
                var temp = this._saveSelection();
                var rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
                return rng;
            }
            else if (this._isIE())
                //Table Aciton Not working in IE condition (this._selectionRange.length>0)
                return this._ieSelection = (window.getSelection && (ej.isNullOrUndefined(this._selectionRange) ? false : (this._selectionRange.length > 0))) ? this._selectionRange : this._saveSelection();
            else if (this._getWindow().getSelection() && this._getWindow().getSelection().rangeCount > 0)
                return this._getWindow().getSelection().getRangeAt(0);
            else {
                var iframe = document.getElementsByTagName("iframe")[0];
                var win = iframe.contentWindow;
                var range
                try {
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                catch (error) {
                    range = this._getDocument().createRange();
                    range.setStart(this._getDocument().body, 0);
                    range.setEnd(this._getDocument().body, 0);
                }
                return range;
            }
        },
        _setBackupData: function () {
            var htmlTxt = this.getHtml();
            var bkuplen = this._backupArray.length;
            var range =  this._getRange();
            var save = this._save(range, this.getDocument());
            var changeEle = {text: htmlTxt, range: save }
            if (bkuplen == this.model.undoStackLimit + 1)
                this._backupArray.splice(0, 1);
            if (htmlTxt != this._backupArray[bkuplen - 1] && this.model.undoStackLimit > 0)
                this._backupArray.push(changeEle);
            this._undoRedoPosition = this._backupArray.length - 1;
            if (this.model.showToolbar && this._rteToolbar.find("li.e-rteItem-undo") && this._backupArray.length > 1 && !$("#" + this._rteId + "_" + "undo").hasClass("e-rteTooldisable"))
                this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
        },
        _getSelectedHtmlString: function () {
            if (typeof document.selection != "undefined" && this._isIE8()) {
                var ieParentElement = this._ieParents(this._getRange()), i, isParent = false, html;
                for (i = ieParentElement.length - 1; i >= 0; i--) {
                    if (ieParentElement[i].innerText == this._getRange().text) {
                        html = ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML : ieParentElement[i].outerHTML;
                        isParent = true;
                        break;
                    }
                }
                if (!isParent)
                    html = this._getRange().htmlText.substring(0, 1) == "<" ? this._getRange().text : this._getRange().htmlText;
                return html;
            }
            else {
                var range = this._getRange(), cnode = range.commonAncestorContainer, parentElement, i, container;
                parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                for (i = parentElement.length - 1; i >= 0; i--) {
                    if (parentElement[i].textContent != "" && parentElement[i].textContent == range.toString()) {
                        range.selectNode(parentElement[i]);
                        break;
                    }
                }
                container = document.createElement("div");
                container.appendChild(range.cloneContents());
                return container.innerHTML;
            }
        },

        _getText: function () {
            var _body = this._getDocument().body;
            if (_body != null) {
                if (!this._isIE())
                    return _body.textContent;
                else
                    return _body.innerText;
            }
        },
        _validateMaxLength: function (e) {
            if (this.model.maxLength != null) {
                var len = this.model.maxLength;
                var usertext = this._getText();
                if (len <= usertext.length) {
                    if (!(e.keyCode < 47 || e.ctrlKey && e.keyCode == 65 || e.ctrlKey && e.keyCode == 67 || e.ctrlKey && e.keyCode == 86 || e.ctrlKey && e.keyCode == 88)) {
                        this._keypressFlag = false;
                        this._cancelEvent(e);
                    }
                }
            }
        },
        _cancelEvent: function (e) {
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _alignToolUpdate: function (name) {
            for (var i = 0; i < this._alignItems.length; i++) {
                if (this._alignItems[i] === name)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + name);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]);
            }
        },


        _getCommandStatus: function (commandName) {
            var state = this._getDocument().queryCommandState(commandName);
            return state;
        },


        _getCommandValue: function (commandName) {
            var value = this._getDocument().queryCommandValue(commandName);
            if (this._isIE()) {
                if (commandName == "fontname") {
                    for (var i = 0; i < this.model.fontName.length; i++) {
                        if (value == this.model.fontName[i].text) {
                            value = this.model.fontName[i].value;
                            break;
                        }
                    }
                    if (ej.isNullOrUndefined(value) || value == "")
                        value = this.model.fontName[0].value;
                }
                if (commandName == "formatblock") {
                    for (var i = 2; i < this.model.format.length; i++) {
                        if (value == this.model.format[i].text) {
                            value = this.model.format[i].value;
                            break;
                        }
                    }
                    if (value == "Normal")
                        value = this.model.format[0].value;
                }
            }
            return value;
        },

        _save: function (range, docElement) {
            range = (range) ? range.cloneRange() : this.getRange(docElement);
            var body = docElement.body;
            var range = range.cloneRange();
            this._undoSave = {range: range, rootNode: this._rootNodes(range), body: body, 
                startContainer: this._getNodeArray(range, range.startContainer, true),
                endContainer: this._getNodeArray(range, range.endContainer, false),
                startOffset: range.startOffset, endOffset: range.endOffset, html: body.innerHTML};
            return this._undoSave;
        },
        _rootNodes: function(range){
            return (9 === range.startContainer.nodeType) ? range.startContainer : range.startContainer.ownerDocument;
        },
        _getNodeArray: function (range, node, isStart, root) {
        var array = [];
        ((isStart) ? (this.startNodeName = []) : (this.endNodeName = []));
        for (; node !== (root ? root : this._rootNodes(range)); null) {
            (isStart) ? this.startNodeName.push(node.nodeName.toLowerCase()) : this.endNodeName.push(node.nodeName.toLowerCase());
            array.push(this._getIndex(node));
            node = node.parentNode;
        }
        return array;
        },
    _getIndex : function (node) {
        var index;
        var num = 0;
        node = !node.previousSibling && node.tagName === 'BR' ? node : node.previousSibling;
        if (node) {
            for (var type = node.nodeType; node; null) {
                index = node.nodeType;
                num++;
                type = index;
                node = node.previousSibling;
            }
        }
        return num;
    },
    _restore: function () {
        var range = this._undoSave.range.cloneRange();
        range = this._setRangePoint(range, true, this._undoSave.startContainer, this._undoSave.startOffset);
        range = this._setRangePoint(range, false, this._undoSave.endContainer, this._undoSave.endOffset);
        var docElement = this._rootNodes(range);
        var selection = docElement.defaultView.getSelection();
        selection.removeAllRanges();
        selection.addRange(range);
        this._save(range, docElement);
        return range;
    },
    _setRangePoint: function (range, isvalid, num, size) {
        var node = this._undoSave.rootNode;
        var index = num.length;
        var constant = size;
        for (; index--; null) {
            node = node.childNodes[num[index]];
        }
        if (node && constant >= 0) {
            range[isvalid ? 'setStart' : 'setEnd'](node, constant);
        }
        return range;
    },
        _undo: function () {
            if (this._undoRedoPosition > 0) {
                this._undoSave = this._backupArray[this._undoRedoPosition - 1].range;
                if (this.model.enableHtmlEncode)
                    this.setHtml(this._decode(this._backupArray[this._undoRedoPosition - 1].text));
                else
                    this.setHtml(this._backupArray[this._undoRedoPosition - 1].text);
                this._undoRedoPosition--;
                this._focus();
                this._restore();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                this._toggleEditTable();
                if (this.model.isResponsive) this._toolBarObj._liTemplte.removeClass("e-display-none");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            if (this._undoRedoPosition == 0) {
                this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            this._updateToolbarStatus();
            this._trigger("execute", { commandName: "undo" });
        },
        _getRedoContent: function () {
            if (this.model.enableHtmlEncode)
                return (this._decode(this._backupArray[this._undoRedoPosition + 1].text));
            else
                return (this._backupArray[this._undoRedoPosition + 1].text);
        },

        _redo: function () {
            if (this._undoRedoPosition != this._backupArray.length) {
                this._undoSave = this._backupArray[this._undoRedoPosition + 1].range;
                if (this._backupArray[this._undoRedoPosition + 1] != null) {
                    var _redoContent = this._getRedoContent();
                    this.setHtml(_redoContent)
                    this._undoRedoPosition++;
                }
                else {
                    var redoString = this._getRedoContent();
                    if (!ej.isNullOrUndefined(redoString)) this.setHtml(redoString);
                    this._undoRedoPosition = this._backupArray.length - 2;
                }
                this._focus();
                this._restore();
                this._updateToolbarStatus();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                if (!ej.isNullOrUndefined(this._toolBarObj)) {
                    if (this._backupArray.length - 1 > 0)
                        this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
                    if (this._undoRedoPosition == this._backupArray.length - 1)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
                }
            }
            this._trigger("execute", { commandName: "redo" });
        },


        _setContent: function (htmltxt) {
            var editdoc = this._getDocument();
            if (editdoc != "" && !ej.isNullOrUndefined(editdoc)) {
                editdoc.open();
                editdoc.write(htmltxt);
                editdoc.close();
                editdoc.EditMode = true;
            }
        },
        _removeResizeObject: function () {
            $(this._getDocument()).find(".e-rteColumnResizer , .e-rteRowResizer , .e-rteLastcolumn").remove();
        },
        _tableMouseOver: function (e) {
            if (!this.model.enableRTL && e.target.nodeName == "TABLE" || (ej.browserInfo().name === "mozilla" && e.target.nodeName == "TD")) {
                this._curTable = (e.target.nodeName == "TD") ? $(e.target).closest("table")[0] : e.target;
                this._removeResizeObject();
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableResizeObject($(this._curTable));
            }
        },
        _preventDefaultResize: function () {
            var proxy = this._getDocument();
            (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? proxy.body.addEventListener('mscontrolselect', this._ieDefaultTableHandler) : (this._isIE()) && proxy.body.attachEvent('oncontrolselect', this._ieTableHandler);
            if (ej.browserInfo().name === "mozilla") {
                proxy.designMode = "on";
                proxy.execCommand("enableObjectResizing", false, "false");
                proxy.execCommand("enableInlineTableEditing", false, "false");
            }
        },
        _tableResizeObject: function (_tableEle) {
            if (this.model.allowEditing) this._preventDefaultResize();
            var cellspace = parseInt($(_tableEle).attr("cellspacing") ? $(_tableEle).attr("cellspacing") : 0);
            this._newcol = _tableEle.find("tr:first td").not(":first"), this._newRow = _tableEle.find("tr td:nth-child(1)"), this._newlas = _tableEle.find("tr:first td:last");
            for (var i = 0; this._newcol.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteColumnResizer\"  unselectable=\"on\" contenteditable=\"false\" data-col =" + (i + 1) + " style=\"top:" + $(this._newcol[i]).closest("table").offset().top + "px;left:" + $(this._newcol[i]).offset().left + "px;height:" + $(this._newcol[i]).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left: " + (-4 - cellspace) + "px;\"></div>");
            for (var i = 0; this._newRow.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteRowResizer\" unselectable=\"on\"  contenteditable=\"false\" data-row =" + (i) + " style=\"top:" + ($(this._newRow[i]).offset().top + $(this._newRow[i]).height()) + "px;left:" + $(this._newRow[i]).offset().left + "px;width:" + $(this._newRow[i]).closest("table").width() + "px;height:" + (5 + cellspace) + "px;\"></div>");
            $(this._getDocument().body).after("<div class =\"e-rteColumnResizer e-rtelastcol\" data-col =" + (this._newcol.length) + "  contenteditable=\"false\" style=\"top:" + $(this._newlas).closest("table").offset().top + "px;left:" + ($(this._newlas).offset().left + $(this._newlas).width()) + "px;height:" + $(this._newlas).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left:3px;\"></div>");
            this._botRigTab = ej.buildTag("span.e-rte-tablebox e-rte-botrig", "", { "cursor": "nwse-resize", "width": "5px", "height": "5px", "position": "absolute", "display": "block", "background": "#fff", "border": "1px solid #000" }, {});
            var tableBox = _tableEle.find("tr:last td:last:not(:has(>span.e-rte-tablebox))");
            if (tableBox.length > 0) $(this._getDocument().body).after($(this._botRigTab).css({ "left": ((parseInt(tableBox.closest("table").width())) + tableBox.closest("table").offset().left) + "px", "top": ((parseInt(tableBox.closest("table").height())) + tableBox.closest("table").offset().top) + "px" }));
        },
        _ieDefaultTableHandler: function (e) {
            e.preventDefault();
        },
        _ieTableHandler: function (e) {
            return false;
        },


        _tableCellStart: function (e) {
            this._tableInsertAt = this._saveSelection();
        },


        _tableCellSelect: function (e) {
            var cellEle, target = $(e.target);
            var row = target.parent().index();
            var col = target.index();
            this._createTable.find("div.e-rte-tablecell").each(function (index) {
                cellEle = $(this);
                if (cellEle.index() <= col && cellEle.parent().index() <= row) {
                    cellEle.addClass("e-active");
                }
                else {
                    cellEle.removeClass("e-active");
                }
            });
            this._tblheaderDiv.html((col + 1) + "x" + (row + 1) + this._getLocalizedLabels("table"));
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt))
                this._restoreSelection(this._tableInsertAt);
        },
        _tableCellLeave: function (e) {
            this._createTable.find("div.e-rte-tablecell").removeClass("e-active");
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
        },
        _tableCellDown: function (e) {
            var target = $(e.target);
            var row = target.parent().index() + 1;
            var col = target.index() + 1;
            this._focus();
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt)) {
                this._restoreSelection(this._tableInsertAt);
                this._onInsertTable(row, col, false);
            }
            //Content editable propert for table and td removed and key navigation support added in keydown           
            this._createTable.ejDialog("close",{clickAction:true});
            this._setBackupData();
            this._onChange();
            if (this.model.isResponsive && !($(this._toolBarObj._liTemplte).hasClass("e-inline"))){
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
        },

        _tableGenerator: function (rows, cols, designTime, width, height, spacing, padding, align, border, caption) {
            var tblClass = "e-rte-table", borderstyle;
            if (designTime)
                tblClass += " e-rte-tableremove";
            width = ej.isNullOrUndefined(width) || width == "" ? "width:99%;" : "width:" + (isNaN(Number(width))?width:width+"px") + ";";
            height = ej.isNullOrUndefined(height) || height == "" ? "" : "height:" + (isNaN(Number(height))?height:height+"px") + ";";
            spacing = ej.isNullOrUndefined(spacing) || spacing == "" ? "" : "border-spacing:" + (isNaN(Number(spacing))?spacing:spacing+"px") + ";";
            padding = ej.isNullOrUndefined(padding) || padding == "" ? "" : " style='padding:" + (isNaN(Number(padding))?padding:padding+"px") + ";'";
            align = ej.isNullOrUndefined(align) || align=="" ? "" : (align=="center") ?" margin: 0 auto;" : " float:" + align + ";";
            var  colTemplate = "<td"+ padding+"><br _moz_dirty=''/></td>"
            switch (border) {

                case "dotted": borderstyle = "dotted";
                    break;
                case "double":
                    this._border = "border:3px double #5C5C5C;";
                    borderstyle = "double";
                    return "<table border='1' class='" + tblClass + "' style='" + width + " " + height + " " + this._border + " " + spacing + " " + padding + " " + align + "' >" + (caption ? "<caption></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td"+padding+"><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
                    break;
                case "dashed": borderstyle = "dashed";
                    break;
                case "solid": borderstyle = "solid";
                    break;
                default: borderstyle = "solid";
                    break;
            }
            if (borderstyle != "double") {
                this._border = "border:1px " + borderstyle + "#5C5C5C;";
                return "<table border='1' class='" + tblClass + "' style='" + width + height + this._border + spacing  + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td"+padding+"><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
            }

            return "<table border='1' class='" + tblClass + "' style='border:1px solid #5C5C5C; " + width + height + spacing + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join(colTemplate) + "</tr>") + "</table>";
        },

        _openCustomTable: function (e) {
            this._createCustomTable();
            if (e.currentTarget.id == this._rteId + "_createCustomTableLink") {
                $("#" + this._rteId + "_customTable_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._customTableDialog.ejDialog("open");
                this._createTable.ejDialog("close");
                this._widthFocusOut();
            }
            else {
                if (!this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')) {
                    this._eTblManager();
                    $("#" + this._rteId + "_eTbl_wrapper").css({ "z-index": this._onGetMaxZindex() });
                    this._eTblDialog.ejDialog("open");
                    this._createTable.ejDialog("close");
                    this._on(this._getTableObj("Width"), "focusout", this._widthFocusOut);
                    this._widthFocusOut();
                }
            }
        },
		_createcustomColorpalette:function(e)
		{
		    var proxy = $("#" + this._rteId).data("ejRTE");
			var palette=ej.buildTag("div.e-custom-palette");
		    this._customColor = ej.buildTag("div.e-rte-customColor#" + this._rteId + "_customColorDialog");
            var colorpalette= ej.buildTag("input.e-custom-palette#" + this._rteId + "customcolor");
            colorpalette.appendTo(this._customColor);
			this.colorobj=this._customColor.find(".e-custom-palette").ejColorPicker({ enableRTL: this.model.enableRTL,enableOpacity:true,showRecentColors:true,modelType: "picker",cssClass: this.model.cssClass,showSwitcher: false,select:function(args){ 
			
			   proxy._checkColor(args.value); 
			   
			 },
			
		    }).data("ejColorPicker");
            var model = this._getDialogModel();
            model.width = "auto";
		    model.height="auto";
			model.minWidth="220px";
		    model.htmlAttributes={"class":"e-custom-Dialog"}
            model.title = this._getLocalizedLabels("customFontColor");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customColor.ejDialog(model);
	        this._customDialogobj=(this._customColor).ejDialog("instance");
            this._customColor.closest(".e-dialog-wrap").addClass("e-rte");
		    this.colorobj.popupContainer.appendTo(palette);
		    this.colorobj.popupContainer.css({"display":"block","border-style":"none"});
		    $("#"+this._rteId+"_customColorDialog").find("span.e-colorwidget.e-picker").remove();
		    $("#"+this._rteId+"_customColorDialog").prepend(palette);
		    this.colorobj._hidePopup=function () {
              if($("#"+this._rteId+"_customColorDialog").ejDialog("isOpen"))
			     $("#"+this._rteId+"_customColorDialog").ejDialog("close"); 
		    !this.colorobj.model.displayInline && this.colorobj.hide();
		     }
           this._on(this.colorobj._cancelTag, "click", this.colorobj._hidePopup);
            
        },
		
		_openColorpalette:function(e)
		{
		  if(!this._customColor)
				this._createcustomColorpalette();
		  if (e.currentTarget.id == this._rteId + "_customcolor") {
		       this._fontclick=true;
		   if (!ej.isNullOrUndefined(this._splitMenu))
               this._splitMenu.hide(e);
	    } 
		else if (e.currentTarget.id == this._rteId + "_customBGcolor") {
	     	     this._fontclick=false;
		    if (!ej.isNullOrUndefined(this._bgSplitMenu))
                this._bgSplitMenu.hide(e);
		
		}
		     this._customColor.ejDialog("open");

		},
		
		
		_checkColor:function(e)
		{
		  if(this._fontclick)
		  {
		  this._onFontColor(e);
		  this._fontColor=e;
		  }
		  else
		  {
		  this._onBGColor(e);
		  this._bgColor=e;		
		  }
		},
	
		
		
        _createTableClose: function (e) {
            if ((!ej.isNullOrUndefined(this._createTable)) && ((!ej.isNullOrUndefined(e) && $(e.target).parents("#" + this._rteId + "_" + "tables").length <= 0) || ej.isNullOrUndefined(e))) {
                if (!ej.isNullOrUndefined(this._createTable.data("ejDialog"))) {
                    if (ej.isNullOrUndefined(e) || (e.target != this._createTable[0] && $(e.target).parents(".e-rte-table-picker").length <= 0)) {
                        this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                    if (this._createTable.ejDialog("isOpened") && this.model.isResponsive&&(!$(e.target).find("div#" + this._toolBarObj.element[0].id + "_hiddenlist").hasClass("e-inline"))) this._toolBarObj._liTemplte.removeClass("e-display-none");
                    else if (this.model.isResponsive && !ej.isNullOrUndefined(e) && !$(e.target).is($("#" + this._toolBarObj.element[0].id + "_target")) && !($(e.target).closest("div#" + this._toolBarObj.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) this._toolBarObj._liTemplte.addClass("e-display-none");
                }
            }
            else
                $(this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')).addClass('e-disable');
        },
        _rteinlineClick: function(e){
            if($(e.target).hasClass("e-inlinearrow"))
		       this._setIframeHeight();
        },
        _documentClick: function (e) { 
          if(this.model.toolbarOverflowMode!="inline")
              this._createTableClose(e);
            if (this._isIE() && !window.getSelection) {
                var checkdropdown = e.target.id;
                if (checkdropdown == "")
                    checkdropdown = e.target.parentNode.id;
                if (checkdropdown == (this._rteId + "_fontSizeDDL") || checkdropdown == (this._rteId + "_fontNameDDL") || checkdropdown == (this._rteId + "_formatDDL") || checkdropdown == (this._rteId + "_fontSizeDDL_dropdown") || checkdropdown == (this._rteId + "_fontNameDDL_dropdown") || checkdropdown == (this._rteId + "_formatDDL_dropdown"))
                    this._restoreSelection(this._selectionRange);
            }
        },


        _iframeFocus: function (e) {
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
            !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass("e-dropdownlist") && this._fontSizeDDL.ejDropDownList("hidePopup");
            !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass("e-dropdownlist") && this._fontStyleDDL.ejDropDownList("hidePopup");
            !$(this._formatDDL).parents("ul.e-rte-format").length == 0 && !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.hasClass("e-dropdownlist") && this._formatDDL.ejDropDownList("hidePopup");
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("close");
            !ej.isNullOrUndefined(this._splitMenu) && this._splitMenu.hide(e);
            !ej.isNullOrUndefined(this._bgSplitMenu) && this._bgSplitMenu.hide(e);
            !ej.isNullOrUndefined(this._orderSplitObj) && this._orderSplitObj.hide(e);
            !ej.isNullOrUndefined(this._unOrderSplitObj) && this._unOrderSplitObj.hide(e);
        },
        _updateKeyDownSelectStatus: function (_toolEle, commandName) {
            if (!_toolEle.hasClass("e-active"))
                this._toolBarObj.selectItemByID(this._rteId + "_" + commandName);
            else
                this._toolBarObj.deselectItemByID(this._rteId + "_" + commandName);
        },
        _iframeKeyDown: function (e) {
            var _toolEle, ele, _newElement;
            if (this._backupArray.length==0)
               this._setBackupData();
            if (this.model.showToolbar && this.model.allowKeyboardNavigation && e) {
                if (e.ctrlKey) {
                    e.keyCode == 65 ? this._contolAKeyfalg = true : ej.isNullOrUndefined(this._contolAKeyfalg) ? this._contolAKeyfalg : this._contolAKeyfalg = false;
                    var _proxy = this;
                    switch (e.keyCode) {
                        case 48://Reset zoom
                            e.preventDefault();
                            $(this.getDocument().body).css({ "zoom": 1, "transform": "scale(1)", "transform-origin": "0 0", "-o-transform": "scale(1)", "-o-transform-origin": "0 0", "-webkit-transform": "scale(1)", "-webkit-transform-origin": "0 0" });
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " 100%");
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " 100%");
                            _proxy._zoomValue = 1;
                            return false;
                        case 57:// Zoom in
                            e.preventDefault();
                            this._onKeyZoom("IN");
                            return false;
                        case 173:
                        case 189:// Zoom out
                            e.preventDefault();
                            this._onKeyZoom("OUT");
                            return false;
                        case 80:// Print
                            e.preventDefault();
                            this._onPrint();
                            return false;
                        case 66://B
                            if (!e.shiftKey) {//bold
                                e.preventDefault();
                                _toolEle = this._toolBarItems.find("li.e-rteItem-bold");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onBold();
                                    this._updateKeyDownSelectStatus(_toolEle, "bold");
                                    this._onChange();
                                    this._setBackupData()
                                };
                                return false;
                            }
                            break;
                        case 72:
                            if (e.shiftKey) {//sourcecode	view.
                                e.preventDefault();
                                this._getPasteRangeVal();
                                this._sourceCodeManager();
                                return false
                            }
                            break;
                        case 73://I
                            e.preventDefault();
                            if (e.shiftKey)
                                this._imageManager();
                            else {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-italic");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onItalics();
                                    this._setBackupData();
                                    this._updateKeyDownSelectStatus(_toolEle, "italic");
                                    this._onChange();
                                }
                            }
                            return false;
                        case 85://U
                            e.preventDefault();
                            if (e.shiftKey)//UpperCase
                                this._onUpperCase();
                            else//Underline
                            {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-underline");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onUnderLine();
                                    this._updateKeyDownSelectStatus(_toolEle, "underline");                                    
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 76://L
                            e.preventDefault();
                            if (e.shiftKey)//Lowercase
                                this._onLowerCase();
                            else {
                                if (!this._toolBarItems.find("li.e-rteItem-justifyLeft").hasClass("e-disable")) {
                                    this._onJustifyLeft();
                                    this._alignToolUpdate("justifyLeft");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 82://R
                            e.preventDefault();
                            if (e.altKey)//Remove table row.
                                this.removeRow();
                            else if (e.shiftKey)//remove formate
                                this._onClearFormat();
                            else {//Jutfy Right.
                                _toolEle = this._toolBarItems.find("li.e-rteItem-justifyRight");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onJustifyRight();
                                    this._alignToolUpdate("justifyRight");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 69://E
                            if (e.shiftKey) {//editable                          
                                e.preventDefault();
                                this._openCustomTable(e);
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            else if (!this._toolBarItems.find("li.e-rteItem-justifyCenter").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyCenter();
                                this._setBackupData();
                                this._alignToolUpdate("justifyCenter");
                                this._onChange();
                                return false;
                            }
                            break;
                        case 74://J							
                            if (!this._toolBarItems.find("li.e-rteItem-justifyFull").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyFull();
                                this._alignToolUpdate("justifyFull");
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            break;
                        case 90://Z							
                            if (!this._toolBarItems.find("li.e-rteItem-undo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onUndo();
                                return false;

                            }
                            break;
                        case 89://Y

                            if (!this._toolBarItems.find("li.e-rteItem-redo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onRedo();
                                return false;
                            }
                            break;
                        case 67://C							
                            if (e.altKey)//Remove table column
                            {
                                e.preventDefault();
                                this.removeColumn();
                                return false;
                            }
                            else if (e.shiftKey) {//custom Table
                                e.preventDefault();
                                this._getPasteRangeVal();
                                if (this._customTableDialog)
                                    this._renderTableDialog();
                                this._customTableDialog.ejDialog("open");
                                return false;
                            }
                            else if (this._toolBarItems.find("li.e-rteItem-copy").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            break
                        case 88://X
                            if (this._toolBarItems.find("li.e-rteItem-cut").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            this._onChange();
                            break;
                        case 86://V
                            if (this._toolBarItems.find("li.e-rteItem-paste").hasClass("e-disable") || ((this.model.maxLength <= $.trim(this._getText()).length) && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : this._contolAKeyfalg))) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            else if (e.shiftKey)//Video insertion.
                            {
                                e.preventDefault();
                                this._keypressFlag = false;
                                this._selectCommand("video");
                                return false;
                            }
                            break;
                        case 77://M
                            e.preventDefault();
                            if (e.shiftKey) {//Outdent.
                                if (!this._toolBarItems.find("li.e-rteItem-outdent").hasClass("e-disable")) {
                                    this._onOutdent();
                                    if (this._indentdepth > 0)
                                        this._indentdepth--;
                                }
                            }
                            else { //Indent.
                                if (!this._toolBarItems.find("li.e-rteItem-indent").hasClass("e-disable")) {
                                    this._onIndent();
                                    this._indentdepth++;
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 75:
                            e.preventDefault();
                            if (e.shiftKey)
                                this._onUnlink();
                            else
                                if (!this._toolBarItems.find("li.e-rteItem-createLink").hasClass("e-disable"))
                                    this._hyperLinkManager(false);
                            return false;

                        case 188://<							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(false);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            this._onChange();
                            break;
                        case 190://>							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(true);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            break;
                        case 61:
                        case 187://+
                            e.preventDefault();
                            (e.shiftKey) ? this._onSuperScript() : this._onSubScript();
                            this._onChange();
                            this._setBackupData();
                            return false;
                        case 79://O							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this.executeCommand('insertorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            else if (e.altKey) {
                                e.preventDefault();
                                this.executeCommand('insertunorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 83://S							
                            if (e.shiftKey)//strike the content.
                            {
                                e.preventDefault();
                                this._onStrikeThrough();
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 70://F							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._selectCommand("fullScreen");
                                return false;
                            }
                            else if (!e.altKey) {
                                e.preventDefault();
                                if (ej.RTE.FindAndReplace)
                                    this._showFindAndReplace();
                                return false;
                            }
                            break;
                        case 37://left arrow.							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 39://right arrow.							
                            if (e.shiftKey  && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 38://up arrow.
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 40://downarrow							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 65://A
                            if (e.altKey) {
                                e.preventDefault();
                                this.removeTable();
                                return false;
                            };
                            break
                        case 121://F10
                            e.preventDefault();
                            this._clearAllManager();
                            return false;
                        case 84://T
                            if (e.altKey && this._toolBarItems) { // Alt+ Ctrl + T.
                                this._toolBarItems.focus();
                                break;
                            }
                    }
                }
                else if ((e.keyCode == 9 && this.model.enableTabKeyNavigation ) && !(this._isIE8() ? this._currentSelNode.nodeName.toLowerCase() == "td" : this._getSelectedNode().nodeName.toLowerCase() == "td")) {
                    this._keypressFlag = true;
                    this.executeCommand('inserthtml', "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", true);
                    return false;
                }
                else if (e.keyCode == 8) {//Backspace for removing the indent.
                    ele = this._getSelectedNode();
                    if ($(ele).find("span#RTE_imgDupDiv").length > 0)
                        $(this._imgDupDiv).remove();
                    if ($(ele).parents("BLOCKQUOTE").length > 0) {
                        this._onOutdent();
                        e.preventDefault();
                    }
                }
            }
            else if (e.ctrlKey == true && (e.keyCode == 66 || e.keyCode == 73 || e.keyCode == 85 || e.keyCode == 76 || e.keyCode == 82 || e.keyCode == 69 || e.keyCode == 74 || e.keyCode == 90 || e.keyCode == 89 || e.keyCode == 67 || e.keyCode == 88 || e.keyCode == 86 || e.keyCode == 8 || e.keyCode == 46) && !this.model.allowKeyboardNavigation)
                e.preventDefault();
            if (this.model.maxLength != null && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : !this._contolAKeyfalg)) {
                try {
                    if (this._isIE8() && e.keyCode == 86 && !((this.model.maxLength) >= (window.clipboardData.getData("Text").length + $.trim(this._getText()).length)))
                        e.preventDefault();
                    else
                        this._validateMaxLength(e);
                }
                catch (error) { }
            }
            if (this._isIE8() ? (this._currentSelNode && this._currentSelNode.nodeName.toLowerCase() == "td") : this._getSelectedNode().nodeName.toLowerCase() == "td") {
                ele = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
               var _newElementIndex = $(ele).parent().children().index($(ele));
                if (e.keyCode == 9 && !e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.nextSibling)) ? ele.nextSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling) ? $(ele).parents("tr")[0].nextSibling.childNodes[0] : (!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling)) ? ($(ele).parents("table")[0].nextSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].nextSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                if (e.keyCode == 9 && e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.previousSibling)) ? ele.previousSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling) ? $(ele).parents("tr")[0].previousSibling.childNodes[$(ele).parents("tr")[0].previousSibling.childNodes.length - 1] : (!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) ? ($(ele).parents("table")[0].previousSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].previousSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                else if (e.keyCode == 40)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling)) ? $(ele).parents("tr")[0].nextSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling) && !this._isIE8()) ? $(ele).parents("table")[0].nextSibling : ele);
                else if (e.keyCode == 38)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling)) ? $(ele).parents("tr")[0].previousSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) && !this._isIE8() ? $(ele).parents("table")[0].previousSibling : ele);
                if (e.keyCode == 9 && ele == _newElement && !ej.isNullOrUndefined($(ele).parents("tr")[0])) {
                    this.insertRow(false);
                    this._setRange(this._isIE8() ? $(this._getRange().parentElement()).parents("tr").next().children().first()[0] : $(this._getRange().startContainer).parents("tr").next().children().first()[0], this._getRange(), true);
                    e.preventDefault();
                }
                else if ((e.keyCode == 9 && this._isIE8()) || e.keyCode == 40 || e.keyCode == 38) {
                    this._setRange(_newElement, this._getRange(), true);
                    e.preventDefault();
                }
                if (this._isIE8())
                    this._getRange().parentElement && (this._currentSelNode = this._getRange().parentElement());
            }
            if ($(e.target).parents("table").length == 0) $(this._getDocument()).find(".e-rte-tablebox").remove();
            this._setAutoHeight();
            this._trigger("keydown", { keyCode: e.keyCode });
        },
        _changeFontsize: function (status) {
            var fontSize = parseInt(this._getCommandValue('fontsize')) ? parseInt(this._getCommandValue('fontsize')) : 2;
            if ((!status && fontSize > this.model.fontSize[0].value) || (status && fontSize < this.model.fontSize[this.model.fontSize.length - 1].value)) {
                this._onFontSize(status ? fontSize + 1 : fontSize - 1);
                this._updateFontOptionStatus();
            }
        },
        _iframeKeypress: function (e) {
            if (!this._keypressFlag) {
                e.preventDefault();
                this._keypressFlag = true;
                return false;
            }
        },
        _setTableSelection: function (_newElement, e) {
            if (!this._isIE8() && !((_newElement.childNodes.length == 1 && _newElement.childNodes[0].nodeName == "BR") || (_newElement.childNodes.length == 0))) {
                var range = this._getDocument().createRange();
                range.selectNodeContents(_newElement);
                this.selectRange(range);
            }
            else this._setRange(_newElement, this._getRange(), true);
            e.preventDefault();
        },
        _setAutoHeightValue: function (selectedtext) {
            if (selectedtext.nodeName == "#text") {
                if (selectedtext.parentNode.nodeName == "BODY") {
                    $(selectedtext).wrap("<div></div>");
                    this.selectRange(this._getRange());
                }
               var range = $(selectedtext.parentNode).position().top + parseInt($(selectedtext.parentNode).css("height"));
            }
            if (selectedtext.nodeName == "DIV")
                range = $(selectedtext).position().top + parseInt($(selectedtext).css("height"));
            return range;
        },
        _setAutoHeight: function () {
            if (this.model.autoHeight)
                this._autoHeight();
            else if (!ej.isNullOrUndefined(this._getDocument())) $(this._getDocument().body).css("overflow", "");
        },
        _autoHeight: function () {
			var toolbarHeight = this._toolBarItems?this._toolBarItems.outerHeight():0;
            if (!ej.isNullOrUndefined(this._getDocument().body)) {
                $(this._getDocument().body).css("overflow", "hidden");
                var iframeTop = (!ej.isNullOrUndefined(this._getDocument().body.lastChild)) ? this._getDocument().body.lastChild.clientHeight + this._getDocument().body.lastChild.offsetTop : 0;
                if ((parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) <= iframeTop)
                    $(this._rteIframe[0]).css("height", (iframeTop + 30) + "px");
                else
                    $(this._rteIframe[0]).css("height", (parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) + "px");
                var range = 0;
                range = (window.getSelection && !ej.isNullOrUndefined(this._getRange().startContainer)) ? this._setAutoHeightValue(this._getRange().startContainer) : (((this._getDocument().selection) && !ej.isNullOrUndefined(this._ieParents(this._getRange())[0])) ? this._setAutoHeightValue(this._ieParents(this._getRange())[0]) : 0);
                if (range >= (this._rteIframe.height() - 30)) {
                    if (this._rteIframe[0].contentDocument)
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentDocument.documentElement.scrollHeight + 20) + "px");
                    else
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentWindow.document.body.scrollHeight + 20) + "px");
                }
                this._rteWapper.outerHeight(this._rteEditor.outerHeight() + toolbarHeight + parseInt(this.model.showFooter ? 19 : 0));
            }
        },
        _ieSelRange: function () {
            if (this._isIE()) {
                this._selectionRange = "";
                this._ieSelectionRange = this._getRange();
                this._seleText = ej.isNullOrUndefined(this._getWindow().document.selection) ? this._selectionRange.toString() : this._getWindow().document.selection.createRange().text;
            }
            else
                this._ieSelectionRange = this._ieSelection;
        },
        _iframeSelectionChange: function (e) {
            this._trigger("select", { event: e, model: this.model });
        },
        _debounce: function(delay) { 
            var proxy = this;
            if (this.undoTimeout != null)
            clearTimeout(this.undoTimeout);
            this.undoTimeout = setTimeout(function() {
                this.undoTimeout = null;
                proxy._setBackupData();
            }, delay);
        },
        _ignorekeyArray: [13, 32, 8, 46],
        _iframeKeyUp: function (e) {
            //if (!(e.which >= 37 && e.which <= 40))
            //    this._updateValue();
            $(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline", "");
            if(this._getSelectedNode().parentNode.localName == "td" || this._getSelectedNode().parentNode.localName == "tr")this._toggleEditTable();
            let allowedKeys = e.which === 32 || e.which === 13 || e.which === 8 || e.which === 46;
            if (((e.key !== 'shift' && !e.ctrlKey) && e.key.length === 1 || allowedKeys) || (this.editorMode === 'Markdown'
            && ((e.key !== 'shift' && !e.ctrlKey) && e.key.length === 1 || allowedKeys)) && !this.inlineMode.enable) {
                this._debounce(300);
            }
            if (e.ctrlKey && (e.keyCode == 57 || e.keyCode == 189))
                this._zoomUp();
                if(e.keyCode == 37 ||e.keyCode == 39 || e.keyCode == 38 || e.keyCode == 40 || e.keyCode == 36 || e.keyCode == 35 || e.keyCode==9){               // top, left, right, left, home and end key code
            this._updateToolbarStatus();
            this._updateFontOptionStatus();
            this._updateFormat();
                }
            if(this.model.showFooter && (this.model.showWordCount||this.model.showCharCount))this._updateCount();
            var selectEle = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
            if (this.model.showToolbar)
                this._isIE8() ? selectEle.nodeName.toLowerCase() : selectEle.nodeName.toLowerCase() != "a" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            this._updateTagInfo(selectEle);            
            this._ieSelRange();
            this._trigger("keyup", { keyCode: e.keyCode });
            this._iframeSelectionChange(e);
            if (e.ctrlKey)
                switch (e.keyCode) {
                    case 88://X
                    case 86://V
                        this._onChange();
                        break;
                }
			if((e.keyCode==46||e.keyCode==8) && (this._getDocument().body.innerHTML==''||this._getDocument().body.innerHTML=="<br>"))
			 this._emptyContent();
			
        },
        _iframeMouseUp: function (e) {
            this._tableResizeUp(e);
			this._zoomUp(e);
            this._resizeBtnInit();
            if (!ej.isNullOrUndefined(this._imgDup) && $(this._imgOrg).parents("body").length > 0) {
                $(this._imgOrg).css({ "width": $(this._imgDup).css("width"), "height": $(this._imgDup).css("height") });
                $(this._imgOrg).position({ left: $(this._imgDup).position().left, top: $(this._imgDup).position().top });
                $(this._imgDup).css("display", "none");
                this._resizeImgPos();
                this._setAutoHeight();
            }
            if (e.target.nodeName != "IMG" && !$(e.target).hasClass("e-rte-imageboxmark")) {
                $(this._imgOrg).css("outline", "");
                $(this._imgDupDiv).remove();
                this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            }
            if (e.target.nodeName == "IMG" && $(e.target).parents("body").length > 0) {
                var range = (this._isIE8()) ? this._getDocument().body.createTextRange() : this._getDocument().createRange();
                (this._isIE8()) ? range.moveToElementText(e.target) : range.selectNode(e.target);
                this.selectRange(range);
            }
            this._currentSelNode = e.target; //For IE
            if (e.currentTarget && e.target.nodeName && e.target.nodeName.toLowerCase() == "html" && this._getDocument() && this._getDocument().body && (this._isIE8() ? true : this._getRange().startOffset == this._getRange().endOffset)) {
                this._isIE() && e.currentTarget.createRange && this._setRange(this._isIE8() ? this._getDocument().body : this._getRange().startContainer, e.currentTarget.createRange(), true);
                if( this._clientX < e.target.offsetWidth) 
					this._getDocument().body.focus();
            }
            this._toggleEditTable();
            this._updateToolbarStatus();
            var isRightClick;
            if (e.button) isRightClick = (e.button == 2);
            else if (e.which) isRightClick = (e.which == 3);
            if (!isRightClick) {
                this._updateFormat();
                this._updateFontOptionStatus();
            }
            this._ieSelRange();
            this._iframeSelectionChange(e);
            if (this._fontStyleDDL && !ej.isNullOrUndefined(this._fontStyleDDL.data("ejDropDownList")) && this._fontStyleDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontStyleDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");
            if (this._fontSizeDDL && !ej.isNullOrUndefined(this._fontSizeDDL.data("ejDropDownList")) && this._fontSizeDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontSizeDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");

        },
        _iframeMouseDown: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this._focus();
            this._contolAKeyfalg = false;
            this._updateTagInfo(e.target);
            this._updateIndent(e.target);
            if (this.model.showToolbar)
                e.target.nodeName != "A" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            if (e.target.nodeName == "VIDEO" && this.model.allowEditing) this._preventDefaultResize();
            if (e.target.nodeName == "IMG" && this.model.allowEditing) {
                this._preventDefaultResize();
                this._imageClick(e.target);
            }
            if ($(e.target).hasClass("e-rte-imageboxmark")) {
                this._resizeBtnInit();
                this._commonBoxDown = true;
                if ($(e.target).hasClass("e-rte-rigmed")) this._rigMidBox = true;
                if ($(e.target).hasClass("e-rte-toplef")) this._topLefBox = true;
                if ($(e.target).hasClass("e-rte-topmed")) this._topMidBox = true;
                if ($(e.target).hasClass("e-rte-toprig")) this._topRigBox = true;
                if ($(e.target).hasClass("e-rte-lefmed")) this._lefMidBox = true;
                if ($(e.target).hasClass("e-rte-botlef")) this._botLefBox = true;
                if ($(e.target).hasClass("e-rte-botmid")) this._botMidBox = true;
                if ($(e.target).hasClass("e-rte-botrig")) this._botRigBox = true;
                return false;
            }
            if ($(e.target).hasClass("e-rteColumnResizer")) {
                this._lastCol = $(e.target).hasClass("e-rtelastcol") ? true : false;
                this._columnEle = $(this._curTable).find("tr:first td").eq(parseInt($(e.target).attr("data-col")))[0];
                this._columnDown = true;
                this._columnIndex = this._columnEle.cellIndex;
                $(this._getDocument().body).after("<span class='colresizerline'style='cursor:col-resize;position:absolute;width:0px;border-left: 1px dashed #787878;height:" + $(this._columnEle).closest("table").height() + "px;left:" + e.pageX + "px;top:" + $(this._columnEle).offset().top + "px;'></span>");
            }
            if ($(e.target).hasClass("e-rteRowResizer")) {
                this._rowEle = $(this._curTable).find("tr").eq(parseInt($(e.target).attr("data-row")))[0];
                this._rowDown = true;
            }
            if ($(e.target).hasClass("e-rte-tablebox")) {
                this._boxDown = true;
                this._boxElement = this._curTable;
            }
            if ($(e.target).hasClass("e-rte-tablebox") || $(e.target).hasClass("e-rteRowResizer") || $(e.target).hasClass("e-rteColumnResizer"))
                this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            if ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && (e.ctrlKey == true && e.which == 1)) {
                if (e.target.tagName.toUpperCase() == 'A' && !ej.isNullOrUndefined($(e.target).attr('href')))
                    window.open($(e.target).attr('href'), "_blank");
            }
            if (this.model.isResponsive && !ej.isNullOrUndefined(this._toolBarObj) && this._toolBarObj._liTemplte.children('ul').length > 0&&(!$(this._toolBarObj._liTemplte).hasClass("e-inline"))) {
                this._toolBarObj.contstatus = true;
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
			this._clientX = e.clientX;
            this._iframeFocus();
            this._onChange();
        },
        _iframeFocusOut: function (e) {
            if (e.data) {
                e.data._proxy._onChange();
                e.data._proxy._selectionRange = e.data._proxy._isIE8() ? e.data._proxy._getRange() : e.data._proxy._saveSelection();
                e.data._proxy._seleText = ej.isNullOrUndefined(e.data._proxy._getWindow().document.selection) ? e.data._proxy._selectionRange.toString() : !e.data._proxy._isIE8() ? e.data._proxy._getWindow().getSelection().toString() : e.data._proxy._getWindow().document.selection.createRange().text;
            }
        },
        _widthFocusOut: function (e) {
            var dialog, drpdwnId, widthId;
            if (this._customTableDialog.ejDialog("isOpen")) {
                dialog = this._customTableDialog;
                drpdwnId = "#" + this._rteId + "_ddlAlignment";
                widthId = "#" + this._rteId + "_txtWidth";
            }
            else {
                dialog = this._eTblDialog;
                drpdwnId = "#" + this._rteId + "_eTblAlign";
                widthId = "#" + this._rteId + "_eTblWidth";
            }
            var val = dialog.find(widthId).val();
            var obj = $(drpdwnId).data('ejDropDownList');
            var option = (val && val != '' && !isNaN(val) || (val.slice(-2) == 'px') || (val.slice(-2) == 'em') || (val.slice(-2) == 'pt') || (val.slice(-1) == '%')) ? true : false;
            obj.option('enabled', option);
        },
        _windowResize: function (e) {
            this._setAutoHeight();
            this._setIframeHeight();
			this._updateCount();
        },
        _tableResizeUp: function (e) {
            if ($(this._getDocument()).find("table.e-rte-table").length && (this._columnDown || this._rowDown || this._boxDown)) {
                if (this._currentTable && this._columnDown && this._columnDownClick) {
                    if (!this._lastCol) {
                        this._currentTable.eq(this._columnIndex - 1).width(this.nexColIndexWid);
                        this._currentTable.eq(this._columnIndex).width(this._columnIndexWid);
                    }
                    else {
                        this._currentTable.closest("table").find("tr:first td").each(function () {
                            if (this.style.width == "") $(this).width(parseInt($(this).closest("table").width() / ($(this).siblings().length + 1)));
                        });
                        this._currentTable.eq(this._columnIndex).width(this.lasColIndexWid);
                        this._currentTable.closest("table").css({ "width": "" });
                        $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (this._currentTable.eq(this._columnIndex).offset().left + this._currentTable.eq(this._columnIndex).outerWidth()) + "px" });
                    }
                }
                this._removeResizeObject();
                $(this._getDocument()).find(".colresizerline").remove();
                $(this._getDocument()).find(".e-rte-tablebox").css("display", "none");
                this._restoreSelection(this._tableSelection);
                this._columnDown = false;
                this._rowDown = false;
                this._boxDown = false;
                this._columnDownClick = false;
            }
            else {
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableSelection = this._getRange();
            }
        },
        _resizeBtnInit: function () {
            this._commonBoxDown = false;
            this._rigMidBox = false;
            this._topLefBox = false;
            this._topMidBox = false;
            this._topRigBox = false;
            this._lefMidBox = false;
            this._botLefBox = false;
            this._botMidBox = false;
            this._botRigBox = false;
        },
        _imgSpanBox: function (e) {
            this._resizeBtnInit();
            this._imgOrg = e;
            this._imgDupDiv = ej.buildTag("span#RTE_imgDupDiv");
            this._imgDup = ej.buildTag("img#RTE_imgdivspan", "", { "display": "none", "position": "absolute", "background-size": "100% 100%", "outline": "1px dashed #000", "opacity": ".64" }, {}).appendTo(this._imgDupDiv);
            this._topLef = ej.buildTag("span.e-rte-imageboxmark e-rte-toplef#RTE_toplef", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._topMid = ej.buildTag("span.e-rte-imageboxmark e-rte-topmed#RTE_topmed", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._topRig = ej.buildTag("span.e-rte-imageboxmark e-rte-toprig#RTE_toprig", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._leftMid = ej.buildTag("span.e-rte-imageboxmark e-rte-lefmed#RTE_lefmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._rigMid = ej.buildTag("span.e-rte-imageboxmark e-rte-rigmed#RTE_rigmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._botLef = ej.buildTag("span.e-rte-imageboxmark e-rte-botlef#RTE_botlef", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._botMid = ej.buildTag("span.e-rte-imageboxmark e-rte-botmid#RTE_botmid", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._botRig = ej.buildTag("span.e-rte-imageboxmark e-rte-botrig#RTE_botrig", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._resizeImgPos();
            this._resizeImgDupPos();
            $(this._getDocument().body).after(this._imgDupDiv);
            $(e).css({ "outline": "1px dashed #5C5C5C" });
            this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);

        },
        _resizeImgPos: function () {
            this._ltPos = $(this._imgOrg).position();
            this._imgWid = $(this._imgOrg).css("width");
            this._imgHgt = $(this._imgOrg).css("height");
            this._imgDup.css({ "width": this._imgWid, "height": this._imgHgt, "left": this._ltPos.left + "px", "top": this._ltPos.top + "px", "border": $(this._imgOrg).css("border") });
            this._imgDup.attr({ "src": $(this._imgOrg).attr("src") });
            var _wid = (parseInt($(this._imgOrg).css("width")) - 2) + this._ltPos.left;
            var _midWid = ((parseInt($(this._imgOrg).css("width")) - 2) / 2) + this._ltPos.left;
            var _hgt = (parseInt($(this._imgOrg).css("height")) - 2) + this._ltPos.top;
            var _midHgt = ((parseInt($(this._imgOrg).css("height")) - 2) / 2) + this._ltPos.top;
            var _imgborder = parseInt($(this._imgOrg).css("border-width") == "" ? 0 : $(this._imgOrg).css("border-width"));
            $(this._rigMid).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_midHgt) + "px" });
            $(this._botLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botMid).css({ "left": (_midWid) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._topRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topMid).css({ "left": (_midWid) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._leftMid).css({ "left": (this._ltPos.left - 3) + "px", "top": (_midHgt) + "px" });

        },
        _resizeImgDupPos: function () {
            this._ltDupPos = $(this._imgOrg).position();
            this._imgMidWid = $(this._imgOrg).css("width");
            this._imgDupHgt = $(this._imgOrg).css("height");
        },
        _imgBoxMouseMove: function (e) {
            if (this._commonBoxDown) {
                if (this._rigMidBox)
                    this._imgDupMouseMove(parseInt(e.pageX) - this._ltDupPos.left + "px", this._imgDupHgt, e);
                else if (this._lefMidBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", this._imgDupHgt, e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topMidBox) {
                    this._imgDupMouseMove(this._img_wid, ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._botMidBox)
                    this._imgDupMouseMove(this._img_wid, (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botRigBox)
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topRigBox) {
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._topLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY, left: e.pageX });
                }
            }
            else if (this._columnDown) {
                this._columnDownClick = true;
                this._currentTable = $(this._columnEle).closest("table").find("tr:first td");
                var prevcolwid = (this._columnEle.style.width == "") ? $(this._columnEle).width() : parseInt(this._columnEle.style.width);
                var _columnEleLeft = $(this._columnEle).offset().left, actualwid = (_columnEleLeft > e.pageX) ? prevcolwid + (_columnEleLeft - e.pageX) : prevcolwid - (e.pageX - _columnEleLeft);
                var nexnodeWid = ($(this._currentTable).eq(this._columnIndex - 1)[0].style.width == "") ? $($(this._currentTable).eq(this._columnIndex - 1)).width() : parseInt($(this._currentTable).eq(this._columnIndex - 1)[0].style.width), totalwid = prevcolwid + nexnodeWid;
                if (!this._lastCol && actualwid > 15 && totalwid - actualwid > 15) {
                    this.nexColIndexWid = totalwid - actualwid;
                    this._columnIndexWid = actualwid;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                else if (this._lastCol && _columnEleLeft < e.pageX && e.pageX - _columnEleLeft > 15) {
                    this.lasColIndexWid = e.pageX - _columnEleLeft;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                this._removeMouseSelection(e);
                $(this._columnEle).closest("table").find("tr:last td:last span.e-rte-tablebox").css({ "display": "none" });
            }
            else if (this._rowDown) {
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
                var _rowOffset = this._rowEle.offsetTop, _rowParentTop = this._rowEle.parentElement.parentElement.offsetTop;
                if ((e.pageY - (_rowOffset + _rowParentTop)) > 20)
                    this._rowEle.style.height = (e.pageY - (_rowOffset + _rowParentTop)) + "px";
                this._removeMouseSelection(e);
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": ($(this._rowEle).closest("table").width() + $(this._rowEle).closest("table").offset().left) + "px", "top": ($(this._rowEle).closest("table").height() + $(this._rowEle).closest("table").offset().top) + "px" });
            }
            else if (this._boxDown) {
                var boxEle = $(this._boxElement),boxParent = boxEle.parent(),boxPosition = boxEle.offset(), _width = (((e.pageX - boxPosition.left) / boxParent.width()) * 100), _height = (((e.pageY - boxPosition.top) / boxParent.height()) * 100);		
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
                if(e.pageX > 0 && _width > 10 && _height > 0) {
                boxEle[0].style.width = _width + "%";
                boxEle[0].style.height = _height + "%";
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (boxEle.width() + boxPosition.left) + "px", "top": (boxEle.height() + boxPosition.top) + "px" });
                boxEle.find("tr:first td").each(function () {
                    var tdEle = $(this);
                    tdEle.width(parseInt(tdEle.closest("table").width() / (tdEle.siblings().length + 1))); });
                
                }
                this._removeMouseSelection(e);
            }

        },
        _removeMouseSelection: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
            if (e.stopPropagation) e.stopPropagation();
            if (e.preventDefault) e.preventDefault();
            e.cancelBubble = true;
            e.returnValue = false;
            return false;
        },
        _imgDupMouseMove: function (width, height, e) {
            $(this._imgDup).css({ "display": "block", "width": width, "height": height });
            this._resizeImgDupPos();
            if (this._isIE8()) this._removeMouseSelection(e);
        },
        _imageClick: function (e) {
            $(this._getDocument().body).find("img").css("outline", "");
            if (this._imgDupDiv)
                this._imgDupDiv.remove();
            this._imgSpanBox(e);
        },
        _iframePaste: function (e) {
            var _proxy = this,temp=ej;
			if(e){
				try {
					var val = ej.isNullOrUndefined(window.clipboardData) ? e.originalEvent.clipboardData.getData("text/plain") : window.clipboardData.getData("Text");
					if (val.length != 0) {
						if (!((_proxy.model.maxLength) >= (val.length + $.trim(_proxy._getText()).length)))
							e.preventDefault();
					}
					else {
						var blob = e.originalEvent.clipboardData.items[0].getAsFile();
						var reader = new FileReader();
						reader.onload = function (event) {
							_proxy.executeCommand('inserthtml', "<img src=" + event.target.result + " alt />");
						};
						reader.readAsDataURL(blob);
					}
				}
				catch (error) { }
			}
            setTimeout(function () {
				_proxy._setBackupData();
				_proxy._onChange();
                _proxy._setAutoHeight();
                _proxy._updateCount();
                _proxy._pasteTableResize();
				
			if (temp.browserInfo().name == "webkit")
                _proxy._getWindow().focus();
            else
                _proxy._getWindow().document.body.focus();
            }, 0);
        },
        _pasteTableResize: function () {
            var tableCollection = $(this._getDocument()).find("table").not(".e-rte-table"), tableElement;
            for (var tableItem = 0; tableItem < tableCollection.length; tableItem++) {
                tableElement = $(tableCollection[tableItem]);
                tableElement.addClass("e-rte-table").removeAttr("style cellspacing").attr({ "border": 1, "cellspacing": 1, "width": tableElement.width() }).css({ "border": "1px solid#5C5C5C", "border-collapse": "separate", "border-spacing": "2px" });
                tableElement.find("table tr,td").removeAttr("style width");
            }
        },
        _wireEvents: function () {
            var _iframe = $(this._getDocument());
            if (this._getDocument() != "") {
                if (!ej.isNullOrUndefined(this._createTable)) {
                    this._on(this._createTable, "mouseenter", "div.e-rte-tablecell", this._tableCellStart)
                    ._on(this._createTable, "mousemove", "div.e-rte-tablecell", this._tableCellSelect)
                    ._on(this._createTable, "mouseleave", "div.e-rte-table", this._tableCellLeave)
                    ._on(this._createTable, "mousedown", "div.e-rte-tablecell", this._tableCellDown)
                    ._on($(document), "click", this._documentClick);
                }
                this._on(_iframe, "focus", this._iframeFocus)
                ._on(_iframe, "keydown", this._iframeKeyDown)
                ._on(_iframe, "keypress", this._iframeKeypress)
                ._on(_iframe, "keyup", this._iframeKeyUp)
                ._on(_iframe, "mouseup", this._iframeMouseUp)
                ._on(_iframe, "mousedown", this._iframeMouseDown)                
                ._on($(window), "resize", this._windowResize)
                ._on(_iframe, "mouseover", 'table', this._tableMouseOver);
                if (this._isIE8() || !(this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion)))
					this._on(_iframe, "paste", this._iframePaste);
					
                if (!ej.isNullOrUndefined((document.getElementById(this._id + "_Iframe"))))
                    $(document.getElementById(this._id + "_Iframe").contentWindow).on('blur', { _proxy: this }, this._iframeFocusOut);
            }
        },

        _unwireEvents: function () {
            var _iframe = $(this._getDocument());
            if (!ej.isNullOrUndefined(this._createTable)) {
                this._off(this._createTable, "mousemove", "div.e-rte-tablecell")
                ._off(this._createTable, "mouseleave", "div.e-rte-table")
                ._off(this._createTable, "mousedown", "div.e-rte-tablecell")
                ._off($(document), "click", this._documentClick);
            }
            this._off(_iframe, "focus")
            ._off(_iframe, "keydown")
            ._off(_iframe, "keyup")
            ._off(_iframe, "mouseup")
            ._off(_iframe, "mousedown")
            ._off($(window), "resize", this._windowResize)
            ._off(_iframe, "mouseover", 'table', this._tableMouseOver);
            $(document.getElementById(this._id + "_Iframe").contentWindow).off('blur', this._iframeFocusOut);
            if (!ej.isNullOrUndefined(this._customTableDialog))
                this._off(this._customTableDialog.find(".e-rte-txtWidth"), "focusout");

        },

        _footerEvents: function (val) {
            this[val](this._htmlSource, "click", this._sourceCodeManager);
            this[val](this._clearFormat, "click", this._onClearFormat);
            this[val](this._clearAll, "click", this._clearAllManager);
        },


        _onChange: function () {
           var _prevhtml = $.trim(this.value());
            if (this.model.enableXHTML) {
                this._updateXhtml();
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._removeNoSpaceChar(this.value())));
            }
            if (_prevhtml !== this._removeNoSpaceChar(this.getHtml())) {
                this._updateValue();
                var args = { value: this.value(),text: this._getText(), htmlText: this.getHtml(), isInteraction: this._isInteraction, };
                this._trigger("change", args);
                this._isInteraction = true;
            }
        },
        _disableIframeContent: function () {
            try {
                this._rteIframe.contents().find("body,[contenteditable='true']").attr("contenteditable", false);
            }
            catch (err) { }
        },

        disable: function () {
            this.model.enabled = false; this._showHideContextMenu();
            this.element.attr("disabled", "disabled");
            this._unwireEvents();
            this.model.showToolbar && this._toolBarObj.disable();
            $(this._rteFooter).ejTooltip("option", "enabled", false);
            this._disableIframeContent();
            this._rteEditor.addClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.addClass("e-disable");
                this._resize.removeClass("e-resizable");
                this._footerEvents("_off");
            }
            this._disableResizeObj(false);
        },

        enable: function () {
            this.model.enabled = true; this._showHideContextMenu();
            this.element.removeAttr("disabled");
            this._wireEvents();
            this.model.showToolbar && this._toolBarObj.enable();
            $(this._rteFooter).ejTooltip("option", "enabled", true);
            this._rteIframe.contents().find("body,[contenteditable='false']").attr("contenteditable", true);
            this._rteEditor.removeClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.removeClass("e-disable");
                this._resize.addClass("e-resizable");
                this._footerEvents("_on");
            }
            this._disableResizeObj(true);
        },

        disableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.disableItemByID(this._rteId + "_" + id) : this._toolBarObj.disableItemByID(id);
            if (id == "undo") $("#" + this._rteId + "_" + id).addClass("e-rteTooldisable");
        },


        enableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.enableItemByID(this._rteId + "_" + id) : this._toolBarObj.enableItemByID(id);
            if (id == "undo" && $("#" + this._rteId + "_" + id).hasClass("e-rteTooldisable"));
            $("#" + id).removeClass("e-rteTooldisable");
        },


        removeToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && this._toolBarObj.removeItemByID(this._rteId + "_" + id);
            this._setIframeHeight();
        },

        refresh: function () {
            this._unwireEvents();
            this._setIFrames();
            this._setIframeHeight();
            if (this.model.enabled) this._wireEvents();
            else this._disableIframeContent();
            if (this.model.enableRTL) this._rteIframe.contents().find("body").css("direction", "rtl");
            this._showHideContextMenu();
        },


        show: function () {
            this._rteWapper.show();
            this._setIFrames();
        },


        hide: function () {
            this._rteWapper.hide();
        },

        setColorPickerType: function (value) {
            if (value == "palette" || value === "picker")
                this._imgPicker.option('modelType', value);
            else
                this._imgPicker.option('modelType', "default");
        },
        pasteContent: function (html) {
            this._pasteAPIFlag = true;
            this._pasteHtml(html);
            this._onChange();
        },
        getDocument: function () {
            return this._getDocument();
        },
        getHtml: function (encode) {
            if (this.model.enableXHTML) {
                if (this.model.enableHtmlEncode) {
                    if (encode == false)
                        return this._removeNoSpaceChar($.trim(this._decode(this.value())));
                    else
                        return this._removeNoSpaceChar($.trim(this.value()));
                }
                else
                    return this._removeNoSpaceChar($.trim(this.value()));
            }
            else {
                try {
                    if (this.model.enableHtmlEncode) {
                        if (encode == false)
                            return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                        else
                            return this._removeNoSpaceChar(this._encode($.trim(this._getDocument().body.innerHTML)));
                    }
                    else
                        return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                }
                catch (err) {
                    return "";
                }
            }
        },
        setHtml: function (value) {
            this._getDocument().body.innerHTML = "";
            this._getDocument().body.innerHTML = $.trim(value);
            this._onChange();
        },


        getText: function () {
            return this._getText();
        },


        executeCommand: function (cmdName, args, textnodeType) {
            if (this._isIE8() && ej.isNullOrUndefined(this._ieSelectionRange)) this._ieSelectionRange = this._getRange();
            else if (this._isIE() && cmdName.toLowerCase() == "inserthtml" && !this._isIE8()) {
                if (this._getRange().startContainer.nodeName.toLowerCase() != "body") {
                    this._currentSelNode = this._getRange().startContainer;
                }
                else {
                    this._ieLinkRange();
                }
            }
            if (this._trigger("execute", { commandName: cmdName })) return false;
            var anchor = "";
            if (ej.browserInfo().name == "chrome" && this._getWindow().getSelection().rangeCount == 0)
                this._restoreSelection(this._saveSelection());
            if (cmdName == "underline") {
                if (window.getSelection) {
                    anchor = $(this._getWindow().getSelection().anchorNode).parents("a");
                    if (anchor.length > 0) {
                        $(anchor).css("text-decoration", ($(anchor).css("text-decoration") == "none") ? "underline" : "none");
                        return;
                    }
                }
            }
            else if (cmdName.toLowerCase() == "inserthtml") {
                if (this._isIE() || (ej.browserInfo().name=="mozilla" && /class=(.*?)e-rte-table(.*?)>/ig.test(args))) {
                    this._pasteHtml(args, textnodeType);
                }
                else
                    this._getDocument().execCommand(cmdName, false, args);
                return;
            }
            else if (cmdName.toLowerCase() == "formatblock") {
                if (this._isIE()) {
                    if (args.charAt(0) != "<" && args.charAt(args.length - 1) != ">")
                        args = "<" + args + ">";
                }
            }
            if (ej.browserInfo().name == "msie")
                this._focus();
            if (this._isIE() && cmdName == "fontName") args = args.substring(0, args.indexOf(","));
            // if (!ej.isNullOrUndefined(this._tempEle) && this._tempEle.length > 0)
            // if ((this._tempEle.get(0).nodeName == "#text") && ($(this._tempEle.parents("li")).length > 0))
            // if ($(this._tempEle.parents("li")).prop("style")["font-size"] != "")
            // var lisize = $(this._tempEle.parents("li")).css("font-size");
            this._getDocument().execCommand(cmdName, false, args);
            this._onChange();
            if (cmdName != "fontName" && cmdName != "fontSize" && cmdName != "indent" && cmdName != "cut" && cmdName != "copy" && cmdName != "paste" && cmdName != "undo" && cmdName != "redo" && cmdName != "outdent" && !ej.isNullOrUndefined(this._toolBarObj))
                if (!this._toolBarObj.itemsContainer.find("li#" + this._rteId + "_" + cmdName).hasClass("e-active"))
                    this._toolBarObj.selectItemByID(this._rteId + "_" + cmdName);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + cmdName);
            //  if (!ej.isNullOrUndefined(this._tempEle)) this._bulletsResizing(lisize, cmdName);
            if (args != "listItem") this._setBackupData();
        },
        //The commented lines behavior need to achieve in custom exec-command task if possible
        // _bulletsResizing: function (lisize, cmd) {
        // if ((!ej.isNullOrUndefined(this._tempEle.get(0))) && cmd=="fontSize")
        // var li = this._tempEle.get(0).tagName == "BODY" ? this._tempEle.find("li") : this._tempEle.get(0).nodeName != "#text" ? $(this._tempEle.parents("body")).find("li") : "";
        // if (li != "")
        // $(li).each(function (index) {
        // //refreshig the li font size after font size of li content executed
        // fonttag = $(this).find("font")[0] || "";
        // if (fonttag != "") {
        // $(this).css("font-size", $($(fonttag)[0]).css("font-size"));
        // // $(li).find("font").removeAttr("style");
        // }
        // else
        // {
        // $(this).css("font-size", $(this).css("font-size"));
        // }
        // });


        // if (cmd == "fontSize" && (this._getCommandStatus('InsertOrderedList') || this._getCommandStatus('InsertOrderedList')))
        // if (this._tempEle.get(0).tagName == "LI" || this._tempEle.get(0).tagName == "OL") {

        // this._tempEle.css("font-Size", this._tempEle.find("font").css("font-Size"));
        // $(this._tempEle.find("font")).removeProp("style")["font-size"];
        // }
        // if (lisize != null) {

        // $(this._tempEle.parents("li")).css("font-size", lisize);
        // $(this._tempEle.parents("li")).find("font").removeAttr("style");
        // }

        // },


        focus: function () {
            this._focus();
        },


        getCommandStatus: function (value) {
            if (ej.isNullOrUndefined(value) || value != "")
                return this._getCommandStatus(value);
        },


        getSelectedHtml: function () {
            return this._getSelectedHtmlString();
        },

        insertMenuOption: function (option) {
            if (option.newItem && option.targetItem && option.insertType && option.menuType) {
                var menuObj = this._textMenuObj, element, elementId = option.newItem, data = option.spriteCssClass ? [{ text: option.newItem, id: elementId, spriteCssClass: option.spriteCssClass }] : [{ text: option.newItem, id: elementId }];
                for (var i = 0; i < menuObj.element.find('li a').length; i++) {
                    if ($(menuObj.element.find('li a')[i]).text() == option.targetItem) {
                        element = $(menuObj.element.find('li')[i]).attr('id');
                        break;
                    }
                }
                if (option.insertType == "insert") menuObj.insert(data, element ? "#" + element : element);
                else if (option.insertType == "insertAfter") menuObj.insertAfter(data, "#" + element);
                else if (option.insertType == "insertBefore") menuObj.insertBefore(data, "#" + element);
                (option.menuType.text && this._contextType.text.push(elementId));
                (option.menuType.image && this._contextType.image.push(elementId));
                (option.menuType.hyperlink && this._contextType.hyperlink.push(elementId));
                (option.menuType.table && (this._contextType.table.push(elementId), this._contextType.table_hyper.push(elementId)));
            }
        },
        removeMenuOption: function (targetElement) {
            var menuObj = this._textMenuObj; menuObj.remove(["#" + targetElement]);
            (index = $.inArray(targetElement, this._contextType.text)) != -1 && (this._contextType.text = this._removeContextData(index, this._contextType.text));
            (index = $.inArray(targetElement, this._contextType.image)) != -1 && (this._contextType.image = this._removeContextData(index, this._contextType.image));
            (index = $.inArray(targetElement, this._contextType.hyperlink)) != -1 && (this._contextType.hyperlink = this._removeContextData(index, this._contextType.hyperlink));
            (index = $.inArray(targetElement, this._contextType.table)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table));
            (index = $.inArray(targetElement, this._contextType.table_hyper)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table_hyper));
        },
        _removeContextData: function (index, data) {
            var temp = [];
            $(data).each(function (ind, elem) { (index != ind) && temp.push(elem); });
            return temp;
        },
        insertRow: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
				var newRow =  $(seletedCell).closest("tr").clone(), curRow = $(seletedCell).closest("tr");
                var cols = newRow.find("td").html("<br _moz_dirty=''/>");
                before ? newRow.insertBefore(curRow) : newRow.insertAfter(curRow);
                newRow.find("td:first").focus();
                this._setAutoHeight();
                return seletedCell;
            }
        },


        insertColumn: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var isTable = $(this._getSelectedNode()).closest("td");
                var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
                var colTemplate = $(seletedCell).clone(), curRow = $(seletedCell).closest("tr"), curCell;
				colTemplate[0].innerHTML = "<br _moz_dirty=''/>";
                var allRows = curRow.closest("table").find("tr");
                var colIndex = curRow.find("td").index(seletedCell);
                for (var i = 0; i < allRows.length; i++) {
                    curCell = $(allRows[i]).find("td")[colIndex];
                    before ? $(colTemplate.clone()).insertBefore(curCell) : $(colTemplate.clone()).insertAfter(curCell);
                }
                return seletedCell;
            }
        },


        removeRow: function (cell) {
            var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
            var range = this._getRange();
            var select; var node = null, curRow;
            var parentTable = $(seletedCell).closest("table");

            if (parentTable.find("tr").length == 1) {
                node = $(seletedCell).parent("tr").closest("table").next()[0] || $(seletedCell).parent("tr").closest("table").prev()[0];
                $(seletedCell).parent("tr").closest("table").remove();
            }
            else {
                node = ($(seletedCell).parent("tr").prev("tr").length != 0) ? $(seletedCell).parent("tr").prev("tr").find("td:last")[0] : $(seletedCell).parent("tr").next("tr").find("td:first")[0];
                curRow = $(seletedCell).closest("tr").remove();
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
            this._setAutoHeight();
        },
        selectRange: function (range, node) {
            this._focus();
            var select;
            if (!this._isIE8()) {
                select = this._getDocument().getSelection();
                select.removeAllRanges();
                select.addRange(range);
            }
            else {
                range.select();
            }
        },
        _encode: function (value) {
            return $('<div/>').text(value).html();
        },
        _decode: function (value) {
            return value.replace(/&amp;/g, "&").replace(/&amp;lt;/g, "<").replace(/&lt;/g, "<").replace(/&amp;gt;/g, ">").replace(/&gt;/g, ">").replace(/&nbsp;/g, " ").replace(/&amp;nbsp;/g, " ").replace(/&quot;/g);
        },
        createRange: function () {
            if (!this._isIE8())
                return this._getRange();
            else
                return this.getDocument().body.createTextRange();
        },
        _setRange: function (node, range, collapse) {
            if (!this._isIE8()) {
                range.setStart(node, 0);
                range.collapse(true);
                if ((ej.browserInfo().name != "msie" || ej.browserInfo().version == "11.0") || !ej.isNullOrUndefined(collapse)) {
                    this.selectRange(range);
                }
                else if (ej.isNullOrUndefined(collapse)) {
                    selection = this._getDocument().body.createTextRange();
                    selection.moveToElementText(node);
                }
            }
            else if (!ej.isNullOrUndefined(node)) {
                range.collapse(true);
                range.moveToElementText(node);
                range.moveStart("character", 1);
                range.select();
            }
        },

        removeColumn: function (cell) {
            var isTable = $(this._getSelectedNode()).closest("td");
            var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
            var range = this._getRange();
            var curRow = $(seletedCell).closest("tr");
            var allRows = curRow.closest("table").find("tr");
            var colIndex = curRow.find("td").index(seletedCell);
            var node = !ej.isNullOrUndefined(seletedCell.nextElementSibling) ? $(seletedCell.nextElementSibling)[0] : $(seletedCell.previousSibling)[0];
            if (ej.isNullOrUndefined(node))
                $(seletedCell).parent("tr").parents("table").remove();
            else {
                for (var i = 0; i < allRows.length; i++) {
                    $($(allRows[i]).find("td")[colIndex]).remove();
                }
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
        },


        removeTable: function (table) {
            var seletedTable = ej.isNullOrUndefined(table) ? $(this._getSelectedNode()).closest("table") : table, tableAction = $(seletedTable).parent().closest('table').length < 1;
            this._currentSelNode = $(seletedTable).parent()[0];
            $(seletedTable).remove();
            if (tableAction)
                this._toggleEditTable();
            this._setAutoHeight();
            this._removeResizeObject();
            $(this._getDocument()).find(".e-rte-tablebox").remove();
        }
    });

    ej.RTE.Locale = ej.RTE.Locale || {};

    ej.RTE.Locale["default"] = ej.RTE.Locale["en-US"] = {
        bold: "Bold",
        italic: "Italic",
        underline: "Underline",
        strikethrough: "Strikethrough",
        superscript: "Superscript",
        subscript: "Subscript",
        justifyCenter: "Align text center",
        justifyLeft: "Align text left",
        justifyRight: "Align text right",
        justifyFull: "Justify",
        unorderedList: "Insert unordered list",
        orderedList: "Insert ordered list",
        indent: "Increase Indent",
        fileBrowser: "File Browser",
        outdent: "Decrease Indent",
        cut: "Cut",
        copy: "Copy",
        paste: "Paste",
        paragraph: "Paragraph",
        undo: "Undo",
        redo: "Redo",
        upperCase: "Upper Case",
        lowerCase: "Lower Case",
        clearAll: "Clear All",
        clearFormat: "Clear Format",
        createLink: "Insert/Edit Hyperlink",
        removeLink: "Remove Hyperlink",
        tableProperties: "Table Properties",
        insertTable: "Insert",
        deleteTables: "Delete",
        imageProperties: "Image Properties",
        openLink: "Open Hyperlink",
        image: "Insert image",
        video: "Insert video",
        editTable: "Edit Table Properties",
        embedVideo: "Paste your embed code below",
        viewHtml: "View HTML",
        fontName: "Select font family",
        fontSize: "Select font size",
        fontColor: "Select color",
		customFontColor:"More Colors...",
		customBGColor:"More Colors...",
        format: "Format",
        backgroundColor: "Background color",
		TransBGColor:"Transparent",
        style: "Styles",
        deleteAlert: "Are you sure you want to clear all the contents?",
        copyAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+C keyboard shortcut instead of copy operation.",
        pasteAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+V keyboard shortcut instead of paste operation.",
        cutAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+X keyboard shortcut instead of cut operation.",
        videoError: "The text area can not be empty",
        imageWebUrl: "Web Address",
        imageAltText: "Alternate text",
        dimensions: "Dimensions",
        constrainProportions: "Constrain Proportions",
        linkWebUrl: "Web Address",
        imageLink: "Image as Link",
        imageBorder: "Image Border",
        imageStyle: "Style",
        linkText: "Text",
        linkTooltipLabel: "Tooltip",
        html5Support: "This tool icon only enabled in HTML5 supported browsers",
        linkOpenInNewWindow: "Open link in new window",
        tableColumns: "No.of Columns",
        tableRows: "No.of Rows",
        tableWidth: "Width",
        tableHeight: "Height",
        tableCellSpacing: "Cell spacing",
        tableCellPadding: "Cell padding",
        tableBorder: "Border",
        tableCaption: "Caption",
        tableAlignment: "Alignment",
        textAlign: "Text align",
        dialogUpdate: "Update",
        dialogInsert: "Insert",
        dialogCancel: "Cancel",
        dialogApply: "Apply",
        dialogOk: "Ok",
        createTable: "Insert Table",
        addColumnLeft: "Insert Columns to the Left",
        addColumnRight: "Insert Columns to the Right",
        addRowAbove: "Insert Rows Above",
        addRowBelow: "Insert Rows Below",
        deleteRow: "Delete entire row",
        deleteColumn: "Delete entire column",
        deleteTable: "Delete Table",
        customTable: "Create custom table...",
        characters: "Characters",
        words: "Words",
		w:"W",
		c:"C",
        general: "General",
        advanced: "Advanced",
        table: "Table",
        row: "Row",
        column: "Column",
        cell: "Cell",
        solid: "Solid",
        dotted: "Dotted",
        dashed: "Dashed",
        doubled: "Double",
        maximize: "Maximize",
        resize: "Minimize",
        swatches: "Swatches",
        quotation: "Quotation",
        heading1: "Heading 1",
        heading2: "Heading 2",
        heading3: "Heading 3",
        heading4: "Heading 4",
        heading5: "Heading 5",
        heading6: "Heading 6",
        segoeui: "Segoe UI",
        arial: "Arial",
        couriernew: "Courier New",
        georgia: "Georgia",
        impact: "Impact",
        lucidaconsole: "Lucida Console",
        tahoma: "Tahoma",
        timesnewroman: "Times New Roman",
        trebuchetms: "Trebuchet MS",
        verdana: "Verdana",
        disc: "Disc",
        circle: "Circle",
        square: "Square",
        number: "Number",
        loweralpha: "Lower Alpha",
        upperalpha: "Upper Alpha",
        lowerroman: "Lower Roman",
        upperroman: "Upper Roman",
        none: "None",
        linkTooltip: "ctrl + click to follow link",
        charSpace: "Characters (with spaces)",
        charNoSpace: "Characters (no spaces)",
        wordCount: "Word Count",
        left: "Left",
        right: "Right",
        center: "Center",
        zoomIn: "Zoom In",
        zoomOut: "Zoom Out",
        print: "Print",
        'import': "Import a Document",
        wordExport: "Export as Word Document",
        pdfExport: "Export as Pdf File",
        FindAndReplace: "Find and Replace",
        Find: "Find",
        MatchCase: "Match Case",
        WholeWord: "Whole Word",
        ReplaceWith: "Replace with",
        Replace: "Replace",
        ReplaceAll: "Replace All",
        FindErrorMsg: "Couldn't find specified word.",
		FindOf: " of ", 
		ReplaceCount: " occurrences were replaced.",
        addtodictionary: "Add to Dictionary",
        ignoreall: "IgnoreAll"
    };
ej.RTE.ToolbarOverflowMode = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar as inline on clicking the arrow. */
        Inline: "inline"
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
	"use strict";
    ej.RTE = ej.RTE || {};
    ej.RTE.FindAndReplace = {
	_findObject:null,
	_selectedIndex:-1,
	_findAndReplaceClick:function (args){
		var dialog=this._findDialog.element,text=$.trim($(dialog).find("[ej-function='findtxt']").val()),targetElement=(args.target.tagName=="SPAN"||args.target.tagName=="DIV")?$(args.target).closest("button")[0]:args.target,replacetxt=$(dialog).find("[ej-function='replacetxt']").val(),target=this.getDocument().body,findElement=$(dialog).find("[ej-function='replace'],[ej-function='replaceAll']"),navElement=$(dialog).find("[ej-function='prev'],[ej-function='next']");
		$(this._findDialog.element).children('span').html('');
		if(!$(targetElement).hasClass("e-disable"))
		switch(targetElement.getAttribute('ej-function'))
		{
			case "find":
			if(text){			
				this._findObject.find(text,target,!$(dialog).find("[ej-function='matchCase']")[0].checked,$(dialog).find("[ej-function='wholeWords']")[0].checked),this._selectedIndex=-1;
				if(this._findObject.nodeCollection.length){
					$('#'+ this._id + '_rtefindcount').html('');
					(this._findObject.nodeCollection.length>0)?findElement.ejButton("enable"):findElement.ejButton("disable");
					this._highlightNode(++this._selectedIndex,target);
					this._updateBtnStatus(this._selectedIndex,navElement);
				}
				else{
					$.merge(navElement,findElement).ejButton("disable");					
					this._findObject.revertAll();
					$(this._findDialog.element).children('span').html(this._getLocalizedLabels("FindErrorMsg"));
				}
			}
			else if(this._findObject.nodeCollection.length)
			this._findObject.revertAll();
			break;
			case "next":
			if(this._selectedIndex<this._findObject.nodeCollection.length){
				$('#'+ this._id + '_rtefindcount').html('');
			this._highlightNode(++this._selectedIndex,target);
			}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break
			case "prev":
			if(this._selectedIndex>0){
				$('#'+ this._id + '_rtefindcount').html('');
				this._highlightNode(--this._selectedIndex,target);
				}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break;
			case "replace":
					this._findObject.replaceByIndex(this._selectedIndex,replacetxt);
					if(!this._findObject.nodeCollection.length){
						$('#'+ this._id + '_rtefindcount').html('');	
						this._selectedIndex=-1;
					}
					else if (this._selectedIndex>this._findObject.nodeCollection.length-1) --this._selectedIndex;
					
					if(this._selectedIndex>-1){
						$('#'+ this._id + '_rtefindcount').html('');
						this._highlightNode(this._selectedIndex,target);
						this._updateBtnStatus(this._selectedIndex,navElement); 
					}
					else
						$.merge(navElement,findElement).ejButton("disable");
					this._setBackupData(); 
			break;
			case "replaceAll":
					var _replaceCount = this._findObject.replaceAll(replacetxt);this._selectedIndex=-1;
					$('#'+ this._id +'_rteReplaceCount').append(_replaceCount +this._getLocalizedLabels("ReplaceCount") );
					$.merge(navElement,findElement).ejButton("disable");					
					this._setBackupData(); 
			break;		
		}
		this._updateCount();        
	
	}, 
	_updateBtnStatus:function(_selectedIndex,element){
		(_selectedIndex<this._findObject.nodeCollection.length-1)?$(element[1]).ejButton("enable"):$(element[1]).ejButton("disable");
		(_selectedIndex>0)?$(element[0]).ejButton("enable"):$(element[0]).ejButton("disable");
	},
	_highlightNode:function(nodeIndex,target){
		$(target).find(".e-highlight").removeClass("e-highlight");
		for (var index=0;index<this._findObject.nodeCollection.length;index++){
			if(nodeIndex==index)
				for (var index1=0;index1<this._findObject.nodeCollection[index].length;index1++){
					$(this._findObject.nodeCollection[index][index1].node).addClass("e-highlight");
					$((ej.browserInfo().name=="msie"||ej.browserInfo().name=="mozilla")?target.parentElement:target).scrollTop($(this._findObject.nodeCollection[index][index1].node).offset().top - 25);
				}
				
		}
		$('#'+ this._id + '_rtefindcount').append(nodeIndex+ this._getLocalizedLabels("FindOf") + this._findObject.nodeCollection.length);		 
	},	

	_renderFindDialog:function (target){
		
	    var content = "<div id='" + this._id + "_basicDialog' title='" + this._getLocalizedLabels("FindAndReplace") + "'><div class='e-maincontent'><div class='e-fd-findcontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("Find") + "</span></div><div class='e-txtbox'><input type='text' ej-function='findtxt' id='" + this._id + "_findtxt' class='e-js e-input'></div><div id='" + this._id + "_rtefindcount' class='e-rtefindcount'></div></div><div class='e-fd-InnerContent'><div><input type='checkbox' ej-function='matchCase' id='" + this._id + "_matchCase' value='true'><label for='" + this._id + "_matchCase' class='e-fd-checkboxlable' style=''>" + this._getLocalizedLabels("MatchCase") + "</label></div><div class='e-checkbx'><input type='checkbox' ej-function='wholeWords' id='" + this._id + "_wholeWords' value='true'><label for='" + this._id + "_wholeWords' class='e-fd-checkboxlable'>" + this._getLocalizedLabels("WholeWord") + "</label></div></div><div class='e-fd-replacecontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("ReplaceWith") + "</span></div><div class='e-txtbox'><input type='text' ej-function='replacetxt' id='" + this._id + "_replacetxt' class='e-js e-input'></div></div></div><div id='" + this._id + "_rteReplaceCount' class='e-rteReplaceCount'></div><span style='text-align: center;'></span><div class='e-fd-btncol'><div class='e-btn-left'><button id='" + this._id + "_find' ej-function='find'>" + this._getLocalizedLabels("Find") + "</button><button id='" + this._id + "_replace' ej-function='replace'>" + this._getLocalizedLabels("Replace") + "</button><button id='" + this._id + "_replaceAll' class='ejRTE-replaceAll' ej-function='replaceAll'>" + this._getLocalizedLabels("ReplaceAll") + "</button></div><div class='e-btn-right'><button id='" + this._id + "_prev' ej-function='prev'></button><button id='" + this._id + "_next' ej-function='next'></button></div></div></div>";
		target._findDialog=$(content).ejDialog({
                width: "auto",
				minWidth:"300px",
				maxWidth:"380px",
				isResponsive:true,
                close:this._onCloseFindAndReplace,cssClass:"e-rte e-findandreplace",enableRTL:target.model.enableRTL,enableResize: false,enableModal: true				
            }).data("ejDialog");
			$(target._findDialog.element).find("input[type=text]").val("");
			$(target._findDialog.element).find("button").ejButton({height: 30});
			$(target._findDialog.element).find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
			$(target._findDialog.element).find("[ej-function='prev'],[ej-function='next']").ejButton({height: 30, width: 30,contentType: "imageonly"});
			$(target._findDialog.element).find("[ej-function='prev']").ejButton({ prefixIcon:"e-icon e-chevron-left_02"}).next().ejButton({ prefixIcon: "e-icon e-chevron-right_02"});
			$(target._findDialog.element).find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({enableRTL:target.model.enableRTL,checked:  false});				
			this._findObject=new ej.FindAndReplace()
			this._on(target._findDialog.element.find("button"), "click", this._findAndReplaceClick);
	},
	_onCloseFindAndReplace:function(args){
					$("#"+this._id.replace("_basicDialog","")).data("ejRTE")._findObject.revertAll();
					this.element.find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
					this.element.find("input[type=text]").val("");
					this.element.find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({checked:false});
					this.element.children('span').html('');
					$('.e-rteReplaceCount').html('');
					$('.e-rtefindcount').html('');
	},
	_showFindAndReplace:function (){
		this._findDialog?this._findDialog.open():this._renderFindDialog(this);
	}
	
	}
	
})(jQuery, Syncfusion);

(function() {

  ej.FindAndReplace = function() {
    this.indexLength=0,this.elements=[],this.matches=[],this.nodeCollection=[];
	this.specialChar=/([{}()|[\]\/\\.*+?^=!:$])/g,this.escapeContent='\\$1';
  }
  ej.FindAndReplace.prototype._addContentEscape=function(content){
	return String(content).replace(this.specialChar, this.escapeContent);
  }

  ej.FindAndReplace.prototype.find=function(text,node,igncase,wholeword){
	if(this.nodeCollection.length)
		this.revertAll();
	this._validateTextContent(text,this._getFormatedText(node,wholeword),igncase,wholeword);
	if(this.matches.length)
	{
		this._iterateNodes(node),this.matches=[];
		return true;
	}
	else
		return false;
  }
  ej.FindAndReplace.prototype._replace=function(collection,text){
	for(var index1=0;index1<collection.length;index1++) 
		(!index1||!text)?this._elementDefragment(collection[index1].node,text):$(collection[index1].node).remove();	
}
  ej.FindAndReplace.prototype.replaceByIndex=function(Index,text){
	var tempNodes=[]
	for(var index=0;index<this.nodeCollection.length;index++) 
		(index==Index)?	this._replace(this.nodeCollection[index],text):tempNodes.push(this.nodeCollection[index]);	
	this.nodeCollection=tempNodes;
}
  ej.FindAndReplace.prototype.replaceAll=function(text){
	for(var index=0;index<this.nodeCollection.length;index++) 
		this._replace(this.nodeCollection[index],text);	
	this.nodeCollection=[];
	return index;
}

  ej.FindAndReplace.prototype.revertAll=function(){
	for(var index=0;index<this.nodeCollection.length;index++) 
	this._replace(this.nodeCollection[index]);
	this.nodeCollection=[];
}
  
 ej.FindAndReplace.prototype._elementDefragment=function (node,text){
var tempNode=node.nextSibling,tempNode1=node.previousSibling;

if(tempNode&&tempNode1&&tempNode.nodeType==3 && tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data)+node.nextSibling.data;	
	$(node.nextSibling).remove();
	$(node).remove();
}
else if(tempNode&&tempNode.nodeType==3)
{	
	tempNode=node.nextSibling;
	tempNode.data=(text!= undefined ? text:node.firstChild.data)+tempNode.data;
	$(node).remove();
}
else if(tempNode1&&tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data);
	$(node).remove();
}
else 
{
	tempNode=(text!= undefined) ? document.createTextNode(text):node.firstChild;
	$(node).replaceWith(tempNode);
}
}

  ej.FindAndReplace.prototype._validateTextContent=function(text,content,igncase,wholeword){
	var temp = content;
	var content = wholeword ? content.split("\n").join('') : content;
 	var target=this._addContentEscape(text),regx=new RegExp(wholeword ? "\\b"+target+"\\b":target,igncase?'gi':'g');
	while(data=regx.exec(content))
		this.matches.push({startIndex:data.index,endIndex:data.index+text.length});
	if(this.matches.length == 0 && wholeword){
	    var indices = []; 
		for(var i=0; i<temp.length;i++) {
			if (temp[i] === "\n") indices.push(i);
		}
	    content = wholeword ? temp.replace(/\n/g,' ') : temp;
		var target=this._addContentEscape(text),regx=new RegExp(wholeword ? "\\b"+target+"\\b":target,igncase?'gi':'g');
		while(data=regx.exec(content)){
			var count = 0, si = data.index, ei = data.index+text.length;
			for(var i = 0; i< indices.length;i++){
				if(indices[i] <= si) count++;
			}
			this.matches.push({startIndex: si - count,endIndex: ei - count });
		}
	}
	return this.matches;
}

 ej.FindAndReplace.prototype._traverseNode=function(element,data){

	if (element.nodeType === 3)	
	{	
		out=this._validateData(element,data);
		if(out.curNode) element=out.curNode;
			if(out.status)
			return true;
	}
	
	if(element=element.firstChild)
	do
	{	  
		if(element.nodeType === 3)
		{
			out=this._validateData(element,data);
			if(out.curNode) element=out.curNode;
			if(out.status)
				return true;
		}
		else 		
		{		
			if(this._traverseNode(element,data))
				return true;
		}
	}while(element=element.nextSibling)
	
	return false;
}

 ej.FindAndReplace.prototype._validateData=function(curNode,data){
	var startIndex=this.indexLength,endIndex=this.indexLength+curNode.length;this.indexLength=this.indexLength+curNode.length;	
	if(startIndex>=data.startIndex||data.startIndex<endIndex)
		return this._elementFragment(data,{startIndex:startIndex,endIndex:endIndex},curNode);
	else 
		return {status:false};

}

 ej.FindAndReplace.prototype._elementFragment=function(cIndex,eIndex,element){
	var tempdata=element.data,finalNode=element;
	if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))//full Element Replacement
	{
		finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(element.data))[0];
		$(element).replaceWith(finalNode);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempindex=(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(0,tempindex)))[0];
		$(dataNode).insertBefore(element);
		element.data=tempdata.substr(tempindex);
		this.elements.push({node:dataNode});
	}	
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))
	{
		
		tempindex=(cIndex.startIndex-eIndex.startIndex),finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(tempindex)))[0];
		$(finalNode).insertAfter(element);
		element.data=tempdata.substr(0,tempindex);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempstart=(cIndex.startIndex-eIndex.startIndex),tempend=tempstart+(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substring(tempstart,tempend)))[0];finalNode=document.createTextNode(tempdata.substring(tempend));		
		element.data=tempdata.substr(0,tempstart);
		$(finalNode).insertAfter(element);
		$(dataNode).insertAfter(element);		
		this.elements.push({node:dataNode});
	}
	return {status:cIndex.endIndex>eIndex.startIndex && cIndex.endIndex<=eIndex.endIndex,curNode:finalNode};
}

 ej.FindAndReplace.prototype._getFormatedText=function (element,wholeword){
	var text='';
	if (element.nodeType === 3) return element.data.replace(/\n/g,' ');
	
	if(element=element.firstChild)
	do
	{	  
		text+= (element.nodeType === 3)? (element.data.replace(/\n/g,' ') + (wholeword ? "\n": "") ):this._getFormatedText(element,wholeword);		
	}while(element=element.nextSibling)
	
	return text;
				
}

 ej.FindAndReplace.prototype._iterateNodes=function (curNode){
	temp=this;
	$(this.matches).each(function(index,data)
	{
		temp._traverseNode(curNode,data),temp.nodeCollection.push(temp.elements),temp.indexLength=0,temp.elements=[];		
	});
}
}());


if(ej.RTE.FindAndReplace)
 $.extend(ej.RTE.prototype, ej.RTE.FindAndReplace);;
var clipboardCleaner = (function () {
    function clipboardCleaner(currentDocument, callback, env) {
        this.CleanerState = true;
        this.syncLoad = false;
        this.listContents = [];
        this.blockNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
        this.flagState = true;
        this.content = null;
        this.htmlContent = "";
        this.insertCleanedContent = true;
        this.filterOptions = {
            listConversion: true, cleanCSS: true,
            removeStyles: false,
            cleanElements: true
        };
        this.Collection = [];
        this.blockqouteNodes = [];
        this.tempCleaner = [];
        this.ignorableNodes = ["A", "APPLET", "B", "BLOCKQUOTE",
            "BR", "BUTTON", "CENTER", "CODE", "COL", "COLGROUP", "DD", "DEL", "DFN", "DIR", "DIV", "DL", "DT", "EM",
            "FIELDSET", "FONT", "FORM", "FRAME", "FRAMESET", "H1", "H2", "H3", "H4", "H5", "H6", "HR", "I", "IMG",
            "IFRAME", "INPUT", "INS", "LABEL", "LI", "OL", "OPTION", "P", "PARAM", "PRE", "Q",
            "S", "SELECT", "SPAN", "STRIKE", "STRONG", "SUB", "SUP", "TABLE", "TBODY", "TD", "TEXTAREA", "TFOOT", "TH", "THEAD", "TITLE", "TR",
            "TT", "U", "UL"];
        this.listNodes = [];
        this.ulData = [
            "disc",
            "square",
            "circle",
            "disc",
            "square",
            "circle"
        ];
        this.olData = [
            "decimal",
            "lower-alpha",
            "lower-roman",
            "upper-alpha",
            "upper-roman",
            "lower-greek"
        ];
        var temp = this;
        this.callback = callback;
        this.env = env;
        this.currentDocument = currentDocument;
        if (this._isIE()) {
            if (this.currentDocument.body.addEventListener) {
                this.currentDocument.body.addEventListener("keydown", keyEventRouter);
            }
            else
                this.currentDocument.body.attachEvent("onkeydown", keyEventRouter);
        }
        if (this.currentDocument.body.addEventListener)
            this.currentDocument.body.addEventListener("paste", pasteRouter);
        else
            this.currentDocument.body.attachEvent("onpaste", pasteRouter);
        function pasteRouter(args) {
            if (temp.CleanerState) {
                temp._pasteHandler(args);
                if (temp.syncLoad) {
                    args.preventDefault();
                    args.stopPropagation();
                    return false;
                }
            }
        }
        function keyEventRouter(args) {
            if (temp.CleanerState)
                temp._keydownHandler(args);
        }
    }
    clipboardCleaner.prototype._keydownHandler = function (e, state) {
        if (state === void 0) { state = false; }
        if ((this._isIE() && e.ctrlKey && !e.shiftKey && e.keyCode == 86 && this.flagState) || state) {
            this.flagState = false;
            this._setContent();
        }
    };
    clipboardCleaner.prototype._setContent = function () {
        var temp = this;
        this.content = this.currentDocument.createElement("div");
        var tempText, tempBlock = this.currentDocument.createElement("P");
        this.content.id = "ClipboardData";
        this.content.style.position = "absolute";
        this.content.style.height = "10px";
        this.content.style.width = "10px";
        this.content.style.overflow = "hidden";
        this.content.style.top = "-3000px";
        tempText = this.currentDocument.createTextNode("PastedContent");
        if (ej.browserInfo().name == "chrome") {
            tempBlock.appendChild(tempText);
            this.content.appendChild(tempBlock);
        }
        else
            this.content.appendChild(tempText);
        if (window.getSelection) {
            var selection = this.currentDocument.getSelection();
            if (selection.rangeCount > 0) {
                var range = selection.getRangeAt(0);
                range.deleteContents();
                range.collapse(true);
                range.insertNode(this.content);
                this._updateRange(tempText, 0, tempText.textContent.length);
                this.content.focus();
                this.syncLoad = false;
            }
        }
    };
    clipboardCleaner.prototype._insertContent = function (args) {
        if (args === void 0) { args = true; }
        var tempSpanNode = this.currentDocument.createElement("span"), elemColl = [], content, blockElem = this.currentDocument.createElement("p");
        tempSpanNode.appendChild(content = this.currentDocument.createTextNode(String.fromCharCode(65279)));
        blockElem.appendChild(tempSpanNode);
        this._finalCleanup(this.Container);
        this.Container.appendChild(blockElem);
        if (this._isIE() && args) {
            elemColl = [];
            for (var gt = this.Container.childNodes.length - 1; gt > -1; gt--)
                elemColl.push(this.Container.childNodes.item(gt));
            for (var gt = 0; gt < elemColl.length; gt++)
                this._insertAfter(this.content, elemColl[gt]);
            this.content.removeNode(true);
        }
        else
            this._contentPositionHandler();
        $((ej.browserInfo().name == "msie" || ej.browserInfo().name == "mozilla") ? this.currentDocument.body.parentNode : this.currentDocument.body).scrollTop($(tempSpanNode).offset().top - 25);
        this.callback.call(this.env);
        this._updateRange(content, 0, content.textContent.length);
    };
    clipboardCleaner.prototype._insertAfter = function (elem, newElem) {
        if (elem.nextSibling) {
            elem.parentElement.insertBefore(newElem, elem.nextSibling);
        }
        else {
            elem.parentElement.appendChild(newElem);
        }
    };
    clipboardCleaner.prototype._findValidListType = function (elem) {
        if (elem.nodeType == 3 && elem.textContent.trim().length > 0) {
            this.listContents.push(elem.textContent);
        }
        if (elem = elem.firstChild) {
            do {
                this._findValidListType(elem);
            } while (elem = elem.nextSibling);
        }
    };
    clipboardCleaner.prototype._createNodeCollection = function (parentNodes) {
        var leafnode, temp = this.currentDocument.createElement(parentNodes.shift()), tagName;
        leafnode = temp;
        while (tagName = parentNodes.shift()) {
            temp = this.currentDocument.createElement(tagName).appendChild(temp);
        }
        return { leaf: leafnode, root: temp };
    };
    clipboardCleaner.prototype._contentPositionHandler = function () {
        var selection = this.currentDocument.getSelection(), elem, tempElem, parentNodes = [], childNodes = [], nodeSet;
        if (selection.rangeCount > 0) {
            if (this.content) {
                var range_1 = this.currentDocument.createRange(), Selection_1 = this.currentDocument.getSelection();
                range_1.selectNode(this.content);
                Selection_1.removeAllRanges();
                Selection_1.addRange(range_1);
            }
            var range = selection.getRangeAt(0);
            if (range.startContainer == range.endContainer) {
                if (range.startOffset != range.endOffset)
                    range.deleteContents();
                range.insertNode(this.Container);
                elem = this.Container.parentNode;
                if (elem.nodeName.toLowerCase() != "body") {
                    do
                        parentNodes.push(elem.nodeName.toLowerCase());
                    while (this.blockNode.indexOf(elem.nodeName.toLowerCase()) == -1 && (elem = elem.parentElement));
                    nodeSet = this._createNodeCollection(parentNodes);
                    if (elem)
                        if (elem.nextSibling)
                            elem.parentElement.insertBefore(nodeSet.root, elem.nextSibling);
                        else
                            elem.parentElement.appendChild(nodeSet.root);
                    elem = this.Container;
                    while (elem = elem.nextSibling)
                        nodeSet.leaf.appendChild(elem);
                    this._insertAfter(this.Container.parentElement, this.Container);
                }
                for (var index = 0; index < this.Container.childNodes.length; index++)
                    childNodes.push(this.Container.childNodes[index]);
                while (tempElem = childNodes.shift())
                    this.Container.parentElement.insertBefore(tempElem, this.Container);
            }
            else {
                range.deleteContents();
                range.insertNode(this.Container);
                for (var index = 0; index < this.Container.childNodes.length; index++) {
                    childNodes.push(this.Container.childNodes[index]);
                }
                while (tempElem = childNodes.shift())
                    this.Container.parentElement.insertBefore(tempElem, this.Container);
            }
        }
        this._remove(this.Container);
        this._remove(this.content);
        this.content = null;
    };
    clipboardCleaner.prototype._updateRange = function (node, sOffset, eOffset) {
        var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection();
        range.setStart(node, sOffset);
        range.setEnd(node, eOffset);
        Selection.removeAllRanges();
        Selection.addRange(range);
    };
    clipboardCleaner.prototype._pasteHandler = function (args) {
        this.clipboardData = { plain: null, rtf: null, html: null };
        this.syncLoad = false;
        if (this._isIE())
            this._extractClipboardIE(args);
        else {
            this._fillClipboard(args);
            this._extractClipboardNonIE(args);
        }
    };
    clipboardCleaner.prototype._isIE = function () {
        return navigator.userAgent.match(/Trident|msie/i) != null;
    };
    clipboardCleaner.prototype._extractClipboardNonIE = function (args) {
        if (this.clipboardData.html) {
            this.content = null;
            this.htmlContent = this.clipboardData.html;
            this._processContent(args);
        }
        else if (ej.browserInfo().name == "chrome" && this.clipboardData.plain) {
            var temp = this.currentDocument.createElement("div"), content, tempcontents = this.clipboardData.plain.split("\n");
            var temp2 = this.currentDocument.createElement("p");
            if (tempcontents.length) {
                while (content = tempcontents.shift()) {
                    temp2.appendChild(this.currentDocument.createTextNode(content));
                    tempcontents.length && temp2.appendChild(this.currentDocument.createElement("br"));
                }
            }
            else {
                temp2.appendChild(this.currentDocument.createTextNode(this.clipboardData.plain));
            }
            this.htmlContent = temp2.innerHTML;
            this._processContent(args, false);
        }
        else if (args && args.clipboardData && args.clipboardData.items.length) {
            this.callback.call(this.env, args);
        }
        else {
            this._setContent();
            this._contentUpdater();
        }
    };
    clipboardCleaner.prototype._extractClipboardIE = function (args) {
        this._contentUpdater();
    };
    clipboardCleaner.prototype._contentUpdater = function () {
        var temp = this;
        setTimeout(function () {
            if (temp.content)
                temp.clipboardData.html = temp.htmlContent = temp.content.innerHTML;
            !temp.flagState && (temp.flagState = true);
            temp._processContent();
        }, 0);
    };
    clipboardCleaner.prototype._fillClipboard = function (args) {
        this.clipboardData.html = args.clipboardData.getData("text/html") ? args.clipboardData.getData("text/html") : null;
        this.clipboardData.plain = args.clipboardData.getData("text/plain") ? args.clipboardData.getData("text/plain") : null;
        this.clipboardData.rtf = args.clipboardData.getData("text/rtf") ? args.clipboardData.getData("text/rtf") : null;
    };
    clipboardCleaner.prototype._processContent = function (args, state) {
        if (args === void 0) { args = null; }
        if (state === void 0) { state = true; }
        var elm = this.currentDocument.createElement("p"), temp = this, nonBlock = true;
        var patern = /class="?Mso|style="[^ ]*\bmso-/i, tempContainer = this.currentDocument.createElement("p"), ChildNode;
        if (patern.test(this.htmlContent) && state) {
            this.htmlContent = this.htmlContent.replace(/<img[^>]+>/i, "");
            elm.innerHTML = this.htmlContent;
            this.syncLoad = true;
            this.Collection = [];
            this.blockqouteNodes = [];
            this.listNodes = [];
            this._cleanup(elm);
            this._flush();
            if (this.filterOptions.listConversion) {
                this._listConverter();
            }
            if (this.filterOptions.cleanElements) {
                this._blockquoteConvert();
                this._cleanElement(elm);
                this._flush();
            }
            if (this.filterOptions.cleanCSS) {
                this._cleanStyles(elm);
                this._flush(false);
            }
            this.Container = elm;
            if (this.insertCleanedContent)
                this._insertContent();
        }
        else {
            this.syncLoad = true;
            elm.innerHTML = this.htmlContent;
            if (this.filterOptions.cleanCSS) {
                this._cleanStyles(elm);
                this._flush(false);
            }
            if (elm.childNodes.length) {
                for (var index = 0; index < elm.childNodes.length; index++) {
                    if (this.blockNode.indexOf(elm.childNodes[index].nodeName.toLowerCase()) != -1)
                        nonBlock = false;
                }
                if (nonBlock) {
                    tempContainer.appendChild(elm);
                    elm = tempContainer;
                }
            }
            this.Container = elm;
            if (this.insertCleanedContent)
                this._insertContent(!nonBlock);
        }
    };
    clipboardCleaner.prototype._flush = function (check) {
        if (check === void 0) { check = true; }
        var temp, tempColl = [];
        if (check) {
            while (temp = this.tempCleaner.shift())
                this._remove(temp);
        }
        else
            while (temp = this.tempCleaner.shift()) {
                if (temp.childNodes.length) {
                    tempColl = [];
                    for (var index = 0; index < temp.childNodes.length; index++) {
                        tempColl.push(temp.childNodes[index]);
                    }
                    for (var index = 0; index < tempColl.length; index++) {
                        temp.parentElement.insertBefore(tempColl[index], temp);
                    }
                }
                this._remove(temp);
            }
    };
    clipboardCleaner.prototype._makeConvertion = function () {
        var root = this.currentDocument.createElement("div"), temp, pLevel = 1, prevList, listCount = 0, elem;
        for (var index = 0; index < this.Collection.length; index++) {
            if ((this.Collection[index].level == 1) && listCount == 0) {
                if (this.Collection[index].content) {
                    root.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                    prevList = this.currentDocument.createElement("li");
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                    temp.appendChild(prevList);
                    temp.setAttribute("level", this.Collection[index].level.toString());
                    temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                }
            }
            else if (this.Collection[index].level == pLevel) {
                if (prevList.parentElement.tagName.toLowerCase() == this.Collection[index].type) {
                    prevList.parentElement.appendChild(prevList = this.currentDocument.createElement("li"));
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                }
                else {
                    temp = this.currentDocument.createElement(this.Collection[index].type);
                    this._insertAfter(prevList.parentElement, temp);
                    prevList = this.currentDocument.createElement("li");
                    prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                    temp.appendChild(prevList);
                    temp.setAttribute("level", this.Collection[index].level.toString());
                }
            }
            else if (this.Collection[index].level > pLevel) {
                prevList.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                prevList = this.currentDocument.createElement("li");
                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                temp.appendChild(prevList);
                prevList.style.marginLeft = (this.Collection[index].level - pLevel - 1) * 40 + "px";
                temp.setAttribute("level", this.Collection[index].level.toString());
                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
            }
            else if (this.Collection[index].level == 1) {
                if (root.lastChild.tagName.toLowerCase() == this.Collection[index].type)
                    temp = root.lastChild;
                else
                    root.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                prevList = this.currentDocument.createElement("li");
                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                temp.appendChild(prevList);
                temp.setAttribute("level", this.Collection[index].level.toString());
                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
            }
            else {
                elem = prevList;
                while (elem = elem.parentElement) {
                    if (elem.attributes.getNamedItem("level")) {
                        if (parseInt(elem.attributes.getNamedItem("level").textContent) == this.Collection[index].level) {
                            if (elem.tagName.toLowerCase() == this.Collection[index].type) {
                                prevList = this.currentDocument.createElement("li");
                                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                                elem.appendChild(prevList);
                            }
                            else {
                                temp = this.currentDocument.createElement(this.Collection[index].type);
                                this._insertAfter(prevList.parentElement, temp);
                                prevList = this.currentDocument.createElement("li");
                                prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                                temp.appendChild(prevList);
                                temp.setAttribute("level", this.Collection[index].level.toString());
                                temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                            }
                            break;
                        }
                        else if (this.Collection[index].level > parseInt(elem.attributes.getNamedItem("level").textContent)) {
                            elem.appendChild(temp = this.currentDocument.createElement(this.Collection[index].type));
                            prevList = this.currentDocument.createElement("li");
                            prevList.appendChild(this.currentDocument.createTextNode(this.Collection[index].content.textContent));
                            temp.appendChild(prevList);
                            prevList.style.marginLeft = (this.Collection[index].level - parseInt(elem.attributes.getNamedItem("level").textContent) - 1) * 40 + "px";
                            temp.setAttribute("level", this.Collection[index].level.toString());
                            temp.style.listStyle = this._getlistStyle(this.Collection[index].type, this.Collection[index].level);
                            break;
                        }
                    }
                    continue;
                }
            }
            pLevel = this.Collection[index].level;
            listCount++;
        }
        return root;
    };
    clipboardCleaner.prototype._listConverter = function () {
        var content, level, type, stNode, tempNode;
        var data = [], elemColl = [];
        for (var index = 0; index < this.listNodes.length; index++) {
            if (this.listNodes[index] == null) {
                data.push({ content: this._makeConvertion(), node: this.listNodes[index - 1] });
                this.Collection = [];
                continue;
            }
            content = this.listNodes[index].attributes.getNamedItem("style").textContent;
            if (content && content.indexOf("level") != -1)
                level = parseInt(content.charAt(content.indexOf("level") + 5));
            else
                level = 1;
            this.listContents = [];
            this._findValidListType(this.listNodes[index]);
            if (this.listContents[0].length > 1)
                type = "ol";
            else
                type = "ul";
            tempNode = this.listContents[1] ?
                this.currentDocument.createTextNode(this.listContents[1]) :
                this.currentDocument.createTextNode("");
            this.Collection.push({
                type: type,
                content: tempNode,
                level: level
            });
        }
        while ((stNode = this.listNodes.shift()) ? stNode : (stNode = this.listNodes.shift())) {
            elemColl = [];
            for (var temp1 = 0; temp1 < data.length; temp1++) {
                if (data[temp1].node == stNode) {
                    for (var index = 0; index < data[temp1].content.childNodes.length; index++) {
                        elemColl.push(data[temp1].content.childNodes[index]);
                    }
                    for (var index = 0; index < elemColl.length; index++) {
                        stNode.parentElement.insertBefore(elemColl[index], stNode);
                    }
                    break;
                }
            }
            stNode.remove && stNode.remove();
            stNode.removeNode && stNode.removeNode(true);
        }
    };
    clipboardCleaner.prototype._blockquoteConvert = function () {
        var temp, elemColl = [];
        for (var index = 0; index < this.blockqouteNodes.length; index++) {
            temp = this.currentDocument.createElement("blockquote");
            elemColl = [];
            if (this.blockqouteNodes[index].childNodes && this.blockqouteNodes[index].childNodes.length) {
                for (var gt = 0; gt < this.blockqouteNodes[index].childNodes.length; gt++)
                    elemColl.push(this.blockqouteNodes[index].childNodes.item(gt));
                for (var gt = 0; gt < elemColl.length; gt++)
                    temp.appendChild(elemColl[gt]);
            }
            this.blockqouteNodes[index].parentElement.insertBefore(temp, this.blockqouteNodes[index]);
            this.blockqouteNodes[index].remove && this.blockqouteNodes[index].remove();
            this.blockqouteNodes[index].removeNode && this.blockqouteNodes[index].removeNode(true);
        }
    };
    clipboardCleaner.prototype._cleanup = function (node) {
        var temp, prevflagState;
        for (var index = 0; index < node.childNodes.length; index++) {
            if (this.ignorableNodes.indexOf(node.childNodes[index].nodeName) == -1 ||
                (node.childNodes[index].nodeType == 3 && node.childNodes[index].textContent.trim() == '')) {
                this.tempCleaner.push(node.childNodes[index]);
                continue;
            }
            else if (node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msoquote") != -1) {
                this.blockqouteNodes.push(node.childNodes[index]);
            }
            else if (node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1) {
                this.listNodes.push(node.childNodes[index]);
            }
            if (prevflagState && (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1) && !(node.childNodes[index].className &&
                node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1))
                this.listNodes.push(null);
            if (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1)
                if (node.childNodes[index].className &&
                    node.childNodes[index].className.toLowerCase().indexOf("msolistparagraph") != -1)
                    prevflagState = true;
                else
                    prevflagState = false;
        }
        if (this.listNodes.length && (this.listNodes[this.listNodes.length - 1] != null)) {
            this.listNodes.push(null);
        }
    };
    clipboardCleaner.prototype._finalCleanup = function (node) {
        var temp, elemCollection = [];
        for (var index = 0; index < node.childNodes.length; index++) {
            if (node.childNodes[index] && node.childNodes[index].nodeType != 3
                && (this.blockNode.indexOf(node.childNodes[index].nodeName.toLowerCase()) != -1)
                && node.childNodes[index].innerHTML
                && (node.childNodes[index].innerHTML.trim() == ""))
                elemCollection.push(node.childNodes[index]);
        }
        while (temp = elemCollection.shift())
            this._remove(temp);
    };
    clipboardCleaner.prototype._getlistStyle = function (listType, level) {
        level = (level > 0) ? level - 1 : level;
        if (listType == 'ol')
            return (level < this.olData.length ? this.olData[level] : this.olData[0]);
        else
            return (level < this.ulData.length ? this.ulData[level] : this.ulData[0]);
    };
    clipboardCleaner.prototype._cleanElement = function (elem) {
        var temp;
        if (elem.nodeType == 3) {
            if (elem.textContent.trim() == '')
                this.tempCleaner.push(elem);
        }
        else if (elem && this.ignorableNodes.indexOf(elem.nodeName) == -1) {
            this.tempCleaner.push(elem);
        }
        if (elem = elem.firstChild)
            do {
                this._cleanElement(elem);
            } while (elem = elem.nextSibling);
    };
    clipboardCleaner.prototype._cleanStyles = function (elem) {
        var temp;
        if (elem && elem.nodeType != 3) {
            this._cleanCSSClass(elem);
            this._cleanCSSStyle(elem);
            if ((elem.nodeName == "SPAN")
                && !elem.attributes.getNamedItem("style")
                && !elem.attributes.getNamedItem("class")) {
                this.tempCleaner.push(elem);
            }
            else if ((elem.nodeName == "FONT")
                && this.filterOptions.removeStyles) {
                this.tempCleaner.push(elem);
            }
        }
        if (elem = elem.firstChild)
            do {
                this._cleanStyles(elem);
            } while (elem = elem.nextSibling);
    };
    clipboardCleaner.prototype._cleanCSSClass = function (elem) {
        if (elem.attributes && elem.attributes.getNamedItem("class") && (this.filterOptions.cleanCSS || this.filterOptions.removeStyles)) {
            var classData = elem.className.split(" "), finalClases = '', attrib = void 0;
            for (var index = 0; index < classData.length; index++) {
                if (classData[index].toLowerCase().indexOf("mso") == -1 && this.filterOptions.cleanCSS) {
                    finalClases += classData[index] + " ";
                }
            }
            if (finalClases.length && !this.filterOptions.removeStyles) {
                attrib = this.currentDocument.createAttribute("class");
                attrib.value = finalClases;
                elem.attributes.setNamedItem(attrib);
            }
            else
                elem.attributes.removeNamedItem("class");
        }
    };
    clipboardCleaner.prototype._cleanCSSStyle = function (elem) {
        if (elem.attributes && elem.attributes.getNamedItem("style") && (this.filterOptions.cleanCSS || this.filterOptions.removeStyles)) {
            var styleData = elem.attributes.getNamedItem("style").textContent.split(";"), finalCss = '', attrib = void 0;
            for (var index = 0; index < styleData.length; index++) {
                if (styleData[index].toLowerCase().indexOf("mso") == -1) {
                    finalCss += styleData[index] + ";";
                }
            }
            if (finalCss.length && !this.filterOptions.removeStyles) {
                attrib = this.currentDocument.createAttribute("style");
                attrib.value = finalCss;
                elem.attributes.setNamedItem(attrib);
            }
            else
                elem.attributes.removeNamedItem("style");
            if (elem.attributes.getNamedItem("align") && !(elem.tagName === "FONT"))
                elem.attributes.removeNamedItem("align");
        }
    };
    clipboardCleaner.prototype._remove = function (elem) {
        if (elem)
            if (elem.remove)
                elem.remove();
            else if (elem.removeNode)
                elem.removeNode(true);
            else if (elem.textContent)
                elem.textContent = "";
    };
    return clipboardCleaner;
}());
$.extend(ej, { "clipboardCleaner": clipboardCleaner });
window["ClipboardCleaner"] = undefined;
;
"use strict";
var documentManager;
(function (documentManager) {
    var editorManager = (function () {
        function editorManager(target, win) {
            this.formatInfo = new formateDataCollection();
            this._nodeCollection = [];
            this._iterationStatus = false;
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.advanceFilterNode = ["img", "video", "table", "tbody", "tr", "td", "th"];
            this.indentFilter = ["img", "video"];
            this._junkSpanNodes = [];
            this.currentDocument = target;
            this.currentWindow = win;
            this._rangeExtract = new RangeExtractor(this.currentDocument);
            this._bindEvent();
        }
        editorManager.prototype._bindEvent = function () {
            $(this.currentDocument.body).on("keydown", $.proxy(this._editorKeyUpEvent, this));
        };
        editorManager.prototype._editorKeyUpEvent = function (e) {
            if (this._junkContentStatus) {
                var range = this._getRangy(this.currentWindow, this.currentDocument), rangeContainer = range.startContainer, rangeOffset = range.startOffset;
                if (!e.shiftKey && (e.which >= 37 && e.which <= 40) && (rangeContainer.nodeType == 3)) {
                    this._junkContentStatus = false;
                    this._iterateCompleteNode(rangeContainer, e, rangeOffset);
                }
            }
        };
        editorManager.prototype._iterateCompleteNode = function (element, e, range) {
            var oldlen = element.data.length;
            this._junkSpanNodes = [];
            this._removeJunkContent(this.currentDocument.body);
            this._collectJunkSpanNodes(this.currentDocument.body);
            this._removeJunkSpanNodes();
            (oldlen > element.data.length) && range--;
            !element.data && $(element).remove();
            if (element.data.trim()) {
                this._updateCursor(element, range);
            }
        };
        editorManager.prototype._collectJunkSpanNodes = function (stNode) {
            var startNode = stNode;
            if ($(startNode).is("span") && !$(startNode).attr("style"))
                this._junkSpanNodes.push(startNode);
            if (startNode = startNode.firstChild)
                do {
                    if ($(startNode).is("span") && !$(startNode).attr("style"))
                        this._junkSpanNodes.push(startNode);
                    this._collectJunkSpanNodes(startNode);
                } while (startNode = startNode.nextSibling);
        };
        editorManager.prototype._removeJunkSpanNodes = function () {
            var temp;
            while (temp = this._junkSpanNodes.shift()) {
                if (temp.childNodes.length)
                    $(temp).replaceWith(temp.childNodes);
                else
                    $(temp).remove();
            }
        };
        editorManager.prototype._removeJunkContent = function (startNode) {
            var temp = startNode;
            if (temp.nodeType == 3)
                this._removeCursorText(temp);
            if (temp = temp.firstChild)
                do {
                    if (temp.nodeType == 3)
                        this._removeCursorText(temp);
                    else
                        this._removeJunkContent(temp);
                } while (temp = temp.nextSibling);
        };
        editorManager.prototype._removeCursorText = function (element) {
            element.data = element.data.replace(String.fromCharCode(65279), "");
        };
        editorManager.prototype.focus = function () {
            var objExec = this;
            setTimeout(function () {
                var browserInfo = ej.browserInfo();
                if (browserInfo.name == "webkit")
                    objExec.currentWindow.focus();
                else
                    objExec.currentWindow.document.body.focus();
            }, 100);
        };
        editorManager.prototype._justifyContent = function (Value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._onApplyjustify(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyFormateBlock = function (Value) {
            var range = this._getRangy(this.currentWindow, this.currentDocument);
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._applyChanges(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
            this._selectionRange = this._getRangy(this.currentWindow, this.currentDocument);
        };
        editorManager.prototype._applyList = function (value, listType) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._applyOrderedList(value.toLowerCase() == "orderlist" ? "ol" : "ul", this.currentDocument, this.currentWindow, listType);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyIndent = function (value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            if (value)
                this._onApplyIndent(this.currentDocument, this.currentWindow);
            else
                this._onApplyDecreaseIndent(this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._getRangy = function (_window, _document) {
            if (_window.getSelection() && _window.getSelection().rangeCount > 0)
                return _window.getSelection().getRangeAt(0);
            else {
                var range;
                try {
                    range = _window.document.createRange();
                    range.setStart(_window.document.body, 0);
                    range.setEnd(_window.document.body, 0);
                }
                catch (error) {
                    range = _document.createRange();
                    range.setStart(_document.body, 0);
                    range.setEnd(_document.body, 0);
                }
                return range;
            }
        };
        editorManager.prototype._getexactSelectedNode = function (range, parentDoc) {
            var nodeDetails = [];
            var _parentNode = [];
            this._parentDoc = parentDoc;
            var startNode = $(this._parentDoc.body).find("span#startRange");
            var that = this;
            function visit(node) {
                if (node.nodeType == 3 && (($.trim(node.nodeValue) != "" || node.nodeValue == "\ufeff") || ($.trim(node.nodeValue) == "" && node.nextSibling == startNode[0]))) {
                    nodeDetails.push(node);
                }
                else if (node.nodeValue && node.nodeName != "#comment" && node.nodeValue.trim() == "" && that.range.endContainer.parentNode.nextSibling != that._next) {
                    if ($.inArray(node.previousElementSibling, _parentNode) < 0)
                        _parentNode.push(node.previousElementSibling);
                }
                else if ((node.nodeName.toLowerCase() == "br" || ($.inArray(node.nodeName.toLowerCase(), that.filterNode) < 0)) && ($.inArray(node.parentNode, nodeDetails) < 0) && node.nodeName.toLowerCase() != "body" && $.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) < 0 && ((!ej.isNullOrUndefined(nodeDetails[nodeDetails.length - 1])) && nodeDetails[nodeDetails.length - 1].parentNode != node.parentNode) && node.previousSibling && node.previousSibling.parentNode != node.parentNode)
                    nodeDetails.push(node.parentNode);
                else if (($.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) >= 0) && ej.isNullOrUndefined(node.firstChild))
                    nodeDetails.push(node);
                else {
                    node = node.firstChild;
                    while (node) {
                        visit(node);
                        node = node.nextSibling;
                    }
                }
            }
            this._generateRange(range);
            this._traverse(visit);
            return nodeDetails;
        };
        editorManager.prototype._getStartEndElement = function (tnode, root) {
            if (this._isAncestor(root, tnode)) {
                while (tnode && tnode.parentNode != root) {
                    tnode = tnode.parentNode;
                }
            }
            return tnode;
        };
        editorManager.prototype._generateRange = function (range) {
            var root = range.commonAncestorContainer;
            this._next = range.startContainer == root && !this._isTextNode(range.startContainer) ? range.startContainer.childNodes[range.startOffset] : this._getStartEndElement(range.startContainer, root);
            this._end = range.endContainer == root && !this._isTextNode(range.endContainer) ? range.endContainer.childNodes[range.endOffset] : (this._getStartEndElement(range.endContainer, root).nodeName.toLowerCase() != "body") && this._getStartEndElement(range.endContainer, root).nextSibling;
        };
        editorManager.prototype._traverse = function (callback) {
            var that = this, current;
            function next() {
                if (that._next != ((that._isTextNode(that.range.endContainer) ? that.range.endContainer.parentNode.nextSibling : that.range.endContainer.nextElementSibling)) && that.range.endContainer.parentNode.nextSibling != that._next) {
                    that._current = that._next;
                    that._next = that._current && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0] && that._current.nextSibling != (ej.isNullOrUndefined(that._end) ? that.range.endContainer.nextSibling : that._end) ? that._current.nextSibling : null;
                    return that._current;
                }
                else {
                    return null;
                }
            }
            while (current = next()) {
                if (that._hasSubNodes()) {
                    that._getSubtree(that._getRangy(that.currentWindow, that.currentDocument));
                    that._traverse(callback);
                }
                else {
                    var _nextNode = current;
                    if (that.range.startContainer.nodeName.toLowerCase() != "body") {
                        if (that._next == null && _nextNode != (that.range.endContainer)) {
                            while (ej.isNullOrUndefined(that._next) && !ej.isNullOrUndefined(_nextNode)) {
                                _nextNode = _nextNode.parentNode;
                                if ((!ej.isNullOrUndefined(_nextNode)) && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0])
                                    that._next = _nextNode.nextSibling;
                            }
                        }
                    }
                    callback(current);
                }
            }
            return current;
        };
        editorManager.prototype._hasSubNodes = function () {
            return !this._isTextNode(this._current) && (this._isAncestorItself(this._current, this.range.startContainer) ||
                this._isAncestorItself(this._current, this.range.endContainer));
        };
        editorManager.prototype._isTextNode = function (node) {
            return node && node.nodeValue !== null && node.data !== null;
        };
        editorManager.prototype._isAncestor = function (parent, node) {
            try {
                return !this._isTextNode(parent) && ($.contains(parent, (this._isTextNode(node) ? node.parentNode : node)) || node.parentNode == parent);
            }
            catch (e) {
                return false;
            }
        };
        editorManager.prototype._isAncestorItself = function (root, node) {
            return this._isAncestor(root, node) || root == node;
        };
        editorManager.prototype._getSubtree = function (range) {
            var that = this;
            var subRange = that.range.cloneRange();
            subRange.selectNodeContents(that._current);
            if (that._isAncestorItself(that._current, that.range.startContainer)) {
                subRange.setStart(that.range.startContainer, that.range.startOffset);
            }
            if (that._isAncestorItself(that._current, that.range.endContainer)) {
                subRange.setEnd(that.range.endContainer, that.range.endOffset);
            }
            return this._generateRange(subRange);
        };
        editorManager.prototype._getModifedRange = function (range) {
            if (range.endOffset == 0 && range.startContainer != range.endContainer) {
                var ele = range.endContainer;
                do {
                    ele = ej.isNullOrUndefined(range.endContainer.previousSibling) ? ele.parentNode : ele;
                } while (ej.isNullOrUndefined(ele.previousSibling));
                if (this._isTextNode(ele.previousSibling) && $.trim(ele.previousSibling.textContent).length != 0)
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                else {
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                }
            }
        };
        editorManager.prototype._getSelectedParent = function (selNode1) {
            var _parentNode = [], selNode = selNode1;
            for (var i = 0; i < selNode.length; i++) {
                if (this._isTextNode(selNode[i])) {
                    while (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && ($.inArray(selNode[i].parentNode.nodeName.toLowerCase(), this.filterNode)) < 0) {
                        selNode[i] = selNode[i].parentNode;
                    }
                    if (selNode[i].parentNode.nodeName.toLowerCase() == "body")
                        _parentNode.push(this._updateParent(selNode[i]));
                }
                if (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && $.inArray(selNode[i].parentNode, _parentNode) < 0) {
                    if (selNode[i].parentNode.nodeName.toLowerCase() != "body" && selNode[i].nodeName.toLowerCase() != "img" && selNode[i].nodeName.toLowerCase() != "video")
                        _parentNode.push(selNode[i].parentNode);
                    else
                        _parentNode.push(selNode[i]);
                }
            }
            return _parentNode;
        };
        editorManager.prototype._updateParent = function (node) {
            var nodeColl = [node], temp = node, leftBlockNode, rightBlockNode, tempDiv = document.createElement("div");
            ;
            while (temp = temp.previousSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    leftBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            nodeColl = nodeColl.reverse();
            temp = node;
            while (temp = temp.nextSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    rightBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            $(nodeColl).appendTo(tempDiv);
            if (leftBlockNode)
                $(tempDiv).insertAfter(leftBlockNode);
            else if (rightBlockNode)
                $(tempDiv).insertBefore(rightBlockNode);
            else
                $(tempDiv).appendTo(this.currentDocument.body);
            return tempDiv;
        };
        editorManager.prototype._applyChanges = function (formatBlock, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var tag = (document.createElement(formatBlock.substring(formatBlock.indexOf("<") + 1, formatBlock.indexOf(">"))));
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
                this.focus();
                tag.innerHTML = "&nbsp;";
                this._parentDoc.body.innerHTML = tag.outerHTML;
            }
            else {
                var exatSelNode = this._getSelectedParent(selNode);
                var nodeArray = [];
                nodeArray.push(selNode[0]);
                var _prevParent = this._getSelectedParent(nodeArray)[0];
                var _childNode = [];
                var tval = 0;
                var condi = false;
                var _tdiv = document.createElement("div");
                var dummyNode = document.createElement("div");
                var _newparent = this._getSelectedParent(nodeArray)[0];
                var _prevParntNode, selVal, tnode, _isListNode, _tobj, _liNode, _liPrevious;
                for (selVal = 0; selVal < exatSelNode.length; selVal++) {
                    nodeArray = [];
                    nodeArray.push(exatSelNode[selVal]);
                    _prevParent = this._getSelectedParent(nodeArray)[0];
                    if ($(exatSelNode[selVal]).attr("style"))
                        $(tag).attr("style", $(exatSelNode[selVal]).attr("style"));
                    if ($.inArray(_prevParent, _childNode) >= 0) {
                        var node;
                    }
                    else {
                        _childNode.push(_prevParent);
                        if (tag.innerHTML.length != 0) {
                            if (_childNode[tval].nodeName.toLowerCase() != "td" && _childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody" && _childNode[tval].nodeName.toLowerCase() != "li" && _childNode[tval].nodeName.toLowerCase() != "body") {
                                $(_childNode[tval]).replaceWith(tag.outerHTML);
                            }
                            else if (_childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody") {
                                $(_childNode[tval]).prepend("<div></div>");
                                _tdiv.innerHTML = tag.outerHTML;
                                _childNode[tval].replaceChild(_tdiv.firstChild, _childNode[tval].firstChild);
                            }
                            tval++;
                        }
                        tag.innerHTML = "";
                        _tdiv.innerHTML = "";
                    }
                    tnode = exatSelNode[selVal];
                    _tobj = false;
                    if (!ej.isNullOrUndefined(tnode.parentNode)) {
                        _isListNode = tnode.nodeName.toLowerCase() == "li";
                    }
                    if (!ej.isNullOrUndefined(tnode)) {
                        _liNode = tnode;
                        while (_liNode.childNodes.length != 0) {
                            if ($.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                while (tnode.firstChild && $.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                    $(tag).append(_liNode.childNodes[0]);
                                }
                            }
                            else {
                                break;
                            }
                        }
                        _liPrevious = tnode.previousSibling;
                    }
                    _prevParntNode = tnode.parentNode;
                    if (tag.innerHTML.length != 0) {
                        if (tnode.nodeName.toLowerCase() != "td" && tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody" && tnode.nodeName.toLowerCase() != "li" && tnode.nodeName.toLowerCase() != "body") {
                            $(tnode).replaceWith(tag.outerHTML);
                        }
                        else if (tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody") {
                            $(tnode).prepend("<div></div>");
                            _tdiv.innerHTML = tag.outerHTML;
                            tnode.replaceChild(_tdiv.firstChild, tnode.firstChild);
                        }
                        tval++;
                    }
                    tag.innerHTML = "";
                    _tdiv.innerHTML = "";
                    $(tag).removeAttr("style");
                }
            }
        };
        editorManager.prototype._validateIndent = function (element) {
            var _indentStatus = false;
            do {
                if ($(element).attr("style") && (parseInt($(element).css("margin-left")) > 0)) {
                    _indentStatus = true;
                }
            } while ((element = element.parentNode) && !$(element).is("body"));
            return _indentStatus;
        };
        editorManager.prototype._validateFontSize = function (element) {
            var size = parseInt($(((element.nodeType == 3) ? element.parentNode : element)).css("font-size"));
            return (Math.round(size * (3 / 4))) + "pt";
        };
        editorManager.prototype._onApplyIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc), temp;
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
            }
            else {
                for (var node = 0; node <= exatSelNode.length - 1; node++) {
                    if (exatSelNode[node].nodeName.toLowerCase() == "td") {
                        $(exatSelNode[node]).append($(temp = (document.createElement("p"))).append(exatSelNode[node].childNodes));
                        exatSelNode[node] = temp;
                    }
                    if (exatSelNode[node].nodeName.toLowerCase() != "li")
                        $(exatSelNode[node]).css("margin-left", 40 + parseInt($(exatSelNode[node]).css("margin-left")) + "px");
                    else {
                        if ($(exatSelNode[node]).prev().length == 0)
                            $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) + 40 + "px");
                        else
                            $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) + 40 + "px");
                    }
                }
            }
        };
        editorManager.prototype._onApplyDecreaseIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            for (var node = 0; node <= exatSelNode.length - 1; node++) {
                if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40 && exatSelNode[node].nodeName.toLowerCase() != "li")
                    $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                else {
                    if ($(exatSelNode[node]).prev().length == 0 && parseInt($(exatSelNode[node].parentNode).css("margin-left")) >= 40)
                        $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) - 40);
                    else if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40)
                        $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                }
            }
        };
        editorManager.prototype._getNodeName = function (node) {
            if (this._isTextNode(node))
                return "#text";
            else
                return node.nodeName.toLowerCase();
        };
        editorManager.prototype._onApplyjustify = function (justify, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode = this._getexactSelectedNode(this.range, parentDoc);
            var _exactparentEle = this._getSelectedParent(selNode);
            for (var a = 0; a < _exactparentEle.length; a++) {
                var node = document.createElement("div");
                if (_exactparentEle[a].nodeName.toLowerCase() == "li") {
                    var _tnode = $(_exactparentEle[a]).children(), _val = 0;
                    for (var b = 0; b < _tnode.length; b++) {
                        if ($.inArray(this._getNodeName(_tnode[b]), this.filterNode) > 0)
                            _val++;
                    }
                    if (_val > 0) {
                        while (_exactparentEle[a].childNodes.length > 0) {
                            if (this._isTextNode(_exactparentEle[a].childNodes[0]) || $.inArray(this._getNodeName(_exactparentEle[a].childNodes[0]), this.filterNode) < 0)
                                node.appendChild(_exactparentEle[a].childNodes[0]);
                            else
                                break;
                        }
                    }
                    else
                        $(_exactparentEle[a]).css("text-align", justify);
                    if (node.childNodes.length > 0) {
                        $(node).css("text-align", justify);
                        _exactparentEle[a].insertBefore(node, _exactparentEle[a].childNodes[0]);
                        _val = 0;
                    }
                }
                else {
                    $(_exactparentEle[a]).css("text-align", justify);
                }
            }
        };
        editorManager.prototype._getParentNodeCollection = function (selNode) {
            var _backUpSelNode = selNode;
            var _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
            var _nodeDetails = [];
            _nodeDetails.push(_backUpSelNode);
            while (_backUpSelNodeName != "body" && (_backUpSelNodeName == "li" || _backUpSelNodeName == "ol" || _backUpSelNodeName == "ul")) {
                _backUpSelNode = _backUpSelNode.parentNode;
                _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
                _nodeDetails.push(_backUpSelNode);
            }
            return _nodeDetails;
        };
        editorManager.prototype._generateListParentTag = function (list, selNode, listType) {
            var tag = document.createElement(list);
            $(tag).css("list-style-type", listType);
            if (selNode.nodeName.toLowerCase() != "li")
                $(tag).insertBefore(selNode);
            else
                $(tag).insertBefore(selNode.parentNode);
            return tag;
        };
        editorManager.prototype._applyOrderedList = function (list, parentDoc, _window, listType) {
            this.range = this._getRangy(_window, parentDoc);
            var nodeArray = this._getexactSelectedNode(this.range, parentDoc);
            var beforeNode = document.createElement(list);
            var afterNode = document.createElement(list);
            var _childNode = new Array();
            var selNode = this._getSelectedParent(nodeArray);
            var _parentNode = this._getParentNodeCollection(selNode[0]);
            var _startNode = document.createElement("p");
            var replaceEle = new Array();
            var removeParent, topMostParent, innerTag, tag, elemN, _node, node, _exactParentEle = _parentNode[_parentNode.length - 1];
            if (listType != "none") {
                tag = this._generateListParentTag(list, selNode[0], listType);
            }
            for (var i = 0; i <= selNode.length - 1; i++) {
                innerTag = document.createElement("li");
                if (selNode[i].parentNode.nodeName.toLowerCase() == "li")
                    selNode[i] = selNode[i].parentNode;
                if (listType == "none") {
                    if ($(selNode[i]).closest("ul,ol").length < 1)
                        continue;
                    if ($(selNode[i]).find("ol").length != 0 || $(selNode[i]).find("ul").length != 0) {
                        removeParent = $(selNode[i]).parents(list).first();
                        var _exactLi = removeParent.parents("li:last");
                        var _prevNode = removeParent.parents("li:last").prevAll();
                        var _nexNode = removeParent.parents("li:last").nextAll();
                        node = $(selNode[i]).parents("li:last")[0];
                    }
                    else {
                        removeParent = $(selNode[i]);
                        var _exactLi = removeParent;
                        var _prevNode = removeParent.prevAll();
                        var _nexNode = removeParent.nextAll();
                        node = $(selNode[i])[0];
                    }
                    topMostParent = $(selNode[i]).parents(list).last();
                    var _selectionComplete = 0;
                    if (_prevNode.length != 0) {
                        $(afterNode).append(_exactLi);
                        $(afterNode).append(_nexNode);
                        $(afterNode).insertAfter(topMostParent);
                    }
                    var ele = document.createElement("p"), elem = elemN = document.createElement("li");
                    beforeNode.appendChild(elem);
                    var backupFirstNode = topMostParent, _removeSibling = new Array(), _inc = false, newNode;
                    while (node) {
                        if ($.inArray(node, selNode) >= 0 || $.inArray(node.firstChild, selNode) >= 0 || $.inArray(node.firstChild, nodeArray) >= 0) {
                            if (_selectionComplete == 0 && elem.firstChild && elem.firstChild.innerHTML != "") {
                                topMostParent.append(elem);
                                elem = elemN = document.createElement("li");
                            }
                            newNode = document.createElement("p");
                            while (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                newNode.appendChild(node.firstChild);
                                _inc = true;
                            }
                            if (_inc) {
                                _selectionComplete++;
                                $(newNode).insertAfter(backupFirstNode);
                                backupFirstNode = $(newNode);
                                if ($(node).children().length == 0) {
                                    _removeSibling.push(node);
                                }
                            }
                            if (_selectionComplete == selNode.length) {
                                var _nextEle = document.createElement(list);
                                if ($(node).children().length != 0)
                                    $(_nextEle).append($(node).parents("li:last").nextAll());
                                else
                                    $(_nextEle).append($(node).nextAll());
                                if (node.nodeName.toLowerCase() == "ol" || node.nodeName.toLowerCase() == "ul")
                                    $(node).insertAfter(backupFirstNode);
                                else if (node.nodeName.toLowerCase() == "li") {
                                    var _tnewNode = document.createElement(list);
                                    $(_tnewNode).append(node);
                                    $(_tnewNode).insertAfter(backupFirstNode);
                                    node = _tnewNode;
                                }
                                $(_nextEle).insertAfter(node);
                                for (var _remove = 0; _remove < _removeSibling.length; _remove++) {
                                    var _removeNodeparent;
                                    _node = _removeSibling[_remove];
                                    while (_node.nodeName.toLowerCase() != "body") {
                                        _removeNodeparent = _node.parentNode;
                                        $(_node).remove();
                                        _node = _removeNodeparent;
                                    }
                                }
                                i = selNode.length;
                                break;
                            }
                        }
                        if (this._isTextNode(node.firstChild) || (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0)) {
                            elemN.appendChild(node.firstChild);
                            if (ej.isNullOrUndefined(node.firstChild)) {
                                node = node.nextSibling;
                            }
                        }
                        else if (this._isTextNode(node)) {
                            var _tflag = 0;
                            var appendElement = node;
                            node = node.nextSibling;
                            if (ej.isNullOrUndefined(node)) {
                                node = appendElement;
                                while ($(node.parentNode).next().length == 0) {
                                    node = node.parentNode;
                                    _tflag++;
                                }
                                if (_tflag > 0) {
                                    node = $(node.parentNode).next()[0];
                                }
                            }
                            elemN.appendChild(appendElement);
                            if (_tflag == 0 && !this._isTextNode(node))
                                elemN = this._createElement(node.nodeName.toLowerCase(), elemN.parentNode, null);
                            else
                                elemN = this._createElement(node.nodeName.toLowerCase(), this._getParentnodeName(_tflag, elemN), "after");
                            _tflag = 0;
                        }
                        else {
                            if (node.firstChild) {
                                elemN = this._createElement(node.firstChild.nodeName.toLowerCase(), elemN, null);
                                node = node.firstChild;
                            }
                            else
                                node = node.nextSibling;
                        }
                    }
                }
                else if (selNode[i].nodeName.toLowerCase() != "li") {
                    if ($(selNode[i]).is("h1,h2,h3,h4,h5,h6,p,blockquote")) {
                        $(innerTag).append(selNode[i]);
                        tag.appendChild(innerTag);
                    }
                    else {
                        if ($(selNode[i]).attr("style"))
                            $(innerTag).attr("style", $(selNode[i]).attr("style"));
                        $(innerTag).append(selNode[i].childNodes);
                        tag.appendChild(innerTag);
                        $(selNode[i]).remove();
                    }
                }
                else if (selNode[i] = $(selNode[i]).closest("li")) {
                    tag = document.createElement(list);
                    $(tag).css("list-style-type", listType);
                    $(tag).append(selNode[i].parentNode.childNodes);
                    $(selNode[i].parentNode).replaceWith(tag);
                }
            }
            if (listType != "none" && _exactParentEle.childNodes.length == 0 && (_exactParentEle.nodeName.toLowerCase() == "ol" || _exactParentEle.nodeName.toLowerCase() == "ul"))
                $(_exactParentEle).remove();
        };
        editorManager.prototype._getParentnodeName = function (_tflag, elemN) {
            var node = elemN;
            for (var a = 0; a <= _tflag; a++) {
                node = node.parentNode;
            }
            return node;
        };
        editorManager.prototype._createElement = function (element, elem, place) {
            var newEle = document.createElement(element);
            if (place != "after")
                elem.appendChild(newEle);
            else
                $(newEle).insertAfter(elem);
            return newEle;
        };
        editorManager.prototype._backUpRange = function (_parentDoc, _window) {
            var nodeStart = _parentDoc.createElement("span");
            nodeStart.id = "startRange";
            var nodeEnd = _parentDoc.createElement("span");
            nodeEnd.id = "endRange";
            var rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(false);
            rng.insertNode(nodeEnd);
            rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(true);
            rng.insertNode(nodeStart);
        };
        editorManager.prototype._resetRange = function (_parentDoc, _window) {
            var a = $(_parentDoc.body).find("span#startRange");
            var b = $(_parentDoc.body).find("span#endRange");
            var len = ej.isNullOrUndefined(b[0].previousSibling) ? 0 : this._isTextNode(b[0].previousSibling) ? b[0].previousSibling.length : b[0].previousSibling.childNodes.length > 0 ? b[0].previousSibling.childNodes.length : 0;
            var rng = this._getRangy(_window, _parentDoc);
            if (a[0].nextSibling != b[0])
                rng.setStart(a[0].nextSibling, 0);
            else
                rng.setStart(a[0].nextSibling.nextSibling, 0);
            if (b[0].previousSibling != a[0])
                ej.isNullOrUndefined(b[0].previousSibling) ? rng.setEnd(b[0].parentNode, len) : rng.setEnd(b[0].previousSibling, len);
            else
                rng.setEnd(b[0].nextSibling, 0);
            a.remove();
            b.remove();
            this._selectRange(rng, _parentDoc);
        };
        editorManager.prototype._selectRange = function (range, _parentDoc) {
            var select = _parentDoc.getSelection();
            select.removeAllRanges();
            select.addRange(range);
        };
        editorManager.prototype._validateFormatData = function (target, data) {
            var nodeData = [], element = target.parentNode, childNode = target, nodeOrder = [], _tagResult, _cssResult;
            if (element)
                do {
                    nodeOrder.push(childNode);
                    if ((_tagResult = this._tagCheck(element, data)) || (_cssResult = this._styleCheck(element, data)))
                        nodeData.push(new ValidatedData(element, target, _tagResult, _cssResult));
                } while (!$(element).is("body") && (childNode = element) && (element = element.parentNode));
            return nodeData;
        };
        editorManager.prototype._tagCheck = function (element, data) {
            return this.formatInfo.getFormatData(data).Value.tag ? $(element).is(this.formatInfo.getFormatData(data).Value.tag) : false;
        };
        editorManager.prototype._styleCheck = function (element, data) {
            var tempArrayData;
            if (!$(element).is(this.formatInfo.filterNode) && this.formatInfo.getFormatData(data).Value.css && (element.getAttribute("style"))) {
                var valStatus = true;
                tempArrayData = this.formatInfo.getFormatData(data).Value.css.split(";");
                $(tempArrayData).each(function (index, styledata) {
                    styledata && (element.getAttribute("style").replace(/\s/g, "").indexOf(styledata) == -1) && (valStatus = false);
                });
                return valStatus;
            }
            return false;
        };
        editorManager.prototype._validateFormat = function (element, format) {
            var data = [], collection = { Info: null, status: null }, status;
            format = format.toLowerCase();
            if ($.inArray(format, this.formatInfo.actionList) != -1) {
                if ((data = this._validateFormatData(element, format)) && data.length)
                    collection.Info = data;
                collection.status = (data.length > 0);
            }
            return collection;
        };
        editorManager.prototype._CurrentformateStatus = function (selectedNode, format) {
            var data = { Info: null, status: null }, status = true;
            for (var index = 0; index < selectedNode.length; index++) {
                data = this._validateFormat(selectedNode[index], format);
                (!data.status) && (status = false);
            }
            return status;
        };
        editorManager.prototype._getSelectNode = function () {
            return this._rangeExtract.ProcessRange();
        };
        editorManager.prototype._getFormatedTagOrder = function (data, index) {
            data[index].currentNode = this._getNodeOrder(data[index].textNode, data[index].node);
            return (!index) ? data : data.slice(index, index + 1);
        };
        editorManager.prototype._getNodeOrder = function (endNode, targetNode) {
            var currentNode = endNode, nodeOrder = [];
            do
                nodeOrder.push(currentNode);
            while ((currentNode = currentNode.parentNode) && currentNode != targetNode);
            return nodeOrder;
        };
        editorManager.prototype._splitNode = function (node) {
            var temp = node, siblingData = { rightSide: [], leftSide: [] };
            while (temp = temp.nextSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.leftSide.push(temp);
            }
            return siblingData;
        };
        editorManager.prototype._validateCommentNode = function (node) {
            return (node.nodeType != 8);
        };
        editorManager.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        editorManager.prototype._validateType = function (node) {
            return (this._validateTextNode(node) && (node.data.length));
        };
        editorManager.prototype._formatechildNodes = function (nodeCollection, format, node) {
            var adjacentNodes = { rightSide: [], leftSide: [] }, cloneNode;
            for (var index = nodeCollection.length - 1; index >= 0; index--) {
                adjacentNodes = this._splitNode(nodeCollection[index]);
                (adjacentNodes.rightSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(nodeCollection[index]));
                cloneNode = node;
                (adjacentNodes.leftSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.leftSide.reverse())).insertBefore(nodeCollection[index]));
            }
        };
        editorManager.prototype._removeFormat = function (nodeData, format, matches) {
            var temp = this._getFormatedTagOrder(nodeData.Info, matches), tempcloneNode, currentNode = temp[0].currentNode.slice(temp[0].currentNode.length - 1), tempSpanNode = document.createElement("span");
            temp[0].currentNode = temp[0].currentNode.slice(0, temp[0].currentNode.length - 1);
            var adjacentNodes = this._splitNode(currentNode[0]);
            (adjacentNodes.rightSide.length) &&
                ($($(temp[0].node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(temp[0].node));
            if (temp[0].tag) {
                if (this._rangeExtract.cursorBasedCollection && !temp[0].textNode.data.trim().length) {
                    $(tempSpanNode).append(currentNode).insertAfter($(temp[0].node));
                }
                else
                    $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = temp[0].textNode;
                if (this._rangeExtract.cursorBasedCollection)
                    this._setCursorOnNode(tempcloneNode, temp[0].textNode);
            }
            else {
                tempcloneNode = $(temp[0].node.cloneNode(false));
                tempcloneNode.css(this.formatInfo.getFormatData(format).Value.removeCSS);
                (tempcloneNode[0].getAttribute("style")) ? $(tempcloneNode.append(currentNode)).insertAfter(temp[0].node) : $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = currentNode;
            }
            (temp[0].currentNode.length) && (this._formatechildNodes(temp[0].currentNode, format, temp[0].node));
            (!adjacentNodes.leftSide.length) && ($(temp[0].node).remove());
            return tempcloneNode[0] ? tempcloneNode[0] : tempcloneNode;
        };
        editorManager.prototype._applyFormat = function (node, format, styleData) {
            var adjacentNodes = this._splitNode(node), tempcloneNode, currentNode = node, tempSpanNode = document.createElement("span");
            if (adjacentNodes.leftSide.length && (adjacentNodes.leftSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.leftSide[0], format) || this._compareCSS(adjacentNodes.leftSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.leftSide[0]).append(node);
            else if (adjacentNodes.rightSide.length && (adjacentNodes.rightSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.rightSide[0], format) || this._compareCSS(adjacentNodes.rightSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.rightSide[0]).prepend(node);
            else if (!adjacentNodes.leftSide.length && !adjacentNodes.rightSide.length && $(node.parentNode).is(this.formatInfo.getFormatData(format).Value.styleParent)) {
                if (styleData)
                    $(node.parentNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
                else
                    $(node.parentNode).css(this._collectStyleData(this.formatInfo.getFormatData(format).Value.css));
            }
            else {
                tempcloneNode = document.createElement(this.formatInfo.getFormatData(format).Value.result);
                if (this._rangeExtract.cursorBasedCollection) {
                    if (this._validateTextNode(node)) {
                        if (!$(tempcloneNode).is("span") && this._rangeExtract._noContent)
                            $(tempSpanNode).append(tempcloneNode);
                        else
                            (tempSpanNode = tempcloneNode);
                        tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, currentNode);
                        }
                        $(node).replaceWith(tempSpanNode);
                    }
                    else {
                        tempcloneNode.innerHTML = "&#65279;";
                        $(tempSpanNode).append(tempcloneNode);
                        if (node.firstChild && $(node.firstChild).is("br"))
                            $(tempSpanNode).insertBefore(node.firstChild);
                        else
                            $(node).append(tempSpanNode);
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, tempcloneNode.firstChild);
                        }
                        currentNode = tempcloneNode;
                    }
                }
                else {
                    tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                    $(node).replaceWith(tempcloneNode);
                }
                styleData && $(tempcloneNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
            }
            return currentNode;
        };
        editorManager.prototype._setCursorOnNode = function (node, currentNode) {
            if (this._rangeExtract._cursorData.node == node)
                this._rangeExtract._cursorData.node = currentNode;
        };
        editorManager.prototype._compareCSS = function (element, css) {
            return element.getAttribute('style') && element.getAttribute('style').toLowerCase().trim().replace(/\s/g, "") == css.toLowerCase().trim().replace(/\s/g, "");
        };
        editorManager.prototype._collectStyleData = function (styledata) {
            var styleList = styledata.replace(/\s/g, "").split(';'), data = {}, temp;
            $(styleList).each(function (index) {
                var style = styleList[index];
                temp = style.split(':');
                (temp.length > 1) && (data[temp[0].toLowerCase().trim()] = temp[1].toLowerCase().trim());
            });
            return data;
        };
        editorManager.prototype._validateStyleData = function (node, style, styleData) {
            var nodeList = node.getAttribute('style').split(';'), status = false;
            $(nodeList).each(function (index) {
                var data = nodeList[index], temp = data.split(':');
                if (temp[0].toLowerCase().trim() == style.toLowerCase().trim() && temp[1].toLowerCase().trim() == styleData.toLowerCase().trim()) {
                    status = true;
                    return false;
                }
            });
            return status;
        };
        editorManager.prototype._caseConvert = function (casing) {
            var selectedNode = this._getSelectNode(), node, startNode, endNode, tempNode;
            if (!selectedNode.length || (selectedNode.length == 1 && !selectedNode[0].data.length))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index];
                tempNode = document.createTextNode(node.data[this.formatInfo.captionConvert[casing]]());
                if (this._rangeExtract._cursorData.node == node)
                    this._rangeExtract._cursorData.node = tempNode;
                node.data && ($(node).replaceWith(tempNode));
                tempNode && (selectedNode.length == 1) ? ((startNode = tempNode) && (endNode = tempNode)) : (index == 0) ? (startNode = tempNode) : (index == selectedNode.length - 1) ? (endNode = tempNode) : null;
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
        };
        editorManager.prototype._validateSelectedNode = function (selectedNode) {
            return (!selectedNode.length || (selectedNode.length == 1 && selectedNode[0].data && !selectedNode[0].data.length));
        };
        editorManager.prototype._tagFormatProcess = function (format, remove) {
            var selectedNode = this._getSelectNode();
            if (this._validateSelectedNode(selectedNode))
                return;
            var status = this._CurrentformateStatus(selectedNode, format), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format), retNode = null;
                if (((remove || status) && nodeData.status))
                    for (var matches = 0; matches < nodeData.Info.length; matches++)
                        retNode = this._removeFormat(nodeData, format, matches);
                else if (!nodeData.status && !remove)
                    retNode = this._applyFormat(node, format, null);
                else
                    retNode = node;
                if (retNode) {
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
                }
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
            this.focus();
            return { data: nodeData, nodeStatus: status };
        };
        editorManager.prototype._refreshRange = function (startNode, endNode) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection(), cursorOnNode, cursorOffset;
            if (this._rangeExtract)
                (cursorOnNode = this._rangeExtract._cursorData.node) && (cursorOffset = this._rangeExtract._cursorData.offSet);
            if (this._rangeExtract.cursorBasedCollection && cursorOnNode && cursorOffset > -1) {
                cursorOffset = this._validateTextNode(cursorOnNode) ?
                    ((cursorOffset > cursorOnNode.data.length) ? cursorOnNode.data.length : cursorOffset) : 0;
                if (cursorOnNode.nodeType == 3 && !cursorOnNode.data.trim()) {
                    cursorOnNode.data = String.fromCharCode(65279) + cursorOnNode.data;
                    cursorOffset++;
                }
                this._updateCursor(cursorOnNode, cursorOffset);
            }
            else if (startNode && endNode) {
                if (startNode.data && !startNode.data.trim() && (startNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    startNode.data = String.fromCharCode(65279) + startNode.data;
                if (endNode.data && !endNode.data.trim() && (endNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    endNode.data = String.fromCharCode(65279);
                Selection.removeAllRanges();
                range.setStart(startNode, 0);
                range.setEnd(endNode, endNode.data ? endNode.data.length : 0);
                Selection.addRange(range);
            }
            $(this.currentWindow).focus();
        };
        editorManager.prototype._updateCursor = function (node, offset) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection();
            range.setStart(node, offset);
            range.setEnd(node, offset);
            Selection.removeAllRanges();
            Selection.addRange(range);
        };
        editorManager.prototype._cssFormatProcess = function (format, styleData, remove) {
            var selectedNode = this._getSelectNode(), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            if (this._validateSelectedNode(selectedNode))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format);
                if (nodeData.status)
                    for (var matches = 0; matches < nodeData.Info.length; matches++) {
                        if (!remove && this._validateStyleData(nodeData.Info[matches].node, this.formatInfo.getFormatData(format).Value.css, styleData))
                            continue;
                        retNode = this._removeFormat(nodeData, format, matches);
                    }
                if (!remove)
                    retNode = this._applyFormat(node, format, styleData);
                if (retNode)
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
            }
            this._refreshRange(startNode, endNode);
            this.focus();
        };
        editorManager.prototype.execCommand = function (command, value) {
            try {
                switch (command) {
                    case execCommand.bold:
                        this._tagFormatProcess("bold", false);
                        break;
                    case execCommand.italic:
                        this._tagFormatProcess("italic", false);
                        break;
                    case execCommand.underline:
                        this._tagFormatProcess("underline", false);
                        break;
                    case execCommand.strikethrough:
                        this._tagFormatProcess("strikethrough", false);
                        break;
                    case execCommand.superscript:
                        this._tagFormatProcess("subscript", true);
                        this._tagFormatProcess("superscript", false);
                        break;
                    case execCommand.subscript:
                        this._tagFormatProcess("superscript", true);
                        this._tagFormatProcess("subscript", false);
                        break;
                    case execCommand.fontsize:
                        this._cssFormatProcess("fontsize", value, false);
                        break;
                    case execCommand.fontname:
                        this._cssFormatProcess("fontname", value, false);
                        break;
                    case execCommand.forecolor:
                        this._cssFormatProcess("forecolor", value, false);
                        break;
                    case execCommand.backcolor:
                        this._cssFormatProcess("backcolor", value, false);
                        break;
                    case execCommand.uppercase:
                        this._caseConvert("uppercase");
                        break;
                    case execCommand.lowercase:
                        this._caseConvert("lowercase");
                        break;
                    case execCommand.indent:
                        this._applyIndent(true);
                        break;
                    case execCommand.outdent:
                        this._applyIndent(false);
                        break;
                    case execCommand.justifyleft:
                        this._justifyContent("left");
                        break;
                    case execCommand.justifycenter:
                        this._justifyContent("center");
                        break;
                    case execCommand.justifyright:
                        this._justifyContent("right");
                        break;
                    case execCommand.justifyfull:
                        this._justifyContent("justify");
                        break;
                    case execCommand.formatblock:
                        this._applyFormateBlock(value);
                        break;
                }
                this._junkContentStatus = true;
            }
            catch (e) {
            }
        };
        return editorManager;
    }());
    documentManager.editorManager = editorManager;
    (function (execCommand) {
        execCommand[execCommand["bold"] = 0] = "bold";
        execCommand[execCommand["italic"] = 1] = "italic";
        execCommand[execCommand["underline"] = 2] = "underline";
        execCommand[execCommand["strikethrough"] = 3] = "strikethrough";
        execCommand[execCommand["superscript"] = 4] = "superscript";
        execCommand[execCommand["subscript"] = 5] = "subscript";
        execCommand[execCommand["fontsize"] = 6] = "fontsize";
        execCommand[execCommand["fontname"] = 7] = "fontname";
        execCommand[execCommand["forecolor"] = 8] = "forecolor";
        execCommand[execCommand["backcolor"] = 9] = "backcolor";
        execCommand[execCommand["uppercase"] = 10] = "uppercase";
        execCommand[execCommand["lowercase"] = 11] = "lowercase";
        execCommand[execCommand["indent"] = 12] = "indent";
        execCommand[execCommand["outdent"] = 13] = "outdent";
        execCommand[execCommand["justifyleft"] = 14] = "justifyleft";
        execCommand[execCommand["justifycenter"] = 15] = "justifycenter";
        execCommand[execCommand["justifyright"] = 16] = "justifyright";
        execCommand[execCommand["justifyfull"] = 17] = "justifyfull";
        execCommand[execCommand["formatblock"] = 18] = "formatblock";
    })(documentManager.execCommand || (documentManager.execCommand = {}));
    var execCommand = documentManager.execCommand;
    var ValidatedData = (function () {
        function ValidatedData(node, textNode, tag, css) {
            this.textNode = textNode;
            this.node = node;
            this.css = css;
            this.tag = tag;
        }
        return ValidatedData;
    }());
    var actionType = (function () {
        function actionType(tag, css, result, removeCSS, styleParent) {
            this.tag = tag;
            this.css = css;
            this.result = result;
            this.removeCSS = removeCSS;
            this.styleParent = styleParent;
        }
        return actionType;
    }());
    var captionConvertion = (function () {
        function captionConvertion() {
            this.uppercase = "toUpperCase";
            this.lowercase = "toLowerCase";
        }
        return captionConvertion;
    }());
    var KeyDictionary = (function () {
        function KeyDictionary(target, value) {
            this.Key = target;
            this.Value = value;
        }
        return KeyDictionary;
    }());
    var formateDataCollection = (function () {
        function formateDataCollection() {
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.actionList = ["bold", "italic", "underline", "strikethrough", "superscript", "subscript", "fontsize", "fontname", "forecolor", "backcolor"];
            this.captionConvert = new captionConvertion();
            this._updateData();
        }
        formateDataCollection.prototype._updateData = function () {
            var temp = Array();
            temp.push(new KeyDictionary("bold", new actionType("b,strong", "font-weight:bold;", "b", { "font-weight": '' }, "span")));
            temp.push(new KeyDictionary("italic", new actionType("i, cite, em, var, address, dfn", "font-style:italic", "i", { "font-style": '' }, "span")));
            temp.push(new KeyDictionary("underline", new actionType("u,ins", "text-decoration:underline;", "u", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("strikethrough", new actionType("s, strike, del", "text-decoration:line-through;", "s", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("superscript", new actionType("sup", "vertical-align:super;font-size:smaller;", "sup", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("subscript", new actionType("sub", "vertical-align:sub;font-size:smaller;", "sub", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontsize", new actionType(null, "font-size", "span", { "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontname", new actionType(null, "font-family", "span", { "font-family": '' }, "span")));
            temp.push(new KeyDictionary("forecolor", new actionType(null, "color", "span", { "color": '' }, "span")));
            temp.push(new KeyDictionary("backcolor", new actionType(null, "background-color", "span", { "background-color": '' }, "span")));
            this.tempCollection = temp;
        };
        formateDataCollection.prototype.getFormatData = function (format) {
            var temp;
            for (var index = 0; index < this.tempCollection.length; index++) {
                temp = this.tempCollection[index];
                if (temp.Key == format)
                    return this.tempCollection[index];
            }
        };
        return formateDataCollection;
    }());
    var RangeExtractor = (function () {
        function RangeExtractor(target) {
            this.exp = /\s/g;
            this._findStatus = { leftSide: null, rightSide: null };
            this._iterationStatus = false;
            this._cursorData = { node: null, offSet: null };
            this._nodeCollection = [];
            this._traverseData = {
                leftSide: { childNode: "lastChild", sibling: "previousSibling" },
                rightSide: { childNode: "firstChild", sibling: "nextSibling" }
            };
            this._blockNodes = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this._noContent = false;
            this.nodeCollection = { leftSide: [], rightSide: [] };
            this.currentDocument = target;
        }
        RangeExtractor.prototype.ProcessRange = function () {
            var tempRange = this._getRange();
            if (($(this.currentDocument.body).attr("contenteditable") == "true") && tempRange) {
                this._nodeCollection = [], this._noContent = false;
                this._iterationStatus = false;
                this._cursorData = { node: null, offSet: null };
                if ((tempRange.startContainer == tempRange.endContainer) && (tempRange.startOffset == tempRange.endOffset)) {
                    this._collectCursorBasedTextNode(tempRange.startContainer, tempRange.startOffset);
                    this.cursorBasedCollection = true;
                }
                else {
                    this._collectSelectionBasedTextNode(tempRange);
                    this.cursorBasedCollection = false;
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._insertCursor = function (startContainer, startOffset) {
            var firstNodeData = startContainer.data.substring(0, startOffset), middleNodeData = "", lastNodeData = startContainer.data.substr(startOffset), tempNode;
            firstNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
            lastNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
            $(startContainer).replaceWith(tempNode = document.createTextNode(middleNodeData));
            this._cursorData = { node: tempNode, offSet: 0 };
            this._nodeCollection.push(tempNode);
            this._noContent = true;
        };
        RangeExtractor.prototype._collectCursorBasedTextNode = function (startContainer, startOffset) {
            var tempLeftIndex, temp, validString, tempNode, tempRightIndex, regx = new RegExp(this.exp);
            while (temp = regx.exec(startContainer.data)) {
                if (startContainer.data.substring(temp.index, temp.index + 1).indexOf(" ") != -1) {
                    if (temp.index < startOffset) {
                        tempLeftIndex = temp;
                    }
                    if (!tempRightIndex && (startOffset <= temp.index)) {
                        tempRightIndex = temp;
                    }
                }
            }
            if (tempLeftIndex && tempRightIndex) {
                if ((startOffset - (tempLeftIndex.index + 1) == 0 || startOffset - (tempLeftIndex.index + 1) == startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index).replace("\n", '').length)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1), lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                }
            }
            else if (tempLeftIndex) {
                var rightSideNode;
                this._collectNodeData(startContainer, false);
                rightSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if ((rightSideNode.length == 0) && (((startOffset - (tempLeftIndex.index + 1)) == 0) || ((startOffset - (tempLeftIndex.index + 1)) == startContainer.data.substring(tempLeftIndex.index + 1).replace("\n", '').length))) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                    this._nodeCollection.concat(rightSideNode);
                }
            }
            else if (tempRightIndex) {
                var leftSideNode;
                this._collectNodeData(startContainer, true);
                leftSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if (leftSideNode.length == 0 && ((startOffset == startContainer.data.substring(0, tempRightIndex.index).replace("\n", '').length) || startOffset == 0)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(0, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._nodeCollection = leftSideNode.reverse();
                    this._nodeCollection.push(tempNode);
                }
            }
            else {
                if (startContainer.nodeType != 3) {
                    tempNode = document.createTextNode("");
                    if (startContainer.firstChild)
                        $(tempNode).insertBefore(startContainer.firstChild);
                    else
                        $(tempNode).appendTo(startContainer);
                    this._nodeCollection.push(tempNode);
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._noContent = true;
                }
                else {
                    var rightSideNode, leftSideNode;
                    this._collectNodeData(tempNode = startContainer, false);
                    rightSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    this._collectNodeData(tempNode, true);
                    leftSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    if (tempNode.data == String.fromCharCode(65279) || (leftSideNode.length == 0 && startOffset == 0) || (rightSideNode.length == 0 && tempNode.data.replace(String.fromCharCode(65279), "").replace("\n", '').length == startOffset)) {
                        this._insertCursor(startContainer, startOffset);
                    }
                    else {
                        this._nodeCollection = leftSideNode.reverse();
                        this._nodeCollection.push(tempNode);
                        this._nodeCollection = this._nodeCollection.concat(rightSideNode);
                        this._cursorData = { node: tempNode, offSet: startOffset };
                    }
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._validateContent = function (node, traverse) {
            var regx = new RegExp(this.exp), temp, _matches = [], tempTxtNode, textIndex;
            while (temp = regx.exec(node.data)) {
                _matches.push(temp);
            }
            if (_matches.length) {
                temp = _matches[(traverse == "leftSide") ? _matches.length - 1 : 0], textIndex = (traverse == "leftSide") ? temp.index + 1 : temp.index;
                $(tempTxtNode = document.createTextNode(node.data.substring(textIndex))).insertAfter(node);
                node.data = node.data.substring(0, textIndex);
                if ((traverse == "rightSide") && $.trim(node.data))
                    this._nodeCollection.push(node);
                else if ((traverse == "leftSide") && $.trim(tempTxtNode.data))
                    this._nodeCollection.push(tempTxtNode);
                this._findStatus[traverse] = true;
            }
            else
                this._nodeCollection.push(node);
        };
        RangeExtractor.prototype._iterateNodes = function (element, traverse) {
            if (!this._findStatus[traverse]) {
                if (element.nodeType == 3 && element.data)
                    this._validateContent(element, traverse);
                else if ((element = element[this._traverseData[traverse]["childNode"]]) && !this._findStatus[traverse])
                    do {
                        (element.nodeType == 3 && element.data) ? this._validateContent(element, traverse) : this._iterateNodes(element, traverse);
                    } while ((element = element[this._traverseData[traverse]["sibling"]]) && !this._findStatus[traverse]);
            }
        };
        RangeExtractor.prototype._collectNodeData = function (node, leftSide) {
            this._findStatus = { leftSide: undefined, rightSide: undefined };
            var _proxy = this;
            var traverse = leftSide ? "leftSide" : "rightSide";
            do {
                this.nodeCollection = this._splitSiblingNode(node);
                $(this.nodeCollection[traverse]).each(function (index, element) { _proxy._iterateNodes(element, traverse); });
            } while (!this._validateBlockType(node.parentNode) && (node = node.parentNode) && !this._findStatus[traverse]);
        };
        RangeExtractor.prototype._validateBlockType = function (node) {
            return ($.inArray(node.tagName.toLowerCase(), this._blockNodes.concat("body")) != -1);
        };
        RangeExtractor.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        RangeExtractor.prototype._splitSiblingNode = function (node) {
            var temp = node, nodeSiblingData = { leftSide: [], rightSide: [] };
            while (temp = temp.nextSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.leftSide.push(temp);
            }
            return nodeSiblingData;
        };
        RangeExtractor.prototype._getRange = function () {
            var selCurrent = this.currentDocument.getSelection(), range = null;
            (selCurrent.rangeCount) && (range = selCurrent.getRangeAt(0));
            return range;
        };
        RangeExtractor.prototype._collectSelectionBasedTextNode = function (tempRange) {
            var leftData, rightData, centerData, leftNode, rightNode, centerNode, startNode = tempRange.startContainer, endNode = tempRange.endContainer;
            this._nodeCollection = [];
            if (tempRange.startContainer == tempRange.endContainer) {
                if (this._validateTextNode(tempRange.endContainer)) {
                    if (tempRange.startOffset)
                        leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    if (tempRange.startContainer.data.length != tempRange.endOffset)
                        rightData = tempRange.startContainer.data.substr(tempRange.endOffset);
                    centerData = tempRange.startContainer.data.substr(tempRange.startOffset, (tempRange.endOffset - tempRange.startOffset));
                    leftData && ($((leftNode = document.createTextNode(leftData))).insertBefore(tempRange.startContainer));
                    rightData && ($((rightNode = document.createTextNode(rightData))).insertAfter(tempRange.startContainer));
                    centerData && ($(tempRange.startContainer).replaceWith(centerNode = document.createTextNode(centerData))) && this._nodeCollection.push(centerNode);
                }
                else
                    this._updateNodeCollection((tempRange.startContainer.nodeName.toLowerCase() == 'html') ? $(tempRange.startContainer).find('body')[0] : tempRange.startContainer, startNode, null);
            }
            else {
                if (tempRange.startContainer.nodeType == 3 && tempRange.startOffset) {
                    leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    rightData = tempRange.startContainer.data.substr(tempRange.startOffset);
                    ($(document.createTextNode(leftData)).insertBefore(tempRange.startContainer));
                    ($(startNode).replaceWith(startNode = document.createTextNode(rightData)));
                }
                if (tempRange.endContainer.nodeType == 3 && tempRange.endContainer.data.length != tempRange.endOffset) {
                    rightData = tempRange.endContainer.data.substr(tempRange.endOffset);
                    leftData = tempRange.endContainer.data.substr(0, tempRange.endOffset);
                    ($(document.createTextNode(rightData)).insertAfter(tempRange.endContainer));
                    ($(endNode).replaceWith(endNode = document.createTextNode(leftData)));
                }
                else if (tempRange.endOffset && tempRange.endContainer.lastChild)
                    endNode = tempRange.endContainer.lastChild;
                this._updateNodeCollection(tempRange.commonAncestorContainer, startNode, endNode);
            }
        };
        RangeExtractor.prototype._updateNodeCollection = function (targetNode, startNode, endNode) {
            this._updateIterationStatus(targetNode, startNode, endNode);
            if (targetNode = targetNode.firstChild)
                do
                    this._updateNodeCollection(targetNode, startNode, endNode);
                while (targetNode = targetNode.nextSibling);
        };
        RangeExtractor.prototype._updateIterationStatus = function (targetNode, startNode, endNode) {
            (targetNode == startNode && !this._iterationStatus) && (this._iterationStatus = true);
            if (targetNode.nodeType == 3 && this._iterationStatus)
                this._nodeCollection.push(targetNode);
            (targetNode == endNode && this._iterationStatus) && (this._iterationStatus = false);
        };
        return RangeExtractor;
    }());
})(documentManager || (documentManager = {}));
$.extend(ej, documentManager);
window["documentManager"] = null;
;
/**
* @fileOverview Plugin provides support to display color picker within your web page and allows to pick the color.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws.
* @version 12.1
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejColorPicker", "ej.ColorPicker", {
        _rootCSS: "e-colorpicker",

        element: null,

        model: null,
        validTags: ["input", "div"],
        _addToPersist: ["value", "opacityValue"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            enableOpacity: true,

            opacityValue: 100,

            columns: 10,

            palette: "basicpalette",

            htmlAttributes: {},

            buttonMode: "split",

            custom: [],

            presetType: "basic",

            modelType: "picker",

            locale: "en-US",

            showPreview: true,

            showTooltip: false,

            showClearButton: false,

            showSwitcher: true,

            value: null,

            displayInline: false,

            buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            },

            showApplyCancel: true,

            showRecentColors: false,

            toolIcon: null,

            cssClass: "",

            enabled: true,

            change: null,

            select: null,

            open: null,

            close: null,

            create: null,

            destroy: null,
        },
        dataTypes: {
            modelType: "enum",
            palette: "enum",
            presetType: "enum",
            cssClass: "string",
            displayInline: "boolean",
            locale: "string",
            showSwitcher: "boolean",
            showRecentColors: "boolean",
            enabled: "boolean",
            showPreview: "boolean",
            enableOpacity: "boolean",
            buttonText: "data",
            custom: "array",
            htmlAttributs: "data"
        },

        observables: ["value", "opacityValue"],
        value: ej.util.valueFunction("value"),
        opacityValue: ej.util.valueFunction("opacityValue"),

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "enableOpacity":
                        this.model.enableOpacity = jsondata[key];
                        this._previewSlider(this.model.enableOpacity);
                        this._valueOperation();
                        break;
                    case "opacityValue":
                        if (this.model.enableOpacity) {
                            this._tempOpacity = parseFloat(ej.util.getVal(jsondata[key]));
                            this._opacity.option('value', this._tempOpacity);
                            !this._switch && this._changeOpacity();
                            this._updateValue();
                            this.opacityValue(this._tempOpacity);
                            typeof jsondata[key] == "function" ? jsondata[key](this.opacityValue()) : jsondata[key] = this.opacityValue();
                            break;
                        } else return false;
                    case "custom":
                        this.model.custom = jsondata[key];
                        this._reInitialize();
                        break;
                    case "palette":
                        this.model.palette = jsondata[key];
                        this._reInitialize();
                        break;
                    case "columns":
                        this.model.columns = parseFloat(jsondata[key]);
                        this._reInitialize();
                        jsondata[key] = this.model.columns;
                        break;
                    case "presetType":
                        this.model.presetType = jsondata[key];
                        if (ej.isNullOrUndefined(Colors[this.model.presetType])) return false;
                        else
                            this._reInitialize();
                        break;
                    case "buttonMode":
                        this._unBindIconClick();
                        this._buttonElement = ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.dropdownbutton : this.wrapper;
                        ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.wrapper.addClass("e-split") : this.wrapper.removeClass("e-split");
                        this._bindIconClick();
                        break;
                    case "showTooltip":
                        this._colorSlider.option('showTooltip', jsondata[key]);
                        this._opacity.option('showTooltip', jsondata[key]);
                        break;
                    case "value":
                        this._setValue(ej.util.getVal(jsondata[key]), true);
                        if (typeof jsondata[key] == "function")
                            jsondata[key](this.value());
                        else
                            jsondata[key] = this.value();
                        break;
                    case "modelType":
                        this.model.modelType = jsondata[key];
                        this._reInitialize();
                        break;
                    case "showSwitcher":
                        this.model.showSwitcher = jsondata[key];
                        this._showSwitcher();
                        break;
                    case "tooltipText":
                        this._toolTipText(jsondata[key]);
                        break;
                    case "locale": 
                        this.model.locale = jsondata[key];
                        this._localize(jsondata[key]);
                        break;
                    case "showPreview":
                        this.model.showPreview = jsondata[key];
                        this._previewPane(this.model.showPreview);
                        break;
                    case "buttonText":
                        this._buttonText(jsondata[key]);
                        break;
                    case "displayInline":
                        this._setDisplayInline(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        this.model.cssClass = jsondata[key];
                        break;
                    case "enabled":
                        this._enabled(jsondata[key]);
                        break;
                    case "showRecentColors":
                        this.model.showRecentColors = jsondata[key];
                        this._previewColor(this.model.showRecentColors);
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "showClearButton": this._showClearIcon(jsondata[key]); break;
                    case "showApplyCancel": this.model.showApplyCancel = jsondata[key]; this._buttonContainer(); break;
                }
            }
        },


        _setSkin: function (className) {
            if (this.wrapper)
                this.wrapper.removeClass(this.model.cssClass).addClass(className);
            else
                this.element.removeClass(this.model.cssClass).addClass(className);
        },
        _showSwitcher: function () {
            if (this.model.showSwitcher) {
                this._changeTag.removeClass('e-hide');
                this.model.modelType == "picker" ? this._switcher.addClass('e-paletteModel').removeClass('e-pickerModel') : this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
            else
                this._changeTag.addClass('e-hide');
        },
        _pickerType: function () {
            this._modelType = "picker";
            this.PaletteWrapper.removeAttr('style');
            this.PaletteWrapper.addClass('e-hide');
            this._gradient.removeClass('e-hide');
            this._gradient.fadeIn(200);
            this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this._switcher.removeAttr('class');
            this._switcher.addClass('e-color-image e-paletteModel');
            this._switch = true;
            this._rgbValue();
            this._hueGradient();
            this._updateUI();
            this._alphaGradient(this.RGBToHEX(this.rgb));
            this._hsva.ejButton("enable");
            this._switchEvents();
            this._unSwitchEvents();
            this._hideUnBindEvents();
            this.isPopupOpen && this._showBindEvents();
            this.model.modelType == "default" ? this._changeTag.removeClass('e-hide') : this._changeTag.addClass('e-hide');
            this.popupList.prepend(this._gradient);
            this._showSwitcher();
        },
        _paletteType: function () {
            this._gradient.removeAttr('style');
            this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.PaletteWrapper.removeClass('e-hide');
            this.PaletteWrapper.fadeIn(200);
            this._switch = false;
            this._disableHSVButton();
            this._cellSelect();
            this._switchEvents();
            this._unSwitchEvents();
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            this.popupList.prepend(this.PaletteWrapper);
            this._showSwitcher();
        },
        _reInitialize: function () {
            this._destroyPalette(false);
        },
        _destroyPalette: function (presets) {
            this.PaletteWrapper.remove();
            if (presets || this._columns != this.model.columns && this.model.palette !== "custompalette") this.PaletteWrapper = this._presetType(this._presetsId);
            if (this._temp !== this.model.presetType) this.PaletteWrapper = this._layoutType(this.model.palette);
            if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._hideUnBindEvents();
                this.isPopupOpen && this._showBindEvents();
                this._gradient.addClass('e-hide');
                this._paletteType();
                presets || this.model.palette == "custompalette" ? "" : this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            }
            if (this.model.modelType == "picker") {
                this._pickerType();
                if (this.model.displayInline && !this.element.is('input'))
                    this._footer.addClass('e-hide');
            }
            this._temp = this.model.presetType; this._columns = this.model.columns;
            if (this._modelType == "picker")
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            else
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.refresh();
        },
        _previewColor: function (color) {
            if (color) {
                this._swatchesArea.fadeIn(200);
                this._bindRecentEvent();
            }
            else {
                this._swatchesArea.fadeOut(200);
                this._unBindRecentEvent();
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            if (!ej.isNullOrUndefined(this._buttonTag)) this._buttonTag.html(this.model.buttonText.apply);
            if (!ej.isNullOrUndefined(this._cancelTag)) this._cancelTag.html(this.model.buttonText.cancel);
            this._spnTag.html(this.model.buttonText.swatches);
        },
        _toolTipText: function (data) {
            $.extend(this.model.tooltipText, data);
            this._addTitleText();
        },
        _previewPane: function (showPreview) {
            showPreview ? this._previewTag.removeClass("e-hide") : this._previewTag.addClass("e-hide");
        },
        _previewSlider: function (slider) {
            slider ? this._opacity.enable() : this._opacity.disable();
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _localize: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (this._options.locale == "en-US" && !ej.isNullOrUndefined(this._options.buttonText) || !ej.isNullOrUndefined(this._options.tooltipText)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    this._buttonText(this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.tooltipText))
                    this._toolTipText(this._options.tooltipText);
            }
            else if (!ej.isNullOrUndefined(this._localizedLabels)) {
                if (!ej.isNullOrUndefined(this._localizedLabels.buttonText))
                    this._buttonText(this._localizedLabels.buttonText)
                if (!ej.isNullOrUndefined(this._localizedLabels.tooltipText))
                    this._toolTipText(this._localizedLabels.tooltipText)
            }
        },
        _destroy: function () {
            if (this.model.displayInline)
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
            if (this.isPopupOpen) this.hide();
            this.popupContainer.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
                this._presetContainer.parent('.e-menu-wrap').remove();
            }
            this.element.removeClass('e-colorpicker e-input e-widget').removeAttr("style name").val(this.element.attr("value"));
        },
        _init: function (options) {
            this._options = options;
            this._browser = ej.browserInfo();
            this._isFocused = false;
            this.isPopupOpen = false;
            this._dataBind = false;
            this._modelType = "picker";
            if (this._id)
                $("#" + this._id + "_popup").remove();
            if ("#" + this._id + "_Presets")
                $('#' + this._id + "_Presets").parent('.e-menu-wrap').remove();
            this.model.palette === "basicpalette" ? this._presetsId = "e-presets30" : "";
            if (ej.isNullOrUndefined(this.value()) && this.element[0].value !== "") this._tempValue = this.element[0].value;
            else this._tempValue = this.value();
            this._previousValue = this._previousColor = this._tempValue;
            this._renderControl();
            this._tempOpacity = this.opacityValue();
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this.popupContainer.find('button.e-presets').ejSplitButton({ targetID: this._presetContainer.attr('id') });
            if (this._tempValue) {
                this._setValue(this._tempValue);
                if (this._switch) this._rgbValue();
            }
            this._hsvValue();
            this._hueGradient();
            this._addTitleText();
            this._showClearIcon(this.model.showClearButton);
            this._columns = this.model.columns;
            this._temp = this.model.presetType;
            if (!this._tempValue) {
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this._tempOpacity);
                this._alphaGradient("#fff");
                this._previousValue = "";
            }
            !this.model.enabled && this._enabled(this.model.enabled);
        },
        _renderControl: function () {
            this._createWrapper();
            this._renderPopupPanelWrapper();
            this._selectedButton = this._groupTag.find('.e-click');
            this._buttonContainer();
            this._renderPopupElement();
            this._buttonElement = ej.ColorPicker.ButtonMode.Split == this.model.buttonMode ? this.dropdownbutton : this.wrapper;
            if (this.model.buttonMode == ej.ColorPicker.ButtonMode.Split && this.element.is('input')) this.wrapper.addClass("e-split");
            this._addAttr(this.model.htmlAttributes);
            this._setDisplayInline(this.model.displayInline);
            this._previewPane(this.model.showPreview);
            this._previewColor(this.model.showRecentColors);
            this._localize();
            if (this._switch) this._previewSlider(this.model.enableOpacity);
            this._wireEvents();
            this._switchEvents();
        },

        _createWrapper: function () {
            if (this.element.is("input")) {
                this.element.addClass('e-input e-widget');
                this.spanElement = ej.buildTag("span.e-selected-color");
                this.wrapper = ej.buildTag("span.e-colorwidget e-picker e-widget " + this.model.cssClass).attr({ 'tabindex': '0', "aria-expanded": false, "aria-haspopup": true, "aria-owns": "popup" });
                if (this._id) this.wrapper.attr('id', this._id + "Wrapper");
                this.container = ej.buildTag("span.e-in-wrap e-box e-splitarrowright");
                this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select" });
                this.dropdownbutton = ej.buildTag("span.e-select", "", {}, { "role": "button" }).append(this.drpbtnspan);
                this.iconWrapper = ej.buildTag("span.e-tool-icon " + this.model.toolIcon);
                this.colorContainer = ej.buildTag("span.e-color-container");
                this.colorContainer.append(this.spanElement);
                this.container.insertAfter(this.element);
                if (!ej.isNullOrUndefined(this.model.toolIcon)) {
                    this.colorContainer.prepend(this.iconWrapper);
                    this.container.addClass('e-tool');
                    this.container.append(this.colorContainer);
                }
                else
                    this.container.append(this.colorContainer);
                this.container.append(this.element, this.dropdownbutton);
                this.wrapper.insertBefore(this.container);
                this.wrapper.append(this.container);
                this.element.css("display", "none").val(this.value());
            }
            this._checkNameAttr();
        },
        _addTitleText: function () {
            this._switcher.attr('title', this.model.tooltipText.switcher);
            this._spanTag.attr('title', this.model.tooltipText.addButton);
            this._presetLi.find("#e-presets00").attr('title', this.model.tooltipText.webColors);
            this._presetLi.find("#e-presets01").attr('title', this.model.tooltipText.vintage);
            this._presetLi.find("#e-presets02").attr('title', this.model.tooltipText.seaWolf);
            this._presetLi.find("#e-presets10").attr('title', this.model.tooltipText.sandy);
            this._presetLi.find("#e-presets11").attr('title', this.model.tooltipText.pinkShades);
            this._presetLi.find("#e-presets12").attr('title', this.model.tooltipText.moonLight);
            this._presetLi.find("#e-presets20").attr('title', this.model.tooltipText.monoChrome);
            this._presetLi.find("#e-presets21").attr('title', this.model.tooltipText.misty);
            this._presetLi.find("#e-presets22").attr('title', this.model.tooltipText.flatColors);
            this._presetLi.find("#e-presets30").attr('title', this.model.tooltipText.basic);
            this._presetLi.find("#e-presets31").attr('title', this.model.tooltipText.candyCrush);
            this._presetLi.find("#e-presets32").attr('title', this.model.tooltipText.citrus);
            this._currentTag.attr('title', this.model.tooltipText.currentColor);
            this._previousTag.attr('title', this.model.tooltipText.selectedColor);
        },
        _renderPopupPanelWrapper: function () {
            this.popupContainer = ej.buildTag("div.e-colorpicker e-box e-popup e-widget " + this.model.cssClass, "", {}, { "role": "grid", "aria-readonly": "true", "tabindex": '0', "style": "visibility:hidden" });
            if (this._id) this.popupContainer.attr('id', this._id + "_popup");
            $('body').append(this.popupContainer);

            this.popupList = ej.buildTag("div.e-popupWrapper");

            this._gradient = ej.buildTag("div.e-container");

            this._colorArea = ej.buildTag("div.e-hsv-color");
            this._gradientArea = ej.buildTag("div.e-hsv-gradient")
            this._handleArea = ej.buildTag("div.e-draghandle e-color-image");
            this._browser == "msie" && this._handleArea.addClass('e-pinch');
            this._colorArea.append(this._gradientArea, this._handleArea);

            this._picker = ej.buildTag("div.e-gradient");
            this._hueSlider = ej.buildTag("div.e-widget e-hue e-state-default");
            this._alphaSlider = ej.buildTag("div.e-widget e-opacity e-state-default");
            this._picker.append(this._hueSlider, this._alphaSlider);

            this._gradient.append(this._colorArea, this._picker);

            this.popupList.append(this._gradient);


            this._footerBlock = ej.buildTag("div.e-footerContainer");

            this._templateWrapper = ej.buildTag("div.e-buttons");


            this._groupTag = ej.buildTag("div.e-grpbtn");

            this._formEle = ej.buildTag("div.e-form");
            this._rgb = ej.buildTag("button.e-rgbButton e-click", "", {}, { type: "button" });
            this._hexCode = ej.buildTag("button.e-hexButton", "", {}, { type: "button" });
            this._hsva = ej.buildTag("button.e-hsvButton", "", {}, { type: "button" });
            this._groupTag.append(this._rgb, this._hexCode, this._hsva);


            this._codeEditor = ej.buildTag("div.e-codeeditor");
            this._inputTag = ej.buildTag("input.e-color-code", "", {}, { "type": "text", 'tabindex': '0', "maxLength": "22" });
            this._codeEditor.append(this._inputTag);

            this._formEle.append(this._groupTag, this._codeEditor);

            this._previewTag = ej.buildTag("div.e-preview").attr({ 'tabindex': '0' });
            this._currentTag = ej.buildTag("div.e-current");
            this._previousTag = ej.buildTag("div.e-previous");
            this._previewTag.append(this._currentTag, this._previousTag);

            this._templateWrapper.append(this._formEle, this._previewTag);

            this._swatchesArea = ej.buildTag("div.e-color-labels");
            var blockCount = 11;
            this._divTag = ej.buildTag("div.e-recent-color");
            this._addTag = ej.buildTag('div.e-colorblock e-block');
            this._spanTag = ej.buildTag('div.e-color e-color-image e-add');
            this._addTag.append(this._spanTag)
            this._divTag.append(this._addTag);
            for (var count = 0; count < blockCount; count++) {
                this._liTag = ej.buildTag('div.e-colorblock e-block');
                var spanTag = ej.buildTag('div.e-color e-color-image e-empty');
                this._liTag.append(spanTag);
                this._divTag.prepend(this._liTag);
            }
            this._swatchesArea.append(this._divTag);

            this._footer = ej.buildTag('div.e-footer');
            this._swatches = ej.buildTag('div.e-element');
            this._changeTag = ej.buildTag('div.e-switcher').attr('tabindex', '0');
            this._switcher = ej.buildTag('div.e-color-image');
            this._presetTag = ej.buildTag('button.e-presets e-colorSplit');
            this._presets = ej.buildTag('div');
            this._changeTag.append(this._switcher);
            this._presetTag.append(this._presets);
            this._swatches.append(this._changeTag, this._presetTag);
            this._footer.append(this._swatches);
            this._footerBlock.append(this._templateWrapper, this._swatchesArea, this._footer);

            this.PaletteWrapper = this._layoutType(this.model.palette);
            this.popupList.append(this.PaletteWrapper, this._footerBlock);
            var oldWrapper = $("#" + this._id + "_Presets").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._presetContainer = $("<ul id='" + this._id + "_Presets' class='e-presetWrapper' style= top:87px ></ul>");
            this._presetLi = ej.buildTag('li.e-item');
            this._presetLi.append(this._renderPresets());
            this._presetContainer.append(this._presetLi);
            this.popupList.append(this._presetContainer);
            this.popupContainer.append(this.popupList);

            //IE Support
            if (this._browser.name = "msie" && (this._browser.version == "9.0" || this._browser.version == "8.0"))
                this._hueSlider.addClass('e-color-image e-filter');
            else
                this._hueSlider.addClass('e-common');
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },
        _buttonContainer: function () {
            if (this.model.showApplyCancel) {
                this._buttonTag = ej.buildTag("button.e-applyButton", "", {}, { type: "button" });
                this._cancelTag = ej.buildTag("button.e-cancelButton", "", {}, { type: "button" });
                this._footer.append(this._buttonTag, this._cancelTag);
                this._applyObj = this.popupContainer.find('button.e-applyButton').ejButton({ text: this.model.buttonText.apply, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._cancelObj = this.popupContainer.find('button.e-cancelButton').ejButton({ text: this.model.buttonText.cancel, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._on(this._cancelTag, "click", this._hidePopup);
                this._on(this._buttonTag, "click", this._buttonClick);
            } else if (this._buttonTag !== undefined && this._cancelTag !== undefined) {
                this._buttonTag.remove();
                this._cancelTag.remove();
                this._off(this._cancelTag, "click", this._hidePopup);
                this._off(this._buttonTag, "click", this._buttonClick);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._enabled(false);
                else proxy.wrapper.attr(key, value)
            });
        },
        _showClearIcon: function (bool) {
            if (bool) {
                this._clearIcon = ej.buildTag("div", {}, {}, { "class": "e-icon e-close_01" }).hide();
                this._codeEditor.append(this._clearIcon);
                this._on(this._clearIcon, "mousedown", this._clearColor);
                this._on(this._clearIcon, "click", this._clearColor);
            } else {
                this._clearIcon && this._clearIcon.remove();
                this._off(this._clearIcon, "mousedown", this._clearColor);
                this._off(this._clearIcon, "click", this._clearColor);
            }
        },
        _colorPresetsClick: function (e) {
            this._presetsId = e.currentTarget.id;
            if (this._presetsId === "e-presets00") this.model.presetType = "webcolors";
            else if (this._presetsId === "e-presets01") this.model.presetType = "vintage";
            else if (this._presetsId === "e-presets02") this.model.presetType = "seawolf";
            else if (this._presetsId === "e-presets10") this.model.presetType = "sandy";
            else if (this._presetsId === "e-presets11") this.model.presetType = "pinkshades";
            else if (this._presetsId === "e-presets12") this.model.presetType = "moonlight";
            else if (this._presetsId === "e-presets20") this.model.presetType = "monochrome";
            else if (this._presetsId === "e-presets21") this.model.presetType = "misty";
            else if (this._presetsId === "e-presets22") this.model.presetType = "flatcolors";
            else if (this._presetsId === "e-presets30") this.model.presetType = "basic";
            else if (this._presetsId === "e-presets31") this.model.presetType = "candycrush";
            else if (this._presetsId === "e-presets32") this.model.presetType = "citrus";
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            $("#" + this._id + "_Presets").find("li.e-preset-row").removeClass("e-presetsactive");
            $("#" + this._presetsId).addClass("e-presetsactive");
            this.PaletteWrapper.remove();
            if (this._modelType == "palette") {
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
        },

        _renderPresets: function () {
            var tableDiv = ej.buildTag("div.e-presets-table");
            this._spnTag = ej.buildTag("span.e-presetHeader");
            this._spnTag.html(this.model.buttonText.swatches);
            tableDiv.append(this._spnTag);
            var color = 0, hexCode, rowDiv;
            for (var row = 0; row < 4 ; row++) {
                rowDiv = ej.buildTag("ul.e-tablerow");
                for (var col = 0; col < 3 ; col++) {
                    var tableCell = ej.buildTag("li.e-color-image e-preset-row" + "#" + "e-presets" + [row] + [col]);
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },
        _renderPopupElement: function () {
            var proxy = this;
            this._hsv =
            {
                h: 360, s: 0, v: 100
            };
            this._rgb.ejButton({ text: "RGBA", type: "button" });
            this._hexCode.ejButton({ text: "HEX", type: "button" });
            this._hsva.ejButton({ text: "HSVA", type: "button" });
            this._splitObj = this._presetTag.ejSplitButton({ size: "normal", showRoundedCorner: true, contentType: "imageonly" }).data('ejSplitButton');
            this._splitObj.option("beforeOpen", function (e) { proxy._bindClickOperation(e); });
            this._presetTag.parents('.e-split.e-widget').css({ "height": "27px" });
            this.model.custom.length == 0 ? this._splitObj.option('prefixIcon', "e-icon e-color-image e-" + this.model.presetType) : "";
            $("#" + this._presetsId).addClass("e-presetsactive");
            this._splitObj._getXYpos = function (e) {
                $("#" + this.model.targetID).ejMenu({ animationType: "none" });
                var btnposx, btnposy, btnpos = this.dropbutton.offset();
                btnposx = btnpos.left - this.dropbutton.prev().outerWidth() - 1;
                btnposy = (btnpos.top - $("#" + this.model.targetID).outerHeight()) - 1;
                return { x: btnposx, y: btnposy }
            }
            this._colorSlider = this._hueSlider.ejSlider({ orientation: "Vertical", showTooltip: this.model.showTooltip, minValue: 0, maxValue: 360, change: function (e) { proxy._changeHue(e); }, slide: function (e) { proxy._changeHue(e); } }).data('ejSlider');
            this._opacity = this._alphaSlider.ejSlider({ value: this.opacityValue(), showTooltip: this.model.showTooltip, orientation: "Vertical", incrementStep: 5, value: 100, change: function (e) { proxy._changeAlpha(e); }, slide: function (e) { proxy._changeAlpha(e); } }).data('ejSlider');
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._handleTag = ej.buildTag("div.e-handle-wrapper");
                this._handleTag.appendTo(this._opacity.element.find("a.e-handle"));
            }
            this._colorSlider.firstHandle.css({ "height": "13px", "width": "13px" });
            this._opacity.firstHandle.css({ "height": "13px", "width": "13px" });
            this.popupContainer.css({ "visibility": "visible", "display": "none" });
            if (this.model.modelType == "picker") {
                this._modelType = "picker";
                this._gradient.removeClass('e-hide');
                this.PaletteWrapper.addClass('e-hide');
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                this._showSwitcher();
                this._switch = true;
            } else if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                this.PaletteWrapper.removeClass('e-hide');
                this._gradient.addClass('e-hide');
                this._hsva.ejButton("disable");
                this._showSwitcher();
                this._switch = false;
            }
        },
        _layoutType: function (type) {
            if (typeof type === "string" && type == "basicpalette")
                this._collection = this._paletteGenerate(Colors[this.model.presetType], this.model.columns);
            else if (typeof type === "string" && type == "custompalette" && this.model.modelType == "palette")
                this._collection = this._paletteGenerate(this.model.custom, this.model.columns);
            type == "custompalette" ? this._collection.addClass('e-custom') : "";
            return this._collection;
        },
        _presetType: function (type) {
            if (type === "e-presets00") this._collection = this._paletteGenerate(Colors.webcolors, this.model.columns);
            else if (type === "e-presets01") this._collection = this._paletteGenerate(Colors.vintage, this.model.columns);
            else if (type === "e-presets02") this._collection = this._paletteGenerate(Colors.seawolf, this.model.columns);
            else if (type === "e-presets10") this._collection = this._paletteGenerate(Colors.sandy, this.model.columns);
            else if (type === "e-presets11") this._collection = this._paletteGenerate(Colors.pinkshades, this.model.columns);
            else if (type === "e-presets12") this._collection = this._paletteGenerate(Colors.moonlight, this.model.columns);
            else if (type === "e-presets20") this._collection = this._paletteGenerate(Colors.monochrome, this.model.columns);
            else if (type === "e-presets21") this._collection = this._paletteGenerate(Colors.misty, this.model.columns);
            else if (type === "e-presets22") this._collection = this._paletteGenerate(Colors.flatcolors, this.model.columns);
            else if (type === "e-presets30") this._collection = this._paletteGenerate(Colors.basic, this.model.columns);
            else if (type === "e-presets31") this._collection = this._paletteGenerate(Colors.candycrush, this.model.columns);
            else if (type === "e-presets32") this._collection = this._paletteGenerate(Colors.citrus, this.model.columns);
            return this._collection;
        },
        _paletteGenerate: function (colors, columns) {
            var color;
            this._PresetTable = ej.buildTag("div.e-palette-color").attr({ "role": "presentation" });
            this._tag = ej.buildTag("div.e-row").attr({"role":"row"});
            for (color = 0; color < colors.length; color++) {
                if (color && color % columns == 0)
                    this._tag = ej.buildTag("div.e-row").attr({"role":"row"});
                this._td = ej.buildTag("div.e-item").attr({ 'role': 'gridcell', "aria-label": "#" + $.trim(colors[color]), "data-value": "#" + $.trim(colors[color]), "style": "background-color:" + "#" + $.trim(colors[color]) });
                this._tag.append(this._td);
                this._PresetTable.append(this._tag);
            }
            return this._PresetTable;
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name")) this.element.attr({ "name": this.element[0].id });
        },
        _enabled: function (bool) {
            if (bool) this.enable();
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this.element.is("input")) {
                this.popupContainer.insertAfter(this.wrapper);
                this._footer.css({ "display": "none" });
                this._setPopupPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.popupContainer);
                this.popupContainer.find('button.e-applyButton').css({ "display": "none" });
                this.popupContainer.find('button.e-cancelButton').css({ "display": "none" });
                this._footer.css({ "display": "none" });
            }
            else {
                this.popupContainer.css('display', 'none');
                $('body').append(this.popupContainer);
                this._isOpen = false;
                if (this.element.is("input")) {
                    this._bindIconClick();
                    if (this.popupContainer.find('button.e-applyButton').length==0) {
                        this._buttonContainer();
                    }
                    this._footer.css({ "display": "block" });
                    this.wrapper.removeClass("e-focus");
                    this._off($(document), "mousedown", this._onDocumentClick);
                }
                this._isFocused = this.isPopupOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                if (this.element.is("input")) this._off($(this._buttonElement), "mousedown", this._iconClick);
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            }
        },
        _bindIconClick: function () {
            var count = $._data($(this._buttonElement)[0], "events");
            if (ej.isNullOrUndefined(count) || ej.isNullOrUndefined(count.mousedown)) this._on(this._buttonElement, "mousedown", this._iconClick);
            else if (count.mousedown.length == 0) this._on(this._buttonElement, "mousedown", this._iconClick);
        },
        _unBindIconClick: function () {
            this._off(this._buttonElement, "mousedown", this._iconClick);
        },
        _setPopupPosition: function () {
            var elementObj = this.element.is('input') ? this.wrapper : this.element;
            var pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupContainer.outerHeight(),
            popupWidth = this.popupContainer.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupContainer.outerWidth() - elementObj.outerWidth();
            if (popupWidth + elementObj.offset().left > $(window).width()) left = Math.abs(popupWidth - ($(window).width()));
            this.popupContainer.css({
                "left": left + "px",
                'position': 'absolute',
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupContainer);
        },

        _setValue: function (value, isCode) {
            var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$";
            if (typeof value == "object" || (typeof value == "number") || ej.isNullOrUndefined(value.match(reg))) value = null;
            this.value(value);
            this._tempValue = value;
            ej.isNullOrUndefined(value) ? this._setEmptyValue() : this._renderModelValue(value);
            this._changeEvent(false, isCode);
            this._selectEvent();
            this.element.is("input") && this._updateValue();
        },
        _renderModelValue: function (value) {
            var color;
            if (value && typeof value === "string") {
                color = this._HexToHSV(value);
                this._oldValue = this.rgb;
                if (this._switch) {
                    this._valueOperation();
                    this._colorSlider.option('value', parseInt(this._hsv.h));
                }
                this._inputTagValue(this._selectedButton);
                if (!this._switch) {
                    this._updateUI();
                    this.element.val(this.value());
                }
                this._hueGradient();
            }
        },
        setValue: function (code) {
            this._setValue(code);
        },

        enable: function () {
            if (this.model.enabled) return false;
            if (this.wrapper && this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.element.prop("disabled", false);
                if (this.container.hasClass("e-disable")) this.container.removeClass('e-disable');
                this.popupList.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
            } else if (this.model.displayInline) this.element.removeClass('e-disable');
            var temp = this._switch;
            this._switch = true;
            this._cancelObj.enable();
            this._colorSlider.enable();
            this.model.enableOpacity ? this._opacity.enable() : this._opacity.disable();
            this._splitObj.enable();
            this._applyObj.enable();
            this._wireEvents();
            this._switchEvents();
            this._switch = temp;
            $(this._inputTag).prop('readonly', false);
            (this._buttonElement) && this._on(this._buttonElement, "mousedown", this._iconClick);
            this.model.enabled = true;
        },

        disable: function () {
            if (!this.model.enabled) return false;
            if (this.wrapper && !this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.element.attr("disabled", "disabled");
                if (!this.container.hasClass("e-disable")) this.container.addClass('e-disable');
                this.popupList.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
            } else if (this.model.displayInline) this.element.addClass('e-disable');
            var temp = this._switch;
            this._switch = false;
            this._cancelObj.disable();
            this._colorSlider.disable();
            this._opacity.disable();
            this._splitObj.disable();
            this._applyObj.disable();
            this._unWireEvents();
            this._unSwitchEvents();
            this._switch = temp;
            this._unBindIconClick();
            $(this._inputTag).attr('readonly', 'readonly');
            if (this.isPopupOpen && !this.model.displayInline) this.hide();
            this.model.enabled = false;
        },

        getColor: function () {
            return this.rgb;
        },

        getValue: function () {
            return this.value();
        },
        _alphaGradient: function (value) {
            var browser = ej.browserInfo();
            var value = ej.isNullOrUndefined(value) ? "#000000" : value;
            if (browser.name == "mozilla")
                this._alphaSlider.attr({ "style": "background:-moz-linear-gradient(center top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if ((browser.name == "msie") || (browser.name == "edge"))
                this._alphaSlider.attr({ "style": "background:-ms-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "opera" && browser.version <= "11.61")
                this._alphaSlider.attr({ "style": "background:-o-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "chrome" || browser.name == "safari" || (browser.name == "opera"))
                this._alphaSlider.attr({ "style": "background:-webkit-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            if ((browser.name == "msie") && (browser.version == "8.0" || browser.version == "9.0"))
                this._alphaSlider.attr({ "style": "progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=" + value + ", endColorstr=#ffffff)"});            
            if (browser.name == "msie" && browser.version == "8.0")
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
        },
        _hueGradient: function () {
            var temp = this._hsv;
            var value = { h: this._hsv.h, s: 100, v: 100 };
            this._hueSlider.children(".e-handle").css({ "background": this._formRGB(this.HSVToRGB(value)) });
            this._hsv = temp;
        },
        _updateColor: function () {
            if (this.model.displayInline || !this.model.showApplyCancel) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeEvent: function (element, isCode) {
            if (this._change && this._previousValue !== this._tempValue) {
                this._alphaGradient(this._tempValue);
                this._previousValue = this._tempValue;
                this._trigger("change", { value: this._tempValue, changeFrom: element ? "slider" : "picker", isInteraction: !isCode });
                this._updateColor(element);
            }
        },
        _selectEvent: function () {
            if (this._previousColor !== this._tempValue || this._tempOpacity !== this.opacityValue()) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this.element.val(this.value());
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeHue: function (e) {
            this._handleArea.css("visibility", "visible");
            if (parseInt(this._hsv.h) !== parseInt(e.value) && this._switch) {
                this._hsv.h = Math.round(e.value);
                this._hueGradient();
                this._hsvValue();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(true);
            }
        },
        _changeAlpha: function (e) {
            this._handleArea.css("visibility", "visible");
            if (this._switch) {
                this.rgb.a = e.value / 100;
                this._tempOpacity = parseInt(this.rgb.a * 100);
                this._changeOpacity(e);
            }
        },
        _changeOpacity: function (e) {
            this.rgb.a = this._tempOpacity / 100;
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css("background-color", this._formRGBA(this.rgb));
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._inputTagValue(this._selectedButton);
            if (this.model.displayInline) {
                this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction : false });
                (this._trigger("select", { value: this.value() }));
            }
        else this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction: false });
        },
        _updateValue: function () {
            if (this.value()) {
                if (this._browser.name = "msie" && this._browser.version == "8.0") this.spanElement.css({ "background-color": this._formRGB(this._HexToRGB(this.value())), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                else this.spanElement.css({ "background-color": this._formRGBA(this._HexToRGB(this.value())) });
            }
            else this.spanElement.removeAttr('style');
        },
        _bindClickOperation: function (e) {
            var proxy = this, splitMenu;
            proxy._on($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            var SplitMenu = $("#" + proxy._presetContainer.attr('id')).ejMenu("instance");
                SplitMenu.model.close = function () {
                proxy._splitObj.contstatus = false;
                proxy._off($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            }
        },
        _wireEvents: function () {
            if (this.element.is('input')) {
                this._on(this.wrapper, "blur", this._targetBlur);
                this._on(this.wrapper, "focus", this._targetFocus);
                this._on(this.wrapper, "keydown", this._popupShown);
                this._on(this.colorContainer, "click", this._containerClick);
            }
            this._on(this._changeTag, "click", this._switchModel);
            this._on(this._groupTag, "click", this._groupButton);
            this._on(this._addTag, "click", this._addColor);
            this._on(this._codeEditor, "mouseenter", this._inputEvent);
            this._on(this._codeEditor, "mouseleave", this._inputEvent);
            this._on(this._inputTag, "blur", this._inputEvent);
            this._on(this._inputTag, "focus", this._inputEvent);
            this._on(this._inputTag, "keyup", this._inputEvent);
            this._on(this.popupContainer, "focus", this._targetFocus);
            this._on(this.popupContainer, "blur", this._targetBlur);
        },
        _unWireEvents: function () {
            if (!this.model.displayInline && this.element.is('input')) {
                this._off(this.wrapper, "blur", this._targetBlur);
                this._off(this.wrapper, "focus", this._targetFocus);
                this._off(this.wrapper, "keydown", this._popupShown);
                this._off(this.colorContainer, "click", this._containerClick);
            }
            this._off(this._changeTag, "click", this._switchModel);
            this._off(this._groupTag, "click", this._groupButton);
            this._off(this._addTag, "click", this._addColor);
            this._off(this._codeEditor, "mouseenter", this._inputEvent);
            this._off(this._codeEditor, "mouseleave", this._inputEvent);
            this._off(this._inputTag, "blur", this._inputEvent);
            this._off(this._inputTag, "focus", this._inputEvent);
            this._off(this._inputTag, "keyup", this._inputEvent);
            this._off(this.popupContainer, "focus", this._targetFocus);
            this._off(this.popupContainer, "blur", this._targetBlur);
        },
        _inputEvent: function (e) {
            if (e.type === "focus") {
                if (e.target.className.indexOf("e-color-code") > -1) {
                    this._codeEditor.addClass("e-focus");
                }
            }
            if (e.type === "blur") {
                if (e.target.className.indexOf("e-color-code") > -1) {
                    this._codeEditor.removeClass("e-focus");
                }
            }
            if (!this._clearIcon) return;
            if (e.type === "focus") this._off(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "blur") this._on(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "keyup") this._inputTag.val() !== "" ? (this._clearIcon.show(), this._handleArea.css("visibility", "visible")) : (this._clearIcon.hide(), this._handleArea.css("visibility", "hidden"));
            if (e.type === "mouseleave" || e.type === "blur" || this._inputTag.val() == "") this._clearIcon.hide();
            else this._clearIcon.show();
        },
        _clearColor: function (e) {
            this._tempValue = "";
            this._inputTag.val("");
            this._setEmptyValue();
            if (e.type == "click") {
                this._clearIcon.hide();
                this._inputTag.focus();
            }
        },
        _containerClick: function () {
            if (this.model.buttonMode == "split") this._trigger("select", { value: this.value() });
        },
        _popupShown: function (e) {
            if (e.keyCode == 13) {
                this._showHidePopup();
                if (!this.isPopupOpen)
                    this._buttonClick(e);
                return false;
            }
        },
        _recentColor: function (e) {
            this._divTag.find('.e-select').removeClass('e-select').addClass('e-block');
            var hexCode = e.target.attributes.getNamedItem("data-value"), value;
            var rgbCode = e.target.attributes.style;
            if (ej.isNullOrUndefined(hexCode) || ej.isNullOrUndefined(rgbCode)) { this._change = false; return false; }
            $(e.target.parentNode).addClass('e-select').removeClass('e-block');
            var alpha = rgbCode.value.replace(/^(background-color:rgb|background-color:rgba)\(/, '').replace(/\)$/, '').replace(/\s/g, '').split(',');
            if (!ej.isNullOrUndefined(alpha[3])) {
                this._opacity.option('value', parseInt((parseFloat(alpha[3]) * 100).toFixed(2)));
                this.rgb.a = parseFloat(parseFloat(alpha[3]).toFixed(2));
            }
            else if (this._browser.name = "msie" && this._browser.version == "8.0") {
                value = parseInt(rgbCode.nodeValue.replace(/^(FILTER: alpha)\(/, '').split('=')[1].split(')')[0]);
                this._opacity.option('value', value);
                this.rgb.a = value / 100;
            }
            else {
                this._opacity.option('value', 100);
                this.rgb.a = 1;
            }
            this._HexToHSV(hexCode.value);
            this._inputTagValue(this._selectedButton);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._valueOperation();
            this._colorSlider.option('value', parseInt(this._hsv.h));
            this._hueGradient();
            this._changeEvent(false);
            if (!this.model.displayInline || this.element.is("input"))
                this.wrapper.focus();
        },

        _handleClick: function (e) {
            e.preventDefault();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            if (this.model.displayInline)
                this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            this.mouseDownPos = this._handlePos;
            $(document).on("mousemove touchmove", $.proxy(this._handleMovement, this));
            $(document).on("mouseup touchend", $.proxy(this._handleUp, this));
        },
        _handleMove: function (e) {
            this._handleArea.css("visibility", "visible");
            this._handleMovement(e);
            this._focusWrapper(e);
        },
        _handleMovement: function (e) {
            if (!this.model.enabled) return false;
            var clientX = e.pageX, clientY = e.pageY;
            this.element.is("input") && this.wrapper.focus();
            if (e.type == "touchstart" || e.type == "touchmove") {
                clientX = e.originalEvent.changedTouches[0].pageX;
                clientY = e.originalEvent.changedTouches[0].pageY;
            }
            this._hsv.v = parseInt(100 * (this._gradientArea.height() - Math.max(0, Math.min(this._gradientArea.height(), (clientY - this._gradientArea.offset().top)))) / this._gradientArea.height(), 10);
            this._hsv.s = parseInt(100 * (Math.max(0, Math.min(this._gradientArea.width(), (clientX - this._gradientArea.offset().left)))) / this._gradientArea.width(), 10);
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._change = true;
            this._changeEvent(false);
        },
        _handleUp: function (e) {
            $(document).off('mouseup touchend', this._handleUp);
            $(document).off('mousemove touchmove', this._handleMovement);
            this._focusWrapper(e);
            return false;
        },
        _handlePosition: function () {
            this._handlePos = this._handleArea ? {
                left: parseInt(parseInt(this._width) * this._hsv.s / 100, 10) + "px",
                top: parseInt(parseInt(this._height) * (100 - this._hsv.v) / 100, 10) + "px"
            } : "";
            this._handleArea.css({ "left": this._handlePos.left, "top": this._handlePos.top });
        },
        _addColor: function () {
            var value, collection = this._divTag.find('> div');
            value = this._selectedButton.html() != "HSVA" ? this._inputTag.val() : this._formRGBA(this.HSVToRGB(this._hsv));
            if (value !== "" && this._change) {
                if (this.model.showRecentColors && collection.length <= 12) {
                    $($(collection)[collection.length - 2]).remove();
                    this._generateLi();
                }
            }
            if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
        },
        _buttonClick: function (e) {
            this._change = true;
            var value = this._inputTag.val(), collection = this._divTag.find('div');
            this._opacity.option('value', this._tempOpacity);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._updatePreviewColor();
            if (this._inputTag.val() === "") {
                this._tempValue = "";
                if (this.model.showClearButton) this._setValue("");
                else {
                    this._inputTag.addClass('e-error');
                    return false;
                }
            }
            this._selectEvent();
            if (this.element.is("input")) {
                this._updateValue();
                this.wrapper.focus();
            }
            !this.model.displayInline && this.hide();
            this._tempOpacity !== this.opacityValue() && this.opacityValue(this._tempOpacity);
        },
        _generateLi: function () {
            this._liTag = ej.buildTag('div.e-colorblock e-block e-colorset').attr({ "data-value": this.RGBToHEX(this.rgb), "tabindex": "0" });
            var spanTag = ej.buildTag('div.e-color e-set').attr({ "data-value": this.RGBToHEX(this.rgb), "title": this.RGBToHEX(this.rgb) });
            if (this._browser.name = "msie" && this._browser.version == "8.0") spanTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else spanTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._liTag.append(spanTag);
            this._divTag.prepend(this._liTag);
        },
        _colorCodeValue: function (e) {
            var newValue = "", codeValue = this._inputTag.val(), value, code, count;
            value = $.trim(codeValue);
            value.length == 5 ? this._inputTag.removeClass('e-error') : "";
            if ((e.shiftKey && e.keyCode >= 35 && e.keyCode <= 40 || (e.keyCode >= 65 && e.keyCode < 71) ) || (e.keyCode == 51) || (e.ctrlKey && (e.keyCode == 88 || e.keyCode == 86)) || e.keyCode == 190)
                this._keyPressFlag = 1;
            else if ((!e.crtlKey && !e.shiftKey) && ((e.keyCode >= 65 && e.keyCode < 71) || (e.keyCode >= 35 && e.keyCode <= 40) || (e.keyCode >= 96 && e.keyCode <= 105) || (e.keyCode >= 48 && e.keyCode <= 57) || e.keyCode == 13 || e.keyCode == 8 || e.keyCode == 46 || e.type === "blur"))
                this._keyPressFlag = 1;
            else this._keyPressFlag = 0;
            if (this.model.enableOpacity && (e.keyCode == 188 || e.keyCode == 71 || e.keyCode == 72 || e.keyCode == 82 || e.keyCode == 83 || e.keyCode == 86) || (e.shiftKey && (e.keyCode == 57 || e.keyCode == 48)))
                this._keyPressFlag = 1;
            if (this._keyPressFlag == 1) {
                this._inputTag.removeClass('e-error');
                if (e.keyCode === 13 || e.type === "blur") {
                    if (value === "") {
                        if (this.model.showClearButton) this._setEmptyValue();
                        else this._inputTag.addClass('e-error');
                    }
                    var regex = /^\#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/;
                    code = value.match(regex);
                    if (!ej.isNullOrUndefined(code)) {
                        if (code[1].length === 3) {
                            for (count = 0; count < code[1].length; count++) {
                                newValue += code[1][count] + code[1][count];
                            }
                        }
                        else if (code[1].length === 6)
                            newValue = code[1];
                        value = this.hexCodeToRGB("#" + newValue);
                        this._inputTag.val("#" + newValue);
                        this.rgb = this.HSVToRGB(this.RGBToHSV(value));
                        this._tempValue = this.RGBToHEX(this.rgb);
                        this._change = true;
                    }
                    else {
                        var rgbRegex = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                        code = value.match(rgbRegex);
                        if (!ej.isNullOrUndefined(code)) this._rgbaColor(code);
                        else {
                            var hsvRegex = /^hsva?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                            code = value.match(hsvRegex);
                            if (!ej.isNullOrUndefined(code)) {
                                this._hsvColor(code);
                            }
                            else {
                                value != "" && this._inputTag.addClass('e-error');
                                this._change = false;
                                return false;
                            }
                        }
                    }
                    if (this._change) {
                        this._valueOperation();
                        this._colorSlider.option('value', parseInt(this._hsv.h));
                        this._hueGradient();
                        this._changeEvent(false);
                        !this.element.is('input') && this._selectEvent();
                        if (this._inputTag.val() !== "") this._inputTag.removeClass("e-error");
                    }
                }
            }
            else {
                if (e.keyCode != 9) e.preventDefault();
                if (!e.shiftKey && !e.ctrlKey && e.keyCode !== 27 && e.keyCode !=20) this._inputTag.addClass('e-error');
            }
        },
        _setEmptyValue: function () {
            this._handleArea.css("visibility", "hidden");
            this._currentTag.css({ "background-color": "" });
            this._removeClass();
            this._tempValue = null;
            this._inputTag.val(null);
            if (this._previousValue !== this._tempValue) {
                this._trigger("change", { value: null });
                this._previousValue = this._tempValue
            }
        },
        _rgbaColor: function (code) {
            var rgb = {}, color;
            if (code[0].split('(')[0] == "rgba" && !ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = code[4];
            }
            else if (code[0].split('(')[0] == "rgb" && ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = this.rgb.a;
                this._inputTag.val("rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + rgb.a + ")");
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(rgb.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this._tempValue = this.RGBToHEX(rgb);
            this._HexToHSV(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _hsvColor: function (code) {
            var hsv = {};
            if (!ej.isNullOrUndefined(code[4])) {
                hsv.h = code[1]; hsv.s = code[2]; hsv.v = code[3]; hsv.a = code[4];
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(hsv.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this.rgb = this.HSVToRGB(hsv);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _iconClick: function (e) {
            e.preventDefault();
            this._showHidePopup();
            this.wrapper.focus();
        },
        _showHidePopup: function () {
            if (this.model.displayInline) return false;
            if (!this.isPopupOpen) this.show();
            else {
                this.hide();
                this.wrapper.focus();
            }
        },

        hide: function () {
            var proxy = this;
            if (!this.isPopupOpen||this.model.displayInline) return false;
            this.isPopupOpen = this._dataBind = false;
            if (this.element.is('input')) {
                this.wrapper.focus();
                this.wrapper.removeClass("e-active");
            }
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            this.popupContainer.slideUp(200, function () {
                if (proxy.model) {
                    proxy._tempOpacity = proxy.opacityValue();
                    proxy.rgb.a = proxy._tempOpacity / 100;
                    proxy._tempValue = proxy.value();
                    proxy._renderModelValue(proxy.value());
                    proxy._opacity.option('value', parseInt(proxy.opacityValue()));
                    if (!proxy.model.displayInline)
                        proxy._off($(document), "mousedown", proxy._onDocumentClick);
                    proxy._trigger("close");
                }
            });
            if (!this.model.displayInline)
                this._off($(document), "mousedown", this._onDocumentClick);
            this._off(this._inputTag, "keydown", this._colorCodeValue);
            this._off(this._inputTag, "blur", this._colorCodeValue);
            this._modelType == "palette" ? this._off($(document), "keydown", this._keyDown) : this._off($(document), "keydown", this._onKeyDown);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
        },
        _hidePopup: function () {
            !this.model.displayInline && this.hide();
        },

        show: function () {
            if (this.element.is("input")) {
                this.wrapper.focus();
                this.wrapper.addClass("e-active");
            }
            if (this.isPopupOpen || !this.model.enabled) return false;
            this.isPopupOpen = true;
            if (this.model.modelType == "palette") this._cellSelect();
            if (!this.model.displayInline && (this.value() === "" || ej.isNullOrUndefined(this.value())))
                this._setEmptyValue();
            else
                this._handleArea.css("visibility", "visible");
            this._previousColor = this._previousValue = this.value();
            this.popupContainer.children().find('.e-focus').removeClass('e-focus');
            if (!this.model.displayInline) this._setPopupPosition();
            var proxy = this;
            this.popupContainer.slideDown(200, function () {
                proxy.isFocused = true;
                proxy._on($(document), "mousedown", proxy._onDocumentClick);
                proxy._trigger("open");
            });
            if (!this._dataBind)
                this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
            this._on(this._inputTag, "keydown", this._colorCodeValue);
            this._on(this._inputTag, "blur", this._colorCodeValue);
            this._dataBind = true;
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline) this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            if (this._prevSize !== $(window).width()) this.refresh();
        },
        _showBindEvents: function () {
            this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
        },
        _hideUnBindEvents: function () {
            this._modelType == "palette" ? this._off($(document), "keydown", this._onKeyDown) : this._off($(document), "keydown", this._keyDown);
        },
        _switchEvents: function () {
            if (this._switch) {
                this._on(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._on(this._handleArea, "mousedown touchstart", this._handleClick);
                this._on(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._on(this._collection, "mousedown", this._onSelect);
        },
        _unSwitchEvents: function () {
            if (!this._switch) {
                this._off(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._off(this._handleArea, "mousedown touchstart", this._handleClick);
                this._off(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._off(this._collection, "mousedown", this._onSelect);
        },
        _groupButton: function (e) {
            if ($(e.target).hasClass('e-disable')) return false;
            if ($(e.target).hasClass("e-button")) {
                var element = this._groupTag.find('.e-btn.e-select');
                if (this._inputTag.val() !== "") this._inputTagValue($(e.target));
                else this._selectedButton = $(e.target);
                this._selectedButton.html() !== "HEX" ? this._inputTag.attr('maxLength', '22') : this._inputTag.attr('maxLength', '7');
                this._groupTag.find('.e-click').removeClass('e-click');
                $(e.target).addClass('e-click');
                this._inputTag.removeClass('e-error');
            }
        },
        _inputTagValue: function (type) {
            if (type.html() == "RGBA") this._inputTag.val(this._formRGBA(this.rgb));
            else if (type.html() == "HEX") this._inputTag.val(this.RGBToHEX(this.rgb));
            else if (type.html() == "HSVA") {
                if (this._modelType != "palette")
                    this._inputTag.val("hsva(" + Math.round(this._hsv.h) + "," + Math.round(this._hsv.s) + "," + Math.round(this._hsv.v) + "," + this.rgb.a + ")");
            }
            this._selectedButton = type;
        },
        _bindRecentEvent: function () {
            this._on(this._divTag, "click", this._recentColor);
        },
        _unBindRecentEvent: function () {
            this._off(this._divTag, "click", this._recentColor);
        },
        _handlePlacement: function (prop, value, bool) {
            this._handleArea.css("visibility", "visible");
            var hsv = this._hsv;
            hsv[prop] += value * (bool ? 1 : 3);
            if (hsv[prop] < 0) { hsv[prop] = 0; }
            prop === "s" ? this._hsv.s = hsv[prop] : this._hsv.v = hsv[prop];
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._changeEvent(false);
        },
        _onKeyDown: function (e) {
            var key = e.keyCode;
            if (!this.model.enabled) return;
            if (e.shiftKey && key == 9) if ($(this._hueSlider).find('.e-handle').hasClass('e-focus')) this._focusWrapper(e);
            if (!this._isFocused) if (key == 9 && key !== 27) return;
            this._change = true;
            if ((!e.altKey && !e.shiftKey)) {
                switch (key) {
                    case 39:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", 1, e.ctrlKey);
                        }
                        break;
                    case 38:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", 1, e.ctrlKey);
                        }
                        break;
                    case 37:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", -1, e.ctrlKey);
                        }
                        break;
                    case 40:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", -1, e.ctrlKey);
                        }
                        break;
                    case 13:
                        e.preventDefault();
                        if ($(e.target).hasClass('e-switcher')) {
                            this._switchModel();
                            $(e.target).focus();
                        }
                        else if ($(e.target).hasClass('e-applyButton')) this._buttonClick(e);
                        break;
                    case 27:
                        e.preventDefault();
                        !this.model.displayInline && this.hide();
                        this._tempValue = this.value();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPopup(e);
                        break;
                }
            }
        },
        _focusPopup: function (e) {
            $(this._hueSlider).find('.e-handle').focus();
            e.preventDefault();
        },
        _focusWrapper: function (e) {
            this.element.is('input') && $(this.wrapper).focus();
            e.preventDefault();
        },
        _onDocumentClick: function (e) {
            if (!$(e.target).is(this.popupContainer) && !$(e.target).parents(".e-colorpicker").is(this.popupContainer) &&
              !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-colorpickerwidget").is(this.wrapper) && !$(e.target).parents('.e-presetWrapper').is("#" + this._id + "_Presets")) {
                if (!this.model.displayInline) {
                    this.hide();
                    if (this.element.is('input')) this.wrapper.removeClass('e-focus');
                }
                this._isFocused = false;
            }
        },

        _OnWindowResize: function (e) {
            if (this.element.is('input')) this._setPopupPosition();
            this.refresh();
        },
        refresh: function () {
            var element = $(this._PresetTable.find('.e-item')[1]);
            var count = 10, paddingSize = 36; //paddingSize is fixed for  palette model cells
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "block", "visibility": "hidden" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            }
            if (parseFloat(this._tag.outerHeight()) > element.outerHeight(true) || (($(this._tag).outerWidth() - ($(element).outerWidth(true) * count)) > element.outerWidth()) || $(this._tag).outerWidth() == 0) {
                var rowSize = parseFloat($(this._tag).outerWidth()) - paddingSize;
                var cellWidth = (rowSize / count) - (element.outerWidth() - element.width());
                this._PresetTable.find('.e-item').css('width', cellWidth);
                if (element.outerWidth(true) * count > this._tag.outerWidth()) this._PresetTable.find('.e-item').css('width', cellWidth - 1);
            }
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "none", "visibility": "visible" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "visibility": "visible" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "none", "visibility": "visible" });
            }
            this._prevSize = $(window).width();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },

        _range: function (range, value) {
            if (value === "") return value = 0;
            else if (value > range) return range;
            else return value;
        },
        _hsvValue: function () {
            var colorCode, hsv;
            this._change = true;
            this._hsv.v = this._hsv.v >= 100 ? 100 : this._hsv.v;
            this._hsv.s = this._hsv.s >= 100 ? 100 : this._hsv.s;
            this.hsv = this._hsv;
            this.rgb = this.HSVToRGB(this.hsv);
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _formRGB: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgb(" + value.r + "," + value.g + "," + value.b + ")";
        },
        _formRGBA: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgba(" + value.r + "," + value.g + "," + value.b + "," + value.a + ")";
        },
        _rgbValue: function (e) {
            var rgbColor, colorCode, value;
            value = this._HexToRGB(this._tempValue);
            if (!ej.isNullOrUndefined(value)) {
                this.rgb = value;
                this._change = true;
                this.HSVToRGB(this.RGBToHSV(this.rgb));
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this.rgb.a * 100);
            }
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _valueOperation: function () {
            this._handlePosition();
            this._alphaGradient(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._updateUI();
        },
        _HexToHSV: function (hex) {
            return this.HSVToRGB(this.RGBToHSV(this._HexToRGB(hex)));
        },
        _HexToRGB: function (hex) {
            if (!ej.isNullOrUndefined(hex)) {
                var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$", hex, validate = hex.match(reg);
                if (ej.isNullOrUndefined(validate)) { this._change = false; return false; }
                if (validate[1].length == 3)
                    hex = "#" + validate[1][0] + validate[1][0] + validate[1][1] + validate[1][1] + validate[1][2] + validate[1][2];
                this._change = true;
                hex = parseInt(((hex.indexOf('#') > -1) ? hex.substring(1) : hex), 16);
                var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
                return this.rgb = { r: hex >> 16, g: (hex & 0x00FF00) >> 8, b: (hex & 0x0000FF), a: value };
            }
        },

        RGBToHSV: function (rgb) {
            var hsv = { h: 0, s: 0, v: 0 };
            var min = Math.min(rgb.r, rgb.g, rgb.b);
            var max = Math.max(rgb.r, rgb.g, rgb.b);
            var differ = max - min;
            hsv.v = max;
            hsv.v *= 100 / 255;
            if (differ === 0) {
                this._hsv = hsv;
                return hsv;
            }
            hsv.s = max != 0 ? 255 * differ / max : 0;
            if (hsv.s != 0) {
                if (rgb.r == max) hsv.h = (rgb.g - rgb.b) / differ;
                else if (rgb.g == max) hsv.h = 2 + (rgb.b - rgb.r) / differ;
                else hsv.h = 4 + (rgb.r - rgb.g) / differ;
            } else hsv.h = -1;
            hsv.h *= 60;
            if (hsv.h < 0) hsv.h += 360;
            hsv.s *= 100 / 255;
            this._hsv = hsv;
            return hsv;
        },

        HSVToRGB: function (hsv) {
            var rgb = {};
            var h = Math.round(hsv.h);
            var s = Math.round(hsv.s * 255 / 100);
            var v = Math.round(hsv.v * 255 / 100);
            if (s == 0) {
                rgb.r = rgb.g = rgb.b = v;
            } else {
                var t1 = v;
                var t2 = (255 - s) * v / 255;
                var t3 = (t1 - t2) * (h % 60) / 60;
                if (h == 360) h = 0;
                if (h < 60) { rgb.r = t1; rgb.b = t2; rgb.g = t2 + t3 }
                else if (h < 120) { rgb.g = t1; rgb.b = t2; rgb.r = t1 - t3 }
                else if (h < 180) { rgb.g = t1; rgb.r = t2; rgb.b = t2 + t3 }
                else if (h < 240) { rgb.b = t1; rgb.r = t2; rgb.g = t1 - t3 }
                else if (h < 300) { rgb.b = t1; rgb.g = t2; rgb.r = t2 + t3 }
                else if (h < 360) { rgb.r = t1; rgb.g = t2; rgb.b = t1 - t3 }
                else { rgb.r = 0; rgb.g = 0; rgb.b = 0 }
            }
            this._hsv = hsv;
            var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
            return { r: Math.round(rgb.r), g: Math.round(rgb.g), b: Math.round(rgb.b), a: value }
        },
        _HSVToHex: function (hsv) {
            return this.RGBToHEX(this.HSVToRGB(hsv));
        },
        _toHEX: function (rgb) {
            if (rgb.indexOf("#") !== -1) return rgb;
            rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
            return "#" + this._hex(rgb[1]) + this._hex(rgb[2]) + this._hex(rgb[3]);
        },



        RGBToHEX: function (rgb) {
            if (!ej.isNullOrUndefined(rgb))
                return "#" + this._hex(rgb.r) + this._hex(rgb.g) + this._hex(rgb.b);
        },
        _hex: function (x) {
            return ("0" + parseInt(x).toString(16)).slice(-2);
        },
        _colorValue: function (value) {
            this._color = value.indexOf("#") != -1 ? this.hexCodeToRGB(value) : "";
            return "rgb(" + this._color.r + ", " + this._color.g + ", " + this._color.b + ")";
        },


        hexCodeToRGB: function (colorCode) {
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(colorCode);
            return result ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16),
                a: this.rgb.a
            } : null;
        },

        _updatePreviewColor: function () {
            if (this._browser.name = "msie" && this._browser.version == "8.0")
                this._previousTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else
                this._previousTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._oldValue = this.rgb;
        },
        _updateUI: function () {
            var value = this._hsv;
            if (this._switch) {
                var hsv = { h: this._hsv.h, s: 100, v: 100 };
                this._gradientArea.css({ "background-color": this._colorValue(this._HSVToHex(hsv)) });
            } else this._cellSelect();
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._previousTag.css({ "background-color": this._formRGB(this._oldValue), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css({ "background-color": this._formRGBA(this.rgb) });
                this._previousTag.css({ "background-color": this._formRGBA(this._oldValue) });
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._hsv = value;
        },

        _targetFocus: function (e) {
            e.preventDefault();
            if (!this._isFocused) {
                this._isFocused = true;
                if (this.element.is("input")) this.wrapper.addClass("e-focus");
            }
        },
        _targetBlur: function (e) {
            this._isFocused = false;
            if (!this.isPopupOpen && this.element.is("input")) this.wrapper.removeClass("e-focus");
        },
        _switchModel: function () {
            this._tempValue = this.RGBToHEX(this.rgb);
            this.refresh();
            var proxy = this;
            this._off(this._changeTag, "click", this._switchModel);
            if (this._modelType == "palette") {
                this._modelType = "picker";
                this._switcher.removeClass("e-pickerModel").addClass("e-paletteModel");
                this.PaletteWrapper.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                    proxy._gradient.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                this._switch = true;
                this._rgbValue();
                this._hueGradient();
                this._hsva.ejButton("enable");
            } else {
                this.PaletteWrapper.remove();
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.removeClass("e-paletteModel").addClass("e-pickerModel");
                this._gradient.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                    if (ej.isNullOrUndefined(proxy.PaletteWrapper)) {
                        proxy.PaletteWrapper = proxy._layoutType(proxy.model.palette);
                        proxy._splitObj.option('prefixIcon', 'e-color-image e-' + proxy.model.presetType);
                        proxy.popupList.prepend(proxy.PaletteWrapper);
                    }
                    proxy.PaletteWrapper.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                if (this.value() !== "")
                    this._cellSelect();
                this._disableHSVButton();
            }
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            if (!this.model.displayInline || this.element.is(":input")) this.wrapper.focus();
            this._switchEvents();
            this._unSwitchEvents();
            if (this.isPopupOpen) {
                this._hideUnBindEvents();
                this._showBindEvents();
            }
        },
        _disableHSVButton: function () {
            if ($(this._groupTag.find('.e-click')).hasClass('e-hsvButton')) {
                this._inputTagValue(this._rgb);
                this._rgb.addClass('e-click');
                this._hsva.removeClass('e-click');
            }
            this._hsva.ejButton("disable");
        },

        _cellSelect: function () {
            var code, element, proxy = this;
            this._removeClass();
            this._collection.find('.e-item').each(function () {
                code = $(this).css("background-color");
                if (proxy._browser.name = "msie" && proxy._browser.version == "8.0") {
                    if (code && code.replace(/ /g, '') === proxy.RGBToHEX(proxy.rgb)) {
                        element = this;
                        $(element).addClass("e-filter");
                    }
                } else {
                    if (code && code.replace(/ /g, '') === proxy._formRGB(proxy.rgb)) element = this;
                }
            });
            $(element).addClass("e-state-selected").attr("aria-selected", true);
        },
        _removeClass: function () {
            this._collection.find('.e-item').removeClass('e-state-selected').removeClass("e-filter").removeAttr("aria-selected");
        },
        _position: function (items, element, columns) {
            items = Array.prototype.slice.call(items);
            var n = items.length,
            index = items.indexOf(element);
            if (index < 0) return columns < 0 ? items[n - 1] : items[0];
            index += columns;
            return items[index < 0 ? index += n : index %= n];
        },
        _onSelect: function (e) {
            if (!this.model.enabled) return false;
            this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            if (e.target.style.backgroundColor != "") {
                this._collection.find('.e-item').removeClass("e-state-selected").removeAttr('aria-selected');
                this._HexToRGB(this._toHEX(e.target.style.backgroundColor));
                this._updateUI();
                this._inputTagValue(this._selectedButton);
                if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(false);
            }
            e.preventDefault();
        },
        _keyDown: function (e) {
            if (this._isFocused) {
                this._change = true;
                if (!this.model.enabled) return false;
                var selected = "",
                    key = e.keyCode,
                    items = this._collection.find('.e-item'),
                    element = items.filter(".e-state-selected").get(0),
                    columnSize = this.model.columns;
                if (!e.altKey && (key == 37 || key == 38 || key == 39 || key == 40) && (e.target.className !== "e-color-code"))
                    this._removeClass();
                switch (!e.altKey && key) {
                    case 40:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, columnSize);
                        }
                        break;
                    case 37:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -1);
                        }
                        break;
                    case 38:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -columnSize);
                        }
                        break;
                    case 39:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, 1);
                        }
                        break;
                    case 13:
                        this._collection.find('.e-item').removeClass('e-state-selected').removeAttr("aria-selected");
                        if ($(e.target).hasClass('e-switcher')){
                            this._switchModel();
                            $(e.target).focus();
                        } 
                        else if ($(e.target).hasClass('e-applyButton')) {
                            this._buttonClick(e);
                            this._updateUI();
                            !this.model.displayInline && this.hide();
                            if (this.element.is("input")) this.wrapper.focus();
                        }
                        break;
                    case 27:
                        !this.model.displayInline && this.hide();
                        $(this._presetContainer).hide();
                        if (this.element.is("input")) this.wrapper.focus();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPalettePopup(e, true);
                        break;
                }
                if (selected) {
                    $(selected).addClass('e-state-selected').attr("aria-selected", true);
                    this._currentTag.css({ "background-color": this._formRGB(this._HexToRGB($(selected).attr("data-value")))});
                    this._inputTagValue(this._selectedButton);
                    this._tempValue = this.RGBToHEX(this.rgb);
                    this._changeEvent(false);
                }
            } else {
                if (e.keyCode == 27) {
                    this.hide();
                    $(this._presetContainer).hide();
                }
            }
        },
        _focusPalettePopup: function (e, type) {
            $(this.popupContainer).focus();
            e.preventDefault();
        },
    })

    ej.ColorPicker.Locale = ej.ColorPicker.Locale || {};

    ej.ColorPicker.Locale["default"] = ej.ColorPicker.Locale["en-US"] = {
        buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            }
    }
    ej.ColorPicker.Palette = {
        /**  Represents the basic Palette. This is default Type*/
        BasicPalette: "basicpalette",
        /**  Represents the custom Palette. User will customize the palette*/
        CustomPalette: "custompalette",
    }

    ej.ColorPicker.ModelType = {
        /**  Represents Palette Type*/
        Palette: "palette",
        /** Represents Picker Type */
        Picker: "picker"
    }

    ej.ColorPicker.ButtonMode = {
        /**  Represents the default bahavior*/
        Default: "dropdown",
        /**  Represents the Split bahavior, to perform the separete operation for each button*/
        Split: "split",
    }

    ej.ColorPicker.PresetType = {
        Basic: "basic",
        MonoChrome: "monochrome",
        FlatColors: "flatcolors",
        SeaWolf: "seawolf",
        WebColors: "webcolors",
        Sandy: "sandy",
        PinkShades: "pinkshades",
        Misty: "misty",
        Citrus: "citrus",
        Vintage: "vintage",
        MoonLight: "moonlight",
        CandyCrush: "candycrush",
    }
    var Colors = {
        basic: ["ffffff", "facbcb", "fccb98", "faf39a", "fbf8cd", "a6d38b", "aadee8", "d1ecf2", "cdcae5", "eecde1", "cccbcb", "f16667", "f69668", "f8ee6b", "f7ec37", "89c987", "75cddd", "8bd3e1", "7f7fcc", "9494c8", "b3b2b3", "ec2024", "f7971d", "ffcb67", "f5ea14", "74bf44", "69c8c9", "46c7f4", "6666ad", "b76cab", "676767", "971b1e", "ca6828", "ca9732", "979937", "0d9948", "339898", "4857a6", "62449a", "973794", "000000", "2f1110", "973620", "663433", "343416", "183319", "023334", "22205f", "3b2f8d", "310e31"],
        monochrome: ["ffffff", "e3e3e3", "c6c6c6", "aaaaaa", "8e8e8e", "717171", "555555", "393939", "1c1c1c", "000000", "f9e6e7", "f4d0d2", "efbabc", "e9a4a7", "e48e92", "df787c", "da6267", "d44c52", "cf363c", "ca2027", "fff4ca", "ffeb9e", "fff0b4", "ffefb1", "ffe788", "ffe272", "ffd947", "ffd531", "ffd01b", "ffcc05", "e4f4eb", "ccead9", "b4e0c7", "9cd6b5", "84cca3", "6dc190", "55b77e", "3dad6c", "25a35a", "0d9948", "e8f4f4", "d6e3eb", "c4d1e3", "b3c0da", "a1aed1", "8f9dc9", "7d8bc0", "6c7ab7", "5a68af", "4857a6"],
        flatcolors: ["7477b8", "488bca", "18b1d4", "1db369", "78c162", "acc063", "ffe84e", "f6b757", "f79853", "ed6346", "E87F3D", "E4C45D", "B7A575", "999999", "67809F", "002228", "00A578", "F9A41F", "F3770B", "D7401B", "FFCB36", "82CC2C", "36B595", "6370AD", "D4264E", "004D8E", "22A04B", "F3A414", "C77405", "F3420B", "1ABC9C", "3498DB", "9B59B6", "E67E22", "E74C3C", "3A738A", "EBD9A7", "89AD78", "FF766D", "C76160", "BF3542", "CDC5BA", "EBE3D6", "3C3C3C", "2E2E2E", "77A7FB", "E57368", "FBCB43", "34B67A", "FFFFFF"],
        seawolf: ["0EEAFF", "15A9FA", "1B76FF", "1C3FFD", "2C1DFF", "0B3C4C", "0E5066", "13647F", "127899", "1A8BB2", "74B8E8", "659EBB", "3C9FFF", "26466F", "2472FF", "0069A4", "009BF2", "004165", "49A0B4", "274C5F", "000000", "7A5848", "E0A088", "F9DEC6", "3A2A22", "DC3522", "D9CB9E", "374140", "2A2C2B", "1E1E20", "CB3937", "FE6B2C", "654E44", "6DD16F", "70FE2C", "275673", "4681A6", "FDDEC9", "F22816", "400101", "071C2F", "388494", "E6A934", "F3DB5F", "534329", "206956", "47683B", "E1BFA6", "BF7950", "903932"],
        webcolors: ["0066aa", "00bbdd", "338800", "77bb00", "ffcc99", "990c0c", "0303c9", "336699", "669933", "cccccc", "EEEEEE", "E7C36F", "F7B230", "E35B20", "000033", "7D7A74", "BD524A", "FCB200", "8CFCC2", "2ACD6B", "666666", "666553", "FFFEEC", "B2B2A4", "AAA4B2", "9CA5E3", "5A668C", "BBA469", "CFC295", "FFFFFF", "DBBF56", "2E94B3", "808080", "E96656", "14A168", "DE185B", "D8806F", "DBE186", "D8CC63", "DCC527", "4E6C89", "E2BDAD", "EC6053", "81BBAD", "DFCDA5", "453394", "66398A", "313E7D", "336694", "788E91"],
        sandy: ["c0a986", "ecd9c3", "dfc79b", "f6d58e", "ecdaad", "fff3e0", "7f6b4a", "ffd694", "7f7a70", "ccac76", "E6E2AF", "A79A71", "EFECCA", "806F4C", "2F2F2E", "997F1A", "CCB65F", "FFD291", "6B674A", "635F3A", "7F693A", "FFEBC1", "FFD275", "7F7561", "CCA85E", "D29854", "4A4034", "C9AD8D", "4A351D", "968169", "E6E39F", "9A9757", "FFFDC9", "94909A", "E2E0E6", "960010", "EB1517", "CD7C29", "9A571C", "1F7A94", "7F6826", "7F724C", "FFE499", "FFD04C", "CCA63D", "FFA669", "92FFB6", "FFF352", "E8C269", "D7E8CB"],
        pinkshades: ["F6B1C3", "F0788C", "DE264C", "BC0D35", "A20D1E", "E12256", "BB1C48", "7B132F", "3B0917", "FA2660", "FFB7B5", "9A423F", "FF6D68", "BB5855", "CC5753", "E88161", "D66C60", "C2646E", "996072", "705262", "FFA1BD", "FF8FB7", "FF82AE", "E9719B", "CC6882", "F250C7", "BF1774", "BF2696", "AC60AA", "BB90C5", "BF1553", "F20775", "F2F2F2", "e5566d", "f2afc1", "f43fa5", "fc8c99", "FF6887", "7F3443", "CC536C", "D06AA9", "E65F41", "650017", "BC1620", "FA427E", "3B1132", "84476E", "B83D65", "E6E0E8", "FF6EE8"],
        misty: ["5C7A84", "3D5372", "7C9196", "50748A", "ADBFBF", "010735", "052159", "194073", "376B8C", "FFFFFF", "985999", "C811CC", "892EFF", "FF6852", "DBA211", "0A0D0C", "85A67C", "46593E", "BBD9AD", "202616", "BF8E63", "734327", "A66C4B", "593A2F", "BFBFBF", "8DB0B6", "1B778A", "F46C1B", "881801", "192129", "81808C", "ABAABF", "0C0E09", "6A7366", "37402F", "5D6663", "84867B", "A4A66A", "BABBB1", "20211C", "6B9695", "646E8C", "6B8196", "61787F", "648C80", "8E9FBA", "89A8C8", "799ED1", "7FAEE7", "849EBD"],
        citrus: ["FAEA41", "E7F03E", "E3C647", "FAC541", "F0AB3E", "CCCA1F", "FFF300", "FFCB0D", "FF9500", "804A00", "6A692A", "FFFCA0", "FFFFFF", "CF664E", "EFAC66", "EFF299", "F2DC6D", "F29727", "F2600C", "592202", "214001", "4F7302", "1A2601", "BCD97E", "C0D904", "AAFEFF", "359D6D", "E5FF45", "65FCCF", "ABDC4B", "42B200", "C6FF00", "F2E304", "FFB200", "FF8600", "52EC04", "04E206", "94D507", "ECE404", "E2C904", "DA321C", "FF7913", "FBD028", "C0D725", "9FC131", "547312", "ADBF26", "DEB329", "F1DB47", "E08214"],
        vintage: ["684132", "fdbe30", "eaac21", "87783c", "3e4028", "ffc706", "cd5648", "5bafa9", "828282", "363636", "424862", "fb9a63", "bfc4d5", "f6fbf4", "febc98", "657050", "FCF082", "D8D98B", "A2AB80", "4D584A", "5ADED4", "4DAAAB", "26596A", "163342", "6C98A1", "010A26", "28403B", "557359", "AEBF8A", "C7D9AD", "AFFCCB", "CB4243", "D2997E", "36857E", "4AC6BB", "28394B", "191313", "AF0A18", "DC373D", "122438", "43734A", "A6A26D", "D9B448", "BF8C2C", "734002", "26010F", "866F53", "ACBD91", "7BAB87", "546859"],
        moonlight: ["241D37", "2A233D", "322B45", "362F49", "D4BA73", "261225", "592040", "8C3063", "A64985", "73345D", "A3C8FF", "85B6FF", "000040", "213190", "050859", "FFFFFF", "6AAED9", "4184BF", "224573", "2e4154", "bcad7e", "955351", "c36a57", "9a8556", "7e6029", "dbd78e", "beae3b", "c3a04c", "58504d", "967644", "CFC496", "B3B391", "889486", "61797B", "366577", "123340", "436E73", "7B8C61", "D7D996", "F0EBB4", "341F36", "D9B5E0", "9889AB", "4D4E66", "1B2129", "5CBBE3", "FCF1BC", "5C8182", "383A47", "B4F257"],
        candycrush: ["0779f4", "30da00", "fb8006", "f9d802", "a71df7", "f70200", "fd49ae", "682e07", "9b2424", "5e7693", "F9AB3B", "EF5627", "FF0000", "00A398", "803C2C", "DE5711", "FFF026", "FF0048", "14A0CC", "00B229", "FFFFBE", "F7CD99", "FF77A1", "9886E8", "97CACB", "EAEDE5", "FFD127", "FF870C", "EC4610", "9A1900", "993460", "CC1464", "C300FF", "FFFFBC", "CCB914", "FFFEE2", "B24C5F", "FF274F", "0A94CC", "679DB2", "C2FFE6", "16B271", "5FFFBC", "B2442F", "FFA190", "E89359", "FFFB75", "F36EFF", "5999E8", "73EB86"],
    }

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejFileExplorer", "ej.FileExplorer", {

        element: null,

        model: null,
        validTags: ["div"],
        _addToPersist: ["layout", "selectedFolder", "selectedItems", "height", "width"],
        _rootCSS: "e-fileexplorer",
        _requiresID: true,
        defaults: {

            fileTypes: "*.*",

            filterSettings: {

                caseSensitiveSearch: false,

                filterType: "contains",

                allowSearchOnTyping : true

            },

            showToolbar: true,

            showCheckbox: true,

            showNavigationPane: true,

            allowDragAndDrop: true,

            showContextMenu: true,

            showFooter: true,

            layout: "grid",

            locale: "en-US",

            selectedFolder: "",

            selectedItems: "",

            gridSettings: {
                allowSorting: true,
                columns: [
                    { field: "name", headerText: "Name", width: "30%" },
                    { field: "dateModified", headerText: "Date Modified", width: "30%" },
                    { field: "type", headerText: "Type", width: "15%" },
                    { field: "size", headerText: "Size", width: "12%", textAlign: "right", headerTextAlign: "left" }],
                allowResizing:true
            },

            tools: {
                creation: ["NewFolder"],
                navigation: ["Back", "Forward", "Upward"],
                addressBar: ["Addressbar"],
                editing: ["Refresh", "Upload", "Delete", "Rename", "Download"],
                copyPaste: ["Cut", "Copy", "Paste"],
                getProperties: ["Details"],
                searchBar: ["Searchbar"],
                layout: ["Layout"],
                sortBy: ["SortBy"]
            },

            toolsList: ["layout", "creation", "navigation", "addressBar", "editing", "copyPaste", "sortBy", "getProperties", "searchBar"],

            path: "",

            rootFolderName: "",

            height: "400px",

            width: "850px",

            minWidth: "400px",

            maxWidth: null,

            minHeight: "250px",

            maxHeight: null,

            isResponsive: false,

            uploadSettings: {

                allowMultipleFile: true,

                maxFileSize: 31457280,

                autoUpload: false

            },

            enableResize: false,

            cssClass: "",

            enableRTL: false,

            allowKeyboardNavigation: true,

            showThumbnail: true,

            enableThumbnailCompress: false,

            showRoundedCorner: false,

            ajaxAction: "",

            ajaxDataType: "json",

            ajaxSettings: {
                read: {},
                createFolder: {},
                remove: {},
                rename: {},
                paste: {},
                getDetails: {},
                download: {},
                upload: {},
                getImage: {},
                search:{}
            },

            allowMultiSelection: true,

            contextMenuSettings: {
                items: {
                    navbar: ["NewFolder", "Upload", "|", "Delete", "Rename", "|", "Cut", "Copy", "Paste", "|", "Getinfo"],
                    cwd: ["Refresh", "Paste", "|", "SortBy", "|", "NewFolder", "Upload", "|", "Getinfo"],
                    files: ["Open", "Download", "|", "Upload", "|", "Delete", "Rename", "|", "Cut", "Copy", "Paste", "|", "OpenFolderLocation", "Getinfo"]
                },
                customMenuFields: []
            },

            enablePersistence: false,

            layoutChange: null,

            getImage: null,

            select: null,

            unselect: null,

            createFolder: null,

            remove: null,

            cut: null,

            copy: null,

            paste: null,

            open: null,

            beforeOpen: null,

            beforeUploadDialogOpen: null,

            beforeUpload: null,

            beforeDownload: null,

            beforeGetImage: null,

            beforeAjaxRequest: null,

            resizeStart: null,

            resize: null,

            resizeStop: null,

            templateRefresh: null,

            dragStart: null,

            drag: null,

            dragStop: null,

            drop: null,

            menuClick: null,

            menuBeforeOpen: null,

            menuOpen: null,

            create: null,

            destroy: null

        },
        dataTypes: {
            filterSettings: "data",
            showToolbar: "boolean",
            showNavigationPane: "boolean",
            showContextMenu: "boolean",
            allowDragAndDrop: "boolean",
            allowKeyboardNavigation: "boolean",
            showRoundedCorner: "boolean",
            showFooter: "boolean",
            layout: "enum",
            gridSettings: "data",
            tools: {
                creation: "array",
                navigation: "array",
                addressBar: "array",
                editing: "array",
                layout: "array",
                copyPaste: "array",
                getProperties: "array",
                searchBar: "array"
            },
            contextMenuSettings: {
                items: {
                    navbar: "array",
                    cwd: "array",
                    files: "array"
                },
                customMenuFields: "array"
            },
            toolsList: "array",
            uploadSettings: "data",
            ajaxSettings: "data",
        },
        _setModel: function (options) {
            var proxy = this;
            for (var prop in options) {
                switch (prop) {
                    case "showToolbar":
                        options[prop] ? ej.isNullOrUndefined(this._toolBarItems) ? this._updateToolbar() : this._toolBarItems.show() : this._toolBarItems.hide();
                        this.adjustSize();
                        break;
                    case "showNavigationPane":
                    case "showTreeview":
                        this.model.showNavigationPane = this.model.showTreeview = options[prop];
                        this._showHideSplitBar(this.model.showNavigationPane);
                        break;
                    case "showContextMenu":
                        this._showHideContextMenu();
                        break;
                    case "height":
                        this.element.css("height", this._getProperValue(this.model.height));
                        this.adjustSize();
                        break;
                    case "width":
                        this.element.css("width", this._getProperValue(this.model.width));
                        this.adjustSize();
                        break;
                    case "layout":
                        this._switchLayoutView(true);
                        break;
                    case "allowDragAndDrop":
                        this.model.allowDragAndDrop = options[prop];
                        this._draggableOption(options[prop] ? "_on" : "_off");
                        options[prop] ? this._allowDrag() : this._preventDrag();
                        break;
                    case "showThumbnail":
                        this.model.showThumbnail = options[prop];
                        this._switchLayoutView();
                        break;
                    case "enableThumbnailCompress":
                        this.model.enableThumbnailCompress = options[prop];
                        this.model.showThumbnail && this.model.layout != "grid" && this._renderTileView(this._fileExplorer[this._originalPath]);
                        break;
                    case "path":
                        options[prop] ? this._setPath(options[prop]) : this._getPath();
                        break;
                    case "enableRTL": this._enableRTL(options[prop]); break;
                    case "allowKeyboardNavigation":
                        this._subControlsSetModel("allowKeyboardNavigation", options[prop]);
                        this._gridObj && this._gridObj.setModel({ "allowKeyboardNavigation": options[prop] });
                        break;
                    case "showFooter":
                        if (options[prop]) {
                            if (this._statusbar.hasClass("e-statusbar")) {
                                var setHeight = this._splittag.find(".e-cont2").outerHeight() - this._statusbar.outerHeight();
                                this._tileView.height(setHeight);
                                this._gridtag.height(setHeight);
                                this._statusbar.show();
                            }
                            else {
                                this._createStatusBar();
                                this._updateData();
                                if (this.model.enableResize)
                                    this._resizeFileExplorer();
                                this._on($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
                                this._on($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
                            }
                            var height = this._splittag.height() - this._gridtag.find(".e-gridheader").outerHeight();
                            this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: this._splittag.outerHeight() - this._statusbar.outerHeight(), scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } });
                        } else {
                            this._tileView.height("auto");
                            this._gridtag.height("auto");
                            this._statusbar.hide();
                            var height = this._splittag.height() - this._gridtag.find(".e-gridheader").outerHeight();
                            this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: this._splittag.outerHeight(), scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } });
                        }
                        break;
                    case "gridSettings":
                        var gridSettings = JSON.parse(JSON.stringify(options[prop]));
                        if (gridSettings.columns) {
                            gridSettings.columns.unshift({ field: "cssClass", headerText: "", cssClass: "e-grid-image", width: 22, template: "<script type='text/x-jsrender'><span class='e-fe-icon {{:cssClass}}' unselectable='on'></span></script>", textAlign: ej.TextAlign.Center, allowResizing: false });
                            if (this.model.showCheckbox)
                                gridSettings.columns.unshift({ field: "", headerText: "check", cssClass: "e-col-check", width: 18, template: "<script type='text/x-jsrender'><input type='checkbox' class='e-grid-row-checkbox'/></script>", textAlign: ej.TextAlign.Center, headerTextAlign: ej.TextAlign.Center, allowResizing: false, allowSorting: false });
                        }
                        this._gridObj && this._gridtag.ejGrid(gridSettings);
                        this._showHideContextMenu();
                        this._renderSortbyDrpdwn();
                        break;
                    case "locale":                        
                        this.model.locale = options[prop];                        
                        this._destroy();
                        this._init();
                        break;
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "fileTypes":
                        $.each(proxy._fileExplorer, function (itemPath, value) {
                            proxy._fileExplorer[itemPath] = "";
                        });
                        this._removeOldSelectionDetails();
                        this._refreshItems(this._selectedNode, this._currentPath);
                        this._uploadtag.ejUploadbox("option", { extensionsAllow: this.model.fileTypes == "*.*" ? "" : this.model.fileTypes.replace(/\*/g, "") });
                        break;
                    case "selectedFolder":
                        this._selectedFolder(this.model.selectedFolder);
                        break;
                    case "selectedItems":
                        this._selectedItems = options[prop];
                        this._setSelectedItems(options[prop]);
                        break;
                    case "allowMultiSelection":
                        !options[prop] && this._setSelectedItems([]);
                        this._gridtag.find(".e-gridheader").length && this._gridtag.ejGrid("option", { selectionType: (options[prop] ? "multiple" : "single") });
                        if (!ej.isNullOrUndefined(this._gridObj)) {
                            if (this.model.allowMultiSelection) this._gridtag.find('.e-headercelldiv>span.e-chkbox-wrap').show();
                            else this._gridtag.find('.e-headercelldiv>span.e-chkbox-wrap').hide();
                        }
                            break;
                    case "isResponsive": {
                        this.model.isResponsive = options[prop];
                        if (this._toolBarObj) {
                            this._toolBarObj.option("isResponsive", this.model.isResponsive);
                            this.model.showToolbar ? this._toolBarItems.show() : this._toolBarItems.hide();
                            this.adjustSize();
                        }
                        this._wireResizing();
                        break;
                    }
                    case "tools":
                    case "toolsList":
                        if (prop == "tools")
                            $.extend(this.model.tools, options[prop]);
                        else
                            this.model.toolsList = options[prop];
                        if (this._toolBarObj) {
                            this._toolBarObj.destroy();
                            this.element.find("#" + this._ExplorerId + "_toolbar").remove();
                            this._updateToolbar();
                            this.model.showToolbar ? this._toolBarItems.show() : this._toolBarItems.hide();
                            this.adjustSize();
                        }
                        break;
                    case "enableResize":
                        if (!options[prop])
                            this._resizeItem && this._resizeItem.remove();
                        else if (options[prop] && this.model.showFooter) {
                            this._resizeItem = ej.buildTag("div.e-icon e-fe-resize e-resize-handle");
                            this._resizeItem.insertBefore(this.element.find(".e-switchView"));
                            this._resizeFileExplorer();
                        }
                        break;
                    case "minHeight":
                        this.element.css("min-height", this._getProperValue(this.model.minHeight));
                        this._refreshResizeHandler();
                        break;
                    case "maxHeight":
                        this.element.css("max-height", this._getProperValue(this.model.maxHeight));
                        this._refreshResizeHandler();
                        break;
                    case "minWidth":
                        this.element.css("min-width", this._getProperValue(this.model.minWidth));
                        this._refreshResizeHandler();
                        break;
                    case "maxWidth":
                        this.element.css("max-width", this._getProperValue(this.model.maxWidth));
                        this._refreshResizeHandler();
                        break;
                    case "showCheckbox":
                        this._changeCheckState = this.model.showCheckbox;
                        this.model.layout == "grid" ? this._renderGridView(this._fileExplorer[this._originalPath]) : this._renderTileView(this._fileExplorer[this._originalPath], true);
                        this._setSelectedItems(this.model.selectedItems);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[prop]);
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model[prop], options[prop]);
                        this._showHideContextMenu();
                        break;
                    case "rootFolderName":
                        this._changeRootFolderName();
                        this._updateAddressBar();
                        if (this._treeObj.element.find('li:first > div > .e-text').hasClass("e-active"))
                            this._treeObj.selectNode(this._treeObj.element.find('li:first > div > .e-text'));
                        break;
                }
            }
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            (!ej.isNullOrUndefined(this.model.uploadBoxSettings)) && (this.model.uploadSettings = this.model.uploadBoxSettings);
            (!ej.isNullOrUndefined(this.model.showTreeview)) && (this.model.showNavigationPane = this.model.showTreeview);
            (!ej.isNullOrUndefined(this.model.move)) && (this.model.cut = this.model.move);
            this._initialize();
            this._render();            
            this._changeLayoutActive(this.model.layout);
        },
        _postInit: function () {
            this._enablePostInit = false;
            this._enableRTL(this.model.enableRTL);
            this._wireEvents();
            this._wireResizing();
            this._setMinMaxSizeInInteger();
            if (this.model.enableResize && this.model.showFooter)
                this._resizeFileExplorer();
            this._isClicked = false;
            if (this._selectedTreeFolder && this._currentPath != this._selectedTreeFolder)
                this._selectedFolder(this._selectedTreeFolder);
            if (this._selectedNodes.length) {
                this._setSelectedItems(this._selectedNodes);
            }
            this._isClicked = true;
        },

        _initialize: function () {
            this._ExplorerId = this.element[0].id;
            this._fileExplorer = {};
            this._feParent = {};
            this._updateImages = {};
            this._selectedStates = [];
            this._updateOnNodeSelection = false;
            this._isClicked = true;
            this._toolBarObj = null;
            this._tileView = null;
            this._tileScroll = null;
            this._originalPath = null;            
            this._initPath = "";
            this._initUpdate = false;
            this._scrollerSize = 8;
            this._editingToolsState = true;
            this._renderMultiTouchDialog();
            this._ensureResolution();
            this._isDevice = this._checkDevice();
            this.element.css({ "height": this._getProperValue(this.model.height), "width": this._getProperValue(this.model.width), "min-width": this._getProperValue(this.model.minWidth), "max-width": this._getProperValue(this.model.maxWidth), "min-height": this._getProperValue(this.model.minHeight), "max-height": this._getProperValue(this.model.maxHeight) });
            this._customCssClass = this.model.cssClass;
            this.element.addClass(this.model.cssClass);            
            this._isTreeNode = false;
            this._selectedItems = [];
            this._selectedTileItems = [];
            this._downloadDialog = null;
            this._newFolderDialog = null;
            this._renameDialog = null;
            this._openDialog = null;
            this._detailsDialog = null;
            this._alertDialog = null;
            this._enablePostInit = true;
            this._initialTime = new Date().getTime();
            this._currentPath = this.model.path.replace(/\\/g, "/");
            this._rootPath = this._currentPath = this._currentPath.endsWith("/") ? this._currentPath : this._currentPath + "/";
            this._gridObj = null;
            this._setUploadLocalization();
            this._restrictedToolbarOptions = [];
            this._restrictedMenuOption = [];
            this._changeCheckState = this.model.showCheckbox;
            this._perRow = 1;
            this._suggestionItems = [];
            this._highlightedNodes = "";
            this._prevsorting = true;
            this._FilteredFiles = [];
        },

        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-fe-popup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSelection) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
            this._on(this._customPop, "mousedown", this._popupClick);
        },

        _mouseSelection: function (event) {

            this._target = $(event.target);
            if ((this.model.allowDragAndDrop && (this._target.closest('li').hasClass('e-tilenode') || this._target.is('li.e-tilenode') || this._target.closest('.e-rowcell').is('td')
                || this._target.closest('.e-row').is('tr') || this._target.is('tr'))) || this._target.closest('.e-scrollbar').length > 0 || !this.model.allowMultiSelection || event.button == 2) return;

            proxy = this;
            this._currentTarget = $(event.currentTarget);
            this._initialx = event.pageX; this._initialy = event.pageY;

            this._selectionContainer = ej.buildTag('div.e-fe-selection-rect');
            this._currentTarget.append(this._selectionContainer);

            if (this.element.hasClass("e-ie8")) this._selectionContainer.addClass("e-active");
            event.preventDefault();

            this._containerleftpos = this._currentTarget.offset().left;
            this._containerrightpos = this._currentTarget.width() + this._containerleftpos;
            this._containertoppos = this._currentTarget.offset().top;
            this._containerbottompos = this._currentTarget.height() + this._containertoppos;
            if (this._currentTarget.hasClass('e-gridcontent')) {
                this._gridheader = this._gridObj.element.find('.e-headercontent').offset().top;
                this._gridcontent = this._containertoppos;
            }
            else {
                this._gridheader = null;
                this._gridcontent = null;
            }

            this._prevGridItems = [], this._prevTileItems = [], this._prevScrollTop = null;
            
            if (!event.ctrlKey && !event.shiftKey) this._selectedRows = [];
            if ((event.ctrlKey || event.shiftKey)) {
                if (this._currentTarget.hasClass('e-gridcontent') && !ej.isNullOrUndefined(this._selectedRows)) 
                    this._prevGridItems = this._selectedRows;
                else this._prevTileItems = this._currentTarget.find('li.e-tilenode.e-active');
            }
            
            this._on($(document), "mousemove", this._createSelectionRectangle);
            this._on($(document), "mouseup", this._removeSelectionRectangle);
        },

        _createSelectionRectangle: function (event) {
            event.preventDefault(); this._selectedRows = [];
            this._scroller(event);
            var container = this._selectionContainer;
            if (this._gridObj) var headerContent = this._gridObj.element.find('.e-headercontent').height();
            if (ej.isNullOrUndefined(headerContent)) headerContent = null;

            if (event.pageX < this._initialx) {
                if (event.pageX < this._containerleftpos) { container.css({ "width": this._initialx - this._containerleftpos, "left": 0 }); }
                else container.css({ "width": this._initialx - event.pageX, "left": event.pageX - this._containerleftpos });
            }
            else {
                if (event.pageX > this._containerrightpos) container.css({ "width": this._containerrightpos - this._initialx, "left": this._initialx - this._containerleftpos });
                else container.css({ "width": event.pageX - this._initialx, "left": this._initialx - this._containerleftpos });
            }
            if (event.pageY < this._initialy) {
                if (event.pageY < this._containertoppos) container.css({ "height": this._initialy - this._containertoppos, top: 0 + (this._gridcontent - this._gridheader) });
                else container.css({ "height": this._initialy - event.pageY, "top": event.pageY - (this._containertoppos - headerContent) });
            }
            else {
                if (event.pageY > this._containerbottompos) container.css({ "height": this._containerbottompos - this._initialy, "top": this._initialy - (this._containertoppos - headerContent) });
                else container.css({ "height": event.pageY - this._initialy, "top": this._initialy - (this._containertoppos - headerContent) });
            }
            
            this._changeItemState(container, event);
        },

        _removeSelectionRectangle: function () {
            this._firstSelectedElement = null;
            this._selectionContainer.remove();
            this._off($(document), "mousemove", this._createSelectionRectangle);
            this._off($(document), "mouseup", this._removeSelectionRectangle);
            this._currentTarget.css("pointer-events", "initial");
        },

        _scroller: function (event) {
            var vpos, hpos;
            this._scrollObj = this._currentTarget.data("ejScroller");
            var scrollTop = scrollLeft = 20;
            if (this._currentTarget.hasClass("e-scroller") && !ej.isNullOrUndefined(this._firstSelectedElement)) {
                if (this._currentTarget.find('.e-vscrollbar').length > 0) vpos = this._firstSelectedElement.offset().top - this._initialy;
                if (this._currentTarget.find('.e-hscrollbar').length > 0) hpos = this._firstSelectedElement.offset().left - this._initialx;
                if (event.pageY > this._containerbottompos) { this._scrollObj.option({ "scrollTop": scrollTop + this._scrollObj.option("scrollTop") }); }
                else if (event.pageY < this._containertoppos) { this._scrollObj.option({ "scrollTop": this._scrollObj.option("scrollTop") - scrollTop }); }
                else if (event.pageX > this._containerrightpos) { this._scrollObj.option({ "scrollLeft": this._scrollObj.option("scrollLeft") + scrollLeft }); }
                else if (event.pageX < this._containerleftpos) { this._scrollObj.option({ "scrollLeft": this._scrollObj.option("scrollLeft") - scrollLeft }); }
                if (this._currentTarget.find('.e-vscrollbar').length > 0) this._initialy = this._firstSelectedElement.offset().top - vpos;
                if (this._currentTarget.find('.e-hscrollbar').length > 0) this._initialx = this._firstSelectedElement.offset().left - hpos;
                this._prevScrollTop = this._scrollObj.option("scrollTop");
            }
        },

        _changeItemState: function (container, event) {
            var rowStart, rowEnd,rect = $(this._currentTarget).find('.e-fe-selection-rect');
            var itemHeight, rectStartX, rectStartY, rectEndX, rectEndY;

            if (this._currentTarget.hasClass('e-gridcontent')) {
                if (this._currentTarget.find('.e-vscrollbar').length > 0)
                    var totHeight = this._currentTarget.find('.e-content')[0].scrollHeight;
                else var totHeight = this._currentTarget.children().outerHeight();
                rectStartY = (parseInt(rect.css("top")) - this._gridObj.element.find('.e-gridheader').outerHeight()) + this._scrollObj.model.scrollTop;
                var rectEndY = rectStartY + parseInt(rect.css("height"));
                itemHeight = proxy._currentTarget.find('tr:first').outerHeight();
                rowStart = parseInt(rectStartY / itemHeight);
                rowEnd = parseInt(rectEndY / itemHeight);
                var totRows = totHeight / itemHeight;
                
                if ((event.ctrlKey || event.shiftKey) && !ej.isNullOrUndefined(this._prevGridItems)) {
                    for (var i = 0; i < this._prevGridItems.length; i++) {
                        this._selectedRows.push(this._prevGridItems[i]);
                    }
                }
                
                this._selectGridRecords(event, container, rowStart, rowEnd);

                if (!ej.isNullOrUndefined(this._prevScrollTop)) {
                    if (this._scrollObj) this._scrollObj.scrollY(this._prevScrollTop);
                }
            }
            else {
                var itemWidth;
                this._tileNodes = $(this._currentTarget).find('li.e-tilenode');
                itemWidth = parseInt(this._tileNodes.first().outerWidth()) + 2 * (parseInt(this._tileNodes.first().css("margin-left")));
                itemHeight = parseInt(this._tileNodes.first().outerHeight()) + parseInt(this._tileNodes.first().css("margin-top")) + parseInt(this._tileNodes.first().css("margin-bottom"));
                rectStartX = parseInt(rect.css("left"));
                rectStartY = parseInt(rect.css("top")) + this._scrollObj.model.scrollTop;
                rectEndX = parseInt(rect.css("left")) + parseInt(rect.css("width"));
                rectEndY = rectStartY + parseInt(rect.css("height"));
                this._columnStart = parseInt(rectStartX / itemWidth) + 1;
                rowStart = parseInt(rectStartY / itemHeight) + 1;
                this._columnEnd = parseInt(rectEndX / itemWidth) + 1;
                rowEnd = parseInt(rectEndY / itemHeight) + 1;
                this._totColumn = parseInt(proxy._currentTarget.find('.e-tile-content').outerWidth() / itemWidth);
                this._selectTileItems(container, event, rowStart, rowEnd);
            }
        },

        _selectGridRecords: function (event, container, rowStart, rowEnd) {
            var currentItem;
            for (var i = rowStart; i <= rowEnd; i++) {
                currentItem = $(this._currentTarget.find('tr')[i]);
                if (!ej.isNullOrUndefined(currentItem)) {
                    if (currentItem.length == 0) continue;
                    var offset = currentItem.offset();
                    if (ej.isNullOrUndefined(this._firstSelectedElement)) this._firstSelectedElement = currentItem;
                    
                    var itemleftpos = offset.left, itemtoppos = offset.top, itemrightpos = offset.left + currentItem.width(), itembottompos = offset.top + currentItem.height();

                    //To check whether the items are present inside the rectangle 
                    if (!((itembottompos < container.offset().top) || (itemtoppos > container.offset().top + container.height()) || (itemrightpos < container.offset().left) || (itemleftpos > container.offset().left + container.width()))) {
                        this._currentTarget.css("pointer-events", "none");
                        if ((event.ctrlKey) && $.inArray(i, this._prevGridItems) > -1) {
                            this._selectedRows.splice(this._selectedRows.indexOf(i), 1);
                        }
                        else if (event.shiftKey && $.inArray(i, this._prevGridItems) > -1) {
                            this._prevGridItems.splice(this._prevGridItems.indexOf(i), 1);
                        }
                        else this._selectedRows.push(i);
                    }
                }
            }

            this.option("selectedItems", []);

            if (this._selectedRows.length > 0) {
                if (this._currentTarget.find('table tr').hasClass('e-hover')) this._currentTarget.find('table tr').removeClass('e-hover');
                this._gridObj.selectRows(this._selectedRows);
            }
        },

        _selectTileItems: function (container,event,rowStart, rowEnd) {

            this.option("selectedItems", []);

            if ((event.ctrlKey || event.shiftKey) && !ej.isNullOrUndefined(this._prevTileItems)) {
                for (var i = 0; i < this._prevTileItems.length; i++) {
                    this._prevTileItems[i].click();
                }
            }

            for (var i = rowStart; i <= rowEnd; i++) {
                for (var j = this._columnStart; j <= this._columnEnd; j++) {
                    if (j > this._totColumn) var column = this._totColumn;
                    else var column = j;
                    if (this.model.enableRTL) var currentColumn = (this._totColumn - column) + 1;
                    else var currentColumn = column;
                    var value = parseInt(((((i - 1) * this._totColumn) + currentColumn) - 1));
                    if (!$(this._tileNodes.eq(value)[0]).hasClass('e-active') || (event.ctrlKey || event.shiftKey)) {
                        var currentItem = this._tileNodes.eq(value);
                        if (currentItem.length == 0) continue;
                        offset = currentItem.offset();
                        var itemleftpos = offset.left, itemtoppos = offset.top, itemrightpos = offset.left + currentItem.width(), itembottompos = offset.top + currentItem.height();

                        if (!((itembottompos < container.offset().top) || (itemtoppos > container.offset().top + container.height()) || (itemrightpos < container.offset().left) || (itemleftpos > container.offset().left + container.width()))) {

                            this._currentTarget.css("pointer-events", "none"); currentItem.removeClass("e-hover");

                            if (ej.isNullOrUndefined(this._firstSelectedElement)) this._firstSelectedElement = currentItem;

                            if (event.shiftKey && $.inArray(currentItem[0], this._prevTileItems) > -1) {
                                for (var i = 0; i < this._prevTileItems.length; i++) {
                                    if (currentItem[0] == this._prevTileItems[i])
                                        this._prevTileItems.splice(i, 1);
                                }
                            }
                            else currentItem.click();
                        }
                    }
                }
            }
        },

        _popupClick: function () {
            var $selElement = this._customPop.find(".e-rowselect");
            if ($selElement.hasClass("e-spanclicked")) {
                this._hidePopup();
            }
            else {
                $selElement.addClass("e-spanclicked");
            }
        },

        _hidePopup: function () {
            if (this._customPop != null && this._customPop.is(":visible")) {
                this._customPop.find(".e-rowselect").removeClass("e-spanclicked");
                this._customPop.hide();
            }
        },

        _ensureResolution: function() {
            this._isMobileOrTab = $(window).width() <= 750 ? true : false;
            if (this._isMobileOrTab) {
                this.element.addClass("e-fe-mobile");
                this._toolBarObj && this._toolBarObj._liTemplte.css("max-width", this.element.width());
            }
            else {
                this.element.removeClass("e-fe-mobile");
                if (this._splitObj && this.model.showNavigationPane && this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                    this.model.enableRTL ? this._splitObj.expand(1) : this._splitObj.expand(0);
                }
            }
            this._toolBarObj && this._toolBarObj.option("cssClass", this.model.cssClass + " e-fe-toolbar " + (this._isMobileOrTab ? "e-fe-mobile" : ""));
            ($(window).width() <= 350 || this.element.width() <= 350) ? this.element.addClass("e-fe-small") : this.element.removeClass("e-fe-small");
            ($(window).width() <= 295 || this.element.width() <= 295) ? this.element.addClass("e-fe-short") : this.element.removeClass("e-fe-short");
        },

        _showHideNavigation: function (event) {
            if (this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                if (this.model.enableRTL)
                    this._splitObj.collapse(0)
                else
                    this._splitObj.collapse(1);
            }
            else {
                if(this.model.enableRTL)
                    this._splitObj.expand(0)
                else
                    this._splitObj.expand(1);
            }
        },

        _renderSplitIcon: function () {
            if (!this.model.showNavigationPane) return;
            this._splitIcon = ej.buildTag('div.e-fe-split-icon');
            this._splitIcon.append("<span class='e-icon e-arrow-sans-left'></span>");
            this._splitObj.element.find(".e-splitbar").append(this._splitIcon);
            this._on(this._splitIcon, "touchend click", this._showHideNavigation);
            if (this._isMobileOrTab && this._splitObj && this.model.showNavigationPane) {
                this.model.enableRTL ? this._splitObj.collapse(1) : this._splitObj.collapse(0);
            }
        },

        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },

        _initContextMenuOptions: function (menu) {
            var menuOptions = [], items = this.model.contextMenuSettings.items[menu], customFields = this.model.contextMenuSettings.customMenuFields;
            for (var i = 0; i < items.length; i++) {
                if (items[i] != "|")
                {
                    var ele = this._getCustomItem(customFields, items[i]);
                    var attr = (items[i + 1] == "|") ? "e-fe-separator" : null;
                    this._addMenuItem(ele, items[i], attr, menuOptions, menu);
                    if (ele && ele.hasOwnProperty('child'))
                        this._getChildItems(ele['child'], menuOptions, menu, ele.id);
                }                
           }
           return menuOptions;  
        },

        _addMenuItem: function (ele, item, attr, menuOptions, menu, parentId) {
            var text = this._extendAttr(ele, "text");
            this["_menu" + item] = text ? text : this._getLocalizedLabels("ContextMenu" + item);
            var htmlAttr = this._extendAttr(ele, "htmlAttributes", attr);
            var css = this._extendAttr(ele, "spriteCssClass", "e-fileexplorer-toolbar-icon " + item);
            menuOptions.push({ id: ej.isNullOrUndefined(ele) ? (this._ExplorerId + "_" + menu + "_" + item) : item, text: this["_menu" + item], parentId: parentId, sprite: css, htmlAttr: htmlAttr });
        },

        _getChildItems: function (items, menuOptions, menu, parentId) {
            for (var i = 0, len = items.length; i < len && !ej.isNullOrUndefined(items[i]); i++) {
                var ele = items[i];
                this._addMenuItem(ele, items[i].id, null, menuOptions, menu, parentId);
                if (ele && ele.hasOwnProperty('child'))
                    this._getChildItems(ele['child'], menuOptions, menu, ele.id);
            }
        },

        _getCustomItem: function (items, id) {
            var ele;
            for (var i = 0, len = items.length; i < len && !ej.isNullOrUndefined(items[i]); i++) {
                if (items[i]["id"] == id) {
                    ele = items[i];
                    break;
                }
                if (items[i].hasOwnProperty('child')) {
                    ele = this._getCustomItem(items[i]['child'], id);
                    break;
                }
            }
            return ele;
        },

        _extendAttr: function (ele, attr, value) {
            if (!value)
                return ele ? (ele[attr] ? ele[attr] : null) : null;
            if (attr == "htmlAttributes")
                return { "class": (ele ? (ele[attr] ? (ele[attr]["class"] ? (ele[attr]["class"] + " " + value) : value) : value) : value) };
            else
                return ele ? (ele[attr] ? (ele[attr] + " " + value) : value) : value;
        },

        _render: function () {
            this._selectedTreeFolder = this.model.selectedFolder;
            this._selectedNodes = this.model.selectedItems;
            this.element.addClass('e-widget e-box').attr({ role: "fileexplorer", tabindex: 0 });
            this.model.showToolbar && this._renderToolBar();
            this._createSplitPane();
            this._read();
            this._roundedCorner(this.model.showRoundedCorner);
            this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false
            if (this._isIE8) this.element.addClass("e-ie8");
        },
        _read: function () {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Read", Path: this._currentPath, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(), this._selectedContent) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    if (result === undefined || result === null) return;
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    proxy._feParent[proxy._currentPath] = result.cwd;
                    proxy._readSuccess(result.files);
                    proxy._enablePostInit && proxy._postInit();
                },
                successAfter: this.model.ajaxSettings.read.success
            };
            this.model.ajaxSettings.read.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.read);
            this._sendAjaxRequest(_ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions, hideWaitingState) {
            if (!ajaxOptions.dataType && this.model.ajaxDataType)
                ajaxOptions.dataType = this.model.ajaxDataType;
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            if (ajaxOptions.data.ActionType != "Read")
                this._selectedItemDetails = ajaxOptions.data.SelectedItems;
            var defaultData = { Name: "", ActionType: "", Path: "", ExtensionsAllow: "", LocationFrom: "", LocationTo: "", Action: "", NewName: "", Names:[], CaseSensitive: false, SearchString: "", FileUpload: null, CommonFiles: null };
            if (!hideWaitingState) {
                this._waitingPopup.show();
            }
            $.extend(true, defaultData, ajaxOptions.data);
            var args = { data: defaultData, ajaxSettings: ajaxOptions };
            var proxy = this;
            if (args.data.ActionType == "Paste") {
                args.data.LocationFrom = this._pathCorrection(args.data.LocationFrom);
                args.data.LocationTo  = this._pathCorrection(args.data.LocationTo);
            }
            else {
                args.data.Path = this._pathCorrection(args.data.Path);
            }
            if (this._trigger("beforeAjaxRequest", args))
                return;
            ajaxOptions = args.ajaxSettings;
            $.ajax({
                data: (((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") || ajaxOptions.contentType == "application/x-www-form-urlencoded") ? { json: JSON.stringify(args.data) } : JSON.stringify(args.data)),
                url: ajaxOptions.url,
                type:((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") ?  "GET" : ajaxOptions.type),
                async: ajaxOptions.async,
                success: function(args) {
                    proxy._waitingPopup.hide();
                    ajaxOptions.success.call(this, args);
                    if(typeof ajaxOptions.successAfter == "function")
                        ajaxOptions.successAfter.apply(this, arguments);
                },
                contentType: (ajaxOptions.contentType ? ajaxOptions.contentType : "application/json"),
                dataType: ajaxOptions.dataType,
                jsonpCallback: ajaxOptions.jsonpCallback ? ajaxOptions.jsonpCallback : ((ajaxOptions.dataType && ajaxOptions.dataType.toLowerCase() == "jsonp") ? "MyCallbackFunction" : ""),
                error: ajaxOptions.error ? ajaxOptions.error : function (xhr, textStatus, errorThrown) {
                    proxy._waitingPopup.hide();
                    var text = xhr.responseJSON ? xhr.responseJSON.ExceptionType + ", " + xhr.responseJSON.ExceptionMessage : xhr.statusText;
                    proxy._alertDialog = proxy._createDialog(ej.buildTag('div.e-fe-dialog-label', text), { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error") });
                    proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                },
                beforeSend: ajaxOptions.beforeSend,
                complete: function () {
                    proxy._waitingPopup.hide();
                    ajaxOptions.complete;
                }
            });

        },

        _pathCorrection: function(path){
            if(this.model.path == "/") {
                if (path.indexOf(":") >= 0) {
                    path = path.replace("//", "");
                }
                else if(path != "/") {
                    path = path.replace("/", "");
                }
            }
            return path;
        },

        _onBeforeOpen: function () {
            var fileUrl, selectedNodes = [], args;
            fileUrl = this._nodeType == "File" ? this._currentPath.replace("~", "..") + this._selectedFile : this._currentPath;
            if (this._selectedFile)
                selectedNodes = this._getSelectedItemDetails(this._currentPath, this._selectedFile);
            else if (this._selectedContent)
                selectedNodes = this._getSelectedItemDetails(this._getFolderPath(), this._selectedContent);
            args = { path: fileUrl, itemType: this._nodeType, selectedItems: selectedNodes };
            return this._trigger("beforeOpen", args);
        },

        _readSuccess: function (result) {
            if (result === undefined || result === null) return;
            this._update = false;
            for (var i = 0; i < result.length; i++) {
                result[i].sizeInByte = result[i].size;
                result[i].size = result[i].isFile ? this._bytesToSize(result[i].size) : "";
                result[i].cssClass = this._getCssClass(result[i]);
            }
            var sortingoption = this.model.gridSettings.columns[0];
            var sortingtype = true;
            var initialsort = true;
            this._changeActiveSortedoption(sortingoption.headerText,initialsort);
            this._sorting(sortingoption.field, sortingtype, result);
            this._fileExplorer[this._currentPath] = result;
            this._itemStatus && this._itemStatus.html(this._sorteditems.length + " " + (this._sorteditems.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
            if (!this._treetag.hasClass("e-treeview")) {
                this._renderTreeView(this._sorteditems);
                this._updateOnNodeSelection = true;
            }
            this.model.layout == "grid" ? this._renderGridView(this._sorteditems) : this._renderTileView(this._sorteditems);
            this._usePreviousValues();
        },
        _getCssClass: function (list) {
            var extension = list.name.substr(list.name.lastIndexOf('.') + 1).toLowerCase();
            if (list.isFile) {
                if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(list.name))
                    return 'e-fe-images';
                else if ((/\.(mp3|wav|aac|ogg|wma|aif|fla|m4a)$/i).test(list.name))
                    return 'e-fe-audio';
                else if ((/\.(webm|mkv|flv|vob|ogv|ogg|avi|wmv|mp4|3gp)$/i).test(list.name))
                    return 'e-fe-video';
                else if (!(/\.(css|exe|html|js|msi|pdf|pptx|ppt|rar|zip|txt|docx|doc|xlsx|xls|xml|rtf|php)$/i).test(list.name))
                    return 'e-fe-unknown e-fe-' + extension;
                else
                    return 'e-fe-' + extension;
            }
            else
                return (list.permission && !list.permission.Read) ? 'e-fe-folder e-fe-lock' : 'e-fe-folder';
        },
        _bytesToSize: function (bytes) {
            var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
            if (bytes == 0) return '0 Byte';
            var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
            var value = (bytes / Math.pow(1024, i));
            return value.toFixed(2) + ' ' + sizes[i];
        },

        _setPath: function (path) {
            this.model.path = path;
            this._treetag.remove();
            this._treetag = ej.buildTag('div#' + this._ExplorerId + '_treeView');
            this._splittag.find(".e-cont1 > .e-tree-wrapper").append(this._treetag);
            this._fileExplorer = this._updateImages= {};             
            this._selectedStates = [];
            this._selectedItems = [];
            this._selectedTileItems = [];
            this._initUpdate = false;
            this._initPath = "";
            this._currentPath = this.model.path.replace(/\\/g, "/");
            this._originalPath = this._rootPath = this._currentPath = this._currentPath.endsWith("/") ? this._currentPath : this._currentPath + "/";
            this._read();            
        },

        _getPath: function () {
            return this.model.path;
        },
        _changeSkin: function (value) {
            this.element.removeClass(this._customCssClass).addClass(value);
            this._customCssClass = value;
            this._waitingPopup.option("cssClass", value);
            this._subControlsSetModel("cssClass", value);
        },
        _draggableOption: function (action) {
            this._treeDragEvents(action);
            this._tileDragEvents(action);
            this._gridDragEvents(action);
            if (action=="_off") this._previousPath = null;
            this._statusbar && this[action](this._statusbar, "dragover", this._preventDropOption);
            this._toolBarItems && this[action](this._toolBarItems, "dragover", this._preventDropOption);
        },
        _swapWith : function(from, to) {
            from = $(from); to = $(to);
            var tmp = $('<span>').hide();
            from.before(tmp);
            to.before(from);
            tmp.replaceWith(to);
        },
        _enableRTL: function (value) {
		    var element1 = this._splittag.find(".e-cont1");
            var element2 = this._splittag.find(".e-cont2");            
            this.model.enableRTL = value;
            if (value) {
			    element1.index() < element2.index() && this._swapWith(element1, element2);
			    var gridColumnSettings = JSON.parse(JSON.stringify(this.model.gridSettings.columns));
			    if (!this._oldFormat)
                    this._oldFormat = JSON.parse(JSON.stringify(gridColumnSettings));
                for (var i = 0; i < gridColumnSettings.length; i++) {
                    gridColumnSettings[i].textAlign = gridColumnSettings[i].headerTextAlign = "right";
                }
                this._gridObj && this._gridObj.columns(gridColumnSettings);                                   
                this.element.addClass("e-rtl");
                this.element.find(".e-scroller").addClass("e-rtl");
            }
            else {
                element1.index() > element2.index() && this._swapWith(element2, element1);                                
                if (this._gridObj && this._oldFormat) {
                    for (var i = 0; i < this._oldFormat.length; i++) {
                        if (!this._oldFormat[i].textAlign)
                            this._oldFormat[i].textAlign = "left";
                        if (!this._oldFormat[i].headerTextAlign)
                            this._oldFormat[i].headerTextAlign = "left";
                    }
                    this._gridObj.columns(this._oldFormat);
                }
                if (this._oldFormat) {
                    this.model.gridSettings.columns = JSON.parse(JSON.stringify(this._oldFormat));
                    this._oldFormat = null;
                }
                this.element.removeClass("e-rtl");
                this.element.find(".e-scroller").removeClass("e-rtl");
                (this._gridtag) && this._gridtag.removeClass('e-rtl');
            }
            this._splitterCorrection();
            this._subControlsSetModel("enableRTL", value);
        },
        _roundedCorner: function (value) {
            var operation = value ? "addClass" : "removeClass";
            this.element[operation]('e-corner-all');
            this._treeContextMenutag && this._treeContextMenutag[operation]("e-corner");
            this._tileContextMenutag && this._tileContextMenutag[operation]("e-corner");
            this._subControlsSetModel("showRoundedCorner", value);
        },
        _destroy: function () {
            this._toolBarObj && this._toolBarObj.destroy();
            this._treeContextMenutag && this._treeContextMenutag.parent().remove();
            this._tileContextMenutag && this._tileContextMenutag.parent().remove();
            if (this._newFolderDialogObj && this._newFolderDialogObj.isOpen()) this._removeDialog(this._newFolderDialogObj);
            if (this._renameDialogObj && this._renameDialogObj.isOpen()) this._removeDialog(this._renameDialogObj);
            if (this._openDialogObj && this._openDialogObj.isOpen()) this._removeDialog(this._openDialogObj);
            if (this._detailsDialogObj && this._detailsDialogObj.isOpen()) this._removeDialog(this._detailsDialogObj);
            if (this._alertDialogObj && this._alertDialogObj.isOpen()) this._removeDialog(this._alertDialogObj);
            if (this._alertWindowObj && this._alertWindowObj.isOpen()) this._removeDialog(this._alertWindowObj);
            if (this._splitButtonObj) this._splitButtonObj.destroy();
            if (this._splitButtonObj1) this._splitButtonObj1.destroy();
            this._waitingPopup && this._waitingPopup.destroy();
            this._gridObj && this._gridObj.element.ejWaitingPopup("destroy");
            this._unwireEvents();
            this.element.html("")
            
            $(this._cloneElement).attr("style") ? this.element.attr("style", $(this._cloneElement).attr("style")) : this.element.removeAttr("style");
            this.element.removeClass('e-widget e-box e-rtl e-ie8');      
            this.element.removeAttr('role');
            delete this._prevsortingoption, this._prevsorting;
        },
        _createFolder: function (_name) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "CreateFolder", Name: _name, Path: this._originalPath, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(this._originalPath), this._treeObj.getText(this._selectedNode)) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (result === undefined || result === null) return;
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    var selectedNode = proxy._selectedNode;
                    var nodeObj = [{ id: result.files[0].name, name: result.files[0].name, spriteCssClass: (result.files[0].permission && !result.files[0].permission.Read) ? "e-fe-icon e-fe-folder e-fe-lock" : "e-fe-icon e-fe-folder", hasChild: false }];
                    if (!proxy._treetag.ejTreeView("isExpanded", selectedNode))
                        proxy._treeObj && proxy._treeObj.expandNode(selectedNode);
                    proxy._nodeExpanded = true;
                    proxy._treeObj.addNode(nodeObj, selectedNode);
                    proxy._nodeExpanded = false;
                    proxy._update = true;
                    proxy._treeObj.selectNode(selectedNode);
                    proxy._refreshTreeScroller();
                    proxy._treetag.find("li").removeAttr("tabindex");
                    var items = proxy._treetag.find("li div a").not(".e-js");
                    if (proxy.model.allowDragAndDrop && items.length) {
                         proxy._drag(items);
                         items.addClass("e-file-draggable");
                    }
                    var args = { data: result, selectedItems: proxy._selectedItemDetails };
                    proxy._trigger("createFolder", args);
                    proxy._setSelectedItems([result.files[0].name]);
                },
                successAfter: this.model.ajaxSettings.createFolder.success
            };
            this.model.ajaxSettings.createFolder.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.createFolder);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _needToScroll: function (element, area) {
            var wrapperHeight, nodeHeight = area=="Tree" ? element.find("a").eq(0).outerHeight() :(element.outerHeight() + ((this.model.layout== "grid") ? 0 : 10));
            var elementHeight = 0;
            elementHeight += element.position().top + nodeHeight;
            if (area == "Tree") {
                while (element.parent().hasClass("e-treeview-ul")) {
                    element = element.parent();
                    elementHeight += element.position().top;
                }
                wrapperHeight = this._splittag.find(".e-cont1").height();
            } else {
                if (this.model.layout == ej.FileExplorer.layoutType.Grid) {
                    wrapperHeight = this._gridtag.find(".e-gridcontent").height();
                    elementHeight = elementHeight - this._gridtag.find(".e-gridheader").outerHeight();
                }
                else {
                    wrapperHeight = this._tileViewWrapper.height();
                }
            }
            var scrollableElement = element.closest(".e-scroller .e-content", ".e-fileexplorer");
            if (wrapperHeight < elementHeight) {
                scrollableElement.animate({
                    scrollTop: scrollableElement.scrollTop() + (nodeHeight *2)
                }, 500, 'linear');
            } else if (elementHeight < element.outerHeight()) {
                scrollableElement.animate({
                    scrollTop: scrollableElement.scrollTop() - (nodeHeight * 2)
                }, 500, 'linear');
            }
        },
        
        _cut_copy: function (maintainSourceNode) {
            var proxy = this;
            if (this._sourcePath == this._currentPath && this._option == "move") {
                this.element.find(".e-blur").removeClass("e-blur");
                this.model.layout!= "grid" && this._clearTileCheckBoxSelection();
                this._setSelectedItems(this._fileName);
                if (maintainSourceNode)
                    this._activeSource = this.model.selectedItems;
                return;
            }
            var data = this._fileExplorer[this._currentPath], _selectedFiles = (typeof this._copiedNodes == "string") ? [this._copiedNodes] : this._copiedNodes;
            this._pastedFiles = _selectedFiles.slice();
            for (var i = 0; i < _selectedFiles.length; i++) {
                if (!this._isNameExist(this._suggestionItems.length ? this._suggestionItems : this._fileExplorer[this._sourcePath], _selectedFiles[i]))
                    return;
            }
            var previousPath = proxy._currentPath;
            var successCallback = function () {
                proxy._currentPath = previousPath;
                if (ej.isNullOrUndefined(data))
                    data = proxy._fileExplorer[previousPath];
                proxy._existingItems = [];
                if (proxy._sourcePath != previousPath && data.length) {
                    proxy._getDuplicateItems(proxy._sourcePath, previousPath, (typeof proxy._fileName == "string" ? [proxy._fileName] : proxy._fileName));
                    if (proxy._existingItems.length) {
                        proxy._createReplaceConformationDiaolg("_pasteOperation", "PasteReplaceAlert");
                    }
                    else
                        proxy._pasteOperation();
                }
                else {
                    for (var i = 0; i < _selectedFiles.length; i++) {
                        proxy._pastedFiles[i] = proxy._getDuplicateName(proxy._fileExplorer[previousPath], _selectedFiles[i]);
                    }
                    proxy._pasteOperation();
                }
            };
            if (ej.isNullOrUndefined(data)) {
                this._getFileDetails(this._currentPath, "", "", successCallback);
            }
            else {
                successCallback();
            }
        },
        _createReplaceConformationDiaolg: function (executableFunction, alert) {
            var proxy = this,title;
            var i = 0;
            if ((alert == "PasteReplaceAlert" || alert == "UploadReplaceAlert") && this._getLocalizedLabels("ReplaceAlert") != "ReplaceAlert") {
                alert = "ReplaceAlert";
            }
            else
                title = executableFunction == "_customUpload" ? "UploadError" : executableFunction == "pasteOperation" ? "PasteError" : executableFunction == "_rename" ? "RenameError" : "Error";
            if (this.model.rootFolderName.length > 0)
                var viewerData = String.format(this._getLocalizedLabels(alert), this._changeName(this._existingItems[i].Path), false);
            else
                var viewerData = String.format(this._getLocalizedLabels(alert), this._existingItems[i].Path);
            var dialogContent = ej.buildTag('div.e-get-name');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var divtag = ej.buildTag('div.e-fe-dialog-btn e-replace');
            var yesButton = ej.buildTag('button.e-fe-btn-yes ', this._getLocalizedLabels("YesButton"));
            var yesToAllButton = ej.buildTag('button.e-fe-btn-yes e-all ', this._getLocalizedLabels("YesToAllButton"));
            var noButton = ej.buildTag('button.e-fe-btn-no ', this._getLocalizedLabels("NoButton"));
            var noToAllButton = ej.buildTag('button.e-fe-btn-no e-all ', this._getLocalizedLabels("NoToAllButton"));
            yesButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(proxy._existingItems[i].Name))
                        proxy._updateImages[proxy._existingItems[i].Path] = new Date().getTime();
                    proxy._existingItems[i].IsReplace = true;
                    i++;
                    if (i < proxy._existingItems.length)
                        proxy._alertDialog.find(".e-fe-dialog-label").text(String.format(proxy._getLocalizedLabels(alert), proxy._existingItems[i].Path));
                    else
                        proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            noButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._existingItems[i].IsReplace = false;
                    i++;
                    if (i < proxy._existingItems.length)
                        proxy._alertDialog.find(".e-fe-dialog-label").text(String.format(proxy._getLocalizedLabels(alert), proxy._existingItems[i].Path));
                    else
                        proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            yesToAllButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    for (var j = i; j < proxy._existingItems.length; j++) {
                        if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(proxy._existingItems[j].Name))
                            proxy._updateImages[proxy._existingItems[j].Path] = new Date().getTime();
                        proxy._existingItems[j].IsReplace = true;
                    }
                    proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            noToAllButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    for (var j = i; j < proxy._existingItems.length; j++) {
                        proxy._existingItems[j].IsReplace = false;
                    }
                    proxy._destroyReplaceConformationDiaolg(executableFunction);
                }
            });
            divtag.append(yesButton, yesToAllButton, noButton, noToAllButton);
            $(dialogContent).append(labeltag, divtag);
            var open = function () {
                yesButton.focus();
            };
            this._alertDialog = this._createDialog(dialogContent, { width: 500, height: "auto", title: this._getLocalizedLabels(title), open: open });
            this._alertDialogObj = this._alertDialog.data("ejDialog");
        },
        _destroyReplaceConformationDiaolg: function (executableFunction) {
            this._removeDialog(this._alertDialogObj);
            this[executableFunction]();
        },
        _pasteOperation: function () {
            this._removeBlurEffect();
            var proxy = this;
            var itemIndex = -1;
            if (typeof this._fileName == "string")
                this._fileName = [this._fileName];
            for (var i = 0; i < this._fileName.length; i++) {
                var tempPath = this._sourcePath + this._fileName[i] + "/";
                if (this._currentPath.indexOf(tempPath) >= 0 ) {
                    itemIndex = i;
                    break;
                }
            }
            if (itemIndex != -1) {
                var viewerData = this._getLocalizedLabels("CancelPasteAction");
                var dialogContent = ej.buildTag('div');
                var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
                var divtag = ej.buildTag('div.e-fe-dialog-centerbtn');
                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', this._getLocalizedLabels("CancelButton"));
                cancelButton.ejButton({
                    cssClass: "e-flat",
                    type: "button",
                    click: function () {
                        proxy._removeDialog(proxy._alertDialogObj);
                    }
                });
                var skipButton = ej.buildTag('button.e-fe-btn-skip ', this._getLocalizedLabels("SkipButton"));
                skipButton.ejButton({
                    cssClass: "e-flat",
                    type: "button",
                    click: function () {
                        proxy._fileName.splice(itemIndex, 1);
                        proxy._removeDialog(proxy._alertDialogObj);
                        proxy._performPasteOperation();
                    }
                });
                divtag.append(skipButton, cancelButton);
                $(dialogContent).append(labeltag, divtag);
                var open = function () {
                    cancelButton.focus();
                };
                this._alertDialog = this._createDialog(dialogContent, { width: 400, height: "auto", title: this._getLocalizedLabels("Error"), open: open });
                this._alertDialogObj = this._alertDialog.data("ejDialog");
            }
            else
                this._performPasteOperation();
        },
        _performPasteOperation: function () {
            var proxy = this;
            var nodes = this._currentPath.split('/')
            var _ajaxOptions = {
                data: { ActionType: "Paste", LocationFrom: this._sourcePath, LocationTo: this._currentPath, Names: (typeof this._fileName == "string") ? [this._fileName] : this._fileName, Action: this._option, CommonFiles: this._existingItems, SelectedItems: this._getSelectedItemDetails(this._sourcePath, this._fileName), TargetFolder: this._getSelectedItemDetails(this._getFolderPath(), nodes[nodes.length - 2]) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    if (typeof proxy._fileName == "string")
                        proxy._fileName = [proxy._fileName];
                    for (var i = 0; i < proxy._pastedFiles.length; i++) {
                        if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(proxy._pastedFiles[i]))
                            proxy._updateImages[proxy._currentPath + proxy._pastedFiles[i]] = new Date().getTime();
                    }
                    proxy._existingItems && proxy._existingItems.filter(function (item) {
                        if (item.IsReplace == false)
                        {
                            var index = $.inArray(item.Name, proxy._pastedFiles);
                            if (index > -1)
                                proxy._pastedFiles.splice(index, 1);
                        }
                    })
                    proxy._existingItems = [];
                    var oldPath = proxy._originalPath;
                    var oldNode = proxy._selectedNode;
                    if (proxy._option == "move") {
                        for (var i = 0; i < proxy._fileName.length; i++) {
                            proxy._modifySelectedStates(proxy._sourcePath + proxy._fileName[i], "");
                        }
                        if (proxy._fileName.length > 0) {
                            if (proxy._fileName.length == 1)
                                proxy._sourceType == "Directory" && proxy._treeObj.removeNode(proxy._refreshNode);
                            else {
                                nodes = proxy._refreshNode.siblings();
                                proxy._sourceType == "Directory" && proxy._treeObj.removeNode(proxy._refreshNode);
                                for (var i = 0; i < proxy._fileName.length; i++) {
                                    for (var j = 0; j < nodes.length; j++) {
                                        if (proxy._fileName[i] == $(nodes[j]).text())
                                            proxy._treeObj.removeNode(nodes[j]);
                                    }
                                }
                            }
                        }
                    }
                    $.each(proxy._fileExplorer, function (path, value) {
                        //display the key and value pair
                        if (path.startsWith(oldPath))
                            proxy._fileExplorer[path] = "";
                    });
                    proxy._currentPath = proxy._originalPath;
                    proxy._highlightedNodes = proxy._pastedFiles;
                    if (proxy._option == "move") {
                        proxy._refreshItems(oldNode, oldPath,
                        function () {
                            proxy._fileExplorer[proxy._sourcePath] = "";
                            proxy._getFileDetails(proxy._sourcePath);
                        });
                    }
                    else{
                        proxy._refreshItems(oldNode, oldPath);
                    }
                    var folderPath = proxy._getFolderPath();
                    if (proxy._option == "move") {
                        proxy._fileName = "";
                        proxy._option = null;
                        proxy._toolBarItems && proxy._toolBarItems.ejToolbar("disableItemByID", proxy._ExplorerId + "Paste");
                        if (proxy.model.showContextMenu) {
                            proxy._viewMenuObj.disableItem(proxy._menuPaste);
                            proxy._treeMenuObj.disableItem(proxy._menuPaste);
                        }
                        }
                        var args = { name: proxy._fileName, targetPath: proxy.model.path, selectedItems: proxy._selectedItemDetails, targetFolder: proxy._getSelectedItemDetails(folderPath, proxy._selectedContent) };
                        proxy._trigger("paste", args);
                    },
                    successAfter: this.model.ajaxSettings.paste.success
                };
                this.model.ajaxSettings.paste.success = undefined;
                $.extend(true, _ajaxOptions, this.model.ajaxSettings.paste);
                this._sendAjaxRequest(_ajaxOptions);
        },
        _deletion: function (names, path) {
            var proxy = this;
            var selectedNode = this._treeObj.getSelectedNode();
            if (!this._treeObj.isExpanded(selectedNode))
                this._treeObj && this._treeObj.expandNode(selectedNode);
            var _ajaxOptions = {
                data: { ActionType: "Remove", Names: (typeof names=="string")? [names]: names , Path: path, SelectedItems: this._getSelectedItemDetails(path, names) },
                traditional: true,
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    proxy._selectedItemsTag && proxy._selectedItemsTag.html("");
                    proxy._fileExplorer[proxy._ajax_folderPath] = "";
                    $.each(proxy._fileExplorer, function (path, value) {
                        //display the key and value pair
                        if (path.startsWith(proxy._ajax_folderPath))
                            proxy._fileExplorer[path] = "";
                    });
                    for (var i = 0; i < _ajaxOptions.data.SelectedItems.length; i++) {
                        _ajaxOptions.data.SelectedItems[i].isFile == false && proxy._modifySelectedStates(path + _ajaxOptions.data.SelectedItems[i].name, "");
                    }                    
                    proxy._currentPath = proxy._ajax_folderPath;
                    var node = (proxy._selectedContent == proxy._selectedTreeText) ? proxy._parentNode : proxy._selectedNode;
                    proxy._refreshItems(node, proxy._ajax_folderPath);
                    if (proxy._treeObj.getSelectedNode().length == 0)
                        proxy._treeObj.selectNode(proxy._parentNode);
                    else  (proxy.model.layout == "grid") ? proxy._gridtag.find(".e-gridcontent").click() : proxy._tileViewWrapper.click();
                    var args = { data: result, path: proxy._ajax_folderPath, name: names, selectedItems: proxy._selectedItemDetails };
                    proxy._trigger("remove", args);
                },
                successAfter: this.model.ajaxSettings.remove.success
            };
            this.model.ajaxSettings.remove.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.remove);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _rename: function () {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Rename", Path: proxy._currentPath, Name: proxy._selectedContent, NewName: proxy._ajax_person, CommonFiles: proxy._existingItems, SelectedItems: this._getSelectedItemDetails(proxy._currentPath, this._selectedContent) },
                url: this.model.ajaxAction,
                type: "POST",
                success: function (result) {
                    if (!ej.isNullOrUndefined(result)) {
                        if (result.hasOwnProperty("d"))
                            result = result.d;
                        if (!ej.isNullOrUndefined(result.error)) {
                            proxy._showErrorDialog(result.error);
                            return;
                        }
                    }
                    proxy._existingItems = [];
                    proxy._fileExplorer[proxy._currentPath] = "";
                    proxy._nodeType != "File" && proxy._modifySelectedStates(proxy._currentPath + proxy._selectedContent, proxy._currentPath + proxy._ajax_person);
                    if (proxy._splittag.find(".e-cont2 .e-active").length <= 0) {
                        $.each(proxy._fileExplorer, function (itemPath, value) {
                            if (itemPath.startsWith(proxy._currentPath + proxy._selectedContent + "/"))
                                proxy._fileExplorer[itemPath] = "";
                        });
                        proxy._selectedNode.find("> div > .e-text")[0].lastChild.nodeValue = proxy._selectedContent = proxy._ajax_person;
                        proxy._originalPath = proxy._currentPath += proxy._ajax_person + "/";
                        proxy._updateAddressBar();
                    }
                    else {
                        if (proxy.model.selectedItems.length > 0) {
                            proxy.model.selectedItems[proxy.model.selectedItems.length - 1] = proxy._getOriginalName(proxy._ajax_person);
                            proxy._selectedItems[0] = proxy._ajax_person;
                            proxy._highlightedNodes = proxy.model.selectedItems;
                            proxy._refreshItems(proxy._selectedNode, proxy._currentPath);
                        }
                        else
                            proxy._refreshItems(proxy._parentNode, proxy._currentPath);
                        if (proxy._treeObj.getSelectedNode().length == 0) {
                            $(proxy._parentNode).find('li a').each(function () {
                                if ($(this).text() == proxy._ajax_person) {
                                    proxy._treeObj.selectNode($(this).closest('li.e-item'));
                                    return false;
                                }
                            });
                        }
                    }
                },
                successAfter: this.model.ajaxSettings.rename.success
            };
            this.model.ajaxSettings.rename.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.rename);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _downloadFile: function () {
            var selectedItems = this._getSelectedItemDetails(this._currentPath, this._selectedItems);
            var dataObj = {
                Path: this._pathCorrection(this._currentPath),
                ActionType: "Download",
                SelectedItems: JSON.stringify(selectedItems),
                Names: this._selectedItems
            };            
            var url = this.model.ajaxAction + "?" + ($.param(dataObj, true));            
            if (this.model.ajaxSettings.download.url) {
                if (this.model.ajaxSettings.download.url.indexOf("{") >= 0)
                    url = String.format(this.model.ajaxSettings.download.url, "?" + ($.param(dataObj, true)));
                else
                    url = this.model.ajaxSettings.download.url;
            }
            var args = { path: this._pathCorrection(this._currentPath), files: this._selectedItems, selectedItems: selectedItems, url: url };
            if (this._trigger("beforeDownload", args))
                return false;
            window.location = args.url;
        },
        _removeBlurEffect: function () {
            if (this._currntNode) {
                this._currntNode.hasClass("e-active") && this._currntNode.removeClass("e-blur");
                this._currntNode.find(".e-active").length && this._currntNode.find(".e-active").removeClass("e-blur");
            }
        },
        _renderTreeView: function (result) {
            var rootDIRID = 1, _hasChild = result.length > 0 ? true : false;
            this._collapse = false;
            var proxy = this;
            var nodes = this._currentPath.split("/");
            for (var i = 0; i < nodes.length - 2; i++) {
                this._initPath += nodes[i] + "/";
            }
            var startNode = nodes[nodes.length - 2];
            this._localData = [{ id: rootDIRID, name: (startNode ? startNode : this._currentPath), spriteCssClass: this._hasReadPermission(this._currentPath) ? "e-fe-icon e-fe-folder" : "e-fe-icon e-fe-folder e-fe-lock", hasChild: _hasChild }];
            this._treetag._collapse = false;
            this._treetag.ejTreeView(
               {
                   loadOnDemand: true,
                   cssClass: proxy.model.cssClass,
                   enableRTL: proxy.model.enableRTL,
                   allowKeyboardNavigation: proxy.model.allowKeyboardNavigation,
                   fields: { dataSource: proxy._localData, id: "id", parentId: "pid", text: "name", hasChild: "hasChild", spriteCssClass: "spriteCssClass" },
                   nodeCollapse: function (e) { proxy._refreshTreeScroller(e); },
                   nodeExpand: function (e) { proxy._refreshTreeScroller(e); },
                   nodeClick: function (e) { proxy._treenodeClicked(e); },
                   beforeExpand: function (e) { proxy._treeNodeBeforeExpand(e); },
                   nodeSelect: function (e) { proxy._updateTreePath(e); },
                   beforeCollapse: function (e) { proxy._onBeforeCollapse(e); },
                   beforeDelete: function (e) { proxy._treeBeforeDelete(e); },
               }
           );
            this._treeObj = this._treetag.data("ejTreeView");
            this._rootFolderName = this._treeObj.element.find('li:first > div > .e-text').text();
            this._changeRootFolderName();
            this._treeViewEvents("_off");
            this._treeViewEvents("_on");
            this._isClicked = false;
            this._treetag.ejTreeView("selectNode", $(this._treetag).find("li")[0]);
            this._isClicked = true;
            this._treeScroll = this._treetag.parent(".e-tree-wrapper").ejScroller({ height: this._splittag.height(), width: parseInt(this._splittag.find(".e-cont1").width()), buttonSize: 0, scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } }).data("ejScroller");
            this._addChild(result);
        },
        _treeViewEvents: function (action) {
            this[action](this._treetag, "focus", this._focusTreeView);
            this[action](this._treetag, "blur", this._blurTreeView);
            this.model.allowDragAndDrop && this._treeDragEvents(action);
        },
        _treeDragEvents: function (action) {
            var treeWraper = this._treetag.parent(".e-tree-wrapper");
            if (treeWraper) {
                this[action](treeWraper, "dragover", this._onDragOverHandler);
                this[action](treeWraper, "drop", this._onDropHandler);
                this[action](treeWraper, "dragleave", this._onDragLeave);
            }
        },
        _focusTreeView: function (e) {
            if (!this._treetag.hasClass("e-focus")) {
                this._treetag.addClass("e-focus");
                this._itemList = [];
                this._on(this._treetag, "keydown", this._OnKeyUp);
                this._hidePopup();
            }
        },
        _blurTreeView: function (e) {
            this._treetag.removeClass("e-focus");
            this._off(this._treetag, "keydown", this._OnKeyUp);
        },
        _treeBeforeDelete: function (args) {
            if (ej.isNullOrUndefined(args.event)) return;
            var code = this._getKeyCode(args.event);
            if (code == 46) // Prevent the treeview Delete action
                args.cancel = true;
        },
        _treeNodeBeforeExpand: function (args) {
            if (!this._nodeExpanded) {
                var path = this._updatePath(args.currentElement, args.value);
                !this._fileExplorer[path] && this._getFileDetails(path, args.currentElement);
                if (!this._treetag.ejTreeView("hasChildNode", args.currentElement)) {
                    this._fileExplorer[path] && this._addChild(this._fileExplorer[path], args.currentElement);
                }
            }
        },
        _treenodeClicked: function (args) {
            args.event.currentTarget && args.event.currentTarget.focus();
            if ($(args.currentElement).hasClass("e-text") && args.currentElement != this._selectedNode.find('> div > .e-text')[0]) {
                this._selectedContent = args.currentElement.text;
                this._selectedNode = $(args.currentElement).closest('li.e-item');
                var node = $(this._selectedNode.parents('li.e-item')[0]);
                this._parentNode = node.length != 0 ? node : this._selectedNode;
                this._nodeType = "Directory";
                this._isTreeNode = true;
            }
        },
        _showHideContextMenu: function () {
            if (this.model.showContextMenu) {
                var events = { beforeOpen: "", click: "" }, menuDetails = { id: "", targetId: "" };
                this._treeMenuOptions = this._initContextMenuOptions("navbar");
                menuDetails.id = this._ExplorerId + "_treeView";
                menuDetails.targetId = "#" + this._ExplorerId + "_treeView";
                events.beforeOpen = $.proxy(this._beforeOpenContextMenu, this);
                events.open = $.proxy(this._contextMenuOpen, this);
                events.close = $.proxy(this._onHideContextMenu, this);
                events.click = $.proxy(this._contextMenuClick, this);
                this._treeContextMenutag = this._createContextMenuTag(this._treeMenuOptions, menuDetails, events);
                this._treeMenuObj = this._treeContextMenutag.ejMenu('instance');
                this._cwdMenuOptions = this._initContextMenuOptions("cwd");
                this._addSortbyoptions();
                menuDetails.id = this._ExplorerId + "_tileView";
                menuDetails.targetId = "#" + this._ExplorerId + "_tileWrapper,#" + this._ExplorerId + "_grid";
                events.beforeOpen = $.proxy(this._beforeOpenTileContextMenu, this);
                events.open = $.proxy(this._contextMenuOpen, this);
                events.click = $.proxy(this._fileContextMenuClick, this);
                this._tileContextMenutag = this._createContextMenuTag(this._cwdMenuOptions, menuDetails, events);
                this._viewMenuObj = this._tileContextMenutag.ejMenu('instance');
                if (ej.isNullOrUndefined(this._fileName) || this._fileName == "") {
                    this._treeMenuObj.disableItem(this._menuPaste);                    
                }
                this._fileMenuOptions = this._initContextMenuOptions("files");                
            }
            else {
                if (this._treeContextMenutag && this._tileContextMenutag) {
                    this._treeMenuObj.destroy();
                    this._viewMenuObj.destroy();
                    $("#" + this._ExplorerId + "_treeViewContextMenu").remove();
                    $("#" + this._ExplorerId + "_tileViewContextMenu").remove();
                    this._viewMenuObj= this._treeMenuObj = null;                     
                }
            }
        },
        _addSortbyoptions: function () {
            var length = this.model.contextMenuSettings.items.cwd.length;
            var items = this.model.contextMenuSettings.items.cwd;
            if (items.indexOf('SortBy') > -1) {
                    var itemslength = this.model.gridSettings.columns.length;
                    for (var j = 0; j < itemslength; j++) {
                        var css = "e-fileexplorer-toolbar-icon " + this.model.gridSettings.columns[j].field;
                        this._cwdMenuOptions.push({ id: this._ExplorerId + "_cwd_" + this.model.gridSettings.columns[j].field, text: this.model.gridSettings.columns[j].headerText, parentId: this._ExplorerId + "_cwd_" + "SortBy", sprite: css});
                    }
                }
        },
        enableMenuItem: function (operation) {            
            operation = this._findCommand(operation, this.model.contextMenuSettings.items, true);
            for(var i=0; i < this._restrictedMenuOption.length; i++){
                if (this._restrictedMenuOption[i] == operation) {
                    this._restrictedMenuOption.splice(i, 1);
                    break;
                }                    
            }                        
            this._treeMenuObj && this._treeMenuObj.enableItem(operation);
            this._viewMenuObj && this._viewMenuObj.enableItem(operation);
        },
        disableMenuItem: function (operation) {
            operation = this._findCommand(operation, this.model.contextMenuSettings.items, true);
            if ($.inArray(operation, this._restrictedMenuOption) == -1)
                this._restrictedMenuOption.push(operation);
            this._treeMenuObj && this._treeMenuObj.disableItem(operation);
            this._viewMenuObj && this._viewMenuObj.disableItem(operation);
        },
        _renderGridView: function (result) {
            var columnSettings = JSON.parse(JSON.stringify(this.model.gridSettings.columns));
            var sortSettings = null;
            for (var i = 0; i < columnSettings.length; i++) {
                if (!columnSettings[i]["template"]) {
                    columnSettings[i]["template"] = "<script type='text/x-jsrender'><span title= '{{:" + columnSettings[i]["field"] + "}}'>{{:" + columnSettings[i]["field"] + "}}</span></script>";
                }
            }
            if (this._suggestionItems.length) 
                columnSettings.push({ field: "filterPath", headerText: this._getLocalizedLabels("Folder"), width: "20%" });
            columnSettings.unshift({ field: "cssClass", headerText: "", cssClass: "e-grid-image", width: 22, template: "<script type='text/x-jsrender'><span class='e-fe-icon {{:cssClass}}' unselectable='on'></span></script>", textAlign: ej.TextAlign.Center, allowResizing: false });
            if (this.model.showCheckbox)
                columnSettings.unshift({ field: "", headerText: "check", cssClass: "e-col-check", width: 22, template: "<script type='text/x-jsrender'><input type='checkbox' class='e-grid-row-checkbox'/></script>", textAlign: ej.TextAlign.Center, headerTextAlign: ej.TextAlign.Center, allowResizing: false, allowSorting: false });
            var proxy = this;
            var lastcolumn = columnSettings[columnSettings.length - 1];
            if (lastcolumn) {
                if (lastcolumn["customAttributes"]) {
                    if (lastcolumn["customAttributes"]["class"]) {
                        if (lastcolumn["customAttributes"]["class"].search("e-rowcell e-last-rowcell") == -1)
                            lastcolumn["customAttributes"]["class"] = lastcolumn["customAttributes"]["class"] + " e-rowcell e-last-rowcell";
                    }
                    else
                        lastcolumn["customAttributes"]["class"] = " e-rowcell e-last-rowcell";
                }
                else {
                    lastcolumn["customAttributes"] = { 'class': "e-rowcell e-last-rowcell" };
                }
            }
            if (this._gridObj) {
                if (columnSettings.length != this._gridObj.model.columns.length) {
                    this._gridObj.model.columns = columnSettings;
                    this._gridObj.columns(this._gridObj.model.columns);
                }
                sortSettings = JSON.parse(JSON.stringify(this._gridObj.model.sortSettings));
                this._gridObj.option({ 'dataSource': result ,'enableRTL':this.model.enableRTL,'sortSettings': sortSettings});
            } else {
                this._gridtag.ejGrid({
                       cssClass: proxy.model.cssClass,
                       enableRTL: proxy.model.enableRTL,
                       allowKeyboardNavigation: this.model.allowKeyboardNavigation,
                       dataSource: result,
                       selectionType: (proxy.model.allowMultiSelection ? "multiple" : "single"),
                       allowSorting: proxy.model.gridSettings.allowSorting,
                       columns: columnSettings,
                       isResponsive: true,
                       scrollSettings: { width: 186, height: 200, buttonSize: 0, scrollerSize: proxy._scrollerSize},
                       allowScrolling: true,
                       enableResponsiveRow: false,
                       rowSelected: function (e) { proxy._updatePathFromGrid(e); },
                       recordDoubleClick: function (e) { proxy._openAction(e); },
                       create: (this.model.showCheckbox ? function (e) { proxy._gridCheckboxState(e); } : null),
                       actionBegin: function (e) { proxy._gridActionBegin(e); },
                       actionComplete: function (e) { proxy._gridActionComplete(e); },
                       allowResizing:proxy.model.gridSettings.allowResizing
                  }
               );
                if(!this.model.allowMultiSelection)
                this._gridtag.find('.e-headercelldiv>span.e-chkbox-wrap').hide();
            }
            if (result.length && result[0].filterPath) {
                this._setFilteredContent();
            }
            if (this.model.templateRefresh){
                this._gridtag.ejGrid({
                    templateRefresh: function (e) { proxy._templateRefresh(e) }
                });
            }
            this._gridObj = this._gridtag.ejGrid("instance");
            var permission = this._getFilePermission(this._currentPath);
            if ((permission) && !(permission.Read)) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("ProtectedFolder")).addClass("e-fe-center");
            else if (this._gridObj.model.dataSource.length == 0 && (this._searchbar && $.trim(this._searchbar.val()))) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("EmptyResult")).addClass("e-fe-center");
            else if(this._gridObj.model.dataSource.length == 0) this._gridObj.getContentTable().find(".emptyrecord").html(this._getLocalizedLabels("EmptyFolder")).addClass("e-fe-center");
            this.gridItems = this._gridObj.getRows();
            if (this.model.allowDragAndDrop) {
                this._gridtag.children(".e-gridcontent").addClass("e-droppable");
                this._drag($(this.gridItems));
                $(this.gridItems).addClass("e-file-draggable");
            }
            this._reSizeHandler();
            var gridScrollObj = this._gridObj.getScrollObject();
            if (gridScrollObj && (gridScrollObj.isVScroll() || gridScrollObj.isVScroll())) {
                gridScrollObj.element.ejScroller({ thumbStart: function (e) { proxy._onThumbStart(e); } });
            }
            this._gridtag.attr("tabindex", -1);
            this._gridViewEvents("_off");
            this._gridViewEvents("_on");
            this._gridupdate(this._prevsortingoption);
        },
        _setFilteredContent: function(){
            var rows = this._gridtag.find(".e-gridcontent tr");
            for (var i = 0; i < rows.length; i++) {
                var node = $(rows[i]).find("td:last");
                $(rows[i]).attr("data-parent-path", node.text());
                if (this.model.rootFolderName.length > 0)
                    node.attr("title", this._changeName(node.text(), false));
                else
                    node.attr("title", node.text());
                node.text("/" + node.text().replace(this._rootPath, ""));
            }
        },
        _templateRefresh: function (args) {
            this._trigger("templateRefresh", args);
        },
        _gridActionBegin: function (args) {
            if (args.requestType == "sorting") {
                args.cancel = true;
                    var length = this.model.gridSettings.columns.length;
                    for (i = 0; i < length; i++) {
                        if (args.columnName == this.model.gridSettings.columns[i].field) {
                            this._changeActiveSortedoption(this.model.gridSettings.columns[i].headerText);
                            this._sorting(this._prevsortingoption, this._prevsorting);
                            this._sortingActioncomplete();
                            break;
                        }
                    }
                    if (this._suggestionItems.length && args.columnName == "filterPath") {
                        this.removeSortingIcons();
                        this._suggestionitemsSorting("filterPath", this._prevsorting);
                        this._sortingActioncomplete(); 
                    }
                    this._suggestionItems.length && this._setFilteredContent();
                }
        },
        _gridActionComplete: function (args) {
            this.model.showCheckbox && this._gridCheckboxState(args);
            if (!ej.isNullOrUndefined(this._gridObj)) {
                this._gridupdate(this._prevsortingoption);
            }
        },

        _gridCheckboxState: function (args) {
            var proxy = this;
            this._gridtag.find(".e-headercelldiv:first").html(" <input type='checkbox' id='headchk' />").addClass("e-col-check");
            this._headCheckObj = this._gridtag.find("#headchk").ejCheckBox({showRoundedCorner: proxy.model.showRoundedCorner, change: function (e) { proxy._headCheckChange(e); } }).data("ejCheckBox");
            this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ showRoundedCorner: proxy.model.showRoundedCorner });
            this._gridtag.find(".e-chkbox-wrap").removeAttr("tabindex");
        },
        _checkChange: function (target) {
            if (!target.isInteraction && target.isInteraction != undefined) return;
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            var checkedElements = this._gridtag.find(" .e-gridcontent .e-checkbox:checked");
            var rowCheck = [];
            for (var i = 0 ; i < checkedElements.length; i++) {
                rowCheck.push($(checkedElements[i]).closest("tr").index());
            }
            if (target && !target.type) {
                var index = $.inArray(target.index(), rowCheck);
                target.find(".e-chk-act").length == 1 ? rowCheck.splice(index, 1) : rowCheck.push(target.index());
            }
            this._changeCheckState = false;
            this._gridObj.clearSelection();
            if (rowCheck.length == rows.length)//check if all checkboxes in the current page are checked
                this._gridtag.find("#headchk").ejCheckBox({ "checked": true });
            else
                this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
            this._isClicked = false;
            for (i = 0; i < rowCheck.length; i++) {
                if (true) {
                    this._gridObj.multiSelectCtrlRequest = true;
                    this._gridObj.selectRows(rowCheck[i]);// To prevent unselection of other rows when a checkbox is unchecked after selectAll rows
                }
            }
            this._isClicked = true;
            if (this.model.checked == false) {
                this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
            }
            this._changeCheckState = true;
        },
        _recordClick: function () {
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            for (var i = 0; i < rows.length; i++) {
                if ($.inArray(i, this._gridObj.selectedRowsIndexes) < 0) {
                    $(rows[i]).ejCheckBox({ "checked": false })  //To clear checkbox when we select row by recordclick rather than checkbox
                    this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                    !this._gridObj.multiSelectCtrlRequest && this._unselectEvent();
                }
                else {
                    $(rows[i]).ejCheckBox({ "checked": true });
                    var rowCheck = this._gridtag.find(".e-grid-row-checkbox:checked");
                    if (rowCheck.length == rows.length)
                        this._gridtag.find("#headchk").ejCheckBox({ "checked": true });
                }
            }
        },
        _headCheckChange: function (args) {
            if (!args.isInteraction) return;
            var proxy = this;
            var rows = this._gridtag.find(".e-grid-row-checkbox");
            rows.ejCheckBox({ "change": function (e) { proxy._checkChange(e); } });
            if (this._gridtag.find("#headchk").is(':checked')) {
                rows.ejCheckBox({ "checked": true });
                this._gridObj.selectRows(0, rows.length);  // To Select all rows in Grid Content
            }
            else {
                rows.ejCheckBox({ "checked": false });
                this._setSelectedItems([]); // To remove selection for all rows
                this._unselectEvent();
            }
        },

        _unselectEvent : function(){
            var prevSelecteditems = this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName);
            this._filteredItemsName = [];
            if (this._gridObj && this._gridObj.multiSelectCtrlRequest)
                return;
            if (prevSelecteditems.length > 0 ) {
                this._unselectedItems = [];
                for (var record = 0; record < prevSelecteditems.length; record++) {
                    name = prevSelecteditems[record].name;
                    this._unselectedItems.push(name);
                }

                var index = $.inArray(undefined, this.model.selectedItems), _nodeType;
                $.each(this._fileExplorer[this._originalPath], function (index, value) {
                    if (!value.isFile) _nodeType = "Directory";
                    else _nodeType = "File";
                });
                var data = { name: this._unselectedItems[this._unselectedItems.length - 1], names: this._unselectedItems, path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: prevSelecteditems[prevSelecteditems.length-1], unselectedItems: prevSelecteditems };
                this._trigger("unselect", data);
            }
        },

        _gridViewEvents: function (action) {
            this[action](this._gridtag.find(".e-gridcontent"), "focusin", this._focusGridView);
            this[action](this._gridtag.find(".e-gridcontent"), "focusout", this._blurGridView);
            this[action](this._gridtag.find(".e-gridcontent"), "mousedown", this._mouseSelection);
            this.model.allowDragAndDrop && this._gridDragEvents(action);
        },
        _gridDragEvents: function (action) {
            var gridContent = this._gridtag.children(".e-gridcontent")
            if (gridContent) {
                this[action](gridContent, "dragover", this._onDragOverHandler);
                this[action](gridContent, "drop", this._onDropHandler);
                this[action](gridContent, "dragleave", this._onDragLeave);
                this[action](this._gridtag.find(".e-gridheader"), "dragover", this._preventDropOption);
            }
        },
        _focusGridView: function (e) {
            if (!this._gridtag.find(".e-gridcontent").hasClass("e-focus")) {
                this._gridtag.find(".e-gridcontent").addClass("e-focus");
                this._itemList = [];
                this._on(this._gridtag.find(".e-gridcontent"), "keydown", this._OnKeyUp);
                this._hidePopup();
            }
        },
        _blurGridView: function (e) {
            this._gridtag.find(".e-gridcontent").removeClass("e-focus");
            this._off(this._gridtag.find(".e-gridcontent"), "keydown", this._OnKeyUp);
        },
        _setThumbImageHeight: function () {
            var perRow = this._perRow = 1;
            if (this.items) {
                for (var i = 0; i < this.items.length - 1; i++) {
                    if (this.items[i].getBoundingClientRect().top == this.items[i + 1].getBoundingClientRect().top)
                        perRow++;
                    else
                        break;
                }
                if (!(perRow == null || perRow < 2)) {
                    for (var i = 0, j = this.items.length; i < j; i += perRow) {
                        var maxHeight = 0,
                        row = this.items.slice(i, i + perRow);
                        row.each(function () {
                            var itemHeight = parseInt($(this).find(".e-thumb-image").outerHeight());
                            if (itemHeight > maxHeight) maxHeight = itemHeight;
                        });
                        row.find(".e-thumb-image.e-image").css('height', maxHeight);
                    }
                }
                this._tileScroll && this._tileScroll.refresh();
            }            
            this._perRow = perRow;
        },
        _renderTileView: function (result, path) {
            this._tileView.children() && this._tileView.children().remove() && this._tileView.removeClass("e-tileview");
            this._tileView.appendTo(this._tileContent);
            this._tileView.addClass("e-tileview").attr("role", "tileview");
            var permission = this._getFilePermission(this._currentPath);
            if ((permission) && !(permission.Read)) this._tileView.html(this._getLocalizedLabels("ProtectedFolder")).addClass("e-fe-center");
            else if ((this._searchbar && $.trim(this._searchbar.val())) && result.length == 0) this._tileView.html(this._getLocalizedLabels("EmptyResult")).addClass("e-fe-center");
            else if(result.length == 0) this._tileView.html(this._getLocalizedLabels("EmptyFolder")).addClass("e-fe-center");
            else this._tileView.html("").removeClass("e-fe-center");
            var proxy = this;
            var pathdetail = path;
            var spantag = null;
            $.each(result, function (index, value) {
                var liTag = document.createElement("li"), imageWrapper, imageWrapperinnerDiv, spantag, divtag1, divtag, fname, filenameSpan, fninfo,fTypeSpan,fSizeDiv,fSizeSpan;
                liTag.className += "e-tilenode";
                if (value.filterPath)
                    liTag.setAttribute("data-parent-path", value.filterPath);
                imageWrapper = document.createElement("div");
                imageWrapper.className += "e-align";
                imageWrapperinnerDiv = document.createElement("div");
                imageWrapperinnerDiv.className += "e-thumb-image";
                imageWrapperinnerDiv.className += " e-image";
                imageWrapperinnerDiv.setAttribute("unselectable", "on");
                imageWrapper.appendChild(imageWrapperinnerDiv);
                spantag = document.createElement("span");
                spantag.className += "e-thumbImage";
                spantag.className += " e-fe-icon";
                spantag.setAttribute("unselectable", "on");
                if (value.isFile) {
                    liTag.appendChild(imageWrapper);
                    var extension = value.name.substr(value.name.lastIndexOf('.') + 1).toLowerCase() , extensionClass;                   
                   extensionClass = "e-fe-" + extension;
                   if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(value.name)) {
                       if (proxy.model.showThumbnail) {
                           var path = value.filterPath ? value.filterPath.replace("~", "..") + value.name : (pathdetail ? proxy._originalPath.replace("~", "..") + value.name : proxy._currentPath.replace("~", "..") + value.name);
                           var url = proxy._getImage(path, value.name, proxy.model.enableThumbnailCompress);
                           spantag = document.createElement("img");
                           spantag.className += "e-thumbImage";
                           spantag.setAttribute("unselectable", "on");
                           spantag.setAttribute("src", (url ? url : (path + "?" + (proxy._updateImages[path] ? proxy._updateImages[path] : proxy._initialTime))));
                       } else spantag.className += " e-fe-images";
                   }
                   else if ((/\.(mp3|wav|aac|ogg|wma|aif|fla|m4a)$/i).test(value.name)) spantag.className += " e-fe-audio";
                   else if ((/\.(webm|mkv|flv|vob|ogv|ogg|avi|wmv|mp4|3gp)$/i).test(value.name)) spantag.className += " e-fe-video";
                   else if (!(/\.(css|exe|html|js|msi|pdf|pptx|ppt|rar|zip|txt|docx|doc|xlsx|xls|xml|rtf|php)$/i).test(value.name)) {
                       spantag.className += " e-fe-unknown";
                       spantag.className += " " + extensionClass;
                   }
                   else spantag.className += " " + extensionClass;
                }
                else {
                    liTag.appendChild(imageWrapper);
                    liTag.className += " e-folder";
                    spantag.className += " e-fe-folder";
                    if (value.permission && !value.permission.Read)
                        spantag.className += " e-fe-lock";
                }
                imageWrapperinnerDiv.appendChild(spantag);

                divtag1 = document.createElement("div");
                divtag1.className += "e-name-wrap";
                divtag1.setAttribute("unselectable", "on");

                divtag = document.createElement("div");
                divtag.className += "e-name";
                divtag.className += " e-name-in-wrap";
                divtag.setAttribute("unselectable", "on");

                filenameSpan = document.createElement("span");
                filenameSpan.className += "e-file-info";
                filenameSpan.setAttribute("title", value.name);
                filenameSpan.innerHTML = value.name;

                fname = document.createElement("div");
                fname.className += "e-file-name";
                fname.setAttribute("unselectable", "on");

                
                fname.appendChild(filenameSpan);

                divtag.appendChild(fname);

                if (value.isFile && proxy.model.layout == "tile") {

                    fninfo = document.createElement("div");
                    fninfo.className += "e-file-type";
                    fninfo.setAttribute("unselectable", "on");

                    fTypeSpan = document.createElement("span");
                    fTypeSpan.className += "e-file-info";
                    fTypeSpan.setAttribute("unselectable", "on");
                    fTypeSpan.innerHTML = value.type;

                    fninfo.appendChild(fTypeSpan);

                    fSizeDiv = document.createElement("div");
                    fSizeDiv.className += "e-file-size";
                    fSizeDiv.setAttribute("unselectable", "on");

                    fSizeSpan = document.createElement("span");
                    fSizeSpan.className +="e-file-info";
                    fSizeSpan.setAttribute("unselectable", "on");
                    fSizeSpan.innerHTML = value.size;

                    fSizeDiv.appendChild(fSizeSpan);

                    divtag.appendChild(fninfo);
                    divtag.appendChild(fSizeDiv);
                }
                divtag1.appendChild(divtag);
                liTag.setAttribute("aria-selected", false);
                liTag.setAttribute("title", value.isFile ? value.dateModified + " (" + value.size + ")" : value.dateModified);
                liTag.setAttribute("role", "tileitem");
                if(proxy.model.showCheckbox){
                    var checkBox = document.createElement("input");
                    checkBox.className += "e-tile-checkbox";
                    checkBox.setAttribute("type", "checkbox");
                    $(checkBox).ejCheckBox({ size: "mini", showRoundedCorner: proxy.model.showRoundedCorner });
                    liTag.insertBefore(checkBox.parentNode, liTag.firstChild);
                }
                liTag.appendChild(divtag1);
                proxy._tileView[0].appendChild(liTag);
                proxy._tileView.find(".e-chkbox-wrap").removeAttr("tabindex");
            });
            this._activeItem = 0;
            this.items = this._tileView.children("li.e-tilenode");
            if (this.model.allowDragAndDrop) {
                this._tileViewWrapper.addClass("e-droppable");
                this._drag(this.items);
                this.items.addClass("e-file-draggable");
            }
            this._tileViewEvents("_off");
            this._tileViewEvents("_on");
            this._tileContent.addClass("e-content");
            var _tileHeight = this.model.showFooter ? this._splittag.outerHeight() - this._statusbar.outerHeight() : this._splittag.outerHeight();
            var _tileWidth = parseInt(this._splittag.find(".e-cont2").width());
            if (ej.isNullOrUndefined(this._tileScroll))
                this._tileScroll = this._tileContent.parent(".e-tile-wrapper").ejScroller({ height: _tileHeight, width: _tileWidth, buttonSize: 0, scrollerSize: this._scrollerSize, thumbStart: function (e) { proxy._onThumbStart(e); } }).data("ejScroller");
            else {
                this._tileScroll.option({ "height": _tileHeight, "width": _tileWidth });
                this._tileScroll && this._tileScroll.refresh();
            }
            if (!proxy._tileView.find(".e-image > img").length)
                proxy._setThumbImageHeight();
            else {
                var images = proxy._tileView.find(".e-image > img");
                var increament = 0;
                for (var i = 0; i < images.length; i++) {
                    var img = new Image();
                    img.onload = img.onabort = img.onerror = function (args) {
						if(args){
							++increament == images.length && proxy._setThumbImageHeight();
							var myargs = { path: args.target.src, element: args.target, originalArgs: args, action: "thumbnailPreview" };
							proxy._trigger("getImage", myargs);
						}
                        
                    };
                    img.src = $(images[i]).attr('src');
                }
            }
        },
        _getImage: function (path, name, canCompress) {
            path = path.replace("..", "~");
            var selectedItems = this._getSelectedItemDetails(this._currentPath, name);
            var args = { path: path, canCompress: canCompress, size: (canCompress ? { Height: 104, Width: 116 } : null), selectedItems: selectedItems };
            args.path = this._pathCorrection(args.path);
            if (this._trigger("beforeGetImage", args))
                return "";
            if (this._currentPath.indexOf(":") == 1 || this.model.ajaxSettings.getImage.url || (this._currentPath.startsWith("//") && this.model.path == "/") ) {
                var url = this.model.ajaxAction + "?Path=" + args.path + "&ActionType=GetImage&CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&SelectedItems=" + JSON.stringify(args.selectedItems);
                if (this.model.ajaxSettings.getImage.url) {
                    if (this.model.ajaxSettings.getImage.url.indexOf("{") >= 0)
                        url = String.format(this.model.ajaxSettings.getImage.url, "?CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&Path=" + args.path + "&SelectedItems=" + JSON.stringify(args.selectedItems));
                    else
                        url = this.model.ajaxSettings.getImage.url;
                }
            }
            return url ? url : (canCompress ? this.model.ajaxAction + "?ActionType=GetImage&CanCompress=" + args.canCompress + "&Size=" + JSON.stringify(args.size) + "&Path=" + args.path + "&SelectedItems=" + JSON.stringify(args.selectedItems): "");
        },
        _gridtagClick: function (event) {
            event.stopPropagation();
            if (($(event.target).hasClass("e-gridcontent") || $(event.target).hasClass("e-content") || $(event.target).hasClass("e-table")) && this._selectedRows.length==0) {
                this._addFocus(this._gridtag.find(".e-gridcontent"));
                if (this.model.showCheckbox) {
                    this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                    this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                }
                this._gridObj.clearSelection();
                this._unselectEvent();
                this._updateCurrentPathPermission();
                this._activeSource && this._activeSource.length && this._setSelectedItems(this._activeSource);
            }
            this._activeSource = null;
        },

        _updateGridSelection: function (args) {
            if (args.events && !args.events.ctrlKey && $(args.target)[0] != null) {
                this._gridObj.selectRows($(args.target).closest('td').parent().index(), null, $(args.target).closest('td'));
            }
        },

        _updateTileSelection: function (args) {
            if (args.events && !args.events.ctrlKey && $(args.target)[0] != null) {
                this._triggerClick(args.target);
            }
        },

        _tileViewEvents: function (action) {
            this[action](this.items, "mousedown", this._preventDefaultSelection);
            this[action](this._tileViewWrapper, "mousedown", this._mouseSelection);
            this[action](this.items, (this._isDevice && $.isFunction($.fn.tap)) ? "tap" : "click", this._upDatePathFromTileView);
            this[action](this.items, (this._isDevice && $.isFunction($.fn.tap)) ? "doubletap" : "dblclick", this._openAction);
            this[action](this.items, "mouseenter", this._onItemHover);
            this[action](this.items, "mouseleave", this._onItemLeave);
            this[action](this._tileViewWrapper, "focusin", this._focusTileView);
            this[action](this._tileViewWrapper, "focusout", this._blurTileView);
            this.model.allowDragAndDrop && this._tileDragEvents(action);
        },
        _tileDragEvents: function (action) {
            if (this._tileViewWrapper) {
                this[action](this._tileViewWrapper, "dragover", this._onDragOverHandler);
                this[action](this._tileViewWrapper, "drop", this._onDropHandler);
                this[action](this._tileViewWrapper, "dragleave", this._onDragLeave);
            }
        },
        _preventDefaultSelection: function(event){
            event.shiftKey && event.preventDefault();
        },
        _tileViewWrapperClick: function (event) {
            if ($(event.target).hasClass("e-tile-wrapper") || $(event.target).hasClass("e-tile-content") || $(event.target).hasClass("e-tileview")) {
                this._lastItemIndex = this._lastItemIndex ? this._lastItemIndex : (this._itemList && this._itemList.length > 0 ? this._itemList.filter(".e-active").index() : -1);
                this._addFocus(this._tileViewWrapper);
                if (this.items.hasClass("e-active"))
                    this.items.removeClass("e-active").attr("aria-selected", false);
                this._updateCurrentPathPermission();
                this.model.showCheckbox && this._clearTileCheckBoxSelection();
                this._hidePopup();
                this._activeSource && this._activeSource.length && this._setSelectedItems(this._activeSource);
                this._unselectEvent();
            }
            this._activeSource = null;
        },
        _onItemHover: function (e) {
            var currentItem = e.currentTarget, targetItem = e.target;
            if (!$(currentItem).hasClass("e-disable")) {
                this.items.removeClass("e-hover");
                $(currentItem).addClass("e-hover");
            }
        },
        _onItemLeave: function (e) {
            var currentItem = e.currentTarget, targetItem = e.target;
            if (!$(currentItem).hasClass("e-disable")) {
                $(currentItem).removeClass("e-hover");
            }
        },
        _focusTileView: function (e) {
            if (!this._tileViewWrapper.hasClass("e-focus")) {
                this._tileViewWrapper.addClass("e-focus");
                this._itemList = this.items;
                this._on(this._tileViewWrapper, "keydown", this._OnKeyUp);
                this._on(this._tileViewWrapper, "keydown", this._OnKeyDown);
            }
        },
        _blurTileView: function (e) {
            this._tileViewWrapper.removeClass("e-focus");
            this._off(this._tileViewWrapper, "keydown", this._OnKeyUp);
            this._off(this._tileViewWrapper, "keydown", this._OnKeyDown);
        },
        _OnKeyDown: function (e) {
            var itemsLength = this._itemList.length - 1, activeItem;
            this._activeItem = this._lastItemIndex ? this._lastItemIndex : (this._itemList ? this._itemList.filter(".e-active").index() : -1);
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            switch (code) {
                case 38:
                    e.preventDefault();
                    if ($(e.target).hasClass("e-statusbar")) {
                        this._focusLayout(this.model.layout);
                        return;
                    }
                    if (this._activeItem < this._perRow-1)
                        return;
                    this._activeItem -= this._perRow;
                    this._beforeListHover(e);
                    break;
                case 37:
                    e.preventDefault();
                    if (this._activeItem == 0)
                        return;
                    if ((this._activeItem < 0) || (this._activeItem == null) || (this._activeItem > itemsLength))
                        this._activeItem = 0;
                    else if (this._activeItem == 0)
                        this._activeItem = itemsLength;
                    else
                        this._activeItem -= 1;
                    this._beforeListHover(e);
                    break;
                case 40:
                    e.preventDefault();
                    if (this._activeItem + this._perRow >= this._itemList.length)
                        return;
                    this._activeItem += this._perRow;
                    this._beforeListHover(e);
                    break;
                case 39:
                    e.preventDefault();
                    if (this._activeItem == itemsLength)
                        return;                    
                    if ((this._activeItem > itemsLength) || (this._activeItem == null) || (this._activeItem < 0))
                        this._activeItem = itemsLength;
                    else if (this._activeItem == itemsLength)
                        this._activeItem = 0;
                    else
                        this._activeItem += 1;
                    this._beforeListHover(e);
                    break;
                case 33:
                case 36:
                    e.preventDefault();
                    this._activeItem = 0;
                    this._beforeListHover(e);
                    break;
                case 34:
                case 35:
                    e.preventDefault();
                    this._activeItem = itemsLength;
                    this._beforeListHover(e);
                    break;
            }
            this._lastItemIndex= e.shiftKey ? this._activeItem : null;
        },
        _OnKeyUp: function (e) {
            var activeItem;
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            if (this._KeydownEventHandler(e)) return;
            switch (code) {
                case 13:
                    e.preventDefault();
                    if (e.altKey) {
                        this._lastFocusedElement = e.currentTarget;
                        this._getDetails();
                    }
                    else {
                        e.preventDefault();
                        this._lastFocusedElement = e.currentTarget;
                        if (!$(e.currentTarget).hasClass("e-treeview")) {
                            var isPresent = false;
                            if ($(e.currentTarget).hasClass("e-tile-wrapper"))
                                isPresent = this.items.hasClass("e-active");
                            else if ($(e.currentTarget).hasClass("e-gridcontent"))
                                isPresent = $(this.gridItems).find("td").hasClass("e-active");
                            if (isPresent && this._selectedContent)
                                this._openAction();
                        }
                    }
                    break;
                case 86:
                    if (e.ctrlKey) {
                        e.preventDefault();
                        if (!ej.isNullOrUndefined(this._option) && this._selectedContent) {
                            if (this._currentPath != this._originalPath) {
                                this._currentPath = this._originalPath;
                            }
                            this._lastFocusedElement = e.currentTarget;
                            this._cut_copy();
                        }
                    }
                    break;
                case 46:
                case 67:
                case 68:
                case 88:
                case 113:
                    e.preventDefault();
                    this._lastFocusedElement = e.currentTarget;
                    var isPresent = false;
                    if ($(e.currentTarget).hasClass("e-treeview")) {
                        if (this._rootPath != this._currentPath)
                            isPresent = (this._treetag.find(".e-active").length > 0) ? true : false;
                    }
                    else {
                        if ($(e.currentTarget).hasClass("e-tile-wrapper"))
                            isPresent = this.items.hasClass("e-active");
                        else if ($(e.currentTarget).hasClass("e-gridcontent"))
                            isPresent = $(this.gridItems).find("td").hasClass("e-active");
                    }
                    if (isPresent && this._selectedContent && this._toRead) {
                        if (code == 67 && this._toCopy) {
                            if (e.ctrlKey)
                                this._copyMoveNode("copy");
                        }
                        if (this._toEdit) {
                            switch (code) {
                                case 46:
                                    this._deleteFolder();
                                    break;
                                case 68:
                                    if (e.ctrlKey)
                                        this._deleteFolder();
                                    break;
                                case 88:
                                    if (e.ctrlKey)
                                        this._copyMoveNode("move");
                                    break;
                                case 113:
                                    this._renameFolder();
                                    break;
                            }
                        }
                    }
                    break;
                case 93:
                case 121:
                    if ((e.shiftKey || code == 93) && this.model.showContextMenu) {
                        e.preventDefault();
                        this._lastFocusedElement = e.currentTarget;
                        var pos = null, _target, _element;
                        if ($(e.currentTarget).hasClass("e-treeview")) {
                            _element = this._treeObj.getSelectedNode().find(".e-active");
                            pos = this._getMenuPosition(_element);
                            this._treeMenuObj.show(pos.left, pos.top, _element, e, true);
                        }
                        else {
                            if ($(e.currentTarget).hasClass("e-tile-wrapper")) {
                                for (var i = 0; i < this.items.length; i++) {
                                    _element = $(this.items[i]);
                                    if (_element.text() == this._selectedContent) {
                                        pos = this._getMenuPosition(_element);
                                        _target = _element;
                                        break;
                                    }
                                }
                            } else if ($(e.currentTarget).hasClass("e-gridcontent")) {
                                for (var i = 0; i < this.gridItems.length; i++) {
                                    _element = $(this.gridItems[i]).find("td.e-grid-image").next();
                                    if (_element.text() == this._selectedContent) {
                                        pos = this._getMenuPosition(_element);
                                        _target = _element;
                                        break;
                                    }
                                }
                            }
                            if (pos == null) {
                                pos = $(e.currentTarget).offset();
                                _target = $(e.currentTarget);
                            }
                            this._viewMenuObj.show(pos.left, pos.top, _target, e, true);
                        }
                    }
                    break;
            }
        },
        _KeydownEventHandler: function (e) {
            data = { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e };
            return this._trigger('keydown', data);
        },
        _getMenuPosition: function (element) {
            var height = element.outerHeight() / 2;
            var width = element.outerWidth() / 2;
            var pos = element.offset();
            pos = { top: pos.top + height, left: pos.left + width };
            return pos;
        },

        _beforeListHover: function (args) {
            var activeItem = this._getActiveItem();
            if (!activeItem.hasClass("e-disable")) {
                if ($(args.target).hasClass("e-statusbar")) {
                    this.model.layout = activeItem.hasClass("e-switchGridView") ? ej.FileExplorer.layoutType.Grid : ej.FileExplorer.layoutType.LargeIcons;
                    this._switchLayoutView(this.model.layout);
                    this._addFocus(this._statusbar);
                }
                else {
                    var e = { keyCode: 91, shiftKey: args.shiftKey, innerEvent: true, currentTarget: activeItem[0], target: activeItem[0] };
                    this._upDatePathFromTileView(e);
                }
            }
        },
        _getActiveItem: function () {
            return $($(this._itemList)[this._activeItem]);
        },
        _getURL: function () {
            var url = this.model.ajaxAction + "?Path=" + this._pathCorrection(this._currentPath) + "&ActionType=Upload" + (this._selectedContent ? "&SelectedItems=" + JSON.stringify(this._getSelectedItemDetails(this._getFolderPath(), [this._selectedContent])) : "");
            if (this.model.ajaxSettings.upload.url) {
                if (this.model.ajaxSettings.upload.url.indexOf("{") >= 0)
                    url = String.format(this.model.ajaxSettings.upload.url, "?Path=" + this._pathCorrection(this._currentPath) + (this._selectedContent ? "&SelectedItems=" + JSON.stringify(this._getSelectedItemDetails(this._getFolderPath(), [this._selectedContent])) : ""));
                else
                    url = this.model.ajaxSettings.upload.url;
            }
            return url;
        },

        _renderUploadBox: function () {
            var proxy = this;
            var url = this._getURL();
            this._uploadtag.ejUploadbox({
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                height: "0px",
                width: "0px",
                uploadName: "FileUpload",
                /* For Automatic Upload */
                autoUpload: this.model.uploadSettings.autoUpload,
                showFileDetails: !this.model.uploadSettings.autoUpload,

                dialogText: { title: proxy._getLocalizedLabels("Upload") },
                dialogAction: { modal: true, content: proxy.element },
                showRoundedCorner: this.model.showRoundedCorner,
                extensionsAllow: this.model.fileTypes == "*.*" ? "" : this.model.fileTypes.replace(/\*/g, ""),
                multipleFilesSelection: this.model.uploadSettings.allowMultipleFile,
                fileSize: this.model.uploadSettings.maxFileSize,
                buttonText: { browse: "Upload file" },
                saveUrl: url,
                removeUrl: this.model.ajaxAction + "?Path=" + this._currentPath + "&ActionType=Remove",
                locale: ej.Uploadbox.Locale[this.model.locale] ? this.model.locale : "en-US",
                complete: function (e) { proxy._uploadSuccess(e); },
                remove: function (e) { proxy._uploadSuccess(e); },
                fileSelect: function (e) {
                    !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                    var targetFiles = proxy._fileExplorer[proxy._currentPath];
                    proxy._existingItems = [];
                    var files = proxy._files = e.files;
                    for (var j = 0; j < files.length; j++) {
                        for (var i = 0; i < targetFiles.length; i++) {
                            if (files[j].name == targetFiles[i].name) {
                                proxy._existingItems.push({ Name: files[j].name, Path: proxy._currentPath + files[j].name, IsReplace: true });
                                break;
                            }
                        }
                    }
                    if (proxy._existingItems.length) {
                        proxy._createReplaceConformationDiaolg("_customUpload", "UploadReplaceAlert");
                        e.cancel = true;
                    }
                    proxy._trigger("beforeUploadDialogOpen", e);
                },
                error: function (e) {
                    if (!proxy._alertDialog || !proxy._alertDialog.is(":visible")) {
                        proxy._alertDialog = proxy._createDialog(ej.buildTag('div.e-fe-dialog-label', (e.error ? e.error : e.responseText)), { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error") });
                        proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                    }
                },
                begin: function (e) {
                    var nodes = proxy._currentPath.split('/');
                    var args = { path: proxy._currentPath, selectedItems: proxy._getSelectedItemDetails(proxy._getFolderPath(), nodes[nodes.length - 2]), uploadItemDetails: e.files, url: proxy._getURL() };
                    if (proxy._trigger("beforeUpload", args))
                        e.cancel = true;
                    proxy._uploadtag.ejUploadbox({ saveUrl: args.url });
                },
                cancel: function (e) { proxy._usePreviousValues(); }
            });
        },
        _usePreviousValues: function(){
            if (this._previousPath) {
                this._currentPath = this._previousPath;
                this._selectedContent = this._previousSelectedContent;
                this._previousPath = null;
            }
        },
        _isRestrictedUpload: function (element, text, hoverPath) {
            var path = null;
            if(element.find(".e-fe-lock").length){
                path = hoverPath ? hoverPath : this._getFolderPath(this._updatePath(element, text));
                if (this._fileExplorer[path] && this._fileExplorer[path].length) {
                    for (var i = 0; i < this._fileExplorer[path].length; i++) {
                        if (this._fileExplorer[path][i].name == text && this._fileExplorer[path][i].permission)
                            return !this._fileExplorer[path][i].permission.Upload;
                    }
                }
                return false;
            }
            return false;
        },
        _onDragOverHandler: function (args) {
            var highlightedElement = "";
            var hoverPath = "";
            var element = $(args.target);
            var hoverElementName = element.hasClass("e-js") || element.hasClass("e-tileview") ? "" : element.text();
            args.originalEvent.dataTransfer.dropEffect = "copy";
            args.stopPropagation();
            args.preventDefault();
            if (!element.hasClass("e-file-droppable")) {
                highlightedElement = this._splittag.find(".e-file-droppable");
                highlightedElement && highlightedElement.removeClass("e-file-droppable");                
                if ($(args.currentTarget).hasClass("e-tree-wrapper")) {
                    if (!ej.isNullOrUndefined(element) && element.is('A')) {
                        this._droppableElement = element;
                        this._droppableElement.length && this._droppableElement.addClass("e-file-droppable");
                        var nodeItem = element.closest("li.e-item");
                        if (nodeItem.find(".e-icon").length && !this._treeObj.isExpanded(nodeItem)) {
                            this._expandTimer = window.setTimeout(function () {
                                this._treeObj && this._treeObj.expandNode(nodeItem);
                            }, 800);
                        }
                    }
                    else {
                        args.originalEvent.dataTransfer.dropEffect = "none";
                    }
                }
                else {
                    if (this.model.layout == "grid") {
                        this._droppableElement = element.closest("tr", "table.e-table");
                        if (this._droppableElement.length) {
                            this._droppableElementData = this._gridObj.model.currentViewData[this._gridObj.getIndexByRow(this._droppableElement)];
                            if (this._droppableElementData.isFile) {
                                this._gridtag.find(".e-gridcontent").addClass("e-file-droppable");
                                this._droppableElement = null;
                            }
                        }
                        else
                            this._gridtag.find(".e-gridcontent").addClass("e-file-droppable");
                    }
                    else {
                        this._droppableElement = element.closest("li", ".e-tileview").has(".e-fe-folder");
                        !this._droppableElement.length && this._tileViewWrapper.addClass("e-file-droppable");
                    }
                    this._droppableElement && this._droppableElement.length && this._droppableElement.addClass("e-file-droppable");
                    hoverPath = this._getHoverTreeElementPath(element);
                    if (this._droppableElement && this._droppableElement.length)
                        hoverElementName = (this.model.layout == "grid" ? this._droppableElementData.name : this._droppableElement.find(".e-file-name").text());
                }
            }
            if (this._droppableElement && this._droppableElement.length && this._isRestrictedUpload(this._droppableElement, hoverElementName? hoverElementName: args.target.textContent, hoverPath)) {
                args.originalEvent.dataTransfer.dropEffect = "none";
            }
            var eventArgs = { target: (this._droppableElement && this._droppableElement.length ? this._droppableElement : element), targetElementName: hoverElementName, targetPath: this._getHoverTreeElementPath(element) + hoverElementName };
            this._trigger("drag", eventArgs);
        },

        _getHoverTreeElementPath: function (element) {
            if (element.hasClass("e-text")) {
                return this._updatePath(element, element.text());
            }
            else
            {
                return this._originalPath;
            }
        },

        _onDropHandler: function (args) {
            if ( !args.originalEvent.dataTransfer.files || !args.originalEvent.dataTransfer.files.length)
                return;
            args.stopPropagation();
            args.preventDefault();
            if (this._expandTimer != null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
            this.element.find(".e-file-droppable").removeClass("e-file-droppable");
            var uploadObj = this._uploadtag.ejUploadbox("instance");
            if (this._droppableElement && this._droppableElement.length) {
                this._previousPath = this._currentPath;
                this._previousSelectedContent = this._selectedContent;
                if ($(args.currentTarget).hasClass("e-tree-wrapper")) {
                    this._selectedContent = args.target.text;
                    this._currentPath = this._updatePath($(args.target), this._selectedContent);
                }
                else {
                    this._selectedContent = this.model.layout == "grid" ? this._droppableElementData.name : $(args.target).closest("li", "e-tileview").find(".e-file-name").text();
                    this._currentPath = this._originalPath + this._selectedContent + "/";
                }
            }
            else {
                if (this._droppableElement && !this._droppableElement.length) {
                    if (this._isRestrictedUpload(this._selectedNode, this._selectedTreeText, this._getFolderPath(this._originalPath))) {
                        args.originalEvent.dataTransfer.dropEffect = "none";
                        return null;
                    }
                }
                this._currentPath = this._originalPath;
                this._selectedContent = this._selectedTreeText;
            }
            var eventArgs = { dropAction: "upload", fileInfo: args.originalEvent.dataTransfer.files, target: this._droppableElement && this._droppableElement.length ? this._droppableElement : $(args.currentTarget), targetPath: this._currentPath, targetElementName: this._selectedContent };
            if (this._trigger("dragStop", eventArgs))
                return;
            uploadObj._onDropHandler(args);
            var eventArgs = { dropAction: "upload", fileInfo: args.originalEvent.dataTransfer.files, target: this._droppableElement && this._droppableElement.length ? this._droppableElement : $(args.currentTarget), targetPath: this._currentPath, targetFolder: this._selectedContent };
            this._trigger("drop", eventArgs);
        },
        _onDragLeave: function (args) {
            if (this._expandTimer!= null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
            if (this._gridtag.find(".e-gridcontent").hasClass("e-file-droppable")||$(args.target).hasClass("e-tile-wrapper") || $(args.target).hasClass("e-gridcontent") || ($(args.target).closest(".e-fileexplorer .e-tile-wrapper") || $(args.target).closest(".e-fileexplorer .e-gridcontent")))
                this.model.layout == "grid" ? this._gridtag.find(".e-gridcontent").removeClass("e-file-droppable") : this._tileViewWrapper.removeClass("e-file-droppable");
        },
        _customUpload: function () {
            for (var i = 0; i < this._existingItems.length; i++) {
                if (!this._existingItems[i].IsReplace) {
                    for (var k = 0; k < this._files.length; k++) {
                        if (this._files[k].name == this._existingItems[i].Name) {
                            this._files.splice(k, 1);
                            break;
                        }
                    }
                }
            }
            this._uploadtag.ejUploadbox({ pushFile: this._files });
        },
        _uploadSuccess: function (args) {
            var oldPath = this._currentPath;
            var uploadedItems = [];
            for (var i = 0; i < args.success; i++) {
                uploadedItems.push(args.success[i].name);
            }
            this.element.find(".e-dialog.e-js .e-action-perform").remove();
            this._fileExplorer[this._currentPath] = "";
            this._treeObj.selectNode(this._selectedNode);
            (oldPath == this._currentPath) && this._setSelectedItems(uploadedItems);
        },
        _preventDrag: function () {
            var items = this._treetag.find("li div a");
            items.removeClass("e-file-draggable");
            if (this.gridItems && this.gridItems.length) {
                $(this.gridItems).removeClass("e-file-draggable");
            }
            if (this.items && this.items.length) {
                this.items.removeClass("e-file-draggable");
            }
        },
        _allowDrag: function () {
            this._gridtag.children(".e-gridcontent").addClass("e-droppable");
            this._tileViewWrapper.addClass("e-droppable");
            var unbindedTreeItems = this._treetag.find("li div a").not(".e-js");
            unbindedTreeItems.length && this._drag(unbindedTreeItems);
            var unbindedGridItems = $(this.gridItems).not(".e-js");
            unbindedGridItems.length && this._drag($(this.gridItems));
            var unbindedTileItems = this.items.not(".e-js");
            unbindedTileItems.length && this._drag(unbindedTileItems);
            var items = this._treetag.find("li div a");
            items.addClass("e-file-draggable");
            if (this.gridItems && this.gridItems.length) {
                $(this.gridItems).addClass("e-file-draggable");
            }
            if (this.items && this.items.length) {
                this.items.addClass("e-file-draggable");
            }
        },
        _drag: function (nodes, area) {
            var _clonedElement, _previousDroppable, hoverElementName, _defaultCursor, _targetNode, _preventDrop, _oldElement, hoverPath, proxy = this;
            nodes.ejDraggable(
           {
               dragOnTaphold: true,
               clone: true,
               dragStart: function (args) {
                   var preventMoveFunction = false;
                   proxy._previousElement = proxy._selectedNode;
                   if ($(args.target).hasClass("e-text")) {
                       preventMoveFunction = true;
                       proxy._copiedNodes = [$(args.target).text()];
                       proxy._option = "move";
                       proxy._sourcePath = proxy._getFolderPath(proxy._getHoverTreeElementPath($(args.target)));
                       proxy._sourceType = "Directory";
                       proxy._fileName = $(args.target).text();
                       proxy._refreshNode = $(args.target).closest("li");
                   }
                   else {
                       if (proxy.model.selectedItems.length <= 1) {
                           if (proxy.model.layout == "grid") {
                               proxy._gridObj.selectRows($(args.target).closest("tr").index());
                           }
                           else {
                               proxy._triggerClick(args.target);
                           }
                       }
                   }
                   if (!proxy.model.selectedItems.length) {
                       if ($(args.target).hasClass("e-text")) {
                           hoverElementName = args.target.textContent;
                       }
                       if (args.target && hoverElementName && proxy._isRestrictedMove(args.element, hoverElementName, "")) {
                           _clonedElement.remove();
                           args.cancel = true;
                           return null;
                       }
                   }
                   else {
                       for (var i = 0; i < proxy.model.selectedItems.length ; i++) {
                           if (args.target && proxy._isRestrictedMove(args.element, proxy.model.selectedItems[i], proxy.model.selectedFolder)) {
                               _clonedElement.remove();
                               args.cancel = true;
                               return null;
                           }
                       }
                   }
                   !preventMoveFunction && proxy._copyMoveNode("move");
                   proxy._previousElement.find("a").eq(0).click();
                   var eventArgs = { target: args.element, targetPath: proxy._currentPath, selectedItems: proxy._getSelectedItemDetails(proxy._sourcePath, proxy._fileName) };
                   proxy._trigger("dragStart", eventArgs);
               },
               drag: function (args) {
                   var timeDelay, _oldElement = _targetNode;
                   if (!args.target)
                       return;
                   var target =  $(args.target).closest(".e-droppable", ".e-fileexplorer");
                   if ($(args.target).hasClass("e-droppable")) {
                       _targetNode = $(args.target);
                   }
                   else if (target.length) {
                       _targetNode = target;
                   }
                   else if ($(args.target).hasClass("e-text"))
                       _targetNode = $(args.target).find(".e-droppable");
                   else
                       proxy._clearExpand($(args.target).closest("li.e-item"));
                   document.body.style.cursor = 'no-drop';
                   if (_previousDroppable)
                       _previousDroppable.style.cursor = _defaultCursor;
                   _previousDroppable = args.target;
                   _defaultCursor = args.target.style.cursor;
                   $(_clonedElement).css({ "margin-left": "10px" });
                   if (_targetNode && _oldElement && _targetNode.hasClass("e-draggable")) {
                       if (_targetNode.text() != _oldElement.text()) {
                           var nodeItem = $(args.target).closest("li.e-item");
                           proxy._clearExpand(nodeItem);
                           if (nodeItem && nodeItem.find(".e-icon").length && !proxy._treeObj.isExpanded(nodeItem)) {
                               proxy._expandTimer = window.setTimeout(function () {
                                   proxy._treeObj && proxy._treeObj.expandNode(nodeItem);
                               }, 800);
                           }
                           clearTimeout(timeDelay);
                           timeDelay = setTimeout(function () {
                               if ($(_previousDroppable).hasClass("e-text")) {
                                   proxy._needToScroll($(_previousDroppable).closest("li"), "Tree");
                               }
                               else {
                                   _targetNode && proxy._needToScroll($(_targetNode), "");
                               }
                           }, 100);
                       }
                       args.target.style.cursor = "pointer";
                   }
                   else {
                       args.target.style.cursor = "no-drop";
                   }
                   if ($(_previousDroppable).hasClass("e-text")) {
                       hoverElementName = _previousDroppable.textContent;
                       hoverPath = "";
                   }
                   else {
                       hoverElementName = proxy.model.layout == "grid" ? (_targetNode ? _targetNode.find("[data-cell='" + proxy._gridObj.getColumnByField("name").headerText + "']").text() :"") : (_targetNode ? (_targetNode.hasClass("e-tile-wrapper") ? "" : _targetNode.text()) : "");
                       hoverPath = proxy._getHoverTreeElementPath($(_previousDroppable));
                   }
                   if (_previousDroppable && proxy._isRestrictedMove(_targetNode, hoverElementName, hoverPath)) {
                       args.target.style.cursor = "no-drop";
                       _preventDrop = true;
                   }
                   else
                       _preventDrop = false;
                   if (hoverPath + (hoverElementName ? (hoverElementName + "/") : "") != proxy._sourcePath)
                       args.target.style.cursor = "pointer";
                   var eventArgs = { target: (_targetNode && _targetNode.length ? _targetNode : $(args.target)), targetElementName: hoverElementName, targetPath: (hoverPath ? hoverPath : proxy._originalPath ) + hoverElementName };
                   proxy._trigger("drag", eventArgs);
               },
               dragStop: function (args) {
                   var isWrapper= false;
                   if(proxy.model.layout == "grid"){
                       isWrapper = ($(args.target).hasClass("e-gridcontent") || ($(args.target).find("table").length && $(args.target).closest(".e-gridcontent", ".e-fileexplorer").length));
                   }
                   else{
                       isWrapper = ($(args.target).hasClass("e-tileview") || ($(args.target).find(".e-tileview").length && $(args.target).closest(".e-fileexplorer").length));
                   }
                   if (isWrapper && proxy._sourcePath == proxy._originalPath)
                       proxy._activeSource = proxy.model.selectedItems;
                   if (isWrapper) {
                       proxy._setSelectedItems([]);
                       if (ej.isNullOrUndefined(proxy._copiedNodes) || !args.element.hasClass("e-file-draggable"))
                           return;
                       _clonedElement.hide();
                       proxy.element.find(".e-blur").removeClass("e-blur");
                       if (proxy._currentPath == proxy._sourcePath + proxy._fileName + "/")
                           return;
                       proxy._cut_copy();
                       _clonedElement && _clonedElement.remove();
                   }
                   if (proxy._expandTimer != null) {
                       window.clearTimeout(proxy._expandTimer);
                       proxy._expandTimer = null;
                   }
                   if (_previousDroppable)
                    _previousDroppable.style.cursor = _defaultCursor;
                   document.body.style.cursor = '';
                   proxy.element.find(".e-blur").removeClass("e-blur");
                   if (!args.element.dropped && ((($(args.target).hasClass('e-tree-wrapper') || $(args.target).parents('.e-tree-wrapper').length > 0) && !$(args.target).is('a'))
                       || (!$(args.target).hasClass("e-tile-wrapper") && !$(args.target).parents(".e-tile-wrapper").length > 0 && !$(args.target).hasClass("e-gridcontent") &&
                       !$(args.target).parents(".e-gridcontent").length > 0 && !$(args.target).hasClass('e-tree-wrapper') && !$(args.target).parents('.e-tree-wrapper').length > 0))) {
                       _clonedElement && _clonedElement.remove();
                   }
                   var eventArgs = { dropAction: "move", fileInfo: proxy._getSelectedItemDetails(proxy._sourcePath, proxy._copiedNodes), target: (_targetNode && _targetNode.length ? _targetNode : $(args.target)), targetElementName: proxy._selectedContent, targetPath: proxy._currentPath };
                   proxy._trigger("dragStop", eventArgs);
               },
               helper: function (event, ui) {
                   var _draggedElement, imgTag, innerEle, itemCount;
                   if (!ej.isNullOrUndefined(event.element)) {
                       if (!event.element.hasClass("e-file-draggable")) {
                           event.cancel = true;
                           return null;
                       }
                       if (proxy) {
                           _clonedElement = ej.buildTag('div.e-dragedNode e-fe');
                           var maxZ = ej.util.getZindexPartial(proxy.element);
                           _clonedElement.css({ "z-index": maxZ });
                           _clonedElement.addClass(proxy.model.cssClass + (proxy.model.enableRTL ? ' e-rtl' : ''));
                           _draggedElement = $(event.element).clone().addClass("dragClone");
                           imgTag = _draggedElement.find("img")
                           if (imgTag.length) {
                               innerEle = ej.buildTag('img.e-thumbImage', "", "", { src: imgTag.attr("src") });
                           } else {
                               innerEle = ej.buildTag('span', "", "", { "class": _draggedElement.find(".e-fe-icon").attr("class") });
                           }
                           if (proxy.model.selectedItems.length > 1) {
                               itemCount = ej.buildTag('div.e-count');
                               itemCount.text(proxy.model.selectedItems.length);
                               _clonedElement.append(itemCount);
                           }
                           _clonedElement.append(innerEle);
                           return _clonedElement.appendTo($("body"));
                       }
                   }
               }
           });
            nodes.ejDroppable({
                accept: nodes,
                drop: function (args, ui) {
                    if (_preventDrop || ej.isNullOrUndefined(proxy._copiedNodes) || !ui.draggable.hasClass("e-file-draggable"))
                        return;
                    $(ui.helper).hide();
                    var successCallback = function (preventClick) {
                        !preventClick && proxy._clickTarget(args);
                        if (proxy._currentPath == proxy._sourcePath + proxy._fileName + "/")
                            return;
                        var selectedFileDetails = proxy._getSelectedItemDetails(proxy._sourcePath, proxy._fileName);
                        proxy._cut_copy(true);
                        var eventArgs = { dropAction: "move", fileInfo: selectedFileDetails, target: $(args.dropTarget), targetPath: proxy._currentPath, targetFolder: proxy._selectedContent };
                        proxy._trigger("drop", eventArgs);
                    }
                    if (proxy.model.layout == "grid" && !$(args.dropTarget).hasClass("e-text")) {
                        proxy._gridObj.selectRows($(args.dropTarget).closest("tr").index());
                        successCallback(true);
                    }
                    else {
                        var treePath = proxy._getHoverTreeElementPath($(args.dropTarget));
                        !proxy._fileExplorer[treePath] ? proxy._getFileDetails(treePath, "", "", successCallback) : successCallback();
                    }
                    if ($("body").find('.e-dragedNode').length > 0) $("body").find('.e-dragedNode').remove();
                }
            });
        },

        _clickTarget: function (args) {
            if (!$(args.dropTarget).hasClass("e-text")) {
                if (this.model.layout == "grid") {
                    var index = $(args.dropTarget).closest("tr").index();
                    (index >= 0) ? this._gridObj.selectRows($(args.dropTarget).closest("tr").index()) : $(args.dropTarget).click();
                }
                else
                    this._triggerClick(args.dropTarget);
            }
            else
                this._treeObj && this._treeObj.selectNode(args.dropTarget);
        },

        _triggerClick: function (ele) {
            var tnode = $(ele).closest(".e-tilenode");
            (tnode.length > 0 && this._isDevice && $.isFunction($.fn.tap)) ? $(ele).trigger("tap") : $(ele).click();
        },

        _clearExpand: function (node) {
            if (this._expandTimer != null) {
                window.clearTimeout(this._expandTimer);
                this._expandTimer = null;
            }
        },
        
        _isRestrictedMove: function (element, text, hoverPath) {
            var path = null;
            if (element && element.find(".e-fe-lock").length) {
                path = hoverPath ? hoverPath : this._getFolderPath(this._updatePath(element, text));
                if (this._fileExplorer[path] && this._fileExplorer[path].length) {
                    for (var i = 0; i < this._fileExplorer[path].length; i++) {
                        if (this._fileExplorer[path][i].name == text && this._fileExplorer[path][i].permission)
                            return !this._fileExplorer[path][i].permission.Copy;
                    }
                }
                return false;
            }
            return false;
        },
        _createAddressBar: function () {
            this._addresstag = ej.buildTag('input.e-addressBar e-tool-input', "", {}, { id: this._ExplorerId + '_addressbar', type: "text" });
            this._addresstag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Addressbar").html(""));
            var spanTag = $("<span class='e-fe-icon e-fe-folder'></span>");
            spanTag.insertBefore(this._addresstag);
            ej.browserInfo().name == "msie" && ej.ieClearRemover(this._addresstag[0]);
            this._addressBarEvents("_on");
        },
        _addressBarEvents: function (action) {
            this[action]($('#' + this._ExplorerId + '_addressbar'), "focus", this._inputFocusin);
            this[action]($('#' + this._ExplorerId + '_addressbar'), "keydown", this._searchPath);
            this[action]($('#' + this._ExplorerId + '_addressbar'), "blur", this._addressbarFocusout);
        },
        _inputFocusin: function (e) {
            $(e.target).select();
        },
        _updateAddressBar: function () {
            if (this._addresstag) {
                var temp = this._currentPath;
                if (this.model.rootFolderName.length > 0)
                    this._addresstag.val(temp.replace(this._initPath, "").replace(this._rootFolderName, this.model.rootFolderName));
                else
                    this._addresstag.val(temp.replace(this._initPath, ""));
            }
        },
        _onEpand: function (args) {
            if (this._splitObj.element.find(".e-cont1").hasClass("collapsed")) {
                if (this._splitIcon && this._splitIcon.find('.e-icon').hasClass("e-arrow-sans-left"))
                    this._splitIcon.find('.e-icon').addClass('e-arrow-sans-right').removeClass("e-arrow-sans-left");
            }
            else {
                if (this._splitIcon && this._splitIcon.find('.e-icon').hasClass("e-arrow-sans-right"))
                    this._splitIcon.find('.e-icon').addClass('e-arrow-sans-left').removeClass("e-arrow-sans-right");
            }
            this._reSizeHandler(args);
        },
        _createSplitPane: function () {
            var proxy = this;
            var pane1 = ej.buildTag('div');
            var pane2 = ej.buildTag('div');
            this._splittag = ej.buildTag('div#' + this._ExplorerId + '_splitter');
            pane1.addClass('e-cont1');
            pane2.addClass('e-cont2');
            this.model.enableRTL ? this._splittag.append(pane2, pane1) : this._splittag.append(pane1, pane2);
            var panesize = this.model.enableRTL ? [{}, { paneSize: this._isMobileOrTab ? "150px" : "25%" }] : [{ paneSize: this._isMobileOrTab ? "150px" : "25%" }, {}];
            this.element.append(this._splittag);
            this._splitObj = this._splittag.ejSplitter({
                enableAutoResize: true,
                animationSpeed: 50,
                width: "100%",
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                allowKeyboardNavigation: this.model.allowKeyboardNavigation,
                height: this.element.height() - (this._toolBarItems ? this._toolBarItems.outerHeight() : 0),
                properties: panesize,
                expandCollapse: function (e) { proxy._onEpand(e); },
                resize: function (e) { proxy._reSizeHandler(e); }
            }).data('ejSplitter');
            var splitbar = this._splitObj.element.find(".e-splitbar");
            var borderWidth = splitbar.css("border-width");
            var splitterWidth = splitbar.css("width");
            splitbar.css({"width" : "0px", "border-width": "0px" });
            this._splitObj.refresh();
            splitbar.css({ "width": splitterWidth, "border-width": borderWidth });
            this._renderSplitIcon();
            var treeWrapper = ej.buildTag('div.e-tree-wrapper');
            pane1.append(treeWrapper);
            this._treetag = ej.buildTag('div#' + this._ExplorerId + '_treeView');
            treeWrapper.append(this._treetag);
            this._gridtag = ej.buildTag('div#' + this._ExplorerId + '_grid');
            pane2.append(this._gridtag);
            this._tileViewWrapper = ej.buildTag('div.e-tile-wrapper' + "#" + this._ExplorerId + '_tileWrapper', "", "", { tabindex: 0 });
            if (this.model.layout == "tile")
                this._tileViewWrapper.addClass("e-tileInfo-view");
            pane2.append(this._tileViewWrapper);
            this._tileViewWrapper.append("<div class='e-tile-content' > </div>");
            this._tileContent = this._tileViewWrapper.find(".e-tile-content");
            this._tileView = ej.buildTag('ul#' + this._ExplorerId + '_tileView');
            this._tileContent.append(this._tileView);

            this._statusbar = ej.buildTag('div', "", "", { tabindex: 0 });
            this._statusbar.insertAfter(this._tileView);
            pane2.append(this._statusbar);
            this.model.showFooter && this._createStatusBar();
            this._waitingPopup = this._splittag.find(".e-cont2").ejWaitingPopup({ showOnInit: false, cssClass: this.model.cssClass }).data("ejWaitingPopup");
            this._showHideSplitBar(false);
            this._showHideContextMenu();
            if (this.model.layout == "grid") {
                this._tileContent.parent().hide();
            }
            else {
                this._gridtag.hide();
            }
            this._createUploadBox();

        },
        _selectedFolder: function (targetNavigationPath) {
            var navigationPath = targetNavigationPath.replace(this._initPath, "");
            var selectedNode = this._treeObj.getSelectedNode();          
            var folders = navigationPath.split("/");
            var newFolders = folders.filter(function (val) { return val != ""; });
            if (newFolders.length > 1) this._isClicked = false;
            navigationPath && this._treeObj.selectNode(this._treeObj.element.find("li:first"));
            for (var j = 0; j < folders.length; j++) {
                if (folders[j] != "") {
                    selectedNode = this._treeObj.getSelectedNode();
                    if (!this._treeObj.isExpanded(selectedNode))
                        this._treeObj && this._treeObj.expandNode(selectedNode);
                    var childItems = selectedNode.find('ul:first>li').find('div:first .e-text');
                    for (var i = 0; i < childItems.length; i++) {
                        if ($(childItems[i]).text() == folders[j]) {
                            if (newFolders[newFolders.length - 1] == $(childItems[i]).text())
                                this._isClicked = true;
                            this._treeObj.selectNode(childItems[i].parentNode.parentNode);
                        }
                    }
                }
            }
            this._isClicked = true;
        },
        _setSelectedItems: function (selectedItems) {
            var realName;
            if (this._suggestionItems.length) {
                realName = selectedItems;
                selectedItems = this._selectedItems;
            }
            if (typeof selectedItems == "string")
                selectedItems = [selectedItems];
            this._removeOldSelectionDetails();
            if (this.model.layout == "grid") {
                this._gridObj.clearSelection();
                var _ctrlKey = this._gridObj.multiSelectCtrlRequest;
                this._gridObj.multiSelectCtrlRequest = true;
                var nodes = this._gridtag.find(".e-gridcontent tr");
                for (var j = 0; j < selectedItems.length; j++) {
                    var nodes = $("#" + this._ExplorerId + " .e-gridcontent td:contains(" + (realName ? realName[j] : selectedItems[j]) + ")");
                    for (var i = 0; i < nodes.length; i++) {
                        if (this._suggestionItems.length ? this._originalPath + selectedItems[j] == $(nodes[i]).closest("tr").attr("data-parent-path") + $(nodes[i]).text()  : selectedItems[j] == $(nodes[i]).text()) {
                            this._gridObj.selectRows($(nodes[i]).closest("tr").index());
                            break;
                        }
                    }
                }
                this._recordClick();
                this._gridObj.multiSelectCtrlRequest = _ctrlKey;
            }
            else {
                this.items.removeClass("e-active").attr("aria-selected", false);
                var nodes = this._tileView.find(".e-tilenode");
                for (var j = 0; j < selectedItems.length; j++) {
                    for (var i = 0; i < nodes.length; i++) {
                        var name = this.model.layout == "tile" ? $(nodes[i]).find(".e-file-name").text() : $(nodes[i]).text();
                        if (this._suggestionItems.length ? this._originalPath + selectedItems[j] == $(nodes[i]).attr("data-parent-path") + name : selectedItems[j] == name) {
                            var e = { keyCode: 91, ctrlKey: true, currentTarget: nodes[i], target: nodes[i] };
                            this._upDatePathFromTileView(e);
                            break;
                        }
                    }
                }
            }
        },
        _refreshTreeScroller: function (args) {
            if (ej.isNullOrUndefined(this.element)) return;
            if (this.model.enableRTL) {
                this._treeScroll.model.scrollLeft = 0;
            }
            this._treeScroll && this._treeScroll.refresh();
        },
        _createStatusBar: function () {
            this._statusbar.addClass("e-statusbar");
            this._itemStatus = ej.buildTag('div.e-itemStaus');
            this._selectedItemsTag = ej.buildTag('div.e-itemStaus e-selected-items');
            this._switchBtn = ej.buildTag('div.e-switchView');
            this._statusbar.append(this._switchBtn, this._itemStatus, this._selectedItemsTag);
            if (this.model.enableResize) {
                this._resizeItem = ej.buildTag("div.e-icon e-fe-resize e-resize-handle");
                this._resizeItem.insertBefore(this._switchBtn);
            }
            var setHeight = this._splittag.find(".e-cont2").outerHeight() - this._statusbar.outerHeight();
            this._gridtag.height(setHeight);
            var button = ej.buildTag('button.e-switchGridView#' + this._ExplorerId + '_switchGridView', "", {}, { title: this._getLocalizedLabels("Grid"), tabindex: 0 });
            this._switchBtn.append(button);
            button.ejButton({ type: "button",  size: "normal", contentType: "imageonly", prefixIcon: "e-icon e-fe-grid" });
            button = ej.buildTag('button.e-swithListView#' + this._ExplorerId + '_swithListView', "", {}, { title: this._getLocalizedLabels("LargeIcons"), tabindex: 0 });
            this._switchBtn.append(button);
            button.ejButton({ type: "button",  size: "normal", contentType: "imageonly", prefixIcon: "e-icon e-fe-largeicons" });
            this.model.layout == "grid" && this._statusbar.find(".e-switchGridView").addClass("e-active");
            this.model.layout == "largeicons" && this._statusbar.find(".e-swithListView").addClass("e-active");
            this._statusBarEvents("_off");
            this._statusBarEvents("_on");
        },
        _statusBarEvents: function (action) {
            this[action](this._statusbar, "focus", this._focusStatusBar);
            this[action](this._statusbar.find("button"), "focus", this._focusStatusBarButton);
            this[action](this._statusbar.find("button"), "blur", this._blurStatusBarButton);
            this[action](this._statusbar, "blur", this._blurStatusBar);
            this.model.allowDragAndDrop && this[action](this._statusbar, "dragover", this._preventDropOption);
        },
        _focusStatusBar: function (e) {
            if (!this._statusbar.hasClass("e-focus")) {
                this._statusbar.addClass("e-focus");
                this._itemList = this._switchBtn.find("button");
                this._on(this._statusbar, "keydown", this._OnKeyDown);
                this._hidePopup();
            }
        },
        _focusStatusBarButton: function(args){
            this._on(this._statusbar.find("button"), "keydown", this._check);
        },
        _blurStatusBarButton: function (args) {
            this._off(this._statusbar.find("button"), "keydown", this._check);
        },
        _blurStatusBar: function (e) {
            this._statusbar.removeClass("e-focus");
            this._off(this._statusbar, "keydown", this._OnKeyDown);
        },
        _check: function (args) {
			var changed;
			if (this.model.layout == ej.FileExplorer.layoutType.Grid) {
                this.model.layout = ej.FileExplorer.layoutType.LargeIcons;
                changed = true;
            }
			else if (this.model.layout == ej.FileExplorer.layoutType.LargeIcons) {
                this.model.layout = ej.FileExplorer.layoutType.Grid;
                changed = true;
			}
			if (changed) {
                this._switchLayoutView();
            }
        },
        _refreshResizeHandler: function () {
            this._setMinMaxSizeInInteger();
            this.adjustSize();
            if (this.model.showFooter && this.model.enableResize)
                this._resizeFileExplorer();
        },
        _refreshResizeEventHandler: function (event) {
            var reElement = $(event.element).parents("div.e-fileexplorer");
            this.model.height = $(reElement).outerHeight();
            this.model.width = $(reElement).outerWidth();
            this.element.css({ "height": this.model.height, "width": this.model.width });
            this.adjustSize();
        },
        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },
        _getProperValue: function (value) {
            if (value == null) return null;
            else return !isNaN(value) ? value : value;
        },
        _setMinMaxSizeInInteger: function () {
            var parentObj;
            this._minWidth = parseInt(this.model.minWidth);
            this._minHeight = parseInt(this.model.minHeight);
            this._maxWidth = parseInt(this.model.maxWidth);
            this._maxHeight = parseInt(this.model.maxHeight);
            parentObj = this.element.parent()[0].nodeName == "BODY" ? $(window) : $(this.element.parent()[0]);
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                this._minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), this._minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                this._minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), this._minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                this._maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), this._maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                this._maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), this._maxHeight);
        },
        _resizeFileExplorer: function () {
            var proxy = this;
            this.element.find("div.e-fe-resize").ejResizable(
                {
                    minHeight: proxy._minHeight,
                    minWidth: proxy._minWidth,
                    maxHeight: proxy._maxHeight,
                    maxWidth: proxy._maxWidth,
                    resizeStart: function (event) {
                        proxy._trigger("resizeStart", { event: event });
                    },
                    resize: function (event) {
                        proxy._refreshResizeEventHandler(event);
                        proxy._trigger("resize", { event: event });                       
                    },
                    resizeStop: function (event) {
                        proxy._refreshResizeEventHandler(event);
                        proxy._trigger("resizeStop", { event: event });
                    },
                    helper: function (event) {
                        return $(proxy.element);
                    }
                });
        },
        _showHideSplitBar: function (option) {
            this._splittag.show();
            if (this._splitObj.model.properties[1].paneSize == 0) {
                this.element.find(".e-splitbar").show();
                this._splitObj.expand(1);
                if (!this._gridtag.hasClass("e-grid") && option) {
                    this._updateData();
                }
            }
            else if (this._splitObj.model.properties[0].paneSize == 0) {
                this.element.find(".e-splitbar").show();
                this._splitObj.expand(0);
                this._treetag.parent(".e-tree-wrapper").css("display", "block");
            }
            if (!this.model.showNavigationPane) {
                this.model.enableRTL?this._splitObj.collapse(1):this._splitObj.collapse(0);
                this.element.find(".e-splitbar").hide();
                if (!this._gridtag.hasClass("e-grid") && option) {
                    this._updateData();
                }
            }
        },
        _updateTreePath: function (args) {
            this._suggestionItems = [];
            this._toDownload = false; this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._removeBlurEffect();
            this._searchbar && this._searchbar.val("");
            if (this.model.rootFolderName.length > 0 && args.value == this.model.rootFolderName && this._treeObj.element.find('li:first > div > .e-text').hasClass("e-active"))
                this._selectedTreeText = this._selectedContent = this._rootFolderName;
            else
                this._selectedTreeText = this._selectedContent = args.value;
            this._selectedNode = args.currentElement;
            var node = $(this._selectedNode.parents('li.e-item')[0]);
            this._parentNode = node.length != 0 ? node : this._selectedNode;
            this._nodeType = "Directory";
            if (this._initUpdate) {
                this._currentPath = this._updatePath(args.currentElement, args.value);
            } else
                this._initUpdate = true;            
            this._updateOnNodeSelection && this._updateData();
            this._originalPath = this._currentPath;
            if (!this._isStateNavigation) {
                if (!ej.isNullOrUndefined(this._currentState)) {
                    for (var i = this._selectedStates.length - 1; i > this._currentState; i--)
                        this._selectedStates.pop();
                    this._toolBarItems && this._disableToolbarItem("Forward");
                }
                if (this._selectedStates[this._selectedStates.length - 1] != this._originalPath) {
                    this._currentState = this._selectedStates.length;
                    this._selectedStates.push(this._originalPath);
                    this._selectedStates.length == 2 && this._toolBarItems && this._enableToolbarItem("Back");
                }
            }
            this._updateAccessRules(this._originalPath);
            this._updateToolbarItems();
            this._updateNewFolderTool(this._toRead && this._toEditContents);
            if (!node.length) {
                this._disableEditingTools();
                this._toolBarItems && this._disableToolbarItem("Copy");
            }
            this.model.selectedFolder = this._currentPath;
            this._updateAddressBar();
            this._currntNode = this._selectedNode.find("> div > .e-text");
            this.model.selectedItems = [];
            this._filteredItemsName = [];
            this._selectedItems = [];
            this._selectedTileItems = [];
            var parentPath = this._getFolderPath();
            if (this._isClicked && !this._isTileViewClick && !this._isGridViewClick) {
                var args = { name: [args.value], names: [args.value], path: parentPath, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(parentPath, this._selectedContent) };
                this._trigger("select", args);
            }
            if (this._isTileViewClick) this._isTileViewClick = false;
            if (this._isGridViewClick) this._isGridViewClick = false;
        },
        _modifySelectedStates: function (startsWith, replace) {
            var proxy = this;            
            $.each(proxy._selectedStates, function (index, path) {
                if (path && path.startsWith(startsWith))
                    proxy._selectedStates[index]= (replace ? proxy._selectedStates[index].replace(startsWith, replace): replace);                                                            
            });            
        },
        _onBeforeCollapse: function (args) {           
           this._collapse = true;
        },
        _updatePath: function (node, val) {
            var parentPath = "";
            var unnecesaryULtags = 1;
            for (var i = 0; i < node.parents("ul").length - unnecesaryULtags; i++) {
                if ($(node.parents("ul")[i]).siblings("div").find("a").text())
                    parentPath = $(node.parents("ul")[i]).siblings("div").find("a").text() + "/" + parentPath;
            }
            if (this.model.rootFolderName.length > 0)
                return this._changeName(this._initPath + parentPath + val + "/", true);
            else
                return this._initPath + parentPath + val + "/";
        },
        _updatePathFromGrid: function (args) {
            if (!(this._searchbar && $.trim(this._searchbar.val())))
                this._suggestionItems = [];
            if (this.model.showCheckbox && this._changeCheckState) {
                if (!this.model.allowMultiSelection) {
                    this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                }
                $(args.target).closest(".e-chkbox-wrap").length && this._checkChange(args.row);
                if ((args.target && $(args.target).closest(".e-chkbox-wrap").length == 0) || ej.isNullOrUndefined(args.target))
                    this._recordClick();
            }
            this._FilteredFiles = [];
            var proxy = this, target = $(args.target).closest("td.e-rowcell");
            this._addFocus(this._gridtag.find(".e-gridcontent"));
            var isFolder, _isUpdate = true;
            this._toDownload = this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._isTreeNode = false;
            var _childItems;
            this._selectedItems = [];
            var sizeInByte = 0;
            this._selectedRecords = this._gridtag.ejGrid("getSelectedRecords");
            var index = $.inArray(undefined, this._selectedRecords);
            if (index > -1)
                this._selectedRecords.splice(index, 1);
            for (var record = 0; record < this._selectedRecords.length; record++) {
                if (this._suggestionItems && this._suggestionItems.length) {
                    name = this._selectedRecords[record].filterPath.replace(this._originalPath, "") + this._selectedRecords[record].name;
                    this._selectedItems.push(name);
                    var filename = this._selectedRecords[record].filterPath + this._selectedRecords[record].name;
                    if ($.inArray(filename, this._FilteredFiles) < 0) this._FilteredFiles.push(this._selectedRecords[record].filterPath + this._selectedRecords[record].name);
                }
                else
                    this._selectedItems.push(this._selectedRecords[record].name);
                sizeInByte += this._selectedRecords[record].sizeInByte;
                if (!this._selectedRecords[record].isFile) {
                    _isUpdate = false;
                    this._toDownload = false;
                }
                this._updateAccessValue(this._selectedRecords[record]);
            }
            if (this._currentPath != this._originalPath) {
                this._currentPath = this._originalPath;
            }
            $.each((proxy._suggestionItems.length > 0 ? proxy._suggestionItems : proxy._fileExplorer[proxy._originalPath]), function (index, value) {
                if (value.name == args.data.name && !value.isFile)
                    isFolder = true;
            });
            if (isFolder) {
                this._nodeType = "Directory";
                if (target.hasClass('e-active'))
                    this._updateNode(args.data.name);
            }
            else {
                this._nodeType = "File";
            }
            var _nodeType = this._nodeType;
            this._currntNode = target[0] != null && target.parent("tr");
            this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
            if (!target.hasClass('e-active') && this._selectedRecords.length > 0) {
                this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
                this._nodeType = this._selectedRecords[this._selectedRecords.length - 1].isFile ? "File" : "Directory";
                if (this._nodeType == "Directory")
                    this._updateNode(this._selectedContent);
            }
            this._selectedItemsTag && this._selectedItemsTag.html((this._selectedItems.length > 0 ? (this._selectedItems.length + " " + (this._selectedItems.length > 1 ? this._getLocalizedLabels("Items") : this._getLocalizedLabels("Item")) + " " + this._getLocalizedLabels("Selected")) : "") + (sizeInByte ? (_isUpdate ? "  " + this._bytesToSize(sizeInByte) : "") : ""));
            this._setFilteredItemsName();
            this.model.selectedItems = this._filteredItemsName;
            var data = { name: this._selectedItems, names: this._selectedItems, path: this.model.selectedFolder, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName) };
            this._urlTag && this._urlTag.find("input").val(data.path);
            this._nameTag && this._nameTag.find("input").val(data.name);
            this._updateSelectionDetails(this._nodeType);
            if (this._isClicked)
                if (!args.target || (target && target.hasClass("e-active")))
                    this._trigger("select", data);
                else {
                    var name = (this._suggestionItems && this._suggestionItems.length) ? (args.data.filterPath.replace(this._originalPath, "") + args.data.name) : args.data.name;
                    var data = { name: name, names: [name], path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: args.data, unselectedItems: [args.data] };
                    this._trigger("unselect", data);
                }
        },
        _enableEditingTools: function () {
            if (!this._editingToolsState && this._toolBarItems) {
                var items = ["Rename", "Delete", "Cut"];
                for (var i = 0; i < items.length; i++) {
                    this._enableToolbarItem(items[i]);
                }
                this._editingToolsState = true;
            }
        },
        _enableToolbarItem: function (suffixID) {
            if (this._restrictedToolbarOptions.indexOf(suffixID) < 0)
            {
                var id = this._ExplorerId + suffixID.replace(/ /g, '');
                if (this._toolBarObj && this._toolBarObj.itemsContainer.find("li#" + id).hasClass("e-disable"))
                    this._toolBarObj.enableItemByID(id);
            }            
        },
        _disableToolbarItem: function (suffixID) {
            var id = this._ExplorerId + suffixID.replace(/ /g, '');
            if (this._toolBarObj && !this._toolBarObj.itemsContainer.find("li#" + id).hasClass("e-disable"))
                this._toolBarObj.disableItemByID(id);
        },

        _disableEditingTools: function () {
            if (this._toolBarItems) {
                var items = ["Rename", "Delete", "Cut"];
                for (var i = 0; i < items.length; i++) {
                    this._disableToolbarItem(items[i]);
                }
                this._editingToolsState = false;
            }
        },
        _clearTileCheckBoxSelection: function () {
            if (this.model.showCheckbox) {
                this._tileView.find(".e-tile-checkbox ").ejCheckBox({ "checked": false });
            }
        },
        _upDatePathFromTileView: function (event) {
            var $target = $(event.target);
            if (event["pointerType"] == "touch" && this._customPop != null && this.model.allowMultiSelection) {
                if (!this._customPop.is(":visible"))
                    this._customPop.show();
                if (this._customPop.is(":visible") && !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) {
                    var offset = $target.offset();
                    this._customPop.offset({ left: offset.left - 40, top: offset.top - 40 });
                }
                else
                    event.ctrlKey = true;
            }
            else
                this._hidePopup();
            if (!(this._searchbar && $.trim(this._searchbar.val())))
                this._suggestionItems = [];
            if (!event.innerEvent)
                this._lastItemIndex = $(event.currentTarget).index();
            this._addFocus(this._tileViewWrapper);
            this._isTreeNode = false;
            var proxy = this;
            var checkboxObj;
            if(this.model.showCheckbox){
                checkboxObj = $(event.target).closest(".e-tilenode").find(".e-tile-checkbox").data("ejCheckBox");
                if ($(event.target).hasClass("e-chk-image"))
                    event.ctrlKey = this.model.showCheckbox;
            }
            if (!event.shiftKey) {
                var _unselectedItem = [];
                if ((!event.ctrlKey || !this.model.allowMultiSelection) && this.element.find(".e-fe-selection-rect").length <= 0) {
                    this._sizeInByte = 0;
                    this._selectedItems = [];
                    this._selectedTileItems = [];
                    $(event.currentTarget).siblings().removeClass("e-active").attr("aria-selected", false);
                    $(event.currentTarget).removeClass("e-active").attr("aria-selected", false);
                    this._clearTileCheckBoxSelection();
                    this._unselectEvent();
                }
                if ($(event.currentTarget).hasClass("e-active")) {
                    $(event.currentTarget).removeClass("e-active").attr("aria-selected", false);
                    checkboxObj && checkboxObj.option("checked", false);
                }
                else {
                    $(event.currentTarget).addClass("e-active").attr("aria-selected", true);
                    checkboxObj && checkboxObj.option("checked", true);
                }
                var nodeType = "File", _childItems, _isUpdate = true;
                this._toDownload = this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
                var name = $(event.currentTarget).find(".e-file-name").text();
                if (this._currentPath != this._originalPath) {
                    this._currentPath = this._originalPath;
                }
                var items = this._suggestionItems.length ? this._suggestionItems : this._fileExplorer[this._originalPath];
                if (items) {
                    for (var i = 0; i < items.length; i++) {
                        if ((this._suggestionItems < 1 && items[i].name == name) || (this._suggestionItems.length > 0 && items[i].filterPath == $(event.currentTarget).attr('data-parent-path') && items[i].name == name)) {
                            if ($(event.currentTarget).hasClass("e-active")) {
                                this._sizeInByte += items[i].sizeInByte;
                                this._selectedTileItems.push(items[i]);
                            } else if (event.ctrlKey) {
                                this._sizeInByte -= items[i].sizeInByte;
                                var index = $.inArray(items[i], this._selectedTileItems);
                                if (index > -1) {
                                    _unselectedItem.push(this._selectedTileItems[index]);
                                    this._selectedTileItems.splice(index, 1);
                                }
                            }
                            break;
                        }
                    }
                }
                $.each(this._selectedTileItems, function (index, value) {
                    if (!value.isFile) {
                        proxy._update = false;
                        _isUpdate = false;
                        proxy._toDownload = false;
                    }
                    proxy._updateAccessValue(value);
                });

                this._FilteredFiles = [];
                for (var i = 0; i < this._selectedTileItems.length; i++) {
                    this._FilteredFiles.push(this._selectedTileItems[i].filterPath + this._selectedTileItems[i].name)
                }

                if ($(event.currentTarget).find(".e-fe-folder").length) {
                    nodeType = "Directory";
                    if ($(event.currentTarget).hasClass("e-active"))
                        this._updateNode(name);
                }
                this._currntNode = $(event.currentTarget);
                if (this._currntNode.attr("data-parent-path")) {                    
                    name = this._currntNode.attr("data-parent-path").replace(this._originalPath, "") + name;
                }                
                this._selectedContent = name;
                if ($(event.currentTarget).hasClass("e-active"))
                    this._selectedItems.push(this._selectedContent);
                else {
                    var index = $.inArray(this._selectedContent, this._selectedItems), _unselectedContent = this._selectedContent, _nodeType = nodeType;
                    if (index > -1)
                        this._selectedItems.splice(index, 1);
                    if (this._selectedTileItems.length > 0) {
                        this._selectedContent = this._selectedItems[this._selectedItems.length - 1];
                        nodeType = this._selectedTileItems[this._selectedTileItems.length - 1].type;
                        if (nodeType == "Directory")
                            this._updateNode(this._selectedContent);
                    }
                }                
                if ((!this._startNode) || this._selectItems.length == 0 || this._selectItems.length == this._selectedItems.length) {
                    if (!this._selectItems || this._selectItems.length <= 0)
                        this._startNode = null;
                    this._selectedItemsTag && this._selectedItemsTag.html((this._selectedItems.length > 0 ? (this._selectedItems.length + " " + (this._selectedItems.length > 1 ? this._getLocalizedLabels("Items") : this._getLocalizedLabels("Item")) + " " + this._getLocalizedLabels("Selected")) : "") + (this._sizeInByte ? (_isUpdate ? "  " + this._bytesToSize(this._sizeInByte) : "") : ""));
                    this._nodeType = nodeType;
                    this._setFilteredItemsName();
                    this.model.selectedItems = this._filteredItemsName;
                    var args = { name: this._selectedItems, names: this._selectedItems, path: this.model.selectedFolder, nodeType: this._nodeType, selectedItems: this._getSelectedItemDetails(this.model.selectedFolder, this._filteredItemsName) };
                    this._urlTag && this._urlTag.find("input").val(args.url);
                    this._nameTag && this._nameTag.find("input").val(args.name);
                    this._updateSelectionDetails(this._nodeType);
                    if (this._isClicked)
                        if ($(event.currentTarget).hasClass("e-active"))
                            this._trigger("select", args);
                        else {
                            var args = { name: _unselectedContent, names: [_unselectedContent], path: this.model.selectedFolder, nodeType: _nodeType, unselectedItem: _unselectedItem[0], unselectedItems: _unselectedItem };
                            this._trigger("unselect", args);
                        }
                    this._selectItems = [];
                }                
            } else {
                this._selectItems = [];
                if (!this._startNode)
                    this._startNode = this._currntNode;
                var startIndex = $(event.currentTarget).index();
                var endIndex = this._startNode.index();
                if (startIndex > endIndex) {
                    var temp = startIndex;
                    startIndex = endIndex;
                    endIndex = temp;
                }
                var items = this._tileContent.find(".e-tilenode");
                items.removeClass("e-active").attr("aria-selected", false);
                for (var i = startIndex ; i <= endIndex; i++) {
                    this._selectItems.push($(items.get(i)).find(".e-file-name").text());
                }
                this._setSelectedItems(this._selectItems);
            }
        },
        _setFilteredItemsName: function () {
            this._filteredItemsName = [];
            for (var i = 0; i < this._selectedItems.length; i++) {
                var names = this._selectedItems[i].split('/');
                this._filteredItemsName.push(names[names.length - 1] ? names[names.length - 1] : names[names.length - 2]);
            }
        },
        _getOriginalName: function(path){
            var names = path.split('/');
             return (names[names.length - 1] ? names[names.length - 1] : names[names.length - 2]);
        },
        _updateNode: function (name) {
            this._currentPath += name + "/";
        },
        _getFileURL: function () {
            if (this._nodeType == "File") {
                if ((/\.(gif|jpg|jpeg|tiff|png|bmp)$/i).test(this._selectedContent)) {
                    this._widthTag && this._widthTag.show().removeClass("e-hide");
                    this._heightTag && this._heightTag.show().removeClass("e-hide");
                } else {
                    this._widthTag && this._widthTag.hide().addClass("e-hide");
                    this._heightTag && this._heightTag.hide().addClass("e-hide");
                }
                return (this._currentPath.replace("~", "..") + this._selectedContent);
            }
            else
                return "";
        },
        _updateData: function () {
            var data = this._fileExplorer[this._currentPath];
            this._selectedItemsTag && this._selectedItemsTag.html("");
            if (data && !this._update) {
                this._itemStatus && this._itemStatus.html(data.length + " " + (data.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
                var sortingoption = this.model.gridSettings.columns[0];
                var sortingtype = true;
                var initialsort = true;
                this._changeActiveSortedoption(sortingoption.headerText, initialsort);
                this._sorting(sortingoption.field, sortingtype, data);
                var details = this._sorteditems;
                this.model.layout == "grid" ? this._renderGridView(details) : this._renderTileView(details);
            }
            else {
                this._read();
            }
        },

        _addChild: function (result, targetNode) {
            var directories = [];
            if (result) {
                for (var i = 0; i < result.length; i++) {
                    if (!result[i].isFile) {
                        result[i].id = result[i].name;
                        result[i].spriteCssClass = (result[i].permission && !result[i].permission.Read) ? "e-fe-icon e-fe-folder e-fe-lock" : "e-fe-icon e-fe-folder";
                        directories.push(result[i]);
                    }
                }
            }
            this._nodeExpanded = true;
            var selectedNode = targetNode ? $(targetNode).closest('li.e-item') : this._treeObj.getSelectedNode();
            directories.length && this._treeObj.addNode(directories, selectedNode);
            var ele = selectedNode.find(".e-load");
            ele && ((ele.hasClass('e-plus') || ele.hasClass('e-minus')) ? ele.removeClass('e-load') : ele.removeClass('e-icon e-load'));
            this._nodeExpanded = false;
            this._treetag.find("li").removeAttr("tabindex");
            var items = this._treetag.find("li div a").not(".e-js");
            if (items.length && this.model.allowDragAndDrop) {
                this._drag(items);
                items.addClass("e-file-draggable");
            }
        },

        _createContextMenuTag: function (menuOptions, menuDetails, events) {
            var contextMenu = $("body").find('#' + menuDetails.id + 'ContextMenu');
            var ContextMenutag = contextMenu.length ? contextMenu : ej.buildTag('ul.fe-context-menu #' + menuDetails.id + 'ContextMenu');
            ContextMenutag.ejMenu({
                menuType: ej.MenuType.ContextMenu,
                enableSeparator: true,
                enableRTL: this.model.enableRTL,
                cssClass: this.model.cssClass,
                contextMenuTarget: menuDetails.targetId,
                beforeOpen: events.beforeOpen,
                open: events.open,
                close: events.close,
                click: events.click,
                fields: { dataSource: menuOptions, id: "id", text: "text", htmlAttribute: "htmlAttr", spriteCssClass: "sprite" },
            });
            ContextMenutag.hide();
            return ContextMenutag;
        },

        _beforeOpenContextMenu: function (args) {
            if (!$(args.target).hasClass("e-text"))
                args.cancel = true;
            else {
                this._menuNode = $(args.target).closest('li.e-item');
                (this._treeObj) && this._treeObj.element.find('.e-node-focus').removeClass('e-node-focus');
                this._menuNode.find('> div > .e-text:first').addClass('e-node-focus');
                args.dataSource = this._treeMenuOptions.slice();
                args.contextMenu = "navbar";
                args.element = this._treeMenuObj.element;
                if (this._trigger("menuBeforeOpen", args)) return false;
                (JSON.stringify(this._treeMenuObj.model.fields.dataSource) != JSON.stringify(this._treeMenuOptions)) && this._treeMenuObj.option("fields", { dataSource: args.dataSource });
                for (var i = 0; i < this._restrictedMenuOption.length; i++) {
                    this._treeMenuObj && this._treeMenuObj.disableItem(this._restrictedMenuOption[i]);
                }
                (this._toRead && this._toEdit) ? this._enableEditingMenus() : this._disableEditingMenus();
                (this._toRead && this._toCopy) ? (this._restrictedMenuOption.indexOf(this._menuCopy) < 0 && this._treeMenuObj.enableItem(this._menuCopy)) : this._treeMenuObj.disableItem(this._menuCopy);
                this._toRead ? (this._restrictedMenuOption.indexOf(this._menuOpen) < 0 && this._treeMenuObj.enableItem(this._menuOpen)) : this._treeMenuObj.disableItem(this._menuOpen);
                (this._toRead && this._toEditContents) ? (this._restrictedMenuOption.indexOf(this._menuNewFolder) < 0 && this._treeMenuObj.enableItem(this._menuNewFolder)) : this._treeMenuObj.disableItem(this._menuNewFolder);
                (this._toRead && this._toUpload) ? (this._restrictedMenuOption.indexOf(this._menuUpload) < 0 && this._treeMenuObj.enableItem(this._menuUpload)) : this._treeMenuObj.disableItem(this._menuUpload);
                if ($(args.target).parents("li.e-item:first").attr("id") == 1) {
                    this._disableEditingMenus();
                }
            }
        },

        _beforeOpenTileContextMenu: function (args) {
            if ($(args.target).closest('th.e-headercell').hasClass('e-col-check'))
                this._headCheckObj.wrapper.click();
            if ($(args.target).hasClass("e-scrollbar") || $(args.target).parents().hasClass("e-scrollbar") || $(args.target).closest('th.e-headercell').hasClass('e-col-check')) {
                args.cancel = true;
                return;
            }
            if (!$(args.target).hasClass('e-rowcell') && !$(args.target).closest('td.e-rowcell').hasClass('e-col-check') && $(args.target).closest('td.e-rowcell').length > 0 && !$(args.target).closest('td.e-rowcell').hasClass('e-active') && args.events && (args.events.button == 2 || args.events.which == 3))
                this._updateGridSelection(args);
            else if (($(args.target).hasClass("e-file-info") || $(args.target).hasClass("e-thumb-image") || $(args.target).closest(".e-thumb-image").length > 0 || $(args.target).closest(".e-tilenode").length > 0) && $(args.target).closest('.e-chkbox-wrap').length == 0 && !$(args.target).closest(".e-tilenode").hasClass("e-active"))
                this._updateTileSelection(args);
            if ($(args.target).is(".e-tilenode.e-active") || $(args.target).closest(".e-tilenode").hasClass("e-active") || $(args.target).closest('td.e-rowcell').is(".e-active") || ((args.events.ctrlKey || args.events.shiftKey || $(args.target).closest('td.e-rowcell').hasClass('e-col-check') || $(args.target).closest('.e-chkbox-wrap').length > 0) && ($(this.items).hasClass('e-active') || $(this.gridItems).find('td').hasClass('e-active')))) {
                args.dataSource = this._fileMenuOptions.slice();
                args.contextMenu = "files";
                args.element = this._viewMenuObj.element;
            }
            else {
                if ($(args.events.currentTarget).hasClass("e-grid") && ($(args.target).hasClass("e-gridcontent") || $(args.target).hasClass("e-content") || $(args.target).hasClass("e-table") || !$(args.target).is(".e-rowcell.e-active"))) {
                    this._gridObj.clearSelection();
                    if (this.model.showCheckbox) {
                        this._gridtag.find(".e-grid-row-checkbox").ejCheckBox({ "checked": false });
                        this._gridtag.find("#headchk").ejCheckBox({ "checked": false });
                    }
                }
                if ($(args.events.currentTarget).hasClass("e-tile-wrapper") && ($(args.target).hasClass("e-tile-wrapper") || $(args.target).hasClass("e-tile-content") || $(args.target).hasClass("e-tileview") || !($(args.target).is(".e-tilenode.e-active") || $(args.target).parent(".e-tilenode").hasClass("e-active")))) {
                    this.model.showCheckbox && this._clearTileCheckBoxSelection();
                    if (this.items.hasClass("e-active"))
                        this.items.removeClass("e-active").attr("aria-selected", false);
                }
                this._updateCurrentPathPermission();
                args.dataSource = this._cwdMenuOptions.slice();
                args.contextMenu = "cwd";
                args.element = this._viewMenuObj.element;
            }
            if (this._trigger("menuBeforeOpen", args)) return false;
            (JSON.stringify(this._viewMenuObj.model.fields.dataSource) != JSON.stringify(args.dataSource)) && this._viewMenuObj.option("fields", { dataSource: args.dataSource });
            for (var i = 0; i < this._restrictedMenuOption.length; i++) {
                this._viewMenuObj && this._viewMenuObj.disableItem(this._restrictedMenuOption[i]);
            }
            if (!this._toRead || (!(/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(this.model.selectedItems) && this._nodeType == "File"))
                this._viewMenuObj && this._viewMenuObj.disableItem("Open");            
            else
                (this._restrictedMenuOption.indexOf(this._menuOpen) < 0) && this._viewMenuObj.enableItem("Open");
            if (!this._option || !this._toRead)
                this._viewMenuObj.disableItem(this._menuPaste);
            this._isupdate ? (this._restrictedMenuOption.indexOf(this._menuDownload) < 0 && this._viewMenuObj.enableItem(this._menuDownload)) : this._viewMenuObj.disableItem(this._menuDownload);
            (this._searchbar && $.trim(this._searchbar.val())) ? (this._restrictedMenuOption.indexOf(this._menuOpenFolderLocation) < 0 && this._viewMenuObj.enableItem(this._menuOpenFolderLocation)) : this._viewMenuObj.disableItem(this._menuOpenFolderLocation);
            (this._toRead && this._toDownload) ? (this._restrictedMenuOption.indexOf(this._menuDownload) < 0 && this._viewMenuObj.enableItem(this._menuDownload)) : this._viewMenuObj.disableItem(this._menuDownload);
            (this._toRead && this._toUpload) ? (this._restrictedMenuOption.indexOf(this._menuUpload) < 0 && this._viewMenuObj.enableItem(this._menuUpload)) : this._viewMenuObj.disableItem(this._menuUpload);
            (this._toRead && this._toEdit) ? this._enableEditingMenus() : this._disableEditingMenus();
            (this._toRead && this._toCopy) ? (this._restrictedMenuOption.indexOf(this._menuCopy) < 0 && this._viewMenuObj.enableItem(this._menuCopy)) : this._viewMenuObj.disableItem(this._menuCopy);
            this._hasEditContentsPermission(this._originalPath) ? (this._restrictedMenuOption.indexOf(this._menuNewFolder) < 0 && this._viewMenuObj.enableItem(this._menuNewFolder)) : this._viewMenuObj.disableItem(this._menuNewFolder);
        },

        _contextMenuOpen: function (args) {
            args.contextMenu = (args.model.contextMenuTarget == this._ExplorerId + "_treeView") ? "navbar" : (this.model.selectedItems.length > 0 ? "files" : "cwd");
            args.element = args.contextMenu == "navbar" ? this._treeMenuObj.element : this._viewMenuObj.element;
            if (args.contextMenu == "cwd")
                var length=this.model.gridSettings.columns.length;
                for (var i = 0; i < length; i++) {
                    if (this._prevsortingoption == this.model.gridSettings.columns[i].field) {
                        this._changeActiveSortedoption(this.model.gridSettings.columns[i].headerText,false,true);
                    }
                }
            this._trigger("menuOpen", args);
        },

        _removeOldSelectionDetails: function (nodeType) {
            if (this._currentPath != this._originalPath) {
                this._currentPath = this._originalPath;
            }
            this._sizeInByte = 0;
            this._selectedItems = [];
            this._selectedTileItems = [];
            this.model.selectedItems = [];
            this._selectedContent = this._selectedTreeText;
            if (nodeType) this._nodeType = nodeType;
            else this._nodeType = "Directory";
            this._selectedItemsTag && this._selectedItemsTag.html("");
            this._toolBarItems && this._disableToolbarItem("Download");            
            this._viewMenuObj && this._viewMenuObj.disableItem(this._menuDownload);
            this._disableEditingTools();
        },
        _contextMenuClick: function (args) {
            this._treeObj.selectNode(this._menuNode);
            this._fileContextMenuClick(args);
        },
        _fileContextMenuClick: function (args) {
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            args.contextMenu = (args.model.contextMenuTarget == this._ExplorerId + "_treeView") ? "navbar" : (this.model.selectedItems.length > 0 ? "files" : "cwd");
            if ((!ej.isNullOrUndefined(args.selectedItem) && args.selectedItem.attr('id') == this._ExplorerId + "_cwd_" + "SortBy") || (!ej.isNullOrUndefined(args.element) && args.element.parentElement.parentElement.id == this._ExplorerId + "_cwd_" + "SortBy")) {
                this._changeActiveSortedoption(args.text);
                this._sorting(this._prevsortingoption, this._prevsorting);
                this._sortingActioncomplete();
            }
            else {
                switch (args.text) {
                    case this._menuOpen:
                        this._openAction();
                        break;
                    case this._menuNewFolder:
                        this._createNewFolder();
                        break;
                    case this._menuDelete:
                        this._deleteFolder();
                        break;
                    case this._menuRefresh:
                        this.refresh();
                        break;
                    case this._menuRename:
                        this._renameFolder();
                        break;
                    case this._menuUpload:
                        this.element.find(".e-uploadinput").click();
                        break;
                    case this._menuDownload:
                        this._downloadFile();
                        break;
                    case this._menuCut:
                        this._copyMoveNode("move");
                        break;
                    case this._menuCopy:
                        this._copyMoveNode("copy");
                        break;
                    case this._menuPaste:
                        this._cut_copy();
                        break;
                    case this._menuGetinfo:
                        this._getDetails();
                        break;
                    case this._menuOpenFolderLocation:
                        this._setFilteredItemsName();
                        var selectedItems = this.model.selectedItems;
                        this._selectedFolder(this._originalPath + this._selectedContent.replace(this._filteredItemsName, ""));
                        this._setSelectedItems(selectedItems);
                        break;
                    case args.text:
                        var customFields = this.model.contextMenuSettings.customMenuFields
                        var fn, customItem = this._getCustomItem(customFields, args.ID);
                        if (customItem) fn = customItem.action;
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        fn && fn(args);
                        break;
                }
            }
                this._trigger("menuClick", args);
        },


        _createNewFolder: function () {
            var proxy = this;
            var name = "";
            var viewerData = this._getLocalizedLabels("NewFolderAlert");
            var dialogContent = ej.buildTag('div.e-get-name');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var inputtag = ej.buildTag('input.e-fe-dialog-text e-ejinputtext e-textbox', "", "", { type: "text" });
            var errDiv= ej.buildTag('div.e-fe-dialog-label e-error-msg');
            inputtag.val("New folder");
            var divtag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok ', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', this._getLocalizedLabels("CancelButton"));
            okButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._removeDialog(proxy._newFolderDialogObj);
                    name = inputtag.val();
                    if (!$.trim(name)) {
                        name = "New folder";
                    }
                    !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                    var data = proxy._fileExplorer[proxy._currentPath];
                    if (!data.length)
                        name && proxy._createFolder(name);
                    else {
                        for (var i = 0; i < data.length; i++) {
                            if (!data[i].isFile && data[i].name == name) {
                                var dialogContent = ej.buildTag('div.e-get-name');
                                var labeltag = ej.buildTag('div.e-fe-dialog-label', String.format(proxy._getLocalizedLabels("ErrorOnFolderCreation"), name));
                                var divtag = ej.buildTag('div.e-fe-dialog-btn');
                                var okButton = ej.buildTag('button.e-fe-btn-ok ', proxy._getLocalizedLabels("YesButton"));
                                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', proxy._getLocalizedLabels("NoButton"));
                                okButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                    }
                                });
                                cancelButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                        proxy._createFolder(proxy._getDuplicateName(data, "New folder"));
                                    }
                                });
                                divtag.append(okButton, cancelButton);
                                $(dialogContent).append(labeltag, divtag);
                                var open = function () {
                                    okButton.focus();
                                };
                                proxy._alertDialog = proxy._createDialog(dialogContent, { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error"), open: open });
                                proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                                break;
                            }
                            else if (i == data.length - 1) {
                                name && proxy._createFolder(name);
                            }
                        }
                    }
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._newFolderDialogObj);
                }
            });
            divtag.append(okButton, cancelButton);
            $(dialogContent).append(labeltag, inputtag, errDiv, divtag);
            this._newFolderDialog = this._createDialog(dialogContent, { width: 350, height: "auto", open: function (e) { proxy._openInputDialog(inputtag, okButton, errDiv, this); }, title: this._getLocalizedLabels("NewFolder") });
            this._newFolderDialogObj = this._newFolderDialog.data("ejDialog");
        },
        _openInputDialog: function (inputtag, okButton, errDiv, obj) {
            var proxy = this;
            inputtag.focus();
            !this._isDevice && inputtag.select();
            if (this._isMobileOrTab || this._isDevice) obj.option("position", { Y: "20%" });
            inputtag.keyup(function (e) {
                var code = proxy._getKeyCode(e);
                if (code == 13)
                    okButton.click();
            });
            inputtag.keypress(function (e) {
                var code = proxy._getKeyCode(e);
                if (/[/\\|*?"<>:]/.test(String.fromCharCode(code))) {
                    errDiv.html(proxy._getLocalizedLabels("InvalidFileName"));
                    return false;
                }
                return true;
            });
            inputtag.keydown(function (e) {
                errDiv.html("");
            });
        },

        _deleteFolder: function () {
            this._alertWindow = ej.buildTag("div#" + "e-fe_deleteAlert");
            var viewerData;
            if (this._selectedItems.length > 1)
                viewerData = String.format(this._getLocalizedLabels("DeleteMultipleFolder"), this._selectedItems.length);
            else
                viewerData = this._getLocalizedLabels("DeleteFolder") + this._selectedContent + "?";
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var divTag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel', this._getLocalizedLabels("CancelButton"));
            divTag.append(okButton, cancelButton);
            this._alertWindow.append(labeltag, divTag);
            proxy = this;
            okButton.ejButton({
                type: "button",
                cssClass: "e-flat",
                click: function () {
                    proxy._removeDialog(proxy._alertWindowObj);
                    proxy._ajax_folderPath = proxy._nodeType == "Directory" ? proxy._getFolderPath() : proxy._currentPath;
                    proxy._deletion(proxy._selectedItems.length > 1 ? proxy._selectedItems : proxy._selectedContent, proxy._ajax_folderPath);
                    proxy._disableEditingTools();
                    proxy._disableToolbarItem("Copy");
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._alertWindowObj);
                }
            });
            var open = function () {
                okButton.focus();
            };
            this._alertWindow = this._createDialog(this._alertWindow, { width: 350, height: "auto", title: this._getLocalizedLabels("Delete"), open: open });
            this._alertWindowObj = this._alertWindow.data("ejDialog");
        },
        _getFileDetails: function (path, updateTreeNode, updateLayoutContent, successCallback) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Read", Path: path, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(path), (updateTreeNode ? updateTreeNode.text() : (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent))) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    result = (result.hasOwnProperty("d")) ? result.d : result;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    for (var i = 0; i < result.files.length; i++) {
                        result.files[i].sizeInByte = result.files[i].size;
                        result.files[i].size = result.files[i].size ? proxy._bytesToSize(result.files[i].size) : "";
                        result.files[i].cssClass = proxy._getCssClass(result.files[i]);
                    }
                    proxy._feParent[path] = result.cwd;
                    proxy._fileExplorer[path] = result.files;
                    updateTreeNode && proxy._addChild(proxy._fileExplorer[path], $(updateTreeNode));
                    if (updateLayoutContent) {
                        proxy._sorting(proxy._prevsortingoption, proxy._prevsorting, result.files);
                        (proxy.model.layout == "grid" ? proxy._renderGridView(proxy._sorteditems) : proxy._renderTileView(proxy._sorteditems));
                        proxy._updateItemStatus(proxy._sorteditems);
                    }                    
                    if (proxy._highlightedNodes && (!proxy._suggestionItems.length)) {
                        proxy._setSelectedItems(proxy._highlightedNodes);                        
                        proxy._highlightedNodes = "";
                    }
                    proxy._searchbar && $.trim(proxy._searchbar.val()) && proxy._searchFiles(proxy._originalPath);
                    successCallback && typeof successCallback === "function" && successCallback();
                },
                successAfter: this.model.ajaxSettings.read.success
            };
            this.model.ajaxSettings.read.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.read);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _searchFiles: function (path) {
            var proxy = this;
            var _ajaxOptions = {
                data: { ActionType: "Search", SearchString: this._queryString, Path: path, CaseSensitive: this.model.filterSettings.caseSensitiveSearch, ExtensionsAllow: this.model.fileTypes, SelectedItems: this._getSelectedItemDetails(this._getFolderPath(path), (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent)) },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    result = (result.hasOwnProperty("d")) ? result.d : result;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    for (var i = 0; i < result.files.length; i++) {
                        result.files[i].sizeInByte = result.files[i].size;
                        result.files[i].size = result.files[i].size ? proxy._bytesToSize(result.files[i].size) : "";
                        result.files[i].cssClass = proxy._getCssClass(result.files[i]);                        
                        result.files[i].filterPath = proxy._originalPath + result.files[i].filterPath.replace(/\\/g, "/");                        
                    }
					proxy._sorting(proxy._prevsortingoption, proxy._prevsorting, result.files);
					proxy._suggestionItems = result.files = proxy._sorteditems;
                    proxy._suggestionItems = result.files;                                                                                   
                    proxy.model.layout == "grid" ? proxy._renderGridView(result.files) : proxy._renderTileView(result.files);
                    proxy._updateItemStatus(result.files);                                       
                    proxy._setSelectedItems(proxy._highlightedNodes);
                    proxy._highlightedNodes = "";                                        
                },
                successAfter: this.model.ajaxSettings.search.success
            };
            this.model.ajaxSettings.search.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.search);
            this._sendAjaxRequest(_ajaxOptions);
        },
        _getDuplicateName: function (fileDetails, name) {
            var directoryCount = 0;
            var initialName = name;
            while (this._isNameExist(fileDetails, name)) {
                directoryCount++;
                name = initialName.split(".")[0] + (directoryCount > 0 ? "(" + directoryCount + ")" : "") + (name.split(".")[1] ? "." + name.split(".")[1] : "");
            }
            return name;
        },
        _isNameExist: function (fileDetails, name) {
            for (var i = 0; fileDetails && i < fileDetails.length; i++) {
                if (name == fileDetails[i].name)
                    return true;
            }
            return false;
        },

        _renameFolder: function () {
            var proxy = this;
            var viewerData = this._getLocalizedLabels("RenameAlert");
            var dialogContent = ej.buildTag('div.e-rename');
            var labeltag = ej.buildTag('div.e-fe-dialog-label', viewerData);
            var selectedFilename;
            if (proxy._nodeType == "Directory")
                selectedFilename = this._selectedContent
            else
                selectedFilename = this._selectedContent.substr(0, this._selectedContent.lastIndexOf('.'));
            var inputtag = ej.buildTag('input.e-fe-dialog-text e-ejinputtext e-textbox', "", "", { type: "text", value: selectedFilename });
            var errDiv = ej.buildTag('div.e-fe-dialog-label e-error-msg');
            var divtag = ej.buildTag('div.e-fe-dialog-btn');
            var okButton = ej.buildTag('button.e-fe-btn-ok', this._getLocalizedLabels("OkButton"));
            var cancelButton = ej.buildTag('button.e-fe-btn-cancel', this._getLocalizedLabels("CancelButton"));
            okButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    var person = inputtag.val(), _oldName = selectedFilename;
                    proxy._removeDialog(proxy._renameDialogObj);
                    if ($.trim(person) && person != _oldName) {
                        proxy._currentPath = proxy._nodeType == "Directory" ? proxy._getFolderPath() : proxy._currentPath;
                        !proxy._fileExplorer[proxy._currentPath] && proxy._getFileDetails(proxy._currentPath);
                        var data = proxy._fileExplorer[proxy._currentPath];
                        proxy._ajax_person = proxy._selectedContent.replace(_oldName, person);
                        if (proxy._nodeType == "File" && (/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(proxy._ajax_person))
                            proxy._updateImages[proxy._currentPath + proxy._ajax_person] = new Date().getTime();
                        for (var i = 0; i < data.length; i++) {
                            if (data[i].name == person) {
                                if (proxy._nodeType == "File") {
                                    person = proxy._getDuplicateName(proxy._fileExplorer[proxy._currentPath], person);
                                    proxy._ajax_person = proxy._selectedContent.replace(_oldName, person);
                                }
                                var dialogContent = ej.buildTag('div.e-get-name');
                                var labeltag = ej.buildTag('div.e-fe-dialog-label', String.format(proxy._getLocalizedLabels(proxy._nodeType == "File" ? "DuplicateFileCreation" : "ErrorOnFolderCreation"), person));
                                var divtag = ej.buildTag('div.e-fe-dialog-btn');
                                var okButton = ej.buildTag('button.e-fe-btn-ok ', proxy._getLocalizedLabels("OkButton"));
                                var cancelButton = ej.buildTag('button.e-fe-btn-cancel ', proxy._getLocalizedLabels("CancelButton"));
                                okButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                        if (proxy._nodeType == "File")
                                            proxy._rename();
                                        else {
                                            proxy._existingItems = [];
                                            proxy._getDuplicateItems(proxy._currentPath + proxy._selectedContent + "/", proxy._currentPath + person + "/", true);
                                            if (proxy._existingItems.length) {
                                                proxy._createReplaceConformationDiaolg("_rename", "DuplicateAlert");
                                            }
                                            else
                                                proxy._rename();
                                        }
                                    }
                                });
                                cancelButton.ejButton({
                                    cssClass: "e-flat",
                                    type: "button",
                                    click: function () {
                                        proxy._removeDialog(proxy._alertDialogObj);
                                    }
                                });
                                divtag.append(okButton, cancelButton);
                                $(dialogContent).append(labeltag, divtag);
                                var open = function () {
                                    okButton.focus();
                                };
                                proxy._alertDialog = proxy._createDialog(dialogContent, { width: 400, height: "auto", title: proxy._getLocalizedLabels("Error"), open: open });
                                proxy._alertDialogObj = proxy._alertDialog.data("ejDialog");
                                break;
                            }
                            else if (i == data.length - 1) {
                                proxy._rename();
                            }
                        }
                    }
                }
            });
            cancelButton.ejButton({
                cssClass: "e-flat",
                type: "button",
                click: function () {
                    proxy._removeDialog(proxy._renameDialogObj);
                }
            });

            divtag.append(okButton, cancelButton);
            $(dialogContent).append(labeltag, inputtag, errDiv, divtag);
            this._renameDialog = this._createDialog(dialogContent, { width: 350, height: "auto", open: function (e) { proxy._openInputDialog(inputtag, okButton, errDiv, this); }, title: this._getLocalizedLabels("Rename") });
            this._renameDialogObj = this._renameDialog.data("ejDialog");
        },

        _isSelectedFile: function (files, name) {
            for (var i = 0; i < files.length; i++) {
                if (name == files[i])
                    return true;
            }
            return false;
        },
        _refreshItems: function (node, path, successCallback) {
            if (!this._treeObj) {
                this._currentPath = this.model.path;
                this._read();
            }
            else {
                node = $(node);
                !this._treeObj.isExpanded(node) && this._treeObj.hasChildNode(node) && this._treeObj.expandNode(node);
                this._fileExplorer[path] = "";
                var proxy = this;
                $.each(proxy._fileExplorer, function (itemPath, value) {
                    //display the key and value pair
                    if (itemPath.startsWith(path))
                        proxy._fileExplorer[itemPath] = "";
                });
                var childNodes = node.find('ul:first > li');
                for (var i = 0; i < childNodes.length; i++) {
                    node.find(childNodes[i]).length && this._treeObj.removeNode($(childNodes[i]));
                }
                var processNode = node.find(".e-process");
                processNode.length && processNode.removeClass("e-process");
                this._getFileDetails(path, node.find('> div > .e-text'), true, successCallback);
            }
        },
        _getDuplicateItems: function (source, target, files) {
            !this._fileExplorer[target] && this._getFileDetails(target);
            var targetFiles = this._fileExplorer[target];
            !this._fileExplorer[source] && this._getFileDetails(source);
            var sourceFiles = this._fileExplorer[source];
            if (sourceFiles && targetFiles) {
                for (var s = 0; s < sourceFiles.length; s++) {
                    for (var t = 0; t < targetFiles.length; t++) {
                        if (sourceFiles[s].name == targetFiles[t].name) {
                            if (files == true || this._isSelectedFile(files, targetFiles[t].name)) {
                                this._existingItems[this._existingItems.length] = { Name: targetFiles[t].name, Path: target + targetFiles[t].name + (!targetFiles[t].isFile ? "/" : ""), IsReplace: true };
                                if (!targetFiles[t].isFile)
                                    this._getDuplicateItems(source + sourceFiles[s].name + "/", target + targetFiles[t].name + "/", true);
                            }
                        }
                    }
                }
            }
        },
        _backward: function () {
            if (this._currentState > 0) {
                //minimum number of states to show forward icon
                var minState = 2;
                var update = true;
                var disableBackwardPosition = 0;
                this._isStateNavigation = true;
                var oldIndex = this._currentState;
                --this._currentState;
                while (this._selectedStates[this._currentState] == "" || this._selectedStates[this._currentState] == this._selectedStates[oldIndex]) {
                    if (this._currentState)
                        --this._currentState;
                    else
                        update = false;                        
                }
                update && this._selectedFolder(this._selectedStates[this._currentState]);
                this._isStateNavigation = false;                
                (this._currentState == disableBackwardPosition || this._selectedStates.length - minState == this._currentState) && this._toolBarItems && this._enableToolbarItem("Forward");
                this._currentState == disableBackwardPosition && this._toolBarItems && this._disableToolbarItem("Back");
            }
        },
        _forward: function () {
            if (this._currentState + 1 < this._selectedStates.length) {
                //used to get index from array length
                var update = true;
                var reduceIndex = 1;
                var disableState = 0;
                var enableState = 1;
                this._isStateNavigation = true;
                var oldIndex = this._currentState;
                ++this._currentState;
                while (this._selectedStates[this._currentState] == "" || this._selectedStates[this._currentState] == this._selectedStates[oldIndex]) {
                    if (this._currentState < this._selectedStates.length - 1)
                        ++this._currentState;
                    else
                        update = false;                        
                }
                update && this._selectedFolder(this._selectedStates[this._currentState]);
                this._isStateNavigation = false;
                this._selectedStates.length - reduceIndex == this._currentState && this._toolBarItems && this._disableToolbarItem("Forward");
                this._currentState == 0 && this._toolBarItems && this._disableToolbarItem("Back");
                this._currentState == 1 && this._toolBarItems && this._enableToolbarItem("Back");
            }
        },
        _copyMoveNode: function (action) {
            if (action == "move") {
                this.element.find(".e-blur").removeClass("e-blur");
                var activeElement = this.element.find(".e-splitter .e-active");
                activeElement.length && activeElement.length == 1 ? activeElement.addClass("e-blur") : this.element.find(".e-cont2 .e-active").addClass("e-blur");
            }
            this._copiedNodes = this._filteredItemsName;
            this._option = action;
            this._sourcePath = this._nodeType == "Directory" ? this._getFolderPath() : this._currentPath;
            this._sourceType = this._nodeType;
            this._fileName = this._selectedItems.length > 1 ? this._selectedItems : this._selectedContent;
            this._refreshNode = this._originalPath != this._currentPath ? this._findMatchingElement(this._selectedNode.find("ul:first"), this._selectedContent) : this._selectedNode;
            this._toolBarItems && this._enableToolbarItem("Paste");
            if (this.model.showContextMenu) {
                this._restrictedMenuOption.indexOf(this._menuPaste) < 0 && this._viewMenuObj.enableItem(this._menuPaste);
                this._restrictedMenuOption.indexOf(this._menuPaste) < 0 && this._treeMenuObj.enableItem(this._menuPaste);
            }
            var args = { name: this._fileName, sourcePath: this._sourcePath, selectedItems: this._getSelectedItemDetails(this._sourcePath, this._fileName) };
            if (action == "move")
                this._trigger("cut", args);
            else
                this._trigger("copy", args);
        },
        _openAction: function (e) {
            if (!ej.isNullOrUndefined(e)) {
                if ($(e.currentTarget).is("li.e-tilenode"))
                    this._isTileViewClick = true;
                if (e.type == "recordDoubleClick") this._isGridViewClick = true;
            }
            if (!this._toRead) return;
            var proxy = this;
            var selectedNodes;
            if (this._nodeType == "File")
                this._selectedFile = this._selectedContent;
            if (this._onBeforeOpen()) return;
            if (this._nodeType == "Directory") {
                if (this._suggestionItems.length) {                    
                    this._selectedFolder(this._originalPath + this._selectedContent);                    
                }
                else {
                    var selectedNode = this._treeObj.getSelectedNode(), _selectedContent = this._selectedContent;
                    if (!this._treeObj.isExpanded(selectedNode))
                        this._treeObj && this._treeObj.expandNode(selectedNode);
                    var _childItems = selectedNode.find('ul:first>li').find('div:first .e-text');
                    if (!this._treeObj.hasChildNode(selectedNode)) {
                        var path = (this._isTreeNode == true ? this._currentPath : this._currentPath.replace(this._selectedContent + "/", ""));
                        this._isTreeNode = false;
                        this._addChild(this._fileExplorer[path]);
                    }
                    for (var i = 0; i < _childItems.length; i++) {
                        if ($(_childItems[i]).text() == _selectedContent) {
                            this._treeObj.selectNode(_childItems[i].parentNode.parentNode);
                            break;
                        }
                    }
                    selectedNodes = this._getSelectedItemDetails(this._getFolderPath(), _selectedContent);
                    this._selectedItems = [];
                    this._selectedTileItems = [];
                }
            }
            else if (this._nodeType == "File") {
                if ((/\.(bmp|dib|jpg|jpeg|jpe|jfif|gif|tif|tiff|png|ico)$/i).test(this._selectedFile)) {
                    proxy._openDialog = ej.buildTag('div.e-imageViewer', "", "", { id: proxy._ExplorerId + '_basicDialog', title: proxy._selectedFile });
                    var path = proxy._currentPath.replace("~", "..") + this._selectedFile;
                    var url = this._getImage(path, this._selectedFile, false);
                    var imagetag = ej.buildTag('img', "", "", { src: (url ? url : path) });
                    $(proxy._openDialog).append(imagetag);
                    $(proxy.element).append(proxy._openDialog);
                    var img = new Image();
                    img.onload = img.onabort = img.onerror = function (args) {
						if(args){
							var myargs = { path: args.target.src, element: args.target, originalArgs: args, action: "open" };
							proxy._trigger("getImage", myargs);
						}
                        
                    };
                    img.src = imagetag.attr('src');
                    proxy._openDialog.ejDialog({
                        width: 450,
                        height: 350,
                        minHeight: 200,
                        minWidth: 300,
                        maxWidth: "100%",
                        isResponsive: proxy.model.isResponsive,
                        target: proxy.element,
                        closeIconTooltip: proxy._getLocalizedLabels("DialogCloseToolTip"),
                        enableRTL: proxy.model.enableRTL,
                        showRoundedCorner: proxy.model.showRoundedCorner,
                        cssClass: proxy.model.cssClass,
                        drag: function (e) { proxy._dialogDragEvent(e); },
                        close: function (e) { proxy._onDialogClose(e); }
                    }).parents(".e-dialog-wrap").addClass("e-imageViewer-wrap");
                    proxy._openDialog.css("height", "90%");
                    proxy._openDialogObj = proxy._openDialog.data("ejDialog");
                }
                selectedNodes = proxy._getSelectedItemDetails(proxy._currentPath, proxy._selectedContent);
            }
            var fileUrl;
            fileUrl = this._nodeType == "File" ? path : this._currentPath;
            var args = { path: fileUrl, itemType: this._nodeType, selectedItems: selectedNodes };
            this._trigger("open", args);
        },
        _dialogDragEvent : function (arg) {
            this._splitObj && this._splitObj._windowResized();
        },
        _getSelectedItemDetails: function (path, names) {
            if (typeof names == "string")
                names = [names];
            var itemDetails = [], items, file;
            if (this.model.layout == 'grid') items = this._selectedRecords;
            else items = this._suggestionItems;
            var data = this._suggestionItems && this._suggestionItems.length ? items : this._fileExplorer[path];
            if (data) {
                for (var j = 0; j < names.length; j++) {
                    for (var i = 0; i < data.length; i++) {
                        if (this._suggestionItems.length > 0) file = data[i].filterPath + data[i].name;
                        else file = names[j];
                        if ((this._suggestionItems.length < 1 && data[i].name == this._getOriginalName(names[j])) || (this._suggestionItems.length > 0 && file == this._FilteredFiles[j] && data[i].name == this._getOriginalName(names[j]))) {
                            itemDetails.push(data[i]);
                            break;
                        }
                    }
                }
            }
            return itemDetails;
        },
        _getDetails: function () {
            var _path = (this._nodeType == "Directory" && this._currentPath != "/" && this._currentPath != "~/") ? this._getFolderPath() : this._currentPath;
            var proxy = this;
            if (this.model.rootFolderName.length > 0 && this._selectedContent == this.model.rootFolderName && this._treeObj.element.find('li:first > div > .e-text').hasClass("e-active") && this._selectedItems.length == 0)
                names = [this._rootFolderName];
            else
                names = (typeof this._selectedContent == "string") ? [this._selectedContent] : this._selectedContent;
            if (names[0].endsWith('/') && names[0] != "/")
                names[0] = names[0].substring(0, names[0].length - 1);
            var _ajaxOptions = {

                data: { ActionType: "GetDetails", Path: _path, Names: names, SelectedItems: this._getSelectedItemDetails(_path, (this.model.selectedItems.length ? this.model.selectedItems : this._selectedContent)), RootFolderPath: this._initPath, OldRootFolderName: this._rootFolderName, NewRootFolderName: this.model.rootFolderName },
                url: this.model.ajaxAction,
                type: "POST",
                async: false,
                success: function (result) {
                    if (result.hasOwnProperty("d"))
                        result = result.d;
                    if (!ej.isNullOrUndefined(result.error)) {
                        proxy._showErrorDialog(result.error);
                        return;
                    }
                    var dialogContent = ej.buildTag('div.e-fe-table');
                    var tabletag = ej.buildTag('table'), trtag, tdtag1, tdtag2, wrapDiv, inputtag, kbsize, tdata;
                    var rootName = proxy._feParent[Object.keys(proxy._feParent)[0]].name;
                    $.each(result.details[0], function (name, value) {
                        name = name[0].toUpperCase() + name.substr(1);   // For Asp.Net Core get details issue
                        trtag = ej.buildTag('tr');
                        tdtag1 = ej.buildTag('td', ej.isNullOrUndefined(proxy._getLocalizedLabels(name)) ? name : proxy._getLocalizedLabels(name));
                        tdtag2 = ej.buildTag('td');
                        if (name == "Name" || name == "Location") {
                            wrapDiv = ej.buildTag('div');
                            inputtag = ej.buildTag('input.e-readonly', "", "", { style: "border:none;", type: 'text', value: value, title: value, readonly: true });
                            inputtag.focus(function () {
                                $(this).blur();
                            });
                            wrapDiv.append(inputtag);
                        } else if (name == "Size") {
                            kbsize = proxy._bytesToSize(value);
                            wrapDiv = ej.buildTag('span', kbsize + " (" + value + " Bytes)");
                        } else if (name == "Permission") {
                            wrapDiv = (value != undefined) ? ej.buildTag('span', proxy._objToString(value), "", { style: "word-break: break-word;" }) : null;
                        } else {
                            wrapDiv = ej.buildTag('span', value);
                        }
                        if (wrapDiv != undefined) {
                            (name == "Permission") && $(tabletag).find("tr:last").addClass('e-border');
                            tdtag2.append(wrapDiv);
                            $(tabletag).append(trtag);
                            $(trtag).append(tdtag1, tdtag2);
                            (name == "Name" || name == "Size") && trtag.addClass('e-border');
                        }
                    });
                    $(dialogContent).append(tabletag);
                    proxy._detailsDialog = proxy._createDialog(dialogContent, { width: 500, height: "auto", title: proxy._getLocalizedLabels("Details") });
                    proxy._detailsDialogObj = proxy._detailsDialog.data("ejDialog");
                    proxy._detailsDialogObj.focus();
                },
                successAfter: this.model.ajaxSettings.getDetails.success
            };
            this.model.ajaxSettings.getDetails.success = undefined;
            $.extend(true, _ajaxOptions, this.model.ajaxSettings.getDetails);
            this._sendAjaxRequest(_ajaxOptions, true);
        },
        _objToString: function (obj) {
            var str = '';
            for (var prop in obj) {
                if (obj.hasOwnProperty(prop)) {
                    str += prop + ': ' + obj[prop] + ', ';
                }
            }
            return str;
        },
        _uploadFile: function () {
            proxy = this.element.find(".e-uploadbox");
            proxy = proxy.ejUploadbox("instance");
        },

        _getFolderPath: function (path) {
            var str_array = path? path.split('/'):this._currentPath.split('/');            
            var editedPath = "";
            for (var i = 0; i < str_array.length - 2; i++) {
                editedPath += str_array[i] + "/";
            }
            return editedPath;
        },
        _renderToolBar: function () {
            this._crateToolbarTemplate();
            this._initToolbarItems();
            var model = {};
            model.click = $.proxy(this._toolBarClick, this);
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeparator = true;
            model.isResponsive = this.model.isResponsive;
            model.height = model.isResponsive ? "" : "auto";
            model.cssClass = this.model.cssClass + " e-fe-toolbar " + (this._isMobileOrTab ? "e-fe-mobile" : "");
            model.enableRTL = this.model.enableRTL;
            this._toolBarItems.ejToolbar(model);
            this._toolBarObj = this._toolBarItems.ejToolbar("instance");
            if (this._isMobileOrTab && this._toolBarObj.model.isResponsive) this._toolBarObj._liTemplte.css("max-width", this.element.width());
            this._disableToolbarItem("Paste");
            this._disableToolbarItem("Download");
            this._disableToolbarItem("Back");
            this._disableToolbarItem("Forward");
            this._disableEditingTools();
        },
        _initToolbarItems: function () {
            this._toolBarItems.find("#" + this._ExplorerId + "Addressbar").length > 0 && this._createAddressBar();
            this._toolBarItems.find("#" + this._ExplorerId + "Searchbar").length > 0 && this._searchDetails();
            this._toolBarItems.find("#" + this._ExplorerId + "Layout").length > 0 && this._renderLayoutDrpdwn();
            this._toolBarItems.find("#" + this._ExplorerId + "SortBy").length > 0 && this._renderSortbyDrpdwn();
        },
        _renderSortbyDrpdwn: function () {
            this._showSortbyDDL = ej.buildTag("button#" + this._ExplorerId + "_sortby", "", "", { "data-role": "none", "type": "button" });
            var ultag = $("<ul id=" + this._ExplorerId + "_splitMenu1 class='e-fe-split-context'>");
            var itemslength = this.model.gridSettings.columns.length;
            for (var i = 0; i < itemslength; i++) {
                ultag.append($("<li><a class=' e-arrow-space'><span class='e-icon'></span>" + this.model.gridSettings.columns[i].headerText + "</a></li>"));
            }
            ultag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "SortBy").html(""));
            var model = {};
            var proxy = this;
            var selectedoption;
            model.height = "24px",
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._ExplorerId + "_splitMenu1";
            model.contentType = "imageonly";
            model.buttonMode = "dropdown";
            model.itemSelected = function (args) {
                proxy._changeActiveSortedoption(args.text);
                proxy._sorting(proxy._prevsortingoption, proxy._prevsorting)
                proxy._sortingActioncomplete();
            }
            model.prefixIcon = 'e-icon e-fe-sortby';
            this._showSortbyDDL.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "SortBy").addClass("e-fe-split-button"));
            this._showSortbyDDL.ejSplitButton(model);
            this._splitButtonObj1 = this._showSortbyDDL.data("ejSplitButton");
        },
        _gridupdate: function (type) {
            var option;
            this._prevsorting ? option = "ascending" : option = "descending";
            if (!ej.isNullOrUndefined(this._gridObj) && this.model.gridSettings.allowSorting) {
                this._gridObj.getHeaderTable().find("[ej-mappingname=" + type + "]").parent().attr('aria-sort', option);
                this._gridObj._addSortElementToColumn(type, option);
            }
        },
        removeSortingIcons:function(){
            $("#" + this._ExplorerId + "_tileViewContextMenu").find("li span").removeClass("e-fe-ascending e-fe-descending");
            $("#" + this._ExplorerId + "_splitMenu1").find("li span").removeClass("e-fe-ascending e-fe-descending");
            var gridSoringCol=this._gridObj.getHeaderTable().find("[ej-mappingname=" + "filterPath" + "]").parent();
            if (this._prevsortingoption == "filterPath") {
                if (this._prevsorting) {
                    gridSoringCol.attr('aria-sort', "descending");
                    this._gridObj._addSortElementToColumn("filterPath", "descending");
                }
                else {
                    gridSoringCol.attr('aria-sort', "ascending");
                    this._gridObj._addSortElementToColumn("filterPath", "ascending");
                }
            }
            else
            {
                if (this._prevsorting) {
                    gridSoringCol.attr('aria-sort', "ascending");
                    this._gridObj._addSortElementToColumn("filterPath", "ascending");
                }
                else {
                    gridSoringCol.attr('aria-sort', "descending");
                    this._gridObj._addSortElementToColumn("filterPath", "descending");
                }
            }
            this._prevsorting = this._gridObj.getHeaderContent().find('span').hasClass("e-icon e-ascending") ? true : false;
        },
        _changeActiveSortedoption: function (args, initialsort, menuopen) {
            if (menuopen == true)
                this._prevsorting = !this._prevsorting
            var sortedoptionlength = this.model.gridSettings.columns.length, tilecontextelement;
            var menulength=$("#" + this._ExplorerId + "_tileViewContextMenu").find("li").length;
            for (var j = 0; j < menulength; j++)
            {
                var liElement=$("#" + this._ExplorerId + "_tileViewContextMenu").find("li")[j];
                if (liElement.id == this._ExplorerId + "_cwd_" + "SortBy")
                    tilecontextelement = $(liElement).find("ul li");
            }
            var splitmenuelement = $("#" + this._ExplorerId + "_splitMenu1").find("li");
            $(tilecontextelement).find('span').removeClass("e-fe-ascending e-fe-descending");
            $(splitmenuelement).find('span').removeClass("e-fe-ascending e-fe-descending");
            var tilemenuli, contextmenuliElement, toolbarliElement, contextactiveElement, toolbaractiveElement;
            for (var i = 0; i < sortedoptionlength; i++) {
                contextmenuliElement = !ej.isNullOrUndefined(tilecontextelement) && tilecontextelement[i];
                toolbarliElement = !ej.isNullOrUndefined(splitmenuelement) && splitmenuelement[i];
                contextactiveElement = $(contextmenuliElement).find('span');
                toolbaractiveElement = $(toolbarliElement).find('span');
                if ((!ej.isNullOrUndefined(contextmenuliElement) && $(contextmenuliElement).text() == args ) || (!ej.isNullOrUndefined(toolbarliElement) && $(toolbarliElement).find('a').text() == args)) {
                    if (initialsort) {
                        contextactiveElement.addClass("e-fe-ascending");
                        toolbaractiveElement.addClass("e-fe-ascending");
                    }
                    else if (this._prevsortingoption == this.model.gridSettings.columns[i].field) {
                        if (this._prevsorting) {
                            contextactiveElement.addClass("e-fe-descending");
                            toolbaractiveElement.addClass("e-fe-descending");
                        }
                        else {
                            contextactiveElement.addClass("e-fe-ascending");
                            toolbaractiveElement.addClass("e-fe-ascending");
                        }
                    }
                    else {
                        if (this._prevsorting) {
                            contextactiveElement.addClass("e-fe-ascending");
                            toolbaractiveElement.addClass("e-fe-ascending");
                        }
                        else {
                            contextactiveElement.addClass("e-fe-descending");
                            toolbaractiveElement.addClass("e-fe-descending");
                        }
                    }
                    this._prevsortingoption = this.model.gridSettings.columns[i].field;
                    this._prevsorting = contextactiveElement.hasClass("e-fe-ascending") || toolbaractiveElement.hasClass("e-fe-ascending") ? true : false;
                    break;
                }
            }
        },
        _suggestionitemsSorting: function (sortingType,sortingOption) {
            var items = this._suggestionItems;
            var dataMgr = ej.DataManager(items);
            this._prevsortingoption = sortingType;
            this._sorteditems = sortingOption ? (dataMgr.executeLocal(ej.Query().sortBy(sortingType))) : (dataMgr.executeLocal(ej.Query().sortByDesc(sortingType)));
        },
        _sorting: function (type, option,data) {
            var items,sortingoption;
            if (ej.isNullOrUndefined(data))
                items = (this._searchbar && this._searchbar.val() != "") ? (this._suggestionItems.length >= 0 ? this._suggestionItems : this._fileExplorer[this._originalPath]) : this._fileExplorer[this._originalPath];
            else
                items = data;
            type == "type" ? sortingoption = "name" : type == "size" ? sortingoption = 'sizeInByte' : sortingoption = type;
            var dataMgr=ej.DataManager(items);
            switch (type) {
                case "type":
                case "dateModified":
                    if (option) {
                        var ascendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortBy(sortingoption)));
                        var ascendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortBy(sortingoption)));
                        this._sorteditems = ascendingdir.concat(ascendingfile);
                    }
                    else {
                        var descendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortByDesc(sortingoption)));
                        var descendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortByDesc(sortingoption)));
                        this._sorteditems = descendingdir.concat(descendingfile);
                    }
                    break;
                case "name":
                case "size":
                default:
                    if (option) {
                        var ascendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortBy(sortingoption)));
                        var ascendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortBy(sortingoption)));
                        this._sorteditems = ascendingdir.concat(ascendingfile);
                    }
                    else {
                        var descendingdir = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, false).sortByDesc(sortingoption)));
                        var descendingfile = (dataMgr.executeLocal(ej.Query().where("isFile", ej.FilterOperators.equal, true).sortByDesc(sortingoption)));
                        this._sorteditems = descendingfile.concat(descendingdir);
                    }
                    break;
            }
        },
        _sortingActioncomplete: function () {
            switch (this.model.layout) {
                case ej.FileExplorer.layoutType.Grid:
                    this._gridObj.option('dataSource', this._sorteditems);
                    break;
                case ej.FileExplorer.layoutType.LargeIcons:
                case ej.FileExplorer.layoutType.Tile:
                default:
                    this._renderTileView(this._sorteditems,true);
            }
            if (!ej.isNullOrUndefined(this._selectedItems) && this._selectedItems.length == 1)
                this._setSelectedItems(this._selectedContent);
        },
        _renderLayoutDrpdwn: function () {
            this._showLayoutDDL = ej.buildTag("button#" + this._ExplorerId + "_layout", "", "", { "data-role": "none","type":"button" });
            var ultag = $("<ul id="+this._ExplorerId+"_splitMenu class='e-fe-split-context'>");
            this._layoutList = ["Tile","Grid","LargeIcons"];
            for (var i = 0; i < this._layoutList.length; i++) {
                ultag.append($("<li><a class=' e-arrow-space'><span class='e-icon e-fe-activeicon'></span>" + this._getLocalizedLabels(this._layoutList[i]) + "</a></li>"));
            }
            ultag.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Layout").html(""));
          
            var model = {};
            var proxy = this;
            model.height = "24px",
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._ExplorerId+"_splitMenu";
            model.contentType = "imageonly";
            model.buttonMode = "dropdown";
            model.itemSelected = function (args) {
                switch (args.text) {
                    case proxy._getLocalizedLabels("LargeIcons"):
                        proxy.model.layout = "largeicons";
                        break;
                    case proxy._getLocalizedLabels("Tile"):
                        proxy.model.layout = "tile";
                        break;
                    case proxy._getLocalizedLabels("Grid"):
                    default:
                        proxy.model.layout = "grid";
                        break;
                }
                proxy._switchLayoutView();
            }
            model.prefixIcon = 'e-icon e-fe-' + this.model.layout;
            this._showLayoutDDL.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Layout").addClass("e-fe-split-button"));
            this._showLayoutDDL.ejSplitButton(model);
            this._splitButtonObj = this._showLayoutDDL.data("ejSplitButton");
        },
        _changeLayoutActive: function (layout) {
            this._splitButtonObj && this._splitButtonObj.option('prefixIcon', 'e-icon e-fe-' + layout);
            if (this._toolBarItems && this._toolBarItems.find("#" + this._ExplorerId + "Layout").length > 0) {
                $($("#" + this._ExplorerId + "_splitMenu").find("li span").removeClass('e-fe-activeicon'));
                switch (layout) {
                    case ej.FileExplorer.layoutType.LargeIcons:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[2]).find("span").addClass('e-fe-activeicon'); break;
                    case ej.FileExplorer.layoutType.Tile:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[0]).find("span").addClass('e-fe-activeicon'); break;
                    case ej.FileExplorer.layoutType.Grid:
                    default:
                        $($("#" + this._ExplorerId + "_splitMenu").find("li")[1]).find("span").addClass('e-fe-activeicon'); break;
                }
            }
        },
        _createUploadBox: function () {
            this._uploadtag = ej.buildTag('div#' + this._ExplorerId + 'FileUpload', "", { padding: "0px", height: "0px", width: "0px" });
            this.element.prepend(this._uploadtag);
            this._renderUploadBox();
            this._uploadtag.find(".e-inputbtn").hide();
            this._uploadtag.find(".e-uploadinput").attr("tabindex", -1);
        },
        _searchDetails: function () {
            this._isWatermark = 'placeholder' in document.createElement('input');
            var waterMark = this._getLocalizedLabels("Search");
            this._searchbar = ej.buildTag('input.e-searchBar e-tool-input', "", {}, { id: this._ExplorerId + '_searchbar', type: "text", placeholder: waterMark });
            this._searchbar.appendTo(this._toolBarItems.find("#" + this._ExplorerId + "Searchbar").html(""));
            ej.browserInfo().name == "msie" && ej.ieClearRemover(this._searchbar[0]);
            if (!this._isWatermark)
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ", waterMark, {display: "block"}).insertAfter(this._searchbar);
            this._on($('#' + this._ExplorerId + '_searchbar'), "focus", this._inputFocusin);
            this._on($('#' + this._ExplorerId + '_searchbar'), "keyup", this._onSearchKeyup);
        },
        _setUploadLocalization: function () {
            $.each(ej.FileExplorer.Locale, function (locale, value) {
                if (value.UploadSettings) {
                    ej.Uploadbox.Locale[locale] = value.UploadSettings;
                }                
            });            
        },
        _getLocalizedLabels: function (property) {
            return ej.FileExplorer.Locale[this.model.locale] === undefined || ej.FileExplorer.Locale[this.model.locale][property] === undefined ? (ej.FileExplorer.Locale["en-US"][property] ? ej.FileExplorer.Locale["en-US"][property] : property) : ej.FileExplorer.Locale[this.model.locale][property];
        },
        _crateToolbarTemplate: function () {
            this._toolBarItems = ej.buildTag("div#" + this._ExplorerId + "_toolbar").prependTo(this.element);
            for (var item = 0; item < this.model.toolsList.length; item++) {
                var items = this.model.toolsList[item];
                if (!ej.isNullOrUndefined(this.model.tools[items])) {
                    if (items == "customTool")
                        !ej.isNullOrUndefined(this.model.tools[items]) && this._customTools(this.model.tools[items]);
                    else
                        this.model.tools[items].length > 0 && this._createToolsItems(this.model.tools[items], items);
                }
            }
        },

        _createToolsItems: function (items, itemName) {
            var ulTag = ej.buildTag("ul#" + (this._ExplorerId + itemName)), liTag;
            ulTag.addClass("e-ul-" + itemName);
            for (var i = 0; i < items.length; i++) {
                liTag = $("<li id='" + (this._ExplorerId + items[i].replace(/ /g, '')) + "' class='e-feItem-" + items[i] + "' title='" + this._getLocalizedLabels(items[i].replace(/ /g, '')) + "' ><div class='e-fileexplorer-toolbar-icon " + items[i] + "'></div></li>");
                liTag.appendTo(ulTag);
            }
            ulTag.appendTo(this._toolBarItems);
        },
        _customTools: function (toolbarItems) {
            for (var item = 0; item < toolbarItems.length; item++) {
                var ulTag = ej.buildTag("ul"), liTag;
                liTag = $("<li id='" + (this._ExplorerId + toolbarItems[item].name.replace(/ /g, '')) + "' title='" + toolbarItems[item].tooltip + "' ><div class='" + (ej.isNullOrUndefined(toolbarItems[item].css) ? "" : toolbarItems[item].css) + "'></div></li>");
                var fn = toolbarItems[item].action;
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }
                !ej.isNullOrUndefined(toolbarItems[item].action) && this._on(liTag, "click", fn);
                $(toolbarItems[item].template).appendTo(liTag.find("div"));
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
        },
        _toolBarClick: function (args) {
            this._hidePopup();
            var proxy = this;
            if ((args.event.which && (args.event.which == 3 || args.event.which == 2)) || (args.event.button && args.event.button == 2))
                return false;
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            this._lastFocusedElement = $(args.currentTarget);
            var currrentElement = $(args.currentTarget);
            var selected = currrentElement.attr("id");
            switch (selected) {
                case this._ExplorerId + "Addressbar":
                case this._ExplorerId + "Searchbar":
                    if (this._searchbar && !this._isWatermark) {
                        this._searchbar.blur(function () {
                            !proxy._searchbar.val() && proxy._hiddenSpan.css("display", "block");
                        });
                        this._hiddenSpan.css("display", "none");
                    }
                    if (args.event.type == "keyup")
                        currrentElement.find("input").focus();
                    break;
                case this._ExplorerId + "Download":
                    this._downloadFile();
                    break;
                case this._ExplorerId + "Upward":
                    this._upward();
                    break;
                case this._ExplorerId + "NewFolder":
                    this._createNewFolder();
                    break;
                case this._ExplorerId + "Delete":
                    this._deleteFolder();
                    break;
                case this._ExplorerId + "Rename":
                    this._renameFolder();
                    break;
                case this._ExplorerId + "Refresh":
                    this._currentPath = this._originalPath;
                    this._highlightedNodes = this.model.selectedItems;
                    this._refreshItems((this._treeObj ? this._treeObj.getSelectedNode(): ""), this._originalPath);
                    break;
                case this._ExplorerId + "Back":
                    this._backward();
                    break;
                case this._ExplorerId + "Forward":
                    this._forward();
                    break;
                case this._ExplorerId + "Cut":
                    this._copyMoveNode("move");
                    break;
                case this._ExplorerId + "Copy":
                    this._copyMoveNode("copy");
                    break;
                case this._ExplorerId + "Paste":
                    this._currentPath = this._originalPath;
                    this._cut_copy();
                    break;
                case this._ExplorerId + "Open":
                    this._openAction();
                    break;
                case this._ExplorerId + "Details":
                    this._getDetails();
                    break;
                case this._ExplorerId + "Upload":
                    this.element.find(".e-uploadinput").click();
                    break;
            }
        },
        _upward: function () {            
            this._treeObj && this._treeObj.selectNode(this._treeObj.getSelectedNode().parent().closest('li.e-item'));            
        },
        _getFilteredList: function (list) {
            var w_char;
            var searchItems = [];
            this._suggestionItems = [];                       
            if ($.trim(this._queryString)) {
                switch (this.model.filterSettings.filterType) {
                    case ej.FileExplorer.filterType.StartsWith:
                        this._queryString = this._queryString + "*";
                        break;
                    case ej.FileExplorer.filterType.EndsWith:
                        this._queryString = "*" + this._queryString;
                        break;
                    case ej.FileExplorer.filterType.Contains:
                        this._queryString =  "*" + this._queryString + "*";
                        break;
                }
                this._searchFiles(this._originalPath);
            }                
            else {
                this._suggestionItems = [];
                this._sorting(this._prevsortingoption, this._prevsorting, this._fileExplorer[this._originalPath]);
                this.model.layout == "grid" ? this._renderGridView(this._sorteditems) : this._renderTileView(this._sorteditems);
                this._updateItemStatus(this._fileExplorer[this._originalPath]);
            }
            this._gridupdate(this._prevsortingoption);
        },
        
        _updateItemStatus: function (items) {
            if (items) {
                this._itemStatus && this._itemStatus.html(items.length + " " + (items.length == 1 ? this._getLocalizedLabels("Item") : this._getLocalizedLabels("Items")));
            }            
        },
        _onSearchKeyup: function (event) {
            var proxy = this;
            var event = event;
            clearTimeout(this._searchTimer);
            this._searchTimer = setTimeout(function () {
                proxy._validateKeyCode(event);
            }, 300);
        },
        _validateKeyCode: function (event) {
            switch (event.which) {
                case 38:
                case 40:
                case 37:
                case 39:
                case 20:
                case 16:
                case 17:
                case 18:
                case 35:
                case 36:
                case 144: break;
                case 27:
                    this._searchbar && this._searchbar.val("");
                    this._queryString = "";
                    var address = this._addresstag.val();
                    if (this.model.rootFolderName.length > 0)
                        address = address.replace(this.model.rootFolderName, this._rootFolderName);
                    this._removeOldSelectionDetails();
                    this._currentPath = this._currentPath.split(address)[0] + address;
                    this._getFilteredList(this._fileExplorer[this._currentPath]);
                    this.model.layout == 'grid' ? this._addFocus(this._gridtag.find(".e-gridcontent")) : this._addFocus(this._tileViewWrapper);
                    break;
                case 9:
                case 46:
                case 8:
                case 13: 
                default:
                    if ((!this.model.filterSettings.allowSearchOnTyping && event.which == (13 || 46 || 9 || 8)) || (this.model.filterSettings.allowSearchOnTyping)) {
                    this._queryString = event.currentTarget.value;
                    var address = this._addresstag.val();
                    if (this.model.rootFolderName.length > 0)
                        address = address.replace(this.model.rootFolderName, this._rootFolderName);
                    this._removeOldSelectionDetails();
                    this._currentPath = this._currentPath.split(address)[0] + address;
                    this._getFilteredList(this._fileExplorer[this._currentPath]);
                    break;
                  }
            }
        },
        _onDialogClose: function (args) {
            $("body").find("#" + this._ExplorerId + "_basicDialog_wrapper").remove();
            this._lastFocusedElement && this._lastFocusedElement.focus();
        },
        _switchView: function (event) {
            var changed = false;
            if (event.currentTarget.getAttribute("id") == this._ExplorerId + '_swithListView') {
                if (this.model.layout != ej.FileExplorer.layoutType.LargeIcons) {
                    this.model.layout = ej.FileExplorer.layoutType.LargeIcons;
                    changed = true;
                }
            } else {
                if (this.model.layout != ej.FileExplorer.layoutType.Grid) {
                    this.model.layout = ej.FileExplorer.layoutType.Grid;
                    changed = true;
                }
            }
            if (changed) {
                this._switchLayoutView();
            }
        },
        _switchLayoutView: function (isCode) {
            var changed = false;
            var items = this._sorteditems;
            this._currentPath = this._originalPath;
            switch (this.model.layout) {
                case ej.FileExplorer.layoutType.LargeIcons:
                case ej.FileExplorer.layoutType.Tile:
                    this._gridtag.hide();
                    this._tileContent.parent().show();
                    this._tileViewWrapper.removeClass("e-tileInfo-view");
                    if (this._statusbar) {
                        this._statusbar.find(".e-swithListView").removeClass("e-active");
                        this._statusbar.find(".e-switchGridView").removeClass("e-active");
                    }
                    if (this.model.layout == ej.FileExplorer.layoutType.LargeIcons)
                        this._statusbar && this._statusbar.find(".e-swithListView").addClass("e-active");
                    else {
                        this._tileViewWrapper.addClass("e-tileInfo-view");
                        this.items = this._tileView.find("li.e-tilenode");
                        this._setThumbImageHeight();
                    }                        
                    this._renderTileView(items);
                    changed = true;
                    break;
                case ej.FileExplorer.layoutType.Grid:
                default:
                    this._tileView && this._tileContent.parent().hide();
                    this._gridtag.show();
                    this._renderGridView(items);
                    if (this._statusbar) {
                        this._statusbar.find(".e-swithListView").removeClass("e-active");
                        this._statusbar.find(".e-switchGridView").addClass("e-active");
                    }
                    changed = true;
                    break;
            }
            this._changeLayoutActive(this.model.layout);
            if (changed) {
                this._updateItemStatus(items);
                this._setSelectedItems(this.model.selectedItems);
                var args = { layoutType: this.model.layout, isInteraction: !isCode };
                this._trigger("layoutChange", args);
            }
        },
        _wireEvents: function () {
            this._on($('#' + this._ExplorerId + '_newFolder'), "click", this._createNewFolder);
            this._on($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
            this._on($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
            this._on(this.element, "keydown", this._keyDownOnInput);
            this._on(this._gridtag, "click", this._gridtagClick);
            this._on(this._tileViewWrapper, "click", this._tileViewWrapperClick);
            this.model.allowDragAndDrop && this._toolBarItems && this._on(this._toolBarItems, "dragover", this._preventDropOption);
        },
        _preventDropOption: function (e) {
                e.preventDefault();
                e.stopPropagation();
                e.originalEvent.dataTransfer.dropEffect = "none";
        },
        _onHideContextMenu: function() {
            (this._treeObj) && this._treeObj.element.find('.e-node-focus').removeClass('e-node-focus');
        },

        _adjustSize: function(args){
            this._isWindowResized = args ? true : false;
            this.adjustSize();
        },
        _closeDialog: function (event) {
            this._unwireDialogEvent(event);
            $(event.target).closest("div.e-dialog").find(".e-dialog").ejDialog("close");
        },

        _searchPath: function (event) {
            var code = this._getKeyCode(event);
            switch (code) {
                case 13:
                    this._searchbar && this._searchbar.val("");
                    var text = this._addresstag.val(), Items = text.split("/"), element = this._treetag;
                    if(this.model.path == "/")
                        Items[0] = "/";
                    for (var i = 0; i < Items.length; i++) {
                        if (Items[i]) {
                            element = this._findMatchingElement($(element).children("ul"), Items[i]);
                            if(element.length)
                                this._treetag.ejTreeView("selectNode", element) 
                            else {
                                this._setSelectedItems([Items[i]]);
                                if (this.model.selectedItems.length) {
                                    this._openAction();
                                }
                                else {
                                    this._alertDialog = this._createDialog(ej.buildTag('div.e-fe-dialog-label', String.format(this._getLocalizedLabels("ErrorPath"), text)), { width: 400, height: "auto", title: this._getLocalizedLabels("Error") });
                                    this._alertDialogObj = this._alertDialog.data("ejDialog");
                                }
                            }
                        }
                    }
                    break;
                case 27:
                    event.preventDefault();
                    this._updateAddressBar();
                    this._toolBarItems.focus();
                    break;
            }
        },

        _addressbarFocusout: function (event) {
            this._updateAddressBar();
        },

        _createDialog: function (contentTag, model) {
            var proxy = this;
            var dialog = ej.buildTag('div#' + this._ExplorerId + '_basicDialog.e-fe-dialog');
            $(contentTag).css("overflow", "hidden");
            $(dialog).append(contentTag);
            dialog.ejDialog({
                title: (model.title) ? model.title : "",
                width: model.width,
                maxWidth: "100%",
                isResponsive: proxy.model.isResponsive,
                target: proxy.element,
                closeIconTooltip: proxy._getLocalizedLabels("DialogCloseToolTip"),
                height: model.height,
                enableModal: true,
                showHeader: true,
                enableResize: false,
                enableAnimation: false,
                allowKeyboardNavigation: proxy.model.allowKeyboardNavigation,
                enableRTL: proxy.model.enableRTL,
                showRoundedCorner: proxy.model.showRoundedCorner,
                cssClass: this.model.cssClass + " e-fe-dialog",
                open: model.open,
                drag: function (e) { proxy._dialogDragEvent(e); },
                close: function (e) {  proxy._onDialogClose(e); }
            });
            return dialog;
        },
        _showErrorDialog: function (error) {
            this._alertDialog = this._createDialog(ej.buildTag('div.e-fe-dialog-label', error), { width: 400, height: "auto", title: this._getLocalizedLabels("Error") });
            this._alertDialogObj = this._alertDialog.data("ejDialog");
        },
        _findMatchingElement: function (element, text) {
            return $(element).children("li").filter(function (index) {
                if ($(this).find(".e-text:first").text() == text)
                    return $(this)
            });
        },
        _getKeyCode: function (e) {
            var code;
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            return code
        },


        _keyDownOnInput: function (e) {
            if ($(e.target).hasClass("e-tool-input"))
                return;
            var code = this._getKeyCode(e);
            if (!this.model.allowKeyboardNavigation) return;
            if (this._KeydownEventHandler(e)) return;
            switch (code) {
                case 49: // Ctrl + Shift + 1 for toolbar focus
                    if (e.shiftKey && e.ctrlKey && this.model.showToolbar) {
                        e.preventDefault();
                        this._addFocus(this._toolBarItems);
                    }
                    break;
                case 50: // Ctrl + Shift + 2 for treeview focus
                    if (e.shiftKey && e.ctrlKey && this.model.showNavigationPane) {
                        e.preventDefault();
                        this._addFocus(this._treetag);
                    }
                    break;
                case 51: // Ctrl + Shift + 3 for splitter focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._addFocus($(this._splittag.find(".e-splitbar")[0]));
                    }
                    break;
                case 52: // Ctrl + Shift + 4 for gridview focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.Grid);
                    }
                    break;
                case 53: // Ctrl + Shift + 5 for tileview focus
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.Tile);
                    }
                    break;
                case 54: // Ctrl + Shift + 6 for largeicons view
                    if (e.shiftKey && e.ctrlKey) {
                        e.preventDefault();
                        this._changeLayout(ej.FileExplorer.layoutType.LargeIcons);
                    }
                    break;
                case 55: // Ctrl + Shift + 7 for Statusbar focus
                    if (e.shiftKey && e.ctrlKey && this.model.showFooter) {
                        e.preventDefault();
                        this._addFocus(this._statusbar);
                    }
                    break;
                case 65: // Ctrl + A for select all file
                    if (e.ctrlKey) {
                        e.preventDefault();
                        var _items;
                        if (this.model.layout == "grid") {
                            _items = this.gridItems;
                            this._gridObj.clearSelection();
                            this._removeOldSelectionDetails();
                            this._addFocus(this._gridtag.find(".e-gridcontent"));
                            this._gridObj.selectRows(0, _items.length - 1, $(_items[_items.length - 1]).find("td:first"));
                        } else {
                            _items = this.items;
                            if (this.items.hasClass("e-active"))
                                this.items.removeClass("e-active").attr("aria-selected", false);
                            this._removeOldSelectionDetails();
                            this._addFocus(this._tileViewWrapper);
                            for (var i = 0; i < _items.length; i++) {
                                var e = { keyCode: 91, ctrlKey: true, currentTarget: _items[i], target: _items[i] };
                                this._upDatePathFromTileView(e);
                            }
                        }
                    }
                    break;
                case 78: // Alt + N for Create newfolder
                    if (e.altKey && this._hasEditContentsPermission(this._originalPath)) {
                        e.preventDefault();
                        this._createNewFolder();
                    }
                    break;
                case 85: // Ctrl + U for upload
                    if (e.ctrlKey && this._toUpload) {
                        e.preventDefault();
                        this.element.find(".e-uploadinput").click();
                    }
                    break;
                case 116: // F5 for refresh
                    e.preventDefault();
                    this._currentPath = this._originalPath;
                    this._highlightedNodes = this.model.selectedItems;
                    this._refreshItems((this._treeObj ? this._treeObj.getSelectedNode(): ""), this._originalPath);
                    break;
            }
        },
        _changeLayout: function (layout) {
            if (this.model.layout != layout) {
                this.model.layout = layout;
                this._removeFocus();
                this._switchLayoutView(layout);
            }
            this._focusLayout(layout);
        },
        _focusLayout: function (layout) {
            switch (layout) {
                case ej.FileExplorer.layoutType.Grid:
                    this._addFocus(this._gridtag.find(".e-gridcontent"));
                    break;
                case ej.FileExplorer.layoutType.Tile:
                case ej.FileExplorer.layoutType.LargeIcons:
                default:
                    this._addFocus(this._tileViewWrapper);
                    break;
            }
        },
        _getFocusedElement: function () {
            var focusedElement = this.element.find(".e-focus");
            return focusedElement = focusedElement ? focusedElement : $(':focus');
        },

        _addFocus: function (target) {
            if (!target.hasClass("e-focus")) {
                this._removeFocus();
                target.focus();
            }
        },
        _removeFocus: function () {
            var target = this._getFocusedElement();
            if (target.length > 0) {
                target.blur();
            }
        },

        _subControlsSetModel: function (prop, value) {
            var propObj = {};
            propObj[prop] = value;
            this._treeObj && this._treeObj.option(prop, value);
            if (this._downloadDialogObj && this._downloadDialogObj.isOpen()) this._downloadDialogObj.option(prop, value);
            if (this._newFolderDialogObj && this._newFolderDialogObj.isOpen()) this._newFolderDialogObj.option(prop, value);
            if (this._renameDialogObj && this._renameDialogObj.isOpen()) this._renameDialogObj.option(prop, value);
            if (this._openDialogObj && this._openDialogObj.isOpen()) this._openDialogObj.option(prop, value);
            if (this._detailsDialogObj && this._detailsDialogObj.isOpen()) this._detailsDialogObj.option(prop, value);
            if (this._alertDialogObj && this._alertDialogObj.isOpen()) this._alertDialogObj.option(prop, value);
            if (this._alertWindowObj && this._alertWindowObj.isOpen()) this._alertWindowObj.option(prop, value);
            this._treeContextMenutag && this._treeMenuObj.option(prop, value);
            this._tileContextMenutag && this._viewMenuObj.option(prop, value);
            this._toolBarObj && this._toolBarObj.option(prop, value);
            this._uploadtag && this._uploadtag.data("ejUploadbox").option(prop, value);
            this._splitObj && this._splitObj.option(prop, value);
            this._splitButtonObj && this._splitButtonObj.option(prop, value);
            this._splitButtonObj1 && this._splitButtonObj1.option(prop, value);
            this._statusbar.find("button").length && this._statusbar.find("button").ejButton(propObj);
            this._headCheckObj && this._headCheckObj.option(prop, value);
            this._tileView.find(".e-tile-checkbox").length && this._tileView.find(".e-tile-checkbox").ejCheckBox(propObj);
            this._gridtag.find(".e-grid-row-checkbox").length && this._gridtag.find(".e-grid-row-checkbox").ejCheckBox(propObj);
        },
        _removeDialog: function (obj) {
            obj.close();
            var isOverLay = obj._overLay;
            isOverLay && isOverLay.remove();
            obj._ejDialog.remove();
        },
        _reSizeHandler: function (args) {
            this._splitterCorrection();
            if (this.model.ajaxAction == "" || this._currentPath == "")
                return;
            if (this.model.layout == "grid") {
                var height = this._splittag.outerHeight() - this._gridtag.find(".e-gridheader").outerHeight();
                this._gridObj && this._gridObj.option("scrollSettings", { height: this.model.showFooter ? height - this._statusbar.outerHeight() : height, width: this._splittag.find(".e-cont2").width() });
            }
            else {
                this._tileScroll && this._tileScroll.option("width", parseInt(this._splittag.find(".e-cont2").width()));
                this._setThumbImageHeight();
            }
            this._treeScroll && this._treeScroll.option("width", parseInt(this._splittag.find(".e-cont1").width()));
            this._waitingPopup && this._waitingPopup.refresh();
        },
        _splitterCorrection: function () {
            var left = this._splittag.find(this.model.enableRTL ? ".e-cont2" : ".e-cont1").width() - 1;
            this._splittag.find(".e-split-divider").css("left", left).css("z-index", 1);
        },
        _findCommand: function (command, obj, isMenu) {
            var proxy = this;
            $.each(obj, function(key, val) {
                for(var j = 0, leng = val.length; j < leng; j++) {
                    if(val[j].toLowerCase() == command.toLowerCase()) {
                        command = isMenu ? proxy["_menu" + val[j]] : val[j];
                        return false;
                    }
                }
            });
            return command;
        },
        _getElement: function (node) {
            typeof node == "string" && (node = this._findCommand(node, this.model.tools));
            (typeof node != "object") && (node = (typeof node == "string") ? (this._toolBarObj.itemsContainer.find("li#" + node).length > 0 ? this._toolBarObj.itemsContainer.find("li#" + node) : this._toolBarObj.itemsContainer.find("li#" + this._ExplorerId + node.replace(/ /g, ''))) : this._toolBarObj.itemsContainer.find('li').eq(node));
            node = $(node);
            return $(node[0]);
        },
        _updateToolbar: function () {
            this._renderToolBar();
            this._selectedStates.length >= 2 && this._enableToolbarItem("Back");
            this._updateAddressBar();
            if (this._selectedItems.length > 0) {
                if (this._toRead) {
                    this._toDownload && this._enableToolbarItem("Download");
                    this._enableEditingTools();
                    this._toCopy && this._enableToolbarItem("Copy");
                }
            }
            if (!ej.isNullOrUndefined(this._fileName) && this._fileName != "")
                this._toRead && this._enableToolbarItem("Paste");
        },
        _enableEditingMenus: function () {
            var items = [this._menuRename, this._menuDelete, this._menuCut];
            for (var i = 0; i < items.length; i++) {
                if (this._restrictedMenuOption.indexOf(items[i]) < 0) {
                    this._viewMenuObj && this._viewMenuObj.enableItem(items[i]);
                    this._treeMenuObj && this._treeMenuObj.enableItem(items[i]);
                }
            }
        },
        _disableEditingMenus: function () {
            var items = [this._menuRename, this._menuDelete, this._menuCut];
            for (var i = 0; i < items.length; i++) {
                this._viewMenuObj && this._viewMenuObj.disableItem(items[i]);
                this._treeMenuObj && this._treeMenuObj.disableItem(items[i]);
            }
        },
        _updateSelectionDetails: function (nodeType) {
            if (this._selectedItems.length == 0)
                this._removeOldSelectionDetails(nodeType);
            else {
                this._updateToolbarItems();
                this._updateNewFolderTool(this._hasEditContentsPermission(this._originalPath));
            }
        },
        _updatePasteTool: function () {
            this._toolBarItems && ((this._option && this._toRead) ? this._enableToolbarItem("Paste") : this._disableToolbarItem("Paste"));
        },
        _updateAccessRules: function (path) {
            var _value = this._feParent[path];
            this._updateAccessValue(_value);
        },
        _updateAccessValue: function (_value) {
            if (!ej.isNullOrUndefined(_value) && !ej.isNullOrUndefined(_value.permission)) {
                if (!_value.permission.Copy) this._toCopy = false;
                if (!_value.permission.Download) this._toDownload = false;
                if (!_value.permission.Edit) this._toEdit = false;
                if (!_value.permission.EditContents) this._toEditContents = false;
                if (!_value.permission.Read) this._toRead = false;
                if (!_value.permission.Upload) this._toUpload = false;
            }
        },
        _updateToolbarItems: function () {
            if (this._toolBarItems) {
                (this._toRead && this._toDownload) ? this._enableToolbarItem("Download") : this._disableToolbarItem("Download");
                (this._toRead && this._toUpload) ? this._enableToolbarItem("Upload") : this._disableToolbarItem("Upload");
                (this._toRead && this._toEdit) ? this._enableEditingTools() : this._disableEditingTools();
                (this._toRead && this._toCopy) ? this._enableToolbarItem("Copy") : this._disableToolbarItem("Copy");
                this._updatePasteTool();
            }
        },
        _getFilePermission: function (path) {
            return this._feParent[path] ? this._feParent[path].permission : null;
        },
        _updateCurrentPathPermission: function () {
            this._removeOldSelectionDetails();
            this._toDownload = false; this._toUpload = this._toEdit = this._toEditContents = this._toRead = this._toCopy = true;
            this._updateAccessRules(this._originalPath);
            this._toolBarItems && (this._toUpload ? this._enableToolbarItem("Upload") : this._disableToolbarItem("Upload"));
            this._updateNewFolderTool(this._hasEditContentsPermission(this._originalPath));
            this._disableToolbarItem("Copy");
            this._updatePasteTool();
        },
        _updateNewFolderTool: function (value) {
            this._toolBarItems && (value ? this._enableToolbarItem("NewFolder") : this._disableToolbarItem("NewFolder"));
        },
        _hasEditContentsPermission: function (path) {
            var permission = this._getFilePermission(path);
            return permission ? ((permission.Read && permission.EditContents) ? true : false) : true;
        },
        _hasReadPermission: function (path) {
            var permission = this._getFilePermission(path);
            return (permission && !permission.Read) ? false : true;
        },
        _changeRootFolderName: function () {
            if (this.model.rootFolderName.length == 0) return;
            var element = this._treeObj.element.find('li:first > div > .e-text');
            this._treeObj.updateText(element, this.model.rootFolderName);
        },
        _changeName: function (path, changeRoot) {
            if (changeRoot)
                var newPath = path.replace(this._initPath, "").replace(this.model.rootFolderName, this._rootFolderName);
            else
                var newPath = path.replace(this._initPath, "").replace(this._rootFolderName, this.model.rootFolderName);
            return this._initPath + newPath;
        },
        _unwireEvents: function () {
            this._off($('#' + this._ExplorerId + '_newFolder'), "click", this._createNewFolder);
            this._off($('#' + this._ExplorerId + '_switchGridView'), "click", this._switchView);
            this._off($('#' + this._ExplorerId + '_swithListView'), "click", this._switchView);
            this._addressBarEvents("_off");
            this._off($('#' + this._ExplorerId + '_searchbar'), "focus", this._inputFocusin);
            this._off($('#' + this._ExplorerId + '_searchbar'), "keyup", this._onSearchKeyup);
            this._off(this.element, "keydown", this._keyDownOnInput);
            this._off(this._gridtag, "click");
            this._off(this._tileViewWrapper, "click");
            this.model.isResponsive &&this._off($(window),'resize',this._adjustSize);
            this._toolBarItems && this._off(this._toolBarItems, "dragover", this._preventDropOption);
        },

        _wireResizing: function () {
            this.model.isResponsive ? this._on($(window),'resize',this._adjustSize) :this._off($(window),'resize',this._adjustSize);
        },
        adjustSize: function () {
            this._ensureResolution();
            (!this._isWindowResized) && this.model.showToolbar && this.model.isResponsive && this._toolBarObj._reSizeHandler();
            this._isWindowResized = false;
            this._splittag.css('height', (this.element.height() - ((this.model.showToolbar && this._toolBarItems) ? this._toolBarItems.outerHeight() : 0)));
            var layoutHeight = this._splittag.outerHeight() - (this.model.showFooter ? this._statusbar.outerHeight() : 0);
            this._tileContent && this._tileContent.parent(".e-tile-wrapper").height(layoutHeight);
            this._tileScroll && this._tileScroll.option("height", layoutHeight);
            this._gridtag && this._gridtag.height(layoutHeight);
            this._splitObj && this._splitObj._windowResized();
            this._treeScroll && this._treeScroll.option("height", this._splittag.height());
            this._reSizeHandler();
        },
        refresh: function () {
            this._refreshItems(this._selectedNode, this._currentPath);
        },
        enableToolbarItem: function (liElement) {
            this._removeRestrictedToolItem(liElement);
            liElement = this._getElement(liElement);
            (liElement[0] != null && this._toolBarObj) && this._toolBarObj.enableItem(liElement);
        },
        disableToolbarItem: function (liElement) {
            liElement = this._getElement(liElement);
            if(liElement[0] != null && this._toolBarObj) {
                var operation = liElement.attr("id").replace(this._ExplorerId, "");
                this._restrictedToolbarOptions.push(operation);
                this._toolBarObj.disableItem(liElement);
            }
        },
        removeToolbarItem: function (liElement) {
            this._removeRestrictedToolItem(liElement);
            liElement = this._getElement(liElement);
            (liElement[0] != null && this._toolBarObj) && this._toolBarObj.removeItem(liElement);
        },
        _removeRestrictedToolItem: function (item) {
            var operation = typeof item == "string" ? item : item.attr("id").replace(this._ExplorerId, "");
            for (var i = 0; i < this._restrictedToolbarOptions.length; i++) {
                if (this._restrictedToolbarOptions[i] == operation) {
                    this._restrictedToolbarOptions.splice(i, 1);
                    break;
                }
            }
        },
        _onThumbStart: function (args) {
            if (this.model.allowMultiSelection && (args.originalEvent.type != "touchstart"))
                args.cancel = true;
            var dragElement = $(args.originalEvent.target);
            if (dragElement.hasClass("e-draggable") || dragElement.closest(".e-draggable").length) {
                args.cancel = true;
                return false;
            }
        }
    });
    ej.FileExplorer.Locale = {};

    ej.FileExplorer.Locale["en-US"] = {
        Folder: "Folder",
        EmptyFolder: "This folder is empty",
        ProtectedFolder:"You don't currently have permission to access this folder",
        EmptyResult:"No items match your search",
        Back: "Backward",
        Forward: "Forward",
        Upward:"Upward",
        Refresh: "Refresh",
        Addressbar: "Address bar",
        Upload: "Upload",
        Rename: "Rename",
        Delete: "Delete",
        Download: "Download",
        Error: "Error",
        PasteError: "Error",
        UploadError: "Error",
        RenameError: "Error",
        Cut: "Cut",
        Copy: "Copy",
        Paste: "Paste",
        Details: "Details",
        Searchbar: "Search bar",
        Open: "Open",
        Search: "Search",
        NewFolder: "New folder",
        SortBy: "Sort by",
        Size: "Size",
        RenameAlert: "Please enter new name",
        NewFolderAlert: "Please enter new folder name",        
        ContextMenuOpen: "Open",
        ContextMenuNewFolder: "New folder",
        ContextMenuDelete: "Delete",
        ContextMenuRename: "Rename",
        ContextMenuUpload: "Upload",
        ContextMenuDownload: "Download",
        ContextMenuCut: "Cut",
        ContextMenuCopy: "Copy",
        ContextMenuPaste: "Paste",
        ContextMenuGetinfo: "Get info",
        ContextMenuRefresh: "Refresh",
        ContextMenuOpenFolderLocation: "Open folder location",
        Item: "item",
        Items: "items",
        Selected: "selected",
        ErrorOnFolderCreation: "This destination already contains a folder named '{0}'. Do you want to merge this folder content with already existing folder '{0}'?",
        InvalidFileName: "A file name can't contain any of the following characters: \\/:*?\"<>|",
        GeneralError: "Please see browser console window for more information",
        ErrorPath: "FileExplorer can't find '{0}'. Check the spelling and try again.",
        PasteReplaceAlert: "File named '{0}' already exists. Replace old file with new one?",
        UploadReplaceAlert: "File named '{0}' already exists. Replace old file with new one?",
        DuplicateAlert: "There is already a file with the same name '{0}'. Do you want to create file with duplicate name",
        DuplicateFileCreation: "There is already a file with the same name in this location. Do you want to rename '{0}' to '{1}'?",
        DeleteFolder: " Are you sure you want to delete ",
        DeleteMultipleFolder: "Are you sure you want to delete these {0} items?",
        CancelPasteAction: "The destination folder is a subfolder of source folder.",
        OkButton: "OK",
        ContextMenuSortBy: "Sort by",
        CancelButton: "Cancel",
        YesToAllButton: "Yes to all",
        NoToAllButton: "No to all",
        YesButton: "Yes",
        NoButton: "No",
        SkipButton:"Skip",
        Grid: "Grid view",
        Tile: "Tile view",
        LargeIcons: "Large icons",
        Name: "Name",
        Location: "Location",
        Type: "Item type",
        Layout:"Layout",
        Created: "Created",
        Accessed: "Accessed",
        Modified: "Modified",
        Permission: "Permission",
        DialogCloseToolTip: "Close",
        UploadSettings: {
            buttonText: {
                upload: "Upload",
                browse: "Browse",
                cancel: "Cancel",
                close: "Close"
            },
            dialogText: {
                title: "Upload Box",
                name: "Name",
                size: "Size",
                status: "Status"
            },
            dropAreaText: "Drop files or click to upload",
            filedetail: "The selected file size is too large. Please select a file within the valid size.",
            denyError: "Files with #Extension extensions are not allowed.",
            allowError: "Only files with #Extension extensions are allowed.",
            cancelToolTip: "Cancel",
            removeToolTip: "Remove",
            retryToolTip: "Retry",
            completedToolTip: "Completed",
            failedToolTip: "Failed",
            closeToolTip: "Close"
        }
    };


    ej.FileExplorer.filterType = {
        /**  Supports to search text with startswith  */
        StartsWith: "startswith",
        /**  Supports to search text with contains */
        Contains: "contains",
        /**  Supports to search text with endswith */
        EndsWith: "endswith"        
    };
    ej.FileExplorer.layoutType = {
        Tile: "tile",
        Grid: "grid",
        LargeIcons: "largeicons"
    };
})(jQuery, Syncfusion);
;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.common = {
        
        refreshContent: function (refreshTemplate) {
            if (refreshTemplate) {
                this.refreshTemplate();
                this.refreshHeader();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                this._renderFilterBarTemplate();
            var args = {};
            this._initialRenderings();
            args.requestType = ej.Grid.Actions.Refresh;
            if (this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewData();
                this._virtualDataRefresh = true;
            }
            this._processBindings(args);
        },

        
        rowHeightRefresh: function () {
            if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.model.currentViewData) && this.model.currentViewData.length) {
                var frozenRows = this.getContentTable().get(0).rows;
                var movableRows = this.getContentTable().get(1).rows, height = 0;
                if (this.getContent().find(".e-frozencontentdiv").is(":visible"))
                    for (var i = 0; i < frozenRows.length; i++) {
                        if ($(frozenRows[i]).css("display") == "none")
                            continue;
                        var frozenHeight = frozenRows[i].getClientRects()[0].height;
                        var movableHeight = movableRows[i].getClientRects()[0].height;
                        if (ej.isNullOrUndefined(frozenHeight) || ej.isNullOrUndefined(movableHeight))
                            height = ej.max([frozenRows[i].offsetHeight, movableRows[i].offsetHeight]);
                        else
                            height = ej.max([frozenHeight, movableHeight]);
                        $(frozenRows[i]).height(height); $(movableRows[i]).height(height);
                        if (i && (i == this.model.scrollSettings.frozenRows - 1 || i == frozenRows.length - 1))
                            height = height + 1;
                        if (!this.model.allowTextWrap) {
                            if (!i || i == this.model.scrollSettings.frozenRows - 1)
                                height = height - 1;
                        }
                        if (this.model.isEdit && $(frozenRows[i]).find("#" + this._id + "EditForm").length && i){
                            $(frozenRows[i]).find("#" + this._id + "EditForm td").css("height", height); 
							$(movableRows[i]).find("#" + this._id + "EditForm td").css("height", height);
						}
                    }
                if (this.model.showSummary && this.model.summaryRows.length > 0) {
                    var frozenFooterRows = this.getFooterTable().get(0).rows;
                    var movableFooterRows = this.getFooterTable().get(1).rows, footerHeight = 0;
                    for (var j = 0; j < frozenFooterRows.length ; j++) {
                        footerHeight = ej.max([frozenFooterRows[j].getClientRects()[0].height, movableFooterRows[j].getClientRects()[0].height]);
                        $(frozenFooterRows[j]).height(footerHeight); $(movableFooterRows[j]).height(footerHeight);
                    }
                }
                this._getRowHeights()
                if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && (this.getScrollObject()._vScrollbar != null || this.getScrollObject().isVScroll())) {
                    var scroller = this.getScrollObject()._vScrollbar;
                    if (ej.isNullOrUndefined(scroller) || scroller.value() != scroller.model.maximum)
						this._scrollObject.refresh(this.model.scrollSettings.frozenColumns > 0);                        
                }

            }
        },
                
        dataSource: function (dataSource, templateRefresh) {
            if (templateRefresh)
                this._templateRefresh = true;
            this._dataSource(dataSource);
			this._currentPage(1);
			if(this.model.scrollSettings.enableVirtualization){
				this._currentVirtualIndex = 1;
				if (this.getContent().ejScroller("isVScroll"))
					this.getContent().ejScroller("scrollY", 0, true);
			}
			this._updateDataSource = true;
			this._refreshDataSource(dataSource, templateRefresh);			
			if (this.model.allowPaging || this.model.scrollSettings.allowVirtualScrolling) {
			    var model = this._refreshVirtualPagerInfo();
			    this._showPagerInformation(model);
			}
            if (this.model.scrollSettings.allowVirtualScrolling) {
				if(this.model.scrollSettings.enableVirtualization && this._isLocalData)
					this._refreshVirtualView(); 
				else
					this._refreshVirtualContent(); 
                if (this.getContent().ejScroller("isHScroll"))
                    this.getContent().ejScroller("scrollX", 0, true);
                if (this.getContent().ejScroller("isVScroll")) {
					if(!this.model.scrollSettings.enableVirtualization)
						this.getContent().ejScroller("scrollY", 0, true);
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
			if(!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount)
				this._addLastRow();
			this._trigger("dataBound", {});
        },
        _refreshDataSource: function (dataSource, refreshTemplate) {
            if (dataSource instanceof ej.DataManager)
                this._dataManager = dataSource;
            else
                this._dataManager = ej.DataManager(dataSource);
			this._isRemoteSaveAdaptor = (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.remoteSaveAdaptor);
            this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataManager.dataSource.offline || this._isRemoteSaveAdaptor || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor));
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				this._refreshVirtualViewData();
				this._virtualDataRefresh = true;
				this._isLocalData && this._refreshVirtualViewDetails(true);
			}
			this.refreshContent(ej.isNullOrUndefined(refreshTemplate) ? true : refreshTemplate);
        },
        _hideRowTemplateColumns: function (column, state) {
            var index = $.inArray(column, this.model.columns);
            this.getContentTable().find("tbody:first > tr").find('> td:nth-child(' + (index + 1) + ')')[state == "hide" ? "addClass" : "removeClass"]("e-hide");
        },
        hideColumns: function (c) {
            var i, count = 0, args = {}, index, colIndex, newHideCol = []; var htext, field, hiddenFrozenCount = 0;
            htext = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
			colIndex = typeof (c) == "number"? this.getColumnByIndex(c) : this.getColumnByIndex(c[0]);
            field = typeof (c) == "string" ? this.getColumnByField(c) : this.getColumnByField(c[0]);
            this._showHideColumns = true;
            var colHeaderText = [];
            $.map(this.model.columns, function (val, i) {
                colHeaderText.push(val.headerText)
            });
            var duparr = this._isDuplicate(colHeaderText);
            var hidden = !duparr ? "_hiddenColumns" : "_hiddenColumnsField";
            var visible = !duparr ? "_visibleColumns" : "_visibleColumnsField";
			if (!duparr && (field != null || colIndex != null)){
                if ($.isArray(c)) {
                    for (var i = 0; i < c.length; i++) {
                      var cfield = (colIndex != null) ? this.getColumnByIndex(c[i]):this.getColumnByField(c[i]); 
                        c[i] = cfield != null ? cfield.headerText : c[i];
                    }
                }
                else
                    c = (colIndex != null) ? colIndex.headerText: field.headerText;
            }
		    var getColumnMethod = (colIndex != null) ? "getColumnByIndex": "getColumnByHeaderText";
            if ($.isArray(c)) {
                for (i = 0; i < c.length; i++) {
                    index = $.inArray(c[i], this[visible]);
                    
                    if (index != -1) {
                        this[hidden].push(c[i]);
                        this[visible].splice(index, 1);
                    }
					else if(index==-1 && visible=="_visibleColumnsField" && $.inArray(c[i],this[hidden])==-1 && ej.isNullOrUndefined(this.getColumnByField(c[i]))){
					    this[hidden].push(this[getColumnMethod](c[i]).field) && this["_hiddenColumns"].push(this[getColumnMethod](c[i]).field);
					    this[visible].splice($.inArray(this[getColumnMethod](c[i]).field, this[visible]), 1) && this["_visibleColumns"].splice($.inArray(c[i], this["_visibleColumns"]), 1);
					}
                    if (this.model.rowTemplate != null) {
                        var templateColumn = index != -1 ? this.getColumnByHeaderText(c[i]) : this[getColumnMethod](c[i]);
                        this._hideRowTemplateColumns(templateColumn, "hide");
                    }
				}
            } else {
                index = $.inArray(c, this[visible]);
                if (index != -1) {
                    this[hidden].push(c);
                    this[visible].splice(index, 1);
                }
				else if(index==-1 && visible=="_visibleColumnsField" && $.inArray(c,this[hidden])==-1 && ej.isNullOrUndefined(this.getColumnByField(c))){
				    this[hidden].push(this[getColumnMethod](c).field) && this["_hiddenColumns"].push(this[getColumnMethod](c).field);
				    this[visible].splice($.inArray(this[getColumnMethod](c).field, this[visible]), 1) && this["_visibleColumns"].splice($.inArray(c, this["_visibleColumns"]), 1);
				}
                if (this.model.rowTemplate != null) {
                    var templateColumn = index != -1 ? this.getColumnByHeaderText(c) : this[getColumnMethod](c);
                    this._hideRowTemplateColumns(templateColumn, "hide");
                }
            }
            for (i = 0; i < this.model.columns.length; i++) {
                var com = !duparr ? "headerText" : "field";
                if ($.inArray(ej.isNullOrUndefined(this.model.columns[i][com]) || this.model.columns[i][com] == "" ? this.model.columns[i]["headerText"] : this.model.columns[i][com], this[hidden]) != -1) {
                    this.model.columns[i].visible && newHideCol.push(this.model.columns[i]);
                    this.model.columns[i].visible = false;
                    if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0 && this.model.columns.indexOf(this.model.columns[i]) < this.model.scrollSettings.frozenColumns)
                        hiddenFrozenCount++;
                    count++;
                }
                if (this[hidden].length == count)
                    break;
            }
            args.requestType = "refresh"; args.action = "hideColumn";
            this._hideHeaderColumn(this[hidden], duparr);
            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
                var $table = this._renderGridHeader();
                this.element.find('.e-gridheader').replaceWith($table[0])
                if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") this._renderFiltering();
                if (this.model.allowReordering)
                   this._headerCellreorderDragDrop();
            }
            this.refreshTemplate();
            if (this.model.scrollSettings.allowVirtualScrolling)
                this._virtualShowHide(args);
            if(this._isAddNew && this.model.isEdit){
                this.model.query = this.commonQuery.clone();
                this._ensureDataSource(args);
                this._isAddNew = false;
            }
            this.sendDataRenderingRequest(args);
            this.rowHeightRefresh();
            if (this.model.allowScrolling) {
                if (this.model.scrollSettings.frozenColumns == 0 && !ej.isIOSWebView() && this.getBrowserDetails().browser == "msie") {
                    var tableWidth = this._calculateWidth();
					this.getHeaderTable().width(tableWidth);
                    this.getContentTable().width(tableWidth);
                    if (!ej.isNullOrUndefined(this.getFooterTable()))
                        this.getFooterTable().width(tableWidth);
                }
                if (!ej.isNullOrUndefined(this._scrollObject))
                this.getScrollObject().refresh();
            }
            if (this.model.showColumnChooser)
                this._refreshColumnChooserList();
             if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
				if(hiddenFrozenCount == this.model.scrollSettings.frozenColumns){
				    this._frozenPaneRefresh();
				}				
                 this.getScrollObject().refresh();
             }
			this._showHideColumns = false;
        },
        
        showColumns: function (c) {
            var i, count = 0, args = {}, index, colIndex, column, newVisColumns = []; var htext, field;
            htext = typeof (c) == "string" ? this.getColumnByHeaderText(c) : this.getColumnByHeaderText(c[0]);
			colIndex = typeof (c) == "number"? this.getColumnByIndex(c) : this.getColumnByIndex(c[0]);
            field = typeof (c) == "string" ? this.getColumnByField(c) : this.getColumnByField(c[0]);
            
			this._showHideColumns = true;
            var colHeaderText = [];
            $.map(this.model.columns, function (val, i) {
                colHeaderText.push(val.headerText)
            });
            var duparr = this._isDuplicate(colHeaderText);
            var hidden = !duparr ? "_hiddenColumns" : "_hiddenColumnsField";
            var visible = !duparr ? "_visibleColumns" : "_visibleColumnsField";
			if (!duparr && (field != null || colIndex != null)){
                if ($.isArray(c)) {
                    for (var i = 0; i < c.length; i++) {
                      var cfield = (colIndex != null) ? this.getColumnByIndex(c[i]):this.getColumnByField(c[i]); 
                        c[i] = cfield != null ? cfield.headerText : c[i];
                    }
                }
                else
                    c = (colIndex != null) ? colIndex.headerText: field.headerText;
             }
		    var getColumnMethod = (colIndex != null) ? "getColumnByIndex": "getColumnByHeaderText";
            if ($.isArray(c)) {
                for (i = 0; i < c.length; i++) {
                    index = $.inArray(c[i], this[hidden]);
                    
                    if (index != -1) {
                        this[hidden].splice(index, 1);
                        this[visible].push(c[i]);
                    }
					else if(index==-1 && hidden=="_hiddenColumnsField" && $.inArray(c[i],this[visible])==-1 && ej.isNullOrUndefined(this.getColumnByField(c[i]))){
					    this[visible].push(this[getColumnMethod](c[i]).field) && this["_visibleColumns"].push(c[i]);
					    this[hidden].splice($.inArray(this[getColumnMethod](c[i]).field, this[hidden]), 1) && this["_hiddenColumns"].splice($.inArray(c[i], this["_hiddenColumns"]), 1);
					}
                    if (this.model.rowTemplate != null) {
                        var templateColumn = index != -1 ? this.getColumnByHeaderText(c[i]) : this[getColumnMethod](c[i]);
                        this._hideRowTemplateColumns(templateColumn, "show");
                    }
                }
            } else {
                index = $.inArray(c, this[hidden]);
                if (index != -1) {
                    this[hidden].splice(index, 1);
                    this[visible].push(c);
                }
				else if(index==-1 && hidden=="_hiddenColumnsField" && $.inArray(c,this[visible])==-1 && ej.isNullOrUndefined(this.getColumnByField(c))){
				    this[visible].push(this[getColumnMethod](c).field) && this["_visibleColumns"].push(c);
				    this[hidden].splice($.inArray(this[getColumnMethod](c).field, this[hidden]), 1) && this["_hiddenColumns"].splice($.inArray(c, this["_hiddenColumns"]), 1);
				}
                if (this.model.rowTemplate != null) {
                    var templateColumn = index != -1 ? this.getColumnByHeaderText(c) : this[getColumnMethod](c);
                    this._hideRowTemplateColumns(templateColumn, "show");
                }
            }
            for (i = 0; i < this.model.columns.length; i++) {
                var com = !duparr ? "headerText" : "field";
                if ($.inArray(ej.isNullOrUndefined(this.model.columns[i][com]) || this.model.columns[i][com] == "" ? this.model.columns[i]["headerText"] : this.model.columns[i][com], this[visible]) != -1) {
                    !this.model.columns[i].visible && newVisColumns.push(this.model.columns[i])
                    this.model.columns[i].visible = true;
                    count++;
                }
                if (this[visible].length == count)
                    break;
            }


            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns > 0) {
                var frozenHide = false;
                for (var i = 0; i < newVisColumns.length; i++) {
                    var index = this.model.columns.indexOf(newVisColumns[i]);
                    if (index < this.model.scrollSettings.frozenColumns)
                        frozenHide = true;
                }
                if (frozenHide) {
					for(var i = 0; i < this.model.columns.length; i++){
						if($.inArray(this.model.columns[i].headerText, this["_hiddenColumns"]) != -1)
							this.model.columns[i].visible = false;
						else if($.inArray(this.model.columns[i].headerText, this["_visibleColumns"]) != -1)
							this.model.columns[i].visible = true;
					}
                    var $table = this._renderGridHeader();
                    this.element.find('.e-gridheader').replaceWith($table[0])
                    if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") this._renderFiltering();
                    if (this.model.allowReordering)
                        this._headerCellreorderDragDrop();
                }
            }

            args.requestType = "refresh"; args.action = "showColumn";
            this._showHeaderColumn(this[visible], duparr);

            this.refreshTemplate();
            if (this.model.scrollSettings.allowVirtualScrolling)
                this._virtualShowHide(args);
            if (this._isAddNew && this.model.isEdit) {
                this.model.query = this.commonQuery.clone();
                this._ensureDataSource(args);
                this._isAddNew = false;
            }
            this.sendDataRenderingRequest(args);
            this.rowHeightRefresh();
            if (this.model.allowScrolling && !ej.isNullOrUndefined(this._scrollObject)) {
                this.getScrollObject().refresh();
            }
            if (this.model.showColumnChooser)
                this._refreshColumnChooserList();
			this._showHideColumns = false;
        },
        _virtualShowHide: function (args) {
            this._currentPage(1);
            this.model.query = this.commonQuery.clone();
            this._ensureDataSource(args);
            this._loadedJsonData = [];
            this._prevPage = this._currentPage();
        },
        
        resizeColumns: function (column, width) {
            if (column instanceof Array) {
                for (var i = 0; i < column.length; i++) {
                    var colWidth = width instanceof Array ? width[i] : width;
                    this._setWidthColumnCollection(column[i], colWidth);
                }
            }
            else
                this._setWidthColumnCollection(column, width);
            this.setWidthToColumns();
            if (this.model.scrollSettings.frozenColumns){
                this._frozenAlign();
                this.rowHeightRefresh();
            }
        },
        _setWidthColumnCollection: function (column, width) {
            var col = this.getColumnByHeaderText(column) || this.getColumnByField(column);
            col.width = width;
            if ($.inArray(col.field, this._disabledResizingColumns) == -1)
                this.columnsWidthCollection[$.inArray(col, this.model.columns)] = width;
        },
        
        refreshTemplate: function () {
            this.addInitTemplate();
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
				this._processEditing();
            }
            if (this.model.allowGrouping) this.addGroupingTemplate();
        },
        refreshHeader: function () {
            var $header = this.element.find(".e-gridheader");
            this.element[0].replaceChild(this._renderGridHeader()[0], $header[0]);           
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                this._renderFiltering();
            this.model.allowGrouping && this._headerCellgDragDrop(); 
            this.model.allowReordering && this._headerCellreorderDragDrop();
            this.model.showColumnChooser && this._renderColumnChooserData(true);
			if(this.model.gridLines != "both")
			    this._showHeaderGridLines();
			if (this.model.mergeHeaderCellInfo != null) {
			    this.setWidthToColumns();
			    var args = { columnHeaders: this.getHeaderContent().find(".e-columnheader"), model: this.model }, proxy = this;
			    this._headerCellMerge(args);
			    this._trigger("mergeHeaderCellInfo", args);
			}
            this.refreshScrollerEvent();
        },        
        set_dropColumn: function (from, to) {
            if (this.model.allowReordering && from != to) {
                this.model.columns.splice(to, 0, this.model.columns.splice(from, 1)[0]);
                var columns = this.model.columns;
                var $header = this.getHeaderTable().find(".e-columnheader:last .e-headercell").not(".e-stackedHeaderCell");
                var $headerCell = $header.find(".e-headercelldiv");
                var scrollLeft = this.getHeaderContent().find("div").first().scrollLeft();
                if (this.model.allowSorting && this.model.sortSettings.sortedColumns.length || this.model.groupSettings.showToggleButton) {
                    $header.find("span.e-ascending").remove();
                    $header.find("span.e-descending").remove();
                    $header.find("span.e-gridgroupbutton").remove();
                }
                if (this.model.allowSorting && this.model.sortSettings.sortedColumns.length) 
                    $header.eq(from).find("span").remove();
                if (!this.model.scrollSettings.frozenColumns)
                    this.getHeaderTable().find("colgroup").replaceWith(this._getMetaColGroup());
                (this.model.detailsTemplate != null || this.model.childGrid != null) && this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());

                //Remove and Returns name/value pair of element attributes
                var removeAttr = function (ele) {
                    var names = []; if (ele == undefined) return;
                    if (["", undefined].indexOf(ele.value) == -1) {
                        names.push({ name: "value", value: ele.value }); ele.value = "";
                    }
                    for (var e = 0, eAttr = ele.attributes, eLen = eAttr.length; e < eLen; e++) {
                        var regex = /^jQuery[0-9]+$/;
                        !eAttr[e].name.match(regex) && names.push({ name: eAttr[e].name, value: eAttr[e].value });
                    }
                    for (var a = 0, aLen = names.length; a < aLen; a++) {
                        $(ele).removeAttr(names[a].name);
                    }
                    return names;
                };
                //Add attributes to the ele
                var addAttr = function (coll, ele) {
                    if (ele == undefined) return;
                    for (var e = 0, eLen = coll.length; e < eLen; e++) {
                        if (coll[e].name == "value") ele.value = coll[e].value;
                        $(ele).attr(coll[e].name, coll[e].value);
                    }
                };

                if (this.getHeaderTable().find(".e-fltrtempdiv").length == 0 && this.getHeaderTable().find(".e-filterdiv").length > 0)
                    var $filterCell = this.getHeaderTable().find(".e-filterdiv input");
                var $fState = ej.isNullOrUndefined($filterCell);
                var $attributeCollection = { "cellattributes": [], "headerattributes": [], "filtercellattributes": [], "filterThattributes": [] };
                var fromIndex = from < to ? from : to;
                var toIndex = from < to ? to : from;
                
                for (var i = fromIndex, j = 0; i <= toIndex; i++) {
                    var hIndx = (this.model.detailsTemplate != null || this.model.childGrid != null) ? i + 1 : i;
                    $attributeCollection.headerattributes[j] = removeAttr($header[hIndx]);
                    $attributeCollection.cellattributes[j] = removeAttr($headerCell[i]);
                    $attributeCollection.filtercellattributes[j] = !$fState ? removeAttr($filterCell[i]) : [];
                    $attributeCollection.filterThattributes[j] = !$fState ? removeAttr($($filterCell[i]).closest("th")[0]) : [];
                    j++;
                }

                var spliceFrom = from < to ? $attributeCollection.cellattributes.length - 1 : 0;
                var spliceTo = from < to ? 0 : $attributeCollection.cellattributes.length - 1;

                for (var prop in $attributeCollection)
                    $attributeCollection[prop].splice(spliceFrom, 0, $attributeCollection[prop].splice(spliceTo, 1)[0]);

                
                for (var i = fromIndex, j = 0; i <= toIndex; i++) {
                    var indx = (this.model.detailsTemplate != null || this.model.childGrid != null) ? i + 1 : i;
                    addAttr($attributeCollection.headerattributes[j], $header[indx]);
                    addAttr($attributeCollection.cellattributes[j], $headerCell[i]);
                    !$fState && addAttr($attributeCollection.filtercellattributes[j], $filterCell[i]);
                    !$fState && addAttr($attributeCollection.filterThattributes[j], $($filterCell[i]).closest("th")[0]);
                    j++;
                }
                if (this.model.allowFiltering && ["menu", "excel"].indexOf(this.model.filterSettings.filterType) != -1) {
                    if (this._$fDlgIsOpen)
                        this._closeFDialog();
                    var col = this.model.columns;
                    $header.find(".e-filtericon").remove();
                    for (var i = 0; i < col.length; i++) {
                        if (col[i]["allowFiltering"] || ej.isNullOrUndefined(col[i]["allowFiltering"])) {
                            var filterHeader = $header.find(".e-headercelldiv[data-ej-mappingname=\"" + col[i].field + "\"]").closest(".e-headercell")
                            filterHeader.append(ej.buildTag('div.e-filtericon e-icon e-filterset'));
                        }
                    }
                    this._refreshFilterIcon();
                }

                this.columnsWidthCollection.splice(to, 0, this.columnsWidthCollection.splice(from, 1)[0]);
                var headerCell;
                this._fieldColumnNames = this._headerColumnNames = [];
                for (var count = 0; count < columns.length; count++) {
                    this._fieldColumnNames[columns[count].headerText] = columns[count].field;
                    this._headerColumnNames[columns[count].field] = columns[count].headerText;
                    headerCell = $($headerCell[count]);
                    header = $($header[count]);
                    if (!ej.isNullOrUndefined(columns[count].headerTemplateID))
                        headerCell.html($(columns[count]["headerTemplateID"]).html());
                    else if (columns[count].type == "checkbox")
                        headerCell.html("<input type = 'checkbox' class = 'e-checkselectall'></input>");
                    else
                    columns[count].disableHtmlEncode ? headerCell.text(columns[count].headerText) : headerCell.html(columns[count].headerText);
                    if (this.model.groupSettings.showToggleButton && (ej.isNullOrUndefined(columns[count].allowGrouping) || columns[count].allowGrouping)) {
                        if ($.inArray(columns[count].field, this.model.groupSettings.groupedColumns) != -1)
                            header.append(this._getToggleButton().addClass("e-toggleungroup"));
                        else
                            header.append(this._getToggleButton().addClass("e-togglegroup"));
                        var $filterset = this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell").find(".e-filterset");
                        $filterset.addClass("e-groupfiltericon");
                        if(this.model.enableRTL && !$filterset.length)
                            header.find(".e-togglegroupbutton").addClass("e-rtltoggle");
                    }
                }
                if (this.model.allowGrouping && this.model.allowSorting != true) {
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                        this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
                }
                if (this.model.allowSorting) {
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                        var opacity = 1;
                        var $sCol = this.model.sortSettings.sortedColumns[i];
                        var sortcolumn = this.getsortColumnByField($sCol.field);
                        var index = this.getColumnIndexByField($sCol.field);
                        var sortindex = $.inArray(sortcolumn, this.model.sortSettings.sortedColumns),
                        imageDirection = $sCol.direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
                        if (this.model.allowMultiSorting) {
                            for (var j = 1; j <= sortindex; j++) {
                                opacity = opacity + 1;
                            }
                            if ($headerCell.eq(index).css("text-align") == "right") {
                                if(this.model.sortSettings.sortedColumns.length > 1)
                                    $headerCell.eq(index).prepend(this._createSortNumber(opacity, $headerCell.eq(index)).addClass("e-sortnumber"));
                                $header.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                            }
                            else {
                                $header.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                                if (this.model.sortSettings.sortedColumns.length > 1)
                                    $headerCell.eq(index).append(this._createSortNumber(opacity, $headerCell.eq(index)).addClass("e-sortnumber"));
                            }
                        }
                        else {
                            imageDirection = $sCol.direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
                            $header.eq(index).append(this._createSortElement().addClass("e-" + ($sCol.direction || "ascending") + " " + imageDirection));
                        }
                        var $headertraversal = this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell").eq(index);
                        var $filterset = $headertraversal.find(".e-filterset");
                        var $togglegroup = $headertraversal.find(".e-gridgroupbutton");
                        $filterset.addClass("e-sortfiltericon");
                        if(this.model.groupSettings.showToggleButton){
                            $filterset.addClass("e-sortfiltergroupicon");
                            $togglegroup.addClass("e-togglesortgroupfilter");
                            if(this.model.enableRTL && $filterset.length)
                                $headertraversal.find(".e-ascending,.e-descending").addClass("e-rtlsortfiltertoggle");
                        }
                        if(this.model.enableRTL) {
                            if((!$filterset.length || !$togglegroup.length) && (!$filterset.length && !$togglegroup.length))
                                $headertraversal.find(".e-ascending,.e-descending").addClass("e-rtlsortadjust");
                            else if(!$filterset.length || !$togglegroup.length)
                                $headertraversal.find(".e-ascending,.e-descending").addClass("e-rtlgrouporfilter");
                        }
                        else if(!this.model.enableRTL && !$filterset.length && !$togglegroup.length)
                            $headertraversal.find(".e-ascending,.e-descending").addClass("e-sortadjust");
                    }
                }
                if(this.getHeaderTable().find(".e-fltrtempdiv").length > 0 ){
                    this.getHeaderTable().find(".e-filterbar").first().remove();
					this._renderFiltering();
					this._renderFilterBarTemplate();
				}
                var args = {};
                args.requestType = ej.Grid.Actions.Reorder;
                this._isReorder = true;
                this.refreshTemplate();
				if(this._isAddNew && this.model.isEdit){
					this.model.query = this.commonQuery.clone();
					this._ensureDataSource(args);
					this._isAddNew = false;
				}
				this.setWidthToColumns();
				if (!this.model.scrollSettings.frozenColumns)
				    this.getHeaderContent().find("div").first().scrollLeft(scrollLeft);
                this.sendDataRenderingRequest(args);
                this._isReorder = false;
            }
        },
        
        getPager: function () {
            return this._gridPager;
        },
        
        getFooterTable: function () {
            return this._gridFooterTable;
        },

        setGridFooterTable: function (value) {
            this._gridFooterTable = value;
        },
        
        getFooterContent: function () {
            return this._gridFooterContent;
        },

        setGridFooterContent: function (value) {
            this._gridFooterContent = value;
        },
        
        getScrollObject: function () {
            if (this._scrollObject == null || ej.isNullOrUndefined(this._scrollObject.model))
                this._scrollObject = this.getContent().ejScroller("instance");
            return this._scrollObject;
        },
        setGridPager: function (value) {
            this._gridPager = value;
        },
        
        getRowHeight: function () {
            var rowHeight = -1;
			if (this.getContentTable() != null) {
				var trColl = this.getContentTable().find('tr:not(.e-virtualrow)'), index = trColl.length > 2 ? 1 : 0;
				if(trColl.length)
					var $trBound = trColl[index].getBoundingClientRect();
				if (trColl.length > 1) {
					if ($trBound && $trBound.height) {
						rowHeight = $trBound.height;
					} else
						rowHeight = trColl[index].offsetHeight;
				}
			}
			else if (!ej.isNullOrUndefined(this.model.rowTemplate) && !ej.isNullOrUndefined(this._dataSource()) && this._dataSource().length > 0) {
			    var temp = document.createElement('div');
			    var myTemplate = $.templates(this.model.rowTemplate);
			    var data = this._dataSource()[0];
			    temp.innerHTML = ['<table class="e-template-table">', myTemplate.render(data), '</table>'].join("");
			    $("body").append(temp.firstChild);
			    var tr = $("body").find(".e-template-table").find("tr")[0];
			    rowHeight = tr.offsetHeight;
			    $("body").find(".e-template-table").remove();
			}
            return rowHeight == -1 ? 32 : rowHeight;
        },
        
        getCurrentIndex: function () {
            return ((this._currentPage() - 1) * (this.model.pageSettings.pageSize));
        },
        
        getColumnByIndex: function (index) {
            if (index < this.model.columns.length)
                return this.model.columns[index];
            return null;
        },
        set_currentPageIndex: function (val) {
            var pageSetting = this.model.pageSettings;
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (pageSetting.totalPages == null)
                pageSetting.totalPages = Math.ceil(recordCount / pageSetting.pageSize);
            if (val > pageSetting.totalPages || val < 1 || val == this._currentPage())
                return false;
            if (ej.isNullOrUndefined(this._prevPageNo))
                this._prevPageNo = this._currentPage();
            this._currentPage(val);
            if (this._currentPage() != this._prevPageNo) {
                var args = {};
                args.requestType = "paging";
                this.gotoPage(this._currentPage(), args);
                return true;
            }
            else
                return false;
        },
        set_currentVirtualIndex: function (currentViewIndex) {                          
            if (currentViewIndex < 1 || (currentViewIndex != 1 && currentViewIndex != this._totalVirtualViews && currentViewIndex == this._currentVirtualIndex && this._checkCurrentVirtualView(this._virtualLoadedRows, currentViewIndex)))
                return false;                      
            this._prevVirtualIndex = this._currentVirtualIndex;							
            this._currentVirtualIndex = currentViewIndex;
			var currentPage = this._calculateCurrentViewPage();
			if(currentPage <= this.model.pageSettings.totalPages && !this._checkCurrentVirtualView(this._virtualLoadedRecords, this._currentVirtualIndex)){				
				if(this._prevVirtualIndex < currentViewIndex && currentViewIndex != 1){
					var setPage = this._isThumbScroll && currentPage != 1 ? currentPage : currentPage + 1;
                    if(!this._virtualPageRecords[setPage] && setPage <= this.model.pageSettings.totalPages)
                        this._setCurrentViewPage(setPage); 
					else	
						this._renderVirtulViewContent(currentPage);	
				}
				else if(this._prevVirtualIndex > currentViewIndex){
					var setPage = this._isThumbScroll ? currentPage : currentPage - 1;
                    if(this._virtualPageRecords[setPage] && !this._virtualLoadedRecords[currentViewIndex - 1])
                        setPage = currentPage - 1;
                    if(!this._virtualPageRecords[setPage] && setPage >= 1)
                        this._setCurrentViewPage(setPage);                                                     
				}                                                
                else 
                    this._renderVirtulViewContent(currentPage);
            }
            else 
                this._renderVirtulViewContent(currentPage);
            return true;            
        },
		_setCurrentViewPage: function(currentPage){
			this._needPaging = true;                
			this._prevPageNo = this._currentPage();             
            this.gotoPage(currentPage);
		},
		_renderVirtulViewContent: function(currentPage){
            this._needPaging = false;                      
            this._refreshVirtualView(this._currentVirtualIndex);
            this.element.ejWaitingPopup("hide");
        },
        _checkCurrentVirtualView: function(virtualContent, viewIndex){
            var virtualRowCount = this._virtualRowCount;            
            var prevView = viewIndex - 1, nextView = viewIndex + 1;
			if(virtualContent instanceof Array){
				if(virtualContent.length){
					if(((prevView == 0 || nextView == this._totalVirtualViews + 1) && $.inArray(viewIndex, virtualContent) != -1) || ($.inArray(prevView, virtualContent) != -1 && 
					$.inArray(viewIndex, virtualContent) != -1 && $.inArray(nextView, virtualContent) != -1))
						return true;					
				}				
			}
			else{
				var nextViewData = nextView == this._totalVirtualViews ? this._lastViewData : virtualRowCount;
				if((!this.initialRender && (viewIndex == 1 && this._virtualLoadedRows[viewIndex]) || viewIndex == this._totalVirtualViews && virtualContent == this._virtualLoadedRows && virtualContent[viewIndex]) ||
					((prevView == 0  && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount) || (nextView == this._totalVirtualViews + 1 && virtualContent[viewIndex] && virtualContent[viewIndex].length == this._lastViewData)) ||
					(virtualContent[prevView] && virtualContent[prevView].length == virtualRowCount && virtualContent[viewIndex] && virtualContent[viewIndex].length == virtualRowCount && virtualContent[nextView] && virtualContent[nextView].length == nextViewData))
						return true;								
			}
			return false;
        },
        expandCollapse: function ($target) {
            if ($target.prop("tagName") == "DIV" && ($target.parent().hasClass("e-recordplusexpand") || $target.parent().hasClass("e-recordpluscollapse") || $target.parent().hasClass("e-detailrowcollapse") || $target.parent().hasClass("e-detailrowexpand")))
                $target = $target.parent();
            var index = -1, fieldName, fieldvalue, parentGroup, collapsed;
            if (this.model.allowGrouping && (ej.isOnWebForms || this.initialRender)) {
                fieldName = $target.attr("data-ej-mappingname");
                fieldValue = $target.attr("data-ej-mappingvalue");
                if ($target.parents(".e-tabletd").length)
                    parentGroup = $target.parents(".e-tabletd").parent("tr").prev("tr").find(".e-recordplusexpand").attr("data-ej-mappingvalue");
                collapsed = this.model._groupingCollapsed;
                for (var i = 0; i < collapsed.length; i++) {
                    if (collapsed[i].key == fieldName && collapsed[i].value == fieldValue && (collapsed[i].parent == undefined || collapsed[i].parent == parentGroup)) {
                        index = i;
                        break;
                    }
                }
            }
            if (!($target.hasClass("e-recordplusexpand") || $target.hasClass("e-recordpluscollapse") || $target.hasClass("e-detailrowcollapse") || $target.hasClass("e-detailrowexpand")))
                return;
            if ($target.hasClass("e-recordplusexpand") && this.model.groupSettings.groupedColumns.length) {
                var cellIndex = $target.index();
                var $rows = $target.closest('tr').next();
                $rows.hide();
                $target.removeClass("e-recordplusexpand").addClass("e-recordpluscollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                if ((ej.isOnWebForms || this.initialRender) && index == -1)
                    this.model._groupingCollapsed.push({ key: fieldName, value: fieldValue, parent: parentGroup })
            } else if ($target.hasClass("e-recordpluscollapse") && this.model.groupSettings.groupedColumns.length) {
                var cellIndex = $target.index();
                var $rows = $target.closest('tr').next();
                var toExpandRows = [];
                var $row = $rows;
                if ($($row[0].cells[cellIndex]).hasClass("e-indentcell")) {
                    if ($row.children(".e-indentcell").length == ($target.parent().children('.e-indentcell').length) + 1) {
                        $row.show();
                        var $expand = $row.children(".e-recordplusexpand");
                        if ($expand != null && $expand.length > 0) {
                            toExpandRows.push($expand);
                        }
                    }
                }
                $target.removeClass("e-recordpluscollapse").addClass("e-recordplusexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                for (var i = 0; i < toExpandRows.length; i++) {
                    toExpandRows[i].removeClass("e-recordplusexpand").addClass("e-recordpluscollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                    this.expandCollapse(toExpandRows[i]);
                }
                if ((ej.isOnWebForms || this.initialRender) && index != -1)
                    this.model._groupingCollapsed.splice(index, 1);
            } else if ($target.hasClass("e-detailrowexpand")) {
                var cellIndex = $target.index(), proxy = this;
                var rowIndexValue = this.getIndexByRow($target.closest('tr'));
                var $rows = $target.closest('tr').next();
                $rows.hide(0, function () {
                    var args = { masterRow: $target.closest('tr'), detailsRow: $rows, masterData: proxy._currentJsonData[rowIndexValue] };
                    var foreignKeyData = proxy._getForeignKeyData(args.masterData);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    proxy._trigger("detailsCollapse", args);
                });
                (proxy.model.childGrid != null || proxy.model.detailsTemplate != null) && proxy.model.allowScrolling && proxy._refreshScroller({ requestType: "refresh" });
                $target.removeClass("e-detailrowexpand").addClass("e-detailrowcollapse").find("div").addClass("e-gnextforward").removeClass("e-gdiagonalnext");
            } else if ($target.hasClass("e-detailrowcollapse")) {
                var cellIndex = $target.index(), proxy = this;
                var rowIndexValue = this.getIndexByRow($target.closest('tr'));
                var detailrow = $target.closest('tr').next();
                if (detailrow.hasClass("e-detailrow"))
                    $rows = detailrow;
                else {
                    var detailtr = ej.buildTag("tr.e-detailrow", "", { 'display': 'none' }, {});
                    var indenttd = ej.buildTag("td.e-detailindentcell");
                    var detailstd = ej.buildTag("td.e-detailcell", "", {}, { colspan: this._visibleColumns.length });
                    var detaildiv = ej.buildTag("div");
                    var count = $($target.closest('tr')).parents('.e-grid').length;
                    detaildiv.attr("id", "child" + count + "_grid" + rowIndexValue + Math.round(Math.random() * 1000));
                    $(detailtr).append(indenttd);
                    $(detailtr).append(detailstd);
                    var rowData = this._currentJsonData[rowIndexValue];
                    if (this.model.detailsTemplate) {
                        var detailTemplate = this.model.detailsTemplate,
                        ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (detailTemplate.startsWith("#") || detailTemplate.startsWith(".") || typeof detailTemplate === "object") ? this.model.ngTemplateId + "griddetailstemplate" : null;
                        $(detailtr).append(detailstd.append(this._renderEjTemplate(this.model.detailsTemplate, rowData, rowIndexValue, null, ngType)));
                    }
                        
                    $($target.closest('tr')).after(detailtr);
                    if (this.model.childGrid) {
                        this.model.childGrid["parentDetails"] = {
                            parentID: this._id,
                            parentPrimaryKeys: this.getPrimaryKeyFieldNames(),
                            parentKeyField: this.model.childGrid.queryString,
                            parentKeyFieldValue: rowData[this.model.childGrid.queryString],
                            parentRowData: rowData
                        }
                        $(detailtr).append(detailstd.append(detaildiv));
                    }
                    $rows = detailtr;
                }
                this._showGridLines();
                var toExpandRows = [];
                var $row = $rows;
                if ($($row[0].cells[cellIndex]).hasClass("e-detailindentcell")) {
                    $row.show(0, function () {
                        var args = { masterRow: $target.closest('tr'), detailsRow: $rows, masterData: proxy._currentJsonData[rowIndexValue] };
                        var foreignKeyData = proxy._getForeignKeyData(args.masterData);
                        if (!ej.isNullOrUndefined(foreignKeyData))
                            args.foreignKeyData = foreignKeyData;
                        proxy._trigger("detailsExpand", args);
                    });
                    if (!detailrow.hasClass("e-detailrow")) {
                        this._trigger("detailsDataBound", { detailsElement: detailtr, data: rowData, rowData: rowData }); // $(tbody).append(trchild);
                       this._trigger("refresh");
                    }
                    this.model.childGrid && !ej.isNullOrUndefined(detaildiv) && detaildiv.ejGrid(this.model.childGrid);
                    (proxy.model.childGrid != null || proxy.model.detailsTemplate != null) && proxy.model.allowScrolling && proxy._refreshScroller({ requestType: "refresh" });
                    var $expand = $row.children(".e-detailrowexpand");
                    if ($expand != null && $expand.length > 0) {
                        toExpandRows.push($expand);
                    }
                }
                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").addClass("e-gdiagonalnext").removeClass("e-gnextforward");
                for (var i = 0; i < toExpandRows.length; i++) {
                    toExpandRows[i].removeClass("e-detailrowexpand").addClass("e-detailrowcollapse").find("div").removeClass("e-gdiagonalnext").addClass("e-gnextforward");
                    this.expandCollapse(toExpandRows[i]);
                }
            }
            if (this.model.allowScrolling && !ej.isNullOrUndefined(this._scrollObject && this._scrollObject.model) && !$target.closest(".e-hscroll").length)
                this.getScrollObject().refresh();
            if (this.model.isResponsive)
                this.windowonresize();

        },
        _refreshGridPager: function () {
            if (this.getPager() != null) {
                var pagerModel = this.getPager().ejPager("model"), model = {};
                model.currentPage = this._currentPage();
                if ((ej.isNullOrUndefined(this._filteredRecordsCount) || this._filteredRecordsCount == 0) && (this.model.currentViewData != null && this.model.currentViewData.length == 0) && (ej.isNullOrUndefined(this._prevPageNo) || this._prevPageNo)) {
                    model.currentPage = 0;
                    this._prevPageNo = pagerModel.currentPage;
                    this.model.pageSettings.currentPage = 0;
                } else if (pagerModel.currentPage == 0 && (ej.isNullOrUndefined(this._prevPageNo) || this._prevPageNo))
                    model.currentPage = this._prevPageNo;
                 var excludeTr = this.model.editSettings.showAddNewRow  && this.model.groupSettings.groupedColumns.length ==  0 ? 1 : 0;
                model.totalRecordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount - excludeTr : this._searchCount : this._filteredRecordsCount;
                if (model.totalRecordsCount == 0 && model.currentPage != 0) {
                    model.currentPage = 0;
                    this.model.pageSettings.currentPage = 0;
                }
                if (ej.util.isNullOrUndefined(model.currentPage))
                    model.currentPage = this._currentPage();
                this.getPager().ejPager("option", model).ejPager("refreshPager");
                this.model.pageSettings.totalPages = pagerModel.totalPages || null;
				this.model.pageSettings.totalRecordsCount = pagerModel.totalRecordsCount || null;
            }
        },
        _showHeaderColumn: function (showColumns, field) {
            var $head = this.getHeaderTable().find("thead");
            var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
            var $filterBarCell = $head.find(".e-filterbar").find(".e-filterbarcell");
            var $col = this.getHeaderTable().find("colgroup").find("col"), column;
            for (var i = 0; i < showColumns.length; i++) {
                if (field)
                    column = ej.isNullOrUndefined(this.getColumnByField(showColumns[i])) ? this.getColumnByHeaderText(showColumns[i], ej.isNullOrUndefined(this.getColumnByField(showColumns[i]))) : this.getColumnByField(showColumns[i]);
                else
                    column = this.getColumnByHeaderText(showColumns[i]);
                var index = $.inArray(column, this.model.columns);
                index = (this.model.detailsTemplate != null || this.model.childGrid) ? index + 1 : index;
                var frznCol = this.model.scrollSettings.frozenColumns;
                if (frznCol != 0 && index >= frznCol)
                    var thIndex = $headerCell.eq(index).removeClass("e-hide").index() + frznCol;
                else
                    var thIndex = $headerCell.eq(index).removeClass("e-hide").index();
                $filterBarCell.eq(thIndex).removeClass("e-hide");
				 if ($col.length > this.model.columns.length && this.model.groupSettings.groupedColumns.length){
					var len = $col.length - this.model.columns.length;
					$col = $col.slice((this.model.detailsTemplate || this.model.childGrid) ? len + 1 : len);				
				}
                $col.eq(index).css("display", "");
            }
            if (this.model.showStackedHeader)
                this._refreshStackedHeader();
        },
        _hideHeaderColumn: function (hiddenColumns, field) {
            var $head = this.getHeaderTable().find("thead");
            var $headerCell = $head.find("tr").not(".e-stackedHeaderRow").find(".e-headercell");
            var $filterBarCell = $head.find(".e-filterbar").find(".e-filterbarcell");
            var $col = this.getHeaderTable().find("colgroup").find("col"), column;
            for (var i = 0; i < hiddenColumns.length; i++) {
                if (field)
                    column = ej.isNullOrUndefined(this.getColumnByField(hiddenColumns[i])) ? this.getColumnByHeaderText(hiddenColumns[i], ej.isNullOrUndefined(this.getColumnByField(hiddenColumns[i]))) : this.getColumnByField(hiddenColumns[i]);
                else
                    column = this.getColumnByHeaderText(hiddenColumns[i]);
                var index = $.inArray(column, this.model.columns);
                var dindex = (this.model.detailsTemplate != null || this.model.childGrid) ? index + 1 : index;
                var frznCol = this.model.scrollSettings.frozenColumns;
                if (frznCol != 0 && index >= frznCol)
                    var thIndex = $headerCell.eq(dindex).addClass("e-hide").index() + frznCol;
                else
                    var thIndex = $headerCell.eq(dindex).addClass("e-hide").index();
                $filterBarCell.eq(thIndex).addClass("e-hide");
                if ($col.length > this.model.columns.length)
                    $col = $col.slice($col.length - this.model.columns.length);
                $col.eq(index).css("display", "none");
            }
            if (this.model.showStackedHeader) {
                this._refreshStackedHeader();
                this._colgroupRefresh();
            }
        },
        _refreshStackedHeader: function () {
			if(this.model.showStackedHeader){
            var stackedRows = this.model.stackedHeaderRows;
            for (var i = 0; i < stackedRows.length; i++) {
                if (this.model.scrollSettings.frozenColumns != 0) {
                    var frznHeader = $(this.getHeaderContent().find(".e-frozenheaderdiv"));
                    var movHeader = $(this.getHeaderContent().find(".e-movableheader"));
                    var newFrzn = this._createStackedRow(stackedRows[i], true);
                    var newMov = this._createStackedRow(stackedRows[i], false);
                    $(frznHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newFrzn);
                    $(movHeader.find("tr.e-stackedHeaderRow")[i]).replaceWith(newMov);
                }
                else {
                    var stackedTR = this._createStackedRow(stackedRows[i], false);
                    if (this.getHeaderTable().find("tr.e-stackedHeaderRow")[i])
                        $(this.getHeaderTable().find("tr.e-stackedHeaderRow")[i]).replaceWith(stackedTR);
                    else
                        stackedTR.insertBefore(this.getHeaderTable().find("tr.e-columnheader:last"));
                }
            }
            var args = {};
            args.requestType = "refresh";
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0) {
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    this.getHeaderTable().find(".e-stackedHeaderRow").prepend(this._getGroupTopLeftCell());
            }
            this.model.allowScrolling && this._refreshScroller(args);
			}

        },
        _getStackedColumnByTarget: function (target) {
            var cls = (target.get(0) || {}).className, match = /e-row([0-9])-column([0-9])/.exec(cls),
                rIndx = match[1], cIndx = match[2], key = [rIndx, "stackedHeaderColumns", cIndx].join(".");

            return ej.getObject(key, this.model.stackedHeaderRows);
        },
        _checkSkipAction: function (args) {
            switch (args.requestType) {
                case ej.Grid.Actions.Save:
                case ej.Grid.Actions.Delete:
                    return true;
            }
            return false;
        },
        _unboundTemplateRendering: function (unboundTemplateId) {
            return $("#" + unboundTemplateId).html();
        },
        _processBindings: function (args) {
            this._requestType = args.requestType;
            this.model.query = this.commonQuery.clone();
            if (!this._checkSkipAction(args) && this._trigger("actionBegin", args))
                return true;
            if (this.model.editSettings.editMode == "batch" && args.requestType != "batchsave" && args.requestType != "cancel" && !this._confirmedValue && this._bulkChangesAcquired() && this.model.editSettings.showConfirmDialog) {
                this._confirmDialog.find(".e-content").html(this.localizedLabels.BatchSaveLostChanges);
                this._confirmDialog.ejDialog("open");
                this._requestArgs = args;
                return false;
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && args.requestType == "refresh" && this.model.scrollSettings.allowVirtualScrolling) {
                this._currentPage(1);
                this._scrollValue = 0;
                this._loadedJsonData = [];
                this._prevPage = this._currentPage();
            }
            this._ensureDataSource(args);
            if (this.model.scrollSettings.allowVirtualScrolling) {
                if (args.requestType == "virtualscroll") {
                    this._loadedJsonData.push({ pageIndex: this._prevPage, data: this._currentJsonData });
                    this._prevPage = this._currentPage();
                }
                else if (!this.model.scrollSettings.enableVirtualization) {
                    this._virtualLoadedRecords[this._currentPage()] = !ej.isNullOrUndefined(this._currentPageData) ? this._currentPageData : this.model.currentViewData;
                    this._currentPageData = null;
                }
                if (args.requestType == "filtering") {
                    this._loadedJsonData = [];
                    this._prevPage = this._currentPage(); $("#" + this._id + "_externalEdit").remove();
                }
                if (args.requestType == ej.Grid.Actions.Delete || args.requestType == ej.Grid.Actions.Add)
                    this._refreshVirtualViewDetails();
            }
            if (this.model.scrollSettings.allowVirtualScrolling && args.requestType == "filtering" && this.model.filterSettings.filteredColumns.length >0) 
                this.getScrollObject().scrollY(0);
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
            } else {
                this.element.hasClass("e-rtl") && this.element.removeClass("e-rtl")
            }
            if (args.requestType == ej.Grid.Actions.Delete && this.model.groupSettings.groupedColumns.length == 0) {
                if (this.model.editSettings.showAddNewRow)
                    this.getContentTable().find(".e-addedrow").remove();
                args.tr.remove();
            }
            this._editForm = this.model.scrollSettings.frozenColumns > 0 || this.model.editSettings.showAddNewRow ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
			if (!(this.model.editSettings.showAddNewRow && args.requestType == "beginedit") && this._editForm.length != 0) {
                for(var i=0;i<this._editForm.length;i++){
					$(this._editForm[i]).find("select.e-dropdownlist").ejDropDownList("destroy");
					$(this._editForm[i]).find(".e-datepicker").ejDatePicker("destroy");
					$(this._editForm[i]).find(".e-datetimepicker").ejDateTimePicker("destroy");
					$(this._editForm[i]).find(".e-numerictextbox").ejNumericTextbox("destroy");
				}
            }
			if ((this._dataSource() instanceof ej.DataManager && !this._isRemoteSaveAdaptor && args.requestType != ej.Grid.Actions.BeginEdit && args.requestType != ej.Grid.Actions.Cancel && args.requestType != ej.Grid.Actions.Add) && (!(this._dataSource().adaptor instanceof ej.SqlDataSourceAdaptor) || (args.requestType != ej.Grid.Actions.Save && args.requestType != ej.Grid.Actions.Delete))) {
			    if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage && this.virtualLoadedPages.indexOf(((this.model.pageSettings.currentPage - 2) * (this.model.pageSettings.pageSize))) == -1) {
                    var pageQuery = ej.pvt.filterQueries(this.model.query.queries, "onPage");
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                    var lastQueryPromise = this._dataSource().executeQuery(this.model.query);
                    this.model.query.queries.splice($.inArray(pageQuery[0], this.model.query.queries), 1);
                    this.model.query.page(this._currentPage(), this.model.pageSettings.pageSize);
                }
                if (this._virtualSelectedRows && this._virtualSelectedRows.length > 0) {
                    this.model.query.addParams('virtualSelectRecords', this._virtualSelectedRows)
                }
                var queryPromise = this._queryPromise = this._dataSource().executeQuery(this.model.query);
                var waitingPopup = this.element.ejWaitingPopup("instance");
                var proxy = this;
                this.element.ejWaitingPopup("show");
                if (proxy._dataSource().ready) {
                    proxy._dataSource().ready.done(function () {
                        proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                    });
                }
                else {
                    proxy._processDataRequest(proxy, args, queryPromise, lastQueryPromise)
                }
            } else {
                if (this._isRelationalRendering(args))
                    this._setForeignKeyData(args);
                else
                    this.sendDataRenderingRequest(args);
            }
        },
        _processDataRequest: function (proxy, args, queryPromise, lastQueryPromise) {
            queryPromise.done(ej.proxy(function (e) {
                if (ej.isNullOrUndefined(proxy.element) || proxy._dataSource().adaptor instanceof ej.SqlDataSourceAdaptor)
                    return;
                if (lastQueryPromise && !proxy._previousPageRendered)
                    proxy._processLastPageData(proxy, args, e, lastQueryPromise);
                else if (proxy._remoteLastPageRendered && proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy.model.scrollSettings.enableVirtualization) {
                    var count = proxy.model.pageSettings.pageSize - proxy._previousPageLength;
                    for (var dupRow = 0; dupRow < count; dupRow++) {
                        var removeEle = proxy.getRows()[proxy.getRows().length - (proxy.model.pageSettings.pageSize - dupRow)];
                        removeEle.remove();
                    }
                    proxy._tempPageRendered = true;
                    proxy.model.currentViewData = e.result;
                    proxy._relationalColumns.length == 0 && proxy.element.ejWaitingPopup("hide");
                }
                else {
                    if (proxy._identityKeys.length && args.action == "add" && this.adaptor instanceof ej.ODataAdaptor)
                        proxy._processIdentityField(e.result, args);
                    if (proxy.model.pageSettings.currentPage == proxy.model.pageSettings.totalPages - 1 && !proxy._remoteLastPageRendered)
                        proxy._previousPageRendered = true;
                    proxy.model.currentViewData = e.result == null ? [] : e.result;
                    if (proxy._$fkColumn && proxy.model.filterSettings.filterType == "excel" && proxy.model.filterSettings.filteredColumns.length > 0)
                        proxy._fkParentTblData = e.result;
                    proxy._relationalColumns.length == 0 && proxy.element.ejWaitingPopup("hide");
                }
				if(proxy.model.allowScrolling && proxy.model.scrollSettings.allowVirtualScrolling && proxy.model.scrollSettings.enableVirtualization){
					if(args.requestType == "filtering"){
						proxy._gridRecordsCount = proxy._filteredRecordsCount = e.count;
						proxy._refreshVirtualViewDetails();
					}
					if(e.result.length){
					    if (proxy._isInitNextPage || proxy._isLastVirtualpage) {
                            proxy._gridRecordsCount = e.count;
                            proxy._refreshVirtualViewDetails();
					        proxy._setInitialCurrentIndexRecords(e.result, proxy._currentPage());
					        proxy._isInitNextPage = proxy._isLastVirtualpage = false;
					    }
					    else {
					        proxy._gridRecordsCount = e.count;
                            proxy._refreshVirtualViewDetails();
					        proxy._setVirtualLoadedRecords(e.result, proxy._currentPage());
					    }
						if(proxy._isThumbScroll && !proxy._checkCurrentVirtualView(proxy._virtualLoadedRecords, proxy._currentVirtualIndex))
							proxy._checkPrevNextViews();																										
						proxy._remoteRefresh = true;
					}
					else
						proxy.getContent().find(".e-virtualtop, .e-virtualbottom").remove();					
				}
                if (!ej.isNullOrUndefined(e.aggregates))
                    proxy._remoteSummaryData = e.aggregates;
                if (ej.isNullOrUndefined(lastQueryPromise) || (ej.isNullOrUndefined(proxy._previousPageRendered) || proxy._previousPageRendered))
                    proxy._processData(e, args);
				if (!ej.isNullOrUndefined(proxy._unboundRow) && args.selectedRow != proxy._unboundRow && args.requestType == "save") {
                    proxy._unboundRow.find(".e-editbutton").trigger("click");
                    proxy._unboundRow = null;
                }
            }));
            queryPromise.fail(ej.proxy(function (e) {
                if (ej.isNullOrUndefined(proxy.element))
                    return;
                proxy.element.ejWaitingPopup("hide");
                args.error = e.error;
                e = [];
                proxy.model.currentViewData = [];
                proxy._processData(e, args);
                if (!ej.isNullOrUndefined(proxy.getPager())) {
                    proxy.getPager().ejPager({ currentPage: 0, totalRecordsCount: 0 });
                }
                proxy._trigger("actionFailure", args);
            }));
        },
        _processIdentityField: function (result, args) {
            var _pKey = this._primaryKeys[0];
            var resultPK = ej.distinct(result, _pKey);
            var curPK = ej.distinct(this.model.currentViewData, _pKey);
            var addPK = $.grep(resultPK, function (value) {
                if ($.inArray(value, curPK) == -1)
                    return true;
                return false;
            });
            var data = ej.DataManager(result).executeLocal(new ej.Query().where(_pKey, "equal", addPK))[0]
            args.data = ej.isNullOrUndefined(data) ? args.data : data;
        },
        _processLastPageData: function (proxy, args, currentData, lastQueryPromise) {
            lastQueryPromise.done(ej.proxy(function (e) {
                proxy.element.ejWaitingPopup("hide");
                proxy.model.previousViewData = e.result;
                if (proxy.model.previousViewData && proxy.model.previousViewData.length != 0) {
                    proxy._previousPageLength = currentData.result.length;
                    proxy._currentPageData = currentData.result;
                    ej.merge(proxy.model.previousViewData, currentData.result);
                    proxy.model.currentViewData = proxy.model.previousViewData;
                    proxy._remoteLastPageRendered = true;
                }
                proxy._processData(currentData, args);
            }));
            lastQueryPromise.fail(ej.proxy(function (e) {
                proxy.element.ejWaitingPopup("hide");
                args.error = e.error;
                e = [];
                proxy.model.previousViewData = [];
                proxy._processData(e, args);
                proxy._trigger("actionFailure", args);
            }));
        },
        _createUnboundElement: function (column,count) {
            var divElement = document.createElement("div");
            column.headerText = !ej.isNullOrUndefined(column.headerText) ? column.headerText : ej.isNullOrUndefined(column.field) ? "" : column.field;
            if (!ej.isNullOrUndefined(column.headerText))
                divElement.id = this._id + column.headerText.replace(/[^a-z0-9|s_]/gi, '') + count + "_UnboundTemplate";
            var $div = ej.buildTag("div.e-unboundcelldiv"), commands = column["commands"];
            for (var unbounType = 0; unbounType < commands.length; unbounType++) {
                var $button = ej.buildTag("button.e-flat e-" + commands[unbounType].type.replace(/\s+/g, "") + "button", "", {}, { type: "button" });
                $button.val(commands[unbounType].type);
                if (commands[unbounType].type == "save" || commands[unbounType].type == "edit")
                    $button.addClass("e-btnsub")
                if (commands[unbounType].type == "cancel" || commands[unbounType].type == "delete")
                    $button.addClass("e-btncan")
                $div.append($button);
            }
            $("body").append($(divElement).html($div).hide());
            return divElement;
        },
        _refreshUnboundTemplate: function ($target) {
            if (this._isUnboundColumn) {
                var index = 0;
                for (var column = 0; column < this.model.columns.length; column++) {
                    if (this.model.columns[column]["commands"]) {
                        var $unboundDivs = $target.find(".e-unboundcell.e-" + this.model.columns[column]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+column).find(".e-unboundcelldiv");
                        var commands = $.extend(true, [], this.model.columns[column].commands);
                        for (var j = 0; j < commands.length; j++) {
                            if (ej.isNullOrUndefined(commands[j].buttonOptions))
                            commands[j].buttonOptions = {};
                            commands[j].buttonOptions.width = ej.isNullOrUndefined(commands[j].buttonOptions.width) ? "52" : commands[j].buttonOptions.width;
                            commands[j].buttonOptions.height = ej.isNullOrUndefined(commands[j].buttonOptions.height) ? "28" : commands[j].buttonOptions.height;
                            commands[j].buttonOptions.cssClass = ej.isNullOrUndefined(commands[j].buttonOptions.cssClass) ? this.model.cssClass : commands[j].buttonOptions.cssClass;
                            commands[j].buttonOptions.enableRTL = this.model.enableRTL;
                            var $buttons = $unboundDivs.find(".e-" + commands[j].type.replace(/\s+/g, "") + "button");
                            if (!this.model.isEdit || this._requestType == "cancel") {
								if ($target.closest(".e-editcell").length) {
									if (commands[j].type == "save" || commands[j].type == "cancel")
										$buttons.show();
									else {
										$buttons.hasClass("e-deletebutton") && $buttons.hide();
										$buttons.hasClass("e-editbutton") && $buttons.hide();
									}
								} else {
									if (commands[j].type == "save" || commands[j].type == "cancel")
										$buttons.hide();
									else {
										$buttons.hasClass("e-deletebutton") && $buttons.show();
										$buttons.hasClass("e-editbutton") && $buttons.show();
									}
								}
                            }
                            for (var i = 0; i < $buttons.length; i++) {
                                if ($($buttons[i]).data("ejButton"))
                                    $($buttons[i]).ejButton("destroy");
                            }
                            $buttons.ejButton(commands[j].buttonOptions);
                        }
                    } else
                        continue;
                }
            }
        },
        _gridTemplate: function (self, templateId, index) {
            var $column = self.model.columns[index];
            if (self.model.scrollSettings.enableVirtualization)
                this.index += self._currentVirtualRowIndex;
            if ((!ej.isNullOrUndefined(self.model.ngTemplateId) && self._isAddNew) || !ej.isNullOrUndefined(self._isGrouping))
                this.index = self._isAddNew ? 0 : self._currentJsonData.indexOf(this.data);
            return self._renderEjTemplate("#" + templateId, this.data, this.index, $column);
        },
        _createTemplateElement: function (column, appendTo /* container to append */, text) {
            var tmpl = column["templateID" in column ? "templateID" : "template"], quickReg = /^#([\w-]*)/,
                match = quickReg.exec(tmpl), scriptReg = /^<script/i, appendTo = appendTo || $("body"), scripEle,
                idText = text ? "Pager" : (column.headerText + $.inArray(column, this.model.columns) + "_") + "Template";

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: tmpl,
                id: (this._id + idText).replace(/(\\|[^0-9A-z-_])/g, "")
            };

            if ( match && match[1] )
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(tmpl)) // branch here to handle tmpl string with SCRIPT. 
                    scripEle = $(tmpl).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }

            scripEle.id = scripEle.id || options.id; // Update Id and type if not in scriptElement template string.
            scripEle.type = scripEle.type || options.type;

            appendTo.append(text ? scripEle.innerHTML : scripEle); //if `text` then append innerHTML instead of element.

            return scripEle;
        },
        _renderGridPager: function () {
            var $div = $(document.createElement('div'));
            var pagerModel = {};
            this.model.pageSettings.change = this._gPagerClickHandler;
            this.model.pageSettings.pageSizeSelected = this._gPageSize;
            this.model.pageSettings.totalRecordsCount = this._gridRecordsCount || null;
            this.model.pageSettings.enableRTL = this.model.enableRTL;
            this.model.pageSettings.locale = this.model.locale;
            this.model.pageSettings.enableQueryString = this.model.pageSettings.enableQueryString;
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                pagerModel.enableExternalMessage = this.model.filterSettings.showFilterBarStatus;
            $.extend(pagerModel, this.model.pageSettings);
            pagerModel.currentPage = this._currentPage();
            pagerModel.masterObject = this;
            this.setGridPager($div);
            if(pagerModel.template != undefined)
                pagerModel.template = null;
            $div.ejPager(pagerModel);
            $div.ejPager("refreshPager");
            pagerModel = $div.ejPager("model");
            this.model.pageSettings.totalPages = pagerModel.totalPages || null;
            if (this._currentPage() !== pagerModel.currentPage)
                this._currentPage(pagerModel.currentPage);
            this._renderPagerTemplate($div);
            return $div;
        },
        _renderPagerTemplate: function (pager, showDefaults) {
            var model = this.model.pageSettings, defaults = pager.find(".e-pagercontainer").not(".e-template").length == 0;            
            pager.find(".e-pagercontainer.e-template").remove();

            if ((showDefaults || !model.enableTemplates) && defaults) //Used to enable default pager from disabled
                pager.ejPager("renderPager");

            if (model.enableTemplates) {                

                if (!model.showDefaults)
                    pager.children().remove();               

                var $customDiv = ej.buildTag('div', null, null, { "class": "e-pagercontainer e-template", "style": "width: auto;" });                
                this._createTemplateElement(this.model.pageSettings, $customDiv, true);                
                pager.append($customDiv)
            }          
           
        },
        _renderContext: function (e) {
            var menuitems = this.model.contextMenuSettings.contextMenuItems;
            var item, item2, i = 0;
            var ul = ej.buildTag('ul', "", {}, { id: this._id + '_Context' });
            if (!this.model.contextMenuSettings.disableDefaultItems) {
                for (i; i < menuitems.length; i++) {
                    item = menuitems[i];
                    item2 = this._items(item, "contextMenuItem");
                    ul.append(item2);
                }
            }
            var customitems = this.model.contextMenuSettings.customContextMenuItems;
            var subMenuItems = this.model.contextMenuSettings.subContextMenu;
            var custom, custom2, j = 0, template;
            for (j; j < customitems.length; j++) {
                custom = customitems[j];
                custom2 = this._items(custom, "customContextMenuItem");                
                for (var k = 0 ; k < subMenuItems.length; k++)
                    if ((typeof custom == "string" && custom ==  subMenuItems[k].contextMenuItem) || (typeof custom == "object" && custom.id ==  subMenuItems[k].contextMenuItem )) {
                        template = subMenuItems[k].template;
                        var ul1 = ej.buildTag('ul', "", {}, { id: this._id + '_subMenuContext' + k }), menuItem, menuItem1;
                        if(!ej.isNullOrUndefined(template))
                            ul1 = this._renderEjTemplate(template);
                        else{
                            for (var l = 0; l < subMenuItems[k].subMenu.length; l++) {
                                menuItem = subMenuItems[k].subMenu[l];
                                menuItem1 = this._items(menuItem, "subMenuItems");
                                ul1.append(menuItem1);
                            }
                        }
                        custom2.append(ul1);
                    }
                ul.append(custom2);
            }
            if (ul.find("li").length > 0) {
                this.element.append(ul);
                var parentControl = this.element.parents("div.e-grid");
                var native = ej.Menu.prototype._showContextMenu;
                ej.Menu.prototype._showContextMenu = function (locationX, locationY, target, evt) {
                    $(this.model.contextMenuTarget).hasClass("e-grid") && (++locationX, ++locationY)
                    native.apply(this, [locationX, locationY, target, evt]);
                };
                $(ul).ejMenu({
                    menuType: ej.MenuType.ContextMenu,
                    openOnClick: false,
                    contextMenuTarget: "#" + this._id,
                    click: $.proxy(this._clickevent, this),
                    width: "auto",
                    beforeOpen: $.proxy(this._menu, this)
                });
                if (parentControl.length) {
                    var parentElement = $("#" + parentControl[0].id + '_Context');
                    var target = parentElement.ejMenu("model.excludeTarget");
                    parentElement.ejMenu({ excludeTarget: !ej.isNullOrUndefined(target) && target.length != 0 ? target.concat(",#" + this._id) : "#" + this._id });
                }
                this._conmenu = ul.data("ejMenu");
            }
        },
        _clickevent: function (sender) {
            var args = sender.events.text;
            var tr = $(this._contexttarget.parentNode);
            var c = $(this._contexttarget);
            if (c.hasClass("e-filterset"))
                c = c.siblings();
            else if (c.hasClass("e-icon") || c.hasClass("e-number"))
                c = c.parent();
            var columnName = c.attr("data-ej-mappingname")|| c.find(".e-headercelldiv").attr("data-ej-mappingname");
            if (this._trigger("contextClick", sender))
                return;
            switch (args) {
                case this.localizedLabels.AddRecord: this._startAdd();
                    break;
                case this.localizedLabels.EditRecord:
                    if (this.model.editSettings.editMode == "batch") {
                        var colindex = $(this._contexttarget.parentNode).find(".e-rowcell").index(c), index = this._excludeDetailRows().index(tr), fieldName = this.model.columns[colindex]["field"];
                        this.editCell(index, fieldName);
                    }
                    else
                        this.startEdit(tr);
                    break;
                case this.localizedLabels.DeleteRecord:
                    if (this.model.editSettings.showDeleteConfirmDialog)
                        this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
					else if (this.multiDeleteMode && this.selectedRowsIndexes.length > 1)
                       this._multiRowDelete();
                    else
                       this.deleteRow(tr);
                    break;
                case this.localizedLabels.Save:
                    if (this.model.editSettings.editMode == "batch")
                        this.batchSave();
                    else
                        this.endEdit();
                    break;
                case this.localizedLabels.Cancel: this.cancelEdit();
                    break;
                case this.localizedLabels.SortInDescendingOrder: var columnSortDirection = ej.sortOrder.Descending;
                    this.sortColumn(columnName, columnSortDirection);
                    break;
                case this.localizedLabels.SortInAscendingOrder: var columnSortDirection = ej.sortOrder.Ascending;
                    this.sortColumn(columnName, columnSortDirection);
                    break;
                case this.localizedLabels.Grouping: this.groupColumn(columnName);
                    break;
                case this.localizedLabels.Ungrouping: this.ungroupColumn(columnName);
                    break;
                case this.localizedLabels.NextPage:
                case this.localizedLabels.PreviousPage:
                case this.localizedLabels.LastPage:
                case this.localizedLabels.FirstPage: this._page(sender);
                    break;
            }

        },

        _menu: function (sender) {
            var context = this._conmenu.element;
            this._contexttarget = sender.target;
            var targetelement = $(sender.target), element, value;
            var td = $(this._contexttarget);
            if (this.model.allowSelection && (td.hasClass("e-rowcell") || td.closest(".e-rowcell").length)  && !targetelement.hasClass("e-selectionbackground")) {
                var tr = td.hasClass("e-rowcell") ? td.parent() : td.closest(".e-rowcell").parent();
                if (!this.model.isEdit)
                    this.selectRows(this.getIndexByRow(tr), null, td);
            }
            if ((targetelement.hasClass("e-ascending") || targetelement.hasClass("e-descending")) && !targetelement.parent().hasClass("e-headercelldiv"))
                return false;
            if (targetelement.hasClass("e-filtericon") || targetelement.hasClass("e-headercelldiv"))
                element = sender.target.parentNode.getAttribute("aria-sort");
			else if (targetelement.hasClass("e-headercell"))
				element = sender.target.getAttribute("aria-sort");
            else
                element = targetelement.parent().parent().attr("aria-sort");
            var target = sender.target.className;
            var sorting = $(context);
            if (targetelement.hasClass("e-filterset"))
                value = targetelement.siblings().attr("data-ej-mappingname");
            else if (targetelement.hasClass("e-icon") || targetelement.hasClass("e-number"))
                value = targetelement.parent().attr("data-ej-mappingname");
            else if(targetelement.hasClass("e-headercell"))
				value=targetelement.find(".e-headercelldiv").attr("data-ej-mappingname");
			else
                value = targetelement.attr("data-ej-mappingname");            
            context.css("visibility", "visible");            
            var index = targetelement.closest("tr").hasClass("e-insertedrow") ? this.model.groupSettings.groupedColumns.length : 0;
            var rowCell = targetelement.closest(".e-rowcell");
            var headerCell = targetelement.closest(".e-headercell");
            var tempIndex = rowCell.index() != -1 ? rowCell.index() : headerCell.index() - this.model.groupSettings.groupedColumns.length;
            var columnIndex = targetelement.hasClass("e-rowcell") ? targetelement.index() - index : tempIndex - index;
            columnIndex = (this.model.detailsTemplate != null || this.model.childGrid != null) ? columnIndex - 1 : columnIndex;
            var col = this.model.columns[columnIndex];
            var mapObj = {
                "allowGrouping": ".e-contextgrouping",
                "allowSorting": ".e-contextascending, .e-contextdescending",
                "editSettings.allowAdding": ".e-contextadd",
                "editSettings.allowEditing": ".e-contextedit",
                "editSettings.allowDeleting": ".e-contextdelete",
            };         
            for (var prop in mapObj) {
                var ele = context.find(mapObj[prop]).parent();
                if (ej.getObject(prop, this.model) == false || (ej.getObject(prop, col) === false))
                    ele.css("display", "none");
                else if (ele.css("display") == "none")
                    ele.css("display", "block");
           }
            if (targetelement.closest(".e-grid").attr("id") !== this._id || targetelement.is("input")) {
                context.css("visibility", "hidden");
                return;
            }
            else if (this.getHeaderTable().find(targetelement).length > 0) {
                if (!(headerCell.length != 0 && headerCell.children().hasClass("e-headercelldiv"))) {
                    context.css("visibility", "hidden");
                    return;
                }
                var a = $(context.find(".e-head"));
                context.find(".e-page").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");                
                if(ej.isNullOrUndefined(col.field) || col.field == "") {
                     a.css("display","none");
                     if (context.find(".e-customitem").length == 0)
                        context.css("visibility", "hidden")
               }
			   var exarg = { columnIndex: columnIndex, headerText: col.headerText }
			   $.extend(sender,exarg);
             }
            else if (this.getContentTable().find(targetelement).length > 0) {
			    var rowIndex = this.getIndexByRow($(sender.target.parentElement));
               var rowData = this.model.editSettings.editMode == "batch"?this.getDataByIndex(rowIndex):this.getSelectedRecords();
                if (rowCell.length == 0) {
                    context.css("visibility", "hidden");
                    return;
                }
                var a = $(context.find(".e-content"));
                context.find(".e-head").css("display", "none");
                context.find(".e-page").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");                
                if ((ej.isNullOrUndefined(col.field) || col.field == "") && this.model.editSettings.editMode == "batch") {
                    a.css("display","none");
                    if (context.find(".e-customitem").length == 0)
                       context.css("visibility", "hidden")
               }
		    if(this.model.editSettings.editMode =="batch")
			   {
			     var exarg = { columnIndex: columnIndex, rowIndex: rowIndex, rowData:rowData , headerText: col.headerText,cellValue:ej.getObject(ej.isNullOrUndefined(col.field) ? "" : col.field, rowData) }
			   }
		     else
			     var exarg = { columnIndex: columnIndex, rowIndex: rowIndex, rowData:rowData, headerText: col.headerText, }
				 $.extend(sender,exarg);
             }
            else if (this.getPager().find(targetelement).length > 0 || targetelement.hasClass("e-pager")) {
                var a = $(context.find(".e-page"));
                context.find(".e-head").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-savcan").css("display", "none");
                a.css("display", "block");
            }
            else {
                var a = $(context);
                context.css("visibility", "hidden");
                return false;
            }
            switch (element) {
                case "ascending": sorting.find(".ascending").parent().css("display", "none");
                    break;
                case "descending": sorting.find(".descending").parent().css("display", "none");
                    break;
            }
            if (targetelement.hasClass("e-rowcell") && this.model.editSettings.showAddNewRow) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-contextadd").parent().css("display", "none");
                a.css("display", "block");
            }
            if (this.model.editSettings.editMode == "batch" && (this.batchChanges.changed.length || this.batchChanges.deleted.length || this.batchChanges.added.length)) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-head").css("display", "none");
                context.find(".e-page").css("display", "none");
                a.css("display", "block");
            }
            if (this.model.isEdit && targetelement.hasClass("e-rowcell") && (!this.model.editSettings.showAddNewRow || $(".e-editedrow").length > 0)) {
                var a = $(context.find(".e-savcan"));
                context.find(".e-head").css("display", "none");
                context.find(".e-content").css("display", "none");
                context.find(".e-page").css("display", "none");
                a.css("display", "block");
            }
            if (this.model.pageSettings.totalPages == 1 && a.hasClass("e-page")) {
                if (context.find(".e-customitem").length == 0)
                    context.css("visibility", "hidden");
                else
                    context.find(".e-page").css("display", "none");
            }            
            else if (this.model.pageSettings.currentPage == 1) {
                sorting.find(".previous").parent().css("display", "none");
                sorting.find(".first").parent().css("display", "none");
            }
            else if (this.model.pageSettings.currentPage == this.model.pageSettings.totalPages) {
                sorting.find(".last").parent().css("display", "none");
                sorting.find(".nextpage").parent().css("display", "none");
            }
            if (this.model.groupSettings.groupedColumns.indexOf(value) != -1)
                a.find(".group").parent().css("display", "none");
            else if (this.model.groupSettings.groupedColumns.indexOf(value) == -1)
                a.find(".ungroup").parent().css("display", "none");
			if (this.model.contextOpen)
                this._trigger("contextOpen", sender);
        },

        _items: function (item, type) {
            if (item == "")
                return false;
            if (type == "contextMenuItem") {
                if (item.indexOf("Record") != -1) {
                    var li = ej.buildTag('li', "", {}, { "class": "e-content" });
                    li.css("display", "none");
                }
                else if (item.indexOf("Page") != -1) {
                    var li = ej.buildTag('li', "", {}, { "class": "e-page" });
                    if (item.indexOf("Next") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "nextpage" });
                    else if (item.indexOf("Previous") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "previous" });
                    else if (item.indexOf("Last") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "last" });
                    else if (item.indexOf("First") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "first" });
                    li.css("display", "none");
                }
                else if (item == "Save" || item == "Cancel") {
                    var li = ej.buildTag('li', "", {}, { "class": "e-savcan" });
                    li.css("display", "none");
                }
                else if (item.indexOf("Order") != -1 || item == "Grouping" || item == "Ungrouping") {
                    var li = ej.buildTag('li', "", {}, { "class": "e-head" });
                    if (item.indexOf("Ascending") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "ascending" });
                    else if (item.indexOf("Descending") != -1)
                        var div = ej.buildTag('div', "", {}, { "class": "descending" });
                    else if (item == "Grouping")
                        var div = ej.buildTag('div', "", {}, { "class": "group" });
                    else if (item == "Ungrouping")
                        var div = ej.buildTag('div', "", {}, { "class": "ungroup" });
                    li.css("display", "none");
                }
            }
            if (ej.isNullOrUndefined(li)) {
                var li = ej.buildTag('li', "", {}, { "class": "e-customitem" });
                li.css("display", "block");
            }
            li.append(div);
            var a = document.createElement("a"), classElement = "";
            if (typeof item == "string") {
                if (item.indexOf("Ascending") != -1)
                    classElement = "ascending";
                else if (item.indexOf("Descending") != -1)
                    classElement = "descending";
                else
                    classElement = item.split(" ")[0].toLowerCase();
                a.innerHTML = !ej.isNullOrUndefined(this.localizedLabels[item.replace(/\s+/g, '')]) ? this.localizedLabels[item.replace(/\s+/g, '')] : item;
            }
            if (typeof item == "object") {
                if (item.id == "Ascending")
                    classElement = "ascending";
                else if (item.id == "Descending")
                    classElement = "descending";
                else
                    classElement = item.id.split(" ")[0].toLowerCase();
                a.innerHTML = !ej.isNullOrUndefined(this.localizedLabels[item.text.replace(/\s+/g, '')]) ? this.localizedLabels[item.text.replace(/\s+/g, '')] : item.text;
                li.attr('id', item.id);
            }
			$(a).append(ej.buildTag('span', "", {}, { "class": "e-gridcontext e-icon e-context" + classElement }));
            li.append(a);
            return li;
        },

        _page: function (send) {
            if (send.events.text == this.localizedLabels.NextPage) {
                var b = this.model.pageSettings.currentPage;
                ++b;
                this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.PreviousPage) {
                var b = this.model.pageSettings.currentPage;
                if (b > 1) {
                    --b;
                    this.gotoPage(b);
                }
                else
                    this.gotoPage(b);
            }
            else if (send.events.text == this.localizedLabels.LastPage) {
                var b = this.model.pageSettings.totalPages
                this.gotoPage(b);
            }
            else
                this.gotoPage(1);


        },
        changePageSize: function (pageSize) {
            var args = {}, returnValue;
            var pageModel = this.getPager().ejPager("instance");
            this.model.pageSettings.pageSize = pageModel._pageSize;
            this.getPager().ejPager({pageSize: pageModel._pageSize});
            args.requestType = ej.Grid.Actions.Refresh;
            returnValue = this._processBindings(args);
        },
        gotoPage: function (pageIndex) {
            if (!pageIndex || (pageIndex == this._currentPage() && !this.model.scrollSettings.allowVirtualScrolling) || (!this.model.allowPaging && (!this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling)))
                return;
            var args = {}, returnValue;
            args.previousPage = this._currentPage();
            this._currentPage(pageIndex);
            args.endIndex = ((this._currentPage() * this.model.pageSettings.pageSize) > this._gridRecordsCount) ? (this._gridRecordsCount) : (this._currentPage() * this.model.pageSettings.pageSize);
            args.startIndex = (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
            args.currentPage = pageIndex;
            if (this.model.allowPaging) {
                //this.model.pageSettings.currentPage = pageIndex;
                //this. getPager().ejPager("refreshPager");
                args.requestType = ej.Grid.Actions.Paging;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
                this._isVirtualRecordsLoaded = false;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                args.requestType = ej.Grid.Actions.VirtualScroll;
            }
            returnValue = this._processBindings(args);
            if (returnValue)
                this._currentPage(args.previousPage);
            this._primaryKeyValues = [];
        },
        _gPagerClickHandler: function (sender) {
            if (this._prevPageNo == sender.currentPage)
                return;
            this.model.masterObject.gotoPage(sender.currentPage);
            return false;
        },
        _gPageSize: function (sender) {
            this.model.masterObject.changePageSize(sender.pageSize);
        },
        _processData: function (e, args) {
            if (this.initialRender) {
                this._initDataProcessed = true;
                this._initDataProcess(e, args);
            }
            else {
                if (e.count == 0 && this.model.currentViewData.length)
                    this._gridRecordsCount = e.result.length;
                else
                    this._gridRecordsCount = e.count;
                if (this.getPager() != null)
                    this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;
                if ((args.requestType == ej.Grid.Actions.Filtering || ej.Grid.Actions.Save || (this.model.filterSettings.filteredColumns.length > 0 && args.requestType == ej.Grid.Actions.Refresh)))
                    this._filteredRecordsCount = e.count;
                if (this.model.allowScrolling && this.model.scrollSettings.enableVirtualization) {
                    this.model.currentViewData = [];
                    for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                        var currentView = this._currentLoadedIndexes[i];
                        $.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView] || []);
                    }
                }
                this._setForeignKeyData(args);
                this._relationalColumns.length == 0 && this.sendDataRenderingRequest(args);
            }
        },

        _frozenCell: function (rowIndex, cellIndex) {
            var currentIndex = cellIndex, frozenDiv = 0, row = this.getRowByIndex(rowIndex), cell;
            if (cellIndex >= this.model.scrollSettings.frozenColumns) {
                frozenDiv = 1;
                currentIndex = currentIndex - this.model.scrollSettings.frozenColumns;
            }
            cell = $(row.eq(frozenDiv).find(".e-rowcell:eq(" + currentIndex + ")"));
            return cell;
        },
        _frozenColumnSelection: function (gridRows, columnIndex, endIndex) {
            var currentIndex = columnIndex, frozenDiv = 0;
            if (endIndex) {
                for (var i = columnIndex; i < endIndex; i++) {
                    currentIndex = i;
                    if (i >= this.model.scrollSettings.frozenColumns) {
                        frozenDiv = 1;
                        currentIndex = i - this.model.scrollSettings.frozenColumns;
                    }
                    for (var j = 0; j < gridRows[frozenDiv].length; j++) {
                        $(gridRows[frozenDiv][j].cells[currentIndex]).addClass("e-columnselection");
                    }
                    $(this.getHeaderTable().find("th.e-headercell")[i]).addClass("e-columnselection");
                    this.selectedColumnIndexes.push(i);
                }
            }
            else {
                if (columnIndex >= this.model.scrollSettings.frozenColumns) {
                    frozenDiv = 1;
                    currentIndex = columnIndex - this.model.scrollSettings.frozenColumns;
                }
                for (var i = 0; i < gridRows[frozenDiv].length; i++) {
                    $(gridRows[frozenDiv][i].cells[currentIndex]).addClass("e-columnselection");
                }
            }

        },
        _renderGridFooter: function () {
            if (this.model.summaryRows.length > 0) {
                var showTotalSummaryItems = ej.DataManager(this.model.summaryRows).executeLocal(ej.Query().where("showTotalSummary", ej.FilterOperators.equal, false));
                var _$gridFooter = ej.buildTag("div.e-gridfooter");
                var $innerDiv = ej.buildTag('div');
                if (this.model.allowScrolling)
                    $innerDiv.addClass("e-footercontent");
                var $table = ej.buildTag("table.e-gridsummary");
                this.setGridFooterContent(_$gridFooter);
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $frozenFooterDiv = ej.buildTag("div.e-frozenfooterdiv"), $movableFooter = ej.buildTag("div.e-movablefooter")
                        , $tableClone = $table.clone(), $movableFooterDiv = ej.buildTag("div.e-movablefooterdiv");
                    $movableFooter.append($movableFooterDiv);
                    $table.append(this.getHeaderTable().first().find('colgroup').clone());
                    $tableClone.append(this.getHeaderTable().last().find('colgroup').clone());
                    $frozenFooterDiv.append($table);
                    $movableFooterDiv.append($tableClone);
                    this.setGridFooterTable($table.add($tableClone));
                    this._createSummaryRows(this.getFooterTable());
                    _$gridFooter.append($frozenFooterDiv.add($movableFooter));
                    _$gridFooter.find(".e-frozenfooterdiv").outerWidth(this.getHeaderContent().find(".e-frozenheaderdiv").width())
                          .end().find(".e-movablefooterdiv").outerWidth(this.getContent().find(".e-movablecontentdiv").width());
                }
                else {
                    $table.append(this.getHeaderTable().find('colgroup').clone());
                    this.setGridFooterTable($table);
                    this._createSummaryRows(this.getFooterTable());
                    $innerDiv.append($table);
                    _$gridFooter.html($innerDiv);
                }
                if (this.model.summaryRows.length == showTotalSummaryItems.length)
                    return;
                return _$gridFooter;
            } else
                throw "summary row collection is missing";
        },
        _setSummaryAggregate: function (queryManager) {
            var rows = this.model.summaryRows, scolumns, sCol = [];
            for (var row = 0, rlen = rows.length; row < rlen; row++) {
                scolumns = rows[row].summaryColumns;
                for (var col = 0, clen = scolumns.length; col < clen; col++) {
                    queryManager.aggregate(scolumns[col].summaryType, scolumns[col].dataMember);
                }
            }
        },
        _createSummaryRows: function (table, summaryData, aggregates, item, showGroup) {
            var col = table.find("col");
            if (table.find("tbody").length > 0)
                table.find("tbody").remove();
            var $tBody = ej.buildTag('tbody'), proxy = this, $tBodyClone = $tBody.clone();
            var summaryCol = this.model.summaryRows;
            if (!ej.isNullOrUndefined(summaryData) && this._isCaptionSummary)
                summaryCol = this._captionSummary(showGroup);
            $.each(summaryCol, function (indx, row) {
                if (row.showTotalSummary === false && ej.isNullOrUndefined(summaryData)) return true;
                if (row.showGroupSummary === false && showGroup && !ej.isNullOrUndefined(summaryData)) return true;
                var $tr = ej.buildTag('tr.e-gridSummaryRows');
                if (ej.isNullOrUndefined(item && item.level)) {
                    for (var i = 0; i < proxy.model.groupSettings.groupedColumns.length; i++) {
                        $tr.prepend(ej.buildTag('td').addClass("e-indentcell"));
                    }
                }
                var gc = showGroup ? " e-gcsummary" : "";
                if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                    if (proxy.model.groupSettings.groupedColumns.length != 0)
                        $tr.children("td.e-indentcell").last().after("<td class='e-summaryrow" + gc + "'></td>");
                    else
                        $tr.prepend("<td class='e-summaryrow'></td>");
                }
                var $cells = proxy.getHeaderTable().find('td').slice(0, proxy.model.columns.length ).clone().addClass("e-summaryrow" + gc + ""), count = 0;
                var index = 0;
                if (!ej.isNullOrUndefined(row.titleColumn)) {
                    var index = proxy.getColumnIndexByField(row.titleColumn);
                    if (index == -1)
                        index = proxy.getColumnIndexByHeaderText(row.titleColumn);
                }
				if(index != -1)
					$cells = proxy._assignTitleColumn(index, row.title, $cells, count);
                proxy._hideSummaryColumn($cells, col);
                if (proxy.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = $tr.clone();
                    $tBody.append($tr.append($cells.slice(0, proxy.model.scrollSettings.frozenColumns)));
                    $tBodyClone.append($trClone.append($cells.slice(proxy.model.scrollSettings.frozenColumns)));
                }
                else {
                    if ((!proxy._isCaptionSummary || showGroup) && !ej.isNullOrUndefined(item && item.level)) {
                        var level = proxy.model.groupSettings.groupedColumns.length - item.level + 1, tableClone = table.clone().addClass("e-groupsummary"), captionData = {};
                        captionData["data"] = { items: item };
                        $tr.prepend("<td class='e-summaryrow" + gc + "' colspan=" + proxy._colSpanAdjust(null, null, captionData) + " style = 'padding:0;' ></td>");
                        $($tr[0].cells).filter(".e-summaryrow").html(tableClone.append(ej.buildTag("tr", $cells)));
                        var len = tableClone.find("col").length - (proxy.model.columns.length + level);
                        if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null)
                            $tr.find("tr").prepend("<td class='e-summaryrow'></td>");
                        for (var i = 0; i < len; i++) {
                            tableClone.find("col").first().remove();
                        }
                        for (var i = 0; i < level; i++) {
                            $(tableClone[0].rows).prepend("<td class='e-indentcell'></td>");
                            $(tableClone.find("col")[i]).addClass("e-summary");
                        }
                        $tBody.append($tr);
                    }
                    else
                        $tBody.append($tr.append($cells));
                }
                $.each(row.summaryColumns, function (cindx, col) {
                    var value;
                    if (col.summaryType != "custom")
                        value = aggregates ? aggregates[col.dataMember + " - " + col.summaryType] : proxy._remoteSummaryData[col.dataMember + " - " + col.summaryType];
                    else
                        value = proxy.getSummaryValues(col, summaryData);
                    var prefix = col.prefix ? col.prefix : "",
                    index = proxy.getColumnIndexByField(col.displayColumn), suffix = col.suffix ? col.suffix : "";
                    if (proxy.model.allowScrolling)
                        $($cells[index]).addClass("e-scroller");
                    if ($($cells[index]).html() != "" && prefix == "")
                        prefix = $($cells[index]).html();
                    if (!ej.isNullOrUndefined(col.template)) {
                        var obj = {
                            summaryValue: col.format ? proxy.formatting(col.format, value, proxy.model.locale) : value,
							summaryColumn: col
                        },
                        sTemplate = obj.summaryColumn.template,
                        ngType = !ej.isNullOrUndefined(proxy.model.ngTemplateId) && (sTemplate.startsWith("#") || sTemplate.startsWith(".") || typeof sTemplate === "object") ? proxy.model.ngTemplateId + "gridsummarytemplate" : null;
                        proxy._summaryContextIndex = proxy._summaryContextIndex + 1;
                        $($cells[index]).html(proxy._renderEjTemplate(obj.summaryColumn.template, obj, proxy._summaryContextIndex, null, ngType)).css("text-align", proxy.model.columns[index].textAlign)
                        $($cells[index]).addClass("e-summarytemplate")
                    }
                    else if (index != -1)
                        $($cells[index]).html(prefix + (col.format ? proxy.formatting(col.format, value, proxy.model.locale) : value) + suffix).css("text-align", proxy.model.columns[index].textAlign);
                });
            });
            if (this.model.scrollSettings.frozenColumns > 0) {
                table.first().append($tBody);
                table.last().append($tBodyClone);
            }
            else
                table.append($tBody);
        },
        _assignTitleColumn: function (index, title, $cells, count) {
            for (var i = index; i < this.model.columns.length; i++) {
                var colindex = this.model.columns[i];
                if (count == 0 && colindex.visible != false) {
                    $cells.eq(i).html(title);
                    break;
                }
            }
            return $cells;
        },
        getSummaryValues: function (summaryCol, summaryData) {
            var $value, jsonData;
            if (!ej.isNullOrUndefined(summaryData))
                jsonData = summaryData;
            else if (this.model.filterSettings.filteredColumns.length > 0)
                jsonData = this._filteredRecords;
            else
                jsonData = this._dataSource();

            var dbMgr;
            if (jsonData instanceof ej.DataManager) {
                dbMgr = jsonData;
                jsonData = jsonData.dataSource.json;
            } else
                dbMgr = ej.DataManager(jsonData);

            switch (summaryCol.summaryType) {
                case ej.Grid.SummaryType.Maximum:
                    var obj = ej.max(jsonData, summaryCol.dataMember);
                    $value = ej.getObject(summaryCol.dataMember, obj);
                    break;
                case ej.Grid.SummaryType.Minimum:
                    var obj = ej.min(jsonData, summaryCol.dataMember);
                    $value = ej.getObject(summaryCol.dataMember, obj);
                    break;
                case ej.Grid.SummaryType.Average:
                    $value = ej.avg(jsonData, summaryCol.dataMember);
                    break;
                case ej.Grid.SummaryType.Sum:
                    $value = ej.sum(jsonData, summaryCol.dataMember);
                    break;
                case ej.Grid.SummaryType.Count:
                    $value = jsonData.length;
                    break;
                case ej.Grid.SummaryType.TrueCount:
                    var predicate = ej.Predicate(summaryCol.dataMember, "equal", true);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.Grid.SummaryType.FalseCount:
                    var predicate = ej.Predicate(summaryCol.dataMember, "equal", false);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.Grid.SummaryType.Custom:
                    var fn = summaryCol.customSummaryValue;
                    if (fn) {
                        if (typeof fn === "string")
                            fn = ej.util.getObject(fn, window);
                        if ($.isFunction(fn))
                            $value = fn.call(this, summaryCol, jsonData);
                    }
                    break;
            }
            return $value;
        },
        _hideCaptionSummaryColumn: function () {
            var headerColumn = this.getHeaderTable().find('.e-headercelldiv[data-ej-mappingname]').first();
            var captionTd = this.getContentTable().find('.e-groupcaption').clone();
            var groupCaptionParent = this.getContentTable().find('.e-groupcaption').parent();
            var colLength = this.model.columns.length - 1;
            if (this._isCaptionSummary) {
                this.getContentTable().find('.e-summaryrow:not(.e-gcsummary)').remove();
                this.getFooterTable().find("tbody td").slice(-colLength).removeClass("e-groupcaptionsummary").addClass("e-summaryrow");
                if (this.getFooterTable() != null) {
                    this.getContentTable().find('.e-recordplusexpand').parent().children('.e-indentcell').remove();
                }
                if (!this.model.groupSettings.showGroupedColumn && this.getContentTable().find(".e-groupcaptionsummary").not(".e-hide").length) {
                    var sumColumn = +this.getContentTable().find(".e-recordtable:first").parents("tbody:first").find(".e-groupcaption").attr("colspan");
                    if (this._hiddenColumnsField.length == this.model.columns.length - 1 && headerColumn.parent().hasClass("e-hide") || !sumColumn) {
                        for (var i = 0; i < captionTd.length; i++) {
                            groupCaptionParent.eq(i).children().not('.e-hide,.e-recordplusexpand').filter('td.e-groupcaptionsummary:first').addClass("e-hide");
                            var caption = groupCaptionParent.eq(i).find(".e-groupcaption");
                            var colspan = parseInt(caption.attr("colspan"));
                            caption.attr("colspan", ++colspan)
                        }
                    }
                }
            }
            this.getContentTable().find('.e-recordtable').find('.e-indentcell').remove();
        },
        _hideSummaryColumn: function (td, col) {
            var i,j;
            if (col.length > this.model.columns.length)
                col = col.slice(col.length - this.model.columns.length);
            if (!this.model.groupSettings.showGroupedColumn && this.model.showSummary) {
                for (i = 0; i < this.model.columns.length; i++) {
                    for (j = 0; j < this.model.groupSettings.groupedColumns.length || j < this._hiddenColumnsField.length; j++) {
                        var headerColumn = this.getHeaderTable().find('.e-headercelldiv:not(.e-emptyCell)');
                        if (headerColumn.eq(i).parent().hasClass('e-hide')) {
                            col.eq(i).css("display", "none");
                            $(td[i]).addClass("e-hide");
                            break;
                        }
                        else {
                            if (col.eq(i).css("display") == "none")
                                col.eq(i).css("display", "");
                        }
                    }
                }
            }
            else {
                for (i = 0; i < this.model.columns.length; i++) {
                    if (!this.model.columns[i]["visible"]) {
                        col.eq(i).css("display", "none");
                        $(td[i]).addClass("e-hide");
                    }
                    else {
                        if (col.eq(i).css("display") == "none")
                            col.eq(i).css("display", "");
                    }
                }
            }
        },

        _initScrolling: function () {
            var frozen = [], unfrozen = [], hideColumns = 0;
            if (this.model.scrollSettings.enableVirtualization)
                this.model.scrollSettings.allowVirtualScrolling = true;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount].visible === false && columnCount < this.model.scrollSettings.frozenColumns)
                    hideColumns++;
                if (this.model.columns[columnCount]["isFrozen"] === true)
                    frozen.push(this.model.columns[columnCount]);
                else
                    unfrozen.push(this.model.columns[columnCount]);
            }            
            if (frozen.length > 0) {
                var freeze = this.model.scrollSettings.frozenColumns;
                this.model.columns = $.merge($.merge([], frozen), unfrozen);
                this.model.scrollSettings.frozenColumns = frozen.length;
                if (frozen.length != freeze && freeze != 0)
                    this.model.scrollSettings.frozenColumns = freeze;
            }
            if ((this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) && (this.model.allowGrouping || this.model.rowTemplate != null || this.model.detailsTemplate != null || this.model.childGrid != null || this.model.scrollSettings.allowVirtualScrolling || this.model.editSettings.editMode == "batch")) {
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this._getLocalizedLabels()["FrozenNotSupportedException"]);
                this._alertDialog.ejDialog("open");
                return;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling) {
				if(!this.model.scrollSettings.enableVirtualization){
					this.model.pageSettings.pageSize = this.model.pageSettings.pageSize == 12 ? Math.round(this.model.scrollSettings.height / 32) + 1 : this.model.pageSettings.pageSize;
					this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
				}
				else{					
					this._vRowHeight = Math.floor(this.getRowHeight() + 1);
					this._virtualRowCount = Math.round(this.model.scrollSettings.height / this._vRowHeight) + 1; 					
					this.model.pageSettings.pageSize = this.model.pageSettings.pageSize <= this._virtualRowCount * 5 ? this._virtualRowCount * 5 : this.model.pageSettings.pageSize;
                }
            }
            if (this.model.width || this.model.height) {
                this.model.allowScrolling = true;
                if (this.model.width) this.model.scrollSettings.width = this.model.width;
                if (this.model.height) this.model.scrollSettings.height = this.model.height;
            }
            this._originalScrollWidth = ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) ? this.model.scrollSettings.width : this.model.scrollSettings.previousStateWidth;
        },
        _checkScrollActions: function (requestType) {
            if ((!this.model.scrollSettings.allowVirtualScrolling && (requestType == ej.Grid.Actions.Sorting || requestType == ej.Grid.Actions.Reorder)) || requestType == ej.Grid.Actions.Grouping || requestType == ej.Grid.Actions.Ungrouping || requestType == ej.Grid.Actions.Add || requestType == ej.Grid.Actions.Cancel
                || requestType == ej.Grid.Actions.Save || requestType == ej.Grid.Actions.BatchSave || requestType == ej.Grid.Actions.Delete || requestType == ej.Grid.Actions.Filtering || requestType == ej.Grid.Actions.Paging || requestType == ej.Grid.Actions.Refresh || requestType == ej.Grid.Actions.Search)
                return true;
            return false;
        },
        _frozenAlign: function () {
             var gridContent = this.getContent().first(), browserDetails = !ej.isIOSWebView() && this.getBrowserDetails(), direction;
             direction = this.model.enableRTL ? "margin-right" : "margin-left";
             gridContent.find(".e-movablecontent").css(direction, browserDetails && browserDetails.browser === "safari" ? "auto" : gridContent.find(".e-frozencontentdiv").width() + "px");
             this.getHeaderContent().find(".e-movableheader").removeAttr("style").css(direction,browserDetails && browserDetails.browser === "safari" ? "auto" : this.getHeaderContent().find(".e-frozenheaderdiv").width() + "px");
			 if(this.getFooterContent())
				 this.getFooterContent().find(".e-movablefooter").removeAttr("style").css(direction,browserDetails && browserDetails.browser === "safari" ? "auto" : this.getFooterContent().find(".e-frozenfooterdiv").width() + "px")
			         
		 },
        _refreshScroller: function (args) {
            var gridContent = this.getContent().first(), temp;
            if (ej.isNullOrUndefined(gridContent.data("ejScroller")))
                return;
            if (this.model.scrollSettings.frozenColumns > 0) {
                if (this._gridRecordsCount || this._isAddNew)
                    this.model.scrollSettings["targetPane"] = ".e-movablecontent";
                else
                    this.model.scrollSettings["targetPane"] = null;
                this.getScrollObject().option({ targetPane: this.model.scrollSettings["targetPane"] });
                if (!this._isFrozenColumnVisible()) {
                    gridContent.find(".e-movablecontentdiv").removeAttr("style");
                    this.getHeaderContent().find(".e-movableheaderdiv").removeAttr("style");
					if(this.getFooterContent())
						this.getFooterContent().find(".e-movablefooter").removeAttr("style");                 
                    gridContent.find(".e-frozencontent").width(0);
                    gridContent.find(".e-frozencontentdiv").width(0);
                    gridContent.find(".e-frozencontent").height(0);
                    gridContent.find("e-frozencontentdiv").height(0);
                }
                else if (this._visibleColumns.length <= this.model.scrollSettings.frozenColumns) {
                    var isMovableCol = false;
                    for (var i = this.model.scrollSettings.frozenColumns; i < this.model.columns.length; i++) {
                        if (this._visibleColumns.indexOf(this.model.columns[i].headerText) != -1) {
                            isMovableCol = true;
                            break;
                        }
                    }
                    if (!isMovableCol) {
                        gridContent.find(".e-frozencontentdiv").removeAttr("style");
                        this.getHeaderContent().find(".e-frozenheaderdiv").removeAttr("style");
                        gridContent.find(".e-movablecontent").width(0);
                        gridContent.find(".e-movablecontentdiv").width(0);
                        gridContent.find(".e-movablecontent").height(0);
                        gridContent.find(".e-movablecontentdiv").height(0);
                    }
                }
                else {
                    this._frozenAlign();
                    gridContent.find(".e-movablecontent").scrollLeft(this.getHeaderContent().find(".e-movableheader").scrollLeft());
                    if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && this.getScrollObject()._vScrollbar.value() > this.getScrollObject()._vScrollbar.model.maximum)
                        temp = this.getScrollObject()._vScrollbar.model.maximum;
                }
                this.refreshScrollerEvent();
            }
            if (this.model.scrollSettings.frozenRows > 0) {
                this._initFrozenRows();
                for (var i = 0 ; i < this.getRows().length ; i++) {
                                       $(this.getRows()[i]).filter(":hidden").css("display", "table-row");
                                    }
                if (!this.initialRender && ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && (this.element.height() > this.model.scrollSettings.height))
                    this.getContent().attr("tabindex", "0").ejScroller(this.model.scrollSettings);
                var temp = this.getScrollObject().model.scrollTop;
                var tempLeft = this.getScrollObject().model.scrollLeft;
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                if ((args.requestType == "cancel" || args.requestType == "save") && temp > this._editFormHeight && this.model.editSettings.editMode.indexOf("inlineform") != -1)
                    temp = temp - this._editFormHeight;
                if (args.requestType == ej.Grid.Actions.Add)
                    this.getScrollObject().scrollY(0, true);
                if (!ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar._scrollData))
                    this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
            }
            if ((args.requestType == "beginedit" || args.requestType == "save") && !this.model.editSettings.editMode == "inlineformtemplate" && !this.model.editSettings.editMode == "inlineform") {
                var temp = this.getScrollObject().model.scrollTop;
                this.getScrollObject().scrollY(0, true);
            }
            if (!ej.isNullOrUndefined(this.model.dataSource) && (args.requestType == "refresh" || args.requestType=="searching") && this.model.scrollSettings.allowVirtualScrolling) {
                if (this.model.scrollSettings.enableVirtualization && (this._isLocalData || this._virtualDataRefresh) && this._gridRecordsCount > 0)
					this._refreshVirtualView(this._currentVirtualIndex);
				else
					this._refreshVirtualContent(1);
				if(this._currentVirtualIndex == 1)
					this.getScrollObject().scrollY(0);
            }            
            if (this.model.scrollSettings.frozenColumns > 0)
				this.rowHeightRefresh();
			this.getScrollObject().refresh();
            gridContent.ejScroller("model.enableRTL", this.model.enableRTL);
            if (this.model.isResponsive && (args.requestType == 'searching' || args.requestType == "filtering")) {
                var scrollObj = this.getScrollObject();
                var height = scrollObj.isHScroll() ? this.getContentTable().height() + scrollObj.model.buttonSize : this.getContentTable().height();
                height = typeof (this.model.scrollSettings.height) == "string" || height > this.model.scrollSettings.height ? this.model.scrollSettings.height : height
                var scrollWidth= typeof (this.model.scrollSettings.width) == "string" ? this.element.width():this.model.scrollSettings.width;
                var width = scrollWidth;
                this.getContent().ejScroller({ height: height, width: width });
            }
            if (this.getScrollObject().isVScroll() && !this.getScrollObject().model.autoHide) {
                this.getHeaderContent().addClass("e-scrollcss");
				this.getHeaderTable().first().width(this.getContentTable().width());
                !this.getHeaderContent().find(".e-headercontent").hasClass("e-hscrollcss") && this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
                if (this.model.showSummary && this.getScrollObject().isHScroll() && !ej.isNullOrUndefined(this.getFooterContent()))
                    this.getFooterContent().find("div table").first().width(this.getContentTable().width() + this.model.scrollSettings.scrollerSize);
                else if(!this.getScrollObject().isHScroll() && !ej.isNullOrUndefined(this.getFooterContent()))
                    this.getFooterContent().find("div table").first().width(this.getFooterContent().find("div").width());
            }
            else
                this._showHideScroller();
            if (!this.model.scrollSettings.frozenColumns && this.model.allowPaging && !this.getScrollObject().isVScroll() && !this.getScrollObject().isHScroll() && this.getContentTable().width() != this.getContent().width()) {
				this.getContentTable().width(this.getContent().width());
				this.getHeaderTable().width(this.getContentTable().width())
				if(!ej.isNullOrUndefined(this.getFooterTable()))
                    this.getFooterTable().width(this.getContentTable().width());
			}
            this._getRowHeights();
            if (temp && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && args.requestType != ej.Grid.Actions.Add && this.model.editSettings.editMode != "inlineformtemplate" && this.model.editSettings.editMode != "inlineform") {
                this._currentTopFrozenRow = 0;
                if (temp > this.getScrollObject()._vScrollbar.model.maximum)
                    temp = this.getScrollObject()._vScrollbar.model.maximum;
                this.getScrollObject()._vScrollbar.scroll(temp);
            }
            if (args.requestType == "beginedit" && !ej.isNullOrUndefined(this.getScrollObject()._vScrollbar) && (this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "inlineform")) {
                var editedFormHeight = $("#" + this._id + "EditForm").parents('tr.e-editedrow')[0].offsetTop + $("#" + this._id + "EditForm").parents('tr.e-editedrow')[0].offsetHeight;
                var content = this.getContent().find(".e-content"), cntHeight = content.height(), scrollerTop = this.getScrollObject().scrollTop(), contentHeight = scrollerTop + cntHeight;
                if (Math.round(editedFormHeight) > Math.round(contentHeight)) {
                    var value = this.getScrollObject()._vScrollbar.model.value + (editedFormHeight - contentHeight);
                    this.getScrollObject()._vScrollbar.scroll(value);
                    this.model.scrollSettings.scrollTop = value;
                }
                else {
                    this.getScrollObject()._vScrollbar.scroll(scrollerTop);
                    this.model.scrollSettings.scrollTop = scrollerTop;
                }
            }
            if(tempLeft && this.model.scrollSettings.frozenColumns > 0 && args.requestType == ej.Grid.Actions.BeginEdit)
            {
                this.getScrollObject()._hScrollbar.scroll(tempLeft);
            }
            if (args.requestType == "virtualscroll") {
                var top = this.getScrollObject().model.scrollTop + this.getScrollObject().model.height - (this.getScrollObject().model.height * .3);
                this.getScrollObject().scrollY(top, true);
            }
        },
        _isFrozenColumnVisible: function () {
            for (var i = 0; i < this.model.scrollSettings.frozenColumns; i++) {
                if (this.model.columns[i].visible)
                    return true;
            }
            return false;
        },
        _frozenPaneRefresh: function () {
            this.getContent().find(".e-frozencontentdiv").css("display", "none");
            this.getHeaderContent().find(".e-frozenheaderdiv").css("display", "none");
            this.getHeaderContent().find(".e-movableheader")[0].style["margin-left"] = "";
            this.getContent().find(".e-movablecontent")[0].style["margin-left"] = "";
            var scrollWidth = ej.isNullOrUndefined(this._scrollObject._vScrollbar) ? 0 : this._scrollObject._vScrollbar["e-vscroll"].width();
            var movableWidth = this.model.scrollSettings.width - scrollWidth - 1;
            if (this.model.scrollSettings.width > this.getContent().find(".e-movablecontentdiv").width()) {
                this.getContent().find(".e-movablecontentdiv").width(movableWidth);
                this.getHeaderContent().find(".e-movableheaderdiv").width(movableWidth);
                if(!ej.isNullOrUndefined(this.getFooterContent()))
                    this.getFooterContent().find(".e-movablefooterdiv").width(movableWidth);
            }
            this._scrollObject.option("scrollLeft", 0);
        },
        _renderScroller: function () {
            if (!this.model.scrollSettings)
                this.model.scrollSettings = {};
            if (this.model.enablePersistence && (ej.isNullOrUndefined(this.model.scrollSettings.previousStateWidth) || !this.model.scrollSettings.previousStateWidth) && this.model.isResponsive)
                this.model.scrollSettings.previousStateWidth = this.model.scrollSettings.width;
            if (typeof (this._originalScrollWidth) == "string" && !this.model.isResponsive) {
                this.element.css("width", "auto");
                var width = this.element.width();
                if (this.model.scrollSettings.width == "auto" || this._originalScrollWidth == "auto")
                    this._originalScrollWidth = "100%";
                this.model.scrollSettings.width = width * (parseFloat(this._originalScrollWidth) / 100)
            }

            if (typeof (this.model.scrollSettings.height) == "string" && !this.model.isResponsive) {
                var height = this.element.height();
                if (this.model.scrollSettings.height == "auto")
                    this.model.scrollSettings.height = "100%";
                this.model.scrollSettings.height = height * (parseFloat(this.model.scrollSettings.height) / 100)
            }

            if ((this.model.scrollSettings.width || this.model.width) && !this._mediaQuery) {
                var width = this.model.scrollSettings.width || this.model.width;
                if (typeof width == "string")
                    this.element.css("width", this.model.scrollSettings.width || this.model.width);
                else
                    this.element.width(this.model.scrollSettings.width || this.model.width);
            }

            var $content = this.getContent().attr("tabindex", "0"), staticWidth, direction, gridRows = this.getRows();

            if (this.model.scrollSettings.frozenColumns > 0) {
                for (var i = 0 ; i < this.getRows().length ; i++) {
                                       $(this.getRows()[i]).filter(":hidden").css("display", "table-row");
                                   }
                var scrollWidth = this.getContent().find(".e-frozencontentdiv").width() + 20;
                if (scrollWidth > this.model.scrollSettings.width) {
                    this.getContent().remove();
                    this.getHeaderTable().eq(1).remove();
                    this._alertDialog.find(".e-content").text(this.localizedLabels.FrozenColumnsViewAlert);
                    this._alertDialog.ejDialog("open");
                    return;
                }
                staticWidth = this.getContent().find(".e-frozencontentdiv").width();
                direction = this.model.enableRTL ? "margin-right" : "margin-left";
                this.getContent().find(".e-movablecontent").css(direction, staticWidth + "px");
                this.getHeaderContent().find(".e-movableheader").css(direction, staticWidth + "px");
                if(!ej.isNullOrUndefined(this.getFooterContent()))
                    this.getFooterContent().find(".e-movablefooter").css(direction, staticWidth + "px");
                this.model.scrollSettings["targetPane"] = ".e-movablecontent";
            }
            this._initFrozenRows();
            if (this.model.scrollSettings.autoHide)
                this.model.scrollSettings["show"] = $.proxy(this._showHideScroller, this);
			if(!this.model.scrollSettings.allowVirtualScrolling && this.model.currentIndex > 0 && !this.model.scrollSettings.scrollTop){
				var sTop = this.model.currentIndex * this.getRowHeight();
				this.model.scrollSettings["scrollTop"] = sTop;
			}
			$content.ejScroller(this.model.scrollSettings);
			if (this.model.allowRowDragAndDrop && this.model.allowScrolling && ej.gridFeatures.dragAndDrop)
			    $content.ejScroller({ thumbStart: function () { return false } });
            if (this.model.rowTemplate != null && ((!ej.isIOSWebView()) && (this.getBrowserDetails().browser == "msie" || this.getBrowserDetails().browser == "safari")))
                this.getScrollObject().refresh();            
            if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenRows == 0 && this.getScrollObject()._vScrollbar && this.getScrollObject()._hScrollbar)
                this.getScrollObject()._vScrollbar._scrollData.skipChange = this.getScrollObject()._hScrollbar._scrollData.skipChange = true;
            if (!this.model.scrollSettings.autoHide)
                this._showHideScroller();
            if ((!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") && this.model.scrollSettings.frozenColumns > 0)
                this.getHeaderContent().find(".e-movableheader").add(this.getContent().find(".e-movablecontent")).css(direction, "auto");
            this.refreshScrollerEvent();
            if (this.model.scrollSettings.frozenColumns > 0 && !this._isFrozenColumnVisible())
                this._frozenPaneRefresh();
            if (this.model.scrollSettings.allowVirtualScrolling) {
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
                this.refreshScrollerEvent();
            }
        },
		_checkScroller: function(e, scrollObj){
			var scrollLeft = e.scrollLeft > 0 ? e.scrollLeft : Math.abs(e.scrollLeft);
			if(e.source == "thumb" && (scrollObj.content()[0].scrollWidth - scrollLeft == scrollObj.content()[0].clientWidth || scrollLeft == 0)){
				if(this.model.enableRTL){
					var hLeft = scrollLeft == 0 ? e.scrollData.scrollable: 0;
					e.scrollData.sTop = e.model.scrollLeft = hLeft;
					scrollObj.content().scrollLeft(hLeft);	
				}
				scrollObj._hScrollbar.refresh();
			}
		},
        _showHideScroller: function () {
            if (this.getScrollObject().isVScroll()) {
                this.getHeaderContent().find("div").first().addClass("e-headercontent");
                if (this.model.showSummary && !ej.isNullOrUndefined(this.getFooterContent()))
                    this.getFooterContent().find("div").first().addClass("e-footercontent");
                !this.model.scrollSettings.autoHide && this.getHeaderContent().addClass("e-scrollcss")
            } else
                this.element.find(".e-gridheader").removeClass("e-scrollcss");
             if (this.model.scrollSettings.frozenColumns == 0 && !this._mediaQuery) {
                if (!this.element.find(".e-gridheader").hasClass("e-scrollcss") && (this.model.filterSettings.filteredColumns.length || (this._hiddenColumns.length&&!this.model.minWidth))) {
                    this.getHeaderTable().removeAttr('style');
                    this.getContentTable().removeAttr('style');
                    if (this.model.showSummary && !ej.isNullOrUndefined(this.getFooterTable()))
                    this.getFooterTable().removeAttr('style');
                }
                else {
					this.getHeaderContent().find("div table").first().width(this.getContentTable().width());
                    this.getContent().find("div table").first().width(this.getContentTable().width());
                    if (this.model.showSummary && !ej.isNullOrUndefined(this.getFooterContent())) {
                        if(this.getScrollObject().isVScroll() && this.getScrollObject().isHScroll()){
                            if(this.model.minWidth && this.model.isResponsive)
                                this.getFooterContent().find("div table").first().width(this.getContentTable().width() + this.model.scrollSettings.scrollerSize);
                            else
                                this.getFooterContent().find("div table").first().width(this.getContentTable().width());
                            this.getFooterContent().find("div").width(this.getHeaderContent().width() + this.model.scrollSettings.scrollerSize);
                        }
                    }
					this.getHeaderTable().width(this.getContentTable().width());
                }
            }
            this._isHscrollcss();
        },
        _isHscrollcss: function () {
            var scroller = this.getContent().data("ejScroller"), css = scroller && (scroller.isHScroll() || scroller.isVScroll()) ? "addClass" : "removeClass";
            this.getHeaderContent().find(".e-headercontent")[css]("e-hscrollcss")
        },
        _initFrozenRows: function () {
            var gridRows = this.getRows();
            if (!this.model.currentViewData || this.model.currentViewData.length == 0)
                return;
            if (this.model.scrollSettings.frozenRows > 0 && gridRows != null) {
                this.getContent().find(".e-frozeny").removeClass("e-frozeny")
                    .end().find(".e-frozenrow").removeClass("e-frozenrow");
                if (!ej.isNullOrUndefined(gridRows[0][this.model.scrollSettings.frozenRows - 1]) && !ej.isNullOrUndefined(gridRows[1][this.model.scrollSettings.frozenRows - 1]) && this.model.scrollSettings.frozenColumns > 0)
                    $(gridRows[0][this.model.scrollSettings.frozenRows - 1].cells).add(gridRows[1][this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                else if (!ej.isNullOrUndefined(this.getRowByIndex(this.model.scrollSettings.frozenRows - 1)[0]))
                    $(gridRows[this.model.scrollSettings.frozenRows - 1].cells).addClass("e-frozeny").parent().addClass("e-frozenrow");
                if (this.getContent().height() > this.model.scrollSettings.height) {
					 var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
                    if (!this.initialRender && !ej.isNullOrUndefined(scrollObj) && ej.isNullOrUndefined(scrollObj._vScrollbar))
                        this._getRowHeights();
                    this.model.scrollSettings.height = this._rowHeightCollection[Math.floor(this.model.scrollSettings.height / this._rowHeightCollection[1])] + 18;
                }
            }           
        },
        refreshScrollerEvent: function () {
            var proxy = this;
            var $content = this.getContent().attr("tabindex", "0");
            var scroller = $content.data("ejScroller");
            if (!ej.isNullOrUndefined(scroller) && scroller.model.scroll == null) {
                $content.ejScroller({
                    scroll: function (e) {
                        if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.scrollVal == "scrollLeft") {
                            if (proxy.model.scrollSettings.targetPane || (!ej.isNullOrUndefined(proxy.getHeaderContent()) && proxy.getHeaderContent().find(".e-movableheader").length)) {
                                proxy.getHeaderContent().find(".e-movableheader").scrollLeft(e.scrollLeft);
                            }
                            else
                                proxy.getHeaderContent().find("div").first().scrollLeft(e.scrollLeft);
                            if (proxy.model.scrollSettings.frozenRows > 0 && proxy.model.editSettings.editMode.indexOf("inlineform") != -1 && proxy.model.isEdit) {
                                var scrollTop = e.scrollTop;
                                proxy.getContent().find(".e-content").scrollTop(0);
                                this.scrollY(this.model.scrollTop + scrollTop, true);
                            }
                        };
                        if (proxy.model.scrollSettings.frozenRows > 0 && proxy.getRows() != null) {
                            if (e.scrollData != null && e.scrollData.dimension != "width") {
                                e.cancel = true;
                                var rows = proxy.getRows(), indexes = proxy._getTopRow(e.scrollTop), currentTopRow = indexes.imaginaryIndex, frozenRows;
                                if (currentTopRow > proxy._currentTopFrozenRow)
                                    proxy._showHideRow(proxy.model.scrollSettings.frozenRows, currentTopRow, "hide", e.scrollTop);
                                else if (currentTopRow < proxy._currentTopFrozenRow)
                                    proxy._showHideRow(currentTopRow, proxy._currentTopFrozenRow + 1, "show", e.scrollTop);
                                var movableContent = proxy.getContentTable().last().find("tr");
                                var border = (parseInt(movableContent.last().find("td:first").css("border-top-width")) * 2) + 1;
                                if (e.scrollTop == this._vScrollbar.model.maximum && ((movableContent.last()[0].offsetTop + movableContent.last().height() - border) > proxy.element.find(".e-content").height())) {
                                    var totalHeight = movableContent.last().prev()[0].offsetTop + movableContent.last().prev().height();
                                    var count = 1;
                                    for (var i = (movableContent.length - 2) ; totalHeight - border > proxy.element.find(".e-content").height() ; i++) {
                                        totalHeight = movableContent[i].offsetTop + movableContent.eq(i).height();
                                        count++;
                                        break;
                                    }
                                    proxy._showHideRow(proxy.model.scrollSettings.frozenRows, currentTopRow + count, "hide", e.scrollTop);
                                }
                                e.model.scrollTop = e.scrollTop;
                            }
                            else {
                                if (!ej.isNullOrUndefined(this._vScrollbar) && !ej.isNullOrUndefined(this._vScrollbar._scrollData))
                                    this._vScrollbar._scrollData.skipChange = true;
                            }
                        }
                        if (proxy.model.scrollSettings.allowVirtualScrolling) {
                            if (proxy.model.scrollSettings.enableVirtualization && e.scrollData != null && e.scrollData.handler != "e-hhandle") {
                                e["reachedEnd"] = e.scrollData.scrollable - e.scrollTop == 0;
                                if (e.source == "thumb") {
                                    var keys = ej._getObjectKeys(proxy._virtualLoadedRows);
                                    var index = (proxy._currentVirtualIndex + 2).toString();
                                    if (proxy.model.scrollSettings.virtualScrollMode == "continuous" && $.inArray(index, keys) == -1 && index < proxy._totalVirtualViews)
                                        proxy._isContinuous = true;
                                    else {
                                        e.model.scrollTop = e.scrollTop;
                                        proxy._isContinuous = false;
                                        e.cancel = true;
                                    }
                                }
                                if (e.source == "button" || e.source == "key" || e.source == "wheel") {
                                    if ($("#" + proxy._id + "_WaitingPopup").is(":visible"))
                                        e.cancel = true;
                                    else {
                                        proxy._isThumbScroll = false;
                                        proxy._virtualViewScroll(e);
                                    }
                                    if (proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
                                        this.refresh();
                                }
                                proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);
                            }
                            else {
                                if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle" && proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter))
                                    !proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();
                                e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollTop == this.content()[0].clientHeight;
                                if ((e.source == "button" || e.source == "key" || e.source == "wheel") && proxy.model != null)
                                    proxy._virtualScroll(e);
                                if (e.source == "wheel" && e.scrollTop != proxy._scrollValue)
                                    e.scrollTop = proxy._scrollValue;
                                proxy._checkScroller(e, this);
                            }
                        }
                        if (!proxy.model.scrollSettings.frozenRows && !proxy.model.scrollSettings.frozenColumns)
                            if (!ej.isNullOrUndefined(e.scrollData) && e.scrollData.handler == "e-hhandle") {
                                if (proxy.model.allowFiltering && (proxy.model.filterSettings.filterType == "menu" || proxy._isExcelFilter))
                                    !proxy._isExcelFilter ? proxy._closeFilterDlg() : proxy._excelFilter.closeXFDialog();
                                proxy._checkScroller(e, this);
                            }
                            else {
                                proxy._scrollValue = e.scrollTop;
                                proxy.model.currentIndex = e.scrollTop == 0 ? e.scrollTop : Math.floor(e.scrollTop / proxy._vRowHeight);
                            }
                    },
                    thumbEnd: function (e) {
                        if (proxy.model.scrollSettings.allowVirtualScrolling) {
                            if (proxy.model.scrollSettings.enableVirtualization && proxy.model.scrollSettings.virtualScrollMode == "continuous")
                                e["reachedEnd"] = e.scrollData.scrollable - e.model.scrollTop == 0;
                            else if (e.originalEvent && !$(e.originalEvent.target).hasClass("e-rowcell"))
                                e["reachedEnd"] = this.content()[0].scrollHeight - e.scrollData.sTop == this.content()[0].clientHeight;
                            if (e.scrollData.handler == "e-hhandle")
                                return;
                            if (proxy.model != null && e.originalEvent) {
                                if (proxy.model.scrollSettings.enableVirtualization) {
                                    proxy._isThumbScroll = true;
								proxy._virtualViewScroll(e);
								if(proxy.model.scrollSettings.virtualScrollMode == "continuous" && e["reachedEnd"])
									this.refresh();
							}
							else
								proxy._virtualScroll(e);
                            }
                        }
                    },
                    scrollEnd: function (e) {
                        if (proxy.model.scrollSettings.allowVirtualScrolling) {
                            if (e.scrollData.type == "mousewheel" || (e.scrollData.model != null && e.scrollData.model.orientation == "horizontal")) return;
                            if (proxy.model.scrollSettings.enableVirtualization && !proxy._isContinuous) {
                                var currentPage = proxy._calculateCurrentViewPage(e.model);
                                var isVirtualPage = $.inArray(currentPage, proxy._virtualLoadedPages) != -1;
                                if (isVirtualPage) {
                                    proxy._isThumbScroll = true;
                                    proxy._virtualViewScroll(e);
                                    proxy.element.ejWaitingPopup("hide");
								if(proxy._totalVirtualViews <= proxy._maxViews * 3)
									this._content[0].scrollTop = e.scrollData.scrollTop;															
							}
							else {                             						
								e.cancel = true;
							}
						}						
                        }
                    }
                });
            }
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader").scroll(ej.proxy(function (e) {
                var $currentTarget = $(e.currentTarget);
                if (this.model.scrollSettings.targetPane) {
                    this.getContent().find(".e-movablecontent").scrollLeft($currentTarget.scrollLeft());
                    (this.model.showSummary && !ej.isNullOrUndefined(this.getFooterContent())) && this.getFooterContent().find(".e-movablefooter").scrollLeft($currentTarget.scrollLeft());;
                }
                else {
                    (this.model.showSummary && !ej.isNullOrUndefined(this.getFooterContent())) && this.getFooterContent().find("div").first().scrollLeft($currentTarget.scrollLeft());
                    this.getContent().find(".e-content").first().scrollLeft($currentTarget.scrollLeft());
                }
            }, this));
        },
        clearFiltering: function (field) {
            if (this.model.filterSettings.filterType == "filterbar")
                this.OldfilterValue = null;
		    if (field) {
		        this._clearFilter(field);
		        if (this.model.filterSettings.filterType != "filterbar")
		            for (var i = 0; i < this.filterColumnCollection.length; i++) {
		                if (this.filterColumnCollection[i].field == field)
		                    this.filterColumnCollection.splice(i, 1);
		            }
		    }
		    else {
		        var fltrCols = this.model.filterSettings.filteredColumns, i = 0;
		        while (i < fltrCols.length) {
		            this._clearFilter(fltrCols[i].field);
		        }
		        this.filterColumnCollection = [];
		        if (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel")
		            this.getHeaderTable().find(".e-filtericon").removeClass("e-filteredicon e-filternone");
		    }
		},
		_clearFilter: function (field) {
		    var filterType = this.model.filterSettings.filterType;
		    if (!ej.isNullOrUndefined(this.getColumnByField(field).filterType))
		        filterType = this.getColumnByField(field).filterType;
		    switch (filterType) {
		        case ej.Grid.FilterType.FilterBar:
		            if ($.inArray(this.getColumnByField(field), this.filterColumnCollection) != -1) {
		                this.getHeaderTable().find("#" + field + "_filterBarcell").val("");
		                this._currentFilterbarValue = "";
		                var index = $.inArray(field, this.filterColumnCollection);
		                this._currentFilterColumn = this.getColumnByField(field);
		                this._showFilterMsg();
		            }
		            break;
		        case ej.Grid.FilterType.Menu:
					var id = "#" + this._id + "_" + this._$colType + "Dlg";
					if (this._$colType == "boolean")
						$(id).find('.e-value .e-js').ejCheckBox("model.checked", false);
					else
						if (this._$colType == "number")
							$(id).find('.e-numerictextbox').ejNumericTextbox("model.value", "");
						else
							$(id).find(".e-value input").val("");					
					        $(id).find(".e-value1 input").val("");
					if (this._excelFilterRendered || this._isExcelFilter)
					    delete this._excelFilter._predicates[0][field];
					this._$curFieldName = field;						
					break;
		        case ej.Grid.FilterType.Excel:
		            if (this._excelFilter._predicates.length)
		                delete this._excelFilter._predicates[0][field];
					this._excelFilter.closeXFDialog();
					this._$curFieldName = field;
					break;
			}
			this.filterColumn(field, "", "", "or");							
		},
		clearSearching: function(){
			this.element.find(".e-gridtoolbar #" + this._id + "_search").val("");
			this.search("");
			$.extend(this.model.searchSettings, this.defaults.searchSettings);
		},
        _renderByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this.model.scrollSettings.frozenColumns))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            this.getContent().find("div").first().get(0).innerHTML = $.render[this._id + "_FrozenTemplate"]({ datas: this.model.currentViewData }, colgroups);
            this.setGridContentTable(this.getContent().find(".e-table").attr("data-role", "grid"));
        },
        addFrozenTemplate: function () {
            var template = "<div class='e-frozencontentdiv'>"
            + "<table class='e-table'>{{:~colgroup1}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONFrozenTemplate'/}}"
            + "</tbody></table></div>"
            + "<div class='e-movablecontent'><div class='e-movablecontentdiv'><table class='e-table'>{{:~colgroup2}}<tbody>"
            + "{{for datas tmpl='" + this._id + "_JSONTemplate'/}}"
            + "</tbody></table></div></div>", templates = {};
            templates[this._id + "_FrozenTemplate"] = template;
            $.templates(templates);
        },
        _getTopRow: function (offsetTop) {
            var currentTopRow = this.model.scrollSettings.frozenRows, i = 0;
            if (offsetTop > 10) {
                for (var i = 0; i < this._rowHeightCollection.length; i++) {
                    if (this._rowHeightCollection[i] > offsetTop) {
                        currentTopRow = this.model.scrollSettings.frozenRows + i - 1;
                        break;
                    }
                }
            }
            return { imaginaryIndex: currentTopRow, actualIndex: i };
        },
        _showHideRow: function (from, to, action, scrollPosition) {
            var rows = this.getRows();
            if (this.model.scrollSettings.frozenColumns > 0)
                $(rows[0]).slice(from, to).add($(rows[1]).slice(from, to).toArray())[action]();
            else
                $(rows).slice(from, to)[action]();
            this._currentTopFrozenRow = action == "show" ? from : to;
            this.getScrollObject()._changevHandlerPosition(scrollPosition);
        },
        _renderAlertDialog: function () {
            var $contentDiv = ej.buildTag('div.e-content', this._getLocalizedLabels()["frozenColumnsMessage"])
                , $buttons = ej.buildTag('span.e-buttons', "<input type='button' class='e-flat' id=" + this._id + 'ConfirmDialogOK' + " value='" + this._getDeprecatedLocalizedLabel("OKButton") + "'/>");
            this._alertDialog = ej.buildTag('div#' + this._id + 'AlertDialog');
            this._alertDialog.append($contentDiv).append($buttons);
            this.element.append(this._alertDialog);
            $buttons.find("input").ejButton({
                cssClass: this.model.cssClass,
                showRoundedCorner: true,
                size: "mini",
                click: $.proxy(function (args) {
                    this._alertDialog.ejDialog("close");
                }, this)
            });
            this._renderFDialog(this._id + 'AlertDialog');
            this._alertDialog.ejDialog({ width: "auto", enableModal: true });
        },
        _renderFDialog: function (id) {
            $("#" + id).ejDialog({ showOnInit: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, "showHeader": false, width: 260, enableResize: false, allowKeyboardNavigation: false, content: "#" + this._id });
        },
        _virtualScroll: function (e) {
			if (this.selectedRowsIndexes.length == this._gridRecordsCount)
                this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", "checked");
            if (e != null) {
                var flag = 0;
                var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
                var pageInfo = this.model.pageSettings;
                var tbody = this.getContentTable()[0].tBodies[0];
                var virtualRows = $(tbody).find('tr.e-virtualrow');
                pageInfo.totalPages = Math.ceil(recordCount / pageInfo.pageSize);
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentPageNo = this._calculateCurrenPage(virtualRows, this.getContentTable(), e.model);
                if (currentPageNo > pageInfo.totalPages)
                    currentPageNo = pageInfo.totalPages;
                if (pageInfo.currentPage != currentPageNo && $.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1 && this.element.find(".gridform:visible").length == 0) {
                    this._isVirtualRecordsLoaded = false;
                }
                if (!this._isVirtualRecordsLoaded) {
                    if ($.inArray((currentPageNo - 1) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                        if (this.model.scrollSettings.virtualScrollMode == "continuous" && !e.reachedEnd)
                            return
                        if (currentPageNo == pageInfo.totalPages && $.inArray((currentPageNo - 2) * pageInfo.pageSize, this.virtualLoadedPages) == -1) {
                            flag++;
                            this.set_currentPageIndex(currentPageNo);
                        }
                        if (flag == 1) this._lastRow = true;
                        this.set_currentPageIndex(currentPageNo);
                    }
                    pageInfo.currentPage = currentPageNo;
                }
                else
                    pageInfo.currentPage = currentPageNo;
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
        },
		_virtualViewScroll: function (e) {
            if (e != null) {                
                if (e.scrollTop !== undefined)
                    e.model.scrollTop = e.scrollTop;
                if (e.reachedEnd != undefined) e.model.reachedEnd = e.reachedEnd;
                var currentVirtualIndex = this._calculateCurrentVirtualIndex(e);
                if (this.model.isEdit)
                    this.cancelEdit();
                if ($.inArray(currentVirtualIndex, this._currentLoadedIndexes) == -1)
                    this._isVirtualRecordsLoaded = false;                               
                if (!this._isVirtualRecordsLoaded)                     
                    this.set_currentVirtualIndex(currentVirtualIndex);                							
            }
		},
        _createPagerStatusBar: function () {
            var $statusBar = this.element.find(".e-pagerstatusbar");
            if ($statusBar.length)
                $statusBar.remove();
            var $pagermsgDiv = ej.buildTag('div.e-pagermsgdiv');
            this.$pagerStatusBarDiv = ej.buildTag('div.e-pagerstatusbar').append($pagermsgDiv);
            if (this.model.scrollSettings.allowVirtualScrolling && this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                var $messageDiv = ej.buildTag('div.e-pagerfiltermsg').css("display", "none");;
                this.$pagerStatusBarDiv.append($messageDiv);
            }
            this.$pagerStatusBarDiv.appendTo(this.element);
            this.$pagerStatusBarDiv.css("display", "none");
        },
        _refreshVirtualContent: function (currentPage) {
            var rowHeight = this.getRowHeight();
            var recordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (currentPage != null) {
                this._currentPage(currentPage);
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
            var currentData = this.model.currentViewData;
            if (!this.model.scrollSettings.enableVirtualization)
                this._virtualLoadedRecords[currentPage] = currentData;
            var isVirtualization = 0;
            if (this.model.scrollSettings.enableVirtualization)
                isVirtualization = 1;
            var currentIndex = isVirtualization == 1 ? this.getCurrentIndex() + 1 : this.getCurrentIndex();
            var tbody = this.getContentTable()[0].tBodies[0];
            if (currentIndex > 1) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * currentIndex).prependTo(tbody);
            } if (currentIndex + this.model.pageSettings.pageSize <= recordsCount && this.getContentTable().find("tr").last().hasClass("e-virtualrow") != true && this.model.scrollSettings.frozenColumns == 0) {
                var virtualTRBottom = document.createElement("tr");
                var virtualHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? rowHeight * (recordsCount - (currentIndex + this.model.pageSettings.pageSize)) : 1;
                $(virtualTRBottom).addClass("e-virtualrow").css("height", virtualHeight).appendTo($(tbody));
            }
            this.virtualLoadedPages = new Array();
            this.orderedVirtualLoadedPage = [];
            this.virtualLoadedPages.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            this.orderedVirtualLoadedPage.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            var focusTR = $(tbody).find('tr:not(.e-virtualrow)').attr('name', currentIndex >= isVirtualization ? currentIndex : isVirtualization)[0];
            if (focusTR && focusTR.previousSibling && ($(focusTR.previousSibling).hasClass("e-virtualrow") || focusTR.previousSibling.offsetTop > (currentIndex * this.getContent().height()))) {
                this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                this._isVirtualRecordsLoaded = true;
            }
        },
        isIntermediate: function(){
            if (this.model.currentIndex < this.model.pageSettings.pageSize * (this.model.pageSettings.currentPage - 1))
                return true;
            else
                return false;
        },
        _refreshVirtualView: function (currentIndex, isSelection, rowIndex) {
			if(!this._singleView){			
				var virtualRowCount = this._virtualRowCount;				
				if(currentIndex){     
					var scrollRefresh, currentPage;
					if(currentIndex > this._totalVirtualViews){						
						currentIndex = 1;					
						scrollRefresh = true;						
					}
					if (isSelection == "selectRows") {
					    scrollRefresh = true;
					}
					this._currentVirtualIndex = currentIndex;
					if (!this._virtualLoadedRecords[currentIndex]) {
					    if (!this._virtualDataRefresh && this._currentVirtualIndex != this._totalVirtualViews) scrollRefresh = true;
					    currentPage = Math.ceil(currentIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
					}
					else {
					    var scrollObj = this.getScrollObject();
					    currentPage = Math.ceil((scrollObj.scrollTop() + this.model.scrollSettings.height) / this._vRowHeight / this.model.pageSettings.pageSize);
					}
					this._refreshVirtualViewScroller(scrollRefresh, isSelection, rowIndex);
					if(currentPage > this.model.pageSettings.totalPages) currentPage = this.model.pageSettings.totalPages;
					if(currentPage <= 0) currentPage = 1;
					if($.inArray(currentPage, this._virtualLoadedPages) == -1)
						this.gotoPage(currentPage);
					else{
						this._currentPage(currentPage);
						if(!this._checkCurrentVirtualView(this._virtualLoadedRecords, currentIndex))
							this._needPaging = true;
						else
							this._needPaging = false;
						this._getVirtualLoadedRecords(this.model.query);
						this._replacingVirtualContent();				
					}
				}
				else{               					
					this._refreshVirtualViewDetails();					
					var rows = $(this.getContentTable()[0].rows);
					this._setVirtualTopBottom();
					if (this.initialRender){
						for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
							var currentLoadedIndex = this._currentLoadedIndexes[i], viewIndex = (i + 1) * virtualRowCount, viewCount = i * virtualRowCount;
							$(rows[viewIndex - 1]).addClass("e-virtualview" + currentLoadedIndex);
							var hex = currentLoadedIndex.toString(32);
							var vRows = rows.slice(viewCount, viewCount + virtualRowCount).attr('name', hex).detach();
							this._virtualLoadedRows[currentLoadedIndex] = vRows;
							vRows.appendTo(this.getContentTable());
						}
						if(this._currentVirtualIndex > 1) 
							this._refreshVirtualViewScroller();											
					}			
					this._eventBindings();
				}
				if($.inArray(this._currentPage(), this._virtualLoadedPages) == -1)
					this._virtualLoadedPages.push(this._currentPage());				
			}
			else {
				this._singleView = false;				
				this._addLastRow();	
				this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
				var hex = this._currentVirtualIndex.toString(32);				
				$(this._gridRows).attr('name', hex);
				this._virtualLoadedRows[this._currentVirtualIndex] = this._gridRows;				
				this._eventBindings();
			}
			if(!currentIndex && (this.model.queryCellInfo || this.model.rowDataBound)){
				for(var i = 0; i < this._currentLoadedIndexes.length; i++){					
					if($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
						this._queryCellView.push(this._currentLoadedIndexes[i]);						
				}
			}
			this._isThumbScroll = false;
			this._virtualDataRefresh = false;
        },
		_refreshVirtualViewData: function(){
			this._virtualLoadedRecords = {};
			this._virtualLoadedRows = {};	
			this._virtualLoadedPages = [];	
			this._virtualPageRecords = {};
			this._queryCellView	= [];									
			if(this.model.pageSettings.totalPages != null && this._currentPage() > this.model.pageSettings.totalPages){
				this._currentPage(1);
				this._currentVirtualIndex = 1;
			}			
		},
		setCurrentPageData: function(currentData){
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				this._refreshVirtualViewData();
				this._refreshVirtualViewDetails();										
				this._setVirtualLoadedRecords(currentData, this._currentPage());
				this._refreshVirtualView(this._currentVirtualIndex);
			}
		},
		_refreshVirtualViewScroller: function (needRefresh, isSelection, rowIndex) {
			var scrollValue;
			if ((this.initialRender && !this.model.scrollSettings.scrollTop) || needRefresh) {
			    var rowHeight = this._vRowHeight;
			    scrollValue = this.model.currentIndex * this._vRowHeight;
			}
			if (isSelection == "selectRows") {
			    scrollValue = rowIndex * this._vRowHeight;
			}
			else
				scrollValue = this._scrollObject.model.scrollTop;
			this.getContent().ejScroller("model.scrollTop", scrollValue);           
            this._scrollValue = scrollValue;
        },
		_calculateCurrentViewPage: function (args) {
			if(!args) args = this._scrollObject.model;
            var pageSize = this.model.pageSettings.pageSize;                                
            var currentPage =  Math.ceil((args.scrollTop + this.model.scrollSettings.height) / this._vRowHeight / pageSize);
			// if(this.model.scrollSettings.virtualScrollMode == "continuous")
				// currentPage = Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize);
            if(this.model.pageSettings.totalPages == null)
                this.model.pageSettings.totalPages = Math.ceil(this._getVirtualTotalRecord() / pageSize);                         
            if(currentPage > this.model.pageSettings.totalPages)
                currentPage = this.model.pageSettings.totalPages;
            this.model.pageSettings.currentPage = currentPage;
            return currentPage;
        },
		_calculateCurrentVirtualIndex: function (e) {
            var args = e.model, recordCount = this._getVirtualTotalRecord();
            var currentIndex, trEle, isLast, viewTr = [], cur, oTop, len, sTop = args.scrollTop;
            var index = sTop + this.model.scrollSettings.height;
            currentIndex = (sTop + this._vRowHeight) / this._vRowHeight / this._virtualRowCount;
            currentIndex = Math.ceil(currentIndex);
            if (sTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd) 
                currentIndex = currentIndex + 1;                      
            if(currentIndex > this._totalVirtualViews) currentIndex = this._totalVirtualViews;
            if(currentIndex <= 0) currentIndex = 1;                
            if ($.inArray(currentIndex, this._currentLoadedIndexes) !== -1 && this._virtualLoadedRows[currentIndex] && sTop != e.scrollData.scrollable) {
                var viewTrs = this.getContentTable()[0].rows; len = viewTrs.length;
                var virtualTopHeight = this.getContent().find(".e-virtualtop").height();
                isLast = sTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop + virtualTopHeight;
                    if (oTop > sTop + this.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= sTop + this.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= sTop && oTop <= sTop + this.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(sTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if(trEle.length)
                    currentIndex = parseInt(trEle.attr("name"), 32);
            }						
            this._scrollValue = sTop;           
            return currentIndex;
        },
        _calculateCurrenPage: function (virtualRows, target, args) {
            var pageSize = this.model.pageSettings.pageSize;
            var currentPage, tempCPage, diff, proxy = this, trEle, isLast, viewTr = [], cur, oTop, len,currentRowValue,$currentRow;
            var rowHeight = this.getRowHeight();
            currentPage = (args.scrollTop + this.model.scrollSettings.height) / rowHeight / pageSize;            
            currentRowValue = (this.model.pageSettings.pageSize * (this.model.pageSettings.currentPage -1 ));
			 $currentRow = this.getContentTable().find("tr[name="+currentRowValue+"]").eq(0);
			if ($currentRow.length && $currentRow.offset().top > 0 && currentPage >= 1 &&  args.scrollTop < this._scrollValue && this.virtualLoadedPages.indexOf(Math.ceil(currentPage - 1) * pageSize) !== -1)
                currentPage = Math.floor(currentPage);
            else
                currentPage = Math.ceil(currentPage);

            if (args.scrollTop >= this._scrollValue && args.virtualScrollMode == "continuous" && args.reachedEnd) {
                currentPage = this.virtualLoadedPages[this.virtualLoadedPages.length - 1] / pageSize + 2;
            }

            if ($.inArray((currentPage - 1) * pageSize, this.virtualLoadedPages) !== -1) {
                var viewTrs = this.getContentTable().children("tbody").children("tr"); len = viewTrs.length;
                isLast = args.scrollTop >= this._scrollValue;
                for (var i = 0; i < len; i++) {
                    cur = viewTrs[i];
                    oTop = cur.offsetHeight + cur.offsetTop;
                    if (oTop > args.scrollTop + proxy.model.scrollSettings.height) {
                        if (viewTr.length === 0 && i !== 0)
                            viewTr = [viewTrs[cur.offsetTop <= args.scrollTop + proxy.model.scrollSettings.height ? i : i - 1]];
                        break;
                    }
                    if (oTop >= args.scrollTop && oTop <= args.scrollTop + proxy.model.scrollSettings.height) {
                        viewTr.push(cur);
                        if (isLast === false && viewTr.length > 1)
                            break;
                    }
                }
                trEle = $(args.scrollTop >= this._scrollValue ? viewTr[viewTr.length - 1] : viewTr[0]);
                if (trEle.hasClass('e-virtualrow')) {
                    if (viewTr.length === 1) {
                        currentPage++;
                    }
                }
                else
                    currentPage = parseInt(trEle.attr("name"), 10) / pageSize + 1;
            }
            this._scrollValue = args.scrollTop;
            for (var index = 0; index < virtualRows.length; index++) {
                var val = virtualRows[index];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var prevVirtualPage = this._calculatePrevPage(virtualRows, target, args);
                    this._prevPageNo = prevVirtualPage;
                    if (currentPage == 0)
                        currentPage = 1;
                    currentPage = currentPage > this.model.pageSettings.totalPages ? this.model.pageSettings.totalPages : currentPage;
                    return currentPage;
                }
            }
            return currentPage;
        },
        _calculatePrevPage: function (virtualRows, target, args) {
            for (var i = 0; i < virtualRows.length; i++) {
                var val = virtualRows[i];
                if (val.offsetTop + val.offsetHeight >= args.scrollTop) {
                    var trElement = $(val).prevAll('tr[name]')[0];
                    if (trElement != null) {
                        return Math.ceil(parseInt($(trElement).attr('name'), 10) / this.model.pageSettings.pageSize) + 1;
                    }
                }
            }
            return -1;
        },
        _refreshVirtualPagerInfo: function () {
            var model = {};
            model.pageSize = this.model.pageSettings.pageSize;            
            model.totalRecordsCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;
            if (model.totalRecordsCount == 0)
                this._currentPage(0);
            model.currentPage = this._currentPage();
            model.totalPages = Math.ceil(model.totalRecordsCount / model.pageSize);

            return model;
        },
        _showPagerInformation: function (model) {
            var from = (model.currentPage - 1) * model.pageSize;
            $(this.$pagerStatusBarDiv).find("div:first").html(String.format(this.localizedLabels.PagerInfo, model.currentPage, model.totalPages, model.totalRecordsCount), from, from + model.pageSize);
            $(this.$pagerStatusBarDiv).css('display', 'block');
        },
        _headerCellMerge: function(args){
            args.headerCellMerge = function(index, colspan){
                var thead = this.columnHeaders;
                thead.find("th").eq(index).attr("colspan", colspan);
                for (var i = 1; i < colspan; i++) {
                    if (!ej.isNullOrUndefined(thead[0].children[index + i]))
                        thead[0].children[index + i].className += " e-hide";
                }
            };
        },
        _cellMerging: function (args) {
            args.colMerge = function (range) {
                if (this.cell.className.indexOf("e-colmerge") == -1) {
                    this.cell.className += " e-colmerge";
                    if (this.model.columns.length - this.cell.cellIndex < range)
                        range = this.model.columns.length - this.cell.cellIndex;
                    this.cell.colSpan = range;
                    for (var i = 1; i < range; i++) {
                        if (!ej.isNullOrUndefined(this.cell.parentElement.children[this.cell.cellIndex + i]))
                            this.cell.parentElement.children[this.cell.cellIndex + i].className += " e-hide";
                    }
                }
            };
            args.rowMerge = function (range) {
                if (this.cell.className.indexOf("e-rowmerge") == -1) {
                    this.cell.className += " e-rowmerge";
                    var ele = this.cell.parentNode.parentNode;
                    if (ele.rows.length - this.cell.parentElement.rowIndex < range)
                        range = ele.rows.length - this.cell.parentElement.rowIndex;
                    this.cell.rowSpan = range;
                    for (var i = 0; i < range - 1; i++) {
                        if (!ej.isNullOrUndefined(ele.children[this.cell.parentElement.rowIndex + i].nextSibling)) {
                            if (!($(".e-grid").children().is('.e-dialog')) || ($(".e-grid").find('.e-dialog').attr("style").indexOf("display: none")) != -1 || this.model.allowFiltering)
                                ele.children[this.cell.parentElement.rowIndex + i].nextSibling.children[this.cell.cellIndex].className += " e-merged e-hide";
                        }
                        else
                            break;
                    }
                }
            };
            args.merge = function (col, row) {
                if (col > 1 && row > 1) {
                    if (this.cell.className.indexOf("e-colmerge") == -1) {
                        this.cell.className += " e-colmerge";
                        var ele = this.cell.parentNode.parentNode;
                        if (ele.rows.length - this.cell.parentElement.rowIndex < row)
                            row = ele.rows.length - this.cell.parentElement.rowIndex;
                        if (!($(".e-grid").children().is('.e-dialog')) || ($(".e-grid").find('.e-dialog').attr("style").indexOf("display: none")) != -1 || this.model.allowFiltering) {
                            for (var i = 0; i < row ; i++) {
                                if (!ej.isNullOrUndefined(ele.children[this.cell.parentElement.rowIndex + i])) {
                                    var selectCell = ele.children[this.cell.parentElement.rowIndex + i].children[this.cell.cellIndex];
                                    if (this.model.columns.length - selectCell.cellIndex < col)
                                        col = this.model.columns.length - selectCell.cellIndex;
                                    selectCell.colSpan = col;
                                    for (var j = 1; j < col; j++) {
                                        if (!ej.isNullOrUndefined(selectCell.parentElement.children[this.cell.cellIndex + j]))
                                            selectCell.parentElement.children[this.cell.cellIndex + j].className += " e-hide";
                                    }
                                }
                                else
                                    break;
                            }
                        }
                        else {
                            this.cell.colSpan = col;
                            for (var j = 1; j < col; j++) {
                                if (!ej.isNullOrUndefined(this.cell.nextSibling))
                                    this.cell.parentElement.children[this.cell.cellIndex + j].className += " e-hide";
                            }
                        }
                        args.rowMerge(row);
                    }
                }
                else {
                    if (col > 1)
                        args.colMerge(col);
                    if (row > 1)
                        args.rowMerge(row);
                }
            };
        },
        _replacingContent: function () {
            var temp = document.createElement('div');
            var isVirtualization = 0;
            if (this.model.scrollSettings.enableVirtualization)
                isVirtualization = 1;
            var currentIndex = isVirtualization == 1 ? this.getCurrentIndex() + 1 : this.getCurrentIndex();
            var contentTable = this.getContentTable()[0];
            var colGroup = $(contentTable).find("colgroup").first();
            var rowHeight = this.getRowHeight();
            colGroup.replaceWith(this._getMetaColGroup());
           (this.model.detailsTemplate != null || this.model.childGrid!=null)&& colGroup.prepend(this._getIndentCol());
            var tbody = contentTable.tBodies[0];
            var currentData = this.model.currentViewData;
            if (!ej.isNullOrUndefined(this._currentPageData)) {
                this._virtualLoadedRecords[this._currentPage()] = this._currentPageData;
                this._currentPageData = null;
            }
            else
                this._virtualLoadedRecords[this._currentPage()] = currentData;
            var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](currentData));
            var proxy = this;
            var $elementTbody = elementTbody.children("tr");
            if (this._allowcolumnSelection && this.selectedColumnIndexes.length > 0) {
                for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
                    var ind = this.selectedColumnIndexes[index] + 1;
                    $elementTbody.find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
                }
            }
            this.virtualLoadedPages.push(currentIndex >= isVirtualization ? currentIndex : isVirtualization);
            if (this._lastRow) {
                var currElementsLength = this._virtualLoadedRecords[this._currentPage()].length;
                $elementTbody.slice(-currElementsLength).attr('name', currentIndex);
                var prevPageElements = $elementTbody.slice(0, $elementTbody.length - currElementsLength);
                if (prevPageElements.length) {
                    var prevPage = ((this._currentPage() - 2) * (this.model.pageSettings.pageSize));
                    prevPageElements.attr('name', prevPage);
                    this.virtualLoadedPages[this.virtualLoadedPages.length - 1] = (prevPage >= isVirtualization) ? prevPage : isVirtualization;
                    this.virtualLoadedPages.push((currentIndex >= isVirtualization) ? currentIndex : isVirtualization);
                }
            }
            else
                $($elementTbody).attr('name', currentIndex);
            var orderedVirtualPages = ej.dataUtil.mergeSort(ej.distinct(this.virtualLoadedPages));
            var minValue = ej.dataUtil.min(orderedVirtualPages);
            var maxValue = ej.dataUtil.max(orderedVirtualPages);
            $(tbody).children(".e-virtualrow").remove();
            for (var i = 0; i < orderedVirtualPages.length; i++) {
                var val = orderedVirtualPages[i];
                var pVal = orderedVirtualPages[i - 1];
                if (val != this.orderedVirtualLoadedPage[i] || this.orderedVirtualLoadedPage[i] == undefined) {
                    if (pVal != undefined)
                        $elementTbody.insertAfter($(tbody).children('[name=' + pVal + ']:last'));
                    else
                        $elementTbody.insertBefore($(tbody).children('[name=' + this.orderedVirtualLoadedPage[i] + ']:first'));
                    this.orderedVirtualLoadedPage = orderedVirtualPages;
                }
                if (val != 0) {
                    var prevValue = val == minValue ? minValue : pVal;
                    var middleRows = val - prevValue - proxy.model.pageSettings.pageSize;
                    if (middleRows > 0) {
                        var virtualTRMiddle = document.createElement("tr");
                        $(virtualTRMiddle).addClass("e-virtualrow").css("height", rowHeight * middleRows).insertBefore($(tbody).children('[name=' + val + ']:first'));
                    }
                }
                if (val == maxValue) {
                    var bottomRows = proxy._gridRecordsCount - maxValue - proxy.model.pageSettings.pageSize;
                    if (bottomRows > 0) {
                        var virtualTRBottom = document.createElement("tr");
                        $(virtualTRBottom).addClass("e-virtualrow").css("height", rowHeight * bottomRows).appendTo(tbody);
                    }
                }
            }
            if (minValue > 0) {
                var virtualTRTop = document.createElement("tr");
                $(virtualTRTop).addClass("e-virtualrow").css("height", rowHeight * minValue).prependTo(tbody);
            }
            var $content = this.getContent();
            var focusTR = $(tbody).children("tr[name=" + currentIndex + "]")[0];
            var focusPrev = focusTR.previousSibling;
            var con = $content.height();
            var focus = focusTR.offsetTop
            if (this._virtaulUnSel) {
                var virtualClone = $.extend(true, [], this._virtaulUnSel);
                for (var i = 0; i < virtualClone.length; i++) {
                    var row = virtualClone[i];
                    var page = this.model.pageSettings.currentPage;
                    var corresPage = row % this.model.pageSettings.pageSize == 0 ? parseInt(row / this.model.pageSettings.pageSize) : parseInt(row / this.model.pageSettings.pageSize) + 1;
                    if (corresPage == page) {
                        var index = row % this.model.pageSettings.pageSize;
                        var $row = $(tbody).find("tr[name=" + currentIndex + "]").eq(index);
                        $row.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                        var removeIndex = this._virtaulUnSel.indexOf(row);
                        if (removeIndex != -1)
                            this._virtaulUnSel.splice(removeIndex, 1);
                    }
                }
            }
            if ((focusTR && focusPrev && ((this._virIndex || $(focusPrev).hasClass("e-virtualrow")) || focusPrev.offsetTop > (currentIndex * con))
            && (this._gridRecordsCount - currentIndex >= this.model.pageSettings.pageSize || focusTR.offsetParent.offsetHeight - focus < con)) || this._lastRow) {
                if (this._lastRow) this._lastRow = false;
                if (this._virIndex) this._virIndex = false;
                this._isVirtualRecordsLoaded = true;
                //this.getContent().children("div").first().scrollTop(this.getContent().find(".content").scrollTop() - (this.getContent().find(".content").scrollTop() - focusTR.offsetTop));
                $content.find(".e-content").scrollTop(focus);
                this._scrollValue = this.getContent()[0].firstChild.scrollTop;
            }
            var $contentTableTr = $(contentTable).get(0);
            var tFirst = temp.firstChild;
            this._currentJsonData = currentData;
            this._gridRows = $(contentTable).get(0).rows;
            var lastVirtualRow = $(contentTable).find(".e-virtualrow").last();
            var lastVirtualRowHeight = this.model.scrollSettings.virtualScrollMode == "normal" ? (lastVirtualRow.height() - ($(contentTable).height() - (this._gridRecordsCount * rowHeight))) : 1;
            lastVirtualRow.css("height", lastVirtualRowHeight);
			if(this._enableCheckSelect )
				this._virtualCheckSelection(currentIndex);
            this._eventBindings();
        },
		_virtualCheckSelection:function(index){
			var tbody = this.getContentTable()[0].tBodies[0];
		    $(tbody).find("tr[name=" + index + "]").find('.e-checkcelldiv input').prop("checked","checked")
			$(tbody).find("tr[name=" + index + "]").attr("aria-selected", "true").find("td").addClass("e-selectionbackground e-active");
		},
		_replacingVirtualContent: function () {                  
            var contentTable = this.getContentTable()[0];                            
            var currentLoadedIndexes = this._currentLoadedIndexes;            
            var tempTbody = $("<tbody></tbody>");		                   
            if (this._checkCurrentVirtualView(this._virtualLoadedRows, this._currentVirtualIndex)) {
				var currentRows = [];
                for (var i = 0; i < currentLoadedIndexes.length; i++) {
					$.merge(currentRows, this._virtualLoadedRows[currentLoadedIndexes[i]]);                    					
                }
				$(tempTbody).append(currentRows);
            }
            else {
				var elementTbody = $("<tbody></tbody>"); 				
                for (var i = 0; i < currentLoadedIndexes.length; i++) {					
                    var currentIndex = currentLoadedIndexes[i], virtualRow = this._virtualLoadedRows[currentIndex];                  
                    if (!virtualRow) {
                        this._currentVirtualRowIndex = currentIndex > 0 ? (currentIndex - 1) * (this._virtualRowCount) : 0;
                        var elementTbody = $("<tbody></tbody>").append($.render[this._id + "_JSONTemplate"](this._virtualLoadedRecords[currentIndex]));                        
                        var $elementTbody = elementTbody[0].rows, length = $elementTbody.length - 1;                        
                        $($elementTbody[length]).addClass("e-virtualview" + currentIndex);
						var hex = currentIndex.toString(32);
                        var vRows = $($elementTbody).attr('name', hex);                        
                        if (vRows.length == this._virtualRowCount || currentIndex == this._totalVirtualViews){
                            this._virtualLoadedRows[currentIndex] = vRows;
                            tempTbody.append($elementTbody);
                        }
                    }
                    else {
                        if (currentIndex < this._currentVirtualIndex) {
                            var vRow = tempTbody.find(".e-virtualview" + currentIndex);
                            if (vRow.length)
                                $(virtualRow).insertBefore(vRow);
                            else
                                tempTbody.prepend(virtualRow);
                        }
                        else
                            $(virtualRow).insertAfter(tempTbody.find(".e-virtualview" + (currentIndex - 1)));
                    }					
                }				
            }						   						
            contentTable.replaceChild(tempTbody[0], contentTable.lastChild);
            if (this.selectedRowsIndexes.length && !this._enableCheckSelect) {
                var loadedIndex = $.inArray(this._prevVirtualIndex, this._currentLoadedIndexes);
                var prevLoadedIndex = $.inArray(this._prevVirtualIndex, this._prevLoadedIndexes);
                if (loadedIndex != -1 && loadedIndex != prevLoadedIndex) {
                    var changes = this._prevVirtualIndex > this._currentVirtualIndex ? this._virtualRowCount : -this._virtualRowCount;
                    this.selectedRowsIndexes = this.selectedRowsIndexes.map(function (val) { return val + changes; });
                    var selectIndex = this._selectedRow() + changes;
                    selectIndex = selectIndex >= 0 ? selectIndex : -1;
                    this._selectedRow(selectIndex);
                }
            }
            $(contentTable.rows).removeClass("e-hover");
			this._setVirtualTopBottom();
			if(this._isThumbScroll || this._remoteRefresh){				
				//this._scrollObject.refresh();				
				this._scrollObject._content[0].scrollTop = this._scrollObject.scrollTop();
                this._isThumbScroll = this._remoteRefresh = false;
            }
			if(this.model.allowSelection)							
				this._checkVirtualSelection();																						
			this._gridRows = contentTable.rows;
			this._currentJsonData = this.model.currentViewData;
			if(!this._checkCurrentVirtualView(this._queryCellView, this._currentVirtualIndex))            
				this._eventBindings();			
			if(this.model.queryCellInfo || this.model.rowDataBound){
				for(var i = 0; i < this._currentLoadedIndexes.length; i++){
					if($.inArray(this._currentLoadedIndexes[i], this._queryCellView) == -1)
						this._queryCellView.push(this._currentLoadedIndexes[i]);						
				}
			}
			this._trigger("refresh");
        },
		_setVirtualTopBottom: function(){
			var contentTable = this.getContentTable()[0];
			var rowHeight = this._vRowHeight;
			var orderedVirtualNames = ej.dataUtil.mergeSort(ej.distinct(this._currentLoadedIndexes));				
			var minValue = ej.dataUtil.min(orderedVirtualNames);
			var maxValue = ej.dataUtil.max(orderedVirtualNames);
			var recordsCount = this._getVirtualTotalRecord(), botHeight, maxViewValue;
			if(this.model.scrollSettings.virtualScrollMode == "continuous" && this._virtualLoadedRows[maxValue + 1]	){
				var keys = Object.keys(this._virtualLoadedRows);
				maxViewValue =  parseInt(ej.dataUtil.max(keys), 10);
				maxValue = maxViewValue - maxValue;
			}			
			botHeight = (maxValue * this._virtualRowCount * rowHeight);
			if($.inArray(this._totalVirtualViews, this._currentLoadedIndexes) != -1 && this._currentVirtualIndex != this._totalVirtualViews)
				botHeight = (recordsCount - (this._virtualRowCount - this._lastViewData)) * rowHeight;										
			var vBot = (recordsCount * rowHeight) - botHeight;	
			if(this.model.scrollSettings.virtualScrollMode == "continuous" && !this._virtualLoadedRows[maxValue + 1]){				
				vBot = maxViewValue && maxViewValue <=  maxValue + 1 ? vBot : 1;			 				
			}
			this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();
			var max = 1000000;							
			if (vBot > 0 && this._getVirtualTotalRecord() > this._virtualRowCount * 2){ 
				if(Math.round(vBot).toString().length < 7)
					ej.buildTag("div.e-virtualbottom", "", { height: vBot }).insertAfter(contentTable);
				else {					
					ej.buildTag("div.e-virtualbottom").insertAfter(contentTable);
					var length = Math.ceil(vBot / max);
					for(var i = 0; i < length; i++){
						var divHeight = max;
						if(i == length - 1) divHeight = vBot % max;
						$(contentTable).next().append(ej.buildTag("div", "", { height: divHeight }));
					}
				}							
			}
			if (minValue > 1) {				
				var vTop =  (minValue - 1) * this._virtualRowCount * rowHeight;																	
				if(Math.round(vTop).toString().length < 7)
					ej.buildTag("div.e-virtualtop", "", { height: vTop }).insertBefore(contentTable);			
				else {					
					ej.buildTag("div.e-virtualtop").insertBefore(contentTable);
					var length = Math.ceil(vTop / max);
					for(var i = 0; i < length; i++){
						var divHeight = max;
						if(i == length - 1) divHeight = vTop % max;
						$(contentTable).prev().append(ej.buildTag("div", "", { height: divHeight }));
					}
				}								
			}      				
			if(this._scrollObject.model.scrollTop != this._scrollValue)
				this.getContent().ejScroller("model.scrollTop", this._scrollValue);				
        },
		_checkVirtualSelection: function(){
			var contentTable = this.getContentTable()[0];
			var selectedIndexes, rowIndex;
			if (this._enableCheckSelect) {
			    this.selectedRowsIndexes = [];
			    this._virtualSelectedRecords = [];
			    this.model.selectedRecords = [];
			    var count = this.model.pageSettings.pageSize;
			    selectedIndexes = [].concat.apply([], this.checkSelectedRowsIndexes.map(function (n, i) {
			        return n.map(function (x) { return x + (i * count) });
			    }));
			}
			else
			    selectedIndexes = this.selectedRowsIndexes;
			if (selectedIndexes)
			    for (var i = 0; i < selectedIndexes.length; i++) {
			        var selectedIndex = selectedIndexes[i];
			        var selectedData = this._getSelectedViewData(selectedIndex);
			        var viewIndex = selectedData.viewIndex
			        if ($.inArray(viewIndex, this._currentLoadedIndexes) != -1) {
			            var selIndex = selectedIndex % this._virtualRowCount + this._currentLoadedIndexes.indexOf(viewIndex) * this._virtualRowCount;
			            if (!ej.isNullOrUndefined(contentTable.rows[selIndex])) {
			                if (!$(contentTable.rows[selIndex].cells).hasClass("e-selectionbackground"))
			                    $($(contentTable.rows[selIndex]).attr("aria-selected", "true")[0].cells).addClass("e-selectionbackground e-active");
			                if (this._enableCheckSelect || !$(contentTable.rows[selIndex].cells).hasClass("e-selectionbackground")) {
			                    rowIndex = $(contentTable.rows[selIndex]).index();
			                    this.selectedRowsIndexes.push(rowIndex);
			                    this._virtualSelectedRecords[rowIndex] = selectedData.data;
			                    this.model.selectedRecords.push(selectedData.data);
			                    $(contentTable.rows[selIndex]).find(".e-checkcelldiv [type=checkbox]").prop("checked", true);
			                }
			            }
			        }
			    }
			for(var i = 0; i < this._rowIndexesColl.length; i++){
				var selectedIndex = this._rowIndexesColl[i];
				var viewIndex = this._getSelectedViewData(selectedIndex).viewIndex;
				if(($.inArray(viewIndex, this._currentLoadedIndexes) != -1 && $.inArray(selectedIndex, this._virtualRowCellSelIndex) == -1) || this._virtualDataRefresh){
					var curIndex = $.inArray(selectedIndex, this._rowIndexesColl);
					var cellIndexes = this.selectedRowCellIndexes[curIndex].cellIndex;
					for(var j = 0; j < cellIndexes.length; j++)
						this._selectMultipleCells(selectedIndex, cellIndexes[j]);						
				}
			}
			var selectedRows = $(contentTable.rows).find(".e-active, .e-cellselectionbackground").closest("tr");
			for(var i = 0; i < selectedRows.length; i++){
				var limit = parseInt($(selectedRows[i]).attr("name"), 32) * this._virtualRowCount;
				var remain = this._virtualRowCount - $(selectedRows[i]).index() % this._virtualRowCount;	
				var current = limit - remain;
				    rowIndex = $(selectedRows[i]).index();
				if (this.selectedRowsIndexes.length && $.inArray(rowIndex, this.selectedRowsIndexes) == -1) {
					this._clearVirtualSelection = true;
					this.clearSelection(rowIndex);					
				}				
				if(this._rowIndexesColl.length && $.inArray(current, this._rowIndexesColl) == - 1)											
					$(this.getRowByIndex(rowIndex)[0].cells).removeClass("e-cellselectionbackground e-activecell");											
			}	
			$(contentTable.rows).find('.e-columnselection').removeClass('e-columnselection');
            for (var index = 0; index < this.selectedColumnIndexes.length; index++) {
				var ind = this.selectedColumnIndexes[index] + 1;
                $(contentTable.rows).find('td:nth-of-type(' + ind + ')').addClass("e-columnselection");
            }  				
			this._clearVirtualSelection = false;
		},
        _refreshPagerTotalRecordsCount: function () {
            if (this.model.filterSettings.filteredColumns.length)
                this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
            else
                this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
        },
        _maxZindex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute')
                    return parseInt($(e).css('z-index')) || 1;
            }));
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },
        _keyPressed: function (action, target, e, event) {
            var $target = $(target), toolbarId;
            if ($target.hasClass('e-tooltxt') && e.code == 13) {
                var args = { currentTarget: target, target: target.firstChild }, $toolbar = $(target).closest(".e-gridtoolbar");
                $toolbar.ejToolbar("instance")._trigger("click", args);
                return false;
            }
            if (this._allowcellSelection && !(this._previousRowCellIndex && this._previousRowCellIndex.length != 0) && !(this._lastSelectedCellIndex && this._lastSelectedCellIndex.length != 0)) {
                this._previousRowCellIndex = [];
                this._previousRowCellIndex.push([0, [0]]);
                this._lastSelectedCellIndex.push([0, [0]]);
            }
            if ($target.hasClass('e-ddl') && e.code == 13 && $(document.activeElement).parents('td').hasClass("e-templatecell") )
            return true;
            if (!this.model.allowKeyboardNavigation || ((target.tagName == 'INPUT' || target.tagName == 'TEXTAREA') && this.model.keyConfigs[action].indexOf(",") == -1 && e.code != 13 && e.code != 27 && e.code != 9) || String.fromCharCode(e.code).toLowerCase() == this.element[0].accessKey.toLowerCase())
                return true;
            if ($(target).prop("type") == "checkbox" && (e.code != 13 && e.code != 9 && e.code!=27))
                return true;
            if (this.model.editSettings.editMode == "batch" && ((target.tagName == 'INPUT' || target.tagName == 'TEXTAREA') && e.code != 13 && e.code != 9 && e.code!=27) && ((target.selectionStart != 0 && action != "moveCellRight") || (target.selectionEnd != target.value.length && action != "moveCellLeft")))
				return true;
            if (this.model.allowFiltering && ($target.hasClass('e-filtertext') && e.code == 13) || ($target.hasClass('e-fltrbtn') && e.code == 13))
                return true;
            if ((this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") && $(target).closest("#" + this._id + "EditForm").length)
                return true;
            else if ($(target).parent().siblings("#" + this._id + "EditForm").length)
                return true;
            if (e.code == 13 && $target.parent().hasClass("e-unboundcelldiv"))
                return true;
            if (e.code == 13 && target.tagName == 'INPUT' && $target.closest("#" + this._id + "_search").length)
                action = "searchRequest";
            if (e.code == 13 && this._excelFilter != null && !ej.isNullOrUndefined(this._excelFilter._openedFltr) && this._excelFilter._openedFltr.length && this._excelFilter._openedFltr.is(":visible"))
                action = "excelfilter";
            if (e.code == 13 && $(target).hasClass("e-gridtoolbar")) {
                toolbarId = $target.find(".e-hover").attr("Id");
                action = "toolbarOperationRequest";
            }
            if ((action == "multiSelectionByRightArrow" && e.code == 39 && e.shift == true) || (action == "multiSelectionByLeftArrow" && e.code == 37 && e.shift == true)) {
                action = "multiSelectionByRLArrow";
            }
            if (!this.model.isEdit && action == "cancelRequest") {
                this.clearSelection();
                this.clearCellSelection();
				this.clearColumnSelection();
                return true;
            }
            if ($(target).find("input.e-dropdownlist").attr("aria-expanded") == "true" && this.model.isEdit && action == "saveRequest")
                return true;
            if (this.getPager() != null)
                var pager = this.getPager().ejPager("model"), pageIndex = pager.currentPage;
            var returnValue = false, curEl, $target = $(target);
            if ($target.closest(".e-grid").attr("Id") !== this._id)
                return;
            switch (action) {
                case "insertRecord":
                    if (ej.gridFeatures.edit && (!this.model.isEdit && (!this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")))
                        this._toolbarOperation(this._id + "_add");
                    if(pageIndex == 0) pageIndex = 1;
                    break;
                case "toolbarOperationRequest":
                    this._toolbarOperation(toolbarId);
                    this.element.focus();
                    break;
                case "searchRequest":
                    this.search($target.val());
                    break;
                case "excelfilter":
                    var dlgID = this._id + this._excelFilter._$colType;
                    if (this._excelFilter._openedFltr.hasClass("e-dlgcustom"))
                        dlgID += "Custom";
                    this._excelFilter._openedFltr.find("#" + dlgID + "_OkBtn").trigger("click");
                    break;
                case "saveRequest":
                    if (ej.gridFeatures.edit) {
                        if (this.model.editSettings.editMode == "batch") {
                            var tr = $(this.getRowByIndex(this._bulkEditCellDetails.rowIndex))
                            if(this.model.isEdit && tr.hasClass('e-insertedrow'))
                                this._batchCellValidation(this._bulkEditCellDetails.rowIndex);
                            this._moveCurrentCell("down");
                        }
                        else
                            this._toolbarOperation(this._id + "_update");
                            event.stopPropagation();
                    }
                    break;
                case "cancelRequest":
                    if (ej.gridFeatures.edit)
                        this._toolbarOperation(this._id + "_cancel");
                    break;
                case "deleteRecord":
                    if (ej.gridFeatures.edit)
                        this._toolbarOperation(this._id + "_delete");
                    break;
                case "editRecord":
                    if (ej.gridFeatures.edit && (!this.model.isEdit || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")))
                        this._toolbarOperation(this._id + "_edit");
                    break;
                case "totalGroupCollapse":
                    if (ej.gridFeatures.group) {
                        this.collapseAll();
                        this.element.focus();
                    }
                    break;
                case "totalGroupExpand":
                    if (ej.gridFeatures.group) {
                        this.expandAll();
                        this.element.focus();
                    }
                    break;
                case "selectedGroupExpand":
                    if (ej.gridFeatures.group) {
                        this._$currentTr = $(this.getRows()).eq(this._selectedRow());
                        curEl = this._$currentTr.parents("tr").first().prev().find(".e-recordpluscollapse");
                        this.expandCollapse(curEl);
                    }
                    break;
                case "selectedGroupCollapse":
                    if (ej.gridFeatures.group) {
                        this._$currentTr = $(this.getRows()).eq(this._selectedRow());
                        curEl = this._$currentTr.parents("tr").first().prev().find(".e-recordplusexpand");
                        this.expandCollapse(curEl);
                    }
                    break;
                case "firstRowSelection":
                    if (ej.gridFeatures.selection)
                        this.selectRows(0);
                    break;
                case "lastRowSelection":
                    var lastRow;
                    if (ej.gridFeatures.selection)
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = $(this.getRows()[0]).length - 1;
                        else
                            lastRow = $(this._excludeDetailRows()).length - 1;
                        this.selectRows(lastRow);
                    break;
                case "rowUpSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    var index = this._traverseRow != null ? this._traverseRow : this._selectedRow();
                    if (index > 0) {
                        this._nextRow = index;
                        this._prevRow = index - 1;
                        var $removeHover = $(this.getContent().find("tr.e-traverse")[0]);
                        $removeHover.removeClass("e-traverse");
                        this.getRowByIndex(this._prevRow).addClass("e-traverse");
                        var selectedRows = this.getContent().find("tr.e-traverse");
                        this._traverseRow = this.getIndexByRow(selectedRows);
                    }
                    break;
                case "rowDownSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    var index = this._traverseRow != null ? this._traverseRow : this._selectedRow();
                    if ((index + 1 < this.model.currentViewData.length) || (this.model.scrollSettings.allowVirtualScrolling)) {
                        this._prevRow = index;
                        this._nextRow = index + 1;
                        var $removeHover = $(this.getContent().find("tr.e-traverse")[0]);
                        $removeHover.removeClass("e-traverse");
                        this.getRowByIndex(this._nextRow).addClass("e-traverse");
                        var selectedRows = this.getContent().find("tr.e-traverse");
                        this._traverseRow = this.getIndexByRow(selectedRows);
                    }
                    break;
                case "randomSelection":
                    this.element.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    if (this.model.selectionType == "multiple")
                        this.multiSelectCtrlRequest = true;
                    var selectedRows = this.getContent().find("tr.e-traverse");
                    this._traverseRow = this.getIndexByRow(selectedRows);
                    if (this._traverseRow != -1) {
                        if (this.model.selectionSettings.enableToggle && this.getSelectedRecords().length == 1 && $.inArray(this._traverseRow, this.selectedRowsIndexes) != -1)
                            this.clearSelection(selectedIndex);
                        else
                            this.selectRows(this._traverseRow);
                    }
                    this.getRowByIndex(index).removeClass("e-traverse");
                    this.multiSelectCtrlRequest = false;
                    break;
                case "upArrow":
                    this.multiSelectCtrlRequest = false;
                    this._traverseRow = null;
					if( this.model.isEdit && $target.hasClass('e-ddl'))
						break;
					if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined) && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if (this._selectedRow() > 0) {
                            var row = this.getRowByIndex(this._selectedRow() - 1);
                            !this._enableCheckSelect && this.selectRows(this._selectedRow() - 1, null, row);
                            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.enableVirtualization && $.inArray("cell", this.model.selectionSettings.selectionMode) == -1)
                                this._moveCurrentCell("up");
                        }
                        if (this._previousRowCellIndex && this._previousRowCellIndex.length != 0 && this._lastSelectedCellIndex[0][0] > 0 && this._allowcellSelection) {
                            this.selectCells([[this._lastSelectedCellIndex[0][0] - 1, this._lastSelectedCellIndex[0][1]]]);
                        }
                    }
                    break;
                case "downArrow":
                    this.multiSelectCtrlRequest = false;
                    this._traverseRow = null;
					if( this.model.isEdit && $target.hasClass('e-ddl'))
						break;
					if (ej.gridFeatures.selection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if(this._selectedRow() == -1)
							this.model.selectedRowIndex=0;
                        var lastRow = this._excludeDetailRows().length - 1;
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        if (this._selectedRow() != lastRow && this._selectedRow() != -1) {
							var row = this._selectedRow() == 0 ? this.getRowByIndex(this._selectedRow()):this.getRowByIndex(this._selectedRow() - 1);
                            !this._enableCheckSelect && this.selectRows(this._selectedRow() + 1, null, row);
                            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.enableVirtualization && $.inArray("cell", this.model.selectionSettings.selectionMode) == -1)
                                this._moveCurrentCell("down");
                        }
                        if (this._previousRowCellIndex && this._previousRowCellIndex.length != 0 && this._lastSelectedCellIndex[0][0] < lastRow && this._allowcellSelection) {
                            this.selectCells([[this._lastSelectedCellIndex[0][0] + 1, this._lastSelectedCellIndex[0][1]]]);
                        }
                    }
                    break;
                case "rightArrow":
                    if (ej.gridFeatures.selection && this._allowcellSelection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var row, rowIndex, columnIndex;
                        rowIndex = this._lastSelectedCellIndex[0][0];
                        row = this.getRowByIndex(rowIndex);
                        columnIndex = this._lastSelectedCellIndex[0][1][0];
                        if (ej.isNullOrUndefined(columnIndex))
                            columnIndex = this._lastSelectedCellIndex[0][1];
                        cellIndex = $(row.find("td:gt(" + columnIndex + ")").not(".e-hide")[0]).index();
                        if (cellIndex == -1) {
                            rowIndex = rowIndex + 1;
                            row = this.getRowByIndex(rowIndex);
                            cellIndex = $(row.find("td").not(".e-hide")[0]).index();
                        }
                        if (rowIndex != -1 && cellIndex != -1)
                            this.selectCells([[rowIndex, [cellIndex]]]);
                    }
                    break;
                case "leftArrow":
                    if (ej.gridFeatures.selection && this._allowcellSelection && (this.element.is(document.activeElement)|| this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var row, rowIndex, columnIndex, cellIndex, Index;
                        rowIndex = this._lastSelectedCellIndex[0][0];
                        row = this.getRowByIndex(rowIndex);
                        var columnIndex = this._lastSelectedCellIndex[0][1];
                        Index = row.find("td:lt(" + columnIndex + ")").not(".e-hide").length - 1;
                        cellIndex = $(row.find("td:lt(" + columnIndex + ")").not(".e-hide")[Index]).index();
                        if (cellIndex == -1) {
                            rowIndex = rowIndex - 1;
                            row = this.getRowByIndex(rowIndex);
                            Index = row.find("td:lt(" + this.model.columns.length + ")").not(".e-hide").length - 1;
                            cellIndex = $(row.find("td:lt(" + this.model.columns.length + ")").not(".e-hide")[Index]).index();
                        }
                        if (rowIndex != -1 && cellIndex != -1)
                            this.selectCells([[rowIndex, cellIndex]]);
                    }
                    break;
                case "firstCellSelection":
                    if (ej.gridFeatures.selection && this._allowcellSelection) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var lastRow = $(this.getRows()).length - 1;
                        lastRow > -1 && this.selectCells([[0, [0]]]);
                    }
                    break;
                case "lastCellSelection":
                    var lastRow;
                    if (ej.gridFeatures.selection && this._allowcellSelection) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        else
                            lastRow = $(this._excludeDetailRows()).length - 1;
                        lastRow > -1 && this.selectCells([[lastRow, [this.model.columns.length - 1]]]);
                    }
                    break;
                case "nextPage":
                    if (this.getPager() != null)
                        pageIndex = pageIndex + 1;
                    if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie")
                        this.element.focus();
                    break;
                case "previousPage":
                    if (this.getPager() != null)
                        pageIndex = pageIndex - 1;
                    if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie")
                        this.element.focus();
                    break;
                case "lastPage":
                    if (this.getPager() != null)
                        pageIndex = pager.totalPages;
                    break;
                case "firstPage":
                    if (this.getPager() != null)
                        pageIndex = 1;
                    break;
                case "nextPager":
                    if (this.getPager() != null)
                        pageIndex = Math.ceil(pager.currentPage / pager.pageCount) * pager.pageCount + 1;
                    break;
                case "previousPager":
                    if (this.getPager() != null)
                        pageIndex = (Math.floor(pager.currentPage / pager.pageCount) - 1) * pager.pageCount + 1;
                    break;
                case "moveCellLeft":
                    if (this.model.editSettings.editMode == "batch"){
						this._tabKey = true;
						returnValue = this._moveCurrentCell("left", event);
					}
                    else
                        returnValue = true;
                    if (e.code == 9 && $.inArray("cell", this.model.selectionSettings.selectionMode) != -1)
                        this.selectCells([[this._bulkEditCellDetails.rowIndex, this._bulkEditCellDetails.columnIndex]]);
                    break;
                case "moveCellRight":
                    if (this.model.editSettings.editMode == "batch" && $target){
						this._tabKey = true;
						returnValue = this._moveCurrentCell("right", event);
					}
                    else
                        returnValue = true;
                    if (e.code == 9 && $.inArray("cell", this.model.selectionSettings.selectionMode) != -1)
                        this.selectCells([[this._bulkEditCellDetails.rowIndex, this._bulkEditCellDetails.columnIndex]]);
                    break;
                case "multiSelectionByDownArrow":
                    if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined)) {
                        var lastRow = this._excludeDetailRows().length - 1, $target = this.element.find('.e-gridcontent').find('.e-rowcell');
                        if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined(this.getRows()[0]))
                            lastRow = this.getRows()[0].length - 1;
                        this.multiSelectShiftRequest = true;
                        if (this._allowcellSelection && this._lastSelectedCellIndex[0][0] <= lastRow && this._lastSelectedCellIndex[0][0] != -1) {
                            var rowIndex, columnIndex;
                            rowIndex = this._lastSelectedCellIndex[0][0] + 1;
                            columnIndex = parseInt(this._lastSelectedCellIndex[0][1]);
                            if (rowIndex <= lastRow)
                                this.selectCells([[rowIndex, [columnIndex]]])
                        }
                        this.multiSelectShiftRequest = false;
                        if (this._selectedRow() <= lastRow && this._selectedRow() != -1) {
                            var selectedRow = this._selectedRow() + 1, fromIndex = this._previousIndex;
                            this.multiSelectShiftRequest = true;
                            this.selectRows(fromIndex, selectedRow, $target);
                            this.multiSelectShiftRequest = false;
                            if ((selectedRow - 1) == lastRow) {
                                this.selectRows(fromIndex, lastRow);
                                selectedRow = lastRow;
                            }
                        }
                        this._selectedRow(selectedRow);
                        this._previousIndex = fromIndex;
                    }
                    this.model.editSettings.editMode == "batch" && this.element.focus();
                    break;
                case "multiSelectionByUpArrow":
                    var firstRow = 0;
                    if (ej.gridFeatures.selection && (this._selectedRow() != -1 || this._previousRowCellIndex != undefined)) {
                        var lastRow = this._excludeDetailRows().length - 1, $target = this.element.find('.e-gridcontent').find('.e-rowcell');
                        this.multiSelectShiftRequest = true;
                        if (this._allowcellSelection && this._lastSelectedCellIndex[0][0] <= lastRow && this._lastSelectedCellIndex[0][0] != -1) {
                            var rowIndex, columnIndex;
                            rowIndex = this._lastSelectedCellIndex[0][0] - 1;
                            columnIndex = parseInt(this._lastSelectedCellIndex[0][1]);
                            if (rowIndex != -1)
                                this.selectCells([[rowIndex, [columnIndex]]])
                        }
                        this.multiSelectShiftRequest = false;
                        if (this._selectedRow() >= 0 && this._selectedRow() >= -1) {
                            var selectedRow = this._selectedRow() - 1, fromIndex = this._previousIndex;
                            this.multiSelectShiftRequest = true;
                            this.selectRows(fromIndex, selectedRow, $target);
                            this.multiSelectShiftRequest = false;
                            if (selectedRow < 0) {
                                this.selectRows(fromIndex, firstRow);
                                selectedRow = firstRow;
                            }
                        }
                        this._selectedRow(selectedRow);
                        this._previousIndex = fromIndex;
                    }
                    this.model.editSettings.editMode == "batch" && this.element.focus();
                    break;
                case "multiSelectionByRLArrow":
                    if (ej.gridFeatures.selection && this._allowcellSelection && (this.element.is(document.activeElement) || this.element.find(document.activeElement).not(".e-gridtoolbar").length)) {
                        if ((target["type"] == "text" || target["type"] == "textarea" || target["type"] == "checkbox") && this.model.isEdit && this.model.editSettings.editMode != "batch")
                            return true;
                        var row, rowIndex, columnIndex, cellIndex, Index;;
                        this.multiSelectShiftRequest = true;
                        rowIndex = this._lastSelectedCellIndex[0][0];
                        row = this.getRowByIndex(rowIndex);
                        if (e.code == 37 && e.shift == true) {
                            columnIndex = this._lastSelectedCellIndex[0][1];
                            Index = row.find("td:lt(" + columnIndex + ")").not(".e-hide").length - 1;
                            cellIndex = $(row.find("td:lt(" + columnIndex + ")").not(".e-hide")[Index]).index();
                            if (cellIndex == -1) {
                                rowIndex = rowIndex - 1;
                                row = this.getRowByIndex(rowIndex);
                                Index = row.find("td:lt(" + this.model.columns.length + ")").not(".e-hide").length - 1;
                                cellIndex = $(row.find("td:lt(" + this.model.columns.length + ")").not(".e-hide")[Index]).index();
                            }
                        }
                        else {
                            columnIndex = this._lastSelectedCellIndex[0][1][0];
                            if (ej.isNullOrUndefined(columnIndex))
                                columnIndex = this._lastSelectedCellIndex[0][1];
                            cellIndex = $(row.find("td:gt(" + columnIndex + ")").not(".e-hide")[0]).index();
                            if (cellIndex == -1) {
                                rowIndex = rowIndex + 1;
                                row = this.getRowByIndex(rowIndex);
                                cellIndex = $(row.find("td").not(".e-hide")[0]).index();
                            }
                        }
                        if (rowIndex != -1 && cellIndex != -1)
                            this.selectCells([[rowIndex, [cellIndex]]]);
                        this.multiSelectShiftRequest = false;
                    }
                    break;
                default:
                    returnValue = true;
            }
            if (this.getPager() != null && pageIndex <= pager.totalPages && pager.currentPage !== pageIndex && action != "searchRequest" && action !== "deleteRecord")
                this.getPager().ejPager("goToPage", pageIndex);
            return returnValue;
        },
        _findColumnsWidth: function () {
            var j = this.getHeaderTable().find(".e-headercell").not(".e-stackedHeaderCell, .e-detailheadercell"), index = 0;           
            for (var i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i]["visible"])
                    this.columnsWidthCollection[i] = j.eq(i + index).outerWidth();
            }
        },
        _calculateWidth: function () {
            var j = this.getHeaderTable().find(".e-columnheader").last().find("th:visible"), width = 0;
            for (var i = 0; i < j.length; i++)
                width += j.eq(i).outerWidth();
            return width;

        },
        _initIndicators: function () {
            var indicatorId = this._id + "_ColumnDropIndicator";
            if ($("#" + indicatorId).length)
                $("#" + indicatorId).remove();
            this._Indicator = document.createElement("DIV");
            $(this._Indicator).attr('id', indicatorId).addClass("e-columndropindicator").addClass("e-dropAcceptor").appendTo(document.body);
            $(this._Indicator).css({ "display": "none" });

        },
        _refreshGridFooterColGroup: function () {
            this.getFooterTable().find("colgroup").remove();
            this._scrollFooterColgroup();
        },
        _refreshGroupSummary: function () {
            var headerCols = this.getHeaderContent().find("colgroup col").clone();
            headerCols.splice(0, this.model.groupSettings.groupedColumns.length);
            var $gsColgroup = this.getContentTable().find(".e-groupsummary colgroup");
            for (var i = 0; i < $gsColgroup.length; i++) {
                if (!$($gsColgroup[i]).find(".e-summary").is("visible"))
                    $($gsColgroup[i]).find(".e-summary").show();
                $($gsColgroup[i]).find("col:not('.e-summary')").remove();
                $($gsColgroup[i]).append(headerCols.clone());
            }
        },
        
        reorderColumns: function (fromfname, tofname) {
            var fromindex, toindex;
            if (typeof (fromfname) == "string" && typeof (tofname) == "string") {
                fromindex = this.getColumnIndexByField(fromfname);
                toindex = this.getColumnIndexByField(tofname);
            }
            else {
                fromindex = fromfname;
                toindex = tofname;
            }
            if (fromindex == -1 || toindex == -1 || typeof (fromindex) == "string" || typeof (toindex) == "string") return;
            this.set_dropColumn(fromindex, toindex);
            if (this.model.showStackedHeader)
                this._refreshStackedHeader();
            if (this.model.scrollSettings.allowVirtualScrolling){
				if(this.model.scrollSettings.enableVirtualization){
					this._virtualDataRefresh = true;
					this._queryCellView = [];
					this._virtualLoadedRows = {};
					this._refreshVirtualView(this._currentVirtualIndex);								
				}
				else
					this._refreshVirtualContent(); 
			}
        },
        
        columns: function (details, action) {
            if (ej.isNullOrUndefined(details)) return;
            var isString = false;
            if (typeof details === "string") {
                details = [details];
                isString = true;
            }
            else if (details instanceof Array && details.length && typeof details[0] === "string")
                isString = true;
            for (var i = 0; i < details.length; i++) {
                var field = isString ? details[i] : details[i].field, headerText = isString ? details[i] : details[i].headerText, index;
                if ((ej.isNullOrUndefined(field) || field == "") && (ej.isNullOrUndefined(headerText) || headerText == ""))
                    index = -1;
                else if (ej.isNullOrUndefined(field) || field == "")
                    index = $.inArray(this.getColumnByHeaderText(headerText), this.model.columns);
                else
                    index = $.inArray(this.getColumnByField(field), this.model.columns);
                if (action == "add" || ej.isNullOrUndefined(action)) {
                    if (index == -1)
                        this.model.columns.push(isString ? { field: details[i] } : details[i]);
                    else
                        this.model.columns[index] = isString ? { field: details[i] } : details[i];
                }
                else {
                    if (index != -1)
                        this.model.columns.splice(index, 1);
                }
            }            
            this.columnsWidthCollection = []; var tooltip = false;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                this.columnsWidthCollection.push(this.model.columns[columnCount]["width"]);
                if (!ej.isNullOrUndefined(tooltip))
                    tooltip = true;
            }
            this._enableRowHover(tooltip);
            this.refreshHeader();
			if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) 
				this._processEditing();
            this.refreshContent(true);
            if (this.model.allowScrolling) {
                this.refreshScrollerEvent();
                if (this.model.allowResizeToFit && this.getContent().ejScroller("isVScroll"))
                    this._showHideScroller();
            }
        },
        _resetDisabledCollections: function(){
            this._disabledResizingColumns = [];
			this._disabledSortableColumns = [];
			this._disabledGroupableColumns = [];
			this._disabledEditableColumns = [];
        },
        _enableRowHover: function (isTooltip) {
            var tooltip = true;
            if (ej.isNullOrUndefined(isTooltip)) {
                for (var i = 0 ; i < this.model.columns.length; i++) {
                    if (!ej.isNullOrUndefined(this.model.columns[i]['tooltip'])) {
                        tooltip = true;
                        break;
                    }
                }
            }
            else
                tooltip = isTooltip;
            if (this.model.enableRowHover || tooltip)
                this._on(this.element, "mouseenter mouseleave", ".e-gridcontent tr td", this._rowHover);
            else
                this._off(this.element, "mouseenter mouseleave", ".e-gridcontent tr td");
        },
        _rowHover: function (e) {
            var $target = $(e.target);
            if (!$target.hasClass("e-rowcell"))
                $target = $target.closest(".e-rowcell");
            if (this.model.scrollSettings.frozenColumns)
                var $gridRows = $(this.getRows());
            else
                var $gridRows = this.element.find(".e-row.e-hover,.e-alt_row.e-hover");
            if (($target.closest("#" + this._id + "EditForm").length && $target.hasClass("e-rowcell")) || !$target.hasClass("e-rowcell"))
                return;
            if (e.type == "mouseenter" && $target.hasClass("e-gridtooltip"))
                this._showTooltip($target);
            if (this.model.enableRowHover) {
                this.element.find(".e-traverse").removeClass("e-traverse");
                this._traverseRow=null;
                if (e.type == "mouseenter" && !this._dragActive) {
                     if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1]))	
					 {
						$gridRows = $($gridRows[0]).add($gridRows[1]);
						$gridRows.removeClass("e-hover");
						var index = this.getIndexByRow($target.parent());
						index != -1 && this.getRowByIndex(index).addClass("e-hover");
					}
                 else {
                     $gridRows.removeClass("e-hover");
                     if( $target.parent().hasClass('e-row') ||$target.parent().hasClass ('e-alt_row'))
                         $target.parent().addClass("e-hover");
					}
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0 && !ej.isNullOrUndefined($gridRows[0]) && !ej.isNullOrUndefined($gridRows[1]))
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.removeClass("e-hover");
                }
                var gridRows = $target.parent();
                var index = this.getIndexByRow(gridRows);
                var data = this._currentJsonData[index];
                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization) {
                    index = (index % this.model.pageSettings.pageSize);
                    data = this._currentJsonData[index];
                }
                else if (this.model.scrollSettings.enableVirtualization) {
                    var viewDetails = this._getSelectedViewData(index, $target);
                    data = viewDetails.data;
                    index = viewDetails.rowIndex;
                }
                var args = { row: gridRows, rowIndex: index, rowData: data, cell: $target };
                this._trigger("rowHover", args);
            }
            return false;
        },
        _showTooltip: function ($target, isHeaderTooltip) {
            var index = $target.index(), isStack = $target.hasClass("e-stackedHeaderCell"), data = {};
            if ($target.hasClass("e-headercelldiv"))
                index = $target.parent(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
            if (!isStack && (this.model.childGrid || this.model.detailsTemplate))
                index--;
            if (this.model.scrollSettings.frozenColumns > 0 && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                index = index + this.model.scrollSettings.frozenColumns;
            var col =  !isStack ? this.getColumnByIndex(index) : this._getStackedColumnByTarget($target);            
            if (col["clipMode"] != ej.Grid.ClipMode.Ellipsis) {
                if (col["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip) {
                    var td = $target;
                    if (!$target.find("span").hasClass("e-ellipsistooltip")) {
                        var $span = ej.buildTag('span.e-ellipsistooltip', {}, {})
                        $span.html($target.html());
                        td.append($span);
                    }
                    td.find('span.e-ellipsistooltip').css('display', 'inline-block')
                    var width = td.find('span:first')[0].getBoundingClientRect().width;
                    td.find('span.e-ellipsistooltip').remove();
                    if ($target.width() > (width)) {
                        $target.removeAttr('title');
                        return;
                    }
                }

                var scriptElement = document.createElement("script");
                if (ej.isNullOrUndefined(col["tooltip"]) && ej.isNullOrUndefined(col["headerTooltip"]))
                    return;
                else {
                    var t;
                    scriptElement.id = (this._id + col.headerText + $.inArray(col, this.model.columns) + "_TemplateToolTip").split(" ").join("");
                    scriptElement.type = "text/x-template";
                    var tooltipType = !isHeaderTooltip ? "tooltip" : "headerTooltip";
                    if (!ej.isNullOrUndefined(col[tooltipType]) && col[tooltipType].slice(0, 1) !== "#")
                        scriptElement.text = col[tooltipType];
                    else
                        t = $(col[tooltipType]);
                    if (t) {
                        scriptElement.text = t.html();
                        scriptElement.type = t.attr("type") || scriptElement.type;
                    }
                   if(!ej.isNullOrUndefined(t) && col[tooltipType].slice(0, 1) !== "#")
                    $("body").append(scriptElement);
                }
                var rowElement = $target.closest("tr");
                if (!$(rowElement).hasClass("e-columnheader") && !$target.hasClass("e-gridheader")) {
                    var index = this.getIndexByRow(rowElement);//get the target rowIndex
                    if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling) {
                        if (!this.model.scrollSettings.enableVirtualization)
                            index = index % this.model.pageSettings.pageSize;
                        else {
                            var nameAttr = rowElement.attr("name");
                            index = index % this._virtualRowCount;
                            var virtualIndex = parseInt(nameAttr, 32);
                            data = this._virtualLoadedRecords[virtualIndex][index];
                        }
                    }
                    else
                        data = this.getCurrentViewData()[index];//get the data corresponding to row hovered
                }
                data.value = !$target.hasClass("e-headercell") || isStack ? $target.text() : $target.find("e-gridheadertooltip").text();
                var str = $(scriptElement).render(data);
                $target.attr('title', str);
                if (!ej.isNullOrUndefined(data.value))
                    delete data.value;
            }
            else
                $target.removeAttr('title');

        },
        _rightClickHandler: function (e) {
            e.preventDefault(); var browser = ej.browserInfo();
            if (e.which == 3 || (browser.name == "msie" && browser.version == "8.0")) {
                var args = {},
                $target = $(e.target),
                $gridRow = $(this.getRows());
                if (this.getContentTable().has($target).length) {
                    var index = $gridRow.index($target.parent());					
					var $row = this.getRowByIndex(index);
					var $data = this._currentJsonData[index];
					if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){	
						var viewDetails = this._getSelectedViewData(index, $target);					
						$data = viewDetails.data;				
						index = viewDetails.rowIndex;					
					}
                    if (index == -1)
                        return;
                    args = { rowIndex: index, row: $row, data: $data, rowData: $data, cellIndex: $target.index(), cellValue: $target.html(), cell: $target };
                }
                else if (this.getHeaderTable().has($target).length) {
                    var index = 0,
                    $th = this.getHeaderTable().find('th').not('.e-detailheadercell,.e-grouptopleftcell,.e-filterbarcell');
                    if ($target.is('.e-headercelldiv'))
                        index = $th.index($target.closest('.e-headercell'));
                    else
                        index = $th.index($target);
                    if (index == -1)
                        return;
                    args = { headerIndex: index, headerText: this.getColumnFieldNames()[index], headerCell: $th.eq(index), column: this.getColumnByIndex(index) }
                }
                else if ($target.is('.e-pager') || (this.getPager() != null && this.getPager().has($target).length)) {
                    args = { pager: this.model.pageSettings }
                }
                this._trigger("rightClick", args);
            }
        },
        _touchGrid: function (e) {
            var curPage = this._currentPage(), doPage = true;
            if (this.model.allowScrolling || (this.model.isResponsive && this.model.minWidth != 0)) {
                var d = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? (this.getScrollObject() || {})._scrollXdata : null;
                if (d)
                    doPage = e.type == "swipeleft" ? d.scrollable - d.sTop == 0 : d.sTop == 0;
            }
            switch (e.type) {
                case "swipeleft":
                    if (this.model.allowPaging && curPage != this.model.pageSettings.totalPages && !this.model.isEdit)
                        doPage && this.element.ejGrid("gotoPage", curPage + 1);
                    break;
                case "swiperight":
                    if (this.model.allowPaging && curPage > 1 && !this.model.isEdit)
                        doPage && this.element.ejGrid("gotoPage", curPage - 1);
                    break;
            }
        },
        _recorddblClickHandler: function (e) {
             if(!ej.isNullOrUndefined(this._previousTr)){
                var isFrozenEnabled, $target = (isFrozenEnabled = this._previousTr.length > 1) ? this.getRowByIndex($(e.target).closest("tr").index()) :  $(e.target).closest("tr");
                if( isFrozenEnabled && $target[0] != this._previousTr[0] && $target[1] != this._previousTr[1])
                    return;
                else if($target[0] != this._previousTr[0])
                        return;
            }
            this._recordClickProcess(e, this, "recordDoubleClick");
        },
        _recordClickProcess: function (e, proxy, eventName) {
            var args = {}, $target = $(e.target).is(".e-rowcell") ? $(e.target) : $(e.target).closest("td");
            if ($target.closest(".e-grid").attr("id") !== proxy._id || (!$target.is('.e-rowcell') && !$target.closest("td").is(".e-rowcell")) || ($target.closest('.e-editcell,.e-insertedrow')).length > 0)
                return;
            var cellIndx = (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) ? $target.index() - 1 : $target.index();
            var column = proxy.getColumnByIndex(cellIndx);
            if (proxy.model.editSettings.editMode == "batch" && !(column.allowEditing == false) && !(column.isPrimaryKey == true))
                return;
            var index = proxy.getIndexByRow($target.closest('tr'));
            var $row = proxy.getRowByIndex(index);
            var $data = proxy._currentJsonData[index];
            if (proxy.model.scrollSettings.allowVirtualScrolling) {
                if (proxy.model.scrollSettings.enableVirtualization) {
                    var viewDetails = proxy._getSelectedViewData(index, $target);
                    $data = viewDetails.data;
                    index = viewDetails.rowIndex;
                }
                else {
                    var trIndex = index % proxy.model.pageSettings.pageSize;
                    var virtualIndex = (parseFloat($row.attr("name")) - (this.model.scrollSettings.enableVirtualization ? 1 : 0)) / proxy.model.pageSettings.pageSize + 1;
                    $data = proxy._virtualLoadedRecords[virtualIndex][trIndex];
                }
            }
            args = { rowIndex: index, row: $row, data: $data, rowData: $data, cell: $target, cellIndex: cellIndx, columnName: column["headerText"], cellValue: $target.text(),event:e };
            proxy._previousTr = args.row;
            proxy._trigger(eventName, args);
        },
        _invokeRecordClick: function (e, proxy) {
            this._recordClickProcess(e, proxy, "recordClick");
        },
        _recordClick: function (e) {
            this._click++;
            var proxy = this, singleClickTimer = null;
            if (proxy._click == 1) {
                if ($.inArray("recordClick", this.model.serverEvents) !== -1 && $.inArray("recordDoubleClick", this.model.serverEvents) !== -1) {
                    singleClickTimer = setTimeout(function () {
                        proxy._click = 0;
                        proxy._invokeRecordClick(e, proxy);
                    }, 400);
                }
                else {
					proxy._click = 0;
                    !ej.isNullOrUndefined(singleClickTimer) && clearTimeout(singleClickTimer);
                    proxy._invokeRecordClick(e, proxy);
                }
            }
            else if (proxy._click == 2) {
                !ej.isNullOrUndefined(singleClickTimer) && clearTimeout(singleClickTimer);
                proxy._click = 0;
            }
        },
        _headerMouseDown: function (e) {
            if (($(e.target).hasClass("e-headercelldiv") && !$(e.target).parent().hasClass("e-grouptopleftcell")) || $(e.target).hasClass("e-headercell")) {
                var $headercell = $(e.target).hasClass("e-headercelldiv") ? $(e.target).parent() : $(e.target);
                this.model.enableHeaderHover && $headercell.removeClass("e-hover e-headercell-hover").addClass("e-headercellactive e-active");
            }
            if (this.model.allowResizing)
                return this._resizer._mouseDown(e);
        },
        _contentMouseDown: function (e) {
            if ($(e.target).closest("td").hasClass("e-selectionbackground"))
                return;
            if ($(e.target).closest("tr").length) {
                var xPos = e.type == "touchstart" ? e.originalEvent.touches[0].pageX : e.pageX;
                var yPos = e.type == "touchstart" ? e.originalEvent.touches[0].pageY : e.pageY;
                this._dragDiv = ej.buildTag("div.e-griddragarea", "", { "position": "absolute", "width": "0px", "height": "0px" })
                this.getContent().append(this._dragDiv);
                var tr = $(e.target).closest("tr.e-row");
                if (!tr.length)
                    tr = $(e.target).closest("tr.e-alt_row");
                this._startIndex = tr.length ? this.getIndexByRow(tr) : null;
                this._on($(document), "touchmove mousemove", this._mouseMoveDragHandler);
                if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") {
                    if (!this.model.contextMenuSettings.enableContextMenu)
                        this._on(this.element, "contextmenu", function (e) { e.preventDefault() });
                }
                this._on($(document), "touchend mouseup", this._mouseUpDragHandler);
                this._startDrag = { _x: xPos, _y: yPos };
            }
        },
        _mouseMoveDragHandler: function (e) {
            if (e.pageY != this._startDrag._y) {
                var xPos = e.type == "touchmove" ? e.originalEvent.touches[0].pageX : e.pageX;
                var yPos = e.type == "touchmove" ? e.originalEvent.touches[0].pageY : e.pageY;
                this._selectDrag = true;
                var left = this._dragDiv[0].offsetLeft;
                var top = this._dragDiv[0].offsetTop;

                var x1 = this._startDrag._x,
                y1 = this._startDrag._y,
                x2 = xPos,
                y2 = yPos, tmp, eleLocation = yPos + 2;

                if (x1 > x2) { tmp = x2; x2 = x1; x1 = tmp; }
                if (y1 > y2) { tmp = y2; y2 = y1; y1 = tmp; eleLocation = yPos - 2 }
                var height = this._dragDiv.height();
                this._dragDiv.css({ left: x1, top: y1, width: x2 - x1, height: y2 - y1 });
                var element = $(document.elementFromPoint(xPos, eleLocation));
                var tr = element.closest("tr.e-row");
                if (!tr.length)
                    tr = element.closest("tr.e-alt_row");
                if (tr.length) {
                    this._endIndex = this.getIndexByRow(tr);
                    if (ej.isNullOrUndefined(this._startIndex))
                        this._startIndex = this._endIndex;
                    this.selectRows(this._startIndex, this._endIndex);
                }
            }
        },
        _mouseUpDragHandler: function (e) {
            this._off($(document), "touchend mouseup", this._mouseUpDragHandler);
            this._off($(document), "touchmove mousemove", this._mouseMoveDragHandler);
            if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "safari") {
                if (!this.model.contextMenuSettings.enableContextMenu)
                    this._off(this.element, "contextmenu", function (e) { e.preventDefault() })
            }
            e.stopPropagation();
            this._selectDrag = false;
            this._dragDiv.remove();
        },
        _headerHover: function (e) {
            var $target = $(e.target);
            if (e.type == "mouseover" || e.type == "mousemove" || e.type == "touchmove" || e.type == "MSPointerMove") {
                if (this.model.allowResizing || this.model.allowResizeToFit)
                    this._resizer._mouseHover(e);

                if (this.model.enableHeaderHover && !this._dragActive && (($target.hasClass("e-headercelldiv") && !$target.parent().hasClass("e-grouptopleftcell")) || $target.hasClass("e-headercell"))) {
                    if ($target.hasClass("e-headercelldiv"))
                        $target = $target.parent();
                    this.getHeaderTable().find(".e-columnheader").find(".e-headercell-hover").removeClass("e-headercell-hover").removeClass("e-hover");
                    $target.addClass("e-headercell-hover e-hover");
                }
                if ($target.hasClass("e-gridtooltip"))
                    this._showTooltip($target);
                if ($target.hasClass("e-gridheadertooltip") || $target.find(".e-gridheadertooltip").length)
                    this._showTooltip($target, true);
                if (e.type == "mouseover")
                    this._addCursor();
            } else
                this.model.enableHeaderHover && this.getHeaderTable().find(".e-columnheader").find(".e-headercell-hover").removeClass("e-headercell-hover").removeClass("e-hover");
        },
        _addCursor: function () {
            var flag = (this.model.allowResizing || this.model.allowResizeToFit || this.model.allowGrouping || this.model.allowFiltering || this.model.allowSorting || this.model.allowReordering || this.model.contextMenuSettings.enableContextMenu || this._allowcolumnSelection), isTempCol;
            if (!flag) {
                this.getHeaderTable().find(".e-columnheader").addClass("e-defaultcursor");
                this.getHeaderTable().find(".e-headercell").removeClass("e-defaultcursor");
            }
            else {
                this.getHeaderTable().find(".e-columnheader").removeClass("e-defaultcursor");
                if (!(this.model.contextMenuSettings.enableContextMenu || this.model.selectionSettings.selectionMode == "column")) {
                    var propArray = [{ val: this.model.allowSorting, str: "sort" }, { val: this.model.allowGrouping, str: "group" }, { val: this.model.allowReordering, str: "reorder" }, { val: this.model.allowFiltering, str: "filter" }];
                    var colpropcount = 0;
                    for (var i = 0; i < propArray.length; i++) {
                        if (propArray[i].val == false) {
                            propArray.splice(i, 1);
                            i--;
                        }
                    }

                    for (i = 0; i < this.model.columns.length && propArray.length > 0 ; i++) {
                        for (var j = 0; j < propArray.length; j++) {
                            switch (propArray[j].str) {
                                case "sort":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowSorting) && !this.model.columns[i].allowSorting)
                                        colpropcount++;
                                    break;
                                case "group":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowGrouping) && !this.model.columns[i].allowGrouping)
                                        colpropcount++
                                    break;
                                case "reorder":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowReordering) && !this.model.columns[i].allowReordering)
                                        colpropcount++
                                    break;
                                case "filter":
                                    if (!ej.isNullOrUndefined(this.model.columns[i].allowFiltering) && !this.model.columns[i].allowFiltering)
                                        colpropcount++;
                                    break;
                            }
                        }
						if(!ej.isNullOrUndefined(this.model.columns[i].template) || !ej.isNullOrUndefined(this.model.columns[i].templateID))
							isTempCol = true;
						else 
							isTempCol = false;
						if (colpropcount == propArray.length && !(isTempCol))
                            this.getHeaderTable().find(".e-headercell").eq(i).addClass("e-defaultcursor");
                        colpropcount = 0;
                    }
                }
            }
        },
        _colgroupRefresh: function () {
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                var gridcontentCol = $(this.getContentTable()).find('colgroup');
            }
            else {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup')[0];
                var gridcontentCol = $(this.getContentTable()).find('colgroup')[0];
            }
            var headerColClone = $(gridheaderCol).clone();
            var contentColClone = $(gridcontentCol).clone();
            $(gridcontentCol).remove();
            $(gridheaderCol).remove();
            if ((this.model.allowResizing || this.model.allowResizeToFit) && this.model.scrollSettings.frozenColumns > 0) {
                $(headerColClone[0]).prependTo(this.getHeaderTable()[0]);
                $(headerColClone[1]).prependTo(this.getHeaderTable()[1]);
                $(contentColClone[0]).prependTo(this.getContentTable()[0]);
                $(contentColClone[1]).prependTo(this.getContentTable()[1]);
            }
            else {
                $(headerColClone).prependTo(this.getHeaderTable());
                $(contentColClone).prependTo(this.getContentTable());
            }
        },
        _detailColsRefresh: function () {
            this._$headerCols = this.getHeaderTable().children("colgroup").find("col");
            this._$contentCols = this.getContentTable().children("colgroup").find("col");
            var colCount = this.model.columns.length;
            if (this._$headerCols.length > colCount) this._$headerCols.splice(0, (this._$headerCols.length - colCount));
            if (this._$contentCols.length > colCount) this._$contentCols.splice(0, (this._$contentCols.length - colCount));
        },
        _summaryColRrefresh: function () {
            var table = this.getFooterContent().find('.e-gridsummary');
            for (var i = 0; i < this.columnsWidthCollection.length; i++) 
                table.find('col').eq(i).width(this.columnsWidthCollection[i]);
        },
        _headerdblClickHandler: function (e) {
            if (this.model.allowResizeToFit)
                this._resizer._columnResizeToFit(e);
            if (this.model.allowScrolling)	{		
                this.getScrollObject().refresh(this.model.scrollSettings.frozenColumns > 0);
					if (this.getScrollObject().isVScroll()) {
                        this.getHeaderContent().addClass("e-scrollcss");
						this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
                    }
			}
        },

        _mouseUp: function (e) {
            if (this.model.allowResizing)
                this._resizer._mouseUp(e);
        },

        _mouseMove: function (e) {
            if (this.model.allowResizing)
                this._resizer._mouseMove(e);
        },
        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "enableResponsiveRow":
                        if (options[prop]) {
                            this.element.addClass("e-responsive");
                            if (this.model.minWidth) {
                                this._removeMedia();
                                this._scrollerAddedOnMedia = false;
                            }
                            if (this.model.allowFiltering) {
                                this.element.find('.e-filterDialog').remove();
                                this._renderFilterDialogs();
                                this._renderResponsiveFilter();
                                this.element.find('.e-gridtoolbar').remove();
                            }
                        } else {
                            if (this.model.allowFiltering) {
                                $('body').find('.e-filterDialog').remove();
                                this._renderFilterDialogs();
                            }
                            if (this.element.css("display") == "none")
                                this.element.css("display", "block");
                            this.element.removeClass("e-responsive");
                            if (this.model.minWidth)
                                this._addMedia();
                            if (this.model.allowScrolling) {
                                this.getScrollObject().refresh();
                                if (!this.getScrollObject().isVScroll()) {
                                    this.getHeaderContent().removeClass("e-scrollcss");
                                    this.getHeaderContent().find(".e-headercontent").removeClass("e-hscrollcss");
                                }
                                else if (this.getScrollObject().isVScroll()) {
                                    this.getHeaderContent().addClass("e-scrollcss");
                                    this.getHeaderContent().find(".e-headercontent").addClass("e-hscrollcss");
                                }
                            }
                        }
                        this._tdsOffsetWidth = [];
                        if (this.model.allowFiltering || this.model.allowSorting) {
                            var index = this.model.toolbarSettings.toolbarItems.indexOf('responsiveFilter');
                            index != -1 && this.model.toolbarSettings.toolbarItems.splice(index, 1);
                            var sortIndex = this.model.toolbarSettings.toolbarItems.indexOf('responsiveSorting');
                            sortIndex != -1 && this.model.toolbarSettings.toolbarItems.splice(sortIndex, 1);
                            this.element.find('.e-gridtoolbar').remove();
                            this._renderToolBar().insertBefore(this.element.find(".e-gridheader").first());
                        }
                        break;
                    case "showColumnChooser":
                        if (options[prop]) {
                            this._visibleColumns = [];
                            this._hiddenColumns = [];
                            this._visibleColumnsField = [];
                            this._hiddenColumnsField = [];
                            this._renderGridHeaderInternalDesign(this.model.columns);
                            this._renderColumnChooser();
                        }
                        else {
                            var dlgObj = $("#" + this._id + "ccDiv").data("ejDialog");
                            if (dlgObj.isOpened())
                                $("#" + this._id + "_ccTail").remove();
                            var ccBtnHeight = 0;
                            if (!ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                                ccBtnHeight += this.element.find(".e-ccButton").outerHeight();
                            this.element.find(".e-ccButton").remove();
                            $("#" + this._id + 'ccDiv_wrapper').remove();
                            this.element.css('margin-top', (parseInt(this.element.css('margin-top'), 10) - ccBtnHeight));
                        }
                        break;
                    case "gridLines":
                        this.getContent().removeClass("e-horizontallines e-verticallines e-hidelines");
						this.getHeaderContent().removeClass("e-horizontallines e-verticallines e-hidelines");
						this._showHeaderGridLines();
                        this._showGridLines();
                        break;
                    case "showDeleteConfirmDialog":
                        this.model.editSettings.showDeleteConfirmDialog = options[prop];
                        if (options[prop])
                            this._renderConfirmDialog();
                        else
                            this.element.find("#" + this._id + 'ConfirmDialog_wrapper').remove()
                        break;
                    case "showConfirmDialog":
                        this.model.editSettings.showConfirmDialog = options[prop];
                        if (options[prop])
                            this._renderConfirmDialog();
                        else
                            this.element.find("#" + this._id + 'ConfirmDialog_wrapper').remove()
                        break;
                    case "pageSettings":
                        var pageModel = this.getPager().ejPager("model");
                        if (ej.isNullOrUndefined(options[prop]["currentPage"]) || pageModel.currentPage != this._currentPage()) {
                            for (var pageProp in options[prop]) {
                                if (pageProp != "currentPage" && options[prop][pageProp] === pageModel[pageProp])
                                    delete options[prop][pageProp];
                            }
                            if ($.isEmptyObject(options[prop]))
                                break;
                            options[prop]["currentPage"] = this._currentPage();
							var pagerObj = {};
							$.extend(pagerObj,options[prop]);
                            if(pagerObj["template"] != undefined && pagerObj["template"] != pageModel.template)
                                pagerObj["template"] = null;
                            this.getPager().ejPager("option", pagerObj);
                            this._renderPagerTemplate(this.getPager(), pagerObj["showDefaults"]);
                            this._currentPage(this._currentPage() > pageModel.totalPages ? pageModel.totalPages : this._currentPage());
                            this.refreshContent();
                        }
                        break;
                    case "columns":
                        var columns = options.columns;
                        this.model.columns = [];
                        this.columns(columns, "add");
                        break;
                    case "allowPaging":
                        this.model.allowPaging = options[prop];
                        if (options[prop] && this.element.children(".e-pager").length == 0) {
						  if(this.model.isResponsive)
                                this.model.pageSettings.isResponsive = true;
                            this.element.append(this._renderGridPager());
                            this.refreshContent();
                            this.getPager().ejPager("refreshPager");
                        } else {
                            this.getPager().remove();
                            this.setGridPager(null);
                            this.refreshContent();
                            if (this.model.filterSettings.filterType == "filterbar" && this.model.allowFiltering)
                                this._createPagerStatusBar();
                        }
                        break;
                    case "allowSearching":
                        this.model.allowSearching = options[prop];
                        break;
                    case "searchSettings":
                        $.extend(this.model.searchSetings, options[prop]);
                        this.refreshContent();
                        break;
                    case "allowGrouping":
                        if (options[prop] && this.element.children(".e-groupdroparea").length == 0) {
                            this.model.allowGrouping = options[prop];
                            this.addGroupingTemplate();
							this.model.showColumnChooser && this.element.find(".e-ccButton").length > 0 ? this.element.find(".e-ccButton").after(this._renderGroupDropArea()) : this.element.prepend(this._renderGroupDropArea());
                            this._enableGroupingEvents();
                            this._headerCellgDragDrop();
                            this._off(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);
                            this._on(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);
                        } else
						{
							this.element.children(".e-groupdroparea").remove();
							if(this.model.groupSettings.groupedColumns.length > 0){
								   for(var i=this.model.groupSettings.groupedColumns.length ; i >0 ;i--){
										this.ungroupColumn(this.model.groupSettings.groupedColumns[0]);
								}
							}
						  if(!this.model.allowReordering){
							this.element.find('.e-draggable, .e-droppable').ejDraggable();
							this.element.find('.e-draggable, .e-droppable').ejDraggable("destroy");
							}
						
						}
                        if (this.model.allowGrouping) {
                            !ej.isNullOrUndefined(options["groupSettings"]) && $.extend(this.model.groupSettings, options["groupSettings"]);
                            this._enableGrouping();
                        }
                        
                        break;
                    case "groupSettings":
                        $.extend(this.model.groupSettings, options[prop]);
                        if(this.model.allowGrouping && ej.isNullOrUndefined(options["allowGrouping"]))
                            this._enableGrouping();
                        if(!ej.isNullOrUndefined(this.model.groupSettings.enableDropAreaAnimation))
                            this.model.groupSettings.enableDropAreaAutoSizing = this.model.groupSettings.enableDropAreaAnimation;
                        break;
                    case "cssClass":
                        this.element.removeClass(this.model.cssClass).addClass(options[prop]);
                        break;
                    case "allowFiltering":
                    case "filterSettings":
                        if (prop == "filterSettings")
                            $.extend(this.model.filterSettings, options[prop]);
                        else
                            this.model.allowFiltering = options[prop];
                        this.filterColumnCollection = [];
						this._excelColTypes = [];
                        if (this._$fDlgIsOpen)
                            this._closeFDialog();
                        if (!this.model.allowFiltering) {
                            if (this.model.filterSettings.filterType == ej.Grid.FilterType.FilterBar)
                                this.getHeaderTable().find(".e-filterbar").remove();
                            else if (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu || this.model.filterSettings.filterType == ej.Grid.FilterType.Excel) {
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                                this.getHeaderTable().find(".e-columnheader").find(".e-headercellsortfilter").removeClass("e-headercellsortfilter");
                                this.getHeaderTable().find(".e-columnheader").find(".e-headercellsort").removeClass("e-headercellsort");
                                var $columheader = this.getHeaderTable().find(".e-columnheader");
                                if(this.model.groupSettings.showToggleButton){
                                    this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell").addClass("e-headercellgroup");
                                    $columheader.find(".e-headercellgroupfilter").removeClass("e-headercellgroupfilter");
                                    if(this.model.enableRTL) {
                                        $columheader.find(".e-gridgroupbutton").addClass("e-rtltoggle");
                                        $columheader.find(".e-headercelldivgroup").removeClass("e-headercelldivgroup");
                                    }
                                }
                            }
                            if (this._isExcelFilter || this._excelFilterRendered) {
                                this._isExcelFilter = this._excelFilterRendered = false;
                                this._excelFilter.resetExcelFilter();
                                this._excelFilter = null;
                            }
                            this.model.filterSettings.filteredColumns = [];
                            this.refreshContent();
                        } else {
                            if (this.model.filterSettings.filterType == ej.Grid.FilterType.FilterBar) {
                                this.getHeaderTable().find(".e-filterbar").remove();
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                                this._renderFiltering();
                                this._renderFilterBarTemplate();
                                if (this.model.filterSettings.showFilterBarStatus && !this.model.allowPaging)
                                    this._createPagerStatusBar();
                                else if (this.model.allowPaging)
                                    this.getPager().ejPager({ enableExternalMessage: this.model.filterSettings.showFilterBarStatus });
                                var $filterbar = this.getHeaderTable().find(".e-filterbar");
                                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                                    $filterbar.prepend(this._getEmptyFilterBarCell());
                            } else if (!_filter && (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu || this.model.filterSettings.filterType == ej.Grid.FilterType.Excel)) {
                                var _filter = 1;
                                this.getHeaderTable().find(".e-columnheader").find(".e-filtericon").remove()
                                    .end().find(".e-headercellfilter").removeClass("e-headercellfilter");
                                this.getHeaderTable().find(".e-columnheader").find(".e-headercellsort").removeClass("e-headercellsort");
                                this.getHeaderTable().find(".e-filterbar").remove();
                                var columnHeader = this.getHeaderTable().find(".e-columnheader").find(".e-headercell").not(".e-detailheadercell");
                                for (var i = 0; i < columnHeader.length; i++) {
                                    var columnName = columnHeader.eq(i).find(".e-headercelldiv").attr("data-ej-mappingname");
									if(!ej.isNullOrUndefined(columnName)){
										var column = this.getColumnByField(columnName);
										if (!ej.isNullOrUndefined(column) && (ej.isNullOrUndefined(column.allowFiltering) || column.allowFiltering))
											columnHeader.eq(i).addClass("e-headercellfilter").append(ej.buildTag('div.e-filtericon e-icon e-filterset'));
									}
								}                           
                                if(this.model.groupSettings.showToggleButton){
                                    this.getHeaderTable().find(".e-columnheader").find(".e-headercellgroup").removeClass("e-headercellgroup");
                                    var $headertraversal = this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell");
                                    $headertraversal.addClass("e-headercellgroupfilter");
                                    $headertraversal.find(".e-filterset").addClass("e-groupfiltericon");
                                    $headertraversal.find(".e-gridgroupbutton").addClass("e-togglegroup");
                                    if(this.model.enableRTL) {
                                        $headertraversal.find(".e-gridgroupbutton").removeClass("e-rtltoggle");
                                        $headertraversal.find(".e-headercelldiv").addClass("e-headercelldivgroup");
                                    }
                                }                                 
							   if (this.model.filterSettings.filterType == ej.Grid.FilterType.Excel) {
                                    this._isExcelFilter = true;
                                    this._renderExcelFilter();
                                } else if (this._isExcelFilter) {
                                    this._isExcelFilter = false;
                                    this._excelFilter.resetExcelFilter();
                                    this._excelFilter = null;
                                }
							   if (this.model.filterSettings.filterType == ej.Grid.FilterType.Menu)
							       this._renderFilterDialogs();
                                this.model.filterSettings.filteredColumns = [];
                                this.refreshContent();
                            }
                            this._enableFilterEvents();
                        }
                        if (this.model.isResponsive && this.model.allowScrolling) {
                            var args = {};
                            args.requestType = "filtering"
                            this._refreshScroller(args);
                        }
                        break;
                    case "enableRowHover":
                        this.model.enableRowHover = options[prop];
                        this._enableRowHover();
                        break;
                    case "allowScrolling":
                    case "scrollSettings":
                        var isDestroy = false;
                        var $content = this.getContent();
						if (prop != "allowScrolling") {
                            if (!ej.util.isNullOrUndefined(options["scrollSettings"])) {
                                if ($.isEmptyObject(options["scrollSettings"])) break;
                                if (!ej.util.isNullOrUndefined(options["scrollSettings"]["enableVirtualization"]) && !ej.util.isNullOrUndefined(options["scrollSettings"]["allowVirtualScrolling"]))
                                    options["scrollSettings"]["allowVirtualScrolling"] = options["scrollSettings"]["enableVirtualization"];
                                $.extend(this.model.scrollSettings, options["scrollSettings"]);
                            }
                            this._initHeight = this.model.scrollSettings.height;
                            this._isHeightResponsive = this.model._isHeightResponsive = this.model.scrollSettings.height == "100%" ? true : false;                           
                            if (!ej.util.isNullOrUndefined(options["allowScrolling"]))
                                this.model.allowScrolling = options["allowScrolling"];
                            this._columnsPixelConvert();
							if(this.model.scrollSettings.allowVirtualScrolling){
								this._currentPage(1);
								this.model.currentIndex = 1;
								if(this.model.scrollSettings.enableVirtualization){								
									this._virtualRowCount = Math.round(this.model.scrollSettings.height / this.getRowHeight()) + 1; 
									this._refreshVirtualViewDetails();
									this._refreshVirtualViewData();
								}
								else {
									this._createPagerStatusBar();
									this._showPagerInformation(this.model.pageSettings);
								}
							}
                            if (options["scrollSettings"]["frozenColumns"] !== undefined || options["scrollSettings"]["frozenRows"] !== undefined ||
                                options["scrollSettings"]["allowVirtualScrolling"] !== undefined || options["scrollSettings"]["virtualScrollMode"] !== undefined ||
								options["scrollSettings"]["enableVirtualization"] != undefined) {
                                var model = this.model;
                                model.query = this.commonQuery.clone();
                                if (this._selectedRow() != -1){
                                    this.clearSelection(this._selectedRow());
									this._selectedRow(-1);
									if(!this._selectAllCheck)
									this._selectedMultipleRows([]);
									}
                                if (options["scrollSettings"]["virtualScrollMode"] != undefined)
                                    model.pageSettings.currentPage = 1;
                                isDestroy = true;
                                this.element.ejGrid("destroy").ejGrid(model);
                            }
                            else {
							    !ej.util.isNullOrUndefined($content.data("ejScroller")) && $content.ejScroller("destroy");
								this.getContentTable().css("width", "100%");
								this.getHeaderTable().css("width", "100%");
                                if (this.model.allowScrolling) {
                                    this.getHeaderContent().find("div").first().addClass("e-headercontent");
									 this._originalScrollWidth = this.model.scrollSettings.width;
									 this._renderScroller();
									 this.setWidthToColumns();
									 !ej.util.isNullOrUndefined($content.data("ejScroller")) && this.getScrollObject().refresh();
									 this.refreshScrollerEvent();
                                } else {
                                    this.element.children(".e-gridheader").removeClass("e-scrollcss");
                                    this.element.get(0).style.width.length == 0 && this.element.css("width", "auto");
                                    this.setWidthToColumns();
                                }
                                this._addLastRow();
                            }
						}
                            if (!isDestroy) {
                                ej.util.isNullOrUndefined(options["scrollSettings"]) && this._columnsPixelConvert();
                                if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0) {
                                    this._groupingAction(true);
                                    this._recalculateIndentWidth();
                                }
                                if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.model.allowScrolling)
                                    var scroller = this.getScrollObject();
                                var css = this.model.enableRTL ? "e-summaryscroll e-rtl" : "e-summaryscroll";
                                if (this.model.allowScrolling && this.model.showSummary) {
                                    if (scroller._vScroll)
                                        this.element.find(".e-summaryrow.e-scroller").addClass(css);
                                    this._scrollFooterColgroup();
                                }
                            }
                        break;
					case "currentIndex":
						if(this.model.allowScrolling &&  this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
							var currentView = Math.ceil(options["currentIndex"] / this._virtualRowCount);
							this._isThumbScroll = true;
							this._refreshVirtualView(currentView);
							this._refreshVirtualViewScroller(true);
						}
						else
							this._scrollObject.option("scrollTop", options["currentIndex"] * this.getRowHeight());						
						break;
                    case "locale":
                        this.model.locale = options[prop];
                        this.model.query = this.commonQuery.clone();                       
                        this._destroy();
                        this.element.css("margin-top", "0px").addClass("e-grid" + this.model.cssClass);
                        this._init();
                        break;
                    case "dataSource":
                        var $content = this.element.find(".e-gridcontent").first();
                        if (!$.isFunction(options["dataSource"]))
                            this.resetModelCollections();
						if(this._gridRecordsCount == 1 && !ej.isNullOrUndefined(this._cDeleteData) && $.inArray(this._cDeleteData[0], this._dataSource()) == -1 && this.model.editSettings.allowDeleting)
						    this._gridRecordsCount = this._dataSource().length;
						for (var i = 0; i < this.model.columns.length; i++) {
						    if (this.model.columns[i].template !== undefined)
						        this._columntemplaterefresh = true;
						}
                        this._updateDataSource = true;
						this._refreshDataSource(this._dataSource());
						this.element.children(".e-gridfooter").remove();
						if (this.model.showSummary && this.model.currentViewData.length > 0) {
						    var footer = this._renderGridFooter();
						    if (!ej.isNullOrUndefined(footer)) footer.insertAfter($content);
						}
						if(!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount)
							this._addLastRow();
                        break;
                    case "selectedRowIndex":
                        if (this._selectedRow() != -1 && $.inArray(this._selectedRow(), this.selectedRowsIndexes) == -1){
							this.model.currentIndex = this._selectedRow();
                            this.selectRows(this._selectedRow());
						}
                        else if (this._selectedRow() == -1) {
                            this.clearSelection();
                            this.selectedRowsIndexes = [];
                        }
                        break;
                    case "selectedRowIndices":
                        if (this.model.allowSelection == true && this.model.selectionType == "multiple" && this._selectedMultipleRows().length > 0) {
                            this.clearSelection();
							this.selectedRowsIndexes = this._selectedMultipleRows();
                            this._selectedMultipleRows(this.selectedRowsIndexes);
                            for (var i = 0 ; i < this.selectedRowsIndexes.length; i++) {
                                var tr = this.getRowByIndex(this.selectedRowsIndexes[i]);
                                tr.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                            }
							this.model.selectedRecords = this.getSelectedRecords();
                        }
                        else if (this._selectedMultipleRows().length == 0) {
                            this.clearSelection();
                            this.selectedRowsIndexes = [];
                        }
                        break;
                    case "editType":
                        if (this._selectedRow() != -1 && $.inArray(this._selectedRow(), this.selectedRowsIndexes) == -1)
                            this.selectRows(this._selectedRow());
                        break;
                    case "editSettings":
                        $.extend(this.model.editSettings, options[prop]);
                        this.refreshToolbar();
                        this.refreshContent(true);
                        this.refreshBatchEditMode();
                        this._tdsOffsetWidth = [];
                        $("#" + this._id + "_dialogEdit").data("ejDialog") && $("#" + this._id + "_dialogEdit").ejDialog("destroy");
                        $("#" + this._id + "_dialogEdit_wrapper,#" + this._id + "_dialogEdit").remove();
                        $("#" + this._id + "_externalEdit").remove();
                        this.getContentTable().find(".e-insertedrow").remove();
                        this.model.isEdit = false;
                        if (this.model.editSettings.editMode != 'normal')
                            this.model.editSettings.showAddNewRow = false;
                        if (!this.model.editSettings.showAddNewRow) 
                            this.getContentTable().find(".e-addedrow").length && this.cancelEdit();
                        if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                            if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate")
                                this.element.append(this._renderDialog());
                            else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                                this.element.append(this._renderExternalForm());
                       }
                        if ((this.model.editSettings.allowDeleting && this.model.editSettings.showDeleteConfirmDialog) ||
                            this.model.editSettings.editMode == "batch" && this.model.editSettings.showConfirmDialog)
                            ej.isNullOrUndefined(this._confirmDialog) && this._renderConfirmDialog();
                        this._enableEditingEvents();
						this.refreshToolbar();
                        break;
                    case "allowResizing":
                        this.model.allowResizing = options[prop];
                        if (this.model.allowResizing) {
                            this._on(this.element, ej.eventType.mouseMove, this._mouseMove);
                            this._on(this.element, "mouseup", this._mouseUp);
                            this._resizer = this._resizer || new ej.gridFeatures.gridResize(this);
                        }
                        else {
                            this._off(this.element, ej.eventType.mouseMove, this._mouseMove);
                            this._off(this.element, "mouseup", this._mouseUp);
                            if (!this.model.allowResizeToFit)
                                this._resizer = null;
                        }
                        break;
                    case "allowResizeToFit":
                        if (this.model.allowResizeToFit) {
                            this._on(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                            this._resizer = this._resizer || new ej.gridFeatures.gridResize(this);
                            this.setWidthToColumns();
                        }
                        else {
                            this._off(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                            if (!this.model.allowResizing)
                                this._resizer = null;
                        }
                        break;
                    case "allowReordering":
                        this.model.allowReordering = options[prop];
                        if (this.model.allowReordering)
                            this._headerCellreorderDragDrop();
						else if(!this.model.allowGrouping)
							this.element.find('.e-draggable, .e-droppable').ejDraggable("destroy");
                        break;
                    case "allowRowDragAndDrop":
                        if (this.model.allowRowDragAndDrop) {
                            this._rowsDragAndDrop();
                            if (this.model.selectionType == "multiple")
                                this._on(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown)
                            this.model.allowScrolling && this.getContent().ejScroller({ thumbStart: function () { return false } });
                        } else {
                            this._off(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown)
                            this.getContent().ejDroppable("destroy");
                            $(this.getRows()).ejDraggable("destroy");
                            this.getContent().ejScroller({ thumbStart: null });
                        }
                        break;
                    case "showSummary":
                    case "summaryRows":
                        if (prop == "showSummary" && options[prop]) this.addSummaryTemplate();
                        if (prop == "showSummary" && !options[prop])
                            this.element.children(".e-gridfooter").remove();
                        else if (prop == "summaryRows" && this.model.showSummary || prop == "showSummary") {
                            this.element.children(".e-gridfooter").remove();
                            this.element.children(".e-gridfooter").remove();
                            var $content = this.element.find(".e-gridcontent").first();
                            var query = this.model.query.queries;
                            var pageQuery = [];
                            for (var i = 0; i < query.length; i++) {
                                if (query[i].fn === "onPage") {
                                    pageQuery = query.splice(i, 1);
                                }
                            }
                            var queryManager = this.model.query;
                            this._setSummaryAggregate(queryManager);
                            if(pageQuery.length)
                                queryManager.queries.push(pageQuery[0]);
                            if (this.model.currentViewData.length) {
                                if (this._isLocalData) {
                                    this._remoteSummaryData = this._dataManager.executeLocal(queryManager).aggregates;
                                    var footer = this._renderGridFooter();
                                    if (!ej.isNullOrUndefined(footer)) footer.insertAfter($content);
                                }
                                else {
                                    var proxy = this;
                                    var promise = this._dataManager.executeQuery(queryManager);
                                    promise.done(function (e) {
                                        proxy.element.children(".e-gridfooter").remove();
                                        proxy._remoteSummaryData = e.aggregates
                                        var footer = this._renderGridFooter();
                                        if (!ej.isNullOrUndefined(footer)) footer.insertAfter($content);
                                    });
                                }
                            }
                            if (this.model.allowGrouping) {
                                this._rowCol = this._captionSummary();
                                this._isCaptionSummary = (this._rowCol != null && this._rowCol.length) > 0 ? true : false;
                                this.refreshContent(true);
                            }
                        }
                        break;
                    case "enableAltRow":
                        this.model.enableAltRow = options[prop];
                        this.addInitTemplate();
                        this.refreshContent();
                        break;
                    case "toolbarSettings":
                        $.extend(this.model.toolbarSettings, options[prop]);
                        this.element.children(".e-gridtoolbar").remove();
                        if (this.model.toolbarSettings.showToolbar)
                            this._renderToolBar().insertBefore(this.element.find(".e-gridheader").first());
                        break;
                    case "allowSorting":
                        this.model.allowSorting = options[prop];
                        if (!this.model.allowSorting) 
                            this.clearSorting();
                        break;
                    case "selectionSettings":
                        $.extend(this.model.selectionSettings, options[prop]);
                        this.clearSelection();
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
						if(this.model.selectionSettings.selectionMode.length > 0 && this.model.allowSelection)
							this._initSelection();
                        break;
                    case "sortSettings":
                        $.extend(this.model.sortSettings, options[prop]);
                        this.refreshContent();
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model.contextMenuSettings, options[prop]);
                        !ej.isNullOrUndefined($("#" + this._id + "_Context").data("ejMenu")) && $("#" + this._id + "_Context").ejMenu("destroy") && $("#" + this._id + "_Context").remove();
                        if (this.model.contextMenuSettings.enableContextMenu)
                            this._renderContext()
                        break;
                    case "enableRTL":
                        this.model.enableRTL = options[prop];
                        var model = this.model;
                        model.query = this.commonQuery.clone();
                        this.element.ejGrid("destroy");
                        model.enableRTL ? $("#" + this._id).addClass("e-rtl") : $("#" + this._id).removeClass("e-rtl");
                        $("#" + this._id).ejGrid(model);
                        break;
                    case "enableTouch":
                        this.model.enableTouch = options[prop];
                        if (!this.model.enableTouch) {
                            this.element.addClass("e-touch");
                            this._off(this.element, "swipeleft swiperight", ".e-gridcontent .e-table");
                        }
                        else {
                            this._on(this.element, "swipeleft swiperight", ".e-gridcontent .e-table", $.proxy(this._touchGrid, this));
                            this.element.removeClass("e-touch");
                        }
                        break;
                    case "allowSelection":
                        if (options[prop]) {
                            this._off(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", this._clickHandler);
                            this._on(this.element, "click", this._clickHandler);
							this._initSelection();
                        }
                        else {
                            this.clearSelection();
                            this.clearCellSelection();
                            this.clearColumnSelection();
                            this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
                        }
                        break;
                    case "query":
                        this.commonQuery = $.extend(true, {}, options[prop]);
                        break;
                    case "showStackedHeader":
                    case "stackedHeaderRows":
                        if (this.model.showStackedHeader && options["stackedHeaderRows"] && options.stackedHeaderRows.length > 0) {
                            if (ej.getObject("stackedHeaderRows.length", options))
                                this.model.stackedHeaderRows = options["stackedHeaderRows"];                            
                            this._refreshStackedHeader();
                         }
                          else
                            this.getHeaderTable().find(".e-stackedHeaderRow").remove();
                        break;
                    case "allowTextWrap":
                    case "textWrapSettings":
                        $.extend(this.model.textWrapSettings, options[prop]);
                            this._setTextWrap();
                        break;
                    case "rowTemplate":
                        this.refreshContent(true);
                        break;
                    case "detailsTemplate":
                        if (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) {
                            this._renderAlertDialog();
                            this._alertDialog.find(".e-content").text(this._getLocalizedLabels("FrozenNotSupportedException"));
                            this._alertDialog.ejDialog("open");
                        }
                        else {
                            var $header = this.element.children(".e-gridheader");
                            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
                            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                                this._renderFiltering();
                            this.setGridHeaderContent($header);
                            this.refreshContent(true);
                            if (this.model.allowReordering)
                                this._headerCellreorderDragDrop();
                            if (this.model.allowGrouping)
                                this._headerCellgDragDrop();
                        }
                        break;
                }
            }

        },
        
        resetModelCollections: function () {
            this.model.groupSettings.groupedColumns = [];
            this.model.filterSettings.filteredColumns = [];
            this.filterColumnCollection = [];
            this.model.sortSettings.sortedColumns = [];
            this.model.pageSettings.currentPage = this.defaults.pageSettings.currentPage;
        },
        _enableGrouping: function(){
			this.refreshTemplate();
			if (this.model.groupSettings.showToggleButton) {
			    var isFiltering = this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel");
			    var columns = this.model.columns;
			    for (var columnCount = 0; columnCount < columns.length; columnCount++) {
			        var headercell = this.getHeaderTable().find(".e-columnheader").find(".e-headercell").not(".e-stackedHeaderCell, .e-detailheadercell").eq(columnCount);
			        var field = columns[columnCount].field;
			        if ($.inArray(field, this._disabledGroupableColumns) == -1 && !ej.isNullOrUndefined(field) && field != "") {
			            if (!headercell.find(".e-gridgroupbutton").length) {
			                if ($.inArray(field, this.model.groupSettings.groupedColumns) != -1)
			                    headercell.append(this._getToggleButton().addClass("e-toggleungroup"));
			                else
			                    headercell.append(this._getToggleButton().addClass("e-togglegroup"));
			                if (isFiltering && (columns[columnCount]["allowFiltering"] == undefined || columns[columnCount]["allowFiltering"] === true) && (!ej.isNullOrUndefined(columns[columnCount].field) || columns[columnCount].field == "") && (columns[columnCount]["type"] != "checkbox")) {
			                    headercell.addClass("e-headercellgroupfilter");
			                    headercell.find(".e-filtericon").addClass("e-groupfiltericon");
			                }
			                headercell.addClass("e-headercellgroup");
			            }
			        }
			    }
			}
			if (!this.model.groupSettings.showToggleButton)
			    this.getHeaderTable().find(".e-gridgroupbutton").remove();
			this.element.find(".e-groupdroparea").remove();
			if (this.model.groupSettings.showDropArea) {
			    this.model.showColumnChooser && this.element.find(".e-ccButton").length > 0 ? this.element.find(".e-ccButton").after(this._renderGroupDropArea()) : this.element.prepend(this._renderGroupDropArea());
			    if (ej.gridFeatures.dragAndDrop) {
			        this._groupHeaderCelldrag();
			        this._headerCellgDragDrop();
			    }
			}
			if (!ej.isNullOrUndefined(this.model.groupSettings.groupedColumns.length) && this.model.groupSettings.groupedColumns.length) {
				var args = {};
			    args.columnName = this.model.groupSettings.groupedColumns[this.model.groupSettings.groupedColumns.length - 1];
			    args.requestType = ej.Grid.Actions.Grouping;
			    this.element.find(".e-groupdroparea").empty();
				for (var i = 0; i < this.model.groupSettings.groupedColumns.length - 1; i++)
					this._addColumnToGroupDrop(this.model.groupSettings.groupedColumns[i]);
				for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
					if (ej.isNullOrUndefined(this.getsortColumnByField(this.model.groupSettings.groupedColumns[i])))
						this.model.sortSettings.sortedColumns.push({ field: this.model.groupSettings.groupedColumns[i], direction: ej.sortOrder.Ascending});
				}
				this._processBindings(args);
			}
        },
        
        addIgnoreOnExport: function (args) {
            if (typeof (args) == 'string')
                this.ignoreOnExport.push(args);
            else
                this.ignoreOnExport = this.ignoreOnExport.concat(args);
        },
        addIgnoreOnToolbarServerClick: function (args) {
            if (typeof (args) == 'string')
                this.ignoreOnToolbarServerClick.push(args);
            else
                this.ignoreOnToolbarServerClick = this.ignoreOnToolbarServerClick.concat(args);
        },
        _decode: function (value) {
            return $('<div/>').html(value).text();
        },
        _htmlEscape: function (str) {
            var regx = /[&<>"']/g, charEntities = {
                "&": "&amp;",
                "<": "&lt;",
                ">": "&gt;",
                "\"": "&#34;",
                "'": "&#39;"
            };
            return str.replace(regx, function (c) {
                return charEntities[c];
            });
        },
        _mappingSelection: function () {
            if (ej.gridFeatures.selection && this._enableCheckSelect) {
                this.multiSelectCtrlRequest = true;
                var rowIndexes = [];
                for (var i = 0; i < this._currentJsonData.length; i++) {
                    if (ej.pvt.getObject(this._selectionMapColumn, this._currentJsonData[i]) == true)
                        rowIndexes.push(i)
                }
                this.selectedRowsIndexes = [];
                this.checkSelectedRowsIndexes = [];
                this._selectedRow(-1);
                this._selectionByGrid = true;
                rowIndexes.length && this.selectRows(rowIndexes);
                this._selectionByGrid = false;
            }
        },
        _headerCheckUpdateAll: function (val) {
            var data = [];
            if (this._isLocalData) {
                if (this.model.searchSettings.key != "" || this.model.filterSettings.filteredColumns.length)
                    data = this.getFilteredRecords();
                else
                    data = this._dataSource() instanceof ej.DataManager ? this._dataSource().dataSource.json : this._dataSource();
            }
            else
                data = this._currentJsonData;
            for (var i = 0; i < data.length; i++) {
                data[i][this._selectionMapColumn] = val;
                this.batchChanges.changed.push(data[i]);
            }
            this.clearSelection();
            this.batchSave();
            return;
        },
        _getForeignKeyData: function (data) {
            var proxy = this;
            var column = {},i;
            for (i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i].foreignKeyValue && this.model.columns[i].dataSource) {
                    var fieldName = ej.isNullOrUndefined(proxy.model.columns[i]["foreignKeyField"]) ? proxy.model.columns[i]["field"] : proxy.model.columns[i]["foreignKeyField"];
                    var dataSource = this.model.columns[i].dataSource instanceof ej.DataManager ? this.model.columns[i].foreignKeyData : this.model.columns[i].dataSource;
                    dataSource.filter(function (col) {
                        var value = ej.getObject(proxy.model.columns[i]["field"], data);
                        var fValue = !isNaN(parseFloat(value)) && isFinite(value) ? parseFloat(value) : value;
                        if (col[fieldName] == fValue) {
                            column[fieldName] = col;
                        }
                    });
                }
            }
            return column;
        },
        _foreignKeyBinding: function (curColumn, cellValue, gridId) {
            var cellData, val;
            var gridObj = $("#" + gridId).ejGrid('instance');
            curColumn = gridObj.model.columns[curColumn];
            var dataSource = curColumn.dataSource instanceof ej.DataManager ? curColumn.foreignKeyData : curColumn.dataSource;
            dataSource.filter(function (col) {
                if (ej.getObject(curColumn.foreignKeyField, col) == cellValue) {
                    val = ej.getObject(curColumn.foreignKeyValue, col);
                    return cellData = curColumn.type == "date" ? new Date(val) : val;
                }
            });
            if (curColumn.format) {
                cellData = gridObj.formatting(curColumn.format, cellData, gridObj.model.locale);
            }
            return cellData;
        },
        _checkForeignKeyBinding: function () {
            if (!this.model.columns.length)
                return;
            var c, _cols, _len, _col;
            for (c = 0, _cols = this.model.columns, _len = _cols.length; c < _len; c++) {
                _col = _cols[c];
                if (_col.hasOwnProperty("foreignKeyField") && _col["dataSource"] instanceof ej.DataManager)
                    this._relationalColumns.push({ field: _col["field"], key: _col["foreignKeyField"], value: _col["foreignKeyValue"], dataSource: _col["dataSource"] });
            }
            this._$fkColumn = true;
        },  
        _setForeignKeyData: function (args) {
            if (!this._relationalColumns.length)
                return;
            var arr = this._relationalColumns, len = this._relationalColumns.length,
                promises = [], viewData = this.model.currentViewData, e = {};
            var obj, qry, pred, dist, qPromise, proxy = this;
            if (viewData.length == 0) {
                for (var c = 0, clen = this.model.columns.length; c < clen; c++) {
                    var column = this.model.columns[c];
                    if (!ej.isNullOrUndefined(column["foreignKeyField"]) && column.dataSource instanceof ej.DataManager)
                        column["foreignKeyData"] = [];
                }
            }
            var failFn = ej.proxy(function (e) { /*Separate fail handler to get more control over request*/
                this._trigger("actionFailure", { requestType: "fetchingforeigndata", error: e.error });
            }, this);
            if (!this.element.ejWaitingPopup("model.showOnInit"))
                this.element.ejWaitingPopup("show");
                
            for (var i = 0; i < len; i++) {
                if (!(0 in viewData)) continue;
                obj = arr[i], e.field = obj["field"], e.keyField = obj["key"], e.valueField = obj["value"], e.dataSource = obj["dataSource"],
                            e.query = new ej.Query().select([e.valueField, e.keyField]),
                            dist = ej.distinct(viewData.level ? viewData.records : viewData, e.field, true);
                       
                var predicate = [];
                for (var j = 0; j < dist.length; j++)
                    predicate.push(new ej.Predicate(e.keyField, "equal", dist[j][e.field], true));
                predicate = ej.Predicate.or(predicate);
                e.query.where(predicate);
                        
                if (this._trigger("actionBegin", $.extend(e, { requestType: "fetchingforeigndata", column: this.getColumnByField(e.field) })))
                    return;
                qPromise = e.dataSource.ready === undefined ? e.dataSource.executeQuery(e.query, null, failFn) : e.dataSource.ready.fail(failFn);
                promises.push(qPromise);
            }
                
            $.when.apply(this, promises).then(function () {
                proxy.element.ejWaitingPopup("hide");
                var arg = [].slice.call(arguments, 0, arguments.length), column;
                for (var i = 0, plen = promises.length; i < plen; i++) {
                    obj = arr[i];
                    for (var c = 0, clen = proxy.model.columns.length; c < clen; c++) {
                        column = proxy.model.columns[c];
                        if (column["foreignKeyField"] == obj["key"] && column["foreignKeyValue"] == obj["value"] && column["field"] == obj["field"])
                            column["foreignKeyData"] = arg[i].result;
                    }
                }
                proxy.initialRender ? proxy._initGridRender() : proxy.sendDataRenderingRequest(args);
            });
                
        },
        _isRelationalRendering: function (args) {
            return (0 in this._relationalColumns) && ["add", "beginedit", "cancel"].indexOf(args.requestType) == -1;
        }        
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.edit = {
        _processEditing: function () {
            var colInfo = this._columnToSelect(), query = colInfo.query, dropObj = [], dropField = colInfo.fields, promises = [], qPromise,
                            e = this._relationalColumns, len = e.length, req;
            this.model.query._fromTable != "" && query.from(this.model.query._fromTable);
            req = dropField.length;
            if (req) 
                promises.push(this._dataManager.executeQuery(query));
            if (len != 0) {
                var obj, qry;
                for (var i = 0; i < len; i++) {
                    obj = e[i], qry = new ej.Query().select([obj.key, obj.value]);
                    qPromise = obj["dataSource"].ready === undefined ? obj["dataSource"].executeQuery(qry) : obj["dataSource"].ready;
                    promises.push(qPromise);
                }
            }
            if (colInfo.fieldsDrop.length) {
                var colLen = colInfo.fieldsDrop.length, fields = colInfo.fieldsDrop;
                for (var col = 0; col < colLen; col++) {
                    var tempobj = [];
                    var colObj = this.getColumnByField(fields[col]);
                    if (!ej.isNullOrUndefined(ej.getObject("editParams.fields.text", colObj))) {
                        var params = colObj.editParams;
                        dropObj.push(params.fields);
                    }
                    else
                        dropObj.push(fields[col]);
                    if (dropObj[col] instanceof Object) {
                        tempobj.push(dropObj[col].text);
                        tempobj.push(dropObj[col].value);
                    }
                    else tempobj.push(dropObj[col]);
                    var query = new ej.Query().select(tempobj);
                    promises.push(colObj.dataSource.executeQuery(query));
                }
            }
            if (promises.length != 0) {
                $.when.apply(this, promises).then(ej.proxy(function () {
                    var arg = [].slice.call(arguments, 0, arguments.length);
                    for (var i = 0, j = 0, k = 0, s = req, flag, plen = promises.length; i < plen; i++) {
                        while (s > 0) {
                            ej.createObject(dropField[--s], arg[i].result, this._dropDownManager);
                            flag = true;
                        }
                        if (flag && i == 0) continue; /* i == 0 - since one req will be made for all Ddl columns*/
                        if (e.length != j) {
                            var obj = e[j], key = obj.field + "." + obj.key + "." + obj.value;
                            ej.createObject(key, arg[i].result, this._dropDownManager);
                            j++;
                            continue;
                        }
                        if (e.length == j && dropObj.length) {
                            if (dropObj[k] instanceof Object) {
                                ej.createObject(dropObj[k].text, arg[i].result, this._dropDownManager);
                                ej.createObject(dropObj[k].value, arg[i].result, this._dropDownManager);
                            }
                            else
                                ej.createObject(dropObj[k], arg[i].result, this._dropDownManager);
                            k++;
                        };
                    }
                    this._initiateTemplateRendering();
                }, this));
            }
            else
                this._initiateTemplateRendering();
        },
        _initiateTemplateRendering: function() {
            if (this.model.editSettings.editMode == "normal") this.addEditingTemplate();
            else if (this.model.editSettings.editMode == "batch") this.addBatchEditTemplate();
            else if (this.model.editSettings.editMode == "dialog" ||
                this.model.editSettings.editMode == "externalform" ||
               this.model.editSettings.editMode == "inlineform")
                this.addDialogEditingTemplate();
            else this.addExternalDialogEditingTemplate();
            if ((this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                this._startAdd();
        },
        addEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('tbody');
            var $tr = ej.buildTag('tr');
            var $td = ej.buildTag('td', "", {}, { colSpan: this.model.scrollSettings.frozenColumns > 0 ? this.model.scrollSettings.frozenColumns : this.model.columns.length });
            var $form = ej.buildTag('form', "", {}, { id: this._id + "EditForm", "class": "gridform" });
            var $table = ej.buildTag('table.e-table');
            var $innerTbody = ej.buildTag('tbody');
            var $innerTr = ej.buildTag('tr');
            $tbody.append($tr);
            $tr.append($td);
            $td.append($form);
            var $colGroup = $(document.createElement('colgroup'));
            $form.append($table);
            $table.append($colGroup);
            $innerTbody.append($innerTr).appendTo($table);
            if (this.model.scrollSettings.frozenColumns > 0) {
                var $tbodyClone = $tbody.clone();
                $tbodyClone.find("td").first().prop("colSpan", this.model.columns.length - this.model.scrollSettings.frozenColumns);
            }
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                var $innerTd = ej.buildTag('td.e-rowcell');
                $innerTr.append($innerTd.get(0));
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) &&
                 (!this.model.columns[columnCount]["template"] || (this.model.columns[columnCount]["template"] && this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"]))) {
                    this._initCellEditType(columnCount, $innerTd);
                } else if (this.model.columns[columnCount]["template"]) {
                    var helpers = {}, htxt = this.model.columns[columnCount].headerText;
                    helpers["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this);
                    $.views.helpers(helpers);
                    if (!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                        htxt = htxt.replace(/[^0-9\s\w]/g, "_");
                    $("#" + this._id + htxt + columnCount + "_Template").remove();
                    var scriptElement = this._createTemplateElement(this.model.columns[columnCount]);
                    $innerTd.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "','" + columnCount + "')}}");
                } else if (this.model.columns[columnCount]["commands"]) {
                    var helpers = {};
                    helpers["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                    $.views.helpers(helpers);
                    $("#" + this._id + this.model.columns[columnCount].headerText.replace(/[^a-z0-9|s_]/gi, '')+ columnCount + "_UnboundTemplate").remove();
                    var divElement = this._createUnboundElement(this.model.columns[columnCount], columnCount);
                    $innerTd.addClass("e-unboundcell").addClass("e-" + this.model.columns[columnCount]["headerText"].replace(/[^a-z0-9|s_]/gi, '') + columnCount).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                    this.model.scrollSettings.frozenColumns > 0 && $innerTd.addClass("e-frozenunbound");
                    this._isUnboundColumn = true;
                }
                if (this.model.columns[columnCount]["textAlign"] != undefined)
                    $innerTd.css("text-align", this.model.columns[columnCount]["textAlign"]);
                this.model.columns[columnCount]["allowEditing"] == false && $innerTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isPrimaryKey"] === true)
                    $innerTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isIdentity"] === true) {
                    $innerTd.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[columnCount].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
                var $col = $(document.createElement('col'));
                if (this.model.columns[columnCount]["priority"]) {
                    $innerTd.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                    $col.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                }
                if (this.model.columns[columnCount]["visible"] === false) {
                    $col.css("display", "none");
                    $innerTd.addClass("e-hide");
                }
                if (!ej.isNullOrUndefined(this.model.columns[columnCount]["cssClass"])) {
                    $innerTd.addClass(this.model.columns[columnCount]["cssClass"]);
                }
                !this.model.groupSettings.showGroupedColumn && $innerTd.addClass("{{for ~groupedColumns}}" +
                    " {{if #data == '" + this.model.columns[columnCount]["field"] + "'}}e-hide{{/if}}" +
                    "{{/for}}") && $col.css("display", "none");
                $colGroup.append($col);
                if (columnCount == this.model.scrollSettings.frozenColumns - 1) {
                    $innerTr = $tbodyClone.find("tr").last();
                    $colGroup = $tbodyClone.find("colgroup");
                    $.templates(this._id + "_JSONFrozenEditingTemplate", $tbody.html());
                    $tbody = $tbodyClone;
                }
            }
            $.templates(this._id + "_JSONEditingTemplate", $tbody.html());
        },

        addDialogEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('div');
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            var $table = ej.buildTag('table');
            var $innerTr, $labelTd, $valueTd, trElement, tdElement;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (this.model.editSettings.editMode == "dialog") {
                    trElement = 'tr';
                    tdElement = 'td';
                }
                else trElement = tdElement = 'div';
                $innerTr = ej.buildTag(trElement);
                $labelTd = ej.buildTag(tdElement, "", { "text-align": "right" }).addClass("e-label");
                $valueTd = ej.buildTag(tdElement, "", { "text-align": "left" }).addClass("e-rowcell");
				if($innerTr.is('div'))
                    $innerTr.addClass("e-gridFromDiv")
                 if (this.model.columns[columnCount]["priority"] && this.model.editSettings.editMode == "inlineform") 
                    $innerTr.addClass("e-table-priority-" + this.model.columns[columnCount]["priority"]);
                $innerTr.append($labelTd.get(0)).append($valueTd.get(0));
                if (this.model.columns[columnCount].headerText == undefined)
                    this.model.columns[columnCount].headerText = this.model.columns[columnCount].field;
                $labelTd.append("<label for='" + this.model.columns[columnCount].field + "'>" + this.model.columns[columnCount].headerText + "</label>");
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) &&
				(!this.model.columns[columnCount]["template"] || (this.model.columns[columnCount]["template"] && this.model.columns[columnCount]["allowEditing"] !=false && this.model.columns[columnCount]["field"])))
                    this._initCellEditType(columnCount, $valueTd);
                else if (this.model.columns[columnCount]["template"]) {
                    var helpers = {}, htxt = this.model.columns[columnCount].headerText;
                    helpers["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this);
                    $.views.helpers(helpers);
                    if (!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                        htxt = htxt.replace(/[^0-9\s\w]/g, "_");
                    $("#" + this._id + htxt + columnCount + "_Template").remove();
                    var scriptElement = this._createTemplateElement(this.model.columns[columnCount]);
                    $valueTd.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "','" + columnCount + "')}}");
                } else if (this.model.columns[columnCount]["commands"]) {
                    var helpers = {};
                    helpers["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                    $.views.helpers(helpers);
                    $("#" + this._id + this.model.columns[columnCount].headerText.replace(/[^a-z0-9|s_]/gi, '')+columnCount+ "_UnboundTemplate").remove();
                    var divElement = this._createUnboundElement(this.model.columns[columnCount], columnCount);
                    $valueTd.addClass("e-unboundcell").addClass("e-" + this.model.columns[columnCount]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+columnCount).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                    this.model.scrollSettings.frozenColumns > 0 && $valueTd.addClass("e-frozenunbound");
                    this._isUnboundColumn = true;
                    $innerTr.addClass("e-hide");
                }
                this.model.columns[columnCount]["allowEditing"] == false && $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                if (this.model.columns[columnCount]["isIdentity"] === true) {
                    $valueTd.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[columnCount].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
                if (this.model.columns[columnCount]["visible"] === false)
                    $innerTr.addClass("e-hide");
                 if (!ej.isNullOrUndefined(this.model.columns[columnCount]["cssClass"])) {
                     $valueTd.addClass(this.model.columns[columnCount]["cssClass"]);
                }
                if (this.model.editSettings.editMode == "dialog") {
                    $form.append($table);
                    $table.append($innerTr);
                } else
                    $form.append($innerTr);
                $form.appendTo($tbody);
                if (this.model.columns[columnCount]["isPrimaryKey"] === true) {
                    $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                    this._primaryKeys.push($.trim(this.model.columns[columnCount].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
            }
            if (this.model.editSettings.editMode == "dialog") $form.append($table);
            $tbody = this.renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONDialogEditingTemplate", $tbody.html());
        },
        _editEventTrigger: function (args) {
            if (args.requestType == "save" || args.requestType == "delete") {
                var params = {
                    data: args.data,
                    rowData: args.data,
                    previousData: args.previousData,
                    action: args.action !== undefined ? args.action : args.requestType,
                };
                if (!ej.isNullOrUndefined(args.foreignKeyData))
                    params.foreignKeyData = args.foreignKeyData;
				this._trigger("end" + params.action.charAt(0).toUpperCase() + params.action.slice(1), params);
            }
        },
        _compiledDropDownTemplate: function (valueField, textField, colType, format) {
            var helpers = { _gridFormatting: this.formatting };
            $.views.helpers(helpers);
            var $select = ej.buildTag('select');
            var $option = ej.buildTag("option", format != null ? "{{:~_gridFormatting('" + format + "'," + textField + ",'" + this.model.locale + "')}}" : "{{:" + textField + "}}", {}, { value: "{{:" + valueField + "}}" });
            $select.append($option);
            return $.templates($select.html());
        },
        _initCellEditType: function (columnCount, element) {
            var fName = this.model.columns[columnCount].field;
            if (this.model.columns[columnCount]["foreignKeyValue"])
                this.model.columns[columnCount]["editType"] = "dropdownedit";
            if (this._dataSource() instanceof ej.DataManager  && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                var index = $.inArray(this.model.columns[columnCount].field,this._dataSource().adaptor.value),fk_Value,fk_fieldName;
				 if(index != -1){
						fk_Value = this._dataSource().adaptor.value[index];
						fk_fieldName = this._dataSource().adaptor.key[index];	 
				 }
            }
            if (this.model.columns[columnCount]["editTemplate"])
                this.model.columns[columnCount]["editType"] = "edittemplate";
            if (ej.isNullOrUndefined(this.model.columns[columnCount]["editType"]))
                if (this.model.columns[columnCount]["type"] == "date" || this.model.columns[columnCount]["type"] == "datetime")
                    this.model.columns[columnCount]["editType"] = this.model.columns[columnCount]["type"] + "picker";
                else
                    this.model.columns[columnCount]["editType"] = "stringedit";
            if (this.model.isResponsive)
                element.attr("data-cell",this._decode(this.model.columns[columnCount]["headerText"]));
            var splits = (fName || "").split("."), sLen = splits.length - 1, braces = "";
            if (!ej.isNullOrUndefined(fName))
                fName = fName.replace(/[^a-z0-9\s_]/gi, '');
            while (sLen) {
                braces += "(";
                sLen--;
            }
            switch (this.model.columns[columnCount]["editType"]) {
                case "edittemplate":
                    var temp = this.model.columns[columnCount].editTemplate.create;
                    if (typeof temp == "string") {
                        var temp1 = ej.util.getObject(temp, window);
                        if (!$.isFunction(temp1)) {
                            if ($(temp).length == 1 && $(temp).get(0).tagName == "SCRIPT")
                                var $edittemplate = $($(temp).html()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field, "class":"e-field" });
                            else
                                var $edittemplate = $(temp).attr({ id: this._id + fName, name: this.model.columns[columnCount].field , "class":"e-field"});
                        }
                        else
                            var $edittemplate = $(temp1()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field, "class":"e-field" });
                    }
                    else
                        var $edittemplate = $(temp()).attr({ id: this._id + fName, name: this.model.columns[columnCount].field, "class":"e-field" });
                    element.append($edittemplate);
                    break;
                case "stringedit":
                    element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{html:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field, type:"text" }));
                    break;
                case "booleanedit":
                    element.html('{{if #data["' + splits.join('"]["') + '"]}} <input class="e-field e-checkbox" type ="checkbox" id=' + this._id + fName + ' name=' + this.model.columns[columnCount].field + ' checked="checkbox"></input>{{else}} <input class="e-field e-checkbox" type ="checkbox" id=' + this._id + fName + ' name=' + this.model.columns[columnCount].field + ' > {{/if}}');
                    if (this.model.editSettings.editMode == "normal")
                        element.addClass("e-boolcell");
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, { type: "text", value: "{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + this.model.columns[columnCount]["editType"] + ' e-field', "", {}, { type: "text", value: "{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}", id: this._id + fName, name: this.model.columns[columnCount].field });
                    element.append($datePicker);
                    break;
                case "dropdownedit":
                    var currColumn = this.model.columns[columnCount], selectedItems = [], $foreignkeyfield, $foreignkeyvalue;
                    if (ej.isNullOrUndefined(currColumn.dataSource)) {
                        var arrayOfDatas;
                        if (ej.isNullOrUndefined(currColumn.dataSource) && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && currColumn.field == fk_Value)) {
                            var data = this.model.dataSource.adaptor.foreignData[index];
                            $foreignkeyfield = this.model.dataSource.adaptor.key[index];
                            $foreignkeyvalue = this.model.dataSource.adaptor.value[index];
                            selectedItems = data;
                        }
                        var arrayOfDatas, field = currColumn.field;
                        if (ej.isNullOrUndefined(ej.getObject(field, this._dropDownManager)))
                            return;
                        arrayOfDatas = ej.getObject(field, this._dropDownManager);
                        var isObj = 0 in arrayOfDatas && typeof arrayOfDatas[0] == "object";
                        var uniqueData = uniqueData = ej.dataUtil.mergeSort(ej.distinct(arrayOfDatas, isObj ? field : undefined, isObj ? false : undefined));
                        if (selectedItems.length == 0) {
                            if (ej.isNullOrUndefined(currColumn.dataSource) && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && currColumn.field == fk_Value)) {
                                for (var index = 0; index < uniqueData.length; index++)
                                    selectedItems.push({ text: uniqueData[index][0], value: uniqueData[index][1] });
                            }
                            else {
                                for (var index = 0; index < uniqueData.length; index++)
                                    selectedItems.push({ text: uniqueData[index], value: uniqueData[index] });
                            }
                        }
                    }
                    else {
                        if (ej.isNullOrUndefined(currColumn.foreignKeyField) && currColumn.dataSource instanceof ej.DataManager) {
                            var field = currColumn.field, arrData = ej.getObject(field, this._dropDownManager);
                            var isObj = 0 in arrData && typeof arrData[0] == "object";
                            var uniqueData = uniqueData = ej.dataUtil.mergeSort(ej.distinct(arrData, isObj ? field : undefined, isObj ? false : undefined));
                            if (!ej.isNullOrUndefined(ej.getObject("editParams.fields.text", currColumn)))
                                selectedItems = arrData;
                            if (selectedItems.length == 0) {
                                for (var index = 0; index < uniqueData.length; index++) {
                                    selectedItems.push({ text: uniqueData[index], value: uniqueData[index] });
                                }
                            }
                        }
                        else if(ej.isNullOrUndefined(currColumn.foreignKeyField) || (!(currColumn.field in this._dropDownManager) && !(currColumn.dataSource instanceof ej.DataManager)))
                            selectedItems = currColumn.dataSource
                        else
                            selectedItems = ej.getObject(currColumn.field + "." + currColumn.foreignKeyField + "." + currColumn.foreignKeyValue, this._dropDownManager);
                    }
                    var dropDownTemplate;
                    var fieldName = ej.isNullOrUndefined(currColumn.foreignKeyField) ? currColumn.field : currColumn.foreignKeyField;
                    if (currColumn.foreignKeyValue)
                        dropDownTemplate = this._compiledDropDownTemplate(fieldName, currColumn.foreignKeyValue, currColumn.type, currColumn.format);
                    else if ((this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) && (currColumn.field == fk_Value)) {
                        dropDownTemplate = this._compiledDropDownTemplate($foreignkeyfield ? $foreignkeyfield : "value", $foreignkeyvalue ? $foreignkeyvalue : "text", currColumn.type, currColumn.format);
                    }
                    else {
                        var value = ej.getObject("editParams.fields.value", currColumn) || "value";
                        var text = ej.getObject("editParams.fields.text", currColumn) || "text";
                        dropDownTemplate = this._compiledDropDownTemplate(value, text, currColumn.type, currColumn.format);
                    }
                    if (!ej.isNullOrUndefined(currColumn.editParams) && ((this._dataSource() instanceof ej.DataManager && (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor)) && (currColumn.field == fk_Value)))
                        element.get(0).innerHTML = "<input data-value='{{:" + fk_fieldName + "}}'/>";
                    else
                        element.get(0).innerHTML = ["<select>", dropDownTemplate.render(selectedItems), "</select>"].join("");
                    element.find("select,input").prop({ id: this._id + fName, name: currColumn.field }).addClass("e-field e-dropdownlist");
                    break;
            }
        },
        addBatchEditTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $outerDiv = ej.buildTag('div', "", { display: "none" }, { id: this._id + "_BulkEditTemplate" }), i, columnCount, $innerDiv;
            for (i = 0, columnCount = this.model.columns.length; i < columnCount; i++) {
                if (ej.isNullOrUndefined(this.model.columns[i]["commands"]) && (ej.isNullOrUndefined(this.model.columns[i]["template"])) ||
                    (this.model.columns[i]["template"] && this.model.columns[i]["allowEditing"] != false && this.model.columns[i]["field"])) {				 
                    $innerDiv = ej.buildTag('div', "", {}, { id: this.model.columns[i].field.replace(/[^a-z0-9\s_]/gi, ej.pvt.consts.complexPropertyMerge) + "_BulkEdit" });
                    this._initCellEditType(i, $innerDiv);
                    $outerDiv.append($innerDiv);
                }
                if (this.model.columns[i]["isPrimaryKey"] === true) {
                    this._primaryKeys.push($.trim(this.model.columns[i].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
                if (this.model.columns[i]["isIdentity"] === true) {
                    $innerDiv.find(".e-field").addClass("e-identity");
                    this._identityKeys.push($.trim(this.model.columns[i].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
            }
            if ($outerDiv.children().length)
                this._bulkEditTemplate = $outerDiv;

        },
        addExternalDialogEditingTemplate: function () {
            if (this.model.columns.length == 0)
                return;
			  var  $valueTd;
			   $valueTd = ej.buildTag('td', "", { "text-align": "left" }).addClass("e-rowcell");
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if (this.model.columns[columnCount]["type"] == "checkbox" && !this._isMapSelection)
                    continue;
                if (ej.isNullOrUndefined(this.model.columns[columnCount]["commands"]) && (!ej.isNullOrUndefined(this.model.columns[columnCount]["template"]) && this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"]) && !ej.isNullOrUndefined(this.model.columns[columnCount].editTemplate))
                    this._initCellEditType(columnCount, $valueTd);
                if (this.model.columns[columnCount]["isPrimaryKey"] === true) {
                    this._primaryKeys.push($.trim(this.model.columns[columnCount].field));
                    this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                }
                if (this.model.columns[columnCount]["isIdentity"] === true) {
                    this._identityKeys.push($.trim(this.model.columns[columnCount].field));
                    this._identityKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._identityKeys.sort()) : $.uniqueSort(this._identityKeys.sort());
                }
            }
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            var cloneElement;
            if (this.model.editSettings.editMode == "dialogtemplate" && this.model.editSettings.dialogEditorTemplateID != null)
                cloneElement = this.model.editSettings.dialogEditorTemplateID;
            else if (this.model.editSettings.editMode == "externalformtemplate" && this.model.editSettings.externalFormTemplateID != null) {
                cloneElement = this.model.editSettings.externalFormTemplateID;
                $form.addClass("e-display");
            }
            else {
                cloneElement = this.model.editSettings.inlineFormTemplateID;
                $form.addClass("e-display");
            }

            $form.html($(cloneElement).html());
            $tbody = this.renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONdialogTemplateMode", $tbody.html());
        },
        _editdblClickHandler: function (e) {
            var $target = $(e.target);
			if ($target.closest(".e-grid").attr("id") !== this._id) return;
            if ($target.hasClass("e-rowcell") || $target.closest("td").hasClass("e-rowcell")) {
                if (!this.model.isEdit || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")) {
                    this._$currentTr = (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0)
                        ? this.getRowByIndex($target.closest('tr').index())
                        : $target.closest('tr');
                     if(!ej.isNullOrUndefined(this._previousTr)){
                        if(this._$currentTr.length > 1 && this._$currentTr[0] != this._previousTr[0] && this._$currentTr[1] != this._previousTr[1])
                            return;
                        else if(this._$currentTr[0] != this._previousTr[0])
                            return;
                    }
                    this.startEdit(this._$currentTr);
                }
            }
        },
        _columnToSelect: function () {
            var column = [], columnDrop = [], cols = this.model.columns;
            for (var i = 0; i < this.model.columns.length; i++) {
                if (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                    if ($.inArray(this.model.columns[i].field, this._dataSource().adaptor.value) != -1)
                        if (ej.isNullOrUndefined(this.model.columns[i]["editType"]))
                        this.model.columns[i]["editType"] = "dropdownedit";
                }
                if (this.model.columns[i]["editType"] === ej.Grid.EditingType.Dropdown && ej.isNullOrUndefined(this.model.columns[i]["dataSource"]))
                    column.push(this.model.columns[i].field);
                if (cols[i]["editType"] === ej.Grid.EditingType.Dropdown && ej.isNullOrUndefined(cols[i].foreignKeyField) && cols[i]["dataSource"] instanceof ej.DataManager)
                    columnDrop.push(this.model.columns[i].field);
            }
            if (column.length)
                return { query: ej.Query().select(column), fields: column, fieldsDrop: columnDrop };
            return { query: ej.Query(), fields: [], fieldsDrop: columnDrop };
        },
        _renderExternalForm: function () {
            var $externalform = ej.buildTag("div", "", { display: "none" }, { id: this._id + "_externalEdit", 'class': "e-form-container" });
            var $eformHeader = ej.buildTag("div", "", "", { id: this._id + "_eFormHeader", 'class': "e-form-titlebar" });
            var $eformTitle = ej.buildTag("span", "", "", { 'class': "e-form-title" });
            var $eformToggleBtn = ej.buildTag("div", "", "", { id: this._id + "_eFormToggleBtn", 'class': "e-form-togglebtn" });
            var $eformToggleIcon = ej.buildTag("span", "", "", { 'class': "e-form-toggle-icon e-icon" });
            $eformToggleBtn.append($eformToggleIcon);
            $eformHeader.append($eformTitle).append($eformToggleBtn);

            var $eformContent = ej.buildTag("div", "", "", { id: this._id + "_eFormContent", 'class': "e-form-content" });
            var $eform = ej.buildTag("div", "", "", { id: this._id + "_externalForm", 'class': "e-externalform" });
            var $contentOuterDiv = ej.buildTag("div", "", "", { 'class': "e-externalformedit" });
            $eform.append($contentOuterDiv);
            $eformContent.append($eform);
            return $externalform.append($eformHeader).append($eformContent);;
        },
        _buttonClick: function (e) {
            if (e.type == "close") {
                if (!this.model.isEdit)
                    return;
                this.model.isEdit = false;
                this.element.ejGrid("cancelEdit");
                this.refreshToolbar();
                return;
            }
            if ((e.keyCode !== undefined && e.keyCode != 13 && e.keyCode != 0) || this.model == null)
                return true;
            if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                if (e.target.id == "EditDialog_" + this._id + "_Save") 
                    this.element.ejGrid("endEdit");
                 else if (e.target.id == "EditDialog_" + this._id + "_Cancel") {
                    this.element.ejGrid("cancelEdit");
                    $("#" + this._id + "_dialogEdit").ejDialog("close");
                }
            }
            else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                if ($(e.target).hasClass("e-form-toggle-icon")) {
                    this.element.ejGrid("cancelEdit");
                    $("#" + this._id + "_externalEdit").css("display", "none");
                }
                else {
                    if (e.target.id == "EditExternalForm_" + this._id + "_Save") {
                        if (this.element.ejGrid("endEdit").length !== undefined)
                            $("#" + this._id + "_externalEdit").css("display", "none");
                    } else if (e.target.id == "EditExternalForm_" + this._id + "_Cancel") {
                        this.element.ejGrid("cancelEdit");
                        $("#" + this._id + "_externalEdit").css("display", "none");
                    }
                }
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                if (e.target.id == "InlineEditForm_" + this._id + "_Save")
                    this.element.ejGrid("endEdit");
                else if (e.target.id == "InlineEditForm_" + this._id + "_Cancel")
                    this.element.ejGrid("cancelEdit");
            }
            else
                this.element.ejGrid("cancelEdit");
        },
        _enableEditingEvents: function () {
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode != "batch" && this.model.editSettings.allowEditOnDblClick) 
                    this._on(this.element, ($.isFunction($.fn.doubletap) && this.model.enableTouch) ? "doubletap" : "dblclick", ".e-gridcontent", this._editdblClickHandler);
                else {
                    this._off(this.element, "dblclick", ".e-gridcontent");
                    this._off(this.element, "doubletap", ".e-gridcontent");
                }
                this._off($("#" + this._id + "_dialogEdit"), "click ", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel");
                this._off($("#" + this._id + "_externalEdit"), "click ", "#EditExternalForm_" + this._id + "_Save ,#EditExternalForm_" + this._id + "_Cancel");
                $(this.element).off("click", ".e-form-toggle-icon");
                $(this.element).off("click ", "#InlineEditForm_" + this._id + "_Save ,#InlineEditForm_" + this._id + "_Cancel");
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    this._on($("#" + this._id + "_dialogEdit"), "click ", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel", this._buttonClick);
                }
                else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                    this._on($("#" + this._id + "_externalEdit"), "click ", "#EditExternalForm_" + this._id + "_Save ,#EditExternalForm_" + this._id + "_Cancel", this._buttonClick);
                    $(this.element).on("click", ".e-form-toggle-icon", $.proxy(this._buttonClick, this));
                }
                else if (this.model.editSettings.editMode == "batch") {
                    this._on($(document), "touchstart mousedown", this._saveCellHandler);
					this._batchEnabled = true;
				}

                else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")
                    $(this.element).on("click ", "#InlineEditForm_" + this._id + "_Save ,#InlineEditForm_" + this._id + "_Cancel", $.proxy(this._buttonClick, this));
				
				if (this.model.editSettings.editMode != "batch" && this._batchEnabled) {
				    this._off($(document), "touchstart mousedown", this._saveCellHandler);
					this._batchEnabled = false;
				}

            } else {
                this._off($("#" + this._id + "_dialogEdit"), "click", "#EditDialog_" + this._id + "_Save ,#EditDialog_" + this._id + "_Cancel");
                $(this.element).off("click", ".e-icon");
                this._off($("#" + this._id + "_externalEdit"), "click", "#EditExternalForm_" + this._id + "_Save ,#EditExternalForm_" + this._id + "_Cancel");
                $(this.element).off("click", ".e-form-toggle-icon");
                $(this.element).off("click", "#InlineEditForm_" + this._id + "_Save ,#InlineEditForm_" + this._id + "_Cancel");
            }
        },
        _multiRowDelete: function () {
            var changes = {};
            changes.added = []; changes.deleted = [], changes.changed = [];
            changes.deleted = this.getSelectedRecords();
            var args = {};
			args.data = this.getSelectedRecords();
            args.tr = this.getSelectedRows();
            var foreignKeyData = this._getForeignKeyData(args.data);
            if (!ej.isNullOrUndefined(foreignKeyData))
                args.foreignKeyData = foreignKeyData;
                args.requestType = "delete";
            if (this._trigger("actionBegin", args))
                return true;
            var gridObject = this;
            this._sendBulkReuqest(changes, args);
        },
        deleteRow: function ($tr) {
            if (!this.model.editSettings.allowDeleting || (this.model.isEdit && this.model.editSettings.editMode != "batch" && !this.model.editSettings.showAddNewRow))
                return;
            if (this.model.editSettings.showDeleteConfirmDialog && !(this._confirmDialog).is(":visible")) {
                this._cDeleteData = $tr;
                this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
                return;
            }
            if ($.isArray($tr)) {
                this.selectRows($tr);
                this._multiRowDelete();
            }
            else {
                if (this.model.editSettings.editMode == "batch")
                    this._bulkDelete(this.getIndexByRow($tr));
                else {
                    if (this._primaryKeys.length == 0 && !this.model.editSettings.allowEditing && !this.model.editSettings.allowAdding) {
                        for (var i = 0; i < this.model.columns.length; i++) {
                            if (this.model.columns[i]["isPrimaryKey"] === true) {
                                this._primaryKeys.push($.trim(this.model.columns[i].field));
                                this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                            }
                        }
                    }
                    if (this._selectedRow() == -1 && ej.isNullOrUndefined($tr)) {
                        alert(this.localizedLabels.DeleteOperationAlert);
                        return;
                    }
                    if (ej.isNullOrUndefined($tr))
                        $tr = this.model.scrollSettings.enableVirtualization ? this.getContentTable().find("tr[aria-selected='true']") : this.getRowByIndex(this._selectedRow());
                    this._primaryKeyValues = [];
                    this._getPrimaryKeyValues($tr);
                    var deleteManager = ej.DataManager(this._currentJsonData);
                    var query = new ej.Query();
                    for (var i = 0; i < this._primaryKeys.length; i++)
                        query = query.where(this._primaryKeys[i], ej.FilterOperators.equal, this._primaryKeyValues[i]);
                    var currentData = deleteManager.executeLocal(query);
                    var args = {};
                    args.tr = $tr;
                    args.data = args.rowData = currentData[0];
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    args.requestType = ej.Grid.Actions.Delete;
                    if (this._trigger("actionBegin", args))
                        return true;
                    this._cDeleteData = currentData;
                    var promise;
                    if (!(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endDelete") != -1) && this._dataSource() instanceof ej.DataManager && (!this._dataManager.dataSource.offline && this._dataManager.dataSource.json !== undefined) || (this._dataSource().adaptor instanceof ej.remoteSaveAdaptor)) {
                        promise = this._dataManager.remove(this._primaryKeys[0], this._primaryKeys.length ? ej.getObject(this._primaryKeys[0], currentData[0]) : null, this.model.query);
                        var proxy = this;
                        if ($.isFunction(promise.promise)) {
                            promise.done(function (e) {
                                proxy._processBindings(args);
                                proxy._primaryKeyValues = [];
                                proxy._cDeleteData = null;
                            });
                            promise.fail(function (e) {
                                args.error = e;
                                proxy._cDeleteData = null;
                                proxy._trigger("actionFailure", args)
                            });
                        } else
                            this._processBindings(args);
                    } else
                        this._processBindings(args);
                    if (promise == undefined || !$.isFunction(promise.promise)) {
                        this._primaryKeyValues = [];
                        this._cDeleteData = null;
                    }
                }
            }
        },
        
        _htmlEncode: function (html) {
            var str = html;
            if (!ej.isNullOrUndefined(str))
                str = isNaN(str) ? str.replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&apos;/g, '\'') : str;
            return str;
        },
        startEdit: function ($tr) {
		    if (!this.model.editSettings.allowEditing || (this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal" && this._excludeDetailRows().hasClass("e-editedrow")))
		        return;
		    if (this.element.ejWaitingPopup("model.showOnInit"))
		        return;
            if (this._selectedRow() == -1 && ej.isNullOrUndefined($tr)) {
                alert(this.localizedLabels.EditOperationAlert);
                return;
            }
            if (this.model.scrollSettings.enableVirtualization && ej.isNullOrUndefined($tr))
                $tr = this.getContentTable().find("tr[aria-selected='true']");
            if (ej.isNullOrUndefined($tr)) {
                this._currentTrIndex = this._selectedRow();
                this._$currentTr = this.getRowByIndex(this._currentTrIndex);
            } else {
                this._currentTrIndex = this.getIndexByRow($tr);
                this._$currentTr = $tr;
            }
            if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization)
                this._currentTrIndex = this._currentTrIndex % this.model.pageSettings.pageSize;
            if (!$(this._$currentTr).is(":visible"))
                return false;
            this._primaryKeyValues = [];
            this._getPrimaryKeyValues(this._$currentTr);
            var editedData = this._editedData = this._currentJsonData[this._currentTrIndex];
            var args = { row: this._$currentTr, rowIndex: this._currentTrIndex, primaryKey: this._primaryKeys, primaryKeyValue: this._primaryKeyValues, rowData: editedData };
            var cancel = this._trigger("beginEdit", args);
            if (cancel) {
                this._primaryKeyValues = [];
                return;
            }
            args.requestType = ej.Grid.Actions.BeginEdit;
            this._processBindings(args);

        },
        _getPrimaryKeyValues: function ($tr) {
            var trIndex, pkVal, nameAttr = $tr.attr("name"), column, virtualIndex, lastPageVal, isLastPage = false;
            this._lastVirtualPage = null;
            for (var index = 0; index < this._primaryKeys.length; index++) {
                column = this.getColumnByField(this._primaryKeys[index]);
                trIndex = this.getIndexByRow($tr);
                pkVal = this._currentJsonData;
                if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling) {
                    if (!this.model.scrollSettings.enableVirtualization) {
                        trIndex = trIndex % this.model.pageSettings.pageSize;
                        virtualIndex = parseFloat(nameAttr) / this.model.pageSettings.pageSize + 1;
                        this._currentJsonData = this._virtualLoadedRecords[virtualIndex];
                        if (virtualIndex == this.model.pageSettings.totalPages && !this._prevPageRendered && this._virtualLoadedRecords[virtualIndex].length != this.model.pageSettings.pageSize) {
                            pkVal = $.extend(true, [], this._previousPageRecords);
                            lastPageVal = $.extend(true, [], this._virtualLoadedRecords[virtualIndex]);
                            ej.merge(pkVal, lastPageVal);
                            this._lastVirtualPage = this._currentJsonData = $.extend(true, [], pkVal);
                            isLastPage = true;
                        }

                    }
                    else {
                        trIndex = trIndex % this._virtualRowCount;
                        virtualIndex = parseInt(nameAttr, 32);
                    }
                    pkVal = isLastPage ? pkVal : this._virtualLoadedRecords[virtualIndex];
                    this._vCurrentTrIndex = trIndex;
                    this._currentVIndex = virtualIndex;
                }
                this._primaryKeyValues.push(this._htmlEncode(ej.getObject(column.field, pkVal[trIndex])));
            }
        },
         _startAdd: function() {
            if (!this.model.editSettings.allowAdding)
                return;
			this._isAddNew = true;
            if (this.model.editSettings.editMode == "batch")
                this._bulkAddRow();
            else {
                var cloneData = {}, cols = this.model.columns;
                for (var i = 0; i < cols.length; i++) {
                    if (!ej.isNullOrUndefined(this.model.parentDetails) && cols[i].field == this.model.parentDetails.parentKeyField)
                        cols[i].defaultValue = this.model.parentDetails.parentKeyFieldValue;
                    if (!ej.isNullOrUndefined(cols[i].field) && cols[i].field.indexOf(".") > 0)
                        ej.createObject(cols[i].field, cols[i].defaultValue || "", cloneData);
                    else
                        cloneData[cols[i].field] = !ej.isNullOrUndefined(cols[i].defaultValue) ? cols[i].defaultValue : (cols[i].type == "date" || cols[i].type == "datetime") ? null : "";
                }
                var args = {}, complexObject = {};
                args.data = args.rowData = cloneData;
                if (this.model.editSettings.editMode.indexOf('template') != -1) {
                    for (var i = 0; i < this.model.columns.length; i++) {
                        if (!ej.isNullOrUndefined(this.model.columns[i].field) && this.model.columns[i].field.indexOf(".") != -1) {
                            var splits = this.model.columns[i].field.split('.');
                            ej.createObject(this.model.columns[i].field, args.data[this.model.columns[i].field], complexObject);
                            args.data[splits[0]] = complexObject;
                            delete args.data[this.model.columns[i].field];
                        }
                    }
                }
                var foreignKeyData = this._getForeignKeyData(args.data);
                if (!ej.isNullOrUndefined(foreignKeyData))
                    args.foreignKeyData = foreignKeyData;
                args.requestType = "add";
                if (!this._enableCheckSelect || !this._isMapSelection)
                    this.clearSelection();
				if(this.model.selectionSettings.selectionMode.indexOf('cell') != -1)
					this.clearCellSelection();
                if (this.model.scrollSettings.allowVirtualScrolling) {
                    this._currentVIndex = null;
                    this._lastVirtualPage = null;
                    if (this.model.scrollSettings.enableVirtualization)
                        this._refreshVirtualView(1);
                    else
                        !this._virtualLoadedRecords[1] ? this.gotoPage(1) : this._currentPage(1);
                    this.getScrollObject().scrollY(0);
                }
                var returnValue = this._processBindings(args);
                if (!returnValue)
                    this.model.editSettings.showAddNewRow ? this._selectedRow(-1) : this._selectedRow(0);
                var groupedColumns = this.model.groupSettings.groupedColumns.length;
                if (groupedColumns > 1) {
                    var $editCol = this.getContentTable().find(".e-addedrow").find("table").find("colgroup").children();
                    $($editCol.slice(0, groupedColumns - 1)).css('width', this.getHeaderTable().find('colgroup').children()[0].style.width);
                }
            }
        },
        
        endEdit: function () {
            if (this.model.isEdit) {
                var formElement, $formElement, editedTr, count = 0;
                if (!this.editFormValidate())
                    return true;
                var obj = {};
                var editedRowWrap, type;
                if (this.model.editSettings.editMode == "batch")
                    this.saveCell();
                else {
					if(this._isAddNew|| this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate" ||this.model.editSettings.editMode == "dialogtemplate" )
						this._isEditChangesApplied = true
					if(this.model.editSettings.showAddNewRow)
						editedTr = this.getContentTable().find(".e-editedrow");
                    formElement = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr[0].lastChild.lastChild: document.getElementById(this._id + "EditForm");
                    $formElement = $(formElement);
                    if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")
                        editedRowWrap = $formElement.closest('tr');
                    else
                        editedRowWrap = $formElement.closest('div');
                    editedRowWrap.find('td.e-rowcell').removeClass('e-validError');
                    formElement = this.model.scrollSettings.frozenColumns > 0 ? formElement[0] : formElement;
                    for (var index = 0; index < formElement.length; index++) {
                        if (editedRowWrap.hasClass("e-addedrow") && $(formElement[index]).hasClass("e-identity"))
                            continue;
                        var columnName = formElement[index].name, $element = $(formElement[index]), column = this.getColumnByField(columnName);
                        if ($element.hasClass("e-dropdownlist e-input") && $element.attr("id").indexOf("_input") != -1 && ej.isNullOrUndefined($formElement[1]))
                            continue;
                        if (columnName != undefined) {
                            if (columnName != "" && obj[columnName] == null) {
                                column = this.getColumnByField(columnName);
                                var  value = formElement[index].value, checkType = formElement[index].type, checkState = $(formElement[index]).is(':checked'),
                                    type = column ? column.originalType : null,colFormat;
                                if ($(formElement[index]).attr("type") == "hidden" && ej.isNullOrUndefined($element.attr("value")))
                                    continue;
                                if (!ej.isNullOrUndefined(column) && (column.editType == "edittemplate")) {
									this._isEditChangesApplied = true;
                                    var isHidden = $(formElement[index]).attr("type") == "hidden";
                                    if ($(formElement[index]).is("#" + this._id + columnName) || isHidden) {
                                        var temp1 = column.editTemplate.read; $element = $(formElement[index]);
                                        $element = isHidden ? $(formElement[index]).siblings("#" + this._id + columnName).length ? $(formElement[index]).siblings("#" + this._id + columnName) : $element : $element;
                                        if (typeof temp1 == "string")
                                            temp1 = ej.util.getObject(temp1, window);
                                        value = temp1($element);
                                       }
                                    else
                                        continue;
                                }
                                else if ($(formElement[index]).hasClass("e-datepicker")) {
                                    value = $element.ejDatePicker("model.value");
                                    if (!this._isEditChangesApplied) {
                                        colFormat = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) ? column.format : "{0:MM/dd/yyyy}";
                                        if (this.formatting(colFormat, value, this.model.locale) != this.formatting(colFormat, this._editedData[columnName], this.model.locale))
                                            this._isEditChangesApplied = true;
                                    }
                                }
                                else if ($(formElement[index]).hasClass("e-datetimepicker")) {
                                    value = $element.ejDateTimePicker("model.value");
                                    if (!this._isEditChangesApplied) {
                                        colFormat = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) ? column.format : "{0:MM/dd/yyyy hh:mm:ss}";
                                        if (this.formatting(colFormat, value, this.model.locale) != this.formatting(colFormat, this._editedData[columnName], this.model.locale))
                                            this._isEditChangesApplied = true;
                                    }
                                }
                                else if ($element.is(".e-numerictextbox")) {
                                    value = $element.ejNumericTextbox("getValue");
                                    if (!ej.isNullOrUndefined(column) && column.type == "string" && !ej.isNullOrUndefined(value))
                                        value = value.toString();
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
								}
                                else if ($element.data("ejDropDownList") || $element.is(".e-dropdownlist")) {
                                    if ($element.is(":hidden") && $element.is("input") && ej.isNullOrUndefined($element.data("ejDropDownList")))
                                        $element = $element.siblings(".e-dropdownlist");
                                    value = $element.ejDropDownList("getSelectedValue");
                                    if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.format) && (column.type == "date" || column.type == "datetime"))
                                        value = value.length > 0 ? new Date(value) : value;
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
                                
								}
                                if (type)
                                    value = type == "number" ? +value : type == "boolean" ? (value === this.localizedLabels.True ? true : false) : type === "date" ? new Date(value) : value;
                                if (column == null)
                                    value = !isNaN(parseFloat(value)) && isFinite(value) ? parseFloat(value) : value;
                                else if (column.type == "number" && !ej.isNullOrUndefined(value) && value.length) {
                                    value = ej.parseFloat(value, this.model.locale);
                                    if (!this._isEditChangesApplied && this._editedData[columnName] != value)
                                        this._isEditChangesApplied = true;
                                }
                                if (typeof value == "string" && !value.length)
                                    value = null;
                                if (!this._isEditChangesApplied && (!ej.isNullOrUndefined(column)&& column.type=="string")  && this._editedData[columnName] != value)
                                    this._isEditChangesApplied = true;
                                 if(!this._isEditChangesApplied && (!ej.isNullOrUndefined(column)&& column.type=="date" && column.editType == 'stringedit')){	
                                     if (column.format != null && this.formatting(column.format, this._editedData[columnName], this.model.locale) != value)
											this._isEditChangesApplied = true;
								}
								if ((checkType != "checkbox" && !ej.isNullOrUndefined(value) && value !== "") || checkState)
                                    count++;
                                var originalvalue;
                                if (checkType != "checkbox" || (!ej.isNullOrUndefined(column) && column.type != "boolean" && column.type != "checkbox"))
                                    originalvalue = value;
                                else
                                    originalvalue = checkState;
                                if (!this._isEditChangesApplied && (!ej.isNullOrUndefined(column) && (column.type == "boolean" || column.type == "checkbox"))) {
									  var colValue =  checkType == "checkbox" ?checkState :  JSON.parse(value);
									  if( this._editedData[columnName] != colValue)
										this._isEditChangesApplied = true;
                                }
                                if (!this._isEditChangesApplied && typeof originalvalue == "string" && typeof this._editedData[columnName] == "string" && this._editedData[columnName] != originalvalue)
                                    this._isEditChangesApplied = true;
                                if (!this._isEditChangesApplied && (!ej.isNullOrUndefined(column) && column.type == "object")) {
                                    var editVal = typeof (value) == "object" ? JSON.stringify(value) : value;
                                    var OrgDbVal = typeof (this._editedData[columnName]) == "object" ? JSON.stringify(this._editedData[columnName]) : this._editedData[columnName];
                                    if(editVal != OrgDbVal )
                                        this._isEditChangesApplied = true;
                                }
                                if (columnName.indexOf(".") != -1)
                                ej.createObject(columnName, originalvalue, obj);
                            else
                                obj[columnName] = originalvalue;
                            }
                        }
                        if (index == formElement.length - 1 && $formElement.length > 1 && $formElement.index(formElement) == 0) {
                            formElement = $formElement[1];
                            index = -1;
                        }

                    }
                    var args = { data: obj, rowData: obj };
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    args.requestType = ej.Grid.Actions.Save;
                    args.selectedRow = this._selectedRow();
                    args.previousData = jQuery.extend({}, this.model.currentViewData[args.selectedRow]);
                    var currentData;
                    if (this._trigger("actionBegin", args))
                        return true;
                    if (editedRowWrap.hasClass("e-editedrow")) {
                        this._cModifiedData = obj;
                        args.action = "edit";
                    } else if (editedRowWrap.hasClass("e-addedrow")) {
                        if (count)
                            this._cAddedRecord = obj;
                        args.action = "add";
                    }
                    if (args.action == "add" && this.editFormValidate()) {
                        if (!ej.isNullOrUndefined(this.model.queryString)) {
                            var keyField = this.model.foreignKeyField || this.model.queryString;
                            args.data[keyField] = this.model.parentDetails.parentRowData[this.model.queryString]
                        }
                        if (!count) {
                            var elements = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
                            var error = ej.buildTag("div");
                            elements.addClass("field-validation-empty");
                            var element = elements.find("input:visible").not(".e-identity").first();
                            this._renderValidator(error, element);
                            error.width("auto");
                            var $errorMessage = ej.buildTag("div.e-field-validation-error", this.localizedLabels.EmptyRowValidationMessage),
                            $tail = $(error).find(".e-errortail");
                            $errorMessage.insertAfter($tail);
                            $errorMessage.css("display", "block");
                            return false;
                        }
                    }
                    if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                        $("#" + this._id + "_externalEdit").css("display", "none");
                    if (!this._isAddNew && !this._isEditChangesApplied)
                        this.cancelEdit();
                    else {
                        this._isEditChangesApplied = false;
                        this._updateAction(args);
                    }
                }
            }
        },
        _updateAction: function (args) {
            var promise;
            if (this._dataSource() instanceof ej.DataManager && (!this._dataManager.dataSource.offline && this._dataManager.dataSource.json !== undefined) || (this._dataSource().adaptor instanceof ej.remoteSaveAdaptor) || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) {
                if (this.model.editSettings.editMode == 'batch') {
                    this.batchChanges.added.push(args.data);
                    this.batchSave();
                }
                else {
                    if (!ej.isNullOrUndefined(this._cModifiedData) && !(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endEdit") != -1))
                        promise = this._dataManager.update(this._primaryKeys[0], args.data, this.model.query);
                    else if (!(ej.isOnWebForms && this.model.serverEvents && this.model.serverEvents.indexOf("endAdd") != -1))
                        promise = this._dataManager.insert(args.data, this.model.query);
                    var proxy = this;
                    this.element.ejWaitingPopup("show");
                    if (promise && $.isFunction(promise.promise)) {
                        promise.done(function (e) {
                            proxy.model.isEdit = false;
                            if (!ej.isNullOrUndefined(e) && $.isPlainObject(e.record)) {
                                $.extend(args.data, e.record);
                                if (args.action == "add")
                                    proxy._cAddedRecord = args.data;
                                if (args.action == "edit")
                                    proxy._cModifiedData = args.data;
                            }
                            proxy._processBindings(args);
                            if (proxy._isRemoteSaveAdaptor) {
                                proxy.element.ejWaitingPopup("hide");
                                if (!ej.isNullOrUndefined(proxy._unboundRow) && args.selectedRow != proxy._unboundRow && args.requestType == "save") {
                                    proxy._unboundRow.find(".e-editbutton").trigger("click");
                                    proxy._unboundRow = null;
                                }
                            }
                            proxy._cModifiedData = null;
                            proxy._cAddedRecord = null;
                            proxy._primaryKeyValues = [];
                        });
                        promise.fail(function (e) {
                            args.error = (e && e.error) ? e.error : e;
                            proxy._cModifiedData = null;
                            proxy._cAddedRecord = null;
                            proxy.element.ejWaitingPopup("hide");
                            proxy._trigger("actionFailure", args)
                        });
                    } else {
                        proxy.model.isEdit = false;
                        proxy._processBindings(args);
                    }
                }
            } else
                this._processBindings(args);
            if (promise == undefined || !$.isFunction(promise.promise)) {
                this._cModifiedData = null;
                this._cAddedRecord = null;
                this._primaryKeyValues = [];
            }
        },
        
        cancelEdit: function () {
            var args = {};
            args.requestType = ej.Grid.Actions.Cancel;
            this._cModifiedData = null;
            this._processBindings(args);
            this._primaryKeyValues = [];
            this._currentData = null;
            if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                $("#" + this._id + "_externalEdit").css("display", "none");
        },
        
        refreshToolbar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            var lis = $toolbar.find("li");
            $toolbar.ejToolbar("enableItem", lis);
			var editedTr = this.getContentTable().find(".e-editedrow");
			if(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal" && editedTr.length==0)
				this._disabledToolItems.push(lis.filter('[id='+this._id+'_add]'));
			else
			{
			    for (var i = 0; i < lis.length; i++) {
			        switch (lis[i].id) {
			            case this._id + "_add":
			            case this._id + "_edit":
			            case this._id + "_delete":
			            case this._id + "_responsiveFilter":
			            case this._id + "_responsiveSorting":
			            case this._id + "_search":
			                if (this.model.isEdit) {
			                    if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal") || editedTr.length != 0) {
			                        $(lis[i]).hasClass("e-hover") && $(lis[i]).removeClass("e-hover");
			                        this._disabledToolItems.push(lis[i]);
			                    }
			                }
			                else if (!this.model.enableToolbarItems && !this.model.editSettings.allowAdding && lis[i].id == this._id + "_add")
			                        this._disabledToolItems.push(lis[i]);
                            else if (!this.model.enableToolbarItems && !this.model.editSettings.allowEditing && lis[i].id == this._id + "_edit")
                                    this._disabledToolItems.push(lis[i]);
                            else if (!this.model.enableToolbarItems && !this.model.editSettings.allowDeleting && lis[i].id == this._id + "_delete")
                                    this._disabledToolItems.push(lis[i]);
			                break;
			            case this._id + "_update":
			            case this._id + "_cancel":
			                if (!this.model.isEdit && (this.getContentTable().find(".e-updatedtd.e-icon.e-gupdatenotify").length == 0 && !this._isBatchDeleteApplied)) {
			                    $(lis[i]).hasClass("e-hover") && $(lis[i]).removeClass("e-hover");
			                    this._disabledToolItems.push(lis[i]);
			                }
			                break;
			        }
			    }
			}
            $toolbar.ejToolbar("disableItem", this._disabledToolItems);
            $toolbar.ejToolbar("model.enableRTL", this.model.enableRTL);
            this._disabledToolItems = $();

        },
        _getHiddenCount: function (elements) {
            var count = 0;
            for (var i = 0; i < elements.length; i++) {
                if (elements.eq(i).hasClass("e-hide"))
                    count++;
            }
            return count;
        },
        _refreshTemplateCell: function (temp, data) {
            var tempcell = temp.find('.e-templatecell');
			for(var i =0; i< tempcell.length;i++){						
				var args = { cell: tempcell[i], data: data, column: this.model.columns[$(tempcell[i]).index()], rowIndex: temp.index()};
				this._trigger("templateRefresh", args);	
			}			
        },
        _edit: function (args) {
            var editingManager = this.model.scrollSettings.enableVirtualization ? ej.DataManager(this._virtualLoadedRecords[this._currentVIndex]) : ej.DataManager(this._currentJsonData), $tempFirstTR;
            var queryManager = new ej.Query(), templateID, ngType;
            if (this.model.allowFiltering)
                this._previousFilterCount = this._filteredRecordsCount;
            for (var index = 0; index < this._primaryKeys.length; index++)
                queryManager = queryManager.where(this._primaryKeys[index], ej.FilterOperators.equal, this._primaryKeyValues[index]);
            this._currentData = editingManager.executeLocal(queryManager);
            var temp = document.createElement('div');
            var formTitle = !ej.isNullOrUndefined(this.model.editSettings.titleColumn) ? this.model.editSettings.titleColumn : this._primaryKeys[0];
            var $temp = $(temp), $tempSecondTR, $tempFirstTR;
            if (this.model.editSettings.editMode == "normal") {
                temp.innerHTML = ['<table>', $.render[this._id + "_JSONEditingTemplate"](this._currentData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
                var $tr = $temp.find("tr").first(), detailCount = 0, firstHidden = this.model.columns.length
                , $currentTrFr = args.row.first(), $currentTrLa, $tempLastTR;
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $temp.prepend(['<table>', $.render[this._id + "_JSONFrozenEditingTemplate"](this._currentData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join(""));
                    $tr.splice(0, 0, $temp.find("table").first().find("tr").first().get(0));
                    $currentTrLa = args.row.last();
                    $tempLastTR = $tr.last();
                }
                $tempFirstTR = $temp.find("tr").first();
                $temp.find('td').not(".e-rowcell").addClass("e-editcell e-normaledit");
                this._setEditDropdownValue($temp);
                if (this.model.groupSettings.groupedColumns.length >= 2) {
                    var $indentCell = args.row.find("td.e-indentcell");
                    $temp.find("tr").first().prepend($indentCell);
                }
                if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                    detailCount++;                    
                    $temp.find(".e-editcell").find("tr").prepend(args.row.find("[class*=e-detailrow]").eq(0).removeClass("e-selectionbackground e-active"));
                    if (this.model.gridLines != "both")
                        $temp.find(".e-editcell .e-rowcell:first").addClass("e-detailrowvisible");
                }
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $temp.find(".e-editcell").get(1).colSpan = this.model.columns.length - this.model.scrollSettings.frozenColumns - args.row.last().find(".e-hide").length + detailCount;
                    firstHidden = this.model.scrollSettings.frozenColumns;
                    $currentTrLa.hasClass("e-alt_row") && $tempLastTR.addClass("e-alt_row")
                }
                $temp.find(".e-editcell").get(0).colSpan = firstHidden - $currentTrFr.find("td").not(":visible").length + detailCount;
                $currentTrFr.hasClass("e-alt_row") && $tempFirstTR.addClass("e-alt_row");                
                $currentTrFr.empty().replaceWith($tempFirstTR.addClass("e-editedrow"));
                args.row = $tempFirstTR;
                if (!$tempFirstTR.is(":last-child"))
                    $tempFirstTR.find('td.e-rowcell').addClass('e-validError');
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $currentTrLa.empty().replaceWith($tempLastTR.addClass("e-editedrow"));
                    args.row = $tempLastTR;
                }
                this._refreshUnboundTemplate($tr.find(".gridform"));
                if(this.model.scrollSettings.frozenColumns == 0)
					this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row, tr.e-editedrow").toArray();
				else
					this._gridRows = $(this.getContentTable().get(0).rows).toArray();                 
                if (this.model.scrollSettings.frozenColumns > 0) {
					this.getScrollObject().scrollY(this.getScrollObject().model.scrollTop, true);
                    this._gridRows = [this._gridRows, $(this.getContentTable().get(1).rows).toArray()];
				}
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                var detailCount = 0;
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    templateID = this.model.editSettings.inlineFormTemplateID;
                    ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (templateID.startsWith("#") || templateID.startsWith(".") || typeof templateID === "object") ? this.model.ngTemplateId + "gridedittemplate" : null;
                } 
                temp.innerHTML = this.model.editSettings.editMode == "inlineform" ? $.render[this._id + "_JSONDialogEditingTemplate"](this._currentData) : this._renderEjTemplate(this.model.editSettings.inlineFormTemplateID, this._currentData[0], args.rowIndex, null, ngType);
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
				this._setEditDropdownValue($temp);
                var tr = ej.buildTag('tr');
                var td = ej.buildTag('td');
                tr.addClass("e-editedrow");
                td.addClass("e-inlineformedit");
                temp = $(temp).clone(true).children();
                td.html(temp);
                tr.append(td);
                if (!tr.is(":last-child"))
                    tr.find('.e-rowcell').addClass('e-validError');
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = tr.clone();
                    $trClone.find("td").empty().prop("colspan", this.model.scrollSettings.frozenColumns);
                    args.row.eq(1).after(tr).end().eq(0).after($trClone);
                    this._gridRows = [this._gridRows, this.getContentTable().last().find("tr").toArray()];
                }
                else
                    args.row.after(tr);
                this._gridRows = this.getContentTable().first().find(".e-rowcell,.e-inlineformedit").closest("tr").toArray();
				if (this.model.detailsTemplate != null || this.model.childGrid != null)
                        detailCount++;
                if (this.model.scrollSettings.frozenColumns > 0)
                    td.prop("colspan", this.model.columns.length - this.model.scrollSettings.frozenColumns - tr.find("form").children().not(":visible").length + detailCount);
                else
                    td.prop("colspan", this.model.columns.length - this._hiddenColumns.length + detailCount);
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find("tr").toArray()];
                $("#" + this._id + "_inlineFormTitle").text(this.localizedLabels.EditFormTitle + this._currentData[0][formTitle]);
                args.row.find("input").attr('disabled', 'disabled').addClass("e-disable");
            }
            else {
                $temp.addClass("e-editedrow");
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    templateID = this.model.editSettings.editMode == "dialogtemplate" ? this.model.editSettings.dialogEditorTemplateID : this.model.editSettings.externalFormTemplateID;
                    ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (templateID.startsWith("#") || templateID.startsWith(".") || typeof templateID === "object") ? this.model.ngTemplateId + "gridedittemplate" : null;
                }
                temp.innerHTML = this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "externalform" ? $.render[this._id + "_JSONDialogEditingTemplate"](this._currentData) : this._renderEjTemplate(templateID, this._currentData[0], args.rowIndex, null, ngType);
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                this._setEditDropdownValue($temp);
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    $("#" + this._id + "_dialogEdit").html($(temp));
                    var model = {};
                    model.cssClass = this.model.cssClass;
                    model.enableRTL = this.model.enableRTL;
                    model.width = "auto";
                    model.enableResize = this.phoneMode;
                    model.close = $.proxy(this._buttonClick, this);
                    model.content = "#" + this._id;
                    model.enableModal = true;
                    model.allowKeyboardNavigation = false;
                    model.title = this.localizedLabels.EditFormTitle + this._currentData[0][formTitle];
                    $("#" + this._id + "_dialogEdit").ejDialog(model);
                    $("#" + this._id + "_dialogEdit").ejDialog("open");
                }
                else {
                    $("#" + this._id + "_externalEdit").css("display", "block").css('z-index', this._maxZindex() + 1);
                    $("#" + this._id + "_externalForm").find(".e-externalformedit").html($(temp));
                    $("#" + this._id + "_eFormHeader").find(".e-form-title").text(this.localizedLabels.EditFormTitle + this._currentData[0][formTitle]);
                    this._externalFormPosition();
                    args.row.find("input").attr('disabled', 'disabled').addClass("e-disable");
                }
            }
            if (this.model.editSettings.editMode != "normal")
                $tempFirstTR = $(temp);
			if(!ej.isNullOrUndefined(this.model.templateRefresh) && $tempFirstTR.find(".e-templatecell").length != 0) 
				this._refreshTemplateCell($tempFirstTR, this.model.currentViewData[$tempFirstTR.index()]);
        },
        _appendForm: function (temp) {
            var $form = ej.buildTag('form.gridform', "", {}, { id: this._id + "EditForm" });
            $form.addClass("e-display");
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            $form.html(temp);
            $tbody = this.renderDiaglogButton($form, $tbody);
            return $tbody.html();
        },
        _setEditDropdownValue: function ($temp) {
            var $select = $temp.find("select.e-field"), x, inputDrop = $temp.find("input.e-field.e-dropdownlist");
            for (var i = 0; i < $select.length; i++) {
                var ddlTemplate = {}, opPara = "";
                if ($select[i].name.indexOf('.') != -1) {
                    for (var j = 1; j < $select[i].name.split(".").length; j++)
                        opPara = opPara.concat("(");
                    ddlTemplate[this._id + "ddlTemp"] = "{{:" + opPara + "#data['" + $select[i].name.split('.').join("'] || {})['") + "']}}";
                }
                else
                    ddlTemplate[this._id + "ddlTemp"] = "{{:" + $select[i].name.replace(/[^a-z0-9\s_]/gi, '') + "}}"
                $.templates(ddlTemplate);
                x = $.render[this._id + "ddlTemp"](this._currentData);
                var $selOptions = $temp.find('select:eq(' + i + ') option[value="' + x + '"]');
                $select.eq(i).data("ej-value", x);
                var curColumn = this.getColumnByField($select[i].name);
                if (this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && this._dataSource().adaptor.value.indexOf(curColumn.field) != -1){
				    $selOptions = $temp.find('select:eq(' + i + ') option:contains("' + x + '")');
				    $select.eq(i).val($selOptions[0].value);
				    $select.eq(i).data("ej-value", $selOptions[0].value);
				}
                $selOptions.attr("selected", "selected");
            }
            for (var j = 0; j < inputDrop.length; j++) {
                inputDrop.eq(j).data("ej-value", ej.getObject(inputDrop.eq(j).attr("name"), this._currentData[0]));
            }
        },
        _add: function (args) {
            var temp = document.createElement('div'), $editTr, templateID, ngType;
            if (this._isLocalData && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0)
                !(this._dataSource() instanceof ej.DataManager) ? this._dataSource().splice(0, 1) : this._dataSource().dataSource.json.splice(0, 1);
            this._previousFilterCount = this._filteredRecordsCount;
            if (this.model.editSettings.editMode == "normal") {
                var $tempFirstTR, $temp = $(temp), frozenColSpan = this.model.columns.length, $tempLastTR;
                temp.innerHTML = ['<table>', $.render[this._id + "_JSONEditingTemplate"](args.data, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
                var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++) {
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                }
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $tempLastTR = $temp.find("table").first().find("tr").first();
                    $temp.prepend(['<table>', $.render[this._id + "_JSONFrozenEditingTemplate"](args.data, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join(""));
					$($tempLastTR).find("td").first().addClass("e-editcell");
                }
                $tempFirstTR = $temp.find("tr").first();
                var td = $(temp).find(".e-editcell").get(0);
                $(temp).find('td').first().addClass("e-editcell");
                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this._currentJsonData.length && this.model.groupSettings.groupedColumns.length == 0 && !this.model.editSettings.showAddNewRow)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $(this.getContentTable().get(0).lastChild.lastChild).children('.e-detailrowexpand').length)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                if ((this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0) && this.model.scrollSettings.frozenColumns == 0) {
                    this.getContentTable().find('tr').first().replaceWith($(temp).find("tr").first().addClass("e-addedrow e-normaledit"));
					if(this.getContentTable().find('tr').length == 0) 
						this.getContentTable().append($(temp).find("tr").first().addClass("e-addedrow e-normaledit"));
				}
                else {
                    if (this.model.scrollSettings.frozenColumns > 0)
                        this._renderByFrozenDesign();
					var  $contentTbody = this.getContentTable().first().find('tbody').first();
                    if (this.model.editSettings.rowPosition == "top")
                        $contentTbody.prepend($tempFirstTR.addClass("e-addedrow e-normaledit"));
                    else if (this.model.editSettings.rowPosition == "bottom")
                        $contentTbody.append($tempFirstTR.addClass("e-addedrow e-normaledit"));
                    if (this.model.scrollSettings.frozenColumns > 0)
                        this.getContentTable().last().find('tbody').first().prepend($tempLastTR.addClass("e-addedrow e-normaledit"));
                }
                $editTr = this.getContentTable().find("tr.e-addedrow");
                if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling)
                    $editTr.attr("name", 0);
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $editTr.find('tr').first().prepend(ej.buildTag('td.e-detailrowcollapse'));
                if (this.model.groupSettings.groupedColumns.length) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                        if (i == 0)
                            $editTr.prepend(ej.buildTag("td.e-indentcell"));
                        else {
                            $editTr.find("tr").prepend(ej.buildTag("td.e-indentcell"));
                        }
                    }
                    if (this.model.groupSettings.groupedColumns.length > 0 && (this.model.detailsTemplate != null || this.model.childGrid != null))
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length + (this.model.groupSettings.groupedColumns.length) - this._hiddenColumns.length));
                    else if (this.model.groupSettings.groupedColumns.length >= 2)
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length + (this.model.groupSettings.groupedColumns.length - 1) - this._hiddenColumns.length));
                    else
                        $editTr.find("td.e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length));
                } else if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $editTr.find(".e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length + 1));
                else {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $editTr.find(".e-editcell").last().prop("colspan", (this.model.columns.length - this.model.scrollSettings.frozenColumns - this._hiddenColumns.length));
                        frozenColSpan = this.model.scrollSettings.frozenColumns;
                    }
                    $editTr.find(".e-editcell").first().prop("colspan", (frozenColSpan - this._hiddenColumns.length));

                }
                if (!$editTr.is(":last-child"))
                    $editTr.find('td.e-rowcell').addClass('e-validError');
                if (!ej.isIOSWebView() && this.getBrowserDetails().browser == "msie" && this.model.editSettings.rowPosition == "bottom")
					this._colgroupRefresh();
                this._refreshUnboundTemplate($editTr.find(".gridform"));
                this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray()];
            }
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    templateID = this.model.editSettings.inlineFormTemplateID;
                    ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (templateID.startsWith("#") || templateID.startsWith(".") || typeof templateID === "object") ? this.model.ngTemplateId + "gridedittemplate" : null;
                }
                temp.innerHTML = this.model.editSettings.editMode == "inlineform" ? $.render[this._id + "_JSONDialogEditingTemplate"](args.data) : this._renderEjTemplate(this.model.editSettings.inlineFormTemplateID, args.data, 0, null, ngType);
                if (this.model.editSettings.editMode == "inlineformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                var detailCount = 0;
                var tr = ej.buildTag('tr');
                var td = ej.buildTag('td');
                tr.addClass("e-addedrow");
                td.addClass("e-inlineformedit e-editcell");
                temp = $(temp).clone(true).children();
				var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++){
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                    }
                td.html(temp);
                tr.append(td);
                if (!tr.is(":last-child"))
                    tr.find('.e-rowcell').addClass('e-validError');
                if (this.model.groupSettings.groupedColumns.length) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                        tr.prepend(ej.buildTag("td.e-indentcell"));
                    }
                } else
                    tr.find("td.e-editcell").prop("colspan", (this.model.columns.length - this._hiddenColumns.length));
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var $trClone = tr.clone(), $divs = td.find(".gridform").children();
                    $trClone.find("td").empty().prop("colSpan", this.model.scrollSettings.frozenColumns - this._getHiddenCount($divs.slice(0, this.model.scrollSettings.frozenColumns)));
                    td.prop("colSpan", this.model.columns.length - this.model.scrollSettings.frozenColumns - this._getHiddenCount($divs.slice(this.model.scrollSettings.frozenColumns)));
                    if (this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0)
                        this._renderByFrozenDesign();
                    this.getContentTable().first().find('tbody').first().prepend($trClone);
                    this.getContentTable().last().find('tbody').first().prepend(tr);
                }
                else {
					if (this.model.detailsTemplate != null || this.model.childGrid != null)
                        detailCount++;
                    td.prop("colspan", this.model.columns.length - this._hiddenColumns.length + detailCount);
                    if (this.model.currentViewData.length == 0 || this.getContentTable().find('td.e-rowcell').length == 0)
                        this.getContentTable().find('tr').first().replaceWith($(tr));
                    else
                        if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && this.model.groupSettings.groupedColumns.length == 0)
                            this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                    if (this.model.editSettings.rowPosition == "top")
                        this.getContentTable().first().find('tbody').first().prepend(tr);
                    else if (this.model.editSettings.rowPosition == "bottom")
                        this.getContentTable().first().find('tbody').first().append(tr);
                }
                
                if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $(this.getContentTable().get(0).lastChild.lastChild).children('.e-detailrowexpand').length)
                    this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                $("#" + this._id + "_inlineFormTitle").text(this.localizedLabels.AddFormTitle);
                this._refreshUnboundTemplate($("#" + this._id + "EditForm"));
                this._gridRows = this.getContentTable().first().find(".e-rowcell,.e-inlineformedit").closest("tr.e-row, tr.e-alt_row").toArray();
                if (this.model.scrollSettings.frozenColumns > 0)
                    this._gridRows = [this._gridRows, this.getContentTable().last().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray()];
            }
            else {
                $(temp).addClass("e-addedrow");
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    templateID = this.model.editSettings.editMode == "dialogtemplate" ? this.model.editSettings.dialogEditorTemplateID : this.model.editSettings.externalFormTemplateID;
                    ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (templateID.startsWith("#") || templateID.startsWith(".") || typeof templateID === "object") ? this.model.ngTemplateId + "gridedittemplate" : null;
                }   
                temp.innerHTML = this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "externalform" ? $.render[this._id + "_JSONDialogEditingTemplate"](args.data) : this._renderEjTemplate(templateID, args.data, 0, null, ngType);
                if (this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate") {
                    temp.innerHTML = this._appendForm(temp.innerHTML);
                }
                var $select = $(temp).find('select.e-field');
                for (var i = 0; i < $select.length; i++){
                    $select.eq(i).val(args.data[$select[i].name]);
                    $select.eq(i).data('ej-value', args.data[$select[i].name]);
                    }
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate") {
                    $("#" + this._id + "_dialogEdit").html($(temp));
                    var model = {};
                    model.cssClass = this.model.cssClass;
                    model.width = "auto";
                    model.enableResize = this.phoneMode;
                    model.content = "#" + this._id;
                    model.enableModal = true;
                    model.close = $.proxy(this._buttonClick, this);
                    model.enableRTL = this.model.enableRTL;
                    model.allowKeyboardNavigation = false;
                    model.title = this.localizedLabels.AddFormTitle;
                    $("#" + this._id + "_dialogEdit").ejDialog(model);
                    $("#" + this._id + "_dialogEdit").ejDialog("open");
                }
                else {
                    $("#" + this._id + "_externalEdit").css("display", "block").css('z-index', this._maxZindex() + 1);
                    $("#" + this._id + "_externalForm").find(".e-externalformedit").html($(temp));
                    $("#" + this._id + "_eFormHeader").find(".e-form-title").text(this.localizedLabels.AddFormTitle);
                    this._externalFormPosition();
                }
            }
            if (this.model.editSettings.editMode != "normal")
                $editTr = $(temp);
			if(!ej.isNullOrUndefined(this.model.templateRefresh) && $editTr.find(".e-templatecell").length != 0) 
				this._refreshTemplateCell($editTr, args.data);
            if (this.model.allowPaging) {
                if (this.model.filterSettings.filteredColumns.length)
                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
                else
                    this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
                this._refreshGridPager();
            }
        },
        editFormValidate: function () {
            if ($.isFunction($.validator)) {
                if (this.model.scrollSettings.frozenColumns > 0) {
                    var forms = this.element.find(".gridform");
                    if (forms.length > 1) {
                        var form1, form2;
                        form1 = forms.eq(0).validate().form();
                        form2 = forms.eq(1).validate().form();
                        if (!(form1 && form2))
                            return false;
                        else
                            return true;
                    }
                    else
                        return forms.validate().form();
                }
                else if (this.model.editSettings.showAddNewRow) {
                   return $(this.getRows()).hasClass("e-editedrow") ? this.element.find(".e-editedrow .gridform").validate().form() : this.element.find(".e-addedrow .gridform").validate().form();
                }
                return $("#" + this._id + "EditForm").validate().form();
            }
            return true;
        },
        _refreshAltRow: function () {
            var $gridRows = this._excludeDetailRows();
            for (var r = 0; r < $gridRows.length; r++) {
                var $row = $($gridRows[r]);
                $row.hasClass("e-alt_row") && $row.removeClass("e-alt_row");
                (r % 2 != 0) ? $row.addClass("e-alt_row") : $row.addClass("e-row")
            }
        },
        _editCompleteAction: function (args) {
            var $form = this.element.find(".gridform");
            this.model.isEdit = true;
            var $cols1 = this.getContentTable().children("colgroup").find("col");
            var width = this.element.width()
            this.setWidthToColumns();
            if (ej.Grid.Actions.Add == args.requestType) {
                var disabledElements = $form.find(".e-field:disabled");
                for (var j = 0; j < disabledElements.length; j++) {
                    var fieldName = $(disabledElements[j]).attr("name");
                    if (!$(disabledElements[j]).hasClass("e-identity"))
                        if ($.inArray(fieldName, this._disabledEditableColumns) == -1 || $.inArray(fieldName, this._primaryKeys) !== -1)
                            $(disabledElements[j]).prop("disabled",false).removeClass("e-disable");
                }
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length - 1; i++)
                    $form.find("colgroup").prepend(this._getIndentCol());
            }
            if (this._tdsOffsetWidth.length == 0 || this.model.groupSettings.groupedColumns.length || $.inArray(0, this._tdsOffsetWidth) != -1 || this._hiddenColumns.length > 0)
                this._setoffsetWidth();
            this._refreshEditForm(args);
            if (this.model.scrollSettings.frozenColumns > 0 && (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate")) {
                if (args.requestType == "beginedit")
                    args.row.eq(0).next().find("td").height(args.row.eq(1).next().find("td").height());
                else
                    this.getContentTable().first().find("tr").first().find("td").height(this.getContentTable().last().find("tr").first().find("td").height());
            }
            if (this.model.scrollSettings.frozenRows > 0 && args.requestType == "beginedit"){
				this._initFrozenRows();
				if (ej.getObject("_vScrollbar._scrollData", this.getScrollObject()))
					this.getScrollObject()._vScrollbar._scrollData.skipChange = true;
			}
            if (this.model.scrollSettings.frozenColumns > 0) {
                this.rowHeightRefresh();
                this._refreshScroller(args);
            }
            if (this.model.allowScrolling && this.model.scrollSettings.frozenColumns <= 0 && this.getScrollObject()
                && this.getScrollObject().isHScroll())
                this.getScrollObject().refresh();
            if ($.isFunction($.validator))
                this.initValidator();
        },
        _refreshEditForm: function (args) {
			var editedTr; 
			if(this.model.editSettings.showAddNewRow)
				editedTr = this.getContentTable().find(".e-editedrow");
            var form = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr[0].lastChild.lastChild : document.getElementById(this._id + "EditForm");
            var elementFocused = false, columnIndex, matchMedia;
            if (this.model.enableResponsiveRow && $.isFunction(window.matchMedia))
                matchMedia = window.matchMedia("(max-width: 320px)");
            var $formElement = $(form).find("input,select,div.e-field,textarea"), percent = 86;
            if ((this._isUnboundColumn || this.getContentTable().find(".e-templatecell") != null) && this.model.editSettings.editMode != "batch")
                $formElement = $formElement.filter(function () { return (!$(this).closest(".e-rowcell").hasClass("e-unboundcell") && !$(this).closest(".e-rowcell").hasClass("e-templatecell")) })
            var focusEle = null;
            for (var i = 0; i < $formElement.length; i++) {
                var $element = $formElement.eq(i);
                var inputWidth, column = this.getColumnByField(!ej.isNullOrUndefined($element.prop("name")) ? $element.prop("name") : $element.attr("name"));
                if (column != null)
                    columnIndex = $.inArray(column, this.model.columns);
                if (this.model.editSettings.editMode == "batch") {
                    percent = 95;
                }
                else if (this.model.editSettings.editMode == "normal")
                    percent = 96;
                if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                    $element.parent().css("width", ej.dataUtil.max(this._tdsOffsetWidth) + "px");
                    inputWidth = ej.max(this._tdsOffsetWidth) * (percent / 100);
                }
                else
                    inputWidth = this._tdsOffsetWidth[i] * (percent / 100);
                if ((this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "batch" || this.model.allowResizing || this.model.allowResizeToFit) && !$element.hasClass("e-checkbox"))
                    inputWidth = "100%";
                if (column !=null && columnIndex !== undefined && (columnIndex < this.model.columns.length && this.model.columns[columnIndex].editTemplate)) {
                    var temp = { rowdata: args.rowData, column: this.model.columns, element: $element, requestType: args.requestType, type: args.type };
                    var temp1 = this.model.columns[columnIndex].editTemplate.write;                    
                    if (typeof temp1 == "string")
                        temp1 = ej.util.getObject(temp1, window);
                    temp1(temp);
					if(this.model.columns[columnIndex].isPrimaryKey && args.requestType == "beginedit")
						$element.addClass("e-disable").attr("disabled", "disabled");
                }
                else if ($element.hasClass("e-numerictextbox") || $element.hasClass("e-datepicker") || $element.hasClass("e-datetimepicker") || $element.hasClass("e-dropdownlist")) {
                    var customParams = this.getColumnByField($element.prop("name")), value = $element.val();
                    if ((!ej.isNullOrUndefined(matchMedia) && matchMedia.matches) || customParams["width"] && typeof customParams["width"] == "string" && customParams["width"].indexOf("%") != -1 && (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "batch"))
                        inputWidth = "100%";
                    $element.css("width", inputWidth);
                    if ($element.hasClass("e-numerictextbox")) {

                        if (value.length)
                            $element.attr("value", parseFloat(value));
                        $element.prop("name", $element.prop("name").replace(this._id, ""));
                    }
                    if ($element.hasClass("e-disable"))
                        $element.attr("disabled", "disabled");
                }
				 else if ($element.hasClass("e-save e-button") || $element.hasClass("e-cancel e-button") )
					 $element.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, width: "100","text-align":"centre",height:"35px"});
                    //else if ($element.hasClass("checkbox"))
                    //{
                    //    var value = $element.prop("checked");
                    //    $element.ejCheckBox({
                    //        id: $element[0].id,
                    //        checked: value
                    //    });
                    //}
                else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":
                            if (!ej.isNullOrUndefined(column) && column.format && $element.val() != "") {
                                switch (column.type) {
                                    case ("date" || "datetime"):
                                        var value = $element.val();
                                        var date = new Date(value);
                                        var format = column.format.replace("{0:", "").replace("}", "");
                                        var newformat = ej.format(date, format, this.model.locale);
                                        $element.val(newformat);
                                        break;
                                    case "number":
                                        var value = $element.val();
                                        var format = new RegExp("\\{0(:([^\\}]+))?\\}", "gm").exec(column.format);
                                        format[2].toLowerCase().split("")[0] == "c" ? format[2] = format[2].toLowerCase().replace("c", "n") : format[2];
                                        $element.val(ej.format(parseFloat(value), format[2], this.model.locale));
                                        break;
                                }
                            }
                            if ($element.attr("type") != "checkbox") {
                                $element.css("text-align", $element.attr("name") != null && this.getColumnByField($element.attr("name")) != null ?
                                this.getColumnByField($element.attr("name")).textAlign : "center");
                                if (this.model.editSettings.editMode == "batch"){
                                    $element.css('width', '100%').css("height", "28px");
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "22px");
							    }
                                else if (this.model.editSettings.editMode == "normal"){
                                    $element.css('width', '100%').css("height", "30px");
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "24px");
								}	
                                else{
                                    $element.outerWidth(inputWidth).height(28);
									if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version, 10) == 8)
									   $element.css("line-height", "26px");
								}

                            }
                            else
                                $element.width(inputWidth > 0 ? ($element.width() > inputWidth ? inputWidth : $element.width()) : this.model.editSettings.editMode.indexOf("template") != -1 ? $element.width() : 1);
								if(this.model.editSettings.editMode == "batch" && !this._tabKey)
									$element.is(':checked') ? $element.prop("checked",false) : $element.prop("checked",true);
                            break;
                        case "SELECT":
                            $element.width(inputWidth).height(28);
                            break;
                    }
                }
                if (column != null && !column.visible && column.validationRules && !(this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate")){				
					$element.addClass("e-hide");
				}
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof ($element.data("ejDropDownList") || $element.data("ejNumericTextbox")) == "object")) {
                    focusEle = $element;
                    elementFocused = true;
                }
            }
            var params2 = {};
            params2.enableRTL = this.model.enableRTL;
            params2.cssClass = this.model.cssClass;
            params2.watermarkText = this.localizedLabels.NumericTextBoxWaterMark;
            params2.locale = this.model.locale;
            $formElement.filter(".e-numerictextbox").ejNumericTextbox($.extend({ showSpinButton: true }, params2));
            params2.watermarkText = this.localizedLabels.DatePickerWaterMark;
            $formElement.filter(".e-datepicker").ejDatePicker($.extend({ displayDefaultDate: true, showPopupButton: false }, params2));
            delete params2["watermarkText"];

            $formElement.filter(".e-datetimepicker").ejDateTimePicker($.extend({ showPopupButton: false }, params2));
            $formElement.filter(".e-dropdownlist").ejDropDownList($.extend({ enableIncrementalSearch: true, htmlAttributes: {style: "width: 100%"} }, params2));
            for (var i = 0; i < this.model.columns.length; i++) {
                var col = this.model.columns[i];
                if (!ej.isNullOrUndefined(col.editParams)) {
                    var field = col.field;
                    field = /^[a-zA-Z0-9- ]*$/.test(field) ? field : field.replace(/[^a-z0-9\s_]/gi, '');

                    switch (col.editType) {
                        case ej.Grid.EditingType.DateTimePicker:
                            $formElement.filter("#" + this._id + field + ".e-datetimepicker").ejDateTimePicker(col.editParams);
                            break;
                        case ej.Grid.EditingType.DatePicker:
                            $formElement.filter("#" + this._id + field + ".e-datepicker").ejDatePicker(col.editParams);
                            break;
                        case ej.Grid.EditingType.Numeric:
                            $formElement.filter("#" + this._id + field + ".e-numerictextbox").ejNumericTextbox(col.editParams);
                            break;
                        case ej.Grid.EditingType.Dropdown:
                            $formElement.filter("#" + this._id + field + ".e-dropdownlist").ejDropDownList(col.editParams);
                            break;
                    }
                }

                if (col.editType == ej.Grid.EditingType.Dropdown) {
                    var f_index = -1;
                    if (this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor)
                        f_index = this._dataSource().adaptor.value.indexOf(col.field)
                    var ele = $formElement.filter("#" + this._id + col.field.replace(/[^a-z0-9\s_]/gi, "") + ".e-dropdownlist");
                    var dataSource = null;
                    if (!ej.isNullOrUndefined(col.dataSource) && !ej.isNullOrUndefined(col.editParams) && ej.isNullOrUndefined(col.foreignKeyField) && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor && f_index != -1)
                        dataSource = col.dataSource;
                    else if (ej.isNullOrUndefined(col.dataSource) && f_index != -1 && !ej.isNullOrUndefined(col.editParams))
                        dataSource = this._dataSource().adaptor.foreignData[f_index];
                    else if (!ej.isNullOrUndefined(col.editParams) && 'fields' in col.editParams && ej.isNullOrUndefined(col.foreignKeyField))
                        dataSource = col.dataSource; //when field is present in 'editParams' then dataSource is needed.
                    if (dataSource != null)
                        ele.ejDropDownList({ dataSource: dataSource });
                    var val = ele.data("ej-value");
                    if ((this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor) && f_index != -1 && !ej.isNullOrUndefined(col.editParams))
                        ele.ejDropDownList("setSelectedText", args.requestType == "add" && ej.isNullOrUndefined(col.defaultValue) && ej.isNullOrUndefined(val) ? ele.val("") : val);
                    else
                        ele.ejDropDownList("setSelectedValue", args.requestType == "add" && ej.isNullOrUndefined(col.defaultValue) && ej.isNullOrUndefined(val) ? ele.val("") : val);
                    if (col != null && !col.visible && col.validationRules && !(this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalformtemplate" || this.model.editSettings.editMode == "inlineformtemplate")) {
                        if (col.editType == ej.Grid.EditingType.Dropdown)
                            ele.closest(".e-rowcell").find("input").addClass("e-hide");
                    }
                }
                var format = null;
                if (col["format"] !== undefined && (col.format.length > 0)) {
                    var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                    var formatVal = toformat.exec(col.format);
                    format = formatVal[2];
                }

                if ([ej.Grid.EditingType.DatePicker, ej.Grid.EditingType.DateTimePicker].indexOf(col.editType) != -1) {
                    var picker = col.editType == ej.Grid.EditingType.DatePicker ? "datePicker" : "dateTimePicker";
                    var pickerControl = "ej" + picker.replace(/\b\w/g, function (m) { return m.toUpperCase(); });
                    var eleID = this._id + col.field;
                    var dateElement = $formElement.filter(function (e, k) { return k.id == eleID && ($(k).hasClass("e-datepicker") || $(k).hasClass("e-datetimepicker")); });
                    var dateParams = {};
                    if (format != null && !(!ej.isNullOrUndefined(col["editParams"]) && (col["editParams"].dateFormat || col["editParams"].dateTimeFormat)))
                        dateParams[picker.replace("Picker", "") + "Format"] = format;
                    if (dateElement.hasClass("e-disable")) dateParams["enabled"] = false;
                    dateElement[pickerControl](dateParams);
                    if (this.model.editSettings.editMode == "batch")
                        dateElement[pickerControl]("show");
                }
            }
            if (focusEle != null) {
                this._focusElements(focusEle);
            }

        },
        _focusElements: function ($currentCell) {
            if ($currentCell.length) {
                var $childElem = $currentCell;
                if (($childElem[0].tagName.toLowerCase() == "select" && !$childElem.hasClass("e-field e-dropdownlist")) || ($childElem[0].tagName.toLowerCase() == "input") && !$childElem.hasClass("e-numerictextbox")) {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.hasClass("e-field e-dropdownlist"))
                     $childElem.closest(".e-ddl").focus();
				else if ($childElem.hasClass('e-numerictextbox'))
					 $childElem.siblings('input:visible').first().select().focus();
                else
                    $childElem.find('input:visible,select').first().select().focus();
            }
        },
        _renderToolBar: function () {
            var $div = ej.buildTag('div.e-gridtoolbar', "", {}, { id: this._id + "_toolbarItems" });
            var $ul = ej.buildTag("ul");
            ((!ej.isNullOrUndefined(this.model.toolbarSettings.toolbarItems) && this.model.toolbarSettings.toolbarItems.length) || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow)) && this._renderLi($ul);
            $div.append($ul);
            var $customUl = ej.buildTag("ul");
            $div.append($customUl);
            (!ej.isNullOrUndefined(this.model.toolbarSettings.customToolbarItems) && this.model.toolbarSettings.customToolbarItems.length) && this._renderCustomLi($customUl);
            var model = {};
            model.click = this._toolBarClick;
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeprator = false;
            $div.ejToolbar(model);
            $div.ejToolbar("disableItem", this._disabledToolItems);
            this._disabledToolItems = $();
            return $div;
        },
        _renderCustomLi: function ($ul) {
            var $li; var customToolbar;
            for (var i = 0; i < this.model.toolbarSettings.customToolbarItems.length; i++) {
                customToolbar = this.model.toolbarSettings.customToolbarItems[i]["templateID"] ? this.model.toolbarSettings.customToolbarItems[i]["templateID"].replace("#", "") : this.model.toolbarSettings.customToolbarItems[i];
                $li = ej.buildTag("li", "", {}, { id: this._id + "_" + customToolbar, title: customToolbar });
                switch (typeof this.model.toolbarSettings.customToolbarItems[i]) {
                    case "string":
                        var $item = ej.buildTag("a.e-toolbaricons e-icon", "", {}).addClass(this.model.toolbarSettings.customToolbarItems[i]);
                        break;
                    case "object":
                        var templi = this.model.toolbarSettings.customToolbarItems[i];
                        $li.attr("title", !ej.isNullOrUndefined(templi["tooltip"]) ? templi["tooltip"] : templi["templateID"].replace("#", ""));
                        var $item = $(templi["templateID"]).hide().html();
                        break;
                }
                $li.html($item);
                $ul.append($li);
            }
        },
        _renderLi: function ($ul) {
            if ($.isFunction(window.matchMedia)) {
                if (this.model.enableResponsiveRow ) {
                    var searchIndex = this.model.toolbarSettings.toolbarItems.indexOf('search');
                    searchIndex != -1 && this.model.toolbarSettings.toolbarItems.splice(searchIndex, 1);
                    if (this.model.allowFiltering)
                        this.model.toolbarSettings.toolbarItems.push('responsiveFilter');
                    if (this.model.allowSorting) {
                        this.model.toolbarSettings.toolbarItems.push('responsiveSorting');
                    }
                    searchIndex != -1 && this.model.toolbarSettings.toolbarItems.push('search');
                }
            }
            for (var i = 0; i < this.model.toolbarSettings.toolbarItems.length; i++) {
                var $li = ej.buildTag("li", "", {}, { id: this._id + "_" + this.model.toolbarSettings.toolbarItems[i], title: this.localizedLabels[this.model.toolbarSettings.toolbarItems[i].slice(0, 1).toUpperCase() + this.model.toolbarSettings.toolbarItems[i].slice(1)] });
                this._renderLiContent($li, this.model.toolbarSettings.toolbarItems[i]);
                var item = this.model.toolbarSettings.toolbarItems[i];
                if (this.model.enableResponsiveRow && (item === "responsiveFilter" || item === "responsiveSorting")) {
                    $li.addClass("e-gridresponsiveicons");
                    $li.css("display", "none");
                }
                $ul.append($li);
            }
        },
        _renderLiContent: function ($li, item) {
            var $a, $input, $div, $span;
            switch (item) {
                case "add":
                    $a = ej.buildTag("a.e-addnewitem e-toolbaricons e-icon e-addnew", "", {});
                    break;
                case "edit":
                    $a = ej.buildTag("a.e-edititem e-toolbaricons e-icon e-edit", "", {});
                    break;
                case "delete":
                    $a = ej.buildTag("a.e-deleteitem e-toolbaricons e-icon e-delete", "", {});
                    break;
                case "update":
                    $a = ej.buildTag("a.e-saveitem e-toolbaricons e-disabletool e-icon e-save", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;
                case "cancel":
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-disabletool e-icon e-gcancel", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;
				
                case "search":
                    $a = ej.buildTag("a.e-searchitem e-toolbaricons e-disabletool e-icon e-searchfind", "", {});
                    if (!this.model.enableResponsiveRow) {
                        $input = ej.buildTag("input.e-ejinputtext e-gridsearchbar", "", {}, { type: "text", id: this._id + "_searchbar" });
                        $span = ej.buildTag('span.e-cancel e-icon e-hide', "", { 'right': '1%' });
                        $div = ej.buildTag('div.e-filterdiv e-searchinputdiv', "", { 'display': 'inline-table', 'width': '83%' });
                        $div.append($input).append($span);
                        $li.append($div);
                        if (!ej.isNullOrUndefined(this.model.searchSettings.key))
                            $input.val(this.model.searchSettings.key);
                    }
                    this.model.allowSearching = true;
                    break;
				case "printGrid":
					 $a = ej.buildTag("a.e-print e-toolbaricons e-icon", "", {});
					 break;
                case "excelExport":
                    $a = ej.buildTag("a.e-toolbaricons e-excelIcon e-icon", "", {});
                    break;
                case "wordExport":
                    $a = ej.buildTag("a.e-toolbaricons e-wordIcon e-icon", "", {});
                    break;
                case "pdfExport":
                    $a = ej.buildTag("a.e-toolbaricons e-pdfIcon e-icon", "", {});
                    break;
                case "responsiveFilter":
                    $a = ej.buildTag("a.e-toolbaricons e-filterset e-icon", "", {});
                    break;
                case "responsiveSorting":
                    $a = ej.buildTag("a.e-toolbaricons e-respponsiveSorting e-icon", "", {});
                    break;
            }
            $li.append($a);
            if (item == "search"){
                this._searchBar = $li;
				$li.css('display','flex');
			}
        },
        _toolBarClick: function (Sender) {
            var $gridEle = $(this.itemsContainer).closest(".e-grid"), gridInstance = $gridEle.ejGrid("instance"), gridId = $gridEle.attr('id');
            if (Sender.event == undefined && Sender.target.tagName == "INPUT" && Sender.currentTarget.id == gridId + "_search")
                return;
            $.isFunction($.fn.ejDatePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = Sender.currentTarget; var target = Sender.target;
            var gridModelClone = $.extend({}, gridInstance.model);
            if (gridInstance.ignoreOnToolbarServerClick.length) {
                for (var i = 0; i < gridInstance.ignoreOnToolbarServerClick.length; i++)
                    delete gridModelClone[gridInstance.ignoreOnToolbarServerClick[i]];
            }
            var args = { itemName: $(currentTarget).attr("data-content"), itemId: currentTarget.id, currentTarget: currentTarget, target: target, itemIndex: $(currentTarget).index(), itemCurrentTarget: currentTarget.outerHTML, gridModel: gridModelClone, itemTarget: target.outerHTML, toolbarData: Sender };
            if ($gridEle.ejGrid("instance")._trigger("toolbarClick", args))
                return;
            switch (args.itemId) {
                case gridId + "_add":
                    gridInstance._toolbarOperation(gridId + "_add");
                    break;
                case gridId + "_edit":
                    gridInstance._toolbarOperation(gridId + "_edit");
                    break;
                case gridId + "_delete":
                    gridInstance._toolbarOperation(gridId + "_delete");
                    break;
                case gridId + "_update":
                    gridInstance._toolbarOperation(gridId + "_update");
                    break;
                case gridId + "_cancel":
                    if (gridInstance.model.editSettings.editMode == "batch"){
                        if(gridInstance.model.editSettings.showConfirmDialog)
                             gridInstance._confirmDialog.find(".e-content").html(gridInstance.localizedLabels.CancelEdit).end().ejDialog("open");
                        else    
                             gridInstance.cancelEdit();
                    }
                    else
                        gridInstance._toolbarOperation(gridId + "_cancel");
                    break;
                case gridId + "_search":
                    if (gridInstance.model.enableResponsiveRow) {
                        if (ej.isNullOrUndefined(gridInstance.element.find('.e-responsesearch')[0])) {
                            var $div = ej.buildTag('div.e-gridtoolbar', "", {}, { id: this._id + "_toolbarItems" });
                            var $ul = ej.buildTag('div.e-responsesearch', '', { 'width': '95%', 'height': '38px', 'margin-top': '7px', 'margin-left': '6px' });
                            var $span = ej.buildTag('span.e-ttoltxt', '', { width: '98%', 'margin-left': '2%' }, { id: gridInstance._id + "_search" });
							var $a = ej.buildTag("span.e-searchitem e-toolbaricons e-disabletool e-icon e-searchfind", "", { 'position': 'absolute', 'right': '2%', 'margin-top': '1%' });
                            if (ej.browserInfo().name === "webkit")
                                $a.css("margin-top", "-2px");
                            var $input = ej.buildTag("input.e-ejinputtext", "", { width: '97%', 'height': '30px' }, { type: "search", id: gridInstance._id + "_searchInput" });
                            if (!ej.isNullOrUndefined(gridInstance.model.searchSettings.key))
                                $input.val(gridInstance.model.searchSettings.key);
                            $span.append($input);
                            $span.append($a);
                            $ul.append($span);
                            $div.append($ul);
                            $div.ejToolbar({
                                click: function (sender) {
                                    gridInstance._toolbarOperation(gridId + "_search", $(sender.currentTarget).find("input").val(),Sender);
                                }
                            });
                            $input.on('keyup', function (e) {
                                if ($input.val() != '') {
                                    $a.removeClass('e-searchfind');
                                    $a.addClass('e-cancel')
                                }
                                else {
                                    $a.removeClass('e-cancel');
                                    $a.addClass('e-searchfind');
                                }
                            });
                            $a.click(function () {
                                if ($a.hasClass('e-cancel')) {
                                    $input.val('');
                                    $a.removeClass('e-cancel');
                                    $a.addClass('e-searchfind');
                                    gridInstance._toolbarOperation(gridId + "_search", $("#" + gridId + "_searchInput").val(),Sender);
                                }
                            })
                            $div.insertBefore(gridInstance.getHeaderContent());
                        }
                        else {
                            if (gridInstance.element.find('.e-responsesearch').css('display') == 'block')
                                gridInstance.element.find('.e-responsesearch').css('display', 'none');
                            else
                                gridInstance.element.find('.e-responsesearch').css('display', 'block');
                        }
                    }
                    else
                        gridInstance._toolbarOperation(gridId + "_search", $(Sender.target).hasClass("e-cancel") ? "" : $(Sender.currentTarget).find("input").val(),Sender);
                    break;
				case gridId + "_printGrid":
                    gridInstance._toolbarOperation(gridId + "_printGrid");
                    break;
                case gridId + "_excelExport":
                    gridInstance._toolbarOperation(gridId + "_excelExport");
                    break;
                case gridId + "_wordExport":
                    gridInstance._toolbarOperation(gridId + "_wordExport");
                    break;
                case gridId + "_pdfExport":
                    gridInstance._toolbarOperation(gridId + "_pdfExport");
                    break;
                case gridId + "_responsiveFilter":
                    gridInstance._toolbarOperation(gridId + "_responsiveFilter");
                    break;
                case gridId + "_responsiveSorting":
                    gridInstance._toolbarOperation(gridId + "_responsiveSorting");
                    break;
            }
            return false;
        },

        _toolbarOperation: function (operation, searchEle,args) {
            var $gridEle = this.element, gridObject = $gridEle.ejGrid("instance"), batchEnable = gridObject.model.editSettings.editMode == "batch", gridId = $gridEle.attr('id'), fieldName;
            gridObject._exportTo = gridObject["export"];
            switch (operation) {
                case gridId + "_add":
                    if (batchEnable)
                        gridObject._bulkAddRow();
                    else
                        gridObject._startAdd();
                    break;
                case gridId + "_edit":
                    if (batchEnable && gridObject.model.editSettings.allowEditing) {
					    if (gridObject._bulkEditCellDetails.columnIndex == -1) {
					        alert(this.localizedLabels.EditOperationAlert);
                            return;
                        }
                        fieldName = gridObject.model.columns[gridObject._bulkEditCellDetails.columnIndex].field;
                        fieldName && gridObject.editCell(gridObject._bulkEditCellDetails.rowIndex, fieldName);
                    }
                    else
                        gridObject.startEdit();
                    break;
                case gridId + "_delete":
                    if (this._selectedRow() == -1) {
                        alert(this.localizedLabels.DeleteOperationAlert);
                        return;
                    }
                    if (this.model.editSettings.showDeleteConfirmDialog)
                        this._confirmDialog.find(".e-content").html(this.localizedLabels.ConfirmDelete).end().ejDialog("open");
                    else {
                        if (batchEnable)
                            this._bulkDelete()
                        else {
                            if (this.multiDeleteMode)
                                this._multiRowDelete();
                            else
                                this.deleteRow();
                        }
                    }
                    break;
                case gridId + "_update":
                    if (batchEnable && $("#" + this._id + "EditForm").children().find(".e-field-validation-error").length == 0)
                        this.model.editSettings.showConfirmDialog ? this._confirmDialog.find(".e-content").html(this.localizedLabels.BatchSaveConfirm).end().ejDialog("open") : this.batchSave();
                    else
                        gridObject.endEdit();
                    break;
                case gridId + "_cancel":
                    if (batchEnable) {
                        if ($("#" + gridId + "ConfirmDialog").ejDialog("isOpened") === true)
                            this._triggerConfirm();
                        else
                            gridObject.cancelEditCell();
                    }
                    else
                        gridObject.cancelEdit();
                    break;
                case gridId + "_search":
                    if (args.type == 'click' && (args.target.nodeName == "A" || args.target.nodeName == "SPAN"))
                        $gridEle.ejGrid("search", searchEle);
                    break;
				case gridId + "_printGrid":
                    this.print();
                    break;
                case gridId + "_excelExport":
                    gridObject._exportTo(gridObject.model.exportToExcelAction, 'excelExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_wordExport":
                    gridObject._exportTo(gridObject.model.exportToWordAction, 'wordExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_pdfExport":
                    gridObject._exportTo(gridObject.model.exportToPdfAction, 'pdfExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_responsiveFilter":
                    $("#responsiveFilter").css('display', 'block');
                    setTimeout(function () { gridObject.element.css('display', 'none'), 0 });
                    break;
                case gridId + "_responsiveSorting":
                    this._sortColumns = []; this._removeSortCol = []
                    for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                        this._sortColumns.push({ field: this.model.sortSettings.sortedColumns[i].field, direction: this.model.sortSettings.sortedColumns[i].direction });
                    }
                    if (ej.isNullOrUndefined($("#responsiveSort")[0])) {
                        var $dlg = $("#responsiveFilter").clone().css('display', 'block');
                        $dlg.insertAfter(this.element);
                        $dlg.attr('id', 'responsiveSort');
                        gridObject._setSortingButton();
                        var $btnDiv = ej.buildTag('div.btnContainer', '', { width: '100%', 'bottom': '0px', 'position': 'absolute' });
                        var $inputOk = ej.buildTag('input.e-resposnsiveFilterBtnLeft e-flat e-btnsub', 'OK', { 'width': '45.6%' });
                        var $inputCancel = ej.buildTag('input.e-resposnsiveFilterBtnRight e-flat e-btncan', 'Cancel', { 'width': '46%' });
                        var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon');
                        var $cspanIcon = ej.buildTag('span.e-icon e-responsiveClose e-resIcon');
                        $dlg.find('.e-resFilterleftIcon').remove();
                        $dlg.find('.e-labelRes').text('Sorting');
                        $dlg.find('.e-resFilterDialogHeaderDiv').append($closeIcon.append($cspanIcon))
                        $dlg.find('.e-resFilterDialogHeaderDiv').find('.e-resFIlterRigthIcon').click(function (e) {
                            $("#responsiveSort").css('display', 'none');
                            gridObject.element.css('display', 'block');
                        })
                        var $divIcon = ej.buildTag('div.e-resFilterleftIcon', '', { 'margin-top': '3%' });
                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responsiveSortClear');
                        $divIcon.click(function () {
                            $dlg.find('.e-responsivefilterColDiv').find('.e-button').remove();
                            gridObject._setSortingButton(true);
                            for (var i = 0; i < gridObject._sortColumns.length; i++) {
                                if (gridObject._removeSortCol.indexOf(gridObject._sortColumns[i].field) == -1)
                                    gridObject._removeSortCol.push(gridObject._sortColumns[i].field);
                            }
                            gridObject._sortColumns = [];
							gridObject._removeSortCol = [];
                        });
                        $dlg.find('.e-resFilterDialogHeaderDiv').prepend($divIcon.append($spanIcon));
                        $dlg.append($btnDiv);
                        $btnDiv.append($inputOk).append($inputCancel);
                        $inputOk.ejButton({
                            text: 'OK', type: 'button',
                            click: $.proxy(this._resSortOperation, this)
                        })
                        $inputCancel.ejButton({
                            text: 'Cancel', type: 'button',
                            click: function () {
                                $("#responsiveSort").css('display', 'none');
                                gridObject.element.css('display', 'block');
                                gridObject._sortColumns = [];
                                $dlg.find('.e-responsivefilterColDiv').find('.e-button').remove();
                                gridObject._setSortingButton();
                            }
                        })
                    }
                    else {
                        $("#responsiveSort").find('.e-responsivefilterColDiv').find('.e-button').remove();
                        this._setSortingButton();
                    }
                    $("#responsiveSort").find('.e-responsivefilterColDiv').find('.e-filternone').remove();
                    $("#responsiveSort").css('display', 'block');
                    setTimeout(function () { gridObject.element.css('display', 'none'), 0 });
                    break;
            }
            return false;
        },
        _resSortOperation: function (sender) {
            var rCol=[];
			for(var i=0; i< this.model.sortSettings.sortedColumns.length;i++)
				rCol.push(this.model.sortSettings.sortedColumns[i].field);
            for (var i = 0; i < rCol.length; i++)
                this.removeSortedColumns(rCol[i]);
            for (var i = 0 ; i < this._sortColumns.length; i++) {
                if (this.model.allowMultiSorting)
                    this.multiSortRequest = true;
                this.sortColumn(this._sortColumns[i].field, this._sortColumns[i].direction);
            }
            $("#responsiveSort").css('display', 'none');
            this.element.css('display', 'block');
        },
        _setSortingButton: function (clear) {
            var $sortDiv = $("#responsiveSort");
            var gridObj = this;
            this._sortCols = [];
            if (ej.isNullOrUndefined($sortDiv.find('.e-responsivefilterColDiv').find('.e-button')[0])) {
                $sortDiv.find('.e-responsivefilterColDiv').each(function (index, object) {
                    var $btnDiv = ej.buildTag('div', '', { 'float': 'right', 'margin-right': '2%', 'margin-top': '-1%' })
                    var fieldName = $(object).attr('data-ej-mappingname');
                    var $but = ej.buildTag('button#' + fieldName + ".e-sortingBtn e-flat", '');
                    $(object).append($btnDiv.append($but));
                    var btnText = 'None', icon = '';
                    if (!clear) {
                        for (var sortC = 0; sortC < gridObj.model.sortSettings.sortedColumns.length; sortC++) {
                            if (gridObj.model.sortSettings.sortedColumns[sortC].field == fieldName) {
                                btnText = gridObj.model.sortSettings.sortedColumns[sortC].direction == 'ascending' ? 'Ascending' : 'Descending';
                                icon = btnText == 'Ascending' ? 'e-resIcon e-respponsiveSortingAsc' : 'e-resIcon e-respponsiveSortingDesc';
                            }
                        }
                        if (icon != '') {
                            $but.ejButton({
                                text: btnText, type: 'button',
                                height: 28,
                                width: 120,
                                cssClass: 'e-resSortIconBtn',
                                id: fieldName,
                                prefixIcon: icon,
                                imagePosition: "imageright",
                                contentType: "textandimage",
                                showRoundedCorner: true,
                                click: $.proxy(gridObj._resSortButClick, gridObj)
                            })
                        }
                        else {
                            $but.ejButton({
                                text: btnText, type: 'button',
                                height: 28,
                                cssClass: 'e-resSortIconBtn',
                                width: 120,
                                id: fieldName,
                                showRoundedCorner: true,
                                click: $.proxy(gridObj._resSortButClick, gridObj)
                            })
                        }
                    }
                    else {
                        $but.ejButton({
                            text: btnText, type: 'button',
                            height: 28,
                            width: 120,
                            id: fieldName,
                            showRoundedCorner: true,
                            click: $.proxy(gridObj._resSortButClick, gridObj)
                        })
                    }
                });
            }
        },
        _sortOperation: function (field, direction) {
            if (this._removeSortCol.indexOf(field) != -1) {
                this._sortColumns.splice(this._removeSortCol.indexOf(field), 0);
				this._removeSortCol.splice(this._removeSortCol.indexOf(field), 0);
            }
            for (var column = 0; column < this._sortColumns.length; column++) {
                if (this._sortColumns[column]["field"] == field)
                    break;
            }
            if (this.model.allowMultiSorting) {
                this.multiSortRequest = true;
                if (column != -1) {
                    this._sortColumns.splice(column, 1);
					if (this._removeSortCol.indexOf(field) == -1)
						this._removeSortCol.push(field);
                }
            }
            else {
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-button').removeClass('e-disable');
                var $divColg = $("#responsiveFilter").find('.e-responsivefilterColDiv').not(".e-responsivefilterColDiv[data-ej-mappingname='" + field + "']");
                var $btn = $divColg.find('.e-button').addClass('e-disable');
                $btn.text('None');
                if (this._sortColumns.length > 0) {
                    this._removeSortCol.push(this._sortColumns[0].field);
                    this._sortColumns = [];
                }
            }
            this._sortColumns.push({ field: field, direction: direction });
        },
        _resSortButClick: function (sender) {
            var text = '', prefixIcon = '', fieldName = sender.model.id;
            var obj = $("#" + sender.model.id).ejButton('instance');
            if (sender.model.text == 'None') {
                text = 'Ascending';
                prefixIcon = 'e-resIcon e-respponsiveSortingAsc';
                this._sortOperation(fieldName, 'ascending');
            }
            else if (sender.model.text == 'Ascending') {
                text = 'Descending';
                prefixIcon = 'e-resIcon e-respponsiveSortingDesc';
                this._sortOperation(fieldName, 'descending');
            }
            else {
                obj.model.text = 'None';
                obj.model.prefixIcon = '';
                obj.type = 'button';
                obj.model.contentType = "text";
                obj._render();
                for (var column = 0; column < this._sortColumns.length; column++) {
                    if (this._sortColumns[column]["field"] == fieldName)
                        break;
                }
                this._removeSortCol.push(fieldName);
                this._sortColumns.splice(column, 1);
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-button').removeClass('e-disable');
                return;
            }
            obj.model.text = text; obj.model.prefixIcon = 'e-resIcon ' + prefixIcon; obj.model.imagePosition = "imageright";
            obj.model.contentType = "textandimage"; obj._render();
        },
        renderDiaglogButton: function (form, tbody) {
            var btnId;
            if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                btnId = "EditExternalForm_";
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                btnId = "InlineEditForm_";
                var inlineTitleBar = ej.buildTag("div", "", "", { id: this._id + "_inlineFormTitle", 'class': "e-inlineform-titlebar" });
                inlineTitleBar.appendTo(tbody);
                    }
					
            else
                btnId = "EditDialog_";
            var savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '30px' }, { type: "button", id: btnId + this._id + "_Save" });
            savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: this.localizedLabels.SaveButton, width: "100" });
            var cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '19px', 'margin-right': '13px' }, { type: "button", id: btnId + this._id + "_Cancel" });
            cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: this.localizedLabels.CancelButton, width: "100" });
            var btnDiv = (this.model.editSettings.editMode != "dialog" && this.model.editSettings.editMode != "dialogtemplate") ? ej.buildTag('div', "", "", { 'class': "e-editform-btn" }) : ej.buildTag('div');
            btnDiv.append(savebtn);
            btnDiv.append(cancelbtn);
            form.appendTo(tbody);
            if (this.model.editSettings.editMode != "dialog" && this.model.editSettings.editMode != "dialogtemplate")
                btnDiv.appendTo(tbody);
            else
                form.append(btnDiv);
            return tbody;
        },
        _externalFormPosition: function () {
            var pos = $(this.element).offset();
            var width = $(this.element).width();
            var height = $(this.element).height();
            var DivElement = $("#" + this._id + "_externalEdit");
            switch (this.model.editSettings.formPosition) {
                case "topright":
                    $(DivElement).find('.e-form-toggle-icon').removeClass('e-bottomleft').addClass('e-topright');
                    $(DivElement).css({ "left": (pos.left + width + 1) + "px", "top": pos.top + "px", "position": "absolute", "width": "290px" });
                    $("#" + this._id + "_eFormContent").height("auto");
                    break;
                case "bottomleft":
                    $(DivElement).find('.e-form-toggle-icon').removeClass('e-topright').addClass('e-bottomleft');
                    $(DivElement).css({ "left": (pos.left) + "px", "top": (pos.top + height + 1) + "px" });
                    $("#" + this._id + "_eFormContent").width("100%");
                    break;
            }
        },
        _setoffsetWidth: function () {
            var tds, $form = this.model.scrollSettings.frozenColumns > 0 ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
            if (this._gridRecordsCount == 0 && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0 && this.model.editSettings.editMode != "batch" && (!($form.find(".e-checkbox").length > 0 && this._dataSource() instanceof ej.DataManager)))
                return;
            if (this.model.editSettings.editMode == "batch")
                tds = $form.closest("td");
            else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                tds = $form.find(".e-rowcell").not(".e-unboundcell,.e-templatecell");
            else
                tds = $form.find("tr").find(".e-rowcell").not(".e-unboundcell,.e-templatecell");
            for (var i = 0; i < tds.length; i++)
                this._tdsOffsetWidth[i] = tds.get(i).offsetWidth;
        },
        _bulkChangesAcquired: function () {
            if (this.batchChanges.added.length > 0 || this.batchChanges.changed.length || this.batchChanges.deleted.length)
                return true;
            return false;
        },
        _renderDialog: function () {
            var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },
        
        getCurrentEditCellData: function () {
            if (this.model.isEdit && $("#" + this._id + "EditForm").length) {
                var $element = $("#" + this._id + this._bulkEditCellDetails.fieldName.replace(/[^a-z0-9\s_]/gi, '')), cellValue,
                    column = this.model.columns[this._bulkEditCellDetails.columnIndex], temp1;
                switch (this._bulkEditCellDetails.cellEditType) {
                    case ej.Grid.EditingType.String:
					case ej.Grid.EditingType.Numeric:
                        cellValue = $element.val();
                        break;                                          
                    case ej.Grid.EditingType.Dropdown:
                        cellValue = this._bulkEditCellDetails.isForeignKey ? { "value": $element.ejDropDownList("getSelectedValue"), "text": $element.ejDropDownList("getValue") } : $element.ejDropDownList("getSelectedValue");
                        if ( this._bulkEditCellDetails.isForeignKey && column.originalType == "number" && cellValue.value !="" )
							cellValue.value = JSON.parse(cellValue.value);
						break;
                    case ej.Grid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;
                    case ej.Grid.EditingType.DatePicker:                       
                        var val = $.trim($element.val());
                        var dropObj = $element.ejDatePicker("instance");
                        dropObj._setDateValue(val);//to update dropdownlist model when manually entering value
                        cellValue = val == "" ? val : dropObj.model.value;
                        break;
                    case ej.Grid.EditingType.DateTimePicker:
                        cellValue = $.trim($element.val()) == "" ? $.trim($element.val()) :$element.ejDateTimePicker("model.value");
                        break;
                    case "edittemplate":
                        temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;
                }
                if (typeof cellValue == "string" && cellValue.length && column.type == "number")
                   cellValue = ej.globalize.parseFloat(cellValue,this.model.locale);
                return cellValue;
            }
            return null;
        },
        cancelEditCell: function () {
            if (this.model.isEdit) {
                var tr = this.getRows()[this._bulkEditCellDetails.rowIndex], cellData = {}, cell;
                ej.createObject(this._bulkEditCellDetails.fieldName, this._bulkEditCellDetails.cellValue, cellData);
                if ($(tr).hasClass("e-insertedrow"))
                    cell = $(tr).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex + this.model.groupSettings.groupedColumns.length);
                else
                    cell = $(tr).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex);
                $(cell).removeClass("e-validError");
                if ($(cell).hasClass("e-updatedtd"))
                    $(cell).addClass("e-gupdatenotify");
                $(cell).removeClass("e-editedbatchcell").empty().html($($.templates[this._id + "_JSONTemplate"].render(cellData)).find('.e-rowcell').get(this._bulkEditCellDetails.columnIndex).innerHTML);
                this.model.isEdit = false;
                this.element.focus();
            }
        },
        saveCell: function (preventSaveEvent) {
            if (this.model.isEdit) {
                if (!this.editFormValidate())
                    return true;
                var $form = $("#" + this._id + "EditForm"), $targetTR = $form.closest("tr"), $targetTD = $form.closest("td"), $toolBar, tempVal, formattedValue
                , args = {}, column = this.model.columns[this._bulkEditCellDetails.columnIndex], $element = $("#" + this._id + this._bulkEditCellDetails.fieldName.replace(/[^a-z0-9\s_]/gi,'')), getVal, setVal;
                args = {
                    columnName: column.field,
                    value: this.getCurrentEditCellData(),
                    rowData: this._bulkEditCellDetails.rowData,
                    previousValue: this._bulkEditCellDetails.cellValue,
                    columnObject: column,
                    cell: $targetTD,
                    isForeignKey: this._bulkEditCellDetails.isForeignKey
                };
                if (!preventSaveEvent && this._trigger("cellSave", args)) {
                    this._focusElements(args.cell);
                    this._bulkEditCellDetails.cancelSave = true;
                    return;
                }
                if (this.model.allowTextWrap)
                    args.cell.addClass("e-nowrap");
                if (this._bulkEditCellDetails.cellEditType == "datetimepicker" || this._bulkEditCellDetails.cellEditType == "dropdownedit" || this._bulkEditCellDetails.cellEditType == "datepicker")
                    $element[$element.data("ejWidgets")[0]]("destroy");
                if (!ej.isNullOrUndefined(column.format)) {
                    if ((column.type == "date" || column.type == "datetime") && !ej.isNullOrUndefined(args.value))
                        (!args.isForeignKey) ? args.value = args.value.length > 0 ? new Date(args.value) : args.value : args.value.text = args.value.text.length > 0 ? new Date(args.value.text) : args.value.text;
                
                    formattedValue = this.formatting(column.format, args.isForeignKey ?
                                              (!isNaN(parseFloat(args.value.text)) && isFinite(args.value.text)
                                              ? parseFloat(args.value.text)
                                              : args.value.text) : args.value,this.model.locale);
                    args.cell.empty().html(formattedValue);
                }
                ej.createObject(this._bulkEditCellDetails["fieldName"], args.isForeignKey ? args.value.value : args.value, args.rowData);
                if (ej.isNullOrUndefined(column.format))
                    formattedValue = args.isForeignKey ? args.value.text : args.value;
                if (!ej.isNullOrUndefined(column.template)) {
                    var rowData = ej.copyObject({}, args.rowData);
                    ej.createObject(this._bulkEditCellDetails["fieldName"], args.isForeignKey ? args.value.value : args.value, rowData);
                    formattedValue = $.templates(column.template).render(rowData);
                }
                if (this._bulkEditCellDetails.cellEditType == "edittemplate") {                
                    if (args.value instanceof Array)
                        formattedValue = args.value.join();
                    args.cell.empty().html(formattedValue);
                }
                else {
                    if (args.columnObject.type == "boolean" || args.columnObject.editType == "booleanedit") {
                        var cellData = {};
                        ej.createObject(args.columnObject.field, args.value, cellData);
                        args.cell.empty().html($($.templates[this._id + "_JSONTemplate"].render(cellData))[0].cells[this._bulkEditCellDetails.columnIndex].innerHTML);						
					}
                    else if ((args.columnObject.editType == "datepicker" || args.columnObject.editType == "datetimepicker") && !ej.isNullOrUndefined(column.format))
						args.cell.empty().html(formattedValue);
                    else {
                        if (args.columnObject.disableHtmlEncode)
                            args.cell.text(formattedValue).html();
                        else
                            args.cell.empty().html(formattedValue);
                    }
                }
                args.cell.removeClass('e-validError');
                if (args.cell.hasClass('e-updatedtd'))
                    args.cell.addClass("e-gupdatenotify");
                args.previousValue = !ej.isNullOrUndefined(args.previousValue) ? (column.type == "date" || column.type == "datetime") ? new Date(args.previousValue) : args.previousValue : "";
                tempVal = args.isForeignKey ? args.value.value : args.value;
                var isValueModified = false,gridColData;
                if (this.model.editSettings.rowPosition == "bottom")
                    gridColData = this._currentJsonData.length == this._bulkEditCellDetails.rowIndex ? this._currentJsonData[this._bulkEditCellDetails.rowIndex - 1] : this._currentJsonData[args.cell.parent().index()];
                else {
                    var rowDataIndex = this.getBatchChanges().added.length ? args.cell.parent().index() - this.getBatchChanges().added.length : args.cell.parent().index();
                    gridColData = this._currentJsonData.length == this._bulkEditCellDetails.rowIndex ? this._currentJsonData[this._bulkEditCellDetails.rowIndex - 1] : this._currentJsonData[rowDataIndex];
                }
                if(this._currentJsonData.length>0){
				    if ((this._bulkEditCellDetails.type == "date" || this._bulkEditCellDetails.type == "datetime") && !ej.isNullOrUndefined(this._bulkEditCellDetails.format))
				       isValueModified = this._bulkEditCellDetails.cellValue instanceof Date ? this.formatting(this._bulkEditCellDetails.format, tempVal) != this.formatting(this._bulkEditCellDetails.format, ej.getObject(args.columnName, gridColData)) : true;
                    else if (!ej.isNullOrUndefined(ej.getObject(args.columnName, gridColData)))
                       isValueModified = ((this._bulkEditCellDetails.cellEditType == "datepicker" || this._bulkEditCellDetails.cellEditType == "datetimepicker" || this._bulkEditCellDetails.cellEditType == "dropdownedit")
						  && tempVal instanceof Date && args.previousValue instanceof Date) ? (tempVal.getTime() !== ej.getObject(args.columnName, gridColData).getTime()) : (typeof (tempVal) == "number" ? tempVal !== parseFloat(ej.getObject(args.columnName, gridColData)) : typeof (tempVal) == "boolean" ? tempVal != ej.getObject(args.columnName, gridColData) : tempVal !== ej.getObject(args.columnName, gridColData).toString());
				    else
				        isValueModified = !ej.isNullOrUndefined(tempVal);
                }
				else
					isValueModified = true;
				this.model.isEdit = false;
                if (isValueModified) {
                    args.cell.addClass("e-updatedtd e-icon e-gupdatenotify");
                    this._enableSaveCancel();
                    getVal = ej.getObject(this._bulkEditCellDetails["fieldName"], args.rowData);
                    if (typeof getVal == "string" && getVal.length)
                        setVal = args.isForeignKey ? args.value.value.toString() : args.value.toString();
                    else
                        setVal = args.isForeignKey ? (!isNaN(parseInt(args.value.value)) ? parseInt(args.value.value) : args.value.value) : args.value;
                    if (typeof args.value == "string" && !setVal.length)
                        setVal = null;
                    ej.createObject(this._bulkEditCellDetails["fieldName"], setVal, args.rowData);
                    if ($.inArray(args.rowData, this.batchChanges.changed) == -1 && $.inArray(args.rowData, this.batchChanges.added) == -1)
                        this.batchChanges.changed.push(args.rowData);
					if(this.isejObservableArray){
                        var batchAction;
                        if (args.cell.closest("tr").hasClass("e-insertedrow"))
                            batchAction = "insert";
                        else
                            batchAction = "update";                                                                             
                        this._refreshViewModel(args, batchAction);
                    }
                }
                else{
                    args.cell.removeClass("e-updatedtd e-icon e-gupdatenotify");
                    this._enableSaveCancel();
                    if(this.batchChanges.changed.length >0 &&  !args.cell.hasClass("e-editedbatchcell e-updatedtd e-icon e-gupdatenotify") && !args.cell.parent().children().hasClass("e-updatedtd e-icon e-gupdatenotify")){
						for(var index = 0 ; index < this.batchChanges.changed.length; index++){
							if(args.rowData[this._primaryKeys[0]] == this.batchChanges.changed[index][this._primaryKeys[0]])
								this.batchChanges.changed.splice(index,1)
						}
					}
                }
                $targetTR.removeClass("e-editedrow").removeClass("e-batchrow");
                args.cell.removeClass("e-editedbatchcell");
            }
        },
		_refreshViewModel:function(args, batchAction){
            var dm;
            if (!(this._dataSource() instanceof ej.DataManager))
                dm = ej.DataManager(this._dataSource());
            else 
                dm = this._dataSource();
            var query = new ej.Query();
            for (var i = 0; i < this._primaryKeys.length; i++)
                query = query.where(this._primaryKeys[i], ej.FilterOperators.equal, this._primaryKeys.length ? ej.getObject(this._primaryKeys[i], args.rowData) : null);
            var currentData = dm.executeLocal(query);
            var $dataSource = this._dataSource(undefined, true);
            var index = $.inArray(currentData[0], this._dataSource());
            this.model.editSettings.showConfirmDialog = false;
            switch (batchAction) {
                case "update":                
                $dataSource(args.rowData, index, batchAction);
                break;
                case "remove":
                $dataSource(args.rowData, index, batchAction);               
                break;
                case "insert":
                $dataSource(args.rowData, 0, batchAction);                  
                break;
            }            
        },
        _enableSaveCancel: function () {
            if (this.model.toolbarSettings.showToolbar) {
                var toolbarState = this.getContentTable().find(".e-updatedtd.e-icon.e-gupdatenotify").length > 0 ||  this._isBatchDeleteApplied  ? "enableItemByID" : "disableItemByID";
                var $toolBar = this.element.find("#" + this._id + "_toolbarItems");
                $toolBar.ejToolbar(toolbarState, this._id + "_update");
                $toolBar.ejToolbar(toolbarState, this._id + "_cancel");
            }
        },
        setCellText: function (rowIndex, cellIndex, value) { /*Supports only local datasource*/
            var byField = typeof cellIndex == "string", rows = this._excludeDetailRows(), cell,
                isGrouped = this.model.groupSettings.groupedColumns.length != 0, isVirtualized = this.model.scrollSettings.allowVirtualScrolling,
                column = this[byField ? "getColumnByField" : "getColumnByIndex"](cellIndex), current = ej.getObject(["currentViewData", (isGrouped ? ".records" : "")].join(""), this.model),
                edited = {}, dm = isVirtualized ? this._dataManager : new ej.DataManager(current),
                key = this._primaryKeys[0], keyValue = byField || ej.getObject(rowIndex + "." + key, isVirtualized ? this._dataManager.dataSource.json : current),
                editedValue = value, valid = false;

            ej.createObject(column.field, value, edited);

            if (byField) {
                keyValue = rowIndex;
                rowIndex = dm.executeLocal(new ej.Query().select(key)).indexOf(rowIndex);
                cellIndex = this.getColumnIndexByField(column.field);
            }
            if (isVirtualized) {
                var pageSize = this.model.pageSettings.pageSize, page, name, mod = rowIndex % pageSize, isCached;
                page = (rowIndex + pageSize - mod)/ pageSize;        
                name = (page - 1) * pageSize; isCached = $.inArray(name, this.virtualLoadedPages) != -1
                if (isCached) {
                    cell = this.getContentTable().find("tr[name=" + name + "]")[mod].cells[cellIndex];
                }
            }

            var tr = this._excludeDetailRows()[rowIndex], proxy = this;
            if (!ej.isNullOrUndefined(column) && !column.isPrimaryKey && column.allowEditing != false) {

                if (!ej.isNullOrUndefined(column.validationRules)) {

                    var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $valElem = ej.buildTag("input", "", {}, { id: this._id + column.field, value: value, name: column.field });
                    $form.addClass("gridform");
                    $form.append($valElem);
                    this.element.append($form);
                    $form.validate({
                        errorPlacement: function (error, element) {
                            if (!proxy._alertDialog) proxy._renderAlertDialog();
                            $("#" + proxy._id + "AlertDialog_wrapper").css("min-height", "");
                            proxy._alertDialog.find(".e-content").text(error.text());
                            proxy._alertDialog.ejDialog("open");
                            proxy.element.find($form).remove();
                            valid = true;
                            return true;
                        },
                    });
                    this.setValidationToField(column.field, column.validationRules);
                }
                if (!ej.isNullOrUndefined(column.format)) {
                    var formattedValue = this.formatting(column.format, column.foreignKeyValue ?
                                                (!isNaN(parseFloat(value)) && isFinite(value)
                                                ? parseFloat(value)
                                                : value) : value, this.model.locale);
                    editedValue = formattedValue;
                }
                if (!ej.isNullOrUndefined(column.validationRules)) {
                    $($form).validate().form();
                    this.element.find($form).remove();
                }
                if (!valid) {
                    var canSkip = rowIndex == -1 || cellIndex == -1 || (isVirtualized && !isCached)
                       || rowIndex > (isVirtualized ? this._dataSource() : current).length || cellIndex > this.model.columns.length;
                    if (!canSkip) { /*Skip when not in current page*/
                        if (this.model.scrollSettings.frozenColumns)
                            cell = this._frozenCell(rowIndex, cellIndex)[0];
                        else
                            cell = cell || this._excludeDetailCells(rows[rowIndex])[cellIndex];
                        value = column.format === undefined ? value : this.formatting(column.format, value, this.model.locale);
                        if (!ej.isNullOrUndefined(column.foreignKeyField) && !ej.isNullOrUndefined(column.foreignKeyValue))
                            value = this._getForeignKeyData(edited)[column.foreignKeyField][column.foreignKeyValue];
                        if (column.disableHtmlEncode)
                            $(cell).text(value);
                        else
                            cell.innerHTML = value;
                        this._trigger("queryCellInfo", { cell: cell, text: cell.innerHTML, column: column, data: edited });
                    }
                    if (key) {
                        ej.createObject(key, keyValue, edited);
                        this._dataManager.update(key, edited);
                    }
                }
            }
        },
        _excludeDetailCells: function ($tr) {
            var $gridCells;
            if (!ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid || this.model.showSummary))
                $gridCells = $($tr.cells).not(".e-detailrowexpand, .e-detailrowcollapse");
            else
                $gridCells = $($tr.cells);
            return $gridCells;
        },
        setCellValue: function (index, fieldName, cellValue) {
            if ($("#" + this._id + "EditForm").length > 0)
                $("#" + this._id + "EditForm").attr("id", "EditForm1");
            if (this.model.editSettings.editMode == "batch" && !this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.frozenColumns) {
                var data = this.getDataByIndex(index), tr = this._excludeDetailRows()[index], dataIndex, columnIndex = this.getColumnIndexByField(fieldName), proxy = this, editedValue = cellValue, valid = false;
                var column = this.getColumnByField(fieldName), editedTd;
                if ($(tr).hasClass("e-insertedrow"))
                    editedTd = $(tr.cells).not(".e-detailrowcollapse, .e-detailrowexpand")[columnIndex + this.model.groupSettings.groupedColumns.length];
                else
                    editedTd = $(tr.cells).not(".e-detailrowcollapse, .e-detailrowexpand")[columnIndex];
                if (!ej.isNullOrUndefined(column) && !column.isPrimaryKey && column.allowEditing != false) {
                    if (!ej.isNullOrUndefined(column.validationRules)) {/*Check for validation*/
                        var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $valElem = ej.buildTag("input", "", {}, { id: this._id + column.field, value: cellValue, name: column.field });
                        $form.append($valElem);
                        this.element.append($form);
                        $form.validate({/*Validate the form*/
                            errorPlacement: function (error, element) {
                                if (!proxy._alertDialog) proxy._renderAlertDialog();
                                $("#" + proxy._id + "AlertDialog_wrapper").css("min-height", "");
                                proxy._alertDialog.find(".e-content").text(error.text());
                                proxy._alertDialog.ejDialog("open");
                                proxy.element.find($form).remove();
                                valid = true;
                                return true;
                            },
                        });
                        this.setValidationToField(column.field, column.validationRules);
                    }

                    if (column.foreignKeyValue) {
                        editedValue = this._foreignKeyBinding(columnIndex, cellValue, this._id);/*Get the corresponding foreign key value*/

                        if (editedValue == undefined) {
                            if (!this._alertDialog) this._renderAlertDialog();
                            $("#" + this._id + "AlertDialog_wrapper").css("min-height", "");
                            this._alertDialog.find(".e-content").text(this.localizedLabels.ForeignKeyAlert);
                            this._alertDialog.ejDialog("open");
                            if (!ej.isNullOrUndefined(column.validationRules)) this.element.find($form).remove();
                            return;
                        }
                    }

                    if (!ej.isNullOrUndefined(column.format)) {/*Get the formatted value*/
                        var formattedValue = this.formatting(column.format, column.foreignKeyValue ?
                                                    (!isNaN(parseFloat(cellValue)) && isFinite(cellValue)
                                                    ? parseFloat(cellValue)
                                                    : cellValue) : cellValue, this.model.locale);
                        editedValue = formattedValue;
                    }
                    


                    if (!ej.isNullOrUndefined(column.validationRules)) {
                        $($form).validate().form();
                        this.element.find($form).remove();
                    }
                    $("#EditForm1").attr("id", this._id + "EditForm");
                    if (!valid && editedTd.innerHTML != editedValue) {
                        if ($(editedTd).has("form").length > 0) this.model.isEdit = false;
                        if ($(editedTd).hasClass("e-boolrowcell"))
                            $(editedTd).find("input").attr("checked", editedValue);
                        else
                            editedTd.innerHTML = editedValue;
                        $(editedTd).addClass("e-updatedtd e-icon e-gupdatenotify");
                        $(editedTd).removeClass("e-validError e-editedbatchcell");
                        ej.createObject(fieldName, cellValue, data);
                        $.inArray(data, this.batchChanges.changed) == -1 && this.batchChanges.changed.push(data);
                        this._enableSaveCancel();
                    }
                }
            }
        },
        setDefaultData: function (defaultData) {
            if (ej.isNullOrUndefined(defaultData)) {
                var fieldNames = [];
                var columns = this.model.columns;
                for (var column = 0; column < this.model.columns.length; column++)
                    fieldNames.push(this.model.columns[column]["field"]);
                if (ej.isNullOrUndefined(this._bulkEditCellDetails._data))
                    this._bulkEditCellDetails._data = [];
                defaultData = {};
                var setter = function (field, value) { ej.createObject(field, value, defaultData) };
                for (var i = 0; i < fieldNames.length; i++) {
                    var index = i, field = fieldNames[i], columnType = columns[i].type, val = ej.getObject(field, this._bulkEditCellDetails._data[0]);
                    var isChild = !ej.isNullOrUndefined(this.model.parentDetails) ? this.model.parentDetails.parentKeyField : null;
                    if (field === isChild)
                        this.model.columns[index].defaultValue = this.model.parentDetails.parentKeyFieldValue;
                    if (!ej.isNullOrUndefined(this.model.columns[index]["defaultValue"])) {
                        setter(field, this.model.columns[index]["defaultValue"]);
                    }
                    else {
                        switch (columnType) {
                            case "number":
                                setter(field, 0);
                                break;
                            case "string":
                                setter(field, null);
                                break;
                            case "boolean":
                                setter(field, false);
                                break;
                            case "object":
                                if ($.isArray(val))
                                    setter(field, new Array());
                                else
                                    setter(field, null);
                            case "datetime":
                            case "date":
                                setter(field, null);
                        }
                    }
                }
                if (!ej.isNullOrUndefined(this.model.queryString)) {
                    var keyField = this.model.foreignKeyField || this.model.queryString;
                    defaultData[keyField] = this.model.parentDetails.parentRowData[this.model.queryString]
                }
            }
            this._bulkEditCellDetails.defaultData = defaultData;
        },
        _bulkDelete: function (index) {
            if (this.model.editSettings.allowDeleting) {
                if (ej.isNullOrUndefined(index))
                    index = this._selectedRow();
                if (index == -1) {
                    alert(this.localizedLabels.DeleteOperationAlert);
                    return;
                }
                var tr, $tr, data, args = {};
                if (this.multiDeleteMode && this.selectedRowsIndexes.length > 1) {
                    data = [];
                    $tr = this.getSelectedRows();
                    Array.prototype.push.apply(data, this.getSelectedRecords());
                    Array.prototype.push.apply(this.batchChanges.deleted, this.getSelectedRecords());
                }
                else
                    tr = this.getRows()[index], $tr = $(tr), data = this.getDataByIndex(index);
                args = {
                    primaryKey: this._primaryKeys,
                    rowIndex: index,
                    rowData: data,
                    row: $tr
                };
                if (this._trigger("beforeBatchDelete", args))
                    return;
				if(this.isejObservableArray)                   
                    this._refreshViewModel(args, "remove");
                if (this.model.isEdit)
                     this.cancelEditCell();
                if ($tr.hasClass("e-insertedrow")) {
                    $tr.remove();
                    index = $.inArray(tr, this._bulkEditCellDetails.insertedTrCollection);
                    if (index != -1) {
                        this._bulkEditCellDetails.insertedTrCollection.splice(index, 1);
                        this.batchChanges.added.splice(index, 1);
                    }
                }
                else {
                    $tr.hide();
					if(args.rowIndex == 0 || $tr.hasClass("e-firstrow")){
						$tr.hasClass("e-firstrow") && this.getContentTable().find("tr").removeClass("e-firstrow");
						this.getContentTable().find("tr:visible").first().addClass("e-firstrow");
					}
                    if (!$.isArray(data))
                        this.batchChanges.deleted.push(data);
                }
                this._gridRows = this.getContentTable().find("td.e-rowcell").closest("tr").toArray();
				if (this.model.allowScrolling)
                  this._refreshScroller(args);
			  this._isBatchDeleteApplied = true;
                this._enableSaveCancel();
                this._selectedRow(-1);
                args = {
                    primaryKey: this._primaryKeys,
                    rowIndex: index,
                    rowData: data
                };
                this._trigger("batchDelete", args);
            }
        },
        _bulkAddRow: function (defaultData) {
            var  $form = $("#" + this._id + "EditForm");
            if ($form.length && !this.editFormValidate())
                return true;
            if (this.model.editSettings.allowAdding) {
                this._isAddNew = true;
                var args = {}, $tr, editCellIndex, rows = this.getRows();
                if (!ej.isNullOrUndefined(defaultData))
                    this._bulkEditCellDetails.defaultData = defaultData;
                ej.isNullOrUndefined(this._bulkEditCellDetails.defaultData) && this.setDefaultData();
                args = {
                    defaultData: $.extend(true, {}, this._bulkEditCellDetails.defaultData),
                    primaryKey: this._primaryKeys,
                };
                if (this._trigger("beforeBatchAdd", args))
                    return;
                $tr = $($.render[this._id + "_JSONTemplate"](args.defaultData)).addClass("e-insertedrow");
                rows != null && $(rows[0]).hasClass("e-alt_row") && $tr.removeClass("e-alt_row");
                if (this.model.editSettings.rowPosition == "top")
                    this.getContentTable().first().find('tbody').first().prepend($tr);
                else if (this.model.editSettings.rowPosition == "bottom")
                    this.getContentTable().first().find('tbody').first().append($tr);
                if (this._gridRecordsCount === 0)
                    this.getContentTable().find("tbody .emptyrecord").first().remove();
                this._gridRows = this.getContentTable().find("td.e-rowcell").closest("tr").toArray();
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    $tr.prepend(ej.buildTag("td.e-indentcell"));
                this._bulkEditCellDetails.insertedTrCollection.push($tr.get(0));
                this.batchChanges.added.push(args.defaultData);
                var rowindex = this._gridRows.length - 1;
                if (this.model.editSettings.rowPosition == "bottom") {
                    editCellIndex = this._findNextEditableCell(0);
                    this.selectRows(rowindex);
                    this.editCell(rowindex, this.model.columns[editCellIndex].field);
                }
                else {
                    editCellIndex = this._findNextEditableCell(0);
                    this.selectRows(0);
                    this.editCell(0, this.model.columns[editCellIndex].field);
                }
				if (this.model.allowScrolling)
                    this._refreshScroller(args);
                $tr.find(".e-rowcell").addClass("e-updatedtd e-icon e-gupdatenotify");
                this._enableSaveCancel();
                args = { defaultData: args.defaultData };
                $.extend(args, {
                    columnObject: this.model.columns[editCellIndex],
                    columnIndex: editCellIndex,
                    row: $tr,
                    primaryKey: this._primaryKeys,
                    cell: $($tr[0].cells[editCellIndex])
                });
                this._trigger("batchAdd", args);
                this._trigger("refresh", args);
            }
        },
        getDataByIndex: function (rowIndex) {
            var $tr = $(this._excludeDetailRows()[rowIndex]), insertedRowIndex, currentRowData, index;
            if ($tr.hasClass("e-insertedrow")) {
                insertedRowIndex = $.inArray($tr[0], this._bulkEditCellDetails.insertedTrCollection);
                return this.batchChanges.added[insertedRowIndex];
            }
            else
                return this._bulkEditCellDetails._data[this.model.editSettings.rowPosition == "top" ? rowIndex - this._bulkEditCellDetails.insertedTrCollection.length : rowIndex];

        },
        
        refreshBatchEditChanges: function () {
            this._bulkEditCellDetails = {
                cellValue: null,
                rowIndex: -1,
                _data: null,
                columnIndex: -1,
                fieldName: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                rowData: null,
                isForeignKey: false
            };
            this.batchChanges = {
                added: [],
                deleted: [],
                changed: []
            };
        },
        refreshBatchEditMode: function () {
            if (this.model.editSettings.editMode == "batch" || this._enableCheckSelect) {
                this.refreshBatchEditChanges();
                this._bulkEditCellDetails._data = $.extend(true, [], this.getCurrentViewData());
            }
        },
        
        batchCancel: function () {
            this.cancelEdit();
        },
        
        batchSave: function () {
            var args = {}, deferedObject, gridObject = this;
			var index=(this.model.editSettings.rowPosition == "top" || this._gridRows == null)?0:this._gridRows.length - 1;
			this._batchCellValidation(index);
            if(!this.saveCell()){
            args["batchChanges"] = this.getBatchChanges();
            if (this._trigger("beforeBatchSave", args))
                return;
            args = {};
            args.requestType = "batchsave";
            this._isAddNew = false;
            this._sendBulkReuqest(this.getBatchChanges(), args);
		  }
        },
        _sendBulkReuqest: function (batchChanges, args) {
            var deferedObject = this._dataManager.saveChanges(batchChanges, this._primaryKeys[0], this.model.query._fromTable, this.model.query), gridObject = this;
            this._isBatchDeleteApplied=false;
			if (this._dataManager instanceof ej.DataManager && !this._dataManager.dataSource.offline) {
                deferedObject.done(function (e) {
                    gridObject._processBindings(args);
                });
                deferedObject.fail(function (e) {
                    var args = { error: e.error };
                    gridObject._trigger("actionFailure", args);
                });
            }
            else
                this._processBindings(args);

        },
        
        getBatchChanges: function () {
            return this.batchChanges;
        },
        
        editCell: function (index, fieldName) {
            if (this.element.ejWaitingPopup("model.showOnInit"))
                return;
            if (this.model.editSettings.allowEditing && $.inArray(fieldName, this._disabledEditableColumns) == -1) {
                var $form = $("#" + this._id + "EditForm");
                this.model.isEdit && this.saveCell();
                if ($.isFunction($.validator) && $form.length && $form.validate().errorList.length)
                    return;
                var $targetTR = $(this._excludeDetailRows()[index]), columnIndex = this.getColumnIndexByField(fieldName), $targetTd = $targetTR.find(".e-rowcell").eq(columnIndex), column = this.model.columns[columnIndex], rowData = this.getDataByIndex(index);
                var args = {
                    validationRules: ej.isNullOrUndefined(column.validationRules) ? {} : $.extend(true, {}, column.validationRules),
                    columnName: column.field,
                    value: ej.getObject(ej.isNullOrUndefined(fieldName) ? "" : fieldName, rowData),
                    rowData: rowData,
                    row: $targetTR,
                    primaryKey: this._primaryKeys,
                    columnObject: column,
                    cell: $targetTd,
                    isForeignKey: !ej.isNullOrUndefined(column.foreignKeyValue) && this.model.editSettings.editMode == "batch" ? true : false,
                }, isEditable = true;
                if (this.model.allowTextWrap)
                    this.element.find(".e-rowcell").removeClass("e-nowrap");
                if (this.model.allowScrolling)
                    this._refreshScroller(args);
                this._batchEditRowData = rowData;
                if (this._trigger("cellEdit", args))
                    return;
                if ($targetTR.hasClass("e-insertedrow")) args.requestType = "add";
                if ($.inArray(fieldName, this._primaryKeys) != -1 || args.columnObject.allowEditing === false || ((args.columnObject.template || args.columnObject.type=="checkbox") && (args.columnObject["allowEditing"] == false || !args.columnObject["field"])) || args.columnObject.commands) {
                    $.extend(this._bulkEditCellDetails, {
                        cellValue: args.value,
                        rowIndex: index,
                        fieldName: fieldName,
                        rowData: args.rowData,
                        columnIndex: columnIndex,
                        isForeignKey: ej.isNullOrUndefined(args.columnObject.foreignKeyValue) ? false : true
                    });
                    isEditable = false;
                }
                if ($targetTR.hasClass("e-insertedrow") && (args.columnObject.isPrimaryKey))
                    isEditable = true;
                if (isEditable) {
                    $.extend(this._bulkEditCellDetails, {
                        rowIndex: index,
                        cellValue: args.value,
                        columnIndex: columnIndex,
                        format: column.format == undefined ? null : column.format,
                        type: column.type,
                        fieldName: fieldName,
                        cellEditType: args.columnObject.editType,
                        rowData: rowData,
                        isForeignKey: ej.isNullOrUndefined(args.columnObject.foreignKeyValue) ? false : true
                    });
                    this._renderBulkEditObject(args, $targetTd);
                    $targetTR.addClass("e-editedrow").addClass("e-batchrow");
                    args.cell.addClass("e-editedbatchcell");
                    if (args.columnObject.editType == "booleanedit")
                        args.cell.addClass("e-boolrowcell");
                }
            }
        },
        _findNextEditableCell: function (columnIndex) {
            var endIndex = this.model.columns.length;
            for (var i = columnIndex; i < endIndex; i++) {
                if (!this.model.columns[i].template && !this.model.columns[i].commands && this.model.columns[i].visible)
                    return i;
            }
            return -1;
        },
        _findNextCell: function (columnIndex, direction, event) {
            var splittedColumn, visibleColumns = [], predicate, rows = this.getRows();
			if (this.model.columns[columnIndex].template) 
                this.model.columns[columnIndex].__isTemplate = true;  
			if(this.model.columns[columnIndex].commands)
				this.model.columns[columnIndex].__isCommand = true; 
			if (!ej.isNullOrUndefined(event) && (event.keyCode == 39 || event.keyCode == 37))
			   predicate = ej.Predicate("visible", "equal", true);
		    else
               predicate = ej.Predicate("visible", "equal", true).and("__isTemplate", "notequal", true).and("__isCommand", "notequal", true).and("allowEditing", "notequal", false).and("isPrimaryKey", "notequal", true);
            splittedColumn = direction == "right" ? this.model.columns.slice(columnIndex) : this.model.columns.slice(0, columnIndex + 1).reverse();
            visibleColumns = ej.DataManager(splittedColumn).executeLocal(ej.Query().where(predicate));
            if (visibleColumns.length == 0 && (!(direction == "left" && this._bulkEditCellDetails.rowIndex == 0) && !(direction == "right" && this._bulkEditCellDetails.rowIndex + 1 == this.getRows().length))) {
                splittedColumn = direction == "right" ? this.model.columns.slice(0, columnIndex) : this.model.columns.slice(columnIndex).reverse();
                visibleColumns = ej.DataManager(splittedColumn).executeLocal(ej.Query().where(predicate));
                this._bulkEditCellDetails.rowIndex = visibleColumns.length && direction == "right" ? this._bulkEditCellDetails.rowIndex + 1 : this._bulkEditCellDetails.rowIndex - 1;
            }
            return visibleColumns.length ? $.inArray(visibleColumns[0], this.model.columns) : -1;
        },
        _moveCurrentCell: function (direction, event) {
            var editCellIndex, rowIndex = this._bulkEditCellDetails.rowIndex, currentRow, $form = $("#" + this._id + "EditForm");
            if (this._bulkEditCellDetails.rowIndex == -1 && this._bulkEditCellDetails.columnIndex == -1)
                return true;
            switch (direction) {
                case "right":
                    if ((this._bulkEditCellDetails.rowIndex == this.getRows().length - 1 && this._bulkEditCellDetails.columnIndex == this.model.columns.length - 1) || (!this.element.is(document.activeElement) && $form.length == 0))
                        return true;
                    if (this._bulkEditCellDetails.columnIndex == this.model.columns.length - 1) {
                        editCellIndex = 0;
                        this._bulkEditCellDetails.rowIndex = this._bulkEditCellDetails.rowIndex + 1;
                    }
                    else
                        editCellIndex = this._bulkEditCellDetails.columnIndex + 1;
                    if ((!ej.isNullOrUndefined(this.model.columns[editCellIndex].template) && ej.isNullOrUndefined(this.model.columns[editCellIndex].field)) || !ej.isNullOrUndefined(this.model.columns[editCellIndex].commands) || this.model.columns[editCellIndex].visible === false || this.model.columns[editCellIndex].allowEditing === false)
                        editCellIndex = this._findNextCell(editCellIndex, direction, event);
                    this._bulkEditCellDetails.rowIndex != rowIndex && this.selectRows(this._bulkEditCellDetails.rowIndex);
                    editCellIndex != -1 && this.editCell(this._bulkEditCellDetails.rowIndex, this.model.columns[editCellIndex].field);
                    break;
                case "left":
                    if ((this._bulkEditCellDetails.rowIndex == 0 && this._bulkEditCellDetails.columnIndex == 0) || (!this.element.is(document.activeElement) && $form.length == 0))
                        return true;
                    if (this._bulkEditCellDetails.columnIndex == 0) {
                        editCellIndex = this.model.columns.length - 1;
                        this._bulkEditCellDetails.rowIndex = this._bulkEditCellDetails.rowIndex - 1;
                        this.selectRows(this._bulkEditCellDetails.rowIndex);
                    }
                    else
                        editCellIndex = this._bulkEditCellDetails.columnIndex - 1;
                    if ((!ej.isNullOrUndefined(this.model.columns[editCellIndex].template) && ej.isNullOrUndefined(this.model.columns[editCellIndex].field)) || !ej.isNullOrUndefined(this.model.columns[editCellIndex].commands) || this.model.columns[editCellIndex].visible === false || this.model.columns[editCellIndex].allowEditing === false)
                        editCellIndex = this._findNextCell(editCellIndex, direction, event);
                    this._bulkEditCellDetails.rowIndex != rowIndex && this.selectRows(this._bulkEditCellDetails.rowIndex);
                    editCellIndex != -1 && this.editCell(this._bulkEditCellDetails.rowIndex, this.model.columns[editCellIndex].field);
                    break;
                case "up":
                    if (this._bulkEditCellDetails.rowIndex == 0)
                        return;
                    editCellIndex = this._bulkEditCellDetails.columnIndex;
                    !this._enableCheckSelect && this.selectRows(this._bulkEditCellDetails.rowIndex - 1);
                    this.editCell(this._bulkEditCellDetails.rowIndex - 1, this.model.columns[this._bulkEditCellDetails.columnIndex].field);
                    break;
                case "down":
                    if (this._bulkEditCellDetails.rowIndex == this.getRows().length - 1) {
                        this.endEdit();
                        return;
                    }
                    editCellIndex = this._bulkEditCellDetails.columnIndex;
                    !this._enableCheckSelect && this.selectRows(this._bulkEditCellDetails.rowIndex + 1);
                    if (this._bulkEditCellDetails.columnIndex != -1) {
                        this.editCell(this._bulkEditCellDetails.rowIndex + 1, this.model.columns[this._bulkEditCellDetails.columnIndex].field);
                        this.selectCells([[this._bulkEditCellDetails.rowIndex, this._bulkEditCellDetails.columnIndex]]);
                    }
                    break;

            }
            var addedRow = !$(this.getRows()[this._bulkEditCellDetails.rowIndex]).hasClass("e-insertedrow");
            if (editCellIndex != -1 && (this.model.columns[editCellIndex].commands || (this.model.columns[editCellIndex].isPrimaryKey && addedRow) || (this.model.columns[editCellIndex].template && this.model.columns[editCellIndex].field == "")))
                this.element.focus();
            return false;
        },
        _renderBulkEditObject: function (cellEditArgs, $td) {
            var $form = ej.buildTag("form", "", {}, { id: this._id + "EditForm" }), $bulkEditTemplate = this._bulkEditTemplate, mappingName = this._id + cellEditArgs.columnObject.field, $element, htmlString, cellData = {};
            ej.createObject(cellEditArgs.columnObject.field, cellEditArgs.value, cellData);
            var args = { requestType: cellEditArgs.requestType, cell:cellEditArgs.cell, columnName:cellEditArgs.columnName,rowData:cellEditArgs.rowData,row:cellEditArgs.row };
            $td.empty();
            if (!$td.parent().is(":last-child")){
                $td.addClass('e-validError');
                $td.removeClass('e-gupdatenotify');
             }
            htmlString = $bulkEditTemplate.find("#" + cellEditArgs.columnObject.field.replace(/[^a-z0-9\s_]/gi, ej.pvt.consts.complexPropertyMerge) + "_BulkEdit").html();
            $element = $($.templates(htmlString).render(cellData));
            if ($element.get(0).tagName == "SELECT") {
                var cellValue = ej.getObject(cellEditArgs.columnObject.field, cellData);
                $element.val(ej.isNullOrUndefined(cellValue) ? "" : cellValue.toString());
                $element.val() == null && $element.val($element.find("option").first().val());
                $element.data('ej-value', cellValue);
            }
            $form.append($element);
            $td.append($form);
            this._setoffsetWidth();
            this._refreshEditForm(args);
            if ($.isFunction($.validator) && !$.isEmptyObject(cellEditArgs.validationRules)) {
                this.initValidator();
                this.setValidationToField(cellEditArgs.columnObject.field, cellEditArgs.validationRules);
            }
            this.model.isEdit = true;
        },
        _triggerConfirm: function (args) {
            if (args !== undefined && args.model.text == this._getDeprecatedLocalizedLabel("OKButton")) {
                if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.BatchSaveConfirm)
                    this.batchSave();
                else if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.ConfirmDelete) {
                    if (this.model.editSettings.editMode == "batch")
                        this._bulkDelete()
                    else {
                        if (this.multiDeleteMode)
                            this._multiRowDelete();
                      else
                        if (!ej.isNullOrUndefined(this._cDeleteData)) {
                            this.deleteRow(this._cDeleteData);
                            this._cDeleteData = null;
                          }
                        else
                            this.deleteRow();
                    }
                }
                else if (this._confirmDialog.find(".e-content").text() == this.localizedLabels.CancelEdit)
                    this.cancelEdit();
                else {
                    this._confirmedValue = true;
                    this._processBindings(this._requestArgs);
                }
				this._isBatchDeleteApplied=false;
				this.clearSelection();
            }
            else {
                if (this._confirmDialog.find(".e-content").text() != this.localizedLabels.BatchSaveConfirm && this._confirmDialog.find(".e-content").text() != this.localizedLabels.ConfirmDelete) {
                    if (this._confirmDialog.find(".e-content").text() != this.localizedLabels.CancelEdit) {
                        switch (this._requestArgs.requestType) {
                            case "grouping":
                                this.model.groupSettings.groupedColumns.pop();
                                break;
                            case "ungrouping":
                                this.model.groupSettings.groupedColumns.push(this._requestArgs.columnName);
                                break;
                            case "sorting":
                                this._cSortedDirection = this._cSortedColumn = null;
                                break
                            case "filtering":
                                this.model.filterSettings.filteredColumns.reverse().splice(0, this._requestArgs.currentFilterObject);
                                this.model.filterSettings.filteredColumns.reverse();
                                break;
                            case "paging":
                                this._currentPage(this._requestArgs.previousPage);
                                this.getPager().ejPager("model.currentPage", this._requestArgs.previousPage);
                                break

                        }
                    }
                }
                this._confirmedValue = false;
            }
            this._requestArgs = null;
            this._confirmDialog.ejDialog("close");
        },
        _batchCellValidation:function(index) {
            var $row = this.getRowByIndex(index),i;
            if (this.model.editSettings.editMode=="batch" && this.model.isEdit && $row.hasClass('e-insertedrow') ){              
                for (i = 0; i < this._validatedColumns.length; i++) {
                      var colindex = this.getColumnIndexByField(this._validatedColumns[i])
                           if (!this.editFormValidate())
                                 return true;                         
                 this.editCell(index, this.model.columns[colindex].field);                          
                    }
               }
         },
        _saveCellHandler: function (e) {
            var $target = $(e.target);
            e.stopPropagation();
            var index=(this.model.editSettings.rowPosition == "top" || this._gridRows == null)?0:this._gridRows.length - 1;
            if ($target.closest(".e-popup").length == 0 && $target.closest(".e-rowcell").find("#" + this._id + "EditForm").length == 0) {
                if ($(this.getRows()).hasClass("e-insertedrow"))
                    this._batchCellValidation(index);
                this.saveCell();
            }
        },
        initValidator: function () {
            var gridObject = this, elements = this.model.scrollSettings.frozenColumns > 0 || this.model.editSettings.showAddNewRow ? this.element.find(".gridform") : $("#" + this._id + "EditForm");
            for (var i = 0; i < elements.length ; i++) {
                elements.eq(i).validate({
                    ignore: ".e-hide",
                    errorClass: 'e-field-validation-error',
                    errorElement: 'div',
                    wrapper: "div",
                    errorPlacement: function (error, element) {
                        gridObject._renderValidator(error, element);
                    },

                });
            }
        },
        _renderValidator: function (error, element) {          
            if (element.is(":hidden"))
                element = element.siblings("input:visible");
            if (!element.length)
                return;
            var $td = element.closest(".e-rowcell"), $container = $(error).addClass("e-error"),
             $tail = ej.buildTag("div.e-errortail e-toparrow");
            var isScrolling = this.model.isResponsive || this.model.allowScrolling;
            var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null; var scrollTop = 0;
            $td = !$td.length ? $td = element.closest("td") : $td;
            $td.find(".e-error").remove();

            if (element.parent().hasClass("e-in-wrap"))
                $container.insertAfter(element.closest(".e-widget"));
            else
                $container.insertAfter(element);
            var doInvert = (this.model.scrollSettings.frozenRows > 0 && (this._currentTrIndex >= this.model.scrollSettings.frozenRows)) ? true : false
            var operation = doInvert ? "append" : "prepend";
            $container[operation]($tail);
            if (isScrolling && (!ej.isNullOrUndefined(scrollObj) && (scrollObj._hScrollbar || scrollObj._vScrollbar))) {
                $td.addClass("e-validError");
                scrollTop = scrollObj._hScrollbar ? scrollObj._hScrollbar.element[0].offsetTop : 0;
            }
            var heightExpected = $td[0].offsetTop + $td[0].offsetHeight + error[0].offsetHeight;
            var eleExceed = false, hScrollerSize = scrollObj && scrollObj._hScrollbar ? scrollObj._hScrollbar.model.height : 0;
            if ((scrollObj && scrollObj.isHScroll() && heightExpected > scrollTop) || (heightExpected > (this.getContent()[0].offsetTop + this.getContent().find(".e-content").height())))
                eleExceed = true;
            if (!isScrolling || !(!ej.isNullOrUndefined(scrollObj) && (scrollObj._hScrollbar || scrollObj._vScrollbar))) {
                var rect = error[0].getBoundingClientRect();
                var errorWidth = rect ? rect.width : error.width();
                if (errorWidth < $td.width())
                    error.width(errorWidth);
                else
                    error.width($td.width());
                element.closest(".e-validError").removeClass("e-validError");
            }
            if (this.model.enableRTL)
                this.model.editSettings.editMode != "dialog" && $container.offset({ top: element.offset().top + element.height() });
            else
                this.model.editSettings.editMode != "dialog" && $container.offset({ left: element.offset().left, top: element.offset().top + element.height() });
            if (this.model.scrollSettings.frozenRows <= 0 && $.inArray(this.model.editSettings.editMode, ["externalform", "externalformtemplate", "dialog", "dialogtemplate"]) == -1) {
                var content = this.getContent();
                var scrollContent = content.find(".e-content");
                var cntHeight = scrollContent.height();
                var contentTop = content[0].offsetTop;
                if (eleExceed && scrollObj != null && scrollObj._vScrollbar && (this.model.scrollSettings.frozenColumns)) {
                    var val = scrollObj._vScrollbar.model.value - (heightExpected - (contentTop + scrollContent[0].scrollHeight));
                    var contentScrollHeight = contentTop + scrollContent[0].scrollHeight;
                    var contentHeight = contentTop + cntHeight;
                    if ((!this.model.scrollSettings.frozenColumns && heightExpected > contentScrollHeight) || (this.model.scrollSettings.frozenColumns && heightExpected > contentHeight)) {
                        scrollObj._vScrollbar.model.maximum += (heightExpected - (contentTop + cntHeight));;
                        scrollObj._vScrollbar.refresh(true);
                    }
                    if (this.model.scrollSettings.frozenColumns) {
                        var movableContent = this.getContent().find(".e-movablecontent");
                        movableContent.height(movableContent[0].scrollHeight);
                    }
                    scrollObj.scrollY(element.offset().top - contentTop + scrollContent[0].scrollTop);
                }
                else if (eleExceed && isScrolling && scrollObj != null) {
                    if (!scrollObj.isVScroll()) {
                        var eleHeight = heightExpected - (contentTop + cntHeight);
                        scrollContent.height(cntHeight + eleHeight);
                    }
                    else if (scrollObj.isVScroll()) {
                        scrollObj.refresh();
                        this._showHideScroller();
                        if (scrollObj._vScroll) {
                            var value = scrollObj._vScrollbar.model.value + (heightExpected - (contentTop + cntHeight + hScrollerSize - hScrollerSize));
                            scrollObj.scrollY(value);
                        }
                    }
                }
            }
            else if (doInvert) {
				if(eleExceed){
					var top = $container.css('top');
					$tail.addClass("e-bottomarrow");
					$container.css({
						'bottom': top,
						'top': 'auto'
					});
				}
				else{
					$tail.prependTo($tail.parent());
				}
            }
            $container.show("slow");
        },

        setValidation: function () {
            for (var i = 0; i < this.model.columns.length; i++) {
                if (!ej.isNullOrUndefined(this.model.columns[i]["validationRules"])) {
                    this.setValidationToField(this.model.columns[i].field, this.model.columns[i].validationRules);
                }
            }
        },
        
        setValidationToField: function (name, rules) {
            var fName = name, ele;
            if (!ej.isNullOrUndefined(name))
                fName = fName.replace(/[^a-z0-9\s_]/gi, '');
            if (this.model.editSettings.editMode == "batch")
                var form = this.element.find("#" + this._id + "EditForm");
            else if(this.model.editSettings.showAddNewRow)
                var form = $(this.getRows()).hasClass("e-editedrow") ? this.element.find(".e-editedrow .gridform") : this.element.find(".e-addedrow .gridform");
            else
                var form = this.element.find(".gridform");
            ele = /^[a-zA-Z0-9- ]*$/.test(name) ?  form.find("[name=" + fName + "]") : form.find("#" + this._id + fName);
            if (!ej.isNullOrUndefined(ele.attr("id")) && ele.attr("id").indexOf("hidden") != -1)
                ele = form.find("#" + this._id + fName);
            if(ele.length == 0) 
               ele = form.find("#" + fName);
            if (rules["regex"]) {
                rules[name + "regex"] = rules["regex"]; delete rules["regex"];
                $.validator.addMethod(fName + "regex", function (value, element, options) {
                    var ptn = options instanceof RegExp ? options : new RegExp(options);
                    return ptn.test(value);
                }, ej.getObject("messages.regex", rules) || this.getColumnByField(name).headerText + " should match the given pattern");
            }
            !ele.attr("name") && ele.attr("name", name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").validate();
            validator.settings.messages[name] = validator.settings.messages[name] || {};
            if (!ej.isNullOrUndefined(rules["required"])) {
                if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"]))
                    var message = rules["messages"]["required"];
                else
                    var message = $.validator.messages.required;
                if (message.indexOf("This field") == 0)
                    message = message.replace("This field", this.getColumnByField(name).headerText);               
                validator.settings.messages[name]["required"] = message;
                if (ele.hasClass("e-datepicker"))
                    ele.ejDatePicker({watermarkText: ""});
            }
        },
        _renderConfirmDialog: function () {
            var $contentDiv = ej.buildTag('div.e-content', this.localizedLabels.BatchSaveConfirm)
            , $buttons = ej.buildTag('span.e-buttons', '<input type="button" class="e-flat e-btnsub" id=' + this._id + "ConfirmDialogOK" + ' value="' + this._getDeprecatedLocalizedLabel("OKButton") + '" /> '
                + "<input type='button' class='e-flat e-btncan' id=" + this._id + 'ConfirmDialogCancel' + " value='" + this.localizedLabels.CancelButton + "' />");

            this._confirmDialog = ej.buildTag('div#' + this._id + 'ConfirmDialog', { float: "left" });
            this._confirmDialog.append($contentDiv).append($buttons);
            this.element.append(this._confirmDialog);
            $buttons.find("input").ejButton({
                cssClass: this.model.cssClass,
                showRoundedCorner: true,
                size: "mini",
                click: $.proxy(this._triggerConfirm, this)
            });
            this._renderFDialog(this._id + 'ConfirmDialog');
            this._confirmDialog.ejDialog({ showOnInit: false, width: "auto", minWidth: 0, minHeight: 0, enableModal: true });
        },
        _unboundClickHandler: function (e) {
            var $target = $(e.target).closest("button");
            if (($target.hasClass("e-button") && ($target.hasClass("e-disable") || $target.prop("disabled"))) || $target.closest(".e-grid").attr("id") !== this._id) return;
            var $editTrLen = 0, params = {};
            if ($(e.target).hasClass("e-unboundcelldiv"))
                return;
            var index = $target.hasClass("e-savebutton") ? this.getIndexByRow($(".e-editedrow")) : this.getIndexByRow($target.closest("tr"));
            if (this.model.isEdit && (!this._isLocalData || this._isRemoteSaveAdaptor) && $target.hasClass("e-editbutton")) {
                this._unboundRow = $target.closest("tr");
                return;
            }
            var rowData = this._currentJsonData[index];
            var btnObj = $($target).ejButton("instance");
			 if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlinetemplate")
                $editTrLen = $("#" + this._id).find(".e-editedrow").length;
            this.model.allowSelection && !this.model.isEdit && this.selectRows(this.getIndexByRow($target.closest("tr")) - $editTrLen);
            if ($target.hasClass("e-cancelbutton"))
                this.model.isEdit = false;
            $.isFunction($.fn.ejDatePicker) && $("#" + this._id + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            if ($target.hasClass("e-editbutton") && this.model.editSettings.editMode != "batch") {
                if (this.model.isEdit)
                    this.cancelEdit();
                var $tr = this.getRowByIndex(index);
                this.startEdit($tr);
            } else if ($target.hasClass("e-deletebutton")) {
                var $tr = this.getRowByIndex(index);
                if (this.model.editSettings.showDeleteConfirmDialog && !this._isUnboundColumn) {
                    this._toolbarOperation(this._id + "_delete");
                    return;
                }
                this.deleteRow($tr);
            }
            else if ($target.hasClass("e-savebutton")) {
                this.endEdit();
                rowData = this._currentJsonData[index];
            }
            else if ($target.hasClass("e-cancelbutton"))
                this.cancelEdit();
            params = { rowIndex: index, data: rowData, buttonModel: btnObj.model, commandType: $target.val() };
            if (ej.raiseWebFormsServerEvents) {
                var serverArgs = { model: this.model, originalEventType: "commandButtonClick" };
                var clientArgs = params;
				if(!ej.isNullOrUndefined(this.model.serverEvents) && $.inArray("commandButtonClick",this.model.serverEvents) != -1)
                  ej.raiseWebFormsServerEvents("commandButtonClick", serverArgs, clientArgs);
            }
        },
          
        addRecord: function (data, serverChange) {
            if (this.model.editSettings.allowAdding && (this.element.find(".e-gridcontent .gridform").length == 0)) {
            if (data) {
                if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                    var $addRow = ej.buildTag('tr.e-addedrow');
                    this.getContentTable().find('tbody').first().prepend($addRow);
                }
                var args = { data: data };
                args.action = "add";
                args.selectedRow = this._selectedRow();
                this._cAddedRecord = data;
                args.requestType = ej.Grid.Actions.Save;
                this._updateAction(args);
                args.selectedRow  != -1 && this.selectRows( args.selectedRow + 1)
                if (this._isUnboundColumn)
                    this._refreshUnboundTemplate(this.getContentTable());
                if (!serverChange) {
                    if ((this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") && this.model.allowPaging && this.model.pageSettings.pageSize < this.model.currentViewData.length && this.model.groupSettings.groupedColumns.length == 0 && !this.model.editSettings.showAddNewRow)
                        this.getContentTable().get(0).lastChild.removeChild(this.getContentTable().get(0).lastChild.lastChild);
                }
            } else
                    this._startAdd();
            }
        },
        
        updateRecord: function (keyField, data, action) {
            this._updateDeleteRecord(keyField, data, "update");
        },
        _updateDeleteRecord: function (keyField, data, action) {
            var dataMgr = ej.DataManager(this._currentJsonData), dataFilter = [], index, $row, $newrow;
            if (!ej.isNullOrUndefined(keyField))
                dataFilter = dataMgr.executeLocal(ej.Query().where(keyField, ej.FilterOperators.equal, ej.getObject(keyField,data)));
            if (dataFilter.length) {
                index = $.inArray(dataFilter[0], this._currentJsonData);
                var args = { data: data, rowData: data, requestType: ej.Grid.Actions.Save, previousData: dataFilter[0], rowIndex: index };
                var foreignKeyData = this._getForeignKeyData(args.data);
                if (!ej.isNullOrUndefined(foreignKeyData))
                    args.foreignKeyData = foreignKeyData;
                if ($(document.activeElement).closest('td.e-checkcell'))
                    args.checkboxTarget = document.activeElement;
                this._trigger("actionBegin", args);
                if (index != -1) {
                    $row = this.getRowByIndex(index);
                    if (action == "update") {
                        ej.copyObject(dataFilter[0], data);
                        $newrow = $($.render[this._id + "_JSONTemplate"](dataFilter));
                        $row.hasClass("e-alt_row") ? $newrow.addClass("e-alt_row") : $newrow.removeClass("e-alt_row");
                        $row.replaceWith($newrow);
                        if (this._isUnboundColumn)
                            this._refreshUnboundTemplate(this.getContentTable());
                        if (this.model.editSettings.editMode == 'batch')
                            this.batchChanges.changed.push(dataFilter[0]);
                        else {
                            var promise = this._dataManager[action](keyField, data);
                            var proxy = this;
                            if (promise && $.isFunction(promise.promise)) {
                                promise.done(function (e) {
                                    if (proxy.model.editSettings.editMode != 'batch' && (proxy.model.sortSettings.sortedColumns.length || proxy.model.summaryRows.length > 0 || proxy.model.groupSettings.groupedColumns.length || !ej.isNullOrUndefined(proxy._searchCount) || proxy.filterColumnCollection.length))
                                        proxy._processBindings(args);
                                    else
                                        proxy._trigger("actionComplete", args);
                                });
                                promise.fail(function (e) {
                                    proxy._trigger("actionFailure", args);
                                });
                            }
                            else {
                                if (proxy.model.editSettings.editMode != 'batch' && (proxy.model.sortSettings.sortedColumns.length || proxy.model.summaryRows.length > 0 || proxy.model.groupSettings.groupedColumns.length || !ej.isNullOrUndefined(proxy._searchCount) || proxy.filterColumnCollection.length))
                                    proxy._processBindings(args);
                                else
                                    proxy._trigger("actionComplete", args);
                            }
                        }
                        if (this._isMapSelection) {
                            this._selectionByGrid = true;
                            this.multiSelectCtrlRequest = true;
                            if(data[this._selectionMapColumn] && !(proxy.model.editSettings.editMode != 'batch' && (proxy.model.sortSettings.sortedColumns.length || proxy.model.summaryRows.length > 0 || proxy.model.groupSettings.groupedColumns.length || !ej.isNullOrUndefined(proxy._searchCount) || proxy.filterColumnCollection.length)))
                                this.selectRows(index)
                            else
                                this.clearSelection(index);
                            this._selectionByGrid = false;
                        }
                    }
                    else {
                        if ($.inArray(index, this.selectedRowsIndexes)==-1) 
                            this.selectedRowsIndexes.push(index);
                        this.deleteRow($row);
                    }
                    if (this.model.editSettings.editMode == 'batch') {
                        this.batchSave();
                        this._confirmedValue=true;
                    }
                }
            }
            else {
                if (this.model.editSettings.editMode == 'batch') {
                    this.batchChanges[action == "update" ? "changed":"deleted"].push(data);
                    this.batchSave();
                    this._confirmedValue=true;
                }
                else
                    this._dataManager[action](keyField, data);
            }
           
        },
        
        deleteRecord: function (keyField, data) {
            this._updateDeleteRecord(keyField, data, "remove");
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.sort = {
        _addSortElementToColumn: function (field, direction) {
            var duplicateColumn = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("field", "equal", field)), imageDirection;
            if (duplicateColumn.length > 1)
                var column = this.getColumnByHeaderText(this._$curSElementTarget.text());
            else
                var column = this.getColumnByField(field);
            if (ej.isNullOrUndefined(column))
                return;
            var index = $.inArray(column, this.model.columns);
            var sortcolumn = this.getsortColumnByField(field);
            var sortindex = $.inArray(sortcolumn, this.model.sortSettings.sortedColumns);
            var $headerCell = this.getHeaderTable().find("thead tr:not('.e-stackedHeaderRow')").find(".e-headercell").not(".e-detailheadercell").eq(index);
            var $headerCellDiv = $headerCell.find(".e-headercelldiv");
            var $filterset = $headerCell.find(".e-filterset");
            var $togglegroup = $headerCell.find(".e-gridgroupbutton");
            if($filterset.length && $togglegroup.length) {
              if(!this.model.enableRTL) {
                $headerCell.addClass("e-headercellsortgroupfilter");
                $filterset.addClass("e-sortfiltergroupicon");
                $togglegroup.addClass("e-togglesortgroupfilter");
              }
              else 
                $headerCellDiv.addClass("e-headercelldivsortgroupfilter");
            }
            else if($filterset.length) {
                if(!this.model.enableRTL) {
                    $headerCell.addClass("e-headercellsortfilter");
                    $filterset.addClass("e-sortfiltericon");
                }
                else
                    $headerCellDiv.addClass("e-headercellsortfilter");
            }
            else if($togglegroup.length) {
                if(!this.model.enableRTL) {
                    $headerCell.addClass("e-headercellsortfilter");
                    $togglegroup.addClass("e-sortgroupicon");
                }
                else
                    $headerCellDiv.addClass("e-headercellsortfilter");
                if(this.model.enableRTL && !$filterset.length) 
                    $togglegroup.addClass("e-rtltoggle");
            }
            else
                $headerCell.addClass("e-headercellsort");
            direction = ej.isNullOrUndefined(direction) ? "ascending" : direction.toLowerCase();
            $headerCell.find(".e-ascending,.e-descending").remove();
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[data-ej-mappingname='" + field + "']").find(".e-ascending,.e-descending").not(".e-ungroupbutton").remove();
            imageDirection = direction != "descending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
            var opacity = 1;
            if (this.model.allowSorting && this.model.allowMultiSorting && this.model.sortSettings.sortedColumns.length > 1) {
                for (var i = 1; i <= sortindex; i++) {
                    opacity = opacity + 1;
                }
                if ($headerCellDiv.css("text-align") == "right") {
                    $headerCellDiv.prepend(this._createSortNumber(opacity, $headerCellDiv).addClass("e-sortnumber"));
                    $headerCell.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
                }
                else {
                    $headerCellDiv.prepend(this._createSortNumber(opacity, $headerCellDiv).addClass("e-sortnumber"));
                    $headerCell.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
                }
            }
            else
                $headerCell.append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
           if(this.model.enableRTL) {
               if($filterset.length && $togglegroup.length)
                    $headerCell.find(".e-ascending,.e-descending").addClass("e-rtlsortfiltertoggle");
               else if($filterset.length || $togglegroup.length)
                    $headerCell.find(".e-ascending,.e-descending").addClass("e-rtlgrouporfilter");
               else
                    $headerCell.find(".e-ascending,.e-descending").addClass("e-rtlsortadjust");
            }
            else if(!this.model.enableRTL && !$filterset.length && !$togglegroup.length)
                $headerCell.find(".e-ascending,.e-descending").addClass("e-sortadjust");
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[data-ej-mappingname='" + field + "']").append(this._createSortElement().addClass("e-" + (direction || "ascending") + " " + imageDirection));
            $headerCellDiv.parent().attr("aria-sort", direction);
        },
        _removeSortElementFromColumn: function (field) {
            var column = this.getColumnByField(field);
            var index = $.inArray(column, this.model.columns);
            var $headerCellDiv = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell").eq(index).find(".e-headercelldiv");
            $headerCellDiv.find(".e-ascending,.e-descending").remove();
            $headerCellDiv.parent().prop("aria-sort",false);
        },
        _sortCompleteAction: function (args) {
            var imageDirection, prevCol;
            var $columnheader = this.getHeaderTable().find(".e-columnheader");
            prevCol = this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-ascending,.e-descending,.e-number").parent().attr('data-ej-mappingname');
            $columnheader.find(".e-headercell")
                    .find(".e-ascending,.e-descending,.e-number").remove();
            var $filterset = $columnheader.find(".e-filterset");
            var $togglegroup = $columnheader.find(".e-gridgroupbutton");
            if($filterset.length || $togglegroup.length)  {
                $columnheader.find(".e-sortfiltericon").removeClass("e-sortfiltericon");
                $columnheader.find(".e-headercellsortfilter").removeClass("e-headercellsortfilter");
                $columnheader.find(".e-sortgroupicon").removeClass("e-sortgroupicon");
                $columnheader.find(".e-headercellsortgroupfilter").removeClass("e-headercellsortgroupfilter");
                $columnheader.find(".e-headercelldivsortgroupfilter").removeClass("e-headercelldivsortgroupfilter");
                $columnheader.find(".e-sortfiltergroupicon").removeClass("e-sortfiltergroupicon");
                $columnheader.find(".e-togglesortgroupfilter").removeClass("e-togglesortgroupfilter");
            }
            else
                $columnheader.find(".e-headercellsort").removeClass("e-headercellsort");
            $(this.getHeaderTable().find(".e-columnheader").find(".e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell,.e-hide)")[this.getColumnIndexByField(prevCol)]).removeAttr("aria-sort");
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this.element.find(".e-groupdroparea").find("div[data-ej-mappingname='" + args.columnName + "']").find(".e-ascending,.e-descending,.e-number").not(".e-ungroupbutton").remove();
            this.getHeaderTable().find("[aria-sort]").prop("aria-sort",false);
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (this.model.groupSettings.groupedColumns.length && this._$curSElementTarget != null) {
                var $element = this._checkEinGroupDrop($.trim(this._$curSElementTarget.attr("data-ej-mappingname")));
                if (!ej.isNullOrUndefined($element)) {
                    imageDirection = (ej.isNullOrUndefined(args.columnSortDirection) || args.columnSortDirection == "" ? this.getsortColumnByField(this._$curSElementTarget.attr("data-ej-mappingname")).direction.toLowerCase() : args.columnSortDirection) == "ascending" ? "e-rarrowup-2x" : "e-rarrowdown-2x"
                    $element.find(".e-ascending,.e-descending").removeClass().addClass("e-icon e-" + (ej.isNullOrUndefined(args.columnSortDirection) || args.columnSortDirection == "" ? this.getsortColumnByField(this._$curSElementTarget.attr("data-ej-mappingname")).direction.toLowerCase() : args.columnSortDirection) + " " + imageDirection);
                }
            }
            this.multiSortRequest = false;
            if (!this.model.allowScrolling || !this.initialRender || this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0)
                this.setWidthToColumns();
        },
        
        removeSortedColumns: function (fieldName) {
            if ($.isArray(fieldName)) {
                for (var i = 0; i < fieldName.length; i++) {
                    this._removeSortedColumnFromCollection(fieldName[i]);
                }
            }
            else
                this._removeSortedColumnFromCollection(fieldName);
            this.multiSortRequest = true;
            this.sortColumn(null, null);
        },
        _removeSortedColumnFromCollection: function (fieldName) {
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == fieldName) {
                    this.model.sortSettings.sortedColumns.splice(i, 1);
                    break;
                }
            }
        },
        
        clearSorting: function () {
            var proxy = this;
            this.model.sortSettings.sortedColumns = $.grep(this.model.sortSettings.sortedColumns, function (value, index) {
                if ($.inArray(value.field, proxy.model.groupSettings.groupedColumns) != -1)
                    return true;
                return false;
            });
            this._$prevSElementTarget = null;
            this._$curSElementTarget = null;
            this.refreshContent();
        },
        
        sortColumn: function (columnName, columnSortDirection) {
            if (!this.model.allowSorting || $.inArray(columnName, this._disabledSortableColumns) != -1 || (columnName != null && columnName.length == 0))
                return;
            var args = {};
            if (!this.multiSortRequest) {
                var proxy = this;
                this.model.sortSettings.sortedColumns = $.grep(this.model.sortSettings.sortedColumns, function (value, index) {
                    if ($.inArray(value.field, proxy.model.groupSettings.groupedColumns) != -1)
                        return true;
                    return false;
                });
            }
            args.requestType = ej.Grid.Actions.Sorting;
            this._cSortedColumn = args.columnName = columnName;
            this._cSortedDirection = args.columnSortDirection = ej.isNullOrUndefined(columnSortDirection) ? ej.sortOrder.Ascending : columnSortDirection.toLowerCase();
            if (this._cSortedColumn !== null) {
                this._removeSortedColumnFromCollection(columnName);
                this.model.sortSettings.sortedColumns.push({ field: this._cSortedColumn, direction: this._cSortedDirection });
            }
            var returnValue = this._processBindings(args);
            if (returnValue)
                this._cSortedDirection = this._cSortedColumn = null;
            this._primaryKeyValues = [];
        },
        _createSortElement: function () {
            return ej.buildTag('span.e-icon', "&#160;");
        },
        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-gridpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSorting) {
                var $selElement = ej.buildTag("span.e-sortdirect e-icon");
                $content.append($selElement);
            }
            if (this.model.selectionType == "multiple") {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
        },

    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.filter = {

        getFilterBar: function () {
            return this._gridFilterBar;
        },

        setGridFilterBar: function (value) {
            this._gridFilterBar = value;
        },

        filterColumn: function (fieldName, filterOperator, filterValue, predicate, matchcase, actualFilterValue, actualOperator) {
            if (!this.model.allowFiltering)
                return;
            var column = this.getColumnByField(fieldName), _format;
            if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate) && column.type == "boolean" && filterValue == "true" || filterValue == "false")
                filterValue = JSON.parse(filterValue);
            if (column && ej.isNullOrUndefined(column.format)) {
                if (column.type == "date")
                    _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                else if (column.type == "datetime")
                    _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
            }
            else if (column)
                _format = column.format.replace("{0:", "").replace('}', "");
            if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate) && (column.type == "date" || column.type == "datetime") && filterValue.length > 0) {
                filterValue = ej.parseDate(filterValue, _format, this.model.locale);
            }
            var filterCollection = [];
            if (typeof (fieldName) == "object")
                filterCollection = fieldName;
            else
                filterCollection.push({ field: fieldName, operator: filterOperator, value: filterValue, predicate: predicate, matchcase: matchcase, actualFilterValue: actualFilterValue });

            for (var i = 0; i < filterCollection.length; i++) {
                var fieldName = filterCollection[i].field, filterOperator = filterCollection[i].operator,
                filterValue = filterCollection[i].value, predicate = filterCollection[i].predicate,
                matchcase = !ej.isNullOrUndefined(filterCollection[i].matchcase) ? filterCollection[i].matchcase : false, actualFilterValue = filterCollection[i].actualFilterValue;
                var args = {};
                args.requestType = ej.Grid.Actions.Filtering;
                args.currentFilterObject = [];
                this._$curFieldName = fieldName;
                if (!$.isArray(filterOperator))
                    filterOperator = $.makeArray(filterOperator);
                if (!$.isArray(filterValue))
                    filterValue = $.makeArray(filterValue);
                if (!$.isArray(predicate))
                    predicate = $.makeArray(predicate);
                var firstLoop = false;
                var filterCol = this._filterCollection;
                this._currentFilterColumn = this.getColumnByField(fieldName);
                for (var index = 0; index < filterOperator.length; index++) {
                    var filterObject = {
                        field: fieldName,
                        operator: filterOperator[index],
                        value: filterValue[index],
                        matchcase: matchcase,
                        predicate: predicate[index],
                        actualFilterValue: ej.getObject("value", actualFilterValue),
                        actualOperator: ej.getObject("operator", actualFilterValue)
                    };
                    var predicated = ej.getObject("ejpredicate", actualFilterValue);
                    if (predicated)
                        filterObject = predicated;
                    if ((this._$colType == null || this.model.filterSettings.filterType == "filterbar") && !ej.isNullOrUndefined(this._currentFilterColumn))
                        this._$colType = this._currentFilterColumn.type;
                    if (this.model.filterSettings.filteredColumns.length == 0 && filterObject.value !== "") {
                        if ((this._$colType == "date" || this._$colType == "datetime") && this.model.filterSettings.filterType !== "excel" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                            this._setDateFilters(filterObject);
                        else
                            this.model.filterSettings.filteredColumns.push(filterObject);
                    } else {
                        var proxy = this;
                        if (!firstLoop) {
                            var dataManger = ej.DataManager(this.model.filterSettings.filteredColumns);
                            var query = new ej.Query().where("field", ej.FilterOperators.equal, filterObject.field);
                            var object = dataManger.executeLocal(query);
                            for (var j = 0; j < object.length; j++) {
                                var objectIndex = $.inArray(object[j], this.model.filterSettings.filteredColumns)
                                if (objectIndex != -1)
                                    this.model.filterSettings.filteredColumns.splice(objectIndex, 1);
                            }
                        }
                        if (filterObject.value !== "") {
                            if ((this._$colType == "date" || this._$colType == "datetime") && this.model.filterSettings.filterType !== "excel" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                                this._setDateFilters(filterObject);
                            else
                                this.model.filterSettings.filteredColumns.push(filterObject);
                        }
                    }
                    firstLoop = true;
                    args.currentFilterObject.push(filterObject);
                }
                args.filterCollection = this.model.filterSettings.filteredColumns;
                args.currentFilteringColumn = fieldName;
                var returnValue = this._processBindings(args);
                if (returnValue) {
                    this.model.filterSettings.filteredColumns.reverse().splice(0, filterOperator.length);
                    this.model.filterSettings.filteredColumns.reverse();
                }
                if (this.model.filterSettings.filterType == "filterbar") {
                    var filterBarCell = this.getHeaderTable().find("#" + fieldName.replace(/[^a-z0-9|s\_.]/gi, '') + "_filterBarcell");
                    if (filterBarCell.val() == "" || (filterBarCell.val() != filterValue) && !this._fltrBarcell) {
                        if (filterValue[0] instanceof Date)
                            filterBarCell.val(ej.format(filterValue[0], _format, this.model.locale));
                        else
                            filterBarCell.val(filterValue[0]);
                        this._currentFilterbarValue = filterValue;
                        this.filterStatusMsg = "";
                        this._showFilterMsg();
                    }
                }
                if (!ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.filterBarTemplate)) {
                    this.filterStatusMsg = "";
                    this._currentFilterbarValue = args.currentFilterObject[0].value;
                    if (this._oldFilterColumn != column && (this.filterColumnCollection.length > 0 && $.inArray(column, this.filterColumnCollection) == -1))
                        this.filterColumnCollection.push(column);
                    this._oldFilterColumn = this._currentFilterColumn = column;
                    this._showFilterMsg();
                }
                this._fltrBarcell = false;
            }
        },

        search: function (searchString) {
            var args = {};
            if ($("#" + this._id + "_search").find("input").val() != searchString);
            $("#" + this._id + "_search").find("input").val(searchString);
            args.requestType = ej.Grid.Actions.Search;
            args.keyValue = searchString;
            this.model.searchSettings.fields = this.model.searchSettings.fields.length != 0 ? this.model.searchSettings.fields : this.getColumnFieldNames();
            if (searchString != "" || this.model.searchSettings.key != "") {
                this.model.searchSettings.key = searchString.toLowerCase() == this.localizedLabels.True.toLowerCase() ? "true" : searchString.toLowerCase() == this.localizedLabels.False.toLowerCase() ? "false" : searchString;
                this._processBindings(args);
            }
            this._primaryKeyValues = [];
        },
        _filterBarHandler: function (e) {
            var keycode = e.keyCode, $target = $(e.target);
            if ($target.closest(".e-grid").attr("id") !== this._id)
                return;
            if ((this.model.filterSettings["filterBarMode"] == "immediate" || keycode == 13) && keycode != 9) {
                var $target = $(e.target);
                this.filterStatusMsg = "";
                var fieldName = $target.prop("id").replace("_filterBarcell", "");
                var column;
                for (var k = 0; k < this.model.columns.length; k++) {
                    if (!ej.isNullOrUndefined(this.model.columns[k].foreignKeyValue) && fieldName.indexOf("_" + this.model.columns[k].foreignKeyValue) != -1) {
                        column = this.model.columns[k];
                        break;
                    }
                    else
                        if (this.model.columns[k].field.replace(/[^a-z0-9|s\_.]/gi, '') == fieldName) {
                            column = this.model.columns[k];
                            break;
                        }
                }
                if (column == null)
                    return;
                this._currentFilterColumn = column;
                this._$curFieldName = column.field;
                if (this._currentFilterColumn != this._oldFilterColumn)
                    this.filterValueOldLength = 0;
                this._currentFilterbarValue = $target.val().toLowerCase() == this.localizedLabels.True.toLowerCase() ? "true" : $target.val().toLowerCase() == this.localizedLabels.False.toLowerCase() ? "false" : $target.val();
                this.filterValueCurrentLength = this._currentFilterbarValue.length;
                if (((this.filterValueCurrentLength == 0 && this.filterValueOldLength == 0) || this._currentFilterbarValue == this.OldfilterValue) && this._currentFilterColumn == this._oldFilterColumn && !this.model.scrollSettings.enableVirtualization) {
                    this._showFilterMsg();
                    return;
                }
                this._skipFilterProcess = this._checkForSkipInput();
                if (!this._skipFilterProcess) {
                    this._processFilter(e);
                } else {
                    if (this._currentFilterColumn.type == "string") {
                        this.filterStatusMsg = "Invalid Filter Data";
                        this._showFilterMsg();
                    } else {
                        this._skipFilterProcess = false;
                        if (!this.model.scrollSettings.enableVirtualization)
                            this._showFilterMsg();
                        return;
                    }
                }
            }
        },
        _renderResponsiveFilter: function () {
            var $outerDiv = ej.buildTag('div#responsiveFilter.e-resFilterDiv', '', { 'width': '100%', 'padding': '0px' });
            var height = $(window).height() + 1;
            var headerHieght = height * (8 / 100);
            var width = this.element.height() > height ? $(window).width() + 16.5 : $(window).width();
            var $columnDiv = ej.buildTag('div.columnDiv', '', { width: '100%' });
            for (var i = 0; i < this.model.columns.length; i++) {
                var $cDiv = ej.buildTag('div.e-responsivefilterColDiv', '', { width: '100%' }, { 'data-ej-mappingname': this.model.columns[i].field });
                var $span = ej.buildTag('span', this.model.columns[i].headerText, { 'margin-left': '4%' });
                $cDiv.append($span);
                $columnDiv.append($cDiv);
            }
            $outerDiv.append($columnDiv);
            this.element.append($outerDiv);
            var gridObj = this;
            var widt = this.element.outerWidth();
            var $headerDiv = ej.buildTag('div.e-resFilterDialogHeaderDiv', '', { 'height': headerHieght });
            var $span = ej.buildTag('div.e-labelRes', '<span>Filter</span>');
            var $resIcon = ej.buildTag('div.e-resFilterleftIcon', '', { 'margin-top': '3%' });
            var $resspan = ej.buildTag('span.e-icon e-responsiveFilterClear e-resIcon', '', { 'font-size': '23px' });
            var $divIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', { 'float': 'right', 'margin-top': '3%' }, { closeDialogue: 'responsiveFilter', gridEle: true });
            var $spanIcon = ej.buildTag('span.e-icon e-responisveClose e-resIcon', '', { 'font-size': '23px' }, { closeDialogue: 'responsiveFilter', gridEle: true });
            $divIcon.click(function (e) {
                $("#responsiveFilter").css('display', 'none');
                gridObj.element.css('display', 'block');
            });
            $resIcon.click(function (e) {
                $("#responsiveFilter").find('.e-responsivefilterColDiv').find('.e-filternone').click();
            });
            $headerDiv.append($resIcon.append($resspan));
            $headerDiv.append($span).append($divIcon.append($spanIcon));
            $outerDiv.prepend($headerDiv);
            $outerDiv.insertAfter(this.element);
            $(".e-resFilterDiv").on('keydown', $.proxy(this._responsiveDialogueKeyUp, this))
            $outerDiv.css('display', 'none');
            $(".e-responsivefilterColDiv").on('click', $.proxy(this._mouseClickHandler, this));
        },
        _closeDivIcon: function (sender) {
            var $div = $(sender.target);
            if (!ej.isNullOrUndefined($div.attr('closeDialogue'))) {
                var $dialog = $("#" + $div.attr('closeDialogue'));
                if (!ej.isNullOrUndefined($dialog.data('ejDialog')))
                    $dialog.ejDialog('close');
                else
                    $dialog.css('display', 'none');
            }
            if (!ej.isNullOrUndefined($div.attr('gridEle'))) {
                this.element.css('display', 'block');
            }
            if (!ej.isNullOrUndefined($div.attr('openDialogue'))) {
                if (this.model.enableResponsiveRow || $div.attr('closeDialogue').indexOf('Custom') != -1) {
                    var $dialog = $("#" + $div.attr('openDialogue'));
                    if (!ej.isNullOrUndefined($dialog.data('ejDialog')))
                        $dialog.ejDialog('open');
                    else
                        $dialog.css('display', 'block');
                }
                else
                    this.element.css('display', 'block');
            }
        },
        _setResponsiveFilterIcon: function () {
            var $div = $("#responsiveFilter").find('.columnDiv'), $proxy = this;
            $div.find('.e-filtericon').remove();
            for (var i = 0; i < this.model.filterSettings.filteredColumns.length; i++) {
                var column = this.model.filterSettings.filteredColumns[i];
                var $selcDiv = $div.find('.e-responsivefilterColDiv[data-ej-mappingname=' + column.field + ']');
                var $divIcon = ej.buildTag('div.e-filtericon e-icon e-resIcon e-filterset e-filternone e-filterreset', '', { float: 'right', height: '22px', width: '21px', 'font-size': '20px', 'margin-right': '3%', 'margin-top': '2%' });
                var $iconSapn = ej.buildTag('span.e-filtericon e-icon e-resIcon e-filterset e-filternone', '', {}, { 'colType': column.type });
                $selcDiv.find('.e-filternone').remove();
                $selcDiv.append($divIcon);
                $iconSapn.click(function (e) {
                    var $target = e.target;
                    $proxy._$colType = $target.attr('colType');
                    $proxy._fltrClrHandler();
                    $target.remove();
                })
            }
        },
        _renderExcelFilter: function () {
            var filterCol = this.model.filterSettings.filteredColumns.length != 0 ? this.model.filterSettings.filteredColumns[0].field : null;
            var model = {
                instance: this,
                showSortOptions: this.model.allowSorting,
                allowFormatFiltering: this.model.filterSettings.allowFormatFiltering,
                allowCaseSensitive: this.model.filterSettings.enableCaseSensitivity,
                maxFilterLimit: this.model.filterSettings.maxFilterChoices,
                interDeterminateState: this.model.filterSettings.enableInterDeterminateState,
                enableComplexBlankFilter: this.model.filterSettings.enableComplexBlankFilter,
                blankValue: this.model.filterSettings.blankValue,
                filterHandler: ej.proxy(this._filterHandler, this),
                initFilterCol: filterCol,
                actionBegin: "actionBegin",
                actionComplete: "actionComplete"
            };
            this._excelFilter = new ej.excelFilter(model);
            $.extend(this._excelFilter, this.model.filterSettings);
        },
        _filterHandler: function (args) {
            var arg = {}, fQMgr;
            arg.requestType = args.action == "sorting" ? args.action : "filtering";
            var temp = this.model.filterSettings.filteredColumns;
            if (args.action == "filtering") {
                fQMgr = ej.DataManager(this.model.filterSettings.filteredColumns);
                var query = new ej.Query().where("field", ej.FilterOperators.equal, args.fieldName);
                var object = fQMgr.executeLocal(query);
                for (var i = 0; i < object.length; i++) {
                    var objectIndex = $.inArray(object[i], this.model.filterSettings.filteredColumns)
                    if (objectIndex != -1)
                        this.model.filterSettings.filteredColumns.splice(objectIndex, 1);
                }
                ej.merge(this.model.filterSettings.filteredColumns, args.filterCollection);
                args.currentFilterCollection = args.filterCollection;
            }
            else if (args.action == "clearfiltering") {
                var filterObj = args.filterDetails;
                delete this._excelFilter._predicates[0][args.fieldName];
                this.filterColumn(filterObj.field, filterObj.operator, filterObj.value, filterObj.predicate);
                for (var i = 0; i < this.filterColumnCollection.length; i++) {
                    if (this.filterColumnCollection[i].field == filterObj.field)
                        this.filterColumnCollection.splice(i, 1);
                }
                return;
            }
            else if (args.action == "sorting") {
                var sortObj = args.sortDetails;
                if (ej.gridFeatures.sort)
                    this.sortColumn(sortObj.field, sortObj.direction);
                this._excelFilter.closeXFDialog();
                return;
            }

            arg.currentFilteringColumn = args.fieldName;
			arg.filterCollection = args.filterCollection;
            arg.predicated = args.ejpredicate;
            var returnValue = this._processBindings(arg);
            if (returnValue)
                this.model.filterSettings.filteredColumns = temp;
        },
        _renderFiltering: function () {
            var $headerTable = this.getHeaderTable(), args, temp;
            var $tr = ej.buildTag('tr.e-filterbar'), $trClone, filteredFields = [], $input;
            if (this.model.detailsTemplate || this.model.childGrid) $tr.append(ej.buildTag('th.e-filterbarcell e-mastercell'));
            for (var column = 0; column < this.model.columns.length; column++) {
                var $th = ej.buildTag('th.e-filterbarcell'), $div = ej.buildTag('div.e-filterdiv'), $span = ej.buildTag('span.e-cancel e-icon e-hide');
                var fltrField = ej.isNullOrUndefined(this.model.columns[column]["field"]) ? this.model.columns[column]["field"] : this.model.columns[column].field.replace(/[^a-z0-9|s_]/gi, ''), fltrId = ej.isNullOrUndefined(this.model.columns[column]["foreignKeyValue"]) ? fltrField + "_filterBarcell" : fltrField + "_" + this.model.columns[column]["foreignKeyValue"] + "_filterBarcell";
                if (this.model.columns[column]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate) && !ej.isNullOrUndefined(this.model.columns[column]["field"])) {
                    $th.addClass('e-fltrtemp');
                    $div.addClass('e-fltrtempdiv');
                    if (ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate.create)) {
                        $input = ej.buildTag('input e-filtertext', "", {}, { title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, id: fltrId, "class": "e-filterUi_input e-filtertext e-fltrTemp" });
                    }
                    else {
                        args = { columnIndex: column, column: this.model.columns[column] }
                        temp = this.model.columns[column].filterBarTemplate.create;
                        if (typeof temp == "string")
                            temp = ej.util.getObject(temp, window);
                        $input = temp(args)
                        $input = $($input).attr({ title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, id: fltrId, "class": "e-filterUi_input e-filtertext e-fltrTemp" });
                    }
                }
                else {
                    $div.addClass('e-fltrinputdiv');
                    var fltrField = this.model.columns[column]["field"], fltrId = ej.isNullOrUndefined(this.model.columns[column]["foreignKeyValue"]) ? fltrField + "_filterBarcell" : fltrField + "_" + this.model.columns[column]["foreignKeyValue"] + "_filterBarcell";
                    $input = ej.buildTag('input.e-ejinputtext e-filtertext', "", {}, { title: this.model.columns[column]["headerText"] + this.localizedLabels.FilterbarTitle, type: "search", id: fltrId.replace(/[^a-z0-9|s\_.]/gi, '') });
                }
                if (this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "filterbar" && $.inArray(this.model.columns[column].field, filteredFields) == -1) {
                    for (var fColumn = 0; fColumn < this.model.filterSettings.filteredColumns.length; fColumn++) {
                        if (this.getColumnIndexByField(this.model.filterSettings.filteredColumns[fColumn].field) == column) {
                            if (this.model.filterSettings.filteredColumns[fColumn].operator == "greaterthan")
                                $input.val(">" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else if (this.model.filterSettings.filteredColumns[fColumn].operator == "lessthan")
                                $input.val("<" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else if (this.model.filterSettings.filteredColumns[fColumn].operator == "notequal")
                                $input.val("!=" + this.model.filterSettings.filteredColumns[fColumn].value);
                            else
                                $input.val(this.model.filterSettings.filteredColumns[fColumn].value);
                            if ($.inArray(this.model.filterSettings.filteredColumns[fColumn].field, filteredFields) == -1) filteredFields.push(this.model.filterSettings.filteredColumns[fColumn].field);
                        }
                    }
                }
                if (this.model.columns[column]["allowFiltering"] === false || this.model.columns[column]["field"] == "" || ej.isNullOrUndefined(this.model.columns[column]["field"])) {
                    $input.attr("disabled", true).addClass("e-disable");
                    this._disabledFilterableColumns.push(this.model.columns[column]["headerText"]);
                }
                this.model.columns[column]["visible"] === false && $th.addClass("e-hide");
                !ej.isNullOrUndefined(this.model.columns[column]["cssClass"]) && $th.addClass(this.model.columns[column]["cssClass"]);
                if (this.model.columns[column]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[column].filterBarTemplate))
                    $div.append($input);
                else
                    $div.append($input).append($span);
                $tr.append($th.append($div));
                if (column == this.model.scrollSettings.frozenColumns - 1) {
                    $trClone = $tr.clone();
                    $headerTable.find("thead").first().append($trClone);
                    $tr.empty();
                }
            }
            $headerTable.find("thead").last().append($tr);
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10) {
                var filterBarCell = $headerTable.find("thead").find(".e-ejinputtext.e-filtertext");
                for (var cell = 0; cell < filterBarCell.length; cell++)
                    ej.ieClearRemover(filterBarCell[cell]);
            }
            this.setGridFilterBar($tr);
        },
        _renderFilterBarTemplate: function () {
            var args, temp1, temp2, flag = false;
            for (var count = 0 ; count < this.model.columns.length; count++) {
                if (this.model.columns[count]["allowFiltering"] != false && !ej.isNullOrUndefined(this.model.columns[count].filterBarTemplate) && !ej.isNullOrUndefined(this.model.columns[count]["field"])) {
                    temp1 = this.model.columns[count].filterBarTemplate.read;
                    if (typeof temp1 == "string")
                        temp1 = ej.util.getObject(temp1, window);
                    if (this.model.columns[count].foreignKeyField)
                        args = { element: this.getHeaderTable().find('.e-filterbar').find('.e-fltrtemp').find("#" + this.model.columns[count].field.replace(/[^a-z0-9|s_]/gi, '') + "_" + this.model.columns[count].foreignKeyValue.replace(/[^a-z0-9|s_]/gi, '') + "_filterBarcell"), columnIndex: count, column: this.model.columns[count] }
                    else
                        args = { element: this.getHeaderTable().find('.e-filterbar').find('.e-fltrtemp').find("#" + this.model.columns[count].field.replace(/[^a-z0-9|s_]/gi, '') + "_filterBarcell"), columnIndex: count, column: this.model.columns[count] }
                    if (typeof args.column.filterBarTemplate.read == "string")
                        args.column.filterBarTemplate.read = temp1;
                    temp2 = this.model.columns[count].filterBarTemplate.write;
                    if (typeof temp2 == "string")
                        temp2 = ej.util.getObject(temp2, window);
                    if (this.model.filterSettings.filteredColumns.length > 0) {
                        for (var index = 0 ; index < this.model.filterSettings.filteredColumns.length; index++) {
                            if (this.model.columns[count].field == this.model.filterSettings.filteredColumns[index].field)
                                args.modelVal = this.model.filterSettings.filteredColumns[index].value;
                        }
                    }
                    temp2.call(this, args);
                    flag = true
                }
            }
            if (flag)
                this.model.filterSettings.filterBarMode = ej.Grid.FilterBarMode.OnEnter;
        },
        _closeFilterDlg: function () {
            if (!ej.isNullOrUndefined($("#" + this._id + "_" + this._$colType + "Dlg").data('ejDialog')))
                $("#" + this._id + "_" + this._$colType + "Dlg").ejDialog('close');
            else
                $("#" + this._id + "_" + this._$colType + "Dlg").css('display', 'none');
            this._$fDlgIsOpen = false;
            this._$menuDlgIsOpen = false;
        },
        _filterBarClose: function (e) {
            var $target = $(e.target);
            if ($target.closest(".e-grid").attr("id") !== this._id)
                return;
            if (e.type == "click" && $target.hasClass("e-cancel")) {
                var $targetText = $target.prev();
                $targetText.focus().val("");
                $targetText.trigger("keyup");
                e.stopPropagation();
            }
            if (e.type == "focusin" && $target.hasClass("e-filtertext")) {
                $target = $(e.target).next();
                this.getFilterBar().find(".e-cancel").addClass("e-hide");
                $target.removeClass("e-hide");
            }
        },
        _processFilter: function (e) {
            if (!this._alreadyFilterProcessed) {
                this._alreadyFilterProcessed = true;
                this._startTimer(e);
            } else {
                this._stopTimer();
                this._startTimer(e);
            }
        },
        _startTimer: function (e) {
            var proxy = this;
            var delay = e.keyCode == 13 ? 0 : proxy.model.filterSettings.immediateModeDelay;
            this._timer = window.setTimeout(
                function () {
                    proxy._onTimerTick();
                },
                delay);
        },
        _stopTimer: function () {
            if (this._timer != null)
                window.clearTimeout(this._timer);
        },

        _onTimerTick: function () {
            this.OldfilterValue = this._currentFilterbarValue;
            this._oldFilterColumn = this._currentFilterColumn;
            this.filterValueOldLength = this.filterValueCurrentLength;
            this._findPredicate();
            var result = null;
            var matchcase = this._currentFilterColumn.type == "string" ? false : true;
            var collection = $.extend([], this.model.filterSettings.filteredColumns);
            for (var i = 0; i < collection.length; i++) {
                if (this.getHeaderContent().find(".e-filterbar #" + collection[i].field.replace(/[^a-z0-9|s\_.]/gi, '') + "_filterBarcell").val() == "") {
                    if ($.inArray(this.model.filterSettings.filteredColumns[i], this.filterColumnCollection) != -1)
                        this.filterColumnCollection.splice(i, 1);
                    this.model.filterSettings.filteredColumns.splice(i, 1);
                }
            }
            if (this._currentFilterColumn.type == "date" || this._currentFilterColumn.type == "datetime") {
                for (var j = 0; j < this.model.filterSettings.filteredColumns.length; j++) {
                    if (this.model.filterSettings.filteredColumns[j].isComplex) {
                        var preobject = this.model.filterSettings.filteredColumns[j].predicates;
                        if (this.model.filterSettings.filteredColumns.length == 1) {
                            this.model.filterSettings.filteredColumns = preobject;
                        }
                        else {
                            this.model.filterSettings.filteredColumns[j] = preobject[0];
                            this.model.filterSettings.filteredColumns.push(preobject[1]);
                        }
                    }
                }
            }
            if (!this._skipFilterProcess) {
                if (this._currentFilterColumn.foreignKeyValue && this._currentFilterColumn.dataSource && this._currentFilterbarValue != "")
                    this._fltrForeignKeyValue(this._operator, this._currentFilterbarValue, matchcase,
                                              this._currentFilterColumn.dataSource, this._currentFilterColumn.foreignKeyField,
                                              this._currentFilterColumn.foreignKeyValue, this._currentFilterColumn.type);
                else {
                    if (ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate)) {
                        this._fltrBarcell = true;
                        this.filterColumn(this._currentFilterColumn.field, this._operator, this._currentFilterbarValue, this._predicate, matchcase);
                    }
                }
            }
            else
                this.filterStatusMsg = "Invalid Filter Data";
            if (!this.model.scrollSettings.enableVirtualization && ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate))
                this._showFilterMsg();
            this._stopTimer();
        },

        _findPredicate: function () {
            var _value = this._currentFilterbarValue.replace(/ && /i, " and ").replace(" || ", " or ");
            var _predicateFinder = _value.split(' ');
            this._predicate = "and";
            if (_predicateFinder.length != 0) {
                if ($.isFunction(ej.Predicate[_predicateFinder[1]])) {
                    this._skipFilterProcess = false;
                    this._predicate = _predicateFinder[1];
                    var valuesArray = _value.split(" " + _predicateFinder[1] + " ");
                    var tempOperator = [];
                    var filterValues = [];
                    for (var i = 0; i < valuesArray.length; i++) {
                        this._validateFilterValue(valuesArray[i]);
                        tempOperator.push(this._operator);
                        if (this._currentFilterColumn.type == "number")
                            filterValues.push(this._currentFilterbarValue);
                        else if (this._currentFilterColumn.type == "string")
                            filterValues.push(valuesArray[i]);
                    }
                    this._currentFilterbarValue = filterValues;
                    this._operator = tempOperator;
                } else
                    this._validateFilterValue($.trim(this._currentFilterbarValue));
            } else
                this._validateFilterValue($.trim(this._currentFilterbarValue));
        },

        _validateFilterValue: function (_value) {
            switch (this._currentFilterColumn.type) {
                case "number":
                    this._operator = ej.FilterOperators.equal;
                    var stringSkipInput = new Array(">", "<", "=", "!");
                    for (var i = 0; i < _value.length; i++) {
                        if (jQuery.inArray(_value[i], stringSkipInput) != -1) {
                            break;
                        }
                    }
                    if (i != _value.length) {
                        this._getOperator(_value.substring(i));
                        if (i != 0)
                            this._currentFilterbarValue = _value.substring(0, i);
                    }
                    if (this._currentFilterbarValue != "" && _value.length >= 1)
                        this._currentFilterbarValue = ej.parseFloat(this._currentFilterbarValue, this.model.locale);
                    else
                        this._currentFilterbarValue = _value.length > 1 ? ej.parseFloat(_value, this.model.locale) : _value;
                    break;
                case "date":
                case "datetime":
                    this._operator = ej.FilterOperators.equal;
                    this._getOperator(_value);
                    var _format;
                    if (ej.isNullOrUndefined(this._currentFilterColumn.format)) {
                        if (this._currentFilterColumn.type == "date")
                            _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                        else
                            _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
                    }
                    else
                        _format = this._currentFilterColumn.format.replace("{0:", "").replace('}', "");
                    if (this._currentFilterbarValue != "") {
                        var filterbarValue = ej.parseDate(this._currentFilterbarValue, _format, this.model.locale);
                        if (!ej.isNullOrUndefined(filterbarValue))
                            this._currentFilterbarValue = ej.parseDate(this._currentFilterbarValue, _format, this.model.locale);
                        else
                            this.filterStatusMsg = "Invalid Filter Data";
                    }
                    break;
                case "string":
                    if (_value.charAt(0) == '*') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(1);
                        this._operator = ej.FilterOperators.startsWith;
                    }
                    else if (_value.charAt(_value.length - 1) == '%') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(0, -1);
                        this._operator = ej.FilterOperators.startsWith;
                    }
                    else if (_value.charAt(0) == '%') {
                        this._currentFilterbarValue = this._currentFilterbarValue.slice(1);
                        this._operator = ej.FilterOperators.endsWith;
                    }
                    else
                        this._operator = ej.FilterOperators.startsWith;
                    break;
                case "boolean":
                case "checkbox":
                    if (this._currentFilterbarValue.toLowerCase() == "true" || this._currentFilterbarValue == "1")
                        this._currentFilterbarValue = true;
                    else if (this._currentFilterbarValue.toLowerCase() == "false" || this._currentFilterbarValue == "0")
                        this._currentFilterbarValue = false;
                    this._operator = ej.FilterOperators.equal;
                    break;
                default:
                    this._operator = ej.FilterOperators.equal;
            }
        },
        _getOperator: function (_value) {
            if (_value.charAt(0) == "=") {
                this._operator = ej.FilterOperators.equal;
                this._currentFilterbarValue = _value.substring(1);
            }
            if (ej.data.operatorSymbols[_value.charAt(0)] !== undefined || ej.data.operatorSymbols[_value.slice(0, 2)] !== undefined) {
                this._operator = ej.data.operatorSymbols[_value.charAt(0)];
                this._currentFilterbarValue = _value.substring(1);
                if (this._operator === undefined) {
                    this._operator = ej.data.operatorSymbols[_value.slice(0, 2)];
                    this._currentFilterbarValue = _value.substring(2);
                }
            }
            if (this._operator == ej.FilterOperators.lessThan || this._operator == ej.FilterOperators.greaterThan) {
                if (this._currentFilterbarValue.charAt(0) == "=") {
                    this._operator = this._operator + "orequal";
                    this._currentFilterbarValue = this._currentFilterbarValue.substring(1);
                }
            }

        },

        _checkForSkipInput: function () {
            var isSkip = false;
            var skipInput = new Array("=", " ", "!");
            var context = this;
            if (this._currentFilterColumn.type == "number") {
                if (ej.data.operatorSymbols[this._currentFilterbarValue] !== undefined || $.inArray(this._currentFilterbarValue, skipInput) != -1)
                    isSkip = true;
            }
            if (this._currentFilterColumn.type == "string") {
                var stringSkipInput = new Array(">", "<", "=", "!");
                for (var i = 0; i < this._currentFilterbarValue.length; i++) {
                    if ($.inArray(this._currentFilterbarValue[i], stringSkipInput) != -1)
                        isSkip = true;
                }
            }
            return isSkip;
        },
        _showFilterMsg: function () {
            var index = $.inArray(this._currentFilterColumn, this.filterColumnCollection);
            if (this._currentFilterbarValue !== "" && index == -1)
                this.filterColumnCollection.push(this._currentFilterColumn);
            if (this._currentFilterbarValue === "" && index != -1) {
                this.filterColumnCollection.splice(index, 1);
            }
            if ((!this._skipFilterProcess || this.filterColumnCollection.length > 0) && this.filterStatusMsg != "Invalid Filter Data") {
                for (var index = 0; index < this.filterColumnCollection.length; index++) {
                    if (!ej.isNullOrUndefined(this.filterColumnCollection[index])) {
                        var val, filterColumnName, hTxt = this.filterColumnCollection[index].headerText;
                        if (this.filterColumnCollection[index].disableHtmlEncode)
                            hTxt = this._htmlEscape(hTxt);
                        if (this.filterColumnCollection[index].field.indexOf('.') != -1) {
                            var spltClmn = (this.filterColumnCollection[index].field.replace(/[^a-z0-9|s\_.]/gi, '')).split(".");
                            filterColumnName = spltClmn.join("\\.");
                            val = $("#" + filterColumnName + "_filterBarcell").val();
                        }
                        else {
                            var fltrId = ej.isNullOrUndefined(this.filterColumnCollection[index]["foreignKeyValue"]) ? this.filterColumnCollection[index].field.replace(/[^a-z0-9|s\_.]/gi, '') + "_filterBarcell" : this.filterColumnCollection[index].field.replace(/[^a-z0-9|s\_.]/gi, '') + "_" + this.filterColumnCollection[index]["foreignKeyValue"] + "_filterBarcell";
                            if (this._currentFilterColumn.type == "boolean" && !ej.isNullOrUndefined(this._currentFilterColumn.filterBarTemplate) && this.element.find("#" + fltrId).hasClass('e-checkbox e-js'))
                                val = this.element.find("#" + fltrId).parent().attr('aria-checked');
                            else
                                val = this.element.find("#" + fltrId).val();
                        }
                        if (val != "") {
                            if (index > 0 && this.filterStatusMsg != "")
                                this.filterStatusMsg += " && ";
                            this.filterStatusMsg += hTxt + ": " + val;
                        }
                    }
                }
            }

            if (this.model.allowPaging)
                this.getPager().ejPager("model.externalMessage", this.filterStatusMsg);
            else {
                if (this.model.scrollSettings.allowVirtualScrolling)
                    this.$pagerStatusBarDiv.find(".e-pagerfiltermsg").html(this.filterStatusMsg).css("display", "block");
                else
                    this.$pagerStatusBarDiv.find("div").html(this.filterStatusMsg);
                if (this.filterStatusMsg.length)
                    this.$pagerStatusBarDiv.css("display", "block");
                else
                    this.model.scrollSettings.allowVirtualScrolling ? this.$pagerStatusBarDiv.find(".e-pagerfiltermsg").hide() : this.$pagerStatusBarDiv.hide();
            }
            if (this.filterStatusMsg == "Invalid Filter Data") {
                index = $.inArray(this._currentFilterColumn, this.filterColumnCollection);
                this.filterColumnCollection.splice(index, 1);
            }
            this.filterStatusMsg = "";
        },
        _renderFilterDialogs: function () {
            var $strDlg, $numDlg, $boolDlg, $dateDlg, $datetimeDlg, $guidDlg;

            $.each(this.model.columns, ej.proxy(function (indx, col) {
                if (col.type == "string" && (!$strDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $strDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "guid" && (!$guidDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $guidDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "number" && (!$numDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $numDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "date" && (!$dateDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $dateDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "datetime" && (!$datetimeDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $datetimeDlg = true;
                    this._renderFilters(col);
                } else if (col.type == "boolean" && (!$boolDlg || !ej.isNullOrUndefined(col.filterType))) {
                    if (ej.isNullOrUndefined(col.filterType))
                        $boolDlg = true;
                    this._renderFilters(col);
                }
            }, this));
        },
        _renderFilters: function (col) {
            if ((this._isExcelFilter && col.filterType != "menu") || col.filterType == "excel") {
                if (ej.isNullOrUndefined(this._excelFilter)) {
                    this._renderExcelFilter();
                    this._excelFilterRendered = true;
                }
                this._excelFilter.renderDialog(col.type);
            }
            else
                eval(this["_render" + col.type.substring(0, 1).toUpperCase() + col.type.substring(1) + "Dialog"](col));
        },
        _renderStringDialog: function () {
            var $id = this._id + "_stringDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "string");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderBooleanDialog: function () {
            var $id = this._id + "_booleanDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "boolean");
            if (!this.model.isResponsive || !this._mediaStatus) {
                this._renderFDialog($id);
                if (!this.model.filterSettings.showPredicate)
                    $("#" + $id).ejDialog({ minHeight: 90, width: "100%" });
                else
                    $("#" + $id).ejDialog({ minHeight: 136, width: "100%" });
            }
        },
        _renderGuidDialog: function () {
            var $id = this._id + "_guidDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "guid");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderNumberDialog: function () {
            var $id = this._id + "_numberDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "number");
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderDateDialog: function (col) {
            var $id = this._id + "_dateDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "date", col);
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderDatetimeDialog: function (col) {
            var $id = this._id + "_datetimeDlg";
            if ($("#" + $id).length > 0) return;
            var $content = ej.buildTag("div#" + $id + ".e-dlgcontainer e-filterDialog");
            $content.appendTo("body");
            this._renderDlgContent($content, "datetime", col);
            if (!this.model.isResponsive || !this._mediaStatus)
                this._renderFDialog($id);
        },
        _renderFDialog: function (id) {
            $("#" + id).ejDialog({ showOnInit: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, "showHeader": false, width: 260, enableResize: false, allowKeyboardNavigation: false, content: "#" + this._id });
        },
        _closeFDialog: function () {
            if (this._isExcelFilter || this._excelFilterRendered)
                this._excelFilter.closeXFDialog();
            if (this._$menuDlgIsOpen)
                this._closeFilterDlg();
        },
        _renderDlgContent: function (content, type, col) {
            content.addClass("e-grid");
            var $predicate = ej.buildTag("div.e-predicate"), $operator = ej.buildTag("div.e-operator"), $value = ej.buildTag("div.e-value"), $value1 = ej.buildTag("div.e-value1");
            var $strOp = this.localizedLabels.StringMenuOptions;
            var $numOp = this.localizedLabels.NumberMenuOptions;
            var $drdown = ej.buildTag("input#" + this._id + type + "_ddinput", {}, {}, { "type": "text" });
            var $drdownDiv = ej.buildTag("div#" + this._id + type + "_dropdown");
            var $drdownUl = ej.buildTag("ul");
            var $radio = ej.buildTag("input", {}, {}, { "type": "radio", "name": this._id + "_predicate" + type, "value": "or" });
            var $andRadio = ej.buildTag("input", {}, {}, { "type": "radio", "name": this._id + "_predicate" + type, "value": "and", "checked": "checked" });
            var $cbox;
            $predicate.append($andRadio)
                .append(ej.buildTag("span.e-caption").html(this.localizedLabels.PredicateAnd))
                .append($radio)
                .append(ej.buildTag("span.e-caption").html(this.localizedLabels.PredicateOr));
            !this.model.filterSettings.showPredicate && $predicate.hide();
            if (type == "string") {
                $cbox = ej.buildTag("input", {}, {}, { "type": "checkbox" });
                $predicate.append($cbox)
                    .append(ej.buildTag("span.e-caption").html(this.localizedLabels.MatchCase));
                $.each($strOp, function (indx, operator) {
                    $drdownUl.append(ej.buildTag("li", {}, {}, { "value": operator.value }).html(operator.text));
                });
            }
            if (type == "number" || type == "date" || type == "datetime" || type == "guid") {
                if (type == "guid")
                    $numOp = $numOp.slice(4, 6);
                $.each($numOp, function (indx, operator) {
                    $drdownUl.append(ej.buildTag("li", {}, {}, { "value": operator.value }).html(operator.text));
                });
            }
            if (type != "boolean") {
                $drdownDiv.append($drdownUl);
                $operator.append($drdown);
                $operator.append($drdownDiv);
            }
            var $tBox = ej.buildTag("input", {}, {}, { "type": "text" }), $tBox1 = ej.buildTag("input", {}, {}, { "type": "text" });
            var $tchkBox = ej.buildTag("input", {}, {}, { "type": "checkbox" });
            var filterVal = this.model.enableResponsiveRow ? 'OKButton' : 'Filter';
            var clearVal = this.model.enableResponsiveRow ? 'CancelButton' : 'Clear';
            var $filter = ej.buildTag("input.e-filter e-flat e-btnsub", {}, {}, { "type": "button", "value": this.localizedLabels[filterVal] });
            var $clear = ej.buildTag("input.e-clear e-flat e-btncan", {}, {}, { "type": "button", "value": this.localizedLabels[clearVal] });
            $value.append(ej.buildTag("span.e-caption").html(this.localizedLabels.FilterMenuCaption)), $value1.append(ej.buildTag("span.e-caption").html(this.localizedLabels.FilterMenuToCaption));
            content.append($predicate);
            if (type == "boolean") {
                $value.find("span.e-caption").css("top", "1px");
                $value.append($tchkBox);
            }
            else {
                $value.append(ej.buildTag("br")).append($tBox);
                content.append($operator);
            }
            content.append($value);
            $value1.append(ej.buildTag("br")).append($tBox1);
            content.append($value1);
            $value1.addClass("e-hide");
            content.append(ej.buildTag("div.e-dlgBtns").append($filter)
                .append($clear));
            var betresult = [$value, $value1];
            if (type != "boolean")
                $drdown.ejDropDownList({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "targetID": this._id + type + "_dropdown", width: "100%", height: "26px", selectedItemIndex: 0, select: ej.proxy(this._openfset, this, betresult) });
            $radio.ejRadioButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            $andRadio.ejRadioButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, checked: true });
            if ($cbox)
                $cbox.ejCheckBox({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            content.css("display", "none");
            this._createButton("filter", $filter);
            this._createButton("clear", $clear);
            var NumberDlgstyle = { "cssClass": this.model.cssClass, locale: this.model.locale, "enableRTL": this.model.enableRTL, showSpinButton: false, height: "26px", decimalPlaces: 2, width: "100%", watermarkText: this.localizedLabels.NumericTextBoxWaterMark };
            if (type == "number")
                $tBox.ejNumericTextbox(NumberDlgstyle),
                $tBox1.ejNumericTextbox(NumberDlgstyle);
            else if (type == "guid")
                $tBox.css({ "height": "26px", "width": "100%" });
            else if (type == "date" || type == "datetime") {
                var cnt = type == "date" ? "Date" : "DateTime";
                $tBox.attr("id", this._id + "_dp" + cnt), $tBox1.attr("id", this._id + "_dp" + cnt);
                var DateDlgstyle = { "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, enableStrictMode: true, width: "100%", locale: this.model.locale }
                if (type == "date")
                    DateDlgstyle["watermarkText"] = this.localizedLabels.DatePickerWaterMark;
                if (!ej.isNullOrUndefined(col.format))
                    DateDlgstyle["dateFormat"] = col.format.replace(/{0:|}/g, function () { return "" })
                $tBox["ej" + cnt + "Picker"](DateDlgstyle);
                $tBox1["ej" + cnt + "Picker"](DateDlgstyle);
            }
            else if (type == "boolean")
                $tchkBox.ejCheckBox({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL });
            else if (type == "string") {
                $tBox.attr("id", this._id + "_acString");
                $tBox.ejAutocomplete({
                    "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "dataSource": this._dataSource(), width: "100%", height: 26, enableDistinct: true, focusIn: function (args) {
                        var $dropdown = this.element.closest(".e-dialog").find(".e-dropdownlist");
                        var $matchcase = this.element.closest(".e-dialog").find(".e-checkbox").prop("checked");
                        this.model.filterType = $dropdown.ejDropDownList("model.value");
                        this.model.caseSensitiveSearch = $matchcase;
                    },
                    open: function (args) {
                        var doped = !this.element.closest(".e-dialog").ejDialog("isOpened")
                        this.suggestionList.css({ visibility: (doped ? "hidden" : "visible") });
                    }

                });
            }
        },
        _createButton: function (name, element) {
            var $func = name == "filter" ? ej.proxy(this._fltrBtnHandler, this) : ej.proxy(this._fltrClrHandler, this);
            element.ejButton({ "cssClass": this.model.cssClass, "enableRTL": this.model.enableRTL, "click": $func });
        },
        _getIdField: function () {
            var $key;
            $.each(this.model.columns, function (indx, col) {
                if (col.key) {
                    $key = col.field;
                    return false;
                }
            });
            return $key;
        },
        _openfset: function (betresult, args) {
            var margin = "5%", padding = "10px";
            if (args.value == "Between") {
                betresult[0].find(".e-caption").eq(0).html(this.localizedLabels.FilterMenuFromCaption)
                betresult[1].removeClass("e-hide");
                $(betresult[1]).css({ "padding-top": padding });
                if (this.model.isResponsive && this._mediaStatus)
                    margin = padding = "0px";
            }
            else {
                betresult[1].addClass("e-hide");
                betresult[0].find(".e-caption").eq(0).html(this.localizedLabels.FilterMenuCaption)
            }
            $(".e-responsiveLabelDiv").css({ "margin-top": margin }), $(".e-operator").css({ "padding-top": padding });
        },
        _filterCompleteAction: function () {
            if (this.model.allowPaging)
                this._refreshGridPager();
            if (this.model.scrollSettings.allowVirtualScrolling) {
                var model = this._refreshVirtualPagerInfo();
                this._showPagerInformation(model);
            }
            if (this.model.filterSettings.filterType == "menu" || this._isExcelFilter) {
                this._closeFDialog();
                var column = this.getColumnByField(this._$curFieldName);
                var index = $.inArray(column, this.model.columns), proxy = this, _addicon = false;
                $.each(this.model.filterSettings.filteredColumns, function (indx, col) {
                    if (col.field == proxy._$curFieldName) {
                        _addicon = true;
                        return false;
                    }
                    else if (col.isComplex == true) {
                        if (col.predicates[0].field == proxy._$curFieldName) {
                            _addicon = true;
                            return false;
                        }
                    }
                });
                var $fIcon = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell").eq(index).find(".e-filtericon");
                if (_addicon)
                    $fIcon.addClass("e-filteredicon e-filternone");
                else
                    $fIcon.removeClass("e-filteredicon e-filternone");
            }
        },
        _refreshFilterIcon: function () {
            if (!this.model.filterSettings.filteredColumns.length)
                return;
            var filteredCols = ej.distinct(this.model.filterSettings.filteredColumns, "field", true), _$headerCells = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell"), index, col;
            if (this.model.showStackedHeader)
                _$headerCells = _$headerCells.not(".e-stackedHeaderCell");
            if (this.model.allowReordering)
                _$headerCells.find(".e-filtericon").removeClass("e-filteredicon e-filternone");
            for (var i = 0, flen = filteredCols.length; i < flen; i++) {
                col = filteredCols[i]
                index = this.getColumnIndexByField(col.isComplex === true ? col.predicates[0].field : col.field);
                _$headerCells.eq(index).find(".e-filtericon").addClass("e-filteredicon e-filternone");
            }
        },
        _setFilterFieldValues: function (id) {
            var $fVal = "", proxy = this, $fVal1 = "";
            var flchk = -1, optr;
            $.each(this.model.filterSettings.filteredColumns, function (indx, value) {
                if (value.field == proxy._$curFieldName)
                    flchk = indx;
            });
            if (flchk == -1 && this._$colType != "boolean") {
                if (this._$colType == "string") {
                    $(".e-predicate input.e-js[type='checkbox']").ejCheckBox({
                        checked: false
                    });
                }
                $(".e-predicate input[name =" + this._id + "_predicate" + this._$colType + "]:first").ejRadioButton({ checked: true });
                $("#" + this._id + this._$colType + "_ddinput").ejDropDownList({
                    selectedItemIndex: 0, change: function (args) {
                        this.element.closest(".e-dialog").find(".e-autocomplete").val($fVal);
                    }
                });
            }
            {
                var filteredFields = $(this.model.filterSettings.filteredColumns).map(function () {
                    return this.field;
                }).get();

                if (this._$curFieldName != this._$prevFieldName || $.inArray(this._$curFieldName, filteredFields) != -1) {
                    var flag = 0;
                    $.each(this.model.filterSettings.filteredColumns, function (indx, col) {
                        if (col.field == proxy._$curFieldName) {
                            var index;
                            var option = proxy._$colType == "number" || proxy._$colType == "date" || proxy._$colType == "datetime" ? "Number" : "String";
                            var $dlist = proxy.localizedLabels[option + "MenuOptions"];
                            var optr = ej.isNullOrUndefined(col.actualOperator) ? col.operator : col.actualOperator
                            for (index = 0; index < $dlist.length; index++) {
                                if ($dlist[index].value.toLowerCase() == optr)
                                    break;
                            }
                            if (proxy._$colType == "string")
                                $(".e-predicate input.e-js[type='checkbox']").ejCheckBox({ checked: col.matchcase });
                            $("input[value=" + col.predicate + "]").ejRadioButton({ checked: true });
                            $("#" + proxy._id + proxy._$colType + "_ddinput").ejDropDownList({ selectedItemIndex: index });
                            if ((proxy.model.isResponsive && proxy._mediaStatus) && (optr == "between")) {
                                $(".e-responsiveLabelDiv").css({ "margin-top": "0%" }), $(".e-operator").css({ "padding-top": "0px" });
                            }
                            if (optr == "between" && flag <= 1) {
                                if (!flag)
                                    $fVal = col.value;
                                else
                                    $fVal1 = col.value;
                                flag++;
                                return true;
                            }
                            else
                                $fVal = col.actualFilterValue != null ? col.actualFilterValue : col.value;
                        }
                    });
                }

                if (this._$colType == "boolean") {
                    if ($fVal && $fVal != "")
                        $(id).find(".e-value input:checkbox.e-js").ejCheckBox({ checked: true });
                    else
                        $(id).find(".e-value input:checkbox.e-js").ejCheckBox({ checked: false });
                }
                else if (this._$colType == "date" || this._$colType == "datetime") {
                    $(id).find(".e-value .e-datepicker")[this._$colType == "date" ? "ejDatePicker" : "ejDateTimePicker"]("model.value", $fVal);
                    $(id).find(".e-value1 .e-datepicker")[this._$colType == "date" ? "ejDatePicker" : "ejDateTimePicker"]("model.value", $fVal1);
                }
                else if (this._$colType == "number") {
                    $(id).find(".e-value .e-numerictextbox").ejNumericTextbox("model.value", $fVal);
                    $(id).find(".e-value1 .e-numerictextbox").ejNumericTextbox("model.value", $fVal1);
                } else
                    $(id).find(".e-value input").val($fVal);
                $(id).find(".e-value1 input1").val($fVal1);
            }
        },
        _fltrBtnHandler: function (e) {
            if (this.model.isResponsive && this._mediaStatus)
                this._responsiveFilterClose();
            var id = this._id + "_" + this._$colType + "Dlg";
            var $par = $("#" + id);
            var $input = $par.find(".e-value input.e-js"), $operator, result, predicateEle, $input1 = $par.find(".e-value1 input.e-js");
            var value = $input.val(), matchcase = undefined, filterValue, value1 = $input1.val();
            if (this._$colType == "number") {
                $input = $input.filter(".e-numerictextbox");
                value = parseFloat($input.ejNumericTextbox("getValue"));
                matchcase = true;
            }
            if (this._$colType == "string")
                matchcase = $par.find(".e-predicate input[type='checkbox']").is(":checked");
            if (this._$colType == "date" || this._$colType == "datetime") {
                value = ej.parseDate(value, this._$colFormat, this.model.locale);
                matchcase = true;
            }
            if (this._$colType == "boolean") {
                value = $input.ejCheckBox("model.checked") != null ? $input.ejCheckBox("model.checked") : false;
                $operator = "equal";
            } else
                $operator = $("#" + this._id + this._$colType + "_ddinput").ejDropDownList("getSelectedValue").toLowerCase();
            predicateEle = $par.find(".e-predicate input[type='radio']:checked");
            if (this._$colForeignKeyValue && this._$colDropdownData)
                this._fltrForeignKeyValue($operator, value, matchcase, this._$colDropdownData, this._$colForeignKeyField, this._$colForeignKeyValue, this._$colType, predicateEle);
            else {
                if (this._$colType != "boolean") {
                    if (($("#" + this._id + this._$colType + "_ddinput").ejDropDownList("getSelectedValue").toLowerCase() == "between")) {
                        if ((this._$colType == "datetime") || (this._$colType == "date")) {
                            value1 = ej.parseDate(value1, this._$colFormat, this.model.locale);
                        }
                        if (this._$colType == "number") {
                            value1 = parseFloat($input1.ejNumericTextbox("getValue"));
                        }
                        value = [value, value1];
                        $operator = ["greaterthanorequal", "lessthanorequal"];
                        var actualOperator = {};
                        actualOperator.operator = 'between';
                    }
                }
            }
            this.filterColumn(this._$curFieldName, $operator, value, $par.find(".e-predicate input[type='radio']:checked").attr("value"), matchcase, actualOperator);
            if (this.model.isResponsive) {
                $par.css('display', 'none');
                this._setResponsiveFilterIcon();
                this.element.css('display', 'block');
                if (this.model.allowScrolling && (!this.model.enableResponsiveRow || !this.model.minWidth)) {
                    var args = {};
                    args.requestType = 'refresh';
                    this._refreshScroller(args);
                }
            }
        },
        _fltrClrHandler: function (e) {
            this.clearFiltering(this._$curFieldName);
        },

        _fltrForeignKeyValue: function (operator, value, matchcase, dataSource, fieldName, mapFieldName, colType, predicateEle) {
            if (ej.isNullOrUndefined(matchcase))
                matchcase = true;
            var operatorCol = [], predicateCol = [], query, filterValue, visible = predicateEle ? predicateEle.css("display") == "none" : true, condition = predicateEle ? predicateEle.attr("value") : "and", predicate;
            var data = dataSource, val;
            var filterCollection = { mapFieldName: mapFieldName, fieldName: fieldName, operator: operator, value: value, predicate: predicateEle, matchcase: matchcase };
            var args = { requestType: ej.Grid.Actions.Filtering, action: "fetchingForeignKeyField", currentFilteringColumn: fieldName, currentFilterObject: filterCollection };
            this._trigger("actionBegin", args);
            if (!(dataSource instanceof ej.DataManager))
                data = new ej.DataManager(dataSource);
            if (colType == "date") {
                var $prevDate = new Date(value.setDate(value.getDate() - 1));
                var $nextDate = new Date(value.setDate(value.getDate() + 2));
                if (operator == "equal" || operator == "notequal") {
                    if (operator == "equal")
                        query = new ej.Query().where(ej.Predicate(filterCollection.mapFieldName, ">", $prevDate, !filterCollection.matchcase).and(filterCollection.mapFieldName, "<", $nextDate, !filterCollection.matchcase)).select(filterCollection.fieldName);
                    else
                        query = new ej.Query().where(ej.Predicate(filterCollection.mapFieldName, "<=", $prevDate, !filterCollection.matchcase).or(filterCollection.mapFieldName, ">=", $nextDate, !filterCollection.matchcase)).select(filterCollection.fieldName);
                }
                else
                    query = new ej.Query().where(filterCollection.mapFieldName, filterCollection.operator, filterCollection.value, !filterCollection.matchcase).select(filterCollection.fieldName);
            }
            else
                query = new ej.Query().where(filterCollection.mapFieldName, filterCollection.operator, filterCollection.value, !filterCollection.matchcase).select(filterCollection.fieldName);
            filterValue = { actualFilterValue: filterCollection.value, actualOperator: filterCollection.operator, ejpredicate: undefined, predicate: condition };
            data.executeQuery(query).done(ej.proxy(function (e) {
                val = e.result;
                var requireProc = $.isPlainObject(val[0]), preds = [], merge = false, field = this._$curFieldName;
                val = requireProc ? ej.distinct(val, fieldName, false) : val,
                predicate = new ej.Predicate(field, "equal", val[0], matchcase);
                for (var i = 1, vlen = val.length; i < vlen; i++) {
                    preds.push(new ej.Predicate(field, "equal", val[i], matchcase));
                    merge = true;
                }
                if (merge) {
                    preds.unshift(predicate);
                    predicate = ej.Predicate.or(preds); /*ensure same level for multiple predicates*/
                }
                $.extend(filterValue, { ejpredicate: $.extend(predicate, { field: field }, filterValue) });
                this.filterColumn(filterCollection.fieldName, filterCollection.operator, filterCollection.value, predicateCol, filterCollection.matchcase, filterValue);
            }, this));
        },
        _setDateFilters: function (filterObject, forGrouping) {
            var $prevDate, $nextDate, pred, predicate;
            if (!forGrouping && !ej.isNullOrUndefined(this.getColumnByField(filterObject.field).format)) {
                var formatString = this.getColumnByField(filterObject.field).format;
                if (formatString.indexOf("s") != -1) {
                    $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                    $nextDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() + 2));
                }
                else if (formatString.indexOf("m") != -1) {
                    $prevDate = new Date(filterObject.value.setMinutes(filterObject.value.getMinutes() - 1));
                    $nextDate = new Date(filterObject.value.setMinutes(filterObject.value.getMinutes() + 2));
                }
                else if (formatString.indexOf("h") != -1) {
                    $prevDate = new Date(filterObject.value.setHours(filterObject.value.getHours() - 1));
                    $nextDate = new Date(filterObject.value.setHours(filterObject.value.getHours() + 2));
                }
                else {
                    $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                    $nextDate = new Date(filterObject.value.setDate(filterObject.value.getDate() + 1));
                }
            }
            else {
                $prevDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() - 1));
                $nextDate = new Date(filterObject.value.setSeconds(filterObject.value.getSeconds() + 2));
            }
            var $prevObj = $.extend({}, filterObject);
            var $nextObj = $.extend({}, filterObject);
            $prevObj.value = $prevDate;
            $nextObj.value = $nextDate;
            if (filterObject.operator == "equal") {
                $prevObj.operator = "greaterthan";
                $prevObj.predicate = "and";
                $nextObj.operator = "lessthan";
                $nextObj.predicate = "and";
            } else {
                $prevObj.operator = "lessthanorequal";
                $prevObj.predicate = "or";
                $nextObj.operator = "greaterthanorequal";
                $nextObj.predicate = "or";
            }
            pred = ej.Predicate($prevObj.field, $prevObj.operator, $prevObj.value, false);
            predicate = pred[$nextObj.predicate](ej.Predicate($nextObj.field, $nextObj.operator, $nextObj.value, false));
            filterObject.value = new Date(filterObject.value.setSeconds($nextObj.value.getSeconds() - 1));
            if (forGrouping)
                return predicate;
            else
                this.model.filterSettings.filteredColumns.push($.extend(predicate, { field: filterObject.field, operator: filterObject.operator, value: filterObject.value }));
        }
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.group = {
        _renderGroupDropArea: function () {
            if(!ej.isNullOrUndefined(this.model.groupSettings.enableDropAreaAnimation))
                this.model.groupSettings.enableDropAreaAutoSizing = this.model.groupSettings.enableDropAreaAnimation;
            var dragLabel = this.model.groupSettings.enableDropAreaAutoSizing ? "" : this.localizedLabels.GroupDropArea;
            if (this.model.groupSettings.showDropArea) {
                var $div = ej.buildTag("div.e-groupdroparea", dragLabel);
				$div.addClass("e-default");
                this.model.groupSettings.enableDropAreaAutoSizing && $div.append(ej.buildTag("div.e-animatebutton e-icon").addClass(this.model.groupSettings.enableDropAreaAutoSizing ? "e-animatebuttondown e-gdownarrow" : "e-animatebuttonup e-guparrow"));
                return $div;
            }
        },
        _getColGroup: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            if (gridObject.model.groupSettings.groupedColumns.length == 1)
                var level = this.data.items.level === undefined ? 0 : this.data.items.level - 1;
            else
                var level = this.data.items.level === undefined ? gridObject.model.groupSettings.groupedColumns.length : this.data.items.level - 1;
            var $div = $(document.createElement("div"));
            var $colGroup;
            if (gridObject._isCaptionSummary)
                $colGroup = gridObject._getCaptionColGroup(level);
            else {
                $colGroup = gridObject._getMetaColGroup();
                if (level != gridObject.model.groupSettings.groupedColumns.length && gridObject.model.groupSettings.groupedColumns.length > 1)
                    $colGroup.prepend(gridObject._getIndentCol());
            }
            $div.html($colGroup);
            return $div.html();
        },
        _colSpanAdjust: function (gridObjectId, type, captionDetails) {
            var gridObject, groupData;
            if (ej.isNullOrUndefined(gridObjectId)) {
                gridObject = this;
                groupData = captionDetails;
            }
            else {
                gridObject = this.getRsc("helpers", gridObjectId);
                groupData = this;
            }
            if (gridObject.model.groupSettings.groupedColumns.length == 1) {
                var level = groupData.data.items.level === undefined ? 1 : groupData.data.items.level - 1;
                if (type == "groupcaption")
                    gridObject._currentJsonData = gridObject._currentJsonData.concat(groupData.data.items);
            } else {
                var level = groupData.data.items.level === undefined ? gridObject.model.groupSettings.groupedColumns.length : groupData.data.items.level - 1;
                if (type == "groupcaption" && groupData.data.items.level === undefined)
                    gridObject._currentJsonData = gridObject._currentJsonData.concat(groupData.data.items);
            }            
            gridObject._isGrouping = true;
            var hideGroupColumnCount = !gridObject.model.groupSettings.showGroupedColumn ? gridObject.model.groupSettings.groupedColumns.length : 0;
            var count = 0;
            $.each(gridObject._hiddenColumnsField, function (indx, col) {
                var tempIndex = $.inArray(col, gridObject.model.groupSettings.groupedColumns);
                if (tempIndex != -1) {
                    count = count + 1;
                    if (gridObject.model.groupSettings.showGroupedColumn)
                        hideGroupColumnCount = hideGroupColumnCount + 1;
                }
            })
            var colHeaderText = [];
            $.map(gridObject.model.columns, function (val, i) {
                colHeaderText.push(val.headerText)
            });
            var duparr = gridObject._isDuplicate(colHeaderText), colspan;
            if(!duparr)
                colspan = gridObject.model.columns.length + gridObject.model.groupSettings.groupedColumns.length - level - gridObject._hiddenColumns.length - hideGroupColumnCount + count;
            else
                colspan = gridObject.model.columns.length + gridObject.model.groupSettings.groupedColumns.length - level - gridObject._hiddenColumnsField.length - hideGroupColumnCount + count;
            colspan = (gridObject.model.detailsTemplate != null || gridObject.model.childGrid != null) ? colspan + 1 : colspan;

            if (gridObject._isCaptionSummary && type == "groupcaption") {
                var index = [], cIndex = 0;
                var row = gridObject._captionSummary();
                var hiddenIndexCount = 0, summaryColIndexes = [];
                $.each(row[0].summaryColumns, function (cindx, col) {
                    if ($.inArray(col.displayColumn, gridObject._hiddenColumnsField) != -1)
                        cIndex++;
                    summaryColIndexes.push(gridObject.getColumnIndexByField(col.displayColumn));
                    index.push(gridObject.getColumnIndexByField(col.displayColumn) + gridObject.model.groupSettings.groupedColumns.length - level);
                });
                var sumColIndex = ej.min(summaryColIndexes)
                var hiddenCol = duparr ? gridObject._hiddenColumnsField : gridObject._hiddenColumns;
                for (var i = 0 ; i < hiddenCol.length; i++) {
                    if (duparr)
                        var colIndex = ej.isNullOrUndefined(gridObject.getColumnByField(gridObject._hiddenColumnsField[i])) ? gridObject.getColumnIndexByHeaderText(gridObject._hiddenColumnsField[i], ej.isNullOrUndefined(gridObject.getColumnByField(gridObject._hiddenColumnsField[i]))) : gridObject.getColumnIndexByField(gridObject._hiddenColumnsField[i]);
                    else
                        var colIndex = ej.isNullOrUndefined(gridObject.getColumnByHeaderText(gridObject._hiddenColumns[i])) ? gridObject.getColumnIndexByHeaderText(gridObject._hiddenColumns[i], ej.isNullOrUndefined(gridObject.getColumnByHeaderText(gridObject._hiddenColumns[i]))) : gridObject.getColumnIndexByHeaderText(gridObject._hiddenColumns[i]);
                    if (sumColIndex > colIndex)
                        hiddenIndexCount++;
                }
                if (index.length > 0)
                    colspan = ej.min(index);
                colspan = colspan - hiddenIndexCount;
                colspan = (gridObject.model.detailsTemplate != null || gridObject.model.childGrid != null) ? colspan + 1 : colspan;
            }
            return colspan;
        },
        _captionEncode: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            var column = gridObject.getColumnByField(this.data.field);
            return column.disableHtmlEncode;
        },
        _captionFormat: function (gridObjectId) {
            var gridObject = this.getRsc("helpers", gridObjectId);
            var keyValue, captionData = $.extend({}, this.data);
			var capationFormat = !ej.isNullOrUndefined(gridObject.model.groupSettings.captionFormat)? gridObject.model.groupSettings.captionFormat: gridObject.localizedLabels.GroupCaptionFormat;
            var column = gridObject.getColumnByField(captionData.field);
            if (column.foreignKeyValue && column.dataSource)
                keyValue = gridObject._foreignKeyBinding(gridObject.getColumnIndexByField(captionData.field), captionData.key, gridObject._id);
            else
                keyValue = captionData.key;
			if(!ej.isNullOrUndefined(column.format) && column.format.indexOf("{0:") == -1){
				captionData[captionData.field] = captionData.key;
				gridObject.data = captionData;
			}
            captionData.key = column.format ? gridObject.formatting(column.format, keyValue, gridObject.model.locale) : keyValue;
            captionData.headerText = column.headerText;
            gridObject._groupContextIndex = gridObject._groupContextIndex + 1;
            if (capationFormat.startsWith("#") || capationFormat.startsWith(".") || typeof capationFormat === "object")
                return gridObject._renderEjTemplate(capationFormat, captionData, gridObject._groupContextIndex, null, !ej.isNullOrUndefined(gridObject.model.ngTemplateId) ? gridObject.model.ngTemplateId + "gridgroupcaptiontemplate" : null);
            else
                return $.render[gridObject._id + "_CaptionTemplate"](captionData);
        },
        _getCaptionColGroup: function (level) {
            var cloneColGroup = this.getHeaderTable().find("colgroup").clone();
            var colColl = cloneColGroup.find("col");
            var indentCol = colColl.length - this.model.columns.length;
            if (this.model.detailsTemplate != null || this.model.childGrid != null)
                indentCol = indentCol - 1;
            cloneColGroup.find("col:lt(" + indentCol + ")").remove();
            if (level > 0 && level != this.model.groupSettings.groupedColumns.length) {
                if (this.model.groupSettings.groupedColumns.length > 2 && level != this.model.groupSettings.groupedColumns.length - 1) {
                    for (var i = 0; i < this.model.groupSettings.groupedColumns.length - level; i++) {
                        cloneColGroup.prepend(this._getIndentCol());
                    }
                }
                else
                    cloneColGroup.prepend(this._getIndentCol());
            }
            return cloneColGroup;
        },
        _groupSummaryRow: function (item, aggregates, gridObjectId, showGroup) {
            var gridObject = this.getRsc("helpers", gridObjectId), showGroup = !ej.isNullOrUndefined(showGroup), colIndex;
            if (gridObject.model.showSummary) {
                if (gridObject.getFooterTable() == null)
                    gridObject._renderGridFooter();
                gridObject._createSummaryRows(gridObject.getFooterTable(), item.records == null ? item : item.records, aggregates, item, showGroup);
                if (gridObject._isCaptionSummary && !showGroup) {
                    var index = [];
                    var row = gridObject._captionSummary();
                    $.each(row[0].summaryColumns, function (cindx, col) {
                        index.push(gridObject.getColumnIndexByField(col.displayColumn));
                    });
                    if (index.length > 0)
                        colIndex = ej.min(index);
                    var colLength = gridObject.model.columns.length;
                    gridObject.getFooterTable().find("tbody td").slice(-(colLength - colIndex)).removeClass("e-summaryrow").addClass("e-groupcaptionsummary");
                }
                if (!gridObject.model.groupSettings.showGroupedColumn) {
                    var groupedcolumns = gridObject.model.groupSettings.groupedColumns;
                    var count = 0;
                    var gridfooterrow = gridObject.getFooterTable().children('tbody').find('tr');
                    for (var j = 0; j < gridObject.model.summaryRows.length; j++) {
                        for (var k = 0; k < gridObject.model.summaryRows[j].summaryColumns.length; k++) {
                            for (var i = 0; i < groupedcolumns.length; i++) {
                                if (groupedcolumns[i] == gridObject.model.summaryRows[j].summaryColumns[k].displayColumn) {
                                    count++;
                                    if (gridObject.model.summaryRows[j].summaryColumns.length == count) {
                                        $(gridfooterrow[j]).addClass("e-hide")
                                    }
                                }
                            }
                        }
                        count = 0;
                    }
                }
                return !showGroup ? gridObject.getFooterTable().find("tbody").find("tr").html() : gridObject.getFooterTable().find("tbody").html();
            }
        },
        addGroupingTemplate: function () {
            var tbody = document.createElement('tbody');
            var expandTd = "<td class='e-recordplusexpand' data-ej-mappingname='{{:field}}' data-ej-mappingvalue='{{:key}}'><div class='e-icon e-gdiagonalnext'></div></td>";
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "ColSpanAdjust"] = this._colSpanAdjust;
            helpers["_" + proxy._id + "Colgroup"] = this._getColGroup;
            if (ej.isNullOrUndefined(this.model.groupSettings.captionFormat))
                $.templates(proxy._id + "_CaptionTemplate", this.localizedLabels.GroupCaptionFormat);
            else
                $.templates(proxy._id + "_CaptionTemplate", this.model.groupSettings.captionFormat);
            helpers["_" + proxy._id + "CaptionFormat"] = this._captionFormat;
            helpers["_" + proxy._id + "GroupSummaryRow"] = this._groupSummaryRow;
            helpers["_" + proxy._id + "CaptionEncode"] = this._captionEncode;
            helpers[proxy._id + "Object"] = this;
            $.views.helpers(helpers);
            var caption = " ~_" + proxy._id + "CaptionFormat('" + proxy._id + "Object')";
            var cpationTd = expandTd + "<td class='e-groupcaption' colspan='{{:~_" + proxy._id + "ColSpanAdjust('" + proxy._id + "Object" + "','groupcaption') }}'>{{if ~_" + proxy._id + "CaptionEncode('" + proxy._id + "Object')}}{{html:" + caption + "}}{{else}}{{:" + caption + "}}{{/if}}</td>";
            if (this._isCaptionSummary && this.model.showSummary)
                cpationTd = cpationTd + "{{:~_" + proxy._id + "GroupSummaryRow(items, aggregates,'" + proxy._id + "Object')}}";
            var captionTr = "<tr class='e-groupcaptionrow'>" + cpationTd + "</tr>";
            var $tbody = ej.buildTag("tbody");
            $tbody.html("{{if items.GROUPGUID}}" +
                "{{for items tmpl='" + proxy._id + "_GroupingTemplate'/}}" +
                "{{else}}" +
                "{{for items tmpl='" + proxy._id + "_JSONTemplate'/}}" +
                "{{/if}}");
            var indentTd = "<td class='e-indentcell'></td>";
            var table = "<table class='e-table {{if items.GROUPGUID}}{{else}}e-recordtable{{/if}}'>" +
                "{{:~_" + proxy._id + "Colgroup('" + proxy._id + "Object')}}" +
                $tbody.html() + "{{:~_" + proxy._id + "GroupSummaryRow(items, aggregates,'" + proxy._id + "Object', '" + proxy._id + "showGroupCaption')}}" +
            "</table>";
            var tableTd = "<td class='e-tabletd' colspan='{{:~_" + proxy._id + "ColSpanAdjust('" + proxy._id + "Object" + "','table')}}'>" + table + "</td>";
            var tr = "<tr>" + indentTd + tableTd + "</tr>";
            $.templates(proxy._id + "_GroupingTemplate", captionTr + tr);
        },
        addSummaryTemplate: function () {
            var proxy = this;
            $.each(proxy.model.summaryRows, function (cindx, row) {
                $.each(row.summaryColumns, function (cindx, cols) {
                    if (!ej.isNullOrUndefined(cols.template))
                        $.templates(proxy._id + "_summaryTemplate" + cols.template, cols.template)
                });
            });
        },
        _getGroupTopLeftCell: function () {
            var $th = ej.buildTag("th.e-grouptopleftcell");
            $th.append(ej.buildTag("div.e-headercelldiv e-emptyCell", "&#160;"));
            return $th;
        },
        _getEmptyFilterBarCell: function () {
            var $th = ej.buildTag("th.e-filterbarcell e-grouptopleftcell");
            return $th;
        },
        _groupingAction: function (refWidth) {
            var $groupTopCell = this.getHeaderTable().find("thead").find(".e-columnheader:not(.e-stackedHeaderRow)").find(".e-grouptopleftcell"), $col = this.getHeaderTable().find("colgroup").find("col");
            var groupColumn = $groupTopCell.length;
            if (groupColumn) {
                this.getHeaderTable().find("colgroup").replaceWith(this._getMetaColGroup());
                (this.model.detailsTemplate != null || this.model.childGrid != null) && this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());
                $groupTopCell.remove();
                this.getHeaderTable().find("thead").find(".e-filterbar").find(".e-filterbarcell:lt(" + groupColumn + ")").remove();
            }
            if (!this.model.allowResizeToFit || refWidth)
                this.setWidthToColumns();
            for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                this.getHeaderTable().find("colgroup").prepend(this._getIndentCol());
                this.getHeaderTable().find("thead").find(".e-columnheader").prepend(this._getGroupTopLeftCell());
                this.getHeaderTable().find("thead").find(".e-filterbar").prepend(this._getEmptyFilterBarCell());
            }
            this.getHeaderTable().find(".e-columnheader").find("th.e-grouptopleftcell").last().addClass("e-lastgrouptopleftcell");
        },
        
        groupColumn: function (columnName) {
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel"))
                this._closeFDialog();
            if (!this.model.allowGrouping || $.inArray(columnName, this._disabledGroupableColumns) != -1)
                return;
            if (ej.isNullOrUndefined(this.getColumnByField(columnName)) || $.inArray(columnName, this.model.groupSettings.groupedColumns) != -1)
                return;
            this.model.groupSettings.groupedColumns.push(columnName);
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == columnName) {
                    break;
                }
            }
            this.model.sortSettings.sortedColumns.length == i && this.model.sortSettings.sortedColumns.push({ field: columnName, direction: ej.sortOrder.Ascending });
            var args = {};
            args.columnName = columnName;
            args.requestType = ej.Grid.Actions.Grouping;
            var returnValue = this._processBindings(args);
            if (returnValue) {
                if (!($.inArray(columnName, this._scolumns) != -1 || this._gridSort == columnName))
                    this.model.sortSettings.sortedColumns.pop();
                this.model.groupSettings.groupedColumns.pop();
            }
            this._primaryKeyValues = [];
        },
        
        ungroupColumn: function (columnName) {
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel"))
                this._closeFDialog();
            if (!this.model.allowGrouping &&this.model.groupSettings.groupedColumns.length == 0)
                return;
            if ($.inArray(columnName, this.model.groupSettings.groupedColumns) != -1)
                this.model.groupSettings.groupedColumns.splice($.inArray(columnName, this.model.groupSettings.groupedColumns), 1);
            else
                return null;
            if (this.model.groupSettings.groupedColumns.length == 0)
                this._LastColumnUnGroup = true;
            var column = this.getColumnByField(columnName)
            if (!this.model.groupSettings.showGroupedColumn && !column["visible"]) {
                var index = this._hiddenColumnsField.indexOf(columnName), hTxt = this.getColumnByField(columnName).headerText;
                this._hiddenColumnsField.splice(index, 1);
                this._hiddenColumns.splice(this._hiddenColumns.indexOf(hTxt), 1);
                this._visibleColumns.push(hTxt);
                this._visibleColumnsField.push(columnName);
                column["visible"] = true;
            }
            var args = {};
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                if (this.model.sortSettings.sortedColumns[i].field == columnName) {
                    if (this._scolumns.indexOf(columnName) != -1 && this.model.allowSorting && this.model.allowMultiSorting || this._gridSort == columnName)
                        if (this.model.allowSorting && this.model.allowMultiSorting) {
                            var no = $.inArray(columnName, this._scolumns);
                            this._scolumns.splice(no, 1);
                            break;
                        }
                        else {
                            this._gridSort = null;
                            break;
                        }
                    else
                        this.model.sortSettings.sortedColumns.splice(i, 1);
                    break;
                }
            }
            args.columnName = columnName;
            args.requestType = ej.Grid.Actions.Ungrouping;
			this._isUngrouping = true;
            var returnValue = this._processBindings(args);
            if (returnValue)
                this.model.groupSettings.groupedColumns.push(columnName);
            this._primaryKeyValues = [];
        },
        
        collapseGroupDropArea: function () {
            var $groupDropArea = this.element.find(".e-groupdroparea").first(), proxy = this;
            this.model.groupSettings.groupedColumns.length == 0 && this.model.groupSettings.enableDropAreaAutoSizing && $groupDropArea.animate({ height: "10px" }, 200, function () {
                if (proxy.model != null && proxy.model.groupSettings.groupedColumns.length == 0) {
                    $(this).html("").append(ej.buildTag("div.e-animatebutton e-animatebuttondown e-icon e-gdownarrow"));
                    $(this).dequeue().css("height", "auto");
                }
            });
            
        },
        
        expandGroupDropArea: function () {
            var $groupDropArea = this.element.find(".e-groupdroparea").first(), proxy = this;
            this.model.groupSettings.groupedColumns.length == 0 && proxy.model.groupSettings.enableDropAreaAutoSizing && $groupDropArea.animate({ height: "30px" }, 150, function () {
                proxy.model.groupSettings.groupedColumns.length == 0 && $groupDropArea.html(proxy.localizedLabels.GroupDropArea).append(ej.buildTag("div.e-animatebutton e-animatebuttonup e-icon e-guparrow"));
                $groupDropArea.dequeue().css("height", "30px");
            });
        },
        _enableGroupingEvents: function () {
            if (this.model.allowGrouping) {
                this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", ".e-groupdroparea", this._groupHeaderCellClick);
            }
        },
        _recalculateIndentWidth: function () {
            var proxy = this;
            var browserDetails = !ej.isIOSWebView() && this.getBrowserDetails();
            var indentWidth = this.getHeaderTable().find(".e-lastgrouptopleftcell").width(), newWidth = indentWidth, perPixel = indentWidth / 30, $col;
            if (perPixel >= 1)
                newWidth = (30 / perPixel);
            this.getHeaderTable().find("colgroup").find("col").slice(0, this.model.groupSettings.groupedColumns.length).css("width", newWidth + "px");
            var $conCol = this.getContentTable().find("table").filter(":not(.e-recordtable)");
            indentWidth = this.getHeaderTable().find(".e-lastgrouptopleftcell").width();
            if (indentWidth > 30 || (this._isCaptionSummary && (indentWidth >= 30 || (indentWidth > newWidth)))) {
                if (this._isCaptionSummary) {
                    var colgroup = this.model.isEdit ? $conCol.parent(":not(.gridform)").children("colgroup") : $conCol.children("colgroup");
                    $.each(colgroup, function (index, item) {
                        var indentCol = $(item).find("col").length - proxy.model.columns.length;
                        if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                            if (indentCol > 0)
                                indentCol = indentCol - 1;
                        }
                        $(item).find("col").slice(0, indentCol).css("width", newWidth + "px");
                    });
                }
                else {
                    if (this.model.isEdit) {
                        var colgroup = $conCol.parent(".gridform").find("colgroup");
                        this._setEditColGroup(colgroup, proxy, newWidth);
                    }
                    else
                        $conCol.children("colgroup").find("col:first-child").css("width", indentWidth + "px");
                }$col = this.getContentTable().find("colgroup").first().find("col").slice(0, this.model.groupSettings.groupedColumns.length);
                if (browserDetails && browserDetails.browser != "msie")
                    $col.css("width", newWidth + "px");
                else{
                    if (this._isCaptionSummary) 
						$col.css("width", newWidth + "px");
					else
						$col.first().css("width", ((indentWidth / this.element.width()) * 100) + "%");
				}
            } else {
                this.getContentTable().find("colgroup").first().find("col").slice(0, this.model.groupSettings.groupedColumns.length).css("width", newWidth + "px");
                if (this.model.isEdit) {
                    var colgroup = this.getContentTable().find(".gridform table").find("colgroup");
                    this._setEditColGroup(colgroup, proxy, newWidth);
                }
                this.getContentTable().find("table").filter(":not(.e-recordtable)").parent(":not(.gridform)").children("colgroup").find("col:first-child").css("width", indentWidth + "px");
            }
            if (this.model.showSummary) {
                var sumCols = this.getContentTable().find("table").filter(".e-groupsummary").find(".e-summary");
                sumCols.css("width", newWidth + "px");
            }
        },
        _setEditColGroup: function (colgroup, proxy, newWidth) {
            $.each(colgroup, function (index, item) {
                var indentCol = $(item).find("col").length - proxy.model.columns.length;
                if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                    if (indentCol > 0)
                        indentCol = indentCol - 1;
                }
                $(item).find("col").slice(0, indentCol).css("width", newWidth + "px");
            });
        },
        getFieldNameByHeaderText: function (headerText) {
            if (ej.isNullOrUndefined(this._fieldColumnNames[headerText]))
                return null;
            return this._fieldColumnNames[headerText];
        },
        
        getHeaderTextByFieldName: function (field) {
            if (ej.isNullOrUndefined(this._headerColumnNames[field]))
                return null;
            return this._headerColumnNames[field];
        },
        
        expandAll: function () {
            var recordPlus = this.element.find(".e-recordpluscollapse");
            var detailRow = this._excludeDetailRows().find(".e-detailrowcollapse");
            if (recordPlus.length != 0) {
                for (var i = 0; i < recordPlus.length; i++)
                    this.expandCollapse($(recordPlus[i]));
            }
            if (detailRow.length != 0) {
                for (var i = 0; i < detailRow.length; i++)
                    this.expandCollapse($(detailRow[i]));
            }
        },
        
        collapseAll: function () {
            var recordPlus = this.element.find(".e-recordplusexpand");
            var detailRow = this.element.find(".e-detailrowexpand");
            if (recordPlus.length != 0) {
                for (var i = 0; i < recordPlus.length; i++)
                    this.expandCollapse($(recordPlus[i]));
            }
            if (detailRow.length != 0) {
                for (var i = 0; i < detailRow.length; i++)
                    this.expandCollapse($(detailRow[i]));
            }
        },
        _group: function (args) {
            if (this.model.groupSettings.groupedColumns.length && this.model.currentViewData) {
                this._currentJsonData = [];
                this._groupContextIndex = -1;
                this._summaryContextIndex = -1;
                var temp = document.createElement('div');
                if (!this.model.groupSettings.showGroupedColumn) {
                    if (!this.initialRender && !ej.isNullOrUndefined(args.columnName) && args.requestType == "grouping") {
                        var col = this.getColumnByField(args.columnName);
                        if ($.inArray(args.columnName, this._hiddenColumnsField) == -1) {
                            var hTxt = this.getColumnByField(args.columnName).headerText;
                            this._hiddenColumnsField.push(args.columnName)
                            this._hiddenColumns.push(hTxt);
                            this._visibleColumns.splice(this._visibleColumns.indexOf(hTxt), 1);
                            this._visibleColumnsField.splice(this._visibleColumnsField.indexOf(args.columnName), 1);
                            col.visible = false;
                        }
                    }
                    else {
                        for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                            if ($.inArray(this.model.groupSettings.groupedColumns[i], this._hiddenColumnsField) == -1) {
                                this._hiddenColumnsField.push(this.model.groupSettings.groupedColumns[i]);
								this._hiddenColumns.push(this.getColumnByField(this.model.groupSettings.groupedColumns[i]).headerText);
                                this.getColumnByField(this.model.groupSettings.groupedColumns[i]).visible = false;
                            }
                        }
                    }
                    this._hideHeaderColumn(this.model.groupSettings.groupedColumns, true);
                    this.getContentTable().children("colgroup").replaceWith(this.getHeaderTable().find('colgroup').clone());
                }
                if (args.requestType == "reorder")
                    this._isReorder = true;
                else
                    this._isReorder = false;
                var $col = this.getContentTable().children("colgroup").find('col');
                var length = $col.length - this.model.columns.length;
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    length--;
                if ($col.length > this.model.columns.length)
                    this.getContentTable().children("colgroup").find('col:lt(' + length + ')').remove();
                if (!this.initialRender) {
                    this.addInitTemplate();
                    this.addGroupingTemplate();
                }
                this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                var dlen;
                if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                    dlen = this.model.groupSettings.groupedColumns.length + 1;
                }
                else
                    dlen = this.model.groupSettings.groupedColumns.length;
                for (var i = 0; i < dlen; i++)
                    this.getContentTable().children("colgroup").prepend(this._getIndentCol());
                if (this.model.currentViewData.length) {
                    var $tbody = this.getContentTable().children('tbody');
                    $tbody.empty();
                    temp.innerHTML = ['<table><tbody>', $.render[this._id + "_GroupingTemplate"](this.model.currentViewData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</tbody></table>'].join("");
                    this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                    this._hideCaptionSummaryColumn();
                }
				else if (this.model.isEdit)
                    this.cancelEdit();
                this._groupingAction();
                this._gridRows = this.getContentTable().find(".e-recordtable").find("tbody").find("tr.e-row,tr.e-alt_row").not(".e-gridSummaryRows");
                this._eventBindings();
            }
        },
        _ungroup: function () {
            this._isGrouping = false;
            if (!ej.isNullOrUndefined(this.model.detailsTemplate))
                this._detailsOuterWidth = null;
            var $header = this.element.children(".e-gridheader");
            var $filterInput = $header.find(".e-filterbar").find("th").find("input");
            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
            this.setGridHeaderContent($header);
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                this._renderFiltering();
                this._renderFilterBarTemplate();

                var filterThNew = this.element.children(".e-gridheader").find(".e-filterbar").find("th").find("input");
                for (var i = 0; i < $filterInput.length; i++)
                    filterThNew.eq(i).val($filterInput.eq(i).val());
            }
            if (!this.model.groupSettings.showGroupedColumn)
                this._hideHeaderColumn(this.model.groupSettings.groupedColumns, true);
            this.addInitTemplate();
            this.addGroupingTemplate();
            this._initiateTemplateRendering();
            this.element.find(".e-gridcontent").children("div").first().empty().append(this._renderGridContent().find("table").first());
            this.setGridContent(this.element.find(".e-gridcontent"));
            if (this.model.groupSettings.groupedColumns.length != 0)
                this._gridRows = this.getContentTable().find(".e-recordtable").find("tbody").find("tr").toArray();
            else
                this._gridRows = this.getContentTable().get(0).rows;
           if(this.element.find('.e-groupdroparea').first().hasClass('e-allowDrop'))
				this.element.find('.e-groupdroparea').first().removeClass('e-allowDrop');
        },
        _groupHeaderCellClick: function (e) {
            var $target = $(e.target);
            if ($target.hasClass('e-groupdroparea'))
                return;
            if ($target.hasClass("e-ungroupbutton")) {
                var field = $target.parent().attr("data-ej-mappingname");
                this.ungroupColumn(field);
            } else if ($target.hasClass("e-togglegroupbutton")) {
                var field = $target.parent().attr("data-ej-mappingname");
                $target.hasClass("e-toggleungroup") && this.ungroupColumn(field);
            } else if ($target.hasClass("e-animatebutton")) {
                if (!$(e.target).hasClass("e-animatebuttondown")) {
                    this.collapseGroupDropArea();
                } else {
                    this.expandGroupDropArea();
                }
            }
            else {
                $target.addClass("e-headercelldiv");
                this._mouseClickHandler(e);
                $target.removeClass("e-headercelldiv");
            }           
        },
        _captionSummary: function (nocaption) {
            var summary = null, cols = this.model.summaryRows, k, len = cols.length;
            for (k = 0; k < len; k++) {
                if (cols[k].showCaptionSummary == true) {
                    summary = $(cols[k]);
                    break;
                }
            }
            
            if (nocaption) {
                var left = cols.slice(0, k), right = cols.slice(k + 1, len);
                ej.merge(summary = left, right);
            }

            return summary;
        },
        _dropAreaHover: function (e) {
            var $target = $(e.target), proxy = this;
            if (e.type == "mouseenter") {
                if (this._dragActive) {
                    if ($target.hasClass("e-groupdroparea"))
                        $target.addClass("e-hover");
                } else
                    $target.removeClass("e-hover");
                $target.hasClass("e-groupheadercell") && this.model.groupSettings.showUngroupButton && $target.find(".e-ungroupbutton").show(150);
            } else if (e.type == "mouseleave") {
                if ($target.hasClass("e-groupdroparea")) {
                    $target.find(".e-ungroupbutton").hide(150);
                    $target.removeClass("e-hover");
                }
                $target.hasClass("e-groupheadercell") && this.model.groupSettings.showUngroupButton && $target.find(".e-ungroupbutton").hide(150);
            }
            return false;
        },
        _groupingCompleteAction: function (args) {
            var $groupDrop = this.element.children(".e-groupdroparea");
            if (this.model.groupSettings.groupedColumns.length && $groupDrop.find(".e-grid-icon").length == 0 || ej.Grid.Actions.Refresh == args.requestType)
                $groupDrop.empty();
            if (this.initialRender || ej.Grid.Actions.Refresh == args.requestType) {
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++)
                    this._addColumnToGroupDrop(this.model.groupSettings.groupedColumns[i]);
                this._refreshGridPager();
            } else
                this._addColumnToGroupDrop(args.columnName);
            this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-number").remove();
            this.getHeaderTable().find(".e-columnheader").find(".e-ascending,.e-descending").remove();
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (!this.initialRender && ej.gridFeatures.dragAndDrop)
                this._groupHeaderCelldrag();
            this.model.allowScrolling && this.getContentTable().parent().scrollLeft(this.getHeaderTable().parent().scrollLeft() - 1);
            this.element.children(".e-cloneproperties").remove();
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType))
                this._refreshFilterIcon();
        },
        _ungroupingCompleteAction: function (args) {
            var $groupDrop = this.element.children(".e-groupdroparea");
            if (args.requestType != ej.Grid.Actions.Refresh)
               this._removeColumnFromDrop(args.columnName);
            this.getHeaderTable().find(".e-columnheader").find(".e-headercelldiv").find(".e-number").remove();
            this.getHeaderTable().find(".e-columnheader").find(".e-ascending,.e-descending").remove();
            for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++)
                this._addSortElementToColumn(this.model.sortSettings.sortedColumns[i].field, this.model.sortSettings.sortedColumns[i].direction);
            if (this.model.groupSettings.groupedColumns.length == 0) {
                $groupDrop.html(this.model.groupSettings.enableDropAreaAutoSizing ? "" : this.localizedLabels.GroupDropArea);
                this.model.groupSettings.enableDropAreaAutoSizing && $groupDrop.append(ej.buildTag("div.e-animatebutton e-icon").addClass(this.model.groupSettings.enableDropAreaAutoSizing ? "e-animatebuttondown e-gdownarrow" : "e-animatebuttonup e-guparrow"));
                $groupDrop.css("height", "auto");
            }
            if (ej.gridFeatures.dragAndDrop)
                this._headerCellgDragDrop();
            if (this.model.allowReordering && ej.gridFeatures.dragAndDrop)
                this._headerCellreorderDragDrop();
            this.model.allowScrolling && this.getContentTable().parent().scrollLeft(this.getHeaderTable().parent().scrollLeft() -1);
            this.element.children(".e-cloneproperties").remove();
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType))
                this._refreshFilterIcon();
        },
        _getToggleButton: function () {
            return ej.buildTag("span.e-togglegroupbutton e-icon e-gridgroupbutton", "&#160;");
        },
        _checkEinHeader: function (field) {
            var $headerCell = this.element.children(".e-gridheader").find("thead").find(".e-columnheader").find(".e-headercell");
            for (var i = 0; i < $headerCell.length; i++) {
                if ($.trim($headerCell.eq(i).find("div").attr("data-ej-mappingname")) == field)
                    return $headerCell.eq(i);
                else if (this.model.allowSorting && this.model.allowMultiSorting) {
                    var header = $($headerCell.eq(i)).clone();
                    header.find(".e-number").remove();
                    if ($.trim(header.find("div").attr("data-ej-mappingname")) == field)
                        return header;
                }
            }
            return null;

        },

        _checkEinGroupDrop: function (field) {
            var $groupHeaderCell = this.element.children(".e-groupdroparea").find(".e-grid-icon");
            for (var i = 0; i < $groupHeaderCell.length; i++) {
                if ($.trim($groupHeaderCell.eq(i).find("div").attr("data-ej-mappingname")) == field)
                    return $groupHeaderCell.eq(i);
            }
            return null;
        },

        _addColumnToGroupDrop: function (field) {
            var $groupedColumn = ej.buildTag("div.e-grid-icon e-groupheadercell"), $groupDropArea = this.element.find(".e-groupdroparea").first();
            var $childDiv = ej.buildTag("div", {}, {}, { "data-ej-mappingname": field }), imageDirection = "e-rarrowup-2x";
            var column = this.getColumnByField(field)
            if (column.disableHtmlEncode)
                $groupedColumn.append($childDiv.text(column.headerText));
            else if (column.headerTemplateID)
                $groupedColumn.append($childDiv.html($(column.headerTemplateID).html()))
            else
                $groupedColumn.append($childDiv.html(column.headerText));
            var $headerCell = this._checkEinHeader(field);
            if (this.model.groupSettings.showToggleButton) {
                $childDiv.append(this._getToggleButton().addClass("e-toggleungroup"));
                $headerCell.find(".e-togglegroupbutton").remove().end().append(this._getToggleButton().addClass("e-toggleungroup"));
            }
            var direction = "ascending";
            if ($headerCell.find(".e-ascending,.e-descending").length) {
                direction = $headerCell.find(".e-ascending,.e-descending").hasClass("e-ascending") ? "ascending" : "descending";
                imageDirection = direction == "ascending" ? "e-rarrowup-2x" : "e-rarrowdown-2x";
            }
            $childDiv.append(this._createSortElement().addClass("e-" + direction + " " + imageDirection));
            this.model.groupSettings.showUngroupButton && $childDiv.append(ej.buildTag("span.e-ungroupbutton e-icon e-cancel", " ", {}, { title: this.localizedLabels.UnGroup }));
            $groupDropArea.append($groupedColumn).css("height", "auto");
            var left = $groupedColumn.offset().left, $cloned = $groupedColumn.clone().css("position", "absolute"), proxy = this;
            $groupedColumn.css("visibility", "hidden")
            $groupDropArea.append($cloned).dequeue();
            $cloned.css({ "left": left + 150 }).animate({ left: left }, 150, function (e) {
                $groupedColumn.css("visibility", "visible");
                $cloned.remove();
            });
        },
        _removeColumnFromDrop: function (field) {
            var headerText = this.getHeaderTextByFieldName(field), proxy = this, $groupDropArea = this.element.children(".e-groupdroparea");
            var $groupHeaderCell = $groupDropArea.css("height", "30px").find(".e-grid-icon");
            for (var i = 0; i < $groupHeaderCell.length; i++) {
                if ($.trim($groupHeaderCell.eq(i).find("div").attr("data-ej-mappingname")) == field) {
                    if (this.model.groupSettings.groupedColumns.length == 0) {
                        this.collapseGroupDropArea();
                    } else
                        $groupHeaderCell.eq(i).remove();
                }
            }
        },
        _setAggreatedCollection: function (clonedQuery) {
            if ((this._dataSource() instanceof ej.DataManager && this._dataManager.dataSource.url != undefined && !this._isRemoteSaveAdaptor && !this._dataManager.dataSource.offline) || this.model.enableLoadOnDemand)
                return;
            var data;
            data = this._dataManager.executeLocal(clonedQuery).result;
            this._aggregatedCollection = data;
        },
        _setAggregates: function (data, collection) {
            var indx, pred, query = new ej.Query();
            data = data || this.model.currentViewData, collection = collection || this._aggregatedCollection;
            var dLen = data.length, cLen;
            if (dLen != 0){
                var fieldPred = ej.Predicate("field", "equal", data[0].field), keyPred = ej.Predicate("key", "equal", data[0].key);
                if(data[0].key instanceof Date) {
                    var dateObject = { value: data[0].key, operator : "equal", field : "key" };
                    keyPred = this._setDateFilters(dateObject,true);
                }
                pred = (fieldPred["and"](keyPred));
            }
            for (indx = 1; indx < dLen; indx++) {
                var fieldPred = ej.Predicate("field", "equal", data[indx].field), keyPred = ej.Predicate("key", "equal", data[indx].key);
                if(data[indx].key instanceof Date) {
                    var dateObject = { value: data[indx].key, operator : "equal", field : "key" };
                    keyPred = this._setDateFilters(dateObject,true);
                }
                pred = pred["or"](fieldPred["and"](keyPred));
            }
            collection = pred ? new ej.DataManager(collection).executeLocal(query.where(pred)) : collection;
            cLen = collection.length;
            if (data.length > 0) {
                for (indx = 0; indx < cLen; indx++) {
                    if (indx > 0 && indx < cLen - 1) continue;
                    data[indx].count = collection[indx].count; 
                    if (data[indx].items.GROUPGUID)
                        this._setAggregates(data[indx].items, collection[indx].items);
                    if (this.model.showSummary) { 
                        var agg = data[indx]["aggregates"] = [];
                        var rows = this.model.summaryRows, scolumns, summaryData;
                        for (var row = 0, rlen = rows.length; row < rlen; row++) {
                            scolumns = rows[row].summaryColumns;
                            for (var col = 0, clen = scolumns.length; col < clen; col++) {
                                summaryData = collection[indx].items.level ? collection[indx].items.records : collection[indx].items;
                                agg[scolumns[col].dataMember + " - " + scolumns[col].summaryType] = this.getSummaryValues(scolumns[col], summaryData);
                            }
                        }
                    }
                }
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.dragAndDrop = {
        _headerCellgDragDrop: function () {
            var proxy = this;
            this.dragHeaderElement();
            var $droppableElements = this.element.children("div.e-groupdroparea");
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible"))
                        return;
                    var column = proxy.getColumnByField($.trim($(ui.draggable[0]).find("div").attr("data-ej-mappingname")));
                    ui.helper.remove();
                    if (proxy._disabledGroupableColumns.length && $.inArray(column["field"], proxy._disabledGroupableColumns) != -1)
                        return;
                    if (!(ej.isNullOrUndefined(column)) && (!(ej.isNullOrUndefined(column.field) || column.field == "")))
                        proxy.groupColumn(column.field);
                    if (proxy.model.allowGrouping)
                        proxy.collapseGroupDropArea();
                }
            });
        },
        _headerCellreorderDragDrop: function () {
            var proxy = this;
            this.dragHeaderElement();
            var $droppableElements = this.element.find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible") || $(ui.draggable[0]).closest('.e-grid').attr("id") != proxy._id)
                        return;
                    if (ui.draggable.attr("aria-sort") == "ascending" || ui.draggable.attr("aria-sort") == "descending") {
                        var scolumn = proxy.getColumnByField($.trim($(ui.draggable[0]).find("div").attr("data-ej-mappingname")));
                        if (proxy.model.allowSorting && proxy.model.allowMultiSorting)
                            proxy._scolumns.push(scolumn.field);
                        else
                            proxy._gridSort = scolumn.field;
                    }
                    var column, dropcolumn, fromindex, toindex, droppedIndex;
                    var draggedIndex = ui.draggable.index();
                    if (event.dropTarget.hasClass("e-headercelldiv"))
                        droppedIndex = event.dropTarget.parent().index();
                    else if (event.dropTarget.parent().hasClass("e-headercell") || event.dropTarget.hasClass("e-headercell"))
                        droppedIndex = event.dropTarget.index();
                    if ($(event.dropTarget).hasClass("e-number") || $(event.dropTarget).hasClass("e-icon") || event.dropTarget.closest(".e-headercelldiv"))
                        droppedIndex = event.dropTarget.closest(".e-headercell").index();
                    if (proxy.model.scrollSettings.frozenColumns > 0) {
                        fromindex = ui.draggable.closest('.e-frozenheaderdiv').length > 0 ? draggedIndex : draggedIndex + proxy.model.scrollSettings.frozenColumns;
                        toindex = event.dropTarget.closest('.e-frozenheaderdiv').length > 0 ? droppedIndex : droppedIndex + proxy.model.scrollSettings.frozenColumns;
                    }
                    else {
                        fromindex = draggedIndex;
                        toindex = droppedIndex;
                    }
                    if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length > 0) {
                        fromindex = fromindex - proxy.model.groupSettings.groupedColumns.length;
                        toindex = toindex - proxy.model.groupSettings.groupedColumns.length;
                    }
                    if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null) {
                        fromindex = fromindex - 1;
                        toindex = toindex - 1;
                    }
                    column = proxy.getColumnByIndex(fromindex);
                    dropcolumn = proxy.getColumnByIndex(toindex);
                    var field = !ej.isNullOrUndefined(column) && !ej.isNullOrUndefined(column.field) && column.field != "" ? column.field : null;
                    var field2 = !ej.isNullOrUndefined(dropcolumn.field) && dropcolumn.field != "" ? dropcolumn.field : null;
                    ui.helper.remove();
                    var header = $(event.dropTarget).clone();
                    header.find(".e-number").remove();
                    if (!ej.isNullOrUndefined(field) && !ej.isNullOrUndefined(field2)) {
                        if ($(event.dropTarget).hasClass("e-droppable")) {
                            header = header.children(".e-headercelldiv");
                            var eDropTarget = $(event.dropTarget).children(".e-headercelldiv");
                        }
                        else {
                            header = $(event.dropTarget).siblings(".e-headercelldiv");
                            var eDropTarget = $(event.dropTarget);
                            if ($(eDropTarget).hasClass("e-filtericon"))
                                eDropTarget = header = $(eDropTarget).siblings(".e-headercelldiv");
                        }
                        if (proxy.model.allowSorting && proxy.model.allowMultiSorting){
                            if (event.dropTarget.hasClass("e-number") || event.dropTarget.hasClass("e-icon")) 
                                var toColumn = proxy.getColumnByField($.trim(header.attr("data-ej-mappingname")));							                            
                            else 
                                var toColumn = proxy.getColumnByField($.trim(eDropTarget.attr("data-ej-mappingname")));
                            }
                        else {
                            if (event.dropTarget.hasClass("e-icon") && !event.dropTarget.hasClass("e-filtericon"))
                                var toColumn = proxy.getColumnByField($.trim(header.attr("data-ej-mappingname")));
                            else
                                var toColumn = proxy.getColumnByField($.trim(eDropTarget.attr("data-ej-mappingname")));
                        }
						if(ej.isNullOrUndefined(toColumn) && event.dropTarget.closest(".e-headercelldiv"))
							 var toColumn = proxy.getColumnByField($.trim(eDropTarget.closest(".e-headercelldiv").attr("data-ej-mappingname")));							
                        proxy.reorderColumns(column.field, toColumn.field);
                    }
                    else {
                        proxy.reorderColumns(fromindex, toindex);
                    }
                    if (proxy.model.allowGrouping)
                        proxy.collapseGroupDropArea();
                }
            });
        },

        dragHeaderElement: function () {
            var proxy = this;
            var $dragableElements = this.element.children("div.e-gridheader").find("th.e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            var $visualElement = ej.buildTag('div.e-cloneproperties', "", { 'height': '20px', 'z-index': 2 }), column;
            //header element columnDrag
            $dragableElements.ejDraggable({
                cursorAt: { top: 0, left: 0 },
                helper: function (event, ui) {
                    if (proxy.element.find(".e-dragclone").length > 0) proxy.element.find(".e-dragclone").remove();
                    var $th, hcell;
                    if ($(event.element).hasClass("e-headercell"))
                        $th = $(event.element);
                    else
                        $th = $(event.element).closest("th");
                    hcell = $th.find(".e-headercelldiv");
                    var columnIndex = $(event.element).index();
                    if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length > 0)
                        columnIndex = columnIndex - proxy.model.groupSettings.groupedColumns.length;
                    else if (proxy.model.detailsTemplate != null || proxy.model.childGrid != null)
                        columnIndex = columnIndex - 1;
                    column = proxy.getColumnByIndex(columnIndex);
                    proxy._$curSElementTarget = hcell; 
                    if (proxy.model.allowSorting && proxy.model.allowMultiSorting) {
                        var header = $($th).clone();
                        header.find(".e-number").remove();
                        return $visualElement.text(header.text()).clone().width($th.outerWidth() + 2).height($th.height() + 2).css({ "font-size": parseInt(($th.height() + 3) / 2) }).addClass("e-dragclone").appendTo(proxy.element);
                    }
                    else
                        return $visualElement.text($th.text()).clone().width($th.outerWidth() + 2).height($th.height() + 2).css({ "font-size": parseInt(($th.height() + 3) / 2) }).addClass("e-dragclone").appendTo(proxy.element);
                },
                dragStart: function (args) {
                    var target = args.target , $target = $(target);
                    var data = { target: target, draggableType: "headercell", column: column }, isGrouped, toggleClass, dragOnToggle = false;
                    if (proxy.model.groupSettings.showToggleButton && column && column.allowGrouping) {
                        isGrouped = $.inArray(column.field, proxy.model.groupSettings.groupedColumns);
                        toggleClass = $(args.element).find(".e-togglegroupbutton").hasClass("e-togglegroup");
                        if ((isGrouped != -1 && toggleClass) || (isGrouped == -1 && !toggleClass))
                            dragOnToggle = true;
                    }
                    if ((proxy._resizer != null && proxy._resizer._expand) || dragOnToggle || $target.eq(0).hasClass("e-filtericon") || (column && column.allowGrouping == false && column.allowReordering == false)) {
                        $(".e-dragclone").remove();
                        return false;
                    }
                    proxy._dragActive = true; 
                    if (proxy.model.allowGrouping)
                        proxy.expandGroupDropArea();
                    if (proxy._trigger("columnDragStart", data))
                        return false;
                },
                drag: function (args) {
                    var $target = $(args.target);
                    var data = { target: $target, draggableType: "headercell", column: column };
                    if (proxy._trigger("columnDrag", data))
                        return false;
                    if ($target.closest(".e-grid").attr("id") !== proxy._id)
                        return;
                    proxy.getHeaderTable().find(".e-headercell").removeClass("e-reorderindicate");
                    if (proxy.model.allowReordering && ($target.hasClass('e-headercelldiv') || $target.hasClass('e-headercell')) && !$target.hasClass('e-detailheadercell') && !$target.hasClass('e-stackedHeaderCell') && !$target.parent().hasClass("e-grouptopleftcell")) {
                        document.body.style.cursor = '';
                        $target.addClass("e-allowDrop");
                        proxy.getHeaderTable().find(".e-reorderindicate").removeClass("e-reorderindicate");
                        if ($target.hasClass('e-headercell')) $target.addClass("e-reorderindicate");
                        else $target.parent().addClass("e-reorderindicate");
                    }
                    if (proxy.model.allowScrolling) {
                        var pos = args.event.type == "touchmove" ? args.event.originalEvent.touches[0].pageX : args.event.pageX;
                        proxy._dragAutoScrollX(pos, args);
                    }
                    if ($target.hasClass('e-groupdroparea') || $target.closest('.e-groupdroparea').length) {
                        document.body.style.cursor = 'default';
                        $target.addClass("e-allowDrop");
                    }
                    else if ($target.hasClass('e-headercelldiv') || $target.hasClass('e-headercell')) {
                        document.body.style.cursor = 'pointer';
                    } else if ($target.hasClass("e-rowcell"))
                        document.body.style.cursor = 'not-allowed';
                },
                dragStop: function (args) {
                    if (!args.element.dropped) {
                        var $target = $(args.target);
                        var data = { target: $target, draggableType: "headercell", column: column };
                        proxy._trigger("columnDrop", data);
                        proxy.element.find(".e-groupdroparea").removeClass("e-hover");
                        proxy.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive").removeClass("e-active");
                        if (!($(args.target).closest(".e-groupdroparea").length || ($(args.target).closest(".e-columnheader").length && proxy.model.allowReordering && !$(args.target).hasClass("e-stackedHeaderCell"))))
                            $(".e-dragclone").remove();
                        if ($(args.target).hasClass("e-rowcell") || $(args.target).hasClass("e-stackedHeaderCell"))
                            proxy.collapseGroupDropArea();
                        proxy._dragActive = false;
                        proxy.getHeaderTable().find(".e-reorderindicate").removeClass("e-reorderindicate");
                        document.body.style.cursor = '';
                        $(proxy._Indicator).css('display', 'none');
                    }
                }
            });
        },
        _groupHeaderCelldrag: function () {
            //grouped header cell drag.
            var $visualElement = ej.buildTag('div.e-cloneproperties e-grid', "", { 'height': '20px', 'z-index': 2 }), proxy;
            proxy = this;
            var $groupedHeaderCells = this.element.children(".e-groupdroparea").find(".e-groupheadercell");
            $groupedHeaderCells.ejDraggable({
                cursorAt: { top: 0, left: 0 },
                helper: function (event, ui) {
                    var $div = $(event.sender.target).closest(".e-grid-icon");
                    return $visualElement.text($(event.sender.target).closest(".e-groupheadercell").text()).clone().width($div.width() + 2).height($div.height() + 2).addClass("e-dragclone").appendTo(proxy.element);
                },
                dragStart: function (args) {
                    var target = args.target;
                    args.model.cursorAt = { top: 0, left: 0 };
                    var data = { target: target, draggableType: "groupheadercell" };
                    if (proxy._trigger("columnDragStart", data))
                        return false;
                },
                drag: function (args) {
                    $(".Sibling").remove();
                    var $target = $(args.target);
                    var data = { target: $target, draggableType: "groupheadercell" };
                    if (proxy._trigger("columnDrag", data))
                        return false;
                    if ($target.closest('div.e-gridcontent').length) {
                        document.body.style.cursor = '';
                        $target.addClass("e-allowDrop");
                    }
                    else if ($(args.target).closest(".e-columnheader").length > 0) {
                        document.body.style.cursor = 'pointer';
                    }
                    else
                        document.body.style.cursor = 'not-allowed';
                },
                dragStop: function (args) {
                    $(args.element).data("targetInstance", proxy);
                    if (!args.element.dropped) {
                        var $target = $(args.target);
                        var data = { target: $target, draggableType: "groupheadercell" };
                        if (!($(args.target).closest(".e-rowcell").length || $(args.target).closest(".e-groupcaption").length || $(args.target).closest(".e-columnheader").length ))
                            $(".e-dragclone").remove();
                        document.body.style.cursor = '';
                    }
                }
            });

            //grid content drop
            var $contentDroppableElements = this.element.children(".e-gridcontent, .e-gridheader");
            $contentDroppableElements.ejDroppable({
                accept: proxy.element.children("div.e-groupdroparea").find(".e-groupheadercell"),
                drop: function (event, ui) {
                    if (ej.isNullOrUndefined(ui.helper) || !ui.helper.is(":visible") || !ui.draggable.hasClass("e-groupheadercell"))
                        return;
                    var field = $(ui.draggable[0]).find("div").attr("data-ej-mappingname");
                    ui.helper.remove();
                    if (!ej.isNullOrUndefined(field)) {
                        var childProxy = $(ui.draggable).data("targetInstance");
                        childProxy.ungroupColumn(field);
                    }
                }
            });
        },

        //Rows DragAndDrop
        _rowsDragAndDrop: function () {
            this.dragRowElement();
            var $droppableElements = this.getContent();
            var proxy = this;
            $droppableElements.ejDroppable({
                accept: $droppableElements,
                drop: function (event, ui) {
                    var targetRow = $(event.dropTarget).closest("tr"), srcControl, currentPageIndex;
                    if (!ui.helper.find("tr.e-srcgridinfo").length)
                        return false;
                    proxy._draggedGridID = ui.helper.find("tr.e-srcgridinfo").children("td").text();
                    if (proxy._draggedGridID != proxy._id)
                        srcControl = $("#" + proxy._draggedGridID).ejGrid("instance");
                    else
                        srcControl = proxy;
                    if (srcControl._id != proxy._id && srcControl.model.rowDropSettings.dropTargetID != "#" + proxy._id)
                        return false;
                    var records =srcControl.selectedRowsIndexes.length >0 ? srcControl.getSelectedRecords():$(srcControl._currentJsonData[srcControl._dragIndex]);
                    if(!ej.isNullOrUndefined(srcControl._dragIndex))
					  srcControl._dragIndex = null;
					var targetIndex = currentPageIndex = proxy.getIndexByRow(targetRow), count = 0;
                    if (targetIndex == -1){
                        targetIndex = currentPageIndex = 0;
                        if(proxy.getRows().length != 0)
                            targetIndex = proxy.getRows().length;
                    }
                    var currentPage = proxy._currentPage() || 1;
                    targetIndex = targetIndex + (currentPage * proxy.model.pageSettings.pageSize) - proxy.model.pageSettings.pageSize;
                    var dropDetails = { sourceID: srcControl._id, destinationID: proxy._id, destinationRowIndex: targetIndex };
                    var args = { target: targetRow, targetIndex: targetIndex, draggedRecords: records, dropDetails: dropDetails };
                    if (proxy._trigger("beforeRowDrop", args)){
                        $(".e-dragclone").remove();
                        return;
                    }                   
                    var dataSource = proxy._dataSource() instanceof ej.DataManager ? proxy._dataSource().dataSource : proxy._dataSource();
                    if (!ej.isNullOrUndefined(proxy.model.rowDropSettings.dropMapper)) {
                        if (ej.isNullOrUndefined(dataSource.headers))
                            dataSource.headers = [];
                        dataSource.headers.push({ rowDropDetails: JSON.stringify(dropDetails) });
                    }
                    if (proxy._id != srcControl._id) {
                        var dm = proxy._dataManager, adaptor = proxy._dataSource().adaptor;
                        var srcBatch = srcControl.getBatchChanges();
                        if(srcControl.model.rowDropSettings.dragBehavior == "move")
                        srcBatch["deleted"] = records;
                        var args = { dropDetails: dropDetails, records: records, requestType: ej.Grid.Actions.Refresh, targetIndex: targetIndex, action: "rowDragged" };
                        proxy._processDropRequest(srcControl, srcBatch, "drag", args);

                        var batch = proxy.getBatchChanges(); batch["added"] = records;
                        args.action = "rowDropped";
                        proxy._processDropRequest(proxy, batch, "drop", args);
                    }
                    else {
                        if (proxy._draggedGridID == proxy._id) {
                            proxy.reorderRows(srcControl.selectedRowsIndexes, currentPageIndex);
                            $(".e-dragclone").remove();
                        }
                    }
                }
            });
        },
        _dragAutoScrollX: function (pos, args) {
            var Position = pos - this.element.offset().left;
            var contentwidth = this.element.width() - this.model.scrollSettings.scrollerSize;
            var scrollObj = this.getScrollObject();
            var proxy = this;
            if (scrollObj && scrollObj._hScrollbar) {
                if (Position < 5) {
                    this._dragLeftInterval = setInterval(function () {
                        if (proxy._dragLeftInterval) {
                            var scrolLeft = scrollObj.scrollLeft();
                            var AvgWidth = ej.sum(proxy.columnsWidthCollection) / proxy.model.columns.length;
                            if (scrolLeft > scrollObj._hScrollbar.model.minimum) {
                                if (scrolLeft > AvgWidth)
                                    scrollObj.scrollX(scrollObj.scrollLeft() - AvgWidth, true);
                                else
                                    scrollObj.scrollX(scrollObj._hScrollbar.model.minimum, true);
                            }
                            else
                                proxy._dragLeftInterval && (proxy._dragLeftInterval = clearInterval(proxy._dragLeftInterval));
                        }
                    }, 500);
                }
                else if (Position > (contentwidth - 5)) {
                    this._dragRightInterval = setInterval(function () {
                        if (proxy._dragRightInterval) {
                            var scrollLeft = scrollObj.scrollLeft();
                            var AvgWidth = ej.sum(proxy.columnsWidthCollection) / proxy.model.columns.length;
                            if (Math.round(scrollLeft) < scrollObj._hScrollbar.model.maximum)
                                scrollObj.scrollX(scrollObj.scrollLeft() + AvgWidth, true);
                            else
                                proxy._dragRightInterval && (proxy._dragRightInterval = clearInterval(proxy._dragRightInterval));
                        }
                    }, 500);
                }
                else {
                    this._dragLeftInterval && (this._dragLeftInterval = clearInterval(this._dragLeftInterval));
                    this._dragRightInterval && (this._dragRightInterval = clearInterval(this._dragRightInterval));
                }
            }
        },
        _dragAutoScroll: function (proxy, args) {
            var scrollObj = proxy.getContent().data("ejScroller");
            var contentOffset = proxy.getContent()[0].getBoundingClientRect();
            if (!contentOffset)
                contentOffset = proxy.getContent().offset();
            if (scrollObj && scrollObj._vScrollbar) {
                if (contentOffset.top >= args.event.clientY) {
                    proxy._dragUpInterval = setInterval(function () {
                        if (proxy._dragUpInterval) {
                            var scrollPixel = -proxy.getRowHeight();
                            var scrolTop = scrollObj.scrollTop();
                            if (scrolTop != 0)
                                scrollObj.scrollY(scrollObj.scrollTop() + scrollPixel, true);
                            else
                                proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));

                        }
                    }, 500);

                }
                else if (contentOffset.top + proxy.getContent().height() <= args.event.clientY) {
                    proxy._dragDownInterval = setInterval(function () {
                        if (proxy._dragDownInterval) {
                            var scrollPixel = proxy.getRowHeight();
                            var scrolTop = scrollObj.scrollTop();
                            if (Math.round(scrolTop) <= scrollObj._vScrollbar.model.maximum)
                                scrollObj.scrollY(scrollObj.scrollTop() + scrollPixel, true);
                            else
                                proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));

                        }
                    }, 500);

                }
                else {
                    proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));
                    proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));
                }
            }
        },
        dragRowElement: function () {
            var proxy = this;
            var $dragableElements = $(this.getRows());
            var column;
            //header element columnDrag
            $dragableElements.ejDraggable({
                cursorAt: { top: -8, left: -8 },
                helper: function (event, ui) {
                    this.clone = true;
                    var tr = $(event.element).closest("tr"),$tr;
                    if (proxy._selectDrag || !tr.length || ($.inArray(proxy.getIndexByRow(tr), proxy.selectedRowsIndexes) == -1 && proxy.model.selectionType != "single") )
                        return false;
                    var $visualElement = ej.buildTag('div.e-cloneproperties e-draganddrop e-grid', "", { 'height': 'auto', 'z-index': 2, 'position': 'absolute', 'width': proxy.element.width() }), $tr;
                    $visualElement.append(ej.buildTag("table", "", { 'width': proxy.element.width() }));
                    var rows = $(proxy.getRows()).clone().removeClass();
                    var height = 0;
					if(proxy.model.selectionType != "single" && proxy.selectedRowsIndexes.length >0){
						$tr = $.map(rows, function (ele, idx) {
						if ($.inArray(idx, proxy.selectedRowsIndexes) != -1) {
                            return ele
                        }
						$($tr).find("td").removeClass("e-selectionbackground e-active");
						if (!tr.find("td.e-selectionbackground").length)
							$visualElement.css("display", "none");
						});
					}
					else
						$tr = tr.clone();
                    var infoTr = ej.buildTag('tr.e-srcgridinfo e-grid', "", { 'display': 'none', 'height': 'auto' }).append("<td>" + proxy._id + "</td>");
                    $tr.push(infoTr[0]);
                    $visualElement.find("table").append($tr);
                      return $visualElement.addClass("e-dragclone").appendTo($('body'));
                },
                dragStart: function (args) {
                    var tr = $(args.target).closest("tr");
                    if (proxy._selectDrag ||($.inArray(proxy.getIndexByRow(tr), proxy.selectedRowsIndexes) == -1 && proxy.model.selectionType != "single"))
                        return false;
                    var target = args.target;
                    var rows = proxy.selectedRowsIndexes.length >0  ?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):tr;
                    if(proxy.model.selectionType != "single" && proxy.selectedRowsIndexes.length >0)
					{
						var records = proxy.getSelectedRecords();	
					}
					 else{
						proxy._dragIndex=proxy.getIndexByRow(tr);
						var records = proxy._currentJsonData[proxy._dragIndex];				
					}	
                    var data = { target: rows, currentTarget: target, draggableType: "rows", data: records, draggedRecords: records };
                    if (proxy._trigger("rowDragStart", data)){
                        $(".e-dragclone").remove();
                        return false;
                    }
                },
                drag: function (args) {
                    var $target = $(args.target), isGrid = $target.closest(".e-grid");
                    if (args.event.type == 'touchmove' && isGrid.length) {
                        isGrid.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                        $target.closest(".e-rowcell").parent().addClass("e-hover");
                    }
                    var rows = proxy.selectedRowsIndexes.length >0?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):proxy.getRowByIndex(proxy._dragIndex);
                    var records = proxy.selectedRowsIndexes.length >0?proxy.getSelectedRecords():proxy._currentJsonData[proxy._dragIndex];
					var data = { target: rows, currentTarget: $target, draggableType: "rows", data: records, draggedRecords: records};
                    proxy._dragAutoScroll(proxy, args);
                    if (proxy._trigger("rowDrag", data)){
                        $(".e-dragclone").remove();
                        return false;
                    }
                    document.body.style.cursor = 'not-allowed';
                    var dropEle = $(proxy.model.rowDropSettings.dropTargetID);
                    if ($target.closest(proxy.model.rowDropSettings.dropTargetID).length || $target.closest("#" + proxy._id).length) {
                        if ($target.closest(".e-grid").length && ($target.closest(".e-rowcell").length || $target.closest(".emptyrecord").length))
                            $target.closest("table").addClass("e-allowRowDrop")
                        else if (!dropEle.hasClass("e-grid"))
                            dropEle.addClass("e-allowRowDrop");
                    }
                },
                dragStop: function (args) {
                    var $target = $(args.target), isGrid = $target.closest(".e-grid");
                    if (args.event.type == 'touchend' && isGrid.length)
                        isGrid.find(".e-row.e-hover,.e-alt_row.e-hover").removeClass("e-hover");
                    if (!args.element.dropped) {
                        proxy._dragUpInterval && (proxy._dragUpInterval = clearInterval(proxy._dragUpInterval));
                        proxy._dragDownInterval && (proxy._dragDownInterval = clearInterval(proxy._dragDownInterval));
                        var rows = proxy.selectedRowsIndexes.length >0?proxy.getRowByIndex(proxy.selectedRowsIndexes[0], proxy.selectedRowsIndexes[proxy.selectedRowsIndexes.length]):proxy.getRowByIndex(proxy._dragIndex);
                        var records = proxy.selectedRowsIndexes.length >0?proxy.getSelectedRecords():proxy._currentJsonData[proxy._dragIndex];
						document.body.style.cursor = '';
                        var dropEle = $(proxy.model.rowDropSettings.dropTargetID);
                        dropEle.hasClass("e-grid") ? dropEle.find(".e-gridcontent").find("table").removeClass("e-allowRowDrop") : dropEle.removeClass("e-allowRowDrop");
                        proxy.getContent().find("table").removeClass("e-allowRowDrop");
                        var data = { rows: rows, target: $target, draggableType: "rows", data: records, droppedRecords: records };
						if(ej.isNullOrUndefined(this._checkTargetElement(args.event)))
						  $(".e-dragclone").remove();
                        if (proxy._trigger("rowDrop", data))
                            return false;
                    }
                }
            });
        },
        _processDropRequest: function (cntrl, batch, action, args) {
			if(args.action == "rowDragged")
				$(".e-dragclone").remove();
            var mapper = cntrl._dataManager.dataSource.batchUrl;
            cntrl._dataManager.dataSource.batchUrl = cntrl.model.rowDropSettings[action + "Mapper"];
            if (cntrl._isRemoteSaveAdaptor && cntrl._dataManager.dataSource.batchUrl == null) {
                if (action == "drop")
                    for (i = 0; i < batch.added.length; i++)
                        ej.JsonAdaptor.prototype.insert(cntrl._dataManager, batch.added[i]);
                else
                    for (i = 0; i < batch.deleted.length; i++)
                        ej.JsonAdaptor.prototype.remove(cntrl._dataManager, cntrl._primaryKeys[0], batch.deleted[i]);
            }
            var dragPromise = cntrl._dataManager.saveChanges(batch, cntrl._primaryKeys[0], cntrl.model.query._fromTable);
            if ($.isFunction(dragPromise.promise) && cntrl._dataManager.dataSource.batchUrl != null) {
                $("#" + cntrl._id).data("ejWaitingPopup").show();
                dragPromise.done(function (e) {
                    if (cntrl._isLocalData && (action == "drop")) {
                        if (args.dropDetails.sourceID == args.dropDetails.destinationID)
                            cntrl._moveDroppedRowIndex(args.targetIndex, args.records, args.draggedRowIndexes);
                        else
                            cntrl._moveDroppedRowIndex(args.targetIndex, args.records);
                    }
                    if (action == "drop")
                        cntrl._dataSource() instanceof ej.DataManager ? cntrl._dataSource().dataSource.headers.pop() : cntrl._dataSource().headers.pop();
                    cntrl._dataManager.dataSource.batchUrl = mapper;
                    cntrl.refreshBatchEditChanges();
                    $("#" + cntrl._id).data("ejWaitingPopup").hide();
                    cntrl._processBindings(args);
                });
                dragPromise.fail(function (e) {
                    cntrl._dataManager.dataSource.batchUrl = mapper;
                    $("#" + cntrl._id).data("ejWaitingPopup").hide();
                    args.error = (e && e.error) ? e.error : e;
                    cntrl._trigger("actionFailure", args)
                });
            }
            else {
                cntrl.refreshBatchEditChanges();
                cntrl._dataManager.dataSource.batchUrl = mapper;
                if (action == "drop")
                    cntrl._moveDroppedRowIndex(args.targetIndex, args.records);
                if (!(args.dropDetails.sourceID == args.dropDetails.destinationID && action == "drag"))
                    cntrl._processBindings(args);
            }
        },
        reorderRows: function (indexes, toIndex) {
            if (!this.model.sortSettings.sortedColumns.length) {
                var records = this.getSelectedRecords();
                this.selectedRowsIndexes = [];
                var args = { requestType: ej.Grid.Actions.Refresh, action: "rowReordering", draggedRowIndexes: indexes, targetIndex: toIndex, dropDetails: { sourceID: this._id, destinationID: this._id, DestinationRowIndex: toIndex }, records: records };
                if (ej.isNullOrUndefined(this.model.rowDropSettings.dropMapper)) {
                    if (this._trigger("actionBegin", args))
                        return false;
                    this._moveDroppedRowIndex(toIndex, records, indexes);
                    this._trigger("actionComplete", args)
                } else {
                    var batch = this.getBatchChanges();
                    batch["changed"] = records;
                    this._processDropRequest(this, batch, "drop", args);
                }
            }
        },
        _moveDroppedRowIndex: function (targetIndex, records, reorderFrom) {
            if (!ej.isNullOrUndefined(reorderFrom)) {
                var reorderFrom = reorderFrom.sort(function (a, b) { return a - b });
                var currentargetIndex = targetIndex, skip, index, count = 0;
                var currentRecords = this.model.currentViewData.slice();
                var targetRow = this.getRowByIndex(targetIndex);
                targetIndex += (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                for (var i = 0; i < reorderFrom.length; i++) {
                    var data = currentRecords[reorderFrom[i]];
                    index = reorderFrom[i] - count;
                    skip = 0;
                    var rows = this._excludeDetailRows();
                    var srcRow = $(rows[index]);
                    if (currentargetIndex > index)
                        count++;
                    if (this.model.allowPaging)
                        skip = (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                    index = skip + index;
                    this.selectedRowsIndexes.push(currentargetIndex - count);
                    if (i == reorderFrom.length - 1)
                        this.model.selectedRowIndex = this.selectedRowsIndexes[0];
                    if ((this.model.detailsTemplate != null || this.model.childGrid != null) && srcRow.next().hasClass("e-detailrow"))
                        srcRow = srcRow.add(srcRow.next()[0]);
                    targetRow.before(srcRow);
                    if (currentargetIndex < reorderFrom[i] - count)
                        currentargetIndex++
                    else
                        targetIndex--;
                    if (!(this._dataSource() instanceof ej.DataManager))
                        this._dataSource().splice(targetIndex + i, 0, this._dataSource().splice(index, 1)[0])
                    else
                        this._dataSource().dataSource.json.splice(targetIndex + i, 0, this._dataSource().dataSource.json.splice(index, 1)[0])
                    this.model.currentViewData.splice(targetIndex + i - skip, 0, this.model.currentViewData.splice(index - skip, 1)[0])
                }
            }
            else if (targetIndex > -1) {
                var data = this._dataSource() instanceof ej.DataManager ? this._dataSource().dataSource.json : this._dataSource();
                var currentIndex = targetIndex + (this._currentPage() * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
                for (var i = 0; i < records.length; i++) {
                    data.splice(targetIndex++, 0, data.splice(data.length - records.length + i, 1)[0]);
                }
            }
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.selection = {
        
        selectRows: function (rowIndex, toIndex, target) {
            if (!this._allowrowSelection)
                return false;
            if (this._traverseRow != rowIndex)
                $(".e-traverse").removeClass("e-traverse");
            this._traverseRow = null;
            var rowIndexCollection = [];
			if(this.initialRender)
				this.model.currentIndex = rowIndex;
			if(this.model.scrollSettings.enableVirtualization){
				if ($.isArray(rowIndex))
					this.model.currentIndex = rowIndex[0];
				else if(toIndex){
					this.model.currentIndex = rowIndex > toIndex ? toIndex : rowIndex;
				}							
			}
            if (!this.multiSelectCtrlRequest && this.model.scrollSettings.allowVirtualScrolling) {
                if (!this._virtuaOtherPage) {
                    this.clearSelection();
                    this._virtualScrollingSelection = false;
                }
                else
                    this._virtualScrollingSelection = true;
            }
            if ($.isArray(rowIndex)) {
                rowIndexCollection = rowIndex;
				rowIndex = rowIndexCollection[0];
				this._virtaulSel = [];
				if(this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization){										
					this._virtualScrollingSelection = true;
					this._virtualSelectedRows = rowIndexCollection;
					var from = (parseInt(rowIndex / this.model.pageSettings.pageSize)) * this.model.pageSettings.pageSize;
					var to = (parseInt((rowIndex / this.model.pageSettings.pageSize)) + 1) * this.model.pageSettings.pageSize;
					this._virtaulSel.push(rowIndex);
					if (!this._virtuaOtherPage)
						this._virtaulUnSel = []
					for (var i = 1; i < rowIndexCollection.length; i++) {
						if (from < rowIndexCollection[i] && rowIndexCollection[i] < to)
							this._virtaulSel.push(rowIndexCollection[i]);
						else
							this._virtaulUnSel.push(rowIndexCollection[i]);
					}										
				}
            }

            var $gridRows = $(this.getRows()),Data;
            if (this.model.allowScrolling && (this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows ==0 )) {
                var selectedRow = $gridRows.eq(rowIndex)[0];
                if (!ej.isNullOrUndefined(selectedRow) && this.model.groupSettings.groupedColumns.length == 0 && !ej.isNullOrUndefined(this.getContent().data("ejScroller"))) {
                    var scrollTop = this.getScrollObject().scrollTop();
                    var ContentViewHeight = scrollTop + this.getScrollObject().content()[0].clientHeight;
                    var selectedRowPos = selectedRow.offsetTop + selectedRow.offsetHeight;
                    var pixel = selectedRow.offsetTop, scrollObj = this.getScrollObject(), currentIndex = !target ? Math.ceil((rowIndex + 1) / this._virtualRowCount) : parseInt($(this._gridRows[rowIndex]).attr("name"), 32);
                    if (this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                        selectedRowPos += (ej.min(this._currentLoadedIndexes) - 1) * this._virtualRowCount * this._vRowHeight;
                        pixel = (this.model.currentIndex * this._vRowHeight) + rowIndex + selectedRow.offsetHeight;
                    }
                    var scrollBottom = ((selectedRowPos - this._vRowHeight) <= scrollTop && selectedRowPos < ContentViewHeight);
                    if (!ej.isNullOrUndefined(selectedRow) && ContentViewHeight < selectedRowPos || scrollBottom) {
                        if (scrollBottom) pixel = selectedRowPos - selectedRow.offsetHeight;
                        (!this.model.scrollSettings.enableVirtualization || $.inArray(currentIndex, this._currentLoadedIndexes) != -1) && scrollObj.scrollY(pixel);
                    }
                }
            }
            var args = {}, ascend, res, currentPage = this._currentPage() - 1, pageSize = this.model.pageSettings.pageSize;
            if (!this.model.scrollSettings.enableVirtualization) {
                var nameIndx = this.getRowByIndex(rowIndex).attr("name");
                var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
            }
            if (!ej.isNullOrUndefined(rowIndex)) {
                if (this.model.editSettings.editMode == "batch" && $($gridRows[rowIndex]).hasClass("e-insertedrow")) {
                    var addedrows = this.batchChanges.added.reverse();
                    Data = addedrows[rowIndex];
                    this.batchChanges.added.reverse();
                }
                else
                    Data = this.model.editSettings.editMode == "batch"?this._currentJsonData[rowIndex - this.batchChanges.added.length]:this._currentJsonData[ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex];
            }
            var $rowIndex = rowIndex, $prevIndex = this._previousIndex, $prevRow = this.getRowByIndex(this._previousIndex), isSelection = "selectRows";
            args = { rowIndex: $rowIndex, row: $gridRows.eq(rowIndex), data: Data, selectedData: Data, target: target, prevRow: $prevRow, prevRowIndex: $prevIndex };
            if (this.model.scrollSettings.allowVirtualScrolling) {
                args = this._getVirtualRows(rowIndex, target, isSelection, rowIndexCollection);
                if(args == false)
                    return;
                if (!this.model.scrollSettings.enableVirtualization)
                    $rowIndex = rowIndex = args.rowIndex;
                else if (this._enableCheckSelect && ej.isNullOrUndefined(target) && args.row.length)
                    $rowIndex = rowIndex = args.row.index();
                Data = args.data;
                $prevIndex = args.prevRowIndex;
                $prevRow = args.prevRow;
            }
            if (this._trigger("rowSelecting", args)) {
                if (this._enableCheckSelect && !ej.isNullOrUndefined(target) && (args.target.parent(".e-checkcelldiv").length || target.hasClass("e-checkselectall") ))
                    target.prop("checked", this.model.enableTouch);
                return;
            }
            if (target && target.hasClass("e-checkselectall") && this._isLocalData && this._isMapSelection)
                return this._headerCheckUpdateAll(!target[0].checked);
            var $gridRows = $(this.getRows());
            if (this._isMapSelection && !this._selectionByGrid && ej.isNullOrUndefined(toIndex) && !this.initialRender) {
                if (!rowIndexCollection.length) {
                    Data[this._selectionMapColumn] = !args.row.find(".e-checkcelldiv input").prop("checked");
                    this.updateRecord(this._primaryKeys[0], Data, "update");
                    return;
                }
            }
            if ((this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && this.model.isEdit && this.model.enableAutoSaveOnSelectionChange) {
                if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal") || this.getContentTable().find(".e-editedrow").length != 0) {
                    if (this.endEdit())
                        return; 
                    else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                        $("#" + this._id + "_externalEdit").css("display", "none");
                }
            }
            if (this.checkSelectedRowsIndexes[currentPage] == undefined && !this._isMapSelection)
                this.checkSelectedRowsIndexes[currentPage] = [];
            if (rowIndexCollection.length > 0) {
                for (var i = 0; i < rowIndexCollection.length; i++) {
                    this.selectedRowsIndexes.indexOf(rowIndexCollection[i]) == -1 && this.selectedRowsIndexes.push(rowIndexCollection[i]);
                    this._selectedMultipleRows(this.selectedRowsIndexes);
                    if (this._isMapSelection && !this._selectionByGrid) {
                        var cData = this._currentJsonData[rowIndexCollection[i]];
                        cData[this._selectionMapColumn] = true;
                        this.batchChanges.changed.push(cData);
                    }
                }
				if( !this.model.scrollSettings.enableVirtualization){
					var diff = this._virtaulSel[0] - rowIndex;
					for (var i = 0; i < this._virtaulSel.length; i++) {
						this._virtaulSel[i] -= diff;
					}
				}
                var rows = this.getRowByIndex(this.model.scrollSettings.allowVirtualScrolling ? this._virtaulSel : rowIndexCollection);
                $(rows).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                if (this._enableCheckSelect && !this._isMapSelection) {
                    $(rows).find(".e-checkcelldiv input").prop("checked", "checked");
                }
                Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                if (this._isMapSelection && !this._selectionByGrid && !this.initialRender) {
                    this.batchSave();
                    return;
                }
            }
            else if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(rowIndex)) {
                rowIndex = ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex;
                $rowIndex = rowIndex;
                switch (this.model.selectionType) {
                    case ej.Grid.SelectionType.Multiple:
                        if (this.multiSelectCtrlRequest) {
                            this.model.selectedRecords = [];
                            var virtualIndex = $rowIndex;
                            if (this.model.scrollSettings.enableVirtualization && this._enableCheckSelect)
                                virtualIndex = args.rowIndex;
                            var selectedRowIndex = $.inArray($rowIndex, this.selectedRowsIndexes);
                            selectedRowIndex != -1 && !this._isMapSelection && this.clearSelection($rowIndex, target) && this.selectedRowsIndexes.splice(selectedRowIndex, 0);
                            if (selectedRowIndex == -1) {
                                this.selectedRowsIndexes.push($rowIndex);
								this._selectedMultipleRows(this.selectedRowsIndexes);
								var tr = this.getRowByIndex(rowIndex);
								if (this.model.scrollSettings.enableVirtualization && this._enableCheckSelect) {
								    var curRowIndex = parseInt(tr.attr("name"), 32);
								    var rowPage = curRowIndex % (this.model.pageSettings.pageSize / this._virtualRowCount);
								    if (rowPage == 0)
								        rowPage = (this.model.pageSettings.pageSize / this._virtualRowCount);
								    var curPage = Math.ceil((curRowIndex * this._virtualRowCount) / this.model.pageSettings.pageSize) - 1
								    var checkIndex = (args.rowIndex % this._virtualRowCount) + ((rowPage * this._virtualRowCount) - this._virtualRowCount);
								    if (this.checkSelectedRowsIndexes[curPage] == undefined && !this._isMapSelection)
								        this.checkSelectedRowsIndexes[curPage] = [];
								    this.checkSelectedRowsIndexes[curPage].push(checkIndex);
								}
                                tr.attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                                if(!this.model.scrollSettings.enableVirtualization)
									this._virtualSelectAction(pageIndex, rowIndex, pageSize);
								else
                                    this._virtualSelectedRecords[$rowIndex] = this._getSelectedViewData(rowIndex, target).data;
                                if ((this._enableCheckSelect && target && !target.parent().hasClass("e-checkcelldiv")) || (ej.isNullOrUndefined(target) && this._enableCheckSelect))
                                    tr.find(".e-checkcelldiv input").prop("checked", "checked");
                            }
                            Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                            break;
                        }
                    case ej.Grid.SelectionType.Single:
                        this.clearSelection();
                        this.clearColumnSelection();
                        this.selectedRowsIndexes = [];
                        this.model.selectedRecords = [];
                        this._virtualSelectedRecords = {};
                        this.selectedRowsIndexes.push($rowIndex);
						this._selectedMultipleRows(this.selectedRowsIndexes);
                        this.getRowByIndex(rowIndex).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                        if(!this.model.scrollSettings.enableVirtualization)
							this._virtualSelectAction(pageIndex, rowIndex, pageSize);
						else
							this._virtualSelectedRecords[$rowIndex] = Data;
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                        this._enableCheckSelect && this.getRowByIndex(rowIndex).find(".e-checkcelldiv [type=checkbox]").prop("checked", true);
                        break;
                }
            } else {
                if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                    !this._isMapSelection && this.clearSelection();
                    this.clearColumnSelection();
                    this.selectedRowsIndexes = [];
                    this.model.selectedRecords = [];                  
                    this._virtualSelectedRecords = {};
                    this._selectedMultipleRows([]);
					var $toIndex = toIndex;					
					this._virtualUnSel = [];
					this._virtualUnSelIndexes = [];
					if (this._isMapSelection || !(target && target.hasClass("e-checkselectall") && target[0].checked) && !this._isCheckboxUnchecked || this._isCheckboxChecked) {
					    if (this.model.scrollSettings.enableVirtualization && (target && !target.hasClass("e-checkselectall"))) {
					        var viewIndex = this._getSelectedViewData(toIndex, target).viewIndex;
					        var remain = toIndex % this._virtualRowCount;
					        $toIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
					        if ($rowIndex != this._prevSelIndex) $rowIndex = this._prevSelIndex;
					    }
					    ascend = $rowIndex - $toIndex < 0;
                        var rows;
					    if (!this.model.scrollSettings.enableVirtualization)
					        rows = ascend ? this.getRowByIndex(rowIndex, toIndex + 1) : this.getRowByIndex(toIndex, rowIndex + 1);
					    if (this.model.scrollSettings.frozenColumns)
					        rows = $(rows[0]).add(rows[1]);
					    var rowIndexes = [];
					    for (var i = ascend ? $rowIndex : $toIndex, to = ascend ? $toIndex : $rowIndex; i <= to; i++) {
					        if (this.model.scrollSettings.allowVirtualScrolling) {
					            if (!this.model.scrollSettings.enableVirtualization) {
					                var nameIndx = this.getRowByIndex(i).attr("name");
					                var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
					                this._virtualSelectedRecords[selIndex] = this._getSelectedViewData(i).data;
					                this._virtualSelectAction(pageIndex, i, pageSize);
					            }
					            else {
					                var viewIndex = this._getSelectedViewData(i).viewIndex;
					                if ($.inArray(viewIndex, this._currentLoadedIndexes) != -1) {
					                    var indx = this._currentLoadedIndexes.indexOf(viewIndex);
					                    var selIndex = i % this._virtualRowCount + indx * this._virtualRowCount;
					                    if (selIndex == 0) indx * this._virtualRowCount;
					                    rowIndexes.push(selIndex);
					                }
					                else {
					                    this._virtualUnSel.push(i);
					                    if ($.inArray(viewIndex, this._virtualUnSelIndexes) == -1)
					                        this._virtualUnSelIndexes.push(viewIndex);
					                }
					            }
					        }
					        
                            if (!(this.model.scrollSettings.enableVirtualization && this._enableCheckSelect) || this.getRowByIndex(i).length)
					                this.selectedRowsIndexes.push(i);
					            this._selectedMultipleRows(this.selectedRowsIndexes);
					        
					        if (this._isMapSelection && !this._selectionByGrid) {
					            var cData = this._currentJsonData[i];
					            cData[this._selectionMapColumn] = !target[0].checked;
					            this.batchChanges.changed.push(cData);
					        }
					    }
					    if (this._isMapSelection) {
					        this.batchSave();
					        return;
					    }
					    if (this.model.scrollSettings.enableVirtualization)
					        rows = this.getRowByIndex(rowIndexes[0], rowIndexes[rowIndexes.length - 1] + 1);
					    $(rows).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
					    Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
					    if (this._enableCheckSelect)
					        $(rows).find(".e-checkcelldiv input").prop("checked", "checked");
							this._isCheckboxChecked = false;
							this._isCheckboxUnchecked = false;
					}
                }
            }
            if (this._enableCheckSelect) {
                if (!this.model.scrollSettings.enableVirtualization)
                    this.checkSelectedRowsIndexes[currentPage] = this.selectedRowsIndexes;
                if (!this._selectAllCheck) {
                    if (this.selectedRowsIndexes.length == this._currentJsonData.length || this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && [].concat.apply([], this.checkSelectedRowsIndexes).length >= this._gridRecordsCount)
                        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", "checked");
                    else if (this._selectionByGrid)
                        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").prop("checked", false);
                }
            }
            if (this._selectedRow() !== $rowIndex && $(this.getRowByIndex($rowIndex)).attr("aria-selected") == "true")
                this._selectedRow($rowIndex);
            if (target && target.hasClass("e-checkselectall") && !this._isMapSelection) {
                var gridInstance = this;
				var totalPage = this._dataSource() instanceof ej.DataManager && this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling && !this.model.scrollSettings.enableVirtualization ? Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize) :this.model.pageSettings.totalPages;
				this.checkSelectedRowsIndexes = !target.is(":checked") ? $.map(Array(totalPage), function (x, i) { x = Array($.map(Array(gridInstance.model.pageSettings.pageSize), function (x2, i2) { return i2 })); return x; }) : [];
				var totalcount = [].concat.apply([], this.checkSelectedRowsIndexes).length;
				if (!target.is(":checked") && totalcount > this._gridRecordsCount) this.checkSelectedRowsIndexes[this.checkSelectedRowsIndexes.length - 1].splice(this._gridRecordsCount - totalcount);
            }
            Data = this._virtualScrollingSelection ? this._virtualSelRecords : Data;
			var selectedIndex = this.model.scrollSettings.enableVirtualization ? $rowIndex : this._selectedRow();
            var args = { rowIndex: selectedIndex, row: this.getRowByIndex(this._selectedRow()), data: Data, selectedData: Data, target: target, prevRow: $prevRow, prevRowIndex : $prevIndex };
            this._previousIndex = this.selectedRowsIndexes.length ? rowIndex :this._previousIndex;
			if(this.model.scrollSettings.enableVirtualization){
				this._prevSelIndex = $rowIndex; 
				this._prevSelRow = this.getRowByIndex(rowIndex);
			}
			for (var i = 0; i < this.checkSelectedRowsIndexes.length; i++) {
			    if (ej.isNullOrUndefined(this.checkSelectedRowsIndexes[i]))
			        this.checkSelectedRowsIndexes[i] = [];
			}
			this.model._checkSelectedRowsIndexes = this.checkSelectedRowsIndexes;
			if ($(this.getRowByIndex(rowIndex)).is('[data-role="row"]') && $(this.getRowByIndex($rowIndex)).attr("aria-selected") == "true")
                this._trigger("rowSelected", args);            
        },
        _getVirtualRows: function (rowIndex, target, isSelection, rowIndexCollection) {
		    var $rowIndex = rowIndex,$prevIndex = this._previousIndex, $prevRow = this.getRowByIndex(this._previousIndex),res,Data,args = {};
		    var $gridRows = $(this.getRows()), preventDynamicSelection=false;
		     if(this.model.scrollSettings.enableVirtualization){					
					var virtualRowCount = this._virtualRowCount;
					var currentIndex = !target ? Math.ceil((rowIndex + 1) / virtualRowCount) : parseInt($(this._gridRows[rowIndex]).attr("name"), 32);
					var rowCount = currentIndex > 1 ? this._virtualRowCount: 0;					
					if (this.initialRender || (currentIndex != this._currentVirtualIndex && !target)) {
					    this._isThumbScroll = true;
                        if(ej.isNullOrUndefined(this._virtualLoadedRecords[currentIndex]) && !this._isLocalData){
                            this._dynamicSelectedRowIndex = rowIndex;
                            preventDynamicSelection = true;
                        }
					    if ($.inArray(currentIndex, this._currentLoadedIndexes) == -1 && isSelection != "clearSelection")
						    this._refreshVirtualView(currentIndex, isSelection, rowIndex);
                            if(preventDynamicSelection)
                                return false;
						rowIndex = rowIndex != 0 ? rowIndex % this._virtualRowCount + rowCount : rowIndex;			
						}					
					else {						
					    if (rowIndex > this._virtualRowCount * 3 || !ej.isNullOrUndefined(target) && !$(target).parent().hasClass("e-headercelldiv") && !ej.isNullOrUndefined(target[0]) && !target[0].checked) {
							var viewIndex = this._getSelectedViewData(rowIndex, target).viewIndex;
							var remain = rowIndex % this._virtualRowCount;
							$rowIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
                        }
                        else {
                            var trIndex = parseInt($(this._gridRows[rowIndex]).attr("name"), 32);
                            var trSiblings = $(this._gridRows[rowIndex]).prevAll("tr[name=" + trIndex + "]").length;
                            $rowIndex = (trIndex * this._virtualRowCount) - this._virtualRowCount + trSiblings;
                        }
                    }
					if(rowIndexCollection.length){												
						for(var i = 0; i < rowIndexCollection.length; i++){
							var viewIndex = this._getSelectedViewData(rowIndexCollection[i]).viewIndex;
							if($.inArray(viewIndex, this._currentLoadedIndexes) != -1)
								this._virtaulSel.push(rowIndexCollection[i]);
							if(!this._virtualSelectedRecords[rowIndexCollection[i]])
								this._virtualSelectedRecords[rowIndexCollection[i]] =  this._getSelectedViewData(rowIndexCollection[i]).data;
						}					
					}
					Data = this._getSelectedViewData(rowIndex, target, currentIndex).data;
					$prevIndex = this._prevSelIndex;
					$prevRow = this._prevSelRow;
				}
				else{
					var pageSize = this.model.pageSettings.pageSize;
					var nameIndx = this.getRowByIndex(rowIndex).attr("name");
					var pageIndex = !ej.isNullOrUndefined(nameIndx) ? (parseInt(nameIndx) / pageSize) + 1 : rowIndex;
					var trIndex = (rowIndex) % (pageSize);
					var pageto = parseInt(rowIndex / pageSize);
					var nameattr = pageto * pageSize;
					if ((!ej.isNullOrUndefined(pageto) && pageto > 0 && $.inArray(nameattr, this.virtualLoadedPages) == -1) && ej.isNullOrUndefined(target) && !(this._requestType =="save" || this._requestType == "cancel")) {
						trIndex--; this._virIndex = true;
						this._virtualTrIndex=trIndex;
						this.gotoPage(pageto + 1);
						var proxy = this;
						if (this._dataSource() instanceof ej.DataManager) {
							this._queryPromise.done(function (e) {
								proxy._virtuaOtherPage=true;
								proxy._virtualdata = proxy._currentJsonData;
								proxy._pageTo = pageto;
								if(proxy._virtualScrollingSelection)
									proxy._virtualSelRecords = e.virtualSelectRecords;
								var from = (parseInt(rowIndex / proxy.model.pageSettings.pageSize)) * proxy.model.pageSettings.pageSize;
								var to = (parseInt((rowIndex / proxy.model.pageSettings.pageSize)) + 1) * proxy.model.pageSettings.pageSize;
								var _selctRow = []
								_selctRow.push(rowIndex);
								for (var i = 1; i < rowIndexCollection.length; i++)
									if (from < rowIndexCollection[i] && rowIndexCollection[i] < to)
										_selctRow.push(rowIndexCollection[i]);
								proxy.selectRows(_selctRow);
								return false;
							});
							if(proxy._virtualScrollingSelection)
								return;
						}
						else {
							proxy._virtualdata = proxy._currentJsonData;
							if (rowIndexCollection.length > 0) {
								proxy._virtualSelRecords = [];
								for (var i = 0; i < rowIndexCollection.length; i++) {
									proxy._virtualSelRecords.push(this.model.dataSource[rowIndexCollection[i]]);
								}
							}
							proxy._pageTo = pageto;
						}
					}
					if (this._virtuaOtherPage) {
						this._virtuaOtherPage=false;
					}
					for (var i = 0; i < this._loadedJsonData.length; i++) {
						if (this._loadedJsonData[i].pageIndex == pageIndex)
							res = this._loadedJsonData[i].data;
					}
					Data = ej.isNullOrUndefined(res) ? this._currentJsonData[trIndex] : res[trIndex];
					Data = this._virtualScrollingSelection ? this._virtualSelRecords : Data;
					var nameattr = this._pageTo * pageSize;
					if (!ej.isNullOrUndefined(this._virtualdata) && this._virtualdata.length > 0) {
						rowIndex = $(document.getElementsByName(nameattr)[trIndex]).index();
						Data = this._virtualdata[trIndex];
						this._virtualdata = [];
					}
					else if ($(document.getElementsByName(pageto * pageSize)).length > 0 && !ej.isNullOrUndefined(this._pageTo))
						rowIndex = $(document.getElementsByName(pageto * pageSize)[rowIndex % pageSize]).index();
				}
		     args = { rowIndex: !this.model.scrollSettings.enableVirtualization ? (!(this._requestType == "save" || this._requestType == "cancel") ? rowIndex : rowIndex % pageSize) : $rowIndex, row: $gridRows.eq(rowIndex), data: Data, selectedData: Data };
			   if (isSelection == "selectRows") {
			       args.prevRow = $prevRow;
			       args.prevRowIndex = $prevIndex;
			   }
		       return args; 
          },
        _selectingMultipleRows: function (selectedIndexes) {
            this._modelMultiSelectedIndexes = selectedIndexes;
            this.clearSelection();
            this.multiSelectCtrlRequest = true;
            for (var index = 0; index < selectedIndexes.length; index++)
                this.selectRows(selectedIndexes[index])
            this.multiSelectCtrlRequest = false;
            this._modelMultiSelectedIndexes = [];
        },
        _virtualSelectAction: function (pageIndex, rowIndex, pageSize) {
            if (this.model.scrollSettings.allowVirtualScrolling && !ej.isNullOrUndefined(rowIndex)) {
                if (!ej.isNullOrUndefined(this._virtualLoadedRecords[pageIndex]))
                    this._virtualSelectedRecords[rowIndex] = this._virtualLoadedRecords[pageIndex][rowIndex % pageSize];
                else
                    this._virtualSelectedRecords[rowIndex] = this._currentJsonData[rowIndex % pageSize];
            }
        },
		_getSelectedViewData: function(rowIndex, target, currentViewIndex){
			var index = rowIndex % this._virtualRowCount, viewIndex, result = {};
			if(target)
				viewIndex = parseInt($(target).closest("tr").attr("name"), 32);
			else if(currentViewIndex)
				viewIndex = currentViewIndex;
			else
				viewIndex = rowIndex > 1 ? Math.ceil((rowIndex + 1) / this._virtualRowCount) : 1;
			result["viewIndex"] = viewIndex;
			if(this._virtualLoadedRecords[viewIndex])
				result["data"] = this._virtualLoadedRecords[viewIndex][index];
			var remain = rowIndex % this._virtualRowCount;	
			result["rowIndex"] = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);
			return result;
		},
        selectCells: function (rowCellIndexes) {
            if (!this._allowcellSelection)
                return false;
            this._lastSelectedCellIndex = rowCellIndexes;
            var $cell = null, previousRowCell, prevRowCellIndex;
            var gridRows = this._excludeDetailRows();
            if (this.model.scrollSettings.frozenColumns)
                $cell = this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]);
            else
                $cell = gridRows.eq(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")");				
            if(!ej.isNullOrUndefined(this._previousRowCellIndex) && this._previousRowCellIndex.length != 0 ){
				if(this.model.scrollSettings.enableVirtualization){
					previousRowCell = this._prevRowCell;
					prevRowCellIndex = this._preVirRowCellIndex;
				}
				else{
					previousRowCell = $(this.getRowByIndex(this._previousRowCellIndex[0][0]).find(".e-rowcell:eq("+this._previousRowCellIndex[0][1]+")"));
					prevRowCellIndex = this._previousRowCellIndex;
				}
			}			
			var $data = this._currentJsonData[rowCellIndexes[0][0]], $rowIndex = rowCellIndexes[0][0], viewDetails;
			if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
				viewDetails = this._getSelectedViewData(rowCellIndexes[0][0], $cell);
				$data = viewDetails.data;
				$rowIndex = viewDetails.rowIndex;
			}				
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, selectedData: $data, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell };
            if (this.model.selectionType == "multiple") {
                args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                args["isShiftPressed"] = this.multiSelectShiftRequest;
            }
            if (this._trigger("cellSelecting", args))
                return;
            switch (this.model.selectionType) {
                case ej.Grid.SelectionType.Multiple:
                    if (this.multiSelectCtrlRequest) {
                        var selectedCellIndex = $.inArray($rowIndex, this._rowIndexesColl);
                        if (selectedCellIndex != -1)
                            this.selectedRowCellIndexes[selectedCellIndex].cellIndex.push(parseInt(rowCellIndexes[0][1].toString()));
                        else {
                            if ($.inArray($rowIndex, this._rowIndexesColl) == -1)
                                this._rowIndexesColl.push($rowIndex);
                            this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[0][1] });
                        }
                        $cell.addClass("e-cellselectionbackground e-activecell");
                        break;
                    }
                    else if (this.multiSelectShiftRequest && this._previousRowCellIndex != undefined) {
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this.selectedRowCellIndexes = [];
                        var previousRowIndex = this._previousRowCellIndex[0][0];
                        var previousCellIndex = parseInt(this._previousRowCellIndex[0][1]);
                        var currentRowIndex = rowCellIndexes[0][0];
                        var currentCellIndex = parseInt(rowCellIndexes[0][1]);
						if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
							previousRowIndex = this._preVirRowCellIndex[0][0];
							currentRowIndex = this._getSelectedViewData(currentRowIndex, this.getRowByIndex(currentRowIndex).find(".e-rowcell")).rowIndex;
						}
                        var newCellColl = [];
                        var min, max;
                        if(this.model.selectionSettings.cellSelectionMode == "box"){
							var $rowCount =  this.model.scrollSettings.frozenColumns ? this.getRows()[0].length - 1 : this.getRows().length - 1;
							var pCellIndex = previousCellIndex < currentCellIndex ? previousCellIndex : currentCellIndex;
							var cCellIndex = pCellIndex == currentCellIndex ? previousCellIndex : currentCellIndex;	
							var newRowColl = [], newCellColl = [];							
							for (var i = pCellIndex; i <= cCellIndex; i++) {								
								min = previousRowIndex;									
								max = currentRowIndex;
								if( min < max ){
									for (var j = min; j <= max; j++) {
										$.inArray(j, newRowColl) == -1 && newRowColl.push(j);											
										this._selectMultipleCells(j, i, currentCellIndex, previousCellIndex);										
									}
								}
								else{
									for (var j = max; j <= min; j++) {
										$.inArray(j, newRowColl) == -1 && newRowColl.push(j);											
										this._selectMultipleCells(j, i, currentCellIndex, previousCellIndex);										
									}
								}
								newCellColl.push(i);								
							}							
							for(var i = 0; i < newRowColl.length; i++){								
								this.selectedRowCellIndexes.push({ rowIndex: newRowColl[i], cellIndex: newCellColl });										
							}
							this._rowIndexesColl = ej.distinct(newRowColl);
						}
                        else if (currentRowIndex > previousRowIndex) {
                            for (var i = previousRowIndex; i <= currentRowIndex; i++) {
                                newCellColl = [];
                                min = i == previousRowIndex ? previousCellIndex : 0;
                                max = i == currentRowIndex ? currentCellIndex : this.model.columns.length - 1;
                                for (var j = min; j <= max; j++) {
                                    newCellColl.push(j);
                                    this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
                                }								
                                this.selectedRowCellIndexes.push({ rowIndex: i, cellIndex: newCellColl });
                                this._rowIndexesColl.push(i);
                            }
                        } 						 						
						else {
                            for (var i = previousRowIndex; i >= currentRowIndex; i--) {
                                newCellColl = [];
                                min = i == previousRowIndex ? previousCellIndex : this.model.columns.length - 1;
                                max = i == currentRowIndex ? currentCellIndex : 0;
								if( min > max ){
									for (var j = min; j >= max; j--) {
										newCellColl.push(j);
										this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
									}
								}
								else{
									for (var j = max; j >= min; j--) {
										newCellColl.push(j);
										this._selectMultipleCells(i, j, currentCellIndex, previousCellIndex);
									}
								}                                
                                this.selectedRowCellIndexes.push({ rowIndex: i, cellIndex: newCellColl });
                                this._rowIndexesColl.push(i);
                            }
                        }
                        break;
                    }
                    else {
                        this.clearCellSelection();
						this._virtualRowCellSelIndex = [];
                        for (var i = 0; i < rowCellIndexes.length; i++) {
                            if (rowCellIndexes[i][1].length > 1) {
                                var td = gridRows.eq(rowCellIndexes[i][0]).find(".e-rowcell");
                                if (this.model.scrollSettings.frozenColumns)
                                    td = $(gridRows[0]).eq(rowCellIndexes[i][0]).find(".e-rowcell").add($(gridRows[1]).eq(rowCellIndexes[i][0]).find(".e-rowcell"));
                                for (var j = 0; j < td.length; j++) {
                                    var index = (this.model.detailsTemplate != null || this.model.childGrid != null) ? td[j].cellIndex - 1 : j;
                                    if ($.inArray(index, rowCellIndexes[i][1]) != -1) {
                                        $(td[j]).addClass("e-cellselectionbackground e-activecell");
                                        var selectedCellIndex = $.inArray(rowCellIndexes[i][0], this._rowIndexesColl);
                                        if (selectedCellIndex != -1)
                                            this.selectedRowCellIndexes[selectedCellIndex].cellIndex.push(td[j].cellIndex);
                                        else {
											$rowIndex = rowCellIndexes[i][0];
											if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
												viewDetails = this._getSelectedViewData($rowIndex, td);
												$data = viewDetails.data;
												$rowIndex = viewDetails.rowIndex;
											}
                                            this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: [td[j].cellIndex] });
                                            this._rowIndexesColl.push(rowCellIndexes[i][0]);
                                        }
                                    }
                                }
                            }
                            else {
                                if (this.model.scrollSettings.frozenColumns)
                                    this._frozenCell(rowCellIndexes[i][0], rowCellIndexes[i][1][0]).addClass("e-cellselectionbackground e-activecell");
                                else
                                    $(this.getRowByIndex(rowCellIndexes[i][0]).find(".e-rowcell:eq(" + rowCellIndexes[i][1] + ")")).addClass("e-cellselectionbackground e-activecell");
                                this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[i][1] });
                                this._rowIndexesColl.push($rowIndex);
                            }
                        }
                        break;

                    }
                case ej.Grid.SelectionType.Single:
                    this.clearCellSelection();
                    this.clearColumnSelection();
                    this.selectedRowCellIndexes = [];
					this._virtualRowCellSelIndex = [];
                    if ($.inArray($rowIndex, this._rowIndexesColl) == -1)
                       this._rowIndexesColl.push($rowIndex);
                    this.selectedRowCellIndexes.push({ rowIndex: $rowIndex, cellIndex: rowCellIndexes[0][1] });
                    if (this.model.scrollSettings.frozenColumns)
                        this._frozenCell(rowCellIndexes[0][0], rowCellIndexes[0][1][0]).addClass("e-cellselectionbackground e-activecell");
                    else
						$(this.getRowByIndex(rowCellIndexes[0][0]).find(".e-rowcell:eq(" + rowCellIndexes[0][1] + ")")).addClass("e-cellselectionbackground e-activecell");
                    break;
            }
            var args = { currentCell: $cell, cellIndex: rowCellIndexes[0][1], data: $data, selectedData: $data, selectedRowCellIndex: this.selectedRowCellIndexes, previousRowCellIndex: prevRowCellIndex, previousRowCell: previousRowCell};
            if (!this.multiSelectShiftRequest || ej.isNullOrUndefined(this._previousRowCellIndex)){
				this._previousRowCellIndex = rowCellIndexes;
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){					
					this._preVirRowCellIndex = $.extend(true, [], rowCellIndexes);
					this._preVirRowCellIndex[0][0] = $rowIndex;
				}											
				this._prevRowCell = $cell;
            }
            if (!ej.isNullOrUndefined(rowCellIndexes[0][1][0])) {
                $.extend(this._bulkEditCellDetails, {
                    rowIndex: rowCellIndexes[0][0],
                    columnIndex: rowCellIndexes[0][1][0],
                });
            }
            else {
                $.extend(this._bulkEditCellDetails, {
                    rowIndex: rowCellIndexes[0][0],
                    columnIndex: rowCellIndexes[0][1],
                });
            }
            if (this._trigger("cellSelected", args))
                return;			
        },
		_selectMultipleCells: function(i, j, currentCellIndex, previousCellIndex){			
			if (this.model.scrollSettings.frozenColumns)
				this._frozenCell(i, j).addClass("e-cellselectionbackground e-activecell");
			else{				
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
					var viewIndex = this._getSelectedViewData(i).viewIndex;
					if($.inArray(viewIndex, this._currentLoadedIndexes) != -1){
						var indx = this._currentLoadedIndexes.indexOf(viewIndex);
						var selIndex = i % this._virtualRowCount + indx * this._virtualRowCount;						
						$(this.getRowByIndex(selIndex).find(".e-rowcell:eq(" + j + ")")).addClass("e-cellselectionbackground e-activecell");
						if($.inArray(i, this._virtualRowCellSelIndex) == -1 && $.inArray(i, this._rowIndexesColl) != -1 && i != this._preVirRowCellIndex[0][0])
							this._virtualRowCellSelIndex.push(i);
					}					
				}
				else
					$(this.getRowByIndex(i).find(".e-rowcell:eq(" + j + ")")).addClass("e-cellselectionbackground e-activecell");
			}
		},

        
        selectColumns: function (columnIndex, toIndex) {
            if (!this._allowcolumnSelection)
                return false;
            this._allowcolumnSelection = true;
            var gridRows = this.getRows();            
            var prevColumnHeaderCell = this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[this._previousColumnIndex];
            var args = { columnIndex: columnIndex == undefined ? toIndex : columnIndex, headerCell: $(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[columnIndex]), column: this.model.columns[columnIndex], previousColumnIndex: this._previousColumnIndex, prevColumnHeaderCell: prevColumnHeaderCell };
            var $precolIndex = this._previousColumnIndex;
            if ((args["isShiftPressed"] = this.multiSelectShiftRequest) == true)
                this._previousColumnIndex = columnIndex == undefined ? toIndex : columnIndex;
            else
                this._previousColumnIndex = toIndex;
            if (this.model.selectionType == "multiple") {
                args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                args["isShiftPressed"] = this.multiSelectShiftRequest;
            }
            if (this._trigger("columnSelecting", args))
                return;
            if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(columnIndex)) {
                columnIndex = ej.isNullOrUndefined(columnIndex) ? toIndex : columnIndex;
                switch (this.model.selectionType) {
                    case ej.Grid.SelectionType.Multiple:
                        if (this.multiSelectCtrlRequest) {
                            var selectedColumnIndex = $.inArray(columnIndex, this.selectedColumnIndexes);
                            selectedColumnIndex != -1 && this.clearColumnSelection(columnIndex) && this.selectedColumnIndexes.splice(selectedColumnIndex, 0);
                            if (selectedColumnIndex == -1) {
                                this.selectedColumnIndexes.push(columnIndex);
                                this._previousColumnIndex = this.selectedColumnIndexes.length ? columnIndex : undefined;
                                if (this.model.scrollSettings.frozenColumns)
                                    this._frozenColumnSelection(gridRows, columnIndex);
                                else
                                    for (var i = 0; i < gridRows.length; i++) {
                                        $(this._excludeDetailCells(gridRows[i])[columnIndex]).addClass("e-columnselection");
                                    }
                                $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[columnIndex]).addClass("e-columnselection");
                            }
                            break;
                        }
                    case ej.Grid.SelectionType.Single:
                        this.clearSelection();
                        this.clearCellSelection();
                        this.clearColumnSelection();
                        this.selectedColumnIndexes = [];
                        this.selectedColumnIndexes.push(columnIndex);
                        this._previousColumnIndex = this.selectedColumnIndexes.length ? columnIndex : undefined;
                        if (this.model.scrollSettings.frozenColumns)
                            this._frozenColumnSelection(gridRows, columnIndex);
                        else
                        for (var i = 0; i < gridRows.length; i++) {
                            $(this._excludeDetailCells(gridRows[i])[columnIndex]).addClass("e-columnselection");
                        }
                        $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[columnIndex]).addClass("e-columnselection");
                        break;
                }
            } else {
                if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                    this.clearColumnSelection();
                    this.selectedColumnIndexes = [];
                    var indent = 0;
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                        indent = 1;
                    }
                    var startIndex = columnIndex > toIndex ? toIndex : columnIndex;
                    var endIndex = columnIndex > toIndex ? columnIndex + 1 : toIndex + 1;
                    if (this.model.scrollSettings.frozenColumns)
                        this._frozenColumnSelection(gridRows, startIndex, endIndex);
                    else
                    for (var i = startIndex; i < endIndex; i++) {
                        for (var j = 0; j < gridRows.length; j++) {
                            $(this._excludeDetailCells(gridRows[j])[i]).addClass("e-columnselection");
                        }
                        $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell,.e-detailheadercell)")[i]).addClass("e-columnselection");
                        this.selectedColumnIndexes.push(i);
                    }
                }
            }
            var args = { columnIndex: columnIndex == undefined ? toIndex : columnIndex, headerCell: $(this.getHeaderTable().find('.e-columnheader').last().find('th').not('.e-detailheadercell')[columnIndex]), column: this.model.columns[columnIndex], selectedColumnIndex: this.selectedColumnIndexes, previousColumnIndex: $precolIndex, prevColumnHeaderCell: prevColumnHeaderCell };
            if (this._trigger("columnSelected", args))
                return;
        },
        
        clearSelection: function (index, $target) {
            var rIndex = index, cSelection = "clearSelection", gridRows = $(this.getRows()), Data, args = {};
            var $gridRows = $(this.getRows()), index;
            if (this._selectedRow() >= -1) {
                if (this.model.scrollSettings.frozenColumns || !ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid))
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find("tr[aria-selected='true']"));
                var isSelected = $gridRows.find("td").hasClass("e-selectionbackground e-active");
                if (isSelected) {
                    $gRows = $(this.getContent().find("tr[aria-selected='true']"));
                    if (!this.model.scrollSettings.allowVirtualScrolling) {
                        if (!ej.isNullOrUndefined(index)) {
                            if (this.model.editSettings.editMode == "batch" && $($gridRows[index]).hasClass("e-insertedrow")) {
                                var addedrows = this.batchChanges.added.reverse();
                                Data = addedrows[index];
                                this.batchChanges.added.reverse();
                            }
                            else
                                Data = this.model.editSettings.editMode == "batch" ? this._currentJsonData[index - this.batchChanges.added.length] : this._currentJsonData[ej.isNullOrUndefined(index) ? toIndex : index];
                        }
                        var srow = [];
                        for (var j = 0; j < this.selectedRowsIndexes.length; j++) {
                            srow.push(this._currentJsonData[this.selectedRowsIndexes[j]]);
                        }
                        args = { rowIndex: index == undefined ? this.selectedRowsIndexes : index, row: index == undefined ? $gRows : gridRows.eq(index), data: index == undefined ? srow : Data, selectedData: index == undefined ? srow : Data };
                    }
                    else{
                     var vIndex, $target;
                     if (ej.isNullOrUndefined(index)) {
                        vIndex = this.selectedRowsIndexes[0];
                        $target = this.getSelectedRecords().length && this._enableCheckSelect && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization?this.element.find('.e-headercheckcelldiv .e-checkselectall') :$gRows[0];
                    }
                    else
                        vIndex = index;
                    var vrowIndexCollection = this.selectedRowsIndexes;
                    args = this._getVirtualRows(vIndex, $target, cSelection, vrowIndexCollection);
                    }
                    if (this._trigger("rowDeselecting", args))
                        return;
                }
                if (!ej.isNullOrUndefined(index)) {
                    this.getRowByIndex(index).removeAttr("aria-selected").find(".e-selectionbackground").removeClass("e-selectionbackground").removeClass("e-active");
					var row = this.getRowByIndex(index);
					if (this.model.scrollSettings.enableVirtualization && this.multiSelectCtrlRequest && !this._enableCheckSelect) {
						var limit = parseInt(row.attr("name"), 32) * this._virtualRowCount;
						var remain = this._virtualRowCount - row.index() % this._virtualRowCount;	
						index = limit - remain;
					}
                    index = $.inArray(index, this.selectedRowsIndexes);
                    if (index != -1) {
                        this.selectedRowsIndexes.splice(index, 1);
                        this._selectedMultipleRows(this.selectedRowsIndexes);
                        this.model.selectedRecords.splice(index, 1);
                    }
                    if (this._enableCheckSelect && !$target)
                        row.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                    if (this._isMapSelection) {
                        if (!this._selectionByGrid && !ej.isNullOrUndefined(index) && index != -1) {
                            var Data = this._currentJsonData[rIndex];
                            Data[this._selectionMapColumn] = false;
                            this.updateRecord(this._primaryKeys[0], Data, "update");
                        }
						this._trigger("rowDeselected", args);
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                    }
                } else {
                    var rows = $gridRows;
                    if (this.model.scrollSettings.enableVirtualization) {
                        for (var i in this._virtualLoadedRows) {
                            $.merge(rows, this._virtualLoadedRows[i]);
                        }
                    }
                    $gridRows.removeAttr("aria-selected").find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-selectionbackground").removeClass("e-active");
                    if(!this._clearVirtualSelection){
						this.selectedRowsIndexes = [];
						this.model.selectedRecords = [];
						this._selectedMultipleRows([]);
                    }
                    if (!this._selectionByGrid && (!this.initialRender || !this._isMapSelection)) {
                        $gridRows.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                        var data = null;
                        if (this._isMapSelection && isSelected && this._trigger("rowDeselected", args));
                        Array.prototype.push.apply(this.model.selectedRecords, this.getSelectedRecords());
                    }
                }
                if (this._enableCheckSelect) {
                    if (!this._selectAllCheck && (this.selectedRowsIndexes.length != this._currentJsonData.length || this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && [].concat.apply([], this.checkSelectedRowsIndexes).length >= this._gridRecordsCount))
                        this.getHeaderTable().find(".e-headercheckcelldiv .e-checkselectall").prop("checked", false);
                    var i, curPage = this._currentPage() - 1;
                    if (this.model.scrollSettings.enableVirtualization && args.row) {
                        var curRowIndex = parseInt(args.row.attr("name"), 32);
                        var rowPage = curRowIndex % (this.model.pageSettings.pageSize / this._virtualRowCount);
                        if (rowPage == 0)
                            rowPage = (this.model.pageSettings.pageSize / this._virtualRowCount);
                        curPage = Math.ceil((curRowIndex * this._virtualRowCount) / this.model.pageSettings.pageSize) - 1
                        rIndex = (args.rowIndex % this._virtualRowCount) + ((rowPage * this._virtualRowCount) - this._virtualRowCount);

                    }
                    checkBoxIndex = $.inArray(rIndex, this.checkSelectedRowsIndexes[curPage]);
                    if (checkBoxIndex != -1) {
                        this.checkSelectedRowsIndexes[curPage].splice(checkBoxIndex, 1);
                    }
                    if (!this.selectedRowsIndexes.length && !this._isMapSelection && !$target) {
                        this.checkSelectedRowsIndexes[curPage] = [];
                        $gridRows.find(".e-checkcelldiv [type=checkbox]").prop("checked", false);
                    }
                }
                if (!this.selectedRowsIndexes.length)
                    this._selectedRow(-1);
            }
            this.model._checkSelectedRowsIndexes = this.checkSelectedRowsIndexes;
            if (isSelected && !this._isMapSelection && this._trigger("rowDeselected", args))
                return true;
        },

        _excludeDetailRows:function()
		{
			var $gridRows;
			if (!ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid || this.model.showSummary) && !this.model.scrollSettings.frozenColumns)
			    $gridRows = $(this.getRows()).not(".e-detailrow,.e-gridSummaryRows");
			else if (this.model.scrollSettings.frozenColumns > 0 && this.getRows() != null && this.getRows().length > 1)
			    $gridRows = $(this.getRows()[0]).not(".e-detailrow,.e-gridSummaryRows").add($(this.getRows()[1]).not(".e-detailrow,.e-gridSummaryRows"));
			else
			    $gridRows = $(this.getRows());
            return $gridRows;
		},
        
        clearCellSelection: function (rowIndex, columnIndex) {
            var $gridRows,$cell, cellIndex;
            if (this._allowcellSelection) {
                if (!ej.isNullOrUndefined(rowIndex) || !ej.isNullOrUndefined(this.model.detailsTemplate || this.model.childGrid))
                    $gridRows = this._excludeDetailRows();
                else
                    $gridRows = $(this.element.find(".e-cellselectionbackground")).parent();
                var isCellSelected = $gridRows.find("td").hasClass("e-cellselectionbackground e-activecell");
                if (isCellSelected) {
                    if (this.model.scrollSettings.frozenColumns && !ej.isNullOrUndefined(rowIndex))
                        $cell = this._frozenCell(rowIndex, columnIndex);
                    else
                        $cell = this.getContent().find(".e-cellselectionbackground");
                    var $data = [], cIndex = [columnIndex], vCell = [];
                    for (var j = 0; j < this.selectedRowCellIndexes.length; j++) {
                        $data.push(this._currentJsonData[this.selectedRowCellIndexes[j].rowIndex]);
                        for (var i = 0; i < this.selectedRowCellIndexes[j].cellIndex.length; i++) {
                            vCell.push(this.selectedRowCellIndexes[j].cellIndex[i]);
                        }
                    }
                    var args = { currentCell: (rowIndex || columnIndex) == undefined ? $cell : $gridRows.eq(rowIndex).find(".e-rowcell").eq(columnIndex), cellIndex: (rowIndex || columnIndex) == undefined ? vCell : cIndex, data: (rowIndex || columnIndex) == undefined ? $data : this._currentJsonData[rowIndex], selectedData: (rowIndex || columnIndex) == undefined ? $data : this._currentJsonData[rowIndex] };
                    if (this.model.selectionType == "multiple") {
                        args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                        args["isShiftPressed"] = this.multiSelectShiftRequest;
                    }
                    if (this._trigger("cellDeselecting", args))
                        return true;
                }
                if (ej.isNullOrUndefined(rowIndex)) {
                    if (this.model.scrollSettings.frozenColumns)
                        $gridRows = $($gridRows[0]).add($gridRows[1]);
                    $gridRows.find(".e-rowcell, .e-detailrowcollapse, .e-detailrowexpand").removeClass("e-cellselectionbackground").removeClass("e-activecell");
                    this.selectedRowCellIndexes = [];
                    this._rowIndexesColl = [];
                }
                else {
                    for (var i = 0; i < this.selectedRowCellIndexes.length ; i++) {
                        if (this.selectedRowCellIndexes[i].rowIndex == rowIndex) {
                            cellIndex = $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex);
                            if (this.model.scrollSettings.frozenColumns)
                                this._frozenCell(rowIndex, columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            else
                            $gridRows.eq(rowIndex).find(".e-rowcell").eq(columnIndex).removeClass("e-cellselectionbackground").removeClass("e-activecell");
                            break;
                        }
                    }
                    if (i != this.selectedRowCellIndexes.length) {
                        this.selectedRowCellIndexes[i].cellIndex.splice(cellIndex, 1);
                        if (this.selectedRowCellIndexes[i].cellIndex.length == 0) {
                            this.selectedRowCellIndexes.splice(i, 1);
                            this._rowIndexesColl.splice($.inArray(rowIndex, this._rowIndexesColl), 1);
                        }
                    }
                }
            }
            if (isCellSelected && this._trigger("cellDeselected", args))
                return true;
        },

        
        clearColumnSelection: function (index) {
             if (this._allowcolumnSelection) {
                var $gridRows = $(this._excludeDetailRows());
				var cIndex = $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)"));
				var isColumnSelected = cIndex.hasClass("e-columnselection");
                if(isColumnSelected){
                var scol = [],hcell = [];
                for (var j = 0; j < this.selectedColumnIndexes.length; j++) {
                    scol.push(this.model.columns[this.selectedColumnIndexes[j]]);
                    hcell.push($(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[this.selectedColumnIndexes[j]]));
                }
                var args = { columnIndex: index == undefined ? this.selectedColumnIndexes : index, headerCell: index == undefined ? hcell : $(this.getHeaderTable().find('.e-columnheader').last().find('th.e-headercell').not('.e-detailheadercell')[index]), column: index == undefined ? scol : this.model.columns[index] };
                if (this.model.selectionType == "multiple") {
                   args["isCtrlPressed"] = this.multiSelectCtrlRequest;
                   args["isShiftPressed"] = this.multiSelectShiftRequest;
                 }
               if (this._trigger("columnDeselecting", args))
                   return;
                }
                if (!ej.isNullOrUndefined(index)) {
                    var indent = 0;
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                        ++index; indent = 1;
                    }
                    if (this.model.scrollSettings.frozenColumns) {
                        var currentIndex = index;
                        if (index >= this.model.scrollSettings.frozenColumns) {
                            currentIndex = index - this.model.scrollSettings.frozenColumns;
							 $gridRows=$(this.getContent).find(".e-movablecontent").find('tr');
                        }
                        else
                            $gridRows=$(this.getContent).find(".e-frozencontentdiv").find('tr');
                        for (var j = 0; j < $gridRows.length; j++) {
                            $($gridRows[j].cells[currentIndex]).removeClass("e-columnselection");
                        }
                    }
                    else
                        for (var i = 0; i < $gridRows.length; i++) {
                            $($gridRows[i].cells[index]).removeClass("e-columnselection");
                        }
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")[index]).removeClass("e-columnselection");
                    this.selectedColumnIndexes.splice(0, index - indent);

                } else {
                    $gridRows.find(".e-rowcell").removeClass("e-columnselection");
                    $(this.getHeaderTable().find("th.e-headercell:not(.e-stackedHeaderCell)")).removeClass("e-columnselection");
                    this.selectedColumnIndexes = [];
                }
            }
            if (isColumnSelected && this._trigger("columnDeselected", args))
                return true;
        },
        getSelectedRows:function(){
            var $rows = $();
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                if (this.model.scrollSettings.frozenColumns > 0) {
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[0]);
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[1]);
                }
                else
                    $rows.push(this.getRowByIndex(this.selectedRowsIndexes[i])[0]);
            }
            return $rows;
        },
        getSelectedRecords: function () {
            var records = [], $gridRows = this.getRows();
            if (this._virtualScrollingSelection)
                return this._virtualSelRecords;
            for (var i = 0; i < this.selectedRowsIndexes.length; i++) {
                if (this.selectedRowsIndexes[i] != -1) {
                    if (this.model.editSettings.editMode == "batch" && $($gridRows[this.selectedRowsIndexes[i]]).hasClass("e-insertedrow")) {
                        var addedrecords = this.batchChanges.added.reverse();
                        records.push(addedrecords[this.selectedRowsIndexes[i]])
                        this.batchChanges.added.reverse();
                    }
                    else if (this.model.scrollSettings.allowVirtualScrolling)
                        records.push(this._virtualSelectedRecords[this.selectedRowsIndexes[i]]);
                    else
                        this.model.editSettings.editMode == "batch" ? records.push(this._currentJsonData[this.selectedRowsIndexes[i] - this.batchChanges.added.length]) : records.push(this._currentJsonData[this.selectedRowsIndexes[i]]);

                }
            }
            return records;
        },
        _setCurrentRow: function (requestType) {
            if (requestType == ej.Grid.Actions.Refresh || requestType == ej.Grid.Actions.Ungrouping || requestType == ej.Grid.Actions.Grouping || requestType == ej.Grid.Actions.Filtering || requestType == ej.Grid.Actions.Sorting || requestType == ej.Grid.Actions.Paging || requestType == ej.Grid.Actions.Search || ((requestType == ej.Grid.Actions.Delete || requestType == ej.Grid.Actions.Cancel) && this.model.currentViewData != null && this.model.currentViewData.length == 0)) {
                this._selectedRow(-1);
                this._selectedMultipleRows([]);
				if(!this._virtualDataRefresh || requestType == ej.Grid.Actions.Refresh )
					this.selectedRowsIndexes = [];
            }
            if (!this._isMapSelection && this._currentJsonData.length && requestType == ej.Grid.Actions.Delete && this._selectedRow() >= this._currentJsonData.length) {
                var lastIndex = this._currentJsonData.length - 1;
                this._selectedRow(lastIndex);
                this._selectedMultipleRows([lastIndex]);
                if (!this._virtualDataRefresh || requestType == ej.Grid.Actions.Refresh)
                    this.selectedRowsIndexes = lastIndex;
            }
            if (!this._isMapSelection && (requestType == ej.Grid.Actions.Delete || (requestType == ej.Grid.Actions.Save && !this._isMapSelection)) && this.model.selectedRowIndex != -1)
                this.selectRows(this.model.selectedRowIndex);
            if (requestType == ej.Grid.Actions.Save || requestType == ej.Grid.Actions.Cancel)
                this.element.focus();
        },
        _renderMultiTouchDialog: function () {
            this._customPop = ej.buildTag("div.e-gridpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-content"), $downTail = ej.buildTag("div.e-downtail e-tail");
            if (this.model.allowMultiSorting) {
                var $selElement = ej.buildTag("span.e-sortdirect e-icon");
                $content.append($selElement);
            }
            if (this.model.selectionType == ej.Grid.SelectionType.Multiple) {
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            }
            this._customPop.append($content);
            this._customPop.append($downTail);
            this.element.append(this._customPop);
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.widget("ejGrid", "ej.Grid",  {
        
        _rootCSS: "e-grid",
        // widget element will be automatically set in this
        element: null,
        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,
        _requiresID: true,
        keyConfigs: /** @lends ejGrid# */{
            focus: "e",
            insertRecord: "45", //Insert
            deleteRecord: "46", // delete
            editRecord: "113", //F2
            saveRequest: "13", // enter
            cancelRequest: "27", //Esc
            nextPage: "34", // PgDn
            previousPage: "33", // PgUp
            lastPage: "ctrl+alt+34", //"CtrlAltPgDn",
            firstPage: "ctrl+alt+33", //"CtrlPlusAltPlusPgUp",
            nextPager: "alt+34", //"AltPlusPgDown",
            previousPager: "alt+33", //"AltPlusPgUp",
            firstCellSelection: "36", //"Home",
            lastCellSelection: "35", //"End",
            firstRowSelection: "ctrl+36", //"CtrlPlusHome",
            lastRowSelection: "ctrl+35", //"CtrlPlusEnd",
            rowUpSelection: "ctrl+shift+38", //"CtrlPlusShiftplusUpArrow",
            rowDownSelection: "ctrl+shift+40", //"CtrlPlusShiftplusDownArrow",
            randomSelection: "ctrl+shift+83", // "CtrlPlusShiftplusSkey",
            upArrow: "38", //Up arrow
            downArrow: "40", //Down arrow
            rightArrow: "39", //Right arrow
            leftArrow: "37", //Left arrow
            moveCellRight: "9", //tab
            moveCellLeft: "shift+9", //shifttab
            selectedGroupExpand: "alt+40", //"AltPlusDownArrow",
            totalGroupExpand: "ctrl+40", //"CtrlPlusDownArrow",
            selectedGroupCollapse: "alt+38", //"AltPlusUpArrow",
            totalGroupCollapse: "ctrl+38", //"CtrlPlusUpArrow",
            multiSelectionByUpArrow: "shift+38",//"shiftPlusUpArrow",
            multiSelectionByDownArrow: "shift+40",//"shiftPlusDownArrow"
            multiSelectionByRightArrow: "shift+39",//"shiftPlusRigthArrow"
            multiSelectionByLeftArrow: "shift+37",//"shiftPlusLeftArrow"
        },
        _ignoreOnPersist: [
            "actionBegin", "actionComplete", "actionFailure", "batchAdd", "batchDelete", "beforeBatchSave", "beforeBatchAdd", "beforeBatchDelete", "beginEdit",
            "cellEdit", "cellSave", "cellSelecting", "cellSelected", "cellDeselecting", "cellDeselected", "columnDrag", "columnDragStart", "columnDrop", "columnSelecting",
            "columnSelected", "columnDeselecting", "columnDeselected", "create", "dataBound", "destroy", "detailsCollapse", "detailsExpand", "endAdd", "endDelete",
            "endEdit", "recordClick", "recordDoubleClick", "load", "resized", "resizeEnd", "resizeStart", "rightClick", "rowSelected", "rowSelecting", "rowDeselected",
            "rowDeselecting", "rowDrag", "rowDragStart", "rowDrop", "templateRefresh", "beforePrint", "beforeRowDrop", "query", "isEdit", "toolbarClick", "queryCellInfo",
            "mergeCellInfo", "mergeHeaderCellInfo","currentViewData", "enableAltRow", "enableRTL", "contextClick", "contextOpen", "rowDataBound", "rowTemplate", "detailsDataBound",
            "detailsTemplate", "childGrid", "summaryRows", "toolbarSettings", "editSettings", "allowMultiSorting", "enableAutoSaveOnSelectionChange", "locale",
            "allowCellMerging", "allowTextWrap", "textWrapSettings", "cssClass", "dataSource", "groupSettings.enableDropAreaAutoSizing", "enableRowHover", "showSummary",
            "allowGrouping", "enableHeaderHover", "allowKeyboardNavigation", "scrollSettings.frozenRows", "scrollSettings.frozenColumns", "enableTouch",
            "contextMenuSettings.enableContextMenu", "exportToExcelAction", "exportToWordAction", "exportToPdfAction"
        ],
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "rowDataBound", "rowTemplate",
            "detailsDataBound", "editSettings", "pageSettings", "enableAutoSaveOnSelectionChange", "localization", "allowScrolling",
            "cssClass", "dataSource", "groupSettings.enableDropAreaAnimation", "enableRowHover", "allowSummary",
            "enableHeaderHover", "allowKeyboardNavigation"
        ],
        ignoreOnToolbarServerClick: [],
        observables: ["dataSource", "selectedRowIndex", "pageSettings.currentPage", "selectedRowIndices"],
        _tags: [{
            tag: "columns",
            attr: ["allowEditing", "allowFiltering","allowTextWrap", "filterType", "allowGrouping","allowResizing","allowSorting", "cssClass", "customAttributes", "dataSource", "defaultValue",
			"disableHtmlEncode", "editTemplate", "editType", "foreignKeyField", "foreignKeyValue", "headerTemplateID", "headerText", "isFrozen",
			"isIdentity", "isPrimaryKey","filterBarTemplate", "textAlign", "templateID", "textAlign", "headerTextAlign", "tooltip", "clipMode",
            "validationRules.minlength", "validationRules.maxlength", "validationRules.range", "validationRules.number", "validationRules.required",
            "editParams.decimalPlaces", [{ tag: "commands", attr: ["type", "buttonOptions"] }]
            ],
            content: "template"
        }, {
            tag: "summaryRows",
            attr: ["showCaptionSummary", "showTotalSummary", [{
                tag: "summaryColumns", attr: ["customSummaryValue", "dataMember", "displayColumn", "summaryType", "template"]
            }]]
        }, {
            tag: "stackedHeaderRows",
            attr: [
            [{
                tag: "stackedHeaderColumns", attr: ["headerText", "column"]
            }]]
        }, {
            tag: "filterSettings.filteredColumns", attr: []
        }, {
            tag: "sortSettings.sortedColumns", attr: []
        }],
        _dataSource: ej.util.valueFunction("dataSource"),
        _selectedRow: ej.util.valueFunction("selectedRowIndex"),
        _selectedMultipleRows: ej.util.valueFunction("selectedRowIndices"),
        _currentPage: ej.util.valueFunction("pageSettings.currentPage"),
        // default model
        defaults: /** @lends ejGrid# */ {            
            allowPaging: false,            
            showColumnChooser: false,            
            gridLines: "both",            
            allowSorting: false,            
            showStackedHeader: false,            
            selectedRecords: [],
            stackedHeaderRows: [],
            allowFiltering: false,
            allowMultipleExporting: false,            
            allowSelection: true,            
            allowGrouping: false,            
            showSummary: false,            
            allowResizing: false,            
            allowResizeToFit: false,            
            allowTextWrap: false,            
            allowCellMerging: false,            
            enableRowHover: true,            
            enablePersistence: false,
            enableFocusout: false,
            selectedRowIndex: -1,
            selectedRowIndices: [],
            allowSearching: false,
            enableToolbarItems:false,            
            enableHeaderHover: false,            
            allowReordering: false,            
            allowKeyboardNavigation: true,
            allowRowDragAndDrop: false,
            enableTouch: true,
			enableLoadOnDemand: false,
            columnLayout:'auto',            
            selectionType: "single",            
            dataSource: null,            
            cssClass: "",            
            allowScrolling: false,            
            locale: "en-US",            
            enableAutoSaveOnSelectionChange: true,            
            allowMultiSorting: false,
            exportToExcelAction: "ExportToExcel",
            exportToWordAction: "ExportToWord",
            exportToPdfAction: "ExportToPdf",
            _groupingCollapsed: [],
            _isHeightResponsive: false,
            _checkSelectedRowsIndexes: [],
            editSettings:  {                
                allowEditing: false,                
                showAddNewRow: false,                
                allowAdding: false,                
                showAddNewRow: false,                
                allowDeleting: false,                
                editMode: "normal",                
                rowPosition: "top",                
                dialogEditorTemplateID: null,                
                allowEditOnDblClick: true,                
                externalFormTemplateID: null,                
                inlineFormTemplateID: null,                
                formPosition: "bottomleft",               
				titleColumn: null,			   
                showConfirmDialog: true,                
                showDeleteConfirmDialog: false
            },            
            selectionSettings:  {                
                selectionMode: ["row"],                
                enableToggle: false,                
                cellSelectionMode: "flow"
            },
            resizeSettings: {
                resizeMode: 'normal'
            },
            pageSettings:  {               
                pageSize: 12,                
                pageCount: 8,                
                currentPage: 1,                
                totalPages: null,                
                enableTemplates: false,                
                showDefaults: false,                
                template: null,      
			     pageSizeList:[],				
                totalRecordsCount: null,                
                enableQueryString: false,
                printMode: "allpages"
            },            
            groupSettings:  {               
                showDropArea: true,                
                showToggleButton: false,                     
                showGroupedColumn: true,                
                showUngroupButton: true,                
                enableDropAreaAutoSizing: true,                
                captionFormat: null,                
                groupedColumns: []
            },          
            contextMenuSettings: {                
                enableContextMenu: false,                
                contextMenuItems: ["Add Record", "Edit Record", "Delete Record", "Sort In Ascending Order", "Sort In Descending Order", "Next Page", "Last Page", "Previous Page", "First Page", "Save", "Cancel", "Grouping", "Ungrouping"],
                customContextMenuItems: [],
                subContextMenu: [],
                disableDefaultItems: false
            },            
            filterSettings:  {                
                filterType: "filterbar",                
                filterBarMode: "immediate",                
                showFilterBarStatus: true,
                statusBarWidth: 450,                
                showPredicate: false,                
                filteredColumns: [],
                enableInterDeterminateState: true,                
                maxFilterChoices: 1000,                
                enableCaseSensitivity: false,
                immediateModeDelay: 1500,
                enableComplexBlankFilter: true,
                blankValue: ""
            },
            searchSettings:  {                
                fields: [],                
                key: "",                
                operator: "contains",                
                ignoreCase: true
            },            
            sortSettings:  {                                             
                sortedColumns: []
            },            
            toolbarSettings:  {                
                showToolbar: false,                
                toolbarItems: [],                
                customToolbarItems: []
            },            
            minWidth: 0,
            currentIndex: 0,
            rowDropSettings: {
                dragBehavior:"move",
                dropMapper: null,
                dragMapper: null,
                dropTargetID: null,
            },
            scrollSettings: 
            {                
                width: "auto",                
                height: 0,                
                enableTouchScroll: true,                
                allowVirtualScrolling: false,                
                virtualScrollMode: "normal",                
                frozenRows: 0,                
                frozenColumns: 0,
                buttonSize: 18,
                autoHide: false,
                scrollerSize: 18,
                scrollOneStepBy: 57,
				enableVirtualization: false
            },  
            textWrapSettings: {
                wrapMode: "both"
            },                    
            summaryRows: [],            
            enableRTL: false,            
            enableAltRow: true,
            currentViewData: [],            
            detailsTemplate: null,            
            childGrid: null,            
            keySettings: null,            
            rowTemplate: null,            
            detailsDataBound: null,            
            rowDataBound: null,            
            queryCellInfo: null,                      
            mergeCellInfo: null,
            mergeHeaderCellInfo:null,
            create: null,            
            actionBegin: null,            
            actionComplete: null,            
            actionFailure: null,            
            beginEdit: null,            
            endEdit: null,            
            endAdd: null,            
            endDelete: null,            
            beforeBatchAdd: null,            
            beforeBatchSave: null,            
            beforeBatchDelete: null,
            beforePrint: null,
            batchAdd: null,            
            batchDelete: null,            
            cellSave: null,            
            cellEdit: null,            
            resizeStart: null,            
            resizeEnd: null,            
            resized: null,            
            load: null,            
            destroy: null,            
            rowSelecting: null,            
            rowSelected: null,
            rowHover: null,
            rowDeselecting:null,
            rowDeselected:null,	            
            cellSelecting: null,            
            cellSelected: null, 
            cellDeselecting:null,
      	    cellDeselected:null,				
            columnSelecting: null,            
            columnSelected: null, 
            columnDeselecting: null,            
            columnDeselected: null,		         
            columnDragStart: null,            
            columnDrag: null,            
            columnDrop: null,
            rowDrag: null,
            rowDragStart: null,
            rowDrop: null,
            beforeRowDrop: null,
            dataBound: null,            
            recordClick: null,            
            recordDoubleClick: null,            
            templateRefresh: null,            
            rightClick: null,            
            detailsCollapse: null,            
            detailsExpand: null,            
            toolbarClick: null,           
            contextOpen: null,            
            contextClick: null,       
            columns: [],            
            query: null,
            isEdit: false,            
            isResponsive: false,            
            enableResponsiveRow: false,
			virtualLoading: null
        },
        dataTypes: {
            dataSource: "data",
            query: "data",
            columns: "array",
            childGrid: "parent",
            gridLines: "enum",
            summaryRows: "array",
            stackedHeaderRows: "array",
            toolbarSettings: {
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            contextMenuSettings: {
                contextMenuItems: "array",
                customContextMenuItems: "array",
                subContextMenu: "array"
            },
            selectionSettings: {
                cellSelectionMode: "enum",
                selectionMode: "array",
                selectedRecords: "array"
            },
            sortSettings: {
                sortedColumns: "array"
            },
            filterSettings: {
                filteredColumns: "array",
                filterType: "enum",
                filterBarMode: "enum",
            },
            groupSettings: {
                groupedColumns: "array"
            },
			pageSettings:{
				pageSizeList: "array"
			},
            editSettings: {
                editMode: "enum",
                formPosition: "enum",
                rowPosition: "enum",
            },
            rowDropSettings: {
                dragBehavior: "enum"
            },
            searchSettings: {
                fields: "array"
            },
            textWrapSettings: {
                wrapMode: "enum"
            }
        },

        _columns: function (index, property, value, old) {
            var $header = this.element.find(".e-gridheader");
            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
            this._headerCellgDragDrop();
            this.refreshContent(true);
            this._trigger("refresh");
        },
        _summaryRows: function (index, property, value, old) {
            if (property == "showTotalSummary" || property == "showCaptionSummary") {
                var indx = index.summaryRows;
                var val = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                this.option("summaryRows")[indx][property] = val;
            }
            this.element.find(".e-gridfooter").remove();
            var footer = this._renderGridFooter();
            if (!ej.isNullOrUndefined(footer)) footer.insertAfter(this.getContent());
            if (property == "showCaptionSummary" || property == "title") {
                this._isCaptionSummary = this.option("summaryRows")[indx]["showCaptionSummary"];
                this.model.showSummary = this._isCaptionSummary;
                if (this.model.groupSettings.groupedColumns.length != 0)
                    this._refreshCaptionSummary();
            }
        },
        _summaryRows_summaryColumns: function (index, property, value, old) {
            if (property == "displayColumn" || property == "dataMember") {
                if (ej.isNullOrUndefined(this.getColumnByField(value)))
                    return;
            }
            this._createSummaryRows(this.getFooterTable());
            if (this.element.find(".e-groupcaptionsummary").length != 0)
                this._refreshCaptionSummary();
        },
        _stackedHeaderRows_stackedHeaderColumns: function (index, property, value, old) {
            this._refreshStackedHeader();
        },
        _sortSettings_sortedColumns: function (index, property, value, old) {
            var colName, direction;
            var sortObj = this.model.sortSettings.sortedColumns[index["sortSettings.sortedColumns"]];
            if (property == "field") {
                colName = this.getColumnByField(value) != null ? value : null;
                direction = (sortObj.direction == "ascending" || sortObj.direction == "descending") ? sortObj.direction : null;
            }
            else if (property == "direction") {
                colName = this.getColumnByField(sortObj.field) != null ? sortObj.field : null;
                direction = (value == "ascending" || value == "descending") ? value : null;
            }
            if (colName != null && direction != null)
                this.sortColumn(colName, direction);
        },
        _filterSettings_filteredColumns: function (index, property, value, old) {
            var field, operator, matchcase, predicate, filtervalue;
            var filterObj = this.model.filterSettings.filteredColumns[index["filterSettings.filteredColumns"]];
            switch (property) {
                case "field":
                    field = this.getColumnByField(value) != null ? value : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "matchcase":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = value.toLowerCase() == "true" || value.toLowerCase() == "false" ? ej.parseJSON(value) : false;
                    break;
                case "operator":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, value);
                    filtervalue = filterObj.value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "predicate":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = filterObj.value;
                    predicate = (value == "and" || value == "or") ? value : null;
                    matchcase = filterObj.matchcase;
                    break;
                case "value":
                    field = this.getColumnByField(filterObj.field) != null ? filterObj.field : null;
                    operator = this._map(ej.FilterOperators, filterObj.operator);
                    filtervalue = value;
                    predicate = (filterObj.predicate == "and" || filterObj.predicate == "or") ? filterObj.predicate : null;
                    matchcase = filterObj.matchcase;
                    break;
            }
            if (field != null && operator != null && filtervalue != null && predicate != null && matchcase != null)
                this.filterColumn(field, operator, filtervalue, predicate, matchcase);
        },
        _map: function (object, value) {
            var data = $.map(object, function (obj) {
                if (obj === value)
                    return obj;
            });
            return data.length != 0 ? data[0] : null;
        },
        _refreshCaptionSummary: function () {
            var temp = document.createElement('div');
            temp.innerHTML = ['<table>', $.render[this._id + "_GroupingTemplate"](this.model.currentViewData, { groupedColumns: this.model.groupSettings.groupedColumns }), '</table>'].join("");
            this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
            this.refreshContent();
        },
        
        getContentTable: function () {
            return this._gridContentTable;
        },

        setGridContentTable: function (value) {
            this._gridContentTable = value;
        },
        
        getContent: function () {
            return this._gridContent;
        },

        setGridContent: function (value) {
            this._gridContent = value;
        },
        
        getHeaderContent: function () {
            return this._gridHeaderContent;
        },

        setGridHeaderContent: function (value) {
            this._gridHeaderContent = value;
        },
        
        getHeaderTable: function () {
            return this._gridHeaderTable;
        },

        setGridHeaderTable: function (value) {
            this._gridHeaderTable = value;
        },
        
        getRows: function () {
            return this._gridRows;
        },
        
        getFilteredRecords: function () {
            return this._filteredRecords;
        },
        
        getRowByIndex: function (from, to) {
            try {
                var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), $row = $();
                if ($.isArray(from)) {
                    for (var i = 0; i < from.length; i++) {
                        if (this.model.scrollSettings.frozenColumns > 0) {
                            $row.push(gridRows[0][from[i]]);
                            $row.push(gridRows[1][from[i]]);
                        }
                        else
                            $row.push(gridRows[from[i]]);
                    }
                    return $row;
                }
                else if (ej.isNullOrUndefined(to)) {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push(gridRows[0][from]);
                        $row.push(gridRows[1][from]);
                        return $row;
                    }
                    return $(($gridRows).not(".e-virtualrow")[from]);
                } else {
                    if (this.model.scrollSettings.frozenColumns > 0) {
                        $row.push($(gridRows[0]).slice(from, to));
                        $row.push($(gridRows[1]).slice(from, to));
                        return $row;
                    }
                    return $($gridRows.not(".e-virtualrow").slice(from, to));
                }
            } catch (e) {
                return $();
            }
        },
        
        getColumnIndexByField: function (field) {
            for (var i = 0, col = this.model.columns, len = col.length ; i < len ; i++) {
                if (col[i]["field"] === field)
                    return i;
            }
            return -1;
        },
        
        getColumnIndexByHeaderText: function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column;
        },
        
        getIndexByRow: function ($tr) {
            var gridRows = this.getRows(), $gridRows = this._excludeDetailRows(), rowIndex;
            if (this.model.scrollSettings.frozenColumns > 0) {
                rowIndex = $(gridRows[0]).index($tr);
                if (rowIndex == -1)
                    rowIndex = $(gridRows[1]).index($tr);
                return rowIndex;
            } else
                return $gridRows.not(".e-virtualrow").index($tr);
        },
        
        getPrimaryKeyFieldNames: function () {
            if (this._primaryKeys.length != 0)
                return this._primaryKeys;
            for (var key = 0, col = this.model.columns, cLen = col.length; key < cLen; key++) {
                if (col[key]["isPrimaryKey"])
                    this._primaryKeys.push(col[key]["field"]);
            }
            return this._primaryKeys;
        },
        
        getVisibleColumnNames: function (headerText) {
            return this._visibleColumns;
        },
        
        getHiddenColumnNames: function (headerText) {
            return this._hiddenColumns;
        },
        
        getColumnByField: function (field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"] == field)
                    break;
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        },
        
        getsortColumnByField: function (field) {
            for (var column = 0; column < this.model.sortSettings.sortedColumns.length; column++) {
                if (this.model.sortSettings.sortedColumns[column]["field"] == field)
                    break;
            }
            return column == this.model.sortSettings.sortedColumns.length ? null : this.model.sortSettings.sortedColumns[column];
        },
        
        getColumnByHeaderText: function (headerText, field) {
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["headerText"] == headerText) {
                    if (field) {
                        if (ej.isNullOrUndefined(this.model.columns[column]["field"]) || this.model.columns[column]["field"] == "")
                            break;
                    }
                    else
                        break;
                }
            }
            return column == this.model.columns.length ? null : this.model.columns[column];
        },
        
        getCurrentViewData: function () {
            return this._currentJsonData;
        },
        
        getColumnFieldNames: function () {
            var columnNames = [];
            for (var column = 0; column < this.model.columns.length; column++) {
                if (this.model.columns[column]["field"])
                    columnNames.push(this.model.columns[column]["field"]);
            }
            return columnNames;
        },
        
        getBrowserDetails: function () {
            var b = navigator.userAgent.match(/(firefox|chrome|opera|msie|safari)\s?\/?(\d+(.\d+)*)/i);
            if (!!navigator.userAgent.match(/Trident\/7\./) || !!navigator.userAgent.match(/Edge/))
                return { browser: "msie", version: $.uaMatch(navigator.userAgent).version };
            return { browser: b[1].toLowerCase(), version: b[2] };
        },
        _initPrivateProperties: function () {
            this._groupContextIndex = -1;
            this._dynamicSelectedRowIndex = null;
            this._summaryContextIndex = -1;
            this._showInColumnchooserCol = [];
            this._currentVirtualRowIndex = 0;
			this._isCheckboxChecked=false;
			this._isCheckboxUnchecked=false;
            this._click = 0;
            this._gridPhoneMode = 320;
            this._columntemplaterefresh = false;
			this._tabKey = false;
            this._gridHeaderTable = null;
            this._gridWidth = this.element.width();
            this._id = this.element.attr("id");
            this._gridRows = [];
            this._fltrBarcell = false;
			this._unboundRow = null;
            this._gridContentTable = null;
            this._gridContent = null;
            this._remoteSummaryData = null;
            this._gridSort = null;
            this._gridHeaderContent = null;
            this._gridFooterContent = null;
            this._gridFooterTable = null;
            this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
            this._links = null;
            this._gridPager = null;
            this._cSortedColumn = null;
            this._cSortedDirection = null;
            this._$curSElementTarget = null;
            this._gridFilterBar = null;
            this._$curFieldName = null;
            this._$prevFieldName = null;
            this._editedData = {};
            this._isEditChangesApplied = false;
            this._mediaStatus = false;
            this._$fDlgIsOpen = false;
            this._$menuDlgIsOpen = false;
            this._$colType = null;
            this._$colFormat = null;
            this._$prevColType = null;
            this._$prevSElementTarget = null;
            this._currentFilterColumn = null;
            this._filteredRecordsCount = null;
            this._filteredRecords = [];
            this._validatedColumns = [];
            this.filterColumnCollection = [];
            this._previousFilterCount = null;
            this._excelFilter = null;
            this._isExcelFilter = this.model.filterSettings.filterType == "excel";
            this._$fkColumn = false;
			this._fkParentTblData =[];
            this._primaryKeys = [];
            this._identityKeys = [];
            this._primaryKeyValues = [];
            this._modifiedRecords = [];
            this._addedRecords = [];
            this._tdsOffsetWidth = [];
            this._deletedRecords = [];
            this._disabledToolItems = $();
            this._validationRules = {};
            this._groupedColumns = [];
            this._LastColumnUnGroup = false;
            this._scolumns = [];
            this._currentJsonData = [];
            this._groupingColumnIndex = 0;
            this._dataManager = this._dataSource() instanceof ej.DataManager ? this._dataSource() : this._dataSource() != null ? ej.DataManager(this._dataSource()) : null;
            if (this._dataManager != null && this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.totalRecordsCount != null && this._dataManager.dataSource.json != null)
                this._dataManager.dataSource.json.splice(this.model.pageSettings.totalRecordsCount);
            this._isRemoteSaveAdaptor = (this._dataSource() instanceof ej.DataManager && this._dataSource().adaptor instanceof ej.remoteSaveAdaptor);
            this._isLocalData = true;
            this._disabledResizingColumns = [];
            this._disabledSortableColumns = [];
            this._disabledGroupableColumns = [];
            this._disabledFilterableColumns = [];
            this._disabledEditableColumns = [];
            this._hiddenColumns = [];
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._hiddenColumnsField = [];
            this._ccVisibleColumns = [];
            this._ccHiddenColumns = [];
            this._sortedColumns = [];
            this.multiSortRequest = false;
            this.multiSelectCtrlRequest = false;
            this.multiSelectShiftRequest = false;
            this._enableSelectMultiTouch = false;
            this._enableSortMultiTouch = false;
            this._templateRefresh = false;
            this.initialRender = false;
            this._selectDrag = false;
            this._isAddNew = false;
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
             this._virtualLoadedRecords = {};
            this._virtualLoadedRows = {};
			this._virtualPageRecords = {};
			this._virtaulSel = [];
            this._singleView = false;
			this._dragIndex = null;
			this._dragUpInterval = null;
			this._dragDownInterval = null;
			this._queryCellView = [];
			this._currentPageViews = [];
            this._virtualLoadedPages = [];                                  
            this._currentLoadedIndexes = [];
            this._prevLoadedIndexes = [];
			this._prevVirtualSort = [];
			this._prevVirtualFilter = [];
            this._prevVirtualIndex = 0;
            this._currentVirtualIndex = 1;
            this._virtualRowCount = 0;
            this._virtualSelectedRecords = {};
            this._selectionByGrid = false;
            this._enableCheckSelect = false;
            this.checkSelectedRowsIndexes = [];
            this._isMapSelection = false;
            this._selectionMapColumn = null;
            this._selectAllCheck = false;
            this.selectedRowsIndexes = [];
            this.OldfilterValue = null;
            this._isReorder = false;
            this._searchString = "";
            this._searchCount = null;
            this.columnsWidthCollection = [];
            this._Indicator = null;
            this._lastSelectedCellIndex = [];
            this._resizer = null;
            this._bulkEditCellDetails = {
                cellValue: null,
                rowIndex: -1,
                columnIndex: -1,
                fieldName: null,
                _data: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                rowData: null
            };
            this.batchChanges = {
                added: [],
                deleted: [],
                changed: []
            };
            this._bulkEditTemplate = $();
            this._confirmDialog = null;
            this._confirmedValue = false;
            this._lastRow = false;
            this._isVirtualRecordsLoaded = false;
            this._scrollValue = 0;
            this._currentTopFrozenRow = this.model.scrollSettings.frozenRows;
            this._rowHeightCollection = [];
            this._scrollObject = null;
            this._customPop = null;
            this.selectedRowCellIndexes = [];
            this._rowIndexesColl = [];
            this.selectedColumnIndexes = [];
			this._allowrowSelection = this._allowcellSelection = this._allowcolumnSelection = false;
			this.commonQuery = this.model.query.clone();
            if (ej.gridFeatures.group) {
                this._rowCol = this._captionSummary();
                this._isCaptionSummary = (this._rowCol != null && this._rowCol.length) > 0 ? true : false;
            }
            this.phoneMode = this.model.isResponsive && document.documentElement.clientWidth < 360 ? true : false;
            if (this.model.selectionSettings.selectionMode.length > 0 && this.model.allowSelection)
                this._initSelection();
            this._mediaQuery = false;
            this._columnChooserList = null;
            this._$headerCols = null;
            this._$contentCols = null;
            this._detailsOuterWidth = null;
            this._editForm = null;
            this._cloneQuery = null;
            this.localizedLabels = this._getLocalizedLabels();
            this._searchBar = null;
            this._relationalColumns = [];
            this._dropDownManager = {};
			this._isUngrouping = false;
			this._columnChooser = false;
			this._showHideColumns = false;
			this._vCurrentTrIndex = null;
			this._lastVirtualPage = null;
			this._currentVIndex = null;
			if (!this.model.enablePersistence || ej.isNullOrUndefined(this._isHeightResponsive))
	           this._isHeightResponsive = false;
			this._resize = false;
			this._initHeight = 0;
			this._initDataProcessed = false;
			this._menuColTypes = [];
			this._excelColTypes = [];
            this._previousTr = null;
        },
        _init: function () {
            this._trigger("load");
            if (ej.isNullOrUndefined(this.model.query) || !(this.model.query instanceof ej.Query))
                this.model.query = ej.Query();
            if (!ej.isNullOrUndefined(this.model.parentDetails)) {
                var temp = this.model.queryString, ftemp = this.model.foreignKeyField;
                this.model.query = this.model.query.clone();
                var val = (this.model.parentDetails.parentKeyFieldValue === undefined) ? "undefined" : this.model.parentDetails.parentKeyFieldValue;
                this.model.query.where(ej.isNullOrUndefined(ftemp) ? temp : ftemp, "equal", val, true);
            }
			this._initPrivateProperties();
            if (ej.gridFeatures.common)
                this._initScrolling();            
            if (this.model.enableResponsiveRow)
                this.element.addClass("e-responsive");
            this._checkForeignKeyBinding();
            this._checkDataBinding();
        },
        _initComplexColumn: function (obj, field, cxField) {
            var complexField = cxField || field;
            for (var field1 in obj) {

                if (typeof obj[field1] == "object" && !ej.isNullOrUndefined(obj[field1])) {
                    complexField = complexField.concat(".").concat(field1);
                    this._initComplexColumn(obj[field1], field1, complexField);
                }
                else {
                    var cxFieldName = (complexField).concat(".").concat(field1), value = obj[field1];;
                    this.model.columns.push({
                        field: cxFieldName,
                        type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                    });
                }
            }
        },
        _initColumns: function (object) {
            while (object.items != undefined)
                object = object.items[0];
            if (this.model.columns.length == 0 && object) {
                for (var field in object) {
                    if (object.hasOwnProperty(field) && (typeof (object[field]) != "object" || object[field] instanceof Date || object[field] == null)) {
                        var value = object[field];
                        this.model.columns.push({
                            field: field,
                            type: value != null ? (value.getDay ? (value.getHours() > 0 || value.getMinutes() > 0 || value.getSeconds() > 0 || value.getMilliseconds() > 0 ? "datetime" : "date") : typeof (value)) : null
                        });
                    }
                    else if (typeof (object[field]) == "object") {
                        this._initComplexColumn(object[field], field);
                    }
                }
                this.model.columns.length && this._renderAfterColumnInitialize();
            } else {
                for (var index = 0; index < this.model.columns.length; index++) {
                    this.model.columns[index].field = ej.isNullOrUndefined(this.model.columns[index].field) ? "" : this.model.columns[index].field;
                    if (!ej.isNullOrUndefined(this.model.columns[index].validationRules))
                        this._validatedColumns.push(this.model.columns[index].field);
                    if (ej.isNullOrUndefined(this.model.columns[index].type)) {
                        var $field = !ej.isNullOrUndefined(this.model.columns[index].field) ? ej.getObject(this.model.columns[index].field, object) : null, coldata = this.model.columns[index].dataSource;
                        if (!!coldata && this.model.columns[index].foreignKeyValue) {
                            this.model.columns[index].originalType = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                            $field = !(coldata instanceof ej.DataManager) ? ej.getObject("0." + this.model.columns[index].foreignKeyValue, coldata) : ej.getObject("0." + this.model.columns[index].foreignKeyValue, this.model.columns[index].foreignKeyData);
                        }
                        this.model.columns[index].type = $field != null ? ($field.getDay ? ($field.getHours() > 0 || $field.getMinutes() > 0 || $field.getSeconds() > 0 || $field.getMilliseconds() > 0 ? "datetime" : "date") : typeof ($field)) : null;
                    }
                    else if (this.model.columns[index]["type"] == "date" && this.model.columns[index].format == undefined && this._isReorder != true && this.initialRender && !this._showHideColumns)
                        $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture(this.model.locale).calendars.standard.patterns.d + "}" });
                    else if (this.model.columns[index]["type"] == "datetime" && this.model.columns[index].format == undefined && this._isReorder != true && this.initialRender && !this._showHideColumns)
                        $.extend(this.model.columns[index], { format: "{0:" + ej.preferredCulture(this.model.locale).calendars.standard.patterns.d + " " + ej.preferredCulture(this.model.locale).calendars.standard.patterns.t + "}" });
                  }
            }
        },
        _initSelection: function () {
            var mode = this.model.selectionSettings.selectionMode,i;
            for (i = 0; i < mode.length; i++) {
                this["_allow" + mode[i] + "Selection"] = true;
            }
        },
        _checkDataBinding: function () {
            if (!this.model.columns.length && (((this._dataSource() == null || !this._dataSource().length) && !(this._dataSource() instanceof ej.DataManager)) || ((this._dataSource() instanceof ej.DataManager) && this._dataManager.dataSource.url == undefined && !this._dataSource().dataSource.json.length))) {
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this.localizedLabels.EmptyDataSource);
                this._alertDialog.ejDialog("open");
                return;
            }
            this._initialRenderings();
            if (this.model.editSettings.allowDeleting && this.model.selectionType == "multiple")
                this.multiDeleteMode = true;
            this.initialRender = true;
            this.model.enableRTL && this.element.addClass("e-rtl");
            if (this.model.allowFiltering && this._isExcelFilter)
                this._renderExcelFilter();
            if (this.model.cssClass != null)
                this.element.addClass(this.model.cssClass);
            if (this.model.allowGrouping)
                this.element.append(this._renderGroupDropArea());
            if (this.model.toolbarSettings.showToolbar || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow)) {
                this.element.append(this._renderToolBar());
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10 && $.inArray("search", this.model.toolbarSettings.toolbarItems) != -1) {
                    var searching = this.element.find('.e-toolbar.e-toolbarspan .e-gridsearchbar');
                    ej.ieClearRemover(searching[0]);
                }
            }
            var columns = this.model.columns;
            if (columns && columns.length) {
                var expands = this.model.query._expands;                
                if (typeof columns[0] === "string")
                    for (var i = 0; i < columns.length; i++)
                        columns[i] = { field: columns[i] };
                for (var i = 0; i < columns.length; i++) {
                    if (!columns[i].field || columns[i].field.indexOf('.') === -1) continue;
                    this._getExpands(columns[i].field, expands);
                }
                this.model.query.expand(expands);
                this.commonQuery.expand(expands);
                this._renderAfterColumnInitialize();
            }
            if (this.model.allowPaging){
			 	if(this.model.isResponsive)
                    this.model.pageSettings.isResponsive = true;
                this.element.append(this._renderGridPager());
				if(this.model.pageSettings.isResponsive)
					$(this.element.find(".e-pager")).ejPager('instance')._reSizeHandler();
			}
            if (this.model.contextMenuSettings.enableContextMenu)
                this.element.append(this._renderContext());
            if ($.isFunction($.fn.ejWaitingPopup)) {
                this.element.ejWaitingPopup({ showOnInit: false });
                $("#" + this._id + "_WaitingPopup").addClass("e-gridwaitingpopup");
            }
            if (this.model.scrollSettings.allowVirtualScrolling) {
                this._loadedJsonData = [];
                this._prevPage = 1;
            }
            if (this._dataSource() instanceof ej.DataManager) {
                this.element.ejWaitingPopup("show");
                if (this._dataSource().ready != undefined) {
                    var proxy = this;
                    this._dataSource().ready.done(function (args) {
                        proxy._initDataSource();
                        proxy.model.dataSource = ej.DataManager(args.result);
                    });
                } else {
                    this.element.ejWaitingPopup("show");
                    this._initDataSource();
                }
            } else {
                this._ensureDataSource();
                this._trigger("actionBegin");
                this._setForeignKeyData();
                this._relationalColumns.length == 0 && this._initGridRender();
            }
        },
        _renderColumnChooser: function () {
            var $columnButton = ej.buildTag("button .e-ccButton", this.localizedLabels.Columns, { 'float': (this.model.enableRTL ? 'left' : 'right') }).attr("type", "button");
            this.element.prepend($columnButton);
            $columnButton.ejButton({
                prefixIcon: "e-icon e-down-arrow",
                imagePosition: "imageright",
                contentType: "textandimage",
                type: 'button',
                click: $.proxy(this._ccClickHandler, this),
                width: 90
            });
            var buttHeight = $columnButton.outerHeight();
            $columnButton.css('margin-top', 0 - (buttHeight));
            var elementTop = parseInt(this.element.css('margin-top'),10);
            this.element.css('margin-top', elementTop + buttHeight);
            var $mainDiv = ej.buildTag("div");
            var $outerDiv = ej.buildTag("div .e-grid e-columnChooser", '', {}, { id: this._id + "ccDiv" });
            if ($("#" + this._id + "ccDiv").data("ejDialog") != undefined) {
                $("#" + this._id + "ccDiv").ejDialog("destroy");
                $("#" + this._id + "ccDiv").remove();
            }
            var $searchBox = ej.buildTag("div.e-searchbox e-fields").append(ej.buildTag("input#" + this._id + "_ccSearchBox.e-ejinputtext e-filtertext", {}, {}, { "type": "text" }))
            var $sapnDiv = ej.buildTag('span .e-searchfind e-icon')
            $searchBox.append($sapnDiv);
            var $listOuterDiv = ej.buildTag('div', '', { 'height': '228px' }, { id: this._id + "liScrollerDiv" })
            this._renderColumnChooserData(false);
            $listOuterDiv.append(this._columnChooserList);
            $outerDiv.append($searchBox);
            $outerDiv.append($listOuterDiv);

            var $splitterDiv = ej.buildTag('div .e-columnChooserSplitter', '', { 'border-bottom': '0px' }), $buttonDiv;
            $outerDiv.append($splitterDiv);
            if (this.model.enableRTL) {
                $buttonDiv = ej.buildTag('div .e-ccBtndiv', '', { 'float': 'left', 'margin-top': '7px', 'margin-right': '-13px' });
                var $cancelButton = ej.buildTag("button .e-ccformbtn e-btncan e-flat", this.localizedLabels.Cancel, { 'margin-right': '7px', 'margin-left': '9px' });
                $($sapnDiv).addClass("e-rtl");
            }
            else {
                $buttonDiv = ej.buildTag('div .e-ccBtndiv', '', { 'float': 'right', 'margin-top': '7px' });
                var $cancelButton = ej.buildTag("button .e-ccformbtn e-btncan e-flat", this.localizedLabels.Cancel, { 'margin-right': '7px', 'margin-left': '6px' });
            }
            var $addButton = ej.buildTag("button .e-ccformbtn e-btnsub e-flat", this.localizedLabels.Done);
            $buttonDiv.append($addButton);
            $buttonDiv.append($cancelButton);
            $outerDiv.append($buttonDiv);
            $addButton.ejButton({
                click: $.proxy(this._addButtonCC, this),
                showRoundedCorner: true,
                width: 66
            });
            $cancelButton.ejButton({
                click: $.proxy(this._cancelButtonHandler, this),
                showRoundedCorner: true,
                width: 66
            });
            $outerDiv.insertBefore(this.element)
            $outerDiv.ejDialog({ width: 'auto', beforeClose: $.proxy(this._columnChooserBeforeClose, this), showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": this.model.enableRTL, "cssClass": this.model.cssClass, showHeader: false, width: 260 });
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10) {
                var searchBox = $(".e-columnChooser").find("input#" + this._id + "_ccSearchBox")[0];
                ej.ieClearRemover(searchBox);
            }
        },
        _renderColumnChooserData: function (refresh) {
            var selectAllCheck = this.model.columns.length == this.getVisibleColumnNames().length;            
            this._ccCheckBoxList = [];
            var $listBox = ej.buildTag("div", '', { 'margin-left': '0px', 'width': '250px' }), count = 0;
            for (var index = -1; index < this.model.columns.length; index++) {
                var isSelectAll = index == -1;
                if (isSelectAll || this.model.columns[index].showInColumnChooser) {
                    var column = this.model.columns[index];
                    var colValue = isSelectAll ? this.localizedLabels["SelectAll"] : ej.isNullOrUndefined(column.headerText) || column.headerText == "" ? column.field == "" ? null : column.field : column.headerText,
                        labelValue = column && column.disableHtmlEncode ? this._htmlEscape(colValue) : colValue;
                    if (!ej.isNullOrUndefined(colValue) || isSelectAll) {
                        var $innerDiv = ej.buildTag('div', '', {}, { 'class': 'e-columnChooserListDiv' });
                        var styleAttr = {};
                        var id = isSelectAll ? this._id + 'selectAll' : this._id + colValue.replace(/\s|\.|[^a-zA-Z0-9]|&nbsp/g, "_");
                        var inDom = $listBox.find("#" + id).length; inDom && count++;
                        var $input = ej.buildTag('input', '', styleAttr, { 'id': (!inDom ? id : id + count + ""), 'value': colValue, 'type': 'checkbox', "ej-field": isSelectAll ? '' : column.field, "ej-headertext": isSelectAll ? '' : column.headerText, 'class': isSelectAll ? 'e-selectall' : '' });
                        var label = ej.buildTag('label', labelValue, { 'font-size': '13px' }, { 'for': (!inDom ? id : id + count + "") });
                        $innerDiv.append($input);
                        $innerDiv.append(label);
                        $listBox.append($innerDiv);
                        var checked = !isSelectAll && !ej.isNullOrUndefined(column.visible) ? column.visible : true;
                        $input.ejCheckBox({
                            checked: isSelectAll ? selectAllCheck : checked,
                            change: $.proxy(this._columnChooserCheckChange, this)
                        });
                        if (!isSelectAll && !ej.isNullOrUndefined(column.visible))
                            $input[column.visible ? "attr" : "removeAttr"]("checked", true);
                    }
                }
                else if(!ej.isNullOrUndefined(this.model.columns[index].showInColumnChooser) && this._showInColumnchooserCol.indexOf(this.model.columns[index]) == -1)
                    this._showInColumnchooserCol.push(this.model.columns[index]);
            }
            if (!refresh)
                this._columnChooserList = $listBox;
            else {
                this._columnChooserList.empty().append($listBox.children());
                $("#" + this._id + "liScrollerDiv").is(":visible") && $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
            }
            this._ccCheckBoxList = this._columnChooserList.find("input:checkbox.e-js").not(".e-selectall");
        },
        _checkFinder: function () {
            var $this = $(this), $parent = $this.closest(".e-columnChooserListDiv");
            if ($this.hasClass("e-checkbox") && !$parent.hasClass("e-hide") && $this.prop("checked"))
                return true;
        },
        _displayFinder: function () {            
            return !$(this).closest(".e-columnChooserListDiv").hasClass("e-hide");
        },
        _columnChooserCheckChange: function (args) {
            if (!args.isInteraction) {
                if (args.isChecked)
                    $("#" + this._id + "ccDiv").find("button.e-ccformbtn.e-btnsub").removeClass("e-disable");
             return;
            }
            var checked = args.isChecked, displayedCheckBoxes = this._ccCheckBoxList.filter(this._displayFinder), checkedBoxes = this._ccCheckBoxList.filter(this._checkFinder),
                totalChecks = displayedCheckBoxes.length, checkedLen = checkedBoxes.length;
            if (args.model.id == this._id + 'selectAll') {
                if (!checked)
                    checkedBoxes.ejCheckBox({ checked: checked });                
                else           
                    displayedCheckBoxes.not(":checked").ejCheckBox({ checked: checked });                
            }
            else {
                this._columnChooserList.find('input.e-selectall').ejCheckBox('model.checked', totalChecks == checkedLen);
                checked = checkedLen != 0;
                this.element[checked ? "attr" : "removeAttr"]("checked", true);
            }
            var operation = !checked ? "addClass" : "removeClass";
            $("#" + this._id + "ccDiv").find("button.e-ccformbtn.e-btnsub")[operation]("e-disable");
        },
        _columnChooserBeforeClose: function () {
            $(".e-columnChoosertail").remove();
            $(".e-columnChoosertailAlt").remove();
            $("#" + this._id + "ccDiv").find("button.e-ccformbtn.e-btnsub").removeClass("e-disable");
            $("#" + this._id + "_ccSearchBox").val('');
            var args = {};
            args.target = {}; args.target.value = '';
            this._columnChooserSearch(args);
        },
        _columnChooserSearch: function (e) {
            if (e.type == 'click') {
                e.target.value = '';
                $("#" + this._id + "_ccSearchBox").val('');
            }
            var val = e.target.value;
            var span = $("#" + this._id + "_ccSearchBox").next('span');
            if (val != '') {
                span.removeClass("e-searchfind");
                span.addClass("e-cancel");
            }
            else {
                span.removeClass("e-cancel");
                span.addClass("e-searchfind");
            }
            $(".e-cancel").on('click', $.proxy(this._columnChooserSearch, this));
            var currentCheckedItemsData = this.model.columns;
            var columnCollection = [], gridColumns = [], tempCollection = [], proxy = this, 
                isHiddenByGroup = function (field) {
                    var model = proxy.model.groupSettings;
                    return !model.showGroupedColumn && $.inArray(field, model.groupedColumns) > -1;
                };
            if (val != '') {
                currentCheckedItemsData = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("headerText", ej.FilterOperators.startsWith, val, true));
                tempCollection = ej.DataManager(this.model.columns).executeLocal(ej.Query().where("field", ej.FilterOperators.startsWith, val, true));
                tempCollection.forEach(function (obj) {
                    if (obj.headerText == "" && $.inArray(obj, currentCheckedItemsData) == -1)
                        currentCheckedItemsData.push(obj);
                })
            }
             currentCheckedItemsData.forEach(function (obj) {
                 if (obj.showInColumnChooser && !isHiddenByGroup(obj.field)) {
                    var headerText = ej.isNullOrUndefined(obj.headerText) || obj.headerText == "" ? obj.field == "" ? null : obj.field : obj.headerText;
                    columnCollection.push(headerText);
                }
            });
            if (!ej.isNullOrUndefined($("#nomatches")[0]))
                $("#nomatches").remove();
       
            var divs = this._columnChooserList.find(".e-columnChooserListDiv");

            for (var i = 0; i < this.model.columns.length; i++) {
                if (this.model.columns[i].showInColumnChooser && !ej.isNullOrUndefined(this.model.columns[i].headerText)) {
                    if (this.model.columns[i].headerText != "")
                        gridColumns.push(this.model.columns[i].headerText)
                    else if (this.model.columns[i].field != "")
                        gridColumns.push(this.model.columns[i].field)
                }
            }

            for (var index = 0; index < gridColumns.length; index++) {
                var colValue = gridColumns[index];
                var indx = columnCollection.indexOf(colValue)
                if (!ej.isNullOrUndefined(colValue))
                    divs.eq(index + 1)[indx == -1 ? "addClass" : "removeClass"]("e-hide");
            }

            if (columnCollection.length == 0) {
               this._emptyColumnChooserData();
            }
            var checkDisplay = this._ccCheckBoxList.filter(this._displayFinder).length, checkChecked = this._ccCheckBoxList.filter(this._checkFinder).length, isChk = checkChecked == checkDisplay;
            if (columnCollection.length)
                divs.eq(0).find("input.e-js").ejCheckBox({ checked: isChk });
            divs.eq(0)[columnCollection.length == 0 ? "addClass" : "removeClass"]("e-hide");
            $("#" + this._id + "ccDiv").find("button.e-ccformbtn.e-btnsub")[!checkChecked ? "addClass" : "removeClass"]("e-disable");
            $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
        },
        _addButtonCC: function () {
            this._visibleColumns = [];
            this._hiddenColumns = [];
            this._visibleColumnsField = [];
            this._hiddenColumnsField = [];
            this._columnChooserClick = true;
            var args = {}; args.requestType = "columnchooser";
			this._columnChooser = true;
            var chbxs = this._columnChooserList.find("input:checkbox.e-js").not('.e-selectall');
            for (var i = 0, len = chbxs.length; i < len; i++) {
                var ele = $(chbxs[i]), hTxt = ele.attr("ej-headertext"), field = ele.attr("ej-field");
                if(this._id+"selectAll"!=ele.attr("id")){
                    this[chbxs[i].checked ? "_visibleColumns" : "_hiddenColumns"].push(hTxt);
                    this[chbxs[i].checked ? "_visibleColumnsField" : "_hiddenColumnsField"].push(field != "" ? field : hTxt);
                }
            }
            for (var i = 0, len = this._showInColumnchooserCol.length; i < len; i++) {
                var column = this._showInColumnchooserCol[i], htext = column.headerText, field = column.field;
                this[column["visible"] ? "_visibleColumns" : "_hiddenColumns"].push(htext);
                this[column["visible"] ? "_visibleColumnsField" : "_hiddenColumnsField"].push(field != "" ? field : htext);
            }
            var array1 = this._visibleColumns;
            var array2 = this._hiddenColumns;
            var arr = [], obj, duparr;
            obj = $.merge($.merge([], array1), array2);
            duparr = this._isDuplicate(obj);
            this._trigger("actionBegin", args);
            if (duparr) {
                this.showColumns(this._visibleColumnsField);
                this.hideColumns(this._hiddenColumnsField);
            }
            else {
                this.showColumns(this._visibleColumns);
                this.hideColumns(this._hiddenColumns);
            }
            $("#" + this._id + "ccDiv").ejDialog('close');
            $(".e-columnChoosertail").remove();
            this.refreshScrollerEvent();
            args = { requestType: "columnchooser", removedcolumns: [], addedcolumns: [], visiblecolumns: this.getVisibleColumnNames(), hiddencolumns: this.getHiddenColumnNames() };
            this._ccColumnUpdate(args.addedcolumns, this.getVisibleColumnNames(), this._ccVisibleColumns);
            this._ccColumnUpdate(args.removedcolumns, this.getHiddenColumnNames(), this._ccHiddenColumns);
            this._trigger("actionComplete", args);
            this._columnChooser = false;
        },
        _ccColumnUpdate: function (args, getColumns, ccColumns) {
            for (var i = 0; i < getColumns.length; i++) {
                if ($.inArray(getColumns[i], ccColumns) == -1)
                    args.push(getColumns[i]);
            }
        },
        _isDuplicate: function (arr) {
            var temp, count = [], duplicate = [];
            for (var i = 0; i < arr.length; i++) {
                temp = arr[i];
                if (count[temp] >= 1)
                    count[temp] = count[temp] + 1;
                else
                    count[temp] = 1;
            }
            for (temp in count) {
                if (count[temp] > 1)
                    return true;
            }
            return false;
        },
        _cancelButtonHandler: function () {
            $("#" + this._id + "ccDiv").ejDialog('close');
            $(".e-columnChoosertailAlt").remove();
            $(".e-columnChoosertail").remove();
        },
        _ccClickHandler: function (e) {
            var dlgWidth = 230, xPos;
            var chooserButton = this.element.find(".e-ccButton");
            xPos = chooserButton.offset().left + chooserButton.width();
            var dialogObj = $("#" + this._id + "ccDiv").data('ejDialog')
            if (dialogObj && dialogObj.isOpened()) {
                dialogObj.close();
                $(".e-columnChoosertail").remove();
                $(".e-columnChoosertailAlt").remove();
            }
            else {
                $("#" + this._id + "ccDiv").ejDialog({ width: '230px', height: '310px', position: { X: (this.model.enableRTL ? (xPos - dlgWidth + 143) : (xPos - dlgWidth)), Y: chooserButton.offset().top + 35 } })
                   .ejDialog("open");
                var maxZindex = parseInt($("#" + this._id + "ccDiv_wrapper").css('z-index'));
                var $tailDiv = ej.buildTag("div #" + this._id + "_ccTail .e-columnChoosertail", '', { 'display': 'block', 'position': 'absolute', 'left': (this.model.enableRTL ? (xPos - 78) : (xPos - 29)), 'top': chooserButton.offset().top + 15 });
                var $tailDiv2 = ej.buildTag("div #" + this._id + "_ccTailAlt .e-columnChoosertailAlt", '', { 'display': 'block', 'z-index': maxZindex + 2, 'position': 'absolute', 'left': (this.model.enableRTL ? (xPos - 78) : (xPos - 29)), 'top': chooserButton.offset().top + 16 });
                $tailDiv.insertBefore($("#" + this._id + "ccDiv_wrapper"));
                $tailDiv2.insertBefore($("#" + this._id + "ccDiv_wrapper"));
            }
            this._refreshColumnChooserList();
            this._ccVisibleColumns = this.getVisibleColumnNames();
            this._ccHiddenColumns = this.getHiddenColumnNames();
            $("#" + this._id + "liScrollerDiv").ejScroller({ height: '228', width: '228', buttonSize: 0 });
            $("#" + this._id + "liScrollerDiv").ejScroller('refresh');
            if (!ej.isIOSWebView() && this.getBrowserDetails().browser == 'chrome')
                $('.e-columnChooser .e-hscrollbar').attr('style', 'height: 10px !important;');
            $(".e-ejinputtext").on('keyup', $.proxy(this._columnChooserSearch, this))
        },
        _refreshColumnChooserList: function (collection) {
            var chbxs = this._columnChooserList.find("input:checkbox.e-js").not('.e-selectall');
			var duparr = this._isDuplicate($.merge($.merge([], this._visibleColumns), this._hiddenColumns));
            for (var i = 0, len = chbxs.length; i < len; i++) {
                var ele = $(chbxs[i]), hTxt = ele.attr("ej-headertext"), field = ele.attr("ej-field"), flag = undefined, isDup = chbxs.filter('[ej-headertext="' + hTxt + '"]').length;
                if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && $.inArray($(chbxs[i]).attr("ej-field"), this.model.groupSettings.groupedColumns) != -1) {
                    $(chbxs[i]).parents(".e-columnChooserListDiv").addClass("e-hide");
                    chbxs[i].checked = false;
				if(this._columnChooserList.find(".e-columnChooserListDiv").eq(0).hasClass("e-hide") && this.model.columns.length > this.model.groupSettings.groupedColumns.length)
					this._columnChooserList.find(".e-columnChooserListDiv").eq(0).removeClass("e-hide")
             
                }
                else {
                    $(chbxs[i]).parents(".e-columnChooserListDiv").removeClass("e-hide");
                    chbxs[i].checked = true;
                }
                var colValue = duparr ? (field == "" ? hTxt : field) : hTxt;
				flag = this[duparr ? "_hiddenColumnsField" : "_hiddenColumns"].indexOf(colValue) != -1;
                ele["prop"]("checked", !flag);
                ele.ejCheckBox("model.checked", !flag);
            }
            var chkSelectAll = chbxs.filter(this._displayFinder).length == chbxs.filter(this._checkFinder).length && chbxs.filter(this._displayFinder).length ? true : false;
            this._columnChooserList.find("input:checkbox.e-selectall").ejCheckBox({ checked: chkSelectAll });
            if (!this.model.groupSettings.showGroupedColumn) {
				if (!ej.isNullOrUndefined($("#nomatches")[0]))
					$("#nomatches").remove();
			if(this.model.columns.length == this.model.groupSettings.groupedColumns.length){
					this._columnChooserList.find(".e-columnChooserListDiv").eq(0).addClass("e-hide")
					this._emptyColumnChooserData();
				}
                var enable = chbxs.filter(this._displayFinder).length > 0 ? true : false;
                $("#" + this._id + "ccDiv").find("button.e-ccformbtn.e-btnsub").ejButton({ enabled: enable })
            }
        },
		_emptyColumnChooserData:function(){
            var $labeldiv = ej.buildTag('div#nomatches', '', { 'padding-left': '13px' });
			var div = $("#" + this._id + "ccDiv").find("#" + this._id + "liScrollerDiv")
            var $label = ej.buildTag('span', this.localizedLabels.NoResult);
            $labeldiv.append($label);
            $(div).append($labeldiv);
		},
        _initDataSource: function () {
            this._isLocalData = (!(this._dataSource() instanceof ej.DataManager) || (this._dataSource().dataSource.offline || this._isRemoteSaveAdaptor || this._dataSource().adaptor instanceof ej.ForeignKeyAdaptor));
            if (this._dataSource().adaptor instanceof ej.SqlDataSourceAdaptor) this._isLocalData = false;
            this._ensureDataSource();
            this._trigger("actionBegin");
            var queryPromise = this._dataSource().executeQuery(this.model.query), subPromises, proxy = this;
            if (this._dataManager.dataSource.table != null)
                this._dataManager.dataSource.table.css("display", "none");
            if (!this.element.is(":visible"))
                this.element.ejWaitingPopup("hide");
            queryPromise.done(ej.proxy(function (e) {
                if (!this._initDataProcessed) {
                    this._initDataProcess(e);
                    this._initDataProcessed = true;
                }
            }, this));
            var proxy = this;
            queryPromise.fail(function (e) {
                if (ej.isNullOrUndefined(proxy.element))
                    return;
                proxy.element.ejWaitingPopup("hide");
                proxy.model.currentViewData = [];
                proxy._gridRecordsCount = 0;
                proxy._renderGridContent().insertAfter(proxy.element.children(".e-gridheader"));
                var args = { error: e.error };
                proxy._trigger("actionFailure", args)
            })
        },
        _initDataProcess: function(e, args){
            if (ej.isNullOrUndefined(this.element))
                return;
            this._relationalColumns.length == 0 && this.element.ejWaitingPopup("hide");
            if (!this.model.columns.length && !e.count) {
                var lastPage = (e.count % this.model.pageSettings.pageSize == 0) ? (e.count / this.model.pageSettings.pageSize) : (parseInt(e.count / this.model.pageSettings.pageSize, 10) + 1);
                if (this._currentPage() > lastPage)
                    this._currentPage(lastPage);
                this._renderAlertDialog();
                this._alertDialog.find(".e-content").text(this.localizedLabels.EmptyDataSource);
                this._alertDialog.ejDialog("open");
                this.element.ejWaitingPopup("hide");
                return;
            }
            if (!ej.isNullOrUndefined(e.aggregates))
                this._remoteSummaryData = e.aggregates;
            if (!this.model.scrollSettings.enableVirtualization)
                this.model.currentViewData = e.result;
            if (this._$fkColumn && this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "excel")
                this._fkParentTblData = e.result;
            if (!this.model.enablePersistence && this.model.pageSettings.totalRecordsCount != null && this.model.filterSettings.filteredColumns.length == 0)
                this._gridRecordsCount = this.model.pageSettings.totalRecordsCount;
            else if (e.count == 0 && e.result.length)
                this._gridRecordsCount = e.result.length;
            else
                this._gridRecordsCount = e.count;
            if (this.model.filterSettings.filteredColumns.length > 0)
                this._filteredRecordsCount = e.count;
            if (this.getPager() != null)
                this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;
            if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {
                this._refreshVirtualViewDetails();
                if (this._isInitNextPage || this._remoteRefresh) {
                    this._setInitialCurrentIndexRecords(e.result, this._currentPage());
                    this._isInitNextPage = this._remoteRefresh = false;
                }
                else
                    this._setVirtualLoadedRecords(e.result, this._currentPage());
                if (this._isThumbScroll && !this._checkCurrentVirtualView(this._virtualLoadedRecords, this._currentVirtualIndex))
                    this._checkPrevNextViews(this._currentPage());
                if (this.initialRender) {
                    this.model.currentViewData = [];
                    for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                        var currentView = this._currentLoadedIndexes[i];
                        $.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView] || []);
                    }
                }
                else
                    this.model.currentViewData = e.result;
            }
            this._setForeignKeyData(args);
            this._relationalColumns.length == 0 && this._initGridRender();
        },
        _initialRenderings: function () {
            if (this.model.groupSettings.groupedColumns.length) {
                var sortedColumns = new Array();
                for (var i = 0; i < this.model.sortSettings.sortedColumns.length; i++) {
                    if (ej.isNullOrUndefined(this.model.sortSettings.sortedColumns[i].direction))
                        this.model.sortSettings.sortedColumns[i].direction = ej.sortOrder.Ascending;
                    sortedColumns.push(this.model.sortSettings.sortedColumns[i].field);
                }
                if(this.model.allowGrouping){
					for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
						if ($.inArray(this.model.groupSettings.groupedColumns[i], sortedColumns) == -1)
							this.model.sortSettings.sortedColumns.push({ field: this.model.groupSettings.groupedColumns[i], direction: ej.sortOrder.Ascending });
					}
                }
            }
        },
        _getExpands: function (field, arr) {
            var splits = field.split('.'), tmp = "";
            splits.splice(splits.length - 1, 1);
            for (var i = 0; i < splits.length; i++, tmp = "") {
                for (var j = 0; j < i; j++)
                    tmp += splits[j] + "/";
                tmp = tmp + splits[i];
                if (arr.indexOf(tmp) === -1)
                    arr.push(tmp);
            }
        },
        _renderAfterColumnInitialize: function () {
            this.element.append(this._renderGridHeader());
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar") {
                this._renderFiltering();
                this._renderFilterBarTemplate();
            }
			if(this.model.gridLines != "both")
				this._showHeaderGridLines();
            if (this.model.allowPaging)
                this.element.append(this.element.find(".e-pager").first());
        },
        _ensureDataSource: function (args) {
            if (this._dataSource() == null && !(this._dataSource() instanceof ej.DataManager)) {
                if (!ej.isNullOrUndefined(args) && args.requestType == "add")
                    this.dataSource([]);
                else
                    return;
            }
            this.model.query.requiresCount();
            var queryManagar = this.model.query;
            var cloneQuery = queryManagar.clone();           
            if (this._isLocalData && (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) && (!ej.isNullOrUndefined(this._cModifiedData) || !ej.isNullOrUndefined(this._cAddedRecord))) {
                if (ej.isNullOrUndefined(this._cAddedRecord)) {
                    for (var index = 0; index < this._primaryKeys.length; index++)
                        queryManagar = queryManagar.where(this._primaryKeys[index], ej.FilterOperators.equal, this._primaryKeyValues[index]);
                    var currentData = this._dataManager.executeLocal(queryManagar);
                    if (!(this._dataSource() instanceof ej.DataManager))
                        ej.copyObject(this._dataSource()[$.inArray(currentData.result[0], this._dataSource())], this._cModifiedData);
                    else
                        ej.copyObject(this._dataSource().dataSource.json[$.inArray(currentData.result[0], this._dataSource().dataSource.json)], this._cModifiedData);
                    this._cModifiedData = null;
                } else {
                    var tmpRcrd = this._cAddedRecord;
                    this._cAddedRecord = null;
                    (this._dataSource() instanceof ej.DataManager) ? this._dataSource().dataSource.json.unshift(tmpRcrd) : this._dataSource(undefined, true).splice(0, 0, tmpRcrd);
                }
                queryManagar.queries = cloneQuery.queries;
                if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                    this.model.isEdit = false;
            }
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && (this._excludeDetailRows().length == 1 || (this.multiDeleteMode == "multiple" && this.selectedRowsIndexes.length == this._excludeDetailRows().length)) && this.model.pageSettings.currentPage != 1)
                this._currentPage(this.model.pageSettings.totalPages - 1)
            if (args && this.model.editSettings.allowDeleting && args.requestType == "delete" && !ej.isNullOrUndefined(this._cDeleteData) && this._isLocalData) {
                if (!(this._dataSource() instanceof ej.DataManager)) {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource());
                    this._dataSource(undefined, true).splice(index, 1);
                }
                else {
                    var index = $.inArray(this._cDeleteData[0], this._dataSource().dataSource.json);
                    this._dataSource().dataSource.json.splice(index, 1);
                }
            }
            if (this.model.scrollSettings.allowVirtualScrolling && args && (args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete")) {
                this._virtualDataRefresh = true;
                this._refreshVirtualViewData();
            }
            if (this.model.sortSettings.sortedColumns.length) {
                 var sortedGrp = [], sortedColumns = this.model.sortSettings.sortedColumns;
                for (var i = sortedColumns.length - 1; i >= 0; i--){
                    if(this.model.groupSettings.groupedColumns.indexOf(sortedColumns[i].field) == -1){
                        queryManagar.sortBy(sortedColumns[i].field, sortedColumns[i].direction);
						if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization && $.inArray(sortedColumns[i], this._prevVirtualSort) == -1){
							for(var j = 0; j < this._prevVirtualSort.length; j++){
								if(sortedColumns[i].field == this._prevVirtualSort[j].field)
									this._prevVirtualSort.splice(j, 1);
							}
							this._needVPaging = this._currentVirtualIndex * this._virtualRowCount % this.model.pageSettings.pageSize <= this._virtualRowCount;
							this._prevVirtualSort.push(sortedColumns[i]);	
							this._virtualDataRefresh = true;
							this._refreshVirtualViewData();							
						}
					}
                    else
                        sortedGrp.push({field: sortedColumns[i].field, direction: sortedColumns[i].direction })
				}
                for (var j = 0; j < sortedGrp.length ; j++){
                    queryManagar.sortBy(sortedGrp[j].field, sortedGrp[j].direction);
                }
            }

            if (this.model.allowSearching && this.model.searchSettings.key.length) {
                var searchDetails = this.model.searchSettings;
                searchDetails.fields = searchDetails.fields.length != 0 ? searchDetails.fields : this.getColumnFieldNames();
                queryManagar.search(searchDetails.key, searchDetails.fields, searchDetails.operator || "contains", searchDetails.ignoreCase);
                if (!this.initialRender && args.requestType == "searching")
                    this._currentPage(1);
            }
            if (this._isLocalData && this.model.allowSearching)
                this._filteredRecords = this.model.searchSettings.key.length != 0 ? this._dataManager.executeLocal(queryManagar).result : [];
            if (this.model.allowFiltering && this.model.filterSettings.filteredColumns.length) {
                var predicate, firstFilterCondition = this.model.filterSettings.filteredColumns[0];
                var filteredColumns = this.model.filterSettings.filteredColumns;
                for (var i = 0; i < filteredColumns.length; i++) {
                    var index = $.inArray(this.getColumnByField(filteredColumns[i].field), this.filterColumnCollection);
                    if (filteredColumns[i].field !== "" && index == -1)
                        this.filterColumnCollection.push(this.getColumnByField(filteredColumns[i].field));
                }
				if ((this._isExcelFilter || this._excelFilterRendered) && !(firstFilterCondition instanceof ej.Predicate)) {
                    this._excelFilter.getPredicate(filteredColumns, null, true);
                    var predicates = this._excelFilter._predicates[0];
                    for (var prop in predicates) {
                        var obj = predicates[prop], isTake = obj["from"] != undefined;
                        if (isTake)
                            queryManagar.skip(obj["from"] == "top" ? 0 : this._gridRecordsCount - obj["take"]).take(obj["take"]);
                        else
                            predicate = predicate != undefined ? predicate["and"](obj) : obj;
                    }
                }
                else {
                    if (!(firstFilterCondition instanceof ej.Predicate))
                        predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, !firstFilterCondition.matchcase);
                    else {
                        predicate = firstFilterCondition;
                        if (this._excelFilterRendered) {
                            var dis = ej.distinct(filteredColumns, "field", false);
                            this._excelFilter._predicates[0] = this._excelFilter._predicates[0] || {};
                            this._excelFilter._predicates[0][dis[0]] = predicate;
                        }
                    }
                    for (var i = 1; i < filteredColumns.length; i++) {
                        if (!(filteredColumns[i] instanceof ej.Predicate)) {
                            if (!this._isLocalData && filteredColumns.length > 2 && i > 1 && filteredColumns[i].predicate == "or")
                                predicate.predicates.push(ej.Predicate(filteredColumns[i].field, filteredColumns[i].operator, filteredColumns[i].value, filteredColumns[i].ignoreCase || !filteredColumns[i].matchcase));
                            else
                                predicate = predicate[filteredColumns[i].predicate || "and"](filteredColumns[i].field, filteredColumns[i].operator, filteredColumns[i].value, !filteredColumns[i].matchcase);
                        }
                        else
                            predicate = predicate[filteredColumns[i].predicate || "and"](filteredColumns[i]);
                    }
                }
                predicate && queryManagar.where(predicate);
                if (this._isLocalData) {
                    var fresults = this._dataManager.executeLocal(queryManagar);
                    this._filteredRecordsCount = isTake ? fresults.result.length : fresults.count;
                    var lastPage = (this._filteredRecordsCount % this.model.pageSettings.pageSize == 0) ? (this._filteredRecordsCount / this.model.pageSettings.pageSize) : (parseInt(this._filteredRecordsCount / this.model.pageSettings.pageSize, 10) + 1);
                    if (this._currentPage() > lastPage)
                        this._currentPage(lastPage);
                    this._filteredRecords = this._dataManager.executeLocal(queryManagar).result;
                    if (this._$fkColumn && this.model.filterSettings.filteredColumns.length > 0 && this.model.filterSettings.filterType == "excel")
                        this._fkParentTblData  = this._filteredRecords;
                } else if (!ej.isNullOrUndefined(args) && args.requestType == ej.Grid.Actions.Filtering)
                    this._currentPage(1);
				if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
					for(var i = 0; i < filteredColumns.length; i++){
						for(var j = 0; j < this._prevVirtualFilter.length; j++){
							if(filteredColumns[i] == this._prevVirtualFilter[j] && args.requestType == ej.Grid.Actions.Filtering)
								this._prevVirtualFilter.splice(j, 1);
						}
						if($.inArray(filteredColumns[i], this._prevVirtualFilter) == -1){
							this._prevVirtualFilter.push(filteredColumns[i]);	
							this._gridRecordsCount = this._filteredRecordsCount;
							this._refreshViewPageDetails();							
							this._refreshVirtualViewData();
							this._refreshVirtualViewDetails();							 
						}
					}
				}
            }
			if (this._isLocalData && this.model.allowFiltering && this.model.filterSettings.filteredColumns.length==0){
				if(!ej.isNullOrUndefined(this._filteredRecordsCount) || this._filteredRecordsCount > 0){
					if(this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization){
						this._refreshViewPageDetails();
						this._refreshVirtualViewDetails(true);						
					}
					this._filteredRecordsCount = null;
					this._filteredRecords = [];
				}
			}

            if (this.model.summaryRows.length) {
                this._setSummaryAggregate(queryManagar);
            }

            if (this.model.allowPaging || (this.model.scrollSettings.allowVirtualScrolling && this.model.allowScrolling && !this.model.scrollSettings.enableVirtualization)) {
                if (this._isLocalData) {
                    var fresults = this._dataManager.executeLocal(queryManagar);
                    this._recordsCount = fresults.count;
                    var lastPage = (this._recordsCount % this.model.pageSettings.pageSize == 0) ? (this._recordsCount / this.model.pageSettings.pageSize) : (parseInt(this._recordsCount / this.model.pageSettings.pageSize, 10) + 1);
                    if (this._currentPage() > lastPage)
                        this._currentPage(lastPage);
                }
                if (this._currentPage() == 0) {
                    if (this._prevPageNo == 0 || this._prevPageNo == null)
                        this._currentPage(1);
                    else
                        this._currentPage(this._prevPageNo);
                }
                if (!this._isLocalData && !this.initialRender && !ej.isNullOrUndefined(args) && args.requestType == "refresh") {
                    if (cloneQuery.queries.length) {
                        for (i = 0; i < cloneQuery.queries.length; i++) {
                            if (cloneQuery.queries[i].fn == "onWhere")
                                this._currentPage(1);
                        }
                    }
                }
                queryManagar.page(this._currentPage(), this.model.pageSettings.pageSize);
            }
			
			 if (this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization) {                              
                this._needPaging = true; 				
                if (this.initialRender && this.model.currentIndex > 1 && (this.model.currentIndex <= this._getVirtualTotalRecord() || !this._isLocalData)) { 					
					if(this.model.scrollSettings.virtualScrollMode == "continuous")
						this.model.currentIndex = 1;
                    this._currentVirtualIndex = Math.ceil(this.model.currentIndex / this._virtualRowCount);
                    this._isThumbScroll = true;
                    this._currentPage(Math.ceil(this.model.currentIndex / this.model.pageSettings.pageSize));
					this._virtualLoadedPages.push(this._currentPage());
                }
				if(this._virtualDataRefresh){					
                    this._isThumbScroll = true;
					this._refreshVirtualViewData(true);
					this._gridRecordsCount = this._dataSource() !== null ? (this.model.pageSettings.totalRecordsCount == null ? this._dataSource().length : this.model.pageSettings.totalRecordsCount) : 0;
                    this._currentPage(Math.ceil(this._currentVirtualIndex * this._virtualRowCount / this.model.pageSettings.pageSize));
					this._virtualLoadedPages.push(this._currentPage());					
				}
                if(this.model.virtualLoading != null)
                    this._gridRecordsCount = this.model.pageSettings.totalRecordsCount;
				if(this.model.filterSettings.filteredColumns == 0 && this._prevVirtualFilter.length){
					this._refreshVirtualViewData();
					this._prevVirtualFilter = [];
				}									
				if(this._isLocalData && this.initialRender)
				    this._refreshVirtualViewDetails();
				if((this.model.scrollSettings.allowVirtualScrolling && this.model.scrollSettings.enableVirtualization && this.model.allowSearching && !ej.isNullOrUndefined(args) && args.requestType == "searching")){	
					this._refreshVirtualViewData();
					this._refreshVirtualViewDetails();	
				}
				this._getVirtualLoadedRecords(queryManagar);
            }	

            if (this.model.allowGrouping) {
                var cloned = queryManagar.clone();
                if (this.model.allowPaging && this.model.groupSettings.groupedColumns.length) {
                    cloned.queries = cloned.queries.slice(0, cloned.queries.length - 1);
                }
                for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                    var colName = this.model.groupSettings.groupedColumns[i], col = this.getColumnByField(colName);
                    if (!ej.isNullOrUndefined(col) && !ej.isNullOrUndefined(col.enableGroupByFormat) && col.enableGroupByFormat) {
                        queryManagar.group(colName, ej.proxy(this._formatGroupColumn, this));
                        cloned.group(colName, ej.proxy(this._formatGroupColumn, this));
                    }
                    else {
                        queryManagar.group(colName);
                        cloned.group(colName);
                    }
                }
                if (this.model.groupSettings.groupedColumns.length)
                    this._setAggreatedCollection(cloned);
            }
            if (args != undefined && args.requestType == "add" && this._isLocalData && this.model.groupSettings.groupedColumns.length == 0 && this.model.scrollSettings.frozenColumns == 0 && this.model.scrollSettings.frozenRows == 0)
                !(this._dataSource() instanceof ej.DataManager) ? this._dataSource().unshift(args.data) : this._dataSource().dataSource.json.unshift(args.data);
            if ((!ej.isNullOrUndefined(args) && args.action == "add") && !ej.isNullOrUndefined(this.model.parentDetails)) {
                var column = this.getColumnByField(this.model.parentDetails.parentKeyField);
                var ix = $.inArray(column, this.model.columns)
                if (ix == -1) {
                    var newdata = {};
                    newdata[this.model.parentDetails.parentKeyField] = this.model.parentDetails.parentKeyFieldValue;
                    $.extend(true, this.model.currentViewData[0], newdata);
                }
            }
            this._cloneQuery = queryManagar.clone();
                if (this._isLocalData && (!this.model.scrollSettings.enableVirtualization || this._virtualDataRefresh)) {
                var dataMgrJson = this._dataManager.dataSource.json;
                var dataSource = this._dataSource().dataSource;
                if (!ej.isNullOrUndefined(dataSource) && this._dataSource() instanceof ej.DataManager)
                    this._dataManager.dataSource.json = dataMgrJson != dataSource.json ? dataSource.json : dataMgrJson;
                var result = this._dataManager.executeLocal(queryManagar);
                if (!(!ej.isNullOrUndefined(args) && args.requestType == "beginedit")) {
                    if (this.model.scrollSettings.allowVirtualScrolling && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1)
                        this._prevPageRendered = true;
                    if (this.model.scrollSettings.allowVirtualScrolling && !this._prevPageRendered && result.result.length != this.model.pageSettings.pageSize && this.model.pageSettings.totalPages == this.model.pageSettings.currentPage) {
                        var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
                        queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
                        queryManagar.page(this._currentPage() - 1, this.model.pageSettings.pageSize);
                        var lastPageResult = this._dataManager.executeLocal(queryManagar);
                        lastPageResult.result.splice(0, result.result.length);
                        this._previousPageRecords = $.extend(true, [], lastPageResult.result);
                        this._previousPageLength = result.result.length;
                        this._currentPageData = result.result;
                        ej.merge(lastPageResult.result, result.result);
                        this.model.currentViewData = this._lastVirtualPage = lastPageResult.result;
                        this._lastPageRendered = true;
                    }
                    else if (this._lastPageRendered && this.model.pageSettings.currentPage == this.model.pageSettings.totalPages - 1 && !this.model.scrollSettings.enableVirtualization) {
                        var count = this.model.pageSettings.pageSize - this._previousPageLength;
                        for (var dupRow = 0; dupRow < count; dupRow++) {
                            var removeEle = this.getRows()[this.getRows().length - (this.model.pageSettings.pageSize - dupRow)];
                            removeEle.remove();
                        }
                        this._tempPageRendered = true;
                        this.model.currentViewData = result.result;
                    }
                    else
                        this.model.currentViewData = result.result;
                }
                else
                    this.model.currentViewData = result.result;
                this._gridRecordsCount = result.count;
                this._remoteSummaryData = result.aggregates;
                this._searchCount = this._searchString.length ? result.count : null;
                this.model.groupSettings.groupedColumns.length && this._setAggregates();
            }
        },
        _formatGroupColumn: function (value,field) {
            var col = this.getColumnByField(field), format;
            format = col.format;
            var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
            format = toformat.exec(format)[2];
            return ej.format(value, format, this.model.locale);
        },
		_refreshViewPageDetails: function(){
			this._currentPage(1);
			this.model.currentIndex = 0;
			this._currentVirtualIndex = 1;
			this.getContent().ejScroller("model.scrollTop", 0);
		},
		_refreshVirtualViewDetails: function (dataRefreshed) {
		    var dataSrc = this._dataSource();
			if(dataRefreshed)
			    this._gridRecordsCount = dataSrc !== null ? dataSrc instanceof ej.DataManager ? dataSrc.dataSource.json.length : dataSrc.length : this.model.pageSettings.totalRecordsCount;
			this._totalVirtualViews = Math.ceil(this._getVirtualTotalRecord() / this._virtualRowCount);
			this._maxViews = Math.ceil(this.model.pageSettings.pageSize / this._virtualRowCount);			
			this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
			this.model.pageSettings.totalRecordsCount = this._gridRecordsCount;			
			this._lastViewData = this._virtualRowCount - ((this._totalVirtualViews * this._virtualRowCount) - this._getVirtualTotalRecord());		
		},
		_getVirtualLoadedRecords: function (queryManagar) {                                        
            var currentPage = this._currentPage(), needTwoPage;
			if (this._needPaging){
				this._isLastVirtualpage = needTwoPage = this._isThumbScroll && currentPage == this.model.pageSettings.totalPages && !this._virtualPageRecords[currentPage];				
				if(this.initialRender || this._virtualDataRefresh) needTwoPage = true;
				if (this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
					this._getVirtualOnLoadingData(currentPage, !needTwoPage);
				else
					this._setVirtualPaging(queryManagar, currentPage, !needTwoPage);
				if(!this.initialRender && this._isThumbScroll && this._virtualPageRecords[currentPage] && !this._virtualDataRefresh)
					this._checkPrevNextViews(currentPage, queryManagar);
			}		                            
			this._needPaging = false;			
            this._setVirtualLoadedIndexes(this._currentVirtualIndex);
            if(this.initialRender && this._isLocalData){
                this.model.currentViewData = [];
                for (var i = 0; i < this._currentLoadedIndexes.length; i++) {
                    var currentView = this._currentLoadedIndexes[i];
					if(this._virtualLoadedRecords[currentView])
						$.merge(this.model.currentViewData, this._virtualLoadedRecords[currentView]);
                }
            }
        },
        _setVirtualPaging: function(queryManagar, currentPage, isCurrentIndex){     
            var pageQuery = ej.pvt.filterQueries(queryManagar.queries, "onPage");
			if(pageQuery.length)
				queryManagar.queries.splice($.inArray(pageQuery[0], queryManagar.queries), 1);
			if((!isCurrentIndex || this._needVPaging) && this.model.currentIndex > this._virtualRowCount)
				this._initCurrentIndex(queryManagar, currentPage);	
			else
				queryManagar.page(currentPage, this.model.pageSettings.pageSize);
            this._needVPaging = false;
            if(this._isLocalData && !this._virtualPageRecords[currentPage]) {								 
				var result = this._dataManager.executeLocal(queryManagar);   
				if(!this.initialRender) this.model.currentViewData = result.result;
				if(this.model.searchSettings.key.length > 0){
					this._gridRecordsCount = result.result.length;
					this.model.pageSettings.totalPages = Math.ceil(this._gridRecordsCount / this.model.pageSettings.pageSize);
				}
				if(result.result.length){
					this._setVirtualLoadedRecords(result.result, currentPage);					
					if($.inArray(currentPage, this._virtualLoadedPages) == -1)
						this._virtualLoadedPages.push(currentPage);
				}
				else if (!this.initialRender)
					this.getContent().find(".e-virtualtop, .e-virtualbottom").remove();					
			}                   						
        },
		_checkPrevNextViews: function(currentPage){
			var currentVirtualIndex = this._currentVirtualIndex;
			var prevView = this._virtualLoadedRecords[currentVirtualIndex - 1], nextView = this._virtualLoadedRecords[currentVirtualIndex + 1];			
				var adjust = this._maxViews == 3 ? 1 : 2, sTop;																	
				if(currentVirtualIndex != 1 && currentVirtualIndex != this._totalVirtualViews){				
					if(!prevView || prevView.length != this._virtualRowCount){
						var currentIndex = currentVirtualIndex + adjust;
						this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex + 1;
						sTop = this._scrollValue + (adjust * this._virtualRowCount * this._vRowHeight);
					}
					else if((!nextView || nextView.length != this._virtualRowCount) && this._totalVirtualViews != currentVirtualIndex - 1){
						var currentIndex = currentVirtualIndex - adjust;
						this._currentVirtualIndex = this._virtualLoadedRecords[currentVirtualIndex] ? currentIndex : currentIndex - 1;
						sTop = this._scrollValue - (adjust * this._virtualRowCount * this._vRowHeight);
					}			
					if(sTop){					
						this._scrollValue = sTop;
						this._setVirtualLoadedIndexes(this._currentVirtualIndex);
						this.model.currentIndex = sTop == 0 ? sTop : Math.floor(sTop / this._vRowHeight);
					}
				}			
		},
		_initCurrentIndex: function(queryManagar, currentPage){			
			var pageResultCount = currentPage * this.model.pageSettings.pageSize;
			var nextDataCount = (this._currentVirtualIndex * this._virtualRowCount) + this._virtualRowCount;
			var prevDataCount = (this._currentVirtualIndex *  this._virtualRowCount) - (this._virtualRowCount * 2);	
			var needTwoPage = nextDataCount > pageResultCount || prevDataCount < pageResultCount - this.model.pageSettings.pageSize;
			if(needTwoPage || this._isLastVirtualpage){
				if(nextDataCount > pageResultCount){
					var skipValue = (currentPage - 1) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;	
					this._isInitNextPage = true;					
				}
				else if(prevDataCount < pageResultCount - this.model.pageSettings.pageSize  || this._isLastVirtualpage){
					var skipValue = (currentPage - 2) * this.model.pageSettings.pageSize, takeValue = this.model.pageSettings.pageSize * 2;
					this._isInitNextPage = false; this._remoteRefresh = true;					
				}
				if(this.model.virtualLoading && this._isLocalData){
					var args = {};					
					args.endIndex = skipValue + takeValue;
					args.endIndex = args.endIndex > this._getVirtualTotalRecord() ? this._getVirtualTotalRecord() : args.endIndex;
					args.startIndex = skipValue;	
					args.currentPage = this._currentPage();
					args.result = null;
					this._trigger("virtualLoading", args);
					var currentData = args.result;
					this._setInitialCurrentIndexRecords(currentData, currentPage);
				}
				else {
				    var skipQuery = ej.pvt.filterQueries(queryManagar.queries, "onSkip");
				    if (skipQuery.length)
				        queryManagar.queries.splice($.inArray(skipQuery[0], queryManagar.queries), 1);
					queryManagar.skip(skipValue).take(takeValue);					
					if(this._isLocalData){
						var result = this._dataManager.executeLocal(queryManagar);                                    
						var currentData = this.model.currentViewData = result.result;
						this._isLastVirtualpage = false;
						this._setInitialCurrentIndexRecords(currentData, currentPage);						
					}
				}
			}			
			else{
				this._needVPaging = false;
				if(this.model.virtualLoading && this._isLocalData && (this.model.currentIndex != 0 || currentPage != 1))
					this._getVirtualOnLoadingData(currentPage, true);
				else
					this._setVirtualPaging(queryManagar, currentPage, true);						
			}
		},
		_setInitialCurrentIndexRecords: function(currentData, currentPage){
			for(i = 0; i < 2; i++){
				var start = i * this.model.pageSettings.pageSize, end = start + this.model.pageSettings.pageSize;
				var data = currentData.slice(start, end), page;
				if (this._isInitNextPage || (currentPage == 1 && this.model.pageSettings.totalPages == 1))
					page = i == 0 ? currentPage : currentPage + 1;
				else
					page = i == 0 ? currentPage - 1 : currentPage;
				this._setVirtualLoadedRecords(data, page);
			}
		},
        _getVirtualOnLoadingData: function(currentPage, isCurrentIndex){
            if(currentPage > 0){
				if(this.model.currentIndex > this._virtualRowCount && (!isCurrentIndex || this._needVPaging) && this.model.currentIndex < this.model.pageSettings.totalRecordsCount)
					this._initCurrentIndex(undefined, currentPage);
				else{
					var args = {};
					args.endIndex = (currentPage * this.model.pageSettings.pageSize) > this._gridRecordsCount ? this._gridRecordsCount : currentPage * this.model.pageSettings.pageSize;
					args.startIndex = (currentPage * this.model.pageSettings.pageSize) - this.model.pageSettings.pageSize;
					args.currentPage = this._currentPage();	args.result = null;			
					this._trigger("virtualLoading", args);
					var currentData = args.result;
					this._setVirtualLoadedRecords(currentData, currentPage);
				}
            }
        },
        _setVirtualLoadedRecords: function(currentData, currentPage){
            var virtualRowCount = this._virtualRowCount, pageSize = this.model.pageSettings.pageSize; 
            var pageIndex = pageSize / virtualRowCount, prevIndex;  
			var maxIndex = Math.ceil(currentPage * pageSize / virtualRowCount);
			var lastPage = currentPage == this.model.pageSettings.totalPages;
			if(!this._virtualPageRecords[currentPage])
				this._virtualPageRecords[currentPage] = currentData;
			if(lastPage){									
			    var lastPageData = this._getVirtualTotalRecord() % pageSize;
				if((!this._virtualLoadedRecords[this._totalVirtualViews] || this._virtualLoadedRecords[this._totalVirtualViews].length != this._lastViewData) && lastPageData < this._lastViewData && lastPageData != 0)
					maxIndex = this._totalVirtualViews + 1;
				else
					maxIndex = this._totalVirtualViews;	
				if(this._getVirtualTotalRecord() < virtualRowCount)
					this._singleView = true;
			}						
            for (var i = 0; i < pageIndex; i++) {
                var startIndex, endIndex;                                                      
                var viewIndex = Math.ceil((currentPage - 1) * pageIndex + (i + 1));				
                if((viewIndex <= this._totalVirtualViews || lastPage) && viewIndex <= maxIndex){					
                    if(this._virtualLoadedRecords[viewIndex - 1] && this._virtualLoadedRecords[viewIndex - 1].length != virtualRowCount) {
                        var start = this._virtualLoadedRecords[viewIndex - 1].length + (i * virtualRowCount);
                        startIndex = virtualRowCount - start + (i * virtualRowCount);
                        $.merge(this._virtualLoadedRecords[viewIndex - 1], currentData.slice(0, startIndex));
                        prevIndex = endIndex = startIndex + virtualRowCount;
						if(viewIndex <= this._totalVirtualViews)
							this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, prevIndex);						
                    }									
                    else {
                        if (viewIndex != 1 && !this._virtualLoadedRecords[viewIndex - 1]) {                                        
                            var prevEnd = endIndex = (viewIndex - 1) * virtualRowCount % pageSize;
                            if(prevEnd != 0)
                                this._virtualLoadedRecords[viewIndex - 1] = currentData.slice(0, prevEnd);
                            startIndex = prevEnd, endIndex = prevIndex = prevEnd + virtualRowCount;
                        }
                        else {
                            startIndex = prevIndex ? prevIndex : i * virtualRowCount % pageSize;       
                            prevIndex = endIndex = startIndex + virtualRowCount;
                        }                                   
                    }                    
					if(!this._singleView && this._virtualLoadedRecords[viewIndex] && this._virtualLoadedRecords[viewIndex].length != virtualRowCount){
						var	data = currentData.slice(startIndex, endIndex);						
						if(data.length + this._virtualLoadedRecords[viewIndex].length <= virtualRowCount){
							var viewData = $.merge(data, this._virtualLoadedRecords[viewIndex]); 
							this._virtualLoadedRecords[viewIndex] = viewData;
						}
					}
					else if(!this._virtualLoadedRecords[viewIndex] && viewIndex <= this._totalVirtualViews)
						this._virtualLoadedRecords[viewIndex] = currentData.slice(startIndex, endIndex);					
                }
            }
			if($.inArray(currentPage, this._virtualLoadedPages) == -1)
				this._virtualLoadedPages.push(currentPage);
        },
        _setVirtualLoadedIndexes: function (currentIndex) {
            this._prevLoadedIndexes = this._currentLoadedIndexes;
			this._currentLoadedIndexes = [];            
            var virtualCount = currentIndex == this._totalVirtualViews ? currentIndex : currentIndex + 1;			
            if(currentIndex != 1)                               
                currentIndex = currentIndex - 1;            
            for (var i = currentIndex; i <= virtualCount; i++) {
                this._currentLoadedIndexes.push(i);                    
            }  
        },
        _getVirtualTotalRecord: function(){
            var recordCount = this.model.filterSettings.filteredColumns.length == 0 ? this._searchCount == null ? this._gridRecordsCount : this._searchCount : this._filteredRecordsCount;    
            return recordCount;
        },
        _initGridRender: function () {
            this.addInitTemplate();
            if (this.model.scrollSettings.frozenColumns > 0)
                this.addFrozenTemplate();
            this.model.allowGrouping && this.addGroupingTemplate();
            this.model.showSummary && this.addSummaryTemplate();
            if (this.model.allowResizing || this.model.allowResizeToFit)
                this._resizer = new ej.gridFeatures.gridResize(this);
            if (this.model.keySettings)
                $.extend(this.model.keyConfigs, this.model.keySettings);
            
            this._initHeight = this.model.scrollSettings.height;
            if (this.model.scrollSettings.height == "100%")
                this._isHeightResponsive = this.model._isHeightResponsive = true;            
            this.render();
            this._setTextWrap();
            if (this.model.columnLayout == "fixed") {
                var headerTableWidth = this.model.scrollSettings.frozenColumns > 0 ? this.getHeaderTable().eq(0).width() + this.getHeaderTable().eq(1).width() : this.getHeaderTable().width();
                var operation = this.getHeaderContent().width() > headerTableWidth ? 'addClass' : 'removeClass';
                var headerTable = this.getHeaderTable();
                var contentTable = this.getContentTable();
                if (this.model.scrollSettings.frozenColumns > 0) {
                    headerTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getHeaderTable().eq(1) : this.getHeaderTable().eq(0);
                    contentTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getContentTable().eq(1) : this.getContentTable().eq(0);
                }
                headerTable[operation]('e-tableLastCell');
                contentTable[operation]('e-tableLastCell');
            }
            if (this.model.allowGrouping && ej.gridFeatures.dragAndDrop)
                this._headerCellgDragDrop();
            if (this.model.allowReordering && ej.gridFeatures.dragAndDrop) {
                this._headerCellreorderDragDrop();
                this._initIndicators();
            }
            this._wireEvents();
            if (this.model.allowGrouping && !ej.isNullOrUndefined(this.model.serverProperties)) {
                this.model._groupingCollapsed = this.model.serverProperties._groupingCollapsed;
                for (var i = 0; i < this.model._groupingCollapsed.length; i++) {
                    var content = this.getContent().find(".e-recordplusexpand");
                    var tr = content.filter("td[data-ej-mappingname='" + this.model._groupingCollapsed[i].key + "'    ][data-ej-mappingvalue='" + this.model._groupingCollapsed[i].value + "']");
                    if (tr.length > 1 && !ej.isNullOrUndefined(this.model._groupingCollapsed[i].parent)) {
                        var parent = this.model._groupingCollapsed[i].parent;
                        tr = tr.filter(function (e) { return $(this).parents(".e-tabletd").parent("tr").prev("tr").find(".e-recordplusexpand[data-ej-mappingvalue=" + parent + "]").length })
                    }

                    this.expandCollapse(tr);
                }
            }
            this.initialRender = false;
            if (this.model.width && !this.model.allowScrolling)
                this.element.width(this.model.width);
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding)
                this._processEditing();
            if (this.model.mergeHeaderCellInfo != null) {               
                var args = { columnHeaders: this.getHeaderContent().find(".e-columnheader"), model: this.model }, proxy = this;
                this._headerCellMerge(args);
                this._trigger("mergeHeaderCellInfo", args);
            }
            this._trigger("dataBound", {});
			this._trigger("refresh");
            if (this.model.parentDetails) {  //refreshes parent scroller on child expand
                var id = this.model.parentDetails.parentID, parentObj = $("#" + id).data("ejGrid");
                parentObj.model.allowScrolling && parentObj._refreshScroller({ requestType: "refresh" });
            }
            if (this.element.closest('tr').hasClass('e-detailrow') && !this.model.parentDetails) {
                var parentObj = this.element.closest('tr.e-detailrow').closest('.e-grid').data("ejGrid");
                parentObj.model.allowScrolling && parentObj.getScrollObject().refresh();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "menu") {
                this._renderFilterDialogs();
            }
            if (this.model.enableResponsiveRow && (this.model.allowSorting || this.model.allowFiltering)) {
                this._renderResponsiveFilter();
            }
            if (this.model.allowScrolling)
                this._vRowHeight = Math.floor(this.getRowHeight()); 
            if (this.model.allowGrouping && this.model.showSummary && this.model.currentViewData) {
                this._refreshGroupSummary();
                if (!ej.isNullOrUndefined(this.model.currentViewData) && this.model.currentViewData.length)
                    this._refreshGridFooterColGroup();
            }   
            if (this._isMapSelection)
                this._mappingSelection();
			if (this.model.showColumnChooser)
			    this._renderColumnChooser();
			if (this._enableCheckSelect) {
			    			    if (this.model.currentViewData != null && this.model.currentViewData.length == 0)
                			        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").hide();
			    			    else
                			        this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").show();
			    			}
        },
        calculatePageSizeByParentHeight: function (containerHeight) {
            if (this.model.allowPaging) {
                if ((this.model.allowTextWrap && this.model.textWrapSettings.wrapMode == "header") || (!this.model.allowTextWrap)) {
                    var pagesize;
                    if (typeof (containerHeight) == "string" && containerHeight.indexOf("%") != -1) {
                        containerHeight = parseInt(containerHeight) / 100 * this.element.height();
                    }
                    var nonContentHeight = this._getNoncontentHeight() + this.getRowHeight();
                    if (parseInt(containerHeight) > nonContentHeight) {
                        var contentHeight = (parseInt(containerHeight) - this._getNoncontentHeight());
                        pagesize = parseInt(contentHeight / this.getRowHeight());
                    }
                    if (ej.isNullOrUndefined(pagesize)) throw "The parent height of grid must be more than 150";
                    else
                        return pagesize;
                }
            }
        },
        _setTextWrap: function () {
            if (this.model.allowTextWrap == true) {
                switch (this.model.textWrapSettings.wrapMode) {
                    case "content":
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.removeClass("e-wrap");
                        this.getContent().addClass("e-wrap");
                        break;
                    case "header":
                        this.element.removeClass("e-wrap");
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").addClass("e-wrap");
                        break;
                    default:
                        this.getContent().removeClass("e-wrap");
                        this.element.find(".e-columnheader").removeClass("e-wrap");
                        this.element.addClass("e-wrap");
                        break;
                }
                if(this.model.scrollSettings.frozenColumns > 0 && this.model.textWrapSettings.wrapMode != "content"){
                    var $frozenTh = this.getHeaderContent().find(".e-frozenheaderdiv").find(".e-columnheader").last().find("th"), $movableTh = this.getHeaderContent().find(".e-movableheader").find(".e-columnheader").last().find("th");
                    $frozenTh.height()> $movableTh.height() ? $movableTh.height($frozenTh.height()) : $frozenTh.height($movableTh.height());
                }
            }
            else {
                this.getContent().removeClass("e-wrap").find(".e-rowcell").removeClass("e-nwrap");
                this.element.find(".e-columnheader").removeClass("e-wrap").find(".e-headercelldiv").removeClass("e-nwrap");
                this.element.removeClass("e-wrap");
            }
        },
        _getMetaColGroup: function () {
            var $colgroup = ej.buildTag("colgroup");
            for (var i = 0; i < this.model.columns.length; i++) {
                var $col = $(document.createElement("col"));
                this.model.columns[i]["visible"] === false && $col.css("display", "none");
				if(this.model.rowTemplate!=null && !ej.isNullOrUndefined(this.model.columns[i]["cssClass"]))
					$col.addClass(this.model.columns[i]["cssClass"]);
                if ( this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && $.inArray(this.model.columns[i]["field"], this.model.groupSettings.groupedColumns) != -1)
                    $col.css("display", "none");
                $colgroup.append($col);
            }
            return $colgroup;
        },
        _alternateRow: function () {
            return this.getIndex() % 2 == 0 ? "e-row" : "e-alt_row";
        },
        addInitTemplate: function () {
            var headerCellDiv = !ej.isNullOrUndefined(this.getHeaderTable()) && this.getHeaderTable().find(".e-headercelldiv:not(.e-emptyCell)"), templates = {}, firstVisible = true;
            var tbody = document.createElement('tbody'), $tbody = $(tbody),divElement, rowTemplateID = null;
            if (this.model.rowTemplate == null) {
                var tr = document.createElement('tr'),
                    $tr = $(tr),
                    columns = this.model.columns,
                    i;
                if (this._gridRecordsCount && !this._virtualDataRefresh) {
                    var currentData = this.model.editSettings.showAddNewRow && !this.initialRender ? this.model.currentViewData[1] : this.model.currentViewData[0];
                    if (!ej.isNullOrUndefined(currentData))
                        this._initColumns(currentData);
                }
                else if (this._isLocalData && (this._dataSource() != null && this._dataSource().length || (this._dataManager && this._dataManager.dataSource.json.length)))
                    this._initColumns(this._dataSource()[0] != undefined ? this._dataSource()[0] : this._dataManager.dataSource.json[0]);
                var helpers = { _gridFormatting: this.formatting, getComplexData: ej.getObject };
                $.views.helpers(helpers);

                var viewHelper = {};
                viewHelper["_foreignKey"] = this._foreignKeyBinding; 
                $.views.helpers(viewHelper);

                if (this.model.childGrid || this.model.detailsTemplate ) {
                    var $tdDetailCell = ej.buildTag("td.e-detailrowcollapse", "<div class='e-icon e-gnextforward'></div>");
                    $tr.append($tdDetailCell);
                }
                for (var i = 0; i < this.model.columns.length; i++) {
                    var $tdCell = ej.buildTag("td.e-rowcell");
                    if (!ej.isNullOrUndefined(columns[i]["tooltip"]) || columns[i]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridtooltip")
                    if (columns[i]["clipMode"] == ej.Grid.ClipMode.Ellipsis || columns[i]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                        $tdCell.addClass("e-gridellipsis");
                    if (this.model.isResponsive)
                        $tdCell.attr("data-cell", this._decode(this.model.columns[i]["headerText"]));
                    if (columns[i]["visible"] == false)
                        $tdCell.addClass("e-hide");
                    else {
                        if (firstVisible && (this.model.detailsTemplate != null || this.model.childGrid != null))
                            $tdCell.addClass('e-detailrowvisible');
                        firstVisible = false;
                    }
                    !$tdCell.hasClass("e-hide") && !this.model.groupSettings.showGroupedColumn && $tdCell.addClass("{{for ~groupedColumns}}" +
                        " {{if #data == '" + this.model.columns[i]["field"] + "'}}e-hide{{/if}}" +
                        "{{/for}}");
                    if (!ej.isNullOrUndefined(columns[i]["templateID"] || columns[i]["template"])) {
                        var viewHelper = {}, index, htxt = columns[i].headerText;
                        viewHelper["_" + this._id + "ColumnTemplating"] = ej.proxy(this._gridTemplate, null, this, index);
                        $.views.helpers(viewHelper);
                        if(!ej.isNullOrUndefined(htxt) && !ej.isNullOrUndefined(htxt.match(/[^0-9\s\w]/g)))
                            htxt = htxt.replace(/[^0-9\s\w]/g,"_");
                        $("#" + this._id + htxt + i + "_Template").remove();
                        var scriptElement = this._createTemplateElement(columns[i]);
                        if ((columns[i].field == "") || ej.isNullOrUndefined(columns[i].field))
                            this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                        if (columns[i]["template"] != false)
                            $tdCell.addClass("e-templatecell").html("{{:~_" + this._id + "ColumnTemplating('" + scriptElement.id + "','" + i + "')}}");
                    } else {
                        var splits = (columns[i].field || "").split("."), sLen = splits.length - 1, braces = "";
                        while (sLen) {
                            braces += "(";
                            sLen--;
                        }
                        var columnType = columns[i].type || columns[i].editType
                        switch (columnType) {
                            case "boolean":
                            case "booleanedit":
                                if (ej.isNullOrUndefined(columns[i].displayAsCheckbox)) columns[i].displayAsCheckbox = true;
                                if (!columns[i]["displayAsCheckbox"])
                                    $tdCell.html("{{if ~getComplexData('"+this.model.columns[i].field+"', #data)}}" + this.localizedLabels.True + '{{else}}' + this.localizedLabels.False + '{{/if}}');
                                else {
                                    var disabled = "";
                                    this.model.editSettings.editMode == "batch" && (ej.isNullOrUndefined(columns[i].allowEditing) || columns[i].allowEditing) ? disabled = disabled : disabled = "disabled='disabled'";
                                    var str = "{{if ~getComplexData('" + this.model.columns[i].field + "', #data)}} <input type ='checkbox' " + disabled + " checked='checked'></input>{{else}} <input type ='checkbox' " + disabled + "></input> {{/if}}";
                                    $tdCell.addClass("e-boolrowcell").html(str);
                                }
                                break;
                            case "checkbox":
                                this._enableCheckSelect = true;
                                this.model.selectionType = "multiple";
                                if(this.model.editSettings.allowDeleting) this.multiDeleteMode = true;
                                this.model.selectionSettings.enableToggle = true;
                                this._isMapSelection = (!ej.isNullOrUndefined(columns[i].field) && (columns[i].field != ""));
                                this._selectionMapColumn = columns[i].field;
                                columns[i]["textAlign"] = "center";
                                if (!this._isMapSelection)
                                    this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                                $tdCell.addClass("e-checkcell").html("<div class = 'e-checkcelldiv'>{{if #data['" + splits.join("']['") + "']}} <input type ='checkbox' checked='checked'></input>{{else}} <input type ='checkbox'></input> {{/if}}</div>");
                                this.model.columns[i].editType = ej.Grid.EditingType.Boolean;
                                this.model.scrollSettings.frozenColumns > 0 && $tdCell.addClass("e-frozenunbound");
                                this.model.enableAutoSaveOnSelectionChange = false;
                                break;
                            default:
                                if (columns[i].disableHtmlEncode)
                                    $tdCell.html("{{html:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                                else
                                    $tdCell.html("{{:" + braces + "#data['" + splits.join("'] || {})['") + "']}}");
                        }
                        if (columns[i]["format"] != undefined && (!columns[i]["foreignKeyValue"]))
                            $tdCell.html("{{:~_gridFormatting('" + columns[i]["format"] + "'," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this.model.locale + "')}}");
                        if (columns[i]["foreignKeyValue"] && columns[i]["dataSource"]) {
                            $tdCell.html("{{:~_foreignKey(" + i + "," + braces + "#data['" + splits.join("'] || {})['") + "'],'" + this._id + "')}}");
                        }
                        if (columns[i]["commands"]) {
                            var viewHelper = {};
                            viewHelper["_" + this._id + "UnboundTemplate"] = this._unboundTemplateRendering;
                            $.views.helpers(viewHelper);
                            if ((ej.isNullOrUndefined(columns[i]["field"])) || (columns[i].field == ""))
                                this.model.columns[i]["allowGrouping"] = this.model.columns[i]["allowFiltering"] = this.model.columns[i]["allowSorting"] = false;
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                            $("#" + this._id + columns[i].headerText.replace(/[^a-z0-9|s_]/gi, '')+ i + "_UnboundTemplate").remove();
                            divElement = this._createUnboundElement(columns[i],i);
                            if (!ej.isNullOrUndefined(columns[i].headerText))
                            $tdCell.addClass("e-unboundcell").addClass("e-" + columns[i]["headerText"].replace(/[^a-z0-9|s_]/gi, '')+i).html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                            this.model.scrollSettings.frozenColumns > 0 && $tdCell.addClass("e-frozenunbound");
                            this._isUnboundColumn = true;
                        }

                    }
                    if (columns[i]["textAlign"] == undefined)
                        columns[i]["textAlign"] = "left";
                    if (columns[i]["isPrimaryKey"] === true) {
                        this._primaryKeys.push($.trim(columns[i].field));
                        this._primaryKeys = ej.isNullOrUndefined($.uniqueSort) ? $.unique(this._primaryKeys.sort()) : $.uniqueSort(this._primaryKeys.sort());
                    }
                    if (!(this.phoneMode && this.model.enableResponsiveRow) && columns[i]["textAlign"] != undefined) {
                        $tdCell.css("text-align", columns[i]["textAlign"]);
                        $(headerCellDiv[i]).css("text-align", columns[i]["textAlign"]);
                    }
                    if (!this.phoneMode && !ej.isNullOrUndefined(columns[i]["headerTextAlign"])) {
                        $(headerCellDiv[i]).css("text-align", columns[i]["headerTextAlign"]);
                    }
                    if (!ej.isNullOrUndefined(columns[i]["cssClass"])) {
                        $tdCell.addClass(columns[i]["cssClass"]);
                    }
                    if (this.model.allowTextWrap && this.model.textWrapSettings.wrapMode != "header") {
                         if (columns[i]["allowTextWrap"] == false)
                            $tdCell.addClass("e-nwrap");
                    }
                    if (!ej.isNullOrUndefined(columns[i]["priority"]))
                        $tdCell.addClass("e-table-priority-" + columns[i]["priority"]);
                    if (!ej.isNullOrUndefined(columns[i]["customAttributes"]))
                        $tdCell.attr(columns[i]["customAttributes"]);
                    $tdCell.attr("data-role", "gridcell");
                    $tr.append($tdCell);
                    if (this.model.enableAltRow) {
                        helpers["_" + this._id + "AlternateRow"] = this._alternateRow;
                        $.views.helpers(helpers);
                        $tr.addClass("{{:~_" + this._id + "AlternateRow()}}");
                    }
                    else
                        $tr.addClass("e-row");
                    $tr.attr("data-role", "row");
                    if (this.model.scrollSettings.frozenColumns > 0 && this.model.scrollSettings.frozenColumns == i + 1) {
                        tbody.appendChild(tr);
                        templates[this._id + "_JSONFrozenTemplate"] = $tbody.html();
                        $tr.empty();
                        $tbody.empty();
                    }
                }
                tbody.appendChild(tr);
            }
			else {
				var viewHelper = {};
				var scriptRElement = this._createRowTemplateElement(this.model.rowTemplate);
                viewHelper["_" + this._id + "rowTemplating"] = ej.proxy(this._gridRowTemplate,null,this);
                var ngType = !ej.isNullOrUndefined(this.model.ngTemplateId) && (this.model.rowTemplate.startsWith("#") || this.model.rowTemplate.startsWith(".") || typeof this.model.rowTemplate === "object") ? this.model.ngTemplateId + "gridrowtemplate" : null;                                              
				rowTemplateID = "{{:~_" + this._id + "rowTemplating('" + scriptRElement.id + "','" + ngType +"')}}";
				$.views.helpers(viewHelper);
			}
            templates[this._id + "_JSONTemplate"] = this.model.rowTemplate != null ? rowTemplateID : $tbody.html();
            $.templates(templates);
        },
        
        _gridRowTemplate: function(self,id,type){
			return self._renderEjTemplate("#" + id, this.data,this.index,null,type);
		},
		_createRowTemplateElement: function(templ){
			var tmpl = templ, quickReg = /^#([\w-]*)/,
                match = quickReg.exec(tmpl), scriptReg = /^<script/i, appendTo = appendTo || $("body"), scripEle;

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: tmpl,
               id: (this._id + "RowTemplate").replace(/(\\|[^0-9A-z-_])/g, "")
            };

            if ( match && match[1] )
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(tmpl)) // branch here to handle tmpl string with SCRIPT. 
                    scripEle = $(tmpl).get(0);
                else
                    scripEle = ej.buildTag(options.name).get(0);
            }

            scripEle.id = scripEle.id || options.id; 
            scripEle.type = scripEle.type || options.type;
			if(ej.isNullOrUndefined(match))
				$(scripEle).text(options.text);
            appendTo.append(scripEle); 
            return scripEle;
		},        
        render: function () {
            this.model.showSummary = this.model.summaryRows.length > 0 || this.model.showSummary;
            this._renderGridContent().insertAfter(this.element.children(".e-gridheader"));
            this.model.allowResizeToFit && this.setWidthToColumns();
            if (this.model.allowGrouping && ej.gridFeatures.dragAndDrop)
                this._groupHeaderCelldrag();
            if (this.model.showSummary && this._currentJsonData.length) {
                var footer = this._renderGridFooter();
                if (!ej.isNullOrUndefined(footer)) footer.insertAfter(this.getContent());
                this._hideCaptionSummaryColumn();
            }
            this._initialEndRendering();

        },
        _createStackedRow: function (stackedHeaderRow, frozenHeader) {
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var sHeader = [], sCss = [], tAl = [], tp = [];
            for (var c = 0; c < this.model.columns.length; c++) {
                var column = this.model.columns[c];
                if (column.visible != false) {
                    if (this.model.allowGrouping && !this.model.groupSettings.showGroupedColumn && this.model.groupSettings.groupedColumns.length > 0) {
                        if ($.inArray(column.field, this.model.groupSettings.groupedColumns) != -1)
                            continue;
                    }
                    var headerText = '', cssClass = '', txtAlign = '', ttp = "";
                    var sColumn = stackedHeaderRow.stackedHeaderColumns;
                    for (var col = 0; col < sColumn.length; col++) {
                        var _column = $.isArray(sColumn[col].column) ? sColumn[col].column : $.map(sColumn[col].column.split(","), $.trim),
                            className = "e-row" + $.inArray(stackedHeaderRow, this.model.stackedHeaderRows) + "-column" + col;
                        if ($.inArray(column.field, _column) != -1)
                        {
                            headerText = sColumn[col].headerText;
                            cssClass = sColumn[col]["cssClass"];
                            txtAlign = sColumn[col].textAlign;
                            ttp = sColumn[col]["tooltip"] ? " e-gridtooltip " + className : '';
                        }                        
                    }
                    sHeader.push(headerText);
                    sCss.push(cssClass);
                    tAl.push(txtAlign);
                    tp.push(ttp);
                }
            }
            var colsPanList = []
            for (var i = 0; i < sHeader.length; i++) {
                var colSpan = 1;
                for (var j = i + 1; j < sHeader.length; j++) {
                    if (sHeader[i] == sHeader[j]) {
                        colSpan++;
                    }
                    else
                        break;
                }
                colsPanList.push({ sapnCount: colSpan, headerText: sHeader[i], cssClass: sCss[i], txtAlign: tAl[i], tooltip: tp[i] });
                i += colSpan - 1;
            }
            var $tr = ej.buildTag('tr.e-columnheader e-stackedHeaderRow');
            var frzCol = this.model.scrollSettings.frozenColumns;
            if (this.model.allowScrolling && frzCol > 0) {
                var frozenColspanList = [];
                var forzenColumn = 0, index = 0, frzHideCol = 0;
                for (var i = 0; i < this.model.columns.length; i++) {
                    var col = this.model.columns[i];
                    if (i < frzCol && col.visible == false)
                        frzHideCol++;
                }
                forzenColumn = frzCol - frzHideCol;
                while (forzenColumn > 0) {
                    var spanC = colsPanList[index].sapnCount;
                    if (colsPanList[index].sapnCount < forzenColumn) {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                        else
                            index++;
                    }
                    else if (colsPanList[index].sapnCount > forzenColumn) {
                        colsPanList[index].sapnCount = colsPanList[index].sapnCount - forzenColumn
                        if (frozenHeader)
                            frozenColspanList.push({ sapnCount: forzenColumn, headerText: colsPanList[index].headerText });
                    }
                    else {
                        frozenColspanList.push(colsPanList[index])
                        if (!frozenHeader)
                            colsPanList.splice(index, 1);
                    }
                    forzenColumn -= spanC;
                }
                if (frozenHeader)
                    colsPanList = frozenColspanList
            }
            if (this.model.detailsTemplate || this.model.childGrid)
                $tr.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
            for (var c = 0; c < colsPanList.length; c++) {
                var $th = ej.buildTag('th.e-headercell e-stackedHeaderCell e-default' + colsPanList[c].tooltip, colsPanList[c].headerText, {}, { 'colspan': colsPanList[c].sapnCount });
                $th.css("textAlign", colsPanList[c].txtAlign);
                $tr.append($th);
                if (colsPanList[c]["cssClass"] != undefined)
                    $th.addClass(colsPanList[c]["cssClass"]);
				if(this.model.allowResizing || this.model.allowReordering || this.model.allowResizeToFit)
                    $th.addClass("e-resizer");
            }
            return $tr;
        },
        _renderGridHeaderInternalDesign: function (columns, frozenHeader) {
            var $table = ej.buildTag('table.e-table', "", {}, { "data-role": "grid" });
            var $thead = ej.buildTag('thead');
            var $tbody = ej.buildTag('tbody.e-hide');
            var $columnHeader = ej.buildTag('tr.e-columnheader');
            var $colGroup = $(document.createElement('colgroup'));
            var $rowBody = $(document.createElement('tr'));
            if (this.model.childGrid || this.model.detailsTemplate ) {
                $columnHeader.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div></div>'));
                $rowBody.append(document.createElement('td'));
                $colGroup.append(this._getIndentCol());
            }
            if (this.model.showStackedHeader) {
                for (var index = 0; index < this.model.stackedHeaderRows.length; index++) {
                    var $tr = this._createStackedRow(this.model.stackedHeaderRows[index], frozenHeader);
                    $thead.append($tr);
                }
            }
            for (var columnCount = 0; columnCount < columns.length; columnCount++) {
                var $headerCell = ej.buildTag('th.e-headercell e-default', "", {}, { "data-role": "columnheader" });
                var bodyCell = document.createElement('td');
                var $headerCellDiv = ej.buildTag('div.e-headercelldiv', (columns[columnCount]["headerText"] === undefined && columns[columnCount]["type"] != "checkbox") ? columns[columnCount]["headerText"] = columns[columnCount]["field"] : columns[columnCount]["headerText"], {}, { "data-ej-mappingname": columns[columnCount]["field"] });
                if (columns[columnCount].disableHtmlEncode)
                    $headerCellDiv.text(columns[columnCount]["headerText"]);
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTooltip"]))
                    $headerCellDiv.addClass("e-gridheadertooltip");
                if (!ej.isNullOrUndefined(columns[columnCount]["tooltip"]))
                    $headerCellDiv.addClass("e-gridtooltip");
                if (columns[columnCount]["clipMode"] == ej.Grid.ClipMode.Ellipsis || columns[columnCount]["clipMode"] == ej.Grid.ClipMode.EllipsisWithTooltip)
                    $headerCellDiv.addClass("e-gridellipsis");
                if(this.model.allowResizing || this.model.allowReordering || this.model.allowResizeToFit)
                        $headerCell.addClass("e-resizer");               
			   $headerCell.append($headerCellDiv);
                if (this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel") &&
                                (columns[columnCount]["allowFiltering"] == undefined || columns[columnCount]["allowFiltering"] === true) && (!ej.isNullOrUndefined(columns[columnCount].field) || columns[columnCount].field == "") && (columns[columnCount]["type"] != "checkbox")) {
                        var filtericon = 'e-filterset';
                    if (!this.initialRender && this.model.filterSettings.filteredColumns) {
                        for (var i = 0; i < this.model.filterSettings.filteredColumns.length; i++) {
                            if (this.model.filterSettings.filteredColumns[i].field == columns[columnCount].field) {
                                filtericon = 'e-filterset e-filteredicon e-filternone';
                            }
                        }
                    }
                    $headerCell.append(ej.buildTag('div.e-filtericon e-icon ' + filtericon));
                    if (this.model.allowGrouping && this.model.groupSettings.showToggleButton && $.inArray(columns[columnCount].field, this._disabledGroupableColumns) == -1 && !ej.isNullOrUndefined(columns[columnCount].field) && columns[columnCount].field != "") {
                        $headerCell.addClass("e-headercellgroupfilter");
                        $headerCell.find(".e-filtericon").addClass("e-groupfiltericon");
                    }
                    else
                        $headerCell.addClass("e-headercellfilter");
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0" && this.model.enableRTL)
                        $($headerCellDiv).css("padding", "0 0 0 2em");
                }
                var col = document.createElement('col');
                if (columns[columnCount]["priority"])
                    $(bodyCell).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                $rowBody.append(bodyCell);
                $columnHeader.append($headerCell);
                $colGroup.append(col);
                if (columns[columnCount]["visible"] === false) {
                    $headerCell.addClass("e-hide") && $(col).css("display", "none")
                    if ($.inArray(columns[columnCount].headerText, this._hiddenColumns) == -1 && $.inArray(columns[columnCount].field, this._hiddenColumnsField) == -1)
                        this._hiddenColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._hiddenColumnsField.push(columns[columnCount].field) : this._hiddenColumnsField.push(columns[columnCount].headerText);
                    if ($.inArray(columns[columnCount].field, this._visibleColumnsField) != -1)
                        this._visibleColumnsField.splice($.inArray(columns[columnCount].field, this._visibleColumnsField), 1) && this._visibleColumns.splice($.inArray(columns[columnCount].headerText, this._visibleColumns), 1)
                }
                else {
                    this._visibleColumns.push(columns[columnCount].headerText) && columns[columnCount].field != ("" || undefined) ? this._visibleColumnsField.push(columns[columnCount].field) : this._visibleColumnsField.push(columns[columnCount].headerText);
                    columns[columnCount]["visible"] = true;
                    if ($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField) != -1)
                        this._hiddenColumnsField.splice($.inArray(columns[columnCount].field == "" ? columns[columnCount].headerText : columns[columnCount].field, this._hiddenColumnsField), 1) && this._hiddenColumns.splice($.inArray(columns[columnCount].headerText, this._hiddenColumns), 1)
                }
                if (this.model.showColumnChooser && columns[columnCount]["showInColumnChooser"] !== false)
                    columns[columnCount]["showInColumnChooser"] = true;
                if (this.model.allowResizing && columns[columnCount]["allowResizing"] !== false)
                    columns[columnCount]["allowResizing"] = true;
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTextAlign"]))
                    $headerCellDiv.css("text-align", columns[columnCount]["headerTextAlign"]);
                else if (columns[columnCount]["textAlign"] != undefined)
                    $headerCellDiv.css("text-align", columns[columnCount]["textAlign"]);
				else if (this.model.enableRTL)
					$headerCellDiv.css("text-align",columns[columnCount]["textAlign"] = "right");
                columns[columnCount]["allowResizing"] === false && this._disabledResizingColumns.push(columns[columnCount].field);
                columns[columnCount]["allowSorting"] === false && this._disabledSortableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowGrouping"] === false && this._disabledGroupableColumns.push(columns[columnCount].field);
                columns[columnCount]["allowEditing"] === false && this._disabledEditableColumns.push(columns[columnCount].field);
                if (!ej.isNullOrUndefined(columns[columnCount]["cssClass"])) {
                    $headerCell.addClass(columns[columnCount]["cssClass"]);
                    $(col).addClass(columns[columnCount]["cssClass"]);
                }
                if ( this.model.allowTextWrap && this.model.textWrapSettings.wrapMode != "content") {
                     if (columns[columnCount]["allowTextWrap"] == false)
                        $headerCellDiv.addClass("e-nwrap");
                }
                if (!ej.isNullOrUndefined(columns[columnCount]["headerTemplateID"])) {
                    $headerCellDiv.html($(columns[columnCount]["headerTemplateID"]).hide().html()).parent().addClass("e-headertemplate");
                    var index = $.inArray(columns[columnCount].field, this._disabledGroupableColumns);
                    index == -1 && ej.isNullOrUndefined(columns[columnCount].field) && this._disabledGroupableColumns.push(columns[columnCount].field);
                }
                if (ej.getObject("type", columns[columnCount]) == "checkbox" && ej.isNullOrUndefined(columns[columnCount]["headerText"])) {
                    $headerCellDiv.addClass("e-headercheckcelldiv");
                    $headerCellDiv.html("<input type = 'checkbox' class = 'e-checkselectall'></input>");
                    if (!ej.isNullOrUndefined(columns[columnCount].field))
                        $headerCellDiv.attr("data-ej-mappingname", columns[columnCount].field);
                }
                if (this.model.allowGrouping && this.model.groupSettings.showToggleButton && $.inArray(columns[columnCount].field, this._disabledGroupableColumns) == -1 && !ej.isNullOrUndefined(columns[columnCount].field) && columns[columnCount].field != "") {
                    if ($.inArray(columns[columnCount].field, this.model.groupSettings.groupedColumns) != -1)
                        $headerCell.append(this._getToggleButton().addClass("e-toggleungroup"));
                    else
                        $headerCell.append(this._getToggleButton().addClass("e-togglegroup"));
                    if(!filtericon) 
                        $headerCell.addClass("e-headercellgroup");
                    if(this.model.enableRTL) {
                        if(filtericon)
                            $headerCellDiv.addClass("e-headercelldivgroup");
                        else
                            $headerCell.find(".e-gridgroupbutton").addClass("e-rtltoggle");
                    }
                }
                $headerCell.attr("title", this._decode(columns[columnCount].headerText));
                if (columns[columnCount]["priority"]) {
                    $headerCell.attr("data-priority", columns[columnCount]["priority"]).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                    $(col).addClass("e-table-priority-" + columns[columnCount]["priority"]);
                }
                if (this.initialRender) {
                    var cCount = columnCount, frozenCols = this.model.scrollSettings.frozenColumns;
                    cCount = !frozenHeader ? frozenCols > 0 ? cCount + frozenCols : cCount : cCount;
                    this._columnsPixelConvert(columns[columnCount], cCount);
                }
                if (columns[columnCount]["width"] == undefined && this.model.commonWidth !== undefined)
                    this.columnsWidthCollection[columnCount + this.model.scrollSettings.frozenColumns] = this.model.commonWidth;
                this._fieldColumnNames[columns[columnCount].headerText] = columns[columnCount].field;
                this._headerColumnNames[columns[columnCount].field] = columns[columnCount].headerText;                
            }
            $thead.append($columnHeader);
            $tbody.append($rowBody);
            $table.append($colGroup).append($thead).append($tbody);
            return $table;
        },
        _columnsPixelConvert: function (column, columnIndex) {
            var colIndex;
            var elementWidth = this.model.scrollSettings.width > 0 ? this.model.scrollSettings.width : this.element.width();
            var cols = ej.isNullOrUndefined(column) ? this.model.columns : $.makeArray(column);
            for (var columnCount = 0; columnCount < cols.length; columnCount++) {
                colIndex = columnIndex || columnCount;
                if (typeof (cols[columnCount].width) == "string" && cols[columnCount].width.indexOf("%") != -1 && (this.model.allowScrolling || (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length)))
                    this.columnsWidthCollection[colIndex] = (parseInt(cols[columnCount]["width"]) / 100 * elementWidth);
                else
                    this.columnsWidthCollection[colIndex] = (cols[columnCount]["width"]);
            }
        },
        _renderGridHeader: function () {
            var $div = ej.buildTag('div.e-gridheader'), temp, $frozenDiv, $movableDiv;
            var $innerDiv = ej.buildTag('div');
            if (this.model.allowScrolling)
                $innerDiv.addClass("e-headercontent");
            this.setGridHeaderContent($div);
            if (this.initialRender) {
                this.columnsWidthCollection = [];
                this._hiddenColumns = [];
                this._hiddenColumnsField = [];
            }
            this._visibleColumns = [];
            this._visibleColumnsField = [];
            this._resetDisabledCollections();
            this._fieldColumnNames = {};
            this._headerColumnNames = {};
            if (this.model.scrollSettings.frozenColumns > 0) {
                $frozenDiv = ej.buildTag("div.e-frozenheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(0, this.model.scrollSettings.frozenColumns), true));
                $movableDiv = ej.buildTag("div.e-movableheader", ej.buildTag("div.e-movableheaderdiv", this._renderGridHeaderInternalDesign(this.model.columns.slice(this.model.scrollSettings.frozenColumns), false)));
                $innerDiv.append($frozenDiv).append($movableDiv);
            } else
                $innerDiv.append(this._renderGridHeaderInternalDesign(this.model.columns));
            $div.html($innerDiv);
            if (this.model.isResponsive)
                $div.addClass("e-textover");
            this.setGridHeaderTable(this.getHeaderContent().find(".e-table"));
            return $div;
        },
        _renderGridContent: function () {
            var $div = ej.buildTag('div.e-gridcontent');
            var $innderDiv = ej.buildTag('div');
            var $table = ej.buildTag('table.e-table', "");
            var $tbody = $(document.createElement('tbody'));
            $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
            $innderDiv.html($table);
            $div.html($innderDiv);
            this.setGridContentTable($table);
            this.setGridContent($div);
            $table.attr("data-role", "grid");
            var args = {};
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length) {
                if (this.initialRender) {
                    args.columnName = this.model.groupSettings.groupedColumns[this.model.groupSettings.groupedColumns.length - 1];
                    if (!this.model.groupSettings.showGroupedColumn) {
                        for (var i = 0; i < this.model.groupSettings.groupedColumns.length; i++) {
                            var col = this.model.groupSettings.groupedColumns[i];
                            if ($.inArray(col, this._hiddenColumnsField) == -1) {//updated for
                                this._hiddenColumnsField.push(col);//updated for
                                this._hiddenColumns.push(this.getColumnByField(col).headerText);
                                this._visibleColumns.splice(this._visibleColumns.indexOf(this.getColumnByField(col).headerText), 1);
                                this._visibleColumnsField.splice(this._visibleColumnsField.indexOf(col), 1);
                                this.getColumnByField(col).visible = false;
                            }
                        }
                    }
                }
                args.requestType = ej.Grid.Actions.Grouping;
            } else
                args.requestType = ej.Grid.Actions.Refresh;
            if (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0) {
                var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: (this.model.columns.length - this._hiddenColumns.length)});
                $tbody.append($(document.createElement("tr")).append($emptyTd));
                this.setWidthToColumns();
                if (this.initialRender || this.model.groupSettings.groupedColumns.length)
                    this.sendDataRenderingRequest(args)
            } else
                this.sendDataRenderingRequest(args);
            if (this._isCaptionSummary && args.requestType == "grouping" && this.model.groupSettings.groupedColumns.length > 1) {
                var colgroup = this.getContentTable().find(".e-table").not(".e-recordtable").children("colgroup");
                var $cols1 = $(this.getContentTable().find(".e-recordtable")[0]).children("colgroup").find("col");
                for (var i = 0; i < colgroup.length; i++) {
                    var colCount = $(colgroup[i]).find("col").length;
                    $(colgroup[i]).find("col:gt(" + (colCount - $cols1.length - 1) + ")").remove();
                    $(colgroup[i]).append($cols1.clone());
                }
            }
            return $div;
        },
        
        print: function () {
            var args = {}; args.requestType = "print";
            this._printselectrows = this.getContentTable().find('tr[aria-selected="true"]');            
            this._trigger("actionBegin", args);

            var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no"), $printDiv = ej.buildTag("div#" + this._id), cloneGridModel = $.extend(true, {}, this.model);            
            cloneGridModel.toolbarSettings.showToolbar = cloneGridModel.allowPaging = cloneGridModel.allowScrolling = cloneGridModel.showColumnChooser = false;
            cloneGridModel.editSettings = {};
            cloneGridModel.query.queries = [];
            cloneGridModel._isPrinting = true;
            if (this.model.allowPaging && this.model.pageSettings.printMode == "currentpage") {
                cloneGridModel.query.queries = [{ fn: "onPage", e:{ pageIndex: this._currentPage(), pageSize: this.model.pageSettings.pageSize }}];
                cloneGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            else {                
                cloneGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            $printDiv.ejGrid(cloneGridModel);

        },
        _printProcess: function (printWin) {
            var elementClone = this.element, args = { requestType: "print", element: elementClone, selectedRows: this._printselectrows };
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                elementClone.find(".e-filterbar").remove();
            elementClone.show();           
            this._trigger("beforePrint", args);
            ej.print(elementClone, printWin);           
            this._trigger("actionComplete", args);
        },
        
         "export": function (action, serverEvent, multipleExport,gridIds) {
           var modelClone = $.extend(true, {}, this.model);
            var proxy = this;
            var attr = { action: action, method: 'post', "data-ajax": "false" };
            var form = ej.buildTag('form', "", null, attr);
            var locale = [];
            if (multipleExport && !ej.isOnWebForms) {
                var gridCol=$('div.e-grid');
                if (gridIds && gridIds.length > 0) {
                    gridCol = $.map(gridIds, function (i) { return document.getElementById(i) })
                }
                $.each(gridCol,function (index, object) {
                        var gridobjectArray = {};
                        var gridObject = $(object).data('ejGrid');
                        locale.push({ id: gridObject._id, locale: gridObject.model.locale });
                        if (!ej.isNullOrUndefined(gridObject)) {
                            var modelClone = $.extend(true, {}, gridObject.model);
                            modelClone = proxy._getModifyExportModel(modelClone);
                            if (gridObject.ignoreOnExport) {
                                for (var i = 0; i < gridObject.ignoreOnExport.length; i++) {
                                    delete modelClone[gridObject.ignoreOnExport[i]];
                                }
                                var inputAttr = { name: 'GridModel', type: 'hidden', value: gridObject.stringify(modelClone) }
                                var input = ej.buildTag('input', "", null, inputAttr);
                                form.append(input);
                            }
                        }
                    });
                    $('body').append(form);
                    form.submit();
            }
            else {
                this._locale = this.model.locale;
                modelClone = this._getModifyExportModel(modelClone);
                var gridob = this;
                if (this.ignoreOnExport) {
                    for (var i = 0; i < this.ignoreOnExport.length; i++) {
                        delete modelClone[this.ignoreOnExport[i]];
                    }
                }
                if (ej.raiseWebFormsServerEvents) {
                    var args = { model: modelClone, originalEventType: serverEvent };
                    var clientArgs = { model: this.stringify(modelClone) };
                    ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
                    setTimeout(function () {
                        ej.isOnWebForms = true;
                    }, 1000);
                }
                else {
                        var inputAttr = { name: 'GridModel', type: 'hidden', value: this.stringify(modelClone) }
                        var input = ej.buildTag('input', "", null, inputAttr);
                        form.append(input);
                        form.append(this);
                        $('body').append(form);
                        form.submit();
                }
            }
            setTimeout(function () {
                if (locale.length) {
                    for (var i = 0; i < locale.length; i++) {
                        var gridObject = $("#" + locale[i].id).data('ejGrid');
                        gridObject.model.locale = locale[i].locale;
                    }
                }
                if (!ej.isNullOrUndefined(proxy._locale))
                    proxy.model.locale = proxy._locale;
            }, 0);
            form.remove();
            return true;
        },
        _getModifyExportModel:function(modelClone){
            var tempObj = {}
            $.extend(tempObj, ej.Grid.Locale["en-US"], ej.Grid.Locale[modelClone.locale]);
            var temp = tempObj.GroupCaptionFormat;
            var split1 = temp.indexOf("{{if");
            var split2 = temp.indexOf(" {{else}}");
            var grpText = temp.slice(split1, split2).replace("{{if count == 1 }}", "");
            var localeProp = { EmptyRecord: tempObj.EmptyRecord, GroupCaptionFormat: temp.slice(0, split1), GroupText: grpText,True:tempObj.True,False:tempObj.False };
            if (!ej.isNullOrUndefined(this.model))
                this.model.locale = modelClone.locale.concat(JSON.stringify(localeProp));
            modelClone.locale = modelClone.locale.concat(JSON.stringify(localeProp));
            for (var i = 0; i < modelClone.columns.length; i++) {
                if (modelClone.columns[i].editType != undefined) {
                    switch (modelClone.columns[i].editType) {
                        case "stringedit":
                        case "edittemplate":
                            modelClone.columns[i].editType = "string";
                            break;
                        case "numericedit":
                            modelClone.columns[i].editType = "numeric";
                            break;
                        case "dropdownedit":
                            modelClone.columns[i].editType = "dropdown";
                            break;
                        case "booleanedit":
                            modelClone.columns[i].editType = "boolean";
                            break;
                        default:
                            break;
                    }
                }
            }
            for (var i = 0; i < modelClone.columns.length; i++) {
                if (!ej.isNullOrUndefined(modelClone.columns[i].template)) {
                    if (modelClone.columns[i].template.indexOf("#") != -1) {
                        var string = $.templates(modelClone.columns[i].template).markup;
                        modelClone.columns[i].template = escape($.trim(string));
                    }
                }
            }
            if (!ej.isNullOrUndefined(modelClone.detailsTemplate))
                modelClone.detailsTemplate = escape($.trim($.templates(modelClone.detailsTemplate).markup));
            for (var i = 0; i < modelClone.filterSettings.filteredColumns.length; i++) {
                if (modelClone.filterSettings.filteredColumns[i].operator == "equal")
                    modelClone.filterSettings.filteredColumns[i].operator = "equals";
                else if (modelClone.filterSettings.filteredColumns[i].operator == "notequal")
                    modelClone.filterSettings.filteredColumns[i].operator = "notequals";
            }
            if (modelClone.showStackedHeader) {
                modelClone.stackedHeaderRow = modelClone.stackedHeaderRows;
                for (var i = 0; i < modelClone.stackedHeaderRow.length; i++) {
                    modelClone.stackedHeaderRow[i].stackedHeaderColumn = modelClone.stackedHeaderRow[i].stackedHeaderColumns;
                    var a = modelClone.stackedHeaderRow[i].stackedHeaderColumn;
                    for (var j = 0; j < a.length; j++) {
                        modelClone.stackedHeaderRow[i].stackedHeaderColumn[j].column = $.isArray(a[j].column) ? a[j].column : a[j].column.split(',');
                    }
                }
            }
            return modelClone
        },
        sendDataRenderingRequest: function (args) {
            if (this._templateRefresh) {
                this.refreshTemplate();
                this._templateRefresh = false;
            }
            this.setFormat();
            if(!this.model.scrollSettings.enableVirtualization){
				this._previousColumnIndex = null;
				this._previousRowCellIndex = null;
				this._previousIndex = null;
			}
            if (args.requestType == "add" || args.requestType == "grouping" || (this.model.currentViewData != null && this.model.currentViewData.length)) {
                switch (args.requestType) {
                    case ej.Grid.Actions.Refresh:
                    case ej.Grid.Actions.Paging:
                    case ej.Grid.Actions.Sorting:
                    case ej.Grid.Actions.Filtering:
                    case ej.Grid.Actions.Save:
                    case ej.Grid.Actions.Cancel:
                    case ej.Grid.Actions.Delete:
                    case ej.Grid.Actions.Search:
                    case ej.Grid.Actions.Reorder:
                    case ej.Grid.Actions.BatchSave:
                        var cloneGroupedColumns = this.model.groupSettings.groupedColumns
                        if(this.model.allowGrouping && args.requestType == ej.Grid.Actions.Refresh && cloneGroupedColumns.length == 0 && this.element.find(".e-grouptopleftcell").length > 0) {
                            var $header = this.element.children(".e-gridheader");
                            $header.find("div").first().empty().append(this._renderGridHeader().find("table"));
                        }
						if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                            $("#" + this._id + "_externalEdit").css("display", "none");
						if (this.model.allowPaging) {
						    if (this.model.filterSettings.filteredColumns.length)
						        this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._filteredRecordsCount : this._searchCount, currentPage: this._currentPage() });
						    else
						        this.getPager().ejPager({ totalRecordsCount: this._searchCount == null ? this._gridRecordsCount : this._searchCount, currentPage: this._currentPage() });
						    this._refreshGridPager();
						}
                        if(!this.model.allowGrouping)
                            cloneGroupedColumns = [];
                        if (cloneGroupedColumns.length == 0) {
                            var temp = document.createElement('div'), temp1, insertIndex = -1, isRemoteAdaptor = false;
                            if (!this.phoneMode)
                                this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                            (this.model.childGrid != null || this.model.detailsTemplate != null) && this.getContentTable().find("colgroup").first().prepend(this._getIndentCol());
                            var currentPage = this._currentPage();
                            if ((this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate" || this.model.editSettings.editMode == "normal") && (args.requestType == "cancel" || args.requestType == "save"))
                                this._editFormHeight = this.element.find(".gridform").closest("tr").height();
     
                            if (this.model.scrollSettings.frozenColumns > 0)
                                temp.innerHTML = this._renderByFrozenDesign();
                            else {                                
                                if (args.data) {
                                    temp1 = document.createElement('div');
                                    temp1.innerHTML = ['<table><tbody>', $.render[this._id + "_JSONTemplate"](args.data), '</tbody></table>'].join("");
                                    if (this._dataSource() instanceof ej.DataManager && args.requestType == ej.Grid.Actions.Save) {
                                        insertIndex = this._getDataIndex(this.model.currentViewData, args.data);
                                        isRemoteAdaptor = this._dataSource().adaptor instanceof ej.remoteSaveAdaptor;
                                    }
                                }
                                var currentData = null;
                                if (this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && !ej.isNullOrUndefined(this._currentVIndex) && (args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete"))
                                    currentData = ej.isNullOrUndefined(this._lastVirtualPage) ? (ej.isNullOrUndefined(this._virtualLoadedRecords[this._currentVIndex]) ? this._virtualLoadedRecords[this._currentVIndex + 1] : this._virtualLoadedRecords[this._currentVIndex]) : this._lastVirtualPage;
                                else
                                    currentData = this.model.currentViewData
                                if (this.model.rowTemplate != null) {
                                    if (args.action == "hideColumn" || args.action == "showColumn")
                                        temp = this.getContent().find("div:first")[0];
                                    else {
                                        temp.innerHTML = ['<table><tbody>', $.render[this._id + "_JSONTemplate"](currentData), '</tbody></table>'].join("");
                                    }
                                } 
                                else
                                    temp.innerHTML = ['<table><tbody>', $.render[this._id + "_JSONTemplate"](currentData), '</tbody></table>'].join("");
                                var tableEle = this.getContentTable().get(0);
                                var tbodyEle = tableEle.lastChild;
                                var rindex = this.getContentTable().first().find('tbody').first(), rowIndex;
                                if ((args.requestType == "save" || args.requestType == "cancel") && this.model.editSettings.editMode != "batch" && !this.model.scrollSettings.allowVirtualScrolling) {
                                    if (this.model.editSettings.editMode.indexOf("inlineform") != -1)
                                        rowIndex = !ej.isNullOrUndefined(args.selectedRow) ? args.selectedRow : this._selectedRow();
                                    else
                                        rowIndex = this.getContentTable().find('.e-' + args.action + 'edrow').index();
                                    var a = this._currentTrIndex;
                                    if (rowIndex == -1)
                                        rowIndex = a;
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        if (this.model.editSettings.editMode == "inlineform")
                                            var rowTr = $($(tbodyEle.childNodes).not('.e-detailrow')[rowIndex]);
                                        else
                                            var rowTr = $(tbodyEle.childNodes[rowIndex]);
                                        var rowEle = $(tbodyEle.childNodes).not('.e-detailrow');
                                        for (var i = 0; i < rowEle.length; i++) {
                                            if (rowTr.is(rowEle[i]))
                                                rowIndex = i;
                                        }
                                    }
                                    var $oldChild, $editedTr, $newChild;
                                    if (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                        if (args.action == "add" && !this.getContentTable().find(".e-addedrow").length) break;
                                        $oldChild = this.getContentTable().find('.e-addedrow').get(0);
                                        $editedTr = this.getContentTable().find('.e-editedrow');
                                        $newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;                       
                                        if ($editedTr.length || (args.requestType == "save" && this._isMapSelection && !ej.isNullOrUndefined(args.checkboxTarget) && this.model.sortSettings.sortedColumns.length > 0)) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                                $oldChild = $editedTr.prev('tr').get(0);
                                                $editedTr.remove();
                                            } else
                                                $oldChild = $editedTr.get(0);
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (args.requestType == "cancel") {
                                                if (this.model.editSettings.showAddNewRow)
                                                    this.getContentTable().find('.e-addedrow').addClass("e-showaddrow");
                                                $oldChildObj.replaceWith($newChildObj);
                                            } else if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else {
                                                if (ej.isNullOrUndefined(this.model.currentViewData[rowIndex]) || (this._primaryKeys.length && ej.getObject(this._primaryKeys[0], this.model.currentViewData[rowIndex]) != ej.getObject(this._primaryKeys[0], args.data)))
                                                    $(tbodyEle).replaceWith($(temp).find('tbody'))
                                                else
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                            }
											if (this.model.editSettings.showAddNewRow)
												this.model.editSettings.rowPosition == "top" ? tbodyEle.firstChild.remove(): tbodyEle.lastChild.remove();
                                        } else {
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if (args.action == "add" && args.requestType == "save" && this.model.editSettings.showAddNewRow && this.model.allowPaging && this.model.pageSettings.pageSize <= this._currentJsonData.length)
                                                this.model.editSettings.rowPosition == "bottom" ? tbodyEle.lastChild.previousSibling.remove() : tbodyEle.lastChild.remove();
                                            if (args.requestType == "cancel" || this._dataSource() instanceof ej.DataManager || this._currentPage() != 1 || (args.requestType == "save" && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                                if (!ej.isNullOrUndefined($oldChild)) {
                                                    $oldChildObj.remove();
                                                    if (this._dataSource() instanceof ej.DataManager && insertIndex != -1) {
                                                        if (insertIndex == 0)
                                                            tbodyEle.insertBefore($newChild, tbodyEle.children[insertIndex]);
                                                        else
                                                            $newChildObj.insertAfter(tbodyEle.children[insertIndex - 1]);
                                                    }
                                                    else if ((!(this._dataSource() instanceof ej.DataManager) || isRemoteAdaptor) && this._currentPage() != 1 && args.requestType == "save")
                                                        $(tbodyEle).prepend($(temp.firstChild.firstChild.firstChild));
                                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && cloneGroupedColumns.length == 0 &&
                                                        ((this._dataSource() instanceof ej.DataManager && insertIndex == -1 && (!isRemoteAdaptor && args.requestType != "save")) ||
                                                        (args.requestType != "save" && !(this._dataSource() instanceof ej.DataManager))) && (args.requestType == "cancel" && !this.model.editSettings.showAddNewRow))
                                                        tableEle.lastChild.appendChild(temp.firstChild.firstChild.lastChild);
                                                }
                                                if (args.requestType == "cancel" && this._selectedRow() != -1 && !this._enableCheckSelect)
                                                    this.clearSelection();

                                            } else if (this.model.currentViewData.length == 1) {
                                                $(tbodyEle).empty();
                                                tbodyEle.appendChild($newChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount) && this.element.find('.gridform').length > 0) {
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            } else if (this.model.editSettings.rowPosition == "bottom" && this.element.find('.gridform').length > 0) {
                                                rindex.prepend($oldChild);
                                                tbodyEle.replaceChild($newChild, $oldChild);
                                            } else
                                                if (!ej.isNullOrUndefined($oldChild))
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                        }
                                    } else if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate") {
                                        $editedTr = this.element.find('.e-editedrow');
                                        if (args.requestType == "cancel" || (!$editedTr.length && !ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount == this._previousFilterCount)) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = tbodyEle.childNodes[rowIndex];
                                            var $newChildObj = $($newChild), $oldChildObj = $($oldChild);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('.e-detailrow:visible').length) {
                                                var $target = $newChildObj.find('.e-detailrowcollapse');
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            $oldChildObj.replaceWith($newChildObj);
                                            if ((args.requestType != "cancel" || this._isAddNew) && !this._enableCheckSelect)
                                                this.clearSelection();
                                            this.model.allowPaging && this._refreshGridPager();

                                        } else if ($editedTr.length) {
                                            $newChild = temp.firstChild.firstChild.childNodes[rowIndex];
                                            $oldChild = this._excludeDetailRows(tbodyEle.childNodes)[rowIndex];
                                            if (this.model.allowCellMerging != null) {
                                                var $oldChildObj = $($oldChild);
                                                if ($($oldChild.childNodes).hasClass("e-merged")) {
                                                    var index = $oldChildObj.children('.e-merged').index();
                                                    var count = $oldChild.children[index].colSpan;
                                                    for (var i = 0 ; i < count; i++) {
                                                        $newChild.childNodes[index + i].className += " e-merged e-hide";
                                                        $newChild.childNodes[index].colSpan = i + 1;
                                                    }
                                                }
                                            }
                                            if (this.model.detailsTemplate != null)
                                                $oldChild = $(tbodyEle.childNodes).not('.e-detailrow').eq(rowIndex).get(0);
                                            if ((this.model.detailsTemplate != null || this.model.childGrid != null) && $oldChildObj.next('tr.e-detailrow:visible').length) {
                                                var $target = $($newChild).find(".e-detailrowcollapse");
                                                $target.removeClass("e-detailrowcollapse").addClass("e-detailrowexpand").find("div").removeClass("e-gnextforward").addClass("e-gdiagonalnext");
                                            }
                                            if (!ej.isNullOrUndefined(this._filteredRecordsCount) && this._filteredRecordsCount < this._previousFilterCount) {
                                                var $oldChildObj = $($oldChild);
                                                if (this.model.detailsTemplate != null && $oldChildObj.next('tr.e-detailrow').length)
                                                    tbodyEle.removeChild($oldChildObj.next('tr.e-detailrow').get(0));
                                                $oldChildObj.remove();
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);
                                            } else if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                            else {
                                                if (ej.isNullOrUndefined(this.model.currentViewData[rowIndex]) || (this._primaryKeys.length && ej.getObject(this._primaryKeys[0], this.model.currentViewData[rowIndex]) != ej.getObject(this._primaryKeys[0], args.data)))
                                                    $(tbodyEle).replaceWith($(temp).find('tbody'))
                                                else
                                                    tbodyEle.replaceChild($newChild, $oldChild);
                                            }
                                        } else if (this.model.currentViewData.length == 1 && this.getContentTable().find('td.e-rowcell').length == 0) {
                                            $newChild = temp.firstChild.firstChild.firstChild;
                                            $(tbodyEle).empty();
                                            tbodyEle.appendChild($newChild);
                                        } else {
                                            var newChild = ($editedTr.length || args.requestType == "cancel") ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;
                                            if (!(this._dataSource() instanceof ej.DataManager)) {
                                                if (this.model.sortSettings.sortedColumns.length && args.requestType == "save" && this._currentJsonData.length > 0 || !ej.isNullOrUndefined(this._searchCount))
                                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);
                                                else if (this._currentPage() == 1)
                                                    this.getContentTable().find('tbody').first().prepend($(newChild));
                                                else
                                                    this.getContentTable().find('tbody').first().prepend($(temp.firstChild.firstChild.firstChild));
                                                if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length)
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            else if (insertIndex != -1) {
                                                if (insertIndex == 0)
                                                    tbodyEle.insertBefore(newChild, tbodyEle.children[insertIndex]);
                                                else
                                                    $(newChild).insertAfter(tbodyEle.children[insertIndex - 1]);
                                                var currentDataLength = this._isAddNew && insertIndex ? this.model.currentViewData.length - 1 : this.model.currentViewData.length + 1;
                                                if (this.model.allowPaging && (this.model.pageSettings.pageSize < currentDataLength || insertIndex == this.model.pageSettings.pageSize))
                                                    tbodyEle.removeChild(tbodyEle.lastChild);
                                            }
                                            if (this.model.detailsTemplate != null && $(tableEle.lastChild.lastChild).children('.e-detailrowexpand').length)
                                                tbodyEle.removeChild(tbodyEle.lastChild);
                                        }
                                    }
                                    if (this.model.editSettings.showAddNewRow)
                                        this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                                    else
                                        this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else if (args.requestType == "delete" && !this.model.scrollSettings.allowVirtualScrolling) {
                                    if (this._isUnboundColumn) {
                                        var $editedrow = this.element.find('.e-editedrow');
                                        $oldChild = this.getContentTable().find('.e-editedrow').get(0);
                                        $newChild = ($editedrow.length) ? temp.firstChild.firstChild.firstChild : temp1.firstChild.firstChild.lastChild;

                                        if ($editedrow.length != 0 && (this.model.editSettings.editMode == "normal" || this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")) {
                                            $($oldChild).replaceWith($($newChild));
                                        }
                                        else if (this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") {
                                            $oldChild = $editedrow.prev('tr').get(0);
                                            $editedrow.remove();
                                        }
                                        else
                                            $oldChild = $editedrow.get(0);
                                    }
                                    if (this.model.allowPaging && this.model.pageSettings.pageSize <= this.model.currentViewData.length && this.getContentTable()[0].rows.length != this.model.currentViewData.length) {
                                        if (this.getContentTable().find("tr").length && this._excludeDetailRows().length) {
                                            if (this.multiDeleteMode) {
                                                var rowLength = temp.firstChild.firstChild.rows.length;
                                                var rows = $(temp.firstChild.firstChild.rows).slice(rowLength - this.selectedRowsIndexes.length, rowLength);
                                                $(tbodyEle).append(rows);
                                            }
                                            else
                                                tbodyEle.appendChild(temp.firstChild.firstChild.lastChild);

                                        }
                                        else
                                            $(tbodyEle).prepend(temp.firstChild.firstChild.rows);
                                    }
                                    if (this.model.detailsTemplate != null || this.model.childGrid != null) {
                                        var visibleRow = this.getContentTable().find('.e-detailrow:visible');
                                        $.each(visibleRow, function (indx, item) {
                                            if (visibleRow.eq(indx).closest('tr').prev().children('.e-detailrowexpand').length == 0)
                                                visibleRow.eq(indx).remove();
                                        });
                                    }
                                    this._gridRows = tableEle.rows;
                                    if (this.model.enableAltRow)
                                        this._refreshAltRow();
                                } else
                                    this.getContentTable().get(0).replaceChild(this.model.rowTemplate != null ? temp.firstChild.lastChild : temp.firstChild.firstChild, this.getContentTable().get(0).lastChild);

                            }
                            this._currentJsonData = this.model.currentViewData;
                            if (this.model.editSettings.showAddNewRow)
                                this._gridRows = this.getContentTable().first().find(".e-rowcell").closest("tr.e-row, tr.e-alt_row").toArray();
                            else
                                this._gridRows = this.getContentTable().get(0).rows;
                            if (this.model.scrollSettings.frozenColumns > 0)
                                this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

                            var model = {};
                            if ((args.requestType == "sorting" || args.requestType == "filtering" || args.requestType == "save" || args.requestType == "cancel" || args.requestType == "delete") && this.model.scrollSettings.allowVirtualScrolling) {
                                if (args.requestType == "filtering") {
                                    this.getContent().first().ejScroller("refresh").ejScroller("isVScroll") ? this.element.find(".gridheader").addClass("e-scrollcss") : this.element.find(".gridheader").removeClass("e-scrollcss");
                                    var model = this._refreshVirtualPagerInfo();
                                }
                                if(this.model.scrollSettings.enableVirtualization)
									this._refreshVirtualView(this._currentVirtualIndex);
								else
									this._refreshVirtualContent(currentPage);
                                args.requestType == "filtering" && this.getContent().first().ejScroller("refresh");
                            }
                            if (args.requestType == "refresh" && (this._singleView || this._getVirtualTotalRecord() < this._virtualRowCount))
                                this._addLastRow();
							if(!this.model.scrollSettings.enableVirtualization)
								this._eventBindings();
                            break;
                        }
                    case ej.Grid.Actions.Grouping:
                        this._group(args);
                        this._refreshStackedHeader();
                        break;
                    case ej.Grid.Actions.BeginEdit:
                        this._edit(args);
                        break;
                    case ej.Grid.Actions.Add:
                        this._add(args);
                        break;
                    case ej.Grid.Actions.Ungrouping:
                        this._ungroup(args);
                        break;
                    case ej.Grid.Actions.VirtualScroll:
						if(!this._isVirtualRecordsLoaded){
							if(!this.model.scrollSettings.enableVirtualization)
								this._replacingContent();
							else
								this._replacingVirtualContent();
						}                        
                        break;
                }
            }
            else if (args.requestType == "reorder" && this.model.groupSettings.groupedColumns.length > 0)
                    this._group(args);
            else {
                if ((ej.isNullOrUndefined(this.model.currentViewData) || this.model.currentViewData.length == 0) && !this.phoneMode) {
                    if (args.requestType == "refresh" && this.model.scrollSettings.frozenColumns == 0)
                        this.getContentTable().find("colgroup").first().replaceWith(this._getMetaColGroup());
                    if((args.requestType == "filtering" ||args.requestType == "cancel" || args.requestType == "refresh") && this.model.scrollSettings.frozenColumns > 0)
                        this._removeFrozenTemplate();
                }
				this._newungroup(args);  
            }
            if (ej.isNullOrUndefined(this.model.currentViewData) || this.model.currentViewData.length == 0)
                this._currentJsonData = [];
            this._showGridLines();
            this._completeAction(args);
        },
        _removeFrozenTemplate: function(){
            this.getContent().find('div').eq(0).empty();
            var $table = ej.buildTag('table.e-table');
            var $tbody = $(document.createElement('tbody'));
            $table.append(this.getHeaderTable().find('colgroup').clone()).append($tbody);
            this.getContent().find('div').eq(0).html($table);
            this.setGridContentTable($table);
        },
        _showGridLines: function () {
            var $lines = this.model.gridLines;
            if ($lines != "both") {
				this.getContent().addClass($lines != "none" ? "e-" + $lines + "lines" : "e-hidelines");
            }
        },
		_showHeaderGridLines: function(){
			var $lines = this.model.gridLines;
			if ($lines != "both") 
				this.getHeaderContent().addClass($lines != "none" ? "e-"+$lines+"lines" : "e-hidelines");
		},
        _newungroup: function (args) {
            if (args.requestType == "ungrouping")
                this._ungroup(args);
            else
                this.getContentTable().find('tbody').empty().first().append(this._getEmptyTbody());
        },
        setFormat: function () {
            var column = [];
            for (var i = 0 ; i < this.model.columns.length ; i++) {
                if (this.model.columns[i].type == "date") {
                    column.push(this.model.columns[i]);
                }
            }
            if (column.length > 0 && !ej.isNullOrUndefined(this.model.currentViewData)) {
                for (var i = 0, len = this.model.currentViewData.length; i < len ; i++) {
                    for (var j = 0 ; j < column.length ; j++) {
                        var data = ej.getObject(column[j].field, this.model.currentViewData[i]);
                        if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*)?)([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(data))
                            ej.createObject(column[j].field, new Date(data), this.model.currentViewData[i]);
                    }
                }
            }
        },
        _completeAction: function (args) {
            if (this.model.editSettings.editMode.indexOf("dialog") != -1 && (args.requestType == "save" || args.requestType == "cancel") && $("#" + this._id + "_dialogEdit").data("ejDialog"))
                $("#" + this._id + "_dialogEdit").ejDialog("close");
            if (!(this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal"))
                this.model.isEdit = false;
            this._confirmedValue = false;
            if (ej.Grid.Actions.Grouping == args.requestType && ej.isNullOrUndefined(args.columnName) || args.requestType == "refresh" && this._LastColumnUnGroup) {
                this._LastColumnUnGroup = false;
                return;
            }
            if ((args.columnSortDirection == "ascending" || args.columnSortDirection == "descending") && !ej.isNullOrUndefined(args.columnName)) {
                var scolumn = this.getColumnByField(args.columnName);
                if (this.model.allowSorting && this.model.allowMultiSorting)
                    this._scolumns.push(scolumn.field);
                else
                    this._gridSort = scolumn.field;
            }
            if (args.requestType != 'beginedit' && args.requestType != 'add' && (!this.model.allowScrolling || !this.initialRender || this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                this.setWidthToColumns();
            if (args.requestType == "save" || args.requestType == "cancel" ||  args.requestType == "delete") {
                this._isAddNew = false;
                if (this.model.isResponsive && this.model.minWidth)
                {
                    this._refreshScroller(args);
                    this.windowonresize();
                }
            }
            if (ej.Grid.Actions.Add == args.requestType || args.requestType == "beginedit") {
                for (var count = 0 ; count < this.model.columns.length; count++) {
                    var editorEle = this.element.find('.gridform').first().find(".e-field[name='"+this.model.columns[count].field +"']");
                    if (this.model.columns[count].allowEditing && editorEle.hasClass('e-disable')) {
                        if (this._disabledEditableColumns.indexOf(this.model.columns[count].field) != -1)
                            this._disabledEditableColumns.splice(this._disabledEditableColumns.indexOf(this.model.columns[count].field), 1);
                        editorEle.prop("disabled", false).removeClass("e-disable")
                    }
                    else {
                        if (this.model.columns[count].allowEditing === false && !editorEle.hasClass('e-disable') && $.inArray(this.model.columns[count].field, this._primaryKeys) == -1 && $.inArray(this.model.columns[count].field, this._disabledEditableColumns) == -1) {
                            this._disabledEditableColumns.push(this.model.columns[count].field);
                            editorEle.addClass("e-disable").prop("disabled", true);
                        }
                    }
                }
            }
            if (!this.initialRender && (ej.Grid.Actions.UnGrouping == args.requestType || this.model.groupSettings.groupedColumns.length > 0) && !$("#" + this._id + "EditForm").length)
                this._recalculateIndentWidth();
            if (ej.Grid.Actions.Paging == args.requestType || ej.Grid.Actions.BatchSave == args.requestType)
                this._refreshGridPager();
            else if ((ej.Grid.Actions.Sorting == args.requestType && this.model.allowSorting) || ej.Grid.Actions.Refresh == args.requestType  || ej.Grid.Actions.Cancel == args.requestType) {
                if (ej.gridFeatures.sort && this.getHeaderTable() !== null)
                    this._sortCompleteAction(args);
                if (this.model.allowPaging) {
                    var pageModel = $.extend({},this.getPager().ejPager("option"));
                    this._currentPage(pageModel.currentPage);
                    delete pageModel.currentPage;
					var template = this.model.pageSettings.template;
                    $.extend(this.model.pageSettings, pageModel);
					this.model.pageSettings.template = template;
                    delete this.model.pageSettings.masterObject;
                    this._refreshGridPager();
                }
				if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
                    this._refreshScroller(args);
                
            } else if (ej.Grid.Actions.Delete == args.requestType || ej.Grid.Actions.Save == args.requestType || ej.Grid.Actions.Search == args.requestType) {
                this._editEventTrigger(args);
				if (!this.initialRender && (this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0))
					this._refreshScroller(args);
                if (this.model.allowPaging)
                    this._refreshPagerTotalRecordsCount();
            } else if (ej.Grid.Actions.Filtering == args.requestType)
                this._filterCompleteAction();
            else if (ej.Grid.Actions.BeginEdit == args.requestType || ej.Grid.Actions.Add == args.requestType)
                this._editCompleteAction(args);
            else if (ej.Grid.Actions.Grouping == args.requestType || ej.Grid.Actions.Ungrouping == args.requestType)
                this["_" + args.requestType + "CompleteAction"](args);
            if (this.model.toolbarSettings.showToolbar || ((this.model.allowSorting || this.model.allowFiltering) && this.model.enableResponsiveRow))
                this.refreshToolbar();
            if (!this.initialRender && this.model.showSummary && this.model.summaryRows.length > 0) {
                if (this.model.currentViewData.length) {
                    if (!this.element.children(".e-gridfooter").length) {
                        var footer = this._renderGridFooter();
                        if (!ej.isNullOrUndefined(footer)) footer.insertAfter(this.getContent());
                    }
                    if (!(args.requestType == "beginedit" || args.requestType == "add")) {
                        this._createSummaryRows(this.getFooterTable());
                        this._refreshGridFooterColGroup();
                    }
                }
                else
                    this.element.children(".e-gridfooter").remove();
            }
            if (!this.initialRender && ej.gridFeatures.selection) {
                if (!this.getContent().find("td.e-selectionbackground").length)
                    this._setCurrentRow(args.requestType);
                if (args.requestType == "cancel" && this.model.selectedRowIndex != -1)
                     $(this.getRowByIndex(this.model.selectedRowIndex)).attr("aria-selected", "true").find('.e-rowcell, .e-detailrowcollapse, .e-detailrowexpand').addClass("e-selectionbackground e-active");
                if (args.requestType != "virtualscroll" && this.clearColumnSelection())
                    $(this.getHeaderTable().find("th.e-headercell")).removeClass("e-columnselection");
            }
            this.refreshBatchEditMode();
            if(this.model.scrollSettings.enableVirtualization && this.model.showColumnChooser && (!this.initialRender && args.requestType == "refresh"))
                this._virtualLoadedRows = {};
            if (!this.initialRender && (this.model.allowScrolling || this.model.isResponsive) && (this._checkScrollActions(args.requestType) || ((this.model.editSettings.editMode.indexOf("inline") != -1 || this.model.editSettings.editMode.indexOf("normal") != -1) && args.requestType == "beginedit")) ||
                (this.model.scrollSettings.virtualScrollMode == "continuous" && args.requestType == "virtualscroll")){
                if(this.model.isResponsive && this.model.minWidth)
                {
                    this._refreshScroller(args);
                    this.windowonresize()
                }
                else
                    this._refreshScroller(args);
            }
            else if (!this.model.scrollSettings.frozenColumns && this.model.allowScrolling && this.element.width() != 0)
                this.refreshScrollerEvent();
             if (!this.initialRender && this.model.parentDetails && !this.model.allowScrolling) {
                var id = this.model.parentDetails.parentID, parentObj = $("#" + id).data("ejGrid");
                parentObj.model.allowScrolling && parentObj._refreshScroller("refresh")
            }
            if (this.model.scrollSettings.virtualScrollMode == "normal" && args.requestType == "virtualscroll")
                this.getContent().find("div:first").scrollLeft(this.getScrollObject().scrollLeft());
            if (this._customPop != null && args.requestType != "sorting") {
                this._customPop.hide();
            }
            if (this.model.allowScrolling && !this.initialRender && !this.model.scrollSettings.enableVirtualization && !(this.model.isResponsive && this._isHeightResponsive))
                this.getContentTable().find("tr:last").find("td").addClass("e-lastrowcell");

            if (this.model.allowGrouping && this.model.showSummary)
                this._refreshGroupSummary();
            if (ej.Grid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length > 0)
                this._groupingCompleteAction(args);
            if (ej.Grid.Actions.Refresh == args.requestType && !this.initialRender && this.model.allowGrouping && this.model.groupSettings.groupedColumns.length < 1)
                this._ungroupingCompleteAction(args);
			 if(this.model.allowGrouping){
                var $groupDrop = this.element.children(".e-groupdroparea");
                $groupDrop.length > 0 && $groupDrop.removeClass("e-default").removeClass("e-active");
                if(this.model.groupSettings.groupedColumns.length > 0)
                    $groupDrop.addClass("e-active");
                else
                    $groupDrop.addClass("e-default");
            }
            if (this.model.textWrapSettings)
                this._setTextWrap();
            if (args.requestType == ej.Grid.Actions.Reorder && this.model.showColumnChooser) {
                var dlgObj = $("#" + this._id + "ccDiv").data("ejDialog");
                if (dlgObj.isOpened())
                    $("#" + this._id + "_ccTail").first().remove();
                var ccBtnHeight = 0;
                if (!ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                    ccBtnHeight += this.element.find(".e-ccButton").outerHeight();
                this.element.find(".e-ccButton").first().remove();
                $("#" + this._id + 'ccDiv_wrapper').remove();
                this.element.css('margin-top', (parseInt(this.element.css('margin-top'), 10) - ccBtnHeight));
                this._renderColumnChooser();
            }
            if(!ej.isNullOrUndefined(this._dynamicSelectedRowIndex)){
                this.selectRows(this._dynamicSelectedRowIndex);
             	this._dynamicSelectedRowIndex = null;
            }
            if (this.initialRender && args.requestType == "grouping")
                args = { requestType: "refresh" };
            if(!((this._isUngrouping || this._columnChooser  ) && ( args.requestType == "refresh") ) ){
				this._trigger("actionComplete", args);
				this._isUngrouping = false;
				this._columnChooser = false;
			}
            if ((!this._isUngrouping && !this.initialRender) || this._showHideColumns || this._columntemplaterefresh)
            this._trigger("refresh");
            if ((this.model.editSettings.showAddNewRow && this.model.editSettings.editMode == "normal")) {
                
                if (!this.initialRender && this.getContentTable().find("tr.e-addedrow").length == 0 && this.element.find(".e-gridcontent").find("tr").length != 0)
                    this._startAdd();
                 if (args.requestType == "searching")
                    this.element.find(".e-gridtoolbar").find("li#" + this._id + "_search input").focus();
            }
            
            if ((ej.Grid.Actions.BeginEdit == args.requestType || ej.Grid.Actions.Add == args.requestType) && $.isFunction($.validator))
                this.setValidation();
            if (!this.initialRender)
                this.model._groupingCollapsed = [];
            if (this._updateDataSource && this._gridRecordsCount) {
                var currentData = this.model.editSettings.showAddNewRow ? this.model.currentViewData[1] : this.model.currentViewData[0];
                if (!ej.isNullOrUndefined(currentData)) {
                    this._initColumns(currentData);
                    this.model.allowFiltering && this._renderFilterDialogs();
                    this._updateDataSource = false;
                }
            }
		    if (this.model.columnLayout == "fixed" && !this.model.isEdit)
		        this.setWidthToColumns();
		    if (this.model.allowRowDragAndDrop)
		        this._rowsDragAndDrop();
		    if (!this.initialRender && this._enableCheckSelect) {
		        var indexes = this.checkSelectedRowsIndexes[this._currentPage() - 1];
		        var headerCheckCell = this.getHeaderTable().find(".e-headercheckcelldiv .e-checkselectall");
		        if (!this._selectAllCheck && !(this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling && [].concat.apply([], this.checkSelectedRowsIndexes).length >= this._gridRecordsCount))
					headerCheckCell.prop("checked", false);
		        if (!this._isMapSelection && indexes && indexes.length > this._gridRows.length && !this.model.scrollSettings.enableVirtualization)
		            indexes.splice(this._gridRows.length, indexes.length - this._gridRows.length);
		        if (this._isMapSelection)
		            this._mappingSelection();
		        else if (args.requestType != "paging" && args.requestType != "save" && args.requestType != "cancel" && args.requestType != "virtualscroll")
		            this.checkSelectedRowsIndexes = [];
		        else if (indexes && indexes.length && !this.model.scrollSettings.enableVirtualization)
		            this.selectRows(indexes);
		        if (this.model.currentViewData != null && this.model.currentViewData.length == 0)
		            this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").hide();
		        else
                    this.getHeaderTable().find(".e-headercelldiv .e-checkselectall").show();
		        if (this._selectAllCheck) { // For Selection using header after filtering
		            var selectAll = headerCheckCell.prop("checked") ^ this.selectedRowsIndexes.length == this.model.currentViewData.length;
		            if (this.model.groupSettings.groupedColumns.length)
		                selectAll = !selectAll;
		            headerCheckCell[0].checked = !selectAll ? !headerCheckCell[0].checked : headerCheckCell[0].checked;
		        }
		    }
        },        
        _getDataIndex: function (data, item) {
            var flag = 0, _plen;
            for (var d = 0, len = data.length; d < len; d++) {
                for (var key = 0, _plen = this._primaryKeys.length; key < _plen; key++) {
                    if (!this._checkPrimaryValue(data[d][this._primaryKeys[key]], item[this._primaryKeys[key]], this._primaryKeys[key])) {
                        if (key == _plen - 1)
                            flag = 1;
                        continue;
                    }
                    else
                        break;
                }
                if (flag) return d;
            }
            return -1;
        },
        _checkPrimaryValue: function (keyData, keyItem, field) {
            var col = this.getColumnByField(field),
            type = ej.isNullOrUndefined(col.foreignKeyField) ? col.type : col.originalType;
            if (type == "string")
                keyData = keyData.trim();
            if (keyData != keyItem)
                return true;
            else
                return false;
        },
        _eventBindings: function () {
            var rowLength = this.model.scrollSettings.frozenColumns > 0 ? this._gridRows[0].length : this._gridRows.length;
            var trIndex = 0;
            var prev;
            var pageSize = this.model.pageSettings.pageSize;
            if (ej.gridFeatures.common)
                this._refreshUnboundTemplate(this.getContentTable());
            if (this._gridRecordsCount != 0) {
                if (this.model.queryCellInfo != null || this.model.rowDataBound != null || this.model.mergeCellInfo != null || this.model.templateRefresh != null) {
                    for (var row = 0; row < rowLength; row++) {
                        var rowIndex = null, trIndex = row, viewIndex, viewData;
                        if (this.model.scrollSettings.allowVirtualScrolling && row < pageSize) {
							if(!this.model.scrollSettings.enableVirtualization){
								for (var i = 0; i < this._cloneQuery.queries.length; i++)
									prev = this._cloneQuery.queries[i].fn == "onPage" &&  this._cloneQuery.queries[i].e.pageIndex - 1;
								var value = pageSize * prev; 
								if (value != 0) {
									rowIndex = this.getContentTable().find("tr[name=" + value + "]").eq(row);
									trIndex = rowIndex.index();
								}
							}
							else{
								rowIndex = $(this._gridRows).eq(row);
								viewIndex = parseInt($(rowIndex).attr("name"), 32);	
								if($.inArray(viewIndex, this._queryCellView) != -1)		
									continue;
								if(this._virtualLoadedRecords[viewIndex])
									viewData = this._virtualLoadedRecords[viewIndex][row % this._virtualRowCount];
								trIndex = viewIndex * this._virtualRowCount + (row % this._virtualRowCount);								
							}
                        }
						else if(this.model.scrollSettings.enableVirtualization)
							rowIndex = $(this._gridRows).eq(row);
                        rowIndex = rowIndex || this.getRowByIndex(trIndex);
                        if (rowIndex.hasClass("e-virtualrow") || ej.isNullOrUndefined(this._currentJsonData[row] || viewData))
                            break;
						var rowData = this.model.scrollSettings.enableVirtualization ? viewData : this._currentJsonData[row];
                        this._rowEventTrigger(rowIndex, rowData);                       
                    }
                }
            }
        },
        _rowEventTrigger: function (row, data) {
            var args = { row: row, data: data, rowData: data };
            this._trigger("rowDataBound", args);
            var tdCells = row.cells;
            var $tdRowcells = $(row).find(".e-rowcell");
            if (this.model.queryCellInfo != null || this.model.mergeCellInfo != null || this.model.templateRefresh != null) {
                for (var cellIndex = 0; cellIndex < $tdRowcells.length; cellIndex++) {
                    var args = { cell: $tdRowcells[cellIndex], data: data, rowData: data, text: $tdRowcells[cellIndex].innerHTML };
                    var foreignKeyData = this._getForeignKeyData(args.data);
                    if ($($tdRowcells[cellIndex]).hasClass("e-rowcell"))
                        args.column = this.model.columns[cellIndex];
                    if (!ej.isNullOrUndefined(foreignKeyData))
                        args.foreignKeyData = foreignKeyData;
                    if (this.model.allowCellMerging == true) {
                        this._cellMerging(args);
                        this._trigger("mergeCellInfo", args);
                    }
                    this._trigger("queryCellInfo", args);
                    if ($($tdRowcells[cellIndex]).hasClass("e-templatecell")) {
                        var args = { cell: $tdRowcells[cellIndex], column: this.model.columns[cellIndex], data: data, rowData: data, rowIndex: $(row).index() };
                        this._trigger("templateRefresh", args);
                    }
                }
            }

        },

        setWidthToColumns: function () {
            var $cols1 = this.getContentTable().children("colgroup").find("col");
            var $cols2 = this.getHeaderTable().children("colgroup").find("col");
            var extendWidth = 0, colsIndex = [], columnsWidth;
            var undefinedColsCollection = [], hCellIndex;
            var width = this.element.width(), frozenWidth = 0, columnsTotalWidth = 0, finalWidth = 0, browserDetails = !ej.isIOSWebView() && this.getBrowserDetails();
            if (this.model.groupSettings.groupedColumns.length && !this.model.allowScrolling && this.model.groupSettings.showGroupedColumn) {
                if (browserDetails && browserDetails.browser == "msie" && parseInt(browserDetails.version, 10) > 8)
                    $cols1.first().css("width", ((30 / width) * 100) + "%");
            }
            if (!ej.isNullOrUndefined(this.model.detailsTemplate)) {
                var headerIndx = this.model.groupSettings.groupedColumns.length;
                var contentIndx = this.model.groupSettings.groupedColumns.length != 0 ? 1 : 0;
                $cols1.eq(contentIndx).css("width", this._detailsOuterWidth);
                $cols2.eq(headerIndx).css("width", this._detailsOuterWidth);
            }
            this._detailColsRefresh();
            $cols1 = this._$headerCols;
            $cols2 = this._$contentCols;
            if (this.model.allowResizeToFit) {
                var visibleColumnsWidth = 0; var undefinedWidthColumnsCount = 0;
                for (j = 0; j < this.model.columns.length; j++) {
                    if (this.model.columns[j].visible) {
                        if (this.model.columns[j]["width"] != undefined)
                            visibleColumnsWidth = visibleColumnsWidth + parseInt(this.model.columns[j]["width"]);
                        else
                            undefinedWidthColumnsCount = undefinedWidthColumnsCount + 1;
                    }
                }
            }
            for (var i = 0; i < $cols2.length; i++) {
                if (this.model.allowResizeToFit && this.model.columns[i]["width"] === undefined) {
                    hCellIndex = this.model.groupSettings.groupedColumns.length ? (i + this.model.groupSettings.groupedColumns.length) : i;
                    var contentWidth = this._resizer._getContentWidth(i);
                    var cellDiv = this.getHeaderTable().find('.e-headercelldiv').eq(hCellIndex);
                    var headerWidth = this._resizer._getHeaderContentWidth(cellDiv);
                    if (this.model.editSettings.editMode == "normal" && (this.model.isEdit || this._isAddNew))
                        finalWidth = browserDetails.browser == "firefox" ? parseInt($cols1[i].style.width, 10) : $cols1.eq(i).width();
                    else if (undefinedWidthColumnsCount > 0) {
                        columnsWidth = finalWidth = this.model.columns[i].visible ? parseInt(this.element.width() - visibleColumnsWidth) / undefinedWidthColumnsCount : 0;
                    }
                    if ((finalWidth < contentWidth && finalWidth < headerWidth) && undefinedWidthColumnsCount > 0) {
                        finalWidth = contentWidth > headerWidth ? contentWidth : headerWidth;
                        finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                        visibleColumnsWidth += finalWidth;                       
                        undefinedWidthColumnsCount -= 1;
                        this.columnsWidthCollection[i] = finalWidth;
                        columnsTotalWidth += this.model.columns[i].visible ? finalWidth : 0;
                        extendWidth += finalWidth - columnsWidth;
                    }
                    else if (undefinedWidthColumnsCount > 0 && (contentWidth > 0 || (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0))) {
                        var cWidth = contentWidth > headerWidth ? contentWidth : headerWidth;
                        if (this._dataSource() == null || this._dataSource().length == 0 || this.model.currentViewData.length == 0) {
                            if (cWidth > finalWidth) {
                                finalWidth = cWidth;
                                finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                            }
                        }
                        else {
                            if (cWidth > finalWidth || (this.element.width() / undefinedWidthColumnsCount < visibleColumnsWidth-finalWidth && !this.model.allowTextWrap)) {
                                finalWidth = cWidth;
                                finalWidth += parseInt(cellDiv.css("padding-left"), 10) + parseInt(cellDiv.css("padding-right"), 10);
                            }
                        }
                        if (this.model.columns[i].visible) {
                            visibleColumnsWidth += finalWidth;
                            undefinedWidthColumnsCount -= 1;
                        }
                        if(columnsWidth < contentWidth || columnsWidth < headerWidth) {
                            extendWidth += finalWidth - columnsWidth;
                        }
                        else
                            colsIndex.push({ index : i, contentWidth : contentWidth, headerWidth : headerWidth });
                        this.columnsWidthCollection[i] = finalWidth;
                        columnsTotalWidth += this.model.columns[i].visible ? finalWidth : 0;
                    }
                } else {
                    if (typeof (this.model.columns[i].width) == "string" && this.model.columns[i].width.indexOf("%") != -1)
                        var columnWidth = (parseInt(this.model.columns[i]["width"]) / 100 * this.element.width());
                    else
                        var columnWidth = parseInt(this.model.columns[i]["width"], 10);
                    columnsTotalWidth += this.model.columns[i].visible ? columnWidth : 0;
                }
                if (this.model.columns[i]["priority"])
                    $cols2.eq(i).addClass("e-table-priority-" + this.model.columns[i]["priority"]);
                if (!ej.isNullOrUndefined(this.columnsWidthCollection[i])) {
                    $cols1.eq(i).width(this.columnsWidthCollection[i]);
                    $cols2.eq(i).width(this.columnsWidthCollection[i]);
                } else if (this.model.allowScrolling) {
                    undefinedColsCollection.push(this.model.columns[i]);
                }
            }
            var colsIndexLength = colsIndex.length;
             for (var i = 0; i < colsIndexLength; i++) { 
                extendWidth = extendWidth / colsIndexLength;
                if(this.columnsWidthCollection[colsIndex[i]["index"]] > extendWidth) {      
                  if(this.columnsWidthCollection[colsIndex[i]["index"]] - extendWidth > colsIndex[i]["headerWidth"] && this.columnsWidthCollection[colsIndex[i]["index"]] - extendWidth > colsIndex[i]["contentWidth"] ) {        
                    $cols1.eq(colsIndex[i]["index"]).width(this.columnsWidthCollection[colsIndex[i]["index"]] - extendWidth);
                    $cols2.eq(colsIndex[i]["index"]).width(this.columnsWidthCollection[colsIndex[i]["index"]]- extendWidth);
                  }
                  else {
                      if(colsIndex[i]["headerWidth"] > colsIndex[i]["contentWidth"]) {
                        $cols1.eq(colsIndex[i]["index"]).width(colsIndex[i]["headerWidth"]);
                        $cols2.eq(colsIndex[i]["index"]).width(colsIndex[i]["headerWidth"]);
                    }
                    else {
                        $cols1.eq(colsIndex[i]["index"]).width(colsIndex[i]["contentWidth"]);
                        $cols2.eq(colsIndex[i]["index"]).width(colsIndex[i]["contentWidth"]);
                    }
                  }                  
                }
                else {
                     if(colsIndex[i]["headerWidth"] > colsIndex[i]["contentWidth"]) {
                        $cols1.eq(colsIndex[i]["index"]).width(colsIndex[i]["headerWidth"]);
                        $cols2.eq(colsIndex[i]["index"]).width(colsIndex[i]["headerWidth"]);
                    }
                    else {
                        $cols1.eq(colsIndex[i]["index"]).width(colsIndex[i]["contentWidth"]);
                        $cols2.eq(colsIndex[i]["index"]).width(colsIndex[i]["contentWidth"]);
                    }
                }
                this.columnsWidthCollection[colsIndex[i]["index"]] = $cols1.eq(colsIndex[i]["index"]).width();
            }
            var hiddenColLength = undefinedColsCollection.filter(function (e) { return !e.visible }).length;
            var headercell = this.getHeaderTable().find("thead").find(".e-headercell").not(".e-detailheadercell,.e-stackedHeaderCell");
            var totalColWidth = ej.sum(this.columnsWidthCollection);
            for (var i = 0; i < undefinedColsCollection.length; i++) {
                if (!undefinedColsCollection[i].visible)
                    continue;
                var colIndex = ej.isNullOrUndefined(undefinedColsCollection[i].field) ? this.getColumnIndexByField(undefinedColsCollection[i].field) : this.getColumnIndexByHeaderText(undefinedColsCollection[i].headerText);
                var cell = headercell.eq(colIndex)[0];
                var colWidth;
                if (!ej.isNullOrUndefined(this.model.commonWidth))
                    colWidth = this.model.commonWidth;
                else {
                    var gridWidth = typeof (this.model.scrollSettings.width) == "string" ? this.element.width() : this.model.scrollSettings.width || this.model.width;
                    var cellWidth = (gridWidth - totalColWidth) / (undefinedColsCollection.length - hiddenColLength);
                    colWidth = !this.model.scrollSettings.frozenColumns ? cell.getBoundingClientRect().width : cellWidth;
                }
                if (ej.isNullOrUndefined(colWidth))
                    colWidth = cell.offsetWidth;
                if (parseInt(colWidth) < 15) {
                    colWidth = (width / this.model.columns.length).toFixed(2);
                    var bSize = (width / (this.model.scrollSettings.buttonSize || 18) / 100).toFixed(2);
                    colWidth = colWidth - bSize;
                }
                $cols1.eq(colIndex).css("width", colWidth + "px");
                $cols2.eq(colIndex).css("width", colWidth + "px");
                this.model.columns[colIndex].width = colWidth;
                this.columnsWidthCollection[colIndex] = parseFloat(colWidth);
            }
            if (!hiddenColLength)
                this._undefinedColsCollection = null;
            if (this.model.columnLayout == "fixed") {
                if (this.model.scrollSettings && this.model.scrollSettings.frozenColumns == 0) {
                    this.getHeaderTable().width(columnsTotalWidth);
					this.getContentTable().width(columnsTotalWidth);
					if(!ej.isNullOrUndefined(this.getFooterTable()))
                        this.getFooterTable().width(columnsTotalWidth);
                }
                var headerTableWidth = this.model.scrollSettings.frozenColumns > 0 ? this.getHeaderTable().eq(0).width() + this.getHeaderTable().eq(1).width() : this.getHeaderTable().width();
                var operation = this.getHeaderContent().width() > headerTableWidth ? 'addClass' : 'removeClass';
                var headerTable = this.getHeaderTable();
                var contentTable = this.getContentTable();
                if (this.model.scrollSettings.frozenColumns > 0) {
                    headerTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getHeaderTable().eq(1) : this.getHeaderTable().eq(0);
                    contentTable = this.getVisibleColumnNames().length <= this.model.scrollSettings.frozenColumns ? this.getContentTable().eq(1) : this.getContentTable().eq(0);
                }
                headerTable[operation]('e-tableLastCell');
                contentTable[operation]('e-tableLastCell');
            }
            if (!this.model.allowScrolling && this.model.allowResizeToFit && ej.isNullOrUndefined(this.model._isPrinting) && !this.model.isResponsive && columnsTotalWidth > width) {
                this.model.allowScrolling = true;
                this.model.scrollSettings.width = width;
                this.getHeaderTable().parent().addClass("e-headercontent");
                this._renderScroller();
                if (!this.model.scrollSettings.frozenColumns > 0)
                    this.getHeaderTable().width(width);
            }
            if (this.model.isEdit) {
                var clonedCol = $cols1.clone();
                var editedTr;
                if (this.model.editSettings.showAddNewRow)
                    editedTr = this.getContentTable().find(".e-editedrow");
                var $colGroup = this.model.scrollSettings.frozenColumns > 0 ? this.getContent().find(".gridform").find("colgroup") : !ej.isNullOrUndefined(editedTr) && editedTr.length == 1 ? editedTr.find("colgroup") : $("#" + this._id + "EditForm").find("colgroup");
                this.model.scrollSettings.frozenColumns > 0 && $colGroup.first().empty().append(clonedCol.splice(0, this.model.scrollSettings.frozenColumns));
                $colGroup.last().empty().append(clonedCol);
                if (this.model.detailsTemplate != null || this.model.childGrid != null)
                    $colGroup.prepend(this._getIndentCol());
            }
            if (this.model.groupSettings.groupedColumns.length) {
                var $grouedColGroup = this.getContentTable().find(".e-recordtable").children("colgroup");
                for (var i = 0; i < $grouedColGroup.length; i++) {
                    var clonedCol = $cols1.clone();
                    var detailsWidth = this._detailsOuterWidth != null ? this._detailsOuterWidth : "30px";
                    if (this.model.detailsTemplate != null || this.model.childGrid != null) clonedCol.splice(0, 0, $(this._getIndentCol()).width(detailsWidth)[0]);
                    $grouedColGroup.eq(i).empty().append(clonedCol);
                }
            }
            if (this.model.scrollSettings.frozenColumns > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.model.columns.length; i++) {
                    totalWidth += this.model.columns[i].visible ? parseInt(this.columnsWidthCollection[i], 10) : 0;
                    if (this.model.scrollSettings.frozenColumns - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this.element.width(this.model.scrollSettings.width || this.model.width);
                var gridContentWidth = this.element.find(".e-gridcontent").children().first().width();
                if (gridContentWidth > totalWidth)
                    totalWidth = gridContentWidth + ((this.getContentTable().height() < this.model.scrollSettings.height && this.getScrollObject()._vScroll) ? this.model.scrollSettings.buttonSize : 0);
                else
                    totalWidth += ((this.getContentTable().height() > this.model.scrollSettings.height) ? this.model.scrollSettings.buttonSize : 0);
                if (totalWidth < this.element.width()) {
                    totalWidth = "100%";
                }
                var finalcolWidth = typeof (totalWidth) == "string" && totalWidth.indexOf("%") != -1 ? totalWidth : totalWidth - frozenWidth;
                this.getContent().find(".e-frozencontentdiv").outerWidth(frozenWidth)
                    .end().find(".e-movablecontentdiv").outerWidth(finalcolWidth);
                this.getHeaderContent().find(".e-frozenheaderdiv").outerWidth(frozenWidth)
                    .end().find(".e-movableheaderdiv").outerWidth(finalcolWidth);
                if(this.getFooterContent())
                this.getFooterContent().find(".e-frozenfooterdiv").outerWidth(frozenWidth)
                    .end().find(".e-movablefooterdiv").outerWidth(finalcolWidth);
            }
           if(!this.initialRender && this.model.allowResizeToFit && this.model.allowScrolling && this.model.scrollSettings.enableVirtualization ){			
				var width = this.getHeaderTable().width() >this.getContentTable().width()?this.getHeaderTable().width() : this.getContentTable().width();
                this.getContentTable().width(width);
				this.getHeaderTable().width(width);
				if(!ej.isNullOrUndefined(this.getFooterTable()))
                    this.getFooterTable().width(width);
			}
        },
        _initialEndRendering: function () {
            // use this method to add behaviour after grid render.
            if (this.model.allowRowDragAndDrop)
                this._rowsDragAndDrop();
            if (this.model.editSettings.allowEditing || this.model.editSettings.allowAdding) {
                if (this.model.editSettings.editMode == "dialog" || this.model.editSettings.editMode == "dialogtemplate")
                    this.element.append(this._renderDialog());
                else if (this.model.editSettings.editMode == "externalform" || this.model.editSettings.editMode == "externalformtemplate")
                    this.element.append(this._renderExternalForm());
            }
            
            (this.model.editSettings.editMode == "batch" || this.model.editSettings.showDeleteConfirmDialog) && this._renderConfirmDialog();
            (this.model.scrollSettings.frozenColumns > 0 || this.model.scrollSettings.frozenRows > 0) && $("#" + this._id + 'AlertDialog').length == 0 && this._renderAlertDialog();
            if (this.model.allowMultiSorting || this.model.selectionType == "multiple")
                this._renderMultiTouchDialog();
            if (this.model.scrollSettings.frozenColumns > 0 && !this.model.allowScrolling) {
                this.getContent().remove();
                this.getHeaderTable().eq(1).remove();
                this._alertDialog.find(".e-content").text(this.localizedLabels.FrozenColumnsScrollAlert);
                this._alertDialog.ejDialog("open");
                return;
            }
            this.model.scrollSettings.allowVirtualScrolling && !this.model.scrollSettings.enableVirtualization && this._createPagerStatusBar();
            this._getRowHeights();
            if (this.element.width() != 0 && this.model.allowScrolling) {
                this._renderScroller();
                if (!(this.model.scrollSettings.frozenRows > 0 || this.model.scrollSettings.frozenColumns > 0)) {
                    this.setWidthToColumns();
                    var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
                    scrollObj != null && scrollObj.refresh();
                    this.refreshScrollerEvent();
                    this._scrollFooterColgroup(true);
                }
            }
            else if ((this.model.allowScrolling || (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length)) && this.element.width() <= 0) {
                var proxy = this, myVar = setInterval(function () {
                    if (!ej.isNullOrUndefined(proxy.element) && proxy.element.width() > 0 && !ej.isNullOrUndefined(proxy.element.width())) {
                        if (proxy.model.allowScrolling) {
                            proxy._renderScroller();
                            if (!(proxy.model.scrollSettings.frozenRows > 0 || proxy.model.scrollSettings.frozenColumns > 0)) {
                                proxy.setWidthToColumns();
                                var scrollObj = !ej.isNullOrUndefined(proxy.getContent().data("ejScroller")) ? proxy.getScrollObject() : null;
                                scrollObj != null && scrollObj.refresh();
                                proxy._addLastRow();
                                proxy.refreshScrollerEvent();
                            }
                        }
                        if (proxy.model.allowGrouping && proxy.model.groupSettings.groupedColumns.length && proxy.getHeaderTable().find(".e-grouptopleftcell").width() <= 0)
                            proxy.getHeaderTable().find(".e-grouptopleftcell").css('width', proxy.getHeaderTable().find('colgroup col').eq(0).width());
                        proxy._endRendering();
                        clearInterval(myVar);
                    }
                }, 100);
                return;
            }
           this._endRendering();
        },

        _scrollFooterColgroup: function (initialfooter) {
            if(ej.isNullOrUndefined(initialfooter))
            {
				if (this.model.scrollSettings.frozenColumns > 0 && !this.getFooterTable().find("colgroup").length) 
                {
                    this.getFooterTable().eq(0).append(this.getHeaderTable().eq(0).find("colgroup").clone());
                    this.getFooterTable().eq(1).append(this.getHeaderTable().eq(1).find("colgroup").clone());
                }
                if(!this.getFooterTable().find("colgroup").length)
                    this.getFooterTable().append(this.getHeaderTable().find("colgroup").clone());
                else
                    this.getFooterTable().find("colgroup").first().replaceWith(this.getHeaderTable().find("colgroup").clone());                
            }
            var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
            if(scrollObj && scrollObj.isVScroll() && !ej.isNullOrUndefined(this.getFooterContent()))
            {
                this.getFooterContent().find("colgroup").append("<col style='width : " + this.model.scrollSettings.scrollerSize + "px'></col>");
                if(!this.getFooterContent().find("tr.e-gridSummaryRows td.e-scrollindent").length)
                this.getFooterContent().find("tr.e-gridSummaryRows").append("<td class='e-scrollindent'></td>");
            }
        },

        _endRendering: function () {
            if (!ej.isNullOrUndefined(this.model.serverProperties)) {
                var chkIndexes = this.model.serverProperties._checkSelectedRowsIndexes;
                this.checkSelectedRowsIndexes = chkIndexes && chkIndexes.length ? chkIndexes : this.checkSelectedRowsIndexes;
            }
            if (!ej.isNullOrUndefined(this.getContent().data("ejScroller")) && this.model.allowScrolling)
                var scroller = this.getScrollObject();
            var css = this.model.enableRTL ? "e-summaryscroll e-rtl" : "e-summaryscroll";
            if (this.model.allowScrolling && this.model.showSummary) {
                if(scroller._vScroll)
                    this.element.find(".e-summaryrow.e-scroller").addClass(css);
                this.getFooterTable() && this._scrollFooterColgroup();
            }
            this._addMedia();
            if(this.model.allowScrolling && this.model.allowTextWrap && !this.model.scrollSettings.allowVirtualScrolling) this.getContent().first().ejScroller("refresh");
            if (this.model.scrollSettings.allowVirtualScrolling) {
                this._currentPage(1);
                if (this._currentPage() == 1 && !this.model.scrollSettings.enableVirtualization)
                    this._virtualLoadedRecords[this._currentPage()] = this._currentJsonData;
                if(this.model.scrollSettings.enableVirtualization)
                    this._refreshVirtualView();				
                else
                    this._refreshVirtualContent(this._currentPage());
                this.getContent().first().ejScroller("refresh");
                if (this.getContent().ejScroller("isVScroll")) {
                    this.element.find(".e-gridheader").addClass("e-scrollcss");
                    this.getHeaderTable().first().width(this.getContentTable().width());
                }
                else
                    this.element.find(".e-gridheader").removeClass("e-scrollcss");
            }
            if (this.model.allowSelection == true && this.model.selectionType == "multiple" && this._selectedMultipleRows().length > 0)
                this._selectingMultipleRows(this._selectedMultipleRows());
            if (this._selectedRow() != -1 || this._selectedMultipleRows().length == 1) {
                var row = this._selectedMultipleRows();
                var indexes = row.length ? row : this._selectedRow();
                this.selectRows(indexes);
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar" && !this.model.allowPaging && !this.model.scrollSettings.allowVirtualScrolling)
                this._createPagerStatusBar();
            if (ej.gridFeatures.common)
                this.rowHeightRefresh()
            if (ej.gridFeatures.filter && ["menu", "excel"].indexOf(this.model.filterSettings.filterType) != -1)
                this._refreshFilterIcon();
            if (this.model.allowGrouping && this.model.groupSettings.groupedColumns.length != 0)
                this._recalculateIndentWidth();
            if (this.initialRender && (!this.model.scrollSettings.enableVirtualization || this._gridRows.length < this._virtualRowCount))
                this._addLastRow();
        },

        _addLastRow: function () {
            var lastRowtd = this.getContentTable().find("tr:last").find("td"), rowHeight = 0;

            if (this.model.allowScrolling && !this.model.scrollSettings.allowVirtualScrolling && !ej.isNullOrUndefined(this.model.dataSource) && !ej.isNullOrUndefined(this.getRows())) {
                for (var i = 0; i < this.getRows().length; i++)
                    rowHeight += $(this.getRows()[i]).height();

                if (rowHeight < this.getContent().height() - 1)
                    lastRowtd.addClass("e-lastrowcell");
            }
            if(this.model.scrollSettings.allowVirtualScrolling && this.getContentTable().height() < this.getContent().height())
                lastRowtd.addClass("e-lastrowcell");
        },
        _addMedia: function () {
            if (!this.model.enablePersistence && typeof (this.model.scrollSettings.width) != "string" && this.model.scrollSettings.width > 0) {
                this._responsiveScrollWidth = this._originalScrollWidth = this.model.scrollSettings.width;
            }
            else
                this._originalScrollWidth = this.element.width();
            if (typeof (this.model.scrollSettings.height) != "string" && this.model.scrollSettings.height > 0)
                this._responsiveScrollHiehgt = this.model.scrollSettings.height;
            if (this.model.minWidth && this.model.isResponsive) {
                this._$onresize = $.proxy(this.windowonresize, this);
                $(window).on("resize", this._$onresize);
                if ($.isFunction(window.matchMedia)) {
                    var mediaFilterObj = window.matchMedia("(max-width: 768px)");
                    this._mediaStatus = mediaFilterObj.matches;
                }
                this.windowonresize();
            }
        },
        _getNoncontentHeight: function () {   
            var height = 0;
            if (!ej.isNullOrUndefined(this.getHeaderContent().outerHeight()))
                height += this.getHeaderContent().outerHeight();
            if (this.model.toolbarSettings.showToolbar && !ej.isNullOrUndefined(this.element.find('.e-gridtoolbar').outerHeight()))
                height += this.element.find('.e-gridtoolbar').outerHeight();
            if (this.model.allowPaging && !ej.isNullOrUndefined(this.element.find('.e-pager').outerHeight()))
                height += this.element.find('.e-pager').outerHeight();
            if (this.model.showColumnChooser && !ej.isNullOrUndefined(this.element.find(".e-ccButton").outerHeight()))
                height += this.element.find(".e-ccButton").outerHeight();
            if (this.model.allowGrouping && this.model.groupSettings.showDropArea && !ej.isNullOrUndefined(this.element.find('.e-groupdroparea').outerHeight()))
                height += this.element.find('.e-groupdroparea').outerHeight();
            if (this.model.showSummary && !ej.isNullOrUndefined(this.element.find('.e-gridsummary').outerHeight()))
                height += this.element.find('.e-gridsummary').outerHeight();
            return height;
        },
        
        setDimension: function (height, width) {
            var originalHeight = height - this._getNoncontentHeight();
            this.model.scrollSettings.height = originalHeight;
            this.model.scrollSettings.width = width;
            this._renderScroller();
        },
		_getVisibleColumnsWidth: function(){
			var i,gridColsWidth=0;
			for(i=0; i<this.columnsWidthCollection.length; i++){
				if(this.model.columns[i].visible)
					gridColsWidth += this.columnsWidthCollection[i];
			}
			return gridColsWidth;
		},
		setPhoneModeMaxWidth: function (value) {
		    this._gridPhoneMode = value;
		},
        _mediaQueryUpdate: function (isScroller, elemHeight, width, winHeight) {
            if (window.innerWidth <= this._gridPhoneMode && this.model.enableResponsiveRow) {
                var contentStyle=this.getContentTable()[0].style;
               if(contentStyle.removeAttribute)
                   contentStyle.removeAttribute('min-width');
               else        
                   contentStyle.removeProperty('min-width');
                var scrollObj = this.getContent().data('ejScroller');
                if (scrollObj)
                    this.getContent().ejScroller('destroy');
                return;
            }
            var scrollObj = !ej.isNullOrUndefined(this.getContent().data("ejScroller")) ? this.getScrollObject() : null;
            if (isScroller) {
                this.model.scrollSettings.width = ej.isNullOrUndefined(this._responsiveScrollWidth) ? width : Math.min(this._responsiveScrollWidth, width);
                var height = Math.min(winHeight, elemHeight) - this._getNoncontentHeight();
                height = ej.isNullOrUndefined(this._responsiveScrollHiehgt) ? height : Math.min(this._responsiveScrollHiehgt, height);
                if(((this.element.parent().is("body") && $(document).height() > height) ||(height > this.element.parent().height())) && this.model.scrollSettings.height != "auto")
					height -= parseInt(this.element.parent().css('margin-bottom')+1);
				height = this.model.scrollSettings.height != "auto" ? height : this.model.scrollSettings.height;
				if ((this.model.minWidth > width || this.getContentTable().width() > width) && elemHeight > winHeight)
                    height = height != "auto" ? height + this.model.scrollSettings.buttonSize : height ;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                this.model.scrollSettings.height = this._isHeightResponsive ? height : this._initHeight ? this._initHeight : this.getContentTable()[0].scrollHeight;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
            }
            else {
                this.model.scrollSettings.width = '100%';
                if (!ej.isNullOrUndefined(this._responsiveScrollWidth))
                    this.model.scrollSettings.width = Math.min(this._responsiveScrollWidth, width);
                var modifyHeight = Math.min(winHeight, elemHeight);
                var height = modifyHeight - this._getNoncontentHeight();
                if (!ej.isNullOrUndefined(this._responsiveScrollHiehgt))
                    height = Math.min(this._responsiveScrollHiehgt, height);
                if(((this.element.parent().is("body") && $(document).height() > height) ||(height > this.element.parent().height())) && this.model.scrollSettings.height != "auto")
					height -= parseInt(this.element.parent().css('margin-bottom'));
				height = this.model.scrollSettings.height != "auto" ? height : this.model.scrollSettings.height;
				if (!ej.isNullOrUndefined(this._responsiveScrollWidth) && this.model.scrollSettings.width == this._responsiveScrollWidth && (this.model.minWidth > this._responsiveScrollWidth || this._getVisibleColumnsWidth() > this._responsiveScrollWidth) || (ej.isNullOrUndefined(this._responsiveScrollWidth) && (this.getRowHeight() == height || this._isHeightResponsive) && this.getContentTable().width() > width))
                   height = height != "auto" ? height + this.model.scrollSettings.buttonSize : height;
                if (ej.isNullOrUndefined(this.getRows()))
                    height = '100%';
                if (this.getContent().height() >= height && !this._resize && !this.initialRender && typeof(this.model.scrollSettings.width) == "string")
                    this.model.scrollSettings.width = width;
                this.model.scrollSettings.height = this._isHeightResponsive ? height : this._initHeight ? this._initHeight : this.getContentTable()[0].scrollHeight;
                this.element.find(".e-gridheader").first().find("div").first().addClass("e-headercontent");
            }
            if (scrollObj != null)
                scrollObj.refresh();
            this._renderScroller();
            this._resize = false;
        },
        windowonresize: function (e) {
            if (!this.element.is(":visible")) {
                var proxy = this;
                proxy._isVisible = true;
                var testVar = setInterval(function () {
                    if (!ej.isNullOrUndefined(proxy.element) && proxy.element.is(":visible") && proxy._isVisible) {
                        proxy.windowonresize();
                        proxy._isVisible = false;
                        clearInterval(testVar);
                    }
                    else if (!ej.isNullOrUndefined(proxy.element))
                        clearInterval(testVar);
                }, 100);
                return;
            }
            if (e && e.type == "resize")
                this._resize = true;
            this.model.scrollSettings.width = this._responsiveScrollWidth;
            var width, height;
            this.element.css("width", '100%');
            this.getContentTable().width('100%');
            this.getHeaderTable().width('100%');
            if(!ej.isNullOrUndefined(this.getFooterTable()))
                this.getFooterTable().width('100%');
            this.getContentTable().css('minWidth', this.model.minWidth);
            if (this._isHeightResponsive) {
                this.getContent().height("100%");
                this.getContent().find(".e-content").height('100%');
            }
            if (this.getBrowserDetails().browser == "msie")
                this.getHeaderTable().css("min-width", this.model.minWidth);
            width = Math.round(this.element.width());
            var winHeight = $(window).height() - this.element.offset()['top'];
            var rowCount = !ej.isNullOrUndefined(this.getRows()) ? this.getRows().length : 1;
            var isBody = this.element.parent().is($('body')) || this.element.parent().height() == $('body').height() || (["", "auto"].indexOf(this.element.parent()[0].style.height) != -1);
            var originalElemHeight=this.getContentTable()[0].scrollHeight + this._getNoncontentHeight();
            var elemHeight = isBody ? winHeight : this.element.parent().height();
            originalElemHeight += parseInt(this.element.parent().css('margin-top'));
            var isScroller = this.model.minWidth > width || elemHeight <= originalElemHeight;
            this._mediaQueryUpdate(isScroller, elemHeight, width, originalElemHeight)
        },
        _removeMedia: function () {
            $(window).off("resize", this._$onresize);
            this.getContentTable().css("min-width", "");
            this.getHeaderTable().css("min-width", "");
            this.getContentTable().css("width", "");
            this.model.scrollSettings.width = "auto";
            if (this.getContent().data("ejScroller"))
                this.getContent().ejScroller("destroy");
        },
        _getRowHeights: function () {
            var trs = this.getRows(), frotrs = [], movtrs = [];
            if (trs !== null) {
                this._rowHeightCollection = [];
                if (trs[1] !== undefined && trs[1].length && ((this.model.scrollSettings.frozenColumns > 0 && trs[0] !== undefined) || (trs[0] !== undefined && typeof trs[0].item !== "undefined" && typeof trs[0].length == "number" && typeof trs[1].item !== "undefined" && typeof trs[1].length == "number"))) {
                    frotrs = trs[0];
                    movtrs = trs[1];
                    for (var i = 0 ; i < frotrs.length ; i++) {
                        this._rowHeightCollection[i] = frotrs[i].offsetTop >= movtrs[i].offsetTop ? frotrs[i].offsetTop : movtrs[i].offsetTop;
                    }
                }
                else {
                    for (var i = 0 ; i < trs.length ; i++) {
                        this._rowHeightCollection[i] = trs[i].offsetTop;
                    }
                }
            }
            return this._rowHeightCollection;
        },
        _getEmptyTbody: function () {
            var $emptyTd = ej.buildTag('td.emptyrecord', this.localizedLabels.EmptyRecord, {}, { colSpan: (this.model.columns.length- this._hiddenColumns.length)});
            return $(document.createElement("tr")).append($emptyTd);
        },
        _getIndentCol: function () {
            return ej.buildTag("col", "", { width: "30px" });
        },
        _createSortElement: function () {
            return ej.buildTag('span.e-icon', "&nbsp;");
        },
        _createSortNumber: function (number, header) {
            if (header.css("text-align") == "right")
            return ej.buildTag('span.e-number', number, { "color": "white", "font-size": "9px", "text-align": "center", "float": "left" });
            else
            return ej.buildTag('span.e-number', number, { "color": "white", "font-size": "9px", "text-align": "center", "float": "right" });
        },
        _onFocusIn: function (e) {
           var proxy=this;
		   setTimeout(function(){proxy.element.removeClass('e-activefocusout')},0);
        },
        _onFocusOut: function (e) {
            var proxy=this;
            setTimeout(function(){
				proxy.element.addClass('e-activefocusout');
            },0)
        },
        _wireEvents: function () {
            this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", this._clickHandler);
            this._on(this.element, ($.isFunction($.fn.tap) && this.model.enableTouch) ? "tap" : "click", ".e-gridheader", this._mouseClickHandler);
            if (this.model.enableFocusout) {
                this._on(this.element, "focusout", this._onFocusOut);
                this._on(this.element, "focusin", this._onFocusIn);
            }
            if (ej.gridFeatures.common) {
				this._on(this.element, ($.isFunction($.fn.doubletap) && this.model.enableTouch) ? "doubletap" : "dblclick", ".e-gridcontent > div:first", this._recorddblClickHandler);
                if (this.model.rightClick)
                    this._on(this.element, "contextmenu", this._rightClickHandler);
                this._on(this.element, "click", ".e-gridcontent", this._recordClick);
                this._enableRowHover();
                if (this.model.enableTouch)
                    this._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._touchGrid, this));
                else
                    this.element.addClass("e-touch");
                this._on(this.element, "mousedown", ".e-gridheader", this._headerMouseDown);
                if (this.model.allowRowDragAndDrop && this.model.selectionType == "multiple")
                    this._on(this.element, "touchstart mousedown", ".e-gridcontent", this._contentMouseDown);
                this._on(this.element, "mouseover mouseleave", ".e-gridheader:first", this._headerHover);
                this._on(this.element, ej.eventType.mouseMove, ".e-gridheader:first", this._headerHover);
                this.model.allowResizeToFit && this._on(this.element, "dblclick", ".e-gridheader", this._headerdblClickHandler);
                if (this.model.allowResizing) {
                    this._on(this.element, ej.eventType.mouseMove,".e-gridheader:first", this._mouseMove);
                    this._on(this.element, "mouseup", this._mouseUp);
                }
                if (this.model.allowKeyboardNavigation) {
                    this.element[0].tabIndex = this.element[0].tabIndex == -1 ? 0 : this.element[0].tabIndex;
                    this.element[0].accessKey = (!ej.isNullOrUndefined(this.element[0].accessKey) && this.element[0].accessKey != "") ? this.element[0].accessKey : "e";
                    this._on(this.element, "keyup", this._keyDownHandler);
                }
            }
            if (ej.gridFeatures.edit) {
                this._enableEditingEvents();
            }
            if (this.model.allowGrouping) {
                this._enableGroupingEvents();
                this._on(this.element, "mouseenter mouseleave", ".e-groupdroparea,.e-groupheadercell", this._dropAreaHover);

            }
            this._enableFilterEvents();
        },
        _enableFilterEvents: function () {
            if (this.model.allowMultiSorting || this.model.selectionType == "multiple" || this.model.allowFiltering)
                this._on($(document), "mousedown", this._docClickHandler);
            if (this.model.allowFiltering) {
                var proxy = this, $target;
                this._off(this.element, "keyup", ".e-filterbar input")._on(this.element, "keyup", ".e-filterbar input", this._filterBarHandler);
                this._on(this.element, "focus click", ".e-filterbar", this._filterBarClose);
            }
        },
        _docClickHandler: function (e) {
            var details = !ej.isIOSWebView() && this.getBrowserDetails(), $target = $(e.target);
            if (this._customPop != null && this.element.find(e.target).length == 0)
                this._customPop.hide();
            if (this.model.allowFiltering) {
                if (this.model.filterSettings.filterType == "menu" || this.model.filterSettings.filterType == "excel") {
                    if (this._$colType && ($(e.target).find(".e-grid.e-dlgcontainer").length > 1 || $(e.target).find(".e-excelfilter").length > 1))
                        if (details && details.browser == "msie")
                            e.target.tagName != "BODY" && (!this.isExcelFilter ? this._closeFilterDlg() : this._excelFilter.closeXFDialog(e));
                        else
                            !this._isExcelFilter ? this._closeFilterDlg() : this._excelFilter.closeXFDialog(e);
                } else if (!$target.hasClass("e-filtertext") && !$target.hasClass("e-cancel"))
                    this.getFilterBar().find(".e-cancel").addClass("e-hide");
            }

        },
        _mouseClickHandler: function (e) {
            var $temp = $(e.target), $target, $cloneCommonQuery = this.commonQuery.clone(), currentColumn;
            if ($temp.closest(".e-grid").length != 0 && $temp.closest(".e-grid").attr("id") !== this._id) return;
            if (this.getHeaderTable().find('.e-columnheader').not('.e-stackedHeaderRow').css('cursor') == "col-resize")
                return;
            if ($(e.target).is(".e-ascending, .e-descending"))
                $target = $(e.target.parentNode);
            else if ($temp.hasClass('e-groupheadercell'))
                $target = $temp.children("div");
            else
                $target = $(e.target);
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this._isExcelFilter)) {
                $.fx.off = true;
                this._closeFDialog();
                $.fx.off = false;
            }
            this.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive").removeClass("e-active");
            if ($target.hasClass("e-headercelldiv") || $target.hasClass("e-headercell") && $.inArray('column', this.model.selectionSettings.selectionMode) == -1 || (!$target.hasClass("e-togglegroupbutton") && $target.closest(".e-headercelldiv").length && $.inArray($target[0].tagName, ["SELECT", "INPUT", "TEXTAREA"]) == -1)
                || ($target.closest(".e-groupheadercell").length && $(e.target).is(".e-ascending, .e-descending"))) {
                if (!this.model.allowSorting || ej.gridFeatures.sort === undefined)
                    return;
                $targetnew = ($target.hasClass("e-headercelldiv") || $target.closest(".e-groupheadercell").length) ? $target : $target.hasClass("e-headercell") ? $target.find(".e-headercelldiv") : $target.closest(".e-headercelldiv");
                var columnName = $targetnew.attr("data-ej-mappingname");
                var columnSortDirection = ej.sortOrder.Ascending;
                this._$prevSElementTarget = this._$curSElementTarget;
                this._$curSElementTarget = $target;
                if ($target.parent().find('span').hasClass("e-ascending"))
                    var columnSortDirection = ej.sortOrder.Descending;
                else
                    var columnSortDirection = ej.sortOrder.Ascending;
                if (e["pointerType"] == "touch" && this._customPop != null && !this._customPop.is(":visible") && this._customPop.find(".e-sortdirect").hasClass("e-spanclicked"))
                    this._customPop.show();
                if (e["pointerType"] == "touch" && this._customPop != null && (this._customPop.find(".e-rowselect").is(":visible") || !this._customPop.find(".e-sortdirect").hasClass("e-spanclicked")) && this.model.allowMultiSorting) {
                    var $offset = $target.offset();
                    this._customPop.removeAttr("style");
                    this._customPop.offset({ left: $offset.left, top: $offset.top - this.getHeaderTable().find(".e-columnheader").height() - $target.height() }).find(".e-sortdirect").show().end()
                        .find(".e-rowselect").hide().end().show();
                }
                if (this.model.allowMultiSorting && (e.ctrlKey || this._enableSortMultiTouch))
                    this.multiSortRequest = true;
                if (e.shiftKey && $.inArray(columnName, this.model.groupSettings.groupedColumns) == -1) {
                    this._removeSortedColumnFromCollection(columnName);
                    this.multiSortRequest = true;
                    columnName = null;
                    this.sortColumn(columnName, columnSortDirection);
                }
                if (!ej.isNullOrUndefined(columnName))
                    this.sortColumn(columnName, columnSortDirection);
            } else if ($target.hasClass("e-togglegroupbutton") && this.model.allowGrouping) {
                var field = $target.parent().children(".e-headercelldiv").attr("data-ej-mappingname");
                $target.hasClass("e-togglegroup") && this.groupColumn(field);
                $target.hasClass("e-toggleungroup") && this.ungroupColumn(field);
            } else if ($target.hasClass("e-filtericon") || $target.hasClass("e-filteredicon") || $target.hasClass('e-responsivefilterColDiv') || $target.parent().hasClass('e-responsivefilterColDiv')) {
                var columnName = $target.parent().find(".e-headercelldiv").attr("data-ej-mappingname") || $target.attr("data-ej-mappingname") || $($target.parent()).attr("data-ej-mappingname");
                this._$prevFieldName = this._$curFieldName, currentColumn = this.getColumnByField(columnName);
                var localXFLabel = { True: this.localizedLabels.True, False: this.localizedLabels.False };
                if (this.model.allowFiltering) {
                    var proxy = this;
                    if (this.model.filterSettings.filterType == "excel" && currentColumn.filterType == "menu" && $.inArray(currentColumn.type, this._menuColTypes) == -1) {
                        this._renderFilters(currentColumn);
                        this._menuColTypes.push(currentColumn.type);
                    }
                    else if (((this.model.filterSettings.filterType == "menu" && currentColumn.filterType == "excel") || (this.model.filterSettings.filterType == "excel" && currentColumn.filterType != "menu")) && $.inArray(currentColumn.type, this._excelColTypes) == -1) {
                        this._renderFilters(currentColumn);
                        this._excelColTypes.push(currentColumn.type);
                    }
                    $.each(this.model.columns, function (indx, col) {
                        if (col.field == columnName) {
                            proxy._$colType = col.type;
                            proxy._$curFieldName = col.field;
                            proxy._$colFormat = col.format;
                            proxy._$filterType = col.filterType;
                            proxy._$colForeignKeyField = col.foreignKeyField ? col.foreignKeyField : col.field;
                            proxy._$colForeignKeyValue = col.foreignKeyValue;
                            proxy._$colDropdownData = col.dataSource;
                        }
                    });
                    if ((this.model.filterSettings.filterType == "menu" && this._$filterType != "excel") || (this.model.filterSettings.filterType == "excel" && this._$filterType == "menu")) {
                        var $id = "#" + this._id + "_" + this._$colType + "Dlg";
                        this._$menuDlgIsOpen = true;
                        if (this._$colType == "string") {
                            if (this._$colForeignKeyValue && this._$colDropdownData)
                                $("#" + this._id + "_acString").ejAutocomplete({ fields: { text: proxy._$colForeignKeyValue, key: proxy._$colForeignKeyField }, dataSource: proxy._$colDropdownData });
                            else
                                $("#" + this._id + "_acString").ejAutocomplete({ fields: { text: proxy._$curFieldName, key: this._getIdField() }, dataSource: this._dataSource() });
                        } else if (this._$colType == "date") {
                            if (this._$colFormat != undefined) {
                                this._$colFormat = this._$colFormat.replace("{0:", "").replace("}", "");
                                $($id).find(".e-datewidget .e-datepicker").ejDatePicker({ dateFormat: this._$colFormat.replace("{0:", "").replace("}", "") });
                            }
                            else
                                $($id).find(".e-datewidget .e-datepicker").ejDatePicker({ dateFormat: ej.preferredCulture(this.model.locale).calendars.standard.patterns.d });
                        }
                        else if (this._$colType == "datetime") {
                            if (this._$colFormat != undefined) {
                                this._$colFormat = this._$colFormat.replace("{0:", "").replace("}", "");
                                $($id).find(".e-datetimewidget input").ejDateTimePicker({ dateFormat: this._$colFormat.replace("{0:", "").replace("}", "") });
                            }
                            this._setFilterFieldValues($id);
                        }
                    }
                    this._mediaStatus = document.documentElement.clientWidth < 768;
                    if (this.model.isResponsive && this._mediaStatus) {
                        var gridObj = this;
                        var $headerDiv = ej.buildTag('div.e-resFilterDialogHeaderDiv');
                        var $titleSapn = ej.buildTag('div.e-labelRes', '<span>Filter</span>');
                        if ($(".e-filterMenuBtn").length > 0)
                            $(".e-filterMenuBtn").remove();
                        var $dlgBtn = ej.buildTag('div.e-filterMenuBtn');
                        var $inputOk = ej.buildTag('input.e-resposnsiveFilterBtnLeft e-flat e-btnsub');
                        var $inputCancel = ej.buildTag('input.e-resposnsiveFilterBtnRight e-flat e-btncan');

                        $headerDiv.append($titleSapn);
                        $headerDiv.css('width', '100%');
                        var $dlgClone = $($id).css('padding-left', '0px');
                        if ($target.parent().hasClass('e-responsivefilterColDiv') && $target.hasClass('e-filternone')) {
                            proxy._fltrClrHandler();
                            $target.remove();
                            $("#responsiveFilter").css('display', 'block');
                            // this.element.css('display', 'block');
                        }
                        else {
                            this.element.css('display', 'none');
                            setTimeout(function () { $("#responsiveFilter").css('display', 'none'), 0 });
                            if (!this._isExcelFilter && this._$filterType != "excel") {
                                var btnText = this.model.enableResponsiveRow ? 'OK' : 'Filter', clearText = this.model.enableResponsiveRow ? 'Cancel' : 'Clear';
                                $inputOk.ejButton({ text: btnText, type: 'button', click: $.proxy(this._fltrBtnHandler, this) });
                                $inputCancel.ejButton({
                                    text: clearText, type: 'button', click: function () {
                                        if (clearText == 'Clear') {
                                            proxy.element.css('display', 'block');
                                            proxy._fltrClrHandler();
                                        }
                                        $($id).css('display', 'none');
                                        if ($inputCancel.hasClass("e-resposnsiveFilterBtnRight"))
                                            proxy.element.css('display', 'block');
                                    }
                                });
                                if ($target.parent().hasClass('e-responsivefilterColDiv') && $target.hasClass('e-filternone')) {
                                    proxy._fltrClrHandler();
                                    $target.remove();
                                }
                                else {
                                    $dlgClone.addClass('e-resMenuFltr');
                                    $dlgClone.css('height', $(window).height() - 1).css('width', $(window).width() - 2);
                                    $dlgClone.find('.e-operator').addClass('e-resFilterOperator');
                                    $dlgClone.find('.e-value').addClass('e-resFilterOperator');
                                    $dlgClone.find('.e-value1').addClass('e-resFilterOperator');
                                    var $btnContainer = $dlgClone.find('.e-dlgBtns').remove().addClass('e-filterMenuBtn');
                                    $dlgClone.append($dlgBtn.append($inputOk).append($inputCancel));
                                    if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                        $dlgClone.insertAfter(this.element);
                                        var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' });
                                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' })
                                        $backIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            if (gridObj.model.enableResponsiveRow)
                                                $("#responsiveFilter").css('display', 'block');
                                            else
                                                gridObj.element.css('display', 'block');
                                        })
                                        $headerDiv.append($backIcon.append($spanIcon));
                                        var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: $id.slice(1), gridEle: true });
                                        var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveClose', '', {}, { closeDialogue: $id.slice(1), gridEle: true })
                                        $closeIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            gridObj.element.css('display', 'block');
                                        });
                                        var $ejWid = $($dlgClone.find('.e-value').find('input:last'));
                                        if (proxy._$colType == 'string') {
                                            var model = $($dlgClone.find('.e-value').find('input:last')).ejAutocomplete('model');
                                            $ejWid.ejAutocomplete('destroy').ejAutocomplete({
                                                enableDistinct: true, dataSource: model.dataSource, fields: model.fields, width: model.width, focusIn: function (args) {
                                                    var $dropdown = this.element.closest(".e-filterDialog").find(".e-dropdownlist");
                                                    this.model.filterType = $dropdown.val();
                                                }
                                            });
                                        }
                                        $headerDiv.append($closeIcon.append($closeSpan));
                                        $dlgClone.prepend($headerDiv);
                                    }
                                    $dlgClone.find('.e-responsiveLabelDiv').remove();
                                    var $label = ej.buildTag('div.e-responsiveLabelDiv', '', { 'margin-left': '5%', 'font-size': '17px', 'margin-top': '5%' }).append(ej.buildTag('span', this.getHeaderTextByFieldName(columnName), { 'font-weight': 'bold' }));
                                    $label.insertAfter($dlgClone.find('.e-resFilterDialogHeaderDiv'));
                                    $dlgClone.fadeIn(100, function () {
                                    });
                                }
                            }
                            else {
                                this._excelDlg = $id = "#" + this._id + this._$colType + "_excelDlg";
                                if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                    $inputOk.ejButton({
                                        text: 'OK', type: 'button', click: function (sender) {
                                            gridObj._responsiveFilterClose();
                                            gridObj._excelFilter._openedFltr = $(gridObj._excelDlg);
                                            gridObj._excelFilter._fltrBtnHandler();
                                            gridObj._setResponsiveFilterIcon();
                                        }
                                    });
                                    $inputCancel.ejButton({ text: 'Cancel', type: 'button', click: function () { $($id).css('display', 'none'); proxy.element.css('display', 'block') } });
                                    $($id).children().not('.e-searchcontainer').remove();
                                    var excelObj = this._excelFilter;
                                    var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' });
                                    var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: $id.slice(1), openDialogue: 'responsiveFilter' })
                                    $backIcon.click(function (e) {
                                        $.proxy(gridObj._closeDivIcon(e), this);
                                    })
                                    $headerDiv.append($backIcon.append($spanIcon));
                                    var $closeIcon = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: $id.slice(1), gridEle: true });
                                    var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveCustomFilter', '', {}, { closeDialogue: $id.slice(1), gridEle: true })
                                    $closeIcon.click(function (e) {
                                        $.proxy(gridObj._closeDivIcon(e), this);
                                    })
                                    if (proxy._$colType != 'boolean')
                                        $headerDiv.append($closeIcon.append($closeSpan));
                                    $($id).css('padding', '0px');
                                    var $searchContainer = $($id).css('height', $(window).height() - 2);
                                    $searchContainer.css('width', $(window).width() - 2);
                                    var $searchBox = $searchContainer.find('.e-searchcontainer .e-searchbox').css('margin-top', '10px');
                                    $searchBox.children().css('margin-top', '10px');
                                    var $checkBoxDiv = $searchContainer.find('.e-checkboxlist');
                                    var scrolWidth = $(window).width() * (97 / 100), scrollHeight = $(window).height() * (65 / 100);
                                    $($searchContainer.find('.e-searchcontainer')).addClass('e-resSearch');
                                    var $btn = $searchContainer.find('.e-resSearch .e-btncontainer').remove();
                                    $btn.find('input:first').css('width', '45.6%');
                                    $btn.find('input:first').addClass('e-resposnsiveFilterBtnLeft');
                                    $btn.find('input:last').addClass('e-resposnsiveFilterBtnRight');
                                    $searchContainer.find('.e-excelLabel').remove();
                                    var $labelDiv = ej.buildTag('div.e-excelLabel', 'Order Id', { 'font-weight': 'bold', 'margin-top': '10px' });
                                    var $searchBox = $searchContainer.find('.e-searchcontainer');
                                    $labelDiv.insertAfter($searchContainer.find('.e-searchcontainer .e-searchbox'));
                                    $searchContainer.prepend($headerDiv);
                                    $($id).append($dlgBtn.append($inputOk).append($inputCancel))
                                    $checkBoxDiv.ejScroller({ height: scrollHeight, width: scrolWidth }).ejScroller('refresh');
                                }
                                this._excelFilter.openXFDialog({ field: columnName, enableResponsiveRow: true, displayName: currentColumn.headerText, dataSource: this._dataSource(), query: $cloneCommonQuery, position: { X: xPos, Y: yPos }, dimension: { height: $(window).height(), width: $(window).width() }, cssClass: "resFilter", type: this._$colType, format: this._$colFormat, localizedStrings: localXFLabel });
                                $($id).insertAfter(this.element);
                                !ej.isNullOrUndefined($($id).parents('.e-grid')[0]) && $($id).remove();
                                $closeIcon.click(function (e) {
                                    $(gridObj._excelDlg).css('display', 'none');
                                    var height = $(window).height() - 5, width = $(window).width();
                                    excelObj._openCustomFilter('equal');
                                    var $dlgClone = $id = $("#" + gridObj._id + gridObj._$colType + "_CustomFDlg").addClass('e-responsviesExcelFilter');
                                    if (ej.isNullOrUndefined($dlgClone.find('.e-resFilterDialogHeaderDiv')[0])) {
                                        var $headerDivCustom = ej.buildTag('div.e-resFilterDialogHeaderDiv');
                                        var $titleSapn = ej.buildTag('div.e-labelRes', '<span>Custom Filter</span>');
                                        $headerDivCustom.append($titleSapn);
                                        var $backIcon = ej.buildTag('div.e-resFilterleftIcon', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", openDialogue: gridObj._excelDlg.slice(1) });
                                        var $spanIcon = ej.buildTag('span.e-icon e-resIcon e-responisveBack', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", openDialogue: gridObj._excelDlg.slice(1) })
                                        $backIcon.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            if (gridObj.model.enableResponsiveRow)
                                                $("#responsiveFilter").css('display', 'block');
                                            else
                                                gridObj.element.css('display', 'block');
                                        });
                                        $headerDivCustom.append($backIcon.append($spanIcon));
                                        var $closeIconCust = ej.buildTag('div.e-resFIlterRigthIcon', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", gridEle: true });
                                        var $closeSpan = ej.buildTag('span.e-icon e-resIcon e-responisveClose', '', {}, { closeDialogue: gridObj._id + gridObj._$colType + "_CustomFDlg", gridEle: true })
                                        $headerDivCustom.append($closeIconCust.append($closeSpan));
                                        $closeIconCust.click(function (e) {
                                            $dlgClone.css('display', 'none');
                                            gridObj.element.css('display', 'block');
                                        })
                                        $dlgClone.prepend($headerDivCustom);
                                        $dlgClone.insertAfter(gridObj.element);
                                        $dlgClone.find('.e-dlgfields').css('width', '100%');
                                        var $firstDiv = $dlgClone.find('.e-dlgfields:first').css('width', '92%').css('margin-left', '6%');
                                        $firstDiv.css('margin-top', '4%');
                                        var colName = $dlgClone.find('.e-dlgfields').find('.e-fieldset legend').text();
                                        var $labelDiv = ej.buildTag('div.e-responsiveLabelDiv', colName, { 'margin-left': '6%' });
                                        $labelDiv.insertAfter($firstDiv);
                                        var $fieldSet = $dlgClone.find('.e-dlgfields').find('.e-fieldset').find('table').css('width', '61%');
                                        $dlgClone.find('.e-dlgfields').find('.e-fieldset').replaceWith($fieldSet);
                                        var $fieldDiv = $fieldSet.parent('div').addClass('e-responsiveExcelFilterFieldDiv');
                                        var $ddl = $fieldSet.find('.e-dropdownlist')
                                        $fieldSet.find('.e-dropdownlist').each(function (index, object) {
                                            var ds = $(object).ejDropDownList('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejDropDownList('destroy').ejDropDownList({ width: wid, popupWidth: wid + "px", dataSource: ds });
                                        });
                                        $fieldSet.find('.e-autocomplete').each(function (index, object) {
                                            var model = $(object).ejAutocomplete('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejAutocomplete('destroy').ejAutocomplete({ width: wid, dataSource: model.dataSource, fields: model.fields });
                                        });
                                        $fieldSet.find('.e-datepicker').each(function (index, object) {
                                            var ds = $(object).ejDatePicker('model.dataSource');
                                            var wid = $(window).width() * (40 / 100);
                                            $(object).ejDatePicker('destroy');
                                            $("#" + $(object).attr("id")).ejDatePicker({ width: wid });
                                        });
                                        var $okClone = $inputOk.clone(), $cancelClone = $inputCancel.clone();
                                        $okClone.ejButton({
                                            text: 'OK', type: 'button', click: function (sender) {
                                                gridObj._excelFilter._openedFltr = $dlgClone;
                                                gridObj._excelFilter._fltrBtnHandler();
                                                if ($dlgClone.hasClass('e-dlgcustom'))
                                                    $dlgClone.css("display","none");
                                                gridObj._setResponsiveFilterIcon();
                                                gridObj.element.css('display', 'block');
                                            }
                                        });
                                        $cancelClone.ejButton({ text: 'Cancel', type: 'button', click: function () { $dlgClone.ejDialog('close'); proxy.element.css('display', 'block') } });
                                        $dlgClone.append($dlgBtn.clone().append($okClone).append($cancelClone))
                                        var $btnContainer = $dlgClone.find('.e-dlgfields .e-btncontainer').remove();
                                        $btnContainer.find('input:first').addClass('e-resposnsiveFilterBtnLeft');
                                        $btnContainer.find('input:first').css('width', '45.6%')
                                        $btnContainer.find('input:last').addClass('e-resposnsiveFilterBtnRight');
                                    }
                                    gridObj.element.css('display', 'none');
                                    $dlgClone.ejDialog({ enableModal: false, height: height, width: width, position: { X: 0, Y: 0 }, enableResize: false, showHeader: false }).ejDialog('open');
                                })
                                var $searchdiv = ej.buildTag('div');
                            }
                        }
                    }
                    else {
                        if ($($id).hasClass("e-resMenuFltr")) {
                            $($id).remove();
                            this._renderFilterDialogs();
                            $id = "#" + this._id + "_" + this._$colType + "Dlg";
                        }
                        $($id).ejDialog({ position: { X: "", Y: "" } });
                        var docWidth = $(document).width(), dlgWidth = document.documentElement.clientWidth < 800 ? 200 : 250, xPos = $target.position().left + (this.model.enableRTL ? -6 : 18), yPos = $target.position().top + 2, gridwidth = $("#" + this._id).width();
                        if ($target.closest(".e-headercell").css("position") == "relative")
                            xPos = $target.offset().left + 15, yPos = $target.offset().top + 20;
                        var filterDlgLargeCss = "e-filterdialoglarge";
                        dlgWidth = this._isExcelFilter && currentColumn.filterType != "menu" && !ej.isNullOrUndefined(this._excelFilter._dialogContainer) ? this._excelFilter._dialogContainer.width() : dlgWidth;
                        var rightPosWidth = (this.element.offset().left + this.element.width()) - $target.offset().left, rightWidth = dlgWidth - rightPosWidth;
                        var leftPosWidth = $target.offset().left - this.element.offset().left, leftWidth = dlgWidth - leftPosWidth;
                        if ($target.offset().left + 18 + dlgWidth > gridwidth && rightWidth > leftWidth)
                            xPos = xPos - dlgWidth - (this.model.enableRTL ? 14 : 10);
                        if (dlgWidth == 200)
                            filterDlgLargeCss = "";
                        if (!ej.isNullOrUndefined(this._$colType)) {
                            if ((this.model.filterSettings.filterType == "menu" && this._$filterType != "excel") || (this.model.filterSettings.filterType == "excel" && this._$filterType == "menu")) {
                                xPos = xPos - $("#" + this._id).offset().left, yPos = yPos - $("#" + this._id).offset().top;
                                $($id).ejDialog({ position: { X: xPos, Y: yPos }, width: dlgWidth, cssClass: filterDlgLargeCss })
                                .ejDialog("open");
                            }
                            else
                                this._excelFilter.openXFDialog({ field: columnName, displayName: currentColumn.headerText, dataSource: this._dataSource(), query: $cloneCommonQuery, position: { X: xPos, Y: yPos }, type: this._$colType, format: currentColumn.format, foreignKey: currentColumn.foreignKeyField, foreignKeyType: currentColumn.originalType, foreignKeyValue: currentColumn.foreignKeyValue, foreignDataSource: currentColumn.dataSource, localizedStrings: localXFLabel });
                        }
                    }
                    this._setFilterFieldValues($id);
                    if (this._$colType == "number" && currentColumn["serverType"] != undefined)
                        $($id).find(".e-numerictextbox").ejNumericTextbox({ width: "100%",decimalPlaces: 0 });
                    else if(this._$colType == "number")
                        $($id).find(".e-numerictextbox").ejNumericTextbox({ width: "100%", decimalPlaces: (/{0:(?:[A-z])+([0-9])?}/.exec(currentColumn.format) || {})[1] | 0 });
                    this._$prevColType = this._$colType;
                    this._$fDlgIsOpen = true;
                }
            }
        },
        _responsiveFilterClose: function () {
            this.element.css('display', 'block');
        },
        _clickHandler: function (e) {
            var $target = $(e.target),tempChooser = $("[id$='ccDiv'].e-grid.e-columnChooser"),fieldName, $form = $("#" + this._id + "EditForm"), index, columnIndex, rowIndex;
			if($(e.target).hasClass('e-checkselectall')  && !this.model.enableTouch){
			    if(e.target.checked)
					this._isCheckboxChecked = true;
				else
					this._isCheckboxUnchecked = true;
			}
			if(tempChooser.length) {
                var  flag = true;
                for(var i = 0; i < tempChooser.length; i++){
                    if($target.parents(".e-ccButton").length|| $target.hasClass('e-ccButton')) flag = $(e.target).closest(".e-grid").attr("id")+"ccDiv" != tempChooser[i].id;
                    var obj = $("#"+tempChooser[i].id).ejDialog("instance");
                    if(obj.isOpened() && flag) {
                        obj.close();
                        $(".e-columnChoosertail").remove();
                        $(".e-columnChoosertailAlt").remove();
                    }
                }
            }
            if ($target.hasClass("e-button") && ($target.hasClass("e-disable") || $target.prop("disabled"))) return;
            if ($target.closest(".e-grid").attr("id") !== this._id) return;
            if ($target.closest("#" + this._id + "EditForm").length){
				if($target.closest(".e-unboundcelldiv").length) this._unboundClickHandler(e);
				return;
			}
            if ($target.hasClass("e-rowcell") || $target.closest("td").is(".e-rowcell") || ($target.hasClass("e-headercell") && ((e.clientY - $target.offset().top) < ($target.height() / 4))) || $target.parents(".e-headercheckcelldiv").length) {
                if (this._bulkEditCellDetails.cancelSave) {
                    this._bulkEditCellDetails.cancelSave = false;
                    return;
                }
                if (this.model.editSettings.editMode == "batch" && ($.isFunction($.validator) && $form.length && $form.validate().errorList.length > 0))
                    return;
                index = $target.closest("tr").hasClass("e-insertedrow") ? this.model.groupSettings.groupedColumns.length : 0;
                var tempIndex = $target.closest(".e-rowcell").index() != -1 ? $target.closest(".e-rowcell").index() : $target.closest(".e-headercell").index() - this.model.groupSettings.groupedColumns.length;
                columnIndex = $target.hasClass("e-rowcell") ? $target.index() - index : tempIndex - index;
                columnIndex = (this.model.detailsTemplate != null || this.model.childGrid != null) ? columnIndex - 1 : columnIndex;
                if (this.model.scrollSettings.frozenColumns && ($target.closest(".e-movableheaderdiv").length || $target.closest(".e-movablecontentdiv").length))
                    columnIndex = columnIndex + this.model.scrollSettings.frozenColumns;
                rowIndex = this.getIndexByRow($target.closest("tr"));
                this._bulkEditCellDetails.columnIndex = columnIndex;
                this._bulkEditCellDetails.rowIndex = rowIndex;
                if (this.model.allowSelection && ej.gridFeatures.selection) {
                    var checkBoxSelection = this._enableCheckSelect && $target.parent(".e-checkcelldiv").length ? true : false;
                    if ($target.hasClass("e-checkselectall")) {
                        this._selectAllCheck = true;
						var rows = this.model.scrollSettings.frozenColumns > 0  ? this._gridRows[0].length : this._gridRows.length;
                        var toCheckIndex =this.model.allowScrolling && this.model.scrollSettings.allowVirtualScrolling ? this._gridRecordsCount:this.model.allowPaging ? this.model.currentViewData.length : rows;
                        this.selectRows(0, toCheckIndex - 1, $target);
                    }
                    if (this.model.selectionType == "multiple") {
                        if (e.ctrlKey || this._enableSelectMultiTouch) {
                            this.multiSelectCtrlRequest = true;
                        }
                        if (e.shiftKey) {
                            this.multiSelectShiftRequest = true;
                            if (this._allowcellSelection && rowIndex > -1)
                                this.selectCells([[rowIndex, [columnIndex]]]);
                            if (this._allowrowSelection && rowIndex > -1 && (!this._enableCheckSelect || checkBoxSelection))
                                this.selectRows(this._previousIndex, this.getIndexByRow($target.closest('tr')), $target);
                                this._selectedRow(this.getIndexByRow($target.closest('tr')));
                            if (this._allowcolumnSelection && $target.hasClass("e-headercell") && !$target.hasClass("e-stackedHeaderCell") && ((e.clientY - $target.offset().top) < ($target.height() / 4)))
                                this.selectColumns(this._previousColumnIndex, columnIndex);
                        }
                        if (e["pointerType"] == "touch" && this._customPop != null && !this._customPop.is(":visible") && this._customPop.find(".e-rowselect").hasClass("e-spanclicked") && this.model.selectionSettings.selectionMode == "row")
                            this._customPop.show();
                        if (e["pointerType"] == "touch" && this._customPop != null && (this._customPop.find(".e-sortdirect").is(":visible") || !this._customPop.find(".e-rowselect").hasClass("e-spanclicked")) && this.model.selectionType == "multiple" &&(this.model.selectionSettings.selectionMode.indexOf("cell")!= -1 || this.model.selectionSettings.selectionMode.indexOf("row") !=-1 )) {
                            this._customPop.removeAttr("style");
                            var offset = $target.offset();
                            this._customPop.offset({ top: 0, left: 0 }).offset({ left: offset.left, top: offset.top - this.getRowHeight() - $target.height() }).find(".e-sortdirect").hide().end()
                                .find(".e-rowselect").show().end().show();
                        }
                    }
                    if (!this.multiSelectShiftRequest) {
                        if (this._allowcellSelection && rowIndex > -1) {
                            var cellProto = this._checkCellSelectionByRow(rowIndex, columnIndex);
                            if ((this.model.selectionSettings.enableToggle && this.selectedRowCellIndexes.length == 1 && this.selectedRowCellIndexes[0].cellIndex.length==1 || (e.ctrlKey && this.model.selectionType == 'multiple')) && (cellProto != -1 && this.selectedRowCellIndexes.length > 0 && this.selectedRowCellIndexes[0].cellIndex.length > 0))
                                this.clearCellSelection(cellProto.rowIndex, columnIndex);
                            else
                                this.selectCells([[rowIndex, [columnIndex]]]);
                        }
                        if (this._allowrowSelection && rowIndex > -1) {
                            var selectedIndex = this.getIndexByRow($target.closest('tr'));
                            if (this._enableCheckSelect)
                                this.multiSelectCtrlRequest = true;
							if(this.model.scrollSettings.enableVirtualization){
								var remain = rowIndex % this._virtualRowCount, viewIndex;							
								viewIndex = parseInt($($target).closest("tr").attr("name"), 32);																												
								selectedIndex = (viewIndex * this._virtualRowCount) - (this._virtualRowCount - remain);	
							}
							var inx;
							if ((this.model.editSettings.editMode == "inlineform" || this.model.editSettings.editMode == "inlineformtemplate") && (!this._enableCheckSelect && !checkBoxSelection) && this.getIndexByRow($target.closest("tr")) > $(".e-editedrow").index()) {
							    var $editTrLen = $("#" + this._id).find(".e-editedrow").length;
							    inx = this.getIndexByRow($target.closest("tr")) - $editTrLen;
							}
							else
							    inx = this.getIndexByRow($target.closest('tr'));
                            if (!this._enableCheckSelect || checkBoxSelection) {
							    if (this.model.selectionSettings.enableToggle && !this._enableCheckSelect && this.getSelectedRecords().length == 1 && $.inArray(this.getIndexByRow($target.closest('tr')), this.selectedRowsIndexes) != -1)
							        this.clearSelection(selectedIndex);
							    else
							        this.selectRows(inx, null, $target);
							}
                            if(this._enableCheckSelect && !(e.ctrlKey || this._enableSelectMultiTouch))
                                this.multiSelectCtrlRequest = false;
                        }
                        if (this._allowcolumnSelection && $target.hasClass("e-headercell") && !$target.hasClass("e-stackedHeaderCell") && ((e.clientY - $target.offset().top) < ($target.height() / 4))) {
                            if (this.model.selectionSettings.enableToggle && this.selectedColumnIndexes.length == 1 && $.inArray(columnIndex, this.selectedColumnIndexes) != -1)
                                this.clearColumnSelection(columnIndex);
                            else
                                this.selectColumns(columnIndex);
                        }
                        this.multiSelectCtrlRequest = false;
                    }
                    this.multiSelectShiftRequest = false;
                }

                fieldName = this._bulkEditCellDetails.columnIndex >= 0 ? this.model.columns[this._bulkEditCellDetails.columnIndex]["field"] : null;
                if ($target.closest(".e-rowcell").length && !ej.isNullOrUndefined(fieldName)) {
                    this._tabKey = false;
                    this.model.editSettings.allowEditing && this.model.editSettings.editMode == ej.Grid.EditMode.Batch && this.editCell($.inArray($target.closest("tr").get(0), this._excludeDetailRows()), fieldName);
                }
            }
            if ($target.hasClass("e-rowselect") || $target.hasClass("e-sortdirect")) {
                if (!$target.hasClass("e-spanclicked")) {
                    $target.addClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = true;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = true;
                } else {
                    $target.removeClass("e-spanclicked");
                    if ($target.hasClass("e-rowselect"))
                        this._enableSelectMultiTouch = false;
                    if ($target.hasClass("e-sortdirect"))
                        this._enableSortMultiTouch = false;
                    this._customPop.hide();
                }
            }
            this._selectAllCheck = false;
            if (ej.gridFeatures.common) {
                this.expandCollapse($target);
            }
            if ($target.is(".e-filtericon") && $target.closest(".e-detailrow").length != 0)
                e.preventDefault();
            if (this._$fDlgIsOpen && this.model.allowFiltering && (this.model.filterSettings.filterType == "menu" || this._isExcelFilter) && !$target.is(".e-filtericon") && $target.closest(".e-dlgcontainer").length != 1)
                this._closeFDialog();
            if (this.model.allowSearching && this._searchBar != null) {
                if ($target.is(this._searchBar.find(".e-cancel")))
                    this._searchBar.find("input").val("");
                else {
                    if (e.target.id == this._id + "_searchbar")
                        this._searchBar.find(".e-cancel").removeClass("e-hide");
                    else if (!this._searchBar.find(".e-cancel").hasClass("e-hide"))
                        this._searchBar.find(".e-cancel").addClass("e-hide");
                }
            }
			if($target.closest(".e-unboundcelldiv").length) this._unboundClickHandler(e);
        },
        _checkCellSelectionByRow: function (rowIndex, columnIndex) {
            for (var i = 0; i < this.selectedRowCellIndexes.length; i++) {
                if (this.selectedRowCellIndexes[i].rowIndex == rowIndex)
                    break;
            }
            if (i != this.selectedRowCellIndexes.length && $.inArray(columnIndex, this.selectedRowCellIndexes[i].cellIndex) != -1)
                return this.selectedRowCellIndexes[i];
            return -1;
        },
        _persistState: function (customModel) {
           if (this.model.enablePersistence && this._isHeightResponsive)
                customModel._isHeightResponsive = this._isHeightResponsive;
         },
        _restoreState: function (customModel) {
           if (this.model.enablePersistence && customModel._isHeightResponsive)
                this._isHeightResponsive = customModel._isHeightResponsive;
         },  
        _destroy: function () {
            /// <summary>This function is  used to destroy the Grid Object</summary>
            this.element.off();
            this.element.find(".e-gridheader").find(".e-headercontent,.e-movableheader")
                .add(this.element.find(".e-gridcontent").find(".e-content,.e-movablecontent")).off('scroll');
            var editForm = $("#" + this._id + "EditForm");
            if (editForm.length) {
                var $formEle = editForm.find('.e-field'), $element;
                for (var i = 0; i < $formEle.length; i++) {
                    $element = $($formEle[i]);
                    if ($element.hasClass('e-datetimepicker'))
                        $element.ejDateTimePicker("destroy");
                    else if ($element.hasClass('e-datepicker'))
                        $element.ejDatePicker("destroy");
                    else if ($element.hasClass('e-dropdownlist'))
                        $element.ejDropDownList("destroy");
                }
                editForm.remove();
            }
            if (this._confirmDialog)
                this._confirmDialog.ejDialog("destroy");
            this.element.find('.e-dropdownlist').ejDropDownList('model.dataSource', []);
            if (this.model.showColumnChooser) {
                $("#" + this._id + "ccDiv").ejDialog("destroy");
                $("#" + this._id + "ccDiv").remove();
                $("#" + this._id + "_ccTail").remove();
                $("#" + this._id + "_ccTailAlt").remove();
            }
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "excel")
                this._excelFilter.resetExcelFilter()
            if (this.model.allowReordering)
                $(".e-columndropindicator").remove();
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "menu") {
                var proxy = this, $colType;
                $.each(this.model.columns, function (indx, col) {
                    $colType = col.type;
                    $("#" + proxy._id + $colType + "_ddinput_popup_wrapper").remove();
                    if ($colType == "string")
                        $("#" + proxy._id + "_stringDlg").find('.e-autocomplete').ejAutocomplete("destroy");
                    else if ($colType == "date")
                        $("#" + proxy._id + "_dateDlg").find('.e-datepicker').ejDatePicker("destroy");
                    else if ($colType == "datetime")
                        $("#" + proxy._id + "_datetimeDlg").find('.e-datetimepicker').ejDateTimePicker("destroy");
                    else if ($colType == "number")
                        $("#" + proxy._id + "_numberDlg").find('.e-numerictextbox').ejNumericTextbox("destroy");
                });
            }
            if (this.element.find(".e-gridcontent .e-scrollbar").length > 0)
                this.element.find(".e-gridcontent").ejScroller("destroy");
            if (this._$onresize)
                $(window).off("resize", this._$onresize);
            this.element.empty().removeClass("e-grid " + this.model.cssClass);
            this.element.ejWaitingPopup("destroy");
            if (this.model.contextMenuSettings.enableContextMenu) {
                $("#" + this._id + "_Context").ejMenu('destroy');
                $("#" + this._id + "_Context").remove();
            }
        },
        _getDeprecatedLocalizedLabel: function (key) {
            if (["OkButton", "OKButton"].indexOf(key) != -1)
                return this.localizedLabels.OkButton || this.localizedLabels.OKButton;
        },
        _getLocalizedLabels: function (property) {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
    });
    if (ej.gridFeatures.common)
        $.extend(ej.Grid.prototype, ej.gridFeatures.common);
    if (ej.gridFeatures.edit)
        $.extend(ej.Grid.prototype, ej.gridFeatures.edit);
    if (ej.gridFeatures.filter)
        $.extend(ej.Grid.prototype, ej.gridFeatures.filter);
    if (ej.gridFeatures.group)
        $.extend(ej.Grid.prototype, ej.gridFeatures.group);
    if (ej.gridFeatures.selection)
        $.extend(ej.Grid.prototype, ej.gridFeatures.selection);
    if (ej.gridFeatures.sort)
        $.extend(ej.Grid.prototype, ej.gridFeatures.sort);
    if (ej.gridFeatures.dragAndDrop)
        $.extend(ej.Grid.prototype, ej.gridFeatures.dragAndDrop);

    ej.Grid.Locale = ej.Grid.Locale || {};

    ej.Grid.Locale["default"] = ej.Grid.Locale["en-US"] = {
        EmptyRecord: "No records to display",
        GroupDropArea: "Drag a column header here to group its column",
        DeleteOperationAlert: "No records selected for delete operation",
        EditOperationAlert: "No records selected for edit operation",
        SaveButton: "Save",
        OKButton: "OK",
        CancelButton: "Cancel",
        EditFormTitle: "Details of ",
        AddFormTitle: "Add New Record",
        GroupCaptionFormat: "{{:headerText}}: {{:key}} - {{:count}} {{if count == 1 }} item {{else}} items {{/if}} ",
        BatchSaveConfirm: "Are you sure you want to save changes?",
        BatchSaveLostChanges: "Unsaved changes will be lost. Are you sure you want to continue?",
        ConfirmDelete: "Are you sure you want to Delete Record?",
        CancelEdit: "Are you sure you want to Cancel the changes?",
        PagerInfo: "{0} of {1} pages ({2} items)",
        FrozenColumnsViewAlert: "Frozen columns should be in grid view area",
        FrozenColumnsScrollAlert: "Enable allowScrolling while using frozen Columns",
        FrozenNotSupportedException: "Frozen Columns and Rows are not supported for Grouping, Row Template, Detail Template, Hierarchy Grid and Batch Editing",
        Add: "Add",
        Edit: "Edit",
        Delete: "Delete",
        Update: "Update",
        Cancel: "Cancel",
        Done: "Done",
        Columns: "Columns",
        SelectAll: "(Select All)",
        PrintGrid: "Print",
        ExcelExport: "Excel Export",
        WordExport: "Word Export",
        PdfExport: "PDF Export",
        StringMenuOptions: [{ text: "StartsWith", value: "StartsWith" }, { text: "EndsWith", value: "EndsWith" }, { text: "Contains", value: "Contains" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }],
        NumberMenuOptions: [{ text: "LessThan", value: "LessThan" }, { text: "GreaterThan", value: "GreaterThan" }, { text: "LessThanOrEqual", value: "LessThanOrEqual" }, { text: "GreaterThanOrEqual", value: "GreaterThanOrEqual" }, { text: "Equal", value: "Equal" }, { text: "NotEqual", value: "NotEqual" }, { text: "Between", value: "Between" }],
        PredicateAnd: "AND",
        PredicateOr: "OR",
        Filter: "Filter",
        FilterMenuFromCaption:"From",        
        FilterMenuToCaption:"To",
        FilterMenuCaption: "Filter Value",
        FilterbarTitle: "'s filter bar cell",
        MatchCase: "Match Case",
        Clear: "Clear",
        ResponsiveFilter: "Filter",
        ResponsiveSorting: "Sort",
        Search: "Search",
        DatePickerWaterMark: "Select date",
        NumericTextBoxWaterMark: "Enter value",
        EmptyDataSource: "DataSource must not be empty at initial load since columns are generated from dataSource in AutoGenerate Column Grid",
        ForeignKeyAlert: "The updated value should be a valid foreign key value",
        True: "true",
        False: "false",
        UnGroup: "Click here to ungroup",
        AddRecord: "Add Record",
        EditRecord: "Edit Record",
        DeleteRecord: "Delete Record",
        Save: "Save",
        Grouping: "Group",
        Ungrouping: "Ungroup",
        SortInAscendingOrder: "Sort In Ascending Order",
        SortInDescendingOrder: "Sort In Descending Order",
        NextPage: "Next Page",
        PreviousPage: "Previous Page",
        FirstPage: "First Page",
        LastPage: "Last Page",
        EmptyRowValidationMessage:"Atleast one field must be updated",
		NoResult: "No Matches Found"
    };
    ej.Grid.Actions = {
        /** Used to specify paging action in grid   */
        Paging: "paging",
        /** Used to specify sorting action in grid   */
        Sorting: "sorting",
        /** Used to specify filtering action in grid   */
        Filtering: "filtering",
        /** Used to specify begin edit action in grid   */
        BeginEdit: "beginedit",
        /** Used to specify saving action in grid   */
        Save: "save",
        /** Used to specify adding action in grid   */
        Add: "add",
        /** Used to specify deleting action in grid   */
        Delete: "delete",
        /** Used to specify cancelling action in grid   */
        Cancel: "cancel",
        /** Used to specify grouping action in grid   */
        Grouping: "grouping",
        /** Used to specify un-grouping action in grid   */
        Ungrouping: "ungrouping",
        /** Used to specify refresh action in grid   */
        Refresh: "refresh",
        /** Used to specify reordering action in grid   */
        Reorder: "reorder",
        /** Used to specify searching action in grid   */
        Search: "searching",
        /** Used to specify batch save action in grid   */
        BatchSave: "batchsave",
        /** Used to specify virtual scroll action in grid   */
        VirtualScroll: "virtualscroll"
    };

    ej.Grid.SummaryType = {
        /**  Creates grid with summary type as Average */
        Average: "average",
        /**  Creates grid with summary type as Minimum */
        Minimum: "minimum",
        /**  Creates grid with summary type as Maximum */
        Maximum: "maximum",
        /**  Creates grid with summary type as Count */
        Count: "count",
        /**  Creates grid with summary type as Sum */
        Sum: "sum",
        /**  Creates grid with summary type as TrueCount */
        TrueCount: "truecount",
        /**  Creates grid with summary type as FalseCount */
        FalseCount: "falsecount",
        /**  Creates grid with summary type as Custom */
        Custom: "custom"
    };

    ej.Grid.EditMode = {
        /**  Creates grid with editMode as Normal */
        Normal: "normal",
        /**  Creates grid with editMode as Dialog */
        Dialog: "dialog",
        /**  Creates grid with editMode as DialogTemplate */
        DialogTemplate: "dialogtemplate",
        /**  Creates grid with editMode as Batch */
        Batch: "batch",
        /**  Creates grid with editMode as ExternalForm */
        ExternalForm: "externalform",
        /**  Creates grid with editMode as ExternalFormTemplate */
        ExternalFormTemplate: "externalformtemplate",
        /**  Creates grid with editMode as InlineForm */
        InlineForm: "inlineform",
        /**  Creates grid with editMode as InlineTemplateForm */
        InlineTemplateForm: "inlineformtemplate"
    };

    ej.Grid.PrintMode = {
        /**  print all pages in grid */
        AllPages: "allpages",
        /**   print current pages in grid */
        CurrentPage: "currentpage",
    };
    ej.Grid.ResizeMode = {
        NextColumn: 'nextcolumn',
        Control: 'control',
        Normal: 'normal'
    };
    ej.Grid.Rowposition = {
        /** Add new row in the top of the grid */
        Top: "top",
        /** Add new row in the bottom of the grid */
        Bottom: "bottom",
    };

    ej.Grid.FormPosition = {
        /**  Creates grid with formPosition as BottomLeft */
        BottomLeft: "bottomleft",
        /**  Creates grid with formPosition as TopRight */
        TopRight: "topright"
    };

    ej.Grid.ClipMode = {
        /** Render an ellipsis ("...") to represent clipped text **/
        Ellipsis: "ellipsis",
        /** Clips the text **/
        Clip: "clip",
        /** Render an ellipsis ("...") to represent clipped text and tooltip would be shown **/
        EllipsisWithTooltip: "ellipsiswithtooltip"
    };

    ej.Grid.DragBehavior = {
        /**  Allows to move a record from one grid to another or within the grid*/
        Move: "move", 
        /**  Allows to copy a record from one grid to another or within the grid*/
        Copy: "copy"
    }; 

    ej.Grid.CellSelectionMode = {
        /**  Allows to select cells continuously from the start cell to end cell*/
        Flow: "flow", 
        /**  Allows to select range of cells as a block from start cell to the end cell*/
        Box: "box"
    }

    ej.Grid.EditingType = {
        /**  Allows to set edit type as string edit type */
        String: "stringedit",
        /**  Allows to set edit type as boolean edit type */
        Boolean: "booleanedit",
        /**  Allows to set edit type as numeric edit type */
        Numeric: "numericedit",
        /**  Allows to set edit type as drop down edit type */
        Dropdown: "dropdownedit",
        /**  Allows to set edit type as date picker edit type */
        DatePicker: "datepicker",
        /**  Allows to set edit type as date time picker edit type */
        DateTimePicker: "datetimepicker",
        /**  Allows to set edit type as edittemplate edit type */
        EditTemplate: "edittemplate"
    };

    ej.Grid.UnboundType = {
        /** Used to specify unbound type as Edit   */
        Edit: "edit",
        /** Used to specify unbound type as Save   */
        Save: "save",
        /** Used to specify unbound type as Delete   */
        Delete: "delete",
        /** Used to specify unbound type as Cancel   */
        Cancel: "cancel"
    };

    ej.Grid.ToolBarItems = {
        /** Used to add toolbar item for adding records    */
        Add: "add",
        /** Used to add toolbar item for editing records    */
        Edit: "edit",
        /** Used to add toolbar item for deleting records    */
        Delete: "delete",
        /** Used to add toolbar item for updating records    */
        Update: "update",
        /** Used to add toolbar item for cancelling records    */
        Cancel: "cancel",
        /** Used to add toolbar item for searching records    */
        Search: "search",
        /** Used to add toolbar item for printing grid    */
        PrintGrid: "printGrid",
        /** Used to add toolbar item for exproting grid to excel    */
        ExcelExport: "excelExport",
        /** Used to add toolbar item for exporting grid to word    */
        WordExport: "wordExport",
        /** Used to add toolbar item for exporting grid to pdf    */
        PdfExport: "pdfExport"
    };

    ej.Grid.FilterType = {
        /**  Creates grid with filtering type as Menu */
        Menu: "menu",
        /**  Creates grid with filtering type as FilterBar */
        FilterBar: "filterbar",
        /** Creates grid with filtering type as Excel */
        Excel: "excel"
    };

    ej.Grid.FilterBarMode = {
        /** Used to set filter bar mode as Immediate mode */
        Immediate: "immediate",
        /** Used to set filter bar mode as OnEnter mode */
        OnEnter: "onenter"
    };

    ej.Grid.SelectionType = {
        /**  Support for Single selection only in grid */
        Single: "single",
        /**  Support for multiple selections in grid */
        Multiple: "multiple"
    };
    ej.Grid.ColumnLayout = {
         /**  Support for auto width in grid */
        Auto: "auto",
        /**  Support for fixed column width in grid */
        Fixed: "fixed"
    };
    ej.Grid.GridLines = {
        /**  Support for Show both the vertical and horizontal line in grid  */
        Both: "both",
        /**  Support for Hide both the vertical and horizontal line in grid  */
        None: "none",
        /**  Support for Shows the horizontal line only in grid */
        Horizontal: "horizontal",
        /**  Support for Shows the vertical line only in grid  */
        Vertical: "vertical",
    };

    ej.Grid.VirtualScrollMode = {
        /** Used to set the Normal mode virtual paging*/
        Normal: "normal",
        /** Used to set the Continuous mode virtual paging*/
        Continuous: "continuous"
    };

    ej.Grid.SelectionMode = {
        /**  Support for Row selection in grid */
        Row: "row",
        /**  Support for Cell selection in grid */
        Cell: "cell",
        /**  Support for Column selection in grid */
        Column: "column"
    };

    ej.Grid.WrapMode = {
        /**  Support for text wrap with both header and content in grid */
        Both: "both",
        /**  Support for text wrap with content alone in grid */
        Content: "content",
        /**  Support for text wrap with header alone in grid */
        Header: "header"
    };

    ej.Grid.exportAll = function (exportAction, gridIds) {
        ej.Grid.prototype["export"](exportAction, null, true, gridIds);
    };

    ej.SqlDataSourceAdaptor = new ej.UrlAdaptor().extend({
        init: function (id) {
            this.initialRender = true;
        },
        processQuery: function (dm, query, hierarchyFilters) {
            var obj = ej.UrlAdaptor.prototype.processQuery(dm, query, hierarchyFilters);
            var data = ej.parseJSON(obj.data), result = {};
            // Param
            if (data.param) {
                for (var i = 0; i < data.param.length; i++) {
                    var param = data.param[i], key = Object.keys(param)[0];
                    result[key] = param[key];
                }
            }
            result["value"] = data;
            var modelStr = JSON.stringify({ type: "SqlData", args: data });
            if (this.initialRender == false) {
                setTimeout(function () { __doPostBack("", modelStr) }, 0);
            }
            this.initialRender = false;
            return {
                data: JSON.stringify(result),
                result: dm.dataSource.json,
                ejPvtData: obj.ejPvtData,
                count: dm.dataSource.json.length,
            }
        },
        processResponse: function (data, ds, query, xhr, changes) {
            var pvt = data.ejPvtData || {};
            var groupDs = data.groupDs;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            var d = JSON.parse(data.data);
            if (d && d.action === "batch" && data.added) {
                changes.added = data.added;
                return changes;
            }
            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                if ('count' in data) args.count = data.count;
                if (data["result"]) args.result = data.result;
                if (data["aggregate"]) data = data.aggregate;
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                args["aggregates"] = res;
                data = args;
            }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups, args = {};
                if ('count' in data) args.count = data.count;
                if (data["aggregates"]) args.aggregates = data.aggregates;
                if (data["result"]) data = data.result;
                for (var i = 0; i < groups.length; i++) {
                    var level = null;
                    if (!ej.isNullOrUndefined(groupDs))
                        groupDs = ej.group(groupDs, groups[i]);
                    data = ej.group(data, groups[i], pvt.aggregates, level, groupDs);
                }
                if (args.count != undefined)
                    args.result = data;
                else
                    args = data;
                return args;
            }
            return data;
        },
    });
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.gridResize = function (instance) {
        this.$headerTable = instance.getHeaderTable();
        this.gridInstance = instance;
        this._colMinWidth = 15;
        this._$visualElement = $();
        this._currentCell = -1;
        this._allowStart = false;
        this._oldWidth = null;
        this._orgX = null;
        this._orgY = null;
        this._extra = null;
        this._expand = false;
        this._target = null;
        this._cellIndex = -1;
    }

    ej.gridFeatures.gridResize.prototype = {
        _mouseHover: function (e) {
            if (this._$visualElement.is(":visible"))
                return;
            this._allowStart = false;
            if ($(e.target).is(".e-headercelldiv"))
                e.target = e.target.parentNode;
            var $target = $(e.target);
			if ($(e.target).hasClass("e-filtericon") && ($(e.target).css("cursor") == "col-resize" || $(e.target).closest("tr").css("cursor") == "col-resize")) {
                $(e.target).css("cursor", "pointer");
                $(e.target).closest("tr").css("cursor", "pointer");
            }
            if ($target.hasClass("e-headercell")) {
                var _resizableCell = e.target;
                var location = _resizableCell.getBoundingClientRect(), _x = 0, _y = 0;
                if (e.type = "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }
                else if (e.type = "touchmove") {
                    _x = evt.originalEvent.changedTouches[0].clientX;
                    _y = evt.originalEvent.changedTouches[0].clientY;
                }
                else if (e.type = "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                    var _nlx = this.gridInstance.getHeaderContent().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                else
                    var _nlx = this.gridInstance.getHeaderTable().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                if (((_x >= (location.left + document.documentElement.scrollLeft + _resizableCell.offsetWidth - 5)) || ((_x <= (location.left + 3)))) && (_x < _nlx) && (_x >= location.left) && (_y <= location.top + document.documentElement.scrollTop + e.target.offsetHeight)) {
                    if (_x > location.left + 3)
                        var tempTarget = $(e.target).find(".e-headercelldiv");
                    else
                        var tempTarget = $(e.target).prevAll("th:visible:first").find(".e-headercelldiv");
                    var windowScrollX = window.pageXOffset || document.documentElement.scrollTop || document.body.scrollTop;
                    var _lx = (this.gridInstance.element.find(".e-headercell").not('.e-detailheadercell').offset().left + 10) - windowScrollX;
                    if ((this.gridInstance.model.enableRTL && (_x <= _lx)) || (!this.gridInstance.model.enableRTL && (_x >= _lx))) {
                        if ((this.gridInstance.model.showStackedHeader || tempTarget.length) && $.inArray($(tempTarget).attr("data-ej-mappingname"), this.gridInstance._disabledResizingColumns) == -1) {
                            this.gridInstance.model.showStackedHeader && $($target.parents('thead')).find('tr').css("cursor", "col-resize");
                            !this.gridInstance.model.showStackedHeader && $target.parent().css("cursor", "col-resize");
                            if ($(e.target).hasClass('e-stackedHeaderCell'))
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").index(_resizableCell);
                            else
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").not(".e-stackedHeaderCell,.e-detailheadercell").index(_resizableCell);
                            if (this.gridInstance.model.enableRTL)
                                this._currentCell = this._currentCell - 1;
                            this._allowStart = true;
                        }
                        else {
                            $target.parent().css("cursor", "pointer");
                            this._currentCell = -1;
                        }
                    }
                }
                else {
                    this.gridInstance.element.find(".e-columnheader").css("cursor", "pointer");
                    this._currentCell = -1;
                }
            }
        },
        _start: function (_x, _y) {
            var _myrow = this.gridInstance.getHeaderTable().find(".e-columnheader"), _top;
            var _cells, _mycel;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                _cells = _myrow.find(".e-headercell").not(".e-hide");
            else
                _cells = _myrow.find(".e-headercell").not(".e-stackedHeaderCell,.e-hide");
            if (this._currentCell != -1 && this._currentCell < _cells.length)
                _mycel = _cells[this._currentCell];
            if (typeof (_mycel) == 'undefined')
                return;
            var _j = _mycel.getBoundingClientRect();
            _top = this._tableY = _j.top + parseInt(navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollTop : document.documentElement.scrollTop);
            if (this._allowStart) {
                var vElement = this._$visualElement = $(document.createElement('div')),
                _height = this.gridInstance.element.find(".e-gridcontent").first().height() + this.gridInstance.element.find(".e-gridheader").height();
                if (this.gridInstance.model.showStackedHeader && this.gridInstance.model.stackedHeaderRows.length > 0) {
                    var headerRow = this.gridInstance.getHeaderTable().find('tr.e-columnheader')
                    var lenght = headerRow.length;
                    var currentIndex = $(this._target).parent('tr')[0].rowIndex;
                    for (var i = 0; i < currentIndex; i++) {
                        _height = _height - $(headerRow[i]).height();
                    }
                    // _height = _height - $(".e-stackedHeaderRow").height();
                }
                vElement.addClass("e-reSizeColbg").appendTo(this.gridInstance.element).attr("unselectable", "on").css("visibility", "hidden");
                this.gridInstance._resizeTimeOut = setTimeout(function() {
                    vElement.css({ visibility: "visible", height: _height + 'px', cursor: 'col-resize', left: _x, top: _top, position: 'fixed' });
                }, 100);
                this._oldWidth = _mycel.offsetWidth;
                this._orgX = _x;
                this._orgY = _y;
                this._extra = _x - this._orgX;
                this._expand = true;
            }
            else {
                this._currentCell = -1;
            }
        },
        _mouseMove: function (e) {
            if (this._expand) {
                var _x = 0, _y = 0;
                if (e.type == "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }                
                else if (e.type == "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                else if (e.type == "touchmove") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                if ((_x == 0 && _y == 0) && navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                _x += document.documentElement.scrollLeft;
                e.preventDefault();
                this._moveVisual(_x);
            }
            else
                this._mouseHover(e);
        },
        _touchStart: function (e) {
            if (this._$visualElement.is(":visible"))
                return;
            this._allowStart = false;
            if ($(e.target).is(".e-headercelldiv"))
                e.target = e.target.parentNode;
            var $target = $(e.target);            
            if ($target.hasClass("e-headercell")) {
                var _resizableCell = e.target;
                var location = _resizableCell.getBoundingClientRect(), _x = 0, _y = 0;
                if (e.type == "touchstart") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                var gridInstChildren = this.gridInstance.element.children(".e-gridheader");
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                    var _nlx = this.gridInstance.getHeaderContent().width() + gridInstChildren.find(".e-columnheader").offset().left;
                else
                    var _nlx = this.gridInstance.getHeaderTable().width() + gridInstChildren.find(".e-columnheader").offset().left;
                if (((_x >= (location.left + document.documentElement.scrollLeft + _resizableCell.offsetWidth - 10)) || ((_x <= (location.left + 8)))) && (_x < _nlx) && (_x >= location.left) && (_y <= location.top + document.documentElement.scrollTop + e.target.offsetHeight)) {
                    if (_x > location.left + 8)
                        var tempTarget = $(e.target).find(".e-headercelldiv");
                    else
                        var tempTarget = $(e.target).prevAll("th:visible:first").find(".e-headercelldiv");
                    var windowScrollX = window.pageXOffset || document.documentElement.scrollTop || document.body.scrollTop;
                    var _lx = (this.gridInstance.element.find(".e-headercell").not('.e-detailheadercell').offset().left + 10) - windowScrollX;
                    if ((this.gridInstance.model.enableRTL && (_x <= _lx)) || (!this.gridInstance.model.enableRTL && (_x >= _lx))) {
                        if ((this.gridInstance.model.showStackedHeader || tempTarget.length) && $.inArray($(tempTarget).attr("data-ej-mappingname"), this.gridInstance._disabledResizingColumns) == -1) {                            
                            if ($(e.target).hasClass('e-stackedHeaderCell'))
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").index(_resizableCell);
                            else
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").not(".e-stackedHeaderCell,.e-detailheadercell").index(_resizableCell);
                            if (this.gridInstance.model.enableRTL)
                                this._currentCell = this._currentCell - 1;
                            this._allowStart = true;
                        }
                        else {                            
                            this._currentCell = -1;
                        }
                    }
                }
                else {                    
                    this._currentCell = -1;
                }
            }
            if (this._allowStart) {
                this._target = $target;
                if (this.gridInstance.pluginName == "ejGrid" && this.gridInstance.model.allowResizing) {                    
                    if (this._triggerResizeEvents("resizeStart", _x))
                        return;
                } else if (this.gridInstance.pluginName == "ejTreeGrid" && this.gridInstance.model.allowColumnResize) {
                    if (this.gridInstance._triggerColumnResize("columnResizeStart", _x, e))
                        return;
                }
                var gridobj = this;
                _x += document.documentElement.scrollLeft;
                if (e.button != 2)
                    this._start(_x, _y);
                return false;
            }
            return true;
        },
        _getCellIndex: function (e) {
            var $target = $(e._target);
            var targetCell = e._target;
            var location = targetCell.getBoundingClientRect();
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            if (this._orgX < location.left + 5 + scrollLeft)
                targetCell = $(targetCell).prevAll(":visible:first")[0];
            var hCellIndex = targetCell.cellIndex;
            var cellIndex = hCellIndex;
            if (e.gridInstance.model.groupSettings.groupedColumns.length) {
                cellIndex = hCellIndex - e.gridInstance.model.groupSettings.groupedColumns.length;
            }
            return cellIndex;
        },
        _reSize: function (_x, _y) {
            // Function used for Resizing the column
            var proxy = this;
            var resized = false, $content;
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                this._initialTableWidth = this.gridInstance.getHeaderTable().first().parent().width() + this.gridInstance.getHeaderTable().last().parent().width();
            else
                this._initialTableWidth = this.gridInstance.getHeaderTable().parent().width();
            if (this.gridInstance.model.enableRTL && (this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid))
                this._currentCell = this._currentCell - 1;
            else
                !this.gridInstance.model.enableRTL && this._getResizableCell();
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0)
                var _rowobj = this.gridInstance.getHeaderTable().find('thead');
            else
                var _rowobj = $(this._target).parents('thead');
            if (this._currentCell != -1 && this._expand) {
                this._expand = false;
                var _childTH = $(this._target).hasClass('e-stackedHeaderCell') ? _rowobj.find(".e-headercell:not(.e-detailheadercell)").filter(":visible") : _rowobj.find(".e-headercell:not(.e-detailheadercell,.e-stackedHeaderCell)").filter(":visible");
                var _outerCell = _childTH[this._currentCell];
                var _oldWidth = _outerCell.offsetWidth;
                var _extra = _x - this._orgX;
                if (this.gridInstance.model.enableRTL)
                    _extra = -_extra;
                //Check whether the column minimum width reached
                if (parseInt(_extra) + parseInt(_oldWidth) > this._colMinWidth) {
                    if (_extra != 0)
                        _rowobj.css("cursor", 'default');
                     var $prevheaderCol, oldColWidth;
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                     var $prevheaderCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                     if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                     this.gridInstance._detailColsRefresh();
                    $prevheaderCols = this.gridInstance._$headerCols;
                   }
                    var $prevheaderCol = $prevheaderCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    var oldColWidth = $prevheaderCol.width();
                   }
                    this._resizeColumnUsingDiff(_oldWidth, _extra);
                    $content = this.gridInstance.element.find(".e-gridcontent").first();
                    var scrollContent = $content.find("div").hasClass("e-content");                    
                    var browser = !ej.isIOSWebView() && this.gridInstance.getBrowserDetails();
                    if (browser && browser.browser == "msie" && this.gridInstance.model.allowScrolling) {
                        var oldWidth = this.gridInstance.getContentTable().width(), newwidth = this.gridInstance._calculateWidth();
                        if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0) {
                            this.gridInstance.getContentTable().last().width(newwidth - this.gridInstance.getContent().find(".e-frozencontentdiv").width());
                            this.gridInstance.getHeaderTable().last().width(newwidth - this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width());
						if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))                            
							this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().last().width(newwidth - this.gridInstance.getFooterContent().find(".e-frozenfootertdiv").width());
                        }
                        else {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getHeaderTable().width(newwidth);
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().width(newwidth);
                            }
                        }
                        if (parseInt(browser.version, 10) > 8 && this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", (20 / $content.find("table").first().width()) * 100 + "%");
                            }
                            else {
                                this.gridInstance.getContentTable().css("width", "100%");
                                this.gridInstance._groupingAction(true);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", ((this.gridInstance.getHeaderTable().find("colgroup").find("col").first().width() / $content.find("table").first().width()) * 100).toFixed(2) + "%");

                            }
                        }
                        this.gridInstance.getHeaderTable().parent().scrollLeft($content.find(".e-content").scrollLeft() - 1);
                    }
                    this.gridInstance._colgroupRefresh();
                    if (this.gridInstance.model.allowTextWrap)
                        this.gridInstance.rowHeightRefresh();
                    if (this.gridInstance.model.groupSettings.groupedColumns.length && !this.gridInstance.model.isEdit)
                        this.gridInstance._recalculateIndentWidth();
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'normal') {
                        if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
                            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                                this.gridInstance._detailColsRefresh();
                                $headerCols = this.gridInstance._$headerCols;
                                $ContentCols = this.gridInstance._$contentCols;
                            }
                            var nextCell = this._currentCell + 1;
                            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                            var newWidth = $headerCol.width() + (oldColWidth - $prevheaderCol.width()), $ContentCol;
                            if (newWidth < this._colMinWidth)
                                newWidth = this._colMinWidth;
                            $headerCol.width(newWidth);
                            if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                                var $colGroup = $tables.find("colgroup");
                                var colCount = this.gridInstance.getVisibleColumnNames().length;
                                if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                                    $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                                for (var i = 0 ; i < $colGroup.length; i++) {
                                    var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                                    if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                                    $(cols[nextCell]).width(newWidth);
                                }
                            }
                            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                                if (nextCell >= 0 && nextCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                                    return;
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(nextCell);
                            }
                            else
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                            $ContentCol.width(newWidth);
                            this.gridInstance._findColumnsWidth();
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(_outerCell).is(":last-child") && this.gridInstance.pluginName == "ejGrid") {
                                var val = $prevheaderCol.width() - oldColWidth;
                                var frozenWidth = this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width() + val;
                                var movableWidth = this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width() - val;
                                var marginLeft = parseInt(this.gridInstance.getHeaderContent().find('.e-movableheader')[0].style["margin-left"]) + val;
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(frozenWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(frozenWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-frozenfooterdiv').width(frozenWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width(movableWidth);
                                this.gridInstance.getContent().find('.e-movablecontentdiv').width(movableWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-movablefooterdiv').width(movableWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheader').css("margin-left", marginLeft);
                                this.gridInstance.getContent().find('.e-movablecontent').css("margin-left", marginLeft);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-movablefooter').css("margin-left", marginLeft);
                            }
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(_outerCell).is(":last-child") && this.gridInstance.pluginName == "ejTreeGrid") {
                                var val = $prevheaderCol.width() - oldColWidth;
                                var frozenWidth = this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width() + val;
                                var movableWidth = this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width() - val;
                                var marginLeft = parseInt(this.gridInstance.getHeaderContent().find('.e-movableheader')[0].style["margin-left"]) + val;
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(frozenWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheader').css("margin-left", marginLeft);
                                this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width(movableWidth);
                                this.gridInstance.getContent().find(".e-frozencontainer").width(frozenWidth).next().css("margin-left", marginLeft + "px");
                                this.gridInstance.getContent().find('.e-movablecontent').width(movableWidth);
                                if (this.gridInstance.model.showTotalSummary) {
                                    this.gridInstance._$totalSummaryRowContainer.find(".e-frozenfooterdiv").width(frozenWidth);
                                    this.gridInstance._$totalSummaryRowContainer.find(".e-movablefooter").css("margin-left", marginLeft + "px");
                                }
                                this.gridInstance._renderScroller(true);                             
                            }

                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(this._target).parent('tr').parents('div:first').hasClass('e-frozenheaderdiv') && this.gridInstance.pluginName == "ejGrid") {
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(this._newWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(this._newWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-frozenfooterdiv').width(this._newWidth);
                            }
                        }
                        else if (!this.gridInstance.model.scrollSettings.frozenColumns) {
                            var oldTableWidth = this.gridInstance.getHeaderTable().width();
                            this.gridInstance.getHeaderTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.getContentTable().css("width", oldTableWidth + parseInt(_extra));
                            if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterTable()))
                                this.gridInstance.getFooterTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.model.scrollSettings.width += parseInt(_extra);
                            if (this.gridInstance.getContent().width() > this.gridInstance.getContentTable().width()) {
                                this.gridInstance.getContentTable().addClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().addClass('e-tableLastCell');
                            }
                            else {
                                this.gridInstance.getContentTable().removeClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().removeClass('e-tableLastCell');
                            }
                        }
                    }
                    if (!(browser.browser == "msie") && browser && this.gridInstance.model.allowScrolling && this.gridInstance.model.scrollSettings.frozenColumns == 0) {
                        this.gridInstance.getHeaderTable().width("100%");
                        this.gridInstance.getContentTable().width("100%");
                        if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterTable()))
                            this.gridInstance.getFooterTable().width("100%");
                        var tableWidth = this.gridInstance._calculateWidth();
                        if (tableWidth <= this.gridInstance.getContentTable().width() || this.gridInstance.getHeaderTable().width() > this.gridInstance.getContentTable().width()) {
                            this.gridInstance.getHeaderTable().width(tableWidth);
                            this.gridInstance.getContentTable().width(tableWidth);
                            if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterTable()))
                                this.gridInstance.getFooterTable().width(tableWidth);
                        }
                    }
                    if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'default') {
                        var cellIndex = this._currentCell;
                        var target = $(this._target), columnIndex = [], col = [];
                        var newWidth = _oldWidth + _extra;
                        var args = {};
                        if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                            var rowindex = target.parent(".e-stackedHeaderRow").index(),
                            stackedHeaderText = target.text(),
                            stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                            for(i=0;i<stackedHeaderCol.length;i++){
                                if(stackedHeaderCol[i].headerText == stackedHeaderText)
                                    stackedHeaderColumns = stackedHeaderCol[i].column;
                            }
                            var columns = stackedHeaderColumns;
                            if (!(stackedHeaderColumns instanceof Array))
                                columns = stackedHeaderColumns.split(",");
                            for (var i = 0 ; i < columns.length; i++) {
                                var index = this.gridInstance.getColumnIndexByField(columns[i]);
                                columnIndex.push(index)
                                col.push(this.gridInstance.model.columns[index]);
                            }
                            args = { columnIndex: columnIndex, column: col, oldWidth: _oldWidth, newWidth: newWidth };
                        }
                        else
                        args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], oldWidth: _oldWidth, newWidth: newWidth };
                        this.gridInstance._trigger("resized", args);
                    }
                    if (this.gridInstance.model.allowScrolling) {
                        this.gridInstance.getScrollObject().refresh(this.gridInstance.model.scrollSettings.frozenColumns > 0);
                        if (this.gridInstance.model.isResponsive && this.gridInstance.model.minWidth)
                            this.gridInstance.windowonresize();
                        if (!scrollContent && $content.find("div").hasClass("e-content"))
                            this.gridInstance.refreshScrollerEvent();
                        this.gridInstance._isHscrollcss();
                    }
                }

            }

            this._target = null;
            this._$visualElement.remove();
            this._expand = false;
            this._currentCell = -1;
            this._allowStart = false;

        },
        _getFrozenResizeWidth: function () {
            var $frozenColumnsCol = this.gridInstance.getHeaderTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0), width = 0;
            for (var i = 0; i < $frozenColumnsCol.length; i++) {
                if ($frozenColumnsCol.eq(i).css("display") != "none")
                    width += parseInt($frozenColumnsCol[i].style.width.replace("px", ""));
            }
            return width;
        },
        _diaplayFinder: function () {
            return $(this).css('display') != 'none';
        },
        _resizeColumnUsingDiff: function (_oldWidth, _extra) {
            var proxy = this, _extraVal;			
            this._currntCe = this._currentCell;
            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                this.gridInstance._detailColsRefresh();
                $headerCols = this.gridInstance._$headerCols;
                $ContentCols = this.gridInstance._$contentCols;
            }
            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    , $ContentCol, $footerCol, $frozenCols = $headerCols.slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0);
            var colWidth = $headerCol[0].style.width, isPercent = colWidth.indexOf("%") != -1;
            var _inlineWidth = (!colWidth || isPercent)? $(this._target).outerWidth() : colWidth;
            var indent = !isPercent ? _oldWidth / parseInt(_inlineWidth) : 1;
            _extraVal = _extra = _extra / indent
            var _newWidth = this._newWidth = parseInt(_extra) + parseInt(_inlineWidth);
            if (this.gridInstance.pluginName == "ejTreeGrid" && _extra > 0 && !ej.isNullOrUndefined(this.gridInstance._currentCell) && this.gridInstance.model.columns[this.gridInstance._currentCell].isFrozen == true) {
                var width = this.gridInstance._frozenWidth();
                //if resizing exceeds the grid width
                if (width > this.gridInstance._gridWidth - 18 - 50) {//container width-scrollerwidth- minimum width of unfrozen column
                    return
                }
            }
            if (_newWidth > 0 && _extra != 0) {
                if (_newWidth < this._colMinWidth)
                    _newWidth = this._colMinWidth;
                if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                    var nextCol = $headerCol.next();
                    var isFrozenLastCell = this.gridInstance.model.scrollSettings.frozenColumns && this._currentCell == this.gridInstance.model.scrollSettings.frozenColumns - 1 ? true : false;
                    if (isFrozenLastCell)
                        nextCol = $headerCols.eq(this.gridInstance.model.scrollSettings.frozenColumns);
                    if ((isFrozenLastCell || !$headerCol.is(":last-child")) && (nextCol.width() + ($headerCol.width() - _newWidth) <= this._colMinWidth))
                        _newWidth = $headerCol.width() + (nextCol.width() - this._colMinWidth);
                }
                var _extra = _newWidth - _oldWidth;
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                    if (this._currentCell >= 0 && this._currentCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                        return;
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(this._currentCell);
                }
                else
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                if (this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterTable())) {
                    this._$footerCols = this.gridInstance.getFooterTable().find('colgroup').find("col");
                    var colCount = this.gridInstance.model.columns.length;
                    if (this._$footerCols.length > colCount) this._$footerCols.splice(0, (this._$footerCols.length - colCount));
                    var $footerCols = this._$footerCols,
                    $footerCol = $footerCols.filter(this._diaplayFinder).eq(this._currentCell);
                    $footerCol.outerWidth(_newWidth);
                }
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    this._resizeStackedHeaderColumn($(this._target).parent('tr'), _extraVal, this._currntCe);
                }
                else
                    $headerCol.outerWidth(_newWidth);
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        for (var i = 0; i < this._changedcell.length; i++) {
                            var cellIndex = this._changedcell[i];
                            for (var j = 0 ; j < $colGroup.length; j++) {
                                var visibleCols = $($colGroup[j]).children().filter(this._diaplayFinder);
                                var width = parseInt((_extraVal)) + parseInt(visibleCols[cellIndex].style.width);
                                if (width < this._colMinWidth)
                                    width = this._colMinWidth
                                $(visibleCols[cellIndex]).width(width);
                            }
                        }
                    }
                    var length = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder).length;
                    for (var i = 0; i < this._changedcell.length; i++) {
                        var $conCol = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder)[this._changedcell[i]]
                        var width = parseInt((_extraVal)) + parseInt($conCol.style.width);
                        if (width < this._colMinWidth)
                            width = this._colMinWidth
                        $($conCol).outerWidth(width);
                        if (this.gridInstance.model.isEdit && (this.gridInstance.model.allowGrouping && this.gridInstance.model.groupSettings.groupedColumns.length == 0)) {
                            var $sEditCol = this.gridInstance.getContentTable().find(".gridform").find("colgroup col").filter(this._diaplayFinder)[this._changedcell[i]];
                            $($sEditCol).outerWidth(width);
                        }
                    }
                }
                else {
                    if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        var cellIndex = this._currentCell;
                        var colCount = this.gridInstance.getVisibleColumnNames().length;
                        if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                            $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                        for (var i = 0 ; i < $colGroup.length; i++) {
                            var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                            if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                            $(cols[cellIndex]).width(_newWidth);
                        }
                    }
                    $ContentCol.outerWidth(_newWidth);
                    if (this.gridInstance.model.isEdit) {
                        var $editableRow = this.gridInstance.getContentTable().find(".e-editedrow,.e-addedrow");
                        var $editCols = $editableRow.find("table").find("colgroup col");
                        var addCol;
                        if ($editableRow.hasClass("e-addedrow") && this.gridInstance.model.groupSettings.groupedColumns.length)
                            addCol = this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length - 1;
                        else
                            addCol = this._currentCell;
                        var $editCol = $editCols.filter(this._diaplayFinder).eq(addCol);
                        $editCol.outerWidth(_newWidth);
                    }
                }
                this.gridInstance._findColumnsWidth();
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns && ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'nextcolumn' && this.gridInstance.pluginName == "ejGrid") {
                    var frozenColumns = this.gridInstance.getContentTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings.frozenColumns)
                        , width = 0, direction;
                    for (i = 0; i < frozenColumns.length; i++)
                        width += frozenColumns[i].style.display == 'none' ? 0 : parseInt(frozenColumns[i].style.width.replace("px", ""));
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width);
                    direction = this.gridInstance.model.enableRTL ? "margin-right" : "margin-left";
                    this.gridInstance.getContent().find(".e-frozencontentdiv").width(width).next().css(direction, width + "px");
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width).next().css(direction, width + "px");
                    (this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent())) && this.gridInstance.getFooterContent().find(".e-frozenfooterdiv").width(width);
                }
                if (this.gridInstance.pluginName == "ejTreeGrid" && ((!ej.isNullOrUndefined(this.gridInstance._currentCell) && this.gridInstance.model.columns[this.gridInstance._currentCell].isFrozen == true && ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'nextcolumn') || (!this.gridInstance._isFrozenStackedResize && this.gridInstance._isStackedResize && this.gridInstance._frozenColumnsLength > 0))) {
                    var width = this.gridInstance._frozenWidth();                    
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width);
                    this.gridInstance.getContent().find(".e-frozencontainer").width(width).next().css("margin-left", width + "px");
                        this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width).next().css("margin-left", width + "px");
                        if (this.gridInstance.model.showTotalSummary) {
                            this.gridInstance._$totalSummaryRowContainer.find(".e-frozenfooterdiv").width(width);
                            this.gridInstance._$totalSummaryRowContainer.find(".e-movablefooter").css("margin-left", width + "px");
                        }
                        this.gridInstance._renderScroller(true);
                     }
                this.gridInstance.getHeaderTable().find(".e-columnheader").css("cursor", "default");
            }
        },
        _resizeStackedHeaderColumn: function (currentTr, extra, currentCell) {
            // var currentIndex = this._currntCe;
            this._changedcell = [];
            var headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
            var preCol = 0, limit = 0, currentTh = headerCells[currentCell], currentSpan = $(currentTh).attr('colspan'), commonExtra = extra / currentSpan, tr = $(currentTh).parent('tr');
            var nextTr = tr.next();
            var currentIndex = currentTh.cellIndex;
            if (this.gridInstance.model.groupSettings.showGroupedColumn) {
                limit = this.gridInstance.model.groupSettings.groupedColumns.length;
                preCol += limit
            }
            while (currentIndex > limit) {
                currentIndex--;
                var th = $(tr).children('th').not(".e-detailheadercell")[currentIndex];
                preCol += parseInt($(th).attr('colspan'));
            }
            this._currentCell = preCol;
            var length = preCol + parseInt(currentSpan);
            for (var i = preCol; i < length; i++) {
                var $colG = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder)[i];
                this._changedcell.push(i - limit)
                var width = parseInt(extra) + parseInt($colG.style.width);
                if (width < this._colMinWidth)
                    width = this._colMinWidth;
                $($colG).outerWidth(width);
             }
        },
        _triggerResizeEvents: function (event, _x) {
            var _rowobj = this.gridInstance.getHeaderTable().find(".e-columnheader");
            var _childTH = _rowobj.find(".e-headercell").filter(":visible");
            var cellIndex = this._cellIndex;
            var target = $(this._target), columnIndex = [], col = [];
            if (event == "resizeStart") {
                this._orgX = _x;
                cellIndex = this._cellIndex = this._getCellIndex(this, _x);
            }
            var _outerCell = _childTH[this._currentCell];
            var _oldWidth = _outerCell.offsetWidth;
            if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                var rowindex = target.parent(".e-stackedHeaderRow").index(),
                stackedHeaderText = target.text(),
                stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                for(i=0;i<stackedHeaderCol.length;i++){
                    if(stackedHeaderCol[i].headerText == stackedHeaderText)
                        stackedHeaderColumns = stackedHeaderCol[i].column;
                }
                var columns = stackedHeaderColumns;
                if (!(stackedHeaderColumns instanceof Array))
                    columns = stackedHeaderColumns.split(",");
                for (var i = 0 ; i < columns.length; i++) {
                    var index = this.gridInstance.getColumnIndexByField(columns[i]);
                    columnIndex.push(index)
                    col.push(this.gridInstance.model.columns[index]);
                }
            }
            if (event == "resizeStart") {
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: target, oldWidth: _oldWidth };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth };
                return this.gridInstance._trigger("resizeStart", args);
            }
            else {
                var _childth = _rowobj.find(".e-headercell").not(".e-detailheadercell").filter(":visible");
                var _extra = _x - this._orgX;
                var newWidth = _oldWidth + _extra;
                this.gridInstance._colgroupRefresh();
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                return this.gridInstance._trigger("resizeEnd", args);
            }
        },
        _mouseUp: function (e) {
            if (this.gridInstance._resizeTimeOut){
                clearTimeout(this.gridInstance._resizeTimeOut);
                this.gridInstance._resizeTimeOut = 0;
            }
            if (this._expand) {
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                if (e.type == "touchend") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                if (this.gridInstance.model.allowResizing && (this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize' || e.type == "touchend")) {
                    if (this._triggerResizeEvents("resizeEnd", _x)) {
                        this.gridInstance.element.find(".e-reSizeColbg").remove();
                        return;
                    }
                }
                _x += document.documentElement.scrollLeft;
                this._reSize(_x, _y);
                if (!ej.isNullOrUndefined(this._currntCe) && this._currntCe >= 0)
                    this.gridInstance.model.columns[this._currntCe].width = this.gridInstance.columnsWidthCollection[this._currntCe];
            }
        },
        _getResizableCell: function () {
            var row, frozenColumns = this.gridInstance.model.scrollSettings.frozenColumns;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                row = this.gridInstance.getHeaderTable().find(".e-columnheader");
            else
                row = this.gridInstance.getHeaderTable().find(".e-columnheader").not('.e-stackedHeaderRow');
            var cell = row.find(".e-headercell").not(".e-hide,.e-detailheadercell");
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            //To identify whether it is previous cell to final frozen cell
            if (frozenColumns && this._currentCell != -1 && this._currentCell == frozenColumns - 1) {
                var cellPoint = cell[this._currentCell].getBoundingClientRect().left + scrollLeft + 5,
                    isFrozenPreviousCell = cellPoint > this._orgX ? true : false;
            }
            if (!frozenColumns || this._currentCell != frozenColumns - 1 || isFrozenPreviousCell)
                for (var i = 0; i < cell.length; i++) {
                    var point = cell[i].getBoundingClientRect();
                    var xlimit = point.left + scrollLeft + 5;
                    if (xlimit > this._orgX && $(cell[i]).height() + point.top >= this._orgY) {
                        this._currentCell = i - 1;
                        return;
                    }
                    if (i == cell.length - 1 || (this.gridInstance.model.showStackedHeader && $(this._target).get(0) === cell[i])) {
                        this._currentCell = i;
                        return;
                    }
                }
        },
        _moveVisual: function (_x) {
            /// Used to move the visual element in mouse move
            var _bounds = this.gridInstance.getHeaderContent().find("div").first()[0].getBoundingClientRect();
            if ((_bounds.left + document.documentElement.scrollLeft + _bounds.width < _x) || (_x < _bounds.left + document.documentElement.scrollLeft))
                this._$visualElement.remove();
            else if (this._currentCell != -1)
                this._$visualElement.css({ left: _x, top: this._tableY });
        },
        _mouseDown: function (e) {
            if (this._allowStart && ($(e.target).closest("tr").css("cursor") == 'col-resize')) {
                this._target = e.target;
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY - (window.pageYOffset || document.body.scrollTop || 0);
                }
                if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize') {
                    if ($(e.target).is(".e-headercelldiv"))
                        e.target = e.target.parentNode;
                    this._target = e.target;
                    if (this._triggerResizeEvents("resizeStart", _x))
                        return;
                }
                var gridobj = this;
                _x += document.documentElement.scrollLeft;
                if (e.button != 2)
                    this._start(_x, _y);
                return false;
            }
            return true;
        },
        _columnResizeToFit: function (e) {
            var resize = this.gridInstance.getHeaderTable().find(".e-columnheader").filter(function (e) {
                return $(this).css("cursor") == "col-resize";
            });
            if (this.gridInstance.model.allowResizeToFit && resize.length) {
                if ($(e.target).is(".e-headercelldiv"))
                    e.target = e.target.parentNode;
                var $target = $(e.target);
                var headerCells, preCol = 0, indent = 0;
                if ($target.hasClass('e-stackedHeaderCell'))
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
                else
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-stackedHeaderCell,.e-detailheadercell");
                this._target = $target;
                if ($target.hasClass("e-headercell")) {
                    var targetCell = e.target;
                    var hCellIndex = $.inArray(targetCell, headerCells);
                    var cellIndex = hCellIndex;
                    this._orgX = e.pageX;
                    if(!this.gridInstance.model.enableRTL) 
						this._getResizableCell();
					else
						this._currentCell = hCellIndex;
                    if (hCellIndex != this._currentCell) {
                        hCellIndex = cellIndex = this._currentCell;
                        targetCell = e.target.previousSibling;
                    }
                    var currentTh = headerCells.filter(":visible")[cellIndex], changesCellIndex = [], changesFinalWdith = [], changesOldWidth = [];
                    indent = this.gridInstance.model.groupSettings.groupedColumns.length;
                    if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) || !ej.isNullOrUndefined(this.gridInstance.model.childGrid))
                        indent += 1;
                    if ($(targetCell).parent("tr").hasClass('e-stackedHeaderRow')) {
                        var currentSpan = $(currentTh).attr('colspan'), tr = $(currentTh).parent('tr'), tHeadIndex = currentTh.cellIndex;
                        var nextTr = tr.next();
                        while (tHeadIndex > indent) {
                            tHeadIndex--
                            var th = $(tr).children('th')[tHeadIndex];
                            preCol += parseInt($(th).attr('colspan'))
                        };
                        var length = preCol + parseInt(currentSpan);
                    }
                    else {

                        preCol = cellIndex; length = cellIndex + 1;
                    }
                    var finalWidth = 0, headerWidth = 0, contentWidth = 0, argCols = [], argExtra = [];
                    if (preCol != -1) {
                        var hiddenLen = headerCells.slice(0, preCol + 1).filter(".e-hide").length;
                        var args = { columnIndex: preCol + hiddenLen, column: this.gridInstance.model.columns[preCol + hiddenLen], target: $target, oldWidth: oldWidth };
                        this.gridInstance._trigger("resizeStart", args);
                        for (var i = preCol; i < length; i++) {
                            hiddenLen = headerCells.slice(0, i + 1).filter(".e-hide").length;
                            contentWidth = this._getContentWidth(i + hiddenLen);
                            var $cellDiv = this.gridInstance.getHeaderTable().find('.e-headercell:not(.e-hide, .e-stackedHeaderCell)').children(".e-headercelldiv").eq(i);
                            headerWidth = this._getHeaderContentWidth($cellDiv);
                            finalWidth = headerWidth > contentWidth ? headerWidth : contentWidth;
                            finalWidth += parseInt(($cellDiv.css("padding-left"), 10) + ($cellDiv.css("padding-right"), 10));
                            var oldWidth = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder).eq(i + indent).width();
                            finalWidth = oldWidth > finalWidth ? finalWidth : (this._colMinWidth < finalWidth ? finalWidth : this._colMinWidth);

                            var headerCols = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                headerCols.splice(0, 1);
                            headerCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $colGroups = this.gridInstance.getContentTable().find('.e-recordtable').find('colgroup');
                                var proxy = this;
                                $.each($colGroups, function (indx, colgroup) {
                                    $(colgroup).find('col').filter(proxy._diaplayFinder).eq(i).width(finalWidth);
                                });
                            }
                            var contentCols = this.gridInstance.getContentTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                contentCols.splice(0, 1);
                            contentCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.isEdit) {
                                var $editableCol = this.gridInstance.getContentTable().find(".e-editedrow").find("col");
                                var $form = this.gridInstance.element.find(".gridform");
                                for (var j = 0; j < $form.length; j++) {
                                   var $editableCol = $($form[j]).find("col")
                                   $editableCol.eq(i + indent).width(finalWidth);
                               }
                            }
                            argCols.push(this.gridInstance.model.columns[i + hiddenLen]);
                            argExtra.push(Math.abs(finalWidth - oldWidth))
                            changesCellIndex.push(i + hiddenLen); changesFinalWdith.push(finalWidth); changesOldWidth.push(oldWidth);
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 || (this.gridInstance.model.groupSettings.groupedColumns.length && this.gridInstance.model.isEdit)) {
                                var colIndex = i + hiddenLen;
                                this.gridInstance.columnsWidthCollection[colIndex] = finalWidth;
                                this.gridInstance.setWidthToColumns();
                                if (this.gridInstance.model.scrollSettings.frozenColumns <= colIndex + 1) {
                                    this.gridInstance.getHeaderContent().find(".e-movableheader").css("margin-left", finalWidth);
                                    this.gridInstance.getContent().find(".e-movablecontent").css("margin-left", finalWidth);
                                    if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                        this.gridInstance.getFooterContent().find(".e-movablefooter").css("margin-left", finalWidth);
                                }
                            }
                        }

                    }
                    this.gridInstance._colgroupRefresh();
                    this.gridInstance._recalculateIndentWidth();
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resizeEnd", args);
                    for (var i = 0; i < changesCellIndex.length; i++) {
                        this.gridInstance.columnsWidthCollection[changesCellIndex[i]] = changesFinalWdith[i];
                        this.gridInstance.model.columns[changesCellIndex[i]]["width"] = changesFinalWdith[i];
                    }
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resized", args);
                    if (this.gridInstance.model.summaryRows.length > 0)
                        this.gridInstance._summaryColRrefresh();
					this.gridInstance._findColumnsWidth();
                }				
            }
        },
        _getContentWidth: function (cellindx) {
            var contentWidth = 0;
            var $span = ej.buildTag('span', {}, {}), proxy = this.gridInstance, tdWidth;
            if (!ej.isNullOrUndefined(proxy._gridRows)) {
                var rows = proxy._gridRows;
                if (this.gridInstance.model.scrollSettings.frozenColumns && cellindx >= this.gridInstance.model.scrollSettings.frozenColumns) {
                    rows = rows[1];
                    cellindx = cellindx - this.gridInstance.model.scrollSettings.frozenColumns;
                }
                $.each(rows, function (indx, row) {
                    if ($(row).is('.e-row,.e-alt_row') && !$(row).is('.e-editedrow')) {
					    var td = $(row).find('td.e-rowcell').eq(cellindx);
					    var content = $(td).html();
					    if (proxy.model.columns[cellindx]["commands"])
					        $span.html($(content).children());
					    else if (td.hasClass("e-validError"))
					        $span.html($(content).attr("value"));
					    else
						    $span.html(content);
					    $(td).html($span);
					    tdWidth = td.find('span:first').width() > 0 ? td.find('span:first').width() + parseInt(td.css("padding-left")) + parseInt(td.css("padding-right")) : td.find('span:first').width();
					    if (tdWidth > contentWidth)
						    contentWidth = tdWidth;
					    $(td).html(content);
                    }
				});
			}
            proxy._refreshUnboundTemplate(this.gridInstance.getContentTable());
            return contentWidth;
        },
        _getHeaderContentWidth: function ($cellDiv) {
            var headerWidth = 0, $span = ej.buildTag('span', {}, {});
            var content = $cellDiv.html();
            $span.html(content);
            $cellDiv.html($span);
            headerWidth = $cellDiv.find('span:first').width() + parseFloat($cellDiv.css("padding-left")) + parseFloat($cellDiv.css("padding-right"));
            if (this.gridInstance.model.allowFiltering && this.gridInstance.model.filterSettings.filterType == "menu" || this.gridInstance.model.filterSettings.filterType == "excel")
                headerWidth = headerWidth + $cellDiv.parent().find(".e-filtericon").width() + 10;
            $cellDiv.html(content);
            return headerWidth;
        },
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var horizontalHeaderTemplate = function () {
        return ("{{if multiRes == true}}<td class = 'e-horizontalheader'><div class='e-horizontalresheader'>{{:label}}</div></td>{{else}}{{/if}}" +
                "<td class='e-horizontaldaterender'><div class='e-horizontaltimecells {{:heightclass}}'>" +
                "<div class='e-headerdays' style='position:absolute;'>" +
                "<table class ='e-table {{:tablelayout}}'style='width:100%;border-collapse:separate;table-layout:fixed;'><tbody>{{if view !== 'month'}}" +
                "<tr style='width:100%;'> <td>{{if view === 'day'}}<table style='width:100%;'>{{else}}<table class='e-table'>{{/if}}<tbody><tr> {{for cols ~headercellWidth = headercellWidth}}<td class='e-headercells {{:cellToday}} e-horizontalheadertddate'><div class='{{:currentDateClass}} e-horizontalheaderdiv'>{{:currentDay}}</div></td>{{/for}} </tr></tbody></table></td> </tr>" +
                "<tr style='width:100%;position:absolute;'> <td><table class ='e-table e-horizontaltabletimecell' style='border-collapse:collapse;'><tbody><tr> {{for timeTdCount  ~columnvalue =column  }}{{for ~name=time ~dayend=timecellclass ~index=#getIndex() }}<td class='e-horizontaltimetd {{:~dayend}}'><div style='width:{{:timeCellWidth}}'><span class ='e-horizontaltimespan'>{{:~name.slice(0,2)}}</span><div class ='e-horizontaltimespandiv'>{{:~name.slice(3,5)}}</div></div></td>{{for ~columnvalue[~index] ~width = timeCellWidth}}<td class='e-horizontalalternatetd'><div style='width:{{:~width}}'></div></td>{{/for}}{{/for}}{{/for}}  </tr></tbody></table></td> </tr>{{/if}}" +
                "{{if view == 'month'}}<tr>{{for cols}}<td class='e-headercells e-horizontmonthheaderdatetd {{:cellToday}}'><div title='{{:title}}' class='e-dateheadercell e-horizontmonthdatealign'>{{:currentDate}}</div></td>{{/for}}</tr>" +
                "<tr>{{for cols}}<td class ='e-horizontmonthheaderdaytd' style='width:{{:cellWidth}}'><div class='e-dateheadercell e-horizontmonthdatealign' title='{{:daynameTitle}}'>{{:currentDay}}</div></td>{{/for}}</tr>" +
                "{{/if}}</tbody></table></div></div></td>");
    };
    var userTimeCellsHoriTemplate = function () {
        return ("{{if multiRes == true}}<td class = 'e-horizontalheader'><div class='e-horizontalresheader'>{{:label}}</div></td>{{else}}{{/if}}" +
                "<td class='e-horizontaldaterender'><div class='e-horizontaltimecells {{:heightclass}}'>" +
                "<div class='e-headerdays' style='position:absolute;'>" +
                "<table class ='e-table' style='width:100%;border-collapse:separate;table-layout:fixed;'><tbody>{{if view !== 'month'}}" +
                "<tr style='width:100%;'> <td>{{if view === 'day'}}<table style='width:100%;'>{{else}}<table class='e-table'>{{/if}}<tbody><tr> {{for cols ~headercellWidth = headercellWidth}}<td class='e-headercells {{:cellToday}} e-horizontalheadertddate'><div class='{{:currentDateClass}} e-horizontalheaderdiv'>{{:currentDay}}</div></td>{{/for}} </tr></tbody></table></td> </tr>" +
                "<tr style='width:100%;position:absolute;'> <td><table class='e-table e-horizontaltabletimecell' style='border-collapse:collapse;'><tbody><tr> {{for timeTdCount  ~userTemplateId = userTemplateId  ~template=template  ~columnvalue =column}}{{for ~name=time ~names=times ~dayend=timecellclass ~index=#getIndex() }}<td class='e-horizontaltimetd {{:~dayend}}'><div style='width:{{:timeCellWidth}}'><span class ='e-horizontaltimespan'>{{:~name}}</span><div class ='e-horizontaltimespandiv'></div></div></td>{{for ~columnvalue[~index] ~width = timeCellWidth ~names=~names}}<td class='e-horizontalalternatetd' style='vertical-align:middle !important;'><div style='width:{{:~width}};' > {{if ~template ==true || ~userTemplateId==true }}{{:~names[#getIndex()]}}{{else}}</div>{{/if}}</td>{{/for}}{{/for}}{{/for}}  </tr></tbody></table></td> </tr>{{/if}}" +
                "{{if view == 'month'}}<tr>{{for cols}}<td class='e-headercells e-horizontmonthheaderdatetd {{:cellToday}}'><div class='e-dateheadercell e-horizontmonthdatealign'>{{:currentDate}}</div></td>{{/for}}</tr>" +
                "<tr>{{for cols}}<td class ='e-horizontmonthheaderdaytd'><div class='e-dateheadercell e-horizontmonthdatealign' style='width:{{:cellWidth}}'>{{:currentDay}}</div></td>{{/for}}</tr>" +
                "{{/if}}</tbody></table></div></div></td>");
    };

    var horizontalResourceHeaderTemplate = function () {
        return ("<div class ='e-horizontresdiv'><div class='e-horires' style='height:100%'><table class='e-table e-resourceheadertable' style='width:100%;table-layout:fixed;'>" +
                "<tbody>{{for trs}}<tr class='e-horizontresheaderdiv'>{{for ~resname=name ~marginleft=marginleft }}{{if classname == 'e-parentnode'}}<td class='{{:classname}} resemptytd' style='width:25px;height:{{:cellHeight}}'></td>{{else}}<td class='resemptytd' style='width:25px;height:{{:cellHeight}}'></td>{{/if}}<td class='{{:classname}}' style='vertical-align:middle;height:{{:cellHeight}};'>" +
                "{{if classname == 'e-parentnode'}}<div id={{:idnum}} class='{{:classname}}category e-resourceicon e-resourcecollapse' style='width:20px;vertical-align:middle;float:left;margin-left:{{:~marginleft}};margin-top:2px;'></div>{{/if}}" +
                "<div class='e-resourceheadertext' style='text-align:left;margin-left:{{:~marginleft}};' title='{{if userResTemplId == true}}{{:name}}{{else}}{{:~resname}}{{/if}}'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resname}}{{/if}}</div>" +
                "</td>{{/for}}</tr>{{/for}}</tbody></table></div></div>");
    };

    var horizontalCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab'>" +
                "<tbody>{{for cellrows ~cols=cols ~hourdiff=hourdiff ~view=view ~classname=classname ~columnvalue=column ~userTemp=userTemplate ~userHtml=userHtml}}" +
                "{{if classname == 'e-parentnode'}} <tr class='e-resourceheadertr' style='width:100%'>{{for ~cols ~value=#getIndex()}}{{if #index % ~hourdiff == 0 && #index != 0 && ~view !== 'month' }}<td class='e-resourceheadercells e-workcells e-parentworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-resourceheadercells e-workcells e-parentworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}{{if ~userTemp == true}}{{if ~view !== 'month'}}{{:~userHtml[~value][0][#getIndex()]}}{{else}}{{:~userHtml[~value][#getIndex()]}}{{/if}}{{/if}}</td>{{if ~view !== 'month' ~val=#index}}{{for ~columnvalue[#getIndex()] ~width = cellWidth}}<td class='e-resourceheadercells e-workcells e-parentworkcell e-alternateworkcell' style='width:{{:~width}};height:{{:cellHeight}}'>{{if ~userTemp == true}}{{:~userHtml[~value][1][~val][#getIndex()]}}{{/if}}</td>{{/for}}{{/if}}{{/for}}</tr>" +
                "{{else}}<tr style='width:100%'>{{for ~cols ~value=#getIndex()}}{{if #index % ~hourdiff == 0 && #index != 0 && ~view !== 'month'  }}<td class='e-workcells e-childworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-workcells e-childworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}{{if ~userTemp == true}}{{if ~view !== 'month'}}{{:~userHtml[~value][0][#getIndex()]}}{{else}}{{:~userHtml[~value][#getIndex()]}}{{/if}}{{/if}}</td>{{if ~view !== 'month' ~val=#index}}{{for ~columnvalue[#getIndex()] ~width = cellWidth}}<td class='e-workcells e-childworkcell e-alternateworkcell' style='width:{{:~width}};height:{{:cellHeight}}'>{{if ~userTemp == true}}{{:~userHtml[~value][1][~val][#getIndex()]}}{{/if}}</td>{{/for}}{{/if}}{{/for}}" +
                "</tr>{{/if}}{{/for}}</tbody></table>");
    };

    ej.scheduleFeatures.horizontal = {

        _renderHorizontalTemplates: function () {
            this.horizontalHeader = $.templates(horizontalHeaderTemplate());
            this.cellTemplate = $.templates(horizontalCellsTemplate());
            this.horizontalResHeader = $.templates(horizontalResourceHeaderTemplate());
            this.userTimeCellHoriTemplate = $.templates(userTimeCellsHoriTemplate());
        },

        _horizontalViewNavigation: function (e) {
            var currentDateIndex, navidate;
            if (e.type == "click") {
                if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    currentDateIndex = e.currentTarget.cellIndex;
                    navidate = new Date(this._dateRender[currentDateIndex]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate) {
                        (this.model.timeScale.enable) && $(e.currentTarget).children().addClass("e-activeview");
                        this.currentDate(navidate);
                    }
                    else { return false; }
                    this._businessHourScroller();
                }
                else if (this.currentView() == "month" || (this._isCustomMonthView())) {
                    currentDateIndex = e.currentTarget.cellIndex;
                    if (this.model.views.indexOf("day") == -1) return false;
                    navidate = new Date(this.monthDays[currentDateIndex]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                        this.currentDate(navidate);
                    else { return false; }
                    this._navView = true;
                    this._viewChange(e, this.currentView(), "day");
                }
            }
            else if (e.type == "dblclick") {
                if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                    var target = $(e.target);
                    var dayTarget = target.hasClass("e-headercells") ? target : target.parent().hasClass("e-headercells") ? target.parent() : target.parent().parent();
                    if (this.model.views.indexOf("day") == -1 || !dayTarget.hasClass("e-headercells")) return false;
                    navidate = new Date(this._dateRender[dayTarget.index()]);
                    if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                        this.currentDate(navidate);
                    else { return false; }
                    this._navView = true;
                    this._viewChange(e, this.currentView(), "day");
                }
            }
        },

        _renderHorizontalHeaderDays: function (localizeDays) {
            this.element.find(".e-headercells").addClass("e-dateheaderselect");
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                var curday, temp;
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId)) {
                    var columns = this._getUserDateheaderTemplate();
                    for (var i = 0; i < this._dateRender.length; i++) {
                        $(this.element.find(".e-headercells")[i]).find("div")[0].innerHTML = columns[i].currentDay;
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                    }
                }
                else {
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    for (var i = 0; i < this._dateRender.length; i++) {
                        curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(this._dateRender[i]).getDay()].split("")[0] : (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? localizeDays.calendar.days.names[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                        if (this.model.timeScale.enable)
                            temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMMM yyyy", this.model.locale) : curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale) : curday + " " + new Date(this._dateRender[i]).getDate();
                        else
                            temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? ej.format(new Date(this._dateRender[i]), "dd MMMM yyyy", this.model.locale) : ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale) : ("0" + new Date(this._dateRender[i]).getDate()).slice(-2);
                        $(this.element.find(".e-headercells")[i]).find("div")[0].innerHTML = temp;
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(this.currentDate().setHours(0, 0, 0, 0)).getTime())
                            $(this.element.find(".e-headercells")[i]).children().addClass("e-activeview");
                    }
                }
                var currentDate = new Date(this.currentDate());
                if (this.model.orientation == "horizontal" && this.currentView() != "month" && this.model.timeScale.enable) {
                    if (new Date(this.currentDate()).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime()) {
                        this.element.find(".e-headercells").children().removeClass("e-activeview");
                        this.element.find(".e-currentdayhighlight").children().addClass("e-activeview");
                    }
                    var active = this.element.find(".e-headercells").children(".e-activeview").parent().index();
                    this.element.find(".e-headercells").children().removeClass("e-activeview");
                    var index = this.currentView() === "day" ? 0 : this.currentView() === "workweek" ? currentDate.getDay() - 1 : this.currentView() === "week" ? currentDate.getDay() : active;
                    this.currentView() != "day" && $(this.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                    new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime() ? $(this.element.find("td.e-horizontalheadertddate")[index]).addClass("e-headerToday") : "";
                }
            }
            else {
                var monthDays = this.monthDays;
                for (var i = 0; i < monthDays.length; i++) {
                    if (new Date(new Date(monthDays[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        $(this.element.find("td.e-headercells")[i]).addClass("e-currentdayhighlight");
                }
            }
        },

        _horizontalScroll: function (e, proxy) {
            proxy._horizontalScrollValue = e.scrollData.scrollable;
            proxy._horizontalScrollValue = e.scrollData.scrollable;
            if (ej.isNullOrUndefined(e.scrollLeft)) return;
            if (proxy.currentView() == "day" || proxy.currentView() == "week" || proxy.currentView() == "workweek" || (proxy.currentView() === "customview" && proxy._renderDays <= 7)) {
                var currentDateIndex = $(proxy.element.find(".e-headercells").find(".e-activeview").parent()).index();
                var index = 0;
                if (proxy.model.enableRTL) {
                    var leftValue = (ej.browserInfo().name == "mozilla") ? Math.abs(e.scrollLeft) : e.scrollData.scrollable - e.scrollLeft;
                    proxy.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", leftValue - 1 + "px");
                    index = Math.floor((Math.abs(leftValue) / (proxy.element.find(".e-workcells").width() + 1)) / ((proxy.model.endHour - proxy.model.startHour) * proxy.model.timeScale.minorSlotCount));
                }
                else {
                    proxy.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", (-e.scrollLeft) + "px");
                    index = Math.floor((Math.abs(e.scrollLeft) / (proxy.element.find(".e-workcells").width())) / ((proxy.model.endHour - proxy.model.startHour) * proxy.model.timeScale.minorSlotCount * (60 / proxy.model.timeScale.majorSlot)));
                }
                if (e.scrollData.scrollable - e.scrollLeft == 0) return;
                if (proxy.currentView() != "day" && currentDateIndex !== index)
                    proxy.element.find(".e-headercells").children().removeClass("e-activeview");
                (proxy.currentView() != "day") && $(proxy.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                (!proxy.model.timeScale.enable) && proxy.element.find(".e-headercells").children().removeClass("e-activeview");
            }
        },

        _getHorizontalheaderCellCount: function (weekcols) {
            var cols = [];
            this._isCustomMonthView();
            if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek" || (this.currentView() == "customview" && this._oneWeek))) {
                cols = this._getUserDateheaderTemplate();
            }
            else {
                var curday, headerCellClass, temp;
                for (var i = 0; i < this._dateRender.length; i++) {
                    curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(this._dateRender[i]).getDay()].split("")[0] : (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? weekcols.calendar.days.names[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                    headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday e-currentdayhighlight" : "";
                    temp = (this.currentView() === "month" || this._isCustomMonthView()) ? { currentDay: curday, currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? { currentDay: ej.format(new Date(this._dateRender[i]), this._pattern.D, this.model.locale), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: curday + " " + ej.format(new Date(this._dateRender[i]), "dd MMM yy", this.model.locale), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: (this._mediaQuery) ? curday + parseInt(ej.format(new Date(this._dateRender[i]), "dd", this.model.locale)) : curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass, cellWidth: this.model.cellWidth };
                    cols.push(temp);
                }
            }
            return cols;
        },

        _getHoriStartEndTime: function (localizeAmPm) {
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)
            if (templateValue) {
                var userTemp = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
            }
            var startendTimes = [];
            var headercellWidth = (!this.model.cellWidth) ? this._safariBrowser ? "29px" : "30px" : this._safariBrowser ? (parseInt(this.model.cellWidth) - 1 + "px") : this.model.cellWidth;
            var daysCount = this.currentView() == "week" ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : this.model.workWeek.length;
            for (var day = 0; day < daysCount; day++) {
                if (templateValue) {
                    var dateValue = new Date(new Date().setHours(0, 0, 0, 0));
                    var j = 0, timelist1 = [];
                    for (var i = this.model.startHour; i < this.model.endHour;) {
                        var value = this.model.timeScale.majorSlot + j;
                        var jvalue = j;
                        while (j < value) {
                            var jval = j;
                            j = j * 60 * 1000;
                            if (templateValue) {
                                if (jval == jvalue)
                                    var timelist = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) ? userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }) : userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) });
                                else if (!ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId))
                                    timelist1.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());

                            }
                            else {
                                if (this._timeMode == "12") {
                                    var timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM) && j == 0) ? ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh:mm tt", this.model.locale);
                                    startendTimes.push({ time: timelist, id: i + "_" + j, timecellclass: ((i == this.model.startHour && day != 0 && j == 0)) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                                }
                                else
                                    startendTimes.push({ time: (i <= 9 ? "0" + i : i) + " 00", timecellclass: ((i % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) == this.model.startHour && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            }
                            j = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId) ? (j / (60 * 1000)) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) : (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                        }
                        i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                        j = (j >= 60) ? 0 : j;
                        if (templateValue) {
                            if (j == this.model.timeScale.majorSlot || j == 0) {
                                startendTimes.push({ time: timelist.trim(), times: timelist1, id: i + "_" + j, timecellclass: (((i - 1) == this.model.startHour) && day != 0 && j == 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                                timelist1 = [];
                            }
                        }
                    }
                }
                else {
                    var dateValue = new Date(new Date().setHours(0, 0, 0, 0));
                    for (var i = this.model.startHour; i < this.model.endHour;) {
                        var j = ej.isNullOrUndefined(j) ? 0 : j % 60;
                        while (j < 60) {
                            j = j * 60 * 1000;
                            if (this._timeMode == "12") {
                                var timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM) && j == 0) ? ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(i, 0, 0, j)), "hh:mm tt", this.model.locale);
                                startendTimes.push({ time: timelist, id: i + "_" + j, timecellclass: ((i == this.model.startHour && day != 0 && j == 0)) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            }
                            else{
                                var min = j/(60*1000);
                                startendTimes.push({ time: (Math.floor(i) <= 9 ? "0" + Math.floor(i) :Math.floor( i)) + "." + ((min == 0) ? min + "0" : min) + " 00", timecellclass: ((i % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) == this.model.startHour && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, timeCellWidth: headercellWidth });
                            }
                            j = (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                        }
                        i = (this.model.timeScale.majorSlot > 60) ? parseFloat((i + (this.model.timeScale.majorSlot / 60)).toFixed(2))  : i + 1;
                        i = Math.ceil(((i < 1.0) ? i : (i % Math.floor(i))) * 100) >= 98 ? i + 0.02 : i;
                    }
                }
            }
            return startendTimes;
        },

        _getHorizontalDayAppointments: function (appointmentsList, dateCount, day, res) {
            var resAvail = [];
            for (var app = 0; app < appointmentsList.length; app++) {
                if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                    resAvail = new ej.DataManager(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, ej.FilterOperators.equal, appointmentsList[app][this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2]]));
                else resAvail = this.res1;
                if (resAvail.length != 0) {
                    if (new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() &&
                          new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) ? appointmentsList[app][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] : true &&
                               new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) {
                        this._renderApp(appointmentsList[app], day, res);
                    }
                }
            }
        },

        _horiGroupCollection: function () {
            if ((this._tempResource.length != 0)) {
                var rIndex, temp = this._resourceSort(), temp1 = this.res1;
                var temp2 = temp.filter(function (a) { return temp1.indexOf(a) === -1; });
                if (ej.isNullOrUndefined(this.model.group)) this.res1 = ["0"];
                return temp2;
            }
        },

        _renderHorizontalApp: function (rStartTime, rEndTime, record, day, cellHeight, timeScaleRowCount, startHour, endHour) {
            var headerCell = this.element.find(".e-workcellstab tr"), appHeight, appWidth, topPosition = 0, leftPosition;
            if (rStartTime <= rEndTime) {
                var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
                var endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
                endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;
                appHeight = (this.element.find(".e-appointment").length > 0 ? this.element.find(".e-appointment").outerHeight(true) : this._getElementHeight("e-appointment"));
                var level = 0;
                if (this.model.startHour <= new Date(rStartTime).getHours() && this.model.endHour >= new Date(rStartTime).getHours()) {
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && this._grouping.length > 1) ? this._findResourceIndex(this._horiHeaderCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()], null, null) + 1 : 0;
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) + 1 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) + 1 : 1;
                    var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                    var userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "";
                    appHeight = (!this.model.appointmentTemplateId) ? appHeight : ($(userTempHtml).css('height') == "100%" ? (!this.model.showOverflowButton ? this.initialCellHeight : (cellHeight - 15)) : $(userTempHtml).css('height') == "0px" ? appHeight : $(userTempHtml).height());
                    level = (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && !ej.isNullOrUndefined(this.model.group)) ? this._getOverlapCount(record, day, this._dateRender, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getOverlapCount(record, day, this._dateRender, null);
                    this._renderedAllDay.push($.extend(true, {}, record));
                    topPosition = (level * appHeight) + topPosition;
                    var diffTime, diffDays, diffMinutes, cellIndex;
                    var dayLength = this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length;
                    var curIndex = Math.floor ((dayLength * day)+(((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) - this.model.startHour * 60) / Math.floor(this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount));
                    if (record[this._appointmentSettings["allDay"]]) {
                        diffTime = new Date(new Date(new Date(rEndTime).setHours(0, 0, 0, 0)).getTime()) - new Date(new Date(new Date(rStartTime).setHours(0, 0, 0, 0)).getTime());
                        diffDays = Math.round(diffTime / 86400000) + 1;
                        if (diffDays > this._dateRender.length)
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                        diffMinutes = ((endHour - startHour) * 60) * diffDays;
                        cellIndex = ((this.model.endHour - this.model.startHour) * (60 /  (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount))) * day;
                        appWidth = (((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * this.cellwidth) + (diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount))) - 1;
                        leftPosition = "0";
                    }
                    else if (new Date(new Date(new Date(record[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) < new Date(new Date(new Date(record[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        var endDiffer = (new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.endHour, 0, 0)) && new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0))) ? (((this.model.endHour) / 2) * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                        var startDiffer = new Date(rStartTime) > new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0)) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        var i = 1, rEnd, rStart, end, start, diffTime;
                        rEnd = this._dateRender.indexOf(new Date(rEndTime).setHours(0, 0, 0, 0));
                        rStart = this._dateRender.indexOf(new Date(rStartTime).setHours(0, 0, 0, 0));
                        if (rEnd == -1) {
                            while (i < 7) {
                                if (new Date(this._dateRender[this._dateRender.length - i]).getTime() < new Date(rEndTime).setHours(0, 0, 0, 0)) {
                                    end = this._dateRender.length - i;
                                    endDiffer = this.model.endHour * 60;
                                    break;
                                }
                                else i++;
                            }
                        }
                        else
                            end = rEnd;
                        if (rStart == -1) {
                            start = day;
                            startDiffer = this.model.startHour * 60;
                        }
                        else
                            start = rStart;
                        diffTime = end - start;
                        diffMinutes = ((((diffTime) * ((endHour - startHour)) * 60) - startDiffer) + endDiffer);
                        cellIndex = (curIndex >= dayLength)? curIndex - ((curIndex % dayLength) % timeScaleRowCount) : curIndex - (curIndex % timeScaleRowCount);
                        var majorTime = this.getSlotByElement(headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex));                        
                        appWidth = (((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * this.cellwidth) + (diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount))) - 1;
                        if (diffDays > this._dateRender.length) {
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                            diffMinutes = ((diffDays) * (endHour - startHour) * 60);
                            appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.cellwidth + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 3);
                        }
                        leftPosition = (rStart == -1 ? 0 : ((rStartTime.getHours()*60 + rStartTime.getMinutes()) -( majorTime.startTime.getHours()*60 + majorTime.startTime.getMinutes()))*(this.cellwidth/Math.floor(this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount)));
                    }
                    else {                        
                        var cellCount = Math.ceil((new Date(rStartTime).getMinutes() +  (new Date(rStartTime).getMilliseconds() / 60))/(Math.round(this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount))) - 1;                        
                        leftPosition =(((Math.ceil(this._deviceRatio()) - 1) > 0) ? (Math.round(cellCount/2)==0)? -1 : Math.round(cellCount/2) : cellCount );
                        if ((this.model.endHour - this.model.startHour) == 24)
                            var diffInMinutes = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) - ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        else {
                            var endDiffer = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) > (this.model.endHour * 60) ? (this.model.endHour * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                            var startDiffer = ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) < (this.model.startHour * 60) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                            var diffInMinutes = endDiffer - startDiffer;
                        }
                        //diffInMinutes += 1;
                        var cellsCount= diffInMinutes* (this.cellwidth/((this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount))) / this.cellwidth;
                        appWidth = (diffInMinutes <= 0) ? 0 : diffInMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.cellwidth + ((diffInMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 1);
                        appWidth = appWidth - (((Math.ceil(this._deviceRatio()) - 1) > 0) ? Math.sqrt(cellsCount - 1) : 0);
                        cellIndex = (curIndex >= dayLength)? curIndex - ((curIndex % dayLength) % timeScaleRowCount) : curIndex - (curIndex % timeScaleRowCount);
                        var majorTime = this.getSlotByElement(headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex));
                        leftPosition = leftPosition + ((rStartTime.getHours()*60 + rStartTime.getMinutes()) -( majorTime.startTime.getHours()*60 + majorTime.startTime.getMinutes()))*(this.cellwidth/Math.floor(this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount));
                    }
					//appWidth=appWidth<1?this.cellwidth:appWidth;
                    var colorAppointment = this._appointmentColor(record);
                    if (this.model.allowInline && (!ej.isNullOrUndefined(record["inline"]))) {
                        topPosition = (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && !ej.isNullOrUndefined(this.model.group) ? 0 : topPosition;
                        this._inlineTemplate(record, leftPosition, topPosition, appWidth, appHeight, colorAppointment, false);
                        var celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
                        celltd.prepend($("<div class='e-inlinewrapper'></div>").append(this._inlineText));
                    }
                    else {
                        if ((!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0))
                            cellHeight = headerCell.eq((resValue + groupIndex) - 1).children()[cellIndex].offsetHeight + 1;
                        else cellHeight = cellHeight;
                        var indicationIcon = this._indicationApp(record);
                        if (topPosition + appHeight + 7 < cellHeight) {
                            var startTimeDisp = this._timeMode == "12" ? ej.format(new Date(record[this._appointmentSettings["startTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["startTime"]]), "HH:mm", this.model.locale),
                                endTimeDisp = this._timeMode == "12" ? ej.format(new Date(record[this._appointmentSettings["endTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["endTime"]]), "HH:mm", this.model.locale),
                                recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                                celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
                            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        }
                        else {
                            if (this.model.showOverflowButton) {
                                var overflowIconIndex = cellIndex + Math.round(new Date(rStartTime).getMinutes() / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount));
                                if ($("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).length == 0) {
                                    var celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(overflowIconIndex);
                                    var overflowhtml = '<div id="' + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex + '" class="e-icon e-arrowhead-down e-appsoverflow" data-cellinfo="' + this._dateRender[day] + '"></div>';
                                    celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(overflowhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(overflowhtml));
                                    topPosition = cellHeight - this.element.find('.e-appsoverflow')[0].offsetHeight;
                                    this.element.find("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).css(this.model.enableRTL ? "right" : "left", (this.cellwidth - 25) + "px").css("top", topPosition + "px");
                                }
                                $("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + overflowIconIndex).attr("data-appcount", level + 1);
                            }
                            else {
                                this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).children().css('height', cellHeight + appHeight - 1 + "px");
                                this.element.find(".e-resourceheadertable tr").eq(resValue + groupIndex - 1).find(".e-childnode").css('height', cellHeight + appHeight - 1 + "px");
                                var startTimeDisp = (this._timeMode == "12") ? ej.format(new Date(record[this._appointmentSettings["startTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["startTime"]]), "HH:mm", this.model.locale),
                                    endTimeDisp = (this._timeMode == "12") ? ej.format(new Date(record[this._appointmentSettings["endTime"]]), this._pattern.t, this.model.locale) : ej.format(new Date(record[this._appointmentSettings["endTime"]]), "HH:mm", this.model.locale),
                                    recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                    timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                                    celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
                                (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                                celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                                this._overflowFlag = true;
                            }
                        }
                    }
                    if (!ej.isNullOrUndefined(indicationIcon)) {
                        if (indicationIcon.leftIndication)
                            this.model.enableRTL ? this.element.find(".e-appointment").filter('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find(".e-appointment").filter('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                        if (indicationIcon.rightIndication)
                            this.model.enableRTL ? this.element.find(".e-appointment").filter('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find(".e-appointment").filter('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
                    }
                    if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1 && ej.isNullOrUndefined(record["inline"]))
                        this._renderAppointmentCategory(this._horiHeaderCollection, groupIndex, cellIndex, record, appWidth, leftPosition);
                }
            }
        },

        _renderAppointmentCategory: function (resCollection, groupIndex, cellIndex, record, appWidth, leftPosition) {
            var appointColor, categoryClass, index = 0, rGroupId, resIndex, rObject = [], rIndex;
            var resHeaderHeight = this.element.find(".e-resourceheadercells")[0].offsetHeight;
            if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 0) {
                appointColor = this._getResourceColor(record);
                categoryClass = (appointColor.appointData == "") ? "e-categorycolor" : "";
                groupIndex -= 1;
                appWidth = (this.currentView() == "month" || this._isCustomMonthView()) ? appWidth : appWidth + 2;
                do {
                    var celltd = this.element.find(".e-resourceheadertr").eq(groupIndex).find("td.e-workcells").eq(cellIndex);
                    var categorybarhtml = this.model.enableRTL ? ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;right:" + leftPosition + "px;'></div>") : ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;left:" + leftPosition + "px;'></div>");
                    celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(categorybarhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(categorybarhtml));
                    if (this._tempResource.length > 2) {
                        for (var a = this._tempResource.length - 2; a >= 0; a--) {
                            index = this._tempResource[a].resourceSettings.dataSource.indexOf(resCollection[groupIndex]);
                            if (index != -1) {
                                index = a;
                                rGroupId = this._tempResource[a].resourceSettings.groupId;
                                if (ej.isNullOrUndefined(rGroupId))
                                    return;
                                break;
                            }
                        }
                        resIndex = (index == 0) ? index : index - 1;
                        rObject = new ej.DataManager(resCollection).executeLocal(new ej.Query().where(this._tempResource[resIndex].resourceSettings.id, ej.FilterOperators.equal, resCollection[groupIndex][rGroupId]));
                        rIndex = this._tempResource[0].resourceSettings.dataSource.indexOf(rObject[0]);
                        if (rIndex == 0) {
                            rObject = [];
                            if (this._tempResource.length > 2) {
                                var celltd = this.element.find(".e-resourceheadertr").eq(rIndex).find("td.e-workcells").eq(cellIndex);
                                var categorybarhtml = this.model.enableRTL ? ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (resHeaderHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;right:" + leftPosition + "px;'></div>") : ("<div class='e-categorybar " + categoryClass + "' id='categorybar_" + record.Guid + "' style='position:absolute;height:" + (this.element.find(".e-resourceheadercells")[0].offsetHeight) + "px;background:" + appointColor.appointData + ";width:" + appWidth + "px;left:" + leftPosition + "px;'></div>");
                                celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(categorybarhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(categorybarhtml));
                            }
                        }
                        else (rObject.length != 0) ? groupIndex = resCollection.indexOf(rObject[0]) : "";
                    }
                } while (rObject.length != 0)
            }
        },

        _getHorizontalOverlapCount: function (appointments, dateRender, day, record, resValue) {
            var filterData = [];
            for (var i = 0, len = appointments.length; i < len; i++) {
                if (ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    if ((new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (new Date(new Date(appointments[i][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (((new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])))
                        && ((resValue != null) ? (resValue == appointments[i][this._tempResource[this._tempResource.length - 1]["field"]]) : resValue == null))) {
                        filterData.push(appointments[i]);
                    }
                }
                else {
                    if ((new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (new Date(new Date(appointments[i][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                    (((new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["startTime"]]) >= new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["startTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]])) ||
                        (new Date(record[this._appointmentSettings["endTime"]]) > new Date(appointments[i][this._appointmentSettings["startTime"]]) && new Date(record[this._appointmentSettings["endTime"]]) < new Date(appointments[i][this._appointmentSettings["endTime"]]))))) {
                        filterData.push(appointments[i]);
                    }
                }
            }
            return filterData;
        },

        _renderHorizontalHeaderBar: function () {
            var customview = this._isCustomMonthView(), view = this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month";
            var viewColCount = view == "day" ? 1 : view == "week" ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : this.model.workWeek.length;
            this._strTime = this._getStartEndTime();
            var colValue = this._columnTimeScale(this._strTime);
            this.datesColumn = this._getHeaderAllDayCellsCount();
            if (view === 'month' || (this._isCustomMonthView())) {
                this.datesColumn = [], this.monthDays = [], this.totdays = [];
                for (var i = 0; i < this._dateRender.length; i++) {
                    if (this.currentView() === "month" || (this._isCustomMonthView() && this._oneWeek)) {
                        if (new Date(this.currentDate()).getMonth() === new Date(this._dateRender[i]).getMonth())
                            this.totdays.push(this._dateRender[i]);
                    }
                    else
                        this.totdays.push(new Date(this._dateRender[i]));
                }
                var date = this.totdays.length;
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek" || (this.currentView() == "customview" && this._oneWeek))) {
                    var temp, columns = this._getUserDateheaderTemplate();
                    for (var i = 0; i < date; i++) {
                        temp = { currentDate: columns[i].currentDay, currentDateClass: "", currentDay: this.currentView() == "day" ? this._dayFullNames[new Date(this.totdays[i]).getDay()] : this._dayShortNames[new Date(this.totdays[i]).getDay()].toString(), cellWidth: !this.model.cellWidth ? "100%" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: (new Date(this.totdays[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime() ? "e-currentdayhighlight" : "") };
                        this.datesColumn.push(temp);
                        this.monthDays.push(this.totdays[i]);
                    }
                }
                else {
                    var temp, curdate, headerCellClass;
                    for (var i = 0; i < date; i++) {
                        headerCellClass = (new Date(this.totdays[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-currentdayhighlight" : "";
                        curdate = customview && new Date(this.totdays[i]).getDate() == 1 ? (ej.format(new Date(this.totdays[i]), "MMM", this.model.locale) + " " + new Date(this.totdays[i]).getDate()) : ej.format(new Date(this.totdays[i]), "dd", this.model.locale);
                        if (this.model.timeScale.enable)
                            temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this._dayFullNames[new Date(this.totdays[i]).getDay()].toString().slice(0, 1), cellWidth: (!this.model.cellWidth && this.currentView() != "month" && !(this._isCustomMonthView())) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                        else {
                            if (this.currentView() == "day" || this.currentView() == "week" || this.currentView() == "workweek")
                                temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this.currentView() == "day" ? this._dayFullNames[new Date(this.totdays[i]).getDay()] : this._dayShortNames[new Date(this.totdays[i]).getDay()].toString(), cellWidth: !this.model.cellWidth ? "100%" : this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                            else
                                temp = { daynameTitle: ej.format(new Date(this.totdays[i]), "dddd", this.model.locale), title: new Date(this.totdays[i]).toDateString(), currentDate: curdate, currentDateClass: "", currentDay: this._dayFullNames[new Date(this.totdays[i]).getDay()].toString().slice(0, 1), cellWidth: this.model.cellWidth, cellHeight: this.model.cellHeight, cellToday: headerCellClass };
                        }
                        this.datesColumn.push(temp);
                        this.monthDays.push(this.totdays[i]);
                    }
                }
            }
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
            if (userTemplateId || template) {
                var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var timeValue1 = [], j = 0;
                for (var i = this.model.startHour; i < this.model.endHour;) {
                    var timeValue = [];
                    var value = this.model.timeScale.majorSlot + j;
                    var jvalue = j;
                    while (j < value) {
                        var jval = j;
                        j = j * 60 * 1000;
                        if (this._timeMode == "12") {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        j = (j / 60000) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    }
                    i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                    j = (j >= 60) ? 0 : j;
                    timeValue1.push(timeValue);
                }
                template = true;
            }
            var multiResources = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? true : false;
            if (userTemplateId || template)
                var html = this.userTimeCellHoriTemplate.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), multiRes: multiResources, view: view, timeTdCount: this._strTime, colspan: view == "month" ? 1 : (this._strTime.length / viewColCount) * 2, heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: colValue, userTemplateId: userTemplateId, template: template });
            else
                var html = this.horizontalHeader.render({ tablelayout: customview ? "e-fixedlayout" : '', cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), multiRes: multiResources, view: view, timeTdCount: this._strTime, colspan: view == "month" ? 1 : (this._strTime.length / viewColCount) * 2, heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: colValue });
            this.aTR.append(html);
        },

        _renderHorizontalContent: function ($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv) {
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId);
            var trCount, resHtml, columnValue = [], value = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var strTime = this._strTime;
            columnValue = this._columnValue;
            if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                resHtml = this._renderHorizontalResources();
                trCount = this._horiResources;
            }
            else {
                resHtml = "";
                trCount = [{ classname: "e-childnode" }];
            }
            var userTemplate = (!ej.isNullOrUndefined(this.model.workCellsTemplateId)) ? true : false;
            if (userTemplate) { var workHtml = this._getUserWorkCellsTemplate(); }
            var workCellhtml = this.cellTemplate.render({ cellrows: trCount, hourdiff: Math.ceil(((this.model.endHour - this.model.startHour)) * (60 / this.model.timeScale.majorSlot)), view: this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month", cols: (this.model.timeScale.enable ? this.currentView() == 'month' || (this._isCustomMonthView()) ? this.datesColumn : strTime : this.datesColumn), column: columnValue, userTemplate: userTemplate, userHtml: workHtml });
            if (resHtml == "")
                this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
            else
                this.wTR.append(ej.buildTag('td.e-horizontalrestd', {}, {}, { width: "15%", height: "100%" }).append(resHtml)).append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
        },
        _columnTimeScale: function (strTime) {
            this._columnValue = []; var _cols2 = [];
            var value = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var templateValue = !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate);
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplate)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplate)) ? true : false;
            if (!templateValue) {
                for (var j = 0; j < strTime.length; j++) {
                    for (var i = 0; i < this.model.timeScale.minorSlotCount - 1; i++) {
                        value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value >= (this.model.endHour - this.model.startHour) * 60) {
                            _cols2.push(i);                           
                             value = 0;
                             break;                            
                        }
                        else
                            _cols2.push(i);
                    }
                    this._columnValue.push(_cols2);
                    value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    _cols2 = [];
                }
            }
            else {
                for (var j = 0; j < strTime.length; j++) {
                    this._columnValue.push(j);
                }
            }
            return this._columnValue;
        },

        _getResourceHeadTemplate: function (record) {
            var userTemp = $.templates($(this.model.resourceHeaderTemplateId).html());
            var userTempHtml = userTemp.render(record);
            return userTempHtml;
        },

        _renderHorizontalResources: function () {
            this._resCollect = []; this._horizontalResRender = []; this._horiResources = [];
            var view = this.currentView();
            var viewColCount = view == "day" ? 1 : view == "week" || view == "month" || (this._isCustomMonthView()) ? 7 : this.model.workWeek.length;
            var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
            if (!ej.isNullOrUndefined(this.model.group)) {
                if (this._grouping.length === 1) {
                    var index;
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i], null, null);
                    }
                    for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
                        this._horiResources.push({ cellHeight: this.model.cellHeight, name: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], idnum: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].id], classname: "e-childnode", marginleft: "10px", width: "10px", backgroundcolor: "", border: "1px solid #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(this._resourceInfo[index].dataSource[i], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                        this._resCollect.push(this._resourceInfo[index].dataSource[i]);
                    }
                    this._horizontalResRender.push(this._resCollect);
                }
                else {
                    var tempResource1 = this._resourceSort();
                    for (var a = 0; a < tempResource1.length; a++) {
                        for (var b = 0; b < this.render_Resources.length; b++) {
                            var rIndex = this.render_Resources[b].indexOf(tempResource1[a]);
                            if (rIndex != -1) {
                                index = b;
                                break;
                            }
                        }
                        if (index == this.render_Resources.length - 1) {
                            this._horiResources.push({ cellHeight: this.model.cellHeight, name: tempResource1[a][this._tempResource[index].resourceSettings.text], classname: "e-childnode", marginleft: ((this._mediaQuery) ? (index * 11) : (index * 21)) + "px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(tempResource1[a], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                            this._resCollect.push(tempResource1[a]);
                        }
                        else {
                            this._horiResources.push({ cellHeight: this.model.cellHeight, name: tempResource1[a][this._tempResource[index].resourceSettings.text], idnum: tempResource1[a][this._tempResource[index].resourceSettings.id] + "_" + tempResource1[a][this._tempResource[index].resourceSettings.groupId], classname: "e-parentnode", marginleft: (index * 10) + "px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", userResHeader: this._getResourceHeadTemplate($.extend(tempResource1[a], { classname: "e-parentnode" })), userResTemplId: userResTemplId });
                            this._resCollect.push(tempResource1[a]);
                        }
                    }
                    this._horizontalResRender.push(this._resCollect);
                }
            }
            else {
                for (var k = 0; k < this._tempResource.length; k++) {
                    this._horizontalResRender.push(this._tempResource[k].resourceSettings.dataSource);
                    this._resCollect.push(this._tempResource[k].resourceSettings.dataSource);
                }
            }
            var html = this.horizontalResHeader.render({ trs: this._horiResources });
            return html;
        },

        _horizontalResIcon: function () {
            var resCat = this.element.find(".e-parentnodecategory"), resId, cIndex, resAvail, count;
            for (var a = 0; a < resCat.length; a++) {
                resId = resCat[a].id.split("_")[0];
                for (var b = 0; b < this._tempResource.length; b++) {
                    cIndex = new ej.DataManager(this._tempResource[b].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[b].resourceSettings.id, ej.FilterOperators.equal, resId));
                    if (cIndex.length != 0) { cIndex = b; break; }
                }
                count = cIndex + 1;
                count = (count == this._tempResource.length) ? count - 1 : count;
                for (var c = 0; c < this._tempResource.length; c++) {
                    resAvail = new ej.DataManager(this._resourceSort()).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.groupId, ej.FilterOperators.equal, resId));
                    if (resAvail.length == 0) { $(resCat[a]).removeClass("e-resourceicon e-resourcecollapse"); }
                    break;
                }
            }
        },

        _renderHorizontalCurrentTime: function () {
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                if (this.element.find("td.e-headerToday").length > 0) {
                    this.element.find('.e-horizontaltabletimecell').parent().append('<div id="' + this._id + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline" style="height: 92%; width: 2px; position: absolute; background-color: red; "></div>');
                    $('#' + this._id + '_HighlightCurrentTimeline').css("top", this.element.find('.e-headerdays tr')[1].offsetTop);
                }
            }
            else {
                var monthDays = this.monthDays;
                var target = this.element.find(".e-headerdays").find("table").find("td");
                for (var i = 0; i < monthDays.length; i++) {
                    if (new Date(new Date(monthDays[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        $(target[i]).addClass("e-monthcurrenttime");
                }
            }
        },

        _horizontalTimePosition: function (temp, now) {
            if (temp.element.find("td.e-headerToday").length > 0) {
                var headertodaypos = temp.element.find("td.e-headerToday")[0].cellIndex;
                var cellIndex = (((temp.model.endHour - temp.model.startHour) * ((60 / temp.model.timeScale.majorSlot) * temp.model.timeScale.minorSlotCount)) * headertodaypos) + ((now.getHours() - temp.model.startHour) * ((60 / temp.model.timeScale.majorSlot) * temp.model.timeScale.minorSlotCount));
                var leftPosition = (parseFloat((now.getMinutes())) * (temp.element.find(".e-workcells")[1].offsetWidth) * temp.model.timeScale.minorSlotCount / temp.model.timeScale.majorSlot);
                $('#' + temp._id + '_HighlightCurrentTimeline').css("left", (cellIndex * temp.element.find(".e-workcells")[1].offsetWidth) + leftPosition);
            }
        },

        _horizontalBusinessHighlight: function (renderDates, bStartHour, bEndHour, timeRowsCount, target) {
            var tdLength = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._horiResources.length : 1;
            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                var colCount =Math.ceil (((this.model.endHour - this.model.startHour) * 60) / (this.model.timeScale.majorSlot/this.model.timeScale.minorSlotCount));
                for (var res = 0; res < tdLength; res++) {
                    for (var k = 0; k < renderDates.length; k++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(renderDates[k]).getDay()) {
                                $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[(k*colCount) +Math.ceil((bStartHour * timeRowsCount) + ((this.model.endHour - this.model.startHour) * timeRowsCount * 0)) - 1]).nextAll(".e-workcells").slice(0, ((bEndHour * timeRowsCount) - (bStartHour * timeRowsCount))).addClass("e-businesshighlightworkcells");
                            }
                        }
                    }
                }
            }
            else {
                var monthDays = this.monthDays;
                target = this.element.find(".e-workcells"); target.removeClass("e-monthcellhighlight");
                for (var res = 0; res < tdLength; res++) {
                    for (var i = 0; i < monthDays.length; i++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(monthDays[i]).getDay())
                                $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[i]).addClass("e-monthcellhighlight");
                        }
                    }
                }
            }
        },

        _onResourceClick: function (e) {
            var index, target, hide, show, tempRes, resCount, pNode, newResCollection, resHeadTable = [], resWorkTable = [];;
            target = $(e.currentTarget);
            if (target.hasClass("e-resourceicon e-resourcecollapse")) {
                target.removeClass("e-resourceicon e-resourcecollapse").addClass("e-resourceicon e-resourceexpand");
                hide = true;
            }
            else {
                target.removeClass("e-resourceicon e-resourceexpand").addClass("e-resourceicon e-resourcecollapse");
                show = true;
            }
            if (!this.model.cellHeight) {
                this.element.find(".e-workcellstab").css('height', '100%');
                this.element.find(".e-resourceheadertable").css('height', '100%');
            }
            index = $(e.currentTarget).closest("td.e-parentnode").parent().index();
            newResCollection = this._getResourceCollection();
            for (var i = 0; i < newResCollection.length; i++) {
                tempRes = new ej.DataManager(this._tempResource[i].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[i].resourceSettings.id, ej.FilterOperators.equal, e.currentTarget.id.split("_")[0]));
                if (tempRes.length != 0) {
                    resCount = tempRes[0].count;
                    break;
                }
            }
            for (var a = 0; a < resCount; a++) {
                resHeadTable.push(this.element.find(".e-resourceheadertable tr")[index + a + 1]);
                resWorkTable.push(this.element.find(".e-workcellstab tr")[index + a + 1]);
            }
            for (var i = 0; i < resHeadTable.length ; i++) {
                if (hide) {
                    pNode = $(resHeadTable[i]).children().hasClass("e-parentnode");
                    if (pNode) $(resHeadTable[i]).find(".e-parentnodecategory").removeClass("e-resourceicon e-resourcecollapse").addClass("e-resourceicon e-resourceexpand");
                    if ($(resHeadTable[i]).is(":visible")) {
                        $(resHeadTable[i]).toggle();
                        $(resWorkTable[i]).toggle();
                    }
                }
                else {
                    pNode = $(resHeadTable[i]).children().hasClass("e-parentnode");
                    if (pNode) $(resHeadTable[i]).find(".e-parentnodecategory").removeClass("e-resourceicon e-resourceexpand").addClass("e-resourceicon e-resourcecollapse");
                    if ($(resHeadTable[i]).is(":hidden")) {
                        $(resHeadTable[i]).toggle();
                        $(resWorkTable[i]).toggle();
                    }
                }
            }
            this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
            this._horizontalRender();
            if (this.model.cellHeight) this._reRenderScroller();
            if (this._mediaQuery) this.refreshScroller();
            this._horizontalResIcon();
            this.element.find("div.e-prevapp,div.e-nextapp").remove();
            this.element.find(".e-categorybar").height(this.element.find(".e-parentworkcell").height() - 3);
            this._businessHourScroller();
            this._renderAppointmentAll();
        },

    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {

    ej.ExcelFilter = ej.ExcelFilter || {};
    ej.excelFilter = function (options) {
		ej.loadLocale("ejExcelFilter");
        this._ctrlInstance = options["instance"];
        this.id = this._ctrlInstance._id;
        this._dialogContainer = null;
        this._showSort = options["showSortOptions"] || false;
        this._interDeterminateState = options["interDeterminateState"] || false;
        this._maxCount = ej.isNullOrUndefined(options["maxFilterLimit"]) ? 1000 : options["maxFilterLimit"];
        this._formatFiltering = true;
        this._locale = this._ctrlInstance.model.locale || "en-US";
        this.localizedLabels = this._getLocalizedLabel();
        this._filterHandler = options["filterHandler"] || null;
        this._searchHandler = this._ctrlInstance.model.searchSettings || null
		this._cancelHandler = options["cancelHandler"] || null;
		this._customFilterHandler = options["customFilterHandler"] || null;
        this._cssClass = options["cssClass"] || null;
        this._matchCase = options["allowCaseSensitive"] || false;
        this._title = options["title"] || this.localizedLabels.title;
        this._complexBlankCriteria = options["enableComplexBlankFilter"];
        this._blankValue = options["blankValue"];
        this.fName = options["initFilterCol"] || null;
        this._spliter = options["valueDelimiter"] || ej.ExcelFilter.valueDelimiter;
        this._initialFName = this.fName;
        this._displayName = null;
        this._dataSource = null;
        this._isUrlAdaptor = false;
		this._$tableID = null;
        this._$blankVal = null;
        this._$selectedColors = [];
        this._$enableColor = false;
        this._$filteredByColor = "";
        this._$colType = null;
        this._$key = 0;
        this.filteredColumn = null;
        this.sortedColumns = null;        
        this._chkList = null;
        this._listsWrap = null;
        this._menuWrap = null;
        this._localJSON = null;
        this._actualCount = 0;
        this._totalRcrd = 0;
        this._enableResponsiveRow=false;
        this._searchCount = 0;
        this._currentData = null;
        this._openedFltr = null;
        this._predicates = [];
        this.cFilteredCols = this.fName!=null ? [this.fName] : [];
        this._columnsFiltered = [];
        this.guid = ej.getGuid("excelfilter");
        this._noDlg = [];
        this._sepAftr = ["sortDesc","notequal", "between", "top10","endswith","contains"];
        this._posType = ["number", "date", "datetime", "string", "boolean","guid"];
        this._empties = !this._complexBlankCriteria ? [this.guid] : ["null", "undefined", ""];
        this._reqInProgess = false;
        this._isFiltered = false;
        this._onActionBegin = options["actionBegin"] || null;
        this._onActionComplete = options["actionComplete"] || null;
        this.maxItemOnQuery = 0; /*To prevent OData URI queryString length*/
        this.enableNormalize = true; /*To clean up redundant values after formatting */
        this.enableSelect = false;
        this._onDemandSearch = false;
        this._maxFilterCount = false;
        this._clearSearchValue = false;
		this._islargeData = false;
        this._checkedValue = [];
        this._searchRequest = false;
        this._isIndeterminate = false;
        this._selectAll = "<div class='e-ftrchk'><input type='checkbox' class='e-selectall' value='selectall' class='e-ftrchk' /><label class='e-ftrchk'>(" + this.localizedLabels.SelectAll + ")</label></div>";
        this._blanks = "<div class='e-ftrchk'><input type='checkbox' id='blanks' class='e-ftrchk' value='" + this._empties.join(this._spliter) + "' @@/><label class='e-ftrchk' for='blanks' value=''>(" + this.localizedLabels.Blanks + ")</label></div>";
        this._blank = undefined;
        this._addAtLast = false;
        this._addToFilter = "<div class='e-ftrchk'><input type='checkbox' class='e-addtofilter'/><label class='e-ftrchk'>" + this.localizedLabels.AddToFilter + "</label></div>";
        this._preChkList = [];
        this._checked = null;
        this._add = null;
        this.guidMenuOpt = [
              { id: 1, text: this.localizedLabels.SortNoSmaller, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortNoLarger, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.GuidFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.GuidMenuOptions }];
        this.numberMenuOpt = this.booleanMenuOpt = [
              { id: 1, text: this.localizedLabels.SortNoSmaller, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortNoLarger, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.NumberFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.NumberMenuOptions }];
        this.stringMenuOpt = [
              { id: 1, text: this.localizedLabels.SortTextAscending, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortTextDescending, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.TextFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.StringMenuOptions }];
        this.dateMenuOpt = [
              { id: 1, text: this.localizedLabels.SortDateOldest, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortDateNewest, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.DateFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.DateMenuOptions }];
        this.datetimeMenuOpt = [
              { id: 1, text: this.localizedLabels.SortDateOldest, sprite: "e-sortasc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortAsc" } },
              { id: 2, text: this.localizedLabels.SortDateNewest, sprite: "e-sortdesc e-icon e-fnsort", htmlAttribute: { "ejfnrole": "sortDesc" } },
              { id: 3, text: this.localizedLabels.SortByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 4, text: this.localizedLabels.ClearFilter, sprite: "e-filternone e-icon", htmlAttribute: { "ejfnrole": "clearfilter" } },
              { id: 5, text: this.localizedLabels.FilterByColor, htmlAttribute: { "ejfnrole": "popup" }, child: [] },
              { id: 6, text: this.localizedLabels.DateTimeFilter, htmlAttribute: { "ejfnrole": "filterpopup" }, child: this.localizedLabels.DatetimeMenuOptions }];
        return this;
    };
    ej.excelFilter.prototype = {
        //Helpers to handle (Blanks) value.
        isNotBlank: function (key, global) {
            var e = ej.isNullOrUndefined(key) || (key === ""||key===null);

            if (!global && (key === ""||key===null))/* Handle special case - since "" string sorted before all */
                this._addAtLast = true;

            return !e;
        },   
        _checkBlank: function (key) {         

            if (this.isNotBlank(key))
                return true;
            /*Ensure Blank value added only once */
            var ret = this._blank == undefined && !this._addAtLast;

            if (ret) this._blank = true;            

            return ret;
        },
        _getValueData: function (key, data) {
            var arr = this._empties;

            if (this.isNotBlank(key, true))
                arr = ej.distinct(data, this._$foreignKey || this.fName, false);

            return arr.join(this._spliter); /*Return value will be set to input element value attr*/
        },
        //Collection to predicate processing
        getPredicate: function (cols, field, updateModel) {
            this._isUrlAdaptor = this._ctrlInstance._dataSource() instanceof ej.DataManager && (this._ctrlInstance._dataSource().adaptor instanceof ej.UrlAdaptor || this._ctrlInstance._dataSource().adaptor instanceof ej.WebMethodAdaptor);
            var c, dis = field != undefined ? [field] : ej.distinct(cols, "field", false), collection, pred = {};
            for (var f = 0, flen = dis.length; f < flen; f++) {
                collection = new ej.DataManager(cols).executeLocal(new ej.Query().where("field", "equal", dis[f]));
                pred[dis[f]] = this.generatePredicate(collection);
                if (updateModel) {
                    this._predicates[this._$key] = this._predicates[this._$key] || {};
                    this._predicates[this._$key][dis[f]] = pred[dis[f]];
                }

            }
            return pred;
        },

        generatePredicate: function (cols) {
            var len = cols ? cols.length : 0, predicate, first;
            if (!len) return;
            first = this._updateDateFilter(cols[0]);
            if(this._isUrlAdaptor && (first.type == "date" || first.type == "datetime"))
                predicate = this._getDatePredicate(first);
            else
                predicate = first.ejpredicate ? first.ejpredicate : ej.Predicate(first.field, first.operator, first.value, first.ignoreCase || !first.matchcase);
            for (var p = 1; p < len; p++) {
                cols[p] = this._updateDateFilter(cols[p]);
                if (this._isUrlAdaptor && len > 2 && p > 1 && cols[p].predicate == "or"){
                    if (cols[p].type == "date" || cols[p].type == "datetime")                        
                        predicate.predicates.push(this._getDatePredicate(cols[p]));             
                    else
                        predicate.predicates.push(ej.Predicate(cols[p].field, cols[p].operator, cols[p].value, cols[p].ignoreCase || !cols[p].matchcase));
                }
                else{
                    if (this._isUrlAdaptor && (cols[p].type == "date" || cols[p].type == "datetime"))
                        predicate = predicate[cols[p].predicate](this._getDatePredicate(cols[p]));
                    else
                        predicate = cols[p].ejpredicate ? predicate[cols[p].predicate](cols[p].ejpredicate) : predicate[cols[p].predicate](cols[p].field, cols[p].operator, cols[p].value, cols[p].ignoreCase || !cols[p].matchcase);
                }
            }
            return predicate || null;
        },
        _getDatePredicate: function(predicate){
            return ej.Predicate(predicate.field, predicate.operator, predicate.value, predicate.ignoreCase || !predicate.matchcase);           
        },
        getFilterFrom: function (dm, data) {
            var data = ej.distinct(data, this.fName, false);
                        
            if (this.maxItemOnQuery > 0) data = data.slice(0, this.maxItemOnQuery);
                        
            return ej.UrlAdaptor.prototype.getFiltersFrom(data, new ej.Query().foreignKey(this._$foreignKey)); /*get [or] conditioned ejPredicate*/
        },
        /*Main Dialog*/
        renderDialog: function (type) {
            this._$colType = type;
            var dlgId = this.id + type + "_excelDlg";           
            //if ($("#" + dlgId).length != 0)
            //    return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcontainer e-shadow");
            var $ul = ej.buildTag("ul#" + this.id + type + "_MenuItem");
            var menuData = this._getMenuData(type);
            $ul = this._createLiTag($ul, menuData, false);
            var $searchBox = ej.buildTag("span.e-searchbox e-fields").append(ej.buildTag("input#" + this.id + "_SearchBox.e-ejinputtext e-searchinput", {}, {}, { "type": "text", "placeholder": this.localizedLabels.Search })).append(ej.buildTag("span.e-search e-icon"))
            var $lbox = ej.buildTag("div#" + this.id + type + "_CheckBoxList.e-checkboxlist e-fields").append(ej.buildTag("div"));
            var $btns = this._createBtn();
            var $sBox = ej.buildTag("div.e-searchcontainer");            
            var $status = ej.buildTag("div.e-status e-fields e-hide", this.localizedLabels.CheckBoxStatusMsg);
            $dlg.append($ul);            
            $sBox.append($searchBox);
            $sBox.append($status);
            $sBox.append($lbox);
            $sBox.append($btns);
            $dlg.append($sBox);
            $dlg.appendTo(this._ctrlInstance.element);
            $dlg.css("display", "none");
            this._renderCustomFDlg(type);
            this._dialogContainer = $dlg;
            if(this._cssClass!=null)
                $dlg.addClass(this._cssClass);
            if (!this._showSort) {
                $ul.find(".e-fnsort").closest("li").css("display", "none");
                $ul.find("li.e-separator:first").css("display", "none");
            }
            this._lsitBoxTemplate();
            this._renderSubCtrls(type);
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 10)
                ej.ieClearRemover($searchBox.find("input")[0]);
            this._wireEvents();
        },
        _getDeprecatedLocalizedLabel: function (key) {
            if (["Ok", "OK"].indexOf(key) != -1)
                return this.localizedLabels.Ok || this.localizedLabels.OK;
        },
        _renderSubCtrls: function (type) {
            $("#" + this.id + type + "_MenuItem").ejMenu({ orientation: "vertical", width: 266, container: "#" + this.id, click: ej.proxy(this._menuHandler, this), enableRTL: this._ctrlInstance.model.enableRTL, enableSeparator: false });
            $("#" + this.id + type + "_OkBtn").ejButton({ text: this._getDeprecatedLocalizedLabel("OK"), showRoundedCorner: true, width: 60, click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + this.id + type + "_CancelBtn").ejButton({ text: this.localizedLabels.Cancel, showRoundedCorner: true, width: 60, click: ej.proxy(this.closeXFDialog, this) });
            $("#" + this.id + type + "_CheckBoxList").ejScroller({ height: 130, width: 234, scroll: ej.proxy(this._virtualize,this) });
            $("#" + this.id + type + "_CheckBoxList").ejWaitingPopup({ showOnInit: false });
        },
        openXFDialog: function (options) {
			var obj;
            this.fName = options["field"];
            this._dataSource = options["dataSource"];
            this._$colType = options["type"] || "string";
            this._$format = options["format"] || "";
            this._enableResponsiveRow=options["enableResponsiveRow"];
            this.filteredColumn = options["filteredColumns"] || this._ctrlInstance.model.filterSettings.filteredColumns;
            this.sortedColumns = options["sortedColumns"] || this._ctrlInstance.model.sortSettings.sortedColumns;
            this._displayName = options["displayName"];
            this.query = options["query"] || new ej.Query();
            this._$key = options["key"] || 0;
			this._$tableID = options["tableID"];
			this._$blankVal = ej.isNullOrUndefined(this._$tableID) ? this._$blankVal : options["blank"];
            this._$selectedColors = options["selectedColors"] || [];
            this._$enableColor = options["enableColor"] || false;
            this._$filteredByColor = options["filteredByColor"] || this._$filteredByColor;
			this._$foreignField = options["foreignKeyValue"];
			this._$foreignData = options["foreignDataSource"];
			this._$foreignKey = options["foreignKey"];
			this._$foreignKeyType = options["foreignKeyType"];
			if (this._$foreignData instanceof ej.DataManager && (this._$foreignData.adaptor instanceof ej.ODataAdaptor || this._$foreignData.adaptor instanceof ej.ODataV4Adaptor || this._$foreignData.adaptor instanceof ej.WebApiAdaptor))
			    this.maxItemOnQuery = 50;
			$.extend(this.localizedLabels, options["localizedStrings"] || {});
            var args = { requestType : "filterbeforeopen", filterModel : this, columnName:this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            if (this._openedFltr == null || !this._openedFltr.is($("#" + this.id + this._$colType + "_excelDlg"))) {
                this.closeXFDialog();
                this._openedFltr = $("#" + this.id + this._$colType + "_excelDlg");
            }
            this._listsWrap = $("#" + this.id + this._$colType + "_CheckBoxList");
            this._menuWrap = $("#" + this.id + this._$colType + "_MenuItem");
            this._searchBox = this._openedFltr.find(".e-searchbox input");
            this._setPosition(this._openedFltr, options["position"]);
            this._openedFltr.addClass(options["cssClass"]);
            this._openedFltr.fadeIn(300, function () {
            });
			var $popups = $("#" + this.id + this._$colType + "_MenuItem").find("li[ejfnrole='popup']");
            if (this._$enableColor) {
                this._createDivTag($popups.eq(0).find(".e-shadow"), this._$selectedColors, false, "sort");
                (this._$filteredByColor == -1 || (this._$filteredByColor.length < 1 || this._$filteredByColor === this.fName)) ? this._createDivTag($popups.eq(1).find(".e-shadow"),this._$selectedColors, false, "filter") : $popups.eq(1).addClass("e-disable-item");
            }    
            else 
                $popups.hide();
            this._isFiltered = this._predicates[this._$key] != undefined && this._predicates[this._$key][this.fName] != undefined;
            this._isFiltered = options["isFiltered"] || this._isFiltered;
            if ((this._$colType == "date" || this._$colType == "datetime") && this._$format == "")
                this._$format = this._$colType == "date" ? "{0:MM/dd/yyyy}" : "{0:MM/dd/yyyy hh:mm:ss}";
            this._processListData();
			obj = this._listsWrap.data("ejScroller");
            if(this._ctrlInstance.model.enableRTL && obj.isHScroll()){
				obj.scrollLeft(obj.content()[0].scrollWidth - obj.content()[0].clientWidth);
				obj.refresh();
			}
                        
            this._setDisable();
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType };
            if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },
        closeXFDialog: function (e) {
            if (e != null) {
                var $target = $(e.target);
                if (!($target.closest("#" + this.id + this._$colType + "_CustomFDlg").length > 0 || $target.closest("#" + this.id + this._$colType + "_excelDlg").length > 0))
                    return;
            }            
            if (this._openedFltr) {
                if (!this._openedFltr.hasClass("e-dlgcustom")) {
                    this._openedFltr.fadeOut(300, function () {
                    });
                    this._listsWrap.ejWaitingPopup("hide");
                }
                else {
                    this._openedFltr.ejDialog("close");
                }
                !ej.isNullOrUndefined(this._cancelHandler) && this._cancelHandler();
                this.resetFilterModel();/*Reset private properties after filter closed*/
                this._ctrlInstance._$fDlgIsOpen = false;
            }
        },
        _setPosition: function (ele, pos) {
            ele.css("position", "absolute");
            ele.css("left", pos["X"]).css("top", pos["Y"]);                      
        },
        _setDisable: function () {
            var $clr = this._menuWrap.find("li[ejfnrole='clearfilter']"), $fltr = this._menuWrap.find("li[ejfnrole='filterpopup']");
            var $sort = this._menuWrap.find("li[ejfnrole *= 'sort']"), $checked = this._listsWrap.find("input").filter(":checked:not(.e-selectall)").length;
            !this._isFiltered ? $clr.addClass("e-disable-item") : $clr.removeClass("e-disable-item");
            if (this._showSort) {
                var sQM = ej.DataManager(this.sortedColumns).executeLocal(new ej.Query().where("field", "equal", this.fName));
                ( sQM.length && sQM[0]["direction"] == "ascending") ? $sort.filter("[ejfnrole='sortAsc']").addClass("e-disable-item") : $sort.filter("[ejfnrole='sortAsc']").removeClass("e-disable-item");
                (sQM.length && sQM[0]["direction"] == "descending") ? $sort.filter("[ejfnrole='sortDesc']").addClass("e-disable-item") : $sort.filter("[ejfnrole ='sortDesc']").removeClass("e-disable-item");
            }
            var $flteredList = $fltr.find(".aschild");
            if (this.cFilteredCols.length != 0 && $.inArray(this.fName,this.cFilteredCols) != -1) {
                for (var f = 0; f < this.filteredColumn.length; f++) {
                    if (this.filteredColumn[f].field == this.fName) {
                        if ($flteredList.find("#ejFiltercheck").length == 0) {
                            $flteredList.append("<input type='checkbox' id='ejFiltercheck' />");
                            $flteredList.find("#ejFiltercheck").ejCheckBox({ checked: true });
                            $flteredList.find("#ejFiltercheck").ejCheckBox("disable");
                        }
                        if ($fltr.find(".e-shadow .e-exceltick").length > 0)
                            $fltr.find(".e-shadow .e-exceltick").remove();
                        if (this.filteredColumn[f].field == this.fName && !ej.isNullOrUndefined(this.filteredColumn[f + 1]) && this.filteredColumn[f + 1].field == this.fName && (this._$foreignField && this.filteredColumn[f + 1].customFilter || !this._$foreignField)) {
                            if (this.filteredColumn[f].operator == "greaterthanorequal" && this.filteredColumn[f + 1].operator == "lessthanorequal")
                                $fltr.find(".e-shadow .e-list[ejvalue=between]").find("a").append("<span class='e-exceltick e-icon' />");
                            else
                                $fltr.find(".e-shadow .e-list[ejvalue=customfilter]").find("a").append("<span class='e-exceltick e-icon' />");
                        }
                        else if (this._$foreignField)
                            $fltr.find(".e-shadow .e-list[ejvalue=" + this.filteredColumn[f].actualFilterOperator + "]").find("a").append("<span class='e-exceltick e-icon' />");
                        else
                            $fltr.find(".e-shadow .e-list[ejvalue=" + this.filteredColumn[f].operator + "]").find("a").append("<span class='e-exceltick e-icon' />");
                        break;
                    }
                }
            }
            else {
                for (var f = 0; f < this.filteredColumn.length; f++) {
                    if (this.filteredColumn[f].field == this.fName) {
                        this._removeTick($fltr,$flteredList);
                        break;
                    }
                }
            }
            if (!this._isFiltered && $flteredList.find("#ejFiltercheck").length != 0) {
                 this._removeTick($fltr,$flteredList);
            }
            if (this._$colType == "boolean")
                this._menuWrap.find("li[aria-haspopup=true]").addClass("e-hide");            
            this._searchBox.val(""); this._searchBox.siblings().addClass("e-search").removeClass("e-cancel");
        },
        _removeTick: function($fltr,$flteredList){
            $flteredList.find("#ejFiltercheck").ejCheckBox("destroy");
            $fltr.find(".aschild #ejFiltercheck").remove();
            $fltr.find(".e-shadow .e-exceltick.e-icon").remove();
        },
        _createBtn: function (isCDlg) {
            var id = isCDlg ? this.id + this._$colType + "Custom" : this.id + this._$colType;
            var $divCon = ej.buildTag("div.e-btncontainer e-fields");
            var $div = ej.buildTag("div");
            $div.append(ej.buildTag("input#" + id + "_OkBtn.e-fltrbtn e-btnsub e-flat", {}, {}, { type: "button" })).append(ej.buildTag("input#" + id + "_CancelBtn.e-fltrbtn e-btncan e-flat", {}, {}, { type: "button" }));
            return $divCon.append($div);
        },
        _menuHandler: function (args) {
            var $ele = $(args.element);
            var role = $ele.attr("ejfnrole");
            var arg = {};
            if (role === "filterbgcolor" || role === "filterfgcolor") {
                var fDetails = { field: this.fName, operation: role, color: $(args.element).css('background-color')};
			    arg = { originalEvent: args.event, action: "filterbycolor", filterDetails: fDetails, tableID: this._$tableID }; 
                this._isFiltered = false;
            }
            else if (role == "clearfilter") {
                var ftrDetails = { field: this.fName, operator: "", value: "", predicate: "or" };
                arg = { originalEvent: args.event, fieldName: this.fName, action: "clearfiltering", filterDetails: ftrDetails, tableID: this._$tableID };
                var indx = $.inArray(this.fName, this.cFilteredCols);
                indx!=-1 && this.cFilteredCols.splice(indx, 1);
				var $cIndx = $.inArray(this.fName, this._columnsFiltered);
                $cIndx!=-1 && this._columnsFiltered.splice($cIndx, 1);
                if (this._initialFName == this.fName)
                    this._initialFName = null;
            }
            else if(role == "popup" || role == "filterpopup") {
                return;
            }
            else if (role == "operator") {
                this._openCustomFilter($ele.attr("ejvalue"));
            }
			else{
                var sOrder, sDetails;
				if(role == "sortAsc" || role == "sortDesc"){
					sOrder = role == "sortAsc" ? "ascending" : "descending";
					sDetails = { field: this.fName, direction: sOrder };
					arg = { originalEvent: args.event, action: "sorting", sortDetails: sDetails, tableID: this._$tableID };
				}
				else{
					sDetails = { field: this.fName, direction: sOrder, operation: role, color: $(args.element).css('background-color')};
					arg = { originalEvent: args.event, action: "sortbycolor", sortDetails: sDetails, tableID: this._$tableID }; 
				}
            }
            if (role != "operator") {
                this._filterHandler(arg);
                this.closeXFDialog();
            }
        },
        _searchBoxFocus: function (e) {
            var $target = $(e.target);
            if ($target.hasClass("e-cancel")) {
                $target.prev().val("");
                $target.next().addClass("e-cancel")
                $target.addClass("e-search");
                $target.prev().trigger("keyup");
            }
            if (e.type == "focusin") {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _search: function (e) {
            var enterText = e.target.value, args = {}, parsed, operator, $target = $(e.target);
            parsed = (this.getType() != "string" && parseFloat(enterText)) ? parseFloat(enterText) : enterText;
            operator ="contains" ;
            parsed = (parsed == "" || parsed == undefined) ? undefined : parsed;
            if (this._$colType == "boolean") {
                if (parsed != undefined && this.localizedLabels.True.toLocaleLowerCase().indexOf(parsed.toLowerCase()) != -1)
                    parsed = "true";
                else if (parsed != undefined && this.localizedLabels.False.toLocaleLowerCase().indexOf(parsed.toLowerCase()) != -1)
                    parsed = "false";
            }
            if (this._$colType == "date" || this._$colType == "datetime") {
                parsed = ej.parseDate(enterText, this.replacer(this._$format, /{0:|}/g, ""));
                operator = "equal";
                if (this._previousValue == null && parsed == null)
                    return;
            }
            this._previousValue = parsed;
            delay = this._dataSource instanceof ej.DataManager && (this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) ? 1500 : 0;
            sender = { type: "filterchoicesearch", value: parsed, operator: operator, matchcase: ["date", "datetime"].indexOf(this._$colType) != -1 ? false : this._matchCase }
            this._processSearch(sender, delay);
            if ($target.val() == "") {
                $target.next().addClass("e-search");
                $target.next().removeClass("e-cancel");
            } else {
                $target.next().addClass("e-cancel");
                $target.next().removeClass("e-search");
            }
        },
        _processSearch: function (sender, delay) {
            if (!this._alreadySearchProcessed) {
                this._alreadySearchProcessed = true;
                this._startTimer(sender, delay);
            } else {
                this._stopTimer();
                this._startTimer(sender, delay);
            }
        },
        _startTimer: function (sender, delay) {
			proxy = this;
            this._timer = window.setTimeout(
                function () {
                    proxy._processListData(sender);
                }, delay)
        },
        _stopTimer: function () {
            if (this._timer != null)
                window.clearTimeout(this._timer);
        },
        _getLocalizedLabel: function (property) {
            return ej.getLocalizedConstants("ej.ExcelFilter", this._locale);
        },
        _getMenuData: function (type) {
            return type != undefined ? this[type + "MenuOpt"] : [];
        },
		_checkHtmlEncode: function(key){
           var isEncode = !ej.isNullOrUndefined(this._ctrlInstance.getColumnByField) ? this._ctrlInstance.getColumnByField(this.fName).disableHtmlEncode : false;
           var bool = !ej.isNullOrUndefined(isEncode) && isEncode  ? true : false;
           return bool;
        },
        /*CheckBox list*/
        _lsitBoxTemplate: function () {
            var helper = {}, temp = {};            
            helper[this.id + "isNotBlank"] = ej.proxy(this.isNotBlank, this);
            helper[this.id + "checkBlank"] = ej.proxy(this._checkBlank, this);
            helper[this.id + "_getValueData"] = ej.proxy(this._getValueData, this);            
            helper[this.id + "_checkBoxState"] = ej.proxy(this._setCheckState, this);          
            helper[this.id + "_htmlEncode"] = ej.proxy(this._checkHtmlEncode, this);    
            helper[this.id + "_genId"] = this._genCheckID;
            $.views.helpers(helper); 			
            var genID = this.id + this._$colType + "{{:~" + this.id + "_genId()}}";
            temp[this.id + this._$colType + "_listBox_Template"] = "{{if ~" + this.id + "checkBlank(key)}}<div class='e-ftrchk'><input type='checkbox' id='" + genID + "' value='{{html:~" + this.id + "_getValueData(key, items)}}' class='e-ftrchk' {{:~" + this.id + "_checkBoxState(~" + this.id + "_getValueData(key, items))}}/><label class='e-ftrchk' for='" + genID + "'>{{if ~" + this.id + "isNotBlank(key,'true')}} {{if ~" + this.id + "_htmlEncode(key)}} {{>key}} {{else}} {{:key}} {{/if}} {{else}} (Blanks) {{/if}}</label></div>{{/if}}";
            $.templates(temp);
        },
      
        _processListData: function (params) {
            var result, promise, args = {}, query = new ej.Query(), searchQuery = new ej.Query().requiresCount(), evtArgs = {}; this._searchCount = 0;
            var predicates = this._predicates[this._$key], pred;
			var data = null, columnName = null, localJSON = null, result = null;
			if(ej.isNullOrUndefined(this._$foreignField && this._$foreignData)){
				data = this._dataSource; 
				columnName =  this.fName;
				localJSON = this._localJSON;
			}
			else{
				data = localJSON = this._$foreignData; 
				if(this._dataSource instanceof ej.DataManager && !(data instanceof ej.DataManager))
                    data = ej.DataManager(data);
				columnName = this._$foreignField;
			}
            for (var prop in predicates) {
                if (prop == this.fName)
                    continue;
                var obj = predicates[prop], from = obj["from"];
                if (from)
                    query.skip(from == "top" ? 0 : data.length - (data.length - obj["take"])).take(obj["take"]);
                else
                    pred = pred != undefined ? pred["and"](obj) : obj;
            }
            args.columnName = columnName;           
            query.requiresCount();
            if (this._dataSource instanceof ej.DataManager && !this._dataSource.dataSource.offline && this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) {
                query.take(this.maxFilterChoices);
                this._onDemandSearch = true;
            }
		    pred && query.where(pred);
            ej.merge(query.queries, this.query.queries) || ej.merge(query._params, this.query._params)
            evtArgs.requestType = params ? params.type : "filterchoicerequest",evtArgs.filterModel = this, evtArgs.query = query, evtArgs.dataSource = data;
            if(evtArgs.requestType == "filterchoicesearch")
				evtArgs.queryParams = params;
			if (this._ctrlInstance._trigger(this._onActionBegin, evtArgs))
                return;
            if (!ej.isNullOrUndefined(this._searchHandler) && this._searchHandler.key.length) {
                var searchDetails = this._searchHandler;
                query.search(searchDetails.key, searchDetails.fields, searchDetails.operator || "contains", searchDetails.ignoreCase || true);
            }
            if (this.enableSelect)
                query.select(this.fName);
            if (params && params.type == "filterchoicesearch") {
                this._clearSearchValue = ej.isNullOrUndefined(params.value) ? true : false;
                args.type = params.type;
                args.value = params.value;
                if (this._$foreignField) query = searchQuery;
                params.value && query.where(columnName, params.operator, params.value, !params.matchcase);
                if (this._dataSource instanceof ej.DataManager && this._ctrlInstance._gridRecordsCount > this._ctrlInstance.model.filterSettings.maxFilterChoices) {
                    this._searchRequest = true;
					var type = this._$colType;
                    var dlgId = this.id + type + "_excelDlg";   
                    if($("#" + dlgId).is(":visible"))
                     this._listsWrap.ejWaitingPopup("show");
                    if (this._$foreignField) {
                        var frKeyData = this._$foreignData instanceof ej.DataManager ? this._$foreignData : ej.DataManager(this._$foreignData);
                        this._dataProcessing(frKeyData, query, args);
                    }
                    else
                        this._dataProcessing(this._dataSource, query, args);
                }
                else
                    this._dataProcessing(ej.DataManager(this._localJSON), query, args);
            }
            else if (!(this._dataSource instanceof ej.DataManager)) {
				var result = [];
                promise = ej.DataManager(this._dataSource).executeLocal(query);
                args.type = "filterchoicerequest";
                if (this._$foreignField)
                    this._filterForeignData(promise, args);
                else {
                    result = promise.result;
                    args.data = this._localJSON = this._currentData = result;
                    this._totalRcrd = promise.count;
                    this._setCheckBoxList(args);
                }
            }
            else {
                proxy = this; args.type = "filterchoicerequest";
                this._listsWrap.ejWaitingPopup("show");
                if (!this._reqInProgess) {
                    this._reqInProgess = true;
					if(this._$foreignField)
                        data = this._dataSource;
                    promise = data.executeQuery(query);
                    promise.done(function (e) {
                        if (proxy._$foreignField)
                            proxy._filterForeignData(e, args);
                        else {
                            result = e.result;
                            args.data = proxy._localJSON = proxy._currentData = result;
                            proxy._totalRcrd = e.count;
                            proxy._listsWrap.ejWaitingPopup("hide");
                            proxy._setCheckBoxList(args);;
                            proxy._reqInProgess = false;
                        }
                    });
                }
            }           
        },
        _dataProcessing: function (dataSource, query, args) {
            var result, promise;
            promise = dataSource.executeQuery(query);
            promise.done(function (e) {
                args.data = proxy._currentData = e.result;
                proxy._totalRcrd = proxy._searchCount = e.result.length;
                proxy._setCheckBoxList(args);
            });
        },
        _filterForeignData: function (fromPromise, args) {
            var custom = typeof args === "boolean", key = this._$foreignKey,
               field = this._$foreignField, type = this._$foreignKeyType,
                result, count, proxy = this, defaults = {}, pred, tmp, actuals, query = new ej.Query(),
                dm = this._$foreignData instanceof ej.DataManager ? this._$foreignData : ej.DataManager(this._$foreignData);
            if (!custom) {
                result = fromPromise.result, count = fromPromise.count;
                if (!!count)
                    query.where(this.getFilterFrom(this._$foreignData, result));
                if (!this._listsWrap.ejWaitingPopup("model.showOnInit"))
                    this._listsWrap.ejWaitingPopup("show");
            }
            else {
                tmp = fromPromise[0], defaults = fromPromise[0], actuals = fromPromise.slice();
                if (!!tmp)
                    this.closeXFDialog();
                pred = new ej.Predicate(field, tmp.operator, tmp.value, !tmp.matchcase);
                for (var i = 1, tmp, len = fromPromise.length; i < len; i++) {
                    tmp = fromPromise[i], pred = pred[tmp.predicate](field, tmp.operator, tmp.value, !tmp.matchcase);
                }
                query.where(pred);
            }
            query.select([key, field]);
            dm.executeQuery(query).done(function (e) {
                if (!custom) {
                    args.data = proxy._localJSON = proxy._currentData = e.result;
                    proxy._totalRcrd = count;
                    proxy._listsWrap.ejWaitingPopup("hide");
                    proxy._setCheckBoxList(args);
                    proxy._reqInProgess = false;
                } else {
                    var dst = ej.distinct(e.result, key, true), dst = 0 in dst ? dst : [{}];
                    var coll = dst.map(function (val, ind) {
                        return $.extend({}, defaults, { value: val[key], operator: "equal", actuals: actuals, type: type });
                    });
                    proxy.initiateFilter(coll);
                }
            });
        },
        _setCheckBoxList: function (args) {
            var evtArgs = {}, _blank ="", sortedData, flag, blank = this._blanks, $checked;
            evtArgs.requestType = args.type, evtArgs.dataSource = this._dataSource, evtArgs.filterModel = this;
            if (this._currentData.length != 0) {                
                sortedData = this.getDistinct(args.data, args.columnName, true, !!this._$foreignKey);
                flag = this._isFiltered;                
                this._actualCount = sortedData.length; sortedData.length = this._maxCount > this._actualCount ? this._actualCount : this._maxCount;               
                (this._onDemandSearch && this._actualCount == 1000) || this._actualCount >= this._maxCount ? this._openedFltr.find("div.e-status").removeClass("e-hide") : this._openedFltr.find("div.e-status").addClass("e-hide");
                this._islargeData = this._maxCount < this._actualCount ? true : false;
				this._filterdCol = ej.DataManager(this.filteredColumn).executeLocal(ej.Query().where("field", "equal", this.fName));               
				if ((args.type == "filterchoicesearch") && (!ej.isNullOrUndefined(args.value)))
                    this._listsWrap.find("div:first").html([this._selectAll, this._addToFilter, $.render[this.id + this._$colType + "_listBox_Template"](sortedData), this._addAtLast ? this.replacer(blank, /@@/g, this._setCheckState, this._empties.join(this._spliter)) : ""].join(""));                
                else 
                    this._listsWrap.find("div:first").html([this._selectAll, $.render[this.id + this._$colType + "_listBox_Template"](sortedData), this._addAtLast ? this.replacer(blank, /@@/g, this._setCheckState, this._empties.join(this._spliter)) : ""].join(""));                
                this._chkList = this._listsWrap.find("input:checkbox").not(".e-selectall,.e-addtofilter"), $inView = this._chkList.slice(0, 20);
                $inView.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
                $inView.siblings().height(14).width(14);
                this._listsWrap.find(".e-addtofilter").ejCheckBox({ change: ej.proxy(this._addToFilterHandler, this) });
                this._listsWrap.find(".e-addtofilter").attr("id", this.id + this._$colType + "AddToFilter");
                this._listsWrap.find(".e-selectall").ejCheckBox({ change: ej.proxy(this._selectAllHandler, this), enableTriState: this._interDeterminateState, beforeChange: this._selectAllBeforeHandler });
				this._listsWrap.find(".e-selectall").attr("id",this.id + this._$colType + "SelectAll");
                this._listsWrap.find(".e-selectall,.e-addtofilter").siblings().height(14).width(14);
				this._listsWrap.find(".e-selectall").closest("span").siblings("label").attr("for", this.id + this._$colType + "SelectAll");
            }
            else
            {
                this._listsWrap.find("div").first().html(ej.buildTag("div.e-ftrchk", this.localizedLabels.NoResult, {}, {}));
                this._chkList = this._listsWrap.find("input:checkbox").not(".e-selectall");
            }
            if (!ej.isNullOrUndefined(this._chkList))
                $checked = this._chkList.filter(":checked").length;
            if (this._isFiltered && this._searchRequest && $checked == 0)
                this._checkIsIndeterminate(args.columnName, this.filteredColumn);
            if (!this._isFiltered || this._actualCount == $checked)
                this._listsWrap.find(".e-selectall").ejCheckBox({ checked: true });
            else if ($checked > 0 || this._isIndeterminate && this._interDeterminateState)
                this._listsWrap.find(".e-selectall").ejCheckBox('model.checkState', 'indeterminate');
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: $checked != 0 });
            this._listsWrap.ejScroller({ scrollTop: 0 }).ejScroller("refresh");
             if(this._listsWrap.hasClass('e-waitingpopup'))
                this._listsWrap.ejWaitingPopup("hide");
            if (this._ctrlInstance._trigger(this._onActionComplete, evtArgs))
                return;
            this._isIndeterminate = false;
            this._checkedValue = [];
            if (args.type == "filterchoicerequest") {
                this._preChkList = this._chkList;
                this._checked = this._preChkList.filter(":checked");
            }
            if (this._listsWrap.find(".e-addtofilter").length)
                this._add = this._listsWrap.find(".e-addtofilter");
            else
                this._add = null;
        },
        _addToFilterHandler: function (args) {
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: args.isChecked || !!this._chkList.filter(":checked").length });
        },
        _checkIsIndeterminate: function (colName, filteredCol) {
            for (var i = 0 ; i < filteredCol.length; i++) {
                if (colName == filteredCol[i].field)
                    this._isIndeterminate = true;
            }
        },
        _createLiTag: function ($ul, menuData, isChild) {
            proxy = this;
            $.each(menuData, function (index, obj) {
                var $li = ej.buildTag("li", {}, {}, obj["htmlAttribute"] || (isChild && { "ejfnrole": "operator", "ejvalue": obj.value }) || {}), $child;
                var apd = (isChild && $.inArray(obj.value,proxy._noDlg)==-1) ? "..." : "";
                var $a = ej.buildTag("a", obj.text + apd, {}, {});
                obj["sprite"] != undefined && $a.append(ej.buildTag("span", {}, {}, { "class": obj["sprite"] }))
                if (obj["child"] != undefined){
                    if(obj.id != 3 && obj.id != 5)
                        $child = proxy._createLiTag(ej.buildTag("ul.e-shadow"), obj["child"], true);
                    else if(obj.id === 3 )
                        $child = proxy._createDivTag(ej.buildTag("ul.e-shadow"), obj["child"], true, "sort");
                    else
                        $child = proxy._createDivTag(ej.buildTag("ul.e-shadow"), obj["child"], true, "filter");
				}
                obj["child"] == undefined ? $ul.append($li.append($a)) : $ul.append($li.append($a).append($child))
                if ($.inArray(obj.value || (obj.htmlAttribute && obj.htmlAttribute.ejfnrole), proxy._sepAftr) != -1)
                    $ul.append(ej.buildTag("li.e-separator"));
            });
            return $ul;
        },
		
		_createDivTag: function ($ul, menuData, isChild, reqType) {
            var $li, $a, $div, bgColor = [], fgColor = [], avble = false, cellcolor = "", fontcolor = "", selCellHdr = "", selCellClr = "", selFontHdr = "", selFontClr = "";
            if (reqType == "sort") {
                cellcolor = this.localizedLabels.SortByCellColor;
                fontcolor = this.localizedLabels.SortByFontColor;
            }
            else{
                cellcolor = this.localizedLabels.FilterByCellColor;
                fontcolor = this.localizedLabels.FilterByFontColor;
            }
			selCellHdr = reqType + "colorhdr";
            selFontHdr = reqType + "fonthdr";
            selCellClr = reqType + "bgcolor";
            selFontClr = reqType + "fgcolor";
            ($ul.length > 0) && $ul.children().remove();
            if(menuData.length > 0){
			    for(var i = 0; i < menuData.length; i++){
				    for(var j = 0; j < bgColor.length; j++){
					    if(bgColor[j] == menuData[i].background){
						    avble = true;
						    break;
					    }
				    }
				    if(!avble && (!ej.isNullOrUndefined(menuData[i].background) && !menuData[i].background.startsWith('#6n'))) 
                        bgColor.push(menuData[i].background);
				    avble = false;
				    for(var j = 0; j < fgColor.length; j++){
					    if(fgColor[j] == menuData[i].foreground){
						    avble = true;
						    break;
					    }
				    }
				    if(!avble && (!ej.isNullOrUndefined(menuData[i].foreground) && !menuData[i].foreground.startsWith('#6n'))) 
                        fgColor.push(menuData[i].foreground);
				    avble = false;
			    }
                if(bgColor.length > 0){
                    $li = ej.buildTag("li.e-list e-bghdrcolor", "", "" , {"ejfnrole": selCellHdr });
                    $a = ej.buildTag("a.e-menulink", cellcolor, {});
                    $li.append($a);
                    $ul.append($li);
			        for(var i = 0; i < bgColor.length; i++){
                        $li = ej.buildTag("li.e-list e-valcolor", {}, {'background-color': bgColor[i]}, {"ejfnrole": selCellClr });
                        $ul.append($li);
			        }
                }
                if(fgColor.length > 0){
			        $li = ej.buildTag("li.e-list e-fghdrcolor", "", "" , {"ejfnrole": selFontHdr });
                    $a = ej.buildTag("a.e-menulink", fontcolor, {});
                    $li.append($a);
                    $ul.append($li);
                    for(var i = 0; i < fgColor.length; i++) {
                        $li = ej.buildTag("li.e-list e-valcolor", {}, {'background-color': fgColor[i]}, {"ejfnrole": selFontClr });
                        $ul.append($li);
                    }
                }
                (bgColor.length < 1 && fgColor.length < 1) ? $ul.parent().addClass("e-disable-item"): $ul.parent().removeClass("e-disable-item");
            }
            else {
                $ul.parent().addClass("e-disable-item");
            }
            return $ul;
        },
		
        _setCheckState: function (value) {           
            var val = value, fobj, splts = value.split(this._spliter), splen = splts.length, flag = false;           
            if (!this._isFiltered || this._searchCount)
                return "checked";
            else {
               
                while (splen--) { /*looped for split values*/
                    val = this.processValue(splts[splen]);

                    //Date and boolean will be checked as iteration due to 
                    if (this._$colType == "date" || this._$colType == "datetime" || this._$colType == "boolean") {
                        for (var i = 0, len = this._filterdCol.length; i < len; i++) {
                            if (this._$colType == "boolean" && val !== this._filterdCol[i].value)
                                continue;
                            if (this._$colType == "date" || this._$colType == "datetime") {
                                var firstVal = this._$colType == "date" && val instanceof Date ? this._formatting(this._$format, new Date(val.getFullYear(), val.getMonth(), val.getDate()), this._locale) : this._formatting(this._$format, val, this._locale);
                                var secondVal = this._formatting(this._$format, this._filterdCol[i].value, this._locale);
                                if ((firstVal !== secondVal || this._filterdCol[i].operator != "equal") && !this._maxFilterCount)
                                    continue;
                                else {
                                    if (this._maxFilterCount && (this._onDemandSearch || this._islargeData)) {
                                        if (firstVal == secondVal) {
                                            this._checkedValue.push(firstVal);
                                            return ""
                                        }
                                        else if (this._checkedValue.indexOf(secondVal) == -1 || this._checkedValue.length == this._filterdCol.length)
                                            return "checked";
                                        else
                                            continue;
                                    }
                                }
                            }
                            return "checked";
                        }
                    }
                    else {
                        if (this._$colType == "string" && !ej.isNullOrUndefined(val)) {
                            if (this._filterdCol[0].value == val.toLowerCase())
                                val = val.toLowerCase();
                        }
                        var fQ = ej.DataManager(this._filterdCol).executeLocal(ej.Query().where("value", "equal", val).where("operator", "equal", "equal"));
                        if (fQ.length != 0) {
                            if (fQ[0].operator == "equal" &&(!ej.isNullOrUndefined(fQ[0].actualFilterOperator) && fQ[0].actualFilterOperator=="equal") && fQ[0].isCustom == true && this._ctrlInstance.model.currentViewData.length > 0)
                                return "checked";
                            else
                                return fQ[0]["isCustom"] === true ? "" : "checked";
                        }
                        else {
                            if ((this._onDemandSearch || this._islargeData) && this._maxFilterCount) {
                                var fltrQury = ej.DataManager(this._filterdCol).executeLocal(ej.Query().where("value", "equal", val).where("operator", "notequal", "equal"));
                                if (fltrQury.length == 0)
                                    return "checked";
                            }
                        }
                    }
                }
            }
        },
        _genCheckID: function () {
            return "CheckBox" + this.getIndex();
        },
        _formatting: function (format, value, locale) {

            if (this._$colType == "date" && format == "")
                format = "{0:MM/dd/yyyy hh:mm:ss}";

            if (this._$colType == "boolean")                 
                return value === "" ? "" : this.localizedLabels[value == true ? "True" : value == false ? "False" : ""];
           
            if (this._formatFiltering || this._$colType == "date") {
                var formatter = this._ctrlInstance.formatting;                
                return format != "" ? formatter(format, value, locale) : value;
            } 
        },
        _updateDateFilter: function (filter) {
            if (filter.type != "date" && !(filter.value instanceof Date))
                return filter;            
            filter.value = filter.value instanceof Date ? filter.value : ej.parseJSON({ val: filter.value }).val;
            return ["equal", "notequal"].indexOf(filter.operator) == -1 ? filter : this._setDateObject(filter);
        },        
        _checkHandler: function (args) {
            $("#" + args.model.id).prop("checked", args.isChecked);
            var $checkedlist = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall,.e-addtofilter)"), clen = $checkedlist.length;
            var $selectall = this._listsWrap.find(".e-selectall"), canCheck;
            if (clen == this._chkList.length) {
                $selectall.prop("checked", true);
                canCheck = true;
            }
            else if (clen == 0) {
                $selectall.prop("checked", false);
                canCheck = false;
            }
            else if (args.isInteraction)
                $selectall.ejCheckBox('model.checkState', 'indeterminate')
            $selectall.ejCheckBox({ checked: canCheck });
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: (clen != 0) || (!ej.isNullOrUndefined(this._add) && this._add.prop("checked")) });
        },
        _selectAllBeforeHandler: function (args) {
            if (args.isChecked) {
                if (this.model.checkState == "indeterminate") {
                    args.cancel = true;
                    this.model.checkState = "uncheck";
                    this.option({ checkState: "check" })
                }
                else
                    this.checkState("uncheck");
            }
        },
        _selectAllHandler: function (args) {
            
            if (args.checkState=="check"){
                this._chkList.filter(":not(:checked)").ejCheckBox({ checked: args.isChecked });
                this._chkList.prop("checked", true);
            }
            else if (args.checkState == "uncheck") {
                this._chkList.filter(function () { if ($(this).hasClass("e-checkbox") && $(this).prop("checked")) return this; }).ejCheckBox({ checked: args.isChecked });
                this._chkList.prop("checked", false); this._chkList.removeAttr("checked");
            }
            $("#" + this.id + this._$colType + "_OkBtn").ejButton({ enabled: args.isChecked || (!ej.isNullOrUndefined(this._add )&& this._add.prop("checked")) });
        },
        /*Custom Dialog*/
        _renderCustomFDlg: function (type) {
            var dlgId = this.id + type + "_CustomFDlg";
            if ($("#" + dlgId).length)
                return;
            var $dlg = ej.buildTag("div#" + dlgId + ".e-excelfilter e-dlgcustom");
            $dlg.addClass(this._cssClass);
            this._renderCDlgContent($dlg, type);
            $dlg.ejDialog({ showOnInit: false, enableResize: false, enableModal: true, allowKeyboardNavigation: false, title: this._title, width: 370, content: "#" + this.id, enableRTL: this._ctrlInstance.model.enableRTL, closeIconTooltip: "Close", cssClass: "e-excelfilter e-customDlg" });
			$dlg.ejDialog("refresh");
        },

        _renderCDlgContent: function (content, type) {
            var $div1 = ej.buildTag("div.e-dlgfields",this.localizedLabels.Showrowswhere, {}, {});
            var $id = this.id + this._$colType;
            var $fset = ej.buildTag("fieldset.e-fieldset");
            var $op1 = ej.buildTag("tr.e-fields"), $op2 = ej.buildTag("tr.e-fields"), $op3 = ej.buildTag("tr.e-fields e-top");
            var $dp1 = ej.buildTag("input#" + $id + "_CustomDrop1"), $dp2 = ej.buildTag("input#" + $id + "_CustomDrop2"), $dp3 = ej.buildTag("input#" + $id + "_CustomDrop3");
            var $in1 = ej.buildTag("input#" + $id + "_CustomValue1.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" }), $in2 = ej.buildTag("input#" + $id + "_CustomValue2.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" }), $in3 = ej.buildTag("input#" + $id + "_CustomValue3.e-ejinputtext e-excustmfltr", {}, {}, { "type": "text" });
            var $pred = ej.buildTag("tr.e-predicate");
            var radioAnd = ej.buildTag("input#" + $id + "_CustomAndPredicate", {}, {}, { "type": "radio", "name": "predicate" , "value":"and" }), radioOr = ej.buildTag("input#" + $id + "_CustomOrPredicate", {}, {}, { "type": "radio", "name": "predicate", "value":"or" });
            var matchCase = ej.buildTag("input#" + $id + "_CustomMatchPredicate", {}, {}, { "type": "checkbox" });
            content.append($div1);
            var table = ej.buildTag("table.e-optable");

            $op1.append(ej.buildTag("td.e-operator").append($dp1))
                .append(ej.buildTag("td.e-value").append($in1));
            $pred.append(ej.buildTag("td", {}, {}, {}).append(radioAnd).append(ej.buildTag("label.e-caption", this.localizedLabels.PredicateAnd, {}, { "for": $id + "_CustomAndPredicate" }))
                .append(radioOr).append(ej.buildTag("label.e-caption", this.localizedLabels.PredicateOr, {}, { "for": $id + "_CustomOrPredicate" })));
            $op2.append(ej.buildTag("td.e-operator").append($dp2))
                .append(ej.buildTag("td.e-value").append($in2));
            table.append($op1)
            .append($pred)
            .append($op2);
			if(type == "string")
			    $pred.append(ej.buildTag("td", {}, {}, {}).append(matchCase).append(ej.buildTag("label.e-caption", this.localizedLabels.MatchCase, {}, { "for": $id + "_CustomMatchPredicate" })));
            if (type == "number" || type == "guid") {
                $op3.append(ej.buildTag("td.e-operator").append($dp3))
                .append(ej.buildTag("td.e-value").append($in3));
                table.append($op3)
            }
            $fset.append(ej.buildTag("legend"))
                .append(table)
            content.append(ej.buildTag("div.e-dlgfields").append($fset));
            content.append(ej.buildTag("div.e-dlgfields").append(this._createBtn(true)));
            content.appendTo("body");
            var uppertype = type.replace(type.charAt(0), type.charAt(0).toUpperCase());
            $([$dp1, $dp2]).ejDropDownList({ fields: { text: "text", value: "value" }, height: 27, width: 120, enableRTL: this._ctrlInstance.model.enableRTL });
            if (type == "number") {
				$([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $([$in1, $in2]).ejNumericTextbox({ showSpinButton: false, height: "27px", width: "177px", enableRTL: this._ctrlInstance.model.enableRTL,watermarkText: this.localizedLabels.NumericTextboxWaterMark, focusOut: function(args){ if(this.model.decimalPlaces == 0) this.element.prev(".e-input").val(this.model.value); } });
            }
			else if (type == "guid") {
                $([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $($in1).css({"height":"22px","width":"175px" });
                $($in2).css({"height":"22px","width":"177px" });
            }
            else if (type == "date") {
				$([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
				$([$in1, $in2]).ejDatePicker({ "cssClass": this._ctrlInstance.model.cssClass, height: "27px", width: "177px", "enableRTL": this._ctrlInstance.model.enableRTL, watermarkText: this.localizedLabels.DatePickerWaterMark, locale: this._locale });
            }
            else if (type == "datetime") {
                $([$dp1, $dp2]).ejDropDownList({ popupWidth: "170px" });
                $([$in1, $in2]).ejDateTimePicker({ "cssClass": this._ctrlInstance.model.cssClass, height: "27px", width: "177px", "enableRTL": this._ctrlInstance.model.enableRTL, watermarkText: this.localizedLabels.DateTimePickerWaterMark, locale: this._locale });
            }
            else if (type == "string") {
                $([$in1, $in2]).ejAutocomplete({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL, enableDistinct: true, width: "177px", height: "27px", locale: this._locale });
            }
            $([radioAnd, radioOr]).ejRadioButton({ "cssClass": this._ctrlInstance.model.cssClass, "enableRTL": this._ctrlInstance.model.enableRTL });
            matchCase.ejCheckBox({ });
            $("#" + $id + "Custom_OkBtn").ejButton({ text: this._getDeprecatedLocalizedLabel("OK"), showRoundedCorner: true, width: "23.6%", click: ej.proxy(this._fltrBtnHandler, this), enabled: true });
            $("#" + $id + "Custom_CancelBtn").ejButton({ text: this.localizedLabels.Cancel, showRoundedCorner: true, width: "23.6%", click: ej.proxy(this.closeXFDialog, this) })
        },
                     
        _openCustomFilter: function (operator) {
            var oper = operator != "top10" ? this._$colType : operator, emptyOp = { text: "", value: "" }, query = this.query;
            var type = oper.replace(oper.charAt(0), oper.charAt(0).toUpperCase());
            var id = this.id + this._$colType;
            this.closeXFDialog();
            this._openedFltr = $("#" + id + "_CustomFDlg");
            var args = { requestType: "filterbeforeopen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            if (this._ctrlInstance._trigger(this._onActionBegin, args))
                return;
            this._openedFltr.ejDialog("open");
            this._openedFltr.ejDialog({open: function(args){
				$("#" + id + "_CustomValue1").hasClass("e-autocomplete") ? $("#" + id + "_CustomValue1").focus() : $("#" + id + "_CustomValue1").prev().focus();
			}});
            this._openedFltr.find("legend").html(this._displayName);            
            var sl = (["Number","Date"].indexOf(type) != -1) ? 6 : 5;
            var sliced = this.localizedLabels[type + "MenuOptions"].slice(0,sl); sliced.unshift(emptyOp);
            $("#" + id + "_CustomDrop1").ejDropDownList({ dataSource: sliced });
            $("#" + id + "_CustomDrop2").ejDropDownList({ dataSource: sliced });
			if (this._$colType == "number") {
                var decimalPlace = 0;
                if(operator == "top10"){
                    this._openedFltr.find(".e-optable tr").not(".e-top").addClass("e-hide");   
                    this._openedFltr.find(".e-optable tr.e-top").removeClass("e-hide");
                    $("#" + id + "_CustomDrop3").ejDropDownList({ dataSource: this.localizedLabels[type + "MenuOptions"] });
                }
                else{                   
                    decimalPlace = this._$format.length != 0 ? parseInt(this._$format.replace(/\D/g,'')) : 0;                    
                    this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                    this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide"); 
                    $("#" + id + "_CustomValue1").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                    $("#" + id + "_CustomValue2").ejNumericTextbox("model.decimalPlaces", decimalPlace);
                }
            }
            else {
                this._openedFltr.find(".e-optable tr.e-top").addClass("e-hide");
                this._openedFltr.find(".e-optable tr").not(".e-top").removeClass("e-hide");
            }
            if(this._$colType == "string"){
				var fName = this._$foreignField ? this._$foreignField : this.fName;
				var data = this._$foreignData && this._$foreignField ? this._$foreignData : this._dataSource;
                this._openedFltr.find(".e-autocomplete").ejAutocomplete({
                    fields: { text: fName }, dataSource: data,query:query, focusIn: function (args) {
                        var type = this.element.closest("td").siblings().find(".e-dropdownlist").ejDropDownList("getSelectedValue");
                        var $matchCase = this.element.closest(".e-dialog-scroller").find(".e-checkbox").prop("checked");
						 this.model.caseSensitiveSearch = $matchCase;
						 this.model.filterType = type == "" ? this.model.filterType : type;
                    }
                });
            }
            if (this._$colType == "date" && this._$format != "")
                this._openedFltr.find(".e-datepicker").ejDatePicker({ dateFormat: this._$format.replace(/{0:|}/g, function () { return "" }), enableStrictMode: true });
            else if (this._$colType == "datetime" && this._$format != "")
                this._openedFltr.find(".e-datetimepicker").ejDateTimePicker({ dateTimeFormat: this._$format.replace(/{0:|}/g, function () { return "" }), enableStrictMode: true });
            this._setFilteredData(id, operator);
			if(!ej.isNullOrUndefined(this._customFilterHandler)) 
				this._customFilterHandler();
            var args = { requestType: "filterafteropen", filterModel: this, columnName: this.fName, columnType: this._$colType, isCustomFilter: true };
            
			if (this._ctrlInstance._trigger(this._onActionComplete, args))
                return;
        },
        
        _setFilteredData: function ($id, op) {
            var indx = $.inArray(this.fName, this.cFilteredCols);
            var fQM = [], optrs = [], fLen;
            var between = ["greaterthanorequal", "lessthanorequal"];
            if (op == "top10")
                return;
            if (indx != -1)
                fQM = ej.DataManager(this.filteredColumn).executeLocal(ej.Query().where("field", "equal", this.fName));
            if (indx != -1 && this._$foreignField)
                fQM = fQM[0]["actuals"];
            if (this._initialFName != null && this._initialFName == this.fName)
                fQM[0]["isCustom"] = true;
            fLen = fQM.length;
            var drops = this._openedFltr.find(".e-dropdownlist"), inputs = this._openedFltr.find(".e-value input.e-ejinputtext.e-input"), $pred = this._openedFltr.find(".e-predicate");            
            if (indx != -1 && fLen && fQM[0]["from"]!=undefined)
                optrs = [op, ""];
			else if(op == "between" && indx != -1 && fLen )
				optrs = [fQM[0]["operator"], !ej.isNullOrUndefined(fQM[1]) ? fQM[1]["operator"] : ""];
            else if (indx != -1 && fLen && fQM[0]["isCustom"])
                optrs = [(op != "customfilter" && indx != -1) ? op : fQM[0]["operator"], op == "customfilter" && fQM[1] ? fQM[1]["operator"] : ""];
			else if(indx == -1 && op == "customfilter") 
                optrs = ["equal", ""];
            else if (op == "between" || op == "customfilter")
                optrs = op != "customfilter" ? between : ["", ""];           
            else
                optrs = [op, ""];
           
            for (var i = 0; i < (indx != -1 ? fLen : 2) ; i++) {
                var opt = /\D*/.exec(optrs[i])[0];
                $(drops[i]).prop("value", opt);
                $(drops[i]).ejDropDownList("setSelectedValue", opt);
				 $(drops[i]).ejDropDownList({ change: function(arg){ 
					this.element.closest(".e-fields").find(".e-autocomplete").val("");
				 }});
				var value = (indx != -1 && fLen && fQM[i]["isCustom"] && (opt == (this._$foreignField ? fQM[i]["actualFilterOperator"] : fQM[i]["operator"]) || opt == "customfilter" || opt == "between")) ? this._$foreignField ? opt != "" ? fQM[i]["actualFilterValue"] : "" : fQM[i]["value"] : "";
                if ($(inputs[i]).hasClass("e-datepicker"))
                    $("#" + inputs[i].id).ejDatePicker("model.value", (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["value"] : null);
                else if ($(inputs[i]).hasClass("e-numerictextbox"))
                    $("#" + inputs[i].id).ejNumericTextbox("model.value", value);
                else if ($(inputs[i]).hasClass("e-datetimepicker"))
                    $(inputs[i]).ejDateTimePicker("model.value", value);
                else
                    $(inputs[i]).val(value);
                var $pre = (indx != -1 && fLen && fQM[i]["isCustom"] && fQM[i]["predicate"] != undefined) ? this._$foreignField ? fQM[i]["actualPredicate"] : fQM[i]["predicate"] : "and";
				$pred.find("input[value=" + $pre + "]").ejRadioButton({checked:  true});
				if(this._$colType == "string"){
				    var $match = (indx != -1 && fLen && fQM[i]["isCustom"]) ? fQM[i]["matchcase"] : this._matchCase;
					$pred.find("input.e-js[type='checkbox']").ejCheckBox({checked: $match});
				}
				this._openedFltr.find(".e-value input:visible:eq(0)").select();
            }            
        },
        _setDateObject: function (filterObject) {
            if (filterObject.value != null) {
                var $fltrVal = filterObject.value;
                var $prevObj = $.extend(true, {}, filterObject);
                var $nextObj = $.extend(true, {}, filterObject);                
                var $prevDate = new Date($prevObj.value.setSeconds($prevObj.value.getSeconds() - 1));
                var $nextDate = new Date($nextObj.value.setSeconds($nextObj.value.getSeconds() + 2));
                filterObject.value = new Date(filterObject.value.setSeconds($nextObj.value.getSeconds() - 1));                
                $prevObj.value = $prevDate;
                $nextObj.value = $nextDate;
                if (filterObject.operator == "equal") {
                    $prevObj.operator = "greaterthan";
                    $prevObj.predicate = "and";
                    $nextObj.operator = "lessthan";
                    $nextObj.predicate = "and";
                } else if (filterObject.operator == "notequal") {
                    $prevObj.operator = "lessthanorequal";
                    $prevObj.predicate = "or";
                    $nextObj.operator = "greaterthanorequal";
                    $nextObj.predicate = "or";
                }
                var predicate = ej.Predicate($prevObj.field, $prevObj.operator, $prevObj.value, false);
                predicate = predicate[$nextObj.predicate]($nextObj.field, $nextObj.operator, $nextObj.value, false);
                filterObject.ejpredicate = predicate; filterObject.type = "date";
                return filterObject;
            }
            else
                return filterObject;
        },
        _getCDlgFields: function () {
            var dropDowns = this._openedFltr.find(".e-dropdownlist"), defaults;
            var $match = this._openedFltr.find(".e-checkbox"), matchcase = true,valueColl = [];
            var $inputs = this._openedFltr.find(".e-value input.e-ejinputtext.e-input");
            var $ginputs = this._openedFltr.find(".e-value input"),
                $pred = this._openedFltr.find(".e-predicate  div[aria-checked = true]").find("input[type ='radio']").val()
            $.inArray(this.fName, this.cFilteredCols) == -1 && this.cFilteredCols.push(this.fName);

            for (var i = 0,len = dropDowns.length; i < len; i++) {
                var dvalue = $(dropDowns[i]).ejDropDownList("getSelectedValue"), value;
                if (this._$colType == "number")
                    value = parseFloat($inputs.eq(i).ejNumericTextbox("model.value"));
				if(this._$colType == "guid")
                    value = $ginputs.eq(i).val();
                if (this._$colType == "string") {
                    value = $inputs.eq(i).val();
                    matchcase = $match.is(":checked");
                }
                if (this._$colType == "date") 
                    value = $inputs.eq(i).ejDatePicker("model.value");
                if (this._$colType == "datetime")
                    value = $inputs.eq(i).ejDateTimePicker("model.value");

                defaults = { field: this.fName, predicate: i == 1 ? $pred : "or", matchcase: matchcase, isCustom: true };
                if (dvalue == "top" || dvalue == "bottom") {
                    valueColl.push($.extend(true, { value: "", operator: "notequal", take: value, from: dvalue }, defaults));
                }
                else if (dvalue != "") {
                    if (this._empties.indexOf(value + "") > -1 || (this._$colType == "number" && isNaN(value))) {
                        var cols = this.iterateAndGetCollection(this._empties.join(this._spliter), $.extend({}, defaults, { predicate: dvalue.toLowerCase() === "notequal" ? "and" : "or", operator: dvalue.toLowerCase() }));
                        var pred = this.generatePredicate(cols);
                        valueColl.push($.extend({}, defaults, { ejpredicate: pred, operator: dvalue.toLowerCase() }));
                    }
                    else {
                        var filterObj = {}; $.extend(true, filterObj, { value: value, operator: dvalue.toLowerCase(), isCustom: true, actualFilterOperator: dvalue.toLowerCase(), actualFilterValue: value, actualPredicate: defaults.predicate }, defaults);
                        if (this._$colType == "date")
                            filterObj.type = "date";
                        valueColl.push((this._$colType == "date" && ["equal", "notequal"].indexOf(dvalue.toLowerCase()) != -1) ? this._setDateObject(filterObj) : filterObj);
                    }
                }
                else
                    break;
            }
            if (this._$foreignField == undefined)
                this.initiateFilter(valueColl);
            else 
                this._filterForeignData(valueColl, true);            
        },
      
        _fltrBtnHandler: function (args) {
            var matchcase, valColl = [], arg = {}, predicate, fObj = {}, optr = "", checked = [], unchecked;
            this._maxFilterCount = false;
            if (this._clearSearchValue)
                this._searchCount = 0;
            if (!this._openedFltr.hasClass("e-dlgcustom")) {
                if (!this._isFiltered && this._listsWrap.find(".e-selectall").ejCheckBox("model.checked") && (this._searchCount == 0 || (this._add && this._add.prop("checked"))))
                    return this.closeXFDialog();                                  
                if (this._onDemandSearch || this._islargeData) {
                    if (this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)").length < this._listsWrap.find("input.e-ftrchk").filter(":not(:checked):not(.e-selectall)").length || this._listsWrap.find(".e-selectall").ejCheckBox("model.checked")) {
                        checked = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall)");
                        optr = "equal";
                    }
                    else {
                        checked = this._listsWrap.find("input.e-ftrchk").filter(":not(:checked):not(.e-selectall)");
                        optr = "notequal";
                        this._maxFilterCount = true;
                    }
                }
                else {
                    var chkdata = this._chkList.filter(":checked"), unchkdata = this._chkList.filter(":not(':checked')");
                    if ((this._add && this._add.prop("checked"))) {
                        if (unchkdata.length)
                            unchecked = unchkdata;
                        checked = this._checked.length == 0 ? this._preChkList : this._checked;
                        if (chkdata.length && this._checked.length != 0)
                            ej.merge(checked, chkdata);
                    }
                    else
                        checked = this._listsWrap.find("input.e-ftrchk").filter(":checked:not(.e-selectall,.e-addtofilter)");
                    optr = this._colType == "string" ? "startswith" : "equal";
                }
                var len = checked.length, cVal, type = this.getType();
                var _isCase = this._colType == "string" ? this._matchCase : true;
                var defaults = this._maxFilterCount ? { field: this.fName, predicate: "and", operator: optr, matchcase: _isCase } : { field: this.fName, predicate: "or", operator: optr, matchcase: _isCase };
                for (var i = 0; i < len; i++) {
                    if (!ej.isNullOrUndefined(unchecked)) {
                        for (var j = 0; j < unchecked.length; j++) {
                            var flag = 0;
                            if (checked[i].value == unchecked[j].value) {
                                flag = 1;
                                break;
                            }
                        }
                    }
                    if (flag)
                        continue;
                    cVal = checked[i].value;
                    if (this.enableNormalize && cVal.indexOf(this._spliter) != -1) {
                        ej.merge(valColl, this.iterateAndGetCollection(cVal, defaults));
                        continue;
                    }
                    cVal = this.processValue(cVal, type);                    
                                        
                    $.extend(true, fObj, { value: cVal }, defaults);
                                                            
                    for (var j = 0; j < valColl.length; j++) {
                        var count = 0;
                        if (valColl[j].value == cVal) {
                            count = 1;
                            break;
                        }
                    }
                    if (count)
                        continue;

                    valColl.push(type == "date" ? this._setDateObject(fObj) : fObj);
                                                             
                    fObj = {};
                }
                var cIndex = $.inArray(this.fName, this.cFilteredCols);
                if(cIndex != -1)
                    this.cFilteredCols.splice(cIndex, 1);
                if (this._isFiltered && this._searchRequest) {
                    this._checkIsIndeterminate(this.fName, this.filteredColumn);
                    if (this._isIndeterminate) {
                        ej.merge(valColl, this.filteredColumn);
                        valColl = ej.distinct(valColl, "value", true);
                        this._searchRequest = false;
                    }          
                }
                this.initiateFilter(valColl);
            }
            else {
                valColl = this._getCDlgFields();
                $.inArray(this.fName, this.cFilteredCols) == -1 && valColl[0] && this.cFilteredCols.push(this.fName);
            }
        },
        initiateFilter: function (valColl) {
            var firstVal = valColl[0], predicate;
            if (!ej.isNullOrUndefined(firstVal)) {
                isTake = firstVal["from"];
                predicate = firstVal["ejpredicate"] ? firstVal["ejpredicate"] : ej.Predicate(firstVal.field, firstVal.operator, firstVal.value, !firstVal.matchcase);
                for (var j = 1, jlen = valColl.length; j < jlen; j++) {
                    predicate = valColl[j].ejpredicate != undefined ? predicate[valColl[j].predicate](valColl[j].ejpredicate) : predicate[valColl[j].predicate](valColl[j].field, valColl[j].operator, valColl[j].value, !valColl[j].matchcase);
                }
                arg = { action: "filtering", filterCollection: valColl, fieldName: this.fName, ejpredicate: predicate, tableID: this._$tableID};
                if (this._predicates[this._$key] == undefined)
                    this._predicates[this._$key] = {};
                this._predicates[this._$key][this.fName] = !isTake ? predicate : { from: firstVal["from"], take: firstVal["take"] };
                if (!this._openedFltr.hasClass("e-dlgcustom") && this._listsWrap.find(".e-selectall").ejCheckBox("model.checked") && (!this._searchCount || ((this._add && this._add.prop("checked")) && (this._preChkList.filter(":not(':checked')").length == 0 || this._checked.length == 0)) || (valColl.length == this._preChkList.length)) && $.inArray(this.fName, this._columnsFiltered) != -1)
                    arg = { action: "clearfiltering", filterDetails: { field: this.fName, operator: "", predicate: "or", value: "" }, fieldName: this.fName, tableID: this._$tableID }
                if ($.inArray(this.fName, this._columnsFiltered) == -1)
                    this._columnsFiltered.push(this.fName);                
                this._filterHandler(arg);
            }
            this.closeXFDialog();
        },        
		/*Util method to perform formatted group on the inputted json*/
        getDistinct: function (json, field, fullRecord, redundancy) {
		    var lookup = {}, len = json.length, result = [], current, value, fd;

		    while (len--) {
		        current = json[len], value = ej.getObject(field, current), fd = value;
            if (!ej.isNullOrUndefined(current)) {
		        if (this.enableNormalize)
		            fd = this._formatting(this._$format, value, this._locale);

		        current["ejvalue"] = fd;

		        if (redundancy || !(value in lookup))
		            result.push(fullRecord ? current : value);

		        lookup[value] = true;
		    }
         }

		    result = ej.group(ej.mergeSort(result, field), "ejvalue"); /* sort with field and group with ejvalue */

		    return result;
		},
        /*Util method to split string and build filterobject collection */
		iterateAndGetCollection: function (valuestring, defaults) {
		    var splts = valuestring.split(this._spliter), len = splts.length, result = [], value;

		    while (len--) {
		        value = this.processValue(splts[len]);		       

		        result.push($.extend(true, { value: value }, defaults));
		    }

		    return result;
		},
        /*Util method to perform type conversion*/
		processValue: function (val, type/* optional */) {		    
		     type = type || this.getType(); type = this._empties.indexOf(val) != -1 ? "empty" : type; val = val === this.guid ? this._blankValue + "" : val;
		    switch (type) {
		        case "empty":/*Handle blanks*/
		            val = val == "null" ? null : val == "undefined" ? undefined : "";
		            break;
		        case "date":
		        case "datetime":
		            val = new Date(val);
		            break;
		        case "number":
		            val = +val;
		            break;
		        case "boolean":		           
		            val = (!isNaN(val) && typeof (val) == "string") ? ej.parseInt(val) != 0 : val === "true" ? true : false;
		            break;
		    }		    		      
		    return val;
		},
		getType: function () {
		    return !ej.isNullOrUndefined(this._$foreignField) ? this._$foreignKeyType : this._$colType;
		},
		replacer: function (input, pattern, processor, params) {
		    if (typeof processor == "function")
		        processor = processor.call(this, params)
		   return input.replace(pattern, processor);
		},
        _virtualize: function (e) {
            var height = $("#" + this.id + this._$colType + "_CheckBoxList").height();
            var chks = this._chkList.not(".e-checkbox").filter(function () { if (this.offsetTop > e.scrollTop - this.offsetHeight && e.scrollTop + height+70 > this.offsetTop + this.offsetHeight) return this; });
            if (chks.length == 0) return;
            chks.filter(":checked").ejCheckBox({ checked: true }); chks.filter(":not(:checked)").ejCheckBox({ checked: false });
            chks.ejCheckBox({ change: ej.proxy(this._checkHandler, this) });
            var scrollObj = this._listsWrap.ejScroller('instance');            
            scrollObj.refresh();
        },
        /*Method to reset private properties*/
        resetFilterModel: function (destroy) {
            this._blank = undefined;
            this._addAtLast = false;
            this._isFiltered = false;
            this._searchCount = 0;
        },
        resetExcelFilter: function (template) {
            var _i, _type, _id = this.id,_len, _$id;
            this._predicates = [];          
            this.cFilteredCols = [];
            this.resetFilterModel();
            for (_i = 0, _len = this._posType.length; _i < _len; _i++) {
                _type = this._posType[_i], _$id = _id + _type;
                var cDlg = $("#" + _$id + "_CustomFDlg");               
                $("#" + _$id + "_CheckBoxList").ejWaitingPopup("destroy"); $("#" + _$id + "_excelDlg").remove();
                cDlg.find(".e-dropdownlist").ejDropDownList("destroy");
                cDlg.find(".e-button").ejButton("destroy");
                if (_type == "string" || _type == "boolean") cDlg.find(".e-autocomplete").ejAutocomplete("destroy");
                if (_type == "number") cDlg.find(".e-numerictextbox").ejNumericTextbox("destroy");
                if (_type == "date") cDlg.find(".e-datepicker").ejDatePicker("destroy");
                cDlg.ejDialog("destroy");
                $("#" + _$id + "_CustomFDlg").remove();
            }
        },
        _wireEvents: function () {
            this._ctrlInstance._on(this._dialogContainer, "focus click", ".e-searchbox", ej.proxy(this._searchBoxFocus, this));
            this._ctrlInstance._on(this._dialogContainer, "keyup", ".e-searchbox input", ej.proxy(this._search, this));
        }
    };

    ej.ExcelFilter.valueDelimiter = "@|@";
    ej.ExcelFilter.Locale = ej.ExcelFilter.Locale || {};

    ej.ExcelFilter.Locale["default"] = ej.ExcelFilter.Locale["en-US"] = {
        SortNoSmaller: "Sort Smallest to Largest",
        SortNoLarger: "Sort Largest to Smallest",
        SortTextAscending: "Sort A to Z",
        SortTextDescending: "Sort Z to A",
        SortDateOldest: "Sort by Oldest",
        SortDateNewest:"Sort by Newest",
		SortByColor: "Sort By Color",
        SortByCellColor: "Sort by Cell Color",
        SortByFontColor: "Sort by Font Color",
        FilterByColor: "Filter By Color",
		CustomSort: "Custom Sort",
        FilterByCellColor: "Filter by Cell Color",
        FilterByFontColor: "Filter by Font Color",
        ClearFilter: "Clear Filter",
        NumberFilter: "Number Filters",
		GuidFilter: "Guid Filters",
        TextFilter: "Text Filters",
        DateFilter: "Date Filters",
        DateTimeFilter: "Date Time Filters",
        SelectAll: "Select All",
        Blanks: "Blanks",
		Search:"Search",
        Showrowswhere:"Show rows where",
		NumericTextboxWaterMark:"Enter value",
        StringMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Starts With", value: "startswith" }, { text: "Ends With", value: "endswith" }, { text: "Contains", value: "contains" }, { text: "Custom Filter", value: "customfilter" }],
        NumberMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
        GuidMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Custom Filter", value: "customfilter" }],
		DateMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
		DatetimeMenuOptions: [{ text: "Equal", value: "equal" }, { text: "Not Equal", value: "notequal" }, { text: "Less Than", value: "lessthan" }, { text: "Less Than Or Equal", value: "lessthanorequal" }, { text: "Greater Than", value: "greaterthan" }, { text: "Greater Than Or Equal", value: "greaterthanorequal" }, { text: "Between", value: "between" }, { text: "Custom Filter", value: "customfilter" }],
		Top10MenuOptions: [{ text: "Top", value: "top" }, { text: "Bottom", value: "bottom" }],
        title:"Custom Filter",
        PredicateAnd: "AND",
        PredicateOr: "OR",
        OK: "OK",
        MatchCase: "Match Case",
        Cancel: "Cancel",
        NoResult: "No Matches Found",
        CheckBoxStatusMsg: "Not all items showing",
        DatePickerWaterMark: "Select date",
        DateTimePickerWaterMark: "Select date time",
		True: "true",
        False: "false",
        AddToFilter: "Add current selection to filter"
    };

})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var resourceHeadTemplate = function () {
        return ("{{for resourceName}}{{for ~cols=colspan}}<td class='e-resourcecells' colspan='{{:~cols}}'> {{for ~resource=resourceNam}}<div class='e-resourceheadertext' align='center' title='{{if userResTemplId == true}}{{:resourceNam}}{{else}}{{:~resource}}{{/if}}'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resource}}{{/if}}</div>{{/for}}  </td>{{/for}}{{/for}}");
    };

    ej.scheduleFeatures.resources = {
        _getMultipleResourceCellsCount: function (count) {
            if (this._grouping.length === 1) {
                var index = this._findResourceIndex(this._tempResource, "name", this._grouping[0], null, null);
                var resCount = this._resourceInfo[index].dataSource.length;
                if (this._resWorkWeek) {
                    var count = 0; var res = this._resourceInfo[index].dataSource;
                    for (var a = 0; a < res.length; a++) {
                        if (!ej.isNullOrUndefined(res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count = count + res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count = count + this.model.workWeek.length;
                        }
                    }
                }
                else if (this._resCustomView) {
                    var count = 0; var res = this._resourceInfo[index].dataSource;
                    for (var a = 0; a < res.length; a++) {
                        var resRenderDate = res[a][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]];
                        if (!ej.isNullOrUndefined(resRenderDate)) {
                            if ($.type(resRenderDate[0]) == "object") {
                                count += this._getMultipleCustomDatesCount(resRenderDate);
                            }
                            else
                                count +=resRenderDate.length;
                        }
                    }
                }
            }
            else {
                var newResCollection = this._getResourceCollection();
                var groupData, prevGroupDataId, query, resApp;
                for (var j = 0; j < newResCollection.length; j++) {
                    var resources = [];
                    if (j == 0) {
                        for (var i = 0; i < newResCollection[j].dataSource.length; i++) {
                            resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text] });
                        }
                    }
                    else {
                        if (j > 1) {
                            newResCollection[j - 1].dataSource = [];
                            newResCollection[j - 1].dataSource = this.res;
                        }
                        this.res = [];
                        groupData = ej.group(newResCollection[j].dataSource, newResCollection[j].groupId);
                        prevGroupDataId = ej.group(newResCollection[j - 1].dataSource, newResCollection[j - 1].id);
                        this._resourceManager1 = groupData instanceof ej.DataManager ? groupData : ej.DataManager(groupData);
                        for (var l = 0; l < prevGroupDataId.length; l++) {
                            for (var k = 0; k < prevGroupDataId[l].items.length; k++) {
                                query = new ej.Query().where("key", ej.FilterOperators.equal, prevGroupDataId[l].items[k][newResCollection[j - 1].id]);
                                resApp = this._resourceManager1.executeLocal(query);
                                if (resApp.length > 0) {
                                    for (var a = 0; a < resApp[0].items.length; a++) {
                                        resources.push({ resourceNam: resApp[0].items[a][newResCollection[j].text] });
                                        this.res.push(resApp[0].items[a]);
                                    }
                                }
                            }
                        }
                    }
                }
                resCount = resources.length;
                this.res1 = resources.length;
            }
            count = (this._resWorkWeek || this._resCustomView) ? count : count * resCount;
            return { resCount: resCount, count: count };
        },

        _initResourceData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this;
            var queryPromise = fields.dataSource.executeQuery(query);
            queryPromise.done(function (e) {
                fields.dataSource = e.result;
                proxy._resourceInfo.push(fields);
                if (i == proxy.model.resources.length - 1) {
                    proxy._renderInitSchedule();
                    proxy._bindAppointmentsData("Load");
                }
            });
        },

        _showMultipleResourceDetails: function (temp) {
            var prevdata, query, resApp1;
            if (this._tempResource.length > 0) {
                var newResCollection = this._resCollection;
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).ejAutocomplete("clearText");
                }
                for (var j = 0; j < this.render_Resources.length - 1; j++) {
                    prevdata = this.render_Resources[j + 1] instanceof ej.DataManager ? this.render_Resources[j + 1] : ej.DataManager(this.render_Resources[j + 1]);
                    query = new ej.Query().where(newResCollection[j + 1].groupId, ej.FilterOperators.equal, temp[this._appointmentSettings.resourceFields.toString().split(',')[j].trim()]);
                    resApp1 = prevdata.executeLocal(query);
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("clearText");
                    this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("option", "dataSource", resApp1);
                }
                for (var i = 0; i < newResCollection.length; i++) {
                    this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByKey(temp[this._appointmentSettings.resourceFields.toString().split(',')[i].trim()]);
                }
            }
        },

        _renderAppWindowResources: function (control) {
            var newResCollection = this.render_Resources;
            var Text = (this.model.enableRTL) ? 'margin-right:30px;margin-top:-18px' : '';
            var Color = (this.model.enableRTL) ? 'float:none' : 'float:left';
            for (var i = 0; i < newResCollection.length; i++) {
                control.find('.owner_' + i).ejAutocomplete({
                    enableRTL: this.model.enableRTL,
                    showPopupButton: true,
                    width: "100%",
					delaySuggestionTimeout: 10,
                    cssClass: this.model.cssClass,
                    multiSelectMode: (!this._tempResource[i].allowMultiple) ? "none" : "visualmode",
                    emptyResultText: this._getLocalizedLabels("EmptyResultText"),
                    dataSource: newResCollection[i],
                    fields: {
                        text: this._resCollection[i]["text"],
                        key: this._resCollection[i]["id"]
                    },
                    change: this._onResourceChange,
                    template: "<div class='e-resourcediv' style='height:15px; margin-right:5px; margin-top:3px; float:left;width:15px;" + Color + "; background-color: ${" + this._resCollection[i].color + "}'></div><div style= " + Text + ">${" + this._resCollection[i]["text"] + "}</div>"
                });
            }
        },

        _onResourceChange: function (e) {
            if (!ej.isNullOrUndefined(e.value) && e.value != "") {
                var scheduleDiv = $("#" + this._id.toString().split("_")[0]), proxy = scheduleDiv.ejSchedule("instance");
                var controlId = parseInt(this._id.toString().split("_")[2]);
                var controlMode = proxy._appointmentAddWindow.find('.owner_' + controlId).ejAutocomplete("option", "multiSelectMode");
                var selectedItems = this.getSelectedItems();
                var resourceCollection = proxy._resCollection;
                if (controlId < proxy.render_Resources.length - 1 && selectedItems.length > 0) {
                    var j = controlId + 1;
                    var data = proxy.render_Resources[j - 1] instanceof ej.DataManager ? proxy.render_Resources[j - 1] : ej.DataManager(proxy.render_Resources[j - 1]);
                    var prevdata = proxy.render_Resources[j] instanceof ej.DataManager ? proxy.render_Resources[j] : ej.DataManager(proxy.render_Resources[j]);
                    var query, resApp1, fieldCollection = [];
                    if (controlMode == "none") {
                        if (!ej.isNullOrUndefined(e.value)) {
                            var textCheck = new ej.Query().where(resourceCollection[j - 1].text, ej.FilterOperators.equal, e.value);
                            var result = data.executeLocal(textCheck);
                        }
                        var currentVal = ((!e.value) || ej.isNullOrUndefined(e.value) || result.length <= 0) ? selectedItems[0][resourceCollection[j - 1].id] : result[0][resourceCollection[j - 1].id];
                        if (!ej.isNullOrUndefined(currentVal)) {
                            for (var a = j; a < resourceCollection.length; a++) {
                                resApp1 = new ej.DataManager(resourceCollection[j].dataSource).executeLocal(new ej.Query().where(resourceCollection[j].groupId, ej.FilterOperators.equal, currentVal));
                                if (resApp1.length != 0)
                                    currentVal = resApp1[0][resourceCollection[j - 1].id];
                                fieldCollection = [];
                                for (var k = 0; k < resApp1.length; k++) {
                                    fieldCollection.push(resApp1[k]);
                                }
                                if (resApp1.length != 0) {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                    proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                                    selectedItems = resApp1[0][resourceCollection[j].id];
                                }
                                else {
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                                }
                                j++;
                            }
                        }
                    }
                    else {
                        var predicate;
                        predicate = ej.Predicate(resourceCollection[j - 1].id, ej.FilterOperators.equal, selectedItems[0][resourceCollection[j - 1].id]);
                        selectedItems = e.value.split(",");
                        for (var i = 1; i < selectedItems.length; i++) {
                            predicate = predicate["or"](resourceCollection[j - 1].text, ej.FilterOperators.equal, selectedItems[i]);
                        }
                        query = new ej.Query().where(predicate);
                        resApp = data.executeLocal(query);
                        if (resApp.length > 0) {
                            var prevPredicate;
                            prevPredicate = ej.Predicate(resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[0][resourceCollection[j - 1].id]);
                            for (var i = 1; i < resApp.length; i++) {
                                prevPredicate = prevPredicate["or"](resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[i][resourceCollection[j - 1].id]);
                            }
                            query = new ej.Query().where(prevPredicate);
                            resApp1 = prevdata.executeLocal(query);
                            fieldCollection = [];
                            for (var k = 0; k < resApp1.length; k++) {
                                fieldCollection.push(resApp1[k]);
                            }
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
                            proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection);
                            proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
                            selectedItems.push(resApp1[0][resourceCollection[j].id]);
                        }
                    }
                }
            }
        },

        _getResourceCollection: function () {
            var resIndexCollection = [], index;
            if ((this._tempResource.length != 0)) {
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i], null, null);
                        resIndexCollection.push({ index: index, name: this._tempResource[i].name });
                    }
                    resIndexCollection = resIndexCollection.sort(function (a, b) {
                        var x = a.index; var y = b.index;
                        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
                    });
                }
                else {
                    for (var i = 0; i < this._tempResource.length; i++) {
                        resIndexCollection.push({ index: i });
                    }
                }
                var newResCollection = [];
                for (var k = 0; k < resIndexCollection.length; k++) {
                    newResCollection.push(this._resourceInfo[resIndexCollection[k].index]);
                }
                this._resCollection = newResCollection;
                return newResCollection;
            }
        },

        _resourceSort: function () {
            var nextRes, count, resAvail, index, rIndex, cRes, tempResource = [], rCollection = [], tempRes1 = [];
            if (this._tempResource.length > 1) {
                for (var i = 0; i < this._tempResource.length; i++) {
                    for (var j = 0; j < this._tempResource[i].resourceSettings.dataSource.length; j++) {
                        tempResource.push(this._tempResource[i].resourceSettings.dataSource[j]);
                    }
                }
                count = 1;
                for (var a = 0; a < this._tempResource.length; a++) {
                    for (var b = 0, cRes = this._tempResource[a].resourceSettings.dataSource; b < cRes.length; b++) {
                        resAvail = rCollection.indexOf(cRes[b]);
                        (resAvail == -1) ? rCollection.push(cRes[b]) : "";
                        nextRes = new ej.DataManager(tempResource).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.groupId, ej.FilterOperators.equal, cRes[b][this._tempResource[a].resourceSettings.id]));
                        nextRes = nextRes.filter(function (a) { return cRes.indexOf(a) === -1; });
                        index = rCollection.indexOf(cRes[b]);
                        if (nextRes.length != 0) {
                            for (var c = 0; c < nextRes.length; c++) {
                                rIndex = index + c + 1;
                                resAvail = rCollection.indexOf(nextRes[c]);
                                (resAvail == -1) ? rCollection.splice(rIndex, 0, nextRes[c]) : "";
                            }
                        }
                    }
                    count++;
                    count = (count == this._tempResource.length) ? count - 1 : count;
                }
                for (var x = 0; x < rCollection.length; x++) {
                    index = this.res1.indexOf(rCollection[x]);
                    if (index != -1) tempRes1.push(rCollection[x]);
                }
                this.res1 = tempRes1;
            }
            else
                rCollection = this.res1;
            return rCollection;
        },

        _renderMultipleResourceHeaderTemplate: function (tbody, cols) {
            this.res1 = []; this.render_Resources = []; this.level_Resources = [];
            var view = this.currentView(), newResCollection = this._getResourceCollection(), noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            var viewColCount = view == "day" ? 1 : (view == "week" || view == "month") ? noOfDays : this.model.workWeek.length;
            viewColCount = (view == "customview" && this._dateRender.length >= 7) ? noOfDays : (view == "customview" && this._dateRender.length < 7) ? this._dateRender.length : viewColCount;
            if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) {
                var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
                var resources = [];
                if (this._grouping.length === 1) {
                    var index;
                    for (var i = 0; i < this._grouping.length; i++) {
                        index = this._findResourceIndex(this._tempResource, "name", this._grouping[i], null, null);
                    }
                    for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
                        var colCount;
                        if (this._resWorkWeek)
                            var colCount = !ej.isNullOrUndefined(this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                        if (this._resCustomView) {                            
                            var resCustomSetting = this._resourceInfo[index].dataSource[i][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]];
                            if(!ej.isNullOrUndefined(resCustomSetting)){
                                if (!ej.isNullOrUndefined(resCustomSetting) && $.type(resCustomSetting[0]) == "object") {                                                                        
                                    colCount = this._getMultipleCustomDatesCount(resCustomSetting);
                                } else
                                    colCount = resCustomSetting.length;
                            }
                            else
                                colCount= viewColCount;                            
                        }
                        (this.currentView() != "agenda") && resources.push({ resourceNam: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], colspan: (this._resWorkWeek || this._resCustomView) ? colCount : viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(this._resourceInfo[index].dataSource[i], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                        this.res1.push(this._resourceInfo[index].dataSource[i]);
                        this.level_Resources.push(this.res1[i]);
                    }
                    this._valueCollection = this.res1;
                    this.render_Resources.push(this.res1);
                    if ((this.model.orientation === "vertical" &&  this._customOrientation === "vertical") && this.currentView() != "agenda" && tbody !== null && cols != null) {
                        var leftCellwidth = view == "month" ? 50 : 56;
                        var resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                        tbody.append(ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml));
                    }
                }
                else {
                    var groupDatasource = [], firstValue = [], collection = [], resAppValueCount = 0, valueCount = [];
                    var res = []; var level = []; var variable = []; this.resourceValue = 0; var resourceLength = 0;
                    groupDatasource = $.merge(groupDatasource, newResCollection);
                    if (this._tempResource.length) {
                        var k = 0;
                        for (var j = 0; j < newResCollection[newResCollection.length - 2].dataSource.length; j++) {
                            var query = new ej.Query().where(newResCollection[newResCollection.length - 1].groupId, ej.FilterOperators.equal, newResCollection[newResCollection.length - 2].dataSource[j][newResCollection[newResCollection.length - 2].id]);
                            var resApp = new ej.DataManager(newResCollection[newResCollection.length - 1].dataSource).executeLocal(query);
                            var m = 0;
                            while (m < resApp.length) {
                                firstValue.push({ resourceNam: resApp[m][newResCollection[newResCollection.length - 1].text], colspan: 1 * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(resApp[m], { classname: "e-childnode" })), userResTemplId: userResTemplId });
                                collection[k] = resApp[m];
                                this.res1.push(resApp[m]);
                                k++;
                                m++;
                            }
                        }
                        this._valueCollection = collection;
                        newResCollection[newResCollection.length - 1].dataSource = collection;
                        var resClone = $.extend(true, [], newResCollection);
                    }
                    for (var i = this._tempResource.length - 1; i >= 0 ; i--) {
                        level.push(i);
                        for (var j = 0; j < newResCollection[i].dataSource.length; j++) {
                            var valuefirst = i != 0 ? this._findResourceIndex(newResCollection[i - 1].dataSource, newResCollection[i - 1].id, newResCollection[i].dataSource[j][newResCollection[i].groupId], null, null) : 0;
                            var valuelast = i != this._tempResource.length - 1 ? this._findResourceIndex(newResCollection[i + 1].dataSource, newResCollection[i + 1].groupId, newResCollection[i].dataSource[j][newResCollection[i].id], null, null) : this._tempResource.length - 1;
                            (ej.isNullOrUndefined(valuefirst) && ej.isNullOrUndefined(valuelast)) ? newResCollection[i].dataSource[j] = 0 : "";
                            if (!ej.isNullOrUndefined(valuefirst) && !ej.isNullOrUndefined(valuelast) && newResCollection[i].dataSource[j] !== 0) {
                                res.push(newResCollection[i].dataSource[j]);
                                this.resourceValue = res.length;
                                if (i <= this._tempResource.length - 2) {
                                    var query = new ej.Query().where(newResCollection[i + 1].groupId, ej.FilterOperators.equal, newResCollection[i].dataSource[j][newResCollection[i].id]);
                                    var resApp = new ej.DataManager(newResCollection[i + 1].dataSource).executeLocal(query);
                                    if (i <= this._tempResource.length - 3) {
                                        for (var k = 0; k < resApp.length; k++)
                                            resAppValueCount = resAppValueCount + (!ej.isNullOrUndefined(resApp[k].count) ? resApp[k].count : 0);

                                        resourceLength = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? resAppValueCount : resAppValueCount + resApp.length;
                                        newResCollection[i].dataSource[j].count = resourceLength;
                                        resAppValueCount = 0;
                                    }
                                    if (i == this._tempResource.length - 2) {
                                        newResCollection[i].dataSource[j].count = resApp.length;
                                        resourceLength = resApp.length;
                                    }
                                    this.resourceValue = resourceLength;
                                    resApp.length = 0;
                                }
                                if (this._resWorkWeek) {
                                    var weekCount = 0;
                                    if (i != this._tempResource.length - 1) {
                                        var query = new ej.Query().where(resClone[i + 1].groupId, ej.FilterOperators.equal, resClone[i].dataSource[j][resClone[i].id]);
                                        var colCount = new ej.DataManager(resClone[i + 1].dataSource).executeLocal(query);
                                        for (var a = 0; a < colCount.length; a++) {
                                            weekCount += !ej.isNullOrUndefined(colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : !ej.isNullOrUndefined(colCount[a].colspan) ? colCount[a].colspan : viewColCount;
                                        }
                                    }
                                    else {
                                        weekCount += !ej.isNullOrUndefined(resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? resClone[i].dataSource[j][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : viewColCount;
                                    }
                                    resClone[i].dataSource[j]["colspan"] = weekCount;
                                    this.resourceValue = weekCount;
                                }
                                if (this._resCustomView) {
                                    var weekCount = 0;
                                    if (i != this._tempResource.length - 1) {
                                        var query = new ej.Query().where(resClone[i + 1].groupId, ej.FilterOperators.equal, resClone[i].dataSource[j][resClone[i].id]);
                                        var colCount = new ej.DataManager(resClone[i + 1].dataSource).executeLocal(query);
                                        for (var a = 0; a < colCount.length; a++) {
                                            var resCustomSetting = colCount[a][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]];
                                            if (!ej.isNullOrUndefined(resCustomSetting)) {
                                                if ($.type(resCustomSetting[0]) == "object") {                                                    
                                                    weekCount += this._getMultipleCustomDatesCount(resCustomSetting);
                                                } else
                                                    weekCount += resCustomSetting.length;
                                            } else {
                                                if (!ej.isNullOrUndefined(colCount[a].colspan))
                                                    weekCount += colCount[a].colspan;
                                                else
                                                    weekCount += viewColCount
                                            }
                                        }
                                    }
                                    else {
                                        var resCustomSetting = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                                        if (!ej.isNullOrUndefined(resClone[i].dataSource[j][resCustomSetting])) {
                                            weekCount += this._getCustomDatesCount(j,resCustomSetting);
                                        } else
                                            weekCount += viewColCount;                                        
                                    }
                                    resClone[i].dataSource[j]["colspan"] = weekCount;
                                    this.resourceValue = weekCount;
                                }
                                (this.currentView() != "agenda") && resources.push({ resourceNam: newResCollection[i].dataSource[j][newResCollection[i].text], colspan: (this._resWorkWeek || this._resCustomView) ? this.resourceValue : this.resourceValue * viewColCount, userResHeader: this._getResourceHeadTemplate($.extend(newResCollection[i].dataSource[j], { classname: (this._tempResource.length - 1 == i) ? "e-childnode" : "e-parentnode" })), userResTemplId: userResTemplId });
                                this.level_Resources.push(newResCollection[i].dataSource[j]);
                                res.length = 0;

                            }
                            if ((this.model.orientation === "vertical" &&  this._customOrientation === "vertical") && this.currentView() != "agenda" && tbody !== null && cols != null) {
                                leftCellwidth = view == "month" ? 50 : 56;
                                resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
                                variable[i] = ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml)[0];
                            }
                        }
                        valueCount[i] = newResCollection[i].dataSource;
                        resources.length = 0;
                    }
                    this.render_Resources = valueCount;
                    (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") && this.currentView() != "agenda" ? tbody.append(variable) : "";
                }
            }
            else {
                for (var k = 0; k < this._tempResource.length; k++) {
                    this.render_Resources.push(this._tempResource[k].resourceSettings.dataSource);
                }
                this.res1 = [0];
            }
            return tbody;
        },

        _getMultipleResourceAlldayApp: function (renderDate, day, res, apps) {
            this.allDayCount = [];
            if ((new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(apps[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (apps[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings.id]) &&
                (apps[this._appointmentSettings["allDay"]] === true || (((new Date(apps[this._appointmentSettings["endTime"]]) - new Date(apps[this._appointmentSettings["startTime"]])) / 3600000) >= 24) || this._findAllDayApp(apps)) &&
                ((!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? (apps[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()] == this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings.groupId]) : true)) {
                this._setAllDayPos(apps, day, res);
                this.allDayCount.push(apps);
            }
        },

        _getResourceColor: function (record) {
            var newResCollection = this._resCollection;
            var resourceDataIndex, appointData = "", appointCustomcss = "", applyFilter = false;
            if (!ej.isNullOrUndefined(this.model.group)) {
                for (var a = 0; a < this.render_Resources.length; a++) {
                    resourceDataIndex = this._findResourceIndex(this.render_Resources[a], newResCollection[a].id, record[this._appointmentSettings.resourceFields.split(',')[a].trim()], null, null);
                    if (!ej.isNullOrUndefined(resourceDataIndex)) {
                        appointData = (appointData == "" || ej.isNullOrUndefined(appointData)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].color] : appointData;
                        appointCustomcss = (appointCustomcss == "" || ej.isNullOrUndefined(appointCustomcss)) ? this.render_Resources[a][resourceDataIndex][newResCollection[a].appointmentClass] : appointCustomcss;
                        if (!ej.isNullOrUndefined(appointData) && !ej.isNullOrUndefined(appointCustomcss)) break;
                    }
                }
                appointData = !ej.isNullOrUndefined(appointData) && appointData != "" ? appointData : "";
                appointCustomcss = !ej.isNullOrUndefined(appointCustomcss) && appointCustomcss != "" ? appointCustomcss : "";
            }
            else {
                resourceDataIndex = this._findResourceIndex(this.render_Resources[this.render_Resources.length - 1], newResCollection[newResCollection.length - 1].id, record[this._appointmentSettings.resourceFields.split(',')[this._appointmentSettings.resourceFields.split(',').length - 1].trim()], null, null);
                if (!ej.isNullOrUndefined(resourceDataIndex)) {
                    appointData = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color] : appointData;
                    appointCustomcss = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass] : appointCustomcss;
                }
            }
            return { appointData: appointData, appointCustomcss: appointCustomcss, applyFilter: applyFilter };
        },

        _getResourceValue: function (target, index) {
            var resDetails;
            if (ej.scheduleFeatures.resources && (this._tempResource.length != 0)) {
                var resource = this._getResourceDetails(target);
                resDetails = ej.DataManager(this._resCollection[resource.length - 1].dataSource).executeLocal(new ej.Query().where(this._tempResource[resource.length - 1].resourceSettings["id"], "equal", resource[0].id))[0];
            }
            return resDetails;
        },

        _getResourceDetails: function (target, index) {
            if ((this._tempResource.length != 0)) {
                if (this._tempResource.length > 0) {
                    var noOfDays = this.currentView() == "day" ? 1 : (this.model.showWeekend && (this.currentView() == "week" || this.currentView() == "month")) ? 7 : this.model.workWeek.length;
                    noOfDays = (this.model.showWeekend && this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 : (this.currentView() == "customview" && this._dateRender.length < 7) ? this._dateRender.length : noOfDays;
                    index = this.currentView() === "month" || this.currentView() == "customview" ? target.index() : (!ej.isNullOrUndefined(this._cellIndex) && ej.isNullOrUndefined(this._multiple)) ? this._cellIndex : target.index();
                    !target.hasClass("e-detailedapp") ? this.index = index : "";
                    index = target.hasClass("e-detailedapp") ? this.index : index;
                    if (this._resWorkWeek) {
                        var resIndex = 0;
                        for (var a = 0; a < this._valueCollection.length; a++) {
                            if (!ej.isNullOrUndefined(this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                                resIndex += this._valueCollection[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            else
                                resIndex += this.model.workWeek.length;
                            if (resIndex > target.index()) {
                                index = a;
                                break;
                            }
                        }
                    }
                    else if (this._resCustomView) {
                        var resIndex = 0;
                        for (var a = 0; a < this._valueCollection.length; a++) {
                            var resRenderDate = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                            if (!ej.isNullOrUndefined(this._valueCollection[a][resRenderDate])) {
                                resIndex += this._getCustomDatesCount(a, resRenderDate);
                            }
                            if (resIndex > target.index()) {
                                index = a;
                                break;
                            }
                        }
                    }
                    else
                        index = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? parseInt(index / noOfDays) : !ej.isNullOrUndefined(this._workCellIndex) ? this._workCellIndex : target.parent().index();
                    var res1 = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? this._valueCollection : this._resCollect;
                    var group, resourceData, query, result; this._resourceCollection = [];
                    var newResCollection = this._resCollection;
                    for (var i = newResCollection.length - 1; i >= 0; i--) {
                        if (i == newResCollection.length - 1) {
                            if (!ej.isNullOrUndefined(this.model.group)) {
                                this._resourceCollection.push({ id: res1[index][newResCollection[i].id] });
                                group = res1[index][newResCollection[i].groupId];
                            }
                            else {
                                this._resourceCollection.push({ id: newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].id] });
                                group = newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].groupId];
                            }
                        }
                        else {
                            resourceData = newResCollection[i].dataSource instanceof ej.DataManager ? newResCollection[i].dataSource : ej.DataManager(newResCollection[i].dataSource);
                            query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, group);
                            result = resourceData.executeLocal(query);
                            this._resourceCollection.push({ id: result[0][newResCollection[i].id] });
                            group = result[0][newResCollection[i].groupId];
                        }
                    }
                    return this._resourceCollection;
                }
            }
        },

        _getResourceFields: function (obj) {
            if (!ej.isNullOrUndefined(this.model.group) || this._tempResource.length > 1) {
                for (var j = 0, i = this._resourceCollection.length - 1; j < this._resourceCollection.length; j++, i--)
                    obj[this._appointmentSettings.resourceFields.split(',')[j].trim()] = this._resourceCollection[i].id;
            }
            else
                obj[this._appointmentSettings.resourceFields.split(',')[0].trim()] = this._resourceCollection[0].id;
            return obj;
        },
        _getDragDropResourceData: function (proxy, cellIndex, newAddList) {
            if (!ej.isNullOrUndefined(cellIndex)) {
                var noOfCols = proxy.currentView() == "day" ? 1 : (proxy.model.showWeekend && (proxy.currentView() == "week" || proxy.currentView() == "month")) ? 7 : proxy.model.workWeek.length;
                noOfCols = (proxy.model.showWeekend && proxy.currentView() == "customview" && proxy._dateRender.length >= 7) ? 7 : (proxy.currentView() == "customview" && proxy._dateRender.length < 7) ? proxy._dateRender.length : noOfCols;
                var index = proxy.model.enableRTL ? proxy.res1.length - Math.floor(cellIndex / noOfCols) - 1 : Math.floor(cellIndex / noOfCols);
                if (proxy._resWorkWeek) {
                    var resIndex = 0;
                    for (var a = 0; a < proxy.res1.length; a++) {
                        if (!ej.isNullOrUndefined(proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]]))
                            resIndex += proxy.res1[a][proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["workWeek"]].length;
                        else
                            resIndex += proxy.model.workWeek.length;

                        if (resIndex > cellIndex) {
                            index = a;
                            break;
                        }
                    }
                }
                if (proxy._resCustomView) {
                    var resIndex = 0;
                    for (var a = 0; a < proxy.res1.length; a++) {
                        var resCustomSettings = proxy.model.resources[proxy.model.resources.length - 1].resourceSettings["renderDates"];
                        if (!ej.isNullOrUndefined(proxy.res1[a][resCustomSettings]))
                            resIndex += proxy._getCustomDatesCount(a, resCustomSettings);
                        if (resIndex > cellIndex) {
                            index = a;
                            break;
                        }
                    }
                }
                var newRes = (proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") ? proxy.res1[index] : proxy._resCollect[cellIndex];
                newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 1].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.id];
                if (proxy._appointmentSettings.resourceFields.split(',').length > 1)
                    newAddList[proxy._appointmentSettings.resourceFields.split(',')[proxy._appointmentSettings.resourceFields.split(',').length - 2].trim()] = newRes[proxy.model.resources[proxy.model.resources.length - 1].resourceSettings.groupId];
            }
            return newAddList;
        },

        _renderResourceData: function (targetElement, index) {
            if ((targetElement.hasClass("e-workcells") || targetElement.hasClass("e-alldaycells") || targetElement.hasClass("e-monthcells")) && !targetElement.hasClass("e-resourceheadercells")) this._getResourceDetails(targetElement)
            var fieldCollection = [], collection = [];
            if (this._tempResource.length) {
                for (var k = this._resourceCollection.length - 1; k >= 0; k--) {
                    var resourceDataIndex = this._findResourceIndex(this._resCollection[k].dataSource, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id, null, null);
                    fieldCollection.push(this._resCollection[k].dataSource[resourceDataIndex]);
                    if (k != 0) {
                        var query = new ej.Query().where(ej.Predicate(this._resCollection[k].groupId, ej.FilterOperators.equal, this._resCollection[k].dataSource[resourceDataIndex][this._resCollection[k].groupId]));
                        var resApp = new ej.DataManager(this._resCollection[k].dataSource).executeLocal(query);
                        index = this._findResourceIndex(resApp, this._resCollection[k].id, this._resourceCollection[(this._resourceCollection.length - 1) - k].id, null, null);
                        collection = resApp;
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("option", "dataSource", collection);
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(collection[index][this._resCollection[k].id]);
                    }
                    else {
                        this._appointmentAddWindow.find('.owner_' + (k)).ejAutocomplete("clearText");
                        this._appointmentAddWindow.find('.owner_' + (k)).data("ejAutocomplete").selectValueByKey(fieldCollection[(this._resourceCollection.length - 1) - k][this._resCollection[k].id]);
                    }
                }
            }
        },

        _bindResourcesData: function () {
            if ((this._tempResource.length != 0)) {
                this._resourceInfo = []; var resFlag = false;
                for (var i = 0; i < this._tempResource.length; i++) {
                    if (!ej.isNullOrUndefined(this._tempResource[i].resourceSettings)) {
                        if (ej.isNullOrUndefined(this._tempResource[i].resourceSettings.query) || !(this._tempResource[i].resourceSettings.query instanceof ej.Query))
                            this._tempResource[i].resourceSettings.query = ej.Query();
                        if (this._tempResource[i].resourceSettings.dataSource instanceof ej.DataManager)
                            this._initResourceData(this._tempResource[i].resourceSettings, i);
                        else {
                            this._resourceInfo.push(this._tempResource[i].resourceSettings);
                            resFlag = true;
                        }
                    }
                }
                if (resFlag)
                    this._renderInitSchedule();
            }
        },

        _renderResourceElements: function ($appWindow) {
            for (var i = 0; i < this._tempResource.length; i++) {
                $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this._tempResource[i].title + ":</td><td colspan='3' class='e-rightfields'><input id='" + this._id + "_ownerfield_" + i + "'  class='owner_" + i + "' type='text' value=''/><div id='ownerlist'></div></td></tr>";
            }
            return $appWindow;
        },

        _renderResourcesTemplate: function () {
            this.resourceHeadTemplate = $.templates(resourceHeadTemplate());
        }
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Schedule elements
* @copyright Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.2
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    ej.scheduleFeatures = ej.scheduleFeatures || {};

    var monthCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab' style='width:100%;height:100%;'>" +
                "<tbody>{{for cellrows ~cols1=cols1 ~userTemp=userTemplate ~userHtml=userHtml ~tenable=tenable ~cview=cview}}" +
                "<tr>{{for ~cwidth=cwidth ~cheight=cheight ~cols1 ~value=#getIndex()}}" +
                "<td class='e-monthcells' style='width:{{:~cwidth}};height:{{:~cheight}};'>" +
                "<div class='e-monthheader' {{if ~tenable == false && ~cview == true}}style='display:none'{{/if}}></div>{{if ~userTemp == true}}{{:~userHtml[~value][#getIndex()]}}{{/if}}</td>{{/for}}" +
                "</tr>{{/for}}</tbody></table>");
    };

    var appointmentTemplate = function () {
        return ("<div class='{{:appClass}} {{:appointCustomcss}}' id='Appointment_{{:id}}' data-guid= '{{:uid}}' data-resource='{{:resId}}' role='presentation' style='{{if rtl == true}}right{{else}}left{{/if}}: {{:left}}; {{if ignoreColorFilter == true}}filter:none;{{/if}} width: {{:appWidth}}; background: {{:appointData}};  color:{{:appointtextcolor}}; height:{{:appHeight}}px; top: {{:top}}px;' >" +
                "{{if appResize == true}}{{if appClass == 'e-appointment'}}" +
                "{{if orientation == 'vertical'}}<div class='e-tophandle'></div><div class='e-bottomhandle'></div>{{else}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>{{/if}}" +
                "{{else}}{{if currentview != 'day'}}<div class='e-lefthandle'></div><div class='e-righthandle'></div>{{/if}}{{/if}}{{/if}}" +
                "<span class='e-icon e-schedulemouseclose'/></span>" +
                "{{if (priority!=undefined && priority!='') && ((priorityTemplate!=undefined && priorityTemplate!=''))}}{{if enablePriority==null}}<div class='e-priority e-{{:priorityTemplate}}'></div>{{else}}<div class='e-priority'>{{:priorityTemplate}}</div>{{/if}}{{/if}}" +
                "{{if userAppTemplId == false}}" +
                "{{if leftInd ==true}}<span class='e-icon e-arrow-sans-left e-leftind'></span>{{/if}}{{if rightInd ==true}}<span class='e-icon e-arrow-sans-right e-rightind'></span>{{/if}}" +
                "{{if bottomInd ==true}}<span class='e-icon e-arrow-sans-down e-bottomind'></span>{{/if}}{{if topInd ==true}}<span class='e-icon e-arrow-sans-up e-topind'></span>{{/if}}" +
                "<div class='e-appointinnertext'><div class='e-apptext {{if (priority!=undefined && priority!='')}}e-priorwidth{{/if}}'>{{if recurrence == true}}{{if recurrenceEdit == true}}<span class='e-icon e-recureditapp'></span>{{else}}<span class='e-icon e-recurapp'></span>{{/if}}{{/if}}{{:subject}} </div><div class='e-apptime {{if (priority!=undefined && priority!='')}}e-priorwidth{{/if}}'> {{:startTime}} - {{:endTime}}</div>{{if value == true}}<div class='e-multipleCategory'>{{:multiDiv}}</div>{{/if}}</div>" +
                "{{else}}{{if recurrence == true}}{{if recurrenceEdit == true}}<span class='e-icon e-recureditapp'></span>{{else}}<span class='e-icon e-recurapp'></span>{{/if}}{{/if}}{{:userTemplate}}{{/if}}</div>");
    };

    var _inlineAppTemplate = function () {
        return ("<div class='{{:appClass}}' id='Appointment_{{:id}}' role='presentation' style='position:absolute; {{if rtl == true}}right{{else}}left{{/if}}: {{:left}}; width: {{:appWidth}}; background: {{:appointData}};  color:{{:appointtextcolor}}; {{if appHeight}}height:{{:appHeight}}px;{{/if}} top: {{:top}}px;' >" +
            "<div class='e-appointinnertext'><input class='e-inlinetext' type='text' style='background:transparent; border: 0px solid; '/>{{:subject}}");
    };

    var blockTimeTemplate = function () {
        return ("<div class='e-blocktimewrapper'><div class='e-blocktimeappointment {{:blockClass}} {{:customStyle}}' id='BlockTime_{{:id}}' role='presentation' style='width: {{:appWidth}}; height: {{:appHeight}}px; left: {{:left}}px; top: {{:top}}px;'>" +
                "{{if userTempId == false}}{{:subject}}{{else}}{{:userTemplate}}{{/if}}</div></div>");

    };

    var categorizeMultipleTemplate = function () {
        return ("{{for renderData }}<div style='background:{{:value}};height:11px;width:6px;float:left'></div>{{/for}}");
    };

    var headerTemplate = function () {
        return ("{{for cols ~view=view ~colspan=colspan}}{{if cellToday == 'e-headerToday'}}<td class='e-headercells e-currentdayhighlight' colspan='{{:~colspan}}'>{{else}}<td class='e-headercells' colspan='{{:~colspan}}'>{{/if}}" +
                "<div class='e-dateheadercell' title='{{:currentDay}}'> <span class='e-headerdaydisplay'>{{:currentDay}}</span></div></td>{{/for}}");
    };
    var leftHeaderTemplate = function () {
        return ("<table class='e-table e-leftindenttable' style='height:100%'>" +
                "<tbody> {{for trs ~tdClass=tdClass ~divClass=divClass}} <tr>{{for ~tdClass=tdClass ~divClass=divClass}} <td class='{{:~tdClass}} {{if ~tdClass == 'e-leftindent' }}e-alldaycellsheight{{else}}e-headercellsheight{{/if}}'> <div class='{{:~divClass}}'></div></td>{{/for}}</tr>" +
                "{{/for}}</tbody></table>");
    };
    var alldayTemplate = function () {
        return ("{{for cols ~colspan=colspan ~userTemp=userTemp ~allDayHtml=userHtml}}<td class='e-alldaycells e-alldaycellsheight' colspan='{{:~colspan}}'>{{if ~userTemp==true}}{{:~allDayHtml[#getIndex()]}}{{/if}}</td>{{/for}}");
    };

    var workCellsTemplate = function () {
        return ("<table class='e-table e-workcellstab' style='width:100%;height:100%;'>" +
                "<tbody >{{for cellrows  ~timesc=timeScale ~cols1=cols1 ~userTemp=userTemplate ~userHtml=userHtml}}" +
                "<tr>{{for ~index=#index ~cwidth=cwidth ~cheight=cheight ~cols1 ~value=#getIndex()}}" +
                "{{if ((~index+1) % ~timesc) == 0 }}<td class='e-workcells' style='width:{{:~cwidth}};height:{{:~cheight}};'>{{else}}<td class='e-workcells e-alternatecells' style='width:{{:~cwidth}};height:{{:~cheight}};'>{{/if}}{{if ~userTemp == true}}{{:~userHtml[~value][#getIndex()]}}{{/if}}</td>" +
                "{{/for}}</tr>{{/for}}</tbody></table>");
    };

    var timeCellsTemplate = function () {
        return ("<div class='e-scrolltimecells' style='width:auto;height:100%;'><table class='e-table e-timecelltable' style='width:100%;height:100%;'>" +
                "<tbody>{{for timerows ~timesc=timeScale ~cols1=cols1 ~view1=viewclass ~userTemplateId = userTemplateId ~timeValue1=timeValue1 ~template=template}}" +
                "<tr>{{for ~name=time ~id=id ~view=~view1 ~index=#index }}" +
                "{{if ~view == 0}}{{if ~userTemplateId==true}}<td class='e-timecells'>{{for ~cols1[~index] }}{{if (#index+1)% ~timesc ==0}}<div class='e-timecelldivs' style='height: 20px'>{{:~timeValue1[~index][#getIndex()]}}</div>{{else}}<div class='e-timecelldivs' style='height: 21px'>{{:~timeValue1[~index][#getIndex()]}}</div>{{/if}}{{/for}}</td>" +
                "{{else}}<td class='e-timecells'><div class='e-timecelldivs'>{{if ~template==true}}{{:~name}}{{else}}{{:~name.slice(0,2)}}{{/if}}</div></td>{{/if}}" +
                "<td class='e-timecells' rowspan='1'>{{for ~cols1[~index] }}{{if (#index+1)% ~timesc ==0}}{{if ~timesc==1}}{{:~name.slice(3,5)}}{{/if}}{{else}} {{if (#getIndex())== 0}}<div id='{{:~id}}' class='e-ampmdisplay e-ampmstyle e-idAmpmstyle'> {{if ~template ==true || ~userTemplateId==true }}{{else}}{{:~name.slice(3,6)}}{{/if}}</div>{{else}}<div class='e-ampmdisplay e-ampmstyle'></div>{{/if}} {{/if}}{{/for}}</td>{{else}}<td class='e-timecells'><div class='e-timecelldivs'></div></td>{{/if}}{{/for}}</tr>{{/for}}</tbody></table></div>");
    };

    var userTimeCellsTemplate = function () {
        return ("<div class='e-scrolltimecells'><table class='e-table' style='width:70px'>" +
                "<tbody>{{for timerows ~timesc=timeScale ~cols1=cols1 ~view1=viewclass  ~userTemplateId = userTemplateId ~timeValue1=timeValue1 ~template=template ~cheight = cheight}}" +
                "<tr height='21px'>{{if ~timesc == 1}}<th class='e-timecells' rowspan='1'>{{else}}<th class='' rowspan='1'>{{/if}}{{:~timeValue1[#getIndex()][0]}}</th></tr>" +
                "{{for ~cols1 ~name=time ~id=id ~view=~view1 ~index=#index ~timeSc=~timesc}}" +
                "{{if  (#getIndex()+2)% ~timeSc ==0}}<tr height='21px'><th class='e-timecells' style='text-align:left' rowspan='1'>{{:~timeValue1[~index][#getIndex()+1]}}</th></tr> " +
                "{{else}}<tr height='21px'>{{if ~timesc == 1}}<th class='e-timecells' rowspan='1'>{{else}}<th class='' rowspan='1'>{{/if}}{{:~timeValue1[~index][#getIndex()+1]}}</th></tr>{{/if}}{{/for}}{{/for}}</tbody></table></div>");
    };
    var agendaHeaderTemplate = function () {
        return ("<tr>{{for cols}}<td class='e-headercells {{:className}} {{if (#index==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'><b>{{:headertext}}</b></div></td>{{/for}}</tr>");
    };

    var agendaCellsTemplate = function () {
        return ("<table class='e-table e-agendacellstab' style='width:100%'>" +
                "<tbody >{{for cols}}<tr>" +
                "{{if resGroup}}{{for resGroup}}<td class='e-agendacells {{:resId}} e-resourcecolumn {{if (#index==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{:text}}</div></td>{{/for}}{{/if}}" +
                "{{if resChild}}<td rowspan={{:resRowSpan}} class='e-agendacells e-resourcecolumn {{if (resGroup.length==0)}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{if userResourceId == false}}{{:resName}}{{else}}{{:userResourceHtml}}{{/if}}</div></td>{{/if}}" +
                "{{if dayChild}}<td rowspan={{:dayRowSpan}} class='e-agendacells e-datecolumn {{if (resGroup.length != 0) }}{{else (resName =='')}}e-firstcolumn{{/if}}'><div class='e-textwrapper'>{{if userDateId == false}}{{:date}}{{else}}{{:userDateHtml}}{{/if}}</div></td>{{/if}}" +
                "<td class='e-agendacells e-timecolumn {{if dayBorderBottom==false}}e-alternatecells{{/if}}'><div class='e-textwrapper'>{{if userTimeId == false}}{{:time}}{{else}}{{:userTimeHtml}}{{/if}}</div></td>" +
                "<td class='e-agendacells e-eventcolumn {{if dayBorderBottom==false}}e-alternatecells{{/if}}'><div class='e-textwrapper'><div id='Appointment_{{:id}}'  data-guid= '{{:uid}}' class='e-agendaappointment'>{{if userAppTemplId == false}}<span class='e-agendacolordiv' style='background:{{:background}}; {{if ignoreColorFilter == true}}filter:none;{{/if}}'/>{{:event}}{{else}}{{:userTemplate}}{{/if}}{{if readOnly == false}}<div class='e-agendahover'><span class='e-icon e-edit_05 e-editapp' title={{:edittext}}/>{{if allowDelete == true}}<span class='e-icon e-close e-deleteapp' title={{:deletetext}}/></div>{{/if}}{{/if}}</div></div></td>" +
                "</tr>{{/for}}</tbody></table>");
    };

    ej.widget("ejSchedule", "ej.Schedule", {
        _rootCSS: "e-schedule",
        element: null,
        validTags: ["div"],
        model: null,
        _requiresID: true,
        defaults: {
            timeZoneCollection: {
                dataSource: [
                { text: "UTC -12:00", id: "1", value: "UTC -12:00" },
                { text: "UTC -11:00", id: "2", value: "UTC -11:00" },
                { text: "UTC -10:00", id: "3", value: "UTC -10:00" },
                { text: "UTC -09:00", id: "4", value: "UTC -09:00" },
                { text: "UTC -08:00", id: "5", value: "UTC -08:00" },
                { text: "UTC -07:00", id: "6", value: "UTC -07:00" },
                { text: "UTC -06:00", id: "7", value: "UTC -06:00" },
                { text: "UTC -05:00", id: "8", value: "UTC -05:00" },
                { text: "UTC -04:30", id: "9", value: "UTC -04:30" },
                { text: "UTC -04:00", id: "10", value: "UTC -04:00" },
                { text: "UTC -03:30", id: "11", value: "UTC -03:30" },
                { text: "UTC -03:00", id: "12", value: "UTC -03:00" },
                { text: "UTC -02:00", id: "13", value: "UTC -02:00" },
                { text: "UTC -01:00", id: "14", value: "UTC -01:00" },
                { text: "UTC +00:00", id: "15", value: "UTC +00:00" },
                { text: "UTC +01:00", id: "16", value: "UTC +01:00" },
                { text: "UTC +02:00", id: "17", value: "UTC +02:00" },
                { text: "UTC +03:00", id: "18", value: "UTC +03:00" },
                { text: "UTC +03:30", id: "19", value: "UTC +03:30" },
                { text: "UTC +04:00", id: "20", value: "UTC +04:00" },
                { text: "UTC +04:30", id: "21", value: "UTC +04:30" },
                { text: "UTC +05:00", id: "22", value: "UTC +05:00" },
                { text: "UTC +05:30", id: "23", value: "UTC +05:30" },
                { text: "UTC +05:45", id: "24", value: "UTC +05:45" },
                { text: "UTC +06:00", id: "25", value: "UTC +06:00" },
                { text: "UTC +06:30", id: "26", value: "UTC +06:30" },
                { text: "UTC +07:00", id: "27", value: "UTC +07:00" },
                { text: "UTC +08:00", id: "28", value: "UTC +08:00" },
                { text: "UTC +09:00", id: "29", value: "UTC +09:00" },
                { text: "UTC +09:30", id: "30", value: "UTC +09:30" },
                { text: "UTC +10:00", id: "31", value: "UTC +10:00" },
                { text: "UTC +11:00", id: "32", value: "UTC +11:00" },
                { text: "UTC +12:00", id: "33", value: "UTC +12:00" },
                { text: "UTC +13:00", id: "34", value: "UTC +13:00" }
                ],
                text: "text",
                id: "id",
                value: "value"
            },
            views: ["Day", "Week", "WorkWeek", "Month", "Agenda"],
            agendaViewSettings: {
                daysInAgenda: 7,
                dateColumnTemplateId: null,
                timeColumnTemplateId: null
            },
            currentView: "week",
            timeMode: null,
            firstDayOfWeek: null,
            workWeek: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"],
            dateFormat: "",
            isDST: false,
            timeZone: null,
            timeScale: {
                enable: true,
                minorSlotCount: 2,
                majorSlot: 60,
                minorSlotTemplateId: null,
                majorSlotTemplateId: null
            },
            startHour: 0,
            endHour: 24,
            highlightBusinessHours: true,
            enableLoadOnDemand: false,
            enablePersistence: false,
            showQuickWindow: true,
			showRecurrenceAlert: true,
            showLocationField: false,
            showTimeZoneFields: true,
            businessStartHour: 9,
            businessEndHour: 18,
            workHours: {
                highlight: true,
                start: 9,
                end: 18
            },
            width: "100%",
            height: "1120px",
            cellHeight: "",
            cellWidth: "",
            currentDate: new Date(),
            minDate: new Date(1900, 1, 1),
            maxDate: new Date(2099, 12, 31),
            cssClass: "",
            locale: "en-US",
            enableResize: false,
            readOnly: false,
            enableRTL: false,
            enableAppointmentNavigation: null,
            showAppointmentNavigator: true,
            appointmentTemplateId: null,
            allDayCellsTemplateId: null,
            dateHeaderTemplateId: null,
            workCellsTemplateId: null,
            resourceHeaderTemplateId: null,
            allowDragDrop: null,
            allowDragAndDrop: true,
            enableAppointmentResize: true,
            showCurrentTimeIndicator: true,
            showAllDayRow: true,
            showHeaderBar: true,
            isResponsive: true,
            showWeekend: true,
            enableRecurrenceValidation: true,
            appointmentDragArea: "",
            showOverflowButton: true,
            allowInline: false,
            allowDelete: true,
            reminderSettings: {
                enable: false,
                alertBefore: 5
            },
            contextMenuSettings: {
                enable: false,
                menuItems: {
                    appointment: [
                        { id: "open", text: "Open Appointment" },
                        { id: "delete", text: "Delete Appointment" }
                    ],
                    cells: [
                        { id: "new", text: "New Appointment" },
                        { id: "recurrence", text: "New Recurring Appointment" },
                        { id: "today", text: "Today" },
                        { id: "gotodate", text: "Go to date" },
                        { id: "settings", text: "Settings" },
                        { id: "view", text: "View", parentId: "settings" },
                        { id: "timemode", text: "TimeMode", parentId: "settings" },
                        { id: "view_Day", text: "Day", parentId: "view" },
                        { id: "view_Week", text: "Week", parentId: "view" },
                        { id: "view_Workweek", text: "Workweek", parentId: "view" },
                        { id: "view_Month", text: "Month", parentId: "view" },
                        { id: "view_Agenda", text: "Agenda", parentId: "view" },
                        { id: "timemode_Hour12", text: "12 Hours", parentId: "timemode" },
                        { id: "timemode_Hour24", text: "24 Hours", parentId: "timemode" },
                        { id: "workhours", text: "Work Hours", parentId: "settings" }
                    ]
                }
            },
            group: null,
            resources: null,
            allowKeyboardNavigation: true,
            blockoutSettings: {
                enable: false,
                templateId: null,
                dataSource: [],
                query: null,
                tableName: null,
                id: "Id",
                subject: "Subject",
                startTime: "StartTime",
                endTime: "EndTime",
                isBlockAppointment: "IsBlockAppointment",
                isAllDay: null,
                customStyle: null,
                resourceId: null,
                groupId: null
            },
            appointmentSettings: {
                applyTimeOffset: true,
                editFutureEventsOnly: false,
                dataSource: [],
                query: null,
                tableName: null,
                id: null,
                subject: null,
                description: null,
                startTime: null,
                endTime: null,
                recurrence: null,
                recurrenceRule: null,
                allDay: null,
                resourceFields: null,
                categorize: null,
                recurrenceId: null,
                recurrenceExDate: null,
                location: null,
                priority: null,
                startTimeZone: null,
                endTimeZone: null
            },
            renderDates: null,
            orientation: "vertical",
            categorizeSettings: {
                title: null,
                enable: false,
                allowMultiple: false,
                dataSource:
                   [
                   { text: "Blue Category", id: 1, color: "#43b496", fontColor: "#ffffff" },
                   { text: "Green Category", id: 2, color: "#7f993e", fontColor: "#ffffff" },
                   { text: "Orange Category", id: 3, color: "#cc8638", fontColor: "#ffffff" },
                   { text: "Purple Category", id: 4, color: "#ab54a0", fontColor: "#ffffff" },
                   { text: "Red Category", id: 5, color: "#dd654e", fontColor: "#ffffff" },
                   { text: "Yellow Category", id: 6, color: "#d0af2b", fontColor: "#ffffff" }
                   ],
                text: "text",
                id: "id",
                color: "color",
                fontColor: "fontColor"
            },
            prioritySettings: {
                title: null,
                enable: false,
                template: null,
                dataSource:
                [
                { text: "None", value: "none" },
                { text: "High", value: "high" },
                { text: "Medium", value: "medium" },
                { text: "Low", value: "low" }
                ],
                text: "text",
                value: "value"
            },
            showTimeScale: true,
            tooltipSettings: {
                enable: false,
                templateId: null
            },
            showDeleteConfirmationDialog: true,
            showNextPrevMonth: true,
            cellClick: null,
            cellHover: null,
            appointmentClick: null,
            appointmentHover: null,
            cellDoubleClick: null,
            appointmentWindowOpen: null,
            appointmentSaved: null,
            appointmentEdited: null,
            appointmentDeleted: null,
            beforeAppointmentCreate: null,
            beforeAppointmentChange: null,
            beforeAppointmentRemove: null,
            appointmentCreated: null,
            appointmentChanged: null,
            appointmentRemoved: null,
            keyDown: null,
            navigation: null,
            dragStart: null,
            drag: null,
            dragStop: null,
            resizeStart: null,
            resize: null,
            resizeStop: null,
            menuItemClick: null,
            beforeContextMenuOpen: null,
            reminder: null,
            actionBegin: null,
            actionComplete: null,
            overflowButtonClick: null,
            overflowButtonHover: null,
            create: null,
            load: null,
            destroy: null,
            queryCellInfo: null
        },
        dataTypes: {
            views: "array",
            workWeek: "array",
            timeZoneCollection: {
                dataSource: "data",
                query: "data"
            },
            renderDates: "data",
            enablePersistence: "boolean",
            showTimeScale: "boolean",
            resources: "array",
            allowInline: "boolean",
            allowDelete: "boolean",
            group: {
                resources: "array"
            },
            appointmentSettings: {
                dataSource: "data",
                query: "data",
                subject: "parent",
                description: "parent",
                startTime: "parent",
                endTime: "parent",
                recurrence: "parent",
                recurrenceRule: "parent",
                allDay: "parent",
                resourceFields: "parent",
                categorize: "parent",
                location: "parent",
                priority: "parent",
                startTimeZone: "parent",
                endTimeZone: "parent"
            },
            categorizeSettings: {
                dataSource: "data",
                query: "data"
            },
            prioritySettings: {
                dataSource: "data",
                query: "data"
            },
            contextMenuSettings: {
                menuItems: {
                    appointment: "array",
                    cells: "array",
                }
            },
            blockoutSettings: {
                dataSource: "data",
                query: "data"
            }
        },
        _ignoreOnPersist: [
            "appointmentSettings.query", "appointmentSettings.dataSource", "timeZoneCollection.dataSource",
            "allowKeyboardNavigation", "showQuickWindow", "cssClass", "locale", "enableResize", "showHeaderBar",
            "readOnly", "enableRTL", "enableAppointmentNavigation", "showAppointmentNavigator", "appointmentTemplateId", "resourceHeaderTemplateId", "allowDragDrop", "allowDragAndDrop", "enableAppointmentResize",
            "showCurrentTimeIndicator", "reminderSettings.enable", "contextMenuSettings.enable", "group", "categorizeSettings.enable", "categorizeSettings.dataSource",
            "cellClick", "overflowButtonClick ", "overflowButtonHover", "keyDown", "appointmentClick", "cellDoubleClick", "appointmentWindowOpen", "appointmentSaved", "appointmentEdited", "appointmentDeleted", "beforeAppointmentCreate", "beforeAppointmentChange", "beforeAppointmentRemove", "appointmentCreated", "appiontmentChanged", "appointmentRemoved", "navigation", "dragStart", "dragStop",
            "resizeStart", "resize", "resizeStop", "menuItemClick", "beforeContextMenuOpen", "reminder", "prioritySettings.dataSource", "prioritySettings.enable", "agendaViewSettings.daysInAgenda", "agendaViewSettings.dateColumnTemplateId", "agendaViewSettings.timeColumnTemplateId", "blockoutSettings.dataSource"
        ],
        _ignoreFromAppointmentOnExport: ["dataSource", "query", "tableName", "resourceFields"],
        _ignoreFromModelOnExport: ["timezoneCollection", "timeZoneCollection", "contextMenuSettings", "prioritySettings"],
        _resources: function (index, property, value, old) {
            this.element.empty();
            this._bindResourcesData();
            if (!ej.isNullOrUndefined(this.dataSource()))
                this._renderAppointmentAll();
        },
        observables: ["appointmentSettings.dataSource", "currentView", "currentDate"],
        _tags: [
            { tag: "timeZoneCollection", attr: [], "singular": "timeZoneCollection" },
            { tag: "appointmentSettings.dataSource", attr: [], "singular": "dataSource" },
            { tag: "resources", attr: ["allowMultiple", "field", "title", "name", "resourceSettings"] },
            { tag: "contextMenuSettings.menuItems.appointment", attr: ["id", "text", "parentId"] },
            { tag: "contextMenuSettings.menuItems.cells", attr: ["id", "text", "parentId"] },
            { tag: "categorizeSettings.dataSource", attr: ["text", "id", "color", "fontColor"] },
            { tag: "timeZoneCollection.dataSource", attr: ["text", "id", "value"] },
            { tag: "prioritySettings.dataSource", attr: ["text", "value"] }
        ],
        currentView: ej.util.valueFunction("currentView"),
        currentDate: ej.util.valueFunction("currentDate"),
        dataSource: ej.util.valueFunction("appointmentSettings.dataSource"),

        _init: function () {
            if ($.isEmptyObject(this.model.group)) this.model.group = null;
            this._localizedLabels = ej.getLocalizedConstants("ej.Schedule", this.model.locale);
            this._diffDays = null;
            if (this.model.locale != "en-US") this._recurrenceLocal();
            if (ej.isNullOrUndefined(this.model.workHours.start)) this.model.workHours.start = this.model.businessStartHour;
            if (ej.isNullOrUndefined(this.model.workHours.end)) this.model.workHours.end = this.model.businessEndHour;
            if (ej.isNullOrUndefined(this.model.workHours.highlight)) this.model.workHours.highlight = this.model.highlightBusinessHours;
            if (ej.isNullOrUndefined(this.model.timeZoneCollection)) this.model.timeZoneCollection = this.model.timezoneCollection;
            if (ej.isNullOrUndefined(this.model.timeScale.enable)) this.model.timeScale.enable = this.model.showTimeScale;
            //Added the deprecating the enableAppointmentNavigation API
            this.model.showAppointmentNavigator = ej.isNullOrUndefined(this.model.enableAppointmentNavigation) ? this.model.showAppointmentNavigator : this.model.enableAppointmentNavigation;
            this.model.allowDragAndDrop = ej.isNullOrUndefined(this.model.allowDragDrop) ? this.model.allowDragAndDrop : this.model.allowDragDrop;
            //Added the deprecating the appointmentEvents API
            if (ej.isNullOrUndefined(this.model.beforeAppointmentCreate)) this.model.beforeAppointmentCreate = this.model.appointmentSaved;
            if (ej.isNullOrUndefined(this.model.beforeAppointmentChange)) this.model.beforeAppointmentChange = this.model.appointmentEdited;
            if (ej.isNullOrUndefined(this.model.beforeAppointmentRemove)) this.model.beforeAppointmentRemove = this.model.appointmentDeleted;
            this._processAppointmentSettings();
            this._currentDateFormat(this.model.dateFormat);
            this._trigger("load");
            this.element.addClass("e-schedule");
            (this.model.cssClass != null) && this.element.addClass(this.model.cssClass);
            this._initPrivateProperties();
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) this._resourceSegregate();
            if (this.model.categorizeSettings.enable && this.model.categorizeSettings.dataSource instanceof ej.DataManager) this._bindCategorizeData();
            if (this.model.prioritySettings.enable && this.model.prioritySettings.dataSource instanceof ej.DataManager) this._bindPriorityData();
            (ej.scheduleFeatures.resources && this._tempResource.length != 0) ? this._bindResourcesData() : this._renderInitSchedule();
            this._wireEvents();
            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
            this._bindAppointmentsData("Load");
            if (this.model.blockoutSettings.enable) {
                (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
            }
            if (this.model.reminderSettings.enable) {
                this._checkReminders();
                this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000);
            }
        },
        _processAppointmentSettings: function () {
            if (ej.isNullOrUndefined(this.model.appointmentSettings.query) || !(this.model.appointmentSettings.query instanceof ej.Query)) this.model.appointmentSettings.query = ej.Query();
            this._appointmentSettings = {}; var resource = "";
            this._applyTimeOffset = this.model.appointmentSettings.applyTimeOffset;
            this._recurrenceFutureActions = this.model.appointmentSettings.editFutureEventsOnly;
            for (var col in this.model.appointmentSettings) {
                if (col != "applyTimeOffset" && col != "editFutureEventsOnly") {
                    if (col !== "tableName" && col !== "query" && col !== "dataSource") {
                        this._appointmentSettings[col] = ($.type(this.model.appointmentSettings[col]) == "string" || ej.isNullOrUndefined(this.model.appointmentSettings[col])) ? this.model.appointmentSettings[col] : this.model.appointmentSettings[col].field;
                        if (col !== "resourceFields" && col !== "categorize" && col !== "priority")
                            (ej.isNullOrUndefined(this._appointmentSettings[col])) && (this._appointmentSettings[col] = col.charAt(0).toUpperCase() + col.slice(1));
                        if (col == "resourceFields" && ej.isNullOrUndefined(this._appointmentSettings.resourceFields) && !ej.isNullOrUndefined(this.model.resources)) {
                            for (var i = 0, len = this.model.resources.length; i < len; i++) {
                                resource = this.model.resources[i].field.charAt(0).toUpperCase() + this.model.resources[i].field.slice(1);
                                this._appointmentSettings[col] += ((i !== 0) ? "," : "") + resource;
                            }
                        }
                    }
                }
            }
        },
        _setModel: function (options) {
            var flag = false;
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow)) this._quickAppDetailsWindow.ejDialog("close");
            for (var prop in options) {
                switch (prop) {
                    case "views":
                        this.model.views = options[prop];
                        this.model.views = (this.model.views.length == 0) ? this.currentView().toString().toLowerCase().split(",") : this.model.views.toString().toLowerCase().split(",");
                        this.hTR.find("table.e-viewstable").remove();
                        this.hTR.find("div.e-viewsdiv").append(this._renderViewNavigation(options[prop].toString().toLowerCase().split(",")));
                        this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview").attr("tabIndex", 0).focus();
                        if (!ej.isNullOrUndefined(this._scheduleDrawer)) {
                            this._scheduleDrawer.ejNavigationDrawer('destroy');
                            $(this._scheduleDrawer).remove(); this._scheduleDrawer = null;
                            ((this._mediaQuery || this.element.width() < 600) && !$("#" + this._id + "navDrawer").hasClass("e-scheduledrawer")) && this._renderNavigationDrawer();
                        }
                        if (this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) == -1) {
                            this._navView = true;
                            if (this.model.views.length == 0) {
                                this.model.views = this.currentView().toString().toLowerCase().split(",");
                                flag = true;
                            }
                            else
                                this._viewChange(null, null, this.model.views[0].toLowerCase());
                        }
                        break;
                    case "currentView":
                        if (this.model.views.toString().toLowerCase().split(',').indexOf(ej.util.getVal(options[prop]).toLowerCase()) != -1) {
                            this._navView = true;
                            this._viewChange(null, null, ej.util.getVal(options[prop]).toLowerCase())
                        }
                        else {
                            this._navView = false;
                            this.currentView((this.element.find(".e-activeview")[0].className.split("e-")[2]).split(" ")[0]);
                        }
                        break;
                    case "currentDate":
                        if ($.type(options[prop]) == "string")
                            this._currentDateFormat(this.model.dateFormat);
                        else if ($.type(options[prop]) == "function" && $.type(ej.util.getVal(options[prop])) == "string")
                            this.currentDate(ej.parseDate(this.currentDate(), this._datepattern()));
                        if (this._keyPressed) {
                            this._keyPressed = false;
                            return false;
                        }
                        this._setCurrentDate = true;
                        ((this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate));
                        ((this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate));
                        this._navigateClick(null, "DateNavigation");
                        break;
                    case "minDate":
                    case "maxDate":
                        this._currentDateFormat(this.model.dateFormat);
                        flag = true;
                        break;
                    case "timeMode":
                        var culture = ej.preferredCulture(this.model.locale);
                        this.model.timeMode = this._timeMode = (options[prop] == "Hour12") ? "12" : (options[prop] == "Hour24") ? "24" : (culture.calendar.AM == null && culture.calendar.PM == null) ? "24" : options[prop];
                        this._pattern.t = (this._timeMode == "12") ? "h:mm tt" : "HH:mm";
                        this._updateTimeMode();
                        this.element.find(".e-scrolltimecells").height(this.element.find('.e-workcellstab').height());
                        break;
                    case "timeZone":
                        this._setmodelvalue = true;
                        this.model.timeZone = options[prop];
                        this.element.find("div.e-categorybar").remove();
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this._bindAppointmentsData("Load");
                        if (this.model.blockoutSettings.enable) {
                            (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                        }
                        break;
                    case "showTimeScale":
                    case "timeScale":
                        if (prop == "showTimeScale") this.model.timeScale.enable = options[prop];
                        if (prop == "timeScale") $.extend(this.model.timeScale, options[prop]);
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "timezoneCollection":
                    case "timeZoneCollection":
                        $.extend(this.model.timeZoneCollection, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find('.startutc').ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                        this._appointmentAddWindow.find('.endutc').ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                        break;
                    case "showTimeZoneFields":
                        this.model.showTimeZoneFields = options[prop];
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.showTimeZoneFields) {
                            if (this._appointmentAddWindow.find("#" + this._id + "_appStartTime").children().length < 4) {
                                if (this._mediaQuery) {
                                    var $startTimeZone = "<td width='31%'><input id='" + this._id + "startTimeZone' class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                                    var $endTimeZone = "<td><input  id='" + this._id + "endTimeZone' class='endutc' name='" + this._appointmentSettings["endTimeZone"] + "' type='text' value=''/><div id='Timezonelistend'></div></td>";
                                }
                                else {
                                    var $startTimeZone = "<td width='28%'><input  id='" + this._id + "startTimeZone'  class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                                    var $endTimeZone = "<td><input id='" + this._id + "endTimeZone'  class='endutc'  name='" + this._appointmentSettings["endTimeZone"] + "'  type='text' value=''/><div id='Timezonelistend'></div></td>";
                                }
                                this._appointmentAddWindow.find("#" + this._id + "_appStartTime").append($startTimeZone);
                                this._appointmentAddWindow.find("#" + this._id + "_appEndTime").append($endTimeZone);
                                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._startUtc, this), cssClass: this.model.cssClass });
                                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._endUtc, this), cssClass: this.model.cssClass });
                            }
                            this._timeZoneCollection(null);
                        }
                        else {
                            this._appointmentAddWindow.find("#" + this._id + "_appStartTime").children().last().remove();
                            this._appointmentAddWindow.find("#" + this._id + "_appEndTime").children().last().remove();
                        }
                        break;
                    case "startHour":
                        this.model.startHour = options[prop];
                        if (this.model.startHour < 0) this.model.startHour = 0;
                        (this.currentView() !== "agenda") && this._setNewStartEndHours();
                        break;
                    case "endHour":
                        this.model.endHour = options[prop];
                        if (this.model.endHour > 24) this.model.endHour = 24;
                        (this.currentView() !== "agenda") && this._setNewStartEndHours();
                        break;
                    case "highlightBusinessHours":
                    case "businessStartHour":
                    case "businessEndHour":
                    case "workHours":
                        if (prop == "highlightBusinessHours") this.model.workHours.highlight = options[prop];
                        if (prop == "businessStartHour") this.model.workHours.start = options[prop];
                        if (prop == "businessEndHour") this.model.workHours.end = options[prop];
                        if (prop == "workHours") $.extend(this.model.workHours, options[prop]);
                        if (this.currentView() !== "agenda") {
                            (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells,.e-monthcells").removeClass("e-businesshighlightworkcells").removeClass("e-monthcellhighlight");
                            this._businessHourScroller();
                            this._renderUpDownIconPosition();
                        }
                        break;
                    case "showAllDayRow":
                        this.model.showAllDayRow = options[prop];
                        (!this.model.timeScale.enable) && (this.model.showAllDayRow = false);
                        if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.timeScale.enable && this.currentView() != "agenda" && this.currentView() != "month" && !(this._isCustomMonthView())) {
                            this.aTR.empty();
                            this._renderHeaderAllDayTemplate();
                            this._borderAddRemove();
                            this._headerbarWidth();
                            this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
							this._renderHoriVerticalScroll();
                            (this.model.showAllDayRow) && this._reRenderAllDayAppointments();
                            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.cellWidth) {
                                this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-headercells").width());
                            }                            
                            this._reRenderScroller();
                        }
                        break;
                    case "isResponsive":
                        this.model.isResponsive = options[prop];
                        this._onScheduleResize();
                        break;
                    case "isDST":
                        this.model.isDST = options[prop];
                        if (ej.isNullOrUndefined(this.model.timeZone)) {
                            var today = new Date();
                            this._timeValue = this._true == false ? -(today.getTimezoneOffset() - this._stdTimezoneOffset()) : today.getTimezoneOffset() - this._stdTimezoneOffset();
                            this._true = (this.model.isDST) ? false : true;
                            this._dayLight = true;
                            this.element.find("div.e-categorybar").remove();
                            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-appsoverflow").remove();
                            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
                            this._bindAppointmentsData("Load");
                        }
                        break;
                    case "enableRecurrenceValidation":
                        this.model.enableRecurrenceValidation = options[prop];
                        (this.model.enableRecurrenceValidation && ej.isNullOrUndefined(this._alertWindow)) && this._renderAlertWindow();
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                        break;
                    case "height":
                        this.model.height = options[prop];
                        if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                        flag = true;
                        break;
                    case "width":
                        this.model.width = options[prop];
                        this._clientWidth = this.model.width;
                        if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                        flag = true;
                        break;
                    case "cssClass":
                        this.element.removeClass(this.model.cssClass).addClass(options[prop]);
                        break;
                    case "locale":
                        this.model.locale = options[prop];
                        this._localizedLabels = ej.getLocalizedConstants("ej.Schedule", this.model.locale);
                        if (this.model.locale != "en-US") this._recurrenceLocal();
                        this._culture = ej.preferredCulture(this.model.locale);
                        this._dayShortNames = this._culture.calendar.days.namesAbbr;
                        this._dayFullNames = this._culture.calendar.days.names;
                        this._monthNames = this._culture.calendar.months.names;
                        this._pattern = this._culture.calendar.patterns;
                        if (this.model.contextMenuSettings.enable) {
                            $("#" + this._id + "gotoWindow_wrapper").remove();
                            this._gotoDate = true;
                        }
                        flag = true;
                        break;
                    case "dateFormat":
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find('.startenddate').ejDatePicker({ dateFormat: options[prop] });
                        this._appointmentAddWindow.find('.recurstartdate').ejDatePicker({ dateFormat: options[prop] });
                        this._appointmentAddWindow.find('.e-until').ejDatePicker({ dateFormat: options[prop] });
                        this._currentDateFormat(options[prop]);
                        break;
                    case "enableResize":
                        this.model.enableResize = options[prop];
                        if (this.model.enableResize) {
                            !ej.isTouchDevice() ? this._on($(window), "resize", $.proxy(this._onScheduleResize, this)) : this._on($(window), "orientationchange", $.proxy(this._onScheduleResize, this));
                        }
                        break;
                    case "readOnly":
                        this.model.readOnly = options[prop];
                        this._renderAppointmentAll();
                        break;
                    case "allowDelete":
                        this.model.allowDelete = options[prop];
                        break;
                    case "showCurrentTimeIndicator":
                        this.model.showCurrentTimeIndicator = options[prop];
                        if (this.currentView() !== "agenda") {
                            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                            if (!this.model.showCurrentTimeIndicator) this.currentView() !== "month" && !(this._isCustomMonthView()) ? this.element.find(".e-highlightcurrenttimeline").remove() : $(this.element.find(".e-monthcells")).removeClass("e-monthcurrenttime");
                        }
                        break;
                    case "enableRTL":
                        options[prop] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                        this.model.enableRTL = options[prop];
                        flag = true;
                        if (this.model.contextMenuSettings.enable) {
                            $("#" + this._id + "gotoWindow_wrapper").remove();
                            this._gotoDate = true;
                        }
                        this._quickAppointWindow = null;
                        break;
                    case "appointmentTemplateId":
                        this.model.appointmentTemplateId = options[prop];
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this.element.find("div.e-categorybar").remove();
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                        break;
                    case "allDayCellsTemplateId":
                        this.model.allDayCellsTemplateId = options[prop];
                        flag = true;
                        break;
                    case "dateHeaderTemplateId":
                        this.model.dateHeaderTemplateId = options[prop];
                        flag = true;
                        break;
                    case "workCellsTemplateId":
                        this.model.workCellsTemplateId = options[prop];
                        flag = true;
                        break;
                    case "showWeekend":
                        this.model.showWeekend = options[prop];
                        flag = true;
                        break;
                    case "allowInine":
                        this.model.allowInline = options[prop];
                        break;
                    case "allowKeyboardNavigation":
                        this.model.allowKeyboardNavigation = options[prop];
                        if (this.model.allowKeyboardNavigation) {
                            this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
                            this._on($(document), "keydown", $.proxy(this._documentOnKeyDown, this));
                        }
                        else {
                            this._off(this.element, "keydown");
                            this._off($(document), "keydown");
                        }
                        break;
                    case "renderDates":
                        $.extend(this.model.renderDates, options[prop]);
                        this._navView = true;
                        this._viewChange(null, null, "customview");
                        break;
                    case "appointmentSettings":
                        if (!$.isEmptyObject(options[prop])) {
                            $.extend(this.model.appointmentSettings, options[prop]);
                            this._processAppointmentSettings();
                            this._quickAppointWindow = null; this._quickAppDetailsWindow = null; this._recurEditWindow = null;
                            $("#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper").remove();
                            this.element.find("div.e-categorybar").remove();
                            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-appsoverflow").remove();
                            !ej.isNullOrUndefined(this.model.appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
                            this._setmodelvalue = true;
                            this._bindAppointmentsData("Load");
                        }
                        break;
                    case "contextMenuSettings":
                        $.extend(this.model.contextMenuSettings, options[prop]);
                        if (this.model.contextMenuSettings.enable && (ej.isNullOrUndefined(this._contextMenu) || this.model.categorizeSettings.enable))
                            this._showContextMenu(this.model.contextMenuSettings.enable);
                        break;
                    case "reminderSettings":
                        if (options[prop].enable)
                            this._checkReminders() && (this._reminderInterval = window.setInterval($.proxy(this._checkReminders, this), 60000));
                        else
                            window.clearInterval(this._reminderInterval);
                        break;
                    case "showAppointmentNavigator":
                    case "enableAppointmentNavigation":
                        this.model.showAppointmentNavigator = this.model.enableAppointmentNavigation = options[prop];
                        if (!this.model.showAppointmentNavigator) {
                            this.element.find(".e-prevapp,.e-nextapp").remove();
                            this.element.find(".e-upicon,.e-downicon").remove();
                        }
                        else {
                            this._nextPrevAppointment(this.model.showAppointmentNavigator);
                            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery))
                                this._renderUpDownIcon();
                            if (!ej.isNullOrUndefined(this.dataSource()))
                                this._renderAppointmentAll();
                        }
                        break;
                    case "enableLoadOnDemand":
                        this.model.enableLoadOnDemand = options[prop];
                        this.element.find("div.e-categorybar").remove();
                        this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,.e-appsoverflow").remove();
                        this._bindAppointmentsData("Load");
                        break;
                    case "resources":
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                            ej.copyObject(this.model.resources, options[prop]);
                            this.model.resources = options[prop];
                            if (this.model.resources.length == 0) {
                                this.model.resources = null;
                                this.model.group = null;
                                flag = true;
                            }
                            else
                                flag = true;
                        }
                        break;
                    case "categorizeSettings":
                        $.extend(this.model.categorizeSettings, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) {
                            this._renderTemplates();
                            this._renderAppointmentWindow();
                        }
                        else if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                            if (this.model.categorizeSettings.enable) {
                                if (this._appointmentAddWindow.find('.e-categorizevalue').length == 1)
                                    this._appointmentAddWindow.find('#' + this._id + "categorizetr").remove();
                                var $appWindow = "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' class='e-categorizevalue' type='text' name='" + this._appointmentSettings["categorize"] + "' value=''/></td></tr>";
                                this._appointmentAddWindow.find('.' + this._id + "summary").after($appWindow);
                                this._renderTemplates();
                                this._renderCategoryItems(this._appointmentAddWindow);
                            }
                            else
                                this._appointmentAddWindow.find('#' + this._id + "categorizetr").remove();
                        }
                        this._showContextMenu(this.model.contextMenuSettings.enable);
                        if (!ej.isNullOrUndefined(this.dataSource()))
                            this._renderAppointmentAll();
                        break;
                    case "group":
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) {
                            $.extend(this.model.group, options[prop]);
                            if ($.isEmptyObject(this.model.group)) this.model.group = null;
                            flag = true;
                        }
                        break;
                    case "cellWidth":
                        this.model.cellWidth = options[prop];
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "cellHeight":
                        this.model.cellHeight = options[prop];
                        (this.currentView() !== "agenda") && (flag = true);
                        break;
                    case "orientation":
                        this.model.orientation = options[prop];
                        if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal"))
                            this._on(this.element, "click", ".e-parentnodecategory", $.proxy(this._onResourceClick, this));
                        flag = true;
                        break;
                    case "resourceHeaderTemplateId":
                        this.model.resourceHeaderTemplateId = options[prop];
                        if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                            if (this.currentView() != "agenda") {
                                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                                    var resDiv = $(this.wTR.find("td")[0]);
                                    resDiv.find("div.e-horizontresdiv").remove();
                                    var resHtml = this._renderHorizontalResources();
                                    resDiv.html(resHtml);
                                }
                                else {
                                    this.aTR.empty();
                                    this._renderHeaderAllDayTemplate();
                                    this._borderAddRemove();
                                    this._headerbarWidth();
                                    this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                                    (this.model.showAllDayRow) && this._reRenderAllDayAppointments();
                                }
                            }
                            else
                                this._renderAgendaContent();
                        }
                        break;
                    case "showLocationField":
                        this.model.showLocationField = options[prop];
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.showLocationField) {
                            $appWindow = "<tr id='" + this._id + "showLocation' class='" + this._id + "showLocation'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td><td colspan='3' class='e-rightfields'>" +
                                 "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                            this._appointmentAddWindow.find("." + this._id + "subjecttr").after($appWindow);
                        }
                        else {
                            this._appointmentAddWindow.find("." + this._id + "showLocation").remove();
                        }
                        break;
                    case "prioritySettings":
                        $.extend(this.model.prioritySettings, options[prop]);
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        if (this.model.prioritySettings.enable) {
                            if (this._appointmentAddWindow.find("." + this._id + "priorityshow").length == 1) {
                                this._appointmentAddWindow.find("." + this._id + "priorityshow").remove();
                                this._appointmentAddWindow.find("." + this._id + "prioritylistshow").remove();
                            }
                            $appWindow = "<td colspan='1' class='e-textlabel " + this._id + "priorityshow'>" + this._getLocalizedLabels("Priority") + ":</td><td colspan='1' class='" + this._id + "prioritylistshow'><input id='" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value='' /><div id='prioritylist'></div></td>";
                            this._appointmentAddWindow.find("." + this._id + "parrow").prepend($appWindow);
                            this._renderPriorityItems(this._appointmentAddWindow);
                            this._renderTemplates();
                        }
                        else {
                            this._appointmentAddWindow.find("." + this._id + "priorityshow").remove();
                            this._appointmentAddWindow.find("." + this._id + "prioritylistshow").remove();
                        }
                        if (!ej.isNullOrUndefined(this.dataSource())) {
                            this._renderAppointmentAll();
                        }
                        break;
                    case "showQuickWindow":
                        this.model.showQuickWindow = options[prop];
                        if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
                        if (!ej.isNullOrUndefined(this._quickAppointWindow)) {
                            this._quickAppointWindow.ejDialog("close");
                            this._quickAppDetailsWindow.ejDialog("close");
                        }
                        this._quickWindow = this.model.showQuickWindow;
                        break;
                    case "allowDragAndDrop":
                    case "allowDragDrop":
                        this.model.allowDragAndDrop = this.model.allowDragDrop = options[prop];
                        if (this.currentView() == "agenda") return false;
                        this.model.allowDragAndDrop ? this._dragdropAppointments() : this._unWireDragDrop();
                        break;
                    case "enableAppointmentResize":
                        this.model.enableAppointmentResize = options[prop];
                        if (this.currentView() == "agenda") return false;
                        this._renderAppointmentAll();
                        break;
                    case "showHeaderBar":
                        this.model.showHeaderBar = options[prop];
                        if (this.model.showHeaderBar) {
                            this.element.find(".e-scheduleheader").show();
                            this._reRenderHeaderBar();
                        }
                        else {
                            this.element.find(".e-scheduleheader").empty();
                            this.element.find(".e-scheduleheader").hide();
                        }
                        this.refreshScroller();
                        break;
                    case "tooltipSettings":
                        $.extend(this.model.tooltipSettings, options[prop]);
                        var target = this.model.tooltipSettings.enable ? ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendacells.e-eventcolumn,.e-appup,.e-appdown,.e-appsoverflow" : ".e-appup,.e-appdown,.e-appsoverflow";
                        var toolTipObj = this.element.data("ejTooltip");
                        toolTipObj.setModel({ target: target });
                        break;
                    case "showOverflowButton":
                        this.model.showOverflowButton = options[prop];
                        flag = true;
                        break;
                    case "appointmentDragArea":
                        this.model.appointmentDragArea = options[prop];
                        flag = true;
                        break;
                    case "firstDayOfWeek":
                        this.model.firstDayOfWeek = this._firstdayofweek = options[prop];
                        if (this._firstdayofweek)
                            flag = true;
                        break;
                    case "workWeek":
                        this.model.workWeek = options[prop];
                        if (this.model.workWeek == null || this.model.workWeek.length >= 0)
                            flag = true;
                        break;
                    case "agendaViewSettings":
                        $.extend(this.model.agendaViewSettings, options[prop]);
                        if (this.currentView() == "agenda") {
                            (this.model.showHeaderBar) && this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
                            this._renderAgendaContent();
                        }
                        break;
                    case "showNextPrevMonth":
                        this.model.showNextPrevMonth = options[prop];
                        if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month") {
                            this._renderMonthTimeCells();
                            this._highlightBusinessHours();
                            this._dataProcessing(this._currentAppointmentData);
                            this._renderAppointmentAll();
                        }
                        break;
                    case "blockoutSettings":
                        if (!$.isEmptyObject(options[prop])) {
                            $.extend(this.model.blockoutSettings, options[prop]);
                            if (this.model.blockoutSettings.enable) {
                                (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                            }
                            else {
                                this.element.find(".e-blocktimewrapper").remove();
                            }
                        }
                        break;
                }
            }
            if (flag) {
                this.element.empty();
                !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('destroy');
                this._scheduleDrawer = null; this._quickAppointWindow = null; this._quickAppDetailsWindow = null; this._alertWindow = null; this._appointmentAddWindow = null;
                $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper").remove();
                if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources)) this._resourceSegregate();
                this._setmodelvalue = true;
                (this._tempResource.length == 0 && this._grouping.length == 0) ? this._renderInitSchedule() : this._bindResourcesData();
                this._businessHourScroller();
                if (!ej.isNullOrUndefined(this.dataSource())) this._dataProcessing(this._currentAppointmentData);
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            }
        },

        _touchSchedule: function (e) {
            if ($(e.target).is(".e-appointment,.e-alldayappointment,.e-monthappointment") || $(e.target).parents().is(".e-appointment,.e-alldayappointment,.e-monthappointment"))
                return false;
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") return false;
            var eventType = this.model.enableRTL ? (e.type == "swipeleft" ? "swiperight" : "swipeleft") : e.type;
            var marginType = this.model.enableRTL ? "margin-right" : "margin-left";
            var event, value = parseInt(this.element.find(".e-draggableworkarea").css(marginType));
            var resWidth = Math.round(this.element.find(".e-draggableworkarea").width() / this.res1.length);
            var workIndent = (this.element.find(".e-workleftindent").length > 0) ? this.element.find(".e-workleftindent").outerWidth() : 0;
            var resPos = Math.round(Math.abs((this.element.find(".e-draggableworkarea").offset().left - workIndent - 1) / resWidth));
            if (this.currentView() == "month" || this._isCustomMonthView()) {
                var width = 0, num = eventType == "swipeleft" ? (resPos + 1) * 7 : (resPos - 1) * 7;
                for (var a = 0; a < num; a++) {
                    width += this.element.find(".e-draggableworkarea tr").eq(0).children().eq(a).outerWidth();
                }
                width += 3;
            }
            switch (eventType) {
                case "swipeleft":
                    if (this._mediaQuery && this.currentView() != "agenda" && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                        if (resPos + 1 != this.res1.length) {
                            var marginValue = (this.currentView() == "month" || this._isCustomMonthView()) ? -width : -((resPos + 1) * resWidth);
                            this.element.find(".e-headrealldaytable").css("left", "0px");
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate((this.model.enableRTL ? { "margin-right": marginValue } : { "margin-left": marginValue }), 500);
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css(this.model.enableRTL ? { "margin-left": 0 } : { "margin-right": 0 });
                            if (resPos + 1 == this.res1.length - 1) this._showScrollTd();
                            return false;
                        }
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css({ marginLeft: "0px", marginRight: "0px" });
                    }
                    event = { currentTarget: this.element.find('.e-navigatenext') };
                    this._navigateClick(event, "Next");
                    break;
                case "swiperight":
                    if (this._mediaQuery && this.currentView() != "agenda" && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                        if (resPos != 0) {
                            var marginValue = (this.currentView() == "month" || this._isCustomMonthView()) ? -width : -((resPos - 1) * resWidth);
                            this.element.find(".e-headrealldaytable").css("left", "0px");
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").animate((this.model.enableRTL ? { "margin-right": marginValue } : { "margin-left": marginValue }), 500);
                            this.element.find(".e-headeralldaydiv,.e-draggableworkarea").css(this.model.enableRTL ? { "margin-left": 0 } : { "margin-right": 0 });
                            if (resPos + 1 == this.res1.length - 1) this._showScrollTd();
                            return false;
                        }
                        this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css({ marginLeft: "0px", marginRight: "0px" });
                    }
                    event = { currentTarget: this.element.find('.e-navigateprevious') };
                    this._navigateClick(event, "Previous");
                    break;
            }
        },

        _initPrivateProperties: function () {
            this._navSelected = this._navDrawer = this._alldayLevel = this._reminderClose = this._navView = this._editKey = this._cellClick = this._recurChecked = this._setCurrentDate = this._leftResizing = this._rightResizing = this._topResizing = this._bottomResizing = this._allDayDrag = this._dateNavigation = this._isQuickDialogOpened = this._ignoreModifyOccurrences = false;
            this._gotoDate = this._bindapp = this._showBlockAlert = this._seriesAlert = this._editclick = this._isCustomAlert = true;
            this._tempStart = this._tempEnd = this._currentAction = "";
            this._currentRowIndex = this._currentColIndex = 0;
            this._appId = this._parentId = 1;
            this._retainScrollerPosition = {};
            this._currentAppointmentData = [], this._currentViewAppointments = [], this._processed = [], this._renderedApp = [], this._renderedAllDay = [], this._dateRender = [], this._grouping = [], this._tempResource = [], this._intialRenderedDates=[];
            this.res1 = [0];
            this._appMainId = null, this._scheduleDrawer = null, this._quickAppointWindow = null, this._quickAppDetailsWindow = null, this._inlineText = null, this._alertWindow = null, this._appointmentAddWindow = null;
            this._dayNamesArray = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
            this._dayNames = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"];
            this._culture = ej.preferredCulture(this.model.locale);
            this._dayShortNames = this._culture.calendar.days.namesAbbr;
            this._dayFullNames = this._culture.calendar.days.names;
            this._monthNames = this._culture.calendar.months.names;
            this._pattern = this._culture.calendar.patterns;
            this._browserInfo = ej.browserInfo();
            this._safariBrowser = this._browserInfo.name == "webkit" && !ej.isTouchDevice();
            this._focused = null;
            this._expandCollapseState = [];
            this._horizontalScrollValue = null;
            Array.prototype.map = Array.prototype.map || function (callback, thisArg) {
                var T, A, k;
                if (this == null) { throw new TypeError('this is null or not defined'); }
                var O = Object(this);
                var len = O.length >>> 0;
                if (typeof callback !== 'function') { throw new TypeError(callback + ' is not a function'); }
                if (arguments.length > 1) { T = thisArg; }
                A = new Array(len);
                k = 0;
                while (k < len) {
                    var kValue, mappedValue;
                    if (k in O) {
                        kValue = O[k];
                        mappedValue = callback.call(T, kValue, k, O);
                        A[k] = mappedValue;
                    }
                    k++;
                }
                return A;
            };
            String.prototype.trim = String.prototype.trim || function () { return this.replace(/^\s+|\s+$/g, ''); };
            String.prototype.capitalizeFirstString = String.prototype.capitalizeFirstString || function () { return this.charAt(0).toUpperCase() + this.slice(1); };
            Date.prototype.parseISO8601 = function (date) {
                var safariDate = new Date(date), isTrue = ((ej.browserInfo().name == "webkit" && !ej.isTouchDevice()) || (ej.browserInfo().name == "msie" && ej.browserInfo().version == "9.0"));
                safariDate = new Date(safariDate.getTime() + (safariDate.getTimezoneOffset() * 60000));
                return (typeof (date) === 'string') ? date.indexOf("Date") != -1 ? new Date(parseInt(date.match(/\d+/).toString())) : date.indexOf("T") != -1 ? (isTrue) ? new Date(safariDate) : new Date(date) : new Date(date.replace(/-/g, "/")) : new Date(date);
            };
            Date.prototype._currentMonthDates = function () { return { start: new Date(this.getFullYear(), this.getMonth(), 1), end: new Date(this.getFullYear(), this.getMonth() + 1, 0) }; };
            Date.prototype._currentWeekDates = function (firstdayofweek) {
                var dayDiffer = this.getDay() - firstdayofweek,
                    start = new Date(this.getFullYear(), this.getMonth(), this.getDate() + (((dayDiffer < 0) ? dayDiffer + 7 : dayDiffer) * -1)),
                    end = new Date(start.getFullYear(), start.getMonth(), start.getDate() + 6);
                return { start: new Date(start), end: new Date(end) };
            };
            Date.prototype._isDST = function () { return this.getTimezoneOffset() < Math.max(new Date(this.getFullYear(), 0, 1).getTimezoneOffset(), new Date(this.getFullYear(), 6, 1).getTimezoneOffset()); };
        },

        _destroy: function () {
            this.element.off();
            this._destorySubControls($("#" + this._id + "_AddEditForm"));
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find("#" + this._id + "recurrenceEditor").ejRecurrenceEditor("destroy");
            this.element.find("#" + this._id + "_navigator").ejDatePicker("destroy");
            window.clearInterval(this._intervalID);
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip("destroy");
            $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "AppointmentQuickWindow_wrapper,#" + this._id + "AppDetailsWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "gotoWindow_wrapper").remove();
            this.element.empty().removeClass("e-schedule e-scheduleouter");
        },

        _destorySubControls: function (formelement) {
            var $formEle = formelement.find('.e-timepicker,.e-datepicker,.e-dropdownlist,.e-autocomplete');
            for (var index = 0; index < $formEle.length; index++) {
                var $element = $($formEle[index]);
                if ($element.hasClass('e-timepicker'))
                    $element.ejTimePicker("destroy");
                else if ($element.hasClass('e-datepicker'))
                    $element.ejDatePicker("destroy");
                else if ($element.hasClass('e-dropdownlist'))
                    $element.ejDropDownList("destroy");
                else if ($element.hasClass('e-autocomplete'))
                    $element.ejAutocomplete("destroy");
            }
        },
        _closeRecurence: function (args) {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            if (this._appointmentAddWindow.find('.e-recuruntil').ejRadioButton("option", "checked") && args.model.text != this._getLocalizedLabels("Cancel") && this._appointmentAddWindow.find('.recurstartdate').ejDatePicker("option", "value") > this._appointmentAddWindow.find(".e-until").ejDatePicker("option", "value")) {
                this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("WrongPattern"));
                this._alertWindow.ejDialog("open");
                return false;
            }
            var toggleWindow = true;
            if (args.model.text == this._getLocalizedLabels("Cancel")) {
                this._appointmentAddWindow.find(".e-recurFinalRule").html() == "" && this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox({ checked: false });
            }
            else {
                var obj = this._appointmentAddWindow.find(".e-recurEditor").data("ejRecurrenceEditor");
                this._rRuleStr = obj.closeRecurPublic();
                var dateChange = obj.element.find(".recurstartdate").ejDatePicker("option", "value");
                var collection = obj.recurrenceDateGenerator(obj._recRule, dateChange);
                if (obj._rRule.freq == "MONTHLY" && !ej.isNullOrUndefined(obj._rRule.monthDay)) {
                    var date = collection.filter(function (time) { return new Date(time).getDate() == obj._rRule.monthDay; });
                    if ((!ej.isNullOrUndefined(obj._rRule.count) && date.length != collection.length) || (ej.isNullOrUndefined(obj._rRule.count) && [29, 30, 31].indexOf(obj._rRule.monthDay) != -1)) {
                        toggleWindow = false;
                        if (this._alertWindow.find(".e-alertbtn").find(".e-alertCancel").length == 0) {
                            this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                            this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                            if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                        }
                        this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                        this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("RecurrenceDateValidation"));
                        this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                        this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                        this._alertWindow.addClass("e-recurAlert");
                        this._alertWindow.ejDialog("open");
                    }
                }
                if (new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value")).setHours(0, 0, 0, 0) != new Date(dateChange).getTime())
                    this._recurDateChange(dateChange);
                if (toggleWindow) {
                    this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    this._appointmentAddWindow.find(".e-recurFinalRule").html(this._rRuleStr);
                    this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                }
            }
            if (toggleWindow) {
                this._appointmentAddWindow.find(".e-recurEditor").toggle();
                this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
                (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "block");
                this._appointmentAddWindow.find('.done').focus();
            }
        },
        _wireEvents: function () {
            this._on((this.element, $(window)), "mousedown", $.proxy(this._onScheduleMouseDown, this));
            this._on(this.element, "click", "div.e-navigateprevious,div.e-navigatenext", $.proxy(this._navigateClick, this));
            this._on($(window), "resize", $.proxy(this._onScheduleResize, this));
            this._on(this.element, "click", ".e-commonviewbutton", $.proxy(this._viewChange, this));
            this._on(this.element, "click", ".e-datedisplay", $.proxy(this._viewCalendar, this));
            this._on(this.element, "click", "div.e-appsoverflow", $.proxy(this._appOverflowClick, this));
            this._on(this.element, "click", ".e-prevapp.enable,.e-nextapp.enable", $.proxy(this._nextPrev, this));
            this._on(this.element, "dblclick", ".e-headercells", $.proxy(this._navigateView, this));
            this._on(this.element, "click", ".e-headercells,.e-timecells,td.e-monthcells div.e-monthheader", $.proxy(this._navigateView, this));
            this._on(this.element, "mouseover", "td.e-alldaycells,td.e-workcells:not('.e-resourceheadercells'),td.e-monthcells:not('.e-othermonths'),td.e-agendacells", $.proxy(this._onCellMouseOver, this));
            this._on(this.element, "mouseout", "td.e-alldaycells,td.e-workcells:not('.e-resourceheadercells'),td.e-monthcells:not('.e-othermonths'),td.e-agendacells", $.proxy(this._onCellMouseOver, this));
            this._on(this.element, "click", ".e-workcells,.e-alldaycells,.e-alldayappointment,.e-monthcells:not('.e-othermonths'),.e-agendacells", $.proxy(this._cellSelection, this));
            if (!this._mediaQuery && !ej.isTouchDevice()) {
                this._on(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells:not('.e-othermonths'),td.e-alldaycells", $.proxy(this._mouseButtonClick, this));
                this._on(this.element, "keydown click", "td.e-workcells,td.e-monthcells:not('.e-othermonths'),td.e-alldaycells", $.proxy(this._shiftSelection, this));
            }
            this._on(this.element, (ej.isMobile()) ? "click" : (ej.isTouchDevice() && ($.isFunction($.fn.tap) || $.isFunction($.fn.doubletap))) ? "doubletap" : "dblclick", ".e-workcells:not('.e-resourceheadercells'),.e-alldaycells,.e-inline,.e-alldayappointment,.e-monthcells:not('.e-othermonths'),.e-agendacells.e-eventcolumn,.e-agendacells.e-timecolumn", $.proxy(this._appointmentWindow, this));
            (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            (ej.isTouchDevice()) && this._on(this.element, ($.isFunction($.fn.tap)) ? "tap" : "doubletap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            this._on(this.element, "mouseover", ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment", $.proxy(this._onAppointMouseOver, this));
            this._on(this.element, "mouseout", ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment", $.proxy(this._onAppointMouseOver, this));
            this._on(this.element, "click", ".e-appup,.e-appdown", $.proxy(this._renderAppPosition, this));
            (this._mediaQuery || this.element.width() < 600) && this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
            if (this.model.allowKeyboardNavigation) {
                this._on(this.element, "keydown", $.proxy(this._onKeyDown, this));
                this._on($(this.element), "keydown", $.proxy(this._documentOnKeyDown, this));
            }
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")
                this._on(this.element, "click", ".e-parentnodecategory", $.proxy(this._onResourceClick, this));
            if (this._mediaQuery || ej.isTouchDevice())
                this._on(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab", $.proxy(this._touchSchedule, this));
            if (this.model.enableResize)
                !ej.isTouchDevice() ? this._on($(window), "resize", $.proxy(this._onScheduleResize, this)) : this._on($(window), "orientationchange", $.proxy(this._onScheduleResize, this));
            this._on(this.element, "click", ".e-schedulemouseclose,.e-deleteapp", $.proxy(this._deleteAppoint, this));
            this._on(this.element, "click", ".e-editapp", $.proxy(this._appointmentWindow, this));
        },

        _drawerOpen: function () {
            this._scheduleDrawer.ejNavigationDrawer("open");
        },

        _mouseButtonClick: function (e) {
            if (!(e.altKey) && !(e.shiftKey) && !(e.ctrlKey) && (e.which != 3)) {
                if ((e.which == 1 || e.type == "touchstart") && !$(e.target).hasClass("e-resourceheadercells") && !$(e.target).hasClass("e-othermonths")) {
                    var oEl = e.target || document.activeElement || e.srcElement;
                    var oRowCell = this.element.find('div.e-draggableworkarea tr'), proxy = this;
                    ($(oEl).hasClass("e-alldaycells")) && (oRowCell = this.element.find(".e-alldaycells").parent());
                    if ($(oEl).hasClass("e-selectedAppointment")) {
                        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    this._currentRowIndex = $(oEl).parent()[0].rowIndex;
                    this._currentColIndex = $(oEl)[0].cellIndex;
                    var renderDate = ((proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal") && proxy.currentView() == "month") ? proxy.monthDays : (proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") ? proxy.dateRender : proxy._dateRender;
                    var cellindexs = $(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                    ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (cellindexs = proxy.currentView() !== "month" ? Math.floor(cellindexs / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : cellindexs));
                    var curDates = new Date(renderDate[cellindexs]);
                    if ((curDates >= this.model.minDate) && (curDates <= this.model.maxDate)) {
                        if ($(oEl).hasClass('e-workcells') || $(oEl).hasClass('e-monthcells') || $(oEl).hasClass('e-alldaycells')) {
                            oRowCell.on(ej.eventType.mouseMove, function (e) {
                                if (!ej.isNullOrUndefined(proxy._quickAppointWindow) && proxy.model.showQuickWindow) {
                                    proxy._quickAppointWindow.ejDialog("close");
                                    proxy._quickAppDetailsWindow.ejDialog("close");
                                }
                                e.preventDefault();
                                var currTarget = e.target;
                                if (e.type == 'touchmove') {
                                    var coor = e.originalEvent.changedTouches[0];
                                    currTarget = document.elementFromPoint(coor.pageX, coor.pageY);
                                }
                                $(currTarget).hasClass('e-selectedCell') && proxy.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                                proxy._mouseSelection(e, proxy, oEl, currTarget);
                                proxy._moveScrollContent(oEl, proxy);
                            });
                            oRowCell.on(ej.eventType.mouseUp, function (e) {
                                oRowCell.off(ej.eventType.mouseMove);
                            });
                            this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
                            this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        }
                    }
                }
            }
        },
        _mouseSelection: function (e, proxy, oE1, currTarget) {
            var oRowCell = proxy.element.find('div.e-draggableworkarea tr');
            var sourceRowIndex = $(oE1).parent().index();
            var sourceColumnIndex = $(oE1).index();
            var rowcount = oRowCell.length - 1;
            var i, j, k;
            var currentRowIndex = $(currTarget).parent().index();
            var currentColumnIndex = $(currTarget).index();
            var ad = proxy.element.find(".e-alldaycells").parent();
            var alldaytr = proxy.model.showAllDayRow;
            if (this._resWorkWeek) {
                var resmincolindex = 0;
                for (var z = 0; z < this.res1.length; z++) {
                    var resCusDays = !ej.isNullOrUndefined(this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]) ? this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length : this.model.workWeek.length;
                    if (currentColumnIndex <= (resmincolindex + (resCusDays - 1))) {
                        var resmaxcolindex = resmincolindex + resCusDays;
                        break;
                    }
                    else
                        resmincolindex += this.res1[z][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                }
            }
            else if (this._resCustomView) {
                var resmincolindex = 0;
                for (var z = 0; z < this.res1.length; z++) {
                    var resCustomSetting = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                    var resCusDates = this._getCustomDatesCount(z, resCustomSetting);
                    if (currentColumnIndex <= (resmincolindex + (resCusDates - 1))) {
                        var resmaxcolindex = resmincolindex + resCusDates;
                        break;
                    }
                    else
                        resmincolindex += this._getCustomDatesCount(z, resCustomSetting);
                }
            }
            else {
                var viewCount = (proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal") ? oRowCell[0].cells.length : ((proxy.currentView() == "month" || proxy._isCustomMonthView()) ? (oRowCell[0].cells.length / proxy.res1.length) : proxy._dateRender.length);
                var resIndex = Math.floor($(currTarget).index() / viewCount);
                var resmaxcolindex = (viewCount * (resIndex + 1));
                var resmincolindex = (viewCount * resIndex);
            }
            this.model.allowInline && (this.element.find(".e-inlinetext").length > 0 && this.element.find(".e-inlinetext").val() != "") ? this._saveAppointment() : (this._inlineRemove() && this._refreshDayAppointments(this._app));
            if ($(currTarget).hasClass('e-workcells')) {
                if (proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") {
                    if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                        if (sourceColumnIndex == currentColumnIndex) {
                            if (currentRowIndex > sourceRowIndex) {
                                for (var k = parseInt(sourceRowIndex) ; k <= currentRowIndex; k++)
                                    $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            }
                            else if (currentRowIndex < sourceRowIndex) {
                                for (var k = parseInt(sourceRowIndex) ; k >= currentRowIndex; k--)
                                    $(oRowCell[k].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            }
                            else
                                $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex > sourceColumnIndex) {
                            var difference = currentColumnIndex - sourceColumnIndex;
                            for (var i = parseInt(sourceRowIndex) ; i <= rowcount; i++)
                                $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[sourceColumnIndex]]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[currentColumnIndex]]).addClass("e-selectedCell");
                            if (difference > 1) {
                                for (var k = 1; k <= difference - 1; k++) {
                                    for (var m = 0; m <= rowcount; m++)
                                        $(oRowCell[m].cells[currentColumnIndex - k]).addClass("e-selectedCell");
                                    alldaytr && $(ad[0].cells[[currentColumnIndex - k]]).addClass("e-selectedCell");
                                }
                            }
                            for (var j = 0; j <= currentRowIndex; j++)
                                $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex < sourceColumnIndex) {
                            var difference = sourceColumnIndex - currentColumnIndex;
                            for (var i = parseInt(sourceRowIndex) ; i >= 0 ; i--)
                                $(oRowCell[i].cells[sourceColumnIndex]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[sourceColumnIndex]]).addClass("e-selectedCell");
                            alldaytr && $(ad[0].cells[[currentColumnIndex]]).addClass("e-selectedCell");
                            if (difference > 1) {
                                for (var k = 1; k <= difference - 1; k++) {
                                    for (var m = 0; m <= rowcount; m++)
                                        $(oRowCell[m].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                    alldaytr && $(ad[0].cells[[currentColumnIndex + k]]).addClass("e-selectedCell");
                                }
                            }
                            for (var j = parseInt(currentRowIndex) ; j <= rowcount; j++)
                                $(oRowCell[j].cells[currentColumnIndex]).addClass("e-selectedCell");
                        }
                        proxy._currentRowIndex = currentRowIndex;
                        proxy._currentColIndex = currentColumnIndex;
                        $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else { return false; }
                }
                else {
                    if (sourceRowIndex == currentRowIndex && sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                        if (currentColumnIndex > sourceColumnIndex) {
                            for (var j = sourceColumnIndex ; j <= currentColumnIndex; j++)
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else if (currentColumnIndex <= sourceColumnIndex) {
                            for (var j = sourceColumnIndex ; j >= currentColumnIndex; j--)
                                $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    else { return false; }
                }
            }
            else if ($(currTarget).hasClass('e-alldaycells')) {
                if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                    if (currentColumnIndex < sourceColumnIndex) {
                        for (var k = sourceColumnIndex; k >= currentColumnIndex; k--)
                            $(ad[0].cells[k]).addClass("e-selectedCell");
                    }
                    else if (currentColumnIndex > sourceColumnIndex) {
                        for (var k = sourceColumnIndex; k <= currentColumnIndex; k++)
                            $(ad[0].cells[k]).addClass("e-selectedCell");
                    }
                    proxy._currentRowIndex = 0;
                    proxy._currentColIndex = currentColumnIndex;
                    $(ad[0].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else { return false; }
            }
            else if ($(currTarget).hasClass('e-monthcells')) {
                if ($(currTarget).hasClass('e-othermonths')) return false;
                if (sourceColumnIndex >= parseInt(resmincolindex) && sourceColumnIndex <= parseInt(resmaxcolindex) - 1 && currentColumnIndex != "undefined") {
                    if (currentRowIndex == sourceRowIndex) {
                        if (currentColumnIndex < sourceColumnIndex) {
                            for (var k = sourceColumnIndex; k >= currentColumnIndex; k--)
                                $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex > sourceColumnIndex) {
                            for (var k = sourceColumnIndex; k <= currentColumnIndex; k++)
                                $(oRowCell[currentRowIndex].cells[k]).addClass("e-selectedCell");
                        }
                        else if (currentColumnIndex == sourceColumnIndex)
                            $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell");
                    }
                    else if (currentRowIndex > sourceRowIndex) {
                        var difference = (currentRowIndex - sourceRowIndex);
                        for (var i = sourceColumnIndex; i < resmaxcolindex; i++)
                            $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                        if (difference > 1) {
                            for (var k = 1; k <= difference - 1; k++) {
                                for (var i = resmincolindex ; i < resmaxcolindex; i++)
                                    $(oRowCell[sourceRowIndex + k].cells[i]).addClass("e-selectedCell");
                            }
                        }
                        for (var j = resmincolindex; j <= currentColumnIndex; j++)
                            $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                    }
                    else if (currentRowIndex < sourceRowIndex) {
                        var difference = (sourceRowIndex - currentRowIndex);
                        for (var i = sourceColumnIndex; i >= resmincolindex; i--)
                            $(oRowCell[sourceRowIndex].cells[i]).addClass("e-selectedCell");
                        if (difference > 1) {
                            for (var k = 1; k <= difference - 1; k++) {
                                for (var i = resmincolindex; i < resmaxcolindex; i++)
                                    $(oRowCell[sourceRowIndex - k].cells[i]).addClass("e-selectedCell");
                            }
                        }
                        for (var j = resmaxcolindex - 1; j >= currentColumnIndex; j--)
                            $(oRowCell[currentRowIndex].cells[j]).addClass("e-selectedCell");
                    }
                    proxy._currentRowIndex = currentRowIndex;
                    proxy._currentColIndex = currentColumnIndex;
                    $(oRowCell[currentRowIndex].cells[currentColumnIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else { return false; }
            }
        },
        _shiftSelection: function (e) {
            if (e.shiftKey == true && e.which == 1 && !$(e.target).hasClass("e-resourceheadercells")) {
                var oE1 = this._focused, proxy = this, currTarget = e.target;
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                this.element.find("e.workcells,e.alldaycells,.e-monthcells").removeClass("e-mousehover");
                this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.dateRender : this._dateRender;
                var cellindex = ($(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-alldaycells")) ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (cellindex = this.currentView() !== "month" ? Math.floor(cellindex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : cellindex));
                var curDate = new Date(renderDate[cellindex]);
                if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate))
                    this._mouseSelection(e, proxy, oE1, currTarget);
            }
        },
        _moveScrollContent: function (oEl, proxy) {
            if (proxy.model.orientation === "horizontal" || proxy._customOrientation === "horizontal") {
                var leftValue = proxy.element.find(".e-draggableworkarea").scrollLeft();
                if (proxy.model.enableRTL) {
                    if (proxy._browserInfo.name == "mozilla")
                        leftValue = leftValue > 0 ? leftValue : (leftValue * -1);
                    else if (proxy._browserInfo.name == "chrome" || proxy._browserInfo.name == "webkit")
                        leftValue = proxy.element.find(".e-workcells")[0].offsetLeft + proxy.element.find(".e-workcells").width() - proxy.element.find(".e-draggableworkarea").scrollLeft() - proxy.element.find(".e-draggableworkarea").width();
                    else
                        leftValue = Math.abs(leftValue);
                }
                else
                    leftValue = (-leftValue);
                proxy.currentView() != "month" ? $(proxy.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", leftValue + "px") : proxy.element.find(".e-headerdays").css("left", leftValue + "px");
                if (proxy.currentView() !== "day" && proxy.currentView() !== "month" && !(proxy.currentView() == "customview" && proxy._dateRender.length > 7) && proxy.model.timeScale.enable) {
                    var currentDateIndex = $(proxy.element.find(".e-headercells").find(".e-activeview").parent()).index();
                    var index = Math.floor((Math.abs(leftValue) / (proxy.element.find(".e-workcells").outerWidth())) / ((proxy.model.endHour - proxy.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    if (currentDateIndex !== index)
                        proxy.element.find(".e-headercells").children().removeClass("e-activeview");
                    $(proxy.element.find(".e-headercells")[index]).children().addClass("e-activeview");
                }
            }
            else
                if (!$(oEl).hasClass("e-monthcells"))
                    proxy.element.find(".e-scrolltimecells").css("top", (-proxy.element.find('.e-draggableworkarea').scrollTop()) + "px");
        },

        _onScheduleMouseDown: function (e) {
            var _targ = $(e.target);
            var appointdiv = _targ.hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? _targ : _targ.parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if (!_targ.hasClass("e-workcells") && !_targ.hasClass("e-inlinetext") && !_targ.hasClass("e-commonviewbutton") && !appointdiv.hasClass("e-appointment") && !appointdiv.hasClass("e-alldayappointment") && !appointdiv.hasClass("e-monthappointment") && !_targ.hasClass("e-alldaycells") && !_targ.hasClass("e-monthcells") && !(_targ).parents(".e-scheduledialog").hasClass("e-scheduledialog")) {
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                if (this.model.allowInline && !ej.isNullOrUndefined(this._inlineText) && (!_targ.hasClass("e-inlineedit") && this.currentView() != "agenda")) {
                    if (this.element.find('.e-inlinetext').length > 0 && this.element.find('.e-inlinetext').val() == "") {
                        if (!ej.isNullOrUndefined(this._inlineDate))
                            this._refreshDayAppointments(this._app);
                        this._inlineRemove();
                    }
                    else this._saveAppointment();
                }
                this.element.find(".e-workcells").removeClass("e-mousehover");
                (_targ.closest("#" + this._id).length > 0) && this._scrollerPosition();
            }
        },

        _onCellMouseOver: function (e) {
            if ($(e.target).closest(".e-appointment,.e-blocktimeappointment,.e-alldayappointment,.e-monthappointment,.e-inline").length > 0 || $(e.target).parents('.e-inline').length > 0) return false;
            if (this.currentView() == "agenda") {
                if (this._mediaQuery == true) return false;
                var element = $(e.currentTarget);
                if (e.type === "mouseover") {
                    this.element.find(".e-mousehover").removeClass("e-mousehover");
                    if (element.hasClass("e-agendacells")) {
                        element.parent().find(".e-timecolumn,.e-eventcolumn").addClass("e-mousehover");
                        element.parent().find(".e-editapp").parent().show();
                    }
                }
                else if (e.type === "mouseout") {
                    if (element.hasClass("e-agendacells")) {
                        element.parent().find(".e-timecolumn,.e-eventcolumn").removeClass("e-mousehover");
                        element.parent().find(".e-editapp").parent().hide();
                    }
                }
            }
            else {
                var element = $(e.currentTarget);
                var index = $(e.target).hasClass("e-workcells") ? $(e.target).index() : $(e.target).hasClass("e-alldaycells") ? $(e.target).index() : 7 - ((parseInt($(e.target).index() / 7) + 1) * 7 - $(e.target).index()) + ($(e.target).parent().index() * 7);
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                    index = this.currentView() !== "month" ? Math.floor(index / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : index;
                }
                var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.dateRender : this._dateRender;
                var curDate = new Date(renderDate[index]);
                this._slotByElement($(e.target), "cellHover");
                var event = { cellIndex: index, startTime: new Date(this.cellHoverStartTime), endTime: new Date(this.cellHoverEndTime), target: e, resources: (!ej.isNullOrUndefined(this.model.cellHover) && (this._tempResource.length != 0)) ? this._getResourceValue(element, index) : null };
                if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
                    if (e.type === "mouseover") {
                        if (this._trigger("cellHover", event)) return false;
                        this.element.find(".e-mousehover").removeClass("e-mousehover");
                        if ((element.hasClass("e-workcells") || element.hasClass("e-monthcells")) && !element.hasClass("e-resourceheadercells"))
                            element.addClass("e-mousehover");
                    }
                    else if (e.type === "mouseout") {
                        if (element.hasClass("e-workcells") || element.hasClass("e-monthcells"))
                            element.removeClass("e-mousehover");
                    }
                } else
                    return false;
            }
        },

        _getAppDetails: function (e) {
            var _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment");
            if (this.currentView() == "agenda" && _target.hasClass("e-eventcolumn"))
                appoint = _target.find(".e-agendaappointment");
            var appId = appoint.attr("data-guid");
            if (ej.isNullOrUndefined(appId)) return false;
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId));
            if (!tempApp[0][this._appointmentSettings["recurrence"]]) {
                var applist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId))[0];
            }
            else {
                var templist = $.extend(true, [], tempApp);
                templist[0][this._appointmentSettings["endTime"]] = templist[templist.length - 1][this._appointmentSettings["endTime"]];
                var applist = (tempApp[0][this._appointmentSettings["recurrence"]] && (tempApp[0][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") == 1)) ? this._getAppointmentByParentId(appId) : templist[0];
            }
            return applist;
        },

        _onAppointMouseOver: function (e) {
            if (!this.model.readOnly) {
                if (!ej.isNullOrUndefined(this.model.appointmentHover) && e.type == "mouseover") {
                    var data = { appointment: this._getAppDetails(e) };
                    if (this._trigger("appointmentHover", data))
                        return false;
                }
                if (this.currentView() == "agenda") {
                    if (this._mediaQuery == true) return false;
                    var element = $(e.currentTarget);
                    if (e.type === "mouseover") {
                        this.element.find(".e-mousehover").removeClass("e-mousehover");
                        if (element.hasClass("e-agendaappointment")) {
                            element.addClass("e-mousehover");
                            element.find(".e-editapp").parent().show();
                        }
                    }
                    else if (e.type === "mouseout") {
                        if (element.hasClass("e-agendaappointment")) {
                            element.removeClass("e-mousehover");
                            element.find(".e-editapp").parent().hide();
                        }
                    }
                }
                else {
                    var appointdiv = $(e.target).hasClass("e-appointment,e-alldayappointment,e-monthappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
                    if (appointdiv.hasClass("e-appointment") && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                        if (e.type === "mouseover" && appointdiv.find(".e-inlineedit").length <= 0) {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-bottomhandle,.e-tophandle").addClass("e-icon e-nsexpand");
                                appointdiv.find(".e-bottomhandle").addClass("e-appointresizer-bottom");
                                appointdiv.find(".e-tophandle").addClass("e-appointresizer-top");
                            }
                            (this.model.allowDelete) && appointdiv.find(".e-schedulemouseclose").css("display", "block");
                        }
                        else if (e.type === "mouseout") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-bottomhandle,.e-tophandle").removeClass("e-icon e-nsexpand");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "none");
                        }

                    }
                    else if (((appointdiv.hasClass("e-alldayappointment") || appointdiv.hasClass("e-monthappointment")) && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) || (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) {
                        if (e.type === "mouseover" && appointdiv.find(".e-inlineedit").length <= 0) {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-lefthandle,.e-righthandle").addClass("e-icon e-ewexpand");
                                appointdiv.find(".e-lefthandle").addClass("e-appointresizer-left");
                                appointdiv.find(".e-righthandle").addClass("e-appointresizer-right");
                            }
                            (this.model.allowDelete) && appointdiv.find(".e-schedulemouseclose").css("display", "block");
                        }
                        else if (e.type === "mouseout") {
                            if (this.model.enableAppointmentResize) {
                                appointdiv.find(".e-lefthandle,.e-righthandle").removeClass("e-icon e-ewexpand");
                            }
                            appointdiv.find(".e-schedulemouseclose").css("display", "none");
                        }
                    }
                }
            }
        },

        _quickWindowPosition: function (x, y, targetEle, quickWindow) {
            var quickWindowTable = quickWindow.find(".e-tableAppoint");
            var wrapperWidth = $("#" + quickWindow.prop("id") + "_wrapper").width();
            var left = this.element.offset().left, right = this.element.offset().left + this.element.width(), top = this.element.offset().top, bottom = this.element.offset().top + this.element.height();
            var widthDiff = targetEle.width() / 2;
            var transform = "rotate(0deg)", topposflag = true, leftpos = "40%";
            if (x > left && x + wrapperWidth > right && y > top) {
                x = right - wrapperWidth - 5;
                leftpos = targetEle.offset().left - x + widthDiff;
            }
            else if (x < left && x + wrapperWidth < right && y > top) {
                x = left + 5;
                leftpos = targetEle.offset().left - x + widthDiff;
            }
            else if (y < top) {
                topposflag = false, transform = "rotate(180deg)";
                if (x < left) {
                    x = left + 5;
                    leftpos = targetEle.offset().left - x + widthDiff;
                }
                else if ((x + wrapperWidth) > right) {
                    x = right - wrapperWidth - 5;
                    leftpos = targetEle.offset().left - x + widthDiff;
                }
                var heightDiff = (quickWindow.prop("id") == this._id + "AppDetailsWindow") ? targetEle.height() : ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") ? targetEle.height() / 2 : targetEle.height() - 4);
                y = targetEle.offset().top + 10 + heightDiff;
                if (y < top || y > bottom - $("#" + quickWindow.prop("id") + "_wrapper").height()) {
                    y = top + 4; topposflag = true, transform = "rotate(0deg)";
                }
            }
            topposflag ? quickWindowTable.removeClass("e-tablePosition") : quickWindowTable.addClass("e-tablePosition");
            quickWindow.find(".e-quickarrow").css("transform", transform).css("top", topposflag ? quickWindowTable.outerHeight() + 1 : 0).css("left", leftpos);
            topposflag ? quickWindow.addClass("e-quickwinarrowbottom").removeClass("e-quickwinarrowtop") : quickWindow.addClass("e-quickwinarrowtop").removeClass("e-quickwinarrowbottom");
            return { X: x, Y: y };
        },
          _getSetScrollPosition: function (args) {
            var _retainScrollerPosition = {};
            if (ej.isNullOrUndefined(args)) {
                var scrolObj = this.element.find("#" + this._id + "_scroller").data("ejScroller");
                _retainScrollerPosition["ScheduleScrollTop"] = scrolObj.scrollTop();
                _retainScrollerPosition["ScheduleScrollLeft"] = scrolObj.scrollLeft();
            }
            else {
                this._retainScrollerPosition["ScheduleScrollTop"] = args["ScheduleScrollTop"];
                this._retainScrollerPosition["ScheduleScrollLeft"] = args["ScheduleScrollLeft"];
            }
            return _retainScrollerPosition;
        },
        retainCurrentScrollPosition: function () {
            var scrolObj = this.element.find("#" + this._id + "_scroller").ejScroller("instance");
            if (scrolObj.isVScroll()) {
                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: this._retainScrollerPosition["ScheduleScrollTop"] });
            }
            if (scrolObj.isHScroll()) {
                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: this._retainScrollerPosition["ScheduleScrollLeft"] });
            }
            this._retainScrollerPosition = {};
        },

        _scrollerPosition: function () {
            if (this.currentView() != "agenda" && this.model.timeScale.enable && (this.element.find(".e-vscroll").length > 0 || this.element.find(".e-hscroll").length > 0)) {
                var scrolObj = this.element.find("#" + this._id + "_scroller").ejScroller("instance");
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    if (scrolObj.isVScroll()) {
                        var scrollValue = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                        this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollValue });
                    }
                    if (scrolObj.isHScroll()) {
                        var scrollValue = this.element.find(".e-draggableworkarea").offset().left - this.element.find(".e-workcellstab").offset().left;
                        this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: Math.abs(scrollValue) });
                    }
                }
                else {
                    if (this._grouping.length > 0) {
                        if (scrolObj.isVScroll()) {
                            if (this.element.find(".e-resourceheadertable").offset().top != this.element.find(".e-workcellstab").offset().top) {
                                var scrollValue = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                                this._isQuickDialogOpened = true;
                                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollValue });
                            }
                        }
                        if (scrolObj.isHScroll()) {
                            var leftValue = (this.currentView() == "month" || this._isCustomMonthView()) ? this.element.find(".e-headerdays").offset().left : this.element.find(".e-horizontaltabletimecell").closest("tr").offset().left;
                            if (this.element.find(".e-workcellstab").offset().left != leftValue) {
                                var scrollValue = this.element.find(".e-draggableworkarea").offset().left - this.element.find(".e-workcellstab").offset().left;
                                this._isQuickDialogOpened = true;
                                this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: Math.abs(scrollValue) });
                            }
                        }
                    }
                }
            }
        },

        _cellSelection: function (e) {
            if (e.shiftKey || $(e.target).parents().hasClass("e-inline") || $(e.target).hasClass("e-inlineedit")) return false;
            if (this.model.allowInline) {
                if (this.element.find(".e-inlineedit").length > 0) {
                    this._saveAppointment();
                    e.target = this.element.find('div[data-guid=' + $(e.target).closest(".e-appointment,.e-monthappointment,.e-alldayappointment").attr("data-guid") + ']');
                }
                if (this.element.find(".e-inlinetext").length > 0) { this.element.find(".e-inlinetext").val() != "" && this._saveAppointment(); }
                this.element.find('.e-inlinewrapper').remove();
                this.element.find('.e-inline').remove();
                var app = $(e.target).closest(".e-appointment,.e-monthappointment,.e-alldayappointment");
                var apptext = app.find('.e-apptext').text() == " " ? false : true;
            }
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            this.element.find("e.workcells,e.alldaycells,.e-monthcells,.e-agendacells").removeClass("e-mousehover");
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            var _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            if (_target.hasClass("e-blocktimeappointment") || _target.closest(".e-blocktimeappointment").length > 0) return false;
            if (this.model.allowInline && (_target.hasClass("e-apptext") || _target.hasClass("e-agendaappointment") || !apptext)) {
                this._inlineEdit(_target);
            }
            if (this.currentView() != "agenda" && !_target.hasClass("e-schedulemouseclose") && (!ej.isNullOrUndefined(this.model.workCellsTemplateId) || !ej.isNullOrUndefined(this.model.allDayCellsTemplateId))) {
                _target = (_target.closest(".e-appointment,.e-monthappointment").length > 0) ? _target.closest(".e-appointment,.e-monthappointment") : (_target.hasClass("e-apptime") || _target.hasClass("e-apptext") || _target.hasClass("e-appointinnertext") || _target.hasClass("e-schedulemouseclose") || _target.hasClass("e-monthheader")) ? $(e.target) : _target.closest(".e-workcells, .e-alldaycells, .e-monthcells");
            }
            _target.hasClass("e-appointwrapper") || _target.hasClass("e-textwrapper") && (_target = $(_target).parent());
            if (!ej.isNullOrUndefined(e.type) && e.type == "beforeOpen") {
                var selectedCells = this.element.find("td.e-selectedCell");
                if ((selectedCells.length > 0) && !(_target.hasClass("e-selectedCell")))
                    this.element.find(".e-workcells,.e-alldaycells,.e-monthcells,.e-agendacells").removeClass("e-selectedCell");
            }
            else
                this.element.find(".e-workcells,.e-alldaycells,.e-monthcells,.e-agendacells").removeClass("e-selectedCell");
            if (this.model.showQuickWindow && ej.isNullOrUndefined(this._quickAppointWindow)) this._renderQuickWindow();
            if (this.currentView() != "agenda") {
                if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells")) && !_target.hasClass("e-resourceheadercells")) {
                    this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
                    this._slotByElement(_target, "cellClick");
                    if ((this.model.minDate > this.curDate || this.model.maxDate < this.curDate)) { return false; }
                    var _quickString = this._dayFullNames[new Date(this.curDate).getDay()] + ", " + ej.format(new Date(this.curDate), "M", this.model.locale) + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale);
                    var event = { cellIndex: this._cellIndex, startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e, resources: ((this.model.cellClick != null || !ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("cellClick") != -1)) && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null, quickString: _quickString };
                    if (this._trigger("cellClick", event)) return false;
					if(!this._mediaQuery)
                    _target.addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._scrollerPosition();
                    if (this.model.allowInline) {
                        if (this.element.find(".e-inlineedit").length > 0) this._saveAppointment();
                        if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && !ej.isNullOrUndefined(this._inlineDate) && this.currentView() != "month" && !this._isCustomMonthView())
                            this._refreshDayAppointments(this._app);
                        if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                            this._getResourceDetails(_target, this._cellIndex);
                        this._inlineAppointment(_target);
                    }
                    if (this.model.showQuickWindow && !this.model.allowInline) {
                        this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");
                        this._quickAppointWindow.find('.e-quickstartend').html(event.quickString);
                        var topElmt = $(e).hasClass("e-workcells") || $(e).hasClass("e-alldaycells") || $(e).hasClass("e-monthcells") ? $(e) : $(e.target);
                        (e.type != "beforeOpen" && !this.model.readOnly) ? this._quickAppointWindow.ejDialog("open") : "";
                        this._quickAppointWindow.find('.subject').val("");
                        var x = topElmt.offset().left - ((this._quickAppointWindow.width() - topElmt.width()) / 2) + 10;
                        var y = topElmt.offset().top - this._quickAppointWindow.outerHeight() + 4;
                        var xy = this._quickWindowPosition(x, y, topElmt, this._quickAppointWindow);
                        this._quickAppointWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                        if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                            this._getResourceDetails(_target, this._cellIndex);
                    }
                    this._focused = $(":focus");
                    this.model.showQuickWindow && this._quickAppointWindow.find('.subject').focus();
                    this._cellClick = true;
                    if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("CreateAppointmentTitle") });
                }
                else {
                    if ((!_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-appsoverflow") && !_target.hasClass("e-monthheader") && !_target.hasClass("e-categorybar") && !this.model.allowInline) || (this.model.allowInline && !_target.hasClass("e-apptext") && !_target.hasClass("e-apptime"))) {
                        if (!_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-appsoverflow") && !_target.hasClass("e-monthheader") && !_target.hasClass("e-categorybar")) {
                            this._cellClick = false;
                            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow)) this._quickAppDetailsWindow.find("" + "#" + this._id + "_quickAppDetailswindow").css("display", "block");
                            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._quickAppointWindow.ejDialog("close");
                            var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") ? _target : _target.closest(".e-appointment,.e-alldayappointment,.e-monthappointment");
                            this._appUid = appoint.attr("data-guid");
                            if (_target.hasClass("e-schedulemouseclose")) return false;
                            this._processed = this._sortAppById(this._processed);
                            var splitObj = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                            for (var i = 0; i < splitObj.length; i++) {
                                var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, splitObj[i]["Guid"]));
                                break;
                            }
                            if (ej.isNullOrUndefined(templist)) return;
                            for (var i = 0; i < templist.length; i++) {
                                var eleFind = this.element.find('div[data-guid=' + templist[i]["Guid"] + ']');
                                eleFind.addClass("e-selectedAppointment");
                            }
                            if (this._mediaQuery)
                                this._mAppId = this._appUid;
                            var templist1 = this._sortAppById(templist);
                            var temp = templist1[0][this._appointmentSettings["recurrence"]] ? templist1[0] : this._getAppointmentByParentId(this._appUid);
                            var diffTime = new Date().getTime() - (temp[this._appointmentSettings["startTime"]].getTime());
                            var diffMinute = 60 * 1000;
                            var diffHour = 60 * diffMinute;
                            var diffDays = 24 * diffHour;
                            var result = Math.abs(new Date() - temp[this._appointmentSettings["startTime"]]);
                            var h = Math.floor(result / 1000 / 60 / 60); h = (h <= 9 ? '0' + h : h);
                            var m = new Date(result).getUTCMinutes(); m = (m <= 9 ? '0' + m : m);
                            var dueIn = Math.ceil(diffTime / diffMinute - 1) < 0 && h < 24 ? this._getLocalizedLabels("EventBeginsin") + " " + h + " " + this._getLocalizedLabels("Hours") + " " + m + " " + this._getLocalizedLabels("Minutes") : Math.ceil(diffTime / diffMinute - 1) < 0 && h >= 24 ? this._getLocalizedLabels("EventBeginsin") + " " + Math.abs(Math.ceil(diffTime / diffDays)) + " " + this._getLocalizedLabels("Days") : this._getLocalizedLabels("Overdue");
                            var appObject = (templist.length > 1) ? this._recurrenceAppSort(templist) : templist;
                            var data = { appointment: appObject[0] };
                            if (ej.isNullOrUndefined(e.events)) {
                                if (this._trigger("appointmentClick", data)) {
                                    this.element.find(".e-selectedAppointment").css({ 'border': "none" });
                                    return false;
                                }
                            }
                            if (this.model.showQuickWindow) {
                                this._quickAppDetailsWindow && this._quickAppDetailsWindow.find('.e-quicksubject').html(temp[this._appointmentSettings["subject"]]).attr("title", temp[this._appointmentSettings["subject"]]);
                                var startTimeDisp = this._timeMode == "12" ? ej.format(templist[0][this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(templist[0][this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                                var endTimeDisp = this._timeMode == "12" ? ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                                this._quickAppDetailsWindow.find('.e-rightfields').html(dueIn);
                                var days = Math.ceil((templist[0][this._appointmentSettings["endTime"]] - templist[0][this._appointmentSettings["startTime"]]) / 3600000) / 24;
                                if ((templist.length > 1) || ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month" && days > 1) || (templist[0][this._appointmentSettings["startTime"]].getDay() != templist[templist.length - 1][this._appointmentSettings["endTime"]].getDay()))
                                    var dateShow = this._dayFullNames[templist[0][this._appointmentSettings["startTime"]].getDay()] + ", " + ej.format(templist[0][this._appointmentSettings["startTime"]], "M", this.model.locale) + " - " + startTimeDisp + " " + "to" + " " + this._dayFullNames[templist[templist.length - 1][this._appointmentSettings["endTime"]].getDay()] + ", " + ej.format(templist[templist.length - 1][this._appointmentSettings["endTime"]], "M", this.model.locale) + " - " + endTimeDisp;
							    else
                                    var dateShow = this._dayFullNames[templist[0][this._appointmentSettings["startTime"]].getDay()] + ", " + ej.format(templist[0][this._appointmentSettings["startTime"]], "M", this.model.locale) + ", " + startTimeDisp + " " + "-" + " " + endTimeDisp;
                                this._quickAppDetailsWindow.find('.e-quickstartendtime').html(dateShow);
                                if (temp[this._appointmentSettings["recurrence"]] == 1)
                                    this._quickAppDetailsWindow.find('.e-editseries,.e-editfutureonly').removeClass("e-disable");
                                else
                                    this._quickAppDetailsWindow.find('.e-editseries,.e-editfutureonly').addClass("e-disable");
                                (e.type != "beforeOpen") ? this._quickAppDetailsWindow.ejDialog("open") : "";
                                (this.model.readOnly) ? this._quickAppDetailsWindow.find(".e-scheduledelete").addClass("e-disable") : this._quickAppDetailsWindow.find(".e-scheduledelete").removeClass("e-disable");
                                (!this.model.allowDelete) && this._quickAppDetailsWindow.find(".e-scheduledelete").addClass("e-disable");
                                if ($(appoint).width() > this.element.width())
                                    var left = ($(appoint).offset().left > this.element.offset().left) ? $(appoint).offset().left : (this.element.find('.e-draggableworkarea').scrollLeft() > $(appoint).width()) ? this.element.offset().left : this.element.width() / 2 - 4;
                                else
                                    var left = $(appoint).offset().left - ((this._quickAppDetailsWindow.width() - $(appoint).width()) / 2 - 4);
                                var top = $(appoint).offset().top - this._quickAppDetailsWindow.outerHeight() + 4;
                                var xy = this._quickWindowPosition(left, top, appoint, this._quickAppDetailsWindow);
                                this._quickAppDetailsWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                                this._quickAppDetailsWindow.focus();
                            }
                            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog({ title: this._getLocalizedLabels("Editevent") });
                        }
                    }
                }
                if (!$(_target).hasClass("e-monthcells"))
                    this.element.find(".e-scrolltimecells").css("top", (-this.element.find('.e-draggableworkarea').scrollTop()) + "px");
            } else {
                this._cellIndex = 0;
                this.cur_StartTime = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
                this.cur_EndTime = new Date(new Date(this.currentDate()).setHours(23, 59, 59));
                $(_target).parentsUntil('.e-agendacellstab tbody').find(".e-eventcolumn,.e-timecolumn").addClass("e-selectedCell").attr("tabIndex", 0).focus();
                var appoint = _target.hasClass("e-agendaappointment") ? _target : this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                this._appUid = appoint.attr("data-guid");
                if (this._mediaQuery)
                    this._mAppId = this._appUid;
                if (_target.hasClass("e-editapp") || _target.hasClass("e-deleteapp")) return false;
                var appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                if (this._trigger("appointmentClick", { appointment: appoint[0] })) {
                    return false;
                }
                this._cellClick = false;
            }
        },

        _inlineAppointment: function (_target) {
            var obj = {}, app = [], id = (this._processed.length > 0) ? Math.max.apply(Math, this._processed.map(function (obj) { return obj.AppTaskId; })) + 1 : 1;
            this._inline = true;
            this._inlineDate = new Date(this.cur_StartTime);
            obj[this._appointmentSettings["startTime"]] = new Date(this._inlineDate);
            obj[this._appointmentSettings["endTime"]] = this.cur_EndTime;
            obj[this._appointmentSettings["id"]] = obj["inline"] = this._maxId = id;
            var isBigApp = (((obj[this._appointmentSettings["endTime"]] - obj[this._appointmentSettings["startTime"]]) / 3600000) >= 24);
            if ((!ej.isNullOrUndefined(this.model.group) || (this._tempResource.length != 0) && ej.scheduleFeatures.resources) && ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0))
                obj = this._getResourceFields(obj);
            var app = this._app = obj;
            this._appointmentProcessing(app);
            var filterApps = this._processed.filter(function (obj) { return obj.ParentId == app.ParentId; });
            if (filterApps.length > 0) {
                for (var ix = 0, len = filterApps.length; ix < len; ix++) {
                    var isAllDay = this._findAllDayApp(filterApps[ix]),
                    strDate = filterApps[ix][this._appointmentSettings["startTime"]],
                    index = (this.currentView() == "day" && (new Date(new Date(this._dateRender[0]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(filterApps[ix][this.model.appointmentSettings["startTime"]]).setHours(0, 0, 0)).getTime())) ? 0 : ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? $.inArray(new Date(strDate.getFullYear(), strDate.getMonth(), strDate.getDate()).getTime(), this.monthDays) : this.currentView() == "day" ? -1 : $.inArray(new Date(strDate.getFullYear(), strDate.getMonth(), strDate.getDate()).getTime(), this._dateRender),
                    resIndex = (this._tempResource.length > 0 && this._grouping.length > 0 && ej.scheduleFeatures.resources) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], filterApps[ix][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]]) : 0;
                    if (this._resWorkWeek) {
                        var date = new Date(filterApps[ix][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0);
                        day = this._resourceWorkWeek(resIndex, date);
                    }
                    if (this._resCustomView) {
                        var date = new Date(filterApps[ix][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0);
                        day = this._resourceCustomView(resIndex, date);
                    }
                    index = (this._resWorkWeek || this._resCustomView) ? day : index;
                    if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() !== "month") {
                        this._refreshDayAppointments(filterApps[ix]);
                    }
                    else 
                        (this.model.timeScale.enable && this.currentView() !== "month" && !this._isCustomMonthView()) ? ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && index >= 0 && (filterApps[ix][this._appointmentSettings["allDay"]] || Math.round((filterApps[ix][this._appointmentSettings["endTime"]].getTime() - filterApps[ix][this._appointmentSettings["startTime"]].getTime()) / 3600000) >= 24 || isAllDay)) ? this._setAllDayPos(filterApps[ix], index, resIndex) : this._renderApp(filterApps[ix], index, resIndex) : this._renderAppointmentMonth(filterApps[ix], index, resIndex);
                    delete filterApps[ix]["Index"];
                }
            }
            ((!isBigApp) && (obj[this._appointmentSettings["endTime"]].getDate() != obj[this._appointmentSettings["startTime"]].getDate())) ? this.element.find(".e-inlinetext")[1].focus() : this.element.find(".e-inlinetext")[0].focus();
            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: filterApps }, "inline");
            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: filterApps }, "inline");
        },

        _inlineEdit: function (_target) {
            this._cellClick = false;
            !ej.isNullOrUndefined(this._quickAppDetailsWindow) && this._quickAppDetailsWindow.ejDialog("close");
            this._inline = true;
            var appoint = this.currentView() != "agenda" ? _target.closest('.e-appointment,.e-monthappointment,.e-alldayappointment') : _target;
            if (this.currentView() != "agenda")
                if (_target.children("span")) _target.children("span").css('display', 'none');
            _target.css("display", "none");
            this._appUid = appoint.attr("data-guid");
            this._subject = this.currentView() != "agenda" ? appoint.find('.e-apptext').text() : appoint.text();
            this._inlineText = ej.buildTag('input .e-inlineedit', "", {}, { type: "text", value: $.trim(this._subject), onfocus: "this.value = this.value;" })
            this.currentView() != "agenda" ? appoint.prepend(this._inlineText) : appoint.before(this._inlineText);
            this._inlineText.css({ 'background': 'transparent', 'border': '0px solid transparent' });
            this.element.find('.e-inlineedit').focus();
        },

        _inlineRemove: function () {
            this._inline = false;
            this.element.find('.e-inlinewrapper').remove();
            this.element.find('.e-inline').remove();
            this._inlineText = null;
            if (this.element.find(".e-inlineedit")) {
                if (this.currentView() == "agenda")
                    this._renderAgendaContent();
                else {
                    this.element.find(".e-inlineedit").remove();
                    this.element.find('.e-icon.e-recurapp').css('display', 'block');
                    this.element.find('.e-apptext').css('display', 'block');
                }
            }
        },

        _inlineTemplate: function (record, leftPosition, topPosition, appWidth, appHeight, colorAppointment, normal) {
            this._inlineText = $(this.inlineTemplate.render({
                id: record[this._appointmentSettings["id"]], rtl: this.model.enableRTL, subject: " ", left: normal ? leftPosition : leftPosition + 'px', top: topPosition, appWidth: normal ? appWidth : appWidth + 'px', appHeight: appHeight,
                appClass: "e-inline", appointData: colorAppointment.appointColor.appointData, appointtextcolor: colorAppointment.appointColor.appointtextcolor
            }));
        },

        _getDateByElement: function (_target) {
            var tagIndex = this.model.showWeekend ? 7 : this.model.workWeek.length;
            if (this.model.timeScale.enable)
                this._cellIndex = _target.hasClass("e-workcells") ? _target.index() : _target.hasClass("e-alldaycells") ? _target.index() : this._isCustomMonthView() && this._oneWeek ? _target.index() : tagIndex - ((parseInt(_target.index() / tagIndex) + 1) * tagIndex - _target.index()) + (_target.parent().index() * tagIndex);
            else
                this._cellIndex = (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month" || ((this.currentView() == "customview" && this._dateRender.length >= 7) && !this._resCustomView) ? tagIndex - ((parseInt(_target.index() / tagIndex) + 1) * tagIndex - _target.index()) + (_target.parent().index() * tagIndex) : _target.index();
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                var dayLength = this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length;
                this._cellIndex = (this.currentView() !== "month" && !(this._isCustomMonthView()) && dayLength < this._cellIndex) ? this._cellIndex - (this._cellIndex % dayLength) : this._cellIndex ;
                this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : this._cellIndex : _target.index();
                this._workCellIndex = _target.parent().index();
            }
            var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : ((this.model.orientation == "vertical" && this._customOrientation == "vertical") || this.currentView() == "customview" && this._dateRender.length <= 7) ? (this._resWorkWeek) ? this._dateRender : this.dateRender : this._dateRender;
            renderDate = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDate;
            this._cellIndex = (this._cellIndex == renderDate.length)? this._cellIndex - 1 : this._cellIndex;
            this.curDate = new Date(renderDate[this._cellIndex]);
        },

        _slotByElement: function (_target, type) {
            this._getDateByElement(_target);
            var curDate = this.curDate;
            if (_target.hasClass("e-workcells") && (this.model.timeScale.enable) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this._calcCurrentTime(curDate, _target, type);
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
            }
            else {
                if (type == "cellHover") {
                    this.cellHoverStartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                    this.cellHoverEndTime = new Date(new Date(curDate).setHours(23, 59, 59));
                }
                else {
                    this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                    this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59, 59));
                    if (_target.hasClass("e-alldaycells")) {
                        if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                        this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    }
                }
            }
        },
        _calcCurrentTime: function (curDate, _target, type) {
            var time, cellDuration = this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount;
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                time = (this.model.startHour * 60) + _target.parent().index() * (cellDuration);
                time = time * 60 * 1000 ;
            } else {
                var dayLength = this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length;
                var currentIndex = Math.floor(_target.index() / dayLength);
                var targetIndex = Math.abs(dayLength - _target.index());
                targetIndex = targetIndex % dayLength;
                var targetTime =(cellDuration * targetIndex) + (this.model.startHour * 60);
                time = ((this.model.startHour * 60) + _target.index() * (cellDuration)) -
                (((this.model.endHour - this.model.startHour) * (this.model.timeScale.minorSlotCount)) * this._cellIndex) *
                (60 / this.model.timeScale.majorSlot) * (cellDuration);
                time = (currentIndex != 0) ? targetTime * 60 * 1000 : time * 60 * 1000  ;
            } 
            this._timeScaleMin = cellDuration;
            this._timeScaleMin = this._timeScaleMin * 60 * 1000;
            if (type == "cellHover") {
                this.cellHoverStartTime = new Date(curDate).setMilliseconds(time);
                var min = (parseInt(new Date(this.cellHoverStartTime).getHours()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getHours() && parseInt(new Date(this.cellHoverStartTime).getMinutes()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getMinutes()) ? time + (this._timeScaleMin - 1) : new Date(this.cellHoverStartTime).getMilliseconds() + this._timeScaleMin;
                this.cellHoverEndTime = new Date(new Date(this.cellHoverStartTime).setMilliseconds(min));
                this.cellHoverEndTime = (new Date(this.cellHoverStartTime).setHours(0, 0, 0, 0) < new Date(this.cellHoverEndTime).setHours(0, 0, 0, 0)) ? new Date(new Date(this.cellHoverStartTime).setHours(23, 59, 59)) : this.cellHoverEndTime;
            }
            else {
                this.cur_StartTime = new Date(curDate).setMilliseconds(time);
                var min = (parseInt(new Date(this.cur_StartTime).getHours()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getHours() && parseInt(new Date(this.cur_StartTime).getMinutes()) == new Date(new Date(curDate).setMinutes((this._timeScaleMin * this.model.timeScale.minorSlotCount * (this.model.endHour - this.model.startHour)) - this.model.timeScale.minorSlotCount)).getMinutes()) ? time + (this._timeScaleMin - 1) : new Date(this.cur_StartTime).getMilliseconds() + this._timeScaleMin;
                this.cur_EndTime = new Date(new Date(this.cur_StartTime).setMilliseconds(min));
                this.cur_EndTime = (new Date(this.cur_StartTime).setHours(0, 0, 0, 0) < new Date(this.cur_EndTime).setHours(0, 0, 0, 0)) ? new Date(new Date(this.cur_StartTime).setHours(23, 59, 59)) : this.cur_EndTime;
            }
        },
        _checkReminders: function (args) {
            this._todayAppointments = [];
            for (var i = 0; i < this._processed.length; i++) {
                if ((new Date(new Date(this._processed[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date().setHours(0, 0, 0, 0)).getTime())) {
                    this._todayAppointments.push(this._processed[i]);
                }
            }
            var proxy = this;
            jQuery.each(this._todayAppointments, function (val, i) {
                if (!ej.isNullOrUndefined(proxy.model) && !ej.isNullOrUndefined(proxy.model.reminderSettings)) {
                    var reminderValue = proxy.model.reminderSettings.alertBefore;
                    var startTime = i[proxy._appointmentSettings["startTime"]];
                    if (reminderValue != -1 && reminderValue != null) {
                        var currTime = new Date().getTime();
                        var difference = (currTime - new Date(startTime).getTime()) / (1000 * 60);
                        if (Math.round(difference) == (reminderValue * -1))
                            proxy._trigger("reminder", { reminderAppointment: i });
                    }
                }
            });
        },

        _showContextMenu: function (flag) {
            var gotoFlag = false, categorizeFlag = false, cellCollection = this.model.contextMenuSettings.menuItems.cells;
            if (flag) {
                this._contextMenu = ej.buildTag("ul#" + this._id + "contextMenu");
                this.element.append(this._contextMenu);
                this._contextMenu.ejMenu({
                    fields: { id: "id", text: "text", parentId: "parentId" },
                    menuType: ej.MenuType.ContextMenu,
                    openOnClick: false,
                    contextMenuTarget: "#" + this._id,
                    width: "auto",
                    open: function (args) { this.element.width("auto"); },
                    click: $.proxy(this._onMenuSelect, this),
                    beforeOpen: $.proxy(this._beforeopen, this)
                });
                if (this.model.categorizeSettings.enable && this.model.contextMenuSettings.menuItems.appointment) {
                    var menuItems = this.model.contextMenuSettings.menuItems.appointment;
                    var dataLength = this.model.categorizeSettings.dataSource.length;
                    for (var i = 0; i < menuItems.length; i++) {
                        if (menuItems[i].id == 'categorize') {
                            var menuId = i;
                            categorizeFlag = true;
                            break;
                        }
                    }
                    if (categorizeFlag) {
                        var deletedItems = new ej.DataManager(this.model.contextMenuSettings.menuItems.appointment).executeLocal(new ej.Query().where("parentId", ej.FilterOperators.equal, "categorize"));
                        new ej.DataManager(this.model.contextMenuSettings.menuItems.appointment).saveChanges({ added: [], changed: [], deleted: deletedItems }, "parentId");
                        for (var i = 0; i < dataLength; i++) {
                            var dataSet = this.model.categorizeSettings;
                            this.model.contextMenuSettings.menuItems.appointment.push({ text: dataSet.dataSource[i][dataSet.text], id: "categorize_" + dataSet.dataSource[i][dataSet.id], fontColor: dataSet.dataSource[i][dataSet.fontColor], color: dataSet.dataSource[i][dataSet.color], parentId: this.model.contextMenuSettings.menuItems.appointment[menuId].id.toString() });
                        }
                    }
                }
                if (this._gotoDate) {
                    if (this.model.contextMenuSettings.enable) {
                        for (var id in cellCollection) {
                            if (cellCollection[id].id == "gotodate") {
                                gotoFlag = true;
                                break;
                            }
                        }
                        if (gotoFlag) {
                            this._renderGotoWindow();
                            this._gotoDate = false;
                        }
                    }
                }
            }
        },

        _beforeopen: function (args) {
            if (this.model.contextMenuSettings.enable) {
                $(document).off(ej.eventType.mouseMove);
                var targetClass = $(args.target).closest(".e-alldayappointment,.e-appointment,.e-monthappointment,.e-workcells,.e-monthcells,.e-alldaycells"), appFlag, appointment = null, event;
                var tempargs = ($(targetClass).parents(".e-draggableworkarea tr").length > 0 && $(targetClass).parentsUntil(".e-draggableworkarea tr").is(".e-agendaappointment,.e-eventcolumn,.e-timecolumn")) || $(targetClass).is(".e-agendaappointment,.e-eventcolumn,.e-timecolumn");
                if (!targetClass.hasClass("e-appointment") && !targetClass.hasClass("e-workcells") && !targetClass.hasClass("e-alldaycells") && !targetClass.hasClass("e-monthcells") && !ej.isNullOrUndefined(this.model.appointmentTemplateId)) {
                    targetClass = $(args.target).offsetParent();
                }
                args.cancel = (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointment") || targetClass.hasClass("e-workcells") || targetClass.hasClass("e-alldaycells") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-monthcells") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || tempargs) ? false : true;
                if (args.cancel == true) {
                    var obj = this._contextMenu.data("ejMenu");
                    obj.hide();
                    return false;
                }
                if (this.currentView() == "agenda" && tempargs) {
                    args = $(targetClass).hasClass("e-agendaappointment") ? args : $(targetClass).parents(".e-draggableworkarea tr").find(".e-agendaappointment");
                }
                this._cellSelection(args);
                if (targetClass.hasClass("e-workcells") || targetClass.hasClass("e-alldaycells") || targetClass.hasClass("e-monthcells")) {
                    event = { currentDate: this.curDate, cellIndex: this._cellIndex, events: args, resources: (!ej.isNullOrUndefined(this.model.beforeContextMenuOpen) && (this._tempResource.length != 0)) ? this._getResourceValue(targetClass, this._cellIndex) : null };
                }
                if (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || targetClass.hasClass("e-appointment")) {
                    appointment = this._getAppDetails(args);
                    event = { appointment: appointment, events: args };
                }
                if (this.currentView() == "agenda") {
                    appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    event = { appointment: appointment, events: args };
                }
                this._baseTarget = targetClass;
                if (this._trigger("beforeContextMenuOpen", event)) return false;
                var menuObj = this._contextMenu.data("ejMenu");
                appFlag = (targetClass.hasClass("e-alldayappointment") || targetClass.hasClass("e-monthappointment") || targetClass.hasClass("e-appointment") || targetClass.hasClass("e-appointinnertext") || targetClass.hasClass("e-apptime") || targetClass.hasClass("e-apptext") || tempargs) ? false : true;
                (appFlag) ? menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.cells) : menuObj.option("fields.dataSource", this.model.contextMenuSettings.menuItems.appointment);
                if (this.model.readOnly) {
                    menuObj.disableItemByID("new");
                    menuObj.disableItemByID("recurrence");
                    menuObj.disableItemByID("delete");
                    menuObj.disableItemByID("categorize");
                }
                else {
                    menuObj.enableItemByID("new");
                    menuObj.enableItemByID("recurrence");
                    (this.model.allowDelete) ? menuObj.enableItemByID("delete") : menuObj.disableItemByID("delete");
                    menuObj.enableItemByID("categorize");
                }
                var tds = this.element.find('td.e-selectedCell');
                if (tds.length > 1 && this.currentView() != "agenda")
                    this._multipleCellAppointCreation(args);
                this._target = args;
                if (this.model.showQuickWindow && !ej.isNullOrUndefined(this._quickAppointWindow)) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                if (this.model.categorizeSettings.enable && appFlag == false) {
                    var findDiv = this._contextMenu.find('li#categorize').find('li').children();
                    if (findDiv.find('div').length == 0) {
                        for (var i = 0; i < this.model.categorizeSettings.dataSource.length; i++) {
                            this._contextMenu.find('li#categorize').find('li#categorize_' + this.model.categorizeSettings.dataSource[i][this.model.categorizeSettings["id"]]).children().append('<div><div style="border: 1px solid black;height: 12px;margin-left: 2px;margin-top: 2px;width: 12px;background-color:' + this.model.categorizeSettings.dataSource[i][this.model.categorizeSettings["color"]] + '"></div></div>');
                        }
                    }
                    for (var i = 1; i <= this.model.categorizeSettings.dataSource.length; i++) {
                        if (this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child.e-categorizeMenuSelected'))
                            this._contextMenu.find('li#categorize').find('li#categorize_' + i).children().find('div:first-child').removeClass('e-categorizeMenuSelected');
                    }
                    var query = new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid);
                    var addItem = ej.DataManager(this._processed).executeLocal(query);
                    if (addItem[0][this._appointmentSettings["categorize"]]) {
                        var categorizeItems = addItem[0][this._appointmentSettings["categorize"]].split(',');
                        if (this.model.categorizeSettings.allowMultiple) {
                            if (categorizeItems[0].length > 0) {
                                for (var i = 0; i < categorizeItems.length; i++) {
                                    this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[i]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                                }
                            }
                        }
                        else {
                            if (categorizeItems[0].length > 0) {
                                var lastValue = categorizeItems.length - 1;
                                this._contextMenu.find('li#categorize').find('li#categorize_' + categorizeItems[lastValue]).children().find('div:first-child').addClass('e-categorizeMenuSelected');
                            }
                        }
                    }
                }
                else {
                    if (this._contextMenu.find('li#categorize'))
                        this._contextMenu.find('li#categorize').css("display", "none");
                }

            }
            else {
                var obj = this._contextMenu.data("ejMenu");
                obj.hide();
                return false;
            }
        },

        _onMenuSelect: function (args) {
            var id = args.events.ID.split("_"), parentData = "";
            var target = this._baseTarget;
            if ($(target).is(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment") || target.parents(".e-appointment").hasClass("e-appointment") || target.parents(".e-monthappointment").hasClass("e-monthappointment") || target.parents(".e-alldayappointment").hasClass("e-alldayappointment") || this.currentView() == "agenda" && this.element.find(".e-selectedCell").parent().find(".e-agendaappointment")) {
                var appointDetails = ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                parentData = (appointDetails[0][this._appointmentSettings["recurrence"]] == 1 && appointDetails[0][this._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1) ? appointDetails[0] : this._getAppointmentByParentId(this._appUid);
            }
            else {
                parentData = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, resourceInfo: this._getResourceDetails(target) };
            }
            if (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("menuItemClick") != -1))
                args = { ID: args.ID, type: args.type, text: args.text, parentId: args.parentId, parentText: args.parentText };
            if (this._trigger("menuItemClick", { events: args, targetInfo: parentData })) return false;
            var oldIdValue = parentData[this._appointmentSettings["categorize"]];
            switch (id[0]) {
                case "new":
                    this._appointmentWindow(this._target);
                    break;
                case "recurrence":
                    this._appointmentWindow(this._target);
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                    this._repeat(args = { isChecked: true, isInteraction: true });
                    break;
                case "open":
                    this._appointmentWindow(this._target);
                    break;
                case "today":
                    this._navigateClick(this.currentDate(new Date()), "DateNavigation");
                    break;
                case "view":
                    if (!ej.isNullOrUndefined(id[1])) {
                        var newView = id[1].toLowerCase();
                        this._navView = true;
                        (this.currentView() != newView) && this._viewChange(null, this.currentView(), newView);
                    }
                    break;
                case "timemode":
                    if (!ej.isNullOrUndefined(id[1])) {
                        this.model.timeMode = this._timeMode = (id[1] == "Hour12") ? "12" : "24";
                        this._updateTimeMode();
                        this.element.find(".e-scrolltimecells").height(this.element.find('.e-workcellstab').height());
                    }
                    break;
                case "businesshours":
                case "workhours":
                    this.model.workHours.highlight = (this.model.workHours.highlight) ? false : true;
                    (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells") && this.element.find(".e-monthcells").removeClass("e-monthcellhighlight");
                    break;
                case "gotodate":
                    this._gotoWindow.ejDialog("open");
                    break;
                case "delete":
                    this._deleteAppoint();
                    break;
                case "print":
                    this._printAppointment(this._appUid);
                    break;
                case "categorize":
                    if (ej.isNullOrUndefined(id[1]))
                        this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment").removeClass("e-selectedAppointment");
                    else {
                        if (this.model.categorizeSettings.enable) {
                            var getId = id[1]; var idValue = "";
                            if (parentData[this._appointmentSettings["categorize"]]) {
                                var categorizeItems = parentData[this._appointmentSettings["categorize"]].split(',');
                                if (!this.model.categorizeSettings.allowMultiple) {
                                    idValue = (categorizeItems[categorizeItems.length - 1] == getId) ? "" : getId.toString();
                                }
                                else {
                                    if (categorizeItems[0].length > 0) {
                                        for (var i = 0; i < categorizeItems.length; i++) {
                                            if (categorizeItems[i] == getId) {
                                                var findId = true;
                                                break;
                                            }
                                        }
                                        if (findId == true) {
                                            for (var i = 0; i < categorizeItems.length; i++) {
                                                if (categorizeItems[categorizeItems.length - 1] != getId) {
                                                    if (categorizeItems[i] != getId) idValue += (categorizeItems.length - 1 != i) ? categorizeItems[i] + "," : categorizeItems[i];
                                                }
                                                else {
                                                    if (categorizeItems[i] != getId) idValue += (categorizeItems.length - 2 != i) ? categorizeItems[i] + "," : categorizeItems[i];
                                                }
                                            }
                                        }
                                        else
                                            idValue = parentData[this._appointmentSettings["categorize"]] + "," + getId;
                                    }
                                }
                            }
                            else {
                                idValue = getId.toString();
                            }
                            parentData[this._appointmentSettings["categorize"]] = idValue;
                            if (!ej.isNullOrUndefined(id[1])) {
                                if (this._trigger("beforeAppointmentChange", { appointment: parentData })) {
                                    parentData[this._appointmentSettings["categorize"]] = oldIdValue;
                                    return false;
                                }
                            }
                            var proxy = this;
                            var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            var promise = this._dataManager.update(queryId, parentData, this.model.appointmentSettings.query._fromTable);
                            new ej.DataManager(this._currentAppointmentData).update("AppTaskId", parentData);
                            var isObjAvail = this._processed.filter(function (obj) { return obj[proxy._appointmentSettings["id"]] == parentData[proxy._appointmentSettings["id"]]; });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                            for (var ii = 0, len = isObjAvail.length; ii < len; ii++) {
                                this._appointmentRemove(isObjAvail[ii]);
                            }
                            this._appointmentProcessing(parentData);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == parentData.ParentId; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                            this._trigger("appointmentChanged", { appointment: parentData });
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                        proxy._processUrlBinding(e);
                                    }
                                });
                            }
                            break;
                        }
                    }
            }
        },

        _updateTimeMode: function () {
            var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
            var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
            var columnValueCount = this._timeSlotCount(userTemplateId, template);
            if (!ej.isNullOrUndefined(this._appointmentAddWindow))
                this._appointmentAddWindow.find('.startendtime').ejTimePicker({ timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() !== "month" && !(this._isCustomMonthView()) && this.currentView() !== "agenda") {
                var leftValue = this.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left");
                var view = this.model.timeScale.enable ? (this._isCustomMonthView()) ? "month" : this.currentView() : "month";
                var viewColCount = view == "day" ? 1 : view == "week" ? 7 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 5;
                this.datesColumn = this._getHeaderAllDayCellsCount();
                var multiResources = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group)) ? true : false;
                if (userTemplateId || template)
                    var html = this.userTimeCellHoriTemplate.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", multiRes: multiResources, view: view, timeTdCount: columnValueCount.strTime, colspan: view == "month" ? 1 : (columnValueCount.strTime.length / viewColCount) * 2, height: view == 'month' ? 62 : 59, width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: columnValueCount.columnCount, userTemplateId: userTemplateId, template: template });
                else
                    var html = this.horizontalHeader.render({ cols: this.datesColumn, label: this._getLocalizedLabels("Resources"), heightclass: view == 'month' ? "e-horizontalmonthtimecellsht" : "e-horizontaltimecellsht", multiRes: multiResources, view: view, timeTdCount: columnValueCount.strTime, colspan: view == "month" ? 1 : (columnValueCount.strTime.length / viewColCount) * 2, height: view == 'month' ? 62 : 59, width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px", column: columnValueCount.columnCount });
                this.aTR.children().remove();
                this.aTR.append(html);
                this._borderAddRemove();
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                this.element.find(".e-headercells").addClass("e-dateheaderselect");
                this.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", (parseInt(leftValue)) + "px");
                this._businessHourScroller();
            }
            else {
                if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.currentView() !== "agenda") {
                    var viewclass = this.currentView() == "month" ? 1 : 0;
                    if ((userTemplateId || template) && (this.currentView() !== "month" && !(this._isCustomMonthView()))) {
                        columnValueCount.columnCount.pop();
                        timeCellhtml = this.userTimeCellTemplate.render({ timerows: columnValueCount.strTime, cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, cheight: this.model.cellHeight, userTemplateId: userTemplateId, timeValue1: columnValueCount.timeValue1, template: template });
                    }
                    else
                        var timeCellhtml = this.timeCellTemplate.render({ timerows: columnValueCount.strTime, cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, userTemplateId: userTemplateId, template: template });
                    this.$TimeCellTD.children().remove();
                    this.$TimeCellTD.append(timeCellhtml); if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                    this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                    if (this._timeMode != "24") {
                        var top = (this.element.find(".e-draggableworkarea").scrollTop() / (this.element.find(".e-workcells").height() * this.model.timeScale.minorSlotCount));
                        top = (Math.round(top) < top) ? Math.round(top) + 1 : Math.round(top);
                        var localizeAmPm = ej.preferredCulture(this.model.locale).calendar;
                        if (localizeAmPm.AM && localizeAmPm.PM) {
                            this.element.find('.e-idAmpmstyle').each(function (i, val) {
                                if (i == (top) && $(val).text().trim() == "00")
                                    (parseInt($(val)[0].id) < 12) ? $(val).text(localizeAmPm.AM[0]) : $(val).text(localizeAmPm.PM[0]);
                                else if (($(val).text() == localizeAmPm.AM[0] && i > 0) || ($(val).text() == localizeAmPm.PM[0] && parseInt($(val)[0].id) > 12))
                                    $(val).text("00");
                            });
                        }
                    }
                    this.element.find(".e-headercells").addClass("e-dateheaderselect");
                    this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                }
            }
            if (!ej.isNullOrUndefined(this.dataSource()))
                this._renderAppointmentAll();
        },

        _gotoOk: function (args) {
            if ($(args.currentTarget).hasClass("e-gotoOk")) {
                var date = this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker("option", "value");
                var view = this._gotoWindow.find("#" + this._id + "show").ejDropDownList("option", "itemValue");
                data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: args };
                if (this._trigger("actionBegin", { data: data, requestType: "dateNavigate" }))
                    return false;
                var oldDate = this.currentDate();
                var oldview = this.currentView();
                this.currentDate(new Date(date));
                this.currentView(view.toLowerCase());
                data = { previousDate: oldDate, currentDate: this.currentDate(), previousView: oldview, currentView: this.currentView(), target: args, requestType: "dateNavigate" };
                if (this._trigger("navigation", data)) {
                    this.currentDate(new Date(oldDate));
                    this.currentView(oldview);
                    this._navView = false;
                    return false;
                }
                this._renderCurrentView("ViewChange");
                this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
            }
            this._gotoCancel();
        },

        _gotoCancel: function () {
            this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ value: this.currentDate() });
            this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ value: this.currentView() });
            this._gotoWindow.ejDialog("close");
        },

        _renderGoto: function () {
            this._gotoWindow.find("#" + this._id + "gotodate").ejDatePicker({ buttonText: this._getLocalizedLabels("Today"), enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            var views = []
            for (var i = 0; i < this.model.views.length; i++) {
                switch (this.model.views[i]) {
                    case "day": views.push({ text: this._getLocalizedLabels("Day"), value: "day" });
                        break;
                    case "week": views.push({ text: this._getLocalizedLabels("Week"), value: "week" });
                        break;
                    case "workweek": views.push({ text: this._getLocalizedLabels("WorkWeek"), value: "workweek" });
                        break;
                    case "month": views.push({ text: this._getLocalizedLabels("Month"), value: "month" });
                        break;
                    case "customview": views.push({ text: this._getLocalizedLabels("CustomView"), value: "customview" });
                        break;
                    case "agenda": views.push({ text: this._getLocalizedLabels("Agenda"), value: "agenda" });
                        break;
                }
            }
            this._gotoWindow.find("#" + this._id + "show").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: views, width: "100%", selectedItemIndex: 0, cssClass: this.model.cssClass });
            this._gotoWindow.find(".e-gotobutton").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "60px", cssClass: "e-flat" + this.model.cssClass });
        },

        _renderGotoWindow: function () {
            if ($("#" + this._id + "gotoWindow_wrapper")) $("#" + this._id + "gotoWindow_wrapper").remove();
            this._gotoWindow = ej.buildTag('div.e-gotodialog#' + this._id + "gotoWindow");
            var $goWindow = "<div><table width='100%' cellpadding='5'><tbody><tr><td>" + this._getLocalizedLabels("Date") + ":</td><td><input id='" + this._id + "gotodate' type='text' value='' /></td></tr>" +
                    "<tr><td>" + this._getLocalizedLabels("Showin") + ":</td><td><input type='text' id='" + this._id + "show' /></td></tr></tbody></table>";
            $goWindow += "<div class='e-floatright'><table><tr><td><div><button id='" + this._id + "gotook' type='button' class='e-gotobutton e-gotoOk'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                                  "<td><div><button id='" + this._id + "gotocancel' type='button' class='e-gotobutton e-gotoCancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            this._on(this._gotoWindow, "click", ".e-gotobutton", $.proxy(this._gotoOk, this));
            this._gotoWindow.append($goWindow);
            this.element.append(this._gotoWindow);
            this._renderGoto();
            this._gotoWindow.ejDialog({
                width: 300,
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("Gotodate"),
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._gotoCancel, this)
            });
            $("#" + this._id + "gotoWindow_wrapper").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
        },


        _highlightCurrentTime: function (showIndicator) {
            ej.preferredCulture(this.model.locale);
            if (showIndicator && this.model.timeScale.enable && !this._resWorkWeek && !this._resCustomView) {
                var flag = false, index = 0;
                if (this.currentView() !== "agenda") {
                    for (var i = 0; i < this._dateRender.length; i++) {
                        if (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) {
                            flag = true;
                            index = i;
                            break;
                        }
                    }
                }
                var tdelement = this.element.find(".e-workcellstab tr").first().find("td");
                if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                    if (flag) {
                        var temp = this;
                        var view = this.currentView() === "week" ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._dateRender.length : 1;
                        var timeWidth = (this.model.cellWidth) ? parseInt(this.model.cellWidth) : this.element.find('.e-draggableworkarea')[0].offsetWidth / (view * this.res1.length);
                        if (new Date().getHours() >= temp.model.startHour && new Date().getHours() <= temp.model.endHour) {
                            if (temp.model.orientation == "vertical") {
                                for (var i = 0; i < this.res1.length; i++) {
                                    this.element.find('.e-draggableworkarea').append('<div id="' + this._id + i + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline"></div>');
                                    $('#' + this._id + i + '_HighlightCurrentTimeline').append('<div class="e-currenttime"></div>').append(ej.buildTag("div.e-icon e-circle_01 e-timeidicatorcircle e-lefttimeindicator")).append(ej.buildTag("div.e-icon e-circle_01 e-timeidicatorcircle e-righttimeindicator")).css("width", timeWidth + "px").css("left", tdelement[index + (view * i)].offsetLeft + "px").find('.e-righttimeindicator').css("margin-left", (timeWidth - 3) + "px");
                                }
                            }
                            else {
                                this._renderHorizontalCurrentTime();
                            }
                        }
                        function ChangeCurrentTimePosition() {
                            if (temp.currentView() != "agenda" && temp.currentView() != "month" && !temp._isCustomMonthView()) {
                                var tdelement = temp.element.find(".e-workcellstab tr").first().find("td");
                                var view = temp.currentView() === "week" ? (temp.model.showWeekend) ? 7 : temp.model.workWeek.length : temp.currentView() === "workweek" ? temp.model.workWeek.length : temp.currentView() == "customview" ? temp._dateRender.length : 1;
                                var now = new Date();
                                now.setMinutes(now.getMinutes());
                                var index = temp._dateRender.indexOf(new Date(now).setHours(0, 0, 0, 0));
                                if (now.getHours() >= temp.model.startHour && now.getHours() <= temp.model.endHour) {
                                    if (temp.model.orientation == "vertical") {
                                        temp.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                                        var topVal = ((((now.getHours() - temp.model.startHour) * 60) + now.getMinutes()) * (temp.element.find(".e-workcells").height() + 1) * temp.model.timeScale.minorSlotCount) / temp.model.timeScale.majorSlot;
                                        for (var i = 0; i < temp.res1.length; i++) {
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').css("top", topVal - 1);
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').css("left", tdelement[index + (view * i)].offsetLeft);
                                            $(temp.element.find(".e-dateheader").children()[index + (view * i)]).addClass("e-currentdayhighlight");
                                        }
                                        var currentTime = temp._timeMode == "12" ? ej.format(new Date(), "hh:mm tt", temp.model.locale) : ej.format(new Date(), "HH:mm", temp.model.locale);
                                        for (var i = 0; i < temp.res1.length; i++) {
                                            temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").html(currentTime);
                                            if (temp._timeMode == "12") temp.element.find('#' + temp._id + i + '_HighlightCurrentTimeline').find(".e-currenttime").addClass("e-timewidth");
                                        }
                                    }
                                    else {
                                        temp._horizontalTimePosition(temp, now);
                                    }
                                }
                            }
                        }
                        ChangeCurrentTimePosition();
                        if (ej.isNullOrUndefined(this._intervalID))
                            this._intervalID = window.setInterval(ChangeCurrentTimePosition, 60000);
                    }
                    else {
                        window.clearInterval(this._intervalID);
                        this._intervalID = null;
                        this.element.find(".e-highlightcurrenttimeline").remove();
                    }
                }
                else {
                    if (flag) {
                        if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                            var rowIndex = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                            var rowPosition = Math.floor(index / rowIndex);
                            var cellId = Math.abs(index - (rowPosition * rowIndex));
                            if (!this.model.group) this.res1 = ["0"];
                            for (var i = 0; i < this.res1.length; i++) {
                                !$($(this.element.find(".e-workcellstab tr")[rowPosition]).children()[Math.floor(cellId)]).hasClass("e-othermonths") && $($(this.element.find(".e-workcellstab tr")[rowPosition]).children()[Math.floor(cellId)]).addClass("e-currentdayhighlight");
                                cellId += rowIndex;
                            }
                        }
                        else
                            this._renderHorizontalCurrentTime();
                    }
                    else
                        (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find(".e-monthcells").removeClass("e-currentdayhighlight") : this.element.find(".e-workcells").removeClass("e-currentdayhighlight");
                }
            }
        },
        _filter: function () {
            var filter = [], filtAppoint = $.extend(true, [], this._processed);
            for (var a = 0; a < filtAppoint.length; a++) {
                if ((new Date(filtAppoint[a][this._appointmentSettings["endTime"]]) >= this.model.minDate) && (new Date(filtAppoint[a][this._appointmentSettings["endTime"]]) <= this.model.maxDate))
                    filter.push(filtAppoint[a]);
            }
            return filter;
        },
        _getPreviousNextAppointment: function () {
            var dateCount = (((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") || !this.model.showNextPrevMonth) && this.currentView() == "month") ? this.monthDays : this._dateRender;
            var previousList = [], nextList = [], appointmentsList = this._filter();
            if (this.currentView() != "workweek") {
                for (var app = 0; app < appointmentsList.length; app++) {
                    if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) < new Date(dateCount[0]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) < new Date(dateCount[0]))
                        previousList.push(appointmentsList[app]);
                    else if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) > new Date(dateCount[(dateCount.length - 1)]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) > new Date(dateCount[(dateCount.length - 1)]))
                        nextList.push(appointmentsList[app]);
                }
            }
            else {
                for (var app = 0; app < appointmentsList.length; app++) {
                    for (var i = 0; i < dateCount.length; i++) {
                        if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).getDay() == new Date(dateCount[i]).getDay()) {
                            if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) < new Date(dateCount[0]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) < new Date(dateCount[0]))
                                previousList.push(appointmentsList[app]);
                            else if (new Date(appointmentsList[app][this._appointmentSettings["startTime"]]) > new Date(dateCount[(dateCount.length - 1)]) && new Date(appointmentsList[app][this._appointmentSettings["endTime"]]) > new Date(dateCount[(dateCount.length - 1)]))
                                nextList.push(appointmentsList[app]);
                        }
                    }
                }
            }
            return { previous: previousList, next: nextList };
        },

        _nextPrevAppointment: function (flag) {
            if (flag && !(this._browserInfo.name === "msie" && this._browserInfo.version < 9)) {
                var base = this.element.find("#" + this._id + "_scroller");
                var scroll = (base.ejScroller('instance').isVScroll()) ? this.element.find("#" + this._id + "_scroller").find(".e-vscroll").outerWidth() : 0;
                var prev = ej.buildTag("div.e-prevapp enable", this._getLocalizedLabels("PreviousAppointment"), {}, {});
                var next = ej.buildTag("div.e-nextapp enable", this._getLocalizedLabels("NextAppointment"), {}, {});
                base.append(prev).append(next);
                var top = (base.height() / 2) - (150 / 2);
                var timecell = this.element.find(".e-scrolltimecells").parent().outerWidth();
                timecell = ej.isNullOrUndefined(timecell) ? 0 : timecell;
                if (!this.model.enableRTL) {
                    prev.css({ top: (top + 40) + "px", transform: "rotate(90deg)", left: (timecell - 61) + "px" });
                    next.css({ top: (top + 40) + "px", transform: "rotate(-90deg)", left: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
                }
                else {
                    prev.css({ top: (top + 40) + "px", transform: "rotate(-90deg)", right: (timecell - 61) + "px" });
                    next.css({ top: (top + 40) + "px", transform: "rotate(90deg)", right: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
                }
            }
        },

        _nextPrev: function (e) {
            var proxy = this, appointmentList = this._getPreviousNextAppointment();
            if ($(e.currentTarget).hasClass("e-prevapp")) {
                if (!ej.isNullOrUndefined(appointmentList)) {
                    appointmentList.previous.sort(function (a, b) { return new Date(b[proxy._appointmentSettings["startTime"]]) - new Date(a[proxy._appointmentSettings["startTime"]]); });
                    if (this.currentView() == "customview") this._daterend = appointmentList.previous[0][this._appointmentSettings["startTime"]];
                    this._navigateClick(this.currentDate(new Date(new Date(appointmentList.previous[0][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0))), "Previous");
                }
            }
            else if ($(e.currentTarget).hasClass("e-nextapp")) {
                if (!ej.isNullOrUndefined(appointmentList)) {
                    appointmentList.next.sort(function (a, b) { return new Date(a[proxy._appointmentSettings["startTime"]]) - new Date(b[proxy._appointmentSettings["startTime"]]); });
                    if (this.currentView() == "customview") this._daterend = appointmentList.next[0][this._appointmentSettings["startTime"]];
                    this._navigateClick(this.currentDate(new Date(new Date(appointmentList.next[0][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0))), "Next");
                }
            }
        },

        _nextPrevButton: function () {
            if (this._appointmentCount().length != 0)
                this.element.find(".e-prevapp,.e-nextapp").css("display", "none");
            else {
                this.currentView() == "agenda" && this._refreshAppNavigation();
                var appointmentList = this._getPreviousNextAppointment();
                this.element.find(".e-prevapp,.e-nextapp").css("display", "block");
                if (appointmentList.previous.length == 0)
                    this.element.find(".e-prevapp").removeClass("enable").addClass("e-nextprevappdisable");
                else
                    this.element.find(".e-prevapp").addClass("enable").removeClass("e-nextprevappdisable");
                if (appointmentList.next.length == 0)
                    this.element.find(".e-nextapp").removeClass("enable").addClass("e-nextprevappdisable");
                else
                    this.element.find(".e-nextapp").addClass("enable").removeClass("e-nextprevappdisable");
            }
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                this.element.find(".e-prevapp,.e-nextapp").hide();
            }
        },

        _navigateView: function (e) {
            var newView, navidate, index, cellIndex, oldview = this.currentView();
            var target = $(e.target);
            if (this.currentView() == "agenda") {
                return false;
            }
            else {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    if (this.currentView() === "month" || (this._isCustomMonthView())) {
                        if (target.hasClass("e-monthheader")) {
                            if (this.model.views.toString().toLowerCase().split(",").indexOf("day") == -1) return false;
                            cellIndex = target.parent().index();
                            index = (cellIndex > (noOfDays - 1)) ? (cellIndex % noOfDays) : cellIndex;
                            navidate = new Date(this._dateRender[((target.parent().parent().index() * noOfDays) + index)]);
                            if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                                this.currentDate(navidate);
                            else return false;
                            newView = "day";
                        }
                        else if (target.hasClass("e-timecells") || target.hasClass("e-timecelldivs")) {
                            target = target.hasClass("e-timecells") ? target : target.parent();
                            if (this.model.views.toString().toLowerCase().split(",").indexOf("week") == -1) return false;
                            navidate = new Date(this._dateRender[(target.parent().index() * noOfDays)]);
                            if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                                this.currentDate(navidate);
                            else return false;
                            newView = "week";
                        }
                    }
                    else if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                        var dayTarget = target.hasClass("e-headercells") ? target : target.parent().hasClass("e-headercells") ? target.parent() : target.closest(".e-headercells");
                        if (this.model.views.toString().toLowerCase().split(",").indexOf("day") == -1 || !dayTarget.hasClass("e-headercells")) return false;
                        cellIndex = dayTarget.index();
                        var cols = (this.currentView() === "workweek") ? this.model.workWeek.length : (this.currentView() === "customview") ? this._dateRender.length : noOfDays;
                        index = (cellIndex > (cols - 1)) ? (cellIndex % cols) : cellIndex;
                        navidate = new Date(this._dateRender[index]);
                        if (this.model.minDate <= navidate && this.model.maxDate >= navidate)
                            this.currentDate(new Date(navidate));
                        else return false;
                        newView = "day";
                    }
                    this._navView = true;
                    if (oldview != "day" && !ej.isNullOrUndefined(newView)) {
                        this._viewChange(e, oldview, newView);
                        this._businessHourScroller();
                    }
                }
                else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                    this._horizontalViewNavigation(e);
            }
        },

        _appOverflowClick: function (e) {
            if (this.model.views.toString().toLowerCase().split(",").indexOf("day") !== -1) {
                if (this._trigger("overflowButtonClick", { event: e, Datas: this._overflowApp })) return false;
                !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    var index = ($(e.target).closest(".e-monthcells,.e-workcells").parent().index() * noOfDays) + ($(e.target).closest(".e-monthcells,.e-workcells").index() % noOfDays);
                    this.currentDate(new Date(this._dateRender[index]));
                }
                else {
                    var index = parseInt($(e.target).attr("id").split("_")[$(e.target).attr("id").split("_").length - 1]);
                    this.currentDate((this.currentView() == "month" || this._isCustomMonthView()) ? new Date(this.monthDays[index]) : new Date(parseInt($(e.target).attr("data-cellinfo"))));
                }
                this._navView = true;
                this._viewChange(e, this.currentView(), "day");
            }
            else return false;
        },

        _viewCalendar: function (e) {
            if (!(((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview")) {
                var obj = this.element.find("#" + this._id + "_navigator").data("ejDatePicker");
                if (obj) {
                    obj.show();
                    this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                    var controlmargin = this.element.offset();
                    if (this.model.enableRTL) {
                        var leftvalue = controlmargin.left + this.element.width() - 280;
                        if (leftvalue < 0) leftvalue = 0;
                    }
                    else {
                        var leftvalue = controlmargin.left + 55, winWidth = $(document).scrollLeft() + $(window).width();
                        if ((winWidth - leftvalue) < $("#e-" + this._id + "_navigator").width())
                            leftvalue = winWidth - $("#e-" + this._id + "_navigator").width();
                    }
                    $("#e-" + this._id + "_navigator").css({ top: (controlmargin.top + 47) + "px", left: leftvalue + "px" });
                }
                this.element.find(".e-workcells").removeClass("e-selectedCell").removeClass("e-mousehover");
                this.element.find(".e-appointment,.e-alldayappointment,.e-monthappointment").removeClass("e-selectedAppointment");
            }
        },

        _viewChange: function (e, oldview, newView) {
            this._viewchange = true; this._renderedApp = [];
            newView = ej.isNullOrUndefined(newView) ? (e.currentTarget.className.split("e-")[2]).split(" ")[0] : newView;
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && newView !== "customview") {
                this.element.find(".e-datecommondiv").hasClass("e-datecursor") && this.element.find(".e-datecommondiv").removeClass("e-datecursor");
                !this.element.find(".e-navigateprevious,.e-navigatenext").is(":visible") && this.element.find(".e-navigateprevious,.e-navigatenext").show();
                !this.element.find(".e-prevapp,.e-nextapp").is(":visible") && this.element.find(".e-prevapp,.e-nextapp").show();
            }
            var flag = true, data;
            data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e };
            if (this._trigger("actionBegin", { data: data, requestType: "viewNavigate" })) return false;
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            if (oldview !== newView || (!oldview && !newView)) {
                oldview = this.currentView();
                if (!this._navView) {
                    flag = (this.currentView() == (e.currentTarget.className.split("e-")[2]).split(" ")[0]) ? false : true;
                    this.currentView($(e.currentTarget).hasClass("e-activeview") ? this.currentView() : (e.currentTarget.className.split("e-")[2]).split(" ")[0]);
                }
                else
                    this.currentView(newView);
                data = { previousView: oldview, currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e, requestType: "viewNavigate" };
                if (this._trigger("navigation", data)) {
                    this.currentView(oldview);
                    this._navView = false;
                    return false;
                }
                if (oldview !== this.currentView())
                    this._customOrientation = this.model.orientation;
                if (flag) this._renderCurrentView("ViewChange");
            }
            data = { previousView: oldview, currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e, requestType: "viewNavigate" };
            (this._mediaQuery && (oldview != this.currentView())) && this.element.find(".e-workareadiv,.e-navigate").addClass("navigate");
            this._trigger("actionComplete", { data: data, requestType: "viewNavigate" });
        },

        _renderCurrentView: function (currentAction) {
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && this._grouping.length > 1) {
                var expandCollapseNode = this.element.find(".e-parentnodecategory"), proxy = this;
                expandCollapseNode.each(function (index) {
                    if ($(this).hasClass("e-resourceexpand")) proxy._expandCollapseState.push(index);
                });
            }
			this._resWorkWeek = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showWeekend && this.currentView() == "workweek" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]));
            this._resCustomView = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showWeekend && this.currentView() == "customview" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]));
            this.element.find(".e-commonviewbutton").blur().removeClass("e-activeview");
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") this.element.find(".e-headerdaydisplay,.e-datedisplay,.e-headrealldaytable").children().remove();
            this._getRenderDates();
            this.wTR.children().remove();
            this.aTR.children().remove();
            this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview").attr("tabIndex", 0).focus();
            if ((!ej.isNullOrUndefined(this._scheduleDrawer)) && (!this._navSelected))
                this._scheduleDrawer.ejNavigationDrawer({ listViewSettings: { selectedItemIndex: this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) + 1 } });
            this._renderHeaderAllDayTemplate();
            this._renderContentAreaTemplate();
            if (this.model.showHeaderBar) this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
            this._renderCommon();
            if (!ej.isNullOrUndefined(this.dataSource())) {
                if (currentAction != "ScheduleResize") {
                    if (this.model.enableLoadOnDemand)
                        this._bindAppointmentsData(currentAction);
                    else {
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                    }
                }
                else
                    this._renderAppointmentAll();
            }
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && this._grouping.length > 1) {
                var expandCollapseNode = this.element.find(".e-parentnodecategory");
                for (var ec = 0; ec < this._expandCollapseState.length; ec++) {
                    expandCollapseNode.eq(this._expandCollapseState[ec]).click();
                }
                if(this.currentView() != "agenda") this._expandCollapseState = [];
            }
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            this._navView = false;
        },

        _renderHeaderDays: function () {
            this.dateRender = [];
            var dateList = $.extend(true, [], this._getRenderDates());
            this.res1 = (!ej.isNullOrUndefined(this.model.group)) ? this.res1 : [0];
            if (!this._resWorkWeek && !this._resCustomView) {
                for (var i = 0; i < this.res1.length; i++) {
                    for (var j = 0; j < dateList.length; j++) {
                        this.dateRender.push(new Date(dateList[j]));
                    }
                }
            }
            if (this.model.showHeaderBar) this.element.find("div.e-datedisplay").html(this._getCurrentDateHeaderValue());
            (this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate);
            (this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate);
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                this.element.find(".e-currentdayhighlight").removeClass("e-currentdayhighlight");
                if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                    var curday, temp;
                    if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId)) {
                        var cols = [], columns = this._getUserDateheaderTemplate();
                        if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                            for (var i = 0; i < this.res1.length; i++) { cols = $.merge(cols, columns); }
                        }
                        else cols = $.merge(cols, columns);
                        for (var i = 0; i < this.dateRender.length; i++) {
                            this.element.find(".e-headerdaydisplay").eq(i).html(cols[i].currentDay);
                            if (new Date(new Date(this.dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                                this.element.find("td.e-headercells").eq(i).addClass("e-currentdayhighlight");
                        }
                    }
                    else {
                        for (var i = 0; i < this.dateRender.length; i++) {
                            curday = (this.currentView() === "day") ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this.dateRender[i]).getDay()] : this._dayShortNames[new Date(this.dateRender[i]).getDay()] : this._dayShortNames[new Date(this.dateRender[i]).getDay()];
                            temp = this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? ej.format(new Date(this.dateRender[i]), this._pattern.D, this.model.locale) : curday + " " + new Date(this.dateRender[i]).getDate() : curday + " " + new Date(this.dateRender[i]).getDate();
                            this.element.find(".e-headerdaydisplay").eq(i).html(temp);
                            if (new Date(new Date(this.dateRender[i]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                                this.element.find("td.e-headercells").eq(i).addClass("e-currentdayhighlight");
                        }
                    }
                    this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                    this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                    if (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId) && this.model.timeScale.enable) {
                        var allDayHtml = this._getUserAllDayCellsTemplate();
                        for (var a = 0; a < allDayHtml.length; a++) { this.element.find(".e-alldaycells").eq(a).html(allDayHtml[a]); }
                        this.element.find(".e-leftindent").height(this.element.find(".e-alldaycells").height());
                    }
                    this.element.find(".e-headercells").addClass("e-dateheaderselect");
                }
                else
                    this._renderMonthTimeCells();
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                this._renderHorizontalHeaderDays(this._culture);
        },

        _renderMonthTimeCells: function () {
            var timeCellIndex = 0, dateRender = this._dateRender, k = 0, rowIndex = (this.model.showWeekend) ? 7 : this.model.workWeek.length, resCount = !ej.isNullOrUndefined(this.model.group) ? this.res1.length * rowIndex : rowIndex;
            var findResource = ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? true : false;
            if (findResource)
                resCount = this._isCustomMonthView() && this._oneWeek ? this.res1.length * this._dateRender.length : this.res1.length * rowIndex;
            else
                resCount = !ej.isNullOrUndefined(this.model.group) ? this._isCustomMonthView() && this._oneWeek ? this.res1.length * this._dateRender.length : this.res1.length * 7 : rowIndex;
            var res = findResource && this._isCustomMonthView() && this._oneWeek ? true : false;
            var monthHeader = this.element.find("div.e-monthheader");
            for (var i = 0; i < dateRender.length; i++) {
                for (var j = k; j < resCount; j = res ? j + this._dateRender.length : j + rowIndex) {
                    var curDate = (new Date(this._dateRender[i]).getDate() == 1) ? (ej.format(new Date(this._dateRender[i]), "MMM", this.model.locale) + " " + new Date(this._dateRender[i]).getDate()) : ej.format(new Date(this._dateRender[i]), "dd", this.model.locale);
                    monthHeader.eq(j).html(curDate);
                    if (this.currentView() !== "customview") {
                        if (new Date(dateRender[i]).getMonth() !== new Date(this.currentDate()).getMonth()) {
                            if (!this.model.showNextPrevMonth)
                                monthHeader.eq(j).addClass("e-monthdateshighlight").closest(".e-monthcells").addClass("e-othermonths").children().hide();
                            else
                                monthHeader.eq(j).addClass("e-monthdateshighlight").closest(".e-monthcells").removeClass("e-othermonths").children().show();
                        }
                        else
                            monthHeader.eq(j).removeClass("e-monthdateshighlight").closest(".e-monthcells").removeClass("e-othermonths").children().show();
                    }
                    if (new Date(dateRender[i]).getTime() == new Date(new Date().setHours(0, 0, 0, 0)).getTime())
                        !this.element.find("td.e-monthcells").eq(j).hasClass("e-othermonths") && this.element.find("td.e-monthcells").eq(j).addClass("e-currentdayhighlight");
                }
                k++;
                if ((i + 1) % rowIndex == 0) {
                    var start, end, tempDate;
                    k = resCount;
                    resCount = resCount + ((!ej.isNullOrUndefined(this.model.group) ? this.res1.length : 1) * rowIndex);
                    if (this.model.showNextPrevMonth || this.currentView() == "customview") {
                        start = ej.format(new Date(dateRender[i - (rowIndex - 1)]), "MMM dd", this.model.locale);
                        end = ej.format(new Date(dateRender[i]), "MMM dd", this.model.locale);
                    }
                    else {
                        tempDate = new Date(this.currentDate());
                        start = (i == rowIndex - 1) ? ej.format(new Date(tempDate.getFullYear(), tempDate.getMonth(), 1), "MMM dd", this.model.locale) : ej.format(new Date(dateRender[i - (rowIndex - 1)]), "MMM dd", this.model.locale);
                        end = (i == dateRender.length - 1) ? ej.format(new Date(tempDate.getFullYear(), tempDate.getMonth() + 1, 0), "MMM dd", this.model.locale) : ej.format(new Date(dateRender[i]), "MMM dd", this.model.locale);
                    }
                    if (this.model.timeScale.enable) this.element.find(".e-timecelldivs").eq(timeCellIndex).html(start + " - " + end);
                    timeCellIndex++;
                }
            }
            if (!this.model.showNextPrevMonth && this.currentView() == "month") {
                this._refreshOtherMonthsBorder();
            }
            this.element.find(".e-timecells").addClass("e-dateheaderselect");
            this.element.find(".e-monthcells, .e-timecells").outerHeight(this.model.cellHeight ? parseInt(this.model.cellHeight) + 1 : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
        },

        _refreshOtherMonthsBorder: function () {
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            var prevMonthlen = this.element.find(".e-workcellstab tr").first().find(".e-othermonths").length;
            var prevRes = prevMonthlen / this.res1.length;
            for (var a = prevRes; a < prevMonthlen; a = a + prevRes) {
                this.element.find(".e-workcellstab tr").first().find(".e-othermonths").eq(a).addClass(border);
            }
            var nextMonthlen = this.element.find(".e-workcellstab tr").last().find(".e-othermonths").length;
            var nextRes = nextMonthlen / this.res1.length;
            for (var b = 0; b < nextMonthlen; b = b + nextRes) {
                this.element.find(".e-workcellstab tr").last().find(".e-othermonths").eq(b).addClass(border);
            }
        },

        _nextPrevDate: function (args) {
            var findDate, weekDate = new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0));
            var noOfDays = (this.currentView() === "day" || this.currentView() === "agenda") ? 1 : this.currentView() === "customview" ? this._dateRender.length : 7;
            if (this.currentView() === "month") {
                var navigateMonth = (args == "navigateprevious") ? new Date(weekDate.getFullYear(), weekDate.getMonth() - 1, weekDate.getDate()) : new Date(weekDate.getFullYear(), weekDate.getMonth() + 1, weekDate.getDate());
                var targetMonth = (args == "navigateprevious") ? new Date(weekDate.getFullYear(), weekDate.getMonth() - 1, 1) : new Date(weekDate.getFullYear(), weekDate.getMonth() + 1, 1);
                findDate = (navigateMonth.getMonth() == targetMonth.getMonth()) ? new Date(navigateMonth) : new Date(targetMonth._currentMonthDates().end);
            }
            else if (this.currentView() === "customview") {
                this._daterend = this._dateRender; this._dateNavigation = true;
                weekDate = (this.model.showWeekend) ? new Date(this._dateRender[0]) : new Date(this._renderStart);
                noOfDays = (this.model.showWeekend) ? noOfDays : this._isCustomMonthView() ? this._numDays : this._renderDays;
                findDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
            }
            else if ((this.currentView() == "day" || this.currentView() === "agenda") && !this.model.showWeekend) {
                var currentDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24));
                noOfDays = this._getPrevNextDateCount(currentDate, (args == "navigateprevious") ? "previous" : "next") + 1;
                weekDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
                findDate = new Date(weekDate);
            }
            else {
                findDate = (args == "navigateprevious") ? new Date(weekDate.getTime() - (1000 * 60 * 60 * 24 * noOfDays)) : new Date(weekDate.getTime() + (1000 * 60 * 60 * 24 * noOfDays));
            }
            return new Date(findDate.getFullYear(), findDate.getMonth(), findDate.getDate());
        },

        _navigateClick: function (e, dateNavigate) {
            this._viewchange = true;
            var currentAction = dateNavigate;
            var oldDate = new Date(this.currentDate());
            var data = { currentView: this.currentView(), currentDate: new Date(this.currentDate()), target: e };
            if (this._trigger("actionBegin", { data: data, requestType: "dateNavigate" }))
                return false;
            if (!ej.isNullOrUndefined(e) && !ej.isNullOrUndefined(e.value)) {
                this.currentDate(ej.parseDate(e.value, this._pattern.d));
            }
            if (e != null && !this._setCurrentDate) {
                if ($(e.currentTarget).hasClass("e-disable")) return false;
                if ($(e.currentTarget).hasClass("e-navigateprevious")) {
                    this.currentDate(this._nextPrevDate("navigateprevious"));
                    this.element.find(".e-navigateprevious").attr("tabIndex", 0).focus();
                    currentAction = "Previous";
                }
                else if ($(e.currentTarget).hasClass("e-navigatenext")) {
                    this.currentDate(this._nextPrevDate("navigatenext"));
                    this.element.find(".e-navigatenext").attr("tabIndex", 0).focus();
                    currentAction = "Next";
                }
            }
            if (e != null)
                if ($(e.currentTarget).hasClass("e-navigateprevious") || $(e.currentTarget).hasClass("e-navigatenext") || (e.type == "select"))
                    data = { previousDate: oldDate, currentDate: new Date(this.currentDate()), currentView: this.currentView(), target: e, requestType: "dateNavigate" };
            if (this._trigger("navigation", data)) {
                this.currentDate(new Date(oldDate));
                return false;
            }
            this.element.find(".e-workcells,.e-alldaycells,.e-monthcells").removeClass("e-selectedCell");
            this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
            this.element.find(".e-appsoverflow").remove();
            this.element.find(".e-monthcells").removeClass("e-monthcurrenttime");
            if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            !ej.isNullOrUndefined(this._scheduleDrawer) && this._scheduleDrawer.ejNavigationDrawer("close");
            if (this.currentView() === "month" || this.currentView() === "agenda" || this._isCustomMonthView() || (this.currentView() === "customview" && !this.model.showWeekend) || !this.model.timeScale.enable || !ej.isNullOrUndefined(this.model.workCellsTemplateId)) {
                this._renderCurrentView(currentAction);
            }
            else {
                this._renderHeaderDays();
                if (!ej.isNullOrUndefined(this.model.queryCellInfo)) {
                    this._renderQueryCellInfo("renderHeaderAllDayTemplate");
                    this._renderQueryCellInfo("renderContentAreaTemplate");
                    this._renderQueryCellInfo("emptycell");
                }
                if (!this.model.showOverflowButton && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) {
                    this._horizontalRender();
                    this._reRenderScroller();
                }
                if (!ej.isNullOrUndefined(this.dataSource())) {
                    if (this.model.enableLoadOnDemand)
                        this._bindAppointmentsData(currentAction);
                    else {
                        this._dataProcessing(this._currentAppointmentData);
                        this._renderAppointmentAll();
                    }
                }
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                !this._dragWeek && this._businessHourScroller();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            }
            this._validateMinMaxDate();
            if (!ej.isNullOrUndefined(this.oldDate) && this.oldDate != "" && this._setCurrentDate) {
                this.currentDate(new Date(this.oldDate));
                this.oldDate = "";
            }
            this._setCurrentDate = false;
            if (this._mediaQuery && !ej.isNullOrUndefined(e)) {
                var value = ($(e.currentTarget).hasClass("e-navigateprevious")) ? this.element.width() : ($(e.currentTarget).hasClass("e-navigatenext") || (e.type == "select")) ? -this.element.width() : 0;
                this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll,.e-emptyscrolltd").toggle();
                if (!this.model.enableRTL)
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginLeft: -value, marginRight: value }).toggle().animate({ marginLeft: 0, marginRight: 0 }, 500, ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length == 1) ? $.proxy(this._animateScroll, this) : "");
                else
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginRight: -value, marginLeft: value }).toggle().animate({ marginLeft: 0, marginRight: 0 }, 500, ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length == 1) ? $.proxy(this._animateScroll, this) : "");
            }
            this._trigger("actionComplete", { data: data, requestType: "dateNavigate" });
        },
        _animateScroll: function () {
            this.element.find(".e-emptyscrolltd").toggle();
            this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-vscroll").css({ marginRight: 0, marginLeft: 0 });
            if (this._browserInfo.name == "webkit" || this._browserInfo.name == "msie") {
                highScrol = this.element.find('.e-businesshighlightworkcells').length != 0 ? this.element.find('.e-businesshighlightworkcells').first().parent()[0].rowIndex * $('.e-workcells').height() : 0;
                $("#" + this._id + "_scroller").ejScroller({ scrollTop: highScrol + 1 });
                this.element.find('.e-scrolltimecells').css('top', -(highScrol + 1) + 'px');
            }
        },
        _validateMinMaxDate: function () {
            this.element.find(".e-navigateprevious,.e-navigatenext").removeClass("e-disable");
            var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : this._dateRender;
            var firstWeekDate = new Date(renderDate[0]);
            var lastWeekDate = new Date(renderDate[renderDate.length - 1]);
            if (this.currentView() == "workweek") {
                firstWeekDate = new Date(firstWeekDate.setDate(firstWeekDate.getDate() - 1));
                lastWeekDate = new Date(lastWeekDate.setDate(lastWeekDate.getDate() + 1));
            }
            if (firstWeekDate <= this.model.minDate)
                this.element.find(".e-navigateprevious").addClass("e-disable");
            else
                this.element.find(".e-navigateprevious").removeClass("e-disable");
            if (lastWeekDate >= this.model.maxDate)
                this.element.find(".e-navigatenext").addClass("e-disable");
            else
                this.element.find(".e-navigatenext").removeClass("e-disable");
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                this.element.find(".e-navigateprevious,.e-navigatenext").hide();
            }
        },

        _onScheduleResize: function () {
            if (!ej.isNullOrUndefined(this._scheduleDrawer)) {
                if (ej.isNullOrUndefined(this._scheduleDrawer.data("ejNavigationDrawer"))) {
                    $(this._scheduleDrawer).remove(); this._scheduleDrawer = null;
                }
                else this._scheduleDrawer.ejNavigationDrawer("close");
            }
            if (this._mediaQuery && ej.isMobile()) {
                if (!ej.isNullOrUndefined(this._recurEditWindow)) this._recurEditWindow.ejDialog("refresh");
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog("refresh");
                if (window.orientation == this._screenOrientation) return false;
                this._screenOrientation = window.orientation;
            }
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
            var temp = this._mediaQuery;
            var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
            this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : ((document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile()) && this.model.isResponsive);
            (this._mediaQuery) ? this.element.addClass("e-scheduleresponsive") : this.element.removeClass("e-scheduleresponsive");
            var scrollerObj = this.element.find('div#' + this._id + '_scroller').data("ejScroller");
            if (this.currentView() != "agenda") {
                var scroll = (scrollerObj.isVScroll()) ? this.element.find('div#' + this._id + '_scroller').find(".e-vscroll").width() : 0;
                this.element.find(".e-nextapp").css("left", (this.element.width() - scroll - 90) + "px");
                this.model.enableRTL && this.element.find(".e-nextapp").css("left", -45 + "px");
                this.model.enableRTL && this.element.find(".e-prevapp").css("left", (this.element.width() - this.element.find(".e-scrolltimecells").width() - 89) + "px");
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                    this.element.find(".resemptytd").width((this.element.find(".e-horizontalrestd").width() < 100) ? 5 : (this.element.find(".e-horizontalrestd").width() >= 100 && this.element.find(".e-horizontalrestd").width() <= 150) ? 10 : 25);
                    this.element.find(".e-horizontalresheader").width((this._mediaQuery) ? "50px" : "100%");
                    this.element.find(".e-parentnodecategory").width((this._mediaQuery) ? "12px" : "20px");
                }
                var scrollWidth = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? ((hasScrollbar && this._mediaQuery) ? this.element.outerWidth() + 17 : this.element.outerWidth()) - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
                scrollerObj.model.width = parseInt(scrollWidth) - 2;
                scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
                scrollerObj.refresh();
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    this._renderHoriVerticalScroll();
                    this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                    this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                    this.element.find(".e-upicon, .e-downicon").children().width(this.element.find(".e-workcells").width());
                    this.element.find(".e-headeralldaydiv,.e-draggableworkarea,.e-emptyscrolltd").css("margin-left", "0px");
                    this.element.find(".e-scrolltimecells").css("top", -(this.element.find(".e-draggableworkarea").scrollTop()) + "px");
                }
                else {
                    if (!this._isCustomMonthView() || this.currentView() != "month" || this.currentView() != "day" || !this.model.enableRTL || this.model.timeScale.enable) {
                        this.element.find(".e-headeralldaydiv").width(this.element.find(".e-draggableworkarea").width());
                        this.element.find(".e-horizontaltimecells").find("table tr").eq(2).css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                        this._horizontalRender();
                        if (!this.model.showOverflowButton) this._renderAppointmentAll();
                    }
                }
                if (this.currentView() != "month" && !(this._isCustomMonthView()) && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                    if (this.model.enableRTL && (this.model.cellWidth || this.model.cellHeight))
                        this._renderCurrentView("ScheduleResize");
                    else {
                        (this.model.showAllDayRow && this.model.timeScale.enable) && this.element.find("div.e-alldayappointment").remove() && this._renderAllDayAppointments();
                        if (!this.model.timeScale.enable) {
                            this.element.find("div.e-monthappointment").remove();
                            this._currentViewAppointments = this._appointmentCount();
                            this._renderMonthAppointment();
                        }
                        this._bindAppointmentAction();
                    }
                }
                else {
                    if (this._isCustomMonthView() || this.currentView() == "month" || this.currentView() == "day" || this.model.enableRTL || !this.model.timeScale.enable)
                        this._renderCurrentView("ScheduleResize");
                }
                if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            } else {
                scrollerObj.model.width = parseInt(this.element.width()) - 2;
                scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
                scrollerObj.refresh();
                var _scrollDiv = $('div#' + this._id + "_scroller");
                this.element.find(".e-headeralldaydiv").width(this.element.find(".e-draggableworkarea").width());
                this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                _scrollDiv.ejScroller("isVScroll") ? (this.element.find(".e-emptyscrolltd").show() && this.element.find('.e-draggableworkarea').height(this.element.find('.e-draggableworkarea').height() + 1)) : this.element.find(".e-emptyscrolltd").hide();
            }
            ((this._mediaQuery || this.element.width() < 600) && !$("#" + this._id + "navDrawer").hasClass("e-scheduledrawer")) && this._renderNavigationDrawer();
            var flag = (this._mediaQuery == temp) ? false : true;
            if (!flag && (this.element.width() < 600 && this.hTR.find(".e-mobileNavigation").length < 1 || this.element.width() > 600 && this.hTR.find("table.e-viewstable").length < 1)) {
                this._reRenderHeaderBar();
                this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
            }
            if (flag) {
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                    var renderDate = this._dateRender;
                    for (var i = 0; i < renderDate.length; i++) {
                        var curday = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? this._dayNames[new Date(renderDate[i]).getDay()].split("")[0] : (this.currentView() === "day") ? (ej.isNullOrUndefined(this._tempResource) && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(renderDate[i]).getDay()] : this._dayShortNames[new Date(renderDate[i]).getDay()] : this._dayShortNames[new Date(renderDate[i]).getDay()];
                        var temp = (this._mediaQuery && (this.currentView() == "week" || this.currentView() == "workweek")) ? curday + parseInt(ej.format(new Date(renderDate[i]), "dd", this.model.locale)) : (this.currentView() === "day") ? (ej.isNullOrUndefined(this._tempResource) && ej.isNullOrUndefined(this.model.group)) ? curday + " " + ej.format(new Date(renderDate[i]), "dd MMMM yyyy", this.model.locale) : curday + " " + ej.format(new Date(renderDate[i]), "dd MMM yy", this.model.locale) : curday + " " + new Date(renderDate[i]).getDate();
                        if (this.element.find(".e-headerdaydisplay,.e-horizontalheaderdiv").length != 0) this.element.find(".e-headerdaydisplay,.e-horizontalheaderdiv")[i].innerHTML = temp;
                    }
                }
                this.model.showAppointmentNavigator = flag && !this._mediaQuery;
                if (!this.model.showAppointmentNavigator)
                    this.element.find(".e-prevapp,.e-nextapp").remove();
                else {
                    this._nextPrevAppointment(this.model.showAppointmentNavigator);
                }
                this.model.showHeaderBar && this._reRenderHeaderBar();
                this.element.find(".e-leftindenttable").width(this.element.find(".e-workleftindent").width());
				if(this.currentView()!="agenda")
                this.element.find(".e-ampmdisplay").outerHeight(this.element.find(".e-workcells, .e-monthcells")[0].offsetHeight);
                this._businessHourScroller();
                this.model.showQuickWindow = this._mediaQuery ? false : this._quickWindow;
                (this._mediaQuery) && (this.model.allowInline = false);
                if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
                this._refreshAppointmentWindow();
                (!ej.isNullOrUndefined(this._alertWindow)) && this._alertWindow.ejDialog("close");
                if (!ej.isNullOrUndefined(this._recurEditWindow)) {
                    this._recurEditWindow.ejDialog("close");
                    this._recurEditWindow.ejDialog({ width: (this._mediaQuery) ? "90%" : 360 });
                }
                if (this._mediaQuery) this._phoneChanges();
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
                if (this._mediaQuery) {
                    this._off(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells,td.e-alldaycells");
                    this._off(this.element, "keydown click", "td.e-workcells,td.e-monthcells,td.e-alldaycells");
                    this._on(this.element, "click", "#" + this._id + "navDrawerIcon", $.proxy(this._drawerOpen, this));
                }
                else {
                    this._on(this.element, ej.eventType.mouseDown, "td.e-workcells,td.e-monthcells,td.e-alldaycells", $.proxy(this._mouseButtonClick, this));
                    this._on(this.element, "keydown click", "td.e-workcells,td.e-monthcells,td.e-alldaycells", $.proxy(this._shiftSelection, this));
                    (this.element.width() > 600) && this._off(this.element, "click", "#" + this._id + "navDrawerIcon");
                }
                (this._mediaQuery || ej.isTouchDevice()) ? this._on(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab", $.proxy(this._touchSchedule, this)) : this._off(this.element, "swipeleft swiperight", ".e-contentarearow .e-workcellstab,.e-agendacellstab");
                this._on(this.element, (ej.isMobile()) ? "click" : "dblclick", ".e-workcells,.e-alldaycells,.e-alldayappointment,.e-monthcells", $.proxy(this._appointmentWindow, this));
                if (this._mediaQuery || ej.isMobile())
                    this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                else
                    this._off(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment");
                var scheduleResponsive = $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "navDrawer,#" + this._id + "alertWindow_wrapper");
                (this._mediaQuery) ? scheduleResponsive.addClass("e-scheduleresponsive") : scheduleResponsive.removeClass("e-scheduleresponsive");
                (this._mediaQuery && this.res1.length > 1) && this.element.addClass("e-resources");
            }
            (this._mediaQuery || this.element.width() < 600) && this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                this._addMonthNameRow();
                this.element.find(".e-datecommondiv").addClass("e-datecursor");
                this.element.find(".e-navigateprevious,.e-navigatenext").hide();
            }
        },

        _reRenderHeaderBar: function () {
            var header = this.element.find(".e-scheduleheader");
            header.empty();
            this._renderHeaderBar(header);
            this.element.find("#" + this._id + "_navigator").ejDatePicker({ enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            this.element.find(".e-datecommondiv").find(".e-datewidget").css("display", "none");
            this.element.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview");
        },

        _renderTemplates: function () {
            this.workcellTemp = $.templates(workCellsTemplate());
            this.monthcellTemp = $.templates(monthCellsTemplate());
            this.timeCellTemplate = $.templates(timeCellsTemplate());
            this.userTimeCellTemplate = $.templates(userTimeCellsTemplate());
            this.headTemplate = $.templates(headerTemplate());
            this.alldayTemp = $.templates(alldayTemplate());
            this.leftIndent = $.templates(leftHeaderTemplate());
            this.agendaheadTemplate = $.templates(agendaHeaderTemplate());
            this.agendacellTemp = $.templates(agendaCellsTemplate());
            this.appTemplate = $.templates(appointmentTemplate());
            this.inlineTemplate = $.templates(_inlineAppTemplate());
            this.blockTimeTemplate = $.templates(blockTimeTemplate());
            if (ej.scheduleFeatures.horizontal) this._renderHorizontalTemplates();
            if (ej.scheduleFeatures.resources && (this._tempResource.length != 0)) this._renderResourcesTemplate();
            if (!ej.isNullOrUndefined(this.model.categorizeSettings) && this.model.categorizeSettings.enable) {
                this._renderCategorizeTemplate();
                this._categorizeMultipleTemplate = $.templates(categorizeMultipleTemplate());
            }
        },

        _setNewStartEndHours: function () {
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                    this.aTR.children().remove();
                    this._renderHeaderAllDayTemplate();
                }
                this.wTR.children().remove();
                this._renderContentAreaTemplate();
                this._borderAddRemove();
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") this._horizontalRender();
                this._renderScroller();
                this.element.find(".e-ampmdisplay").outerHeight(this.element.find(".e-workcells")[0].offsetHeight);
                (this.model.workHours.highlight) ? this._highlightBusinessHours() : this.element.find(".e-workcells").addClass("e-businesshighlightworkcells");
                this._businessHourScroller();
                if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
                this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
                this._renderAppointmentAll();
                if (this.model.blockoutSettings.enable) {
                    (this.model.blockoutSettings.dataSource instanceof ej.DataManager) ? this._bindBlockData() : this._renderBlockAppointments();
                }
            }
        },

        _renderInitSchedule: function () {
            this.element.addClass("e-scheduleouter");
            this._screenOrientation = window.orientation;
            this._quickWindow = this.model.showQuickWindow;
            this._customOrientation = this.model.orientation;
            var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
            this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : ((document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile()) && this.model.isResponsive);
            (this._mediaQuery) ? this.element.addClass("e-scheduleresponsive") : this.element.removeClass("e-scheduleresponsive");
            (this._mediaQuery) && (this.model.showQuickWindow = false);
            (this._mediaQuery) && (this.model.allowInline = false);
            (ej.isNullOrUndefined(this._clientWidth)) && (this._clientWidth = this.model.width);
            this.currentView(this.currentView().toLowerCase());
            this.model.views = (this.model.views.length == 0) ? this.currentView().toString().toLowerCase().split(",") : this.model.views.toString().toLowerCase().split(",");
            this.model.workWeek = (this.model.workWeek == "" || this.model.workWeek == null) ? this._dayNamesArray : this.model.workWeek;
            this._resWorkWeek = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showWeekend && this.currentView() == "workweek" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]));
            this._resCustomView = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showWeekend && this.currentView() == "customview" && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]));
            if (this.model.endHour > 24) this.model.endHour = 24;
            if (this.model.startHour < 0) this.model.startHour = 0;
            var culture = ej.preferredCulture(this.model.locale);
            this._timeMode = (this.model.timeMode == null) ? (culture.calendar.AM == null && culture.calendar.PM == null) ? "24" : "12" : this.model.timeMode == "Hour12" ? "12" : this.model.timeMode == "Hour24" ? "24" : (culture.calendar.AM == null && culture.calendar.PM == null) ? "24" : this.model.timeMode;
            if (this.model.timeMode == null) { this._pattern = culture.calendar.patterns; }
            else this._pattern.t = (this._timeMode == "12") ? "h:mm tt" : "HH:mm";
            this._firstdayofweek = (this.model.firstDayOfWeek != null) ? (typeof this.model.firstDayOfWeek == "string") ? this._dayNamesArray.indexOf(this.model.firstDayOfWeek.toString().toLowerCase()) : this.model.firstDayOfWeek : culture.calendar.firstDay;
            this.model.workWeek = this.model.workWeek.toString().toLowerCase().split(",");
            this.model.width = this.model.width ? this.element.width(this._clientWidth).width() : this.element.width();
            this.model.height = this.model.height ? this.element.height(this.model.height).height() : this.element.height();
            this.scWidth = this._scWidth ? parseInt(this._scWidth) : parseInt(this.model.width);
            this.scHeight = this._scHeight ? parseInt(this._scHeight) : parseInt(this.model.height);
            (this.currentDate() < this.model.minDate) && this.currentDate(this.model.minDate);
            (this.currentDate() > this.model.maxDate) && this.currentDate(this.model.maxDate);
            this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) == -1 && this.currentView(this.model.views[0].toLowerCase());
            this._getRenderDates();
            this.element.css({ width: this._clientWidth, height: this.model.height }).attr({ role: "presentation", tabIndex: 1 });
            var orientationClass = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? "e-vertical" : "e-horizontal";
            var $scheduleDiv = ej.buildTag('div.e-scheduleinner ' + orientationClass, "", {}, {}).css({ height: this.scHeight - 2 + "px", position: "relative" });
            var $scheduleTable = ej.buildTag('table.e-table', "", {}, {}).addClass("e-scheduleoutertable");
            var $tBody = ej.buildTag('tbody');
            this.hTR = ej.buildTag("tr.e-scheduleheader");
            this.aTR = ej.buildTag("tr.e-headerarearow");
            this.wTR = ej.buildTag("tr.e-contentarearow");
            (!this.model.cellHeight) ? this.wTR.addClass("e-celldefaultheight") : this.wTR.removeClass("e-celldefaultheight");
            this._renderTemplates();
            this.model.showHeaderBar && this._renderHeaderBar(this.hTR);
            this._renderHeaderAllDayTemplate();
            this._renderContentAreaTemplate();
            $scheduleDiv.append($scheduleTable.append($tBody.append(this.hTR).append(this.aTR).append(this.wTR)));
            (this._mediaQuery && this.res1.length > 1) && this.element.addClass("e-resources");
            this._renderToolTip();
            this.element.append($scheduleDiv);
            !this.model.showHeaderBar && this.element.find(".e-scheduleheader").hide();
            if (this.model.showHeaderBar) {
                this.hTR.find(".e-commonviewbutton.e-" + this.currentView()).addClass("e-activeview");
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ startDay: this._firstdayofweek, enableRTL: this.model.enableRTL, buttonText: this._getLocalizedLabels("Today"), select: $.proxy(this._onselect, this), locale: this.model.locale, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
                this.element.find("span.e-datewidget").css("display", "none");
            }
            (this._mediaQuery || this.element.width() < 600) && this._renderNavigationDrawer();
            this._showContextMenu(this.model.contextMenuSettings.enable);
            var scheduleResponsive = $("#" + this._id + "AppointmentAddEditWindow_wrapper,#" + this._id + "RecurrenceEdit_wrapper,#" + this._id + "navDrawer,#" + this._id + "alertWindow_wrapper");
            (this._mediaQuery) ? scheduleResponsive.addClass("e-scheduleresponsive") : scheduleResponsive.removeClass("e-scheduleresponsive");
            if (this._mediaQuery) this._phoneChanges();
            if (this.model.enableRTL && this._browserInfo.name == "webkit" && !ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".e-chk-image").css("margin-right", "-13px");
            this._renderCommon();
        },

        _addMonthNameRow: function () {
            var dateRender = $.extend(true, [], this._dateRender);
            dateRender.sort();
            if (new Date(dateRender[0]).getMonth() != new Date(dateRender[dateRender.length - 1]).getMonth() || new Date(dateRender[0]).getFullYear() != new Date(dateRender[dateRender.length - 1]).getFullYear()) {
                var isRangeInYear = new Date(dateRender[0]).getFullYear() == new Date(dateRender[dateRender.length - 1]).getFullYear();
                var result = $.grep($(".e-monthnamerow"), function (value) { if ($(value).hasClass("e-monthnamerow")) { return value; } });
                if (result.length != 0) $(".e-monthnamerow").remove();
                var $monthNameRow = "<tr class='e-monthnamerow'>";
                if (this._resCustomView) {
                    for (var i = 0; i < Object.keys(this._resCustomDate).length; i++) {
                        var resDateRender = this._resCustomDate[i];
                        var temp = resDateRender.map(function (time) { return new Date(time).getMonth() + "," + new Date(time).getFullYear(); });
                        var sortTemp = $.unique(resDateRender.map(function (time) {
                            return new Date(time).getMonth() + "," + new Date(time).getFullYear();
                        }));
                        var count = {};
                        temp.forEach(function (i) {
                            count[i] = (count[i] || 0) + 1;
                        });
                        for (var a = 0, len = sortTemp.length; a < len; a++) {
                            $monthNameRow += "<td class='e-monthrow e-monthnamecells' colspan='" + count[sortTemp[a]] + "'>" + "<div class='e-monthnameheadertext'>" + (isRangeInYear ? this._monthNames[sortTemp[a].split(",")[0]] : (this._monthNames[sortTemp[a].split(",")[0]] + " " + sortTemp[a].split(",")[1])) + "</div></td>";
                        }
                    }
                } else {
                    var temp = dateRender.map(function (time) { return new Date(time).getMonth() + "," + new Date(time).getFullYear(); });
                    var sortTemp = $.unique(dateRender.map(function (time) {
                        return new Date(time).getMonth() + "," + new Date(time).getFullYear();
                    }));
                    var count = {};
                    temp.forEach(function (i) {
                        count[i] = (count[i] || 0) + 1;
                    });
                    for (var a = 0, len = sortTemp.length; a < len; a++) {
                        $monthNameRow += "<td class='e-monthrow e-monthnamecells' colspan='" + count[sortTemp[a]] + "'>" + "<div class='e-monthnameheadertext'>" + (isRangeInYear ? this._monthNames[sortTemp[a].split(",")[0]] : (this._monthNames[sortTemp[a].split(",")[0]] + " " + sortTemp[a].split(",")[1])) + "</div></td>";
                    }
                }
                $monthNameRow += "</tr>";
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && dateRender.length > 7) {
                    $($monthNameRow).insertBefore(this.element.find(".e-headerdays").find("tr:first"));
                    this.element.find(".e-horizontalmonthtimecellsht").addClass("e-monthheaderrow");
                    if (this.element.find(".e-horizontaltimecellsht").length > 0)
                        this.element.find(".e-horizontaltimecellsht").addClass("e-monthheaderrow");

                } else {
                    $($monthNameRow).insertBefore(this.element.find(".e-dateheader"));
                    this.element.find(".e-headrealldaytable").addClass("e-monthheaderrow");
                    this.element.find(".e-headercellsheight").addClass("e-monthheaderrow");
                }
                if (this.element.find(".e-monthnameleftindentcell").length == 0) {
                    var $monthNameLeftIndentRow = "<tr><td class='e-monthnameleftindentcell e-headercellsheight'><div></div></td></tr>";
                    $($monthNameLeftIndentRow).insertBefore(this.element.find(".e-settingsindent").parent());
                }
                if (this.model.enableRTL)
                    this.element.find(".e-monthnamerow td:first-child").css("border-right", "none");
                else
                    this.element.find(".e-monthnamerow td:first-child").css("border-left", "none");
            }
        },

        _renderToolTip: function () {
            var proxy = this;
            if (ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                var target = this.model.tooltipSettings.enable ? ".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendacells.e-eventcolumn,.e-appup,.e-appdown,.e-appsoverflow" : ".e-appup,.e-appdown,.e-appsoverflow";
                this.element.ejTooltip({
                    target: target,
                    associate: "mousefollow",
                    isBalloon: false,
                    beforeOpen: function (args) {
                        if (!proxy._showToolTip(args)) {
                            args.cancel = true;
                            proxy._openTooltip = false;
                        } else
                            proxy._openTooltip = true;
                    },
                    containment: "#" + this._id,
                    tip: {
                        adjust: {
                            xValue: 20,
                            yValue: 20
                        }
                    },
                    position: {
                        target: { horizontal: "center", vertical: "bottom" },
                        stem: { horizontal: "left", vertical: "top" }
                    },
                    tracking: function (args) {
                        if (!proxy._openTooltip || $(args.event.target).is(".e-tophandle,.e-bottomhandle,.e-schedulemouseclose,.e-righthandle,.e-lefthandle,.e-schedulerepeat,.e-editapp,.e-deleteapp")) {
                            args.cancel = true;
                            this.hide();
                        }
                    }
                });
            }
        },

        _renderQuickWindow: function () {
            if (this.model.showQuickWindow) {
                this._renderQuickAppWindow();
                this._renderQuickAppDetailsView();
            }
        },

        _renderDialogs: function () {
            this._renderQuickWindow();
            this._renderAppointmentWindow();
            this._renderRecurrenceEditor();
            this._renderRecurEditWindow();
            this._renderAlertWindow();
        },

        _renderCommon: function () {
            if (this.currentView() != "agenda") {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    this._headerbarWidth();
                    (this.currentView() === "month" || (this._isCustomMonthView())) && this._renderMonthTimeCells();
                    if (!this.model.timeScale.enable) {
                        this.element.find(".e-headercells").first("td").css("border-left", "none");
                        this.element.find(".e-workcellstab tr td:first-child").css("border-left", "none");
                    }
                    // if (!this.model.showAllDayRow && this.model.cellWidth) {
                    //     this.element.find(".e-workcellstab tr td:first-child").css({ width: this.element.find(".e-headercells").width() });
                    // }
                    this.element.find(".e-schedulesettings").html(this._getLocalizedLabels("AllDay"));
                    if (this.element.find(".e-ampmdisplay").length > 0) {
                        this.element.find(".e-ampmdisplay").css({ outerHeight: this.element.find(".e-workcells")[0].offsetHeight });
                    }
                }
                if (this.currentView() != "agenda" && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0))) {
                    var border = this.model.enableRTL ? 'border-right' : 'border-left';
                    this.element.find(".e-horizontaldaterender").css(border, '0px');
                    this.wTR.find(".e-workareadiv").parent().css(border, '0px');
                    if (!this.model.timeScale.enable && this.currentView() !== "month" && !this._isCustomMonthView()) this.element.find(".e-workcellstab tr td:nth-child(1)").css(border, '0px');
                }
                this.model.enableRTL && this.element.addClass("e-rtl");
                (this.model.timeScale.enable) && this._borderAddRemove();
                (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? (this.currentView() !== "month" && !(this._isCustomMonthView())) ? this.element.find(".e-headercells").addClass("e-dateheaderselect") : "" : this.element.find(".e-headercells").addClass("e-dateheaderselect");
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (this.currentView() == "month" || this._isCustomMonthView()) && this.element.find('.e-workcells').width() < this.element.find('.e-dateheadercell').width() && this.model.cellWidth == "")
                    this.model.timeScale.enable ? this.element.find('.e-workcells').css({ width: this.element.find('.e-horizontmonthheaderdaytd').width() }) : this.element.find(".e-headerdays table tr td:nth-child(1)").css({ width: this.element.find('.e-horizontmonthheaderdaytd').width() + 1 });
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && !this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView() && this.model.cellWidth == "") {
                    this.element.find(".e-horizontmonthheaderdatetd,.e-horizontmonthheaderdaytd").width(this.element.find(".e-workcells").width());
                }
                this.element.find(".e-horizontalresheader").css({ width: (this._mediaQuery) ? "50px" : "100%" });
                if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                    this._addMonthNameRow();
                    this.element.find(".e-datecommondiv").addClass("e-datecursor");
                }
                this._renderScroller();
                if (this.model.showAppointmentNavigator && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery)) this._renderUpDownIcon();
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")
                    this._horizontalRender();
                else {
                    if (!this.model.showOverflowButton && this.currentView() == "month")
                        this._monthCellsRender();
                    else
                        this.currentView() == "month" || (this._isCustomMonthView()) ? this.element.find(".e-monthcells, .e-timecells").outerHeight(this.model.cellHeight ? parseInt(this.model.cellHeight) + 1 : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length)) :  (this.model.timeScale.enable) && this.element.find(".e-ampmdisplay").outerHeight((this.model.timeScale.minorSlotCount == 1) ? this.element.find(".e-timecelldivs")[0].offsetHeight : this.element.find(".e-workcells")[0].offsetHeight);
                }
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal) {
                    if (!this.model.timeScale.enable)
                        this.element.find(".e-headercells").removeClass("e-dateheaderselect");
                    if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0)
                        this._horizontalResIcon();
                    if (this.model.timeScale.enable && !ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && this.currentView() != "month" && !this._isCustomMonthView())
                        this.element.find(".e-headercells").parent().parent().parent().css("width", ((this.element.width() * 10) / 100) * this._dateRender.length + "px");
                    this.element.find(".e-parentnodecategory").css({ width: (this._mediaQuery) ? "12px" : "20px" });
                }
                else {
                    if (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId))
                        this.element.find(".e-leftindent").css({ height: this.element.find(".e-alldaycells").height() });
                }
                (this.model.workHours.highlight && this.model.highlightBusinessHours) ? this._highlightBusinessHours() : this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                if (this.model.timeScale.enable && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && (this.currentView() == "month" || this._isCustomMonthView())){
                    if ((!this._resWorkWeek && this._dateRender.length > 60) || ($.isNumeric(this.element.find(".e-monthcells")[0].offsetHeight) && (this.element.find(".e-monthcells")[0].offsetHeight != this.element.find(".e-timecells")[0].offsetHeight && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showOverflowButton))) this.element.find('td.e-timecells .e-timecelldivs').addClass('e-timedivcells');
                    if ((!this._resCustomView && this._dateRender.length > 60) || ($.isNumeric(this.element.find(".e-monthcells")[0].offsetHeight) && (this.element.find(".e-monthcells")[0].offsetHeight != this.element.find(".e-timecells")[0].offsetHeight && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showOverflowButton))) this.element.find('td.e-timecells .e-timecelldivs').addClass('e-timedivcells');
                }
                if ((this.model.orientation == ej.Schedule.Orientation.Vertical && this._customOrientation == "vertical") && this._isCustomMonthView() && this.model.timeScale.enable) {
                    (this.element.find(".e-timecelldivs")[0].offsetHeight >= this.element.find(".e-timecelldivs").parent()[0].offsetHeight) && this.element.find(".e-timecelldivs").addClass("e-timedivcells");
                }
                ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this._safariBrowser) && this.element.find(".e-workcells.e-dayend").width(this.element.find(".e-workcells.e-dayend").outerWidth() + 1);
                if (this._browserInfo.name == "msie" && this._browserInfo.version < 9 && (this.model.orientation == "vertical" && this._customOrientation == "vertical")) {
                    this.element.find(".e-workleftindent").find("tr").last().find("td").addClass("e-lastcell");
                    this.element.find(".e-workcellstab").find("tr").last().find("td").addClass("e-lastcell");
                }
            }
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            this._validateMinMaxDate();
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("emptycell");
            this._businessHourScroller();
        },

        _resourceSegregate: function () {
            var resourceFields = ""; this._tempResource = []; this._grouping = [];
            if (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) {
                for (var i = 0; i < this.model.group.resources.length; i++) {
                    var index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i], null, null);
                    if (!ej.isNullOrUndefined(index)) {
                        if (this.model.resources.length != 0 && this.model.resources[index].resourceSettings.dataSource.length != 0) {
                            this._tempResource.push(this.model.resources[index]);
                            this._grouping.push(this.model.group.resources[i]);
                            if (i == this.model.group.resources.length - 1)
                                resourceFields = resourceFields + this.model.resources[index].field;
                            else
                                resourceFields = resourceFields + this.model.resources[index].field + ",";
                        }
                        else
                            return false;
                    }
                }
                this._appointmentSettings.resourceFields = resourceFields;
            }
            else if (ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) {
                $.merge(this._tempResource, this.model.resources);
            }
        },
        _borderAddRemove: function () {
            if (!this.model.enableRTL) {
                this.element.find(".e-headrealldaytable tr td:first-child,.e-workcellstab tr td:first-child,.e-headerdays table tr td:first-child").css("border-left", "none");
                this.element.find(".e-horizontalheader,.e-horizontalrestd,.e-monthleftindent,.e-workleftindent,.e-empty").addClass("e-borderright");
            }
            else {
                this.element.find(".e-headrealldaytable tr td:first-child,.e-workcellstab tr td:first-child,.e-headerdays table tr td:first-child").css("border-right", "none");
                this.element.find(".e-horizontalheader,.e-horizontalrestd,.e-monthleftindent,.e-workleftindent,.e-empty").addClass("e-borderleft");
            }
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                if (this.currentView() == "month")
                    this.element.find(".e-headerdays table tr td:first-child").width(this.element.find(".e-workcellstab tr td:first-child").width());
                else if (this._browserInfo.name == "webkit")
                    this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-horizontaltimetd").first().width());
            }
            else {
                // if (this.model.cellWidth != "")
                //     this.element.find(".e-workcellstab tr td:first-child").width(this.element.find(".e-headercells").first().width());
                this._safariBrowser && (this.currentView() == "month" ? this.element.find(".e-monthleftindent").width(this.element.find(".e-monthempty").width() + 1) : this.element.find(".e-workleftindent").attr('style', "width:" + (this.element.find(".e-empty").width() + 1) + "px !important"));
            }
            if (!ej.isNullOrUndefined(this.oldDate) && this.oldDate != "") {
                this.currentDate(new Date(this.oldDate));
                this.oldDate = "";
            }
        },
        _phoneChanges: function () {
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                this._appointmentAddWindow.ejDialog({
                    allowDraggable: false,
                    position: { X: "0", Y: "0" }
                });
            }
        },
        _dateConvert: function (dtstr) {
            if (!ej.isNullOrUndefined(dtstr)) {
                var convdt = new Date(parseInt(dtstr.match(/\d+/).toString()));
                convdt = $.type(convdt) == "date" ? convdt : new Date();
            }
            else
                convdt = null;
            return convdt;
        },
        _calculateCustomDays: function () {
            if ($.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) {
                this.oldDate = this.currentDate();
                if ($.type(this.model.renderDates[0]) == "object") {
                    var customLength = this.model.renderDates.length;
                    if (ej.isNullOrUndefined(this._renderDays)) {
                        this._renderDays = 0;
                        for (var i = 0; i < customLength; i++) {
                            this._renderDays = this._renderDays + Math.round(Math.abs((new Date(ej.format(this.model.renderDates[i].end, this._datepattern(), this.model.locale)).getTime() - new Date(ej.format(this.model.renderDates[i].start, this._datepattern(), this.model.locale)).getTime()) / (24 * 60 * 60 * 1000)) + 1);
                        }
                    }
                } else {
                    this._renderDays = this.model.renderDates.length;
                }
                this._customOrientation = this._renderDays > 7 ? "horizontal" : this.model.orientation;
            } else {
                var startdate = $.type(this.model.renderDates.start) != "date" ? ej.parseDate(this.model.renderDates.start, this._datepattern()) : new Date(this.model.renderDates.start);
                startdate = (!ej.isNullOrUndefined(startdate)) ? startdate : ((new Date(this.model.renderDates.start).toString() == "Invalid Date" || new Date(this.model.renderDates.start).toString() == "NaN") ? this._dateConvert(this.model.renderDates.start) : new Date(this.model.renderDates.start));
                var enddate = $.type(this.model.renderDates.end) != "date" ? ej.parseDate(this.model.renderDates.end, this._datepattern()) : new Date(this.model.renderDates.end);
                enddate = (!ej.isNullOrUndefined(enddate)) ? enddate : ((new Date(this.model.renderDates.end).toString() == "Invalid Date" || new Date(this.model.renderDates.end).toString() == "NaN") ? this._dateConvert(this.model.renderDates.end) : new Date(this.model.renderDates.end));;
                if (!ej.isNullOrUndefined(this.model.minDate) && !ej.isNullOrUndefined(this.model.maxDate)) {
                    startdate = (this.model.minDate >= startdate && this.model.maxDate <= startdate) ? startdate : (this.model.minDate >= startdate && this.model.maxDate >= startdate) ? this.model.minDate : (this.model.maxDate <= startdate) ? this.model.minDate : startdate;
                    enddate = (this.model.minDate >= enddate && this.model.maxDate <= enddate) ? enddate : (this.model.minDate <= enddate && this.model.maxDate <= enddate) ? this.model.maxDate : (this.model.minDate >= enddate) ? this.model.maxDate : enddate;
                }
                this._renderStart = !ej.isNullOrUndefined(startdate) ? new Date(startdate.getFullYear(), startdate.getMonth(), startdate.getDate()) : enddate;
                this._renderEnd = !ej.isNullOrUndefined(enddate) ? new Date(enddate.getFullYear(), enddate.getMonth(), enddate.getDate()) : startdate;
                this._renderDays = Math.round((this._renderEnd - this._renderStart) / (1000 * 60 * 60 * 24)) + 1;
                this.oldDate = this.currentDate();
                if (this._dateNavigation || (this._renderStart.getTime() > this.currentDate().getTime()) || (this._renderEnd.getTime() < this.currentDate().getTime())) {
                    this._renderStart = new Date(this.currentDate());
                    this._renderEnd = new Date(this._renderStart.getTime() + (1000 * 60 * 60 * 24 * (this._renderDays - 1)));
                    this._dateNavigation = false;
                }
                else
                    this.currentDate(new Date(this._renderStart));
                if (this._renderDays > 7) {
                    var firstDay = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? new Date(this._firstweekdate(this._renderStart)) : new Date(this._renderStart);
                    var endDay = new Date(this._renderEnd); var day = endDay.getDay();
                    (this._firstdayofweek == 0 && day != 6) ? endDay.setDate(new Date(this._renderEnd).getDate() + (6 - day)) : endDay.setDate(new Date(this._renderEnd).getDate() + (6 - day) + this._firstdayofweek);
                    endDay = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? endDay : new Date(this._renderEnd);
                    this._numDays = Math.round((endDay - firstDay) / (1000 * 60 * 60 * 24)) + 1;
                }
            }
            return this;
        },

        _isCustomMonthView: function () {
            if (this.currentView() == "customview" && !this._resCustomView) {
                this._oneWeek = (this._dateRender.length > 7) ? false : true;
                return !this._oneWeek;
            }
            return false;
        },

        _headerbarWidth: function () {
            if (this.element.children().length == 0) return false;
            var cols = this.currentView() == "workweek" ? this.model.workWeek.length : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 7;
            var col = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? (this.res1.length * cols) : cols;
            var border = this.element.outerWidth() - (this.element.find('.e-draggableworkarea').offset().left - this.element.offset().left) < parseInt(this.model.cellWidth) * col ? 1 : 0;
            // if (this._browserInfo.name == "webkit")
            //     this.aTR.find(".e-headrealldaytable").width(this.model.cellWidth ? (parseInt(this.model.cellWidth) * col + (border ? 0 : col)) : "100%");
            // else
            //     this.aTR.find(".e-headrealldaytable").width(this.model.cellWidth ? (parseInt(this.model.cellWidth) * col) + col : "100%");
        },
         
        _deviceRatio: function() {
            return (ej.browserInfo().name == "msie") ? screen.deviceXDPI / screen.logicalXDPI : devicePixelRatio;
        },

        _renderScroller: function () {
            if (this.element.children().length == 0) return false;
            var _scrollDiv = this.element.find("div#" + this._id + "_scroller");
            var tempHght = this.scHeight - (this.element.find(".e-draggableworkarea").offset().top - this.element.offset().top);
            var hghtdiff = ((Math.ceil(this._deviceRatio()) - 1) > 0) ? tempHght - 1 : tempHght;
            var proxy = this;
            var scrollWidth = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() - 1 : this.element.width();
            _scrollDiv.ejScroller({
                enableRTL: this.model.enableRTL, height: (hghtdiff - 1), width: parseInt(scrollWidth) - 2, cssClass: this.model.cssClass,
                thumbStart: function (e) {
                    var target = $(e.originalEvent.target);
                    if (!proxy._mediaQuery && !ej.isTouchDevice() && target.closest(".e-workcells").hasClass("e-workcells") || target.closest(".e-appointment").hasClass("e-appointment") || target.closest(".e-monthappointment").hasClass("e-monthappointment") || target.closest(".e-categorybar").hasClass("e-categorybar")) return false;
                },
                scroll: function (e) {
                    !ej.isNullOrUndefined(e.scrollTop) && (e.scrollTop = parseInt(e.scrollTop));
                    var scrollerObj = proxy.element.find('div#' + proxy._id + "_scroller").data("ejScroller");
                    if ((scrollerObj.isVScroll()) || (scrollerObj.isHScroll())) {
                        (proxy.model.orientation === "vertical" && proxy._customOrientation === "vertical") ? proxy.element.find(".e-scrolltimecells").css("top", (-e.scrollTop) + "px") : (proxy.model.timeScale.enable && proxy.currentView() !== "month" && !(proxy._isCustomMonthView())) ? $(proxy.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-e.scrollLeft) + "px") : proxy.element.find(".e-headerdays").css("left", (-e.scrollLeft) + "px");
                        if (proxy.element.find('.e-vhandle').length == 1)
                            proxy.element.find(".e-horires").css("top", (-e.scrollTop) + "px");
                        if (proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") {
                            proxy.element.find(".e-headrealldaytable").css("left", (proxy.model.enableRTL) ? (e.scrollData.scrollable - e.scrollLeft) : (-e.scrollLeft) + "px");
                            var timeWidth = proxy.element.find(".e-scrolltimecells").width() - 3;
                            proxy.element.find(".e-upicon, .e-downicon").css("left", -(e.scrollLeft - timeWidth) + "px");
                            if (proxy._timeMode == "12" && (proxy.currentView() !== "month" && !(proxy._isCustomMonthView()))) {
                                var top = (e.scrollTop / (proxy.element.find(".e-workcells").height() * proxy.model.timeScale.minorSlotCount));
                                top = (Math.round(top) < top) ? Math.round(top) + 1 : Math.round(top);
                                var localizeAmPm = ej.preferredCulture(proxy.model.locale).calendar;
                                if (localizeAmPm.AM && localizeAmPm.PM) {
                                    proxy.element.find('.e-idAmpmstyle').each(function (i, val) {
                                        if (i == (top) && $(val).text().trim() == "00")
                                            (parseInt($(val)[0].id) < 12) ? $(val).text(localizeAmPm.AM[0]) : $(val).text(localizeAmPm.PM[0]);
                                        else if (($(val).text() == localizeAmPm.AM[0] && i > 0) || ($(val).text() == localizeAmPm.PM[0] && parseInt($(val)[0].id) > 12))
                                            $(val).text("00");
                                    });
                                }
                            }
                            if (proxy._mediaQuery) {
                                proxy.element.find(".e-headrealldaytable").css("left", "0px");
                            }
                            if (proxy.model.showAppointmentNavigator && (proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") && scrollerObj.isVScroll() && proxy.currentView() != "month" && (!proxy._isCustomMonthView()) && (!proxy._mediaQuery)) {
                                proxy._renderUpDownIcon();
                                proxy._renderUpDownIconPosition();
                            }
                        }
                        else if (ej.scheduleFeatures.horizontal && (proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal"))
                            proxy._horizontalScroll(e, proxy);
                    }
                    if (!(ej.isNullOrUndefined(proxy._quickAppointWindow)) && proxy.model.showQuickWindow && !proxy._isQuickDialogOpened) {
                        proxy._isQuickDialogOpened = false;
                        proxy._quickAppointWindow.ejDialog("close");
                        proxy._quickAppDetailsWindow.ejDialog("close");
                    }
                }
            });
            (!this._mediaQuery) && this._nextPrevAppointment(this.model.showAppointmentNavigator);
            this._renderHoriVerticalScroll();
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            this._showScrollTd();
        },

        _showScrollTd: function () {
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            var tdwidth = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") ? "16px" : "17px";
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                if (this.element.find(".e-vscroll").length > 0) {
                    this.element.find(".e-scheduleheader td").first().attr("colspan", "3");
                    this.element.find(".e-workareadiv").parent().attr("colspan", "2");
                    if (this.element.find(".e-emptyscrolltd").length == 0)
                        this.aTR.append(ej.buildTag("td.e-emptyscrolltd", "", {}, {}).css({ width: (this._mediaQuery) ? "0px" : "16px" }));
                    this.element.find(".e-emptyscrolltd").addClass("e-horizontalemptytd");
                }
                else {
                    this.element.find(".e-scheduleheader td").first().attr("colspan", "2");
                    this.element.find(".e-workareadiv").parent().attr("colspan", "2");
                }
            }
            (this.element.find(".e-vscroll").length > 0) ? this.element.find(".e-emptyscrolltd").addClass(border).css("width", tdwidth).show() : this.element.find(".e-emptyscrolltd").removeClass(border).css("width", "0px").hide();
        },
        _renderHoriVerticalScroll: function () {
            var _scrollDiv = this.element.find("div#" + this._id + "_scroller");
            var scrollWidth = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find(".e-scrolltimecells").length > 0 ? this.element.find(".e-scrolltimecells").parent().outerWidth() : 0)) : (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
            scrollWidth = parseInt(scrollWidth) - 1;
            var hghtdiff = parseInt(this.scHeight) - (this.element.find(".e-draggableworkarea").offset().top - this.element.offset().top);
            var vScrollBarWidth = _scrollDiv.ejScroller("isVScroll") ? 18 : 0, hScrollBarWidth = _scrollDiv.ejScroller("isHScroll") ? 18 : 0;
            this.element.find(".e-headeralldaydiv").width(this.element.find(".e-draggableworkarea").width());
            (!ej.isNullOrUndefined(this.model.group) && this.currentView() != "day" && this.model.timeScale.enable) && this.element.find(".e-headrealldaytable").css("table-layout","auto");
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                if (this.model.cellWidth || this.model.cellHeight) {
                    // (this.currentView() == "day") && this.element.find(".e-headerdaydisplay").css("width", this.model.cellWidth);
                    (this.model.cellHeight && !this.model.cellWidth) && this.element.find(".e-headrealldaytable").css("table-layout","");
                    var overallWidth = (parseInt(this.model.cellWidth) + 1) * (this.element.find("div.e-draggableworkarea tr:first td").length);
                    var overallHeight = parseInt(this.model.cellHeight) * (this.element.find("div.e-draggableworkarea tr").length);
                    var timeScaleWidth = this.element.find(".e-scrolltimecells").length > 0 ? this.element.find(".e-scrolltimecells").width() : 0;
                    this.element.find(".e-draggableworkarea").width((this.element.width() > overallWidth + timeScaleWidth + vScrollBarWidth) ? overallWidth - 1 : scrollWidth - 1 - vScrollBarWidth);
                    (!this.model.cellHeight) ? this.element.find(".e-draggableworkarea").height(hghtdiff - 1 - hScrollBarWidth) : this.element.find(".e-draggableworkarea").height(hghtdiff > overallHeight ? overallHeight : hghtdiff - 1 - hScrollBarWidth);
                    (this.model.cellWidth) && this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                    if (this.currentView() != "month" && !this._isCustomMonthView()) {
                        this.element.find(".e-workcells").css("width", this.model.cellWidth);
                        // this.element.find(".e-headrealldaytable").css("width", overallWidth - 1);
                    }
                }
                else {
                    this.element.find(".e-headrealldaytable").css("table-layout","");
                    this.element.find(".e-draggableworkarea").height(hghtdiff - 1);
                    if (!this.model.showOverflowButton && (this.currentView() == "month" || this._isCustomMonthView())) this._monthCellsRender();
                    this.element.find(".e-draggableworkarea").width(scrollWidth - 1 - vScrollBarWidth);
                }
                this.element.find(".e-timecells").height(this.element.find(".e-workcells").height() * this.model.timeScale.minorSlotCount + (this.model.timeScale.minorSlotCount - 1));
                this.element.find(".e-headrealldaytable").width((this.model.cellWidth) ? "" : "100%");
                var cellWidth = (this.model.cellWidth) ? this.model.cellWidth : this.element.find(".e-workcells,.e-monthcells").width() + "px";
                cellWidth = (ej.browserInfo().name == "webkit" && this.currentView() != "day") ? (parseFloat(cellWidth) - 1) + "px" : cellWidth;
                (((this._tempResource.length > 1) && (!ej.isNullOrUndefined(this.model.group))) || this.model.cellWidth) && this.element.find(".e-headercells").css({ "width": cellWidth, "min-width": cellWidth, "max-width": cellWidth });
                (ej.isNullOrUndefined(this.model.group) || this.model.cellWidth || this.currentView() == "day") && this.element.find(".e-headrealldaytable").css("width", overallWidth - 1)
                if (this._mediaQuery && this.res1.length > 1) {
                    var headerWorkarea = this.element.find(".e-draggableworkarea").width() * this.res1.length;
                    this.element.find(".e-draggableworkarea").width(headerWorkarea);
                    this.element.find(".e-headrealldaytable").width(headerWorkarea);
                }
                this.element.find(".e-e-headeralldaydiv").width(this.element.find(".e-draggableworkarea").width());
                (this._browserInfo.name == "chrome") ? this.element.find(".e-scrolltimecells").height(this.element.find('.e-workcellstab').height()): this.element.find(".e-scrolltimecells").height(this.element.find('.e-workcellstab').height() - 1);
                if (this.model.timeScale.enable && (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId))) {
                    this.element.find(".e-scrolltimecells tr").height(this.element.find(".e-workcells,.e-monthcells").outerHeight());
                }
                this.element.find(".e-ampmstyle").css({ minHeight: ((this.model.timeScale.enable && this._mediaQuery && this.currentView() != "month") ? this.element.find(".e-workcells").height() : 0) + "px" });
            }
            else {
                (!this.model.timeScale.enable) && this.element.find(".e-workcellstab tr td:first-child").css("border-left", "none");
                !(_scrollDiv.ejScroller("isHScroll")) ? this.element.find(".e-draggableworkarea").css("height", "100%") && this.element.find(".e-resfootertr").css("height", "0px") : "";
                !(_scrollDiv.ejScroller("isVScroll")) ? this.element.find(".e-draggableworkarea").css("height", hghtdiff - 19) : "";
                if (this._mediaQuery) {
                    this.element.find(".e-horizontresdiv").height(_scrollDiv.height());
                    this.element.find(".e-draggableworkarea").children().height("100%");
                    this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
                    this.element.find(".e-horires").children().height("100%");
                }
                if (this.model.cellWidth || this.model.cellHeight) {
                    var count = $(this.element.find(".e-workcells")[0]).parent().find("td").length;
                    !(_scrollDiv.ejScroller("isHScroll")) ? this.element.find(".e-draggableworkarea").width((parseInt(this.model.cellWidth) * count) + (count - 1)) : "";
                    (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) && this.element.find(".e-headerdays").children().css("width", (this.element.find(".e-draggableworkarea").children().width() + "px")).css("table-layout", "auto");
                    (this.model.cellHeight && !this._tempResource) && this.element.find('.e-draggableworkarea').height(parseInt(this.model.cellHeight) - 1);
                }
                if (!(!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0)) {
                    if (this.currentView() == "month" || this._isCustomMonthView()) {
                        this.element.find(".e-headerdays table tr td:first-child").width(this.element.find(".e-workcellstab tr td:first-child").width());
                    }
                    else {
                        this.element.find(".e-workcellstab").width(this.element.find(".e-workcellstab tr:first-child").children().length * ((this.model.cellWidth) ? parseInt(this.model.cellWidth) : this.element.find(".e-workcells,.e-monthcells").outerWidth()));
                    }
                }
                //Temp if scroll left issue fixed need to remove
                this.currentView() == "day" && this.model.timeScale.enable && $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
                this.element.find('.e-horizontaltabletimecell').width(this.element.find('.e-workcellstab').width());
                if (this.model.timeScale.enable && !_scrollDiv.ejScroller("isHScroll") && this.currentView() != "month" && !this._isCustomMonthView()) {
                    var width = Math.floor(this.element.find(".e-draggableworkarea").width() / $(this.element.find(".e-workcells")[0]).parent().find("td").length);
                    this.element.find(".e-workcells").width(width);
                    this.element.find(".e-horizontaltabletimecell").find("tr td").width(width);
                    this.element.find(".e-horizontaltabletimecell").css("table-layout", "fixed").width(this.element.find('.e-draggableworkarea').width());
                    _scrollDiv.ejScroller("refresh");
                }
                if (!this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                    if (!this.model.cellWidth && this._browserInfo.name != "webkit") {
                        // this.element.find(".e-dateheadercell").width(this.element.find(".e-workcells").width());
                        this.element.find(".e-workcells").width(this.element.find(".e-horizontmonthheaderdaytd").width());
                    }
                    else if (this._browserInfo.name == "webkit" && this.currentView() != "month") {
                        (this.model.cellWidth) && this.element.find(".e-headerdays").width(this.model.cellWidth);
                        this.element.find(".e-workcells").width(this.element.find(".e-draggableworkarea").width / this._dateRender.length);
                        this.element.find(".e-dateheadercell").width(this.element.find(".e-workcells").width());
                        this.element.find(".e-headerdays table tr td:not(:first-child)").find(".e-dateheadercell").width(this.element.find(".e-workcells").width() - 1);
                        this.element.find(".e-workcells").width(this.element.find(".e-workcells").width());
                    }
                }
            }
        },

        _getDayNameIndex: function (day) {
            var dayNames = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
            var cultureNames = [], index = this._firstdayofweek;
            do {
                if (index > 6) index = 0;
                cultureNames.push(dayNames[index]);
                index++;
            } while (cultureNames.length < 7)
            return cultureNames.indexOf(day.capitalizeFirstString());
        },

        _highlightBusinessHours: function () {
            if (this.currentView() == "agenda") return false;
            var viewName = (this._resWorkWeek || this._resCustomView) && this._resWorkWeek ? "workWeek" : "renderDates";
            var resource = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? ((!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings[viewName])) || (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["start"]) || !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["end"]))) : false;
            if (resource) {
                this.element.find(".e-workcells, .e-monthcells").removeClass("e-businesshighlightworkcells e-monthcellhighlight");
                var renderDates, startHour, endHour, resStartHour, resEndHour, noOfHours, startIndex, endIndex, tdLength, colCount, customDays, dayIndex, index, rowFirst, rowLast, dayCount = 0, dateCount = [];;
                var target = this.element.find(".e-workcellstab tr");
                var resources = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this._grouping.length > 1) ? this._resourceSort() : this.res1;
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    for (var i = 0; i < resources.length; i++) {
                        if (!ej.isNullOrUndefined(resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                            customDays = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                        else
                            customDays = this.model.workWeek;
                        if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                            renderDates = this.dateRender;
                            if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["start"]) || !ej.isNullOrUndefined(this._tempResource[this._tempResource.length - 1].resourceSettings["end"])) {
                                resStartHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["start"]];
                                resEndHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["end"]];
                                startHour = !ej.isNullOrUndefined(resStartHour) ? (resStartHour >= this.model.startHour) ? resStartHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour;
                                endHour = !ej.isNullOrUndefined(resEndHour) ? (resEndHour <= this.model.endHour) ? resEndHour : (this.model.workHours.end <= this.model.endHour) ? this.model.endHour : this.model.workHours.end : (this.model.workHours.end <= this.model.endHour) ? this.model.workHours.end : this.model.endHour;
                            }
                            else {
                                startHour = this.model.workHours.start >= this.model.startHour ? this.model.workHours.start - this.model.startHour : 0;
                                endHour = this.model.workHours.end <= this.model.endHour ? this.model.workHours.end - this.model.startHour : this.model.endHour - this.model.startHour;
                            }
                            noOfHours = this.model.endHour - this.model.startHour;
                            startIndex = Math.floor((target.length / noOfHours) * startHour) - (this.model.startHour * this.model.timeScale.minorSlotCount);
                            endIndex = Math.floor((target.length / noOfHours) * endHour) - (this.model.startHour * this.model.timeScale.minorSlotCount);
                            colCount = this.currentView() === "week" ? (this.model.showWeekend) ? 7 : customDays.length : this.currentView() === "workweek" ? customDays.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 1;
                            if (this._resCustomView && this.currentView() === "customview") {
                                colCount = this._resCustomDate[i].length;
                            }
                            for (var a = startIndex; a < endIndex; a++) {
                                for (var b = dayCount; b < (dayCount + colCount) ; b++) {
                                    for (var c = 0; c < customDays.length; c++) {
                                        dayIndex = this._dayNamesArray.indexOf(customDays[c]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(customDays[c]);
                                        }
                                        if (dayIndex == new Date(renderDates[b]).getDay()) {
                                            $($(target[a]).children()[b]).addClass("e-businesshighlightworkcells");
                                        }
                                    }
                                }
                            }
                            dayCount += colCount;
                        }
                        else {
                            if (this._resWorkWeek) {
                                for (var a = 0; a < customDays.length; a++) {
                                    index = this._dayFullNames.indexOf(customDays[a].capitalizeFirstString());
                                    if (index == -1) {
                                        index = this._getDayNameIndex(customDays[a]);
                                    }
                                    dateCount.push(this._renderDates[index]);
                                }
                                renderDates = dateCount;
                            }
                            else renderDates = (this.currentView() != "month" && !this._isCustomMonthView()) ? this.dateRender : this._dateRender;
                            colCount = (this._resWorkWeek) ? customDays.length : (this.currentView() == "day") ? 1 : 7;
                            rowFirst = (this.currentView() != "month" && !this._isCustomMonthView()) ? dayCount : (i * 7);
                            rowLast = (this.currentView() != "month" && !this._isCustomMonthView()) ? (dayCount + colCount) : ((i + 1) * 7);
                            for (var a = 0; a < target.length; a++) {
                                for (var b = rowFirst; b < rowLast; b++) {
                                    for (var c = 0; c < customDays.length; c++) {
                                        dayIndex = this._dayNamesArray.indexOf(customDays[c]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(customDays[c]);
                                        }
                                        if (dayIndex == new Date(renderDates[b]).getDay()) {
                                            !$($(target[a]).children()[b]).hasClass("e-othermonths") ? $($(target[a]).children()[b]).addClass("e-monthcellhighlight") : $($(target[a]).children()[b]).removeClass("e-monthcellhighlight");
                                        }
                                    }
                                }
                            }
                            dayCount += colCount;
                        }
                    }
                }
                else {
                    if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                        renderDates = this._dateRender;
                        for (var i = 0; i < resources.length; i++) {
                            if (resources[i].classname != "e-parentnode") {
                                resStartHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["start"]];
                                resEndHour = resources[i][this._tempResource[this._tempResource.length - 1].resourceSettings["end"]];
                                startHour = !ej.isNullOrUndefined(resStartHour) ? (resStartHour >= this.model.startHour) ? resStartHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour : (this.model.workHours.start >= this.model.startHour) ? this.model.workHours.start : this.model.startHour;
                                endHour = !ej.isNullOrUndefined(resEndHour) ? (resEndHour <= this.model.endHour) ? resEndHour : (this.model.workHours.end <= this.model.endHour) ? this.model.endHour : this.model.workHours.end : (this.model.workHours.end <= this.model.endHour) ? this.model.workHours.end : this.model.endHour;
                                noOfHours = this.model.endHour - this.model.startHour;
                                tdLength = $(target[i]).children().length / renderDates.length;
                                startIndex = Math.floor((tdLength / noOfHours) * startHour);
                                endIndex = Math.floor((tdLength / noOfHours) * endHour);
                                for (var a = 0; a < renderDates.length; a++) {
                                    for (var b = 0; b < this.model.workWeek.length; b++) {
                                        dayIndex = this._dayNamesArray.indexOf(this.model.workWeek[b]);
                                        if (dayIndex == -1) {
                                            dayIndex = this._getDayNameIndex(this.model.workWeek[b]);
                                        }
                                        if (dayIndex == new Date(renderDates[a]).getDay()) {
                                            for (var c = ((tdLength * a) + startIndex) ; c < ((tdLength * a) + endIndex) ; c++) {
                                                $($(target[i]).children()[c]).addClass("e-businesshighlightworkcells");
                                                if (this._grouping.length > 1) {
                                                    var resIndex = i;
                                                    var index = this._tempResource.length - 1;
                                                    do {
                                                        var resParent = new ej.DataManager(this._tempResource[index - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[index - 1].resourceSettings["id"], ej.FilterOperators.equal, resources[resIndex][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]));
                                                        if (!ej.isNullOrUndefined(resParent)) {
                                                            resIndex = resources.indexOf(resParent[0]);
                                                            $($(target[resIndex]).children()[c]).addClass("e-businesshighlightworkcells");
                                                        }
                                                        index -= 1;
                                                    } while (index > 0)
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else
                        this._horizontalBusinessHighlight(null, null, null, null, null);
                }
            }
            else if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                this.element.find(".e-workcells").removeClass("e-businesshighlightworkcells");
                var renderDates = this.dateRender;
                var target = this.element.find(".e-workcells");
                var b_startHour = this.model.workHours.start >= this.model.startHour ? this.model.workHours.start - this.model.startHour : 0;
                var b_endHour = this.model.workHours.end <= this.model.endHour ? this.model.workHours.end - this.model.startHour : this.model.endHour - this.model.startHour;
                var timeRowsCount = (60 / this.model.timeScale.majorSlot) * (this.model.timeScale.minorSlotCount);
                this.res1 = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.res1 : [0];
                var colCount = this.currentView() === "week" ? (this.model.showWeekend) ? 7 * this.res1.length : this.model.workWeek.length * this.res1.length : this.currentView() === "workweek" ? this.model.workWeek.length * this.res1.length : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length * this.res1.length : 1 * this.res1.length;
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    for (var i = Math.ceil(b_startHour * timeRowsCount) ; i < (b_endHour * timeRowsCount) ; i++) {
                        for (var j = 0; j < colCount; j++) {
                            for (var k = 0; k < this.model.workWeek.length; k++) {
                                if (this._dayNamesArray.indexOf(this.model.workWeek[k]) == new Date(renderDates[j]).getDay())
                                    $(target[(i * colCount) + j]).addClass("e-businesshighlightworkcells");
                            }
                        }
                    }
                }
                else
                    this._horizontalBusinessHighlight(this._dateRender, b_startHour, b_endHour, timeRowsCount, target);
            }
            else {
                var target, monthDays;
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    monthDays = this.dateRender;
                    target = this.element.find(".e-monthcells");
                    target.removeClass("e-monthcellhighlight");
                    for (var i = 0; i < monthDays.length; i++) {
                        for (var j = 0; j < this.model.workWeek.length; j++) {
                            if (this._dayNamesArray.indexOf(this.model.workWeek[j]) == new Date(monthDays[i]).getDay())
                                !$(target[i]).hasClass("e-othermonths") ? $(target[i]).addClass("e-monthcellhighlight") : $(target[i]).removeClass("e-monthcellhighlight");
                        }
                    }
                }
                else
                    this._horizontalBusinessHighlight(null, null, null, null, null);
            }
        },

        _onselect: function (e) {
            this._navigateClick(e, "DateNavigation");
        },

        _renderHeaderBar: function (hTR) {
            var colsVal = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? 1 : 3;
            var hTD = ej.buildTag('td', "", {}, { colspan: colsVal });
            var commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous"), "role":"button","aria-label": this._getLocalizedLabels("Previous"),tabindex: 0})).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay")).append(ej.buildTag("input#" + this._id + "_navigator", "", {}, { "type": "text" }).css("display", "none").addClass("dateCalendar")).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next"), "role":"button","aria-label": this._getLocalizedLabels("Next"), tabindex: 0 }));
            if (this._mediaQuery || this.element.width() < 600) {
                this._mediaQuery && (commonDiv = ej.buildTag('div.e-datecommondiv').append(ej.buildTag('div.e-icon e-navigateprevious', "", {}, { title: this._getLocalizedLabels("Previous") })).append(ej.buildTag('div.e-icon e-navigatenext', "", {}, { title: this._getLocalizedLabels("Next") })).append(ej.buildTag('div', "", {}, { "aria-live": "assertive", tabindex: 0 }).html(this._getCurrentDateHeaderValue()).addClass("e-datedisplay")).append(ej.buildTag("input#" + this._id + "_navigator", "", {}, { "type": "text" }).css("display", "none").addClass("dateCalendar")));
                var menuIcon = ej.buildTag('div#' + this._id + 'navDrawerIcon.e-mobileNavigation e-icon');
                hTR.append(hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(menuIcon)));
            }
            else {
                var buttonsDiv = ej.buildTag('div.e-viewsdiv');
                hTR.append(hTD.append(ej.buildTag("div").css("width", "100%").append(commonDiv).append(buttonsDiv.append(this._renderViewNavigation(this.model.views)))));
            }
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderHeaderBar", "", hTR);
        },

        _renderViewNavigation: function (views) {
            var $viewTable = ej.buildTag('table.e-table e-viewstable', "", {}, {});
            var $viewBody = ej.buildTag('tbody');
            var $viewTR = ej.buildTag('tr');
            var _viewCollection = views, viewClassname;
            for (var i = 0; i < _viewCollection.length; i++) {
                viewClassname = (_viewCollection.length == 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-singleview" : (i == 0) ? "e-" + _viewCollection[i].toLowerCase() + " e-firstview" : i == (_viewCollection.length - 1) ? "e-" + _viewCollection[i].toLowerCase() + " e-lastview" : "e-" + _viewCollection[i].toLowerCase();
                switch (_viewCollection[i]) {
                    case "day": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Day"), {}, {"role":"button","aria-label":this._getLocalizedLabels("Day")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "week": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Week"), {}, {"role":"button","aria-label":this._getLocalizedLabels("Week")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "workweek": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("WorkWeek"), {}, {"role":"button","aria-pressed":"false","aria-label":this._getLocalizedLabels("WorkWeek")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "month": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Month"), {}, {"role":"button","aria-label":this._getLocalizedLabels("Month")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "customview": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("CustomView"), {}, {"role":"button", "aria-label":this._getLocalizedLabels("CustomView")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                    case "agenda": $viewTR.append(ej.buildTag('td').append(ej.buildTag('div', this._getLocalizedLabels("Agenda"), {}, {"role":"button","aria-label":this._getLocalizedLabels("Agenda")}).addClass("e-commonviewbutton").addClass(viewClassname)));
                        break;
                }
            }
            $viewTable.append($viewBody.append($viewTR))
            return $viewTable;
        },
        _renderNavigationDrawer: function () {
            if (ej.isNullOrUndefined(this._scheduleDrawer)) {
                this._scheduleDrawer = ej.buildTag('div#' + this._id + 'navDrawer.navDrawerMenu e-scheduledrawer');
                var $scheduleDrawer = "<ul><li data-ej-imageClass='e-icon e-mAddEvent' data-ej-text='" + this._getLocalizedLabels("AddEvent") + "' id='addEvent'></li>";
                for (var i = 0; i < this.model.views.length; i++) {
                    switch (this.model.views[i]) {
                        case "day": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Day") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "week": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Week") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "workweek": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("WorkWeek") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "month": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Month") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "customview": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("CustomView") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                        case "agenda": $scheduleDrawer += "<li data-ej-imageClass='e-icon e-m" + this.model.views[i] + " e-" + this.model.views[i] + "' data-ej-text='" + this._getLocalizedLabels("Agenda") + "' id='" + this.model.views[i] + "'></li>";
                            break;
                    }
                }
                $scheduleDrawer += "</ul>";
                this._scheduleDrawer.append($scheduleDrawer);
                this.element.find(".e-scheduleinner").append(this._scheduleDrawer);
                this._navDrawer = true;
                this._scheduleDrawer.ejNavigationDrawer({ type: "overlay", targetId: this._id + "navDrawerIcon", direction: (this.model.enableRTL) ? "left" : "right", enableListView: true, listViewSettings: { persistSelection: true, selectedItemIndex: this.model.views.toString().toLowerCase().split(',').indexOf(this.currentView()) + 1, width: 100, height: "auto", mouseUp: $.proxy(this._slideMenuClick, this) }, position: "normal" });
                this.model.enableRTL && this._scheduleDrawer.parent().css("left", "0px");
                this._navDrawer = false;
            }
        },

        _slideMenuClick: function (e) {
            if (this._navDrawer) return false;
            this._scheduleDrawer.ejNavigationDrawer("close");
            var menu = (e.item.find("div").hasClass("e-day")) ? "day" : (e.item.find("div").hasClass("e-week")) ? "week" : (e.item.find("div").hasClass("e-workweek")) ? "workweek" : (e.item.find("div").hasClass("e-month")) ? "month" : (e.item.find("div").hasClass("e-customview")) ? "customview" : (e.item.find("div").hasClass("e-agenda")) ? "agenda" : "open";
            if (menu != "open") {
                this._navView = this._navSelected = true;
                (this.currentView() != menu) && this._viewChange(null, this.currentView(), menu);
                this._navSelected = false;
            }
            else {
                if (this.currentView() != "agenda") {
                    var date = new Date(this.currentDate()), targetElement;
                    var column = 0;
                    date = new Date(date.setHours(0, 0, 0, 0));
                    for (var i = 0; i < this.dateRender.length; i++) {
                        if (new Date(this.dateRender[i]).getTime() == date.getTime()) {
                            column = i;
                            break;
                        }
                    }
                    if (this.model.orientation == "vertical" && this._customOrientation == "vertical")
                        var row = this.model.startHour + ((new Date().getHours()) * (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    else
                        var row = this.res1.length - 1;
                    targetElement = (this.currentView() != "month" && this.currentView() != "customview") && this.model.timeScale.enable ? this.element.find(".e-draggableworkarea tr")[row].cells[column] : this.element.find(".e-monthcells")[column];
                    $(targetElement).addClass(".e-selectedCell").trigger($.Event('click'));
                    this._appointmentWindow({ target: targetElement });
                }
            }
        },

        _renderAlertWindow: function () {
            this._alertWindow = ej.buildTag('div.e-alertdialog#' + this._id + "alertWindow");
            var $alertWindow = "<div><div class='e-alerttext'></div><div class='e-alertbtn'><button id='" + this._id + "alertok' type='button' class='e-alertbutton e-alertOk e-buttonactive'>" + this._getLocalizedLabels("Ok") + "</button></div></div>";
            this._alertWindow.append($alertWindow);
            this.element.append(this._alertWindow);
            this._alertWindow.find(".e-alertbutton").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
            this._alertWindow.ejDialog({
                width: (this._mediaQuery) ? "75%" : 450,
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("RecurrenceAlert"),
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._alertClose, this)
            });
            $("#" + this._id + "alertWindow_wrapper").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
        },

        _alertClose: function (args) {
            this._alertWindow.ejDialog("close");
            if (this._alertWindow.hasClass("e-recurAlert")) {
                this._alertWindow.removeClass("e-recurAlert");
                if ($(args.target).hasClass("e-alertOk")) {
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                    this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    this._appointmentAddWindow.find(".e-recurFinalRule").html(this._rRuleStr);
                    this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                    this._appointmentAddWindow.find(".e-recurEditor").toggle();
                    this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
                    (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "block");
                    this._appointmentAddWindow.find('.done').focus();
                }
                else {
                    this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: false });
                }
            }
            else if (this._alertWindow.hasClass("e-seriesAlert")) {
                this._alertWindow.removeClass("e-seriesAlert");
                if ($(args.target).hasClass("e-alertOk")) {
                    //$("#" + this._id + "AppointmentAddEditWindow").find("#done").click();
                    this._appointmentAddWindow.find("#done").click();
                }
                else {
                    this._seriesAlert = true;
                    //var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                    //recurEdit.recurrenceRuleSplit(this._rule);
                    //this._appointmentAddWindow.find(".e-recurFinalRule").html(recurEdit.showRecurrenceSummary());
                }
            }
            else if (this._alertWindow.hasClass("e-deleteAlert")) {
                this._alertWindow.removeClass("e-deleteAlert");
                if ($(args.target).hasClass("e-alertOk")) this._deletingAppointment();
            }
            if (this._alertWindow.find("#" + this._id + "alertcancel").length != 0) this._alertWindow.find("#" + this._id + "alertcancel").remove();
        },

        _renderAppointmentWindow: function () {
            if ($("#" + this._id + "AppointmentAddEditWindow_wrapper")) $("#" + this._id + "AppointmentAddEditWindow_wrapper").remove();
            this._appointmentAddWindow = ej.buildTag('div.e-scheduledialog e-appointmentaddwindow#' + this._id + "AppointmentAddEditWindow");
            var $appWindow = "<div class='e-appwindow e-windowmargin'><form id='" + this._id + "_AddEditForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            if (this._mediaQuery) {
                $appWindow += "<tr id='" + this._id + "subjectlabeltr'><td colspan='3' class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td></tr><tr id='" + this._id + "subjecttr' class='" + this._id + "subjecttr'><td colspan='3' class='e-rightfields'>" +
                              "<input id='" + this._id + "subject' tabIndex='0' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "' type='text' /><span class='e-ripple-bar'><input id='id' class='id' type='text' name='" + this._appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
                if (this.model.showLocationField) {
                    $appWindow += "<tr><td colspan='3' class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" +
                                      "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                }
                $appWindow += "<tr id='" + this._id + "_appStartTime'><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("StartTime") + ":</td></tr><tr><td width='37%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=31%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td width='31%'><input id='" + this._id + "startTimeZone' class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                }
                $appWindow += "</tr>";
                $appWindow += "<tr id='" + this._id + "_appEndTime'><td class='e-textlabel' colspan='3'>" + this._getLocalizedLabels("EndTime") + ":</td></tr><tr><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td><input  id='" + this._id + "endTimeZone' class='endutc' name='" + this._appointmentSettings["endTimeZone"] + "' type='text' value=''/><div id='Timezonelistend'></div></td>";
                }
                $appWindow += "</tr>";
                if (this.model.prioritySettings.enable) {
                    $appWindow += "<tr><td class='e-leftfields e-textlabel' colspan='3'>" + this._getLocalizedLabels("Priority") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value=''/><div id='prioritylist'></div></td></tr>";
                }
                $appWindow += "<tr class='" + this._id + "parrow'><td class='" + this._id + "allDay' colspan='3'><table class='e-table e-appchecktable' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this._appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                                  "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                                  "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this._appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                                      this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
                $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td></tr><tr class='" + this._id + "summary' style='display:none'><td colspan='4'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#' onclick='return false;'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-edit_01 e-scheduleedit'></span></div></td></tr></table></td></tr>";
                if (this.model.categorizeSettings.enable)
                    $appWindow += "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel' colspan='3'>" + this._getLocalizedLabels("Categorize") + ":</td></tr><tr><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' name='" + this._appointmentSettings["categorize"] + "' class='e-categorizevalue' type='text' value=''/></td></tr>";
                if (this._tempResource.length > 0 && ej.scheduleFeatures.resources) $appWindow = this._renderResourceElements($appWindow);
                $appWindow += "<tr><td colspan='3'><textarea class='e-description e-textarea e-animation e-inputtext' id='" + this._id + "description' name='" + this._appointmentSettings["description"] + "'></textarea><span class='e-ripple-bar'></td></tr>";
                $appWindow += "</tbody></table></form>";
                $appWindow += "<div class='e-floatright' style='width:100%'><table width='100%' class='e-table' cellpadding='5'><tr><td width='30%'><div class='e-btnmargin e-floatleft'><button id='mDelete' class='e-btndelete e-appdelete'>" + this._getLocalizedLabels("Delete") + "</button></div></td><td width='30%'><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                              "<td width='30%'><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            }
            else {
                $appWindow += "<tr  id='" + this._id + "subjecttr' class='" + this._id + "subjecttr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td><td colspan='3' class='e-rightfields'>" +
                                 "<input id='" + this._id + "subject' tabIndex='0' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "' type='text' /><span class='e-ripple-bar'><input id='id' class='id' type='text' name='" + this._appointmentSettings["id"] + "' value='' style='display: none'/></td></tr>";
                if (this.model.showLocationField) {
                    $appWindow += "<tr id='" + this._id + "showLocation' class='" + this._id + "showLocation'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Location") + ":</td><td colspan='3' class='e-rightfields'>" +
                                     "<input id='" + this._id + "location' tabIndex='0' class='location e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["location"] + "' type='text' /><span class='e-ripple-bar'></td></tr>";
                }
                $appWindow += "<tr id='" + this._id + "_appStartTime'><td class='e-textlabel'>" + this._getLocalizedLabels("StartTime") + ":</td><td width='25%'><input id='" + this._id + "startdate' class='startenddate' type='text' name='StartDate' value='' /></td><td width=22%'><input type='text' id='" + this._id + "starttime' class='startendtime' name='StartTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td width='28%'><input  id='" + this._id + "startTimeZone'  class='startutc'  name='" + this._appointmentSettings["startTimeZone"] + "' type='text' value=''/><div id='Timezoneliststr'></div></td>";
                }
                $appWindow += "</tr>";
                $appWindow += "<tr id='" + this._id + "_appEndTime'><td class='e-textlabel'>" + this._getLocalizedLabels("EndTime") + ":</td><td><input id='" + this._id + "enddate' class='startenddate' type='text' name='EndDate' value='' /></td><td><input type=''text' id='" + this._id + "endtime' class='startendtime' name='EndTime'/></td>";
                if (this.model.showTimeZoneFields) {
                    $appWindow += "<td><input id='" + this._id + "endTimeZone'  class='endutc'  name='" + this._appointmentSettings["endTimeZone"] + "'  type='text' value=''/><div id='Timezonelistend'></div></td>";
                }
                $appWindow += "</tr>";
                var win = this.model.prioritySettings.enable ? "<td colspan='1' class='e-textlabel " + this._id + "priorityshow'>" + this._getLocalizedLabels("Priority") + ":</td><td colspan='1' class='" + this._id + "prioritylistshow'><input id='" + this._id + "priority' class='priority' type='text' name='" + this._appointmentSettings["priority"] + "' value='' /><div id='prioritylist'></div></td>" : '';
                $appWindow += "<tr class='" + this._id + "parrow'>" + win + "<td class='" + this._id + "allDay' colspan='4'><table class='e-table e-appchecktable' cellpadding='3'><tr><td><div class='e-allday e-checkboxmargin'><input id='" + this._id + "allday' tabIndex='0' class='allday' type='checkbox' name='" + this._appointmentSettings["allDay"] + "'/></div></td><td><div class='e-alldaytext'>" +
                                 "<label for='" + this._id + "allday'>" + this._getLocalizedLabels("AllDay") + "</label></div></td><td><div class='e-checkboxmargin e-recurrence'>" +
                                  "<input id='" + this._id + "recurrence' tabIndex='0' class='recurrence' type='checkbox' name='" + this._appointmentSettings["recurrence"] + "' value='recurrence'/></div></td><td><label class='e-repeatlbl' for='" + this._id + "recurrence'>" +
                                  this._getLocalizedLabels("Recurrence") + "</label></td></tr></table></td></tr>";
                $appWindow += "<tr id='" + this._id + "summary' class='" + this._id + "summary' style='display:none'><td class='e-textlabel'><label>" + this._getLocalizedLabels("Summary") + ":</label></td><td colspan='3'><table><tr><td><label class='e-recurFinalRule'></label></td><td><div class='e-recuredit'><a class='e-recuredit' href='#' onclick='return false;'>" + this._getLocalizedLabels("Edit") + "</a><span class='e-icon e-edit_01 e-scheduleedit'></span></div></td></tr></table></td></tr>";
                if (this.model.categorizeSettings.enable)
                    $appWindow += "<tr id='" + this._id + "categorizetr'><td class='e-leftfields e-textlabel'>" + this._getLocalizedLabels("Categorize") + ":</td><td colspan='3' class='e-rightfields'>" + "<input id= '" + this._id + "categorize' name='" + this._appointmentSettings["categorize"] + "' class='e-categorizevalue' type='text' value=''/></td></tr>";
                if (this._tempResource.length > 0 && ej.scheduleFeatures.resources) $appWindow = this._renderResourceElements($appWindow);
                $appWindow += "<tr><td colspan='4'><textarea class='e-description e-textarea e-animation e-inputtext' id='" + this._id + "description' name='" + this._appointmentSettings["description"] + "'></textarea><span class='e-ripple-bar'></td></tr>";
                $appWindow += "</tbody></table></form>";
                $appWindow += "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='done' class='e-btndone e-appsave e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                              "<td><div class='e-btnmargin e-floatleft'><button id='cancel' class='e-appointcancel cancel'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div></div>";
            }
            this._appointmentAddWindow.append($appWindow);
            this.element.append(this._appointmentAddWindow);
            this._renderControls();
            this._appointmentAddWindow.ejDialog({
                width: (this._mediaQuery) ? "100%" : 600,
                height: (this._mediaQuery) ? "100%" : "auto",
                cssClass: this.model.cssClass,
                showOnInit: false,
                enableRTL: this.model.enableRTL, enableModal: true,
                title: this._getLocalizedLabels("CreateAppointmentTitle"),
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._onclose, this)
            });
            if (this._mediaQuery)
                $("#" + this._id + "AppointmentAddEditWindow_wrapper").addClass("e-scheduledialog e-scheduleresponsive").find(".e-titlebar").addClass("e-dialogheader");
            else
                $("#" + this._id + "AppointmentAddEditWindow_wrapper").addClass("e-scheduledialog").find(".e-titlebar").addClass("e-dialogheader");
            $("#" + this._id + "priority_popup_wrapper").addClass("e-schedulepriority");
            this._on(this._appointmentAddWindow, "click", "a.e-recuredit", $.proxy(this._editRecurrence, this));
            if (this._mediaQuery) this._appointmentAddWindow.ejDialog("refresh");
            $.isFunction($.validator) && this._setValidation();
            if (this._mediaQuery) this._phoneChanges();
        },

        _renderRecurrenceEditor: function () {
            var recurrenceEditor = ej.buildTag('div.e-recurEditor#' + this._id + 'recurrenceEditor').ejRecurrenceEditor({ selectedRecurrenceType: 1, frequencies: ["daily", "weekly", "monthly", "yearly", "everyweekday"], startDate: this.currentDate(), minDate: this.model.minDate, maxDate: this.model.maxDate, firstDayOfWeek: this.model.firstDayOfWeek, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, locale: this.model.locale });
            var recurWin = "<div class='e-floatright'><table class='e-table' cellpadding='5'><tr><td><div class='e-btnmargin e-floatleft'><button id='" + this._id + "donerecur'  class='recurbutton e-buttonactive'>" + this._getLocalizedLabels("Done") + "</button></div></td>" +
                            "<td><div class='e-btnmargin e-floatleft'><button id='" + this._id + "cancelrecur' class='e-cancelrecur recurbutton'>" + this._getLocalizedLabels("Cancel") + "</button></div></td></tr></table></div>";
            $(recurrenceEditor).insertAfter(this._appointmentAddWindow.find(".e-appwindow"));
            this._appointmentAddWindow.find(".e-recurEditor").append(recurWin);
            this._appointmentAddWindow.find('#' + this._id + 'donerecur').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._closeRecurence, this), cssClass: "e-flat" + this.model.cssClass });
            this._appointmentAddWindow.find('#' + this._id + 'cancelrecur').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._closeRecurence, this), cssClass: "e-flat" + this.model.cssClass });
            this._appointmentAddWindow.find('.e-recurEditor').css("display", "none");
            if (this._mediaQuery) this._phoneChanges();
        },

        _refreshAppointmentWindow: function () {
            this._destorySubControls($("#" + this._id + "_AddEditForm"));
            this._destorySubControls($("#" + this._id + "_RecurForm"));
            $("#" + this._id + "AppointmentAddEditWindow_wrapper").remove();
            this._renderAppointmentWindow();
            $.isFunction($.validator) && this._setValidation();
        },

        _renderQuickAppWindow: function () {
            this._quickAppointWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppointmentQuickWindow");
            var $quickWin = "<div id='" + this._id + "_quickAppwindow' class='e-tableAppoint'><table cellpadding='7' class='e-qappwindow'><tbody>";
            $quickWin += "<tr><td colspan='2'><div class='e-quickstartend'></div> <div title='" + this._getLocalizedLabels("Close") + "'class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td class='e-subjectlabel'>" + this._getLocalizedLabels("AppointmentSubject") + ":</td><td colspan='2' class='e-rightfields'>" +
                              "<form id='" + this._id + "_AddForm' onsubmit='return false;'><input id='" + this._id + "subject' class='subject e-textbox e-animation e-inputtext' name='" + this._appointmentSettings["subject"] + "'  type='text' /><span class='e-ripple-bar'></span></form></td></tr></tbody></table>";
            $quickWin += "<div class='e-quickcreatebottomcontainer'><div tabIndex='0' class='e-detailedapp e-detailedwindow'> " + this._getLocalizedLabels("Detailed") + " >></div><div style='margin-right:-3px;' class='e-floatright'><div class='e-quickAppDone'><button id='done' class='e-btndone e-qAppDone e-buttonactive' style='font-size:12px !important;'>" + this._getLocalizedLabels("CreateAppointmentTitle") + "</button></div></div></div></div>";
            this._quickAppointWindow.append($quickWin);
            this.element.append(this._quickAppointWindow);
            this._quickAppointWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
            var control = this._quickAppointWindow;
            control.find('.e-btndone').ejButton({ showRoundedCorner: true, click: $.proxy(this._saveAppointment, this), cssClass: "e-flat" + this.model.cssClass, enableRTL: this.model.enableRTL });
            this._on(control.find('.e-scheduleclose'), "click", $.proxy(this._quickWindowClose, this));
            this._on(control.find('.e-detailedapp'), "click", $.proxy(this._appointmentWindow, this));
            this._quickAppointWindow.ejDialog({
                width: 330, minHeight: 0,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                enableAnimation: false,
                showOnInit: false,
                enableResize: false,
                allowDraggable: false, showHeader: false,
                allowKeyboardNavigation: false,
                close: $.proxy(function () { this._processFocus(); }, this)
            });
            $.isFunction($.validator) && this._setQuickValidation();
            $("#" + this._id + "AppointmentQuickWindow_wrapper").addClass("e-scheduledialog e-schedulequickdialog").css("overflow", "visible").find("#" + this._id + "AppointmentQuickWindow").addClass("e-dialogouter");
        },

        _renderQuickAppDetailsView: function () {
            this._quickAppDetailsWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "AppDetailsWindow");
            var $quickAppWin = "<div id='" + this._id + "_quickAppDetailswindow' class='e-tableAppoint e-appdetails'>" +
                              "<table cellpadding='1' class='e-qappwindow'><tbody>";
            $quickAppWin += "<tr><td colspan='2'><div class='e-quicksubject e-textellipsis'></div> <div title='" + this._getLocalizedLabels("Close") + "' class='e-icon e-scheduleclose e-schedclosemargin e-pointercursor'></div></td></tr><tr><td colspan='2' class='e-quickduein e-rightfields'>" +
                              "</td></tr><tr><td colspan='2'><div class='e-quickstartendtime'></div></td></tr></tbody></table>";
            $quickAppWin += "<div class='e-quickbottomcontainer'><div title='" + this._getLocalizedLabels("Delete") + "' class='e-icon e-delete e-scheduledelete e-pointercursor' tabIndex='0'></div><div class='e-floatright'><div class='e-editevents'><div class='e-editevent e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editevent") + " | " + "</div><div class='e-editseries e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editseries") + " >></div> </div>" +
                              "</div></div></div>";
            this._quickAppDetailsWindow.append($quickAppWin);
            if (this._recurrenceFutureActions) {
                var futureEdit = $("<div class='e-editfutureonly e-textellipsis' tabIndex='0'>" + this._getLocalizedLabels("Editfollowingevent") + " | </div>");
                futureEdit.insertAfter(this._quickAppDetailsWindow.find(".e-editevent"));
            }
            this.element.append(this._quickAppDetailsWindow);
            this._quickAppDetailsWindow.append(ej.buildTag("div.e-quickarrow").append("<div class='e-outerarrowline'></div>").append("<div class='e-innerarrow'></div>"));
            this._on(this._quickAppDetailsWindow.find('.e-scheduleclose'), "click", $.proxy(this._quickAppDetailWindowClose, this));
            this._on(this._quickAppDetailsWindow.find('.e-scheduledelete'), "click", $.proxy(this._deleteAppoint, this));
            this._on(this._quickAppDetailsWindow.find('.e-editevent,.e-editfutureonly,.e-editseries'), "click", $.proxy(this._editClick, this));
            this._quickAppDetailsWindow.ejDialog({
                width: (this._recurrenceFutureActions) ? 360 : 270,
                minHeight: 0,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                enableAnimation: false,
                showOnInit: false,
                enableResize: false,
                allowDraggable: false, showHeader: false,
                allowKeyboardNavigation: false,
                close: $.proxy(function () { this._processFocus(); }, this)
            });
            $("#" + this._id + "AppDetailsWindow_wrapper").addClass("e-scheduledialog e-schedulequickdialog").css("overflow", "visible").find("#" + this._id + "AppDetailsWindow").addClass("e-dialogouter");
        },

        _editClick: function (e) {
		    this._editclick = true;
            if ($(e.target).hasClass("e-editseries") && this._quickAppDetailsWindow.find('.e-editseries').hasClass("e-disable")) return false;
            if ($(e.target).hasClass("e-editfutureonly") && this._quickAppDetailsWindow.find('.e-editfutureonly').hasClass("e-disable")) return false;
            var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
            if ($(e.target).hasClass("e-editevent")) {
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    this._parentId = templist[0]["ParentId"];
                    this._currentAction = ej.Schedule.Actions.EditOccurrence;
                    this._showAppointmentDetails(this._appUid, true);
                }
                else if (ej.isNullOrUndefined(templist[0][this._appointmentSettings["recurrence"]])) {
                    this._currentAction = ej.Schedule.Actions.Save;
                    this._showAppointmentDetails(this._appUid, true);
                }
                else {
                    this._currentAction = ej.Schedule.Actions.Save;
                    this._showAppointmentDetails(templist[0]["Guid"], true);
                }
            }
            else if ($(e.target).hasClass("e-editfutureonly")) {
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    this._parentId = templist[0]["ParentId"];
                    this._currentAction = ej.Schedule.Actions.EditFutureOccurrences;
                    this._showAppointmentDetails(this._appUid, true);
                }
            }
            else if ($(e.target).hasClass("e-editseries")) {
                if (templist[0][this._appointmentSettings["recurrence"]] == 1) {
                    this._parentId = (templist[0][this._appointmentSettings["recurrenceId"]] == null) ? templist[0]["ParentId"] : templist[0][this._appointmentSettings["recurrenceId"]];
                    this._currentAction = ej.Schedule.Actions.EditSeries;
                    this._showAppointmentDetails(this._parentId, false);
                }
            }
			this._editclick = false;
            this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("close");
        },

        _deleteAppoint: function (e) {
            if (!this.model.readOnly && this.model.allowDelete) {
                if (!ej.isNullOrUndefined(e) && (ej.isNullOrUndefined(this._quickAppDetailsWindow) || !this._quickAppDetailsWindow.ejDialog("isOpen"))) {
                    var _target = $(e.target).parent();
                    var appoint = _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents(".e-appointment,.e-alldayappointment,.e-monthappointment,.e-agendaappointment");
                    this._appUid = appoint.attr("data-guid");
                    if (this._mediaQuery) this._mAppId = this._appUid;
                    var _editApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (_editApp[0][this._appointmentSettings["recurrence"]] || !this.model.showDeleteConfirmationDialog)
                        this._deletingAppointment();
                    else
                        this._deleteConfirmation();
                }
                else {
                    var _editApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (_editApp[0][this._appointmentSettings["recurrence"]] || !this.model.showDeleteConfirmationDialog) {
                        this.model.showQuickWindow && this._quickAppDetailsWindow.ejDialog("isOpen") && this._quickAppDetailsWindow.ejDialog("close");
                        this._deletingAppointment();
                    }
                    else
                        this._deleteConfirmation();
                }
            }
        },

        _deletingAppointment: function () {
            this._appUid = ej.isNullOrUndefined(this._appUid) ? this._deleteUid : this._appUid;
            if (this._appUid) {
                this._currentAction = ej.Schedule.Actions.Delete;
                var parentData = this._getAppointmentByParentId((this._mediaQuery) ? ej.isNullOrUndefined(this._mAppId) ? this._appUid : this._mAppId : this._appUid);
                if (!parentData[this._appointmentSettings["recurrence"]])
                    this._deleteApp((this._mediaQuery) ? ej.isNullOrUndefined(this._mAppId) ? this._appUid : this._mAppId : this._appUid);
                else {
                    if (this.model.showRecurrenceAlert) {
                        if (ej.isNullOrUndefined(this._recurEditWindow)) this._renderRecurEditWindow();
                        this._parentId = parentData["ParentId"];
                        this._recurEditWindow.ejDialog("open");
                        this._recurEditWindow.focus();
                        this._deleteBeforeOpen();
                    } else {
                        this._currentAction = this._actionType = ej.Schedule.Actions.DeleteSeries;
                        this._deleteApp(parentData["ParentId"]);
                    }
                }
            }
            (!ej.isNullOrUndefined(this._alertWindow)) && this._alertWindow.ejDialog("close");
        },

        _deleteConfirmation: function () {
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            if (this._alertWindow.find(".e-alertCancel").length == 0) {
                this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                $("#" + this._id + "alertWindow").ejDialog({
                    width: (this._mediaQuery) ? "90%" : 450,
                    title: this._getLocalizedLabels("MouseOverDeleteTitle")
                });
                this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("DeleteConfirmation"));
                this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Delete"));
            }
            if (!this._alertWindow.ejDialog("isOpen")) {
                this._alertWindow.addClass("e-deleteAlert");
                this._alertWindow.ejDialog("open");
                this._alertWindow.find(".e-alertOk").attr("tabIndex", 0).focus();
            }
        },

        _quickAppDetailWindowClose: function () {
            this._quickAppDetailsWindow.ejDialog("close");
            this._processFocus();
        },

        _alldayCheck: function () {
            if (this._appointmentAddWindow.find(".allday").ejCheckBox("option", "checked")) {
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: (this._timeMode == "12") ? "12:00 AM" : "00:00", enabled: false });
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: (this._timeMode == "12") ? "11:59 PM" : "23:59", enabled: false });
                this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: false });
            }
            else {
                if (this._tempStart != "" || this._tempEnd != "") {
                    var dayStTime = ej.format(new Date(new Date().setHours(0, 0, 0)), this._pattern.t, this.model.locale);
                    var dayEndTime = ej.format(new Date(new Date().setHours(23, 59, 59)), this._pattern.t, this.model.locale);
                    this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: this._tempStart });
                    this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: this._tempEnd });
                    if (((this._timeMode == "12") ? (this._tempStart == dayStTime && this._tempEnd == dayEndTime) : (this._tempStart == "00:00" && this._tempEnd == "23:59"))) {
                        this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker({ value: ej.format(new Date("1/1/2000 " + this.model.workHours.start + ":00:00"), this._pattern.t, this.model.locale) });
                        this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker({ value: ej.format(new Date("1/1/2000 " + this.model.workHours.start + ":30:00"), this._pattern.t, this.model.locale) });
                    }
                }
                this._appointmentAddWindow.find(".startendtime").ejTimePicker({ enabled: true });
                this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList({ enabled: true });
                this._endSlotChange = true;
                this._startSlotChange = true;
            }
        },

        _renderRecurEditWindow: function () {
            if ($("#" + this._id + "RecurrenceEdit_wrapper")) $("#" + this._id + "RecurrenceEdit_wrapper").remove();
            this._recurEditWindow = ej.buildTag('div.e-scheduledialog#' + this._id + "RecurrenceEdit");
            var msgDiv = ej.buildTag('div.e-recureditmsg', this._getLocalizedLabels("RecurrenceEditMessage"));
            var editOnly = this._getLocalizedLabels("RecurrenceEditOnly");
            var editSeries = this._getLocalizedLabels("RecurrenceEditSeries");
            var btns = ej.buildTag('div.e-recureditbtns').append(ej.buildTag('button.e-editonly#' + this._id + "Editonly", editOnly, {}, { name: "recurrenceeditonly", value: editOnly })).append(ej.buildTag('button.e-editseries#' + this._id + "EditSeries", editSeries, {}, { name: "recurrenceeditseries", value: editSeries }));
            if (this._recurrenceFutureActions) {
                var editFutureOnly = this._getLocalizedLabels("RecurrenceEditFollowingEvent");
                var futurBtn = ej.buildTag('button.e-editfutureonly#' + this._id + "EditFutureOnly", editFutureOnly, {}, { name: "recurrenceeditfutureonly", value: editFutureOnly });
                futurBtn.insertAfter(btns.find(".e-editonly"));
            }
            this._recurEditWindow.append(msgDiv).append(btns);
            btns.find('.e-editonly,.e-editfutureonly,.e-editseries').ejButton({ cssClass: "e-flat" + this.model.cssClass, enableRTL: this.model.enableRTL, showRoundedCorner: true });
            this._on(this._recurEditWindow, "click", ".e-editonly,.e-editfutureonly,.e-editseries", $.proxy(this._recurBtnClick, this));
            this._on(this._recurEditWindow, "click", "div.e-scheduleclose", $.proxy(this._recrConformClose, this));
            this._recurEditWindow.appendTo(this.element);
            if (this._mediaQuery) {
                this._recurEditWindow.find('.e-editonly,.e-editfutureonly,.e-editseries').css({ 'margin-top': '10px' });
            }
            this._recurEditWindow.ejDialog({
                width: (this._mediaQuery) ? "90%" : (this._recurrenceFutureActions) ? 500 : 360,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                title: this._getLocalizedLabels("RecurrenceEditTitle"),
                showOnInit: false,
                enableModal: true,
                enableResize: false,
                allowKeyboardNavigation: false,
                close: $.proxy(this._processFocus, this),
                beforeOpen: $.proxy(this._deleteBeforeOpen, this)
            });
            $("#" + this._id + "RecurrenceEdit_wrapper").addClass("e-scheduledialog");
        },

        _recrConformClose: function () {
            if (!ej.isNullOrUndefined(this._recurEditWindow))
                this._recurEditWindow.ejDialog("close");
            this._processFocus();
        },
        _deleteBeforeOpen: function () {
            $('#' + this._id + 'RecurrenceEdit_title').addClass('e-dialogheader');
            $('#' + this._id + 'RecurrenceEdit_title').find('.e-title').html(this._currentAction == ej.Schedule.Actions.Delete ? this._getLocalizedLabels("RecurrenceDeleteTitle") : this._getLocalizedLabels("RecurrenceEditTitle"));
        },

        _recurBtnClick: function (args) {
            if ($(args.target).hasClass("e-editonly")) {
                this._editOnlyClicked = true;
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    var _newAddList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    if (_newAddList[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) {
                        if (this._trigger("actionBegin", { id: this._appUid, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var Parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]]
                        var deleted = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                        if (this._trigger("beforeAppointmentRemove", { appointment: deleted, currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "Guid";
                        var promise = this._dataManager.remove(queryId, _newAddList[queryId], this.model.appointmentSettings.query._fromTable);
                        if (this.dataSource() instanceof ej.DataManager) new ej.DataManager(this._currentAppointmentData).remove("Guid", _newAddList);
                        var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        this._appointmentRemove(deleteApp[0]);
                        this._refreshDayAppointments(deleteApp[0]);
                        this._trigger("appointmentRemoved", { appointment: deleted, requestType: "appointmentDeleted", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        this._trigger("actionComplete", { appointment: deleted, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    }
                    else {
                        if (this._trigger("actionBegin", { id: this._appId, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence }))
                            return false;
                        var Parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]]
                        var deleApp = this._deleteOcurrence(Parid, _newAddList[this._appointmentSettings["startTime"]]);
                        var temp = this._timeZoneAppointments(deleApp[0], "");
                        if (this._trigger("beforeAppointmentRemove", { appointment: _newAddList, currentAction: ej.Schedule.Actions.DeleteOccurrence })) {
                            this._recurEditWindow.ejDialog("close");
                            return false;
                        }
                        var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                        var promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable);
                        var updateTemp = (this._timeZoneAppointments(temp, "reverse"));
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                        this._refreshCellsHeight();
                        var delApp_ = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        if (delApp_.length > 1) {
                            var delApp = [];
                            for (var i = 0; i < delApp_.length; i++) {
                                var tmpApp = this._processed.filter(function (obj) { return obj.Guid == delApp_[i]["Guid"]; });
                                if (tmpApp.length > 0) delApp.push(tmpApp[0]);
                                new ej.DataManager(this._processed).remove("Guid", delApp_[i]["Guid"]);
                                new ej.DataManager(this._renderedApp).remove("Guid", delApp_[i]["Guid"]);
                                new ej.DataManager(this._renderedAllDay).remove("Guid", delApp_[i]["Guid"]);
                            }
                        }
                        else {
                            var delApp = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                            new ej.DataManager(this._processed).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedApp).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedAllDay).remove("Guid", this._appUid);
                            this._appUid = null;
                        }
                        for (var ix = 0, len = delApp.length; ix < len; ix++) {
                            this._appointmentRemove(delApp[ix]);
                            this._refreshDayAppointments(delApp[ix]);
                        }
                        this._trigger("appointmentRemoved", { appointment: _newAddList, requestType: "appointmentDeleted", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        this._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDelete", currentAction: ej.Schedule.Actions.DeleteOccurrence });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    }
                    this._currentViewAppointments = this._appointmentCount();
                    if (this.model.showAppointmentNavigator) this._nextPrevButton();
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditOccurrence;
                    this._showAppointmentDetails(this._appUid, true);
                }
            }
            else if ($(args.target).hasClass("e-editfutureonly")) {
                this._editOnlyClicked = false;
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    this._actionType = ej.Schedule.Actions.DeleteFutureOccurrences;
                    this._deleteApp(this._appUid);
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditFutureOccurrences;
                    this._showAppointmentDetails(this._appUid, true);
                }
            }
            else {
                this._editOnlyClicked = false;
                if (this._currentAction == ej.Schedule.Actions.Delete) {
                    this._actionType = ej.Schedule.Actions.DeleteSeries;
                    this._deleteApp(this._appUid);
                }
                else {
                    this._currentAction = ej.Schedule.Actions.EditSeries;
                    this._showAppointmentDetails(this._parentId, false);
                }
            }
            if (!ej.isNullOrUndefined(this._recurEditWindow)) this._recurEditWindow.ejDialog("close");
        },

        _repeat: function (e) {
            if (e.isInteraction) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                this._appointmentAddWindow.find(".e-recurEditor").length == 0 && this._renderRecurrenceEditor();
                if (e.isChecked || this._recurChecked) {
                    if (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") {
                        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                    }
                    else {
                        (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
                        this._appointmentAddWindow.find(".e-appwindow").toggle();
                        this._appointmentAddWindow.find(".e-recurEditor").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 400);
                        var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                        recurEdit.clearRecurrenceFields();
                        this._appointmentAddWindow.find('.e-recurEditor').css("display", "block");
                        var strDate = new Date(this._appointmentAddWindow.find('.startenddate').ejDatePicker("option", "value"));
                        recurEdit.model.startDate = strDate;;
                        recurEdit.setDefaultValues();
                    }
                }
                else {
                    (this._currentAction == ej.Schedule.Actions.EditSeries || this._appointmentAddWindow.find(".e-recurFinalRule").html() != "") && this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
                }
                this._recurChecked = false;
            }
        },

        _resourceDaysReorder: function (days) {
            var dayNames = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
            var cultureNames = [], resDays = [], oldOrder = [], newOrder = [], index = this._firstdayofweek;
            do {
                if (index > 6) index = 0;
                cultureNames.push(dayNames[index]);
                index++;
            } while (cultureNames.length < 7)
            for (var a = 0; a < days.length; a++) { resDays.push(days[a].toLowerCase()); }
            for (var b = 0; b < resDays.length; b++) { if (cultureNames.indexOf(resDays[b]) != -1) oldOrder[cultureNames.indexOf(resDays[b])] = resDays[b]; }
            for (var c = 0; c < oldOrder.length; c++) { if (!ej.isNullOrUndefined(oldOrder[c])) newOrder.push(oldOrder[c]); }
            return newOrder;
        },

        _daysReorder: function (firstdayofweek) {
            var dayNames = [], index = firstdayofweek, names = [0, 1, 2, 3, 4, 5, 6];
            do {
                if (index > 6) index = 0;
                dayNames.push(names[index]);
                index++;
            } while (dayNames.length < 7)
            return dayNames;
        },

        _getWeekDays: function () {
            var weekDays = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], showWeekDays = [];
            for (var days = 0; days < this.model.workWeek.length; days++) {
                var dayIndex = weekDays.indexOf(this.model.workWeek[days]);
                if (dayIndex != -1) showWeekDays.push(dayIndex);
            }
            return showWeekDays;
        },

        _resourceRenderDates: function () {
            if (this._tempResource.length > 1) {
                var resCollection = this._resourceSort();
                var resource = [];
                for (var x = 0; x < resCollection.length; x++) {
                    var index = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource.indexOf(resCollection[x]);
                    if (index != -1) resource.push(resCollection[x]);
                }
                this.res1 = resource;
            }
            else
                var resource = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource;
            var resDateRender = [], temp = [], proxy = this;
            this._resDateRen = {};
            for (var a = 0; a < resource.length; a++) {
                var resColl = resource[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                if (!ej.isNullOrUndefined(resColl)) {
                    resColl = this._resourceDaysReorder(resColl);
                    for (var b = 0; b < resColl.length; b++) {
                        var index = this._getDayNameIndex(resColl[b].capitalizeFirstString());
                        if (index == -1) {
                            index = this._getDayNameIndex(resColl[b]);
                        }
                        resDateRender.push(this._renderDates[index]);
                        temp.push(this._renderDates[index]);
                    }
                    this._resDateRen[a] = temp;
                    temp = [];
                }
                else {
                    var resCustomDates = $.extend(true, [], this._dateRender), weekDays = this._getWeekDays();
                    resCustomDates = resCustomDates.filter(function (date) { return weekDays.indexOf(new Date(date).getDay()) != -1; });
                    $.merge(resDateRender, resCustomDates);
                    this._resDateRen[a] = resCustomDates;
                }
            }
            return resDateRender;
        },

        _resourceCustomDates: function () {
            if (this._tempResource.length > 1) {
                var resCollection = this._resourceSort();
                var resource = [];
                for (var x = 0; x < resCollection.length; x++) {
                    var index = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource.indexOf(resCollection[x]);
                    if (index != -1) resource.push(resCollection[x]);
                }
                this.res1 = resource;
            }
            else
                var resource = this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource;
            var resDateRender = [], temp = [], proxy = this;
            this._resCustomDate = {}, this._resCustomCollection = [];
            for (var a = 0; a < resource.length; a++) {
                var resColl = resource[a][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]];
                if (!ej.isNullOrUndefined(resColl)) {
                    var newDate;
                    if ($.type(resColl[0]) == "object") {
                        for (var j = 0; j < resColl.length; j++) {
                            var startDate = resColl[j].start;
                            var endDate = resColl[j].end;
                            var renderDays = Math.round(Math.abs((endDate.getTime() - startDate.getTime()) / (24 * 60 * 60 * 1000))) + 1;
                            var customDate = startDate;
                            for (var i = 0; i < renderDays; i++) {
                                temp.push(new Date(customDate.getFullYear(), customDate.getMonth(), customDate.getDate() + i).getTime());
                            }
                        }
                    } else {
                        for (var b = 0; b < resColl.length; b++) {
                            newDate = new Date(new Date(resColl[b]).getTime());
                            temp.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                        }
                    }
                    temp.sort();
                }
                else {
                    var firstDay = this._firstweekdate(this.currentDate());
                    do {
                        temp.push(new Date(firstDay.getFullYear(), firstDay.getMonth(), firstDay.getDate()).getTime());
                        firstDay.setDate(firstDay.getDate() + 1);
                    } while (temp.length < 7)
                }
                for (var i = 0; i < temp.length; i++) {
                    resDateRender.push(temp[i]);
                }
                if (temp.length > 1) {
                    this._resCustomDate[a] = temp;
                    var obj = {};
                    obj["id"] = resource[a].id;
                    obj["renderDates"] = temp;
                    this._resCustomCollection.push(obj);
                    temp = [];
                }
            }
            return resDateRender;
        },

        _customviewRenderDates: function () {
            if (!ej.isNullOrUndefined(this.model.renderDates)) {
                this._calculateCustomDays();
                var customRenderDates = [], showWeekDays = this._getWeekDays();
                if ($.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) {
                    var newDate;
                    if ($.type(this.model.renderDates[0]) == "object") {
                        for (var j = 0; j < this.model.renderDates.length; j++) {
                            var startDate = new Date(ej.parseDate(ej.format(new Date().parseISO8601(this.model.renderDates[j].start), this._datepattern(), this.model.locale)));
                            var endDate = new Date(ej.parseDate(ej.format(new Date().parseISO8601(this.model.renderDates[j].end), this._datepattern(), this.model.locale)));
                            var renderDays = Math.round(Math.abs((endDate.getTime() - startDate.getTime()) / (24 * 60 * 60 * 1000))) + 1;
                            var customDate = startDate;
                            for (var i = 0; i < renderDays; i++) {
                                if (this.model.showWeekend) {
                                    customRenderDates.push(new Date(customDate.getFullYear(), customDate.getMonth(), customDate.getDate() + i).getTime());
                                }
                                else {
                                    newDate = new Date(customDate.getFullYear(), customDate.getMonth(), customDate.getDate() + i);
                                    var dayIndex = showWeekDays.indexOf(newDate.getDay());
                                    if (dayIndex != -1) customRenderDates.push(new Date(customDate.getFullYear(), customDate.getMonth(), customDate.getDate() + i).getTime());
                                }
                            }
                        }
                    } else {
                        if ($.type(this.model.renderDates[0]) == "string" || $.type(this.model.renderDates[0]) == "date") {
                            var noOfDays = this._renderDays;
                            for (var ia = 0; ia < noOfDays; ia++) {
                                newDate = new Date(new Date(ej.parseDate(ej.format(new Date().parseISO8601(this.model.renderDates[ia]), this._datepattern(), this.model.locale))).getTime());
                                if (this.model.showWeekend) {
                                    customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                                }
                                else {
                                    var dayIndex = showWeekDays.indexOf(newDate.getDay());
                                    if (dayIndex != -1) customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                                }
                            }
                        }
                    }
                    cusomRenderDates = customRenderDates.sort();
                    this._customOrientation = cusomRenderDates.length > 7 ? "horizontal" : this.model.orientation;
                } else {
                    if (this._setCurrentDate && this.model.orientation != "horizontal") {
                        this.oldDate = this.currentDate();
                        if ((this._renderStart.getTime() < this.currentDate().getTime()) && (this._renderEnd.getTime() > this.currentDate().getTime()))
                            this.currentDate(new Date(this._renderStart));
                        else {
                            this._renderStart = new Date(this.currentDate());
                            this._renderEnd = new Date(this._renderStart.getTime() + ((this._renderDays - 1) * 86400000));
                        }
                    }
                    var newDate, firstDay = this._renderDays <= 7 ? new Date(this.currentDate()) : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this._firstweekdate(this.currentDate()) : new Date(this.currentDate());
                    var noOfDays = (this._renderDays <= 7) ? this._renderDays : this._numDays;
                    for (var ia = 0; ia < noOfDays; ia++) {
                        var newDate = new Date(new Date(firstDay).getTime() + (1000 * 60 * 60 * 24 * ia));
                        if (this.model.showWeekend) {
                            customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                        }
                        else {
                            var dayIndex = showWeekDays.indexOf(newDate.getDay());
                            if (dayIndex != -1) customRenderDates.push(new Date(newDate.getFullYear(), newDate.getMonth(), newDate.getDate()).getTime());
                        }
                    }
                }
            }
            else {
                var customRenderDates = this._monthdates();
            }
			if (this._intialRenderedDates.length == 0)
			    this._intialRenderedDates = customRenderDates;
			if (customRenderDates.length == 0)
			    customRenderDates = this._intialRenderedDates;
            return customRenderDates;
        },

        _getRenderDates: function () {
            this.currentDate(new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0)));
            this._dateRender = [];
            if (this.currentView() === "week" || this.currentView() === "workweek") {
                if (this.model.showWeekend) {
                    var firstDay = this._firstweekdate(this.currentDate());
                    do {
                        this._dateRender.push(new Date(firstDay.getFullYear(), firstDay.getMonth(), firstDay.getDate()).getTime());
                        firstDay.setDate(firstDay.getDate() + 1);
                    } while (this._dateRender.length < 7)
                    this._renderDates = $.extend(true, [], this._dateRender);
                } else {
                    var showWeekDays = this._getWeekDays();
                    var weekFirst = this._firstweekdate(this.currentDate());
                    do {
                        var dayIndex = showWeekDays.indexOf(weekFirst.getDay());
                        if (dayIndex != -1) this._dateRender.push(new Date(weekFirst.getFullYear(), weekFirst.getMonth(), weekFirst.getDate()).getTime());
                        weekFirst = new Date(new Date(weekFirst).getTime() + (1000 * 60 * 60 * 24));
                    } while (this._dateRender.length != this.model.workWeek.length)
                    this._renderDates = $.extend(true, [], this._dateRender);
                }
                if (this._resWorkWeek) {
                    this.dateRender = this._dateRender = this._resourceRenderDates();
                } else if (this.currentView() == "workweek" && this.model.showWeekend) {
                    var proxy = this;
                    var reorderDays = this._daysReorder(this._firstdayofweek);
                    var weekDays = this.model.workWeek.map(function (day) { return proxy._dayNamesArray.indexOf(day); });
                    var workweek = reorderDays.filter(function (a) { return weekDays.indexOf(a) !== -1; });
                    var filterDate = this._dateRender.map(function (date) { if (workweek.indexOf(new Date(date).getDay()) != -1) return date; });
                    this._dateRender = filterDate.filter(function (date) { return date != undefined; });
                }
            } else if (this.currentView() === "month") {
                this._dateRender = this._monthdates();
            } else if (this.currentView() === "customview") {
                this._dateRender = (this._resCustomView) ? this._resourceCustomDates() : this._customviewRenderDates();
            } else {
                if (!this.model.showWeekend) {
                    var showWeekDays = this._getWeekDays();
                    if (showWeekDays.indexOf(this.currentDate().getDay()) == -1) {
                        var noOfDays = this._getPrevNextDateCount(this.currentDate(), "next");
                        this.currentDate(new Date(this.currentDate().getTime() + (1000 * 60 * 60 * 24 * noOfDays)));
                    }
                }
                this._dateRender.push(new Date(this.currentDate().getFullYear(), this.currentDate().getMonth(), this.currentDate().getDate()).getTime());
            }
            return this._dateRender;
        },

        _getAgendaDateCount: function () {
            var count = (this.model.agendaViewSettings.daysInAgenda > 0) ? this.model.agendaViewSettings.daysInAgenda - 1 : 0;
            if (!this.model.showWeekend) {
                var showWeekDays = this._getWeekDays(), daysCount = 0;
                var weekFirst = agendaDate = new Date(this.currentDate());
                do {
                    var dayIndex = showWeekDays.indexOf(weekFirst.getDay());
                    if (dayIndex != -1) daysCount++;
                    weekFirst = new Date(new Date(weekFirst).getTime() + (1000 * 60 * 60 * 24));
                } while (this.model.agendaViewSettings.daysInAgenda != daysCount)
                count = (weekFirst.getTime() - agendaDate.getTime()) / (1000 * 60 * 60 * 24) - 1;
            }
            return count;
        },

        _getCurrentDateHeaderValue: function () {
            var dateValue, value = (this._resWorkWeek) ? this._renderDates : this._dateRender;
            if (this.currentView() === "day") {
                if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat))
                    dateValue = ej.format(new Date(value[0]), this.model.dateFormat, this.model.locale);
                else {
                    var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim();
                    if (ddt.toLowerCase().startsWith("d"))
                        dateValue = ej.format(new Date(value[0]), "dd MMM yyyy", this.model.locale);
                    else if (ddt.toLowerCase().startsWith("m"))
                        dateValue = ej.format(new Date(value[0]), "MMM dd, yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(value[0]), ddt, this.model.locale);
                }
            }
            else if (this.currentView() === "week" || this.currentView() === "workweek" || this.currentView() == "agenda") {
                var startDate = this.currentView() == "agenda" ? new Date(this.currentDate()) : new Date(value[0]),
                endDate = this.currentView() == "agenda" ? new Date(new Date(this.currentDate()).setDate(startDate.getDate() + this._getAgendaDateCount())) : new Date(value[value.length - 1]);
                dateValue = this._formatDateHeaderValue(startDate, endDate);
            }
            else if (this.currentView() === "customview") {
                if (value.length == 1) {
                    if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat))
                        dateValue = ej.format(new Date(value[0]), this.model.dateFormat, this.model.locale);
                    else {
                        var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim();
                        if (ddt.toLowerCase().startsWith("d"))
                            dateValue = ej.format(new Date(value[0]), "dd MMM yyyy", this.model.locale);
                        else if (ddt.toLowerCase().startsWith("m"))
                            dateValue = ej.format(new Date(value[0]), "MMM dd, yyyy", this.model.locale);
                        else
                            dateValue = ej.format(new Date(value[0]), ddt, this.model.locale);
                    }
                }
                else if (value.length > 1 && value.length <= 7 && !this._resCustomView && (!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "object"))
                    dateValue = this._formatDateHeaderValue(new Date(value[0]), new Date(value[value.length - 1]));
                else {
                    var beforeSortValue = value;
                    value = value.concat().sort();
                    if (new Date(value[0]).getFullYear() == new Date(value[value.length - 1]).getFullYear()) {
                        if (new Date(value[0]).getMonth() == new Date(value[value.length - 1]).getMonth())
                            dateValue = ej.format(new Date(value[0]), "MMM yyyy", this.model.locale);
                        else
                            dateValue = ej.format(new Date(value[0]), "MMM", this.model.locale) + " - " + ej.format(new Date(value[value.length - 1]), "MMM yyyy", this.model.locale);
                    }
                    else
                        dateValue = ej.format(new Date(value[0]), "MMM yyyy", this.model.locale) + " - " + ej.format(new Date(value[value.length - 1]), "MMM yyyy", this.model.locale);
                    // Reassigning the values
                    value = beforeSortValue;
                }
            }
            else
                dateValue = ej.format(new Date(this.currentDate()), "MMM yyyy", this.model.locale);
            return dateValue;
        },

        _firstweekdate: function (currentDate) {
            var firstdayofweek = new Date(currentDate);
            var day = firstdayofweek.getDay();
            if (this._firstdayofweek == 0) {
                if (day != 0) {
                    firstdayofweek.setDate(firstdayofweek.getDate() - day);
                    if (!this.model.timeScale.enable && (this.currentView() == "workweek" || this._oneWeek) && this._resize)
                        firstdayofweek = new Date(this._dateRender[0]);
                }
            }
            else if (this._firstdayofweek != 0) {
                var diff = ((firstdayofweek.getDay() - this._firstdayofweek) < 0) ? (7 + firstdayofweek.getDay() - this._firstdayofweek) : (firstdayofweek.getDay() - this._firstdayofweek);
                firstdayofweek = new Date(firstdayofweek.setDate(firstdayofweek.getDate() - diff));
            }
            return firstdayofweek;
        },

        _formatDateHeaderValue: function (startDate, endDate) {
            if (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) {
                var dateValue = ej.format(startDate, this.model.dateFormat, this.model.locale) + " - " + ej.format(endDate, this.model.dateFormat, this.model.locale);
                return dateValue;
            }
            var ddt = this._pattern.D.toString().replace(/\s*dddd,?/, "").trim(), dateValue;
            if (ddt.toLowerCase().startsWith("d")) {
                if (new Date(startDate).getYear() === new Date(endDate).getYear()) {
                    if (new Date(startDate).getMonth() === new Date(endDate).getMonth())
                        dateValue = ej.format(new Date(startDate), "dd", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(startDate), "dd MMM", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
                } else
                    dateValue = ej.format(new Date(startDate), "dd MMM yyyy", this.model.locale) + " - " + ej.format(new Date(endDate), "dd MMM yyyy", this.model.locale);
            }
            else if (ddt.toLowerCase().startsWith("m")) {
                if (new Date(startDate).getYear() === new Date(endDate).getYear()) {
                    if (new Date(startDate).getMonth() === new Date(endDate).getMonth())
                        dateValue = ej.format(new Date(startDate), "MMM dd", this.model.locale) + " - " + ej.format(new Date(endDate), "dd, yyyy", this.model.locale);
                    else
                        dateValue = ej.format(new Date(startDate), "MMM dd", this.model.locale) + " - " + ej.format(new Date(endDate), "MMM dd, yyyy", this.model.locale);
                } else
                    dateValue = ej.format(new Date(startDate), "MMM dd, yyyy", this.model.locale) + " - " + ej.format(new Date(endDate), "MMM dd, yyyy", this.model.locale);
            } else
                dateValue = ej.format(new Date(startDate), ddt, this.model.locale) + " - " + ej.format(new Date(endDate), ddt, this.model.locale);
            return dateValue
        },

        _getHeaderAllDayCellsCount: function () {
            var temp, headerCellClass, count, columns = [], cols = [], curday, resCount = 1; this.dateRender = []; this._value = []; this.value = [];
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                if (!ej.isNullOrUndefined(this.model.dateHeaderTemplateId) && (this.currentView() != "month" && !this._isCustomMonthView())) {
                    columns = this._getUserDateheaderTemplate();
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                        var getCount = this._getMultipleResourceCellsCount(count);
                        resCount = getCount.resCount;
                        if ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0)
                            resCount = 1;
                    }
                }
                else {
                    count = this._getColumnCount().length;
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                        var getCount = this._getMultipleResourceCellsCount(count);
                        resCount = getCount.resCount;
                        if ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0)
                            resCount = 1;
                    }
                    for (var i = 0; i < count; i++) {
                        curday = (this.currentView() === "month" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                        headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday" : "";
                        temp = (this.currentView() === "month" || (this._isCustomMonthView())) ? { currentDay: curday, currentDateClass: "", cellToday: "" } : this.currentView() === "day" ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? { currentDay: ej.format(new Date(this._dateRender[i]), this._pattern.D, this.model.locale), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: "", cellToday: headerCellClass } : { currentDay: curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass };
                        columns.push(temp);
                        this._value.push(i);
                    }
                }
                if (this._resWorkWeek || this._resCustomView) {
                    cols = $.merge(cols, columns);
                    this.dateRender = $.merge(this.dateRender, this._dateRender);
                    this.value = $.merge(this.value, this._value);
                }
                else {
                    for (var i = 0; i < resCount; i++) {
                        this.dateRender = $.merge(this.dateRender, this._dateRender);
                        cols = $.merge(cols, columns);
                        this.value = $.merge(this.value, this._value);
                    }
                }
            }
            else
                cols = this._getHorizontalheaderCellCount(this._culture);
            return cols;
        },

        _findResourceIndex: function (data, attr1, value, attr2, val) {
            for (var i = 0; i < data.length; i++) {
                if (!(ej.isNullOrUndefined(val))) {
                    if (data[i][attr1] == value && data[i][attr2] == val) {
                        return i;
                    }
                }
                else {
                    if (data[i][attr1] == value) {
                        return i;
                    }
                }
            }
        },

        _renderHeaderAllDayTemplate: function () {
            if (this.currentView() != "agenda") {
                if (ej.scheduleFeatures.horizontal && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) {
                    if ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) this._renderMultipleResourceHeaderTemplate(null, null);
                    this._renderHorizontalHeaderBar();
                }
                else {
                    var headerScrollDiv = ej.buildTag("div.e-headerscrolldiv");
                    var headerDiv = ej.buildTag('div.e-headeralldaydiv', "", {}, {}).css({ position: "relative", overflow: "hidden" });
                    var resCount = 0;
                    var table = ej.buildTag('table.e-table e-headrealldaytable', "", {}, {});
                    var tbody = ej.buildTag('tbody');
                    var headTR = ej.buildTag('tr.e-dateheader');
                    var cols = this._getHeaderAllDayCellsCount();
                    var html = this.headTemplate.render({ cols: cols, view: this.currentView(), colspan: 1 });
                    if ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) {
                        tbody = this._renderMultipleResourceHeaderTemplate(tbody, cols);
                        resCount = !ej.isNullOrUndefined(this.model.group) ? this._grouping.length : 0;
                        if (this._tempResource.length != 0 && this._tempResource[0].resourceSettings.dataSource.length == 0) resCount = 0;
                    }
                    var tempNavigate = ej.buildTag('div.e-navigate', "", {}, {});
                    var inner_table = ej.buildTag('table.e-table e-headertable', "", {}, {});
                    var tb = ej.buildTag('tbody');
                    var headT = ej.buildTag('tr.e-headertr');
                    var headTrCount = (this.currentView() == "month") || (this._isCustomMonthView()) ? 1 : 2;
                    var rowCount = resCount + headTrCount; var rows = [];
                    for (var i = 0; i < rowCount; i++) {
                        if (this.currentView() == "month" || (this._isCustomMonthView()))
                            rows.push({ tdClass: (i == rowCount - 1) ? "e-monthleftcells" : "e-resourceleftindentcells", divClass: (i == rowCount - 1) ? "e-dateheadercell" : "" });
                        else
                            rows.push({ tdClass: (i == rowCount - 1) ? "e-leftindent" : (i == rowCount - 2) ? "e-settingsindent" : "e-resourceleftindentcells", divClass: (i == rowCount - 1) ? "e-schedulesettings e-textellipsis" : (i == rowCount - 2) ? "e-dateheadercell" : "" });
                    }
                    if (!this.model.showAllDayRow)
                        new ej.DataManager(rows).remove("tdClass", "e-leftindent");
                    var leftIndentHtml = this.leftIndent.render({ trs: rows });
                    if (this.model.timeScale.enable)
                        this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td.e-empty').addClass((this.currentView() == "month" || this._isCustomMonthView()) ? "e-monthempty" : "").append(leftIndentHtml)).append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(headTR.append(html))))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, {}).css({ width: (this.currentView() == "month" || this._isCustomMonthView()) ? "0px" : (this._mediaQuery) ? "0px" : "18px" })))))));
                    else
                        this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(headTR.append(html))))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, {}).css({ width: (this.currentView() == "month" || this._isCustomMonthView()) ? "0px" : (this._mediaQuery) ? "0px" : "18px" })))))));
                    if (this.currentView() !== "month" && !this._isCustomMonthView() && this.model.timeScale.enable && this.model.showAllDayRow) {
                        var userTemplate = (!ej.isNullOrUndefined(this.model.allDayCellsTemplateId)) ? true : false;
                        if (userTemplate) { var allDayHtml = this._getUserAllDayCellsTemplate(); }
                        var allHtml = this.alldayTemp.render({ cols: cols, colspan: 1, userTemp: userTemplate, userHtml: allDayHtml });
                        tbody.append(ej.buildTag('tr').append(allHtml));
                    }
                }
            }
            else {
                var tempNavigate = ej.buildTag('div.e-navigate', "", {}, {});
                var inner_table = ej.buildTag('table.e-table e-headertable', "", {}, {});
                var tb = ej.buildTag('tbody');
                var headT = ej.buildTag('tr.e-headertr');
                var headerScrollDiv = ej.buildTag("div.e-headerscrolldiv");
                var headerDiv = ej.buildTag('div.e-headeralldaydiv', "", {}, {}).css({ position: "relative", overflow: "hidden" });
                var table = ej.buildTag('table.e-table e-headrealldaytable', "", {}, {}).css({ width: "100%" });
                var tbody = ej.buildTag('tbody tr');
                var colspan = 1;
                var cols = [{ headertext: this._getLocalizedLabels("Date"), className: "e-datecolumn" }, { headertext: this._getLocalizedLabels("Time"), className: "e-timecolumn" }, { headertext: this._getLocalizedLabels("Event"), className: "e-eventcolumn" }];
                if (this._tempResource.length != 0 && ej.scheduleFeatures.resources) {
                    this._renderMultipleResourceHeaderTemplate(null, null);
                    var res = [];
                    for (var resLevel = 0; resLevel < this.render_Resources.length; resLevel++)
                        res.push({ headertext: "", className: "e-resourcecolumn" });
                    (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) && (cols = $.merge(res, cols));
                }
                var html = this.agendaheadTemplate.render({ cols: cols });
                this.aTR.append(ej.buildTag('td').append(tempNavigate.append(inner_table.append(tb.append(headT.append(ej.buildTag('td').append(headerScrollDiv.append(headerDiv.append(table.append(tbody.append(html)))))).append(ej.buildTag('td.e-emptyscrolltd', "", {}, {}).css({ width: "18px" })))))));
            }
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderHeaderAllDayTemplate");
        },
        _getDateTime: function (args) {
            var _target = args;
            if (this.model.timeScale.enable)
                this._cellIndex = (_target.is('.e-workcells, .e-alldaycells') || this._isCustomMonthView() && this._oneWeek) ? _target.index() : 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7);
            else
                this._cellIndex = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month") || (this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7) : _target.index();
            if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) : this._cellIndex : _target.index();
                this._workCellIndex = _target.parent().index();
            }
            var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : ((this.model.orientation == "vertical" && this._customOrientation == "vertical") || this.currentView() == "customview" && this._dateRender.length <= 7) ? (this._resWorkWeek || this._resCustomView) ? this._dateRender : this.dateRender : this._dateRender;
            renderDate = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDate;
            var curDate = new Date(renderDate[this._cellIndex]);
            if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
            if (_target.hasClass("e-workcells") && (this.model.showTimeScale) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                this._calcCurrentTime(curDate, _target, "");
            }
            else {
                this.cur_StartTime = new Date(new Date(curDate).setHours(0, 0, 0));
                this.cur_EndTime = new Date(new Date(curDate).setHours(23, 59, 59));
            }
            var result;
            if (_target.hasClass("e-horizontmonthheaderdaytd")) {
                result = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, currentDate: curDate, cellIndex: this._cellIndex };
            }
            else {
                result = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, currentDate: curDate, cellIndex: this._cellIndex, resources: (this._tempResource.length != 0) ? this._getResourceValue(_target, this._cellIndex) : null };
            }
            return result;
        },

        _getAgendaAppointment: function (_target) {
            var appoint = [];
            if (_target.hasClass("e-datecolumn")) {
                var rowspan = $(_target).attr('rowspan');
                var appEvents = $(_target).parent().nextAll("tr").andSelf().slice(0, parseInt(rowspan));
                if (appEvents.length > 0) {
                    for (var m = 0; m < appEvents.length; m++) {
                        var tempGUID = $(appEvents[m]).find(".e-eventcolumn .e-agendaappointment").attr("data-guid");
                        appoint.push(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempGUID))[0]);
                    }
                }
            } else {
                var appoint = _target.hasClass("e-agendaappointment") ? _target : _target.parent().find(".e-agendaappointment");
                var _appUid = appoint.attr("data-guid");
                if (this._mediaQuery)
                    this._mAppId = _appUid;
                appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, _appUid));
            }
            return appoint;
        },

        _monthdates: function () {
            var currentDate = new Date(this.currentDate());
            var currentMonth = currentDate._currentMonthDates();
            var monthStart = currentMonth.start._currentWeekDates(this._firstdayofweek).start;
            var monthEnd = currentMonth.end._currentWeekDates(this._firstdayofweek).end;
            var dates = []; this.monthDays = [];
            var showWeekDays = this._getWeekDays();
            var monthDate = new Date(monthStart.getFullYear(), monthStart.getMonth(), monthStart.getDate());
            do {
                if (this.model.showWeekend) {
                    dates.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                    if (new Date(currentDate).getMonth() === new Date(monthDate).getMonth())
                        this.monthDays.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                }
                else {
                    var dayIndex = showWeekDays.indexOf(new Date(monthDate).getDay());
                    if (dayIndex != -1) {
                        dates.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                        if (new Date(currentDate).getMonth() === new Date(monthDate).getMonth())
                            this.monthDays.push(new Date(monthDate.getFullYear(), monthDate.getMonth(), monthDate.getDate()).getTime());
                    }
                }
                monthDate.setDate(monthDate.getDate() + 1);
            } while (monthDate.getTime() <= monthEnd.getTime())
            return (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? dates : this.monthDays;
        },

        _getStartEndTime: function () {
            var timerows, startendTimes = [], timelist;
            this._timeInitial = 0;
            var localizeAmPm = this._culture.calendar;
            if (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") {
                if (this.currentView() == "month" || this._isCustomMonthView()) {
                    var row = this._dateRender.length, count = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    for (var i = 0; i < (row / count) ; i++) {
                        startendTimes.push(i);
                    }
                }
                else {
                    if (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) {
                        startendTimes = this._getUserTimeCellsTemplate();
                    }
                    else {
                        var dateValue = new Date(new Date().setHours(0, 0, 0, 0));

                        for (var i = this.model.startHour * 60; i < this.model.endHour * 60;) {
                            if (this._timeMode == "12") {
                                if (new Date(new Date(dateValue).setHours(this.model.endHour, 0, 0, 0)).getTime() > new Date(new Date(dateValue).setHours(0, i, 0, 0)).getTime()) {
                                    timelist = (((i / 60) === this.model.startHour || (i / 60) === 12) && (localizeAmPm.AM && localizeAmPm.PM)) ? ej.format(new Date(new Date(dateValue).setHours(0, i, 0, 0)), "hh tt", this.model.locale) : ej.format(new Date(new Date(dateValue).setHours(0, i, 0, 0)), "hh mm", this.model.locale);
                                    startendTimes.push({ time: timelist, id: (i / 60) });
                                }
                            }
                            else
                                startendTimes.push({ time: new Date(new Date(dateValue).setHours(0, i, 0, 0)).toTimeString().slice(0, 5) + " 00" });
                            i = i + this.model.timeScale.majorSlot;
                        }
                    }
                }
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                startendTimes = this._getHoriStartEndTime(localizeAmPm);
            return startendTimes;
        },

        _getWorkCellsCount: function () {
            var workcells = [], count = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            if (this.model.timeScale.enable) {
                if (this.currentView() == "month" || (this._isCustomMonthView())) {
                    var row = this._dateRender.length;
                    for (var i = 0; i < (row / count) ; i++) {
                        workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                    }
                }
                else {
                    var strEndTime = this._getStartEndTime();
                    var value = 0;
                    for (var i = 0; i < (this.model.timeScale.minorSlotCount * strEndTime.length) ; i++) {
                        value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value > (this.model.endHour - this.model.startHour) * 60) {
                            workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                            break;
                        }
                        else
                            workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                    }
                }
            }
            else {
                var row = (this._resWorkWeek || this._resCustomView) ? 1 : this._dateRender.length;
                for (var i = 0; i < (row / count) ; i++) {
                    workcells.push({ crow: i, cwidth: this.model.cellWidth, cheight: this.model.cellHeight });
                }
            }
            return workcells;
        },

        _renderContentAreaTemplate: function () {
            var $contentAreaDiv = ej.buildTag('div.e-workareadiv');
            var $contentTable = ej.buildTag('table.e-table e-worktable', "", {}, {});
            var $contentBody = ej.buildTag('tbody');
            var $contentTR = ej.buildTag('tr');
            var $WorkCellTD = ej.buildTag('td');
            var $scrollerbarDiv = ej.buildTag('div#' + this._id + "_scroller");
            this.$WorkCellDiv = ej.buildTag('div.e-draggableworkarea');
            if (this.currentView() != "agenda") {
                if (ej.scheduleFeatures.horizontal && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal"))
                    this._renderHorizontalContent($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv);
                else {
                    this.$TimeCellTD = ej.buildTag('td', "", {}, {}).addClass((this.currentView() == "month" || this._isCustomMonthView()) ? "e-monthleftindent" : "e-workleftindent");
                    var timeCellhtml, workCellhtml;
                    var userTemplateId = ((!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId) && !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) || !ej.isNullOrUndefined(this.model.timeScale.minorSlotTemplateId)) ? true : false;
                    var template = (!ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId)) ? true : false;
                    var viewclass = this.currentView() == "month" || (this._isCustomMonthView()) ? 1 : 0;
                    var columnValueCount = this._timeSlotCount(userTemplateId, template);
                    if ((userTemplateId || template) && (this.currentView() != "month" && !(this._isCustomMonthView()))) {
                        columnValueCount.columnCount.pop();
                        timeCellhtml = this.userTimeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, cheight: this.model.cellHeight, userTemplateId: userTemplateId, timeValue1: columnValueCount.timeValue1, template: template });
                    }
                    else
                        timeCellhtml = this.timeCellTemplate.render({ timerows: this._getStartEndTime(), cols1: columnValueCount.columnCount, viewclass: viewclass, timeScale: this.model.timeScale.minorSlotCount, userTemplateId: userTemplateId, template: template });
                    var userTemplate = (!ej.isNullOrUndefined(this.model.workCellsTemplateId)) ? true : false;
                    if (userTemplate) { var workHtml = this._getUserWorkCellsTemplate(); }
                    if (this.currentView() != "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable)
                        workCellhtml = this.workcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: this.value, orientation: this.model.orientation, timeScale: this.model.timeScale.minorSlotCount, userTemplate: userTemplate, userHtml: workHtml });
                    else
                        workCellhtml = this.monthcellTemp.render({ cellrows: this._getWorkCellsCount(), cols1: this.value, orientation: this.model.orientation, timeScale: this.model.timeScale.minorSlotCount, userTemplate: userTemplate, userHtml: workHtml, tenable: this.model.timeScale.enable, cview: (this.currentView() !== "month" && !this._isCustomMonthView()) });
                    if (this.model.timeScale.enable)
                        this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append(this.$TimeCellTD.append(timeCellhtml)).append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
                    else
                        this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
                }
            }
            else
                this.wTR.append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv))))))));
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderContentAreaTemplate");
        },

        _renderQueryCellInfo: function (method, record, temp) {
            if (method == "renderHeaderBar") {
                this._trigger("queryCellInfo", { element: temp, requestType: "headerBar" });
            }
            if (method == "appointment") {
                this._trigger("queryCellInfo", { appointment: record, element: temp, requestType: "appointment" });
            }
            if (method == "blockAppointment") {
                this._trigger("queryCellInfo", { appointment: record, element: temp, requestType: "blockoutCells" });
            }
            if (method == "emptycell") {
                var emptytd = this.aTR.find(".e-emptyscrolltd");
                this._trigger("queryCellInfo", { element: $(emptytd[0]), requestType: "emptytd" });
            }
            if (method == "renderAgendaContent") {
                var headerCells = this.aTR.find(".e-headercells");
                for (var i = 0; i < headerCells.length; i++) {
                    this._trigger("queryCellInfo", { element: $(headerCells[i]), cellType: "agendaheadercells", requestType: "agendacells" });
                }
                var dateColumn = this.element.find(".e-draggableworkarea").find(".e-datecolumn");
                var timeColumn = this.element.find(".e-draggableworkarea").find(".e-timecolumn");
                var eventColumn = this.element.find(".e-draggableworkarea").find(".e-eventcolumn");
                if (this._tempResource.length != 0) {
                    var resourceColumn = this.element.find(".e-draggableworkarea").find(".e-resourcecolumn");
                    for (var i = 0; i < resourceColumn.length; i++) {
                        var result = this._getAgendaAppointment($(resourceColumn[i]));
                        this._trigger("queryCellInfo", { appointment: result[0], element: $(resourceColumn[i]), cellType: "agendaresourcecell", requestType: "agendacells" });
                    }
                }
                for (var i = 0; i < dateColumn.length; i++) {
                    var result = this._getAgendaAppointment($(dateColumn[i]));
                    this._trigger("queryCellInfo", { currentAppointmentDate: new Date(new Date(result[0][this._appointmentSettings['startTime']]).setHours(0, 0, 0)), appointments: result, element: $(dateColumn[i]), cellType: "agendadatecell", requestType: "agendacells" });
                }
                for (var i = 0; i < timeColumn.length; i++) {
                    var result = this._getAgendaAppointment($(timeColumn[i]));
                    this._trigger("queryCellInfo", { appointment: result[0], element: $(timeColumn[i]), cellType: "agendatimecell", requestType: "agendacells" });
                }
                for (var i = 0; i < eventColumn.length; i++) {
                    var result = this._getAgendaAppointment($(eventColumn[i]));
                    this._trigger("queryCellInfo", { appointment: result[0], element: $(eventColumn[i]), cellType: "agendaeventcell", requestType: "agendacells" });
                }
            }
            else if (method == "renderHeaderAllDayTemplate") {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var headerCells = this.aTR.find(".e-headercells");
                    var resInfo = this.res1;
                    var headerDates = this._getHeaderAllDayCellsCount();
                    this.res1 = resInfo;
                    if (this.model.showAllDayRow) {
                        var alldayElements = this.aTR.find(".e-alldaycells");
                        for (var i = 0; i < alldayElements.length; i++) {
                            var result = this._getDateTime($(alldayElements[i]));
                            var event = {
                                cellIndex: result.cellIndex,
                                currentDate: result.currentDate,
                                resources: result.resources
                            };
                            this._trigger("queryCellInfo", { cell: event, element: $(alldayElements[i]), requestType: "alldaycells" });
                        }
                    }
                    if (this.currentView() != "agenda") {
                        var numberOfDates = headerCells.length / this.res1.length;
                        for (var i = 0; i < headerCells.length; i++) {
                            var k = Math.floor(i / numberOfDates);
                            this._trigger("queryCellInfo", { resource: this.res1[k], currentDay: headerDates[i].currentDay, element: $(headerCells[i]), requestType: "headercells" });
                        }
                    }
                    if ((this._tempResource.length != 0)) {
                        var resource = [];
                        var resourceHeaderCells = this.aTR.find(".e-resourcecells");
                        var resourceHeaderDivCells = this.aTR.find(".e-resourceleftindentcells");
                        for (var j = 0; j < this._tempResource.length; j++) {
                            $.merge(resource, this._tempResource[j].resourceSettings.dataSource);
                        }
                        for (var i = 0; i < resourceHeaderCells.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[i], element: $(resourceHeaderCells[i]), cellType: "headercells", requestType: "resourceheadercells" });
                        }
                        for (var i = 0; i < resourceHeaderDivCells.length; i++) {
                            this._trigger("queryCellInfo", { element: $(resourceHeaderDivCells[i]), cellType: "headerdivcells", requestType: "resourceheadercells" });
                        }
                    }
                    if (this.currentView() != "month" || !this._isCustomMonthView()) {
                        var indent = this.aTR.find(".e-leftindent");
                        this._trigger("queryCellInfo", { element: indent, requestType: "leftindentcells" });
                    }
                    var leftHeaderCells = (this.currentView() == "month" || this._isCustomMonthView()) ? this.aTR.find(".e-monthleftcells") : this.aTR.find(".e-settingsindent");
                    this._trigger("queryCellInfo", { element: leftHeaderCells, requestType: "leftheadercells" });
                }
                else {
                    var headercells = this.aTR.find(".e-headercells");
                    var resInfo = this.res1;
                    var headerDates = this._getHeaderAllDayCellsCount();
                    this.res1 = resInfo;
                    var timeCells = this.aTR.find(".e-horizontaltimetd ");
                    var timeCellsDiv = this.aTR.find(".e-horizontalalternatetd");
                    var timeCellsStartTime = this._getStartEndTime();
                    for (var i = 0; i < timeCells.length; i++) {
                        this._trigger("queryCellInfo", { cell: timeCellsStartTime[i], element: $(timeCells[i]), cellType: "timecell", requestType: "timecells" });
                    }
                    for (var i = 0; i < timeCellsDiv.length; i++) {
                        this._trigger("queryCellInfo", { element: $(timeCellsDiv[i]), cellType: "timeampmcell", requestType: "timecells" });
                    }

                    if (this.currentView() != "agenda") {
                        for (var i = 0; i < headercells.length; i++) {
                            this._trigger("queryCellInfo", { currentDay: headerDates[i].currentDay, element: $(headercells[i]), requestType: "headercells" });
                        }
                    }
                    var dateHeader = this.aTR.find(".e-horizontmonthheaderdaytd");
                    for (var i = 0; i < dateHeader.length; i++) {
                        var result = this._getDateTime($(dateHeader[i]));
                        var event = {
                            cellIndex: result.cellIndex,
                            currentDate: result.currentDate
                        };
                        this._trigger("queryCellInfo", { cell: event, element: $(dateHeader[i]), requestType: "headerdate" });
                    }
                    if ((this._tempResource.length != 0)) {
                        var resourceGroupHeader = this.aTR.find(".e-horizontalheader");
                        for (var i = 0; i < resourceGroupHeader.length; i++) {
                            this._trigger("queryCellInfo", { element: $(resourceGroupHeader[i]), requestType: "resourcegroupheader" });
                        }
                    }
                }
            }
            else if (method == "renderContentAreaTemplate") {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var tdElements, reqType;
                    timeCellsDiv = this.wTR.find(".e-timecelldivs");
                    timeCellAMPM = this.wTR.find(".e-ampmdisplay");
                    timeCellsStartTime = this._getStartEndTime();
                    if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                        tdElements = this.wTR.find(".e-workcells");
                        reqType = "workcells";
                    }
                    else {
                        tdElements = this.wTR.find(".e-monthcells");
                        reqType = "monthcells";
                    }
                    for (var i = 0; i < timeCellsDiv.length; i++) {
                        this._trigger("queryCellInfo", { cell: timeCellsStartTime[i], element: $(timeCellsDiv[i]).parent(), cellType: "timecell", requestType: "timecells" });
                    }
                    for (var i = 0; i < timeCellAMPM.length; i++) {
                        this._trigger("queryCellInfo", { element: $(timeCellAMPM[i]), cellType: "timeampmcell", requestType: "timecells" });
                    }
                    for (var i = 0; i < tdElements.length; i++) {
                        var result = this._getDateTime($(tdElements[i])), event;
                        if (this.currentView() != "month" && this.currentView() != "customview" && this.model.timeScale.enable) {
                            event = {
                                cellIndex: result.cellIndex,
                                startTime: result.startTime,
                                endTime: result.endTime,
                                resources: result.resources
                            };
                        }
                        else {
                            event = {
                                cellIndex: result.cellIndex,
                                currentDate: result.currentDate,
                                resources: result.resources
                            };
                        }
                        this._trigger("queryCellInfo", { cell: event, element: $(tdElements[i]), requestType: reqType });
                    }
                }
                else {
                    var tdElements;
                    tdElements = !ej.isNullOrUndefined(this.$WorkCellDiv) ? this.$WorkCellDiv.find(".e-workcells") : null;
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.$WorkCellDiv)) {
                        var resourceHeaderCells = this.$WorkCellDiv.find(".e-resourceheadercells");
                        var resource = this._resourceSort();
                        var resourceHeader = this.wTR.find('.e-horizontresheaderdiv');
                        for (var i = 0; i < resourceHeader.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[$(resourceHeaderCells[i]).index()], element: $(resourceHeader[i]), cellType: "headerdivcells", requestType: "resourceheadercells" });
                        }
                        for (var i = 0; i < resourceHeaderCells.length; i++) {
                            this._trigger("queryCellInfo", { resource: resource[$($(resourceHeaderCells[i]).parent()).index()], element: $(resourceHeaderCells[i]), cellType: "headercells", requestType: "resourceheadercells" });
                        }
                    }
                    if (!ej.isNullOrUndefined(tdElements)) {
                        for (var i = 0; i < tdElements.length; i++) {
                            if ($(tdElements[i]).hasClass("e-childworkcell") && $(tdElements[i]).hasClass("e-workcells")) {
                                var result = this._getDateTime($(tdElements[i]));
                                var event = {
                                    cellIndex: result.cellIndex,
                                    startTime: result.startTime,
                                    endTime: result.endTime,
                                    resources: result.resources
                                };
                                this._trigger("queryCellInfo", { cell: event, element: $(tdElements[i]), requestType: "workcells" });
                            }
                        }
                    }
                }
            }
        },

        _timeSlotCount: function (userTemplateId, template) {
            var value = 0, columnValue = [], cols2 = [];
            if ((!userTemplateId && !template) || (this.currentView() === "month" || (this._isCustomMonthView()))) {
                var strTime = this._getStartEndTime();
                var lenMinorSlot = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.model.timeScale.minorSlotCount : this.model.timeScale.minorSlotCount - 1;
                for (var j = 0; j < strTime.length; j++) {
                    for (var i = 0; i < lenMinorSlot; i++) {
                        var value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                        if (value > (this.model.endHour - this.model.startHour) * 60) {
                            columnValue.push(i);
                            if (i == (this.model.timeScale.minorslotcount - 2)) {
                                value = 0; break;
                            }
                        }
                        else
                            columnValue.push(i);
                    }
                    cols2.push(columnValue);
                    value = value + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    columnValue = [];
                }
                var columnCount = cols2;
            }
            else {
                for (var i = 0; i < this.model.timeScale.minorSlotCount; i++) {
                    columnValue.push(i);
                }
                var columnCount = columnValue;
            }

            if ((userTemplateId || template) && (this.currentView() !== "month" && !(this._isCustomMonthView()))) {
                var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
                var userTemp1 = $.templates($(this.model.timeScale.majorSlotTemplateId).html());
                var timeValue1 = [], j = 0;
                for (var i = this.model.startHour; i < this.model.endHour;) {
                    var timeValue = [];
                    var value = this.model.timeScale.majorSlot + j;
                    var jvalue = j;
                    while (j < value) {
                        var jval = j;
                        j = j * 60 * 1000;
                        if (this._timeMode == "12") {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        else {
                            if (jval == jvalue && !ej.isNullOrUndefined(this.model.timeScale.majorSlotTemplateId))
                                timeValue.push(userTemp1.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                            else
                                timeValue.push(userTemp.render(object = { date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) }).trim());
                        }
                        j = (j / 60000) + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
                    }
                    i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : j >= 60 ? i + 1 : i;
                    j = (j >= 60) ? 0 : j;

                    timeValue1.push(timeValue);
                }
                template = true;
            }
            return { columnCount: columnCount, timeValue1: timeValue1, strTime: strTime };
        },
        _renderAgendaContent: function () {
            this.element.find(".e-agendacellstab").remove();
            var dateStart = new Date(new Date(this.currentDate()).setHours(0, 0, 0, 0));
            var row = []; var col = [];
            var startTimeDisp, endTimeDisp, date, time, subject, colorDiv, resName, userAppTemplId, userTempHtml, userDateId, userDateHtml, userTimeId, userTimeHtml, userResourceId, userResourceHtml;
            if (!this.model.group) this.res1 = ["0"];
            var repeatText = this._getLocalizedLabels("Recurrence");
            var count = this._getAgendaDateCount();
            for (var res = 0; res < this.res1.length; res++) {
                var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateStart)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(new Date(dateStart).setDate(dateStart.getDate() + count)).setHours(23, 59, 59)));
                predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                var appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(predicate));
                appList = this._appointmentSort(appList);
                if (appList.length > 0) {
                    var resGroup = [];
                    if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) {
                        var resgroupid = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]];
                        var resLevels = this._resCollection;
                        for (var i = resLevels.length - 1; i > 0; i--) {
                            var resApp = new ej.DataManager(resLevels[i - 1].dataSource).executeLocal(new ej.Query().where(resLevels[i - 1].id, ej.FilterOperators.equal, resgroupid));
                            resGroup.push({ resId: "resLevel_" + i + "_" + resApp[0][resLevels[i - 1].id], text: resApp[0][resLevels[i - 1].text] });
                            resgroupid = resApp[0][resLevels[i - 1].groupId];
                        }
                        resGroup.reverse();
                    }
                    var resChild = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? true : false;
                    var resRowSpan = appList.length;
                    userResourceId = (this.model.resourceHeaderTemplateId) ? true : false;
                    userResourceHtml = userResourceId ? this._getResourceHeadTemplate(this.res1[res]) : "";
                    var day = 0;
                    if (new Date(dateStart) < this.model.minDate)
                        day = Math.floor((new Date(this.model.minDate) - new Date(dateStart)) / (1000 * 60 * 60 * 24));
                    if (new Date(new Date(dateStart).setDate(dateStart.getDate() + count)) > this.model.maxDate)
                        count = count - Math.floor((new Date(new Date(dateStart).setDate(dateStart.getDate() + count)) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    for (var day; day <= count; day++) {
                        if (!this.model.showWeekend) {
                            var showWeekDays = this._getWeekDays();
                            var agendaDate = new Date(new Date(dateStart).setDate(dateStart.getDate() + day));
                            if (showWeekDays.indexOf(agendaDate.getDay()) == -1) continue;
                        }
                        var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(dateStart).setDate(dateStart.getDate() + day))).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(new Date(dateStart).setDate(dateStart.getDate() + day)).setHours(23, 59, 59)));
                        predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                        var dailyapplist = new ej.DataManager(appList).executeLocal(new ej.Query().where(predicate));
                        dailyapplist = this._resourceOrderSort(dailyapplist);
                        if (dailyapplist.length > 0) {
                            row.push(row.length + 1);
                            var dayRowSpan = dailyapplist.length; var dayChild = true; var dayBorderBottom = false;
                            for (var i = 0; i < dailyapplist.length; i++) {
                                if (i == dailyapplist.length - 1) dayBorderBottom = true;
                                startTimeDisp = this._timeMode == "12" ? ej.format(dailyapplist[i][this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(dailyapplist[i][this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                                endTimeDisp = this._timeMode == "12" ? ej.format(dailyapplist[i][this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(dailyapplist[i][this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                                date = "<strong class='e-agendaday'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'dd', this.model.locale) + "</strong><span class='e-agendaweek'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'dddd', this.model.locale) + "</span><span class='e-agendamonth'>" + ej.format(new Date(dailyapplist[i][this._appointmentSettings['startTime']]), 'MMM, yyyy', this.model.locale) + "</span>";
                                time = (!ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["allDay"]]) && JSON.parse(dailyapplist[i][this._appointmentSettings["allDay"]])) ? "<div class='e-icon e-circle e-scheduleallday'></div>" + this._getLocalizedLabels("AllDay") : startTimeDisp + " - " + endTimeDisp;
                                subject = (!ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["recurrence"]]) && JSON.parse(dailyapplist[i][this._appointmentSettings["recurrence"]])) ? dailyapplist[i][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 ? "<span class='e-icon e-schedulerepeatedit' title='" + repeatText + "'/>" + dailyapplist[i][this._appointmentSettings["subject"]] : "<span class='e-icon e-schedulerepeat' title='" + repeatText + "'/>" + dailyapplist[i][this._appointmentSettings["subject"]] : dailyapplist[i][this._appointmentSettings["subject"]];
                                colorDiv = (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(dailyapplist[i][this._appointmentSettings["categorize"]]) && dailyapplist[i][this._appointmentSettings["categorize"]] != "") ? this._getCategorizeColor(dailyapplist[i]) : ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? this._getResourceColor(dailyapplist[i]) : { appointData: "", appointCustomcss: "", appointtextcolor: "" };
                                resName = (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources && (this._tempResource.length != 0)) ? this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["text"]] : "";
                                userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
                                userTempHtml = userAppTemplId ? dailyapplist[i][this._appointmentSettings["recurrence"]] ? dailyapplist[i][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 ? "<span class='e-icon e-schedulerepeatedit' title='" + repeatText + "'/>" + this._getUserAppointmentTemplate(dailyapplist[i]) : "<span class='e-icon e-schedulerepeat' title='" + repeatText + "'/>" + this._getUserAppointmentTemplate(dailyapplist[i]) : this._getUserAppointmentTemplate(dailyapplist[i]) : "";
                                userDateId = (this.model.agendaViewSettings.dateColumnTemplateId) ? true : false;
                                userDateHtml = userDateId ? this._getUserTemplate(this.model.agendaViewSettings.dateColumnTemplateId, dailyapplist[i]) : "";
                                userTimeId = (this.model.agendaViewSettings.timeColumnTemplateId) ? true : false;
                                userTimeHtml = userTimeId ? this._getUserTemplate(this.model.agendaViewSettings.timeColumnTemplateId, dailyapplist[i]) : "";
                                col.push({ readOnly: this.model.readOnly, allowDelete: this.model.allowDelete, edittext: this._getLocalizedLabels("Edit"), deletetext: this._getLocalizedLabels("Delete"), userResourceId: userResourceId, userResourceHtml: userResourceHtml, userDateId: userDateId, userDateHtml: userDateHtml, userTimeId: userTimeId, userTimeHtml: userTimeHtml, userAppTemplId: userAppTemplId, userTemplate: userTempHtml, resGroup: resGroup, resName: resName, resChild: resChild, resRowSpan: resRowSpan, id: dailyapplist[i]["AppTaskId"], uid: dailyapplist[i].Guid, dayRowSpan: dailyapplist.length, dayChild: dayChild, dayBorderBottom: dayBorderBottom, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorDiv.applyFilter) ? true : false, background: colorDiv.appointData, date: date, time: time, event: subject });
                                dayChild = false; resChild = false;
                            }
                        }
                    }
                }
            }
            var workCellhtml = this.agendacellTemp.render({ rows: row, cols: col });
            this.element.find(".e-draggableworkarea").append(workCellhtml);
            if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                var resLevels = this.render_Resources;
                for (var i = 0; i < resLevels.length - 1; i++) {
                    for (var j = 0; j < resLevels[i].length; j++) {
                        var cname = "resLevel_" + (i + 1) + "_" + resLevels[i][j][this._resCollection[i].id];
                        this.element.find("." + cname).first().attr('rowspan', this.element.find("." + cname).length);
                        this.element.find("." + cname).slice(1).addClass("e-hide");
                        this.element.find(".e-hide").remove();
                        (this.model.resourceHeaderTemplateId) && (this.element.find("." + cname).children().empty().append(this._getResourceHeadTemplate(resLevels[i][j])));
                    }
                }
            }
            var _scrollDiv = this.element.find('div#' + this._id + "_scroller");
            if (ej.isNullOrUndefined(_scrollDiv.data("ejScroller"))) {
                _scrollDiv.ejScroller({
                    enableRTL: this.model.enableRTL, height: this.scHeight - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top) - 1, width: parseInt(this.element.width()) - 2, cssClass: this.model.cssClass
                });
                (!this._mediaQuery) && this._nextPrevAppointment(this.model.showAppointmentNavigator);
            }
            _scrollDiv.ejScroller('refresh');
            var border = this.model.enableRTL ? "e-borderright" : "e-borderleft";
            _scrollDiv.ejScroller("isVScroll") ? (this.element.find(".e-emptyscrolltd").addClass(border).show() && this.element.find('.e-draggableworkarea').height(this.element.find('.e-draggableworkarea').height() + 1)) : this.element.find(".e-emptyscrolltd").removeClass(border).hide();
            this.element.find(".e-vscroll").css("left", (this.model.enableRTL) ? 0 : this.element.outerWidth() - (_scrollDiv.ejScroller("isVScroll") ? 19 : 0));
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            this.element.find(".e-headeralldaydiv").width(this.element.find(".e-draggableworkarea").width());
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("renderAgendaContent");
        },

        _getUserTemplate: function (id, record) {
            var cloneObj = $.extend(cloneObj, record);
            cloneObj.View = this.currentView();
            return $.templates($(id).html()).render(cloneObj);
        },

        _getColumnCount: function () {
            var weekcells = [];
            var daysCount = (this.currentView() === "month" || this._isCustomMonthView()) ? this._isCustomMonthView() ? this._renderDays <= 7 ? this._renderDays : (this.model.showWeekend) ? 7 : this.model.workWeek.length : (this.model.showWeekend) ? 7 : this.model.workWeek.length : this._dateRender.length;
            if (this._resCustomView && this.currentView() == "customview")
                daysCount = this._dateRender.length;
            for (var i = 0; i < daysCount; i++) weekcells.push(i);
            return weekcells;
        },

        _bindAppointmentsData: function (currentAction) {
            if (!ej.isNullOrUndefined(this.model.appointmentSettings) && this.dataSource() != null) {
                if (this.model.enablePersistence) {
                    this.model.appointmentSettings.query = new ej.Query();
                    this._enablePersist = true;
                }
                if (!this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.offline)
                    this._dateFormat(this.dataSource());
                if (this.dataSource() instanceof ej.DataManager && !this.dataSource().dataSource.offline) {
                    this._initDataSource(currentAction);
                }
                else {
                    this._bindAppointments = (this.dataSource().length > 0) ? true : false;
                    var viewchange = (currentAction == "Refresh") ? false : this._viewchange;
                    this._angular = this._bindAppointments && (!this._bindapp && !this._setmodelvalue && viewchange == true && this._obj.length > 0 && this.dataSource()[0][this._appointmentSettings["id"]] == this._obj[0][this._appointmentSettings["id"]]);
                    this._true = (this.model.isDST) ? true : false;
                    this._timeZoneOffset = (ej.isNullOrUndefined(this.model.timeZone) && !this.model.isDST) ? new Date().getTimezoneOffset() - this._stdTimezoneOffset() : 0;
                    this._currentAppointmentData = this.dataSource();
                    $.extend(true, this._obj = [], this.dataSource());
                    !ej.isNullOrUndefined(this.dataSource().dataSource) && this.dataSource().dataSource.json && (this._currentAppointmentData = this.dataSource().dataSource.json);
                    this._dataCount = this._currentAppointmentData.length;
                    if (this._dataCount > 0) {
                        this._dataProcessing(this._currentAppointmentData);
                        (this.element.children().length > 0) && this._renderAppointmentAll();
                    }
                    if (this.model.showAppointmentNavigator) this._nextPrevButton();
                    this.tzone = this.model.timeZone;
                    this._bindapp = false;
                    this._setmodelvalue = false;
                    this._viewchange = false;
                }
            }
            else
                if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _initDataSource: function (currentAction) {
            this._trigger("actionBegin", { currentAction: currentAction, requestType: "dataBinding" });
            var query = this._columnToSelect(this.model.appointmentSettings, currentAction);
            var tempQuery = $.extend(true, [], query._params);
            this._true = (this.model.isDST) ? true : false;
            this._timeZoneOffset = (ej.isNullOrUndefined(this.model.timeZone) && !this.model.isDST) ? new Date().getTimezoneOffset() - this._stdTimezoneOffset() : 0;
            query._params = [];
            if ((!ej.isNullOrUndefined(this.model.renderDates) && ($.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() == "customview") {
                var startDate = new Date(new Date(this._dateRender[0]).setHours(0, 0, 0));
                var endDate = new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(0, 0, 0));
                query.addParams("StartDate", startDate).addParams("EndDate", endDate);
            } else {
                var value = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
                var temp = new Date(value.getTime() + (-(this._timeZoneCalculate()) * 60000));
                query.addParams("CurrentDate", value).addParams("CurrentView", this.currentView()).addParams("CurrentAction", currentAction);
                for (var i = 0; i < tempQuery.length; i++) {
                    if (tempQuery[i].key != "CurrentDate" && tempQuery[i].key != "CurrentView" && tempQuery[i].key != "CurrentAction") {
                        query.addParams(tempQuery[i].key, tempQuery[i].value);
                    }
                }
            }
            var proxy = this, queryPromise = this.dataSource().executeQuery(query);
            queryPromise.done(function (e) {
                proxy._dataCount = e.result.length;
                if (!ej.isNullOrUndefined(e.result.result)) {
                    proxy._dataCount = e.result.count + 1;
                    e.result = e.result.result;
                }
                proxy._bindAppointments = (e.result.length > 0) ? true : false;
                proxy._currentAppointmentData = e.result;
                proxy._dataProcessing(e.result);
                proxy._renderAppointmentAll();
                if (proxy.model.showAppointmentNavigator) proxy._nextPrevButton();
                proxy._trigger("actionComplete", { requestType: "dataBound" });
            });
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _bindCategorizeData: function () {
            if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                this._categoryInfo = [];
                if (ej.isNullOrUndefined(this.model.categorizeSettings.query) || !(this.model.categorizeSettings.query instanceof ej.Query))
                    this.model.categorizeSettings.query = ej.Query();
                if (this.model.categorizeSettings.dataSource instanceof ej.DataManager)
                    this._initCategorizeData(this.model.categorizeSettings);
                else {
                    this._categoryInfo.push(this.model.categorizeSettings);
                }
            }
        },

        _initCategorizeData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this, queryCategoryPromise = fields.dataSource.executeQuery(query);
            queryCategoryPromise.done(function (e) {
                if (ej.isNullOrUndefined(proxy._appointmentAddWindow)) proxy._renderAppointmentWindow();
                fields.dataSource = e.result;
                proxy._categoryInfo.push(fields);
                proxy._renderCategoryItems(proxy._appointmentAddWindow);
            });
        },

        _bindPriorityData: function () {
            if (!ej.isNullOrUndefined(this.model.prioritySettings)) {
                this._priorityInfo = [];
                if (ej.isNullOrUndefined(this.model.prioritySettings.query) || !(this.model.prioritySettings.query instanceof ej.Query))
                    this.model.prioritySettings.query = ej.Query();
                if (this.model.prioritySettings.dataSource instanceof ej.DataManager)
                    this._initPriorityData(this.model.prioritySettings);
                else {
                    this._priorityInfo.push(this.model.prioritySettings);
                }
            }
        },

        _initPriorityData: function (fields, i) {
            var query = this._columnToSelect(fields);
            var proxy = this, queryPriorityPromise = fields.dataSource.executeQuery(query);
            queryPriorityPromise.done(function (e) {
                if (ej.isNullOrUndefined(proxy._appointmentAddWindow)) proxy._renderAppointmentWindow();
                fields.dataSource = e.result;
                proxy._priorityInfo.push(fields);
                proxy._renderPriorityItems(proxy._appointmentAddWindow);
            });
        },

        _bindBlockData: function () {
            if (!ej.isNullOrUndefined(this.model.blockoutSettings)) {
                if (ej.isNullOrUndefined(this.model.blockoutSettings.query) || !(this.model.blockoutSettings.query instanceof ej.Query))
                    this.model.blockoutSettings.query = ej.Query();
                if (this.model.blockoutSettings.dataSource instanceof ej.DataManager) {
                    var query = this._columnToSelect(this.model.blockoutSettings);
                    var proxy = this, queryPromise = this.model.blockoutSettings.dataSource.executeQuery(query);
                    queryPromise.done(function (e) {
                        proxy.model.blockoutSettings.dataSource = e.result;
                        proxy._renderBlockAppointments();
                    });
                }
            }
        },

        _dateFormat: function (appointments) {
            if (appointments.length > 0) {
                if (new Date(appointments[0][this._appointmentSettings["startTime"]]).toString() == "Invalid Date") {
                    for (var i = 0, len = appointments.length; i < len; i++) {
                        appointments[i][this._appointmentSettings["startTime"]] = (new Date()).parseISO8601(appointments[i][this._appointmentSettings["startTime"]]);
                        appointments[i][this._appointmentSettings["endTime"]] = (new Date()).parseISO8601(appointments[i][this._appointmentSettings["endTime"]]);
                    }
                }
            }
        },

        _columnToSelect: function (mapper, currentAction) {
            var column = [], queryManager = ej.Query();
            if (!ej.isNullOrUndefined(mapper.tableName) && !this.dataSource().dataSource.url.match(mapper.tableName + "$")) {
                queryManager = mapper.query;
                queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },

        _getColumns: function (mapper) {
            var column = [];
            for (var col in mapper) {
                if (col !== "tableName" && col !== "query" && col !== "dataSource")
                    !ej.isNullOrUndefined(mapper[col]) && column.push(mapper[col]);
            }
            return column;
        },

        _sortAppById: function (appointments) {
            appointments.sort(function (a, b) {
                var x = a["AppTaskId"]; var y = b["AppTaskId"];
                return ((x < y) ? -1 : ((x > y) ? 1 : 0));
            });
            return appointments;
        },
        _stdTimezoneOffset: function () {
            return Math.max(new Date(new Date().getFullYear(), 0, 1).getTimezoneOffset(), new Date(new Date().getFullYear(), 6, 1).getTimezoneOffset());
        },
        _timeZoneCalculate: function (appointment) {
            var utc, timezone, oldtimezone, hour, mins, modelutc, oldhour, oldmins, oldmodelutc, localutc = (new Date()._isDST() && !this.model.isDST) ? -(new Date().getTimezoneOffset()) + this._timeZoneOffset : -(new Date().getTimezoneOffset());
            utc = localutc;
            if (!ej.isNullOrUndefined(this.model.timeZone)) {
                if (this.model.timeZone.indexOf(':') !== -1) {
                    if (ej.isNullOrUndefined(this.tzone)) this.tzone = this.model.timeZone;
                    timezone = this.model.timeZone.split(" ")[this.model.timeZone.split(" ").length - 1].split(":");
                    oldtimezone = this.tzone.split(" ")[this.tzone.split(" ").length - 1].split(":");
                    if (($.isNumeric(parseInt(timezone[0])) && (parseInt(timezone[0])).toString.length <= 2) || timezone[0].indexOf("UTC") !== -1) {
                        hour = this.model.timeZone.indexOf("-") !== -1 ? -parseInt(timezone[0].replace(/\D/g, '')) : parseInt(timezone[0].replace(/\D/g, ''));
                        mins = parseInt(timezone[1]);
                        modelutc = -((hour * 60) + mins);
                        if (this._setmodelvalue == true) {
                            if (this.tzone == this.model.timeZone) utc = -(-localutc + modelutc);
                            else {
                                oldhour = this.tzone.indexOf("-") !== -1 ? -parseInt(oldtimezone[0].replace(/\D/g, '')) : parseInt(oldtimezone[0].replace(/\D/g, ''));
                                oldmins = parseInt(oldtimezone[1]);
                                oldmodelutc = -((oldhour * 60) + oldmins);
                                utc = -(-oldmodelutc + modelutc);
                            }
                        }
                        else utc = -modelutc;
                    }
                    else utc = -localutc;
                }
                else utc = -localutc;
            }
            return utc;
        },
        _timeZoneAppointments: function (appoint, app) {
            if (this.model.appointmentSettings.applyTimeOffset) {
                var tempStartTime, tempEndTime, startUtc, endUtc, difference, startTime, endTime;
                if (!appoint[this._appointmentSettings["allDay"]]) {
                    if (ej.isNullOrUndefined(this._dayLight)) {
                        startUtc = appoint[this._appointmentSettings["startTimeZone"]];
                        endUtc = appoint[this._appointmentSettings["endTimeZone"]];
                        if (ej.isNullOrUndefined(endUtc) && !ej.isNullOrUndefined(startUtc)) appoint[this._appointmentSettings["endTimeZone"]] = endUtc = startUtc;
                        if (!ej.isNullOrUndefined(endUtc) && ej.isNullOrUndefined(startUtc)) appoint[this._appointmentSettings["startTimeZone"]] = startUtc = endUtc;
                        if (!ej.isNullOrUndefined(startUtc) && !ej.isNullOrUndefined(endUtc)) {
                            startUtc = startUtc.indexOf("UTC") != -1 ? parseInt(startUtc.split(" ")[1].split(":")[0]) * 60 + parseInt(startUtc.split(" ")[1].split(":")[1]) : parseInt(startUtc.split(":")[0]) * 60 + parseInt(startUtc.split(":")[1]);
                            endUtc = endUtc.indexOf("UTC") != -1 ? parseInt(endUtc.split(" ")[1].split(":")[0]) * 60 + parseInt(endUtc.split(" ")[1].split(":")[1]) : parseInt(endUtc.split(":")[0]) * 60 + parseInt(endUtc.split(':')[1]);
                        }
                        difference = (ej.isNullOrUndefined(startUtc) && !$.isNumeric(startUtc)) ? this._timeZoneCalculate(appoint) : startUtc - this._timeZoneCalculate(appoint);
                    }
                    else difference = this._timeValue;
                    difference = (app == "") ? -difference : difference;
                    tempStartTime = new Date(appoint[this._appointmentSettings["startTime"]]);
                    tempEndTime = new Date(appoint[this._appointmentSettings["endTime"]]);
                    if (appoint[this._appointmentSettings["allDay"]] && (Math.round((new Date(appoint[this._appointmentSettings["endTime"]]) - new Date(appoint[this._appointmentSettings["startTime"]])) / 3600000) < 24))
                        return appoint;
                    else {
                        appoint[this._appointmentSettings["startTime"]] = new Date(tempStartTime.setMinutes(tempStartTime.getMinutes() + difference));
                        appoint[this._appointmentSettings["endTime"]] = new Date(tempEndTime.setMinutes(tempEndTime.getMinutes() + difference));
                        return appoint;
                    }
                }
                else {
                    appoint[this._appointmentSettings["startTime"]] = new Date(appoint[this._appointmentSettings["startTime"]]);
                    appoint[this._appointmentSettings["endTime"]] = new Date(appoint[this._appointmentSettings["endTime"]]);
                }
                return appoint;
            }
            return appoint;
        },
        _processtimeZone: function (record, app) {
            if (this.model.appointmentSettings.applyTimeOffset) {
                var tempstarttime = new Date(record[this.model.blockoutSettings["startTime"]]), tempendtime = new Date(record[this.model.blockoutSettings["endTime"]]);
                if (!record[this.model.blockoutSettings["isAllDay"]]) {
                    var difference = this._timeZoneCalculate(record);
                    record[this.model.blockoutSettings["startTime"]] = new Date(tempstarttime.setMinutes(tempstarttime.getMinutes() + difference));
                    record[this.model.blockoutSettings["endTime"]] = new Date(tempendtime.setMinutes(tempendtime.getMinutes() + difference));
                }
                else {
                    record[this.model.blockoutSettings["startTime"]] = new Date(tempstarttime.getFullYear(), tempstarttime.getMonth(), tempstarttime.getDate());
                    record[this.model.blockoutSettings["endTime"]] = new Date(tempendtime.getFullYear(), tempendtime.getMonth(), tempendtime.getDate(), 23, 59, 59);
                }
            }
            return record;
        },

        _dataProcessing: function (appointments) {
            this._processed = [];
            this._appMainId = null;
            if (appointments.length > 0) {
                var appId = this._sortAppById(appointments);
                this._maxId = (ej.isNullOrUndefined(appointments[0]) || ej.isNullOrUndefined(appointments[0].AppTaskId)) ? 1 : appointments[0].AppTaskId;
                for (var app = 0; app < appointments.length; app++) {
                    appointments[app][this._appointmentSettings["startTime"]] = (new Date()).parseISO8601(appointments[app][this._appointmentSettings["startTime"]]);
                    appointments[app][this._appointmentSettings["endTime"]] = (new Date()).parseISO8601(appointments[app][this._appointmentSettings["endTime"]]);
                    if (this._bindAppointments == true && !this._angular && !this._setmodelvalue && this._applyTimeOffset && ej.isNullOrUndefined(this._enablePersist)) {
                        var appoint = this._timeZoneAppointments(appointments[app], "reverse");
                        this._appointmentProcessing(appoint);
                    }
                    else
                        this._appointmentProcessing(appointments[app]);
                }
                this._bindAppointments = false;
                this._setmodelvalue = false;
                this._processed = this._sortAppById(this._processed);
                return this._processed;
            }
        },
        _guidFormatGenerate: function () {
            function guid() {
                return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
            }
            return guid() + guid() + '-' + guid() + '-' + guid() + '-' + guid() + '-' + guid() + guid() + guid();
        },
        _RecurrenceAppointment: function (appointment) {
            ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = ej.RecurrenceEditor.prototype;
            recurEdit._rRule = {};
            appointment.AppTaskId = ej.isNullOrUndefined(appointment.AppTaskId) ? this._maxId : appointment.AppTaskId;
            ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
            recurEdit.model.startDate = new Date(this.currentDate());
            var collection = recurEdit.recurrenceDateGenerator(appointment[this._appointmentSettings["recurrenceRule"]], appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["recurrenceExDate"]]);
            var i = 0;
            var newArray = collection;
            while (i < newArray.length) {
                var newAppointment = {}, orgStrTime = new Date(newArray[i]), orgEndTime = appointment[this._appointmentSettings["endTime"]];
                ((recurEdit._rRule.freq == "MONTHLY" || recurEdit._rRule.freq == "YEARLY") && !ej.isNullOrUndefined(recurEdit._rRule.setPositions)) && (orgStrTime = recurEdit._dayOfWeekInMonth(orgStrTime, recurEdit._rRule.weekDays, recurEdit._rRule.setPositions));
                var strTime = new Date(orgStrTime.getFullYear(), orgStrTime.getMonth(), orgStrTime.getDate(), new Date(appointment[this._appointmentSettings["startTime"]]).getHours(), new Date(appointment[this._appointmentSettings["startTime"]]).getMinutes(), new Date(appointment[this._appointmentSettings["startTime"]]).getSeconds());
                var endTime = new Date(new Date(strTime).setMilliseconds(appointment[this._appointmentSettings["endTime"]].getTime() - appointment[this._appointmentSettings["startTime"]].getTime()));
                this._idChecking();
                appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] || appointment[this._appointmentSettings["id"]] || appointment.AppTaskId);
                appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]];
                if (!ej.isNullOrUndefined(recurEdit._rRule.exDate)) {
                    if (recurEdit._rRule.exDate.indexOf(ej.format(new Date(orgStrTime), this._pattern.d, this.model.locale)) == -1) {
                        newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment.ParentId);
                    }
                }
                else
                    newAppointment = this._addAppData(appointment, this._maxId, strTime, endTime, appointment.ParentId);

                if ((new Date(new Date(appointment[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appointment[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this._appointmentSettings["allDay"]] !== true)) {
                    newAppointment.Guid = this._guidFormatGenerate();
                    this._multipleDayApp(newAppointment, this._maxId, newAppointment[this._appointmentSettings["startTime"]], endTime);
                }
                else if (Math.round((newAppointment[this._appointmentSettings["endTime"]] - newAppointment[this._appointmentSettings["startTime"]]) / 3600000) > 24) {
                    newAppointment.Guid = this._guidFormatGenerate();
                    this._multipleSplit(newAppointment, this._maxId, newAppointment[this._appointmentSettings["startTime"]], newAppointment[this._appointmentSettings["endTime"]]);
                }
                else {
                    if (!$.isEmptyObject(newAppointment)) {
                        newAppointment.Guid = this._guidFormatGenerate();
                        this._processed.push(newAppointment);
                    }
                }
                i++;
                this._maxId++;
            }
        },

        _recurrenceAppSort: function (apps) {
            var splitProcessed = [];
            for (var a = 0; a < apps.length; a++) {
                var obj = new ej.DataManager(apps).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, apps[a]["Guid"]));
                if (obj.length > 1) {
                    var tempObj = $.extend(true, [], obj);
                    tempObj[0][this._appointmentSettings["endTime"]] = tempObj[tempObj.length - 1][this._appointmentSettings["endTime"]];
                    splitProcessed.push(tempObj[0]);
                    a++;
                }
                else
                    splitProcessed.push(apps[a]);
            }
            return splitProcessed;
        },
        _appointmentProcessing: function (appointment) {
            this._maxId = !ej.isNullOrUndefined(this._appMainId) ? parseInt(this._appMainId) + 1 : parseInt(this._maxId);
            var recurEdit = ej.RecurrenceEditor.prototype;
            recurEdit._rRule = {};
            if (!ej.isNullOrUndefined(appointment[this._appointmentSettings["recurrence"]]) && !ej.isNullOrUndefined(appointment[this._appointmentSettings["recurrenceRule"]]))
                recurEdit.recurrenceRuleSplit(appointment[this._appointmentSettings["recurrenceRule"]], appointment[this._appointmentSettings["recurrenceExDate"]]);
            if (appointment[this._appointmentSettings["recurrence"]] == 1 && ej.isNullOrUndefined(recurEdit._rRule.recurEditId)) {
                this._RecurrenceAppointment(appointment);
            }
            else if ((new Date(new Date(appointment[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appointment[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) < 24) && (appointment[this._appointmentSettings["allDay"]] !== true) && ((appointment[this._appointmentSettings["recurrence"]] && !ej.isNullOrUndefined(recurEdit._rRule.recurEditId)) || !appointment[this._appointmentSettings["recurrence"]])) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._maxId = appointment.AppTaskId;
                this._multipleDayApp(appointment, this._maxId, appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["endTime"]]);
            }
            else if ((((appointment[this._appointmentSettings["endTime"]] - appointment[this._appointmentSettings["startTime"]]) / 3600000) >= 24)) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._maxId = appointment.AppTaskId;
                this._multipleSplit(appointment, this._maxId, appointment[this._appointmentSettings["startTime"]], appointment[this._appointmentSettings["endTime"]]);
            }
            else if ((appointment[this._appointmentSettings["recurrence"]] == 0 || !ej.isNullOrUndefined(recurEdit._rRule.recurEditId))) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (!ej.isNullOrUndefined(recurEdit._rRule.recurEditId) ? recurEdit._rRule.recurEditId : appointment[this._appointmentSettings["id"]]);
                if (appointment[this._appointmentSettings["recurrence"]]) {
                    appointment["ParentId"] = appointment[this._appointmentSettings["recurrenceId"]] = (appointment[this._appointmentSettings["recurrenceId"]] == null ? appointment["ParentId"] : appointment[this._appointmentSettings["recurrenceId"]]);
                }
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                this._processed.push(appointment);
            }
            else if (((appointment[this._appointmentSettings["recurrence"]] == undefined) || (appointment[this._appointmentSettings["allDay"]] == undefined)) && !appointment[this._appointmentSettings["recurrence"]]) {
                this._appMainId = appointment.AppTaskId = appointment.AppTaskId == null ? this._maxId : appointment.AppTaskId;
                ej.isNullOrUndefined(appointment[this._appointmentSettings["id"]]) && (appointment[this._appointmentSettings["id"]] = appointment.AppTaskId);
                appointment.ParentId = (appointment[this._appointmentSettings["id"]]);
                appointment.Guid = ej.isNullOrUndefined(appointment.Guid) ? this._guidFormatGenerate() : appointment.Guid;
                appointment.RecurrenceId = appointment.recurrenceExDate = null;
                this._processed.push(appointment);
            }
            this._appMainId = (ej.isNullOrUndefined(this._appMainId) || this._appMainId < this._maxId) ? this._maxId : this._appMainId;
        },
        _idChecking: function () {
            for (var i = 0; i < this._currentAppointmentData.length ; i++) {
                var query = new ej.Query().where("AppTaskId", ej.FilterOperators.equal, this._maxId);
                var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                if (_editApp.length == 0) { this._maxId; break; }
                else
                    this._maxId++;
            }
            for (; ;) {
                var query = new ej.Query().where("AppTaskId", ej.FilterOperators.equal, this._maxId);
                var _editApp = new ej.DataManager(this._processed).executeLocal(query);
                if (_editApp.length == 0) { this._maxId; break; }
                else
                    this._maxId++;
            }
            return this._maxId
        },

        _getTotalDays: function (strDate, endDate) {
            var showWeekDays = this._getWeekDays();
            var firstDate = new Date(strDate), count = 0;
            do {
                count = showWeekDays.indexOf(firstDate.getDay()) != -1 ? count + 1 : count;
                firstDate = new Date(new Date(firstDate).getTime() + (1000 * 60 * 60 * 24));
            } while (new Date(firstDate.getFullYear(), firstDate.getMonth(), firstDate.getDate()).getTime() <= new Date(endDate).getTime())
            return count;
        },

        _getPrevNextDateCount: function (date, type) {
            var showWeekDays = this._getWeekDays();
            var currentDate = new Date(date), count = 0;
            while (showWeekDays.indexOf(currentDate.getDay()) < 0) {
                currentDate = (type == "next") ? new Date(new Date(currentDate).getTime() + (1000 * 60 * 60 * 24)) : new Date(new Date(currentDate).getTime() - (1000 * 60 * 60 * 24));
                count++;
            }
            return count;
        },

        _getPrevNextDates: function (currentDate, type) {
            var count = 0, dates = this._dateRender;
            while (dates.indexOf(currentDate.getTime()) < 0) {
                currentDate = (type == "next") ? new Date(new Date(currentDate).getTime() + (1000 * 60 * 60 * 24)) : new Date(new Date(currentDate).getTime() - (1000 * 60 * 60 * 24));
                count++;
            }
            return count;
        },

        _getPrevNextCustomDates: function (currentDate, type, resId) {
            var count = 0, monthCount = 0, yearCount = 0, dates = [];
            for (var i = 0; i < this._resCustomCollection.length; i++) {
                if (this._resCustomCollection[i].id == resId)
                    dates = this._resCustomCollection[i]["renderDates"];
            }
            while (dates.indexOf(currentDate.getTime()) < 0) {
                var previousDate = currentDate;
                currentDate = (type == "next") ? new Date(new Date(currentDate).getTime() + (1000 * 60 * 60 * 24)) : new Date(new Date(currentDate).getTime() - (1000 * 60 * 60 * 24));
                if (previousDate.getFullYear() != currentDate.getFullYear()) {
                    count = 0;
                    monthCount = 0;
                    yearCount++;
                } else if (previousDate.getMonth() == currentDate.getMonth()) {
                    count++;
                } else {
                    count = 0;
                    monthCount++;
                }
            }
            return { count: count, monthCount: monthCount, yearCount: yearCount };
        },

        _getCustomDatesCount: function (res, resDates) {
            var count = 0;
            var resCustomDates = this.res1[res][resDates];
            if (!ej.isNullOrUndefined(resCustomDates) && $.type(resCustomDates[0]) == "object") {
                count += this._getMultipleCustomDatesCount(resCustomDates);
            } else
                count += resCustomDates.length;
            return count;
        },

        _getMultipleCustomDatesCount: function (resCustomDates) {
            var count = 0;
            for (var j = 0; j < resCustomDates.length; j++) {
                var startDate = resCustomDates[j].start;
                var endDate = resCustomDates[j].end;
                var renderDatesLength = Math.round(Math.abs((endDate.getTime() - startDate.getTime()) / (24 * 60 * 60 * 1000))) + 1;
                count = count + renderDatesLength;
            }
            return count;
        },

        _multipleDayApp: function (app, maxId, startTime, endTime) {
            if (endTime.getHours() == 0 && endTime.getMinutes() == 0) endTime = new Date(endTime.getTime() - 1000);
            var dayStart = new Date(startTime), dayEnd = new Date(endTime);
            if (((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.timeScale.enable) || ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (startTime < new Date(this._dateRender[0]) || endTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)))))
                dayEnd = new Date(new Date(startTime).setHours(23, 59, 59));
            while (dayStart >= new Date(startTime) && dayStart <= dayEnd && dayEnd <= new Date(endTime)) {
                this._processed.push(this._addAppData(app, maxId, dayStart, dayEnd, app.ParentId));
                dayStart = new Date(new Date(dayEnd).setHours(24, 0, 0));
                dayEnd = app[this._appointmentSettings["endTime"]];
                this._maxId = maxId = this._idChecking();
            }
        },

        _multipleSplit: function (app, maxId, startTime, endTime) {
            startTime = new Date(startTime);
            var appstarttime = new Date(new Date(startTime).getFullYear(), new Date(startTime).getMonth(), new Date(startTime).getDate(), new Date(startTime).getHours(), new Date(startTime).getMinutes(), new Date(startTime).getSeconds());
            var end = new Date(new Date(endTime).getFullYear(), new Date(endTime).getMonth(), new Date(endTime).getDate(), 23, 59, 59);
            while (appstarttime <= end) {
                var differDate = 0, day_start = new Date(appstarttime);
                if (this.currentView() !== "day" && this.currentView() != "agenda") {
                    var weekDate = (day_start)._currentWeekDates(this._firstdayofweek);
                    if (!this._isCustomMonthView() && this._oneWeek) {
                        appstarttime = (new Date(new Date(day_start).getFullYear(), new Date(day_start).getMonth(), new Date(day_start).getDate()));
                        differDate = (this._dateRender.indexOf(appstarttime.getTime()) != -1) ? (this._dateRender.length - 1) - this._dateRender.indexOf(appstarttime.getTime()) : (appstarttime.getTime() < new Date(this._dateRender[0]).getTime()) ? ((new Date(new Date(this._dateRender[0]).setDate(new Date(this._dateRender[0]).getDate() - 1)).getTime() - new Date(appstarttime).setHours(0, 0, 0, 0)) / 3600000) / 24 : (appstarttime.getTime() > new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)) ? this._dateRender.length - 1 : 0;
                    }
                    else if (this.currentView() == "month" && ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") || !this.model.showNextPrevMonth && new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(appstarttime.getFullYear(), appstarttime.getMonth(), 1).getTime())) {
                        differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                    }
                    else {
                        differDate = ((weekDate.end.getTime() - new Date(day_start).setHours(0, 0, 0)) / (1000 * 60 * 60 * 24));
                    }
                }
                if (this.currentView() == "workweek" && (new Date(day_start).getTime() == new Date(weekDate.start).getTime()) && (this._firstdayofweek == 0)) {
                    var end = new Date(new Date(day_start).setHours(23, 59, 59));
                    var appointment = this._addAppData(app, maxId, day_start, end, app["ParentId"]);
                    this._processed.push(appointment);
                    this._maxId = maxId = this._idChecking();
                    day_start = new Date(day_start.getFullYear(), day_start.getMonth(), day_start.getDate() + 1);
                }
                var nextDay = new Date(appstarttime.getFullYear(), appstarttime.getMonth(), appstarttime.getDate() + differDate);
                var day_end = (new Date(nextDay).getDate() == new Date(end).getDate() && this.currentView() !== "month") ? new Date(new Date(nextDay).setHours(endTime.getHours(), endTime.getMinutes(), endTime.getSeconds())) : new Date(new Date(nextDay).setHours(23, 59, 59));
                if ((day_end >= new Date(endTime)) && this.currentView !== "day")
                    day_end = app[this._appointmentSettings["endTime"]];
                if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(appstarttime.getFullYear(), appstarttime.getMonth(), 1).getTime() != new Date(day_end.getFullYear(), day_end.getMonth(), 1).getTime())
                    day_end = new Date(appstarttime.getFullYear(), appstarttime.getMonth() + 1, 0, day_end.getHours(), day_end.getMinutes(), day_end.getSeconds());
                appointment = this._addAppData(app, maxId, day_start, day_end, app["ParentId"]);
                this._processed.push(appointment);
                this._maxId = maxId = this._idChecking();
                var noOfDays = (this.model.showWeekend) ? 1 : this._getPrevNextDateCount(new Date(new Date(day_end).setHours(0, 0, 0, 0) + (1000 * 60 * 60 * 24)), "next") + 1;
                appstarttime = new Date(new Date(day_end).getFullYear(), new Date(day_end).getMonth(), new Date(day_end).getDate() + noOfDays);
                if (appstarttime <= end) {
                    if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                        var diffDatesCount = 0;
                        if (this._resCustomView) {
                            diffDatesCount = this._getPrevNextCustomDates(appstarttime, "next", app[this._appointmentSettings.resourceFields.split(',')[this._appointmentSettings.resourceFields.split(',').length - 1]]);
                            if (diffDatesCount["yearCount"] > 0)
                                appstarttime = new Date(appstarttime.getFullYear() + diffDatesCount["yearCount"], new Date(appstarttime.setMonth(0)).getMonth() + diffDatesCount["monthCount"], new Date(appstarttime.setDate(1)).getDate() + diffDatesCount["count"]);
                            else if (diffDatesCount["monthCount"] > 0)
                                appstarttime = new Date(appstarttime.getFullYear(), appstarttime.getMonth() + diffDatesCount["monthCount"], new Date(appstarttime.setDate(1)).getDate() + diffDatesCount["count"]);
                            else
                                appstarttime = new Date(appstarttime.getFullYear(), appstarttime.getMonth() + diffDatesCount["monthCount"], appstarttime.getDate() + diffDatesCount["count"]);
                        }
                        else {
                            diffDatesCount = this._getPrevNextDates(appstarttime, "next");
                            appstarttime = new Date(appstarttime.getFullYear(), appstarttime.getMonth(), appstarttime.getDate() + diffDatesCount);
                        }
                    }
                }
            }
        },

        _deleteOcurrence: function (appId, date) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            var query = new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, appId);
            var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
            if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                var objDate = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["startTime"], ej.FilterOperators.equal, date));
                objDate = objDate.length == 0 ? this._objDate : objDate;
                objDate = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, objDate[0]["AppTaskId"]));
            }
            if (!ej.isNullOrUndefined(_editApp) && !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceRule"]])) {
                var _rRule = _editApp[0][this._appointmentSettings["recurrenceRule"]];
                recurEdit.recurrenceRuleSplit(_rRule, _editApp[0][this._appointmentSettings["recurrenceExDate"]]);
                if (ej.isNullOrUndefined(recurEdit._rRule.exDate)) {
                    if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                        if (objDate[0][this._appointmentSettings["startTime"]].getDay() == objDate[0][this._appointmentSettings["endTime"]].getDay()) {
                            date = objDate[0][this._appointmentSettings["startTime"]];
                            _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                            _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                        }
                        else {
                            _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                            _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                        }
                    }
                    else {
                        _editApp[0][this._appointmentSettings["recurrenceRule"]] = _rRule + ";EXDATE=" + ej.format(date, this._pattern.d, this.model.locale);
                        _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                    }
                }
                else {
                    var _rules = _rRule.split(';');
                    var recurRule = "";
                    for (var i = 0; i < _rules.length; i++) {
                        if (recurRule != "")
                            recurRule += ";";
                        var keyValuePair = _rules[i].replace(/ /g, '').split('=');
                        if (keyValuePair[0] == "EXDATE") {
                            if ((this._currentAction == "delete" || this._currentAction == "editOccurrence") && _editApp[0][this._appointmentSettings["endTime"]].getDay() > _editApp[0][this._appointmentSettings["startTime"]].getDay()) {
                                if (objDate[0][this._appointmentSettings["startTime"]].getDay() == objDate[0][this._appointmentSettings["endTime"]].getDay()) {
                                    date = objDate[0][this._appointmentSettings["startTime"]];
                                    _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                                }
                                else
                                    _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                            }
                            else
                                _rules[i] = _rules[i] + "," + ej.format(date, this._pattern.d, this.model.locale);
                        }
                        recurRule += _rules[i];
                    }
                    _editApp[0][this._appointmentSettings["recurrenceRule"]] = recurRule;
                    _editApp[0][this._appointmentSettings["recurrenceExDate"]] = !ej.isNullOrUndefined(_editApp[0][this._appointmentSettings["recurrenceExDate"]]) ? _editApp[0][this._appointmentSettings["recurrenceExDate"]] + "," + ej.format(date, this._pattern.d, this.model.locale).toString() : ej.format(date, this._pattern.d, this.model.locale).toString();
                }
                return _editApp;
            }
        },

        _getWeekIndex: function (curDate) {
            var index = 0;
            var firstDate = new Date(curDate.getFullYear(), curDate.getMonth(), 1);
            var dayIndex = curDate.getDay();
            if (dayIndex != firstDate.getDay())
                do {
                    firstDate = new Date(firstDate.setDate(firstDate.getDate() + 1));
                } while (dayIndex != firstDate.getDay())
            while (firstDate.getDate() != curDate.getDate()) {
                firstDate = new Date(firstDate.setDate(firstDate.getDate() + 7));
                index++;
            }
            return index;
        },

        _addAppData: function (app, id, startTime, endTime, parentId) {
            var data = {};
            for (var item in this._appointmentSettings) {
                if (item != "dataSource" && item != "query" && item != "tableName" && item != "resourceFields")
                    data[this._appointmentSettings[item]] = app[this._appointmentSettings[item]];
                if (item == "resourceFields" && !ej.isNullOrUndefined(this._appointmentSettings.resourceFields)) {
                    var level = this._appointmentSettings.resourceFields.split(',');
                    for (var val = 0, len = level.length; val < len; val++)
                        data[level[val]] = app[level[val]];
                }
            }
            (!ej.isNullOrUndefined(id)) && (data.AppTaskId = id);
            (!ej.isNullOrUndefined(startTime)) && (data[this._appointmentSettings["startTime"]] = startTime);
            (!ej.isNullOrUndefined(endTime)) && (data[this._appointmentSettings["endTime"]] = endTime);
            (!ej.isNullOrUndefined(parentId)) && (data["ParentId"] = parentId);
            var appdata = $.extend({}, app, data);
            return appdata;
        },
        _renderAppointments: function () {
            var dateCount = $.extend(true, [], this._dateRender);
            this._overflowFlag = false;
            this._renderedApp = [], this._renderedAllDay = [];
            var level = 1; this.level = 0;
            !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
            this.cellwidth = this.element.find(".e-workcells").width();
            this.cellheight = this.element.find(".e-workcells")[0].offsetHeight;
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showAllDayRow) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
            }
            this.alldaycellsheight = this.element.find(".e-alldaycells").height();
            this._horiHeaderCollection = this._horiGroupCollection();
            this.leftPosition = 0;
            this._variable = [];
            if (!this.model.group || (this._tempResource.length != 0 && this._tempResource[0].resourceSettings.dataSource.length == 0)) this.res1 = ["0"];
            this.resIndex = 0;
            this._processed = this._appointmentSort(this._processed);
            for (var res = 0; res < this.res1.length; res++) {
                var day = 0, diff, count = dateCount.length;
                if (new Date(dateCount[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(dateCount[0])) / (1000 * 60 * 60 * 24));
                if (new Date(dateCount[dateCount.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(dateCount[dateCount.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = dateCount.length - diff;
                }
                if (this._resWorkWeek) {
                    count = 0; day = 0; var temp = 0;
                    for (var a = 0; a < res + 1; a++) {
                        if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            if (a == res) temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count += this.model.workWeek.length;
                            if (a == res) temp += this.model.workWeek.length;
                        }

                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                if (this._resCustomView) {
                    count = 0; day = 0; var temp = 0;
                    for (var a = 0; a < res + 1; a++) {
                        var resCustomSettings = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                        if (!ej.isNullOrUndefined(this.res1[a][resCustomSettings])) {
                            count += this._getCustomDatesCount(a, resCustomSettings);
                            if (a == res) temp += this._getCustomDatesCount(a, resCustomSettings);
                        }
                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                for (day; day < count; day++) {
                    this._getDayAppointments(day, res);
                }
            }
            (this._overflowFlag || this._allDayDrag) && this._reRenderScroller();
            this._overflowFlag = this._allDayDrag = false;
        },

        _appointmentRemove: function (app) {
            this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment").filter("div[data-guid=" + app.Guid + "]").remove();
            this.element.find(".e-categorybar").filter("div[id=categorybar_" + app.Guid + "]").remove();
        },
		
		_resourceCustomView: function (resIndex, date) {
            var count = 0, day = 0, temp = 0, curday = 0;
            for (var a = 0; a < resIndex + 1; a++) {
                var resCustomSettings = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                if (!ej.isNullOrUndefined(this.res1[a][resCustomSettings])) {
                    count += this._getCustomDatesCount(a, resCustomSettings);
                    if (a == resIndex) {
                        temp += this._getCustomDatesCount(a, resCustomSettings);
                        curday = this._resCustomDate[resIndex].indexOf(date);
                    }
                }
                if (a == resIndex) {
                    day = count - temp;
                    break;
                }
            }
            day = day + curday;
            return day;
        },

        _resourceWorkWeek: function (resIndex, date) {
            var count = 0, day = 0, temp = 0, curday = 0;
            for (var a = 0; a < resIndex + 1; a++) {
                if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                    count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                    if (a == resIndex) {
                        temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        curday = this._resDateRen[resIndex].indexOf(date);
                    }
                }
                else {
                    count += this.model.workWeek.length;
                    if (a == resIndex) {
                        temp += this.model.workWeek.length;
                        curday = this._resDateRen[resIndex].indexOf(date);
                    }
                }
                if (a == resIndex) {
                    day = count - temp;
                    break;
                }
            }
            day = day + curday;
            return day;
        },

        _refreshDayAppointments: function (app) {
            if (this.model.timeScale.enable && this.currentView() != "agenda" && this.currentView() != "month" && !this._isCustomMonthView()) {
                this._overflowFlag = false;
                var date = new Date(app[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0);
                var resIndex = (ej.scheduleFeatures.resources && this._tempResource.length > 0 && this._grouping.length > 0) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], app[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], app[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], app[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2]]) : 0;
                var day = this._dateRender.indexOf(date), resDay = 0;
                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._grouping.length > 0) {
                    if (this._resWorkWeek) {
                        day = this._resourceWorkWeek(resIndex, date);
                    }
                    else if (this._resCustomView) {
                        day = this._resourceCustomView(resIndex, date);
                    }
                    else {
                        resDay += resIndex * (this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : (this.currentView() == "week" || this.currentView() == "week" || this._isCustomMonthView()) ? this.model.showWeekend ? 7 : this.model.workWeek.length : this._dateRender.length);
                    }
                }
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                    var horiIndex = (this._grouping.length > 1) ? this._resCollect.indexOf(this.res1[resIndex]) : resIndex;
                }
                (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find(".e-workcellstab tr td:nth-child(" + (day + resDay + 1) + ")").find(".e-appointwrapper").remove() : this.element.find(".e-workcellstab tr:nth(" + horiIndex + ")").find(".e-appointwrapper").remove();
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(date)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(date).setHours(23, 59, 59)));
                    predicate = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources) ? predicate.and(this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[resIndex][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
                    var dayApps = new ej.DataManager(this._renderedApp).executeLocal(new ej.Query().where(predicate));
                }
                else {
                    var tempApps = this._appointmentCount();
                    if (this._grouping.length > 0) {
                        var proxy = this;
                        var resApps = tempApps.filter(function (obj) { return obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == app[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]; });
                    }
                    var dayApps = (this._grouping.length > 0) ? resApps : tempApps;
                }
                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: dayApps }, "AppTaskId");
                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: dayApps }, "AppTaskId");
                var count = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? 1 : this._dateRender.length;
                var dayNo = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? day : 0;
                var index = 0, dayNo = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? day : 0;
                !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
                this.cellwidth = this.element.find(".e-workcells").width();
                this.cellheight = this.element.find(".e-workcells").outerHeight();
                this.alldaycellsheight = ej.isNullOrUndefined(this.alldaycellsheight) ? this.element.find(".e-alldaycells").height() : this.alldaycellsheight;
                this._horiHeaderCollection = this._horiGroupCollection();
                do {
                    this._getDayAppointments(dayNo, resIndex);
                    index++;
                    dayNo++;
                } while (index < count)

                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showAllDayRow) this._renderAllDayAppointments();
                if (this._overflowFlag) {
                    this._reRenderScroller();
                    this._overflowFlag = false;
                }
                if (this.model.showAppointmentNavigator && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length > 0 && this.currentView() != "month" && (!this._isCustomMonthView()) && (!this._mediaQuery)) this._renderUpDownIconPosition();
            }
            else (this.currentView() == "agenda") ? this._renderAgendaContent() : this._renderMonthAppointment();
			if (this.model.blockoutSettings.enable) this._renderBlockAppointments();
            this._bindAppointmentAction();
        },

        _renderUpDownIcon: function () {
            if (this.element.find(".e-upicon, .e-downicon").length == 0) {
                var upIcon = "", downIcon = "", upIconHtml = "", downIconHtml = "";
                var bottomVal = (this.element.find(".e-hscroll").length == 0) ? "0px" : this.element.find(".e-hscroll").outerHeight() + "px";
                for (var a = 0; a < this.dateRender.length; a++) {
                    upIcon = upIcon + "<div class='upicon_" + a + "' style='width:100%;height:100%;'><span class='e-icon e-arrow-sans-up e-appup'></span></div>";
                    downIcon = downIcon + "<div class='downicon_" + a + "' style='width:100%;height:100%;'><span class='e-icon e-arrow-sans-down e-appdown'></span></div>";
                }
                upIconHtml = "<div class='e-upicon' style='pointer-events:none;top:0px;'>" + upIcon + "</div>";
                downIconHtml = "<div class='e-downicon' style='pointer-events:none;bottom:" + bottomVal + ";'>" + downIcon + "</div>";
                $(upIconHtml).insertBefore(this.element.find(".e-draggableworkarea").parent());
                $(downIconHtml).insertAfter(this.element.find(".e-draggableworkarea").parent());
                if (this.model.enableRTL) this.element.find(".e-appup, .e-appdown").addClass("e-rtl");
                this.element.find(".e-upicon, .e-downicon").css({ width: this.element.find(".e-workcellstab").width() });
                this.element.find(".e-appup, .e-appdown").css({ pointerEvents: "visible" });
                this.element.find(".e-upicon, .e-downicon").children().css({ float: (this.model.enableRTL) ? "right" : "left", visibility: "hidden", width: Math.floor(this.element.find(".e-workcellstab").width() / this.element.find(".e-upicon").children().length) });
            }
        },

        _renderUpDownIconPosition: function () {
            this.element.find(".e-upicon, .e-downicon").children().css({ visibility: "hidden" });
            if (this.element.find(".e-vscroll").length > 0) {
                var scrollObject = this.element.find("div#" + this._id + "_scroller").data("ejScroller");
                var scrollMax = !ej.isNullOrUndefined(scrollObject._scrollYdata) ? scrollObject._scrollYdata.scrollable : this.element.height();
                var curValue = scrollObject.scrollTop();
                var upValue = (curValue > scrollMax) ? scrollMax : curValue;
                var downValue = upValue + this.element.find(".e-draggableworkarea").height();
                var upIndex = parseInt(upValue / this.element.find(".e-workcells").outerHeight()) + 1;
                var downIndex = parseInt(downValue / this.element.find(".e-workcells").outerHeight());
                var upTrgt = this.element.find(".e-upicon");
                var downTrgt = this.element.find(".e-downicon");
                var upTime = ((this.model.startHour * 60) + upIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                var time = (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * 60 * 1000;
                var downTime = (((this.model.startHour * 60) + downIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000)) + time;
                this._currentViewAppointments = this._appointmentCount();
                var proxy = this;
                var appointments = this._currentViewAppointments.filter(function (app) { return ((app[proxy._appointmentSettings["endTime"]] - app[proxy._appointmentSettings["startTime"]]) / (1000 * 3600)) < 24; });
                for (var a = 0; a < this._dateRender.length; a++) {
                    var endDateTime = (this.model.endHour < 24) ? new Date(new Date(this._dateRender[a]).setHours(this.model.endHour, 0, 0)) : new Date(new Date(this._dateRender[a]).setHours(23, 59, 59));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(this._dateRender[a]).setHours(this.model.startHour, 0, 0)))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
                    var dayApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (dayApps.length != 0) {
                        var upDate = new Date(new Date(this._dateRender[a]).setMilliseconds(upTime));
                        var upApps = new ej.DataManager(dayApps).executeLocal(new ej.Query().where(this._appointmentSettings["endTime"], ej.FilterOperators.lessThan, new Date(upDate)));
                        upApps = this._appointmentSort(upApps).reverse();
                        if (!ej.isNullOrUndefined(upTrgt) && upApps.length != 0) {
                            if (this._grouping.length == 0) { upTrgt.children().eq(a).css({ visibility: "visible" }); }
                            else {
                                if (this._grouping.length == 1) {
                                    for (var b = 0; b < this.res1.length; b++) {
                                        var tempRes = new ej.DataManager(upApps).executeLocal(new ej.Query().where(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[b].id));
                                        if (tempRes.length != 0) { upTrgt.children().eq(a + b * this._dateRender.length).css({ visibility: "visible" }); }
                                    }
                                }
                                else {
                                    for (var b = 0; b < this.res1.length; b++) {
                                        var predicate1 = ej.Predicate(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[b].id);
                                        var predicate2 = ej.Predicate(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2], ej.FilterOperators.equal, this.res1[b].groupId);
                                        var query = predicate1["and"](predicate2);
                                        var tempRes = new ej.DataManager(upApps).executeLocal(new ej.Query().where(query));
                                        var resDateRenderValue = this._resWorkWeek ? this._resDateRen : this._resCustomDate;
                                        var resView = this._resWorkWeek || this._resCustomView;
                                        if (resView && (resDateRenderValue[b].indexOf(this._dateRender[a]) == -1)) tempRes = [];
                                        if (tempRes.length != 0 && !resView) { upTrgt.children().eq(a + b * this._dateRender.length).css({ visibility: "visible" }); }
                                        else if (tempRes.length != 0 && resView) {
                                            var days = 0;
                                            for (var i = 0; i < b ; i++) { days = days + resDateRenderValue[i].length; }
                                            for (var j = 0; j < resDateRenderValue[b].length ; j++) { if (resDateRenderValue[b][j] == this._dateRender[a]) break; }
                                            upTrgt.children().eq(days + j).css({ visibility: "visible" });
                                        }
                                    }
                                }
                            }
                        }
                        var downApps = new ej.DataManager(dayApps).executeLocal(new ej.Query().where(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThan, new Date(new Date(this._dateRender[a]).setMilliseconds(downTime))));
                        downApps = this._appointmentSort(downApps);
                        if (!ej.isNullOrUndefined(downTrgt) && downApps.length != 0) {
                            if (this._grouping.length == 0) { downTrgt.children().eq(a).css({ visibility: "visible" }); }
                            else {
                                if (this._grouping.length == 1) {
                                    for (var c = 0; c < this.res1.length; c++) {
                                        var tempRes1 = new ej.DataManager(downApps).executeLocal(new ej.Query().where(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[c].id));
                                        if (tempRes1.length != 0) { downTrgt.children().eq(a + c * this._dateRender.length).css({ visibility: "visible" }); }
                                    }
                                }
                                else {
                                    for (var c = 0; c < this.res1.length; c++) {
                                        var predicate1 = ej.Predicate(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1], ej.FilterOperators.equal, this.res1[c].id);
                                        var predicate2 = ej.Predicate(this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2], ej.FilterOperators.equal, this.res1[c].groupId);
                                        var query = predicate1["and"](predicate2);
                                        var tempRes = new ej.DataManager(downApps).executeLocal(new ej.Query().where(query));
                                        var resDateRenderValue = this._resWorkWeek ? this._resDateRen : this._resCustomDate;
                                        var resView = this._resWorkWeek || this._resCustomView;
                                        if (resView && (resDateRenderValue[c].indexOf(this._dateRender[a]) == -1)) tempRes = [];
                                        if (tempRes.length != 0 && !resView) { downTrgt.children().eq(a + c * this._dateRender.length).css({ visibility: "visible" }); }
                                        else if (tempRes.length != 0 && resView) {
                                            var days = 0;
                                            for (var k = 0; k < c ; k++) { days = days + resDateRenderValue[k].length; }
                                            for (var l = 0; l < resDateRenderValue[c].length ; l++) { if (resDateRenderValue[c][l] == this._dateRender[a]) break; }
                                            downTrgt.children().eq(days + l).css({ visibility: "visible" });
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },

        _renderAppPosition: function (e) {
            var choice = $(e.target).hasClass("e-appup") ? "e-appup" : "e-appdown";
            var index = $(e.target).parent().index();
            var appointments = this._appointmentCount();
            var scrollerObject = this.element.find("div#" + this._id + "_scroller").data("ejScroller");
            switch (choice) {
                case "e-appup":
                    var upValue = scrollerObject.scrollTop();
                    var upIndex = parseInt(upValue / this.element.find(".e-workcells").outerHeight()) + 1;
                    var upTrgt = this.element.find(".e-draggableworkarea").find("tr").eq(upIndex);
                    var time = ((this.model.startHour * 60) + upIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                    var trgtDate = new Date(new Date(this.dateRender[index]).setMilliseconds(time));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(this.dateRender[index]))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(trgtDate));
                    var upApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (upApps.length != 0) {
                        var upTime = Math.abs(upApps[0][this._appointmentSettings["startTime"]] - trgtDate);
                        var appRowIndex = parseInt((time - upTime) / ((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * (60 * 1000)));
                        var scrollTo = upValue - ((upIndex - appRowIndex) * this.element.find(".e-workcells").height());
                        this.element.find('div#' + this._id + "_scroller").ejScroller({ scrollTop: scrollTo });
                        this.element.find('.e-scrolltimecells').css({ top: -(this.element.find('.e-draggableworkarea').scrollTop()) + 'px' });
                    }
                    break;
                case "e-appdown":
                    var downValue = scrollerObject.scrollTop() + $(this.element.find(".e-vscroll")[0]).height();
                    var downIndex = parseInt(downValue / this.element.find(".e-workcells").height());
                    var downTrgt = this.element.find(".e-draggableworkarea").find("tr").eq(downIndex);
                    var time = ((this.model.startHour * 60) + downIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000);
                    var trgtDate = new Date(new Date(this.dateRender[index]).setMilliseconds(time));
                    var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(trgtDate))["and"](this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(this.dateRender[index]).setHours(23, 59, 59)));
                    var downApps = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
                    if (downApps.length != 0) {
                        var downTime = trgtDate.getTime() - downApps[0][this._appointmentSettings["endTime"]].getTime();
                        var appRowIndex = parseInt((time - downTime) / ((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * (60 * 1000)));
                        var scrollTo = scrollerObject.scrollTop() + ((appRowIndex - downIndex) * this.element.find(".e-workcells").height()) + this.element.find("div#Appointment_" + downApps[0]["AppTaskId"]).height();
                        this.element.find('div#' + this._id + "_scroller").ejScroller({ scrollTop: scrollTo });
                        this.element.find('.e-scrolltimecells').css({ top: -(this.element.find('.e-draggableworkarea').scrollTop()) + 'px' });
                    }
                    break;
            }
            this._renderUpDownIconPosition();
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
        },

        _findAllDayApp: function (apps) {
            if (!apps[this._appointmentSettings["allDay"]]) {
                if (!apps[this._appointmentSettings["recurrence"]])
                    var tempCurrent = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, apps.ParentId));
                else
                    var tempCurrent = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, apps[this._appointmentSettings["id"]]));
                var Value = (!ej.isNullOrUndefined(tempCurrent[0])) ? (((tempCurrent[0][this._appointmentSettings["endTime"]] - tempCurrent[0][this._appointmentSettings["startTime"]]) / 3600000) >= 24) ? true : false : false;
                return Value;
            }
        },

        _resourceOrderSort: function (appointmentsList) {
            if (appointmentsList.length > 0 && this._grouping.length == 0 && this._tempResource.length > 0) {
                var proxy = this, filterCollection = [];
                var resMapping = this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim();
                var resSettings = this._tempResource[this._tempResource.length - 1].resourceSettings;
                appointmentsList.forEach(function (obj) {
                    var appList = appointmentsList.filter(function (list) { return new Date(list[proxy._appointmentSettings["startTime"]]).getTime() == new Date(obj[proxy._appointmentSettings["startTime"]]).getTime() && new Date(list[proxy._appointmentSettings["endTime"]]).getTime() == new Date(obj[proxy._appointmentSettings["endTime"]]).getTime(); });
                    var collection = $(appList).not(filterCollection);
                    if (collection.length != 0) {
                        var resField = $.unique(collection.map(function (index, list) { return list[proxy._id + "_ownerfield_" + (proxy._tempResource.length - 1)]; }));
                        var resOrder = resSettings.dataSource.map(function (a) { return a[resSettings.id]; }).toString();
                        var resId = (resField.length > 0) ? resField[0].split(",") : resOrder.split(",");
                        for (var r = 0, len = resId.length; r < len; r++) {
                            var filterList = collection.filter(function (index, list) { return list[resMapping] == (resId[r] || parseInt(resId[r])); });
                            for (var res = 0; res < filterList.length; res++) {
                                filterCollection.push(filterList[res]);
                            }
                        }
                    }
                });
                new ej.DataManager(appointmentsList).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                $.merge(appointmentsList, filterCollection);
            }
            return appointmentsList;
        },

        _getDayAppointments: function (day, res) {
            var dateCount = this._dateRender, appointmentsList = this._currentViewAppointments = this._appointmentCount();
            var startDateTime = new Date(new Date(dateCount[day]).setHours(this.model.startHour, 0, 0));
            var endDateTime = (this.model.endHour < 24) ? new Date(new Date(dateCount[day]).setHours(this.model.endHour, 0, 0)) : new Date(new Date(dateCount[day]).setHours(23, 59, 59));
			var predicate3 = ej.Predicate(this._appointmentSettings["allDay"], ej.FilterOperators.equal, true);
            var predicate2 = ej.Predicate(this._appointmentSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, new Date(startDateTime)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
            var predicate1 = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(startDateTime)).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(endDateTime));
            var predicate = predicate2["or"](predicate1)["or"](predicate3);
            predicate = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
            predicate = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]) : predicate;
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate));
            var renderedAlready = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(new Date(dateCount[day - 1]).setHours(24, 0, 0))).or(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day]));
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(renderedAlready));
            appointmentsList = this._resourceOrderSort(appointmentsList);
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                for (var app = 0; app < appointmentsList.length; app++) {
                    var isBigApp = (((appointmentsList[app][this._appointmentSettings["endTime"]] - appointmentsList[app][this._appointmentSettings["startTime"]]) / 3600000) >= 24);
                    var allDayCheck = appointmentsList[app][this._appointmentSettings["allDay"]];
                    allDayCheck = (ej.isNullOrUndefined(allDayCheck) || allDayCheck == "") ? false : allDayCheck;
                    if (((new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime())) && allDayCheck) || isBigApp) {
                        this._setAllDayPos(appointmentsList[app], day, res);
                    }
                    else if ((new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(appointmentsList[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (!allDayCheck)) {
                        if (this._findAllDayApp(appointmentsList[app]))
                            this._setAllDayPos(appointmentsList[app], day, res);
                        else {
                            var isAvail = this._renderedApp.filter(function (obj) { return obj.Guid == appointmentsList[app]; });
                            if (isAvail.length == 0) this._renderApp(appointmentsList[app], day, res);
                        }
                    }
                }
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                this._getHorizontalDayAppointments(appointmentsList, dateCount, day, res);
        },

        _startUtc: function (e) {
            (!ej.isNullOrUndefined(this.startutcValue) && ej.isNullOrUndefined(this.tempValue)) ? this._utcValue(e, "startUtc") : e.model.value == "" ? "" : ((e.model.value == this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList('model.value') && this._appointmentAddWindow.find("#" + this._id + "startTimeZone").attr('aria-expanded') == "true")) ? this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { text: e.text, value: e.value }) : "";
        },
        _endUtc: function (e) {
            (this._appointmentAddWindow.find("#" + this._id + "endTimeZone").attr('aria-expanded') == "true") ? this._utcValue(e, "endUtc") : this.startutcValue = this.tempValue = null;
        },
        _utcValue: function (temp, getValue) {
            ej.preferredCulture(this.model.locale);
            getValue == "endUtc" ? this._appointmentAddWindow.find('.endutc').val(temp.text) : "";
            var localeDate = { StartDate: this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("model.value"), EndDate: this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("model.value") };
            var localeTime = { StartTime: this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("model.value"), EndTime: this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("model.value") };
            var strTime = this._timeFormat(localeTime.StartTime).split(":"), endTime = this._timeFormat(localeTime.EndTime).split(":");
            var utcValue = new Date(localeDate.StartDate.setHours(parseInt(strTime[0], 10), parseInt(strTime[1], 10)));
            var utcendValue = new Date(localeDate.EndDate.setHours(parseInt(endTime[0], 10), parseInt(endTime[1], 10)));
            var startDateutc = new Date(utcValue);
            var EndDateutc = new Date(utcendValue);
            var utcEnd = getValue == "Appoint" ? this.endTimeAppoint : getValue == "endUtc" ? temp.value : this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("model.value");
            var utcStart = getValue == "Appoint" ? this.startTimeAppoint : getValue == "startUtc" ? temp.value : this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("model.value");
            utcStart = (utcStart == "") ? this._timezoneStringValue() : utcStart;
            utcEnd = (utcEnd == "") ? this._timezoneStringValue() : utcEnd;
            utcEnd = utcEnd.indexOf("UTC") != -1 ? parseInt(utcEnd.split(" ")[1].split(":")[0]) * 60 + parseInt(utcEnd.split(" ")[1].split(":")[1]) : parseInt(utcEnd.split(":")[0]) * 60 + parseInt(utcEnd.split(":")[1]);
            utcStart = utcStart.indexOf("UTC") != -1 ? parseInt(utcStart.split(" ")[1].split(":")[0]) * 60 + parseInt(utcStart.split(" ")[1].split(":")[1]) : parseInt(utcStart.split(":")[0]) * 60 + parseInt(utcStart.split(':')[1]);
            var startendUtc = utcEnd - utcStart;
            utcValue = new Date(utcValue.setMinutes(utcValue.getMinutes() + startendUtc));
            if (getValue == "Appoint") {
                var dateNew = new Date(temp[this._appointmentSettings["startTime"]]);
                var endNew = new Date(temp[this._appointmentSettings["endTime"]]);
                var timeZoneValue = ej.isNullOrUndefined(this.model.timeZone) ? -new Date().getTimezoneOffset() + this._timeZoneOffset : this.model.timeZone.indexOf('UTC') != -1 ? ((parseInt(this.model.timeZone.split(" ")[1].split(":")[0]) * 60) + (parseInt(this.model.timeZone.split(" ")[1].split(":")[1]))) : ((parseInt(this.model.timeZone.split(":")[0]) * 60) + (parseInt(this.model.timeZone.split(":")[1])));
                var timeZoneStart = (utcStart == timeZoneValue) ? 0 : timeZoneValue - utcStart;
                timeZoneStart = new Date(dateNew.setMinutes(dateNew.getMinutes() - timeZoneStart));
                var value2 = this._timeMode == "12" ? ej.format(new Date(timeZoneStart), this._pattern.t, this.model.locale) : ej.format(new Date(timeZoneStart), "HH:mm", this.model.locale);
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker({ value: ej.format(new Date(timeZoneStart), this._datepattern(), this.model.locale) });
                var timeZoneEnd = utcEnd - timeZoneValue;
                this._appointmentAddWindow.find('#' + this._id + "starttime").ejTimePicker({ value: value2 });
            }
            utcendValue = (getValue == "endUtc" || getValue == "Appoint") ? new Date(startDateutc.setMinutes(startDateutc.getMinutes() + startendUtc)) : utcValue;
            utcendValue = getValue == "Appoint" ? new Date(endNew.setMinutes(endNew.getMinutes() + timeZoneEnd)) : utcendValue;
            var different = this._timeMode == "12" ? ej.format(new Date(utcValue), this._pattern.t, this.model.locale) : ej.format(new Date(utcValue), "HH:mm", this.model.locale);
            if (getValue == "Appoint") {
                value = this._timeMode == "12" ? ej.format(new Date(endNew), this._pattern.t, this.model.locale) : ej.format(new Date(endNew), "HH:mm", this.model.locale);
            }
            else {
                var endTimeValue = new Date(utcendValue.setMinutes(utcendValue.getMinutes() + 30));
                var value = this._timeMode == "12" ? ej.format(new Date(endTimeValue), this._pattern.t, this.model.locale) : ej.format(new Date(endTimeValue), "HH:mm", this.model.locale);
            }
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker({ value: ej.format(new Date(utcendValue), this._datepattern(), this.model.locale) });
            this._appointmentAddWindow.find('#' + this._id + "endtime").ejTimePicker({ value: value });
            this.startutcValue = 1;
        },

        _rowHandlesOver: function (e) {
            this.model.enableAppointmentResize && $(e.target).addClass("e-rowcursor");
        },

        _colHandlesOver: function (e) {
            this.model.enableAppointmentResize && $(e.target).addClass("e-columncursor");
        },

        _getDateCount: function (res) {
            if (this._resWorkWeek) {
                var index, resDates, dateCount = [];
                if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                    resDates = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                else resDates = this.model.workWeek;
                resDates = this._resourceDaysReorder(resDates);
                for (var a = 0; a < resDates.length; a++) {
                    index = this._dayFullNames.indexOf(resDates[a].capitalizeFirstString());
                    if (index == -1) {
                        index = this._getDayNameIndex(resDates[a]);
                    }
                    dateCount.push(this._renderDates[index]);
                }
            }
            else if (this._resCustomView) {
                dateCount = this._resCustomDate[res];
            }
            else
                var dateCount = this._dateRender;
            return dateCount;
        },

        _renderApp: function (record, day, res) {
            var cellHeight = this.cellheight,
                startHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.startHour) : 0,
                endHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.endHour) : 24,
                dateCount = this._getDateCount(res),
                rStartTime = new Date(record[this._appointmentSettings["startTime"]]),
                rEndTime = new Date(record[this._appointmentSettings["endTime"]]);

            rStartTime = ((new Date(rStartTime).getHours()) < startHour) ? new Date(new Date(rStartTime).setHours(startHour, rStartTime.getMinutes(), rStartTime.getSeconds())) : rStartTime;
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                var appWidth, appHeight, startTime, endTime, endDate, topPosition, resValue, overlapList, predicate, appointmentsList, appLevelsInDay, index = -1;
                if (rStartTime <= rEndTime && (new Date(dateCount[0]).getTime() <= rStartTime.getTime() && new Date(new Date(dateCount[dateCount.length - 1]).setHours(23, 59, 59)) >= rStartTime.getTime())) {
                    startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
                    endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
                    endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;
                    if (endHour <= rEndTime.getHours()) {
                        endDate = new Date(rEndTime.setHours(endHour, 0, 0));
                        appHeight = (parseFloat(((new Date(endDate).getHours() * 60) + (new Date(endDate).getMinutes())) - ((new Date(rStartTime).getHours() * 60) + (new Date(rStartTime).getMinutes()))) * ((cellHeight) * this.model.timeScale.minorSlotCount) / this.model.timeScale.majorSlot) - 2;
                    }
                    else {
                        appHeight = ((parseFloat(new Date(new Date(rEndTime).getTime()) - new Date(new Date(rStartTime).getTime()))) / (60 * 1000) * (cellHeight * this.model.timeScale.minorSlotCount) / (this.model.timeScale.majorSlot)) - 2;
                        appHeight = (record[this._appointmentSettings["endTime"]].getTimezoneOffset() - record[this._appointmentSettings["startTime"]].getTimezoneOffset() != 0) ? (appHeight - (cellHeight * this.model.timeScale.minorSlotCount)) : appHeight;
                    }
					appHeight=appHeight<0?cellHeight-2:appHeight;
                    topPosition = ((parseFloat((((new Date(rStartTime).getHours() * 60)) + new Date(rStartTime).getMinutes() + (new Date(rStartTime).getSeconds() / 60))) - parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - (this.model.startHour * 60)) * cellHeight * (this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    if (this.model.startHour <= new Date(rStartTime).getHours()) {
                        resValue = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] : null;
                        overlapList = this._overlapApp(record["AppTaskId"], record[this._appointmentSettings["startTime"]], record[this._appointmentSettings["endTime"]], resValue);
                        var proxy = this;
                        if (this._grouping.length > 0 && this._tempResource.length > 0 && this._tempResource[0].resourceSettings.dataSource.length > 0 && ej.scheduleFeatures.resources)
                            appointmentsList = overlapList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > record[proxy._appointmentSettings["startTime"]] && obj[proxy._appointmentSettings["startTime"]] < record[proxy._appointmentSettings["endTime"]] && obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == proxy.res1[res][proxy._tempResource[proxy._tempResource.length - 1].resourceSettings["id"]]; });
                        else
                            appointmentsList = overlapList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > record[proxy._appointmentSettings["startTime"]] && obj[proxy._appointmentSettings["startTime"]] < record[proxy._appointmentSettings["endTime"]]; });

                        if (appointmentsList.length > 0) {
                            this._variable = [];
                            for (var list = 0, len = appointmentsList.length; list < len; list++) {
                                ej.isNullOrUndefined(this._variable[appointmentsList[list]["Index"]]) ? this._variable[appointmentsList[list]["Index"]] = [appointmentsList[list]] : this._variable[appointmentsList[list]["Index"]].push(appointmentsList[list]);
                            }
                            appLevelsInDay = $.map(appointmentsList, function (value, Index) { return [value.Index]; });
                            index = this._smallestMissingNumber(appLevelsInDay);
                        }
                        index = (index == -1) ? 0 : index;
                        record.Index = index;
                        overlapList.push(record);
                        if (overlapList.length != 1)
                            ej.isNullOrUndefined(this._variable[index]) ? this._variable[index] = [record] : this._variable[index].push(record);
                        else {
                            this._variable = [];
                            this._variable.push([record]);
                        }
                        var defaultAppWidth = (this.element.find(".e-workcells").width() < 20) ? 60 : 90;
                        appWidth = ((((defaultAppWidth - (this._variable.length)) / (this._variable.length)))) + "%";
                        this.leftPosition = '0%';
                        var resDay = (this._resWorkWeek || this._resCustomView) ? 0 : this._dateRender.length * res;
                        for (var i = 0, len1 = this._variable.length; i < len1; i++) {
                            if (!ej.isNullOrUndefined(this._variable[i])) {
                                for (var j = 0, len2 = this._variable[i].length; j < len2; j++) {
                                    var element = this.element.find(".e-workcellstab tr td:nth-child(" + (resDay + day + 1) + ")").find(".e-appointwrapper").find(".e-appointment");
                                    var eleGuid = this._variable[i][j]["Guid"];
                                    var apps = element.filter('div[data-guid=' + eleGuid + ']');
                                    if (!ej.isNullOrUndefined(apps[0]) && eleGuid != record["Guid"]) {
                                        if (parseFloat(appWidth) <= parseFloat(apps[0].style.width)) {
                                            this.model.enableRTL ? apps[0].style.right = ((parseFloat(appWidth) + 1) * i) + '%' : apps[0].style.left = ((parseFloat(appWidth) + 1) * i) + '%';
                                            apps[0].style.width = ((parseFloat(appWidth))) + '%';
                                        }
                                        else {
                                            var eleGuid = this._variable[ej.isNullOrUndefined(this._variable[i - 1]) ? i : i - 1][0]["Guid"];
                                            var apps1 = element.filter('div[data-guid=' + eleGuid + ']');
                                            if (apps1.length > 0) apps[0].style.width = apps1[0].style.width;
                                            this.model.enableRTL ? apps[0].style.right = ((parseFloat(apps[0].style.width) + 1) * i) + '%' : apps[0].style.left = ((parseFloat(apps[0].style.width) + 1) * i) + '%';
                                        }
                                    }
                                    else {
                                        appWidth = ej.isNullOrUndefined(this._variable[i - 1]) ? ((((defaultAppWidth - (this._variable.length)) / (this._variable.length)))) : !ej.isNullOrUndefined(this.element.find('div[data-guid=' + this._variable[i - 1][0]["Guid"] + ']')[0]) && parseFloat(element.filter('div[data-guid=' + this._variable[i - 1][0]["Guid"] + ']')[0].style.width);
                                        this.leftPosition = ((appWidth + 1) * index) + '%';
                                    }
                                }
                            }
                        }
                        appWidth = parseFloat(appWidth) + "%";
                        !record.inline && this._renderedApp.push($.extend(true, {}, record));
                        var colorAppointment = this._appointmentColor(record);
                        if (this.model.allowInline && (!ej.isNullOrUndefined(record["inline"]))) {
                            this._inlineTemplate(record, this.leftPosition, topPosition, appWidth, appHeight, colorAppointment, true);
                            var cellindex = (this._resWorkWeek || this._resCustomView) ? ((startTime * this.model.timeScale.minorSlotCount) * this.element.find(".e-headercells").length) + day : parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * dateCount.length * this.res1.length + day + (dateCount.length * res);
                            var celltd = this.element.find("td.e-workcells").eq(cellindex);
                            celltd.prepend($("<div class='e-inlinewrapper' style='position:relative;'></div>").append(this._inlineText));
                        }
                        else {
                            var userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                            userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                            startTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                            endTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale),
                            recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                            indicationIcon = this._indicationApp(record),
                            timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), appHeight: appHeight, rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition, top: topPosition, appWidth: appWidth, userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, topInd: indicationIcon.leftIndication, bottomInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" })),
                            index = (this._resWorkWeek || this._resCustomView) ? ((startTime * this.model.timeScale.minorSlotCount) * this.element.find(".e-headercells").length) + day : parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * dateCount.length * this.res1.length + day + (dateCount.length * res),
                            celltd = this.element.find("td.e-workcells").eq(index);
                            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        }
                    }
                }
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                this._renderHorizontalApp(rStartTime, rEndTime, record, day, cellHeight, this.model.timeScale.minorSlotCount, startHour, endHour);
            delete record["Index"];
        },

        _priorityTemplate: function (record) {
            return this.model.prioritySettings.template.replace("{", "").replace("$", "").replace("}", "").replace(this.model.prioritySettings.template.indexOf("value") != -1 ? this.model.prioritySettings.value : this.model.prioritySettings.text, record[this._appointmentSettings["priority"]]);
        },

        _getUserAppointmentTemplate: function (record) {
            var userTemp = $.templates($(this.model.appointmentTemplateId).html());
            var cloneObj = $.extend(cloneObj, record);
            cloneObj.View = this.currentView();
            var userTempHtml = userTemp.render(cloneObj);
            return userTempHtml;
        },

        _getUserTimeCellsTemplate: function () {
            var userTemp = $.templates($(this.model.timeScale.minorSlotTemplateId).html());
            var timelist, startendTimes = [];
            for (var i = this.model.startHour; i < this.model.endHour;) {
                var j = 0;
                while (j < 60) {
                    j = j * 60 * 1000;
                    timelist = userTemp.render({ date: new Date(new Date(this._dateRender[0]).setHours(i, 0, 0, j)) });
                    startendTimes.push({ time: timelist.trim(), id: i + "_" + j });
                    j = (j / (60 * 1000)) + this.model.timeScale.majorSlot;
                }
                i = (this.model.timeScale.majorSlot > 60) ? i + (this.model.timeScale.majorSlot / 60) : i + 1;
            }
            return startendTimes;
        },

        _getUserAllDayCellsTemplate: function () {
            var dateRender = [], minutes = 0, date, userTemp, userHtml;
            userTemp = $.templates($(this.model.allDayCellsTemplateId).html());
            for (var a = 0; a < this.res1.length; a++) {
                for (var b = 0; b < this._dateRender.length; b++) {
                    date = new Date(new Date(this._dateRender[b]).setHours(this.model.startHour, minutes, 0));
                    userHtml = userTemp.render({ date: date, view: this.currentView(), resource: this.res1[a], timescale: this.model.timeScale.enable });
                    dateRender.push(userHtml.trim());
                }
            }
            return dateRender;
        },

        _getUserDateheaderTemplate: function () {
            var colCount = [], userTemp, userDate, curday, headerCellClass, temp;
            userTemp = $.templates($(this.model.dateHeaderTemplateId).html());
            for (var i = 0; i < this._dateRender.length; i++) {
                userDate = userTemp.render({ date: new Date(this._dateRender[i]) });
                curday = (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomMonthView())) ? (this._tempResource.length == 0 && ej.isNullOrUndefined(this.model.group)) ? this._dayFullNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()] : this._dayShortNames[new Date(this._dateRender[i]).getDay()];
                headerCellClass = (new Date(new Date(this._dateRender[i]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date().setHours(0, 0, 0, 0)).getTime()) ? "e-headerToday" : "";
                temp = (this.currentView() === "month" || (this._isCustomMonthView())) ? { currentDay: curday, currentDateClass: "", cellToday: "" } : { currentDay: userDate, currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass };
                colCount.push(temp);
                this._value.push(i);
            }
            return colCount;
        },

        _getUserWorkCellsTemplate: function () {
            var date, dateRender = [], dateRender1 = [], userTemp, userHtml, minutes = 0, tdCount = this.model.timeScale.minorSlotCount;
            userTemp = $.templates($(this.model.workCellsTemplateId).html());
            this._isCustomMonthView();
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                if (this.currentView() != "month" && !this._isCustomMonthView()) {
                    for (var a = 0; a < ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) ; a++) {
                        dateRender = [];
                        for (var b = 0; b < this.res1.length; b++) {
                            for (var c = 0; c < this._dateRender.length; c++) {
                                date = new Date(new Date(this._dateRender[c]).setHours(this.model.startHour, minutes, 0));
                                userHtml = userTemp.render({ date: date, view: this.currentView(), resource: this.res1[b], timescale: this.model.timeScale.enable });
                                dateRender.push(userHtml.trim());
                            }
                        }
                        minutes = minutes + (this.model.timeScale.majorSlot / tdCount);
                        dateRender1.push(dateRender);
                    }
                }
                else {
                    var i = 0, noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
                    for (var a = 0; a < this._dateRender.length / noOfDays; a++) {
                        dateRender = [];
                        for (var b = 0; b < this.res1.length; b++) {
                            i = a * 7;
                            for (var c = 0; c < noOfDays; c++) {
                                date = new Date(new Date(this._dateRender[i]).setHours(this.model.startHour, minutes, 0));
                                userHtml = userTemp.render({ date: date, view: this.currentView(), resource: this.res1[b], timescale: this.model.timeScale.enable });
                                dateRender.push(userHtml.trim());
                                i++;
                            }
                        }
                        dateRender1.push(dateRender);
                    }
                }
            }
            else {
                var userHtml1, timeRender = [], tempRender = [], time = [], rCollection = this._tempResource.length == 0 ? this.res1 : this._resourceSort();
                if (this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                    for (var a = 0; a < rCollection.length; a++) {
                        dateRender = []; tempRender = []; time = [];
                        for (var b = 0; b < this._dateRender.length; b++) {
                            minutes = 0;
                            for (var c = 0; c < ((this.model.endHour - this.model.startHour) * (60 / this.model.timeScale.majorSlot)) ; c++) {
                                for (var d = 0; d < tdCount; d++) {
                                    date = new Date(new Date(this._dateRender[b]).setHours(this.model.startHour, minutes, 0));
                                    if (d == 0) {
                                        userHtml = userTemp.render({ date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                                        dateRender.push(userHtml.trim());
                                    }
                                    else {
                                        userHtml1 = userTemp.render({ date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                                        timeRender.push(userHtml1.trim());
                                        if (timeRender.length == tdCount - 1) {
                                            time.push(timeRender);
                                            timeRender = [];
                                        }
                                    }
                                    minutes = minutes + (this.model.timeScale.majorSlot / tdCount);
                                }
                            }
                        }
                        var temp = $.extend(true, [], dateRender);
                        var temp1 = $.extend(true, [], time);
                        tempRender.push(temp, temp1);
                        dateRender1.push(tempRender);
                    }
                }
                else {
                    var monthDates = (!this.model.timeScale.enable && this.currentView() != "month" || (this.currentView() == "customview" && this._oneWeek)) ? this._dateRender : this.monthDays;
                    for (var a = 0; a < rCollection.length; a++) {
                        dateRender = [];
                        for (var b = 0; b < monthDates.length; b++) {
                            date = new Date(new Date(monthDates[b]).setHours(this.model.startHour, minutes, 0));
                            userHtml = userTemp.render({ date: date, view: this.currentView(), resource: rCollection[a], timescale: this.model.timeScale.enable });
                            dateRender.push(userHtml.trim());
                        }
                        dateRender1.push(dateRender);
                    }
                }
            }
            return dateRender1;
        },

        _overlapApp: function (id, appStartTime, appEndTime, resValue) {
            var _appList = this._renderedApp, appointmentsList = [], app = [], appList = [], overlapList = [];
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                var proxy = this;
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                    appointmentsList = _appList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > appStartTime && obj[proxy._appointmentSettings["startTime"]] < appEndTime && obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == resValue; });
                else
                    appointmentsList = _appList.filter(function (obj) { return obj[proxy._appointmentSettings["endTime"]] > appStartTime && obj[proxy._appointmentSettings["startTime"]] < appEndTime; });

                appointmentsList.forEach(function (obj) {
                    if (!ej.isNullOrUndefined(proxy.model.group) && (proxy._tempResource.length != 0) && proxy._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                        appList = _appList.filter(function (list) { return list[proxy._appointmentSettings["endTime"]] >= new Date(obj[proxy._appointmentSettings["startTime"]]) && list[proxy._appointmentSettings["startTime"]] <= new Date(obj[proxy._appointmentSettings["endTime"]]) && list[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == resValue; });
                    else
                        appList = _appList.filter(function (list) { return list[proxy._appointmentSettings["endTime"]] >= new Date(obj[proxy._appointmentSettings["startTime"]]) && list[proxy._appointmentSettings["startTime"]] <= new Date(obj[proxy._appointmentSettings["endTime"]]); });
                    var collection = $(appList).not(appointmentsList);
                    if (collection.length != 0) app = $.merge(app, collection);
                    return app;
                });
                overlapList = $.merge(appointmentsList, app);
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal) {
                for (var i = 0; i < _appList.length; i++) {
                    if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group)) {
                        if ((new Date(_appList[i][this._appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(_appList[i][this._appointmentSettings["startTime"]]) <= new Date(appEndTime))
                            && (_appList[i][this._tempResource[this._tempResource.length - 1]["field"]] == resValue)
                            && (new Date(new Date(_appList[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date(appStartTime).setHours(0, 0, 0, 0)).getTime())) {
                            overlapList.push(_appList[i]);
                        }
                    }
                    else {
                        if ((new Date(_appList[i][this._appointmentSettings["endTime"]]) > new Date(appStartTime)) && (new Date(_appList[i][this._appointmentSettings["startTime"]]) <= new Date(appEndTime))
                            && (new Date(new Date(_appList[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() === new Date(new Date(appStartTime).setHours(0, 0, 0, 0)).getTime())) {
                            overlapList.push(_appList[i]);
                        }
                    }
                }
            }
            return overlapList;
        },

        _getOverlapCount: function (record, day, dateRender, resValue) {
            if (this._renderedAllDay.length == 0) {
                record.Index = 0;
                var index = 0;
            }
            else {
                var appLevelsInDay = [], proxy = this;
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    var appointments = this._renderedAllDay.filter(function (obj) {
                        return ((obj[proxy._appointmentSettings["endTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))) ||
                               (obj[proxy._appointmentSettings["startTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59)))) &&
                               (obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == record[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]);
                    });
                }
                else {
                    var appointments = this._renderedAllDay.filter(function (obj) {
                        return ((obj[proxy._appointmentSettings["endTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))) ||
                               (obj[proxy._appointmentSettings["startTime"]] >= new Date(dateRender[day]) && obj[proxy._appointmentSettings["startTime"]] <= new Date(new Date(dateRender[day]).setHours(23, 59, 59))));
                    });
                }
                var filterData = [];
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    for (var i = 0, len = appointments.length; i < len; i++) {
                        var isBigApp = (((appointments[i][this._appointmentSettings["endTime"]] - appointments[i][this._appointmentSettings["startTime"]]) / 3600000) >= 24);
                        var allDayCheck = appointments[i][this._appointmentSettings["allDay"]];
                        if (((((new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime() == (new Date(new Date(appointments[i][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime())) &&
                                  allDayCheck) || isBigApp) && (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) ? (appointments[i][this._tempResource[this._tempResource.length - 1]["field"]] == resValue) : true))) {
                            filterData.push(appointments[i]);
                        }
                    }
                }
                else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                    filterData = this._getHorizontalOverlapCount(appointments, dateRender, day, record, resValue);
                var index = -1;
                index = this._findResourceIndex(filterData, "AppTaskId", record["AppTaskId"], null, null);
                var appLevelsInDay = $.map(filterData, function (value, Index) { return [value.Index]; });
                index = this._smallestMissingNumber(appLevelsInDay);
                record.Index = index;
                index = index == -1 ? 0 : index;
            }
            return index;
        },
        _smallestMissingNumber: function (array) {
            if (array.length == 0) return 0;
            var large = Math.max.apply(Math, array);
            for (var i = 0; i < large; i++) {
                if (array.indexOf(i) == -1) {
                    return i;
                }
            }
            return large + 1;
        },
        _setAllDayPos: function (record, day, res) {
            var level = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._getOverlapCount(record, day, this._dateRender, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getOverlapCount(record, day, this._dateRender, null);
            var start = new Date(record[this._appointmentSettings["startTime"]]),
                end = new Date(record[this._appointmentSettings["endTime"]]);
            if (new Date(start) <= new Date(end)) {
                var dateRender = this._dateRender, appWidth, left = 0, top = (this.element.find(".e-alldayappointment").length > 0 ? this.element.find(".e-alldayappointment").outerHeight(true) : this._getElementHeight("e-alldayappointment")), appHeight = top;
                if (this.level <= level) {
                    var cellHeight = (level + 1) * (appHeight) + this.alldaycellsheight;
                    this.element.find(".e-alldaycells,.e-leftindent").removeClass("e-alldaycellsheight").css('height', cellHeight + "px");
                    this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                    if (this.element.find(".e-vscroll").length == 0 && this.level == 0) this._reRenderScroller();
                }
                this._overflowFlag = true;
                if (this._resWorkWeek) {
                    var index, resDates, dateCount = [];
                    if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        resDates = this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                    else
                        resDates = this.model.workWeek;
                    for (var a = 0; a < resDates.length; a++) {
                        index = this._dayFullNames.indexOf(resDates[a].capitalizeFirstString());
                        if (index == -1) {
                            index = this._getDayNameIndex(resDates[a]);
                        }
                        dateCount.push(this._renderDates[index]);
                    }
                    dateRender = dateCount;
                }
                if (this._resCustomView) {
                    dateRender = this._resCustomDate[res];
                }
                var r_start = ($.inArray(new Date(record[this._appointmentSettings["startTime"]]).getTime(), dateRender) == -1) ? record[this._appointmentSettings["startTime"]] : new Date(dateRender[0]),
                    r_end = new Date(new Date(dateRender[dateRender.length - 1]).setHours(23, 59, 59));
                end = new Date(end) > new Date(r_end) ? r_end : end;
                if ((this.currentView() == "workweek" || this.currentView() == "week" && !this.model.showWeekend) && $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), this._dateRender) == -1) {
                    for (var i = 1; i < this._dateRender.length; i++) {
                        if ($.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate() - i).getTime(), this._dateRender) > 0) {
                            var index = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate() - i).getTime(), this._dateRender);
                            end = new Date(new Date(this._dateRender[index]).setHours(record[this._appointmentSettings["endTime"]].getHours(), record[this._appointmentSettings["endTime"]].getMinutes(), record[this._appointmentSettings["endTime"]].getSeconds()));
                            break;
                        }
                    }
                }
                !record.inline && this._renderedAllDay.push($.extend(true, {}, record));
                var diffInDays;
                if (this._resWorkWeek || this.currentView() == "workweek" || (this.currentView() == "week" && !this.model.showWeekend))
                    diffInDays = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), dateRender) - ($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), dateRender)) + 1;
                else if (this.currentView() == "week" || this.currentView() == "day" || (this.currentView() == "customview" && parseFloat((end - start) / 3600000) <= 24))
                    diffInDays = (end.getHours() == 0 && end.getMinutes() == 0) ? Math.ceil(((new Date(end) - new Date(start)) / (1000 * 3600)) / 24) : Math.ceil(((new Date(end).setHours(23, 59, 59) - new Date(start).setHours(0, 0, 0)) / (1000 * 3600)) / 24);
                else
                    diffInDays = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), this._dateRender) - ($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), this._dateRender)) + 1;
                if ((($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), dateRender) == -1) && this.currentView() == "workweek") || (this.currentView() == "week" && (!this.model.showWeekend))) {
                    var appstart = new Date(record[this._appointmentSettings["startTime"]]);
                    for (var i = 0; i < this._dateRender.length; i++) {
                        if ($.inArray(new Date(appstart.getFullYear(), appstart.getMonth(), appstart.getDate()).getTime(), dateRender) == -1)
                            appstart.setDate(appstart.getDate() + 1);
                        if ($.inArray(new Date(appstart.getFullYear(), appstart.getMonth(), appstart.getDate()).getTime(), dateRender) != -1)
                            break;
                    }
                    start = appstart;
                    diffInDays = $.inArray(new Date(end.getFullYear(), end.getMonth(), end.getDate()).getTime(), dateRender) - ($.inArray(new Date(start.getFullYear(), start.getMonth(), start.getDate()).getTime(), dateRender)) + 1;
                }
                if (diffInDays <= 0) diffInDays = 1;
                var cellWidth = this.element.find(".e-alldaycells").width(),
                    daysCount = this._dateRender.length,
                    alldayTr = (!ej.isNullOrUndefined(this.model.group) && this._tempResource.length != 0) ? this._grouping.length : 0,
                    tdIndex = this.currentView() === "day" ? 0 : this._dateRender.indexOf(new Date(start).setHours(0, 0, 0));
                if (this._resWorkWeek || this._resCustomView)
                    left = (this.model.enableRTL) ? this.element.find(".e-headrealldaytable").width() - this.element.find(".e-alldaycells")[day].offsetLeft - this.element.find(".e-alldaycells").width() : this.element.find(".e-alldaycells")[day].offsetLeft;
                else if (!ej.isNullOrUndefined(this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)]))
                    left = (this.model.enableRTL) ? this.element.find(".e-headrealldaytable").width() - this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft - this.element.find(".e-alldaycells").width() : this.element.find(".e-alldaycells")[tdIndex + (res * daysCount)].offsetLeft;
                appWidth = ((diffInDays * cellWidth) + diffInDays) - 2;
                top = (level * top) + (level + 1) + this.element.find(".e-headercells").outerHeight() + ((alldayTr != 0) ? (alldayTr * this.element.find(".e-headerbar").first().height()) : alldayTr);
                if ((((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") && this.element.find(".e-monthnamerow").length > 0)
                    top = this.element.find(".e-monthnamerow").height() + top;
                var colorAppointment = this._appointmentColor(record);
                if (this.model.allowInline && (!ej.isNullOrUndefined(record["inline"]))) {
                    this._inlineTemplate(record, left, top, appWidth, appHeight, colorAppointment, false);
                    this.element.find(".e-headrealldaytable").append(this._inlineText);
                }
                else {
                    var userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                    userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                    startTimeDisp = this._timeMode == "12" ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                    endTimeDisp = this._timeMode == "12" ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale),
                    recEditIcon = (record[this._appointmentSettings["recurrence"]]) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                    indicationIcon = this._indicationApp(record),
                    alldayCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), top: top, rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", allday: true, left: left + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-alldayappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }));
                    (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, alldayCellhtml);
                    this.element.find(".e-headrealldaytable").append(alldayCellhtml);
                }
            }
            this._alldayLevel = false;
            this.level = this.level < level ? level : this.level;
            if (record[this._appointmentSettings["recurrence"]] != 1 && !(this.model.allowInline)) {
                var templist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record.ParentId));
                if ((new Date(record[this._appointmentSettings["endTime"]])) < (templist[0][this._appointmentSettings["endTime"]]))
                    (this.model.enableRTL) ? this.element.find('div[data-guid=' + record["Guid"] + ']').children('.e-lefthandle').remove() : this.element.find('div[data-guid=' + record["Guid"] + ']').children(".e-righthandle").remove();
                if ((new Date(record[this._appointmentSettings["startTime"]])) > (templist[0][this._appointmentSettings["startTime"]]))
                    (this.model.enableRTL) ? this.element.find('div[data-guid=' + record["Guid"] + ']').children(".e-righthandle").remove() : this.element.find('div[data-guid=' + record["Guid"] + ']').children('.e-lefthandle').remove();
            }
            if (!ej.isNullOrUndefined(indicationIcon)) {
                if (indicationIcon.leftIndication)
                    this.model.enableRTL ? this.element.find('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                if (indicationIcon.rightIndication)
                    this.model.enableRTL ? this.element.find('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
            }
            delete record["Index"];
        },
        _indicationApp: function (record) {
            var leftIndication = false, rightIndication = false;
            var indication = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record["ParentId"]))[0];
            if (!ej.isNullOrUndefined(indication)) {
                if (indication[this._appointmentSettings["endTime"]].getHours() == 0 && indication[this._appointmentSettings["endTime"]].getMinutes() == 0) {
                    indication = $.extend(true, [], indication);
                    indication[this._appointmentSettings["endTime"]] = new Date(indication[this._appointmentSettings["endTime"]].getTime() - 1000);
                }
                var rightIndication, leftIndication, startCheck, endCheck, dateRender, splitapp;
                dateRender = this.currentView() == "day" ? [new Date(this._dateRender[0]).getTime()] : this._dateRender;

                startCheck = $.inArray(new Date(new Date(record[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime(), dateRender);
                endCheck = $.inArray(new Date(new Date(record[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime(), dateRender);
                splitapp = ((startCheck != endCheck) && (new Date(new Date(indication[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(indication[this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) && (((indication[this._appointmentSettings["endTime"]] - indication[this._appointmentSettings["startTime"]]) / 3600000) < 24));
                if (!record[this._appointmentSettings["recurrence"]]) {
                    if (((new Date(indication[this._appointmentSettings["startTime"]]) < record[this._appointmentSettings["startTime"]]) || startCheck == -1) && !splitapp)
                        this.model.enableRTL ? rightIndication = true : leftIndication = true;
                    if (((new Date(indication[this._appointmentSettings["endTime"]]) > record[this._appointmentSettings["endTime"]]) || endCheck == -1) && !splitapp)
                        this.model.enableRTL ? leftIndication = true : rightIndication = true;
                }
                else {
                    var recurIndication = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, record["Guid"]));
                    if (recurIndication.length > 1) {
                        var recur = this._sortAppById(recurIndication);
                        if (((recur[0][this._appointmentSettings["startTime"]] < record[this._appointmentSettings["startTime"]]) || startCheck == -1) && !splitapp)
                            this.model.enableRTL ? rightIndication = true : leftIndication = true;
                        if (((recur[recur.length - 1][this._appointmentSettings["endTime"]] > record[this._appointmentSettings["endTime"]]) || endCheck == -1) && !splitapp)
                            this.model.enableRTL ? leftIndication = true : rightIndication = true;
                    }
                }
                return { leftIndication: (ej.isNullOrUndefined(leftIndication)) ? false : leftIndication, rightIndication: (ej.isNullOrUndefined(rightIndication)) ? false : rightIndication };
            }
            else {
                return { leftIndication: false, rightIndication: false };
            }
        },
        _reRenderScroller: function () {
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                var dialogObj = this._appointmentAddWindow.data("ejDialog");
                dialogObj.option("enableAnimation", false);
                dialogObj.close();
            }
            var _scrollDiv = this.element.find('div#' + this._id + '_scroller');
            var scrollerObj = _scrollDiv.data("ejScroller");
            var scrollWidth = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? parseInt(this.element.width()) - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? parseInt(this.element.width()) - parseInt(this.element.find(".e-resourceheadertable").width()) : parseInt(this.element.width());
            scrollerObj.model.width = parseInt(scrollWidth) - 2;
            scrollerObj.model.height = this.scHeight - 1 - (this.wTR.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            scrollerObj.refresh();
            if (this.model.cellWidth != "") {
                var overallWidth = (parseInt(this.model.cellWidth) + 1) * (this.element.find('div.e-draggableworkarea tr:first td').length);
                var timeScaleWidth = this.wTR.find(".e-scrolltimecells").length > 0 ? this.wTR.find(".e-scrolltimecells").width() : 0;
                this.wTR.find(".e-draggableworkarea").width((this.element.width() > (overallWidth) + timeScaleWidth + (_scrollDiv.ejScroller("isVScroll") ? 18 : 0)) ? (overallWidth) - 1 : scrollWidth - 2 - (_scrollDiv.ejScroller("isVScroll") ? 18 : 0));
                this.aTR.find(".e-headeralldaydiv").width(this.wTR.find(".e-draggableworkarea").width());
            }
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && (!this.model.cellHeight) && this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable)
                this.element.find(".e-draggableworkarea").height(scrollerObj.model.height - (_scrollDiv.ejScroller("isHScroll") ? 18 : 0));
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._mediaQuery && this.res1.length > 1)
                this.element.find(".e-draggableworkarea").width(this.element.find(".e-draggableworkarea").width() * this.res1.length);
            this.aTR.find(".e-headeralldaydiv").width(this.wTR.find(".e-draggableworkarea").width());
            this.wTR.find(".e-scrolltimecells").css("top", -(this.wTR.find(".e-draggableworkarea").scrollTop()) + "px");
            (this._mediaQuery && !ej.isNullOrUndefined(this._appointmentAddWindow)) && this._appointmentAddWindow.ejDialog("close");
            !ej.isNullOrUndefined(this._appointmentAddWindow) && dialogObj.option("enableAnimation", true);
            if (((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && _scrollDiv.ejScroller("isVScroll")) || this._mediaQuery) this._renderHoriVerticalScroll();
            this._showScrollTd();
        },
        _appointmentSort: function (appointments) {
            var proxy = this;
            if (this.currentView() == "agenda") {
                appointments.sort(function (a, b) {
                    var d1 = a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["startTime"]];
                    var d3 = a[proxy._appointmentSettings["endTime"]];
                    var d4 = b[proxy._appointmentSettings["endTime"]];
                    return d1.getTime() - d2.getTime() || d3.getTime() - d4.getTime();
                });
            }
            else if (this.currentView() != "day") {
                appointments.sort(function (a, b) {
                    var d1 = a[proxy._appointmentSettings["endTime"]] - a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["endTime"]] - b[proxy._appointmentSettings["startTime"]];
                    var date1 = new Date(a[proxy._appointmentSettings["startTime"]]);
                    var date2 = new Date(b[proxy._appointmentSettings["startTime"]]);
                    var date3 = new Date(a[proxy._appointmentSettings["endTime"]]);
                    var date4 = new Date(b[proxy._appointmentSettings["endTime"]]);
                    var d3 = a[proxy._appointmentSettings["startTime"]];
                    var d4 = b[proxy._appointmentSettings["startTime"]];
                    if (date1 == date2 && date3 == date4)
                        return d3 - d4 || a.Guid.localeCompare(b.Guid);
                    else if (date1 - date2 == 0)
                        return d2 - d1 || d3 - d4 || a.Guid.localeCompare(b.Guid);
                    else
                        return d3 - d4 || a.Guid.localeCompare(b.Guid);
                });
            }
            else {
                appointments.sort(function (a, b) {
                    var d3 = a[proxy._appointmentSettings["startTime"]];
                    var d4 = b[proxy._appointmentSettings["startTime"]];
                    var d1 = a[proxy._appointmentSettings["endTime"]] - a[proxy._appointmentSettings["startTime"]];
                    var d2 = b[proxy._appointmentSettings["endTime"]] - b[proxy._appointmentSettings["startTime"]];
                    return d3 - d4 || d2 - d1 || a.Guid.localeCompare(b.Guid);
                });
            }
            return appointments;
        },
        _alldaySort: function (appointments) {
            var value = [];
            for (var i = 0; i < appointments.length; i++) {
                if (((new Date(appointments[i][this._appointmentSettings["endTime"]]) - new Date(appointments[i][this._appointmentSettings["startTime"]])) / 3600000) < 24 && !appointments[i][this._appointmentSettings["allDay"]])
                    value.push(appointments[i]);
            }
            return value;
        },
        _appointmentRecurrenceSort: function (appointments) {
            var proxy = this;
            appointments.sort(function (a, b) {
                var d1 = a[proxy._appointmentSettings["startTime"]];
                var d2 = b[proxy._appointmentSettings["startTime"]];
                return d1 - d2;
            });
            return appointments;
        },

        _renderMonthAppointment: function () {
            this._overflowFlag = false;
            this.filterData = []; this._renderedApp = [];
            this.element.find(".e-appointwrapper").remove();
            !this.model.showOverflowButton && (this.initialCellHeight = this.model.cellHeight ? parseInt(this.model.cellHeight) : parseInt(this.element.find(".e-draggableworkarea").height() / this.element.find(".e-draggableworkarea tr").length));
            var renderDate = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? (this.currentView() == "month" && !this.model.showNextPrevMonth ? this.monthDays : this._dateRender) : this.monthDays;            
            var temp;
            if (this._resCustomView) {
                temp = $.extend(true, [], renderDate);
                temp.sort();
            } else {
                temp = renderDate;
            }            
            var appointments = this._currentViewAppointments = this._appointmentCount();
            var predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(temp[0])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(temp[temp.length - 1]).setHours(23, 59, 59)));
            var appointmentsList = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
            appointments = appointmentsList;
            renderDate = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this._dateRender : this.monthDays;
            if (!this.model.group || (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length == 0) this.res1 = ["0"];
            var day = 0, count = renderDate.length;
            if (new Date(renderDate[0]) < this.model.minDate) {
                day = Math.floor((new Date(this.model.minDate) - new Date(renderDate[0])) / (1000 * 60 * 60 * 24));
            }
            if (new Date(renderDate[renderDate.length - 1]) > this.model.maxDate) {
                count = renderDate.length - Math.floor((new Date(renderDate[renderDate.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
            }
            for (day; day < count; day++) {
                var predicate12 = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(renderDate[day])).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(renderDate[day]).setHours(23, 59, 59)));
                //predicate12 = !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources ? predicate["and"](this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate12;
                //predicate12 = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? predicate12["and"](this._appointmentSettings.resourceFields.toString().split(',')[0].trim(), ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]) : predicate12;
                appointments = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate12));
                var renderedAlready = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(renderDate[day]));
                appointments = new ej.DataManager(appointments).executeLocal(new ej.Query().where(renderedAlready));
                appointments = this._resourceOrderSort(appointments);
                for (var app = 0; app < appointments.length; app++) {
                    if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && !ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                        var resAvail = new ej.DataManager(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, ej.FilterOperators.equal, appointments[app][this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 2]]));
                    else var resAvail = this.res1;
                    if (resAvail.length != 0) {
                        if ((new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(renderDate[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                            var res = (this._tempResource.length == 0) ? 0 : (this._tempResource.length > 0 && this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appointments[app][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appointments[app][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], appointments[app][this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2]]);
                            this._renderAppointmentMonth(appointments[app], day, res);
                        }
                    }
                }
            }
            if (this._overflowFlag) {
                this._reRenderScroller();
                this._overflowFlag = false;
            }
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
        },

        _wireResizeEvents: function () {
            if (this.model.enableAppointmentResize && !this.model.readOnly) {
                this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle").on("mousedown", $.proxy(this._appointmentResizeStart, this));
                this._on(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
                this._on(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
            }
        },

        _unWireResizeEvents: function () {
            if (this.model.enableAppointmentResize) {
                this.element.find("div.e-lefthandle,div.e-righthandle,div.e-tophandle,div.e-bottomhandle").off("mousedown", $.proxy(this._appointmentResizeStart, this));
                this._off(this.element.find("div.e-lefthandle,div.e-righthandle"), "mouseover", $.proxy(this._colHandlesOver, this));
                this._off(this.element.find("div.e-tophandle,div.e-bottomhandle"), "mouseover", $.proxy(this._rowHandlesOver, this));
            }
        },

        _recuCollectionIndex: function (recurColl, _appList) {
            var index, model = this._appointmentSettings;
            for (var i = 0; i < recurColl.length; i++) {
                if (recurColl[i]["Guid"] == _appList["Guid"]) {
                    if (recurColl[i]["AppTaskId"] == _appList["AppTaskId"]) {
                        index = i;
                        break;
                    }
                }
            }
            return index;
        },

        _getIndex: function (day, record, dateRender, renderedApp, resValue) {
            if (this._renderedApp.length == 0) {
                record.Index = 0;
                var index = 0;
            }
            else {
                var appLevelsInDay = [];
                var proxy = this;
                var len = dateRender.length;
                var data = [];
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.resources && (this._tempResource.length > 0) && this._grouping.length > 0) {
                    var appointments = renderedApp.filter(function (obj) { return (obj[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()] == record[proxy._appointmentSettings.resourceFields.toString().split(',')[proxy._tempResource.length - 1].trim()]); });
                }
                else
                    var appointments = renderedApp;
                for (var app = 0, alen = appointments.length; app < alen; app++) {
                    if (((ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? (appointments[app][this._tempResource[this._tempResource.length - 1]["field"]] == resValue) : true) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime() >= new Date(new Date(dateRender[day]).setHours(0, 0, 0, 0)).getTime()) &&
                            (new Date(new Date(appointments[app][this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointments[app][this._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        data.push(appointments[app]);
                    }
                }
                var index = -1;
                if (data.length > 0) {
                    var appLevelsInDay = $.map(data, function (value, Index) { return [value.Index]; });
                    index = this._smallestMissingNumber(appLevelsInDay);
                }
                index = index == -1 ? 0 : index;
                record.Index = index;
            }
            return index;
        },
        _recurrenceLocal: function () {
            var recurLocale = ej.RecurrenceEditor.Locale[this.model.locale] = $.extend(true, {}, ej.RecurrenceEditor.Locale["en-US"]);
            var proxy = this;
            $.each(recurLocale, function (key, value) { ej.RecurrenceEditor.Locale[proxy.model.locale][key] = proxy._getLocalizedLabels(key); });
        },
        _minMaxIndex: function () {
            var dayIndex = $.unique(this._dateRender.map(function (time) { return new Date(time).getDay(); }));
            var minValue = Math.min.apply(Math, dayIndex);
            var maxValue = Math.max.apply(Math, dayIndex);
            return { minIndex: minValue, maxIndex: maxValue };
        },
        _renderAppointmentMonth: function (record, day, res) {
            var renderDate = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") || !this.model.timeScale.enable) ? this._dateRender : this.monthDays,
                renderCells = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? "td.e-monthcells" : "td.e-workcells",
                appointments = this._renderedApp,
                overlapCount = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? this._getIndex(day, record, renderDate, appointments, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()]) : this._getIndex(day, record, renderDate, appointments, null),
                startTime = new Date(record[this._appointmentSettings["startTime"]]),
                endTime = new Date(record[this._appointmentSettings["endTime"]]),
                appWidth, topPosition = 0,
                start = new Date(startTime),
                end = new Date(endTime),
                r_end = new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59));
            end = end > r_end ? r_end : end;
            var dateLength =(endTime - startTime) / (1000 * 60 * 60 * 24);
            var count = 0, startdate = startTime;;
            for (var i = 0; i < dateLength; i++) {
                if (this._dateRender.indexOf(new Date(startdate.setHours(0, 0, 0)).getTime()) != -1)
                    count++;
                startdate = new Date(startdate.getFullYear(), startdate.getMonth(), startdate.getDate() + 1);
            }
            this.leftPosition = 0;
            this.CellWidth = this.element.find(".e-monthcells, .e-workcells").width();
            this.CellHeight = this.element.find(".e-monthcells, .e-workcells")[0].offsetHeight ;
            !record.inline && this._renderedApp.push($.extend(true, {}, record));
            var diffInDays = count,
                noOfDays = (this.model.showWeekend) ? 7 : this._minMaxIndex().maxIndex + 1,
                maxDays = (!this.model.timeScale.enable && this._oneWeek) ? (noOfDays - renderDate.indexOf(start.getTime())) : (noOfDays - new Date(start).getDay()) + this._firstdayofweek;

            if (startTime.getTime() <= endTime.getTime()) {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    diffInDays = diffInDays >= maxDays ? maxDays : diffInDays;
                    var rowPosition = Math.ceil((day + 1) / ((this.model.showWeekend) ? noOfDays : this.model.workWeek.length));
                    appWidth = (diffInDays * this.CellWidth) - ((this.CellWidth * 5) / 100);
                }
                else {
                    appWidth = (!this.model.timeScale.enable || this.currentView() == "month" || this._isCustomMonthView()) ? (this.model.cellWidth != "") ? ((diffInDays * this.CellWidth) + diffInDays) : (diffInDays * this.CellWidth) : (this.CellWidth * diffInDays) - parseInt((this.CellWidth * 10) / 100);
                }
                var resIndex = ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) : 0;
                if (this.model.showWeekend) {
                    if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                        var cellId = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.currentView() == "day" ? resIndex + 1 : this.currentView() == "workweek" || this._isCustomMonthView() && this._oneWeek ? (resIndex * (this._dateRender.length)) + (day + 1) : this.currentView() == "workweek" ? (resIndex * (this._dateRender.length) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * this._dateRender.length)) : this._firstdayofweek == 0 ? (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) : ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._firstdayofweek != 0) ? ((resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) - this._firstdayofweek) : day + 1 : day + 1;
                    else
                        var cellId = ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._isCustomMonthView() && !this._oneWeek) ? (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) : day + 1;
                }
                else {
                    var cellId = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? ((rowPosition - 1) * (this.res1.length * this.model.workWeek.length)) + (res * this.model.workWeek.length) + (day % this.model.workWeek.length) + 1 : day + 1;
                }
                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._firstdayofweek != 0 && new Date(startTime).getDay() < this._firstdayofweek)
                    var cellId = (resIndex * (noOfDays) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * noOfDays)) - this._firstdayofweek + noOfDays;
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.model.cellWidth == "" && diffInDays > 1 && !this.model.enableRTL) {
                    var startLeft = this.element.find(".e-workcellstab tr:first").children().eq(cellId - 1).offset().left,
                        endElement = this.element.find(".e-workcellstab tr:first").children().eq(cellId - 2 + diffInDays),
                        endLeft = endElement.offset().left + endElement.width();
                    appWidth = endLeft - startLeft;
                }
                var tempAppWidth = appWidth - 1,
                    userAppTemplId = (this.model.appointmentTemplateId) ? true : false,
                    userTempHtml = (userAppTemplId) ? this._getUserAppointmentTemplate(record) : "",
                    monthHeader = (this.element.find('.e-monthheader').length != 0) ? this.element.find('.e-monthheader').height() : 0,
                    appHeight = (!this.model.appointmentTemplateId) ? (this.element.find(".e-monthappointment").length > 0 ? this.element.find(".e-monthappointment").outerHeight(true) : this._getElementHeight("e-monthappointment")) : ($(userTempHtml).css('height') == "100%" ? (!this.model.showOverflowButton ? this.initialCellHeight : (this.CellHeight - monthHeader - 15)) : $(userTempHtml).css('height') == "0px" ? (this.element.find(".e-monthappointment").length > 0 ? this.element.find(".e-monthappointment").outerHeight(true) : this._getElementHeight("e-monthappointment")) : $(userTempHtml).height());
                appWidth = (!this.model.appointmentTemplateId) ? appWidth : ($(userTempHtml).css('width') == "100%" || $(userTempHtml).css('width') == "0px" ? appWidth : $(userTempHtml).width());
                topPosition = (overlapCount * appHeight);
                this.leftPosition = 0;
                if (!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0 && !ej.isNullOrUndefined(this._diffDays)) {
                    appWidth = Math.abs(count) * this.CellWidth;
                }
                if (this._tempResource.length != 0) {
                    var newResCollection = this._resCollection;
                    var newResCollection1 = this._horiGroupCollection();
                }
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical")
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? this._findResourceIndex(newResCollection[0].dataSource, newResCollection[0].id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()], null, null) + 1 : 0;
                else
                    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1) ? this._findResourceIndex(newResCollection1, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()], null, null) + 1 : 0;
                var colorAppointment = this._appointmentColor(record),
                    resValue = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) + 1 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 2].trim()]) + 1 : 1,
                    monthCal = this.element.find(".e-monthappointment").length != 0 ? this.element.find(".e-monthappointment").outerWidth(true) - this.element.find(".e-monthappointment").width() : 0,
                    colCount = parseInt(this.CellWidth / (this.CellWidth <= appWidth ? this.CellWidth : (appWidth + monthCal))),
                    rowCount = parseInt((this.CellHeight - monthHeader - 10) / (this.element.find(".e-monthappointment").length > 0 ? this.element.find(".e-monthappointment").outerHeight(true) : appHeight));
                this.CellHeight = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") ? this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find(".e-workcells")[0].offsetHeight : this.element.find(".e-workcellstab").height() / this.element.find(".e-draggableworkarea tr").length;
                var indicationIcon = this._indicationApp(record),
                    startTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale),
                    endTimeDisp = (this._timeMode == "12") ? ej.format(record[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(record[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                if (this.model.showOverflowButton && userAppTemplId && $(userTempHtml).css('height') != "0px" && this.model.orientation != "horizontal" ? ((overlapCount + 1) <= (colCount * rowCount) || !ej.isNullOrUndefined(record["inline"])) : (this.CellHeight > monthHeader + ((overlapCount + 1) * appHeight) + 10) || !ej.isNullOrUndefined(record["inline"])) {
                    if (userAppTemplId && (appWidth < tempAppWidth))
                        this.element.find(".e-appointwrapper").eq(cellId - 1).attr('style', "height:" + (parseInt(overlapCount / colCount) + 1) * appHeight + "px !important;width:" + this.CellWidth + "px !important;position:absolute !important;");
                    if (this.model.allowInline && (!ej.isNullOrUndefined(record["inline"]))) {
                        topPosition = 0;
                        this._inlineTemplate(record, this.leftPosition, topPosition, appWidth, appHeight, colorAppointment, false);
                        var celltd = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("td.e-monthcells").eq(cellId - 1) : this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(cellId - 1);
                        (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? celltd.find(".e-monthheader").after($("<div class='e-inlinewrapper'></div>").append(this._inlineText)) : celltd.prepend($("<div class='e-inlinewrapper'></div>").append(this._inlineText));
                    }
                    else {
                        if (topPosition > 1) topPosition = (overlapCount * appHeight);
                        this.leftPosition = (this.leftPosition > 1) ? this.leftPosition - 1 : this.leftPosition;
                        var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false;
                        var timeCellhtml = $(this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, priority: this.model.prioritySettings.enable ? record[this._appointmentSettings["priority"]] : '', enablePriority: this.model.prioritySettings["template"], priorityTemplate: this.model.prioritySettings["template"] ? this._priorityTemplate(record) : record[this._appointmentSettings['priority']], uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }));
                        var celltd = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("td.e-monthcells").eq(cellId - 1) : this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(cellId - 1);
                        (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("appointment", record, timeCellhtml);
                        if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        }
                        else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal) {
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                                this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                        }
                        timeCellhtml = "";
                    }
                }
                else {
                    if ($("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).length != 0) {
                        $("#" + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (cellId - 1)).remove();
                    }
                    if (this.model.showOverflowButton) {
                        var count = cellId - 1,
                            DateString = new Date(record[this._appointmentSettings["startTime"]]).getTime(),
                            endDay = Math.round(((record[this._appointmentSettings["endTime"]] - record[this._appointmentSettings["startTime"]]) / 3600000) / 24),
                            i = count,
                            appCount = overlapCount + 1;
                        do {
                            var celltd = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("td.e-monthcells").eq(i) : this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(i);
                            var overflowhtml = '<div id="' + this._id + "_" + ej.format(new Date(record[this._appointmentSettings["startTime"]]), "MM_dd_yyyy", this.model.locale) + "_" + (resValue + groupIndex - 1) + "_" + (i) + '" class="e-icon e-arrowhead-down e-appsoverflow" data-cellinfo="' + renderDate[day] + '" data-appcount="' + appCount + '"></div>';
                            if (ej.isNullOrUndefined(record.inline) == true) {
                                celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(overflowhtml) : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml)) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            }
                            DateString = DateString + (60 * 60 * 24 * 1000);
                            i++;
                        }
                        while (i < endDay + count);
                        if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && !ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                            this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                    }
                    else {
                        if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                            topPosition = (overlapCount * appHeight);
                            var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timecellindex = this.element.find("td.e-monthcells").eq(cellId - 1).parent().index(),
                                timeCellhtml = this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }),
                                celltd = this.element.find("td.e-monthcells").eq(cellId - 1),
                                cellHeight = this.element.find("td.e-monthcells").eq(cellId - 1).parent().children().outerHeight();
                            this.CellHeight = (cellHeight > ((appHeight * (overlapCount + 1)) + monthHeader)) ? cellHeight : (cellHeight + (appHeight - 1));
                            this.element.find("td.e-monthcells").eq(cellId - 1).parent().children().css('height', this.CellHeight + "px");
                            this.element.find(".e-timecells").eq(timecellindex).css('height', this.CellHeight + "px");
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.find(".e-monthheader").after($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                        }
                        else {
                            topPosition = (overlapCount * appHeight);
                            if ((this.CellHeight - 10) < (appHeight * (overlapCount + 1))) {
                                this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find(".e-workcells").css('height', this.CellHeight + appHeight + "px");
                                this.element.find(".e-resourceheadertable tr").eq(resValue + groupIndex - 1).find(".e-childnode").css('height', this.CellHeight + appHeight + "px");
                            }
                            var recEditIcon = (!ej.isNullOrUndefined(record[this._appointmentSettings["recurrenceRule"]])) ? record[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 : false,
                                timeCellhtml = this.appTemplate.render({ id: record["AppTaskId"], appResize: this.model.enableAppointmentResize, currentview: this.currentView(), rtl: this.model.enableRTL, ignoreColorFilter: (this._browserInfo.name == "msie" && this._browserInfo.version <= 9 && !colorAppointment.appointColor.applyFilter) ? true : false, subject: record[this._appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: this.leftPosition + "px", top: topPosition, appHeight: (this.model.appointmentTemplateId ? appHeight : ''), appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-monthappointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, uid: record.Guid, recurrence: record[this._appointmentSettings["recurrence"]], recurrenceEdit: recEditIcon, leftInd: indicationIcon.leftIndication, rightInd: indicationIcon.rightIndication, resId: (!ej.isNullOrUndefined(this._appointmentSettings["resourceFields"])) ? record[this._appointmentSettings["resourceFields"].split(",")[this._appointmentSettings["resourceFields"].split(",").length - 1]] : "" }),
                                celltd = this.element.find(".e-workcellstab tr").eq(resValue + groupIndex - 1).find("td.e-workcells").eq(cellId - 1);
                            celltd.find("div.e-appointwrapper").length > 0 ? celltd.find("div.e-appointwrapper").append(timeCellhtml) : celltd.prepend($("<div class='e-appointwrapper'></div>").append(timeCellhtml));
                            if (!ej.isNullOrUndefined(this.model.group) && this._grouping.length > 1)
                                this._renderAppointmentCategory(newResCollection1, groupIndex, cellId - 1, record, appWidth, this.leftPosition);
                        }
                        this._overflowFlag = true;
                    }
                    var appsoverflow = (this.element.find('.e-appsoverflow').length > 0) ? this.element.find('.e-appsoverflow').height() : 0;
                    topPosition = this.CellHeight - ((monthHeader + appsoverflow) - 2);
                    (this.model.enableRTL) ? this.element.find(".e-icon.e-appsoverflow").css({ right: (this.CellWidth + this.leftPosition - 25) + "px", top: topPosition + "px" }) : this.element.find(".e-icon.e-appsoverflow").css({ left: (this.CellWidth + this.leftPosition - 25) + "px", top: topPosition + "px" });
                }
                delete record["Index"];
            }
            if (!record[this._appointmentSettings["recurrence"]] && !(this.model.allowInline)) {
                var templist = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, record.ParentId));
                var tempMultiApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, record.Guid));
                if ((new Date(record[this._appointmentSettings["endTime"]])) < (templist[0][this._appointmentSettings["endTime"]])) {
                    (this.model.enableRTL) ? this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + templist[0]["Guid"] + ']').children(".e-lefthandle").remove() : this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + templist[0]["Guid"] + ']').children(".e-righthandle").remove();
                }
                if ((new Date(record[this._appointmentSettings["startTime"]])) > (templist[0][this._appointmentSettings["startTime"]])) {
                    (this.model.enableRTL) ? this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + record["Guid"] + ']').children(".e-righthandle").remove() : this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + record["Guid"] + ']').children(".e-lefthandle").remove();
                }
            }
            if (!ej.isNullOrUndefined(tempMultiApp) && tempMultiApp > 1) {
                this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + record["Guid"] + ']').children(".e-lefthandle").remove();
                this.element.find(renderCells).eq(cellId - 1).find('div[data-guid=' + record["Guid"] + ']').children(".e-righthandle").remove();
            }
            if (!ej.isNullOrUndefined(indicationIcon)) {
                if (indicationIcon.leftIndication)
                    this.model.enableRTL ? this.element.find('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-left", "11px") : this.element.find('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-left", "13px");
                if (indicationIcon.rightIndication)
                    this.model.enableRTL ? this.element.find('div[data-guid=' + record.Guid + ']').find(".e-apptime,.e-apptext").css("margin-right", "13px") : this.element.find('div[data-guid=' + record.Guid + ']').find(".e-schedulemouseclose").css("margin-right", "11px");
            }
        },

        _getElementHeight: function (elementClass) {
            var el = $(document.createElement('div')).addClass(elementClass).clone(false), height;
            el.css({ visibility: 'hidden', position: 'absolute' });
            el.appendTo(this.element.find(".e-scheduleinner"));
            height = el.outerHeight(true);
            el.remove()
            return height;
        },

        _quickWindowClose: function () {
            this._quickAppointWindow.find(".e-error").remove();
            this._quickAppointWindow.ejDialog("close");
            this._scrollerPosition();
            this._processFocus();
        },

        _appointmentWindow: function (e) {
            if (this.model.allowInline) {
                if ($(e.target).hasClass("e-inlineedit")) return false;
                if (($(e.currentTarget).hasClass("e-agendacells") || $(e.currentTarget).hasClass("e-inline") || $(e.currentTarget).hasClass("e-monthcells") || $(e.currentTarget).hasClass("e-workcells") || $(e.currentTarget).hasClass("e-alldaycells")) && !ej.isNullOrUndefined(this._inlineText)) this._inlineRemove();
            }
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._quickAppointWindow.ejDialog("close");
            var startTime, endTime, _target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e);
            if (this.currentView() != "agenda" && !_target.hasClass("e-detailedapp") && (!ej.isNullOrUndefined(this.model.workCellsTemplateId) || !ej.isNullOrUndefined(this.model.allDayCellsTemplateId)))
                _target = !ej.isNullOrUndefined($(e.target).closest(".e-appointment,.e-alldayappointment,.e-monthappointment")) ? $(e.target).closest(".e-appointment,.e-alldayappointment,.e-monthappointment") : _target.closest(".e-workcells, .e-alldaycells, .e-monthcells");
            if (_target.hasClass("e-appup") || _target.hasClass("e-appdown") || _target.closest(".e-blocktimeappointment").hasClass("e-blocktimeappointment") || _target.closest(".e-categorybar").hasClass("e-categorybar")) return false;
            var customFlag = (_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells") || this._cellClick || _target.hasClass("e-detailedapp")) && !_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose") && !_target.hasClass("e-appointinnertext") && !_target.hasClass("e-apptext") && !_target.hasClass("e-apptime");
            var eventFlag = (this.model.appointmentWindowOpen != null || this.model.cellDoubleClick != null) || (!ej.isNullOrUndefined(this.model.serverEvents) && ((this.model.serverEvents.indexOf("appointmentWindowOpen") != -1) || (this.model.serverEvents.indexOf("cellDoubleClick") != -1)));
            var event = { startTime: new Date(this.cur_StartTime), endTime: this.cur_EndTime, target: e, resources: (eventFlag && customFlag && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null };
            if ((_target.hasClass("e-workcells") || _target.hasClass("e-alldaycells") || _target.hasClass("e-monthcells") || this._cellClick || _target.hasClass("e-detailedapp")) && !_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose") && !_target.hasClass("e-appointinnertext") && !_target.hasClass("e-apptext") && !_target.hasClass("e-apptime")) {
                if (!ej.isNullOrUndefined(this.model.cellDoubleClick) && this._trigger("cellDoubleClick", event)) return false;
                this._currentAction = ej.Schedule.Actions.Add;
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                    this._appointmentAddWindow.find(".e-recurEditor").css("display", "none");
                    this._appointmentAddWindow.find(".e-appwindow").css("display", "block");
                }
                var index = this._cellIndex;
                var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.dateRender : this._dateRender;
                var curDate = new Date(renderDate[index]);
                if (this.model.minDate > curDate || this.model.maxDate < curDate) return false;
                startTime = new Date(this.cur_StartTime);
                endTime = new Date(this.cur_EndTime);
                if (!ej.isNullOrUndefined(this.model.appointmentWindowOpen) || (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("appointmentWindowOpen") != -1))) {
                    if (this._trigger("appointmentWindowOpen", event)) return false;
                }
                if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                    this._appointmentAddWindow.find("#" + this._id + "subject").val(this.model.showQuickWindow ? this._quickAppointWindow.find(".subject").val() : "");
                    this._appointmentAddWindow.find("#" + this._id + "location").val(this.model.showQuickWindow ? this._quickAppointWindow.find(".location").val() : "");
                    this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", { value: ej.format(new Date(startTime), this._datepattern(), this.model.locale) });
                    this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", { value: ej.format(new Date(endTime), this._datepattern(), this.model.locale) });
                    this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(startTime), this._pattern.t, this.model.locale));
                    this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(endTime), this._pattern.t, this.model.locale));
                    this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", "value", this.model.prioritySettings.dataSource[0][this.model.prioritySettings["value"]]);
                    ($(e.currentTarget).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomMonthView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    this._timeZoneCollection(null);
                    this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                    this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");
                    this._alldayCheck();
                    if (ej.scheduleFeatures.resources && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0)
                        this._renderResourceData(_target, this._cellIndex);
                    if (!this.model.readOnly) {
                        this._appointmentAddWindow.find(".e-appsave ,#" + this._id + "donerecur").ejButton("enable", true);
                        (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                        this._appointmentAddWindow.ejDialog("open");
                    }
                    (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
                    this._cellClick = false;
                }
            } else {
                if (!_target.hasClass("e-resourceheadercells") && !_target.hasClass("e-schedulemouseclose")) {
                    if (_target.hasClass("e-monthheader") || _target.hasClass("e-appsoverflow")) return false;
                    var target = (this._editKey) ? $(e) : _target.hasClass("e-appointment") || _target.hasClass("e-monthappointment") || _target.hasClass("e-alldayappointment") || _target.hasClass("e-agendaappointment") ? _target : _target.parents('.e-monthappointment,.e-appointment,.e-alldayappointment,.e-agendaappointment');
                    this.currentView() == "agenda" && (target = target.hasClass("e-agendaappointment") ? target : this.element.find(".e-selectedCell").parent().find(".e-agendaappointment"));
                    if (target.length > 0 && !ej.isNullOrUndefined(target[0].id)) {
                        this._currentAction = ej.Schedule.Actions.Save;
                        this._appUid = target.attr("data-guid");
                        var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        if (templist[0][this._appointmentSettings["recurrence"]]) {
                            this._parentId = templist[0]["ParentId"];
                            if (this.model.showRecurrenceAlert) {
                                if (ej.isNullOrUndefined(this._recurEditWindow)) this._renderRecurEditWindow();
                                this._recurEditWindow.ejDialog("open");
                                this._recurEditWindow.focus();
                                this._deleteBeforeOpen();
                            } else {
                                this._editclick = false;
                                this._showAppointmentDetails(this._parentId, false);
                            }
                        } else
                            this._showAppointmentDetails(this._appUid, true);
                        if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
                    }
                    this._editKey = false;
                }
            }
        },

        _editRecurrence: function (args) {
            this._appointmentAddWindow.find(".e-appwindow").toggle();
            (this._mediaQuery) && this._appointmentAddWindow.parent().parent().find(".e-dialog-icon").css("display", "none");
            this._appointmentAddWindow.find(".e-recurEditor").css("margin-left", 700).toggle().animate({ "margin-left": 10 }, 300);
        },

        _showAppointmentDetails: function (appId, editOcurrence) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
            var recurEdit = !ej.isNullOrUndefined(this._appointmentAddWindow) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            this._appUid = ej.isNullOrUndefined(this._appUid) ? appId : this._appUid;
            var query = editOcurrence == true ? new ej.Query().where("Guid", ej.FilterOperators.equal, appId) : new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, appId);
            var list = editOcurrence == true ? this._processed : this._currentAppointmentData;
            var tempApp = this._sortAppById(new ej.DataManager(list).executeLocal(query));
            var templist = this._recurrenceAppSort(tempApp);
            if (!this.model.showRecurrenceAlert) {
                var tempApp1 = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                var templist1 = this._recurrenceAppSort(tempApp1);
            }
            var data = !templist[0][this._appointmentSettings["recurrence"]] ? { appointment: templist[0], edit: editOcurrence } : this.model.showRecurrenceAlert ? { appointment: templist[0], edit: editOcurrence } : { appointment: templist[0], edit: editOcurrence, editSeries: true, recurrenceCollection: { occurrences: templist1[0], parentData: templist[0] } };
            if (this._trigger("appointmentWindowOpen", data)) return false;
            if (this.model.showRecurrenceAlert)
                this._currentAction = (ej.isNullOrUndefined(this._currentAction) || this._currentAction == "") ? ej.Schedule.Actions.Save : this._currentAction;
            else
                this._currentAction = this._editclick ? this._currentAction : data.editSeries ? ej.Schedule.Actions.EditSeries : ej.Schedule.Actions.EditOccurrence;
            if (editOcurrence && this.model.showRecurrenceAlert) {
                (!ej.isNullOrUndefined(templist[0][this._appointmentSettings["recurrenceRule"]]) && templist[0][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1 && this._currentAction != ej.Schedule.Actions.EditFutureOccurrences) && (this._currentAction = ej.Schedule.Actions.Save);
            }
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) {
                var temp = (this.model.showRecurrenceAlert) ? templist[0] : (data.editSeries) ? templist[0] : templist1[0];
                this._appointmentAddWindow.find('.subject').val(temp[this._appointmentSettings["subject"]]);
                this._appointmentAddWindow.find('.location').val(temp[this._appointmentSettings["location"]]);
                this._appointmentAddWindow.find('.id').val(temp["AppTaskId"]);
                this._appointmentAddWindow.find('.e-description').val(temp[this._appointmentSettings["description"]] ? temp[this._appointmentSettings["description"]] : "");
                
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", ej.format(temp[this._appointmentSettings["startTime"]], this._datepattern(), this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", ej.format(temp[this._appointmentSettings["endTime"]], this._datepattern(), this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(temp[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(temp[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale));
                if (this.model.prioritySettings.enable) {
                    if (!ej.isNullOrUndefined(temp[this._appointmentSettings["priority"]])) {
                        this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", { value: temp[this._appointmentSettings["priority"]] });
                    } else {
                        this._appointmentAddWindow.find("#" + this._id + "priority").ejDropDownList("option", { value: this.model.prioritySettings.dataSource[0][this.model.prioritySettings.value] });
                    }
                }
                this._timeZoneCollection(temp);
                this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");
                temp[this._appointmentSettings["allDay"]] && (this._appointmentAddWindow.find(".allday ").ejCheckBox({ checked: true }));
                if (temp[this._appointmentSettings["recurrence"]]) {
                    recurEdit._recRule = temp[this._appointmentSettings["recurrenceRule"]];
                    editOcurrence = (this.model.showRecurrenceAlert) ? editOcurrence : !data.editSeries;
                    if (editOcurrence) {
                        this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true, enabled: (this._currentAction == ej.Schedule.Actions.EditFutureOccurrences) ? true : false });
                        if (this._currentAction != ej.Schedule.Actions.EditFutureOccurrences) this._appointmentAddWindow.find(".e-repeatlbl").addClass('e-disable');
                        this._appointmentAddWindow.find("." + this._id + "summary").css({ "display": (this._currentAction == ej.Schedule.Actions.EditFutureOccurrences) ? "table-row" : "none" });
                        this._appointmentAddWindow.find(".e-recurFinalRule").html("");
                        if (this._currentAction == ej.Schedule.Actions.EditFutureOccurrences) {
                            recurEdit.recurrenceRuleSplit(temp[this._appointmentSettings["recurrenceRule"]]);
                            this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: ej.format(temp[this._appointmentSettings["startTime"]], this._datepattern(), this.model.locale) });
                            this._appointmentAddWindow.find(".e-recurFinalRule").html(recurEdit.showRecurrenceSummary());
                            this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                        }
                    } else {
                        recurEdit.recurrenceRuleSplit(temp[this._appointmentSettings["recurrenceRule"]], temp[this._appointmentSettings["recurrenceExDate"]]);
                        this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: ej.format(temp[this._appointmentSettings["startTime"]], this._datepattern(), this.model.locale) });
                        this._appointmentAddWindow.find("." + this._id + "summary").css("display", "table-row");
                        this._appointmentAddWindow.find(".e-recurFinalRule").html(recurEdit.showRecurrenceSummary(appId));
                        this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: true });
                        this._appointmentAddWindow.find(".e-recuredit").css("display", "inline");
                    }
                }
                if (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(temp[this._appointmentSettings["categorize"]])) {
                    this._showCategorizeDetails(temp);
                }
                if (this._tempResource.length != 0 && ej.scheduleFeatures.resources)
                    this._showMultipleResourceDetails(temp);
                if (temp[this._appointmentSettings["allDay"]] || this.currentView() == "agenda") this._alldayCheck();
                var enableDisable = (this.model.readOnly) ? "disable" : "enable";
                this._appointmentAddWindow.find(".e-appsave,#" + this._id + "donerecur").ejButton(enableDisable, true);
                (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "block");
                this._appointmentAddWindow.ejDialog("open");
                (!this._mediaQuery) && this._appointmentAddWindow.find(".subject").focus();
            }
        },

        _recurDateChange: function (args) {
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", args);
            if (this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value") < this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value"))
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", args);
            else if (args != this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value"))
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", args);
        },

        _cancel: function () {
            this._appointmentAddWindow.ejDialog("close");
        },

        _timeChange: function (e) {
            var obj = this._appointmentAddWindow.find("#" + this._id + "starttime").data("ejTimePicker");
            if (ej.isNullOrUndefined(e.value)) {
                obj.option("value", new Date(this.cur_StartTime));
                return;
            }
            if (obj.showDropdown && obj._id == this._id + "starttime") {
                if (this._appointmentAddWindow.find('.startutc').val() != this._appointmentAddWindow.find('.endutc').val()) {
                    this._utcValue("", "starttime");
                }
                else {
                    var end = this._timeFormat(this._appointmentAddWindow.find('#' + this._id + 'endtime').ejTimePicker("option", "value")).split(":");
                    var endTime = new Date(new Date("1/1/2000").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
                    var start = this._timeFormat(this._appointmentAddWindow.find('#' + this._id + 'starttime').ejTimePicker("option", "value")).split(":");
                    var startTime = new Date(new Date("1/1/2000").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
                    var prev = this._timeFormat(e.prevTime).split(":");
                    var prevtime = new Date(new Date("1/1/2000").setHours(parseInt(prev[0], 10), parseInt(prev[1], 10)));
                    var updatetime = new Date(new Date(startTime).setHours(startTime.getHours() + endTime.getHours() - prevtime.getHours(), startTime.getMinutes() + endTime.getMinutes() - prevtime.getMinutes()));
                    this._appointmentAddWindow.find('#' + this._id + 'endtime').ejTimePicker("option", "value", updatetime);
                }
                this._startSlotChange = true;
            }
        },
        _setQuickValidation: function () {
            if (ej.isNullOrUndefined(this._quickAppointWindow)) return false;
            var form = this._id + "_AddForm";
            this._initValidator(form);
            if (!ej.isNullOrUndefined(this.model.appointmentSettings["subject"]) && !ej.isNullOrUndefined(this.model.appointmentSettings["subject"]["validationRules"])) {
                var name = this.model.appointmentSettings["subject"].field, rules = this.model.appointmentSettings["subject"]["validationRules"];
                ele = this._quickAppointWindow.find('.subject');
                !ele.attr("name") && ele.attr("name", name);
                ele.rules("add", rules);
                var validator = $("#" + this._id + "_AddForm").validate();
                if (!ej.isNullOrUndefined(rules["required"])) {
                    ej.isNullOrUndefined(validator.settings.messages[name]) ? (validator.settings.messages[name] = {}) : "";
                    validator.settings.messages[name]["required"] = (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"])) ? rules["messages"]["required"] : name + " is required.";
                }
            }
        },
        _setValidation: function () {
            var form = this._id + "_AddEditForm";
            this._initValidator(form);
            var proxy = this;
            $.each(this.model.appointmentSettings, function (key, value) {
                if (!ej.isNullOrUndefined(proxy.model.appointmentSettings[key]) && !ej.isNullOrUndefined(proxy.model.appointmentSettings[key]["validationRules"])) {
                    proxy._setValidationToField(key, proxy.model.appointmentSettings[key].field, proxy.model.appointmentSettings[key].validationRules);
                }
            });
        },
        _initValidator: function (form) {
            $("#" + form).validate({
                onfocusout: false,
                ignore: ".e-hide",
                errorClass: 'e-field-validation-error',
                errorElement: 'div',
                wrapper: "div",
                errorPlacement: function (error, element) {
                    var $td = element.closest("td"), $container = $(error).addClass("e-error"), $tail = ej.buildTag("div.e-errortail e-toparrow"), $container;
                    $td.find(".e-error").remove();
                    (element.parent().hasClass("e-in-wrap")) ? $container.insertAfter(element.closest(".e-widget")) : $container.insertAfter(element);
                    $container.prepend($tail)
                    var offsettop = (element[0]['type'] == 'checkbox' || element[0]['type'] == 'hidden') ? element.parent().offset().top + element.parent().height() : element.offset().top + element.height();
                    $container.offset({ top: offsettop });
                    $container.fadeIn("slow");
                }
            });
        },
        _setValidationToField: function (field, name, rules) {
            if (field == "startTime")
                ele = this._appointmentAddWindow.find("#" + this._id + "startdate,#" + this._id + "starttime");
            else if (field == "endTime")
                ele = this._appointmentAddWindow.find("#" + this._id + "enddate,#" + this._id + "endtime");
            else if (field == "resourceFields")
                ele = $("#" + this._id + "AppointmentAddEditWindow").find("[id^=" + this._id + "_ownerfield_" + "][type!=hidden]").find(".e-autocomplete");
            else
                ele = $("#" + this._id + "AppointmentAddEditWindow").find("[name=" + name + "][type!=hidden]");
            if (ele.length < 1) ele = $("#" + this._id + field);
            for (var i = 0; i < ele.length; i++) {
                if ($(ele[i]).hasClass("e-autocomplete")) {
                    var obj = $(ele[i]).data("ejAutocomplete");
                    ele[i] = obj.model.multiSelectMode == "visualmode" ? obj._hiddenInput : obj.element;
                }
                $(ele[i]).rules("add", rules);
                var validator = $("#" + this._id + "_AddEditForm").validate();
                if (!ej.isNullOrUndefined(rules["required"])) {
                    ej.isNullOrUndefined(validator.settings.messages[name]) ? (validator.settings.messages[name] = {}) : "";
                    validator.settings.messages[name]["required"] = (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"])) ? rules["messages"]["required"] : name + " is required.";
                }
            }
        },
        _endTimeChange: function (e) {
            var obj = this._appointmentAddWindow.find("#" + this._id + "endtime").data("ejTimePicker");
            if (ej.isNullOrUndefined(e.value)) {
                obj.option("value", new Date(this.cur_EndTime));
                return;
            }
            if (obj.showDropdown && obj._id == this._id + "endtime") {
                this._endSlotChange = true;
            }
        },

        _renderControls: function (e) {
            var control = this._appointmentAddWindow;
            control.find('.allday').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._alldayCheck, this) });
            control.find('.startenddate').ejDatePicker({ buttonText: this._getLocalizedLabels("Today"), startDay: this._firstdayofweek, enableRTL: this.model.enableRTL, width: '100%', value: this.currentDate(), locale: this.model.locale, dateFormat: this.model.dateFormat, cssClass: this.model.cssClass, minDate: this.model.minDate, maxDate: this.model.maxDate });
            control.find("#" + this._id + "starttime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._timeChange, this), cssClass: this.model.cssClass, interval: 30, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            control.find("#" + this._id + "endtime").ejTimePicker({ enableRTL: this.model.enableRTL, width: "100%", value: this.currentDate(), locale: this.model.locale, change: $.proxy(this._endTimeChange, this), cssClass: this.model.cssClass, interval: 30, timeFormat: (this._timeMode == "12") ? this._pattern.t : "HH:mm" });
            control.find("#" + this._id + "startTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._startUtc, this), cssClass: this.model.cssClass });
            control.find("#" + this._id + "endTimeZone").ejDropDownList({ enableRTL: this.model.enableRTL, dataSource: this.model.timeZoneCollection.dataSource, fields: { text: this.model.timeZoneCollection["text"], id: this.model.timeZoneCollection["id"], value: this.model.timeZoneCollection["value"] }, width: "100%", select: $.proxy(this._endUtc, this), cssClass: this.model.cssClass });
            if (this.model.prioritySettings.enable && !(this.model.prioritySettings.dataSource instanceof ej.DataManager)) this._renderPriorityItems(control);
            if (this._tempResource.length != 0 && ej.scheduleFeatures.resources) this._renderAppWindowResources(control);
            if (this.model.categorizeSettings.enable && !(this.model.categorizeSettings.dataSource instanceof ej.DataManager)) this._renderCategoryItems(control);
            control.find('.recurrence').ejCheckBox({ enableRTL: this.model.enableRTL, change: $.proxy(this._repeat, this), cssClass: this.model.cssClass });
            control.find('.e-btndone').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: (this._mediaQuery) ? "100%" : "100px", click: $.proxy(this._saveAppointment, this), cssClass: "e-flat" + this.model.cssClass });
            control.find('.cancel').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: (this._mediaQuery) ? "100%" : "100px", click: $.proxy(this._cancel, this), cssClass: "e-flat" + this.model.cssClass });
            (this._mediaQuery) && control.find('.e-btndelete').ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100%", click: $.proxy(this._mobileAppDelete, this), cssClass: "e-flat" + this.model.cssClass });
        },

        _mobileAppDelete: function () {
            if ((this._mediaQuery) && !(ej.isNullOrUndefined(this._editOnlyClicked)) && !(this._editOnlyClicked) && this._appointmentAddWindow.find(".recurrence").ejCheckBox("option", "checked")) {
                this._deleteApp(this._appUid);
            }
            else
                this._deleteAppoint();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.ejDialog("close");
        },

        _renderPriorityItems: function (control) {
            if (!ej.isNullOrUndefined(control)) {
                control.find('.priority').ejDropDownList({
                    enableRTL: this.model.enableRTL,
                    template: ej.isNullOrUndefined(this.model.prioritySettings["template"]) ? "<div class='e-" + "${" + this.model.prioritySettings["value"] + "}'></div><div>${" + this.model.prioritySettings["text"] + "}</div>" : this.model.prioritySettings["template"] + "${" + this.model.prioritySettings["text"] + "}",
                    dataSource: this.model.prioritySettings.dataSource, fields: { text: this.model.prioritySettings["text"], value: this.model.prioritySettings["value"] },
                    width: "100%",
                    cssClass: this.model.cssClass
                });
            }
        },

        _renderCategoryItems: function (control) {
            if (!ej.isNullOrUndefined(control)) {
                control.find('.e-categorizevalue').ejAutocomplete({
                    enableRTL: this.model.enableRTL,
                    showPopupButton: true,
                    width: "100%",
                    cssClass: this.model.cssClass,
                    delaySuggestionTimeout: 10,
                    multiSelectMode: (this.model.categorizeSettings.allowMultiple) ? "visualmode" : "none",
                    open: function (args) { this.suggestionList.find(".e-ul").width("auto"); },
                    focusOut: $.proxy(this._categorizeValidate, this),
                    dataSource: this.model.categorizeSettings.dataSource,
                    fields: {
                        text: this.model.categorizeSettings["text"],
                        key: this.model.categorizeSettings["id"]
                    },
                    template: this._categorizeTemplate,
                    emptyResultText: this._getLocalizedLabels("EmptyResultText")
                });
            }
        },
        _categorizeValidate: function (args) {
            if ($.isFunction($.validator) && !$("#" + this._id + "_AddEditForm").validate().form())
                return false;
        },
        _appointmentColor: function (record) {
            var appointColor = (this.model.categorizeSettings.enable && !ej.isNullOrUndefined(record[this._appointmentSettings["categorize"]]) && record[this._appointmentSettings["categorize"]] != "") ? this._getCategorizeColor(record) : ((this._tempResource.length != 0) && ej.scheduleFeatures.resources) ? this._getResourceColor(record) : { appointData: "", appointCustomcss: "", appointtextcolor: "", applyFilter: true };
            if (this.model.categorizeSettings.enable && this.model.categorizeSettings.allowMultiple && !ej.isNullOrUndefined(record[this._appointmentSettings["categorize"]])) {
                var categorizeItems = record[this._appointmentSettings["categorize"]].split(",");
                var categorizeItemsLength = categorizeItems.length;
                var value = (categorizeItemsLength > 1) ? true : false;
                var multiDiv = this._categorizeMultipleDiv(record, categorizeItems, categorizeItemsLength);
            }
            if (!ej.isNullOrUndefined(multiDiv) && appointColor.appointData.length > 0 && this.model.categorizeSettings.allowMultiple)
                return { appointColor: appointColor, value: value, multiDiv: multiDiv, applyFilter: false };
            else if (appointColor.appointData.length > 0 && !this.model.categorizeSettings.allowMultiple || (this._tempResource.length != 0) && ej.scheduleFeatures.resources)
                return { appointColor: appointColor, applyFilter: false };
            else {
                var appointData = "", appointCustomcss = "", appointtextcolor = "", value = "";
                return { appointColor: appointColor, value: value, multiDiv: multiDiv, applyFilter: true };
            }
        },

        _categorizeMultipleDiv: function (record, categorizeItems, categorizeItemsLength) {
            var renderData = [];
            for (var i = 0; i <= categorizeItemsLength - 1; i++) {
                if (i != categorizeItemsLength - 1) {
                    var dataSet = this.model.categorizeSettings;
                    var categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], categorizeItems[i], null, null);
                    (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], parseInt(categorizeItems[i]), null, null));
                    if (ej.isNullOrUndefined(categorizeDataIndex)) {
                        record[this._appointmentSettings["categorize"]] = "";
                        return null;
                    }
                    else
                        renderData.push({ text: dataSet.dataSource[categorizeDataIndex][dataSet.text], value: dataSet.dataSource[categorizeDataIndex][dataSet.color], key: dataSet.dataSource[categorizeDataIndex][dataSet.id], fontColor: dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] })
                }
            }
            var template = this._categorizeMultipleTemplate.render({ renderData: renderData });
            return template;
        },

        _getResCategorySaveData: function (categorizeVal, autoVal, obj, maxId, parId, starttime, endtime) {
            var args = [], newAppointment, data, prevdata, tempSource = [];
            newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
            if (categorizeVal.length > 0 && !ej.isNullOrUndefined(categorizeVal[0][0])) {
                var categorizeItemsLength = categorizeVal[categorizeVal.length - 1].length - 1; var idValue = "";
                for (var i = 0; i <= categorizeItemsLength; i++) {
                    var getId = categorizeVal[categorizeVal.length - 1][i][this.model.categorizeSettings["id"]];
                    idValue = (i != categorizeItemsLength) ? idValue + getId.toString() + "," : idValue + getId.toString();
                }
                newAppointment[this._appointmentSettings["categorize"]] = idValue;
            }
            if (autoVal.length > 0) {
                var categorizeVar = newAppointment[this._appointmentSettings["categorize"]];
                var resources = this._appointmentSettings.resourceFields.toString().split(',');
                if (this._grouping.length != 0) {
                    if (resources.length != this._grouping.length) {
                        for (var i = 0; i < this._grouping.length; i++) {
                            tempSource.push(resources[i]);
                        }
                        resources = tempSource;
                    }
                }
                var newResCollection = this._getResourceCollection();
                if (autoVal[autoVal.length - 1].length > 0) {
                    for (var j = 0; j < autoVal[autoVal.length - 1].length; j++) {
                        newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                        if (categorizeVal.length > 0)
                            newAppointment[this._appointmentSettings["categorize"]] = categorizeVar;

                        if (autoVal[autoVal.length - 1].length > 1) {
                            obj.Guid = this._guidFormatGenerate();
                            maxId++;
                            var templist = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, maxId));
                            maxId = (templist.length == 0) ? maxId : this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"] + 1;
                            obj[this._appointmentSettings["id"]] = parId = maxId;
                            if (this._currentAction == ej.Schedule.Actions.EditSeries) obj[this._appointmentSettings["recurrenceId"]] = maxId;
                        }
                        newAppointment[resources[resources.length - 1].trim()] = autoVal[resources.length - 1][j][newResCollection[newResCollection.length - 1]["id"]];

                        var id = autoVal[resources.length - 1][j][newResCollection[newResCollection.length - 1]["id"]];
                        for (var i = resources.length - 1; i > 0; i--) {
                            data = this.render_Resources[i] instanceof ej.DataManager ? this.render_Resources[i] : ej.DataManager(this.render_Resources[i]);
                            query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, id);
                            appointId = data.executeLocal(query);
                            prevdata = this.render_Resources[i - 1] instanceof ej.DataManager ? this.render_Resources[i - 1] : ej.DataManager(this.render_Resources[i - 1]);
                            query1 = new ej.Query().where(newResCollection[i - 1].id, ej.FilterOperators.equal, appointId[0][newResCollection[i].groupId]);
                            appointGroupId = prevdata.executeLocal(query1);
                            id = appointGroupId[0][newResCollection[i - 1].id];
                            grpId = appointGroupId[0][this._tempResource[i - 1].resourceSettings["groupId"]];
                            newAppointment[resources[i - 1]] = id;
                        }
                        if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                        args.push(newAppointment);
                    }
                }
                else {
                    var resources = this._appointmentSettings.resourceFields.toString().split(',');
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    if (categorizeVal.length > 0)
                        newAppointment[this._appointmentSettings["categorize"]] = categorizeVar;
                    if (resources.length > 1) {
                        for (var i = 0; i < resources.length; i++) {
                            newAppointment[resources[i].trim()] = this._tempResource[i].resourceSettings.dataSource[0].id
                        }
                    }
                    else
                        newAppointment[resources[resources.length - 1].trim()] = this._tempResource[0].resourceSettings.dataSource[0].id;
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                }
            }

            if (autoVal.length == 0 && categorizeVal.length > 0) {
                if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                args.push(newAppointment);
            }
            return args;
        },

        _timeZoneCollection: function (temp) {
            if (!ej.isNullOrUndefined(temp)) {
                this.startTimeAppoint = temp[this._appointmentSettings["startTimeZone"]];
                this.endTimeAppoint = temp[this._appointmentSettings["endTimeZone"]];
            }
            this.startutcValue = this.tempValue = null;
            if (!ej.isNullOrUndefined(temp) && this.endTimeAppoint) {
                this._utcValue(temp, "Appoint");
                this.tempValue = 1;
            }
            var rawTimezone = (this.model.timeZone == null) ? this._timezoneStringValue() : this.model.timeZone;
            var value1 = !ej.isNullOrUndefined(temp) ? ej.isNullOrUndefined(this.startTimeAppoint) ? rawTimezone : this.startTimeAppoint : rawTimezone;
            var addUTC = (value1.indexOf("UTC") != 0) ? "UTC " + value1 : value1;
            var zeroValue = (addUTC.split(" ")[1].split(":")[0].length != 3) ? ((addUTC.split(" ")[1].split(":")[0][0] == "+") ? "+0" + addUTC.split(" ")[1].split(":")[0].split("+")[1] + ":" + addUTC.split(" ")[1].split(":")[1] : "-0" + addUTC.split(" ")[1].split(":")[0].split("-")[1] + ":" + addUTC.split(" ")[1].split(":")[1]) : addUTC;
            var timeZoneValue = (zeroValue.indexOf("UTC") != 0) ? "UTC " + zeroValue : zeroValue;
            var value = !ej.isNullOrUndefined(this._findResourceIndex(this.model.timeZoneCollection.dataSource, this.model.timeZoneCollection["value"], timeZoneValue, null, null)) ? this._findResourceIndex(this.model.timeZoneCollection.dataSource, this.model.timeZoneCollection["value"], timeZoneValue, null, null) : "add";
            if (!ej.isNullOrUndefined(temp) && value !== "add") {
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("option", { value: (!ej.isNullOrUndefined(temp) && !ej.isNullOrUndefined(this.startTimeAppoint)) ? this.startTimeAppoint : this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { value: (!ej.isNullOrUndefined(temp) && !ej.isNullOrUndefined(this.endTimeAppoint)) ? this.endTimeAppoint : this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
            }
            else if (value !== "add") {
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList("option", { text: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["text"]], value: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList("option", { text: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["text"]], value: this.model.timeZoneCollection.dataSource[value][this.model.timeZoneCollection["value"]] });
            }
            if (value == "add") {
                var addDataSoure = {};
                addDataSoure[this.model.timeZoneCollection["text"]] = timeZoneValue;
                addDataSoure[this.model.timeZoneCollection["id"]] = (this.model.timeZoneCollection.dataSource.length + 1).toString();
                addDataSoure[this.model.timeZoneCollection["value"]] = timeZoneValue;
                this.model.timeZoneCollection.dataSource.push(addDataSoure);
                this._appointmentAddWindow.find("#" + this._id + "startTimeZone").ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                this._appointmentAddWindow.find("#" + this._id + "endTimeZone").ejDropDownList({ dataSource: this.model.timeZoneCollection.dataSource });
                temp != null ? this._timeZoneCollection(temp) : this._timeZoneCollection(null);
            }
            this.tempValue = null;
        },

        _timezoneStringValue: function () {
            var isDST = new Date().getTimezoneOffset() < Math.max(new Date(new Date().getFullYear(), 0, 1).getTimezoneOffset(), new Date(new Date().getFullYear(), 6, 1).getTimezoneOffset());
            var offsetValue = new Date().getTimezoneOffset() + ((isDST) ? (new Date(new Date().getFullYear(), 0, 1).getTimezoneOffset() - new Date(new Date().getFullYear(), 6, 1).getTimezoneOffset()) : 0);
            var signValue = (offsetValue > 0) ? "-" : "+";
            var offset = Math.abs(offsetValue);
            var offsetHour = ((Math.floor(offset / 60)) < 10) ? '0' + (Math.floor(offset / 60)) : (Math.floor(offset / 60));
            var offsetMinute = ((offset % 60) < 10) ? '0' + (offset % 60) : (offset % 60);
            return signValue + offsetHour + ":" + offsetMinute;
        },

        _showCategorizeDetails: function (temp) {
            var categorizeItems = temp[this._appointmentSettings["categorize"]].split(",");
            var key;
            for (var i = 0; i < categorizeItems.length; i++) {
                key = $.type(categorizeItems[i]) == 'string' ? categorizeItems[i] : parseInt(categorizeItems[i]);
                this._appointmentAddWindow.find('.e-categorizevalue').data("ejAutocomplete").selectValueByKey(key);
            }
        },

        _renderCategorizeTemplate: function () {
            var Text = this.model.enableRTL ? 'margin-right:30px;margin-top:-18px' : '';
            var Color = this.model.enableRTL ? 'float:none' : 'float:left';
            if (!ej.isNullOrUndefined(this.model.categorizeSettings)) {
                this._categorizeTemplate = "<div class='e-categorizeTemplate' style='height:15px;margin-right:5px;margin-top:3px;" + Color + ";width:15px;background-color: ${" + this.model.categorizeSettings["color"] + "}'></div><div style= " + Text + ">${" + this.model.categorizeSettings["text"] + "}</div>";
            }
        },

        _getCategorizeColor: function (record) {
            var categorizeDataIndex = null, appointData = "", appointCustomcss = "", appointtextcolor = "", applyFilter = false;
            var categorizeItems = record[this._appointmentSettings["categorize"]].split(",");
            var categorizeItemsLength = categorizeItems.length - 1;
            var dataSet = this.model.categorizeSettings;
            categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], categorizeItems[categorizeItemsLength], null, null);
            (ej.isNullOrUndefined(categorizeDataIndex)) && (categorizeDataIndex = this._findResourceIndex(dataSet.dataSource, this.model.categorizeSettings["id"], parseInt(categorizeItems[categorizeItemsLength]), null, null));
            if (ej.isNullOrUndefined(categorizeDataIndex)) {
                record[this._appointmentSettings["categorize"]] = "";
                return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor };
            }
            else {
                appointData = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.color]) ? dataSet.dataSource[categorizeDataIndex][dataSet.color] : appointData;
                appointtextcolor = !ej.isNullOrUndefined(dataSet.dataSource[categorizeDataIndex][dataSet.fontColor]) ? dataSet.dataSource[categorizeDataIndex][dataSet.fontColor] : appointtextcolor;
            }
			/* below if-else is used for the following case "Resource color is not applying on appointments, even when no color value is mentioned for category option" (JS-52238)*/
            if((this._tempResource.length != 0) && ej.scheduleFeatures.resources && appointData=="")
			   return this._getResourceColor(record);
			else
			   return { appointData: appointData, appointCustomcss: appointCustomcss, appointtextcolor: appointtextcolor, applyFilter: applyFilter }
        },

        _currentDateFormat: function (option) {
            var minDate, maxDate;
            if (!ej.isNullOrUndefined(option) && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
                var date = ej.parseDate(this.currentDate(), this.model.dateFormat);
                minDate = ej.parseDate(this.model.minDate, this.model.dateFormat);
                maxDate = ej.parseDate(this.model.maxDate, this.model.dateFormat);
                this.currentDate((!ej.isNullOrUndefined(date)) ? date : ((new Date(this.currentDate()).toString() == "Invalid Date" || new Date(this.currentDate()).toString() == "NaN") ? this._dateConvert(this.currentDate()) : new Date(this.currentDate())));
                this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : ((new Date(this.model.minDate).toString() == "Invalid Date" || new Date(this.model.minDate).toString() == "NaN") ? this._dateConvert(this.model.minDate) : new Date(this.model.minDate));
                this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : ((new Date(this.model.maxDate).toString() == "Invalid Date" || new Date(this.model.maxDate).toString() == "NaN") ? this._dateConvert(this.model.maxDate) : new Date(this.model.maxDate));
            }
            else if (option == "MM/dd/yyyy" && ($.type(this.currentDate()) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
                var curntDate = ej.parseDate(this.currentDate());
                minDate = ej.parseDate(this.model.minDate);
                maxDate = ej.parseDate(this.model.maxDate);
                (!ej.isNullOrUndefined(curntDate)) ? this.currentDate(curntDate) : this.currentDate(new Date());
                this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
                this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
            }
        },

        _datepattern: function () {
            return (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) ? this.model.dateFormat : this._pattern.d;
        },

        _businessHourScroller: function () {
            if (this.currentView() == "agenda") return false;
            var highScrol = 0;
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.timeScale.enable && this.currentView() != "month" && !this._isCustomMonthView()) {
                highScrol = (this.element.find(".e-businesshighlightworkcells").length != 0 && this.model.workHours.highlight) ? this.element.find(".e-businesshighlightworkcells").first().parent().index() * (this.element.find(".e-workcells")[0].offsetHeight - 1) : 0;
                this.element.find("div#" + this._id + "_scroller").ejScroller({ scrollTop: highScrol });
                this.element.find(".e-scrolltimecells").css({ top: -(this.element.find(".e-draggableworkarea").scrollTop()) + "px" });
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.model.timeScale.enable) {
                if (this.element.find(".e-businesshighlightworkcells").length != 0 && this.model.workHours.highlight && this.currentView() != "month") {
                    highScrol = this.element.find(".e-businesshighlightworkcells")[0].offsetLeft;
                    if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
                        var currentDateIndex = this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index();
                        if (!ej.isNullOrUndefined(currentDateIndex) && currentDateIndex >= 0) {
                            this.currentView() == "customview" ? this.currentDate(new Date(this._dateRender[0])) : this.currentDate(new Date(this._dateRender[currentDateIndex]));
                            highScrol = this.element.find(".e-workcells")[Math.ceil(currentDateIndex * ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))].offsetLeft;
                            var hourDiff = (this.model.workHours.start - this.model.startHour) <= 0 ? 1 : this.model.workHours.start - this.model.startHour;
                            if ([0, 6].indexOf(new Date(this._dateRender[currentDateIndex]).getDay()) == -1 && this.currentView() != "customview") {
                                if (this.model.enableRTL)
                                    highScrol -= (hourDiff * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) * this.element.find(".e-workcells").width());
                                else
                                    highScrol += (hourDiff * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) * this.element.find(".e-workcells").width()) - this.element.find(".e-workcells").width();
                            }
                        }
                    }
                }
                else
                    highScrol = (this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index() != -1) ? this.element.find(".e-workcells")[(this.element.find(".e-activeview.e-horizontalheaderdiv").parent().index()) * ((this.model.endHour - this.model.startHour) * Math.ceil(this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))].offsetLeft : 0;
                var leftValue = (this.model.enableRTL) ? this.element.find(".e-workcells")[0].offsetLeft - highScrol : highScrol;
                this.element.find("div#" + this._id + "_scroller").ejScroller({ scrollLeft: leftValue });
            }
        },

        _minToHour: function (mins) {
            return { "h": parseInt(mins / 60), "m": mins % 60 };
        },

        _onclose: function (args) {
            this._appointmentAddWindow.find(".e-error").remove();
            this._appointmentAddWindow.find(".e-recurEditor").hide();
            this._appointmentAddWindow.find(".e-appwindow").css("margin-left", 700).show().animate({ "margin-left": 10 }, 300);
            this._clearFields();
            this._processFocus();
        },

        _printAppointment: function (appointment) {
            var $element = ej.buildTag("div"), templist;
            if (typeof appointment === 'object')
                templist = appointment;
            else {
                var query = new ej.Query().where("Guid", ej.FilterOperators.equal, appointment);
                list = new ej.DataManager(this._processed).executeLocal(query);
                if (list.length > 1) {
                    var applist = $.extend(true, [], list);
                    applist[0][this._appointmentSettings["endTime"]] = applist[applist.length - 1][this._appointmentSettings["endTime"]];
                    templist = applist[0];
                } else templist = list[0];
            }
            var appointmentTable = "<table align='center' style='margin-top:50px;margin-left:50;'>";
            var proxy = this;
            var exclude = ["Guid", "ParentId", "RecurrenceId", "RecurrenceExDate", "AppTaskId"];
            $.each(templist, function (i, val) {
                if ((exclude.indexOf(i) == -1) && !ej.isNullOrUndefined(val) && !ej.isNullOrUndefined(i) && i != "null") {
                    if (i == proxy._appointmentSettings.startTime || i == proxy._appointmentSettings.endTime)
                        val = val;
                    appointmentTable += "<tr style='height:30px'><td style='width:300px'><b>" + i + ":</b></td><td  style='width:600px'>" + val + "</td></tr>";
                }
            });
            appointmentTable += "</table>";
            var ownerTextName = "";
            if ((this._tempResource.length != 0)) {
                if (!ej.isNullOrUndefined(templist[this._tempResource[this._tempResource.length - 1].field])) {
                    var s = proxy._appointmentSettings.resourceFields.split(',');
                    $.each(this._tempResource[this._tempResource.length - 1].resourceSettings.dataSource, function (i, val) {
                        if (val.id == templist[s[s.length - 1].trim()])
                            ownerTextName = val.text;
                    });
                }
            }
            ownerTextName = (ownerTextName == "") ? "Unknown" : ownerTextName;
            var appointmentWindowData = "<font size='20' style='margin-top:50px;margin-left:50;font-family:Times New Roman'><b>" + ownerTextName + "</b></font></br><hr style='margin-left:50' size='10'>"
            var printElement = appointmentWindowData + appointmentTable;
            $element.append(printElement);
            ej.print($element);
            return false;
        },

        _recurrenceValidate: function (rule, recurId, sTime, eTime) {
            var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
            (!ej.isNullOrUndefined(rule)) && recurEdit.recurrenceRuleSplit(rule, recurId);
            var appEnd, appStart, recurEndDate;
            if (!ej.isNullOrUndefined(eTime))
                appEnd = eTime;
            else {
                var end = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value")).split(':');
                appEnd = new Date(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
            }
            if (!ej.isNullOrUndefined(sTime))
                appStart = sTime;
            else {
                var start = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value")).split(':');
                appStart = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
            }
            var day_start = !ej.isNullOrUndefined(sTime) ? sTime : this._appointmentAddWindow.find(".recurstartdate").ejDatePicker("option", "value");
            var _interval = recurEdit._rRule.interval;
            if (!ej.isNullOrUndefined(recurEdit._rRule.until)) {
                recurEndDate = new Date(recurEdit._rRule.until);
                recurEndDate.setDate(recurEndDate.getDate() + 1);
            } else if (!ej.isNullOrUndefined(recurEdit._rRule.count))
                switch (recurEdit._rRule.freq) {
                    case "DAILY":
                        recurEndDate = new Date(new Date(day_start).setDate(day_start.getDate() + recurEdit._rRule.count * (_interval)));
                        break;
                    case "WEEKLY":
                        var byDay = recurEdit._rRule.weekDays.split(",");
                        var dayCount = day_start.getDate() + (((recurEdit._rRule.count / byDay.length) * 7)) * (_interval);
                        recurEndDate = new Date(new Date(day_start).setDate(Math.round(dayCount) < dayCount ? dayCount + 1 : dayCount));
                        break;
                    case "MONTHLY":
                        recurEndDate = new Date(new Date(day_start).setMonth(day_start.getMonth() + recurEdit._rRule.count * (_interval)));
                        break;
                    case "YEARLY":
                        recurEndDate = new Date(new Date(day_start).setFullYear(day_start.getFullYear() + recurEdit._rRule.count * (_interval)));
                        break;
                }
            else {
                recurEndDate = new Date(new Date(this.currentDate()).setDate(day_start.getDate() + 42 * (_interval)));
            }
            if (((recurEndDate - day_start) / (1000 * 3600) / 24) < ((recurEdit._rRule.freq == "DAILY") ? 2 : (recurEdit._rRule.freq == "WEEKLY") ? 7 : 1)) {
                return true;
            } else {
                switch (recurEdit._rRule.freq) {
                    case "DAILY":
                        var count = recurEdit._rRule.interval;
                        return ((appEnd - appStart) / (1000 * 3600) > parseInt(count) * 24) ? false : true;
                        break;
                    case "WEEKLY":
                        if (rule.split(";")[1].split("=")[0] == "INTERVAL") {
                            var types = recurEdit._rRule.weekDays.split(",");
                            var obj = { "SU": 0, "MO": 1, "TU": 2, "WE": 3, "TH": 4, "FR": 5, "SA": 6 };
                            var temp = [], tempDiff = [];
                            for (var i = 0; i < types.length * (parseInt(recurEdit._rRule.interval) + 1) ; i++) {
                                temp[i] = (types.length > i) ? obj[types[i]] : temp[i - types.length] + (7 * parseInt(recurEdit._rRule.interval));
                            }
                            var tempvalue = temp.sort(function (a, b) { return a - b });
                            for (var i = 1; i < tempvalue.length; i++) {
                                tempDiff.push(tempvalue[i] - tempvalue[i - 1]);
                            }
                            return ((appEnd - appStart) / (1000 * 3600) > Math.min.apply(Math, tempDiff) * 24) ? false : true;
                        } else {
                            return ((appEnd - appStart) / (1000 * 3600) > 24) ? false : true;
                        }
                        break;
                    case "MONTHLY":
                        if (appEnd.getTime() > new Date(appStart).setMonth(appStart.getMonth() + parseInt(recurEdit._rRule.interval)))
                            return false;
                        else
                            return true;
                        break;
                    case "YEARLY":
                        if (appEnd.getTime() > new Date(appStart).setFullYear(appStart.getFullYear() + parseInt(recurEdit._rRule.interval)))
                            return false;
                        else
                            return true;
                        break;
                }
            }
            return true;
        },

        _saveAppointment: function () {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            var recurEdit = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
            if (this._currentAction != "") {
                if (ej.isNullOrUndefined(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value")) || ej.isNullOrUndefined(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value")))
                    return false;
                var start = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value")).split(":");
                var end = this._timeFormat(this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value")).split(":");
                var startTime = new Date(this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value").setHours(parseInt(start[0], 10), parseInt(start[1], 10)));
                var endTime = new Date(this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value").setHours(parseInt(end[0], 10), parseInt(end[1], 10)));
                if (startTime > endTime) {
                    ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
                    this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                    this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("StartEndError"));
                    this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                    this._alertWindow.ejDialog("open");
                    return false;
                }
            }
            if (this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox("option", "checked") && recurEdit._recRule != "" && !ej.isNullOrUndefined(recurEdit._recRule) && this.model.enableRecurrenceValidation && this._currentAction == "add") {
                if (!this._recurrenceValidate(recurEdit._recRule)) {
                    this._alertCreateError();
                    return false;
                }
            }
            var appointments = this._sortAppById(this._processed), maxId, query, query1, appointId, appointGroupId, _editApp;
            if (this._cellClick && (this.model.showQuickWindow || this.model.allowInline)) {
                if ($.isFunction($.validator) && !$("#" + this._id + "_AddForm").validate().form()) return false;
                var argsValue, obj = {};
                var maxId = !ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : 1;
                if (this.model.enableLoadOnDemand) maxId = this._dataCount;
                obj[this._appointmentSettings["id"]] = obj["AppTaskId"] = obj["ParentId"] = maxId;
                obj[this._appointmentSettings["subject"]] = (this.model.allowInline && this._inline) ? (this.element.find(".e-inlinetext").length > 1 && this.currentView() != "month") ? $(this.element.find(".e-inlinetext")[1]).val() : this.element.find(".e-inlinetext").val() : this._quickAppointWindow.find('.subject').val();
                obj[this._appointmentSettings["startTime"]] = new Date(this.cur_StartTime);
                obj[this._appointmentSettings["endTime"]] = new Date(this.cur_EndTime);
                if (this.currentView() === "month" || (new Date(this.cur_StartTime).getHours() == 0 && new Date(this.cur_EndTime).getHours() == 23 && new Date(this.cur_EndTime).getMinutes() == 59) || (this._isCustomMonthView()))
                    obj[this._appointmentSettings["allDay"]] = true;
                else
                    obj[this._appointmentSettings["allDay"]] = false;
                if (this.model.appointmentSettings.applyTimeOffset && !obj[this._appointmentSettings["allDay"]]) {
                    obj[this._appointmentSettings["startTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                    obj[this._appointmentSettings["endTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                }
                obj[this._appointmentSettings["recurrence"]] = false;
                if ((!ej.isNullOrUndefined(this.model.group) || (this._tempResource.length != 0) && ej.scheduleFeatures.resources) && ((this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0))
                    obj = this._getResourceFields(obj);
                ("null" in obj) && delete obj[null];
                var avail = this._checkAvailability(obj);
                var args = { appointment: obj };
                if (this._trigger("actionBegin", { data: args.appointment, requestType: "appointmentSave" }) || avail.length > 0) {
                    this._showBlockAlert && avail.length > 0 && this._alertBlockError();
                    if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                    return false;
                }
                if (this._trigger("beforeAppointmentCreate", args)) {
                    if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                    return false;
                }
                this._currentAction == ej.Schedule.Actions.Add;
                args.appointment.Guid = this._guidFormatGenerate();
                $.extend(true, argsValue = {}, args.appointment);
                var temp = this._timeZoneAppointments(argsValue, "");
                var promise = this._dataManager.insert(temp, this.model.appointmentSettings.query._fromTable);
                if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args.appointment);
                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", args.appointment);
                this._appointmentProcessing(args.appointment);
                this._currentViewAppointments = this._appointmentCount();
                var renderCollection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == args.appointment.Guid; });
                for (var rx = 0; rx < renderCollection.length; rx++) {
                    this._refreshDayAppointments(renderCollection[rx]);
                }
                this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                this._trigger("appointmentCreated", { appointment: args.appointment, requestType: "appointmentSaved" });
                this._trigger("actionComplete", { data: args.appointment, requestType: "appointmentSave" });
                this._cellClick = false;
                if (!ej.isNullOrUndefined(this._quickAppointWindow)) this._quickAppointWindow.ejDialog("close");
                this._scrollerPosition();
                if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                    var proxy = this;
                    promise.done(function (e) {
                        var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                        if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                            proxy._processUrlBinding(e);
                        }
                        else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                            if (value.added.length > 0) {
                                proxy._dateFormat(value.added);
                                for (var a = 0, len = value.added.length; a < len; a++) {
                                    args.appointment[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                    if (!args.appointment[proxy._appointmentSettings["recurrence"]]) args.appointment.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    new ej.DataManager(proxy._processed).update("Guid", args.appointment);
                                }
                            }
                        }
                    });
                }
            }
            else {
                var autoVal = [], categorizeVal = [];
                if (ej.isNullOrUndefined(this._inline) || (this._inline == false)) {
                    if ($.isFunction($.validator) && !$("#" + this._id + "_AddEditForm").validate().form()) return false;
                    var formelement, obj = {}, temp = {};
                    var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    maxId = (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOccurrence || this._currentAction == ej.Schedule.Actions.EditFutureOccurrences) ? (this.model.enableLoadOnDemand ? this._dataCount + 1 : (!ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : parseInt(this._appId))) : tempApp[0]["AppTaskId"];
                    formelement = $("#" + this._id + "AppointmentAddEditWindow").find("#" + this._id + "_AddEditForm").get(0);
                    for (var index = 0; index < formelement.length; index++) {
                        var columnName = formelement[index].name, $element = $(formelement[index]);
                        if (columnName != undefined) {
                            var value = formelement[index].value;
                            if ((columnName != "" && obj[columnName] == null)) {
                                if (columnName == this._appointmentSettings["id"])
                                    value = (value == "") ? parseInt(maxId) : parseInt(value);
                                if ($(formelement[index]).hasClass("e-datepicker"))
                                    value = $element.ejDatePicker("option", "value");
                                else if ($(formelement[index]).hasClass("e-timepicker"))
                                    value = $element.ejTimePicker("option", "value");
                                else if ($element.data("ejDropDownList"))
                                    value = $element.ejDropDownList("model.value");
                                else if ($element.data("ejAutocomplete")) {
                                    if ($(formelement[index])[0].id == this._id + "categorize")
                                        categorizeVal.push($element.data("ejAutocomplete").getSelectedItems());
                                    else if ($(formelement[index])[0].id.indexOf(this._id + "_ownerfield_") == 0)
                                        autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                                }
                                if (columnName != "StartDate" && columnName != "EndDate" && columnName != "StartTime" && columnName != "EndTime") {
                                    if (formelement[index].type != "checkbox")
                                        obj[columnName] = value;
                                    else
                                        obj[columnName] = $(formelement[index]).is(':checked');
                                }
                                else {
                                    temp[columnName] = columnName == "StartDate" || columnName == "EndDate" ? new Date(value) : value;
                                }
                            }
                            else {
                                if ($element.data("ejAutocomplete")) {
                                    if ($(formelement[index])[0].id == this._id + "categorize")
                                        categorizeVal.push($element.data("ejAutocomplete").getSelectedItems());
                                    else if ($(formelement[index])[0].id.indexOf(this._id + "_ownerfield_") == 0)
                                        autoVal.push($element.data("ejAutocomplete").getSelectedItems());
                                }
                            }
                        }
                    }
                    this.startutcValue = this.tempValue = null;
                    if (!this.model.showTimeZoneFields) {
                        obj[this._appointmentSettings["startTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                        obj[this._appointmentSettings["endTimeZone"]] = this.model.timeZone == null ? ("UTC " + this._timezoneStringValue()) : this.model.timeZone;
                    }
                    ("null" in obj) && delete obj[null];
                    var starttime = this._timeFormat(temp.StartTime).split(":");
                    var endtime = this._timeFormat(temp.EndTime).split(":");
                    obj[this._appointmentSettings["startTime"]] = new Date(temp.StartDate.setHours(parseInt(starttime[0], 10), parseInt(starttime[1], 10)));
                    obj[this._appointmentSettings["endTime"]] = new Date(temp.EndDate.setHours(parseInt(endtime[0], 10), parseInt(endtime[1], 10)));
                    (obj[this._appointmentSettings["recurrence"]]) && (obj[this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule);
                    this._publicMethodSave = true;
                    var value = this._timeZoneSavingAppoint(obj, temp);
                    obj = value.obj;
                    var currentAction = this._currentAction == "save" ? "edit" : this._currentAction;
                }
                else {
                    var obj = {}, res = [], resIdCollection = [], cRes;
                    var inlineEdit = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                    inlineEdit[0][this._appointmentSettings["endTime"]] = (inlineEdit.length > 1) ? inlineEdit[inlineEdit.length - 1][this._appointmentSettings["endTime"]] : inlineEdit[0][this._appointmentSettings["endTime"]];
                    obj = inlineEdit[0];
                    if (this._tempResource.length > 0) {
                        resIdCollection = $.extend(true, [], this._resourceCollection);
                        resIdCollection.reverse();
                        for (var i = 0; i < this.res1.length; i++) {
                            if (this._grouping.length == 1) {
                                if (this.res1[i][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] == obj[this._tempResource[this._tempResource.length - 1]["field"]])
                                    break;
                            }
                            else {
                                if (this.res1[i][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]] == obj[this._tempResource[this._tempResource.length - 1]["field"]] && this.res1[i][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]] == obj[this._tempResource[this._tempResource.length - 2]["field"]])
                                    break;
                            }
                        }
                        res.push(this.res1[i]);
                        autoVal.push(res);
                        var nextRes, count, resAvail, cRes, b = 0, rCollection = [];
                        if (this._tempResource.length > 1) {
                            count = 1;
                            for (var a = this._tempResource.length - 2; a >= 0; a--) {
                                cRes = this._tempResource[a].resourceSettings.dataSource;
                                nextRes = new ej.DataManager(cRes).executeLocal(new ej.Query().where(this._tempResource[count].resourceSettings.id, ej.FilterOperators.equal, autoVal[b][0][this._tempResource[a + 1].resourceSettings["groupId"]]));
                                autoVal.push(nextRes);
                                count++;
                                b++;
                                count = (count == this._tempResource.length) ? count - 1 : count;
                            }
                            autoVal.reverse();
                        }
                    }
                    maxId = obj["AppTaskId"];
                    var starttime = this._timeFormat(ej.format(new Date(obj[this._appointmentSettings["startTime"]]), this._pattern.t, this.model.locale)).split(":");
                    var endtime = this._timeFormat(ej.format(new Date(obj[this._appointmentSettings["endTime"]]), this._pattern.t, this.model.locale)).split(":");
                    var currentAction = this._currentAction = (obj[this._appointmentSettings["recurrence"]] == true) ? "editOccurrence" : "save";
                    var subject = this.element.find(".e-inlineedit").val();
                    (obj[this._appointmentSettings["recurrence"]] === true)
                    if ($.trim(this._subject) == subject) {
                        this._inlineRemove();
                        return false;
                    }

                    obj[this._appointmentSettings["subject"]] = subject;
                    obj[this._appointmentSettings["startTimeZone"]] = !ej.isNullOrUndefined(obj[this._appointmentSettings["startTimeZone"]]) ? obj[this._appointmentSettings["startTimeZone"]] : "UTC " + this._timezoneStringValue();
                    obj[this._appointmentSettings["endTimeZone"]] = !ej.isNullOrUndefined(obj[this._appointmentSettings["endTimeZone"]]) ? obj[this._appointmentSettings["endTimeZone"]] : "UTC " + this._timezoneStringValue();
                }
                if (this.model.categorizeSettings.enable && !this.model.categorizeSettings.allowMultiple) {
                    if (categorizeVal.length != 0 && categorizeVal[0].length != 0) {
                        var categorizeDataIndex = this._findResourceIndex(this.model.categorizeSettings.dataSource, this.model.categorizeSettings["id"], categorizeVal[0][0][this.model.categorizeSettings["id"]], null, null);
                        categorizeVal[0].push(this.model.categorizeSettings.dataSource[categorizeDataIndex]);
                        categorizeVal[0].shift();
                    }
                }
                var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                if (obj[this._appointmentSettings["recurrenceRule"]] != "" && !ej.isNullOrUndefined(obj[this._appointmentSettings["recurrenceRule"]]) && this.model.enableRecurrenceValidation && (this._currentAction == "editSeries" || this._currentAction == "editOccurrence" || this._currentAction == "save")) {
                    if (this._currentAction == "editOccurrence") {
                        var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                        var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                        var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                        var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                        var twoDayApps = (((obj[this._appointmentSettings["endTime"]] - obj[this._appointmentSettings["startTime"]]) / 3600000) < 24 && obj[this._appointmentSettings["endTime"]].getDate() != obj[this._appointmentSettings["startTime"]].getDate());
                        if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                        var recurColl = this._appointmentRecurrenceSort(recurColl);
                        var index = this._recuCollectionIndex(recurColl, _appList);
                        var model = this._appointmentSettings;
                        if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                    else {
                        if (!this._recurrenceValidate(obj[this._appointmentSettings["recurrenceRule"]], _editApps[0][this._appointmentSettings["recurrenceExDate"]])) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                }
                if (this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                    this._objDate = _editApps;
                    var MapValue = this._objDate[0][this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var _editApp = this._deleteOcurrence(this._objDate[0][MapValue], new Date(_editApps[0][this._appointmentSettings["startTime"]]));
                    obj[this._appointmentSettings["recurrence"]] = 1;
                    obj[this._appointmentSettings["recurrenceRule"]] = _editApp[0][this._appointmentSettings["recurrenceRule"]] + ";RECUREDITID=" + _editApp[0]["ParentId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj["Guid"] = this._appUid;
                    obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExDate"]];
                }
                else if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                    var Parid = _editApps[0][this._appointmentSettings["recurrenceId"]] == null ? _editApps[0]["ParentId"] : _editApps[0][this._appointmentSettings["recurrenceId"]];
                    var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                    if (!ej.isNullOrUndefined(_editApp[0].RecurrenceExDate) && this._seriesAlert) {
                        this._seriesAlert = false;
                        //this._rule=_editApp[0].RecurrenceRule.slice(0,_editApp[0].RecurrenceRule.indexOf('EXDATE'));
                        ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
                        if (this._alertWindow.find(".e-alertbtn").find(".e-alertCancel").length == 0) {
                            this._alertWindow.find(".e-alertbtn").append("<button id='" + this._id + "alertcancel' class='e-alertbutton e-alertCancel'></button>");
                            this._alertWindow.find(".e-alertCancel").ejButton({ enableRTL: this.model.enableRTL, showRoundedCorner: true, width: "100px", click: $.proxy(this._alertClose, this), cssClass: "e-flat" + this.model.cssClass });
                            if (this._mediaQuery) this._alertWindow.find(".e-alertCancel").css({ 'margin': '0px 20px 15px 10px' });
                        }
                        this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
                        this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("SeriesChangeAlert"));
                        this._alertWindow.find(".e-alertCancel").html(this._getLocalizedLabels("Cancel"));
                        this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
                        this._alertWindow.addClass("e-seriesAlert");
                        this._alertWindow.ejDialog("open");
                        return false;
                    }
                    if (!ej.isNullOrUndefined(_editApp[0].RecurrenceExDate)) this._seriesAlert = true;
                    obj["AppTaskId"] = _editApp[0]["AppTaskId"];
                    obj[this._appointmentSettings["id"]] = _editApp[0][this._appointmentSettings["id"]];
                    obj["Guid"] = this._appUid;
                    maxId = _editApp[0]["AppTaskId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj[this._appointmentSettings["recurrenceExDate"]] = null;
                    obj[this._appointmentSettings["recurrenceRule"]] = (ej.isNullOrUndefined(recurEdit._recRule) || recurEdit._recRule == "") ? _editApp[0][this._appointmentSettings["recurrenceRule"]] : recurEdit._recRule;
                }
                if (this._currentAction != ej.Schedule.Actions.Add) {
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj["AppTaskId"] = _editApps[0]["AppTaskId"];
                    obj[this._appointmentSettings["id"]] = (this._currentAction != ej.Schedule.Actions.EditSeries) ? _editApps[0][this._appointmentSettings["id"]] : obj[this._appointmentSettings["id"]];
                    var editedApp = $.extend(editedApp, obj);
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                else {
                    obj.Guid = ej.isNullOrUndefined(obj.Guid) ? this._guidFormatGenerate() : obj.Guid;
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentSave" })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                var args = [], newAppointment;
                (this._startTimezone != this._endTimezone) ? obj[this._appointmentSettings["endTime"]] = value.cloneEnddiffer : "";
                var parId = this._currentAction == ej.Schedule.Actions.Add ? maxId : _editApps[0]["ParentId"];
                if (!ej.isNullOrUndefined(this.model.categorizeSettings) && categorizeVal.length > 0 && !ej.isNullOrUndefined(categorizeVal[0][0]) || (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                    args = this._getResCategorySaveData(categorizeVal, autoVal, obj, maxId, parId, starttime, endtime);
                else {
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                }
                if (this._currentAction == ej.Schedule.Actions.Add) {
                    if (this._trigger("beforeAppointmentCreate", { appointment: args, currentAction: currentAction })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                }
                if (this._currentAction != ej.Schedule.Actions.Add && this._currentAction != ej.Schedule.Actions.EditFutureOccurrences) {
                    if (this._currentAction != ej.Schedule.Actions.EditOccurrence) {
                        var _newApp = new ej.DataManager(args).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.notEqual, editedApp[this._appointmentSettings["id"]]));
                        var _editedApp = new ej.DataManager(args).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, editedApp[this._appointmentSettings["id"]]));
                    }
                    else {
                        for (var i = 0; i < args.length; i++) {
                            var _editedApp = new ej.DataManager(args).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, editedApp[this._appointmentSettings["id"]]));
                            var _newApp = new ej.DataManager(args).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.notEqual, editedApp[this._appointmentSettings["id"]]));
                        }
                    }
                    var beforeArgs = { appointment: { added: _newApp, changed: _editedApp }, currentAction: currentAction };
                    if (currentAction == ej.Schedule.Actions.EditSeries) beforeArgs["ignoreEditedOccurrences"] = false;
                    if (this._trigger("beforeAppointmentChange", beforeArgs)) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                    this._ignoreModifyOccurrences = beforeArgs["ignoreEditedOccurrences"];
                }
                var avail = this._checkAvailability(args[0]);
                if (args[this._appointmentSettings["startTime"]] > args[this._appointmentSettings["endTime"]] || avail.length > 0) {
                    this._showBlockAlert && this._alertBlockError();
                    return false;
                }
                if (this._currentAction == ej.Schedule.Actions.Add || this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                    var temp = [];
                    for (var a = 0; a < args.length; a++) {
                        var startTimezone1 = args[a][this._appointmentSettings["startTimeZone"]];
                        (startTimezone1 != this.model.timeZone) ? temp.push(this._timeZoneAppointments(args[a], "")) : temp.push(args[a]);
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", args[a]);
                    }
                    var _editApp = [];
                    if (this._currentAction == ej.Schedule.Actions.EditOccurrence) {
                        var _parentId = (this._inline) ? _editApps[0].ParentId : this._parentId;
                        var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, _parentId));
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", _App[0]);
                        _editApp.push(this._timeZoneAppointments(_App[0], ""));
                    }
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable);
                    var updateTempNew = [];
                    for (var c = 0; c < temp.length; c++) {
                        updateTempNew = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(temp[c], "reverse") : temp[c];
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                    }
                    var updateTempNew2 = [];
                    for (var c = 0; c < _editApp.length; c++) {
                        updateTempNew2 = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(_editApp[c], "reverse") : _editApp[c];
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew2);
                    }
                    for (var d = 0, count = args.length; d < count; d++) {
                        if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args[d]);
                        var isObjAvail = this._processed.filter(function (obj) { return obj.Guid == args[d].Guid; });
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                        this._maxId = ej.isNullOrUndefined(this._maxId) ? args[d].AppTaskId : this._maxId;
                        this._appointmentProcessing(args[d]);
                        this._currentViewAppointments = this._appointmentCount();
                        var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[d].ParentId; });
                        for (var e = 0, len = collection.length; e < len; e++) {
                            this._refreshDayAppointments(collection[e]);
                        }
                    }
                    this._trigger("appointmentCreated", { appointment: args[0], requestType: "appointmentSaved" });
                    this._trigger("actionComplete", { data: args, requestType: "appointmentSave" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        var proxy = this;
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", args[0]);
                                    }
                                }
                            }
                        });
                    }
                }
                else if (this._currentAction == ej.Schedule.Actions.Save || this._currentAction == ej.Schedule.Actions.EditSeries) {
                    var newApp = [], editedApp = [], deleted = [];
                    for (var i = 0; i < args.length; i++) {
                        var GId = this._currentAction == ej.Schedule.Actions.Save ? args[i]["Guid"] : args[i][this._appointmentSettings["recurrenceId"]];
                        var idName = this._currentAction == ej.Schedule.Actions.Save ? "Guid" : this._appointmentSettings["recurrenceId"];
                        _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(idName, ej.FilterOperators.equal, GId));
                        (!ej.isNullOrUndefined(_editApp) && _editApp.length > 0) ? editedApp.push(args[i]) : newApp.push(args[i]);
                    }
                    if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                        if (this._ignoreModifyOccurrences) {
                            var proxy = this;
                            var _parentObj = this._getAppointmentByParentId(this._appUid);
                            editedApp[0][this._appointmentSettings["recurrenceRule"]] = _parentObj[this._appointmentSettings["recurrenceRule"]];
                            editedApp[0][this._appointmentSettings["recurrenceExDate"]] = _parentObj[this._appointmentSettings["recurrenceExDate"]];
                            var removeCollection = this._processed.filter(function (obj) { return obj.ParentId == editedApp[0].ParentId && obj[proxy._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") == -1 });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                            var objCol = this._appointmentCount(removeCollection);
                            for (var j = 0, len = objCol.length; j < len; j++) {
                                this._appointmentRemove(objCol[j]);
                                this._refreshDayAppointments(objCol[j]);
                            }
                        }
                        else {
                            for (var i = 0; i < editedApp.length; i++) {
                                var dele = new ej.DataManager(this._currentAppointmentData).executeLocal(ej.Query().where(ej.Predicate(this._appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + args[i][this._appointmentSettings["recurrenceId"]], true)));
                                deleted = deleted.concat(dele);
                                this._appointmentAddWindow.find('.recurbutton').click();
                                editedApp[i][this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule;
                                editedApp[i][this._appointmentSettings["recurrenceExDate"]] = null;
                                new ej.DataManager(this._currentAppointmentData).remove("ParentId", editedApp[i].ParentId);
                                var removeCollection = this._processed.filter(function (obj) { return obj.ParentId == editedApp[i].ParentId; });
                                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCollection }, "Guid");
                                var objCol = this._appointmentCount(removeCollection);
                                for (var j = 0, len = objCol.length; j < len; j++) {
                                    this._appointmentRemove(objCol[j]);
                                    this._refreshDayAppointments(objCol[j]);
                                }
                            }
                        }
                    }
                    var newTemp = [], editTemp = [];
                    for (var a = 0; a < newApp.length; a++)
                        newTemp.push(this._timeZoneAppointments(newApp[a], ""));
                    for (var b = 0; b < editedApp.length; b++)
                        editTemp.push(this._timeZoneAppointments(editedApp[b], ""));
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newTemp, changed: editTemp, deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
                    for (var c = 0; c < newTemp.length; c++)
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(newTemp[c], "reverse"));
                    for (var d = 0; d < editTemp.length; d++)
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(editTemp[d], "reverse"));
                    if (editedApp.length > 0) {
                        for (var iy = 0; iy < args.length; iy++) {
                            new ej.DataManager(this._currentAppointmentData).remove("Guid", args[iy]);
                            var tempApps = this._processed.filter(function (obj) { return obj.Guid == args[iy].Guid; });
                            new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                            this._currentAppointmentData.push(args[iy]);
                            this._appointmentProcessing(args[iy]);
                            this._appointmentRemove(args[iy]);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[iy].ParentId; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                        }
                        this._trigger("appointmentChanged", { appointment: editedApp[0], requestType: "appointmentChanged", currentAction: currentAction });
                        this._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit", currentAction: currentAction });
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                    proxy._processUrlBinding(e);
                                }
                                else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                    if (value.added.length > 0) {
                                        proxy._dateFormat(value.added);
                                        for (var a = 0, len = value.added.length; a < len; a++) {
                                            args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                            if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        }
                                    }
                                }
                            });
                        }
                    }
                }
                else if (this._currentAction == ej.Schedule.Actions.EditFutureOccurrences) {
                    if (this._trigger("beforeAppointmentChange", { appointment: args[0], currentAction: ej.Schedule.Actions.EditFutureOccurrences })) {
                        this._appointmentAddWindow.ejDialog("close");
                        return false;
                    }
                    var proxy = this;
                    var _editedObj = $.extend(true, {}, args[0]);
                    var _parentObj = this._getAppointmentByParentId(this._appUid);
                    var newRecurrenceRule = this._updateRecurrenceRule(_parentObj, _editedObj);
                    var isObjAvail = this._processed.filter(function (obj) { return obj.ParentId == _parentObj.ParentId; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    var filterObj = this._currentAppointmentData.filter(function (obj) { return obj.ParentId == _parentObj.ParentId; });
                    var tempFilter = [], newAdded = [];
                    if (!ej.isNullOrUndefined(_parentObj[this._appointmentSettings["recurrenceExDate"]])) {
                        tempFilter = filterObj.filter(function (obj) {
                            return new Date(new Date(obj[proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) >= new Date(new Date(_editedObj[proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) && obj[proxy._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1;
                        });
                    }
                    var deletedObj = new ej.DataManager(filterObj).remove("Guid", _editedObj.Guid);
                    deletedObj = ej.isNullOrUndefined(deletedObj) ? [] : deletedObj;
                    $.merge(deletedObj, tempFilter);
                    new ej.DataManager(filterObj).saveChanges({ added: [], changed: [], deleted: tempFilter }, "Guid");
                    if (new Date(_parentObj[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0) == new Date(_editedObj[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) {
                        new ej.DataManager(filterObj).update(this._appointmentSettings["id"], _editedObj);
                    }
                    if (new Date(_parentObj[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0) != new Date(_editedObj[this._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) {
                        for (var f = 0, len = filterObj.length; f < len; f++) {
                            if (filterObj[f][this._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1) {
                                filterObj[f][this._appointmentSettings["recurrenceRule"]] = filterObj[f][this._appointmentSettings["recurrenceRule"]].replace(newRecurrenceRule.mainRule, newRecurrenceRule.parentRule);
                            }
                            else {
                                filterObj[f][this._appointmentSettings["recurrenceRule"]] = newRecurrenceRule.parentRule;
                            }
                            this._appointmentProcessing(filterObj[f]);
                        }
                        _editedObj[this._appointmentSettings["recurrenceRule"]] = newRecurrenceRule.followRule;
                        _editedObj.AppTaskId = this._appMainId;
                        _editedObj.ParentId = _editedObj[this._appointmentSettings["id"]] = Math.max.apply(Math, this._processed.map(function (a) { return a.AppTaskId; })) + 1;
                        newAdded = [_editedObj];
                    }
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newAdded, changed: filterObj, deleted: deletedObj }, queryId, this.model.appointmentSettings.query._fromTable);
                    this._appointmentProcessing(_editedObj);
                    this._currentViewAppointments = this._appointmentCount();
                    var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == _parentObj.ParentId || _editedObj.ParentId; });
                    for (var e = 0, len = collection.length; e < len; e++) {
                        this._refreshDayAppointments(collection[e]);
                    }
                    this._trigger("appointmentChanged", { appointment: _editedObj, requestType: "appointmentChanged", currentAction: ej.Schedule.Actions.EditFutureOccurrences });
                    this._trigger("actionComplete", { data: _editedObj, requestType: "appointmentEdit", currentAction: ej.Schedule.Actions.EditFutureOccurrences });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        var proxy = this;
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        _editedObj[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!_editedObj[proxy._appointmentSettings["recurrence"]]) _editedObj.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", _editedObj);
                                    }
                                }
                            }
                        });
                    }
                }
                this._clearFields();
                this._appointmentAddWindow.ejDialog("close");
            }
            if (this.element.find('div.e-draggableworkarea tr').find('td').hasClass("e-selectedCell"))
                this._processFocus();
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() != "agenda" && (this.element.find(".e-draggableworkarea").offset().top > this.element.find(".e-workcellstab").offset().top)) {
                var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                this.element.find(".e-horires").css("top", -restop + "px");
            }
            this._recRule = "";
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            this.model.allowInline && this._inlineRemove();
        },

        _updateRecurrenceRule: function (parentObj, followObj) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            var originalRule = previousRule = parentObj[this._appointmentSettings["recurrenceRule"]];
            var followDate = new Date(followObj[this._appointmentSettings["startTime"]]);
            var lastDate = new Date(followDate.setDate(followDate.getDate() - 1));
            var recurEditor = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
            var recurDates = recurEditor.recurrenceDateGenerator(parentObj[this._appointmentSettings["recurrenceRule"]], parentObj[this._appointmentSettings["startTime"]]);
            var followDate = new Date(recurDates[recurDates.length - 1]);
            var startDate = new Date(parentObj[this._appointmentSettings["startTime"]]);
            var generateRule = [];
            for (var c = 0; c < 2; c++) {
                var _rules = previousRule.split(';'), changeRule = "", _exDate = "";
                changeRule = (previousRule.indexOf("COUNT") == -1 && c == 0) ? "UNTIL=" + ej.format(lastDate, this._pattern.d, this.model.locale) : changeRule;
                for (var i = 0; i < _rules.length; i++) {
                    if (changeRule != "") changeRule += ";";
                    var keyValuePair = _rules[i].replace(/ /g, '').split('=');
                    _rules[i] = (keyValuePair[0] == "COUNT") ? "UNTIL=" + ej.format(lastDate, this._pattern.d, this.model.locale) : _rules[i];
                    _exDate = (keyValuePair[0] == "EXDATE") ? _rules[i] : _exDate;
                    changeRule += _rules[i];
                }
                var recurEditor = this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                this._appointmentAddWindow.find(".recurstartdate").ejDatePicker({ value: ej.format(startDate, this._datepattern(), this.model.locale) });
                recurEditor.recurrenceRuleSplit(changeRule);
                recurEditor.showRecurrenceSummary();
                var nextRule = recurEditor.getRecurrenceRule();
                nextRule = (_exDate != "" && c == 0) ? nextRule + ";" + _exDate : nextRule;
                generateRule.push(nextRule);
                lastDate = new Date(followDate);
                startDate = new Date(followObj[this._appointmentSettings["startTime"]]);
                previousRule = followObj[this._appointmentSettings["recurrenceRule"]];
            }
            return { mainRule: originalRule, parentRule: generateRule[0], followRule: generateRule[1] };
        },

        _alertCreateError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("CreateError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },

        _timeZoneSavingAppoint: function (obj, temp) {
            if (this.model.appointmentSettings.applyTimeOffset) {
                this._startTimezone = obj[this._appointmentSettings["startTimeZone"]];
                this._endTimezone = obj[this._appointmentSettings["endTimeZone"]];
                if (!ej.isNullOrUndefined(this._startTimezone) && this._startTimezone != "") {
                    var utc = this._startTimezone.indexOf("UTC") != -1 ? this._startTimezone.split(" ")[1].split(":") : this._startTimezone.split(":");
                    var hour = parseInt(utc[0]);
                    var minutes = parseInt(utc[1]);
                    var calcualtevalue = (hour * 60) + minutes;
                    if (this.model.timeZone == null) {
                        var localtime = new Date().getTimezoneOffset() - this._timeZoneOffset;
                        var local = this._minToHour(localtime + calcualtevalue);
                    }
                    else {
                        var timezone = this.model.timeZone.indexOf("UTC") != -1 ? this.model.timeZone.split(" ")[1].split(":") : this.model.timeZone.split(":");
                        var local = this._minToHour(calcualtevalue);
                        local.h = local.h - (parseInt(timezone[0]));
                        local.m = local.m - (parseInt(timezone[1]));
                    }
                    new Date(obj[this._appointmentSettings["startTime"]].setHours(obj[this._appointmentSettings["startTime"]].getHours() - local.h, obj[this._appointmentSettings["startTime"]].getMinutes() - local.m));
                    if (this._startTimezone != this._endTimezone && this._publicMethodSave) {
                        this.startutcValue = null;
                        this.tempValue = null;
                        var utc1 = this._endTimezone.indexOf("UTC") != -1 ? this._endTimezone.split(" ")[1].split(":") : this._endTimezone.split(":");
                        var hour1 = parseInt(utc1[0]);
                        var minutes1 = parseInt(utc1[1]);
                        var calculateend = (hour1 * 60) + minutes1;
                        var newcalcualtevalue = calcualtevalue - calculateend;
                        var tempStart = new Date(temp.StartDate);
                        var CloneStart = new Date(obj[this._appointmentSettings["startTime"]]);
                        var cloneEnd = new Date(temp.EndDate);
                        duration = new Date(cloneEnd.setMinutes(cloneEnd.getMinutes() + newcalcualtevalue));
                        duration = new Date(duration.setMinutes(duration.getMinutes() - ((local.h * 60) + local.m)));
                        var cloneEnddiffer = duration;
                    }
                    else
                        new Date(obj[this._appointmentSettings["endTime"]].setHours(obj[this._appointmentSettings["endTime"]].getHours() - (local.h), obj[this._appointmentSettings["endTime"]].getMinutes() - local.m));
                }
                return { obj: obj, cloneEnddiffer: cloneEnddiffer };
            }
            return { obj: obj, cloneEnddiffer: cloneEnddiffer };
        },

        _renderAllDayAppointments: function () {
            var appHeight = 16;
            var appWidth = this.element.find(".e-workcells").width() - 20;
            var level = 1; this.level = 0;
            var renderDate = this._dateRender; this._renderedAllDay = [];
            var allDayCount = [];
            this.element.find(".e-alldayappointment").remove();
            var appoints = this._appointmentCount(this._processed);
            if (!this.model.group) this.res1 = ["0"];
            if (this._resWorkWeek) {
                var count = 0, resDay = 0;
                for (var res = 0; res < this.res1.length; res++) {
                    if (!ej.isNullOrUndefined(this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        count += this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                    else
                        count += this.model.workWeek.length;
                    for (resDay; resDay < count; resDay++) {
                        for (var i = 0; i < appoints.length; i++) {
                            this._getMultipleResourceAlldayApp(renderDate, resDay, res, appoints[i]);
                            if (!ej.isNullOrUndefined(this.allDayCount[0])) allDayCount.push(this.allDayCount[0]);
                        }
                    }
                }
            }
            else if (this._resCustomView) {
                var count = 0, resDate = 0;
                var resDates = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                for (var res = 0; res < this.res1.length; res++) {
                    if (!ej.isNullOrUndefined(this.res1[res][resDates])) {
                        count += this._getCustomDatesCount(res, resDates);
                    }
                    for (resDate; resDate < count; resDate++) {
                        for (var i = 0; i < appoints.length; i++) {
                            this._getMultipleResourceAlldayApp(renderDate, resDate, res, appoints[i]);
                            if (!ej.isNullOrUndefined(this.allDayCount[0])) allDayCount.push(this.allDayCount[0]);
                        }
                    }
                }
            }
            else {
                for (var res = 0; res < this.res1.length; res++) {
                    for (var day = 0; day < renderDate.length; day++) {
                        for (var i = 0; i < appoints.length; i++) {
                            if ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
                                this._getMultipleResourceAlldayApp(renderDate, day, res, appoints[i]);
                                if (!ej.isNullOrUndefined(this.allDayCount[0])) allDayCount.push(this.allDayCount[0]);
                            }
                            else {
                                if ((ej.format(new Date(renderDate[day]), this._pattern.d, this.model.locale) == ej.format(new Date(appoints[i][this._appointmentSettings["startTime"]]), this._pattern.d, this.model.locale)) && (appoints[i][this._appointmentSettings["allDay"]] === true || this._findAllDayApp(appoints[i]))) {
                                    this._setAllDayPos(appoints[i], day, res);
                                    allDayCount.push(appoints[i]);
                                }
                            }
                        }
                    }
                }
            }
            this.allDayLevel = allDayCount.length;
            if (allDayCount.length == 0 && this.level == 0) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
            }
            this._reRenderScroller();
        },

        _renderSingleApp: function () {
            this.element.find(".e-prevapp,.e-nextapp").css("display", "none");
            this._dataProcessing(this._currentAppointmentData);
            this._renderAppointmentAll();
        },

        _timeFormat: function (time) {
            var dateObj = ej.parseDate(time, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale);
            if (dateObj) {
                var hours = dateObj.getHours();
                var minutes = dateObj.getMinutes();
            } else {
                var hours = Number(time.match(/^(\d+)/)[1]);
                var minutes = Number(time.match(/:(\d+)/)[1]);
                if (!ej.isNullOrUndefined(time.split(" ")[1])) {
                    var AMPM = time.match(/\s(.*)$/)[1];
                    if (!ej.isNullOrUndefined(this._culture.calendar.AM) && !ej.isNullOrUndefined(this._culture.calendar.PM)) {
                        if (AMPM == this._culture.calendar.PM[0] && hours < 12) hours = hours + 12;
                        if (AMPM == this._culture.calendar.AM[0] && hours == 12) hours = hours - 12;
                    }
                }
            }
            var sHours = hours.toString();
            var sMinutes = minutes.toString();
            if (hours < 10) sHours = "0" + sHours;
            if (minutes < 10) sMinutes = "0" + sMinutes;
            return sHours + ":" + sMinutes;
        },

        _processEscapeKey: function () {
            if (!ej.isNullOrUndefined(this._inlineText)) {
                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && !ej.isNullOrUndefined(this._inlineDate) && this.currentView() != "month" && !this._isCustomMonthView())
                    this._refreshDayAppointments(this._app);
                this._inlineRemove();
            }
            (!ej.isNullOrUndefined(this._quickAppointWindow)) && this._quickAppointWindow.find(".e-error").remove();
            this._processFocus();
            this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
        },

        _processFocus: function () {
            var selectApp = this.element.find("div.e-selectedAppointment");
            if (selectApp.length != 0)
                selectApp.focus();
            if (this.element.find("td.e-selectedCell").hasClass("e-workcells")) {
                var oRowCell = this.element.find('div.e-draggableworkarea tr');
                var rowcount = oRowCell.length - 1;
                var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
                var curr_View = this.currentView();
                var proxy = this;
                this.element.find('td.e-selectedCell').each(function (index, tdItem) {
                    var targetId = $(tdItem).index();
                    if (targetId != null && !isNaN(targetId)) {
                        if (omincolIndex == null) {
                            omincolIndex = targetId;
                            rowInx = $(tdItem).parent()[0].rowIndex;
                        }
                        else if (omincolIndex < targetId) {
                            omincolIndex = omincolIndex;
                        }
                        else {
                            if (omincolIndex != targetId) {
                                omincolIndex = targetId;
                                rowInx = $(tdItem).parent()[0].rowIndex;
                            }
                        }
                        if (omaxcolIndex == null) {
                            omaxcolIndex = targetId;
                            if (curr_View != "month") {
                                checkcolindex = parseInt(omaxcolIndex);
                                for (var i = 0; i <= rowcount; i++) {
                                    if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                        maxrowInx = i;

                                    }
                                }
                            }
                        }
                        else if (omaxcolIndex > targetId) {
                            omaxcolIndex = omaxcolIndex;
                        }
                        else {
                            if (omaxcolIndex != targetId) {
                                omaxcolIndex = targetId;
                                if (curr_View != "month") {
                                    checkcolindex = parseInt(omaxcolIndex);
                                    for (var i = 0; i <= rowcount; i++) {
                                        if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                            maxrowInx = i;

                                        }
                                    }
                                }
                            }
                        }
                    }
                });
                if (curr_View != "month") {
                    $(oRowCell[maxrowInx].cells[omaxcolIndex]).attr("tabIndex", 0).focus();
                }
                else {
                    var tdsel = oRowCell.find('td.e-selectedCell');
                    var tdlen = parseInt(tdsel.length) - 1;
                    $(tdsel[tdlen]).attr("tabIndex", 0).focus();
                }
            }
            else {
                this.element.focus();
                this.element.find("td.e-selectedCell").attr("tabIndex", 0).focus();
                if (!ej.isNullOrUndefined(this._appointmentAddWindow))
                    this._appointmentAddWindow.ejDialog("isOpened") && this._appointmentAddWindow.find(".subject").focus();
            }
        },

        _clearFields: function () {
            this._appointmentAddWindow.find('.subject').val("");
            this._appointmentAddWindow.find('.id').val("");
            this._appointmentAddWindow.find('.e-description').val("").css("height", "");
            this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", new Date());
            this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", new Date());
            this._appointmentAddWindow.find('.startendtime').ejTimePicker({ enabled: true });
            this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(), this._pattern.t, this.model.locale));
            this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(), this._pattern.t, this.model.locale));
            this._appointmentAddWindow.find(".recurrence,.weekdays").ejCheckBox({ checked: false, enabled: true });
            this._appointmentAddWindow.find(".e-repeatlbl").removeClass('e-disable');
            this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
            this._appointmentAddWindow.find(".startutc,.endutc").ejDropDownList("clearText");
            this._appointmentAddWindow.find("." + this._id + "summary").css("display", "none");
            this._appointmentAddWindow.find(".e-recurFinalRule").html("");
            this._appointmentAddWindow.find(".e-recuredit").hide();
            this._appointmentAddWindow.find(".e-categorizevalue").ejAutocomplete("clearText");
        },

        _getNumericModel: function () {
            return numericModel = {
                width: "100px",
                minValue: 1,
                value: 1,
                cssClass: this.model.cssClass,
                enableRTL: this.model.enableRTL,
                localize: this.model.locale
            };
        },

        _deleteApp: function (id) {
            var currentAction = (this._actionType == ej.Schedule.Actions.DeleteSeries) ? ej.Schedule.Actions.DeleteSeries : (this._actionType == ej.Schedule.Actions.DeleteOccurrence) ? ej.Schedule.Actions.DeleteOccurrence : (this._actionType == ej.Schedule.Actions.DeleteFutureOccurrences) ? ej.Schedule.Actions.DeleteFutureOccurrences : ej.Schedule.Actions.Delete;
            var list = this.model.showRecurrenceAlert ? this._processed : currentAction == ej.Schedule.Actions.DeleteSeries ? this._currentAppointmentData : this._processed;
            var query = this.model.showRecurrenceAlert ? new ej.Query().where("Guid", ej.FilterOperators.equal, id) : currentAction == ej.Schedule.Actions.DeleteOccurrence ? new ej.Query().where("Guid", ej.FilterOperators.equal, id) : new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, id);
            if (this._trigger("actionBegin", { id: id, requestType: "appointmentDelete", currentAction: currentAction }))
                return false;
            var removeItem = new ej.DataManager(list).executeLocal(query);
            if (removeItem.length == 0) return false;
            if (!this.model.showRecurrenceAlert) {
                var occurrenceItem = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
            }
            var data = this.model.showRecurrenceAlert ? { appointment: removeItem[0], currentAction: currentAction } : { appointment: removeItem[0], currentAction: currentAction, recurrenceCollection: { occurrences: occurrenceItem[0], parentData: removeItem[0] }, deleteSeries: true };
            if (this._trigger("beforeAppointmentRemove", data))
                return false;
            currentAction = (this.model.showRecurrenceAlert) ? currentAction : this._currentAction = data.deleteSeries ? currentAction : ej.Schedule.Actions.DeleteOccurrence;
            var parentObj = (this.model.showRecurrenceAlert) ? this._getAppointmentByParentId(id) : (data.deleteSeries) ? removeItem[0] : occurrenceItem[0];
            if (parentObj[this._appointmentSettings["recurrence"]]) {
                var Parid = (removeItem[0][this._appointmentSettings["recurrenceId"]] == null) ? removeItem[0]["ParentId"] : removeItem[0][this._appointmentSettings["recurrenceId"]];
                var MapValue = (removeItem[0][this._appointmentSettings["recurrenceId"]] == null) ? "ParentId" : this._appointmentSettings["recurrenceId"];
                var deleted = ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                if (currentAction == ej.Schedule.Actions.DeleteFutureOccurrences) {
                    var newRecurrenceRule = this._updateRecurrenceRule(parentObj, removeItem[0]);
                    var isObjAvail = this._processed.filter(function (obj) { return obj.ParentId == parentObj.ParentId; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    var filterObj = this._currentAppointmentData.filter(function (obj) { return obj.ParentId == parentObj.ParentId; });
                    if (!ej.isNullOrUndefined(parentObj[this._appointmentSettings["recurrenceExDate"]])) {
                        var proxy = this;
                        tempFilter = filterObj.filter(function (obj) { return new Date(new Date(obj[proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) >= new Date(new Date(removeItem[0][proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)) && obj[proxy._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1; });
                    }
                    var deletedObj = new ej.DataManager(filterObj).remove("Guid", removeItem[0].Guid);
                    deletedObj = ej.isNullOrUndefined(deletedObj) ? [] : deletedObj;
                    $.merge(deletedObj, tempFilter);
                    new ej.DataManager(filterObj).saveChanges({ added: [], changed: [], deleted: tempFilter }, "Guid");
                    for (var f = 0, len = filterObj.length; f < len; f++) {
                        if (filterObj[f][this._appointmentSettings["recurrenceRule"]].indexOf("RECUREDITID") != -1) {
                            filterObj[f][this._appointmentSettings["recurrenceRule"]] = filterObj[f][this._appointmentSettings["recurrenceRule"]].replace(newRecurrenceRule.mainRule, newRecurrenceRule.parentRule);
                        } else {
                            filterObj[f][this._appointmentSettings["recurrenceRule"]] = newRecurrenceRule.parentRule;
                        }
                    }
                    var promise = this._dataManager.saveChanges({ added: [], changed: filterObj, deleted: deletedObj }, queryId, this.model.appointmentSettings.query._fromTable);
                } else if (currentAction == ej.Schedule.Actions.DeleteOccurrence) {
                    parentObj = occurrenceItem;
                    if (parentObj[0][this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) {
                        var promise = this._dataManager.remove("Guid", parentObj[0]["Guid"], this.model.appointmentSettings.query._fromTable);
                        if (this.dataSource() instanceof ej.DataManager) new ej.DataManager(this._currentAppointmentData).remove("Guid", parentObj[0]);
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: parentObj }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: parentObj }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: parentObj }, "Guid");
                        this._appointmentRemove(parentObj[0]);
                        this._refreshDayAppointments(parentObj[0]);
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    } else {
                        var Parid = occurrenceItem[0][this._appointmentSettings["recurrenceId"]] == null ? occurrenceItem[0]["ParentId"] : occurrenceItem[0][this._appointmentSettings["recurrenceId"]]
                        var deleApp = this._deleteOcurrence(Parid, occurrenceItem[0][this._appointmentSettings["startTime"]]);
                        var temp = this._timeZoneAppointments(deleApp[0], "");
                        var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                        var promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable);
                        var updateTemp = (this._timeZoneAppointments(temp, "reverse"));
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                        this._refreshCellsHeight();
                        var delApp_ = this._processed.filter(function (obj) { return obj.Guid == occurrenceItem[0].Guid; });
                        if (delApp_.length > 1) {
                            var delApp = [];
                            for (var i = 0; i < delApp_.length; i++) {
                                var tmpApp = this._processed.filter(function (obj) { return obj.Guid == delApp_[i]["Guid"]; });
                                if (tmpApp.length > 0) delApp.push(tmpApp[0]);
                                new ej.DataManager(this._processed).remove("Guid", delApp_[i]["Guid"]);
                                new ej.DataManager(this._renderedApp).remove("Guid", delApp_[i]["Guid"]);
                                new ej.DataManager(this._renderedAllDay).remove("Guid", delApp_[i]["Guid"]);
                            }
                        } else {
                            var delApp = this._processed.filter(function (obj) { return obj.Guid == occurrenceItem[0].Guid; });
                            new ej.DataManager(this._processed).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedApp).remove("Guid", this._appUid);
                            new ej.DataManager(this._renderedAllDay).remove("Guid", this._appUid);
                            this._appUid = null;
                        }
                        for (var ix = 0, len = delApp.length; ix < len; ix++) {
                            this._appointmentRemove(delApp[ix]);
                            this._refreshDayAppointments(delApp[ix]);
                        }
                        if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                            var proxy = this;
                            promise.done(function (e) {
                                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                    proxy._processUrlBinding(e);
                                }
                            });
                        }
                    }
                } else {
                    var promise = this._dataManager.saveChanges({ added: [], changed: [], deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
                }
            } else {
                var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                var promise = this._dataManager.remove(queryId, parentObj[queryId], this.model.appointmentSettings.query._fromTable);
                if (this.dataSource() instanceof ej.DataManager) new ej.DataManager(this._currentAppointmentData).remove(queryId, parentObj[queryId]);
            }
            this._refreshCellsHeight();
            if (currentAction != ej.Schedule.Actions.DeleteOccurrence) {
                if (this.currentView() != "agenda") {
                    if (this._currentAppointmentData.length > 0) {
                        if (removeItem[0][this._appointmentSettings["recurrence"]])
                            var deleteApp = this._processed.filter(function (obj) { return obj[MapValue] == Parid; });
                        else
                            var deleteApp = this._processed.filter(function (obj) { return obj.Guid == id; });
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        var removeCollection = this._appointmentCount(deleteApp);
                        for (var del = 0, len = removeCollection.length; del < len; del++) {
                            this._appointmentRemove(removeCollection[del]);
                            this._refreshDayAppointments(removeCollection[del]);
                        }
                        if (currentAction == ej.Schedule.Actions.DeleteFutureOccurrences) {
                            var filterApps = this._currentAppointmentData.filter(function (obj) { return obj.ParentId == parentObj.ParentId; });
                            for (var filt = 0, len = filterApps.length; filt < len; filt++) {
                                this._appointmentProcessing(filterApps[filt]);
                            }
                            this._currentViewAppointments = this._appointmentCount();
                            for (var app = 0, len = this._currentViewAppointments.length; app < len; app++) {
                                this._refreshDayAppointments(this._currentViewAppointments[app]);
                            }
                        }
                    } else {
                        this._processed = [];
                        this._renderedApp = [];
                        this._renderedAllDay = [];
                        this.element.find("div.e-appointwrapper").remove();
                        this._appointmentRemove(removeItem[0]);
                        this._refreshDayAppointments(removeItem[0]);
                    }
                } else {
                    new ej.DataManager(this._processed).remove("Guid", id);
                    var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(ej.Predicate("ParentId", ej.FilterOperators.equal, removeItem[0].ParentId)));
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                    this._renderAgendaContent();
                }
            }
            this._trigger("appointmentRemoved", { appointment: parentObj, requestType: "appointmentDeleted", currentAction: currentAction });
            this._trigger("actionComplete", { data: parentObj, requestType: "appointmentDelete", currentAction: currentAction });
            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                var proxy = this;
                promise.done(function (e) {
                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                    if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                        proxy._processUrlBinding(e);
                    }
                });
            }
            if (this.model.timeScale.enable && ((((removeItem[0][this._appointmentSettings["endTime"]] - removeItem[0][this._appointmentSettings["startTime"]]) / 3600000) > 24) || removeItem[0][this._appointmentSettings["allDay"]]) && this.currentView() != "month" && !(this._isCustomMonthView()) && this.currentView() != "agenda" && (this.allDayLevel == 0)) {
                this.element.find(".e-alldaycells,.e-leftindent").addClass("e-alldaycellsheight");
                this.element.find(".e-alldaycells").first().css(this.model.enableRTL ? 'border-right' : 'border-left', "none");
                this._reRenderScroller();
            }
            this._currentViewAppointments = this._appointmentCount();
            if (this.model.showAppointmentNavigator) this._nextPrevButton();
            if (!this.model.showOverflowButton && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() != "agenda") {
                var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                this.element.find(".e-horires").css("top", -restop + "px");
            }
            this._appUid = null;
            this._actionType = "";
        },

        _appointmentCount: function (apps) {
            var newAppList;
            if (this._resCustomView) {
                newAppList = this._processed;
            } else {
                var renderDate = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (this.currentView() == "month" || this._isCustomMonthView())) ? this.monthDays : (this._resWorkWeek) ? this._renderDates : this._dateRender,
                    appointments = ej.isNullOrUndefined(apps) ? this._appointmentSort(this._processed) : this._appointmentSort(apps),
                    startDate = this.currentView() == "agenda" ? new Date(new Date(this.currentDate()).setHours(0, 0, 0)) : new Date(renderDate[0]),
                    endDate = this.currentView() == "agenda" ? new Date(new Date(new Date(this.currentDate()).setDate(startDate.getDate() + (this.model.agendaViewSettings.daysInAgenda > 0 ? this.model.agendaViewSettings.daysInAgenda - 1 : 0))).setHours(23, 59, 59)) : new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59)),
                    predicate = ej.Predicate(this._appointmentSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, startDate).and(this._appointmentSettings["startTime"], ej.FilterOperators.lessThanOrEqual, endDate);
                newAppList = new ej.DataManager(appointments).executeLocal(new ej.Query().where(predicate));
            }
            return newAppList;
        },

        _reRenderAllDayAppointments: function () {
            this._alldayLevel = (this.level == 1) ? true : false;
            (this.model.showAllDayRow) && this.element.find("div.e-alldayappointment").remove() && this._renderAllDayAppointments();
            this._bindAppointmentAction();
        },

        _appointmentResizeStart: function (e) {
            if (this.model.enableAppointmentResize) {
                this._tooltipEvents("disable");
                this._appointdata = $(e.target).parent();
                var appUid = $(e.target).parent().attr("data-guid");
                var app = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appUid)));
                var data = { element: $(e.target).parent(), appointment: app[0] };                
                if (this._trigger("actionBegin", { data: data, requestType: "appointmentResize" })) {
                    this._tooltipEvents("enable");
                    return false;
                }
                if (this._trigger("resizeStart", data)) {
                    this._tooltipEvents("enable");
                    return false;
                }
                e.preventDefault();
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                this.resizeStart = true;
                if ($(e.target).hasClass("e-lefthandle") || $(e.target).hasClass("e-righthandle")) {
                    this.resize = e.pageX;
                    this.appoint_width = $(e.target).parent().width();
                    this.appoint_left = parseInt($(e.target).parent()[0].style.left);
                    this._appointleft = parseInt($($(e.target).parent()[0]).offset().left);
                    this._appointright = parseInt($($(e.target).parent()[0]).css('right'));
                    if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.model.enableRTL)
                        $(e.target).hasClass("e-lefthandle") ? this._rightResizing = true : this._leftResizing = true;
                    else $(e.target).hasClass("e-lefthandle") ? this._leftResizing = true : this._rightResizing = true;
                }
                else if ($(e.target).hasClass("e-tophandle") || $(e.target).hasClass("e-bottomhandle")) {
                    this.resize = e.pageY;
                    this.appoint_height = $(e.target).parent().height();
                    this.appoint_top = parseInt($(e.target).parent()[0].style.top);
                    $(e.target).hasClass("e-tophandle") ? this._topResizing = true : this._bottomResizing = true;
                }
                this._curElmt = $(e.target).parent();
                this.element.find(".e-workcells").removeClass("e-selectedCell,e-mousehover");
                $(document).on(ej.eventType.mouseMove, $.proxy(this._appointmentResizing, this));
                $(document).on(ej.eventType.mouseUp, $.proxy(this._appointmentResizeStop, this));
                if ($(e.target).hasClass("e-rowcursor") || $(e.target).hasClass("e-columncursor"))
                    return false;
            }
        },

        _appointmentResizing: function (e) {
            var target = $(e.target);
            var data = { element: target.parent(), interval: 10 };
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-alldayappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            if ($(".e-scheduleAppGlassy").length == 0) {
                appointDiv.find('.e-schedulemouseclose').addClass('e-schedulemouseclosetemp').removeClass('e-schedulemouseclose e-icon');
                appointDiv.clone().prop('id', 'cloneElement').appendTo(appointDiv.parent());
                appointDiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose").appendTo(appointDiv.parent());
                if (this._topResizing || this._bottomResizing) {
                    (!this.model.enableRTL) ? appointDiv.css("left", "0") : appointDiv.css("right", "0");
                    appointDiv.css("width", "98%");
                }
                else if (this._rightResizing || this._leftResizing) {
                    if (this.model.orientation != "horizontal") {
                        if (this.currentView() === "month" || this._isCustomMonthView()) {
                            this._appointmentResizeHeight(appointDiv, -(this.element.find(".e-monthheader").height()), "e-monthcells");
                        }
                        else {
                            if (!this.model.timeScale.enable) {
                                appointDiv.css("height", this.element.find(".e-monthcells").height() - 2);
                            }
                            else {
                                appointDiv.css("top", (this.element.find(".e-headerarearow").height() - this.element.find(".e-alldaycells").height() - 2));
                                appointDiv.css("height", this.element.find(".e-alldaycells").height() - 2);
                            }
                        }
                    }
                    else {
                        this._appointmentResizeHeight(appointDiv, 0, "e-workcells");
                    }
                }
            }
            appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-workcells") || $(e.target).hasClass("e-monthcells") || $(e.target).hasClass("e-alldayappointment") || $(e.target).hasClass("e-alldaycells") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
            var cellHeight = this.element.find(".e-workcells").height();
            var appointcellCount = ($(appointDiv[0]).height() / cellHeight);
            if (this._topResizing) {
                if (appointcellCount > 0 && !$(e.target).hasClass("e-alldaycells") && !$(e.target).hasClass("e-apptext")) {
                    this._curElmt.height(this.appoint_height + this.resize - e.pageY + 3);
                    this._curElmt.css("top", this.appoint_top - (this.resize - e.pageY) - 3);
                }
            }
            else if (this._bottomResizing) {
                this._curElmt.height(this.appoint_height + (e.pageY - this.resize) + 2);
            }
            else if (this._rightResizing) {
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.model.enableRTL) {
                    this._curElmt.width(this.appoint_width + this.resize - e.pageX + 3);
                    this._curElmt.css("left", this.appoint_left - (this.resize - e.pageX) - 3);
                }
                else {
                    this._curElmt.width(this.appoint_width + (e.pageX - this.resize) + 2);
                    this._curElmt.css("right", this._appointright - (e.pageX - this.resize) - 2);
                }
            }
            else if (this._leftResizing) {
                if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.model.enableRTL) {
                    this._curElmt.width(this.appoint_width + (e.pageX - this.resize) + 2);
                    this._curElmt.css("right", this._appointright - (e.pageX - this.resize) - 2);
                }
                else {
                    this._curElmt.width(this.appoint_width + this.resize - e.pageX + 3);
                    this._curElmt.css("left", this.appoint_left - (this.resize - e.pageX) - 3);
                }
            }
            this._trigger("resize", data);
            this._resizeInterval = data.interval;
            (this._curElmt.hasClass("e-appointment")) && this._appointmentCurrentTimeUpdate();
        },

        _appointmentResizeHeight: function (appointDiv, topHeight, classname) {
            if (appointDiv.length > 0) {
                var target = (this.model.showOverflowButton) ? this.element.find("." + classname) : appointDiv.closest("td");
                appointDiv.css("top", topHeight).css("height", $(target).height() - 2);
            }
        },
        _appointmentCurrentTimeUpdate: function () {
            var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, parseInt(this._curElmt.attr("id").split("_")[1])))[0];
            var newStartTime = new Date(appointment[this._appointmentSettings["startTime"]]), newEndTime = new Date(appointment[this._appointmentSettings["endTime"]]);
            var cellHeight = this.element.find(".e-workcells").outerHeight();
            var timesoltduration = parseInt(this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                var dragArea = this.element.find(".e-draggableworkarea");
                var appTop = $(this._curElmt[0]).offset().top;
                var resizeMax = dragArea.height() + dragArea.scrollTop();
                var resizeElmntHeight = $(this._curElmt[0]).outerHeight();
                var topPos = appTop - dragArea.offset().top + dragArea.scrollTop();
                var resizeMaxTop = (topPos - (cellHeight / this.model.timeScale.minorSlotCount)) < resizeMax ? topPos : resizeMax - resizeElmntHeight;
            }
            if (this._topResizing) {
                var newTopTime = resizeMaxTop * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight));
                newStartTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                newStartTime.setMinutes(parseInt(newTopTime % 60));
                (timesoltduration >= this._resizeInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
            }
            else if (this._bottomResizing) {
                var newcellCount = ($(this._curElmt[0]).outerHeight() / cellHeight);
                var newTopTime = (resizeMaxTop + (newcellCount * cellHeight)) * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight));
                newEndTime.setHours(parseInt(this.model.startHour) + parseInt(newTopTime / 60));
                newEndTime.setMinutes(newTopTime % 60);
                (timesoltduration >= this._resizeInterval) ? newEndTime.setMinutes((Math.round(newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval)) : newEndTime.setMinutes(((newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval));
            }
            else if (this._rightResizing) {
                var diffWidth = (this.model.endHour - this.model.startHour === 24) ? this._curElmt.width() - this.appoint_width : this._curElmt.width();
                var diffMinutes = (diffWidth * 60) / ((this.element.find(".e-workcells").width() * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) + 1);

                if (this.model.endHour - this.model.startHour === 24) {
                    newEndTime.setHours(new Date(newEndTime).getHours() + parseInt(diffMinutes / 60));
                    newEndTime.setMinutes(new Date(newEndTime).getMinutes() + parseInt(diffMinutes % 60));
                }
                else {
                    newEndTime.setHours(new Date(newStartTime).getHours() + (parseInt(this._curElmt.width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    newEndTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                }
                (timesoltduration >= this._resizeInterval) ? newEndTime.setMinutes(Math.round(newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newEndTime.setMinutes((newEndTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
                if (newEndTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)))
                    newEndTime = new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59));
                if (this.model.endHour - this.model.startHour != 24) {
                    var indexCell = parseInt((this._curElmt.offset().left + (dragArea.scrollLeft() - dragArea.offset().left) + this._curElmt.width()) / this.element.find(".e-workcells").width()) - 1;
                    var hourValue = parseInt(indexCell / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var newStart = new Date(newStartTime);
                    var variable = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? (this._dateRender[hourValue] - new Date(new Date(new Date(newStartTime).setHours(0, 0, 0, 0))).getTime()) / (24 * 1000 * 60 * 60) : 0;
                    var missDate = this.currentView() == "workweek" ? ((variable - 1) * (this.model.endHour - this.model.startHour)) : 0;
                    var minStartTime = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? new Date(new Date(newStart).setHours(new Date(newStartTime).getHours() + missDate + (parseInt($(this._curElmt).width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) + (variable * ((24 - this.model.endHour) + this.model.startHour)))) : newEndTime;
                    if (new Date(newEndTime).getHours() >= (this.model.endHour)) minStartTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                    if (new Date(new Date(minStartTime).setHours(0, 0, 0, 0)).getTime() != new Date(this._dateRender[hourValue]).getTime())
                        minStartTime = new Date(this._dateRender[hourValue]).setHours(new Date(minStartTime).getHours(), new Date(minStartTime).getMinutes(), new Date(minStartTime).getSeconds(), new Date(minStartTime).getMilliseconds());
                    newEndTime = new Date(minStartTime);
                }
            }
            else if (this._leftResizing) {
                if ($(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left < $(this._curElmt).offset().left)
                    var diffLeft = this._curElmt.offset().left - this._appointleft;
                else
                    var diffLeft = $(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left - this._appointleft;
                if (this.model.enableRTL) {
                    var diff = this._curElmt.width() - this.appoint_width;
                    diffLeft = -diff;
                }
                var diffMinutes = (diffLeft * 60) / ((this.element.find(".e-workcells").width() * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)) + 1);
                newStartTime.setHours(parseInt(new Date(newStartTime).getHours()) + parseInt(diffMinutes / 60));
                newStartTime.setMinutes(new Date(newStartTime).getMinutes() + parseInt(diffMinutes % 60));
                (timesoltduration >= this._resizeInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._resizeInterval) * this._resizeInterval);
                if (newStartTime < new Date(this._dateRender[0]))
                    newStartTime = new Date(this._dateRender[0]);
                //if (this.model.endHour - this.model.startHour !== 24) {
                //    var drag = (dragArea.scrollLeft() == 0) ? dragArea.offset().left : dragArea.scrollLeft() - dragArea.offset().left;
                //    var offsetLeft = (((this._curElmt.offset().left + drag)) / this.element.find(".e-workcells").width()) - 1;
                //    var cellIndex = parseInt(parseInt(offsetLeft) / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                //    var maxNewStartTime = new Date(this._dateRender[cellIndex]);
                //    var indTime = (offsetLeft % ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                //    var hrsTime = ((this.model.startHour) + (indTime / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))) - 0.2;
                //    maxNewStartTime.setHours(hrsTime);
                //    maxNewStartTime.setMinutes((hrsTime * 60) % 60);
                //    newStartTime = new Date(maxNewStartTime);
                //}
            }
            if (this.model.enableRTL) {
                this._curElmt.find(".e-apptext").html(ej.format(new Date(newStartTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal");
                this._curElmt.find(".e-apptime").html(ej.format(new Date(newEndTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal").css("float", "left").css("margin-top", (this._curElmt.height() - (this._curElmt.find(".e-apptime").outerHeight() + this._curElmt.find(".e-apptext").outerHeight())) + "px");
            }
            else {
                this._curElmt.find(".e-apptext").html(ej.format(new Date(newStartTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal");
                this._curElmt.find(".e-apptime").html(ej.format(new Date(newEndTime), (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).css("font-size", "12px").css("white-space", "normal").css("float", "right").css("margin-top", (this._curElmt.height() - (this._curElmt.find(".e-apptime").outerHeight() + this._curElmt.find(".e-apptext").outerHeight())) + "px");
            }
            this._resizeNewStartTime = newStartTime;
            this._resizeNewEndTime = newEndTime;
        },

        _leftRightResize: function (document, appointDiv, index, noOfDays, Start, End) {
            var StartTime = this._leftResizing ? Start : End;
            var EndTime = this._leftResizing ? End : Start;

            if (this._resWorkWeek || this._resCustomView) {
                var eleOffset = appointDiv.offset();
                this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
                var element = this._leftResizing ? document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop())) : document.elementFromPoint((eleOffset.left + appointDiv.width() - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop()));
                if (this._leftResizing)
                    var trgtIndex = Math.floor(appointDiv.offset().left / this.element.find(".e-alldaycells").width()) - 1; // - Math.floor(appointDiv.width() / this.element.find(".e-alldaycells").width());
                else
                    var trgtIndex = Math.floor(appointDiv.offset().left / this.element.find(".e-alldaycells").width()) + 1; // + Math.floor(appointDiv.width() / this.element.find(".e-alldaycells").width());
                this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
            }
            else var trgtIndex = this._leftResizing ? index * noOfDays : (index == this.res1.length - 1) ? ((index + 1) * noOfDays - 1) : (index + 1) * noOfDays;

            if (!this.model.enableRTL) {
                if (this._rightResizing) {
                    var diffLeft = appointDiv[0].offsetLeft + $(appointDiv[0]).width();
                    if (!this._resWorkWeek || !this._resCustomView) var diffDays = Math.floor(diffLeft / (this.element.find(".e-alldaycells").width())) - (index * noOfDays);
                    var cellsLeft = (index == this.res1.length - 1) ? $(this.element.find(".e-alldaycells")[trgtIndex]).offset().left + this.element.find(".e-alldaycells").width() : $(this.element.find(".e-alldaycells")[trgtIndex]).offset().left;
                }
                else {
                    var diffLeft = this.element.find(".e-alldaycells").eq(trgtIndex).offset().left;
                    var cellsLeft = $(appointDiv[0]).offset().left;
                }
                if (cellsLeft >= diffLeft) {
                    newStartTime = new Date(this._dateRender[0]);
                    if ((!this._resWorkWeek || !this._resCustomView) && this._leftResizing) {
                        var diffLeft = $(appointDiv[0]).offset().left - $(this.element.find(".e-alldaycells")[index * noOfDays]).offset().left;
                        var diffDays = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                    }
                    if (this.model.workWeek.length > 0) {
                        if (this._resWorkWeek) {
                            newStartTime = new Date(this._dateRender[trgtIndex]);
                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                        }
                        else {
                            newStartTime = new Date(this._dateRender[0]);
                            newStartTime.setDate(new Date(this._dateRender[diffDays]).getDate());
                            newStartTime.setMonth(new Date(this._dateRender[diffDays]).getMonth());
                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                        }
                    }
                    else {
                        newStartTime = new Date(this._dateRender[0]);
                        newStartTime.setDate(new Date(newStartTime).getDate() + ((diffDays >= noOfDays) ? diffDays - 1 : diffDays));
                        newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                    }
                }
                else {
                    (this._rightResizing) ? this._rightResizing = false : this._leftResizing = false;
                    (!this.model.enableRTL) ? newStartTime = Start : newEndTime = End;
                }
            }
            else {
                if (this._resWorkWeek || this._resCustomView) {
                    var resDates = $.extend(true, [], this._dateRender);
                    resDates.reverse();
                    var eleOffset = appointDiv.offset();
                    this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
                    var element = this._rightResizing ? document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop())) : document.elementFromPoint((eleOffset.left + appointDiv.width() - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop()));
                    var target = $.grep(element, function (value) { if ($(value).closest("td").hasClass("e-alldaycells")) { return value; } });
                    var trgtIndex = (this.element.find(".e-alldaycells").length - 1) - $(target[0]).index();
                    this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
                    newEndTime = new Date(resDates[trgtIndex]);
                    newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                }
                else {
                    var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                    var diffDays = Math.round($(appointDiv[0]).width() / this.element.find(".e-alldaycells").width()) - 1;
                    newEndTime = this._rightResizing ? new Date(End) : new Date(StartTime);
                    this._rightResizing ? newEndTime.setDate(new Date(newEndTime).getDate() - diffDays) : newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                    newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                    if (newEndTime > new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()))) {
                        newEndTime = new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()));
                    }
                    else if (newEndTime < new Date(new Date(this._dateRender[this._dateRender.length - 1]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()))) {
                        newEndTime = new Date(new Date(this._dateRender[0]).setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds()));
                    }
                }
            }
            return (!this.model.enableRTL) ? newStartTime : newEndTime;
        },
        _appointmentResizeStop: function (e) {
            this._tooltipEvents("enable");
            try {
                var dragArea = this.element.find(".e-draggableworkarea");
                this.resizeStart = false;
                $(document).off(ej.eventType.mouseMove, $.proxy(this._appointmentResizing, this));
                $(document).off(ej.eventType.mouseUp, $.proxy(this._appointmentResizeStop, this));
                var model = this._appointmentSettings;
                var workcell = this.element.find(".e-workcellstab");
                var scheduleHeight = workcell.find("tr").length * this.element.find(".e-workcells").height();
                var appointDiv = $(e.target).hasClass("e-appointment") || $(e.target).hasClass("e-monthappointment") || $(e.target).hasClass("e-alldayappointment") ? $(e.target) : $(e.target).parents(".e-appointment,.e-alldayappointment,.e-monthappointment");
                (appointDiv.length == 0) && (appointDiv = this._appointdata);
                if (appointDiv.attr("data-guid") != this._appointdata.attr("data-guid")) { appointDiv = this._appointdata; }
                this._appUid = appointDiv.attr("data-guid");
                var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                var twoDayApps = tempApp.length > 1 ? true : false;
                var appoint = ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? tempApp[0] : this._getAppointmentByParentId(this._appUid));
                var noOfDays = (this.currentView() === "week" || this.currentView() === "month" || this._isCustomMonthView()) ? this.model.showWeekend ? 7 : this.model.workWeek.length : this.currentView() === "workweek" && this.model.workWeek.length > 0 ? this.model.workWeek.length : 1;
                noOfDays = (this.currentView() == "customview" && this._renderDays <= 7) ? this._renderDays : noOfDays;
                if (this._resWorkWeek) {
                    var resDates;
                    var resObj = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, tempApp[0][this._appointmentSettings.resourceFields.split(",")[this._appointmentSettings.resourceFields.split(",").length - 1]]));
                    if (!ej.isNullOrUndefined(resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]]))
                        resDates = resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]];
                    else
                        resDates = this.model.workWeek;
                    noOfDays = resDates.length;
                }
                if (this._resCustomView) {
                    var resDates;
                    var resObj = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, tempApp[0][this._appointmentSettings.resourceFields.split(",")[this._appointmentSettings.resourceFields.split(",").length - 1]]));
                    if (!ej.isNullOrUndefined(resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]])) {
                        resDates = resObj[0][this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"]];
                        if (!ej.isNullOrUndefined(resDates) && $.type(resDates[0]) == "object") {
                            noOfDays = this._getMultipleCustomDatesCount(resDates);
                        } else
                            noOfDays = resDates.length;
                    }
                }
                if (appoint != null || appoint !== undefined) {
                    var bigApps = appoint[this._appointmentSettings["startTime"]].getDate() < new Date(appoint[this._appointmentSettings["endTime"]]).getDate() ? true : false;
                    var newStartTime = new Date(appoint[this._appointmentSettings["startTime"]]);
                    var newEndTime = new Date(appoint[this._appointmentSettings["endTime"]]);
                    if (twoDayApps && tempApp[0][model["recurrence"]]) {
                        var splitObj = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempApp[0].Guid)));
                        newStartTime = new Date(splitObj[0][this._appointmentSettings["startTime"]]);
                        newEndTime = new Date(splitObj[1][this._appointmentSettings["endTime"]]);
                    }
                    else if (tempApp[0][model["recurrence"]]) {
                        newStartTime = new Date(tempApp[0][this._appointmentSettings["startTime"]]);
                        newEndTime = new Date(tempApp[0][this._appointmentSettings["endTime"]]);
                    }
                    this.element.find('div[data-guid=' + tempApp[0]["Guid"] + ']').removeClass("e-selectedAppointment");
                    var StartTime = appoint[this._appointmentSettings["startTime"]];
                    var EndTime = appoint[this._appointmentSettings["endTime"]];
                    var resizeElmntHeight = $(appointDiv[0]).outerHeight();

                    var cellHeight = this.element.find(".e-workcells").outerHeight();
                    if (this.currentView() !== "month" && !(this._isCustomMonthView())) {
                        var appTop = $(appointDiv[0]).offset().top;
                        var resizeMax = dragArea.height() + dragArea.scrollTop();
                        var topPos = appTop - dragArea.offset().top + dragArea.scrollTop();
                        var resizeMaxTop = (topPos - (cellHeight / this.model.timeScale.minorSlotCount)) < resizeMax ? topPos : resizeMax - resizeElmntHeight;
                    }
                    resizeMaxTop = ej.isNullOrUndefined(resizeMaxTop) ? 0 : resizeMaxTop;
                    var cellCount = ($(appointDiv[0]).outerHeight() / cellHeight);
                    var cellDiff = (resizeMaxTop + (cellCount * cellHeight)) * this.model.timeScale.majorSlot / ((this.model.timeScale.minorSlotCount) * (cellHeight)) / 30;
                    var difHeight = resizeElmntHeight - parseInt(cellDiff);
                    var apptotheight = resizeMaxTop + difHeight;
                    if (this._topResizing) {
                        var splitTopResize = this._topResizing;
                        if (resizeMaxTop > 0) {
                            newStartTime = this._resizeNewStartTime;
                        }
                        else {
                            newStartTime.setHours(0, 0, 0);
                        }
                        this._topResizing = false;
                    }
                    else if (this._bottomResizing) {
                        var splitBottomResize = this._bottomResizing;
                        if (resizeMaxTop >= 0 && apptotheight < scheduleHeight) {
                            newEndTime = this._resizeNewEndTime;
                        }
                        else {
                            newEndTime.setHours(23, 59, 59);
                        }
                        this._bottomResizing = false;
                    }
                    else if (this._leftResizing) {
                        if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                            var index = (!this.model.group) ? 0 : (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 1].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 2].trim()]);
                            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                                !this.model.enableRTL ? newStartTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime) : newEndTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime);
                            }
                            else {
                                var cellsLeft = !this.model.enableRTL ? ($(this.element.find(".e-monthcells")[index * noOfDays]).offset().left) : $(this.element.find(".e-monthcells")[(index + 1) * noOfDays - 1]).offset().left;
                                if ($(appointDiv[0]).offset().left > cellsLeft) {
                                    if (!this.model.enableRTL) {
                                        this._resize = true;
                                        newStartTime = new Date(this._firstweekdate(new Date(tempApp[0][model["startTime"]])));
                                        this._resize = false;
                                        var diffDays = Math.round(($(appointDiv[0]).offset().left - $(this.element.find(".e-monthcells")[index * noOfDays]).offset().left) / this.element.find(".e-monthcells").width());
                                        if (this.model.showWeekend) {
                                            newStartTime.setDate(newStartTime.getDate() + diffDays);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                        else {
                                            var showWeekDays = this._getWeekDays();
                                            while (showWeekDays.indexOf(newStartTime.getDay()) < 0) {
                                                newStartTime = new Date(new Date(newStartTime).getTime() + (1000 * 60 * 60 * 24));
                                            }
                                            var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newStartTime = new Date(this._dateRender[dateIndex]);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                    }
                                    else {
                                        if (this.model.showWeekend) {
                                            var diffDays = Math.round(($(appointDiv[0]).width() - this.appoint_width) / (this.element.find(".e-monthcells").width()));
                                            newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                        else {
                                            var showWeekDays = this._getWeekDays();
                                            while (showWeekDays.indexOf(newEndTime.getDay()) < 0) {
                                                newEndTime = new Date(new Date(newEndTime).getTime() + (1000 * 60 * 60 * 24));
                                            }
                                            var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newEndTime = new Date(this._dateRender[dateIndex]);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                    }
                                }
                            }
                        }
                        else {
                            if ($(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left < $(appointDiv[0]).offset().left)
                                var diffLeft = $(appointDiv[0]).offset().left - this._appointleft;
                            else
                                var diffLeft = $(this.element.find('.e-workcells.e-childworkcell')[0]).offset().left - this._appointleft;
                            if (this.model.enableRTL) {
                                var diff = $(appointDiv[0]).width() - this.appoint_width;
                                diffLeft = -diff;
                            }
                            if (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) {
                                var diffDays = Math.round(diffLeft / (this.element.find(".e-workcells").width() + 1));
                                this._diffDays = Math.round($(appointDiv[0]).width() / (this.element.find(".e-workcells").width()));
                                if (!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) {
                                    var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) + diffDays;
                                    var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newStartTime).getHours(), new Date(newStartTime).getMinutes(), new Date(newStartTime).getSeconds()));
                                    newStartTime = new Date(findDate);
                                } else {
                                    if (this.model.showWeekend) {
                                        newStartTime.setDate(new Date(newStartTime).getDate() + diffDays);
                                    }
                                    else {
                                        var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) + diffDays;
                                        var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newStartTime).getHours(), new Date(newStartTime).getMinutes(), new Date(newStartTime).getSeconds()));
                                        newStartTime = new Date(findDate);
                                    }
                                }
                            }
                            else {
                                newStartTime = this._resizeNewStartTime;
                            }
                        }
                        this._leftResizing = false;
                    }
                    else if (this._rightResizing) {
                        if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                            var index = (!this.model.group) ? 0 : (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1]], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 1].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], appoint[this._appointmentSettings.resourceFields.split(',')[this._tempResource.length - 2].trim()]);
                            if (this.currentView() !== "month" && !(this._isCustomMonthView()) && this.model.timeScale.enable) {
                                (!this.model.enableRTL) ? newEndTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime) : newStartTime = this._leftRightResize(document, appointDiv, index, noOfDays, StartTime, EndTime);
                            }
                            else {
                                var cellwidth = this.element.find(".e-monthcells").width();
                                var cellsLeft = this.model.enableRTL ? ($(this.element.find(".e-monthcells")[(index) * noOfDays]).offset().left + cellwidth) : (index == this.res1.length - 1) ? $(this.element.find(".e-monthcells")[(index + 1) * noOfDays - 1]).offset().left + cellwidth : $(this.element.find(".e-monthcells")[(index + 1) * noOfDays]).offset().left;
                                if (cellsLeft >= ($(appointDiv[0]).offset().left + $(appointDiv[0]).width())) {
                                    var diffDays = this._diffDays = Math.round(($(appointDiv[0]).width() - this.appoint_width) / cellwidth);
                                    if (!this.model.enableRTL) {
                                        if (this.model.showWeekend) {
                                            newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                        else {
                                            var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                            newEndTime = new Date(this._dateRender[dateIndex]);
                                            newEndTime.setHours(new Date(EndTime).getHours(), new Date(EndTime).getMinutes(), new Date(EndTime).getSeconds());
                                        }
                                    }
                                    else {
                                        if (this.model.showWeekend) {
                                            newStartTime.setDate(new Date(newStartTime).getDate() - diffDays);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                        else {
                                            var dateIndex = this._dateRender.indexOf(new Date(newStartTime).setHours(0, 0, 0, 0)) - diffDays;
                                            newStartTime = new Date(this._dateRender[dateIndex]);
                                            newStartTime.setHours(new Date(StartTime).getHours(), new Date(StartTime).getMinutes(), new Date(StartTime).getSeconds());
                                        }
                                    }
                                }
                            }
                        }
                        else {
                            var diffWidth = (this.model.endHour - this.model.startHour === 24) ? $(appointDiv[0]).width() - this.appoint_width : $(appointDiv[0]).width();
                            if (this.currentView() == "month" || (this._isCustomMonthView()) || !this.model.timeScale.enable) {
                                var diffWidth = $(appointDiv[0]).width() - this.appoint_width;
                                var diffDays = Math.round(diffWidth / (this.element.find(".e-workcells").width() + 1));
                                this._diffDays = Math.round($(appointDiv[0]).width() / (this.element.find(".e-workcells").width()));
                                if (!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) {
                                    var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                    var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newEndTime).getHours(), new Date(newEndTime).getMinutes(), new Date(newEndTime).getSeconds()));
                                    newEndTime = new Date(findDate);
                                } else {
                                    if (this.model.showWeekend) {
                                        newEndTime.setDate(new Date(newEndTime).getDate() + diffDays);
                                    }
                                    else {
                                        var dateIndex = this._dateRender.indexOf(new Date(newEndTime).setHours(0, 0, 0, 0)) + diffDays;
                                        var findDate = new Date(new Date(this._dateRender[dateIndex]).setHours(new Date(newEndTime).getHours(), new Date(newEndTime).getMinutes(), new Date(newEndTime).getSeconds()));
                                        newEndTime = new Date(findDate);
                                    }
                                }
                            }
                            else {
                                newEndTime = this._resizeNewEndTime;
                            }
                        }
                        this._rightResizing = false;
                    }
                    if ((newStartTime >= newEndTime) || $(appointDiv[0]).width() == 0) {
                        newStartTime = tempApp[0][model["startTime"]];
                        newEndTime = tempApp[0][model["endTime"]];
                    }
                    if (newStartTime.getTime() == tempApp[0][model["startTime"]].getTime() && newEndTime.getTime() == tempApp[0][model["endTime"]].getTime()) {
                        if (this.element.find("#cloneElement").length > 0) {
                            var height = (this.element.find(".e-monthappointment").length > 1) ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height();
                            if (this.model.enableRTL)
                                this._curElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({ 'width': this.element.find("#cloneElement").width(), 'height': height, 'top': this.element.find("#cloneElement").css('top'), 'right': this.element.find("#cloneElement").css('right') });
                            else
                                this._curElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({ 'width': this.element.find("#cloneElement").width(), 'height': height, 'top': this.element.find("#cloneElement").css('top'), 'left': this.element.find("#cloneElement").css('left') });
                            this._curElmt.find(".e-apptext").replaceWith(this.element.find("#cloneElement").find(".e-apptext")).prop("style", false);
                            this._curElmt.find(".e-apptime").html(this.element.find("#cloneElement").find(".e-apptime").text()).prop("style", false);
                            this._curElmt.css("width", this.element.find("#cloneElement")[0].style.width);
                            if (this._curElmt.hasClass("e-alldayappointment")) this._curElmt.height(19);
                            this.element.find("#cloneElement").remove();
                            $(appointDiv[0]).find('.e-schedulemouseclosetemp').addClass('e-schedulemouseclose e-icon').removeClass('e-schedulemouseclosetemp');
                        }
                        return false;
                    }
                    (this.element.find("#cloneElement").length > 0) && this.element.find('#cloneElement').remove();
                    this._refreshCellsHeight();
                    var currentMonth = new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1);
                    var maxdate = new Date(new Date(this.model.maxDate).getTime()).setHours(23, 59, 59);
                    var otherMonth = (!this.model.showNextPrevMonth && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month") ? currentMonth.getTime() != new Date(newStartTime.getFullYear(), newStartTime.getMonth(), 1).getTime() || currentMonth.getTime() != new Date(newEndTime.getFullYear(), newEndTime.getMonth(), 1).getTime() : false;
                    if (!otherMonth && (newEndTime >= new Date(this.model.minDate)) && (newEndTime <= maxdate)) {
                        if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1) {
                            var index, reverse = false;
                            var recList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                            var _appList = $.extend(true, {}, recList[0]);
                            _appList[this._appointmentSettings["endTime"]] = recList[recList.length - 1][this._appointmentSettings["endTime"]];
                            var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                            var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                            var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                            if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                            var recurColl = this._appointmentRecurrenceSort(recurColl);
                            var _newAddList = $.extend({}, tempApp[0]);
                            if (twoDayApps) _newAddList = $.extend({}, recurColl.filter(function (a) { return a.Guid == tempApp[0].Guid; })[0]);
                            (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, _appList));
                            if (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                                _newAddList[model["startTime"]] = _appList[model["startTime"]];
                                _newAddList[model["endTime"]] = _appList[model["endTime"]];
                                this._alertDragResizeError();
                                reverse = true;
                            }
                            else {
                                var prvStartTime = _newAddList[model["startTime"]];
                                var prvEndTime = _newAddList[model["endTime"]];
                                _newAddList[model["startTime"]] = new Date(newStartTime);
                                _newAddList[model["endTime"]] = new Date(newEndTime);
                                var avail = this._checkAvailability(_newAddList);
                                var eventTarget = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("resizeStop") != -1)) ? { type: e.type } : e;
                                if (this._trigger("resizeStop", { appointment: _newAddList, target: eventTarget }) || avail.length > 0) {
                                    this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                                    _newAddList[model["startTime"]] = new Date(prvStartTime);
                                    _newAddList[model["endTime"]] = new Date(prvEndTime);
                                    reverse = true;
                                }
                                else {
                                    var maxId = this.model.enableLoadOnDemand ? this._dataCount : this._appMainId + 1;
                                    var Parid = _newAddList[model["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[model["recurrenceId"]];
                                    this._deleteOcurrence(Parid, new Date(_appList[model["startTime"]]));
                                    _newAddList[model["recurrenceRule"]] = tempApp[0][model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList["ParentId"];
                                    _newAddList[model["id"]] = _newAddList["AppTaskId"] = maxId;
                                }
                            }
                            var temp = [], _editApp = [];
                            temp.push(this._timeZoneAppointments(_newAddList, ""));
                            var parid = _newAddList[this._appointmentSettings["recurrenceId"]] == null ? _newAddList["ParentId"] : _newAddList[this._appointmentSettings["recurrenceId"]];
                            var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, parid));
                            _editApp.push(this._timeZoneAppointments(_App[0], ""));
                            var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            (!reverse) && (promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable));
                            var updateTempNew = [];
                            for (var c = 0; c < temp.length; c++) {
                                updateTempNew = this._timeZoneAppointments(temp[c], "reverse");
                                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                            }
                            var updateTempNew1 = [];
                            for (var c = 0; c < _editApp.length; c++) {
                                updateTempNew1 = this._timeZoneAppointments(_editApp[c], "reverse");
                                new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew1);
                            }
                            if (!reverse) {
                                if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(_newAddList);
                                var filterCollection = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                this._appointmentProcessing(_newAddList);
                                this._appointmentRemove(_newAddList);
                                this._currentViewAppointments = this._appointmentCount();
                                var collection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                for (var e = 0, len = collection.length; e < len; e++) {
                                    this._refreshDayAppointments(collection[e]);
                                }
                            }
                            else {
                                this._appointmentRemove(_newAddList);
                                var filterCollection = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: filterCollection }, "Guid");
                                for (var e = 0, len = filterCollection.length; e < len; e++) {
                                    this._refreshDayAppointments(filterCollection[e]);
                                }
                            }
                            this._trigger("actionComplete", { data: _newAddList, requestType: "appointmentResize" });
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                var proxy = this;
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                        proxy._processUrlBinding(e);
                                    }
                                    else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                        if (value.added.length > 0) {
                                            proxy._dateFormat(value.added);
                                            for (var a = 0, len = value.added.length; a < len; a++) {
                                                _newAddList[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                                new ej.DataManager(proxy._processed).update("Guid", _newAddList);
                                            }
                                        }
                                    }
                                });
                                promise.fail(function (e) {
                                    proxy._renderAppointmentAll();
                                });
                            }
                        }
                        else {
                            var index, reverse = false, appointSource = (twoDayApps) ? this._currentAppointmentData : this._processed;
                            var object = new ej.DataManager(appointSource).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appoint.Guid));
                            var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, object[0].ParentId));
                            if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                            var recurColl = this._appointmentRecurrenceSort(recurColl);
                            var _updateList = $.extend({}, object[0]);
                            (this.model.enableRecurrenceValidation && _updateList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, object[0]));
                            if (this.model.enableRecurrenceValidation && _updateList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                                _updateList[model["startTime"]] = object[0][model["startTime"]];
                                _updateList[model["endTime"]] = object[0][model["endTime"]];
                                this._alertDragResizeError();
                                reverse = true;
                            }
                            else {
                                var prevStartTime = _updateList[model["startTime"]];
                                var prevEndTime = _updateList[model["endTime"]];
                                _updateList[model["startTime"]] = newStartTime;
                                _updateList[model["endTime"]] = newEndTime;
                                var avail = this._checkAvailability(_updateList);
                                var eventTarget = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("resizeStop") != -1)) ? { type: e.type } : e;
                                if (this._trigger("resizeStop", { appointment: _updateList, target: eventTarget }) || avail.length > 0) {
                                    this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                                    _updateList[model["startTime"]] = prevStartTime;
                                    _updateList[model["endTime"]] = prevEndTime;
                                    reverse = true;
                                }
                            }
                            var temp = this._timeZoneAppointments(_updateList, "");
                            var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                            (!reverse) && (promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable));
                            var updateTemp = this._timeZoneAppointments(temp, "reverse");
                            new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                            if (twoDayApps) {
                                var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, _updateList["Guid"]));
                                new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                                this._appointmentProcessing(_updateList);
                            }
                            else {
                                new ej.DataManager(this._processed).update("Guid", _updateList);
                                new ej.DataManager(this._renderedApp).remove("Guid", _updateList);
                                new ej.DataManager(this._renderedAllDay).remove("Guid", _updateList);
                            }
                            this._appointmentRemove(_updateList);
                            this._currentViewAppointments = this._appointmentCount();
                            var collection = this._currentViewAppointments.filter(function (obj) { return obj.Guid == _updateList.Guid; });
                            for (var e = 0, len = collection.length; e < len; e++) {
                                this._refreshDayAppointments(collection[e]);
                            }
                            this._trigger("actionComplete", { data: _updateList, requestType: "appointmentResize" });
                            this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                            if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                                var proxy = this;
                                promise.done(function (e) {
                                    var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                                    if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                        proxy._processUrlBinding(e);
                                    }
                                });
                                promise.fail(function (e) {
                                    proxy._renderAppointmentAll();
                                });
                            }
                        }
                    }
                    else
                        this._renderAppointmentAll();
                }
                this.element.find("div.e-tophandle,div.e-bottomhandle").removeClass("e-rowcursor");
                this.element.find("div.e-lefthandle,div.e-righthandle").removeClass("e-columncursor");
            } catch (e) {

            }
        },
        _dragdropAppointments: function () {
            if (this.model.readOnly)
                return false;
            this._topResizing = false;
            this._bottomResizing = false;
            this._leftResizing = false;
            this._rightResizing = false;
            var appointdiv;
            if (this.model.allowDragAndDrop) {
                var proxy = this;
                var $dragableElements = this.element.find(".e-appointment");
                $dragableElements.ejDraggable({
                    handle: ".e-appointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element.find("div.e-draggableworkarea", (".e-headrealldaytable tr")[(!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._grouping.length + 1 : 1]) : $(proxy.model.appointmentDragArea),
                    cursorAt: (proxy.model.appointmentDragArea == "") ? { top: 0, left: 0 } : { top: -40, left: -40 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-appointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-appointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
                var $dragableElements = this.element.find(".e-alldayappointment");
                $dragableElements.ejDraggable({
                    handle: ".e-alldayappointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element : $(proxy.model.appointmentDragArea),// proxy.element.find((".e-headrealldaytable tr")[(!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length!=0)) ? this._grouping.length + 1 : 1],"div.e-draggableworkarea"),
                    cursorAt: { top: 17, left: 0 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-alldayappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-alldayappointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
                var $dragableElements = this.element.find(".e-monthappointment");
                $dragableElements.ejDraggable({
                    handle: ".e-monthappointment",
                    dragArea: (proxy.model.appointmentDragArea == "") ? proxy.element.find("div.e-draggableworkarea") : $(proxy.model.appointmentDragArea),
                    cursorAt: (proxy.model.appointmentDragArea == "") ? { top: 0, left: 0 } : { top: -20, left: 10 },
                    dragStart: function (args) {
                        proxy._dragStart(args);
                    },
                    drag: function (args) {
                        proxy._dragOver(args);
                    },
                    dragStop: function (args) {
                        proxy._dragStop(args);
                    },
                    helper: function (event, ui) {
                        appointdiv = $(event.sender.target).hasClass("e-monthappointment") ? $(event.sender.target) : $(event.sender.target).parents(".e-monthappointment");
                        return proxy._appointElement(appointdiv, proxy);
                    }

                });
            }
        },
        _appointElement: function (appointdiv, proxy) {
            var _cloneWidth = ((proxy.model.orientation == "vertical" &&  proxy._customOrientation == "vertical") && appointdiv.hasClass("e-appointment")) ? appointdiv.closest('td').width() * 0.85 : appointdiv.width();
            appointdiv.find('.e-schedulemouseclose').removeClass('e-schedulemouseclose e-icon');
            appointdiv.find('.e-tophandle').removeClass('e-tophandle e-appointresizer-top e-icon e-nsexpand');
            appointdiv.find('.e-bottomhandle').removeClass('e-bottomhandle e-appointresizer-bottom e-icon e-nsexpand');
            appointdiv.find('.e-lefthandle').removeClass('e-lefthandle e-appointresizer-left e-icon e-ewexpand');
            appointdiv.find('.e-righthandle').removeClass('e-righthandle e-appointresizer-right e-icon e-ewexpand');
            appointdiv.clone().prop('id', 'cloneElement').appendTo(appointdiv.parent());
            appointdiv.css('cursor', 'move');
            return (proxy.model.appointmentDragArea == "") ? appointdiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose e-tophandle e-bottomhandle").css("width", _cloneWidth + "px").appendTo(proxy.element) : appointdiv.addClass("e-draggableAppointment e-scheduleAppGlassy").removeClass("e-schedulemouseclose e-tophandle e-bottomhandle").css("width", _cloneWidth + "px").appendTo($(document.body));
        },
        _dragStart: function (args) {
            if ($(args.element[0]).hasClass("e-appointment") || $(args.element[0]).hasClass("e-monthappointment") || $(args.element[0]).hasClass("e-alldayappointment")) {
                this._tooltipEvents("disable");
                (this._mediaQuery || ej.isMobile()) && this._off(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment");
                var target = this._curDragElmt = args.element;
                var model = this._appointmentSettings, appoint;
                this._appUid = $(args.element[0]).attr("data-guid");
                var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                this._dragApp = this._recurrenceAppSort(tempApp);
                if (tempApp[0][this._appointmentSettings["recurrence"]]) {
                    this._recAppGuid = this._appUid;
                    this._recAppId = tempApp[0]["AppTaskId"];
                }
                if (tempApp.length > 1) {
                    var templist = $.extend(true, [], tempApp);
                    templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                    appoint = templist[0];
                } else appoint = tempApp[0];
                var data = { target: target, appointment: appoint };
                if (this._trigger("actionBegin", { data: data, requestType: "appointmentDrag" })) {
                    args.cancel = true;
                    ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                    this._renderAppointmentAll();
                    this._tooltipEvents("enable");
                    (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                    return false;
                }
                if (this._trigger("dragStart", data)) {
                    args.cancel = true;
                    ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                    this._renderAppointmentAll();
                    this._tooltipEvents("enable");
                    (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
                    return false;
                }
            }
            else
                args.cancel = true;
            if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                this._quickAppointWindow.ejDialog("close");
                this._quickAppDetailsWindow.ejDialog("close");
            }
        },

        _dragOver: function (args) {
            var $target = $(args.element);
            var data = { target: $target, interval: 10, timeDelay: 3000, scrollBy: 15 };
            !ej.isNullOrUndefined(this.element.data("ejTooltip")) && this.element.ejTooltip('hide');
            this.element.find(".e-workcells").removeClass("e-selectedCell").removeClass("e-mousehover");
            this._trigger("drag", data);
            this._dragInterval = data.interval;
            this._scrollBy = data.scrollBy;
            this._timeDelay = data.timeDelay;
            var scrollObj = this.element.find("#" + this._id + "_scroller").ejScroller("instance");
            var topValue = this.element.find(".e-draggableworkarea").offset().top;
            var leftValue = this.element.find('.e-draggableworkarea').offset().left;
            var rightValue = Math.round(leftValue + this.element.find(".e-draggableworkarea").width());
            var bottomValue = Math.round(topValue + this.element.find(".e-draggableworkarea").height());			
            if(this.element.find(".e-draggableworkarea").height() > $(window).height() ){
                if (scrollObj._vScroll) {
                    if ((args.element.offset().top) <= $(window).scrollTop()) window.scrollBy(0, -(this._scrollBy));
                    else if (Math.round(args.element.offset().top + args.element.outerHeight()) >= $(window).scrollTop() + $(window).height()) window.scrollBy(0, this._scrollBy);
                }
            }
            if (this.element.find(".e-draggableworkarea").width() > $(window).width()) {
                if (scrollObj._hScroll) {
                    if (args.element.offset().left <= $(window).scrollLeft()) window.scrollBy(-(this._scrollBy), 0);
                    else if (Math.round(args.element.offset().left + args.element.outerWidth()) >= ($(window).width() - (args.element.offset().left + args.element.outerWidth()))) window.scrollBy(this._scrollBy, 0);
                }
            }
            if(this.model.orientation == "vertical" && this._customOrientation == "vertical"){
                if (topValue == args.element.offset().top) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollObj.scrollTop() - this._scrollBy });
                else if (bottomValue == Math.round(args.element.offset().top + args.element.outerHeight()) ) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollTop: scrollObj.scrollTop() + this._scrollBy });     
            }	
            if(scrollObj.isHScroll()){
                if(this.model.enableRTL){
                    if (leftValue == args.element.offset().left) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: (this._horizontalScrollValue - scrollObj.scrollLeft() ) + this._scrollBy });  
                    else if (rightValue == Math.round(args.element.offset().left + args.element.outerWidth())) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: (this._horizontalScrollValue - scrollObj.scrollLeft() ) - this._scrollBy });
                }
                else{
                    if (leftValue == args.element.offset().left) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: scrollObj.scrollLeft() - this._scrollBy }); 
                    else if (rightValue == Math.round(args.element.offset().left + args.element.outerWidth())) this.element.find("#" + this._id + "_scroller").ejScroller({ scrollLeft: scrollObj.scrollLeft() + this._scrollBy });
                }
            }
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.timeScale.enable && this.model.showAllDayRow && this._curDragElmt.hasClass("e-alldayappointment")) {
                var timeScaleWidth = (this.model.timeScale.enable) ? this.element.find(".e-scrolltimecells").width() : 0;
                var leftSide = (timeScaleWidth + this.element.offset().left + 1) >= parseInt(this._curDragElmt.css("left"));
                var rightSide = (this.element.width() + this.element.offset().left) <= (this._curDragElmt.width() + parseInt(this._curDragElmt.css("left")) + (this.element.find("#" + this._id + "_scroller").data("ejScroller").isVScroll() ? 18 : 0));
                var leftIcon = this._curDragElmt.find(".e-leftind").length;
                if (leftSide) {
                    if ((this.element.offset().left + (this.element.find(".e-leftindenttable").length > 0 ? this.element.find(".e-leftindenttable").width() : 0)) >= parseInt(this._curDragElmt.css("left"))) {
                        var noOfDays = Math.floor(args.event.clientX / this.element.find(".e-alldaycells").width());
                        noOfDays = (noOfDays < 1) ? 1 : noOfDays;
                        var dragWidth = (this.element.find(".e-alldaycells").width() * noOfDays) - noOfDays;
                        this._curDragElmt.css({ width: dragWidth });
                    }
                }
                else if (rightSide) {
                    var eleWidth = this.element.width() + this.element.offset().left;
                    var noOfDays = this._dateRender.length - Math.floor(args.event.clientX / this.element.find(".e-alldaycells").width());
                    noOfDays = (noOfDays < 1) ? 1 : noOfDays;
                    var dragWidth = (this.element.find(".e-alldaycells").width() * noOfDays) - noOfDays;
                    this._curDragElmt.css({ width: dragWidth, left: eleWidth - dragWidth });
                }
                else {
                    if (leftIcon > 0) {
                        var dragWidth = Math.floor(args.event.clientX / this.element.find(".e-alldaycells").width()) * this.element.find(".e-alldaycells").width();
                        var dragLeft = this.element.offset().left + ((this.model.timeScale.enable) ? this.element.find(".e-scrolltimecells").width() : 0);
                        this._curDragElmt.css({ width: dragWidth, left: dragLeft });
                    }
                }
            }
            ((this.currentView() != "month" && !this._isCustomMonthView()) && ($(args.element[0]).hasClass("e-appointment") || (!ej.isNullOrUndefined(args.target)) && (!ej.isNullOrUndefined(args.target.className) ?args.target.className.indexOf('e-workcells') > -1 : false))) && this._dragAppointmentCurrentTime(args);
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this._tempResource.length != 0 && this._grouping.length != 0) {
                args.element.css("pointer-events", "none");
                if (this.model.group.resources.length > 1) {
                    var tempTrgt = document.elementFromPoint(args.element.offset().left, args.element.offset().top);
                    var trgtIndex = $(tempTrgt).closest(".e-workcells").parent().index();
                    var trgtElement = $(this.element.find(".e-resourceheadertable tr")[trgtIndex]).children();
                    if (trgtElement.hasClass("e-parentnode")) {
                        if ($(trgtElement.children()[0]).hasClass("e-resourceexpand")) {
                            $(trgtElement.children()[0]).removeClass("e-resourceexpand").addClass("e-resourcecollapse");
                            var grpIndex = $(trgtElement.children()[0]).attr("id").split("_")[0];
                            var resColl = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, grpIndex));
                            for (var a = 0; a < resColl.length; a++) {
                                var newIndex = trgtIndex + a + 1;
                                if ($(this.element.find(".e-resourceheadertable tr")[newIndex]).is(":hidden")) {
                                    $(this.element.find(".e-resourceheadertable tr")[newIndex]).toggle();
                                    $(this.element.find(".e-workcellstab tr")[newIndex]).toggle();
                                }
                            }
                            this.element.find(".e-horires").height(this.element.find(".e-draggableworkarea").height());
                            this._horizontalRender();
                            if (this.model.cellHeight) this._reRenderScroller();
                            this._horizontalResIcon();
                        }
                    }
                }
                args.element.css("pointer-events", "");
            }
            var enableLoadOnDemand = (this.model.enableLoadOnDemand) ? !(this.dataSource() instanceof ej.DataManager) : true;
            if (enableLoadOnDemand) {
                var proxy = this;
                if ($(args.element[0]).hasClass("e-monthappointment")) {
                    this._monthdrag(args);
                }
                function changePrevWeek() {
                    proxy._Prevend = Date.now();
                    var start = new Date(proxy._Prevstart).getSeconds() + parseInt(proxy._timeDelay / 1000);
                    if (start >= 60) start = start - 60;
                    var time = (start == new Date(proxy._Prevend).getSeconds());
                    var edge = (proxy.model.timeScale.enable) ? ((proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal")) ? (proxy.element.offset().left + 1) : (proxy.element.find(".e-scrolltimecells").width() + proxy.element.offset().left + 1) : (proxy.element.offset().left + 1);
                    var drag = edge >= parseInt(proxy.element.find(".e-scheduleAppGlassy").css("left"));
                    drag = ((proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal")) && (proxy.model.timeScale.enable) ? (new Date(proxy._dateRender[0]).getDate() == proxy._dragNewStartTime.getDate()) ? drag : false : drag;
                    if (ej.isNullOrUndefined(proxy._dragNewStartTime)) return false;
                    if (drag && time) {
                        proxy._dragWeek = true;
                        proxy.currentDate(proxy._nextPrevDate("navigateprevious"));
                        proxy._navigateClick(null, "Previous");
                        if (!ej.isNullOrUndefined(proxy._recAppGuid)) {
                            var tempApp = proxy._sortAppById(new ej.DataManager(proxy._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, proxy._recAppId)));
                            tempApp[0].Guid = proxy._recAppGuid;
                            new ej.DataManager(proxy._processed).update("AppTaskId", tempApp[0]);
                        }
                        var strTime = new Date(proxy._dateRender[0]);
                        var endTime = new Date(proxy._dateRender[0]);
                        strTime.setHours(proxy._dragNewStartTime.getHours(), proxy._dragNewStartTime.getMinutes(), proxy._dragNewStartTime.getSeconds());
                        endTime.setHours(proxy._dragNewEndTime.getHours(), proxy._dragNewEndTime.getMinutes(), proxy._dragNewEndTime.getSeconds());
                        proxy._dragNewStartTime = new Date(strTime);
                        proxy._dragNewEndTime = new Date(endTime);
                        proxy._Prevstart = proxy._Nextstart = proxy._Prevend;
                        proxy._Prevend = Date.now();
                        return (proxy.model.appointmentDragArea == "") ? proxy._curDragElmt.appendTo(proxy.element) : proxy._curDragElmt.appendTo($(document.body));
                    }
                }
                if (ej.isNullOrUndefined(this._dragCountPrev)) {
                    this._Prevstart = Date.now();
                    this._dragCountPrev = window.setInterval(changePrevWeek, proxy._timeDelay);
                }
                function changeNextWeek() {
                    proxy._Nextend = Date.now();
                    var start = new Date(proxy._Nextstart).getSeconds() + parseInt(proxy._timeDelay / 1000);
                    if (start >= 60) start = start - 60;
                    var time = (start == new Date(proxy._Nextend).getSeconds());
                    var scroller = $("#" + proxy._id + "_scroller").ejScroller("instance");
                    var scroll = scroller.isVScroll();
                    var edge = (scroll == true) ? proxy.element.find(".e-scheduleAppGlassy").width() + parseInt(proxy.element.find(".e-scheduleAppGlassy").css("left")) - proxy.element.offset().left + 25 : proxy.element.find(".e-scheduleAppGlassy").width() + parseInt(proxy.element.find(".e-scheduleAppGlassy").css("left")) - proxy.element.offset().left + 6;
                    var drag = proxy.element.width() <= edge;
                    drag = ((proxy.model.orientation == "horizontal" || proxy._customOrientation == "horizontal")) && (proxy.model.timeScale.enable) ? (new Date(proxy._dateRender[proxy._dateRender.length - 1]).getDate() == proxy._dragNewEndTime.getDate()) ? drag : false : drag;
                    if (ej.isNullOrUndefined(proxy._dragNewStartTime)) return false;
                    if (drag && time) {
                        proxy._dragWeek = true;
                        proxy.currentDate(proxy._nextPrevDate("navigatenext"));
                        proxy._navigateClick(null, "Next");
                        if (!ej.isNullOrUndefined(proxy._recAppGuid)) {
                            var tempApp = proxy._sortAppById(new ej.DataManager(proxy._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, proxy._recAppId)));
                            tempApp[0].Guid = proxy._recAppGuid;
                            new ej.DataManager(proxy._processed).update("AppTaskId", tempApp[0]);
                        }
                        var strTime = new Date(proxy._dateRender[proxy._dateRender.length - 1]);
                        var endTime = new Date(proxy._dateRender[proxy._dateRender.length - 1]);
                        strTime.setHours(proxy._dragNewStartTime.getHours(), proxy._dragNewStartTime.getMinutes(), proxy._dragNewStartTime.getSeconds());
                        endTime.setHours(proxy._dragNewEndTime.getHours(), proxy._dragNewEndTime.getMinutes(), proxy._dragNewEndTime.getSeconds());
                        proxy._dragNewStartTime = new Date(strTime);
                        proxy._dragNewEndTime = new Date(endTime);
                        proxy._Nextstart = proxy._Prevstart = proxy._Nextend;
                        proxy._Nextend = Date.now();
                        return (proxy.model.appointmentDragArea == "") ? proxy._curDragElmt.appendTo(proxy.element) : proxy._curDragElmt.appendTo($(document.body));
                    }
                }
                if (ej.isNullOrUndefined(this._dragCountNext)) {
                    this._Nextstart = Date.now();
                    this._dragCountNext = window.setInterval(changeNextWeek, proxy._timeDelay);
                }
            }
        },

        _monthdrag: function (args) {
            var model = this._appointmentSettings, dragArea = this.element.find(".e-draggableworkarea"), cellIndex;
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                var apps = $.extend(true, {}, this._dragApp);
                var model = this._appointmentSettings, dragArea = this.element.find(".e-draggableworkarea");
                var splitDrag = ((Math.ceil((apps[model["endTime"]] - apps[model["startTime"]]) / 3600000) < 24) && (apps[model["endTime"]].getDay() != apps[model["startTime"]].getDay())) ? true : false;
                var oldStartTime = new Date(this._dragApp[0][model["startTime"]]);
                var oldEndTime = new Date(this._dragApp[0][model["endTime"]]);
                if ((this._dragApp[0][model["recurrence"]] && this._dragApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                    oldStartTime = this._dragApp[0][model["startTime"]];
                    oldEndTime = this._dragApp[this._dragApp.length - 1][model["endTime"]];
                }
                newStartTime = new Date(new Date(this.model.currentDate).getFullYear(), new Date(this.model.currentDate).getMonth(), 1);
                var daysInPrevMonth = newStartTime.getDay();
                newStartTime.setDate(newStartTime.getDate() - daysInPrevMonth);
                if (this.currentView() == "month" || (this.currentView() == "customview" && !this._oneWeek)) {
                    cellIndex = parseInt(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-monthcells").width());
                    cellIndex = (this.model.enableRTL) ? 7 - cellIndex - 1 : cellIndex;
                }
                else {
                    var noOfCols = !ej.isNullOrUndefined(this.model.group) ? this._dateRender.length * this.res1.length : this._dateRender.length;
                    cellIndex = parseInt(($(args.element[0]).offset().left - dragArea.offset().left) / (Math.round(dragArea.width() / noOfCols)));
                }
                if (splitDrag && (parseInt(args.element.attr("id").split("_")[1]) == this._dragApp[this._dragApp.length - 1]["AppTaskId"])) cellIndex -= 1;
                var newTopDate = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-monthcells").outerHeight()));
                if (!this.model.showOverflowButton) newTopDate = this._findRowIndex(args);
                var dateCount = this.currentView() == "month" || this._isCustomMonthView() && !this._oneWeek ? (this.model.showWeekend) ? 7 : this.model.workWeek.length : this._dateRender.length;
                var index = (this.model.enableRTL) ? (newTopDate * dateCount) + (cellIndex - (Math.floor(cellIndex / dateCount) * dateCount)) - (oldEndTime.getDay() - oldStartTime.getDay()) : (newTopDate * dateCount) + (cellIndex - (Math.floor(cellIndex / dateCount) * dateCount));
                newStartTime = new Date(new Date(this._dateRender[index]).setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds()));
                if (Math.ceil((this._dragApp[0][model["endTime"]] - this._dragApp[0][model["startTime"]]) / 3600000) > 24) {
                    var trgtApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("AppTaskId", ej.FilterOperators.equal, parseInt(args.element.attr('id').split("_")[1])));
                    var multiDif = new Date(trgtApp[0][model["startTime"]]) - new Date(this._dragApp[0][model["startTime"]]);
                    cellstrtime = new Date(newStartTime - multiDif);
                    var diffTime = (newStartTime.getTime() - new Date(oldStartTime).getTime()) - new Date(multiDif).getTime();
                }
                else {
                    cellstrtime = new Date(newStartTime);
                    var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                }
                newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                cellendtime = new Date(newEndTime);
                this._dragNewStartTime = cellstrtime;
                this._dragNewEndTime = cellendtime;
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal) {
                var newStartTime = cellstrtime = this._dragNewStartTime;
                var newEndTime = cellendtime = this._dragNewEndTime;
                this.element.find(".e-appointment,.e-monthappointment").css({ "pointer-events": "none" });
                if (this.model.enableRTL) {
                    var colIndex = (document.elementFromPoint($(args.element[0]).offset().left, $(args.element[0]).offset().top - 1)).cellIndex;
                    colIndex -= Math.round(($(args.element[0]).width() / 30) - 1);
                }
                else
                    var colIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                this.element.find(".e-appointment,.e-monthappointment").css({ "pointer-events": "visible" });
                var rowIndex = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-workcells").outerHeight()));
                if (!this.model.showOverflowButton) rowIndex = this._findRowIndex(args);
                if (this.element.find('.e-resourceheadertable .e-resourceexpand').length > 0)
                    rowIndex += $(this.element.find('.e-resourceheadertable').find('tr').filter(function () { return $(this).css('display') !== 'none'; })[rowIndex]).prevUntil("table.e-resourceheadertable").filter(function () { return $(this).css('display') == 'none'; }).length;
                var target = $(this.element.find(".e-workcellstab tr")[rowIndex]).find("td")[colIndex];
                if (!$(target).hasClass("e-resourceheadercells") && !ej.isNullOrUndefined(target)) {
                    this._cellIndex = (this.model.enableRTL) ? this.element.find(".e-workcells").length - (Math.floor($(args.element[0]).offset().left / this.element.find(".e-workcells").width())) : Math.floor(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                    var cellIndex = rowIndex;
                    if ($(args.element[0]).hasClass("e-monthappointment")) {
                        var oldStartTime = new Date(this._dragApp[0][model["startTime"]]);
                        var oldEndTime = new Date(this._dragApp[0][model["endTime"]]);
                        if ((this._dragApp[0][model["recurrence"]] && this._dragApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                            oldStartTime = this._dragApp[0][model["startTime"]];
                            oldEndTime = this._dragApp[0][model["endTime"]];
                        }
                        else if ((this._dragApp[0][model["recurrence"]] && this._dragApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") > 0)) {
                            oldStartTime = this._dragApp[0][model["startTime"]];
                            oldEndTime = this._dragApp[0][model["endTime"]];
                        }
                        newStartTime = new Date(this.monthDays[colIndex]);
                        newStartTime.setHours(oldStartTime.getHours(), oldStartTime.getMinutes(), oldStartTime.getSeconds());
                        cellstrtime = new Date(newStartTime);
                        var diffTime = newStartTime.getTime() - new Date(oldStartTime).getTime();
                        newEndTime = new Date(new Date(oldEndTime).getTime() + diffTime);
                        cellendtime = new Date(newEndTime);
                        this._dragNewStartTime = cellstrtime;
                        this._dragNewEndTime = cellendtime;
                    }
                }
            }
            if (this.model.orientation == ej.Schedule.Orientation.Vertical && this._customOrientation == "vertical") {
                if (this.currentView() == "month" || (this.currentView() == "customview" && !this._oneWeek)) {
                    cellIndex = parseInt(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-monthcells").width());
                }
                else {
                    cellIndex = parseInt(($(args.element[0]).offset().left - dragArea.offset().left) / (Math.round(dragArea.width() / noOfCols)));
                }
            }
            if (this.model.orientation == ej.Schedule.Orientation.Vertical && this._customOrientation == "vertical") {
                if (this.currentView() == "month" || (this.currentView() == "customview" && !this._oneWeek)) {
                    cellIndex = parseInt(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-monthcells").width());
                }
                else {
                    cellIndex = parseInt(($(args.element[0]).offset().left - dragArea.offset().left) / (Math.round(dragArea.width() / noOfCols)));
                }
            }
            return cellIndex;
        },

        _dragStop: function (args) {
            clearInterval(this._dragCountPrev);
            clearInterval(this._dragCountNext);
            this._dragCountPrev = this._dragCountNext = null;
            this._dragWeek = false;
            (this._mediaQuery || ej.isMobile()) && this._on(this.element, "tap", ".e-appointment,.e-alldayappointment,div.e-monthappointment,.e-agendaappointment", $.proxy(this._appointmentWindow, this));
            this._tooltipEvents("enable");
            if (!ej.isNullOrUndefined(this._quickAppDetailsWindow) && this.model.showQuickWindow) this._quickAppDetailsWindow.ejDialog("close");
            var proxy = this, model = this._appointmentSettings, dragArea = this.element.find(".e-draggableworkarea");
            this._appUid = args.element.attr("data-guid");
            var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
            if (tempApp.length > 1 && !tempApp[0][model["recurrence"]]) {
                var twoDayApps = true;
                var appoint = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
            }
            else {
                var twoDayApps = (tempApp.length > 1) ? true : false;
                var templist = $.extend(true, [], tempApp);
                templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                var appoint = (tempApp[0][model["recurrence"]] && (tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? (tempApp.length > 1) ? templist[0] : tempApp[0] : this._getAppointmentByParentId(this._appUid));
            }
            if ((ej.isNullOrUndefined(this._dragNewStartTime) || ej.isNullOrUndefined(this._dragNewEndTime)) || ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (this.currentView() == "month" || this._isCustomMonthView())) && tempApp.length != 0 && proxy._dragWeek) {
                this._dragNewStartTime = new Date(tempApp[0][this._appointmentSettings["startTime"]]);
                this._dragNewEndTime = new Date(tempApp[tempApp.length - 1][this._appointmentSettings["endTime"]]);
            }
            var apps = $.extend(true, {}, appoint);
            var splitDrag = ((Math.ceil((apps[model["endTime"]] - apps[model["startTime"]]) / 3600000) < 24) && (apps[model["endTime"]].getDay() != apps[model["startTime"]].getDay())) ? true : false;
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                if ($(args.element[0]).hasClass("e-appointment")) {
                    var newStartTime, newEndTime, cellstrtime, cellendtime;
                    newStartTime = cellstrtime = this._dragNewStartTime;
                    newEndTime = cellendtime = this._dragNewEndTime;
                    if ((!ej.isNullOrUndefined(args.target.className) ?args.target.className.indexOf('e-alldaycells') > -1 : false)|| Math.ceil((this._dragNewEndTime.getTime() - this._dragNewStartTime.getTime()) / (60 * 60 * 1000)) >= 24) {
                        var allday = true;
                        cellstrtime = new Date(cellstrtime.setHours(0, 0, 0, 0));
                        cellendtime = new Date(cellendtime.setHours(23, 59, 59, 59));
                    }
                    var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                }
                else if ($(args.element[0]).hasClass("e-alldayappointment")) {
                    if ((!ej.isNullOrUndefined(args.target)) && (!ej.isNullOrUndefined(args.target.className) ?args.target.className.indexOf('e-workcells') > -1 : false)) {
                        var cellIndex = args.target.cellIndex;
                        cellstrtime = this._dragNewStartTime;
                        cellendtime = this._dragNewEndTime;
                        var allday = false;
                        this._allDayDrag = true;
                    }
                    else {
                        newStartTime = new Date(appoint[model["startTime"]]);
                        newEndTime = new Date(appoint[model["endTime"]]);
                        if ((tempApp[0][model["recurrence"]] && tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == -1)) {
                            newStartTime = new Date(tempApp[0][model["startTime"]]);
                            newEndTime = new Date(tempApp[0][model["endTime"]]);
                        }
                        var diffLeft = $(args.element[0]).offset().left + dragArea.scrollLeft() - this.element.find(".e-alldaycells").offset().left - 1;
                        diffLeft = (this.model.enableRTL) ? Math.abs(diffLeft) : diffLeft;
                        var cellIndex = Math.round(diffLeft / (this.element.find(".e-alldaycells").width() + 1));
                        var count = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                        var overall = Math.ceil((newEndTime - newStartTime) / (1000 * 60 * 60 * 24));
                        var endInd = Math.round($(args.element[0]).width() / (this.element.find(".e-alldaycells").width() + 1));
                        var cols = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._renderDays : 1;
                        var firstDate = new Date(newStartTime);
                        var firstIndex = this._dateRender.indexOf(new Date(firstDate).setHours(0, 0, 0));
                        var dateChange = true;
                        if (firstIndex == -1) {
                            var daysCount = Math.ceil(this.element.find("#cloneElement").width() / this.element.find(".e-alldaycells").width()) - Math.ceil(args.element.width() / this.element.find(".e-alldaycells").width());
                            newStartTime.setDate(newStartTime.getDate() - daysCount);
                            newEndTime.setDate(newEndTime.getDate() - daysCount);
                            dateChange = false;
                            cellstrtime = new Date(newStartTime);
                        }
                        else {
                            newStartTime = new Date(this._dateRender[cellIndex]);
                            newEndTime = new Date(this._dateRender[cellIndex]);
                            newEndTime.setHours(appoint[model["endTime"]].getHours(), appoint[model["endTime"]].getMinutes(), appoint[model["endTime"]].getSeconds());
                            var originalDays = Math.ceil(this.element.find("#cloneElement").width() / this.element.find(".e-alldaycells").width());
                            var dragDays = Math.ceil(args.element.width() / this.element.find(".e-alldaycells").width());
                            if (originalDays != dragDays) {
                                var leftSide = this.element.offset().left + (this.element.find(".e-leftindenttable").length > 0 ? this.element.find(".e-leftindenttable").width() : 0) >= parseInt(args.element.css("left"));
                                var noOfDays = (leftSide) ? originalDays - dragDays : 0;
                                newStartTime.setDate(newStartTime.getDate() - noOfDays);
                                dateChange = false;
                                cellstrtime = new Date(newStartTime);
                            }
                        }
                        if (cellIndex < 0 && dateChange) {
                            if (newStartTime <= new Date(this._dateRender[0])) {
                                cellstrtime = new Date(newStartTime);
                                cellstrtime.setDate(cellstrtime.getDate() + cellIndex);
                                cellstrtime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(cellstrtime);
                            }
                            else {
                                var startdate = new Date(this._dateRender[0]);
                                startdate.setDate(startdate.getDate() + cellIndex);
                                startdate.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(startdate);
                            }
                        }
                        else if (dateChange) {
                            if (newStartTime < new Date(this._dateRender[0])) {
                                var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                                (this._resWorkWeek || this._resCustomView) ? newStartTime = new Date(new Date(this._dateRender[cellIndex])) : newStartTime.setDate(new Date(appoint[proxy._appointmentSettings["startTime"]]).getDate() + Index);
                                newStartTime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                                cellstrtime = new Date(newStartTime);
                            }
                            else {
                                var Index = (cellIndex > cols - 1) ? (cellIndex % cols) : cellIndex;
                                cellstrtime = new Date(new Date(this._dateRender[Index]));
                                cellstrtime.setHours(new Date(appoint[model["startTime"]]).getHours(), new Date(appoint[model["startTime"]]).getMinutes());
                            }
                        }
                        var starttime = new Date(cellstrtime);
                        var diff = new Date(appoint[model["endTime"]]).getTime() - new Date(appoint[model["startTime"]]).getTime();
                        cellendtime = new Date(new Date(starttime).setMilliseconds(diff));
                    }
                }
                else if ($(args.element[0]).hasClass("e-monthappointment")) {
                    var cellIndex = this._monthdrag(args);
                    newStartTime = cellstrtime = this._dragNewStartTime;
                    newEndTime = cellendtime = this._dragNewEndTime;
                }
            }
            else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal) {
                var cellIndex = this._monthdrag(args);
                newStartTime = cellstrtime = this._dragNewStartTime;
                newEndTime = cellendtime = this._dragNewEndTime
            }
            if (this.model.orientation == ej.Schedule.Orientation.Horizontal && tempApp[0][model["allDay"]] && this.res1.length > 1 && !(this.currentView() == ej.Schedule.CurrentView.Month || this._isCustomMonthView())) {
                cellstrtime = new Date(tempApp[0][model["startTime"]]);
                cellendtime = new Date(tempApp[0][model["endTime"]]);
            }
            var curLevel = true;
            if (this._grouping.length > 0) {
                var tempList = $.extend(true, {}, tempApp[0]);
                tempList = this._getDragDropResourceData(this, cellIndex, tempList);
                var resLevel = this._appointmentSettings.resourceFields.split(",");
                var curLevel = tempList[this._appointmentSettings.resourceFields.split(",")[resLevel.length - 1]] == tempApp[0][this._appointmentSettings.resourceFields.split(",")[resLevel.length - 1]];
            }
            if (curLevel && !ej.isNullOrUndefined(newStartTime) && new Date(newStartTime).getTime() == new Date(this._dragApp[0][model["startTime"]]).getTime() && new Date(newEndTime).getTime() == new Date(this._dragApp[this._dragApp.length - 1][model["endTime"]]).getTime()) {
                if (this.element.find("#cloneElement").length > 0) {
                    var originElmt = this._curDragElmt.clone();
                    var startTimeDisp = this._timeMode == "12" ? ej.format(tempApp[0][model["startTime"]], this._pattern.t, this.model.locale) : ej.format(tempApp[0][model["startTime"]], "HH:mm", this.model.locale);
                    var endTimeDisp = this._timeMode == "12" ? ej.format(tempApp[0][model["endTime"]], this._pattern.t, this.model.locale) : ej.format(tempApp[0][model["endTime"]], "HH:mm", this.model.locale);
                    originElmt.find(".e-apptime").remove();
                    originElmt.find(".e-appointinnertext").append($("<div class='e-apptime'>" + startTimeDisp + " - " + endTimeDisp + "</div>"));
                    if (this.model.enableRTL)
                        originElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({
                            'width': (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("#cloneElement").outerWidth() : this.element.find("#cloneElement").width(),
                            'height': (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height(),
                            'top': this.element.find("#cloneElement").css('top'),
                            'right': this.element.find("#cloneElement").css('right'),
                            'cursor': ''
                        });
                    else
                        originElmt.removeClass("e-draggableAppointment e-scheduleAppGlassy").css({
                            'width': (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("#cloneElement").outerWidth() : this.element.find("#cloneElement").width(),
                            'height': (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find("#cloneElement").outerHeight() : this.element.find("#cloneElement").height(),
                            'top': this.element.find("#cloneElement").css('top'),
                            'left': this.element.find("#cloneElement").css('left'),
                            'cursor': ''
                        });
                    if (this.model.timeScale.enable && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() != "month" && !this._isCustomMonthView() && !originElmt.hasClass("e-alldayappointment")) {
                        originElmt.children().eq(0).addClass('e-tophandle e-appointresizer-top e-icon');
                        originElmt.children().eq(1).addClass('e-bottomhandle e-appointresizer-bottom e-icon');
                    }
                    else {
                        originElmt.children().eq(0).addClass('e-lefthandle e-appointresizer-left e-icon');
                        originElmt.children().eq(1).addClass('e-righthandle e-appointresizer-right e-icon');
                    }
                    originElmt.children().eq(2).addClass('e-schedulemouseclose e-icon').removeAttr("style");
                    this._bindAppointmentAction();
                }
                ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
                return false;
            }
            var maxdate = new Date(new Date(this.model.maxDate).getTime()).setHours(23, 59, 59);
            var otherMonth = (!this.model.showNextPrevMonth && (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month") ? new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(cellstrtime.getFullYear(), cellstrtime.getMonth(), 1).getTime() : false;
            if (!otherMonth && (cellendtime >= new Date(this.model.minDate)) && (cellendtime <= maxdate)) {
                this._refreshCellsHeight();
                if (appoint[model["recurrence"]] == 1 && appoint[model["recurrenceRule"]].indexOf("RECUREDITID") == -1) {
                    var _appList = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid)));
                    if (_appList.length > 1) {
                        var tempList = $.extend(true, [], _appList);
                        tempList[0][model["endTime"]] = tempList[tempList.length - 1][model["endTime"]];
                    }
                    _appList = (_appList.length > 1) ? tempList[0] : _appList[0];
                    var Parid = _appList[model["recurrenceId"]] == null ? _appList["ParentId"] : _appList[model["recurrenceId"]];
                    var MapValue = _appList[model["recurrenceId"]] == null ? "ParentId" : model["recurrenceId"];
                    var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid));
                    if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                    var recurColl = this._appointmentRecurrenceSort(recurColl);
                    var _newAddList = $.extend({}, _appList), index, reverse = false;
                    (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]]) && (index = this._recuCollectionIndex(recurColl, _appList));
                    if (this.model.enableRecurrenceValidation && _newAddList[model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                        _newAddList[model["startTime"]] = _appList[model["startTime"]];
                        _newAddList[model["endTime"]] = _appList[model["endTime"]];
                        this._alertDragResizeError();
                        reverse = true;
                    }
                    else {
                        var _prevObj = $.extend(true, [], _appList);
                        _newAddList[model["startTime"]] = cellstrtime;
                        _newAddList[model["endTime"]] = cellendtime;
                        if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                            _newAddList = this._getDragDropResourceData(this, cellIndex, _newAddList);
                        if (!ej.isNullOrUndefined(allday)) _newAddList[model["allDay"]] = allday;
                        var avail = this._checkAvailability(_newAddList);
                        var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                        if (this._trigger("dragStop", { appointment: _newAddList, event: eventArgs }) || avail.length > 0) {
                            this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                            _newAddList = $.extend(true, [], _prevObj);
                            reverse = true;
                        }
                        else {
                            this._processed = this._sortAppById(this._processed);
                            var maxId = this.model.enableLoadOnDemand ? this._dataCount : this._appMainId + 1;
                            this._appMainId = maxId;
                            var Parid = appoint[model["recurrenceId"]] == null ? appoint["ParentId"] : appoint[model["recurrenceId"]];
                            this._deleteOcurrence(Parid, _appList[model["startTime"]]);
                            _newAddList[model["recurrenceRule"]] = appoint[model["recurrenceRule"]] + ";RECUREDITID=" + _newAddList["ParentId"];
                            _newAddList[model["recurrenceExDate"]] = appoint[model["recurrenceExDate"]];
                            _newAddList[model["id"]] = _newAddList["AppTaskId"] = maxId;
                        }
                    }
                    var temp = [], _editApp = [];
                    temp.push(this._timeZoneAppointments(_newAddList, ""));
                    var Parid = _newAddList[model["recurrenceId"]] == null ? appoint["ParentId"] : _newAddList[model["recurrenceId"]];
                    var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                    _editApp.push(this._timeZoneAppointments(_App[0], ""));
                    var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? model["id"] : "AppTaskId";
                    (!reverse) && (promise = this._dataManager.saveChanges({ added: temp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable));
                    for (var c = 0; c < temp.length; c++) {
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp[c], "reverse"));
                    }
                    for (var c = 0; c < _editApp.length; c++) {
                        new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(_editApp[c], "reverse"));
                    }
                    if (!reverse) {
                        if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(_newAddList);
                        var removeCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        this._appointmentProcessing(_newAddList);
                        this._appointmentRemove(_newAddList);
                        var currentDrag = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        for (var cd = 0; cd < currentDrag.length; cd++) { this._refreshDayAppointments(currentDrag[cd]); }
                        this._refreshDayAppointments(_prevObj);
                    }
                    else {
                        this._appointmentRemove(_newAddList);
                        var removeCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCol }, "Guid");
                        var dragCol = this._processed.filter(function (obj) { return obj.Guid == _newAddList.Guid; });
                        for (var d = 0; d < dragCol.length; d++) { this._refreshDayAppointments(dragCol[d]); }
                    }
                    this._trigger("actionComplete", { appointment: _newAddList, requestType: "appointmentDrag" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        _newAddList[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", _newAddList);
                                    }
                                }
                            }
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                }
                else {
                    var index, reverse = false, appointSource = (twoDayApps) ? this._currentAppointmentData : this._processed;
                    var object = new ej.DataManager(appointSource).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, tempApp[0]["Guid"]));
                    var _prevObj = $.extend(true, {}, object[0]);
                    var prvcellstrtime = object[0][model["startTime"]];
                    var prvcellendtime = object[0][model["endTime"]];
                    var recurColl = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, object[0].ParentId));
                    if (twoDayApps) { recurColl = this._recurrenceAppSort(recurColl); }
                    var recurColl = this._appointmentRecurrenceSort(recurColl);
                    object[0][model["startTime"]] = cellstrtime;
                    object[0][model["endTime"]] = cellendtime;
                    (this.model.enableRecurrenceValidation) && (index = this._recuCollectionIndex(recurColl, object[0]));
                    if (this.model.enableRecurrenceValidation && object[0][model["recurrence"]] && ((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(newEndTime).setHours(0, 0, 0, 0)).getTime())))) {
                        object[0][model["startTime"]] = prvcellstrtime;
                        object[0][model["endTime"]] = prvcellendtime;
                        this._alertDragResizeError();
                        reverse = true;
                    }
                    else {
                        if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && ej.scheduleFeatures.resources)
                            object[0] = this._getDragDropResourceData(this, cellIndex, object[0]);
                        if (!ej.isNullOrUndefined(allday)) object[0][model["allDay"]] = allday;
                        var avail = this._checkAvailability(object[0]);
                        var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                        if (this._trigger("dragStop", { appointment: object[0], event: eventArgs }) || avail.length > 0) {
                            this._showBlockAlert && (avail.length > 0) && this._alertBlockError();
                            object[0] = $.extend(true, {}, _prevObj);
                            reverse = true;
                        }
                    }
                    if (this.model.appointmentDragArea != "") {
                        var appoint = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                        if (appoint.length == 0) return false;
                    }
                    var temp = this._timeZoneAppointments(object[0], "");
                    var promise, queryId = (this.dataSource() instanceof ej.DataManager) ? model["id"] : "AppTaskId";
                    (!reverse) && (promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable));
                    var updateTemp = this._timeZoneAppointments(temp, "reverse");
                    var objId = (twoDayApps) ? "Guid" : "AppTaskId";
                    new ej.DataManager(this._currentAppointmentData).update(objId, updateTemp);
                    var isBigApp = (new Date(new Date(object[0][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(object[0][model["endTime"]]).setHours(0, 0, 0, 0)).getTime());
                    if (isBigApp || twoDayApps) {
                        var deleteApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, object[0]["Guid"]));
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: deleteApp }, "Guid");
                        this._appointmentProcessing(object[0]);
                    }
                    else {
                        new ej.DataManager(this._processed).update("AppTaskId", object[0]);
                        new ej.DataManager(this._renderedApp).remove("AppTaskId", object[0]);
                        new ej.DataManager(this._renderedAllDay).remove("AppTaskId", object[0]);
                    }
                    this._appointmentRemove(object[0]);
                    var currentFilter = this._processed.filter(function (obj) { return obj.Guid == object[0].Guid; });
                    for (var f = 0; f < currentFilter.length; f++) { this._refreshDayAppointments(currentFilter[f]); }
                    this._refreshDayAppointments(_prevObj);
                    this._trigger("actionComplete", { appointment: object[0], requestType: "appointmentDrag" });
                    this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                    if (!ej.isNullOrUndefined(promise) && promise && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                        });
                        promise.fail(function (e) {
                            proxy._renderAppointmentAll();
                        });
                    }
                }
            }
            else {
                this._renderAppointmentAll();
                var eventArgs = (!ej.isNullOrUndefined(this.model.serverEvents) && (this.model.serverEvents.indexOf("dragStop") != -1)) ? { type: args.type } : args;
                this._trigger("dragStop", { appointment: tempApp[0], event: eventArgs });
            }
            ($(document.body).find(".e-scheduleAppGlassy").length > 0) && $(document.body).find(".e-scheduleAppGlassy").remove();
            (this.element.find('#cloneElement').length > 0) && this.element.find('#cloneElement').remove();
            if (this.model.showAppointmentNavigator && this.model.timeScale.enable) this._nextPrevButton();
        },

        _findRowIndex: function (args) {
            var eleOffset = $(args.element[0]).offset();
            this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "none");
            var element = $(document.elementFromPoint((eleOffset.left - $(document).scrollLeft()), (eleOffset.top - $(document).scrollTop() - 1)));
            var rowIndex = $(element).closest("td").parent().index();
            this.element.find(".e-appointment,.e-monthappointment").css("pointer-events", "visible");
            return rowIndex;
        },

        _alertDragResizeError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("RecurrenceAlert"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("DragResizeError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },

        _processUrlBinding: function (e) {
            if (this.model.enableLoadOnDemand || (this.dataSource() instanceof ej.DataManager && this.dataSource().adaptor instanceof ej.ODataAdaptor))
                this._initDataSource("refresh");
            else {
                var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                this._currentAppointmentData.length = 0;
                this._dateFormat(value);
                this._bindAppointments = true;
                this._currentAppointmentData = $.merge(this._currentAppointmentData, value);
                this._dataProcessing(value);
                this._renderAppointmentAll();
            }
        },

        _refreshCellsHeight: function () {
            if (this.currentView() == "agenda") return false;
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && !this.model.showOverflowButton) {
                this._horizontalRender();
                this._reRenderScroller();
            }
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && !this.model.showOverflowButton && this.currentView() == "month") {
                this._monthCellsRender();
                this._reRenderScroller();
            }
        },

        _dragAppointmentCurrentTime: function (args) {
            var tempApp = this._sortAppById(new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, args.element.attr("data-guid"))));
            var dragArea = this.element.find(".e-draggableworkarea");
            var timesoltduration = parseInt(this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount);
            var proxy = this;
            var model = proxy._appointmentSettings;
            if (!tempApp[0][model["recurrence"]]) {
                var appoint = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
            }
            else {
                var templist = $.extend(true, [], tempApp);
                templist[0][model["endTime"]] = templist[templist.length - 1][model["endTime"]];
                var appoint = (tempApp[0][model["recurrence"]] && (tempApp[0][model["recurrenceRule"]].toString().indexOf("RECUREDITID") == 1)) ? this._getAppointmentByParentId(this._appUid) : (tempApp[0][model["recurrence"]] ? templist[0] : this._getAppointmentByParentId(this._appUid));
            }
            if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && ($(args.element[0]).hasClass("e-appointment") || (!ej.isNullOrUndefined(args.target.className) ?args.target.className.indexOf('e-workcells') > -1 : false))) {
                var dragMax = dragArea.height() + dragArea.scrollTop();
                var dragElmntHeight = args.element[0].offsetHeight;
                var cellHeight = this.element.find(".e-workcells").outerHeight();
                var topPos = $(args.element[0]).offset().top - dragArea.offset().top + dragArea.scrollTop();
                var dragMaxTop = (topPos - (cellHeight / (60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)))) < dragMax ? topPos : dragMax - dragElmntHeight;
                var newStartTime, newEndTime, cellstrtime, cellendtime;
                if ($(args.element[0]).hasClass("e-alldayappointment")) {
                    var cellIndex = args.target.cellIndex;
                    newStartTime = new Date(this.dateRender[cellIndex]);
                    var newTopTime = (dragMaxTop > 0) ? dragMaxTop * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight) : 1 * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight);
                    newStartTime.setHours(parseInt(this.model.startHour) + Math.round(newTopTime / 60));
                    newStartTime.setMinutes(parseInt(newTopTime % 60));
                    newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                    newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                    cellstrtime = new Date(newStartTime);
                    newEndTime = new Date(newStartTime).setMinutes(newStartTime.getMinutes() + (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount));
                    cellendtime = new Date(newEndTime);
                }
                else {
                    if ((dragMaxTop > 0 || !this.model.showAllDayRow) && (!ej.isNullOrUndefined(args.target) && (!ej.isNullOrUndefined(args.target.className) ? args.target.className.indexOf('e-alldaycells') != 1 : true))){
                        var newTopTime = Math.round((dragMaxTop > 0) ? dragMaxTop * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight) : 1 * 60 / ((60 / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * cellHeight));
                        var twoDayApps = (new Date(new Date(appoint[proxy._appointmentSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(appoint[proxy._appointmentSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) ? true : false;
                        if (proxy.currentView() !== "month" && !(proxy._isCustomMonthView())) {
                            var firstDayOfWeek = new Date(proxy._firstweekdate(proxy.currentDate()));
                            if (proxy.currentView() === "workweek" || (proxy.currentView() == "customview" && proxy._renderDays == 5)) {
                                var _day = new Date(firstDayOfWeek).getDay();
                                var _dayAdd = _day == 0 ? 1 : 0;
                                firstDayOfWeek.setDate(firstDayOfWeek.getDate() + _dayAdd);
                            }
                            newStartTime = firstDayOfWeek;
                            var noOfCols = proxy.currentView() === "week" ? this.model.showWeekend ? 7 : this.model.workWeek.length : proxy.currentView() === "workweek" ? this.model.workWeek.length : proxy.currentView() == "customview" ? proxy._renderDays : 1;
                            noOfCols = !ej.isNullOrUndefined(proxy.model.group) ? noOfCols * proxy.res1.length : noOfCols;
                            var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                            newStartTime = (this.model.enableRTL) ? new Date(this.dateRender[noOfCols - cellIndex - 1]) : new Date(this.dateRender[cellIndex]);
                            newEndTime = newStartTime;
                        }
                        else {
                            newStartTime = appoint[model["startTime"]];
                            newEndTime = new Date(newStartTime);
                        }
                        if (twoDayApps) {
                            newStartTime = this._getNewStartTime(newTopTime, newStartTime);
                            cellstrtime = new Date(newStartTime);
                        }
                        else {
                            var min = (newTopTime % 60).toFixed(1);
                            var sec = min.toString().split(".");
                            var milliSec = !ej.isNullOrUndefined(sec[1]) ? ((sec[1] * 60) / 60) : 0;
                            newStartTime.setHours(parseInt(this.model.startHour) + Math.round(newTopTime / 60), parseInt(min.toString().split('.')[0]), milliSec, 0);
                            newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                            (timesoltduration >= this._dragInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                            cellstrtime = new Date(newStartTime);
                        }
                        var diff = new Date(appoint[model["endTime"]]).getTime() - new Date(appoint[model["startTime"]]).getTime();
                        cellendtime = new Date(new Date(newStartTime).setMilliseconds(diff));
                    }
                    else {
                        var noOfCols = this.currentView() === "week" ? 7 : this.currentView() === "workweek" ? this.model.workWeek.length : this.currentView() == "customview" ? this._renderDays : 1;
                        noOfCols = !ej.isNullOrUndefined(this.model.group) ? noOfCols * this.res1.length : noOfCols;
                        var cellIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                        newStartTime = (this.model.enableRTL) ? new Date(this.dateRender[noOfCols - cellIndex - 1]) : new Date(this.dateRender[cellIndex]);
                        cellstrtime = new Date(newStartTime.setHours(0, 0, 0));
                        cellendtime = new Date(newStartTime.setHours(23, 59, 59));
                    }
                }
            }
            else if (((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && $(args.element[0]).hasClass("e-appointment"))) {
                var diffTimeLeft;
                var cellstrtime = new Date(appoint[proxy._appointmentSettings["startTime"]]);
                var cellendtime = new Date(appoint[proxy._appointmentSettings["endTime"]]);
                if (this.model.enableRTL) {
                    var colIndex = (document.elementFromPoint($(args.element[0]).offset().left, $(args.element[0]).offset().top - 1)).cellIndex;
                    colIndex -= Math.round(($(args.element[0]).width() / 30) - 1);
                }
                else
                    var colIndex = Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                this.element.find(".e-appointment,.e-monthappointment").css({ "pointer-events": "visible" });
                var rowIndex = parseInt(($(args.element[0]).offset().top + dragArea.scrollTop() - dragArea.offset().top) / (this.element.find(".e-workcells").outerHeight()));
                if (!this.model.showOverflowButton) rowIndex = this._findRowIndex(args);
                if (this.element.find('.e-resourceheadertable .e-resourceexpand').length > 0)
                    rowIndex += $(this.element.find('.e-resourceheadertable').find('tr').filter(function () { return $(this).css('display') !== 'none'; })[rowIndex]).prevUntil("table.e-resourceheadertable").filter(function () { return $(this).css('display') == 'none'; }).length;
                var target = $(this.element.find(".e-workcellstab tr")[rowIndex]).find("td")[colIndex];
                if (!$(target).hasClass("e-resourceheadercells") && !ej.isNullOrUndefined(target)) {
                    var newStartTime = new Date(this._dateRender[0]);
                    diffTimeLeft = this.model.enableRTL ? (colIndex * 30) : (($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) / $(this.element.find(".e-workcells")[1]).outerWidth();
                    var minStartTime = ((this.model.startHour) + ((colIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) / 60));
                    var minVal = parseInt(((colIndex) / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    minStartTime = (minStartTime >= (this.model.endHour)) ? (Math.round(diffTimeLeft / 60) + (minVal * ((24 - this.model.endHour) + this.model.startHour))) : Math.round(diffTimeLeft / 60);
                    newStartTime.setHours(parseInt(proxy.model.startHour) + minStartTime);
                    newStartTime.setMinutes(parseInt(diffTimeLeft % 60));
                    newStartTime = (new Date(newStartTime).getMinutes() >= 30) ? new Date(new Date(newStartTime).setHours(new Date(newStartTime).getHours() - 1)) : new Date(newStartTime);
                    (timesoltduration >= this._dragInterval) ? newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / this._dragInterval) * this._dragInterval) : newStartTime.setMinutes((newStartTime.getMinutes() / this._dragInterval) * this._dragInterval);
                    cellstrtime = new Date(newStartTime);
                    var startTime = appoint[proxy._appointmentSettings["startTime"]];
                    var endTime = appoint[proxy._appointmentSettings["endTime"]];
                    var duration = (endTime - startTime) / 1000;
                    var hours = Math.floor(duration / 3600);
                    var hourValue = parseInt(args.element.width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot));
                    if (this.currentView() == "workweek" && this.model.workWeek != 5)
                        if (new Date(appoint["StartTime"]).getDay() != new Date(appoint["EndTime"]).getDay()) {
                            var differ = new Date(appoint["EndTime"]).getDay() - new Date(appoint["StartTime"]).getDay();
                            var hours = hours - ((differ - 1) * (this.model.endHour - this.model.startHour));
                        }
                    var minutes = Math.round(Math.floor((duration % 3600) / 60) / this._dragInterval) * this._dragInterval;
                    newEndTime = proxy._getNewEndTime(newStartTime, hourValue, minutes);
                    if (new Date(appoint["StartTime"]).getDay() == new Date(appoint["EndTime"]).getDay() && this.currentView() == "workweek" && this.model.workWeek.length != 5) {
                        totalhrs = newStartTime.getHours() + hours;
                        if (totalhrs > 24) {
                            var index = $.inArray(new Date(newStartTime.getFullYear(), newStartTime.getMonth(), newStartTime.getDate()).getTime(), this._dateRender) + 1;
                            newEndTime.setDate(new Date(this._dateRender[index]).getDate());
                        }
                    }
                    var some = parseInt(colIndex) + (parseInt($(args.element[0]).width() / this.element.find(".e-workcells").width())) - 1;
                    some = parseInt(some / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)));
                    var variable = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? parseInt(parseInt((new Date(newEndTime) - new Date(new Date(new Date(newStartTime).setHours(0, 0, 0, 0)).setHours(this.model.endHour))) / (1000 * 60 * 60)) / (this.model.endHour - this.model.startHour)) : 0;
                    var newStart = new Date(newStartTime);
                    var missDate = this.currentView() == "workweek" ? ((variable - 1) * (this.model.endHour - this.model.startHour)) : 0;
                    minStartTime = (new Date(newEndTime).getHours() >= (this.model.endHour)) ? new Date(new Date(newStart).setHours(new Date(newStartTime).getHours() + missDate + (parseInt($(args.element[0]).width() / this.element.find(".e-workcells").width()) / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))) + (variable * ((24 - this.model.endHour) + this.model.startHour)))) : newEndTime;
                    if (new Date(newEndTime).getHours() >= (this.model.endHour)) minStartTime.setMinutes(new Date(newStartTime).getMinutes() + Math.round(parseInt(diffTimeLeft % 60) / this._dragInterval) * this._dragInterval);
                    if (this.model.endHour - this.model.startHour !== 24) {
                        if (new Date(new Date(minStartTime).setHours(0, 0, 0, 0)).getTime() != new Date(this._dateRender[some]).getTime())
                            minStartTime = new Date(this._dateRender[some]).setHours(new Date(minStartTime).getHours(), new Date(minStartTime).getMinutes(), new Date(minStartTime).getSeconds(), new Date(minStartTime).getMilliseconds());
                    }
                    cellendtime = new Date(minStartTime);
                    this._cellIndex = (this.model.enableRTL) ? this.element.find(".e-workcells").length - (Math.round($(args.element[0]).offset().left / this.element.find(".e-workcells").width())) : Math.round(($(args.element[0]).offset().left + dragArea.scrollLeft() - dragArea.offset().left) / this.element.find(".e-workcells").width());
                }
            }
            args.element.find(".e-apptime").html(ej.format(cellstrtime, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(cellendtime, (this._timeMode == "12") ? this._pattern.t : "HH:mm", this.model.locale)).insertBefore(args.element.find(".e-apptext")).css("font-size", "12px").css("white-space", "normal");
            this._dragNewStartTime = cellstrtime;
            this._dragNewEndTime = cellendtime;
        },
        _unWireDragDrop: function () {
            var dragableElements = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment");
            dragableElements.ejDraggable("destroy");
        },

        _getAppointmentByParentId: function (appId) {
            var tempApp, appoint, appList = this._currentAppointmentData;
            var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, appId));
            var appoint = new ej.DataManager(appList).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, tempApp[0]["ParentId"]));
            return !$.isEmptyObject(appoint) ? appoint[0] : appoint;
        },

        _renderAppointmentAll: function () {
            if (this.element.children().length == 0) return false;
            if (this.currentView() == "agenda")
                this._renderAgendaContent();
            else {
                ej.preferredCulture(this.model.locale);
                this.element.find("div.e-appointwrapper,.e-alldayappointment,.e-scheduleAppGlassy").remove();
                this._currentViewAppointments = this._appointmentCount();
                if (this.currentView() != "month" && (!this._isCustomMonthView()) && this.model.timeScale.enable) {
                    if (this.model.orientation == "vertical" && this._customOrientation == "vertical") this._reRenderScroller();
                    this._renderAppointments();
                    if (this.model.showAppointmentNavigator) {
                        if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.element.find(".e-vscroll").length > 0 && (!this._mediaQuery)) this._renderUpDownIconPosition();
                        this._nextPrevButton();
                    }
                }
                else
                    this._renderMonthAppointment();
                this._bindAppointmentAction();
                if (!this.model.showOverflowButton && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) {
                    var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;
                    this.element.find(".e-horires").css({ top: -restop + "px" });
                }
            }
        },

        _bindAppointmentAction: function () {
            this._unWireResizeEvents();
            this._wireResizeEvents();
            this._dragdropAppointments();
        },

        _renderBlockAppointments: function () {
            this.element.find(".e-blocktimewrapper").remove();
            if (!this.model.blockoutSettings.enable || this.model.blockoutSettings.dataSource instanceof ej.DataManager || this.currentView() == "agenda") return;
            this._processBlockApps();
            var dateCount = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month" ? $.extend(true, [], this.monthDays) : $.extend(true, [], this._dateRender);
            if (!this.model.group) this.res1 = ["0"];
            for (var res = 0; res < this.res1.length; res++) {
                var day = 0, diff, count = dateCount.length;
                if (new Date(dateCount[0]) < this.model.minDate)
                    day = Math.floor((new Date(this.model.minDate) - new Date(dateCount[0])) / (1000 * 60 * 60 * 24));
                if (new Date(dateCount[dateCount.length - 1]) > this.model.maxDate) {
                    diff = Math.floor((new Date(dateCount[dateCount.length - 1]) - new Date(this.model.maxDate)) / (1000 * 60 * 60 * 24));
                    count = dateCount.length - diff;
                }
                if (this._resWorkWeek) {
                    count = 0; day = 0; var temp = 0;
                    for (var a = 0; a < res + 1; a++) {
                        if (!ej.isNullOrUndefined(this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]])) {
                            count += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                            if (a == res) temp += this.res1[a][this._tempResource[this._tempResource.length - 1].resourceSettings["workWeek"]].length;
                        }
                        else {
                            count += this.model.workWeek.length;
                            if (a == res) temp += this.model.workWeek.length;
                        }
                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                if (this._resCustomView) {
                    count = 0; day = 0; var temp = 0;
                    var resCustomSetting = this._tempResource[this._tempResource.length - 1].resourceSettings["renderDates"];
                    for (var a = 0; a < res + 1; a++) {
                        if (!ej.isNullOrUndefined(this.res1[a][resCustomSetting])) {
                            count += this._getCustomDatesCount(a, resCustomSetting);
                            if (a == res) {
                                temp += this._getCustomDatesCount(a, resCustomSetting);
                            }
                        }
                        if (a == res) {
                            day = count - temp;
                            break;
                        }
                    }
                }
                for (day; day < count; day++) {
                    this._getBlockIntervals(day, res, dateCount);
                }
            }
        },

        _processBlockApps: function () {
            this._processedIntervals = [];
            var data = $.extend(true, [], this.model.blockoutSettings.dataSource);
            for (var app = 0; app < data.length; app++) {
                data[app] = this._processtimeZone(data[app]);
                if (new Date(new Date(data[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(data[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())
                    this._blockTimeSplit(data[app], new Date(data[app][this.model.blockoutSettings["startTime"]]), new Date(data[app][this.model.blockoutSettings["endTime"]]));
                else
                    this._processedIntervals.push(data[app]);
            }
        },

        _blockTimeSplit: function (app, startTime, endTime) {
            var start = (new Date(this._dateRender[0]) <= startTime) ? startTime : new Date(this._dateRender[0]);
            var end = new Date(new Date(endTime).getFullYear(), new Date(endTime).getMonth(), new Date(endTime).getDate(), 23, 59, 59);
            var next = 0, differDate, nextDay, day_start, day_end;
            while (start <= end) {
                differDate = 0; day_start = start;
                if (this.currentView() == "month" || this._isCustomMonthView() || (this.currentView() != "agenda" && this.currentView() != "day" && (this.model.orientation == "horizontal" || this._customOrientation == "horizontal"))) {
                    if (((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month"))
                        differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                    else if (this.currentView() == "customview" && (this._renderDays <= 7 || (this.model.orientation == "horizontal" || this._customOrientation == "horizontal"))) {
                        start = (new Date(new Date(day_start).getFullYear(), new Date(day_start).getMonth(), new Date(day_start).getDate()));
                        if (this._dateRender.indexOf(start.getTime()) != -1)
                            differDate = (this._dateRender.length - 1) - this._dateRender.indexOf(start.getTime());
                        else
                            differDate = (start.getTime() < new Date(this._dateRender[0]).getTime()) ? ((new Date(new Date(this._dateRender[0]).setDate(new Date(this._dateRender[0]).getDate() - 1)).getTime() - new Date(start).setHours(0, 0, 0, 0)) / 3600000) / 24 : (start.getTime() > new Date(this._dateRender[this._dateRender.length - 1]).setHours(23, 59, 59)) ? this._dateRender.length - 1 : 0;
                    }
                    else {
                        if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(new Date(this.currentDate()).getFullYear(), new Date(this.currentDate()).getMonth(), 1).getTime() != new Date(start.getFullYear(), start.getMonth(), 1).getTime())
                            differDate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() - (day_start.getDate());
                        else
                            differDate = 6 - day_start.getDay() + this._firstdayofweek;
                        if (this._firstdayofweek > day_start.getDay())
                            differDate = (6 - day_start.getDay()) - (7 - this._firstdayofweek);
                    }
                }
                nextDay = new Date(new Date(start).getFullYear(), new Date(start).getMonth(), new Date(start).getDate() + differDate);
                day_end = (new Date(nextDay).getDate() == new Date(endTime).getDate()) ? new Date(new Date(nextDay).setHours(endTime.getHours(), endTime.getMinutes(), endTime.getSeconds())) : new Date(new Date(nextDay).setHours(23, 59, 59));
                if (day_end >= new Date(endTime))
                    day_end = app[this.model.blockoutSettings["endTime"]];
                if (!this.model.showNextPrevMonth && this.currentView() == "month" && new Date(start.getFullYear(), start.getMonth(), 1).getTime() != new Date(day_end.getFullYear(), day_end.getMonth(), 1).getTime())
                    day_end = new Date(start.getFullYear(), start.getMonth() + 1, 0, day_end.getHours(), day_end.getMinutes(), day_end.getSeconds());
                var data = {};
                data[this.model.blockoutSettings["startTime"]] = day_start;
                data[this.model.blockoutSettings["endTime"]] = day_end;
                this._processedIntervals.push($.extend({}, app, data));
                next = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "workweek" && new Date(this._dateRender[0]).getDay() == 1 && new Date(this._dateRender[this._dateRender.length - 1]).getDay() == 5) ? 3 : 1;
                start = new Date(new Date(day_end).getFullYear(), new Date(day_end).getMonth(), new Date(day_end).getDate() + next);
                if (new Date(this._dateRender[this._dateRender.length - 1]) < start) {
                    break;
                }
            }
        },

        _getBlockIntervals: function (day, res, dateCount) {
            var appointmentsList = this._processedIntervals;
            var predicate2 = ej.Predicate(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(dateCount[day]).setHours(23, 59, 59)));
            var predicate1 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, new Date(dateCount[day])).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, new Date(new Date(dateCount[day]).setHours(23, 59, 59)));
            var predicate = predicate2["or"](predicate1);
            predicate = !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources ? predicate["and"](this.model.blockoutSettings.resourceId, ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["id"]]) : predicate;
            predicate = (this._grouping.length > 1) ? predicate["and"](this.model.blockoutSettings.groupId, ej.FilterOperators.equal, this.res1[res][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]]) : predicate;
            appointmentsList = new ej.DataManager(appointmentsList).executeLocal(new ej.Query().where(predicate));
            for (var app = 0; app < appointmentsList.length; app++) {
                if ((new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(appointmentsList[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
            (new Date(new Date(dateCount[day]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime()) &&
            (new Date(new Date(appointmentsList[app][this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime() <= new Date(new Date(appointmentsList[app][this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                    if (this.currentView() == "month" || this._isCustomMonthView() || !this.model.timeScale.enable)
                        (appointmentsList[app][this.model.blockoutSettings["isAllDay"]]) && this._renderMonthBlockTime(appointmentsList[app], day, res);
                    else
                        this._renderBlockTime(appointmentsList[app], day, res);
                }
            }
        },

        _renderBlockTime: function (record, day, res) {
            var cellHeight = this.element.find(".e-workcells")[0].offsetHeight;
            var startHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.startHour) : 0;
            var endHour = parseInt(this.model.startHour) < parseInt(this.model.endHour) ? parseInt(this.model.endHour) : 24;
            var dateCount = this._getDateCount(res);
            var rStartTime = record[this.model.blockoutSettings["startTime"]];
            var rEndTime = record[this.model.blockoutSettings["endTime"]];
            rStartTime = new Date(rStartTime).getHours() < startHour ? new Date(new Date(rStartTime).setHours(startHour, rStartTime.getMinutes(), rStartTime.getSeconds())) : rStartTime;
            rEndTime = endHour <= rEndTime.getHours() ? new Date(new Date(rEndTime).setHours(endHour, 0, 0)) : rEndTime;
            var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
            if (rStartTime <= rEndTime && (new Date(dateCount[0]).getTime() <= rStartTime.getTime() && new Date(new Date(dateCount[dateCount.length - 1]).setHours(23, 59, 59)) >= rStartTime.getTime())) {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var appWidth = "100%", appHeight, topPosition, leftPosition = 0;
                    appHeight = ((parseFloat(new Date(new Date(rEndTime).getTime()) - new Date(new Date(rStartTime).getTime()))) / (60 * 1000) * (cellHeight * this.model.timeScale.minorSlotCount) / (this.model.timeScale.majorSlot));
                    topPosition = ((parseFloat((((new Date(rStartTime).getHours() * 60)) + new Date(rStartTime).getMinutes() + (new Date(rStartTime).getSeconds() / 60))) - parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - (this.model.startHour * 60)) * cellHeight * (this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                    if (this._resWorkWeek || this._resCustomView)
                        $(this.element.find("td.e-workcells")[((startTime * this.model.timeScale.minorSlotCount) * this.element.find(".e-headercells").length) + day]).append(timeCellhtml);
                    else
                        $(this.element.find("td.e-workcells")[parseInt((startTime * 60) / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * dateCount.length * this.res1.length + day + (dateCount.length * res)]).append(timeCellhtml);
                }
                else {
                    var newResCollection = this._horiGroupCollection(), appHeight = cellHeight, appWidth, topPosition = 0, leftPosition, groupIndex = 0;
                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
                        predicate1 = ej.Predicate(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, record[this.model.blockoutSettings.resourceId]);
                        predicate2 = ej.Predicate(this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, record[this.model.blockoutSettings.groupId]);
                        var predicate = predicate1["and"](predicate2);
                        var templist = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(predicate));
                        groupIndex = this._findResourceIndex(newResCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], templist[0][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]], null, null) + 1;
                    }
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource)) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], null, null) + 1 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this.model.blockoutSettings.groupId]) + 1 : 1;
                    var diffTime, diffDays, diffMinutes, cellIndex;
                    if (new Date(new Date(new Date(record[this.model.blockoutSettings["startTime"]]).setHours(0, 0, 0, 0)).getTime()) < new Date(new Date(new Date(record[this.model.blockoutSettings["endTime"]]).setHours(0, 0, 0, 0)).getTime())) {
                        var endDiffer = (new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.endHour, 0, 0)) && new Date(rEndTime) < new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0))) ? (((this.model.endHour) / 2) * 60) : ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
                        var startDiffer = new Date(rStartTime) > new Date(new Date(rEndTime).setHours(this.model.startHour, 0, 0)) ? (this.model.startHour * 60) : ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
                        var i = 1, rEnd, rStart, end, start, diffTime;
                        rEnd = this._dateRender.indexOf(new Date(rEndTime).setHours(0, 0, 0, 0));
                        rStart = this._dateRender.indexOf(new Date(rStartTime).setHours(0, 0, 0, 0));
                        if (rEnd == -1) {
                            while (i < 7) {
                                if (new Date(this._dateRender[this._dateRender.length - i]).getTime() < new Date(rEndTime).setHours(0, 0, 0, 0)) {
                                    end = this._dateRender.length - i;
                                    endDiffer = this.model.endHour * 60;
                                    break;
                                }
                                else i++;
                            }
                        }
                        else
                            end = rEnd;
                        if (rStart == -1) {
                            start = day;
                            startDiffer = this.model.startHour * 60;
                        }
                        else
                            start = rStart;
                        diffTime = end - start;
                        diffMinutes = ((((diffTime) * ((endHour - startHour)) * 60) - startDiffer) + endDiffer);
                        cellIndex = (((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot) * day) + ((rStart == -1) ? 0 : startTime * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot);
                        appWidth = (((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * this.element.find(".e-workcells").width()) + (diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount))) - 1;
                        if (diffDays > this._dateRender.length) {
                            diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
                            diffMinutes = ((diffDays) * (endHour - startHour) * 60);
                            appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.element.find(".e-workcells").width() + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 3);
                        }
                        leftPosition = (rStart == -1 ? 0 : parseFloat((new Date(rStartTime).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * this.model.timeScale.minorSlotCount / this.model.timeScale.majorSlot);
                    }
                    else {
                        leftPosition = (parseFloat((new Date(rStartTime).getMinutes() + (new Date(rStartTime).getMilliseconds() / 60))) * ($(this.element.find(".e-workcells")[1]).width() * this.model.timeScale.minorSlotCount) / this.model.timeScale.majorSlot) - 1;
                        diffMinutes = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) - ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) + 1;
                        appWidth = diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * this.element.find(".e-workcells").width() + ((diffMinutes / (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) - 2) + 1;
                        cellIndex = (((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount) * (60 / this.model.timeScale.majorSlot) * day) + (startTime * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot));
                    }
					var headerCell = this.element.find(".e-workcellstab tr");
				    var groupIndex = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0 && this._grouping.length > 1) ? this._findResourceIndex(this._horiGroupCollection(), this._tempResource[this._tempResource.length - 2].resourceSettings["id"], record[this.model.blockoutSettings["groupId"].trim()], null, null) + 1 : 0;
				    var resValue = (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0) && this._tempResource[0].resourceSettings.dataSource.length != 0) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings["id"], record[this.model.blockoutSettings["resourceId"]], null, null) + 1 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings["resourceId"].trim()], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this.model.blockoutSettings["groupId"].trim()]) + 1 : 1;
				    celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellIndex);
				    appHeight= celltd.outerHeight();
					appWidth += Math.ceil((rEndTime.getTime() - rStartTime.getTime()) / (1000 * 60 * 60 * 24)) - 1;
                    appWidth = appWidth + "px";
                    var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                    $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("td.e-workcells")[cellIndex]).append(timeCellhtml);
                }
            }
        },
        _generateBlockElement: function (record, appWidth, appHeight, topPosition, leftPosition) {
            var userTempId = (this.model.blockoutSettings.templateId) ? true : false;
            var userTempHtml = userTempId ? this._getUserTemplate(this.model.blockoutSettings.templateId, record) : "";
            var blockClass = record[this.model.blockoutSettings["isBlockAppointment"]] ? "e-blockenable" : '';
            var timeCellhtml = $(this.blockTimeTemplate.render({ id: record[this.model.blockoutSettings["id"]], subject: record[this.model.blockoutSettings["subject"]], appWidth: appWidth, appHeight: appHeight, left: leftPosition, top: topPosition, blockClass: blockClass, customStyle: record[this.model.blockoutSettings["customStyle"]], userTempId: userTempId, userTemplate: userTempHtml }));
            (!ej.isNullOrUndefined(this.model.queryCellInfo)) && this._renderQueryCellInfo("blockAppointment", record, timeCellhtml);
            return timeCellhtml;
        },
        _renderMonthBlockTime: function (record, day, res) {
            var renderDate = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this._dateRender : this.monthDays;
            var startTime = new Date(record[this.model.blockoutSettings["startTime"]]);
            var endTime = new Date(record[this.model.blockoutSettings["endTime"]]);
            var appWidth, appHeight, topPosition = 0, leftPosition = 0, userTempId, userTempHtml, blockClass, timeCellhtml, cellHeight;
            var cellWidth = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.element.find(".e-monthcells").width() : this.element.find(".e-workcells").width();
            var start = new Date(startTime);
            var r_end = new Date(new Date(renderDate[renderDate.length - 1]).setHours(23, 59, 59));
            var end = new Date(endTime) > r_end ? r_end : new Date(endTime);
            var diffInDays = (start.getHours() == 0 && end.getHours() == 0) ? Math.ceil(((new Date(end) - new Date(start)) / (1000 * 3600)) / 24) : Math.ceil(((new Date(end).setHours(23, 59, 59) - new Date(start).setHours(0, 0, 0)) / (1000 * 3600)) / 24);
            if (startTime <= endTime) {
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                    var maxDays = this._firstdayofweek == 0 ? 7 - (new Date(start).getDay()) : 7 - (new Date(start).getDay()) + this._firstdayofweek;
                    diffInDays = diffInDays >= maxDays ? maxDays : diffInDays;
                    var rowPosition = Math.ceil((day + 1) / 7);
                }
                appWidth = (diffInDays * cellWidth)+(Math.ceil((endTime.getTime() - startTime.getTime()) / (1000 * 60 * 60 * 24)) - 1) + "px";
                var resIndex = (this._tempResource.length != 0 && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], null, null) : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this.model.blockoutSettings.groupId]) : 0;
                var cellId = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? ((resIndex * (7) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * 7)) - this._firstdayofweek) : day + 1;
                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && this._firstdayofweek != 0 && new Date(startTime).getDay() < this._firstdayofweek)
                    cellId = (resIndex * (7) + (new Date(startTime).getDay() + 1)) + ((rowPosition - 1) * (this.res1.length * 7)) - this._firstdayofweek + 7;
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical"){
                    cellHeight = $(this.element.find("td.e-monthcells")[cellId - 1]).closest("tr").find(".e-monthcells")[0].offsetHeight;
					appHeight = cellHeight - this.element.find('.e-monthheader').height();
					}
                else {
                    var newResCollection = this._horiGroupCollection(), groupIndex = 0;
                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
                        predicate1 = ej.Predicate(this._tempResource[this._tempResource.length - 1].resourceSettings["id"], ej.FilterOperators.equal, record[this.model.blockoutSettings.resourceId]);
                        predicate2 = ej.Predicate(this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"], ej.FilterOperators.equal, record[this.model.blockoutSettings.groupId]);
                        var predicate = predicate1["and"](predicate2);
                        var templist = new ej.DataManager(this.res1).executeLocal(new ej.Query().where(predicate));
                        groupIndex = this._findResourceIndex(newResCollection, this._tempResource[this._tempResource.length - 2].resourceSettings["id"], templist[0][this._tempResource[this._tempResource.length - 1].resourceSettings["groupId"]], null, null) + 1;
                    }
                    var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this._tempResource)) ? (this._grouping.length == 1) ? this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], null, null) + 1 : this._findResourceIndex(this.res1, this._tempResource[this._tempResource.length - 1].resourceSettings.id, record[this.model.blockoutSettings.resourceId], this._tempResource[this._tempResource.length - 1].resourceSettings.groupId, record[this.model.blockoutSettings.groupId]) + 1 : 1;
                    var headerCell = this.element.find(".e-workcellstab tr");
					celltd = headerCell.eq(resValue + groupIndex - 1).children().eq(cellId-1);
                    appHeight =  celltd.outerHeight();
                }                
                var timeCellhtml = this._generateBlockElement(record, appWidth, appHeight, topPosition, leftPosition);
                var celltd = $(this.element.find("td.e-monthcells")[cellId - 1]);
                if (this.model.orientation == "vertical" && this._customOrientation == "vertical")
                    celltd.find(".e-monthheader").after(timeCellhtml);
                else if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && ej.scheduleFeatures.horizontal)
                    $($(this.element.find(".e-workcellstab tr")[resValue + groupIndex - 1]).find("td.e-workcells")[cellId - 1]).append(timeCellhtml);
            }
        },
        _checkAvailability: function (record) {
            if (this.model.blockoutSettings.enable) {
                var start = new Date(record[this._appointmentSettings["startTime"]]), end = new Date(record[this._appointmentSettings["endTime"]]), resId, available = [];
                if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources)
                    resId = record[this._appointmentSettings.resourceFields.toString().split(',')[this._tempResource.length - 1].trim()];
                var predicate2 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.greaterThanOrEqual, start).and(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThanOrEqual, start).and(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThan, end);
                var predicate1 = ej.Predicate(this.model.blockoutSettings["startTime"], ej.FilterOperators.lessThanOrEqual, start).and(this.model.blockoutSettings["endTime"], ej.FilterOperators.greaterThan, start);
                var predicate = predicate2["or"](predicate1);
                predicate = !ej.isNullOrUndefined(resId) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources ? predicate["and"](this.model.blockoutSettings.resourceId, ej.FilterOperators.equal, resId) : predicate;
                predicate = predicate["and"](this.model.blockoutSettings["isBlockAppointment"], ej.FilterOperators.equal, true);
                available = new ej.DataManager(this._processedIntervals).executeLocal(new ej.Query().where(predicate));
                return available;
            }
            return [];
        },
        _alertBlockError: function () {
            ej.isNullOrUndefined(this._alertWindow) && this._renderAlertWindow();
            this._alertWindow.ejDialog("instance").option("title", this._getLocalizedLabels("BlockIntervalAlertTitle"));
            this._alertWindow.find(".e-alerttext").html(this._getLocalizedLabels("BlockIntervalError"));
            this._alertWindow.find(".e-alertOk").html(this._getLocalizedLabels("Ok"));
            this._alertWindow.ejDialog("open");
        },
        _getNewEndTime: function (newStartTime, hours, minutes) {
            var newEndTime = new Date(newStartTime);
            newEndTime.setMilliseconds(1000 * 60 * 60 * hours);
            return newEndTime;
        },

        _getNewStartTime: function (newTopTime, newStartTime) {
            newStartTime.setHours((newStartTime.getHours()) + parseInt(this.model.startHour) + parseInt(newTopTime / 60));
            newStartTime.setMinutes((newStartTime.getMinutes()) + parseInt(newTopTime % 60));
            newStartTime.setMinutes(Math.round(newStartTime.getMinutes() / 10.0) * 10);
            return newStartTime;
        },

        _documentOnKeyDown: function (event) {
            if (this.model.allowKeyboardNavigation) {
                var oEl = event.target || document.activeElement || event.srcElement;
                if (event.which == 27) {
                    this._processEscapeKey();
                }
                else if (event.which == 13) {
                    this._processEnterKey(oEl);
                }
                else if (event.shiftKey == false && event.which == 9) {
                    this._processWindowTab(oEl);
                }
            }
        },

        _processWindowTab: function (oEl) {
            if ($(oEl).hasClass("e-qAppDone") && !ej.isNullOrUndefined(this._quickAppointWindow))
                this._quickAppointWindow.find(".subject").focus();
            else if (!ej.isNullOrUndefined(this._appointmentAddWindow) && ($(oEl).hasClass("e-appointcancel") || $(oEl).hasClass("e-cancelrecur")))
                this._appointmentAddWindow.find(".subject").focus();
            else if ($(oEl).hasClass("e-editseries") && !ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow)
                this._quickAppDetailsWindow.focus();
        },

        _onKeyDown: function (event) {
            if (this.model.allowKeyboardNavigation) {
                if (!ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) {
                    this._quickAppointWindow.ejDialog("close");
                    this._quickAppDetailsWindow.ejDialog("close");
                }
                var oRowCell = this.element.find('div.e-draggableworkarea tr');
                var oEl = event.target || document.activeElement || event.srcElement;
                $(oEl).hasClass("e-alldaycells") && (oRowCell = this.element.find(".e-alldaycells").parent());
                if (this._trigger("keyDown", { event: event })) return false;
                if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-alldaycells") || $(oEl).hasClass("e-monthcells")) {
                    this._getDateByElement($(oEl));
                    var curDate = this.curDate;
                    (event.which == 39) && curDate.setDate(curDate.getDate() + 1);
                    (event.which == 37) && curDate.setDate(curDate.getDate() - 1);
                    if ((curDate >= this.model.minDate) && (curDate <= this.model.maxDate)) {
                        this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                        if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-alldaycells") || $(oEl).hasClass("e-monthcells"))
                            $(oEl).addClass("e-selectedCell");
                        if (event.shiftKey == false && event.which == 38) { //up arrow navigation
                            this._stopDefaultAction(event);
                            this._processUpArrow(oEl, oRowCell);
                        }
                        else if (event.shiftKey == false && event.which == 40) { //down arrow for cell navigation
                            this._stopDefaultAction(event);
                            this._processDown(oEl, oRowCell);
                        }
                        else if (event.ctrlKey == false && event.shiftKey == false && event.which == 39) { //right arrow cell navigation
                            this._stopDefaultAction(event);
                            this._processRight(oEl, oRowCell);
                        }
                        else if (event.ctrlKey == false && event.shiftKey == false && event.which == 37) { //left arrow cell navigation
                            this._stopDefaultAction(event);
                            this._processLeft(oEl, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 38) { //shift + up arrow
                            this._stopDefaultAction(event);
                            this._processShiftUp(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 40) { //shift + down arrow
                            this._stopDefaultAction(event);
                            this._processShiftDown(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 37) { //shift+left
                            this._stopDefaultAction(event);
                            this._processShiftLeft(oEl, event, oRowCell);
                        }
                        else if (event.shiftKey == true && event.which == 39) { //shift+right
                            this._stopDefaultAction(event);
                            this._processShiftRight(oEl, event, oRowCell);
                        }
                    }
                }
                else if (this.currentView() == "agenda" && $(oEl).hasClass("e-agendacells")) {
                    this._stopDefaultAction(event);
                    if (event.which == 38 || event.which == 40) {
                        this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                        var rowcount = oRowCell.length - 1;
                        var currrowindex = this.element.find(".e-selectedCell").parent().index();
                        var newcur = (event.which == 38) ? parseInt(currrowindex) - 1 : parseInt(currrowindex) + 1;
                        if (newcur >= 0 && newcur <= rowcount && currrowindex != "undefined") {
                            $(oRowCell).find(".e-eventcolumn,.e-timecolumn").removeClass("e-selectedCell");
                            $(oRowCell[newcur]).find(".e-eventcolumn,.e-timecolumn").addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                if (event.altKey == true && event.which == 67) { //Alt+C To show/hide the calendar pane
                    this._stopDefaultAction(event);
                    this.element.find(".e-datedisplay").click();
                }
                else if (event.ctrlKey == true && event.which == 37) { //Previous button
                    this._stopDefaultAction(event);
                    this.element.find("div.e-navigateprevious").click();
                    this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                    this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                }
                else if (event.ctrlKey == true && event.which == 39) { //Next button
                    this._stopDefaultAction(event);
                    this.element.find("div.e-navigatenext").click();
                    this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                    this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                }
                else if ((event.altKey == true && event.which == 107) || (event.altKey == true && event.which == 187) || (event.altKey == true && event.which == 61)) { //Alt + "+" to navigate through the toolbar items
                    this._stopDefaultAction(event);
                    this._navigateToolbarRight(event);
                }
                else if ((event.altKey == true && event.which == 189) || (event.altKey == true && event.which == 109) || (event.altKey == true && event.which == 45) || (event.altKey == true && event.which == 173)) { // Alt + "-" to navigate back through the toolbar items
                    this._stopDefaultAction(event);
                    this._navigateToolbarLeft(event);
                }
                else if (event.ctrlKey == true && event.which == 67) { //Cancel Ctrl+C
                    this._stopDefaultAction(event);
                    this._cancel();
                }
                else if (event.which == 32) { //spacebar
                    if ($(document.activeElement)[0] === this.element.find("div.e-navigateprevious")[0]) {
                        this._stopDefaultAction(event);
                        this.element.find("div.e-navigateprevious").click();
                        this.element.find('div.e-navigateprevious').attr("tabIndex", 0).focus();
                        this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                    }
                    else if ($(document.activeElement)[0] === this.element.find("div.e-navigatenext")[0]) {
                        this._stopDefaultAction(event);
                        this.element.find("div.e-navigatenext").click();
                        this.element.find('div.e-navigatenext').attr("tabIndex", 0).focus();
                        this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
                    }
                }
                else if (event.altKey == true && event.which == 78) { //New appointment window
                    this._stopDefaultAction(event);
                    this.currentView() != "agenda" && this._newAppWindow(oEl, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                else if (event.ctrlKey == true && event.which == 69) { //(E)Edit appointment window
                    this._stopDefaultAction(event);
                    var elmt = this.element.find(".e-selectedAppointment");
                    if (this.currentView() == "agenda" && this.element.find('.e-selectedCell').length > 0) {
                        selCell = this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                        selCell.hasClass("e-agendaappointment") && (elmt = selCell);
                    }
                    if (elmt.length > 0) {
                        this._editKey = true;
                        this._cellClick = false;
                        this._appointmentWindow(elmt);
                        this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                    }
                }
                else if (event.which == 46) { //Delete
                    this._stopDefaultAction(event);
                    var delap = this.element.find('.e-selectedAppointment');
                    if (this.currentView() == "agenda" && this.element.find('.e-selectedCell').length > 0) {
                        var selCell = this.element.find(".e-selectedCell").parent().find(".e-agendaappointment");
                        selCell.hasClass("e-agendaappointment") && (delap = selCell);
                    }
                    if (delap.length > 0) {
                        this._appUid = delap.attr("data-guid");
                        this._deleteAppoint();
                    }
                }
                else if (event.shiftKey == true && event.which == 9) { //Shift + tab for reverse navigation of appointments
                    this._stopDefaultAction(event);
                    this._reverseTab(oEl, event, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                else if (event.shiftKey == false && event.which == 9) { // For tab navigation of appointments
                    this._stopDefaultAction(event);
                    this._processTab(oEl, event, oRowCell);
                    this.element.find("#" + this._id + "_navigator").ejDatePicker("hide");
                }
                var proxy = this;
                this.currentView() != "agenda" && this._moveScrollContent(oEl, proxy);
            }
        },

        _processShiftUp: function (oEl, event, oRowCell) {
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) return false;
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) - 1;
                    if (newcur >= 0) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        else {
                            $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                            $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    this._currentRowIndex = newcur;
                    this._currentColIndex = currcolindex;
                }
                else {
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = currrowindex;
                    this._currentColIndex = currcolindex;
                }

            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resourceIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) - 1;
                    if (newcur >= 0) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            for (var i = currcolindex; i >= mincolindex; i--) {
                                $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                                $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                            }
                            for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                                if (newcur >= 0) {
                                    $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                                }
                            }
                            !$(oRowCell[newcur].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        else {
                            for (var i = currcolindex; i >= mincolindex; i--)
                                $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            for (var j = resmaxcolindex - 1; j >= currcolindex; j--) {
                                if (newcur >= 0)
                                    !$(oRowCell[newcur].cells[j]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                        }
                    }
                    else
                        $(oRowCell[newcur + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            else
                return false;

        },

        _processShiftDown: function (oEl, event, oRowCell) {
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) return false;
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    var newcur = parseInt(currrowindex) + 1;
                    if (newcur <= rowcount) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            $(oRowCell[newcur].cells[currcolindex]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        else {
                            $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell");
                            $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        this._currentRowIndex = newcur;
                        this._currentColIndex = currcolindex;
                    }
                    else {
                        $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                        this._currentRowIndex = currrowindex;
                        this._currentColIndex = currcolindex;
                    }

                }
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resourceIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, resmaxcolindex = 7 * (resourceIndex + 1), mincolindex = 7 * (parseInt(resourceIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    var newcur = parseInt(currrowindex) + 1;
                    if (newcur < (this._dateRender.length) / 7) {
                        if ($(oRowCell[newcur].cells[currcolindex]).hasClass("e-selectedCell")) {
                            for (var i = currcolindex; i <= resmaxcolindex - 1; i++) {
                                $(oRowCell[currrowindex].cells[i]).attr("tabIndex", 0).focus();
                                $(oRowCell[currrowindex].cells[i]).removeClass("e-selectedCell");
                            }
                            for (var j = mincolindex; j <= currcolindex; j++) {
                                if (newcur < (this._dateRender.length) / 7) {
                                    $(oRowCell[newcur].cells[j]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newcur].cells[j]).removeClass("e-selectedCell");
                                }
                            }
                            !$(oRowCell[newcur].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell");
                        }
                        else {
                            for (var i = currcolindex; i <= resmaxcolindex - 1; i++)
                                !$(oRowCell[currrowindex].cells[i]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[i]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            for (var j = mincolindex; j <= currcolindex; j++) {
                                if (newcur < (this._dateRender.length) / 7)
                                    !$(oRowCell[newcur].cells[j]).hasClass("e-othermonths") && $(oRowCell[newcur].cells[j]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                        }
                    }
                    else
                        $(oRowCell[newcur - 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            else
                return false;
        },

        _processShiftLeft: function (oEl, event, oRowCell) {
            var rowcount = oRowCell.length - 1;
            if ($(oEl).hasClass('e-workcells')) {
                var targetElement = oEl;
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var viewCount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot);
                var resIndex = Math.floor($(targetElement).index() / viewCount);
                var resmaxcolindex = (viewCount * resIndex);
                var currColInx = $(targetElement)[0].cellIndex;
                var currRowInx = $(targetElement).parent()[0].rowIndex;
                var leftColInx = currColInx - 1;
                var irowcount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? 0 : currRowInx;
                var Hrowcount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? rowcount : currRowInx;
                var flag = (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showAllDayRow ? true : false;
                var ad = this.element.find(".e-alldaycells").parent();
                if (currColInx > 0 && leftColInx > parseInt(resmaxcolindex) - 1 && currColInx != "undefined") {
                    if ($(oRowCell[currRowInx].cells[leftColInx]).hasClass("e-selectedCell")) {
                        for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                            $(oRowCell[i].cells[currColInx]).removeClass("e-selectedCell");
                        for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                            $(oRowCell[j].cells[leftColInx]).removeClass("e-selectedCell");
                        flag && $(ad[0].cells[currColInx]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                        $(oRowCell[currRowInx].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        for (var i = irowcount; i <= parseInt(currRowInx) ; i++)
                            $(oRowCell[i].cells[currColInx]).addClass("e-selectedCell");
                        for (var j = Hrowcount; j >= parseInt(currRowInx) ; j--)
                            $(oRowCell[j].cells[leftColInx]).addClass("e-selectedCell");
                        if (flag) {
                            $(ad[0].cells[currColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            $(ad[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                        $(oRowCell[currRowInx].cells[leftColInx]).attr("tabIndex", 0).focus();
                    }
                    this._currentRowIndex = currRowInx;
                    this._currentColIndex = leftColInx;
                }
                else {
                    $(oRowCell[currRowInx].cells[leftColInx + 1]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = currRowInx;
                    this._currentColIndex = leftColInx + 1;
                }
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1);
                var mincolindex = 7 * (parseInt(resIndex));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                if (currcolindex >= mincolindex && currcolindex <= mcolind && currcolindex != "undefined") {
                    newcur = parseInt(currcolindex) - 1;
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        if (currcolindex == mincolindex && currrowindex >= 1) {
                            var newrow = parseInt(currrowindex) - 1;
                            var newcol = parseInt(mcolind) - 1;
                            if (newrow >= 0) {
                                $(oRowCell[newrow].cells[newcol]).attr("tabIndex", 0).focus();
                                $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                                $(oRowCell[currrowindex].cells[mincolindex]).removeClass("e-selectedClass");
                            }
                        }
                        else if (currcolindex < mcolind) {
                            newcur = parseInt(currcolindex) - 1;
                            $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                    }
                    else {
                        if (currcolindex == mincolindex && currrowindex >= 0) {
                            var newrow = parseInt(currrowindex) - 1;
                            var newcol = parseInt(mcolind) - 1;
                            if (newrow >= 0)
                                !$(oRowCell[newrow].cells[newcol]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            else
                                $(oRowCell[newrow + 1].cells[currcolindex]).attr("tabIndex", 0).focus();
                        }
                        else if (currcolindex < mcolind) {
                            newcur = parseInt(currcolindex) - 1;
                            !$(oRowCell[currrowindex].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass('e-alldaycells')) {
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var resIndex = Math.floor($(oEl).index() / count);
                var resmaxcolindex = (count * resIndex);
                var currColInx = $(oEl)[0].cellIndex;
                var leftColInx = currColInx - 1;
                if (currColInx > 0 && leftColInx > parseInt(resmaxcolindex) - 1 && currColInx != "undefined") {
                    if ($(oRowCell[0].cells[leftColInx]).hasClass("e-selectedCell")) {
                        $(oRowCell[0].cells[currColInx]).removeClass("e-selectedCell");
                        $(oRowCell[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[leftColInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = leftColInx;
                }
                else {
                    $(oRowCell[0].cells[leftColInx + 1]).attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = leftColInx + 1;
                }
            }
            else
                return false;
        },

        _processShiftRight: function (oEl, event, oRowCell) {
            if ($(oEl).hasClass('e-workcells')) {
                var rowcount = oRowCell.length - 1;
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var viewCount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot);
                var resIndex = Math.floor($(oEl).index() / viewCount);
                var resmaxcolindex = (viewCount * (resIndex + 1));
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                var irowcount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? 0 : currrowindex;
                var Hrowcount = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? rowcount : currrowindex;
                var ad = this.element.find(".e-alldaycells").parent();
                var flag = (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.model.showAllDayRow ? true : false;
                if (currcolindex >= 0 && currcolindex < parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                            $(oRowCell[i].cells[currcolindex]).removeClass("e-selectedCell");
                        for (var j = irowcount; j <= currrowindex; j++)
                            $(oRowCell[j].cells[newcur]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                        flag && $(ad[0].cells[currcolindex]).removeClass("e-selectedCell");
                        $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell");
                    }
                    else {
                        for (var i = parseInt(currrowindex) ; i <= Hrowcount; i++)
                            $(oRowCell[i].cells[currcolindex]).addClass("e-selectedCell");
                        for (var j = irowcount; j <= currrowindex; j++)
                            $(oRowCell[j].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (flag) {
                            $(ad[0].cells[newcur]).addClass("e-selectedCell");
                            $(ad[0].cells[currcolindex]).addClass("e-selectedCell");
                        }
                    }
                    this._currentRowIndex = currrowindex;
                    this._currentColIndex = newcur;
                }
                else
                    $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass('e-monthcells')) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex <= parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[currrowindex].cells[newcur]).hasClass("e-selectedCell")) {
                        if (newcur < mcolind) {
                            $(oRowCell[currrowindex].cells[newcur]).attr("tabIndex", 0).focus();
                            $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell");
                        }
                        if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                            var newrow = parseInt(currrowindex) + 1;
                            currcolindex = mincolindex;
                            if (newrow < (this._dateRender.length) / 7) {
                                !$(oRowCell[newrow].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell").attr("tabIndex", 0).focus();
                                if (newcur < mcolind) {
                                    $(oRowCell[newrow].cells[newcur]).attr("tabIndex", 0).focus();
                                    $(oRowCell[newrow].cells[currcolindex]).removeClass("e-selectedCell");
                                }
                            }
                        }
                    }
                    else {
                        if (newcur < mcolind)
                            !$(oRowCell[currrowindex].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                            var newrow = parseInt(currrowindex) + 1;
                            currcolindex = mincolindex;
                            if (newrow < (this._dateRender.length) / 7) {
                                $(oRowCell[newrow].cells[currcolindex]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                                if (newcur < mcolind)
                                    $(oRowCell[newrow].cells[newcur]).hasClass("e-othermonths") && $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                            }
                            else
                                $(oRowCell[newrow - 1].cells[newcur - 1]).attr("tabIndex", 0).focus();
                        }
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass('e-alldaycells')) {
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var resIndex = Math.floor($(oEl).index() / count);
                var resmaxcolindex = (count * (resIndex + 1));
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex < parseInt(resmaxcolindex) - 1 && currcolindex != "undefined") {
                    if ($(oRowCell[0].cells[newcur]).hasClass("e-selectedCell")) {
                        $(oRowCell[0].cells[currcolindex]).removeClass("e-selectedCell");
                        $(oRowCell[0].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._currentRowIndex = 0;
                    this._currentColIndex = newcur;
                }
                else
                    $(oRowCell[0].cells[currcolindex]).attr("tabIndex", 0).focus();
            }
            else
                return false;
        },

        _processEnterKey: function (oEl) {
            if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
            if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
            if ($(oEl).hasClass("e-workcells") || $(oEl).hasClass("e-monthcells") || $(oEl).hasClass("e-alldaycells")) {
                var tds = this.element.find('td.e-selectedCell');
                var nt = tds.length - 1;
                if (nt == 0) {
                    this._cellSelection(oEl);
                }
                else {
                    this._multipleCellAppointCreation(oEl);
                }
            }
            else if ($(oEl).hasClass("e-inlinetext") || $(oEl).hasClass("e-inlineedit")) {
                this._saveAppointment();
            }
            else if ($(oEl).hasClass("e-detailedapp e-detailedwindow")) {
                this._appointmentWindow(oEl);
            }
            else if ($(oEl).parent().hasClass("e-allday")) {
                var e = this._appointmentAddWindow.find("#" + this._id + "allday").ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: checkedVal });
            }
            else if ($(oEl).parent().hasClass("e-recurrence")) {
                var e = this._appointmentAddWindow.find("#" + this._id + "recurrence").ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find(".recurrence").ejCheckBox({ checked: checkedVal });
                this._recurChecked = checkedVal ? true : false;
                this._repeat(oEl);
            }
            else if ($(oEl).hasClass("e-scheduledelete")) {
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-scheduledelete').click();
            }
            else if ($(oEl).hasClass("e-editevent"))
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editevent').click();
            else if ($(oEl).hasClass(".e-editseries"))
                this.model.showQuickWindow && this._quickAppDetailsWindow.find('.e-editseries').click();
            else if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment"))
                this._cellSelection(oEl);
            else if ($(oEl).parent().hasClass("e-weekday")) {
                var e = this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox("option", "checked");
                var checkedVal = e ? false : true;
                this._appointmentAddWindow.find("#" + $(oEl).children()[0].id).ejCheckBox({ checked: checkedVal });
            }
        },

        _findMinMaxCellIndex: function () {
            var oRowCell = this.element.find('div.e-draggableworkarea tr');
            var rowcount = oRowCell.length - 1;
            var omincolIndex, omaxcolIndex, rowInx, maxrowInx, checkcolindex;
            var curr_View = this.currentView();
            var viewCount = curr_View == "day" ? 1 : curr_View == "workweek" ? this.model.workWeek.length : 7;
            var proxy = this;
            this.element.find('td.e-selectedCell').each(function (index, tdItem) {
                var targetId = $(tdItem).index();
                if (targetId != null && !isNaN(targetId)) {
                    if (omincolIndex == null) {
                        omincolIndex = targetId;
                        rowInx = $(tdItem).parent()[0].rowIndex;
                    }
                    else if (omincolIndex < targetId) {
                        omincolIndex = omincolIndex;
                    }
                    else {
                        if (omincolIndex != targetId) {
                            omincolIndex = targetId;
                            rowInx = $(tdItem).parent()[0].rowIndex;
                        }
                    }
                    if (curr_View != "month") {
                        for (var i = 0; i <= rowcount; i++) {
                            if ($(oRowCell[i].cells[omincolIndex]).hasClass("e-selectedCell")) {
                                rowInx = i;
                                break;
                            }
                        }
                    }
                    if (omaxcolIndex == null) {
                        omaxcolIndex = targetId;
                        if (curr_View != "month") {
                            checkcolindex = parseInt(omaxcolIndex);
                            for (var i = 0; i <= rowcount; i++) {
                                if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                    maxrowInx = i;

                                }
                            }
                        }
                    }
                    else if (omaxcolIndex > targetId) {
                        omaxcolIndex = omaxcolIndex;
                    }
                    else {
                        if (omaxcolIndex != targetId) {
                            omaxcolIndex = targetId;
                            if (curr_View != "month") {
                                checkcolindex = parseInt(omaxcolIndex);
                                for (var i = 0; i <= rowcount; i++) {
                                    if ($(oRowCell[i].cells[checkcolindex]).hasClass("e-selectedCell")) {
                                        maxrowInx = i;
                                    }
                                }
                            }
                        }
                    }
                }
            });
            var _minMaxIndexes = { rowInx: rowInx, maxrowInx: maxrowInx, omincolIndex: omincolIndex, omaxcolIndex: omaxcolIndex };
            return _minMaxIndexes;
        },

        _multipleCellAppointCreation: function (e) {
            if (ej.isNullOrUndefined(this._quickAppointWindow) && this.model.showQuickWindow) this._renderQuickWindow();
            var target = !ej.isNullOrUndefined(e.target) ? $(e.target) : $(e); this._multiple = true;
            if (this.element.find(".e-inline").length > 0) { this.element.find(".e-inlinetext").val() != "" && this._saveAppointment(); }
            if (this.element.find(".e-inlineedit").length > 0) { this._saveAppointment(); }
            this._slotByCellSelect(target);
            if (this.model.allowInline) {
                if ((this.model.orientation == "vertical" && this._customOrientation == "vertical") && !ej.isNullOrUndefined(this._inlineDate) && this.currentView() != "month" && !this._isCustomMonthView())
                    this._refreshDayAppointments(this._app);
                this.element.find('.e-inlinetext').removeClass('e-inlinetext');
                this.element.find('.e-inlinewrapper').remove();
                if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                    this._getResourceDetails(target, this._cellIndex);
                this._inlineAppointment(target);
            }
            else if (this.model.showQuickWindow && e.type !== "beforeOpen") {
                this._quickAppointWindow.find("#" + this._id + "_quickAppwindow").css("display", "block");
                if (new Date(new Date(this.cur_StartTime).setHours(0, 0, 0, 0)).getTime() == new Date(new Date(this.cur_EndTime).setHours(0, 0, 0, 0)).getTime())
                    this._quickAppointWindow.find('.e-quickstartend').html(this._dayFullNames[new Date(this.cur_StartTime).getDay()] + ", " + ej.format(new Date(this.cur_StartTime), "M", this.model.locale) + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale));
                else
                    this._quickAppointWindow.find('.e-quickstartend').html(this._dayFullNames[new Date(this.cur_StartTime).getDay()] + ", " + ej.format(new Date(this.cur_StartTime), "M", this.model.locale) + ", " + ej.format(new Date(this.cur_StartTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale) + " - " + this._dayFullNames[new Date(this.cur_EndTime).getDay()] + ", " + ej.format(new Date(this.cur_EndTime), "M", this.model.locale) + ", " + ej.format(new Date(this.cur_EndTime), this._timeMode == "12" ? this._pattern.t : "HH:mm", this.model.locale));
                this._quickAppointWindow.find('.subject').val("");
                if (!this.model.readOnly)
                    this._quickAppointWindow.ejDialog("open");
                var x = $(target).offset().left - ((this._quickAppointWindow.width() - $(target).width()) / 2) + 10;
                var y = $(target).offset().top - this._quickAppointWindow.height() - 10;
                var xy = this._quickWindowPosition(x, y, $(target), this._quickAppointWindow);
                this._quickAppointWindow.ejDialog({ position: { X: xy["X"], Y: xy["Y"] } });
                this._quickAppointWindow.find(".subject").focus();
                if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                    this._getResourceDetails($(target));
            }
            this._cellClick = true;

        },
        _slotByCellSelect: function (target) {
            var noOfDays = (this.model.showWeekend) ? 7 : this.model.workWeek.length;
            this._cellIndex = $(target).hasClass("e-workcells") ? $(target).index() : $(target).hasClass("e-alldaycells") ? $(target).index() : noOfDays - ((parseInt($(target).index() / noOfDays) + 1) * noOfDays - $(target).index()) + ($(target).parent().index() * noOfDays);
            this._cellIndex = this._resCustomView ? $(target).index() : this._cellIndex;
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal")) {
                this._cellIndex = this.currentView() !== "month" ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount)) : this._cellIndex;
                this._workCellIndex = $(target).parent().index();
            }
            var indexes = this._findMinMaxCellIndex();
            var renderDates = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.dateRender : this._dateRender;
            var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
            var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                if ($(target).hasClass("e-workcells")) {
                    var cellmins = this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount;
                    var minStartTime = (this.model.startHour * 3600000) + (rowInx * cellmins * 60 * 1000);
                    var maxEndTime = ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot) - 1) == maxrowInx ? (this.model.startHour * 3600000) + ((maxrowInx + 1) * cellmins * 60 * 1000) - 1 : (this.model.startHour * 3600000) + ((maxrowInx + 1) * cellmins * 60 * 1000);
                    this.cur_StartTime = new Date(new Date(minStartDate).setMilliseconds(minStartTime));
                    this.cur_EndTime = new Date(new Date(maxEndDate).setMilliseconds(maxEndTime));
                }
                else if ($(target).hasClass("e-monthcells")) {
                    var selCell = this.element.find('td.e-selectedCell');
                    var nsc = selCell.length - 1;
                    var startIndex = ($(selCell[0]).parent().index() * noOfDays) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / noOfDays) * noOfDays));
                    var endIndex = ($(selCell[nsc]).parent().index() * noOfDays) + ($(selCell[nsc]).index() - (Math.floor($(selCell[nsc]).index() / noOfDays) * noOfDays));
                    var startDate = new Date(this._dateRender[startIndex]);
                    var endDate = new Date(this._dateRender[endIndex]);
                    this.cur_StartTime = new Date(startDate.setHours(0, 0, 0));
                    this.cur_EndTime = new Date(endDate.setHours(23, 59, 59));
                }
                else if ($(target).hasClass("e-alldaycells")) {
                    this.cur_StartTime = new Date(minStartDate);
                    this.cur_EndTime = new Date(new Date(maxEndDate).setHours(23, 59, 59));
                }
            }
            else {
                if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                    var dayLength = this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length;
                    var mincolIndex = (dayLength < omincolIndex) ? omincolIndex - (omincolIndex % dayLength) : omincolIndex ;
                    var maxcolIndex = (dayLength < omaxcolIndex) ? omaxcolIndex - (omaxcolIndex % dayLength) : omaxcolIndex ;
                    var minStartDate = renderDates[parseInt(mincolIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))];
                    var maxEndDate = renderDates[parseInt(maxcolIndex / ((this.model.endHour - this.model.startHour) * this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot)))];
                    var minVal = (omincolIndex % (this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length));
                    var minStartTime = ((this.model.startHour) + (minVal / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    var maxVal = (omaxcolIndex % (this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length));
                    var maxEndTime = ((this.model.startHour) + (maxVal / (this.model.timeScale.minorSlotCount * (60 / this.model.timeScale.majorSlot))));
                    this.cur_StartTime = new Date(minStartDate).setMinutes(minStartTime * 60);
                    this.cur_EndTime = new Date(maxEndDate).setMinutes(maxEndTime * 60);
                    if((this.element.find('.e-workcellstab tr:first-child').children().length / this._dateRender.length)-1 == maxVal ){
                        this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + (60 - new Date(this.cur_EndTime).getMinutes())-1));
                    }else{
                        this.cur_EndTime = new Date(new Date(this.cur_EndTime).setMinutes(new Date(this.cur_EndTime).getMinutes() + Math.ceil(this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)));
                    }
                }
                else {
                    var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                    this.cur_StartTime = new Date(minStartDate);
                    this.cur_EndTime = new Date(new Date(maxEndDate).setHours(23, 59, 59));
                }
            }
        },

        _addCellSelection: function (oRowCell) {
            var tds = this.element.find('td.e-selectedCell');
            var nt = tds.length - 1;
            if (nt > 0) {
                this.element.find('td.e-selectedCell').removeClass("e-selectedCell");
                $(oRowCell[this._currentRowIndex].cells[this._currentColIndex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        },

        _processUpArrow: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            var allda = this.element.find(".e-alldaycells");
            if ($(oEl).hasClass("e-workcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) - 1;
                if (currrowindex > 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if ($(oRowCell[currrowindex - 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currrowindex == 0) {
                    if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                        var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                        var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(this.element).attr("tabIndex", 0).focus();
                        $(allda[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                return false;
            }

            else if ($(oEl).hasClass("e-monthcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) - 1;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if (newcur >= 0) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[0].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
                }
                else
                    return false;
            }
            else
                return false;

        },

        _processDown: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) + 1;
                if (currrowindex >= 0 && currrowindex <= rowcount && currrowindex != "undefined") {
                    if (newcur <= rowcount) {
                        if ($(oRowCell[currrowindex + 1].cells[currcolindex]).hasClass("e-resourceheadercells")) return false;
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[currrowindex].cells[currcolindex]).attr("tabIndex", 0).focus();
                }
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var allda = this.element.find(".e-alldaycells");
                $(allda[allDayInx]).removeClass("e-selectedCell").blur();
                $(this.element.find(".e-workcells")[allDayInx]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }

            else if ($(oEl).hasClass("e-monthcells")) {
                var rowcount = oRowCell.length - 1;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currrowindex) + 1;
                if (currrowindex >= 0 && currrowindex < rowcount && currrowindex != "undefined") {
                    if (newcur <= 7) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newcur].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else
                        $(oRowCell[newcur - 1].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else
                return false;
        },

        _processRight: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var maxcolindex = oRowCell[0].cells.length;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (currcolindex >= 0 && currcolindex < parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currcolindex == parseInt(maxcolindex) - 1) {
                    if (this.currentView() != "month") {
                        var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                        this.element.find("div.e-navigatenext").click();
                        $(oRowCell[maxrowInx1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    } else {
                        this.element.find("div.e-navigatenext").click();
                        $(this.element.find('div.e-draggableworkarea tr')[currrowindex].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass("e-monthcells")) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = resmaxcolindex = 7 * (parseInt(resIndex) + 1), mincolindex = 7 * (parseInt(resIndex));;
                var currrowindex = $(oEl).parent()[0].rowIndex;
                var currcolindex = $(oEl)[0].cellIndex;
                var newcur = parseInt(currcolindex) + 1;
                if (newcur < mcolind) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                if (currcolindex == parseInt(resmaxcolindex) - 1 && currrowindex < (this._dateRender.length) / 7) {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    var newrow = parseInt(currrowindex) + 1;
                    currcolindex = mincolindex;
                    if (newrow < (this._dateRender.length) / 7) {
                        $(oRowCell[newrow].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        if (newcur < mcolind) {
                            $(oRowCell[newrow].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                        }
                    }
                    else {
                        var previndex = currcolindex / 7;
                        this.element.find("div.e-navigatenext").click();
                        var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                        $(this.element.find(".e-monthcells")[index]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var nall = parseInt(this.element.find(".e-alldaycells").length) - 1;
                if (allDayInx >= 0 && allDayInx < nall) {
                    $(this.element.find(".e-alldaycells")[allDayInx]).removeClass("e-selectedCell").blur();
                    $(this.element.find(".e-alldaycells")[parseInt(allDayInx) + 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (allDayInx == nall) {
                    this.element.find("div.e-navigatenext").click();
                    $(this.element.find(".e-alldaycells")[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            this._keyPressed = true;
        },

        _processLeft: function (oEl, oRowCell) {
            if ($(oEl).hasClass("e-selectedAppointment")) {
                this.element.find('.e-selectedAppointment').removeClass("e-selectedAppointment");
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-selectedCell"))
                this._addCellSelection(oRowCell);
            if ($(oEl).hasClass("e-workcells")) {
                var maxcolindex = oRowCell[0].cells.length;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;
                var newcur = parseInt(currcolindex) - 1;
                if (currcolindex > 0 && currcolindex <= parseInt(maxcolindex) - 1 && currcolindex != "undefined") {
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (currcolindex == 0) {
                    if (this.currentView() != "month") {
                        var maxrowInx1 = $(oEl).parent()[0].rowIndex;
                        this.element.find("div.e-navigateprevious").click();
                        $(oRowCell[maxrowInx1].cells[maxcolindex - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        this.element.find("div.e-navigateprevious").click();
                        $(this.element.find('div.e-draggableworkarea tr')[currrowindex].cells[this.totdays.length - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else
                    return false;
            }
            else if ($(oEl).hasClass("e-monthcells")) {
                var resIndex = Math.floor($(oEl).index() / 7);
                var rowcount = oRowCell.length - 1, mcolind = 7 * (parseInt(resIndex) + 1);
                var mincolindex = 7 * (parseInt(resIndex));
                var count = this.currentView() == "day" ? 1 : this.currentView() == "workweek" ? this.model.workWeek.length : 7;
                var colIndex = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? count : this.currentView() == "month" ? this.totdays.length : count * (this.model.endHour - this.model.startHour) * 2;
                maxcolindex = ((this._tempResource.length != 0) && !ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) && (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.render_Resources[this.render_Resources.length - 1].length * colIndex : colIndex;
                var currrowindex = this.element.find("td.e-selectedCell").parent()[0].rowIndex;
                var currcolindex = this.element.find("td.e-selectedCell")[0].cellIndex;

                if (currcolindex == mincolindex && currrowindex >= 0) {
                    var newrow = parseInt(currrowindex) - 1;
                    var newcol = parseInt(mcolind) - 1;
                    if (newrow >= 0) {
                        $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                        $(oRowCell[newrow].cells[newcol]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                    else {
                        var previndex = currcolindex / 7;
                        this.element.find("div.e-navigateprevious").click();
                        var rowmax = this._dateRender.length / 7;
                        var index = (!ej.isNullOrUndefined(this.model.group) ? previndex * 7 : 0);
                        $(this.element.find('div.e-draggableworkarea tr')[rowmax - 1].cells[index + 6]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                    }
                }
                else if (currcolindex < mcolind) {
                    newcur = parseInt(currcolindex) - 1;
                    $(oRowCell[currrowindex].cells[currcolindex]).removeClass("e-selectedCell").blur();
                    $(oRowCell[currrowindex].cells[newcur]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                this._selectCurrentMonth(oRowCell, currrowindex, currcolindex);
            }
            else if ($(oEl).hasClass("e-alldaycells")) {
                var allDayInx = this.element.find('td.e-selectedCell')[0].cellIndex;
                var nall = parseInt(this.element.find(".e-alldaycells").length) - 1;
                if (allDayInx > 0 && allDayInx <= nall) {
                    $(this.element.find(".e-alldaycells")[allDayInx]).removeClass("e-selectedCell").blur();
                    $(this.element.find(".e-alldaycells")[parseInt(allDayInx) - 1]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else if (allDayInx == 0) {
                    this.element.find("div.e-navigateprevious").click();
                    $(this.element.find(".e-alldaycells")[nall]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                }
                else
                    return false;
            }
            this._keyPressed = true;
        },

        _selectCurrentMonth: function (oRowCell, currrowindex, currcolindex) {
            if (oRowCell.find(".e-selectedCell").hasClass("e-othermonths")) {
                oRowCell.find(".e-selectedCell").removeClass("e-selectedCell").blur();
                $(oRowCell[currrowindex].cells[currcolindex]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
        },

        _navigateToolbarRight: function (event) {
            var views = this.model.views;
            var curViewIndex = this.element.find(".e-commonviewbutton.e-" + this.currentView()).parent().index();
            if (curViewIndex < views.length - 1) {
                var newView = views[curViewIndex + 1].toLowerCase(); this._navView = true;
                this._viewChange(event, this.currentView(), newView);
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
        },

        _navigateToolbarLeft: function (event) {
            var curViewIndex = this.element.find(".e-commonviewbutton.e-" + this.currentView()).parent().index();
            if (curViewIndex > 0) {
                var newView = this.model.views[curViewIndex - 1].toLowerCase(); this._navView = true;
                this._viewChange(event, this.currentView(), newView);
                this.element.find("#" + this._id + "_navigator").ejDatePicker({ value: new Date(this.currentDate()) });
            }
        },

        _newAppWindow: function (contextElement, oRowCell) {
            if ($(contextElement).hasClass("e-selectedCell")) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                this._currentAction = ej.Schedule.Actions.Add;
                var targetElement = contextElement == null ? event : contextElement;
                var rowIndex = $(targetElement).parent().index();
                var columnIndex = $(targetElement).index();
                var resourceIndex = 0;
                var renderDates = ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "month") ? this.monthDays : ((this.model.orientation == "vertical" && this._customOrientation == "vertical") || this.currentView() == "customview" && this._dateRender.length <= 7) ? this.dateRender : this._dateRender;
                renderDates = (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() == "customview" && this._dateRender.length <= 7 ? this._dateRender : renderDates;
                var ns = parseInt(this.element.find('td.e-selectedCell').length) - 1;
                _target = $(targetElement);
                if (this.model.timeScale.enable)
                    this._cellIndex = _target.hasClass("e-workcells") ? _target.index() : _target.hasClass("e-alldaycells") ? _target.index() : this._isCustomMonthView() && this._oneWeek ? _target.index() : 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7);
                else
                    this._cellIndex = (this.model.orientation == "vertical" && this._customOrientation == "vertical") && this.currentView() == "month" || (this.currentView() == "customview" && this._dateRender.length >= 7) ? 7 - ((parseInt(_target.index() / 7) + 1) * 7 - _target.index()) + (_target.parent().index() * 7) : _target.index();
                if (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") {
                    this._cellIndex = this.model.timeScale.enable ? this.currentView() !== "month" && !(this._isCustomMonthView()) ? Math.floor(this._cellIndex / ((this.model.endHour - this.model.startHour) * 2)) : this._cellIndex : _target.index();
                    this._workCellIndex = _target.parent().index();
                }
                if (ns == 0) {
                    var curDate = new Date(renderDates[this._cellIndex]);
                    if ((this.model.minDate > curDate || this.model.maxDate < curDate)) { return false; }
                    if (_target.hasClass("e-workcells") && (this.model.timeScale.enable) && this.currentView() !== "month" && !(this._isCustomMonthView())) {
                        var time = (this.model.orientation == "vertical" && this._customOrientation == "vertical") ? this.model.startHour + (_target.parent().index() / 2) : this.model.startHour + ((_target.index() - (((this.model.endHour - this.model.startHour) * 2) * this._cellIndex)) / 2);
                        var timemin = time.toString().split(".");
                        startTime = new Date(curDate).setHours(parseInt(timemin[0]), parseInt(timemin[1]) == 5 ? 30 : 0);
                        var min = (parseInt(new Date(startTime).getHours()) == 23 && parseInt(new Date(startTime).getMinutes()) == 30) ? new Date(startTime).getMinutes() + 29 : new Date(startTime).getMinutes() + 30;
                        endTime = new Date(new Date(startTime).setMinutes(min));
                        if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: false });
                    }
                    else {
                        startTime = new Date(new Date(curDate).setHours(0, 0, 0));
                        endTime = new Date(new Date(curDate).setHours(23, 59, 59));
                        if (!ej.isNullOrUndefined(this._appointmentAddWindow)) this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                    }
                }
                else if (ns > 0) {
                    var indexes = this._findMinMaxCellIndex();
                    var omincolIndex = indexes.omincolIndex, omaxcolIndex = indexes.omaxcolIndex, rowInx = indexes.rowInx, maxrowInx = indexes.maxrowInx;
                    if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                        if ($(contextElement).hasClass('e-workcells')) {
                            var minStartDate = renderDates[omincolIndex]; var maxEndDate = renderDates[omaxcolIndex];
                            var minStartTime = (this.model.startHour + (rowInx / 2)).toString().split(".");
                            var maxEndTime = (this.model.startHour + (maxrowInx / 2)).toString().split(".");
                            startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 0));
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 0);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                        }
                        else if ($(contextElement).hasClass('e-monthcells')) {
                            var selCell = this.element.find('td.e-selectedCell');
                            var startIndex = ($(selCell[0]).parent().index() * 7) + ($(selCell[0]).index() - (Math.floor($(selCell[0]).index() / 7) * 7));
                            var endIndex = ($(selCell[ns]).parent().index() * 7) + ($(selCell[ns]).index() - (Math.floor($(selCell[ns]).index() / 7) * 7));
                            var startDate = new Date(this._dateRender[startIndex]);
                            var endDate = new Date(this._dateRender[endIndex]);
                            startTime = new Date(new Date(startDate).setHours(0, 0, 0));
                            endTime = new Date(new Date(endDate).setHours(23, 59, 59));
                        }
                        else if ($(contextElement).hasClass('e-alldaycells')) {
                            startTime = new Date(new Date(renderDates[omincolIndex]).setHours(0, 0, 0));
                            endTime = new Date(new Date(renderDates[omaxcolIndex]).setHours(23, 59, 59));
                        }
                    }
                    else {
                        if (this.currentView() != "month" && !this._isCustomMonthView() && this.model.timeScale.enable) {
                            var minStartDate = renderDates[0]; var maxEndDate = renderDates[0];
                            var minStartTime = (this.model.startHour + (omincolIndex / 2)).toString().split(".");
                            var maxEndTime = (this.model.startHour + (omaxcolIndex / 2)).toString().split(".");
                            startTime = new Date(new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 0));
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 0);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                        }
                        else {
                            var minStartDate = this.totdays[omincolIndex]; var maxEndDate = this.totdays[omaxcolIndex];
                            var minStartTime = (this.model.startHour).toString().split(".");
                            var maxEndTime = (this.model.startHour).toString().split(".");
                            startTime = new Date(minStartDate).setHours(parseInt(minStartTime[0]), parseInt(minStartTime[1]) == 5 ? 30 : 0);
                            endTime = new Date(maxEndDate).setHours(parseInt(maxEndTime[0]), parseInt(maxEndTime[1]) == 5 ? 30 : 0);
                            endTime = new Date(new Date(endTime).setMinutes(new Date(endTime).getMinutes() + 30));
                            endTime = new Date(new Date(endTime).setHours(23, 59, 59));
                        }
                    }
                }
                var event = { startTime: new Date(startTime), endTime: new Date(endTime), target: _target, resources: ((this.model.appointmentWindowOpen != null || this.model.cellDoubleClick != null) && (this._tempResource.length != 0)) ? this._getResourceValue(_target) : null };
                if (this._trigger("appointmentWindowOpen", event))
                    return false;
                if (ej.scheduleFeatures.resources && (this._tempResource.length != 0))
                    this._renderResourceData($(targetElement), this._cellIndex);
                this._appointmentAddWindow.find("#" + this._id + "startdate").ejDatePicker("option", "value", new Date(startTime));
                this._appointmentAddWindow.find("#" + this._id + "enddate").ejDatePicker("option", "value", new Date(endTime));
                this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value", ej.format(new Date(startTime), this._pattern.t, this.model.locale));
                this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value", ej.format(new Date(endTime), this._pattern.t, this.model.locale));
                ($(contextElement).hasClass("e-alldaycells") || this.currentView() == "month" || (this._isCustomMonthView())) && this._appointmentAddWindow.find(".allday").ejCheckBox({ checked: true });
                this._timeZoneCollection(null);
                this._tempStart = this._appointmentAddWindow.find("#" + this._id + "starttime").ejTimePicker("option", "value");
                this._tempEnd = this._appointmentAddWindow.find("#" + this._id + "endtime").ejTimePicker("option", "value");
                this._alldayCheck();
                if (!this.model.readOnly) {
                    this._appointmentAddWindow.find(".e-appsave,#" + this._id + "donerecur").ejButton("enable", true);
                    (this._mediaQuery) && this._appointmentAddWindow.find(".e-btndelete").css("display", "none");
                    this._appointmentAddWindow.ejDialog("open");
                }
                this._appointmentAddWindow.find('.subject').focus();
                this._cellClick = false;
            }

        },

        _tooltipEvents: function (args) {
            if (args == "disable") {
                if (!ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                    var tipObj = this.element.ejTooltip('instance');
                    tipObj._wireEvents(false);
                }
            }
            else {
                if (!ej.isNullOrUndefined(this.element.data("ejTooltip"))) {
                    var tipObj = this.element.ejTooltip('instance');
                    tipObj._wireEvents(true);
                }
            }
        },
        _showToolTip: function (event) {
            var event = event.event;
            if (ej.isNullOrUndefined(event.target)) return false;
            var toolTipObj = this.element.data("ejTooltip");
            if ($(event.target).hasClass("e-appup") || $(event.target).hasClass("e-appdown")) {
                toolTipObj.setModel({ content: this._getLocalizedLabels("AppointmentIndicator") });
                return true;
            } else if ($(event.target).hasClass("e-appsoverflow")) {
                return this._showAppCount(event);
            }
            else if (this.model.tooltipSettings.enable && !ej.isTouchDevice()) {
                var appData = this._getAppDetails(event.currentTarget);
                if (appData == false) return false;
                if (ej.isNullOrUndefined(this.model.tooltipSettings.templateId)) {
                    var startTime = this._timeMode == "12" ? ej.format(appData[this._appointmentSettings["startTime"]], this._pattern.t, this.model.locale) : ej.format(appData[this._appointmentSettings["startTime"]], "HH:mm", this.model.locale);
                    var endTime = this._timeMode == "12" ? ej.format(appData[this._appointmentSettings["endTime"]], this._pattern.t, this.model.locale) : ej.format(appData[this._appointmentSettings["endTime"]], "HH:mm", this.model.locale);
                    var subject = (appData[this._appointmentSettings["subject"]] == "" || ej.isNullOrUndefined(appData[this._appointmentSettings["subject"]])) ? this._getLocalizedLabels("NoTitle") : appData[this._appointmentSettings["subject"]];
                    var appDetails = subject + ":&nbsp;(" + startTime + "-" + endTime + ")";
                } else {
                    var appDetails = $(this.model.tooltipSettings.templateId).render(appData).trim();
                }
                toolTipObj.setModel({ content: appDetails });
                return true;
            }
            return false;
        },
        _showAppCount: function (e) {
            var id = e.target.id.split("_");
            var date = (this.currentView() != "day") ? new Date(parseInt($(e.currentTarget).attr("data-cellinfo"))) : new Date($(e.currentTarget).attr("data-cellinfo"));
            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group)) var resValue = this._resourceSort()[parseInt(id[id.length - 2])].id;
            if ((this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && this.currentView() != "month") {
                var cellIndex = parseInt(id[id.length - 1]);
                var starttime = new Date(date.setMilliseconds(((this.model.startHour * 60) + cellIndex * (this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount)) * (60 * 1000)));
                var endtime = new Date(starttime.setMilliseconds((this.model.timeScale.majorSlot / this.model.timeScale.minorSlotCount) * 60 * 1000));
            }
            var userTempHtml = $.templates($(this.model.appointmentTemplateId).html());
            var appoverflowheight = this.element.find(".e-appsoverflow").height();
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                var monthcellheight = this.element.find(".e-monthcells").outerHeight();
                var monthappheight = this.element.find(".e-monthappointment").outerHeight();
                var monthheaderheight = this.element.find(".e-monthheader").height();
                if (ej.isNullOrUndefined(monthappheight)) monthappheight = (!this.model.appointmentTemplateId) ? 19 : ($(userTempHtml.markup).css('height') == "100%" ? (monthcellheight - this.element.find('.e-monthheader').height() - 15) : $(userTempHtml.markup).css('height') == "0px" ? 20 : $(userTempHtml.markup).height());
                var appCount = parseInt($(e.currentTarget).attr("data-appcount"));
                var total = (appCount * monthappheight) + monthheaderheight + appoverflowheight;
                var overflowapps = Math.round((total - monthcellheight) / monthappheight);
                overflowapps = (overflowapps == 0) ? 1 : overflowapps;
            }
            else {
                var cellheight = this.element.find(".e-workcells").outerHeight();
                var appheight = (this.currentView() == "month") ? appheight = this.element.find(".e-monthappointment").outerHeight() : this.element.find(".e-appointment").height();
                if (ej.isNullOrUndefined(appheight)) appheight = (!this.model.appointmentTemplateId) ? 20 : ($(userTempHtml.markup).css('height') == "100%" ? (cellheight - 15) : $(userTempHtml.markup).css('height') == "0px" ? 20 : $(userTempHtml.markup).height());
                var appoverflowheight = this.element.find(".e-appsoverflow").height();
                var appCount = parseInt($(e.currentTarget).attr("data-appcount"));
                var total = (appCount * appheight) + appoverflowheight;
                var overflowapps = Math.ceil((total - cellheight) / appheight);
            }
            var data = { Date: date, ResourceValue: resValue, StartTime: starttime, EndTime: endtime };
            this._overflowApp = data;
            var toolTipObj = this.element.data("ejTooltip");
            if (this._trigger("overflowButtonHover", { event: e, datas: data })) {
                return false;
            }
            toolTipObj.setModel({ content: overflowapps + "&nbsp;" + this._getLocalizedLabels("OverFlowAppCount") });
            return true;
        },

        _horizontalRender: function () {
            (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) && this.element.find(".resemptytd").width((this.element.find(".e-horizontalrestd").width() < 100) ? 5 : (this.element.find(".e-horizontalrestd").width() >= 100 && this.element.find(".e-horizontalrestd").width() <= 150) ? 10 : 25);
            if (this._mediaQuery) {
                this.element.find(".e-parentnode,.e-childnode").css({ height: this.element.find(".e-workcells").height() });
            }
            else {
                var resLength = (this._tempResource.length == 0) ? this.res1.length : this._resourceSort().length;
                var scrollHeight = (this.element.find("div#" + this._id + "_scroller").ejScroller("isHScroll")) ? this.element.find("div#" + this._id + "_scroller").find(".e-hscroll").outerHeight() : 0;
                scrollHeight = ej.isNullOrUndefined(scrollHeight) ? 0 : scrollHeight;
                var workareaheight = this.scHeight - 1 - ((this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top) + scrollHeight);
                if (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) {
                    var workcellheight = Math.round(workareaheight / resLength) - 1;
                    workcellheight = workcellheight < 20 ? 20 : workcellheight;
                    this.element.find(".e-workcells").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    this.element.find(".e-childnode").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    this.element.find(".e-parentnode").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : workcellheight + "px" });
                    if (this.currentView() != "agenda") {
                        var restop = this.element.find(".e-draggableworkarea").offset().top - this.element.find(".e-workcellstab").offset().top;//this.element.find(".e-draggableworkarea")[0].scrollTop;
                        this.element.find(".e-horires").css({ top: -restop + "px" });
                    }
                }
                else {
                    this.element.find(".e-workcells").css({ height: (this.model.cellHeight) ? parseInt(this.model.cellHeight) : Math.round(workareaheight - 1) + "px" });
                }
            }
            if (this.element.find(".e-workcells").height() > workareaheight) this.element.find("div#" + this._id + "_scroller").ejScroller("refresh");
            this.element.find("div#" + this._id + "_scroller").ejScroller("isVScroll") && this._showScrollTd();
        },
        _monthCellsRender: function () {
            var len = this.element.find(".e-workcellstab tr").length;
            var workareaheight = parseInt(this.scHeight) - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            this.element.find(".e-monthcells, .e-timecells").outerHeight((this.model.cellHeight) ? parseInt(this.model.cellHeight) + 1 : Math.round(workareaheight / len));
        },

        _processTab: function (oEl, event, oRowCell) {
            var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment');
            if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
                if (appo.length != 0)
                    $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                else
                    $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-selectedCell")) {
                if (appo.length != 0) {
                    var selcel = this.element.find('td.e-selectedCell');
                    var n = parseInt(selcel.length) - 1;
                    if (n > 0) {
                        for (var i = 0; i <= n; i++) {
                            selcel.eq(i).removeClass("e-selectedCell").blur();
                        }
                    }
                    else
                        $(oEl).removeClass("e-selectedCell").blur();
                    $(appo[0]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                }
            }
            if ($(oEl).hasClass("e-navigateprevious")) {
                this.element.find('.e-navigatenext').attr("tabIndex", 0).focus();
            }
            else if ($(oEl).hasClass("e-navigatenext")) {
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                    $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment") || $(oEl).hasClass("e-agendaappointment")) {
                var appcount = appo.length;
                var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment").index(this.element.find(".e-selectedAppointment"));
                if (appindex < appcount && appindex >= 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    var newappindex = parseInt(appindex) + 1;
                    if (newappindex < appcount)
                        $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                    else if (newappindex == appcount)
                        this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
                }
                else if (appindex == appcount)
                    this.element.find('.e-navigateprevious').attr("tabIndex", 0).focus();
            }
        },

        _reverseTab: function (oEl, event, oRowCell) {
            var appo = this.element.find('div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment');
            if (oEl.id == this._id || $(oEl).hasClass("e-datedisplay")) {
                var len = parseInt(appo.length) - 1;
                if (appo.length != 0)
                    $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
            }
            var appcount = appo.length;
            if ($(oEl).hasClass("e-selectedCell")) {
                var len = appo.length - 1;
                if (appo.length != 0) {
                    var selcel = this.element.find('td.e-selectedCell');
                    var n = parseInt(selcel.length) - 1;
                    if (n > 0) {
                        for (var i = 0; i <= n; i++)
                            selcel.eq(i).removeClass("e-selectedCell").blur();
                    }
                    else
                        $(oEl).removeClass("e-selectedCell").blur();
                    $(appo[len]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                }
            }
            if ($(oEl).hasClass("e-navigatenext"))
                $(this.element).find('.e-navigateprevious').attr("tabIndex", 0).focus();
            else if ($(oEl).hasClass("e-navigateprevious")) {
                $(oRowCell[0].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
                if ($(oRowCell[0].cells[0]).hasClass("e-resourceheadercells"))
                    $(oRowCell[1].cells[0]).addClass("e-selectedCell").attr("tabIndex", 0).focus();
            }
            if ($(oEl).hasClass("e-appointment") || $(oEl).hasClass("e-alldayappointment") || $(oEl).hasClass("e-monthappointment") || $(oEl).hasClass("e-agendaappointment")) {
                var appindex = this.element.find("div.e-appointment,div.e-alldayappointment,div.e-monthappointment,div.e-agendaappointment").index(this.element.find(".e-selectedAppointment"));
                if (appindex < appcount && appindex > 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    var newappindex = parseInt(appindex) - 1;
                    if (newappindex < appcount && appindex >= 0)
                        $(appo[newappindex]).addClass("e-selectedAppointment").attr("tabIndex", 0).focus();
                    else if (newappindex == 0)
                        $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
                }
                else if (appindex == 0) {
                    $(appo[appindex]).removeClass("e-selectedAppointment").blur();
                    $(this.element).find('.e-navigatenext').attr("tabIndex", 0).focus();
                }
            }
        },

        _stopDefaultAction: function (e) {
            e.cancelBubble = true; e.returnValue = false; e.stopPropagation(); e.preventDefault();
        },

        _getLocalizedLabels: function (property) {
            var _localizedText;
            if (property == "Categorize")
                _localizedText = !ej.isNullOrUndefined(this.model.categorizeSettings.title) ? this.model.categorizeSettings.title : this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];
            else if (property == "Priority")
                _localizedText = !ej.isNullOrUndefined(this.model.prioritySettings.title) ? this.model.prioritySettings.title : this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];
            else
                _localizedText = this._localizedLabels[property] === undefined ? ej.Schedule.Locale["en-US"][property] : this._localizedLabels[property];;
            return _localizedText;
        },

        _refreshDatasource: function () {
            if (!ej.isNullOrUndefined(this.dataSource()) && this.dataSource().length > 0) {
                var appointments = this.dataSource();
                for (var a = 0, len = appointments.length; a < len; a++) {
                    this._timeZoneAppointments(appointments[a], "");
                }
            }
        },

        refreshAppointments: function () {
            !ej.isNullOrUndefined(this._appointmentSettings) && (this._dataManager = this.dataSource() instanceof ej.DataManager ? this.dataSource() : this.dataSource() != null ? ej.DataManager(this.dataSource()) : null);
            this._refreshDatasource();
            this._bindAppointmentsData("Refresh");
        },

        refresh: function () {
            this._refreshDatasource();
            var retainScrollValue = this._getSetScrollPosition();
            this._destroy();
            this._init();
            this._getSetScrollPosition(retainScrollValue);
        },

        getSlotByElement: function (args) {
            var target = !ej.isNullOrUndefined(args) ? $(args) : $(this.element.find("td.e-selectedCell"));
            if (ej.isNullOrUndefined(target) || target.length == 0 || this.currentView() == "agenda") return false;
            if (target.hasClass("e-workcells") || target.hasClass("e-monthcells") || target.hasClass("e-alldaycells")) {
                if (target.length == 1)
                    this._slotByElement(target, "");
                else
                    this._slotByCellSelect(target);
            }
            return { startTime: new Date(this.cur_StartTime), endTime: new Date(this.cur_EndTime), resources: (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this._getResourceValue(target) : null };
        },

        saveAppointment: function (obj) {
            if (!this.model.readOnly) {
                if (ej.isNullOrUndefined(this._appointmentAddWindow)) this._renderAppointmentWindow();
                if (!ej.isNullOrUndefined(this._appointmentAddWindow) && this._appointmentAddWindow.find(".e-recurEditor").length == 0) this._renderRecurrenceEditor();
                (ej.isNullOrUndefined(this._appointmentAddWindow)) && ej.RecurrenceEditor.prototype._initializePrivateProperties();
                var recurEdit = (!ej.isNullOrUndefined(this._appointmentAddWindow)) ? this._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor") : ej.RecurrenceEditor.prototype;
                var appointments = this._sortAppById(this._processed), maxId;
                this._publicMethodSave = false;
                if (this.model.appointmentSettings.applyTimeOffset) {
                    ej.isNullOrUndefined(obj[this._appointmentSettings["startTimeZone"]]) && (obj[this._appointmentSettings["startTimeZone"]] = (this.model.timeZone == null) ? "UTC " + this._timezoneStringValue() : this.model.timeZone);
                    ej.isNullOrUndefined(obj[this._appointmentSettings["endTimeZone"]]) && (obj[this._appointmentSettings["endTimeZone"]] = (this.model.timeZone == null) ? "UTC " + this._timezoneStringValue() : this.model.timeZone);
                }
                var savingTimeZone = this._timeZoneSavingAppoint(obj, "");
                obj = savingTimeZone.obj;
                if (!ej.isNullOrUndefined(obj[this._appointmentSettings["id"]]) || !obj[this._appointmentSettings["id"]] == "") {
                    var tempApp = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, obj[this._appointmentSettings["id"]]));
                    if (!ej.isNullOrUndefined(tempApp[0])) {
                        obj["Guid"] = tempApp[0]["Guid"];
                        obj["AppTaskId"] = tempApp[0]["AppTaskId"];
                        obj[this._appointmentSettings["recurrenceId"]] = tempApp[0][this._appointmentSettings["recurrenceId"]];
                        obj[this._appointmentSettings["recurrenceExDate"]] = tempApp[0][this._appointmentSettings["recurrenceExDate"]];
                        obj["ParentId"] = tempApp[0]["ParentId"];
                    }
                }
                var proxy = this;
                this._maxId = maxId = !ej.isNullOrUndefined(this._appMainId) ? this._appMainId + 1 : 1;
                var currentAction = this._currentAction == "save" ? "edit" : this._currentAction;
                if (ej.isNullOrUndefined(obj["AppTaskId"]) || obj["AppTaskId"] == "") {
                    obj[this._appointmentSettings["id"]] = (ej.isNullOrUndefined(obj[this._appointmentSettings["id"]]) || obj[this._appointmentSettings["id"]] == "") ? maxId : obj[this._appointmentSettings["id"]];
                    obj["AppTaskId"] = obj["ParentId"] = maxId;
                    obj.Guid = this._guidFormatGenerate();
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentSave", methodType: "public" }))
                        return false;
                    if (this._trigger("beforeAppointmentCreate", { appointment: obj, methodType: "public" }))
                        return false;
                    var temp = this._timeZoneAppointments(obj, "");
                    var promise = this._dataManager.insert(temp, this.model.appointmentSettings.query._fromTable);
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp, "reverse"));
                    if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(temp);
                    this._appointmentProcessing(obj);
                    this._currentViewAppointments = this._appointmentCount();
                    var renderApps = this._currentViewAppointments.filter(function (list) { return obj.ParentId == list.ParentId });
                    for (var ix = 0, len = renderApps.length; ix < len; ix++) {
                        this._refreshDayAppointments(renderApps[ix]);
                    }
                    this._appMainId = this._sortAppById(this._processed)[this._processed.length - 1]["AppTaskId"];
                    this._trigger("appointmentCreated", { appointment: temp, requestType: "appointmentSaved", methodType: "public" });
                    this._trigger("actionComplete", { data: temp, requestType: "appointmentSave", methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        temp[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!temp[proxy._appointmentSettings["recurrence"]]) temp.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", temp);
                                    }
                                }
                            }
                        });
                    }
                }
                else if (this._currentAction == "editOccurrence") {
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction }))
                        return false;
                    var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                    var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                    var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var recurColl = this._appointmentRecurrenceSort(new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid)));
                    var index = this._recuCollectionIndex(recurColl, _appList);
                    var model = this._appointmentSettings;
                    if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                        this._alertCreateError();
                        return false;
                    }
                    var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    this._objDate = _editApps;
                    var MapValue = this._objDate[0][this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                    var _editApp = this._deleteOcurrence(this._objDate[0][MapValue], new Date(_editApps[0][this._appointmentSettings["startTime"]]));
                    obj[this._appointmentSettings["recurrence"]] = 1;
                    obj[this._appointmentSettings["recurrenceRule"]] = _editApp[0][this._appointmentSettings["recurrenceRule"]] + ";RECUREDITID=" + _editApp[0]["ParentId"];
                    obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                    obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExdate"]];
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj[this._appointmentSettings["id"]] = _editApps[0][this._appointmentSettings["id"]];
                    var args = [], newAppointment;
                    newAppointment = this._addAppData(obj, maxId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), obj[this._appointmentSettings["recurrenceId"]]);
                    newAppointment[this._appointmentSettings["id"]] = newAppointment.AppTaskId;
                    args.push(newAppointment);
                    var newApp = [], _editApp = [];
                    var startTimezone1 = args[0][this._appointmentSettings["startTimeZone"]];
                    (startTimezone1 != this.model.timeZone) ? newApp.push(this._timeZoneAppointments(args[0], "")) : newApp.push(args[0]);
                    var _App = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, this._parentId));
                    (startTimezone1 != this.model.timeZone) ? _editApp.push(this._timeZoneAppointments(_App[0], "")) : _editApp.push(_App[0]);
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newApp, changed: _editApp, deleted: [] }, queryId, this.model.appointmentSettings.query._fromTable);
                    var updateTempNew = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(newApp[0], "reverse") : newApp[0];
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew);
                    var updateTempNew2 = (startTimezone1 != this.model.timeZone) ? this._timeZoneAppointments(_editApp[0], "reverse") : _editApp[0];
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTempNew2);
                    if (this.dataSource() instanceof ej.DataManager) this._currentAppointmentData.push(args[0]);
                    var isObjAvail = this._processed.filter(function (obj) { return obj.Guid == args[0].Guid; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: isObjAvail }, "Guid");
                    this._appointmentProcessing(args[0]);
                    this._currentViewAppointments = this._appointmentCount();
                    var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == args[0].ParentId; });
                    for (var e = 0, len = collection.length; e < len; e++) {
                        this._refreshDayAppointments(collection[e]);
                    }
                    this._trigger("appointmentChanged", { appointment: args[0], requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: args, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        args[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!args[0][proxy._appointmentSettings["recurrence"]]) args[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                        new ej.DataManager(proxy._processed).update("Guid", args[0]);
                                    }
                                }
                            }
                        });
                    }
                }
                else if ((this._currentAction == "save" && obj[this._appointmentSettings["recurrence"]]) || (this._currentAction == ej.Schedule.Actions.EditSeries)) {
                    var _editApps = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid));
                    if (this._currentAction != ej.Schedule.Actions.EditSeries) {
                        if (!ej.isNullOrUndefined(_editApps[0][this._appointmentSettings["recurrenceRule"]]))
                            obj[this._appointmentSettings["recurrenceRule"]] = _editApps[0][this._appointmentSettings["recurrenceRule"]];
                        var _appList = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, this._appUid))[0];
                        var Parid = _appList[this._appointmentSettings["recurrenceId"]] == null ? _appList["ParentId"] : _appList[this._appointmentSettings["recurrenceId"]];
                        var MapValue = _appList[this._appointmentSettings["recurrenceId"]] == null ? "ParentId" : this._appointmentSettings["recurrenceId"];
                        var recurColl = this._appointmentRecurrenceSort(new ej.DataManager(this._processed).executeLocal(new ej.Query().where(MapValue, ej.FilterOperators.equal, Parid)));
                        var index = this._recuCollectionIndex(recurColl, _appList);
                        var model = this._appointmentSettings;
                        if (((index == 0) ? (!ej.isNullOrUndefined(recurColl[index + 1]) ? !(new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime()) : false) : (index == recurColl.length - 1) ? !(new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) : !((new Date(new Date(recurColl[index - 1][model["endTime"]]).setHours(0, 0, 0, 0)).getTime() < new Date(new Date(obj[model["startTime"]]).setHours(0, 0, 0, 0)).getTime()) && (new Date(new Date(recurColl[index + 1][model["startTime"]]).setHours(0, 0, 0, 0)).getTime() > new Date(new Date(obj[model["endTime"]]).setHours(0, 0, 0, 0)).getTime())))) {
                            this._alertCreateError();
                            return false;
                        }
                    }
                    else {
                        var Parid = _editApps[0][this._appointmentSettings["recurrenceId"]] == null ? _editApps[0]["ParentId"] : _editApps[0][this._appointmentSettings["recurrenceId"]];
                        var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, Parid));
                        maxId = obj["AppTaskId"] = _editApp[0]["AppTaskId"];
                        obj[this._appointmentSettings["id"]] = _editApp[0][this._appointmentSettings["id"]];
                        obj[this._appointmentSettings["recurrenceId"]] = _editApp[0][this._appointmentSettings["recurrenceId"]];
                        obj[this._appointmentSettings["recurrenceExDate"]] = _editApp[0][this._appointmentSettings["recurrenceExDate"]];
                        obj[this._appointmentSettings["recurrenceRule"]] = (ej.isNullOrUndefined(recurEdit._recRule) || recurEdit._recRule == "") ? _editApp[0][this._appointmentSettings["recurrenceRule"]] : recurEdit._recRule;
                    }
                    obj["Guid"] = _editApps[0]["Guid"];
                    obj[this._appointmentSettings["id"]] = (this._currentAction != ej.Schedule.Actions.EditSeries) ? _editApps[0][this._appointmentSettings["id"]] : obj[this._appointmentSettings["id"]];
                    var args = [], newAppointment;
                    var parId = this._currentAction == ej.Schedule.Actions.EditOccurrence || (!ej.isNullOrUndefined(obj[this._appointmentSettings["recurrenceRule"]]) && obj[this._appointmentSettings["recurrenceRule"]].toString().indexOf("RECUREDITID") != -1) ? this._parentId : this._currentAction == (ej.Schedule.Actions.Save) ? _editApps[0].AppTaskId : maxId;
                    var taskId = ((((new Date(obj[this._appointmentSettings["endTime"]]) - new Date(obj[this._appointmentSettings["startTime"]])) / 3600000) > 24) && this._currentAction != ej.Schedule.Actions.EditOccurrence && (obj[this._appointmentSettings["allDay"]] == true)) ? parId : this._currentAction == (ej.Schedule.Actions.Save) ? _editApps[0].AppTaskId : this._appMainId + 1;
                    taskId = (this._currentAction == ej.Schedule.Actions.EditSeries) ? parId : taskId;
                    newAppointment = this._addAppData(obj, taskId, new Date(obj[this._appointmentSettings["startTime"]]), new Date(obj[this._appointmentSettings["endTime"]]), parId);
                    args.push(newAppointment);
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction }))
                        return false;
                    if (this._currentAction == ej.Schedule.Actions.EditSeries && !ej.isNullOrUndefined(obj["RecurrenceExDate"]))
                        this._isCustomAlert = true;
                    var newApp = [], editedApp = [], deleted = [];
                    var GId = this._currentAction == ej.Schedule.Actions.Save ? args[0]["Guid"] : args[0][this._appointmentSettings["recurrenceId"]];
                    var idName = this._currentAction == ej.Schedule.Actions.Save ? "Guid" : this._appointmentSettings["recurrenceId"];
                    var _editApp = new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().where(idName, ej.FilterOperators.equal, GId));
                    (!ej.isNullOrUndefined(_editApp) && _editApp.length > 0) ? editedApp.push(args[0]) : newApp.push(args[0]);
                    if (this._currentAction == ej.Schedule.Actions.EditSeries) {
                        var query = ej.Query().where(ej.Predicate(this._appointmentSettings["recurrenceRule"], ej.FilterOperators.contains, "RECUREDITID=" + args[0].ParentId, true));
                        var dele = new ej.DataManager(this._currentAppointmentData).executeLocal(query);
                        deleted = deleted.concat(dele);
                        //this._appointmentAddWindow.find('.recurbutton').click();
                        editedApp[0][this._appointmentSettings["recurrenceRule"]] = recurEdit._recRule;
                        editedApp[0][this._appointmentSettings["recurrenceExDate"]] = null;
                        var removeCollection = this._processed.filter(function (obj) { return obj.ParentId == editedApp[0].ParentId; });
                        new ej.DataManager(this._currentAppointmentData).remove("ParentId", editedApp[0].ParentId);
                        new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: removeCollection }, "ParentId");
                        for (var j = 0, len = removeCollection.length; j < len; j++) {
                            this._appointmentRemove(removeCollection[j]);
                            this._refreshDayAppointments(removeCollection[j]);
                        }
                    }
                    else if (editedApp.length > 0) {
                        for (var k = 0; k < editedApp.length; k++) {
                            new ej.DataManager(this._processed).remove("Guid", editedApp[k].Guid);
                            new ej.DataManager(this._renderedApp).remove("Guid", editedApp[k].Guid);
                            new ej.DataManager(this._renderedAllDay).remove("Guid", editedApp[k].Guid);
                            this._appointmentRemove(editedApp[k]);
                            this._refreshDayAppointments(editedApp[k]);
                        }
                    }
                    var proxy = this, newTemp = [], editTemp = [];
                    if (newApp.length > 0)
                        newTemp.push(this._timeZoneAppointments(newApp[0], ""));
                    if (editedApp.length > 0)
                        editTemp.push(this._timeZoneAppointments(editedApp[0], ""));
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.saveChanges({ added: newTemp, changed: editTemp, deleted: deleted }, queryId, this.model.appointmentSettings.query._fromTable);
                    if (editedApp.length > 0)
                        var updateTemp = this._timeZoneAppointments(editTemp[0], "reverse");
                    if (newApp.length > 0)
                        var updateTemp = this._timeZoneAppointments(newTemp[0], "reverse");
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", updateTemp);
                    new ej.DataManager(this._currentAppointmentData).remove("Guid", editedApp[0]);
                    var tempApps = this._processed.filter(function (obj) { return obj.Guid == editedApp[0].Guid; });
                    new ej.DataManager(this._processed).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    new ej.DataManager(this._renderedApp).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    new ej.DataManager(this._renderedAllDay).saveChanges({ added: [], changed: [], deleted: tempApps }, "Guid");
                    this._currentAppointmentData.push(editedApp[0]);
                    this._appointmentProcessing(editedApp[0]);
                    this._currentViewAppointments = this._appointmentCount();
                    var collection = this._currentViewAppointments.filter(function (obj) { return obj.ParentId == editedApp[0].ParentId; });
                    for (var e = 0, len = collection.length; e < len; e++) {
                        this._refreshDayAppointments(collection[e]);
                    }
                    for (var f = 0, len = deleted.length; f < len; f++) {
                        this._refreshDayAppointments(deleted[f]);
                    }
                    this._trigger("appointmentChanged", { appointment: editedApp[0], requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: editedApp, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        editedApp[0][proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!editedApp[0][proxy._appointmentSettings["recurrence"]]) editedApp[0].ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    }
                                }
                            }
                        });
                    }
                }
                else {
                    if (this._trigger("actionBegin", { data: obj, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" }))
                        return false;
                    if (this._trigger("beforeAppointmentChange", { appointment: obj, currentAction: currentAction, methodType: "public" }))
                        return false;
                    var temp = this._timeZoneAppointments(obj, "");
                    var queryId = (this.dataSource() instanceof ej.DataManager) ? this._appointmentSettings["id"] : "AppTaskId";
                    var promise = this._dataManager.update(queryId, temp, this.model.appointmentSettings.query._fromTable);
                    new ej.DataManager(this._currentAppointmentData).update("AppTaskId", this._timeZoneAppointments(temp, "reverse"));
                    this._renderSingleApp();
                    this._trigger("appointmentChanged", { appointment: obj, requestType: "appointmentChanged", currentAction: currentAction, methodType: "public" });
                    this._trigger("actionComplete", { data: obj, requestType: "appointmentEdit", currentAction: currentAction, methodType: "public" });
                    if (!ej.isNullOrUndefined(promise) && $.isFunction(promise.promise) && this.dataSource() instanceof ej.DataManager) {
                        promise.done(function (e) {
                            var value = (ej.isNullOrUndefined(e.record)) ? e : e.record;
                            if ($.isArray(value) || ($.isPlainObject(value) && ej.isNullOrUndefined(value.added))) {
                                proxy._processUrlBinding(e);
                            }
                            else if ($.isPlainObject(value) && !ej.isNullOrUndefined(value.added)) {
                                if (value.added.length > 0) {
                                    proxy._dateFormat(value.added);
                                    for (var a = 0, len = value.added.length; a < len; a++) {
                                        obj[proxy._appointmentSettings["id"]] = value.added[a][proxy._appointmentSettings["id"]];
                                        if (!obj[proxy._appointmentSettings["recurrence"]]) obj.ParentId = value.added[a][proxy._appointmentSettings["id"]];
                                    }
                                }
                            }
                        });
                    }
                }
                this._currentViewAppointments = this._appointmentCount();
                if (this.model.showAppointmentNavigator) this._nextPrevButton();
            }
        },

        print: function (appointment) {
            if (!ej.isNullOrUndefined(appointment))
                this._printAppointment(appointment);
            else {
                var cloneElement = this.element.clone();
                if (this.currentView() == "agenda") {
                    cloneElement.width(this.element.find('.e-agendacellstab').width() + 2);
                    cloneElement.height($("#" + this._id + " .e-headertr").height() + this.element.find('.e-agendacellstab').height() + $("#" + this._id + " .e-scheduleheader").height() + 2);
                    cloneElement.find("div#" + this._id + "_scroller").ejScroller({ width: this.element.find('.e-agendacellstab').width(), height: this.element.find('.e-agendacellstab').height() + 2 });
                    cloneElement.find('.e-commonviewbutton').css({ 'margin-top': '0px' });
                    cloneElement.find('.e-viewstable').css({ 'padding-top': '15px' });
                }
                else {
                    cloneElement.find(".e-upicon,.e-downicon").remove();
                    if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                        cloneElement.find(".e-borderleft").remove();
                        if (this.model.timeScale.enable) {
                            //if (this.currentView() == "month" || (this._isCustomMonthView() && this._renderDays > 7))
                            //    cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-monthleftindent').width());
                            //else
                            //    cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-workleftindent').width());
                            cloneElement.width(this.element.find('.e-scheduleoutertable').width());
                            cloneElement.height($("#" + this._id + " .e-headertr").height() + $("#" + this._id + " .e-workcellstab").height() + $("#" + this._id + " .e-scheduleheader").height() + 2);
                            cloneElement.find('.e-scroller').ejScroller({ width: $('.e-dateheader').width(), height: $("#" + this._id + " .e-workcellstab").height() + 2 });
                            cloneElement.find('.e-scrolltimecells').css({ top: 0 });
                            cloneElement.find('.e-commonviewbutton').css({ 'margin-top': '0px' });
                            cloneElement.find('.e-viewstable').css({ 'padding-top': '15px' });
                            cloneElement.children().first().css({ border: "0px solid #bbbcbb" });
                            cloneElement.css({ border: "1px solid #bbbcbb" });
                            if (this.currentView() == "month")
                                cloneElement.find('.e-draggableworkarea').css({ 'height': this.element.find('.e-timecells').height() * this.element.find('.e-timecells').length + 2 });
                        }
                        else {
                            //cloneElement.width(this.element.find('.e-workcellstab').width() + $('.e-workleftindent').width());
                            cloneElement.width(this.element.find('.e-scheduleoutertable').width());
                            cloneElement.find(".e-workcellstab").css({ left: -($("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()), position: 'absolute' });
                        }
                    }
                    else {
                        if (this.currentView() == "month" || (this._isCustomMonthView() && this._renderDays > 7)) {
                            cloneElement.width(this.element.find('.e-workcellstab').width());
                        }
                        else {
                            cloneElement.find(".e-workcellstab").css({ left: -($("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()), position: 'absolute' });
                            cloneElement.find(".e-horizontaltimecells tr:nth-child(2)").css("left", (!this.model.enableRTL)? -(this.element.find("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()) : (this.element.find("div#" + this._id + "_scroller").data("ejScroller").scrollLeft()) + "px");
                        }
                    }
                }
                //ej.print(cloneElement);
                this._schedulePrint(cloneElement);
            }
        },

        _schedulePrint: function (element, printWin) {
            var $div = ej.buildTag('div');
            var elementClone = element.clone();
            var elementWidth = Math.round((elementClone.width()) / 100) * 100;
            $div.append(elementClone);
            if (!printWin)
                var printWin = window.open('', 'print', "height=452,width=" + elementWidth + ",tabbar=no");
            printWin.document.write('<!DOCTYPE html>');
            var links = $('head').find('link').add("style");
            if (ej.browserInfo().name === "msie") {
                var a = ""
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                var a = ""
                printWin.document.write('<html><head>')
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.writeln(a + '</head><body>')
                printWin.document.writeln($div[0].innerHTML + '</body></html>')
            }
            printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if (!ej.isNullOrUndefined(printWin.window)) {
                    printWin.print();
                    setTimeout(function () { printWin.close() }, 1000);
                }
            }, 1000);
        },

        notifyChanges: function (action, data) {
            if (!ej.isNullOrUndefined(data) || data.length != 0) {
			    if(action == "beforeAppointmentChange"){
				   var app1=data.added[0];
				   var app=data.changed[0]; 
			    }
				else
				var app =  ej.isNullOrUndefined(data[0]) ? data : data[0];
                var object = $.extend(true, {}, app);
                object[this._appointmentSettings["startTime"]] = new Date(object[this._appointmentSettings["startTime"]]);
                object[this._appointmentSettings["endTime"]] = new Date(object[this._appointmentSettings["endTime"]]);
                if (!ej.isNullOrUndefined(app1)) {
				    var object1 = $.extend(true, {}, app1);
					object1[this._appointmentSettings["startTime"]] = new Date(object1[this._appointmentSettings["startTime"]]);
					object1[this._appointmentSettings["endTime"]] = new Date(object1[this._appointmentSettings["endTime"]]);
				}
                if (action == "beforeAppointmentCreate") {
                    new ej.DataManager(this._currentAppointmentData).insert(object);
                    this._appointmentProcessing(object);
                    this._renderAppointmentAll();
                }
                else if (action == "beforeAppointmentChange" || action == "dragStop" || action == "resizeStop") {
				    if (!ej.isNullOrUndefined(app1)){
					    new ej.DataManager(this._currentAppointmentData).insert(object1);
						this._appointmentProcessing(object1);
					}
                    new ej.DataManager(this._currentAppointmentData).update(this._appointmentSettings["id"], object);
                    new ej.DataManager(this._processed).remove(this._appointmentSettings["id"], object[this._appointmentSettings["id"]]);
                    this._dataProcessing(this._currentAppointmentData);
                    this._renderAppointmentAll();
                }
                else if (action == "beforeAppointmentRemove") {
                    var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where(this._appointmentSettings["id"], ej.FilterOperators.equal, object[this._appointmentSettings["id"]]));
                    new ej.DataManager(this._currentAppointmentData).remove(this._appointmentSettings["id"], appointment[0][this._appointmentSettings["id"]]);
                    new ej.DataManager(this._processed).remove(this._appointmentSettings["id"], appointment[0][this._appointmentSettings["id"]]);
                    this._renderAppointmentAll();
                }
            }
        },

        deleteAppointment: function (id) {
            if (!this.model.readOnly && this.model.allowDelete) {
                if (typeof id == "string") {
                    var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("Guid", ej.FilterOperators.equal, id));
                    if (appointment[0][this._appointmentSettings["recurrence"]]) {
                        this._deleteUid = id;
                        this._deletingAppointment();
                    }
                    else this._deleteApp(id);
                }
                else if (typeof id == "object") {
                    this._deleteUid = id.Guid;
                    if (ej.isNullOrUndefined(this._deleteUid)) {
                        var appointment = new ej.DataManager(this._processed).executeLocal(new ej.Query().where("ParentId", ej.FilterOperators.equal, id.ParentId));
                        this._deleteUid = appointment[0].Guid;
                    }
                    if (id[this._appointmentSettings["recurrence"]])
                        this._deletingAppointment();
                    else this._deleteApp(this._deleteUid);
                }
            }
        },

        getAppointments: function () {
            var appList = this.dataSource();
            return appList;
        },

        searchAppointments: function (searchString, fields, filterOperator, ignoreCase) {
            var _fields = ej.isNullOrUndefined(fields) ? this._getColumns(this._appointmentSettings) : fields;
            var _filterOperator = ej.isNullOrUndefined(filterOperator) ? "contains" : filterOperator;
            var _ignoreCase = ej.isNullOrUndefined(ignoreCase) ? true : ignoreCase;
            var result;
            if (typeof searchString == "string") {
                result = (searchString == "") ? [] : new ej.DataManager(this._currentAppointmentData).executeLocal(new ej.Query().search(searchString, _fields, _filterOperator, _ignoreCase));
            }
            else if (typeof searchString == "object") {
                result = this.filterAppointments(searchString);
            }
            return result;
        },

        filterAppointments: function (filterConditions) {
            var result, queryManagar = ej.Query(), matchcaseVal;
            if (!ej.isNullOrUndefined(filterConditions)) {
                var firstFilterCondition = filterConditions[0];
                matchcaseVal = ej.isNullOrUndefined(firstFilterCondition.matchcase) ? true : firstFilterCondition.matchcase;
                var predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, matchcaseVal);
                for (var i = 1; i < filterConditions.length; i++) {
                    matchcaseVal = ej.isNullOrUndefined(filterConditions[i].matchcase) ? true : filterConditions[i].matchcase;
                    predicate = predicate[filterConditions[i].predicate](filterConditions[i].field, filterConditions[i].operator, filterConditions[i].value, matchcaseVal);
                }
                queryManagar.where(predicate);
                result = new ej.DataManager(this._currentAppointmentData).executeLocal(queryManagar);
            }
            return result;
        },

        refreshScroller: function () {
            var scrollerObj = this.element.find('div#' + this._id + '_scroller').data("ejScroller");
            var scrollWidth = (this.model.orientation === "vertical" &&  this._customOrientation === "vertical") ? this.element.width() - (this._mediaQuery && (this.currentView() == "month" || this._isCustomMonthView()) ? 1 : (this.element.find('.e-scrolltimecells').length > 0 ? this.element.find('.e-scrolltimecells').parent().outerWidth() : 0)) : (this.model.orientation == "horizontal" || this._customOrientation == "horizontal") && (!ej.isNullOrUndefined(this.model.group) && (this._tempResource.length != 0)) ? this.element.width() - this.element.find(".e-resourceheadertable").width() : this.element.width();
            scrollerObj.model.width = parseInt(scrollWidth) - 2;
            scrollerObj.model.height = this.scHeight - 1 - (this.element.find('.e-draggableworkarea').offset().top - this.element.offset().top);
            scrollerObj.refresh();
            if (this.model.orientation == "vertical" && this._customOrientation == "vertical") {
                this._renderHoriVerticalScroll();
                this.element.find(".e-datecommondiv").parent().width(parseInt(this.element.width()) - 2);
                this.element.find(".e-headrealldaytable").css("left", -(this.element.find(".e-draggableworkarea").scrollLeft()) + "px");
            }
            else {
                $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", -(this.element.find('.e-draggableworkarea').scrollLeft()) + "px");
                this.element.find(".e-horizontresdiv").height(this.element.find('.e-draggableworkarea').height());
            }
            this._reRenderHeaderBar();
            this.model.showAppointmentNavigator && this._refreshAppNavigation();
            if (this.model.showCurrentTimeIndicator) this.element.find(".e-highlightcurrenttimeline").remove();
            this._highlightCurrentTime(this.model.showCurrentTimeIndicator);
            if ((this.currentView() == "month" || this._isCustomMonthView()) && (this.model.orientation == "vertical" && this._customOrientation == "vertical"))
                this._renderCurrentView("ScheduleResize");
            this._showScrollTd();
            this.element.find(".e-mobileNavigation").css(this.model.enableRTL ? "right" : "left", this.element.outerWidth() - 36);
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                this.element.find(".e-datecommondiv").addClass("e-datecursor");
                this.element.find(".e-navigateprevious,.e-navigatenext").hide();
                this.element.find(".e-prevapp,.e-nextapp").hide();
            }
        },
        _refreshAppNavigation: function () {
            var base = this.element.find("#" + this._id + "_scroller");
            if ((this._browserInfo.name === "msie" && this._browserInfo.version < 9) || ej.isNullOrUndefined(base.data("ejScroller")))
                return;
            var scroll = (base.ejScroller('instance').isVScroll()) ? base.find(".e-vscroll").outerWidth() : 0;
            var top = (base.height() / 2) - (150 / 2);
            var timecell = this.element.find(".e-scrolltimecells").parent().outerWidth();
            timecell = ej.isNullOrUndefined(timecell) ? 0 : timecell;
            if (!this.model.enableRTL) {
                this.element.find(".e-prevapp").css({ top: (top + 40) + "px", transform: "rotate(90deg)", left: (timecell - 61) + "px" });
                this.element.find(".e-nextapp").css({ top: (top + 40) + "px", transform: "rotate(-90deg)", left: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
            }
            else {
                this.element.find(".e-prevapp").css({ top: (top + 40) + "px", transform: "rotate(-90deg)", right: (timecell - 61) + "px" });
                this.element.find(".e-nextapp").css({ top: (top + 40) + "px", transform: "rotate(90deg)", right: (this.element.find(".e-workareadiv").width() - 61 - scroll - 30) + "px" });
            }
        },
        getDifference: function (value) {
            var time = "";
            if (value.toString().indexOf("-") != -1) {
                time = value.toString().substring(value.toString().indexOf("-") + 1, value.toString().indexOf("-") + 5);
                return -(parseInt(time.substring(0, 2)) * 60) + parseInt(time.substring(2, 4));
            }
            else {
                time = value.toString().substring(value.toString().indexOf("+") + 1, value.toString().indexOf("+") + 5);
                return (parseInt(time.substring(0, 2)) * 60) + parseInt(time.substring(2, 4));
            }
        },
        exportToExcel: function (action, serverEvent, type) {
            var appointments = (type) ? this._processed : this._currentAppointmentData;
            var proxy = this, appCollection = $.extend(true, [], appointments);
            appCollection.forEach(function (app) {
                delete app["AppTaskId"];
                delete app["Guid"];
                delete app[proxy._appointmentSettings["recurrenceId"]];
                delete app[proxy._appointmentSettings["recurrenceExDate"]];
                app[proxy._appointmentSettings["startTime"]] = new Date(app[proxy._appointmentSettings["startTime"]].getTime() + (proxy.getDifference(app[proxy._appointmentSettings["startTime"]]) * 60000));
                app[proxy._appointmentSettings["endTime"]] = new Date(app[proxy._appointmentSettings["endTime"]].getTime() + (proxy.getDifference(app[proxy._appointmentSettings["endTime"]]) * 60000));
            });
            appCollection.sort(function (a, b) {
                var a1 = a[proxy._appointmentSettings["id"]];
                var b1 = b[proxy._appointmentSettings["id"]];
                return (a1 == b1) ? 0 : a1 > b1 ? 1 : -1;
            });
            var form = ej.buildTag('form', "", null, { action: action, method: 'post' });
            var modelClone = JSON.parse(JSON.stringify($.extend(true, {}, this.model)));
            if (!ej.isNullOrUndefined(ej.raiseWebFormsServerEvents)) {
                var serverArgs = { model: modelClone, originalEventType: serverEvent };
                var clientArgs = { ScheduleAppointment: JSON.stringify(appCollection) };
                ej.raiseWebFormsServerEvents(serverEvent, serverArgs, clientArgs);
            } else {
                var scheduleModel = ej.buildTag('input', "", null, { name: 'ScheduleModel', type: 'hidden', value: JSON.stringify(modelClone) });
                var appData = ej.buildTag('input', "", null, { name: 'ScheduleAppointment', type: 'hidden', value: JSON.stringify(appCollection) });
                form.append(scheduleModel);
                form.append(appData);
                form.append(this);
                $('body').append(form);
                form.submit();
            }
            return true;
        },
        exportSchedule: function (action, serverEvent, id) {
            var sampleModel = {}, processedApp = [], blockedApp = [];
            this._currentViewAppointments = this._appointmentCount();
            $.extend(true, sampleModel, this.model);
            $.extend(true, processedApp, this._currentViewAppointments);
            $.extend(true, blockedApp, this._processedIntervals);
            for (var i = 0; i < processedApp.length; i++) {
                processedApp[i][this._appointmentSettings["startTime"]] = new Date(processedApp[i][this._appointmentSettings["startTime"]].getTime() + (this.getDifference(processedApp[i][this._appointmentSettings["startTime"]]) * 60000));
                processedApp[i][this._appointmentSettings["endTime"]] = new Date(processedApp[i][this._appointmentSettings["endTime"]].getTime() + (this.getDifference(processedApp[i][this._appointmentSettings["endTime"]]) * 60000));
            }
            for (var a = 0; a < blockedApp.length; a++) {
                blockedApp[a][this.model.blockoutSettings["startTime"]] = new Date(blockedApp[a][this.model.blockoutSettings["startTime"]].getTime() + (this.getDifference(blockedApp[a][this.model.blockoutSettings["startTime"]]) * 60000));
                blockedApp[a][this.model.blockoutSettings["endTime"]] = new Date(blockedApp[a][this.model.blockoutSettings["endTime"]].getTime() + (this.getDifference(blockedApp[a][this.model.blockoutSettings["endTime"]]) * 60000));
            }
            var value = new Date(new Date(this.currentDate()).setHours(0, 0, 0));
            sampleModel.currentDate = new Date(value.getTime() + (this.getDifference(value) * 60000));
            if (((!ej.isNullOrUndefined(this.model.renderDates) && $.type(this.model.renderDates) == "array" && this.model.renderDates.length > 0) || this._resCustomView) && this.currentView() === "customview") {
                for (var i = 0; i < this._dateRender.length; i++) {
                    var value1 = new Date(new Date(this._dateRender[i]).setHours(0, 0, 0));
                    sampleModel.renderDates.custom[i] = new Date(value1.getTime() + (this.getDifference(value1) * 60000));
                }
            }
            var appointmentClone = JSON.parse(JSON.stringify(this._appointmentSettings));
            $.extend(true, sampleModel.appointmentSettings, appointmentClone);
            var blockAppsClone = JSON.parse(JSON.stringify(this.model.blockoutSettings));
            $.extend(true, sampleModel.blockoutSettings, blockAppsClone);
            var modelClone = JSON.parse(JSON.stringify(sampleModel));
            var attr = { action: action, method: 'post' };
            var form = ej.buildTag('form', "", null, attr);
            var view = this.currentView() == "day" ? "Day" : this.currentView() == "month" ? "Month" : this.currentView() == "week" ? "Week" : this.currentView() == "agenda" ? "Agenda" : this.currentView() == "workweek" ? "WorkWeek" : "CustomView";
            if (this._ignoreFromAppointmentOnExport) {
                for (var i = 0; i < this._ignoreFromAppointmentOnExport.length; i++) {
                    delete appointmentClone[this._ignoreFromAppointmentOnExport[i]];
                    delete blockAppsClone[this._ignoreFromAppointmentOnExport[i]];
                }
            }
            if (this._ignoreFromModelOnExport) {
                for (var i = 0; i < this._ignoreFromModelOnExport.length; i++) {
                    delete modelClone[this._ignoreFromModelOnExport[i]];
                }
            }
            delete modelClone.appointmentSettings.dataSource;
            delete modelClone.blockoutSettings.dataSource;
            if (ej.raiseWebFormsServerEvents) {
                var args = { model: modelClone, originalEventType: serverEvent };
                var clientArgs = { appSetting: JSON.stringify(appointmentClone), appId: id, processedApp: JSON.stringify(processedApp), blockedApp: JSON.stringify(blockedApp), model: JSON.stringify(modelClone), locale: this._getLocalizedLabels(view) + ',' + this._getLocalizedLabels("AllDay") + ',' + this._getLocalizedLabels("Date") + ',' + this._getLocalizedLabels("Time") + ',' + this._getLocalizedLabels("Event") };
                ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
            } else {
                var inputAttr = { name: 'ScheduleApps', type: 'hidden', value: JSON.stringify(appointmentClone) }
                var input = ej.buildTag('input', "", null, inputAttr);
                var blockInputAttr = { name: 'ScheduleBlockedApps', type: 'hidden', value: JSON.stringify(blockAppsClone) }
                var blockInput = ej.buildTag('input', "", null, blockInputAttr);
                var inputAttrModel = { name: 'ScheduleModel', type: 'hidden', value: JSON.stringify(modelClone) }
                var inputModel = ej.buildTag('input', "", null, inputAttrModel);
                var processedApp = { name: 'ScheduleProcesedApps', type: 'hidden', value: JSON.stringify(processedApp) }
                var inputApp = ej.buildTag('input', "", null, processedApp);
                var blockedApp = { name: 'ScheduleProcesedIntervalsApps', type: 'hidden', value: JSON.stringify(blockedApp) }
                var blockInputApp = ej.buildTag('input', "", null, blockedApp);
                var localeText = { name: 'Locale', type: 'hidden', value: this._getLocalizedLabels(view) + ',' + this._getLocalizedLabels("AllDay") + ',' + this._getLocalizedLabels("Date") + ',' + this._getLocalizedLabels("Time") + ',' + this._getLocalizedLabels("Event") }
                var inputLocale = ej.buildTag('input', "", null, localeText);
                form.append(inputModel);
                form.append(inputApp);
                form.append(blockInputApp);
                form.append(inputLocale);
                if (!ej.isNullOrUndefined(id)) {
                    var idAttr = { name: 'AppointmentId', type: 'hidden', value: id }
                    var inputId = ej.buildTag('input', "", null, idAttr);
                    form.append(inputId);
                }
                form.append(input);
                form.append(blockInput);
                form.append(this);
                $('body').append(form);
                form.submit();
            }
            return true;
        }
    });

    if (ej.scheduleFeatures.resources)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.resources);
    if (ej.scheduleFeatures.horizontal)
        $.extend(ej.Schedule.prototype, ej.scheduleFeatures.horizontal);

    ej.Schedule.Locale = ej.Schedule.Locale || {};
    ej.Schedule.Locale['default'] = ej.Schedule.Locale["en-US"] = {
        ReminderWindowTitle: "Reminder window",
        CreateAppointmentTitle: "Create Appointment",
        RecurrenceEditTitle: "Edit Repeat Appointment",
        RecurrenceEditMessage: "How would you like to change the appointment in the series?",
        RecurrenceEditOnly: "Only this appointment",
        RecurrenceEditFollowingEvent: "Following Events",
        RecurrenceEditSeries: "Entire series",
        PreviousAppointment: "Previous Appointment",
        NextAppointment: "Next Appointment",
        AppointmentSubject: "Subject",
        StartTime: "Start Time",
        EndTime: "End Time",
        AllDay: "All day",
        StartTimeZone: "Start TimeZone",
        EndTimeZone: "End TimeZone",
        Today: "Today",
        Recurrence: "Repeat",
        Done: "Done",
        Cancel: "Cancel",
        Ok: "OK",
        Repeat: "Repeat",
        RepeatBy: "Repeat by",
        RepeatEvery: "Repeat every",
        RepeatOn: "Repeat on",
        StartsOn: "Starts on",
        Ends: "Ends",
        Summary: "Summary",
        Daily: "Daily",
        Weekly: "Weekly",
        Monthly: "Monthly",
        Yearly: "Yearly",
        Every: "Every",
        EveryWeekDay: "Every weekday",
        Never: "Never",
        After: "After",
        Occurrence: "Occurrence(s)",
        On: "On",
        Edit: "Edit",
        RecurrenceDay: "Day(s)",
        RecurrenceWeek: "Week(s)",
        RecurrenceMonth: "Month(s)",
        RecurrenceYear: "Year(s)",
        The: "The",
        OfEvery: "of every",
        First: "First",
        Second: "Second",
        Third: "Third",
        Fourth: "Fourth",
        Last: "Last",
        WeekDay: "Weekday",
        WeekEndDay: "Weekendday",
        Subject: "Subject",
        Categorize: "Categories",
        DueIn: "Due In",
        DismissAll: "Dismiss All",
        Dismiss: "Dismiss",
        OpenItem: "Open Item",
        Snooze: "Snooze",
        Day: "Day",
        Week: "Week",
        WorkWeek: "Work Week",
        Month: "Month",
        AddEvent: "Add Event",
        CustomView: "Custom View",
        Agenda: "Agenda",
        Detailed: "Edit Appointment",
        EventBeginsin: "Appointment Begins in",
        Editevent: "Edit Appointment",
        Editfollowingevent: "Following Events",
        Editseries: "Edit Series",
        Times: "times",
        Until: "until",
        Eventwas: "Appointment was",
        Hours: "hrs",
        Minutes: "mins",
        Overdue: "Overdue Appointment",
        Days: "day(s)",
        Event: "Event",
        Select: "select",
        Previous: "Previous",
        Next: "Next",
        Close: "Close",
        Delete: "Delete",
        Date: "Date",
        Showin: "Show in",
        Gotodate: "Go To Date",
        Resources: "RESOURCES",
        RecurrenceDeleteTitle: "Delete Repeat Appointment",
        Location: "Location",
        Priority: "Priority",
        RecurrenceAlert: "Alert",
        RecurrenceDateValidation: "Some months have fewer than selected dates. For these months, the occurrence will fall on the last date of the month.",
        NoTitle: "No Title",
        OverFlowAppCount: "more appointment(s)",
        AppointmentIndicator: "Click for more appointments",
        WrongPattern: "The recurrence pattern is not valid",
        CreateError: "The duration of the appointment must be shorter than how frequently it occurs. Shorten the duration, or change the recurrence pattern in the Appointment Recurrence dialog box.",
        DragResizeError: "Cannot reschedule an occurrence of the recurring appointment if it skips over a later occurrence of the same appointment.",
        StartEndError: "End time should be greater than start time",
        SeriesChangeAlert: "The changes made to specific instances of this series will be cancelled and those appointments will match the series again.",
        MouseOverDeleteTitle: "Delete Appointment",
        DeleteConfirmation: "Are you sure you want to delete this appointment?",
        Time: "Time",
        EmptyResultText: "No suggestions",
        BlockIntervalAlertTitle: "Alert",
        BlockIntervalError: "The selected time interval has been blocked and is unavailable for selection."
    };

    ej.Schedule.Actions = {
        Add: "add",
        Save: "save",
        Delete: "delete",
        DeleteOccurrence: "deleteOccurrence",
        DeleteFutureOccurrences: "deleteFutureOccurrences",
        DeleteSeries: "deleteSeries",
        EditOccurrence: "editOccurrence",
        EditFutureOccurrences: "editFutureOccurrences",
        EditSeries: "editSeries"
    };

    ej.Schedule.CurrentView = {
        Day: "day",
        Week: "week",
        Workweek: "workweek",
        Month: "month",
        CustomView: "customview",
        Agenda: "agenda"
    };

    ej.Schedule.TimeMode = {
        Hour12: "12",
        Hour24: "24"
    };

    ej.Schedule.Orientation = {
        Vertical: "vertical",
        Horizontal: "horizontal"
    };
    ej.Schedule.DayOfWeek = {
        Sunday: "Sunday",
        Monday: "Monday",
        Tuesday: "Tuesday",
        Wednesday: "Wednesday",
        Thursday: "Thursday",
        Friday: "Friday",
        Saturday: "Saturday"
    };
})(jQuery, Syncfusion);;
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var RecurrenceEditor = (function (_super) {
    __extends(RecurrenceEditor, _super);
    function RecurrenceEditor(element, options) {
        _super.call(this);
        this.defaults = {
            frequencies: ["never", "daily", "weekly", "monthly", "yearly", "everyweekday"],
            firstDayOfWeek: null,
            enableSpinners: true,
            startDate: new Date(),
            locale: "en-US",
            enableRTL: false,
            value: "",
            dateFormat: "",
            selectedRecurrenceType: 0,
            minDate: new Date(1900, 1, 1),
            maxDate: new Date(2099, 12, 31),
            cssClass: "",
            change: null,
            create: null
        };
        this.dataTypes = {
            frequencies: "array",
            enableSpinners: "boolean",
            enableRTL: "boolean",
        };
        this.rootCSS = "e-recurrenceeditor";
        this.PluginName = "ejRecurrenceEditor";
        this._id = "null";
        this.validTags = ["div"];
        this.model = this.defaults;
        if (element) {
            this._id = element[0].id;
            if (!element["jquery"])
                element = $('#' + element);
            if (element.length) {
                return $(element).ejRecurrenceEditor(options).data(this.PluginName);
            }
        }
    }
    RecurrenceEditor.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    RecurrenceEditor.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    RecurrenceEditor.prototype._setModel = function (options) {
        var flag = false;
        for (var key in options) {
            switch (key) {
                case "frequencies":
                    this.model.frequencies = options[key];
                    flag = true;
                    break;
                case "firstDayOfWeek":
                    this.model.firstDayOfWeek = this._firstDayOfWeek = options[key];
                    flag = true;
                    break;
                case "enableSpinners":
                    this.model.enableSpinners = options[key];
                    flag = true;
                    break;
                case "startDate":
                    if ($.type(options[key]) == "string")
                        this._currentDateFormat(this.model.dateFormat);
                    else if ($.type(options[key]) == "function" && $.type(ej.util.getVal(options[key])) == "string")
                        this.model.startDate = ej.parseDate(this.model.startDate.toString(), this._datepattern());
                    ((this.model.startDate < this.model.minDate) ? this.model.startDate = this.model.minDate : "");
                    ((this.model.startDate > this.model.maxDate) ? this.model.startDate = this.model.maxDate : "");
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker("option", "value", this.model.startDate);
                    break;
                case "locale":
                    this.model.locale = options[key];
                    flag = true;
                    break;
                case "enableRTL":
                    this.model.enableRTL = options[key];
                    this._recurrenceLayout.addClass('e-rtl');
                    break;
                case "value":
                    this.model.value = options[key];
                    break;
                case "dateFormat":
                    this.model.dateFormat = options[key];
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker("option", "dateFormat", this.model.dateFormat);
                    this._recurrenceContent.find('.until').ejDatePicker("option", "dateFormat", this.model.dateFormat);
                    break;
                case "selectedRecurrenceType":
                    this.model.selectedRecurrenceType = options[key];
                    this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: this.model.selectedRecurrenceType });
                    break;
                case "minDate":
                case "maxDate":
                    this._currentDateFormat(this.model.dateFormat);
                    this._recurrenceContent.find('.recurstartdate').ejDatePicker({ minDate: this.model.minDate, maxDate: this.model.maxDate });
                    break;
                case "cssClass":
                    this.model.cssClass = options[key];
                    this.element.removeClass(this.model.cssClass).addClass(options[key]);
                    break;
            }
            if (flag == true)
                this._render();
        }
    };
    RecurrenceEditor.prototype._init = function () {
        if (!ej.isNullOrUndefined(this.element))
            this._render();
    };
    RecurrenceEditor.prototype._destroy = function () {
        this.element.off();
        var $formElements = this.element.find('.e-datepicker,.e-dropdownlist');
        for (var index = 0; index < $formElements.length; index++) {
            var $element = $($formElements[index]);
            if ($element.hasClass('e-datepicker'))
                $element.ejDatePicker("destroy");
            else if ($element.hasClass('e-dropdownlist'))
                $element.ejDropDownList("destroy");
        }
        this.element.empty().removeClass("e-recurrenceeditor");
    };
    RecurrenceEditor.prototype._render = function () {
        $("#" + this._id + "recurrenceeditor").remove();
        this._currentDateFormat(this.model.dateFormat);
        this._initializePrivateProperties();
        var hasScrollbar = (typeof window.innerWidth === 'number') && window.innerWidth > document.documentElement.clientWidth;
        this._mediaQuery = (this._browserInfo.name == "msie" && parseInt(this._browserInfo.version, 10) <= 8) ? false : (document.documentElement.clientWidth + (hasScrollbar ? 17 : 0) < 361 || ej.isMobile());
        this.model.frequencies = this.model.frequencies.toString().toLowerCase().split(",");
        for (var i = 0; i < this.model.frequencies.length; i++) {
            if (this.model.frequencies[i] == "everyweekday")
                this.model.frequencies[i] = "EveryWeekDay";
            else
                this.model.frequencies[i] = this.model.frequencies[i].replace(/^./, function (str) { return str.toUpperCase(); });
        }
        this._renderRecurrenceEditor();
    };
    RecurrenceEditor.prototype._initializePrivateProperties = function () {
        this._rRule = {};
        this.flag = true;
        this._subControlChange = false;
        this._culture = ej.preferredCulture(this.model.locale);
        this._dayNamesArray = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
        this._firstDayOfWeek = (this.model.firstDayOfWeek != null) ? (typeof this.model.firstDayOfWeek == "string") ? this._dayNamesArray.indexOf(this.model.firstDayOfWeek.toString().toLowerCase()) : this.model.firstDayOfWeek : this._culture.calendar.firstDay;
        this._monthNames = this._culture.calendar.months.names;
        this._pattern = this._culture.calendar.patterns;
        this._browserInfo = ej.browserInfo();
        this._dayNamesValue = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"];
        this._dayNames = [];
        this._dayShortNames = [];
        this._dayFullNames = [];
        var index = this._firstDayOfWeek;
        do {
            if (index > 6)
                index = 0;
            this._dayFullNames.push(this._culture.calendar.days.names[index]);
            this._dayShortNames.push(this._culture.calendar.days.namesAbbr[index]);
            this._dayNames.push(this._dayNamesValue[index]);
            index++;
        } while (this._dayNames.length < 7);
        this._mediaQuery = false;
    };
    RecurrenceEditor.prototype._currentDateFormat = function (option) {
        var minDate, maxDate;
        if (!ej.isNullOrUndefined(option) && ($.type(this.model.startDate) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
            var date = ej.parseDate(this.model.startDate.toString(), this.model.dateFormat);
            minDate = ej.parseDate(this.model.minDate.toString(), this.model.dateFormat);
            maxDate = ej.parseDate(this.model.maxDate.toString(), this.model.dateFormat);
            this.model.startDate = ((!ej.isNullOrUndefined(date)) ? date : ((new Date(this.model.startDate.toString()).toString() == "Invalid Date" || new Date(this.model.startDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.startDate) : new Date(this.model.startDate.toString())));
            this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : ((new Date(this.model.minDate.toString()).toString() == "Invalid Date" || new Date(this.model.minDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.minDate) : new Date(this.model.minDate.toString()));
            this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : ((new Date(this.model.maxDate.toString()).toString() == "Invalid Date" || new Date(this.model.maxDate.toString()).toString() == "NaN") ? this._dateConvert(this.model.maxDate) : new Date(this.model.maxDate.toString()));
        }
        else if (option == "MM/dd/yyyy" && ($.type(this.model.startDate) != "date" || $.type(this.model.minDate) != "date" || $.type(this.model.maxDate) != "date")) {
            var currentDate = ej.parseDate(this.model.startDate.toString(), option);
            minDate = ej.parseDate(this.model.minDate.toString(), option);
            maxDate = ej.parseDate(this.model.maxDate.toString(), option);
            this.model.startDate = (!ej.isNullOrUndefined(currentDate)) ? currentDate : this.model.startDate;
            this.model.minDate = (!ej.isNullOrUndefined(minDate)) ? minDate : this.model.minDate;
            this.model.maxDate = (!ej.isNullOrUndefined(maxDate)) ? maxDate : this.model.maxDate;
        }
    };
    RecurrenceEditor.prototype._renderRecurrenceEditor = function () {
        this._recurrenceLayout = ej.buildTag('div#' + this._id + 'recurrenceeditor', "", {}, {});
        if (this.model.enableRTL)
            this._recurrenceLayout.addClass('e-rtl');
        var $recurWind = "<table style='width:100%'><tr><td style='width:20%'><div class='e-textlabel'>" + this._getLocalizedLabels("Repeat") + ":</div></td><td><input class='e-recurrencetype' id='" + this._id + "_recurrenceType' type='text' name='RecurrenceType' value='' /></td></tr></table><div id='" + this._id + "_recurtypelist'><ul>";
        for (var type = 0; type < this.model.frequencies.length; type++) {
            $recurWind += "<li>" + this._getLocalizedLabels(this.model.frequencies[type]) + "</li>";
        }
        $recurWind += "</ul></div>";
        this.element.append(this._recurrenceLayout.append($recurWind));
        this._renderRecurrenceContent();
        this._initialSubControlRender = true;
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_recurtypelist", width: (this._mediaQuery ? "140px" : "33%"), change: $.proxy(this._recurrenceTypeChange, this), cssClass: this.model.cssClass });
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: this.model.selectedRecurrenceType });
    };
    RecurrenceEditor.prototype._renderRecurrenceContent = function () {
        for (var i = 0; i < this._dayNames.length; i++)
            this._dayNames[i] = this._dayNames[i].toUpperCase();
        var startday = [this._getLocalizedLabels("First"), this._getLocalizedLabels("Second"), this._getLocalizedLabels("Third"), this._getLocalizedLabels("Fourth"), this._getLocalizedLabels("Last")];
        var margin = this.model.enableRTL ? "margin-right" : "margin-left";
        this._recurrenceContent = ej.buildTag('div.e-recurrencecontent#' + this._id + 'recurrencecontent', "", {}, {});
        if (this._mediaQuery) {
            var $recurCont = "<form id='" + this._id + "_recurrenceForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurCont += "<tr id='" + this._id + "_every' style='display:none'><td width='16%' id='everylabel' class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td id='everycount' class='e-tdpadding'><table><tr><td><div class='e-floatleft'><input id='" + this._id + "_recurevery' class='recurevery' type='text' /></div></td>" +
                "<td><div id='" + this._id + "_recurtypes' class='e-appcheckbox e-labelcursor'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_weekly' class='" + this._id + "_weekly' style='display:none'><td colspan='2' id='weeklabel' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td></tr><tr class='" + this._id + "_weekly' style='display:none'>" +
                "<td colspan='2' id='weekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < this._dayShortNames.length; weekcount++) {
                $recurCont += "<td><div class='e-weekday " + this._dayShortNames[weekcount] + "'><input id='" + this._id + "_" + this._dayNames[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + this._id + "_" + this._dayNames[weekcount] + "'>" + this._dayShortNames[weekcount] + "</label></div></td>";
            }
            $recurCont += "</tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_monthly' class='" + this._id + "_monthly' style='display:none'><td colspan='2' id='monthlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "_monthly' style='display:none'>" +
                "<td colspan='2' id='monthcount'><table class='e-table' cellpadding='3'><tr id='monthdaytr'><td><div><input id='" + this._id + "_monthday' class='monthdaytype' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthdate' class='monthdate' type='text'/></div></td></tr>" +
                "<tr id='monthweekdaytr'><td><div><input id='" + this._id + "_monthon' class='monthposition' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='" + this._id + "_monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurCont += "<li>" + startday[day] + "</li>";
            }
            $recurCont += "</div></div></td>";
            $recurCont += "<td><div class='e-appcheckbox e-labelcursor'><input id='" + this._id + "_monthsrtday' class='e-monthsrtday monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='" + this._id + "_monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < this._dayFullNames.length; monthday++) {
                $recurCont += "<li>" + this._dayFullNames[monthday] + "</li>";
            }
            $recurCont += "</div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_yearly' class='" + this._id + "_yearly' style='display:none'><td colspan='2' id='yearlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td></tr><tr class='" + this._id + "_yearly' style='display:none'>" +
                "<td colspan='2' id='yearcount' ><table class='e-table' cellpadding='3'><tr id='yeardaytr'>" +
                "<td><div><input id='" + this._id + "_yearday' class='yearrecurday' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div class='e-controlalign'><input id='" + this._id + "_yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                "<div id='" + this._id + "_yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (this._monthNames.length - 1); monthcount++) {
                $recurCont += "<li>" + this._monthNames[monthcount] + "</li>";
            }
            $recurCont += "</ul></div><td><input id='" + this._id + "_yeardate' class='yeardate' text='text'/></td></tr>" +
                "<tr id='yearweekdaytr'><td><div><input id='" + this._id + "_yearother' class='yearrecurposi' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='" + this._id + "_yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurCont += "<li>" + startday[yearstartday] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div class='e-controlalign'><input id='" + this._id + "_yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='" + this._id + "_yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < this._dayFullNames.length; yearweek++) {
                $recurCont += "<li>" + this._dayFullNames[yearweek] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery") + "</span></div></td></tr><tr><td></td><td><div><input id='" + this._id + "_yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                "<div id='" + this._id + "_yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (this._monthNames.length - 1); yearmonth++) {
                $recurCont += "<li>" + this._monthNames[yearmonth] + "</li>";
            }
            $recurCont += "</ul></div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_startson' ><td colspan='2' id='startsonlabel' class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td></tr><tr>" +
                "<td colspan='2' id='startsoncount'><input id='" + this._id + "_recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurCont += "<tr id='" + this._id + "_endson' ><td colspan='2' id='endsonlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td></tr><tr>" +
                "<td colspan='2' id='endsoncount'><table class='e-table' cellpadding='3'><tr id='endsonnever'><td><div><input id='" + this._id + "_repeatendnever' class='recurends e-recurnoend' type='radio' name='" + this._id + "_repeatend' value='Never'/><label class='e-textmargin' for='" + this._id + "_repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                "<tr id='endsonafter'><td><div><input id='" + this._id + "_repeatendafter' class='recurends e-recurafter' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                "</div></td><td><div><input id='" + this._id + "_recurcount' class='recurcount' type='text'/></div></td>" +
                "<td><span class='e-labelcursor' style='" + margin + ": -80px;'>" + this._getLocalizedLabels("Occurrence") + "</span></td></tr>" +
                "<tr id='endsonuntil'><td><div><input id='" + this._id + "_repeatendon' class='recurends e-recuruntil' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                "<td><input id='" + this._id + "_daily' class='e-until until' type='text' name='daily' value=''/></td></tr>  </table></td></tr>";
            $recurCont += "<tr style='display:none'><td><span class='e-textlabel'>Summary:</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
        }
        else {
            var $recurCont = "<form id='" + this._id + "_recurrenceForm'><table class='e-table' width='100%' cellpadding='7'><tbody>";
            $recurCont += "<tr id='" + this._id + "_every' style='display:none'><td width='20%' id='everylabel' class='e-textlabel'>" + this._getLocalizedLabels("Every") + ":</td><td id='everycount' class='e-tdpadding'><table><tr><td><div class='e-floatleft'><input id='" + this._id + "_recurevery' class='recurevery' type='text' /></div></td>" +
                "<td><div id='" + this._id + "_recurtypes' class='e-appcheckbox e-labelcursor'>" + this._getLocalizedLabels("RecurrenceDay") + "</div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_weekly' class='" + this._id + "_weekly' style='display:none'><td id='weeklabel' class='e-textlabel'><div>" + this._getLocalizedLabels("RepeatOn") + ":</div></td>" +
                "<td id='weekcount'><table class='e-table' cellpadding='3'><tr>";
            for (var weekcount = 0; weekcount < this._dayShortNames.length; weekcount++) {
                $recurCont += "<td><div class='e-weekday " + this._dayShortNames[weekcount] + "'><input id='" + this._id + "_" + this._dayNames[weekcount] + "' class='weekdays e-weekly" + this._dayNames[weekcount] + "'name='weekdays' type='checkbox'/><label class='e-textmargin' for='" + this._id + "_" + this._dayNames[weekcount] + "'>" + this._dayShortNames[weekcount] + "</label></div></td>";
            }
            $recurCont += "</tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_monthly' class='" + this._id + "_monthly' style='display:none'><td id='monthlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                "<td id='monthcount'><table class='e-table' cellpadding='3'><tr id='monthdaytr'><td><div><input id='" + this._id + "_monthday' class='monthdaytype' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthday'>" + this._getLocalizedLabels("Day") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthdate' class='monthdate' type='text'/></div></td></tr>" +
                "<tr id='monthweekdaytr'><td><div><input id='" + this._id + "_monthon' class='monthposition' name='" + this._id + "_monthday' type='radio'/><label class='e-textmargin' for='" + this._id + "_monthon'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_monthsrt' class='monthsrt' type='text' name='monthsrt' value=''/><div id='" + this._id + "_monthsrtlist'><ul>";
            for (var day = 0; day < startday.length; day++) {
                $recurCont += "<li>" + startday[day] + "</li>";
            }
            $recurCont += "</div></div></td>";
            $recurCont += "<td><div class='e-appcheckbox e-labelcursor'><input id='" + this._id + "_monthsrtday' class='e-monthsrtday monthsrtday' type='text' name='monthsrtday' value=''/>" +
                "<div id='" + this._id + "_monthsrtdaylist'><ul>";
            for (var monthday = 0; monthday < this._dayFullNames.length; monthday++) {
                $recurCont += "<li>" + this._dayFullNames[monthday] + "</li>";
            }
            $recurCont += "</div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_yearly' class='" + this._id + "_yearly' style='display:none'><td id='yearlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("RepeatBy") + ":</div></td>" +
                "<td id='yearcount' ><table class='e-table' cellpadding='3'><tr id='yeardaytr'>" +
                "<td><div><input id='" + this._id + "_yearday' class='yearrecurday' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearday'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div class='e-controlalign'><input id='" + this._id + "_yearmonth' class='yearmonth' type='text' name='yearmonth' value=''/></div></td>" +
                "<div id='" + this._id + "_yearmonthlist'><ul>";
            for (var monthcount = 0; monthcount < (this._monthNames.length - 1); monthcount++) {
                $recurCont += "<li>" + this._monthNames[monthcount] + "</li>";
            }
            $recurCont += "</ul></div><td><input id='" + this._id + "_yeardate' class='yeardate' text='text'/></td></tr>" +
                "<tr id='yearweekdaytr'><td><div><input id='" + this._id + "_yearother' class='yearrecurposi' name='" + this._id + "_yearday' type='radio'/><label class='e-textmargin' for='" + this._id + "_yearother'>" + this._getLocalizedLabels("The") + "</label></div></td>" +
                "<td><div><input id='" + this._id + "_yearsrt' class='yearsrt' type='text' name='yearsrt' value=''/><div id='" + this._id + "_yearsrtlist'><ul>";
            for (var yearstartday = 0; yearstartday < startday.length; yearstartday++) {
                $recurCont += "<li>" + startday[yearstartday] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div class='e-controlalign'><input id='" + this._id + "_yearsrtday' class='yearsrtday' type='text' name='yearsrtday' value=''/>" +
                "<div id='" + this._id + "_yearsrtdaylist'><ul>";
            for (var yearweek = 0; yearweek < this._dayFullNames.length; yearweek++) {
                $recurCont += "<li>" + this._dayFullNames[yearweek] + "</li>";
            }
            $recurCont += "</ul></div></div></td><td><div><span>" + this._getLocalizedLabels("OfEvery") + "</span></div></td><td><div><input id='" + this._id + "_yearsrtmonth' class='yearsrtmonth' type='text' name='yearsrtmonth' value=''/>" +
                "<div id='" + this._id + "_yearsrtmonthlist'><ul>";
            for (var yearmonth = 0; yearmonth < (this._monthNames.length - 1); yearmonth++) {
                $recurCont += "<li>" + this._monthNames[yearmonth] + "</li>";
            }
            $recurCont += "</ul></div></div></td></tr></table></td></tr>";
            $recurCont += "<tr id='" + this._id + "_startson' style='display:none'><td width='20%' id='startsonlabel' class='e-textlabel'>" + this._getLocalizedLabels("StartsOn") + ":</td>" +
                "<td id='startsoncount'><input id='" + this._id + "_recurstartdate' class='recurstartdate' type='text' name='RecurStartDate' value=''/></td></tr>";
            $recurCont += "<tr id='" + this._id + "_endson' style='display:none'><td id='endsonlabel' class='e-recurendslabel'><div class='e-recurendsalign'>" + this._getLocalizedLabels("Ends") + ":</div></td>" +
                "<td id='endsoncount'><table class='e-table' cellpadding='3'><tr id='endsonnever'><td><div><input id='" + this._id + "_repeatendnever' class='recurends e-recurnoend' type='radio' name='" + this._id + "_repeatend' value='Never'/><label class='e-textmargin' for='" + this._id + "_repeatendnever'>" + this._getLocalizedLabels("Never") + "</label></div></td></tr>" +
                "<tr id='endsonafter'><td><div><input id='" + this._id + "_repeatendafter' class='recurends e-recurafter' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendafter'>" + this._getLocalizedLabels("After") + "</label>" +
                "</div></td><td><div><input id='" + this._id + "_recurcount' class='recurcount' type='text'/></div></td>" +
                "<td><span class='e-labelcursor' style='" + margin + ": -80px;'>" + this._getLocalizedLabels("Occurrence") + "</span></td></tr>" +
                "<tr id='endsonuntil'><td><div><input id='" + this._id + "_repeatendon' class='recurends e-recuruntil' type='radio' name='" + this._id + "_repeatend'/><label class='e-textmargin' for='" + this._id + "_repeatendon'>" + this._getLocalizedLabels("On") + "</label></div></td>" +
                "<td><input id='" + this._id + "_daily' class='e-until until' type='text' name='daily' value=''/></td></tr>  </table></td></tr>";
            $recurCont += "<tr style='display:none'><td><span class='e-textlabel'>Summary:</span></td><td><span class=e-recurRule></span></td></tr></tbody></table></form>";
        }
        this._recurrenceLayout.append(this._recurrenceContent.append($recurCont));
        this._renderControls();
    };
    RecurrenceEditor.prototype._renderControls = function () {
        var control = this._recurrenceContent;
        control.find('.weekdays').ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._weeklyClick, this) });
        control.find('.monthsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_monthsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthSrt, this) });
        control.find('.monthsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_monthsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._monthSrt, this) });
        control.find('.yearsrt').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.yearmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearmonth, this) });
        control.find('.yearsrtday').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtdaylist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.yearsrtmonth').ejDropDownList({ enableRTL: this.model.enableRTL, targetID: this._id + "_yearsrtmonthlist", width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._yearsrt, this) });
        control.find('.recurstartdate').ejDatePicker({ buttonText: "Today", startDay: this._firstDayOfWeek, enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, value: this.model.startDate, minDate: this.model.minDate, maxDate: this.model.maxDate, change: $.proxy(this._startDateChange, this) });
        control.find('.until').ejDatePicker({ buttonText: "Today", startDay: this._firstDayOfWeek, enableRTL: this.model.enableRTL, locale: this.model.locale, cssClass: this.model.cssClass, dateFormat: this.model.dateFormat, change: $.proxy(this._recurUntil, this) });
        control.find('.recurcount').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "recurcount", minValue: 1, value: 10, width: "65px", decimalPlaces: 0, cssClass: this.model.cssClass, change: $.proxy(this._recurCount, this) });
        control.find('.recurevery').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "recurevery", minValue: 1, value: 1, decimalPlaces: 0, width: "100px", cssClass: this.model.cssClass, change: $.proxy(this._everyCount, this) });
        control.find('.monthdate').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "monthdate", minValue: 1, decimalPlaces: 0, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._monthDate, this) });
        control.find('.yeardate').ejNumericTextbox({ enableRTL: this.model.enableRTL, showSpinButton: this.model.enableSpinners, name: "yeardate", minValue: 1, decimalPlaces: 0, maxValue: 31, value: 1, width: "70px", cssClass: this.model.cssClass, change: $.proxy(this._yearmonth, this) });
        control.find('.recurends').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
        control.find('.monthposition,.monthdaytype').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
        control.find('.yearrecurposi,.yearrecurday').ejRadioButton({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, change: $.proxy(this._recurEndChange, this) });
    };
    RecurrenceEditor.prototype._recurrenceTypeChange = function (args) {
        this._recurrenceType(args);
        if (this._rRuleFreq != "")
            this.closeRecurPublic();
        if (this._rRuleFreq == "") {
            this._recRule = undefined;
        }
        this._trigger("change", { recurrenceRule: this._recRule });
    };
    RecurrenceEditor.prototype._recurrenceType = function (args) {
        this._rRuleFreq = "";
        var _rule = "";
        var strDate = ($.type(this.model.startDate) == "string") ? this._dateConvert(this.model.startDate) : this.model.startDate;
        if (this.flag) {
            this._subControlChange = true;
            this._recurrenceContent.find('.until').ejDatePicker({ value: new Date(new Date(strDate.toDateString()).setDate(new Date(strDate.toDateString()).getDate() + 7 * 10)) });
            this._subControlChange = false;
            this._recurrenceContent.find(".e-recurnoend").ejRadioButton({ checked: true });
            this.flag = false;
        }
        !this._mediaQuery && this._recurrenceContent.find("#" + this._id + "_startson,#" + this._id + "_endson").css("display", "table-row");
        if (args.itemId != null) {
            this._recurrenceContent.find("#" + this._id + "_every").css("display", "table-row");
            var selectedType = this._getLocalizedLabels(this.model.frequencies[args.itemId]);
            switch (selectedType) {
                case this._getLocalizedLabels("Never"):
                    this._recurrenceContent.css("display", "none");
                    break;
                case this._getLocalizedLabels("Daily"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceDay");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_monthly,." + this._id + "_yearly").css("display", "none");
                    this._rRuleFreq = "DAILY";
                    _rule = this._getLocalizedLabels("RecurrenceDay").toLowerCase();
                    break;
                case this._getLocalizedLabels("Weekly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceWeek");
                    var curDay = this._dayShortNames.indexOf(ej.format(strDate, "ddd", this.model.locale));
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find(".e-weekly" + this._dayNames[curDay]).ejCheckBox({ checked: true });
                    _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._dayFullNames[strDate.getDay()];
                    this._rRuleFreq = "WEEKLY";
                    this._recurrenceContent.find("." + this._id + "_monthly,." + this._id + "_yearly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_weekly").css("display", "table-row");
                    break;
                case this._getLocalizedLabels("Monthly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceMonth");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_yearly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_monthly").css("display", "table-row");
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find('.monthdate').ejNumericTextbox({ value: strDate.getDate() });
                    this._recurrenceContent.find('.monthsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf((ej.format(strDate, "ddd", "en-US").substr(0, 2)).toUpperCase()) });
                    this._recurrenceContent.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                    this._recurrenceContent.find('.monthdaytype').ejRadioButton({ checked: true });
                    this._rRuleFreq = "MONTHLY";
                    _rule = this._getLocalizedLabels("RecurrenceMonth").toLowerCase();
                    break;
                case this._getLocalizedLabels("Yearly"):
                    this._recurrenceContent.css("display", "block");
                    this._recurrenceContent.find("#" + this._id + "_recurtypes").get(0).innerHTML = this._getLocalizedLabels("RecurrenceYear");
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_monthly").css("display", "none");
                    this._recurrenceContent.find("." + this._id + "_yearly").css("display", "table-row");
                    this._initialSubControlRender = true;
                    this._recurrenceContent.find('.yearmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                    this._recurrenceContent.find('.yeardate').ejNumericTextbox({ value: strDate.getDate() });
                    this._recurrenceContent.find('.yearsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf((ej.format(strDate, "ddd", "en-US").substr(0, 2)).toUpperCase()) });
                    this._recurrenceContent.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: strDate.getMonth() });
                    this._recurrenceContent.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._getWeekIndex(strDate) });
                    this._recurrenceContent.find('.yearrecurday').ejRadioButton({ checked: true });
                    this._rRuleFreq = "YEARLY";
                    _rule = this._getLocalizedLabels("RecurrenceYear").toLowerCase();
                    break;
                case this._getLocalizedLabels("EveryWeekDay"):
                    this._recurrenceContent.css("display", "block");
                    this._rRuleFreq = "WEEKDAYS";
                    this._recurrenceContent.find("." + this._id + "_weekly,." + this._id + "_yearly,#" + this._id + "_every,." + this._id + "_monthly").css("display", "none");
                    _rule = args.text;
                    break;
            }
            this._initialSubControlRender = false;
        }
        this._recurrenceContent.find(".e-recurRule").html(_rule);
    };
    RecurrenceEditor.prototype._getWeekIndex = function (curDate) {
        var index = 0;
        var firstDate = new Date(curDate.getFullYear(), curDate.getMonth(), 1);
        var dayIndex = curDate.getDay();
        if (dayIndex != firstDate.getDay())
            do {
                firstDate = new Date(firstDate.setDate(firstDate.getDate() + 1));
            } while (dayIndex != firstDate.getDay());
        while (firstDate.getDate() != curDate.getDate()) {
            firstDate = new Date(firstDate.setDate(firstDate.getDate() + 7));
            index++;
        }
        return index;
    };
    RecurrenceEditor.prototype._weeklyClick = function () {
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._monthSrt = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_monthon").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._yearsrt = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_yearother").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._yearmonth = function () {
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_yearday").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._startDateChange = function (args) {
        this.model.startDate = new Date(args.model.value);
        if (!this._recurrenceContent.find("#" + this._id + "_repeatendon").ejRadioButton("model.checked") || (this.model.startDate > this._recurrenceContent.find(".until").ejDatePicker("option", "value"))) {
            this._subControlChange = true;
            this._recurrenceContent.find(".until").ejDatePicker("option", "value", new Date(new Date(args.model.value).setDate(args.model.value.getDate() + 7 * 10)));
        }
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurUntil = function (args) {
        if (this._subControlChange)
            return;
        this._subControlChange = true;
        this._recurrenceContent.find("#" + this._id + "_repeatendon").ejRadioButton("option", "checked", true);
        this._subControlChange = false;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurCount = function (args) {
        this._recurrenceContent.find("#" + this._id + "_repeatendafter").ejRadioButton("option", "checked", true);
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._everyCount = function () {
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._monthDate = function () {
        this._recurrenceContent.find("#" + this._id + "_monthday").ejRadioButton("option", "checked", true);
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._recurEndChange = function () {
        if (this._subControlChange)
            return;
        if (!this._initialSubControlRender)
            this._stringGenerate();
    };
    RecurrenceEditor.prototype._stringGenerate = function () {
        this.closeRecurPublic();
        this._trigger("change", { recurrenceRule: this._recRule });
    };
    RecurrenceEditor.prototype._findInterval = function (numericElement) {
        var interval;
        interval = numericElement.ejNumericTextbox("model.value");
        return interval = ej.isNullOrUndefined(interval) ? 0 : interval;
    };
    RecurrenceEditor.prototype._weeklyDayFind = function (strDate, days) {
        var newdayStr = strDate;
        do {
            newdayStr = new Date(newdayStr.setDate(newdayStr.getDate() + 1));
            var curDay = this._dayNamesValue[new Date(newdayStr).getDay()].toUpperCase();
        } while (days.indexOf(curDay) == -1);
        return newdayStr;
    };
    RecurrenceEditor.prototype._dayOfWeekInMonth = function (strDate, dayName, weekIndex) {
        var dayIndex = this._dayNamesValue.indexOf(dayName);
        var curDate = weekIndex == -1 ? new Date(strDate.getFullYear(), strDate.getMonth() + 1, 0) : new Date(strDate.getFullYear(), strDate.getMonth(), 1);
        while (curDate.getDay() != dayIndex) {
            curDate = new Date(weekIndex == -1 ? curDate.setDate(curDate.getDate() - 1) : curDate.setDate(curDate.getDate() + 1));
        }
        var curIndex = Math.abs(Math.ceil((curDate.getDate() - 1 - curDate.getDay()) / 7));
        return new Date(weekIndex == 1 || weekIndex == -1 ? curDate.toString() : new Date(curDate.setDate(curDate.getDate() + ((weekIndex - curIndex - 1) * 7))).toString());
    };
    RecurrenceEditor.prototype._findRecurCount = function (_interval, byDay, objValue) {
        var _count = 0, _interval, byDay, wTrue = false, ractualDate, rincrDate, interCount = this._interval;
        var day_start = new Date(this._recurrenceContent.find('.recurstartdate').ejDatePicker("model.value"));
        if (!ej.isNullOrUndefined(this._actualDate) && this._actualDate != 0) {
            var lastdate = new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0);
            day_start = lastdate.getDate() < this._actualDate ? lastdate : new Date(day_start.getFullYear(), day_start.getMonth(), this._actualDate);
        }
        rincrDate = ractualDate = new Date(day_start.toString());
        var recurEndDate = new Date(this.element.find('.e-until').ejDatePicker("model.value"));
        while (day_start <= recurEndDate) {
            switch (this._rRuleFreq) {
                case "DAILY":
                    day_start = new Date(day_start.setDate(day_start.getDate() + _interval));
                    wTrue = true;
                    break;
                case "WEEKLY":
                case "WEEKDAYS":
                    var wDays = byDay.split(",");
                    var curDay = objValue._dayNames[new Date(day_start.toString()).getDay()];
                    for (var b = 0; b < wDays.length; b++) {
                        if (wDays[b] == curDay) {
                            if (interCount == this._interval) {
                                wTrue = true;
                                interCount = 1;
                                break;
                            }
                            interCount++;
                        }
                    }
                    break;
                case "MONTHLY":
                    day_start = new Date(day_start.setMonth(day_start.getMonth() + _interval));
                    if (!ej.isNullOrUndefined(this._month) && this._month && ractualDate.getMonth() > day_start.getMonth())
                        day_start = new Date(day_start.setDate(ractualDate.getDate()));
                    if (day_start.getDate() != rincrDate.getDate() && (ej.isNullOrUndefined(this._month) || !this._month)) {
                        this._month = true;
                        day_start = new Date(day_start.setDate(day_start.getDate() - day_start.getDate()));
                    }
                    wTrue = true;
                    break;
                case "YEARLY":
                    day_start = new Date(day_start.setFullYear(day_start.getFullYear() + _interval));
                    wTrue = true;
                    break;
            }
            (wTrue) && _count++;
            wTrue = false;
            if (this._rRuleFreq == "WEEKLY" || this._rRuleFreq == "WEEKDAYS") {
                day_start = new Date(day_start.setDate(day_start.getDate() + 1));
            }
            rincrDate = new Date(day_start.toString());
        }
        this._month = false;
        this._actualDate = 0;
        return _count;
    };
    RecurrenceEditor.prototype._getLocalizedLabels = function (prop) {
        return ej.isNullOrUndefined(ej.RecurrenceEditor.Locale[this.model.locale]) ? ej.RecurrenceEditor.Locale["en-US"][prop] : ej.RecurrenceEditor.Locale[this.model.locale][prop];
    };
    RecurrenceEditor.prototype._datepattern = function () {
        return (this.model.dateFormat != "" && !ej.isNullOrUndefined(this.model.dateFormat)) ? this.model.dateFormat : this._pattern.d;
    };
    RecurrenceEditor.prototype._dateConvert = function (dateString) {
        if (!ej.isNullOrUndefined(dateString)) {
            var convertedDate = new Date(parseInt(dateString.match(/\d+/).toString()));
            convertedDate = $.type(convertedDate) == "date" ? convertedDate : new Date();
        }
        else
            convertedDate = null;
        return convertedDate;
    };
    RecurrenceEditor.prototype.recurrenceDateGenerator = function (recurrenceString, strDate, recurExDate) {
        var RecDateCollection = [], weeklyRule = recurrenceString.split(';');
        this._recurDates = {};
        var day_start = new Date(strDate), _count = 0;
        var rincrDate, ractualDate, rcurrentDate, recurEndDate;
        rcurrentDate = new Date(day_start);
        if (ej.isNullOrUndefined(recurExDate))
            recurExDate = null;
        this.recurrenceRuleSplit(recurrenceString, recurExDate);
        if (ej.isNullOrUndefined(this._rRule.recurEditId)) {
            var byDay = "", _interval = ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval;
            !ej.isNullOrUndefined(this._rRule.weekDays) && (byDay = this._rRule.weekDays.split(','));
            if (!ej.isNullOrUndefined(this._rRule.until)) {
                recurEndDate = new Date(this._rRule.until);
                recurEndDate.setDate(recurEndDate.getDate() + 1);
            }
            else if (!ej.isNullOrUndefined(this._rRule.count))
                switch (this._rRule.freq) {
                    case "DAILY":
                        recurEndDate = new Date(new Date(day_start).setDate(day_start.getDate() + this._rRule.count * (_interval)));
                        break;
                    case "WEEKLY":
                        var dayCount = day_start.getDate() + (((this._rRule.count / byDay.length) * 7)) * (_interval);
                        recurEndDate = new Date(new Date(day_start).setDate(Math.round(dayCount) < dayCount ? dayCount + 1 : dayCount));
                        break;
                    case "MONTHLY":
                        recurEndDate = new Date(new Date(day_start).setMonth(day_start.getMonth() + this._rRule.count * (_interval)));
                        break;
                    case "YEARLY":
                        recurEndDate = new Date(new Date(day_start).setFullYear(day_start.getFullYear() + this._rRule.count * (_interval)));
                        break;
                }
            else
                recurEndDate = new Date(new Date(this.model.startDate.toString()).setDate(day_start.getDate() + 42 * (_interval)));
            switch (this._rRule.freq) {
                case "WEEKLY":
                    byDay = this._rRule.weekDays.split(',');
                    if (byDay.indexOf(this._dayNamesValue[new Date(day_start).getDay()].toUpperCase()) == -1)
                        day_start = this._weeklyDayFind(day_start, byDay);
                    break;
                case "MONTHLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        var _lastDay = new Date(day_start).getDate() == new Date(day_start.getFullYear(), day_start.getMonth() + 1, 0).getDate() ? true : false;
                        while (new Date(day_start).getDate() != this._rRule.monthDay) {
                            day_start = new Date(day_start.setDate(day_start.getDate() + 1));
                        }
                    }
                    else
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions && this._rRule.setPositions != -1 ? new Date(day_start.getFullYear(), day_start.getMonth(), 1) : day_start);
                    rincrDate = ractualDate = new Date(day_start);
                    break;
                case "YEARLY":
                    if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                        var appMonth = new Date(rcurrentDate.setMonth(this._rRule.month - 1));
                        var lastDate = new Date(appMonth.getFullYear(), appMonth.getMonth() + 1, 0).getDate();
                        if (this._rRule.monthDay > lastDate)
                            this._rRule.monthDay = lastDate;
                        day_start = (day_start.getMonth() + 1 >= this._rRule.month) && day_start.getDate() > this._rRule.monthDay ? new Date(day_start.getFullYear() + 1, this._rRule.month - 1, this._rRule.monthDay) : new Date(day_start.getFullYear(), this._rRule.month - 1, this._rRule.monthDay);
                    }
                    else if (!ej.isNullOrUndefined(this._rRule.setPositions)) {
                        day_start = new Date(day_start.getFullYear(), this._rRule.month - 1, day_start.getDate());
                        day_start = new Date((this._getWeekIndex(day_start) + 1) > this._rRule.setPositions && this._rRule.setPositions != -1 ? new Date(day_start.getFullYear(), day_start.getMonth(), 1) : day_start);
                    }
                    break;
            }
            while (day_start <= recurEndDate) {
                ((this._rRule.freq == "MONTHLY" || this._rRule.freq == "YEARLY") && !ej.isNullOrUndefined(this._rRule.setPositions)) && (day_start = this._dayOfWeekInMonth(day_start, this._rRule.weekDays, this._rRule.setPositions));
                if (!ej.isNullOrUndefined(this._rRule.exDate)) {
                    if (this._rRule.exDate.indexOf(ej.format(new Date(day_start), this._pattern.d, this.model.locale)) == -1) {
                        var i = 2;
                    }
                }
                else
                    var i = 0;
                var value = new Date(day_start);
                switch (this._rRule.freq) {
                    case "DAILY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        day_start = new Date(day_start.setDate(day_start.getDate() + _interval));
                        break;
                    case "WEEKLY":
                        var curDay = this._dayNamesValue[new Date(day_start).getDay()].toUpperCase();
                        if (byDay.length - 1 != byDay.indexOf(curDay)) {
                            RecDateCollection.push(new Date(value.toString()).getTime());
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        else {
                            RecDateCollection.push(new Date(value.toString()).getTime());
                            day_start = new Date(day_start.setDate(day_start.getDate() + (day_start.getDay() * -1)));
                            day_start = new Date(day_start.setDate(day_start.getDate() + (_interval * 7) - 1));
                            day_start = this._weeklyDayFind(day_start, byDay);
                        }
                        break;
                    case "MONTHLY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        if (_lastDay)
                            day_start = new Date(day_start.getFullYear(), (day_start.getMonth() + _interval) + 1, 0);
                        else if (ej.isNullOrUndefined(this._rRule.setPositions)) {
                            var cloneDate = new Date(day_start);
                            var nextMonth = new Date(cloneDate.setMonth(cloneDate.getMonth() + _interval));
                            var lastDayOfMonth = new Date(nextMonth.getFullYear(), nextMonth.getMonth() + 1, 0);
                            var nextInterval = (day_start.getFullYear() == nextMonth.getFullYear()) ? day_start.getMonth() + _interval : nextMonth.getMonth();
                            if (nextInterval == nextMonth.getMonth())
                                day_start = (nextMonth > lastDayOfMonth) ? new Date(lastDayOfMonth.toString()) : new Date(nextMonth.setDate(this._rRule.monthDay));
                            else {
                                var prevMonth = new Date(nextMonth.setMonth(nextMonth.getMonth() - 1));
                                day_start = new Date(prevMonth.getFullYear(), prevMonth.getMonth() + 1, 0);
                            }
                        }
                        else
                            day_start = new Date(day_start.getFullYear(), day_start.getMonth() + _interval, 1);
                        break;
                    case "YEARLY":
                        RecDateCollection.push(new Date(value.toString()).getTime());
                        day_start = new Date(day_start.setFullYear(day_start.getFullYear() + _interval));
                        break;
                }
                _count++;
                if (!ej.isNullOrUndefined(this._rRule.count) && _count == this._rRule.count)
                    break;
            }
        }
        return RecDateCollection;
    };
    RecurrenceEditor.prototype.recurrenceRuleSplit = function (rRule, exDate) {
        this._rRule = {};
        _ruleExdate = exDate;
        var _rule, _ruleExdate, _rRuleSplit = rRule.split(";");
        if (!ej.isNullOrUndefined(exDate) && !ej.isNullOrUndefined(_ruleExdate.split(","))) {
            var _exDates = _ruleExdate.split(",");
            this._rRule.exDate = [];
            for (var i = 0; i < _exDates.length; i++) {
                this._rRule.exDate[i] = _exDates[i];
            }
        }
        for (var r = 0; r < _rRuleSplit.length; r++) {
            _rule = _rRuleSplit[r].split("=");
            switch ($.trim(_rule[0]).toUpperCase()) {
                case "FREQ":
                    this._rRule.freq = $.trim(_rule[1]).toUpperCase();
                    break;
                case "INTERVAL":
                    this._rRule.interval = parseInt(_rule[1], 10);
                    break;
                case "COUNT":
                    this._rRule.count = parseInt(_rule[1], 10);
                    break;
                case "UNTIL":
                    this._rRule.until = new Date(_rule[1]);
                    break;
                case "BYDAY":
                    this._rRule.weekDays = _rule[1];
                    break;
                case "BYMONTHDAY":
                    this._rRule.monthDay = parseInt(_rule[1], 10);
                    break;
                case "BYMONTH":
                    this._rRule.month = parseInt(_rule[1], 10);
                    break;
                case "BYSETPOS":
                    this._rRule.setPositions = parseInt(_rule[1], 10);
                    break;
                case "WKST":
                    this._rRule.weekStart = _rule[1];
                    break;
                case "EXDATE":
                    if (!ej.isNullOrUndefined(exDate) && !ej.isNullOrUndefined(_ruleExdate.split(","))) {
                        var _exDates = _ruleExdate.split(",");
                        this._rRule.exDate = [];
                        for (var i = 0; i < _exDates.length; i++) {
                            this._rRule.exDate[i] = _exDates[i];
                        }
                    }
                    else {
                        var _exDates = _rule[1].split(",");
                        this._rRule.exDate = [];
                        for (var i = 0; i < _exDates.length; i++) {
                            this._rRule.exDate[i] = _exDates[i];
                        }
                    }
                    break;
                case "RECUREDITID":
                    this._rRule.recurEditId = parseInt(_rule[1]);
                    break;
            }
        }
        return this._rRule;
    };
    RecurrenceEditor.prototype.clearRecurrenceFields = function () {
        var list = this.element.find("input.weekdays");
        for (var i = 0; i < list.length; i++) {
            $(list[i]).ejCheckBox({ checked: false });
        }
        this.element.find('.recurevery').ejNumericTextbox({ value: 1 });
        this.element.find('.recurcount').ejNumericTextbox({ value: 10 });
        this.element.find(".e-recurRule").html("");
    };
    RecurrenceEditor.prototype.setDefaultValues = function () {
        var strDate = this.model.startDate.toString();
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: 0 });
        this._recurrenceLayout.find('.e-recurrencetype').ejDropDownList({ selectedItemIndex: 1 });
        this.element.find(".recurstartdate").ejDatePicker({ value: new Date(strDate) });
        this.element.find('.e-until').ejDatePicker({ value: new Date(new Date(strDate).setDate(new Date(strDate).getDate() + 7 * 10)) });
        this.element.find(".e-recurnoend").ejRadioButton({ checked: true });
    };
    RecurrenceEditor.prototype.showRecurrenceSummary = function (appId) {
        for (var i = 0; i < this._dayNames.length; i++)
            this._dayNames[i] = this._dayNames[i].toUpperCase();
        var _recurRule = "", _recurOpt = "", _recurType = this.element.find('#' + this._id + '_recurrenceType');
        _recurRule = ej.isNullOrUndefined(this._rRule.interval) ? this._getLocalizedLabels("Every") + " " : this._getLocalizedLabels("Every") + " " + this._rRule.interval + " ";
        _recurType.ejDropDownList({ selectedItemIndex: this.model.frequencies.indexOf(this._rRule.freq.toLowerCase().replace(/^./, function (str) { return str.toUpperCase(); })) });
        switch (this._rRule.freq) {
            case "DAILY":
                _recurRule += this._getLocalizedLabels("RecurrenceDay").toLowerCase();
                this._rRuleFreq = "DAILY";
                break;
            case "WEEKLY":
                this._rRuleFreq = "WEEKLY";
                this.element.find('.weekdays').ejCheckBox({ checked: false });
                var _days = this._rRule.weekDays.split(',');
                for (var i = 0; i < _days.length; i++) {
                    this.element.find('.e-weekly' + _days[i]).ejCheckBox({ checked: true });
                    _recurOpt += this._dayShortNames[this._dayNames.indexOf(_days[i])] + (i == _days.length - 1 ? "" : ", ");
                }
                _recurRule += this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "MONTHLY":
                this._rRuleFreq = "MONTHLY";
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this.element.find('.e-monthdaytype').ejRadioButton({ checked: true });
                    this.element.find('.e-monthdate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = parseInt(this._rRule.monthDay).toString();
                }
                else {
                    this.element.find('.e-monthposition').ejRadioButton({ checked: true });
                    this.element.find('.e-monthsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this.element.find('.monthsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this.element.find('.monthsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceMonth").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
            case "YEARLY":
                this._rRuleFreq = "YEARLY";
                if (!ej.isNullOrUndefined(this._rRule.monthDay)) {
                    this.element.find('.e-yearrecurday').ejRadioButton({ checked: true });
                    this.element.find('.yearmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this.element.find('.yeardate').ejNumericTextbox({ value: parseInt(this._rRule.monthDay) });
                    _recurOpt = this._monthNames[this._rRule.month - 1] + " " + parseInt(this._rRule.monthDay);
                }
                else {
                    this.element.find('.e-yearrecurposi').ejRadioButton({ checked: true });
                    this.element.find('.yearsrtday').ejDropDownList({ selectedItemIndex: this._dayNames.indexOf(this._rRule.weekDays) });
                    this.element.find('.yearsrtmonth').ejDropDownList({ selectedItemIndex: this._rRule.month - 1 });
                    this.element.find('.yearsrt').ejDropDownList({ selectedItemIndex: this._rRule.setPositions - 1 });
                    _recurOpt = this.element.find('.yearsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[this._dayNames.indexOf(this._rRule.weekDays)] + " " + this._monthNames[this._rRule.month - 1];
                }
                _recurRule += this._getLocalizedLabels("RecurrenceYear").toLowerCase() + " " + this._getLocalizedLabels("On").toLowerCase() + " " + _recurOpt;
                break;
        }
        this.element.find('.recurevery').ejNumericTextbox({ value: ej.isNullOrUndefined(this._rRule.interval) ? 1 : this._rRule.interval });
        if (!ej.isNullOrUndefined(this._rRule.count)) {
            this.element.find(".e-recurafter").ejRadioButton({ checked: true });
            this.element.find('.recurcount').ejNumericTextbox({ value: this._rRule.count });
            _recurRule += ", " + this._rRule.count + this._getLocalizedLabels("Times").toLowerCase();
        }
        else if (!ej.isNullOrUndefined(this._rRule.until)) {
            this.element.find(".e-recuruntil").ejRadioButton({ checked: true });
            this.element.find('.e-until').ejDatePicker({ value: new Date(this._rRule.until) });
            _recurRule += " " + this._getLocalizedLabels("Until").toLowerCase() + " " + ej.format(new Date(this._rRule.until), this._datepattern(), this.model.locale);
        }
        else
            this.element.find(".e-recurnoend").ejRadioButton({ checked: true });
        return _recurRule;
    };
    RecurrenceEditor.prototype.getRecurrenceRule = function () {
        this.closeRecurPublic();
        return this._recRule;
    };
    RecurrenceEditor.prototype.closeRecurPublic = function () {
        var recurEditValue = this._rRuleFreq;
        var interval, monthDate, endRecur = "", recurOption = "", _weekRule = "", recurRules = "";
        interval = this._interval = this._findInterval(this.element.find('.recurevery'));
        switch (recurEditValue) {
            case "DAILY":
                recurRules = "FREQ=" + recurEditValue + ";INTERVAL=" + interval;
                break;
            case "WEEKDAYS":
                recurRules = "FREQ=WEEKLY;BYDAY=MO,TU,WE,TH,FR";
                _weekRule = "MO,TU,WE,TH,FR";
                break;
            case "WEEKLY":
                var _weekChkList = this.element.find("input.weekdays");
                var _dayName = "", _byDay = "", checked = "", checkedNames = "";
                for (var i = 0; i < _weekChkList.length; i++) {
                    $(_weekChkList[i]).ejCheckBox("model.checked") == true ? _weekRule += (_weekRule != "" ? "," : "") + this._dayNames[i].toUpperCase() : "";
                    $(_weekChkList[i]).ejCheckBox("model.checked") == true ? _dayName += (_dayName != "" ? ", " : "") + this._dayShortNames[i] : "";
                }
                for (var c = 0; c < this._dayNamesValue.length; c++) {
                    if (checked.indexOf(this._dayNamesValue[c]) != -1) {
                        _weekRule += (_weekRule != "" ? "," : "") + this._dayNamesValue[c];
                    }
                    if (checkedNames.indexOf(this._culture.calendar.days.namesAbbr[c]) != -1) {
                        _dayName += (_dayName != "" ? "," : "") + this._culture.calendar.days.namesAbbr[c];
                    }
                }
                if (_weekRule == "") {
                    var date = this.element.find('.recurstartdate').ejDatePicker("model.value");
                    _weekRule = this._dayNames[date.getDay()].toUpperCase();
                }
                var _rule = this._getLocalizedLabels("RecurrenceWeek").toLowerCase() + " on " + _dayName;
                this.element.find(".e-recurRule").html(_rule);
                recurRules = "FREQ=" + recurEditValue + ";INTERVAL=" + interval + ";" + "BYDAY=" + _weekRule;
                break;
            case "MONTHLY":
                if (this.element.find('.monthdaytype').ejRadioButton("model.checked")) {
                    monthDate = this.element.find('.monthdate').ejNumericTextbox("model.value");
                    recurRules = "FREQ=" + recurEditValue + ";BYMONTHDAY=" + monthDate + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + monthDate;
                }
                else {
                    var _setPos = this.element.find('.monthsrt').ejDropDownList("selectedItemIndex");
                    var dayName = this.element.find('.e-monthsrtday').ejDropDownList("selectedItemIndex");
                    _setPos = _setPos < 5 ? (_setPos + 1) : -1;
                    recurRules = "FREQ=" + recurEditValue + ";BYDAY=" + this._dayNames[dayName] + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this.element.find('.monthsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[dayName];
                }
                break;
            case "YEARLY":
                if (this.element.find("#" + this._id + "_yearday").ejRadioButton("model.checked")) {
                    var _monthIndex = this.element.find('.yearmonth').ejDropDownList("selectedItemIndex");
                    var _monthDate = this._findInterval(this.element.find('.yeardate'));
                    recurRules = "FREQ=" + recurEditValue + ";BYMONTHDAY=" + _monthDate + ";BYMONTH=" + (_monthIndex + 1) + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this._monthNames[_monthIndex] + " " + _monthDate;
                }
                else {
                    var _setPos = this.element.find('.yearsrt').ejDropDownList("selectedItemIndex");
                    var _monthIndex = this.element.find('.yearsrtmonth').ejDropDownList("selectedItemIndex");
                    var dayName = this.element.find('.yearsrtday').ejDropDownList("selectedItemIndex");
                    _setPos = _setPos < 5 ? (_setPos + 1) : -1;
                    recurRules = "FREQ=" + recurEditValue + ";BYDAY=" + this._dayNames[dayName] + ";BYMONTH=" + (_monthIndex + 1) + ";BYSETPOS=" + _setPos + ";INTERVAL=" + interval;
                    recurOption = " " + this._getLocalizedLabels("On").toLowerCase() + " " + this.element.find('.yearsrt').ejDropDownList("model.value").toLowerCase() + " " + this._dayFullNames[dayName] + " " + this._monthNames[_monthIndex];
                }
                break;
            case "NEVER":
                this._recRule = undefined;
                break;
        }
        if (this.element.find('.e-recurafter').ejRadioButton("model.checked")) {
            var _count = this._findInterval(this.element.find('.recurcount'));
            recurRules += ";COUNT=" + _count;
            endRecur = _count ? ", " + _count + " " + this._getLocalizedLabels("Times") : ", ";
        }
        else if (this.element.find('.e-recuruntil').ejRadioButton("model.checked")) {
            var _count1 = this._findRecurCount(interval, _weekRule, this);
            recurRules += ";COUNT=" + _count1;
            endRecur = _count1 ? ", " + _count1 + " " + this._getLocalizedLabels("Times") : ", ";
        }
        var _every = (this._rRuleFreq != "WEEKDAYS" ? this._getLocalizedLabels("Every") : "") + " " + (interval > 1 ? interval + " " : "");
        var _rRuleStr = _every + this.element.find(".e-recurRule").html() + recurOption + endRecur;
        this._recRule = recurRules;
        return _rRuleStr;
    };
    return RecurrenceEditor;
}(ej.WidgetBase));
ej.widget("ejRecurrenceEditor", "ej.RecurrenceEditor", new RecurrenceEditor());
ej.RecurrenceEditor.Locale = {};
ej.RecurrenceEditor.Locale["en-US"] = {
    Repeat: "Repeat",
    Never: "Never",
    Daily: "Daily",
    Weekly: "Weekly",
    Monthly: "Monthly",
    Yearly: "Yearly",
    First: "First",
    Second: "Second",
    Third: "Third",
    Fourth: "Fourth",
    Last: "Last",
    EveryWeekDay: "Every weekday",
    Every: "Every",
    RecurrenceDay: "Day(s)",
    RecurrenceWeek: "Week(s)",
    RecurrenceMonth: "Month(s)",
    RecurrenceYear: "Year(s)",
    RepeatOn: "Repeat on",
    RepeatBy: "Repeat by",
    StartsOn: "Starts on",
    Times: "times",
    Ends: "Ends",
    Day: "Day",
    The: "The",
    OfEvery: "Of",
    After: "After",
    On: "On",
    Occurrence: "Occurrence(s)",
    Until: "Until"
};
;
/**
* @fileOverview Plugin to style the Html PDFViewer elements
* @copyright Copyright Syncfusion Inc. 2001 - 2013. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author &lt;a href="mailto:licensing@syncfusion.com"&gt;Syncfusion Inc&lt;/a&gt;
*/
(function ($, ej, undefined) {
    ej.widget("ejPdfViewer", "ej.PdfViewer", {

        _rootCSS: "e-pdfviewer",
        _requiresID: true,
        element: null,
        model: null,
        validTags: ["div"],

        //#region Defaults
        defaults: {
            serviceUrl: "",
            hyperlinkOpenState: 1,
            serverActionSettings: {
                load: "Load",
                fileUpload: "FileUpload",
                print: "Load",
                download: "Download",
                unload: "Unload"
            },
            documentPath: null,
            toolbarSettings: {
                toolbarItem: 1 | 2 | 4 | 8 | 16 | 32 |64| 128,
                showTooltip: true
            },
            enableHyperlink: true,
            enableTextSelection: true,
            pdfService: 1,
            locale: "en-US",
            interactionMode: 1,
            bufferingMode: 1,
            pageChange: "",
            documentLoad: "",
            hyperlinkClick: "",
            beforePrint: "",
            afterPrint: "",
            zoomchange: "",
            bufferStart: "",
            bufferEnd: "",
            annotationAdd: "",
            annotationRemove: "",
            annotationPropertiesChange: "",
            annotationResize: "",
            signatureDelete: "",
            signatureAdd: "",
            signatureResize: "",
            signaturePropertiesChange: "",
            isResponsive: true,
            pageClick: "",
            allowClientBuffering: false,
            documentUnload: "",
            ajaxRequestFailure: "",
            annotationType: null,
            enableTextMarkupAnnotations: true,
            enableHighlightAnnotation: true,
            enableStrikethroughAnnotation: true,
            enableUnderlineAnnotation: true,
            enableSignature: true,
            shouldFlattenDocument: false,
            downloadStart: "",
            downloadEnd: "",
            strikethroughSettings: {
                color: "#ff0000",
                author: "Guest",
                opacity: 1,
                subject: "Strikethrough",
                modifiedDate: null,
                isLocked: false
            },
            underlineSettings: {
                color: "#00ff00",
                author: "Guest",
                opacity: 1,
                subject: "Underline",
                modifiedDate: null,
                isLocked: false
            },
            highlightSettings: {
                color: "#ffff00",
                author: "Guest",
                opacity: 1,
                subject: "Highlight",
                modifiedDate: null,
                isLocked: false
            },
            signatureSettings: {
                color: "#000000",
                opacity: 1,
            },
            textSelectionContextMenu: {
                isEnable: true,
                isCopyEnable: true,
                isSearchEnable: true,
                isHighlightEnable: true,
                isStrikeoutEnable: true,
            },
            annotationContextMenu: {
                isEnable: true,
                isPopupEnable: true,
                isDeleteEnable: true,
                isPropertiesEnable: true,
            }
        },
        dataTypes: {
            toolbarSettings: "data",
        },
        //#endregion

        //#region Local Members
        _isToolbarClick: false,
        _curYPos: 0,
        _curXPos: 0,
        _curDown: false,
        _pageModel: null,
        _currentPage: 1,
        _zoomLevel: 2,
        _preZoomVal: 1,
        _fitType: null,
        _higherZoomIndex: 0,
        _lowerZoomIndex: 0,
        _actionUrl: null,
        _isDevice: false,
        _contextMenu: false,
        _zoomVal: 1,
        _currentPageBackup: 0,
        _zoomValBackup: 0,
        _zoomLevelBackup: 0,
        _fitTypeBackup: null,
        _scrollTop: 0,
        _bgRenderTimer: 0,
        _renderCount: 0,
        _prevDiff: -1,
        _pointerCount: 0,
        _searchText: null,
        _selectedIndex: 0,
        _searchPageIndex: 0,
        _isRenderedByPinch: false,
        _isPinchLimitReached: false,
        _isRerenderCanvasCreated: false,
        _isPrinting: false,
        _isContainImage: false,
        _isPercentHeight: -1,
        _isPercentWidth: -1,
        _isHeight: false,
        _isWidth: false,
        _isFindboxPresent: false,
        _isTextSearch: false,
        _isTextHighlighted: false,
        _isRequestFired: false,
        _isPageScrollHighlight: false,
        _isPageScrolledForSearch: false,
        _searchAjaxRequestState: null,
        _isPrevSearch: false,
        _isMatchCase: false,
        _isPrintHidden: false,
        _isNavigationHidden: false,
        _isMagnificationHidden: false,
        _isDownloadHidden: false,
        _isTextSearchHidden: false,
        _isZoomCntlHidden: false,
        _isDownloadCntlHidden: false,
        _isToolbarHidden: false,
        _isSignatureHidden: false,
        _viewerAction: {
            getPageModel: 'GetPageModel',
        },
        _scrollTimer: null,
        _isDestroyed: false,
        _pdfService: null,
        _toolbar: null,
        _printIframe: null,
        _currentPrintPage: 0,
        _abortPrinting: false,
        _isWindowResizing: false,
        _ejViewerInstance: null,
        _isAutoZoom: false,
        _isAutoSelected: false,
        _ejDropDownInstance: null,
        _clientx: null,
        _clienty: null,
        _curPosX: null,
        _curPosY: null,
        _previousBounds: null,
        _topValue: false,
        _clearText: false,
        _timers: null,
        _scrollMove: null,
        _rangePosition: null,
        _selectedRanges: null,
        _longTouch: false,
        _ranges: false,
        _touchcontextMenu: false,
        _selectionNodes: null,
        _selectionRange: null,
        _touched: false,
        _lockTimer: null,
        _timer: null,
        _displaySearch: false,
        _isCopyRestrict: false,
        _isPrintRestrict: false,
        _isPageExtraction: false,
        _isFormFieldsDisabled: false,
        _isTargetPage: false,
        _targetPage: 0,
        _isBuffering: false,
        _isBufferStart: false,
        _pagesGot: null,
        _isPrintingProcess: false,
        _isRequestSuccess: false,
        _fileId: null,
        _isFormFields: false,
        _imageObj: null,
        _isJsondataAvailable: false,
        _highestWidth: 0,
        _horizontalResolution: null,
        _isAsynchronousDownload: true,
        _searchedText: null,
        _annotationActive: false,
        _isHighlight: false,
        _isUnderline: false,
        _isStrikeout: false,
        _drawColor: null,
        _selectedAnnotation: null,
        _selectedAnnotationObject: null,
        _isPopupNoteFocused: false,
        _colorpickerObject: null,
        _toolbarColorpickerObject: null,
        _isBackwardSelection: false,
        _isPropertiesWindowOpen: false,
        _isAnnotationSelected: false,
        _currentAnnotationRectangle: [],
        _currentAnnotationRectangleBackup: [],
        _annotationBackupNoteSave: [],
        _isPopupNoteVisible: false,
        _isUnderlineEnabled: false,
        _isHighlightEnabled: false,
        _isStrikeOutEnabled: false,
        _isContextMenuPresent: false,
        _isDefaultColorSet: false,
        _isTextSelection: false,
        _colorPickerStatus: null,
        _annotationsDeletedNo: null,
        _selectedValue: null,
        _highestHeight: 0,
        _removeSearch: false,
        _ajaxInProgress: false,
        _isNonBreackingCharacter: false,
        _mouseDetection: false,
        _oldX: null,
        _mouseX: null,
        _oldY: null,
        _mouseY: null,
        _newObject: [],
        _newx: null,
        _newy: null,
        _outputString: "",
        _completeSign: [],
        _outputPath: {},
        _valueChanges: {},
        _totalSignature: [],
        _isCanvasClicked: false,
        _isCanasResized: false,
        _tempCanvas: null,
        _previousZoomValue: 1,
        _canvasTopPosition: 0,
        _canvasLeftPosition: 0,
        _newpoints: [],
        _maxpointsX :0,
        _minpointsX :0,
        _maxpointsY :0,
        _minpointsY: 0,
        _controlSelectionRange: null,
        _selectionObject: null,
        _cancelDownloads: false,
        _downloadfileName: null,
        _signatureLayer: [],
        //#endregion

        //#region public members
        pageCount: 0,
        currentPageNumber: 1,
        zoomPercentage: 100,
        fileName: null,
        isDocumentEdited: false,
        //#endregion

        //#region Initialization
        _init: function () {
            this._actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.load;
            this._renderViewer();
            this._initViewer();
            this._createContextMenu();
            this._createHighlightContextMenu();
            this._createWaterDropDiv();
            this._createTouchContextMenu();
            this._createPopupMenu();
            this._createNote();
            this._createPropertiesMenu();
            this._createColorPalette();
            this._createSignatureControl();
            var colorPicker = document.getElementById(this._id + '_pdfviewer_colorpicker');
            if (colorPicker) {
                colorPicker.style.display = 'none';
            }
            this._isToolbarColorPicker = false;
            this._ejDropDownInstance = $('#' + this._id + '_toolbar_zoomSelection').data("ejDropDownList");
            this._getPdfService(this.model.pdfService);
            if (this.model.serviceUrl) {
                var jsonResult = new Object();
                jsonResult["viewerAction"] = "GetPageModel";
                jsonResult["controlId"] = this._id;
                jsonResult["pageindex"] = "1";
                jsonResult["isInitialLoading"] = "true";
                if (this.model.allowClientBuffering) {
                    jsonResult["enableOfflineMode"] = true;
                    if (this.model.bufferingMode == ej.PdfViewer.BufferingMode.Default)
                        jsonResult["bufferingMode"] = "default";
                    else if (this.model.bufferingMode == ej.PdfViewer.BufferingMode.Complete)
                        jsonResult["bufferingMode"] = "complete";
                    if (!this._isPrintingProcess) {
                        jsonResult["isPageScrolled"] = false;
                    }
                }

                if (this.model.documentPath) {
                    var documentPath = this.model.documentPath;
                    var base64String = documentPath.split("base64,")[1];
                    var isNotFileName = false; var isFilePath = false;
                    if (!base64String) {
                        //For handling File path
                        if (this.model.documentPath.indexOf('\\') != -1 || this.model.documentPath.indexOf('/') != -1) {
                            isNotFileName = true;
                            isFilePath = true;
                            if (!this.model.documentPath.toLowerCase().endsWith('.pdf')) {
                                documentPath = this.model.documentPath + '.pdf';
                            }
                        } else {
                            var password = documentPath.split(',');
                            if (password.length > 1) {
                                jsonResult["newFileName"] = password[1];
                                jsonResult["password"] = password[0];
                            } else {
                                jsonResult["newFileName"] = documentPath;
                            }
                            this._fileName = jsonResult["newFileName"];
                        }
                    }
                    jsonResult["file"] = documentPath;
                }
                jsonResult["id"] = this._createGUID();
                this._fileId = jsonResult["id"];
                if (!this.model.allowClientBuffering) {
                    if (this._pdfService == ej.PdfViewer.PdfService.Local)
                        this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                    else
                        this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
                } else {
                    if (this.model.bufferingMode == ej.PdfViewer.BufferingMode.Default) {
                        if (this._pdfService == ej.PdfViewer.PdfService.Local)
                            this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel", true);
                        else
                            this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel", true);
                    } else if (this.model.bufferingMode == ej.PdfViewer.BufferingMode.Complete) {
                        if (this._pdfService == ej.PdfViewer.PdfService.Local)
                            this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                        else
                            this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
                    }
                }
            }
            this._printIframe = document.createElement("iframe");
        },

        _getPdfService: function (isLocal) {
            if (isLocal == 1)
                this._pdfService = ej.PdfViewer.PdfService.Local;
            else
                this._pdfService = ej.PdfViewer.PdfService.Remote;
        },

        _initViewer: function () {
            this._wireEvents();
            this._initToolbar();
            this._currentPage = 1;
            this._textMarkupAnnotationList = new Array();
            this._newAnnotationList = new Array();
            this._colorModifiedAnnotationList = new Array();
            this._existingAnnotationsModified = new Array();
            this._deletedAnnotationList = new Array();
            this._undoAnnotationCollection = new Array();
            this._redoAnnotationCollection = new Array();
            this._deletedAnnotationCollection = new Array();
            this._recentOperation = new Array();
            this._annotationsDeletedNo = new Array();
            this._redoActions = new Array();
            this._totalAnnotations = new Array();
            var tbSettings = this.model.toolbarSettings;
            if (!tbSettings.templateId) {
                this._showToolbar(true);
                this._showPrintButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.PrintTools);
                this._showZoomControl(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.MagnificationTools);
                this._showFittoPage(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.MagnificationTools);
                this._showPageNavigationControls(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.PageNavigationTools);
                this._showDownloadButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.DownloadTool);
                this._showTextSearchButton(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.TextSearchTool);
                this._showTextMarkupButtons(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.TextMarkupAnnotationTools);
                this._showSignatureButtons(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.SignatureTool);
                this._showSelectionButtons(tbSettings.toolbarItem & ej.PdfViewer.ToolbarItems.SelectionTool)
            }
            this._showViewerBlock(false);
            this._setContainerSize();
            this._showloadingIndicator(true);
            this._on($('#' + this._id + 'e-pdf-viewer'), "keydown", this._keyboardShortcutFind);
        },

        _unLoad: function () {
            var proxy = this;
            if (this.pageCount != 0) {
                $.ajax({
                    type: "POST",
                    url: this.model.serviceUrl + '/' + this.model.serverActionSettings.unload,
                    crossDomain: true,
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    traditional: true,
                    error: function (msg, textStatus, errorThrown) {
                        proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                    }
                });
            }
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + "0");
            $('#' + this._id + '_txtpageNo').val(0);
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoom');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_Print');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_download');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_search');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_highlight');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_strikeout');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_underline');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_signature');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_select');
            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_scroll');
            var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
            zoomddl._selectItemByIndex(0);
            zoomddl.disable();
            clearTimeout(this._scrollTimer);
            var count = this._canvascount;
            while (count >= 1) {
                $('#' + this._id + 'pageDiv_' + count).remove();
                $('#' + this._id + 'selectioncanvas_' + count).remove();
                count--;
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;
            this._showloadingIndicator(false);
            this._showPageLoadingIndicator(false);
            this._raiseClientEvent("documentUnload", null);
        },

        _destroy: function () {
            this._isDestroyed = true;
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + 0);
            $('#' + this._id + '_txtpageNo').val(0);
            clearTimeout(this._scrollTimer);
            this._unwireEvents();
            var count = this._canvascount;
            while (count >= 1) {
                $('#' + this._id + 'pageDiv_' + count).remove();
                $('#' + this._id + 'selectioncanvas_' + count).remove();
                count--;
            }
            $("#" + this._id + "_PropertiesDialogTab").data('ejTab')._destroy();
            $('#' + this._id + "_signatureContainerDialogTab").data('ejDialog')._destroy();
            $('#' + this._id + '_pdfviewer_colorpicker').data('ejColorPicker')._destroy();
            $('#' + this._id + '_colorpicker').data('ejColorPicker')._destroy();
            $('#' + this._id + '_containerDialogTab').data('ejDialog')._destroy();
            $('#' + this._id + '_pdfviewer_colorpicker_Presets').parent().remove();
            $('#' + this._id + '_signatureContainerDialogTab').remove();
            $('#' + this._id + '_containerDialogTab').remove();
            $('#' + this._id + '_pageviewContainer').remove();
            $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList')._destroy();
            $('#' + this._id + '_pdfviewer_searchbox').data('ejToolbar')._destroy();
            this._toolbar._destroy();
            $('#' + this._id + '_toolbarContainer').remove();
            $('#' + this._id + '_viewerContainer').remove();
            $('#' + this._id + '_viewBlockContainer').remove();
            $('#' + this._id + '_rptTooltip').remove();
            $('#' + this._id + '_loadingIndicator_WaitingPopup').remove();
            $('#' + this._id + '_viewerContainer_WaitingPopup').remove();
            $('#' + this._id + '_WaitingPopup').remove();

            $(this.element).find('.e-pdfviewer-viewer').remove();
            this.element.html("");
            var cloneElement = $(this.element).clone();
            cloneElement.removeClass('e-pdfviewer e-js');
            this.element.replaceWith(cloneElement);
            this._renderedCanvasList.length = 0;
            this._raiseClientEvent("destroy", null);
        },
        //#endregion

        //-------------------- Render the pdfviewer Ctrl [start] -------------------------//

        _renderToolTip: function () {
            var $divTooltip = ej.buildTag("div.e-pdfviewer-tbdiv e-pdfviewer-tooltip", "", { 'display': 'none','min-width': '200px', 'width': '' }, { 'id': this._id + '_rptTooltip' });
            var $tooltipHeader = ej.buildTag("span.e-pdfviewer-headerspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Header' });
            var $tooltipContent = ej.buildTag("span.e-pdfviewer-contentspan", "", { 'display': 'block' }, { 'id': this._id + '_rptTooltip_Content' });
            $divTooltip.append($tooltipHeader);
            $divTooltip.append($tooltipContent);
            return $divTooltip;
        },

        _renderToolBar: function (targetTag) {
            if (!this.model.toolbarSettings.templateId) {
                var div = ej.buildTag("div.e-pdfviewer-toolbarcontainer .e-pdfviewer-viewer", "", { 'width': '100%' }, { 'id': this._id + '_toolbarContainer' });
                targetTag.append(div);

                if (this._isDevice) {
                    var $ultoolbaritems = ej.buildTag("ul.e-pdfviewer-toolbarul", "", {});
                    this._appendToolbarItems($ultoolbaritems, 'zoomin');
                    this._appendToolbarItems($ultoolbaritems, 'zoomout');
                    this._appendToolbarItems($ultoolbaritems, 'fitWidth');
                    this._appendToolbarItems($ultoolbaritems, 'fitPage');
                    div.append($ultoolbaritems);
                } else {
                    var $ulnavigate = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, {});
                    this._appendToolbarItems($ulnavigate, 'gotoprevious');
                    this._appendToolbarItems($ulnavigate, 'gotonext');
                    this._appendToolbarItems($ulnavigate, 'gotopage');
                    div.append($ulnavigate);

                    var $ulzoom = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_zoomul' });
                    this._appendToolbarItems($ulzoom, 'zoomin');
                    this._appendToolbarItems($ulzoom, 'zoomout');
                    this._appendToolbarItems($ulzoom, 'zoom');
                    //Appending the fitWidth and the fitPage buttons to the toolbar
                    this._appendToolbarItems($ulzoom, 'fitWidth');
                    this._appendToolbarItems($ulzoom, 'fitPage');
                    div.append($ulzoom);

                    var $ultextmarkup = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_textmarkupul' });
                    this._appendToolbarItems($ultextmarkup, 'underline');
                    this._appendToolbarItems($ultextmarkup, 'strikeout');
                    this._appendToolbarItems($ultextmarkup, 'highlight');
                    div.append($ultextmarkup);

                    var $ulsignature = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_signatureul' });
                    this._appendToolbarItems($ulsignature, 'signature');
                    div.append($ulsignature);

                    var $ulselect = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'padding-right': '10px' }, { 'id': this._id + '_pdfviewer_selectul' });
                    this._appendToolbarItems($ulselect, 'selection');
                    this._appendToolbarItems($ulselect, 'scrolling');
                    div.append($ulselect);

                    var $uldownload = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_downloadul' });
                    this._appendToolbarItems($uldownload, 'download');
                    div.append($uldownload);

                    var $ulprintExport = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_printul' });
                    this._appendToolbarItems($ulprintExport, 'print');
                    div.append($ulprintExport);

                    var $ulsearch = ej.buildTag("ul.e-pdfviewer-toolbarul", "", { 'float': 'right' }, { 'id': this._id + '_pdfviewer_searchul' });
                    this._appendToolbarItems($ulsearch, 'search');
                    div.append($ulsearch);
                    $('#' + this._id + '_toolbar_zoomSelection').ejDropDownList({ height: "27px", width: "75px", cssClass: "e-pdfviewer-ddl", change: this._zoomValChange, selectedItem: 0 });
                }
                div.ejToolbar({ enableSeparator: !this._isDevice, click: $.proxy(this._toolbarClick, this), itemHover: $.proxy(this._toolbarHover, this), isResponsive: true, overflowClose: $.proxy(this._overflowToolbarClose, this) });
                this._toolbar = $('#' + this._id + '_toolbarContainer').data('ejToolbar');
                $('#' + this._id + '_toolbarContainer_hiddenlist').removeClass("e-responsive-toolbar").addClass("e-pdfviewer-responsivesecondarytoolbar");
                $('#' + this._id + '_pdfviewer_searchul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_printul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_signatureul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_selectul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_downloadul').removeClass('e-separator');
                $('#' + this._id + '_toolbarContainer_hiddenlist').removeClass("e-toolbarspan");
            } else {
                var templateDiv = document.getElementById(this.model.toolbarSettings.templateId);
                targetTag.append(templateDiv);
                templateDiv.ejToolbar({ enableSeparator: true, height: templateDiv.height(), click: this.model.toolbarSettings.click, isResponsive: true });
                templateDiv.css('display', 'block');
            }
        },

        _appendToolbarItems: function (litag, eletype) {
            var $divouter;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            switch (eletype) {
                case 'print':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_Print' });
                    var $spanprint = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-print", "", {}, { 'id': this._id + '_toolbar_Print' });
                    $divouter.append($spanprint);
                    break;
                case 'download':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_download' });
                    var $spandownload = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-download", "", {}, { 'id': this._id + '_toolbar_download' });
                    $divouter.append($spandownload);
                    break;
                case 'gotofirst':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotofirst' });
                    var $spangotofirst = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotofirst", "", {});
                    $divouter.append($spangotofirst);
                    break;
                case 'gotolast':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotolast' });
                    var $spangotolast = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotolast", "", {});
                    $divouter.append($spangotolast);
                    break;
                case 'gotonext':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotonext' });
                    var $spangotonext = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotonext", "", {});
                    $divouter.append($spangotonext);
                    break;
                case 'gotoprevious':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_gotoprevious' });
                    var $spangotoprevious = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-gotoprevious", "", {});
                    $divouter.append($spangotoprevious);
                    break;
                case 'gotopage':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli-label", "", {}, { 'id': this._id + '_pdfviewer_toolbar_pageli' });
                    var $divouterdiv = ej.buildTag("div.e-pdfviewer-tbpage", "", { 'display': 'block', 'overflow' : 'visible' }, {});
                    var $inputpageno = ej.buildTag("input.e-pdfviewer-pagenumber e-pdfviewer-elementalignments ejinputtext", "", {}, { 'type': 'text', 'value': '0', 'id': this._id + '_txtpageNo', 'data-role': 'none' });
                    var $spanpageno = ej.buildTag("span.e-pdfviewer-labelpageno", "", {}, {});
                    $divouterdiv.append($inputpageno);
                    $divouterdiv.append($spanpageno);
                    $divouter.append($divouterdiv);
                    break;
                case 'zoomin':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoomin' });
                    var $spanzoomin = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-zoomin", "", {}, { 'id': this._id + '_toolbar_zoomin' });
                    $divouter.append($spanzoomin);
                    break;
                case 'zoomout':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoomout' });
                    var $spanzoomout = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-zoomout", "", {}, { 'id': this._id + '_toolbar_zoomout' });
                    $divouter.append($spanzoomout);
                    break;
                case 'zoom':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli-label", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoomli' });
                    var $divouterdiv = ej.buildTag("div.e-pdfviewer-ejdropdownlist", "", {}, { 'id': this._id + '_pdfviewer_toolbar_zoom' });
                    var $sltzoom = ej.buildTag("select.e-pdfviewer-tbdiv e-pdfviewer-zoomlist", "", {}, { 'id': this._id + '_toolbar_zoomSelection', 'data-role': 'none' });
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    var text = localeObj['contextMenu']['auto']['contentText'];
                    $sltzoom.append("<option Selected>" + text + "</option>");
                    $sltzoom.append("<option>50%</option>");
                    $sltzoom.append("<option>75%</option>");
                    $sltzoom.append("<option>100%</option>");
                    $sltzoom.append("<option>125%</option>");
                    $sltzoom.append("<option>150%</option>");
                    $sltzoom.append("<option>200%</option>");
                    $sltzoom.append("<option>400%</option>");
                    $divouterdiv.append($sltzoom);
                    $divouter.append($divouterdiv);
                    break;
                    //Creating the fitWidth and the fitPage spans in the HTML page and appending them to the toolbar of the PDF viewer
                case 'fitWidth':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_fitWidth' });
                    var $spanexport = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-fitwidth", "", {}, { 'id': this._id + '_fitWidth' });
                    $divouter.append($spanexport);
                    break;
                case 'fitPage':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_fitPage' });
                    var $spanFitPage = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-fitpage", "", {}, { 'id': this._id + '_fitPage' });
                    $divouter.append($spanFitPage);
                    break;
                case 'search':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli", "", {}, { 'id': this._id + '_pdfviewer_toolbar_search' });
                    var $spansearch = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-find", "", {}, { 'id': this._id + '_find' });
                    $divouter.append($spansearch);
                    break;
                case 'highlight':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-highlight", "", {}, { 'id': this._id + '_pdfviewer_toolbar_highlight' });
                    var $spanhighlight = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-highlight-markup", "", {}, { 'id': this._id + '_highlight_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_highlight_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_highlight_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanhighlight);
                    $divouter.append(dropdownspan);
                    break;
                case 'underline':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-underline", "", {}, { 'id': this._id + '_pdfviewer_toolbar_underline' });
                    var $spanunderline = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-underline-markup", "", {}, { 'id': this._id + '_underline_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_underline_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_underline_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanunderline);
                    $divouter.append(dropdownspan);
                    break;
                case 'strikeout':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-strikeout", "", {}, { 'id': this._id + '_pdfviewer_toolbar_strikeout' });
                    var $spanstrikeout = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-strikeout-markup", "", {}, { 'id': this._id + '_strikeout_markup' });
                    var dropdownspan = ej.buildTag("span.e-pdfviewer-dropdown-wrapper", "", {}, { 'id': this._id + '_strikeout_dropdown' });
                    var dropdownarrowspan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-dropdown-arrow", "", {}, { 'id': this._id + '_strikeout_dropdown_arrow' });
                    dropdownspan.append(dropdownarrowspan);
                    $divouter.append($spanstrikeout);
                    $divouter.append(dropdownspan);
                    break;
                case 'signature':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-sign", "", {}, { 'id': this._id + '_pdfviewer_toolbar_signature' });
                    var $spansign = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-sign", "", {}, { 'id': this._id + '_sign' });
                    $divouter.append($spansign);
                    break;
                case 'selection':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-select", "", {}, { 'id': this._id + '_pdfviewer_toolbar_select' });
                    var $spansign = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-select", "", {}, { 'id': this._id + '_select' });
                    $divouter.append($spansign);
                    break;
                case 'scrolling':
                    $divouter = ej.buildTag("li.e-pdfviewer-toolbarli e-pdfviewer-toolbar-scroll", "", {}, { 'id': this._id + '_pdfviewer_toolbar_scroll' });
                    var $spansign = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-scroll", "", {}, { 'id': this._id + '_scroll' });
                    $divouter.append($spansign);
                    break;
            }
            litag.append($divouter);
        },

        _renderViewerBlockinWeb: function (targetTag) {
            var div = ej.buildTag("div.e-pdfviewer-viewer e-pdfviewer-viewerblock", "", {}, { 'id': this._id + '_viewBlockContainer' });
            targetTag.append(div);

            var $innerContent = ej.buildTag("table.e-pdfviewer-viewerblockcellcontent", "", { 'margin': '1px', 'padding': '5px 5px 10px' });
            var $tr = ej.buildTag("tr", "", { 'width': '100%' });
            var $tdleft = ej.buildTag("td.e-pdfviewer-viewerblockcontent", "", {});
            $tr.append($tdleft);
            $innerContent.append($tr);
            div.append($innerContent);
            return div;
        },

        _renderViewerContainer: function (targetTag) {
            var div = ej.buildTag("div", "", {}, { 'id': this._id + '_pdfviewerContainer' });
            targetTag.append(div);

            var $pdfviewContainer = ej.buildTag("div.e-pdfviewer-viewer e-pdfviewer-scrollcontainer e-pdfviewer-viewercontainer", "", { 'height': '100%', 'width': '100%', 'font-size': '8pt' }, { 'id': this._id + '_viewerContainer' });
            var $loadingindicator = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%' }, { 'id': this._id + '_loadingIndicator' });
            var $loadingemptybackview = ej.buildTag("div", "", { 'margin': '0px', 'height': '99.8%', 'width': '100%', 'background-color': 'rgba(164, 183, 216, 0.18)', 'display': 'block' }, { 'id': this._id + '_loadingIndicatorBackView' });

            var $pageviewContainer = ej.buildTag("div", "", {}, { 'id': this._id + '_pageviewContainer' });

            $loadingindicator.append($loadingemptybackview);
            $pdfviewContainer.append($loadingindicator);

            $pdfviewContainer.append($pageviewContainer);

            if (this._isDevice) {
                this._renderViewerBlockinDevice($pdfviewContainer);
            }

            div.append($pdfviewContainer);

            return div;
        },

        _renderViewer: function () {
            var height = this.element.height();
            var width = this.element.width();
            //control root div tag.
            var viewer = ej.buildTag("div.e-pdfviewer-viewer", "", {}, { 'id': this._id + 'e-pdf-viewer' });

            if (!this.element[0].style.height && this.element[0].parentElement.clientHeight != 0) {
                this._isHeight = true;
            }

            if (!this.element[0].style.width && this.element[0].parentElement.clientWidth != 0) {
                this._isWidth = true;
            }

            if (height === 0 && this.element[0].parentElement.clientHeight != 0) {
                this.element.height(this.element[0].parentElement.clientHeight);
            }

            if (width === 0 && this.element[0].parentElement.clientWidth != 0) {
                this.element.width(this.element[0].parentElement.clientWidth);
            }

            this.element.append(viewer);
            this._renderToolBar(viewer);
            if (!this._isDevice) {
                this._renderViewerBlockinWeb(viewer);
                var tooltip = this._renderToolTip();
            }
            var div = this._renderViewerContainer(viewer);
            div.append(tooltip);
            this._renderSearchBox();
        },

        _renderSearchBox: function () {
            var div = ej.buildTag('div.e-pdfviewer-searchbox e-pdfviewer-arrow', "", {}, { 'id': this._id + '_pdfviewer_searchbox' });
            var ulItem = ej.buildTag('ul.e-pdfviewer-toolbarul-search', "", {});
            div.append(ulItem);
            var inputLi = ej.buildTag('li.e-pdfviewer-toolbarli-label', "", {}, {});
            var inputContainer = ej.buildTag('div.e-pdfviewer-searchboxitem e-pdfviewer-search-inputcontainer', "", {}, {});
            var findLabel = ej.buildTag('span.e-pdfviewer-label e-pdfviewer-searchboxitem', "Find : ", { 'float': 'left', 'padding-top': '1px', 'margin-right': '5px', 'width': '32px', 'overflow': 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }, {id: this._id+'_pdfviewer_findlabel'});
            var input = ej.buildTag('input.e-pdfviewer-searchinput e-pdfviewer-elementalignments ejinputtext', '', { 'width': '150px' }, { 'id': this._id + '_pdfviewer_searchinput' });
            inputContainer.append(findLabel);
            inputContainer.append(input);
            inputLi.append(inputContainer);
            var prevbutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-previous', '', { 'float': 'left' }, { 'id': this._id + '_pdfviewer_previous_search' });
            var nextbutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-next', '', { 'float': 'left' }, { 'id': this._id + '_pdfviewer_next_search' });
            var closebutton = ej.buildTag('li.e-pdfviewer-toolbarli-search e-pdfviewer-search-close', '', { 'float': 'left', 'margin-left': '4px' }, { 'id': this._id + '_pdfviewer_close_search' });
            var prevBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-prevfind", "", {}, { 'id': this._id + '_prevfind' });
            prevbutton.append(prevBtnSpan);
            $(prevbutton).css({ "pointer-events": "none", "opacity": "0.6" });
            $(nextbutton).css({ "pointer-events": "none", "opacity": "0.6" });
            var nextBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-nextfind", "", {}, { 'id': this._id + '_nextfind' });
            nextbutton.append(nextBtnSpan);
            var checkboxLi = ej.buildTag('li.e-pdfviewer-toolbarli-label', "", {}, {});
            var checkboxContainer = ej.buildTag('div.e-pdfviewer-searchboxitem e-pdfviewer-search-checkboxcontainer', "", { 'float': 'left', 'overflow':'visible' }, {});
            var checkbox = ej.buildTag("input", "", {}, { 'type': 'checkbox' });
            var spanElement = ej.buildTag("span.e-pdfviewer-label e-pdfviewer-searchboxitem", "Match case", { 'float': 'left', 'padding-top': '3px', 'margin-left': '5px', 'margin-top': '4px', 'width': '70.5px', 'overflow': 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }, { id: this._id + '_pdfviewer_matchlabel' });
            checkboxContainer.append(checkbox);
            checkboxContainer.append(spanElement);
            checkboxLi.append(checkboxContainer);
            var closeBtnSpan = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-closefind", "", {}, { 'id': this._id + '_closefind' });
            closebutton.append(closeBtnSpan);
            ulItem.append(inputLi);
            ulItem.append(prevbutton);
            ulItem.append(nextbutton);
            ulItem.append(checkboxLi);
            ulItem.append(closebutton);
            div.ejToolbar({ enableSeparator: false, isResponsive: false, width: '400px', hide: true, itemHover: $.proxy(this._toolbarHover, this) });
            checkbox.ejCheckBox({ cssClass: 'e-pdfviewer-match-checkbox', id: this._id + '_search_matchcase', size: ej.CheckboxSize.Medium, change: $.proxy(this._matchcase, this) });
            checkbox.ejCheckBox("disable");
            $('#' + this._id + '_pdfviewerContainer').append(div);
        },

        _createColorPalette: function () {
            var palette = ej.buildTag('div.e-pdfviewer-colorpicker', "", {}, { 'id': this._id + '_pdfviewer_colorpicker' });
            $('#' + this._id + '_pdfviewerContainer').append(palette);
            palette.ejColorPicker({ displayInline: true, modelType: "palette", change: $.proxy(this._setDrawColor, this) });
            this._toolbarColorpickerObject = palette.data('ejColorPicker');
        },
        //-------------------- Render the pdfviewer Ctrl [End] -------------------------//

        //-------------------- Apply Page Style and Actions [Start] -------------------------//
        _setContainerSize: function () {
            var control = document.getElementById(this._id);
            if (control) {
                var ctrlheight = control.clientHeight;
                var viewerblockHeight = 0;
                if (!this._isDevice) {
                    var viewerContainer = $('#' + this._id + '_viewBlockContainer');
                    if (viewerContainer.css('display').toLowerCase() == 'block') {
                        viewerblockHeight = viewerContainer.height();
                    }
                }

                var toolbarHeight = this.model.toolbarSettings.templateId ? $('#' + this.model.toolbarSettings.templateId).height() : $('#' + this._id + '_toolbarContainer').height();

                var calcHeight = ctrlheight - viewerblockHeight - toolbarHeight - 4;
                $('#' + this._id + '_viewerContainer').css({ "height": calcHeight + "px" });
            }
        },

        _setPageSize: function (pageHeight, pageWidth, headerHeight, footerHeight) {
            headerHeight = 0;
            var scalePageSize = $('#' + this._id + '_pageviewContainer')[0].getBoundingClientRect();
            var ins = this;
            this._renderPreviousPage = false;
            $('#' + this._id + '_viewerContainer').unbind('scroll').on('scroll', function () {
                ins._computeCurrentPage(pageHeight);
            });
            $('#' + this._id + '_pageviewContainer').mouseup(function (e) {
                ins._raiseClientEvent("pageClick", e);
            });
            //timer
            this._scrollTimer = setInterval(function () { ins._pageviewscrollchanged(pageHeight) }, 500);
            ins._backgroundPage = 1;

            this._previousZoom = 1;
            ins._previousPage = ins._currentPage;
            if (!this.model.allowClientBuffering) {
                this._pageLocation = new Array();
                this._renderedCanvasList = new Array();
                this._pageContents = new Array();
                this._pageText = new Array();
                this._textDivs = new Array();
                this._textContents = new Array();
                this._searchMatches = new Array();
                this._searchCollection = new Array();
                this._pageLocation[1] = 0;
                this._searchedPages = new Array();
                this._canvascount = this._totalPages;
                this._pointers = new Array();
                this._imageObj = new Array();
                this._pagesGot = new Array();
                this._imageSrcCollection = new Array();
                this._selectionPages = new Array();
            }
            this._designPageCanvas();
        },

        _designPageCanvas: function () {
            var cummulativepageheight = 5;
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            var w = pageViewerContainer.width();
            var h = pageViewerContainer.height();
            var pageW = this._pageWidth;
            var pageH = this._pageHeight;
            var scaleX = 1;
            var scaleY = 1;
            scaleX = (w - 25) / pageW;
            scaleX = Math.min(1, scaleX);
            this._zoomVal = scaleX;
            for (var index = 1; index <= this._totalPages; index++) {
                var leftpos;
                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[index - 1].PageHeight) / 2;
                } else {
                    leftpos = (this.element.width() - this._pageSize[index - 1].PageWidth) / 2;
                }
                if (leftpos < 0)
                    leftpos = 5;
                var imageDiv = ej.buildTag("div", "", {}, { id: this._id + 'pageDiv_' + index });
                pageviewcontainer.append(imageDiv);
                imageDiv.css("position", "absolute");
                imageDiv.css("top", this._zoomVal * cummulativepageheight);
                imageDiv.css("left", leftpos + "px");
                this._pageLocation[index] = cummulativepageheight;
                var imgwidth = '100%';
                var imgheight = '100%';

                var secondarycanvas = document.createElement('canvas');
                secondarycanvas.id = this._id + '_secondarycanvas_' + index;
                secondarycanvas.className = 'e-pdfviewer-secondarycanvas';
                secondarycanvas.style.position = 'absolute';
                secondarycanvas.style.left = 0;
                secondarycanvas.style.top = 0;
                secondarycanvas.style.backgroundColor = 'transparent';
                imageDiv.append(secondarycanvas);
                var proxy = this;

                var canvas = document.createElement('canvas');
                canvas.id = this._id + "pagecanvas_" + index;
                canvas.className = "e-pdfviewer-pageCanvas";
                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    canvas.width = this._zoomVal * this._pageSize[index - 1].PageHeight;
                    canvas.height = this._zoomVal * this._pageSize[index - 1].PageWidth;
                    canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
                } else {
                    canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                    canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                    canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                }
                canvas.style.backgroundColor = "white";
                imageDiv.append(canvas);

                secondarycanvas.height = canvas.height;
                secondarycanvas.width = canvas.width;
                secondarycanvas.style.height = canvas.height + 'px';
                secondarycanvas.style.width = canvas.width + 'px';

                var selectionlayer = document.createElement('div');
                selectionlayer.id = this._id + 'selectioncanvas_' + index;
                selectionlayer.className = 'e-pdfviewer-selectiondiv';
                selectionlayer.style.height = canvas.height + 'px';
                selectionlayer.style.width = canvas.width + 'px';
                selectionlayer.style.position = 'absolute';
                selectionlayer.style.left = 0;
                selectionlayer.style.top = 0;
                selectionlayer.style.backgroundColor = 'transparent';
                selectionlayer.style.zIndex = '2';
                imageDiv.append(selectionlayer);
                //Add loading indicator in every page
                $('#' + this._id + 'pageDiv_' + index).ejWaitingPopup({ showOnInit: true, appendTo: '#' + this._id + 'pageDiv_' + index, target: '#' + this._id + 'pageDiv_' + index });
                $('#' + this._id + 'pageDiv_' + index + '_WaitingPopup').appendTo($('#' + this._id + 'pageDiv_' + index)).css({ 'left': '0px', 'top': '0px', 'background-color': '#dbdbdb' });

                if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                    cummulativepageheight = parseFloat(cummulativepageheight) + parseFloat(this._pageSize[index - 1].PageWidth) + 8;
                } else {
                    cummulativepageheight = parseFloat(cummulativepageheight) + parseFloat(this._pageSize[index - 1].PageHeight) + 8;
                }
            }
            this._cummulativeHeight = cummulativepageheight;
        },

        _computeCurrentPage: function (pageHeight) {
            var sum = 0;
            var currentPageNum = 0;
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolvalue = vscrolBar.scrollTop;
            if (this._zoomVal != 1) {
                vscrolvalue = vscrolvalue + ((this._currentPage) * (8 - this._zoomVal * 8));
            }
            var pagevalue = 0;
            var pageupdatevalue = 0;
            var pagenumbervalue = { currentPageNumber: 0 };
            for (var i = 0; i < this._totalPages; i++) {
                if (this._isDestroyed)
                    return;
                if (sum > vscrolvalue && vscrolvalue >= 0) {
                    currentPageNum = i;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    var elementOffset = $('#' + this._id + 'pageDiv_' + currentPageNum)[0];
                    if (elementOffset != undefined && elementOffset != null) {
                        var offset = elementOffset.getBoundingClientRect();
                        var bottom = offset.bottom;
                        var pdfViewerElements = $('#' + this._id + 'e-pdf-viewer')[0];
                        var heights = parseInt(pdfViewerElements.getBoundingClientRect().height);
                        var toolbarHeight = this.model.toolbarSettings.templateId ? $('#' + this.model.toolbarSettings.templateId).height() : $('#' + this._id + '_toolbarContainer').height();
                        var pageheight = parseInt($(pageviewcontainer).css("height")) - toolbarHeight;
                        var currentDifference = heights - pageheight;
                        var currentpageheightinview = parseFloat(sum) - parseFloat(vscrolvalue);
                        var containerHeight = parseFloat(this.element[0].parentElement.children[0].style.height);
                        var nextpageheightinview = this.element[0].parentElement.clientHeight - currentpageheightinview;
                        if (this.element[0].parentElement.clientHeight < ((this._pageSize[i - 1].PageHeight * this._zoomVal) + (this._pageSize[i].PageHeight * this._zoomVal)) && (parseInt(this._pageLocation[i] * this._zoomVal) < pageviewcontainer.scrollTop)) {
                            if (nextpageheightinview > currentpageheightinview && (bottom <= (290 + currentDifference))) {
                                currentPageNum = parseFloat(currentPageNum) + 1;
                                $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("visibility", "");
                                this._renderPreviousPage = true;
                            }
                        }
                        else if (this._pageSize[i - 1].PageOrientation == "Landscape" && pageviewcontainer.scrollTop > parseInt(this._pageLocation[i] * this._zoomVal) && containerHeight <= 600) {
                            currentPageNum = parseFloat(currentPageNum) + 1;
                            $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("visibility", "");
                            this._renderPreviousPage = true;
                        }
                        this._renderPreviousPage = false;
                        break;
                    }
                }

                else {
                    if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                        sum = parseFloat(sum) + parseFloat(this._pageSize[i].PageWidth * this._zoomVal) + 8;
                    } else {
                        sum = parseFloat(sum) + parseFloat(this._pageSize[i].PageHeight * this._zoomVal) + 8;
                    }
                }
                if (vscrolvalue >= 0) {
                    currentPageNum = i + 1;
                }
                else {
                    currentPageNum = 1;
                }
            }
            if (this._fitType == "fitToPage") {
			    var currentPageHeight = parseFloat($('#' + this._id + 'pageDiv_' + (currentPageNum)).css("height"));
                var currentPageTop = this._pageLocation[currentPageNum] * this._zoomVal;
                var viewerContainerHeight = parseFloat($(pageviewcontainer).css("height"));
                var totalHeight = ((viewerContainerHeight - currentPageHeight) / 2);
                $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("top", (currentPageTop + totalHeight) + "px");
                $('#' + this._id + 'pageDiv_' + (currentPageNum + 1)).css("visibility", "hidden");
                $('#' + this._id + 'pageDiv_' + (currentPageNum - 1)).css("visibility", "hidden");
            }
            $('#' + this._id + 'pageDiv_' + (currentPageNum)).css("visibility", "");
            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
            pagevalue = document.getElementById(this._id + "_txtpageNo").value;
            $('#' + this._id + '_txtpageNo').val(currentPageNum);
            this._updatePageNavigation(currentPageNum, this._totalPages);
            pageupdatevalue = document.getElementById(this._id + "_txtpageNo").value;
            pagenumbervalue.currentPageNumber = pageupdatevalue;
            this._currentPage = currentPageNum;
            this.currentPageNumber = this._currentPage;
            if (pagevalue != pageupdatevalue) {
                this._raiseClientEvent("pageChange", pagenumbervalue);
            }
        },

        _pageviewscrollchanged: function (pageHeight) {
            var sum = 0;
            var currentPageNum = 0;
            var vscrolvalue = $('#' + this._id + '_viewerContainer').scrollTop();
            if (this._isTargetPage) {
                if (this.model.allowClientBuffering && this.model.bufferingMode == ej.PdfViewer.BufferingMode.Default) {
                    this._isTargetPage = false;
                    this._isBuffering = true;
                    if (this._targetPage <= this._totalPages) {
                        if (!this._isBufferStart) {
                            this._raiseClientEvent("bufferStart", this._isBuffering);
                            this._isBufferStart = true;
                        }
                        var jsonString = { "viewerAction": this._viewerAction.getPageModel, "pageindex": this._targetPage.toString(), "enableOfflineMode": true, "bufferingMode": "default", "isPageScrolled": false };
                        var proxy = this;
                        this._ajaxRequestState = $.ajax({
                            type: 'POST',
                            url: this.model.serviceUrl + '/' + this.model.serverActionSettings.load,
                            crossDomain: true,
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            data: JSON.stringify(jsonString),
                            traditional: true,
                            success: function (data) {
                                if (typeof data === 'object')
                                    jsondata = JSON.parse(JSON.stringify(data));
                                else
                                    jsondata = JSON.parse(data);
                                jsondata = jsondata["pdf"];
                                var count = 0;
                                var isLoopBreak = false;
                                if (jsondata) {
                                    for (var i = proxy._targetPage; i <= proxy._totalPages; i++) {
                                        var backupjson = jsondata[i];
                                        if (backupjson) {
                                            proxy._pageContents[parseInt(backupjson["currentpage"])] = JSON.stringify(backupjson);
                                            proxy._pageText[parseInt(backupjson["currentpage"])] = backupjson["pageContents"];
                                            proxy._pagesGot.push(parseInt(backupjson["currentpage"]));
                                            count++;
                                        } else {
                                            isLoopBreak = true;
                                            break;
                                        }
                                    }
                                    if (backupjson == undefined && !isLoopBreak) {
                                        for (var i = proxy._targetPage; i <= proxy._totalPages; i++) {
                                            if (proxy._pagesGot.indexOf(i)) {
                                                count++;
                                            }
                                        }
                                    }
                                    if (count) {
                                        proxy._targetPage = proxy._targetPage + count;
                                    } else {
                                        proxy._targetPage = proxy._targetPage
                                    }
                                    if (proxy._targetPage >= proxy._totalPages) {
                                        proxy._raiseClientEvent("bufferEnd", this._isBuffering);
                                        proxy._isBufferStart = false;
                                    }
                                    proxy._isTargetPage = true;
                                    proxy._isBuffering = false;
                                }
                            },
                            error: function () {

                            }
                        });
                    }
                }
            }
            if (vscrolvalue == this._previousPosition) {
                currentPageNum = this._currentPage;

                if (this._totalPages && this._previousPage != currentPageNum) {
                    var pagenumber = parseInt(currentPageNum);
                    this._previousPage = currentPageNum;
                    if (pagenumber >= 1 && pagenumber <= this._totalPages) {
                        if (!this._isJsondataAvailable) {
                            this._showloadingIndicator(true);
                            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html("");
                            $('#' + this._id + '_txtpageNo').val('0');
                        }
                        else {

                            $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
                            $('#' + this._id + '_txtpageNo').val(pagenumber);
                        }
                        this._currentPage = pagenumber;
                        this._updatePageNavigation(this._currentPage, this._totalPages);
                        if (this._renderedCanvasList.indexOf(parseInt(this._currentPage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && !this._pageContents[parseInt(this._currentPage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = this._currentPage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                    }
                }
            }
            if (this._renderedCanvasList.indexOf(parseInt(this._currentPage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && this._currentPage <= this._totalPages) {
                if (!this._pageContents[parseInt(this._currentPage)]) {
                    if (!this._scrollTriggered) {
                        this._scrollTriggered = true;
                        var jsonResult = new Object();
                        jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                        jsonResult["pageindex"] = this._currentPage.toString();
                        jsonResult["id"] = this._fileId;
                        if (this._pdfService == ej.PdfViewer.PdfService.Local)
                            this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                        else
                            this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                    }
                }
                else {
                    var jsdata = this._pageContents[parseInt(this._currentPage)];
                    this._drawPdfPage(jsdata);
                }
            }
            var nextpage = parseInt(this._currentPage) + 1;
            if (this.model.allowClientBuffering) {
                if (!this._renderPreviousPage) {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    } else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    var isTargetFire = true;
                                    if (!this._isPrintingProcess) {
                                        jsonResult["isPageScrolled"] = false;
                                    }
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult), isTargetFire);
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
                else {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this.model.allowClientBuffering) {
                                    jsonResult["isPageScrolled"] = true;
                                }
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
            } else {
                if (!this._renderPreviousPage) {
                    if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
                else {
                    if (this._renderedCanvasList.indexOf(parseInt(this._currentPage) - 1) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && (parseInt(this._currentPage) - 1) > 0) {
                        if (!this._pageContents[parseInt(this._currentPage) - 1]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = (parseInt(this._currentPage) - 1).toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(this._currentPage) - 1];
                            this._drawPdfPage(jsdata);
                        }
                    }
                    else if (this._renderedCanvasList.indexOf(parseInt(nextpage)) == -1 && (!this._scrollTriggered || this.model.allowClientBuffering) && nextpage <= this._totalPages) {
                        if (!this._pageContents[parseInt(nextpage)]) {
                            if (!this._scrollTriggered) {
                                this._scrollTriggered = true;
                                var jsonResult = new Object();
                                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                                jsonResult["pageindex"] = nextpage.toString();
                                jsonResult["id"] = this._fileId;
                                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                                    this._doAjaxPostscroll("POST", this._actionUrl, JSON.stringify(jsonResult));
                                else
                                    this._doAjaxPostscroll("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                            }
                        }
                        else {
                            var jsdata = this._pageContents[parseInt(nextpage)];
                            this._drawPdfPage(jsdata);
                        }
                    }
                }
            }
            this._previousPosition = vscrolvalue;
            var proxy = this;
            setTimeout(function () {
                $('.e-pdfviewer-formFields').show();
                if (proxy.model) {
                    var localeObj = ej.PdfViewer.Locale[proxy.model.locale] ? ej.PdfViewer.Locale[proxy.model.locale] : ej.PdfViewer.Locale["default"];
                    var text = localeObj['contextMenu']['auto']['contentText'];
                    var zoomddl = $('#' + proxy._id + '_toolbar_zoomSelection').data('ejDropDownList');
                    if (zoomddl) {
                        var values = $('#' + proxy._id + '_toolbar_zoomSelection_hidden').val();
                        $('#' + proxy._id + '_toolbar_zoomSelection_popup li')[0].innerHTML = text;
                        var index = zoomddl.selectedIndex();
                        if (index == 0 && isNaN(parseFloat(values))) {
                            $('#' + proxy._id + '_toolbar_zoomSelection_hidden').val(text);
                            proxy._ejDropDownInstance.model.value = text;
                        }
                        proxy._searchBoxLocalization();
                    }
                }
                if (proxy._selectionRange != null && !proxy._displaySearch) {
                    proxy._selectionNodes.addRange(proxy._selectionRange);
                    proxy._selectionRange = null;
                    proxy._selectionNodes = null;
                }
            }, 5000);
            setTimeout(function () {
                if (proxy._controlSelectionRange != null && proxy._selectionObject != null) {
                    proxy._selectionNodes.removeAllRanges();
                    proxy._clearHighlightDiv();
                    var range = document.createRange();
                    range.setStart(proxy._controlSelectionRange.startContainer.childNodes[0], proxy._selectionObject.anchorOffset);
                    range.setEnd(proxy._controlSelectionRange.endContainer.childNodes[0], proxy._selectionObject.focusOffset);
                    proxy._selectionNodes.addRange(range);
                    proxy._controlSelectionRange = null;
                    proxy._selectionNodes = null;
                    proxy._selectionObject = null;
                }
            }, 0.5);
        },

        _doAjaxPostscroll: function (type, url, jsonResult, isTargetFire) {
            var proxy = this;
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            this._ajaxInProgress = true;
            ($.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    proxy._ajaxInProgress = false;
                    if (typeof data === 'object')
                        proxy._drawPdfPage(JSON.stringify(data));
                    else
                        proxy._drawPdfPage(data);
                    proxy._scrollTriggered = false;
                    if (proxy._searchText && proxy._isRequestFired) {
                        if (typeof data === 'object')
                            var backupjson = (JSON.stringify(data));
                        else
                            var backupjson = data;
                        if (typeof data === 'object') {
                            if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                                jsondata = JSON.parse((JSON.stringify(data)));
                            else
                                jsondata = JSON.parse((JSON.stringify(data))["d"]);
                        }
                        else {
                            if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                                jsondata = JSON.parse(data);
                            else
                                jsondata = JSON.parse(data["d"]);
                        }
                        proxy._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                        proxy._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                        if (proxy._searchText && proxy._isRequestFired) {
                            proxy._initSearch(proxy._searchPageIndex);
                        }
                    }
                    if (isTargetFire) {
                        if (proxy.model.allowClientBuffering) {
                            if (typeof data === 'object')
                                var jsonData = JSON.parse(JSON.stringify(data));
                            else
                                var jsonData = JSON.parse(data);
                            proxy._pagesGot.push(parseInt(jsonData["currentpage"]));
                            if (parseInt(jsonData["currentpage"]) <= proxy._totalPages) {
                                proxy._targetPage = jsonData["currentpage"] + 1;
                                proxy._isTargetPage = true;
                            }
                        }
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (msg.readyState == 0) {
                        return;
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }));
        },

        _drawPdfPage: function (jsondata) {
            var backupjson = jsondata;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsondata = JSON.parse(jsondata);
            else
                jsondata = JSON.parse(jsondata["d"]);
            this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
            var pageindex = parseInt(jsondata["currentpage"]);
            if (!this._isWindowResizing)
                this._showPageLoadingIndicator(pageindex, true);
            var pageimageList = jsondata["imagestream"];
            var canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));    
            if (canvas && this.model) {
                var context = canvas.getContext('2d');
                var ratio = this._scalingTextContent(context);
                if (this._pageSize[pageindex - 1].PageRotation == 90 || this._pageSize[pageindex - 1].PageRotation == 270) {
                    canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth;
                    canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight;
                    canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
                }
                else {
                    canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth * ratio;
                    canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight * ratio;
                    canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                    canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
                }
                this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                this._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                this._imageObj = new Array();
                if (!$('#' + this._id + 'selectioncanvas_' + pageindex).hasClass('text_container')) {
                    this._textSelection(jsondata, pageindex, context);
                    this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])] = jsondata["textMarkupAnnotation"];
                    if (this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])]) {
                        this._totalAnnotations[pageindex] = jsondata["textMarkupAnnotation"].slice();
                    }
                } else {
                    this._resizeSelection(jsondata, pageindex, context);
                }
                if (!$('#' + this._id + 'selectioncanvas_' + pageindex).hasClass('input_container')) {
                    this._createFormFields(jsondata, pageindex);
                } else {
                    this._generateFormFields(jsondata, pageindex);
                }
                if (navigator.userAgent.indexOf("Firefox") != -1) {
                    var shapes = pageimageList["textelements"];
                    for (var n = 0; n < shapes.length; n++) {
                        var pathdata = shapes[n];
                        var textureBrush = pathdata["textureBrushs"];
                        if (textureBrush) {
                            var textureImageData = pathdata.texturFields[0].Image;
                            var imageData = "data:image/png;base64," + textureImageData;
                            var imageObjects = new Image();
                            imageObjects.src = imageData;
                            this._imageSrcCollection.push(imageObjects.src);
                        }
                    }
                }
                if (this._isTextSearch) {
                    var proxy = this;
                    setTimeout(function () {
                        proxy._isPageScrollHighlight = true;
                        proxy._isPageScrolledForSearch = true;
                        proxy._highlightOtherOccurrences();
                    }, 100)
                }
                // Hyperlink
                var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
                for (i = 0; i < children.length; i++) {
                    if (children[i].hasAttribute('href'))
                        $(children[i]).remove();
                }
                var linkannot = jsondata["linkannotation"];
                var documentlinkpagenumber = jsondata["annotpagenum"];
                var ins = this;
                if (this.model.enableHyperlink) {
                    for (var l = 0; l < linkannot.length; l++) {
                        var aTag = document.createElement('a');
                        aTag.id = 'linkdiv_' + l;
                        var rect = linkannot[l].AnnotRectangle;
                        aTag.style.background = 'transparent';
                        aTag.style.position = 'absolute';
                        aTag.style.left = this._convertPointToPixel(rect.Left * this._zoomVal) + 'px';
                        aTag.style.top = this._convertPointToPixel(rect.Top * this._zoomVal) + 'px';
                        aTag.style.width = this._convertPointToPixel(rect.Width * this._zoomVal) + 'px';
                        aTag.style.height = this._convertPointToPixel(rect.Height * this._zoomVal) + 'px';
                        aTag.style.color = 'transparent';
                        if (linkannot[l].URI.indexOf("mailto:") != -1) {
                            var mail = linkannot[l].URI.substring(linkannot[l].URI.indexOf("mailto:"), linkannot[l].URI.length);
                            aTag.title = mail;
                            aTag.setAttribute('href', mail);
                        } else {
                            aTag.title = linkannot[l].URI;
                            aTag.setAttribute('href', linkannot[l].URI);
                        }
                        if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.Default) {
                            aTag.target = "_self";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewTab) {
                            aTag.target = "_blank";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);

                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewWindow) {

                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                                window.open(this.href, '_blank', 'scrollbars=yes,resizable=yes');
                                return false;
                            }
                        }
                        if (documentlinkpagenumber[l] != undefined) {
                            var destPageHeight = (this._pageSize[pageindex - 1].PageHeight);
                            var destAnnotLoc = this._convertPointToPixel(linkannot[l].AnnotLocation);
                            var dest = (destPageHeight - destAnnotLoc);
                            var scrollvalue = (parseFloat(this._pageLocation[documentlinkpagenumber[l]] * this._zoomVal)) + parseFloat(dest * this._zoomVal);
                            aTag.name = scrollvalue;
                            aTag.onclick = function () {
                                var pageviewcontainer = document.getElementById(ins._id + '_viewerContainer');
                                pageviewcontainer.scrollTop = this.name;
                                return false;
                            }
                        }
                        var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                        selectioncanvas.appendChild(aTag);
                    }
                }
                //Hyperlink

                if (this._textMarkupAnnotationList[pageindex]) {
                    this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
                }

                var index = parseInt(jsondata["currentpage"]);
                var imageObjCollection = new Array();
                var imageTransformCollection = new Array();
                var imageDataCollection = new Array();
                var currentIndexCollection = new Array();
                var pageDataCollection = new Array();
                var zoomFactor;
                var browserUserAgent = navigator.userAgent;
                var offsett;
                var imageIndex = 0;

                var charPath = new Array();
                var shapes = pageimageList["textelements"];
                for (var j = 0; j < shapes.length; j++) {
                    var pathdata = shapes[j];
                    var color = pathdata["color"];
                    var matrix = pathdata["matrix"];
                    if (matrix != null)
                        matrix = matrix["Elements"];
                    var brushMode = pathdata["brush"];
                    var pathValue = pathdata["pathValue"];
                    var isClipping = pathdata["iscliping"];
                    var restoreCanvas = pathdata["restorecanvas"];
                    var imageData = pathdata["imagedata"];
                    var fillMode = pathdata["fillrule"];
                    var fillStroke = pathdata["isFillandStroke"];
                    var fillColor = pathdata["fillcolor"];
                    var strokeColor = pathdata["strokecolor"];
                    var lineWidth = pathdata["linewidth"];
                    var lineCap = pathdata["linecap"];
                    var linearGradient = pathdata["linearGradientBrush"];
                    var textureBrush = pathdata["textureBrushs"];
                    var charID = pathdata["charID"];
                    var rectangle = pathdata["rectvalue"];
                    var alpha = pathdata["alpha"];
                    if (pathValue != null) {
                        pathValue = pathValue.split(";");
                        if (charID)
                            charPath[charID] = pathValue;
                    }
                    else if (pathValue == null && charID) {
                        pathValue = charPath[charID];
                    }
                    if (restoreCanvas == false) {
                        context.save();
                    }
                    if (pathValue != undefined) {
                        context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                    }
                    if (pathValue != null) {
                        context.beginPath();

                        for (var i = 0; i < pathValue.length; i++) {
                            var val = pathValue[i];
                            var pathType = val[0];
                            if (pathType == "M") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.moveTo((val[0]), val[1]);
                            }
                            else if (pathType == "L") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.lineTo((val[0]), val[1]);
                            }
                            else if (pathType == "C") {
                                val = val.substring(1, val.length);
                                val = val.split(" ");
                                context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                            }
                            else if (pathType == "Z") {
                                context.closePath();
                            }
                        }
                        if (isClipping == true) {
                            if (fillMode == "evenodd") {
                                context.msFillRule = "evenodd";
                                context.mozFillRule = "evenodd";
                                context.clip(fillMode);
                            }
                            context.clip();

                        }
                        else {
                            if (fillStroke == undefined) {
                                if (brushMode == "Fill") {
                                    if (linearGradient != undefined) {
                                        context.fillStyle = this._getGradientBrush(linearGradient, context);
                                    }
                                    else if (textureBrush != undefined) {
                                        context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                    }
                                    else {
                                        if (alpha != undefined)
                                            context.globalAlpha = alpha;
                                        context.fillStyle = color;
                                    }
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.fill(fillMode);
                                    }
                                    context.fill();
                                }
                                else if (brushMode == "FillandStroke") {
                                    context.fillStyle = color;
                                    context.fill();
                                    context.strokeStyle = strokeColor;
                                    context.stroke();
                                }
                                else if (brushMode == "Stroke") {
                                    context.strokeStyle = strokeColor;
                                    context.lineWidth = lineWidth;
                                    context.lineCap = lineCap;
                                    context.stroke();
                                }
                                else {
                                    context.strokeStyle = color;
                                    context.lineWidth = lineWidth;
                                    context.lineCap = lineCap;
                                    context.stroke();
                                }
                            }
                            else {
                                context.strokeStyle = strokeColor;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                                if (linearGradient != undefined) {
                                    context.fillStyle = this._getGradientBrush(linearGradient, context);
                                }
                                else if (textureBrush != undefined) {
                                    context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                }
                                else
                                    context.fillStyle = fillColor;
                                if (fillMode == "evenodd") {
                                    context.msFillRule = "evenodd";
                                    context.mozFillRule = "evenodd";
                                    context.fill(fillMode);
                                }
                                context.fill();
                            }
                        }
                    }

                    if (restoreCanvas)
                        context.restore();
                    if (imageData != undefined) {
                        if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                            imageObjCollection.push(imageData);
                            imageTransformCollection.push(matrix);
                            pageDataCollection.push(shapes);
                            currentIndexCollection.push(j);
                            zoomFactor = this._zoomVal;
                            this._isContainImage = true;
                            break;
                        }
                        else {
                            var imageObj = new Image();
                            imageObj.src = imageData;
                            context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                            context.drawImage(imageObj, 0, 0, 1, 1);
                        }
                    }
                }

                if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                    for (var k = 0; k < imageObjCollection.length; k++) {
                        this._imageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, k, pageDataCollection, currentIndexCollection, charPath, canvas, index, imageIndex);
                        imageIndex++;
                    }
                }
                var tempcanvas = canvas;
                var proxy = this;
                if (this._pageSize[index - 1].PageRotation != 0) {
                    if (!(imageData != undefined && browserUserAgent.indexOf("Firefox") != -1)) {
                        tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                        var canvasUrl = tempcanvas.toDataURL();
                        var context = tempcanvas.getContext('2d');
                        var image = new Image();
                        image.onload = function () {
                            context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            }
                            context.save();
                            context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                            context.drawImage(image, -image.width / 2, -image.height / 2);
                            context.restore();
                        }
                        image.src = canvasUrl;
                    }
                }
                this._showPageLoadingIndicator(pageindex, false);
                this._changingImageCanvasPosition(pageindex);
                this._showSignature();
                return tempcanvas;
            }
        },
        _hidingSignature: function () {
            $('.e-pdfviewer-imagecanvasDraw').hide();
            var selector = document.getElementById(this._id + "e-pdfviewer-selector");
            var isButtons = document.getElementsByClassName('e-pdfviewer-buttons');
            $(selector).remove();
            $(isButtons).remove();
        },
        _showSignature: function () {
            $('.e-pdfviewer-imagecanvasDraw').show();
            var selector = document.getElementById(this._id + "e-pdfviewer-selector");
            var isButtons = document.getElementsByClassName('e-pdfviewer-buttons');
            $(selector).remove();
            $(isButtons).remove();
        },
        _changingImageCanvasPosition: function (pageindex) {
            var imageCanvas = $('.e-pdfviewer-imagecanvasDraw');
            this._calculatingPositions(imageCanvas);
            this._previousZoomValue = this._zoomVal;
        },
        _calculatingPositions: function (imageCanvas) {
            for (var i = 0; i < imageCanvas.length; i++) {
                var newCanvasLeft = (parseFloat($(imageCanvas[i]).css("left")) / this._previousZoomValue) * this._zoomVal;
                var newCanvasTop = (parseFloat($(imageCanvas[i]).css("top")) / this._previousZoomValue) * this._zoomVal;
                var newCanvasWidth = (parseFloat($(imageCanvas[i]).css("width")) / this._previousZoomValue) * this._zoomVal;
                var newCanvasHeight = (parseFloat($(imageCanvas[i]).css("height")) / this._previousZoomValue) * this._zoomVal;
                $(imageCanvas[i]).css("top", newCanvasTop + "px");
                $(imageCanvas[i]).css("left", newCanvasLeft + "px");
                if (imageCanvas[i].className != "e-pdfviewer-buttons") {
                    $(imageCanvas[i]).css("width", newCanvasWidth + "px");
                    $(imageCanvas[i]).css("height", newCanvasHeight + "px");
                }
                var path = this._outputPath[imageCanvas[i].id];
                this._reDrawSignature(path, imageCanvas[i], newCanvasWidth, newCanvasHeight);
            }
        },
        _reDrawSignature: function (path, newCanvas, newCanvasWidth, newCanvasHeight) {
            var imageTempcanvas = document.getElementById(this._id + "_imageTemp");
            var w = parseFloat($(imageTempcanvas).css("width"));
            var h = parseFloat($(imageTempcanvas).css("height"));
            var controlPoints = this._valueChanges[newCanvas.id];
            var differenceX = controlPoints.differenceX / newCanvasWidth;
            var differenceY = controlPoints.differenceY / newCanvasHeight;
            var widths = this.element[0].parentElement.clientWidth;
            if (widths >= 500) {
                var heightRatio = newCanvasHeight / 400;
                var widthRatio = newCanvasWidth / 470;
            }
            else {
                var heightRatio = newCanvasHeight / 100;
                var widthRatio = newCanvasWidth / widths;
            }
            if (heightRatio <= 0 || widthRatio <= 0) {
                heightRatio = 1;
                widthRatio = 1;
            }
            var context = newCanvas.getContext("2d");
            var color = context.strokeStyle;
            newCanvas.width = newCanvasWidth;
            newCanvas.height = newCanvasHeight;
            newCanvas.style.width = newCanvasWidth + "px";
            newCanvas.style.height = newCanvasHeight + "px";

            var length = path.split("<br>").length;
            context.beginPath();
            for (var k = 0; k < length; k++) {
                var splitedvalue = path.split("<br>")[k].split('.').slice(1).join('.');
                if (splitedvalue) {
                    var substring = splitedvalue.substring(0, 6);
                    var movevalues = splitedvalue.substring(6);
                    var points = movevalues.replace(/[{()}]/g, '');
                    var splitPoints = points.split(',');
                    var point1 = (((parseFloat(splitPoints[0]))) - controlPoints.minimumX) / differenceX;
                    var point2 = (((parseFloat(splitPoints[1]))) - controlPoints.minimumY) / differenceY;
                    if (substring == "moveTo") {
                        context.moveTo(point1, point2);
                    }
                    else if (substring == "lineTo") {
                        context.lineTo(point1, point2);
                    }
                }
            }
            context.lineWidth = 4;
            context.scale(widthRatio, heightRatio);
            context.strokeStyle = color;
            context.stroke();
        },
        _scalingTextContent: function (context) {
            var backingPixel = context.webkitBackingStorePixelRatio ||
           context.mozBackingStorePixelRatio ||
           context.msBackingStorePixelRatio ||
            context.oBackingStorePixelRatio ||
            context.backingStorePixelRatio || 1;
            var ratio = window.devicePixelRatio / backingPixel;
            return ratio;
        },
        _convertPointToPixel: function (value) {
            if (this._horizontalResolution)
                return (parseFloat(value) * (this._horizontalResolution / 72));
            else
                return (parseFloat(value) * (96 / 72));
        },

        _getRandomNum: function () {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        },

        _createGUID: function () {
            var guid;
            return guid = "Syncfusion_PDFviewer_" + (this._getRandomNum() + this._getRandomNum() + "-" + this._getRandomNum() + "-4" + this._getRandomNum().substr(0, 3) + "-" + this._getRandomNum() + this._getRandomNum() + this._getRandomNum()).toLowerCase();
        },
        _createSignatureID: function () {
            var guid;
            return guid = "Signature_" + (this._getRandomNum() + this._getRandomNum() + "-" + this._getRandomNum() + "-4" + this._getRandomNum().substr(0, 3) + "-" + this._getRandomNum() + this._getRandomNum() + this._getRandomNum()).toLowerCase();
        },
        _createFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["pdfRenderedFields"];
            var cropBoxValue = jsondata["cropBoxValue"];
            var browserUserAgent = navigator.userAgent;
            var backgroundcolor;
            var proxy = this;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    var inputdiv;
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        var boundingRect = TextBoxField[l].LineBounds;
                        if (TextBoxField[l].Name == "Textbox") {
                            if (TextBoxField[l].Multiline) {
                                inputdiv = document.createElement("textarea");
                                $(inputdiv).css("resize", "none");                              
                            } else {
                                inputdiv = document.createElement("input");
                                inputdiv.type = "text";
                            }
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
							proxy._addAlignmentPropety(TextBoxField[l], inputdiv);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].FieldName);
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            if (TextBoxField[l].Text != "")
                                $(inputdiv).val(TextBoxField[l].Text);
                            else
                                $(inputdiv).val('');
                        }
                        else if (TextBoxField[l].Name == "Password") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "password";
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).attr("disabled", true);
						    proxy._addAlignmentPropety(TextBoxField[l], inputdiv);
                            $(inputdiv).attr("name", TextBoxField[l].FieldName);
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            if (TextBoxField[l].Text != "")
                                $(inputdiv).val(TextBoxField[l].Text);
                            else
                                $(inputdiv).val('');
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "radio";
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].Selected == true)
                                $(inputdiv).prop("checked", true);
                            $(inputdiv).val(TextBoxField[l].Value);
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            $(inputdiv).css("cursor", "pointer");
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            if (browserUserAgent.indexOf('Chrome') != -1)
                                $(inputdiv).css("-webkit-apperance", "none");
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            inputdiv = document.createElement("input");
                            inputdiv.type = "checkbox";
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].Selected == true)
                                $(inputdiv).prop('checked', true);
                            else if (browserUserAgent.indexOf('Chrome') != -1)
                                $(inputdiv).css("-webkit-appearance", "none");
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            var backColor = TextBoxField[l].BackColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else {
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                                $(inputdiv).css("cursor", "pointer");
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            inputdiv = document.createElement("select");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].Text);
                            if (TextBoxField[l].SelectedValue == "") {
                                var option = document.createElement("option");
                                option.id = "dropdownhide";
                                $(option).css("display", "none");
                                option.selected = "selected";
                                option.innerHTML = "";
                                inputdiv.appendChild(option);
                            }
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = document.createElement("option");
                                option.className = "e-dropdownSelect";
                                if (TextBoxField[l].SelectedValue == TextBoxField[l].TextList[j])
                                    $(option).prop("selected", true);
                                else
                                    $(option).prop("selected", false);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                inputdiv.appendChild(option);
                            }
                            var backColor = TextBoxField[l].BackColor;
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "black");
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            inputdiv = document.createElement("select");
                            $(inputdiv).attr("multiple", "multiple");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            $(inputdiv).attr("name", TextBoxField[l].Text);
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = document.createElement("option");
                                option.className = "e-pdfviewer-ListBox"
                                for (var k = 0; k < TextBoxField[l].SelectedList.length; k++) {
                                    if (TextBoxField[l].SelectedList[k] == j)
                                        $(option).prop("selected", true);
                                }
                                option.innerHTML = TextBoxField[l].TextList[j];
                                inputdiv.appendChild(option);
                                var backColor = TextBoxField[l].BackColor;
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).attr("disabled", true);
                        }
                        if (TextBoxField[l].Font != null) {
                            if (TextBoxField[l].Font.Bold || TextBoxField[l].Font.Italic || TextBoxField[l].Font.Strikeout ||
                                 TextBoxField[l].Font.Underline) {
                                if (TextBoxField[l].Font.Italic)
                                    inputdiv.style.fontStyle = "italic";
                                if (TextBoxField[l].Font.Bold)
                                    inputdiv.style.fontWeight = "Bold";
                            }
                            $(inputdiv).css("font-family", TextBoxField[l].Font.Name);
                            var heights = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            $(inputdiv).css("font-size", heights);
                        }
                        if ($(inputdiv).css("background-color") == "rgba(255, 255, 255, 0.2)") {
                            $(inputdiv).css("background-color", "rgba(0, 20, 200, 0.2)");
                        }
                        if (!cropBoxValue)
                            cropBoxValue = 0;
                        inputdiv.style.borderStyle = "solid";
                        inputdiv.id = this._id + 'input_' + pageindex + '_' + l;
                        inputdiv.className = 'e-pdfviewer-formFields';
                        inputdiv.style.margin = "0px";
                        inputdiv.style.zIndex = 1000;
                        inputdiv.style.left = this._convertPointToPixel((boundingRect.X + cropBoxValue) * this._zoomVal) + 'px';
                        inputdiv.style.top = this._convertPointToPixel((boundingRect.Y + cropBoxValue) * this._zoomVal) + 'px';
                        inputdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                        inputdiv.style.height = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                        inputdiv.style.position = 'absolute';
                        var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                        $('#' + this._id + 'selectioncanvas_' + pageindex).addClass('input_container');
                        selectioncanvas.appendChild(inputdiv);
                        var borderwidth;
                        var proxy = this;
                        var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
                        $(inputdiv).on("focus", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            var backgroundColour = $(e.target).css("background-color");
                            var currentIndex = backgroundColour.lastIndexOf(',');
                            var color = backgroundColour.slice(0, currentIndex + 1) + 0 + ")";
                            if (type == "checkbox" && is_chrome)
                                $(e.target).css("-webkit-appearance", "");
                            $(e.target).css("background-color", color);
                            borderwidth = e.target.style.borderWidth;
                            $(e.target).css('border-width', '0');
                            proxy._isFormFields = true;
                        });
                        $(inputdiv).on("blur", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            if (is_chrome)
                                var backgroundColour = $(e.target).css("background-color");
                            else
                                var backgroundColour = e.target.style["background-color"];
                            var currentIndex = backgroundColour.lastIndexOf(',');
                            if (type == "checkbox" && $(e.target).prop("checked") == true) {
                                var colors = backgroundColour.slice(0, currentIndex + 1) + 0 + ")";
                                $(e.target).css("background-color", colors);
                            }
                            else {
                                var color = backgroundColour.slice(0, currentIndex + 1) + 0.2 + ")";
                                $(e.target).css("background-color", color);
                            }
                            if (parseFloat(borderwidth) == 0)
                                $(e.target).css('border-width', "1px");
                             else
                                $(e.target).css('border-width', borderwidth);
                            proxy._isFormFields = false;
                        });
                        $(inputdiv).on("change", function (e) {
                            proxy.isDocumentEdited = true;
                        });
                        $(inputdiv).unbind('click').on("click touchstart", function (e) {
                            var type = $(e.target).attr('type');
                            var list = $(e.target)[0].type;
                            if (type == "password" || type == "text") {
                                $(e.target).select();
                                var target = $(e.target)[0];
                                $(target).on('keypress', function (e) {
                                    var MaxLength = $(target).attr("maxlength");
                                    if ($(target).val().length > (MaxLength - 2)) {
                                        var value = $(target).val() + String.fromCharCode(e.keyCode);
                                        $(target).val(value);
                                        $(target).blur();

                                    }
                                });
                                $(target).on("keyup", function (e) {
                                    var value = $(target).val();
                                    var jsonData = proxy._pageContents[proxy._currentPage];
                                    var jsdata = JSON.parse(jsonData);
                                    var TextBoxField = jsdata["pdfRenderedFields"];
                                    var field = (target.id).split("_");
                                    var fieldPosition = field[field.length - 1];
                                    if (value != TextBoxField[fieldPosition].Text) {
                                        proxy.isDocumentEdited = true;
                                    } else {
                                        proxy.isDocumentEdited = false;
                                    }
                                });
                                $(target).unbind('change').on("change", function (e) {
                                    var value = $(target).val();
                                    $(target).val(value);
                                });
                            }
                            if (type == "radio") {
                                var name = $(e.target).attr("name");
                                var radioButton = $('.e-pdfviewer-formFields:radio');
                                for (var m = 0; m < radioButton.length; m++) {
                                    if ($(radioButton[m]).attr("name") == name) {
                                        $(radioButton[m]).prop("checked", false);
                                    }
                                }
                                $(e.target).prop("checked", true);
                            }
                            else if (type == "checkbox") {
                                if ($(e.target).prop("checked") == true) {
                                    $(e.target).prop("checked", true);
                                    if (is_chrome)
                                        $(e.target).css("-webkit-appearance", "");
                                    $(e.target).css('border-width', "1px");
                                }
                                else {
                                    $(e.target).prop("checked", false);
                                    if (is_chrome)
                                        $(e.target).css("-webkit-appearance", "none");
                                }
                            }
                            else if (list == "select-one") {
                                proxy.isDocumentEdited = true;
                                var target = $(e.target)[0];
                                $(target).unbind('change').on("change", function (e) {
                                    var target = $(e.target)[0];
                                    var value = target.options[target.selectedIndex].text;
                                    var childrens = target.children;
                                    for (var k = 0; k < childrens.length; k++) {
                                        if (childrens[k].text == value)
                                            $(childrens[k]).prop("selected", true);
                                        else
                                            $(childrens[k]).prop("selected", false);
                                    }
                                });
                            }
                        });
                    }
                }
            }
        },
       _addAlignmentPropety: function (TextAlign, inputdiv) {
            var alignment = TextAlign.Alignment;
            switch (alignment) {
                case 0:
                    $(inputdiv).css("text-align", "left");
                    break;
                case 1:
                    $(inputdiv).css("text-align", "center");
                    break;
                case 2:
                    $(inputdiv).css("text-align", "right");
                    break;
                case 3:
                    $(inputdiv).css("text-align", "justify");
                    break;
            }
        },
        _saveFormFieldsValue: function () {
            var result = {};
            var values = {};
            $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("visibility", "");
            var input = $('.e-pdfviewer-formFields');
            if (input != null) {
                for (var i = 0; i < input.length; i++) {
                    if (input[i].type == "text" || input[i].type == "password")
                        result[input[i].name] = input[i].value;
                    else if (input[i].type == "radio" && $(input[i]).prop("checked") == true)
                        result[input[i].name] = input[i].value;
                    else if (input[i].type == "checkbox") {
                        if ($(input[i]).prop("checked") == true)
                            result[input[i].name] = $(input[i]).prop("checked");
                        else
                            result[input[i].name] = $(input[i]).prop("checked");
                    }
                    else if (input[i].type == "select-one") {
                        result[input[i].name] = input[i].options[input[i].selectedIndex].text;
                    }
                    else if (input[i].type == "select-multiple") {
                        var text = [];
                        var children = $(input[i]).children();
                        for (var j = 0; j < children.length; j++) {
                            if ($(children[j]).prop("selected") == true)
                                text.push(children[j].text);
                        }
                        text = JSON.stringify(text);
                        result[input[i].name] = text;
                    }
                }
            }
            var annotationList = new Array();
            for (var i = 1; i <= this._totalPages; i++) {
                var newArray = [];
                var existingAnnotationList = this._textMarkupAnnotationList[i];
                if (existingAnnotationList) {
                    for (var j = 0; j < existingAnnotationList.length; j++) {
                        var annotation = existingAnnotationList[j];
                        if (annotation) {
                            var opacity = annotation.Opacity;
                            if (annotation.TextMarkupAnnotationType == "Highlight")
                                opacity = opacity * 0.5;
                            if (annotation.Author == null) {
                                annotation.Author = this.model.strikethroughSettings.author;
                            }
                            for (var k = 0; k < annotation.Bounds.length; k++) {
                                var newObject = {
                                    index: annotation.index,
                                    colorA: annotation.Opacity * 255,
                                    colorR: annotation.Color.R,
                                    colorG: annotation.Color.G,
                                    colorB: annotation.Color.B,
                                    opacity: opacity,
                                    type: annotation.TextMarkupAnnotationType,
                                    author: annotation.Author,
                                    subject: annotation.Subject,
                                    text: annotation.note,
                                    xPosition: annotation.Bounds[k].X,
                                    yPosition: annotation.Bounds[k].Y,
                                    height: annotation.Bounds[k].Height,
                                    width: annotation.Bounds[k].Width
                                }
                                newArray.push(newObject);
                            }
                        }
                    }
                }
                annotationList[i - 1] = newArray;
            }
            var newAnnotationList = new Array();
            for (var i = 1; i <= this._totalPages; i++) {
                var newArray = [];
                newAnnotationList[i - 1] = newArray;
                for (var j = 0; j < this._newAnnotationList[i - 1].length; j++) {
                    var annotation = this._newAnnotationList[i - 1][j];
                    var opacity = annotation.opacity;
                    if (annotation.type == "Highlight")
                        opacity = opacity * 0.5;
                    for (var k = 0; k < annotation.bounds.length; k++) {
                        var newObject = {
                            type: annotation.type,
                            xPosition: annotation.bounds[k].xPosition,
                            yPosition: annotation.bounds[k].yPosition,
                            height: annotation.bounds[k].height,
                            width: annotation.bounds[k].width,
                            colorA: annotation.colorA,
                            colorR: annotation.colorR,
                            colorG: annotation.colorG,
                            colorB: annotation.colorB,
                            opacity: opacity,
                            author: annotation.author,
                            subject: annotation.subject,
                            text: annotation.note
                        }
                        newArray.push(newObject);
                    }
                }
                newAnnotationList[i - 1] = newArray;
            }
            this._saveSignatureControl();
            values["savetextMarkupAnnotation"] = JSON.stringify(newAnnotationList);
            values["existingAnnotations"] = JSON.stringify(annotationList);
            values["savedFields"] = JSON.stringify(result);
            values["signatureFields"] = JSON.stringify(this._completeSign);
            values["id"] = this._fileId;
            var newFileID;
            if (this._completeSign.length > 0) {
                newFileID = this._createSignatureID();
                this._signatureLayer.push(newFileID);
            }
            values["signatureValues"] = JSON.stringify(this._signatureLayer);
            values["newFileID"] = newFileID;
            this._saveAs("POST", this.model.serviceUrl, JSON.stringify(values));
        },
        _saveSignatureControl: function () {
            this._completeSign = [];
            var signature = $('.e-pdfviewer-imagecanvasDraw');
            var leftDifference = 0;
            var topDifference = 0;
            for (var i = 0; i < signature.length; i++) {
                var leftDifference = 0;
                var topDifference = 0;
                var angle = 0;
                var signatureElement = signature[i];
                var signatureResult = new Array();
                var signatureContext = signatureElement.getContext("2d");
                var pageIndex = signatureElement.id.split('imagecanvasDraw_')[1].split('_')[0];
                var hex = signatureContext.strokeStyle;
                var r1 = parseInt(hex.slice(1, 3), 16),
                 g1 = parseInt(hex.slice(3, 5), 16),
                 b1 = parseInt(hex.slice(5, 7), 16);
                var newResult = {
                    id: signatureElement.id,
                    xPosition: ((parseFloat($(signatureElement).css("left")))) / this._zoomVal,
                    yPosition: ((parseFloat($(signatureElement).css("top")))) / this._zoomVal,
                    height: parseInt(parseFloat($(signatureElement).css("height")) / this._zoomVal),
                    width: parseInt(parseFloat($(signatureElement).css("width")) / this._zoomVal),
                    path: this._outputPath[signatureElement.id],
                    pageIndex: pageIndex,
                    rotation: angle,
                    valueChange:this._valueChanges[signatureElement.id],
                    zoomValue: this._zoomVal,
                    colorA: (parseFloat($(signatureElement).css("opacity")) * 255),
                    colorR: r1,
                    colorG: g1,
                    colorB: b1,
                }
                signatureResult.push(newResult);
                this._completeSign.push(signatureResult);
            }
        },
        _saveAs: function (type, actionUrl, data) {
            var proxy = this;
            if (this._ajaxDownloaded != null) {
                this._ajaxDownloaded.abort();
                this._ajaxDownloaded = null;
            }
            this._ajaxDownloaded = ($.ajax({
                type: type,
                url: actionUrl + '/' + this.model.serverActionSettings.download,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: data,
                traditional: true,
                async: this._isAsynchronousDownload,
                success: function (data) {
                    if (this._cancelDownloads) {
                        proxy._downloadAborted();
                        return;
                    }
                    if (data) {
                        proxy._save(data);
                        var downloaded = new Object();
                        downloaded.fileName = proxy._downloadfileName;
                        downloaded.status = "is completed"
                        proxy._raiseClientEvent("downloadEnd", downloaded);
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (proxy._cancelDownloads && errorThrown == "abort") {
                        proxy._downloadAborted();
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }))
        },
        _downloadAborted: function () {
            var proxy = this;
            var downloadaborted = new Object();
            downloadaborted.fileName = proxy._downloadfileName;
            downloadaborted.status = "is aborted"
            proxy._raiseClientEvent("downloadEnd", downloadaborted);
        },
        _generateFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["pdfRenderedFields"];
            var cropBoxValue = jsondata["cropBoxValue"];
            var backgroundcolor;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    var boundingRect = TextBoxField[l].LineBounds;
                    var inputdiv = document.getElementById(this._id + 'input_' + pageindex + '_' + l);
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        if (TextBoxField[l].Name == "Password" || TextBoxField[l].Name == "Textbox") {
                            var backColor = TextBoxField[l].BackColor;
                            var foreColor = TextBoxField[l].FontColor;
							this._addAlignmentPropety(TextBoxField[l], inputdiv);
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            $(inputdiv).css("color", "rgb(" + foreColor.R + "," + foreColor.G + "," + foreColor.B + ")");
                            var fontSize = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            if (TextBoxField[l].MaxLength > 0) {
                                $(inputdiv).attr("maxlength", TextBoxField[l].MaxLength);
                            }
                            if (TextBoxField[l].InsertSpaces)
                                $(inputdiv).css("letter-spacing", fontSize);
                            var value = $(inputdiv).val();
                            $(inputdiv).val(value);
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if ($(inputdiv).prop("checked") == true)
                                $(inputdiv).prop("checked", true);
                            $(inputdiv).attr("name", TextBoxField[l].GroupName);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else
                            $(inputdiv).css("cursor", "pointer");
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            var backColor = TextBoxField[l].BackColor;
                       
                            if (TextBoxField[l].IsRequired) {
                                $(inputdiv).css("border", "1px solid red");
                                $(inputdiv).css("outline", "1px solid red");
                            }
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if ($(inputdiv).prop("checked") == true)
                                $(inputdiv).prop('checked', true);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                $(inputdiv).attr("disabled", true);
                                $(inputdiv).css("background-color", "none");
                                $(inputdiv).css("cursor", "default");
                            }
                            else {
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                                $(inputdiv).css("cursor", "pointer");
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            if (TextBoxField[l].SelectedValue == "") {
                                var option = $(inputdiv).children()[0];
                                option.id = "dropdownhide";
                                $(option).css("display", "none");
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                option.innerHTML = "";
                            }
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option;
                                if ($(inputdiv).children()[0].id == "dropdownhide")
                                    option = $(inputdiv).children()[j + 1];
                                else
                                    option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            $(inputdiv).attr("multiple", "multiple");
                            if (TextBoxField[l].IsRequired)
                                $(inputdiv).css("border", "1px solid red");
                            else
                                $(inputdiv).css("border", TextBoxField[l].BorderWidth);
                            if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled)
                                $(inputdiv).css("disabled", true);
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true)
                                    $(option).prop('selected', true);
                                else
                                    $(option).prop('selected', false);
                                option.innerHTML = TextBoxField[l].TextList[j];
                                var backColor = TextBoxField[l].BackColor;
                                if (TextBoxField[l].IsReadonly || this._isFormFieldsDisabled) {
                                    $(inputdiv).attr("disabled", true);
                                    $(inputdiv).css("background-color", "none");
                                    $(inputdiv).css("cursor", "default");
                                }
                                else
                                $(inputdiv).css("background-color", "rgba(" + backColor.R + "," + backColor.G + "," + backColor.B + "," + 0.2 + ")");
                            }
                            $(inputdiv).css("color", "black");
                        }
                        if (TextBoxField[l].Font != null) {
                            if (TextBoxField[l].Font.Bold || TextBoxField[l].Font.Italic || TextBoxField[l].Font.Strikeout ||
                                 TextBoxField[l].Font.Underline) {
                                if (TextBoxField[l].Font.Italic)
                                    inputdiv.style.fontStyle = "italic";
                                if (TextBoxField[l].Font.Bold)
                                    inputdiv.style.fontWeight = "Bold";
                            }
                            $(inputdiv).css("font-family", TextBoxField[l].Font.Name);
                            var heights = this._convertPointToPixel(TextBoxField[l].Font.Height * this._zoomVal) + 'px';
                            $(inputdiv).css("font-size", heights);
                        }
                        if ($(inputdiv).css("background-color") == "rgba(255, 255, 255, 0.2)") {
                            $(inputdiv).css("background-color", "rgba(0, 20, 200, 0.2)");
                        }
                        if (!cropBoxValue)
                            cropBoxValue = 0;
                        inputdiv.style.borderStyle = "solid";
                        inputdiv.style.margin = "0px";
                        inputdiv.style.zIndex = 1000;
                        inputdiv.style.left = this._convertPointToPixel((boundingRect.X + cropBoxValue) * this._zoomVal) + 'px';
                        inputdiv.style.top = this._convertPointToPixel((boundingRect.Y + cropBoxValue) * this._zoomVal) + 'px';
                        inputdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                        inputdiv.style.height = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                        inputdiv.style.position = 'absolute';
                    }
                }
            }
        },

        _textSelection: function (jsondata, pageindex, context) {
            //Text selection line by line
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var isnbsp;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var selectionlines = jsondata["selection"];
            var textDivs = [];
            var textContents = [];
            var re = new RegExp(String.fromCharCode(160), "g");
            for (var l = 0; l < selectionlines.length; l++) {
                var innerText = " ";
                var boundingRect = selectionlines[l].LineBounds;
                var textdiv = document.createElement("DIV");
                textdiv.id = this._id + 'text_' + pageindex + '_' + l;
                textdiv.className = 'e-pdfviewer-textLayer';
                var text = selectionlines[l].Line;
                text = text.replace(/</g, "&lt;");
                text = text.replace(/>/g, "&gt;");
                var x = new RegExp("[\x00-\x80]+"); // is ascii
                var isAscii = x.test(text);
                var isRtl = this._isRtl(text);
                if (!isAscii && isRtl) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    text = text.replace(re, " ");
                    text = text.split("").reverse().join("");
                    textContents.push(text);
                }
                else {
                    textContents.push(selectionlines[l].Line.toString());
                }
                if (is_edgeNew && !is_ie) {
                    textdiv.innerHTML = text;
                }
                else {
                    if (this._previousBounds == parseInt(boundingRect.Y) || this._previousBounds == parseInt((boundingRect.Y) + 1) || this._previousBounds == parseInt((boundingRect.Y) - 1)) {
                        innerText = document.getElementById(this._id + 'text_' + pageindex + '_' + (l - 1));
                        if (innerText.innerHTML != " ") {
                            innerText.innerHTML = innerText.innerHTML.replace(/&nbsp;/g, ' ');
                            innerText.innerHTML = innerText.innerHTML.replace(/(\r\n|\n|\r)/gm, "");
                        }
                    }
                    this._previousBounds = parseInt(boundingRect.Y);
                    textdiv.innerHTML = text + "\r\n";
                    $(textdiv).filter(function () {
                        isnbsp = $(textdiv).html().match(/&nbsp;/);
                    });
                    if (isnbsp !== null) {
                        this._isNonBreackingCharacter = true;
                    }
                    textdiv.innerHTML = textdiv.innerHTML.replace(/&nbsp;/g, ' ');
                }
                textdiv.innerHTML = textdiv.innerHTML.replace(/&nbsp;/g, ' ')
                var newLines = text.replace(/  +/g, ' ');
                if (newLines != " ") {
                    textdiv.style.whiteSpace = 'pre';
                }
                textdiv.style.background = 'transparent';
                textdiv.style.position = 'absolute';
                textdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                textdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                textdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                textdiv.style.color = 'transparent';
                textdiv.style.fontSize = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                textdiv.style.fontFamily = 'sans-serif';
                textdiv.style.opacity = '0.2';
                textdiv.style.transformOrigin = '0%';
                //settting the properties of div to context to calculate the width of the text in canvas
                context.fontFamily = 'sans-serif'
                context.fontSize = textdiv.style.fontSize;
                context.font = textdiv.style.fontSize + " " + textdiv.style.fontFamily;
                //scaling the div to match the width of the line in canvas
                var ctxwidth = context.measureText(selectionlines[l].Line).width;
                var scale = parseFloat(textdiv.style.width) / ctxwidth;
                textdiv.style.transform = 'scaleX(' + scale + ')';
                var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                $('#' + this._id + 'selectioncanvas_' + pageindex).addClass('text_container');
                selectioncanvas.appendChild(textdiv);
                var selectioncanvasWidth = selectioncanvas.getBoundingClientRect();
                var textDivWidth = textdiv.getBoundingClientRect();
                if ((textDivWidth.width + textDivWidth.left) >= (selectioncanvasWidth.width + selectioncanvasWidth.left) || (textDivWidth.width > selectioncanvasWidth.width)) {
                    $(textdiv).css("width", "auto");
                    var newWidth = textdiv.clientWidth;
                    $(textdiv).css("width", newWidth + "px");
                }
                textDivs.push(textdiv);
            }
            this._previousBounds = null;
            this._textDivs[pageindex] = textDivs;
            this._textContents[pageindex] = textContents;
            //Text selection line by line
        },

        _resizeSelection: function (jsondata, pageindex, context) {
            var selectionlines = jsondata["selection"];
            for (var l = 0; l < selectionlines.length; l++) {
                var boundingRect = selectionlines[l].LineBounds;
                var textdiv = document.getElementById(this._id + 'text_' + pageindex + '_' + l);
                if (textdiv) {
                    var text = selectionlines[l].Line;
                    textdiv.style.position = 'absolute';
                    textdiv.style.left = this._convertPointToPixel(boundingRect.X * this._zoomVal) + 'px';
                    textdiv.style.top = this._convertPointToPixel(boundingRect.Y * this._zoomVal) + 'px';
                    textdiv.style.width = this._convertPointToPixel(boundingRect.Width * this._zoomVal) + 'px';
                    var newLines = text.replace(/  +/g, ' ');
                    if (newLines != " ") {
                        textdiv.style.whiteSpace = 'pre';
                    }
                    textdiv.style.transformOrigin = '0%';
                    textdiv.style.opacity = '0.2';
                    textdiv.style.fontSize = this._convertPointToPixel(boundingRect.Height * this._zoomVal) + 'px';
                    context.font = textdiv.style.fontSize + " " + textdiv.style.fontFamily;
                    context.fontSize = textdiv.style.fontSize;
                    var ctxwidth = context.measureText(selectionlines[l].Line).width;
                    var scale = parseFloat(textdiv.style.width) / ctxwidth;
                    textdiv.style.transform = 'scaleX(' + scale + ')';
                    var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                    var selectioncanvasWidth = selectioncanvas.getBoundingClientRect();
                    var textDivWidth = textdiv.getBoundingClientRect();
                    if ((textDivWidth.width + textDivWidth.left) >= (selectioncanvasWidth.width + selectioncanvasWidth.left) || (textDivWidth.width > selectioncanvasWidth.width)) {
                        $(textdiv).css("width", "auto");
                        var newWidth = textdiv.clientWidth;
                        $(textdiv).css("width", newWidth + "px");
                    }
                }
            }
        },

        _maintainSelection: function () {
            var selection = this._selectionNodes;
            var range = document.createRange();
            if (selection.anchorNode != null) {
                var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                var backward = false;
                if (!position && selection.anchorOffset > selection.focusOffset ||
                  position === Node.DOCUMENT_POSITION_PRECEDING)
                    backward = true;
                if (backward) {
                    range.setStart(selection.focusNode, selection.focusOffset);
                    range.setEnd(selection.anchorNode, selection.anchorOffset);
                }
                else {
                    range.setStart(selection.anchorNode, selection.anchorOffset);
                    range.setEnd(selection.focusNode, selection.focusOffset);
                }
                this._selectionRange = range;
            }
            selection.removeAllRanges();
        },

        /*function helps to enable and disable the loading indicator of the requested page*/
        _showPageLoadingIndicator: function (pageIndex, isShow) {
            if (isShow) {
                $('#' + this._id + 'pageDiv_' + pageIndex + '_WaitingPopup').css('display', 'block');
            }
            else {
                $('#' + this._id + 'pageDiv_' + pageIndex + '_WaitingPopup').css('display', 'none');
            }
        },

        _imageRendering: function (shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, index, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex) {
            var zoomValue = this._zoomVal;
            var imageObject = new Image();
            var proxy = this;
            var browserUserAgent = navigator.userAgent;
            imageObject.onload = function () {
                var isImageContentChanged = false;
                var ratio = proxy._scalingTextContent(context);
                    for (var l = 0; l < imageTransformCollection.length; l++) {
                        if (isImageContentChanged == false) {
                            var matrixData = imageTransformCollection[l];
                            context.setTransform(matrixData[0] * zoomValue * ratio, matrixData[1] * zoomValue * ratio, matrixData[2] * zoomValue * ratio, matrixData[3] * zoomValue * ratio, matrixData[4] * zoomValue * ratio, matrixData[5] * zoomValue * ratio);
                            if (imageDataCollection[imageIndex] != undefined) {
                                context.drawImage(imageDataCollection[imageIndex], 0, 0, 1, 1);
                            }
                            var dataIndex = currentIndexCollection[l];
                            dataIndex = dataIndex + 1;
                            var data = pageDataCollection[l];
                            while (dataIndex < data.length) {
                                var pathdata = data[dataIndex];
                                var color = pathdata["color"];
                                var matrix = pathdata["matrix"];
                                if (matrix != null)
                                    matrix = matrix["Elements"];
                                var brushMode = pathdata["brush"];
                                var pathValue = pathdata["pathValue"];
                                var isClipping = pathdata["iscliping"];
                                var restoreCanvas = pathdata["restorecanvas"];
                                var imageData = pathdata["imagedata"];
                                var fillMode = pathdata["fillrule"];
                                var fillStroke = pathdata["isFillandStroke"];
                                var fillColor = pathdata["fillcolor"];
                                var strokeColor = pathdata["strokecolor"];
                                var lineWidth = pathdata["linewidth"];
                                var lineCap = pathdata["linecap"];
                                var linearGradient = pathdata["linearGradientBrush"];
                                var textureBrush = pathdata["textureBrushs"];
                                var charID = pathdata["charID"];
                                var rectangle = pathdata["rectvalue"];
                                var alpha = pathdata["alpha"];
                                if (pathValue != null) {
                                    pathValue = pathValue.split(";");
                                    if (charID)
                                        charPath[charID] = pathValue;
                                }
                                else if (pathValue == null && charID) {
                                    pathValue = charPath[charID];
                                }
                                if (restoreCanvas == false) {
                                    context.save();
                                }
                                if (pathValue != undefined) {
                                    context.setTransform(matrix[0] * zoomValue * ratio, matrix[1], matrix[2], matrix[3] * zoomValue * ratio, matrix[4] * zoomValue * ratio, matrix[5] * zoomValue * ratio);
                                }

                                if (pathValue != null) {
                                    context.beginPath();

                                    for (var i = 0; i < pathValue.length; i++) {
                                        var val = pathValue[i];
                                        var pathType = val[0];
                                        if (pathType == "M") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.moveTo((val[0]), val[1]);
                                        }
                                        else if (pathType == "L") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.lineTo((val[0]), val[1]);
                                        }
                                        else if (pathType == "C") {
                                            val = val.substring(1, val.length);
                                            val = val.split(" ");
                                            context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                        }
                                        else if (pathType == "Z") {
                                            context.closePath();
                                        }
                                    }
                                    if (isClipping == true) {
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.clip(fillMode);
                                        }
                                        context.clip();

                                    }
                                    else {
                                        if (fillStroke == undefined) {
                                            if (brushMode == "Fill") {
                                                if (linearGradient != undefined) {
                                                    context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                                }
                                                else if (textureBrush != undefined) {
                                                    context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                                }
                                                else {
                                                    if (alpha != undefined)
                                                        context.globalAlpha = alpha;
                                                    context.fillStyle = color;
                                                }
                                                if (fillMode == "evenodd") {
                                                    context.msFillRule = "evenodd";
                                                    context.mozFillRule = "evenodd";
                                                    context.fill(fillMode);
                                                }
                                                context.fill();
                                            }
                                            else if (brushMode == "FillandStroke") {
                                                context.fillStyle = color;
                                                context.fill();
                                                context.strokeStyle = strokeColor;
                                                context.stroke();
                                            }
                                            else if (brushMode == "Stroke") {
                                                context.strokeStyle = strokeColor;
                                                context.lineWidth = lineWidth;
                                                context.lineCap = lineCap;
                                                context.stroke();
                                            }
                                            else {
                                                context.strokeStyle = color;
                                                context.lineWidth = lineWidth;
                                                context.lineCap = lineCap;
                                                context.stroke();
                                            }
                                        }
                                        else {
                                            context.strokeStyle = strokeColor;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                            if (linearGradient != undefined) {
                                                context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                            }
                                            else if (textureBrush != undefined) {
                                                context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                            }
                                            else
                                                context.fillStyle = fillColor;
                                            if (fillMode == "evenodd") {
                                                context.msFillRule = "evenodd";
                                                context.mozFillRule = "evenodd";
                                                context.fill(fillMode);
                                            }
                                            context.fill();
                                        }
                                    }
                                }

                                if (restoreCanvas)
                                    context.restore();
                                if (imageData != undefined) {
                                    isImageContentChanged = true;
                                    imageObjCollection.pop();
                                    imageTransformCollection.pop();
                                    pageDataCollection.pop();
                                    currentIndexCollection.pop();
                                    imageObjCollection.push(imageData);
                                    imageTransformCollection.push(matrix);
                                    pageDataCollection.push(shapes);
                                    currentIndexCollection.push(dataIndex);
                                    l = -1;
                                    imageIndex++;
                                    break;
                                }
                                dataIndex++;
                            }
                        }
                        else {
                            proxy._imageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, l, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex);
                            imageIndex++;
                        }
                    }
                    if (dataIndex == shapes.length) {
                        if (proxy._pageSize[currentindex - 1].PageRotation != 0) {
                            var tempcanvas = document.getElementById(proxy._id + 'pagecanvas_' + currentindex);
                            var canvasUrl = tempcanvas.toDataURL();
                            var ctx = tempcanvas.getContext('2d');
                            var image = new Image();
                            image.onload = function () {
                                ctx.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                                if (proxy._pageSize[currentindex - 1].PageRotation == 90 || proxy._pageSize[currentindex - 1].PageRotation == 270) {
                                    tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                    tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                    tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                    tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                                } else {
                                    tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                    tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                    tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                    tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                                }
                                ctx.save();
                                ctx.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                                ctx.rotate((proxy._pageSize[currentindex - 1].PageRotation / 2) * Math.PI / 2);
                                ctx.drawImage(image, -image.width / 2, -image.height / 2);
                                ctx.restore();
                            }
                            image.src = canvasUrl;
                        }
                    }
                };
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
            this._imageObj.push(imageObject);
        },

        _createTextureBrush: function (textureBrush, context, pathdata) {
            var imageSrc = pathdata.texturFields[0].Image;
            var width = pathdata.texturFields[0].Width;
            var height = pathdata.texturFields[0].Height;
            var imageData = "data:image/png;base64," + imageSrc;
            var imageObjects = new Image();
            if (navigator.userAgent.indexOf("Firefox") != -1) {
                imageObjects.src = this._imageSrcCollection[0];
                this._loadimages(imageObjects, width, height, context);
                this._imageSrcCollection.shift();
            }
            else {
                imageObjects.src = imageData;
                this._loadimages(imageObjects, width, height, context);
            }
        },
        _loadimages: function (img, width, height, context) {
            var tempCanvas = document.createElement("canvas");
            var tempContext = tempCanvas.getContext("2d");
            tempCanvas.width = width;
            tempCanvas.height = height;
            tempContext.drawImage(img, 0, 0, img.width, img.height, 0, 0, tempCanvas.width, tempCanvas.height);
            var pattern = context.createPattern(tempCanvas, 'repeat');
            context.fillStyle = pattern;
            context.fill();
            return pattern;
        },
        _getGradientBrush: function (linearGradient, context) {
            var rectangle = linearGradient["Rectangle"];
            var interpolationColors = linearGradient["InterpolationColors"];
            var gradientColor = interpolationColors["Colors"];
            var gradientPosition = interpolationColors["Positions"];
            var gradient = context.createLinearGradient(rectangle["X"], rectangle["Y"], rectangle["Width"], rectangle["Height"]);
            for (var k = 0; k < gradientPosition.length; k++) {
                var colorCodeString = gradientColor[k];
                colorCodeString = colorCodeString.split(",");
                var colorCode = this._rgb2Color(colorCodeString[0], colorCodeString[1], colorCodeString[2]);
                gradient.addColorStop(gradientPosition[k], colorCode);
            }
            return gradient;
        },

        _rgb2Color: function (r, g, b) {
            return '#' + this._byte2Hex(r) + this._byte2Hex(g) + this._byte2Hex(b);
        },
        _byte2Hex: function (n) {
            var nybHexString = "0123456789ABCDEF";
            return String(nybHexString.substr((n >> 4) & 0x0F, 1)) + nybHexString.substr(n & 0x0F, 1);
        },
        //-------------------- Apply Page Style and Actions [End] -------------------------//

        //-------------------- Ajax Web API Call back methods[start] -------------------------//
        _doAjaxPost: function (type, url, jsonResult, onSuccess, isTargetFire) {
            var proxy = this;
            var inVokemethod = onSuccess;
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            this._ajaxRequestState = ($.ajax({
                type: type,
                url: url,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    if (proxy.model.allowClientBuffering) {
                        proxy._initPages();
                        if (typeof data === 'object')
                            jsondata = JSON.parse(JSON.stringify(data));
                        else
                            jsondata = JSON.parse(data);
                        jsondata = jsondata["pdf"];
                        var length = proxy._getObjectSize(jsondata);
                        if (jsondata) {
                            for (var i = 1; i <= length; i++) {
                                var backupjson = jsondata[i];
                                if (backupjson) {
                                    proxy._pageContents[parseInt(backupjson["currentpage"])] = JSON.stringify(backupjson);
                                    proxy._pageText[parseInt(backupjson["currentpage"])] = backupjson["pageContents"];
                                }
                            }
                            data = proxy._pageContents[parseInt(1)];
                        }
                    } else {
                        if (typeof data === 'object')
                            data = JSON.stringify(data);
                    }
                    var jsData = JSON.parse(data);
                    var pagecount = jsData["pagecount"];
                    if (pagecount == 0) {
                        this.pageCount = 0;
                        proxy._unLoad();
                    } else {
                        if (typeof data === 'object')
                            proxy[inVokemethod](JSON.stringify(data));
                        else
                            proxy[inVokemethod](data);
                        var name = (jsData["filename"]).split('\\');
                        var pdfFileName;
                        if (name.length > 1) {
                            pdfFileName = name[name.length - 1];
                        }
                        else if (proxy._fileName != "" && proxy._fileName != null) {
                            pdfFileName = proxy._fileName;
                        }
                        else {
                            pdfFileName = null;
                        }
                        var filename = { fileName: pdfFileName };
                        proxy._downloadfileName = pdfFileName;
                        if (proxy.model) {
                            proxy._raiseClientEvent("documentLoad", filename);
                            if (proxy.model.allowClientBuffering) {
                                if (typeof data === 'object')
                                    var jsonData = JSON.parse(JSON.stringify(data));
                                else
                                    var jsonData = JSON.parse(data);
                                proxy._pagesGot.push(parseInt(jsonData["currentpage"]));
                            }
                        }
                    }
                    if (proxy.model.allowClientBuffering) {
                        if (isTargetFire) {
                            proxy._pagesGot.push(parseInt(jsonData["currentpage"]) + 1);
                            if (2 <= proxy._totalPages) {
                                proxy._targetPage = jsonData["currentpage"] + 2;
                                proxy._isTargetPage = true;
                            }
                        }
                    }
                },
                error: function (msg, textStatus, errorThrown) {
                    if (inVokemethod != "_clearCurrentServerCache") {
                        if (msg.readyState == 0) {
                            return;
                        }
                    }
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            }));
        },

        _initPages: function () {
            this._pageLocation = new Array();
            this._renderedCanvasList = new Array();
            this._pageContents = new Array();
            this._pageText = new Array();
            this._textDivs = new Array();
            this._textContents = new Array();
            this._searchMatches = new Array();
            this._searchCollection = new Array();
            this._pageLocation[1] = 0;
            this._searchedPages = new Array();
            this._canvascount = this._totalPages;
            this._pointers = new Array();
            this._imageObj = new Array();
            this._pagesGot = new Array();
            this._imageSrcCollection = new Array();
            this._selectionPages = new Array();
        },

        _getObjectSize: function (obj) {
            var size = 0, key;
            for (key in obj) {
                if (obj.hasOwnProperty(key))
                    size++;
            }
            return size;
        },

        /*
         * This function [_raiseClientEvent] is triggered when client side events (documentload,beforePrint,afterPrint,zoomchange,pageChange) are occured.
         */
        _raiseClientEvent: function (eventName, argument) {
            var eventfunction = this.model[eventName];
            var val = new Array();
            if (argument === null) {
                val = "";
            }
            else {
                val = argument;
            }
            if (eventfunction) {

                if (typeof eventfunction === "string") {
                    eventfunction = ej.util.getObject(eventfunction, window);
                }
                if ($.isFunction(eventfunction)) {
                    var args;
                    if (eventName == "pageChange")
                        args = { currentPageNumber: parseInt(argument.currentPageNumber) };
                    else if (eventName == "zoomChange")
                        args = { previousZoomPercentage: argument.previousZoomPercentage, currentZoomPercentage: argument.currentZoomPercentage };
                    else if (eventName == "hyperlinkClick")
                        args = { hyperlink: argument.hyperlink };
                    else if (eventName == "pageClick")
                        args = { XCoordinate: argument.offsetX, YCoordinate: argument.offsetY };
                    else if (eventName == "bufferStart")
                        args = { isBuffering: true };
                    else if (eventName == "bufferEnd")
                        args = { isBuffering: false };
                    else if (eventName == "documentLoad")
                        args = { fileName: argument.fileName };
                    else if (eventName == "ajaxRequestFailure")
                        args = { message: argument };
                    else if (eventName == "annotationAdd")
                        args = { annotationSettings: argument.annotationSettings, annotationID: argument.annotationId, pageID: argument.pageId, annotationBound: argument.annotationBound, annotationType: argument.annotationType };
                    else if (eventName == "annotationRemove")
                        args = { annotationID: argument.annotationId, pageID: argument.pageId, annotationType: argument.annotationType };
                    else if (eventName == "annotationPropertiesChange")
                        args = { annotationID: argument.annotationId, pageID: argument.pageId, annotationType: argument.annotationType, isColorChanged: argument.isColorChanged, isOpacityChanged: argument.isOpacityChanged };
                    else if (eventName == "annotationResize")
                        args = { annotationSettings: argument.annotationSettings, annotationID: argument.annotationID, pageID: argument.pageID, annotationBound: argument.annotationBound, annotationType: argument.annotationType };
                    else if (eventName == "signatureDelete")
                        args = { pageNumber: argument.pageNumber };
                    else if (eventName == "signatureAdd")
                        args = { signatureSettings: argument.signatureSettings, pageNumber: argument.pageNumber, signatureBound: argument.signatureBound };
                    else if (eventName == "signatureResize")
                        args = { signatureSettings: argument.signatureSettings,pageNumber: argument.pageNumber, signatureCurrentBound: argument.signatureCurrentBound, signaturePreviousBound: argument.signaturePreviousBound };
                    else if (eventName == "signaturePropertiesChange")
                        args = { pageID: argument.pageId, isColorChange: argument.isColorChange, isOpacityChange: argument.isOpacityChange, perviousColor: argument.perviousColor, currentColor: argument.currentColor, previousOpacity: argument.previousOpacity, currentOpacity: argument.currentOpacity };
                    else if (eventName == "downloadStart")
                        args = { fileName: argument.fileName, status: argument.status };
                    else if (eventName == "downloadEnd")
                        args = { fileName: argument.fileName, status: argument.status };
                    this._trigger(eventName, args);
                }
            }
        },

        _getPageModel: function (jsondata) {
            this._on($(window), "resize", this._viewerResize);
            if (jsondata) {
                this._isJsondataAvailable = true;
            }
            if (jsondata == "" || jsondata == null) {
                this._showloadingIndicator(true);
                $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html("");
                $('#' + this._id + '_txtpageNo').val('0');
            }
            var jsData;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsData = JSON.parse(jsondata);
            else
                jsData = JSON.parse(jsondata["d"]);
            if (jsData && this.model) {
                this._pageWidth = jsData["pagewidth"];
                this._pageHeight = jsData["pageheight"];
                this._imageUrl = jsData["imageurl"];
                this._pageSize = jsData["pagesize"];
                this._totalPages = jsData["pagecount"];
                this.pageCount = this._totalPages;
                this._pdfFileName = jsData["filename"];
                if (this.fileName) {
                    this._pdfFileName = this.fileName;
                } else {
                    if (this._pdfFileName) {
                        this.fileName = this._pdfFileName;
                    }
                }
                this._currentPage = jsData["currentpage"];
                this._restrictionSummary = jsData["restrictionSummary"];
                this._horizontalResolution = jsData["horizontalResolution"];
                this._isRestrictionEnabled();
                if (this._isPrintRestrict)
                    this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_Print');
                else if (!this._isPrintRestrict)
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_Print');
                this.currentPageNumber = this._currentPage;
                if (!this._isToolbarClick) {
                    this._enableToolbarItems();
                }
                if (!this._isSelectionHidden) {
                    if (this.model.enableTextSelection) {
                        this._isEnabled = true;
                    }
                    if (this.model.interactionMode == ej.PdfViewer.InteractionMode.TextSelection && this.model.enableTextSelection) {
                        this.model.enableTextSelection = true;
                    }
                    else if (this.model.interactionMode == ej.PdfViewer.InteractionMode.Pan) {
                        this.model.enableTextSelection = false;
                    }
                    var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
                    if (this._isCopyRestrict)
                        this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_select');
                    else if (!this._isCopyRestrict)
                        this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_select');
                    if (this.model.enableTextSelection && !isMobile) {
                        this._highlightSelectItems();
                    }
                    else if (!this.model.enableTextSelection || isMobile) {
                        if (!this._isEnabled) {
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_select');
                        }
                        this._highlightScrollItems();
                    }
                }
                this._gotoPage(this._currentPage);
                this._toolbarResizeHandler();
                this._setSearchToolbarTop();
                this._resizeSearchToolbar();
                this._drawPdfPage(jsondata);
                for (var i = 0; i < this._totalPages; i++) {
                    var pageArray = [], newArray = [], deleteArray = [], undoArray = [], redoArray = [], modifiedArray = [], totalArray = [];
                    this._newAnnotationList[i] = pageArray;
                    this._colorModifiedAnnotationList[i] = newArray;
                    this._deletedAnnotationList[i] = deleteArray;
                    this._existingAnnotationsModified[i] = modifiedArray;
                    this._redoAnnotationCollection[i] = redoArray;
                    this._annotationsDeletedNo[i] = 0;
                    this._totalAnnotations[i + 1] = totalArray;
                }
                this._showNavigationIndicator(false);
                this._showloadingIndicator(false);
            }
        },
        _isRestrictionEnabled: function () {
            if (this._restrictionSummary) {
                for (var i = 0; i < this._restrictionSummary.length; i++) {
                    switch (this._restrictionSummary[i]) {
                        case 'Print':
                            this._isPrintRestrict = true;
                            break;
                        case 'CopyContent':
                            this._isCopyRestrict = true;
                            this.model.enableTextSelection = false;
                            break;
                        case 'PageExtraction':
                            this._isPageExtraction = true;
                            break;
                        case 'FillFields':
                            this._isFormFieldsDisabled = true;
                            break;
                        case 'EditAnnotations':
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_highlight');
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                            this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_underline');
                            break;
                    }
                }
            }
        },
        //-------------------- Ajax Web API Call back methods[end] -------------------------//

        //-------------------- Print Actions[Start] -------------------------//
        _print: function () {
            this._abortPrinting = false;
            this._isPrintingProcess = true;
            this._raiseClientEvent("beforePrint", null);
            this._showPrintLoadingIndicator(true);
            this._setViewerForPrint();
            this._scrollPageByPage();

        },

        //Set the viewer for printing with zoom as 100% and moves the page to first page.
        _setViewerForPrint: function () {
            this._isPrinting = true;
            this._currentPageBackup = this._currentPage;
            this._scrollTop = $('#' + this._id + '_viewerContainer').scrollTop();
            this._zoomValBackup = this._zoomVal;
            this._zoomLevelBackup = this._zoomLevel;
            if (this._zoomVal != 1) {
                this._zoomVal = 1;
                this._zoomLevel = 2;
                this._fitTypeBackup = this._fitType;
                this._zoomContainer(this._zoomVal, false);
            }
        },

        //Changes the page one by one to render the pages in the viewer.
        _scrollPageByPage: function () {

            for (var i = 1; i <= this._totalPages; i++) {
                this._scrollTriggered = false;
                var isPrintingStarted = this._scrollToPageNo(i);
                if (isPrintingStarted)
                    break;
            }
            this._isPrinting = false;
            if (!isPrintingStarted) {
                var browserUserAgent = navigator.userAgent;
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    var proxy = this;
                    setTimeout(function () { proxy._printPages() }, 1000);
                } else {
                    this._printPages();
                }
                this._raiseClientEvent("afterPrint", null);
            }
        },

        //Gets the current page canvas and the scroll position.
        _scrollToPageNo: function (pageNo) {
            var currentPageNum = this._currentPage;
            if (this._totalPages) {
                var pagenumber = parseInt(pageNo);
                if (pagenumber >= 1 && pagenumber <= this._totalPages) {
                    this._currentPage = pagenumber;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    var isPrintingStarted = this._scrollPage(this._pageHeight);
                    return isPrintingStarted;
                }
            }
        },

        //Renders the current page and the next page in the viewer canvas.
        _scrollPage: function (pageHeight) {
            var currentPageNum = 0;
            this._scrollTriggered = true;
            var jsonResult = new Object();
            jsonResult["viewerAction"] = this._viewerAction.getPageModel;
            jsonResult["pageindex"] = this._currentPage.toString();
            jsonResult["id"] = this._fileId;
            jsonResult["isPrinting"] = true;
            jsonResult["signatureValues"] = JSON.stringify(this._signatureLayer);
            var actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.print;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                this._doAjaxPostPrint("POST", actionUrl, JSON.stringify(jsonResult));
            else
                this._doAjaxPostPrint("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
            return true;
        },

        //Opens the print window, displays print dialog box and closes the print function.
        _printPages: function () {
            var browserUserAgent = navigator.userAgent;
            var proxy = this;
            var iframe = this._printIframe;
            iframe.name = "printFrame";
            iframe.style.position = "absolute";
            iframe.style.top = "-100000000px";
            document.body.appendChild(iframe);
            var frameDoc = iframe.contentWindow ? iframe.contentWindow : iframe.contentDocument.document ? iframe.contentDocument.document : iframe.contentDocument;
            frameDoc.document.open();
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    //chrome and firefox
                    frameDoc.document.write('<!DOCTYPE html>');
                    frameDoc.document.write('<html moznomarginboxes mozdisallowselectionprint><head><style>html, body { height: 100%; } img { height: 100%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');
                    //chrome and firefox
                }
                else {
                    //ie
                    frameDoc.document.write('<!DOCTYPE html>');
                    frameDoc.document.write('<html><head><style>html, body { height: 99%; } img { height: 99%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');

                }
            }
            else {
                //ie
                frameDoc.document.write('<!DOCTYPE html>');
                frameDoc.document.write('<html><head><style>html, body { height: 99%; } img { height: 99%; width: 100%; display: block; }@media print { body { margin: 0cm; }img { box-sizing: border-box; }br, button { display: none; }} @page{margin:0cm; size: 816px 1056px;}</style></head><body><center>');
            }

            for (var i = 1; i <= proxy._totalPages; i++) {
                var canvasUrl = "", values = "";
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var selectionCanvas = document.getElementById(this._id + 'selectioncanvas_' + i);
                var secondaryCanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                var pagediv = document.getElementById(this._id + 'pageDiv_' + i);
                canvasUrl = canvas.toDataURL();
                var secCanvasUrl = secondaryCanvas.toDataURL();

                if (window.innerWidth < screen.width) {
                    values = proxy._zoomVal;
                    proxy._topValue = true;
                    var jsdata = proxy._pageContents[parseInt(i)];
                    var newData = proxy._printPdfPages(jsdata);
                    canvasUrl = newData.toDataURL();
                    secCanvasUrl = secondaryCanvas.toDataURL();
                }
                else
                    values = 1;
                if ((browserUserAgent.indexOf("Firefox")) == -1) {
                    if (proxy._pageSize[i - 1].PageWidth > proxy._pageSize[i - 1].PageHeight) {
                        var context = canvas.getContext('2d');
                        var seccontext = secondaryCanvas.getContext('2d');
                        var image = new Image();
                        context.clearRect(0, 0, canvas.width, canvas.height);
                        canvas.width = proxy._pageSize[i - 1].PageHeight;
                        canvas.height = proxy._pageSize[i - 1].PageWidth;
                        canvas.style.height = proxy._pageSize[i - 1].PageWidth + 'px';
                        canvas.style.width = proxy._pageSize[i - 1].PageHeight + 'px';
                        context.save();
                        context.translate(canvas.width / 2, canvas.height / 2);
                        context.rotate(-Math.PI / 2);
                        image.src = canvasUrl;
                        context.drawImage(image, -image.width / 2, -image.height / 2);
                        context.restore();
                        canvasUrl = canvas.toDataURL();

                        seccontext.clearRect(0, 0, secondaryCanvas.width, secondaryCanvas.height);
                        secondaryCanvas.width = proxy._pageSize[i - 1].PageHeight;
                        secondaryCanvas.height = proxy._pageSize[i - 1].PageWidth;
                        secondaryCanvas.style.height = proxy._pageSize[i - 1].PageWidth + 'px';
                        secondaryCanvas.style.width = proxy._pageSize[i - 1].PageHeight + 'px';
                        seccontext.save();
                        seccontext.translate(secondaryCanvas.width / 2, secondaryCanvas.height / 2);
                        seccontext.rotate(-Math.PI / 2);
                        image.src = secCanvasUrl;
                        seccontext.drawImage(image, -image.width / 2, -image.height / 2);
                        seccontext.restore();
                        secCanvasUrl = secondaryCanvas.toDataURL();
                    }
                }
                frameDoc.document.write('<div style="margin:0px;width:816px;height:1056px;position:relative"><img src="' + canvasUrl + '" id="' + 'image_' + i + '" /><img src="' + secCanvasUrl + '" id = "secimage_' + i + '" style="margin:0px;top:0px;left:0px;position:absolute;width:816px;height:1056px;z-index:2" /><div id="' + 'fields_' + i + '"></div><div id="' + 'signaturefields_' + i + '"style="margin:0px;top:0px;left:0px;position:absolute;z-index:1000"></div></div><br/>');
                var length = $(selectionCanvas).find('.e-pdfviewer-formFields').length;
                var cummulativepageheight = 2;
                for (var l = 0; l < length; l++) {
                    var index = "";
                    var inputdiv = $(selectionCanvas).find('.e-pdfviewer-formFields')[l];
                    var currentInput = inputdiv.cloneNode(true);
                    if (inputdiv.type == "select-one") {
                        index = inputdiv.selectedIndex;
                        var childrens = currentInput.children;
                        $(childrens[index]).prop("selected", true);
                    }
                    var PagesWidth = proxy._pageSize[i - 1].PageWidth;
                    var PagesHeight = proxy._pageSize[i - 1].PageHeight;
                    var heightRatio = PagesHeight / 1056;
                    var widthRatio = PagesWidth / 816;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    if (is_ie || browserUserAgent.indexOf('Edge') != -1) {
                        $(currentInput).css("left", ((parseFloat($(currentInput).css("left")))) + "px");
                        $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) - 6)) + "px");
                    }
                    if (window.innerWidth < screen.width) {
                        $(currentInput).css("left", ((parseFloat($(currentInput).css("left")) / values)) + "px");
                        $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) / values)) + "px");
                    }
                    $(currentInput).css("left", ((parseFloat($(currentInput).css("left")) / widthRatio)) + "px");
                    $(currentInput).css("top", ((parseFloat($(currentInput).css("top")) / heightRatio)) + "px");
                    $(currentInput).css("width", (parseFloat($(currentInput).css("width")) / values) + "px");
                    $(currentInput).css("height", (parseFloat($(currentInput).css("height")) / values) + "px");
                    $(frameDoc.document.getElementById('fields_' + i)).append(currentInput);
                }
                var signature = $(pagediv).find('.e-pdfviewer-imagecanvasDraw');
                for (var k = 0; k < signature.length; k++) {
                    var signatureElement = $(signature)[k];
                    var img = document.createElement("img");
                    img.src = signatureElement.toDataURL();
                    $(img).css("position", "absolute");
                    $(img).css("left", ($(signatureElement).css("left")));
                    $(img).css("top", ($(signatureElement).css("top")));
                    $(img).css("width", ($(signatureElement).css("width")));
                    $(img).css("height", ($(signatureElement).css("height")));
                    $(frameDoc.document.getElementById('signaturefields_' + i)).append(img);
                }
            }
            this._topValue = false;
            frameDoc.document.write('</center></body></html>');
            if (navigator.userAgent.match("Firefox")) {
                window.frames["printFrame"].close();
            } else {
                frameDoc.document.close();
            }
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                    var proxy = this;
                    setTimeout(function () {
                        window.frames["printFrame"].focus();
                        window.frames["printFrame"].print();
                        document.body.removeChild(iframe);
                    }, 500);
                }
                else {
                    var target = $('iframe')[0];
                    try {
                        target.contentWindow.document.execCommand('print', false, null);
                    } catch (e) {
                        target.contentWindow.print();
                    }
                }
            }
            else {
                var target = $('iframe')[0];
                try {
                    target.contentWindow.document.execCommand('print', false, null);
                } catch (e) {
                    target.contentWindow.print();
                }
            }
            this._restoreViewer();
        },

        //Cancels the printing and restores the PDF viewer.
        _printCancel: function () {
            this._abortPrinting = true;
            this._restoreViewer();
            this._raiseClientEvent("afterPrint", null);
        },

        //Restores the viewer with the current zoom value and scroll position.
        _restoreViewer: function () {
            this._isPrintingProcess = false;
            this._currentPage = this._currentPageBackup;
            this._zoomVal = this._zoomValBackup;
            this._zoomLevel = this._zoomLevelBackup;
            for (var i = 1; i <= this._totalPages; i++) {
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                if (this._pageSize[i - 1].PageWidth > this._pageSize[i - 1].PageHeight) {
                    canvas.style.height = this._pageSize[i - 1].PageHeight + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageWidth + 'px';
                    canvas.width = this._pageSize[i - 1].PageWidth;
                    canvas.height = this._pageSize[i - 1].PageHeight;
                    this._renderedCanvasList.length = 0;
                }
            }
            if (this._fitTypeBackup == null) {
                this._zoomContainer(this._zoomVal, false);
            } else {
                var _scaleXY = this._fitToPage(this._fitTypeBackup);
                this._applyDropDownVal(_scaleXY, true, false);
                this._updatePageFitModel(this._fitType);
            }
            var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
            pageviewcontainer.scrollTop = this._scrollTop;
            this._showPrintLoadingIndicator(false);
        },

        _doAjaxPostPrint: function (type, url, jsonResult) {
            var parseJson = JSON.parse(jsonResult);
            if (this._pdfService == ej.PdfViewer.PdfService.Local) {
                this._currentPrintPage = parseJson["pageindex"];
            }
            else {
                var jsonData = parseJson["jsonResult"];
                this._currentPrintPage = jsonData["pageindex"];
            }
            if (this.model.allowClientBuffering && this._isBuffering) {
                if (this._ajaxRequestState != null) {
                    this._ajaxRequestState.abort();
                    this._ajaxRequestState = null;
                }
            }
            if (this._pageContents[this._currentPrintPage]) {
                var data = this._pageContents[this._currentPrintPage];
                if (typeof data === 'object')
                    this._printPdfPages(JSON.stringify(data));
                else
                    this._printPdfPages(data);
                this._scrollTriggered = false;
                if (this._abortPrinting) {
                    return;
                }
                if (parseFloat(this._currentPrintPage) < this.pageCount) {
                    var jsonResult = new Object();
                    jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                    jsonResult["pageindex"] = (parseFloat(this._currentPrintPage) + 1).toString();//proxy._currentPage.toString();
                    jsonResult["id"] = this._fileId;
                    jsonResult["isPrinting"] = true;
                    jsonResult["signatureValues"] = JSON.stringify(this._signatureLayer);
                    var actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.print;
                    if (this._pdfService == ej.PdfViewer.PdfService.Local)
                        this._doAjaxPostPrint("POST", actionUrl, JSON.stringify(jsonResult));
                    else
                        this._doAjaxPostPrint("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                }
                else {
                    var browserUserAgent = navigator.userAgent;
                    if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                        var proxy = this;
                        setTimeout(function () { proxy._printPages() }, 1000);
                    } else {
                        this._printPages();
                    }
                    this._raiseClientEvent("afterPrint", null);
                }
            } else {
                var proxy = this;
                ($.ajax({
                    type: type,
                    url: url,
                    crossDomain: true,
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    data: jsonResult,
                    traditional: true,
                    success: function (data) {
                        if (typeof data === 'object')
                            proxy._printPdfPages(JSON.stringify(data));
                        else
                            proxy._printPdfPages(data);
                        proxy._scrollTriggered = false;
                        if (proxy._abortPrinting) {
                            return;
                        }
                        if (parseFloat(proxy._currentPrintPage) < proxy.pageCount) {
                            var jsonResult = new Object();
                            jsonResult["viewerAction"] = proxy._viewerAction.getPageModel;
                            jsonResult["pageindex"] = (parseFloat(proxy._currentPrintPage) + 1).toString();//proxy._currentPage.toString();
                            jsonResult["id"] = proxy._fileId;
                            jsonResult["isPrinting"] = true;
                            jsonResult["signatureValues"] = JSON.stringify(proxy._signatureLayer);
                            var actionUrl = proxy.model.serviceUrl + "/" + proxy.model.serverActionSettings.print;
                            if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                                proxy._doAjaxPostPrint("POST", actionUrl, JSON.stringify(jsonResult));
                            else
                                proxy._doAjaxPostPrint("POST", proxy.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }));
                        }
                        else {
                            var browserUserAgent = navigator.userAgent;
                            if ((browserUserAgent.indexOf('Chrome') != -1) || (browserUserAgent.indexOf('Safari') != -1) || (browserUserAgent.indexOf("Firefox")) != -1) {
                                setTimeout(function () { proxy._printPages() }, 1000);
                            } else {
                                proxy._printPages();
                            }
                            proxy._raiseClientEvent("afterPrint", null);
                        }
                    },
                    error: function (msg, textStatus, errorThrown) {
                        if (msg.readyState == 0) {
                            return;
                        }
                        proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                    }
                }));
            }
        },

        //Rendering function for print.
        _printPdfPages: function (printData) {
            var imageIndex = 0;
            var backupjson = printData;
            var jsondata;
            if (this._pdfService == ej.PdfViewer.PdfService.Local)
                jsondata = JSON.parse(printData);
            else
                jsondata = JSON.parse(printData["d"]);
            var pageindex = parseInt(jsondata["currentpage"]);
            this._showPageLoadingIndicator(pageindex, true);
            var pageimageList = jsondata["imagestream"];
            var index = parseInt(jsondata["currentpage"]);
            if (this._renderedCanvasList.indexOf(index) == -1) {
                this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
            }
            if (!this._pageContents[pageindex]) {
                this._textMarkupAnnotationList[parseInt(jsondata["currentpage"])] = jsondata["textMarkupAnnotation"];
            }
            this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
            if (this._textMarkupAnnotationList[pageindex] || this._newAnnotationList[pageindex - 1]) {
                this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
            }
            var canvas;
            if (this._topValue == true) {
                var currentpage = parseInt(jsondata["currentpage"]);
                var canvas = document.createElement('canvas');
                var height = this._pageSize[currentpage - 1].PageHeight;
                var width = this._pageSize[currentpage - 1].PageWidth;
                canvas.style.visibility = 'hidden';
                canvas.style.width = width + "px";
                canvas.style.height = height + "px";
                canvas.style.backgroundColor = 'white';
                canvas.className = "e-pdfviewer-pageCanvas";
                canvas.height = height;
                canvas.width = width;
            }
            else
                canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
            if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
            }
            else {
                canvas.width = this._pageSize[pageindex - 1].PageWidth ;
                canvas.height =  this._pageSize[pageindex - 1].PageHeight;
                canvas.style.height =  this._pageSize[pageindex - 1].PageHeight + 'px';
                canvas.style.width =  this._pageSize[pageindex - 1].PageWidth + 'px';
            }
            var context = canvas.getContext('2d');
            var imageObjCollection = new Array();
            var imageTransformCollection = new Array();
            var imageDataCollection = new Array();
            var currentIndexCollection = new Array();
            var pageDataCollection = new Array();
            var zoomFactor;
            var browserUserAgent = navigator.userAgent;
            var offsett;

            var charPath = new Array();
            this._regenerateFormFields(jsondata, pageindex);
            var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
            for (i = 0; i < children.length; i++) {
                if (children[i].hasAttribute('href') || $(children[i]).hasClass('e-pdfviewer-formFields'))
                    $(children[i]).remove();
            }
            this._createFormFields(jsondata, pageindex);
            var shapes = pageimageList["textelements"];
            for (var j = 0; j < shapes.length; j++) {
                var pathdata = shapes[j];
                var color = pathdata["color"];
                var matrix = pathdata["matrix"];
                if (matrix != null)
                    matrix = matrix["Elements"];
                var brushMode = pathdata["brush"];
                var pathValue = pathdata["pathValue"];
                var isClipping = pathdata["iscliping"];
                var restoreCanvas = pathdata["restorecanvas"];
                var imageData = pathdata["imagedata"];
                var fillMode = pathdata["fillrule"];
                var fillStroke = pathdata["isFillandStroke"];
                var fillColor = pathdata["fillcolor"];
                var strokeColor = pathdata["strokecolor"];
                var lineWidth = pathdata["linewidth"];
                var lineCap = pathdata["linecap"];
                var linearGradient = pathdata["linearGradientBrush"];
                var textureBrush = pathdata["textureBrushs"];
                var charID = pathdata["charID"];
                var alpha = pathdata["alpha"];
                if (pathValue != null) {
                    pathValue = pathValue.split(";");
                    if (charID)
                        charPath[charID] = pathValue;
                }
                else if (pathValue == null && charID) {
                    pathValue = charPath[charID];
                }
                if (restoreCanvas == false) {
                    context.save();
                }
                if (pathValue != undefined) {
                    context.setTransform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
                }

                if (pathValue != null) {
                    context.beginPath();

                    for (var i = 0; i < pathValue.length; i++) {
                        var val = pathValue[i];
                        var pathType = val[0];
                        if (pathType == "M") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.moveTo((val[0]), val[1]);
                        }
                        else if (pathType == "L") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.lineTo((val[0]), val[1]);
                        }
                        else if (pathType == "C") {
                            val = val.substring(1, val.length);
                            val = val.split(" ");
                            context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                        }
                        else if (pathType == "Z") {
                            context.closePath();
                        }
                    }
                    if (isClipping == true) {
                        if (fillMode == "evenodd") {
                            context.msFillRule = "evenodd";
                            context.mozFillRule = "evenodd";
                            context.clip(fillMode);
                        }
                        context.clip();

                    }
                    else {
                        if (fillStroke == undefined) {
                            if (brushMode == "Fill") {
                                if (linearGradient != undefined) {
                                    context.fillStyle = this._getGradientBrush(linearGradient, context);
                                }
                                        else if (textureBrush != undefined) {
                                            context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                        }
                                        else {
                                            if (alpha != undefined)
                                                context.globalAlpha = alpha;
                                            context.fillStyle = color;
                                        }
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                    context.fill(fillMode);
                                }
                                context.fill();
                            }
                            else if (brushMode == "FillandStroke") {
                                context.fillStyle = color;
                                context.fill();
                                context.strokeStyle = strokeColor;
                                context.stroke();
                            }
                            else if (brushMode == "Stroke") {
                                context.strokeStyle = strokeColor;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                            }
                            else {
                                context.strokeStyle = color;
                                context.lineWidth = lineWidth;
                                context.lineCap = lineCap;
                                context.stroke();
                            }
                        }
                        else {
                            context.strokeStyle = strokeColor;
                            context.lineWidth = lineWidth;
                            context.lineCap = lineCap;
                            context.stroke();
                            if (linearGradient != undefined) {
                                context.fillStyle = this._getGradientBrush(linearGradient, context);
                            }
                            else if (textureBrush != undefined) {
                                context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                            }
                            else
                                context.fillStyle = fillColor;
                            if (fillMode == "evenodd") {
                                context.msFillRule = "evenodd";
                                context.mozFillRule = "evenodd";
                                context.fill(fillMode);
                            }
                            context.fill();
                        }
                    }
                }

                if (restoreCanvas)
                    context.restore();
                if (imageData != undefined) {
                    if (((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) && !this._topValue) {
                        imageObjCollection.push(imageData);
                        imageTransformCollection.push(matrix);
                        pageDataCollection.push(shapes);
                        currentIndexCollection.push(j);
                        this._isContainImage = true;
                        break;
                    }
                    else {
                        var imageObj = new Image();
                        imageObj.src = imageData;
                        context.setTransform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
                        context.drawImage(imageObj, 0, 0, 1, 1);
                    }
                }
            }
            if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                for (var k = 0; k < imageObjCollection.length; k++) {
                    this._printWinImageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, k, pageDataCollection, currentIndexCollection, charPath, canvas, index, imageIndex);
                    imageIndex++;
                }
            }
            var tempcanvas = canvas;
            var proxy = this;
            if (this._pageSize[index - 1].PageRotation != 0) {
                if (!(imageObjCollection.length != 0 && (browserUserAgent.indexOf("Firefox") != -1 || browserUserAgent.indexOf("Chrome") != -1))) {
                    tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                    var canvasUrl = tempcanvas.toDataURL();
                    var context = tempcanvas.getContext('2d');
                    var image = new Image();
                    if ((browserUserAgent.indexOf("Firefox")) != -1) {
                        image.onload = function () {
                            context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px'
                            }
                            context.save();
                            context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                            context.drawImage(image, -image.width / 2, -image.height / 2);
                            context.restore();
                        }
                        image.src = canvasUrl;
                    } else {
                        context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                        if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                            tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                            tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                            tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                            tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                        } else {
                            tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                            tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                            tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px'
                        }
                        context.save();
                        context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                        context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                        image.src = canvasUrl;
                        context.drawImage(image, -image.width / 2, -image.height / 2);
                        context.restore();
                    }
                }
            }
            this._showPageLoadingIndicator(pageindex, false);
            this._changingImageCanvasPosition(pageindex);
            this._showSignature()
            return tempcanvas;
        },

        //Renders images while the image is loaded.
        _printWinImageRendering: function (shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, index, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex) {
            var proxy = this;
            var imageObject = new Image();
            imageObject.onload = function () {
                var isImageContentChanged = false;
                var matrixData = imageTransformCollection[index];
                for (var l = 0; l < imageTransformCollection.length; l++) {
                    if (isImageContentChanged == false) {
                        var matrixData = imageTransformCollection[l];
                        context.setTransform(matrixData[0], matrixData[1], matrixData[2], matrixData[3], matrixData[4], matrixData[5]);
                        if (imageDataCollection[imageIndex] != undefined) {
                            context.drawImage(imageDataCollection[imageIndex], 0, 0, 1, 1);
                        }
                        var dataIndex = currentIndexCollection[l];
                        dataIndex = dataIndex + 1;
                        var data = pageDataCollection[l];
                        while (dataIndex < data.length) {
                            var pathdata = data[dataIndex];
                            var color = pathdata["color"];
                            var matrix = pathdata["matrix"];
                            if (matrix != null)
                                matrix = matrix["Elements"];
                            var brushMode = pathdata["brush"];
                            var pathValue = pathdata["pathValue"];
                            var isClipping = pathdata["iscliping"];
                            var restoreCanvas = pathdata["restorecanvas"];
                            var imageData = pathdata["imagedata"];
                            var fillMode = pathdata["fillrule"];
                            var fillStroke = pathdata["isFillandStroke"];
                            var fillColor = pathdata["fillcolor"];
                            var strokeColor = pathdata["strokecolor"];
                            var lineWidth = pathdata["linewidth"];
                            var lineCap = pathdata["linecap"];
                            var linearGradient = pathdata["linearGradientBrush"];
                            var textureBrush = pathdata["textureBrushs"];
                            var charID = pathdata["charID"];
                            var rectangle = pathdata["rectvalue"];
                            var alpha = pathdata["alpha"];
                            if (pathValue != null) {
                                pathValue = pathValue.split(";");
                                if (charID)
                                    charPath[charID] = pathValue;
                            }
                            else if (pathValue == null && charID) {
                                pathValue = charPath[charID];
                            }
                            if (restoreCanvas == false) {
                                context.save();
                            }
                            if (pathValue != undefined) {
                                context.setTransform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
                            }

                            if (pathValue != null) {
                                context.beginPath();

                                for (var i = 0; i < pathValue.length; i++) {
                                    var val = pathValue[i];
                                    var pathType = val[0];
                                    if (pathType == "M") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.moveTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "L") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.lineTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "C") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                    }
                                    else if (pathType == "Z") {
                                        context.closePath();
                                    }
                                }
                                if (isClipping == true) {
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.clip(fillMode);
                                    }
                                    context.clip();

                                }
                                else {
                                    if (fillStroke == undefined) {
                                        if (brushMode == "Fill") {
                                            if (linearGradient != undefined) {
                                                context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                            }
                                            else if (textureBrush != undefined) {
                                                context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                            }
                                            else {
                                                if (alpha != undefined)
                                                    context.globalAlpha = alpha;
                                                context.fillStyle = color;
                                            }
                                            if (fillMode == "evenodd") {
                                                context.msFillRule = "evenodd";
                                                context.mozFillRule = "evenodd";
                                                context.fill(fillMode);
                                            }
                                            context.fill();
                                        }
                                        else if (brushMode == "FillandStroke") {
                                            context.fillStyle = color;
                                            context.fill();
                                            context.strokeStyle = strokeColor;
                                            context.stroke();
                                        }
                                        else if (brushMode == "Stroke") {
                                            context.strokeStyle = strokeColor;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                        else {
                                            context.strokeStyle = color;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                    }
                                    else {
                                        context.strokeStyle = strokeColor;
                                        context.lineWidth = lineWidth;
                                        context.lineCap = lineCap;
                                        context.stroke();
                                        if (linearGradient != undefined) {
                                            context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                        }
                                        else if (textureBrush != undefined) {
                                            context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                        }
                                        else
                                            context.fillStyle = fillColor;
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.fill(fillMode);
                                        }
                                        context.fill();
                                    }
                                }
                            }

                            if (restoreCanvas)
                                context.restore();
                            if (imageData != undefined) {
                                isImageContentChanged = true;
                                imageObjCollection.pop();
                                imageTransformCollection.pop();
                                pageDataCollection.pop();
                                currentIndexCollection.pop();
                                imageObjCollection.push(imageData);
                                imageTransformCollection.push(matrix);
                                pageDataCollection.push(shapes);
                                currentIndexCollection.push(dataIndex);
                                l = -1;
                                imageIndex++;
                                break;
                            }
                            dataIndex++;
                        }
                    }
                    else {
                        proxy._printWinImageRendering(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, l, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex);
                        imageIndex++;
                    }
                }
                if (imageDataCollection.length - 1 == index) {
                    if (proxy._pageSize[currentindex - 1].PageRotation != 0) {
                        var tempcanvas = document.getElementById(proxy._id + 'pagecanvas_' + currentindex);
                        var canvasUrl = tempcanvas.toDataURL();
                        var ctx = tempcanvas.getContext('2d');
                        var image = new Image();
                        image.onload = function () {
                            ctx.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[currentindex - 1].PageRotation == 90 || proxy._pageSize[currentindex - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight;
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageWidth + 'px';
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[currentindex - 1].PageHeight + 'px';
                            }
                            ctx.save();
                            ctx.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            ctx.rotate((proxy._pageSize[currentindex - 1].PageRotation / 2) * Math.PI / 2);
                            ctx.drawImage(image, -image.width / 2, -image.height / 2);
                            ctx.restore();
                        }
                        image.src = canvasUrl;
                    }
                }
            };
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
            this._imageObj.push(imageObject);
        },

        _showPrintButton: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isPrintHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isPrintHidden = true;
            }
        },
        _showDownloadButton: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isDownloadHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_download').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isDownloadHidden = true;
            }
        },
        //-------------------- Print Actions[end] -------------------------//

        //-------------------- Page Navigation Actions[Start] -------------------------//
        _updatePageNavigation: function (pageNo, totalPage) {
            if (pageNo > 1 && pageNo < totalPage) {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else if (pageNo == 1 && pageNo < totalPage) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else if (pageNo == totalPage && totalPage != 1) {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            } else {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            }
            if (!this._isJsondataAvailable) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
            }

            this.currentPageNumber = this._currentPage;
        },

        _gotoFirstPage: function () {
            if (this._totalPages) {
                if (this._totalPages > 0) {
                    this._currentPage = 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoLastPage: function () {
            if (this._totalPages) {
                if (this._totalPages > 0) {
                    this._currentPage = this._totalPages;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoNextPage: function () {
            if (this._totalPages) {
                if (this._currentPage < this._totalPages) {
                    this._currentPage = this._currentPage + 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoPreviousPage: function () {
            if (this._totalPages) {
                if (this._currentPage > 1) {
                    this._currentPage = this._currentPage - 1;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
        },

        _gotoPageNo: function (pageNo) {
            var pagenumbervalue = { currentPageNumber: 0 };
            var pagenoentered = pageNo;
            var currentPageNum = this._currentPage;
            if (this._totalPages) {
                var pagenumber = parseInt(pageNo);
                if (pagenumber >= 1 && pagenumber <= this._totalPages && this._currentPage != pagenumber) {
                    this._currentPage = pagenumber;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    this._pageviewscrollchanged(this._pageHeight);
                    this._updatePageNavigation(this._currentPage, this._totalPages);
                }
            }
            if (currentPageNum != pagenoentered) {
                pagenumbervalue.currentPageNumber = pagenoentered;
                this._raiseClientEvent("pageChange", pagenumbervalue);
            }
        },

        _gotoPage: function (pageNo) {
            this._setPageSize(this._pageHeight, this._pageWidth, null, null);
            var pagenumber = parseInt(pageNo);
            this._updatePageNavigation(pagenumber, this._totalPages);
            if (this._totalPages > 0 && this._totalPages) {
                $('#' + this._id + '_toolbarContainer span.e-pdfviewer-labelpageno').html(" / " + this._totalPages);
                $('#' + this._id + '_txtpageNo').val(pagenumber);
            }
        },

        _allowOnlyNumbers: function (event) {
            if ((event.which < 48 || event.which > 57) && event.which != 8 && event.which != 13) {
                return false;
            }
            else {
                return true;
            }
        },

        _onkeyPress: function (event) {
            if (event.which == 13) {
                event.preventDefault();
                try {
                    var val = parseInt($(event.currentTarget).val());
                    if (val > 0 && val <= this.pageCount)
                        this._gotoPageNo(val);
                    else
                        $(event.currentTarget).val(this.currentPageNumber);
                } catch (err) {
                }
            }
        },

        _showPageNavigationControls: function (show) {
            if (show) {
                $('#' + this._id + '_txtpageNo').parents(".e-pdfviewer-toolbarul").css("display", "block");
                $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("border-right-width", "1px");
                this._isNavigationHidden = false;
            } else {
                $('#' + this._id + '_txtpageNo').parents(".e-pdfviewer-toolbarul").css("display", "none");
                this._isNavigationHidden = true;
                if (!this._isPrintHidden && this._isNavigationHidden && this._isMagnificationHidden) {
                    $('#' + this._id + '_toolbar_Print').parent().parents(".e-pdfviewer-toolbarul").css("border-right-width", "0px");
                }
            }
        },
        //-------------------- Page Navigation Actions[End] -------------------------//


        //-------------------- FitToPage[start] -------------------------//
        _showFittoPage: function (show) {
            if (show) {
                $('#' + this._id + '_fitWidth').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_fitPage').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_fitPage').parents("ul.e-pdfviewer-toolbarul").css("display", "block");
            } else {
                $('#' + this._id + '_fitWidth').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_fitPage').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_fitPage').parents("ul.e-pdfviewer-toolbarul").css("display", "none");
            }
        },

        _resetPage: function () {
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (pagecontainer[0] != undefined) {
                pageViewline.css({ "width": pagecontainer.width(), "height": pagecontainer.height() });
                pageViewline.css({ "width": pagecontainer[0].getBoundingClientRect().width, "height": pagecontainer[0].getBoundingClientRect().height });
            }
        },

        /*  _applyFitToWidth() is a event handler for the fitWidth button. This function fits the page to width of the container and applies the
            dropDown value to the zoom dropdown list. Then updates the page fit button.
        */
        _applyFitToWidth: function () {
            this._isAutoZoom = false;
            this._isAutoSelected = false;
            var _scaleXY = this._fitToPage("fitToWidth");
            this._applyDropDownVal(_scaleXY, true, false);
            this._updatePageFitModel(this._fitType);
            this.model.isResponsive = false;
        },

        /*  _applyFitToPage() is a event handler for the fitPage button. This function fits the page to the container and applies the
            dropDown value to the zoom dropdown list. Then updates the page fit button.
        */
        _applyFitToPage: function () {
            this._isAutoZoom = false;
            this._isAutoSelected = false;
            var _scaleXY = this._fitToPage("fitToPage");
            this._applyDropDownVal(_scaleXY, false, true);
            this._updatePageFitModel(this._fitType);
            this.model.isResponsive = false;
        },


        /* _updatePageFitModel() function is used to enable or disable the PageFit button. This is done by adding and removing 
          a class "e-pdfviewer-disabled-fitButton".
        */
        _updatePageFitModel: function (fitType) {
            if (fitType == "fitToWidth") {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            } else if (fitType == "fitToPage") {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            }
        },

        _applyFitToWidthAuto: function () {
            var _scaleXY = this._fitToAuto("fitToWidth");
            this._applyDropDownValAuto(_scaleXY, true, false);
        },

        _fitToAuto: function (fitType) {
            this._resetPage();
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var pageViewline = $('#' + this._id + '_pageviewOuterline');
            if (pageViewerContainer[0] != undefined) {
                var w = pageViewerContainer.width();
                var h = pageViewerContainer.height();
                var pageW = this._pageWidth;
                var pageH = this._pageHeight;
                var scaleX = 1;
                var scaleY = 1;
                scaleX = (w - 25) / pageW;
                if (this._isAutoZoom) {
                    scaleX = Math.min(1, scaleX);
                    if (scaleX == 1)
                        this._zoomLevelBackup = this._zoomLevel = 3;

                }
                if (window.innerWidth >= screen.width) {
                    this._isWindowResizing = false;
                }
                scaleY = scaleX;
                this._zoomVal = scaleX;
                this._fitToAutoSize();
                this._calculateZoomLevel(this._zoomVal);
                this._initRerendering();
                this._updateZoomButtons();
                return { scalX: scaleX, scalY: scaleY }
            }
        },

        _fitToPage: function (fitType) {
            if (this._pageSize != undefined) {
                this._resetPage();
                var pageViewerContainer = $('#' + this._id + '_viewerContainer');
                var pagecontainer = $('#' + this._id + '_pageviewContainer');
                var pageViewline = $('#' + this._id + '_pageviewOuterline');
                var w = pageViewerContainer.width();
                var h = pageViewerContainer.height();
                if (fitType == "fitToWidth") {
                    for (var i = 0; i < this._pageSize.length; i++) {
                        var pageWidth = 0;
                        if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                            pageWidth = this._pageSize[i].PageHeight;
                        } else {
                            pageWidth = this._pageSize[i].PageWidth;
                        }
                        if (pageWidth > this._highestWidth) {
                            this._highestWidth = pageWidth;
                        }
                    }
                } else {
                    this._highestWidth = this._pageWidth;
                }
                if (fitType == "fitToPage") {
                    for (var i = 0; i < this._pageSize.length; i++) {
                        var pageHeight = 0;
                        if (this._pageSize[i].PageRotation == 90 || this._pageSize[i].PageRotation == 270) {
                            pageHeight = this._pageSize[i].PageWidth;
                        } else {
                            pageHeight = this._pageSize[i].PageHeight;
                        }
                        if (pageHeight > this._highestHeight) {
                            this._highestHeight = pageHeight;
                        }
                    }
                } else {
                    this._highestHeight = this._PageHeight;
                }
                var pageW = this._highestWidth;
                var pageH = this._highestHeight;
                var scaleX = 1;
                var scaleY = 1;
                this._fitType = fitType;
                if (fitType == "fitToPage") {
                    scaleX = (w - 25) / pageW;
                    scaleY = (h) / pageH;
                    if (h > pageH) {
                        scaleY = this._preZoomVal;
                    }

                    if (w > pageW) {
                        scaleX = this._preZoomVal;
                    }
                    if (this._fitType == "fitToPage" && this._pageSize[this._currentPage - 1].PageOrientation == "Landscape" && scaleX < scaleY) {
                        scaleX = scaleX;
                    }
                    else
                        scaleX = scaleY;
                    this._zoomVal = scaleX;
                    this._zoomInContainer();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + 'pageDiv_' + (this._currentPage + 1)).css("visibility", "hidden");
                    var proxy = this;
                    var pageviewcontainer = document.getElementById(this._id + '_viewerContainer');
                    $('#' + this._id + '_viewerContainer').on('mousewheel DOMMouseScroll', function (e) {
                        var pageviewcontainer = document.getElementById(proxy._id + '_viewerContainer');
                        var fittopage = $('#' + proxy._id + '_pdfviewer_toolbar_fitPage').attr('aria-disabled');
                        if (fittopage == "true") {
                            if (e.originalEvent.wheelDelta > 0 || e.originalEvent.detail < 0) {
                                if (proxy._currentPage > 1) {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage - 1] * proxy._zoomVal));
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                }
                            }
                            else {
                                if (proxy._currentPage != proxy._totalPages) {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage + 1] * proxy._zoomVal));
                                    if ((proxy._currentPage + 1) == proxy._totalPages) {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                    }
                                    else {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 2)).css("visibility", "hidden");
                                    }
                                }
                            }
                            e.preventDefault();
                        }
                    });
                    $(window).on('keydown', function (e) {
                        var pageviewcontainer = document.getElementById(proxy._id + '_viewerContainer');
                        var fittopage = $('#' + proxy._id + '_pdfviewer_toolbar_fitPage').attr('aria-disabled');
                        if (fittopage == "true") {
                            if (proxy._currentPage > 1 && e.keyCode == '38') {
                                $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "");
                                pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage - 1] * proxy._zoomVal));
                                $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                            }
                            else {
                                if (proxy._currentPage != proxy._totalPages && e.keyCode == '40') {
                                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "");
                                    pageviewcontainer.scrollTop = (parseFloat(proxy._pageLocation[proxy._currentPage + 1] * proxy._zoomVal));
                                    if ((proxy._currentPage + 1) == proxy._totalPages) {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage)).css("visibility", "hidden");
                                    }
                                    else {
                                        $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 2)).css("visibility", "hidden");
                                    }
                                }
                            }
                        }
                    });
                    pageviewcontainer.scrollTop = (parseFloat(this._pageLocation[this._currentPage] * this._zoomVal));
                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage - 1)).css("visibility", "hidden");
                    $('#' + proxy._id + 'pageDiv_' + (proxy._currentPage + 1)).css("visibility", "hidden");

                } else if (fitType == "fitToWidth") {
                    scaleX = (w - 25) / pageW;
                    scaleY = scaleX;
                    this._zoomVal = scaleX;
                    this._zoomInContainer();
                    this._calculateZoomLevel(this._zoomVal);
                }
                this._updateZoomButtons();
                return { scalX: scaleX, scalY: scaleY }
            }
        },

        _selectDropDownIndex: function (index) {
            var _selectedObj = $($('#' + this._id + '_toolbar_zoomSelection_popup li')[index]);
            _selectedObj.addClass('e-active');
            $('#' + this._id + '_toolbar_zoomSelection_input').val(_selectedObj.text());
        },

        _applyDropDownVal: function (scaleXY, orientationX, isFittoPage) {
            if (scaleXY != undefined) {
                if (isFittoPage) {
                    var _maxScale = scaleXY.scalX > scaleXY.scalY ? scaleXY.scalY : scaleXY.scalX;
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((_maxScale * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(_maxScale * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                }
                else if (orientationX) {
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalX * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(scaleXY.scalX * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                } else {
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalY * 100)) + "%");
                    this._ejDropDownInstance.model.value = Math.round(scaleXY.scalY * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                }
            }
        },

        _applyDropDownValAuto: function (scaleXY, orientationX, isFittoPage) {
            if (!this._isAutoZoom) {
                $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((scaleXY.scalY * 100)) + "%");
                this._ejDropDownInstance.model.value = Math.round(scaleXY.scalY * 100) + "%";
                this._ejDropDownInstance.model.selectedIndices[0] = "";
            }
            else {
                var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                var text = localeObj['contextMenu']['auto']['contentText'];
                $('#' + this._id + '_toolbar_zoomSelection_hidden').val(text);
                this._ejDropDownInstance.model.value = text;
            }
            $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
        },

        _showFitToPagetip: function () {
            var fittoPage = $('#' + this._id + '_toolbar_fittoPagePopup');
            if (!(fittoPage.length > 0)) {
                fittoPage = this._renderPageFitPopup();
                $('body').append(fittoPage);
                this._on($('#' + this._id + '_toolbar_fittoPagePopup li.e-pdfviewer-popupli'), "click", this._pageFitMenuClick);
            }

            if (fittoPage.css('display') == 'block') {
                fittoPage.css('display', 'none');
            } else {
                fittoPage.css('display', 'block');
            }

            var exportTagPos = $('#' + this._id + '_toolbarContainer .e-pdfviewer-pagefit')[0].getBoundingClientRect();
            var expTagPos = $($('#' + this._id + '_toolbarContainer .e-pdfviewer-pagefit')[0]).offset();
            fittoPage.css({ 'top': (expTagPos.top + exportTagPos.height) - 3, 'left': (expTagPos.left - 5) });
        },
        //-------------------- FitToPage[end] -------------------------//

        //-------------------- Page Zoom[start] -------------------------//
        _zoomValChange: function (sender) {
            if (!this._ejViewerInstance) {
                var id = this._id.split('_toolbar')[0];
                var ejViewer = $("#" + id);
                var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            }
            var zoomVal;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            if (sender.value != undefined) {
                if (sender.value == text || sender.model.selectedItemIndex == 0) {
                    ejViewerInstance.model.isResponsive = true;
                    zoomVal = 1;
                    ejViewerInstance._zoomLevel = 3;
                    ejViewerInstance._isAutoZoom = true;
                    ejViewerInstance._isAutoSelected = true;
                }
                else {
                    zoomVal = parseInt(sender.value) / 100;
                    ejViewerInstance.model.isResponsive = false;
                    ejViewerInstance._zoomLevel = sender.itemId;
                    ejViewerInstance._isAutoZoom = false;
                    ejViewerInstance._isAutoSelected = false;
                }

                ejViewerInstance._zoomContainer(zoomVal, false);
            } else if (sender.target.innerHTML != undefined) {
                var str = sender.target.innerHTML;
                if (sender.target.innerHTML == text) {
                    ejViewerInstance.model.isResponsive = true;
                    zoomVal = 1;
                    ejViewerInstance._isAutoZoom = true;
                }
                else {
                    var str = str.substring(0, str.length - 1);
                    zoomVal = parseInt(str) / 100;
                    ejViewerInstance.model.isResponsive = false;
                    ejViewerInstance._isAutoZoom = false;
                }
                ejViewerInstance._zoomContainer(zoomVal, false);
            }
        },

        _zoomIn: function () {
            if (this._zoomLevel >= 7) {
                this._zoomLevel = 7;
            } else {
                this._zoomLevel++;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl._selectItemByIndex(this._zoomLevel);
            }
            this.model.isResponsive = false;
        },

        _zoomOut: function () {
            if (this._zoomLevel <= 1) {
                this._zoomLevel = 1;
            } else {
                this._zoomLevel--;
            }
            if (this._isDevice) {
                this._mobileLayoutZoomChange();
            } else {
                var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                zoomddl._selectItemByIndex(this._zoomLevel);
            }
            this.model.isResponsive = false;
        },

        _zoomInContainer: function (isFactor, scaleFactor) {
            this._hidingSignature();
            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            this._selectionNodes = window.getSelection();
            $('.e-pdfviewer-formFields').hide();
            if (!(this._selectionNodes.anchorOffset == 0 && this._selectionNodes.focusOffset == 0)) {
                this._maintainSelection();
            }
            if (isFactor) {
                this._zoomVal = this._zoomVal + zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomineventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                var pageWidth = 0;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                    pageWidth = this._pageSize[i - 1].PageHeight;
                } else {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                    pageWidth = this._pageSize[i - 1].PageWidth;
                }
                var currentWidth = leftpos + this._pageSize[i - 1].PageWidth * this._zoomVal;
                if (leftpos < 0 || (this._fitType == "fitToWidth" && pageWidth == this._highestWidth) || (this._fitType == "fitToPage" && this._pageSize[i - 1].PageOrientation == "Landscape" && currentWidth > w))
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                if (canvas != undefined) {
                    var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                    var context = canvas.getContext('2d');
                    if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                        canvas.height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        canvas.width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        canvas.style.height = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                        canvas.style.width = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                        var height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        var width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        canvas.style.width = width + "px";
                        canvas.style.height = height + "px";
                        seccanvas.width = width;
                        seccanvas.height = height;
                        seccanvas.style.width = width + "px";
                        seccanvas.style.height = height + "px";
                    }
                    else {
                        canvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        canvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        canvas.style.height = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                        canvas.style.width = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                        var height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        var width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        canvas.style.width = width + "px";
                        canvas.style.height = height + "px";
                        seccanvas.width = width;
                        seccanvas.height = height;
                        seccanvas.style.width = width + "px";
                        seccanvas.style.height = height + "px";
                    }
                    context.clearRect(0, 0, canvas.clientWidth, canvas.clientHeight);
                    var pagediv = $('#' + this._id + 'pageDiv_' + i);
                    pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                    pagediv[0].style.left = leftpos + "px";
                    pagediv[0].style.width = width + 'px';
                    pagediv[0].style.height = height + 'px';
                    //Hyperlink canvas

                    var hyperlinklayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                    hyperlinklayer.style.height = canvas.height + 'px';
                    hyperlinklayer.style.width = canvas.width + 'px';
                    hyperlinklayer.style.position = 'absolute';
                    hyperlinklayer.style.left = 0;
                    hyperlinklayer.style.top = 0;
                    hyperlinklayer.style.backgroundColor = 'transparent';
                    hyperlinklayer.style.zIndex = '2';

                    if ($('#' + this._id + 'selectioncanvas_' + i).hasClass('text_container')) {
                        this._resizeSelection(JSON.parse(this._pageContents[parseInt(i)]), i, context);
                    }

                    if (!this._isAutoZoom) {
                        //resizing the loding indicator of the page
                        $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block', 'height': canvas.height + 'px', 'width': canvas.width + 'px', 'left': '0px', 'top': '0px' });
                        var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                        var spanDiv = loadingindicator.childNodes[0];
                        spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
                    }
                }
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;

            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            if (this._imageObj) {
                for (var i = 0; i < this._imageObj.length; i++) {
                    this._imageObj[i].onload = null;
                }
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._preZoomVal = this._zoomVal;
            this._previousZoom = this._zoomVal;
            zoomineventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomineventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomineventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            this._highestWidth = 0;
            this._highestHeight = 0;
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _zoomOutContainer: function (isFactor, scaleFactor) {
            this._hidingSignature();
            var zoomFactor = scaleFactor;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            this._selectionNodes = window.getSelection();
            $('.e-pdfviewer-formFields').hide();
            if (!(this._selectionNodes.anchorOffset == 0 && this._selectionNodes.focusOffset == 0)) {
                this._maintainSelection();
            }
            if (isFactor) {
                this._zoomVal = this._zoomVal + zoomFactor;
            }
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomouteventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    var leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                } else {
                    var leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if (leftpos < 0)
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var context = canvas.getContext('2d');
                var seccanvas = document.getElementById(this._id + "_secondarycanvas_" + i);
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    canvas.height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    var width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                else {
                    canvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    canvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.height = this._pageSize[i - 1].PageHeight * this._zoomVal + 'px';
                    canvas.style.width = this._pageSize[i - 1].PageWidth * this._zoomVal + 'px';
                    var height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    var width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    canvas.style.width = width + "px";
                    canvas.style.height = height + "px";
                    seccanvas.width = width;
                    seccanvas.height = height;
                    seccanvas.style.width = width + "px";
                    seccanvas.style.height = height + "px";
                }
                context.clearRect(0, 0, canvas.clientWidth, canvas.clientHeight);
                var pagediv = $('#' + this._id + 'pageDiv_' + i);
                pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                pagediv[0].style.left = leftpos + "px";
                pagediv[0].style.width = width + 'px';
                pagediv[0].style.height = height + 'px';

                //Hyperlink canvas

                var hyperlinklayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                hyperlinklayer.style.height = canvas.height + 'px';
                hyperlinklayer.style.width = canvas.width + 'px';
                hyperlinklayer.style.position = 'absolute';
                hyperlinklayer.style.left = 0;
                hyperlinklayer.style.top = 0;
                hyperlinklayer.style.backgroundColor = 'transparent';
                hyperlinklayer.style.zIndex = '2';

                if ($('#' + this._id + 'selectioncanvas_' + i).hasClass('text_container')) {
                    this._resizeSelection(JSON.parse(this._pageContents[parseInt(i)]), i, context);
                }

                //resizing the loding indicator of the page
                $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block', 'height': canvas.height + 'px', 'width': canvas.width + 'px', 'left': '0px', 'top': '0px' });
                var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                var spanDiv = loadingindicator.childNodes[0];
                spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
            }
            if (this._renderedCanvasList)
                this._renderedCanvasList.length = 0;
            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            if (this._imageObj) {
                for (var i = 0; i < this._imageObj.length; i++) {
                    this._imageObj[i].onload = null;
                }
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._previousZoom = this._zoomVal;
            zoomouteventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomouteventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomouteventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _zoomContainer: function (zoomfactor, isMode) {
            this._fitType = null;
            this._zoomVal = zoomfactor;
            /*When the zoom options are used after the page fit operations, the buttons that are disabled during page fit operation
               must be enabled. So the class that disables the button is removed.
            */
            $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');

            if (this._isAutoZoom && this._renderedCanvasList && (this._isWindowResizing || this._isAutoSelected)) {
                this._applyFitToWidthAuto();
                zoomfactor = this._zoomVal;
            }
            else {
                var scalefactor = Math.abs(this._preZoomVal - zoomfactor);
                if (scalefactor == 0) return false;
                if (this._preZoomVal > zoomfactor) {
                    this._zoomOutContainer(isMode, scalefactor);
                } else {
                    this._zoomInContainer(isMode, scalefactor);
                }
            }
            this._preZoomVal = zoomfactor;
            this._updateZoomButtons();
        },

        /*  *Since the pageFit option does not have a index for zoom level,assign the zoom level based on its nearest value. 
            * _calculateZoomLevel() function  does this function by getting the nearest lower index and higher index of 
            zoom percent in "container_toolbar_zoomSelection_popup" using binary search algorithm.
        */

        _calculateZoomLevel: function (zoomfactor) {
            this._calculateZoomArrayValues();
            //searching the nearest lower index and higher index for the fitType in the zoom level.
            var zoomVal = zoomfactor;
            var min = 0, max = this._zoomArray.length - 1;
            while ((min <= max) && !(min == 0 && max == 0)) {
                var mid = Math.round((min + max) / 2);
                if (this._zoomArray[mid] <= zoomVal) {
                    min = mid + 1;
                } else if (this._zoomArray[mid] >= zoomVal) {
                    max = mid - 1;
                }
            }
            this._lowerZoomIndex = max;
            this._higherZoomIndex = min;
            this._zoomLevel = this._lowerZoomIndex;
        },

        /*  If zoomIn() function is used after the page fit option, the lower zoom index must be set as the value for _zoomLevel.
            This is done by _applyLowerZoomIndex(). This function is executed only if the fitType is "fitToWidth" or "fitToPage".
        */

        _applyLowerZoomIndex: function () {
            var currentZoomArrayCount = 0;
            this._calculateZoomArrayValues();
            for (var i = 0; i < this._zoomArray.length; i++) {
                if (this._preZoomVal != this._zoomArray[i]) {
                    currentZoomArrayCount++;
                }
            }
            if (currentZoomArrayCount == this._zoomArray.length)
                this._zoomLevel = this._lowerZoomIndex;
            this._fitType = null;
        },

        /*  If zoomOut() function is used after the page fit option, the higher zoom index must be set as the value for _zoomLevel.
            This is done by _applyHigherZoomIndex(). This function is executed only if the fitType is "fitToWidth" or "fitToPage".
        */

        _applyHigherZoomIndex: function () {
            var currentZoomArrayCount = 0;
            this._calculateZoomArrayValues();
            for (var i = 0; i < this._zoomArray.length; i++) {
                if (this._preZoomVal != this._zoomArray[i]) {
                    currentZoomArrayCount++;
                }
            }
            if (currentZoomArrayCount == this._zoomArray.length)
                this._zoomLevel = this._higherZoomIndex;
            this._fitType = null;
        },
        _calculateZoomArrayValues: function () {
            if (this._zoomArray == undefined) {
                var popupLiItems = document.getElementById(this._id + "_toolbar_zoomSelection_popup").getElementsByTagName("li"); //getting the list of zoom percent in the div
                var zoomArray = [];
                this._zoomArray = zoomArray;
                //Converting the list into an array.
                for (var i = 0; i < popupLiItems.length; i++) {
                    zoomArray.push(parseInt(popupLiItems[i].textContent) / 100);
                }
            }
        },

        _updateZoomButtons: function () {
            if (this._zoomVal <= 0.5) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            } else if (this._zoomVal == 4) {
                this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            } else {
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
                this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            }
        },

        _showZoomControl: function (show) {
            if (show) {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-pdfviewer-toolbarli").css("display", "block");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-pdfviewer-ejdropdownlist").css("display", "block");
                this._isMagnificationHidden = false;
            }
            else {
                $('#' + this._id + '_toolbar_zoomin').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomout').parents("li.e-pdfviewer-toolbarli").css("display", "none");
                $('#' + this._id + '_toolbar_zoomSelection').parents("div.e-pdfviewer-ejdropdownlist").css("display", "none");
                this._isMagnificationHidden = true;
            }
        },
        //-------------------- Page Zoom[end] -------------------------//

        _fitToAutoSize: function () {
            var zoomFactor = this._zoomVal;
            var pageViewerContainer = $('#' + this._id + '_viewerContainer');
            var pagecontainer = $('#' + this._id + '_pageviewContainer');
            var w = pagecontainer.width();
            var h = pagecontainer.height();
            var zoomouteventvalue = { currentZoomPercentage: 0, previousZoomPercentage: 0 };
            var vscrolBar = document.getElementById(this._id + '_viewerContainer');
            var vscrolValue = vscrolBar.scrollTop;
            var scrollValue = (vscrolValue / this._previousZoom) * this._zoomVal;
            var transform = "scale(" + this._zoomVal + "," + this._zoomVal + ")";
            for (var i = 1; i <= this._totalPages; i++) {
                var leftpos;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                } else {
                    leftpos = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if ((this._isAutoZoom && this._zoomVal < 1) || leftpos < 0)
                    leftpos = 5;
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                if (canvas != undefined) {
                    var context = canvas.getContext('2d');
                    var height, width;
                    if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                        height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        width = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    } else {
                        height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    }
                    canvas.style.height = height + 'px';
                    canvas.style.width = width + 'px';
                    if (this._renderedCanvasList.indexOf(i) != -1) {
                        seccanvas.style.width = width + "px";
                        seccanvas.style.height = height + "px";
                    seccanvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        seccanvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                        this._clearRectOnClick(i);
                    } else {
                        seccanvas.style.width = width + "px";
                        seccanvas.style.height = height + "px";
                        seccanvas.height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                        seccanvas.width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    }
                    var pagediv = $('#' + this._id + 'pageDiv_' + i);
                    pagediv[0].style.top = this._pageLocation[i] * this._zoomVal + "px";
                    pagediv[0].style.left = leftpos + "px";
                    pagediv[0].style.width = width + 'px';
                    pagediv[0].style.height = height + 'px';

                    var selectionlayer = document.getElementById(this._id + 'selectioncanvas_' + i);
                    selectionlayer.style.height = height + 'px';
                    selectionlayer.style.width = width + 'px';
                    selectionlayer.style.position = 'absolute';
                    selectionlayer.style.left = 0;
                    selectionlayer.style.top = 0;
                    selectionlayer.style.backgroundColor = 'transparent';
                    selectionlayer.style.zIndex = '2';
                    //resizing the loding indicator of the page
                    var jsonData = this._pageContents[parseInt(i)];
                    var jsondata;
                    if (jsonData && this._renderedCanvasList.indexOf(i) != -1) {
                        if (this._pdfService == ej.PdfViewer.PdfService.Local)
                            jsondata = JSON.parse(jsonData);
                        else
                            jsondata = JSON.parse(jsonData["d"]);
                        var children = $('#' + this._id + 'selectioncanvas_' + i).children();
                        for (var k = 0; k < children.length; k++) {
                            if ($(children[k]).hasClass('e-pdfviewer-textLayer')) {
                                $(children[k]).remove();
                                $('#' + this._id + 'selectioncanvas_' + i).removeClass('text_container');
                            }
                        }
                        if (!$('#' + this._id + 'selectioncanvas_' + i).hasClass('text_container')) {
                            this._textSelection(jsondata, i, context);
                        } else {
                            this._resizeSelection(jsondata, i, context);
                        }
                    }
                }
                    $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'none', 'height': height + 'px', 'width': width + 'px', 'left': '0px', 'top': '0px' });
                    var loadingindicator = document.getElementById(this._id + 'pageDiv_' + i + '_WaitingPopup');
                    if (loadingindicator) {
                        var spanDiv = loadingindicator.childNodes[0];
                        spanDiv.style.top = (canvas.height - spanDiv.clientHeight) / 2 + 'px';
                    }
                }
            if (this._zoomVal < 1)
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': (this._cummulativeHeight * this._zoomVal) - this.element.height() + 50 + "px" });
            else {
                pageViewerContainer.css({ '-ms-scroll-limit-y-max': "" });
            }
            $("#" + this._id + "_popupmenu").hide();
            this._isPopupNoteVisible = false;
            vscrolBar.scrollTop = scrollValue;
            this._eventpreviouszoomvalue = this._preZoomVal;
            this._eventzoomvalue = this._zoomVal;
            this._previousZoom = this._zoomVal;
            this._preZoomVal = this._zoomVal;
            zoomouteventvalue.previousZoomPercentage = Math.round(this._eventpreviouszoomvalue * 100);
            zoomouteventvalue.currentZoomPercentage = Math.round(this._eventzoomvalue * 100);
            this._raiseClientEvent("zoomChange", zoomouteventvalue);
            this.zoomPercentage = Math.round(this._zoomVal * 100);
            var annotationArray = [];
            if (this._selectedAnnotationObject) {
                annotationArray.push(this._selectedAnnotationObject.annotation);
                this._drawAnnotSelectRect(this._selectedAnnotationObject.pageIndex, annotationArray);
            }
        },

        _initRerendering: function () {
            if (!this._isRerenderCanvasCreated) {
                this._designNewCanvas();
                var renderList = [];
                var currentPage = this._currentPage;
                renderList.push(parseInt(this._currentPage));
                var prevPage; var nextPage;
                if (this._renderedCanvasList) {
                    prevPage = parseInt(this._currentPage) - 1;
                    if (this._renderedCanvasList.indexOf(prevPage) != -1)
                        renderList.push(prevPage);
                    nextPage = parseInt(this._currentPage) + 1;
                    if (this._renderedCanvasList.indexOf(nextPage) != -1)
                        renderList.push(nextPage);
                }
                else {
                    prevPage = parseInt(this._currentPage) - 1;
                    renderList.push(prevPage);
                    nextPage = parseInt(this._currentPage) + 1;
                    renderList.push(nextPage);
                }
                this._rerenderCanvasList = renderList;
                if (true) {
                    var proxy = this;
                    clearInterval(proxy._scrollTimer);
                    proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                }
                this._renderedCanvasList.length = 0;
            }
        },

        _designNewCanvas: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var newCanvas = document.createElement('canvas');
                var height, width;
                if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270) {
                    height = this._pageSize[i - 1].PageWidth * this._zoomVal;
                    width = this._pageSize[i - 1].pageHeight * this._zoomVal;
                } else {
                    height = this._pageSize[i - 1].PageHeight * this._zoomVal;
                    width = this._pageSize[i - 1].PageWidth * this._zoomVal;
                }
                newCanvas.style.visibility = 'hidden';
                newCanvas.style.width = width + "px";
                newCanvas.style.height = height + "px";
                newCanvas.style.backgroundColor = 'white';
                newCanvas.height = height;
                newCanvas.width = width;
                newCanvas.id = canvas.id;
                newCanvas.className = "e-pdfviewer-pageCanvas";
                canvas.id = this._id + 'oldcanvas_' + i;
                pageDiv.appendChild(newCanvas);
                $(newCanvas).css({ 'user-select': 'none' });
                var seccanvas = document.getElementById(this._id + '_secondarycanvas_' + i);
                seccanvas.style.width = width + "px";
                seccanvas.style.height = height + "px";
                seccanvas.width = width;
                seccanvas.height = height;
            }
            this._isRerenderCanvasCreated = true;
        },

        _replaceOldCanvas: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                var canvas = document.getElementById(this._id + 'pagecanvas_' + i);
                var oldcanvas = document.getElementById(this._id + 'oldcanvas_' + i);
                if (canvas != undefined && canvas != null) {
                    canvas.style.visibility = 'visible';
                }
                if (oldcanvas != undefined && oldcanvas != null) {
                    pageDiv.removeChild(oldcanvas);
                }
            }
            this._isRerenderCanvasCreated = false;
            var proxy = this;
            clearInterval(proxy._bgRenderTimer);
                proxy._scrollTimer = setInterval(function () { proxy._pageviewscrollchanged(proxy._pageHeight) }, 500);
        },

        _rerenderCanvas: function (currentPage) {
            if (this._renderedCanvasList.indexOf(parseInt(currentPage)) == -1 && currentPage <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage)) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage)];
                if (jsdata != undefined && jsdata != null) {
                    this._rerenderPdfPage(jsdata);
                    this._renderCount = this._renderCount + 1;
                }
            } else if (this._renderedCanvasList.indexOf(parseInt(currentPage) - 1) == -1 && (currentPage - 1) <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage) - 1) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage) - 1];
                if (jsdata != undefined && jsdata != null) {
                    this._rerenderPdfPage(jsdata);
                    this._renderCount = this._renderCount + 1;
                }
            } else if (this._renderedCanvasList.indexOf(parseInt(currentPage) + 1) == -1 && (currentPage + 1) <= this._totalPages && this._rerenderCanvasList.indexOf(parseInt(currentPage) + 1) != -1) {
                var jsdata = this._pageContents[parseInt(currentPage) + 1];
                if (jsdata != undefined && jsdata != null) {
                    this._rerenderPdfPage(jsdata);
                    this._renderCount = this._renderCount + 1;
                }
            }
            if (this._renderCount == this._rerenderCanvasList.length) {
                this._replaceOldCanvas();
                for (var i = 1; i <= this._totalPages; i++) {
                    if (this._renderedCanvasList.indexOf(i) == -1) {
                        $('#' + this._id + 'pageDiv_' + i + '_WaitingPopup').css({ 'display': 'block' });
                    }
                }
                this._renderCount = 0;
                this._rerenderCanvasList.length = 0;
            }
        },

        _rerenderPdfPage: function (jsondata) {
            var backupjson = jsondata;
            if (jsondata != undefined && jsondata != null) {
                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                    jsondata = JSON.parse(jsondata);
                else
                    jsondata = JSON.parse(jsondata["d"]);
                this._renderedCanvasList.push(parseInt(jsondata["currentpage"]));
                var pageindex = parseInt(jsondata["currentpage"]);
                var pageimageList = jsondata["imagestream"];

                this._pageContents[parseInt(jsondata["currentpage"])] = backupjson;

                //  Hyperlink
                this._regenerateFormFields(jsondata, pageindex);
                var children = $('#' + this._id + 'selectioncanvas_' + pageindex).children();
                for (i = 0; i < children.length; i++) {
                    if (children[i].hasAttribute('href') || $(children[i]).hasClass('e-pdfviewer-formFields'))
                        $(children[i]).remove();
                }
                this._createFormFields(jsondata, pageindex);
                var linkannot = jsondata["linkannotation"];
                var documentlinkpagenumber = jsondata["annotpagenum"];
                var ins = this;
                if (this.model.enableHyperlink) {
                    for (var l = 0; l < linkannot.length; l++) {
                        var aTag = document.createElement('a');
                        aTag.id = 'linkdiv_' + l;
                        var rect = linkannot[l].AnnotRectangle;
                        aTag.style.background = 'transparent';
                        aTag.style.position = 'absolute';
                        aTag.style.left = this._convertPointToPixel(rect.Left * this._zoomVal) + 'px';
                        aTag.style.top = this._convertPointToPixel(rect.Top * this._zoomVal) + 'px';
                        aTag.style.width = this._convertPointToPixel(rect.Width * this._zoomVal) + 'px';
                        aTag.style.height = this._convertPointToPixel(rect.Height * this._zoomVal) + 'px';
                        aTag.style.color = 'transparent';
                        if (linkannot[l].URI.indexOf("mailto:") != -1) {
                            var mail = linkannot[l].URI.substring(linkannot[l].URI.indexOf("mailto:"), linkannot[l].URI.length);
                            aTag.title = mail;
                            aTag.setAttribute('href', mail);
                        } else {
                            aTag.title = linkannot[l].URI;
                            aTag.setAttribute('href', linkannot[l].URI);
                        }
                        if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.Default) {
                            aTag.target = "_self";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewTab) {
                            aTag.target = "_blank";
                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);

                            }
                        } else if (this.model.hyperlinkOpenState == ej.PdfViewer.LinkTarget.NewWindow) {

                            aTag.onclick = function () {
                                var hyperlink = { hyperlink: this.href }
                                ins._raiseClientEvent("hyperlinkClick", hyperlink);
                                window.open(this.href, '_blank', 'scrollbars=yes,resizable=yes');
                                return false;
                            }
                        }
                        if (documentlinkpagenumber[l] != undefined) {
                            var destPageHeight = (this._pageSize[pageindex - 1].PageHeight);
                            var destAnnotLoc = this._convertPointToPixel(linkannot[l].AnnotLocation);
                            var dest = (destPageHeight - destAnnotLoc);
                            var scrollvalue = (parseFloat(this._pageLocation[documentlinkpagenumber[l]] * this._zoomVal)) + parseFloat(dest * this._zoomVal);
                            aTag.name = scrollvalue;
                            aTag.onclick = function () {
                                var pageviewcontainer = document.getElementById('container_viewerContainer');
                                pageviewcontainer.scrollTop = this.name;
                                return false;
                            }
                        }
                        var selectioncanvas = document.getElementById(this._id + 'selectioncanvas_' + pageindex);
                        if(selectioncanvas)
                        selectioncanvas.appendChild(aTag);
                    }
                }
                //Hyperlink

                if (this._textMarkupAnnotationList[pageindex]) {
                    this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageindex], pageindex);
                }
                var index = parseInt(jsondata["currentpage"]);
                var canvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                if (canvas != undefined && canvas != null) {
                    var context = canvas.getContext('2d');
                    var ratio = this._scalingTextContent(context);
                    if (this._pageSize[index - 1].PageRotation == 90 || this._pageSize[index - 1].PageRotation == 270) {
                        canvas.height = this._zoomVal * this._pageSize[index - 1].PageHeight;
                        canvas.width = this._zoomVal * this._pageSize[index - 1].PageWidth;
                        canvas.style.width = this._zoomVal * this._pageSize[index - 1].PageWidth + 'px';
                        canvas.style.height = this._zoomVal * this._pageSize[index - 1].PageHeight + 'px';
                    }
                    else {
                        canvas.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth * ratio;
                        canvas.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight * ratio;
                        canvas.style.height = this._zoomVal * this._pageSize[pageindex - 1].PageHeight + 'px';
                        canvas.style.width = this._zoomVal * this._pageSize[pageindex - 1].PageWidth + 'px';
                    }
                    var context = canvas.getContext('2d');
                    var imageObjCollection = new Array();
                    var imageTransformCollection = new Array();
                    var imageDataCollection = new Array();
                    var currentIndexCollection = new Array();
                    var pageDataCollection = new Array();
                    var zoomFactor;
                    var browserUserAgent = navigator.userAgent;
                    var offsett;
                    var imageIndex = 0;

                    var charPath = new Array();
                    var shapes = pageimageList["textelements"];
                    for (var j = 0; j < shapes.length; j++) {
                        var pathdata = shapes[j];
                        var color = pathdata["color"];
                        var matrix = pathdata["matrix"];
                        if (matrix != null)
                            matrix = matrix["Elements"];
                        var brushMode = pathdata["brush"];
                        var pathValue = pathdata["pathValue"];
                        var isClipping = pathdata["iscliping"];
                        var restoreCanvas = pathdata["restorecanvas"];
                        var imageData = pathdata["imagedata"];
                        var fillMode = pathdata["fillrule"];
                        var fillStroke = pathdata["isFillandStroke"];
                        var fillColor = pathdata["fillcolor"];
                        var strokeColor = pathdata["strokecolor"];
                        var lineWidth = pathdata["linewidth"];
                        var lineCap = pathdata["linecap"];
                        var linearGradient = pathdata["linearGradientBrush"];
                        var textureBrush = pathdata["textureBrushs"];
                        var charID = pathdata["charID"];
                        var alpha = pathdata["alpha"];
                        if (pathValue != null) {
                            pathValue = pathValue.split(";");
                            if (charID)
                                charPath[charID] = pathValue;
                        }
                        else if (pathValue == null && charID) {
                            pathValue = charPath[charID];
                        }
                        if (restoreCanvas == false) {
                            context.save();
                        }
                        if (pathValue != undefined) {
                            context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1], matrix[2], matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                        }

                        if (pathValue != null) {
                            context.beginPath();

                            for (var i = 0; i < pathValue.length; i++) {
                                var val = pathValue[i];
                                var pathType = val[0];
                                if (pathType == "M") {
                                    val = val.substring(1, val.length);
                                    val = val.split(" ");
                                    context.moveTo((val[0]), val[1]);
                                }
                                else if (pathType == "L") {
                                    val = val.substring(1, val.length);
                                    val = val.split(" ");
                                    context.lineTo((val[0]), val[1]);
                                }
                                else if (pathType == "C") {
                                    val = val.substring(1, val.length);
                                    val = val.split(" ");
                                    context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                }
                                else if (pathType == "Z") {
                                    context.closePath();
                                }
                            }
                            if (isClipping == true) {
                                if (fillMode == "evenodd") {
                                    context.msFillRule = "evenodd";
                                    context.mozFillRule = "evenodd";
                                    context.clip(fillMode);
                                }
                                context.clip();

                            }
                            else {
                                if (fillStroke == undefined) {
                                    if (brushMode == "Fill") {
                                        if (linearGradient != undefined) {
                                            context.fillStyle = this._getGradientBrush(linearGradient, context);
                                        }
                                        else if (textureBrush != undefined) {
                                            context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                        }
                                        else {
                                            if (alpha != undefined)
                                                context.globalAlpha = alpha;
                                            context.fillStyle = color;
                                        }
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.fill(fillMode);
                                        }
                                        context.fill();
                                    }
                                    else if (brushMode == "FillandStroke") {
                                        context.fillStyle = color;
                                        context.fill();
                                        context.strokeStyle = strokeColor;
                                        context.stroke();
                                    }
                                    else if (brushMode == "Stroke") {
                                        context.strokeStyle = strokeColor;
                                        context.lineWidth = lineWidth;
                                        context.lineCap = lineCap;
                                        context.stroke();
                                    }
                                    else {
                                        context.strokeStyle = color;
                                        context.lineWidth = lineWidth;
                                        context.lineCap = lineCap;
                                        context.stroke();
                                    }
                                }
                                else {
                                    context.strokeStyle = strokeColor;
                                    context.lineWidth = lineWidth;
                                    context.lineCap = lineCap;
                                    context.stroke();
                                    if (linearGradient != undefined) {
                                        context.fillStyle = this._getGradientBrush(linearGradient, context);
                                    }
                                    else if (textureBrush != undefined) {
                                        context.fillStyle = this._createTextureBrush(textureBrush, context, pathdata);
                                    }
                                    else
                                        context.fillStyle = fillColor;
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.fill(fillMode);
                                    }
                                    context.fill();
                                }
                            }
                        }

                        if (restoreCanvas)
                            context.restore();
                        if (imageData != undefined) {
                            if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                                imageObjCollection.push(imageData);
                                imageTransformCollection.push(matrix);
                                pageDataCollection.push(shapes);
                                currentIndexCollection.push(j);
                                zoomFactor = this._zoomVal;
                                this._isContainImage = true;
                                break;
                            }
                            else {
                                var imageObj = new Image();
                                imageObj.src = imageData;
                                context.setTransform(matrix[0] * this._zoomVal * ratio, matrix[1] * this._zoomVal * ratio, matrix[2] * this._zoomVal * ratio, matrix[3] * this._zoomVal * ratio, matrix[4] * this._zoomVal * ratio, matrix[5] * this._zoomVal * ratio);
                                context.drawImage(imageObj, 0, 0, 1, 1);
                            }
                        }
                    }

                    if ((offsett = browserUserAgent.indexOf("Firefox")) != -1 || (offsett = browserUserAgent.indexOf("Chrome")) != -1 || (offsett = browserUserAgent.indexOf("Safari")) != -1 || (offsett = browserUserAgent.indexOf("AppleWebKit")) != -1) {
                        for (var k = 0; k < imageObjCollection.length; k++) {
                            this._imageRenderingPinch(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, k, pageDataCollection, currentIndexCollection, charPath, canvas, index, imageIndex);
                            imageIndex++;
                        }
                    }
                    var tempcanvas = canvas;
                    var proxy = this;
                    if (this._pageSize[index - 1].PageRotation != 0) {
                        tempcanvas = document.getElementById(this._id + 'pagecanvas_' + parseInt(jsondata["currentpage"]));
                        var canvasUrl = tempcanvas.toDataURL();
                        var context = tempcanvas.getContext('2d');
                        var image = new Image();
                        image.onload = function () {
                            context.clearRect(0, 0, tempcanvas.width, tempcanvas.height);
                            if (proxy._pageSize[index - 1].PageRotation == 90 || proxy._pageSize[index - 1].PageRotation == 270) {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                            } else {
                                tempcanvas.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth;
                                tempcanvas.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight;
                                tempcanvas.style.height = proxy._zoomVal * proxy._pageSize[index - 1].PageHeight + 'px';
                                tempcanvas.style.width = proxy._zoomVal * proxy._pageSize[index - 1].PageWidth + 'px';

                            }
                            context.save();
                            context.translate(tempcanvas.width / 2, tempcanvas.height / 2);
                            context.rotate((proxy._pageSize[index - 1].PageRotation / 2) * Math.PI / 2);
                            context.drawImage(image, -image.width / 2, -image.height / 2);
                            context.restore();
                        }
                        image.src = canvasUrl;
                    }
                    this._changingImageCanvasPosition(pageindex);
                    this._showSignature();
                    this._showPageLoadingIndicator(pageindex, false);
                    return tempcanvas;
                }
            }
        },
        _regenerateFormFields: function (jsondata, pageindex) {
            var TextBoxField = jsondata["pdfRenderedFields"];
            var backgroundcolor;
            if (TextBoxField != null) {
                for (var l = 0; l < TextBoxField.length; l++) {
                    if ((TextBoxField[l].PageIndex + 1) == pageindex) {
                        var boundingRect = TextBoxField[l].LineBounds;
                        var inputdiv = document.getElementById(this._id + 'input_' + pageindex + '_' + l);
                        if (TextBoxField[l].Name == "Textbox") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].FieldName == name)
                                TextBoxField[l].Text = $(inputdiv).val();
                        }
                        else if (TextBoxField[l].Name == "Password") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].FieldName == name)
                                TextBoxField[l].Text = $(inputdiv).val();
                        }
                        else if (TextBoxField[l].Name == "RadioButton") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].GroupName == name) {
                                if ($(inputdiv).prop("checked") == true)
                                    TextBoxField[l].Selected = true;
                                else
                                    TextBoxField[l].Selected = false;
                            }
                        }
                        else if (TextBoxField[l].Name == "CheckBox") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].GroupName == name) {
                                if ($(inputdiv).prop("checked") == true)
                                    TextBoxField[l].Selected = true;
                                else
                                    TextBoxField[l].Selected = false;
                            }
                        }
                        else if (TextBoxField[l].Name == "DropDown") {
                            var name = $(inputdiv).attr("name");
                            if (TextBoxField[l].Text == name) {
                                if (TextBoxField[l].SelectedValue == "") {
                                    var option = $(inputdiv).children()[0];
                                    option.id = "dropdownhide";
                                    if ($(option).prop("selected") == true)
                                        TextBoxField[l].SelectedValue = "";
                                }
                                for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                    var option;
                                    if ($(inputdiv).children()[0].id == "dropdownhide")
                                        option = $(inputdiv).children()[j + 1];
                                    else
                                        option = $(inputdiv).children()[j];
                                    if ($(option).prop("selected") == true)
                                        TextBoxField[l].SelectedValue = TextBoxField[l].TextList[j];
                                }
                            }
                        }
                        else if (TextBoxField[l].Name == "ListBox") {
                            var k = 0;
                            for (var j = 0; j < TextBoxField[l].TextList.length; j++) {
                                var option = $(inputdiv).children()[j];
                                if ($(option).prop("selected") == true) {
                                    TextBoxField[l].SelectedList[k] = j;
                                    k++;
                                }
                            }
                        }
                    }
                }
            }


        },
        _imageRenderingPinch: function (shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, index, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex) {
            var proxy = this;
            var zoomValue = proxy._zoomVal;
            var imageObject = new Image();
            imageObject.onload = function () {
                var isImageContentChanged = false;
                var ratio = proxy._scalingTextContent(context);
                for (var l = 0; l < imageTransformCollection.length; l++) {
                    if (isImageContentChanged == false) {
                        var matrixData = imageTransformCollection[l];
                        context.setTransform(matrixData[0] * zoomValue * ratio, matrixData[1] * zoomValue * ratio, matrixData[2] * zoomValue* ratio, matrixData[3] * zoomValue* ratio, matrixData[4] * zoomValue* ratio, matrixData[5] * zoomValue * ratio);
                        if (imageDataCollection[imageIndex] != undefined) {
                            context.drawImage(imageDataCollection[imageIndex], 0, 0, 1, 1);
                        }
                        var dataIndex = currentIndexCollection[l];
                        dataIndex = dataIndex + 1;
                        var data = pageDataCollection[l];
                        while (dataIndex < data.length) {
                            var pathdata = data[dataIndex];
                            var color = pathdata["color"];
                            var matrix = pathdata["matrix"];
                            if (matrix != null)
                                matrix = matrix["Elements"];
                            var brushMode = pathdata["brush"];
                            var pathValue = pathdata["pathValue"];
                            var isClipping = pathdata["iscliping"];
                            var restoreCanvas = pathdata["restorecanvas"];
                            var imageData = pathdata["imagedata"];
                            var fillMode = pathdata["fillrule"];
                            var fillStroke = pathdata["isFillandStroke"];
                            var fillColor = pathdata["fillcolor"];
                            var strokeColor = pathdata["strokecolor"];
                            var lineWidth = pathdata["linewidth"];
                            var lineCap = pathdata["linecap"];
                            var linearGradient = pathdata["linearGradientBrush"];
                            var textureBrush = pathdata["textureBrushs"];
                            var charID = pathdata["charID"];
                            var alpha = pathdata["alpha"];
                            if (pathValue != null) {
                                pathValue = pathValue.split(";");
                                if (charID)
                                    charPath[charID] = pathValue;
                            }
                            else if (pathValue == null && charID) {
                                pathValue = charPath[charID];
                            }
                            if (restoreCanvas == false) {
                                context.save();
                            }
                            if (pathValue != undefined) {
                                context.setTransform(matrix[0] * zoomValue * ratio, matrix[1], matrix[2], matrix[3] * zoomValue * ratio, matrix[4] * zoomValue * ratio, matrix[5] * zoomValue * ratio);
                            }

                            if (pathValue != null) {
                                context.beginPath();

                                for (var i = 0; i < pathValue.length; i++) {
                                    var val = pathValue[i];
                                    var pathType = val[0];
                                    if (pathType == "M") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.moveTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "L") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.lineTo((val[0]), val[1]);
                                    }
                                    else if (pathType == "C") {
                                        val = val.substring(1, val.length);
                                        val = val.split(" ");
                                        context.bezierCurveTo(val[0], val[1], val[2], val[3], val[4], val[5]);
                                    }
                                    else if (pathType == "Z") {
                                        context.closePath();
                                    }
                                }
                                if (isClipping == true) {
                                    if (fillMode == "evenodd") {
                                        context.msFillRule = "evenodd";
                                        context.mozFillRule = "evenodd";
                                        context.clip(fillMode);
                                    }
                                    context.clip();

                                }
                                else {
                                    if (fillStroke == undefined) {
                                        if (brushMode == "Fill") {
                                            if (linearGradient != undefined) {
                                                context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                            }
                                            else if (textureBrush != undefined) {
                                                context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                }
                                else {
                                    if (alpha != undefined)
                                        context.globalAlpha = alpha;
                                    context.fillStyle = color;
                                }
                                if (fillMode == "evenodd") {
                                                context.msFillRule = "evenodd";
                                                context.mozFillRule = "evenodd";
                                                context.fill(fillMode);
                                            }
                                            context.fill();
                                        }
                                        else if (brushMode == "FillandStroke") {
                                            context.fillStyle = color;
                                            context.fill();
                                            context.strokeStyle = strokeColor;
                                            context.stroke();
                                        }
                                        else if (brushMode == "Stroke") {
                                            context.strokeStyle = strokeColor;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                        else {
                                            context.strokeStyle = color;
                                            context.lineWidth = lineWidth;
                                            context.lineCap = lineCap;
                                            context.stroke();
                                        }
                                    }
                                    else {
                                        context.strokeStyle = strokeColor;
                                        context.lineWidth = lineWidth;
                                        context.lineCap = lineCap;
                                        context.stroke();
                                        if (linearGradient != undefined) {
                                            context.fillStyle = proxy._getGradientBrush(linearGradient, context);
                                        }
                                        else if (textureBrush != undefined) {
                                            context.fillStyle = proxy._createTextureBrush(textureBrush, context, pathdata);
                                        }
                                        else
                                            context.fillStyle = fillColor;
                                        if (fillMode == "evenodd") {
                                            context.msFillRule = "evenodd";
                                            context.mozFillRule = "evenodd";
                                            context.fill(fillMode);
                                        }
                                        context.fill();
                                    }
                                }
                            }

                            if (restoreCanvas)
                                context.restore();
                            if (imageData != undefined) {
                                isImageContentChanged = true;
                                imageObjCollection.pop();
                                imageTransformCollection.pop();
                                pageDataCollection.pop();
                                currentIndexCollection.pop();
                                imageObjCollection.push(imageData);
                                imageTransformCollection.push(matrix);
                                pageDataCollection.push(shapes);
                                currentIndexCollection.push(dataIndex);
                                l = -1;
                                imageIndex++;
                                break;
                            }
                            dataIndex++;
                        }
                    }
                    else {
                        proxy._imageRenderingPinch(shapes, imageDataCollection, imageObjCollection, imageTransformCollection, context, l, pageDataCollection, currentIndexCollection, charPath, canvas, currentindex, imageIndex);
                        imageIndex++;
                    }
                }
            }
            imageObject.src = imageObjCollection[index];
            imageDataCollection.push(imageObject);
        },
        //-------------------- Pinch Zoom [Start] -----------------------------//

        _touchStart: function (event) {
            var eventTouch = event.touches;
            if (eventTouch.length > 1) {
                event.preventDefault();
            }
            var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
            var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            ejViewerInstance._touched = false;
        },
        _touchMove: function (event) {
            var eventTouch = event.touches;
            if (eventTouch.length > 1) {
                var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
                var ejViewerInstance = ejViewer.ejPdfViewer("instance");
                ejViewerInstance._touched = true;
                if (!ejViewerInstance._isRerenderCanvasCreated) {
                    $('.e-pdfviewer-formFields').hide();
                    var currentDiff = Math.sqrt(Math.pow((eventTouch[0].clientX - eventTouch[1].clientX), 2) + Math.pow((eventTouch[0].clientY - eventTouch[1].clientY), 2));
                    if (ejViewerInstance._prevDiff > -1) {
                        if (currentDiff > ejViewerInstance._prevDiff) {
                            ejViewerInstance._pinchOut(event);
                        } else if (currentDiff < ejViewerInstance._prevDiff) {
                            ejViewerInstance._pinchIn(event);
                        }
                    } else if (ejViewerInstance._zoomVal < 2) {
                        if (ejViewerInstance._prevDiff != -1) {
                            if (currentDiff > ejViewerInstance._prevDiff) {
                                ejViewerInstance._pinchIn(event);
                            }
                        }
                    } else if (ejViewerInstance._prevDiff == -1) {
                        if (ejViewerInstance._zoomVal > 2) {
                            if (currentDiff > ejViewerInstance._prevDiff) {
                                ejViewerInstance._pinchIn(event);
                            }
                        }
                    }
                    ejViewerInstance._prevDiff = currentDiff;
                }
            }
        },

        _touchEnd: function (event) {
            var ejViewer = $(event.target).parents('.e-pdfviewer.e-js');
            var ejViewerInstance = ejViewer.ejPdfViewer("instance");
            ejViewerInstance._prevDiff = -1;
            if (ejViewerInstance._isRenderedByPinch) {
                if (ejViewerInstance._renderedCanvasList.length != 0) {
                    if (!ejViewerInstance._isRerenderCanvasCreated) {
                        ejViewerInstance._designNewCanvas();
                        var renderList = [];
                        var currentPage = ejViewerInstance._currentPage;
                        renderList.push(parseInt(ejViewerInstance._currentPage));
                        var prevPage = parseInt(ejViewerInstance._currentPage) - 1;
                        if (ejViewerInstance._renderedCanvasList.indexOf(prevPage) != -1)
                            renderList.push(prevPage);
                        var nextPage = parseInt(ejViewerInstance._currentPage) + 1;
                        if (ejViewerInstance._renderedCanvasList.indexOf(nextPage) != -1)
                            renderList.push(nextPage);
                        ejViewerInstance._rerenderCanvasList = renderList;
                        var proxy = ejViewerInstance;
                        window.clearInterval(proxy._scrollTimer);
                        proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                        ejViewerInstance._renderedCanvasList.length = 0;
                    }
                }
                ejViewerInstance._isRenderedByPinch = false;
            }
        },

        _pointerdown: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                this._pointerCount = this._pointerCount + 1;
                if (this._pointerCount <= 2) {
                    event.preventDefault();
                    this._pointers.push(event.originalEvent);
                    if (this._pointerCount == 2)
                        this._pointerCount = 0;
                }
            }
        },

        _pointermove: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                if (this._pointers.length == 2) {
                    event.preventDefault();
                    for (var i = 0; i < this._pointers.length; i++) {
                        if (event.originalEvent.pointerId == this._pointers[i].pointerId) {
                            this._pointers[i] = event.originalEvent;
                            break;
                        }
                    }
                    if (!this._isRerenderCanvasCreated) {
                        var currentDiff = Math.sqrt(Math.pow((this._pointers[0].clientX - this._pointers[1].clientX), 2) + Math.pow((this._pointers[0].clientY - this._pointers[1].clientY), 2));
                        if (this._prevDiff > -1) {
                            if (currentDiff > this._prevDiff) {
                                this._pinchOut(event);
                            } else if (currentDiff < this._prevDiff) {
                                this._pinchIn(event);
                            }
                        }
                        var vscrolBar = document.getElementById(this._id + '_viewerContainer');
                        var scroltop = vscrolBar.scrollTop;
                        if (!(scroltop == 0)) {
                            if (currentDiff > this._prevDiff) {
                                this._pinchOut(event);
                            } else if (currentDiff < this._prevDiff) {
                                this._pinchIn(event);
                            }
                        }
                        this._prevDiff = currentDiff;
                    }
                }
            }
        },

        _pointerup: function (event) {
            if (event.originalEvent.pointerType == 'touch') {
                this._pointers = new Array();
                this._pointerCount = 0;
                this._prevDiff = -1;
                if (this._isRenderedByPinch) {
                    event.preventDefault();
                    if (this._renderedCanvasList.length != 0) {
                        if (!this._isRerenderCanvasCreated) {
                            this._designNewCanvas();
                            var renderList = [];
                            var currentPage = this._currentPage;
                            renderList.push(parseInt(this._currentPage));
                            var prevPage = parseInt(this._currentPage) - 1;
                            if (this._renderedCanvasList.indexOf(prevPage) != -1)
                                renderList.push(prevPage);
                            var nextPage = parseInt(this._currentPage) + 1;
                            if (this._renderedCanvasList.indexOf(nextPage) != -1)
                                renderList.push(nextPage);
                            this._rerenderCanvasList = renderList;
                            var proxy = this;
                            window.clearInterval(proxy._scrollTimer);
                            proxy._bgRenderTimer = setInterval(function () { proxy._rerenderCanvas(currentPage) }, 10);
                            this._renderedCanvasList.length = 0;
                        }
                    }
                    this._isRenderedByPinch = false;
                }
            }
        },

        _pinchOut: function (event) {
            this._isAutoSelected = false;
            this._isAutoZoom = false;
            this._zoomVal = this._zoomVal + 0.05;
            if (this._zoomVal > 2) {
                this._zoomVal = this._zoomVal + 0.05;
            }
            if (this._zoomVal > 4) {
                this._zoomVal = 4;
                this._isPinchLimitReached = true;
            }
            if (this._zoomVal <= 4) {
                if (!this._isPinchLimitReached) {
                    this._changingImageCanvasPosition(this._currentPage);
                    this._fitType = null;
                    this._fitToAutoSize();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((this._zoomVal * 100)) + "%");
                    this._ejDropDownInstance.model.value = (this._zoomVal * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                    this._updateZoomButtons();
                    $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                    this._isRenderedByPinch = true;
                }
                this._isPinchLimitReached = false;
            } else {
                this._zoomVal = 4;
            }
        },

        _pinchIn: function (event) {
            this._isAutoSelected = false;
            this._isAutoZoom = false;
            this._zoomVal = this._zoomVal - 0.04;
            if (this._zoomVal < 4 && this._zoomVal > 2) {
                this._zoomVal = this._zoomVal - 0.04;
            }
            if (this._zoomVal < 0.5) {
                this._zoomVal = 0.5;
                this._isPinchLimitReached = true;
            }
            if (this._zoomVal >= 0.5) {
                if (!this._isPinchLimitReached) {
                    this._changingImageCanvasPosition(this._currentPage);
                    this._fitType = null;
                    this._fitToAutoSize();
                    this._calculateZoomLevel(this._zoomVal);
                    $('#' + this._id + '_toolbar_zoomSelection_hidden').val(Math.round((this._zoomVal * 100)) + "%");
                    this._ejDropDownInstance.model.value = (this._zoomVal * 100) + "%";
                    this._ejDropDownInstance.model.selectedIndices[0] = "";
                    $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
                    this._updateZoomButtons();
                    $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
                    this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
                    this._isRenderedByPinch = true;
                }
                this._isPinchLimitReached = false;
            } else {
                this._zoomVal = 0.5;
            }
        },

        //------------------------------- Pinch Zoom [End] ----------------------------------//
        //-------------------------------Text Select and Search [start] ---------------------------//

        _textSearch: function () {
            this._clearAllOccurrences();
            this._selectedIndex = 0;
            this._isTextSearch = true;
            this._searchedPages = new Array();
            this._searchCollection = new Array();
            if (!this._isToolbarHidden && $('#' + this._id + '_pdfviewer_searchbox').css('display') == 'block') {
                var searchText = $('#' + this._id + '_pdfviewer_searchinput').val();
            }
            else
                var searchText = this._searchText;
            this._searchText = searchText;
            if (this._searchText && this._searchText != "") {
                this._enableSearchIcons();
            }
            else {
                this._disableSearchIcons();
            }
            if (searchText == '' || searchText == ' ' || !searchText) {
                $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                return true;
            }
            this._searchPageIndex = parseInt(this._currentPage);
            this._initSearch(this._searchPageIndex);
            this._highlightOtherOccurrences();
        },
        _disableSearchIcons: function () {
            $('#' + this._id + '_pdfviewer_previous_search').css({ "pointer-events": "none", "opacity": "0.6" });
            $('#' + this._id + '_pdfviewer_next_search').css({ "pointer-events": "none", "opacity": "0.6" });
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            checkBox.disable();
        },
        _enableSearchIcons: function () {
            $('#' + this._id + '_pdfviewer_previous_search').css({ "pointer-events": "", "opacity": "" });
            $('#' + this._id + '_pdfviewer_next_search').css({ "pointer-events": "", "opacity": "" });
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            checkBox.enable();
        },
        _prevSearch: function () {
            if (this._searchText) {
                this._clearAllOccurrences();
                this._isPrevSearch = true;
                this._isTextSearch = true;
                this._selectedIndex = this._selectedIndex - 1;
                if (this._selectedIndex < 0) {
                    this._searchPageIndex = this._searchPageIndex - 1;
                    if (this._searchPageIndex < 1) {
                        this._searchPageIndex = parseInt(this._totalPages);
                    }
                    this._initSearch(this._searchPageIndex);
                } else {
                    this._highlightText(this._searchPageIndex, this._selectedIndex);
                }
                this._highlightOtherOccurrences();
            }
        },

        _nextSearch: function () {
            if (this._searchText) {
                this._clearAllOccurrences();
                this._isPrevSearch = false;
                this._isTextSearch = true;
                this._selectedIndex = this._selectedIndex + 1;
                if (this._searchCollection[this._searchPageIndex]) {
                    if (this._selectedIndex >= this._searchCollection[this._searchPageIndex].length) {
                        this._selectedIndex = 0;
                        if (this._searchPageIndex < this._totalPages) {
                            this._searchPageIndex = this._searchPageIndex + 1;
                        } else {
                            this._searchPageIndex = 1;
                        }
                        this._initSearch(this._searchPageIndex);
                    } else {
                        this._highlightText(this._searchPageIndex, this._selectedIndex);
                    }
                } else {
                    this._searchPageIndex = this._currentPage;
                    this._selectedIndex = 0;
                    this._initSearch(this._searchPageIndex);
                }
                this._highlightOtherOccurrences();
            }
        },

        _matchcase: function () {
            var checkBox = $('#' + this._id + '_search_matchcase').data('ejCheckBox');
            if (checkBox.model.checkState == "check") {
                this._isMatchCase = true;
            } else {
                this._isMatchCase = false;
            }
            this._textSearch();
        },

        _searchKeypressHandler: function (event) {
            if (event.which == 13) {
                event.preventDefault();
                this._searchText = $('#' + this._id + '_pdfviewer_searchinput').val();
                if (this._searchMatches[this._searchPageIndex] && this._searchText != "") {
                    if (this._searchMatches[this._searchPageIndex].length == 0) {
                        this._initSearch(this._searchPageIndex);
                    } else {
                        this._nextSearch();
                    }
                } else if (this._searchText != "") {
                    this._searchPageIndex = this._currentPage;
                    this._selectedIndex = 0;
                    this._initSearch(this._searchPageIndex);
                }
            }
        },

        _initSearch: function (pageIndex) {
            var queryLength = this._searchText.length;
            var searchText = this._searchText;
            if (searchText != '' || searchText != ' ' || !searchText)
               this._getPossibleMatches(pageIndex, searchText, queryLength);
        },

        _getPossibleMatches: function (pageIndex, searchText, queryLength) {
            if (!this._pageText[parseInt(pageIndex)] && pageIndex == this._searchPageIndex) {
                this._isRequestFired = true;
                var jsonResult = new Object();
                jsonResult["viewerAction"] = this._viewerAction.getPageModel;
                jsonResult["pageindex"] = pageIndex.toString();
                jsonResult["id"] = this._fileId;
                $('#' + this._id + '_pdfviewer_searchinput').addClass('e-pdfviewer-progressloader');
                if (!this._ajaxInProgress)
                   this._doAjaxPostSearch(JSON.stringify(jsonResult), pageIndex);
            }
            this._searchPageText(pageIndex, searchText, queryLength);
        },
        _searchPageText: function (pageIndex, searchText, queryLength) {
            var pageText = this._pageText[pageIndex];
            if (pageText) {
                if (!this._isMatchCase) {
                    pageText = pageText.toLowerCase();
                    searchText = searchText.toLowerCase();
                }
                var matches = [];
                var matchIndex = -queryLength;
                var texts = /[^\u0000-\u00ff]/.test(pageText);
                var x = new RegExp("[\x00-\x80]+"); // is ascii
                var isAscii = x.test(pageText);
                var isRtl = this._isRtl(pageText);
                if (!isAscii && isRtl) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    pageText = pageText.replace(re, " ");
                    searchText = searchText.split("").reverse().join("");
                    searchText = searchText.replace(/\s/g, '\u00A0');
                }
                if (this._isNonBreackingCharacter && texts) {
                    var re = new RegExp(String.fromCharCode(160), "g");
                    pageText = pageText.replace(re, " ");
                }
                while (true) {
                    if (searchText == '' || searchText == ' ' || !searchText) {
                                                break;
                     }
                    matchIndex = pageText.indexOf(searchText, matchIndex + queryLength);
                    if (matchIndex == -1)
                        break;
                    matches.push(matchIndex);
                }
                this._searchMatches[pageIndex] = matches;
                if (pageIndex == this._searchPageIndex) {
                    if (this._selectedIndex < 0 && this._isPrevSearch) {
                        this._selectedIndex = this._searchMatches[pageIndex].length - 1;
                    }
                    if (this._isRequestFired && this._searchMatches[pageIndex].length != 0 || this._renderedCanvasList.indexOf(pageIndex) == -1 && this._searchMatches[pageIndex].length != 0) {
                        this._gotoPageNo(pageIndex);
                        this._isPageScrolledForSearch = true;
                    }
                    if (this._searchMatches[pageIndex].length == 0) {
                        if (pageIndex != this._totalPages) {
                            if (this._searchedPages.indexOf(parseInt(pageIndex)) == -1) {
                                this._searchedPages.push(pageIndex);
                            }
                            if (this._isPrevSearch) {
                                this._searchPageIndex = this._searchPageIndex - 1;
                                if (this._searchPageIndex <= 0)
                                    this._searchPageIndex = this._totalPages;
                            } else {
                                this._searchPageIndex = this._searchPageIndex + 1;
                            }
                        }
                        else {
                            if (this._searchedPages.indexOf(parseInt(pageIndex)) == -1) {
                                this._searchedPages.push(pageIndex);
                            }
                            if (this._isPrevSearch) {
                                this._searchPageIndex = this._searchPageIndex - 1;
                            } else {
                                this._searchPageIndex = 1;
                            }
                        }
                        if (this._searchedPages.length != this._totalPages || this._searchMatches[pageIndex].length != 0) {
                            this._initSearch(this._searchPageIndex);
                        } else {
                            if (searchText != "") {
                                $('#' + this._id + '_pdfviewer_searchinput').addClass('e-pdfviewer-nooccurrence');
                            }
                            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                            this._isRequestFired = false;
                        }
                    } else {
                        if (this._isRequestFired) {
                            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                            var proxy = this;
                            setTimeout(function () {
                                proxy._convertMatches(pageIndex, queryLength);
                                proxy._isRequestFired = false;
                                proxy._isPageScrolledForSearch = false;
                            }, 100);
                        } else {
                            this._convertMatches(pageIndex, queryLength);
                        }
                    }
                } else {
                    if (this._searchMatches[pageIndex].length != 0) {
                        this._convertMatches(pageIndex, queryLength);
                    }
                }
                if (!this._isRequestFired && !this._isPageScrollHighlight) {
                    this._isPageScrolledForSearch = false;
                }
            }
        },
        _convertMatches: function (index, queryLength) {
            var m = 0;
            var matches = this._searchMatches[index];
            var textDiv = this._textDivs[index];
            var divIndex = 0;
            var end = textDiv.length - 1;
            var matchCollection = [];
            for (var i = 0, l = matches.length; i < l; i++) {
                var matchIndex = matches[i];
                if (!this._isPageScrolledForSearch) {
                    while (m != end && matchIndex >= (divIndex + textDiv[m].textContent.length)) {
                        divIndex += textDiv[m].textContent.length;
                        m++;
                    }
                } else {
                    while (m != end && matchIndex >= (divIndex + textDiv[m].textContent.split('\n')[0].length)) {
                        divIndex += textDiv[m].textContent.split('\n')[0].length;
                        m++;
                    }
                }
                var match = {
                    begin: {
                        divId: m,
                        offsetValue: matchIndex - divIndex,
                    }
                };
                matchIndex += queryLength;
                while (m != end && matchIndex > (divIndex + textDiv[m].textContent.length)) {
                    divIndex += textDiv[m].textContent.length;
                    m++;
                }
                match.end = {
                    divId: m,
                    offsetValue: matchIndex - divIndex,
                };
                matchCollection.push(match);
            }
            this._searchCollection[index] = matchCollection;
            this._highlightText(index, this._selectedIndex);
        },

        _highlightText: function (pageIndex, index) {
            var matches = this._searchCollection[pageIndex];
            var textDiv = this._textDivs[pageIndex];
            var prevEnd = null;
            var scrollPoint = { y: -70, x: -400 }
            var startId, className;
            var index0 = 0, index1 = matches.length;
            for (var i = index0; i < index1; i++) {
                var match = matches[i];
                var start = match.begin;
                var end = match.end;
                if (i == this._selectedIndex && pageIndex == this._searchPageIndex) {
                    className = 'e-pdfviewer-texthighlight';
                    startId = start.divId;
                } else {
                    className = 'e-pdfviewer-text-highlightother'
                }
                if (!prevEnd || start.divId !== prevEnd.divId) {
                    if (prevEnd !== null) {
                        this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, undefined, pageIndex, textDiv, null);
                    }
                    this._beginText(start, textDiv, pageIndex, null);
                } else {
                    this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, start.offsetValue, pageIndex, textDiv, null);
                }
                if (start.divId == end.divId) {
                    this._addSpanForSearch(start.divId, start.offsetValue, end.offsetValue, pageIndex, textDiv, className);
                } else {
                    this._addSpanForSearch(start.divId, start.offsetValue, undefined, pageIndex, textDiv, className);
                    for (var k = start.divId + 1, j = end.divId; k < j; k++) {
                        this._addSpanForSearch(k, 0, undefined, pageIndex, textDiv, className + ' middle');
                    }
                    this._beginText(end, textDiv, pageIndex, className);
                }
                prevEnd = end;
            }
            if (prevEnd) {
                this._addSpanForSearch(prevEnd.divId, prevEnd.offsetValue, undefined, pageIndex, textDiv, null);
            }
            if (pageIndex == this._searchPageIndex)
                this._scrollToSearchStr(textDiv[startId], scrollPoint);
            this._isTextHighlighted = true;
        },

        _beginText: function (span, textDiv, pageIndex, className) {
            var divIndex = span.divId;
            textDiv[divIndex].textContent = '';
            this._addSpanForSearch(divIndex, 0, span.offsetValue, pageIndex, textDiv, className);
        },

        _addSpanForSearch: function (divIndex, fromOffset, toOffset, pageIndex, textDiv, className) {
            var divTextContent;
            var re = new RegExp(String.fromCharCode(160), "g");
            var textContent = this._textContents[pageIndex];
            var totalLength = textContent[divIndex].length;
            var x = new RegExp("[\x00-\x80]+"); // is ascii
            var isRtl = this._isRtl(textContent[divIndex]);
            if (isRtl) {
                divTextContent = textContent[divIndex].substring(totalLength - fromOffset, totalLength - toOffset);
                var node = document.createTextNode(divTextContent);
                if (className) {
                    this._isTextHighlighted = true;
                    var spanElement = document.createElement('span');
                    spanElement.className = className + ' e-pdfviewer-textLayer';
                    if ($(spanElement).hasClass('middle')) {
                        textDiv[divIndex].textContent = '';
                    }
                    node.textContent = node.textContent.replace(re, " ");
                    $(spanElement).prepend(node);
                    $(textDiv[divIndex]).prepend(spanElement);
                    textDiv[divIndex].innerHTML.replace(/&nbsp;/g, ' ');
                    return;
                }
                node.textContent = node.textContent.replace(re, " ");
                $(textDiv[divIndex]).prepend(node);
                textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
            }
            else {
                divTextContent = textContent[divIndex].substring(fromOffset, toOffset);
                var node = document.createTextNode(divTextContent);
                if (className) {
                    this._isTextHighlighted = true;
                    var spanElement = document.createElement('span');
                    spanElement.className = className + ' e-pdfviewer-textLayer';
                    if ($(spanElement).hasClass('middle')) {
                        textDiv[divIndex].textContent = '';
                    }
                    node.textContent = node.textContent.replace(re, " ");
                    spanElement.appendChild(node);
                    spanElement.innerHTML = spanElement.innerHTML.replace(re, " ");
                    textDiv[divIndex].appendChild(spanElement);
                    textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
                    return;
                }
                node.textContent = node.textContent.replace(re, " ");
                textDiv[divIndex].appendChild(node);
                textDiv[divIndex].innerHTML = textDiv[divIndex].innerHTML.replace(re, " ");
            }
        },
        _isRtl: function (text) {
            var ltrChars = 'A-Za-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02B8\\u0300-\\u0590\\u0800-\\u1FFF' + '\\u2C00-\\uFB1C\\uFDFE-\\uFE6F\\uFEFD-\\uFFFF',
                rtlChars = '\\u0591-\\u07FF\\uFB1D-\\uFDFD\\uFE70-\\uFEFC',
                rtlDirCheck = new RegExp('^[^' + ltrChars + ']*[' + rtlChars + ']');
            return rtlDirCheck.test(text);
        },
        _scrollToSearchStr: function (textDiv, scrollPoint) {
            var parent = textDiv.offsetParent;
            var offsetY = textDiv.offsetTop + textDiv.clientTop;
            var offsetX = textDiv.offsetLeft + textDiv.clientLeft;
            while (parent.id != this._id + '_viewerContainer') {
                offsetY += parent.offsetTop;
                offsetX += parent.offsetLeft;
                parent = parent.offsetParent;
            }
            if (scrollPoint) {
                offsetY += scrollPoint.y;
                offsetX += scrollPoint.x;
                if (this._zoomVal > 1.5) {
                    parent.scrollLeft = offsetX;
                }
            }
            parent.scrollTop = offsetY;
        },

        _highlightOtherOccurrences: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                if (this._renderedCanvasList.indexOf(i) != -1 && i != this._searchPageIndex)
                    this._initSearch(i);
            }
            this._isPageScrollHighlight = false;
        },

        _clearAllOccurrences: function () {
            this._searchedText = "";
            var customMenu = document.getElementById(this._id + "custom-menu");
            $(customMenu).hide();
            this._isTextHighlighted = false;
            this._isTextSearch = false;
            if (this._searchAjaxRequestState != null) {
                this._searchAjaxRequestState.abort();
                this._searchAjaxRequestState = null;
            }
            if (this._ajaxRequestState != null) {
                this._ajaxRequestState.abort();
                this._ajaxRequestState = null;
            }
            $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-nooccurrence');
            for (var i = 1; i <= this._totalPages; i++) {
                if (this._renderedCanvasList.indexOf(parseInt(i)) !== -1) {
                    var textDiv = this._textDivs[i];
                    var textContent = this._textContents[i];
                    if (!textDiv || textDiv == undefined) {
                        break;
                    }
                    for (var j = 0; j < textDiv.length; j++) {
                        textDiv[j].textContent = textContent[j];
                        if (!this._isFindboxPresent) {
                            textDiv[j].textContent = '';
                            textDiv[j].textContent = textContent[j] + '\r\n';
                        }
                    }
                }
            }
        },

        _doAjaxPostSearch: function (jsonResult, pageIndex) {
            var proxy = this;
            this._searchAjaxRequestState = $.ajax({
                type: 'POST',
                url: this.model.serviceUrl + '/' + this.model.serverActionSettings.load,
                crossDomain: true,
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                data: jsonResult,
                traditional: true,
                success: function (data) {
                    if (typeof data === 'object')
                        var backupjson = (JSON.stringify(data));
                    else
                        var backupjson = data;
                    if (typeof data === 'object') {
                        if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                            jsondata = JSON.parse((JSON.stringify(data)));
                        else
                            jsondata = JSON.parse((JSON.stringify(data))["d"]);
                    }
                    else {
                        if (proxy._pdfService == ej.PdfViewer.PdfService.Local)
                            jsondata = JSON.parse(data);
                        else
                            jsondata = JSON.parse(data["d"]);
                    }
                    proxy._pageContents[parseInt(jsondata["currentpage"])] = backupjson;
                    proxy._pageText[parseInt(jsondata["currentpage"])] = jsondata["pageContents"];
                    proxy._initSearch(pageIndex);
                },
                error: function (msg, textStatus, errorThrown) {
                    proxy._raiseClientEvent("ajaxRequestFailure", msg.responseText);
                }
            });
        },

        _keyboardShortcutFind: function (event) {
            if (event.ctrlKey && event.which == 70) {
                event.preventDefault();
                if (!this._isTextSearchHidden) {
                    this._displaySearchBox();
                }
            }
        },

        _setSearchToolbarTop: function () {
            var searchToolbar = document.getElementById(this._id + '_pdfviewer_searchbox');
            if (searchToolbar)
                searchToolbar.style.top = '0px';
        },
        _searchBoxLocalization: function () {
            var findText = $('#' + this._id + '_pdfviewer_searchbox').find('.e-pdfviewer-label')[0];
            var matchCase = $('#' + this._id + '_pdfviewer_searchbox').find('.e-pdfviewer-label')[1];
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var copyText = localeObj['contextMenu']['Find']['contentText'];
            var googleText = localeObj['contextMenu']['matchCase']['contentText'];
            $(findText).text(copyText);
            $(matchCase).text(googleText);
        },
        _displaySearchBox: function () {
            if (!this._isToolbarHidden) {
                if ($('#' + this._id + '_pdfviewer_searchbox').css('display') == 'none') {
                    this._searchBoxLocalization();
                    this._clearSelector();
                    this._displaySearch = true;
                    $('#' + this._id + '_pdfviewer_searchbox').css({ 'position': 'absolute', 'display': 'block' });
                    this._resizeSearchToolbar();
                    $('#' + this._id + '_pdfviewer_searchinput').focus().select();
                    this._isFindboxPresent = true;
                } else {
                    this._displaySearch = false;
                    this._isFindboxPresent = false;
                    this._clearAllOccurrences();
                    $('#' + this._id + '_pdfviewer_searchinput').removeClass('e-pdfviewer-progressloader');
                    $('#' + this._id + '_pdfviewer_searchbox').css({ 'display': 'none' });
                }
            }
        },

        _showTextSearchButton: function (show) {
            if (show) {
                $('#' + this._id + '_find').parent().parents(".e-pdfviewer-toolbarul").css("display", "block");
                this._isTextSearchHidden = false;
            }
            else {
                $('#' + this._id + '_find').parent().parents(".e-pdfviewer-toolbarul").css("display", "none");
                if (this._isFindboxPresent) {
                    this._displaySearchBox();
                }
                this._isTextSearchHidden = true;
            }
        },

        //-------------------------------Text Select and Search [end] -----------------------------//
        //-------------------------------Text Markup Annotation [Start] ---------------------------//

        _renderTextMarkupAnnotation: function (textMarkupAnnotation, pageIndex) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            var context;
            if (canvas != undefined && canvas != null) {
                context = canvas.getContext("2d");
                context.setLineDash([]);
                canvas.height = this._pageSize[pageIndex - 1].PageHeight * this._zoomVal;
                canvas.width = this._pageSize[pageIndex - 1].PageWidth * this._zoomVal;
                if (textMarkupAnnotation) {
                    for (var i = 0; i < textMarkupAnnotation.length; i++) {
                        var annotation = textMarkupAnnotation[i];
                        if (annotation.TextMarkupAnnotationType == "StrikeOut") {
                            var color = annotation.Color;
                            annotation.isLocked = this.model.strikethroughSettings.isLocked;
                            for (var j = 0; j < annotation.Bounds.length; j++) {
                                var bound = annotation.Bounds[j];
                                context.globalAlpha = annotation.Opacity;
                                context.beginPath();
                                context.moveTo(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height) / 2) * this._zoomVal);
                                context.lineTo(this._convertPointToPixel(bound.Width + bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height) / 2) * this._zoomVal);
                                context.strokeStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                                context.closePath();
                                context.msFillRule = "nonzero"
                                context.stroke();
                            }
                            context.lineWidth = annotation.BorderWidth;
                            context.save();
                        }
                        else if (annotation.TextMarkupAnnotationType == "Highlight") {
                            annotation.isLocked = this.model.highlightSettings.isLocked;
                            for (var j = 0; j < annotation.Bounds.length; j++) {
                                var bound = annotation.Bounds[j];
                                context.beginPath();
                                context.rect(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y) * this._zoomVal, this._convertPointToPixel(bound.Width) * this._zoomVal, this._convertPointToPixel(bound.Height) * this._zoomVal);
                                context.lineWidth = annotation.BorderWidth;
                                var color = annotation.Color;
                                context.globalAlpha = annotation.Opacity * 0.5;
                                context.closePath();
                                context.fillStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                                context.msFillRule = "nonzero";
                                context.fill();
                            }
                            context.save();
                        }
                        else if (annotation.TextMarkupAnnotationType == "Underline") {
                            annotation.isLocked = this.model.underlineSettings.isLocked;
                            var color = annotation.Color;
                            for (var j = 0; j < annotation.Bounds.length; j++) {
                                var bound = annotation.Bounds[j];
                                context.globalAlpha = annotation.Opacity;
                                context.beginPath();
                                context.moveTo(this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height)) * this._zoomVal);
                                context.lineTo(this._convertPointToPixel(bound.Width + bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y + (bound.Height)) * this._zoomVal);
                                context.lineWidth = annotation.BorderWidth;
                                context.closePath();
                                context.strokeStyle = "rgb(" + color.R + "," + color.G + "," + color.B + ")";
                                context.msFillRule = "nonzero"
                                context.stroke();;
                            }
                            context.save();
                        }
                    }
                }
                if (this._newAnnotationList[pageIndex - 1]) {
                    if (this._newAnnotationList[pageIndex - 1].length != 0) {
                        this._renderNewAnnotations(this._newAnnotationList[pageIndex - 1], context)
                    }
                }
            }
        },

        _renderNewAnnotations: function (annotations, context) {
            for (var i = 0; i < annotations.length; i++) {
                var markupAnnotation = annotations[i];
                if (markupAnnotation.type == "StrikeOut") {
                    context.globalAlpha = markupAnnotation.opacity;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.moveTo(bound.xPosition * this._zoomVal, (bound.yPosition + (bound.height / 2)) * this._zoomVal);
                        context.lineTo((bound.xPosition + bound.width) * this._zoomVal, (bound.yPosition + (bound.height) / 2) * this._zoomVal);
                        context.strokeStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.closePath();
                        context.msFillRule = "nonzero"
                        context.stroke();
                    }
                    context.save();
                }
                else if (markupAnnotation.type == "Highlight") {
                    context.globalAlpha = markupAnnotation.opacity * 0.5;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.rect(bound.xPosition * this._zoomVal, bound.yPosition * this._zoomVal, bound.width * this._zoomVal, bound.height * this._zoomVal);
                        context.closePath();
                        context.fillStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.msFillRule = "nonzero";
                        context.fill();
                    }
                    context.save();
                }
                else if (markupAnnotation.type == "Underline") {
                    context.globalAlpha = markupAnnotation.opacity;
                    for (var j = 0; j < markupAnnotation.bounds.length; j++) {
                        var bound = markupAnnotation.bounds[j];
                        context.beginPath();
                        context.moveTo(bound.xPosition * this._zoomVal, (bound.yPosition + bound.height) * this._zoomVal);
                        context.lineTo((bound.xPosition + bound.width) * this._zoomVal, (bound.yPosition + bound.height) * this._zoomVal);
                        context.strokeStyle = "rgb(" + markupAnnotation.colorR + "," + markupAnnotation.colorG + "," + markupAnnotation.colorB + ")";
                        context.closePath();
                        context.msFillRule = "nonzero"
                        context.stroke();
                    }
                    context.save();
                }
            }
        },

        _addAnnotation: function (annotationType) {
            var annotationLayer = document.getElementById(this._id + "_secondarycanvas_" + this._currentPage);
            var context = annotationLayer.getContext("2d");
            annotationLayer.style.zIndex = "2";
            var s = window.getSelection().toString();
            switch (annotationType) {
                case "StrikeOut":
                    if (window.getSelection().toString()) {
                        this._drawStrikeOutAnnotation();
                        this._isHighlight = false;
                        this._annotationActive = true;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = false;
                        this._isStrikeout = true;
                        this._isUnderline = false;
                    }
                    break;
                case "Underline":
                    if (window.getSelection().toString()) {
                        this._drawUnderlineAnnotation();
                        this._annotationActive = true;
                        this._isHighlight = false;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = false;
                        this._isUnderline = true;
                        this._isStrikeout = false;
                    }
                    break;
                case "Highlight":
                    if (window.getSelection().toString()) {
                        this._drawHighlightAnnotation();
                        this._annotationActive = true;
                        this._isHighlight = true;
                    } else {
                        this._annotationActive = true;
                        this._isHighlight = true;
                        this._isUnderline = false;
                        this._isStrikeout = false;
                    }
                    break;
                default:
                    break;
            }
        },

        _initHighlight: function () {
            if (!this._isHighlightEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._addAnnotation("Highlight");
                this._isHighlightEnabled = true;
                this._isUnderlineEnabled = false;
                this._isStrikeOutEnabled = false;
                this._isHighlight = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },

        _initStrikeOut: function () {
            if (!this._isStrikeOutEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._addAnnotation("StrikeOut");
                this._isStrikeOutEnabled = true;
                this._isUnderlineEnabled = false;
                this._isHighlightEnabled = false;
                this._isStrikeout = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },

        _initUnderline: function () {
            if (!this._isUnderlineEnabled) {
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_underline');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
                this._addAnnotation("Underline");
                this._isUnderlineEnabled = true;
                this._isHighlightEnabled = false;
                this._isStrikeOutEnabled = false;
                this._isUnderline = true;
            } else {
                if (!this._isToolbarColorPicker) {
                    this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
                    this._isHighlightEnabled = false;
                    this._annotationActive = false;
                    this._isHighlight = false;
                    this._isUnderline = false;
                    this._isStrikeout = false;
                    this._isUnderlineEnabled = false;
                    this._isStrikeOutEnabled = false;
                    this._drawColor = null;
                    this._isDefaultColorSet = false;
                }
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
            }
        },
        _showSignatureDialog: function (e) {
            if (this.model.enableSignature) {
                var canvas = document.getElementById(this._id + "_imageTemp");
                var widths = this.element[0].parentElement.clientWidth;
                var heights = this.element[0].parentElement.clientHeight;
                if (widths >= 500) {
                    canvas.width = 470;
                    canvas.style.width = "470px";
                    if (window.innerHeight >= 500) {
                        canvas.height = 400;
                        canvas.style.height = "400px";
                    }
                    else {
                        canvas.height = 100;
                        canvas.style.height = "100px";
                    }
                  
                }
                else {
                    canvas.width = widths;
                    canvas.height = 100;
                    canvas.style.width = widths + "px";
                    canvas.style.height = "100px";
                }
                var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                var appearanceText = localeObj['signatureWindow']['Signature']['contentText'];
                var add = localeObj['signatureWindow']['Add']['contentText'];
                var clear = localeObj['signatureWindow']['clear']['contentText'];
                this._replaceTextLocale($("#" + this._id + "_addSignature")[0], add);
                this._replaceTextLocale($("#" + this._id + "_clearSignature")[0], clear);
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ title: appearanceText });
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog("open");
            }
        },
        _createSignatureControl: function (e) {
            this._minX = this._minY = 0;
            this._maxX = this._maxY = 0;
            var proxy = this;
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var container = document.createElement("div");
            container.id = this._id + "_signatureContainerDialogTab";
            var applyProperties = document.createElement("div");
            var signatureControl = document.createElement("div");
            signatureControl.id = this._id + "_signatureContainer";
            var canvas = document.createElement('canvas');
            canvas.id = this._id + "_imageTemp";
            var parentElement = proxy.element[0].parentElement;
            if (parentElement) {
                var widths = parentElement.clientWidth;
                if (widths >= 500) {
                    canvas.width = 470;
                    canvas.height = 400;
                    canvas.style.width = "470px";
                    canvas.style.height = "400px";
                }
                else {
                    canvas.width = widths;
                    canvas.height = 100;
                    canvas.style.width = widths + "px";
                    canvas.style.height = "100px";
                }
            }
            signatureControl.appendChild(canvas);
            var context = canvas.getContext("2d");
            var ok = ej.buildTag("button", "Add", { "margin-bottom": "5px", "margin-top": "6px", "margin-right": "10px", "float": "right", "opacity": "0.2", "cursor": "default", "pointer-events": "none" }, { "id": this._id + "_addSignature", });
            var cancel = ej.buildTag("button", "Clear", { "margin-bottom": "5px", "margin-top": "6px", "margin-right": "10px", "float": "right" }, { "id": this._id + "_clearSignature", });
            applyProperties.appendChild(cancel[0]);
            applyProperties.appendChild(ok[0]);
            container.appendChild(signatureControl);
            container.appendChild(applyProperties);
            pageviewcontainer.append(container);
            ok.ejButton({ showRoundedCorner: false, size: "small" });
            cancel.ejButton({ showRoundedCorner: false, size: "small" });
            var proxy = this;
            $('#' + this._id + "_imageTemp").on("mousedown touchstart", function (e) {
                if (e.which != 3 && e.type != "contextmenu") {
                    e.preventDefault();
                    proxy._findMouse(e);
                    proxy._mouseDetection = true;
                    proxy._oldX = proxy._mouseX;
                    proxy._oldY = proxy._mouseY;
                    proxy._newObject = [];
                    proxy._newpoints = [];
                    proxy._mouseEvent(e);
                }
            });
            $('#' + this._id + "_imageTemp").on("mousemove touchmove", function (e) {
                if (proxy._mouseDetection) {
                    proxy._findMouse(e);
                    $('#' + proxy._id + "_addSignature").css({ "opacity": "", "cursor": "pointer", "pointer-events": "" });
                    proxy._mouseEvent(e);
                }
            });
            $(window).on("mouseup touchend", function (e) {
                if (proxy._mouseDetection == true) {
                    proxy._convertToString(proxy._newObject, context);
                }
                proxy._mouseDetection = false;
            });
            $('#' + this._id + "_addSignature").on("click touchend", function (e) {
                proxy._newCanvas = null;
                proxy._signatureAdded = true;
                proxy._isNewlyAdded = true;
                var pageDiv = document.getElementById(proxy._id + 'pageDiv_' + (proxy._currentPage));
                if (e.type == "touchend") {
                    e.preventDefault();
                    proxy._signatureAdded = false;
                    proxy._isNewlyAdded = false;
                    proxy._addSignature(e);
                }
                $(pageDiv).on("mousemove", function (e) {
                    if (proxy._isNewlyAdded) {
                        proxy._isNewlyAdded = false;
                        proxy._addSignature(e);
                    }
                });
                $('#' + proxy._id + "_signatureContainerDialogTab").ejDialog("close");
            });
            $('#' + this._id + "_clearSignature").on("click", function (e) {
                $('#' + proxy._id + "_addSignature").css({ "opacity": "0.2", "cursor": "default", "pointer-events": "none" });
                proxy._clearSignature(e);
            });
            $('#' + this._id + "_signatureContainerDialogTab").ejDialog({
                showOnInit: false,
                enableResize: false,
                allowDraggable: false,
                zIndex: 100000000,
                backgroundScroll: false, enableModal: true,
                open: function (e) {
                    $('#' + proxy._id + "_addSignature").css({ "opacity": "0.2", "cursor": "default", "pointer-events": "none" });
                    proxy._clearSignature(e);
                },
                close: function (e) {
                    $('#' + proxy._id + "_addSignature").css({ "opacity": "0.2", "cursor": "default", "pointer-events": "none" });
                    var canvas = document.getElementById(proxy._id + "_imageTemp");
                    var context = canvas.getContext("2d");
                    context.clearRect(0, 0, canvas.width, canvas.height);
                },
            });
            if (widths >= 500)
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ width: "500px" });
            else
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ width: "auto" });
            $('#' + this._id + '_signatureContainerDialogTab').addClass('e-pdfviewer-sign-dialog');
        },
        _convertToString: function (newObject, context) {
            this._addMoveTo(newObject[0], newObject[1], context);
            this._addLineTo(newObject[0], newObject[1], context);
            for (var i = 2; i < newObject.length; i = i + 2) {
                this._addLineTo(newObject[i], newObject[i + 1], context);
            }
        },
        _addLineTo: function (x, y, context) {
            this._newx = x;
            this._newy = y;
            this._outputString += "<br>" + ".lineTo(" + this._newx + "," + this._newy + ");";
        },

        _addMoveTo: function (x, y, context) {
            this._newx = x;
            this._newy = y;
            this._outputString += "<br>" + ".moveTo(" + this._newx + "," + this._newy + ");";
        },
        _findMouse: function (event) {
            if (event.type == "touchstart" || event.type == "touchmove") {
                var points = new Object();
                var rect = event.originalEvent.target.getBoundingClientRect()
                this._mouseX = event.originalEvent.touches[0].pageX - rect.left;
                this._mouseY = event.originalEvent.touches[0].pageY - rect.top;
                points = { x: this._mouseX, y: this._mouseY };
                this._newpoints.push(points);
            }
            else {
                if (event.offsetX) {
                    var points = new Object();
                    this._mouseX = event.offsetX;
                    this._mouseY = event.offsetY;
                    points = { x: this._mouseX, y: this._mouseY };
                    this._newpoints.push(points);
                }
                else if (event.layerX) {
                    this._mouseX = event.layerX;
                    this._mouseY = event.layerY;
                }
            }
        },
        _mouseEvent: function (event) {
            if (this._mouseDetection) {
                this._draw(2, event);
                this._oldX = this._mouseX;
                this._oldY = this._mouseY;
            }
        },
        _draw: function (line_width, event) {
            var canvas = document.getElementById(this._id + "_imageTemp");
            var context = canvas.getContext("2d");
            context.beginPath();
            context.moveTo(this._oldX, this._oldY);
            context.lineTo(this._mouseX, this._mouseY);
            context.stroke();
            context.lineWidth = line_width;
            context.arc(this._oldX, this._oldY, line_width / 2, 0, Math.PI * 2, true);
            context.closePath();
            this._newObject.push(this._mouseX, this._mouseY);
        },
        _appendChildElement: function (rightBottomBtn) {
            var rightBottomBtns = document.createElement("div");
            rightBottomBtns.style.position = "absolute";
            rightBottomBtns.style.border = "1px solid #4f80ff";
            rightBottomBtns.style.backgroundColor = "white";
            rightBottomBtns.style.width = "8px";
            rightBottomBtns.style.height = "8px";
            rightBottomBtns.className = rightBottomBtn.className;
            rightBottomBtns.id = rightBottomBtn.id;
            rightBottomBtns.style.zIndex = "100000000";
            rightBottomBtns.style.left = (parseFloat(rightBottomBtn.style.width) / 2) - (parseFloat(rightBottomBtns.style.width) / 2) + "px";
            rightBottomBtns.style.top = (parseFloat(rightBottomBtn.style.height) / 2) - (parseFloat(rightBottomBtns.style.height) / 2) + "px";
            rightBottomBtn.appendChild(rightBottomBtns);
        },
        _addSignature: function (event) {
            var pageIndex = this._currentPage;
            var pageDiv = document.getElementById(this._id + 'pageDiv_' + pageIndex);
            var canvas = document.getElementById(this._id + "pagecanvas_" + pageIndex);
            var imageTempcanvas = document.getElementById(this._id + "_imageTemp");
            var length = this._totalSignature.length;
            var w = parseFloat($(imageTempcanvas).css("width"));
            var h = parseFloat($(imageTempcanvas).css("height"));
            var newCanvas = document.createElement('canvas');
            newCanvas.id = this._id + "imagecanvasDraw_" + pageIndex + '_' + length;
            newCanvas.className = "e-pdfviewer-imagecanvasDraw";
            var splitedvalue = this._outputString.split("<br>")[1].split('.').slice(1).join('.');
            if (splitedvalue) {
                var substring = splitedvalue.substring(0, 6);
                var movevalues = splitedvalue.substring(6);
                var points = movevalues.replace(/[{()}]/g, '');
                var splitPoints = points.split(',');
                var point1 = parseFloat(splitPoints[0]);
                var point2 = parseFloat(splitPoints[1]);
                this._maxpointsX = this._minpointsX = point1;
                this._maxpointsY = this._minpointsY = point2;
            }
            var length = this._outputString.split("<br>").length;
            for (var n = 0; n < length; n++) {
                var splitedvalue = this._outputString.split("<br>")[n].split('.').slice(1).join('.');
                if (splitedvalue) {
                    var substring = splitedvalue.substring(0, 6);
                    var movevalues = splitedvalue.substring(6);
                    var points = movevalues.replace(/[{()}]/g, '');
                    var splitPoints = points.split(',');
                    var point1 = parseFloat(splitPoints[0]);
                    var point2 = parseFloat(splitPoints[1]);
                    if (this._minpointsX >= point1) {
                        this._minpointsX = point1;
                    }
                    if (this._minpointsY >= point2) {
                        this._minpointsY = point2;
                    }
                    if (this._maxpointsX <= point1) {
                        this._maxpointsX = point1;
                    }
                    if (this._maxpointsY <= point2) {
                        this._maxpointsY = point2;
                    }
                }
            }
            this._minpointsX = this._minpointsX - 5;
            this._minpointsY = this._minpointsY - 5;
            this._maxpointsX = this._maxpointsX + 5;
            this._maxpointsY = this._maxpointsY + 5;
            var differenceX = this._maxpointsX - this._minpointsX;
            var differenceY = this._maxpointsY - this._minpointsY;
            this._differenceX = differenceX;
            this._differenceY = differenceY;
            newCanvas.width = 200 * this._zoomVal;
            newCanvas.height = 140 * this._zoomVal;
            newCanvas.style.width = 200 * this._zoomVal + "px";
            newCanvas.style.height = 140 * this._zoomVal + "px";
            var widths = newCanvas.width;
            var heights = newCanvas.height;

            newCanvas.style.position = "absolute";
            if (event.type == "touchend") {
                event = event.originalEvent.changedTouches[0];
                var pageviewcontainer = $('#' + this._id + '_viewerContainer');
                newCanvas.style.left = (parseFloat($(pageviewcontainer).css("width")) / 2) - $(pageDiv).offset().left + "px";
                newCanvas.style.top = (parseFloat($(pageviewcontainer).css("height")) / 2) - $(pageDiv).offset().top + "px";
                if (((parseFloat(newCanvas.style.top) + heights)) > ($(pageDiv).height())) {
                    newCanvas.style.top = (parseFloat(newCanvas.style.top) - heights) + "px";
                }
                else if ((parseFloat(newCanvas.style.top) < 0)) {
                    newCanvas.style.top = (parseFloat(newCanvas.style.top) + heights) + "px";
                }
            }
            else {
                if (event.pageX - $(pageDiv).offset().left + (widths / 2) < canvas.clientWidth && event.pageX - $(pageDiv).offset().left - (widths / 2) > 0) {
                    newCanvas.style.left = event.pageX - $(pageDiv).offset().left - (widths/2) + "px";
                }
                else if (event.pageX - $(pageDiv).offset().left - (widths) <= 0) {
                    newCanvas.style.left = "0px";
                }
                else if (event.pageX - $(pageDiv).offset().left + (widths) >= canvas.clientWidth) {
                    newCanvas.style.left = event.pageX - $(pageDiv).offset().left - (widths) + "px";
                }
                if (event.pageY - $(pageDiv).offset().top + (heights) < canvas.clientHeight && event.pageY - $(pageDiv).offset().top - (heights) > 0) {
                    newCanvas.style.top = event.pageY - $(pageDiv).offset().top - (heights) + "px";
                }
                else {
                    newCanvas.style.top = "0px";
                }
            }
            this._canvasTopPosition = event.pageX;
            this._canvasLeftPosition = event.pageY;
            this._newCanvas = newCanvas;
            newCanvas.style.zIndex = "10000000";
            pageDiv.appendChild(newCanvas);
            var proxy = this;
            var pageviewcontainer = $('#' + this._id + '_viewerContainer');
            $(window).on("mousemove", function (event) {
                if (proxy._signatureAdded && proxy._newCanvas) {
                    var tempCavas = proxy._newCanvas;
                    var tempctx = tempCavas.getContext("2d");
                    proxy._isCanasResized = false;
                    proxy._startWidth = tempCavas.clientWidth;
                    proxy._startHeight = tempCavas.clientHeight;
                    var bounds = tempCavas.getBoundingClientRect();
                    var x = event.pageX - proxy._canvasTopPosition;
                    var y = event.pageY - proxy._canvasLeftPosition;
                    proxy._canvasTopPosition = event.pageX;
                    proxy._canvasLeftPosition = event.pageY;
                    var top = (y + parseFloat(tempCavas.style.top));
                    var left = (x + parseFloat(tempCavas.style.left));
                    var isButtons = document.getElementById(proxy._id + "e-pdfviewer-buttons");
                    if (event.pageX - $(pageDiv).offset().left + (proxy._startWidth/2) < canvas.clientWidth && event.pageX - $(pageDiv).offset().left - (proxy._startWidth/2) > 0) {
                        tempCavas.style.left = event.pageX - $(pageDiv).offset().left - (proxy._startWidth/2) + "px";
                    }
                    else {
                        tempCavas.style.left = tempCavas.style.left;
                    }
                    if (event.pageY - $(pageDiv).offset().top + (proxy._startHeight/2) < canvas.clientHeight && event.pageY - $(pageDiv).offset().top - (proxy._startHeight/2) > 0) {
                        tempCavas.style.top = event.pageY - $(pageDiv).offset().top - (proxy._startHeight/2) + "px";
                    }
                    else {
                        tempCavas.style.top = tempCavas.style.top;
                    }
                }
            });
            $(window).on("mouseup touchend", function (event) {
                proxy._isCanasResized = false;
                proxy._isCanvasClicked = false;
                proxy._signatureAdded = false;
                var newCanvas = proxy._tempCanvas;
                if (proxy._isCanvasMoved) {
                    proxy._addingHistoryMove(newCanvas);
                }
                if (proxy._isCanvasResizeOver) {
                     proxy._addingHistoryResize(newCanvas);
                }
            });
            $(pageDiv).on("mousedown touchstart", function (event) {
                var isSelectors = document.getElementById(proxy._id + "e-pdfviewer-selector");
                var isButtons = document.getElementsByClassName('e-pdfviewer-buttons');
                if (event.target.className != "e-pdfviewer-imagecanvasDraw" && event.target.className != "e-pdfviewer-buttons") {
                    var highlight = document.getElementById(this._id + "highlight-menu");
                    $(highlight).hide();
                    proxy._tempCanvas = null;
                    proxy._isCanasResized = false;
                    proxy._isCanvasClicked = false;
                }
                if (isSelectors && !proxy._isCanvasClicked && !proxy._isCanasResized && isButtons) {
                    $(isSelectors).remove();
                    $(isButtons).remove();
                }
                proxy._signatureAdded = false;
                $(newCanvas).on("mousedown touchstart", function (event) {
                    proxy._signatureAdded = false;
                    proxy._clearRectOnClick(proxy._AnnotationPage);
                    if (event.type == "touchstart") {
                        event.preventDefault();
                        event = event.originalEvent.changedTouches[0];
                    }
                    var rect = event.target.id;
                    var tempCavas = document.getElementById(rect);
                    var pageDiv = document.getElementById(proxy._id + 'pageDiv_' + pageIndex);
                    proxy._tempCanvas = tempCavas;
                    proxy._canvasTopPosition = event.pageX;
                    proxy._canvasLeftPosition = event.pageY;
                    proxy._isCanvasClicked = true;
                    proxy._isCanasResized = false;
                    proxy._initialCoordinates = new Object();
                    proxy._initialCoordinates.left = parseFloat(tempCavas.style.left);
                    proxy._initialCoordinates.top = parseFloat(tempCavas.style.top);
                    proxy._removeSelector();
                    var selector = document.createElement("div");
                    selector.style.position = "absolute";
                    selector.style.borderRadius = "3px";
                    selector.style.border = "1px solid #4f80ff";
                    selector.id = proxy._id + "e-pdfviewer-selector";
                    var bounds = proxy._getBounds(event);
                    selector.style.width = bounds.width + "px";
                    selector.style.height = bounds.height + "px";
                    selector.style.left = bounds.x;
                    selector.style.top = bounds.y;
                    selector.style.zIndex = "100000";
                    pageDiv.appendChild(selector);
                    var rightBottomBtn = document.createElement("div");
                    rightBottomBtn.style.position = "absolute";
                    rightBottomBtn.id = proxy._id + "e-pdfviewer-rightbottombtn";
                    rightBottomBtn.className = "e-pdfviewer-buttons";
                    rightBottomBtn.style.width = "20px";
                    rightBottomBtn.style.height = "20px";
                    rightBottomBtn.style.left = parseFloat(bounds.width) - (parseFloat(rightBottomBtn.style.width) / 2) + "px";
                    rightBottomBtn.style.top = parseFloat(bounds.height) - (parseFloat(rightBottomBtn.style.height) / 2) + "px";
                    rightBottomBtn.style.zIndex = "100000000";
                    rightBottomBtn.style.cursor = "se-resize";
                    selector.appendChild(rightBottomBtn);
                    proxy._appendChildElement(rightBottomBtn);
                    $('.e-pdfviewer-buttons').on("mousedown touchstart", function (event) {
                        if (event.type == "touchstart") {
                            event.preventDefault();
                            event = event.originalEvent.changedTouches[0];
                        }
                        var selectorsId = document.getElementById(proxy._id + "e-pdfviewer-selector");
                        proxy._target = event.target;
                        var tempCavas = proxy._tempCanvas;
                        proxy._startX = event.clientX;
                        proxy._startY = event.clientY;
                        proxy._startWidth = tempCavas.clientWidth;
                        proxy._startHeight = tempCavas.clientHeight;
                        proxy._initialSize = { height: parseInt(proxy._startHeight), width: parseInt(proxy._startWidth) };
                        proxy._canvasTopPosition = parseFloat($(tempCavas).css("top"));
                        proxy._canvasLeftPosition = parseFloat($(tempCavas).css("left"));
                        proxy._isCanasResized = true;
                    });
                    $(window).on("mousemove touchmove", function (event) {
                        var canvas = document.getElementById(proxy._id + "pagecanvas_" + proxy._currentPage);
                        var isSelectors = document.getElementById(proxy._id + "e-pdfviewer-selector");
                        if (event.type == "touchmove") {
                            event = event.originalEvent.changedTouches[0];
                        }
                        if (proxy._isCanasResized == true) {
                            var pageDiv = document.getElementById(proxy._id + 'pageDiv_' + proxy._currentPage);
                            var target = event.target;
                            if (target.className != "e-pdfviewer-buttons") {
                                target.style.cursor = "auto";
                            }
                            var tempCavas = proxy._tempCanvas;
                            var tempctx = tempCavas.getContext("2d");
                            proxy._isCanvasClicked = false;
                            var width = proxy._startWidth + (event.clientX - proxy._startX);
                            var height = proxy._startHeight + (event.clientY - proxy._startY);
                            var left = proxy._canvasLeftPosition - (proxy._startX - event.clientX);
                            var top = proxy._canvasTopPosition - (proxy._startY - event.clientY);
                            width -= ($(tempCavas).outerWidth() - parseInt($(tempCavas).css("width")));
                            width += "px";
                            height -= ($(tempCavas).outerHeight() - parseInt($(tempCavas).css("height")));
                            height += "px";
                            left += "px";
                            top += "px";
                            proxy._applyNewBounds(event, tempCavas, width, height, left, top, proxy._startX, proxy._startY, event.pageX, event.clientY, proxy._target, canvas, pageDiv);
                            proxy._calculateIconPosition(event);
                        }
                        if ((proxy._isCanvasClicked == true && isSelectors)) {
                            var tempCavas = proxy._tempCanvas;
                            var tempctx = tempCavas.getContext("2d");
                            proxy._isCanasResized = false;
                            proxy._startWidth = tempCavas.clientWidth;
                            proxy._startHeight = tempCavas.clientHeight;
                            var isButtons = document.getElementById(proxy._id + "e-pdfviewer-buttons");
                            var x = event.pageX - proxy._canvasTopPosition;
                            var y = event.pageY - proxy._canvasLeftPosition;
                            proxy._canvasTopPosition = event.pageX;
                            proxy._canvasLeftPosition = event.pageY;
                            var top = (y + parseFloat(tempCavas.style.top));
                            var left = (x + parseFloat(tempCavas.style.left));
                            var total = parseFloat(tempCavas.clientWidth) + parseFloat(tempCavas.style.left);
                            if (left > 0 && (left + proxy._startWidth) < canvas.clientWidth) {
                                if (top > 0 && (top + proxy._startHeight) < canvas.clientHeight) {
                                    tempCavas.style.top = (y + parseFloat(tempCavas.style.top)) + "px";
                                }
                                tempCavas.style.left = (x + parseFloat(tempCavas.style.left)) + "px";
                                proxy._calculateIconPosition(event);
                            }
                            else {
                                tempCavas.style.top = tempCavas.style.top + "px";
                                tempCavas.style.left = tempCavas.style.left + "px";
                            }
                            proxy._isCanvasMoved = true;
                        }
                    });
                    $('.e-pdfviewer-buttons').on("mouseup touchend", function (e) {
                        proxy._isCanasResized = false;
                        proxy._isCanvasClicked = false;
                        proxy._target = null;
                        if (proxy._isCanvasResizeOver) {
                            proxy._addingHistoryResize(newCanvas);
                        }
                    });
                });
                $(newCanvas).on("mouseup touchend", function (event) {
                    proxy._isCanvasClicked = false;
                    proxy._isCanasResized = false;
                    if (proxy._isCanvasMoved) {
                        proxy._addingHistoryMove(newCanvas);
                    }
                });
            });
            var context = newCanvas.getContext("2d");
            var length = this._outputString.split("<br>").length;
            this._totalSignature.push(newCanvas);
            this._outputPath[newCanvas.id] = this._outputString;
            context.beginPath();
            var newdifferenceX = differenceX / newCanvas.clientWidth;
            var newdifferenceY = differenceY / newCanvas.clientHeight;
            for (var k = 0; k < length; k++) {
                var splitedvalue = this._outputString.split("<br>")[k].split('.').slice(1).join('.');
                if (splitedvalue) {
                    var substring = splitedvalue.substring(0, 6);
                    var movevalues = splitedvalue.substring(6);
                    var points = movevalues.replace(/[{()}]/g, '');
                    var splitPoints = points.split(',');
                    var point1 = ((parseFloat(splitPoints[0])) - this._minpointsX) / newdifferenceX;
                    var point2 = ((parseFloat(splitPoints[1])) - this._minpointsY) / newdifferenceY;
                    if (substring == "moveTo") {
                        context.moveTo(point1, point2);
                    }
                    else if (substring == "lineTo") {
                        context.lineTo(point1, point2);
                    }
                }
            }
            context.lineWidth = 4;
            context.scale(0.5, 0.5);
            context.strokeStyle = this.model.signatureSettings.color;
            context.stroke();
            var minimumX = this._minpointsX;
            var minimumY = this._minpointsY;
            var completestring = new Object();
            completestring.minimumX = minimumX;
            completestring.minimumY = minimumY;
            completestring.differenceX = differenceX;
            completestring.differenceY = differenceY;
            this._valueChanges[newCanvas.id] = completestring;
            $(newCanvas).css("opacity", this.model.signatureSettings.opacity);
            $('#' + this._id + "_containerDialogTab").ejDialog("close");
            var bounds = { "width": 0, "height": 0, "x": 0, "y": 0 };
            if (newCanvas) {
                bounds.width = newCanvas.clientWidth/this._zoomVal;
                bounds.height = newCanvas.clientHeight / this._zoomVal;
                bounds.x = parseFloat($(newCanvas).css("left")) / this._zoomVal;
                bounds.y = parseFloat($(newCanvas).css("top")) / this._zoomVal;
            }
            var args = new Object();
            args.annotationSettings = this.model.signatureSettings;
            args.annotationId = newCanvas.id;
            args.pageId = pageIndex;
            args.annotationBound = bounds;
            this._raiseClientEvent("signatureAdd", args);
        },
        _addingHistoryMove: function (newCanvas) {
            var proxy = this;
            var signatureObject = new Object();
            signatureObject.operation = "signatureMoved";
            var pageIndex = parseInt(newCanvas.id.split("imagecanvasDraw_")[1].split('_')[0]);
            signatureObject.pageNumber = pageIndex;
            signatureObject.signCanvas = newCanvas;
            var pageDivElement = document.getElementById(proxy._id + 'pageDiv_' + pageIndex);
            var pagePosition = pageDivElement.getBoundingClientRect();
            proxy._newinitialCoordinates = new Object();
            proxy._newinitialCoordinates.left = parseFloat(newCanvas.style.left);
            proxy._newinitialCoordinates.top = parseFloat(newCanvas.style.top);
            signatureObject.Coordinates = proxy._newinitialCoordinates;
            signatureObject.initialCoordinates = proxy._initialCoordinates;
            proxy._recentOperation.push(signatureObject);
            proxy._isCanvasMoved = false;

        },
        _addingHistoryResize: function (newCanvas) {
            var proxy = this;
            var path = proxy._outputPath[newCanvas.id];
            var newWidths = newCanvas.clientWidth;
            var newHeight = newCanvas.clientHeight;
            proxy._reDrawSignature(path, newCanvas, newWidths, newHeight);
            var signObject = new Object();
            signObject.operation = "signatureResized";
            var pageIndex = parseInt(newCanvas.id.split("imagecanvasDraw_")[1].split('_')[0]);
            signObject.pageNumber = pageIndex;
            signObject.signCanvas = newCanvas;
            signObject.initialSize = proxy._initialSize;
            signObject.size = proxy._size;
            proxy._recentOperation.push(signObject);
            proxy._isCanvasResizeOver = false;
            var bounds = { "width": 0, "height": 0, "x": 0, "y": 0 };
            if (newCanvas) {
                bounds.width = newCanvas.clientWidth / proxy._zoomVal;
                bounds.height = newCanvas.clientHeight / proxy._zoomVal;
                bounds.x = parseFloat($(newCanvas).css("left")) / proxy._zoomVal;
                bounds.y = parseFloat($(newCanvas).css("top")) / proxy._zoomVal;
            }
            var signatureContext = newCanvas.getContext("2d");
            var args = new Object();
            var newSignatureSettings = {
                color: signatureContext.strokeStyle,
                opacity: $(newCanvas).css("opacity"),
            };
            args.signatureSettings = newSignatureSettings;
            args.pageNumber = newCanvas.id;
            args.pageId = parseInt(newCanvas.id.split("imagecanvasDraw_")[1].split('_')[0]);
            args.signatureCurrentBound = bounds;
            args.signaturePreviousBound = proxy._size;
            proxy._raiseClientEvent("signatureResize", args);
        },
        _moveSignatureArrowKey: function (event) {
            var proxy = this;
            if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40) {
                var tempCavas = proxy._tempCanvas;
                if (tempCavas) {
                    event.preventDefault();
                }
                var isSelectors = document.getElementById(proxy._id + "e-pdfviewer-selector");
                var canvas = document.getElementById(proxy._id + "pagecanvas_" + proxy._currentPage);
                if (tempCavas) {
                    var left = parseFloat(tempCavas.style.left);
                    var top = parseFloat(tempCavas.style.top);
                    proxy._keyInitialCoordinates = new Object();
                    proxy._keyInitialCoordinates.left = left;
                    proxy._keyInitialCoordinates.top = top;
                }
                var pageviewcontainer = $('#' + this._id + '_viewerContainer');
                if (tempCavas && isSelectors) {
                    var left = parseFloat(tempCavas.style.left);
                    var top = parseFloat(tempCavas.style.top);
                    var width = parseFloat(tempCavas.style.width);
                    var height = parseFloat(tempCavas.style.height);
                    var selectorLeft = parseFloat($(isSelectors).css("left"));
                    var selectorTop = parseFloat($(isSelectors).css("top"));
                    switch (event.keyCode) {
                        case 37:
                            if ((left + width) > 0 && (left - 20) > 0) {
                                tempCavas.style.left = parseFloat(tempCavas.style.left) - 20 + "px";
                                $(isSelectors).css("left", selectorLeft - 20 + "px");
                            }
                            break;
                        case 39:
                            if ((left + width + 20) < canvas.clientWidth) {

                                tempCavas.style.left = parseFloat(tempCavas.style.left) + 20 + "px";
                                $(isSelectors).css("left", selectorLeft + 20 + "px");
                            }
                            break;
                        case 38:
                            if ((top + height) > 0 && (top - 20) > 0) {
                                tempCavas.style.top = parseFloat(tempCavas.style.top) - 20 + "px";
                                $(isSelectors).css("top", selectorTop - 20 + "px");
                            }
                            break;

                        case 40:
                            if ((top + height + 20) < canvas.clientHeight) {
                                tempCavas.style.top = parseFloat(tempCavas.style.top) + 20 + "px";
                                $(isSelectors).css("top", selectorTop + 20 + "px");
                            }
                            break;
                    }
                    var signatureObject = new Object();
                    signatureObject.operation = "keyMoved";
                    var pageIndex = parseInt(tempCavas.id.split("imagecanvasDraw_")[1].split('_')[0]);
                    signatureObject.pageNumber = pageIndex;
                    signatureObject.signCanvas = tempCavas;
                    var pageDivElement = document.getElementById(proxy._id + 'pageDiv_' + pageIndex);
                    var pagePosition = pageDivElement.getBoundingClientRect();
                    proxy._newinitialPosition = new Object();
                    proxy._newinitialPosition.left = parseFloat(tempCavas.style.left);
                    proxy._newinitialPosition.top = parseFloat(tempCavas.style.top);
                    signatureObject.Coordinates = proxy._newinitialPosition;
                    signatureObject.keyinitialCoordinates = proxy._keyInitialCoordinates;
                    proxy._recentOperation.push(signatureObject);
                }
            }
            else if (event.keyCode == 46) {
                proxy._deleteSignatureCanvas();
            }
        },
        _applyNewBounds: function (event, element, width, height, left, top, startX, startY, clientX, clientY, resizeElement, canvas, pageDiv) {
            var proxy = this;
            proxy._size = new Object();
            var lefts = $(element).css("left");
            var tops = $(element).css("top");
            if (resizeElement.id == (proxy._id + "e-pdfviewer-rightbottombtn")) {
                if (parseFloat(lefts) > 0 && (parseFloat(width) + parseFloat(lefts)) < canvas.clientWidth)
                    $(element).css("width", width);
                proxy._size.width = width;
            }
            if (resizeElement.id == (proxy._id + "e-pdfviewer-rightbottombtn")) {
                if (parseFloat(tops) > 0 && (parseFloat(height) + parseFloat(tops)) < canvas.clientHeight) {
                    $(element).css("height", height);
                }
                proxy._size.height = height;
            }
            proxy._isCanvasResizeOver = true;
        },
        _calculateIconPosition: function (event) {
            var proxy = this;
            var selector = document.getElementById(proxy._id + "e-pdfviewer-selector");
            var rightBottomBtn = document.getElementById(proxy._id + "e-pdfviewer-rightbottombtn");
            var leftBottomBtn = document.getElementById(proxy._id + "e-pdfviewer-leftBottomBtn");
            var rightTopBtn = document.getElementById(proxy._id + "e-pdfviewer-rightTopBtn");
            var leftTopBtn = document.getElementById(proxy._id + "e-pdfviewer-leftTopBtn");
            var isRotateBtn = document.getElementsByClassName('e-pdfviewer-rotatebuttons')[0];
            var isRotate = document.getElementsByClassName('e-pdfviewer-rotate')[0];
            var bounds = proxy._getBounds(event);
            selector.style.width = bounds.width + "px";
            selector.style.height = bounds.height + "px";
            selector.style.left = bounds.x;
            selector.style.top = bounds.y;
            rightBottomBtn.style.left = parseFloat(bounds.width) - (parseFloat(rightBottomBtn.style.width) / 2) + "px";
            rightBottomBtn.style.top = parseFloat(bounds.height) - (parseFloat(rightBottomBtn.style.height) / 2) + "px";
        },
        _removeSelector: function (e) {
            var proxy = this;
            var isSelectors = document.getElementById(proxy._id + "e-pdfviewer-selector");
            var isButtons = $(".e-pdfviewer-buttons");
            if (isSelectors) {
                $(isSelectors).remove();
                $(isButtons).remove();
            }
        },
        _getBounds: function (event) {
            var bounds = { "width": 0, "height": 0, "x": 0, "y": 0 };
            var tempCavas = this._tempCanvas;
            if (tempCavas) {
                bounds.width = tempCavas.clientWidth;
                bounds.height = tempCavas.clientHeight;
                bounds.x = $(tempCavas).css("left");
                bounds.y = $(tempCavas).css("top");
            }
            return bounds;
        },
        _clearSignature: function (e) {
            var canvas = document.getElementById(this._id + "_imageTemp");
            var context = canvas.getContext("2d");
            context.clearRect(0, 0, canvas.width, canvas.height);
            this._outputString = "";
            this._newObject = [];
            this._minX = this._minY = 0;
            this._maxX = this._maxY = 0;
        },
        _getPagePosition: function (id) {
            var pageContainer = document.getElementById(this._id + "selectioncanvas_" + id);
            return pageContainer.getBoundingClientRect();
        },

        _getTextNodes: function (selection, pageIndex) {
            var selectionRects = [];
            var range = document.createRange();
            var selectionRange = selection.getRangeAt(0);
            var annotationRect = selectionRange.getBoundingClientRect();
            if (selection.anchorNode == selection.focusNode) {
                if (this._isBackwardSelection) {
                    range.setStart(selection.focusNode, selection.focusOffset);
                    range.setEnd(selection.anchorNode, selection.anchorOffset);
                } else {
                    if (selection.anchorOffset < selection.focusOffset) {
                        range.setStart(selection.anchorNode, selection.anchorOffset);
                        range.setEnd(selection.focusNode, selection.focusOffset);
                    } else {
                        range.setStart(selection.focusNode, selection.focusOffset);
                        range.setEnd(selection.anchorNode, selection.anchorOffset);
                    }
                }
                var boundingRect = range.getBoundingClientRect();
                selectionRects.push(boundingRect);
            } else {
                if (this._isBackwardSelection) {
                    this._getAnnotationOffsets(selectionRange, selection.focusNode, selection.anchorNode, selection.focusOffset, selection.anchorOffset, selectionRects);
                } else {
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        var isBackwardSelection = false;
                        var anchorIndex, focusIndex;
                        for (var i = 0; i < this._textDivs[pageIndex].length; i++) {
                            var textContent = this._textDivs[pageIndex][i].textContent;
                            if (textContent == selection.anchorNode.data)
                                anchorIndex = i;
                            if (textContent == selection.focusNode.data)
                                focusIndex = i;
                            if (i == this._textDivs[pageIndex].length - 1 && !focusIndex) {
                                focusIndex = this._textDivs[pageIndex].length - 1;
                            }
                        }
                        if (anchorIndex < focusIndex || !anchorIndex) {
                            this._getAnnotationOffsets(selectionRange, selection.anchorNode, selection.focusNode, selection.anchorOffset, selection.focusOffset, selectionRects);
                        } else 
                            this._getAnnotationOffsets(selectionRange, selection.focusNode, selection.anchorNode, selection.focusOffset, selection.anchorOffset, selectionRects);
                    } else
                        this._getAnnotationOffsets(selectionRange, selection.anchorNode, selection.focusNode, selection.anchorOffset, selection.focusOffset, selectionRects);
                }
            }
            return { rectangleBound : annotationRect, bounds : selectionRects };
        },

        _getAnnotationOffsets: function (selectionRange, startNode, endNode, selectionStartOffset, selectionEndOffset, selectionRects) {
            if (startNode.parentNode.className == "e-pdfviewer-selectiondiv text_container") {
                var anchorPageId = parseInt(startNode.id.split("text_")[1]);
                var anchorTextId = parseInt(startNode.id.split("text_" + anchorPageId + '_')[1]);
            }
            else {
                var anchorPageId = parseInt(startNode.parentNode.id.split("text_")[1]);
                var anchorTextId = parseInt(startNode.parentNode.id.split("text_" + anchorPageId + '_')[1]);
            }
            if (endNode.parentNode.className == "e-pdfviewer-selectiondiv text_container") {
                var focusPageId = parseInt(endNode.id.split("text_")[1]);
                var focusTextId = parseInt(endNode.id.split("text_" + focusPageId + '_')[1]);
            }
            else {
                var focusPageId = parseInt(endNode.parentNode.id.split("text_")[1]);
                var focusTextId = parseInt(endNode.parentNode.id.split("text_" + focusPageId + '_')[1]);
            }
            var startOffset, endOffset, currentId;
            if (this._isFindboxPresent) {
                this._clearAllOccurrences();
            }
            var pageId;
            if (anchorPageId != focusPageId && this._isBackwardSelection)
                pageId = focusPageId;
            else
                pageId = anchorPageId;
            for (var i = pageId; i <= focusPageId; i++) {
                var textDivs = this._textDivs[i];
                if (i == anchorPageId) {
                    currentId = anchorTextId;
                } else {
                    if (this._isBackwardSelection)
                        currentId = 0;
                    else
                        break;
                }
                for (var j = currentId; j < this._textDivs[i].length; j++) {
                    var textElement = textDivs[j];
                    var range = document.createRange();
                    if (j == anchorTextId) {
                        startOffset = selectionStartOffset;
                    } else {
                        startOffset = 0;
                    }
                    if (j == focusTextId) {
                        endOffset = selectionEndOffset;
                    } else {
                        endOffset = textElement.textContent.length;
                    }
                    for (var k = 0; k < textElement.childNodes.length; k++) {
                        var node = textElement.childNodes[k];
                        range.setStart(node, startOffset);
                        range.setEnd(node, endOffset);
                    }
                    var boundingRect = range.getBoundingClientRect();
                    range.detach();
                    selectionRects.push(boundingRect);
                    if (i == focusPageId && j == focusTextId) {
                        break;
                    }
                }
            }
        },

        _drawStrikeOutAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = this._getAnchorId(selection);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        var selectionNodes = this._getSelectionNodes(selection);
                        anchorId = selectionNodes.anchorIds;
                        focusId = selectionNodes.focusIds;
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var drawColor = this._drawColor ? this._drawColor : this.model.strikethroughSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var date = new Date();
                    var modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "StrikeOut",
                        bounds: [],
                        author: this.model.strikethroughSettings.author,
                        subject: this.model.strikethroughSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.strikethroughSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.strikethroughSettings.isLocked
                    }
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.moveTo(xPosition, (yPosition) + (bounds.height / 2));
                        context.lineTo(xPosition + bounds.width, (yPosition) + (bounds.height / 2));
                        context.closePath();
                        context.strokeStyle = drawColor;
                        context.stroke();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.strikethroughSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "StrikeOut"
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedStrikeOut",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    window.getSelection().removeAllRanges();
                    this.isDocumentEdited = true;
                }
                if ($('#' + this._id + 'custom-menu'))
                    $('#' + this._id + 'custom-menu').hide();
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
            }
        },

        _drawUnderlineAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = this._getAnchorId(selection);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        var selectionNodes = this._getSelectionNodes(selection);
                        anchorId = selectionNodes.anchorIds;
                        focusId = selectionNodes.focusIds;
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var drawColor = this._drawColor ? this._drawColor : this.model.underlineSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var date = new Date();
                    var modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "Underline",
                        bounds: [],
                        author: this.model.underlineSettings.author,
                        subject: this.model.underlineSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.underlineSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.underlineSettings.isLocked
                    };
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.moveTo(xPosition, yPosition + bounds.height);
                        context.lineTo(xPosition + bounds.width, yPosition + bounds.height);
                        context.closePath();
                        context.strokeStyle = drawColor;
                        context.stroke();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.underlineSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "Underline";
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedUnderline",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    this.isDocumentEdited = true;
                    window.getSelection().removeAllRanges();
                    this._waterDropletDivHide();
                    $('#' + this._id + 'touchcustom-menu').hide();
                }
            }
        },

        _getAnchorId: function (selection) {
            var anchorId;
            if (selection.anchorNode.parentNode.className == "e-pdfviewer-selectiondiv text_container") {
                 anchorId = parseInt(selection.anchorNode.id.split("text_")[1]);
            }
            else {
                 anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
            }
            return anchorId;
        },
        _getSelectionNodes: function (selection) {
            var anchorId, focusId;
            if (selection.anchorNode.parentNode.className == "e-pdfviewer-selectiondiv text_container") {
                anchorId = parseInt(selection.anchorNode.id.split("text_")[1]);
            }
            else {
                anchorId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
            }
            if (selection.focusNode.parentNode.className == "e-pdfviewer-selectiondiv text_container") {
                focusId = parseInt(selection.focusNode.id.split("text_")[1]);
            }
            else {
                focusId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
            }
            return { anchorIds: anchorId ,focusIds:focusId};
        },

        _drawHighlightAnnotation: function () {
            if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
                if (window.getSelection().toString()) {
                    var selection = window.getSelection();
                    var anchorId = this._getAnchorId(selection);
                    var focusId;
                    var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                    var is_edge = navigator.userAgent.indexOf("Edge") != -1;
                    var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                    if (is_ie || is_edge || is_edgeNew) {
                        var selectionNodes = this._getSelectionNodes(selection);
                        anchorId = selectionNodes.anchorIds;
                        focusId = selectionNodes.focusIds;
                        if (anchorId < focusId) {
                            this._isBackwardSelection = false;
                        } else if (anchorId > focusId) {
                            this._isBackwardSelection = true;
                        }
                    }
                    var prevYPosition = 0;
                    var indexes = [];
                    var selectionRects = this._getTextNodes(selection, anchorId);
                    var drawColor = this._drawColor ? this._drawColor : this.model.highlightSettings.color;
                    var tempColorObject;
                    if (typeof drawColor === 'object') {
                        tempColorObject = JSON.parse(JSON.stringify(drawColor));
                        drawColor = 'rgb(' + drawColor.r + ',' + drawColor.g + ',' + drawColor.b + ')';
                    } else if (typeof drawColor === 'string') {
                        tempColorObject = this._toolbarColorpickerObject.hexCodeToRGB(drawColor);
                    }
                    var date = new Date();
                    var modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    var textMarkupAnnotation = {
                        type: "Highlight",
                        bounds: [],
                        author: this.model.highlightSettings.author,
                        subject: this.model.highlightSettings.subject,
                        modifiedDate: modifiedDate,
                        colorR: tempColorObject.r,
                        colorG: tempColorObject.g,
                        colorB: tempColorObject.b,
                        colorA: 1 * 255,
                        opacity: this.model.highlightSettings.opacity,
                        note: "",
                        pageNumber: anchorId,
                        isLocked: this.model.highlightSettings.isLocked
                    };
                    for (var i = 0; i < selectionRects.bounds.length; i++) {
                        var pagePosition = this._getPagePosition(anchorId);
                        var bounds = selectionRects.bounds[i];
                        var xPosition = bounds.left - pagePosition.left;
                        var yPosition = bounds.top - pagePosition.top;
                        if (yPosition > this._pageSize[anchorId - 1].PageHeight) {
                            anchorId++;
                            pagePosition = this._getPagePosition(anchorId);
                            var yPosition = bounds.top - pagePosition.top;
                        }
                        var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + anchorId);
                        var secCanvasPosition = secCanvas.getBoundingClientRect();
                        var context = secCanvas.getContext("2d");
                        context.beginPath();
                        yPosition = yPosition - 1.2 * this._zoomVal;
                        context.rect(xPosition, yPosition, bounds.width, bounds.height);
                        context.closePath();
                        context.globalAlpha = 0.5;
                        context.fillStyle = drawColor;
                        context.fill();
                        var annotationBound = {
                            xPosition: xPosition / this._zoomVal,
                            yPosition: yPosition / this._zoomVal,
                            width: bounds.width / this._zoomVal,
                            height: bounds.height / this._zoomVal
                        };
                        textMarkupAnnotation.bounds.push(annotationBound);
                    }
                    this._newAnnotationList[anchorId - 1].push(textMarkupAnnotation);
                    this._totalAnnotations[anchorId].push(JSON.parse(JSON.stringify(textMarkupAnnotation)));
                    var args = new Object();
                    args.annotationSettings = this.model.highlightSettings;
                    args.annotationId = this._totalAnnotations[anchorId].length - 1;
                    args.pageId = anchorId;
                    args.annotationBound = textMarkupAnnotation.bounds;
                    args.annotationType = "Highlight"
                    this._raiseClientEvent("annotationAdd", args);
                    var lastIndex = this._newAnnotationList[anchorId - 1].length - 1;
                    indexes.push(lastIndex);
                    var recentOp = {
                        operation: "AddedHighlight",
                        pageNumber: anchorId,
                        indexes: indexes
                    }
                    this._recentOperation.push(recentOp);
                    this._redoActions = new Array();
                    for (var i = 0; i < this._totalPages; i++) {
                        var newArray = [];
                        this._redoAnnotationCollection[i] = newArray;
                    }
                    this.isDocumentEdited = true;
                    window.getSelection().removeAllRanges();
                }
                if ($('#' + this._id + 'custom-menu'))
                    $('#' + this._id + 'custom-menu').hide();
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
            }
        },
        _drawAnnotationRect: function (pageIndex, xPosition, yPosition, width, height) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            if (canvas) {
                var context = canvas.getContext("2d");
                context.beginPath();
                context.setLineDash([4]);
                context.globalAlpha = 1;
                context.rect(xPosition, yPosition, width, height);
                context.closePath();
                context.strokeStyle = "blue";
                context.stroke();
                context.save();
            }
        },

        _drawAnnotSelectRect: function (pageNumber, currentAnnotationRectangle) {
            this._tempCanvas = null;
            this._removeSelector();
            var currentAnnotation = currentAnnotationRectangle[currentAnnotationRectangle.length - 1];
            this._selectedAnnotation = currentAnnotation;
            this._selectedAnnotationObject = new Object();
            this._selectedAnnotationObject.annotation = currentAnnotation;
            this._selectedAnnotationObject.pageIndex = pageNumber;
            var annotDetails = this._getAnnotation(currentAnnotationRectangle, pageNumber);
            if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[pageNumber][annotDetails.currentAnnotationIndex];
                for (var i = 0; i < annot.Bounds.length; i++) {
                    var bound = annot.Bounds[i];
                    this._drawAnnotationRect(pageNumber, this._convertPointToPixel(bound.X) * this._zoomVal, this._convertPointToPixel(bound.Y) * this._zoomVal, this._convertPointToPixel(bound.Width) * this._zoomVal, this._convertPointToPixel(bound.Height) * this._zoomVal);
                }
            } else {
                var annotation = currentAnnotationRectangle[0];
                if (annotation.bounds) {
                    for (var i = 0; i < annotation.bounds.length; i++) {
                        var bound = annotation.bounds[i];
                        this._drawAnnotationRect(pageNumber, (bound.xPosition - 0.5) * this._zoomVal, (bound.yPosition - 0.5) * this._zoomVal,
                                    (bound.width + 0.5) * this._zoomVal,
                                    (bound.height + 0.5) * this._zoomVal);
                    }
                }
            }
            this._isAnnotationSelected = true;
        },

        _clearRectOnClick: function (pageIndex) {
            var canvas = document.getElementById(this._id + '_secondarycanvas_' + pageIndex);
            if (canvas) {
                var context = canvas.getContext("2d");
                context.setLineDash([]);
                this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageIndex], pageIndex);
                this._isAnnotationSelected = false;
                this._selectedAnnotationObject = null;
            }
        },

        _onCanvasMousedown: function (secanvas, pageX, pageY) {
            var targetContext = secanvas.getContext("2d");
            var x = parseInt(pageX - $(secanvas.parentNode).offset().left);
            var y = parseInt(pageY - $(secanvas.parentNode).offset().top);
            var imagedata = targetContext.getImageData(x, y, 1, 1).data;
            this._annotationColor = this._rgb2Color(imagedata[0], imagedata[1], imagedata[2]);
        },

        _showPopupNote: function (e) {
            var noteContent = document.getElementById(this._id + '_note_content');
            var annotation = this._currentAnnotationRectangle[0];
            if (annotation.note) {
                noteContent.textContent = annotation.note;
                var r = annotation.Color ? annotation.Color.R : annotation.colorR;
                var g = annotation.Color ? annotation.Color.G : annotation.colorG;
                var b = annotation.Color ? annotation.Color.B : annotation.colorB;
                var authorContent = document.getElementById(this._id + '_author_content');
                authorContent.style.borderBottom = "1px solid black";
                authorContent.style.fontWeight = "bold";
                var author = annotation.Author ? annotation.Author : annotation.author;
                if (author);
                authorContent.textContent = author;
                noteContent.style.backgroundColor = 'rgb(' + r + ',' + g + ',' + b + ')';
                var noteElement =$('#' + this._id + '_popup_note');
                var position = this._setPopupMenuPosition(e, noteElement);
                noteElement.css({ 'display': 'block', 'background-color': 'rgb(' + r + ',' + g + ',' + b + ')', 'position': 'absolute' });
                noteElement.show();
                noteElement.offset({ top: position.y + 5, left: position.x + 5 }).show();
                noteElement.show();
                noteElement.offset({ top: position.y + 5, left: position.x + 5 }).show();
                noteElement.show();
            }
        },

        _showPopupMenu: function (e) {
            if (!this._isPropertiesWindowOpen) {
                this._isPopupNoteVisible = true;
                $('#' + this._id + '_popup_note').hide();
                document.getElementById(this._id + '_popupinnercontent').innerText = "";
                var highlight = document.getElementById(this._id + "highlight-menu");
                $(highlight).hide();
                this._isContextMenuPresent = false;
                var notesContent = document.getElementById(this._id + "_popupinnercontent");
                $(notesContent).focus();
                notesContent.contentEditable = true;
                var authorName, modifiedDate, note;
                var currentAnnotation = (this._currentAnnotationRectangle.length > 0) ? this._currentAnnotationRectangle : this._currentAnnotationRectangleBackup;
                this._annotationBackupNoteSave = currentAnnotation;
                var annotDetails = this._getAnnotation(currentAnnotation, this._AnnotationPage);
                if (annotDetails.isExistingAnnotation) {
                    var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                    authorName = annot.Author;
                    modifiedDate = annot.ModifiedDate;
                    if (annot.note) {
                        note = annot.note;
                    }
                } else {
                    for (var j = 0; j < this._currentAnnotations.length; j++) {
                        var annotation = this._currentAnnotations[j];
                        authorName = annotation.author;
                        modifiedDate = annotation.modifiedDate;
                        if (annotation.note) {
                            note = annotation.note;
                        }
                        break;
                    }
                }
                document.getElementById(this._id + '_username').innerText = authorName;
                document.getElementById(this._id + '_currentTime').innerText = modifiedDate;
                if (note) {
                    document.getElementById(this._id + '_popupinnercontent').innerText = note;
                }
                var popupmenu = document.getElementById(this._id + "_popupmenu");
                $(popupmenu).css("z-index", 1000000000);
                var contextMenu = $(popupmenu);
                var pos = this._setPopupMenuPosition(e, contextMenu);
                $(popupmenu).show();
                $(popupmenu).offset({ top: pos.y, left: pos.x }).show();
                $(popupmenu).show();
                $(popupmenu).offset({ top: pos.y, left: pos.x }).show();
                $(popupmenu).show();
            }
        },

        _saveNote: function () {
            var currentAnnotation;
            if (this._annotationBackupNoteSave) {
                currentAnnotation = this._annotationBackupNoteSave;
            } else {
                currentAnnotation = (this._currentAnnotationRectangle.length > 0) ? this._currentAnnotationRectangle : this._currentAnnotationRectangleBackup;
            }
            var date = new Date();
            var annotDetails = this._getAnnotation(currentAnnotation, this._AnnotationPage);
            var popupContent = document.getElementById(this._id + '_popupinnercontent');
            if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                if (annot.note != popupContent.textContent) {
                    var annotationType = annot.TextMarkupAnnotationType;
                    if (annotationType == "Highlight") {
                        annot.ModifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.ModifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.ModifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    annot.note = popupContent.textContent;
                }
            } else {
                for (var j = 0; j < this._currentAnnotations.length; j++) {
                    var annotation = this._currentAnnotations[j];
                    if (annotation.note != popupContent.textContent) {
                        var annotationType = annotation.type;
                        if (annotationType == "Highlight") {
                            annotation.modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                        } else if (annotationType == "Underline") {
                            annotation.modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                        } else if (annotationType == "StrikeOut") {
                            annotation.modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                        }
                        annotation.note = popupContent.textContent;
                    }
                    break;
                }
            }
            popupContent.innerText = "";
        },

        _setPropertiesWindowLocale: function (localeObj) {
            var appearanceText = localeObj['propertyWindow']['appearance']['contentText'];
            var generalText = localeObj['propertyWindow']['general']['contentText'];
            var colorText = localeObj['propertyWindow']['color']['contentText'];
            var opacityText = localeObj['propertyWindow']['opacity']['contentText'];
            var authorText = localeObj['propertyWindow']['author']['contentText'];
            var subjectText = localeObj['propertyWindow']['subject']['contentText'];
            var modifiedText = localeObj['propertyWindow']['modified']['contentText'];
            var okText = localeObj['propertyWindow']['ok']['contentText'];
            var cancelText = localeObj['propertyWindow']['cancel']['contentText'];
            var lockedText = localeObj['propertyWindow']['locked']['contentText'];
            this._replaceTextLocale($("#" + this._id + "_appearanceli").children("a")[0], appearanceText);
            this._replaceTextLocale($("#" + this._id + "_generalli").children("a")[0], generalText);
            this._replaceTextLocale($("#" + this._id + "_colorspan")[0], colorText);
            this._replaceTextLocale($("#" + this._id + "_opacityspan")[0], opacityText);
            this._replaceTextLocale($("#" + this._id + "_authorspan")[0], authorText);
            this._replaceTextLocale($("#" + this._id + "_subjectspan")[0], subjectText);
            this._replaceTextLocale($("#" + this._id + "_modifiedspan")[0], modifiedText);
            this._replaceTextLocale($("#" + this._id + "_ok")[0], okText);
            this._replaceTextLocale($("#" + this._id + "_cancel")[0], cancelText);
            this._replaceTextLocale($("#" + this._id + "_lockedprop")[0], lockedText);
        },

        _showPropertiesMenu: function (e) {
            this._isPropertiesWindowOpen = true;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            this._setPropertiesWindowLocale(localeObj);
            var highlight = document.getElementById(this._id + "highlight-menu");
            $(highlight).hide();
            $("#" + this._id + "_generalli").css("display", "");
            $('.e-pdfviewer-lockedcheckbox').css("visibility", "");
            $("#" + this._id + "_lockedprop").css("visibility", "");
            this._isContextMenuPresent = false;
            var tabObject = $("#" + this._id + "_PropertiesDialogTab").data("ejTab");
            tabObject.showItem(0);
            var annotColor, annotOpacity, authorName, subjectName, modifiedDate, isLocked;
            var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
            var annotationType;
            if (this._tempCanvas) {
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                checkboxObject.option("checked", false);
                var signatureCanvas = this._tempCanvas;
                var signatureContext = signatureCanvas.getContext("2d");
                var hex = signatureContext.strokeStyle;
                var r1 = parseInt(hex.slice(1, 3), 16),
                 g1 = parseInt(hex.slice(3, 5), 16),
                 b1 = parseInt(hex.slice(5, 7), 16);
                annotColor = { r: r1, g: g1, b: b1 };
                annotOpacity = parseFloat($(signatureCanvas).css("opacity")),
                annotationType = "Signature";
                $("#" + this._id + "_generalli").css("display", "none");
                $('.e-pdfviewer-lockedcheckbox').css("visibility", "hidden");
                $("#" + this._id + "_lockedprop").css("visibility", "hidden");
                this._hided = true;
            }
            else if (annotDetails.isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[this._AnnotationPage][annotDetails.currentAnnotationIndex];
                annotColor = { r: annot.Color.R, g: annot.Color.G, b: annot.Color.B };
                annotOpacity = annot.Opacity;
                authorName = annot.Author;
                subjectName = annot.Subject;
                modifiedDate = annot.ModifiedDate;
                isLocked = annot.isLocked;
                annotationType = annot.TextMarkupAnnotationType;
            } else if (this._currentAnnotations.length > 0) {
                for (var j = 0; j < this._currentAnnotations.length; j++) {
                    var annotation = this._currentAnnotations[j];
                    annotColor = { r: annotation.colorR, g: annotation.colorG, b: annotation.colorB };
                    annotOpacity = annotation.opacity;
                    authorName = annotation.author;
                    subjectName = annotation.subject;
                    modifiedDate = annotation.modifiedDate;
                    isLocked = annotation.isLocked;
                    annotationType = annotation.type;
                    break;
                }
            }
            if (annotColor) {
                this._colorpickerObject.option("value", this._rgb2Color(annotColor.r, annotColor.g, annotColor.b));
            }
            var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
            var displayOpacity = parseInt(annotOpacity * 100);
            sliderObject.option("value", displayOpacity);
            $("#" + this._id + "_opacity").val(displayOpacity + "%");
            $('#' + this._id + "_author_input").val(authorName);
            $('#' + this._id + "_subject_input").val(subjectName);
            var spanElement = document.getElementById(this._id + "_modifieddate").childNodes[0];
            spanElement.textContent = modifiedDate;
            $('#' + this._id + "_containerDialogTab").ejDialog({ title: annotationType + " Properties" });
            var headerElement = $("#" + this._id + "_containerDialogTab_title").children("span")[0];
            if (annotationType == "Highlight")
                headerElement.textContent = localeObj['propertyWindow']['highlightProperties']['contentText'];
            else if (annotationType == "StrikeOut")
                headerElement.textContent = localeObj['propertyWindow']['strikeOutProperties']['contentText'];
            else if (annotationType == "Underline")
                headerElement.textContent = localeObj['propertyWindow']['underlineProperties']['contentText'];
            else if (annotationType == "Signature")
                headerElement.textContent = localeObj['propertyWindow']['signatureProperties']['contentText'];
            $('#' + this._id + "_containerDialogTab").ejDialog("open");
            var height = Math.max(0, (($(window).height() - $('#' + this._id + "_containerDialogTab").outerHeight()) / 2) + $(window).scrollTop()) + "px";
            var width = Math.max(0, (($(window).width() - $('#' + this._id + "_containerDialogTab").outerWidth()) / 2) + $(window).scrollLeft()) + "px";
            $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: width, Y: height } });
            if (isLocked) {
                this._colorpickerObject.option('enabled', false);
                document.getElementById(this._id + "_opacity").disabled = true;
                $('#' + this._id + "_opacity").addClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.disable();
                document.getElementById(this._id + "_author_input").disabled = true;
                $('#' + this._id + "_author_input").addClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = true;
                $('#' + this._id + "_subject_input").addClass("e-disable");
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                checkboxObject.option("checked", true);
            } else {
                this._colorpickerObject.option('enabled', true);
                document.getElementById(this._id + "_opacity").disabled = false;
                $('#' + this._id + "_opacity").removeClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = false;
                $('#' + this._id + "_author_input").removeClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = false;
                $('#' + this._id + "_subject_input").removeClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.enable();
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                checkboxObject.option("checked", false);
            }
        },
        _lockProperties: function () {
            var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
            if (checkboxObject.model.checkState == "check") {
                this._colorpickerObject.option('enabled', false);
                document.getElementById(this._id + "_opacity").disabled = true;
                $('#' + this._id + "_opacity").addClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = true;
                $('#' + this._id + "_author_input").addClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = true;
                $('#' + this._id + "_subject_input").addClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.disable();
            } else {
                this._colorpickerObject.option('enabled', true);
                document.getElementById(this._id + "_opacity").disabled = false;
                $('#' + this._id + "_opacity").removeClass("e-disable");
                document.getElementById(this._id + "_author_input").disabled = false;
                $('#' + this._id + "_author_input").removeClass("e-disable");
                document.getElementById(this._id + "_subject_input").disabled = false;
                $('#' + this._id + "_subject_input").removeClass("e-disable");
                var sliderObject = $("#" + this._id + "_slider").data("ejSlider");
                sliderObject.enable();
            }
        },

        _setDrawColor: function (event) {
            if (this._isDefaultColorSet) {
                this._drawColor = this._toolbarColorpickerObject.hexCodeToRGB(event.value);
                document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                this._isToolbarColorPicker = false;
                this._isDefaultColorSet = false;
            }
        },

        _createNote: function () {
            var pageviewcontainer = $('#' + this._id + '_viewerContainer');
            var note = ej.buildTag("div.e-pdfviewer-annotation-note", "", { 'display': 'none' }, { "id": this._id + '_popup_note' });
            var authorcontent = ej.buildTag("div.e-pdfviewer-annotation-authorcontent", "", {}, { "id": this._id + '_author_content' });
            var notecontent = ej.buildTag("div.e-pdfviewer-annotation-notecontent", "", {}, { "id": this._id + '_note_content' });
            note.append(authorcontent);
            note.append(notecontent);
            pageviewcontainer.append(note);
        },

        _createPopupMenu: function () {
            var pageviewcontainer = $('#' + this._id + '_viewerContainer');
            var popupmenu = document.createElement("DIV");
            popupmenu.id = this._id + "_popupmenu";
            popupmenu.className = "e-pdfviewer-popupmenu";
            pageviewcontainer.append(popupmenu);
            var popupHeader = document.createElement("DIV");
            popupHeader.className = "e-pdfviewer-header"
            popupHeader.id = this._id + "_popupheader";
            popupmenu.appendChild(popupHeader);
            var userName = document.createElement("DIV");
            userName.className = "e-pdfviewer-username";
            userName.id = this._id + "_username";
            userName.innerHTML = "Guest";
            popupHeader.appendChild(userName);
            var closeIconContainer = ej.buildTag("div.e-pdfviewer-closepopup", "", {}, { "id": this._id + '_popup_close' });
            var closeIcon = ej.buildTag("span.e-pdfviewer-icon e-pdfviewer-closeicon");
            closeIconContainer[0].appendChild(closeIcon[0]);
            popupHeader.appendChild(closeIconContainer[0]);
            var proxy = this;
            $('.e-pdfviewer-closeicon').on("click touchend", function () {
                proxy._saveNote();
                $('.e-pdfviewer-popupmenu').hide();
                proxy._isPopupNoteVisible = false;
            });
            var timeDivContainer = document.createElement("DIV");
            var timeDiv = document.createElement("DIV");
            timeDivContainer.className = "e-pdfviewer-currenttime";
            timeDiv.id = this._id + "_currentTime";
            var d = new Date();
            timeDiv.innerHTML = d.toLocaleString();
            timeDivContainer.appendChild(timeDiv);
            popupmenu.appendChild(timeDivContainer);
            var popupContent = document.createElement("DIV");
            popupContent.className = "e-pdfviewer-content";
            popupContent.id = this._id + "_popupcontent";
            var popupInnerContent = document.createElement("DIV");
            popupInnerContent.className = "e-pdfviewer-innercontent";
            popupInnerContent.id = this._id + "_popupinnercontent";
            popupInnerContent.innerText = " ";
            popupInnerContent.style.width = "366.667px";
            popupInnerContent.style.height = "132.073px";
            popupInnerContent.style.overflow = "hidden";
            popupInnerContent.style.overflowY = "auto";
            popupContent.appendChild(popupInnerContent);
            popupmenu.appendChild(popupContent);
            var popupFooter = document.createElement("DIV");
            popupFooter.className = "e-pdfviewer-footer";
            popupFooter.id = this._id + "_popupfooter";
            popupmenu.appendChild(popupFooter);
            var popupNote = document.getElementById(this._id + "_popupmenu");
            popupInnerContent.addEventListener("paste", function (e) {
                e.preventDefault();
                var text = e.clipboardData.getData("text/plain");
                document.execCommand("insertHTML", false, text);
            });
            this._on($(popupNote), "mousedown touchstart", this._popupNoteMousedown);
            this._on($(popupNote), "mouseup touchend", this._popupNoteMouseup);
            this._on($(window), "touchmove mousemove", this._movePopupNote);
        },
      _popupNoteMousedown: function (e) {
            if (e.type == "touchstart")
                e = e.originalEvent.changedTouches[0];
            if (e.which != 3 || e.type == "touchstart") {
                this._isPopupNoteFocused = true;
                var popupNote = document.getElementById(this._id + "_popupmenu");
                this._xpos = e.clientX - popupNote.offsetLeft;
                this._ypos = e.clientY - popupNote.offsetTop;
            }
        },
        _popupNoteMouseup: function (e) {
            this._enableSelection();
            this._isPopupNoteFocused = false;
        },
        _movePopupNote: function (e) {
            if (e.type == "touchmove")
                e = e.originalEvent.changedTouches[0];
            if (this._isPopupNoteFocused || e.type == "touchmove") {
                var viewer = document.getElementById(this._id + '_viewerContainer');
                var popupNote = document.getElementById(this._id + "_popupmenu");
                this._isContextMenuPresent = true;
                var leftValue = (e.clientX - this._xpos);
                var topValue = (e.clientY - this._ypos);
                var isInPosition = this._calulateCurrentPosition(topValue, popupNote);
                var width = parseFloat($(popupNote).css("width"));
                var height = parseFloat($(popupNote).css("height"));
                if (leftValue > 0 && (leftValue + width) <= viewer.clientWidth)
                    popupNote.style.left = leftValue + 'px';
                if (isInPosition)
                    popupNote.style.top = (topValue) + 'px';
            }
        },
        _calulateCurrentPosition: function (topVal, popupNote) {
            var cummulativeValue;
            var cummulativePageHeight = 5;
            var height = parseFloat($(popupNote).css("height"));
            for (var i = 1; i <= this._totalPages; i++) {
                var pageBottom = this._pageSize[i - 1].PageHeight * this._zoomVal;
                if (i == this._AnnotationPage) {
                    if (topVal > cummulativePageHeight && (topVal + height) < pageBottom + cummulativePageHeight)
                        cummulativeValue = cummulativePageHeight;
                }
                cummulativePageHeight += pageBottom;
            }
            if (cummulativeValue)
                return true;
        },
        _createPropertiesMenu: function (e) {
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var container = document.createElement("div");
            container.id = this._id + "_containerDialogTab";
            var ejtabContainer = document.createElement("div");
            var ejtab = ej.buildTag("div", "", { "height": "auto" }, { "id": this._id + "_PropertiesDialogTab" });
            var ul = document.createElement("ul");
            ul.innerHTML = "<li id= '" + this._id + "_appearanceli" + "'><a href=" + "#" + this._id + "_apperanceProperties" + ">Appearance</a></li><li id= '" + this._id + "_generalli" + "'><a href=" + "#" + this._id + "_generalProperties" + ">General</a></li>";
            var apperanceProperty = ej.buildTag("div", "", {}, { "id": this._id + "_apperanceProperties" });
            var generalProperty = ej.buildTag("div", "", {}, { "id": this._id + "_generalProperties" });
            ejtabContainer.appendChild(ejtab[0]);
            ejtab[0].appendChild(ul);
            ejtab[0].appendChild(apperanceProperty[0]);
            ejtab[0].appendChild(generalProperty[0]);
            var applyProperties = document.createElement("div");
            applyProperties.style.paddingBottom = "11px";
            var ok = ej.buildTag("button.e-pdfviewer-properties-okbtn", "OK", { "float": "right", "margin-right": "18px" }, { "id": this._id + "_ok", });
            var cancel = ej.buildTag("button.e-pdfviewer-properties-cancelbtn", "Cancel", { "float": "right" }, { "id": this._id + "_cancel", });
            var lockedCheckbox = ej.buildTag("input", "", {}, { 'type': 'checkbox' });
            var lockedContent = document.createElement("label");
            lockedContent.id = this._id + "_lockedprop";
            lockedContent.className = "e-pdfviewer-properties-label";
            lockedContent.style.marginRight = "18px";
            lockedContent.innerHTML = "Locked";
            applyProperties.appendChild(lockedCheckbox[0]);
            applyProperties.appendChild(lockedContent);
            applyProperties.appendChild(cancel[0]);
            applyProperties.appendChild(ok[0]);
            lockedCheckbox.ejCheckBox({ cssClass: 'e-pdfviewer-lockedcheckbox', id: this._id + '_lockedcheckbox', size: ej.CheckboxSize.Small, change: $.proxy(this._lockProperties, this) });
            apperanceProperty[0].style.height = "300px";
            generalProperty[0].style.height = "300px";
            ejtabContainer.appendChild(applyProperties);
            container.appendChild(ejtabContainer);
            pageviewcontainer.append(container);
            ok.ejButton({ showRoundedCorner: true, size: "small" });
            cancel.ejButton({ showRoundedCorner: true, size: "small" });
            $("#" + this._id + "_PropertiesDialogTab").ejTab({});
            var width = this.element.width();
            if (width >= 500)
                $('#' + this._id + "_containerDialogTab").ejDialog({ showOnInit: false, width: "500px", enableResize: false, close: $.proxy(this._closePropertiesWindow, this), backgroundScroll: false, enableModal: true });
            else
                $('#' + this._id + "_containerDialogTab").ejDialog({ showOnInit: false, width: "auto", enableResize: false, close: $.proxy(this._closePropertiesWindow, this), backgroundScroll: false, enableModal: true });
            var table = document.createElement('div');
            var tableRow1 = document.createElement("div");
            tableRow1.className = "e-pdfviewer-color-container";
            table.appendChild(tableRow1);
            var tableData1 = document.createElement("div");
            tableData1.className = "e-pdfviewer-color-span";
            var tableData2 = document.createElement("div");
            tableData2.className = "e-pdfviewer-color-picker";
            tableRow1.appendChild(tableData1);
            tableRow1.appendChild(tableData2);
            var colorSpan = document.createElement("SPAN");
            colorSpan.id = this._id + "_colorspan";
            colorSpan.innerHTML = "Color:";
            tableData1.appendChild(colorSpan);
            var input = document.createElement("input");
            input.type = "text";
            input.id = this._id + "_colorpicker";
            tableData2.appendChild(input);
            var tableRow2 = document.createElement("div");
            tableRow2.className = "e-pdfviewer-opacity-container";
            table.appendChild(tableRow2);
            var tableData3 = document.createElement("div");
            tableData3.className = "e-pdfviewer-opacity-span";
            var tableData4 = document.createElement("div");
            tableData4.className = "e-pdfviewer-opacity-field";
            tableRow2.appendChild(tableData3);
            tableRow2.appendChild(tableData4);
            var opacity = document.createElement("SPAN");
            opacity.id = this._id + "_opacityspan";
            opacity.innerHTML = "Opacity:";
            tableData3.appendChild(opacity);
            var opacityInput = document.createElement("input");
            opacityInput.type = "text";
            opacityInput.id = this._id + "_opacity";
            opacityInput.className = "e-inputchangeval"
            opacityInput.value = "100%"
            opacityInput.style.width = "50px";
            opacityInput.style.height = "20px";
            tableData4.appendChild(opacityInput);
            var sliderData = document.createElement("div");
            sliderData.className = "e-pdfviewer-slider-control";
            sliderData.style.width = "100px";
            tableRow2.appendChild(sliderData);
            var slider = document.createElement("DIV");
            slider.id = this._id + "_slider";
            sliderData.appendChild(slider);
            apperanceProperty.append(table);
            $("#" + this._id + "_colorpicker").ejColorPicker({ modelType: "palette" });
            $("#" + this._id + "_colorpicker").ejColorPicker("hide");
            this._colorpickerObject = $("#" + this._id + "_colorpicker").data("ejColorPicker");
            $("#" + this._id + "_slider").ejSlider({
                cssClass: 'e-pdfviewer-opacity-slider',
                value: 100,
                minValue: 0,
                maxValue: 100,
                incrementStep: 1,
                showRoundedCorner: true,
                change: this._slidervaluechange,
                slide: this._slidervaluechange,
            });
            var generalTable = document.createElement('div');
            generalTable.style.border = "0px";
            var generalTableRow = document.createElement("div");
            generalTableRow.className = "e-pdfviewer-author-container";
            generalTable.appendChild(generalTableRow);
            var authorData = document.createElement("div");
            authorData.className = "e-pdfviewer-author-span";
            generalTableRow.appendChild(authorData);
            var author = document.createElement("SPAN");
            author.id = this._id + "_authorspan";
            author.innerHTML = "Author:";
            authorData.appendChild(author);
            var authorinput = document.createElement("div");
            authorinput.className = "e-pdfviewer-author-inputdiv";
            generalTableRow.appendChild(authorinput);
            var authorinputValue = document.createElement("input");
            authorinputValue.id = this._id + "_author_input";
            authorinputValue.className = "e-pdfviewer-author-input";
            authorinput.appendChild(authorinputValue);
            var generalTableRow2 = document.createElement("div");
            generalTableRow2.className = "e-pdfviewer-subject-container";
            generalTable.appendChild(generalTableRow2);
            var subjectData = document.createElement("div");
            subjectData.className = "e-pdfviewer-subject-span";
            generalTableRow2.appendChild(subjectData);
            var subject = document.createElement("SPAN");
            subject.id = this._id + "_subjectspan";
            subject.innerHTML = "Subject:";
            subjectData.appendChild(subject);
            var subjectinput = document.createElement("div");
            subjectinput.className = "e-pdfviewer-subject-inputdiv";
            generalTableRow2.appendChild(subjectinput);
            var subjectValue = document.createElement("input");
            subjectValue.id = this._id + "_subject_input";
            subjectValue.className = "e-pdfviewer-subject-input";
            subjectinput.appendChild(subjectValue);
            var generalTableRow3 = document.createElement("div");
            generalTableRow3.className = "e-pdfviewer-modifieddate-container";
            generalTableRow3.style.height = "18.67px";
            generalTable.appendChild(generalTableRow3);
            var modifiedlabeldiv = document.createElement("div");
            modifiedlabeldiv.className = "e-pdfviewer-modified-labeldiv";
            var modifiedlabel = document.createElement("SPAN");
            modifiedlabel.id = this._id + "_modifiedspan";
            modifiedlabel.innerHTML = "Modified:";
            modifiedlabeldiv.appendChild(modifiedlabel);
            generalTableRow3.appendChild(modifiedlabeldiv);
            var datelabeldiv = document.createElement("div");
            datelabeldiv.className = "e-pdfviewer-modifieddate-labeldiv";
            datelabeldiv.id = this._id + "_modifieddate";
            var modifieddatelabel = document.createElement("SPAN");
            modifieddatelabel.innerHTML = "";
            datelabeldiv.appendChild(modifieddatelabel);
            generalTableRow3.appendChild(datelabeldiv);

            generalProperty.append(generalTable);
            $("#" + this._id + "_containerDialogTab_title").addClass("e-pdfviewer-propertiestitle");
            $("#" + this._id + "_containerDialogTab").addClass("e-pdfviewer-propertiestab");
            $("#" + this._id + "_PropertiesDialogTab").addClass("e-pdfviewer-innertab");
            $("#" + this._id + "_apperanceProperties").addClass("e-pdfviewer-appearanceprop");
            $("#" + this._id + "_generalProperties").addClass("e-pdfviewer-generalprop");
            $("#" + this._id + "_appearanceli").addClass("e-pdfviewer-tab-li");
            $("#" + this._id + "_generalli").addClass("e-pdfviewer-tab-li");
            $(opacityInput).addClass("e-pdfviewer-elementalignments");
            $(opacityInput).addClass("ejinputtext");
            $(authorinputValue).addClass("e-pdfviewer-elementalignments");
            $(authorinputValue).addClass("ejinputtext");
            $(subjectValue).addClass("e-pdfviewer-elementalignments");
            $(subjectValue).addClass("ejinputtext");
            this._tabObject = $("#" + this._id + "_PropertiesDialogTab").data("ejTab");
            this._on($('#' + this._id + '_ok'), "click", this._applyAnnotationProperties);
            this._on($('#' + this._id + '_cancel'), "click", this._cancelAnnotationProperties);
        },
        _applyAnnotationProperties: function () {
            var tab = this._tabObject;
            var color = this._colorpickerObject.rgb;
            var opacity = parseInt($("#" + this._id + '_opacity').val().split("%")[0]) / 100;
            var authorName = $("#" + this._id + '_author_input').val();
            var subject = $("#" + this._id + '_subject_input').val();
            var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
            this._changeAnnotationProperties(color, opacity, authorName, subject, annotDetails.currentAnnotationIndex, this._AnnotationPage, annotDetails.isExistingAnnotation);
            $('#' + this._id + '_containerDialogTab').ejDialog("close");
        },
        _cancelAnnotationProperties: function () {
            $('#' + this._id + '_containerDialogTab').ejDialog("close");
        },
        _getAnnotation: function (currentAnnotationRect, pageIndex) {
            var annotList = this._textMarkupAnnotationList[pageIndex];
            var currentAnnotations = [];
            var currentAnnotationIndex = null;
            var isExistingAnnotation = false;
            for (var a = 0; a < currentAnnotationRect.length; a++) {
                if (annotList) {
                    for (var i = 0; i < annotList.length; i++) {
                        if (currentAnnotationRect[a] == annotList[i]) {
                            currentAnnotations.push(annotList[i]);
                            currentAnnotationIndex = i;
                            isExistingAnnotation = true;
                        }
                    }
                }
            }
            annotList = this._newAnnotationList[pageIndex - 1];
            var currentAnnot;
            for (var a = 0; a < currentAnnotationRect.length; a++) {
                if (annotList) {
                    for (var j = 0; j < annotList.length; j++) {
                        if (currentAnnotationRect[a] == annotList[j]) {
                            currentAnnotations.push(annotList[j]);
                            currentAnnotationIndex = j;
                            isExistingAnnotation = false;
                            currentAnnot = annotList[j];
                        }
                    }
                }
                if (currentAnnotationRect[a] == currentAnnot)
                    break;
            }
            this._currentAnnotations = currentAnnotations;
            return { currentAnnotationIndex: currentAnnotationIndex, isExistingAnnotation: isExistingAnnotation };
        },
        _changeAnnotationProperties: function (color, opacity, author, subject, currentAnnotationIndex, pageIndex, isExistingAnnotation) {
            var secCanvas = document.getElementById(this._id + "_secondarycanvas_" + pageIndex);
            if (secCanvas && !this._tempCanvas) {
                var context = secCanvas.getContext("2d");
                context.clearRect(0, 0, secCanvas.width, secCanvas.height);
                this._selectedAnnotationObject = null;
                var isColorChanged = false;
                var isOpacityChanged = false;
                var annotationType, annotationId;
                var args = new Object();
                var date = new Date();
                this._drawAnnotSelectRect(pageIndex, this._currentAnnotationRectangleBackup);
            }
            if (this._tempCanvas) {
                var opacityChanged=false, colorChanged=false;
                var signatureCanvas = this._tempCanvas;
                var signatureContext = signatureCanvas.getContext("2d");
                var previousstrokeStyle = signatureContext.strokeStyle;
                var previousOpacity = $(signatureCanvas).css("opacity");

                signatureContext.strokeStyle = "rgb(" + color.r + "," + color.g + "," + color.b + ")";
                signatureContext.stroke();
                $(signatureCanvas).css("opacity", opacity);
                if (previousOpacity != opacity) {
                    opacityChanged = true;
                }
                if (previousstrokeStyle != signatureContext.strokeStyle) {
                    colorChanged = true;
                }
                if (opacityChanged || colorChanged) {
                    var args = new Object();
                    args.isColorChange = colorChanged;
                    args.isOpacityChange = opacityChanged;
                    args.signatureID = this._tempCanvas.id;
                    args.currentColor = signatureContext.strokeStyle;
                    args.perviousColor = previousstrokeStyle;
                    args.previousOpacity = previousOpacity;
                    args.currentOpacity = opacity;
                    args.pageId = parseInt(this._tempCanvas.id.split("imagecanvasDraw_")[1].split('_')[0]);
                    this._raiseClientEvent('signaturePropertiesChange', args);
                }
                var recentOp = {
                    operation: "SignatureModifed",
                    pageNumber: this._currentPage,
                    sign: signatureCanvas,
                    newstrokeStyle: signatureContext.strokeStyle,
                    newsopacity: $(signatureCanvas).css("opacity"),
                    previousstrokeStyle: previousstrokeStyle,
                    previousOpacity: previousOpacity,
                }
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                this._recentOperation.push(recentOp);
            }
            else if (isExistingAnnotation) {
                var annot = this._textMarkupAnnotationList[pageIndex][currentAnnotationIndex];
                if (annot.Color.R != color.r || annot.Color.G != color.g || annot.Color.B != color.b || annot.Opacity != opacity || annot.Author != author || annot.Subject != subject) {
                    var annotObject = new Object();
                    annotObject = JSON.parse(JSON.stringify(annot));
                    this._colorModifiedAnnotationList[pageIndex - 1].push(annotObject);
                    if (annot.Color.R != color.r || annot.Color.G != color.g || annot.Color.B != color.b) {
                        isColorChanged = true;
                    } else if (annot.Opacity != opacity) {
                        isOpacityChanged = true;
                    }
                    annot.Color.R = color.r;
                    annot.Color.G = color.g;
                    annot.Color.B = color.b;
                    annot.Color.A = color.a;
                    annot.Opacity = opacity;
                    annot.Author = author;
                    annot.Subject = subject;
                    annotationType = annot.TextMarkupAnnotationType;
                    if (annotationType == "Highlight") {
                        annot.ModifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.ModifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.ModifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    annotationId = currentAnnotationIndex;
                    this._totalAnnotations[pageIndex][currentAnnotationIndex] = JSON.parse(JSON.stringify(annot));
                    var colorAnnotObj = new Object();
                    colorAnnotObj.index = currentAnnotationIndex;
                    colorAnnotObj.annotation = annot;
                    colorAnnotObj.action = "propertyChanged";
                    this._existingAnnotationsModified[pageIndex - 1].push(colorAnnotObj);
                    var recentOp = {
                        operation: "propertiesModifiedForExistingAnnot",
                        pageNumber: this._AnnotationPage,
                        indexes: currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
                var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                if (checkboxObject.model.checkState == "check") {
                    annot.isLocked = true;
                } else {
                    annot.isLocked = false;
                }
            } else {
                var annot = this._newAnnotationList[pageIndex - 1][currentAnnotationIndex];
                if (annot.colorR != color.r || annot.colorG != color.g || annot.colorB != color.b || annot.opacity != opacity || annot.author != author || annot.subject != subject) {
                    var annotObject = new Object();
                    annotObject = JSON.parse(JSON.stringify(annot));
                    this._colorModifiedAnnotationList[pageIndex - 1].push(annotObject);
                    if (annot.colorR != color.r || annot.colorG != color.g || annot.colorB != color.b) {
                        isColorChanged = true;
                    } else if (annot.opacity != opacity) {
                        isOpacityChanged = true;
                    }
                    annot.colorR = color.r;
                    annot.colorG = color.g;
                    annot.colorB = color.b;
                    annot.opacity = opacity;
                    annot.colorA = annot.opacity * 255;
                    annot.author = author;
                    annot.subject = subject;
                    annotationType = annot.type;
                    if (annotationType == "Highlight") {
                        annot.modifiedDate = this.model.highlightSettings.modifiedDate ? this.model.highlightSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "Underline") {
                        annot.modifiedDate = this.model.underlineSettings.modifiedDate ? this.model.underlineSettings.modifiedDate : date.toLocaleString();
                    } else if (annotationType == "StrikeOut") {
                        annot.modifiedDate = this.model.strikethroughSettings.modifiedDate ? this.model.strikethroughSettings.modifiedDate : date.toLocaleString();
                    }
                    if (this._textMarkupAnnotationList[pageIndex])
                        annotationId = this._textMarkupAnnotationList[pageIndex].length + currentAnnotationIndex;
                    else
                        annotationId = currentAnnotationIndex;
                    this._totalAnnotations[pageIndex][annotationId] = JSON.parse(JSON.stringify(annot));
                    var checkboxObject = $("#" + this._id + '_lockedcheckbox').data("ejCheckBox");
                    if (checkboxObject.model.checkState == "check") {
                        annot.isLocked = true;
                    } else {
                        annot.isLocked = false;
                    }
                    var recentOp = {
                        operation: "propertiesModifiedForNewAnnot",
                        pageNumber: this._AnnotationPage,
                        indexes: currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
            }
            if (isColorChanged || isOpacityChanged) {
                args.isColorChanged = isColorChanged;
                args.isOpacityChanged = isOpacityChanged;
                args.annotationType = annotationType;
                args.annotationId = annotationId;
                args.pageId = pageIndex;
                this._raiseClientEvent('annotationPropertiesChange', args);
            }
            this._redoActions = new Array();
            for (var i = 0; i < this._totalPages; i++) {
                var newArray = [];
                this._redoAnnotationCollection[i] = newArray;
            }
            this.isDocumentEdited = true;
            if (!this._tempCanvas) {
                this._renderTextMarkupAnnotation(this._textMarkupAnnotationList[pageIndex], pageIndex);
            }
        },
        _slidervaluechange: function (sender) {
            var values = sender.value;
            var id = this._id.split('_slider')[0];
            $("#" + id + "_opacity").val(values + "%");
        },
        _deleteAnnotation: function () {
            if (this._isAnnotationSelected) {
                var pageAnnotList; var newList = [];
                var args = new Object();
                var annotDetails = this._getAnnotation(this._currentAnnotationRectangleBackup, this._AnnotationPage);
                if (annotDetails.isExistingAnnotation) {
                    pageAnnotList = this._textMarkupAnnotationList[this._AnnotationPage];
                    var annot = pageAnnotList[annotDetails.currentAnnotationIndex];
                    args.annotationType = annot.TextMarkupAnnotationType;
                    this._deletedAnnotationList[this._AnnotationPage - 1].push(annot);
                    var deletedAnnotObj = new Object();
                    deletedAnnotObj.index = annot.Index;
                    args.annotationId = annot.Index;
                    args.pageId = this._AnnotationPage;
                    deletedAnnotObj.annotation = annot;
                    deletedAnnotObj.action = "deleted";
                    this._existingAnnotationsModified[this._AnnotationPage - 1].push(deletedAnnotObj);
                    this._annotationsDeletedNo[this._AnnotationPage - 1] = this._annotationsDeletedNo[this._AnnotationPage - 1] + 1;
                    for (var i = 0; i < pageAnnotList.length; i++) {
                        if (pageAnnotList[i] != annot) {
                            newList.push(pageAnnotList[i]);
                        }
                    }
                    var recentOp = {
                        operation: "existingAnnotationDeleted",
                        pageNumber: this._AnnotationPage,
                        indexes: annotDetails.currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                    this._textMarkupAnnotationList[this._AnnotationPage] = newList;
                    this._totalAnnotations[this._AnnotationPage].splice(annotDetails.currentAnnotationIndex, 1);
                } else {
                    pageAnnotList = this._newAnnotationList[this._AnnotationPage - 1];
                    var annotation = pageAnnotList[annotDetails.currentAnnotationIndex];
                    args.annotationType = annotation.type;
                    this._deletedAnnotationList[this._AnnotationPage - 1].push(annotation);
                    this._newAnnotationList[this._AnnotationPage - 1].splice(annotDetails.currentAnnotationIndex, 1);
                    var index;
                    if (this._textMarkupAnnotationList[this._AnnotationPage])
                        index = this._textMarkupAnnotationList[this._AnnotationPage].length + annotDetails.currentAnnotationIndex;
                    else
                        index = annotDetails.currentAnnotationIndex;
                    args.annotationId = index;
                    args.pageId = this._AnnotationPage;
                    this._totalAnnotations[this._AnnotationPage].splice(index, 1);
                    var recentOp = {
                        operation: "newAnnotationDeleted",
                        pageNumber: this._AnnotationPage,
                        indexes: annotDetails.currentAnnotationIndex
                    }
                    this._recentOperation.push(recentOp);
                }
                this._redoActions = new Array();
                for (var i = 0; i < this._totalPages; i++) {
                    var newArray = [];
                    this._redoAnnotationCollection[i] = newArray;
                }
                this._raiseClientEvent("annotationRemove", args);
                this.isDocumentEdited = true;
                this._clearRectOnClick(this._AnnotationPage);
                this._isAnnotationSelected = false;
            }
            this._deleteSignatureCanvas();
        },

        _createHighlightContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "highlight-menu";
            containerDiv.className = "e-pdfviewer-highlight-menu";
            pageviewcontainer.append(containerDiv);
            var orderedList = document.createElement('ol');
            orderedList.className = 'highlightorderedList'
            containerDiv.appendChild(orderedList);
            var searchText = window.getSelection().toString();
            $(orderedList).append("<li class='popupnoteli'><a href='javascript:void(0);' class='popupnote' id = '" + this._id + "_openPopup'>Open Pop-Up Note</a></li>");
            $(orderedList).append("<li class='deleteAnnotationli'><a href='javascript:void(0);' id='" + this._id + "_deleteannot' class='deleteAnnotation'>Delete </a></li>");
            $(orderedList).append("<li class='Propertiesli'><a href='javascript:void(0);' class='Properties' id = '" + this._id + "_propAnnot'>Properties.... </a></li>");
        },

        _setPopupMenuPosition: function (event, element) {
            if (event.type == "touchstart" && element[0].id == this._id + "_popupmenu") {
                event = event.originalEvent.changedTouches[0];
            }
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = element.outerWidth();
            menuDimension.y = element.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            if (element[0].id == this._id + "_popupmenu") {
                var viewer = document.getElementById(this._id + '_viewerContainer');
                if (menuPostion.x + menuDimension.x > viewer.clientWidth) {
                    menuPostion.x = menuPostion.x - menuDimension.x / 4;
                }
            }
            return menuPostion;
        },
        _setDeleteContextMenuPostion: function (event) {
            var contextMenu = $("#" + this._id + "custom-menu");
            if (event.type == "touchstart") {
                event = event.originalEvent.changedTouches[0];
            }
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            return menuPostion;
        },
        _setHighLightContextMenuPostion: function (event) {
            var contextMenu = $("#" + this._id + "custom-menu");
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            return menuPostion;
        },

        _onViewerKeypress: function (event) {
            this._moveSignatureArrowKey(event);
            if ((event.ctrlKey && event.which == 90) || event.ctrlKey && event.keyCode == 90) {
                if (!this._isPropertiesWindowOpen)
                    this._undo();
            } else if ((event.ctrlKey && event.which ==89) || event.ctrlKey && event.keyCode == 89) {
                if (!this._isPropertiesWindowOpen)
                    this._redo();
            }
        },

        _undo: function () {
            this._removeSelector();
            var poppedItem = this._recentOperation.pop();
            if (poppedItem) {
                if (poppedItem.operation == "AddedHighlight" || poppedItem.operation == "AddedUnderline" || poppedItem.operation == "AddedStrikeOut") {
                    for (var i = 0; i < poppedItem.indexes.length; i++) {
                        var poppedAnnotation = this._newAnnotationList[poppedItem.pageNumber - 1].pop();
                        this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(poppedAnnotation);
                    }
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "propertiesModifiedForExistingAnnot" || poppedItem.operation == "propertiesModifiedForNewAnnot") {
                    this._undoModifiedProperty(poppedItem);
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "existingAnnotationDeleted" || poppedItem.operation == "newAnnotationDeleted") {
                    this._undoDeletedItem(poppedItem);
                    this._redoActions.push(poppedItem);
                }
                else if (poppedItem.operation == "signatureAdded") {
                    this._undoSignatureAdd(poppedItem);
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "signatureResized") {
                    this._undoSignatureResize(poppedItem);
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "signatureMoved") {
                    this._undoSignatureMove(poppedItem);
                    this._redoActions.push(poppedItem);
                } else if (poppedItem.operation == "signatureDeleted") {
                    this._undoSignatureDeletion(poppedItem);
                    this._redoActions.push(poppedItem);
                }
                else if (poppedItem.operation == "keyMoved") {
                    this._undoSignatureKeyMoved(poppedItem);
                    this._redoActions.push(poppedItem);
                }
                else if (poppedItem.operation == "SignatureModifed") {
                    this._undoSignatureProperties(poppedItem);
                    this._redoActions.push(poppedItem);
                }
                this._clearRectOnClick(poppedItem.pageNumber);
            }
        },
        _undoSignatureProperties: function (poppedItem) {
            var signatureCanvas = poppedItem.sign;
            var signatureContext = signatureCanvas.getContext("2d");
            signatureContext.strokeStyle = poppedItem.previousstrokeStyle;
            signatureContext.stroke();
            $(signatureCanvas).css("opacity", poppedItem.previousOpacity);
        },
        _undoModifiedProperty: function (poppedItem) {
            if (poppedItem.operation == "propertiesModifiedForExistingAnnot") {
                var annotation = this._textMarkupAnnotationList[poppedItem.pageNumber][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(annot);
                var originalItem = this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].pop();
                annotation.Color.R = originalItem.Color.R;
                annotation.Color.G = originalItem.Color.G;
                annotation.Color.B = originalItem.Color.B;
                annotation.Opacity = originalItem.Opacity;
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].pop();
            } else {
                var annotation = this._newAnnotationList[poppedItem.pageNumber - 1][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                this._redoAnnotationCollection[poppedItem.pageNumber - 1].push(annot);
                var originalItem = this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].pop();
                annotation.colorR = originalItem.colorR;
                annotation.colorG = originalItem.colorG;
                annotation.colorB = originalItem.colorB;
                annotation.opacity = originalItem.opacity;
                annotation.colorA = originalItem.colorA;
            }
        },

        _undoDeletedItem: function (poppedItem) {
            if (poppedItem.operation == "existingAnnotationDeleted") {
                var annotation = this._deletedAnnotationList[poppedItem.pageNumber - 1].pop();
                this._textMarkupAnnotationList[poppedItem.pageNumber].splice(poppedItem.indexes, 0, annotation);
                this._totalAnnotations[poppedItem.pageNumber].splice(poppedItem.indexes, 0, annotation);
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].pop();
            } else {
                var annotation = this._deletedAnnotationList[poppedItem.pageNumber - 1].pop();
                var newList = this._newAnnotationList[poppedItem.pageNumber - 1].splice(poppedItem.indexes, 0, annotation);
                var index;
                if (this._textMarkupAnnotationList[poppedItem.pageNumber])
                    index = this._textMarkupAnnotationList[poppedItem.pageNumber].length + poppedItem.indexes;
                else
                    index = poppedItem.indexes;
                this._totalAnnotations[poppedItem.pageNumber].splice(index, 0, annotation);
            }
        },
        _undoSignatureAdd: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            $(canvas).remove();
        },

        _undoSignatureDeletion: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            var pageDiv = document.getElementById(this._id + 'pageDiv_' + poppedItem.pageNumber);
            pageDiv.appendChild(canvas);
        },
        _undoSignatureMove: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.initialCoordinates) {
                canvas.style.left = poppedItem.initialCoordinates.left + 'px';
                canvas.style.top = poppedItem.initialCoordinates.top + 'px';
            }
        },
        _undoSignatureKeyMoved: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.keyinitialCoordinates) {
                canvas.style.left = poppedItem.keyinitialCoordinates.left + 'px';
                canvas.style.top = poppedItem.keyinitialCoordinates.top + 'px';
            }
        },
        _undoSignatureResize: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.initialSize) {
                canvas.style.height = poppedItem.initialSize.height + 'px';
                canvas.style.width = poppedItem.initialSize.width + 'px';
            }
        },
        _redo: function () {
            this._removeSelector();
            var poppedItem = this._redoActions.pop();
            if (poppedItem) {
                this._recentOperation.push(poppedItem);
                if (poppedItem.operation == "AddedHighlight" || poppedItem.operation == "AddedUnderline" || poppedItem.operation == "AddedStrikeOut") {
                    for (var i = 0; i < poppedItem.indexes.length; i++) {
                        var poppedAnnotation = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                        this._newAnnotationList[poppedItem.pageNumber - 1].push(poppedAnnotation);
                    }
                } else if (poppedItem.operation == "propertiesModifiedForExistingAnnot" || poppedItem.operation == "propertiesModifiedForNewAnnot") {
                    this._redoModifiedProperty(poppedItem);
                } else if (poppedItem.operation == "existingAnnotationDeleted" || poppedItem.operation == "newAnnotationDeleted") {
                    this._redoDeletedItem(poppedItem);
                }
                else if (poppedItem.operation == "signatureAdded") {
                    this._redoSignatureAdd(poppedItem);
                } else if (poppedItem.operation == "signatureResized") {
                    this._redoSignatureResize(poppedItem);
                } else if (poppedItem.operation == "signatureMoved") {
                    this._redoSignatureMove(poppedItem);
                } else if (poppedItem.operation == "signatureDeleted") {
                    this._redoSignatureDelete(poppedItem);
                }
                else if (poppedItem.operation == "keyMoved") {
                    this._redoSignatureKeyMoved(poppedItem);
                }
                else if (poppedItem.operation == "SignatureModifed") {
                    this._redoSignatureProperties(poppedItem);
                }
                this._clearRectOnClick(poppedItem.pageNumber);
            }
        },
        _redoSignatureProperties: function (poppedItem) {
            var signatureCanvas = poppedItem.sign;
            var signatureContext = signatureCanvas.getContext("2d");
            signatureContext.strokeStyle = poppedItem.newstrokeStyle;
            signatureContext.stroke();
            $(signatureCanvas).css("opacity", poppedItem.newsopacity);
        },
        _redoModifiedProperty: function (poppedItem) {
            if (poppedItem.operation == "propertiesModifiedForExistingAnnot") {
                var annotation = this._textMarkupAnnotationList[poppedItem.pageNumber][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                var originalItem = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].push(annot);
                annotation.Color.R = originalItem.Color.R;
                annotation.Color.G = originalItem.Color.G;
                annotation.Color.B = originalItem.Color.B;
                annotation.Opacity = originalItem.Opacity;
                var colorAnnotObj = new Object();
                colorAnnotObj.index = poppedItem.indexes;
                colorAnnotObj.annotation = annotation;
                colorAnnotObj.action = "propertyChanged";
                this._existingAnnotationsModified[poppedItem.pageNumber - 1].push(colorAnnotObj);
            } else {
                var annotation = this._newAnnotationList[poppedItem.pageNumber - 1][poppedItem.indexes];
                var annot = JSON.parse(JSON.stringify(annotation));
                var originalItem = this._redoAnnotationCollection[poppedItem.pageNumber - 1].pop();
                this._colorModifiedAnnotationList[poppedItem.pageNumber - 1].push(annot);
                annotation.colorR = originalItem.colorR;
                annotation.colorG = originalItem.colorG;
                annotation.colorB = originalItem.colorB;
                annotation.opacity = originalItem.opacity;
                annotation.colorA = originalItem.colorA;
            }
        },

        _redoDeletedItem: function (poppedItem) {
            if (poppedItem.operation == "existingAnnotationDeleted") {
                var pageAnnotList = this._textMarkupAnnotationList[poppedItem.pageNumber];
                var annotation = pageAnnotList[poppedItem.indexes];
                this._deletedAnnotationList[poppedItem.pageNumber - 1].push(annotation);
                this._textMarkupAnnotationList[poppedItem.pageNumber].splice(poppedItem.indexes, 1);
                this._totalAnnotations[poppedItem.pageNumber].splice(poppedItem.indexes, 1);
            } else {
                var pageAnnotList = this._newAnnotationList[poppedItem.pageNumber - 1];
                var annotation = pageAnnotList[poppedItem.indexes];
                this._deletedAnnotationList[poppedItem.pageNumber - 1].push(annotation);
                this._newAnnotationList[poppedItem.pageNumber - 1].splice(poppedItem.indexes, 1);
                var index;
                if (this._textMarkupAnnotationList[poppedItem.pageNumber])
                    index = this._textMarkupAnnotationList[poppedItem.pageNumber].length + poppedItem.indexes;
                else
                    index = poppedItem.indexes;
                this._totalAnnotations[poppedItem.pageNumber].splice(index, 1);
            }
        },
        _redoSignatureAdd: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            var pageDiv = document.getElementById(this._id + 'pageDiv_' + poppedItem.pageNumber);
            pageDiv.appendChild(canvas);
        },

        _redoSignatureDelete: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            $(canvas).remove();
        },

        _redoSignatureMove: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.Coordinates) {
                canvas.style.left = poppedItem.Coordinates.left + 'px';
                canvas.style.top = poppedItem.Coordinates.top + 'px';
            }
        },
        _redoSignatureKeyMoved: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.Coordinates) {
                canvas.style.left = poppedItem.Coordinates.left + 'px';
                canvas.style.top = poppedItem.Coordinates.top + 'px';
            }
        },
        _redoSignatureResize: function (poppedItem) {
            var canvas = poppedItem.signCanvas;
            if (poppedItem.size) {
                canvas.style.height = poppedItem.size.height;
                canvas.style.width = poppedItem.size.width;
            }
        },
        _displayColorPicker: function (type) {
            var colorPicker = document.getElementById(this._id + '_pdfviewer_colorpicker');
            if ($(colorPicker).css('display') == 'none' && !this._isToolbarColorPicker) {
                colorPicker.style.display = 'block';
                this._isToolbarColorPicker = true;
                if (this._colorPickerStatus != type) {
                    this._drawColor = null;
                    if (type == "Highlight")
                        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
                    else if (type == "Underline")
                        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
                    else if (type == "StrikeOut")
                        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
                }
                this._colorPickerStatus = type;
                this._isDefaultColorSet = true;
            } else {
                if (this._colorPickerStatus == type) {
                    colorPicker.style.display = 'none';
                    this._isToolbarColorPicker = false;
                } else {
                    if (type == "Highlight")
                        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
                    else if (type == "Underline")
                        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
                    else if (type == "StrikeOut")
                        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
                    this._colorPickerStatus = type;
                    this._isDefaultColorSet = true;
                }
            }
        },

        _setPickerPosition: function (liItem) {
            var toolbar = $('#' + this._id + '_toolbarContainer');
            this._toolbarColorpickerObject.refresh();
            var colorPicker = document.getElementById(this._id + '_pdfviewer_colorpicker');
            var pickerPosition = colorPicker.getBoundingClientRect();
            if ($('#' + this._id + '_pdfviewer_textmarkupul').parent()[0] == toolbar[0]) {
                colorPicker.style.top = "0px";
                colorPicker.style.left = (liItem.parentNode.offsetLeft + liItem.offsetLeft - toolbar[0].offsetLeft - pickerPosition.width + liItem.clientWidth) + 'px';
            } else {
                var secondaryToolbar = document.getElementById(this._id + '_toolbarContainer_hiddenlist');
                secondaryToolbarPosition = secondaryToolbar.getBoundingClientRect();
                var btnLiPosition = document.getElementById(this._id + '_pdfviewer_textmarkupul').getBoundingClientRect();
                colorPicker.style.top = secondaryToolbarPosition.bottom - btnLiPosition.bottom + "px";
                colorPicker.style.left = (liItem.parentNode.parentNode.offsetLeft - toolbar[0].offsetLeft + liItem.offsetLeft - pickerPosition.width + liItem.clientWidth) + 'px';
            }
        },
        _showSignatureButtons: function (show) {
            if (show) {
                $('#' + this._id + '_pdfviewer_signatureul').css("display", "block");
                $('#' + this._id + '_pdfviewer_textmarkupul').addClass('e-separator');
                this._isSignatureHidden = false;
            }
            else {
                $('#' + this._id + '_pdfviewer_signatureul').css("display", "none");
                $('#' + this._id + '_pdfviewer_textmarkupul').removeClass('e-separator');
                this._isSignatureHidden = true;
            }
        },
        _showTextMarkupButtons: function (show) {
            if (show) {
                $('#' + this._id + '_pdfviewer_textmarkupul').css("display", "block");
                $('#' + this._id + '_pdfviewer_zoomul').addClass('e-separator');
            }
            else {
                $('#' + this._id + '_pdfviewer_textmarkupul').css("display", "none");
                $('#' + this._id + '_pdfviewer_zoomul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_colorpicker').css("display", "none");
                this._isToolbarColorPicker = false;
            }
        },

        //-------------------------------Text Markup Annotation [end] ---------------------------//
        //-------------------- Toolbar Actions[Start] -------------------------//
        _wireEvents: function () {
            var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
            var is_firefox = navigator.userAgent.indexOf('Firefox') != -1;
            var is_safari = navigator.userAgent.indexOf("Safari") != -1;
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            var isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
            var proxy = this;

            if (!this.model.toolbarSettings.templateId) {
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._allowOnlyNumbers);
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._on($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._on($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._on($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
                this._on($('#' + this._id + '_toolbarContainer'), "mousedown", this._onToolBarContainerMouseDown);
                this._on($('.e-pdfviewer-ejdropdownlist'), "mousedown", this._onToolBarContainerMouseDown);
                this._on($('#' + this._id + '_viewerContainer'), "mousewheel", this._onContainerScroll);
                    if (document.documentMode || is_ie) {
                        this._on($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                        this._on($('#' + this._id + '_viewerContainer'), "dblclick", this._selectingTextOnDblClick);
                        this._on($('#' + this._id + '_viewerContainer'), "click", this._selectingTextOnClick);
                    }
                    else if (!is_edgeNew) {
                        if (is_firefox) {
                            this._on($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                            this._on($('#' + this._id + '_viewerContainer'), "touchstart", this._onTextContainerTouch);
                            this._on($('#' + this._id + '_viewerContainer'), "touchmove", this._onTextContainerTouchMove);
                            this._on($('#' + this._id + '_viewerContainer'), "touchend", this._onTextContainerTouchEnd);
                        }
                        else if (is_chrome || isMobile) {
                            this._on($('#' + this._id + '_viewerContainer'), "touchstart", this._onTextContainerTouch);
                            this._on($('#' + this._id + '_viewerContainer'), "touchmove", this._onTextContainerTouchMove);
                            this._on($('#' + this._id + '_viewerContainer'), "touchend", this._onTextContainerTouchEnd);
                        }
                        this._on($('#' + this._id + '_viewerContainer'), "mouseleave", this._onTextContainerMouseLeave);
                        this._on($('#' + this._id + '_viewerContainer'), "mouseenter", this._onTextContainerMouseEnter);
                        this._on($('#' + this._id + '_viewerContainer'), "mouseover", this._onTextContainerMouseIn);
                        this._on($('#' + this._id + '_viewerContainer'), "dragstart", this._onTextContainerDragStart);
                    }
                    if (is_chrome || is_firefox || is_ie || is_edge || is_edgeNew || isMobile) {
                        this._on($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
                        this._on($('#' + this._id + '_viewerContainer'), "mousemove", this._onTextContainerMouseMove);
                        this._on($('#' + this._id + '_viewerContainer'), "mousedown", this._onTextContainerMouseDown);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.copy", this._copySelectedText);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.googleSearch", this._openInNewTab);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.e-highlight-text", this._drawHighlightAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.e-strikeout-text", this._drawStrikeOutAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.deleteAnnotation", this._deleteAnnotation);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.popupnote", this._showPopupMenu);
                        this._on($('#' + this._id + '_pageviewContainer'), "click touchstart", "a.Properties", this._showPropertiesMenu);
                        this._on($('#' + this._id + '_pageviewContainer'), "contextmenu", this._onTextContainerMouseUp);
                        this._on($('#' + this._id + '_viewerContainer'), "click", this._onTextContainerclick);
                    }
                    else if (is_safari) {
                        this._on($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
                        this._on($('#' + this._id + '_viewerContainer'), "mousemove", this._onTextContainerMouseMove);
                        this._on($('#' + this._id + '_viewerContainer'), "mousedown", this._onTextContainerMouseDown);
                    }
            }
            $(window).on("keydown", function (e) {
                proxy._onViewerKeypress(e);
                if (e.ctrlKey && (e.keyCode == 65 || e.keyCode == 97)) {
                    e.preventDefault();
                } else if (e.keyCode == 46) {
                    if (proxy._currentAnnotationRectangleBackup.length != 0 && !proxy._isPropertiesWindowOpen && !proxy._isPopupNoteVisible) {
                        proxy._deleteAnnotation();
                        $("#" + proxy._id + "_popupmenu").hide();
                        proxy._isPopupNoteVisible = false;
                    }
                }
            });
            var viewer = document.getElementById(this._id + '_viewerContainer');
            $('#' + this._id + '_viewerContainer').css({ 'touch-action': 'pan-x pan-y' });
            $('#' + this._id + '_pdfviewerContainer').css({ 'touch-action': 'pan-x pan-y', 'position': 'relative' });
            if (navigator.userAgent.match("Firefox") || navigator.userAgent.match("Chrome")) {
                if (viewer) {
                    viewer.addEventListener('touchstart', this._touchStart);
                    viewer.addEventListener('touchmove', this._touchMove);
                    viewer.addEventListener('touchleave', this._touchEnd);
                    viewer.addEventListener('touchend', this._touchEnd);
                    viewer.addEventListener('touchcancel', this._touchEnd);
                }
            }
            //Wire search events
            this._on($('#' + this._id + '_pdfviewer_searchinput'), 'input', this._textSearch);
            this._on($('#' + this._id + '_pdfviewer_searchinput'), 'keypress', this._searchKeypressHandler);
            this._on($('#' + this._id + '_pdfviewer_previous_search'), 'click', this._prevSearch);
            this._on($('#' + this._id + '_pdfviewer_next_search'), 'click', this._nextSearch);
            this._on($('#' + this._id + '_pdfviewer_close_search'), "click ", this._displaySearchBox);
            //Wire search events
            this._on($('#' + this._id + '_viewerContainer'), 'pointerdown', this._pointerdown);
            this._on($('#' + this._id + '_viewerContainer'), 'pointermove', this._pointermove);
            this._on($('#' + this._id + '_viewerContainer'), 'pointerup', this._pointerup);
            this._on($('#' + this._id + '_viewerContainer'), 'pointerleave', this._pointerup);
            this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseover", this._showIconToolTip);
            this._on($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseout", this._hideIconToolTip);
            this._on($('#' + this._id + '_pdfviewer_findlabel, #' + this._id + '_pdfviewer_matchlabel'), 'mouseover', this._showLocalizationTooltip);
            this._on($('#' + this._id + '_pdfviewer_findlabel, #' + this._id + '_pdfviewer_matchlabel'), 'mouseout', this._hideLocalizationTooltip);
            this._on($('.e-pdfviewer-toolbarli-label'), 'mousedown', this._preventClick);
            this._on($(window), 'mousedown', this._windowMaintainSelection);
            this._on($(window), 'dblclick', this._windowMaintainSelectionOnDblclick);
            this._on($(window), 'mousemove', this._windowMaintainSelectionOnMousemove);
            this._on($(window), "touchstart", this._windowOnTextContainerTouch);
        },

        _unwireEvents: function () {
            var is_chrome = navigator.userAgent.indexOf('Chrome') != -1;
            var is_firefox = navigator.userAgent.indexOf('Firefox') != -1;
            var is_safari = navigator.userAgent.indexOf("Safari") != -1;
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            var is_edge = navigator.userAgent.indexOf("Edge") != -1;
            var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
            if (!this.model.toolbarSettings.templateId) {
                this._on($('#' + this._id + '_txtpageNo'), "keypress", this._allowOnlyNumbers);
                this._off($('#' + this._id + '_txtpageNo'), "keypress", this._onkeyPress);
                this._off($('#' + this._id + '_txtpageNo'), "click ", this._onToolbarItemClick);
                this._off($('#' + this._id + '_zoomSelection'), "change", this._zoomValChange);
                this._off($('#' + this._id + '_toolbar_zoomSelection_container'), "click ", this._onToolbarItemClick);
                this._off($('#' + this._id + '_viewerContainer'), "mousewheel", this._onContainerScroll);
                this._off($(window), "keypress", this._onViewerKeypress);
            }

            var viewer = document.getElementById(this._id + '_viewerContainer');
            if (document.documentMode || is_edge || is_ie || is_edgeNew) {
                this._off($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                this._off($('#' + this._id + '_viewerContainer'), "dblclick", this._selectingTextOnDblClick);
                this._off($('#' + this._id + '_viewerContainer'), "click", this._selectingTextOnClick);
            }
            else {
                if (is_firefox)
                    this._off($('#' + this._id + '_viewerContainer'), "keydown", this._onTextKeyboardCopy);
                this._off($('#' + this._id + '_viewerContainer'), "mousemove", this._onTextContainerMouseMove);
                this._off($('#' + this._id + '_viewerContainer'), "mousedown", this._onTextContainerMouseDown);
                this._off($('#' + this._id + '_viewerContainer'), "mouseleave", this._onTextContainerMouseLeave);
                this._off($('#' + this._id + '_viewerContainer'), "mouseover", this._onTextContainerMouseIn);
                this._off($('#' + this._id + '_viewerContainer'), "touchstart", this._onTextContainerTouch);
                this._off($('#' + this._id + '_viewerContainer'), "touchend", this._onTextContainerTouchEnd);
                this._off($('#' + this._id + '_viewerContainer'), "touchmove", this._onTextContainerTouchMove);
                this._off($('#' + this._id + '_viewerContainer'), "dragstart", this._onTextContainerDragStart);
                this._off($('#' + this._id + '_viewerContainer'), "click", this._onTextContainerclick);
            }
            if (is_chrome || is_firefox || is_ie || is_edgeNew || is_edge) {
                this._off($('#' + this._id + '_viewerContainer'), "mouseup", this._onTextContainerMouseUp);
                this._off($('#' + this._id + '_pageviewContainer'), "click", "a.copy", this._copySelectedText);
                this._off($('#' + this._id + '_pageviewContainer'), "click", "a.googleSearch", this._openInNewTab);
                this._off($('#' + this._id + '_pageviewContainer'), "contextmenu", this._onTextContainerMouseUp);
            }
            if (navigator.userAgent.match("Firefox") || navigator.userAgent.match("Chrome")) {
                viewer.removeEventListener('touchstart', this._touchStart);
                viewer.removeEventListener('touchmove', this._touchMove);
                viewer.removeEventListener('touchleave', this._touchEnd);
                viewer.removeEventListener('touchend', this._touchEnd);
                viewer.removeEventListener('touchcancel', this._touchEnd);
            }
            this._off($('#' + this._id + '_viewerContainer'), 'pointerdown', this._pointerdown);
            this._off($('#' + this._id + '_viewerContainer'), 'pointermove', this._pointermove);
            this._off($('#' + this._id + '_viewerContainer'), 'pointerup', this._pointerup);
            this._off($('#' + this._id + '_viewerContainer'), 'pointerleave', this._pointerup);
            //Unwire search events
            this._off($('#' + this._id + '_pdfviewer_searchinput'), 'input', this._textSearch);
            this._off($('#' + this._id + '_pdfviewer_searchinput'), 'keypress', this._searchKeypressHandler);
            this._off($('#' + this._id + '_pdfviewer_previous_search'), 'click', this._prevSearch);
            this._off($('#' + this._id + '_pdfviewer_next_search'), 'click', this._nextSearch);
            this._off($('#' + this._id + '_pdfviewer_close_search'), "click ", this._displaySearchBox);
            //Unwire search events
            this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseover", this._showIconToolTip);
            this._off($('#' + this._id + '_toolbarContainer li,#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist,#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage'), "mouseout", this._hideIconToolTip);
            this._off($('#' + this._id + '_pdfviewer_findlabel, #' + this._id + '_pdfviewer_matchlabel'), 'mouseover', this._showLocalizationTooltip);
            this._off($('#' + this._id + '_pdfviewer_findlabel, #' + this._id + '_pdfviewer_matchlabel'), 'mouseout', this._hideLocalizationTooltip);
            this._off($('.e-pdfviewer-toolbarli-label'), 'mousedown', this._preventClick);
            this._off($(window), 'mousedown', this._windowMaintainSelection);
            this._off($(window), 'dblclick', this._windowMaintainSelectionOnDblclick);
            this._off($(window), 'mousemove', this._windowMaintainSelectionOnMousemove);
            this._off($(window), "touchstart", this._windowOnTextContainerTouch);
            this._off($(window), "resize", this._viewerResize);
        },
        _windowMaintainSelection: function (event) {
            if (!$(event.target).parents().hasClass("e-pdfviewer")) {
                var selection = window.getSelection();
                this._selectionNodes = selection;
                var range = document.createRange();
                var anchorpageId, focuspageId, anchorOffsetDiv,focusOffsetDiv, anchorOffset, focusOffset;
                if ($(selection.anchorNode).parent().hasClass('e-pdfviewer-textLayer') && $(selection.focusNode).parent().hasClass('e-pdfviewer-textLayer') || $(selection.anchorNode).hasClass('e-pdfviewer-textLayer') && $(selection.focusNode).hasClass('e-pdfviewer-textLayer')) {
                    var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                    var backward = false;
                    this._selectionObject = new Object();
                    this._selectionObject.isBackward = false;
                    if (!position && selection.anchorOffset > selection.focusOffset ||
                      position === Node.DOCUMENT_POSITION_PRECEDING)
                        backward = true;
                    if (backward) {
                        this._selectionObject.isBackward = backward;
                        this._selectionObject.anchorOffset = selection.focusOffset;
                        this._selectionObject.focusOffset = selection.anchorOffset;
                        range.setStart(selection.focusNode, selection.focusOffset);
                        range.setEnd(selection.anchorNode, selection.anchorOffset);
                        anchorpageId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
                        focuspageId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                        anchorOffsetDiv = parseInt(selection.focusNode.parentNode.id.split("text_")[1].split('_')[1]);
                        focusOffsetDiv = parseInt(selection.anchorNode.parentNode.id.split("text_")[1].split('_')[1]);
                        anchorOffset = selection.focusOffset;
                        focusOffset = selection.anchorOffset;
                    }
                    else {
                        this._selectionObject.anchorOffset = selection.anchorOffset;
                        this._selectionObject.focusOffset = selection.focusOffset;
                        range.setStart(selection.anchorNode, selection.anchorOffset);
                        range.setEnd(selection.focusNode, selection.focusOffset);
                        anchorpageId = parseInt(selection.anchorNode.parentNode.id.split("text_")[1]);
                        focuspageId = parseInt(selection.focusNode.parentNode.id.split("text_")[1]);
                        anchorOffsetDiv = parseInt(selection.anchorNode.parentNode.id.split("text_")[1].split('_')[1]);
                        focusOffsetDiv = parseInt(selection.focusNode.parentNode.id.split("text_")[1].split('_')[1]);
                        anchorOffset = selection.anchorOffset;
                        focusOffset = selection.focusOffset;
                    }
                    this._controlSelectionRange = range;
                    if ($('#' + this._id + 'custom-menu'))
                        $('#' + this._id + 'custom-menu').hide();
                    this._waterDropletDivHide();
                    $('#' + this._id + 'touchcustom-menu').hide();
                    var pageNo;
                    selection.removeAllRanges();
                    for (var i = anchorpageId; i <= focuspageId; i++) {
                        var startId, endId;
                        var textDivs = this._textDivs[i];
                        if (i == anchorpageId){
                            pageNo = anchorpageId;
                            startId = anchorOffsetDiv;
                            endId = textDivs.length - 1;
                        }
                        else if (i == focuspageId){
                            pageNo = focuspageId;
                            startId = 0;
                            endId = focusOffsetDiv;
                        }
                        else{
                            pageNo++;
                            startId = 0;
                            endId = textDivs.length - 1;
                        }
                        if (anchorpageId == focuspageId) {
                            startId = anchorOffsetDiv;
                            endId = focusOffsetDiv;
                        }
                        for (var j = startId; j <= endId; j++) {
                            var textDiv = textDivs[j];
                            var initId, lastId, length;
                            length = textDiv.textContent.length;
                            textDiv.textContent = '';
                            if (j == startId) {
                                initId = anchorOffset;
                                lastId = length;
                                this._addSpanForSearch(j, 0, initId, i, textDivs, null);
                            } else if (j == endId) {
                                initId = 0;
                                lastId = focusOffset;
                            } else {
                                initId = 0;
                                lastId = length;
                            }
                            if (startId == endId) {
                                initId = anchorOffset;
                                lastId = focusOffset;
                            }
                            this._addSpanForSearch(j, initId, lastId, i, textDivs, 'e-pdfviewer-maintaincontent');
                        }
                    }
                }
            }
        },
        _windowMaintainSelectionOnDblclick: function (event) {
            if (!$(event.target).parents().hasClass("e-pdfviewer")) {
                if (this._controlSelectionRange != null) {
                    var selection = window.getSelection();
                    if (!($(selection.anchorNode).parent().hasClass('e-pdfviewer-textLayer') && $(selection.focusNode).parent().hasClass('e-pdfviewer-textLayer'))) {
                        this._controlSelectionRange = null;
                        this._selectionObject = null;
                        if ($('#' + this._id + 'custom-menu'))
                            $('#' + this._id + 'custom-menu').hide();
                        this._waterDropletDivHide();
                        $('#' + this._id + 'touchcustom-menu').hide();
                        this._clearHighlightDiv();
                    }
                } else {
                    this._clearHighlightDiv();
                }
            }
        },
        _windowMaintainSelectionOnMousemove: function (event) {
            if (!$(event.target).parents().hasClass("e-pdfviewer")){
                if (this._controlSelectionRange != null) {
                    var selection = window.getSelection();
                    if (!($(selection.anchorNode).parent().hasClass('e-pdfviewer-textLayer') && $(selection.focusNode).parent().hasClass('e-pdfviewer-textLayer'))) {
                        this._controlSelectionRange = null;
                        this._selectionObject = null;
                        if ($('#' + this._id + 'custom-menu'))
                            $('#' + this._id + 'custom-menu').hide();
                        this._waterDropletDivHide();
                        $('#' + this._id + 'touchcustom-menu').hide();
                        this._clearHighlightDiv();
                    }
                }
            }
        },
        _windowOnTextContainerTouch: function (event) {
            var proxy = this;
            var timer = setTimeout(function () {
                proxy._controlSelectionRange = null;
                this._selectionObject = null;
                clearTimeout(timer);
                if (!$(event.target).parents().hasClass("e-pdfviewer")) {
                    if ($('#' + proxy._id + 'custom-menu'))
                        $('#' + proxy._id + 'custom-menu').hide();
                    proxy._waterDropletDivHide();
                    $('#' + proxy._id + 'touchcustom-menu').hide();
                    this._clearHighlightDiv();
                }
            }, 1000);
        },
        _clearHighlightDiv: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                if (this._renderedCanvasList.indexOf(parseInt(i)) !== -1) {
                    var textDiv = this._textDivs[i];
                    var textContent = this._textContents[i];
                    if (!textDiv || textDiv == undefined) {
                        break;
                    }
                    for (var j = 0; j < textDiv.length; j++) {
                        textDiv[j].textContent = textContent[j];
                        if (!this._isFindboxPresent) {
                            textDiv[j].textContent = '';
                            textDiv[j].textContent = textContent[j] + '\r\n';
                        }
                    }
                }
            }
        },
        _deleteSignatureCanvas: function (event) {
            var target = this._tempCanvas;
            if (target) {
                var args = new Object();
                var isSelectors = document.getElementById(this._id + "e-pdfviewer-selector");
                var isButtons = document.getElementsByClassName('e-pdfviewer-buttons');
                args.annotationID = target.id;
                args.pageID = parseInt(target.id.split("imagecanvasDraw_")[1].split('_')[0]);
                var signatureObject = new Object();
                signatureObject.operation = "signatureDeleted";
                signatureObject.signCanvas = target;
                signatureObject.pageNumber = parseInt(target.id.split("imagecanvasDraw_")[1].split('_')[0]);
                this._recentOperation.push(signatureObject);
                $(target).remove();
                $(isSelectors).remove();
                $(isButtons).remove();
                this._raiseClientEvent("signatureDelete", args);
            }
        },
        _onContainerScroll: function (event) {
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            if (this._isPropertiesWindowOpen) {
                event.preventDefault();
            }
        },

        _closePropertiesWindow: function (event) {
            this._isPropertiesWindowOpen = false;
        },

        _onToolBarContainerMouseDown: function (e) {
            if (!($(event.target).hasClass('e-pdfviewer-ddl') || $(event.target).parents().hasClass('e-pdfviewer-ddl'))) {
                if (document.activeElement.id == this._id + '_toolbar_zoomSelection_wrapper') {
                    $('#' + this._id + '_toolbar_zoomSelection_wrapper').blur();
                }
            }
            e.preventDefault();
            return false;
        },
        _onToolbarItemClick: function (event) {
            if (event.target.id == this._id + "_txtpageNo") {
                $('#' + this._id + '_txtpageNo').select();
            }
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },
        _selectingTextOnClick: function (e) {
            if (this._timers && this._clientx == e.clientX && this._clienty == e.clientY) {
                clearTimeout(this._timers);
                this._timers = null;
                this._selectingEntireLine(e);
            }
        },
        _selectingEntireLine: function (e) {
            var textNode, range, offset;
            var textIds = [];
            var target = e.target;
            var targetTop = target.getBoundingClientRect();
            var len = $('.e-pdfviewer-textLayer').length;
            if ($(e.target).hasClass('e-pdfviewer-textLayer')) {
                for (var i = 0; i < len; i++) {
                    var rect = $('.e-pdfviewer-textLayer')[i].getBoundingClientRect();
                    var top = parseInt(rect.top);
                    var targetPosition = parseInt(targetTop.top);
                    if (top == targetPosition || (top + 1) == targetPosition || (top - 1) == targetPosition) {
                        var textId = $('.e-pdfviewer-textLayer')[i].id;
                        if (textId != "") {
                            textIds.push(textId);
                        }
                    }
                }
                var selection = window.getSelection();
                selection.removeAllRanges();
                var range = document.createRange();
                var lengths = (textIds.length - 1);
                var d1 = document.getElementById(textIds[0]);
                var d2 = document.getElementById(textIds[lengths]);
                var childNodes = d2.childNodes.length;
                if (childNodes > 0) {
                    var nodes = d2.childNodes[childNodes - 1]
                    range.setStart(d1, 0);
                    range.setEnd(nodes, nodes.length);
                }
                else {
                    range.setStart(d1, 0);
                    range.setEnd(d2, 1);
                }
                selection.addRange(range);
            }
        },
        _selectingTextOnDblClick: function (e) {
            this._clientx = e.clientX;
            this._clienty = e.clientY;
            if (this._isAnnotationSelected) {
                this._showPopupMenu(e);
                this._clearSelector(e);
            }
            this._timers = setTimeout(function () {
                this._timers = null;
            }, 200);
        },
        _onTextContainerMouseIn: function (e) {
            if (this.Clicked) {
                e.preventDefault();
                return false;
            }
        },
        _onTextContainerMouseUp: function (e) {
            if (this._dragstate) {
                this._dragstate = false;
            }
            $('#' + this._id + '_toolbarContainer_hiddenlist').addClass("e-display-none");
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            this._isDefaultColorSet = false;
            var annotation, annotationType;
            var target = e.target;
            var popupnoteInnerContent = $("#" + this._id + '_popupinnercontent');
            if (target == popupnoteInnerContent[0]) {
                popupnoteInnerContent.focus();
            } else {
                popupnoteInnerContent.blur();
            }
            this._isPopupNoteFocused = false;
            if (!this._isPropertiesWindowOpen && !(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent")) {
                this._curDown = false;
                var storedSelection = [];
                var target = e.target;
                this._currentAnnotationRectangle = [];
                var customMenu = document.getElementById(this._id + "custom-menu");
                var highlight = document.getElementById(this._id + "highlight-menu");
                if (e.target.className != "popupnoteli" && e.target.className != "deleteAnnotationli" && e.target.className != "Propertiesli" && e.target.className != "e-pdfviewer-highlight-menu")
                $(highlight).hide();
                this._isContextMenuPresent = false;
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                if (pageNumber && this.model.enableTextMarkupAnnotations) {
                    for (var i = 1; i <= this._totalPages; i++) {
                        if (this._textMarkupAnnotationList[i] || this._newAnnotationList[i - 1]) {
                            this._clearRectOnClick(i);
                        }
                    }
                    var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                    this._onCanvasMousedown(secanvas, e.pageX, e.pageY);
                    this._contextClickPosition(e, pageNumber);
                }
                if (!window.getSelection().toString()) {
                    if (this._currentAnnotationRectangle.length != 0) {
                        annotation = this._currentAnnotationRectangle[0];
                        annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                        if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                            this._AnnotationPage = pageNumber;
                            this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                        }
                    }
                }
                var targetValue, focusNode, anchorNode, focusPage, anchorPage, targetPage;
                var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
                var searchText = window.getSelection().toString();
                if (e.type == "contextmenu") {
                    var selection = window.getSelection();
                    if (selection.anchorNode) {
                        var ranges = selection.getRangeAt(0);
                        var cloneRange = ranges.cloneContents();
                        var childNodes = cloneRange.childNodes;
                        var className = ranges.startContainer.parentNode.className;
                        var textHighlight = $(cloneRange).find('span');
                        if (textHighlight.length > 0) {
                            if (textHighlight[0].className == "e-pdfviewer-texthighlight e-pdfviewer-textLayer" || textHighlight[0].className == "e-pdfviewer-text-highlightother e-pdfviewer-textLayer") {
                                if (ranges.startContainer.id)
                                    storedSelection.push(ranges.startContainer.id);
                            }
                        }
                        var is_edgeNew = document.documentMode || /Edge/.test(navigator.userAgent);
                        if ((is_ie || is_edgeNew) && $(cloneRange).children().length == 0) {
                            if (className == "e-pdfviewer-textLayer" && ranges.startContainer.parentNode)
                                storedSelection.push(ranges.startContainer.parentNode.id);
                            else
                                storedSelection.push(ranges.startContainer.id);
                        }
                        if (cloneRange.childElementCount == 0) {
                            if (className == "e-pdfviewer-textLayer")
                                storedSelection.push(ranges.startContainer.parentElement.id);
                            else
                                storedSelection.push(ranges.startContainer.id);
                        }
                        else {
                            if (childNodes.length > 0) {
                                if (childNodes[0].className == "e-waitingpopup e-js") {
                                    for (var k = 0; k < childNodes.length; k++) {
                                        var children = $(childNodes[k]).find('.text_container').children();
                                        for (var l = 0; l < children.length; l++)
                                            storedSelection.push(children[l].id);
                                    }
                                }
                                else if (childNodes[0].className == "e-pdfviewer-selectiondiv text_container") {
                                    var children = $('.text_container').children();
                                    for (var m = 0; m < children.length; m++)
                                        storedSelection.push(children[m].id);
                                }
                                else {
                                    for (var i = 0; i < childNodes.length; i++) {
                                        var element = childNodes[i].id;
                                        storedSelection.push(element);
                                    }
                                }
                            }
                        }
                        for (var j = 0; j < storedSelection.length; j++) {
                            if ($(target).hasClass('e-pdfviewer-text-highlightother') || $(target).hasClass('e-pdfviewer-texthighlight')) {
                                target = target.parentElement;
                            }
                            if (target.id == storedSelection[j]) {
                                this._contextMenu = true;
                                break;
                            }
                            else
                                this._contextMenu = false;
                        }
                    }
                    if (e.target.className == "e-pdfviewer-imagecanvasDraw")
                        this._contextMenu = true;
                }
                if (e.which == 3 && e.target.className == "e-pdfviewer-imagecanvasDraw") {
                    this._contextMenu = true;
                }
                if (e.which == 3 && this._contextMenu && e.type == "contextmenu" && !this._isCopyRestrict && e.target.className == "e-pdfviewer-imagecanvasDraw") {
                    e.preventDefault();
                    this._showSignatureContext(e, highlight);
                    this._contextMenu = false;
                }
                else if (searchText != "" && e.which == 3 && this._contextMenu && e.type == "contextmenu" && !this._isCopyRestrict && ((e.target.className).indexOf('input_container') == -1) && this.model.textSelectionContextMenu.isEnable) {
                    e.preventDefault();
                    this._searchedText = "";
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    var copyText = localeObj['contextMenu']['copy']['contentText'];
                    var googleText = localeObj['contextMenu']['googleSearch']['contentText'];
                    var highlightText = localeObj['toolbar']['highlight']['headerText'];
                    var strikeText = localeObj['toolbar']['strikeout']['headerText'];
                    $(customMenu).css("z-index", 1000000000);
                    $(customMenu).find('li a.copy').text(copyText);
                    $(customMenu).find('li a.googleSearch').text(googleText);
                    $(customMenu).find('li a.e-highlight-text').text(highlightText);
                    $(customMenu).find('li a.e-strikeout-text').text(strikeText);    
                    if (searchText.length > 20) {
                        var trimmed = searchText.substring(0, 18);
                        var str = trimmed + "...";
                        $(customMenu).find('li a.googleSearch').text(googleText + "'" + str + "'");
                    }
                    else
                        $(customMenu).find('li a.googleSearch').text(googleText + "'" + searchText + "'");
                    var pos = this._setContextMenuPostion(e);
                    if (this.model.enableTextMarkupAnnotations) {
                        if (this.model.enableHighlightAnnotation)
                            $('#' + this._id + "_highlight_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        if (this.model.enableStrikethroughAnnotation)
                            $('#' + this._id + "_strikeout_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    } else {
                        $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    }
                    if (!this.model.textSelectionContextMenu.isCopyEnable && !this.model.textSelectionContextMenu.isSearchEnable && !this.model.textSelectionContextMenu.isHighlightEnable && !this.model.textSelectionContextMenu.isStrikeoutEnable)
                        $(customMenu).hide();
                    else {
                        $(customMenu).show();
                        $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                        $(customMenu).show();
                        $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    }
                    this._contextMenu = false;
                } else if (e.which == 3 && e.type == "contextmenu" && !this._isCopyRestrict
   && ($(e.target).hasClass('e-pdfviewer-text-highlightother e-pdfviewer-textLayer') || $(e.target).hasClass('e-pdfviewer-texthighlight e-pdfviewer-textLayer') || $(e.target).hasClass('e-pdfviewer-texthighlight middle e-pdfviewer-textLayer')) && this.model.textSelectionContextMenu.isEnable) {
                    e.preventDefault();
                    this._searchedText = "";
                    var childElements = $('.e-pdfviewer-textLayer').find('.e-pdfviewer-texthighlight');
                    if (childElements.length > 1) {
                        childElements = $('.e-pdfviewer-textLayer').find('.e-pdfviewer-texthighlight');
                        for (var m = 0; m < childElements.length; m++) {
                            var texts = childElements[m].innerHTML
                            this._searchedText += texts;
                        }
                    }
                    else
                        this._searchedText = e.target.innerHTML;
                    if (this._searchedText.length > 20) {
                        var trimmed = this._searchedText.substring(0, 18);
                        var str = trimmed + "...";
                        $(customMenu).find('li a.googleSearch').text("Search Google For " + "'" + str + "'");
                    }
                    else
                        $(customMenu).find('li a.googleSearch').text("Search Google For " + "'" + this._searchedText + "'");
                    var pos = this._setContextMenuPostion(e);
                    if (this.model.enableTextMarkupAnnotations) {
                        if (this.model.enableHighlightAnnotation)
                            $('#' + this._id + "_highlight_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        if (this.model.enableStrikethroughAnnotation)
                            $('#' + this._id + "_strikeout_contextmenu").removeClass('e-disable');
                        else
                            $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    } else {
                        $('#' + this._id + "_highlight_contextmenu").addClass('e-disable');
                        $('#' + this._id + "_strikeout_contextmenu").addClass('e-disable');
                    }
                    if (!this.model.textSelectionContextMenu.isCopyEnable && !this.model.textSelectionContextMenu.isSearchEnable && !this.model.textSelectionContextMenu.isHighlightEnable && !this.model.textSelectionContextMenu.isStrikeoutEnable)
                        $(customMenu).hide();
                    else {
                        $(customMenu).show();
                        $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                        $(customMenu).show();
                        $(customMenu).offset({ top: pos.y, left: pos.x }).show();
                    }
                    this._contextMenu = false;
                }
                else if ($(customMenu).has(e.target).length == 0) {
                    $(customMenu).hide();
                    if (e.type == "contextmenu" && !this._contextMenu && e.target.className != "e-pdfviewer-formFields")
                        this._clearSelector();
                    else if (this._contextMenu)
                        e.preventDefault();
                    if (e.type == "contextmenu") {
                        if (e.which == 3 &&
                            (!this._contextMenu || !this.model.textSelectionContextMenu.isEnable || searchText =="") &&
                            e.type == "contextmenu" &&
                            (this._currentAnnotationRectangle.length != 0 || "#000000" != this._annotationColor) && this.model.annotationContextMenu.isEnable) {
                            if (this.model.enableTextMarkupAnnotations) {
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._showAnnotationContextMenu(e, highlight);
                                }
                            }
                            e.preventDefault();
                        } else {
                            if (this._currentAnnotationRectangle.length != 0 || "#000000" != this._annotationColor && !this.model.annotationContextMenu.isEnable)
                                e.preventDefault();
                            $(highlight).hide();
                        }
                    }
                }

                if (this._annotationActive) {
                    if (this._isStrikeout) {
                        this._drawStrikeOutAnnotation();
                    } else if (this._isUnderline) {
                        this._drawUnderlineAnnotation();
                    } else if (this._isHighlight) {
                        this._drawHighlightAnnotation();
                    }
                }
            } else {
                e.preventDefault();
            }
        },
        _replaceTextLocale: function (element, text) {
            element.textContent = text;
        },
        _showSignatureContext: function (e, highlight) {
            var popupNote = $(highlight).find('.popupnoteli');
            $(popupNote).css("display", "none");
            this._showHideAnnotationMenu(highlight, "Signature");
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var popupText = localeObj['contextMenu']['openPopup']['contentText'];
            var propertiesText = localeObj['contextMenu']['properties']['contentText'];
            this._replaceTextLocale($("#" + this._id + "_openPopup")[0], popupText);
            this._replaceTextLocale($("#" + this._id + "_propAnnot")[0], propertiesText);
            var pos = this._setDeleteContextMenuPostion(e);
            if (!this.model.annotationContextMenu.isPropertiesEnable && !this.model.annotationContextMenu.isDeleteEnable)
                $(highlight).hide();
            else if (this.model.annotationContextMenu.isEnable) {
                $(highlight).show();
                $(highlight).offset({ top: pos.y, left: pos.x }).show();
                $(highlight).show();
                $(highlight).offset({ top: pos.y, left: pos.x }).show();
                $(highlight).css("z-index", 1000000000);
            }
        },
        _showAnnotationContextMenu: function (e, highlight) {
            $('#' + this._id + '_popup_note').hide();
            $("#" + this._id + "_popupmenu").hide();
            var popupNote = $(highlight).find('.popupnoteli');
            $(popupNote).css("display", "");
            this._showHideAnnotationMenu(highlight, "annotation");
            this._isPopupNoteVisible = false;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var popupText = localeObj['contextMenu']['openPopup']['contentText'];
            var deleteText = localeObj['contextMenu']['Delete']['contentText'];
            var propertiesText = localeObj['contextMenu']['properties']['contentText'];
            this._replaceTextLocale($("#" + this._id + "_openPopup")[0], popupText);
            this._replaceTextLocale($("#" + this._id + "_deleteannot")[0], deleteText);
            this._replaceTextLocale($("#" + this._id + "_propAnnot")[0], propertiesText);
            var pos = this._setHighLightContextMenuPostion(e);
            this._isContextMenuPresent = true;
            if (!this.model.annotationContextMenu.isPopupEnable && !this.model.annotationContextMenu.isPropertiesEnable && !this.model.annotationContextMenu.isDeleteEnable)
                $(highlight).hide();
            else if (this.model.annotationContextMenu.isEnable) {
                $(highlight).show();
                $(highlight).offset({ top: pos.y, left: pos.x }).show();
                $(highlight).show();
                $(highlight).offset({ top: pos.y, left: pos.x }).show();
            }
        },
        _showHideSelectionContextMenu: function (contextMenu) {
            if (!this.model.textSelectionContextMenu.isEnable)
                $(contextMenu).css("display", "none");
            else {
                $(contextMenu).css("display", "");
                if (!this.model.textSelectionContextMenu.isCopyEnable)
                    $(contextMenu).find('.copyli').css("display", "none");
                else
                    $(contextMenu).find('.copyli').css("display", "");
                if (!this.model.textSelectionContextMenu.isSearchEnable)
                    $(contextMenu).find('.googlesearchli').css("display", "none");
                else
                    $(contextMenu).find('.googlesearchli').css("display", "");
                if (!this.model.textSelectionContextMenu.isHighlightEnable)
                    $(contextMenu).find('.e-highlight-textli').css("display", "none");
                else
                    $(contextMenu).find('.e-highlight-textli').css("display", "");
                if (!this.model.textSelectionContextMenu.isStrikeoutEnable)
                    $(contextMenu).find('.e-strikeout-textli').css("display", "none");
                else
                    $(contextMenu).find('.e-strikeout-textli').css("display", "");
            }
        },
        _showHideAnnotationMenu: function (contextMenu, type) {
            if (!this.model.annotationContextMenu.isEnable) {
                $(contextMenu).css("display", "none");
            }
            else {
                if (!this.model.annotationContextMenu.isPopupEnable)
                    $(contextMenu).find('.popupnoteli').css("display", "none");
                else if (type == "annotation")
                    $(contextMenu).find('.popupnoteli').css("display", "");
                if (!this.model.annotationContextMenu.isPropertiesEnable)
                    $(contextMenu).find('.Propertiesli').css("display", "none");
                else
                    $(contextMenu).find('.Propertiesli').css("display", "");
                if (!this.model.annotationContextMenu.isDeleteEnable)
                    $(contextMenu).find('.deleteAnnotationli').css("display", "none");
                else
                    $(contextMenu).find('.deleteAnnotationli').css("display", "");
            }
        },
        _contextClickPosition: function (event, pageNumber) {
            var pagePosition;
            this._currentAnnotationRectangleBackup = [];
            var currentAnnotations = [];
            var isAnnotationGot = false;
            if (pageNumber) {
                var parent = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                pagePosition = parent.getBoundingClientRect();
            }
            var leftClickPosition = event.clientX - pagePosition.left;
            var topClickPosition = event.clientY - pagePosition.top;
            var annotationList = this._newAnnotationList[pageNumber - 1];
            for (var i = 0; i < annotationList.length; i++) {
                var annotation = annotationList[i];
                for (var k = 0; k < annotation.bounds.length; k++) {
                    var bound = annotation.bounds[k];
                    if (leftClickPosition >= bound.xPosition * this._zoomVal && leftClickPosition <= (bound.xPosition + bound.width) * this._zoomVal && topClickPosition >= bound.yPosition * this._zoomVal && topClickPosition <= (bound.yPosition + bound.height) * this._zoomVal) {
                        this._currentAnnotationRectangle.push(annotationList[i]);
                        this._currentAnnotationRectangleBackup.push(annotationList[i]);
                        isAnnotationGot = true;
                        currentAnnotations.push(annotation);
                    } else {
                        if (isAnnotationGot) {
                            isAnnotationGot = false;
                            break;
                        }
                        if (!this._isPopupNoteVisible) {
                            this._currentAnnotationRectangleBackup = [];
                        }
                        this._currentAnnotationRectangle = [];
                    }
                }
            }
                annotationList = this._textMarkupAnnotationList[pageNumber];
                if (annotationList) {
                    for (var j = 0; j < annotationList.length; j++) {
                        var annotation = annotationList[j];
                        for (var k = 0; k < annotation.Bounds.length; k++) {
                            var bound = annotation.Bounds[k];
                            var xPosition = this._convertPointToPixel(bound.X);
                            var yPosition = this._convertPointToPixel(bound.Y);
                            var width = this._convertPointToPixel(bound.Width);
                            var height = this._convertPointToPixel(bound.Height);
                            if (leftClickPosition >= xPosition * this._zoomVal &&
                                leftClickPosition <= (xPosition + width) * this._zoomVal &&
                                topClickPosition >= yPosition * this._zoomVal &&
                                topClickPosition <= (yPosition + height) * this._zoomVal) {
                                this._currentAnnotationRectangle.push(annotation);
                                this._currentAnnotationRectangleBackup.push(annotation);
                                isAnnotationGot = true;
                                currentAnnotations.push(annotation);
                            } else {
                                if (isAnnotationGot) {
                                    isAnnotationGot = false;
                                    break;
                                }
                                if (!this._isPopupNoteVisible) {
                                    this._currentAnnotationRectangleBackup = [];
                                }
                                this._currentAnnotationRectangle = [];
                            }
                        }
                    }
                }
            if (currentAnnotations.length > 1) {
                currentAnnotations = this._compareAnnotations(currentAnnotations);
            }
            this._currentAnnotationRectangle = currentAnnotations;
            this._currentAnnotationRectangleBackup = currentAnnotations;
        },
        _compareAnnotations: function (currentAnnotations) {
            var prevXposition, currentAnnot;
            for (var i = 0; i < currentAnnotations.length; i++) {
                if (i == currentAnnotations.length - 1) {
                    break;
                }
                var firstAnnotBounds = currentAnnotations[i].bounds ? currentAnnotations[i].bounds : currentAnnotations[i].Bounds;
                var firstXposition = firstAnnotBounds[0].X ? firstAnnotBounds[0].X : firstAnnotBounds[0].xPosition
                var firstYposition = firstAnnotBounds[0].Y ? firstAnnotBounds[0].Y : firstAnnotBounds[0].yPosition;
                var secondAnnotBounds = currentAnnotations[i + 1].bounds ? currentAnnotations[i + 1].bounds : currentAnnotations[i + 1].Bounds;
                var secondXposition = secondAnnotBounds[0].X ? secondAnnotBounds[0].X : secondAnnotBounds[0].xPosition;
                var secondYposition = secondAnnotBounds[0].Y ? secondAnnotBounds[0].Y : secondAnnotBounds[0].yPosition;
                if (firstXposition < secondXposition || firstYposition < secondYposition) {
                    prevXposition = secondXposition;
                    currentAnnot = currentAnnotations[i + 1];
                } else {
                    prevXposition = firstXposition;
                    currentAnnot = currentAnnotations[i];
                }
                if (prevXposition && i == currentAnnotations.length - 2) {
                    if (prevXposition == firstXposition && prevXposition == secondXposition) {
                        prevXposition = secondXposition;
                        currentAnnot = currentAnnotations[i + 1];
                    }
                }
            }
            currentAnnotations = [];
            currentAnnotations.push(currentAnnot);
            return currentAnnotations;
        },
        _setContextMenuPostion: function (event) {
            var contextMenu = $("#" + this._id + "custom-menu");
            this._showHideSelectionContextMenu(contextMenu);
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = event.pageX;
            mousePosition.y = event.pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x - menuDimension.x;
            } else {
                menuPostion.x = mousePosition.x;
            }

            if (mousePosition.y + menuDimension.y > $(window).height() + $(window).scrollTop()) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            } else {
                menuPostion.y = mousePosition.y;
            }
            return menuPostion;
        },
        _createWaterDropDiv: function (e) {
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            var dropdownX = document.createElement("DIV");
            dropdownX.id = this._id + "droplet1";
            dropdownX.className = "e-pdfviewer-droplet1";
            var dropdownY = document.createElement("DIV");
            dropdownY.id = this._id + "droplet2";
            dropdownY.className = "e-pdfviewer-droplet2";
            pageviewcontainer.append(dropdownX);
            pageviewcontainer.append(dropdownY);
            var vscrolvalue = $('#' + this._id + '_viewerContainer');
            var instance = this;
            $('#' + this._id + 'droplet2').on("touchmove", function (e) {
                if (instance.model.enableTextSelection) {
                    instance._enableSelection();
                    var selectionRange = window.getSelection();
                    var anchorPageId = parseInt(selectionRange.anchorNode.parentNode.id.split("text_")[1]);
                    var focusPageId = parseInt(selectionRange.focusNode.parentNode.id.split("text_")[1]);
                    if (anchorPageId == parseInt(instance._selectionStartPage) && focusPageId == parseInt(instance._selectionStartPage) || !instance._annotationActive) {
                        instance._longTouch = true;
                        var scrollTop = $(vscrolvalue).scrollTop();
                        $('#' + instance._id + 'touchcustom-menu').hide();
                        var touchX, touchY, curX, curY;
                        e.preventDefault();
                        var backwardPos = $('#' + instance._id + 'droplet1').offset();
                        if (e.type == "touchmove") {
                            touchX = e.originalEvent.changedTouches[0].clientX;
                            touchY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 0);
                            curX = e.originalEvent.changedTouches[0].clientX;
                            curY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 1000);
                        }
                        if (curY >= backwardPos.top) {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop + 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop + 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, true);
                        }
                        else {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop - 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop - 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, false);
                        }
                        if ($(parent).hasClass('e-pdfviewer-textLayer')) {
                            var width = $('#' + instance._id + 'droplet2').width();
                            $('#' + instance._id + 'droplet2').offset({ 'top': curY + window.scrollY, 'left': (curX - width) });
                        }
                    }
                }
                else if (!instance.model.enableTextSelection)
                    instance._disableSelection();
            });
            $('#' + this._id + 'droplet1').on("touchmove", function (e) {
                if (instance.model.enableTextSelection) {
                    instance._enableSelection();
                    var selectionRange = window.getSelection();
                    var anchorPageId = parseInt(selectionRange.anchorNode.parentNode.id.split("text_")[1]);
                    var focusPageId = parseInt(selectionRange.focusNode.parentNode.id.split("text_")[1]);
                    if (anchorPageId == parseInt(instance._selectionStartPage) && focusPageId == parseInt(instance._selectionStartPage) || !instance._annotationActive) {
                        var scrollTop = $(vscrolvalue).scrollTop();
                        $('#' + instance._id + 'touchcustom-menu').hide();
                        var touchX, touchY, curX, curY;
                        e.preventDefault();
                        var forwardPos = $('#' + instance._id + 'droplet2').offset();
                        if (e.type == "touchmove") {
                            instance._longTouch = true;
                            touchX = e.originalEvent.changedTouches[0].clientX;
                            touchY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 0);
                            curX = e.originalEvent.changedTouches[0].clientX;
                            curY = e.originalEvent.changedTouches[0].clientY;
                            $(e.target).css("z-index", 1000);
                        }
                        if (curY <= forwardPos.top) {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop - 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop - 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, false);
                        }
                        else {
                            if (document.caretPositionFromPoint) {
                                range = document.caretPositionFromPoint(curX, curY);
                                textNode = range.offsetNode;
                            } else if (document.caretRangeFromPoint) {
                                range = document.caretRangeFromPoint(curX, curY);
                                if (range != null) {
                                    textNode = range.startContainer;
                                    if (!$(textNode).hasClass('e-pdfviewer-toolbarcontainer')) {
                                        offset = range.startOffset;
                                    }
                                    else
                                        $(vscrolvalue).scrollTop(scrollTop + 30);
                                }
                                else
                                    $(vscrolvalue).scrollTop(scrollTop + 30);
                            }
                            parent = textNode.parentElement;
                            var point = instance._selectingTextByTouch(parent, curX, curY, true);
                        }
                        $(e.target).css("z-index", 1000);
                        if ($(parent).hasClass('e-pdfviewer-textLayer')) {
                            var width = $('#' + instance._id + 'droplet1').width();
                            $('#' + instance._id + 'droplet1').offset({ 'top': curY + window.scrollY, 'left': (curX - width) });
                        }
                    }
                }
                else if (!instance.model.enableTextSelection)
                    instance._disableSelection();
            });
        },
        _disableSelection:function(){
            if (!this.model.enableTextSelection) {
                $('#' + this._id + '_viewerContainer').attr('unselectable', 'on')
                     .css({
                         '-moz-user-select': 'none',
                         '-o-user-select': 'none',
                         '-khtml-user-select': 'none',
                         '-webkit-user-select': 'none',
                         '-ms-user-select': 'none',
                         'user-select': 'none'
                     }).bind('selectstart', function () { return false; });
            }
        },
        _enableSelection: function () {
            if (this.model.enableTextSelection) {
                $('#' + this._id + '_viewerContainer').removeAttr("unselectable")
                     .css({
                         '-moz-user-select': 'text',
                         '-o-user-select': 'text',
                         '-khtml-user-select': 'text',
                         '-webkit-user-select': 'text',
                         '-ms-user-select': 'text',
                         'user-select': 'text'
                     }).unbind('selectstart').bind('selectstart', function () { return true; });
            }
        },
        _selectingTextByTouch: function (elem, x, y, type) {
            if (elem.nodeType == elem.TEXT_NODE) {
                var range = elem.ownerDocument.createRange();
                var selection = window.getSelection();
                range.selectNodeContents(elem);
                var currentPos = 0;
                var endPos = range.endOffset;
                while (currentPos < endPos) {
                    range.setStart(elem, currentPos);
                    range.setEnd(elem, currentPos + 1);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        var singleWord = range.toString();
                        var rangesPosition = range.getBoundingClientRect();
                        if (selection.anchorNode != null && selection.anchorNode.parentNode.className == "e-pdfviewer-textLayer" && type) {
                            range.setStart(selection.anchorNode, selection.anchorOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                            selection.extend(elem, currentPos);
                        }
                        else if (selection.anchorNode != null && !type) {
                            range.setEnd(selection.focusNode, selection.focusOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                        }
                        range.detach();
                        return (singleWord);
                    }
                    currentPos += 1;
                }
            } else {
                for (var i = 0; i < elem.childNodes.length; i++) {
                    var range = elem.childNodes[i].ownerDocument.createRange();
                    range.selectNodeContents(elem.childNodes[i]);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        range.detach();
                        return (this._selectingTextByTouch(elem.childNodes[i], x, y, type));
                    } else {
                        range.detach();
                    }
                }
            }
            return (null);
        },
        _onTextContainerTouchMove: function (e) {
            $('#' + this._id + '_toolbarContainer_hiddenlist').addClass("e-display-none");
            if ($(e.target).hasClass('e-pdfviewer-textLayer') && this._lockTimer) {
                var curX = e.originalEvent.changedTouches[0].clientX;
                var curY = e.originalEvent.changedTouches[0].clientY;
                var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                if (parseInt(curX) != parseInt(this._curPosX) && parseInt(curY) != parseInt(this._curPosY)) {
                    $('.e-pdfviewer-formFields').css("visibility", "visible");
                    $(touchmenu).hide();
   
                }
            }
        },
        _setTouchContextMenu: function (e) {
            var contextMenu = $('#' + this._id + 'touchcustom-menu');
            var mousePosition = {};
            var menuPostion = {};
            var menuDimension = {};

            menuDimension.x = contextMenu.outerWidth();
            menuDimension.y = contextMenu.outerHeight();
            mousePosition.x = e.originalEvent.changedTouches[0].pageX;
            mousePosition.y = e.originalEvent.changedTouches[0].pageY;

            if (mousePosition.x + menuDimension.x > $(window).width() + $(window).scrollLeft()) {
                menuPostion.x = mousePosition.x;
            } else {
                menuPostion.x = mousePosition.x - (menuDimension.x / 2);
            }
            if (mousePosition.y) {
                menuPostion.y = mousePosition.y - menuDimension.y;
            }
            return menuPostion;
        },
        _onTextContainerTouch: function (e) {
            var eventTouch = e.originalEvent.touches.length;
            this._curPosX = e.originalEvent.changedTouches[0].clientX;
            this._curPosY = e.originalEvent.changedTouches[0].clientY;
            if (this.model.enableTextSelection && !this._isSelectionHidden) {
                e.preventDefault();
            }
            if (this._lockTimer)
                return;
            var proxy = this;

            this._timer = setTimeout(function () {
                proxy._onlongtouch(e);
            }, 1000);
            this._lockTimer = true;
        },
        _onlongtouch: function (e) {
            if (e.type == "touchstart" && e.target.id != this._id + "droplet2" || e.target.id != this._id + "droplet2" && this.model.enableTextSelection) {
                this._enableSelection();
                this._longTouch = true;
                $('.text_container').css("visibility", "");
                this._curXPos = e.originalEvent.changedTouches[0].clientX;
                this._curYPos = e.originalEvent.changedTouches[0].clientY;
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                this._selectionStartPage = pageNumber;
                if (!this._isPropertiesWindowOpen) {
                    if (pageNumber && this.model.enableTextMarkupAnnotations) {
                        this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                    }
                }
                if (!this._isAnnotationSelected || this._selectedAnnotation != this._currentAnnotationRectangle[0]) {
                    var point = this._getElementTouch(e.target, this._curXPos, this._curYPos, true);
                    if(pageNumber)
                    this._clearRectOnClick(pageNumber);
                }
                if (e.target.className == "e-pdfviewer-imagecanvasDraw"  && !this._isCanasResized && !this._isCanvasMoved) {
                    var highlight = document.getElementById(this._id + "highlight-menu");
                    this._showSignatureContext(e, highlight);
                }
                e.preventDefault();
            }
            else if (!this.model.enableTextSelection) {
                this._disableSelection();
                var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                $(touchmenu).hide();
                this._waterDropletDivHide();
            }
        },
        _onTextContainerTouchEnd: function (e) {
            $('#' + this._id + '_toolbarContainer_hiddenlist').addClass("e-display-none");
            var touchSelection = [];
            var target = e.target;
            var ranges;
            var eventTouch = e.originalEvent.touches.length;
            if (this._timer) {
                this._enableSelection();
            var popupnote = $("a.popupnote");
            var popupnoteInnerContent = $("#" + this._id + '_popupinnercontent');
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            if (target == popupnoteInnerContent[0]) {
                popupnoteInnerContent.focus();
            } else {
                popupnoteInnerContent.blur();
            }
            if (target.id != this._id + "highlight-menu" && target != popupnote[0] && target != popupnoteInnerContent[0] && target.className != "e-pdfviewer-imagecanvasDraw") {
                if (!this._isPropertiesWindowOpen) {
                    var highlight = document.getElementById(this._id + "highlight-menu");
                    $(highlight).hide();
                    this._isContextMenuPresent = false;
                    var annotation, annotationType;
                    var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                    if (pageNumber && this.model.enableTextMarkupAnnotations) {
                        this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                    }
                    if (this._currentAnnotationRectangleBackup.length != 0 && this._isAnnotationSelected && this._selectedAnnotation == this._currentAnnotationRectangleBackup[0] ) {
                        window.getSelection().removeAllRanges();
                        var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                        $(touchmenu).hide();
                        this._waterDropletDivHide();
                    }
                    if (this._longTouch && this._isAnnotationSelected && this._currentAnnotationRectangleBackup.length != 0 && this._selectedAnnotation == this._currentAnnotationRectangleBackup[0]) {
                        if (this.model.enableTextMarkupAnnotations) {
                            annotation = this._currentAnnotationRectangleBackup[0];
                            annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                            if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                this._showAnnotationContextMenu(e.originalEvent.changedTouches[0], highlight);
                            }
                        }
                        this._longTouch = false;
                    }
                    if (!this._isContextMenuPresent) {
                        var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("_secondarycanvas_")[1]);
                        if (pageNumber && this.model.enableTextMarkupAnnotations) {
                            this._clearRectOnClick(pageNumber);
                            var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                            this._onCanvasMousedown(secanvas, e.originalEvent.changedTouches[0].pageX, e.originalEvent.changedTouches[0].pageY);
                            this._contextClickPosition(e.originalEvent.changedTouches[0], pageNumber);
                        }
                        if (!window.getSelection().toString()) {
                            if (this._currentAnnotationRectangle.length != 0) {
                                annotation = this._currentAnnotationRectangle[0];
                                annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._AnnotationPage = pageNumber;
                                    this._drawAnnotSelectRect(pageNumber, this._currentAnnotationRectangle);
                                }
                            }
                        }
                    }
                }
            }
                clearTimeout(this._timer);
                this._lockTimer = false;
                var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                var curX = e.originalEvent.changedTouches[0].clientX;
                var curY = e.originalEvent.changedTouches[0].clientY;
                var selection = window.getSelection();
                if (selection.anchorNode) {
                    ranges = selection.getRangeAt(0);
                    var cloneRange = ranges.cloneContents();
                    var childNodes = cloneRange.childNodes;
                    var className = ranges.startContainer.parentElement.className;
                    if (cloneRange.childElementCount == 0 && !this._longTouch) {
                        if (className == "e-pdfviewer-textLayer")
                            touchSelection.push(ranges.startContainer.parentElement.id);
                        else
                            touchSelection.push(ranges.startContainer.id);
                    }
                    else {
                        if (childNodes.length > 0) {
                            if (childNodes[0].className == "e-waitingpopup e-js") {
                                for (var k = 0; k < childNodes.length; k++) {
                                    var children = $(childNodes[k]).find('.text_container').children();
                                    for (var l = 0; l < children.length; l++)
                                        touchSelection.push(children[l].id);
                                }
                            }
                            else {
                                for (var i = 0; i < childNodes.length; i++) {
                                    var element = childNodes[i].id;
                                    touchSelection.push(element);
                                }
                            }
                        }
                    }
                    for (var j = 0; j < touchSelection.length; j++) {
                        if (target.id == touchSelection[j]) {
                            this._touchcontextMenu = true;
                            break;
                        }
                        else
                            this._touchcontextMenu = false;
                    }
                }
                else
                    this._touchcontextMenu = false;
                if (this._rangePosition && this._longTouch) {
                    $('.text_container').css("visibility", "");
                    var outerHeight = $(touchmenu).outerHeight();
                    var outerWidth = $(touchmenu).outerWidth();
                    var width = this._rangePosition.width / 2;
                    var searchText = window.getSelection().toString();
                    if (this._ranges || this._touchcontextMenu || e.target.id == this._id + "droplet1" || e.target.id == this._id + "droplet2") {
                        if (e.target.id == this._id + "droplet1" || e.target.id == this._id + "droplet2" && this.model.textSelectionContextMenu.isEnable) {
                            $(touchmenu).show();
                            var context = this._setTouchContextMenu(e);
                            $(touchmenu).show();
                            $(touchmenu).offset({ 'top': context.y, 'left': context.x }).show();

                            if (this._annotationActive) {
                                if (this._isStrikeout) {
                                    this._drawStrikeOutAnnotation();
                                } else if (this._isUnderline) {
                                    this._drawUnderlineAnnotation();
                                } else if (this._isHighlight) {
                                    this._drawHighlightAnnotation();
                                }
                            }
                        }
                        else {
                            if (!this._annotationActive && this.model.textSelectionContextMenu.isEnable) {
                                $(touchmenu).show();
                                $(touchmenu).offset({ 'top': this._rangePosition.top - outerHeight + window.scrollY, 'left': this._rangePosition.left + width - (outerWidth / 2) });
                            }
                        }
                        this._ranges = false;
                        $('.text_container').css("visibility", "");
                    }
                    else {
                        if ($(e.target).hasClass('copy') || $(e.target).hasClass('googleSearch')) {
                            $(touchmenu).hide();
                        }
                        else {
                            $(touchmenu).hide();
                            this._waterDropletDivHide();
                        }
                    }
                    this._longTouch = false;
                }
                else {
                    $(touchmenu).hide();
                    if (this._annotationActive) {
                        if (this._isStrikeout) {
                            this._drawStrikeOutAnnotation();
                        } else if (this._isUnderline) {
                            this._drawUnderlineAnnotation();
                        } else if (this._isHighlight) {
                            this._drawHighlightAnnotation();
                        }
                    }
                }
                if (!this._annotationActive) {
                    if ($(touchmenu).css('display') == 'none' && e.target.id != this._id + "droplet2"
                        && e.target.id != this._id + "droplet1" && e.target.className != "copy" && e.target.className != "googleSearch"
                                    && $('#' + this._id + 'custom-menu').css('display') == 'none' && !this._touched && !this._touchcontextMenu) {
                        if (this.model.textSelectionContextMenu.isEnable) {
                            this._clearSelector();
                            this._clearText = true;
                        }
                    }
                }
                else if (this._touchcontextMenu) {
                    var selection = window.getSelection();
                    var range = document.createRange();
                    var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                    var backward = false;
                    if (!position && selection.anchorOffset > selection.focusOffset ||
                      position === Node.DOCUMENT_POSITION_PRECEDING)
                        backward = true;
                    if (backward) {
                        range.setStart(selection.focusNode, selection.focusOffset);
                        range.setEnd(selection.anchorNode, selection.anchorOffset);
                    }
                    else {
                        range.setStart(selection.anchorNode, selection.anchorOffset);
                        range.setEnd(selection.focusNode, selection.focusOffset);
                    }
                    var outerHeight = $(touchmenu).outerHeight();
                    var outerWidth = $(touchmenu).outerWidth();
                    var rangesPosition = range.getBoundingClientRect();
                    var boundingClient = range.getClientRects();
                    var length = boundingClient.length - 1;
                    var customMenuWidth = rangesPosition.width / 2;
                    var droplet1 = document.getElementById(this._id + 'droplet1');
                    var droplet2 = document.getElementById(this._id + 'droplet2');
                    var width = $(droplet1).outerWidth();
                    var height = $(droplet1).outerHeight();
                    var searchText = window.getSelection().toString();
                    if (searchText != "" && this.model.textSelectionContextMenu.isEnable) {
                        var context = this._setTouchContextMenu(e);
                        $(droplet1).show();
                        $(droplet1).offset({ "top": boundingClient[0].top + window.scrollY, "left": boundingClient[0].left - width }).show();
                        $(droplet2).show();
                        $(droplet2).offset({ "top": boundingClient[length].top + window.scrollY, "left": boundingClient[length].left + boundingClient[length].width - width }).show();
                        $(touchmenu).show();
                        $(touchmenu).offset({ 'top': context.y, 'left': context.x }).show();
                    }
                    e.preventDefault();
                }
                if (this._clearText) {
                    $(touchmenu).hide();
                    this._waterDropletDivHide();
                    this._clearText = false;
                }
            }
            else if (!this.model.enableTextSelection) {
                var droplet1 = document.getElementById(this._id + 'droplet1');
                var droplet2 = document.getElementById(this._id + 'droplet2');
                $(droplet1).hide();
                $(droplet2).hide();
                this._disableSelection();
            }
        },
        _onTextContainerMouseDown: function (e) {
            if (document.activeElement.id == this._id + '_toolbar_zoomSelection_wrapper') {
                $('#' + this._id + '_toolbar_zoomSelection_wrapper').blur();
            }
            if (!this.model.enableTextSelection) {
                this._dragx = e.pageX;
                this._dragy = e.pageY;
                this._dragstate = true;
            }
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection && !is_ie) {
                this._enableSelection();
                $('.text_container').css("visibility", "");
                var target = e.target;
                this._waterDropletDivHide();
                $('#' + this._id + 'touchcustom-menu').hide();
                this._curYPos = e.clientY;
                this._curXPos = e.clientX;
                if ((!$(e.target).hasClass('text_container')) && (!$(e.target).hasClass('e-pdfviewer-viewercontainer')) && e.which != 3) {
                    this._curDown = true;
                    this._removeSearch = true;
                    var splittedText = e.target.id.split('text_')[1];
                    if (splittedText)
                        this._selectedValue = splittedText.split('_')[0];
                    this._selectionStartPage = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("secondarycanvas_")[1]);
                }
                if ($('#' + this._id + 'custom-menu').css('display') == 'none' && e.which != 3 && !$(target).hasClass('e-pdfviewer-secondarycanvas')) {
                    this._clearSelector();
                }
                if (!$(target).hasClass('e-pdfviewer-formFields') && !$(target).hasClass('e-pdfviewer-ListBox') && !this._isFormFields && !$(target).hasClass('e-dropdownSelect'))
                    e.preventDefault();
            }
            else if (!this.model.enableTextSelection) {
                var secanvas = $('#' + this._id + 'selectioncanvas_' + (this._currentPage))[0].id;
                if (!this._isCanasResized && !this._isCanvasClicked && e.target.id == secanvas) {
                    e.target.style.cursor = "move";
                    e.target.style.cursor = "-webkit-grabbing";
                    e.target.style.cursor = "-moz-grabbing";
                    e.target.style.cursor = "grabbing";
                }
                this._disableSelection();
            }
        },
        _onTextContainerclick: function (e) {
            this._waterDropletDivHide();
            var target = e.target;
            if (e.originalEvent.detail == 2 && $(target).hasClass('e-pdfviewer-textLayer') &&  this.model.enableTextSelection) {
                e.preventDefault();
                this._clearAllOccurrences();
                this._enableSelection();
                this._getElementTouch(target, e.clientX, e.clientY, false);
                if (this._annotationActive && !this._isAnnotationSelected) {
                    if (this._isStrikeout) {
                        this._drawStrikeOutAnnotation();
                    } else if (this._isUnderline) {
                        this._drawUnderlineAnnotation();
                    } else if (this._isHighlight) {
                        this._drawHighlightAnnotation();
                    }
                }
                if (this._isAnnotationSelected) {
                    this._showPopupMenu(e);
                    this._clearSelector(e);
                }
                e.preventDefault();
            }
            if (e.originalEvent.detail == 3 && $(target).hasClass('e-pdfviewer-textLayer') && this.model.enableTextSelection) {
                this._enableSelection();
                if (!this._annotationActive)
                    this._selectingEntireLine(e);
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onTextContainerMouseMove: function (e) {
            if (!this.model.enableTextSelection && (e.target.className != "e-pdfviewer-imagecanvasDraw") && e.target.tagName.toLowerCase() != 'a')
                $('#' + this._id + 'pageDiv_' + (this._currentPage)).css("cursor", "-webkit-grab");
            else if ((e.target.className != "e-pdfviewer-buttons") && event.target.tagName.toLowerCase() != 'a')
                e.target.style.cursor = "auto";
            var is_ie = navigator.userAgent.indexOf("MSIE") != -1 || !!document.documentMode == true;
              if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent")&& !(e.target.className == "e-pdfviewer-formFields")) {
                e.preventDefault();
                this._enableSelection();
                this._currentAnnotationRectangle = [];
                var pageNumber = parseInt(e.target.id.split("text_")[1]) || parseInt(e.target.id.split("selectioncanvas_")[1]) || parseInt(e.target.id.split("secondarycanvas_")[1]);
                if (pageNumber && !this._isPropertiesWindowOpen) {
                    if (!is_ie) {
                        var secanvas = document.getElementById(this._id + "_secondarycanvas_" + pageNumber);
                        this._onCanvasMousedown(secanvas, e.pageX, e.pageY);
                    }
                    if (this.model.enableTextMarkupAnnotations) {
                        if (!this._isPopupNoteVisible && !this._isContextMenuPresent) {
                            if (!is_ie)
                                this._contextClickPosition(e, pageNumber);
                            if (this._currentAnnotationRectangle.length != 0 && !is_ie) {
                                var annotation = this._currentAnnotationRectangle[0];
                                var annotationType = annotation.TextMarkupAnnotationType ? annotation.TextMarkupAnnotationType : annotation.type;
                                if (annotationType == "StrikeOut" && this.model.enableStrikethroughAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                } else if (annotationType == "Underline" && this.model.enableUnderlineAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                } else if (annotationType == "Highlight" && this.model.enableHighlightAnnotation) {
                                    this._showPopupNote(e);
                                    e.target.style.cursor = "pointer";
                                }
                            } else {
                                $('#' + this._id + '_popup_note').css({ 'display': 'none' });
                                if (this.model.enableTextSelection) {
                                    e.target.style.cursor = "auto";
                                    e.preventDefault();
                                    this._enableSelection();
                                }
                                else if (!this.model.enableTextSelection && !this._isCanasResized && !this._isCanvasClicked) {
                                    var pageDiv = $('#' + this._id + 'pageDiv_' + (this._currentPage))
                                    if (this._dragstate) {
                                        this._deltax = this._dragx - e.pageX;
                                        this._deltay = this._dragy - e.pageY;
                                        var vscrolvalue = $('#' + this._id + '_viewerContainer').scrollTop();
                                        var vscrolleft = $('#' + this._id + '_viewerContainer').scrollLeft();
                                        if (this._deltay > 3)
                                            $('#' + this._id + '_viewerContainer').scrollTop(vscrolvalue + 20);
                                        else if (this._deltay < -2)
                                            $('#' + this._id + '_viewerContainer').scrollTop(vscrolvalue - 20);
                                        if (this._deltax > 3)
                                            $('#' + this._id + '_viewerContainer').scrollLeft(vscrolleft + 20);
                                        else if (this._deltax < -2)
                                            $('#' + this._id + '_viewerContainer').scrollLeft(vscrolleft - 20);
                                        e.target.style.cursor = "move";
                                        e.target.style.cursor = "-webkit-grabbing";
                                        e.target.style.cursor = "-moz-grabbing";
                                        e.target.style.cursor = "grabbing";
                                        this._dragx = e.pageX;
                                        this._dragy = e.pageY;

                                    }
                                    else {
                                        e.target.style.cursor = "move";
                                        e.target.style.cursor = "-webkit-grab";
                                        e.target.style.cursor = "-moz-grab";
                                        e.target.style.cursor = "grab";
                                    }
                                }
                            }
                        }
                    }
                }
                $('.text_container').css("visibility", "");
                var curY, curX;
                var target = e.target;
                var splittedText = e.target.id.split('text_')[1];
                if (splittedText) {
                    var currentIndex = splittedText.split('_')[0];
                    if (currentIndex == this._selectedValue) {
                        this._isTextSelection = true;
                    }
                    else {
                        this._isTextSelection = false;
                    }
                }
                if (window.getSelection().toString()) {
                    if (this._selectionPages.indexOf(pageNumber) == -1 && pageNumber && pageNumber != 0) {
                        this._selectionPages.push(pageNumber);
                    }
                } else {
                    this._selectionPages = new Array();
                }
                this.pageY = e.pageY;
                if (this._curDown == true && ($('#' + this._id + 'custom-menu').css('display') == 'none')) {
                    if (this._removeSearch) {
                        this._clearAllOccurrences();
                        this._removeSearch = false;
                    }
                    curY = e.clientY;
                    curX = e.clientX;
                    if (this._currentAnnotationRectangle.length == 0 || (this._annotationActive && this._isTextSelection)) {
                        var point = this._getWordAtPoint(target, curX, curY);
                    }
                    e.preventDefault();
                }
            }
        },
        _onTextContainerMouseLeave: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                this._enableSelection();
                if (this._curDown == true) {
                    var instance = this;
                    var value;
                    e.preventDefault();
                    var vscrolvalue = $('#' + this._id + '_viewerContainer');
                    var documentHeight = $(vscrolvalue).offset().top;
                    if (e.clientY > documentHeight) {
                        this._scrollMove = setInterval(function () {
                            $(vscrolvalue).animate({ scrollTop: $(vscrolvalue).scrollTop() + (200) }, 'fast');
                        }, 500);
                    }
                    else {
                        this._scrollMove = setInterval(function () {
                            $(vscrolvalue).animate({ scrollTop: $(vscrolvalue).scrollTop() - (200) }, 'fast');
                        }, 500);
                    }
                    $(window).on('mouseup', function (e) {
                        this._curDown = false;
                        instance._onMouseClickedOutside(e);
                        e.preventDefault();
                        e.stopPropagation();
                        return false;
                    });
                }
            }
            else if (!this.model.enableTextSelection) {
                var instances = this;
                $(window).on('mouseup', function (e) {
                    instances._dragstate = false;
                    e.preventDefault();
                    e.stopPropagation();
                    return false;
                });
                this._disableSelection();
            }
        },
        _onTextContainerMouseEnter: function (e) {
            if (!(e.target.id == this._id + "_popupinnercontent") && !(e.target.id == this._id + "_popupcontent") && this.model.enableTextSelection) {
                this._enableSelection();
                if (this._scrollMove)
                    clearInterval(this._scrollMove);
            }
            else if (!this.model.enableTextSelection)
                this._disableSelection();
        },
        _onMouseClickedOutside: function (e) {
            this._curDown = false;
            if (this._scrollMove)
                clearInterval(this._scrollMove);
            e.preventDefault();
            e.stopPropagation();
        },
        _onTextContainerDragStart: function (e) {
            e.preventDefault();// cancel the native drag event chain
        },
        _clearSelector: function (e) {
            if (window.getSelection) {
                if (window.getSelection().removeAllRanges) {  // Firefox
                    window.getSelection().removeAllRanges();
                }
                else if (document.selection) {  // IE?
                    document.selection.empty();
                }
            }
        },
        _createContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "custom-menu";
            containerDiv.className = "e-pdfviewer-custom-menu";
            pageviewcontainer.append(containerDiv);
            var orderedList = document.createElement('ol');
            orderedList.className = 'orderedList'
            containerDiv.appendChild(orderedList);
            var searchText = window.getSelection().toString();
            $(orderedList).append("<li class='copyli'><a href='javascript:void(0);' class='copy'>Copy</a></li>");
            $(orderedList).append("<li class='googlesearchli'><a href='javascript:void(0);' class='googleSearch'>Search Google For </a></li>");
            $(orderedList).append("<li class='e-highlight-textli'><a href='javascript:void(0);' id = '" + this._id + "_highlight_contextmenu' class='e-highlight-text'>Highlight Text </a></li>");
            $(orderedList).append("<li class='e-strikeout-textli'><a href='javascript:void(0);' id = '" + this._id + "_strikeout_contextmenu' class='e-strikeout-text'>Strikethrough Text </a></li>");
        },
        _createTouchContextMenu: function (e) {
            var containerDiv = document.createElement("div");//create a new div
            var pageviewcontainer = $('#' + this._id + '_pageviewContainer');
            containerDiv.id = this._id + "touchcustom-menu";
            containerDiv.className = "e-pdfviewer-touchcustom-menu";
            pageviewcontainer.append(containerDiv);
            var searchText = window.getSelection().toString();
            $(containerDiv).append("<div class='e-pdfviewer-touchCopy'><a href='javascript:void(0);' class='copy'>Copy</a></div>");
            $(containerDiv).append("<div class='e-pdfviewer-touchDot'><a href='javascript:void(0);' class='googleSearch'>Search</a></div>");
        },
        _onTextKeyboardCopy: function (e) {
            if (e.ctrlKey && e.keyCode == 67) {
                e.preventDefault();
                if (!this._isCopyRestrict)
                    this._copySelectedText(e);
            }
        },
        _copySelectedText: function (e) {
            if (!this._isCopyRestrict && this._searchedText && this._searchedText.length > 0 && this._searchedText != "" && this.model.enableTextSelection) {
                this._enableSelection();
                if (window.clipboardData && window.clipboardData.setData) {
                    var data = clipboardData.setData("Text", this._searchedText);
                    if ($('#' + this._id + 'custom-menu'))
                        $('#' + this._id + 'custom-menu').hide();
                    return data;
                } else {
                    var textarea = document.createElement("textarea");
                    $(textarea).css("contenteditable", "true");
                    textarea.textContent = this._searchedText
                    textarea.style.position = "fixed";  // Prevent scrolling to bottom of page in MS Edge.
                    document.body.appendChild(textarea);
                    textarea.select();
                }
                try {
                    return document.execCommand("copy");
                } catch (ex) {
                    console.warn("Copy to clipboard failed.", ex);
                } finally {
                    if (textarea)
                        document.body.removeChild(textarea);
                    $('#' + this._id + 'custom-menu').hide();
                }

                e.preventDefault();
            }
            else {
                if (!this._isCopyRestrict && this.model.enableTextSelection) {
                    this._enableSelection();
                    var searchText = window.getSelection().getRangeAt(0).toString();
                    var is_firefox = navigator.userAgent.indexOf('Firefox') > -1;
                    if (window.clipboardData && window.clipboardData.setData) {
                        var data = clipboardData.setData("Text", searchText);
                        if ($('#' + this._id + 'custom-menu'))
                            $('#' + this._id + 'custom-menu').hide();
                        return data;

                    } else if (document.queryCommandSupported && document.queryCommandSupported("copy")) {
                        var selection = window.getSelection();
                        var range = document.createRange();
                        var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                        var backward = false;
                        if (!position && selection.anchorOffset > selection.focusOffset ||
                          position === Node.DOCUMENT_POSITION_PRECEDING)
                            backward = true;
                        if (backward) {
                            range.setStart(selection.focusNode, selection.focusOffset);
                            range.setEnd(selection.anchorNode, selection.anchorOffset);
                        }
                        else {
                            range.setStart(selection.anchorNode, selection.anchorOffset);
                            range.setEnd(selection.focusNode, selection.focusOffset);
                        }
                        var textarea = document.createElement("textarea");
                        $(textarea).css("contenteditable", "true");
                        textarea.textContent = searchText;
                        textarea.style.position = "fixed";  // Prevent scrolling to bottom of page in MS Edge.
                        document.body.appendChild(textarea);
                        textarea.select();
                        selection.removeAllRanges();
                        selection.addRange(range);
                    }
                    try {
                        return document.execCommand("copy");
                    } catch (ex) {
                        console.warn("Copy to clipboard failed.", ex);
                    } finally {
                        document.body.removeChild(textarea);
                        $('#' + this._id + 'custom-menu').hide();
                    }

                    e.preventDefault();
                }
            }
        },
        _openInNewTab: function () {
            var searchText;
            if (this._searchedText && this._searchedText.length > 0 && this._searchedText != "")
                searchText = this._searchedText;
            else
                var searchText = window.getSelection().toString();
            var url = "http://www.google.com/search?q=" + searchText;
            var win = window.open(url, '_blank');
            win.focus();
            $('#' + this._id + 'custom-menu').hide();
        },
        _waterDropletDivHide: function (e) {
            $(document.getElementById(this._id + 'droplet1')).hide();
            $(document.getElementById(this._id + 'droplet2')).hide();
        },
        _getWordAtPoint: function (elem, x, y) {
            if (!this._isPopupNoteFocused && !this._isCanvasClicked && !this._isCanasResized ) {
                if (elem.nodeType == elem.TEXT_NODE) {
                    var backward = false;
                    this._isBackwardSelection = false;
                    var range = elem.ownerDocument.createRange();
                    var selection = window.getSelection();
                    if (selection.anchorNode != null) {
                        var position = selection.anchorNode.compareDocumentPosition(selection.focusNode)
                        if (!position && selection.anchorOffset > selection.focusOffset ||
                              position === Node.DOCUMENT_POSITION_PRECEDING) {
                            backward = true;
                            this._isBackwardSelection = true;
                        }
                    }
                    range.selectNodeContents(elem);
                    var currentPos = 0;
                    var endPos = range.endOffset;
                    while (currentPos < endPos) {
                        range.setStart(elem, currentPos);
                        range.setEnd(elem, currentPos + 1);
                        if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                           range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                            var singleWord = range.toString();
                            if (selection.anchorNode != null && selection.anchorNode.parentNode.className == "e-pdfviewer-textLayer")
                                range.setStart(selection.anchorNode, selection.anchorOffset);
                            selection.removeAllRanges();
                            selection.addRange(range);
                            if (backward)
                                selection.extend(elem, currentPos);
                            else
                                selection.extend(elem, currentPos + 1);
                            range.detach();
                            this._isTextSelection = true;
                            return (singleWord);
                        }
                        currentPos += 1;
                    }
                } else {
                    for (var i = 0; i < elem.childNodes.length; i++) {
                        var range = elem.childNodes[i].ownerDocument.createRange();
                        range.selectNodeContents(elem.childNodes[i]);
                        if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                           range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                            range.detach();
                            this._isTextSelection = true;
                            return (this._getWordAtPoint(elem.childNodes[i], x, y));
                        } else {
                            range.detach();
                        }
                    }
                }
                this._isTextSelection = false;
                return (null);
            }
        },
        _getElementTouch: function (elem, x, y, type) {
            if (elem.nodeType == elem.TEXT_NODE) {
                var selection = window.getSelection();
                var range = elem.ownerDocument.createRange();
                range.selectNodeContents(elem);
                var currentPos = 0;
                var endPos = range.endOffset;
                while (currentPos < endPos) {
                    range.setStart(elem, currentPos);
                    range.setEnd(elem, currentPos + 1);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        var singleWord = range.toString();
                        var textContent = elem.textContent;
                        var indices = [];
                        var startPos, endPos;
                        for (var i = 0; i < textContent.length; i++) {
                            if (textContent[i] == " ") indices.push(i);
                        }
                        for (var j = 0; j < indices.length; j++) {
                            if (currentPos == indices[j]) {
                                startPos = indices[j];
                                endPos = indices[j];
                            }
                            if (indices[0] > currentPos) {
                                startPos = 0;
                                endPos = indices[j];
                                break;
                            }
                            if (currentPos > indices[j] && currentPos < indices[j + 1]) {
                                startPos = indices[j];
                                endPos = indices[j + 1];
                            }
                            else if (currentPos > indices[j]) {
                                if (!indices[j + 1])
                                    startPos = indices[j];
                            }
                        }
                        this.startelem = startPos;
                        this.endelem = endPos;
                        if (startPos == 0)
                            range.setStart(elem, startPos);
                        else
                            range.setStart(elem, startPos + 1);
                        range.setEnd(elem, endPos);
                        selection.removeAllRanges();
                        selection.addRange(range);
                        if (type && this.model.enableTextSelection) {
                            var rangesPosition = range.getBoundingClientRect();
                            this._rangePosition = rangesPosition;
                            this._ranges = true;
                            this._selectedRanges = range;
                            var droplet1 = document.getElementById(this._id + 'droplet1');
                            var droplet2 = document.getElementById(this._id + 'droplet2');
                            var width = $(droplet1).width();
                            var height = $(droplet1).height();
                            $(droplet1).show();
                            $(droplet1).offset({ "top": rangesPosition.top + window.scrollY + (height / 2), "left": rangesPosition.left - width }).show();
                            $(droplet2).show();
                            $(droplet2).offset({ "top": rangesPosition.top + window.scrollY + (height / 2), "left": rangesPosition.left + rangesPosition.width - width }).show();
                        }
                        else if (!this.model.enableTextSelection) {
                            this._disableSelection();
                            var touchmenu = document.getElementById(this._id + 'touchcustom-menu');
                            $(touchmenu).hide();
                            this._waterDropletDivHide();
                        }
                        range.detach();
                        return (singleWord);
                    }
                    currentPos += 1;
                }
            } else {
                for (var i = 0; i < elem.childNodes.length; i++) {
                    var range = elem.childNodes[i].ownerDocument.createRange();
                    range.selectNodeContents(elem.childNodes[i]);
                    if (range.getBoundingClientRect().left <= x && range.getBoundingClientRect().right >= x &&
                       range.getBoundingClientRect().top <= y && range.getBoundingClientRect().bottom >= y) {
                        range.detach();
                        return (this._getElementTouch(elem.childNodes[i], x, y, type));
                    } else {
                        range.detach();
                    }
                }
            }
            return (null);
        },

        _preventClick: function (event) {
            var element;
            if ($(event.target).hasClass('e-pdfviewer-toolbarli-label')) {
                element = event.target;
                $(element).removeClass('e-active');
                $(element).removeClass('e-hover');
            } else {
                element = $(event.target).parents(".e-pdfviewer-toolbarli-label");
                element.removeClass('e-active');
                element.removeClass('e-hover');
            }
        },

        _toolbarHover: function (event) {
            if ($(event.target).hasClass('e-pdfviewer-toolbarli-label') || $(event.target).parents().hasClass('e-pdfviewer-toolbarli-label')) {
                var element;
                if ($(event.target).hasClass('e-pdfviewer-toolbarli-label')){
                    element = event.target;
                    $(element).removeClass('e-hover');
                } else{
                    element = $(event.target).parents(".e-pdfviewer-toolbarli-label");
                    element.removeClass('e-hover');
                }
            }
        },

        _toolbarClick: function (event) {
            var targetItem = event.target
            var clickedItem = event.target;
            if (this._isToolbarClick) {
                $('#' + this._id + '_rptTooltip').css('display', 'none');
                if (!($(clickedItem).hasClass("e-pdfviewer-highlight-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-strikeout-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout") || $(clickedItem).hasClass("e-pdfviewer-dropdown-wrapper") || $(clickedItem).hasClass("e-pdfviewer-dropdown-arrow"))) {
                    this._selectionNodes = window.getSelection();
                    this._maintainSelection();
                    document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                    this._isToolbarColorPicker = false;
                }
                if ($(clickedItem).hasClass("e-pdfviewer-highlight-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-strikeout-markup") ||
                    $(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
                    document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
                    this._isToolbarColorPicker = false;
                }
                this._displaySearch = false;
                this._isDefaultColorSet = false;
                if ($(clickedItem).hasClass('e-pdfviewer-toolbarli')) {
                    clickedItem = $(clickedItem).find('span');
                }
                if ($(clickedItem).hasClass("e-pdfviewer-print")) {
                    if (!this._isPrintRestrict)
                        this._print();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-download")) {
                    this._isAsynchronousDownload = true;
                    this._cancelDownloads = false;
                    var downloaded = new Object();
                    downloaded.fileName = this._downloadfileName;
                    downloaded.status = "is started"
                    this._raiseClientEvent("downloadStart", downloaded);
                    if (this._cancelDownloads)
                        return;
                    this._saveFormFieldsValue();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotofirst") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoFirstPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotolast") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoLastPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotonext") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoNextPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-gotoprevious") && !($(clickedItem).hasClass("e-pdfviewer-disabled"))) {
                    this._gotoPreviousPage();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-zoomin")) {
                    this._applyLowerZoomIndex();
                    this._zoomIn();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-select") || $(clickedItem).hasClass("e-pdfviewer-toolbar-select")) {
                    this._highlightSelectItems();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-scroll") || $(clickedItem).hasClass("e-pdfviewer-toolbar-scroll")) {
                    this._highlightScrollItems();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-sign") || $(clickedItem).hasClass("e-pdfviewer-toolbar-sign")) {
                    this._showSignatureDialog();
                }
                else if ($(clickedItem).hasClass("e-pdfviewer-zoomout")) {
                    this._applyHigherZoomIndex();
                    this._zoomOut();
                }
                    /*  * The event handler for the click event of the fiWidth and fitPage operations are given below. 
                        * The handler is chosen based on the id name of the target element. 
                    */
                else if ($(clickedItem).hasClass("e-pdfviewer-fitpage") || $(clickedItem).hasClass("e-pdfviewer-fitwidth")) {
                    var clickedSpan = clickedItem;
                    var spanId = $(clickedSpan).attr('id');
                    switch (spanId) {
                        case this._id + "_fitWidth":
                            this._applyFitToWidth();
                            break;
                        case this._id + "_fitPage":
                            this._applyFitToPage();
                            break;
                    }
                }
                else if ($(clickedItem).hasClass('e-pdfviewer-find')) {
                    this._displaySearchBox();
				} else if ($(clickedItem).hasClass("e-pdfviewer-highlight-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-highlight")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.highlightSettings.color);
				        this._isDefaultColorSet = true;
				        this._initHighlight();
				        this._highlightSelectItems();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-underline-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-underline")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.underlineSettings.color);
				        this._isDefaultColorSet = true;
				        this._initUnderline();
				        this._highlightSelectItems();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-strikeout-markup") || $(clickedItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
				    if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
				        this._drawColor = null;
				        this._toolbarColorpickerObject.option("value", this.model.strikethroughSettings.color);
				        this._isDefaultColorSet = true;
				        this._initStrikeOut();
				        this._highlightSelectItems();
				    }
				} else if ($(clickedItem).hasClass("e-pdfviewer-dropdown-wrapper") || $(clickedItem).hasClass("e-pdfviewer-dropdown-arrow")) {
				    var liItem = $(clickedItem).parents('.e-pdfviewer-toolbarli');
				    if (liItem.hasClass('e-pdfviewer-toolbar-underline')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableUnderlineAnnotation) {
				            this._displayColorPicker('Underline');
				            this._setPickerPosition(liItem[0]);
				            this._isUnderlineEnabled = false;
				            this._initUnderline();
				            this._highlightSelectItems();
				        }
				    } else if (liItem.hasClass('e-pdfviewer-toolbar-highlight')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableHighlightAnnotation) {
				            this._displayColorPicker('Highlight');
				            this._setPickerPosition(liItem[0]);
				            this._isHighlightEnabled = false;
				            this._initHighlight();
				            this._highlightSelectItems();
				        }
				    } else if (liItem.hasClass('e-pdfviewer-toolbar-strikeout')) {
				        if (this.model.enableTextMarkupAnnotations && this.model.enableStrikethroughAnnotation) {
				            this._displayColorPicker('StrikeOut');
				            this._setPickerPosition(liItem[0]);
				            this._isStrikeOutEnabled = false;
				            this._initStrikeOut();
				            this._highlightSelectItems();
				        }
				    }
				}
            }
        },
        _enableSelectionOnly: function () {
            if ($('#' + this._id + '_pdfviewer_toolbar_select').hasClass('e-disable')) {
                this.model.enableTextSelection = false;
                this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_select');
                this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_scroll');
            }
            else if (!this._isCopyRestrict) {
                this.model.enableTextSelection = true;
                this._enableSelection();
            }
        },
        _enableScrollingOnly: function () {
            this.model.enableTextSelection = false;
            this._disableSelection();
        },
        _highlightSelectItems: function () {
            this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_select');
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_scroll');
            this._enableSelectionOnly();
        },
        _highlightScrollItems: function () {
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_select');
            this._toolbar.selectItemByID(this._id + '_pdfviewer_toolbar_scroll');
            this._waterDropletDivHide();
            this._enableScrollingOnly();
        },
        _cancelDownload: function () {
            this._cancelDownloads = true;
            if (this._ajaxDownloaded != null) {
                this._ajaxDownloaded.abort();
                this._ajaxDownloaded = null;
            }
        },
        _save: function (data) {
            var filename;
            if (this.fileName.indexOf('\\') == -1) {
                filename = this.fileName;
            } else
                filename = this.fileName.replace(/^.*[\\\/]/, '')
            var browserUserAgent = navigator.userAgent;
            var url = '';
            var blob = this._base64toBlob(data["documentStream"], 'application/pdf', 512);
            if (browserUserAgent.indexOf('Edge') == -1) {
                if ((browserUserAgent.indexOf("Firefox")) != -1 || (browserUserAgent.indexOf("Chrome")) != -1 || (browserUserAgent.indexOf("Safari")) != -1 || (browserUserAgent.indexOf("AppleWebKit")) != -1) {
                    this._download(blob, url, filename);
                }
                else
                    window.navigator.msSaveOrOpenBlob(blob, filename);
            }
            else
                window.navigator.msSaveOrOpenBlob(blob, filename);
        },
        _base64toBlob: function (b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        },
        _createBlob: function (data, contentType) {
            if (typeof Blob !== 'undefined') {
                return new Blob([data], { type: contentType });
            }
            warn('The "Blob" constructor is not supported.');
        },

        _download: function (blob, url, filename) {
            var blobUrl = URL.createObjectURL(blob);
            var a = document.createElement('a');
            if (a.click) {
                a.href = blobUrl;
                a.target = '_parent';
                if ('download' in a) {
                    a.download = filename;
                }
                (document.body || document.documentElement).appendChild(a);
                a.click();
                a.parentNode.removeChild(a);
            } else {
                if (window.top === window &&
                    blobUrl.split('#')[0] === window.location.href.split('#')[0]) {
                    var padCharacter = blobUrl.indexOf('?') === -1 ? '?' : '&';
                    blobUrl = blobUrl.replace(/#|$/, padCharacter + '$&');
                }
                window.open(blobUrl, '_parent');
            }
        },

        _showToolbar: function (showToolbar) {
            if (showToolbar) {
                $('#' + this._id + '_toolbarContainer').css("display", "block");
                this._setSearchToolbarTop();
                this._isToolbarHidden = false;
            }
            else {
                $('#' + this._id + '_toolbarContainer').css("display", "none");
                if (this._isFindboxPresent) {
                    this._displaySearchBox();
                }
                this._isToolbarHidden = true;
            }
            this._setViewerContainerHeight();
        },
        _setViewerContainerHeight: function () {
            var ctrlheight = document.getElementById(this._id).clientHeight;
            var viewerblockHeight = 0;
            if (!this._isDevice) {
                var viewerContainer = $('#' + this._id + '_viewBlockContainer');
                if (viewerContainer.css('display').toLowerCase() == 'block') {
                    viewerblockHeight = viewerContainer.height();
                }
            }
            var toolbarHeight = this.model.toolbarSettings.templateId ? $('#' + this.model.toolbarSettings.templateId).height() : $('#' + this._id + '_toolbarContainer').height();
            var toolbarContainer = $('#' + this._id + '_toolbarContainer').css("display");
            if (toolbarContainer.toLowerCase() == 'block') {
                var calcHeight = ctrlheight - viewerblockHeight - toolbarHeight - 4;
            }
            else if (toolbarContainer.toLowerCase() == 'none') {
                var calcHeight = ctrlheight - viewerblockHeight - 4;
            }
            $('#' + this._id + '_viewerContainer').css({ "height": calcHeight + "px" });
        },
        _initToolbar: function () {
            this._isToolbarClick = false;

            if (!this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    var zoomddl = $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList');
                    if (zoomddl) {
                        zoomddl._selectItemByIndex(0);
                        zoomddl.disable();
                    }

                    $('#' + this._id + '_txtpageNo').attr('disabled', 'disabled');
                    if (this._toolbar) {
                        this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotofirst');
                        this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotoprevious');
                        this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotonext');
                        this._toolbar.disableItemByID(this._id + '_pdfviewer_toolbar_gotolast');
                    }
                }
            }
        },

        _enableToolbarItems: function () {
            this._isToolbarClick = true;
            if (this.model && !this.model.toolbarSettings.templateId) {
                if (!this._isDevice) {
                    $('#' + this._id + '_txtpageNo').removeAttr('disabled');
                    $('#' + this._id + '_toolbar_zoomSelection').data('ejDropDownList').enable();
                }
            }
        },
        //-------------------- Toolbar Actions[End] -------------------------//

        //-------------------- Tooltip Localization Actions[Start]------------------------//
        _showLocalizationTooltip: function (event) {
            if ($('#' + this._id + '_rptTooltip').css('display') == 'none') {
                this._showLocaleTooltip(event);
            }
        },

        _hideLocalizationTooltip: function (event) {
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },

        _showLocaleTooltip: function (event) {
            var currentItem = event.target;
            var TagPos;
            var headerTxt, contentTxt;
            if (currentItem.id == this._id + '_pdfviewer_findlabel') {
                var label = $('#' + this._id + '_pdfviewer_findlabel')[0];
                if (label.scrollWidth > $(label).innerWidth()) {
                    if (label)
                        TagPos = label.getBoundingClientRect();
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    headerTxt = '';
                    contentTxt = localeObj['contextMenu']['Find']['contentText'];
                }
            }
            if (currentItem.id == this._id + '_pdfviewer_matchlabel') {
                var label = $('#' + this._id + '_pdfviewer_matchlabel')[0];
                if (label.scrollWidth > $(label).innerWidth()) {
                    if (label)
                        TagPos = label.getBoundingClientRect();
                    var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
                    headerTxt = '';
                    contentTxt = localeObj['contextMenu']['matchCase']['contentText'];
                }
            }
            if (contentTxt) {
                var maxZindex = this._viewerMaxZindex();
                $('#' + this._id + '_rptTooltip_Header').html(headerTxt);
                $('#' + this._id + '_rptTooltip_Content').html(contentTxt);
                var toolbarPosition = document.getElementById(this._id + "_pdfviewer_searchbox").getBoundingClientRect();
                var mainToolbarPosition = $('#' + this._id + '_toolbarContainer')[0].getBoundingClientRect();
                var windowWidth = this.element[0].clientWidth;
                var minimunWidth = parseFloat($('#' + this._id + '_rptTooltip').css('min-width'));
                if (windowWidth <= (TagPos.left) + (minimunWidth)) {
                    $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top + toolbarPosition.height)) - 18, 'left': ((TagPos.left - mainToolbarPosition.left) + (TagPos.width / 2) - minimunWidth), 'display': 'block', 'position': 'absolute' });
                    var currentLeft = parseFloat($('#' + this._id + '_rptTooltip').css("left"));
                    if (currentLeft < 0) {
                        $('#' + this._id + '_rptTooltip').css("left", "0px");
                    }
                }
                else if (windowWidth <= (TagPos.left) + 2 * (TagPos.width)) {
                    $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top + toolbarPosition.height)) - 18, 'left': ((TagPos.left - mainToolbarPosition.left) - (3 * TagPos.width)), 'display': 'block', 'position': 'absolute' });
                }
                else {
                    $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top + toolbarPosition.height)) - 18, 'left': ((TagPos.left - mainToolbarPosition.left) + (TagPos.width / 2)), 'display': 'block', 'position': 'absolute' });
                }
            }
        },

        _showIconToolTip: function (event) {
            if ($('#' + this._id + '_rptTooltip').css('display') == 'none') {
                this._showTooltipContent(event);
            }
        },

        _hideIconToolTip: function () {
            $('#' + this._id + '_rptTooltip').css('display', 'none');
        },

        _viewpopupBlockNone: function (jqueryEement) {
            if (jqueryEement.css('display') == 'block') {
                return false;
            } else {
                return true;
            }
        },

        _showTooltipContent: function (event) {
            var currentToolbarItem = event.target;
            if (this.model && this.model.toolbarSettings.showTooltip && !this._isDevice) {
                var TagPos;
                var toolTipText;
                var isShowTooltip = true;
                if ($(currentToolbarItem).hasClass('e-pdfviewer-toolbarli')) {
                    currentToolbarItem = $(currentToolbarItem).find('span');
                }
                var disabledItem = $(currentToolbarItem).prev();
                if ($(currentToolbarItem).hasClass("e-pdfviewer-print")) {
                    var printId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-print')[0];
                    if (printId)
                        TagPos = printId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-print')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('print');
                }
                if ($(currentToolbarItem).hasClass("e-pdfviewer-download")) {
                    var printId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-download')[0];
                    if (printId)
                        TagPos = printId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-download')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('download');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotofirst")) || ($(disabledItem).hasClass('e-pdfviewer-gotofirst'))) {
                    var gotoFirstId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotofirst')[0];
                    if (gotoFirstId)
                        TagPos = gotoFirstId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotofirst')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('first');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotolast")) || ($(disabledItem).hasClass('e-pdfviewer-gotolast'))) {
                    var gotoLastId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotolast')[0];
                    if (gotoLastId)
                        TagPos = gotoLastId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotolast')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('last');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotonext")) || ($(disabledItem).hasClass('e-pdfviewer-gotonext'))) {
                    var gotoNextId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotonext')[0];
                    if (gotoNextId)
                        TagPos = gotoNextId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotonext')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('next');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-gotoprevious")) || ($(disabledItem).hasClass('e-pdfviewer-gotoprevious'))) {
                    var gotoPreviousId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-gotoprevious')[0];
                    if (gotoPreviousId)
                        TagPos = gotoPreviousId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-gotoprevious')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('previous');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-zoomin")) || ($(disabledItem).hasClass('e-pdfviewer-zoomin'))) {
                    var zoomInId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-zoomin')[0];
                    if (zoomInId)
                        TagPos = zoomInId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-zoomin')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomin');
                }
                else if (($(currentToolbarItem).hasClass("e-pdfviewer-zoomout")) || ($(disabledItem).hasClass('e-pdfviewer-zoomout'))) {
                    var zoomOutId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-zoomout')[0];
                    if (zoomOutId)
                        TagPos = zoomOutId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-zoomout')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoomout');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-tbpage") || $(currentToolbarItem).hasClass("e-pdfviewer-pagenumber") || $(currentToolbarItem).hasClass("e-pdfviewer-labelpageno")) {
                    var pageNumberId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-tbpage')[0];
                    if (pageNumberId)
                        TagPos = pageNumberId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-tbpage')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('pageIndex');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-ejdropdownlist") || $(currentToolbarItem).hasClass("e-dropdownlist") || $(currentToolbarItem).hasClass("e-select") || $(currentToolbarItem).hasClass("e-down-arrow")) {
                    var zoomDropdownId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-ejdropdownlist')[0];
                    if (zoomDropdownId)
                        TagPos = zoomDropdownId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-ejdropdownlist')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('zoom');
                    isShowTooltip = this._viewpopupBlockNone($('#' + this._id + '_toolbar_zoomSelection_popup_list_wrapper'));
                }
                    //The below code is used to render the tooltip for fitWidth and fitPage buttons based on the id name of the target element
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-fitwidth") || $(currentToolbarItem).hasClass("e-pdfviewer-fitpage") || ($(disabledItem).hasClass('e-pdfviewer-fitwidth')) || ($(disabledItem).hasClass('e-pdfviewer-fitpage'))) {
                    var hoverSpan = currentToolbarItem;
                    var spanId = $(hoverSpan).attr('id');
                    switch (spanId) {
                        case this._id + "_fitWidth":
                            var fitWidthId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitwidth')[0];
                            if (fitWidthId)
                                TagPos = fitWidthId.getBoundingClientRect();
                            else
                                TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitwidth')[0].getBoundingClientRect();
                            toolTipText = this._getTootipText('fittoWidth');
                            break;
                        case this._id + "_fitPage":
                            var fitPageId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitpage')[0];
                            if (fitPageId)
                                TagPos = fitPageId.getBoundingClientRect();
                            else
                                TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitpage')[0].getBoundingClientRect();
                            toolTipText = this._getTootipText('fittopage');
                            break;
                        default:
                            var prevElement = $(hoverSpan).prev();
                            if ($(prevElement).hasClass('e-pdfviewer-fitwidth')) {
                                fitWidthId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitwidth')[0];
                                if (fitWidthId)
                                    TagPos = fitWidthId.getBoundingClientRect();
                                else
                                    TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitwidth')[0].getBoundingClientRect();
                                toolTipText = this._getTootipText('fittoWidth');
                            } else if ($(prevElement).hasClass('e-pdfviewer-fitpage')) {
                                fitPageId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-fitpage')[0];
                                if (fitPageId)
                                    TagPos = fitPageId.getBoundingClientRect();
                                else
                                    TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-fitpage')[0].getBoundingClientRect();
                                toolTipText = this._getTootipText('fittopage');
                            }
                    }
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-find")) {
                    if (!this._isFindboxPresent) {
                        var searchSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-find')[0];
                        if (searchSpanId)
                            TagPos = searchSpanId.getBoundingClientRect();
                        else
                            TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-find')[0].getBoundingClientRect();
                        toolTipText = this._getTootipText('search');
                    }
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-highlight-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-highlight")) {
                    var highlightSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-highlight-markup')[0];
                    if (highlightSpanId)
                        TagPos = highlightSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-highlight-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('highlight');
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-strikeout-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-strikeout")) {
                    var strikeoutSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-strikeout-markup')[0];
                    if (strikeoutSpanId)
                        TagPos = strikeoutSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-strikeout-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('strikeout');
                } else if ($(currentToolbarItem).hasClass("e-pdfviewer-underline-markup") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-underline")) {
                    var underlineSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-underline-markup')[0];
                    if (underlineSpanId)
                        TagPos = underlineSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-underline-markup')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('underline');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-sign") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-sign")) {
                    var signatureSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-sign')[0];
                    if (signatureSpanId)
                        TagPos = signatureSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist  .e-pdfviewer-sign')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('signature');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-select") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-select")) {
                    var selectSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-select')[0];
                    if (selectSpanId)
                        TagPos = selectSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist  .e-pdfviewer-select')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('select');
                }
                else if ($(currentToolbarItem).hasClass("e-pdfviewer-scroll") || $(currentToolbarItem).hasClass("e-pdfviewer-toolbar-scroll")) {
                    var scrollSpanId = $('#' + this._id + '_toolbarContainer .e-pdfviewer-scroll')[0];
                    if (scrollSpanId)
                        TagPos = scrollSpanId.getBoundingClientRect();
                    else
                        TagPos = $('#' + this._id + '_toolbarContainer_hiddenlist  .e-pdfviewer-scroll')[0].getBoundingClientRect();
                    toolTipText = this._getTootipText('scroll');
                }
                if (toolTipText && isShowTooltip) {
                    var maxZindex = this._viewerMaxZindex();
                    $('#' + this._id + '_rptTooltip_Header').html(toolTipText.header);
                    $('#' + this._id + '_rptTooltip_Content').html(toolTipText.content);
                    var toolbarPosition = document.getElementById(this._id + "_toolbarContainer").getBoundingClientRect();
                    var windowWidth = this.element[0].clientWidth;
                    var minimunWidth = parseFloat($('#' + this._id + '_rptTooltip').css('min-width'));
                    if (windowWidth <= (TagPos.left) + (minimunWidth)) {
                        $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) + (TagPos.width / 2) - minimunWidth), 'display': 'block', 'position': 'absolute' });
                        var currentLeft = parseFloat($('#' + this._id + '_rptTooltip').css("left"));
                        if (currentLeft < 0) {
                            $('#' + this._id + '_rptTooltip').css("left", "0px");
                        }
                    }
                    else if (windowWidth <= (TagPos.left) + 2 * (TagPos.width)) {
                        if (toolTipText.header == "Zoom") {
                            $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) - (2 * TagPos.width)), 'display': 'block', 'position': 'absolute' });
                        }
                        else
                            $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) - (3 * TagPos.width)), 'display': 'block', 'position': 'absolute' });
                    }
                    else {
                        $('#' + this._id + '_rptTooltip').css({ 'zIndex': maxZindex + 1, 'top': ((TagPos.top - toolbarPosition.top)) - 21, 'left': ((TagPos.left - toolbarPosition.left) + (TagPos.width / 2)), 'display': 'block', 'position': 'absolute' });
                    }
                }
            }
        },

        _viewerMaxZindex: function () {
            var parents = this.element.parents(), bodyEle, contEle;
            var bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            var contEle = $(this.model.target).children(), cindex = contEle.index(this.popup);
            contEle.splice(cindex, 1);
            $(contEle).each(function (i, ele) { parents.push(ele); });
            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;
        },

        _getTootipText: function (tipType) {
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var headerTxt = '';
            var contentTxt = '';
            switch (tipType) {
                case 'print':
                    headerTxt = localeObj['toolbar']['print']['headerText'];
                    contentTxt = localeObj['toolbar']['print']['contentText'];
                    break;
                case 'download':
                    headerTxt = localeObj['toolbar']['download']['headerText'];
                    contentTxt = localeObj['toolbar']['download']['contentText'];
                    break;
                case 'first':
                    headerTxt = localeObj['toolbar']['first']['headerText'];
                    contentTxt = localeObj['toolbar']['first']['contentText'];
                    break;
                case 'previous':
                    headerTxt = localeObj['toolbar']['previous']['headerText'];
                    contentTxt = localeObj['toolbar']['previous']['contentText'];
                    break;
                case 'next':
                    headerTxt = localeObj['toolbar']['next']['headerText'];
                    contentTxt = localeObj['toolbar']['next']['contentText'];
                    break;
                case 'last':
                    headerTxt = localeObj['toolbar']['last']['headerText'];
                    contentTxt = localeObj['toolbar']['last']['contentText'];
                    break;
                case 'zoomin':
                    headerTxt = localeObj['toolbar']['zoomIn']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomIn']['contentText'];
                    break;
                case 'zoomout':
                    headerTxt = localeObj['toolbar']['zoomOut']['headerText'];
                    contentTxt = localeObj['toolbar']['zoomOut']['contentText'];
                    break;
                case 'pageIndex':
                    headerTxt = localeObj['toolbar']['pageIndex']['headerText'];
                    contentTxt = localeObj['toolbar']['pageIndex']['contentText'];
                    break;
                case 'zoom':
                    headerTxt = localeObj['toolbar']['zoom']['headerText'];
                    contentTxt = localeObj['toolbar']['zoom']['contentText'];
                    break;
                case 'fittoWidth':
                    headerTxt = localeObj['toolbar']['fitToWidth']['headerText'];
                    contentTxt = localeObj['toolbar']['fitToWidth']['contentText'];
                    break;
                case 'fittopage':
                    headerTxt = localeObj['toolbar']['fitToPage']['headerText'];
                    contentTxt = localeObj['toolbar']['fitToPage']['contentText'];
                    break;
                case 'search':
                    headerTxt = localeObj['toolbar']['search']['headerText'];
                    contentTxt = localeObj['toolbar']['search']['contentText'];
                    break;
                case 'highlight':
                    headerTxt = localeObj['toolbar']['highlight']['headerText'];
                    contentTxt = localeObj['toolbar']['highlight']['contentText'];
                    break;
                case 'strikeout':
                    headerTxt = localeObj['toolbar']['strikeout']['headerText'];
                    contentTxt = localeObj['toolbar']['strikeout']['contentText'];
                    break;
                case 'underline':
                    headerTxt = localeObj['toolbar']['underline']['headerText'];
                    contentTxt = localeObj['toolbar']['underline']['contentText'];
                    break;
                case 'signature':
                    headerTxt = localeObj['toolbar']['signature']['headerText'];
                    contentTxt = localeObj['toolbar']['signature']['contentText'];
                    break;
                case 'select':
                    headerTxt = localeObj['toolbar']['select']['headerText'];
                    contentTxt = localeObj['toolbar']['select']['contentText'];
                    break;
                case 'scroll':
                    headerTxt = localeObj['toolbar']['scroll']['headerText'];
                    contentTxt = localeObj['toolbar']['scroll']['contentText'];
                    break;
            }
            return { header: headerTxt, content: contentTxt };
        },
        //-------------------- Tooltip Localization Actions[End]------------------------//

        //-------------------- DrillThrough Actions[Start]----------------------//

        _setInitialization: function () {
            this._canvascount = 0;
            this._fileName = '';
            this._isToolbarClick = false;
            this._pageModel = null;
            this._currentPage = 1;
            this._zoomLevel = 2;
            this._pageImageStream = null;
            this._pageWidth;
            this._pageHeight;
            this._pageLocation = new Array();
            this._scrollTriggered = false;
            this._previousPage = 1;
            this._totalPages;
            this._previousPosition;
            this._cummulativeHeight;
            this._backgroundPage = 1;
            this._renderedCanvasList = new Array();
            this._pageContents = new Array();
            this._pageText = new Array();
            this._searchMatches = new Array();
            this._pagePrinted = false;
            this._printingPage = 1;
            this._printingTimer;
            this._previousZoom = 1;
            this._renderPreviousPage = false;
            this._pageSize;
            this._eventpreviouszoomvalue;
            this._eventzoomvalue;
            this._pdfFileName;
            this._zoomArray = new Array();
            this._rerenderCanvasList = new Array();
            this._ajaxRequestState = null;
            this._ajaxDownloaded = null;
        },

        //-------------------- DrillThrough Actions[End]----------------------//

        //-------------------- Common pdfviewer events & utils[start]----------------------//
        _showViewerBlock: function (showblock) {
            if (showblock) {
                $('#' + this._id + '_viewBlockContainer').css("display", "block");
                var parameterBlock = $('#' + this._id + '_viewBlockContainer .e-pdfviewer-viewerblockcellcontent').find('table');
                this._selectparamToolItem(parameterBlock.is('[isviewclick]'));
            } else {
                $('#' + this._id + '_viewBlockContainer').css("display", "none");
            }
            if (this._isDevice) {
                $('#' + this._id + '_viewBlockContainer.e-pdfviewer-blockstyle').css('z-index', showblock ? '10' : '0');
            }
        },

        _showNavigationIndicator: function (isShow) {
            $('#' + this._id + '_viewerContainer').ejWaitingPopup({ showOnInit: isShow, appendTo: '#' + this._id + '_viewerContainer' });
            $('#' + this._id + '_viewerContainer_WaitingPopup').addClass('e-pdfviewer-waitingpopup');
        },
        _showSelectionButtons: function (show) {
            if (show) {
                $('#' + this._id + '_pdfviewer_selectul').css("display", "block");
                $('#' + this._id + '_pdfviewer_signatureul').addClass('e-separator');
                this._isSelectionHidden = false;
            }
            else {
                $('#' + this._id + '_pdfviewer_selectul').css("display", "none");
                $('#' + this._id + '_pdfviewer_signatureul').removeClass('e-separator');
                this._isSelectionHidden = true;
            }
        },
        _showloadingIndicator: function (isShow) {
            if (isShow) {
                $('#' + this._id + '_loadingIndicator').css('display', 'block');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'none');
            }
            else {
                $('#' + this._id + '_loadingIndicator').css('display', 'none');
                $('#' + this._id + '_pageviewOuterContainer').css('display', 'block');
            }
            $('#' + this._id + '_loadingIndicator').ejWaitingPopup({ showOnInit: isShow, appendTo: '#' + this._id + '_loadingIndicator' });
            $('#' + this._id + '_loadingIndicator_WaitingPopup').addClass('e-pdfviewer-waitingpopup');
        },

        _showPrintLoadingIndicator: function (isShow) {
            $('#' + this._id + 'e-pdf-viewer').css({ 'position': 'relative' });
            $('#' + this._id + 'e-pdf-viewer').ejWaitingPopup({ showOnInit: isShow, text: "Preparing document for printing...", cssClass: 'e-pdfviewer-waitingpopup-print', appendTo: '#' + this._id + 'e-pdf-viewer' });
        },

        _viewerResize: function (event) {
            var proxy = this;
            var elementWidth = proxy._isWidth ? proxy.element[0].parentElement.style.width : proxy.element[0].style.width;
            var elementHeight = proxy._isHeight ? proxy.element[0].parentElement.style.height : proxy.element[0].style.height;
            var _height = $(proxy.element).height();
            var _width = $(proxy.element).width();
            if (elementHeight.indexOf("%") != -1) {
                proxy._isPercentHeight = parseInt(elementHeight);
                var containerHeight = proxy._isHeight ? $(proxy.element).parent().height() : _height;
                _height = !proxy._isHeight ? ((containerHeight / 100) * proxy._isPercentHeight) : containerHeight;
            } else if (proxy.element[0].parentElement.clientHeight != 0 && proxy._isPercentHeight != -1) {
                _height = !proxy._isHeight ? ((proxy.element[0].parentElement.clientHeight / 100) * proxy._isPercentHeight) : proxy.element[0].parentElement.clientHeight;
            } else if (proxy._isHeight && proxy.element[0].parentElement.clientHeight != 0) {
                _height = proxy.element[0].parentElement.clientHeight;
            }
            proxy.element.height(_height);
            if (elementWidth.indexOf("%") != -1) {
                proxy._isPercentWidth = parseInt(elementWidth);
                var containerWidth = proxy._isWidth ? $(proxy.element).parent().width() : _width;
                _width = !proxy._isWidth ? (containerWidth / 100) * proxy._isPercentWidth : containerWidth;
            } else if (proxy.element[0].parentElement.clientWidth != 0 && proxy._isPercentWidth != -1) {
                _width = !proxy._isWidth ? (proxy.element[0].parentElement.clientWidth / 100) * proxy._isPercentWidth : proxy.element[0].parentElement.clientWidth;
            } else if (proxy._isWidth && proxy.element[0].parentElement.clientWidth != 0) {
                _width = proxy.element[0].parentElement.clientWidth;
            }
            proxy.element.width(_width);
            proxy._toolbar._activeItem = undefined;
            proxy._toolbar._reSizeHandler();
            if (_width <= 500) {
                $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: ((_width / 2) - (307 / 2)) + "px", Y: (_height / 2) + "px" }, width: "auto", height: "auto" });
            }
            else {
                $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: ((_width / 2) - (500 / 2)) + "px", Y: (_height / 2) + "px" }, width: "500px", height: "322px" });
            }
            var height = Math.max(0, (($(window).height() - $('#' + this._id + "_containerDialogTab").outerHeight()) / 2) + $(window).scrollTop()) + "px";
            var width = Math.max(0, (($(window).width() - $('#' + this._id + "_containerDialogTab").outerWidth()) / 2) + $(window).scrollLeft()) + "px";
            $('#' + this._id + "_containerDialogTab").ejDialog({ position: { X: width, Y: height } });
            if (_width <= 500 || window.innerHeight <= 500) {
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ width: "auto", height: "auto" });
                var newCanvas = $('#' + this._id + "_imageTemp")[0];
                newCanvas.height = 100;
                newCanvas.width = _width;
                newCanvas.style.height = "100px";
                newCanvas.style.width = _width + "px";
                var elemnts = proxy.element[0].parentElement.parentElement.parentElement;
                var width = elemnts.offsetWidth;
                var heights = elemnts.offsetHeight;
                var newWidths = (width / 2) - (newCanvas.width / 2);
                var newHeight = (window.innerHeight / 2) - (newCanvas.height / 2);
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ position: { X: newWidths + "px", Y: newHeight + "px" } });
            }
            else {
                var newCanvas = $('#' + this._id + "_imageTemp")[0];
                newCanvas.height = 400;
                newCanvas.width = 470;
                newCanvas.style.height = "400px";
                newCanvas.style.width = "470px";
                var elemnts = proxy.element[0].parentElement.parentElement.parentElement;
                var width = elemnts.offsetWidth;
                var heights = elemnts.offsetHeight;
                var newWidths = (width / 2) - (newCanvas.width / 2);
                var newHeight = (window.innerHeight / 2) - (newCanvas.height / 2);
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ height: "503px" });
                $('#' + this._id + "_signatureContainerDialogTab").ejDialog({ position: { X: newWidths + "px", Y: newHeight + "px" } });
            }
            $('#' + proxy._id + '_pdfviewer_searchul').removeClass('e-separator');
            $('#' + proxy._id + '_pdfviewer_downloadul').removeClass('e-separator');
            document.getElementById(proxy._id + '_pdfviewer_colorpicker').style.display = 'none';
            proxy._isToolbarColorPicker = false;
            proxy._toolbarResizeHandler();
            proxy._resizeSearchToolbar();
            if (proxy.model && proxy.model.isResponsive && proxy._renderedCanvasList.length > 0 && proxy._isAutoZoom) {
                proxy._applyFitToWidthAuto();
            }
            if (proxy.model && proxy._fitType == "fitToWidth" && !proxy.model.isResponsive) {
                proxy._applyFitToWidth();
            }
            proxy._isAutoSelected = false;
            proxy._isWindowResizing = true;
            //Function for assigning left style property for page Canvas.
            proxy._applyLeftPosition();
        },

        /*  * _applyLeftPosition() assigns the left style property of the page canvas.
            * The left style property is calculated and added to each page canvas.
            * So the page canvas is centered.
        */
        _applyLeftPosition: function () {
            for (var i = 1; i <= this._totalPages; i++) {
                var leftPosition;
                if ((this._fitType == "fitToWidth") || (this._isAutoZoom && this._zoomVal < 1))
                    leftPosition = 5;
                else {
                    if (this._pageSize[i - 1].PageRotation == 90 || this._pageSize[i - 1].PageRotation == 270)
                        leftPosition = (this.element.width() - this._pageSize[i - 1].PageHeight * this._zoomVal) / 2;
                    else
                        leftPosition = (this.element.width() - this._pageSize[i - 1].PageWidth * this._zoomVal) / 2;
                }
                if (leftPosition < 0)
                    leftPosition = 5;
                var pageDiv = document.getElementById(this._id + 'pageDiv_' + i);
                if (pageDiv) {
                    pageDiv.style.left = leftPosition + "px";
                }
            }
        },

        _toolbarResizeHandler: function () {
            var toolbar = $('#' + this._id + '_toolbarContainer');
            if ($('#' + this._id + '_pdfviewer_printul').parent()[0] != toolbar[0]) {
                if (!this._isDownloadCntlHidden) {
                    toolbar.append($('#' + this._id + '_pdfviewer_printul')[0]);
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                    this._isDownloadCntlHidden = true;
                }
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'right' });
            } else if ($('#' + this._id + '_pdfviewer_printul').parent()[0] == toolbar[0]) {
                $('#' + this._id + '_pdfviewer_printul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_printul').css({ 'float': 'right' });
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'right' });
                $('#' + this._id + '_pdfviewer_selectul').removeClass('e-separator');
            }
            if ($('#' + this._id + '_pdfviewer_downloadul').parent()[0] != toolbar[0]) {
                if (this._isDownloadCntlHidden) {
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_printul')[0]);
                    this._isDownloadCntlHidden = false;
                    $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'left' });
                }
            } else if ($('#' + this._id + '_pdfviewer_downloadul').parent()[0] == toolbar[0]) {
                $('#' + this._id + '_pdfviewer_downloadul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_downloadul').css({ 'float': 'right' });
                toolbar.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_printul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                $('#' + this._id + '_toolbarContainer_target').addClass('e-display-none');
                $('#' + this._id + '_toolbarContainer_target').removeClass('e-display-block');
            }
            if ($('#' + this._id + '_pdfviewer_searchul').parent()[0] != toolbar[0]) {
                if (!this._isSearchHidden) {
                    this._isSearchHidden = false;
                    toolbar.append($('#' + this._id + '_pdfviewer_selectul')[0]);
                    toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                    $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'left' });
                    $('#' + this._id + '_pdfviewer_printul').css({ 'float': 'left', 'padding-right': '10px' });
                    $('#' + this._id + '_pdfviewer_downloadul').css({ 'float': 'left' });
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_printul')[0]);
                    this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                    $('#' + this._id + '_pdfviewer_searchul').addClass('e-separator');
                    $('#' + this._id + '_pdfviewer_printul').addClass('e-separator');
                }
            }
            if ($('#' + this._id + '_pdfviewer_selectul').parent()[0] != toolbar[0]) {
                this._isZoomCntlHidden = true;
                this._isSearchHidden = true;
                toolbar.append($('#' + this._id + '_pdfviewer_selectul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_zoomul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_textmarkupul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_signatureul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_printul')[0]);
                this._toolbar._liTemplte.append($('#' + this._id + '_pdfviewer_downloadul')[0]);
                $('#' + this._id + '_pdfviewer_printul').css({ 'float': 'left', 'padding-right': '10px' });
                $('#' + this._id + '_pdfviewer_downloadul').css({ 'float': 'left' });
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'left' });
                $('#' + this._id + '_pdfviewer_selectul').addClass('e-separator');
                $('#' + this._id + '_pdfviewer_printul').addClass('e-separator');
            }
            if (($('#' + this._id + '_pdfviewer_zoomul').parent()[0] == toolbar[0]) && this._isZoomCntlHidden) {
                toolbar.append($('#' + this._id + '_pdfviewer_zoomul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_textmarkupul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_signatureul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_selectul')[0]);
                toolbar.append($('#' + this._id + '_pdfviewer_searchul')[0]);
                $('#' + this._id + '_pdfviewer_printul').css({ 'float': 'right', 'padding-right': '0px' });
                $('#' + this._id + '_pdfviewer_downloadul').css({ 'float': 'right' });
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'right', 'padding-right': '0px' });
                $('#' + this._id + '_pdfviewer_printul').removeClass('e-separator');
                $('#' + this._id + '_pdfviewer_selectul').removeClass('e-separator');
                this._isZoomCntlHidden = false;
            }
            if ($('#' + this._id + '_toolbarContainer_target').hasClass('e-display-block') && $('#' + this._id + '_toolbarContainer_hiddenlist')[0].childElementCount == 2) {
                $('#' + this._id + '_pdfviewer_searchul').css({ 'float': 'left' });
                $('#' + this._id + '_pdfviewer_selectul').addClass('e-separator');
            }
        },

        _overflowToolbarClose: function () {
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
        },

        _resizeSearchToolbar: function () {
            var searchToolbar = document.getElementById(this._id + '_pdfviewer_searchbox');
            if (searchToolbar) {
                var searchicon = $('#' + this._id + '_toolbarContainer .e-pdfviewer-find')[0];
                if (!searchicon) {
                    searchicon = $('#' + this._id + '_toolbarContainer_hiddenlist .e-pdfviewer-find')[0];
                }
                var position = searchicon.getBoundingClientRect();
                var style = document.getElementById('e-pdfviewer-arrow-responsive');
                if (style) {
                    document.head.removeChild(style);
                }
                if (!$('#' + this._id + '_toolbarContainer_target').hasClass('e-display-block')) {
                    searchToolbar.style.left = (searchicon.parentNode.parentNode.offsetLeft - searchicon.parentNode.parentNode.parentNode.offsetLeft - 2) + 'px';
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    searchInput.style.width = '150px';
                    searchToolbar.style.width = '400px';
                } else {
                    var viewerToolbar = document.getElementById(this._id + '_toolbarContainer');
                    searchToolbar.style.left = '0px';
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    searchInput.style.width = '150px';
                    searchToolbar.style.width = '400px';
                }
                var viewer = document.getElementById(this._id + 'e-pdf-viewer');
                if ((viewer.clientWidth) < (searchToolbar.offsetLeft + searchToolbar.clientWidth)) {
                    var searchInput = $('#' + this._id + '_pdfviewer_searchinput')[0];
                    if (this._isZoomCntlHidden) {
                        searchInput.style.width = parseInt(searchInput.style.width) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                        searchToolbar.style.width = parseInt(searchToolbar.style.width) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    } else {
                        searchToolbar.style.left = parseInt(searchToolbar.style.left) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    }
                } else {
                    if ($('#' + this._id + '_toolbarContainer_target').hasClass('e-display-block')) {
                        searchToolbar.style.left = parseInt(searchToolbar.style.left) - ((searchToolbar.offsetLeft + searchToolbar.clientWidth) - (viewer.clientWidth)) + 'px';
                    }
                }
                this._responsiveArrow(position, searchToolbar);
            }
        },

        _responsiveArrow: function (position, searchToolbar) {
            var styleSheet = document.createElement("Style");
            styleSheet.id = 'e-pdfviewer-arrow-responsive';
            document.head.appendChild(styleSheet);
            var style = styleSheet.sheet;
            if (!navigator.userAgent.match("Firefox") && style) {
                var searchToolbarPosition = searchToolbar.getBoundingClientRect();
                var left = position.left - searchToolbarPosition.left;
                style.addRule('.e-pdfviewer-arrow::before', 'left:' + left + 'px');
                style.addRule('.e-pdfviewer-arrow::after', 'left:' + left + 'px');
            } else {
                $('#' + this._id + '_pdfviewer_searchbox').removeClass('e-pdfviewer-arrow');
            }
        },

        //-------------------- Common pdfviewer events & utils[End]----------------------//

        /*---------------------client side methods[start]----------------------------------------------------------*/

        goToPage: function (pageNo) {
            this._gotoPageNo(pageNo);
        },

        goToLastPage: function () {
            this._gotoLastPage();
        },

        goToFirstPage: function () {
            this._gotoFirstPage();
        },

        goToNextPage: function () {
            this._gotoNextPage();
        },

        goToPreviousPage: function () {
            this._gotoPreviousPage();
        },

        print: function () {
            this._print();
        },

        abortPrint: function () {
            this._printCancel();
        },
        abortDownload: function () {
            this._cancelDownload();
        },
        showPrintTools: function (show) {
            this._showPrintButton(show);
        },

        showDownloadTool: function (show) {
            this._showDownloadButton(show);
        },

        showTextSearchTool: function (show) {
            this._showTextSearchButton(show);
        },

        showPageNavigationTools: function (show) {
            this._showPageNavigationControls(show);
        },

        showMagnificationTools: function (show) {
            this._showZoomControl(show);
            this._showFittoPage(show);
        },

        showTextMarkupAnnotationTools: function (show) {
            this._showTextMarkupButtons(show);
        },

        showSignatureTool: function (show) {
            this._showSignatureButtons(show);
        },
        addSignature: function () {
            this._showSignatureDialog();
        },
        showSelectionTool: function (show) {
            this._showSelectionButtons(show);
        },
        showToolbar: function (showToolbar) {
            this._showToolbar(showToolbar);
        },

        unload: function () {
            this._unLoad();
        },

        load: function (file) {
            $('#' + this._id + '_viewerContainer').scrollTop(0);
            this._showloadingIndicator(true);
            this.isDocumentEdited = false;
            this._fitType = null;
            this.model.isResponsive = true;
            this.model.enableTextSelection = true;
            this._isAutoZoom = true;
            $('#' + this._id + '_pageviewContainer').find('.e-waitingpopup').css("visibility", "");
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitPage');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_fitWidth');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomin');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_zoomout');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_download');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_search');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_highlight');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_strikeout');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_underline');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_signature');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_select');
            this._toolbar.enableItemByID(this._id + '_pdfviewer_toolbar_scroll');
            document.getElementById(this._id + '_pdfviewer_colorpicker').style.display = 'none';
            this._isToolbarColorPicker = false;
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_highlight');
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_underline');
            this._toolbar.deselectItemByID(this._id + '_pdfviewer_toolbar_strikeout');
            this._isHighlightEnabled = false;
            this._isUnderlineEnabled = false;
            this._isStrikeOutEnabled = false;
            this._isHighlight = false;
            this._isUnderline = false;
            this._isStrikeout = false;
            this._annotationActive = false;
            this._isCopyRestrict = false;
            this._isPrintRestrict = false;
            this._isFormFieldsDisabled = false;
            this._zoomVal = 1;
            this._zoomLevel = 3;
            this.fileName = null;
            this._fileName = "";
            this._signatureLayer = [];
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            $('#' + this._id + '_toolbar_zoomSelection_hidden').val(text);
            this._ejDropDownInstance.model.value = text;
            this._initToolbar();
            if (file) {
                var count = this._canvascount;
                while (count >= 1) {
                    $('#' + this._id + 'pageDiv_' + count).remove();
                    count--;
                }
            }

            window.clearInterval(this._scrollTimer);
            var jsonResult = new Object();
            jsonResult["viewerAction"] = "GetPageModel";
            jsonResult["controlId"] = this._id;
            jsonResult["pageindex"] = "1";
            jsonResult["isInitialLoading"] = "true";

            var fileUrl = file.split("base64,")[1];
            if (fileUrl == undefined) {
                this._fileName = file;
                jsonResult["newFileName"] = this._fileName;
                this._fileId = this._createGUID();
                jsonResult["id"] = this._fileId;
                this._actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.load;
                if (this._pdfService == ej.PdfViewer.PdfService.Local)
                    this._doAjaxPost("POST", this._actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                else
                    this._doAjaxPost("POST", this.model.serviceUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
            } else {
                var actionUrl = this.model.serviceUrl;
                jsonResult["uploadedFile"] = fileUrl;
                this._fileId = this._createGUID();
                jsonResult["id"] = this._fileId;
                if (this._pdfService == ej.PdfViewer.PdfService.Local) {
                    actionUrl = this.model.serviceUrl + "/" + this.model.serverActionSettings.fileUpload;
                    this._doAjaxPost("POST", actionUrl, JSON.stringify(jsonResult), "_getPageModel");
                }
                else {
                    actionUrl = actionUrl.replace(this.model.serverActionSettings.load, this.model.serverActionSettings.fileUpload);
                    this._doAjaxPost("POST", actionUrl, JSON.stringify({ 'jsonResult': jsonResult }), "_getPageModel");
                }
            }
        },
        searchText: function (searchText) {
            this._searchText = searchText;
            this._displaySearch = true;
            this._isFindboxPresent = true;
            this._textSearch();
        },
        searchNext: function () {
            this._nextSearch();
        },
        searchPrevious: function () {
            this._prevSearch();
        },
        matchCase: function (checked) {
            if (checked) {
                this._isMatchCase = true;
            } else {
                this._isMatchCase = false;
            }
            this._textSearch();
        },
        cancelSearchText: function () {
            this._searchText = "";
            this._displaySearch = false;
            this._isFindboxPresent = false;
            this._clearAllOccurrences();
        },

        fitToPage: function () {
            this._applyFitToPage();
        },

        fitToWidth: function () {
            this._applyFitToWidth();
        },

        download: function (isAsynchronous) {
            if (typeof isAsynchronous === "boolean")
                this._isAsynchronousDownload = isAsynchronous;
            else
                this._isAsynchronousDownload = true;
            this._saveFormFieldsValue();
        },

        zoomIn: function () {
            this._applyLowerZoomIndex();
            this._zoomIn();
        },

        zoomOut: function () {
            this._applyHigherZoomIndex();
            this._zoomOut();
        },

        zoomTo: function (zoomvalue) {
            if (zoomvalue < 50)
                zoomvalue = 50;
            else if (zoomvalue > 400)
                zoomvalue = 400;
            var zoomfactor = parseInt(zoomvalue) / 100;
            var localeObj = ej.PdfViewer.Locale[this.model.locale] ? ej.PdfViewer.Locale[this.model.locale] : ej.PdfViewer.Locale["default"];
            var text = localeObj['contextMenu']['auto']['contentText'];
            if (zoomvalue == text) {
                zoomfactor = 1;
                this.model.isResponsive = true;
            }
            else {
                zoomvalue = zoomvalue + "%";
                this.model.isResponsive = false;
            }
            this._calculateZoomLevel(zoomfactor);
            this._zoomContainer(zoomfactor, false);
            $('#' + this._id + '_toolbar_zoomSelection_hidden').val(zoomvalue);
            this._ejDropDownInstance.model.selectedIndices[0] = "";
            $('#' + this._id + '_toolbar_zoomSelection_popup li').removeClass('e-active');
            this._ejDropDownInstance.model.value = zoomvalue;
        },

        undo: function () {
            if (!this._isPropertiesWindowOpen)
                this._undo();
        },

        redo: function () {
            if (!this._isPropertiesWindowOpen)
                this._redo();
        },

        addAnnotation: function (annotationType) {
            if (annotationType == ej.PdfViewer.AnnotationType.Highlight)
                this._addAnnotation("Highlight");
            else if (annotationType == ej.PdfViewer.AnnotationType.Underline)
                this._addAnnotation("Underline");
            else if (annotationType == ej.PdfViewer.AnnotationType.Strikethrough)
                this._addAnnotation("StrikeOut");
        }
        /*---------------------client side methods[end]----------------------------------------------------------*/
    });

    /**
	* Enum for enable and disable toolbar items.	 
	* @enum {number}
	* @global 
	*/
    ej.PdfViewer.ToolbarItems = {
        /**  Enables zoom toolbar item. */
        MagnificationTools: 1 << 0,
        /**  Enables page navigation toolbar item. */
        PageNavigationTools: 1 << 1,
        /**  Enables print toolbar item. */
        PrintTools: 1 << 2,
        /**  Enables download toolbar item. */
        DownloadTool: 1 << 3,
        /**  Enables Search toolbar item. */
        TextSearchTool: 1 << 4,
        /**  Enables Search toolbar item. */
        TextMarkupAnnotationTools: 1 << 5,
        /**   Enables all the toolbar items. */
         SignatureTool: 1 << 6,
        /**   Enables signature items. */
         SelectionTool: 1 << 7,
        /**   Enables selection items. */
         All: 1 << 0 | 1 << 1 | 1 << 2 | 1 << 3 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7
    };

    ej.PdfViewer.PdfService = {
        Local: 1 << 0,
        Remote: 1 << 1,
    };
    ej.PdfViewer.LinkTarget = {
        Default: 1 << 0,
        NewTab: 1 << 1,
        NewWindow: 1 << 2,
    };

    ej.PdfViewer.AnnotationType = {
        Underline: 1 << 0,
        Strikethrough: 1 << 1,
        Highlight: 1 << 2
    };
    ej.PdfViewer.InteractionMode = {
        TextSelection: 1 << 0,
        Pan: 1 << 1,
    };
    ej.PdfViewer.BufferingMode = {
        Default: 1 << 0,
        Complete: 1 << 1,
    };
    ej.PdfViewer.Locale = ej.PdfViewer.Locale || {};

    ej.PdfViewer.Locale["default"] = ej.PdfViewer.Locale["en-US"] = {
        toolbar: {
            print: {
                headerText: 'Print',
                contentText: 'Print the PDF document.'
            },
            download: {
                headerText: 'Download',
                contentText: 'Download the PDF document.'
            },
            first: {
                headerText: 'First',
                contentText: 'Go to the first page of the PDF document.'
            },
            previous: {
                headerText: 'Previous',
                contentText: 'Go to the previous page of the PDF document.'
            },
            next: {
                headerText: 'Next',
                contentText: 'Go to the next page of the PDF document.'
            },
            last: {
                headerText: 'Last',
                contentText: 'Go to the last page of the PDF document.'
            },
            zoomIn: {
                headerText: 'Zoom-In',
                contentText: 'Zoom in to the PDF document.'
            },
            zoomOut: {
                headerText: 'Zoom-Out',
                contentText: 'Zoom out of the PDF document.'
            },
            pageIndex: {
                headerText: 'Page Number',
                contentText: 'Current page number to view.'
            },
            zoom: {
                headerText: 'Zoom',
                contentText: 'Zoom in or out on the PDF document.'
            },
            fitToWidth: {
                headerText: 'Fit to Width',
                contentText: 'Fit the PDF page to the width of the container.',
            },
            fitToPage: {
                headerText: 'Fit to Page',
                contentText: 'Fit the PDF page to the container.',
            },
            search: {
                headerText: 'Search Text',
                contentText: 'Search text in the PDF pages.',
            },
            highlight: {
                headerText: 'Highlight Text',
                contentText: 'Highlight text in the PDF pages.',
            },
            strikeout: {
                headerText: 'Strikethrough Text',
                contentText: 'Strikethrough text in the PDF pages.',
            },
            underline: {
                headerText: 'Underline Text',
                contentText: 'Underline text in the PDF pages.',
            },
            signature: {
                headerText: 'Signature',
                contentText: 'Add or create hand-written signature.',
            },
            select: {
                headerText: 'Selection',
                contentText: 'Selection tool for text.',
            },
            scroll: {
                headerText: 'Panning',
                contentText: 'Click to pan around the document',
            },
        },
        contextMenu: {
            copy: {
                contentText: 'Copy',
            },
            googleSearch: {
                contentText: 'Search google',
            },
            openPopup: {
                contentText: 'Open Pop-Up Note',
            },
            Delete: {
                contentText: 'Delete',
            },
            properties: {
                contentText: 'Properties....',
            },
            Find: {
                contentText: 'Find:',
            },
            matchCase: {
                contentText: 'Match Case',
            },
            auto: {
                contentText: 'Auto',
            },
        },
        propertyWindow: {
            underlineProperties: {
                contentText: "Underline Properties"
            },
            strikeOutProperties: {
                contentText: "StrikeOut Properties"
            },
            highlightProperties: {
                contentText: "Highlight Properties"
            },
            signatureProperties: {
                contentText: "Signature Properties"
            },
            appearance: {
                contentText: "Appearance"
            },
            general: {
                contentText: "General"
            },
            color: {
                contentText: "Color:"
            },
            opacity: {
                contentText: "Opacity:"
            },
            author: {
                contentText: "Author:"
            },
            subject: {
                contentText: "Subject:"
            },
            modified: {
                contentText: "Modified:"
            },
            ok: {
                contentText: "OK"
            },
            cancel: {
                contentText: "Cancel"
            },
            locked: {
                contentText: "Locked"
            }
        },
        signatureWindow: {
            Signature: {
                contentText: "Add Signature"
            },
            Add: {
                contentText: "Add"
            },
            clear: {
                contentText: "Clear"
            },
        },
    };
})(jQuery, Syncfusion);
;;

});